class
	SD_COREPART

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_WIDGETREC]} self.make
			create {CE_CLASS_POINTER [SD_WIDGETCLASSREC]} widget_class.make
			create {CE_CLASS_POINTER [SD_WIDGETREC]} parent.make
			create {CE_CLASS_POINTER [SD_XTCALLBACKREC]} destroy_callbacks.make
			create {CE_VOID_POINTER} constraints.make
			create {CE_VOID_POINTER} event_table.make
			create tm.make
			create {CE_VOID_POINTER} accelerators.make
			create {CE_POINTER_POINTER [SD_WIDGETREC]} popup_list.make
			create {CE_INTEGER_8_POINTER} name.make
			create {CE_CLASS_POINTER [SD_SCREEN]} screen.make
		end

feature {ANY} -- fields

	self: CE_POINTER [SD_WIDGETREC] assign set_self

	widget_class: CE_POINTER [SD_WIDGETCLASSREC] assign set_widget_class

	parent: CE_POINTER [SD_WIDGETREC] assign set_parent

	xrm_name: INTEGER_32 assign set_xrm_name

	being_destroyed: INTEGER_8 assign set_being_destroyed

	destroy_callbacks: CE_POINTER [SD_XTCALLBACKREC] assign set_destroy_callbacks

	constraints: CE_POINTER [ANY] assign set_constraints

	x: INTEGER_16 assign set_x

	y: INTEGER_16 assign set_y

	width: NATURAL_16 assign set_width

	height: NATURAL_16 assign set_height

	border_width: NATURAL_16 assign set_border_width

	managed: INTEGER_8 assign set_managed

	sensitive: INTEGER_8 assign set_sensitive

	ancestor_sensitive: INTEGER_8 assign set_ancestor_sensitive

	event_table: CE_POINTER [ANY] assign set_event_table

	tm: SD_XTTMREC assign set_tm

	accelerators: CE_POINTER [ANY] assign set_accelerators

	border_pixel: NATURAL_32 assign set_border_pixel

	border_pixmap: NATURAL_32 assign set_border_pixmap

	popup_list: CE_POINTER [CE_POINTER [SD_WIDGETREC]] assign set_popup_list

	num_popups: NATURAL_32 assign set_num_popups

	name: CE_POINTER [INTEGER_8] assign set_name

	screen: CE_POINTER [SD_SCREEN] assign set_screen

	colormap: NATURAL_32 assign set_colormap

	window: NATURAL_32 assign set_window

	depth: NATURAL_32 assign set_depth

	background_pixel: NATURAL_32 assign set_background_pixel

	background_pixmap: NATURAL_32 assign set_background_pixmap

	visible: INTEGER_8 assign set_visible

	mapped_when_managed: INTEGER_8 assign set_mapped_when_managed

feature {ANY} -- field setters

	set_self (a_self: CE_POINTER [SD_WIDGETREC])
		do
			self := a_self
			update_memory_field ("self")
		end

	set_widget_class (a_widget_class: CE_POINTER [SD_WIDGETCLASSREC])
		do
			widget_class := a_widget_class
			update_memory_field ("widget_class")
		end

	set_parent (a_parent: CE_POINTER [SD_WIDGETREC])
		do
			parent := a_parent
			update_memory_field ("parent")
		end

	set_xrm_name (a_xrm_name: INTEGER_32)
		do
			xrm_name := a_xrm_name
			update_memory_field ("xrm_name")
		end

	set_being_destroyed (a_being_destroyed: INTEGER_8)
		do
			being_destroyed := a_being_destroyed
			update_memory_field ("being_destroyed")
		end

	set_destroy_callbacks (a_destroy_callbacks: CE_POINTER [SD_XTCALLBACKREC])
		do
			destroy_callbacks := a_destroy_callbacks
			update_memory_field ("destroy_callbacks")
		end

	set_constraints (a_constraints: CE_POINTER [ANY])
		do
			constraints := a_constraints
			update_memory_field ("constraints")
		end

	set_x (a_x: INTEGER_16)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_16)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_width (a_width: NATURAL_16)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_height (a_height: NATURAL_16)
		do
			height := a_height
			update_memory_field ("height")
		end

	set_border_width (a_border_width: NATURAL_16)
		do
			border_width := a_border_width
			update_memory_field ("border_width")
		end

	set_managed (a_managed: INTEGER_8)
		do
			managed := a_managed
			update_memory_field ("managed")
		end

	set_sensitive (a_sensitive: INTEGER_8)
		do
			sensitive := a_sensitive
			update_memory_field ("sensitive")
		end

	set_ancestor_sensitive (a_ancestor_sensitive: INTEGER_8)
		do
			ancestor_sensitive := a_ancestor_sensitive
			update_memory_field ("ancestor_sensitive")
		end

	set_event_table (a_event_table: CE_POINTER [ANY])
		do
			event_table := a_event_table
			update_memory_field ("event_table")
		end

	set_tm (a_tm: SD_XTTMREC)
		do
			tm := a_tm
			update_memory_field ("tm")
		end

	set_accelerators (a_accelerators: CE_POINTER [ANY])
		do
			accelerators := a_accelerators
			update_memory_field ("accelerators")
		end

	set_border_pixel (a_border_pixel: NATURAL_32)
		do
			border_pixel := a_border_pixel
			update_memory_field ("border_pixel")
		end

	set_border_pixmap (a_border_pixmap: NATURAL_32)
		do
			border_pixmap := a_border_pixmap
			update_memory_field ("border_pixmap")
		end

	set_popup_list (a_popup_list: CE_POINTER [CE_POINTER [SD_WIDGETREC]])
		do
			popup_list := a_popup_list
			update_memory_field ("popup_list")
		end

	set_num_popups (a_num_popups: NATURAL_32)
		do
			num_popups := a_num_popups
			update_memory_field ("num_popups")
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_screen (a_screen: CE_POINTER [SD_SCREEN])
		do
			screen := a_screen
			update_memory_field ("screen")
		end

	set_colormap (a_colormap: NATURAL_32)
		do
			colormap := a_colormap
			update_memory_field ("colormap")
		end

	set_window (a_window: NATURAL_32)
		do
			window := a_window
			update_memory_field ("window")
		end

	set_depth (a_depth: NATURAL_32)
		do
			depth := a_depth
			update_memory_field ("depth")
		end

	set_background_pixel (a_background_pixel: NATURAL_32)
		do
			background_pixel := a_background_pixel
			update_memory_field ("background_pixel")
		end

	set_background_pixmap (a_background_pixmap: NATURAL_32)
		do
			background_pixmap := a_background_pixmap
			update_memory_field ("background_pixmap")
		end

	set_visible (a_visible: INTEGER_8)
		do
			visible := a_visible
			update_memory_field ("visible")
		end

	set_mapped_when_managed (a_mapped_when_managed: INTEGER_8)
		do
			mapped_when_managed := a_mapped_when_managed
			update_memory_field ("mapped_when_managed")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			self := a_other.self
			widget_class := a_other.widget_class
			parent := a_other.parent
			xrm_name := a_other.xrm_name
			being_destroyed := a_other.being_destroyed
			destroy_callbacks := a_other.destroy_callbacks
			constraints := a_other.constraints
			x := a_other.x
			y := a_other.y
			width := a_other.width
			height := a_other.height
			border_width := a_other.border_width
			managed := a_other.managed
			sensitive := a_other.sensitive
			ancestor_sensitive := a_other.ancestor_sensitive
			event_table := a_other.event_table
			tm := a_other.tm.twin
			accelerators := a_other.accelerators
			border_pixel := a_other.border_pixel
			border_pixmap := a_other.border_pixmap
			popup_list := a_other.popup_list
			num_popups := a_other.num_popups
			name := a_other.name
			screen := a_other.screen
			colormap := a_other.colormap
			window := a_other.window
			depth := a_other.depth
			background_pixel := a_other.background_pixel
			background_pixmap := a_other.background_pixmap
			visible := a_other.visible
			mapped_when_managed := a_other.mapped_when_managed
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				self.is_equal (a_other.self) and
				widget_class.is_equal (a_other.widget_class) and
				parent.is_equal (a_other.parent) and
				xrm_name = a_other.xrm_name and
				being_destroyed = a_other.being_destroyed and
				destroy_callbacks.is_equal (a_other.destroy_callbacks) and
				constraints.is_equal (a_other.constraints) and
				x = a_other.x and
				y = a_other.y and
				width = a_other.width and
				height = a_other.height and
				border_width = a_other.border_width and
				managed = a_other.managed and
				sensitive = a_other.sensitive and
				ancestor_sensitive = a_other.ancestor_sensitive and
				event_table.is_equal (a_other.event_table) and
				tm.is_equal (a_other.tm) and
				accelerators.is_equal (a_other.accelerators) and
				border_pixel = a_other.border_pixel and
				border_pixmap = a_other.border_pixmap and
				popup_list.is_equal (a_other.popup_list) and
				num_popups = a_other.num_popups and
				name.is_equal (a_other.name) and
				screen.is_equal (a_other.screen) and
				colormap = a_other.colormap and
				window = a_other.window and
				depth = a_other.depth and
				background_pixel = a_other.background_pixel and
				background_pixmap = a_other.background_pixmap and
				visible = a_other.visible and
				mapped_when_managed = a_other.mapped_when_managed
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("self"),
					create {CE_STRUCTURE_FIELD}.make ("widget_class"),
					create {CE_STRUCTURE_FIELD}.make ("parent"),
					create {CE_STRUCTURE_FIELD}.make ("xrm_name"),
					create {CE_STRUCTURE_FIELD}.make ("being_destroyed"),
					create {CE_STRUCTURE_FIELD}.make ("destroy_callbacks"),
					create {CE_STRUCTURE_FIELD}.make ("constraints"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("height"),
					create {CE_STRUCTURE_FIELD}.make ("border_width"),
					create {CE_STRUCTURE_FIELD}.make ("managed"),
					create {CE_STRUCTURE_FIELD}.make ("sensitive"),
					create {CE_STRUCTURE_FIELD}.make ("ancestor_sensitive"),
					create {CE_STRUCTURE_FIELD}.make ("event_table"),
					create {CE_STRUCTURE_FIELD}.make ("tm"),
					create {CE_STRUCTURE_FIELD}.make ("accelerators"),
					create {CE_STRUCTURE_FIELD}.make ("border_pixel"),
					create {CE_STRUCTURE_FIELD}.make ("border_pixmap"),
					create {CE_STRUCTURE_FIELD}.make ("popup_list"),
					create {CE_STRUCTURE_FIELD}.make ("num_popups"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("screen"),
					create {CE_STRUCTURE_FIELD}.make ("colormap"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("depth"),
					create {CE_STRUCTURE_FIELD}.make ("background_pixel"),
					create {CE_STRUCTURE_FIELD}.make ("background_pixmap"),
					create {CE_STRUCTURE_FIELD}.make ("visible"),
					create {CE_STRUCTURE_FIELD}.make ("mapped_when_managed")
				>>)
			init_structure_info
		end

end
