class
	SD_SCREEN

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_XEXTDATA]} ext_data.make
			create {CE_VOID_POINTER} display.make
			create {CE_CLASS_POINTER [SD_DEPTH]} depths.make
			create {CE_CLASS_POINTER [SD_VISUAL]} root_visual.make
			create {CE_VOID_POINTER} default_gc.make
		end

feature {ANY} -- fields

	ext_data: CE_POINTER [SD_XEXTDATA] assign set_ext_data

	display: CE_POINTER [ANY] assign set_display

	root: NATURAL_32 assign set_root

	width: INTEGER_32 assign set_width

	height: INTEGER_32 assign set_height

	mwidth: INTEGER_32 assign set_mwidth

	mheight: INTEGER_32 assign set_mheight

	ndepths: INTEGER_32 assign set_ndepths

	depths: CE_POINTER [SD_DEPTH] assign set_depths

	root_depth: INTEGER_32 assign set_root_depth

	root_visual: CE_POINTER [SD_VISUAL] assign set_root_visual

	default_gc: CE_POINTER [ANY] assign set_default_gc

	cmap: NATURAL_32 assign set_cmap

	white_pixel: NATURAL_32 assign set_white_pixel

	black_pixel: NATURAL_32 assign set_black_pixel

	max_maps: INTEGER_32 assign set_max_maps

	min_maps: INTEGER_32 assign set_min_maps

	backing_store: INTEGER_32 assign set_backing_store

	save_unders: INTEGER_32 assign set_save_unders

	root_input_mask: INTEGER_32 assign set_root_input_mask

feature {ANY} -- field setters

	set_ext_data (a_ext_data: CE_POINTER [SD_XEXTDATA])
		do
			ext_data := a_ext_data
			update_memory_field ("ext_data")
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			display := a_display
			update_memory_field ("display")
		end

	set_root (a_root: NATURAL_32)
		do
			root := a_root
			update_memory_field ("root")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_height (a_height: INTEGER_32)
		do
			height := a_height
			update_memory_field ("height")
		end

	set_mwidth (a_mwidth: INTEGER_32)
		do
			mwidth := a_mwidth
			update_memory_field ("mwidth")
		end

	set_mheight (a_mheight: INTEGER_32)
		do
			mheight := a_mheight
			update_memory_field ("mheight")
		end

	set_ndepths (a_ndepths: INTEGER_32)
		do
			ndepths := a_ndepths
			update_memory_field ("ndepths")
		end

	set_depths (a_depths: CE_POINTER [SD_DEPTH])
		do
			depths := a_depths
			update_memory_field ("depths")
		end

	set_root_depth (a_root_depth: INTEGER_32)
		do
			root_depth := a_root_depth
			update_memory_field ("root_depth")
		end

	set_root_visual (a_root_visual: CE_POINTER [SD_VISUAL])
		do
			root_visual := a_root_visual
			update_memory_field ("root_visual")
		end

	set_default_gc (a_default_gc: CE_POINTER [ANY])
		do
			default_gc := a_default_gc
			update_memory_field ("default_gc")
		end

	set_cmap (a_cmap: NATURAL_32)
		do
			cmap := a_cmap
			update_memory_field ("cmap")
		end

	set_white_pixel (a_white_pixel: NATURAL_32)
		do
			white_pixel := a_white_pixel
			update_memory_field ("white_pixel")
		end

	set_black_pixel (a_black_pixel: NATURAL_32)
		do
			black_pixel := a_black_pixel
			update_memory_field ("black_pixel")
		end

	set_max_maps (a_max_maps: INTEGER_32)
		do
			max_maps := a_max_maps
			update_memory_field ("max_maps")
		end

	set_min_maps (a_min_maps: INTEGER_32)
		do
			min_maps := a_min_maps
			update_memory_field ("min_maps")
		end

	set_backing_store (a_backing_store: INTEGER_32)
		do
			backing_store := a_backing_store
			update_memory_field ("backing_store")
		end

	set_save_unders (a_save_unders: INTEGER_32)
		do
			save_unders := a_save_unders
			update_memory_field ("save_unders")
		end

	set_root_input_mask (a_root_input_mask: INTEGER_32)
		do
			root_input_mask := a_root_input_mask
			update_memory_field ("root_input_mask")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ext_data := a_other.ext_data
			display := a_other.display
			root := a_other.root
			width := a_other.width
			height := a_other.height
			mwidth := a_other.mwidth
			mheight := a_other.mheight
			ndepths := a_other.ndepths
			depths := a_other.depths
			root_depth := a_other.root_depth
			root_visual := a_other.root_visual
			default_gc := a_other.default_gc
			cmap := a_other.cmap
			white_pixel := a_other.white_pixel
			black_pixel := a_other.black_pixel
			max_maps := a_other.max_maps
			min_maps := a_other.min_maps
			backing_store := a_other.backing_store
			save_unders := a_other.save_unders
			root_input_mask := a_other.root_input_mask
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ext_data.is_equal (a_other.ext_data) and
				display.is_equal (a_other.display) and
				root = a_other.root and
				width = a_other.width and
				height = a_other.height and
				mwidth = a_other.mwidth and
				mheight = a_other.mheight and
				ndepths = a_other.ndepths and
				depths.is_equal (a_other.depths) and
				root_depth = a_other.root_depth and
				root_visual.is_equal (a_other.root_visual) and
				default_gc.is_equal (a_other.default_gc) and
				cmap = a_other.cmap and
				white_pixel = a_other.white_pixel and
				black_pixel = a_other.black_pixel and
				max_maps = a_other.max_maps and
				min_maps = a_other.min_maps and
				backing_store = a_other.backing_store and
				save_unders = a_other.save_unders and
				root_input_mask = a_other.root_input_mask
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ext_data"),
					create {CE_STRUCTURE_FIELD}.make ("display"),
					create {CE_STRUCTURE_FIELD}.make ("root"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("height"),
					create {CE_STRUCTURE_FIELD}.make ("mwidth"),
					create {CE_STRUCTURE_FIELD}.make ("mheight"),
					create {CE_STRUCTURE_FIELD}.make ("ndepths"),
					create {CE_STRUCTURE_FIELD}.make ("depths"),
					create {CE_STRUCTURE_FIELD}.make ("root_depth"),
					create {CE_STRUCTURE_FIELD}.make ("root_visual"),
					create {CE_STRUCTURE_FIELD}.make ("default_gc"),
					create {CE_STRUCTURE_FIELD}.make ("cmap"),
					create {CE_STRUCTURE_FIELD}.make ("white_pixel"),
					create {CE_STRUCTURE_FIELD}.make ("black_pixel"),
					create {CE_STRUCTURE_FIELD}.make ("max_maps"),
					create {CE_STRUCTURE_FIELD}.make ("min_maps"),
					create {CE_STRUCTURE_FIELD}.make ("backing_store"),
					create {CE_STRUCTURE_FIELD}.make ("save_unders"),
					create {CE_STRUCTURE_FIELD}.make ("root_input_mask")
				>>)
			init_structure_info
		end

end
