class
	SD_XEXTDATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_XEXTDATA]} next.make
			create free_private.make
			create {CE_INTEGER_8_POINTER} private_data.make
		end

feature {ANY} -- fields

	number: INTEGER_32 assign set_number

	next: CE_POINTER [SD_XEXTDATA] assign set_next

	free_private: CE_ROUTINE assign set_free_private

	private_data: CE_POINTER [INTEGER_8] assign set_private_data

feature {ANY} -- field setters

	set_number (a_number: INTEGER_32)
		do
			number := a_number
			update_memory_field ("number")
		end

	set_next (a_next: CE_POINTER [SD_XEXTDATA])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_free_private (a_free_private: CE_ROUTINE)
		do
			free_private := a_free_private
			update_memory_field ("free_private")
		end

	set_private_data (a_private_data: CE_POINTER [INTEGER_8])
		do
			private_data := a_private_data
			update_memory_field ("private_data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			number := a_other.number
			next := a_other.next
			free_private := a_other.free_private
			private_data := a_other.private_data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				number = a_other.number and
				next.is_equal (a_other.next) and
				free_private.is_equal (a_other.free_private) and
				private_data.is_equal (a_other.private_data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("number"),
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("free_private"),
					create {CE_STRUCTURE_FIELD}.make ("private_data")
				>>)
			init_structure_info
		end

end
