class
	P_IFILE_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	anchor: CE_STATIC [CE_ARRAY [PD_IFILE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_IFILE]}.make (<<1>>)
			Result.item[0] := create {PD_IFILE}.make_initialized ([anchor.item, anchor.item, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0, (('%/0/').code).to_integer_8, create {PD_SCRPOS}.make_initialized ([(-1).to_integer_32, 0])])
		end

	ifiles: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	new_ifile (a_filename: CE_POINTER [INTEGER_8]; a_prev: CE_POINTER [PD_IFILE]): CE_POINTER [PD_IFILE]
		require
			not a_filename.is_void
		local
			l_p: CE_POINTER [PD_IFILE]
		do
			l_p := create {CE_CLASS_POINTER [PD_IFILE]}.make_cast (((create {P_MAIN_STATIC}).ecalloc (1, (create {PD_IFILE}.make).structure_size.to_natural_32)))
			l_p.item.h_filename := (create {P_MAIN_STATIC}).save (a_filename)
			l_p.item.h_scrpos.pos := (-1).to_integer_32
			l_p.item.h_opened := (0).to_integer_8
			l_p.item.h_hold := 0
			l_p.item.h_filestate := create {CE_VOID_POINTER}.make_shared (default_pointer)
			l_p.item.link_ifile (a_prev)
			Result := l_p
		end

	del_ifile (a_h: CE_POINTER [ANY])
		local
			l_p: CE_POINTER [PD_IFILE]
			l_return: BOOLEAN
		do
			if a_h.is_void then
				l_return := True
			end
			if not l_return then
				(create {P_MARK_STATIC}).unmark (a_h)
				if a_h.is_equal ((create {P_MAIN_STATIC}).curr_ifile.item) then
					(create {P_MAIN_STATIC}).curr_ifile.item := getoff_ifile ((create {P_MAIN_STATIC}).curr_ifile.item)
				end
				l_p := create {CE_CLASS_POINTER [PD_IFILE]}.make_cast (a_h)
				l_p.item.unlink_ifile
				free (create {CE_VOID_POINTER}.make_cast (l_p.item.h_filename))
				free (create {CE_VOID_POINTER}.make_cast (l_p))
			end
		end

	next_ifile (a_h: CE_POINTER [ANY]): CE_POINTER [ANY]
		local
			l_p: CE_POINTER [PD_IFILE]
			l_return: BOOLEAN
		do
			if a_h.is_void then
				l_p := anchor.item
			else
				l_p := create {CE_CLASS_POINTER [PD_IFILE]}.make_cast (a_h)
			end
			if (l_p.item.h_next).is_equal (anchor.item) then
				Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := (create {CE_VOID_POINTER}.make_cast (l_p.item.h_next))
			end
		end

	prev_ifile (a_h: CE_POINTER [ANY]): CE_POINTER [ANY]
		local
			l_p: CE_POINTER [PD_IFILE]
			l_return: BOOLEAN
		do
			if a_h.is_void then
				l_p := anchor.item
			else
				l_p := create {CE_CLASS_POINTER [PD_IFILE]}.make_cast (a_h)
			end
			if (l_p.item.h_prev).is_equal (anchor.item) then
				Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := (create {CE_VOID_POINTER}.make_cast (l_p.item.h_prev))
			end
		end

	getoff_ifile (a_ifile: CE_POINTER [ANY]): CE_POINTER [ANY]
		local
			l_newifile: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			l_newifile := prev_ifile (a_ifile)
			if not l_newifile.is_void then
				Result := l_newifile
				l_return := True
			end
			if not l_return then
				l_newifile := next_ifile (a_ifile)
				if not l_newifile.is_void then
					Result := l_newifile
					l_return := True
				end
			end
			if not l_return then
				Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
			end
		end

	nifile: INTEGER_32
		do
			Result := ifiles.item
		end

	find_ifile (a_filename: CE_POINTER [INTEGER_8]): CE_POINTER [PD_IFILE]
		local
			l_p: CE_POINTER [PD_IFILE]
			l_return: BOOLEAN
		do
			l_p := anchor.item.item.h_next
			from
			until
				not (not (l_return) and then (not l_p.is_equal (anchor.item)))
			loop
				if (strcmp (a_filename, l_p.item.h_filename)) = 0 then
					Result := l_p
					l_return := True
				end
				if not l_return then
					l_p := l_p.item.h_next
				end
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_IFILE]}.make_shared (default_pointer))
			end
		end

	get_ifile (a_filename: CE_POINTER [INTEGER_8]; a_prev: CE_POINTER [ANY]): CE_POINTER [ANY]
		local
			l_p: CE_POINTER [PD_IFILE]
		do
			l_p := find_ifile (a_filename)
			if l_p.is_void then
				l_p := new_ifile (a_filename, create {CE_CLASS_POINTER [PD_IFILE]}.make_cast (a_prev))
			end
			Result := (create {CE_VOID_POINTER}.make_cast (l_p))
		end

	get_filename (a_ifile: CE_POINTER [ANY]): CE_POINTER [INTEGER_8]
		local
			l_return: BOOLEAN
		do
			if a_ifile.is_void then
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := ((create {CE_CLASS_POINTER [PD_IFILE]}.make_cast (a_ifile)).item.h_filename)
			end
		end

	get_index (a_ifile: CE_POINTER [ANY]): INTEGER_32
		do
			Result := ((create {CE_CLASS_POINTER [PD_IFILE]}.make_cast (a_ifile)).item.h_index)
		end

	get_pos (a_ifile: CE_POINTER [ANY]; a_scrpos: CE_POINTER [PD_SCRPOS])
		require
			not a_scrpos.is_void
		do
			a_scrpos.item := ((create {CE_CLASS_POINTER [PD_IFILE]}.make_cast (a_ifile)).item.h_scrpos).twin
		end

	set_open (a_ifile: CE_POINTER [ANY])
		do
			(create {CE_CLASS_POINTER [PD_IFILE]}.make_cast (a_ifile)).item.h_opened := (1).to_integer_8
		end

	opened (a_ifile: CE_POINTER [ANY]): INTEGER_32
		do
			Result := ((create {CE_CLASS_POINTER [PD_IFILE]}.make_cast (a_ifile)).item.h_opened).to_integer_32
		end

	hold_ifile (a_ifile: CE_POINTER [ANY]; a_incr: INTEGER_32)
		do
			(create {CE_CLASS_POINTER [PD_IFILE]}.make_cast (a_ifile)).item.h_hold := (create {CE_CLASS_POINTER [PD_IFILE]}.make_cast (a_ifile)).item.h_hold + a_incr
		end

	held_ifile (a_ifile: CE_POINTER [ANY]): INTEGER_32
		do
			Result := ((create {CE_CLASS_POINTER [PD_IFILE]}.make_cast (a_ifile)).item.h_hold)
		end

	get_filestate (a_ifile: CE_POINTER [ANY]): CE_POINTER [ANY]
		do
			Result := ((create {CE_CLASS_POINTER [PD_IFILE]}.make_cast (a_ifile)).item.h_filestate)
		end

	set_filestate (a_ifile, a_filestate: CE_POINTER [ANY])
		do
			(create {CE_CLASS_POINTER [PD_IFILE]}.make_cast (a_ifile)).item.h_filestate := a_filestate
		end

end
