class
	P_LSYSTEM_STATIC

inherit
	CE_UTILITIES
	S_UNISTD_STATIC
	S_FCNTL_STATIC
	S_STRING_STATIC
	S_STDIO_STATIC
	S_STDLIB_STATIC
	S_SIGNAL_STATIC
	S_LIBIO_STATIC

feature {ANY} -- public routines

	lsystem (a_cmd, a_donemsg: CE_POINTER [INTEGER_8])
		require
			not a_cmd.is_void
		local
			l_cmd: CE_POINTER [INTEGER_8]
			l_inp: INTEGER_32
			l_shell: CE_POINTER [INTEGER_8]
			l_p: CE_POINTER [INTEGER_8]
			l_save_ifile: CE_POINTER [ANY]
			l_esccmd: CE_POINTER [INTEGER_8]
			l_tmp___1: NATURAL_32
		do
			l_cmd := a_cmd
			if (l_cmd[0]).to_integer_32 = 45 then
				l_cmd := l_cmd + 1
			else
				(create {P_SCREEN_STATIC}).clear_bot;
				(create {P_OUTPUT_STATIC}).putstr (ce_string ("!"));
				(create {P_OUTPUT_STATIC}).putstr (l_cmd);
				(create {P_OUTPUT_STATIC}).putstr (ce_string ("%N"))
			end
			l_save_ifile := (create {P_EDIT_STATIC}).save_curr_ifile;
			(create {P_EDIT_STATIC}).edit_ifile (create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing;
			(create {P_SCREEN_STATIC}).deinit;
			(create {P_OUTPUT_STATIC}).flush;
			(create {P_SCREEN_STATIC}).raw_mode (0);
			(create {P_SIGNAL_STATIC}).init_signals (0)
			l_inp := dup (0)
			close (0).do_nothing
			if (open ([ce_string ("/dev/tty"), 0])) < 0 then
				dup (l_inp).do_nothing
			end
			l_p := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_shell := (create {P_DECODE_STATIC}).lgetenv (ce_string ("SHELL"))
			if not l_shell.is_void then
				if (l_shell[0]).to_integer_32 /= 0 then
					if (l_cmd[0]).to_integer_32 = 0 then
						l_p := (create {P_MAIN_STATIC}).save (l_shell)
					else
						l_esccmd := ((create {P_FILENAME_STATIC}).shell_quote (l_cmd))
						if not l_esccmd.is_void then
							l_tmp___1 := strlen (l_shell)
							l_p := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MAIN_STATIC}).ecalloc (((l_tmp___1 + (strlen (l_esccmd))) + {NATURAL_32} 5).to_integer_32, {PLATFORM}.Integer_8_bytes.to_natural_32)))
							sprintf ([l_p, ce_string ("%%s %%s %%s"), l_shell, ((create {P_FILENAME_STATIC}).shell_coption), l_esccmd]).do_nothing
							free (create {CE_VOID_POINTER}.make_cast (l_esccmd))
						end
					end
				end
			end
			if l_p.is_void then
				if (l_cmd[0]).to_integer_32 = 0 then
					l_p := (create {P_MAIN_STATIC}).save (ce_string ("sh"))
				else
					l_p := (create {P_MAIN_STATIC}).save (l_cmd)
				end
			end
			system (l_p).do_nothing
			free (create {CE_VOID_POINTER}.make_cast (l_p))
			close (0).do_nothing
			dup (l_inp).do_nothing
			close (l_inp).do_nothing;
			(create {P_SIGNAL_STATIC}).init_signals (1);
			(create {P_SCREEN_STATIC}).raw_mode (1)
			if not a_donemsg.is_void then
				(create {P_OUTPUT_STATIC}).putstr (a_donemsg);
				(create {P_OUTPUT_STATIC}).putstr (ce_string ("  (press RETURN)"));
				(create {P_OUTPUT_STATIC}).get_return;
				(create {P_OUTPUT_STATIC}).putchr (('%N').code).do_nothing;
				(create {P_OUTPUT_STATIC}).flush
			end
			(create {P_SCREEN_STATIC}).init;
			(create {P_COMMAND_STATIC}).screen_trashed.item := 1;
			(create {P_EDIT_STATIC}).reedit_ifile (l_save_ifile);
			(create {P_SIGNAL_STATIC}).winch (0)
		end

	pipe_mark (a_c: INTEGER_32; a_cmd: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_mpos: INTEGER_32
			l_tpos: INTEGER_32
			l_bpos: INTEGER_32
			l_return: BOOLEAN
		do
			l_mpos := (create {P_MARK_STATIC}).markpos (a_c)
			if l_mpos = -1 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_tpos := (create {P_POSITION_STATIC}).position (0)
				if l_tpos = -1 then
					l_tpos := (0).to_integer_32
				end
				l_bpos := (create {P_POSITION_STATIC}).position (-1)
				if a_c = 46 then
					Result := (pipe_data (a_cmd, l_tpos, l_bpos))
				elseif l_mpos <= l_tpos then
					Result := (pipe_data (a_cmd, l_mpos, l_bpos))
				elseif l_bpos = -1 then
					Result := (pipe_data (a_cmd, l_tpos, l_bpos))
				else
					Result := (pipe_data (a_cmd, l_tpos, l_mpos))
				end
			end
		end

	pipe_data (a_cmd: CE_POINTER [INTEGER_8]; a_spos, a_epos: INTEGER_32): INTEGER_32
		local
			l_spos: INTEGER_32
			l_f: CE_POINTER [SD_IO_FILE]
			l_c: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_spos := a_spos
			if ((create {P_CH_STATIC}).ch_seek (l_spos)) /= 0 then
				(create {P_OUTPUT_STATIC}).error (ce_string ("Cannot seek to start position"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_f := popen (a_cmd, ce_string ("w"))
				if l_f.is_void then
					(create {P_OUTPUT_STATIC}).error (ce_string ("Cannot create pipe"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				(create {P_SCREEN_STATIC}).clear_bot;
				(create {P_OUTPUT_STATIC}).putstr (ce_string ("!"));
				(create {P_OUTPUT_STATIC}).putstr (a_cmd);
				(create {P_OUTPUT_STATIC}).putstr (ce_string ("%N"));
				(create {P_SCREEN_STATIC}).deinit;
				(create {P_OUTPUT_STATIC}).flush;
				(create {P_SCREEN_STATIC}).raw_mode (0);
				(create {P_SIGNAL_STATIC}).init_signals (0)
				signal (13, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
				l_c := -1
				from
				until
					(l_break)
				loop
					l_break := False
					if a_epos /= -1 then
						l_tmp___1 := l_spos
						l_spos := l_spos + 1
						if not (l_tmp___1 <= a_epos) then
							l_break := True
						end
					end
					if not (l_break) then
						l_c := (create {P_CH_STATIC}).ch_forw_get
						if l_c = -1 then
							l_break := True
						end
					end
					if not (l_break) then
						if (IO_putc (l_c, l_f)) = -1 then
							l_break := True
						end
					end
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					if l_c /= 10 then
						if l_c = -1 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_c := (create {P_CH_STATIC}).ch_forw_get
						if l_c = -1 then
							l_break := True
						end
					end
					if not (l_break) then
						if (IO_putc (l_c, l_f)) = -1 then
							l_break := True
						end
					end
				end
				l_break := False
				pclose (l_f).do_nothing
				signal (13, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing;
				(create {P_SIGNAL_STATIC}).init_signals (1);
				(create {P_SCREEN_STATIC}).raw_mode (1);
				(create {P_SCREEN_STATIC}).init;
				(create {P_COMMAND_STATIC}).screen_trashed.item := 1;
				(create {P_SIGNAL_STATIC}).winch (0)
				Result := 0
			end
		end

end
