class
	P_MAIN_STATIC

inherit
	CE_UTILITIES
	S_UNISTD_STATIC
	S_STRING_STATIC
	S_STDLIB_STATIC

feature {ANY} -- public attributes

	every_first_cmd: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
		end

	new_file: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	is_tty: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	curr_ifile: CE_STATIC [CE_POINTER [ANY]]
		once ("PROCESS")
			Result.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
		end

	old_ifile: CE_STATIC [CE_POINTER [ANY]]
		once ("PROCESS")
			Result.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
		end

	initial_scrpos: CE_STATIC [CE_ARRAY [PD_SCRPOS]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_SCRPOS]}.make (<<1>>)
		end

	any_display: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	start_attnpos: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (-1).to_integer_32
		end

	end_attnpos: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (-1).to_integer_32
		end

	wscroll: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	progname: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	quitting: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	secure: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	dohelp: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	logfile: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	force_logfile: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	namelogfile: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
		end

	editor: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	editproto: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	jump_sline: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	know_dumb: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	save_status: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

feature {ANY} -- public routines

	main (a_argc: INTEGER_32; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		require
			not a_argv.is_void
		local
			l_argc: INTEGER_32
			l_argv: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_ifile: CE_POINTER [ANY]
			l_s: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_tmp___1: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_filename: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_argc := a_argc
					l_argv := a_argv
					l_tmp := l_argv
					l_argv := l_argv + 1
					progname.item := l_tmp.item
					l_argc := l_argc - 1
					secure.item := 0
					l_s := (create {P_DECODE_STATIC}).lgetenv (ce_string ("LESSSECURE"))
					if not l_s.is_void then
						if (l_s[0]).to_integer_32 /= 0 then
							secure.item := 1
						end
					end
					is_tty.item := isatty (1);
					(create {P_SCREEN_STATIC}).get_term;
					(create {P_DECODE_STATIC}).init_cmds;
					(create {P_PROMPT_STATIC}).init_prompt;
					(create {P_CHARSET_STATIC}).init_charset;
					(create {P_LINE_STATIC}).init_line;
					(create {P_OPTTBL_STATIC}).init_option
					l_s := (create {P_DECODE_STATIC}).lgetenv (ce_string ("LESS"))
					if not l_s.is_void then
						(create {P_OPTION_STATIC}).scan_option ((save (l_s)))
					end
				when 1 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if not (l_argc > 0) then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if (l_argv.item[0]).to_integer_32 /= 45 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if (l_argv.item[0]).to_integer_32 /= 43 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___0:
						if (l_argv.item[1]).to_integer_32 = 0 then
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if not ((create {P_OPTION_STATIC}).isoptpending).to_boolean then
							l_break := True
						end
				when 10 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_break := True
				when 12 then
						if not (l_break) then
							l_tmp___1 := l_argv
							l_argv := l_argv + 1
							l_s := l_tmp___1.item
							l_argc := l_argc - 1
							if (strcmp (l_s, ce_string ("--"))) = 0 then
								l_break := True
							end
						end
						if not (l_break) then
							(create {P_OPTION_STATIC}).scan_option (l_s)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					l_break := False
					if ((create {P_OPTION_STATIC}).isoptpending).to_boolean then
						(create {P_OPTION_STATIC}).nopendopt
						quit (0)
					end
					editor.item := (create {P_DECODE_STATIC}).lgetenv (ce_string ("VISUAL"))
					if not (editor.item.is_void) then
						l_pos := -1 + 16 -- skip if block
					end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___1
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if (editor.item[0]).to_integer_32 /= 0 then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L___1:
						editor.item := (create {P_DECODE_STATIC}).lgetenv (ce_string ("EDITOR"))
						if editor.item.is_void then
							editor.item := ce_string ("vi")
						elseif (editor.item[0]).to_integer_32 = 0 then
							editor.item := ce_string ("vi")
						end
				when 18 then -- if done
					editproto.item := (create {P_DECODE_STATIC}).lgetenv (ce_string ("LESSEDIT"))
					if editproto.item.is_void then
						editproto.item := ce_string ("%%E ?lm+%%lm. %%f")
					elseif (editproto.item[0]).to_integer_32 = 0 then
						editproto.item := ce_string ("%%E ?lm+%%lm. %%f")
					end
					l_ifile := create {CE_VOID_POINTER}.make_shared (default_pointer)
					if dohelp.item.to_boolean then
						l_ifile := (create {P_IFILE_STATIC}).get_ifile (ce_string ("@/\less/\help/\file/\@"), l_ifile)
					end
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___5 := l_argc
						l_argc := l_argc - 1
						if not (l_tmp___5 > 0) then
							l_break := True
						end
						if not (l_break) then
							l_filename := (create {P_FILENAME_STATIC}).shell_quote (l_argv.item)
							if l_filename.is_void then
								l_filename := l_argv.item
							end
							l_argv := l_argv + 1;
							(create {P_IFILE_STATIC}).get_ifile (l_filename, l_ifile).do_nothing
							l_ifile := (create {P_IFILE_STATIC}).prev_ifile (create {CE_VOID_POINTER}.make_shared (default_pointer))
						end
					end
					l_break := False
					if not is_tty.item.to_boolean then
						if ((create {P_IFILE_STATIC}).nifile) = 0 then
							if ((create {P_EDIT_STATIC}).edit_stdin) = 0 then
								(create {P_EDIT_STATIC}).cat_file
							end
						elseif ((create {P_EDIT_STATIC}).edit_first) = 0 then
							from
							until
								(l_break)
							loop
								l_break := False;
								(create {P_EDIT_STATIC}).cat_file
								if ((create {P_EDIT_STATIC}).edit_next (1)) /= 0 then
									l_break := True
								end
							end
							l_break := False
						end
						quit (0)
					end
					if ((create {P_SCREEN_STATIC}).missing_cap.item).to_boolean then
						if not (know_dumb.item.item).to_boolean then
							(create {P_OUTPUT_STATIC}).error (ce_string ("WARNING: terminal is not fully functional"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						end
					end
					(create {P_MARK_STATIC}).init_mark;
					(create {P_TTYIN_STATIC}).open_getchr;
					(create {P_SCREEN_STATIC}).raw_mode (1);
					(create {P_SIGNAL_STATIC}).init_signals (1)
					if ((create {P_OPTFUNC_STATIC}).tagoption.item).is_void then
						l_pos := -1 + 21 -- skip if block
					end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L___2
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else:
						if (strcmp ((create {P_TAGS_STATIC}).tags.item, ce_string ("-"))) /= 0 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if: | _L___2:
						if ((create {P_IFILE_STATIC}).nifile) > 0 then
							(create {P_OUTPUT_STATIC}).error (ce_string ("No filenames allowed with -t option"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							quit (1)
						end
						(create {P_TAGS_STATIC}).findtag ((create {P_OPTFUNC_STATIC}).tagoption.item)
						if ((create {P_TAGS_STATIC}).edit_tagfile).to_boolean then
							quit (1)
						end
						initial_scrpos.item.item.pos := (create {P_TAGS_STATIC}).tagsearch
						if initial_scrpos.item.item.pos = -1 then
							quit (1)
						end
						initial_scrpos.item.item.ln := jump_sline.item.item
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						if ((create {P_IFILE_STATIC}).nifile) = 0 then
							if ((create {P_EDIT_STATIC}).edit_stdin).to_boolean then
								quit (1)
							end
						elseif ((create {P_EDIT_STATIC}).edit_first).to_boolean then
							quit (1)
						end
				when 25 then -- if done;
					(create {P_SCREEN_STATIC}).init;
					(create {P_COMMAND_STATIC}).commands
					quit (0)
					Result := 0
				when 26 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	save (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_s.is_void
		local
			l_p: CE_POINTER [INTEGER_8]
		do
			l_p := create {CE_INTEGER_8_POINTER}.make_cast ((ecalloc (((strlen (a_s)) + {NATURAL_32} 1).to_integer_32, {PLATFORM}.Integer_8_bytes.to_natural_32)))
			strcpy (l_p, a_s).do_nothing
			Result := l_p
		end

	ecalloc (a_count: INTEGER_32; a_size: NATURAL_32): CE_POINTER [ANY]
		local
			l_p: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			l_p := (calloc (a_count.to_natural_32, a_size))
			if not l_p.is_void then
				Result := l_p
				l_return := True
			end
			if not l_return then
				(create {P_OUTPUT_STATIC}).error (ce_string ("Cannot allocate memory"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
				quit (1)
				Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
			end
		end

	skipsp (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_s.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
		do
			l_s := a_s
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_s[0]).to_integer_32 /= 32 then
					if (l_s[0]).to_integer_32 /= 9 then
						l_break := True
					end
				end
				if not (l_break) then
					l_s := l_s + 1
				end
			end
			l_break := False
			Result := l_s
		end

	sprefix (a_ps, a_s: CE_POINTER [INTEGER_8]; a_uppercase: INTEGER_32): INTEGER_32
		require
			not a_s.is_void
		local
			l_ps: CE_POINTER [INTEGER_8]
			l_s: CE_POINTER [INTEGER_8]
			l_c: INTEGER_32
			l_sc: INTEGER_32
			l_len: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_ps := a_ps
			l_s := a_s
			l_len := 0
			from
			until
				not (not (l_return or l_break) and then ((l_s[0]).to_integer_32 /= 0))
			loop
				l_break := False
				l_c := (l_ps[0]).to_integer_32
				if a_uppercase.to_boolean then
					if l_len = 0 then
						if l_c >= 97 then
							if l_c <= 122 then
								Result := (-1)
								l_return := True
							end
						end
					end
					if not l_return and then (l_c >= 65) then
						if l_c <= 90 then
							l_c := (l_c - 65) + 97
						end
					end
				end
				if not l_return then
					l_sc := (l_s[0]).to_integer_32
					if l_len > 0 then
						if l_sc >= 65 then
							if l_sc <= 90 then
								l_sc := (l_sc - 65) + 97
							end
						end
					end
					if l_c /= l_sc then
						l_break := True
					end
					if not (l_return or l_break) then
						l_len := l_len + 1
						l_s := l_s + 1
						l_ps := l_ps + 1
					end
				end
			end
			if not l_return then
				l_break := False
				Result := l_len
			end
		end

	quit (a_status: INTEGER_32)
		local
			l_status: INTEGER_32
		do
			l_status := a_status
			if l_status < 0 then
				l_status := save_status.item
			else
				save_status.item := l_status
			end
			quitting.item := 1;
			(create {P_EDIT_STATIC}).edit (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)).do_nothing
			if any_display.item.to_boolean then
				if is_tty.item.to_boolean then
					(create {P_SCREEN_STATIC}).clear_bot
				end
			end
			(create {P_SCREEN_STATIC}).deinit;
			(create {P_OUTPUT_STATIC}).flush;
			(create {P_SCREEN_STATIC}).raw_mode (0);
			(create {P_TTYIN_STATIC}).close_getchr
			exit (l_status)
		end

end
