class
	P_OPTFUNC_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC
	S_STDIO_STATIC

feature {ANY} -- public attributes

	bufspace: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	pr_type: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	prproto: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make (<<3>>)
		end

	tagoption: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
		end

feature {ANY} -- public routines

	opt_o (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_s: CE_POINTER [INTEGER_8]
			l_parg: CE_ARRAY [PD_PARG]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_PARG]} l_parg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					if ((create {P_MAIN_STATIC}).secure.item).to_boolean then
						(create {P_OUTPUT_STATIC}).error (ce_string ("log file support is not available"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						inspect a_type -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 1 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 2 then -- switch 1, case 0;
						(create {P_MAIN_STATIC}).namelogfile.item := l_s
						l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 2
						if ((((create {P_CH_STATIC}).ch_getflags)).bit_and (1)).to_boolean then
							(create {P_OUTPUT_STATIC}).error (ce_string ("Input is not a pipe"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return and then ((create {P_MAIN_STATIC}).logfile.item >= 0) then
							(create {P_OUTPUT_STATIC}).error (ce_string ("Log file is already in use"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return then
							l_s := (create {P_MAIN_STATIC}).skipsp (l_s);
							(create {P_MAIN_STATIC}).namelogfile.item := (create {P_FILENAME_STATIC}).lglob (l_s);
							(create {P_EDIT_STATIC}).use_logfile ((create {P_MAIN_STATIC}).namelogfile.item);
							(create {P_CH_STATIC}).sync_logfile
						end
						l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, case 1
						if (create {P_MAIN_STATIC}).logfile.item < 0 then
							(create {P_OUTPUT_STATIC}).error (ce_string ("No log file"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						else
							l_parg.item.p_string := (create {P_MAIN_STATIC}).namelogfile.item;
							(create {P_OUTPUT_STATIC}).error (ce_string ("Log file %"%%s%""), l_parg)
						end
						l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done: | if done
					if not l_return then
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt__O (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		do
			(create {P_MAIN_STATIC}).force_logfile.item := 1
			opt_o (a_type, a_s)
		end

	opt_l (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_err: CE_ARRAY [INTEGER_32]
			l_n: INTEGER_32
			l_t: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_err.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_t.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					else l_pos := -1 + 2
					end
				when 1 then -- switch 1, case 0
					l_t.item := a_s
					l_n := (create {P_OPTION_STATIC}).getnum (l_t, ce_string ("l"), l_err)
					if (l_err.item).to_boolean then
						(create {P_OUTPUT_STATIC}).error (ce_string ("Line number is required after -l"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						l_return := True
					elseif l_n <= 0 then
						(create {P_OUTPUT_STATIC}).error (ce_string ("Line number is required after -l"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						(create {P_OPTION_STATIC}).plusoption.item := 1;
						(create {P_COMMAND_STATIC}).ungetsc (a_s)
					end
					l_pos := -1 + 2 -- switch 1; break
				when 2 then -- switch 1, done:
					if not l_return then
					end
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_k (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_parg: CE_ARRAY [PD_PARG]
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_PARG]} l_parg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					else l_pos := -1 + 2
					end
				when 1 then -- switch 1, case 0
					if ((create {P_DECODE_STATIC}).lesskey (a_s, 0)).to_boolean then
						l_parg.item.p_string := a_s;
						(create {P_OUTPUT_STATIC}).error (ce_string ("Cannot use lesskey file %"%%s%""), l_parg)
					end
					l_pos := -1 + 2 -- switch 1; break
				when 2 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_t (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_save_ifile: CE_POINTER [ANY]
			l_pos2: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 0
					tagoption.item := a_s
					l_pos := -1 + 6 -- switch 1; break
				when 2 then -- switch 1, case 2
					if ((create {P_MAIN_STATIC}).secure.item).to_boolean then
						(create {P_OUTPUT_STATIC}).error (ce_string ("tags support is not available"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						l_pos := -1 + 6 -- switch 1; break
					end
				when 3 then;
					(create {P_TAGS_STATIC}).findtag (((create {P_MAIN_STATIC}).skipsp (a_s)))
					l_save_ifile := (create {P_EDIT_STATIC}).save_curr_ifile
					if ((create {P_TAGS_STATIC}).edit_tagfile).to_boolean then
						l_pos := -1 + 6 -- switch 1; break
					end
				when 4 then
					l_pos2 := (create {P_TAGS_STATIC}).tagsearch
					if l_pos2 = -1 then
						(create {P_EDIT_STATIC}).reedit_ifile (l_save_ifile)
						l_pos := -1 + 6 -- switch 1; break
					end
				when 5 then;
					(create {P_EDIT_STATIC}).unsave_ifile (l_save_ifile);
					(create {P_JUMP_STATIC}).jump_loc (l_pos2, (create {P_MAIN_STATIC}).jump_sline.item.item)
					l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt__T (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_s: CE_POINTER [INTEGER_8]
			l_parg: CE_ARRAY [PD_PARG]
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_PARG]} l_parg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 0;
					(create {P_TAGS_STATIC}).tags.item := l_s
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_s := (create {P_MAIN_STATIC}).skipsp (l_s);
					(create {P_TAGS_STATIC}).tags.item := (create {P_FILENAME_STATIC}).lglob (l_s)
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 1
					l_parg.item.p_string := (create {P_TAGS_STATIC}).tags.item;
					(create {P_OUTPUT_STATIC}).error (ce_string ("Tags file %"%%s%""), l_parg)
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_p (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					else l_pos := -1 + 2
					end
				when 1 then -- switch 1, case 0;
					(create {P_OPTION_STATIC}).plusoption.item := 1;
					(create {P_COMMAND_STATIC}).ungetsc (a_s);
					(create {P_COMMAND_STATIC}).ungetsc (ce_string ("/"))
					l_pos := -1 + 2 -- switch 1; break
				when 2 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt__P (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_s: CE_POINTER [INTEGER_8]
			l_proto: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_parg: CE_ARRAY [PD_PARG]
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_PARG]} l_parg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 10
					else l_pos := -1 + 11
					end
				when 1 then -- switch 1, case 0 | switch 1, case 2
					inspect (l_s[0]).to_integer_32 -- switch 2 head
					when 115 then l_pos := -1 + 2
					when 109 then l_pos := -1 + 3
					when 77 then l_pos := -1 + 4
					when 61 then l_pos := -1 + 5
					when 104 then l_pos := -1 + 6
					when 119 then l_pos := -1 + 7
					else l_pos := -1 + 8
					end
				when 2 then -- switch 2, case 115
					l_proto := prproto.item + 0
					l_s := l_s + 1
					l_pos := -1 + 9 -- switch 2; break
				when 3 then -- switch 2, case 109
					l_proto := prproto.item + 1
					l_s := l_s + 1
					l_pos := -1 + 9 -- switch 2; break
				when 4 then -- switch 2, case 77
					l_proto := prproto.item + 2
					l_s := l_s + 1
					l_pos := -1 + 9 -- switch 2; break
				when 5 then -- switch 2, case 61
					l_proto := ((create {P_PROMPT_STATIC}).eqproto.item)
					l_s := l_s + 1
					l_pos := -1 + 9 -- switch 2; break
				when 6 then -- switch 2, case 104
					l_proto := ((create {P_PROMPT_STATIC}).hproto.item)
					l_s := l_s + 1
					l_pos := -1 + 9 -- switch 2; break
				when 7 then -- switch 2, case 119
					l_proto := ((create {P_PROMPT_STATIC}).wproto.item)
					l_s := l_s + 1
					l_pos := -1 + 9 -- switch 2; break
				when 8 then -- switch 2, default:
					l_proto := prproto.item + 0
					l_pos := -1 + 9 -- switch 2; break
				when 9 then -- switch 2, done:
					free (create {CE_VOID_POINTER}.make_cast (l_proto.item))
					l_proto.item := (create {P_MAIN_STATIC}).save (l_s)
					l_pos := -1 + 11 -- switch 1; break
				when 10 then -- switch 1, case 1
					l_parg.item.p_string := prproto.item[pr_type.item.item];
					(create {P_OUTPUT_STATIC}).error (ce_string ("%%s"), l_parg)
					l_pos := -1 + 11 -- switch 1; break
				when 11 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_b (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 0 | switch 1, case 2;
					(create {P_CH_STATIC}).ch_setbufspace (bufspace.item.item)
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 1
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_i (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 0 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2;
					(create {P_SEARCH_STATIC}).chg_caseless
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 1 | switch 1, case 0
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt__V (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 1
					when 0 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2 | switch 1, case 1;
					(create {P_COMMAND_STATIC}).dispversion
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 0;
					(create {P_MAIN_STATIC}).any_display.item := 1;
					(create {P_OUTPUT_STATIC}).putstr (ce_string ("less "));
					(create {P_OUTPUT_STATIC}).putstr ((create {P_VERSION_STATIC}).version.item);
					(create {P_OUTPUT_STATIC}).putstr (ce_string ("%NCopyright (C) 2002 Mark Nudelman%N%N"));
					(create {P_OUTPUT_STATIC}).putstr (ce_string ("less comes with NO WARRANTY, to the extent permitted by law.%N"));
					(create {P_OUTPUT_STATIC}).putstr (ce_string ("For information about the terms of redistribution,%N"));
					(create {P_OUTPUT_STATIC}).putstr (ce_string ("see the file named README in the less distribution.%N"));
					(create {P_OUTPUT_STATIC}).putstr (ce_string ("Homepage: http://www.greenwoodsoftware.com/less%N"));
					(create {P_MAIN_STATIC}).quit (0)
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_x (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_s: CE_POINTER [INTEGER_8]
			l_msg: CE_ARRAY [INTEGER_8]
			l_i: INTEGER_32
			l_p: CE_ARRAY [PD_PARG]
			l_n: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_msg.make (<<188>>)
			create {CE_CLASS_ARRAY [PD_PARG]} l_p.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 0 | switch 1, case 2
					l_i := 1
					from
					until
						not (not (l_return or l_break) and then (l_i < 32))
					loop
						l_break := False
						l_n := 0
						l_s := (create {P_MAIN_STATIC}).skipsp (l_s)
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_s[0]).to_integer_32 >= 48 then
								if not ((l_s[0]).to_integer_32 <= 57) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_tmp := l_s
								l_s := l_s + 1
								l_n := 10 * l_n + ((l_tmp[0]).to_integer_32 - 48)
							end
						end
						l_break := False
						if l_n > (create {P_LINE_STATIC}).tabstops.item[l_i - 1] then
							l_tmp___0 := l_i
							l_i := l_i + 1;
							(create {P_LINE_STATIC}).tabstops.item[l_tmp___0] := l_n
						end
						l_s := (create {P_MAIN_STATIC}).skipsp (l_s)
						l_tmp___1 := l_s
						l_s := l_s + 1
						if (l_tmp___1[0]).to_integer_32 /= 44 then
							l_break := True
						end
					end
					l_break := False
					if l_i < 2 then
						l_return := True
					end
					if not l_return then
						(create {P_LINE_STATIC}).ntabstops.item := l_i;
						(create {P_LINE_STATIC}).tabdefault.item := (create {P_LINE_STATIC}).tabstops.item[(create {P_LINE_STATIC}).ntabstops.item - 1] - (create {P_LINE_STATIC}).tabstops.item[(create {P_LINE_STATIC}).ntabstops.item - 2]
					end
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 1
					strcpy (l_msg, ce_string ("Tab stops ")).do_nothing
					if (create {P_LINE_STATIC}).ntabstops.item > 2 then
						l_i := 1
						from
						until
							not (l_i < (create {P_LINE_STATIC}).ntabstops.item)
						loop
							if l_i > 1 then
								strcat (l_msg, ce_string (",")).do_nothing
							end
							sprintf ([(l_msg + (strlen (l_msg)).to_integer_32), ce_string ("%%d"), (create {P_LINE_STATIC}).tabstops.item[l_i]]).do_nothing
							l_i := l_i + 1
						end
						sprintf ([(l_msg + (strlen (l_msg)).to_integer_32), ce_string (" and then ")]).do_nothing
					end
					sprintf ([(l_msg + (strlen (l_msg)).to_integer_32), ce_string ("every %%d spaces"), (create {P_LINE_STATIC}).tabdefault.item]).do_nothing
					l_p.item.p_string := l_msg;
					(create {P_OUTPUT_STATIC}).error (ce_string ("%%s"), l_p)
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
					if not l_return then
					end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_quote (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_buf___1: CE_ARRAY [INTEGER_8]
			l_parg: CE_ARRAY [PD_PARG]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_buf___1.make (<<3>>)
			create {CE_CLASS_ARRAY [PD_PARG]} l_parg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 0 | switch 1, case 2
					if (a_s[0]).to_integer_32 = 0 then
						(create {P_CMDBUF_STATIC}).closequote.item := (('%/0/').code).to_integer_8;
						(create {P_CMDBUF_STATIC}).openquote.item := (create {P_CMDBUF_STATIC}).closequote.item
						l_pos := -1 + 4 -- switch 1; break
					end
				when 2 then
					if (a_s[1]).to_integer_32 /= 0 then
						if (a_s[2]).to_integer_32 /= 0 then
							(create {P_OUTPUT_STATIC}).error (ce_string ("-%" must be followed by 1 or 2 chars"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_return := True
						end
					end
					if not l_return then
						(create {P_CMDBUF_STATIC}).openquote.item := a_s[0]
						if (a_s[1]).to_integer_32 = 0 then
							(create {P_CMDBUF_STATIC}).closequote.item := (create {P_CMDBUF_STATIC}).openquote.item
						else
							(create {P_CMDBUF_STATIC}).closequote.item := a_s[1]
						end
					end
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 1
					l_buf___1[0] := (create {P_CMDBUF_STATIC}).openquote.item
					l_buf___1[1] := (create {P_CMDBUF_STATIC}).closequote.item
					l_buf___1[2] := (('%/0/').code).to_integer_8
					l_parg.item.p_string := l_buf___1;
					(create {P_OUTPUT_STATIC}).error (ce_string ("quotes %%s"), l_parg)
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					if not l_return then
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_query (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 1
					when 0 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 1 | switch 1, case 2;
					(create {P_OUTPUT_STATIC}).error (ce_string ("Use %"h%" for help"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 0;
					(create {P_MAIN_STATIC}).dohelp.item := 1
				when 3 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_swindow: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (create {P_COMMAND_STATIC}).swindow.item.item > 0 then
				Result := ((create {P_COMMAND_STATIC}).swindow.item.item)
				l_return := True
			end
			if not l_return then
				Result := ((create {P_SCREEN_STATIC}).sc_height.item + (create {P_COMMAND_STATIC}).swindow.item.item)
			end
		end

feature {ANY} -- routine addresses

	opt_o_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent opt_o)
		end

	opt__O_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent opt__O)
		end

	opt_l_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent opt_l)
		end

	opt_k_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent opt_k)
		end

	opt_t_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent opt_t)
		end

	opt__T_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent opt__T)
		end

	opt_p_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent opt_p)
		end

	opt__P_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent opt__P)
		end

	opt_b_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent opt_b)
		end

	opt_i_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent opt_i)
		end

	opt__V_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent opt__V)
		end

	opt_x_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent opt_x)
		end

	opt_quote_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent opt_quote)
		end

	opt_query_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent opt_query)
		end

end
