class
	P_SEARCH_STATIC

inherit
	CE_UTILITIES
	S_CTYPE_STATIC
	S_REGEX_STATIC
	S_STDLIB_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	hide_hilite: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	prep_startpos: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	prep_endpos: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	hilite_anchor: CE_STATIC [CE_ARRAY [PD_HILITE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_HILITE]}.make_initialized (<<
					create {PD_HILITE}.make_initialized ([create {CE_CLASS_POINTER [PD_HILITE]}.make_shared (default_pointer), (-1).to_integer_32, (-1).to_integer_32])
				>>)
		end

	regpattern: CE_STATIC [CE_POINTER [SD_RE_PATTERN_BUFFER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [SD_RE_PATTERN_BUFFER]}.make_shared (default_pointer)
		end

	is_caseless: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	is_ucase_pattern: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	last_search_type: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	last_pattern: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
		end

feature {ANY} -- public routines

	cvt_text (a_odst, a_osrc: CE_POINTER [INTEGER_8]; a_ops: INTEGER_32)
		require
			not a_odst.is_void
			not a_osrc.is_void
		local
			l_dst: CE_POINTER [INTEGER_8]
			l_src: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src := a_osrc
					l_dst := a_odst
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_src[0]).to_integer_32 /= 0)) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						if not (((a_ops).bit_and (1)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if ((((ctype_b_loc).item[((l_src[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (256)).to_boolean then
							l_tmp := l_dst
							l_dst := l_dst + 1
							l_tmp[0] := (tolower (((l_src[0]).to_natural_8).to_integer_32)).to_integer_8
						else
							l_pos := -1 + 5 -- goto _L___1
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else: | _L___1:
						if not (((a_ops).bit_and (2)).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_src[0]).to_integer_32 = 8 then
							if (l_dst.c_pointer.to_integer_32).to_natural_32 > (a_odst.c_pointer.to_integer_32).to_natural_32 then
								l_dst := l_dst - 1
							else
								l_pos := -1 + 8 -- goto _L___0
							end
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L___0:
						if ((a_ops).bit_and (8)).to_boolean then
							if (l_src[0]).to_integer_32 = 27 then
								from
								until
									not (not (l_break) and then ((l_src[1]).to_integer_32 /= 0))
								loop
									l_break := False
									l_src := l_src + 1
									if ((create {P_LINE_STATIC}).is_ansi_end (((l_src[0]).to_integer_32).to_integer_8)).to_boolean then
										l_break := True
									end
								end
								l_break := False
							else
								l_tmp___2 := l_dst
								l_dst := l_dst + 1
								l_tmp___2[0] := l_src[0]
							end
						else
							l_tmp___2 := l_dst
							l_dst := l_dst + 1
							l_tmp___2[0] := l_src[0]
						end
				when 9 then -- if done
						l_src := l_src + 1
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					if ((a_ops).bit_and (4)).to_boolean then
						if (l_dst.c_pointer.to_integer_32).to_natural_32 > (a_odst.c_pointer.to_integer_32).to_natural_32 then
							if (l_dst[-1]).to_integer_32 = 13 then
								l_dst := l_dst - 1
							end
						end
					end
					l_dst[0] := (('%/0/').code).to_integer_8
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_cvt_ops: INTEGER_32
		local
			l_ops: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ops := 0
					if not (is_caseless.item.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (create {P_LINE_STATIC}).bs_mode.item.item /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if is_caseless.item.to_boolean then
							l_ops := (l_ops).bit_or ((1))
						end
						if (create {P_LINE_STATIC}).bs_mode.item.item = 0 then
							l_ops := (l_ops).bit_or ((2))
						end
						if (create {P_LINE_STATIC}).bs_mode.item.item /= 2 then
							l_ops := (l_ops).bit_or ((4))
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if (create {P_LINE_STATIC}).bs_mode.item.item /= 2 then
							l_ops := (l_ops).bit_or ((4))
						end
				when 7 then -- if done
					if (create {P_LINE_STATIC}).ctldisp.item.item = 2 then
						l_ops := (l_ops).bit_or ((8))
					end
					Result := l_ops
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	is_ucase (a_s: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_s.is_void
		local
			l_p: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_p := a_s
			from
			until
				not (not (l_return) and then ((l_p[0]).to_integer_32 /= 0))
			loop
				if ((((ctype_b_loc).item[((l_p[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (256)).to_boolean then
					Result := 1
					l_return := True
				end
				if not l_return then
					l_p := l_p + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	prev_pattern: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((last_search_type.item).bit_and (512)).to_boolean then
				Result := (not last_pattern.item.is_void).to_integer
				l_return := True
			end
			if not l_return then
				Result := (not regpattern.item.is_void).to_integer
			end
		end

	repaint_hilite (a_on: INTEGER_32)
		local
			l_slinenum: INTEGER_32
			l_pos2: INTEGER_32
			l_epos: INTEGER_32
			l_save_hide_hilite: INTEGER_32
			l_return, l_continue: BOOLEAN
		do
			if ((create {P_FORWBACK_STATIC}).squished.item).to_boolean then
				(create {P_JUMP_STATIC}).repaint
			end
			l_save_hide_hilite := hide_hilite.item
			if not a_on.to_boolean then
				if hide_hilite.item.to_boolean then
					l_return := True
				end
				if not l_return then
					hide_hilite.item := 1
				end
			end
			if not l_return and then (not ((create {P_SCREEN_STATIC}).can_goto_line.item).to_boolean) then
				(create {P_JUMP_STATIC}).repaint
				hide_hilite.item := l_save_hide_hilite
				l_return := True
			end
			if not l_return then
				l_slinenum := 0
				from
				until
					not (l_slinenum < (create {P_SCREEN_STATIC}).sc_height.item - 1)
				loop
					l_continue := False
					l_pos2 := (create {P_POSITION_STATIC}).position (l_slinenum)
					if l_pos2 = -1 then
						l_continue := True
					end
					if not (l_continue) then
						l_epos := (create {P_POSITION_STATIC}).position (l_slinenum + 1)
						if (is_hilited (l_pos2, l_epos, 1)).to_boolean then
							(create {P_INPUT_STATIC}).forw_line (l_pos2).do_nothing;
							(create {P_SCREEN_STATIC}).goto_line (l_slinenum);
							(create {P_OUTPUT_STATIC}).put_line
						end
					end
					l_slinenum := l_slinenum + 1
				end
				l_continue := False
				hide_hilite.item := l_save_hide_hilite
			end
		end

	clear_attn
		local
			l_slinenum: INTEGER_32
			l_old_start_attnpos: INTEGER_32
			l_old_end_attnpos: INTEGER_32
			l_pos2: INTEGER_32
			l_epos: INTEGER_32
			l_return, l_continue: BOOLEAN
		do
			if (create {P_MAIN_STATIC}).start_attnpos.item = -1 then
				l_return := True
			end
			if not l_return then
				l_old_start_attnpos := (create {P_MAIN_STATIC}).start_attnpos.item
				l_old_end_attnpos := (create {P_MAIN_STATIC}).end_attnpos.item;
				(create {P_MAIN_STATIC}).end_attnpos.item := (-1).to_integer_32;
				(create {P_MAIN_STATIC}).start_attnpos.item := (create {P_MAIN_STATIC}).end_attnpos.item
				if not ((create {P_SCREEN_STATIC}).can_goto_line.item).to_boolean then
					(create {P_JUMP_STATIC}).repaint
					l_return := True
				end
			end
			if not l_return then
				if ((create {P_FORWBACK_STATIC}).squished.item).to_boolean then
					(create {P_JUMP_STATIC}).repaint
				end
				l_slinenum := 0
				from
				until
					not (l_slinenum < (create {P_SCREEN_STATIC}).sc_height.item - 1)
				loop
					l_continue := False
					l_pos2 := (create {P_POSITION_STATIC}).position (l_slinenum)
					if l_pos2 = -1 then
						l_continue := True
					end
					if not (l_continue) then
						l_epos := (create {P_POSITION_STATIC}).position (l_slinenum + 1)
						if l_pos2 < l_old_end_attnpos then
							if l_epos = -1 then
								(create {P_INPUT_STATIC}).forw_line (l_pos2).do_nothing;
								(create {P_SCREEN_STATIC}).goto_line (l_slinenum);
								(create {P_OUTPUT_STATIC}).put_line
							elseif l_epos > l_old_start_attnpos then
								(create {P_INPUT_STATIC}).forw_line (l_pos2).do_nothing;
								(create {P_SCREEN_STATIC}).goto_line (l_slinenum);
								(create {P_OUTPUT_STATIC}).put_line
							end
						end
					end
					l_slinenum := l_slinenum + 1
				end
				l_continue := False
			end
		end

	undo_search
		local
			l_return: BOOLEAN
		do
			if not (prev_pattern).to_boolean then
				(create {P_OUTPUT_STATIC}).error (ce_string ("No previous regular expression"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				hide_hilite.item := (not hide_hilite.item.to_boolean).to_integer
				repaint_hilite (1)
			end
		end

	compile_pattern (a_pattern: CE_POINTER [INTEGER_8]; a_search_type___0: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [SD_RE_PATTERN_BUFFER]
			l_return: BOOLEAN
		do
			if ((a_search_type___0).bit_and (512)) = 0 then
				l_s := create {CE_CLASS_POINTER [SD_RE_PATTERN_BUFFER]}.make_cast (((create {P_MAIN_STATIC}).ecalloc (1, (create {SD_RE_PATTERN_BUFFER}.make).structure_size.to_natural_32)))
				if (regcomp (l_s, a_pattern, 1)).to_boolean then
					free (create {CE_VOID_POINTER}.make_cast (l_s));
					(create {P_OUTPUT_STATIC}).error (ce_string ("Invalid pattern"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
					Result := (-1)
					l_return := True
				end
				if not l_return then
					if not regpattern.item.is_void then
						regfree (regpattern.item)
					end
					regpattern.item := l_s
				end
			end
			if not l_return then
				if not last_pattern.item.is_void then
					free (create {CE_VOID_POINTER}.make_cast (last_pattern.item))
				end
				last_pattern.item := create {CE_INTEGER_8_POINTER}.make_cast ((calloc ((1).to_natural_32, (strlen (a_pattern)) + {NATURAL_32} 1)))
				if not last_pattern.item.is_void then
					strcpy (last_pattern.item, a_pattern).do_nothing
				end
				last_search_type.item := a_search_type___0
				Result := 0
			end
		end

	uncompile_pattern
		do
			if not regpattern.item.is_void then
				regfree (regpattern.item)
			end
			regpattern.item := create {CE_CLASS_POINTER [SD_RE_PATTERN_BUFFER]}.make_shared (default_pointer)
			last_pattern.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
		end

	match_pattern (a_line: CE_POINTER [INTEGER_8]; a_sp, a_ep: CE_POINTER [CE_POINTER [INTEGER_8]]; a_notbol: INTEGER_32): INTEGER_32
		local
			l_matched: INTEGER_32
			l_rm: CE_ARRAY [SD_REGMATCH_T]
			l_flags: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_REGMATCH_T]} l_rm.make (<<1>>)

			if ((last_search_type.item).bit_and (512)).to_boolean then
				Result := (match (last_pattern.item, a_line, a_sp, a_ep))
				l_return := True
			end
			if not l_return then
				if a_notbol.to_boolean then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
				l_flags := l_tmp___0
				if (regexec (regpattern.item, a_line, (1).to_natural_32, l_rm, l_flags)).to_boolean then
					l_tmp___2 := 0
				else
					l_tmp___2 := 1
				end
				l_matched := l_tmp___2
				if not l_matched.to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				a_sp.item := a_line + l_rm.item.rm_so
				a_ep.item := a_line + l_rm.item.rm_eo
				Result := l_matched
			end
		end

	clr_hilite
		local
			l_hl: CE_POINTER [PD_HILITE]
			l_nexthl: CE_POINTER [PD_HILITE]
		do
			l_hl := hilite_anchor.item.item.hl_next
			from
			until
				l_hl.is_void
			loop
				l_nexthl := l_hl.item.hl_next
				free (create {CE_VOID_POINTER}.make_cast (l_hl))
				l_hl := l_nexthl
			end
			hilite_anchor.item.item.hl_next := create {CE_CLASS_POINTER [PD_HILITE]}.make_shared (default_pointer)
			prep_endpos.item := (-1).to_integer_32
			prep_startpos.item := prep_endpos.item
		end

	is_hilited (a_pos, a_epos: INTEGER_32; a_nohide: INTEGER_32): INTEGER_32
		local
			l_hl: CE_POINTER [PD_HILITE]
			l_return: BOOLEAN
		do
			if not ((create {P_LINE_STATIC}).status_col.item.item).to_boolean then
				if (create {P_MAIN_STATIC}).start_attnpos.item /= -1 then
					if a_pos < (create {P_MAIN_STATIC}).end_attnpos.item then
						if a_epos = -1 then
							Result := 1
							l_return := True
						elseif a_epos > (create {P_MAIN_STATIC}).start_attnpos.item then
							Result := 1
							l_return := True
						end
					end
				end
			end
			if not l_return and then ((create {P_SCREEN_STATIC}).hilite_search.item.item = 0) then
				Result := 0
				l_return := True
			end
			if not l_return and then (not a_nohide.to_boolean) then
				if hide_hilite.item.to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_hl := hilite_anchor.item.item.hl_next
				from
				until
					not (not (l_return) and then (not l_hl.is_void))
				loop
					if l_hl.item.hl_endpos > a_pos then
						if a_epos = -1 then
							Result := 1
							l_return := True
						elseif a_epos > l_hl.item.hl_startpos then
							Result := 1
							l_return := True
						end
					end
					if not l_return then
						l_hl := l_hl.item.hl_next
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	add_hilite (a_anchor___1, a_hl: CE_POINTER [PD_HILITE])
		require
			not a_anchor___1.is_void
			not a_hl.is_void
		local
			l_ihl: CE_POINTER [PD_HILITE]
			l_return, l_break: BOOLEAN
		do
			l_ihl := a_anchor___1
			from
			until
				not (not (l_break) and then (not (l_ihl.item.hl_next).is_void))
			loop
				l_break := False
				if (l_ihl.item.hl_next).item.hl_startpos > a_hl.item.hl_startpos then
					l_break := True
				end
				if not (l_break) then
					l_ihl := l_ihl.item.hl_next
				end
			end
			l_break := False
			if not l_ihl.is_equal (a_anchor___1) then
				if a_hl.item.hl_startpos > l_ihl.item.hl_endpos then
					a_hl.item.hl_startpos := a_hl.item.hl_startpos
				else
					a_hl.item.hl_startpos := l_ihl.item.hl_endpos
				end
			end
			if not (l_ihl.item.hl_next).is_void then
				if a_hl.item.hl_endpos < (l_ihl.item.hl_next).item.hl_startpos then
					a_hl.item.hl_endpos := a_hl.item.hl_endpos
				else
					a_hl.item.hl_endpos := (l_ihl.item.hl_next).item.hl_startpos
				end
			end
			if a_hl.item.hl_startpos >= a_hl.item.hl_endpos then
				free (create {CE_VOID_POINTER}.make_cast (a_hl))
				l_return := True
			end
			if not l_return then
				a_hl.item.hl_next := l_ihl.item.hl_next
				l_ihl.item.hl_next := a_hl
			end
		end

	hilite_line (a_linepos: INTEGER_32; a_line, a_sp, a_ep: CE_POINTER [INTEGER_8]; a_cvt_ops: INTEGER_32)
		local
			l_ep: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_sp: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_searchp: CE_POINTER [INTEGER_8]
			l_hl: CE_POINTER [PD_HILITE]
			l_hilites___0: CE_ARRAY [PD_HILITE]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_ep.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_sp.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_HILITE]} l_hilites___0.make (<<1>>)

			l_ep.item := a_ep
			l_sp.item := a_sp
			if (l_sp.item).is_void then
				l_return := True
			elseif (l_ep.item).is_void then
				l_return := True
			end
			if not l_return then
				l_searchp := a_line
				l_hilites___0.item.hl_next := create {CE_CLASS_POINTER [PD_HILITE]}.make_shared (default_pointer)
				from
				until
					(l_break)
				loop
					l_break := False
					if ((l_ep.item).c_pointer.to_integer_32).to_natural_32 > ((l_sp.item).c_pointer.to_integer_32).to_natural_32 then
						l_hl := create {CE_CLASS_POINTER [PD_HILITE]}.make_cast (((create {P_MAIN_STATIC}).ecalloc (1, (create {PD_HILITE}.make).structure_size.to_natural_32)))
						l_hl.item.hl_startpos := a_linepos + ((l_sp.item).distance (a_line)).to_integer_32
						l_hl.item.hl_endpos := a_linepos + ((l_ep.item).distance (a_line)).to_integer_32
						add_hilite (l_hilites___0, l_hl)
					end
					if ((l_ep.item).c_pointer.to_integer_32).to_natural_32 > (l_searchp.c_pointer.to_integer_32).to_natural_32 then
						l_searchp := l_ep.item
					elseif (l_searchp[0]).to_integer_32 /= 0 then
						l_searchp := l_searchp + 1
					else
						l_break := True
					end
					if not (l_break) then
						if not (match_pattern (l_searchp, l_sp, l_ep, 1)).to_boolean then
							l_break := True
						end
					end
				end
				l_break := False
				l_hilites___0.item.adj_hilite (a_linepos, a_cvt_ops)
				from
				until
					(l_break)
				loop
					l_break := False
					l_hl := l_hilites___0.item.hl_next
					if l_hl.is_void then
						l_break := True
					end
					if not (l_break) then
						l_hilites___0.item.hl_next := l_hl.item.hl_next
						add_hilite (hilite_anchor.item, l_hl)
					end
				end
				l_break := False
			end
		end

	chg_caseless
		do
			if not is_ucase_pattern.item.to_boolean then
				is_caseless.item := (create {P_OPTTBL_STATIC}).caseless.item.item
			else
				uncompile_pattern
			end
		end

	hilite_screen
		local
			l_scrpos: CE_ARRAY [PD_SCRPOS]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_SCRPOS]} l_scrpos.make (<<1>>)

			l_scrpos.item.get_scrpos
			if l_scrpos.item.pos = -1 then
				l_return := True
			end
			if not l_return then
				prep_hilite (l_scrpos.item.pos, ((create {P_POSITION_STATIC}).position (-2)), -1)
				repaint_hilite (1)
			end
		end

	chg_hilite
		do
			clr_hilite
			hide_hilite.item := 0
			if (create {P_SCREEN_STATIC}).hilite_search.item.item = 2 then
				hilite_screen
			end
		end

	search_pos (a_search_type___0: INTEGER_32): INTEGER_32
		local
			l_pos2: INTEGER_32
			l_linenum: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if ((create {P_POSITION_STATIC}).empty_screen).to_boolean then
				if ((a_search_type___0).bit_and (1)).to_boolean then
					Result := (0).to_integer_32
					l_return := True
				else
					l_pos2 := (create {P_CH_STATIC}).ch_length
					if l_pos2 = -1 then
						(create {P_CH_STATIC}).ch_end_seek.do_nothing
						l_pos2 := (create {P_CH_STATIC}).ch_length
					end
					Result := l_pos2
					l_return := True
				end
			end
			if not l_return then
				if ((create {P_OPTTBL_STATIC}).how_search.item.item).to_boolean then
					if ((a_search_type___0).bit_and (1)).to_boolean then
						l_linenum := -2
					else
						l_linenum := 0
					end
					l_pos2 := (create {P_POSITION_STATIC}).position (l_linenum)
				else
					l_linenum := (create {P_POSITION_STATIC}).adjsline ((create {P_MAIN_STATIC}).jump_sline.item.item)
					l_pos2 := (create {P_POSITION_STATIC}).position (l_linenum)
					if ((a_search_type___0).bit_and (1)).to_boolean then
						l_pos2 := (create {P_LINE_STATIC}).forw_raw_line (l_pos2, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer))
						from
						until
							not (not (l_break) and then (l_pos2 = -1))
						loop
							l_break := False
							l_linenum := l_linenum + 1
							if l_linenum >= (create {P_SCREEN_STATIC}).sc_height.item then
								l_break := True
							end
							if not (l_break) then
								l_pos2 := (create {P_POSITION_STATIC}).position (l_linenum)
							end
						end
						l_break := False
					else
						from
						until
							not (not (l_break) and then (l_pos2 = -1))
						loop
							l_break := False
							l_linenum := l_linenum - 1
							if l_linenum < 0 then
								l_break := True
							end
							if not (l_break) then
								l_pos2 := (create {P_POSITION_STATIC}).position (l_linenum)
							end
						end
						l_break := False
					end
				end
				Result := l_pos2
			end
		end

	search_range (a_pos, a_endpos: INTEGER_32; a_search_type___0, a_matches, a_maxlines: INTEGER_32; a_plinepos, a_pendpos___0: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_pos2: INTEGER_32
			l_matches: INTEGER_32
			l_maxlines: INTEGER_32
			l_line: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_linenum: INTEGER_32
			l_sp: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_ep: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_line_match: INTEGER_32
			l_cvt_ops: INTEGER_32
			l_linepos: INTEGER_32
			l_oldpos: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_line.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_sp.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_ep.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pos2 := a_pos
					l_matches := a_matches
					l_maxlines := a_maxlines
					l_linenum := (create {P_LINENUM_STATIC}).find_linenum (l_pos2)
					l_oldpos := l_pos2
				when 1 then -- loop condition:
					if (l_return) then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						l_continue := False
						if (((create {P_CH_STATIC}).sigs.item).bit_and (3)).to_boolean then
							Result := (-1)
							l_return := True
						end
						if l_return then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if a_endpos = -1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_pos2 >= a_endpos then
							l_pos := -1 + 7 -- goto _L
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else: | _L___0:
						if l_maxlines /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if not a_pendpos___0.is_void then
							a_pendpos___0.item := l_pos2
						end
						Result := l_matches
						l_return := True
				when 8 then -- if done | if done
						if not l_return then
							if l_maxlines > 0 then
								l_maxlines := l_maxlines - 1
							end
							if ((a_search_type___0).bit_and (1)).to_boolean then
								l_linepos := l_pos2
								l_pos2 := (create {P_LINE_STATIC}).forw_raw_line (l_pos2, l_line)
								if l_linenum /= 0 then
									l_linenum := l_linenum + 1
								end
							else
								l_pos2 := (create {P_LINE_STATIC}).back_raw_line (l_pos2, l_line)
								l_linepos := l_pos2
								if l_linenum /= 0 then
									l_linenum := l_linenum - 1
								end
							end
							if l_pos2 = -1 then
								if not a_pendpos___0.is_void then
									a_pendpos___0.item := l_oldpos
								end
								Result := l_matches
								l_return := True
							end
						end
						if l_return then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if:
						if ((create {P_LINE_STATIC}).linenums.item.item).to_boolean then
							if (abs ((l_pos2 - l_oldpos).to_integer_32)) > 1_024 then
								(create {P_LINENUM_STATIC}).add_lnum (l_linenum, l_pos2)
							end
						end
						l_oldpos := l_pos2
						l_cvt_ops := get_cvt_ops
						cvt_text (l_line.item, l_line.item, l_cvt_ops)
						l_line_match := match_pattern (l_line.item, l_sp, l_ep, 0)
						if ((a_search_type___0).bit_and (64)).to_boolean then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_line_match.to_boolean then
							l_tmp___0 := 1
						else
							l_pos := -1 + 12 -- goto _L___1
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___1:
						if ((a_search_type___0).bit_and (64)).to_boolean then
							if not l_line_match.to_boolean then
								l_tmp___0 := 1
							else
								l_tmp___0 := 0
							end
						else
							l_tmp___0 := 0
						end
				when 13 then
						l_line_match := l_tmp___0
						if not l_line_match.to_boolean then
							l_continue := True
						end
						if not (l_return or l_continue) then
							if ((a_search_type___0).bit_and (8)).to_boolean then
								if l_line_match.to_boolean then
									hilite_line (l_linepos, l_line.item, l_sp.item, l_ep.item, l_cvt_ops)
								end
							else
								l_matches := l_matches - 1
								if l_matches <= 0 then
									if (create {P_SCREEN_STATIC}).hilite_search.item.item = 1 then
										clr_hilite
										if l_line_match.to_boolean then
											hilite_line (l_linepos, l_line.item, l_sp.item, l_ep.item, l_cvt_ops)
										end
									end
									if not a_plinepos.is_void then
										a_plinepos.item := l_linepos
									end
									Result := 0
									l_return := True
								end
							end
						end
						if (not l_return) then
							
						end
				when 14 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					if not l_return then
						l_continue := False
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	search (a_search_type___0: INTEGER_32; a_pattern: CE_POINTER [INTEGER_8]; a_n: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_pos2: CE_ARRAY [INTEGER_32]
			l_ucase: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_pos2.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := a_n
					if not (a_pattern.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (a_pattern[0]).to_integer_32 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if not (prev_pattern).to_boolean then
							(create {P_OUTPUT_STATIC}).error (ce_string ("No previous regular expression"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							Result := (-1)
							l_return := True
						end
						if not l_return and then (((a_search_type___0).bit_and (512)) /= ((last_search_type.item).bit_and (512))) then
							(create {P_OUTPUT_STATIC}).error (ce_string ("Please re-enter search pattern"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							Result := (-1)
							l_return := True
						end
						if not l_return then
							if (create {P_SCREEN_STATIC}).hilite_search.item.item = 1 then
								repaint_hilite (0)
							end
							if (create {P_SCREEN_STATIC}).hilite_search.item.item = 2 then
								if hide_hilite.item.to_boolean then
									hide_hilite.item := 0
									hilite_screen
								end
							end
							hide_hilite.item := 0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_ucase := is_ucase (a_pattern)
						if (create {P_OPTTBL_STATIC}).caseless.item.item = 2 then
							cvt_text (a_pattern, a_pattern, 1)
						end
						if (compile_pattern (a_pattern, a_search_type___0)) < 0 then
							Result := (-1)
							l_return := True
						end
						if not l_return then
							is_ucase_pattern.item := l_ucase
							if is_ucase_pattern.item.to_boolean then
								if (create {P_OPTTBL_STATIC}).caseless.item.item /= 2 then
									is_caseless.item := 0
								else
									is_caseless.item := (create {P_OPTTBL_STATIC}).caseless.item.item
								end
							else
								is_caseless.item := (create {P_OPTTBL_STATIC}).caseless.item.item
							end
							if ((create {P_SCREEN_STATIC}).hilite_search.item.item).to_boolean then
								repaint_hilite (0)
								hide_hilite.item := 0
								clr_hilite
							end
							if (create {P_SCREEN_STATIC}).hilite_search.item.item = 2 then
								hilite_screen
							end
						end
				when 7 then -- if done
					if not l_return then
						l_pos2.item := search_pos (a_search_type___0)
						if l_pos2.item = -1 then
							if ((a_search_type___0).bit_and (128)).to_boolean then
								Result := l_n
								l_return := True
							end
							if not l_return then
								(create {P_OUTPUT_STATIC}).error (ce_string ("Nothing to search"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
								Result := (-1)
								l_return := True
							end
						end
					end
					if not l_return then
						l_n := search_range (l_pos2.item, (-1).to_integer_32, a_search_type___0, l_n, -1, l_pos2, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						if l_n /= 0 then
							if (create {P_SCREEN_STATIC}).hilite_search.item.item = 1 then
								if l_n > 0 then
									repaint_hilite (1)
								end
							end
							Result := l_n
							l_return := True
						end
					end
					if not l_return then
						if not ((a_search_type___0).bit_and (4)).to_boolean then
							(create {P_JUMP_STATIC}).jump_loc (l_pos2.item, (create {P_MAIN_STATIC}).jump_sline.item.item)
						end
						if (create {P_SCREEN_STATIC}).hilite_search.item.item = 1 then
							repaint_hilite (1)
						end
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	prep_hilite (a_spos, a_epos: INTEGER_32; a_maxlines: INTEGER_32)
		local
			l_spos: INTEGER_32
			l_epos: INTEGER_32
			l_nprep_startpos: INTEGER_32
			l_nprep_endpos: INTEGER_32
			l_new_epos: CE_ARRAY [INTEGER_32]
			l_max_epos: INTEGER_32
			l_result: INTEGER_32
			l_i: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_new_epos.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_spos := a_spos
					l_epos := a_epos
					l_nprep_startpos := prep_startpos.item
					l_nprep_endpos := prep_endpos.item
					if not (prev_pattern).to_boolean then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						if a_maxlines < 0 then
							l_max_epos := (-1).to_integer_32
						else
							l_max_epos := l_spos
							l_i := 0
							from
							until
								not (l_i < a_maxlines)
							loop
								l_max_epos := (create {P_LINE_STATIC}).forw_raw_line (l_max_epos, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer))
								l_i := l_i + 1
							end
						end
						if prep_startpos.item /= -1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						if l_epos = -1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_epos < prep_startpos.item then
							l_pos := -1 + 8 -- goto _L
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else: | _L___0:
						if not (l_spos > prep_endpos.item) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						clr_hilite
						if l_epos /= -1 then
							l_epos := l_epos + (3 * (create {P_LINE_STATIC}).size_linebuf.item).to_integer_32
						end
						l_nprep_startpos := l_spos
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						if l_epos /= -1 then
							if l_epos > prep_endpos.item then
								l_epos := l_epos + (3 * (create {P_LINE_STATIC}).size_linebuf.item).to_integer_32
							else
								l_epos := prep_startpos.item
							end
						end
						if l_spos < prep_startpos.item then
							if l_spos < (3 * (create {P_LINE_STATIC}).size_linebuf.item).to_integer_32 then
								l_spos := (0).to_integer_32
							else
								l_spos := l_spos - (3 * (create {P_LINE_STATIC}).size_linebuf.item).to_integer_32
							end
							l_nprep_startpos := l_spos
						else
							l_spos := prep_endpos.item
						end
				when 11 then -- if done | if done
						if l_epos /= -1 then
							if l_max_epos /= -1 then
								if l_epos > l_max_epos then
									l_epos := l_max_epos
								end
							end
						end
						if l_epos /= -1 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L___1
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else:
						if not (l_epos > l_spos) then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L___1:
						l_result := search_range (l_spos, l_epos, 9, 0, a_maxlines, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_new_epos)
						if l_result < 0 then
							l_return := True
						end
						if not l_return then
							if prep_endpos.item = -1 then
								l_nprep_endpos := l_new_epos.item
							elseif l_new_epos.item > prep_endpos.item then
								l_nprep_endpos := l_new_epos.item
							end
						end
				when 16 then -- if done | if done
					if not l_return then
						prep_startpos.item := l_nprep_startpos
						prep_endpos.item := l_nprep_endpos
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	match (a_pattern, a_buf___1: CE_POINTER [INTEGER_8]; a_pfound, a_pend: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		require
			not a_buf___1.is_void
		local
			l_buf___1: CE_POINTER [INTEGER_8]
			l_pp: CE_POINTER [INTEGER_8]
			l_lp: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			l_buf___1 := a_buf___1
			from
			until
				not (not (l_return) and then ((l_buf___1[0]).to_integer_32 /= 0))
			loop
				l_pp := a_pattern
				l_lp := l_buf___1
				from
				until
					not (not (l_break) and then ((l_pp[0]).to_integer_32 = (l_lp[0]).to_integer_32))
				loop
					l_break := False
					if (l_pp[0]).to_integer_32 = 0 then
						l_break := True
					elseif (l_lp[0]).to_integer_32 = 0 then
						l_break := True
					end
					if not (l_break) then
						l_pp := l_pp + 1
						l_lp := l_lp + 1
					end
				end
				l_break := False
				if (l_pp[0]).to_integer_32 = 0 then
					if not a_pfound.is_void then
						a_pfound.item := l_buf___1
					end
					if not a_pend.is_void then
						a_pend.item := l_lp
					end
					Result := 1
					l_return := True
				end
				if not l_return then
					l_buf___1 := l_buf___1 + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

end
