class
	P_SIGNAL_STATIC

inherit
	CE_UTILITIES
	S_SIGNAL_STATIC
	S_UNISTD_STATIC

feature {ANY} -- public routines

	u_interrupt (a_type: INTEGER_32)
		do
			signal (2, u_interrupt_address).do_nothing;
			(create {P_CH_STATIC}).sigs.item := ((create {P_CH_STATIC}).sigs.item).bit_or ((1))
			if ((create {P_OS_STATIC}).reading.item).to_boolean then
				(create {P_OS_STATIC}).intread
			end
		end

	stop (a_type: INTEGER_32)
		do
			signal (20, stop_address).do_nothing;
			(create {P_CH_STATIC}).sigs.item := ((create {P_CH_STATIC}).sigs.item).bit_or ((2))
			if ((create {P_OS_STATIC}).reading.item).to_boolean then
				(create {P_OS_STATIC}).intread
			end
		end

	winch (a_type: INTEGER_32)
		do
			signal (28, winch_address).do_nothing;
			(create {P_CH_STATIC}).sigs.item := ((create {P_CH_STATIC}).sigs.item).bit_or ((4))
			if ((create {P_OS_STATIC}).reading.item).to_boolean then
				(create {P_OS_STATIC}).intread
			end
		end

	init_signals (a_on: INTEGER_32)
		do
			if a_on.to_boolean then
				signal (2, u_interrupt_address).do_nothing
				signal (20, stop_address).do_nothing
				signal (28, winch_address).do_nothing
			else
				signal (2, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
				signal (20, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
				signal (28, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
				signal (3, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
			end
		end

	psignals
		local
			l_tsignals: INTEGER_32
			l_old_width: INTEGER_32
			l_old_height: INTEGER_32
			l_return: BOOLEAN
		do
			l_tsignals := (create {P_CH_STATIC}).sigs.item
			if l_tsignals = 0 then
				l_return := True
			end
			if not l_return then
				(create {P_CH_STATIC}).sigs.item := 0
				if ((l_tsignals).bit_and (2)).to_boolean then
					signal (22, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing;
					(create {P_SCREEN_STATIC}).clear_bot;
					(create {P_SCREEN_STATIC}).deinit;
					(create {P_OUTPUT_STATIC}).flush;
					(create {P_SCREEN_STATIC}).raw_mode (0)
					signal (22, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
					signal (20, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
					kill ((getpid), 20).do_nothing
					signal (20, stop_address).do_nothing;
					(create {P_SCREEN_STATIC}).raw_mode (1);
					(create {P_SCREEN_STATIC}).init;
					(create {P_COMMAND_STATIC}).screen_trashed.item := 1
					l_tsignals := (l_tsignals).bit_or ((4))
				end
				if ((l_tsignals).bit_and (4)).to_boolean then
					l_old_width := (create {P_SCREEN_STATIC}).sc_width.item
					l_old_height := (create {P_SCREEN_STATIC}).sc_height.item;
					(create {P_SCREEN_STATIC}).get_term
					if (create {P_SCREEN_STATIC}).sc_width.item /= l_old_width then
						(create {P_MAIN_STATIC}).wscroll.item := ((create {P_SCREEN_STATIC}).sc_height.item + 1) // 2;
						(create {P_COMMAND_STATIC}).screen_trashed.item := 1
					elseif (create {P_SCREEN_STATIC}).sc_height.item /= l_old_height then
						(create {P_MAIN_STATIC}).wscroll.item := ((create {P_SCREEN_STATIC}).sc_height.item + 1) // 2;
						(create {P_COMMAND_STATIC}).screen_trashed.item := 1
					end
				end
				if ((l_tsignals).bit_and (1)).to_boolean then
					(create {P_SCREEN_STATIC}).bell
					if ((create {P_LINENUM_STATIC}).lnloop.item).to_boolean then
						(create {P_LINENUM_STATIC}).lnloop.item := 0
						if (create {P_LINE_STATIC}).linenums.item.item = 2 then
							(create {P_COMMAND_STATIC}).screen_trashed.item := 1
						end
						(create {P_LINE_STATIC}).linenums.item.item := 0;
						(create {P_OUTPUT_STATIC}).error (ce_string ("Line numbers turned off"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
					end
				end
			end
		end

feature {ANY} -- routine addresses

	u_interrupt_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent u_interrupt)
		end

	stop_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent stop)
		end

	winch_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent winch)
		end

end
