class
	PD_LINENUM_INFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_LINENUM_INFO]} next.make
			create {CE_CLASS_POINTER [PD_LINENUM_INFO]} prev.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_LINENUM_INFO] assign set_next

	prev: CE_POINTER [PD_LINENUM_INFO] assign set_prev

	pos: INTEGER_32 assign set_pos

	gap: INTEGER_32 assign set_gap

	line: INTEGER_32 assign set_line

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_LINENUM_INFO])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_LINENUM_INFO])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_pos (a_pos: INTEGER_32)
		do
			pos := a_pos
			update_memory_field ("pos")
		end

	set_gap (a_gap: INTEGER_32)
		do
			gap := a_gap
			update_memory_field ("gap")
		end

	set_line (a_line: INTEGER_32)
		do
			line := a_line
			update_memory_field ("line")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			pos := a_other.pos
			gap := a_other.gap
			line := a_other.line
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				pos = a_other.pos and
				gap = a_other.gap and
				line = a_other.line
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("pos"),
					create {CE_STRUCTURE_FIELD}.make ("gap"),
					create {CE_STRUCTURE_FIELD}.make ("line")
				>>)
			init_structure_info
		end

end
