class
	PD_LOPTION

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_OPTNAME]} onames.make
			create {CE_INTEGER_32_POINTER} ovar.make
			create ofunc.make
			create {CE_POINTER_ARRAY [INTEGER_8]} odesc.make (<<3>>)
		end

feature {ANY} -- fields

	oletter: INTEGER_8 assign set_oletter

	onames: CE_POINTER [PD_OPTNAME] assign set_onames

	otype: INTEGER_32 assign set_otype

	odefault: INTEGER_32 assign set_odefault

	ovar: CE_POINTER [INTEGER_32] assign set_ovar

	ofunc: CE_ROUTINE assign set_ofunc

	odesc: CE_ARRAY [CE_POINTER [INTEGER_8]]

feature {ANY} -- field setters

	set_oletter (a_oletter: INTEGER_8)
		do
			oletter := a_oletter
			update_memory_field ("oletter")
		end

	set_onames (a_onames: CE_POINTER [PD_OPTNAME])
		do
			onames := a_onames
			update_memory_field ("onames")
		end

	set_otype (a_otype: INTEGER_32)
		do
			otype := a_otype
			update_memory_field ("otype")
		end

	set_odefault (a_odefault: INTEGER_32)
		do
			odefault := a_odefault
			update_memory_field ("odefault")
		end

	set_ovar (a_ovar: CE_POINTER [INTEGER_32])
		do
			ovar := a_ovar
			update_memory_field ("ovar")
		end

	set_ofunc (a_ofunc: CE_ROUTINE)
		do
			ofunc := a_ofunc
			update_memory_field ("ofunc")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			oletter := a_other.oletter
			onames := a_other.onames
			otype := a_other.otype
			odefault := a_other.odefault
			ovar := a_other.ovar
			ofunc := a_other.ofunc
			odesc := a_other.odesc.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				oletter = a_other.oletter and
				onames.is_equal (a_other.onames) and
				otype = a_other.otype and
				odefault = a_other.odefault and
				ovar.is_equal (a_other.ovar) and
				ofunc.is_equal (a_other.ofunc) and
				odesc.is_equal (a_other.odesc)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("oletter"),
					create {CE_STRUCTURE_FIELD}.make ("onames"),
					create {CE_STRUCTURE_FIELD}.make ("otype"),
					create {CE_STRUCTURE_FIELD}.make ("odefault"),
					create {CE_STRUCTURE_FIELD}.make ("ovar"),
					create {CE_STRUCTURE_FIELD}.make ("ofunc"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("odesc", <<3>>)
				>>)
			init_structure_info
		end

end
