class
	PD_MARK

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} m_ifile.make
			create m_scrpos.make
		end

feature {ANY} -- fields

	m_ifile: CE_POINTER [ANY] assign set_m_ifile

	m_scrpos: PD_SCRPOS assign set_m_scrpos

feature {ANY} -- field setters

	set_m_ifile (a_m_ifile: CE_POINTER [ANY])
		do
			m_ifile := a_m_ifile
			update_memory_field ("m_ifile")
		end

	set_m_scrpos (a_m_scrpos: PD_SCRPOS)
		do
			m_scrpos := a_m_scrpos
			update_memory_field ("m_scrpos")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			m_ifile := a_other.m_ifile
			m_scrpos := a_other.m_scrpos.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				m_ifile.is_equal (a_other.m_ifile) and
				m_scrpos.is_equal (a_other.m_scrpos)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("m_ifile"),
					create {CE_STRUCTURE_FIELD}.make ("m_scrpos")
				>>)
			init_structure_info
		end

end
