class
	PD_TEXTLIST

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} string.make
			create {CE_INTEGER_8_POINTER} endstring.make
			Precursor
		end

feature {ANY} -- fields

	string: CE_POINTER [INTEGER_8] assign set_string

	endstring: CE_POINTER [INTEGER_8] assign set_endstring

feature {ANY} -- field setters

	set_string (a_string: CE_POINTER [INTEGER_8])
		do
			string := a_string
			update_memory_field ("string")
		end

	set_endstring (a_endstring: CE_POINTER [INTEGER_8])
		do
			endstring := a_endstring
			update_memory_field ("endstring")
		end

feature {ANY} -- public routines

	init_textlist (a_str: CE_POINTER [INTEGER_8])
		require
			not a_str.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_meta_quoted: INTEGER_32
			l_delim_quoted: INTEGER_32
			l_esc: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_esclen: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___1: NATURAL_32
			l_tmp___2: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_meta_quoted := 0
					l_delim_quoted := 0
					l_tmp := (create {P_FILENAME_STATIC}).get_meta_escape
					update_class_fields -- Current might have been changed; synchronize
					l_esc := l_tmp
					l_tmp___0 := strlen (l_esc)
					update_class_fields -- Current might have been changed; synchronize
					l_esclen := l_tmp___0.to_integer_32
					Current.string := (create {P_MAIN_STATIC}).skipsp (a_str)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___1 := strlen (string)
					update_class_fields -- Current might have been changed; synchronize
					Current.endstring := string + l_tmp___1.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_s := a_str
				when 1 then -- loop condition:
					if not ((l_s.c_pointer.to_integer_32).to_natural_32 < (endstring.c_pointer.to_integer_32).to_natural_32) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						if not (l_meta_quoted.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_meta_quoted := 0
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if not (l_esclen > 0) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if ((l_s + l_esclen).c_pointer.to_integer_32).to_natural_32 < (endstring.c_pointer.to_integer_32).to_natural_32 then
							l_tmp___2 := strncmp (l_s, l_esc, l_esclen.to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___2 = 0 then
								l_meta_quoted := 1
								l_s := l_s + (l_esclen - 1)
							else
								l_pos := -1 + 8 -- goto _L___0
							end
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L___0:
						if l_delim_quoted.to_boolean then
							if (l_s[0]).to_integer_32 = ((create {P_CMDBUF_STATIC}).closequote.item).to_integer_32 then
								l_delim_quoted := 0
							end
						elseif (l_s[0]).to_integer_32 = ((create {P_CMDBUF_STATIC}).openquote.item).to_integer_32 then
							l_delim_quoted := 1
						elseif (l_s[0]).to_integer_32 = 32 then
							l_s[0] := (('%/0/').code).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
						end
				when 9 then -- if done
						l_s := l_s + 1
						l_pos := -1 + 1 -- back to loop condition
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	forw_textlist (a_prev: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_s: CE_POINTER [INTEGER_8]
			l_tmp: NATURAL_32
			l_return: BOOLEAN
		do
			if a_prev.is_void then
				l_s := string
			else
				l_tmp := strlen (a_prev)
				update_class_fields -- Current might have been changed; synchronize
				l_s := a_prev + l_tmp.to_integer_32
			end
			if (l_s.c_pointer.to_integer_32).to_natural_32 >= (endstring.c_pointer.to_integer_32).to_natural_32 then
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				from
				until
					(l_s[0]).to_integer_32 /= 0
				loop
					l_s := l_s + 1
				end
				if (l_s.c_pointer.to_integer_32).to_natural_32 >= (endstring.c_pointer.to_integer_32).to_natural_32 then
					Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				Result := l_s
			end
		end

	back_textlist (a_prev: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_s: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			if a_prev.is_void then
				l_s := endstring
			elseif (a_prev.c_pointer.to_integer_32).to_natural_32 <= (string.c_pointer.to_integer_32).to_natural_32 then
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
				l_return := True
			else
				l_s := a_prev - 1
			end
			if not l_return then
				from
				until
					(l_s[0]).to_integer_32 /= 0
				loop
					l_s := l_s - 1
				end
				if (l_s.c_pointer.to_integer_32).to_natural_32 <= (string.c_pointer.to_integer_32).to_natural_32 then
					Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_s[-1]).to_integer_32 /= 0 then
						if not ((l_s.c_pointer.to_integer_32).to_natural_32 > (string.c_pointer.to_integer_32).to_natural_32) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_s := l_s - 1
					end
				end
				l_break := False
				Result := l_s
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			string := a_other.string
			endstring := a_other.endstring
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				string.is_equal (a_other.string) and
				endstring.is_equal (a_other.endstring)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("string"),
					create {CE_STRUCTURE_FIELD}.make ("endstring")
				>>)
			init_structure_info
		end

end
