class
	S_STRING_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	strcpy (a___dest, a___src: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a___dest.is_void
			not a___src.is_void
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strcpy (a___dest.c_pointer, a___src.c_pointer))
		end

	c_strcpy (a___dest: POINTER; a___src: POINTER): POINTER
		external
			"C inline use <less.h>"
		alias
			"return (EIF_POINTER)strcpy($a___dest, $a___src);"
		end

	strcmp (a___s1, a___s2: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a___s1.is_void
			not a___s2.is_void
		do
			Result := c_strcmp (a___s1.c_pointer, a___s2.c_pointer)
		end

	c_strcmp (a___s1: POINTER; a___s2: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return strcmp($a___s1, $a___s2);"
		end

	strlen (a___s: CE_POINTER [INTEGER_8]): NATURAL_32
		require
			not a___s.is_void
		do
			Result := c_strlen (a___s.c_pointer)
		end

	c_strlen (a___s: POINTER): NATURAL_32
		external
			"C inline use <less.h>"
		alias
			"return strlen($a___s);"
		end

	strcat (a___dest, a___src: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a___dest.is_void
			not a___src.is_void
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strcat (a___dest.c_pointer, a___src.c_pointer))
		end

	c_strcat (a___dest: POINTER; a___src: POINTER): POINTER
		external
			"C inline use <less.h>"
		alias
			"return (EIF_POINTER)strcat($a___dest, $a___src);"
		end

	strstr (a___haystack, a___needle: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a___haystack.is_void
			not a___needle.is_void
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strstr (a___haystack.c_pointer, a___needle.c_pointer))
		end

	c_strstr (a___haystack: POINTER; a___needle: POINTER): POINTER
		external
			"C inline use <less.h>"
		alias
			"return (EIF_POINTER)strstr($a___haystack, $a___needle);"
		end

	strncpy (a___dest, a___src: CE_POINTER [INTEGER_8]; a___n: NATURAL_32): CE_POINTER [INTEGER_8]
		require
			not a___dest.is_void
			not a___src.is_void
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strncpy (a___dest.c_pointer, a___src.c_pointer, a___n))
		end

	c_strncpy (a___dest: POINTER; a___src: POINTER; a___n: NATURAL_32): POINTER
		external
			"C inline use <less.h>"
		alias
			"return (EIF_POINTER)strncpy($a___dest, $a___src, $a___n);"
		end

	strncmp (a___s1, a___s2: CE_POINTER [INTEGER_8]; a___n: NATURAL_32): INTEGER_32
		require
			not a___s1.is_void
			not a___s2.is_void
		do
			Result := c_strncmp (a___s1.c_pointer, a___s2.c_pointer, a___n)
		end

	c_strncmp (a___s1: POINTER; a___s2: POINTER; a___n: NATURAL_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return strncmp($a___s1, $a___s2, $a___n);"
		end

	strchr (a___s: CE_POINTER [INTEGER_8]; a___c: INTEGER_32): CE_POINTER [INTEGER_8]
		require
			not a___s.is_void
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strchr (a___s.c_pointer, a___c))
		end

	c_strchr (a___s: POINTER; a___c: INTEGER_32): POINTER
		external
			"C inline use <less.h>"
		alias
			"return (EIF_POINTER)strchr($a___s, $a___c);"
		end

	memcpy (a___dest, a___src: CE_POINTER [ANY]; a___n: NATURAL_32): CE_POINTER [ANY]
		require
			a___n > 0 implies (not a___dest.is_void and not a___src.is_void)
		do
			create {CE_VOID_POINTER} Result.make_shared (c_memcpy (a___dest.c_pointer, a___src.c_pointer, a___n))
		end

	c_memcpy (a___dest: POINTER; a___src: POINTER; a___n: NATURAL_32): POINTER
		external
			"C inline use <less.h>"
		alias
			"return (EIF_POINTER)memcpy($a___dest, $a___src, $a___n);"
		end

	strerror (a___errnum: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strerror (a___errnum))
		end

	c_strerror (a___errnum: INTEGER_32): POINTER
		external
			"C inline use <less.h>"
		alias
			"return (EIF_POINTER)strerror($a___errnum);"
		end

end
