#ifndef WGET_H
#define WGET_H

#include <ffi.h>
#include <time.h>
#include <sys/select.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <libio.h>
#include <sys/stat.h>
#include <netdb.h>
#include <pwd.h>
#include <getopt.h>
#include <bits/sigset.h>
#include <sys/time.h>
#include <utime.h>
#include <locale.h>
#include <sys/ioctl.h>
#include <termios.h>
#include <wchar.h>
#include <libintl.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <assert.h>
#include <bits/errno.h>
#include <fnmatch.h>
#include <ctype.h>
#include <arpa/inet.h>
#include <signal.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <langinfo.h>
#include <stdio_ext.h>
#include <wctype.h>

#undef uri_encoding
#undef content_encoding
#undef orig_url
#undef utf8_encode
#undef tv_sec
#undef tv_usec
#undef fds_bits
#undef verbose
#undef quiet
#undef ntry
#undef retry_connrefused
#undef background
#undef ignore_length
#undef recursive
#undef spanhost
#undef max_redirect
#undef relative_only
#undef no_parent
#undef reclevel
#undef dirstruct
#undef no_dirstruct
#undef cut_dirs
#undef add_hostdir
#undef protocol_directories
#undef noclobber
#undef dir_prefix
#undef lfilename
#undef input_filename
#undef force_html
#undef default_page
#undef spider
#undef accepts
#undef rejects
#undef excludes
#undef includes
#undef ignore_case
#undef domains
#undef exclude_domains
#undef dns_cache
#undef follow_tags
#undef ignore_tags
#undef follow_ftp
#undef retr_symlinks
#undef output_document
#undef user
#undef passwd
#undef ask_passwd
#undef always_rest
#undef ftp_user
#undef ftp_passwd
#undef netrc
#undef ftp_glob
#undef ftp_pasv
#undef http_user
#undef http_passwd
#undef user_headers
#undef http_keep_alive
#undef use_proxy
#undef allow_cache
#undef http_proxy
#undef ftp_proxy
#undef https_proxy
#undef no_proxy
#undef base_href
#undef progress_type
#undef proxy_user
#undef proxy_passwd
#undef read_timeout
#undef dns_timeout
#undef connect_timeout
#undef random_wait
#undef wait
#undef waitretry
#undef use_robots
#undef limit_rate
#undef quota
#undef server_response
#undef save_headers
#undef debug2
#undef timestamping
#undef backup_converted
#undef backups
#undef useragent
#undef referer
#undef convert_links
#undef remove_listing
#undef htmlify
#undef dot_style
#undef dot_bytes
#undef dots_in_line
#undef dot_spacing
#undef delete_after
#undef adjust_extension
#undef page_requisites
#undef bind_address
#undef cookies
#undef cookies_input
#undef cookies_output
#undef keep_session_cookies
#undef post_data
#undef post_file_name
#undef restrict_files_os
#undef restrict_files_ctrl
#undef restrict_files_nonascii
#undef restrict_files_case
#undef strict_comments
#undef preserve_perm
#undef ipv4_only
#undef ipv6_only
#undef prefer_family
#undef content_disposition
#undef auth_without_challenge
#undef enable_iri
#undef encoding_remote
#undef locale
#undef sa_family
#undef sa_data
#undef ss_family
#undef ss_align
#undef ss_padding
#undef s_addr
#undef u6_addr8
#undef u6_addr16
#undef u6_addr32
#undef in6_u
#undef sin_family
#undef sin_port
#undef sin_addr
#undef sin_zero
#undef sin6_family
#undef sin6_port
#undef sin6_flowinfo
#undef sin6_addr
#undef sin6_scope_id
#undef d4
#undef d6
#undef family
#undef data
#undef ipv6_scope
#undef reader
#undef writer
#undef poller
#undef peeker
#undef errstr
#undef closer
#undef fd
#undef addr
#undef addrlen
#undef result2
#undef imp
#undef ctx
#undef next
#undef sbuf
#undef pos
#undef flags
#undef IO_read_ptr
#undef IO_read_end
#undef IO_read_base
#undef IO_write_base
#undef IO_write_ptr
#undef IO_write_end
#undef IO_buf_base
#undef IO_buf_end
#undef IO_save_base
#undef IO_backup_base
#undef IO_save_end
#undef markers
#undef chain
#undef fileno
#undef flags2
#undef old_offset
#undef cur_column
#undef vtable_offset
#undef shortbuf
#undef lock
#undef offset
#undef pad1
#undef pad2
#undef pad3
#undef pad4
#undef pad5
#undef mode
#undef unused2
#undef url
#undef local_name
#undef ignore_when_downloading
#undef link_relative_p
#undef link_complete_p
#undef link_base_p
#undef link_inline_p
#undef link_css_p
#undef link_expect_html
#undef link_expect_css
#undef link_refresh_p
#undef refresh_timeout
#undef convert2
#undef size
#undef scheme
#undef host
#undef port
#undef path
#undef params
#undef query
#undef fragment
#undef dir
#undef file
#undef content
#undef length
#undef mmap_p
#undef key
#undef value
#undef end2
#undef b
#undef e
#undef chains
#undef cookie_count
#undef domain
#undef discard_requested
#undef secure
#undef domain_exact
#undef permanent
#undef expiry_time
#undef attr
#undef cookie
#undef domain_goodness
#undef path_goodness
#undef tv_nsec
#undef st_dev
#undef st_ino
#undef st_mode
#undef st_nlink
#undef st_uid
#undef st_gid
#undef st_rdev
#undef st_size
#undef st_blksize
#undef st_blocks
#undef st_atim
#undef st_mtim
#undef st_ctim
#undef unused4
#undef unused5
#undef type
#undef name
#undef tstamp
#undef perms
#undef linkto
#undef prev
#undef st
#undef cmd
#undef csock
#undef dltime
#undef rs
#undef id
#undef target
#undef proxy
#undef yy_input_file
#undef yy_ch_buf
#undef yy_buf_pos
#undef yy_buf_size
#undef yy_n_chars
#undef yy_is_our_buffer
#undef yy_is_interactive
#undef yy_at_bol
#undef yy_bs_lineno
#undef yy_bs_column
#undef yy_fill_buffer
#undef yy_buffer_status
#undef text
#undef base
#undef parent_base
#undef document_file
#undef nofollow
#undef head
#undef tail
#undef tm_sec
#undef tm_min
#undef tm_hour
#undef tm_mday
#undef tm_mon
#undef tm_year
#undef tm_wday
#undef tm_yday
#undef tm_isdst
#undef tm_gmtoff
#undef tm_zone
#undef hash_function
#undef test_function
#undef cells
#undef count
#undef resize_threshold
#undef prime_offset
#undef ai_flags
#undef ai_family
#undef ai_socktype
#undef ai_protocol
#undef ai_addrlen
#undef ai_addr
#undef ai_canonname
#undef ai_next
#undef addresses
#undef faulty
#undef connected
#undef refcount
#undef node
#undef service
#undef hints
#undef res
#undef exit_code
#undef value_raw_beginning
#undef value_raw_size
#undef name_pool_index
#undef value_pool_index
#undef end_tag_p
#undef nattrs
#undef attrs
#undef start_position
#undef end_position
#undef contents_begin
#undef contents_end
#undef contents
#undef resized
#undef orig_contents
#undef orig_size
#undef tagname_begin
#undef tagname_end
#undef tagid
#undef handler
#undef attr_name
#undef release_policy
#undef method
#undef arg
#undef headers
#undef hcount
#undef hcapacity
#undef socket
#undef ssl
#undef authorized
#undef len
#undef contlen
#undef restval
#undef rderrmsg
#undef newloc
#undef remote_time
#undef error
#undef statcode
#undef message
#undef rd_size
#undef local_file
#undef existence_checked
#undef timestamp_checked
#undef orig_file_name
#undef orig_file_size
#undef orig_file_tstamp
#undef variable
#undef pw_name
#undef pw_passwd
#undef pw_uid
#undef pw_gid
#undef pw_gecos
#undef pw_dir
#undef pw_shell
#undef place
#undef action
#undef code
#undef static_line
#undef malloced_line
#undef bigmsg
#undef expected_size
#undef allocated
#undef buffer
#undef has_arg
#undef flag
#undef val
#undef long_name
#undef short_name
#undef argtype
#undef acc
#undef interactive
#undef create2
#undef update
#undef finish
#undef set_params
#undef initial_length
#undef total_length
#undef accumulated
#undef rows
#undef dots
#undef last_timer_value
#undef times
#undef bytes
#undef total_time
#undef total_bytes
#undef last_screen_update
#undef width
#undef tick
#undef hist
#undef recent_start
#undef recent_bytes
#undef stalled
#undef last_eta_time
#undef last_eta_value
#undef sysconf_name
#undef start
#undef elapsed_last
#undef elapsed_pre_start
#undef depth
#undef html_allowed
#undef iri
#undef css_allowed
#undef maxcount
#undef allowedp
#undef user_agent_exact_p
#undef paths
#undef chunk_bytes
#undef chunk_start
#undef sleep_adjust
#undef leading_string
#undef default_port
#undef it_interval
#undef it_value
#undef actime
#undef modtime
#undef decimal_point
#undef thousands_sep
#undef grouping
#undef int_curr_symbol
#undef currency_symbol
#undef mon_decimal_point
#undef mon_thousands_sep
#undef mon_grouping
#undef positive_sign
#undef negative_sign
#undef int_frac_digits
#undef frac_digits
#undef p_cs_precedes
#undef p_sep_by_space
#undef n_cs_precedes
#undef n_sep_by_space
#undef p_sign_posn
#undef n_sign_posn
#undef int_p_cs_precedes
#undef int_p_sep_by_space
#undef int_n_cs_precedes
#undef int_n_sep_by_space
#undef int_p_sign_posn
#undef int_n_sign_posn
#undef ws_row
#undef ws_col
#undef ws_xpixel
#undef ws_ypixel
#undef A
#undef B
#undef C
#undef D
#undef total
#undef buflen
#undef c2_iflag
#undef c2_oflag
#undef c2_cflag
#undef c2_lflag
#undef c2_line
#undef c2_cc
#undef c2_ispeed
#undef c2_ospeed
#undef wch
#undef wchb
#undef style
#undef quote_these_too
#undef left_quote
#undef right_quote
#undef c
#undef x
#undef builtin_expect
#undef select2
#undef __nfds
#undef __readfds
#undef __writefds
#undef __exceptfds
#undef __timeout
#undef gettext
#undef __msgid
#undef memset
#undef __s
#undef __c
#undef __n
#undef strcmp
#undef __s1
#undef __s2
#undef strlen
#undef strerror
#undef __errnum
#undef snprintf
#undef __maxlen
#undef __format
#undef free
#undef __ptr
#undef abort
#undef close
#undef __fd
#undef read
#undef __buf
#undef __nbytes
#undef write
#undef assert_fail
#undef __assertion
#undef __file
#undef __line
#undef __function
#undef __domain
#undef __type
#undef __protocol
#undef bind
#undef __addr
#undef __len
#undef getsockname
#undef connect
#undef getpeername
#undef recv
#undef __flags
#undef setsockopt
#undef __level
#undef __optname
#undef __optval
#undef __optlen
#undef listen
#undef accept
#undef __addr_len
#undef ntohs
#undef __netshort
#undef htons
#undef __hostshort
#undef errno_location
#undef memcpy
#undef __dest
#undef __src
#undef strcpy
#undef strpbrk
#undef __accept
#undef IO_putc
#undef __fp
#undef rename2
#undef __old
#undef __new
#undef fclose
#undef __stream
#undef fopen
#undef __filename
#undef __modes
#undef sprintf
#undef fputs
#undef fwrite
#undef __size
#undef unlink
#undef __name
#undef memcmp
#undef memchr
#undef strncmp
#undef strchr
#undef strrchr
#undef strcasecmp
#undef strncasecmp
#undef fprintf
#undef sscanf
#undef fputc
#undef ferror
#undef qsort
#undef __base
#undef __nmemb
#undef __compar
#undef time
#undef __timer
#undef stat
#undef lstat
#undef chmod
#undef __mode
#undef fnmatch
#undef __pattern
#undef strstr
#undef __haystack
#undef __needle
#undef strtoll
#undef __nptr
#undef __endptr
#undef symlink
#undef __from
#undef __to
#undef readlink
#undef __path
#undef IO_getc
#undef fread
#undef clearerr
#undef malloc
#undef realloc
#undef exit
#undef __status
#undef strncpy
#undef ctype_b_loc
#undef strtok
#undef __delim
#undef strcat
#undef strncat
#undef fflush
#undef fgetc
#undef atoi
#undef getenv
#undef mktime
#undef __tp
#undef strptime
#undef __fmt
#undef localtime
#undef inet_ntop
#undef __af
#undef __cp
#undef getaddrinfo
#undef __service
#undef __req
#undef __pai
#undef freeaddrinfo
#undef __ai
#undef gai_strerror
#undef __ecode
#undef strcspn
#undef __reject
#undef strspn
#undef memmove
#undef memrchr
#undef feof
#undef timegm
#undef setlocale
#undef __category
#undef __locale
#undef getuid
#undef getpwuid
#undef __uid
#undef vfprintf
#undef __arg
#undef vsnprintf
#undef isatty
#undef fstat
#undef textdomain
#undef __domainname
#undef bindtextdomain
#undef __dirname
#undef printf
#undef perror
#undef signal
#undef __sig
#undef __handler
#undef getopt_long
#undef ___argc
#undef ___argv
#undef __shortopts
#undef __longopts
#undef __longind
#undef mbtowc
#undef __pwc
#undef wcwidth
#undef sysconf
#undef clock_getres
#undef __clock_id
#undef __res
#undef clock_gettime
#undef ngettext
#undef __msgid1
#undef __msgid2
#undef mkdir
#undef freopen
#undef fdopen
#undef vasprintf
#undef __f
#undef fgets
#undef fseeko
#undef __off
#undef __whence
#undef ftello
#undef drand48
#undef lrand48
#undef srand48
#undef __seedval
#undef strftime
#undef __maxsize
#undef nanosleep
#undef __requested_time
#undef __remaining
#undef setitimer
#undef __which
#undef getpid
#undef setsid
#undef fork
#undef mmap
#undef __prot
#undef __offset
#undef munmap
#undef utime
#undef __file_times
#undef open
#undef __oflag
#undef localeconv
#undef ioctl
#undef __request
#undef fscanf
#undef getc_unlocked
#undef ungetc
#undef nl_langinfo
#undef __item
#undef fflush_unlocked
#undef putc_unlocked
#undef getline
#undef __lineptr
#undef fputs_unlocked
#undef flockfile
#undef funlockfile
#undef fsetlocking
#undef tcgetattr
#undef __termios_p
#undef tcsetattr
#undef __optional_actions
#undef ctype_get_mb_cur_max
#undef mbsinit
#undef __ps
#undef mbrtowc
#undef __p
#undef iswprint
#undef __wc
#undef calloc

enum PC_RESTRICT_FILES_OS {
	restrict_unix = 0,
	restrict_windows = 1
};
enum PC_RESTRICT_FILES_CASE {
	restrict_no_case_restriction = 0,
	restrict_lowercase = 1,
	restrict_uppercase = 2
};
enum PC_PREFER_FAMILY {
	prefer_ipv4 = 0,
	prefer_ipv6 = 1,
	prefer_none = 2
};
enum PC_LOG_OPTIONS {
	LOG_VERBOSE = 0,
	LOG_NOTQUIET = 1,
	LOG_NONVERBOSE = 2,
	LOG_ALWAYS = 3
};
enum PC_CONVERT_OPTIONS {
	CO_NOCONVERT = 0,
	CO_CONVERT_TO_RELATIVE = 1,
	CO_CONVERT_TO_COMPLETE = 2,
	CO_NULLIFY_BASE = 3
};
enum PC_DOWNLOADED_FILE_T {
	FILE_NOT_ALREADY_DOWNLOADED = 0,
	FILE_DOWNLOADED_NORMALLY = 1,
	FILE_DOWNLOADED_AND_HTML_EXTENSION_ADDED = 2,
	CHECK_FOR_FILE = 3
};
enum PC_URL_SCHEME {
	SCHEME_HTTP = 0,
	SCHEME_FTP = 1,
	SCHEME_INVALID = 2
};
enum PC_QUOTING_STYLE {
	literal_quoting_style = 0,
	shell_quoting_style = 1,
	shell_always_quoting_style = 2,
	c_quoting_style = 3,
	c_maybe_quoting_style = 4,
	escape_quoting_style = 5,
	locale_quoting_style = 6,
	clocale_quoting_style = 7,
	custom_quoting_style = 8
};
enum PC_UERR_T {
	NOCONERROR = 0,
	HOSTERR = 1,
	CONSOCKERR = 2,
	CONERROR = 3,
	CONSSLERR = 4,
	CONIMPOSSIBLE = 5,
	NEWLOCATION = 6,
	NOTENOUGHMEM = 7,
	CONPORTERR = 8,
	CONCLOSED = 9,
	FTPOK = 10,
	FTPLOGINC = 11,
	FTPLOGREFUSED = 12,
	FTPPORTERR = 13,
	FTPSYSERR = 14,
	FTPNSFOD = 15,
	FTPRETROK = 16,
	FTPUNKNOWNTYPE = 17,
	FTPRERR = 18,
	FTPREXC = 19,
	FTPSRVERR = 20,
	FTPRETRINT = 21,
	FTPRESTFAIL = 22,
	URLERROR = 23,
	FOPENERR = 24,
	FOPEN_EXCL_ERR = 25,
	FWRITEERR = 26,
	HOK = 27,
	HLEXC = 28,
	HEOF = 29,
	HERR = 30,
	RETROK = 31,
	RECLEVELEXC = 32,
	FTPACCDENIED = 33,
	WRONGCODE = 34,
	FTPINVPASV = 35,
	FTPNOPASV = 36,
	CONTNOTSUPPORTED = 37,
	RETRUNNEEDED = 38,
	RETRFINISHED = 39,
	READERR = 40,
	TRYLIMEXC = 41,
	URLBADPATTERN = 42,
	FILEBADFILE = 43,
	RANGEERR = 44,
	RETRBADPATTERN = 45,
	RETNOTSUP = 46,
	ROBOTSOK = 47,
	NOROBOTS = 48,
	PROXERR = 49,
	AUTHFAILED = 50,
	QUOTEXC = 51,
	WRITEFAILED = 52,
	SSLINITFAILED = 53,
	VERIFCERTERR = 54
};
enum PC_URL_AUTH_MODE {
	URL_AUTH_SHOW = 0,
	URL_AUTH_HIDE_PASSWD = 1,
	URL_AUTH_HIDE = 2
};
enum PC_STYPE {
	ST_UNIX = 0,
	ST_VMS = 1,
	ST_WINNT = 2,
	ST_MACOS = 3,
	ST_OS400 = 4,
	ST_OTHER = 5
};
enum PC_FTYPE {
	FT_PLAINFILE = 0,
	FT_DIRECTORY = 1,
	FT_SYMLINK = 2,
	FT_UNKNOWN = 3
};
enum PC_CSS_TOKENS {
	CSSEOF = 0,
	S = 1,
	CDO = 2,
	CDC = 3,
	INCLUDES = 4,
	DASHMATCH = 5,
	LBRACE = 6,
	PLUS = 7,
	GREATER = 8,
	COMMA = 9,
	STRING = 10,
	INVALID = 11,
	IDENT = 12,
	HASH = 13,
	IMPORT_SYM = 14,
	PAGE_SYM = 15,
	MEDIA_SYM = 16,
	CHARSET_SYM = 17,
	IMPORTANT_SYM = 18,
	EMS = 19,
	EXS = 20,
	LENGTH = 21,
	ANGLE = 22,
	TIME = 23,
	FREQ = 24,
	DIMENSION = 25,
	PERCENTAGE = 26,
	NUMBER = 27,
	URI = 28,
	FUNCTION = 29
};
enum PC_STATE {
	AC_S_DONE = 0,
	AC_S_BACKOUT = 1,
	AC_S_BANG = 2,
	AC_S_DEFAULT = 3,
	AC_S_DCLNAME = 4,
	AC_S_DASH1 = 5,
	AC_S_DASH2 = 6,
	AC_S_COMMENT = 7,
	AC_S_DASH3 = 8,
	AC_S_DASH4 = 9,
	AC_S_QUOTE1 = 10,
	AC_S_IN_QUOTE = 11,
	AC_S_QUOTE2 = 12
};
enum PC_RP {
	rel_none = 0,
	rel_name = 1,
	rel_value = 2,
	rel_both = 3
};
enum PC_PARSE_LINE {
	line_ok = 0,
	line_empty = 1,
	line_syntax_error = 2,
	line_unknown_command = 3
};
enum PC_REDIRECT_REQUEST {
	RR_NONE = 0,
	RR_REQUESTED = 1,
	RR_DONE = 2
};
enum PC_TYPE {
	OPT_VALUE = 0,
	OPT_BOOLEAN = 1,
	OPT_FUNCALL = 2,
	OPT__APPEND_OUTPUT = 3,
	OPT__CLOBBER = 4,
	OPT__DONT_REMOVE_LISTING = 5,
	OPT__EXECUTE = 6,
	OPT__NO = 7,
	OPT__PARENT = 8
};
enum PC_LAST_TOKEN {
	tok_nothing = 0,
	tok_account = 1,
	tok_login = 2,
	tok_macdef = 3,
	tok_machine = 4,
	tok_password = 5
};

struct iri;
struct __anonstruct_fd_set_3;
struct options;
union __anonunion___in6_u_44;
union __anonunion_data_49;
struct __anonstruct_ip_address_48;
struct transport_implementation;
struct cwt_context;
struct transport_info;
struct urlpos;
struct url;
struct file_memory;
struct __anonstruct_hash_table_iterator_38;
struct __anonstruct_param_token_35;
struct cookie_jar;
struct cookie;
struct weighed_cookie;
struct fileinfo;
struct __anonstruct_ccon_57;
struct yy_buffer_state;
struct map_context;
struct cell;
struct hash_table;
struct address_list;
struct gaiwt_context;
struct attr_pair;
struct taginfo;
struct pool;
struct tagstack_item;
struct known_tag;
struct __anonstruct_tag_url_attributes_37;
struct request_header;
struct request;
struct response;
struct __anonstruct_pconn_60;
struct http_stat;
struct __anonstruct_options_61;
struct __anonstruct_commands_54;
struct decode_item;
struct log_ln;
struct logvprintf_state;
struct ringel;
struct cmdline_option;
struct _acc_t;
struct progress_implementation;
struct dot_progress;
struct bar_progress_hist;
struct bar_progress;
struct __anonstruct_clocks_37;
struct ptimer;
struct queue_element;
struct url_queue;
struct path_info;
struct robot_specs;
struct __anonstruct_limit_data_59;
struct scheme_data;
struct growable;
struct __anonstruct___sigset_t_2;
struct md5_ctx;
struct gen_md5_context;
union __anonunion___value_25;
struct __anonstruct___mbstate_t_24;
struct quoting_options;
struct slotvec;
struct __anonstruct_28;

typedef struct __anonstruct_ip_address_48 ip_address;
typedef struct __anonstruct_hash_table_iterator_38 hash_table_iterator;
typedef struct __anonstruct_param_token_35 param_token;
typedef struct __anonstruct_ccon_57 ccon;

struct iri {
	char * uri_encoding;
	char * content_encoding;
	char * orig_url;
	_Bool utf8_encode;
};
struct __anonstruct_fd_set_3 {
	long fds_bits[1024 / (8 * (int)sizeof(long))];
};
struct options {
	int verbose;
	_Bool quiet;
	int ntry;
	_Bool retry_connrefused;
	_Bool background;
	_Bool ignore_length;
	_Bool recursive;
	_Bool spanhost;
	int max_redirect;
	_Bool relative_only;
	_Bool no_parent;
	int reclevel;
	_Bool dirstruct;
	_Bool no_dirstruct;
	int cut_dirs;
	_Bool add_hostdir;
	_Bool protocol_directories;
	_Bool noclobber;
	char * dir_prefix;
	char * lfilename;
	char * input_filename;
	_Bool force_html;
	char * default_page;
	_Bool spider;
	char * * accepts;
	char * * rejects;
	char * * excludes;
	char * * includes;
	_Bool ignore_case;
	char * * domains;
	char * * exclude_domains;
	_Bool dns_cache;
	char * * follow_tags;
	char * * ignore_tags;
	_Bool follow_ftp;
	_Bool retr_symlinks;
	char * output_document;
	char * user;
	char * passwd;
	_Bool ask_passwd;
	_Bool always_rest;
	char * ftp_user;
	char * ftp_passwd;
	_Bool netrc;
	_Bool ftp_glob;
	_Bool ftp_pasv;
	char * http_user;
	char * http_passwd;
	char * * user_headers;
	_Bool http_keep_alive;
	_Bool use_proxy;
	_Bool allow_cache;
	char * http_proxy;
	char * ftp_proxy;
	char * https_proxy;
	char * * no_proxy;
	char * base_href;
	char * progress_type;
	char * proxy_user;
	char * proxy_passwd;
	double read_timeout;
	double dns_timeout;
	double connect_timeout;
	_Bool random_wait;
	double wait;
	double waitretry;
	_Bool use_robots;
	long long limit_rate;
	long long quota;
	_Bool server_response;
	_Bool save_headers;
	_Bool debug;
	_Bool timestamping;
	_Bool backup_converted;
	_Bool backups;
	char * useragent;
	char * referer;
	_Bool convert_links;
	_Bool remove_listing;
	_Bool htmlify;
	char * dot_style;
	long long dot_bytes;
	int dots_in_line;
	int dot_spacing;
	_Bool delete_after;
	_Bool adjust_extension;
	_Bool page_requisites;
	char * bind_address;
	_Bool cookies;
	char * cookies_input;
	char * cookies_output;
	_Bool keep_session_cookies;
	char * post_data;
	char * post_file_name;
	unsigned int restrict_files_os;
	_Bool restrict_files_ctrl;
	_Bool restrict_files_nonascii;
	unsigned int restrict_files_case;
	_Bool strict_comments;
	_Bool preserve_perm;
	_Bool ipv4_only;
	_Bool ipv6_only;
	unsigned int prefer_family;
	_Bool content_disposition;
	_Bool auth_without_challenge;
	_Bool enable_iri;
	char * encoding_remote;
	char * locale;
};
union __anonunion___in6_u_44 {
	unsigned char __u6_addr8[16];
	unsigned short __u6_addr16[8];
	unsigned int __u6_addr32[4];
};
union __anonunion_data_49 {
	struct in_addr d4;
	struct in6_addr d6;
};
struct __anonstruct_ip_address_48 {
	int family;
	union __anonunion_data_49 data;
	int ipv6_scope;
};
struct transport_implementation {
	int( * reader)(int, char *, int, void *);
	int( * writer)(int, char *, int, void *);
	int( * poller)(int, double, int, void *);
	int( * peeker)(int, char *, int, void *);
	char const *( * errstr)(int, void *);
	void( * closer)(int, void *);
};
struct cwt_context {
	int fd;
	struct sockaddr const * addr;
	unsigned int addrlen;
	int result;
};
struct transport_info {
	struct transport_implementation * imp;
	void * ctx;
};
struct urlpos {
	struct url * url;
	char * local_name;
	unsigned int ignore_when_downloading : 1;
	unsigned int link_relative_p : 1;
	unsigned int link_complete_p : 1;
	unsigned int link_base_p : 1;
	unsigned int link_inline_p : 1;
	unsigned int link_css_p : 1;
	unsigned int link_expect_html : 1;
	unsigned int link_expect_css : 1;
	unsigned int link_refresh_p : 1;
	int refresh_timeout;
	unsigned int convert;
	int pos;
	int size;
	struct urlpos * next;
};
struct url {
	char * url;
	unsigned int scheme;
	char * host;
	int port;
	char * path;
	char * params;
	char * query;
	char * fragment;
	char * dir;
	char * file;
	char * user;
	char * passwd;
};
struct file_memory {
	char * content;
	long length;
	int mmap_p;
};
struct __anonstruct_hash_table_iterator_38 {
	void * key;
	void * value;
	void * pos;
	void * end;
};
struct __anonstruct_param_token_35 {
	char const * b;
	char const * e;
};
struct cookie_jar {
	struct hash_table * chains;
	int cookie_count;
};
struct cookie {
	char * domain;
	int port;
	char * path;
	unsigned int discard_requested : 1;
	unsigned int secure : 1;
	unsigned int domain_exact : 1;
	unsigned int permanent : 1;
	long expiry_time;
	char * attr;
	char * value;
	struct cookie * next;
};
struct weighed_cookie {
	struct cookie * cookie;
	int domain_goodness;
	int path_goodness;
};
struct fileinfo {
	unsigned int type;
	char * name;
	long long size;
	long tstamp;
	int perms;
	char * linkto;
	struct fileinfo * prev;
	struct fileinfo * next;
};
struct __anonstruct_ccon_57 {
	int st;
	int cmd;
	int csock;
	double dltime;
	unsigned int rs;
	char * id;
	char * target;
	struct url * proxy;
};
struct yy_buffer_state {
	struct _IO_FILE * yy_input_file;
	char * yy_ch_buf;
	char * yy_buf_pos;
	unsigned int yy_buf_size;
	int yy_n_chars;
	int yy_is_our_buffer;
	int yy_is_interactive;
	int yy_at_bol;
	int yy_bs_lineno;
	int yy_bs_column;
	int yy_fill_buffer;
	int yy_buffer_status;
};
struct map_context {
	char * text;
	char * base;
	char const * parent_base;
	char const * document_file;
	_Bool nofollow;
	struct urlpos * head;
	struct urlpos * tail;
};
struct cell {
	void * key;
	void * value;
};
struct hash_table {
	unsigned long( * hash_function)(void const *);
	int( * test_function)(void const *, void const *);
	struct cell * cells;
	int size;
	int count;
	int resize_threshold;
	int prime_offset;
};
struct address_list {
	int count;
	ip_address * addresses;
	int faulty;
	_Bool connected;
	int refcount;
};
struct gaiwt_context {
	char const * node;
	char const * service;
	struct addrinfo const * hints;
	struct addrinfo * * res;
	int exit_code;
};
struct attr_pair {
	char * name;
	char * value;
	char const * value_raw_beginning;
	int value_raw_size;
	int name_pool_index;
	int value_pool_index;
};
struct taginfo {
	char * name;
	int end_tag_p;
	int nattrs;
	struct attr_pair * attrs;
	char const * start_position;
	char const * end_position;
	char const * contents_begin;
	char const * contents_end;
};
struct pool {
	char * contents;
	int size;
	int tail;
	_Bool resized;
	char * orig_contents;
	int orig_size;
};
struct tagstack_item {
	char const * tagname_begin;
	char const * tagname_end;
	char const * contents_begin;
	struct tagstack_item * prev;
	struct tagstack_item * next;
};
struct known_tag {
	int tagid;
	char const * name;
	void( * handler)(int, struct taginfo *, struct map_context *);
};
struct __anonstruct_tag_url_attributes_37 {
	int tagid;
	char const * attr_name;
	int flags;
};
struct request_header {
	char * name;
	char * value;
	unsigned int release_policy;
};
struct request {
	char const * method;
	char * arg;
	struct request_header * headers;
	int hcount;
	int hcapacity;
};
struct response {
	char const * data;
	char const * * headers;
};
struct __anonstruct_pconn_60 {
	int socket;
	char * host;
	int port;
	_Bool ssl;
	_Bool authorized;
};
struct http_stat {
	long long len;
	long long contlen;
	long long restval;
	int res;
	char * rderrmsg;
	char * newloc;
	char * remote_time;
	char * error;
	int statcode;
	char * message;
	long long rd_size;
	double dltime;
	char const * referer;
	char * local_file;
	_Bool existence_checked;
	_Bool timestamp_checked;
	char * orig_file_name;
	long long orig_file_size;
	long orig_file_tstamp;
};
struct __anonstruct_options_61 {
	char const * name;
	char * * variable;
};
struct __anonstruct_commands_54 {
	char const * name;
	void * place;
	_Bool( * action)(char const *, char const *, void *);
};
struct decode_item {
	char const * name;
	int code;
};
struct log_ln {
	char static_line[129];
	char * malloced_line;
	char * content;
};
struct logvprintf_state {
	char * bigmsg;
	int expected_size;
	int allocated;
};
struct ringel {
	char * buffer;
	int size;
};
struct cmdline_option {
	char const * long_name;
	char short_name;
	unsigned int type;
	void const * data;
	int argtype;
};
struct _acc_t {
	char * host;
	char * acc;
	char * passwd;
	struct _acc_t * next;
};
struct progress_implementation {
	char const * name;
	_Bool interactive;
	void *( * create)(long long, long long);
	void( * update)(void *, long long, double);
	void( * finish)(void *, double);
	void( * set_params)(char const *);
};
struct dot_progress {
	long long initial_length;
	long long total_length;
	int accumulated;
	int rows;
	int dots;
	double last_timer_value;
};
struct bar_progress_hist {
	int pos;
	double times[20];
	long long bytes[20];
	double total_time;
	long long total_bytes;
};
struct bar_progress {
	long long initial_length;
	long long total_length;
	long long count;
	double last_screen_update;
	int width;
	char * buffer;
	int tick;
	struct bar_progress_hist hist;
	double recent_start;
	long long recent_bytes;
	_Bool stalled;
	double last_eta_time;
	int last_eta_value;
};
struct __anonstruct_clocks_37 {
	int id;
	int sysconf_name;
};
struct ptimer {
	struct timespec start;
	double elapsed_last;
	double elapsed_pre_start;
};
struct queue_element {
	char const * url;
	char const * referer;
	int depth;
	_Bool html_allowed;
	struct iri * iri;
	_Bool css_allowed;
	struct queue_element * next;
};
struct url_queue {
	struct queue_element * head;
	struct queue_element * tail;
	int count;
	int maxcount;
};
struct path_info {
	char * path;
	_Bool allowedp;
	_Bool user_agent_exact_p;
};
struct robot_specs {
	int count;
	int size;
	struct path_info * paths;
};
struct __anonstruct_limit_data_59 {
	long long chunk_bytes;
	double chunk_start;
	double sleep_adjust;
};
struct scheme_data {
	char const * name;
	char const * leading_string;
	int default_port;
	int flags;
};
struct growable {
	char * base;
	int size;
	int tail;
};
struct __anonstruct___sigset_t_2 {
	unsigned long __val[1024u / (8u * sizeof(unsigned long))];
};
struct md5_ctx {
	unsigned int A;
	unsigned int B;
	unsigned int C;
	unsigned int D;
	unsigned int total[2];
	unsigned int buflen;
	unsigned int buffer[32];
};
struct gen_md5_context {
	struct md5_ctx imp;
};
union __anonunion___value_25 {
	unsigned int __wch;
	char __wchb[4];
};
struct __anonstruct___mbstate_t_24 {
	int __count;
	union __anonunion___value_25 __value;
};
struct quoting_options {
	unsigned int style;
	int flags;
	unsigned int quote_these_too[255u / (sizeof(int) * 8u) + 1u];
	char const * left_quote;
	char const * right_quote;
};
struct slotvec {
	unsigned int size;
	char * val;
};
struct __anonstruct_28 {
	char c;
	unsigned int x;
};

extern void error(int __status, int __errnum, char const * __format, ...);

#endif
