class
	P_HASH_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	primes: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					13, 19, 29, 41, 59, 79, 107, 149, 197, 263, 347, 457, 599, 787, 1_031, 1_361, 1_777, 2_333, 3_037,
					3_967, 5_167, 6_719, 8_737, 11_369, 14_783, 19_219, 24_989, 32_491, 42_257, 54_941, 71_429, 92_861,
					120_721, 156_941, 204_047, 265_271, 344_857, 448_321, 582_821, 757_693, 985_003, 1_280_519, 1_664_681,
					2_164_111, 2_813_353, 3_657_361, 4_754_591, 6_180_989, 8_035_301, 10_445_899, 13_579_681, 17_653_589,
					22_949_669, 29_834_603, 38_784_989, 50_420_551, 65_546_729, 85_210_757, 110_774_011, 144_006_217,
					187_208_107, 243_370_577, 316_381_771, 411_296_309, 534_685_237, 695_090_819, 903_618_083, 1_174_703_521,
					1_527_114_613, 1_837_299_131, 2_147_483_647
				>>)
		end

feature {ANY} -- public routines

	prime_size (a_size: INTEGER_32; a_prime_offset: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_prime_offset.is_void
		local
			l_i: NATURAL_32
			l_return: BOOLEAN
		do
			l_i := (a_prime_offset.item).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < ({PLATFORM}.Integer_32_bytes.to_natural_32 * (71).to_natural_32) // {PLATFORM}.Integer_32_bytes.to_natural_32))
			loop
				if primes.item[l_i.to_integer_32] >= a_size then
					a_prime_offset.item := (l_i + {NATURAL_32} 1).to_integer_32
					Result := (primes.item[l_i.to_integer_32])
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				abort
			end
		end

	hash_table_new (a_items: INTEGER_32; a_hash_function, a_test_function: CE_ROUTINE): CE_POINTER [PD_HASH_TABLE]
		local
			l_size: INTEGER_32
			l_ht: CE_POINTER [PD_HASH_TABLE]
		do
			l_ht := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((create {PD_HASH_TABLE}.make).structure_size.to_natural_32)))
			if (not a_hash_function.is_void) then
				l_ht.item.hash_function := a_hash_function
			else
				l_ht.item.hash_function := hash_pointer_address
			end
			if (not a_test_function.is_void) then
				l_ht.item.test_function := a_test_function
			else
				l_ht.item.test_function := cmp_pointer_address
			end
			l_ht.item.prime_offset := 0
			l_size := ((1).to_double + a_items.to_double / 0.75).truncated_to_integer
			l_size := prime_size (l_size, create {CE_INTEGER_32_POINTER}.make_shared (l_ht.c_pointer + (create {PD_HASH_TABLE}.make).offset_of ("prime_offset")))
			l_ht.item.size := l_size
			l_ht.item.resize_threshold := (l_size.to_double * 0.75).truncated_to_integer
			l_ht.item.cells := create {CE_CLASS_POINTER [PD_CELL]}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((l_ht.item.size).to_natural_32 * (create {PD_CELL}.make).structure_size.to_natural_32)))
			memset (create {CE_VOID_POINTER}.make_cast (l_ht.item.cells), 255, l_size.to_natural_32 * (create {PD_CELL}.make).structure_size.to_natural_32).do_nothing
			l_ht.item.count := 0
			Result := l_ht
		end

	hash_string (a_key: CE_POINTER [ANY]): NATURAL_32
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_h: NATURAL_32
		do
			l_p___0 := create {CE_INTEGER_8_POINTER}.make_cast (a_key)
			l_h := (l_p___0[0]).to_natural_32
			if l_h.to_boolean then
				l_p___0 := l_p___0 + 1
				from
				until
					(l_p___0[0]).to_integer_32 = 0
				loop
					l_h := (((l_h).bit_shift_left (5)) - l_h) + (l_p___0[0]).to_natural_32
					l_p___0 := l_p___0 + 1
				end
			end
			Result := l_h.to_natural_32
		end

	cmp_string (a_s1, a_s2: CE_POINTER [ANY]): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_s1), create {CE_INTEGER_8_POINTER}.make_cast (a_s2))).to_boolean then
				l_tmp___0 := 0
			else
				l_tmp___0 := 1
			end
			Result := l_tmp___0
		end

	make_string_hash_table (a_items: INTEGER_32): CE_POINTER [PD_HASH_TABLE]
		do
			Result := (hash_table_new (a_items, hash_string_address, cmp_string_address))
		end

	hash_string_nocase (a_key: CE_POINTER [ANY]): NATURAL_32
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_h: NATURAL_32
		do
			l_p___0 := create {CE_INTEGER_8_POINTER}.make_cast (a_key)
			l_h := ((create {P_C_CTYPE_STATIC}).c2_tolower ((l_p___0[0]).to_integer_32)).to_natural_32
			if l_h.to_boolean then
				l_p___0 := l_p___0 + 1
				from
				until
					(l_p___0[0]).to_integer_32 = 0
				loop
					l_h := (((l_h).bit_shift_left (5)) - l_h) + ((create {P_C_CTYPE_STATIC}).c2_tolower ((l_p___0[0]).to_integer_32)).to_natural_32
					l_p___0 := l_p___0 + 1
				end
			end
			Result := l_h.to_natural_32
		end

	string_cmp_nocase (a_s1, a_s2: CE_POINTER [ANY]): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_s1), create {CE_INTEGER_8_POINTER}.make_cast (a_s2))).to_boolean then
				l_tmp___0 := 0
			else
				l_tmp___0 := 1
			end
			Result := l_tmp___0
		end

	make_nocase_string_hash_table (a_items: INTEGER_32): CE_POINTER [PD_HASH_TABLE]
		do
			Result := (hash_table_new (a_items, hash_string_nocase_address, string_cmp_nocase_address))
		end

	hash_pointer (a_ptr: CE_POINTER [ANY]): NATURAL_32
		local
			l_key: NATURAL_32
		do
			l_key := (a_ptr.c_pointer.to_integer_32).to_natural_32
			l_key := l_key + ((l_key).bit_shift_left (12))
			l_key := (l_key).bit_xor (((l_key).bit_shift_right (22)))
			l_key := l_key + ((l_key).bit_shift_left (4))
			l_key := (l_key).bit_xor (((l_key).bit_shift_right (9)))
			l_key := l_key + ((l_key).bit_shift_left (10))
			l_key := (l_key).bit_xor (((l_key).bit_shift_right (2)))
			l_key := l_key + ((l_key).bit_shift_left (7))
			l_key := (l_key).bit_xor (((l_key).bit_shift_right (12)))
			Result := l_key.to_natural_32
		end

	cmp_pointer (a_ptr1, a_ptr2: CE_POINTER [ANY]): INTEGER_32
		do
			Result := (a_ptr1.is_equal (a_ptr2)).to_integer
		end

feature {ANY} -- routine addresses

	hash_string_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent hash_string)
		end

	cmp_string_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent cmp_string)
		end

	hash_string_nocase_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent hash_string_nocase)
		end

	string_cmp_nocase_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent string_cmp_nocase)
		end

	hash_pointer_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent hash_pointer)
		end

	cmp_pointer_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent cmp_pointer)
		end

end
