class
	P_HTML_PARSE_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC
	S_ASSERT_STATIC

feature {ANY} -- public routines

	tagstack_push (a_head, a_tail: CE_POINTER [CE_POINTER [PD_TAGSTACK_ITEM]]): CE_POINTER [PD_TAGSTACK_ITEM]
		require
			not a_head.is_void
			not a_tail.is_void
		local
			l_ts: CE_POINTER [PD_TAGSTACK_ITEM]
			l_tmp___0: CE_POINTER [PD_TAGSTACK_ITEM]
			l_tmp___1: CE_POINTER [PD_TAGSTACK_ITEM]
		do
			l_ts := create {CE_CLASS_POINTER [PD_TAGSTACK_ITEM]}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((create {PD_TAGSTACK_ITEM}.make).structure_size.to_natural_32)))
			if (a_head.item).is_void then
				l_tmp___0 := l_ts
				a_tail.item := l_tmp___0
				a_head.item := l_tmp___0
				l_tmp___1 := create {CE_CLASS_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer)
				l_ts.item.next := l_tmp___1
				l_ts.item.prev := l_tmp___1
			else
				(a_tail.item).item.next := l_ts
				l_ts.item.prev := a_tail.item
				a_tail.item := l_ts
				l_ts.item.next := create {CE_CLASS_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer)
			end
			Result := l_ts
		end

	tagstack_pop (a_head, a_tail: CE_POINTER [CE_POINTER [PD_TAGSTACK_ITEM]]; a_ts: CE_POINTER [PD_TAGSTACK_ITEM])
		require
			not a_head.is_void
		local
			l_ts: CE_POINTER [PD_TAGSTACK_ITEM]
			l_tmp: CE_POINTER [PD_TAGSTACK_ITEM]
			l_p___0: CE_POINTER [PD_TAGSTACK_ITEM]
			l_return: BOOLEAN
		do
			l_ts := a_ts
			if (a_head.item).is_void then
				l_return := True
			end
			if not l_return then
				if l_ts.is_equal (a_tail.item) then
					if l_ts.is_equal (a_head.item) then
						free (create {CE_VOID_POINTER}.make_cast (l_ts))
						l_tmp := create {CE_CLASS_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer)
						a_tail.item := l_tmp
						a_head.item := l_tmp
					else
						(l_ts.item.prev).item.next := create {CE_CLASS_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer)
						a_tail.item := l_ts.item.prev
						free (create {CE_VOID_POINTER}.make_cast (l_ts))
					end
				else
					if l_ts.is_equal (a_head.item) then
						a_head.item := create {CE_CLASS_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer)
					end
					a_tail.item := l_ts.item.prev
					if (not (l_ts.item.prev).is_void) then
						(l_ts.item.prev).item.next := create {CE_CLASS_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer)
					end
					from
					until
						l_ts.is_void
					loop
						l_p___0 := l_ts.item.next
						free (create {CE_VOID_POINTER}.make_cast (l_ts))
						l_ts := l_p___0
					end
				end
			end
		end

	tagstack_find (a_tail: CE_POINTER [PD_TAGSTACK_ITEM]; a_tagname_begin, a_tagname_end: CE_POINTER [INTEGER_8]): CE_POINTER [PD_TAGSTACK_ITEM]
		local
			l_tail: CE_POINTER [PD_TAGSTACK_ITEM]
			l_len: INTEGER_32
			l_return: BOOLEAN
		do
			l_tail := a_tail
			l_len := a_tagname_end.distance (a_tagname_begin)
			from
			until
				not (not (l_return) and then (not l_tail.is_void))
			loop
				if l_len = (l_tail.item.tagname_end).distance ((l_tail.item.tagname_begin)) then
					if 0 = (strncasecmp (l_tail.item.tagname_begin, a_tagname_begin, l_len.to_natural_32)) then
						Result := l_tail
						l_return := True
					end
				end
				if not l_return then
					l_tail := l_tail.item.prev
				end
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer))
			end
		end

	advance_declaration (a_beg, a_end: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_quote_char: INTEGER_8
			l_ch: INTEGER_8
			l_state: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_beg
					l_quote_char := (('%/0/').code).to_integer_8
					l_state := {PC_STATE}.AC_S_BANG
					if a_beg.is_equal (a_end) then
						Result := a_beg
						l_return := True
					end
					if l_return then
						l_pos := -1 + 34 -- skip if block
					end
				when 1 then -- if:
						l_tmp := l_p___0
						l_p___0 := l_p___0 + 1
						l_ch := l_tmp[0]
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 33 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if l_state /= {NATURAL_32} 0 then
							if l_state = {NATURAL_32} 1 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 32 -- skip if block
						end
				when 4 then -- if:
						if l_p___0.is_equal (a_end) then
							l_state := {PC_STATE}.AC_S_BACKOUT
						end
						inspect l_state.to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 5
						when 1 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 6
						when 3 then l_pos := -1 + 7
						when 4 then l_pos := -1 + 14
						when 10 then l_pos := -1 + 15
						when 11 then l_pos := -1 + 16
						when 12 then l_pos := -1 + 17
						when 5 then l_pos := -1 + 18
						when 6 then l_pos := -1 + 19
						when 7 then l_pos := -1 + 23
						when 8 then l_pos := -1 + 27
						when 9 then l_pos := -1 + 28
						else l_pos := -1 + 32
						end
				when 5 then -- switch 1, case 0 | switch 1, case 1
						l_pos := -1 + 32 -- switch 1; break
				when 6 then -- switch 1, case 2
						if l_ch.to_integer_32 = 33 then
							l_tmp___0 := l_p___0
							l_p___0 := l_p___0 + 1
							l_ch := l_tmp___0[0]
							l_state := {PC_STATE}.AC_S_DEFAULT
						else
							l_state := {PC_STATE}.AC_S_BACKOUT
						end
						l_pos := -1 + 32 -- switch 1; break
				when 7 then -- switch 1, case 3
						inspect l_ch.to_integer_32 -- switch 2 head
						when 45 then l_pos := -1 + 8
						when 32 then l_pos := -1 + 9
						when 9 then l_pos := -1 + 9
						when 13 then l_pos := -1 + 9
						when 10 then l_pos := -1 + 9
						when 62 then l_pos := -1 + 10
						when 39 then l_pos := -1 + 11
						when 34 then l_pos := -1 + 11
						else l_pos := -1 + 12
						end
				when 8 then -- switch 2, case 45
						l_state := {PC_STATE}.AC_S_DASH1
						l_pos := -1 + 13 -- switch 2; break
				when 9 then -- switch 2, case 32 | switch 2, case 9 | switch 2, case 13 | switch 2, case 10
						l_tmp___1 := l_p___0
						l_p___0 := l_p___0 + 1
						l_ch := l_tmp___1[0]
						l_pos := -1 + 13 -- switch 2; break
				when 10 then -- switch 2, case 62
						l_state := {PC_STATE}.AC_S_DONE
						l_pos := -1 + 13 -- switch 2; break
				when 11 then -- switch 2, case 39 | switch 2, case 34
						l_state := {PC_STATE}.AC_S_QUOTE1
						l_pos := -1 + 13 -- switch 2; break
				when 12 then -- switch 2, default:
						if l_ch.to_integer_32 > 32 then
							if l_ch.to_integer_32 < 127 then
								if l_ch.to_integer_32 /= 61 then
									if l_ch.to_integer_32 /= 62 then
										if l_ch.to_integer_32 /= 47 then
											l_state := {PC_STATE}.AC_S_DCLNAME
										else
											l_state := {PC_STATE}.AC_S_BACKOUT
										end
									else
										l_state := {PC_STATE}.AC_S_BACKOUT
									end
								else
									l_state := {PC_STATE}.AC_S_BACKOUT
								end
							else
								l_state := {PC_STATE}.AC_S_BACKOUT
							end
						else
							l_state := {PC_STATE}.AC_S_BACKOUT
						end
						l_pos := -1 + 13 -- switch 2; break
				when 13 then -- switch 2, done:
						l_pos := -1 + 32 -- switch 1; break
				when 14 then -- switch 1, case 4
						if l_ch.to_integer_32 = 45 then
							l_state := {PC_STATE}.AC_S_DASH1
						elseif l_ch.to_integer_32 > 32 then
							if l_ch.to_integer_32 < 127 then
								if l_ch.to_integer_32 /= 61 then
									if l_ch.to_integer_32 /= 62 then
										if l_ch.to_integer_32 /= 47 then
											l_tmp___2 := l_p___0
											l_p___0 := l_p___0 + 1
											l_ch := l_tmp___2[0]
										else
											l_state := {PC_STATE}.AC_S_DEFAULT
										end
									else
										l_state := {PC_STATE}.AC_S_DEFAULT
									end
								else
									l_state := {PC_STATE}.AC_S_DEFAULT
								end
							else
								l_state := {PC_STATE}.AC_S_DEFAULT
							end
						else
							l_state := {PC_STATE}.AC_S_DEFAULT
						end
						l_pos := -1 + 32 -- switch 1; break
				when 15 then -- switch 1, case 10
						if l_ch.to_integer_32 /= 39 then
							if l_ch.to_integer_32 /= 34 then
								assert_fail (ce_string ("ch == %'\%'%' || ch == 0x22"), ce_string ("html-parse.c"), {NATURAL_32} 648, ce_string ("advance_declaration"))
							end
						end
						l_quote_char := l_ch
						l_tmp___3 := l_p___0
						l_p___0 := l_p___0 + 1
						l_ch := l_tmp___3[0]
						l_state := {PC_STATE}.AC_S_IN_QUOTE
						l_pos := -1 + 32 -- switch 1; break
				when 16 then -- switch 1, case 11
						if l_ch.to_integer_32 = l_quote_char.to_integer_32 then
							l_state := {PC_STATE}.AC_S_QUOTE2
						else
							l_tmp___4 := l_p___0
							l_p___0 := l_p___0 + 1
							l_ch := l_tmp___4[0]
						end
						l_pos := -1 + 32 -- switch 1; break
				when 17 then -- switch 1, case 12
						if l_ch.to_integer_32 /= l_quote_char.to_integer_32 then
							assert_fail (ce_string ("ch == quote_char"), ce_string ("html-parse.c"), {NATURAL_32} 662, ce_string ("advance_declaration"))
						end
						l_tmp___5 := l_p___0
						l_p___0 := l_p___0 + 1
						l_ch := l_tmp___5[0]
						l_state := {PC_STATE}.AC_S_DEFAULT
						l_pos := -1 + 32 -- switch 1; break
				when 18 then -- switch 1, case 5
						if l_ch.to_integer_32 /= 45 then
							assert_fail (ce_string ("ch == %'-%'"), ce_string ("html-parse.c"), {NATURAL_32} 667, ce_string ("advance_declaration"))
						end
						l_tmp___6 := l_p___0
						l_p___0 := l_p___0 + 1
						l_ch := l_tmp___6[0]
						l_state := {PC_STATE}.AC_S_DASH2
						l_pos := -1 + 32 -- switch 1; break
				when 19 then -- switch 1, case 6
						inspect l_ch.to_integer_32 -- switch 3 head
						when 45 then l_pos := -1 + 20
						else l_pos := -1 + 21
						end
				when 20 then -- switch 3, case 45
						l_tmp___7 := l_p___0
						l_p___0 := l_p___0 + 1
						l_ch := l_tmp___7[0]
						l_state := {PC_STATE}.AC_S_COMMENT
						l_pos := -1 + 22 -- switch 3; break
				when 21 then -- switch 3, default:
						l_state := {PC_STATE}.AC_S_BACKOUT
				when 22 then -- switch 3, done:
						l_pos := -1 + 32 -- switch 1; break
				when 23 then -- switch 1, case 7
						inspect l_ch.to_integer_32 -- switch 4 head
						when 45 then l_pos := -1 + 24
						else l_pos := -1 + 25
						end
				when 24 then -- switch 4, case 45
						l_state := {PC_STATE}.AC_S_DASH3
						l_pos := -1 + 26 -- switch 4; break
				when 25 then -- switch 4, default:
						l_tmp___8 := l_p___0
						l_p___0 := l_p___0 + 1
						l_ch := l_tmp___8[0]
						l_pos := -1 + 26 -- switch 4; break
				when 26 then -- switch 4, done:
						l_pos := -1 + 32 -- switch 1; break
				when 27 then -- switch 1, case 8
						if l_ch.to_integer_32 /= 45 then
							assert_fail (ce_string ("ch == %'-%'"), ce_string ("html-parse.c"), {NATURAL_32} 694, ce_string ("advance_declaration"))
						end
						l_tmp___9 := l_p___0
						l_p___0 := l_p___0 + 1
						l_ch := l_tmp___9[0]
						l_state := {PC_STATE}.AC_S_DASH4
						l_pos := -1 + 32 -- switch 1; break
				when 28 then -- switch 1, case 9
						inspect l_ch.to_integer_32 -- switch 5 head
						when 45 then l_pos := -1 + 29
						else l_pos := -1 + 30
						end
				when 29 then -- switch 5, case 45
						l_tmp___10 := l_p___0
						l_p___0 := l_p___0 + 1
						l_ch := l_tmp___10[0]
						l_state := {PC_STATE}.AC_S_DEFAULT
						l_pos := -1 + 31 -- switch 5; break
				when 30 then -- switch 5, default:
						l_state := {PC_STATE}.AC_S_COMMENT
						l_pos := -1 + 31 -- switch 5; break
				when 31 then -- switch 5, done:
						l_pos := -1 + 32 -- switch 1; break
				when 32 then -- switch 1, done: | if done
						l_pos := -1 + 2 -- back to loop condition
				when 33 then -- loop done
						l_break := False
						if l_state = {NATURAL_32} 1 then
							Result := (a_beg + 1)
							l_return := True
						end
				when 34 then -- if done
					if not l_return then
						Result := l_p___0
					end
				when 35 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_comment_end (a_beg, a_end: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_beg - 1
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 16 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + (3)
						if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32) then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 15 -- skip if block
						end
				when 3 then -- if:
						inspect (l_p___0[0]).to_integer_32 -- switch 1 head
						when 62 then l_pos := -1 + 4
						when 45 then l_pos := -1 + 5
						else l_pos := -1 + 15
						end
				when 4 then -- switch 1, case 62
						if (l_p___0[-1]).to_integer_32 = 45 then
							if (l_p___0[-2]).to_integer_32 = 45 then
								Result := (l_p___0 + 1)
								l_return := True
							end
						end
						l_pos := -1 + 15 -- switch 1; break
				when 5 then -- at_dash: | switch 1, case 45
						if (l_p___0[-1]).to_integer_32 /= 45 then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if: | at_dash_dash:
						l_p___0 := l_p___0 + 1
						if l_p___0.is_equal (a_end) then
							Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
						if l_return then
							l_pos := -1 + 10 -- skip if block
						end
				when 7 then -- if:
						inspect (l_p___0[0]).to_integer_32 -- switch 2 head
						when 62 then l_pos := -1 + 8
						when 45 then l_pos := -1 + 9
						else l_pos := -1 + 10
						end
				when 8 then -- switch 2, case 62
						Result := (l_p___0 + 1)
						l_return := True
				when 9 then -- switch 2, case 45
						if not l_return then
							l_pos := -1 + 6 -- goto at_dash_dash
						end
				when 10 then -- switch 2, done: | if done | if block done, skip else block:
						l_pos := -1 + 15
				when 11 then -- else:
						l_p___0 := l_p___0 + (2)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (a_end.c_pointer.to_integer_32).to_natural_32 then
							Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
						if l_return then
							l_pos := -1 + 15 -- skip if block
						end
				when 12 then -- if:
						inspect (l_p___0[0]).to_integer_32 -- switch 3 head
						when 62 then l_pos := -1 + 13
						when 45 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 13 then -- switch 3, case 62
						if (l_p___0[-1]).to_integer_32 = 45 then
							Result := (l_p___0 + 1)
							l_return := True
						end
						l_pos := -1 + 15 -- switch 3; break
				when 14 then -- switch 3, case 45
						l_pos := -1 + 5 -- goto at_dash
				when 15 then -- switch 3, done: | if done | switch 1, done: | if done
						l_pos := -1 + 1 -- back to loop condition
				when 16 then -- loop done
					if not l_return then
						l_break := False
						Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	name_allowed (a_ht: CE_POINTER [PD_HASH_TABLE]; a_b, a_e: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_copy: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_BTA_beg: CE_POINTER [INTEGER_8]
			l_BTA_len: INTEGER_32
			l_BTA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_copy.make (<<1>>)

			if a_ht.is_void then
				Result := (1).to_boolean
				l_return := True
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					l_BTA_beg := a_b
					l_BTA_len := a_e.distance (l_BTA_beg)
					l_BTA_dest := l_copy
					l_BTA_dest.item := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new ((l_BTA_len + 1).to_natural_32)))
					memcpy (create {CE_VOID_POINTER}.make_cast (l_BTA_dest.item), create {CE_VOID_POINTER}.make_cast (l_BTA_beg), l_BTA_len.to_natural_32).do_nothing
					l_BTA_dest.item[l_BTA_len] := (('%/0/').code).to_integer_8
					l_break := True
				end
				l_break := False
				Result := (not (a_ht.item.hash_table_get (create {CE_VOID_POINTER}.make_cast (l_copy.item))).is_void)
			end
		end

	map_html_tags (a_text: CE_POINTER [INTEGER_8]; a_size: INTEGER_32; a_mapfun: CE_ROUTINE; a_maparg: CE_POINTER [ANY]; a_flags: INTEGER_32; a_allowed_tags, a_allowed_attributes: CE_POINTER [PD_HASH_TABLE])
		local
			l_pool_initial_storage: CE_ARRAY [INTEGER_8]
			l_pool: CE_ARRAY [PD_POOL]
			l_p___0: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_attr_pair_initial_storage: CE_ARRAY [PD_ATTR_PAIR]
			l_attr_pair_size: INTEGER_32
			l_attr_pair_resized: BOOLEAN
			l_pairs: CE_POINTER [PD_ATTR_PAIR]
			l_head: CE_ARRAY [CE_POINTER [PD_TAGSTACK_ITEM]]
			l_tail: CE_ARRAY [CE_POINTER [PD_TAGSTACK_ITEM]]
			l_P: CE_POINTER [PD_POOL]
			l_nattrs: INTEGER_32
			l_end_tag: INTEGER_32
			l_tag_name_begin: CE_POINTER [INTEGER_8]
			l_tag_name_end: CE_POINTER [INTEGER_8]
			l_tag_start_position: CE_POINTER [INTEGER_8]
			l_uninteresting_tag: BOOLEAN
			l_comment_end: CE_POINTER [INTEGER_8]
			l_ts: CE_POINTER [PD_TAGSTACK_ITEM]
			l_attr_name_begin: CE_POINTER [INTEGER_8]
			l_attr_name_end: CE_POINTER [INTEGER_8]
			l_attr_value_begin: CE_POINTER [INTEGER_8]
			l_attr_value_end: CE_POINTER [INTEGER_8]
			l_attr_raw_value_begin: CE_POINTER [INTEGER_8]
			l_attr_raw_value_end: CE_POINTER [INTEGER_8]
			l_operation: INTEGER_32
			l_newline_seen: BOOLEAN
			l_quote_char: INTEGER_8
			l_ga_needed_size: INTEGER_32
			l_ga_newsize: INTEGER_32
			l_ga_new: CE_POINTER [ANY]
			l_i: INTEGER_32
			l_taginfo: CE_ARRAY [PD_TAGINFO]
			l_ts___0: CE_POINTER [PD_TAGSTACK_ITEM]
			l_P___02: CE_POINTER [PD_POOL]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_pool_initial_storage.make (<<256>>)
			create {CE_CLASS_ARRAY [PD_POOL]} l_pool.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_ATTR_PAIR]} l_attr_pair_initial_storage.make (<<8>>)
			create {CE_POINTER_ARRAY [PD_TAGSTACK_ITEM]} l_head.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TAGSTACK_ITEM]} l_tail.make (<<1>>)
			create {CE_INTEGER_8_POINTER} l_attr_name_begin.make
			create {CE_INTEGER_8_POINTER} l_attr_name_end.make
			create {CE_INTEGER_8_POINTER} l_attr_value_begin.make
			create {CE_INTEGER_8_POINTER} l_attr_value_end.make
			create {CE_INTEGER_8_POINTER} l_attr_raw_value_begin.make
			create {CE_INTEGER_8_POINTER} l_attr_raw_value_end.make
			create {CE_CLASS_ARRAY [PD_TAGINFO]} l_taginfo.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_text
					l_end := a_text + a_size
					l_attr_pair_size := (((create {PD_ATTR_PAIR}.make).structure_size.to_natural_32 * (8).to_natural_32) // (create {PD_ATTR_PAIR}.make).structure_size.to_natural_32).to_integer_32
					l_attr_pair_resized := (0).to_boolean
					l_pairs := l_attr_pair_initial_storage
					l_head.item := create {CE_CLASS_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer)
					l_tail.item := create {CE_CLASS_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer)
					if not a_size.to_boolean then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 166 -- skip if block
					end
				when 1 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							l_P := l_pool
							l_P.item.contents := l_pool_initial_storage
							l_P.item.size := (({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32) // {PLATFORM}.Integer_8_bytes.to_natural_32).to_integer_32
							l_P.item.tail := 0
							l_P.item.resized := (0).to_boolean
							l_P.item.orig_contents := l_P.item.contents
							l_P.item.orig_size := l_P.item.size
							l_break := True
						end
						l_break := False
				when 2 then -- look_for_tag:
						l_pool.item.tail := 0
						l_nattrs := 0
						l_end_tag := 0
						l_p___0 := create {CE_INTEGER_8_POINTER}.make_cast ((memchr (create {CE_VOID_POINTER}.make_cast (l_p___0), ('<').code, (l_end.distance (l_p___0)).to_natural_32)))
						if l_p___0.is_void then
							l_pos := -1 + 165 -- goto finish
						end
				when 3 then
						l_tag_start_position := l_p___0
				when 4 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 7 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 6 then
						l_break := True
						l_pos := -1 + 4 -- back to loop condition
				when 7 then -- loop done
						l_break := False
						if (l_p___0[0]).to_integer_32 /= 33 then
							l_pos := -1 + 11 -- skip if block
						end
				when 8 then -- if:
						if not ((a_flags).bit_and (1)).to_boolean then
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_end + 3).c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0[1]).to_integer_32 = 45 then
									if (l_p___0[2]).to_integer_32 = 45 then
										l_comment_end := (find_comment_end (l_p___0 + 3, l_end))
										if (not l_comment_end.is_void) then
											l_p___0 := l_comment_end
										end
									else
										l_p___0 := advance_declaration (l_p___0, l_end)
									end
								else
									l_p___0 := advance_declaration (l_p___0, l_end)
								end
							else
								l_p___0 := advance_declaration (l_p___0, l_end)
							end
						else
							l_p___0 := advance_declaration (l_p___0, l_end)
						end
						if l_p___0.is_equal (l_end) then
							l_pos := -1 + 165 -- goto finish
						end
				when 9 then
						l_pos := -1 + 2 -- goto look_for_tag
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 11 then -- else:
						if (l_p___0[0]).to_integer_32 /= 47 then
							l_pos := -1 + 17 -- skip if block
						end
				when 12 then -- if:
						l_end_tag := 1
				when 13 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 16 -- skip loop
						end
				when 14 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 15 then
						l_break := True
						l_pos := -1 + 13 -- back to loop condition
				when 16 then -- loop done
						l_break := False
				when 17 then -- if done
						l_tag_name_begin := l_p___0
				when 18 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 25 -- skip loop
						end
				when 19 then -- loop body:
						l_break := False
						if (l_p___0[0]).to_integer_32 > 32 then
							if (l_p___0[0]).to_integer_32 < 127 then
								if (l_p___0[0]).to_integer_32 /= 61 then
									if (l_p___0[0]).to_integer_32 /= 62 then
										if (l_p___0[0]).to_integer_32 = 47 then
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 24 -- skip if block
						end
				when 20 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 23 -- skip loop
						end
				when 21 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 22 then
						l_break := True
						l_pos := -1 + 20 -- back to loop condition
				when 23 then -- loop done
						l_break := False
				when 24 then -- if done
						l_pos := -1 + 18 -- back to loop condition
				when 25 then -- loop done
						l_break := False
						if l_p___0.is_equal (l_tag_name_begin) then
							l_pos := -1 + 2 -- goto look_for_tag
						end
				when 26 then
						l_tag_name_end := l_p___0
				when 27 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 37 -- skip loop
						end
				when 28 then -- loop body:
						l_break := False
				when 29 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 36 -- skip loop
						end
				when 30 then -- loop body:
						l_break := False
						if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 35 -- skip if block
						end
				when 31 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 34 -- skip loop
						end
				when 32 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 33 then
						l_break := True
						l_pos := -1 + 31 -- back to loop condition
				when 34 then -- loop done
						l_break := False
				when 35 then -- if done
						l_pos := -1 + 29 -- back to loop condition
				when 36 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 27 -- back to loop condition
				when 37 then -- loop done
						l_break := False
						if not l_end_tag.to_boolean then
							l_ts := (tagstack_push (l_head, l_tail))
							if (not l_ts.is_void) then
								l_ts.item.tagname_begin := l_tag_name_begin
								l_ts.item.tagname_end := l_tag_name_end
								l_ts.item.contents_begin := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							end
						end
						if l_end_tag.to_boolean then
							if (l_p___0[0]).to_integer_32 /= 62 then
								l_pos := -1 + 164 -- goto backout_tag
							end
						end
				when 38 then
						if (name_allowed (a_allowed_tags, l_tag_name_begin, l_tag_name_end)) then
							l_uninteresting_tag := (0).to_boolean
							l_pool.item.convert_and_copy (l_tag_name_begin, l_tag_name_end, 1)
						else
							l_uninteresting_tag := (1).to_boolean
						end
				when 39 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 154 -- skip loop
						end
				when 40 then -- loop body:
						l_break := False
						l_continue := False
						l_operation := 1
				when 41 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 51 -- skip loop
						end
				when 42 then -- loop body:
						l_break := False
				when 43 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 50 -- skip loop
						end
				when 44 then -- loop body:
						l_break := False
						if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 49 -- skip if block
						end
				when 45 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 48 -- skip loop
						end
				when 46 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 47 then
						l_break := True
						l_pos := -1 + 45 -- back to loop condition
				when 48 then -- loop done
						l_break := False
				when 49 then -- if done
						l_pos := -1 + 43 -- back to loop condition
				when 50 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 41 -- back to loop condition
				when 51 then -- loop done
						l_break := False
						if (l_p___0[0]).to_integer_32 /= 47 then
							l_pos := -1 + 67 -- skip if block
						end
				when 52 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 55 -- skip loop
						end
				when 53 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 54 then
						l_break := True
						l_pos := -1 + 52 -- back to loop condition
				when 55 then -- loop done
						l_break := False
				when 56 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 66 -- skip loop
						end
				when 57 then -- loop body:
						l_break := False
				when 58 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 65 -- skip loop
						end
				when 59 then -- loop body:
						l_break := False
						if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 64 -- skip if block
						end
				when 60 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 63 -- skip loop
						end
				when 61 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 62 then
						l_break := True
						l_pos := -1 + 60 -- back to loop condition
				when 63 then -- loop done
						l_break := False
				when 64 then -- if done
						l_pos := -1 + 58 -- back to loop condition
				when 65 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 56 -- back to loop condition
				when 66 then -- loop done
						l_break := False
						if (l_p___0[0]).to_integer_32 /= 62 then
							l_pos := -1 + 164 -- goto backout_tag
						end
				when 67 then
						if (l_p___0[0]).to_integer_32 = 62 then
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 153 -- skip if block
						end
				when 68 then -- if:
						l_attr_name_begin := l_p___0
				when 69 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 76 -- skip loop
						end
				when 70 then -- loop body:
						l_break := False
						if (l_p___0[0]).to_integer_32 > 32 then
							if (l_p___0[0]).to_integer_32 < 127 then
								if (l_p___0[0]).to_integer_32 /= 61 then
									if (l_p___0[0]).to_integer_32 /= 62 then
										if (l_p___0[0]).to_integer_32 = 47 then
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 75 -- skip if block
						end
				when 71 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 74 -- skip loop
						end
				when 72 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 73 then
						l_break := True
						l_pos := -1 + 71 -- back to loop condition
				when 74 then -- loop done
						l_break := False
				when 75 then -- if done
						l_pos := -1 + 69 -- back to loop condition
				when 76 then -- loop done
						l_break := False
						l_attr_name_end := l_p___0
						if l_attr_name_begin.is_equal (l_attr_name_end) then
							l_pos := -1 + 164 -- goto backout_tag
						end
				when 77 then
						if (l_return or l_break) then
							l_pos := -1 + 87 -- skip loop
						end
				when 78 then -- loop body:
						l_break := False
				when 79 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 86 -- skip loop
						end
				when 80 then -- loop body:
						l_break := False
						if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 85 -- skip if block
						end
				when 81 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 84 -- skip loop
						end
				when 82 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 83 then
						l_break := True
						l_pos := -1 + 81 -- back to loop condition
				when 84 then -- loop done
						l_break := False
				when 85 then -- if done
						l_pos := -1 + 79 -- back to loop condition
				when 86 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 77 -- back to loop condition
				when 87 then -- loop done
						l_break := False
						if not ((l_p___0[0]).to_integer_32 > 32) then
							l_pos := -1 + 90 -- skip if block
						end
				when 88 then -- if:
						if (l_p___0[0]).to_integer_32 < 127 then
							if (l_p___0[0]).to_integer_32 /= 61 then
								if (l_p___0[0]).to_integer_32 /= 62 then
									if (l_p___0[0]).to_integer_32 /= 47 then
										l_attr_value_begin := l_attr_name_begin
										l_attr_raw_value_begin := l_attr_value_begin
										l_attr_value_end := l_attr_name_end
										l_attr_raw_value_end := l_attr_value_end
									else
										l_pos := -1 + 90 -- goto _L___4
									end
								else
									l_pos := -1 + 90 -- goto _L___4
								end
							else
								l_pos := -1 + 90 -- goto _L___4
							end
						else
							l_pos := -1 + 90 -- goto _L___4
						end
				when 89 then -- if block done, skip else block:
						l_pos := -1 + 152
				when 90 then -- else: | _L___4:
						if (l_p___0[0]).to_integer_32 /= 47 then
							l_pos := -1 + 93 -- skip if block
						end
				when 91 then -- if:
						l_attr_value_begin := l_attr_name_begin
						l_attr_raw_value_begin := l_attr_value_begin
						l_attr_value_end := l_attr_name_end
						l_attr_raw_value_end := l_attr_value_end
				when 92 then -- if block done, skip else block:
						l_pos := -1 + 152
				when 93 then -- else:
						if (l_p___0[0]).to_integer_32 /= 62 then
							l_pos := -1 + 96 -- skip if block
						end
				when 94 then -- if:
						l_attr_value_begin := l_attr_name_begin
						l_attr_raw_value_begin := l_attr_value_begin
						l_attr_value_end := l_attr_name_end
						l_attr_raw_value_end := l_attr_value_end
				when 95 then -- if block done, skip else block:
						l_pos := -1 + 152
				when 96 then -- else:
						if (l_p___0[0]).to_integer_32 /= 61 then
							l_pos := -1 + 151 -- skip if block
						end
				when 97 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 100 -- skip loop
						end
				when 98 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 99 then
						l_break := True
						l_pos := -1 + 97 -- back to loop condition
				when 100 then -- loop done
						l_break := False
				when 101 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 111 -- skip loop
						end
				when 102 then -- loop body:
						l_break := False
				when 103 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 110 -- skip loop
						end
				when 104 then -- loop body:
						l_break := False
						if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 109 -- skip if block
						end
				when 105 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 108 -- skip loop
						end
				when 106 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 107 then
						l_break := True
						l_pos := -1 + 105 -- back to loop condition
				when 108 then -- loop done
						l_break := False
				when 109 then -- if done
						l_pos := -1 + 103 -- back to loop condition
				when 110 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 101 -- back to loop condition
				when 111 then -- loop done
						l_break := False
						if (l_p___0[0]).to_integer_32 /= 34 then
							l_pos := -1 + 114 -- skip if block
						end
				when 112 then -- if:
						l_pos := -1 + 115 -- goto _L___0
				when 113 then -- if block done, skip else block:
						l_pos := -1 + 150
				when 114 then -- else:
						if (l_p___0[0]).to_integer_32 /= 39 then
							l_pos := -1 + 140 -- skip if block
						end
				when 115 then -- if: | _L___0:
						l_newline_seen := (0).to_boolean
						l_quote_char := l_p___0[0]
						l_attr_raw_value_begin := l_p___0
				when 116 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 119 -- skip loop
						end
				when 117 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 118 then
						l_break := True
						l_pos := -1 + 116 -- back to loop condition
				when 119 then -- loop done
						l_break := False
						l_attr_value_begin := l_p___0
				when 120 then -- loop condition:
						if not (not (l_return or l_break) and then ((l_p___0[0]).to_integer_32 /= l_quote_char.to_integer_32)) then
							l_pos := -1 + 131 -- skip loop
						end
				when 121 then -- loop body:
						l_break := False
						l_continue := False
						if l_newline_seen then
							l_pos := -1 + 124 -- skip if block
						end
				when 122 then -- if:
						if (l_p___0[0]).to_integer_32 = 10 then
							l_p___0 := l_attr_value_begin
							l_newline_seen := (1).to_boolean
							l_continue := True
						else
							l_pos := -1 + 124 -- goto _L
						end
				when 123 then -- if block done, skip else block:
						l_pos := -1 + 125
				when 124 then -- else: | _L:
						if l_newline_seen then
							if (l_p___0[0]).to_integer_32 = 62 then
								l_break := True
							end
						end
				when 125 then
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 130 -- skip if block
						end
				when 126 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 129 -- skip loop
						end
				when 127 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 128 then
						l_break := True
						l_pos := -1 + 126 -- back to loop condition
				when 129 then -- loop done
						l_break := False
				when 130 then -- if done
						l_pos := -1 + 120 -- back to loop condition
				when 131 then -- loop done
						l_break := False
						l_continue := False
						l_attr_value_end := l_p___0
						if (l_p___0[0]).to_integer_32 /= l_quote_char.to_integer_32 then
							l_pos := -1 + 137 -- skip if block
						end
				when 132 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 135 -- skip loop
						end
				when 133 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 134 then
						l_break := True
						l_pos := -1 + 132 -- back to loop condition
				when 135 then -- loop done
						l_break := False
				when 136 then -- if block done, skip else block:
						l_pos := -1 + 138
				when 137 then -- else:
						l_pos := -1 + 2 -- goto look_for_tag
				when 138 then
						l_attr_raw_value_end := l_p___0
						l_operation := 2
						if ((a_flags).bit_and (2)).to_boolean then
							l_operation := (l_operation).bit_or ((4))
						end
				when 139 then -- if block done, skip else block:
						l_pos := -1 + 150
				when 140 then -- else:
						l_attr_value_begin := l_p___0
				when 141 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 148 -- skip loop
						end
				when 142 then -- loop body:
						l_break := False
						if ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
							l_break := True
						elseif (l_p___0[0]).to_integer_32 = 62 then
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 147 -- skip if block
						end
				when 143 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 146 -- skip loop
						end
				when 144 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 145 then
						l_break := True
						l_pos := -1 + 143 -- back to loop condition
				when 146 then -- loop done
						l_break := False
				when 147 then -- if done
						l_pos := -1 + 141 -- back to loop condition
				when 148 then -- loop done
						l_break := False
						l_attr_value_end := l_p___0
						if l_attr_value_begin.is_equal (l_attr_value_end) then
							l_pos := -1 + 164 -- goto backout_tag
						end
				when 149 then
						l_attr_raw_value_begin := l_attr_value_begin
						l_attr_raw_value_end := l_attr_value_end
						l_operation := 2
				when 150 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 152
				when 151 then -- else:
						l_pos := -1 + 164 -- goto backout_tag
				when 152 then -- if done | if done | if done
						if l_uninteresting_tag then
							l_continue := True
						end
				when 153 then -- if done
						if not (l_return or l_break or l_continue) then
							if not (name_allowed (a_allowed_attributes, l_attr_name_begin, l_attr_name_end)) then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_ga_needed_size := (l_nattrs + 1).to_integer_32
								l_ga_newsize := l_attr_pair_size.to_integer_32
								from
								until
									not (l_ga_newsize < l_ga_needed_size)
								loop
									l_ga_newsize := (l_ga_newsize).bit_shift_left ((1))
								end
								if l_ga_newsize /= l_attr_pair_size.to_integer_32 then
									if l_attr_pair_resized then
										l_pairs := create {CE_CLASS_POINTER [PD_ATTR_PAIR]}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_pairs), (l_ga_newsize.to_natural_32 * ((create {PD_ATTR_PAIR}.make).structure_size.to_natural_32).to_natural_32).to_natural_32)))
									else
										l_ga_new := ((create {P_XMALLOC_STATIC}).xmalloc ((l_ga_newsize.to_natural_32 * ((create {PD_ATTR_PAIR}.make).structure_size.to_natural_32).to_natural_32).to_natural_32))
										memcpy (l_ga_new, create {CE_VOID_POINTER}.make_cast (l_pairs), l_attr_pair_size.to_natural_32 * (create {PD_ATTR_PAIR}.make).structure_size.to_natural_32).do_nothing
										l_pairs := create {CE_CLASS_POINTER [PD_ATTR_PAIR]}.make_cast (l_ga_new)
										l_attr_pair_resized := (1).to_boolean
									end
									l_attr_pair_size := l_ga_newsize.to_integer_32
								end
								l_break := True
							end
							l_break := False;
							(l_pairs + l_nattrs).item.name_pool_index := l_pool.item.tail
							l_pool.item.convert_and_copy (l_attr_name_begin, l_attr_name_end, 1);
							(l_pairs + l_nattrs).item.value_pool_index := l_pool.item.tail
							l_pool.item.convert_and_copy (l_attr_value_begin, l_attr_value_end, l_operation);
							(l_pairs + l_nattrs).item.value_raw_beginning := l_attr_raw_value_begin;
							(l_pairs + l_nattrs).item.value_raw_size := l_attr_raw_value_end.distance (l_attr_raw_value_begin)
							l_nattrs := l_nattrs + 1
						end
						l_pos := -1 + 39 -- back to loop condition
				when 154 then -- loop done
						l_break := False
						l_continue := False
						if not l_end_tag.to_boolean then
							if (not (l_tail.item).is_void) then
								if (l_tail.item.item.tagname_begin).is_equal (l_tag_name_begin) then
									l_tail.item.item.contents_begin := l_p___0 + 1
								end
							end
						end
						if not l_uninteresting_tag then
							l_pos := -1 + 159 -- skip if block
						end
				when 155 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 158 -- skip loop
						end
				when 156 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 157 then
						l_break := True
						l_pos := -1 + 155 -- back to loop condition
				when 158 then -- loop done
						l_break := False
						l_pos := -1 + 2 -- goto look_for_tag
				when 159 then
						l_ts___0 := create {CE_CLASS_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer)
						l_taginfo.item.name := l_pool.item.contents
						l_taginfo.item.end_tag_p := l_end_tag
						l_taginfo.item.nattrs := l_nattrs
						l_i := 0
						from
						until
							not (l_i < l_nattrs)
						loop
							(l_pairs + l_i).item.name := l_pool.item.contents + (l_pairs + l_i).item.name_pool_index;
							(l_pairs + l_i).item.value := l_pool.item.contents + (l_pairs + l_i).item.value_pool_index
							l_i := l_i + 1
						end
						l_taginfo.item.attrs := l_pairs
						l_taginfo.item.start_position := l_tag_start_position
						l_taginfo.item.end_position := l_p___0 + 1
						l_taginfo.item.contents_begin := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						l_taginfo.item.contents_end := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						if l_end_tag.to_boolean then
							l_ts___0 := tagstack_find (l_tail.item, l_tag_name_begin, l_tag_name_end)
							if (not l_ts___0.is_void) then
								if (not (l_ts___0.item.contents_begin).is_void) then
									l_taginfo.item.contents_begin := l_ts___0.item.contents_begin
									l_taginfo.item.contents_end := l_tag_start_position
								end
								tagstack_pop (l_head, l_tail, l_ts___0)
							end
						end
						a_mapfun.call ([l_taginfo, a_maparg])
				when 160 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 163 -- skip loop
						end
				when 161 then -- loop body:
						l_break := False
						l_p___0 := l_p___0 + 1
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 162 then
						l_break := True
						l_pos := -1 + 160 -- back to loop condition
				when 163 then -- loop done
						l_break := False
						l_pos := -1 + 2 -- goto look_for_tag
				when 164 then -- backout_tag:
						l_p___0 := l_tag_start_position + 1
						l_pos := -1 + 2 -- goto look_for_tag
				when 165 then -- finish:
						from
						until
							(l_break)
						loop
							l_break := False
							l_P___02 := l_pool
							if l_P___02.item.resized then
								free (create {CE_VOID_POINTER}.make_cast (l_P___02.item.contents))
							end
							l_P___02.item.contents := l_P___02.item.orig_contents
							l_P___02.item.size := l_P___02.item.orig_size
							l_P___02.item.tail := 0
							l_P___02.item.resized := (0).to_boolean
							l_break := True
						end
						l_break := False
						if l_attr_pair_resized then
							free (create {CE_VOID_POINTER}.make_cast (l_pairs))
						end
						tagstack_pop (l_head, l_tail, l_head.item)
				when 166 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
