class
	P_PROGRESS_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_STDLIB_STATIC
	S_LIBINTL_STATIC
	S_ASSERT_STATIC
	S_STDIO_STATIC
	S_UNISTD_STATIC
	S_SIGNAL_STATIC

feature {ANY} -- public attributes

	implementations: CE_STATIC [CE_ARRAY [PD_PROGRESS_IMPLEMENTATION]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_PROGRESS_IMPLEMENTATION]}.make_initialized (<<
					create {PD_PROGRESS_IMPLEMENTATION}.make_initialized ([ce_string ("dot"), (0).to_boolean, dot_create_address, dot_update_address, dot_finish_address, dot_set_params_address]),
					create {PD_PROGRESS_IMPLEMENTATION}.make_initialized ([ce_string ("bar"), (1).to_boolean, bar_create_address, bar_update_address, bar_finish_address, bar_set_params_address])
				>>)
		end

	current_impl: CE_STATIC [CE_POINTER [PD_PROGRESS_IMPLEMENTATION]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_PROGRESS_IMPLEMENTATION]}.make
		end

	current_impl_locked: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	output_redirected: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	screen_width: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	received_sigwinch: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	buf___2: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<10>>)
		end

	last: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

feature {ANY} -- public routines

	valid_progress_implementation_p (a_name: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_name.is_void
		local
			l_i: NATURAL_32
			l_pi: CE_POINTER [PD_PROGRESS_IMPLEMENTATION]
			l_colon: CE_POINTER [INTEGER_8]
			l_namelen: NATURAL_32
			l_tmp___1: NATURAL_32
			l_return: BOOLEAN
		do
			l_pi := implementations.item
			l_colon := (strchr (a_name, (':').code))
			if (not l_colon.is_void) then
				l_tmp___1 := (l_colon.distance (a_name)).to_natural_32
			else
				l_tmp___1 := (strlen (a_name))
			end
			l_namelen := l_tmp___1
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < ((create {PD_PROGRESS_IMPLEMENTATION}.make).structure_size.to_natural_32 * (2).to_natural_32) // (create {PD_PROGRESS_IMPLEMENTATION}.make).structure_size.to_natural_32))
			loop
				if not (strncmp (l_pi.item.name, a_name, l_namelen)).to_boolean then
					Result := (1).to_boolean
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
					l_pi := l_pi + 1
				end
			end
			if not l_return then
				Result := (0).to_boolean
			end
		end

	set_progress_implementation (a_name: CE_POINTER [INTEGER_8])
		local
			l_name: CE_POINTER [INTEGER_8]
			l_i: NATURAL_32
			l_namelen: NATURAL_32
			l_pi: CE_POINTER [PD_PROGRESS_IMPLEMENTATION]
			l_colon: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_name := a_name
			l_pi := implementations.item
			if l_name.is_void then
				l_name := ce_string ("bar")
			end
			l_colon := (strchr (l_name, (':').code))
			if (not l_colon.is_void) then
				l_namelen := (l_colon.distance (l_name)).to_natural_32
			else
				l_namelen := (strlen (l_name))
			end
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < ((create {PD_PROGRESS_IMPLEMENTATION}.make).structure_size.to_natural_32 * (2).to_natural_32) // (create {PD_PROGRESS_IMPLEMENTATION}.make).structure_size.to_natural_32))
			loop
				if not (strncmp (l_pi.item.name, l_name, l_namelen)).to_boolean then
					current_impl.item := l_pi
					current_impl_locked.item := 0
					if (not l_colon.is_void) then
						l_colon := l_colon + 1
					end
					if (not (l_pi.item.set_params).is_void) then
						(l_pi.item.set_params).call ([l_colon])
					end
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
					l_pi := l_pi + 1
				end
			end
			if not l_return then
				abort
			end
		end

	progress_schedule_redirect
		do
			output_redirected.item := 1
		end

	dot_create (a_initial, a_total: INTEGER_64): CE_POINTER [ANY]
		local
			l_dp: CE_POINTER [PD_DOT_PROGRESS]
			l_dot_bytes: INTEGER_32
			l_ROW_BYTES: INTEGER_64
			l_remainder: INTEGER_32
			l_skipped: INTEGER_64
			l_skipped_k: INTEGER_64
			l_skipped_k_len: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
		do
			l_dp := create {CE_CLASS_POINTER [PD_DOT_PROGRESS]}.make_cast (((create {P_XMALLOC_STATIC}).xcalloc ((1).to_natural_32, (create {PD_DOT_PROGRESS}.make).structure_size.to_natural_32)))
			l_dp.item.initial_length := a_initial
			l_dp.item.total_length := a_total
			if (l_dp.item.initial_length).to_boolean then
				l_dot_bytes := ((create {P_OPTIONS_STATIC}).opt.item.item.dot_bytes).to_integer_32
				l_ROW_BYTES := (create {P_OPTIONS_STATIC}).opt.item.item.dot_bytes * ((create {P_OPTIONS_STATIC}).opt.item.item.dots_in_line).to_integer_64
				l_remainder := (l_dp.item.initial_length \\ l_ROW_BYTES).to_integer_32
				l_skipped := l_dp.item.initial_length - l_remainder.to_integer_64
				if l_skipped.to_boolean then
					l_skipped_k := l_skipped // {INTEGER_64} 1_024
					l_skipped_k_len := ((create {P_UTILS_STATIC}).numdigit (l_skipped_k))
					if l_skipped_k_len < 6 then
						l_skipped_k_len := 6
					end
					l_tmp___1 := (create {P_UTILS_STATIC}).number_to_static_string (l_skipped_k);
					(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("%N%%*s[ skipping %%sK ]"))), 2 + l_skipped_k_len, ce_string (""), l_tmp___1])
				end
				(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N%%6sK"), ((create {P_UTILS_STATIC}).number_to_static_string (l_skipped // {INTEGER_64} 1_024))])
				from
				until
					not (l_remainder >= l_dot_bytes)
				loop
					if l_dp.item.dots \\ (create {P_OPTIONS_STATIC}).opt.item.item.dot_spacing = 0 then
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (" "))
					end
					(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (","))
					l_dp.item.dots := (l_dp.item.dots) + 1
					l_remainder := l_remainder - l_dot_bytes
				end
				if not (l_dp.item.dots < (create {P_OPTIONS_STATIC}).opt.item.item.dots_in_line) then
					assert_fail (ce_string ("dp->dots < opt.dots_in_line"), ce_string ("progress.c"), {NATURAL_32} 256, ce_string ("dot_create"))
				end
				l_dp.item.accumulated := l_remainder
				l_dp.item.rows := (l_skipped // l_ROW_BYTES).to_integer_32
			end
			Result := (create {CE_VOID_POINTER}.make_cast (l_dp))
		end

	dot_update (a_progress: CE_POINTER [ANY]; a_howmuch: INTEGER_64; a_dltime: REAL_64)
		local
			l_dp: CE_POINTER [PD_DOT_PROGRESS]
			l_dot_bytes: INTEGER_32
			l_ROW_BYTES: INTEGER_64
		do
			l_dp := create {CE_CLASS_POINTER [PD_DOT_PROGRESS]}.make_cast (a_progress)
			l_dot_bytes := ((create {P_OPTIONS_STATIC}).opt.item.item.dot_bytes).to_integer_32
			l_ROW_BYTES := (create {P_OPTIONS_STATIC}).opt.item.item.dot_bytes * ((create {P_OPTIONS_STATIC}).opt.item.item.dots_in_line).to_integer_64;
			(create {P_LOG_STATIC}).log_set_flush ((0).to_boolean)
			l_dp.item.accumulated := ((l_dp.item.accumulated).to_integer_64 + a_howmuch).to_integer_32
			from
			until
				not (l_dp.item.accumulated >= l_dot_bytes)
			loop
				if l_dp.item.dots = 0 then
					(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N%%6sK"), ((create {P_UTILS_STATIC}).number_to_static_string (((l_dp.item.rows).to_integer_64 * l_ROW_BYTES) // {INTEGER_64} 1_024))])
				end
				if l_dp.item.dots \\ (create {P_OPTIONS_STATIC}).opt.item.item.dot_spacing = 0 then
					(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (" "))
				end
				(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("."))
				l_dp.item.dots := (l_dp.item.dots) + 1
				if l_dp.item.dots >= (create {P_OPTIONS_STATIC}).opt.item.item.dots_in_line then
					l_dp.item.rows := (l_dp.item.rows) + 1
					l_dp.item.dots := 0
					l_dp.item.print_row_stats (a_dltime, (0).to_boolean)
				end
				l_dp.item.accumulated := l_dp.item.accumulated - l_dot_bytes
			end
			(create {P_LOG_STATIC}).log_set_flush ((1).to_boolean)
		end

	dot_finish (a_progress: CE_POINTER [ANY]; a_dltime: REAL_64)
		local
			l_dp: CE_POINTER [PD_DOT_PROGRESS]
			l_ROW_BYTES: INTEGER_64
			l_i: INTEGER_32
		do
			l_dp := create {CE_CLASS_POINTER [PD_DOT_PROGRESS]}.make_cast (a_progress)
			l_ROW_BYTES := (create {P_OPTIONS_STATIC}).opt.item.item.dot_bytes * ((create {P_OPTIONS_STATIC}).opt.item.item.dots_in_line).to_integer_64;
			(create {P_LOG_STATIC}).log_set_flush ((0).to_boolean)
			if l_dp.item.dots = 0 then
				(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N%%6sK"), ((create {P_UTILS_STATIC}).number_to_static_string (((l_dp.item.rows).to_integer_64 * l_ROW_BYTES) // {INTEGER_64} 1_024))])
			end
			l_i := l_dp.item.dots
			from
			until
				not (l_i < (create {P_OPTIONS_STATIC}).opt.item.item.dots_in_line)
			loop
				if l_i \\ (create {P_OPTIONS_STATIC}).opt.item.item.dot_spacing = 0 then
					(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (" "))
				end
				(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (" "))
				l_i := l_i + 1
			end
			l_dp.item.print_row_stats (a_dltime, (1).to_boolean);
			(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N%N"));
			(create {P_LOG_STATIC}).log_set_flush ((0).to_boolean)
			free (create {CE_VOID_POINTER}.make_cast (l_dp))
		end

	dot_set_params (a_params: CE_POINTER [INTEGER_8])
		local
			l_params: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_params := a_params
			if l_params.is_void then
				l_params := (create {P_OPTIONS_STATIC}).opt.item.item.dot_style
			elseif not (l_params[0]).to_boolean then
				l_params := (create {P_OPTIONS_STATIC}).opt.item.item.dot_style
			end
			if l_params.is_void then
				l_return := True
			end
			if not l_return then
				if (strcasecmp (l_params, ce_string ("default"))).to_boolean then
					if (strcasecmp (l_params, ce_string ("binary"))).to_boolean then
						if (strcasecmp (l_params, ce_string ("mega"))).to_boolean then
							if (strcasecmp (l_params, ce_string ("giga"))).to_boolean then
								l_tmp := (create {P_QUOTE_STATIC}).quote (l_params)
								fprintf ([(create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("Invalid dot style specification %%s; leaving unchanged.%N"))), l_tmp]).do_nothing
							else
								(create {P_OPTIONS_STATIC}).opt.item.item.dot_bytes := ((1).bit_shift_left (20)).to_integer_64;
								(create {P_OPTIONS_STATIC}).opt.item.item.dot_spacing := 8;
								(create {P_OPTIONS_STATIC}).opt.item.item.dots_in_line := 32
							end
						else
							(create {P_OPTIONS_STATIC}).opt.item.item.dot_bytes := (65_536).to_integer_64;
							(create {P_OPTIONS_STATIC}).opt.item.item.dot_spacing := 8;
							(create {P_OPTIONS_STATIC}).opt.item.item.dots_in_line := 48
						end
					else
						(create {P_OPTIONS_STATIC}).opt.item.item.dot_bytes := (8_192).to_integer_64;
						(create {P_OPTIONS_STATIC}).opt.item.item.dot_spacing := 16;
						(create {P_OPTIONS_STATIC}).opt.item.item.dots_in_line := 48
					end
				else
					(create {P_OPTIONS_STATIC}).opt.item.item.dot_bytes := (1_024).to_integer_64;
					(create {P_OPTIONS_STATIC}).opt.item.item.dot_spacing := 10;
					(create {P_OPTIONS_STATIC}).opt.item.item.dots_in_line := 50
				end
			end
		end

	bar_create (a_initial, a_total: INTEGER_64): CE_POINTER [ANY]
		local
			l_total: INTEGER_64
			l_bp: CE_POINTER [PD_BAR_PROGRESS]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_total := a_total
					l_bp := create {CE_CLASS_POINTER [PD_BAR_PROGRESS]}.make_cast (((create {P_XMALLOC_STATIC}).xcalloc ((1).to_natural_32, (create {PD_BAR_PROGRESS}.make).structure_size.to_natural_32)))
					if a_initial > l_total then
						l_total := a_initial
					end
					l_bp.item.initial_length := a_initial
					l_bp.item.total_length := l_total
					if screen_width.item.to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (received_sigwinch.item.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						screen_width.item := (create {P_UTILS_STATIC}).determine_screen_width
						if not screen_width.item.to_boolean then
							screen_width.item := 80
						elseif screen_width.item < 45 then
							screen_width.item := 45
						end
						received_sigwinch.item := 0
				when 5 then -- if done
					l_bp.item.width := screen_width.item - 1
					l_bp.item.buffer := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((l_bp.item.width + 100).to_natural_32)));
					(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
					l_bp.item.create_image ((0).to_double, (0).to_boolean)
					display_image (l_bp.item.buffer)
					Result := (create {CE_VOID_POINTER}.make_cast (l_bp))
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	bar_update (a_progress: CE_POINTER [ANY]; a_howmuch: INTEGER_64; a_dltime: REAL_64)
		local
			l_bp: CE_POINTER [PD_BAR_PROGRESS]
			l_force_screen_update: BOOLEAN
			l_old_width: INTEGER_32
			l_return: BOOLEAN
		do
			l_bp := create {CE_CLASS_POINTER [PD_BAR_PROGRESS]}.make_cast (a_progress)
			l_force_screen_update := (0).to_boolean
			l_bp.item.count := l_bp.item.count + a_howmuch
			if l_bp.item.total_length > {INTEGER_64} 0 then
				if l_bp.item.count + l_bp.item.initial_length > l_bp.item.total_length then
					l_bp.item.total_length := l_bp.item.initial_length + l_bp.item.count
				end
			end
			l_bp.item.update_speed_ring (a_howmuch, a_dltime)
			if received_sigwinch.item.to_boolean then
				l_old_width := screen_width.item
				screen_width.item := (create {P_UTILS_STATIC}).determine_screen_width
				if not screen_width.item.to_boolean then
					screen_width.item := 80
				elseif screen_width.item < 45 then
					screen_width.item := 45
				end
				if screen_width.item /= l_old_width then
					l_bp.item.width := screen_width.item - 1
					l_bp.item.buffer := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_bp.item.buffer), (l_bp.item.width + 100).to_natural_32)))
					l_force_screen_update := (1).to_boolean
				end
				received_sigwinch.item := 0
			end
			if a_dltime - l_bp.item.last_screen_update < 0.2 then
				if not l_force_screen_update then
					l_return := True
				end
			end
			if not l_return then
				l_bp.item.create_image (a_dltime, (0).to_boolean)
				display_image (l_bp.item.buffer)
				l_bp.item.last_screen_update := a_dltime
			end
		end

	bar_finish (a_progress: CE_POINTER [ANY]; a_dltime: REAL_64)
		local
			l_bp: CE_POINTER [PD_BAR_PROGRESS]
		do
			l_bp := create {CE_CLASS_POINTER [PD_BAR_PROGRESS]}.make_cast (a_progress)
			if l_bp.item.total_length > {INTEGER_64} 0 then
				if l_bp.item.count + l_bp.item.initial_length > l_bp.item.total_length then
					l_bp.item.total_length := l_bp.item.initial_length + l_bp.item.count
				end
			end
			l_bp.item.create_image (a_dltime, (1).to_boolean)
			display_image (l_bp.item.buffer);
			(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N%N"))
			free (create {CE_VOID_POINTER}.make_cast (l_bp.item.buffer))
			free (create {CE_VOID_POINTER}.make_cast (l_bp))
		end

	display_image (a_buf___6: CE_POINTER [INTEGER_8])
		local
			l_old: BOOLEAN
		do
			l_old := ((create {P_LOG_STATIC}).log_set_save_context ((0).to_boolean));
			(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%R"));
			(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, a_buf___6);
			(create {P_LOG_STATIC}).log_set_save_context (l_old).do_nothing
		end

	bar_set_params (a_params: CE_POINTER [INTEGER_8])
		local
			l_term: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_term := (getenv (ce_string ("TERM")))
					if (not a_params.is_void) then
						if 0 = (strcmp (a_params, ce_string ("force"))) then
							current_impl_locked.item := 1
						end
					end
					if ((create {P_OPTIONS_STATIC}).opt.item.item.lfilename).is_void then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 3 then -- else:
						if not ((isatty ((fileno ((create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)))))).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if l_term.is_void then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if 0 /= (strcmp (l_term, ce_string ("emacs"))) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						if not current_impl_locked.item.to_boolean then
							set_progress_implementation (ce_string ("dot"))
							l_return := True
						end
				when 7 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 6 -- goto _L
				when 9 then -- if done
					if not l_return then
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	progress_handle_sigwinch (a_sig: INTEGER_32)
		do
			received_sigwinch.item := 1
			signal (28, progress_handle_sigwinch_address).do_nothing
		end

	eta_to_human_short (a_secs: INTEGER_32; a_condensed: BOOLEAN): CE_POINTER [INTEGER_8]
		local
			l_space: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			if a_condensed then
				l_tmp := ce_string ("")
			else
				l_tmp := ce_string (" ")
			end
			l_space := l_tmp
			if a_secs = last.item then
				Result := buf___2.item
				l_return := True
			end
			if not l_return then
				last.item := a_secs
				if a_secs < 100 then
					sprintf ([buf___2.item, ce_string ("%%ds"), a_secs]).do_nothing
				elseif a_secs < 6_000 then
					sprintf ([buf___2.item, ce_string ("%%dm%%s%%ds"), a_secs // 60, l_space, a_secs \\ 60]).do_nothing
				elseif a_secs < 172_800 then
					sprintf ([buf___2.item, ce_string ("%%dh%%s%%dm"), a_secs // 3_600, l_space, (a_secs // 60) \\ 60]).do_nothing
				elseif a_secs < 8_640_000 then
					sprintf ([buf___2.item, ce_string ("%%dd%%s%%dh"), a_secs // 86_400, l_space, (a_secs // 3_600) \\ 24]).do_nothing
				else
					sprintf ([buf___2.item, ce_string ("%%dd"), a_secs // 86_400]).do_nothing
				end
				Result := buf___2.item
			end
		end

feature {ANY} -- routine addresses

	dot_create_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent dot_create)
		end

	dot_update_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent dot_update)
		end

	dot_finish_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent dot_finish)
		end

	dot_set_params_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent dot_set_params)
		end

	bar_create_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent bar_create)
		end

	bar_update_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent bar_update)
		end

	bar_finish_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent bar_finish)
		end

	bar_set_params_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent bar_set_params)
		end

	progress_handle_sigwinch_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent progress_handle_sigwinch)
		end

end
