class
	P_RES_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public attributes

	registered_specs: CE_STATIC [CE_POINTER [PD_HASH_TABLE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make
		end

feature {ANY} -- public routines

	is_robots_txt_url (a_url: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_robots_url: CE_POINTER [INTEGER_8]
			l_ret: BOOLEAN
		do
			l_robots_url := ((create {P_URL_STATIC}).uri_merge (a_url, ce_string ("/robots.txt")))
			l_ret := ((create {P_URL_STATIC}).are_urls_equal (a_url, l_robots_url))
			free (create {CE_VOID_POINTER}.make_cast (l_robots_url))
			Result := l_ret
		end

	res_cleanup
		local
			l_iter: CE_ARRAY [PD_HASH_TABLE_ITERATOR]
			l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_HASH_TABLE_ITERATOR]} l_iter.make (<<1>>)

			if (not registered_specs.item.is_void) then
				registered_specs.item.item.hash_table_iterate (l_iter)
				from
				until
					(l_break)
				loop
					l_break := False
					if not (l_iter.item.hash_table_iter_next).to_boolean then
						l_break := True
					end
					if not (l_break) then
						free (l_iter.item.key);
						(create {CE_CLASS_POINTER [PD_ROBOT_SPECS]}.make_cast (l_iter.item.value)).item.free_specs
					end
				end
				l_break := False
				registered_specs.item.item.hash_table_destroy
				registered_specs.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make_shared (default_pointer)
			end
		end

end
