class
	P_UTILS_STATIC

inherit
	CE_UTILITIES
	S_LIBINTL_STATIC
	S_STDLIB_STATIC
	S_STRING_STATIC
	S_STDIO_STATIC
	S_BITS_ERRNO_STATIC
	S_TIME_STATIC
	S_UNISTD_STATIC
	S_UTIME_STATIC
	S_SYS_STAT_STATIC
	S_FCNTL_STATIC
	S_FNMATCH_STATIC
	S_SYS_MMAN_STATIC
	S_SYS_IOCTL_STATIC
	S_ASSERT_STATIC
	S_SYS_TIME_STATIC
	S_SIGNAL_STATIC

feature {ANY} -- public attributes

	output: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<32>>)
		end

	powers: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("KMGTPE")
		end

	buf___3: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<8>>)
		end

	ring___0: CE_STATIC [CE_ARRAY [CE_ARRAY [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_ARRAY_ARRAY [INTEGER_8]}.make (<<3, 24>>)
		end

	ringpos___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	rnd_seeded: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	run_with_timeout_env: CE_STATIC [CE_EXCEPTION]
		once ("PROCESS")
		end

	base64_char_to_value: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make_initialized (<<
					(-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8,
					(-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8,
					(-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8,
					(-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8,
					(-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8,
					(-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8,
					(-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8,
					(-1).to_integer_8, 62, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, 63, 52, 53, 54, 55,
					56, 57, 58, 59, 60, 61, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8,
					(-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12,
					13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, (-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8,
					(-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35,
					36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, (-1).to_integer_8, (-1).to_integer_8,
					(-1).to_integer_8, (-1).to_integer_8, (-1).to_integer_8
				>>)
		end

	buf___4: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<32>>)
		end

feature {ANY} -- public routines

	memfatal (a_context: CE_POINTER [INTEGER_8]; a_attempted_size: INTEGER_32)
		do
			(create {P_LOG_STATIC}).log_set_save_context ((0).to_boolean).do_nothing
			if a_attempted_size = -3 then
				(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_ALWAYS, (gettext (ce_string ("%%s: %%s: Failed to allocate enough memory; memory exhausted.%N"))), (create {P_WGET_STATIC}).exec_name.item, a_context])
			else
				(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_ALWAYS, (gettext (ce_string ("%%s: %%s: Failed to allocate %%ld bytes; memory exhausted.%N"))), (create {P_WGET_STATIC}).exec_name.item, a_context, a_attempted_size])
			end
			exit (1)
		end

	strdupdelim (a_beg, a_end: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_res___0: CE_POINTER [INTEGER_8]
		do
			l_res___0 := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc (((a_end.distance (a_beg)) + 1).to_natural_32)))
			memcpy (create {CE_VOID_POINTER}.make_cast (l_res___0), create {CE_VOID_POINTER}.make_cast (a_beg), (a_end.distance (a_beg)).to_natural_32).do_nothing
			l_res___0[(a_end.distance (a_beg))] := (('%/0/').code).to_integer_8
			Result := l_res___0
		end

	sepstring (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [CE_POINTER [INTEGER_8]]
		local
			l_s: CE_POINTER [INTEGER_8]
			l_res___0: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_p___0: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_s := a_s
			l_i := 0
			if l_s.is_void then
				Result := (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer))
				l_return := True
			elseif not (l_s[0]).to_boolean then
				Result := (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_res___0 := create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_p___0 := l_s
				from
				until
					not (not (l_return) and then ((l_s[0]).to_boolean))
				loop
					if (l_s[0]).to_integer_32 = 44 then
						l_res___0 := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_res___0), (l_i + 2).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
						l_res___0[l_i] := strdupdelim (l_p___0, l_s)
						l_i := l_i + 1
						l_res___0[l_i] := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						l_s := l_s + 1
						from
						until
							(l_break)
						loop
							l_break := False
							if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_s[0]).to_integer_32)) then
								l_break := True
							end
							if not (l_break) then
								l_s := l_s + 1
							end
						end
						l_break := False
						l_p___0 := l_s
					else
						l_s := l_s + 1
					end
				end
				l_res___0 := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_res___0), (l_i + 2).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
				l_res___0[l_i] := strdupdelim (l_p___0, l_s)
				l_res___0[(l_i + 1)] := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				Result := l_res___0
			end
		end

	aprintf (a_args: TUPLE [a_fmt: CE_POINTER [INTEGER_8]]): CE_POINTER [INTEGER_8]
		local
			l_ret: INTEGER_32
			l_args: CE_VA_LIST
			l_str: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create l_args.make_shared (default_pointer)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_str.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_args := create {CE_VA_LIST}.make (a_args, agent aprintf)
					l_ret := vasprintf (l_str, a_args.a_fmt, l_args.twin)
					if not (l_ret < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (errno_location).item = 12 then
							memfatal (ce_string ("aprintf"), -3)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if l_ret < 0 then
							Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
				when 4 then
					if not l_return then
						Result := (l_str.item)
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	concat_strings (a_args: TUPLE [a_str0: CE_POINTER [INTEGER_8]]): CE_POINTER [INTEGER_8]
		local
			l_args: CE_VA_LIST
			l_saved_lengths: CE_ARRAY [INTEGER_32]
			l_ret: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_next_str: CE_POINTER [INTEGER_8]
			l_total_length: INTEGER_32
			l_argcount: NATURAL_32
			l_len: INTEGER_32
			l_tmp___0: NATURAL_32
			l_len___0: INTEGER_32
			l_tmp___2: NATURAL_32
		do
			create l_args.make_shared (default_pointer)
			create {CE_INTEGER_32_ARRAY} l_saved_lengths.make (<<5>>)

			l_total_length := 0
			l_argcount := (0).to_natural_32
			l_args := create {CE_VA_LIST}.make (a_args, agent concat_strings)
			l_next_str := a_args.a_str0
			from
			until
				l_next_str.is_void
			loop
				l_len := (strlen (l_next_str)).to_integer_32
				if l_argcount < ({PLATFORM}.Integer_32_bytes.to_natural_32 * (5).to_natural_32) // {PLATFORM}.Integer_32_bytes.to_natural_32 then
					l_tmp___0 := l_argcount
					l_argcount := l_argcount + 1
					l_saved_lengths[l_tmp___0.to_integer_32] := l_len
				end
				l_total_length := l_total_length + l_len
				l_next_str := (create {CE_INTEGER_8_POINTER}.make_cast (l_args.pointer_item))
			end
			l_ret := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((l_total_length + 1).to_natural_32)))
			l_p___0 := l_ret
			l_argcount := (0).to_natural_32
			l_args := create {CE_VA_LIST}.make (a_args, agent concat_strings)
			l_next_str := a_args.a_str0
			from
			until
				l_next_str.is_void
			loop
				if l_argcount < ({PLATFORM}.Integer_32_bytes.to_natural_32 * (5).to_natural_32) // {PLATFORM}.Integer_32_bytes.to_natural_32 then
					l_tmp___2 := l_argcount
					l_argcount := l_argcount + 1
					l_len___0 := l_saved_lengths[l_tmp___2.to_integer_32]
				else
					l_len___0 := (strlen (l_next_str)).to_integer_32
				end
				memcpy (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_next_str), l_len___0.to_natural_32).do_nothing
				l_p___0 := l_p___0 + l_len___0
				l_next_str := (create {CE_INTEGER_8_POINTER}.make_cast (l_args.pointer_item))
			end
			l_p___0[0] := (('%/0/').code).to_integer_8
			Result := l_ret
		end

	fmttime (a_t: INTEGER_32; a_fmt: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_t: CE_ARRAY [INTEGER_32]
			l_tm: CE_POINTER [SD_TM]
		do
			create {CE_INTEGER_32_ARRAY} l_t.make (<<1>>)

			l_t.item := a_t
			l_tm := (localtime (l_t))
			if l_tm.is_void then
				abort
			end
			if not (strftime (output.item, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (32).to_natural_32), a_fmt, l_tm)).to_boolean then
				abort
			end
			Result := output.item
		end

	time_str (a_t: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			Result := (fmttime (a_t, ce_string ("%%H:%%M:%%S")))
		end

	datetime_str (a_t: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			Result := (fmttime (a_t, ce_string ("%%Y-%%m-%%d %%H:%%M:%%S")))
		end

	fork_to_background
		local
			l_pid: INTEGER_32
			l_logfile_changed: BOOLEAN
			l_new_log_fp: CE_POINTER [SD_IO_FILE]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_logfile_changed := (0).to_boolean
					if (not ((create {P_OPTIONS_STATIC}).opt.item.item.lfilename).is_void) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if (create {P_OPTIONS_STATIC}).opt.item.item.quiet then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.server_response) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_new_log_fp := (unique_create (ce_string ("wget-log"), (0).to_boolean, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared ((create {P_OPTIONS_STATIC}).opt.item.item.c_pointer + (create {PD_OPTIONS}.make).offset_of ("lfilename"))))
						if (not l_new_log_fp.is_void) then
							l_logfile_changed := (1).to_boolean
							fclose (l_new_log_fp).do_nothing
						end
				when 6 then -- if done | if done
					l_pid := fork
					if l_pid < 0 then
						perror (ce_string ("fork"))
						exit (1)
					elseif l_pid /= 0 then
						printf ([(gettext (ce_string ("Continuing in background, pid %%d.%N"))), l_pid]).do_nothing
						if l_logfile_changed then
							l_tmp___1 := (create {P_QUOTE_STATIC}).quote ((create {P_OPTIONS_STATIC}).opt.item.item.lfilename)
							printf ([(gettext (ce_string ("Output will be written to %%s.%N"))), l_tmp___1]).do_nothing
						end
						exit (0)
					end
					setsid.do_nothing
					freopen (ce_string ("/dev/null"), ce_string ("r"), (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer))).do_nothing
					freopen (ce_string ("/dev/null"), ce_string ("w"), (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
					freopen (ce_string ("/dev/null"), ce_string ("w"), (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))).do_nothing
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	touch (a_file: CE_POINTER [INTEGER_8]; a_tm: INTEGER_32)
		require
			not a_file.is_void
		local
			l_times: CE_ARRAY [SD_UTIMBUF]
		do
			create {CE_CLASS_ARRAY [SD_UTIMBUF]} l_times.make (<<1>>)

			l_times.item.modtime := a_tm
			l_times.item.actime := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
			if (utime (a_file, l_times)) = -1 then
				(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("utime(%%s): %%s%N"), a_file, (strerror ((errno_location).item))])
			end
		end

	file_exists_p (a_filename: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_filename.is_void
		local
			l_buf___6: CE_ARRAY [SD_STAT]
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_buf___6.make (<<1>>)

			Result := ((stat (a_filename, l_buf___6)) >= 0)
		end

	unique_name_1 (a_prefix: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_prefix.is_void
		local
			l_count: INTEGER_32
			l_plen: INTEGER_32
			l_template: CE_POINTER [INTEGER_8]
			l_template_tail: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_32
			l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			l_count := 1
			l_plen := (strlen (a_prefix)).to_integer_32
			l_template := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new (((l_plen + 1) + 24).to_natural_32)))
			l_template_tail := l_template + l_plen
			memcpy (create {CE_VOID_POINTER}.make_cast (l_template), create {CE_VOID_POINTER}.make_cast (a_prefix), l_plen.to_natural_32).do_nothing
			l_tmp___1 := l_template_tail
			l_template_tail := l_template_tail + 1
			l_tmp___1[0] := (('.').code).to_integer_8
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp___2 := l_count
				l_count := l_count + 1
				number_to_string (l_template_tail, l_tmp___2.to_integer_64).do_nothing
				if not (file_exists_p (l_template)) then
					l_break := True
				end
			end
			l_break := False
			Result := ((create {P_XMALLOC_STATIC}).xstrdup (l_template))
		end

	unique_name (a_file: CE_POINTER [INTEGER_8]; a_allow_passthrough: BOOLEAN): CE_POINTER [INTEGER_8]
		require
			not a_file.is_void
		local
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			if not (file_exists_p (a_file)) then
				if a_allow_passthrough then
					l_tmp___0 := a_file
				else
					l_tmp___0 := ((create {P_XMALLOC_STATIC}).xstrdup (a_file))
				end
				Result := l_tmp___0
				l_return := True
			end
			if not l_return then
				Result := (unique_name_1 (a_file))
			end
		end

	unique_create (a_name: CE_POINTER [INTEGER_8]; a_binary: BOOLEAN; a_opened_name: CE_POINTER [CE_POINTER [INTEGER_8]]): CE_POINTER [SD_IO_FILE]
		require
			not a_name.is_void
		local
			l_uname: CE_POINTER [INTEGER_8]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_break: BOOLEAN
		do
			l_uname := (unique_name (a_name, (0).to_boolean))
			from
			until
				(l_break)
			loop
				l_break := False
				l_fp := fopen_excl (l_uname, a_binary.to_integer)
				if l_fp.is_void then
					if (errno_location).item /= 17 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					free (create {CE_VOID_POINTER}.make_cast (l_uname))
					l_uname := unique_name (a_name, (0).to_boolean)
				end
			end
			l_break := False
			if (not a_opened_name.is_void) then
				if not l_fp.is_void then
					if (not l_fp.is_void) then
						a_opened_name.item := l_uname
					else
						a_opened_name.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						free (create {CE_VOID_POINTER}.make_cast (l_uname))
					end
				else
					free (create {CE_VOID_POINTER}.make_cast (l_uname))
				end
			else
				free (create {CE_VOID_POINTER}.make_cast (l_uname))
			end
			Result := l_fp
		end

	fopen_excl (a_fname: CE_POINTER [INTEGER_8]; a_binary: INTEGER_32): CE_POINTER [SD_IO_FILE]
		local
			l_fd: INTEGER_32
			l_flags: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_flags := 193
			l_fd := open ([a_fname, l_flags, 438])
			if l_fd < 0 then
				Result := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				if a_binary.to_boolean then
					l_tmp := ce_string ("wb")
				else
					l_tmp := ce_string ("w")
				end
				Result := (fdopen (l_fd, l_tmp))
			end
		end

	fnmatch_nocase (a_pattern, a_string: CE_POINTER [INTEGER_8]; a_flags: INTEGER_32): INTEGER_32
		do
			Result := (fnmatch (a_pattern, a_string, (a_flags).bit_or (((1).bit_shift_left (4)))))
		end

	acceptable (a_s: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_s.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_l: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_s := a_s
			l_l := (strlen (l_s)).to_integer_32
			from
			until
				(l_break)
			loop
				l_break := False
				if l_l.to_boolean then
					if (l_s[l_l]).to_integer_32 = 47 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_l := l_l - 1
				end
			end
			l_break := False
			if (l_s[l_l]).to_integer_32 = 47 then
				l_s := l_s + (l_l + 1)
			end
			if (not ((create {P_OPTIONS_STATIC}).opt.item.item.accepts).is_void) then
				if (not ((create {P_OPTIONS_STATIC}).opt.item.item.rejects).is_void) then
					if (in_acclist ((create {P_OPTIONS_STATIC}).opt.item.item.accepts, l_s, (1).to_boolean)) then
						if (in_acclist ((create {P_OPTIONS_STATIC}).opt.item.item.rejects, l_s, (1).to_boolean)) then
							l_tmp___2 := 0
						else
							l_tmp___2 := 1
						end
					else
						l_tmp___2 := 0
					end
					Result := l_tmp___2.to_boolean
					l_return := True
				else
					Result := (in_acclist ((create {P_OPTIONS_STATIC}).opt.item.item.accepts, l_s, (1).to_boolean))
					l_return := True
				end
			elseif (not ((create {P_OPTIONS_STATIC}).opt.item.item.rejects).is_void) then
				if (in_acclist ((create {P_OPTIONS_STATIC}).opt.item.item.rejects, l_s, (1).to_boolean)) then
					l_tmp___5 := 0
				else
					l_tmp___5 := 1
				end
				Result := l_tmp___5.to_boolean
				l_return := True
			end
			if not l_return then
				Result := (1).to_boolean
			end
		end

	subdir_p (a_d1, a_d2: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_d1.is_void
		local
			l_d1: CE_POINTER [INTEGER_8]
			l_d2: CE_POINTER [INTEGER_8]
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_d1 := a_d1
			l_d2 := a_d2
			if (l_d1[0]).to_integer_32 = 0 then
				Result := (1).to_boolean
				l_return := True
			end
			if not l_return then
				if not (create {P_OPTIONS_STATIC}).opt.item.item.ignore_case then
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_d1[0]).to_boolean then
							if (l_d2[0]).to_boolean then
								if (l_d1[0]).to_integer_32 /= (l_d2[0]).to_integer_32 then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_d1 := l_d1 + 1
							l_d2 := l_d2 + 1
						end
					end
					l_break := False
				else
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_d1[0]).to_boolean then
							if (l_d2[0]).to_boolean then
								l_tmp := (create {P_C_CTYPE_STATIC}).c2_tolower ((l_d1[0]).to_integer_32)
								if l_tmp /= ((create {P_C_CTYPE_STATIC}).c2_tolower ((l_d2[0]).to_integer_32)) then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_d1 := l_d1 + 1
							l_d2 := l_d2 + 1
						end
					end
					l_break := False
				end
				if (l_d1[0]).to_integer_32 = 0 then
					if (l_d2[0]).to_integer_32 = 0 then
						l_tmp___1 := 1
					elseif (l_d2[0]).to_integer_32 = 47 then
						l_tmp___1 := 1
					else
						l_tmp___1 := 0
					end
				else
					l_tmp___1 := 0
				end
				Result := l_tmp___1.to_boolean
			end
		end

	dir_matches_p (a_dirlist: CE_POINTER [CE_POINTER [INTEGER_8]]; a_dir: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_dirlist.is_void
		local
			l_x: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_matcher: CE_ROUTINE
			l_tmp: CE_ROUTINE
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___3: INTEGER_32
			l_break: BOOLEAN
		do
			if (create {P_OPTIONS_STATIC}).opt.item.item.ignore_case then
				l_tmp := fnmatch_nocase_address
			else
				l_tmp := fnmatch_address
			end
			l_matcher := l_tmp
			l_x := a_dirlist
			from
			until
				not (not (l_break) and then (not (l_x.item).is_void))
			loop
				l_break := False
				l_p___0 := l_x.item + (((l_x.item).item).to_integer_32 = 47).to_integer
				if (has_wildcards_p (l_p___0)) then
					if (l_matcher.integer_32_item ([l_p___0, a_dir, 1])) = 0 then
						l_break := True
					end
				elseif (subdir_p (l_p___0, a_dir)) then
					l_break := True
				end
				if not (l_break) then
					l_x := l_x + 1
				end
			end
			l_break := False
			if (not (l_x.item).is_void) then
				l_tmp___3 := 1
			else
				l_tmp___3 := 0
			end
			Result := l_tmp___3.to_boolean
		end

	accdir (a_directory: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_directory.is_void
		local
			l_directory: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_directory := a_directory
			if (l_directory[0]).to_integer_32 = 47 then
				l_directory := l_directory + 1
			end
			if (not ((create {P_OPTIONS_STATIC}).opt.item.item.includes).is_void) then
				if not (dir_matches_p ((create {P_OPTIONS_STATIC}).opt.item.item.includes, l_directory)) then
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return and then (not ((create {P_OPTIONS_STATIC}).opt.item.item.excludes).is_void) then
				if (dir_matches_p ((create {P_OPTIONS_STATIC}).opt.item.item.excludes, l_directory)) then
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return then
				Result := (1).to_boolean
			end
		end

	match_tail (a_string, a_tail: CE_POINTER [INTEGER_8]; a_fold_case: BOOLEAN): BOOLEAN
		require
			not a_string.is_void
			not a_tail.is_void
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_tmp___3: INTEGER_32
			l_break: BOOLEAN
		do
			if not a_fold_case then
				l_i := (strlen (a_string)).to_integer_32
				l_j := (strlen (a_tail)).to_integer_32
				from
				until
					(l_break)
				loop
					l_break := False
					if l_i >= 0 then
						if not (l_j >= 0) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) and then ((a_string[l_i]).to_integer_32 /= (a_tail[l_j]).to_integer_32) then
						l_break := True
					end
					if not (l_break) then
						l_i := l_i - 1
						l_j := l_j - 1
					end
				end
				l_break := False
			else
				l_i := (strlen (a_string)).to_integer_32
				l_j := (strlen (a_tail)).to_integer_32
				from
				until
					(l_break)
				loop
					l_break := False
					if l_i >= 0 then
						if not (l_j >= 0) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_tmp___3 := (create {P_C_CTYPE_STATIC}).c2_tolower ((a_string[l_i]).to_integer_32)
						if l_tmp___3 /= ((create {P_C_CTYPE_STATIC}).c2_tolower ((a_tail[l_j]).to_integer_32)) then
							l_break := True
						end
					end
					if not (l_break) then
						l_i := l_i - 1
						l_j := l_j - 1
					end
				end
				l_break := False
			end
			if l_j = -1 then
				Result := (1).to_boolean
			else
				Result := (0).to_boolean
			end
		end

	in_acclist (a_accepts: CE_POINTER [CE_POINTER [INTEGER_8]]; a_s: CE_POINTER [INTEGER_8]; a_backward: BOOLEAN): BOOLEAN
		require
			not a_accepts.is_void
		local
			l_accepts: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_res___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_cmp: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return: BOOLEAN
		do
			l_accepts := a_accepts
			from
			until
				not (not (l_return) and then (not (l_accepts.item).is_void))
			loop
				if (has_wildcards_p (l_accepts.item)) then
					if (create {P_OPTIONS_STATIC}).opt.item.item.ignore_case then
						l_tmp___1 := (fnmatch_nocase (l_accepts.item, a_s, 0))
					else
						l_tmp___1 := (fnmatch (l_accepts.item, a_s, 0))
					end
					l_res___0 := l_tmp___1
					if l_res___0 = 0 then
						Result := (1).to_boolean
						l_return := True
					end
				elseif a_backward then
					if (match_tail (a_s, l_accepts.item, (create {P_OPTIONS_STATIC}).opt.item.item.ignore_case)) then
						Result := (1).to_boolean
						l_return := True
					end
				else
					if (create {P_OPTIONS_STATIC}).opt.item.item.ignore_case then
						l_tmp___5 := (strcasecmp (a_s, l_accepts.item))
					else
						l_tmp___5 := (strcmp (a_s, l_accepts.item))
					end
					l_cmp := l_tmp___5
					if l_cmp = 0 then
						Result := (1).to_boolean
						l_return := True
					end
				end
				if not l_return then
					l_accepts := l_accepts + 1
				end
			end
			if not l_return then
				Result := (0).to_boolean
			end
		end

	suffix (a_str: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_str.is_void
		local
			l_i: INTEGER_32
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_i := (strlen (a_str)).to_integer_32
			from
			until
				(l_break)
			loop
				l_break := False
				if l_i.to_boolean then
					if (a_str[l_i]).to_integer_32 /= 47 then
						if (a_str[l_i]).to_integer_32 = 46 then
							l_break := True
						end
					else
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_i := l_i - 1
				end
			end
			l_break := False
			l_tmp___0 := l_i
			l_i := l_i + 1
			if (a_str[l_tmp___0]).to_integer_32 = 46 then
				Result := (a_str + l_i)
			else
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
			end
		end

	has_wildcards_p (a_s: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_s.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_s := a_s
			from
			until
				not (not (l_return) and then ((l_s[0]).to_boolean))
			loop
				if (l_s[0]).to_integer_32 = 42 then
					Result := (1).to_boolean
					l_return := True
				elseif (l_s[0]).to_integer_32 = 63 then
					Result := (1).to_boolean
					l_return := True
				elseif (l_s[0]).to_integer_32 = 91 then
					Result := (1).to_boolean
					l_return := True
				elseif (l_s[0]).to_integer_32 = 93 then
					Result := (1).to_boolean
					l_return := True
				end
				if not l_return then
					l_s := l_s + 1
				end
			end
			if not l_return then
				Result := (0).to_boolean
			end
		end

	has_html_suffix_p (a_fname: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_fname.is_void
		local
			l_suf: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_suf := suffix (a_fname)
			if l_suf.is_void then
				Result := (0).to_boolean
				l_return := True
			end
			if not l_return then
				if not (strcasecmp (l_suf, ce_string ("html"))).to_boolean then
					Result := (1).to_boolean
					l_return := True
				end
			end
			if not l_return then
				if not (strcasecmp (l_suf, ce_string ("htm"))).to_boolean then
					Result := (1).to_boolean
					l_return := True
				end
			end
			if not l_return and then ((l_suf[0]).to_boolean) then
				if not (strcasecmp ((l_suf + 1), ce_string ("html"))).to_boolean then
					Result := (1).to_boolean
					l_return := True
				end
			end
			if not l_return then
				Result := (0).to_boolean
			end
		end

	read_whole_line (a_fp: CE_POINTER [SD_IO_FILE]): CE_POINTER [INTEGER_8]
		local
			l_length: INTEGER_32
			l_bufsize___0: INTEGER_32
			l_line: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
		do
			l_length := 0
			l_bufsize___0 := 82
			l_line := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc (l_bufsize___0.to_natural_32)))
			from
			until
				(l_break)
			loop
				l_break := False
				l_continue := False
				if (fgets ((l_line + l_length), l_bufsize___0 - l_length, a_fp)).is_void then
					l_break := True
				end
				if not (l_break or l_continue) then
					l_length := (l_length.to_natural_32 + (strlen ((l_line + l_length)))).to_integer_32
					if l_length = 0 then
						l_continue := True
					end
				end
				if not (l_break or l_continue) and then ((l_line[(l_length - 1)]).to_integer_32 = 10) then
					l_break := True
				end
				if not (l_break or l_continue) then
					l_bufsize___0 := (l_bufsize___0).bit_shift_left ((1))
					l_line := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_line), l_bufsize___0.to_natural_32)))
				end
			end
			l_break := False
			l_continue := False
			if l_length = 0 then
				free (create {CE_VOID_POINTER}.make_cast (l_line))
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
				l_return := True
			elseif (ferror (a_fp)).to_boolean then
				free (create {CE_VOID_POINTER}.make_cast (l_line))
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				if l_length + 1 < l_bufsize___0 then
					l_line := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_line), (l_length + 1).to_natural_32)))
				end
				Result := l_line
			end
		end

	read_file (a_file: CE_POINTER [INTEGER_8]): CE_POINTER [PD_FILE_MEMORY]
		require
			not a_file.is_void
		local
			l_fd: INTEGER_32
			l_fm: CE_POINTER [PD_FILE_MEMORY]
			l_size: INTEGER_32
			l_inhibit_close: BOOLEAN
			l_buf___6: CE_ARRAY [SD_STAT]
			l_nread: INTEGER_64
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [PD_FILE_MEMORY]} l_fm.make
			create {CE_CLASS_ARRAY [SD_STAT]} l_buf___6.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_inhibit_close := (0).to_boolean
					if (a_file[0]).to_integer_32 = 45 then
						if not (a_file[1]).to_boolean then
							l_fd := fileno ((create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer)))
							l_inhibit_close := (1).to_boolean
						else
							l_fd := open ([a_file, 0])
						end
					else
						l_fd := open ([a_file, 0])
					end
					if l_fd < 0 then
						Result := (create {CE_CLASS_POINTER [PD_FILE_MEMORY]}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						l_fm := create {CE_CLASS_POINTER [PD_FILE_MEMORY]}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((create {PD_FILE_MEMORY}.make).structure_size.to_natural_32)))
						if (fstat (l_fd, l_buf___6)) < 0 then
							l_pos := -1 + 5 -- goto mmap_lose
						end
				when 2 then
						l_fm.item.length := l_buf___6.item.st_size
						l_fm.item.content := create {CE_INTEGER_8_POINTER}.make_cast ((mmap (create {CE_VOID_POINTER}.make_shared (default_pointer), (l_fm.item.length).to_natural_32, 3, 2, l_fd, (0).to_integer_32)))
						if ((l_fm.item.content).c_pointer.to_integer_32).to_natural_32 = ((create {CE_INTEGER_8_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 5 -- goto mmap_lose
						end
				when 3 then
						if not l_inhibit_close then
							close (l_fd).do_nothing
						end
						l_fm.item.mmap_p := 1
						Result := l_fm
						l_return := True
				when 4 then -- if done
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 5 then -- if: | mmap_lose:
						l_fm.item.length := 0
						l_size := 512
						l_fm.item.content := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc (l_size.to_natural_32)))
				when 6 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 9 -- skip loop
						end
				when 7 then -- loop body:
						l_break := False
						if l_fm.item.length > l_size // 2 then
							l_size := (l_size).bit_shift_left ((1))
							l_fm.item.content := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_fm.item.content), l_size.to_natural_32)))
						end
						l_nread := (read (l_fd, create {CE_VOID_POINTER}.make_cast ((l_fm.item.content + l_fm.item.length)), (l_size - l_fm.item.length).to_natural_32)).to_integer_64
						if l_nread > {INTEGER_64} 0 then
							l_fm.item.length := ((l_fm.item.length).to_integer_64 + l_nread).to_integer_32
						elseif l_nread < {INTEGER_64} 0 then
							l_pos := -1 + 11 -- goto lose
						else
							l_break := True
						end
				when 8 then
						l_pos := -1 + 6 -- back to loop condition
				when 9 then -- loop done
						l_break := False
						if not l_inhibit_close then
							close (l_fd).do_nothing
						end
						if l_size > l_fm.item.length then
							if l_fm.item.length /= 0 then
								l_fm.item.content := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_fm.item.content), (l_fm.item.length).to_natural_32)))
							end
						end
						l_fm.item.mmap_p := 0
						Result := l_fm
						l_return := True
				when 10 then -- if done
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 11 then -- if: | lose:
						if not l_inhibit_close then
							close (l_fd).do_nothing
						end
						free (create {CE_VOID_POINTER}.make_cast (l_fm.item.content))
						free (create {CE_VOID_POINTER}.make_cast (l_fm))
						Result := (create {CE_CLASS_POINTER [PD_FILE_MEMORY]}.make_shared (default_pointer))
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	free_vec (a_vec: CE_POINTER [CE_POINTER [INTEGER_8]])
		local
			l_p___0: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_tmp: CE_POINTER [CE_POINTER [INTEGER_8]]
		do
			if (not a_vec.is_void) then
				l_p___0 := a_vec
				from
				until
					(l_p___0.item).is_void
				loop
					l_tmp := l_p___0
					l_p___0 := l_p___0 + 1
					free (create {CE_VOID_POINTER}.make_cast (l_tmp.item))
				end
				free (create {CE_VOID_POINTER}.make_cast (a_vec))
			end
		end

	merge_vecs (a_v1___0, a_v2___0: CE_POINTER [CE_POINTER [INTEGER_8]]): CE_POINTER [CE_POINTER [INTEGER_8]]
		local
			l_v1___0: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_return: BOOLEAN
		do
			l_v1___0 := a_v1___0
			if l_v1___0.is_void then
				Result := a_v2___0
				l_return := True
			end
			if not l_return and then (a_v2___0.is_void) then
				Result := l_v1___0
				l_return := True
			end
			if not l_return and then ((a_v2___0.item).is_void) then
				free (create {CE_VOID_POINTER}.make_cast (a_v2___0))
				Result := l_v1___0
				l_return := True
			end
			if not l_return then
				l_i := 0
				from
				until
					(l_v1___0[l_i]).is_void
				loop
					l_i := l_i + 1
				end
				l_j := 0
				from
				until
					(a_v2___0[l_j]).is_void
				loop
					l_j := l_j + 1
				end
				l_v1___0 := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_v1___0), ((l_i + l_j) + 1).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
				memcpy (create {CE_VOID_POINTER}.make_cast ((l_v1___0 + l_i)), create {CE_VOID_POINTER}.make_cast (a_v2___0), (l_j + 1).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32).do_nothing
				free (create {CE_VOID_POINTER}.make_cast (a_v2___0))
				Result := l_v1___0
			end
		end

	vec_append (a_vec: CE_POINTER [CE_POINTER [INTEGER_8]]; a_str: CE_POINTER [INTEGER_8]): CE_POINTER [CE_POINTER [INTEGER_8]]
		local
			l_vec: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_cnt: INTEGER_32
		do
			l_vec := a_vec
			if not l_vec.is_void then
				l_cnt := 0
				from
				until
					(l_vec[l_cnt]).is_void
				loop
					l_cnt := l_cnt + 1
				end
				l_cnt := l_cnt + 1
			else
				l_cnt := 1
			end
			l_vec := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_vec), (l_cnt + 1).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
			l_vec[(l_cnt - 1)] := (create {P_XMALLOC_STATIC}).xstrdup (a_str)
			l_vec[l_cnt] := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			Result := l_vec
		end

	human_readable (a_n: INTEGER_64): CE_POINTER [INTEGER_8]
		local
			l_n: INTEGER_64
			l_i: NATURAL_32
			l_val: REAL_64
			l_tmp: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := a_n
					if l_n < {INTEGER_64} 1_024 then
						snprintf ([buf___3.item, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8).to_natural_32), ce_string ("%%d"), l_n.to_integer_32]).do_nothing
						Result := buf___3.item
						l_return := True
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_i := (0).to_natural_32
				when 2 then -- loop condition:
						if not (not (l_return) and then (l_i < ({PLATFORM}.Integer_8_bytes.to_natural_32 * (6).to_natural_32) // {PLATFORM}.Integer_8_bytes.to_natural_32)) then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						if not (l_n // {INTEGER_64} 1_024 < {INTEGER_64} 1_024) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if l_i /= ({PLATFORM}.Integer_8_bytes.to_natural_32 * (6).to_natural_32) // {PLATFORM}.Integer_8_bytes.to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_val := l_n.to_double / 1024.0
						if l_val < (10).to_double then
							l_tmp := 1
						else
							l_tmp := 0
						end
						snprintf ([buf___3.item, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8).to_natural_32), ce_string ("%%.*f%%c"), l_tmp, l_val, (powers.item[l_i.to_integer_32]).to_integer_32]).do_nothing
						Result := buf___3.item
						l_return := True
				when 8 then -- if done
						if not l_return then
							l_n := l_n // ({INTEGER_64} 1_024)
							l_i := l_i + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done | if done
					if not l_return then
						Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	numdigit (a_number: INTEGER_64): INTEGER_32
		local
			l_number: INTEGER_64
			l_cnt: INTEGER_32
			l_break: BOOLEAN
		do
			l_number := a_number
			l_cnt := 1
			if l_number < {INTEGER_64} 0 then
				l_cnt := l_cnt + 1
			end
			from
			until
				(l_break)
			loop
				l_break := False
				l_number := l_number // ({INTEGER_64} 10)
				if l_number = {INTEGER_64} 0 then
					l_break := True
				end
				if not (l_break) then
					l_cnt := l_cnt + 1
				end
			end
			l_break := False
			Result := l_cnt
		end

	number_to_string (a_buffer___0: CE_POINTER [INTEGER_8]; a_number: INTEGER_64): CE_POINTER [INTEGER_8]
		require
			not a_buffer___0.is_void
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_n: INTEGER_64
			l_last_digit_char: INTEGER_32
			l_last_digit: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_tmp___18: CE_POINTER [INTEGER_8]
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___20: CE_POINTER [INTEGER_8]
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_tmp___22: CE_POINTER [INTEGER_8]
			l_tmp___23: CE_POINTER [INTEGER_8]
			l_tmp___24: CE_POINTER [INTEGER_8]
			l_tmp___25: CE_POINTER [INTEGER_8]
			l_tmp___26: CE_POINTER [INTEGER_8]
			l_tmp___27: CE_POINTER [INTEGER_8]
			l_tmp___28: CE_POINTER [INTEGER_8]
			l_tmp___29: CE_POINTER [INTEGER_8]
			l_tmp___30: CE_POINTER [INTEGER_8]
			l_tmp___31: CE_POINTER [INTEGER_8]
			l_tmp___32: CE_POINTER [INTEGER_8]
			l_tmp___33: CE_POINTER [INTEGER_8]
			l_tmp___34: CE_POINTER [INTEGER_8]
			l_tmp___35: CE_POINTER [INTEGER_8]
			l_tmp___36: CE_POINTER [INTEGER_8]
			l_tmp___37: CE_POINTER [INTEGER_8]
			l_tmp___38: CE_POINTER [INTEGER_8]
			l_tmp___39: CE_POINTER [INTEGER_8]
			l_tmp___40: CE_POINTER [INTEGER_8]
			l_tmp___41: CE_POINTER [INTEGER_8]
			l_tmp___42: CE_POINTER [INTEGER_8]
			l_tmp___43: CE_POINTER [INTEGER_8]
			l_tmp___44: CE_POINTER [INTEGER_8]
			l_tmp___45: CE_POINTER [INTEGER_8]
			l_tmp___46: CE_POINTER [INTEGER_8]
			l_tmp___47: CE_POINTER [INTEGER_8]
			l_tmp___48: CE_POINTER [INTEGER_8]
			l_tmp___49: CE_POINTER [INTEGER_8]
			l_tmp___50: CE_POINTER [INTEGER_8]
			l_tmp___51: CE_POINTER [INTEGER_8]
			l_tmp___52: CE_POINTER [INTEGER_8]
			l_tmp___53: CE_POINTER [INTEGER_8]
			l_tmp___54: CE_POINTER [INTEGER_8]
			l_tmp___55: CE_POINTER [INTEGER_8]
			l_tmp___56: CE_POINTER [INTEGER_8]
			l_tmp___57: CE_POINTER [INTEGER_8]
			l_tmp___58: CE_POINTER [INTEGER_8]
			l_tmp___59: CE_POINTER [INTEGER_8]
			l_tmp___60: CE_POINTER [INTEGER_8]
			l_tmp___61: CE_POINTER [INTEGER_8]
			l_tmp___62: CE_POINTER [INTEGER_8]
			l_tmp___63: CE_POINTER [INTEGER_8]
			l_tmp___64: CE_POINTER [INTEGER_8]
			l_tmp___65: CE_POINTER [INTEGER_8]
			l_tmp___66: CE_POINTER [INTEGER_8]
			l_tmp___67: CE_POINTER [INTEGER_8]
			l_tmp___68: CE_POINTER [INTEGER_8]
			l_tmp___69: CE_POINTER [INTEGER_8]
			l_tmp___70: CE_POINTER [INTEGER_8]
			l_tmp___71: CE_POINTER [INTEGER_8]
			l_tmp___72: CE_POINTER [INTEGER_8]
			l_tmp___73: CE_POINTER [INTEGER_8]
			l_tmp___74: CE_POINTER [INTEGER_8]
			l_tmp___75: CE_POINTER [INTEGER_8]
			l_tmp___76: CE_POINTER [INTEGER_8]
			l_tmp___77: CE_POINTER [INTEGER_8]
			l_tmp___78: CE_POINTER [INTEGER_8]
			l_tmp___79: CE_POINTER [INTEGER_8]
			l_tmp___80: CE_POINTER [INTEGER_8]
			l_tmp___81: CE_POINTER [INTEGER_8]
			l_tmp___82: CE_POINTER [INTEGER_8]
			l_tmp___83: CE_POINTER [INTEGER_8]
			l_tmp___84: CE_POINTER [INTEGER_8]
			l_tmp___85: CE_POINTER [INTEGER_8]
			l_tmp___86: CE_POINTER [INTEGER_8]
			l_tmp___87: CE_POINTER [INTEGER_8]
			l_tmp___88: CE_POINTER [INTEGER_8]
			l_tmp___89: CE_POINTER [INTEGER_8]
			l_tmp___90: CE_POINTER [INTEGER_8]
			l_tmp___91: CE_POINTER [INTEGER_8]
			l_tmp___92: CE_POINTER [INTEGER_8]
			l_tmp___93: CE_POINTER [INTEGER_8]
			l_tmp___94: CE_POINTER [INTEGER_8]
			l_tmp___95: CE_POINTER [INTEGER_8]
			l_tmp___96: CE_POINTER [INTEGER_8]
			l_tmp___97: CE_POINTER [INTEGER_8]
			l_tmp___98: CE_POINTER [INTEGER_8]
			l_tmp___99: CE_POINTER [INTEGER_8]
			l_tmp___100: CE_POINTER [INTEGER_8]
			l_tmp___101: CE_POINTER [INTEGER_8]
			l_tmp___102: CE_POINTER [INTEGER_8]
			l_tmp___103: CE_POINTER [INTEGER_8]
			l_tmp___104: CE_POINTER [INTEGER_8]
			l_tmp___105: CE_POINTER [INTEGER_8]
			l_tmp___106: CE_POINTER [INTEGER_8]
			l_tmp___107: CE_POINTER [INTEGER_8]
			l_tmp___108: CE_POINTER [INTEGER_8]
			l_tmp___109: CE_POINTER [INTEGER_8]
			l_tmp___110: CE_POINTER [INTEGER_8]
			l_tmp___111: CE_POINTER [INTEGER_8]
			l_tmp___112: CE_POINTER [INTEGER_8]
			l_tmp___113: CE_POINTER [INTEGER_8]
			l_tmp___114: CE_POINTER [INTEGER_8]
			l_tmp___115: CE_POINTER [INTEGER_8]
			l_tmp___116: CE_POINTER [INTEGER_8]
			l_tmp___117: CE_POINTER [INTEGER_8]
			l_tmp___118: CE_POINTER [INTEGER_8]
			l_tmp___119: CE_POINTER [INTEGER_8]
			l_tmp___120: CE_POINTER [INTEGER_8]
			l_tmp___121: CE_POINTER [INTEGER_8]
			l_tmp___122: CE_POINTER [INTEGER_8]
			l_tmp___123: CE_POINTER [INTEGER_8]
			l_tmp___124: CE_POINTER [INTEGER_8]
			l_tmp___125: CE_POINTER [INTEGER_8]
			l_tmp___126: CE_POINTER [INTEGER_8]
			l_tmp___127: CE_POINTER [INTEGER_8]
			l_tmp___128: CE_POINTER [INTEGER_8]
			l_tmp___129: CE_POINTER [INTEGER_8]
			l_tmp___130: CE_POINTER [INTEGER_8]
			l_tmp___131: CE_POINTER [INTEGER_8]
			l_tmp___132: CE_POINTER [INTEGER_8]
			l_tmp___133: CE_POINTER [INTEGER_8]
			l_tmp___134: CE_POINTER [INTEGER_8]
			l_tmp___135: CE_POINTER [INTEGER_8]
			l_tmp___136: CE_POINTER [INTEGER_8]
			l_tmp___137: CE_POINTER [INTEGER_8]
			l_tmp___138: CE_POINTER [INTEGER_8]
			l_tmp___139: CE_POINTER [INTEGER_8]
			l_tmp___140: CE_POINTER [INTEGER_8]
			l_tmp___141: CE_POINTER [INTEGER_8]
			l_tmp___142: CE_POINTER [INTEGER_8]
			l_tmp___143: CE_POINTER [INTEGER_8]
			l_tmp___144: CE_POINTER [INTEGER_8]
			l_tmp___145: CE_POINTER [INTEGER_8]
			l_tmp___146: CE_POINTER [INTEGER_8]
			l_tmp___147: CE_POINTER [INTEGER_8]
			l_tmp___148: CE_POINTER [INTEGER_8]
			l_tmp___149: CE_POINTER [INTEGER_8]
			l_tmp___150: CE_POINTER [INTEGER_8]
			l_tmp___151: CE_POINTER [INTEGER_8]
			l_tmp___152: CE_POINTER [INTEGER_8]
			l_tmp___153: CE_POINTER [INTEGER_8]
			l_tmp___154: CE_POINTER [INTEGER_8]
			l_tmp___155: CE_POINTER [INTEGER_8]
			l_tmp___156: CE_POINTER [INTEGER_8]
			l_tmp___157: CE_POINTER [INTEGER_8]
			l_tmp___158: CE_POINTER [INTEGER_8]
			l_tmp___159: CE_POINTER [INTEGER_8]
			l_tmp___160: CE_POINTER [INTEGER_8]
			l_tmp___161: CE_POINTER [INTEGER_8]
			l_tmp___162: CE_POINTER [INTEGER_8]
			l_tmp___163: CE_POINTER [INTEGER_8]
			l_tmp___164: CE_POINTER [INTEGER_8]
			l_tmp___165: CE_POINTER [INTEGER_8]
			l_tmp___166: CE_POINTER [INTEGER_8]
			l_tmp___167: CE_POINTER [INTEGER_8]
			l_tmp___168: CE_POINTER [INTEGER_8]
			l_tmp___169: CE_POINTER [INTEGER_8]
			l_tmp___170: CE_POINTER [INTEGER_8]
			l_tmp___171: CE_POINTER [INTEGER_8]
			l_tmp___172: CE_POINTER [INTEGER_8]
			l_tmp___173: CE_POINTER [INTEGER_8]
			l_tmp___174: CE_POINTER [INTEGER_8]
			l_tmp___175: CE_POINTER [INTEGER_8]
			l_tmp___176: CE_POINTER [INTEGER_8]
			l_tmp___177: CE_POINTER [INTEGER_8]
			l_tmp___178: CE_POINTER [INTEGER_8]
			l_tmp___179: CE_POINTER [INTEGER_8]
			l_tmp___180: CE_POINTER [INTEGER_8]
			l_tmp___181: CE_POINTER [INTEGER_8]
			l_tmp___182: CE_POINTER [INTEGER_8]
			l_tmp___183: CE_POINTER [INTEGER_8]
			l_tmp___184: CE_POINTER [INTEGER_8]
			l_tmp___185: CE_POINTER [INTEGER_8]
			l_tmp___186: CE_POINTER [INTEGER_8]
			l_tmp___187: CE_POINTER [INTEGER_8]
			l_tmp___188: CE_POINTER [INTEGER_8]
			l_tmp___189: CE_POINTER [INTEGER_8]
			l_tmp___190: CE_POINTER [INTEGER_8]
		do
			l_p___0 := a_buffer___0
			l_n := a_number
			l_last_digit_char := 0
			if l_n < {INTEGER_64} 0 then
				if l_n < -((((-{INTEGER_64} 1).bit_shift_left (({PLATFORM}.Integer_64_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1).to_integer_32))).bit_not) then
					l_last_digit := (l_n \\ {INTEGER_64} 10).to_integer_32
					if l_last_digit < 0 then
						l_last_digit_char := 48 - l_last_digit
					else
						l_last_digit_char := 48 + l_last_digit
					end
					l_n := l_n // ({INTEGER_64} 10)
				end
				l_tmp := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp[0] := (('-').code).to_integer_8
				l_n := -l_n
			end
			if l_n < {INTEGER_64} 10 then
				l_tmp___0 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___0[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 100 then
				l_tmp___1 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___1[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___2 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___2[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 1_000 then
				l_tmp___3 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___3[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___4 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___4[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___5 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___5[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 10_000 then
				l_tmp___6 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___6[0] := (l_n // {INTEGER_64} 1_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000)
				l_tmp___7 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___7[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___8 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___8[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___9 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___9[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 100_000 then
				l_tmp___10 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___10[0] := (l_n // {INTEGER_64} 10_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000)
				l_tmp___11 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___11[0] := (l_n // {INTEGER_64} 1_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000)
				l_tmp___12 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___12[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___13 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___13[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___14 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___14[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 1_000_000 then
				l_tmp___15 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___15[0] := (l_n // {INTEGER_64} 100_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000)
				l_tmp___16 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___16[0] := (l_n // {INTEGER_64} 10_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000)
				l_tmp___17 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___17[0] := (l_n // {INTEGER_64} 1_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000)
				l_tmp___18 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___18[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___19 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___19[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___20 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___20[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 10_000_000 then
				l_tmp___21 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___21[0] := (l_n // {INTEGER_64} 1_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000)
				l_tmp___22 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___22[0] := (l_n // {INTEGER_64} 100_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000)
				l_tmp___23 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___23[0] := (l_n // {INTEGER_64} 10_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000)
				l_tmp___24 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___24[0] := (l_n // {INTEGER_64} 1_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000)
				l_tmp___25 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___25[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___26 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___26[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___27 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___27[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 100_000_000 then
				l_tmp___28 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___28[0] := (l_n // {INTEGER_64} 10_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000)
				l_tmp___29 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___29[0] := (l_n // {INTEGER_64} 1_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000)
				l_tmp___30 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___30[0] := (l_n // {INTEGER_64} 100_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000)
				l_tmp___31 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___31[0] := (l_n // {INTEGER_64} 10_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000)
				l_tmp___32 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___32[0] := (l_n // {INTEGER_64} 1_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000)
				l_tmp___33 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___33[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___34 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___34[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___35 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___35[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 1_000_000_000 then
				l_tmp___36 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___36[0] := (l_n // {INTEGER_64} 100_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000)
				l_tmp___37 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___37[0] := (l_n // {INTEGER_64} 10_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000)
				l_tmp___38 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___38[0] := (l_n // {INTEGER_64} 1_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000)
				l_tmp___39 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___39[0] := (l_n // {INTEGER_64} 100_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000)
				l_tmp___40 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___40[0] := (l_n // {INTEGER_64} 10_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000)
				l_tmp___41 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___41[0] := (l_n // {INTEGER_64} 1_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000)
				l_tmp___42 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___42[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___43 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___43[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___44 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___44[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 10_000_000_000 then
				l_tmp___45 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___45[0] := (l_n // {INTEGER_64} 1_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000)
				l_tmp___46 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___46[0] := (l_n // {INTEGER_64} 100_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000)
				l_tmp___47 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___47[0] := (l_n // {INTEGER_64} 10_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000)
				l_tmp___48 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___48[0] := (l_n // {INTEGER_64} 1_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000)
				l_tmp___49 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___49[0] := (l_n // {INTEGER_64} 100_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000)
				l_tmp___50 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___50[0] := (l_n // {INTEGER_64} 10_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000)
				l_tmp___51 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___51[0] := (l_n // {INTEGER_64} 1_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000)
				l_tmp___52 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___52[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___53 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___53[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___54 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___54[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 100_000_000_000 then
				l_tmp___55 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___55[0] := (l_n // {INTEGER_64} 10_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000)
				l_tmp___56 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___56[0] := (l_n // {INTEGER_64} 1_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000)
				l_tmp___57 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___57[0] := (l_n // {INTEGER_64} 100_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000)
				l_tmp___58 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___58[0] := (l_n // {INTEGER_64} 10_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000)
				l_tmp___59 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___59[0] := (l_n // {INTEGER_64} 1_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000)
				l_tmp___60 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___60[0] := (l_n // {INTEGER_64} 100_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000)
				l_tmp___61 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___61[0] := (l_n // {INTEGER_64} 10_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000)
				l_tmp___62 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___62[0] := (l_n // {INTEGER_64} 1_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000)
				l_tmp___63 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___63[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___64 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___64[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___65 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___65[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 1_000_000_000_000 then
				l_tmp___66 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___66[0] := (l_n // {INTEGER_64} 100_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000_000)
				l_tmp___67 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___67[0] := (l_n // {INTEGER_64} 10_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000)
				l_tmp___68 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___68[0] := (l_n // {INTEGER_64} 1_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000)
				l_tmp___69 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___69[0] := (l_n // {INTEGER_64} 100_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000)
				l_tmp___70 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___70[0] := (l_n // {INTEGER_64} 10_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000)
				l_tmp___71 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___71[0] := (l_n // {INTEGER_64} 1_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000)
				l_tmp___72 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___72[0] := (l_n // {INTEGER_64} 100_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000)
				l_tmp___73 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___73[0] := (l_n // {INTEGER_64} 10_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000)
				l_tmp___74 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___74[0] := (l_n // {INTEGER_64} 1_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000)
				l_tmp___75 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___75[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___76 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___76[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___77 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___77[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 10_000_000_000_000 then
				l_tmp___78 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___78[0] := (l_n // {INTEGER_64} 1_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000_000)
				l_tmp___79 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___79[0] := (l_n // {INTEGER_64} 100_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000_000)
				l_tmp___80 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___80[0] := (l_n // {INTEGER_64} 10_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000)
				l_tmp___81 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___81[0] := (l_n // {INTEGER_64} 1_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000)
				l_tmp___82 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___82[0] := (l_n // {INTEGER_64} 100_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000)
				l_tmp___83 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___83[0] := (l_n // {INTEGER_64} 10_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000)
				l_tmp___84 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___84[0] := (l_n // {INTEGER_64} 1_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000)
				l_tmp___85 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___85[0] := (l_n // {INTEGER_64} 100_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000)
				l_tmp___86 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___86[0] := (l_n // {INTEGER_64} 10_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000)
				l_tmp___87 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___87[0] := (l_n // {INTEGER_64} 1_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000)
				l_tmp___88 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___88[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___89 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___89[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___90 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___90[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 100_000_000_000_000 then
				l_tmp___91 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___91[0] := (l_n // {INTEGER_64} 10_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000_000)
				l_tmp___92 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___92[0] := (l_n // {INTEGER_64} 1_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000_000)
				l_tmp___93 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___93[0] := (l_n // {INTEGER_64} 100_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000_000)
				l_tmp___94 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___94[0] := (l_n // {INTEGER_64} 10_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000)
				l_tmp___95 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___95[0] := (l_n // {INTEGER_64} 1_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000)
				l_tmp___96 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___96[0] := (l_n // {INTEGER_64} 100_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000)
				l_tmp___97 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___97[0] := (l_n // {INTEGER_64} 10_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000)
				l_tmp___98 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___98[0] := (l_n // {INTEGER_64} 1_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000)
				l_tmp___99 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___99[0] := (l_n // {INTEGER_64} 100_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000)
				l_tmp___100 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___100[0] := (l_n // {INTEGER_64} 10_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000)
				l_tmp___101 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___101[0] := (l_n // {INTEGER_64} 1_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000)
				l_tmp___102 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___102[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___103 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___103[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___104 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___104[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 1_000_000_000_000_000 then
				l_tmp___105 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___105[0] := (l_n // {INTEGER_64} 100_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000_000_000)
				l_tmp___106 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___106[0] := (l_n // {INTEGER_64} 10_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000_000)
				l_tmp___107 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___107[0] := (l_n // {INTEGER_64} 1_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000_000)
				l_tmp___108 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___108[0] := (l_n // {INTEGER_64} 100_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000_000)
				l_tmp___109 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___109[0] := (l_n // {INTEGER_64} 10_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000)
				l_tmp___110 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___110[0] := (l_n // {INTEGER_64} 1_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000)
				l_tmp___111 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___111[0] := (l_n // {INTEGER_64} 100_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000)
				l_tmp___112 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___112[0] := (l_n // {INTEGER_64} 10_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000)
				l_tmp___113 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___113[0] := (l_n // {INTEGER_64} 1_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000)
				l_tmp___114 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___114[0] := (l_n // {INTEGER_64} 100_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000)
				l_tmp___115 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___115[0] := (l_n // {INTEGER_64} 10_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000)
				l_tmp___116 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___116[0] := (l_n // {INTEGER_64} 1_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000)
				l_tmp___117 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___117[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___118 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___118[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___119 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___119[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 10_000_000_000_000_000 then
				l_tmp___120 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___120[0] := (l_n // {INTEGER_64} 1_000_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000_000_000)
				l_tmp___121 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___121[0] := (l_n // {INTEGER_64} 100_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000_000_000)
				l_tmp___122 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___122[0] := (l_n // {INTEGER_64} 10_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000_000)
				l_tmp___123 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___123[0] := (l_n // {INTEGER_64} 1_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000_000)
				l_tmp___124 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___124[0] := (l_n // {INTEGER_64} 100_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000_000)
				l_tmp___125 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___125[0] := (l_n // {INTEGER_64} 10_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000)
				l_tmp___126 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___126[0] := (l_n // {INTEGER_64} 1_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000)
				l_tmp___127 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___127[0] := (l_n // {INTEGER_64} 100_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000)
				l_tmp___128 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___128[0] := (l_n // {INTEGER_64} 10_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000)
				l_tmp___129 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___129[0] := (l_n // {INTEGER_64} 1_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000)
				l_tmp___130 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___130[0] := (l_n // {INTEGER_64} 100_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000)
				l_tmp___131 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___131[0] := (l_n // {INTEGER_64} 10_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000)
				l_tmp___132 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___132[0] := (l_n // {INTEGER_64} 1_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000)
				l_tmp___133 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___133[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___134 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___134[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___135 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___135[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 100_000_000_000_000_000 then
				l_tmp___136 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___136[0] := (l_n // {INTEGER_64} 10_000_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000_000_000)
				l_tmp___137 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___137[0] := (l_n // {INTEGER_64} 1_000_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000_000_000)
				l_tmp___138 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___138[0] := (l_n // {INTEGER_64} 100_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000_000_000)
				l_tmp___139 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___139[0] := (l_n // {INTEGER_64} 10_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000_000)
				l_tmp___140 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___140[0] := (l_n // {INTEGER_64} 1_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000_000)
				l_tmp___141 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___141[0] := (l_n // {INTEGER_64} 100_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000_000)
				l_tmp___142 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___142[0] := (l_n // {INTEGER_64} 10_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000)
				l_tmp___143 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___143[0] := (l_n // {INTEGER_64} 1_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000)
				l_tmp___144 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___144[0] := (l_n // {INTEGER_64} 100_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000)
				l_tmp___145 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___145[0] := (l_n // {INTEGER_64} 10_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000)
				l_tmp___146 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___146[0] := (l_n // {INTEGER_64} 1_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000)
				l_tmp___147 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___147[0] := (l_n // {INTEGER_64} 100_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000)
				l_tmp___148 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___148[0] := (l_n // {INTEGER_64} 10_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000)
				l_tmp___149 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___149[0] := (l_n // {INTEGER_64} 1_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000)
				l_tmp___150 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___150[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___151 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___151[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___152 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___152[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 1_000_000_000_000_000_000 then
				l_tmp___153 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___153[0] := (l_n // {INTEGER_64} 100_000_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000_000_000_000)
				l_tmp___154 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___154[0] := (l_n // {INTEGER_64} 10_000_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000_000_000)
				l_tmp___155 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___155[0] := (l_n // {INTEGER_64} 1_000_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000_000_000)
				l_tmp___156 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___156[0] := (l_n // {INTEGER_64} 100_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000_000_000)
				l_tmp___157 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___157[0] := (l_n // {INTEGER_64} 10_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000_000)
				l_tmp___158 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___158[0] := (l_n // {INTEGER_64} 1_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000_000)
				l_tmp___159 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___159[0] := (l_n // {INTEGER_64} 100_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000_000)
				l_tmp___160 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___160[0] := (l_n // {INTEGER_64} 10_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000)
				l_tmp___161 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___161[0] := (l_n // {INTEGER_64} 1_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000)
				l_tmp___162 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___162[0] := (l_n // {INTEGER_64} 100_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000)
				l_tmp___163 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___163[0] := (l_n // {INTEGER_64} 10_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000)
				l_tmp___164 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___164[0] := (l_n // {INTEGER_64} 1_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000)
				l_tmp___165 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___165[0] := (l_n // {INTEGER_64} 100_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000)
				l_tmp___166 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___166[0] := (l_n // {INTEGER_64} 10_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000)
				l_tmp___167 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___167[0] := (l_n // {INTEGER_64} 1_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000)
				l_tmp___168 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___168[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___169 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___169[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___170 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___170[0] := (l_n + {INTEGER_64} 48).to_integer_8
			else
				l_tmp___171 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___171[0] := (l_n // {INTEGER_64} 1_000_000_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000_000_000_000)
				l_tmp___172 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___172[0] := (l_n // {INTEGER_64} 100_000_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000_000_000_000)
				l_tmp___173 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___173[0] := (l_n // {INTEGER_64} 10_000_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000_000_000)
				l_tmp___174 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___174[0] := (l_n // {INTEGER_64} 1_000_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000_000_000)
				l_tmp___175 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___175[0] := (l_n // {INTEGER_64} 100_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000_000_000)
				l_tmp___176 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___176[0] := (l_n // {INTEGER_64} 10_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000_000)
				l_tmp___177 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___177[0] := (l_n // {INTEGER_64} 1_000_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000_000)
				l_tmp___178 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___178[0] := (l_n // {INTEGER_64} 100_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000_000)
				l_tmp___179 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___179[0] := (l_n // {INTEGER_64} 10_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000_000)
				l_tmp___180 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___180[0] := (l_n // {INTEGER_64} 1_000_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000_000)
				l_tmp___181 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___181[0] := (l_n // {INTEGER_64} 100_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000_000)
				l_tmp___182 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___182[0] := (l_n // {INTEGER_64} 10_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000_000)
				l_tmp___183 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___183[0] := (l_n // {INTEGER_64} 1_000_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000_000)
				l_tmp___184 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___184[0] := (l_n // {INTEGER_64} 100_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100_000)
				l_tmp___185 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___185[0] := (l_n // {INTEGER_64} 10_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10_000)
				l_tmp___186 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___186[0] := (l_n // {INTEGER_64} 1_000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1_000)
				l_tmp___187 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___187[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___188 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___188[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___189 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___189[0] := (l_n + {INTEGER_64} 48).to_integer_8
			end
			if l_last_digit_char.to_boolean then
				l_tmp___190 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___190[0] := l_last_digit_char.to_integer_8
			end
			l_p___0[0] := (('%/0/').code).to_integer_8
			Result := l_p___0
		end

	number_to_static_string (a_number: INTEGER_64): CE_POINTER [INTEGER_8]
		local
			l_buf___6: CE_POINTER [INTEGER_8]
		do
			l_buf___6 := ring___0.item[ringpos___0.item]
			number_to_string (l_buf___6, a_number).do_nothing
			ringpos___0.item := (ringpos___0.item + 1) \\ 3
			Result := l_buf___6
		end

	determine_screen_width: INTEGER_32
		local
			l_fd: INTEGER_32
			l_wsz: CE_ARRAY [SD_WINSIZE]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_WINSIZE]} l_wsz.make (<<1>>)

			if not ((create {P_OPTIONS_STATIC}).opt.item.item.lfilename).is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_fd := fileno ((create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)))
				if (ioctl ([l_fd, {NATURAL_32} 21_523, l_wsz])) < 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := (l_wsz.item.ws_col).to_integer_32
			end
		end

	random_number (a_max: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if not rnd_seeded.item.to_boolean then
				l_tmp := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
				srand48 ((l_tmp).bit_xor ((getpid).to_integer_32))
				rnd_seeded.item := 1
			end
			Result := ((lrand48) \\ a_max.to_integer_32).to_integer_32
		end

	random_float: REAL_64
		local
			l_tmp: INTEGER_32
		do
			if not rnd_seeded.item.to_boolean then
				l_tmp := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
				srand48 ((l_tmp).bit_xor ((getpid).to_integer_32))
				rnd_seeded.item := 1
			end
			Result := (drand48)
		end

	abort_run_with_timeout (a_sig: INTEGER_32)
		do
			if a_sig /= 14 then
				assert_fail (ce_string ("sig == 14"), ce_string ("utils.c"), {NATURAL_32} 1_912, ce_string ("abort_run_with_timeout"))
			end
			run_with_timeout_env.item.raise (-1)
		end

	alarm_set (a_timeout: REAL_64)
		local
			l_itv: CE_ARRAY [SD_ITIMERVAL]
		do
			create {CE_CLASS_ARRAY [SD_ITIMERVAL]} l_itv.make (<<1>>)

			memset (create {CE_VOID_POINTER}.make_cast (l_itv), ('%/0/').code, (create {SD_ITIMERVAL}.make).structure_size.to_natural_32).do_nothing
			l_itv.item.it_value.tv_sec := a_timeout.truncated_to_integer
			l_itv.item.it_value.tv_usec := ((1_000_000).to_double * (a_timeout - (a_timeout.truncated_to_integer).to_double)).truncated_to_integer
			if l_itv.item.it_value.tv_sec = 0 then
				if l_itv.item.it_value.tv_usec = 0 then
					l_itv.item.it_value.tv_usec := (1).to_integer_32
				end
			end
			setitimer ({SC_ITIMER_WHICH}.ITIMER_REAL, l_itv, create {CE_CLASS_POINTER [SD_ITIMERVAL]}.make_shared (default_pointer)).do_nothing
		end

	alarm_cancel
		local
			l_disable: CE_ARRAY [SD_ITIMERVAL]
		do
			create {CE_CLASS_ARRAY [SD_ITIMERVAL]} l_disable.make (<<1>>)

			memset (create {CE_VOID_POINTER}.make_cast (l_disable), ('%/0/').code, (create {SD_ITIMERVAL}.make).structure_size.to_natural_32).do_nothing
			setitimer ({SC_ITIMER_WHICH}.ITIMER_REAL, l_disable, create {CE_CLASS_POINTER [SD_ITIMERVAL]}.make_shared (default_pointer)).do_nothing
		end

	run_with_timeout (a_timeout: REAL_64; a_fun: CE_ROUTINE; a_arg: CE_POINTER [ANY]): BOOLEAN
		local
			l_saved_errno: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_timeout = (0).to_double then
						a_fun.call ([a_arg])
						Result := (0).to_boolean
						l_return := True
					end
					if l_return then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						signal (14, abort_run_with_timeout_address).do_nothing
						run_with_timeout_env.item := create {CE_EXCEPTION}.make ($run_with_timeout, l_pos, $l_tmp)
				when 2 then -- continue here on raising run_with_timeout_env:
						if l_tmp /= 0 then
							signal (14, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
							Result := (1).to_boolean
							l_return := True
						end
				when 3 then -- if done
					if not l_return then
						alarm_set (a_timeout)
						a_fun.call ([a_arg])
						l_saved_errno := (errno_location).item
						alarm_cancel
						signal (14, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing;
						(errno_location).item := l_saved_errno
						Result := (0).to_boolean
					end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		rescue
			if attached {CE_EXCEPTION} (create {EXCEPTION_MANAGER}).last_exception as ex then
				if ex.routine = $run_with_timeout then
					l_pos := ex.position + 1
					retry
				end
				ex.re_raise
			end
		end

	xsleep (a_seconds: REAL_64)
		local
			l_sleep___0: CE_ARRAY [SD_TIMESPEC]
			l_remaining: CE_ARRAY [SD_TIMESPEC]
			l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_TIMESPEC]} l_sleep___0.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMESPEC]} l_remaining.make (<<1>>)

			l_sleep___0.item.tv_sec := a_seconds.truncated_to_integer
			l_sleep___0.item.tv_nsec := ((1_000_000_000).to_double * (a_seconds - (a_seconds.truncated_to_integer).to_double)).truncated_to_integer
			from
			until
				(l_break)
			loop
				l_break := False
				if (nanosleep (l_sleep___0, l_remaining)) < 0 then
					if (errno_location).item /= 4 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_sleep___0.item := (l_remaining.item).twin
				end
			end
			l_break := False
		end

	base64_decode (a_base64: CE_POINTER [INTEGER_8]; a_dest: CE_POINTER [ANY]): INTEGER_32
		require
			not a_base64.is_void
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_q: CE_POINTER [INTEGER_8]
			l_c: NATURAL_8
			l_value: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_base64
					l_q := create {CE_INTEGER_8_POINTER}.make_cast (a_dest)
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 33 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp := l_p___0
							l_p___0 := l_p___0 + 1
							l_c := (l_tmp[0]).to_natural_8
							if not ((create {P_C_CTYPE_STATIC}).c2_isspace (l_c.to_integer_32)) then
								l_break := True
							end
						end
						l_break := False
						if not l_c.to_boolean then
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 32 -- skip if block
						end
				when 3 then -- if:
						if l_c.to_integer_32 /= 61 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (-1)
						l_return := True
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if ((l_c.to_integer_32).bit_and (128)) /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if not ((base64_char_to_value.item[l_c.to_integer_32]).to_integer_32 >= 0) then
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if l_c.to_integer_32 /= 61 then
							Result := (-1)
							l_return := True
						end
				when 10 then -- if done
						if not l_return then
							l_value := (((base64_char_to_value.item[l_c.to_integer_32]).to_integer_32).bit_shift_left (18)).to_natural_32
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___1 := l_p___0
								l_p___0 := l_p___0 + 1
								l_c := (l_tmp___1[0]).to_natural_8
								if not ((create {P_C_CTYPE_STATIC}).c2_isspace (l_c.to_integer_32)) then
									l_break := True
								end
							end
							l_break := False
							if not l_c.to_boolean then
								Result := (-1)
								l_return := True
							end
						end
						if l_return then
							l_pos := -1 + 18 -- skip if block
						end
				when 11 then -- if:
						if l_c.to_integer_32 /= 61 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						Result := (-1)
						l_return := True
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 14 then -- else:
						if ((l_c.to_integer_32).bit_and (128)) /= 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if not ((base64_char_to_value.item[l_c.to_integer_32]).to_integer_32 >= 0) then
							l_pos := -1 + 17 -- goto _L___0
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L___0:
						if l_c.to_integer_32 /= 61 then
							Result := (-1)
							l_return := True
						end
				when 18 then -- if done | if done
						if not l_return then
							l_value := (l_value).bit_or ((((base64_char_to_value.item[l_c.to_integer_32]).to_integer_32).bit_shift_left (12)).to_natural_32)
							l_tmp___3 := l_q
							l_q := l_q + 1
							l_tmp___3[0] := ((l_value).bit_shift_right (16)).to_integer_8
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___4 := l_p___0
								l_p___0 := l_p___0 + 1
								l_c := (l_tmp___4[0]).to_natural_8
								if not ((create {P_C_CTYPE_STATIC}).c2_isspace (l_c.to_integer_32)) then
									l_break := True
								end
							end
							l_break := False
							if not l_c.to_boolean then
								Result := (-1)
								l_return := True
							end
						end
						if l_return then
							l_pos := -1 + 23 -- skip if block
						end
				when 19 then -- if:
						if ((l_c.to_integer_32).bit_and (128)) /= 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if not ((base64_char_to_value.item[l_c.to_integer_32]).to_integer_32 >= 0) then
							l_pos := -1 + 22 -- goto _L___1
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else: | _L___1:
						if l_c.to_integer_32 /= 61 then
							Result := (-1)
							l_return := True
						end
				when 23 then -- if done
						if l_return then
							l_pos := -1 + 32 -- skip if block
						end
				when 24 then -- if:
						if l_c.to_integer_32 = 61 then
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___6 := l_p___0
								l_p___0 := l_p___0 + 1
								l_c := (l_tmp___6[0]).to_natural_8
								if not ((create {P_C_CTYPE_STATIC}).c2_isspace (l_c.to_integer_32)) then
									l_break := True
								end
							end
							l_break := False
							if not l_c.to_boolean then
								Result := (-1)
								l_return := True
							end
							if not l_return and then (l_c.to_integer_32 /= 61) then
								Result := (-1)
								l_return := True
							end
							if not l_return then
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 32 -- skip if block
						end
				when 25 then -- if:
						l_value := (l_value).bit_or ((((base64_char_to_value.item[l_c.to_integer_32]).to_integer_32).bit_shift_left (6)).to_natural_32)
						l_tmp___8 := l_q
						l_q := l_q + 1
						l_tmp___8[0] := (({NATURAL_32} 255).bit_and (((l_value).bit_shift_right (8)))).to_integer_8
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___9 := l_p___0
							l_p___0 := l_p___0 + 1
							l_c := (l_tmp___9[0]).to_natural_8
							if not ((create {P_C_CTYPE_STATIC}).c2_isspace (l_c.to_integer_32)) then
								l_break := True
							end
						end
						l_break := False
						if not l_c.to_boolean then
							Result := (-1)
							l_return := True
						end
						if l_return then
							l_pos := -1 + 32 -- skip if block
						end
				when 26 then -- if:
						if l_c.to_integer_32 = 61 then
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 32 -- skip if block
						end
				when 27 then -- if:
						if ((l_c.to_integer_32).bit_and (128)) /= 0 then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if not ((base64_char_to_value.item[l_c.to_integer_32]).to_integer_32 >= 0) then
							l_pos := -1 + 30 -- goto _L___2
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else: | _L___2:
						if l_c.to_integer_32 /= 61 then
							Result := (-1)
							l_return := True
						end
				when 31 then
						if not l_return then
							l_value := (l_value).bit_or (((base64_char_to_value.item[l_c.to_integer_32]).to_integer_32).to_natural_32)
							l_tmp___11 := l_q
							l_q := l_q + 1
							l_tmp___11[0] := (({NATURAL_32} 255).bit_and (l_value)).to_integer_8
						end
				when 32 then -- if done | if done | if done | if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 33 then -- loop done
					if not l_return then
						l_break := False
						l_continue := False
						Result := (l_q.distance ((create {CE_INTEGER_8_POINTER}.make_cast (a_dest))))
					end
				when 34 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mergesort_internal (a_base, a_temp: CE_POINTER [ANY]; a_size, a_from, a_to: NATURAL_32; a_cmpfun: CE_ROUTINE)
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_mid: NATURAL_32
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___3: NATURAL_32
			l_tmp___4: NATURAL_32
			l_tmp___5: NATURAL_32
			l_break: BOOLEAN
		do
			if a_from < a_to then
				l_mid := (a_to + a_from) // {NATURAL_32} 2
				mergesort_internal (a_base, a_temp, a_size, a_from, l_mid, a_cmpfun)
				mergesort_internal (a_base, a_temp, a_size, l_mid + {NATURAL_32} 1, a_to, a_cmpfun)
				l_i := a_from
				l_j := l_mid + {NATURAL_32} 1
				l_k := a_from
				from
				until
					(l_break)
				loop
					l_break := False
					if l_i <= l_mid then
						if not (l_j <= a_to) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						if (a_cmpfun.integer_32_item ([create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (a_base) + (l_i * a_size).to_integer_32)), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (a_base) + (l_j * a_size).to_integer_32))])) <= 0 then
							l_tmp := l_i
							l_i := l_i + 1
							memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (a_temp) + (l_k * a_size).to_integer_32)), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (a_base) + (l_tmp * a_size).to_integer_32)), a_size).do_nothing
						else
							l_tmp___0 := l_j
							l_j := l_j + 1
							memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (a_temp) + (l_k * a_size).to_integer_32)), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (a_base) + (l_tmp___0 * a_size).to_integer_32)), a_size).do_nothing
						end
						l_k := l_k + 1
					end
				end
				l_break := False
				from
				until
					not (l_i <= l_mid)
				loop
					l_tmp___2 := l_i
					l_i := l_i + 1
					l_tmp___3 := l_k
					l_k := l_k + 1
					memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (a_temp) + (l_tmp___3 * a_size).to_integer_32)), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (a_base) + (l_tmp___2 * a_size).to_integer_32)), a_size).do_nothing
				end
				from
				until
					not (l_j <= a_to)
				loop
					l_tmp___4 := l_j
					l_j := l_j + 1
					l_tmp___5 := l_k
					l_k := l_k + 1
					memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (a_temp) + (l_tmp___5 * a_size).to_integer_32)), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (a_base) + (l_tmp___4 * a_size).to_integer_32)), a_size).do_nothing
				end
				l_k := a_from
				from
				until
					not (l_k <= a_to)
				loop
					memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (a_base) + (l_k * a_size).to_integer_32)), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (a_temp) + (l_k * a_size).to_integer_32)), a_size).do_nothing
					l_k := l_k + 1
				end
			end
		end

	stable_sort (a_base: CE_POINTER [ANY]; a_nmemb, a_size: NATURAL_32; a_cmpfun: CE_ROUTINE)
		local
			l_temp: CE_POINTER [ANY]
			l_aaf: CE_ALLOCA_FACTORY
		do
			if a_size > {NATURAL_32} 1 then
				l_temp := (l_aaf.new ((a_nmemb * a_size) * {PLATFORM}.Pointer_bytes.to_natural_32))
				mergesort_internal (a_base, l_temp, a_size, (0).to_natural_32, a_nmemb - {NATURAL_32} 1, a_cmpfun)
			end
		end

	print_decimal (a_number: REAL_64): CE_POINTER [INTEGER_8]
		local
			l_n: REAL_64
			l_tmp: REAL_64
		do
			if a_number >= (0).to_double then
				l_tmp := a_number
			else
				l_tmp := -a_number
			end
			l_n := l_tmp
			if l_n >= 9.95 then
				snprintf ([buf___4.item, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (32).to_natural_32), ce_string ("%%.0f"), a_number]).do_nothing
			elseif l_n >= 0.95 then
				snprintf ([buf___4.item, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (32).to_natural_32), ce_string ("%%.1f"), a_number]).do_nothing
			elseif l_n >= 0.001 then
				snprintf ([buf___4.item, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (32).to_natural_32), ce_string ("%%.1g"), a_number]).do_nothing
			elseif l_n >= 0.0005 then
				snprintf ([buf___4.item, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (32).to_natural_32), ce_string ("%%.3f"), a_number]).do_nothing
			else
				strcpy (buf___4.item, ce_string ("0")).do_nothing
			end
			Result := buf___4.item
		end

feature {ANY} -- routine addresses

	fnmatch_nocase_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent fnmatch_nocase)
		end

	abort_run_with_timeout_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent abort_run_with_timeout)
		end

end
