class
	PD_ACC_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} host.make
			create {CE_INTEGER_8_POINTER} acc.make
			create {CE_INTEGER_8_POINTER} passwd.make
			create {CE_CLASS_POINTER [PD_ACC_T]} next.make
		end

feature {ANY} -- fields

	host: CE_POINTER [INTEGER_8] assign set_host

	acc: CE_POINTER [INTEGER_8] assign set_acc

	passwd: CE_POINTER [INTEGER_8] assign set_passwd

	next: CE_POINTER [PD_ACC_T] assign set_next

feature {ANY} -- field setters

	set_host (a_host: CE_POINTER [INTEGER_8])
		do
			host := a_host
			update_memory_field ("host")
		end

	set_acc (a_acc: CE_POINTER [INTEGER_8])
		do
			acc := a_acc
			update_memory_field ("acc")
		end

	set_passwd (a_passwd: CE_POINTER [INTEGER_8])
		do
			passwd := a_passwd
			update_memory_field ("passwd")
		end

	set_next (a_next: CE_POINTER [PD_ACC_T])
		do
			next := a_next
			update_memory_field ("next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			host := a_other.host
			acc := a_other.acc
			passwd := a_other.passwd
			next := a_other.next
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				host.is_equal (a_other.host) and
				acc.is_equal (a_other.acc) and
				passwd.is_equal (a_other.passwd) and
				next.is_equal (a_other.next)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("host"),
					create {CE_STRUCTURE_FIELD}.make ("acc"),
					create {CE_STRUCTURE_FIELD}.make ("passwd"),
					create {CE_STRUCTURE_FIELD}.make ("next")
				>>)
			init_structure_info
		end

end
