class
	PD_COOKIE_JAR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_GCC_BUILTIN_STATIC
		redefine
			copy,
			is_equal
		end
	S_TIME_STATIC
		redefine
			copy,
			is_equal
		end
	S_ASSERT_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_HASH_TABLE]} chains.make
			Precursor
		end

feature {ANY} -- fields

	chains: CE_POINTER [PD_HASH_TABLE] assign set_chains

	cookie_count: INTEGER_32 assign set_cookie_count

feature {ANY} -- field setters

	set_chains (a_chains: CE_POINTER [PD_HASH_TABLE])
		do
			chains := a_chains
			update_memory_field ("chains")
		end

	set_cookie_count (a_cookie_count: INTEGER_32)
		do
			cookie_count := a_cookie_count
			update_memory_field ("cookie_count")
		end

feature {ANY} -- public routines

	find_matching_cookie (a_cookie: CE_POINTER [PD_COOKIE]; a_prevptr: CE_POINTER [CE_POINTER [PD_COOKIE]]): CE_POINTER [PD_COOKIE]
		require
			not a_cookie.is_void
		local
			l_chain: CE_POINTER [PD_COOKIE]
			l_prev: CE_POINTER [PD_COOKIE]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := chains.item.hash_table_get (create {CE_VOID_POINTER}.make_cast (a_cookie.item.domain))
					update_class_fields -- Current might have been changed; synchronize
					l_chain := create {CE_CLASS_POINTER [PD_COOKIE]}.make_cast (l_tmp)
					if l_chain.is_void then
						l_pos := -1 + 2 -- goto nomatch
					end
				when 1 then
					l_prev := create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer)
					from
					until
						not (not (l_return) and then (not l_chain.is_void))
					loop
						l_tmp___0 := strcmp (a_cookie.item.path, l_chain.item.path)
						update_class_fields -- Current might have been changed; synchronize
						if 0 = l_tmp___0 then
							l_tmp___1 := strcmp (a_cookie.item.attr, l_chain.item.attr)
							update_class_fields -- Current might have been changed; synchronize
							if 0 = l_tmp___1 then
								if a_cookie.item.port = l_chain.item.port then
									a_prevptr.item := l_prev
									update_class_fields -- Current might have been changed; synchronize
									Result := l_chain
									l_return := True
								end
							end
						end
						if not l_return then
							l_prev := l_chain
							l_chain := l_chain.item.next
						end
					end
					if l_return then
						l_pos := -1 + 3 -- skip if block
					end
				when 2 then -- if: | nomatch:
						a_prevptr.item := create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						Result := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer))
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	store_cookie (a_cookie: CE_POINTER [PD_COOKIE])
		require
			not a_cookie.is_void
		local
			l_chain_head: CE_ARRAY [CE_POINTER [PD_COOKIE]]
			l_chain_key: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_prev: CE_ARRAY [CE_POINTER [PD_COOKIE]]
			l_victim: CE_POINTER [PD_COOKIE]
			l_tmp: CE_POINTER [PD_COOKIE]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_exptime: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_COOKIE]} l_chain_head.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_chain_key.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_COOKIE]} l_prev.make (<<1>>)

			l_tmp___1 := chains.item.hash_table_get_pair (create {CE_VOID_POINTER}.make_cast (a_cookie.item.domain), create {CE_VOID_POINTER}.make_cast (l_chain_key), create {CE_VOID_POINTER}.make_cast (l_chain_head))
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___1.to_boolean then
				l_tmp := ((create {CE_CLASS_POINTER [PD_COOKIE_JAR]}.make_shared (c_pointer))).item.find_matching_cookie (a_cookie, l_prev)
				update_class_fields -- Current might have been changed; synchronize
				l_victim := l_tmp
				if (not l_victim.is_void) then
					if (not (l_prev.item).is_void) then
						l_prev.item.item.next := l_victim.item.next
						update_class_fields -- Current might have been changed; synchronize
						a_cookie.item.next := l_chain_head.item
						update_class_fields -- Current might have been changed; synchronize
					else
						a_cookie.item.next := l_victim.item.next
						update_class_fields -- Current might have been changed; synchronize
					end
					l_victim.item.delete_cookie
					update_class_fields -- Current might have been changed; synchronize
					Current.cookie_count := cookie_count - 1
					update_class_fields -- Current might have been changed; synchronize
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___0 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0.to_boolean then
							(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Deleted old cookie (to be replaced.)%N")])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_break := True
					end
					l_break := False
				else
					a_cookie.item.next := l_chain_head.item
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				a_cookie.item.next := create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_chain_key.item := (create {P_XMALLOC_STATIC}).xstrdup (a_cookie.item.domain)
				update_class_fields -- Current might have been changed; synchronize
			end
			chains.item.hash_table_put (create {CE_VOID_POINTER}.make_cast (l_chain_key.item), create {CE_VOID_POINTER}.make_cast (a_cookie))
			update_class_fields -- Current might have been changed; synchronize
			Current.cookie_count := cookie_count + 1
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___8 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___8.to_boolean then
				l_exptime := a_cookie.item.expiry_time
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___7 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___7.to_boolean then
						if (a_cookie.item.expiry_time).to_boolean then
							l_tmp___2 := (create {P_UTILS_STATIC}).datetime_str (l_exptime)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___3 := l_tmp___2
						else
							l_tmp___3 := ce_string ("none")
						end
						if (a_cookie.item.secure).to_boolean then
							l_tmp___4 := ce_string ("secure")
						else
							l_tmp___4 := ce_string ("insecure")
						end
						if (a_cookie.item.permanent).to_boolean then
							l_tmp___5 := ce_string ("permanent")
						else
							l_tmp___5 := ce_string ("session")
						end
						if a_cookie.item.port = -1 then
							l_tmp___6 := ce_string (" (ANY)")
						else
							l_tmp___6 := ce_string ("")
						end
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%NStored cookie %%s %%d%%s %%s <%%s> <%%s> [expiry %%s] %%s %%s%N"), a_cookie.item.domain, a_cookie.item.port, l_tmp___6, a_cookie.item.path, l_tmp___5, l_tmp___4, l_tmp___3, a_cookie.item.attr, a_cookie.item.value])
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	find_chains_of_host (a_host: CE_POINTER [INTEGER_8]; a_dest: CE_POINTER [CE_POINTER [PD_COOKIE]]): INTEGER_32
		local
			l_host: CE_POINTER [INTEGER_8]
			l_dest_count: INTEGER_32
			l_passes: INTEGER_32
			l_passcnt: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: BOOLEAN
			l_chain: CE_POINTER [PD_COOKIE]
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			l_host := a_host
			l_dest_count := 0
			l_tmp := chains.item.hash_table_count
			update_class_fields -- Current might have been changed; synchronize
			if not l_tmp.to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_tmp___0 := (create {P_COOKIES_STATIC}).numeric_address_p (l_host)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0 then
					l_passes := 1
				else
					l_passes := count_char (l_host, (('.').code).to_integer_8)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_passcnt := 0
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___1 := chains.item.hash_table_get (create {CE_VOID_POINTER}.make_cast (l_host))
					update_class_fields -- Current might have been changed; synchronize
					l_chain := create {CE_CLASS_POINTER [PD_COOKIE]}.make_cast (l_tmp___1)
					if (not l_chain.is_void) then
						l_tmp___2 := l_dest_count
						l_dest_count := l_dest_count + 1
						a_dest[l_tmp___2] := l_chain
						update_class_fields -- Current might have been changed; synchronize
					end
					l_passcnt := l_passcnt + 1
					if l_passcnt >= l_passes then
						l_break := True
					end
					if not (l_break) then
						l_tmp___3 := strchr (l_host, ('.').code)
						update_class_fields -- Current might have been changed; synchronize
						l_host := (l_tmp___3 + 1)
					end
				end
				l_break := False
				Result := l_dest_count
			end
		end

	cookie_header (a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32; a_path: CE_POINTER [INTEGER_8]; a_secflag: BOOLEAN): CE_POINTER [INTEGER_8]
		require
			not a_host.is_void
			not a_path.is_void
		local
			l_path: CE_POINTER [INTEGER_8]
			l_chains: CE_POINTER [CE_POINTER [PD_COOKIE]]
			l_chain_count: INTEGER_32
			l_cookie: CE_POINTER [PD_COOKIE]
			l_outgoing: CE_POINTER [PD_WEIGHED_COOKIE]
			l_count: INTEGER_32
			l_i: INTEGER_32
			l_ocnt: INTEGER_32
			l_result: CE_POINTER [INTEGER_8]
			l_result_size: INTEGER_32
			l_pos2: INTEGER_32
			l_PS_newstr: CE_POINTER [INTEGER_8]
			l_tmp: NATURAL_32
			l_tmp___1: INTEGER_32
			l_tmp___3: BOOLEAN
			l_pg: CE_ARRAY [INTEGER_32]
			l_tmp___5: BOOLEAN
			l_tmp___6: NATURAL_32
			l_c: CE_POINTER [PD_COOKIE]
			l_tmp___7: NATURAL_32
			l_tmp___8: NATURAL_32
			l_tmp___9: CE_POINTER [ANY]
			l_c___0: CE_POINTER [PD_COOKIE]
			l_namlen: INTEGER_32
			l_tmp___10: NATURAL_32
			l_vallen: INTEGER_32
			l_tmp___11: NATURAL_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_INTEGER_32_ARRAY} l_pg.make (<<1>>)

			l_path := a_path
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp := strlen (l_path)
				update_class_fields -- Current might have been changed; synchronize
				l_PS_newstr := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new (({NATURAL_32} 1 + l_tmp) + {NATURAL_32} 1)))
				l_PS_newstr[0] := (('/').code).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
				strcpy ((l_PS_newstr + 1), l_path).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_path := l_PS_newstr
				l_break := True
			end
			l_break := False
			l_tmp___1 := count_char (a_host, (('.').code).to_integer_8)
			update_class_fields -- Current might have been changed; synchronize
			l_chains := create {CE_POINTER_POINTER [PD_COOKIE]}.make_cast ((l_aaf.new ((1 + l_tmp___1).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
			l_chain_count := ((create {CE_CLASS_POINTER [PD_COOKIE_JAR]}.make_shared (c_pointer))).item.find_chains_of_host (a_host, l_chains)
			update_class_fields -- Current might have been changed; synchronize
			if not l_chain_count.to_boolean then
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				(create {P_COOKIES_STATIC}).cookies_now.item := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				l_count := 0
				l_i := 0
				from
				until
					not (not (l_return) and then (l_i < l_chain_count))
				loop
					l_cookie := l_chains[l_i]
					from
					until
						l_cookie.is_void
					loop
						l_tmp___3 := cookie_matches_url (l_cookie, a_host, a_port, l_path, a_secflag, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___3 then
							l_count := l_count + 1
						end
						l_cookie := l_cookie.item.next
					end
					l_i := l_i + 1
				end
				if not l_count.to_boolean then
					Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_outgoing := create {CE_CLASS_POINTER [PD_WEIGHED_COOKIE]}.make_cast ((l_aaf.new (l_count.to_natural_32 * (create {PD_WEIGHED_COOKIE}.make).structure_size.to_natural_32)))
				l_ocnt := 0
				l_i := 0
				from
				until
					not (not (l_return) and then (l_i < l_chain_count))
				loop
					l_cookie := l_chains[l_i]
					from
					until
						l_cookie.is_void
					loop
						l_continue := False
						l_tmp___5 := cookie_matches_url (l_cookie, a_host, a_port, l_path, a_secflag, l_pg)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___5 then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							(l_outgoing + l_ocnt).item.cookie := l_cookie
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___6 := strlen (l_cookie.item.domain)
							update_class_fields; -- Current might have been changed; synchronize
							(l_outgoing + l_ocnt).item.domain_goodness := l_tmp___6.to_integer_32
							update_class_fields; -- Current might have been changed; synchronize
							(l_outgoing + l_ocnt).item.path_goodness := l_pg.item
							update_class_fields -- Current might have been changed; synchronize
							l_ocnt := l_ocnt + 1
						end
						l_cookie := l_cookie.item.next
					end
					l_continue := False
					l_i := l_i + 1
				end
				if l_ocnt /= l_count then
					assert_fail (ce_string ("ocnt == count"), ce_string ("cookies.c"), {NATURAL_32} 1_016, ce_string ("cookie_header"))
					update_class_fields -- Current might have been changed; synchronize
				end
				l_count := eliminate_dups (l_outgoing, l_count)
				update_class_fields -- Current might have been changed; synchronize
				qsort (create {CE_VOID_POINTER}.make_cast (l_outgoing), l_count.to_natural_32, (create {PD_WEIGHED_COOKIE}.make).structure_size.to_natural_32, (create {P_COOKIES_STATIC}).goodness_comparator_address)
				update_class_fields -- Current might have been changed; synchronize
				l_result_size := 0
				l_i := 0
				from
				until
					not (l_i < l_count)
				loop
					l_c := (l_outgoing + l_i).item.cookie
					l_tmp___7 := strlen (l_c.item.attr)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___8 := strlen (l_c.item.value)
					update_class_fields -- Current might have been changed; synchronize
					l_result_size := (l_result_size.to_natural_32 + ((l_tmp___7 + {NATURAL_32} 1) + l_tmp___8)).to_integer_32
					l_i := l_i + 1
				end
				l_result_size := (l_result_size + (l_count - 1) * 2) + 1
				l_tmp___9 := (create {P_XMALLOC_STATIC}).xmalloc (l_result_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_result := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___9)
				l_pos2 := 0
				l_i := 0
				from
				until
					not (l_i < l_count)
				loop
					l_c___0 := (l_outgoing + l_i).item.cookie
					l_tmp___10 := strlen (l_c___0.item.attr)
					update_class_fields -- Current might have been changed; synchronize
					l_namlen := l_tmp___10.to_integer_32
					l_tmp___11 := strlen (l_c___0.item.value)
					update_class_fields -- Current might have been changed; synchronize
					l_vallen := l_tmp___11.to_integer_32
					memcpy (create {CE_VOID_POINTER}.make_cast ((l_result + l_pos2)), create {CE_VOID_POINTER}.make_cast (l_c___0.item.attr), l_namlen.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_pos2 := l_pos2 + l_namlen
					l_tmp___12 := l_pos2
					l_pos2 := l_pos2 + 1
					l_result[l_tmp___12] := (('=').code).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					memcpy (create {CE_VOID_POINTER}.make_cast ((l_result + l_pos2)), create {CE_VOID_POINTER}.make_cast (l_c___0.item.value), l_vallen.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_pos2 := l_pos2 + l_vallen
					if l_i < l_count - 1 then
						l_tmp___13 := l_pos2
						l_pos2 := l_pos2 + 1
						l_result[l_tmp___13] := ((';').code).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___14 := l_pos2
						l_pos2 := l_pos2 + 1
						l_result[l_tmp___14] := ((' ').code).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
					end
					l_i := l_i + 1
				end
				l_tmp___15 := l_pos2
				l_pos2 := l_pos2 + 1
				l_result[l_tmp___15] := (('%/0/').code).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
				if l_pos2 /= l_result_size then
					assert_fail (ce_string ("pos == result_size"), ce_string ("cookies.c"), {NATURAL_32} 1_060, ce_string ("cookie_header"))
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_result
			end
		end

	cookie_jar_delete
		local
			l_iter: CE_ARRAY [PD_HASH_TABLE_ITERATOR]
			l_chain: CE_POINTER [PD_COOKIE]
			l_next: CE_POINTER [PD_COOKIE]
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_HASH_TABLE_ITERATOR]} l_iter.make (<<1>>)

			chains.item.hash_table_iterate (l_iter)
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_tmp := l_iter.item.hash_table_iter_next
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp.to_boolean then
					l_break := True
				end
				if not (l_return or l_break) then
					l_chain := create {CE_CLASS_POINTER [PD_COOKIE]}.make_cast (l_iter.item.value)
					free (l_iter.item.key)
					update_class_fields -- Current might have been changed; synchronize
					from
					until
						l_chain.is_void
					loop
						l_next := l_chain.item.next
						l_chain.item.delete_cookie
						update_class_fields -- Current might have been changed; synchronize
						l_chain := l_next
					end
				end
			end
			l_break := False
			chains.item.hash_table_destroy
			update_class_fields -- Current might have been changed; synchronize
			free (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_COOKIE_JAR} -- private routines

	count_char (a_string: CE_POINTER [INTEGER_8]; a_chr: INTEGER_8): INTEGER_32
		require
			not a_string.is_void
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_count: INTEGER_32
		do
			l_count := 0
			l_p___0 := a_string
			from
			until
				not ((l_p___0[0]).to_boolean)
			loop
				if (l_p___0[0]).to_integer_32 = a_chr.to_integer_32 then
					l_count := l_count + 1
				end
				l_p___0 := l_p___0 + 1
			end
			Result := l_count
		end

	cookie_matches_url (a_cookie: CE_POINTER [PD_COOKIE]; a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32; a_path: CE_POINTER [INTEGER_8]; a_secflag: BOOLEAN; a_path_goodness: CE_POINTER [INTEGER_32]): BOOLEAN
		require
			not a_cookie.is_void
		local
			l_pg: INTEGER_32
			l_return: BOOLEAN
		do
			if (a_cookie.item.cookie_expired_p) then
				Result := (0).to_boolean
				l_return := True
			end
			if not l_return and then ((a_cookie.item.secure).to_boolean) then
				if not a_secflag then
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return and then (a_cookie.item.port /= -1) then
				if a_cookie.item.port /= a_port then
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return and then ((a_cookie.item.domain_exact).to_boolean) then
				if 0 /= (strcasecmp (a_host, a_cookie.item.domain)) then
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return then
				l_pg := (create {P_COOKIES_STATIC}).path_matches (a_path, a_cookie.item.path)
				if l_pg = 0 then
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return then
				if (not a_path_goodness.is_void) then
					a_path_goodness.item := l_pg
				end
				Result := (1).to_boolean
			end
		end

	eliminate_dups (a_outgoing: CE_POINTER [PD_WEIGHED_COOKIE]; a_count: INTEGER_32): INTEGER_32
		local
			l_h: CE_POINTER [PD_WEIGHED_COOKIE]
			l_t: CE_POINTER [PD_WEIGHED_COOKIE]
			l_end: CE_POINTER [PD_WEIGHED_COOKIE]
			l_c0: CE_POINTER [PD_COOKIE]
			l_c1: CE_POINTER [PD_COOKIE]
			l_tmp___1: CE_POINTER [PD_WEIGHED_COOKIE]
			l_continue: BOOLEAN
		do
			l_end := a_outgoing + a_count
			qsort (create {CE_VOID_POINTER}.make_cast (a_outgoing), a_count.to_natural_32, (create {PD_WEIGHED_COOKIE}.make).structure_size.to_natural_32, (create {P_COOKIES_STATIC}).equality_comparator_address)
			l_t := a_outgoing
			l_h := l_t
			from
			until
				not ((l_h.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32)
			loop
				l_continue := False
				if not l_h.is_equal (l_end - 1) then
					l_c0 := (l_h + 0).item.cookie
					l_c1 := (l_h + 1).item.cookie
					if not (strcmp (l_c0.item.attr, l_c1.item.attr)).to_boolean then
						if not (strcmp (l_c0.item.value, l_c1.item.value)).to_boolean then
							l_continue := True
						end
					end
				end
				if not (l_continue) then
					if not l_h.is_equal (l_t) then
						l_tmp___1 := l_t
						l_t := l_t + 1
						l_tmp___1.item := (l_h.item).twin
					else
						l_t := l_t + 1
					end
				end
				l_h := l_h + 1
			end
			l_continue := False
			Result := (l_t.distance (a_outgoing))
		end

feature {ANY}

	copy (a_other: like Current)
		do
			chains := a_other.chains
			cookie_count := a_other.cookie_count
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				chains.is_equal (a_other.chains) and
				cookie_count = a_other.cookie_count
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("chains"),
					create {CE_STRUCTURE_FIELD}.make ("cookie_count")
				>>)
			init_structure_info
		end

end
