class
	PD_CWT_CONTEXT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_SOCKADDR]} addr.make
		end

feature {ANY} -- fields

	fd: INTEGER_32 assign set_fd

	addr: CE_POINTER [SD_SOCKADDR] assign set_addr

	addrlen: NATURAL_32 assign set_addrlen

	result2: INTEGER_32 assign set_result2

feature {ANY} -- field setters

	set_fd (a_fd: INTEGER_32)
		do
			fd := a_fd
			update_memory_field ("fd")
		end

	set_addr (a_addr: CE_POINTER [SD_SOCKADDR])
		do
			addr := a_addr
			update_memory_field ("addr")
		end

	set_addrlen (a_addrlen: NATURAL_32)
		do
			addrlen := a_addrlen
			update_memory_field ("addrlen")
		end

	set_result2 (a_result2: INTEGER_32)
		do
			result2 := a_result2
			update_memory_field ("result2")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fd := a_other.fd
			addr := a_other.addr
			addrlen := a_other.addrlen
			result2 := a_other.result2
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fd = a_other.fd and
				addr.is_equal (a_other.addr) and
				addrlen = a_other.addrlen and
				result2 = a_other.result2
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fd"),
					create {CE_STRUCTURE_FIELD}.make ("addr"),
					create {CE_STRUCTURE_FIELD}.make ("addrlen"),
					create {CE_STRUCTURE_FIELD}.make ("result2")
				>>)
			init_structure_info
		end

end
