class
	PD_FILEINFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} name.make
			create {CE_INTEGER_8_POINTER} linkto.make
			create {CE_CLASS_POINTER [PD_FILEINFO]} prev.make
			create {CE_CLASS_POINTER [PD_FILEINFO]} next.make
		end

feature {ANY} -- fields

	type: NATURAL_32 assign set_type

	name: CE_POINTER [INTEGER_8] assign set_name

	size: INTEGER_64 assign set_size

	tstamp: INTEGER_32 assign set_tstamp

	perms: INTEGER_32 assign set_perms

	linkto: CE_POINTER [INTEGER_8] assign set_linkto

	prev: CE_POINTER [PD_FILEINFO] assign set_prev

	next: CE_POINTER [PD_FILEINFO] assign set_next

feature {ANY} -- field setters

	set_type (a_type: NATURAL_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_size (a_size: INTEGER_64)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_tstamp (a_tstamp: INTEGER_32)
		do
			tstamp := a_tstamp
			update_memory_field ("tstamp")
		end

	set_perms (a_perms: INTEGER_32)
		do
			perms := a_perms
			update_memory_field ("perms")
		end

	set_linkto (a_linkto: CE_POINTER [INTEGER_8])
		do
			linkto := a_linkto
			update_memory_field ("linkto")
		end

	set_prev (a_prev: CE_POINTER [PD_FILEINFO])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_next (a_next: CE_POINTER [PD_FILEINFO])
		do
			next := a_next
			update_memory_field ("next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			name := a_other.name
			size := a_other.size
			tstamp := a_other.tstamp
			perms := a_other.perms
			linkto := a_other.linkto
			prev := a_other.prev
			next := a_other.next
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				name.is_equal (a_other.name) and
				size = a_other.size and
				tstamp = a_other.tstamp and
				perms = a_other.perms and
				linkto.is_equal (a_other.linkto) and
				prev.is_equal (a_other.prev) and
				next.is_equal (a_other.next)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("tstamp"),
					create {CE_STRUCTURE_FIELD}.make ("perms"),
					create {CE_STRUCTURE_FIELD}.make ("linkto"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("next")
				>>)
			init_structure_info
		end

end
