class
	PD_GROWABLE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} base.make
		end

feature {ANY} -- fields

	base: CE_POINTER [INTEGER_8] assign set_base

	size: INTEGER_32 assign set_size

	tail: INTEGER_32 assign set_tail

feature {ANY} -- field setters

	set_base (a_base: CE_POINTER [INTEGER_8])
		do
			base := a_base
			update_memory_field ("base")
		end

	set_size (a_size: INTEGER_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_tail (a_tail: INTEGER_32)
		do
			tail := a_tail
			update_memory_field ("tail")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			base := a_other.base
			size := a_other.size
			tail := a_other.tail
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				base.is_equal (a_other.base) and
				size = a_other.size and
				tail = a_other.tail
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("base"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("tail")
				>>)
			init_structure_info
		end

end
