class
	PD_LIMIT_DATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	chunk_bytes: INTEGER_64 assign set_chunk_bytes

	chunk_start: REAL_64 assign set_chunk_start

	sleep_adjust: REAL_64 assign set_sleep_adjust

feature {ANY} -- field setters

	set_chunk_bytes (a_chunk_bytes: INTEGER_64)
		do
			chunk_bytes := a_chunk_bytes
			update_memory_field ("chunk_bytes")
		end

	set_chunk_start (a_chunk_start: REAL_64)
		do
			chunk_start := a_chunk_start
			update_memory_field ("chunk_start")
		end

	set_sleep_adjust (a_sleep_adjust: REAL_64)
		do
			sleep_adjust := a_sleep_adjust
			update_memory_field ("sleep_adjust")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			chunk_bytes := a_other.chunk_bytes
			chunk_start := a_other.chunk_start
			sleep_adjust := a_other.sleep_adjust
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				chunk_bytes = a_other.chunk_bytes and
				chunk_start = a_other.chunk_start and
				sleep_adjust = a_other.sleep_adjust
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("chunk_bytes"),
					create {CE_STRUCTURE_FIELD}.make ("chunk_start"),
					create {CE_STRUCTURE_FIELD}.make ("sleep_adjust")
				>>)
			init_structure_info
		end

end
