class
	PD_MD5_CTX

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_32_ARRAY} total.make (<<2>>)
			create {CE_NATURAL_32_ARRAY} buffer.make (<<32>>)
			Precursor
		end

feature {ANY} -- fields

	A: NATURAL_32 assign set_A

	B: NATURAL_32 assign set_B

	C: NATURAL_32 assign set_C

	D: NATURAL_32 assign set_D

	total: CE_ARRAY [NATURAL_32]

	buflen: NATURAL_32 assign set_buflen

	buffer: CE_ARRAY [NATURAL_32]

feature {ANY} -- field setters

	set_A (a_A: NATURAL_32)
		do
			A := a_A
			update_memory_field ("A")
		end

	set_B (a_B: NATURAL_32)
		do
			B := a_B
			update_memory_field ("B")
		end

	set_C (a_C: NATURAL_32)
		do
			C := a_C
			update_memory_field ("C")
		end

	set_D (a_D: NATURAL_32)
		do
			D := a_D
			update_memory_field ("D")
		end

	set_buflen (a_buflen: NATURAL_32)
		do
			buflen := a_buflen
			update_memory_field ("buflen")
		end

feature {PD_MD5_CTX} -- private attributes

	fillbuf: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<64>>)
			Result.item[0] := 128
			Result.item[1] := 0
		end

feature {ANY} -- public routines

	md5_init_ctx
		local
			l_tmp: NATURAL_32
		do
			Current.A := (1_732_584_193).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Current.B := {NATURAL_32} 4_023_233_417
			update_class_fields -- Current might have been changed; synchronize
			Current.C := {NATURAL_32} 2_562_383_102
			update_class_fields -- Current might have been changed; synchronize
			Current.D := (271_733_878).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (0).to_natural_32
			total[1] := l_tmp
			update_class_fields -- Current might have been changed; synchronize
			total[0] := l_tmp
			update_class_fields -- Current might have been changed; synchronize
			Current.buflen := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
		end

	md5_read_ctx (a_resbuf: CE_POINTER [ANY]): CE_POINTER [ANY]
		local
			l_r: CE_POINTER [INTEGER_8]
		do
			l_r := create {CE_INTEGER_8_POINTER}.make_cast (a_resbuf)
			set_uint32 (l_r + ({NATURAL_32} 0).to_integer_32, A)
			update_class_fields -- Current might have been changed; synchronize
			set_uint32 (l_r + ({PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32, B)
			update_class_fields -- Current might have been changed; synchronize
			set_uint32 (l_r + ({NATURAL_32} 2 * {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32, C)
			update_class_fields -- Current might have been changed; synchronize
			set_uint32 (l_r + ({NATURAL_32} 3 * {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32, D)
			update_class_fields -- Current might have been changed; synchronize
			Result := a_resbuf
		end

	md5_finish_ctx (a_resbuf: CE_POINTER [ANY]): CE_POINTER [ANY]
		local
			l_bytes: NATURAL_32
			l_size: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [ANY]
		do
			l_bytes := buflen
			if l_bytes < {NATURAL_32} 56 then
				l_tmp := 16
			else
				l_tmp := 32
			end
			l_size := l_tmp.to_natural_32
			total[0] := total[0] + l_bytes
			update_class_fields -- Current might have been changed; synchronize
			if total[0] < l_bytes then
				total[1] := (total[1]) + 1
				update_class_fields -- Current might have been changed; synchronize
			end
			buffer[(l_size - {NATURAL_32} 2).to_integer_32] := (total[0]).bit_shift_left (3)
			update_class_fields -- Current might have been changed; synchronize
			buffer[(l_size - {NATURAL_32} 1).to_integer_32] := (((total[1]).bit_shift_left (3))).bit_or (((total[0]).bit_shift_right (29)))
			update_class_fields -- Current might have been changed; synchronize
			memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (buffer) + l_bytes.to_integer_32)), create {CE_VOID_POINTER}.make_cast (fillbuf.item), (l_size - {NATURAL_32} 2) * {NATURAL_32} 4 - l_bytes).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_MD5_CTX]}.make_shared (c_pointer))).item.md5_process_block (create {CE_VOID_POINTER}.make_cast (buffer), l_size * {NATURAL_32} 4)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := ((create {CE_CLASS_POINTER [PD_MD5_CTX]}.make_shared (c_pointer))).item.md5_read_ctx (a_resbuf)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp___0
		end

	md5_process_bytes (a_buffer___0: CE_POINTER [ANY]; a_len: NATURAL_32)
		local
			l_buffer___0: CE_POINTER [ANY]
			l_len: NATURAL_32
			l_left_over: NATURAL_32
			l_add: NATURAL_32
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [ANY]
			l_left_over___0: NATURAL_32
		do
			l_buffer___0 := a_buffer___0
			l_len := a_len
			if buflen /= {NATURAL_32} 0 then
				l_left_over := buflen
				if {NATURAL_32} 128 - l_left_over > l_len then
					l_tmp := l_len
				else
					l_tmp := {NATURAL_32} 128 - l_left_over
				end
				l_add := l_tmp
				memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (buffer) + l_left_over.to_integer_32)), l_buffer___0, l_add).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Current.buflen := buflen + l_add
				update_class_fields -- Current might have been changed; synchronize
				if buflen > {NATURAL_32} 64 then
					((create {CE_CLASS_POINTER [PD_MD5_CTX]}.make_shared (c_pointer))).item.md5_process_block (create {CE_VOID_POINTER}.make_cast (buffer), (buflen).bit_and ({NATURAL_32} 4_294_967_232))
					update_class_fields -- Current might have been changed; synchronize
					Current.buflen := (buflen).bit_and (({NATURAL_32} 63))
					update_class_fields -- Current might have been changed; synchronize
					memcpy (create {CE_VOID_POINTER}.make_cast (buffer), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (buffer) + (((l_left_over + l_add)).bit_and ({NATURAL_32} 4_294_967_232)).to_integer_32)), buflen).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_buffer___0 := create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (l_buffer___0) + l_add.to_integer_32))
				l_len := l_len - l_add
			end
			if l_len >= {NATURAL_32} 64 then
				if (l_buffer___0.c_pointer.to_integer_32).to_natural_32 \\ ((create {CE_NATURAL_32_POINTER}.make_shared ((create {CE_CLASS_POINTER [PD_ANONYMOUS]}.make_shared (default_pointer)).c_pointer + (create {PD_ANONYMOUS}.make).offset_of ("x"))).c_pointer.to_integer_32).to_natural_32 /= {NATURAL_32} 0 then
					from
					until
						not (l_len > {NATURAL_32} 64)
					loop
						l_tmp___0 := memcpy (create {CE_VOID_POINTER}.make_cast (buffer), l_buffer___0, (64).to_natural_32)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_MD5_CTX]}.make_shared (c_pointer))).item.md5_process_block (l_tmp___0, (64).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_buffer___0 := create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (l_buffer___0) + 64))
						l_len := l_len - ({NATURAL_32} 64)
					end
				else
					((create {CE_CLASS_POINTER [PD_MD5_CTX]}.make_shared (c_pointer))).item.md5_process_block (l_buffer___0, (l_len).bit_and ({NATURAL_32} 4_294_967_232))
					update_class_fields -- Current might have been changed; synchronize
					l_buffer___0 := create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (l_buffer___0) + ((l_len).bit_and ({NATURAL_32} 4_294_967_232)).to_integer_32))
					l_len := (l_len).bit_and (({NATURAL_32} 63))
				end
			end
			if l_len > {NATURAL_32} 0 then
				l_left_over___0 := buflen
				memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (buffer) + l_left_over___0.to_integer_32)), l_buffer___0, l_len).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_left_over___0 := l_left_over___0 + l_len
				if l_left_over___0 >= {NATURAL_32} 64 then
					((create {CE_CLASS_POINTER [PD_MD5_CTX]}.make_shared (c_pointer))).item.md5_process_block (create {CE_VOID_POINTER}.make_cast (buffer), (64).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_left_over___0 := l_left_over___0 - ({NATURAL_32} 64)
					memcpy (create {CE_VOID_POINTER}.make_cast (buffer), create {CE_VOID_POINTER}.make_cast ((create {CE_NATURAL_32_POINTER}.make_shared (c_pointer + (create {PD_MD5_CTX}.make).offset_of ("buffer") + {PLATFORM}.Natural_32_bytes * (16)))), l_left_over___0).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.buflen := l_left_over___0
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	md5_process_block (a_buffer___0: CE_POINTER [ANY]; a_len: NATURAL_32)
		local
			l_correct_words: CE_ARRAY [NATURAL_32]
			l_words: CE_POINTER [NATURAL_32]
			l_nwords: NATURAL_32
			l_endp: CE_POINTER [NATURAL_32]
			l_A: NATURAL_32
			l_B: NATURAL_32
			l_C: NATURAL_32
			l_D: NATURAL_32
			l_cwp: CE_POINTER [NATURAL_32]
			l_A_save: NATURAL_32
			l_B_save: NATURAL_32
			l_C_save: NATURAL_32
			l_D_save: NATURAL_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [NATURAL_32]
			l_tmp___2: NATURAL_32
			l_tmp___3: CE_POINTER [NATURAL_32]
			l_tmp___4: NATURAL_32
			l_tmp___5: CE_POINTER [NATURAL_32]
			l_tmp___6: NATURAL_32
			l_tmp___7: CE_POINTER [NATURAL_32]
			l_tmp___8: NATURAL_32
			l_tmp___9: CE_POINTER [NATURAL_32]
			l_tmp___10: NATURAL_32
			l_tmp___11: CE_POINTER [NATURAL_32]
			l_tmp___12: NATURAL_32
			l_tmp___13: CE_POINTER [NATURAL_32]
			l_tmp___14: NATURAL_32
			l_tmp___15: CE_POINTER [NATURAL_32]
			l_tmp___16: NATURAL_32
			l_tmp___17: CE_POINTER [NATURAL_32]
			l_tmp___18: NATURAL_32
			l_tmp___19: CE_POINTER [NATURAL_32]
			l_tmp___20: NATURAL_32
			l_tmp___21: CE_POINTER [NATURAL_32]
			l_tmp___22: NATURAL_32
			l_tmp___23: CE_POINTER [NATURAL_32]
			l_tmp___24: NATURAL_32
			l_tmp___25: CE_POINTER [NATURAL_32]
			l_tmp___26: NATURAL_32
			l_tmp___27: CE_POINTER [NATURAL_32]
			l_tmp___28: NATURAL_32
			l_tmp___29: CE_POINTER [NATURAL_32]
			l_tmp___30: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_correct_words.make (<<16>>)

			l_words := create {CE_NATURAL_32_POINTER}.make_cast (a_buffer___0)
			l_nwords := a_len // {PLATFORM}.Natural_32_bytes.to_natural_32
			l_endp := l_words + l_nwords.to_integer_32
			l_A := A
			l_B := B
			l_C := C
			l_D := D
			total[0] := total[0] + a_len
			update_class_fields -- Current might have been changed; synchronize
			if total[0] < a_len then
				total[1] := (total[1]) + 1
				update_class_fields -- Current might have been changed; synchronize
			end
			from
			until
				not (not (l_return) and then ((l_words.c_pointer.to_integer_32).to_natural_32 < (l_endp.c_pointer.to_integer_32).to_natural_32))
			loop
				l_cwp := l_correct_words
				l_A_save := l_A
				l_B_save := l_B
				l_C_save := l_C
				l_D_save := l_D
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___0 := l_words.item
					l_tmp.item := l_tmp___0
					update_class_fields -- Current might have been changed; synchronize
					l_A := l_A + ((((l_D).bit_xor (((l_B).bit_and (((l_C).bit_xor (l_D)))))) + l_tmp___0) + {NATURAL_32} 3_614_090_360)
					l_words := l_words + 1
					l_A := (((l_A).bit_shift_left (7))).bit_or (((l_A).bit_shift_right (25)))
					l_A := l_A + l_B
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___1 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___2 := l_words.item
					l_tmp___1.item := l_tmp___2
					update_class_fields -- Current might have been changed; synchronize
					l_D := l_D + ((((l_C).bit_xor (((l_A).bit_and (((l_B).bit_xor (l_C)))))) + l_tmp___2) + {NATURAL_32} 3_905_402_710)
					l_words := l_words + 1
					l_D := (((l_D).bit_shift_left (12))).bit_or (((l_D).bit_shift_right (20)))
					l_D := l_D + l_A
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___3 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___4 := l_words.item
					l_tmp___3.item := l_tmp___4
					update_class_fields -- Current might have been changed; synchronize
					l_C := l_C + ((((l_B).bit_xor (((l_D).bit_and (((l_A).bit_xor (l_B)))))) + l_tmp___4) + {NATURAL_32} 606_105_819)
					l_words := l_words + 1
					l_C := (((l_C).bit_shift_left (17))).bit_or (((l_C).bit_shift_right (15)))
					l_C := l_C + l_D
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___5 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___6 := l_words.item
					l_tmp___5.item := l_tmp___6
					update_class_fields -- Current might have been changed; synchronize
					l_B := l_B + ((((l_A).bit_xor (((l_C).bit_and (((l_D).bit_xor (l_A)))))) + l_tmp___6) + {NATURAL_32} 3_250_441_966)
					l_words := l_words + 1
					l_B := (((l_B).bit_shift_left (22))).bit_or (((l_B).bit_shift_right (10)))
					l_B := l_B + l_C
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___7 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___8 := l_words.item
					l_tmp___7.item := l_tmp___8
					update_class_fields -- Current might have been changed; synchronize
					l_A := l_A + ((((l_D).bit_xor (((l_B).bit_and (((l_C).bit_xor (l_D)))))) + l_tmp___8) + {NATURAL_32} 4_118_548_399)
					l_words := l_words + 1
					l_A := (((l_A).bit_shift_left (7))).bit_or (((l_A).bit_shift_right (25)))
					l_A := l_A + l_B
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___9 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___10 := l_words.item
					l_tmp___9.item := l_tmp___10
					update_class_fields -- Current might have been changed; synchronize
					l_D := l_D + ((((l_C).bit_xor (((l_A).bit_and (((l_B).bit_xor (l_C)))))) + l_tmp___10) + {NATURAL_32} 1_200_080_426)
					l_words := l_words + 1
					l_D := (((l_D).bit_shift_left (12))).bit_or (((l_D).bit_shift_right (20)))
					l_D := l_D + l_A
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___11 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___12 := l_words.item
					l_tmp___11.item := l_tmp___12
					update_class_fields -- Current might have been changed; synchronize
					l_C := l_C + ((((l_B).bit_xor (((l_D).bit_and (((l_A).bit_xor (l_B)))))) + l_tmp___12) + {NATURAL_32} 2_821_735_955)
					l_words := l_words + 1
					l_C := (((l_C).bit_shift_left (17))).bit_or (((l_C).bit_shift_right (15)))
					l_C := l_C + l_D
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___13 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___14 := l_words.item
					l_tmp___13.item := l_tmp___14
					update_class_fields -- Current might have been changed; synchronize
					l_B := l_B + ((((l_A).bit_xor (((l_C).bit_and (((l_D).bit_xor (l_A)))))) + l_tmp___14) + {NATURAL_32} 4_249_261_313)
					l_words := l_words + 1
					l_B := (((l_B).bit_shift_left (22))).bit_or (((l_B).bit_shift_right (10)))
					l_B := l_B + l_C
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___15 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___16 := l_words.item
					l_tmp___15.item := l_tmp___16
					update_class_fields -- Current might have been changed; synchronize
					l_A := l_A + ((((l_D).bit_xor (((l_B).bit_and (((l_C).bit_xor (l_D)))))) + l_tmp___16) + {NATURAL_32} 1_770_035_416)
					l_words := l_words + 1
					l_A := (((l_A).bit_shift_left (7))).bit_or (((l_A).bit_shift_right (25)))
					l_A := l_A + l_B
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___17 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___18 := l_words.item
					l_tmp___17.item := l_tmp___18
					update_class_fields -- Current might have been changed; synchronize
					l_D := l_D + ((((l_C).bit_xor (((l_A).bit_and (((l_B).bit_xor (l_C)))))) + l_tmp___18) + {NATURAL_32} 2_336_552_879)
					l_words := l_words + 1
					l_D := (((l_D).bit_shift_left (12))).bit_or (((l_D).bit_shift_right (20)))
					l_D := l_D + l_A
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___19 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___20 := l_words.item
					l_tmp___19.item := l_tmp___20
					update_class_fields -- Current might have been changed; synchronize
					l_C := l_C + ((((l_B).bit_xor (((l_D).bit_and (((l_A).bit_xor (l_B)))))) + l_tmp___20) + {NATURAL_32} 4_294_925_233)
					l_words := l_words + 1
					l_C := (((l_C).bit_shift_left (17))).bit_or (((l_C).bit_shift_right (15)))
					l_C := l_C + l_D
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___21 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___22 := l_words.item
					l_tmp___21.item := l_tmp___22
					update_class_fields -- Current might have been changed; synchronize
					l_B := l_B + ((((l_A).bit_xor (((l_C).bit_and (((l_D).bit_xor (l_A)))))) + l_tmp___22) + {NATURAL_32} 2_304_563_134)
					l_words := l_words + 1
					l_B := (((l_B).bit_shift_left (22))).bit_or (((l_B).bit_shift_right (10)))
					l_B := l_B + l_C
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___23 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___24 := l_words.item
					l_tmp___23.item := l_tmp___24
					update_class_fields -- Current might have been changed; synchronize
					l_A := l_A + ((((l_D).bit_xor (((l_B).bit_and (((l_C).bit_xor (l_D)))))) + l_tmp___24) + {NATURAL_32} 1_804_603_682)
					l_words := l_words + 1
					l_A := (((l_A).bit_shift_left (7))).bit_or (((l_A).bit_shift_right (25)))
					l_A := l_A + l_B
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___25 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___26 := l_words.item
					l_tmp___25.item := l_tmp___26
					update_class_fields -- Current might have been changed; synchronize
					l_D := l_D + ((((l_C).bit_xor (((l_A).bit_and (((l_B).bit_xor (l_C)))))) + l_tmp___26) + {NATURAL_32} 4_254_626_195)
					l_words := l_words + 1
					l_D := (((l_D).bit_shift_left (12))).bit_or (((l_D).bit_shift_right (20)))
					l_D := l_D + l_A
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___27 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___28 := l_words.item
					l_tmp___27.item := l_tmp___28
					update_class_fields -- Current might have been changed; synchronize
					l_C := l_C + ((((l_B).bit_xor (((l_D).bit_and (((l_A).bit_xor (l_B)))))) + l_tmp___28) + {NATURAL_32} 2_792_965_006)
					l_words := l_words + 1
					l_C := (((l_C).bit_shift_left (17))).bit_or (((l_C).bit_shift_right (15)))
					l_C := l_C + l_D
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___29 := l_cwp
					l_cwp := l_cwp + 1
					l_tmp___30 := l_words.item
					l_tmp___29.item := l_tmp___30
					update_class_fields -- Current might have been changed; synchronize
					l_B := l_B + ((((l_A).bit_xor (((l_C).bit_and (((l_D).bit_xor (l_A)))))) + l_tmp___30) + {NATURAL_32} 1_236_535_329)
					l_words := l_words + 1
					l_B := (((l_B).bit_shift_left (22))).bit_or (((l_B).bit_shift_right (10)))
					l_B := l_B + l_C
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_A := l_A + ((((l_C).bit_xor (((l_D).bit_and (((l_B).bit_xor (l_C)))))) + l_correct_words[1]) + {NATURAL_32} 4_129_170_786)
					l_A := (((l_A).bit_shift_left (5))).bit_or (((l_A).bit_shift_right (27)))
					l_A := l_A + l_B
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_D := l_D + ((((l_B).bit_xor (((l_C).bit_and (((l_A).bit_xor (l_B)))))) + l_correct_words[6]) + {NATURAL_32} 3_225_465_664)
					l_D := (((l_D).bit_shift_left (9))).bit_or (((l_D).bit_shift_right (23)))
					l_D := l_D + l_A
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_C := l_C + ((((l_A).bit_xor (((l_B).bit_and (((l_D).bit_xor (l_A)))))) + l_correct_words[11]) + {NATURAL_32} 643_717_713)
					l_C := (((l_C).bit_shift_left (14))).bit_or (((l_C).bit_shift_right (18)))
					l_C := l_C + l_D
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_B := l_B + ((((l_D).bit_xor (((l_A).bit_and (((l_C).bit_xor (l_D)))))) + l_correct_words[0]) + {NATURAL_32} 3_921_069_994)
					l_B := (((l_B).bit_shift_left (20))).bit_or (((l_B).bit_shift_right (12)))
					l_B := l_B + l_C
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_A := l_A + ((((l_C).bit_xor (((l_D).bit_and (((l_B).bit_xor (l_C)))))) + l_correct_words[5]) + {NATURAL_32} 3_593_408_605)
					l_A := (((l_A).bit_shift_left (5))).bit_or (((l_A).bit_shift_right (27)))
					l_A := l_A + l_B
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_D := l_D + ((((l_B).bit_xor (((l_C).bit_and (((l_A).bit_xor (l_B)))))) + l_correct_words[10]) + {NATURAL_32} 38_016_083)
					l_D := (((l_D).bit_shift_left (9))).bit_or (((l_D).bit_shift_right (23)))
					l_D := l_D + l_A
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_C := l_C + ((((l_A).bit_xor (((l_B).bit_and (((l_D).bit_xor (l_A)))))) + l_correct_words[15]) + {NATURAL_32} 3_634_488_961)
					l_C := (((l_C).bit_shift_left (14))).bit_or (((l_C).bit_shift_right (18)))
					l_C := l_C + l_D
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_B := l_B + ((((l_D).bit_xor (((l_A).bit_and (((l_C).bit_xor (l_D)))))) + l_correct_words[4]) + {NATURAL_32} 3_889_429_448)
					l_B := (((l_B).bit_shift_left (20))).bit_or (((l_B).bit_shift_right (12)))
					l_B := l_B + l_C
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_A := l_A + ((((l_C).bit_xor (((l_D).bit_and (((l_B).bit_xor (l_C)))))) + l_correct_words[9]) + {NATURAL_32} 568_446_438)
					l_A := (((l_A).bit_shift_left (5))).bit_or (((l_A).bit_shift_right (27)))
					l_A := l_A + l_B
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_D := l_D + ((((l_B).bit_xor (((l_C).bit_and (((l_A).bit_xor (l_B)))))) + l_correct_words[14]) + {NATURAL_32} 3_275_163_606)
					l_D := (((l_D).bit_shift_left (9))).bit_or (((l_D).bit_shift_right (23)))
					l_D := l_D + l_A
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_C := l_C + ((((l_A).bit_xor (((l_B).bit_and (((l_D).bit_xor (l_A)))))) + l_correct_words[3]) + {NATURAL_32} 4_107_603_335)
					l_C := (((l_C).bit_shift_left (14))).bit_or (((l_C).bit_shift_right (18)))
					l_C := l_C + l_D
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_B := l_B + ((((l_D).bit_xor (((l_A).bit_and (((l_C).bit_xor (l_D)))))) + l_correct_words[8]) + {NATURAL_32} 1_163_531_501)
					l_B := (((l_B).bit_shift_left (20))).bit_or (((l_B).bit_shift_right (12)))
					l_B := l_B + l_C
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_A := l_A + ((((l_C).bit_xor (((l_D).bit_and (((l_B).bit_xor (l_C)))))) + l_correct_words[13]) + {NATURAL_32} 2_850_285_829)
					l_A := (((l_A).bit_shift_left (5))).bit_or (((l_A).bit_shift_right (27)))
					l_A := l_A + l_B
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_D := l_D + ((((l_B).bit_xor (((l_C).bit_and (((l_A).bit_xor (l_B)))))) + l_correct_words[2]) + {NATURAL_32} 4_243_563_512)
					l_D := (((l_D).bit_shift_left (9))).bit_or (((l_D).bit_shift_right (23)))
					l_D := l_D + l_A
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_C := l_C + ((((l_A).bit_xor (((l_B).bit_and (((l_D).bit_xor (l_A)))))) + l_correct_words[7]) + {NATURAL_32} 1_735_328_473)
					l_C := (((l_C).bit_shift_left (14))).bit_or (((l_C).bit_shift_right (18)))
					l_C := l_C + l_D
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_B := l_B + ((((l_D).bit_xor (((l_A).bit_and (((l_C).bit_xor (l_D)))))) + l_correct_words[12]) + {NATURAL_32} 2_368_359_562)
					l_B := (((l_B).bit_shift_left (20))).bit_or (((l_B).bit_shift_right (12)))
					l_B := l_B + l_C
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_A := l_A + ((((((l_B).bit_xor (l_C))).bit_xor (l_D)) + l_correct_words[5]) + {NATURAL_32} 4_294_588_738)
					l_A := (((l_A).bit_shift_left (4))).bit_or (((l_A).bit_shift_right (28)))
					l_A := l_A + l_B
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_D := l_D + ((((((l_A).bit_xor (l_B))).bit_xor (l_C)) + l_correct_words[8]) + {NATURAL_32} 2_272_392_833)
					l_D := (((l_D).bit_shift_left (11))).bit_or (((l_D).bit_shift_right (21)))
					l_D := l_D + l_A
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_C := l_C + ((((((l_D).bit_xor (l_A))).bit_xor (l_B)) + l_correct_words[11]) + {NATURAL_32} 1_839_030_562)
					l_C := (((l_C).bit_shift_left (16))).bit_or (((l_C).bit_shift_right (16)))
					l_C := l_C + l_D
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_B := l_B + ((((((l_C).bit_xor (l_D))).bit_xor (l_A)) + l_correct_words[14]) + {NATURAL_32} 4_259_657_740)
					l_B := (((l_B).bit_shift_left (23))).bit_or (((l_B).bit_shift_right (9)))
					l_B := l_B + l_C
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_A := l_A + ((((((l_B).bit_xor (l_C))).bit_xor (l_D)) + l_correct_words[1]) + {NATURAL_32} 2_763_975_236)
					l_A := (((l_A).bit_shift_left (4))).bit_or (((l_A).bit_shift_right (28)))
					l_A := l_A + l_B
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_D := l_D + ((((((l_A).bit_xor (l_B))).bit_xor (l_C)) + l_correct_words[4]) + {NATURAL_32} 1_272_893_353)
					l_D := (((l_D).bit_shift_left (11))).bit_or (((l_D).bit_shift_right (21)))
					l_D := l_D + l_A
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_C := l_C + ((((((l_D).bit_xor (l_A))).bit_xor (l_B)) + l_correct_words[7]) + {NATURAL_32} 4_139_469_664)
					l_C := (((l_C).bit_shift_left (16))).bit_or (((l_C).bit_shift_right (16)))
					l_C := l_C + l_D
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_B := l_B + ((((((l_C).bit_xor (l_D))).bit_xor (l_A)) + l_correct_words[10]) + {NATURAL_32} 3_200_236_656)
					l_B := (((l_B).bit_shift_left (23))).bit_or (((l_B).bit_shift_right (9)))
					l_B := l_B + l_C
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_A := l_A + ((((((l_B).bit_xor (l_C))).bit_xor (l_D)) + l_correct_words[13]) + {NATURAL_32} 681_279_174)
					l_A := (((l_A).bit_shift_left (4))).bit_or (((l_A).bit_shift_right (28)))
					l_A := l_A + l_B
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_D := l_D + ((((((l_A).bit_xor (l_B))).bit_xor (l_C)) + l_correct_words[0]) + {NATURAL_32} 3_936_430_074)
					l_D := (((l_D).bit_shift_left (11))).bit_or (((l_D).bit_shift_right (21)))
					l_D := l_D + l_A
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_C := l_C + ((((((l_D).bit_xor (l_A))).bit_xor (l_B)) + l_correct_words[3]) + {NATURAL_32} 3_572_445_317)
					l_C := (((l_C).bit_shift_left (16))).bit_or (((l_C).bit_shift_right (16)))
					l_C := l_C + l_D
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_B := l_B + ((((((l_C).bit_xor (l_D))).bit_xor (l_A)) + l_correct_words[6]) + {NATURAL_32} 76_029_189)
					l_B := (((l_B).bit_shift_left (23))).bit_or (((l_B).bit_shift_right (9)))
					l_B := l_B + l_C
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_A := l_A + ((((((l_B).bit_xor (l_C))).bit_xor (l_D)) + l_correct_words[9]) + {NATURAL_32} 3_654_602_809)
					l_A := (((l_A).bit_shift_left (4))).bit_or (((l_A).bit_shift_right (28)))
					l_A := l_A + l_B
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_D := l_D + ((((((l_A).bit_xor (l_B))).bit_xor (l_C)) + l_correct_words[12]) + {NATURAL_32} 3_873_151_461)
					l_D := (((l_D).bit_shift_left (11))).bit_or (((l_D).bit_shift_right (21)))
					l_D := l_D + l_A
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_C := l_C + ((((((l_D).bit_xor (l_A))).bit_xor (l_B)) + l_correct_words[15]) + {NATURAL_32} 530_742_520)
					l_C := (((l_C).bit_shift_left (16))).bit_or (((l_C).bit_shift_right (16)))
					l_C := l_C + l_D
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_B := l_B + ((((((l_C).bit_xor (l_D))).bit_xor (l_A)) + l_correct_words[2]) + {NATURAL_32} 3_299_628_645)
					l_B := (((l_B).bit_shift_left (23))).bit_or (((l_B).bit_shift_right (9)))
					l_B := l_B + l_C
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_A := l_A + ((((l_C).bit_xor (((l_B).bit_or ((l_D).bit_not)))) + l_correct_words[0]) + {NATURAL_32} 4_096_336_452)
					l_A := (((l_A).bit_shift_left (6))).bit_or (((l_A).bit_shift_right (26)))
					l_A := l_A + l_B
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_D := l_D + ((((l_B).bit_xor (((l_A).bit_or ((l_C).bit_not)))) + l_correct_words[7]) + {NATURAL_32} 1_126_891_415)
					l_D := (((l_D).bit_shift_left (10))).bit_or (((l_D).bit_shift_right (22)))
					l_D := l_D + l_A
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_C := l_C + ((((l_A).bit_xor (((l_D).bit_or ((l_B).bit_not)))) + l_correct_words[14]) + {NATURAL_32} 2_878_612_391)
					l_C := (((l_C).bit_shift_left (15))).bit_or (((l_C).bit_shift_right (17)))
					l_C := l_C + l_D
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_B := l_B + ((((l_D).bit_xor (((l_C).bit_or ((l_A).bit_not)))) + l_correct_words[5]) + {NATURAL_32} 4_237_533_241)
					l_B := (((l_B).bit_shift_left (21))).bit_or (((l_B).bit_shift_right (11)))
					l_B := l_B + l_C
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_A := l_A + ((((l_C).bit_xor (((l_B).bit_or ((l_D).bit_not)))) + l_correct_words[12]) + {NATURAL_32} 1_700_485_571)
					l_A := (((l_A).bit_shift_left (6))).bit_or (((l_A).bit_shift_right (26)))
					l_A := l_A + l_B
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_D := l_D + ((((l_B).bit_xor (((l_A).bit_or ((l_C).bit_not)))) + l_correct_words[3]) + {NATURAL_32} 2_399_980_690)
					l_D := (((l_D).bit_shift_left (10))).bit_or (((l_D).bit_shift_right (22)))
					l_D := l_D + l_A
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_C := l_C + ((((l_A).bit_xor (((l_D).bit_or ((l_B).bit_not)))) + l_correct_words[10]) + {NATURAL_32} 4_293_915_773)
					l_C := (((l_C).bit_shift_left (15))).bit_or (((l_C).bit_shift_right (17)))
					l_C := l_C + l_D
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_B := l_B + ((((l_D).bit_xor (((l_C).bit_or ((l_A).bit_not)))) + l_correct_words[1]) + {NATURAL_32} 2_240_044_497)
					l_B := (((l_B).bit_shift_left (21))).bit_or (((l_B).bit_shift_right (11)))
					l_B := l_B + l_C
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_A := l_A + ((((l_C).bit_xor (((l_B).bit_or ((l_D).bit_not)))) + l_correct_words[8]) + {NATURAL_32} 1_873_313_359)
					l_A := (((l_A).bit_shift_left (6))).bit_or (((l_A).bit_shift_right (26)))
					l_A := l_A + l_B
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_D := l_D + ((((l_B).bit_xor (((l_A).bit_or ((l_C).bit_not)))) + l_correct_words[15]) + {NATURAL_32} 4_264_355_552)
					l_D := (((l_D).bit_shift_left (10))).bit_or (((l_D).bit_shift_right (22)))
					l_D := l_D + l_A
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_C := l_C + ((((l_A).bit_xor (((l_D).bit_or ((l_B).bit_not)))) + l_correct_words[6]) + {NATURAL_32} 2_734_768_916)
					l_C := (((l_C).bit_shift_left (15))).bit_or (((l_C).bit_shift_right (17)))
					l_C := l_C + l_D
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_B := l_B + ((((l_D).bit_xor (((l_C).bit_or ((l_A).bit_not)))) + l_correct_words[13]) + {NATURAL_32} 1_309_151_649)
					l_B := (((l_B).bit_shift_left (21))).bit_or (((l_B).bit_shift_right (11)))
					l_B := l_B + l_C
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_A := l_A + ((((l_C).bit_xor (((l_B).bit_or ((l_D).bit_not)))) + l_correct_words[4]) + {NATURAL_32} 4_149_444_226)
					l_A := (((l_A).bit_shift_left (6))).bit_or (((l_A).bit_shift_right (26)))
					l_A := l_A + l_B
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_D := l_D + ((((l_B).bit_xor (((l_A).bit_or ((l_C).bit_not)))) + l_correct_words[11]) + {NATURAL_32} 3_174_756_917)
					l_D := (((l_D).bit_shift_left (10))).bit_or (((l_D).bit_shift_right (22)))
					l_D := l_D + l_A
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_C := l_C + ((((l_A).bit_xor (((l_D).bit_or ((l_B).bit_not)))) + l_correct_words[2]) + {NATURAL_32} 718_787_259)
					l_C := (((l_C).bit_shift_left (15))).bit_or (((l_C).bit_shift_right (17)))
					l_C := l_C + l_D
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_B := l_B + ((((l_D).bit_xor (((l_C).bit_or ((l_A).bit_not)))) + l_correct_words[9]) + {NATURAL_32} 3_951_481_745)
					l_B := (((l_B).bit_shift_left (21))).bit_or (((l_B).bit_shift_right (11)))
					l_B := l_B + l_C
					l_break := True
				end
				l_break := False
				l_A := l_A + l_A_save
				l_B := l_B + l_B_save
				l_C := l_C + l_C_save
				l_D := l_D + l_D_save
			end
			Current.A := l_A
			update_class_fields -- Current might have been changed; synchronize
			Current.B := l_B
			update_class_fields -- Current might have been changed; synchronize
			Current.C := l_C
			update_class_fields -- Current might have been changed; synchronize
			Current.D := l_D
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_MD5_CTX} -- private routines

	set_uint32 (a_cp: CE_POINTER [INTEGER_8]; a_v: NATURAL_32)
		local
			l_v: CE_ARRAY [NATURAL_32]
		do
			create {CE_NATURAL_32_ARRAY} l_v.make (<<1>>)

			l_v.item := a_v
			memcpy (create {CE_VOID_POINTER}.make_cast (a_cp), create {CE_VOID_POINTER}.make_cast (l_v), {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
		end

feature {ANY}

	copy (a_other: like Current)
		do
			A := a_other.A
			B := a_other.B
			C := a_other.C
			D := a_other.D
			total := a_other.total.twin
			buflen := a_other.buflen
			buffer := a_other.buffer.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				A = a_other.A and
				B = a_other.B and
				C = a_other.C and
				D = a_other.D and
				total.is_equal (a_other.total) and
				buflen = a_other.buflen and
				buffer.is_equal (a_other.buffer)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("A"),
					create {CE_STRUCTURE_FIELD}.make ("B"),
					create {CE_STRUCTURE_FIELD}.make ("C"),
					create {CE_STRUCTURE_FIELD}.make ("D"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("total", <<2>>),
					create {CE_STRUCTURE_FIELD}.make ("buflen"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("buffer", <<32>>)
				>>)
			init_structure_info
		end

end
