class
	PD_REQUEST_HEADER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} name.make
			create {CE_INTEGER_8_POINTER} value.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	value: CE_POINTER [INTEGER_8] assign set_value

	release_policy: NATURAL_32 assign set_release_policy

feature {ANY} -- field setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_value (a_value: CE_POINTER [INTEGER_8])
		do
			value := a_value
			update_memory_field ("value")
		end

	set_release_policy (a_release_policy: NATURAL_32)
		do
			release_policy := a_release_policy
			update_memory_field ("release_policy")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			value := a_other.value
			release_policy := a_other.release_policy
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				value.is_equal (a_other.value) and
				release_policy = a_other.release_policy
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("value"),
					create {CE_STRUCTURE_FIELD}.make ("release_policy")
				>>)
			init_structure_info
		end

end
