class
	PD_RESPONSE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} data.make
			create {CE_POINTER_POINTER [INTEGER_8]} headers.make
			Precursor
		end

feature {ANY} -- fields

	data: CE_POINTER [INTEGER_8] assign set_data

	headers: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_headers

feature {ANY} -- field setters

	set_data (a_data: CE_POINTER [INTEGER_8])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_headers (a_headers: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			headers := a_headers
			update_memory_field ("headers")
		end

feature {ANY} -- public routines

	print_server_response (a_prefix: CE_POINTER [INTEGER_8])
		local
			l_i: INTEGER_32
			l_b: CE_POINTER [INTEGER_8]
			l_e: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			if headers.is_void then
				l_return := True
			end
			if not l_return then
				l_i := 0
				from
				until
					(headers[(l_i + 1)]).is_void
				loop
					l_b := headers[l_i]
					l_e := headers[(l_i + 1)]
					if (l_b.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32 then
						if (l_e[-1]).to_integer_32 = 10 then
							l_e := l_e - 1
						end
					end
					if (l_b.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32 then
						if (l_e[-1]).to_integer_32 = 13 then
							l_e := l_e - 1
						end
					end
					print_response_line (a_prefix, l_b, l_e)
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
			end
		end

feature {PD_RESPONSE} -- private routines

	print_response_line (a_prefix, a_b, a_e: CE_POINTER [INTEGER_8])
		local
			l_copy: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_BTA_beg: CE_POINTER [INTEGER_8]
			l_BTA_len: INTEGER_32
			l_BTA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_copy.make (<<1>>)

			from
			until
				(l_break)
			loop
				l_break := False
				l_BTA_beg := a_b
				l_BTA_len := a_e.distance (l_BTA_beg)
				l_BTA_dest := l_copy
				l_BTA_dest.item := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new ((l_BTA_len + 1).to_natural_32)))
				memcpy (create {CE_VOID_POINTER}.make_cast (l_BTA_dest.item), create {CE_VOID_POINTER}.make_cast (l_BTA_beg), l_BTA_len.to_natural_32).do_nothing
				l_BTA_dest.item[l_BTA_len] := (('%/0/').code).to_integer_8
				l_break := True
			end
			l_break := False;
			(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_ALWAYS, ce_string ("%%s%%s%N"), a_prefix, ((create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_copy.item))])
		end

feature {ANY}

	copy (a_other: like Current)
		do
			data := a_other.data
			headers := a_other.headers
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				data.is_equal (a_other.data) and
				headers.is_equal (a_other.headers)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("headers")
				>>)
			init_structure_info
		end

end
