class
	PD_ROBOT_SPECS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_PATH_INFO]} paths.make
			Precursor
		end

feature {ANY} -- fields

	count: INTEGER_32 assign set_count

	size: INTEGER_32 assign set_size

	paths: CE_POINTER [PD_PATH_INFO] assign set_paths

feature {ANY} -- field setters

	set_count (a_count: INTEGER_32)
		do
			count := a_count
			update_memory_field ("count")
		end

	set_size (a_size: INTEGER_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_paths (a_paths: CE_POINTER [PD_PATH_INFO])
		do
			paths := a_paths
			update_memory_field ("paths")
		end

feature {ANY} -- public routines

	free_specs
		local
			l_i: INTEGER_32
		do
			l_i := 0
			from
			until
				not (l_i < count)
			loop
				free (create {CE_VOID_POINTER}.make_cast ((paths + l_i).item.path))
				update_class_fields -- Current might have been changed; synchronize
				l_i := l_i + 1
			end
			if (not paths.is_void) then
				free (create {CE_VOID_POINTER}.make_cast (paths))
				update_class_fields -- Current might have been changed; synchronize
			end
			free (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			count := a_other.count
			size := a_other.size
			paths := a_other.paths
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				count = a_other.count and
				size = a_other.size and
				paths.is_equal (a_other.paths)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("count"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("paths")
				>>)
			init_structure_info
		end

end
