class
	PD_TAGSTACK_ITEM

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} tagname_begin.make
			create {CE_INTEGER_8_POINTER} tagname_end.make
			create {CE_INTEGER_8_POINTER} contents_begin.make
			create {CE_CLASS_POINTER [PD_TAGSTACK_ITEM]} prev.make
			create {CE_CLASS_POINTER [PD_TAGSTACK_ITEM]} next.make
		end

feature {ANY} -- fields

	tagname_begin: CE_POINTER [INTEGER_8] assign set_tagname_begin

	tagname_end: CE_POINTER [INTEGER_8] assign set_tagname_end

	contents_begin: CE_POINTER [INTEGER_8] assign set_contents_begin

	prev: CE_POINTER [PD_TAGSTACK_ITEM] assign set_prev

	next: CE_POINTER [PD_TAGSTACK_ITEM] assign set_next

feature {ANY} -- field setters

	set_tagname_begin (a_tagname_begin: CE_POINTER [INTEGER_8])
		do
			tagname_begin := a_tagname_begin
			update_memory_field ("tagname_begin")
		end

	set_tagname_end (a_tagname_end: CE_POINTER [INTEGER_8])
		do
			tagname_end := a_tagname_end
			update_memory_field ("tagname_end")
		end

	set_contents_begin (a_contents_begin: CE_POINTER [INTEGER_8])
		do
			contents_begin := a_contents_begin
			update_memory_field ("contents_begin")
		end

	set_prev (a_prev: CE_POINTER [PD_TAGSTACK_ITEM])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_next (a_next: CE_POINTER [PD_TAGSTACK_ITEM])
		do
			next := a_next
			update_memory_field ("next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tagname_begin := a_other.tagname_begin
			tagname_end := a_other.tagname_end
			contents_begin := a_other.contents_begin
			prev := a_other.prev
			next := a_other.next
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tagname_begin.is_equal (a_other.tagname_begin) and
				tagname_end.is_equal (a_other.tagname_end) and
				contents_begin.is_equal (a_other.contents_begin) and
				prev.is_equal (a_other.prev) and
				next.is_equal (a_other.next)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tagname_begin"),
					create {CE_STRUCTURE_FIELD}.make ("tagname_end"),
					create {CE_STRUCTURE_FIELD}.make ("contents_begin"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("next")
				>>)
			init_structure_info
		end

end
