class
	PD_WEIGHED_COOKIE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_COOKIE]} cookie.make
		end

feature {ANY} -- fields

	cookie: CE_POINTER [PD_COOKIE] assign set_cookie

	domain_goodness: INTEGER_32 assign set_domain_goodness

	path_goodness: INTEGER_32 assign set_path_goodness

feature {ANY} -- field setters

	set_cookie (a_cookie: CE_POINTER [PD_COOKIE])
		do
			cookie := a_cookie
			update_memory_field ("cookie")
		end

	set_domain_goodness (a_domain_goodness: INTEGER_32)
		do
			domain_goodness := a_domain_goodness
			update_memory_field ("domain_goodness")
		end

	set_path_goodness (a_path_goodness: INTEGER_32)
		do
			path_goodness := a_path_goodness
			update_memory_field ("path_goodness")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			cookie := a_other.cookie
			domain_goodness := a_other.domain_goodness
			path_goodness := a_other.path_goodness
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				cookie.is_equal (a_other.cookie) and
				domain_goodness = a_other.domain_goodness and
				path_goodness = a_other.path_goodness
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("cookie"),
					create {CE_STRUCTURE_FIELD}.make ("domain_goodness"),
					create {CE_STRUCTURE_FIELD}.make ("path_goodness")
				>>)
			init_structure_info
		end

end
