class
	SD_LCONV

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} decimal_point.make
			create {CE_INTEGER_8_POINTER} thousands_sep.make
			create {CE_INTEGER_8_POINTER} grouping.make
			create {CE_INTEGER_8_POINTER} int_curr_symbol.make
			create {CE_INTEGER_8_POINTER} currency_symbol.make
			create {CE_INTEGER_8_POINTER} mon_decimal_point.make
			create {CE_INTEGER_8_POINTER} mon_thousands_sep.make
			create {CE_INTEGER_8_POINTER} mon_grouping.make
			create {CE_INTEGER_8_POINTER} positive_sign.make
			create {CE_INTEGER_8_POINTER} negative_sign.make
		end

feature {ANY} -- fields

	decimal_point: CE_POINTER [INTEGER_8] assign set_decimal_point

	thousands_sep: CE_POINTER [INTEGER_8] assign set_thousands_sep

	grouping: CE_POINTER [INTEGER_8] assign set_grouping

	int_curr_symbol: CE_POINTER [INTEGER_8] assign set_int_curr_symbol

	currency_symbol: CE_POINTER [INTEGER_8] assign set_currency_symbol

	mon_decimal_point: CE_POINTER [INTEGER_8] assign set_mon_decimal_point

	mon_thousands_sep: CE_POINTER [INTEGER_8] assign set_mon_thousands_sep

	mon_grouping: CE_POINTER [INTEGER_8] assign set_mon_grouping

	positive_sign: CE_POINTER [INTEGER_8] assign set_positive_sign

	negative_sign: CE_POINTER [INTEGER_8] assign set_negative_sign

	int_frac_digits: INTEGER_8 assign set_int_frac_digits

	frac_digits: INTEGER_8 assign set_frac_digits

	p_cs_precedes: INTEGER_8 assign set_p_cs_precedes

	p_sep_by_space: INTEGER_8 assign set_p_sep_by_space

	n_cs_precedes: INTEGER_8 assign set_n_cs_precedes

	n_sep_by_space: INTEGER_8 assign set_n_sep_by_space

	p_sign_posn: INTEGER_8 assign set_p_sign_posn

	n_sign_posn: INTEGER_8 assign set_n_sign_posn

	int_p_cs_precedes: INTEGER_8 assign set_int_p_cs_precedes

	int_p_sep_by_space: INTEGER_8 assign set_int_p_sep_by_space

	int_n_cs_precedes: INTEGER_8 assign set_int_n_cs_precedes

	int_n_sep_by_space: INTEGER_8 assign set_int_n_sep_by_space

	int_p_sign_posn: INTEGER_8 assign set_int_p_sign_posn

	int_n_sign_posn: INTEGER_8 assign set_int_n_sign_posn

feature {ANY} -- field setters

	set_decimal_point (a_decimal_point: CE_POINTER [INTEGER_8])
		do
			decimal_point := a_decimal_point
			update_memory_field ("decimal_point")
		end

	set_thousands_sep (a_thousands_sep: CE_POINTER [INTEGER_8])
		do
			thousands_sep := a_thousands_sep
			update_memory_field ("thousands_sep")
		end

	set_grouping (a_grouping: CE_POINTER [INTEGER_8])
		do
			grouping := a_grouping
			update_memory_field ("grouping")
		end

	set_int_curr_symbol (a_int_curr_symbol: CE_POINTER [INTEGER_8])
		do
			int_curr_symbol := a_int_curr_symbol
			update_memory_field ("int_curr_symbol")
		end

	set_currency_symbol (a_currency_symbol: CE_POINTER [INTEGER_8])
		do
			currency_symbol := a_currency_symbol
			update_memory_field ("currency_symbol")
		end

	set_mon_decimal_point (a_mon_decimal_point: CE_POINTER [INTEGER_8])
		do
			mon_decimal_point := a_mon_decimal_point
			update_memory_field ("mon_decimal_point")
		end

	set_mon_thousands_sep (a_mon_thousands_sep: CE_POINTER [INTEGER_8])
		do
			mon_thousands_sep := a_mon_thousands_sep
			update_memory_field ("mon_thousands_sep")
		end

	set_mon_grouping (a_mon_grouping: CE_POINTER [INTEGER_8])
		do
			mon_grouping := a_mon_grouping
			update_memory_field ("mon_grouping")
		end

	set_positive_sign (a_positive_sign: CE_POINTER [INTEGER_8])
		do
			positive_sign := a_positive_sign
			update_memory_field ("positive_sign")
		end

	set_negative_sign (a_negative_sign: CE_POINTER [INTEGER_8])
		do
			negative_sign := a_negative_sign
			update_memory_field ("negative_sign")
		end

	set_int_frac_digits (a_int_frac_digits: INTEGER_8)
		do
			int_frac_digits := a_int_frac_digits
			update_memory_field ("int_frac_digits")
		end

	set_frac_digits (a_frac_digits: INTEGER_8)
		do
			frac_digits := a_frac_digits
			update_memory_field ("frac_digits")
		end

	set_p_cs_precedes (a_p_cs_precedes: INTEGER_8)
		do
			p_cs_precedes := a_p_cs_precedes
			update_memory_field ("p_cs_precedes")
		end

	set_p_sep_by_space (a_p_sep_by_space: INTEGER_8)
		do
			p_sep_by_space := a_p_sep_by_space
			update_memory_field ("p_sep_by_space")
		end

	set_n_cs_precedes (a_n_cs_precedes: INTEGER_8)
		do
			n_cs_precedes := a_n_cs_precedes
			update_memory_field ("n_cs_precedes")
		end

	set_n_sep_by_space (a_n_sep_by_space: INTEGER_8)
		do
			n_sep_by_space := a_n_sep_by_space
			update_memory_field ("n_sep_by_space")
		end

	set_p_sign_posn (a_p_sign_posn: INTEGER_8)
		do
			p_sign_posn := a_p_sign_posn
			update_memory_field ("p_sign_posn")
		end

	set_n_sign_posn (a_n_sign_posn: INTEGER_8)
		do
			n_sign_posn := a_n_sign_posn
			update_memory_field ("n_sign_posn")
		end

	set_int_p_cs_precedes (a_int_p_cs_precedes: INTEGER_8)
		do
			int_p_cs_precedes := a_int_p_cs_precedes
			update_memory_field ("int_p_cs_precedes")
		end

	set_int_p_sep_by_space (a_int_p_sep_by_space: INTEGER_8)
		do
			int_p_sep_by_space := a_int_p_sep_by_space
			update_memory_field ("int_p_sep_by_space")
		end

	set_int_n_cs_precedes (a_int_n_cs_precedes: INTEGER_8)
		do
			int_n_cs_precedes := a_int_n_cs_precedes
			update_memory_field ("int_n_cs_precedes")
		end

	set_int_n_sep_by_space (a_int_n_sep_by_space: INTEGER_8)
		do
			int_n_sep_by_space := a_int_n_sep_by_space
			update_memory_field ("int_n_sep_by_space")
		end

	set_int_p_sign_posn (a_int_p_sign_posn: INTEGER_8)
		do
			int_p_sign_posn := a_int_p_sign_posn
			update_memory_field ("int_p_sign_posn")
		end

	set_int_n_sign_posn (a_int_n_sign_posn: INTEGER_8)
		do
			int_n_sign_posn := a_int_n_sign_posn
			update_memory_field ("int_n_sign_posn")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			decimal_point := a_other.decimal_point
			thousands_sep := a_other.thousands_sep
			grouping := a_other.grouping
			int_curr_symbol := a_other.int_curr_symbol
			currency_symbol := a_other.currency_symbol
			mon_decimal_point := a_other.mon_decimal_point
			mon_thousands_sep := a_other.mon_thousands_sep
			mon_grouping := a_other.mon_grouping
			positive_sign := a_other.positive_sign
			negative_sign := a_other.negative_sign
			int_frac_digits := a_other.int_frac_digits
			frac_digits := a_other.frac_digits
			p_cs_precedes := a_other.p_cs_precedes
			p_sep_by_space := a_other.p_sep_by_space
			n_cs_precedes := a_other.n_cs_precedes
			n_sep_by_space := a_other.n_sep_by_space
			p_sign_posn := a_other.p_sign_posn
			n_sign_posn := a_other.n_sign_posn
			int_p_cs_precedes := a_other.int_p_cs_precedes
			int_p_sep_by_space := a_other.int_p_sep_by_space
			int_n_cs_precedes := a_other.int_n_cs_precedes
			int_n_sep_by_space := a_other.int_n_sep_by_space
			int_p_sign_posn := a_other.int_p_sign_posn
			int_n_sign_posn := a_other.int_n_sign_posn
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				decimal_point.is_equal (a_other.decimal_point) and
				thousands_sep.is_equal (a_other.thousands_sep) and
				grouping.is_equal (a_other.grouping) and
				int_curr_symbol.is_equal (a_other.int_curr_symbol) and
				currency_symbol.is_equal (a_other.currency_symbol) and
				mon_decimal_point.is_equal (a_other.mon_decimal_point) and
				mon_thousands_sep.is_equal (a_other.mon_thousands_sep) and
				mon_grouping.is_equal (a_other.mon_grouping) and
				positive_sign.is_equal (a_other.positive_sign) and
				negative_sign.is_equal (a_other.negative_sign) and
				int_frac_digits = a_other.int_frac_digits and
				frac_digits = a_other.frac_digits and
				p_cs_precedes = a_other.p_cs_precedes and
				p_sep_by_space = a_other.p_sep_by_space and
				n_cs_precedes = a_other.n_cs_precedes and
				n_sep_by_space = a_other.n_sep_by_space and
				p_sign_posn = a_other.p_sign_posn and
				n_sign_posn = a_other.n_sign_posn and
				int_p_cs_precedes = a_other.int_p_cs_precedes and
				int_p_sep_by_space = a_other.int_p_sep_by_space and
				int_n_cs_precedes = a_other.int_n_cs_precedes and
				int_n_sep_by_space = a_other.int_n_sep_by_space and
				int_p_sign_posn = a_other.int_p_sign_posn and
				int_n_sign_posn = a_other.int_n_sign_posn
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("decimal_point"),
					create {CE_STRUCTURE_FIELD}.make ("thousands_sep"),
					create {CE_STRUCTURE_FIELD}.make ("grouping"),
					create {CE_STRUCTURE_FIELD}.make ("int_curr_symbol"),
					create {CE_STRUCTURE_FIELD}.make ("currency_symbol"),
					create {CE_STRUCTURE_FIELD}.make ("mon_decimal_point"),
					create {CE_STRUCTURE_FIELD}.make ("mon_thousands_sep"),
					create {CE_STRUCTURE_FIELD}.make ("mon_grouping"),
					create {CE_STRUCTURE_FIELD}.make ("positive_sign"),
					create {CE_STRUCTURE_FIELD}.make ("negative_sign"),
					create {CE_STRUCTURE_FIELD}.make ("int_frac_digits"),
					create {CE_STRUCTURE_FIELD}.make ("frac_digits"),
					create {CE_STRUCTURE_FIELD}.make ("p_cs_precedes"),
					create {CE_STRUCTURE_FIELD}.make ("p_sep_by_space"),
					create {CE_STRUCTURE_FIELD}.make ("n_cs_precedes"),
					create {CE_STRUCTURE_FIELD}.make ("n_sep_by_space"),
					create {CE_STRUCTURE_FIELD}.make ("p_sign_posn"),
					create {CE_STRUCTURE_FIELD}.make ("n_sign_posn"),
					create {CE_STRUCTURE_FIELD}.make ("int_p_cs_precedes"),
					create {CE_STRUCTURE_FIELD}.make ("int_p_sep_by_space"),
					create {CE_STRUCTURE_FIELD}.make ("int_n_cs_precedes"),
					create {CE_STRUCTURE_FIELD}.make ("int_n_sep_by_space"),
					create {CE_STRUCTURE_FIELD}.make ("int_p_sign_posn"),
					create {CE_STRUCTURE_FIELD}.make ("int_n_sign_posn")
				>>)
			init_structure_info
		end

end
