class
	P_CACHE_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_UNISTD_STATIC

feature {ANY} -- public attributes

	cache: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (cache.item), create {CE_VOID_POINTER}.make_cast (cache.item)])
		end

	cache_size: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	cache_count: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	page_size: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 4_096
		end

feature {ANY} -- public routines

	extract_proxy (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_a: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_url))) < {NATURAL_32} 8 then
				Result := a_url
				l_return := True
			elseif ((create {P_LINKS_STATIC}).casecmp (a_url, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("proxy://")), (8).to_natural_32)).to_boolean then
				Result := a_url
				l_return := True
			end
			if not l_return then
				l_a := strchr (create {CE_INTEGER_8_POINTER}.make_cast ((a_url + 8)), ('/').code)
				if l_a.is_void then
					Result := a_url
					l_return := True
				end
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast ((l_a + 1)))
			end
		end

	find_in_cache (a_url: CE_POINTER [NATURAL_8]; a_f: CE_POINTER [CE_POINTER [PD_CACHE_ENTRY]]): INTEGER_32
		local
			l_url: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [PD_CACHE_ENTRY]
			l_return, l_break: BOOLEAN
		do
			l_url := a_url
			l_url := extract_proxy (l_url)
			l_e := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_cast (cache.item.item.next)
			from
			until
				not (not (l_return) and then (not l_e.is_equal (cache.item)))
			loop
				if not (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_e.item.url), create {CE_INTEGER_8_POINTER}.make_cast (l_url))).to_boolean then
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_e));
					(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_e.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_e.item.prev);
					(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_e.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_e.item.next);
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_e))
					from
					until
						(l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (cache.item))
						l_e.item.next := (create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_cast (cache.item)).item.next
						l_e.item.prev := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_cast (cache.item);
						(create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_cast (cache.item)).item.next := l_e;
						(l_e.item.next).item.prev := l_e;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (cache.item))
						l_break := True
					end
					l_break := False
					a_f.item := l_e
					Result := 0
					l_return := True
				end
				if not l_return then
					l_e := l_e.item.next
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

	get_cache_entry (a_url: CE_POINTER [NATURAL_8]; a_f: CE_POINTER [CE_POINTER [PD_CACHE_ENTRY]]): INTEGER_32
		local
			l_url: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [PD_CACHE_ENTRY]
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_url := a_url
			if not (find_in_cache (l_url, a_f)).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				(create {P_MAIN_STATIC}).shrink_memory (0)
				l_url := extract_proxy (l_url)
				l_e := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 60, (create {PD_CACHE_ENTRY}.make).structure_size.to_natural_32)))
				memset (create {CE_VOID_POINTER}.make_cast (l_e), 0, (create {PD_CACHE_ENTRY}.make).structure_size.to_natural_32).do_nothing
				l_e.item.url := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 62, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_url))) + {NATURAL_32} 1)))
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_e.item.url), create {CE_INTEGER_8_POINTER}.make_cast (l_url)).do_nothing
				l_e.item.length := (0).to_integer_32
				l_e.item.incomplete := 1
				l_e.item.data_size := (0).to_integer_32;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))))
				l_e.item.frag.next := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))))
				l_e.item.frag.prev := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))));
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))))
				l_tmp___3 := cache_count.item
				cache_count.item := cache_count.item + 1
				l_e.item.count := l_tmp___3.to_natural_32
				l_e.item.refcount := 0
				from
				until
					(l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (cache.item))
					l_e.item.next := (create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_cast (cache.item)).item.next
					l_e.item.prev := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_cast (cache.item);
					(create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_cast (cache.item)).item.next := l_e;
					(l_e.item.next).item.prev := l_e;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (cache.item))
					l_break := True
				end
				l_break := False
				a_f.item := l_e
				Result := 0
			end
		end

	garbage_collection (a_u: INTEGER_32)
		local
			l_e: CE_POINTER [PD_CACHE_ENTRY]
			l_f: CE_POINTER [PD_CACHE_ENTRY]
			l_ncs: INTEGER_32
			l_ccs: INTEGER_32
			l_no: INTEGER_32
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [PD_CACHE_ENTRY]} l_e.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ncs := cache_size.item
					l_ccs := 0
					l_no := 0
					if not a_u.to_boolean then
						if cache_size.item <= (create {P_DEFAULT_STATIC}).memory_cache_size.item.item then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_e := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_cast (cache.item.item.next)
				when 2 then -- loop condition:
						if not (not (l_return) and then (not l_e.is_equal (cache.item))) then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						if not ((l_e.item.refcount).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if not (((create {P_SCHED_STATIC}).is_entry_used (l_e)).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_ncs := l_ncs - (l_e.item.data_size)
						if l_ncs < 0 then
							from
							until
								False
							loop
								(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c"));
								(create {P_LINKS_STATIC}).errline.item := 295;
								(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache_size underflow: %%ld")), l_ncs])
							end
							l_ncs := 0
						end
				when 8 then -- if done
						l_ccs := l_ccs + (l_e.item.data_size)
						l_e := l_e.item.next
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done
						if l_ccs /= cache_size.item then
							from
							until
								False
							loop
								(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c"));
								(create {P_LINKS_STATIC}).errline.item := 300;
								(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache size badly computed: %%ld != %%ld")), cache_size.item, l_ccs])
								cache_size.item := l_ccs
							end
						end
						if not a_u.to_boolean then
							if l_ncs <= (create {P_DEFAULT_STATIC}).memory_cache_size.item.item then
								l_return := True
							end
						end
				when 10 then -- if done
					if l_return then
						l_pos := -1 + 17 -- skip if block
					end
				when 11 then -- if:
						l_e := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_cast (cache.item.item.prev)
				when 12 then -- loop condition:
						if not (not (l_return) and then (not l_e.is_equal (cache.item))) then
							l_pos := -1 + 15 -- skip loop
						end
				when 13 then -- loop body:
						l_continue := False
						if not a_u.to_boolean then
							if l_ncs <= ((create {P_DEFAULT_STATIC}).memory_cache_size.item.item * 9) // 10 then
								l_pos := -1 + 16 -- goto g
							end
						end
				when 14 then
						if (l_e.item.refcount).to_boolean then
							l_no := 1
							l_e.item.tgc := 0
							l_continue := True
						elseif ((create {P_SCHED_STATIC}).is_entry_used (l_e)).to_boolean then
							l_no := 1
							l_e.item.tgc := 0
							l_continue := True
						end
						if not (l_return or l_continue) then
							l_e.item.tgc := 1
							l_ncs := l_ncs - (l_e.item.data_size)
							if l_ncs < 0 then
								from
								until
									False
								loop
									(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c"));
									(create {P_LINKS_STATIC}).errline.item := 311;
									(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache_size underflow: %%ld")), l_ncs])
								end
								l_ncs := 0
							end
						end
						if (not l_return) then
							l_e := l_e.item.prev
						end
						l_pos := -1 + 12 -- back to loop condition
				when 15 then -- loop done
						l_continue := False
						if l_ncs.to_boolean then
							from
							until
								False
							loop
								(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c"));
								(create {P_LINKS_STATIC}).errline.item := 315;
								(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache_size(%%ld) is larger than size of all objects(%%ld)")), cache_size.item, cache_size.item - l_ncs])
							end
						end
				when 16 then -- g:
						l_e := l_e.item.next
						if l_e.is_equal (cache.item) then
							l_return := True
						end
				when 17 then -- if done
					if not l_return then
						if not a_u.to_boolean then
							l_f := l_e
							from
							until
								l_f.is_equal (cache.item)
							loop
								if l_ncs + l_f.item.data_size <= ((create {P_DEFAULT_STATIC}).memory_cache_size.item.item * 9) // 10 then
									l_ncs := l_ncs + (l_f.item.data_size)
									l_f.item.tgc := 0
								end
								l_f := l_f.item.next
							end
						end
						l_f := l_e
						from
						until
							l_f.is_equal (cache.item)
						loop
							l_f := l_f.item.next
							if ((l_f.item.prev).item.tgc).to_boolean then
								(l_f.item.prev).item.delete_cache_entry
							end
						end
					end
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	init_cache
		local
			l_tmp___1: INTEGER_32
		do
			if (getpagesize).to_boolean then
				if (getpagesize) < 65_536 then
					l_tmp___1 := getpagesize
					if not ((l_tmp___1).bit_and (((getpagesize) - 1))).to_boolean then
						page_size.item := getpagesize
					end
				end
			end
		end

end
