class
	P_COOKIES_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC

feature {ANY} -- public attributes

	cookies: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (cookies.item), create {CE_VOID_POINTER}.make_cast (cookies.item)])
		end

	c2_domains: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (c2_domains.item), create {CE_VOID_POINTER}.make_cast (c2_domains.item)])
		end

	c2_servers: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (c2_servers.item), create {CE_VOID_POINTER}.make_cast (c2_servers.item)])
		end

feature {ANY} -- public routines

	find_cookie_id (a_idp: CE_POINTER [ANY]): CE_POINTER [PD_COOKIE]
		local
			l_id: INTEGER_32
			l_c: CE_POINTER [PD_COOKIE]
			l_return: BOOLEAN
		do
			l_id := (a_idp.c_pointer.to_integer_32).to_integer_32
			l_c := create {CE_CLASS_POINTER [PD_COOKIE]}.make_cast (cookies.item.item.next)
			from
			until
				not (not (l_return) and then (not l_c.is_equal (cookies.item)))
			loop
				if l_c.item.id = l_id then
					Result := l_c
					l_return := True
				end
				if not l_return then
					l_c := l_c.item.next
				end
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer))
			end
		end

	reject_cookie (a_idp: CE_POINTER [ANY])
		local
			l_c: CE_POINTER [PD_COOKIE]
			l_return: BOOLEAN
		do
			l_c := find_cookie_id (a_idp)
			if l_c.is_void then
				l_return := True
			end
			if not l_return then
				l_c.item.delete_cookie
			end
		end

	cookie_default (a_idp: CE_POINTER [ANY]; a_a: INTEGER_32)
		local
			l_c: CE_POINTER [PD_COOKIE]
			l_s: CE_POINTER [PD_C2_SERVER]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := find_cookie_id (a_idp)
					if l_c.is_void then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_s := create {CE_CLASS_POINTER [PD_C2_SERVER]}.make_cast (c2_servers.item.item.next)
				when 2 then -- loop condition:
						if l_s.is_equal (c2_servers.item) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if not (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_s.item.server)), create {CE_INTEGER_8_POINTER}.make_cast (l_c.item.server))).to_boolean then
							l_pos := -1 + 6 -- goto found
						end
				when 4 then
						l_s := l_s.item.next
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						l_s := create {CE_CLASS_POINTER [PD_C2_SERVER]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 216, ((create {PD_C2_SERVER}.make).structure_size.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_c.item.server)))) + {NATURAL_32} 1)))
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_s.item.server)), create {CE_INTEGER_8_POINTER}.make_cast (l_c.item.server)).do_nothing
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (c2_servers.item))
							l_s.item.next := (create {CE_CLASS_POINTER [PD_C2_SERVER]}.make_cast (c2_servers.item)).item.next
							l_s.item.prev := create {CE_CLASS_POINTER [PD_C2_SERVER]}.make_cast (c2_servers.item);
							(create {CE_CLASS_POINTER [PD_C2_SERVER]}.make_cast (c2_servers.item)).item.next := l_s;
							(l_s.item.next).item.prev := l_s;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (c2_servers.item))
							l_break := True
						end
						l_break := False
				when 6 then -- found:
						l_s.item.accept := a_a
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	accept_cookie_always (a_idp: CE_POINTER [ANY])
		do
			cookie_default (a_idp, 1)
		end

	accept_cookie_never (a_idp: CE_POINTER [ANY])
		do
			cookie_default (a_idp, 0)
			reject_cookie (a_idp)
		end

	init_cookies
		do
		end

	cleanup_cookies
		local
			l_c: CE_POINTER [PD_COOKIE]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
			l_a_____0: CE_POINTER [PD_XLIST_HEAD]
		do
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (c2_domains.item))
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (c2_domains.item.item.next)
			from
			until
				l_a__.is_equal (c2_domains.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (c2_domains.item.item.prev)
			from
			until
				l_a__.is_equal (c2_domains.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				l_a__ := l_a__.item.prev
			end
			from
			until
				(c2_domains.item.item.next).is_equal (c2_domains.item)
			loop
				l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (c2_domains.item.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 301, create {CE_VOID_POINTER}.make_cast (l_a__))
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (c2_domains.item))
			l_c := create {CE_CLASS_POINTER [PD_COOKIE]}.make_cast (cookies.item.item.next)
			from
			until
				l_c.is_equal (cookies.item)
			loop
				l_c.item.free_cookie
				l_c := l_c.item.next
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (cookies.item))
			l_a_____0 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (cookies.item.item.next)
			from
			until
				l_a_____0.is_equal (cookies.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____0))
				l_a_____0 := l_a_____0.item.next
			end
			l_a_____0 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (cookies.item.item.prev)
			from
			until
				l_a_____0.is_equal (cookies.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____0))
				l_a_____0 := l_a_____0.item.prev
			end
			from
			until
				(cookies.item.item.next).is_equal (cookies.item)
			loop
				l_a_____0 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (cookies.item.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____0));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____0.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a_____0.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____0.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a_____0.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____0));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 304, create {CE_VOID_POINTER}.make_cast (l_a_____0))
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (cookies.item))
		end

end
