class
	P_KBD_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_TERMIOS_STATIC
	S_STDLIB_STATIC

feature {ANY} -- public attributes

	ditrm: CE_STATIC [CE_POINTER [PD_ITRM]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_ITRM]}.make_shared (default_pointer)
		end

	init_seq: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('%/27/').code).to_natural_8, ((')').code).to_natural_8, (('0').code).to_natural_8, (('%/27/').code).to_natural_8,
					(('7').code).to_natural_8, (('%/0/').code).to_natural_8
				>>)
		end

	init_seq_x_mouse: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('%/27/').code).to_natural_8, (('[').code).to_natural_8, (('?').code).to_natural_8, (('1').code).to_natural_8,
					(('0').code).to_natural_8, (('0').code).to_natural_8, (('0').code).to_natural_8, (('h').code).to_natural_8,
					(('%/0/').code).to_natural_8
				>>)
		end

	init_seq_tw_mouse: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('%/27/').code).to_natural_8, (('[').code).to_natural_8, (('?').code).to_natural_8, (('9').code).to_natural_8,
					(('h').code).to_natural_8, (('%/0/').code).to_natural_8
				>>)
		end

	term_seq: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('%/27/').code).to_natural_8, (('[').code).to_natural_8, (('2').code).to_natural_8, (('J').code).to_natural_8,
					(('%/27/').code).to_natural_8, (('8').code).to_natural_8, (('%R').code).to_natural_8, ((' ').code).to_natural_8,
					(('%B').code).to_natural_8, (('%/0/').code).to_natural_8
				>>)
		end

	term_seq_x_mouse: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('%/27/').code).to_natural_8, (('[').code).to_natural_8, (('?').code).to_natural_8, (('1').code).to_natural_8,
					(('0').code).to_natural_8, (('0').code).to_natural_8, (('0').code).to_natural_8, (('l').code).to_natural_8,
					(('%R').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					(('%R').code).to_natural_8, (('%/0/').code).to_natural_8
				>>)
		end

	term_seq_tw_mouse: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('%/27/').code).to_natural_8, (('[').code).to_natural_8, (('?').code).to_natural_8, (('9').code).to_natural_8,
					(('l').code).to_natural_8, (('%/0/').code).to_natural_8
				>>)
		end

feature {ANY} -- public routines

	is_blocked: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if (not ditrm.item.is_void) then
				if (ditrm.item.item.blocked).to_boolean then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	free_all_itrms
		do
			if (not ditrm.item.is_void) then
				free_trm (ditrm.item)
			end
		end

	kbd_ctrl_c
		local
			l_ev: CE_ARRAY [PD_EVENT]
		do
			create {CE_CLASS_ARRAY [PD_EVENT]} l_ev.make (<<1>>)

			l_ev.item.ev := 1
			l_ev.item.x := 512
			l_ev.item.y := 0
			l_ev.item.b := 0
			if (not ditrm.item.is_void) then
				ditrm.item.item.queue_event (create {CE_NATURAL_8_POINTER}.make_cast (l_ev), ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32)
			end
		end

	send_init_sequence (a_h, a_flags: INTEGER_32)
		do
			(create {P_OS_DEP_STATIC}).want_draw;
			(create {P_TERMINAL_STATIC}).hard_write (a_h, init_seq.item, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (init_seq.item))).to_integer_32).do_nothing
			if ((a_flags).bit_and (1)).to_boolean then
				(create {P_TERMINAL_STATIC}).hard_write (a_h, init_seq_tw_mouse.item, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (init_seq_tw_mouse.item))).to_integer_32).do_nothing
			else
				(create {P_TERMINAL_STATIC}).hard_write (a_h, init_seq_x_mouse.item, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (init_seq_x_mouse.item))).to_integer_32).do_nothing
			end
			(create {P_OS_DEP_STATIC}).done_draw
		end

	send_term_sequence (a_h, a_flags: INTEGER_32)
		do
			(create {P_OS_DEP_STATIC}).want_draw;
			(create {P_TERMINAL_STATIC}).hard_write (a_h, term_seq.item, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (term_seq.item))).to_integer_32).do_nothing
			if ((a_flags).bit_and (1)).to_boolean then
				(create {P_TERMINAL_STATIC}).hard_write (a_h, term_seq_tw_mouse.item, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (term_seq_tw_mouse.item))).to_integer_32).do_nothing
			else
				(create {P_TERMINAL_STATIC}).hard_write (a_h, term_seq_x_mouse.item, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (term_seq_x_mouse.item))).to_integer_32).do_nothing
			end
			(create {P_OS_DEP_STATIC}).done_draw
		end

	resize_terminal
		local
			l_ev: CE_ARRAY [PD_EVENT]
			l_x: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_EVENT]} l_ev.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_x.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)

			l_ev.item.ev := 4
			l_ev.item.x := 0
			l_ev.item.y := 0
			l_ev.item.b := 0
			if ((create {P_OS_DEP_STATIC}).get_terminal_size (ditrm.item.item.std_out, l_x, l_y)).to_boolean then
				l_return := True
			end
			if not l_return then
				l_ev.item.x := (l_x.item).to_integer_32
				l_ev.item.y := (l_y.item).to_integer_32
				ditrm.item.item.queue_event (create {CE_NATURAL_8_POINTER}.make_cast (l_ev), ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32)
			end
		end

	ttcgetattr (a_fd: INTEGER_32; a_t: CE_POINTER [SD_TERMIOS]): INTEGER_32
		local
			l_r: INTEGER_32
		do
			(create {P_SELECT_STATIC}).interruptible_signal (22, 1);
			(create {P_SELECT_STATIC}).interruptible_signal (21, 1)
			l_r := tcgetattr (a_fd, a_t);
			(create {P_SELECT_STATIC}).interruptible_signal (22, 0);
			(create {P_SELECT_STATIC}).interruptible_signal (21, 0)
			Result := l_r
		end

	ttcsetattr (a_fd, a_a: INTEGER_32; a_t: CE_POINTER [SD_TERMIOS]): INTEGER_32
		local
			l_r: INTEGER_32
		do
			(create {P_SELECT_STATIC}).interruptible_signal (22, 1);
			(create {P_SELECT_STATIC}).interruptible_signal (21, 1)
			l_r := tcsetattr (a_fd, a_a, a_t);
			(create {P_SELECT_STATIC}).interruptible_signal (22, 0);
			(create {P_SELECT_STATIC}).interruptible_signal (21, 0)
			Result := l_r
		end

	setraw (a_fd: INTEGER_32; a_p: CE_POINTER [SD_TERMIOS]): INTEGER_32
		local
			l_t: CE_ARRAY [SD_TERMIOS]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_TERMIOS]} l_t.make (<<1>>)

			memset (create {CE_VOID_POINTER}.make_cast (l_t), 0, (create {SD_TERMIOS}.make).structure_size.to_natural_32).do_nothing
			if (ttcgetattr (a_fd, l_t)).to_boolean then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if (not a_p.is_void) then
					memcpy (create {CE_VOID_POINTER}.make_cast (a_p), create {CE_VOID_POINTER}.make_cast (l_t), (create {SD_TERMIOS}.make).structure_size.to_natural_32).do_nothing
				end
				(create {P_OS_DEP_STATIC}).os_cfmakeraw (l_t)
				l_t.item.c2_lflag := (l_t.item.c2_lflag).bit_or (({NATURAL_32} 1))
				l_t.item.c2_lflag := (l_t.item.c2_lflag).bit_or (({NATURAL_32} 256))
				l_t.item.c2_oflag := (l_t.item.c2_oflag).bit_or (({NATURAL_32} 1))
				if (ttcsetattr (a_fd, 0, l_t)).to_boolean then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	handle_trm (a_std_in, a_std_out, a_sock_in, a_sock_out, a_ctl_in: INTEGER_32; a_init_string: CE_POINTER [ANY]; a_init_len: INTEGER_32)
		local
			l_init_len: CE_ARRAY [INTEGER_32]
			l_x: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_itrm: CE_POINTER [PD_ITRM]
			l_ev: CE_ARRAY [PD_EVENT]
			l_ts: CE_POINTER [NATURAL_8]
			l_xwin: CE_ARRAY [INTEGER_32]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			l_mm: CE_POINTER [NATURAL_8]
			l_ll: INTEGER_32
			l_mm___0: CE_POINTER [NATURAL_8]
			l_ll___0: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_init_len.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_x.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_EVENT]} l_ev.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_xwin.make (<<1>>)

			l_init_len.item := a_init_len
			l_ev.item.ev := 0
			l_ev.item.x := 80
			l_ev.item.y := 24
			l_ev.item.b := 0
			if ((create {P_OS_DEP_STATIC}).get_terminal_size (a_ctl_in, l_x, l_y)).to_boolean then
				(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: could not get terminal size"))])
				l_return := True
			end
			if not l_return then
				l_itrm := create {CE_CLASS_POINTER [PD_ITRM]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 202, (create {PD_ITRM}.make).structure_size.to_natural_32)))
				ditrm.item := l_itrm
				l_itrm.item.std_in := a_std_in
				l_itrm.item.std_out := a_std_out
				l_itrm.item.sock_in := a_sock_in
				l_itrm.item.sock_out := a_sock_out
				l_itrm.item.ctl_in := a_ctl_in
				l_itrm.item.blocked := 0
				l_itrm.item.qlen := 0
				l_itrm.item.tm := -1
				l_itrm.item.ev_queue := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer + -1)
				l_itrm.item.eqlen := 0
				if a_ctl_in >= 0 then
					setraw (a_ctl_in, create {CE_CLASS_POINTER [SD_TERMIOS]}.make_shared (l_itrm.c_pointer + (create {PD_ITRM}.make).offset_of ("t"))).do_nothing
				end
				(create {P_SELECT_STATIC}).set_handlers (a_std_in, ((create {PD_ITRM_STATIC}).in_kbd_address), create {CE_ROUTINE}.make_shared (default_pointer), (free_trm_address), create {CE_VOID_POINTER}.make_cast (l_itrm))
				if a_sock_in /= a_std_out then
					(create {P_SELECT_STATIC}).set_handlers (a_sock_in, ((create {PD_ITRM_STATIC}).in_sock_address), create {CE_ROUTINE}.make_shared (default_pointer), (free_trm_address), create {CE_VOID_POINTER}.make_cast (l_itrm))
				end
				l_ev.item.x := (l_x.item).to_integer_32
				l_ev.item.y := (l_y.item).to_integer_32;
				(create {P_OS_DEP_STATIC}).handle_terminal_resize (a_ctl_in, resize_terminal_address)
				l_itrm.item.queue_event (create {CE_NATURAL_8_POINTER}.make_cast (l_ev), ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32)
				l_tmp___1 := (create {P_OS_DEP_STATIC}).is_xterm
				l_tmp___2 := (create {P_OS_DEP_STATIC}).can_twterm
				if (not (getenv (ce_string ("STY"))).is_void) then
					l_tmp___4 := 1
				else
					l_tmp___4 := 0
				end
				l_xwin.item := ((l_tmp___1 + l_tmp___2 * 16) + l_tmp___4 * 2) + ((create {P_OS_DEP_STATIC}).get_system_env)
				l_itrm.item.flags := 0
				l_ts := create {CE_NATURAL_8_POINTER}.make_cast ((getenv (ce_string ("TERM"))))
				if l_ts.is_void then
					l_ts := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
				end
				if ((l_xwin.item).bit_and (16)).to_boolean then
					if not (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_ts), ce_string ("linux"))).to_boolean then
						l_itrm.item.flags := (l_itrm.item.flags).bit_or ((1))
					end
				end
				if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ts))) >= {NATURAL_32} 32 then
					l_itrm.item.queue_event (l_ts, 32)
				else
					l_ll := ({NATURAL_32} 32 - (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ts)))).to_integer_32
					l_itrm.item.queue_event (l_ts, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ts))).to_integer_32)
					l_mm := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 230, l_ll.to_natural_32)))
					memset (create {CE_VOID_POINTER}.make_cast (l_mm), 0, l_ll.to_natural_32).do_nothing
					l_itrm.item.queue_event (l_mm, l_ll);
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 233, create {CE_VOID_POINTER}.make_cast (l_mm))
				end
				l_ts := (create {P_TERMINAL_STATIC}).get_cwd
				if l_ts.is_void then
					l_ts := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 235, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
				end
				if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ts))) >= {NATURAL_32} 256 then
					l_itrm.item.queue_event (l_ts, 256)
				else
					l_ll___0 := ({NATURAL_32} 256 - (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ts)))).to_integer_32
					l_itrm.item.queue_event (l_ts, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ts))).to_integer_32)
					l_mm___0 := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 241, l_ll___0.to_natural_32)))
					memset (create {CE_VOID_POINTER}.make_cast (l_mm___0), 0, l_ll___0.to_natural_32).do_nothing
					l_itrm.item.queue_event (l_mm___0, l_ll___0);
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 244, create {CE_VOID_POINTER}.make_cast (l_mm___0))
				end
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 246, create {CE_VOID_POINTER}.make_cast (l_ts))
				l_itrm.item.queue_event (create {CE_NATURAL_8_POINTER}.make_cast (l_xwin), ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32)
				l_itrm.item.queue_event (create {CE_NATURAL_8_POINTER}.make_cast (l_init_len), ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32)
				l_itrm.item.queue_event (create {CE_NATURAL_8_POINTER}.make_cast (a_init_string), l_init_len.item)
				l_itrm.item.mouse_h := (create {P_OS_DEP_STATIC}).handle_mouse (0, ((create {PD_ITRM_STATIC}).mouse_queue_event_address), create {CE_VOID_POINTER}.make_cast (l_itrm))
				l_itrm.item.orig_title := (create {P_OS_DEP_STATIC}).get_window_title;
				(create {P_OS_DEP_STATIC}).set_window_title (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Links")))
				send_init_sequence (a_std_out, l_itrm.item.flags)
			end
		end

	unblock_itrm_x (a_h: CE_POINTER [ANY])
		local
			l_return: BOOLEAN
		do
			(create {P_TERMINAL_STATIC}).close_handle (a_h)
			if ditrm.item.is_void then
				l_return := True
			end
			if not l_return then
				unblock_itrm (0).do_nothing
			end
		end

	unblock_itrm (a_fd: INTEGER_32): INTEGER_32
		local
			l_itrm: CE_POINTER [PD_ITRM]
			l_return: BOOLEAN
		do
			l_itrm := ditrm.item
			if l_itrm.is_void then
				Result := (-1)
				l_return := True
			end
			if not l_return and then (l_itrm.item.ctl_in >= 0) then
				if (setraw (l_itrm.item.ctl_in, create {CE_CLASS_POINTER [SD_TERMIOS]}.make_shared (default_pointer))).to_boolean then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return and then (l_itrm.item.blocked /= a_fd + 1) then
				Result := (-2)
				l_return := True
			end
			if not l_return then
				l_itrm.item.blocked := 0
				send_init_sequence (l_itrm.item.std_out, l_itrm.item.flags);
				(create {P_SELECT_STATIC}).set_handlers (l_itrm.item.std_in, ((create {PD_ITRM_STATIC}).in_kbd_address), create {CE_ROUTINE}.make_shared (default_pointer), (free_trm_address), create {CE_VOID_POINTER}.make_cast (l_itrm));
				(create {P_OS_DEP_STATIC}).handle_terminal_resize (l_itrm.item.ctl_in, resize_terminal_address);
				(create {P_OS_DEP_STATIC}).unblock_stdin
				resize_terminal
				Result := 0
			end
		end

	block_itrm (a_fd: INTEGER_32)
		local
			l_itrm: CE_POINTER [PD_ITRM]
			l_return: BOOLEAN
		do
			l_itrm := ditrm.item
			if l_itrm.is_void then
				l_return := True
			end
			if not l_return and then ((l_itrm.item.blocked).to_boolean) then
				l_return := True
			end
			if not l_return then
				l_itrm.item.blocked := a_fd + 1;
				(create {P_OS_DEP_STATIC}).block_stdin;
				(create {P_OS_DEP_STATIC}).unhandle_terminal_resize (l_itrm.item.ctl_in)
				send_term_sequence (l_itrm.item.std_out, l_itrm.item.flags)
				ttcsetattr (l_itrm.item.ctl_in, 0, create {CE_CLASS_POINTER [SD_TERMIOS]}.make_shared (l_itrm.c_pointer + (create {PD_ITRM}.make).offset_of ("t"))).do_nothing;
				(create {P_SELECT_STATIC}).set_handlers (l_itrm.item.std_in, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), (free_trm_address), create {CE_VOID_POINTER}.make_cast (l_itrm))
			end
		end

	free_trm (a_itrm: CE_POINTER [PD_ITRM])
		local
			l_return: BOOLEAN
		do
			if a_itrm.is_void then
				l_return := True
			end
			if not l_return then
				(create {P_OS_DEP_STATIC}).set_window_title (a_itrm.item.orig_title)
				if (not (a_itrm.item.orig_title).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 295, create {CE_VOID_POINTER}.make_cast (a_itrm.item.orig_title))
					a_itrm.item.orig_title := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				end
				(create {P_OS_DEP_STATIC}).unhandle_terminal_resize (a_itrm.item.ctl_in)
				send_term_sequence (a_itrm.item.std_out, a_itrm.item.flags)
				ttcsetattr (a_itrm.item.ctl_in, 0, create {CE_CLASS_POINTER [SD_TERMIOS]}.make_shared (a_itrm.c_pointer + (create {PD_ITRM}.make).offset_of ("t"))).do_nothing
				if (not (a_itrm.item.mouse_h).is_void) then
					(create {P_OS_DEP_STATIC}).unhandle_mouse (a_itrm.item.mouse_h)
				end
				(create {P_SELECT_STATIC}).set_handlers (a_itrm.item.std_in, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer));
				(create {P_SELECT_STATIC}).set_handlers (a_itrm.item.sock_in, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer));
				(create {P_SELECT_STATIC}).set_handlers (a_itrm.item.std_out, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer));
				(create {P_SELECT_STATIC}).set_handlers (a_itrm.item.sock_out, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
				if a_itrm.item.tm /= -1 then
					(create {P_SELECT_STATIC}).kill_timer (a_itrm.item.tm)
				end
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 305, create {CE_VOID_POINTER}.make_cast (a_itrm.item.ev_queue));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 306, create {CE_VOID_POINTER}.make_cast (a_itrm))
				if a_itrm.is_equal (ditrm.item) then
					ditrm.item := create {CE_CLASS_POINTER [PD_ITRM]}.make_shared (default_pointer)
				end
			end
		end

	fatal_tty_exit
		do
			if (not ditrm.item.is_void) then
				ttcsetattr (ditrm.item.item.ctl_in, 0, create {CE_CLASS_POINTER [SD_TERMIOS]}.make_shared (ditrm.item.c_pointer + (create {PD_ITRM}.make).offset_of ("t"))).do_nothing
			end
		end

	resize_terminal_x (a_text: CE_POINTER [NATURAL_8])
		local
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_p: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_p := create {CE_NATURAL_8_POINTER}.make_cast ((strchr (create {CE_INTEGER_8_POINTER}.make_cast (a_text), (',').code)))
			if l_p.is_void then
				l_return := True
			end
			if not l_return then
				l_tmp___0 := l_p
				l_p := l_p + 1
				l_tmp___0.item := (0).to_natural_8
				l_x := atoi (create {CE_INTEGER_8_POINTER}.make_cast (a_text))
				l_y := atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_p));
				(create {P_OS_DEP_STATIC}).resize_window (l_x, l_y).do_nothing
				resize_terminal
			end
		end

	dispatch_special (a_text: CE_POINTER [NATURAL_8])
		require
			not a_text.is_void
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (a_text[0]).to_integer_32 -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 1;
					(create {P_OS_DEP_STATIC}).set_window_title (a_text + 1)
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 2
					resize_terminal_x (a_text + 1)
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	resize_terminal_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent resize_terminal)
		end

	unblock_itrm_x_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent unblock_itrm_x)
		end

	free_trm_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent free_trm)
		end

end
