class
	PD_ASSOC

inherit
	PD_ASSOC_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_ASSOC]} next.make
			create {CE_CLASS_POINTER [PD_ASSOC]} prev.make
			create {CE_NATURAL_8_POINTER} label.make
			create {CE_NATURAL_8_POINTER} ct.make
			create {CE_NATURAL_8_POINTER} prog.make
			Precursor
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_ASSOC] assign set_next

	prev: CE_POINTER [PD_ASSOC] assign set_prev

	cnt: NATURAL_32 assign set_cnt

	label: CE_POINTER [NATURAL_8] assign set_label

	ct: CE_POINTER [NATURAL_8] assign set_ct

	prog: CE_POINTER [NATURAL_8] assign set_prog

	cons: INTEGER_32 assign set_cons

	xwin: INTEGER_32 assign set_xwin

	block: INTEGER_32 assign set_block

	ask: INTEGER_32 assign set_ask

	system: INTEGER_32 assign set_system

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_ASSOC])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_ASSOC])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_cnt (a_cnt: NATURAL_32)
		do
			cnt := a_cnt
			update_memory_field ("cnt")
		end

	set_label (a_label: CE_POINTER [NATURAL_8])
		do
			label := a_label
			update_memory_field ("label")
		end

	set_ct (a_ct: CE_POINTER [NATURAL_8])
		do
			ct := a_ct
			update_memory_field ("ct")
		end

	set_prog (a_prog: CE_POINTER [NATURAL_8])
		do
			prog := a_prog
			update_memory_field ("prog")
		end

	set_cons (a_cons: INTEGER_32)
		do
			cons := a_cons
			update_memory_field ("cons")
		end

	set_xwin (a_xwin: INTEGER_32)
		do
			xwin := a_xwin
			update_memory_field ("xwin")
		end

	set_block (a_block: INTEGER_32)
		do
			block := a_block
			update_memory_field ("block")
		end

	set_ask (a_ask: INTEGER_32)
		do
			ask := a_ask
			update_memory_field ("ask")
		end

	set_system (a_system: INTEGER_32)
		do
			system := a_system
			update_memory_field ("system")
		end

feature {ANY} -- public routines

	delete_association
		do
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (next)).item.prev := create {CE_VOID_POINTER}.make_cast (prev)
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (prev)).item.next := create {CE_VOID_POINTER}.make_cast (next)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 22, create {CE_VOID_POINTER}.make_cast (label))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 23, create {CE_VOID_POINTER}.make_cast (ct))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 24, create {CE_VOID_POINTER}.make_cast (prog))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 25, create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	update_assoc
		local
			l_repl: CE_POINTER [PD_ASSOC]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (label[0]).to_boolean then
						l_return := True
					elseif not (ct[0]).to_boolean then
						l_return := True
					elseif not (prog[0]).to_boolean then
						l_return := True
					end
					if not (not l_return and then (cnt.to_boolean)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_repl := create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast ((create {P_TYPES_STATIC}).assoc.item.item.next)
				when 2 then -- loop condition:
						if l_repl.is_equal ((create {P_TYPES_STATIC}).assoc.item) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if l_repl.item.cnt = cnt then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 191, create {CE_VOID_POINTER}.make_cast (l_repl.item.label))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 192, create {CE_VOID_POINTER}.make_cast (l_repl.item.ct))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 193, create {CE_VOID_POINTER}.make_cast (l_repl.item.prog))
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 8 -- goto replace
						end
				when 4 then
						l_repl := l_repl.item.next
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						l_return := True
				when 6 then -- if done
					if not l_return then
						l_repl := create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast ((create {P_TYPES_STATIC}).assoc.item.item.next)
						from
						until
							not (not (l_return) and then (not l_repl.is_equal ((create {P_TYPES_STATIC}).assoc.item)))
						loop
							l_tmp := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_repl.item.label), create {CE_INTEGER_8_POINTER}.make_cast (label))
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp.to_boolean then
								l_tmp___0 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_repl.item.ct), create {CE_INTEGER_8_POINTER}.make_cast (ct))
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___0.to_boolean then
									l_tmp___1 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_repl.item.prog), create {CE_INTEGER_8_POINTER}.make_cast (prog))
									update_class_fields -- Current might have been changed; synchronize
									if not l_tmp___1.to_boolean then
										if l_repl.item.block = block then
											if l_repl.item.cons = cons then
												if l_repl.item.xwin = xwin then
													if l_repl.item.ask = ask then
														if l_repl.item.system = system then
															(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_repl))
															update_class_fields; -- Current might have been changed; synchronize
															(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_repl.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_repl.item.prev)
															update_class_fields; -- Current might have been changed; synchronize
															(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_repl.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_repl.item.next)
															update_class_fields; -- Current might have been changed; synchronize
															(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_repl))
															update_class_fields -- Current might have been changed; synchronize
															from
															until
																(l_break)
															loop
																l_break := False;
																(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_TYPES_STATIC}).assoc.item)))
																update_class_fields -- Current might have been changed; synchronize
																l_repl.item.next := (create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast (((create {P_TYPES_STATIC}).assoc.item))).item.next
																update_class_fields -- Current might have been changed; synchronize
																l_repl.item.prev := create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast (((create {P_TYPES_STATIC}).assoc.item))
																update_class_fields; -- Current might have been changed; synchronize
																(create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast (((create {P_TYPES_STATIC}).assoc.item))).item.next := l_repl
																update_class_fields; -- Current might have been changed; synchronize
																(l_repl.item.next).item.prev := l_repl
																update_class_fields; -- Current might have been changed; synchronize
																(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_TYPES_STATIC}).assoc.item)))
																update_class_fields -- Current might have been changed; synchronize
																l_break := True
															end
															l_break := False
															l_return := True
														end
													end
												end
											end
										end
									end
								end
							end
							if not l_return then
								l_repl := l_repl.item.next
							end
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 7 then -- if:
						Current.cnt := (create {P_TYPES_STATIC}).get_assoc_cnt
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 204, (create {PD_ASSOC}.make).structure_size.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_repl := create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast (l_tmp___2)
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_TYPES_STATIC}).assoc.item)))
							update_class_fields -- Current might have been changed; synchronize
							l_repl.item.next := (create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast (((create {P_TYPES_STATIC}).assoc.item))).item.next
							update_class_fields -- Current might have been changed; synchronize
							l_repl.item.prev := create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast (((create {P_TYPES_STATIC}).assoc.item))
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast (((create {P_TYPES_STATIC}).assoc.item))).item.next := l_repl
							update_class_fields; -- Current might have been changed; synchronize
							(l_repl.item.next).item.prev := l_repl
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_TYPES_STATIC}).assoc.item)))
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
				when 8 then -- replace:
						l_repl.item.label := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 207, label)
						update_class_fields -- Current might have been changed; synchronize
						l_repl.item.ct := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 208, ct)
						update_class_fields -- Current might have been changed; synchronize
						l_repl.item.prog := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 209, prog)
						update_class_fields -- Current might have been changed; synchronize
						l_repl.item.block := block
						update_class_fields -- Current might have been changed; synchronize
						l_repl.item.cons := cons
						update_class_fields -- Current might have been changed; synchronize
						l_repl.item.xwin := xwin
						update_class_fields -- Current might have been changed; synchronize
						l_repl.item.ask := ask
						update_class_fields -- Current might have been changed; synchronize
						l_repl.item.system := system
						update_class_fields -- Current might have been changed; synchronize
						l_repl.item.cnt := cnt
						update_class_fields -- Current might have been changed; synchronize
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			cnt := a_other.cnt
			label := a_other.label
			ct := a_other.ct
			prog := a_other.prog
			cons := a_other.cons
			xwin := a_other.xwin
			block := a_other.block
			ask := a_other.ask
			system := a_other.system
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				cnt = a_other.cnt and
				label.is_equal (a_other.label) and
				ct.is_equal (a_other.ct) and
				prog.is_equal (a_other.prog) and
				cons = a_other.cons and
				xwin = a_other.xwin and
				block = a_other.block and
				ask = a_other.ask and
				system = a_other.system
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("cnt"),
					create {CE_STRUCTURE_FIELD}.make ("label"),
					create {CE_STRUCTURE_FIELD}.make ("ct"),
					create {CE_STRUCTURE_FIELD}.make ("prog"),
					create {CE_STRUCTURE_FIELD}.make ("cons"),
					create {CE_STRUCTURE_FIELD}.make ("xwin"),
					create {CE_STRUCTURE_FIELD}.make ("block"),
					create {CE_STRUCTURE_FIELD}.make ("ask"),
					create {CE_STRUCTURE_FIELD}.make ("system")
				>>)
			init_structure_info
		end

end
