class
	PD_BOTTOM_HALF

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_BOTTOM_HALF]} next.make
			create {CE_CLASS_POINTER [PD_BOTTOM_HALF]} prev.make
			create fn.make
			create {CE_VOID_POINTER} data.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_BOTTOM_HALF] assign set_next

	prev: CE_POINTER [PD_BOTTOM_HALF] assign set_prev

	fn: CE_ROUTINE assign set_fn

	data: CE_POINTER [ANY] assign set_data

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_BOTTOM_HALF])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_BOTTOM_HALF])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_fn (a_fn: CE_ROUTINE)
		do
			fn := a_fn
			update_memory_field ("fn")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			fn := a_other.fn
			data := a_other.data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				fn.is_equal (a_other.fn) and
				data.is_equal (a_other.data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("fn"),
					create {CE_STRUCTURE_FIELD}.make ("data")
				>>)
			init_structure_info
		end

end
