class
	PD_BOX_ITEM

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_BOX_ITEM]} next.make
			create {CE_CLASS_POINTER [PD_BOX_ITEM]} prev.make
			create {CE_NATURAL_8_POINTER} text.make
			create on_hilight.make
			create on_selected.make
			create {CE_VOID_POINTER} data.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_BOX_ITEM] assign set_next

	prev: CE_POINTER [PD_BOX_ITEM] assign set_prev

	text: CE_POINTER [NATURAL_8] assign set_text

	on_hilight: CE_ROUTINE assign set_on_hilight

	on_selected: CE_ROUTINE assign set_on_selected

	data: CE_POINTER [ANY] assign set_data

	free_i: NATURAL_32 assign set_free_i

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_BOX_ITEM])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_BOX_ITEM])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_text (a_text: CE_POINTER [NATURAL_8])
		do
			text := a_text
			update_memory_field ("text")
		end

	set_on_hilight (a_on_hilight: CE_ROUTINE)
		do
			on_hilight := a_on_hilight
			update_memory_field ("on_hilight")
		end

	set_on_selected (a_on_selected: CE_ROUTINE)
		do
			on_selected := a_on_selected
			update_memory_field ("on_selected")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_free_i (a_free_i: NATURAL_32)
		do
			free_i := a_free_i
			update_memory_field ("free_i")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			text := a_other.text
			on_hilight := a_other.on_hilight
			on_selected := a_other.on_selected
			data := a_other.data
			free_i := a_other.free_i
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				text.is_equal (a_other.text) and
				on_hilight.is_equal (a_other.on_hilight) and
				on_selected.is_equal (a_other.on_selected) and
				data.is_equal (a_other.data) and
				free_i = a_other.free_i
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("text"),
					create {CE_STRUCTURE_FIELD}.make ("on_hilight"),
					create {CE_STRUCTURE_FIELD}.make ("on_selected"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("free_i")
				>>)
			init_structure_info
		end

end
