class
	PD_DLG_DATA_ITEM_DATA_BOX

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create items.make
		end

feature {ANY} -- fields

	sel: INTEGER_32 assign set_sel

	box_top: INTEGER_32 assign set_box_top

	items: PD_LIST_HEAD assign set_items

	list_len: INTEGER_32 assign set_list_len

feature {ANY} -- field setters

	set_sel (a_sel: INTEGER_32)
		do
			sel := a_sel
			update_memory_field ("sel")
		end

	set_box_top (a_box_top: INTEGER_32)
		do
			box_top := a_box_top
			update_memory_field ("box_top")
		end

	set_items (a_items: PD_LIST_HEAD)
		do
			items := a_items
			update_memory_field ("items")
		end

	set_list_len (a_list_len: INTEGER_32)
		do
			list_len := a_list_len
			update_memory_field ("list_len")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sel := a_other.sel
			box_top := a_other.box_top
			items := a_other.items.twin
			list_len := a_other.list_len
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sel = a_other.sel and
				box_top = a_other.box_top and
				items.is_equal (a_other.items) and
				list_len = a_other.list_len
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sel"),
					create {CE_STRUCTURE_FIELD}.make ("box_top"),
					create {CE_STRUCTURE_FIELD}.make ("items"),
					create {CE_STRUCTURE_FIELD}.make ("list_len")
				>>)
			init_structure_info
		end

end
