class
	PD_DNSENTRY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_DNSENTRY]} next.make
			create {CE_CLASS_POINTER [PD_DNSENTRY]} prev.make
			create {CE_INTEGER_8_ARRAY} name.make (<<1>>)
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_DNSENTRY] assign set_next

	prev: CE_POINTER [PD_DNSENTRY] assign set_prev

	get_time: INTEGER_32 assign set_get_time

	addr: NATURAL_32 assign set_addr

	name: CE_ARRAY [INTEGER_8]

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_DNSENTRY])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_DNSENTRY])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_get_time (a_get_time: INTEGER_32)
		do
			get_time := a_get_time
			update_memory_field ("get_time")
		end

	set_addr (a_addr: NATURAL_32)
		do
			addr := a_addr
			update_memory_field ("addr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			get_time := a_other.get_time
			addr := a_other.addr
			name := a_other.name.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				get_time = a_other.get_time and
				addr = a_other.addr and
				name.is_equal (a_other.name)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("get_time"),
					create {CE_STRUCTURE_FIELD}.make ("addr"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("name", <<1>>)
				>>)
			init_structure_info
		end

end
