class
	PD_FRAME_DESC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_FRAMESET_DESC]} subframe.make
			create {CE_NATURAL_8_POINTER} name.make
			create {CE_NATURAL_8_POINTER} url.make
		end

feature {ANY} -- fields

	subframe: CE_POINTER [PD_FRAMESET_DESC] assign set_subframe

	name: CE_POINTER [NATURAL_8] assign set_name

	url: CE_POINTER [NATURAL_8] assign set_url

	line: INTEGER_32 assign set_line

	xw: INTEGER_32 assign set_xw

	yw: INTEGER_32 assign set_yw

feature {ANY} -- field setters

	set_subframe (a_subframe: CE_POINTER [PD_FRAMESET_DESC])
		do
			subframe := a_subframe
			update_memory_field ("subframe")
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_line (a_line: INTEGER_32)
		do
			line := a_line
			update_memory_field ("line")
		end

	set_xw (a_xw: INTEGER_32)
		do
			xw := a_xw
			update_memory_field ("xw")
		end

	set_yw (a_yw: INTEGER_32)
		do
			yw := a_yw
			update_memory_field ("yw")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			subframe := a_other.subframe
			name := a_other.name
			url := a_other.url
			line := a_other.line
			xw := a_other.xw
			yw := a_other.yw
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				subframe.is_equal (a_other.subframe) and
				name.is_equal (a_other.name) and
				url.is_equal (a_other.url) and
				line = a_other.line and
				xw = a_other.xw and
				yw = a_other.yw
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("subframe"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("line"),
					create {CE_STRUCTURE_FIELD}.make ("xw"),
					create {CE_STRUCTURE_FIELD}.make ("yw")
				>>)
			init_structure_info
		end

end
