class
	PD_HTML_ELEMENT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_HTML_ELEMENT]} next.make
			create {CE_CLASS_POINTER [PD_HTML_ELEMENT]} prev.make
			create attr.make
			create parattr.make
			create {CE_NATURAL_8_POINTER} name.make
			create {CE_NATURAL_8_POINTER} options.make
			create {CE_CLASS_POINTER [PD_FRAMESET_DESC]} frameset.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_HTML_ELEMENT] assign set_next

	prev: CE_POINTER [PD_HTML_ELEMENT] assign set_prev

	attr: PD_TEXT_ATTRIB assign set_attr

	parattr: PD_PAR_ATTRIB assign set_parattr

	invisible: INTEGER_32 assign set_invisible

	name: CE_POINTER [NATURAL_8] assign set_name

	namelen: INTEGER_32 assign set_namelen

	options: CE_POINTER [NATURAL_8] assign set_options

	linebreak: INTEGER_32 assign set_linebreak

	dontkill: INTEGER_32 assign set_dontkill

	frameset: CE_POINTER [PD_FRAMESET_DESC] assign set_frameset

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_HTML_ELEMENT])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_HTML_ELEMENT])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_attr (a_attr: PD_TEXT_ATTRIB)
		do
			attr := a_attr
			update_memory_field ("attr")
		end

	set_parattr (a_parattr: PD_PAR_ATTRIB)
		do
			parattr := a_parattr
			update_memory_field ("parattr")
		end

	set_invisible (a_invisible: INTEGER_32)
		do
			invisible := a_invisible
			update_memory_field ("invisible")
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_namelen (a_namelen: INTEGER_32)
		do
			namelen := a_namelen
			update_memory_field ("namelen")
		end

	set_options (a_options: CE_POINTER [NATURAL_8])
		do
			options := a_options
			update_memory_field ("options")
		end

	set_linebreak (a_linebreak: INTEGER_32)
		do
			linebreak := a_linebreak
			update_memory_field ("linebreak")
		end

	set_dontkill (a_dontkill: INTEGER_32)
		do
			dontkill := a_dontkill
			update_memory_field ("dontkill")
		end

	set_frameset (a_frameset: CE_POINTER [PD_FRAMESET_DESC])
		do
			frameset := a_frameset
			update_memory_field ("frameset")
		end

feature {ANY} -- public routines

	kill_html_stack_item
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if dontkill = 2 then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).errline.item := 477
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("trying to kill unkillable element"))])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if (not (c_pointer = default_pointer)) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not ((c_pointer = ((create {P_HTML_STATIC}).html_stack.item).c_pointer)) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).errline.item := 481
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("trying to free bad html element"))])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_return := True
				when 6 then -- if done | if done
					if not l_return then
						if (not (attr.link).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 484, create {CE_VOID_POINTER}.make_cast (attr.link))
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not (attr.target).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 485, create {CE_VOID_POINTER}.make_cast (attr.target))
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not (attr.image).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 486, create {CE_VOID_POINTER}.make_cast (attr.image))
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not (attr.href_base).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 487, create {CE_VOID_POINTER}.make_cast (attr.href_base))
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not (attr.target_base).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 488, create {CE_VOID_POINTER}.make_cast (attr.target_base))
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not (attr.select2).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 489, create {CE_VOID_POINTER}.make_cast (attr.select2))
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
						update_class_fields; -- Current might have been changed; synchronize
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (next)).item.prev := create {CE_VOID_POINTER}.make_cast (prev)
						update_class_fields; -- Current might have been changed; synchronize
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (prev)).item.next := create {CE_VOID_POINTER}.make_cast (next)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 491, create {CE_VOID_POINTER}.make_shared (c_pointer))
						update_class_fields -- Current might have been changed; synchronize
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			attr := a_other.attr.twin
			parattr := a_other.parattr.twin
			invisible := a_other.invisible
			name := a_other.name
			namelen := a_other.namelen
			options := a_other.options
			linebreak := a_other.linebreak
			dontkill := a_other.dontkill
			frameset := a_other.frameset
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				attr.is_equal (a_other.attr) and
				parattr.is_equal (a_other.parattr) and
				invisible = a_other.invisible and
				name.is_equal (a_other.name) and
				namelen = a_other.namelen and
				options.is_equal (a_other.options) and
				linebreak = a_other.linebreak and
				dontkill = a_other.dontkill and
				frameset.is_equal (a_other.frameset)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("attr"),
					create {CE_STRUCTURE_FIELD}.make ("parattr"),
					create {CE_STRUCTURE_FIELD}.make ("invisible"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("namelen"),
					create {CE_STRUCTURE_FIELD}.make ("options"),
					create {CE_STRUCTURE_FIELD}.make ("linebreak"),
					create {CE_STRUCTURE_FIELD}.make ("dontkill"),
					create {CE_STRUCTURE_FIELD}.make ("frameset")
				>>)
			init_structure_info
		end

end
