class
	PD_ITRM

inherit
	PD_ITRM_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_UNISTD_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_BITS_ERRNO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create t.make
			create {CE_NATURAL_8_ARRAY} kqueue.make (<<16>>)
			create {CE_NATURAL_8_POINTER} ev_queue.make
			create {CE_VOID_POINTER} mouse_h.make
			create {CE_NATURAL_8_POINTER} orig_title.make
			Precursor
		end

feature {ANY} -- fields

	std_in: INTEGER_32 assign set_std_in

	std_out: INTEGER_32 assign set_std_out

	sock_in: INTEGER_32 assign set_sock_in

	sock_out: INTEGER_32 assign set_sock_out

	ctl_in: INTEGER_32 assign set_ctl_in

	blocked: INTEGER_32 assign set_blocked

	t: SD_TERMIOS assign set_t

	flags: INTEGER_32 assign set_flags

	kqueue: CE_ARRAY [NATURAL_8]

	qlen: INTEGER_32 assign set_qlen

	tm: INTEGER_32 assign set_tm

	ev_queue: CE_POINTER [NATURAL_8] assign set_ev_queue

	eqlen: INTEGER_32 assign set_eqlen

	mouse_h: CE_POINTER [ANY] assign set_mouse_h

	orig_title: CE_POINTER [NATURAL_8] assign set_orig_title

feature {ANY} -- field setters

	set_std_in (a_std_in: INTEGER_32)
		do
			std_in := a_std_in
			update_memory_field ("std_in")
		end

	set_std_out (a_std_out: INTEGER_32)
		do
			std_out := a_std_out
			update_memory_field ("std_out")
		end

	set_sock_in (a_sock_in: INTEGER_32)
		do
			sock_in := a_sock_in
			update_memory_field ("sock_in")
		end

	set_sock_out (a_sock_out: INTEGER_32)
		do
			sock_out := a_sock_out
			update_memory_field ("sock_out")
		end

	set_ctl_in (a_ctl_in: INTEGER_32)
		do
			ctl_in := a_ctl_in
			update_memory_field ("ctl_in")
		end

	set_blocked (a_blocked: INTEGER_32)
		do
			blocked := a_blocked
			update_memory_field ("blocked")
		end

	set_t (a_t: SD_TERMIOS)
		do
			t := a_t
			update_memory_field ("t")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_qlen (a_qlen: INTEGER_32)
		do
			qlen := a_qlen
			update_memory_field ("qlen")
		end

	set_tm (a_tm: INTEGER_32)
		do
			tm := a_tm
			update_memory_field ("tm")
		end

	set_ev_queue (a_ev_queue: CE_POINTER [NATURAL_8])
		do
			ev_queue := a_ev_queue
			update_memory_field ("ev_queue")
		end

	set_eqlen (a_eqlen: INTEGER_32)
		do
			eqlen := a_eqlen
			update_memory_field ("eqlen")
		end

	set_mouse_h (a_mouse_h: CE_POINTER [ANY])
		do
			mouse_h := a_mouse_h
			update_memory_field ("mouse_h")
		end

	set_orig_title (a_orig_title: CE_POINTER [NATURAL_8])
		do
			orig_title := a_orig_title
			update_memory_field ("orig_title")
		end

feature {PD_ITRM} -- private attributes

	buf: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<16_384>>)
		end

	os2xtd: CE_STATIC [CE_ARRAY [PD_KEY]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_KEY]}.make_initialized (<<
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([(' ').code, 2]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([257, 4]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([('Q').code, 4]),
					create {PD_KEY}.make_initialized ([('W').code, 4]),
					create {PD_KEY}.make_initialized ([('E').code, 4]),
					create {PD_KEY}.make_initialized ([('R').code, 4]),
					create {PD_KEY}.make_initialized ([('T').code, 4]),
					create {PD_KEY}.make_initialized ([('Y').code, 4]),
					create {PD_KEY}.make_initialized ([('U').code, 4]),
					create {PD_KEY}.make_initialized ([('I').code, 4]),
					create {PD_KEY}.make_initialized ([('O').code, 4]),
					create {PD_KEY}.make_initialized ([('P').code, 4]),
					create {PD_KEY}.make_initialized ([('[').code, 4]),
					create {PD_KEY}.make_initialized ([(']').code, 4]),
					create {PD_KEY}.make_initialized ([256, 4]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([('A').code, 4]),
					create {PD_KEY}.make_initialized ([('S').code, 4]),
					create {PD_KEY}.make_initialized ([('D').code, 4]),
					create {PD_KEY}.make_initialized ([('F').code, 4]),
					create {PD_KEY}.make_initialized ([('G').code, 4]),
					create {PD_KEY}.make_initialized ([('H').code, 4]),
					create {PD_KEY}.make_initialized ([('J').code, 4]),
					create {PD_KEY}.make_initialized ([('K').code, 4]),
					create {PD_KEY}.make_initialized ([('L').code, 4]),
					create {PD_KEY}.make_initialized ([(';').code, 4]),
					create {PD_KEY}.make_initialized ([('%'').code, 4]),
					create {PD_KEY}.make_initialized ([('`').code, 4]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([('\').code, 4]),
					create {PD_KEY}.make_initialized ([('Z').code, 4]),
					create {PD_KEY}.make_initialized ([('X').code, 4]),
					create {PD_KEY}.make_initialized ([('C').code, 4]),
					create {PD_KEY}.make_initialized ([('V').code, 4]),
					create {PD_KEY}.make_initialized ([('B').code, 4]),
					create {PD_KEY}.make_initialized ([('N').code, 4]),
					create {PD_KEY}.make_initialized ([('M').code, 4]),
					create {PD_KEY}.make_initialized ([(',').code, 4]),
					create {PD_KEY}.make_initialized ([('.').code, 4]),
					create {PD_KEY}.make_initialized ([('/').code, 4]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([('*').code, 4]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([(' ').code, 4]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([288, 0]),
					create {PD_KEY}.make_initialized ([289, 0]),
					create {PD_KEY}.make_initialized ([290, 0]),
					create {PD_KEY}.make_initialized ([291, 0]),
					create {PD_KEY}.make_initialized ([292, 0]),
					create {PD_KEY}.make_initialized ([293, 0]),
					create {PD_KEY}.make_initialized ([294, 0]),
					create {PD_KEY}.make_initialized ([295, 0]),
					create {PD_KEY}.make_initialized ([296, 0]),
					create {PD_KEY}.make_initialized ([297, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([266, 0]),
					create {PD_KEY}.make_initialized ([262, 0]),
					create {PD_KEY}.make_initialized ([268, 0]),
					create {PD_KEY}.make_initialized ([('-').code, 4]),
					create {PD_KEY}.make_initialized ([260, 0]),
					create {PD_KEY}.make_initialized ([('5').code, 0]),
					create {PD_KEY}.make_initialized ([261, 0]),
					create {PD_KEY}.make_initialized ([('+').code, 4]),
					create {PD_KEY}.make_initialized ([267, 0]),
					create {PD_KEY}.make_initialized ([263, 0]),
					create {PD_KEY}.make_initialized ([269, 0]),
					create {PD_KEY}.make_initialized ([264, 0]),
					create {PD_KEY}.make_initialized ([265, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([288, 2]),
					create {PD_KEY}.make_initialized ([289, 2]),
					create {PD_KEY}.make_initialized ([290, 2]),
					create {PD_KEY}.make_initialized ([291, 2]),
					create {PD_KEY}.make_initialized ([292, 2]),
					create {PD_KEY}.make_initialized ([293, 2]),
					create {PD_KEY}.make_initialized ([294, 2]),
					create {PD_KEY}.make_initialized ([295, 2]),
					create {PD_KEY}.make_initialized ([296, 2]),
					create {PD_KEY}.make_initialized ([297, 2]),
					create {PD_KEY}.make_initialized ([288, 4]),
					create {PD_KEY}.make_initialized ([289, 4]),
					create {PD_KEY}.make_initialized ([290, 4]),
					create {PD_KEY}.make_initialized ([291, 4]),
					create {PD_KEY}.make_initialized ([292, 4]),
					create {PD_KEY}.make_initialized ([293, 4]),
					create {PD_KEY}.make_initialized ([294, 4]),
					create {PD_KEY}.make_initialized ([295, 4]),
					create {PD_KEY}.make_initialized ([296, 4]),
					create {PD_KEY}.make_initialized ([297, 4]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([260, 2]),
					create {PD_KEY}.make_initialized ([261, 2]),
					create {PD_KEY}.make_initialized ([267, 2]),
					create {PD_KEY}.make_initialized ([269, 2]),
					create {PD_KEY}.make_initialized ([266, 2]),
					create {PD_KEY}.make_initialized ([('1').code, 4]),
					create {PD_KEY}.make_initialized ([('2').code, 4]),
					create {PD_KEY}.make_initialized ([('3').code, 4]),
					create {PD_KEY}.make_initialized ([('4').code, 4]),
					create {PD_KEY}.make_initialized ([('5').code, 4]),
					create {PD_KEY}.make_initialized ([('6').code, 4]),
					create {PD_KEY}.make_initialized ([('7').code, 4]),
					create {PD_KEY}.make_initialized ([('8').code, 4]),
					create {PD_KEY}.make_initialized ([('9').code, 4]),
					create {PD_KEY}.make_initialized ([('0').code, 4]),
					create {PD_KEY}.make_initialized ([('-').code, 4]),
					create {PD_KEY}.make_initialized ([('=').code, 4]),
					create {PD_KEY}.make_initialized ([268, 2]),
					create {PD_KEY}.make_initialized ([298, 0]),
					create {PD_KEY}.make_initialized ([299, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([298, 2]),
					create {PD_KEY}.make_initialized ([299, 2]),
					create {PD_KEY}.make_initialized ([298, 4]),
					create {PD_KEY}.make_initialized ([299, 4]),
					create {PD_KEY}.make_initialized ([262, 2]),
					create {PD_KEY}.make_initialized ([('-').code, 2]),
					create {PD_KEY}.make_initialized ([('5').code, 2]),
					create {PD_KEY}.make_initialized ([('+').code, 2]),
					create {PD_KEY}.make_initialized ([263, 2]),
					create {PD_KEY}.make_initialized ([264, 2]),
					create {PD_KEY}.make_initialized ([265, 2]),
					create {PD_KEY}.make_initialized ([258, 2]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([266, 4]),
					create {PD_KEY}.make_initialized ([262, 4]),
					create {PD_KEY}.make_initialized ([268, 4]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([260, 4]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([261, 4]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([267, 4]),
					create {PD_KEY}.make_initialized ([263, 4]),
					create {PD_KEY}.make_initialized ([269, 4]),
					create {PD_KEY}.make_initialized ([264, 4]),
					create {PD_KEY}.make_initialized ([265, 4]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([258, 4]),
					create {PD_KEY}.make_initialized ([256, 4]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0]),
					create {PD_KEY}.make_initialized ([0, 0])
				>>)
		end

	xterm_button: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

feature {ANY} -- public routines

	write_ev_queue
		local
			l_l: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			if not eqlen.to_boolean then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).errline.item := 48
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("event queue empty"))])
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if eqlen > 128 then
				l_tmp := 128
			else
				l_tmp := eqlen
			end
			l_l := write (sock_out, create {CE_VOID_POINTER}.make_cast (ev_queue), l_tmp.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			if l_l = -1 then
				(create {P_KBD_STATIC}).free_trm ((create {CE_CLASS_POINTER [PD_ITRM]}.make_shared (c_pointer)))
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_tmp___0 := eqlen - l_l
				Current.eqlen := l_tmp___0
				update_class_fields -- Current might have been changed; synchronize
				memmove (create {CE_VOID_POINTER}.make_cast (ev_queue), create {CE_VOID_POINTER}.make_cast ((ev_queue + l_l)), l_tmp___0.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				if not eqlen.to_boolean then
					l_tmp___1 := get_handler (sock_out, 3)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := get_handler (sock_out, 2)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___3 := get_handler (sock_out, 0)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_SELECT_STATIC}).set_handlers (sock_out, create {CE_ROUTINE}.make_cast (l_tmp___3), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_cast (l_tmp___2), l_tmp___1)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	mouse_queue_event (a_data: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_return: BOOLEAN
		do
			if blocked.to_boolean then
				l_return := True
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_ITRM]}.make_shared (c_pointer))).item.queue_event (a_data, a_len)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	queue_event (a_data: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_w: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			l_w := 0
			if not a_len.to_boolean then
				l_return := True
			end
			if not l_return and then (not eqlen.to_boolean) then
				l_tmp := (create {P_LINKS_STATIC}).can_write (sock_out)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					l_w := write (sock_out, create {CE_VOID_POINTER}.make_cast (a_data), a_len.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_w <= 0 then
						(create {P_SELECT_STATIC}).register_bottom_half (((create {P_KBD_STATIC}).free_trm_address), create {CE_VOID_POINTER}.make_shared (c_pointer)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
				end
			end
			if not l_return and then (l_w < a_len) then
				if eqlen.to_natural_32 + (a_len - l_w).to_natural_32 > {NATURAL_32} 2_147_483_647 then
					from
					until
						False
					loop
						(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("kbd.c"), 75])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_KBD_STATIC}).fatal_tty_exit
						update_class_fields -- Current might have been changed; synchronize
						exit (4)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 76, create {CE_VOID_POINTER}.make_cast (ev_queue), ((eqlen + a_len) - l_w).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				Current.ev_queue := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0)
				update_class_fields -- Current might have been changed; synchronize
				memcpy (create {CE_VOID_POINTER}.make_cast ((ev_queue + eqlen)), create {CE_VOID_POINTER}.make_cast ((a_data + l_w)), (a_len - l_w).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Current.eqlen := eqlen + (a_len - l_w)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___1 := get_handler (sock_out, 0)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SELECT_STATIC}).set_handlers (sock_out, create {CE_ROUTINE}.make_cast (l_tmp___1), (write_ev_queue_address), ((create {P_KBD_STATIC}).free_trm_address), create {CE_VOID_POINTER}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	in_sock
		local
			l_path: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_delete: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pl: CE_ARRAY [INTEGER_32]
			l_dl: CE_ARRAY [INTEGER_32]
			l_ch: INTEGER_8
			l_fg: INTEGER_32
			l_c: INTEGER_32
			l_i: INTEGER_32
			l_p: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_cc: CE_ARRAY [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_cc___0: CE_ARRAY [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_cc___1: CE_ARRAY [NATURAL_8]
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_blockh: INTEGER_32
			l_param: CE_POINTER [NATURAL_8]
			l_tmp___7: INTEGER_32
			l_tmp___8: NATURAL_32
			l_tmp___9: NATURAL_32
			l_tmp___10: CE_POINTER [ANY]
			l_tmp___11: NATURAL_32
			l_tmp___12: NATURAL_32
			l_tmp___13: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_path.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_delete.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_pl.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_dl.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_cc.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_cc___0.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_cc___1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := read (sock_in, create {CE_VOID_POINTER}.make_cast (buf.item), (16_384).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if not (l_c <= 0) then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | fr:;
						(create {P_KBD_STATIC}).free_trm ((create {CE_CLASS_POINTER [PD_ITRM]}.make_shared (c_pointer)))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SELECT_STATIC}).terminate.item := 1
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
				when 2 then -- if done
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 3 then -- if: | qwerty:
						l_i := 0
				when 4 then -- loop condition:
						if not (l_i < l_c) then
							l_pos := -1 + 7 -- skip loop
						end
				when 5 then -- loop body:
						if not (buf.item[l_i]).to_boolean then
							l_pos := -1 + 9 -- goto ex
						end
				when 6 then
						l_i := l_i + 1
						l_pos := -1 + 4 -- back to loop condition
				when 7 then -- loop done
						l_tmp := (create {P_KBD_STATIC}).is_blocked
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp.to_boolean then
							(create {P_OS_DEP_STATIC}).want_draw
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_TERMINAL_STATIC}).hard_write (std_out, buf.item, l_c).do_nothing
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_OS_DEP_STATIC}).done_draw
							update_class_fields -- Current might have been changed; synchronize
						end
						l_return := True
				when 8 then -- if done
					if l_return then
						l_pos := -1 + 25 -- skip if block
					end
				when 9 then -- if: | ex:
						l_tmp___0 := (create {P_KBD_STATIC}).is_blocked
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___0.to_boolean then
							(create {P_OS_DEP_STATIC}).want_draw
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_TERMINAL_STATIC}).hard_write (std_out, buf.item, l_i).do_nothing
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_OS_DEP_STATIC}).done_draw
							update_class_fields -- Current might have been changed; synchronize
						end
						l_i := l_i + 1
						memmove (create {CE_VOID_POINTER}.make_cast (buf.item), create {CE_VOID_POINTER}.make_cast ((buf.item + l_i)), (16_384 - l_i).to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_c := l_c - l_i
						l_p := 0
						if l_p < l_c then
							l_tmp___1 := l_p
							l_p := l_p + 1
							l_cc.item := buf.item[l_tmp___1]
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___2 := hard_read (sock_in, l_cc, 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___2 <= 0 then
								l_pos := -1 + 1 -- goto fr
							end
						end
				when 10 then
						l_fg := (l_cc.item).to_integer_32
						l_path.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 378)
						update_class_fields -- Current might have been changed; synchronize
						l_delete.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 379)
						update_class_fields -- Current might have been changed; synchronize
						l_dl.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_pl.item := l_dl.item
						update_class_fields -- Current might have been changed; synchronize
				when 11 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 14 -- skip loop
						end
				when 12 then -- loop body:
						l_break := False
						if l_p < l_c then
							l_tmp___3 := l_p
							l_p := l_p + 1
							l_cc___0.item := buf.item[l_tmp___3]
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___4 := hard_read (sock_in, l_cc___0, 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___4 <= 0 then
								l_pos := -1 + 1 -- goto fr
							end
						end
				when 13 then
						l_ch := (l_cc___0.item).to_integer_8
						if not l_ch.to_boolean then
							l_break := True
						end
						if not (l_break) then
							(create {P_LINKS_STATIC}).add_chr_to_str (l_path, l_pl, l_ch.to_natural_8)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 11 -- back to loop condition
				when 14 then -- loop done
						l_break := False
				when 15 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 18 -- skip loop
						end
				when 16 then -- loop body:
						l_break := False
						if l_p < l_c then
							l_tmp___5 := l_p
							l_p := l_p + 1
							l_cc___1.item := buf.item[l_tmp___5]
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___6 := hard_read (sock_in, l_cc___1, 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___6 <= 0 then
								l_pos := -1 + 1 -- goto fr
							end
						end
				when 17 then
						l_ch := (l_cc___1.item).to_integer_8
						if not l_ch.to_boolean then
							l_break := True
						end
						if not (l_break) then
							(create {P_LINKS_STATIC}).add_chr_to_str (l_delete, l_dl, l_ch.to_natural_8)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 15 -- back to loop condition
				when 18 then -- loop done
						l_break := False
						if (l_path.item.item).to_boolean then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:;
						(create {P_KBD_STATIC}).dispatch_special (l_delete.item)
						update_class_fields -- Current might have been changed; synchronize
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 21 then -- else:
						l_tmp___7 := (create {P_KBD_STATIC}).is_blocked
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___7.to_boolean then
							if l_fg.to_boolean then
								if (l_delete.item.item).to_boolean then
									unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_delete.item)).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
								l_pos := -1 + 24 -- goto to_je_ale_hnus
							end
						end
				when 22 then
						l_tmp___8 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_path.item))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___9 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_delete.item))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___10 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 400, (l_tmp___8 + l_tmp___9) + {NATURAL_32} 3)
						update_class_fields -- Current might have been changed; synchronize
						l_param := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___10)
						l_param[0] := l_fg.to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_param + 1)), create {CE_INTEGER_8_POINTER}.make_cast (l_path.item)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___11 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_path.item))
						update_class_fields -- Current might have been changed; synchronize
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((((l_param + 1) + l_tmp___11.to_integer_32) + 1)), create {CE_INTEGER_8_POINTER}.make_cast (l_delete.item)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if l_fg = 1 then
							(create {P_KBD_STATIC}).block_itrm (0)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tmp___12 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_path.item))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___13 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_delete.item))
						update_class_fields -- Current might have been changed; synchronize
						l_blockh := (create {P_OS_DEP_STATIC}).start_thread (((create {P_TERMINAL_STATIC}).exec_thread_address), create {CE_VOID_POINTER}.make_cast (l_param), ((l_tmp___12 + l_tmp___13) + {NATURAL_32} 3).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_blockh = -1 then
							if l_fg = 1 then
								(create {P_KBD_STATIC}).unblock_itrm (0).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 407, create {CE_VOID_POINTER}.make_cast (l_param))
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 24 -- goto to_je_ale_hnus
						end
				when 23 then;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 410, create {CE_VOID_POINTER}.make_cast (l_param))
						update_class_fields -- Current might have been changed; synchronize
						if l_fg = 1 then
							(create {P_SELECT_STATIC}).set_handlers (l_blockh, (create {P_KBD_STATIC}).unblock_itrm_x_address, create {CE_ROUTINE}.make_shared (default_pointer), (create {P_KBD_STATIC}).unblock_itrm_x_address, create {CE_VOID_POINTER}.make_shared (default_pointer + l_blockh))
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_SELECT_STATIC}).set_handlers (l_blockh, (create {P_TERMINAL_STATIC}).close_handle_address, create {CE_ROUTINE}.make_shared (default_pointer), (create {P_TERMINAL_STATIC}).close_handle_address, create {CE_VOID_POINTER}.make_shared (default_pointer + l_blockh))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 24 then -- to_je_ale_hnus:;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 418, create {CE_VOID_POINTER}.make_cast (l_path.item))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c")), 419, create {CE_VOID_POINTER}.make_cast (l_delete.item))
						update_class_fields -- Current might have been changed; synchronize
						memmove (create {CE_VOID_POINTER}.make_cast (buf.item), create {CE_VOID_POINTER}.make_cast ((buf.item + l_p)), (16_384 - l_p).to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_c := l_c - l_p
						l_pos := -1 + 3 -- goto qwerty
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	kbd_timeout
		local
			l_ev: CE_ARRAY [PD_EVENT]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_EVENT]} l_ev.make (<<1>>)

			l_ev.item.ev := 1
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.x := 259
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.y := 0
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.b := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.tm := -1
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_LINKS_STATIC}).can_read (std_in)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				((create {CE_CLASS_POINTER [PD_ITRM]}.make_shared (c_pointer))).item.in_kbd
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return and then (not qlen.to_boolean) then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).errline.item := 436
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("timeout on empty queue"))])
					update_class_fields -- Current might have been changed; synchronize
				end
				l_return := True
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_ITRM]}.make_shared (c_pointer))).item.queue_event (create {CE_NATURAL_8_POINTER}.make_cast (l_ev), ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				Current.qlen := qlen - 1
				update_class_fields -- Current might have been changed; synchronize
				if qlen.to_boolean then
					memmove (create {CE_VOID_POINTER}.make_cast (kqueue), create {CE_VOID_POINTER}.make_cast ((kqueue + 1)), qlen.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___0 := ((create {CE_CLASS_POINTER [PD_ITRM]}.make_shared (c_pointer))).item.process_queue
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp___0.to_boolean then
						l_break := True
					end
				end
				l_break := False
			end
		end

	process_queue: INTEGER_32
		local
			l_ev: CE_ARRAY [PD_EVENT]
			l_el: CE_ARRAY [INTEGER_32]
			l_c: CE_ARRAY [INTEGER_8]
			l_v: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_EVENT]} l_ev.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_el.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_c.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_v.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ev.item.ev := 1
					update_class_fields -- Current might have been changed; synchronize
					l_ev.item.x := -1
					update_class_fields -- Current might have been changed; synchronize
					l_ev.item.y := 0
					update_class_fields -- Current might have been changed; synchronize
					l_ev.item.b := 0
					update_class_fields -- Current might have been changed; synchronize
					l_el.item := 0
					update_class_fields -- Current might have been changed; synchronize
					if not qlen.to_boolean then
						l_pos := -1 + 84 -- goto end
					end
				when 1 then
					if (kqueue[0]).to_integer_32 /= 27 then
						l_pos := -1 + 78 -- skip if block
					end
				when 2 then -- if:
						if qlen < 2 then
							l_pos := -1 + 85 -- goto ret
						end
				when 3 then
						if (kqueue[1]).to_integer_32 /= 91 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 6 then -- else:
						if (kqueue[1]).to_integer_32 /= 79 then
							l_pos := -1 + 73 -- skip if block
						end
				when 7 then -- if: | _L___0:
						if not (qlen >= 4) then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
						if (kqueue[2]).to_integer_32 /= 91 then
							l_pos := -1 + 12 -- skip if block
						end
				when 9 then -- if:
						if (kqueue[3]).to_integer_32 < 65 then
							l_pos := -1 + 85 -- goto ret
						elseif (kqueue[3]).to_integer_32 > 76 then
							l_pos := -1 + 85 -- goto ret
						end
				when 10 then
						l_ev.item.x := (288 - ((kqueue[3]).to_integer_32 - 65)).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_el.item := 4
						update_class_fields -- Current might have been changed; synchronize
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_pos := -1 + 14 -- goto _L
				when 13 then -- if done | if block done, skip else block:
						l_pos := -1 + 72
				when 14 then -- else: | _L:
						l_tmp___2 := get_esc_code (create {CE_INTEGER_8_POINTER}.make_cast (kqueue), qlen, l_c, l_v, l_el)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___2.to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 85 -- goto ret
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 17 then -- else:
						inspect (l_c.item).to_integer_32 -- switch 1 head
						when 64 then l_pos := -1 + 18
						when 65 then l_pos := -1 + 19
						when 66 then l_pos := -1 + 20
						when 67 then l_pos := -1 + 21
						when 68 then l_pos := -1 + 22
						when 70 then l_pos := -1 + 23
						when 75 then l_pos := -1 + 23
						when 101 then l_pos := -1 + 23
						when 72 then l_pos := -1 + 24
						when 0 then l_pos := -1 + 24
						when 86 then l_pos := -1 + 25
						when 73 then l_pos := -1 + 25
						when 85 then l_pos := -1 + 26
						when 71 then l_pos := -1 + 26
						when 80 then l_pos := -1 + 27
						when 81 then l_pos := -1 + 28
						when 83 then l_pos := -1 + 29
						when 84 then l_pos := -1 + 30
						when 87 then l_pos := -1 + 31
						when 88 then l_pos := -1 + 32
						when 89 then l_pos := -1 + 33
						when 122 then l_pos := -1 + 34
						when 126 then l_pos := -1 + 42
						when 82 then l_pos := -1 + 59
						when 77 then l_pos := -1 + 60
						else l_pos := -1 + 72
						end
				when 18 then -- switch 1, case 64
						l_ev.item.x := 264
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 19 then -- switch 1, case 65
						l_ev.item.x := 262
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 20 then -- switch 1, case 66
						l_ev.item.x := 263
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 21 then -- switch 1, case 67
						l_ev.item.x := 261
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 22 then -- switch 1, case 68
						l_ev.item.x := 260
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 23 then -- switch 1, case 70 | switch 1, case 75 | switch 1, case 101
						l_ev.item.x := 267
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 24 then -- switch 1, case 72 | switch 1, case 0
						l_ev.item.x := 266
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 25 then -- switch 1, case 86 | switch 1, case 73
						l_ev.item.x := 268
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 26 then -- switch 1, case 85 | switch 1, case 71
						l_ev.item.x := 269
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 27 then -- switch 1, case 80
						l_ev.item.x := 288
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 28 then -- switch 1, case 81
						l_ev.item.x := 289
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 29 then -- switch 1, case 83
						l_ev.item.x := 291
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 30 then -- switch 1, case 84
						l_ev.item.x := 292
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 31 then -- switch 1, case 87
						l_ev.item.x := 295
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 32 then -- switch 1, case 88
						l_ev.item.x := 296
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 33 then -- switch 1, case 89
						l_ev.item.x := 298
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 34 then -- switch 1, case 122
						inspect l_v.item -- switch 2 head
						when 247 then l_pos := -1 + 35
						when 214 then l_pos := -1 + 36
						when 220 then l_pos := -1 + 37
						when 216 then l_pos := -1 + 38
						when 222 then l_pos := -1 + 39
						when 249 then l_pos := -1 + 40
						else l_pos := -1 + 41
						end
				when 35 then -- switch 2, case 247
						l_ev.item.x := 264
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 41 -- switch 2; break
				when 36 then -- switch 2, case 214
						l_ev.item.x := 266
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 41 -- switch 2; break
				when 37 then -- switch 2, case 220
						l_ev.item.x := 267
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 41 -- switch 2; break
				when 38 then -- switch 2, case 216
						l_ev.item.x := 268
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 41 -- switch 2; break
				when 39 then -- switch 2, case 222
						l_ev.item.x := 269
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 41 -- switch 2; break
				when 40 then -- switch 2, case 249
						l_ev.item.x := 265
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 41 -- switch 2; break
				when 41 then -- switch 2, done:
						l_pos := -1 + 72 -- switch 1; break
				when 42 then -- switch 1, case 126
						inspect l_v.item -- switch 3 head
						when 1 then l_pos := -1 + 43
						when 2 then l_pos := -1 + 44
						when 3 then l_pos := -1 + 45
						when 4 then l_pos := -1 + 46
						when 5 then l_pos := -1 + 47
						when 6 then l_pos := -1 + 48
						when 7 then l_pos := -1 + 49
						when 8 then l_pos := -1 + 50
						when 17 then l_pos := -1 + 51
						when 18 then l_pos := -1 + 52
						when 19 then l_pos := -1 + 53
						when 20 then l_pos := -1 + 54
						when 21 then l_pos := -1 + 55
						when 23 then l_pos := -1 + 56
						when 24 then l_pos := -1 + 57
						else l_pos := -1 + 58
						end
				when 43 then -- switch 3, case 1
						l_ev.item.x := 266
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 58 -- switch 3; break
				when 44 then -- switch 3, case 2
						l_ev.item.x := 264
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 58 -- switch 3; break
				when 45 then -- switch 3, case 3
						l_ev.item.x := 265
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 58 -- switch 3; break
				when 46 then -- switch 3, case 4
						l_ev.item.x := 267
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 58 -- switch 3; break
				when 47 then -- switch 3, case 5
						l_ev.item.x := 268
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 58 -- switch 3; break
				when 48 then -- switch 3, case 6
						l_ev.item.x := 269
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 58 -- switch 3; break
				when 49 then -- switch 3, case 7
						l_ev.item.x := 266
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 58 -- switch 3; break
				when 50 then -- switch 3, case 8
						l_ev.item.x := 267
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 58 -- switch 3; break
				when 51 then -- switch 3, case 17
						l_ev.item.x := 293
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 58 -- switch 3; break
				when 52 then -- switch 3, case 18
						l_ev.item.x := 294
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 58 -- switch 3; break
				when 53 then -- switch 3, case 19
						l_ev.item.x := 295
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 58 -- switch 3; break
				when 54 then -- switch 3, case 20
						l_ev.item.x := 296
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 58 -- switch 3; break
				when 55 then -- switch 3, case 21
						l_ev.item.x := 297
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 58 -- switch 3; break
				when 56 then -- switch 3, case 23
						l_ev.item.x := 298
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 58 -- switch 3; break
				when 57 then -- switch 3, case 24
						l_ev.item.x := 299
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 58 -- switch 3; break
				when 58 then -- switch 3, done:
						l_pos := -1 + 72 -- switch 1; break
				when 59 then -- switch 1, case 82;
						(create {P_KBD_STATIC}).resize_terminal
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 60 then -- switch 1, case 77
						if qlen - l_el.item < 3 then
							l_pos := -1 + 85 -- goto ret
						end
				when 61 then
						if l_v.item /= 5 then
							l_pos := -1 + 70 -- skip if block
						end
				when 62 then -- if:
						if xterm_button.item = -1 then
							xterm_button.item := 0
						end
						if qlen - l_el.item < 5 then
							l_pos := -1 + 85 -- goto ret
						end
				when 63 then
						l_ev.item.x := ((((kqueue[l_el.item + 1]).to_integer_32 - 32) - 1) + (((((kqueue[l_el.item + 2]).to_integer_32 - 32) - 1)).bit_shift_left (7))).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						if ((l_ev.item.x).bit_and (((1).bit_shift_left (13)).to_integer_32)).to_boolean then
							l_ev.item.x := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						l_ev.item.y := ((((kqueue[l_el.item + 3]).to_integer_32 - 32) - 1) + (((((kqueue[l_el.item + 4]).to_integer_32 - 32) - 1)).bit_shift_left (7))).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						if ((l_ev.item.y).bit_and (((1).bit_shift_left (13)).to_integer_32)).to_boolean then
							l_ev.item.y := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						inspect (((kqueue[l_el.item]).to_integer_32 - 32)).bit_xor (xterm_button.item) -- switch 4 head
						when 1 then l_pos := -1 + 64
						when 2 then l_pos := -1 + 65
						when 4 then l_pos := -1 + 66
						when 0 then l_pos := -1 + 67
						else l_pos := -1 + 68
						end
				when 64 then -- switch 4, case 1
						if ((xterm_button.item).bit_and (1)).to_boolean then
							l_tmp := 4
						else
							l_tmp := 0
						end
						l_ev.item.b := l_tmp.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 68 -- switch 4; break
				when 65 then -- switch 4, case 2
						if ((xterm_button.item).bit_and (2)).to_boolean then
							l_tmp___0 := 4
						else
							l_tmp___0 := 0
						end
						l_ev.item.b := ((1).bit_or (l_tmp___0)).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 68 -- switch 4; break
				when 66 then -- switch 4, case 4
						if ((xterm_button.item).bit_and (4)).to_boolean then
							l_tmp___1 := 4
						else
							l_tmp___1 := 0
						end
						l_ev.item.b := ((2).bit_or (l_tmp___1)).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 68 -- switch 4; break
				when 67 then -- switch 4, case 0
						l_ev.item.b := 8
						update_class_fields -- Current might have been changed; synchronize
				when 68 then -- switch 4, done:
						xterm_button.item := (kqueue[l_el.item]).to_integer_32 - 32
						l_el.item := l_el.item + (5)
						update_class_fields -- Current might have been changed; synchronize
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 71
				when 70 then -- else:
						l_ev.item.x := (((kqueue[l_el.item + 1]).to_integer_32 - 32) - 1).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_ev.item.y := (((kqueue[l_el.item + 2]).to_integer_32 - 32) - 1).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_ev.item.b := 0
						update_class_fields -- Current might have been changed; synchronize
						if (((kqueue[l_el.item]).to_integer_32).bit_and (4)).to_boolean then
							l_ev.item.b := 8
							update_class_fields -- Current might have been changed; synchronize
						end
						l_ev.item.b := (l_ev.item.b).bit_or ((((kqueue[l_el.item]).to_integer_32).bit_and (3)).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_ev.item.b = 3 then
							l_ev.item.b := 4
							update_class_fields -- Current might have been changed; synchronize
							if xterm_button.item /= -1 then
								l_ev.item.b := (l_ev.item.b).bit_or (xterm_button.item.to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						xterm_button.item := -1
						if ((l_ev.item.b).bit_and (12)) = 0 then
							xterm_button.item := ((l_ev.item.b).bit_and (3)).to_integer_32
						end
						l_el.item := l_el.item + (3)
						update_class_fields -- Current might have been changed; synchronize
				when 71 then -- if done
						l_ev.item.ev := 2
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 72 then -- switch 1, done: | if done | if done | if block done, skip else block:
						l_pos := -1 + 76
				when 73 then -- else:
						l_el.item := 2
						update_class_fields -- Current might have been changed; synchronize
						if (kqueue[1]).to_integer_32 >= 32 then
							l_ev.item.x := (kqueue[1]).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							l_ev.item.y := 4
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 82 -- goto l2
						end
				when 74 then
						if (kqueue[1]).to_integer_32 = 127 then
							l_ev.item.x := 265
							update_class_fields -- Current might have been changed; synchronize
							l_ev.item.y := 0
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 82 -- goto l2
						end
				when 75 then
						if (kqueue[1]).to_integer_32 = 27 then
							if qlen >= 3 then
								if (kqueue[2]).to_integer_32 = 91 then
									l_el.item := 1
									update_class_fields -- Current might have been changed; synchronize
								elseif (kqueue[2]).to_integer_32 = 79 then
									l_el.item := 1
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_ev.item.x := 259
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 82 -- goto l2
						end
				when 76 then -- if done
						l_pos := -1 + 83 -- goto l1
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 78 then -- else:
						if (kqueue[0]).to_integer_32 /= 0 then
							l_pos := -1 + 81 -- skip if block
						end
				when 79 then -- if:
						if qlen < 2 then
							l_pos := -1 + 85 -- goto ret
						end
				when 80 then
						l_ev.item.x := (os2xtd.item[(kqueue[1]).to_integer_32].x).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						if not (l_ev.item.x).to_boolean then
							l_ev.item.x := -1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_ev.item.y := (os2xtd.item[(kqueue[1]).to_integer_32].y).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_el.item := 2
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 83 -- goto l1
				when 81 then -- if done
					l_el.item := 1
					update_class_fields -- Current might have been changed; synchronize
					l_ev.item.x := (kqueue[0]).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				when 82 then -- l2:
					if l_ev.item.x = 8 then
						l_ev.item.x := 257
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_ev.item.x = 9 then
						l_ev.item.x := 258
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_ev.item.x = 10 then
						l_ev.item.x := 256
						update_class_fields -- Current might have been changed; synchronize
						l_ev.item.y := 2
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_ev.item.x = 13 then
						l_ev.item.x := 256
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_ev.item.x = 127 then
						l_ev.item.x := 257
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_ev.item.x < 32 then
						l_ev.item.x := l_ev.item.x + (64)
						update_class_fields -- Current might have been changed; synchronize
						l_ev.item.y := 2
						update_class_fields -- Current might have been changed; synchronize
					end
				when 83 then -- l1:
					if qlen < l_el.item then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kbd.c"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).errline.item := 666
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("event queue underflow"))])
							update_class_fields -- Current might have been changed; synchronize
						end
						Current.qlen := l_el.item
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_ev.item.x /= -1 then
						((create {CE_CLASS_POINTER [PD_ITRM]}.make_shared (c_pointer))).item.queue_event (create {CE_NATURAL_8_POINTER}.make_cast (l_ev), ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___3 := qlen - l_el.item
						Current.qlen := l_tmp___3
						update_class_fields -- Current might have been changed; synchronize
						memmove (create {CE_VOID_POINTER}.make_cast (kqueue), create {CE_VOID_POINTER}.make_cast ((kqueue + l_el.item)), l_tmp___3.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					else
						l_tmp___4 := qlen - l_el.item
						Current.qlen := l_tmp___4
						update_class_fields -- Current might have been changed; synchronize
						memmove (create {CE_VOID_POINTER}.make_cast (kqueue), create {CE_VOID_POINTER}.make_cast ((kqueue + l_el.item)), l_tmp___4.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
				when 84 then -- end:
					if qlen < 16 then
						(create {P_SELECT_STATIC}).set_handlers (std_in, (in_kbd_address), create {CE_ROUTINE}.make_shared (default_pointer), ((create {P_KBD_STATIC}).free_trm_address), create {CE_VOID_POINTER}.make_shared (c_pointer))
						update_class_fields -- Current might have been changed; synchronize
					end
					Result := (l_el.item)
					l_return := True
					if l_return then
						l_pos := -1 + 86 -- skip if block
					end
				when 85 then -- if: | ret:
						Current.tm := (create {P_SELECT_STATIC}).install_timer ((200).to_integer_32, (kbd_timeout_address), create {CE_VOID_POINTER}.make_shared (c_pointer))
						update_class_fields -- Current might have been changed; synchronize
						Result := 0
				when 86 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	in_kbd
		local
			l_r: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_tmp := (create {P_LINKS_STATIC}).can_read (std_in)
			update_class_fields -- Current might have been changed; synchronize
			if not l_tmp.to_boolean then
				l_return := True
			end
			if not l_return then
				if tm /= -1 then
					(create {P_SELECT_STATIC}).kill_timer (tm)
					update_class_fields -- Current might have been changed; synchronize
					Current.tm := -1
					update_class_fields -- Current might have been changed; synchronize
				end
				if qlen >= 16 then
					(create {P_SELECT_STATIC}).set_handlers (std_in, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), ((create {P_KBD_STATIC}).free_trm_address), create {CE_VOID_POINTER}.make_shared (c_pointer))
					update_class_fields -- Current might have been changed; synchronize
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___0 := ((create {CE_CLASS_POINTER [PD_ITRM]}.make_shared (c_pointer))).item.process_queue
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___0.to_boolean then
							l_break := True
						end
					end
					l_break := False
					l_return := True
				end
			end
			if not l_return then
				l_r := read (std_in, create {CE_VOID_POINTER}.make_cast ((kqueue + qlen)), (16 - qlen).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				if l_r <= 0 then
					(create {P_KBD_STATIC}).free_trm ((create {CE_CLASS_POINTER [PD_ITRM]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
				l_tmp___1 := qlen + l_r
				Current.qlen := l_tmp___1
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___1 > 16 then
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: too many bytes read"))])
					update_class_fields -- Current might have been changed; synchronize
					Current.qlen := 16
					update_class_fields -- Current might have been changed; synchronize
				end
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___2 := ((create {CE_CLASS_POINTER [PD_ITRM]}.make_shared (c_pointer))).item.process_queue
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp___2.to_boolean then
						l_break := True
					end
				end
				l_break := False
			end
		end

feature {PD_ITRM} -- private routines

	get_handler (a_fd, a_tp: INTEGER_32): CE_POINTER [ANY]
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_fd < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_fd >= 1_024) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("select.c"));
							(create {P_LINKS_STATIC}).errline.item := 148;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("get_handler: handle %%d >= FD_SETSIZE %%d")), a_fd, 1_024])
						end
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
				when 5 then -- if done
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 6 then -- if:
						inspect a_tp -- switch 1 head
						when 0 then l_pos := -1 + 7
						when 1 then l_pos := -1 + 8
						when 2 then l_pos := -1 + 9
						when 3 then l_pos := -1 + 10
						else l_pos := -1 + 11
						end
				when 7 then -- switch 1, case 0
						Result := (create {CE_VOID_POINTER}.make_cast ((create {P_SELECT_STATIC}).threads.item[a_fd].read_func))
						l_return := True
				when 8 then -- switch 1, case 1
						if not l_return then
							Result := (create {CE_VOID_POINTER}.make_cast ((create {P_SELECT_STATIC}).threads.item[a_fd].write_func))
							l_return := True
						end
				when 9 then -- switch 1, case 2
						if not l_return then
							Result := (create {CE_VOID_POINTER}.make_cast ((create {P_SELECT_STATIC}).threads.item[a_fd].error_func))
							l_return := True
						end
				when 10 then -- switch 1, case 3
						if not l_return then
							Result := ((create {P_SELECT_STATIC}).threads.item[a_fd].data)
							l_return := True
						end
				when 11 then -- switch 1, done: | if done
					if not l_return then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("select.c"));
							(create {P_LINKS_STATIC}).errline.item := 157;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("get_handler: bad type %%d")), a_tp])
						end
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_esc_code (a_str: CE_POINTER [INTEGER_8]; a_len: INTEGER_32; a_code: CE_POINTER [INTEGER_8]; a_num, a_el: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_num.is_void
		local
			l_pos___0: INTEGER_32
			l_return: BOOLEAN
		do
			a_num.item := 0
			l_pos___0 := 2
			from
			until
				not (not (l_return) and then (l_pos___0 < a_len))
			loop
				if (a_str[l_pos___0]).to_integer_32 < 48 then
					a_el.item := l_pos___0 + 1
					a_code[0] := a_str[l_pos___0]
					Result := 0
					l_return := True
				elseif (a_str[l_pos___0]).to_integer_32 > 57 then
					a_el.item := l_pos___0 + 1
					a_code[0] := a_str[l_pos___0]
					Result := 0
					l_return := True
				elseif l_pos___0 > 7 then
					a_el.item := l_pos___0 + 1
					a_code[0] := a_str[l_pos___0]
					Result := 0
					l_return := True
				end
				if not l_return then
					a_num.item := (a_num.item * 10 + (a_str[l_pos___0]).to_integer_32) - 48
					l_pos___0 := l_pos___0 + 1
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

	hard_read (a_fd: INTEGER_32; a_p: CE_POINTER [NATURAL_8]; a_l: INTEGER_32): INTEGER_32
		local
			l_p: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_r: INTEGER_32
			l_t: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			l_p := a_p
			l_l := a_l
			l_r := 1
			l_t := 0
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_continue := False
				if l_l > 0 then
					if not l_r.to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_return or l_break or l_continue) then
					l_r := read (a_fd, create {CE_VOID_POINTER}.make_cast (l_p), l_l.to_natural_32)
					if l_r < 0 then
						if (errno_location).item = 4 then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							Result := (-1)
							l_return := True
						end
					end
				end
				if not (l_return or l_break or l_continue) then
					l_t := l_t + l_r
					l_p := l_p + l_r
					l_l := l_l - l_r
				end
			end
			if not l_return then
				l_break := False
				l_continue := False
				Result := l_t
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			std_in := a_other.std_in
			std_out := a_other.std_out
			sock_in := a_other.sock_in
			sock_out := a_other.sock_out
			ctl_in := a_other.ctl_in
			blocked := a_other.blocked
			t := a_other.t.twin
			flags := a_other.flags
			kqueue := a_other.kqueue.twin
			qlen := a_other.qlen
			tm := a_other.tm
			ev_queue := a_other.ev_queue
			eqlen := a_other.eqlen
			mouse_h := a_other.mouse_h
			orig_title := a_other.orig_title
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				std_in = a_other.std_in and
				std_out = a_other.std_out and
				sock_in = a_other.sock_in and
				sock_out = a_other.sock_out and
				ctl_in = a_other.ctl_in and
				blocked = a_other.blocked and
				t.is_equal (a_other.t) and
				flags = a_other.flags and
				kqueue.is_equal (a_other.kqueue) and
				qlen = a_other.qlen and
				tm = a_other.tm and
				ev_queue.is_equal (a_other.ev_queue) and
				eqlen = a_other.eqlen and
				mouse_h.is_equal (a_other.mouse_h) and
				orig_title.is_equal (a_other.orig_title)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("std_in"),
					create {CE_STRUCTURE_FIELD}.make ("std_out"),
					create {CE_STRUCTURE_FIELD}.make ("sock_in"),
					create {CE_STRUCTURE_FIELD}.make ("sock_out"),
					create {CE_STRUCTURE_FIELD}.make ("ctl_in"),
					create {CE_STRUCTURE_FIELD}.make ("blocked"),
					create {CE_STRUCTURE_FIELD}.make ("t"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("kqueue", <<16>>),
					create {CE_STRUCTURE_FIELD}.make ("qlen"),
					create {CE_STRUCTURE_FIELD}.make ("tm"),
					create {CE_STRUCTURE_FIELD}.make ("ev_queue"),
					create {CE_STRUCTURE_FIELD}.make ("eqlen"),
					create {CE_STRUCTURE_FIELD}.make ("mouse_h"),
					create {CE_STRUCTURE_FIELD}.make ("orig_title")
				>>)
			init_structure_info
		end

end
