class
	PD_LINK_DEF

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} link.make
			create {CE_NATURAL_8_POINTER} target.make
		end

feature {ANY} -- fields

	link: CE_POINTER [NATURAL_8] assign set_link

	target: CE_POINTER [NATURAL_8] assign set_target

feature {ANY} -- field setters

	set_link (a_link: CE_POINTER [NATURAL_8])
		do
			link := a_link
			update_memory_field ("link")
		end

	set_target (a_target: CE_POINTER [NATURAL_8])
		do
			target := a_target
			update_memory_field ("target")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			link := a_other.link
			target := a_other.target
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				link.is_equal (a_other.link) and
				target.is_equal (a_other.target)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("link"),
					create {CE_STRUCTURE_FIELD}.make ("target")
				>>)
			init_structure_info
		end

end
