class
	PD_PART

inherit
	PD_PART_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_F_DATA]} data.make
			create {CE_NATURAL_8_POINTER} spaces.make
			create uf.make
			Precursor
		end

feature {ANY} -- fields

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	xp: INTEGER_32 assign set_xp

	yp: INTEGER_32 assign set_yp

	xmax: INTEGER_32 assign set_xmax

	xa: INTEGER_32 assign set_xa

	cx: INTEGER_32 assign set_cx

	cy: INTEGER_32 assign set_cy

	data: CE_POINTER [PD_F_DATA] assign set_data

	bgcolor: INTEGER_32 assign set_bgcolor

	spaces: CE_POINTER [NATURAL_8] assign set_spaces

	spl: INTEGER_32 assign set_spl

	link_num: INTEGER_32 assign set_link_num

	uf: PD_LIST_HEAD assign set_uf

feature {ANY} -- field setters

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_xp (a_xp: INTEGER_32)
		do
			xp := a_xp
			update_memory_field ("xp")
		end

	set_yp (a_yp: INTEGER_32)
		do
			yp := a_yp
			update_memory_field ("yp")
		end

	set_xmax (a_xmax: INTEGER_32)
		do
			xmax := a_xmax
			update_memory_field ("xmax")
		end

	set_xa (a_xa: INTEGER_32)
		do
			xa := a_xa
			update_memory_field ("xa")
		end

	set_cx (a_cx: INTEGER_32)
		do
			cx := a_cx
			update_memory_field ("cx")
		end

	set_cy (a_cy: INTEGER_32)
		do
			cy := a_cy
			update_memory_field ("cy")
		end

	set_data (a_data: CE_POINTER [PD_F_DATA])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_bgcolor (a_bgcolor: INTEGER_32)
		do
			bgcolor := a_bgcolor
			update_memory_field ("bgcolor")
		end

	set_spaces (a_spaces: CE_POINTER [NATURAL_8])
		do
			spaces := a_spaces
			update_memory_field ("spaces")
		end

	set_spl (a_spl: INTEGER_32)
		do
			spl := a_spl
			update_memory_field ("spl")
		end

	set_link_num (a_link_num: INTEGER_32)
		do
			link_num := a_link_num
			update_memory_field ("link_num")
		end

	set_uf (a_uf: PD_LIST_HEAD)
		do
			uf := a_uf
			update_memory_field ("uf")
		end

feature {ANY} -- public routines

	xpand_lines (a_y: INTEGER_32)
		local
			l_y: INTEGER_32
			l_i: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			l_y := a_y
			if data.is_void then
				l_return := True
			end
			if not l_return then
				if ((((l_y.to_natural_32 + yp.to_natural_32) + {NATURAL_32} 127)).bit_and ({NATURAL_32} 4_294_967_168)) > {NATURAL_32} 2_147_483_647 then
					from
					until
						False
					loop
						(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_r.c"), 134])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_KBD_STATIC}).fatal_tty_exit
						update_class_fields -- Current might have been changed; synchronize
						exit (4)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_y := l_y + yp
				if l_y >= data.item.y then
					if ((((l_y + 1) + 127)).bit_and (-128)) > (((data.item.y + 127)).bit_and (-128)) then
						if ((((l_y.to_natural_32 + {NATURAL_32} 1) + {NATURAL_32} 127)).bit_and ({NATURAL_32} 4_294_967_168)) > {NATURAL_32} 2_147_483_647 // (create {PD_LINE}.make).structure_size.to_natural_32 then
							from
							until
								False
							loop
								(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_r.c"), 139])
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_KBD_STATIC}).fatal_tty_exit
								update_class_fields -- Current might have been changed; synchronize
								exit (4)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_tmp := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 140, create {CE_VOID_POINTER}.make_cast (data.item.data), ((((l_y + 1) + 127)).bit_and (-128)).to_natural_32 * (create {PD_LINE}.make).structure_size.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						data.item.data := create {CE_CLASS_POINTER [PD_LINE]}.make_cast (l_tmp)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_i := data.item.y
					from
					until
						not (l_i <= l_y)
					loop
						(data.item.data + l_i).item.l := 0
						update_class_fields; -- Current might have been changed; synchronize
						(data.item.data + l_i).item.c := bgcolor.to_natural_16
						update_class_fields; -- Current might have been changed; synchronize
						(data.item.data + l_i).item.d := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer + -1)
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i + 1
					end
					data.item.y := l_i
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	xpand_line (a_y, a_x: INTEGER_32)
		local
			l_y: INTEGER_32
			l_x: INTEGER_32
			l_i: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			l_y := a_y
			l_x := a_x
			if data.is_void then
				l_return := True
			end
			if not l_return then
				if ((((l_x.to_natural_32 + xp.to_natural_32) + {NATURAL_32} 127)).bit_and ({NATURAL_32} 4_294_967_168)) > {NATURAL_32} 2_147_483_647 then
					from
					until
						False
					loop
						(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_r.c"), 154])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_KBD_STATIC}).fatal_tty_exit
						update_class_fields -- Current might have been changed; synchronize
						exit (4)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_x := l_x + xp
				l_y := l_y + yp
				if l_y >= data.item.y then
					from
					until
						False
					loop
						(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).errline.item := 159
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("line does not exist"))])
						update_class_fields -- Current might have been changed; synchronize
					end
					l_return := True
				end
			end
			if not l_return and then (l_x >= (data.item.data + l_y).item.l) then
				if ((((l_x + 1) + 127)).bit_and (-128)) > ((((data.item.data + l_y).item.l + 127)).bit_and (-128)) then
					if ((((l_x.to_natural_32 + {NATURAL_32} 1) + {NATURAL_32} 127)).bit_and ({NATURAL_32} 4_294_967_168)) > {NATURAL_32} 2_147_483_647 // {PLATFORM}.Natural_16_bytes.to_natural_32 then
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_r.c"), 166])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_KBD_STATIC}).fatal_tty_exit
							update_class_fields -- Current might have been changed; synchronize
							exit (4)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_tmp := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 167, create {CE_VOID_POINTER}.make_cast ((data.item.data + l_y).item.d), ((((l_x + 1) + 127)).bit_and (-128)).to_natural_32 * {PLATFORM}.Natural_16_bytes.to_natural_32)
					update_class_fields; -- Current might have been changed; synchronize
					(data.item.data + l_y).item.d := create {CE_NATURAL_16_POINTER}.make_cast (l_tmp)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_i := (data.item.data + l_y).item.l
				from
				until
					not (l_i <= l_x)
				loop
					(data.item.data + l_y).item.d[l_i] := ((((((data.item.data + l_y).item.c).to_integer_32).bit_shift_left (11))).bit_or (32)).to_natural_16
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				(data.item.data + l_y).item.c := bgcolor.to_natural_16
				update_class_fields; -- Current might have been changed; synchronize
				(data.item.data + l_y).item.l := l_i
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	r_xpand_spaces (a_l: INTEGER_32)
		local
			l_c: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [ANY]
		do
			if a_l.to_natural_32 >= {NATURAL_32} 2_147_483_647 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_r.c"), 179])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_KBD_STATIC}).fatal_tty_exit
					update_class_fields -- Current might have been changed; synchronize
					exit (4)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 180, create {CE_VOID_POINTER}.make_cast (spaces), (a_l + 1).to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_c := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)
			memset (create {CE_VOID_POINTER}.make_cast ((l_c + spl)), 0, ((a_l - spl) + 1).to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Current.spl := a_l + 1
			update_class_fields -- Current might have been changed; synchronize
			Current.spaces := l_c
			update_class_fields -- Current might have been changed; synchronize
		end

	xpand_spaces (a_l: INTEGER_32)
		do
			if a_l.to_natural_32 >= spl.to_natural_32 then
				((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.r_xpand_spaces (a_l)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	set_hchars (a_x, a_y, a_xl: INTEGER_32; a_c: NATURAL_32)
		local
			l_x: INTEGER_32
			l_xl: INTEGER_32
		do
			l_x := a_x
			l_xl := a_xl;
			((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.xpand_lines (a_y)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.xpand_line (a_y, (l_x + l_xl) - 1)
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				not (l_xl.to_boolean)
			loop
				(data.item.data + (yp + a_y)).item.d[(xp + l_x)] := a_c.to_natural_16
				update_class_fields -- Current might have been changed; synchronize
				l_xl := l_xl - 1
				l_x := l_x + 1
			end
		end

	set_hline (a_x, a_y, a_xl: INTEGER_32; a_d: CE_POINTER [NATURAL_8]; a_c: NATURAL_32; a_spc: INTEGER_32)
		local
			l_x: INTEGER_32
			l_xl: INTEGER_32
			l_d: CE_POINTER [NATURAL_8]
		do
			l_x := a_x
			l_xl := a_xl
			l_d := a_d;
			((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.xpand_lines (a_y)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.xpand_line (a_y, (l_x + l_xl) - 1)
			update_class_fields -- Current might have been changed; synchronize
			if a_spc.to_boolean then
				((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.xpand_spaces ((l_x + l_xl) - 1)
				update_class_fields -- Current might have been changed; synchronize
			end
			from
			until
				not (l_xl.to_boolean)
			loop
				if a_spc.to_boolean then
					spaces[l_x] := ((l_d.item).to_integer_32 = 32).to_integer.to_natural_8
					update_class_fields -- Current might have been changed; synchronize
				end
				if (not data.is_void) then
					(data.item.data + (yp + a_y)).item.d[(xp + l_x)] := (((l_d.item).to_natural_32).bit_or (a_c)).to_natural_16
					update_class_fields -- Current might have been changed; synchronize
				end
				l_xl := l_xl - 1
				l_x := l_x + 1
				l_d := l_d + 1
			end
		end

	move_links (a_xf, a_yf, a_xt___1, a_yt: INTEGER_32)
		local
			l_n: INTEGER_32
			l_t: CE_POINTER [PD_TAG]
			l_w: INTEGER_32
			l_i: INTEGER_32
			l_link___0: CE_POINTER [PD_LINK]
			l_return: BOOLEAN
		do
			l_w := 0
			if data.is_void then
				l_return := True
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.xpand_lines (a_yt)
				update_class_fields -- Current might have been changed; synchronize
				l_n := (create {P_LINKS_STATIC}).last_link_to_move.item
				from
				until
					not (not (l_return) and then (l_n < data.item.nlinks))
				loop
					l_link___0 := data.item.links + l_n
					l_i := 0
					from
					until
						not (l_i < l_link___0.item.n)
					loop
						if (l_link___0.item.pos + l_i).item.y >= yp + a_yf then
							l_w := 1
							if (l_link___0.item.pos + l_i).item.y = yp + a_yf then
								if (l_link___0.item.pos + l_i).item.x >= xp + a_xf then
									if a_yt >= 0 then
										(l_link___0.item.pos + l_i).item.y := yp + a_yt
										update_class_fields; -- Current might have been changed; synchronize
										(l_link___0.item.pos + l_i).item.x := (l_link___0.item.pos + l_i).item.x + (-a_xf + a_xt___1)
										update_class_fields -- Current might have been changed; synchronize
									else
										memmove (create {CE_VOID_POINTER}.make_cast ((l_link___0.item.pos + l_i)), create {CE_VOID_POINTER}.make_cast ((l_link___0.item.pos + (l_i + 1))), ((l_link___0.item.n - l_i) - 1).to_natural_32 * (create {PD_POINT}.make).structure_size.to_natural_32).do_nothing
										update_class_fields -- Current might have been changed; synchronize
										l_link___0.item.n := (l_link___0.item.n) - 1
										update_class_fields -- Current might have been changed; synchronize
										l_i := l_i - 1
									end
								end
							end
						end
						l_i := l_i + 1
					end
					if not l_w.to_boolean then
						(create {P_LINKS_STATIC}).last_link_to_move.item := l_n
						update_class_fields -- Current might have been changed; synchronize
					end
					l_n := l_n + 1
				end
				l_w := 0
				if a_yt >= 0 then
					l_t := (create {P_HTML_R_STATIC}).last_tag_to_move.item.item.next
					from
					until
						l_t.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (data.c_pointer + (create {PD_F_DATA}.make).offset_of ("tags")))
					loop
						if l_t.item.y = yp + a_yf then
							l_w := 1
							if l_t.item.x >= xp + a_xf then
								l_t.item.y := yp + a_yt
								update_class_fields -- Current might have been changed; synchronize
								l_t.item.x := l_t.item.x + (-a_xf + a_xt___1)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if not l_w.to_boolean then
							(create {P_HTML_R_STATIC}).last_tag_to_move.item := l_t
							update_class_fields -- Current might have been changed; synchronize
						end
						l_t := l_t.item.next
					end
				end
			end
		end

	move_chars (a_x, a_y, a_nx, a_ny: INTEGER_32)
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			if (data.item.data + (yp + a_y)).item.l - xp < 0 then
				l_tmp := 0
			else
				l_tmp := (data.item.data + (yp + a_y)).item.l - xp
			end
			if l_tmp - a_x <= 0 then
				l_return := True
			end
			if not l_return then
				if (data.item.data + (yp + a_y)).item.l - xp < 0 then
					l_tmp___0 := 0
				else
					l_tmp___0 := (data.item.data + (yp + a_y)).item.l - xp
				end
				copy_chars ((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer)), a_nx, a_ny, l_tmp___0 - a_x, (data.item.data + (yp + a_y)).item.d + (xp + a_x))
				update_class_fields; -- Current might have been changed; synchronize
				(data.item.data + (yp + a_y)).item.l := xp + a_x
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.move_links (a_x, a_y, a_nx, a_ny)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	shift_chars (a_y, a_s: INTEGER_32)
		local
			l_a: CE_POINTER [NATURAL_16]
			l_l: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [ANY]
		do
			if (data.item.data + (yp + a_y)).item.l - xp < 0 then
				l_tmp := 0
			else
				l_tmp := (data.item.data + (yp + a_y)).item.l - xp
			end
			l_l := l_tmp
			if l_l.to_natural_32 > {NATURAL_32} 2_147_483_647 // {PLATFORM}.Natural_16_bytes.to_natural_32 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_r.c"), 308])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_KBD_STATIC}).fatal_tty_exit
					update_class_fields -- Current might have been changed; synchronize
					exit (4)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 309, l_l.to_natural_32 * {PLATFORM}.Natural_16_bytes.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_a := create {CE_NATURAL_16_POINTER}.make_cast (l_tmp___0)
			memcpy (create {CE_VOID_POINTER}.make_cast (l_a), create {CE_VOID_POINTER}.make_cast (((data.item.data + (yp + a_y)).item.d + xp)), l_l.to_natural_32 * {PLATFORM}.Natural_16_bytes.to_natural_32).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.set_hchars (0, a_y, a_s, ((((((data.item.data + a_y).item.c).to_integer_32).bit_shift_left (11))).bit_or (32)).to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			copy_chars ((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer)), a_s, a_y, l_l, l_a)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 313, create {CE_VOID_POINTER}.make_cast (l_a))
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.move_links (0, a_y, a_s, a_y)
			update_class_fields -- Current might have been changed; synchronize
		end

	del_chars (a_x, a_y: INTEGER_32)
		do
			(data.item.data + (yp + a_y)).item.l := xp + a_x
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.move_links (a_x, a_y, -1, -1)
			update_class_fields -- Current might have been changed; synchronize
		end

	split_line: INTEGER_32
		local
			l_i: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width - (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin > 0 then
						l_i := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width - (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin
					else
						l_i := 0
					end
				when 1 then -- loop condition:
					if not (l_i >= (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin) then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if l_i < spl then
							if (spaces[l_i]).to_boolean then
								l_pos := -1 + 9 -- goto split
							end
						end
				when 3 then
						l_i := l_i - 1
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					l_i := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin
				when 5 then -- loop condition:
					if not (l_i < cx) then
						l_pos := -1 + 8 -- skip loop
					end
				when 6 then -- loop body:
						if l_i < spl then
							if (spaces[l_i]).to_boolean then
								l_pos := -1 + 9 -- goto split
							end
						end
				when 7 then
						l_i := l_i + 1
						l_pos := -1 + 5 -- back to loop condition
				when 8 then -- loop done
					if cx + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin > x then
						Current.x := cx + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin
						update_class_fields -- Current might have been changed; synchronize
					end
					Result := 0
					l_return := True
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 9 then -- if: | split:
						if l_i + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin > x then
							Current.x := l_i + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not data.is_void) then
							if ((((data.item.data + (yp + cy)).item.d[(xp + l_i)]).to_integer_32).bit_and (255)) /= 32 then
								from
								until
									False
								loop
									(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c"))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_LINKS_STATIC}).errline.item := 352
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bad split: %%c")), (((data.item.data + (yp + cy)).item.d[(xp + l_i)]).to_integer_8).to_integer_32])
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.move_chars (l_i + 1, cy, (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin, cy + 1)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.del_chars (l_i, cy)
							update_class_fields -- Current might have been changed; synchronize
						end
						memmove (create {CE_VOID_POINTER}.make_cast (spaces), create {CE_VOID_POINTER}.make_cast (((spaces + l_i) + 1)), ((spl - l_i) - 1).to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						memset (create {CE_VOID_POINTER}.make_cast ((((spaces + spl) - l_i) - 1)), 0, (l_i + 1).to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						memmove (create {CE_VOID_POINTER}.make_cast ((spaces + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin)), create {CE_VOID_POINTER}.make_cast (spaces), (spl - (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin).to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Current.cy := cy + 1
						update_class_fields -- Current might have been changed; synchronize
						Current.cx := cx - ((l_i - (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin) + 1)
						update_class_fields -- Current might have been changed; synchronize
						if cx = (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin then
							Current.cx := -1
							update_class_fields -- Current might have been changed; synchronize
						end
						if y < cy + (cx /= -1).to_integer then
							Current.y := cy + (cx /= -1).to_integer
							update_class_fields -- Current might have been changed; synchronize
						end
						Result := (1 + (cx = -1).to_integer)
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	align_line (a_y: INTEGER_32)
		local
			l_na: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			if data.is_void then
				l_return := True
			end
			if not l_return then
				if (data.item.data + (yp + a_y)).item.l - xp < 0 then
					l_tmp := 0
				else
					l_tmp := (data.item.data + (yp + a_y)).item.l - xp
				end
				if l_tmp.to_boolean then
					if (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.align = 0 then
						l_return := True
					elseif (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.align = 4 then
						l_return := True
					elseif (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.align = 3 then
						l_return := True
					end
				else
					l_return := True
				end
			end
			if not l_return then
				if (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width - (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin > 0 then
					l_tmp___0 := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width - (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin
				else
					l_tmp___0 := 0
				end
				if (data.item.data + (yp + a_y)).item.l - xp < 0 then
					l_tmp___1 := 0
				else
					l_tmp___1 := (data.item.data + (yp + a_y)).item.l - xp
				end
				l_na := l_tmp___0 - l_tmp___1
				if (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.align = 1 then
					l_na := l_na // (2)
				end
				if l_na > 0 then
					((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.shift_chars (a_y, l_na)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	line_break
		local
			l_t: CE_POINTER [PD_TAG]
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if cx + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin > x then
						Current.x := cx + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin
						update_class_fields -- Current might have been changed; synchronize
					end
					if ((create {P_HTML_R_STATIC}).nobreak.item).to_boolean then
						(create {P_HTML_R_STATIC}).nobreak.item := 0
						update_class_fields -- Current might have been changed; synchronize
						Current.cx := -1
						update_class_fields -- Current might have been changed; synchronize
						Current.xa := 0
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if data.is_void then
							l_pos := -1 + 3 -- goto e
						end
				when 2 then;
						((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.xpand_lines (cy + 1)
						update_class_fields -- Current might have been changed; synchronize
						if cx > (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin then
							if (data.item.data + (yp + cy)).item.l - xp < 0 then
								l_tmp := 0
							else
								l_tmp := (data.item.data + (yp + cy)).item.l - xp
							end
							if l_tmp > cx - 1 then
								if ((((data.item.data + (yp + cy)).item.d[(xp + (cx - 1))]).to_integer_32).bit_and (255)) = 32 then
									((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.del_chars (cx - 1, cy)
									update_class_fields -- Current might have been changed; synchronize
									Current.cx := cx - 1
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if cx > 0 then
							((create {CE_CLASS_POINTER [PD_PART]}.make_shared (c_pointer))).item.align_line (cy)
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not data.is_void) then
							l_t := (create {P_HTML_R_STATIC}).last_tag_for_newline.item
							from
							until
								(l_break)
							loop
								l_break := False
								if (not l_t.is_void) then
									if l_t.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (data.c_pointer + (create {PD_F_DATA}.make).offset_of ("tags"))) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_t.item.x := xp
									update_class_fields -- Current might have been changed; synchronize
									l_t.item.y := yp + (cy + 1)
									update_class_fields -- Current might have been changed; synchronize
									l_t := l_t.item.prev
								end
							end
							l_break := False
						end
				when 3 then -- e:
						Current.cy := cy + 1
						update_class_fields -- Current might have been changed; synchronize
						Current.cx := -1
						update_class_fields -- Current might have been changed; synchronize
						Current.xa := 0
						update_class_fields -- Current might have been changed; synchronize
						memset (create {CE_VOID_POINTER}.make_cast (spaces), 0, spl.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	html_form_control (a_fc: CE_POINTER [PD_FORM_CONTROL])
		local
			l_tmp: INTEGER_32
			l_dv: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___2: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if data.is_void then
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_PART}.make).offset_of ("uf")))))
							update_class_fields -- Current might have been changed; synchronize
							a_fc.item.next := (create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_PART}.make).offset_of ("uf"))))).item.next
							update_class_fields -- Current might have been changed; synchronize
							a_fc.item.prev := create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_PART}.make).offset_of ("uf"))))
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_PART}.make).offset_of ("uf"))))).item.next := a_fc
							update_class_fields; -- Current might have been changed; synchronize
							(a_fc.item.next).item.prev := a_fc
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_PART}.make).offset_of ("uf")))))
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_return := True
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_tmp := (create {P_HTML_R_STATIC}).g_ctrl_num.item;
						(create {P_HTML_R_STATIC}).g_ctrl_num.item := (create {P_HTML_R_STATIC}).g_ctrl_num.item + 1
						update_class_fields -- Current might have been changed; synchronize
						a_fc.item.g_ctrl_num := l_tmp
						update_class_fields -- Current might have been changed; synchronize
						if a_fc.item.type /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 4 then -- else:
						if a_fc.item.type /= 2 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if a_fc.item.type /= 4 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_fc.item.default_value))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := (create {P_CHARSETS_STATIC}).convert_string ((create {P_HTML_R_STATIC}).convert_table.item, a_fc.item.default_value, l_tmp___0.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						l_dv := l_tmp___1
						if (not l_dv.is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 655, create {CE_VOID_POINTER}.make_cast (a_fc.item.default_value))
							update_class_fields -- Current might have been changed; synchronize
							a_fc.item.default_value := l_dv
							update_class_fields -- Current might have been changed; synchronize
						end
				when 9 then -- if done | if done
						if a_fc.item.type = 4 then
							l_p___0 := a_fc.item.default_value
							from
							until
								not ((l_p___0[0]).to_boolean)
							loop
								if (l_p___0[0]).to_integer_32 = 13 then
									if (l_p___0[1]).to_integer_32 = 10 then
										l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))
										update_class_fields -- Current might have been changed; synchronize
										memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + 1)), l_tmp___2).do_nothing
										update_class_fields -- Current might have been changed; synchronize
										l_p___0 := l_p___0 - 1
									else
										l_p___0[0] := (('%N').code).to_natural_8
										update_class_fields -- Current might have been changed; synchronize
									end
								end
								l_p___0 := l_p___0 + 1
							end
						end
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (data.c_pointer + (create {PD_F_DATA}.make).offset_of ("forms")))))
							update_class_fields -- Current might have been changed; synchronize
							a_fc.item.next := (create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (data.c_pointer + (create {PD_F_DATA}.make).offset_of ("forms"))))).item.next
							update_class_fields -- Current might have been changed; synchronize
							a_fc.item.prev := create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (data.c_pointer + (create {PD_F_DATA}.make).offset_of ("forms"))))
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (data.c_pointer + (create {PD_F_DATA}.make).offset_of ("forms"))))).item.next := a_fc
							update_class_fields; -- Current might have been changed; synchronize
							(a_fc.item.next).item.prev := a_fc
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (data.c_pointer + (create {PD_F_DATA}.make).offset_of ("forms")))))
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {PD_PART} -- private routines

	copy_chars (a_p: CE_POINTER [PD_PART]; a_x, a_y, a_xl: INTEGER_32; a_d: CE_POINTER [NATURAL_16])
		local
			l_x: INTEGER_32
			l_xl: INTEGER_32
			l_d: CE_POINTER [NATURAL_16]
			l_return: BOOLEAN
		do
			l_x := a_x
			l_xl := a_xl
			l_d := a_d
			if l_xl <= 0 then
				l_return := True
			end
			if not l_return then
				a_p.item.xpand_lines (a_y)
				a_p.item.xpand_line (a_y, (l_x + l_xl) - 1)
				from
				until
					not (l_xl.to_boolean)
				loop
					((a_p.item.data).item.data + (a_p.item.yp + a_y)).item.d[(a_p.item.xp + l_x)] := l_d.item
					l_xl := l_xl - 1
					l_x := l_x + 1
					l_d := l_d + 1
				end
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x := a_other.x
			y := a_other.y
			xp := a_other.xp
			yp := a_other.yp
			xmax := a_other.xmax
			xa := a_other.xa
			cx := a_other.cx
			cy := a_other.cy
			data := a_other.data
			bgcolor := a_other.bgcolor
			spaces := a_other.spaces
			spl := a_other.spl
			link_num := a_other.link_num
			uf := a_other.uf.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x = a_other.x and
				y = a_other.y and
				xp = a_other.xp and
				yp = a_other.yp and
				xmax = a_other.xmax and
				xa = a_other.xa and
				cx = a_other.cx and
				cy = a_other.cy and
				data.is_equal (a_other.data) and
				bgcolor = a_other.bgcolor and
				spaces.is_equal (a_other.spaces) and
				spl = a_other.spl and
				link_num = a_other.link_num and
				uf.is_equal (a_other.uf)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("xp"),
					create {CE_STRUCTURE_FIELD}.make ("yp"),
					create {CE_STRUCTURE_FIELD}.make ("xmax"),
					create {CE_STRUCTURE_FIELD}.make ("xa"),
					create {CE_STRUCTURE_FIELD}.make ("cx"),
					create {CE_STRUCTURE_FIELD}.make ("cy"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("bgcolor"),
					create {CE_STRUCTURE_FIELD}.make ("spaces"),
					create {CE_STRUCTURE_FIELD}.make ("spl"),
					create {CE_STRUCTURE_FIELD}.make ("link_num"),
					create {CE_STRUCTURE_FIELD}.make ("uf")
				>>)
			init_structure_info
		end

end
