class
	PD_PROTOCOLS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} prot.make
			create func.make
			create nc_func.make
		end

feature {ANY} -- fields

	prot: CE_POINTER [NATURAL_8] assign set_prot

	port: INTEGER_32 assign set_port

	func: CE_ROUTINE assign set_func

	nc_func: CE_ROUTINE assign set_nc_func

	free_syntax: INTEGER_32 assign set_free_syntax

	need_slashes: INTEGER_32 assign set_need_slashes

	need_slash_after_host: INTEGER_32 assign set_need_slash_after_host

	allow_post: INTEGER_32 assign set_allow_post

feature {ANY} -- field setters

	set_prot (a_prot: CE_POINTER [NATURAL_8])
		do
			prot := a_prot
			update_memory_field ("prot")
		end

	set_port (a_port: INTEGER_32)
		do
			port := a_port
			update_memory_field ("port")
		end

	set_func (a_func: CE_ROUTINE)
		do
			func := a_func
			update_memory_field ("func")
		end

	set_nc_func (a_nc_func: CE_ROUTINE)
		do
			nc_func := a_nc_func
			update_memory_field ("nc_func")
		end

	set_free_syntax (a_free_syntax: INTEGER_32)
		do
			free_syntax := a_free_syntax
			update_memory_field ("free_syntax")
		end

	set_need_slashes (a_need_slashes: INTEGER_32)
		do
			need_slashes := a_need_slashes
			update_memory_field ("need_slashes")
		end

	set_need_slash_after_host (a_need_slash_after_host: INTEGER_32)
		do
			need_slash_after_host := a_need_slash_after_host
			update_memory_field ("need_slash_after_host")
		end

	set_allow_post (a_allow_post: INTEGER_32)
		do
			allow_post := a_allow_post
			update_memory_field ("allow_post")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			prot := a_other.prot
			port := a_other.port
			func := a_other.func
			nc_func := a_other.nc_func
			free_syntax := a_other.free_syntax
			need_slashes := a_other.need_slashes
			need_slash_after_host := a_other.need_slash_after_host
			allow_post := a_other.allow_post
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				prot.is_equal (a_other.prot) and
				port = a_other.port and
				func.is_equal (a_other.func) and
				nc_func.is_equal (a_other.nc_func) and
				free_syntax = a_other.free_syntax and
				need_slashes = a_other.need_slashes and
				need_slash_after_host = a_other.need_slash_after_host and
				allow_post = a_other.allow_post
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("prot"),
					create {CE_STRUCTURE_FIELD}.make ("port"),
					create {CE_STRUCTURE_FIELD}.make ("func"),
					create {CE_STRUCTURE_FIELD}.make ("nc_func"),
					create {CE_STRUCTURE_FIELD}.make ("free_syntax"),
					create {CE_STRUCTURE_FIELD}.make ("need_slashes"),
					create {CE_STRUCTURE_FIELD}.make ("need_slash_after_host"),
					create {CE_STRUCTURE_FIELD}.make ("allow_post")
				>>)
			init_structure_info
		end

end
