class
	PD_TERM_SPEC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_TERM_SPEC]} next.make
			create {CE_CLASS_POINTER [PD_TERM_SPEC]} prev.make
			create {CE_NATURAL_8_ARRAY} term.make (<<32>>)
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_TERM_SPEC] assign set_next

	prev: CE_POINTER [PD_TERM_SPEC] assign set_prev

	term: CE_ARRAY [NATURAL_8]

	mode: INTEGER_32 assign set_mode

	m11_hack: INTEGER_32 assign set_m11_hack

	restrict_852: INTEGER_32 assign set_restrict_852

	block_cursor: INTEGER_32 assign set_block_cursor

	col: INTEGER_32 assign set_col

	charset: INTEGER_32 assign set_charset

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_TERM_SPEC])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_TERM_SPEC])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_mode (a_mode: INTEGER_32)
		do
			mode := a_mode
			update_memory_field ("mode")
		end

	set_m11_hack (a_m11_hack: INTEGER_32)
		do
			m11_hack := a_m11_hack
			update_memory_field ("m11_hack")
		end

	set_restrict_852 (a_restrict_852: INTEGER_32)
		do
			restrict_852 := a_restrict_852
			update_memory_field ("restrict_852")
		end

	set_block_cursor (a_block_cursor: INTEGER_32)
		do
			block_cursor := a_block_cursor
			update_memory_field ("block_cursor")
		end

	set_col (a_col: INTEGER_32)
		do
			col := a_col
			update_memory_field ("col")
		end

	set_charset (a_charset: INTEGER_32)
		do
			charset := a_charset
			update_memory_field ("charset")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			term := a_other.term.twin
			mode := a_other.mode
			m11_hack := a_other.m11_hack
			restrict_852 := a_other.restrict_852
			block_cursor := a_other.block_cursor
			col := a_other.col
			charset := a_other.charset
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				term.is_equal (a_other.term) and
				mode = a_other.mode and
				m11_hack = a_other.m11_hack and
				restrict_852 = a_other.restrict_852 and
				block_cursor = a_other.block_cursor and
				col = a_other.col and
				charset = a_other.charset
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("term", <<32>>),
					create {CE_STRUCTURE_FIELD}.make ("mode"),
					create {CE_STRUCTURE_FIELD}.make ("m11_hack"),
					create {CE_STRUCTURE_FIELD}.make ("restrict_852"),
					create {CE_STRUCTURE_FIELD}.make ("block_cursor"),
					create {CE_STRUCTURE_FIELD}.make ("col"),
					create {CE_STRUCTURE_FIELD}.make ("charset")
				>>)
			init_structure_info
		end

end
