class
	PD_THREAD

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create read_func.make
			create write_func.make
			create error_func.make
			create {CE_VOID_POINTER} data.make
		end

feature {ANY} -- fields

	read_func: CE_ROUTINE assign set_read_func

	write_func: CE_ROUTINE assign set_write_func

	error_func: CE_ROUTINE assign set_error_func

	data: CE_POINTER [ANY] assign set_data

feature {ANY} -- field setters

	set_read_func (a_read_func: CE_ROUTINE)
		do
			read_func := a_read_func
			update_memory_field ("read_func")
		end

	set_write_func (a_write_func: CE_ROUTINE)
		do
			write_func := a_write_func
			update_memory_field ("write_func")
		end

	set_error_func (a_error_func: CE_ROUTINE)
		do
			error_func := a_error_func
			update_memory_field ("error_func")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			read_func := a_other.read_func
			write_func := a_other.write_func
			error_func := a_other.error_func
			data := a_other.data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				read_func.is_equal (a_other.read_func) and
				write_func.is_equal (a_other.write_func) and
				error_func.is_equal (a_other.error_func) and
				data.is_equal (a_other.data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("read_func"),
					create {CE_STRUCTURE_FIELD}.make ("write_func"),
					create {CE_STRUCTURE_FIELD}.make ("error_func"),
					create {CE_STRUCTURE_FIELD}.make ("data")
				>>)
			init_structure_info
		end

end
