class
	PD_VIEW_STATE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} goto_position.make
			create {CE_NATURAL_8_POINTER} goto_position_end.make
			create {CE_CLASS_POINTER [PD_FORM_STATE]} form_info.make
			create {CE_NATURAL_8_ARRAY} url.make (<<1>>)
			Precursor
		end

feature {ANY} -- fields

	view_pos: INTEGER_32 assign set_view_pos

	view_posx: INTEGER_32 assign set_view_posx

	orig_view_pos: INTEGER_32 assign set_orig_view_pos

	orig_view_posx: INTEGER_32 assign set_orig_view_posx

	current_link: INTEGER_32 assign set_current_link

	orig_link: INTEGER_32 assign set_orig_link

	plain: INTEGER_32 assign set_plain

	goto_position: CE_POINTER [NATURAL_8] assign set_goto_position

	goto_position_end: CE_POINTER [NATURAL_8] assign set_goto_position_end

	form_info: CE_POINTER [PD_FORM_STATE] assign set_form_info

	form_info_len: INTEGER_32 assign set_form_info_len

	url: CE_ARRAY [NATURAL_8]

feature {ANY} -- field setters

	set_view_pos (a_view_pos: INTEGER_32)
		do
			view_pos := a_view_pos
			update_memory_field ("view_pos")
		end

	set_view_posx (a_view_posx: INTEGER_32)
		do
			view_posx := a_view_posx
			update_memory_field ("view_posx")
		end

	set_orig_view_pos (a_orig_view_pos: INTEGER_32)
		do
			orig_view_pos := a_orig_view_pos
			update_memory_field ("orig_view_pos")
		end

	set_orig_view_posx (a_orig_view_posx: INTEGER_32)
		do
			orig_view_posx := a_orig_view_posx
			update_memory_field ("orig_view_posx")
		end

	set_current_link (a_current_link: INTEGER_32)
		do
			current_link := a_current_link
			update_memory_field ("current_link")
		end

	set_orig_link (a_orig_link: INTEGER_32)
		do
			orig_link := a_orig_link
			update_memory_field ("orig_link")
		end

	set_plain (a_plain: INTEGER_32)
		do
			plain := a_plain
			update_memory_field ("plain")
		end

	set_goto_position (a_goto_position: CE_POINTER [NATURAL_8])
		do
			goto_position := a_goto_position
			update_memory_field ("goto_position")
		end

	set_goto_position_end (a_goto_position_end: CE_POINTER [NATURAL_8])
		do
			goto_position_end := a_goto_position_end
			update_memory_field ("goto_position_end")
		end

	set_form_info (a_form_info: CE_POINTER [PD_FORM_STATE])
		do
			form_info := a_form_info
			update_memory_field ("form_info")
		end

	set_form_info_len (a_form_info_len: INTEGER_32)
		do
			form_info_len := a_form_info_len
			update_memory_field ("form_info_len")
		end

feature {ANY} -- public routines

	init_vs (a_url: CE_POINTER [NATURAL_8])
		do
			memset (create {CE_VOID_POINTER}.make_shared (c_pointer), 0, (create {PD_VIEW_STATE}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Current.current_link := -1
			update_class_fields -- Current might have been changed; synchronize
			Current.orig_link := -1
			update_class_fields -- Current might have been changed; synchronize
			Current.plain := -1
			update_class_fields -- Current might have been changed; synchronize
			Current.form_info := create {CE_CLASS_POINTER [PD_FORM_STATE]}.make_shared (default_pointer + -1)
			update_class_fields -- Current might have been changed; synchronize
			Current.form_info_len := 0
			update_class_fields -- Current might have been changed; synchronize
			strcpy (create {CE_INTEGER_8_POINTER}.make_cast (url), create {CE_INTEGER_8_POINTER}.make_cast (a_url)).do_nothing
			update_class_fields -- Current might have been changed; synchronize
		end

	destroy_vs
		local
			l_i: INTEGER_32
		do
			if (not goto_position.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 17, create {CE_VOID_POINTER}.make_cast (goto_position))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not goto_position_end.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 18, create {CE_VOID_POINTER}.make_cast (goto_position_end))
				update_class_fields -- Current might have been changed; synchronize
			end
			l_i := 0
			from
			until
				not (l_i < form_info_len)
			loop
				if (not ((form_info + l_i).item.value).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 19, create {CE_VOID_POINTER}.make_cast ((form_info + l_i).item.value))
					update_class_fields -- Current might have been changed; synchronize
				end
				l_i := l_i + 1
			end
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 20, create {CE_VOID_POINTER}.make_cast (form_info))
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			view_pos := a_other.view_pos
			view_posx := a_other.view_posx
			orig_view_pos := a_other.orig_view_pos
			orig_view_posx := a_other.orig_view_posx
			current_link := a_other.current_link
			orig_link := a_other.orig_link
			plain := a_other.plain
			goto_position := a_other.goto_position
			goto_position_end := a_other.goto_position_end
			form_info := a_other.form_info
			form_info_len := a_other.form_info_len
			url := a_other.url.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				view_pos = a_other.view_pos and
				view_posx = a_other.view_posx and
				orig_view_pos = a_other.orig_view_pos and
				orig_view_posx = a_other.orig_view_posx and
				current_link = a_other.current_link and
				orig_link = a_other.orig_link and
				plain = a_other.plain and
				goto_position.is_equal (a_other.goto_position) and
				goto_position_end.is_equal (a_other.goto_position_end) and
				form_info.is_equal (a_other.form_info) and
				form_info_len = a_other.form_info_len and
				url.is_equal (a_other.url)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("view_pos"),
					create {CE_STRUCTURE_FIELD}.make ("view_posx"),
					create {CE_STRUCTURE_FIELD}.make ("orig_view_pos"),
					create {CE_STRUCTURE_FIELD}.make ("orig_view_posx"),
					create {CE_STRUCTURE_FIELD}.make ("current_link"),
					create {CE_STRUCTURE_FIELD}.make ("orig_link"),
					create {CE_STRUCTURE_FIELD}.make ("plain"),
					create {CE_STRUCTURE_FIELD}.make ("goto_position"),
					create {CE_STRUCTURE_FIELD}.make ("goto_position_end"),
					create {CE_STRUCTURE_FIELD}.make ("form_info"),
					create {CE_STRUCTURE_FIELD}.make ("form_info_len"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("url", <<1>>)
				>>)
			init_structure_info
		end

end
