class
	PD_XLIST_HEAD

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_XLIST_HEAD]} next.make
			create {CE_CLASS_POINTER [PD_XLIST_HEAD]} prev.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_XLIST_HEAD] assign set_next

	prev: CE_POINTER [PD_XLIST_HEAD] assign set_prev

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_XLIST_HEAD])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_XLIST_HEAD])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev")
				>>)
			init_structure_info
		end

end
