class
	S_SYS_SOCKET_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	socket (a___domain: INTEGER_32; a___type: INTEGER_32; a___protocol: INTEGER_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return socket($a___domain, $a___type, $a___protocol);"
		end

	bind (a___fd: INTEGER_32; a___addr: CE_POINTER [SD_SOCKADDR]; a___len: NATURAL_32): INTEGER_32
		do
			Result := c_bind (a___fd, a___addr.c_pointer, a___len)
		end

	c_bind (a___fd: INTEGER_32; a___addr: POINTER; a___len: NATURAL_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return bind($a___fd, $a___addr, $a___len);"
		end

	connect (a___fd: INTEGER_32; a___addr: CE_POINTER [SD_SOCKADDR]; a___len: NATURAL_32): INTEGER_32
		do
			Result := c_connect (a___fd, a___addr.c_pointer, a___len)
		end

	c_connect (a___fd: INTEGER_32; a___addr: POINTER; a___len: NATURAL_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return connect($a___fd, $a___addr, $a___len);"
		end

	setsockopt (a___fd, a___level, a___optname: INTEGER_32; a___optval: CE_POINTER [ANY]; a___optlen: NATURAL_32): INTEGER_32
		do
			Result := c_setsockopt (a___fd, a___level, a___optname, a___optval.c_pointer, a___optlen)
		end

	c_setsockopt (a___fd: INTEGER_32; a___level: INTEGER_32; a___optname: INTEGER_32; a___optval: POINTER; a___optlen: NATURAL_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return setsockopt($a___fd, $a___level, $a___optname, $a___optval, $a___optlen);"
		end

	listen (a___fd: INTEGER_32; a___n: INTEGER_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return listen($a___fd, $a___n);"
		end

	accept (a___fd: INTEGER_32; a___addr: CE_POINTER [SD_SOCKADDR]; a___addr_len: CE_POINTER [NATURAL_32]): INTEGER_32
		do
			Result := c_accept (a___fd, a___addr.c_pointer, a___addr_len.c_pointer)
		end

	c_accept (a___fd: INTEGER_32; a___addr: POINTER; a___addr_len: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return accept($a___fd, $a___addr, $a___addr_len);"
		end

	getsockname (a___fd: INTEGER_32; a___addr: CE_POINTER [SD_SOCKADDR]; a___len: CE_POINTER [NATURAL_32]): INTEGER_32
		do
			Result := c_getsockname (a___fd, a___addr.c_pointer, a___len.c_pointer)
		end

	c_getsockname (a___fd: INTEGER_32; a___addr: POINTER; a___len: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return getsockname($a___fd, $a___addr, $a___len);"
		end

	getsockopt (a___fd, a___level, a___optname: INTEGER_32; a___optval: CE_POINTER [ANY]; a___optlen: CE_POINTER [NATURAL_32]): INTEGER_32
		do
			Result := c_getsockopt (a___fd, a___level, a___optname, a___optval.c_pointer, a___optlen.c_pointer)
		end

	c_getsockopt (a___fd: INTEGER_32; a___level: INTEGER_32; a___optname: INTEGER_32; a___optval: POINTER; a___optlen: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return getsockopt($a___fd, $a___level, $a___optname, $a___optval, $a___optlen);"
		end

	getpeername (a___fd: INTEGER_32; a___addr: CE_POINTER [SD_SOCKADDR]; a___len: CE_POINTER [NATURAL_32]): INTEGER_32
		do
			Result := c_getpeername (a___fd, a___addr.c_pointer, a___len.c_pointer)
		end

	c_getpeername (a___fd: INTEGER_32; a___addr: POINTER; a___len: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return getpeername($a___fd, $a___addr, $a___len);"
		end

end
