class
	SD_UTSNAME

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_ARRAY} sysname.make (<<65>>)
			create {CE_INTEGER_8_ARRAY} nodename.make (<<65>>)
			create {CE_INTEGER_8_ARRAY} release.make (<<65>>)
			create {CE_INTEGER_8_ARRAY} version.make (<<65>>)
			create {CE_INTEGER_8_ARRAY} machine.make (<<65>>)
			create {CE_INTEGER_8_ARRAY} domainname.make (<<65>>)
		end

feature {ANY} -- fields

	sysname: CE_ARRAY [INTEGER_8]

	nodename: CE_ARRAY [INTEGER_8]

	release: CE_ARRAY [INTEGER_8]

	version: CE_ARRAY [INTEGER_8]

	machine: CE_ARRAY [INTEGER_8]

	domainname: CE_ARRAY [INTEGER_8]

feature {ANY}

	copy (a_other: like Current)
		do
			sysname := a_other.sysname.twin
			nodename := a_other.nodename.twin
			release := a_other.release.twin
			version := a_other.version.twin
			machine := a_other.machine.twin
			domainname := a_other.domainname.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sysname.is_equal (a_other.sysname) and
				nodename.is_equal (a_other.nodename) and
				release.is_equal (a_other.release) and
				version.is_equal (a_other.version) and
				machine.is_equal (a_other.machine) and
				domainname.is_equal (a_other.domainname)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sysname", <<65>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("nodename", <<65>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("release", <<65>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("version", <<65>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("machine", <<65>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("domainname", <<65>>)
				>>)
			init_structure_info
		end

end
