class
	P_OPS_STATIC

inherit
	CE_UTILITIES
	S_CTYPE_STATIC
	S_LIBINTL_STATIC
	S_STRING_STATIC
	S_STDIO_STATIC
	S_LIBIO_STATIC
	S_X11_XLIB_STATIC

feature {ANY} -- public attributes

	y_regs: CE_STATIC [CE_ARRAY [PD_YANKREG]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_YANKREG]}.make (<<40>>)
		end

	y_current: CE_STATIC [CE_POINTER [PD_YANKREG]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_YANKREG]}.make
		end

	y_append: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	y_previous: CE_STATIC [CE_POINTER [PD_YANKREG]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_YANKREG]}.make_shared (default_pointer)
		end

	expr_line: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	nested: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	execreg_lastc: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := ('%/0/').code
		end

feature {ANY} -- public routines

	shift_line (a_left, a_round, a_amount, a_call_changed_bytes: INTEGER_32)
		local
			l_amount: INTEGER_32
			l_count___2: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_p_sw___0: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_amount := a_amount
			l_p_sw___0 := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
			l_count___2 := (create {P_MISC1_STATIC}).get_indent
			if a_round.to_boolean then
				l_i___0 := l_count___2 // l_p_sw___0
				l_j := l_count___2 \\ l_p_sw___0
				if l_j.to_boolean then
					if a_left.to_boolean then
						l_amount := l_amount - 1
					end
				end
				if a_left.to_boolean then
					l_i___0 := l_i___0 - l_amount
					if l_i___0 < 0 then
						l_i___0 := 0
					end
				else
					l_i___0 := l_i___0 + l_amount
				end
				l_count___2 := l_i___0 * l_p_sw___0
			elseif a_left.to_boolean then
				l_count___2 := l_count___2 - (l_p_sw___0 * l_amount)
				if l_count___2 < 0 then
					l_count___2 := 0
				end
			else
				l_count___2 := l_count___2 + (l_p_sw___0 * l_amount)
			end
			if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
				(create {P_EDIT_STATIC}).change_indent (1, l_count___2, 0, ('%/0/').code, a_call_changed_bytes)
			else
				if a_call_changed_bytes.to_boolean then
					l_tmp := 1
				else
					l_tmp := 0
				end
				(create {P_MISC1_STATIC}).set_indent (l_count___2, l_tmp).do_nothing
			end
		end

	get_expr_register: INTEGER_32
		local
			l_new_line: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_new_line := (create {P_EX_GETLN_STATIC}).getcmdline (('=').code, 0, 0)
			if l_new_line.is_void then
				Result := (('%/0/').code)
				l_return := True
			end
			if not l_return then
				if (l_new_line.item).to_integer_32 = 0 then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_new_line))
				else
					set_expr_line (l_new_line)
				end
				Result := (('=').code)
			end
		end

	set_expr_line (a_new_line: CE_POINTER [NATURAL_8])
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (expr_line.item))
			expr_line.item := a_new_line
		end

	get_expr_line: CE_POINTER [NATURAL_8]
		local
			l_expr_copy: CE_POINTER [NATURAL_8]
			l_rv: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			if expr_line.item.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_expr_copy := (create {P_MISC2_STATIC}).vim_strsave (expr_line.item)
				if l_expr_copy.is_void then
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return and then (nested.item >= 10) then
				Result := l_expr_copy
				l_return := True
			end
			if not l_return then
				nested.item := nested.item + 1
				l_rv := (create {P_EVAL_STATIC}).eval_to_string (l_expr_copy, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), 1)
				nested.item := nested.item - 1;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_expr_copy))
				Result := l_rv
			end
		end

	get_expr_line_src: CE_POINTER [NATURAL_8]
		local
			l_return: BOOLEAN
		do
			if expr_line.item.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := ((create {P_MISC2_STATIC}).vim_strsave (expr_line.item))
			end
		end

	valid_yank_reg (a_regname___0, a_writing: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_regname___0 > 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_regname___0 < 127 then
							if ((((ctype_b_loc).item[a_regname___0]).to_integer_32).bit_and (8)).to_boolean then
								Result := 1
								l_return := True
							else
								l_pos := -1 + 3 -- goto _L___0
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else: | _L___0:
						if a_writing.to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/.%%#:=")), a_regname___0)).is_void then
							Result := 1
							l_return := True
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if a_regname___0 = 34 then
							Result := 1
							l_return := True
						elseif a_regname___0 = 45 then
							Result := 1
							l_return := True
						elseif a_regname___0 = 95 then
							Result := 1
							l_return := True
						elseif a_regname___0 = 42 then
							Result := 1
							l_return := True
						elseif a_regname___0 = 43 then
							Result := 1
							l_return := True
						elseif not a_writing.to_boolean then
							if a_regname___0 = 126 then
								Result := 1
								l_return := True
							end
						end
				when 7 then -- if done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_yank_register (a_regname___0, a_writing: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					y_append.item := 0
					if a_regname___0 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if a_regname___0 /= 34 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if not a_writing.to_boolean then
							if not y_previous.item.is_void then
								y_current.item := y_previous.item
								l_return := True
							end
						end
				when 5 then -- if done
					if l_return then
						l_pos := -1 + 26 -- skip if block
					end
				when 6 then -- if:
						l_i___0 := a_regname___0
						if not (l_i___0 >= 48) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_i___0 <= 57 then
							l_i___0 := l_i___0 - (48)
						else
							l_pos := -1 + 9 -- goto _L___4
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 9 then -- else: | _L___4:
						if not (l_i___0 < 127) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if ((((ctype_b_loc).item[l_i___0]).to_integer_32).bit_and (512)).to_boolean then
							l_i___0 := (l_i___0 - 97) + 10
						else
							l_pos := -1 + 12 -- goto _L___3
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 12 then -- else: | _L___3:
						if not (l_i___0 < 127) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if ((((ctype_b_loc).item[l_i___0]).to_integer_32).bit_and (256)).to_boolean then
							l_i___0 := (l_i___0 - 65) + 10
							y_append.item := 1
						else
							l_pos := -1 + 15 -- goto _L___2
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else: | _L___2:
						if a_regname___0 /= 45 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_i___0 := 36
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 18 then -- else:
						if not (((create {P_GLOBALS_STATIC}).clip_star.item.item.available).to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if a_regname___0 = 42 then
							l_i___0 := 37
						else
							l_pos := -1 + 21 -- goto _L___1
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else: | _L___1:
						if not (((create {P_GLOBALS_STATIC}).clip_plus.item.item.available).to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if a_regname___0 = 43 then
							l_i___0 := 38
						else
							l_pos := -1 + 24 -- goto _L___0
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L___0:
						if not a_writing.to_boolean then
							if a_regname___0 = 126 then
								l_i___0 := 39
							else
								l_i___0 := 0
							end
						else
							l_i___0 := 0
						end
				when 25 then -- if done | if done | if done | if done | if done
						y_current.item := y_regs.item + l_i___0
						if a_writing.to_boolean then
							y_previous.item := y_current.item
						end
				when 26 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	may_get_selection (a_regname___0: INTEGER_32): INTEGER_32
		local
			l_regname___0: INTEGER_32
		do
			l_regname___0 := a_regname___0
			if l_regname___0 = 42 then
				if not ((create {P_GLOBALS_STATIC}).clip_star.item.item.available).to_boolean then
					l_regname___0 := 0
				else
					((create {P_GLOBALS_STATIC}).clip_star.item).item.clip_get_selection
				end
			elseif l_regname___0 = 43 then
				if not ((create {P_GLOBALS_STATIC}).clip_plus.item.item.available).to_boolean then
					l_regname___0 := 0
				else
					((create {P_GLOBALS_STATIC}).clip_plus.item).item.clip_get_selection
				end
			end
			Result := l_regname___0
		end

	yank_register_mline (a_regname___0: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_regname___0 /= 0 then
				if not (valid_yank_reg (a_regname___0, 0)).to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return and then (a_regname___0 = 95) then
				Result := 0
				l_return := True
			end
			if not l_return then
				get_yank_register (a_regname___0, 0)
				Result := ((y_current.item.item.y_type).to_integer_32 = 1).to_integer
			end
		end

	do_execreg (a_regname___0, a_colon, a_addcr, a_silent: INTEGER_32): INTEGER_32
		local
			l_regname___0: INTEGER_32
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_remap: INTEGER_32
			l_escaped: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_regname___0 := a_regname___0
					l_retval := 1
					if l_regname___0 = 64 then
						if execreg_lastc.item = 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E748: No previously used register"))))).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							l_regname___0 := execreg_lastc.item
						end
					end
					if not l_return then
						if l_regname___0 = 37 then
							(create {P_MESSAGE_STATIC}).emsg_invreg (l_regname___0)
							Result := 0
							l_return := True
						elseif l_regname___0 = 35 then
							(create {P_MESSAGE_STATIC}).emsg_invreg (l_regname___0)
							Result := 0
							l_return := True
						elseif not (valid_yank_reg (l_regname___0, 0)).to_boolean then
							(create {P_MESSAGE_STATIC}).emsg_invreg (l_regname___0)
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						execreg_lastc.item := l_regname___0
						l_regname___0 := may_get_selection (l_regname___0)
						if l_regname___0 = 95 then
							Result := 1
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 25 -- skip if block
					end
				when 1 then -- if:
						if l_regname___0 /= 58 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((create {P_GLOBALS_STATIC}).last_cmdline.item).is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_nolastcmd.item)))))).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).new_last_cmdline.item));
							(create {P_GLOBALS_STATIC}).new_last_cmdline.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							l_p___0 := (create {P_MISC2_STATIC}).vim_strsave_escaped_ext ((create {P_GLOBALS_STATIC}).last_cmdline.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/1/%/2/%/3/%/4/%/5/%/6/%/7/%B%T%N%/11/%F%R%/14/%/15/%/16/%/17/%/18/%/19/%/20/%/21/%/22/%/23/%/24/%/25/%/26/%/27/%/28/%/29/%/30/%/31/")), 22, 0)
							if not l_p___0.is_void then
								if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
									if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("%'<,%'>"), (5).to_natural_32)) = 0 then
										l_retval := put_in_typebuf (l_p___0 + 5, 1, 1, a_silent)
									else
										l_retval := put_in_typebuf (l_p___0, 1, 1, a_silent)
									end
								else
									l_retval := put_in_typebuf (l_p___0, 1, 1, a_silent)
								end
							end
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 4 then -- else:
						if l_regname___0 /= 61 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_p___0 := get_expr_line
						if l_p___0.is_void then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_retval := put_in_typebuf (l_p___0, 1, a_colon, a_silent);
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 7 then -- else:
						if l_regname___0 /= 46 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_p___0 := (create {P_EDIT_STATIC}).get_last_insert_save
						if l_p___0.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_noinstext.item)))))).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							l_retval := put_in_typebuf (l_p___0, 0, a_colon, a_silent);
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 10 then -- else:
						get_yank_register (l_regname___0, 0)
						if (y_current.item.item.y_array).is_void then
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 24 -- skip if block
						end
				when 11 then -- if:
						if a_colon.to_boolean then
							l_remap := -1
						else
							l_remap := 0
						end
						put_reedit_in_typebuf (a_silent)
						l_i___0 := y_current.item.item.y_size
				when 12 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 24 -- skip loop
						end
				when 13 then -- loop body:
						l_break := False
						l_i___0 := l_i___0 - 1
						if not (l_i___0 >= 0) then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 23 -- skip if block
						end
				when 14 then -- if:
						if (y_current.item.item.y_type).to_integer_32 /= 1 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 21 -- goto _L
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 17 then -- else:
						if not (l_i___0 < y_current.item.item.y_size - 1) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 20 then -- else:
						if not (a_addcr.to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 21 then -- if: | _L:
						if ((create {P_GETCHAR_STATIC}).ins_typebuf (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")), l_remap, 0, 1, a_silent)) = 0 then
							Result := 0
							l_return := True
						end
				when 22 then -- if done | if done
						if not l_return then
							l_escaped := (create {P_GETCHAR_STATIC}).vim_strsave_escape_csi (y_current.item.item.y_array[l_i___0])
							if l_escaped.is_void then
								Result := 0
								l_return := True
							end
						end
						if not l_return then
							l_retval := (create {P_GETCHAR_STATIC}).ins_typebuf (l_escaped, l_remap, 0, 1, a_silent);
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_escaped))
							if l_retval = 0 then
								Result := 0
								l_return := True
							end
						end
						if not l_return and then (a_colon.to_boolean) then
							if ((create {P_GETCHAR_STATIC}).ins_typebuf (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":")), l_remap, 0, 1, a_silent)) = 0 then
								Result := 0
								l_return := True
							end
						end
				when 23 then -- if done
						l_pos := -1 + 12 -- back to loop condition
				when 24 then -- loop done | if done
						if not l_return then
							l_break := False;
							(create {P_GLOBALS_STATIC}).Exec_reg.item := 1
						end
				when 25 then -- if done | if done | if done | if done
					if not l_return then
						Result := l_retval
					end
				when 26 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	put_reedit_in_typebuf (a_silent: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<3>>)

			if (create {P_GLOBALS_STATIC}).restart_edit.item /= 0 then
				if (create {P_GLOBALS_STATIC}).restart_edit.item = 86 then
					l_buf___6[0] := (('g').code).to_natural_8
					l_buf___6[1] := (('R').code).to_natural_8
					l_buf___6[2] := (('%/0/').code).to_natural_8
				else
					if (create {P_GLOBALS_STATIC}).restart_edit.item = 73 then
						l_buf___6[0] := (('i').code).to_natural_8
					else
						l_buf___6[0] := ((create {P_GLOBALS_STATIC}).restart_edit.item).to_natural_8
					end
					l_buf___6[1] := (('%/0/').code).to_natural_8
				end
				if ((create {P_GETCHAR_STATIC}).ins_typebuf (l_buf___6, -1, 0, 1, a_silent)) = 1 then
					(create {P_GLOBALS_STATIC}).restart_edit.item := ('%/0/').code
				end
			end
		end

	put_in_typebuf (a_s: CE_POINTER [NATURAL_8]; a_esc, a_colon, a_silent: INTEGER_32): INTEGER_32
		local
			l_retval: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
		do
			l_retval := 1
			put_reedit_in_typebuf (a_silent)
			if a_colon.to_boolean then
				l_retval := (create {P_GETCHAR_STATIC}).ins_typebuf (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")), -1, 0, 1, a_silent)
			end
			if l_retval = 1 then
				if a_esc.to_boolean then
					l_p___0 := (create {P_GETCHAR_STATIC}).vim_strsave_escape_csi (a_s)
				else
					l_p___0 := a_s
				end
				if l_p___0.is_void then
					l_retval := 0
				else
					if a_esc.to_boolean then
						l_tmp := -1
					else
						l_tmp := 0
					end
					l_retval := (create {P_GETCHAR_STATIC}).ins_typebuf (l_p___0, l_tmp, 0, 1, a_silent)
				end
				if a_esc.to_boolean then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
				end
			end
			if a_colon.to_boolean then
				if l_retval = 1 then
					l_retval := (create {P_GETCHAR_STATIC}).ins_typebuf (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":")), -1, 0, 1, a_silent)
				end
			end
			Result := l_retval
		end

	insert_reg (a_regname___0, a_literally: INTEGER_32): INTEGER_32
		local
			l_regname___0: INTEGER_32
			l_i___0: INTEGER_32
			l_retval: INTEGER_32
			l_arg: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_allocated: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_arg.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_allocated.make (<<1>>)

			l_regname___0 := a_regname___0
			l_retval := 1;
			(create {P_UI_STATIC}).ui_breakcheck
			if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return and then (l_regname___0 /= 0) then
				if not (valid_yank_reg (l_regname___0, 0)).to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_regname___0 := may_get_selection (l_regname___0)
				if l_regname___0 = 46 then
					l_retval := (create {P_EDIT_STATIC}).stuff_inserted (('%/0/').code, 1, 1)
				elseif (get_spec_reg (l_regname___0, l_arg, l_allocated, 1)).to_boolean then
					if (l_arg.item).is_void then
						Result := 0
						l_return := True
					end
					if not l_return then
						stuffescaped (l_arg.item, a_literally)
						if (l_allocated.item).to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_arg.item))
						end
					end
				else
					get_yank_register (l_regname___0, 0)
					if (y_current.item.item.y_array).is_void then
						l_retval := 0
					else
						l_i___0 := 0
						from
						until
							not (l_i___0 < y_current.item.item.y_size)
						loop
							stuffescaped (y_current.item.item.y_array[l_i___0], a_literally)
							if (y_current.item.item.y_type).to_integer_32 = 1 then
								(create {P_GETCHAR_STATIC}).stuffcharReadbuff (('%N').code)
							elseif l_i___0 < y_current.item.item.y_size - 1 then
								(create {P_GETCHAR_STATIC}).stuffcharReadbuff (('%N').code)
							end
							l_i___0 := l_i___0 + 1
						end
					end
				end
			end
			if not l_return then
				Result := l_retval
			end
		end

	stuffescaped (a_arg: CE_POINTER [NATURAL_8]; a_literally: INTEGER_32)
		local
			l_arg: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_c: INTEGER_32
			l_start___1: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_arg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg.item := a_arg
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_arg.item.item).to_integer_32 /= 0)) then
						l_pos := -1 + 17 -- skip loop
					end
				when 2 then -- loop body:
						l_start___1 := l_arg.item
				when 3 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 9 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						if not ((l_arg.item.item).to_integer_32 >= 32) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not ((l_arg.item.item).to_integer_32 < 127) then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if (l_arg.item.item).to_integer_32 = 128 then
							if a_literally.to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
				when 8 then
						if not (l_break) then
							l_arg.item := l_arg.item + 1
						end
						l_pos := -1 + 3 -- back to loop condition
				when 9 then -- loop done
						l_break := False
						if ((l_arg.item).c_pointer.to_integer_32).to_natural_32 > (l_start___1.c_pointer.to_integer_32).to_natural_32 then
							(create {P_GETCHAR_STATIC}).stuffReadbuffLen (l_start___1, ((l_arg.item).distance (l_start___1)).to_integer_32)
						end
						if (l_arg.item.item).to_integer_32 = 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 10 then -- if:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_c := (create {P_MBYTE_STATIC}).mb_cptr2char_adv (l_arg)
						else
							l_tmp := l_arg.item
							l_arg.item := l_arg.item + 1
							l_c := (l_tmp.item).to_integer_32
						end
						if not (a_literally.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 11 then -- if:
						if not (l_c < 32) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if l_c /= 9 then
							(create {P_GETCHAR_STATIC}).stuffcharReadbuff (22)
						else
							l_pos := -1 + 14 -- goto _L___0
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L___0:
						if l_c = 127 then
							(create {P_GETCHAR_STATIC}).stuffcharReadbuff (22)
						end
				when 15 then -- if done;
						(create {P_GETCHAR_STATIC}).stuffcharReadbuff (l_c)
				when 16 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_spec_reg (a_regname___0: INTEGER_32; a_argp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_allocated: CE_POINTER [INTEGER_32]; a_errmsg: INTEGER_32): INTEGER_32
		require
			not a_argp.is_void
			not a_allocated.is_void
		local
			l_cnt: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_argp.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					a_allocated.item := 0
					inspect a_regname___0 -- switch 1 head
					when 37 then l_pos := -1 + 1
					when 35 then l_pos := -1 + 2
					when 61 then l_pos := -1 + 3
					when 58 then l_pos := -1 + 4
					when 47 then l_pos := -1 + 5
					when 46 then l_pos := -1 + 6
					when 6 then l_pos := -1 + 7
					when 16 then l_pos := -1 + 7
					when 23 then l_pos := -1 + 8
					when 1 then l_pos := -1 + 8
					when 95 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 1 then -- switch 1, case 37
					if a_errmsg.to_boolean then
						(create {P_EX_CMDS2_STATIC}).check_fname.do_nothing
					end
					a_argp.item := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname
					Result := 1
					l_return := True
				when 2 then -- switch 1, case 35
					if not l_return then
						a_argp.item := (create {P_BUFFER_STATIC}).getaltfname (a_errmsg)
						Result := 1
						l_return := True
					end
				when 3 then -- switch 1, case 61
					if not l_return then
						a_argp.item := get_expr_line
						a_allocated.item := 1
						Result := 1
						l_return := True
					end
				when 4 then -- switch 1, case 58
					if not l_return then
						if ((create {P_GLOBALS_STATIC}).last_cmdline.item).is_void then
							if a_errmsg.to_boolean then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_nolastcmd.item)))))).do_nothing
							end
						end
						a_argp.item := (create {P_GLOBALS_STATIC}).last_cmdline.item
						Result := 1
						l_return := True
					end
				when 5 then -- switch 1, case 47
					if not l_return then
						if ((create {P_SEARCH_STATIC}).last_search_pat).is_void then
							if a_errmsg.to_boolean then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_noprevre.item)))))).do_nothing
							end
						end
						a_argp.item := (create {P_SEARCH_STATIC}).last_search_pat
						Result := 1
						l_return := True
					end
				when 6 then -- switch 1, case 46
					if not l_return then
						a_argp.item := (create {P_EDIT_STATIC}).get_last_insert_save
						a_allocated.item := 1
						if (a_argp.item).is_void then
							if a_errmsg.to_boolean then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_noinstext.item)))))).do_nothing
							end
						end
						Result := 1
						l_return := True
					end
				when 7 then -- switch 1, case 6 | switch 1, case 16
					if not l_return and then (not a_errmsg.to_boolean) then
						Result := 0
						l_return := True
					end
					if not l_return then
						if a_regname___0 = 16 then
							l_tmp___3 := 2
						else
							l_tmp___3 := 0
						end
						a_argp.item := (create {P_WINDOW_STATIC}).file_name_at_cursor ((5).bit_or (l_tmp___3), 1, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						a_allocated.item := 1
						Result := 1
						l_return := True
					end
				when 8 then -- switch 1, case 23 | switch 1, case 1
					if not l_return and then (not a_errmsg.to_boolean) then
						Result := 0
						l_return := True
					end
					if not l_return then
						if a_regname___0 = 23 then
							l_tmp___4 := 3
						else
							l_tmp___4 := 2
						end
						l_cnt := (create {P_NORMAL_STATIC}).find_ident_under_cursor (a_argp, l_tmp___4)
						if l_cnt.to_boolean then
							a_argp.item := ((create {P_MISC2_STATIC}).vim_strnsave (a_argp.item, l_cnt))
						else
							a_argp.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
						a_allocated.item := 1
						Result := 1
						l_return := True
					end
				when 9 then -- switch 1, case 95
					if not l_return then
						a_argp.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
						Result := 1
						l_return := True
					end
				when 10 then -- switch 1, done:
					if not l_return then
						Result := 0
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cmdline_paste_reg (a_regname___0, a_literally, a_remcr: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			get_yank_register (a_regname___0, 0)
			if (y_current.item.item.y_array).is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_i___0 := 0
				from
				until
					not (not (l_return) and then (l_i___0 < y_current.item.item.y_size))
				loop
					(create {P_EX_GETLN_STATIC}).cmdline_paste_str (y_current.item.item.y_array[l_i___0], a_literally)
					if (y_current.item.item.y_type).to_integer_32 = 1 then
						(create {P_EX_GETLN_STATIC}).cmdline_paste_str (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R")), a_literally)
					elseif l_i___0 < y_current.item.item.y_size - 1 then
						if a_remcr.to_boolean then
							if l_i___0 = y_current.item.item.y_size - 2 then
								if ((y_current.item.item.y_array[(l_i___0 + 1)]).item).to_integer_32 /= 0 then
									(create {P_EX_GETLN_STATIC}).cmdline_paste_str (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R")), a_literally)
								end
							else
								(create {P_EX_GETLN_STATIC}).cmdline_paste_str (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R")), a_literally)
							end
						else
							(create {P_EX_GETLN_STATIC}).cmdline_paste_str (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R")), a_literally)
						end
					end
					(create {P_UI_STATIC}).ui_breakcheck
					if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not l_return then
				Result := 1
			end
		end

	adjust_clip_reg (a_rp: CE_POINTER [INTEGER_32])
		require
			not a_rp.is_void
		do
			if a_rp.item = 0 then
				if ((create {P_GLOBALS_STATIC}).clip_unnamed.item).to_boolean then
					a_rp.item := ('*').code
				end
			end
			if not ((create {P_GLOBALS_STATIC}).clip_star.item.item.available).to_boolean then
				if a_rp.item = 42 then
					a_rp.item := 0
				end
			end
			if not ((create {P_GLOBALS_STATIC}).clip_plus.item.item.available).to_boolean then
				if a_rp.item = 43 then
					a_rp.item := 0
				end
			end
		end

	op_delete (a_oap: CE_POINTER [PD_OPARG_S]): INTEGER_32
		local
			l_n: INTEGER_32
			l_lnum: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_newp: CE_POINTER [NATURAL_8]
			l_oldp: CE_POINTER [NATURAL_8]
			l_bd: CE_ARRAY [PD_BLOCK_DEF]
			l_old_lcount: INTEGER_32
			l_did_yank: INTEGER_32
			l_msg_silent_save: INTEGER_32
			l_endcol: INTEGER_32
			l_curline: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp___26: INTEGER_32
			l_curpos: PD_POS_T
			l_tmp___28: INTEGER_32
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_newp.make
			create {CE_NATURAL_8_POINTER} l_oldp.make
			create {CE_CLASS_ARRAY [PD_BLOCK_DEF]} l_bd.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_old_lcount := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
					l_did_yank := 0
					if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_and (1)).to_boolean then
						Result := 1
						l_return := True
					end
					if not l_return and then ((a_oap.item.empty).to_boolean) then
						Result := ((create {P_UNDO_STATIC}).u_save_cursor)
						l_return := True
					end
					if not l_return and then (not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ma).to_boolean) then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_modifiable.item)))))).do_nothing
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						adjust_clip_reg (create {CE_INTEGER_32_POINTER}.make_shared (a_oap.c_pointer + (create {PD_OPARG_S}.make).offset_of ("regname")))
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							a_oap.item.mb_adjust_opend
						end
						if a_oap.item.motion_type = 0 then
							if not (a_oap.item.is_VIsual).to_boolean then
								if not (a_oap.item.block_mode).to_boolean then
									if a_oap.item.line_count > 1 then
										if a_oap.item.op_type = 1 then
											l_ptr := (((create {P_MEMLINE_STATIC}).ml_get (a_oap.item.end2.lnum)) + a_oap.item.end2.col) + a_oap.item.inclusive
											l_ptr := (create {P_CHARSET_STATIC}).skipwhite (l_ptr)
											if (l_ptr.item).to_integer_32 = 0 then
												if ((create {P_MISC1_STATIC}).inindent (0)).to_boolean then
													a_oap.item.motion_type := 1
												end
											end
										end
									end
								end
							end
						end
						if a_oap.item.motion_type /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if a_oap.item.line_count /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						if a_oap.item.op_type /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 4 then -- if:
						if (((create {P_MEMLINE_STATIC}).ml_get (a_oap.item.start.lnum)).item).to_integer_32 /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if ((create {P_GLOBALS_STATIC}).virtual_op.item).to_boolean then
							l_pos := -1 + 23 -- goto setmarks
						end
				when 6 then
						if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('E').code)).is_void then
							(create {P_MISC1_STATIC}).beep_flush
						end
						Result := 1
						l_return := True
				when 7 then -- if done | if done | if done | if done | if done
					if not (not l_return and then (a_oap.item.regname /= 95)) then
						l_pos := -1 + 21 -- skip if block
					end
				when 8 then -- if:
						if a_oap.item.regname /= 0 then
							if not (valid_yank_reg (a_oap.item.regname, 1)).to_boolean then
								(create {P_MISC1_STATIC}).beep_flush
								Result := 1
								l_return := True
							end
							if not l_return then
								get_yank_register (a_oap.item.regname, 1)
								if (a_oap.item.op_yank (1, 0)) = 1 then
									l_did_yank := 1
								end
							end
						end
						if l_return then
							l_pos := -1 + 21 -- skip if block
						end
				when 9 then -- if:
						if a_oap.item.regname = 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 19 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 12 then -- else:
						if a_oap.item.motion_type /= 1 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 19 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 15 then -- else:
						if not (a_oap.item.line_count > 1) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 18 then -- else:
						if not ((a_oap.item.use_reg_one).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 19 then -- if: | _L:
						y_current.item := y_regs.item + 9
						free_yank_all
						l_n := 9
						from
						until
							not (l_n > 1)
						loop
							y_regs.item[l_n] := (y_regs.item[l_n - 1]).twin
							l_n := l_n - 1
						end
						y_current.item := y_regs.item + 1
						y_previous.item := y_current.item
						y_regs.item[1].y_array := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
						if (a_oap.item.op_yank (1, 0)) = 1 then
							l_did_yank := 1
						end
				when 20 then -- if done | if done | if done
						if a_oap.item.regname = 0 then
							if a_oap.item.motion_type /= 1 then
								if a_oap.item.line_count = 1 then
									a_oap.item.regname := ('-').code
									get_yank_register (a_oap.item.regname, 1)
									if (a_oap.item.op_yank (1, 0)) = 1 then
										l_did_yank := 1
									end
									a_oap.item.regname := 0
								end
							end
						end
						if not l_did_yank.to_boolean then
							l_msg_silent_save := (create {P_GLOBALS_STATIC}).msg_silent.item;
							(create {P_GLOBALS_STATIC}).msg_silent.item := 0
							l_n := (create {P_MISC1_STATIC}).ask_yesno (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("cannot yank; delete anyway")))), 1);
							(create {P_GLOBALS_STATIC}).msg_silent.item := l_msg_silent_save
							if l_n /= 121 then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_abort.item)))))).do_nothing
								Result := 0
								l_return := True
							end
						end
				when 21 then -- if done | if done
					if not l_return then
						if (a_oap.item.block_mode).to_boolean then
							if ((create {P_UNDO_STATIC}).u_save (a_oap.item.start.lnum - 1, a_oap.item.end2.lnum + 1)) = 0 then
								Result := 0
								l_return := True
							end
							if not l_return then
								l_lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
								from
								until
									not (l_lnum <= a_oap.item.end2.lnum)
								loop
									l_continue := False
									a_oap.item.block_prep (l_bd, l_lnum, 1)
									if l_bd.item.textlen = 0 then
										l_continue := True
									end
									if not (l_continue) then
										if l_lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_bd.item.textcol + l_bd.item.startspaces;
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0
										end
										l_n := (l_bd.item.textlen - l_bd.item.startspaces) - l_bd.item.endspaces
										l_oldp := (create {P_MEMLINE_STATIC}).ml_get (l_lnum)
										l_newp := (create {P_MISC2_STATIC}).alloc_check (((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_oldp))) + {NATURAL_32} 1) - l_n.to_natural_32)
										if l_newp.is_void then
											l_continue := True
										end
									end
									if not (l_continue) then
										memmove (create {CE_VOID_POINTER}.make_cast (l_newp), create {CE_VOID_POINTER}.make_cast (l_oldp), (l_bd.item.textcol).to_natural_32).do_nothing;
										(create {P_MISC2_STATIC}).copy_spaces (l_newp + l_bd.item.textcol, (l_bd.item.startspaces + l_bd.item.endspaces).to_natural_32)
										l_oldp := l_oldp + (l_bd.item.textcol + l_bd.item.textlen)
										memmove (create {CE_VOID_POINTER}.make_cast ((((l_newp + l_bd.item.textcol) + l_bd.item.startspaces) + l_bd.item.endspaces)), create {CE_VOID_POINTER}.make_cast (l_oldp), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_oldp))) + {NATURAL_32} 1).do_nothing;
										(create {P_MEMLINE_STATIC}).ml_replace (l_lnum, l_newp, 0).do_nothing
									end
									l_lnum := l_lnum + 1
								end
								l_continue := False;
								(create {P_MISC2_STATIC}).check_cursor_col;
								(create {P_MISC1_STATIC}).changed_lines ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col, a_oap.item.end2.lnum + 1, 0)
								a_oap.item.line_count := 0
							end
						elseif a_oap.item.motion_type = 1 then
							if a_oap.item.op_type = 3 then
								if a_oap.item.line_count > 1 then
									l_lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum;
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1;
									(create {P_MISC1_STATIC}).del_lines (a_oap.item.line_count - 1, 1);
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_lnum
								end
								if ((create {P_UNDO_STATIC}).u_save_cursor) = 0 then
									Result := 0
									l_return := True
								end
								if not l_return then
									if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ai).to_boolean then
										(create {P_EDIT_STATIC}).beginline (1);
										(create {P_GLOBALS_STATIC}).did_ai.item := 1;
										(create {P_GLOBALS_STATIC}).ai_col.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
									else
										(create {P_EDIT_STATIC}).beginline (0)
									end
									(create {P_MISC1_STATIC}).truncate_line (0).do_nothing
									if a_oap.item.line_count > 1 then
										(create {P_UNDO_STATIC}).u_clearline
									end
								end
							else
								(create {P_MISC1_STATIC}).del_lines (a_oap.item.line_count, 1);
								(create {P_EDIT_STATIC}).beginline (5);
								(create {P_UNDO_STATIC}).u_clearline
							end
						else
							if ((create {P_GLOBALS_STATIC}).virtual_op.item).to_boolean then
								l_endcol := 0
								if ((create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (a_oap.c_pointer + (create {PD_OPARG_S}.make).offset_of ("start"))).item.gchar_pos) = 9 then
									if ((create {P_UNDO_STATIC}).u_save_cursor) = 0 then
										Result := 0
										l_return := True
									end
									if not l_return then
										if a_oap.item.line_count = 1 then
											l_endcol := (create {P_MISC2_STATIC}).getviscol2 (a_oap.item.end2.col, a_oap.item.end2.coladd)
										end
										(create {P_MISC2_STATIC}).coladvance_force (((create {P_MISC2_STATIC}).getviscol2 (a_oap.item.start.col, a_oap.item.start.coladd))).do_nothing
										a_oap.item.start := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
										if a_oap.item.line_count = 1 then
											(create {P_MISC2_STATIC}).coladvance (l_endcol).do_nothing
											a_oap.item.end2.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
											a_oap.item.end2.coladd := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd;
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (a_oap.item.start).twin
										end
									end
								end
								if not l_return then
									if ((create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (a_oap.c_pointer + (create {PD_OPARG_S}.make).offset_of ("end2"))).item.gchar_pos) = 9 then
										if a_oap.item.end2.coladd < a_oap.item.inclusive then
											if ((create {P_UNDO_STATIC}).u_save (a_oap.item.end2.lnum - 1, a_oap.item.end2.lnum + 1)) = 0 then
												Result := 0
												l_return := True
											end
											if not l_return then
												(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (a_oap.item.end2).twin;
												(create {P_MISC2_STATIC}).coladvance_force (((create {P_MISC2_STATIC}).getviscol2 (a_oap.item.end2.col, a_oap.item.end2.coladd))).do_nothing
												a_oap.item.end2 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
												(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (a_oap.item.start).twin
											end
										end
									end
								end
							end
							if not l_return then
								if a_oap.item.line_count = 1 then
									if ((create {P_UNDO_STATIC}).u_save_cursor) = 0 then
										Result := 0
										l_return := True
									end
									if not l_return then
										if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('$').code)).is_void then
											if a_oap.item.op_type = 3 then
												if a_oap.item.end2.lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
													if not (a_oap.item.is_VIsual).to_boolean then
														(create {P_EDIT_STATIC}).display_dollar (a_oap.item.end2.col - (not (a_oap.item.inclusive).to_boolean).to_integer)
													end
												end
											end
										end
										l_n := ((a_oap.item.end2.col - a_oap.item.start.col) + 1) - (not (a_oap.item.inclusive).to_boolean).to_integer
										if ((create {P_GLOBALS_STATIC}).virtual_op.item).to_boolean then
											l_curline := ((create {P_MEMLINE_STATIC}).ml_get_curline)
											l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_curline))).to_integer_32
											if a_oap.item.end2.coladd /= 0 then
												if a_oap.item.end2.col >= l_len - 1 then
													if (a_oap.item.start.coladd).to_boolean then
														if not (a_oap.item.end2.col >= l_len - 1) then
															l_n := l_n + 1
														end
													else
														l_n := l_n + 1
													end
												end
											end
											if l_n = 0 then
												if a_oap.item.start.coladd /= a_oap.item.end2.coladd then
													l_n := 1
												end
											end
											if ((create {P_MISC1_STATIC}).gchar_cursor) /= 0 then
												(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0
											end
										end
										if a_oap.item.op_type = 1 then
											if not (a_oap.item.is_VIsual).to_boolean then
												l_tmp___26 := 1
											else
												l_tmp___26 := 0
											end
										else
											l_tmp___26 := 0
										end
										(create {P_MISC1_STATIC}).del_bytes (l_n.to_integer_32, (not ((create {P_GLOBALS_STATIC}).virtual_op.item).to_boolean).to_integer, l_tmp___26).do_nothing
									end
								else
									if ((create {P_UNDO_STATIC}).u_save ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + a_oap.item.line_count)) = 0 then
										Result := 0
										l_return := True
									end
									if not l_return then
										(create {P_MISC1_STATIC}).truncate_line (1).do_nothing
										l_curpos := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1;
										(create {P_MISC1_STATIC}).del_lines (a_oap.item.line_count - 2, 0);
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
										if a_oap.item.op_type = 1 then
											if not (a_oap.item.is_VIsual).to_boolean then
												l_tmp___28 := 1
											else
												l_tmp___28 := 0
											end
										else
											l_tmp___28 := 0
										end
										(create {P_MISC1_STATIC}).del_bytes (((a_oap.item.end2.col + 1) - (not (a_oap.item.inclusive).to_boolean).to_integer).to_integer_32, (not ((create {P_GLOBALS_STATIC}).virtual_op.item).to_boolean).to_integer, l_tmp___28).do_nothing;
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_curpos.twin
										do_join (2, 0, 0).do_nothing
									end
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 24 -- skip if block
					end
				when 22 then -- if:;
						(create {P_MISC1_STATIC}).msgmore ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count - l_old_lcount)
				when 23 then -- setmarks:
						if (a_oap.item.block_mode).to_boolean then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.lnum := a_oap.item.end2.lnum;
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.col := a_oap.item.start.col
						else
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end := (a_oap.item.start).twin
						end
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start := (a_oap.item.start).twin
						Result := 1
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	init_yank
		local
			l_i___0: INTEGER_32
		do
			l_i___0 := 0
			from
			until
				not (l_i___0 < 40)
			loop
				y_regs.item[l_i___0].y_array := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_i___0 := l_i___0 + 1
			end
		end

	free_yank (a_n: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_break: BOOLEAN
		do
			if not (y_current.item.item.y_array).is_void then
				l_i___0 := a_n
				from
				until
					(l_break)
				loop
					l_break := False
					l_i___0 := l_i___0 - 1
					if not (l_i___0 >= 0) then
						l_break := True
					end
					if not (l_break) then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (y_current.item.item.y_array[l_i___0]))
					end
				end
				l_break := False;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (y_current.item.item.y_array))
				y_current.item.item.y_array := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
		end

	free_yank_all
		do
			free_yank (y_current.item.item.y_size)
		end

	do_put (a_regname___0, a_dir___0: INTEGER_32; a_count___2: INTEGER_32; a_flags___0: INTEGER_32)
		local
			l_regname___0: CE_ARRAY [INTEGER_32]
			l_dir___0: INTEGER_32
			l_ptr: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_newp: CE_POINTER [NATURAL_8]
			l_oldp: CE_POINTER [NATURAL_8]
			l_yanklen: INTEGER_32
			l_totlen: INTEGER_32
			l_lnum: CE_ARRAY [INTEGER_32]
			l_col: CE_ARRAY [INTEGER_32]
			l_i___0: INTEGER_32
			l_y_type: INTEGER_32
			l_y_size: INTEGER_32
			l_oldlen: INTEGER_32
			l_y_width: INTEGER_32
			l_vcol: INTEGER_32
			l_delcount: INTEGER_32
			l_incr: INTEGER_32
			l_j: INTEGER_32
			l_bd: PD_BLOCK_DEF
			l_y_array: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_nr_lines: INTEGER_32
			l_new_cursor: PD_POS_T
			l_indent: INTEGER_32
			l_orig_indent: INTEGER_32
			l_indent_diff: INTEGER_32
			l_first_indent: INTEGER_32
			l_lendiff: INTEGER_32
			l_old_pos: PD_POS_T
			l_insert_string: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_allocated: CE_ARRAY [INTEGER_32]
			l_cnt: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_c: INTEGER_8
			l_endcol2: CE_ARRAY [INTEGER_32]
			l_spaces: INTEGER_32
			l_shortline: INTEGER_8
			l_tmp___25: INTEGER_32
			l_len: INTEGER_32
			l_bytelen___0: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_regname___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_ptr.make (<<1>>)
			create {CE_NATURAL_8_POINTER} l_newp.make
			create {CE_NATURAL_8_POINTER} l_oldp.make
			create {CE_INTEGER_32_ARRAY} l_lnum.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)
			create l_bd.make
			create {CE_POINTER_ARRAY [NATURAL_8]} l_insert_string.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_allocated.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_endcol2.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_regname___0.item := a_regname___0
					l_dir___0 := a_dir___0
					l_totlen := 0
					l_y_width := 0
					l_incr := 0
					l_y_array := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_nr_lines := 0
					l_orig_indent := 0
					l_indent_diff := 0
					l_first_indent := 1
					l_lendiff := 0
					l_insert_string.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_allocated.item := 0
					adjust_clip_reg (l_regname___0)
					may_get_selection (l_regname___0.item).do_nothing
					if ((a_flags___0).bit_and (1)).to_boolean then
						l_orig_indent := (create {P_MISC1_STATIC}).get_indent
					end
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
					if l_regname___0.item = 46 then
						if l_dir___0 = 1 then
							if a_count___2 = -1 then
								l_tmp := ('o').code
							else
								l_tmp := ('a').code
							end
							l_tmp___1 := l_tmp
						else
							if a_count___2 = -1 then
								l_tmp___0 := ('O').code
							else
								l_tmp___0 := ('i').code
							end
							l_tmp___1 := l_tmp___0
						end
						(create {P_EDIT_STATIC}).stuff_inserted (l_tmp___1, a_count___2, 0).do_nothing
						if ((a_flags___0).bit_and (2)).to_boolean then
							if ((create {P_MISC1_STATIC}).gchar_cursor) /= 0 then
								(create {P_GETCHAR_STATIC}).stuffcharReadbuff (('l').code)
							end
						end
						l_return := True
					end
					if not l_return then
						if (get_spec_reg (l_regname___0.item, l_insert_string, l_allocated, 1)).to_boolean then
							if (l_insert_string.item).is_void then
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 85 -- skip if block
					end
				when 1 then -- if:
						if (l_insert_string.item).is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						l_y_type := 0
						if l_regname___0.item /= 61 then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						l_y_size := 0
						l_ptr.item := l_insert_string.item
						from
						until
							not (not (l_break) and then (not (l_ptr.item).is_void))
						loop
							l_break := False
							if not l_y_array.is_void then
								l_y_array[l_y_size] := l_ptr.item
							end
							l_y_size := l_y_size + 1
							l_ptr.item := (create {P_MISC2_STATIC}).vim_strchr (l_ptr.item, ('%N').code)
							if not (l_ptr.item).is_void then
								if not l_y_array.is_void then
									l_ptr.item.item := (('%/0/').code).to_natural_8
								end
								l_ptr.item := l_ptr.item + 1
								if (l_ptr.item.item).to_integer_32 = 0 then
									l_y_type := 1
									l_break := True
								end
							end
						end
						l_break := False
						if not l_y_array.is_void then
							l_break := True
						end
						if not (l_return or l_break) then
							l_y_array := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (((create {P_MISC2_STATIC}).alloc ((l_y_size.to_natural_32 * ({PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32).to_natural_32)))
							if l_y_array.is_void then
								l_pos := -1 + 84 -- goto end
							end
						end
				when 5 then
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						l_break := False
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_y_size := 1
						l_y_array := l_insert_string
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						get_yank_register (l_regname___0.item, 0)
						l_y_type := (y_current.item.item.y_type).to_integer_32
						l_y_width := (y_current.item.item.y_width).to_integer_32
						l_y_size := y_current.item.item.y_size
						l_y_array := y_current.item.item.y_array
				when 11 then -- if done
						if l_y_type /= 1 then
							l_pos := -1 + 18 -- skip if block
						end
				when 12 then -- if:
						if not (((a_flags___0).bit_and (16)).to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 13 then -- if:
						if ((create {P_UNDO_STATIC}).u_save_cursor) = 0 then
							l_pos := -1 + 84 -- goto end
						end
				when 14 then
						l_ptr.item := (create {P_MISC2_STATIC}).vim_strsave (((create {P_MEMLINE_STATIC}).ml_get_cursor))
						if (l_ptr.item).is_void then
							l_pos := -1 + 84 -- goto end
						end
				when 15 then;
						(create {P_MEMLINE_STATIC}).ml_append ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_ptr.item, 0, 0).do_nothing;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ptr.item))
						l_ptr.item := (create {P_MISC2_STATIC}).vim_strnsave (((create {P_MEMLINE_STATIC}).ml_get_curline), (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col)
						if (l_ptr.item).is_void then
							l_pos := -1 + 84 -- goto end
						end
				when 16 then;
						(create {P_MEMLINE_STATIC}).ml_replace ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_ptr.item, 0).do_nothing
						l_nr_lines := l_nr_lines + 1
						l_dir___0 := 1
				when 17 then -- if done
						if ((a_flags___0).bit_and (32)).to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_end).twin
							l_dir___0 := 1
						end
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
				when 18 then -- if done
						if ((a_flags___0).bit_and (8)).to_boolean then
							l_y_type := 1
						end
						if l_y_size /= 0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 21 then -- else:
						if not (l_y_array.is_void) then
							l_pos := -1 + 23 -- skip if block
						end
				when 22 then -- if: | _L:
						if l_regname___0.item = 0 then
							l_tmp___9 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%""))
						else
							l_tmp___9 := ((create {P_CHARSET_STATIC}).transchar (l_regname___0.item))
						end
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E353: Nothing in register %%s")))), l_tmp___9).do_nothing
						l_pos := -1 + 84 -- goto end
				when 23 then -- if done
						if l_y_type /= 2 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_lnum.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + l_y_size) + 1
						if l_lnum.item > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							l_lnum.item := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count + 1
						end
						if ((create {P_UNDO_STATIC}).u_save ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1, l_lnum.item)) = 0 then
							l_pos := -1 + 84 -- goto end
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 26 then -- else:
						if l_y_type /= 1 then
							l_pos := -1 + 30 -- skip if block
						end
				when 27 then -- if:
						l_lnum.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
						if l_dir___0 = -1 then
							(create {P_FOLD_STATIC}).hasFolding (l_lnum.item, l_lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing
						else
							(create {P_FOLD_STATIC}).hasFolding (l_lnum.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_lnum).do_nothing
						end
						if l_dir___0 = 1 then
							l_lnum.item := l_lnum.item + 1
						end
						if ((create {P_UNDO_STATIC}).u_save (l_lnum.item - 1, l_lnum.item)) = 0 then
							l_pos := -1 + 84 -- goto end
						end
				when 28 then
						if l_dir___0 = 1 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_lnum.item - 1
						else
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_lnum.item
						end
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else:
						if ((create {P_UNDO_STATIC}).u_save_cursor) = 0 then
							l_pos := -1 + 84 -- goto end
						end
				when 31 then -- if done
						l_yanklen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_y_array[0]))).to_integer_32
						if (create {P_OPTION_STATIC}).ve_flags.item.item = {NATURAL_32} 4 then
							if l_y_type = 0 then
								if ((create {P_MISC1_STATIC}).gchar_cursor) = 9 then
									if l_dir___0 = 1 then
										l_tmp___16 := (((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd).to_integer_32 < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts - 1).to_integer
									else
										l_tmp___16 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd > 0).to_integer
									end
									if l_tmp___16.to_boolean then
										(create {P_MISC2_STATIC}).coladvance_force (((create {P_MISC2_STATIC}).getviscol)).do_nothing
									else
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0
									end
								elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd > 0 then
									l_tmp___17 := (create {P_MISC2_STATIC}).getviscol;
									(create {P_MISC2_STATIC}).coladvance_force (l_tmp___17 + (l_dir___0 = 1).to_integer).do_nothing
								elseif ((create {P_MISC1_STATIC}).gchar_cursor) = 0 then
									l_tmp___17 := (create {P_MISC2_STATIC}).getviscol;
									(create {P_MISC2_STATIC}).coladvance_force (l_tmp___17 + (l_dir___0 = 1).to_integer).do_nothing
								end
							end
						end
						l_lnum.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
						l_col.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
						if l_y_type /= 2 then
							l_pos := -1 + 53 -- skip if block
						end
				when 32 then -- if:
						l_c := ((create {P_MISC1_STATIC}).gchar_cursor).to_integer_8
						l_endcol2.item := 0
						if l_dir___0 = 1 then
							if l_c.to_integer_32 /= 0 then
								if (create {P_OPTION_STATIC}).ve_flags.item.item = {NATURAL_32} 4 then
									((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), l_col, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_endcol2)
								else
									((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_col)
								end
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([((create {P_MEMLINE_STATIC}).ml_get_cursor)]))
								elseif l_c.to_integer_32 /= 9 then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1
								elseif (create {P_OPTION_STATIC}).ve_flags.item.item /= {NATURAL_32} 4 then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1
								end
								l_col.item := l_col.item + 1
							else
								((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), l_col, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_endcol2)
							end
						else
							((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), l_col, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_endcol2)
						end
						l_col.item := l_col.item + ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd)
						if (create {P_OPTION_STATIC}).ve_flags.item.item /= {NATURAL_32} 4 then
							l_pos := -1 + 38 -- skip if block
						end
				when 33 then -- if:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd > 0) then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_pos := -1 + 37 -- goto _L___0
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 36 then -- else:
						if l_endcol2.item /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
							l_pos := -1 + 38 -- skip if block
						end
				when 37 then -- if: | _L___0:
						if l_dir___0 = 1 then
							if l_c.to_integer_32 = 0 then
								l_col.item := l_col.item + 1
							end
						end
						if l_dir___0 /= 1 then
							if l_c.to_integer_32 /= 0 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1
							end
						end
						if l_c.to_integer_32 = 9 then
							if l_dir___0 = -1 then
								if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col).to_boolean then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) - 1
								end
							end
							if l_dir___0 = 1 then
								if l_col.item - 1 = l_endcol2.item then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1
								end
							end
						end
				when 38 then -- if done | if done;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0
						l_bd.textcol := 0
						l_i___0 := 0
				when 39 then -- loop condition:
						if not (not (l_return or l_break) and then (l_i___0 < l_y_size)) then
							l_pos := -1 + 51 -- skip loop
						end
				when 40 then -- loop body:
						l_break := False
						l_bd.startspaces := 0
						l_bd.endspaces := 0
						l_vcol := 0
						l_delcount := 0
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							if ((create {P_MEMLINE_STATIC}).ml_append ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 1, 0)) = 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_nr_lines := l_nr_lines + 1
							end
						end
						if not (l_return or l_break) then
							l_oldp := (create {P_MEMLINE_STATIC}).ml_get_curline
							l_oldlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_oldp))).to_integer_32
							l_ptr.item := l_oldp
							from
							until
								(l_break)
							loop
								l_break := False
								if l_vcol < l_col.item then
									if not (l_ptr.item.item).to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_incr := (create {P_CHARSET_STATIC}).lbr_chartabsize_adv (l_ptr, l_vcol)
									l_vcol := l_vcol + l_incr
								end
							end
							l_break := False
							l_bd.textcol := (l_ptr.item).distance (l_oldp)
							if l_vcol < l_col.item then
								l_tmp___25 := 1
							elseif l_vcol = l_col.item then
								if not (l_ptr.item.item).to_boolean then
									l_tmp___25 := 1
								else
									l_tmp___25 := 0
								end
							else
								l_tmp___25 := 0
							end
							l_shortline := l_tmp___25.to_integer_8
							if l_vcol < l_col.item then
								l_bd.startspaces := l_col.item - l_vcol
							elseif l_vcol > l_col.item then
								l_bd.endspaces := l_vcol - l_col.item
								l_bd.startspaces := l_incr - l_bd.endspaces
								l_bd.textcol := (l_bd.textcol) - 1
								l_delcount := 1
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_bd.textcol := l_bd.textcol - ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_oldp, l_oldp + l_bd.textcol]))
								end
								if (l_oldp[l_bd.textcol]).to_integer_32 /= 9 then
									l_delcount := 0
									l_bd.endspaces := 0
								end
							end
							l_yanklen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_y_array[l_i___0]))).to_integer_32
							l_spaces := (l_y_width + 1).to_integer_32
							l_j := 0
							from
							until
								not (l_j < l_yanklen.to_integer_32)
							loop
								l_spaces := l_spaces - ((create {P_CHARSET_STATIC}).lbr_chartabsize (l_y_array[l_i___0] + l_j, 0))
								l_j := l_j + 1
							end
							if l_spaces < 0 then
								l_spaces := 0
							end
							l_totlen := ((a_count___2 * (l_yanklen + l_spaces).to_integer_32 + (l_bd.startspaces).to_integer_32) + (l_bd.endspaces).to_integer_32).to_integer_32
							l_newp := (create {P_MISC2_STATIC}).alloc_check ((l_totlen.to_natural_32 + l_oldlen.to_natural_32) + {NATURAL_32} 1)
							if l_newp.is_void then
								l_break := True
							end
						end
						if (l_return or l_break) then
							l_pos := -1 + 50 -- skip if block
						end
				when 41 then -- if:
						l_ptr.item := l_newp
						memmove (create {CE_VOID_POINTER}.make_cast (l_ptr.item), create {CE_VOID_POINTER}.make_cast (l_oldp), (l_bd.textcol).to_natural_32).do_nothing
						l_ptr.item := l_ptr.item + (l_bd.textcol);
						(create {P_MISC2_STATIC}).copy_spaces (l_ptr.item, (l_bd.startspaces).to_natural_32)
						l_ptr.item := l_ptr.item + (l_bd.startspaces)
						l_j := 0
				when 42 then -- loop condition:
						if not (l_j < a_count___2) then
							l_pos := -1 + 49 -- skip loop
						end
				when 43 then -- loop body:
						memmove (create {CE_VOID_POINTER}.make_cast (l_ptr.item), create {CE_VOID_POINTER}.make_cast (l_y_array[l_i___0]), l_yanklen.to_natural_32).do_nothing
						l_ptr.item := l_ptr.item + l_yanklen
						if not (l_j < a_count___2 - 1) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						l_pos := -1 + 47 -- goto _L___1
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 46 then -- else:
						if l_shortline.to_boolean then
							l_pos := -1 + 48 -- skip if block
						end
				when 47 then -- if: | _L___1:
						if l_spaces.to_boolean then
							(create {P_MISC2_STATIC}).copy_spaces (l_ptr.item, l_spaces.to_natural_32)
							l_ptr.item := l_ptr.item + l_spaces
						end
				when 48 then -- if done
						l_j := l_j + 1
						l_pos := -1 + 42 -- back to loop condition
				when 49 then -- loop done;
						(create {P_MISC2_STATIC}).copy_spaces (l_ptr.item, (l_bd.endspaces).to_natural_32)
						l_ptr.item := l_ptr.item + (l_bd.endspaces)
						memmove (create {CE_VOID_POINTER}.make_cast (l_ptr.item), create {CE_VOID_POINTER}.make_cast (((l_oldp + l_bd.textcol) + l_delcount)), (((l_oldlen - l_bd.textcol) - l_delcount) + 1).to_natural_32).do_nothing;
						(create {P_MEMLINE_STATIC}).ml_replace ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_newp, 0).do_nothing;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1
						if l_i___0 = 0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + (l_bd.startspaces)
						end
						l_i___0 := l_i___0 + 1
				when 50 then -- if done
						l_pos := -1 + 39 -- back to loop condition
				when 51 then -- loop done
						l_break := False;
						(create {P_MISC1_STATIC}).changed_lines (l_lnum.item, 0, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_nr_lines);
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum := l_lnum.item;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.col := (l_bd.textcol + l_totlen) - 1;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.coladd := 0
						if ((a_flags___0).bit_and (2)).to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end).twin;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1
							l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MEMLINE_STATIC}).ml_get_curline)))).to_integer_32
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > l_len then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_len
							end
						else
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_lnum.item
						end
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 83
				when 53 then -- else:
						if l_y_type = 0 then
							if l_dir___0 = 1 then
								if ((create {P_MISC1_STATIC}).gchar_cursor) /= 0 then
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_bytelen___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([((create {P_MEMLINE_STATIC}).ml_get_cursor)]))
										l_col.item := l_col.item + l_bytelen___0
										if l_yanklen.to_boolean then
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + l_bytelen___0;
											(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.col := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.col + l_bytelen___0
										end
									else
										l_col.item := l_col.item + 1
										if l_yanklen.to_boolean then
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1;
											(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.col := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.col) + 1
										end
									end
								end
							end
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
						elseif l_dir___0 = -1 then
							l_lnum.item := l_lnum.item - 1
						end
						l_new_cursor := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
						if l_y_type /= 0 then
							l_pos := -1 + 62 -- skip if block
						end
				when 54 then -- if:
						if l_y_size /= 1 then
							l_pos := -1 + 60 -- skip if block
						end
				when 55 then -- if:
						l_totlen := (a_count___2 * l_yanklen.to_integer_32).to_integer_32
						if not (l_totlen.to_boolean) then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						l_oldp := (create {P_MEMLINE_STATIC}).ml_get (l_lnum.item)
						l_newp := (create {P_MISC2_STATIC}).alloc_check (((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_oldp))) + l_totlen.to_natural_32) + {NATURAL_32} 1)
						if l_newp.is_void then
							l_pos := -1 + 84 -- goto end
						end
				when 57 then
						memmove (create {CE_VOID_POINTER}.make_cast (l_newp), create {CE_VOID_POINTER}.make_cast (l_oldp), (l_col.item).to_natural_32).do_nothing
						l_ptr.item := l_newp + l_col.item
						l_i___0 := 0
						from
						until
							not (l_i___0 < a_count___2)
						loop
							memmove (create {CE_VOID_POINTER}.make_cast (l_ptr.item), create {CE_VOID_POINTER}.make_cast (l_y_array[0]), l_yanklen.to_natural_32).do_nothing
							l_ptr.item := l_ptr.item + l_yanklen
							l_i___0 := l_i___0 + 1
						end
						memmove (create {CE_VOID_POINTER}.make_cast (l_ptr.item), create {CE_VOID_POINTER}.make_cast ((l_oldp + l_col.item)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_oldp + l_col.item)))) + {NATURAL_32} 1).do_nothing;
						(create {P_MEMLINE_STATIC}).ml_replace (l_lnum.item, l_newp, 0).do_nothing;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + (l_totlen - 1)
				when 58 then -- if done;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
						if l_totlen.to_boolean then
							if (create {P_GLOBALS_STATIC}).restart_edit.item /= 0 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1
							elseif ((a_flags___0).bit_and (2)).to_boolean then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1
							end
						end
						(create {P_MISC1_STATIC}).changed_bytes (l_lnum.item, l_col.item)
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 60 then -- else:
						l_pos := -1 + 62 -- goto _L___4
				when 61 then -- if done | if block done, skip else block:
						l_pos := -1 + 83
				when 62 then -- else: | _L___4:
						l_cnt := 1
				when 63 then -- loop condition:
						if not (not (l_return) and then (l_cnt <= a_count___2)) then
							l_pos := -1 + 82 -- skip loop
						end
				when 64 then -- loop body:
						l_i___0 := 0
						if l_y_type /= 0 then
							l_pos := -1 + 68 -- skip if block
						end
				when 65 then -- if:
						l_lnum.item := l_new_cursor.lnum
						l_ptr.item := ((create {P_MEMLINE_STATIC}).ml_get (l_lnum.item)) + l_col.item
						l_totlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_y_array[(l_y_size - 1)]))).to_integer_32
						l_newp := (create {P_MISC2_STATIC}).alloc_check (((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr.item))) + l_totlen.to_natural_32) + {NATURAL_32} 1)
						if l_newp.is_void then
							l_pos := -1 + 82 -- goto error
						end
				when 66 then
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_newp), create {CE_INTEGER_8_POINTER}.make_cast (l_y_array[(l_y_size - 1)])).do_nothing
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_newp), create {CE_INTEGER_8_POINTER}.make_cast (l_ptr.item)).do_nothing;
						(create {P_MEMLINE_STATIC}).ml_append (l_lnum.item, l_newp, 0, 0).do_nothing;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_newp))
						l_oldp := (create {P_MEMLINE_STATIC}).ml_get (l_lnum.item)
						l_newp := (create {P_MISC2_STATIC}).alloc_check (((l_col.item + l_yanklen) + 1).to_natural_32)
						if l_newp.is_void then
							l_pos := -1 + 82 -- goto error
						end
				when 67 then
						memmove (create {CE_VOID_POINTER}.make_cast (l_newp), create {CE_VOID_POINTER}.make_cast (l_oldp), (l_col.item).to_natural_32).do_nothing
						memmove (create {CE_VOID_POINTER}.make_cast ((l_newp + l_col.item)), create {CE_VOID_POINTER}.make_cast (l_y_array[0]), (l_yanklen + 1).to_natural_32).do_nothing;
						(create {P_MEMLINE_STATIC}).ml_replace (l_lnum.item, l_newp, 0).do_nothing;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_lnum.item
						l_i___0 := 1
				when 68 then -- if done
						if not (l_i___0 < l_y_size) then
							l_pos := -1 + 81 -- skip loop
						end
				when 69 then -- loop body:
						if l_y_type = 0 then
							l_pos := -1 + 72 -- skip if block
						end
				when 70 then -- if:
						l_pos := -1 + 73 -- goto _L___2
				when 71 then -- if block done, skip else block:
						l_pos := -1 + 74
				when 72 then -- else:
						if not (l_i___0 < l_y_size - 1) then
							l_pos := -1 + 74 -- skip if block
						end
				when 73 then -- if: | _L___2:
						if ((create {P_MEMLINE_STATIC}).ml_append (l_lnum.item, l_y_array[l_i___0], 0, 0)) = 0 then
							l_pos := -1 + 82 -- goto error
						end
				when 74 then -- if done
						l_lnum.item := l_lnum.item + 1
						l_nr_lines := l_nr_lines + 1
						if not (((a_flags___0).bit_and (1)).to_boolean) then
							l_pos := -1 + 80 -- skip if block
						end
				when 75 then -- if:
						l_old_pos := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_lnum.item
						l_ptr.item := (create {P_MEMLINE_STATIC}).ml_get (l_lnum.item)
						if l_cnt = a_count___2 then
							if l_i___0 = l_y_size - 1 then
								l_lendiff := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr.item))).to_integer_32
							end
						end
						if (l_ptr.item.item).to_integer_32 /= 35 then
							l_pos := -1 + 78 -- skip if block
						end
				when 76 then -- if:
						if (preprocs_left).to_boolean then
							l_indent := 0
						else
							l_pos := -1 + 78 -- goto _L___3
						end
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 79
				when 78 then -- else: | _L___3:
						if (l_ptr.item.item).to_integer_32 = 0 then
							l_indent := 0
						elseif l_first_indent.to_boolean then
							l_indent_diff := l_orig_indent - ((create {P_MISC1_STATIC}).get_indent)
							l_indent := l_orig_indent
							l_first_indent := 0
						else
							l_indent := ((create {P_MISC1_STATIC}).get_indent) + l_indent_diff
							if l_indent < 0 then
								l_indent := 0
							end
						end
				when 79 then;
						(create {P_MISC1_STATIC}).set_indent (l_indent, 0).do_nothing;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_old_pos.twin
						if l_cnt = a_count___2 then
							if l_i___0 = l_y_size - 1 then
								l_lendiff := l_lendiff - (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MEMLINE_STATIC}).ml_get (l_lnum.item))))).to_integer_32
							end
						end
				when 80 then -- if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 68 -- back to loop condition
				when 81 then -- loop done
						l_cnt := l_cnt + 1
						l_pos := -1 + 63 -- back to loop condition
				when 82 then -- error:
						if l_y_type = 1 then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.col := 0
							if l_dir___0 = 1 then
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum) + 1
							end
						end
						(create {P_MARK_STATIC}).mark_adjust ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum + (l_y_type = 0).to_integer, 2_147_483_647, l_nr_lines, 0)
						if l_y_type = 0 then
							(create {P_MISC1_STATIC}).changed_lines ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_col.item, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + 1, l_nr_lines)
						else
							(create {P_MISC1_STATIC}).changed_lines ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum, 0, (create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum, l_nr_lines)
						end
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.lnum := l_lnum.item
						l_col.item := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_y_array[(l_y_size - 1)]))).to_integer_32 - l_lendiff
						if l_col.item > 1 then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.col := l_col.item - 1
						else
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.col := 0
						end
						if ((a_flags___0).bit_and (4)).to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_lnum.item;
							(create {P_EDIT_STATIC}).beginline (5)
						elseif ((a_flags___0).bit_and (2)).to_boolean then
							if l_y_type = 1 then
								if l_lnum.item >= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
								else
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_lnum.item + 1
								end
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
							else
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_lnum.item;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_col.item
							end
						elseif l_y_type = 1 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
							if l_dir___0 = 1 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1
							end
							(create {P_EDIT_STATIC}).beginline (5)
						else
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_new_cursor.twin
						end
				when 83 then -- if done;
						(create {P_MISC1_STATIC}).msgmore (l_nr_lines);
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
				when 84 then -- end:
						if (l_allocated.item).to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_insert_string.item))
						end
						if l_regname___0.item = 61 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_y_array))
						end
						adjust_cursor_eol
				when 85 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	adjust_cursor_eol
		local
			l_scol: CE_ARRAY [INTEGER_32]
			l_ecol: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_scol.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_ecol.make (<<1>>)

			if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > 0 then
				if ((create {P_MISC1_STATIC}).gchar_cursor) = 0 then
					if (((create {P_OPTION_STATIC}).ve_flags.item.item).bit_and ({NATURAL_32} 8)) = {NATURAL_32} 0 then
						if not ((create {P_GLOBALS_STATIC}).restart_edit.item).to_boolean then
							if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
								(create {P_MISC2_STATIC}).dec_cursor.do_nothing
								if (create {P_OPTION_STATIC}).ve_flags.item.item = {NATURAL_32} 4 then
									((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), l_scol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_ecol);
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := (l_ecol.item - l_scol.item) + 1
								end
							end
						end
					end
				end
			end
		end

	preprocs_left: INTEGER_32
		local
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_si).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cin).to_boolean then
							l_tmp___0 := 1
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cin).to_boolean then
							if ((create {P_EDIT_STATIC}).in_cinkeys (('#').code, (' ').code, 1)).to_boolean then
								l_tmp___0 := 1
							else
								l_tmp___0 := 0
							end
						else
							l_tmp___0 := 0
						end
				when 4 then
					Result := l_tmp___0
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_register_name (a_num: INTEGER_32): INTEGER_32
		do
			if a_num = -1 then
				Result := (('%"').code)
			elseif a_num < 10 then
				Result := (a_num + 48)
			elseif a_num = 36 then
				Result := (('-').code)
			elseif a_num = 37 then
				Result := (('*').code)
			elseif a_num = 38 then
				Result := (('+').code)
			else
				Result := ((a_num + 97) - 10)
			end
		end

	do_join (a_count___2: INTEGER_32; a_insert_space, a_save_undo: INTEGER_32): INTEGER_32
		local
			l_curr: CE_POINTER [NATURAL_8]
			l_cend: CE_POINTER [NATURAL_8]
			l_newp: CE_POINTER [NATURAL_8]
			l_spaces: CE_POINTER [NATURAL_8]
			l_endcurr1: INTEGER_32
			l_endcurr2: INTEGER_32
			l_currsize: INTEGER_32
			l_sumsize: INTEGER_32
			l_t: INTEGER_32
			l_col: INTEGER_32
			l_ret: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___9: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_curr := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_endcurr1 := ('%/0/').code
					l_endcurr2 := ('%/0/').code
					l_currsize := 0
					l_sumsize := 0
					l_col := 0
					l_ret := 1
					if a_save_undo.to_boolean then
						if ((create {P_UNDO_STATIC}).u_save ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + a_count___2)) = 0 then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_spaces := (create {P_MISC2_STATIC}).lalloc_clear (a_count___2.to_natural_32, 1)
						if l_spaces.is_void then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 25 -- skip if block
					end
				when 1 then -- if:
						l_t := (0).to_integer_32
				when 2 then -- loop condition:
						if not (l_t < a_count___2) then
							l_pos := -1 + 23 -- skip loop
						end
				when 3 then -- loop body:
						l_curr := (create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + l_t)
						if not (a_insert_space.to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 4 then -- if:
						if not (l_t > 0) then
							l_pos := -1 + 21 -- skip if block
						end
				when 5 then -- if:
						l_curr := (create {P_CHARSET_STATIC}).skipwhite (l_curr)
						if (l_curr.item).to_integer_32 = 41 then
							l_pos := -1 + 21 -- skip if block
						end
				when 6 then -- if:
						if l_currsize = 0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 7 then -- if:
						if l_endcurr1 = 9 then
							l_pos := -1 + 21 -- skip if block
						end
				when 8 then -- if:
						if not (((create {P_OPTION_STATIC}).has_format_option (('M').code)).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 9 then -- if:
						if not (((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_curr])) < 256) then
							l_pos := -1 + 19 -- skip if block
						end
				when 10 then -- if:
						if not (l_endcurr1 < 256) then
							l_pos := -1 + 19 -- skip if block
						end
				when 11 then -- if: | _L___0:
						if not (((create {P_OPTION_STATIC}).has_format_option (('B').code)).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 12 then -- if:
						if not (((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_curr])) < 256) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if not (l_endcurr1 < 256) then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L:
						if l_endcurr1 = 32 then
							l_endcurr1 := l_endcurr2
						else
							l_spaces[l_t] := ((l_spaces[l_t]).to_integer_32 + 1).to_natural_8
						end
						if ((create {P_OPTION_STATIC}).p_js.item.item).to_boolean then
							if l_endcurr1 = 46 then
								l_spaces[l_t] := ((l_spaces[l_t]).to_integer_32 + 1).to_natural_8
							elseif ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('j').code)).is_void then
								if l_endcurr1 = 63 then
									l_spaces[l_t] := ((l_spaces[l_t]).to_integer_32 + 1).to_natural_8
								elseif l_endcurr1 = 33 then
									l_spaces[l_t] := ((l_spaces[l_t]).to_integer_32 + 1).to_natural_8
								end
							end
						end
				when 17 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_pos := -1 + 16 -- goto _L
				when 19 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_pos := -1 + 11 -- goto _L___0
				when 21 then -- if done | if done | if done | if done | if done
						l_currsize := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_curr))).to_integer_32
						l_sumsize := l_sumsize + (l_currsize + (l_spaces[l_t]).to_integer_32)
						l_endcurr2 := ('%/0/').code
						l_endcurr1 := l_endcurr2
						if a_insert_space.to_boolean then
							if l_currsize > 0 then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_cend := l_curr + l_currsize
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_tmp___7 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_curr, l_cend - 1])) + 1
									else
										l_tmp___7 := 1
									end
									l_cend := l_cend - l_tmp___7
									l_endcurr1 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_cend])
									if (l_cend.c_pointer.to_integer_32).to_natural_32 > (l_curr.c_pointer.to_integer_32).to_natural_32 then
										if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
											l_tmp___9 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_curr, l_cend - 1])) + 1
										else
											l_tmp___9 := 1
										end
										l_cend := l_cend - l_tmp___9
										l_endcurr2 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_cend])
									end
								else
									l_endcurr1 := ((l_curr + l_currsize)[-1]).to_integer_32
									if l_currsize > 1 then
										l_endcurr2 := ((l_curr + l_currsize)[-2]).to_integer_32
									end
								end
							end
						end
						(create {P_MISC1_STATIC}).line_breakcheck
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_ret := 0
							l_pos := -1 + 24 -- goto theend
						end
				when 22 then
						l_t := l_t + 1
						l_pos := -1 + 2 -- back to loop condition
				when 23 then -- loop done
						l_col := (l_sumsize - l_currsize) - (l_spaces[(a_count___2 - 1)]).to_integer_32
						l_newp := (create {P_MISC2_STATIC}).alloc_check ((l_sumsize + 1).to_natural_32)
						l_cend := l_newp + l_sumsize
						l_cend.item := (0).to_natural_8
						l_t := a_count___2 - 1
						from
						until
							(l_break)
						loop
							l_break := False
							l_cend := l_cend - l_currsize
							memmove (create {CE_VOID_POINTER}.make_cast (l_cend), create {CE_VOID_POINTER}.make_cast (l_curr), l_currsize.to_natural_32).do_nothing
							if (l_spaces[l_t]).to_integer_32 > 0 then
								l_cend := l_cend - (l_spaces[l_t]).to_integer_32;
								(create {P_MISC2_STATIC}).copy_spaces (l_cend, (l_spaces[l_t]).to_natural_32)
							end
							(create {P_MARK_STATIC}).mark_col_adjust ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + l_t, 0, -l_t, ((l_cend.distance (l_newp)) + (l_spaces[l_t]).to_integer_32).to_integer_32)
							if l_t = 0 then
								l_break := True
							end
							if not (l_break) then
								l_curr := (create {P_MEMLINE_STATIC}).ml_get (((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + l_t) - 1)
								if a_insert_space.to_boolean then
									if l_t > 1 then
										l_curr := (create {P_CHARSET_STATIC}).skipwhite (l_curr)
									end
								end
								l_currsize := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_curr))).to_integer_32
								l_t := l_t - 1
							end
						end
						l_break := False;
						(create {P_MEMLINE_STATIC}).ml_replace ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_newp, 0).do_nothing;
						(create {P_MISC1_STATIC}).changed_lines ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_currsize, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + 1, 0)
						l_t := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1;
						(create {P_MISC1_STATIC}).del_lines (a_count___2 - 1, 0);
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_t
						if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('q').code)).is_void then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_currsize
						else
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_col
						end
						(create {P_MISC2_STATIC}).check_cursor_col;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
				when 24 then -- theend:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_spaces))
						Result := l_ret
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	same_leader (a_lnum: INTEGER_32; a_leader1_len: INTEGER_32; a_leader1_flags: CE_POINTER [NATURAL_8]; a_leader2_len: INTEGER_32; a_leader2_flags: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_idx1: INTEGER_32
			l_idx2: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_line1: CE_POINTER [NATURAL_8]
			l_line2: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_idx1 := 0
					l_idx2 := 0
					if a_leader1_len = 0 then
						Result := (a_leader2_len = 0).to_integer
						l_return := True
					end
					if not l_return and then (not a_leader1_flags.is_void) then
						l_p___0 := a_leader1_flags
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if (l_p___0.item).to_boolean then
								if (l_p___0.item).to_integer_32 = 58 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								if (l_p___0.item).to_integer_32 = 102 then
									Result := (a_leader2_len = 0).to_integer
									l_return := True
								end
								if not l_return and then ((l_p___0.item).to_integer_32 = 101) then
									Result := 0
									l_return := True
								end
								if not l_return and then ((l_p___0.item).to_integer_32 = 115) then
									if (((create {P_MEMLINE_STATIC}).ml_get (a_lnum))[a_leader1_len]).to_integer_32 = 0 then
										Result := 0
										l_return := True
									end
									if not l_return then
										if a_leader2_flags.is_void then
											Result := 0
											l_return := True
										elseif a_leader2_len = 0 then
											Result := 0
											l_return := True
										end
									end
									if not l_return then
										l_p___0 := a_leader2_flags
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											if (l_p___0.item).to_boolean then
												if (l_p___0.item).to_integer_32 = 58 then
													l_break := True
												end
											else
												l_break := True
											end
											if not (l_return or l_break) then
												if (l_p___0.item).to_integer_32 = 109 then
													Result := 1
													l_return := True
												end
												if not l_return then
													l_p___0 := l_p___0 + 1
												end
											end
										end
									end
									if not l_return then
										l_break := False
										Result := 0
										l_return := True
									end
								end
								if not l_return then
									l_p___0 := l_p___0 + 1
								end
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l_line1 := (create {P_MISC2_STATIC}).vim_strsave (((create {P_MEMLINE_STATIC}).ml_get (a_lnum)))
						if l_line1.is_void then
							l_pos := -1 + 13 -- skip if block
						end
				when 2 then -- if:
						l_idx1 := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_line1[l_idx1]).to_integer_32 /= 32 then
								if (l_line1[l_idx1]).to_integer_32 /= 9 then
									l_break := True
								end
							end
							if not (l_return or l_break) then
								l_idx1 := l_idx1 + 1
							end
						end
						l_break := False
						l_line2 := (create {P_MEMLINE_STATIC}).ml_get (a_lnum + 1)
						l_idx2 := 0
				when 3 then -- loop condition:
						if not (not (l_return or l_break) and then (l_idx2 < a_leader2_len)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						if (l_line2[l_idx2]).to_integer_32 /= 32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if (l_line2[l_idx2]).to_integer_32 /= 9 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_line1[l_idx1]).to_integer_32 /= 32 then
								if (l_line1[l_idx1]).to_integer_32 /= 9 then
									l_break := True
								end
							end
							if not (l_return or l_break) then
								l_idx1 := l_idx1 + 1
							end
						end
						l_break := False
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_tmp___1 := l_idx1
						l_idx1 := l_idx1 + 1
						if (l_line1[l_tmp___1]).to_integer_32 /= (l_line2[l_idx2]).to_integer_32 then
							l_break := True
						end
				when 11 then -- if done
						if not (l_return or l_break) then
							l_idx2 := l_idx2 + 1
						end
						l_pos := -1 + 3 -- back to loop condition
				when 12 then -- loop done
						l_break := False;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_line1))
				when 13 then -- if done
						if l_idx2 = a_leader2_len then
							if l_idx1 = a_leader1_len then
								l_tmp___2 := 1
							else
								l_tmp___2 := 0
							end
						else
							l_tmp___2 := 0
						end
						Result := l_tmp___2
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	fex_format (a_lnum, a_count___2: INTEGER_32; a_c: INTEGER_32): INTEGER_32
		local
			l_use_sandbox: INTEGER_32
			l_r: INTEGER_32
		do
			l_use_sandbox := ((create {P_OPTION_STATIC}).was_set_insecurely (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("formatexpr")), 4));
			(create {P_EVAL_STATIC}).set_vim_var_nr (9, a_lnum);
			(create {P_EVAL_STATIC}).set_vim_var_nr (0, a_count___2);
			(create {P_EVAL_STATIC}).set_vim_var_char (a_c)
			if l_use_sandbox.to_boolean then
				(create {P_GLOBALS_STATIC}).sandbox.item := (create {P_GLOBALS_STATIC}).sandbox.item + 1
			end
			l_r := (create {P_EVAL_STATIC}).eval_to_number ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_fex)
			if l_use_sandbox.to_boolean then
				(create {P_GLOBALS_STATIC}).sandbox.item := (create {P_GLOBALS_STATIC}).sandbox.item - 1
			end
			(create {P_EVAL_STATIC}).set_vim_var_string (48, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), -1)
			Result := l_r
		end

	format_lines (a_line_count: INTEGER_32; a_avoid_fex: INTEGER_32)
		local
			l_max_len: INTEGER_32
			l_is_not_par: INTEGER_32
			l_next_is_not_par: INTEGER_32
			l_is_end_par: INTEGER_32
			l_prev_is_end_par: INTEGER_32
			l_next_is_start_par: INTEGER_32
			l_leader_len: CE_ARRAY [INTEGER_32]
			l_next_leader_len: CE_ARRAY [INTEGER_32]
			l_leader_flags: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_next_leader_flags: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_do_comments: INTEGER_32
			l_advance: INTEGER_32
			l_second_indent: INTEGER_32
			l_do_second_indent: INTEGER_32
			l_do_number_indent: INTEGER_32
			l_do_trail_white: INTEGER_32
			l_first_par_line: INTEGER_32
			l_smd_save: INTEGER_32
			l_count___2: INTEGER_32
			l_need_set_indent: INTEGER_32
			l_force_format: INTEGER_32
			l_old_State: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_leader_len.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_next_leader_len.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_leader_flags.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_next_leader_flags.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_prev_is_end_par := 0
					l_next_is_start_par := 0
					l_leader_len.item := 0
					l_leader_flags.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_advance := 1
					l_second_indent := -1
					l_first_par_line := 1
					l_need_set_indent := 1
					l_force_format := 0
					l_old_State := (create {P_GLOBALS_STATIC}).State.item
					l_max_len := ((create {P_EDIT_STATIC}).comp_textwidth (1)) * 3
					l_do_comments := (create {P_OPTION_STATIC}).has_format_option (('q').code)
					l_do_second_indent := (create {P_OPTION_STATIC}).has_format_option (('2').code)
					l_do_number_indent := (create {P_OPTION_STATIC}).has_format_option (('n').code)
					l_do_trail_white := (create {P_OPTION_STATIC}).has_format_option (('w').code)
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > 1 then
						l_is_not_par := fmt_check_par ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1, l_leader_len, l_leader_flags, l_do_comments)
					else
						l_is_not_par := 1
					end
					l_next_is_not_par := fmt_check_par ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_next_leader_len, l_next_leader_flags, l_do_comments)
					if l_is_not_par.to_boolean then
						l_tmp___0 := 1
					elseif l_next_is_not_par.to_boolean then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
					l_is_end_par := l_tmp___0
					if not l_is_end_par.to_boolean then
						if l_do_trail_white.to_boolean then
							if (ends_in_white ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1)).to_boolean then
								l_tmp___2 := 0
							else
								l_tmp___2 := 1
							end
							l_is_end_par := l_tmp___2
						end
					end
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1
					l_count___2 := a_line_count
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 26 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if l_count___2 /= 0 then
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 25 -- skip if block
						end
				when 3 then -- if:
						if l_advance.to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1
							l_prev_is_end_par := l_is_end_par
							l_is_not_par := l_next_is_not_par
							l_leader_len.item := l_next_leader_len.item
							l_leader_flags.item := l_next_leader_flags.item
						end
						if l_count___2 = 1 then
							l_next_is_not_par := 1
							l_next_leader_len.item := 0
							l_next_leader_flags.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							l_next_is_not_par := 1
							l_next_leader_len.item := 0
							l_next_leader_flags.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						else
							l_next_is_not_par := fmt_check_par ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + 1, l_next_leader_len, l_next_leader_flags, l_do_comments)
							if l_do_number_indent.to_boolean then
								l_next_is_start_par := (((create {P_MISC1_STATIC}).get_number_indent ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + 1)) > 0).to_integer
							end
						end
						l_advance := 1
						if l_is_not_par.to_boolean then
							l_tmp___4 := 1
						elseif l_next_is_not_par.to_boolean then
							l_tmp___4 := 1
						elseif l_next_is_start_par.to_boolean then
							l_tmp___4 := 1
						else
							l_tmp___4 := 0
						end
						l_is_end_par := l_tmp___4
						if not l_is_end_par.to_boolean then
							if l_do_trail_white.to_boolean then
								if (ends_in_white ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)).to_boolean then
									l_tmp___6 := 0
								else
									l_tmp___6 := 1
								end
								l_is_end_par := l_tmp___6
							end
						end
						if not (l_is_not_par.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_line_count < 0 then
							l_break := True
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 6 then -- else:
						if not (l_first_par_line.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 7 then -- if:
						if not (l_do_second_indent.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L___0
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 10 then -- else:
						if not (l_do_number_indent.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 11 then -- if: | _L___0:
						if not (l_prev_is_end_par.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 12 then -- if:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count) then
							l_pos := -1 + 19 -- skip if block
						end
				when 13 then -- if:
						if l_leader_len.item /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if l_next_leader_len.item /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 15 then -- if:
						if not (l_do_second_indent.to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if (((create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + 1)).item).to_integer_32 = 0 then
							l_pos := -1 + 18 -- goto _L
						else
							l_second_indent := (create {P_MISC1_STATIC}).get_indent_lnum ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + 1)
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:
						if l_do_number_indent.to_boolean then
							l_second_indent := (create {P_MISC1_STATIC}).get_number_indent ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)
						end
				when 19 then -- if done | if done | if done | if done | if done | if done | if done
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum >= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							l_is_end_par := 1
						elseif not (same_leader ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_leader_len.item, l_leader_flags.item, l_next_leader_len.item, l_next_leader_flags.item)).to_boolean then
							l_is_end_par := 1
						end
						if not (l_is_end_par.to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___1
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 22 then -- else:
						if not (l_force_format.to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 23 then -- if: | _L___1:
						if l_need_set_indent.to_boolean then
							(create {P_MISC1_STATIC}).set_indent (((create {P_MISC1_STATIC}).get_indent), 1).do_nothing
						end
						(create {P_GLOBALS_STATIC}).State.item := 1;
						(create {P_MISC2_STATIC}).coladvance ((2_147_483_647).to_integer_32).do_nothing
						from
						until
							(l_break)
						loop
							l_break := False
							if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col).to_boolean then
								if not ((create {P_MISC2_STATIC}).vim_isspace (((create {P_MISC1_STATIC}).gchar_cursor))).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								(create {P_MISC2_STATIC}).dec_cursor.do_nothing
							end
						end
						l_break := False;
						(create {P_GLOBALS_STATIC}).State.item := 16
						l_smd_save := (create {P_OPTION_STATIC}).p_smd.item.item;
						(create {P_OPTION_STATIC}).p_smd.item.item := 0
						if l_do_comments.to_boolean then
							l_tmp___12 := 2
						else
							l_tmp___12 := 0
						end
						if a_avoid_fex.to_boolean then
							l_tmp___13 := 8
						else
							l_tmp___13 := 0
						end
						(create {P_EDIT_STATIC}).insertchar (('%/0/').code, (1 + l_tmp___12) + l_tmp___13, l_second_indent);
						(create {P_GLOBALS_STATIC}).State.item := l_old_State;
						(create {P_OPTION_STATIC}).p_smd.item.item := l_smd_save
						l_second_indent := -1
						l_need_set_indent := l_is_end_par
						if l_is_end_par.to_boolean then
							if a_line_count < 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_first_par_line := 1
							end
						end
						if not (l_return or l_break) then
							l_force_format := 0
						end
				when 24 then -- if done
						if not (l_return or l_break) and then (not l_is_end_par.to_boolean) then
							l_advance := 0;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
							if a_line_count < 0 then
								if ((create {P_UNDO_STATIC}).u_save_cursor) = 0 then
									l_break := True
								end
							end
							if not (l_return or l_break) then
								(create {P_MISC1_STATIC}).del_bytes ((l_next_leader_len.item).to_integer_32, 0, 0).do_nothing
								if l_next_leader_len.item > 0 then
									(create {P_MARK_STATIC}).mark_col_adjust ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 0, 0, (-l_next_leader_len.item).to_integer_32)
								end
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1
								if (do_join (2, 1, 0)) = 0 then
									(create {P_MISC1_STATIC}).beep_flush
									l_break := True
								end
							end
							if not (l_return or l_break) then
								l_first_par_line := 0
								if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MEMLINE_STATIC}).ml_get_curline)))) > l_max_len.to_natural_32 then
									l_force_format := 1
								else
									l_force_format := 0
								end
							end
						end
				when 25 then -- if done | if done
						if not (l_return or l_break) then
							(create {P_MISC1_STATIC}).line_breakcheck
							l_count___2 := l_count___2 - 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 26 then -- loop done
					l_break := False
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ends_in_white (a_lnum: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_l: NATURAL_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			l_s := ((create {P_MEMLINE_STATIC}).ml_get (a_lnum))
			if (l_s.item).to_integer_32 = 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))) - {NATURAL_32} 1
				if (l_s[l_l.to_integer_32]).to_integer_32 = 32 then
					l_tmp___1 := 1
				elseif (l_s[l_l.to_integer_32]).to_integer_32 = 9 then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
				Result := l_tmp___1
			end
		end

	fmt_check_par (a_lnum: INTEGER_32; a_leader_len: CE_POINTER [INTEGER_32]; a_leader_flags: CE_POINTER [CE_POINTER [NATURAL_8]]; a_do_comments: INTEGER_32): INTEGER_32
		require
			not a_leader_len.is_void
		local
			l_flags___0: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_flags___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_ptr := (create {P_MEMLINE_STATIC}).ml_get (a_lnum)
					if a_do_comments.to_boolean then
						a_leader_len.item := (create {P_MISC1_STATIC}).get_leader_len (l_ptr, a_leader_flags, 0)
					else
						a_leader_len.item := 0
					end
					if a_leader_len.item > 0 then
						l_flags___0 := a_leader_flags.item
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_flags___0.item).to_boolean then
								if (l_flags___0.item).to_integer_32 /= 58 then
									if (l_flags___0.item).to_integer_32 = 101 then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_flags___0 := l_flags___0 + 1
							end
						end
						l_break := False
					end
					if (((create {P_CHARSET_STATIC}).skipwhite (l_ptr + a_leader_len.item)).item).to_integer_32 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_tmp___1 := 1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_leader_len.item > 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (l_flags___0.item).to_integer_32 = 101 then
							l_tmp___1 := 1
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if ((create {P_SEARCH_STATIC}).startPS (a_lnum, ('%/0/').code, 0)).to_boolean then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
				when 7 then -- if done
					Result := l_tmp___1
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	paragraph_start (a_lnum: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_leader_len: CE_ARRAY [INTEGER_32]
			l_leader_flags: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_next_leader_len: CE_ARRAY [INTEGER_32]
			l_next_leader_flags: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_do_comments: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_leader_len.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_leader_flags.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_next_leader_len.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_next_leader_flags.make (<<1>>)

			l_leader_len.item := 0
			l_leader_flags.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if a_lnum <= 1 then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_p___0 := (create {P_MEMLINE_STATIC}).ml_get (a_lnum - 1)
				if (l_p___0.item).to_integer_32 = 0 then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				l_do_comments := (create {P_OPTION_STATIC}).has_format_option (('q').code)
				if (fmt_check_par (a_lnum - 1, l_leader_len, l_leader_flags, l_do_comments)).to_boolean then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				if (fmt_check_par (a_lnum, l_next_leader_len, l_next_leader_flags, l_do_comments)).to_boolean then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				if ((create {P_OPTION_STATIC}).has_format_option (('w').code)).to_boolean then
					if not (ends_in_white (a_lnum - 1)).to_boolean then
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return then
				if ((create {P_OPTION_STATIC}).has_format_option (('n').code)).to_boolean then
					if ((create {P_MISC1_STATIC}).get_number_indent (a_lnum)) > 0 then
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return then
				if not (same_leader (a_lnum - 1, l_leader_len.item, l_leader_flags.item, l_next_leader_len.item, l_next_leader_flags.item)).to_boolean then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	write_viminfo_registers (a_fp: CE_POINTER [SD_IO_FILE])
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_type: CE_POINTER [NATURAL_8]
			l_c: NATURAL_8
			l_num_lines: INTEGER_32
			l_max_num_lines: INTEGER_32
			l_max_kbyte: INTEGER_32
			l_len: INTEGER_32
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					fputs ((gettext (ce_string ("%N# Registers:%N"))), a_fp).do_nothing
					l_max_num_lines := (create {P_OPTION_STATIC}).get_viminfo_parameter (('<').code)
					if l_max_num_lines < 0 then
						l_max_num_lines := (create {P_OPTION_STATIC}).get_viminfo_parameter (('%"').code)
					end
					if l_max_num_lines = 0 then
						l_return := True
					end
					if not l_return then
						l_max_kbyte := (create {P_OPTION_STATIC}).get_viminfo_parameter (('s').code)
						if l_max_kbyte = 0 then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_i___0 := 0
				when 2 then -- loop condition:
						if not (not (l_return) and then (l_i___0 < 40)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 3 then -- loop body:
						l_continue := False
						if (y_regs.item[l_i___0].y_array).is_void then
							l_continue := True
						end
						if not (l_return or l_continue) then
							if l_i___0 = 37 then
								l_continue := True
							elseif l_i___0 = 38 then
								l_continue := True
							end
						end
						if not (l_return or l_continue) and then (l_i___0 = 39) then
							l_continue := True
						end
						if not (l_return or l_continue) then
							l_num_lines := (y_regs.item[l_i___0].y_size).to_integer_32
							if l_num_lines = 0 then
								l_continue := True
							elseif l_num_lines = 1 then
								if (y_regs.item[l_i___0].y_type).to_integer_32 = 0 then
									if ((y_regs.item[l_i___0].y_array[0]).item).to_integer_32 = 0 then
										l_continue := True
									end
								end
							end
						end
						if not (l_return or l_continue) and then (l_max_kbyte > 0) then
							l_len := 0
							l_j := 0
							from
							until
								not (l_j < l_num_lines)
							loop
								l_len := l_len + ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (y_regs.item[l_i___0].y_array[l_j]))).to_integer_32 + 1)
								l_j := l_j + 1
							end
							if l_len > l_max_kbyte.to_integer_32 * 1_024 then
								l_continue := True
							end
						end
						if (l_return or l_continue) then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						inspect (y_regs.item[l_i___0].y_type).to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 5
						when 0 then l_pos := -1 + 6
						when 2 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 5 then -- switch 1, case 1
						l_type := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("LINE"))
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 0
						l_type := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("CHAR"))
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 2
						l_type := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("BLOCK"))
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, default:
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("E574: Unknown register type %%d"))), (y_regs.item[l_i___0].y_type).to_integer_32]).do_nothing;
						(create {P_MESSAGE_STATIC}).emsg ((create {P_GLOBALS_STATIC}).IObuff.item).do_nothing
						l_type := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("LINE"))
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done:
						if y_previous.item.is_equal (y_regs.item + l_i___0) then
							fprintf ([a_fp, ce_string ("%"")]).do_nothing
						end
						l_c := (get_register_name (l_i___0)).to_natural_8
						fprintf ([a_fp, ce_string ("%"%%c"), l_c.to_integer_32]).do_nothing
						if l_c.to_integer_32 = execreg_lastc.item then
							fprintf ([a_fp, ce_string ("@")]).do_nothing
						end
						fprintf ([a_fp, ce_string ("%T%%s%T%%d%N"), l_type, y_regs.item[l_i___0].y_width]).do_nothing
						if l_max_num_lines > 0 then
							if l_num_lines > l_max_num_lines then
								l_num_lines := l_max_num_lines
							end
						end
						l_j := 0
						from
						until
							not (l_j < l_num_lines)
						loop
							IO_putc (('%T').code, a_fp).do_nothing;
							(create {P_EX_CMDS_STATIC}).viminfo_writestring (a_fp, y_regs.item[l_i___0].y_array[l_j])
							l_j := l_j + 1
						end
				when 10 then -- if done
						if (not l_return) then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 11 then -- loop done
						l_continue := False
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	x11_export_final_selection
		local
			l_dpy: CE_POINTER [ANY]
			l_str___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_len: CE_ARRAY [NATURAL_32]
			l_motion_type: INTEGER_32
			l_vc: CE_ARRAY [PD_VIMCONV_T]
			l_intlen: CE_ARRAY [INTEGER_32]
			l_conv_str: CE_POINTER [NATURAL_8]
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_str___1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_len.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_VIMCONV_T]} l_vc.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_intlen.make (<<1>>)

			l_str___1.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_len.item := (0).to_natural_32
			l_motion_type := -1
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
					l_dpy := ((create {P_GUI_GTK_X11_STATIC}).gui_mch_get_display)
				else
					l_dpy := (create {P_GLOBALS_STATIC}).xterm_dpy.item.item
				end
			else
				l_dpy := (create {P_GLOBALS_STATIC}).xterm_dpy.item.item
			end
			if ((create {P_GLOBALS_STATIC}).clip_plus.item.item.owned).to_boolean then
				l_motion_type := clip_convert_selection (l_str___1, l_len, (create {P_GLOBALS_STATIC}).clip_plus.item)
			elseif ((create {P_GLOBALS_STATIC}).clip_star.item.item.owned).to_boolean then
				l_motion_type := clip_convert_selection (l_str___1, l_len, (create {P_GLOBALS_STATIC}).clip_star.item)
			end
			if not l_dpy.is_void then
				if not (l_str___1.item).is_void then
					if l_motion_type >= 0 then
						if l_len.item < {NATURAL_32} 1_048_576 then
							if l_len.item > {NATURAL_32} 0 then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_vc.item.vc_type := 0
									if (l_vc.item.convert_setup ((create {P_OPTION_STATIC}).p_enc.item.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("latin1")))) = 1 then
										l_intlen.item := (l_len.item).to_integer_32
										l_conv_str := (create {P_MBYTE_STATIC}).string_convert (l_vc, l_str___1.item, l_intlen)
										l_len.item := (l_intlen.item).to_natural_32
										if not l_conv_str.is_void then
											(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_str___1.item))
											l_str___1.item := l_conv_str
										end
										l_vc.item.convert_setup (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)).do_nothing
									end
								end
								XStoreBuffer (l_dpy, create {CE_INTEGER_8_POINTER}.make_cast (l_str___1.item), (l_len.item).to_integer_32, 0).do_nothing
								XFlush (l_dpy).do_nothing
							end
						end
					end
				end
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_str___1.item))
		end

	clip_free_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		local
			l_y_ptr: CE_POINTER [PD_YANKREG]
		do
			l_y_ptr := y_current.item
			if a_cbd.is_equal ((create {P_GLOBALS_STATIC}).clip_plus.item) then
				y_current.item := y_regs.item + 38
			else
				y_current.item := y_regs.item + 37
			end
			free_yank_all
			y_current.item.item.y_size := (0).to_integer_32
			y_current.item := l_y_ptr
		end

	clip_yank_selection (a_type: INTEGER_32; a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		local
			l_y_ptr: CE_POINTER [PD_YANKREG]
		do
			if a_cbd.is_equal ((create {P_GLOBALS_STATIC}).clip_plus.item) then
				l_y_ptr := y_regs.item + 38
			else
				l_y_ptr := y_regs.item + 37
			end
			clip_free_selection (a_cbd)
			l_y_ptr.item.str_to_reg (a_type, a_str___1, a_len, 0)
		end

	clip_convert_selection (a_str___1: CE_POINTER [CE_POINTER [NATURAL_8]]; a_len: CE_POINTER [NATURAL_32]; a_cbd: CE_POINTER [PD_VIMCLIPBOARD]): INTEGER_32
		require
			not a_str___1.is_void
			not a_len.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_eolsize: NATURAL_32
			l_y_ptr: CE_POINTER [PD_YANKREG]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			if a_cbd.is_equal ((create {P_GLOBALS_STATIC}).clip_plus.item) then
				l_y_ptr := y_regs.item + 38
			else
				l_y_ptr := y_regs.item + 37
			end
			l_eolsize := (1).to_natural_32
			a_str___1.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			a_len.item := (0).to_natural_32
			if (l_y_ptr.item.y_array).is_void then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_i___0 := 0
				from
				until
					not (l_i___0.to_integer_32 < l_y_ptr.item.y_size)
				loop
					a_len.item := a_len.item + ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_y_ptr.item.y_array[l_i___0]))).to_natural_32 + l_eolsize.to_natural_32)
					l_i___0 := l_i___0 + 1
				end
				if (l_y_ptr.item.y_type).to_integer_32 = 0 then
					if a_len.item >= l_eolsize.to_natural_32 then
						a_len.item := a_len.item - l_eolsize.to_natural_32
					end
				end
				l_tmp___0 := (create {P_MISC2_STATIC}).lalloc (a_len.item + {NATURAL_32} 1, 1)
				a_str___1.item := l_tmp___0
				l_p___0 := l_tmp___0
				if l_p___0.is_void then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_lnum := 0
				l_i___0 := 0
				l_j := 0
				from
				until
					not (l_i___0 < (a_len.item).to_integer_32)
				loop
					if ((l_y_ptr.item.y_array[l_lnum])[l_j]).to_integer_32 = 10 then
						l_p___0[l_i___0] := (('%/0/').code).to_natural_8
					elseif ((l_y_ptr.item.y_array[l_lnum])[l_j]).to_integer_32 = 0 then
						l_p___0[l_i___0] := (('%N').code).to_natural_8
						l_lnum := l_lnum + 1
						l_j := -1
					else
						l_p___0[l_i___0] := (l_y_ptr.item.y_array[l_lnum])[l_j]
					end
					l_i___0 := l_i___0 + 1
					l_j := l_j + 1
				end
				Result := (l_y_ptr.item.y_type).to_integer_32
			end
		end

	may_set_selection
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (y_current.item.is_equal (y_regs.item + 37)) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_GLOBALS_STATIC}).clip_star.item.item.available).to_boolean then
							((create {P_GLOBALS_STATIC}).clip_star.item).item.clip_own_selection;
							(create {P_UI_STATIC}).clip_gen_set_selection ((create {P_GLOBALS_STATIC}).clip_star.item)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if y_current.item.is_equal (y_regs.item + 38) then
							if ((create {P_GLOBALS_STATIC}).clip_plus.item.item.available).to_boolean then
								((create {P_GLOBALS_STATIC}).clip_plus.item).item.clip_own_selection;
								(create {P_UI_STATIC}).clip_gen_set_selection ((create {P_GLOBALS_STATIC}).clip_plus.item)
							end
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dnd_yank_drag_data (a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_curr: CE_POINTER [PD_YANKREG]
		do
			l_curr := y_current.item
			y_current.item := y_regs.item + 39
			free_yank_all
			y_current.item.item.str_to_reg (0, a_str___1, a_len, 0)
			y_current.item := l_curr
		end

	get_reg_type (a_regname___0: INTEGER_32; a_reglen: CE_POINTER [INTEGER_32]): NATURAL_8
		local
			l_regname___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_regname___0 := a_regname___0
					inspect l_regname___0 -- switch 1 head
					when 37 then l_pos := -1 + 1
					when 35 then l_pos := -1 + 1
					when 61 then l_pos := -1 + 1
					when 58 then l_pos := -1 + 1
					when 47 then l_pos := -1 + 1
					when 46 then l_pos := -1 + 1
					when 6 then l_pos := -1 + 1
					when 16 then l_pos := -1 + 1
					when 23 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 1
					when 95 then l_pos := -1 + 1
					else l_pos := -1 + 2
					end
				when 1 then -- switch 1, case 37 | switch 1, case 35 | switch 1, case 61 | switch 1, case 58 | switch 1, case 47 | switch 1, case 46 | switch 1, case 6 | switch 1, case 16 | switch 1, case 23 | switch 1, case 1 | switch 1, case 95
					Result := (0).to_natural_8
					l_return := True
				when 2 then -- switch 1, done:
					if not l_return then
						l_regname___0 := may_get_selection (l_regname___0)
						get_yank_register (l_regname___0, 0)
						if not (y_current.item.item.y_array).is_void then
							if not a_reglen.is_void then
								if (y_current.item.item.y_type).to_integer_32 = 2 then
									a_reglen.item := (y_current.item.item.y_width).to_integer_32
								end
							end
							Result := (y_current.item.item.y_type)
							l_return := True
						end
					end
					if not l_return then
						Result := (255).to_natural_8
					end
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_reg_contents (a_regname___0, a_allowexpr, a_expr_src: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_regname___0: INTEGER_32
			l_i___0: INTEGER_32
			l_retval: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_allocated: CE_ARRAY [INTEGER_32]
			l_len: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_retval.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_allocated.make (<<1>>)

			l_regname___0 := a_regname___0
			if l_regname___0 = 61 then
				if a_allowexpr.to_boolean then
					if a_expr_src.to_boolean then
						Result := (get_expr_line_src)
						l_return := True
					end
					if not l_return then
						Result := (get_expr_line)
						l_return := True
					end
				end
				if not l_return then
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				if l_regname___0 = 64 then
					l_regname___0 := ('%"').code
				end
				if l_regname___0 /= 0 then
					if not (valid_yank_reg (l_regname___0, 0)).to_boolean then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
				end
			end
			if not l_return then
				l_regname___0 := may_get_selection (l_regname___0)
				if (get_spec_reg (l_regname___0, l_retval, l_allocated, 0)).to_boolean then
					if (l_retval.item).is_void then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						if not (l_allocated.item).to_boolean then
							l_retval.item := (create {P_MISC2_STATIC}).vim_strsave (l_retval.item)
						end
						Result := (l_retval.item)
						l_return := True
					end
				end
			end
			if not l_return then
				get_yank_register (l_regname___0, 0)
				if (y_current.item.item.y_array).is_void then
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_len := 0
				l_i___0 := 0
				from
				until
					not (l_i___0 < y_current.item.item.y_size)
				loop
					l_len := l_len + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (y_current.item.item.y_array[l_i___0]))).to_integer_32
					if (y_current.item.item.y_type).to_integer_32 = 1 then
						l_len := l_len + 1
					elseif l_i___0 < y_current.item.item.y_size - 1 then
						l_len := l_len + 1
					end
					l_i___0 := l_i___0 + 1
				end
				l_retval.item := (create {P_MISC2_STATIC}).lalloc ((l_len + 1).to_natural_32, 1)
				if not (l_retval.item).is_void then
					l_len := 0
					l_i___0 := 0
					from
					until
						not (l_i___0 < y_current.item.item.y_size)
					loop
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_retval.item + l_len)), create {CE_INTEGER_8_POINTER}.make_cast (y_current.item.item.y_array[l_i___0])).do_nothing
						l_len := l_len + (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_retval.item + l_len)))).to_integer_32
						if (y_current.item.item.y_type).to_integer_32 = 1 then
							l_tmp___5 := l_len
							l_len := l_len + 1
							l_retval.item[l_tmp___5] := (('%N').code).to_natural_8
						elseif l_i___0 < y_current.item.item.y_size - 1 then
							l_tmp___5 := l_len
							l_len := l_len + 1
							l_retval.item[l_tmp___5] := (('%N').code).to_natural_8
						end
						l_i___0 := l_i___0 + 1
					end
					l_retval.item[l_len] := (('%/0/').code).to_natural_8
				end
				Result := (l_retval.item)
			end
		end

	write_reg_contents (a_name___1: INTEGER_32; a_str___1: CE_POINTER [NATURAL_8]; a_maxlen, a_must_append: INTEGER_32)
		do
			write_reg_contents_ex (a_name___1, a_str___1, a_maxlen, a_must_append, 255, 0)
		end

	write_reg_contents_ex (a_name___1: INTEGER_32; a_str___1: CE_POINTER [NATURAL_8]; a_maxlen, a_must_append, a_yank_type: INTEGER_32; a_block_len: INTEGER_32)
		local
			l_yank_type: INTEGER_32
			l_old_y_previous: CE_POINTER [PD_YANKREG]
			l_old_y_current: CE_POINTER [PD_YANKREG]
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_yank_type := a_yank_type
			if a_maxlen >= 0 then
				l_len := a_maxlen.to_integer_32
			else
				l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_str___1))).to_integer_32
			end
			if a_name___1 = 47 then
				(create {P_SEARCH_STATIC}).set_last_search_pat (a_str___1, 0, 1, 1)
				l_return := True
			end
			if not l_return and then (a_name___1 = 61) then
				l_p___0 := (create {P_MISC2_STATIC}).vim_strnsave (a_str___1, l_len.to_integer_32)
				if l_p___0.is_void then
					l_return := True
				end
				if not l_return then
					if a_must_append.to_boolean then
						l_s := (create {P_MISC1_STATIC}).concat_str ((get_expr_line_src), l_p___0);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
						l_p___0 := l_s
					end
					set_expr_line (l_p___0)
					l_return := True
				end
			end
			if not l_return then
				if not (valid_yank_reg (a_name___1, 1)).to_boolean then
					(create {P_MESSAGE_STATIC}).emsg_invreg (a_name___1)
					l_return := True
				end
			end
			if not l_return and then (a_name___1 = 95) then
				l_return := True
			end
			if not l_return then
				l_old_y_previous := y_previous.item
				l_old_y_current := y_current.item
				get_yank_register (a_name___1, 1)
				if not y_append.item.to_boolean then
					if not a_must_append.to_boolean then
						free_yank_all
					end
				end
				if l_yank_type = 255 then
					if l_len > 0 then
						if (a_str___1[(l_len - 1)]).to_integer_32 = 10 then
							l_yank_type := 1
						elseif (a_str___1[(l_len - 1)]).to_integer_32 = 13 then
							l_yank_type := 1
						else
							l_yank_type := 0
						end
					else
						l_yank_type := 0
					end
				end
				y_current.item.item.str_to_reg (l_yank_type, a_str___1, l_len, a_block_len)
				may_set_selection
				if a_name___1 /= 34 then
					y_previous.item := l_old_y_previous
				end
				y_current.item := l_old_y_current
			end
		end

	clear_oparg (a_oap: CE_POINTER [PD_OPARG_S])
		do
			memset (create {CE_VOID_POINTER}.make_cast (a_oap), 0, (create {PD_OPARG_S}.make).structure_size.to_natural_32).do_nothing
		end

end
