class
	P_PTY_STATIC

inherit
	CE_UTILITIES
	S_FCNTL_STATIC
	S_SIGNAL_STATIC
	S_STDLIB_STATIC
	S_UNISTD_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	TtyName: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<32>>)
		end

feature {ANY} -- public routines

	initmaster (a_f: INTEGER_32)
		do
		end

	SetupSlavePTY (a_fd: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_fd < 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	OpenPTY (a_ttyn: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_f: INTEGER_32
			l_m: CE_POINTER [INTEGER_8]
			l_sigcld: CE_ROUTINE
			l_return: BOOLEAN
		do
			l_f := open ([ce_string ("/dev/ptmx"), 258, 0])
			if l_f = -1 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_sigcld := signal (17, create {CE_ROUTINE}.make_shared (default_pointer))
				l_m := ptsname (l_f)
				if l_m.is_void then
					signal (17, l_sigcld).do_nothing
					close (l_f).do_nothing
					Result := (-1)
					l_return := True
				elseif (grantpt (l_f)).to_boolean then
					signal (17, l_sigcld).do_nothing
					close (l_f).do_nothing
					Result := (-1)
					l_return := True
				elseif (unlockpt (l_f)).to_boolean then
					signal (17, l_sigcld).do_nothing
					close (l_f).do_nothing
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				signal (17, l_sigcld).do_nothing
				strncpy (TtyName.item, l_m, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (32).to_natural_32)).do_nothing
				initmaster (l_f)
				a_ttyn.item := TtyName.item
				Result := l_f
			end
		end

end
