class
	P_QUICKFIX_STATIC

inherit
	CE_UTILITIES
	S_STDIO_STATIC
	S_LIBINTL_STATIC
	S_STRING_STATIC
	S_STDLIB_STATIC

feature {ANY} -- public attributes

	dir_stack: CE_STATIC [CE_ARRAY [CE_POINTER [PD_DIR_STACK_T]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [PD_DIR_STACK_T]}.make_initialized (<<
					create {CE_CLASS_POINTER [PD_DIR_STACK_T]}.make_shared (default_pointer)
				>>)
		end

	ql_info: CE_STATIC [CE_ARRAY [PD_QF_INFO_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_QF_INFO_S]}.make (<<1>>)
		end

	fmt_pat: CE_STATIC [CE_ARRAY [PD_FMTPATTERN]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_FMTPATTERN]}.make_initialized (<<
					create {PD_FMTPATTERN}.make_initialized ([(('f').code).to_natural_8, ce_string (".\+")]),
					create {PD_FMTPATTERN}.make_initialized ([(('n').code).to_natural_8, ce_string ("\d\+")]),
					create {PD_FMTPATTERN}.make_initialized ([(('l').code).to_natural_8, ce_string ("\d\+")]),
					create {PD_FMTPATTERN}.make_initialized ([(('c').code).to_natural_8, ce_string ("\d\+")]),
					create {PD_FMTPATTERN}.make_initialized ([(('t').code).to_natural_8, ce_string (".")]),
					create {PD_FMTPATTERN}.make_initialized ([(('m').code).to_natural_8, ce_string (".\+")]),
					create {PD_FMTPATTERN}.make_initialized ([(('r').code).to_natural_8, ce_string (".*")]),
					create {PD_FMTPATTERN}.make_initialized ([(('p').code).to_natural_8, ce_string ("[- .]*")]),
					create {PD_FMTPATTERN}.make_initialized ([(('v').code).to_natural_8, ce_string ("\d\+")]),
					create {PD_FMTPATTERN}.make_initialized ([(('s').code).to_natural_8, ce_string (".\+")])
				>>)
		end

	e_no_more_items: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E553: No more items"))
		end

	buf___2: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<20>>)
		end

	cc: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<3>>)
		end

feature {ANY} -- public routines

	qf_init (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_efile, a_errorformat: CE_POINTER [NATURAL_8]; a_newlist: INTEGER_32; a_qf_title: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_return: BOOLEAN
		do
			l_qi := ql_info.item
			if a_efile.is_void then
				Result := 0
				l_return := True
			end
			if not l_return and then (not a_wp___0.is_void) then
				l_qi := a_wp___0.item.ll_get_or_alloc_list
				if l_qi.is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := (qf_init_ext (l_qi, a_efile, (create {P_GLOBALS_STATIC}).curbuf.item, create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (default_pointer), a_errorformat, a_newlist, (0).to_integer_32, (0).to_integer_32, a_qf_title))
			end
		end

	qf_init_ext (a_qi: CE_POINTER [PD_QF_INFO_S]; a_efile: CE_POINTER [NATURAL_8]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_tv: CE_POINTER [PD_TYPVAL_T]; a_errorformat: CE_POINTER [NATURAL_8]; a_newlist: INTEGER_32; a_lnumfirst, a_lnumlast: INTEGER_32; a_qf_title: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_namebuf: CE_POINTER [NATURAL_8]
			l_errmsg: CE_POINTER [NATURAL_8]
			l_pattern: CE_POINTER [NATURAL_8]
			l_fmtstr: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
			l_use_viscol: NATURAL_8
			l_type: INTEGER_32
			l_valid: INTEGER_32
			l_buflnum: INTEGER_32
			l_lnum: INTEGER_32
			l_enr: INTEGER_32
			l_fd: CE_POINTER [SD_IO_FILE]
			l_qfprev: CE_ARRAY [CE_POINTER [PD_QFLINE_S]]
			l_efmp: CE_POINTER [NATURAL_8]
			l_fmt_first: CE_POINTER [PD_EFM_S]
			l_fmt_last: CE_POINTER [PD_EFM_S]
			l_fmt_ptr: CE_POINTER [PD_EFM_S]
			l_fmt_start: CE_POINTER [PD_EFM_S]
			l_efm: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_srcptr: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_round: INTEGER_32
			l_idx: INTEGER_32
			l_multiline: INTEGER_32
			l_multiignore: INTEGER_32
			l_multiscan: INTEGER_32
			l_retval: INTEGER_32
			l_directory: CE_POINTER [NATURAL_8]
			l_currfile: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_p_str: CE_POINTER [NATURAL_8]
			l_p_li: CE_POINTER [PD_LISTITEM_S]
			l_file_stack: CE_ARRAY [CE_POINTER [PD_DIR_STACK_T]]
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: NATURAL_8
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_tmp___15: CE_POINTER [NATURAL_8]
			l_tmp___16: CE_POINTER [NATURAL_8]
			l_tmp___17: NATURAL_8
			l_tmp___19: CE_POINTER [NATURAL_8]
			l_tmp___20: CE_POINTER [NATURAL_8]
			l_tmp___21: NATURAL_8
			l_tmp___22: CE_POINTER [NATURAL_8]
			l_tmp___23: CE_POINTER [NATURAL_8]
			l_tmp___25: CE_POINTER [NATURAL_8]
			l_tmp___26: CE_POINTER [NATURAL_8]
			l_tmp___27: CE_POINTER [NATURAL_8]
			l_tmp___33: CE_POINTER [NATURAL_8]
			l_tmp___35: CE_POINTER [NATURAL_8]
			l_tmp___36: CE_POINTER [NATURAL_8]
			l_tmp___37: CE_POINTER [PD_REGPROG_T]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___41: INTEGER_32
			l_c: INTEGER_32
			l_tmp___56: CE_POINTER [NATURAL_8]
			l_tmp___57: CE_POINTER [NATURAL_8]
			l_tmp___59: NATURAL_32
			l_tmp___65: CE_POINTER [NATURAL_8]
			l_tmp___66: CE_POINTER [NATURAL_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_QFLINE_S]} l_qfprev.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_DIR_STACK_T]} l_file_stack.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_REGMATCH_T]} l_regmatch___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fmtstr := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_col := 0
					l_use_viscol := (0).to_natural_8
					l_type := 0
					l_buflnum := a_lnumfirst
					l_lnum := 0
					l_enr := 0
					l_fd := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
					l_qfprev.item := create {CE_CLASS_POINTER [PD_QFLINE_S]}.make_shared (default_pointer)
					l_fmt_first := create {CE_CLASS_POINTER [PD_EFM_S]}.make_shared (default_pointer)
					l_fmt_last := create {CE_CLASS_POINTER [PD_EFM_S]}.make_shared (default_pointer)
					l_fmt_start := create {CE_CLASS_POINTER [PD_EFM_S]}.make_shared (default_pointer)
					l_idx := 0
					l_multiline := 0
					l_multiignore := 0
					l_multiscan := 0
					l_retval := -1
					l_directory := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_currfile := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_tail := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_p_str := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_p_li := create {CE_CLASS_POINTER [PD_LISTITEM_S]}.make_shared (default_pointer)
					l_file_stack.item := create {CE_CLASS_POINTER [PD_DIR_STACK_T]}.make_shared (default_pointer)
					l_namebuf := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 1_025)
					l_errmsg := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 1_025)
					l_pattern := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 1_025)
					if l_namebuf.is_void then
						l_pos := -1 + 110 -- goto qf_init_end
					elseif l_errmsg.is_void then
						l_pos := -1 + 110 -- goto qf_init_end
					elseif l_pattern.is_void then
						l_pos := -1 + 110 -- goto qf_init_end
					end
				when 1 then
					if not a_efile.is_void then
						l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (a_efile), ce_string ("r"))
						if l_fd.is_void then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_openerrf.item))))), a_efile).do_nothing
							l_pos := -1 + 110 -- goto qf_init_end
						end
					end
				when 2 then
					if a_newlist.to_boolean then
						a_qi.item.qf_new_list (a_qf_title)
					elseif a_qi.item.qf_curlist = a_qi.item.qf_listcount then
						a_qi.item.qf_new_list (a_qf_title)
					elseif a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_count > 0 then
						l_qfprev.item := a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_start
						from
						until
							(l_qfprev.item.item.qf_next).is_equal (l_qfprev.item)
						loop
							l_qfprev.item := l_qfprev.item.item.qf_next
						end
					end
					if a_errorformat.is_equal ((create {P_OPTION_STATIC}).p_efm.item.item) then
						if a_tv.is_void then
							if ((a_buf___6.item.b_p_efm).item).to_integer_32 /= 0 then
								l_efm := a_buf___6.item.b_p_efm
							else
								l_efm := a_errorformat
							end
						else
							l_efm := a_errorformat
						end
					else
						l_efm := a_errorformat
					end
					l_i___0 := 30 + (((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_efm))).to_integer_32).bit_shift_left (2))
					l_round := 10
					from
					until
						not (l_round > 0)
					loop
						l_round := l_round - 1
						l_i___0 := l_i___0 + (strlen (fmt_pat.item[l_round].pattern)).to_integer_32
					end
					l_i___0 := l_i___0 + (2)
					l_fmtstr := (create {P_MISC2_STATIC}).alloc (l_i___0.to_natural_32)
					if l_fmtstr.is_void then
						l_pos := -1 + 108 -- goto error2
					end
				when 3 then
					if not (not (l_return) and then ((l_efm[0]).to_integer_32 /= 0)) then
						l_pos := -1 + 40 -- skip loop
					end
				when 4 then -- loop body:
						l_fmt_ptr := create {CE_CLASS_POINTER [PD_EFM_S]}.make_cast (((create {P_MISC2_STATIC}).alloc_clear ((create {PD_EFM_S}.make).structure_size.to_natural_32)))
						if l_fmt_ptr.is_void then
							l_pos := -1 + 108 -- goto error2
						end
				when 5 then
						if l_fmt_first.is_void then
							l_fmt_first := l_fmt_ptr
						else
							l_fmt_last.item.next := l_fmt_ptr
						end
						l_fmt_last := l_fmt_ptr
						l_len := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_efm[l_len]).to_integer_32 /= 0 then
								if (l_efm[l_len]).to_integer_32 = 44 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								if (l_efm[l_len]).to_integer_32 = 92 then
									if (l_efm[(l_len + 1)]).to_integer_32 /= 0 then
										l_len := l_len + 1
									end
								end
								l_len := l_len + 1
							end
						end
						l_break := False
						l_ptr := l_fmtstr
						l_tmp___3 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___3.item := (('^').code).to_natural_8
						l_round := 0
						l_efmp := l_efm
				when 6 then -- loop condition:
						if not (not (l_return) and then ((l_efmp.c_pointer.to_integer_32).to_natural_32 < ((l_efm + l_len).c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 38 -- skip loop
						end
				when 7 then -- loop body:
						if (l_efmp.item).to_integer_32 /= 37 then
							l_pos := -1 + 32 -- skip if block
						end
				when 8 then -- if:
						l_efmp := l_efmp + 1
						l_idx := 0
						from
						until
							not (not (l_break) and then (l_idx < 10))
						loop
							l_break := False
							if (fmt_pat.item[l_idx].convchar).to_integer_32 = (l_efmp.item).to_integer_32 then
								l_break := True
							end
							if not (l_break) then
								l_idx := l_idx + 1
							end
						end
						l_break := False
						if not (l_idx < 10) then
							l_pos := -1 + 20 -- skip if block
						end
				when 9 then -- if:
						if (l_fmt_ptr.item.addr[l_idx]).to_boolean then
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_errmsg), (gettext (ce_string ("E372: Too many %%%%%%c in format string"))), (l_efmp.item).to_integer_32]).do_nothing;
							(create {P_MESSAGE_STATIC}).emsg (l_errmsg).do_nothing
							l_pos := -1 + 108 -- goto error2
						end
				when 10 then
						if not (l_idx.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_idx < 6 then
							if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("DXOPQ")), (l_fmt_ptr.item.prefix2).to_integer_32)).is_void then
								l_tmp___5 := gettext (ce_string ("E373: Unexpected %%%%%%c in format string"))
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_errmsg), l_tmp___5, (l_efmp.item).to_integer_32]).do_nothing;
								(create {P_MESSAGE_STATIC}).emsg (l_errmsg).do_nothing
								l_pos := -1 + 108 -- goto error2
							else
								l_pos := -1 + 13 -- goto _L___0
							end
						else
							l_pos := -1 + 13 -- goto _L___0
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___0:
						if l_idx = 6 then
							if ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("OPQ")), (l_fmt_ptr.item.prefix2).to_integer_32)).is_void then
								l_tmp___5 := gettext (ce_string ("E373: Unexpected %%%%%%c in format string"))
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_errmsg), l_tmp___5, (l_efmp.item).to_integer_32]).do_nothing;
								(create {P_MESSAGE_STATIC}).emsg (l_errmsg).do_nothing
								l_pos := -1 + 108 -- goto error2
							end
						end
				when 14 then
						l_round := l_round + 1
						l_fmt_ptr.item.addr[l_idx] := l_round.to_natural_8
						l_tmp___8 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___8.item := (('\').code).to_natural_8
						l_tmp___9 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___9.item := (('(').code).to_natural_8
						if (l_efmp.item).to_integer_32 /= 102 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if (l_efmp[1]).to_integer_32 /= 0 then
							if (l_efmp[1]).to_integer_32 /= 92 then
								if (l_efmp[1]).to_integer_32 /= 37 then
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr), ce_string (".\{-1,}")).do_nothing
									l_ptr := l_ptr + (7)
								else
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr), ce_string ("\f\+")).do_nothing
									l_ptr := l_ptr + (4)
								end
							else
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr), ce_string ("\f\+")).do_nothing
								l_ptr := l_ptr + (4)
							end
						else
							l_pos := -1 + 17 -- goto _L___1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L___1:
						l_srcptr := create {CE_NATURAL_8_POINTER}.make_cast (fmt_pat.item[l_idx].pattern)
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___11 := l_srcptr
							l_srcptr := l_srcptr + 1
							l_tmp___10 := l_tmp___11.item
							l_ptr.item := l_tmp___10
							if l_tmp___10.to_integer_32 = 0 then
								l_break := True
							end
							if not (l_break) then
								l_ptr := l_ptr + 1
							end
						end
						l_break := False
				when 18 then
						l_tmp___12 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___12.item := (('\').code).to_natural_8
						l_tmp___13 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___13.item := ((')').code).to_natural_8
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 20 then -- else:
						if (l_efmp.item).to_integer_32 /= 42 then
							l_pos := -1 + 30 -- skip if block
						end
				when 21 then -- if:
						l_efmp := l_efmp + 1
						if (l_efmp.item).to_integer_32 /= 91 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L___2
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 24 then -- else:
						if (l_efmp.item).to_integer_32 /= 92 then
							l_pos := -1 + 28 -- skip if block
						end
				when 25 then -- if: | _L___2:
						l_tmp___20 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___21 := l_efmp.item
						l_tmp___20.item := l_tmp___21
						if l_tmp___21.to_integer_32 = 91 then
							if (l_efmp[1]).to_integer_32 = 94 then
								l_tmp___14 := l_ptr
								l_ptr := l_ptr + 1
								l_efmp := l_efmp + 1
								l_tmp___14.item := l_efmp.item
							end
							if (l_efmp.c_pointer.to_integer_32).to_natural_32 < ((l_efm + l_len).c_pointer.to_integer_32).to_natural_32 then
								l_tmp___15 := l_ptr
								l_ptr := l_ptr + 1
								l_efmp := l_efmp + 1
								l_tmp___15.item := l_efmp.item
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_efmp.c_pointer.to_integer_32).to_natural_32 < ((l_efm + l_len).c_pointer.to_integer_32).to_natural_32 then
										l_tmp___16 := l_ptr
										l_ptr := l_ptr + 1
										l_efmp := l_efmp + 1
										l_tmp___17 := l_efmp.item
										l_tmp___16.item := l_tmp___17
										if l_tmp___17.to_integer_32 = 93 then
											l_break := True
										end
									else
										l_break := True
									end
								end
								l_break := False
								if l_efmp.is_equal (l_efm + l_len) then
									(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E374: Missing ] in format string"))))).do_nothing
									l_pos := -1 + 108 -- goto error2
								end
							end
						elseif (l_efmp.c_pointer.to_integer_32).to_natural_32 < ((l_efm + l_len).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___19 := l_ptr
							l_ptr := l_ptr + 1
							l_efmp := l_efmp + 1
							l_tmp___19.item := l_efmp.item
						end
				when 26 then
						l_tmp___22 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___22.item := (('\').code).to_natural_8
						l_tmp___23 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___23.item := (('+').code).to_natural_8
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_errmsg), (gettext (ce_string ("E375: Unsupported %%%%%%c in format string"))), (l_efmp.item).to_integer_32]).do_nothing;
						(create {P_MESSAGE_STATIC}).emsg (l_errmsg).do_nothing
						l_pos := -1 + 108 -- goto error2
				when 29 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else:
						if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%\.^$~[")), (l_efmp.item).to_integer_32)).is_void then
							l_tmp___25 := l_ptr
							l_ptr := l_ptr + 1
							l_tmp___25.item := l_efmp.item
						elseif (l_efmp.item).to_integer_32 = 35 then
							l_tmp___26 := l_ptr
							l_ptr := l_ptr + 1
							l_tmp___26.item := (('*').code).to_natural_8
						elseif (l_efmp.item).to_integer_32 = 62 then
							l_fmt_ptr.item.conthere := 1
						elseif l_efmp.is_equal (l_efm + 1) then
							if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("+-")), (l_efmp.item).to_integer_32)).is_void then
								l_tmp___27 := l_efmp
								l_efmp := l_efmp + 1
								l_fmt_ptr.item.flags := l_tmp___27.item
							end
							if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("DXAEWICZGOPQ")), (l_efmp.item).to_integer_32)).is_void then
								l_fmt_ptr.item.prefix2 := l_efmp.item
							else
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_errmsg), (gettext (ce_string ("E376: Invalid %%%%%%c in format string prefix"))), (l_efmp.item).to_integer_32]).do_nothing;
								(create {P_MESSAGE_STATIC}).emsg (l_errmsg).do_nothing
								l_pos := -1 + 108 -- goto error2
							end
						else
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_errmsg), (gettext (ce_string ("E377: Invalid %%%%%%c in format string"))), (l_efmp.item).to_integer_32]).do_nothing;
							(create {P_MESSAGE_STATIC}).emsg (l_errmsg).do_nothing
							l_pos := -1 + 108 -- goto error2
						end
				when 31 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 37
				when 32 then -- else:
						if (l_efmp.item).to_integer_32 /= 92 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						if ((l_efmp + 1).c_pointer.to_integer_32).to_natural_32 < ((l_efm + l_len).c_pointer.to_integer_32).to_natural_32 then
							l_efmp := l_efmp + 1
						else
							l_pos := -1 + 35 -- goto _L___3
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else: | _L___3:
						if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".*^$~[")), (l_efmp.item).to_integer_32)).is_void then
							l_tmp___33 := l_ptr
							l_ptr := l_ptr + 1
							l_tmp___33.item := (('\').code).to_natural_8
						end
				when 36 then
						if (l_efmp.item).to_boolean then
							l_tmp___35 := l_ptr
							l_ptr := l_ptr + 1
							l_tmp___35.item := l_efmp.item
						end
				when 37 then
						l_efmp := l_efmp + 1
						l_pos := -1 + 6 -- back to loop condition
				when 38 then -- loop done
						l_tmp___36 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___36.item := (('$').code).to_natural_8
						l_ptr.item := (('%/0/').code).to_natural_8
						l_tmp___37 := (create {P_REGEXP_STATIC}).vim_regcomp (l_fmtstr, 3)
						l_fmt_ptr.item.prog := l_tmp___37
						if l_tmp___37.is_void then
							l_pos := -1 + 108 -- goto error2
						end
				when 39 then
						l_efm := (create {P_MISC1_STATIC}).skip_to_option_part (l_efm + l_len)
						l_pos := -1 + 3 -- back to loop condition
				when 40 then -- loop done
					if l_fmt_first.is_void then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E378: %'errorformat%' contains no pattern"))))).do_nothing
						l_pos := -1 + 108 -- goto error2
					end
				when 41 then;
					(create {P_GLOBALS_STATIC}).got_int.item := 0
					l_regmatch___0.item.rm_ic := 1
					if not a_tv.is_void then
						if (a_tv.item.v_type).to_integer_32 = 2 then
							l_p_str := a_tv.item.vval.v_string
						elseif (a_tv.item.v_type).to_integer_32 = 4 then
							l_p_li := (a_tv.item.vval.v_list).item.lv_first
						end
					end
				when 42 then -- loop condition:
					if not (not (l_return or l_break) and then (not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean)) then
						l_pos := -1 + 102 -- skip loop
					end
				when 43 then -- loop body:
						l_break := False
						l_continue := False
						if l_fd.is_void then
							if not a_tv.is_void then
								if (a_tv.item.v_type).to_integer_32 = 2 then
									if not (l_p_str.item).to_boolean then
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (l_p_str, ('%N').code)
										if (not l_p___0.is_void) then
											l_len := (l_p___0.distance (l_p_str)) + 1
										else
											l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p_str))).to_integer_32
										end
										if l_len > 1_022 then
											(create {P_MISC2_STATIC}).vim_strncpy ((create {P_GLOBALS_STATIC}).IObuff.item, l_p_str, (1_022).to_natural_32)
										else
											(create {P_MISC2_STATIC}).vim_strncpy ((create {P_GLOBALS_STATIC}).IObuff.item, l_p_str, l_len.to_natural_32)
										end
										l_p_str := l_p_str + l_len
									end
								elseif (a_tv.item.v_type).to_integer_32 = 4 then
									from
									until
										(l_break)
									loop
										l_break := False
										if (not l_p_li.is_void) then
											if (l_p_li.item.li_tv.v_type).to_integer_32 = 2 then
												l_break := True
											end
										else
											l_break := True
										end
										if not (l_return or l_break) then
											l_p_li := l_p_li.item.li_next
										end
									end
									l_break := False
									if l_p_li.is_void then
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p_li.item.li_tv.vval.v_string))).to_integer_32
										if l_len > 1_022 then
											l_len := 1_022
										end
										(create {P_MISC2_STATIC}).vim_strncpy ((create {P_GLOBALS_STATIC}).IObuff.item, l_p_li.item.li_tv.vval.v_string, l_len.to_natural_32)
										l_p_li := l_p_li.item.li_next
									end
								end
							else
								if l_buflnum > a_lnumlast then
									l_break := True
								end
								if not (l_return or l_break or l_continue) then
									l_tmp___41 := l_buflnum
									l_buflnum := l_buflnum + 1;
									(create {P_MISC2_STATIC}).vim_strncpy ((create {P_GLOBALS_STATIC}).IObuff.item, (a_buf___6.item.ml_get_buf (l_tmp___41, 0)), (1_022).to_natural_32)
								end
							end
						elseif (fgets (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), 1_022, l_fd)).is_void then
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 98 -- skip if block
						end
				when 44 then -- if:;
						(create {P_GLOBALS_STATIC}).IObuff.item[1_022] := (('%/0/').code).to_natural_8
						l_efmp := (create {P_MISC2_STATIC}).vim_strrchr ((create {P_GLOBALS_STATIC}).IObuff.item, ('%N').code)
						if not l_efmp.is_void then
							l_efmp.item := (('%/0/').code).to_natural_8
						end
						if l_fmt_start.is_void then
							l_fmt_ptr := l_fmt_first
						else
							l_fmt_ptr := l_fmt_start
							l_fmt_start := create {CE_CLASS_POINTER [PD_EFM_S]}.make_shared (default_pointer)
						end
						l_valid := 1
				when 45 then -- restofline:
						if not (not (l_break) and then (not l_fmt_ptr.is_void)) then
							l_pos := -1 + 60 -- skip loop
						end
				when 46 then -- loop body:
						l_break := False
						l_continue := False
						l_idx := (l_fmt_ptr.item.prefix2).to_integer_32
						if l_multiscan.to_boolean then
							if ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("OPQ")), l_idx)).is_void then
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 59 -- skip if block
						end
				when 47 then -- if:
						l_namebuf[0] := (('%/0/').code).to_natural_8
						l_pattern[0] := (('%/0/').code).to_natural_8
						if not l_multiscan.to_boolean then
							l_errmsg[0] := (('%/0/').code).to_natural_8
						end
						l_lnum := 0
						l_col := 0
						l_use_viscol := (0).to_natural_8
						l_enr := -1
						l_type := 0
						l_tail := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_regmatch___0.item.regprog := l_fmt_ptr.item.prog
						if not ((l_regmatch___0.item.vim_regexec ((create {P_GLOBALS_STATIC}).IObuff.item, 0)).to_boolean) then
							l_pos := -1 + 59 -- skip if block
						end
				when 48 then -- if:
						if l_idx /= 67 then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						l_pos := -1 + 52 -- goto _L___4
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 51 then -- else:
						if l_idx /= 90 then
							l_pos := -1 + 53 -- skip if block
						end
				when 52 then -- if: | _L___4:
						if not l_multiline.to_boolean then
							l_continue := True
						end
				when 53 then -- if done
						if not (l_return or l_break or l_continue) then
							if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("EWI")), l_idx)).is_void then
								l_type := l_idx
							else
								l_type := 0
							end
							l_i___0 := (l_fmt_ptr.item.addr[0]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									l_continue := True
								elseif (l_regmatch___0.item.endp[l_i___0]).is_void then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_c := ((l_regmatch___0.item.endp[l_i___0]).item).to_integer_32;
									(l_regmatch___0.item.endp[l_i___0]).item := (('%/0/').code).to_natural_8;
									(create {P_MISC1_STATIC}).expand_env (l_regmatch___0.item.startp[l_i___0], l_namebuf, 1_024);
									(l_regmatch___0.item.endp[l_i___0]).item := l_c.to_natural_8
									if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("OPQ")), l_idx)).is_void then
										if ((create {P_OS_UNIX_STATIC}).mch_getperm (l_namebuf)) = -1 then
											l_continue := True
										end
									end
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_i___0 := (l_fmt_ptr.item.addr[1]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_enr := (atol (create {CE_INTEGER_8_POINTER}.make_cast (l_regmatch___0.item.startp[l_i___0]))).to_integer_32
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_i___0 := (l_fmt_ptr.item.addr[2]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_lnum := atol (create {CE_INTEGER_8_POINTER}.make_cast (l_regmatch___0.item.startp[l_i___0]))
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_i___0 := (l_fmt_ptr.item.addr[3]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_col := (atol (create {CE_INTEGER_8_POINTER}.make_cast (l_regmatch___0.item.startp[l_i___0]))).to_integer_32
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_i___0 := (l_fmt_ptr.item.addr[4]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_type := ((l_regmatch___0.item.startp[l_i___0]).item).to_integer_32
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 58 -- skip if block
						end
				when 54 then -- if:
						if (l_fmt_ptr.item.flags).to_integer_32 /= 43 then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						if not l_multiscan.to_boolean then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_errmsg), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item)).do_nothing
						else
							l_pos := -1 + 57 -- goto _L___5
						end
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 57 then -- else: | _L___5:
						l_i___0 := (l_fmt_ptr.item.addr[5]).to_integer_32
						if l_i___0 > 0 then
							if (l_regmatch___0.item.startp[l_i___0]).is_void then
								l_continue := True
							elseif (l_regmatch___0.item.endp[l_i___0]).is_void then
								l_continue := True
							end
							if not (l_return or l_break or l_continue) then
								l_len := (l_regmatch___0.item.endp[l_i___0]).distance ((l_regmatch___0.item.startp[l_i___0]));
								(create {P_MISC2_STATIC}).vim_strncpy (l_errmsg, l_regmatch___0.item.startp[l_i___0], l_len.to_natural_32)
							end
						end
				when 58 then -- if done
						if not (l_return or l_break or l_continue) then
							l_i___0 := (l_fmt_ptr.item.addr[6]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_tail := l_regmatch___0.item.startp[l_i___0]
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_i___0 := (l_fmt_ptr.item.addr[7]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									l_continue := True
								elseif (l_regmatch___0.item.endp[l_i___0]).is_void then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_col := ((l_regmatch___0.item.endp[l_i___0]).distance ((l_regmatch___0.item.startp[l_i___0]))) + 1
									if ((l_regmatch___0.item.startp[l_i___0]).item).to_integer_32 /= 9 then
										l_use_viscol := (1).to_natural_8
									end
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_i___0 := (l_fmt_ptr.item.addr[8]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_col := (atol (create {CE_INTEGER_8_POINTER}.make_cast (l_regmatch___0.item.startp[l_i___0]))).to_integer_32
									l_use_viscol := (1).to_natural_8
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_i___0 := (l_fmt_ptr.item.addr[9]).to_integer_32
							if l_i___0 > 0 then
								if (l_regmatch___0.item.startp[l_i___0]).is_void then
									l_continue := True
								elseif (l_regmatch___0.item.endp[l_i___0]).is_void then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_len := (l_regmatch___0.item.endp[l_i___0]).distance ((l_regmatch___0.item.startp[l_i___0]))
									if l_len > 1_019 then
										l_len := 1_019
									end
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_pattern), ce_string ("^\V")).do_nothing
									strncat (create {CE_INTEGER_8_POINTER}.make_cast (l_pattern), create {CE_INTEGER_8_POINTER}.make_cast (l_regmatch___0.item.startp[l_i___0]), l_len.to_natural_32).do_nothing
									l_pattern[(l_len + 3)] := (('\').code).to_natural_8
									l_pattern[(l_len + 4)] := (('$').code).to_natural_8
									l_pattern[(l_len + 5)] := (('%/0/').code).to_natural_8
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_break := True
						end
				when 59 then -- if done | if done
						if (not l_break) then
							l_fmt_ptr := l_fmt_ptr.item.next
						end
						l_pos := -1 + 45 -- back to loop condition
				when 60 then -- loop done
						l_break := False
						l_continue := False
						l_multiscan := 0
						if not (l_fmt_ptr.is_void) then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						l_pos := -1 + 67 -- goto _L___8
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 98
				when 63 then -- else:
						if l_idx /= 68 then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						l_pos := -1 + 67 -- goto _L___8
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 98
				when 66 then -- else:
						if l_idx /= 88 then
							l_pos := -1 + 75 -- skip if block
						end
				when 67 then -- if: | _L___8:
						if l_fmt_ptr.is_void then
							l_pos := -1 + 73 -- skip if block
						end
				when 68 then -- if:
						if l_idx /= 68 then
							l_pos := -1 + 72 -- skip if block
						end
				when 69 then -- if:
						if (l_namebuf.item).to_integer_32 = 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E379: Missing or empty directory name"))))).do_nothing
							l_pos := -1 + 108 -- goto error2
						end
				when 70 then
						l_directory := qf_push_dir (l_namebuf, dir_stack.item)
						if l_directory.is_void then
							l_pos := -1 + 108 -- goto error2
						end
				when 71 then -- if block done, skip else block:
						l_pos := -1 + 73
				when 72 then -- else:
						if l_idx = 88 then
							l_directory := qf_pop_dir (dir_stack.item)
						end
				when 73 then -- if done
						l_namebuf[0] := (('%/0/').code).to_natural_8
						l_lnum := 0
						l_valid := 0
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_errmsg), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item)).do_nothing
						if l_fmt_ptr.is_void then
							l_multiignore := 0
							l_multiline := l_multiignore
						end
				when 74 then -- if block done, skip else block:
						l_pos := -1 + 98
				when 75 then -- else:
						if l_fmt_ptr.is_void then
							l_pos := -1 + 98 -- skip if block
						end
				when 76 then -- if:
						if (l_fmt_ptr.item.conthere).to_boolean then
							l_fmt_start := l_fmt_ptr
						end
						if ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("AEWI")), l_idx)).is_void then
							l_pos := -1 + 79 -- skip if block
						end
				when 77 then -- if:
						l_multiline := 1
				when 78 then -- if block done, skip else block:
						l_pos := -1 + 97
				when 79 then -- else:
						if ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("CZ")), l_idx)).is_void then
							l_pos := -1 + 87 -- skip if block
						end
				when 80 then -- if:
						if (l_qfprev.item).is_void then
							l_pos := -1 + 108 -- goto error2
						end
				when 81 then
						if not ((l_errmsg.item).to_boolean) then
							l_pos := -1 + 85 -- skip if block
						end
				when 82 then -- if:
						if l_multiignore.to_boolean then
							l_pos := -1 + 85 -- skip if block
						end
				when 83 then -- if:
						l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_qfprev.item.item.qf_text))).to_integer_32
						l_ptr := (create {P_MISC2_STATIC}).alloc ((l_len.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_errmsg)))) + {NATURAL_32} 2)
						if l_ptr.is_void then
							l_pos := -1 + 108 -- goto error2
						end
				when 84 then
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr), create {CE_INTEGER_8_POINTER}.make_cast (l_qfprev.item.item.qf_text)).do_nothing;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_qfprev.item.item.qf_text))
						l_qfprev.item.item.qf_text := l_ptr
						l_ptr := l_ptr + l_len
						l_ptr.item := (('%N').code).to_natural_8
						l_ptr := l_ptr + 1
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr), create {CE_INTEGER_8_POINTER}.make_cast (l_errmsg)).do_nothing
				when 85 then -- if done | if done
						if l_qfprev.item.item.qf_nr = -1 then
							l_qfprev.item.item.qf_nr := l_enr
						end
						if ((create {P_CHARSET_STATIC}).vim_isprintc (l_type)).to_boolean then
							if not (l_qfprev.item.item.qf_type).to_boolean then
								l_qfprev.item.item.qf_type := l_type.to_natural_8
							end
						end
						if not (l_qfprev.item.item.qf_lnum).to_boolean then
							l_qfprev.item.item.qf_lnum := l_lnum
						end
						if not (l_qfprev.item.item.qf_col).to_boolean then
							l_qfprev.item.item.qf_col := l_col
						end
						l_qfprev.item.item.qf_viscol := l_use_viscol
						if not (l_qfprev.item.item.qf_fnum).to_boolean then
							if (l_namebuf.item).to_boolean then
								l_tmp___57 := l_namebuf
							elseif (not l_directory.is_void) then
								l_tmp___57 := l_namebuf
							else
								if (not l_currfile.is_void) then
									if l_valid.to_boolean then
										l_tmp___56 := l_currfile
									else
										l_tmp___56 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
									end
								else
									l_tmp___56 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								end
								l_tmp___57 := l_tmp___56
							end
							l_qfprev.item.item.qf_fnum := qf_get_fnum (l_directory, l_tmp___57)
						end
						if l_idx = 90 then
							l_multiignore := 0
							l_multiline := l_multiignore
						end
						(create {P_MISC1_STATIC}).line_breakcheck
						l_continue := True
				when 86 then -- if block done, skip else block:
						l_pos := -1 + 97
				when 87 then -- else:
						if ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("OPQ")), l_idx)).is_void then
							l_pos := -1 + 97 -- skip if block
						end
				when 88 then -- if:
						l_valid := 0
						if (l_namebuf.item).to_integer_32 /= 0 then
							l_pos := -1 + 91 -- skip if block
						end
				when 89 then -- if:
						l_pos := -1 + 92 -- goto _L___7
				when 90 then -- if block done, skip else block:
						l_pos := -1 + 97
				when 91 then -- else:
						if not (((create {P_OS_UNIX_STATIC}).mch_getperm (l_namebuf)) >= 0) then
							l_pos := -1 + 97 -- skip if block
						end
				when 92 then -- if: | _L___7:
						if not ((l_namebuf.item).to_boolean) then
							l_pos := -1 + 95 -- skip if block
						end
				when 93 then -- if:
						if l_idx = 80 then
							l_currfile := qf_push_dir (l_namebuf, l_file_stack)
						else
							l_pos := -1 + 95 -- goto _L___6
						end
				when 94 then -- if block done, skip else block:
						l_pos := -1 + 96
				when 95 then -- else: | _L___6:
						if l_idx = 81 then
							l_currfile := qf_pop_dir (l_file_stack)
						end
				when 96 then
						l_namebuf.item := (('%/0/').code).to_natural_8
						if (not l_tail.is_void) then
							if (l_tail.item).to_boolean then
								l_tmp___59 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_CHARSET_STATIC}).skipwhite (l_tail))))
								memmove (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), create {CE_VOID_POINTER}.make_cast (((create {P_CHARSET_STATIC}).skipwhite (l_tail))), l_tmp___59 + {NATURAL_32} 1).do_nothing
								l_multiscan := 1
								l_pos := -1 + 45 -- goto restofline
							end
						end
				when 97 then -- if done | if done | if done | if done
						if not (l_return or l_break or l_continue) and then ((l_fmt_ptr.item.flags).to_integer_32 = 45) then
							if l_multiline.to_boolean then
								l_multiignore := 1
							end
							l_continue := True
						end
				when 98 then -- if done | if done | if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 101 -- skip if block
						end
				when 99 then -- if:
						if (l_namebuf.item).to_boolean then
							l_tmp___66 := l_namebuf
						elseif (not l_directory.is_void) then
							l_tmp___66 := l_namebuf
						else
							if (not l_currfile.is_void) then
								if l_valid.to_boolean then
									l_tmp___65 := l_currfile
								else
									l_tmp___65 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								end
							else
								l_tmp___65 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							end
							l_tmp___66 := l_tmp___65
						end
						if (qf_add_entry (a_qi, l_qfprev, l_directory, l_tmp___66, 0, l_errmsg, l_lnum, l_col, l_use_viscol.to_integer_32, l_pattern, l_enr, l_type, l_valid)) = 0 then
							l_pos := -1 + 108 -- goto error2
						end
				when 100 then;
						(create {P_MISC1_STATIC}).line_breakcheck
				when 101 then -- if done
						l_pos := -1 + 42 -- back to loop condition
				when 102 then -- loop done
					l_break := False
					l_continue := False
					if not (l_fd.is_void) then
						l_pos := -1 + 105 -- skip if block
					end
				when 103 then -- if:
						l_pos := -1 + 106 -- goto _L___9
				when 104 then -- if block done, skip else block:
						l_pos := -1 + 107
				when 105 then -- else:
						if (ferror (l_fd)).to_boolean then
							l_pos := -1 + 107 -- skip if block
						end
				when 106 then -- if: | _L___9:
						if a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_index = 0 then
							a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_ptr := a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_start
							a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_index := 1
							a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_nonevalid := 1
						else
							a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_nonevalid := 0
							if (a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_ptr).is_void then
								a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_ptr := a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_start
							end
						end
						l_retval := a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_count
						l_pos := -1 + 109 -- goto qf_init_ok
				when 107 then -- if done;
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_readerrf.item)))))).do_nothing
				when 108 then -- error2:
					a_qi.item.qf_free (a_qi.item.qf_curlist)
					a_qi.item.qf_listcount := (a_qi.item.qf_listcount) - 1
					if a_qi.item.qf_curlist > 0 then
						a_qi.item.qf_curlist := (a_qi.item.qf_curlist) - 1
					end
				when 109 then -- qf_init_ok:
					if not l_fd.is_void then
						fclose (l_fd).do_nothing
					end
					l_fmt_ptr := l_fmt_first
					from
					until
						l_fmt_ptr.is_void
					loop
						l_fmt_first := l_fmt_ptr.item.next;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fmt_ptr.item.prog));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fmt_ptr))
						l_fmt_ptr := l_fmt_first
					end
					qf_clean_dir_stack (dir_stack.item)
					qf_clean_dir_stack (l_file_stack)
				when 110 then -- qf_init_end:;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_namebuf));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_errmsg));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pattern));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fmtstr))
					qf_update_buffer (a_qi)
					Result := l_retval
				when 111 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ll_free_all (a_pqi: CE_POINTER [CE_POINTER [PD_QF_INFO_S]])
		require
			not a_pqi.is_void
		local
			l_i___0: INTEGER_32
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_return: BOOLEAN
		do
			l_qi := a_pqi.item
			if l_qi.is_void then
				l_return := True
			end
			if not l_return then
				a_pqi.item := create {CE_CLASS_POINTER [PD_QF_INFO_S]}.make_shared (default_pointer)
				l_qi.item.qf_refcount := (l_qi.item.qf_refcount) - 1
				if l_qi.item.qf_refcount < 1 then
					l_i___0 := 0
					from
					until
						not (l_i___0 < l_qi.item.qf_listcount)
					loop
						l_qi.item.qf_free (l_i___0)
						l_i___0 := l_i___0 + 1
					end
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_qi))
				end
			end
		end

	qf_add_entry (a_qi: CE_POINTER [PD_QF_INFO_S]; a_prevp: CE_POINTER [CE_POINTER [PD_QFLINE_S]]; a_dir___0, a_fname: CE_POINTER [NATURAL_8]; a_bufnum: INTEGER_32; a_mesg: CE_POINTER [NATURAL_8]; a_lnum: INTEGER_32; a_col, a_vis_col: INTEGER_32; a_pattern: CE_POINTER [NATURAL_8]; a_nr, a_type, a_valid: INTEGER_32): INTEGER_32
		local
			l_type: INTEGER_32
			l_qfp: CE_POINTER [PD_QFLINE_S]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_type := a_type
			l_qfp := create {CE_CLASS_POINTER [PD_QFLINE_S]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_QFLINE_S}.make).structure_size.to_natural_32)))
			if l_qfp.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				if a_bufnum /= 0 then
					l_qfp.item.qf_fnum := a_bufnum
				else
					l_qfp.item.qf_fnum := qf_get_fnum (a_dir___0, a_fname)
				end
				l_tmp___0 := (create {P_MISC2_STATIC}).vim_strsave (a_mesg)
				l_qfp.item.qf_text := l_tmp___0
				if l_tmp___0.is_void then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_qfp))
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_qfp.item.qf_lnum := a_lnum
				l_qfp.item.qf_col := a_col
				l_qfp.item.qf_viscol := a_vis_col.to_natural_8
				if a_pattern.is_void then
					l_qfp.item.qf_pattern := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				elseif (a_pattern.item).to_integer_32 = 0 then
					l_qfp.item.qf_pattern := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				else
					l_tmp___1 := (create {P_MISC2_STATIC}).vim_strsave (a_pattern)
					l_qfp.item.qf_pattern := l_tmp___1
					if l_tmp___1.is_void then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_qfp.item.qf_text));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_qfp))
						Result := 0
						l_return := True
					end
				end
			end
			if not l_return then
				l_qfp.item.qf_nr := a_nr
				if l_type /= 1 then
					if not ((create {P_CHARSET_STATIC}).vim_isprintc (l_type)).to_boolean then
						l_type := 0
					end
				end
				l_qfp.item.qf_type := l_type.to_natural_8
				l_qfp.item.qf_valid := a_valid.to_natural_8
				if a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_count = 0 then
					a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_start := l_qfp
					l_qfp.item.qf_prev := l_qfp
				else
					l_qfp.item.qf_prev := a_prevp.item;
					(a_prevp.item).item.qf_next := l_qfp
				end
				l_qfp.item.qf_next := l_qfp
				l_qfp.item.qf_cleared := (0).to_natural_8
				a_prevp.item := l_qfp
				a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_count := (a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_count) + 1
				if a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_index = 0 then
					if (l_qfp.item.qf_valid).to_boolean then
						a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_index := a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_count
						a_qi.item.qf_lists[a_qi.item.qf_curlist].qf_ptr := l_qfp
					end
				end
				Result := 1
			end
		end

	ll_new_list: CE_POINTER [PD_QF_INFO_S]
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
		do
			l_qi := create {CE_CLASS_POINTER [PD_QF_INFO_S]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_QF_INFO_S}.make).structure_size.to_natural_32)))
			if not l_qi.is_void then
				memset (create {CE_VOID_POINTER}.make_cast (l_qi), 0, (create {PD_QF_INFO_S}.make).structure_size.to_natural_32).do_nothing
				l_qi.item.qf_refcount := (l_qi.item.qf_refcount) + 1
			end
			Result := l_qi
		end

	qf_get_fnum (a_directory, a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_directory: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_fnum___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_directory := a_directory
			if a_fname.is_void then
				Result := 0
				l_return := True
			elseif (a_fname.item).to_integer_32 = 0 then
				Result := 0
				l_return := True
			end
			if not l_return and then (not l_directory.is_void) then
				if not ((create {P_WINDOW_STATIC}).vim_isAbsName (a_fname)).to_boolean then
					l_ptr := (create {P_MISC1_STATIC}).concat_fnames (l_directory, a_fname, 1)
					if not l_ptr.is_void then
						if ((create {P_OS_UNIX_STATIC}).mch_getperm (l_ptr)) < 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ptr))
							l_directory := qf_guess_filepath (a_fname)
							if (not l_directory.is_void) then
								l_ptr := (create {P_MISC1_STATIC}).concat_fnames (l_directory, a_fname, 1)
							else
								l_ptr := (create {P_MISC2_STATIC}).vim_strsave (a_fname)
							end
						end
						l_fnum___0 := (create {P_BUFFER_STATIC}).buflist_add (l_ptr, 0);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ptr))
						Result := l_fnum___0
						l_return := True
					end
				end
			end
			if not l_return then
				Result := ((create {P_BUFFER_STATIC}).buflist_add (a_fname, 0))
			end
		end

	qf_push_dir (a_dirbuf: CE_POINTER [NATURAL_8]; a_stackptr: CE_POINTER [CE_POINTER [PD_DIR_STACK_T]]): CE_POINTER [NATURAL_8]
		local
			l_ds_new: CE_POINTER [PD_DIR_STACK_T]
			l_ds_ptr: CE_POINTER [PD_DIR_STACK_T]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ds_new := create {CE_CLASS_POINTER [PD_DIR_STACK_T]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_DIR_STACK_T}.make).structure_size.to_natural_32)))
					if l_ds_new.is_void then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_ds_new.item.next := a_stackptr.item
						a_stackptr.item := l_ds_new
						if not (((create {P_WINDOW_STATIC}).vim_isAbsName (a_dirbuf)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:;
						(a_stackptr.item).item.dirname := (create {P_MISC2_STATIC}).vim_strsave (a_dirbuf)
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						if not (((a_stackptr.item).item.next).is_void) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:;
						(a_stackptr.item).item.dirname := (create {P_MISC2_STATIC}).vim_strsave (a_dirbuf)
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if (a_stackptr.item).is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if not (dir_stack.item.item).is_equal (a_stackptr.item) then
							(a_stackptr.item).item.dirname := (create {P_MISC2_STATIC}).vim_strsave (a_dirbuf)
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						l_ds_new := (a_stackptr.item).item.next;
						(a_stackptr.item).item.dirname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						from
						until
							not (not (l_break) and then (not l_ds_new.is_void))
						loop
							l_break := False;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((a_stackptr.item).item.dirname));
							(a_stackptr.item).item.dirname := (create {P_MISC1_STATIC}).concat_fnames (l_ds_new.item.dirname, a_dirbuf, 1)
							if ((create {P_OS_UNIX_STATIC}).mch_isdir ((a_stackptr.item).item.dirname)) = 1 then
								l_break := True
							end
							if not (l_break) then
								l_ds_new := l_ds_new.item.next
							end
						end
						l_break := False
						from
						until
							((a_stackptr.item).item.next).is_equal (l_ds_new)
						loop
							l_ds_ptr := (a_stackptr.item).item.next;
							(a_stackptr.item).item.next := ((a_stackptr.item).item.next).item.next;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ds_ptr.item.dirname));
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ds_ptr))
						end
						if l_ds_new.is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((a_stackptr.item).item.dirname));
							(a_stackptr.item).item.dirname := (create {P_MISC2_STATIC}).vim_strsave (a_dirbuf)
						end
				when 11 then -- if done | if done
						if not ((a_stackptr.item).item.dirname).is_void then
							Result := ((a_stackptr.item).item.dirname)
						else
							l_ds_ptr := a_stackptr.item
							a_stackptr.item := (a_stackptr.item).item.next;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ds_ptr))
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	qf_pop_dir (a_stackptr: CE_POINTER [CE_POINTER [PD_DIR_STACK_T]]): CE_POINTER [NATURAL_8]
		require
			not a_stackptr.is_void
		local
			l_ds_ptr: CE_POINTER [PD_DIR_STACK_T]
			l_tmp: CE_POINTER [NATURAL_8]
		do
			if not (a_stackptr.item).is_void then
				l_ds_ptr := a_stackptr.item
				a_stackptr.item := (a_stackptr.item).item.next;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ds_ptr.item.dirname));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ds_ptr))
			end
			if (not (a_stackptr.item).is_void) then
				l_tmp := (a_stackptr.item).item.dirname
			else
				l_tmp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			end
			Result := l_tmp
		end

	qf_clean_dir_stack (a_stackptr: CE_POINTER [CE_POINTER [PD_DIR_STACK_T]])
		require
			not a_stackptr.is_void
		local
			l_ds_ptr: CE_POINTER [PD_DIR_STACK_T]
			l_break: BOOLEAN
		do
			from
			until
				(l_break)
			loop
				l_break := False
				l_ds_ptr := a_stackptr.item
				if l_ds_ptr.is_void then
					l_break := True
				end
				if not (l_break) then
					a_stackptr.item := (a_stackptr.item).item.next;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ds_ptr.item.dirname));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ds_ptr))
				end
			end
			l_break := False
		end

	qf_guess_filepath (a_filename: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_ds_ptr: CE_POINTER [PD_DIR_STACK_T]
			l_ds_tmp: CE_POINTER [PD_DIR_STACK_T]
			l_fullname: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			if (dir_stack.item.item).is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_ds_ptr := dir_stack.item.item.item.next
				l_fullname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				from
				until
					not (not (l_break) and then (not l_ds_ptr.is_void))
				loop
					l_break := False;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fullname))
					l_fullname := (create {P_MISC1_STATIC}).concat_fnames (l_ds_ptr.item.dirname, a_filename, 1)
					if not l_fullname.is_void then
						if ((create {P_OS_UNIX_STATIC}).mch_getperm (l_fullname)) >= 0 then
							l_break := True
						end
					end
					if not (l_break) then
						l_ds_ptr := l_ds_ptr.item.next
					end
				end
				l_break := False;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fullname))
				from
				until
					(dir_stack.item.item.item.next).is_equal (l_ds_ptr)
				loop
					l_ds_tmp := dir_stack.item.item.item.next
					dir_stack.item.item.item.next := (dir_stack.item.item.item.next).item.next;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ds_tmp.item.dirname));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ds_tmp))
				end
				if l_ds_ptr.is_void then
					l_tmp___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				else
					l_tmp___0 := l_ds_ptr.item.dirname
				end
				Result := l_tmp___0
			end
		end

	qf_jump (a_qi: CE_POINTER [PD_QF_INFO_S]; a_dir___0, a_errornr, a_forceit: INTEGER_32)
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_errornr: INTEGER_32
			l_ll_ref: CE_POINTER [PD_QF_INFO_S]
			l_qf_ptr: CE_POINTER [PD_QFLINE_S]
			l_old_qf_ptr: CE_POINTER [PD_QFLINE_S]
			l_qf_index: INTEGER_32
			l_old_qf_fnum: INTEGER_32
			l_old_qf_index: INTEGER_32
			l_prev_index: INTEGER_32
			l_err: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_old_lnum: INTEGER_32
			l_screen_col: INTEGER_32
			l_char_col: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_old_swb: CE_POINTER [NATURAL_8]
			l_old_swb_flags: NATURAL_32
			l_opened_window: INTEGER_32
			l_win: CE_POINTER [PD_WINDOW_S]
			l_altwin: CE_POINTER [PD_WINDOW_S]
			l_flags___0: INTEGER_32
			l_oldwin: CE_POINTER [PD_WINDOW_S]
			l_print_message: INTEGER_32
			l_len: INTEGER_32
			l_old_KeyTyped: INTEGER_32
			l_ok: INTEGER_32
			l_usable_win: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_wp___1: CE_POINTER [PD_WINDOW_S]
			l_tmp___11: CE_POINTER [PD_WINDOW_S]
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_save_cursor: PD_POS_T
			l_tmp___15: CE_POINTER [NATURAL_8]
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_qi := a_qi
					l_errornr := a_errornr
					l_err := e_no_more_items.item
					l_old_swb := (create {P_OPTION_STATIC}).p_swb.item.item
					l_old_swb_flags := (create {P_OPTION_STATIC}).swb_flags.item.item
					l_opened_window := 0
					l_oldwin := (create {P_GLOBALS_STATIC}).curwin.item
					l_print_message := 1
					l_old_KeyTyped := (create {P_GLOBALS_STATIC}).KeyTyped.item
					l_ok := 1
					if l_qi.is_void then
						l_qi := ql_info.item
					end
					if l_qi.item.qf_curlist >= l_qi.item.qf_listcount then
						l_tmp := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_quickfix.item)));
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
						l_return := True
					elseif l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count = 0 then
						l_tmp := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_quickfix.item)));
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
						l_return := True
					end
					if l_return then
						l_pos := -1 + 92 -- skip if block
					end
				when 1 then -- if:
						l_qf_ptr := l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_ptr
						l_old_qf_ptr := l_qf_ptr
						l_qf_index := l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_index
						l_old_qf_index := l_qf_index
						if a_dir___0 /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___4
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 4 then -- else:
						if a_dir___0 /= 3 then
							l_pos := -1 + 25 -- skip if block
						end
				when 5 then -- if: | _L___4:
						if (l_return or l_break) then
							l_pos := -1 + 23 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						l_tmp___1 := l_errornr
						l_errornr := l_errornr - 1
						if not l_tmp___1.to_boolean then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 22 -- skip if block
						end
				when 7 then -- if:
						l_old_qf_ptr := l_qf_ptr
						l_prev_index := l_qf_index
						l_old_qf_fnum := l_qf_ptr.item.qf_fnum
				when 8 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 21 -- skip loop
						end
				when 9 then -- loop body:
						l_break := False
						if l_qf_index /= l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 12 then -- else:
						if not ((l_qf_ptr.item.qf_next).is_void) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | _L:
						l_qf_ptr := l_old_qf_ptr
						l_qf_index := l_prev_index
						if not l_err.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (l_err))))).do_nothing
							l_pos := -1 + 91 -- goto theend
						end
				when 14 then
						l_errornr := 0
						l_break := True
				when 15 then -- if done
						if (l_break) then
							l_pos := -1 + 20 -- skip if block
						end
				when 16 then -- if:
						l_qf_index := l_qf_index + 1
						l_qf_ptr := l_qf_ptr.item.qf_next
						if (l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_nonevalid).to_boolean then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if (l_qf_ptr.item.qf_valid).to_boolean then
							l_pos := -1 + 19 -- goto _L___0
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___0:
						if a_dir___0 = 3 then
							if l_qf_ptr.item.qf_fnum /= l_old_qf_fnum then
								l_break := True
							end
						else
							l_break := True
						end
				when 20 then -- if done
						l_pos := -1 + 8 -- back to loop condition
				when 21 then -- loop done
						l_break := False
						l_err := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				when 22 then -- if done
						l_pos := -1 + 5 -- back to loop condition
				when 23 then -- loop done
						l_break := False
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 25 then -- else:
						if a_dir___0 /= -1 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 29 -- goto _L___3
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 28 then -- else:
						if a_dir___0 /= -3 then
							l_pos := -1 + 49 -- skip if block
						end
				when 29 then -- if: | _L___3:
						if (l_return or l_break) then
							l_pos := -1 + 47 -- skip loop
						end
				when 30 then -- loop body:
						l_break := False
						l_tmp___3 := l_errornr
						l_errornr := l_errornr - 1
						if not l_tmp___3.to_boolean then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 46 -- skip if block
						end
				when 31 then -- if:
						l_old_qf_ptr := l_qf_ptr
						l_prev_index := l_qf_index
						l_old_qf_fnum := l_qf_ptr.item.qf_fnum
				when 32 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 45 -- skip loop
						end
				when 33 then -- loop body:
						l_break := False
						if l_qf_index /= 1 then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_pos := -1 + 37 -- goto _L___1
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 36 then -- else:
						if not ((l_qf_ptr.item.qf_prev).is_void) then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if: | _L___1:
						l_qf_ptr := l_old_qf_ptr
						l_qf_index := l_prev_index
						if not l_err.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (l_err))))).do_nothing
							l_pos := -1 + 91 -- goto theend
						end
				when 38 then
						l_errornr := 0
						l_break := True
				when 39 then -- if done
						if (l_return or l_break) then
							l_pos := -1 + 44 -- skip if block
						end
				when 40 then -- if:
						l_qf_index := l_qf_index - 1
						l_qf_ptr := l_qf_ptr.item.qf_prev
						if (l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_nonevalid).to_boolean then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						if (l_qf_ptr.item.qf_valid).to_boolean then
							l_pos := -1 + 43 -- goto _L___2
						end
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else: | _L___2:
						if a_dir___0 = -3 then
							if l_qf_ptr.item.qf_fnum /= l_old_qf_fnum then
								l_break := True
							end
						else
							l_break := True
						end
				when 44 then -- if done
						l_pos := -1 + 32 -- back to loop condition
				when 45 then -- loop done
						l_break := False
						l_err := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				when 46 then -- if done
						l_pos := -1 + 29 -- back to loop condition
				when 47 then -- loop done
						l_break := False
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else:
						if l_errornr /= 0 then
							from
							until
								(l_break)
							loop
								l_break := False
								if l_errornr < l_qf_index then
									if l_qf_index > 1 then
										if (l_qf_ptr.item.qf_prev).is_void then
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_qf_index := l_qf_index - 1
									l_qf_ptr := l_qf_ptr.item.qf_prev
								end
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								if l_errornr > l_qf_index then
									if l_qf_index < l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count then
										if (l_qf_ptr.item.qf_next).is_void then
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_qf_index := l_qf_index + 1
									l_qf_ptr := l_qf_ptr.item.qf_next
								end
							end
							l_break := False
						end
				when 50 then -- if done | if done | if done
						l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_index := l_qf_index
						if (l_qi.item.qf_win_pos_update (l_old_qf_index)).to_boolean then
							l_print_message := 0
						end
						if (l_qf_ptr.item.qf_type).to_integer_32 /= 1 then
							l_pos := -1 + 61 -- skip if block
						end
				when 51 then -- if:
						if (((create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer).item.b_help).to_boolean then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
						l_pos := -1 + 55 -- goto _L___6
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 54 then -- else:
						if (create {P_GLOBALS_STATIC}).cmdmod.item.item.tab = 0 then
							l_pos := -1 + 61 -- skip if block
						end
				when 55 then -- if: | _L___6:
						if (create {P_GLOBALS_STATIC}).cmdmod.item.item.tab /= 0 then
							l_wp___0 := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
						else
							l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
							from
							until
								not (not (l_break) and then (not l_wp___0.is_void))
							loop
								l_break := False
								if not (l_wp___0.item.w_buffer).is_void then
									if ((l_wp___0.item.w_buffer).item.b_help).to_boolean then
										l_break := True
									end
								end
								if not (l_return or l_break) then
									l_wp___0 := l_wp___0.item.w_next
								end
							end
							l_break := False
						end
						if l_wp___0.is_void then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						if (l_wp___0.item.w_buffer).item.b_nwindows > 0 then
							(create {P_WINDOW_STATIC}).win_enter (l_wp___0, 1)
						else
							l_pos := -1 + 58 -- goto _L___5
						end
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 60
				when 58 then -- else: | _L___5:
						l_flags___0 := 16
						if (create {P_GLOBALS_STATIC}).cmdmod.item.item.split = 0 then
							if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_width).to_integer_32 /= (create {P_GLOBALS_STATIC}).Columns.item.item then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_width < 80 then
									l_flags___0 := (l_flags___0).bit_or ((4))
								end
							end
						end
						if not l_qi.is_equal (ql_info.item) then
							l_flags___0 := (l_flags___0).bit_or ((128))
						end
						if ((create {P_WINDOW_STATIC}).win_split (0, l_flags___0)) = 0 then
							l_pos := -1 + 91 -- goto theend
						end
				when 59 then
						l_opened_window := 1
						if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_height).to_integer_32 < (create {P_OPTION_STATIC}).p_hh.item.item then
							(create {P_WINDOW_STATIC}).win_setheight (((create {P_OPTION_STATIC}).p_hh.item.item).to_integer_32)
						end
						if not l_qi.is_equal (ql_info.item) then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_llist := l_qi
							l_qi.item.qf_refcount := (l_qi.item.qf_refcount) + 1
						end
				when 60 then
						if not ((create {P_OPTION_STATIC}).p_im.item.item).to_boolean then
							(create {P_GLOBALS_STATIC}).restart_edit.item := 0
						end
				when 61 then -- if done | if done
						if not ((((create {P_GLOBALS_STATIC}).curbuf.item).item.bt_quickfix).to_boolean) then
							l_pos := -1 + 81 -- skip if block
						end
				when 62 then -- if:
						if l_opened_window.to_boolean then
							l_pos := -1 + 81 -- skip if block
						end
				when 63 then -- if:
						if l_qf_ptr.item.qf_fnum = 0 then
							l_pos := -1 + 91 -- goto theend
						end
				when 64 then
						l_usable_win := 0
						l_win := (create {P_GLOBALS_STATIC}).firstwin.item
						from
						until
							not (not (l_break) and then (not l_win.is_void))
						loop
							l_break := False
							if ((l_win.item.w_buffer).item.b_p_bt[0]).to_integer_32 = 0 then
								l_usable_win := 1
								l_break := True
							end
							if not (l_return or l_break) then
								l_win := l_win.item.w_next
							end
						end
						l_break := False
						if l_usable_win.to_boolean then
							l_pos := -1 + 73 -- skip if block
						end
				when 65 then -- if:
						if not ((((create {P_OPTION_STATIC}).swb_flags.item.item).bit_and ({NATURAL_32} 2)).to_boolean) then
							l_pos := -1 + 73 -- skip if block
						end
				when 66 then -- if:
						l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
				when 67 then -- loop condition:
						if not (not (l_return) and then (not l_tp.is_void)) then
							l_pos := -1 + 73 -- skip loop
						end
				when 68 then -- loop body:
						if l_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
							l_wp___1 := (create {P_GLOBALS_STATIC}).firstwin.item
						else
							l_wp___1 := l_tp.item.tp_firstwin
						end
				when 69 then -- loop condition:
						if l_wp___1.is_void then
							l_pos := -1 + 72 -- skip loop
						end
				when 70 then -- loop body:
						if (l_wp___1.item.w_buffer).item.b_fnum = l_qf_ptr.item.qf_fnum then
							(create {P_WINDOW_STATIC}).goto_tabpage_win (l_tp, l_wp___1)
							l_usable_win := 1
							l_pos := -1 + 73 -- goto win_found
						end
				when 71 then
						l_wp___1 := l_wp___1.item.w_next
						l_pos := -1 + 69 -- back to loop condition
				when 72 then -- loop done
						l_tp := l_tp.item.tp_next
						l_pos := -1 + 67 -- back to loop condition
				when 73 then -- loop done | if done | win_found:
						if not (((create {P_GLOBALS_STATIC}).firstwin.item).is_equal ((create {P_GLOBALS_STATIC}).lastwin.item)) then
							l_pos := -1 + 76 -- skip if block
						end
				when 74 then -- if:
						if (((create {P_GLOBALS_STATIC}).curbuf.item).item.bt_quickfix).to_boolean then
							l_pos := -1 + 77 -- goto _L___7
						else
							l_pos := -1 + 76 -- goto _L___8
						end
				when 75 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 76 then -- else: | _L___8:
						if l_usable_win.to_boolean then
							l_pos := -1 + 80 -- skip if block
						end
				when 77 then -- if: | _L___7:
						l_ll_ref := (create {P_GLOBALS_STATIC}).curwin.item.item.w_llist_ref
						l_flags___0 := 64
						if not l_ll_ref.is_void then
							l_flags___0 := (l_flags___0).bit_or ((128))
						end
						if ((create {P_WINDOW_STATIC}).win_split (0, l_flags___0)) = 0 then
							l_pos := -1 + 90 -- goto failed
						end
				when 78 then
						l_opened_window := 1;
						(create {P_OPTION_STATIC}).p_swb.item.item := (create {P_GLOBALS_STATIC}).empty_option.item;
						(create {P_OPTION_STATIC}).swb_flags.item.item := {NATURAL_32} 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_scb := 0
						if not l_ll_ref.is_void then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_llist := l_ll_ref
							l_ll_ref.item.qf_refcount := (l_ll_ref.item.qf_refcount) + 1
						end
				when 79 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 80 then -- else:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_llist_ref).is_void then
							l_ll_ref := (create {P_GLOBALS_STATIC}).curwin.item.item.w_llist_ref
							l_win := (create {P_GLOBALS_STATIC}).firstwin.item
							from
							until
								not (not (l_break) and then (not l_win.is_void))
							loop
								l_break := False
								if (l_win.item.w_llist).is_equal (l_ll_ref) then
									l_break := True
								end
								if not (l_return or l_break) then
									l_win := l_win.item.w_next
								end
							end
							l_break := False
							if l_win.is_void then
								l_win := (create {P_GLOBALS_STATIC}).firstwin.item
								from
								until
									not (not (l_break) and then (not l_win.is_void))
								loop
									l_break := False
									if (l_win.item.w_buffer).item.b_fnum = l_qf_ptr.item.qf_fnum then
										l_break := True
									end
									if not (l_return or l_break) then
										l_win := l_win.item.w_next
									end
								end
								l_break := False
								if l_win.is_void then
									l_win := (create {P_GLOBALS_STATIC}).curwin.item
									from
									until
										not (not (l_break) and then (((l_win.item.w_buffer).item.b_p_bt[0]).to_integer_32 /= 0))
									loop
										l_break := False
										if (l_win.item.w_prev).is_void then
											l_win := (create {P_GLOBALS_STATIC}).lastwin.item
										else
											l_win := l_win.item.w_prev
										end
										if l_win.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
											l_break := True
										end
									end
									l_break := False
								end
							end
							(create {P_WINDOW_STATIC}).win_goto (l_win)
							if (l_win.item.w_llist).is_void then
								l_win.item.w_llist := l_ll_ref
								l_ll_ref.item.qf_refcount := (l_ll_ref.item.qf_refcount) + 1
							end
						else
							l_win := (create {P_GLOBALS_STATIC}).curwin.item
							l_altwin := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
							from
							until
								not (not (l_break) and then ((l_win.item.w_buffer).item.b_fnum /= l_qf_ptr.item.qf_fnum))
							loop
								l_break := False
								if (l_win.item.w_prev).is_void then
									l_win := (create {P_GLOBALS_STATIC}).lastwin.item
								else
									l_win := l_win.item.w_prev
								end
								if ((l_win.item.w_buffer).item.bt_quickfix).to_boolean then
									if (l_win.item.w_llist_ref).is_void then
										if not l_altwin.is_void then
											l_win := l_altwin
										elseif not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_prev).is_void then
											l_win := (create {P_GLOBALS_STATIC}).curwin.item.item.w_prev
										else
											l_win := (create {P_GLOBALS_STATIC}).curwin.item.item.w_next
										end
										l_break := True
									end
								end
								if not (l_return or l_break) and then (l_altwin.is_void) then
									if not (l_win.item.w_onebuf_opt.wo_pvw).to_boolean then
										if ((l_win.item.w_buffer).item.b_p_bt[0]).to_integer_32 = 0 then
											l_altwin := l_win
										end
									end
								end
							end
							l_break := False;
							(create {P_WINDOW_STATIC}).win_goto (l_win)
						end
				when 81 then -- if done | if done | if done
						l_old_curbuf := (create {P_GLOBALS_STATIC}).curbuf.item
						l_old_lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
						if l_qf_ptr.item.qf_fnum /= 0 then
							if (l_qf_ptr.item.qf_type).to_integer_32 = 1 then
								if (((create {P_GLOBALS_STATIC}).curbuf.item).item.can_abandon (a_forceit)).to_boolean then
									if l_oldwin.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
										l_tmp___11 := (create {P_GLOBALS_STATIC}).curwin.item
									else
										l_tmp___11 := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
									end
									l_ok := (create {P_EX_CMDS_STATIC}).do_ecmd (l_qf_ptr.item.qf_fnum, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), (1).to_integer_32, 3, l_tmp___11)
								else
									(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_nowrtmsg.item)))))).do_nothing
									l_ok := 0
								end
							else
								l_ok := (create {P_BUFFER_STATIC}).buflist_getfile (l_qf_ptr.item.qf_fnum, (1).to_integer_32, 5, a_forceit)
							end
						end
						if l_ok /= 1 then
							l_pos := -1 + 89 -- skip if block
						end
				when 82 then -- if:
						if ((create {P_GLOBALS_STATIC}).curbuf.item).is_equal (l_old_curbuf) then
							(create {P_MARK_STATIC}).setpcmark
						end
						if (l_qf_ptr.item.qf_pattern).is_void then
							l_i___0 := l_qf_ptr.item.qf_lnum
							if l_i___0 > 0 then
								if l_i___0 > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
									l_i___0 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
								end
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_i___0
							end
							if l_qf_ptr.item.qf_col > 0 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_qf_ptr.item.qf_col - 1
								if (l_qf_ptr.item.qf_viscol).to_integer_32 = 1 then
									l_line := (create {P_MEMLINE_STATIC}).ml_get_curline
									l_screen_col := 0
									l_char_col := 0
									from
									until
										not (not (l_break) and then (l_char_col < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col))
									loop
										l_break := False
										if (l_line.item).to_integer_32 = 0 then
											l_break := True
										end
										if not (l_return or l_break) then
											l_tmp___13 := l_line
											l_line := l_line + 1
											if (l_tmp___13.item).to_integer_32 = 9 then
												(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - (7 - l_screen_col \\ 8)
												l_screen_col := l_screen_col + (8 - l_screen_col \\ 8)
											else
												l_screen_col := l_screen_col + 1
											end
											l_char_col := l_char_col + 1
										end
									end
									l_break := False
								end
								(create {P_MISC2_STATIC}).check_cursor
							else
								(create {P_EDIT_STATIC}).beginline (5)
							end
						else
							l_save_cursor := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (0).to_integer_32
							if not ((create {P_SEARCH_STATIC}).do_search (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('/').code, l_qf_ptr.item.qf_pattern, 1, 1_024, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))).to_boolean then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_save_cursor.twin
							end
						end
						if (((create {P_OPTION_STATIC}).fdo_flags.item.item).bit_and ({NATURAL_32} 32)).to_boolean then
							if l_old_KeyTyped.to_boolean then
								(create {P_FOLD_STATIC}).foldOpenCursor
							end
						end
						if not (l_print_message.to_boolean) then
							l_pos := -1 + 88 -- skip if block
						end
				when 83 then -- if:;
						(create {P_MOVE_STATIC}).update_topline_redraw
						l_tmp___15 := qf_types ((l_qf_ptr.item.qf_type).to_integer_32, l_qf_ptr.item.qf_nr)
						if (l_qf_ptr.item.qf_cleared).to_boolean then
							l_tmp___17 := (gettext (ce_string (" (line deleted)")))
						else
							l_tmp___17 := ce_string ("")
						end
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("(%%d of %%d)%%s%%s: "))), l_qf_index, l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count, l_tmp___17, create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___15)]).do_nothing
						l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item))).to_integer_32
						qf_fmt_text (((create {P_CHARSET_STATIC}).skipwhite (l_qf_ptr.item.qf_text)), (create {P_GLOBALS_STATIC}).IObuff.item + l_len, 1_025 - l_len)
						l_i___0 := ((create {P_GLOBALS_STATIC}).msg_scroll.item).to_integer_32
						if not (((create {P_GLOBALS_STATIC}).curbuf.item).is_equal (l_old_curbuf)) then
							l_pos := -1 + 86 -- skip if block
						end
				when 84 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = l_old_lnum then
							(create {P_GLOBALS_STATIC}).msg_scroll.item := 1
						else
							l_pos := -1 + 86 -- goto _L___9
						end
				when 85 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 86 then -- else: | _L___9:
						if not ((create {P_GLOBALS_STATIC}).msg_scrolled.item).to_boolean then
							if ((create {P_OPTION_STATIC}).shortmess (('O').code)).to_boolean then
								(create {P_GLOBALS_STATIC}).msg_scroll.item := 0
							end
						end
				when 87 then;
						(create {P_MESSAGE_STATIC}).msg_attr_keep ((create {P_GLOBALS_STATIC}).IObuff.item, 0, 1).do_nothing;
						(create {P_GLOBALS_STATIC}).msg_scroll.item := l_i___0.to_integer_32
				when 88 then -- if done | if block done, skip else block:
						l_pos := -1 + 91
				when 89 then -- else:
						if l_opened_window.to_boolean then
							(create {P_WINDOW_STATIC}).win_close ((create {P_GLOBALS_STATIC}).curwin.item, 1)
						end
						if l_qf_ptr.item.qf_fnum = 0 then
							l_pos := -1 + 91 -- skip if block
						end
				when 90 then -- if: | failed:
						l_qf_ptr := l_old_qf_ptr
						l_qf_index := l_old_qf_index
				when 91 then -- if done | theend:
						l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_ptr := l_qf_ptr
						l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_index := l_qf_index
						if not ((create {P_OPTION_STATIC}).p_swb.item.item).is_equal (l_old_swb) then
							if l_opened_window.to_boolean then
								if ((create {P_OPTION_STATIC}).p_swb.item.item).is_equal ((create {P_GLOBALS_STATIC}).empty_option.item) then
									(create {P_OPTION_STATIC}).p_swb.item.item := l_old_swb;
									(create {P_OPTION_STATIC}).swb_flags.item.item := l_old_swb_flags
								else
									(create {P_OPTION_STATIC}).free_string_option (l_old_swb)
								end
							end
						end
				when 92 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	qf_fmt_text (a_text, a_buf___6: CE_POINTER [NATURAL_8]; a_bufsize: INTEGER_32)
		require
			not a_text.is_void
			not a_buf___6.is_void
		local
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			l_p___0 := a_text
			l_i___0 := 0
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if (l_p___0.item).to_integer_32 /= 0 then
					if not (l_i___0 < a_bufsize - 1) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_return or l_break) then
					if (l_p___0.item).to_integer_32 = 10 then
						a_buf___6[l_i___0] := ((' ').code).to_natural_8
						from
						until
							(l_break)
						loop
							l_break := False
							l_p___0 := l_p___0 + 1
							if (l_p___0.item).to_integer_32 = 0 then
								l_break := True
							end
							if not (l_break) and then ((l_p___0.item).to_integer_32 /= 32) then
								if (l_p___0.item).to_integer_32 /= 9 then
									if (l_p___0.item).to_integer_32 /= 10 then
										l_break := True
									end
								end
							end
						end
						l_break := False
					else
						l_tmp := l_p___0
						l_p___0 := l_p___0 + 1
						a_buf___6[l_i___0] := l_tmp.item
					end
					l_i___0 := l_i___0 + 1
				end
			end
			l_break := False
			a_buf___6[l_i___0] := (('%/0/').code).to_natural_8
		end

	qf_mark_adjust (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_line1, a_line2, a_amount, a_amount_after: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_qfp: CE_POINTER [PD_QFLINE_S]
			l_idx: INTEGER_32
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_qi := ql_info.item
					if not a_wp___0.is_void then
						if (a_wp___0.item.w_llist).is_void then
							l_return := True
						end
						if not l_return then
							l_qi := a_wp___0.item.w_llist
						end
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_idx := 0
				when 2 then -- loop condition:
						if not (not (l_return) and then (l_idx < l_qi.item.qf_listcount)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 3 then -- loop body:
						if not ((l_qi.item.qf_lists[l_idx].qf_count).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						l_i___0 := 0
						l_qfp := l_qi.item.qf_lists[l_idx].qf_start
				when 5 then -- loop condition:
						if not (l_i___0 < l_qi.item.qf_lists[l_idx].qf_count) then
							l_pos := -1 + 12 -- skip loop
						end
				when 6 then -- loop body:
						if l_qfp.item.qf_fnum /= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum then
							l_pos := -1 + 11 -- skip if block
						end
				when 7 then -- if:
						if not (l_qfp.item.qf_lnum >= a_line1) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_qfp.item.qf_lnum <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_qfp.item.qf_cleared := (1).to_natural_8
							else
								l_qfp.item.qf_lnum := l_qfp.item.qf_lnum + a_amount
							end
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if a_amount_after.to_boolean then
							if l_qfp.item.qf_lnum > a_line2 then
								l_qfp.item.qf_lnum := l_qfp.item.qf_lnum + a_amount_after
							end
						end
				when 11 then -- if done
						l_i___0 := l_i___0 + 1
						l_qfp := l_qfp.item.qf_next
						l_pos := -1 + 5 -- back to loop condition
				when 12 then -- loop done | if done
						l_idx := l_idx + 1
						l_pos := -1 + 2 -- back to loop condition
				when 13 then -- loop done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	qf_types (a_c, a_nr: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_c /= 87 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" warning"))
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 3 then -- else:
						if a_c /= 119 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" warning"))
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else:
						if a_c /= 73 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" info"))
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 9 then -- else:
						if a_c /= 105 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" info"))
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 12 then -- else:
						if a_c /= 69 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" error"))
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else:
						if a_c /= 101 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" error"))
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else:
						if a_c /= 0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if a_nr > 0 then
							l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" error"))
						else
							l_pos := -1 + 21 -- goto _L
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else: | _L:
						if a_c = 0 then
							l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
						elseif a_c = 1 then
							l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
						else
							cc.item[0] := ((' ').code).to_natural_8
							cc.item[1] := a_c.to_natural_8
							cc.item[2] := (('%/0/').code).to_natural_8
							l_p___0 := cc.item
						end
				when 22 then -- if done | if done | if done | if done | if done | if done
					if a_nr <= 0 then
						Result := l_p___0
						l_return := True
					end
					if not l_return then
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (buf___2.item), ce_string ("%%s %%3d"), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), a_nr]).do_nothing
						Result := buf___2.item
					end
				when 23 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	qf_find_win (a_qi: CE_POINTER [PD_QF_INFO_S]): CE_POINTER [PD_WINDOW_S]
		local
			l_win: CE_POINTER [PD_WINDOW_S]
			l_break: BOOLEAN
		do
			l_win := (create {P_GLOBALS_STATIC}).firstwin.item
			from
			until
				not (not (l_break) and then (not l_win.is_void))
			loop
				l_break := False
				if (l_win.item.is_qf_win (a_qi)).to_boolean then
					l_break := True
				end
				if not (l_break) then
					l_win := l_win.item.w_next
				end
			end
			l_break := False
			Result := l_win
		end

	qf_find_buf (a_qi: CE_POINTER [PD_QF_INFO_S]): CE_POINTER [PD_FILE_BUFFER]
		local
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_win: CE_POINTER [PD_WINDOW_S]
			l_return: BOOLEAN
		do
			l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
			from
			until
				not (not (l_return) and then (not l_tp.is_void))
			loop
				if l_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
					l_win := (create {P_GLOBALS_STATIC}).firstwin.item
				else
					l_win := l_tp.item.tp_firstwin
				end
				from
				until
					not (not (l_return) and then (not l_win.is_void))
				loop
					if (l_win.item.is_qf_win (a_qi)).to_boolean then
						Result := (l_win.item.w_buffer)
						l_return := True
					end
					if not l_return then
						l_win := l_win.item.w_next
					end
				end
				if not l_return then
					l_tp := l_tp.item.tp_next
				end
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
			end
		end

	qf_update_buffer (a_qi: CE_POINTER [PD_QF_INFO_S])
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_aco: CE_ARRAY [PD_ACO_SAVE_T]
		do
			create {CE_CLASS_ARRAY [PD_ACO_SAVE_T]} l_aco.make (<<1>>)

			l_buf___6 := qf_find_buf (a_qi)
			if not l_buf___6.is_void then
				l_aco.item.aucmd_prepbuf (l_buf___6)
				a_qi.item.qf_fill_buffer
				l_aco.item.aucmd_restbuf
				a_qi.item.qf_win_pos_update (0).do_nothing
			end
		end

	get_errorlist (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_list: CE_POINTER [PD_LISTVAR_S]): INTEGER_32
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_dict: CE_POINTER [PD_DICTVAR_S]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_qfp: CE_POINTER [PD_QFLINE_S]
			l_i___0: INTEGER_32
			l_bufnum: INTEGER_32
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<2>>)

			l_qi := ql_info.item
			if not a_wp___0.is_void then
				if ((a_wp___0.item.w_buffer).item.bt_quickfix).to_boolean then
					if not (a_wp___0.item.w_llist_ref).is_void then
						l_qi := a_wp___0.item.w_llist_ref
					else
						l_qi := a_wp___0.item.w_llist
					end
				else
					l_qi := a_wp___0.item.w_llist
				end
				if l_qi.is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if l_qi.item.qf_curlist >= l_qi.item.qf_listcount then
					Result := 0
					l_return := True
				elseif l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count = 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_qfp := l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_start
				l_i___0 := 1
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						if not (l_i___0 <= l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_return or l_break) then
						l_bufnum := l_qfp.item.qf_fnum
						if l_bufnum /= 0 then
							if ((create {P_BUFFER_STATIC}).buflist_findnr (l_bufnum)).is_void then
								l_bufnum := 0
							end
						end
						l_dict := (create {P_EVAL_STATIC}).dict_alloc
						if l_dict.is_void then
							Result := 0
							l_return := True
						end
						if not l_return then
							if ((create {P_EVAL_STATIC}).list_append_dict (a_list, l_dict)) = 0 then
								Result := 0
								l_return := True
							end
						end
						if not l_return then
							l_buf___6[0] := l_qfp.item.qf_type
							l_buf___6[1] := (('%/0/').code).to_natural_8
							if ((create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("bufnr"), l_bufnum.to_integer_32, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))) = 0 then
								Result := 0
								l_return := True
							elseif ((create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("lnum"), l_qfp.item.qf_lnum, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))) = 0 then
								Result := 0
								l_return := True
							elseif ((create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("col"), (l_qfp.item.qf_col).to_integer_32, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))) = 0 then
								Result := 0
								l_return := True
							elseif ((create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("vcol"), (l_qfp.item.qf_viscol).to_integer_32, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))) = 0 then
								Result := 0
								l_return := True
							elseif ((create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("nr"), (l_qfp.item.qf_nr).to_integer_32, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))) = 0 then
								Result := 0
								l_return := True
							else
								if (l_qfp.item.qf_pattern).is_void then
									l_tmp___8 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
								else
									l_tmp___8 := l_qfp.item.qf_pattern
								end
								if ((create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("pattern"), 0, l_tmp___8)) = 0 then
									Result := 0
									l_return := True
								else
									if (l_qfp.item.qf_text).is_void then
										l_tmp___10 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
									else
										l_tmp___10 := l_qfp.item.qf_text
									end
									if ((create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("text"), 0, l_tmp___10)) = 0 then
										Result := 0
										l_return := True
									elseif ((create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("type"), 0, l_buf___6)) = 0 then
										Result := 0
										l_return := True
									elseif ((create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("valid"), (l_qfp.item.qf_valid).to_integer_32, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))) = 0 then
										Result := 0
										l_return := True
									end
								end
							end
						end
						if not l_return then
							l_qfp := l_qfp.item.qf_next
							l_i___0 := l_i___0 + 1
						end
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 1
			end
		end

	set_errorlist (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_list: CE_POINTER [PD_LISTVAR_S]; a_action: INTEGER_32; a_title: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_li: CE_POINTER [PD_LISTITEM_S]
			l_d: CE_POINTER [PD_DICTVAR_S]
			l_filename: CE_POINTER [NATURAL_8]
			l_pattern: CE_POINTER [NATURAL_8]
			l_text: CE_POINTER [NATURAL_8]
			l_type: CE_POINTER [NATURAL_8]
			l_bufnum: INTEGER_32
			l_lnum: INTEGER_32
			l_col: INTEGER_32
			l_nr: INTEGER_32
			l_vcol: INTEGER_32
			l_prevp: CE_ARRAY [CE_POINTER [PD_QFLINE_S]]
			l_valid: INTEGER_32
			l_status: INTEGER_32
			l_retval: INTEGER_32
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_did_bufnr_emsg: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [PD_DICTVAR_S]} l_d.make
			create {CE_POINTER_ARRAY [PD_QFLINE_S]} l_prevp.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_prevp.item := create {CE_CLASS_POINTER [PD_QFLINE_S]}.make_shared (default_pointer)
					l_retval := 1
					l_qi := ql_info.item
					l_did_bufnr_emsg := 0
					if not a_wp___0.is_void then
						l_qi := a_wp___0.item.ll_get_or_alloc_list
						if l_qi.is_void then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 21 -- skip if block
					end
				when 1 then -- if:
						if a_action /= 32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_qi.item.qf_new_list (a_title)
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						if l_qi.item.qf_curlist /= l_qi.item.qf_listcount then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_qi.item.qf_new_list (a_title)
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if a_action /= 97 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_count > 0 then
							l_prevp.item := l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_start
							from
							until
								(l_prevp.item.item.qf_next).is_equal (l_prevp.item)
							loop
								l_prevp.item := l_prevp.item.item.qf_next
							end
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if a_action = 114 then
							l_qi.item.qf_free (l_qi.item.qf_curlist)
						end
				when 11 then -- if done | if done
						l_li := a_list.item.lv_first
				when 12 then -- loop condition:
						if not (not (l_break) and then (not l_li.is_void)) then
							l_pos := -1 + 20 -- skip loop
						end
				when 13 then -- loop body:
						l_break := False
						l_continue := False
						if (l_li.item.li_tv.v_type).to_integer_32 /= 5 then
							l_continue := True
						end
						if not (l_break or l_continue) then
							l_d := l_li.item.li_tv.vval.v_dict
							if l_d.is_void then
								l_continue := True
							end
						end
						if (l_break or l_continue) then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						l_filename := (create {P_EVAL_STATIC}).get_dict_string (l_d, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("filename")), 1)
						l_bufnum := ((create {P_EVAL_STATIC}).get_dict_number (l_d, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bufnr")))).to_integer_32
						l_lnum := (create {P_EVAL_STATIC}).get_dict_number (l_d, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lnum")))
						l_col := ((create {P_EVAL_STATIC}).get_dict_number (l_d, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("col")))).to_integer_32
						l_vcol := ((create {P_EVAL_STATIC}).get_dict_number (l_d, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vcol")))).to_integer_32
						l_nr := ((create {P_EVAL_STATIC}).get_dict_number (l_d, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("nr")))).to_integer_32
						l_type := (create {P_EVAL_STATIC}).get_dict_string (l_d, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("type")), 1)
						l_pattern := (create {P_EVAL_STATIC}).get_dict_string (l_d, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("pattern")), 1)
						l_text := (create {P_EVAL_STATIC}).get_dict_string (l_d, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("text")), 1)
						if l_text.is_void then
							l_text := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
						end
						l_valid := 1
						if not (l_filename.is_void) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if l_bufnum = 0 then
							l_valid := 0
						else
							l_pos := -1 + 17 -- goto _L___0
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L___0:
						if l_lnum = 0 then
							if l_pattern.is_void then
								l_valid := 0
							end
						end
				when 18 then
						if l_bufnum /= 0 then
							if ((create {P_BUFFER_STATIC}).buflist_findnr (l_bufnum)).is_void then
								if not l_did_bufnr_emsg.to_boolean then
									l_did_bufnr_emsg := 1;
									(create {P_MISC2_STATIC}).emsgn (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E92: Buffer %%ld not found")))), l_bufnum.to_integer_32).do_nothing
								end
								l_valid := 0
								l_bufnum := 0
							end
						end
						if l_type.is_void then
							l_tmp___5 := ('%/0/').code
						else
							l_tmp___5 := (l_type.item).to_integer_32
						end
						l_status := qf_add_entry (l_qi, l_prevp, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_filename, l_bufnum, l_text, l_lnum, l_col, l_vcol, l_pattern, l_nr, l_tmp___5, l_valid);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_filename));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pattern));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_text));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_type))
						if l_status = 0 then
							l_retval := 0
							l_break := True
						end
				when 19 then -- if done
						if (not l_break) then
							l_li := l_li.item.li_next
						end
						l_pos := -1 + 12 -- back to loop condition
				when 20 then -- loop done
						l_break := False
						l_continue := False
						if l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_index = 0 then
							l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_nonevalid := 1
						else
							l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_nonevalid := 0
						end
						l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_ptr := l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_start
						l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_index := 1
						qf_update_buffer (l_qi)
						Result := l_retval
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
