class
	P_UI_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_UNISTD_STATIC
	S_LIBINTL_STATIC
	S_X11_INTRINSIC_STATIC
	S_X11_XLIB_STATIC
	S_X11_XUTIL_STATIC
	S_TIME_STATIC

feature {ANY} -- public attributes

	ta_str: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	ta_off: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	ta_len: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	count___1: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	inbuf: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<4_102>>)
		end

	inbufcount: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	did_read_something: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	rest: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				>>)
		end

	restlen: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					0
				>>)
		end

	vim_atom: CE_STATIC [NATURAL_32]
		once ("PROCESS")
		end

	vimenc_atom: CE_STATIC [NATURAL_32]
		once ("PROCESS")
		end

	compound_text_atom: CE_STATIC [NATURAL_32]
		once ("PROCESS")
		end

	text_atom: CE_STATIC [NATURAL_32]
		once ("PROCESS")
		end

	targets_atom: CE_STATIC [NATURAL_32]
		once ("PROCESS")
		end

	timestamp_atom: CE_STATIC [NATURAL_32]
		once ("PROCESS")
		end

	on_status_line: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	on_sep_line: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	prev_row___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	prev_col___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	dragwin: CE_STATIC [CE_POINTER [PD_WINDOW_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
		end

	did_drag: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	last_time: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (0).to_integer_32
		end

feature {ANY} -- public routines

	ui_write (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_len: CE_ARRAY [INTEGER_32]
			l_s: CE_POINTER [NATURAL_8]
			l_tofree: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_len.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len.item := a_len
					l_s := a_s
					if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
						if not ((create {P_GUI_STATIC}).gui.item.item.dying).to_boolean then
							if not ((create {P_GUI_STATIC}).gui.item.item.starting).to_boolean then
								(create {P_GUI_STATIC}).gui_write (l_s, l_len.item)
								if ((create {P_OPTION_STATIC}).p_wd.item.item).to_boolean then
									(create {P_GUI_STATIC}).gui_wait_for_chars ((create {P_OPTION_STATIC}).p_wd.item.item).do_nothing
								end
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_GLOBALS_STATIC}).silent_mode.item).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (create {P_OPTION_STATIC}).p_verbose.item.item /= 0 then
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_tofree := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type /= 0 then
							l_tofree := (create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, l_s, l_len)
							if not l_tofree.is_void then
								l_s := l_tofree
							end
						end
						(create {P_OS_UNIX_STATIC}).mch_write (l_s, l_len.item)
						if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type /= 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tofree))
						end
				when 5 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ui_inchar_undo (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_new: CE_POINTER [NATURAL_8]
			l_newlen: INTEGER_32
		do
			l_newlen := a_len
			if not ta_str.item.is_void then
				l_newlen := l_newlen + (ta_len.item - ta_off.item)
			end
			l_new := (create {P_MISC2_STATIC}).alloc (l_newlen.to_natural_32)
			if not l_new.is_void then
				if not ta_str.item.is_void then
					memmove (create {CE_VOID_POINTER}.make_cast (l_new), create {CE_VOID_POINTER}.make_cast ((ta_str.item + ta_off.item)), (ta_len.item - ta_off.item).to_natural_32).do_nothing
					memmove (create {CE_VOID_POINTER}.make_cast (((l_new + ta_len.item) - ta_off.item)), create {CE_VOID_POINTER}.make_cast (a_s), a_len.to_natural_32).do_nothing;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (ta_str.item))
				else
					memmove (create {CE_VOID_POINTER}.make_cast (l_new), create {CE_VOID_POINTER}.make_cast (a_s), a_len.to_natural_32).do_nothing
				end
				ta_str.item := l_new
				ta_len.item := l_newlen
				ta_off.item := 0
			end
		end

	ui_inchar (a_buf___6: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32; a_wtime: INTEGER_32; a_tb_change_cnt: INTEGER_32): INTEGER_32
		local
			l_retval: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := 0
					if not ta_str.item.is_void then
						if a_maxlen >= ta_len.item - ta_off.item then
							memmove (create {CE_VOID_POINTER}.make_cast (a_buf___6), create {CE_VOID_POINTER}.make_cast ((ta_str.item + ta_off.item)), ta_len.item.to_natural_32).do_nothing;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (ta_str.item))
							ta_str.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							Result := ta_len.item
							l_return := True
						end
						if not l_return then
							memmove (create {CE_VOID_POINTER}.make_cast (a_buf___6), create {CE_VOID_POINTER}.make_cast ((ta_str.item + ta_off.item)), a_maxlen.to_natural_32).do_nothing
							ta_off.item := ta_off.item + a_maxlen
							Result := a_maxlen
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_GUI_STATIC}).no_console_input).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if a_wtime >= 0 then
							if a_wtime < 10 then
								l_tmp := 10
							else
								l_tmp := a_wtime
							end
						else
							l_tmp := a_wtime
						end
						l_retval := (create {P_OS_UNIX_STATIC}).mch_inchar (a_buf___6, a_maxlen, l_tmp, a_tb_change_cnt)
						if l_retval > 0 then
							l_pos := -1 + 10 -- goto theend
						elseif ((create {P_GETCHAR_STATIC}).typebuf_changed (a_tb_change_cnt)).to_boolean then
							l_pos := -1 + 10 -- goto theend
						elseif a_wtime >= 0 then
							l_pos := -1 + 10 -- goto theend
						end
				when 3 then
						if a_wtime = -1 then
							count___1.item := count___1.item + 1
							if count___1.item = 1_000 then
								read_error_exit
							end
						end
						a_buf___6[0] := (('%R').code).to_natural_8
						l_retval := 1
						l_pos := -1 + 10 -- goto theend
				when 4 then
						if a_wtime /= -1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if not (a_wtime > 100) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:;
						(create {P_OS_UNIX_STATIC}).vim_handle_signal (-2).do_nothing
						if ((create {P_GLOBALS_STATIC}).mapped_ctrl_c.item).to_boolean then
							(create {P_GLOBALS_STATIC}).ctrl_c_interrupts.item := 0
						end
				when 9 then -- if done
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							if ((create {P_GUI_STATIC}).gui_wait_for_chars (a_wtime)).to_boolean then
								if not ((create {P_GETCHAR_STATIC}).typebuf_changed (a_tb_change_cnt)).to_boolean then
									l_retval := read_from_input_buf (a_buf___6, a_maxlen.to_integer_32)
								end
							end
						else
							l_retval := (create {P_OS_UNIX_STATIC}).mch_inchar (a_buf___6, a_maxlen, a_wtime, a_tb_change_cnt)
						end
						if a_wtime = -1 then
							(create {P_OS_UNIX_STATIC}).vim_handle_signal (-1).do_nothing
						elseif a_wtime > 100 then
							(create {P_OS_UNIX_STATIC}).vim_handle_signal (-1).do_nothing
						end
						(create {P_GLOBALS_STATIC}).ctrl_c_interrupts.item := 1
				when 10 then -- theend:
						Result := l_retval
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ui_char_avail: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_GUI_GTK_X11_STATIC}).gui_mch_update
				Result := ((create {P_GETCHAR_STATIC}).input_available)
				l_return := True
			end
			if not l_return then
				if ((create {P_GUI_STATIC}).no_console_input).to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := ((create {P_OS_UNIX_STATIC}).mch_char_avail)
			end
		end

	ui_delay (a_msec: INTEGER_32; a_ignoreinput: INTEGER_32)
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				if not a_ignoreinput.to_boolean then
					(create {P_GUI_STATIC}).gui_wait_for_chars (a_msec).do_nothing
				else
					(create {P_OS_UNIX_STATIC}).mch_delay (a_msec, a_ignoreinput)
				end
			else
				(create {P_OS_UNIX_STATIC}).mch_delay (a_msec, a_ignoreinput)
			end
		end

	ui_suspend
		local
			l_return: BOOLEAN
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_GUI_GTK_X11_STATIC}).gui_mch_iconify
				l_return := True
			end
			if not l_return then
				(create {P_OS_UNIX_STATIC}).mch_suspend
			end
		end

	ui_get_shellsize: INTEGER_32
		local
			l_retval: INTEGER_32
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				l_retval := (create {P_GUI_STATIC}).gui_get_shellsize
			else
				l_retval := (create {P_OS_UNIX_STATIC}).mch_get_shellsize
			end
			(create {P_TERM_STATIC}).check_shellsize
			if l_retval = 1 then
				(create {P_OPTION_STATIC}).set_number_default (ce_string ("lines"), (create {P_GLOBALS_STATIC}).Rows.item.item);
				(create {P_OPTION_STATIC}).set_number_default (ce_string ("columns"), (create {P_GLOBALS_STATIC}).Columns.item.item)
			end
			Result := l_retval
		end

	ui_set_shellsize (a_mustset: INTEGER_32)
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_GUI_STATIC}).gui_set_shellsize (a_mustset, 0, 15)
			else
				(create {P_OS_UNIX_STATIC}).mch_set_shellsize
			end
		end

	ui_new_shellsize
		do
			if ((create {P_GLOBALS_STATIC}).full_screen.item).to_boolean then
				if not ((create {P_GLOBALS_STATIC}).exiting.item).to_boolean then
					if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
						(create {P_GUI_STATIC}).gui_new_shellsize
					else
						(create {P_OS_UNIX_STATIC}).mch_new_shellsize
					end
				end
			end
		end

	ui_breakcheck
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_GUI_GTK_X11_STATIC}).gui_mch_update
			else
				(create {P_OS_UNIX_STATIC}).mch_breakcheck
			end
		end

	clip_init (a_can_use: INTEGER_32)
		local
			l_cb: CE_POINTER [PD_VIMCLIPBOARD]
			l_break: BOOLEAN
		do
			l_cb := (create {P_GLOBALS_STATIC}).clip_star.item
			from
			until
				(l_break)
			loop
				l_break := False
				l_cb.item.available := a_can_use
				l_cb.item.owned := 0
				l_cb.item.start.lnum := (0).to_integer_32
				l_cb.item.start.col := 0
				l_cb.item.end2.lnum := (0).to_integer_32
				l_cb.item.end2.col := 0
				l_cb.item.state := (0).to_natural_16
				if l_cb.is_equal ((create {P_GLOBALS_STATIC}).clip_plus.item) then
					l_break := True
				end
				if not (l_break) then
					l_cb := (create {P_GLOBALS_STATIC}).clip_plus.item
				end
			end
			l_break := False
		end

	clip_update_selection
		local
			l_start___1: PD_POS_T
			l_end: PD_POS_T
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_GLOBALS_STATIC}).redo_VIsual_busy.item).to_boolean then
						l_pos := -1 + 23 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 2 then -- if:
						if not ((((create {P_GLOBALS_STATIC}).State.item).bit_and (1)).to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 3 then -- if:
						if (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							l_tmp___2 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum).to_integer
						else
							if (create {P_GLOBALS_STATIC}).VIsual.item.item.col /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
								l_tmp___1 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.col < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col).to_integer
							else
								l_tmp___1 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.coladd < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd).to_integer
							end
							l_tmp___2 := l_tmp___1
						end
						if l_tmp___2.to_boolean then
							l_start___1 := ((create {P_GLOBALS_STATIC}).VIsual.item.item).twin
							l_end := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_end.col := l_end.col + (((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([((create {P_MEMLINE_STATIC}).ml_get_cursor)])) - 1)
							end
						else
							l_start___1 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
							l_end := ((create {P_GLOBALS_STATIC}).VIsual.item.item).twin
						end
						if (create {P_GLOBALS_STATIC}).clip_star.item.item.start.lnum /= l_start___1.lnum then
							l_pos := -1 + 22 -- skip if block
						end
				when 4 then -- if:
						if (create {P_GLOBALS_STATIC}).clip_star.item.item.start.col /= l_start___1.col then
							l_pos := -1 + 20 -- skip if block
						end
				when 5 then -- if:
						if (create {P_GLOBALS_STATIC}).clip_star.item.item.start.coladd /= l_start___1.coladd then
							l_pos := -1 + 18 -- skip if block
						end
				when 6 then -- if:
						if (create {P_GLOBALS_STATIC}).clip_star.item.item.end2.lnum /= l_end.lnum then
							l_pos := -1 + 16 -- skip if block
						end
				when 7 then -- if:
						if (create {P_GLOBALS_STATIC}).clip_star.item.item.end2.col /= l_end.col then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
						if (create {P_GLOBALS_STATIC}).clip_star.item.item.end2.coladd /= l_end.coladd then
							l_pos := -1 + 12 -- skip if block
						end
				when 9 then -- if:
						if (create {P_GLOBALS_STATIC}).clip_star.item.item.vmode = (create {P_GLOBALS_STATIC}).VIsual_mode.item then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						clip_clear_selection;
						(create {P_GLOBALS_STATIC}).clip_star.item.item.start := l_start___1.twin;
						(create {P_GLOBALS_STATIC}).clip_star.item.item.end2 := l_end.twin;
						(create {P_GLOBALS_STATIC}).clip_star.item.item.vmode := (create {P_GLOBALS_STATIC}).VIsual_mode.item;
						(create {P_OPS_STATIC}).clip_free_selection ((create {P_GLOBALS_STATIC}).clip_star.item);
						((create {P_GLOBALS_STATIC}).clip_star.item).item.clip_own_selection
						clip_gen_set_selection ((create {P_GLOBALS_STATIC}).clip_star.item)
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_pos := -1 + 10 -- goto _L
				when 13 then -- if done | if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_pos := -1 + 10 -- goto _L
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 10 -- goto _L
				when 17 then -- if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_pos := -1 + 10 -- goto _L
				when 19 then -- if done | if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_pos := -1 + 10 -- goto _L
				when 21 then -- if done | if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_pos := -1 + 10 -- goto _L
				when 23 then -- if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_copy_selection
		do
			if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
				if (((create {P_GLOBALS_STATIC}).State.item).bit_and (1)).to_boolean then
					if ((create {P_GLOBALS_STATIC}).clip_star.item.item.available).to_boolean then
						if (clip_isautosel).to_boolean then
							clip_update_selection
						end
						(create {P_OPS_STATIC}).clip_free_selection ((create {P_GLOBALS_STATIC}).clip_star.item);
						((create {P_GLOBALS_STATIC}).clip_star.item).item.clip_own_selection
						if ((create {P_GLOBALS_STATIC}).clip_star.item.item.owned).to_boolean then
							((create {P_GLOBALS_STATIC}).clip_star.item).item.clip_get_selection
						end
						clip_gen_set_selection ((create {P_GLOBALS_STATIC}).clip_star.item)
					end
				end
			end
		end

	clip_auto_select
		do
			if (clip_isautosel).to_boolean then
				clip_copy_selection
			end
		end

	clip_isautosel: INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				l_tmp___0 := (not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_go.item.item, ('a').code)).is_void).to_integer
			else
				l_tmp___0 := (create {P_GLOBALS_STATIC}).clip_autoselect.item
			end
			Result := l_tmp___0
		end

	clip_modeless (a_button, a_is_click, a_is_drag: INTEGER_32)
		local
			l_repeat: INTEGER_32
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_GLOBALS_STATIC}).clip_star.item.item.mode).to_integer_32 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if ((create {P_GLOBALS_STATIC}).clip_star.item.item.mode).to_integer_32 /= 2 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___0:
						if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (32)).to_boolean then
							l_tmp := 1
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if ((create {P_GLOBALS_STATIC}).clip_star.item.item.mode).to_integer_32 = 1 then
							if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (64)).to_boolean then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 7 then -- if done
					l_repeat := l_tmp
					if not (a_is_click.to_boolean) then
						l_pos := -1 + 10 -- skip if block
					end
				when 8 then -- if:
						if a_button = 2 then
							if ((create {P_GLOBALS_STATIC}).clip_star.item.item.state).to_integer_32 = 0 then
								clip_start_selection ((create {P_GLOBALS_STATIC}).mouse_col.item, (create {P_GLOBALS_STATIC}).mouse_row.item, 0)
							end
							clip_process_selection (a_button, (create {P_GLOBALS_STATIC}).mouse_col.item, (create {P_GLOBALS_STATIC}).mouse_row.item, l_repeat.to_natural_32)
						else
							l_pos := -1 + 10 -- goto _L___1
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___1:
						if a_is_click.to_boolean then
							clip_start_selection ((create {P_GLOBALS_STATIC}).mouse_col.item, (create {P_GLOBALS_STATIC}).mouse_row.item, l_repeat)
						elseif a_is_drag.to_boolean then
							if ((create {P_GLOBALS_STATIC}).clip_star.item.item.state).to_integer_32 /= 0 then
								clip_process_selection (a_button, (create {P_GLOBALS_STATIC}).mouse_col.item, (create {P_GLOBALS_STATIC}).mouse_row.item, l_repeat.to_natural_32)
							end
						else
							clip_process_selection (3, (create {P_GLOBALS_STATIC}).mouse_col.item, (create {P_GLOBALS_STATIC}).mouse_row.item, (0).to_natural_32)
						end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_compare_pos (a_row1, a_col1, a_row2, a_col2: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_row1 > a_row2 then
				Result := 1
				l_return := True
			end
			if not l_return and then (a_row1 < a_row2) then
				Result := (-1)
				l_return := True
			end
			if not l_return and then (a_col1 > a_col2) then
				Result := 1
				l_return := True
			end
			if not l_return and then (a_col1 < a_col2) then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	clip_start_selection (a_col, a_row, a_repeated_click: INTEGER_32)
		local
			l_col: INTEGER_32
			l_row: INTEGER_32
			l_cb: CE_POINTER [PD_VIMCLIPBOARD]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_col := a_col
					l_row := a_row
					l_cb := (create {P_GLOBALS_STATIC}).clip_star.item
					if (l_cb.item.state).to_integer_32 = 2 then
						clip_clear_selection
					end
					l_row := check_row (l_row)
					l_col := check_col (l_col)
					l_col := (create {P_MBYTE_STATIC}).mb_fix_col (l_col, l_row)
					l_cb.item.start.lnum := l_row.to_integer_32
					l_cb.item.start.col := l_col
					l_cb.item.end2 := (l_cb.item.start).twin
					l_cb.item.origin_row := (l_cb.item.start.lnum).to_natural_16
					l_cb.item.state := (1).to_natural_16
					if a_repeated_click.to_boolean then
						l_cb.item.mode := ((l_cb.item.mode).to_integer_32 + 1).to_natural_16
						if l_cb.item.mode > 2 then
							l_cb.item.mode := (0).to_natural_16
						end
					else
						l_cb.item.mode := (0).to_natural_16
					end
					if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
						(create {P_GUI_STATIC}).gui_undraw_cursor
					end
					inspect (l_cb.item.mode).to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 0
					l_cb.item.origin_start_col := (l_cb.item.start.col).to_natural_16
					l_cb.item.word_end_col := (clip_get_line_end ((l_cb.item.start.lnum).to_integer_32)).to_natural_16
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 1
					clip_get_word_boundaries (l_cb, (l_cb.item.start.lnum).to_integer_32, l_cb.item.start.col)
					l_cb.item.origin_start_col := l_cb.item.word_start_col
					l_cb.item.origin_end_col := l_cb.item.word_end_col
					clip_invert_area ((l_cb.item.start.lnum).to_integer_32, (l_cb.item.word_start_col).to_integer_32, (l_cb.item.end2.lnum).to_integer_32, (l_cb.item.word_end_col).to_integer_32, 2)
					l_cb.item.start.col := (l_cb.item.word_start_col).to_integer_32
					l_cb.item.end2.col := (l_cb.item.word_end_col).to_integer_32
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 2
					clip_invert_area ((l_cb.item.start.lnum).to_integer_32, 0, (l_cb.item.start.lnum).to_integer_32, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32, 2)
					l_cb.item.start.col := 0
					l_cb.item.end2.col := ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					l_cb.item.prev := (l_cb.item.start).twin
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_process_selection (a_button, a_col, a_row: INTEGER_32; a_repeated_click: NATURAL_32)
		local
			l_col: INTEGER_32
			l_row: INTEGER_32
			l_cb: CE_POINTER [PD_VIMCLIPBOARD]
			l_diff: INTEGER_32
			l_slen: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_col := a_col
					l_row := a_row
					l_cb := (create {P_GLOBALS_STATIC}).clip_star.item
					l_slen := 1
					if a_button = 3 then
						if l_cb.item.start.lnum = l_cb.item.end2.lnum then
							if l_cb.item.start.col = l_cb.item.end2.col then
								if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
									(create {P_GUI_STATIC}).gui_update_cursor (0, 0)
								end
								l_cb.item.state := (0).to_natural_16
								l_return := True
							end
						end
						if not l_return then
							if (clip_isautosel).to_boolean then
								clip_copy_modeless_selection (0)
							else
								if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
									l_tmp___1 := (not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_go.item.item, ('A').code)).is_void).to_integer
								else
									l_tmp___1 := (create {P_GLOBALS_STATIC}).clip_autoselectml.item
								end
								if l_tmp___1.to_boolean then
									clip_copy_modeless_selection (0)
								end
							end
							if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
								(create {P_GUI_STATIC}).gui_update_cursor (0, 0)
							end
							l_cb.item.state := (2).to_natural_16
							l_return := True
						end
					end
					if not l_return then
						l_row := check_row (l_row)
						l_col := check_col (l_col)
						l_col := (create {P_MBYTE_STATIC}).mb_fix_col (l_col, l_row)
						if l_col = l_cb.item.prev.col then
							if l_row.to_integer_32 = l_cb.item.prev.lnum then
								if not a_repeated_click.to_boolean then
									l_return := True
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						if (l_cb.item.state).to_integer_32 /= 2 then
							l_pos := -1 + 14 -- skip if block
						end
				when 2 then -- if:
						if a_button /= 2 then
							l_pos := -1 + 14 -- skip if block
						end
				when 3 then -- if:
						if not ((clip_compare_pos (l_row, l_col, (l_cb.item.start.lnum).to_integer_32, l_cb.item.start.col)) < 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_cb.item.origin_row := (l_cb.item.end2.lnum).to_natural_16
						l_cb.item.origin_start_col := (l_cb.item.end2.col - 1).to_natural_16
						l_cb.item.origin_end_col := (l_cb.item.end2.col).to_natural_16
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not ((clip_compare_pos (l_row, l_col, (l_cb.item.end2.lnum).to_integer_32, l_cb.item.end2.col)) < 0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if l_cb.item.start.lnum /= l_cb.item.end2.lnum then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_cb.item.end2.col - l_col > l_col - l_cb.item.start.col then
							l_cb.item.origin_row := (l_cb.item.end2.lnum).to_natural_16
							l_cb.item.origin_start_col := (l_cb.item.end2.col - 1).to_natural_16
							l_cb.item.origin_end_col := (l_cb.item.end2.col).to_natural_16
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						l_diff := ((l_cb.item.end2.lnum - l_row.to_integer_32) - (l_row.to_integer_32 - l_cb.item.start.lnum)).to_integer_32
						if l_diff > 0 then
							l_cb.item.origin_row := (l_cb.item.end2.lnum).to_natural_16
							l_cb.item.origin_start_col := (l_cb.item.end2.col - 1).to_natural_16
							l_cb.item.origin_end_col := (l_cb.item.end2.col).to_natural_16
						elseif l_diff = 0 then
							if l_col < (l_cb.item.start.col + l_cb.item.end2.col) // 2 then
								l_cb.item.origin_row := (l_cb.item.end2.lnum).to_natural_16
								l_cb.item.origin_start_col := (l_cb.item.end2.col - 1).to_natural_16
								l_cb.item.origin_end_col := (l_cb.item.end2.col).to_natural_16
							else
								l_cb.item.origin_row := (l_cb.item.start.lnum).to_natural_16
								l_cb.item.origin_start_col := (l_cb.item.start.col).to_natural_16
								l_cb.item.origin_end_col := (l_cb.item.start.col).to_natural_16
							end
						else
							l_cb.item.origin_row := (l_cb.item.start.lnum).to_natural_16
							l_cb.item.origin_start_col := (l_cb.item.start.col).to_natural_16
							l_cb.item.origin_end_col := (l_cb.item.start.col).to_natural_16
						end
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_cb.item.origin_row := (l_cb.item.start.lnum).to_natural_16
						l_cb.item.origin_start_col := (l_cb.item.start.col).to_natural_16
						l_cb.item.origin_end_col := (l_cb.item.start.col).to_natural_16
				when 13 then -- if done
						if (l_cb.item.mode).to_integer_32 = 1 then
							if not a_repeated_click.to_boolean then
								l_cb.item.mode := (0).to_natural_16
							end
						end
				when 14 then -- if done | if done
						l_cb.item.state := (1).to_natural_16
						if a_repeated_click.to_boolean then
							l_cb.item.mode := ((l_cb.item.mode).to_integer_32 + 1).to_natural_16
							if l_cb.item.mode > 2 then
								l_cb.item.mode := (0).to_natural_16
							end
						end
						inspect (l_cb.item.mode).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 15
						when 1 then l_pos := -1 + 16
						when 2 then l_pos := -1 + 17
						else l_pos := -1 + 18
						end
				when 15 then -- switch 1, case 0
						if l_row.to_integer_32 /= l_cb.item.prev.lnum then
							l_cb.item.word_end_col := (clip_get_line_end (l_row)).to_natural_16
						end
						if (clip_compare_pos (l_row, l_col, (l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32)) >= 0 then
							if l_col >= (l_cb.item.word_end_col).to_integer_32 then
								l_cb.item.clip_update_modeless_selection ((l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32, l_row, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32)
							else
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									if ((create {P_MBYTE_STATIC}).mb_lefthalve (l_row, l_col)).to_boolean then
										l_slen := 2
									end
								end
								l_cb.item.clip_update_modeless_selection ((l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32, l_row, l_col + l_slen)
							end
						else
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								if ((create {P_MBYTE_STATIC}).mb_lefthalve ((l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32)).to_boolean then
									l_slen := 2
								end
							end
							if l_col >= (l_cb.item.word_end_col).to_integer_32 then
								l_cb.item.clip_update_modeless_selection (l_row, (l_cb.item.word_end_col).to_integer_32, (l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32 + l_slen)
							else
								l_cb.item.clip_update_modeless_selection (l_row, l_col, (l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32 + l_slen)
							end
						end
						l_pos := -1 + 18 -- switch 1; break
				when 16 then -- switch 1, case 1
						if l_row.to_integer_32 = l_cb.item.prev.lnum then
							if l_col >= (l_cb.item.word_start_col).to_integer_32 then
								if l_col < (l_cb.item.word_end_col).to_integer_32 then
									if not a_repeated_click.to_boolean then
										l_return := True
									end
								end
							end
						end
						if not l_return then
							clip_get_word_boundaries (l_cb, l_row, l_col)
							if (clip_compare_pos (l_row, l_col, (l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32)) >= 0 then
								l_cb.item.clip_update_modeless_selection ((l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32, l_row, (l_cb.item.word_end_col).to_integer_32)
							else
								l_cb.item.clip_update_modeless_selection (l_row, (l_cb.item.word_start_col).to_integer_32, (l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_end_col).to_integer_32)
							end
						end
						l_pos := -1 + 18 -- switch 1; break
				when 17 then -- switch 1, case 2
						if l_row.to_integer_32 = l_cb.item.prev.lnum then
							if not a_repeated_click.to_boolean then
								l_return := True
							end
						end
						if not l_return then
							if (clip_compare_pos (l_row, l_col, (l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32)) >= 0 then
								l_cb.item.clip_update_modeless_selection ((l_cb.item.origin_row).to_integer_32, 0, l_row, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32)
							else
								l_cb.item.clip_update_modeless_selection (l_row, 0, (l_cb.item.origin_row).to_integer_32, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32)
							end
						end
						l_pos := -1 + 18 -- switch 1; break
				when 18 then -- switch 1, done: | if done
					if not l_return then
						l_cb.item.prev.lnum := l_row.to_integer_32
						l_cb.item.prev.col := l_col
					end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_may_redraw_selection (a_row, a_col, a_len: INTEGER_32)
		local
			l_start___1: INTEGER_32
			l_end: INTEGER_32
		do
			l_start___1 := a_col
			l_end := a_col + a_len
			if ((create {P_GLOBALS_STATIC}).clip_star.item.item.state).to_integer_32 /= 0 then
				if a_row.to_integer_32 >= (create {P_GLOBALS_STATIC}).clip_star.item.item.start.lnum then
					if a_row.to_integer_32 <= (create {P_GLOBALS_STATIC}).clip_star.item.item.end2.lnum then
						if a_row.to_integer_32 = (create {P_GLOBALS_STATIC}).clip_star.item.item.start.lnum then
							if l_start___1 < (create {P_GLOBALS_STATIC}).clip_star.item.item.start.col then
								l_start___1 := (create {P_GLOBALS_STATIC}).clip_star.item.item.start.col
							end
						end
						if a_row.to_integer_32 = (create {P_GLOBALS_STATIC}).clip_star.item.item.end2.lnum then
							if l_end > (create {P_GLOBALS_STATIC}).clip_star.item.item.end2.col then
								l_end := (create {P_GLOBALS_STATIC}).clip_star.item.item.end2.col
							end
						end
						if l_end > l_start___1 then
							clip_invert_area (a_row, l_start___1, a_row, l_end, 0)
						end
					end
				end
			end
		end

	clip_clear_selection
		local
			l_cb: CE_POINTER [PD_VIMCLIPBOARD]
			l_return: BOOLEAN
		do
			l_cb := (create {P_GLOBALS_STATIC}).clip_star.item
			if (l_cb.item.state).to_integer_32 = 0 then
				l_return := True
			end
			if not l_return then
				clip_invert_area ((l_cb.item.start.lnum).to_integer_32, l_cb.item.start.col, (l_cb.item.end2.lnum).to_integer_32, l_cb.item.end2.col, 1)
				l_cb.item.state := (0).to_natural_16
			end
		end

	clip_may_clear_selection (a_row1, a_row2: INTEGER_32)
		do
			if ((create {P_GLOBALS_STATIC}).clip_star.item.item.state).to_integer_32 = 2 then
				if a_row2.to_integer_32 >= (create {P_GLOBALS_STATIC}).clip_star.item.item.start.lnum then
					if a_row1.to_integer_32 <= (create {P_GLOBALS_STATIC}).clip_star.item.item.end2.lnum then
						clip_clear_selection
					end
				end
			end
		end

	clip_scroll_selection (a_rows: INTEGER_32)
		local
			l_lnum: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).clip_star.item.item.state).to_integer_32 = 0 then
				l_return := True
			end
			if not l_return then
				l_lnum := ((create {P_GLOBALS_STATIC}).clip_star.item.item.start.lnum - a_rows.to_integer_32).to_integer_32
				if l_lnum <= 0 then
					(create {P_GLOBALS_STATIC}).clip_star.item.item.start.lnum := (0).to_integer_32
				elseif l_lnum >= (create {P_GLOBALS_STATIC}).screen_Rows.item then
					(create {P_GLOBALS_STATIC}).clip_star.item.item.state := (0).to_natural_16
				else
					(create {P_GLOBALS_STATIC}).clip_star.item.item.start.lnum := l_lnum.to_integer_32
				end
				l_lnum := ((create {P_GLOBALS_STATIC}).clip_star.item.item.end2.lnum - a_rows.to_integer_32).to_integer_32
				if l_lnum < 0 then
					(create {P_GLOBALS_STATIC}).clip_star.item.item.state := (0).to_natural_16
				elseif l_lnum >= (create {P_GLOBALS_STATIC}).screen_Rows.item then
					(create {P_GLOBALS_STATIC}).clip_star.item.item.end2.lnum := ((create {P_GLOBALS_STATIC}).screen_Rows.item - 1).to_integer_32
				else
					(create {P_GLOBALS_STATIC}).clip_star.item.item.end2.lnum := l_lnum.to_integer_32
				end
			end
		end

	clip_invert_area (a_row1, a_col1, a_row2, a_col2, a_how: INTEGER_32)
		local
			l_row1: INTEGER_32
			l_col1: INTEGER_32
			l_row2: INTEGER_32
			l_col2: INTEGER_32
			l_invert: INTEGER_32
			l_tmp_row: INTEGER_32
			l_tmp_col: INTEGER_32
		do
			l_row1 := a_row1
			l_col1 := a_col1
			l_row2 := a_row2
			l_col2 := a_col2
			l_invert := 0
			if a_how = 2 then
				l_invert := 1
			end
			if (clip_compare_pos (l_row1, l_col1, l_row2, l_col2)) > 0 then
				l_tmp_row := l_row1
				l_tmp_col := l_col1
				l_row1 := l_row2
				l_col1 := l_col2
				l_row2 := l_tmp_row
				l_col2 := l_tmp_col
			elseif a_how = 3 then
				l_invert := 1
			end
			if l_row1 = l_row2 then
				clip_invert_rectangle (l_row1, l_col1, 1, l_col2 - l_col1, l_invert)
			else
				if l_col1 > 0 then
					clip_invert_rectangle (l_row1, l_col1, 1, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32 - l_col1, l_invert)
					l_row1 := l_row1 + 1
				end
				if l_col2.to_integer_32 < (create {P_GLOBALS_STATIC}).Columns.item.item - 1 then
					clip_invert_rectangle (l_row2, 0, 1, l_col2, l_invert)
					l_row2 := l_row2 - 1
				end
				if l_row2 >= l_row1 then
					clip_invert_rectangle (l_row1, 0, (l_row2 - l_row1) + 1, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32, l_invert)
				end
			end
		end

	clip_invert_rectangle (a_row, a_col, a_height, a_width, a_invert: INTEGER_32)
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_GUI_GTK_X11_STATIC}).gui_mch_invert_rectangle (a_row, a_col, a_height, a_width)
			else
				(create {P_SCREEN_STATIC}).screen_draw_rectangle (a_row, a_col, a_height, a_width, a_invert)
			end
		end

	clip_copy_modeless_selection (a_both: INTEGER_32)
		local
			l_buffer: CE_POINTER [NATURAL_8]
			l_bufp: CE_POINTER [NATURAL_8]
			l_row: INTEGER_32
			l_start_col: INTEGER_32
			l_end_col: INTEGER_32
			l_line_end_col: INTEGER_32
			l_add_newline_flag: INTEGER_32
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_row1: INTEGER_32
			l_col1: INTEGER_32
			l_row2: INTEGER_32
			l_col2: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_off___0: INTEGER_32
			l_i___1: INTEGER_32
			l_ci: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_add_newline_flag := 0
					l_row1 := ((create {P_GLOBALS_STATIC}).clip_star.item.item.start.lnum).to_integer_32
					l_col1 := (create {P_GLOBALS_STATIC}).clip_star.item.item.start.col
					l_row2 := ((create {P_GLOBALS_STATIC}).clip_star.item.item.end2.lnum).to_integer_32
					l_col2 := (create {P_GLOBALS_STATIC}).clip_star.item.item.end2.col
					if ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
						l_return := True
					end
					if not l_return then
						if l_row1 > l_row2 then
							l_row := l_row1
							l_row1 := l_row2
							l_row2 := l_row
							l_row := l_col1
							l_col1 := l_col2
							l_col2 := l_row
						elseif l_row1 = l_row2 then
							if l_col1 > l_col2 then
								l_row := l_col1
								l_col1 := l_col2
								l_col2 := l_row
							end
						end
						l_p___0 := (create {P_GLOBALS_STATIC}).ScreenLines.item + ((create {P_GLOBALS_STATIC}).LineOffset.item[l_row1]).to_integer_32
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 0 then
							l_col1 := l_col1 - ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_p___0, l_p___0 + l_col1]))
						elseif ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							if (l_p___0[l_col1]).to_integer_32 = 0 then
								l_col1 := l_col1 - 1
							end
						end
						l_len := (((l_row2 - l_row1) + 1).to_integer_32 * (create {P_GLOBALS_STATIC}).Columns.item.item + 1).to_integer_32
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 0 then
							l_len := l_len * (2)
						elseif ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							l_len := l_len * (21)
						end
						l_buffer := (create {P_MISC2_STATIC}).lalloc (l_len.to_natural_32, 1)
						if l_buffer.is_void then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 23 -- skip if block
					end
				when 1 then -- if:
						l_bufp := l_buffer
						l_row := l_row1
				when 2 then -- loop condition:
						if not (not (l_return) and then (l_row <= l_row2)) then
							l_pos := -1 + 22 -- skip loop
						end
				when 3 then -- loop body:
						if l_row = l_row1 then
							l_start_col := l_col1
						else
							l_start_col := 0
						end
						if l_row = l_row2 then
							l_end_col := l_col2
						else
							l_end_col := ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32
						end
						l_line_end_col := clip_get_line_end (l_row)
						if not (l_end_col.to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if not (l_row < l_row2) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if not (l_end_col > l_line_end_col) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						l_end_col := l_line_end_col
						if l_end_col < l_start_col then
							l_end_col := l_start_col
						end
						if l_row = l_row2 then
							l_add_newline_flag := 1
						end
				when 9 then -- if done | if done
						if l_row > l_row1 then
							if not ((create {P_GLOBALS_STATIC}).LineWraps.item[(l_row - 1)]).to_boolean then
								l_tmp___0 := l_bufp
								l_bufp := l_bufp + 1
								l_tmp___0.item := (('%N').code).to_natural_8
							end
						end
						if not (l_row < (create {P_GLOBALS_STATIC}).screen_Rows.item) then
							l_pos := -1 + 21 -- skip if block
						end
				when 10 then -- if:
						if not (l_end_col <= (create {P_GLOBALS_STATIC}).screen_Columns.item) then
							l_pos := -1 + 21 -- skip if block
						end
				when 11 then -- if:
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 0 then
							l_pos := -1 + 20 -- skip if block
						end
				when 12 then -- if:
						l_p___0 := (create {P_GLOBALS_STATIC}).ScreenLines.item + ((create {P_GLOBALS_STATIC}).LineOffset.item[l_row]).to_integer_32
						l_i___0 := l_start_col
				when 13 then -- loop condition:
						if not (l_i___0 < l_end_col) then
							l_pos := -1 + 19 -- skip loop
						end
				when 14 then -- loop body:
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 9_932 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if (l_p___0[l_i___0]).to_integer_32 = 142 then
							l_tmp___1 := l_bufp
							l_bufp := l_bufp + 1
							l_tmp___1.item := (142).to_natural_8
							l_tmp___2 := l_bufp
							l_bufp := l_bufp + 1
							l_tmp___2.item := (create {P_GLOBALS_STATIC}).ScreenLines2.item[((create {P_GLOBALS_STATIC}).LineOffset.item[l_row] + l_i___0.to_natural_32).to_integer_32]
						else
							l_pos := -1 + 17 -- goto _L___0
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L___0:
						l_tmp___3 := l_bufp
						l_bufp := l_bufp + 1
						l_tmp___3.item := l_p___0[l_i___0]
						if ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_p___0[l_i___0]).to_integer_32]).to_integer_32 = 2 then
							l_tmp___4 := l_bufp
							l_bufp := l_bufp + 1
							l_i___0 := l_i___0 + 1
							l_tmp___4.item := l_p___0[l_i___0]
						end
				when 18 then
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 13 -- back to loop condition
				when 19 then -- loop done | if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							l_off___0 := ((create {P_GLOBALS_STATIC}).LineOffset.item[l_row]).to_integer_32
							l_i___1 := l_start_col
							from
							until
								not (not (l_return) and then (l_i___1 < l_end_col))
							loop
								if (create {P_GLOBALS_STATIC}).ScreenLinesUC.item[(l_off___0 + l_i___1)] = {NATURAL_32} 0 then
									l_tmp___5 := l_bufp
									l_bufp := l_bufp + 1
									l_tmp___5.item := (create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off___0 + l_i___1)]
								else
									l_bufp := l_bufp + ((create {P_MBYTE_STATIC}).utf_char2bytes (((create {P_GLOBALS_STATIC}).ScreenLinesUC.item[(l_off___0 + l_i___1)]).to_integer_32, l_bufp))
									l_ci := 0
									from
									until
										not (not (l_break) and then (l_ci < (create {P_GLOBALS_STATIC}).Screen_mco.item))
									loop
										l_break := False
										if ((create {P_GLOBALS_STATIC}).ScreenLinesC.item[l_ci])[(l_off___0 + l_i___1)] = {NATURAL_32} 0 then
											l_break := True
										end
										if not (l_break) then
											l_bufp := l_bufp + ((create {P_MBYTE_STATIC}).utf_char2bytes ((((create {P_GLOBALS_STATIC}).ScreenLinesC.item[l_ci])[(l_off___0 + l_i___1)]).to_integer_32, l_bufp))
											l_ci := l_ci + 1
										end
									end
									l_break := False
								end
								if ((create {P_GLOBALS_STATIC}).ScreenLines.item[((l_off___0 + l_i___1) + 1)]).to_integer_32 = 0 then
									l_i___1 := l_i___1 + 1
								end
								l_i___1 := l_i___1 + 1
							end
						else
							strncpy (create {CE_INTEGER_8_POINTER}.make_cast (l_bufp), create {CE_INTEGER_8_POINTER}.make_cast ((((create {P_GLOBALS_STATIC}).ScreenLines.item + ((create {P_GLOBALS_STATIC}).LineOffset.item[l_row]).to_integer_32) + l_start_col)), (l_end_col - l_start_col).to_natural_32).do_nothing
							l_bufp := l_bufp + (l_end_col - l_start_col)
						end
				when 21 then -- if done | if done | if done
						l_row := l_row + 1
						l_pos := -1 + 2 -- back to loop condition
				when 22 then -- loop done
						if l_add_newline_flag.to_boolean then
							l_tmp___8 := l_bufp
							l_bufp := l_bufp + 1
							l_tmp___8.item := (('%N').code).to_natural_8
						end
						(create {P_OPS_STATIC}).clip_free_selection ((create {P_GLOBALS_STATIC}).clip_star.item);
						((create {P_GLOBALS_STATIC}).clip_star.item).item.clip_own_selection;
						(create {P_OPS_STATIC}).clip_yank_selection (0, l_buffer, (l_bufp.distance (l_buffer)).to_integer_32, (create {P_GLOBALS_STATIC}).clip_star.item)
						clip_gen_set_selection ((create {P_GLOBALS_STATIC}).clip_star.item)
						if a_both.to_boolean then
							(create {P_OPS_STATIC}).clip_free_selection ((create {P_GLOBALS_STATIC}).clip_plus.item);
							((create {P_GLOBALS_STATIC}).clip_plus.item).item.clip_own_selection;
							(create {P_OPS_STATIC}).clip_yank_selection (0, l_buffer, (l_bufp.distance (l_buffer)).to_integer_32, (create {P_GLOBALS_STATIC}).clip_plus.item)
							clip_gen_set_selection ((create {P_GLOBALS_STATIC}).clip_plus.item)
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buffer))
				when 23 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_get_word_boundaries (a_cb: CE_POINTER [PD_VIMCLIPBOARD]; a_row, a_col: INTEGER_32)
		local
			l_col: INTEGER_32
			l_start_class: INTEGER_32
			l_temp_col: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_mboff: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_col := a_col
					if a_row >= (create {P_GLOBALS_STATIC}).screen_Rows.item then
						l_return := True
					elseif l_col >= (create {P_GLOBALS_STATIC}).screen_Columns.item then
						l_return := True
					elseif ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						l_p___0 := (create {P_GLOBALS_STATIC}).ScreenLines.item + ((create {P_GLOBALS_STATIC}).LineOffset.item[a_row]).to_integer_32
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 0 then
							l_col := l_col - ((create {P_MBYTE_STATIC}).dbcs_screen_head_off (l_p___0, l_p___0 + l_col))
						elseif ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							if (l_p___0[l_col]).to_integer_32 = 0 then
								l_col := l_col - 1
							end
						end
						if (l_p___0[l_col]).to_integer_32 <= 32 then
							l_start_class := (' ').code
						else
							l_start_class := ((create {P_CHARSET_STATIC}).vim_iswordc ((l_p___0[l_col]).to_integer_32))
						end
						l_temp_col := l_col
				when 2 then -- loop condition:
						if not (not (l_break) and then (l_temp_col > 0)) then
							l_pos := -1 + 8 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_mboff := (create {P_MBYTE_STATIC}).dbcs_screen_head_off (l_p___0, (l_p___0 + l_temp_col) - 1)
						if l_mboff > 0 then
							l_temp_col := l_temp_col - l_mboff
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if (l_p___0[(l_temp_col - 1)]).to_integer_32 <= 32 then
							l_tmp___2 := (' ').code
						else
							l_tmp___2 := ((create {P_CHARSET_STATIC}).vim_iswordc ((l_p___0[(l_temp_col - 1)]).to_integer_32))
						end
						if l_tmp___2 /= l_start_class then
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								if (l_p___0[(l_temp_col - 1)]).to_integer_32 /= 0 then
									l_break := True
								end
							else
								l_break := True
							end
						end
				when 7 then
						if not (l_break) then
							l_temp_col := l_temp_col - 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 8 then -- loop done
						l_break := False
						a_cb.item.word_start_col := l_temp_col.to_natural_16
						l_temp_col := l_col
				when 9 then -- loop condition:
						if not (not (l_break) and then (l_temp_col < (create {P_GLOBALS_STATIC}).screen_Columns.item)) then
							l_pos := -1 + 15 -- skip loop
						end
				when 10 then -- loop body:
						l_break := False
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if ((create {P_MBYTE_STATIC}).dbcs_ptr2cells (l_p___0 + l_temp_col)) = 2 then
							l_temp_col := l_temp_col + 1
						else
							l_pos := -1 + 13 -- goto _L___0
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___0:
						if (l_p___0[l_temp_col]).to_integer_32 <= 32 then
							l_tmp___4 := (' ').code
						else
							l_tmp___4 := ((create {P_CHARSET_STATIC}).vim_iswordc ((l_p___0[l_temp_col]).to_integer_32))
						end
						if l_tmp___4 /= l_start_class then
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								if (l_p___0[l_temp_col]).to_integer_32 /= 0 then
									l_break := True
								end
							else
								l_break := True
							end
						end
				when 14 then
						if not (l_break) then
							l_temp_col := l_temp_col + 1
						end
						l_pos := -1 + 9 -- back to loop condition
				when 15 then -- loop done
						l_break := False
						a_cb.item.word_end_col := l_temp_col.to_natural_16
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_get_line_end (a_row: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if a_row >= (create {P_GLOBALS_STATIC}).screen_Rows.item then
				Result := 0
				l_return := True
			elseif ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_i___0 := (create {P_GLOBALS_STATIC}).screen_Columns.item
				from
				until
					not (not (l_break) and then (l_i___0 > 0))
				loop
					l_break := False
					if ((create {P_GLOBALS_STATIC}).ScreenLines.item[(((create {P_GLOBALS_STATIC}).LineOffset.item[a_row] + l_i___0.to_natural_32) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 32 then
						l_break := True
					end
					if not (l_break) then
						l_i___0 := l_i___0 - 1
					end
				end
				l_break := False
				Result := l_i___0
			end
		end

	clip_gen_set_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_GUI_GTK_X11_STATIC}).clip_mch_set_selection (a_cbd)
			else
				(create {P_OS_UNIX_STATIC}).clip_xterm_set_selection (a_cbd)
			end
		end

	vim_is_input_buf_full: INTEGER_32
		do
			Result := (inbufcount.item >= 4_096).to_integer
		end

	vim_is_input_buf_empty: INTEGER_32
		do
			Result := (inbufcount.item = 0).to_integer
		end

	vim_used_in_input_buf: INTEGER_32
		do
			Result := inbufcount.item
		end

	add_to_input_buf (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_s := a_s
			l_len := a_len
			if inbufcount.item + l_len > 4_102 then
				l_return := True
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___1 := l_len
					l_len := l_len - 1
					if not l_tmp___1.to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_tmp := inbufcount.item
						inbufcount.item := inbufcount.item + 1
						l_tmp___0 := l_s
						l_s := l_s + 1
						inbuf.item[l_tmp] := l_tmp___0.item
					end
				end
				l_break := False
			end
		end

	add_to_input_buf_csi (a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<2>>)

			l_i___0 := 0
			from
			until
				not (l_i___0 < a_len)
			loop
				add_to_input_buf (a_str___1 + l_i___0, 1)
				if (a_str___1[l_i___0]).to_integer_32 = 155 then
					l_buf___6[0] := (253).to_natural_8
					l_buf___6[1] := (81).to_natural_8
					add_to_input_buf (l_buf___6, 2)
				end
				l_i___0 := l_i___0 + 1
			end
		end

	trash_input_buf
		do
			inbufcount.item := 0
		end

	read_from_input_buf (a_buf___6: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32): INTEGER_32
		local
			l_maxlen: INTEGER_32
		do
			l_maxlen := a_maxlen
			if inbufcount.item = 0 then
				fill_input_buf (1)
			end
			if l_maxlen > inbufcount.item.to_integer_32 then
				l_maxlen := inbufcount.item.to_integer_32
			end
			memmove (create {CE_VOID_POINTER}.make_cast (a_buf___6), create {CE_VOID_POINTER}.make_cast (inbuf.item), l_maxlen.to_natural_32).do_nothing
			inbufcount.item := (inbufcount.item.to_integer_32 - l_maxlen).to_integer_32
			if inbufcount.item.to_boolean then
				memmove (create {CE_VOID_POINTER}.make_cast (inbuf.item), create {CE_VOID_POINTER}.make_cast ((inbuf.item + l_maxlen)), inbufcount.item.to_natural_32).do_nothing
			end
			Result := l_maxlen.to_integer_32
		end

	fill_input_buf (a_exit_on_error: INTEGER_32)
		local
			l_len: INTEGER_32
			l_try: INTEGER_32
			l_unconverted: INTEGER_32
			l_m: INTEGER_32
			l_tmp___2: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				if not ((create {P_GUI_STATIC}).no_console_input).to_boolean then
					(create {P_GUI_GTK_X11_STATIC}).gui_mch_update
					l_return := True
				end
			end
			if not l_return then
				if (vim_is_input_buf_full).to_boolean then
					l_return := True
				end
			end
			if not l_return then
				if not (rest.item.item).is_void then
					if restlen.item.item > 4_096 - inbufcount.item then
						l_unconverted := 4_096 - inbufcount.item
					else
						l_unconverted := restlen.item.item
					end
					memmove (create {CE_VOID_POINTER}.make_cast ((inbuf.item + inbufcount.item)), create {CE_VOID_POINTER}.make_cast (rest.item.item), l_unconverted.to_natural_32).do_nothing
					if l_unconverted = restlen.item.item then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (rest.item.item))
						rest.item.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					else
						restlen.item.item := restlen.item.item - l_unconverted
						memmove (create {CE_VOID_POINTER}.make_cast (rest.item.item), create {CE_VOID_POINTER}.make_cast ((rest.item.item + l_unconverted)), (restlen.item.item).to_natural_32).do_nothing
					end
					inbufcount.item := inbufcount.item + l_unconverted
				else
					l_unconverted := 0
				end
				l_len := 0
				l_try := 0
				from
				until
					not (not (l_return or l_break) and then (l_try < 100))
				loop
					l_break := False
					l_len := read ((create {P_GLOBALS_STATIC}).read_cmd_fd.item, create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (inbuf.item) + inbufcount.item)), ((4_096 - inbufcount.item) // (create {P_GLOBALS_STATIC}).input_conv.item.item.vc_factor).to_natural_32)
					if l_len > 0 then
						l_break := True
					elseif ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						l_break := True
					end
					if not (l_return or l_break) then
						if not did_read_something.item.to_boolean then
							if not (isatty ((create {P_GLOBALS_STATIC}).read_cmd_fd.item)).to_boolean then
								if (create {P_GLOBALS_STATIC}).read_cmd_fd.item = 0 then
									l_m := (create {P_GLOBALS_STATIC}).cur_tmode.item;
									(create {P_TERM_STATIC}).settmode (0)
									close (0).do_nothing;
									(create {P_GLOBALS_STATIC}).ignored.item := dup (2);
									(create {P_TERM_STATIC}).settmode (l_m)
								end
							end
						end
						if not a_exit_on_error.to_boolean then
							l_return := True
						end
						if not l_return then
							l_try := l_try + 1
						end
					end
				end
			end
			if not l_return then
				l_break := False
				if l_len <= 0 then
					if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						read_error_exit
					end
				end
				if l_len > 0 then
					did_read_something.item := 1
				end
				if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
					inbuf.item[0] := (3).to_natural_8
					inbufcount.item := 1
				else
					if (create {P_GLOBALS_STATIC}).input_conv.item.item.vc_type /= 0 then
						inbufcount.item := inbufcount.item - l_unconverted
						if (rest.item.item).is_void then
							l_tmp___2 := rest.item
						else
							l_tmp___2 := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
						end
						l_len := (create {P_MBYTE_STATIC}).convert_input_safe (inbuf.item + inbufcount.item, l_len + l_unconverted, 4_096 - inbufcount.item, l_tmp___2, restlen.item)
					end
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___3 := l_len
						l_len := l_len - 1
						if not (l_tmp___3 > 0) then
							l_break := True
						end
						if not (l_return or l_break) then
							if (inbuf.item[inbufcount.item]).to_integer_32 = 3 then
								if ((create {P_GLOBALS_STATIC}).ctrl_c_interrupts.item).to_boolean then
									memmove (create {CE_VOID_POINTER}.make_cast (inbuf.item), create {CE_VOID_POINTER}.make_cast ((inbuf.item + inbufcount.item)), (l_len + 1).to_natural_32).do_nothing
									inbufcount.item := 0;
									(create {P_GLOBALS_STATIC}).got_int.item := 1
								end
							end
							inbufcount.item := inbufcount.item + 1
						end
					end
					l_break := False
				end
			end
		end

	read_error_exit
		do
			if ((create {P_GLOBALS_STATIC}).silent_mode.item).to_boolean then
				(create {P_MAIN_STATIC}).getout (0)
			end
			strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("Vim: Error reading input, exiting...%N")))).do_nothing;
			(create {P_MISC1_STATIC}).preserve_exit
		end

	ui_cursor_shape
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_GUI_STATIC}).gui_update_cursor_later
			else
				(create {P_TERM_STATIC}).term_cursor_shape
			end
		end

	check_col (a_col: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_col < 0 then
				Result := 0
				l_return := True
			end
			if not l_return and then (a_col >= (create {P_GLOBALS_STATIC}).screen_Columns.item) then
				Result := ((create {P_GLOBALS_STATIC}).screen_Columns.item - 1)
				l_return := True
			end
			if not l_return then
				Result := a_col
			end
		end

	check_row (a_row: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_row < 0 then
				Result := 0
				l_return := True
			end
			if not l_return and then (a_row >= (create {P_GLOBALS_STATIC}).screen_Rows.item) then
				Result := ((create {P_GLOBALS_STATIC}).screen_Rows.item - 1)
				l_return := True
			end
			if not l_return then
				Result := a_row
			end
		end

	open_app_context
		do
			if ((create {P_GLOBALS_STATIC}).app_context.item).is_void then
				XtToolkitInitialize;
				(create {P_GLOBALS_STATIC}).app_context.item := XtCreateApplicationContext
			end
		end

	x11_setup_atoms (a_dpy: CE_POINTER [ANY])
		do
			vim_atom.item := XInternAtom (a_dpy, ce_string ("_VIM_TEXT"), 0)
			vimenc_atom.item := XInternAtom (a_dpy, ce_string ("_VIMENC_TEXT"), 0)
			compound_text_atom.item := XInternAtom (a_dpy, ce_string ("COMPOUND_TEXT"), 0)
			text_atom.item := XInternAtom (a_dpy, ce_string ("TEXT"), 0)
			targets_atom.item := XInternAtom (a_dpy, ce_string ("TARGETS"), 0);
			(create {P_GLOBALS_STATIC}).clip_star.item.item.sel_atom := (1).to_natural_32;
			(create {P_GLOBALS_STATIC}).clip_plus.item.item.sel_atom := XInternAtom (a_dpy, ce_string ("CLIPBOARD"), 0)
			timestamp_atom.item := XInternAtom (a_dpy, ce_string ("TIMESTAMP"), 0)
		end

	clip_x11_timestamp_cb (a_w, a_n: CE_POINTER [ANY]; a_event: CE_POINTER [SD_XEVENT]; a_cont: CE_POINTER [INTEGER_8])
		require
			not a_event.is_void
		local
			l_actual_type: CE_ARRAY [NATURAL_32]
			l_format: CE_ARRAY [INTEGER_32]
			l_nitems: CE_ARRAY [NATURAL_32]
			l_bytes_after: CE_ARRAY [NATURAL_32]
			l_prop: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_xproperty: CE_POINTER [SD_XPROPERTYEVENT]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_actual_type.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_format.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_nitems.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_bytes_after.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_prop.make (<<1>>)

			l_prop.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_xproperty := create {CE_CLASS_POINTER [SD_XPROPERTYEVENT]}.make_shared (a_event.c_pointer + (create {SD_XEVENT}.make).offset_of ("xproperty"))
			if a_event.item.type /= 28 then
				l_return := True
			elseif (l_xproperty.item.state).to_boolean then
				l_return := True
			elseif l_xproperty.item.atom /= (create {P_GLOBALS_STATIC}).clip_star.item.item.sel_atom then
				if l_xproperty.item.atom /= (create {P_GLOBALS_STATIC}).clip_plus.item.item.sel_atom then
					l_return := True
				end
			end
			if not l_return then
				if (XGetWindowProperty (l_xproperty.item.display, l_xproperty.item.window, l_xproperty.item.atom, 0, 0, 0, timestamp_atom.item, l_actual_type, l_format, l_nitems, l_bytes_after, l_prop)).to_boolean then
					l_return := True
				end
			end
			if not l_return then
				if (not (l_prop.item).is_void) then
					XFree (create {CE_VOID_POINTER}.make_cast (l_prop.item)).do_nothing
				end
				if l_actual_type.item /= timestamp_atom.item then
					l_return := True
				elseif l_format.item /= 32 then
					l_return := True
				end
			end
			if not l_return then
				XtOwnSelection (a_w, l_xproperty.item.atom, l_xproperty.item.time, clip_x11_convert_selection_cb_address, clip_x11_lose_ownership_cb_address, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
			end
		end

	x11_setup_selection (a_w: CE_POINTER [ANY])
		do
			XtAddEventHandler (a_w, ((1).bit_shift_left (22)).to_natural_32, (0).to_integer_8, clip_x11_timestamp_cb_address, create {CE_VOID_POINTER}.make_shared (default_pointer))
		end

	clip_x11_request_selection_cb (a_w, a_success___0: CE_POINTER [ANY]; a_sel_atom, a_type: CE_POINTER [NATURAL_32]; a_value: CE_POINTER [ANY]; a_length: CE_POINTER [NATURAL_32]; a_format: CE_POINTER [INTEGER_32])
		require
			not a_sel_atom.is_void
		local
			l_motion_type: INTEGER_32
			l_len: NATURAL_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_text_list: CE_ARRAY [CE_POINTER [CE_POINTER [INTEGER_8]]]
			l_cbd: CE_POINTER [PD_VIMCLIPBOARD]
			l_tmpbuf: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_enc: CE_POINTER [NATURAL_8]
			l_conv: CE_ARRAY [PD_VIMCONV_T]
			l_convlen: CE_ARRAY [INTEGER_32]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_text_prop: CE_ARRAY [SD_XTEXTPROPERTY]
			l_n_text: CE_ARRAY [INTEGER_32]
			l_status: INTEGER_32
			l_tmp___3: CE_POINTER [ANY]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_p___0.make
			create {CE_POINTER_ARRAY [CE_POINTER [INTEGER_8]]} l_text_list.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_VIMCONV_T]} l_conv.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_convlen.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_XTEXTPROPERTY]} l_text_prop.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_n_text.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_text_list.item := create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_tmpbuf := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					if a_sel_atom.item = (create {P_GLOBALS_STATIC}).clip_plus.item.item.sel_atom then
						l_cbd := (create {P_GLOBALS_STATIC}).clip_plus.item
					else
						l_cbd := (create {P_GLOBALS_STATIC}).clip_star.item
					end
					if a_value.is_void then
						(create {P_OPS_STATIC}).clip_free_selection (l_cbd);
						(create {CE_INTEGER_32_POINTER}.make_cast (a_success___0)).item := 0
						l_return := True
					elseif a_length.item = {NATURAL_32} 0 then
						(create {P_OPS_STATIC}).clip_free_selection (l_cbd);
						(create {CE_INTEGER_32_POINTER}.make_cast (a_success___0)).item := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_motion_type := 0
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (a_value)
						l_len := a_length.item
						if a_type.item /= vim_atom.item then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_tmp := l_p___0
						l_p___0 := l_p___0 + 1
						l_motion_type := (l_tmp.item).to_integer_32
						l_len := l_len - 1
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 4 then -- else:
						if a_type.item /= vimenc_atom.item then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_tmp___0 := l_p___0
						l_p___0 := l_p___0 + 1
						l_motion_type := (l_tmp___0.item).to_integer_32
						l_len := l_len - 1
						l_enc := l_p___0
						l_p___0 := l_p___0 + ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))) + {NATURAL_32} 1).to_integer_32
						l_len := l_len - (l_p___0.distance (l_enc)).to_natural_32
						l_conv.item.vc_type := 0
						l_conv.item.convert_setup (l_enc, (create {P_OPTION_STATIC}).p_enc.item.item).do_nothing
						if l_conv.item.vc_type /= 0 then
							l_convlen.item := l_len.to_integer_32
							l_tmpbuf := (create {P_MBYTE_STATIC}).string_convert (l_conv, l_p___0, l_convlen)
							l_len := (l_convlen.item).to_natural_32
							if not l_tmpbuf.is_void then
								l_p___0 := l_tmpbuf
							end
							l_conv.item.convert_setup (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)).do_nothing
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 7 then -- else:
						if a_type.item /= compound_text_atom.item then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 10 then -- else:
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if a_type.item /= text_atom.item then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						l_n_text.item := 0
						l_text_prop.item.value := create {CE_NATURAL_8_POINTER}.make_cast (a_value)
						l_text_prop.item.encoding := a_type.item
						l_text_prop.item.format := a_format.item
						l_text_prop.item.nitems := l_len
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							l_tmp___3 := ((create {P_GUI_GTK_X11_STATIC}).gui_mch_get_display)
						else
							l_tmp___3 := (create {P_GLOBALS_STATIC}).xterm_dpy.item.item
						end
						l_status := XmbTextPropertyToTextList (l_tmp___3, l_text_prop, l_text_list, l_n_text)
						if l_status /= 0 then
							(create {CE_INTEGER_32_POINTER}.make_cast (a_success___0)).item := 0
							l_return := True
						elseif l_n_text.item < 1 then
							(create {CE_INTEGER_32_POINTER}.make_cast (a_success___0)).item := 0
							l_return := True
						end
						if not l_return then
							l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (l_text_list.item[0])
							l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_natural_32
						end
				when 13 then -- if done | if done | if done | if done | if done
					if not l_return then
						(create {P_OPS_STATIC}).clip_yank_selection (l_motion_type, l_p___0, l_len.to_integer_32, l_cbd)
						if not (l_text_list.item).is_void then
							XFreeStringList (l_text_list.item)
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tmpbuf))
						XtFree (create {CE_INTEGER_8_POINTER}.make_cast (a_value));
						(create {CE_INTEGER_32_POINTER}.make_cast (a_success___0)).item := 1
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_x11_convert_selection_cb (a_w: CE_POINTER [ANY]; a_sel_atom, a_target, a_type: CE_POINTER [NATURAL_32]; a_value: CE_POINTER [CE_POINTER [ANY]]; a_length: CE_POINTER [NATURAL_32]; a_format: CE_POINTER [INTEGER_32]): INTEGER_8
		require
			not a_sel_atom.is_void
		local
			l_string___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_result___2: CE_POINTER [NATURAL_8]
			l_motion_type: INTEGER_32
			l_cbd: CE_POINTER [PD_VIMCLIPBOARD]
			l_i___0: INTEGER_32
			l_array: CE_POINTER [NATURAL_32]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_text_prop: CE_ARRAY [SD_XTEXTPROPERTY]
			l_string_nt: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_tmp___10: CE_POINTER [ANY]
			l_l: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_string___0.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_XTEXTPROPERTY]} l_text_prop.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_string_nt.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_sel_atom.item = (create {P_GLOBALS_STATIC}).clip_plus.item.item.sel_atom then
						l_cbd := (create {P_GLOBALS_STATIC}).clip_plus.item
					else
						l_cbd := (create {P_GLOBALS_STATIC}).clip_star.item
					end
					if not (l_cbd.item.owned).to_boolean then
						Result := (0).to_integer_8
						l_return := True
					end
					if not l_return and then (a_target.item = targets_atom.item) then
						l_array := create {CE_NATURAL_32_POINTER}.make_cast ((XtMalloc ({PLATFORM}.Natural_32_bytes.to_natural_32 * {NATURAL_32} 6)))
						if l_array.is_void then
							Result := (0).to_integer_8
							l_return := True
						end
						if not l_return then
							a_value.item := create {CE_VOID_POINTER}.make_cast (l_array)
							l_i___0 := 0
							l_tmp___0 := l_i___0
							l_i___0 := l_i___0 + 1
							l_array[l_tmp___0] := (31).to_natural_32
							l_tmp___1 := l_i___0
							l_i___0 := l_i___0 + 1
							l_array[l_tmp___1] := targets_atom.item
							l_tmp___2 := l_i___0
							l_i___0 := l_i___0 + 1
							l_array[l_tmp___2] := vimenc_atom.item
							l_tmp___3 := l_i___0
							l_i___0 := l_i___0 + 1
							l_array[l_tmp___3] := vim_atom.item
							l_tmp___4 := l_i___0
							l_i___0 := l_i___0 + 1
							l_array[l_tmp___4] := text_atom.item
							l_tmp___5 := l_i___0
							l_i___0 := l_i___0 + 1
							l_array[l_tmp___5] := compound_text_atom.item
							a_type.item := (4).to_natural_32
							a_format.item := 32
							a_length.item := l_i___0.to_natural_32
							Result := (1).to_integer_8
							l_return := True
						end
					end
					if not l_return and then (a_target.item /= {NATURAL_32} 31) then
						if a_target.item /= vimenc_atom.item then
							if a_target.item /= vim_atom.item then
								if a_target.item /= text_atom.item then
									if a_target.item /= compound_text_atom.item then
										Result := (0).to_integer_8
										l_return := True
									end
								end
							end
						end
					end
					if not l_return then
						l_cbd.item.clip_get_selection
						l_motion_type := (create {P_OPS_STATIC}).clip_convert_selection (l_string___0, a_length, l_cbd)
						if l_motion_type < 0 then
							Result := (0).to_integer_8
							l_return := True
						end
					end
					if not l_return then
						if a_target.item = vim_atom.item then
							a_length.item := (a_length.item) + 1
						end
						if a_target.item = vimenc_atom.item then
							a_length.item := a_length.item + ((strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_enc.item.item))) + {NATURAL_32} 2).to_natural_32
						end
						a_value.item := create {CE_VOID_POINTER}.make_cast ((XtMalloc ((a_length.item).to_natural_32)))
						l_result___2 := create {CE_NATURAL_8_POINTER}.make_cast (a_value.item)
						if l_result___2.is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_string___0.item))
							Result := (0).to_integer_8
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if a_target.item /= {NATURAL_32} 31 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						memmove (create {CE_VOID_POINTER}.make_cast (l_result___2), create {CE_VOID_POINTER}.make_cast (l_string___0.item), (a_length.item).to_natural_32).do_nothing
						a_type.item := (31).to_natural_32
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						if a_target.item /= compound_text_atom.item then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if a_target.item /= text_atom.item then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						l_string_nt.item := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC2_STATIC}).alloc ((a_length.item).to_natural_32 + {NATURAL_32} 1)))
						memmove (create {CE_VOID_POINTER}.make_cast (l_string_nt.item), create {CE_VOID_POINTER}.make_cast (l_string___0.item), (a_length.item).to_natural_32).do_nothing
						l_string_nt.item[(a_length.item).to_integer_32] := (('%/0/').code).to_integer_8
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							l_tmp___10 := ((create {P_GUI_GTK_X11_STATIC}).gui_mch_get_display)
						else
							l_tmp___10 := (create {P_GLOBALS_STATIC}).xterm_dpy.item.item
						end
						XmbTextListToTextProperty (l_tmp___10, l_string_nt, 1, {SC_XICCENCODINGSTYLE}.XCompoundTextStyle, l_text_prop).do_nothing;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_string_nt.item))
						XtFree (create {CE_INTEGER_8_POINTER}.make_cast (a_value.item))
						a_value.item := create {CE_VOID_POINTER}.make_cast (l_text_prop.item.value)
						a_length.item := l_text_prop.item.nitems
						a_type.item := compound_text_atom.item
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						if a_target.item = vimenc_atom.item then
							l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_enc.item.item))).to_integer_32
							l_result___2[0] := l_motion_type.to_natural_8
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_result___2 + 1)), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_enc.item.item)).do_nothing
							memmove (create {CE_VOID_POINTER}.make_cast (((l_result___2 + l_l) + 2)), create {CE_VOID_POINTER}.make_cast (l_string___0.item), ((a_length.item - l_l.to_natural_32) - {NATURAL_32} 2).to_natural_32).do_nothing
							a_type.item := vimenc_atom.item
						else
							l_result___2[0] := l_motion_type.to_natural_8
							memmove (create {CE_VOID_POINTER}.make_cast ((l_result___2 + 1)), create {CE_VOID_POINTER}.make_cast (l_string___0.item), (a_length.item - {NATURAL_32} 1).to_natural_32).do_nothing
							a_type.item := vim_atom.item
						end
				when 11 then -- if done | if done
						a_format.item := 8;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_string___0.item))
						Result := (1).to_integer_8
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_x11_lose_ownership_cb (a_w: CE_POINTER [ANY]; a_sel_atom: CE_POINTER [NATURAL_32])
		require
			not a_sel_atom.is_void
		do
			if a_sel_atom.item = (create {P_GLOBALS_STATIC}).clip_plus.item.item.sel_atom then
				((create {P_GLOBALS_STATIC}).clip_plus.item).item.clip_lose_selection
			else
				((create {P_GLOBALS_STATIC}).clip_star.item).item.clip_lose_selection
			end
		end

	clip_x11_set_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
		end

	jump_to_mouse (a_flags___0: INTEGER_32; a_inclusive: CE_POINTER [INTEGER_32]; a_which_button: INTEGER_32): INTEGER_32
		local
			l_flags___0: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_old_cursor: PD_POS_T
			l_count___2: INTEGER_32
			l_first___0: INTEGER_32
			l_row: CE_ARRAY [INTEGER_32]
			l_col: CE_ARRAY [INTEGER_32]
			l_mouse_char: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [PD_WINDOW_S]} l_old_curwin___1.make
			create l_old_cursor.make
			create {CE_INTEGER_32_ARRAY} l_row.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_flags___0 := a_flags___0
					l_row.item := (create {P_GLOBALS_STATIC}).mouse_row.item
					l_col.item := (create {P_GLOBALS_STATIC}).mouse_col.item;
					(create {P_GLOBALS_STATIC}).mouse_past_bottom.item := 0;
					(create {P_GLOBALS_STATIC}).mouse_past_eol.item := 0
					if ((l_flags___0).bit_and (32)).to_boolean then
						if not dragwin.item.is_void then
							if not did_drag.item.to_boolean then
								l_flags___0 := (l_flags___0).bit_and ((-6))
							end
						end
						dragwin.item := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
						did_drag.item := 0
					end
					if not (((l_flags___0).bit_and (4)).to_boolean) then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if prev_row___0.item /= (create {P_GLOBALS_STATIC}).mouse_row.item then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if prev_col___0.item /= (create {P_GLOBALS_STATIC}).mouse_col.item then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | retnomove:
						if on_status_line.item.to_boolean then
							Result := 2
							l_return := True
						end
						if not l_return and then (on_sep_line.item.to_boolean) then
							Result := 4
							l_return := True
						end
						if not l_return then
							if ((l_flags___0).bit_and (16)).to_boolean then
								(create {P_NORMAL_STATIC}).end_visual_mode;
								(create {P_SCREEN_STATIC}).redraw_curbuf_later (20)
							end
							if (create {P_GLOBALS_STATIC}).cmdwin_type.item /= 0 then
								if l_row.item < (create {P_GLOBALS_STATIC}).curwin.item.item.w_winrow then
									Result := 8
									l_return := True
								end
							end
						end
						if not l_return then
							Result := 1
							l_return := True
						end
				when 4 then -- if done | if done | if done
					if l_return then
						l_pos := -1 + 16 -- skip if block
					end
				when 5 then -- if:
						prev_row___0.item := (create {P_GLOBALS_STATIC}).mouse_row.item
						prev_col___0.item := (create {P_GLOBALS_STATIC}).mouse_col.item
						if ((l_flags___0).bit_and (8)).to_boolean then
							l_pos := -1 + 3 -- goto retnomove
						end
				when 6 then
						if l_row.item >= 0 then
							if (l_row.item).to_integer_32 < (create {P_GLOBALS_STATIC}).Rows.item.item then
								if l_col.item >= 0 then
									if (l_col.item).to_integer_32 <= (create {P_GLOBALS_STATIC}).Columns.item.item then
										if not ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
											l_mouse_char := ((create {P_GLOBALS_STATIC}).ScreenLines.item[((create {P_GLOBALS_STATIC}).LineOffset.item[l_row.item] + (l_col.item).to_natural_32).to_integer_32]).to_integer_32
										else
											l_mouse_char := (' ').code
										end
									else
										l_mouse_char := (' ').code
									end
								else
									l_mouse_char := (' ').code
								end
							else
								l_mouse_char := (' ').code
							end
						else
							l_mouse_char := (' ').code
						end
						l_old_curwin___1 := (create {P_GLOBALS_STATIC}).curwin.item
						l_old_cursor := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
						if ((l_flags___0).bit_and (1)).to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_row.item < 0 then
							Result := 0
							l_return := True
						elseif l_col.item < 0 then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_wp___0 := mouse_find_win (l_row, l_col)
							dragwin.item := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
							if l_row.item >= l_wp___0.item.w_height then
								on_status_line.item := (l_row.item - l_wp___0.item.w_height) + 1
								dragwin.item := l_wp___0
							else
								on_status_line.item := 0
							end
							if l_col.item >= l_wp___0.item.w_width then
								on_sep_line.item := (l_col.item - l_wp___0.item.w_width) + 1
								dragwin.item := l_wp___0
							else
								on_sep_line.item := 0
							end
							if on_status_line.item.to_boolean then
								if on_sep_line.item.to_boolean then
									if (l_wp___0.item.stl_connected).to_boolean then
										on_sep_line.item := 0
									else
										on_status_line.item := 0
									end
								end
							end
							if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
								if not (l_wp___0.item.w_buffer).is_equal ((create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer) then
									(create {P_NORMAL_STATIC}).end_visual_mode;
									(create {P_SCREEN_STATIC}).redraw_curbuf_later (20)
								elseif not on_status_line.item.to_boolean then
									if not on_sep_line.item.to_boolean then
										if (create {P_GLOBALS_STATIC}).cmdwin_type.item = 0 then
											if l_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
												l_tmp___0 := 0
											else
												l_tmp___0 := 1
											end
										else
											l_tmp___0 := 1
										end
										if (l_col.item).to_integer_32 >= l_wp___0.item.w_onebuf_opt.wo_fdc + l_tmp___0.to_integer_32 then
											if ((l_flags___0).bit_and (16)).to_boolean then
												(create {P_NORMAL_STATIC}).end_visual_mode;
												(create {P_SCREEN_STATIC}).redraw_curbuf_later (20)
											end
										end
									end
								end
							end
							if (create {P_GLOBALS_STATIC}).cmdwin_type.item /= 0 then
								if not l_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
									on_sep_line.item := 0
									if on_status_line.item.to_boolean then
										Result := 2
										l_return := True
									end
									if not l_return then
										Result := 8
										l_return := True
									end
								end
							end
						end
						if not l_return then
							if dragwin.item.is_void then
								(create {P_WINDOW_STATIC}).win_enter (l_wp___0, 1)
							elseif ((l_flags___0).bit_and (32)).to_boolean then
								(create {P_WINDOW_STATIC}).win_enter (l_wp___0, 1)
							end
							if not ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_old_curwin___1) then
								((create {P_GLOBALS_STATIC}).curwin.item).item.set_mouse_topline
							end
							if on_status_line.item.to_boolean then
								if ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_old_curwin___1) then
									Result := 2
									l_return := True
								else
									Result := 258
									l_return := True
								end
							end
						end
						if not l_return and then (on_sep_line.item.to_boolean) then
							if ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_old_curwin___1) then
								Result := 4
								l_return := True
							else
								Result := 260
								l_return := True
							end
						end
						if not l_return then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline;
							(create {P_GLOBALS_STATIC}).gui_prev_topline.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline;
							(create {P_GLOBALS_STATIC}).gui_prev_topfill.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 9 then -- else:
						if not (on_status_line.item.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if a_which_button = 0 then
							if not dragwin.item.is_void then
								l_count___2 := (((l_row.item - dragwin.item.item.w_winrow) - dragwin.item.item.w_height) + 1) - on_status_line.item
								dragwin.item.item.win_drag_status_line (l_count___2)
								did_drag.item := (did_drag.item).bit_or (l_count___2)
							end
							Result := 2
							l_return := True
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else: | _L___0:
						if not (on_sep_line.item.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if a_which_button = 0 then
							if not dragwin.item.is_void then
								l_count___2 := (((l_col.item - dragwin.item.item.w_wincol) - dragwin.item.item.w_width) + 1) - on_sep_line.item
								dragwin.item.item.win_drag_vsep_line (l_count___2)
								did_drag.item := (did_drag.item).bit_or (l_count___2)
							end
							Result := 4
							l_return := True
						else
							l_pos := -1 + 15 -- goto _L
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L:
						if ((l_flags___0).bit_and (16)).to_boolean then
							(create {P_NORMAL_STATIC}).end_visual_mode;
							(create {P_SCREEN_STATIC}).redraw_curbuf_later (20)
						end
						if (create {P_GLOBALS_STATIC}).cmdwin_type.item /= 0 then
							if l_row.item < (create {P_GLOBALS_STATIC}).curwin.item.item.w_winrow then
								Result := 8
								l_return := True
							end
						end
						if not l_return then
							l_row.item := l_row.item - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_winrow)
							l_col.item := l_col.item - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_wincol)
							if l_row.item < 0 then
								l_count___2 := 0
								l_first___0 := 1
								from
								until
									not (not (l_break) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline > 1))
								loop
									l_break := False
									if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill < (((create {P_GLOBALS_STATIC}).curwin.item).item.diff_check ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline)) then
										l_count___2 := l_count___2 + 1
									else
										l_count___2 := l_count___2 + ((create {P_MISC1_STATIC}).plines ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline - 1))
									end
									if not l_first___0.to_boolean then
										if l_count___2 > -l_row.item then
											l_break := True
										end
									end
									if not (l_break) then
										l_first___0 := 0;
										(create {P_FOLD_STATIC}).hasFolding ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline, create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_topline")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing
										if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill < (((create {P_GLOBALS_STATIC}).curwin.item).item.diff_check ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline)) then
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill) + 1
										else
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline) - 1;
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := 0
										end
									end
								end
								l_break := False;
								((create {P_GLOBALS_STATIC}).curwin.item).item.check_topfill (0);
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-114));
								(create {P_SCREEN_STATIC}).redraw_later (10)
								l_row.item := 0
							elseif l_row.item >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_height then
								l_count___2 := 0
								l_first___0 := 1
								from
								until
									not (not (l_break) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count))
								loop
									l_break := False
									if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill > 0 then
										l_count___2 := l_count___2 + 1
									else
										l_count___2 := l_count___2 + ((create {P_MISC1_STATIC}).plines ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline))
									end
									if not l_first___0.to_boolean then
										if l_count___2 > (l_row.item - (create {P_GLOBALS_STATIC}).curwin.item.item.w_height) + 1 then
											l_break := True
										end
									end
									if not (l_break) then
										l_first___0 := 0
										if ((create {P_FOLD_STATIC}).hasFolding ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_topline")))).to_boolean then
											if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
												l_break := True
											end
										end
									end
									if not (l_break) then
										if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill > 0 then
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill) - 1
										else
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline) + 1;
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := (create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline)
										end
									end
								end
								l_break := False;
								((create {P_GLOBALS_STATIC}).curwin.item).item.check_topfill (0);
								(create {P_SCREEN_STATIC}).redraw_later (10);
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-114))
								l_row.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_height - 1
							elseif l_row.item = 0 then
								if (create {P_GLOBALS_STATIC}).mouse_dragging.item > 0 then
									if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = ((create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer).item.b_ml.ml_line_count then
										if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-129))
										end
									end
								end
							end
						end
				when 16 then -- if done | if done | if done
					if not l_return then
						if (create {P_GLOBALS_STATIC}).cmdwin_type.item = 0 then
							l_tmp___6 := 0
						else
							l_tmp___6 := 1
						end
						if (l_col.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_fdc + l_tmp___6.to_integer_32 then
							l_mouse_char := (' ').code
						end
						if (((create {P_GLOBALS_STATIC}).curwin.item).item.mouse_comp_pos (l_row, l_col, create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor") + (create {PD_POS_T}.make).offset_of ("lnum")))).to_boolean then
							(create {P_GLOBALS_STATIC}).mouse_past_bottom.item := 1
						end
						if ((l_flags___0).bit_and (2)).to_boolean then
							if not ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
								(create {P_NORMAL_STATIC}).check_visual_highlight;
								(create {P_GLOBALS_STATIC}).VIsual.item.item := l_old_cursor.twin;
								(create {P_GLOBALS_STATIC}).VIsual_active.item := 1;
								(create {P_GLOBALS_STATIC}).VIsual_reselect.item := 1;
								(create {P_NORMAL_STATIC}).may_start_select (('o').code);
								(create {P_TERM_STATIC}).setmouse
								if ((create {P_OPTION_STATIC}).p_smd.item.item).to_boolean then
									if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
										(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
									end
								end
							end
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant := l_col.item;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 0
						if ((create {P_MISC2_STATIC}).coladvance (l_col.item)) = 0 then
							if not a_inclusive.is_void then
								a_inclusive.item := 1
							end
							(create {P_GLOBALS_STATIC}).mouse_past_eol.item := 1
						elseif not a_inclusive.is_void then
							a_inclusive.item := 0
						end
						l_count___2 := 1
						if not ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_old_curwin___1) then
							l_count___2 := (l_count___2).bit_or ((256))
						elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= l_old_cursor.lnum then
							l_count___2 := (l_count___2).bit_or ((256))
						elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col /= l_old_cursor.col then
							l_count___2 := (l_count___2).bit_or ((256))
						end
						if l_mouse_char = 43 then
							l_count___2 := (l_count___2).bit_or ((1_024))
						elseif l_mouse_char /= 32 then
							l_count___2 := (l_count___2).bit_or ((512))
						end
						Result := l_count___2
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mouse_find_win (a_rowp, a_colp: CE_POINTER [INTEGER_32]): CE_POINTER [PD_WINDOW_S]
		require
			not a_rowp.is_void
		local
			l_fp: CE_POINTER [PD_FRAME_S]
			l_return, l_break: BOOLEAN
		do
			l_fp := (create {P_GLOBALS_STATIC}).topframe.item
			a_rowp.item := a_rowp.item - ((create {P_GLOBALS_STATIC}).firstwin.item.item.w_winrow)
			from
			until
				not (not (l_return) and then ((l_fp.item.fr_layout).to_integer_32 /= 0))
			loop
				if (l_fp.item.fr_layout).to_integer_32 = 1 then
					l_fp := l_fp.item.fr_child
					from
					until
						not (not (l_break) and then (not (l_fp.item.fr_next).is_void))
					loop
						l_break := False
						if a_colp.item < l_fp.item.fr_width then
							l_break := True
						end
						if not (l_break) then
							a_colp.item := a_colp.item - (l_fp.item.fr_width)
							l_fp := l_fp.item.fr_next
						end
					end
					l_break := False
				else
					l_fp := l_fp.item.fr_child
					from
					until
						not (not (l_break) and then (not (l_fp.item.fr_next).is_void))
					loop
						l_break := False
						if a_rowp.item < l_fp.item.fr_height then
							l_break := True
						end
						if not (l_break) then
							a_rowp.item := a_rowp.item - (l_fp.item.fr_height)
							l_fp := l_fp.item.fr_next
						end
					end
					l_break := False
				end
			end
			Result := (l_fp.item.fr_win)
		end

	get_fpos_of_mouse (a_mpos: CE_POINTER [PD_POS_T]): INTEGER_32
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_row: CE_ARRAY [INTEGER_32]
			l_col: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_row.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)

			l_row.item := (create {P_GLOBALS_STATIC}).mouse_row.item
			l_col.item := (create {P_GLOBALS_STATIC}).mouse_col.item
			if l_row.item < 0 then
				Result := 0
				l_return := True
			elseif l_col.item < 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_wp___0 := mouse_find_win (l_row, l_col)
				if l_row.item >= l_wp___0.item.w_height then
					Result := 2
					l_return := True
				end
			end
			if not l_return and then (l_col.item >= l_wp___0.item.w_width) then
				Result := 4
				l_return := True
			end
			if not l_return and then (not l_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item)) then
				Result := 0
				l_return := True
			end
			if not l_return then
				if (((create {P_GLOBALS_STATIC}).curwin.item).item.mouse_comp_pos (l_row, l_col, create {CE_INTEGER_32_POINTER}.make_shared (a_mpos.c_pointer + (create {PD_POS_T}.make).offset_of ("lnum")))).to_boolean then
					Result := 2
					l_return := True
				end
			end
			if not l_return then
				a_mpos.item.col := l_wp___0.item.vcol2col (a_mpos.item.lnum, l_col.item)
				if a_mpos.item.col > 0 then
					a_mpos.item.col := (a_mpos.item.col) - 1
				end
				a_mpos.item.coladd := 0
				Result := 1
			end
		end

	ui_focus_change (a_in_focus: INTEGER_32)
		local
			l_need_redraw: INTEGER_32
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_need_redraw := 0
					if a_in_focus.to_boolean then
						if last_time.item + 2 < (time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))) then
							l_need_redraw := (create {P_FILEIO_STATIC}).check_timestamps ((create {P_GUI_STATIC}).gui.item.item.in_use)
							last_time.item := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						end
					end
					if a_in_focus.to_boolean then
						l_tmp___0 := 39
					else
						l_tmp___0 := 40
					end
					l_need_redraw := (l_need_redraw).bit_or (((create {P_FILEIO_STATIC}).apply_autocmds (l_tmp___0.to_natural_32, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item)))
					if not (l_need_redraw.to_boolean) then
						l_pos := -1 + 28 -- skip if block
					end
				when 1 then -- if:;
						(create {P_GLOBALS_STATIC}).need_wait_return.item := 0
						if not ((((create {P_GLOBALS_STATIC}).State.item).bit_and (8)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:;
						(create {P_EX_GETLN_STATIC}).redrawcmdline
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 4 then -- else:
						if (create {P_GLOBALS_STATIC}).State.item /= 513 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:;
						(create {P_MESSAGE_STATIC}).repeat_message
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 7 then -- else:
						if (create {P_GLOBALS_STATIC}).State.item /= 1_024 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:;
						(create {P_MESSAGE_STATIC}).repeat_message
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 10 then -- else:
						if (create {P_GLOBALS_STATIC}).State.item /= 768 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:;
						(create {P_MESSAGE_STATIC}).repeat_message
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 13 then -- else:
						if (create {P_GLOBALS_STATIC}).State.item /= 1_536 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:;
						(create {P_MESSAGE_STATIC}).repeat_message
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 16 then -- else:
						if (create {P_GLOBALS_STATIC}).State.item /= 2_048 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:;
						(create {P_MESSAGE_STATIC}).repeat_message
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 19 then -- else:
						if not (((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:;
						(create {P_MESSAGE_STATIC}).repeat_message
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 22 then -- else:
						if not ((((create {P_GLOBALS_STATIC}).State.item).bit_and (1)).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 25 then -- else:
						if not ((((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 26 then -- if: | _L:
						if (create {P_GLOBALS_STATIC}).must_redraw.item /= 0 then
							(create {P_SCREEN_STATIC}).update_screen (0)
						end
						(create {P_SCREEN_STATIC}).setcursor
				when 27 then -- if done | if done | if done | if done | if done | if done | if done | if done;
						(create {P_TERM_STATIC}).cursor_on;
						(create {P_TERM_STATIC}).out_flush
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							(create {P_GUI_STATIC}).gui_update_cursor (0, 1);
							(create {P_GUI_STATIC}).gui_update_scrollbars (0)
						end
				when 28 then -- if done
					if ((create {P_GLOBALS_STATIC}).need_maketitle.item).to_boolean then
						(create {P_BUFFER_STATIC}).maketitle
					end
				when 29 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	im_save_status (a_psave: CE_POINTER [INTEGER_32])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_OPTION_STATIC}).p_imdisable.item.item).to_boolean then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 2 then -- if:
						if ((create {P_GLOBALS_STATIC}).KeyStuffed.item).to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if ((create {P_GLOBALS_STATIC}).xic.item).is_void then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if not (((create {P_GUI_STATIC}).gui.item.item.in_focus).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if ((create {P_GLOBALS_STATIC}).vgetc_im_active.item).to_boolean then
							a_psave.item := 2
						elseif a_psave.item = 2 then
							a_psave.item := 0
						end
				when 9 then -- if done | if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	clip_x11_timestamp_cb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent clip_x11_timestamp_cb)
		end

	clip_x11_request_selection_cb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent clip_x11_request_selection_cb)
		end

	clip_x11_convert_selection_cb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent clip_x11_convert_selection_cb)
		end

	clip_x11_lose_ownership_cb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent clip_x11_lose_ownership_cb)
		end

end
