class
	P_UNDO_STATIC

inherit
	CE_UTILITIES
	S_LIBINTL_STATIC
	S_TIME_STATIC
	S_STRING_STATIC
	S_SYS_STAT_STATIC
	S_STDIO_STATIC
	S_LIBIO_STATIC
	S_FCNTL_STATIC
	S_UNISTD_STATIC

feature {ANY} -- public attributes

	u_newcount: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	u_oldcount: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	undo_undoes: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	lastmark: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	e_not_open: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('E').code).to_natural_8, (('8').code).to_natural_8, (('2').code).to_natural_8, (('8').code).to_natural_8,
					((':').code).to_natural_8, ((' ').code).to_natural_8, (('C').code).to_natural_8, (('a').code).to_natural_8,
					(('n').code).to_natural_8, (('n').code).to_natural_8, (('o').code).to_natural_8, (('t').code).to_natural_8,
					((' ').code).to_natural_8, (('o').code).to_natural_8, (('p').code).to_natural_8, (('e').code).to_natural_8,
					(('n').code).to_natural_8, ((' ').code).to_natural_8, (('u').code).to_natural_8, (('n').code).to_natural_8,
					(('d').code).to_natural_8, (('o').code).to_natural_8, ((' ').code).to_natural_8, (('f').code).to_natural_8,
					(('i').code).to_natural_8, (('l').code).to_natural_8, (('e').code).to_natural_8, ((' ').code).to_natural_8,
					(('f').code).to_natural_8, (('o').code).to_natural_8, (('r').code).to_natural_8, ((' ').code).to_natural_8,
					(('w').code).to_natural_8, (('r').code).to_natural_8, (('i').code).to_natural_8, (('t').code).to_natural_8,
					(('i').code).to_natural_8, (('n').code).to_natural_8, (('g').code).to_natural_8, ((':').code).to_natural_8,
					((' ').code).to_natural_8, (('%%').code).to_natural_8, (('s').code).to_natural_8, (('%/0/').code).to_natural_8
				>>)
		end

feature {ANY} -- public routines

	u_save_cursor: INTEGER_32
		do
			Result := (u_save ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + 1))
		end

	u_save (a_top, a_bot: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).undo_off.item).to_boolean then
				Result := 1
				l_return := True
			end
			if not l_return then
				if a_top > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
					Result := 0
					l_return := True
				elseif a_top >= a_bot then
					Result := 0
					l_return := True
				elseif a_bot > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count + 1 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if a_top + 2 = a_bot then
					u_saveline (a_top + 1)
				end
				Result := (u_savecommon (a_top, a_bot, (0).to_integer_32, 0))
			end
		end

	u_savesub (a_lnum: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).undo_off.item).to_boolean then
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := (u_savecommon (a_lnum - 1, a_lnum + 1, a_lnum + 1, 0))
			end
		end

	u_savedel (a_lnum, a_nlines: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).undo_off.item).to_boolean then
				Result := 1
				l_return := True
			end
			if not l_return then
				if a_nlines = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
					l_tmp := (2).to_integer_32
				else
					l_tmp := a_lnum
				end
				Result := (u_savecommon (a_lnum - 1, a_lnum + a_nlines, l_tmp, 0))
			end
		end

	undo_allowed: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ma).to_boolean then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_modifiable.item)))))).do_nothing
				Result := 0
				l_return := True
			end
			if not l_return and then ((create {P_GLOBALS_STATIC}).sandbox.item /= 0) then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_sandbox.item)))))).do_nothing
				Result := 0
				l_return := True
			end
			if not l_return and then ((create {P_GLOBALS_STATIC}).textlock.item /= 0) then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_secure.item)))))).do_nothing
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := 1
			end
		end

	u_savecommon (a_top, a_bot, a_newbot: INTEGER_32; a_reload: INTEGER_32): INTEGER_32
		local
			l_lnum: INTEGER_32
			l_i___0: INTEGER_32
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_old_curhead: CE_ARRAY [CE_POINTER [PD_U_HEADER]]
			l_uep: CE_POINTER [PD_U_ENTRY]
			l_prev_uep: CE_POINTER [PD_U_ENTRY]
			l_size: INTEGER_32
			l_uhfree: CE_POINTER [PD_U_HEADER]
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___13: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp___15: CE_POINTER [NATURAL_8]
			l_tmp___16: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_U_HEADER]} l_old_curhead.make (<<1>>)
			create {CE_CLASS_POINTER [PD_U_ENTRY]} l_uep.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not a_reload.to_boolean then
						if not (undo_allowed).to_boolean then
							Result := 0
							l_return := True
						end
						if not l_return then
							if ((create {P_NETBEANS_STATIC}).netbeans_active).to_boolean then
								if ((create {P_NETBEANS_STATIC}).netbeans_is_guarded (a_top, a_bot)).to_boolean then
									(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_guarded.item)))))).do_nothing
									Result := 0
									l_return := True
								end
								if not l_return and then (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro).to_boolean) then
									(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_nbreadonly.item)))))).do_nothing
									Result := 0
									l_return := True
								end
							end
						end
						if not l_return then
							(create {P_MISC1_STATIC}).change_warning (0)
							if a_bot > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count + 1 then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E834: Line count changed unexpectedly"))))).do_nothing
								Result := 0
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_size := (a_bot - a_top) - 1
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_synced).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_new_change := 1
						if (create {P_OPTION_STATIC}).p_ul.item.item >= 0 then
							l_uhp := create {CE_CLASS_POINTER [PD_U_HEADER]}.make_cast (((create {P_MISC2_STATIC}).lalloc (((create {PD_U_HEADER}.make).structure_size.to_natural_32).to_natural_32, 0)))
							if l_uhp.is_void then
								l_pos := -1 + 19 -- goto nomem
							end
						else
							l_uhp := create {CE_CLASS_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
						end
				when 3 then
						l_old_curhead.item := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead
						if not (l_old_curhead.item).is_void then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead := l_old_curhead.item.item.uh_next.ptr;
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead := create {CE_CLASS_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_numhead).to_integer_32 > (create {P_OPTION_STATIC}).p_ul.item.item then
								if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_oldhead).is_void then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_uhfree := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_oldhead
								if l_uhfree.is_equal (l_old_curhead.item) then
									((create {P_GLOBALS_STATIC}).curbuf.item).item.u_freebranch (l_uhfree, l_old_curhead)
								elseif (l_uhfree.item.uh_alt_next.ptr).is_void then
									((create {P_GLOBALS_STATIC}).curbuf.item).item.u_freeheader (l_uhfree, l_old_curhead)
								else
									from
									until
										(l_uhfree.item.uh_alt_next.ptr).is_void
									loop
										l_uhfree := l_uhfree.item.uh_alt_next.ptr
									end
									((create {P_GLOBALS_STATIC}).curbuf.item).item.u_freebranch (l_uhfree, l_old_curhead)
								end
							end
						end
						l_break := False
						if l_uhp.is_void then
							if not (l_old_curhead.item).is_void then
								((create {P_GLOBALS_STATIC}).curbuf.item).item.u_freebranch (l_old_curhead.item, create {CE_POINTER_POINTER [PD_U_HEADER]}.make_shared (default_pointer))
							end
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_synced := 0
							Result := 1
							l_return := True
						end
						if not l_return then
							l_uhp.item.uh_prev.ptr := create {CE_CLASS_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
							l_uhp.item.uh_next.ptr := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead
							l_uhp.item.uh_alt_next.ptr := l_old_curhead.item
							if not (l_old_curhead.item).is_void then
								l_uhp.item.uh_alt_prev.ptr := l_old_curhead.item.item.uh_alt_prev.ptr
								if not (l_uhp.item.uh_alt_prev.ptr).is_void then
									(l_uhp.item.uh_alt_prev.ptr).item.uh_alt_next.ptr := l_uhp
								end
								l_old_curhead.item.item.uh_alt_prev.ptr := l_uhp
								if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_oldhead).is_equal (l_old_curhead.item) then
									(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_oldhead := l_uhp
								end
							else
								l_uhp.item.uh_alt_prev.ptr := create {CE_CLASS_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
							end
							if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead).is_void then
								((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead).item.uh_prev.ptr := l_uhp
							end
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_seq_last := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_seq_last) + 1
							l_uhp.item.uh_seq := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_seq_last;
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_seq_cur := l_uhp.item.uh_seq
							l_uhp.item.uh_time := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
							l_uhp.item.uh_save_nr := 0;
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_time_cur := l_uhp.item.uh_time + 1
							l_uhp.item.uh_walk := 0
							l_uhp.item.uh_entry := create {CE_CLASS_POINTER [PD_U_ENTRY]}.make_shared (default_pointer)
							l_uhp.item.uh_getbot_entry := create {CE_CLASS_POINTER [PD_U_ENTRY]}.make_shared (default_pointer)
							l_uhp.item.uh_cursor := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
							if ((create {P_MISC2_STATIC}).virtual_active).to_boolean then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd > 0 then
									l_uhp.item.uh_cursor_vcol := ((create {P_MISC2_STATIC}).getviscol).to_integer_32
								else
									l_uhp.item.uh_cursor_vcol := -1
								end
							else
								l_uhp.item.uh_cursor_vcol := -1
							end
							if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changed).to_boolean then
								l_tmp___8 := 1
							else
								l_tmp___8 := 0
							end
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_and (1)).to_boolean then
								l_tmp___9 := 2
							else
								l_tmp___9 := 0
							end
							l_uhp.item.uh_flags := l_tmp___8 + l_tmp___9
							memmove (create {CE_VOID_POINTER}.make_cast ((l_uhp.item.uh_namedm)), create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_namedm)), (create {PD_POS_T}.make).structure_size.to_natural_32 * {NATURAL_32} 26).do_nothing
							l_uhp.item.uh_visual := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual).twin;
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead := l_uhp
							if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_oldhead).is_void then
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_oldhead := l_uhp
							end
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_numhead := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_numhead) + 1
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else:
						if (create {P_OPTION_STATIC}).p_ul.item.item < 0 then
							Result := 1
							l_return := True
						end
						if not l_return and then (l_size = 1) then
							l_uep := u_get_headentry
							l_prev_uep := create {CE_CLASS_POINTER [PD_U_ENTRY]}.make_shared (default_pointer)
							l_i___0 := 0
							from
							until
								not (not (l_return or l_break) and then (l_i___0 < 10))
							loop
								l_break := False
								if l_uep.is_void then
									l_break := True
								end
								if not (l_return or l_break) then
									if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead).item.uh_getbot_entry).is_equal (l_uep) then
										if l_uep.item.ue_bot = 0 then
											l_tmp___10 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count + 1
										else
											l_tmp___10 := l_uep.item.ue_bot
										end
										l_tmp___11 := ((l_uep.item.ue_top + l_uep.item.ue_size) + 1 /= l_tmp___10).to_integer
									else
										l_tmp___11 := (l_uep.item.ue_lcount /= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count).to_integer
									end
									if l_tmp___11.to_boolean then
										l_break := True
									elseif l_uep.item.ue_size > 1 then
										if a_top >= l_uep.item.ue_top then
											if a_top + 2 <= (l_uep.item.ue_top + l_uep.item.ue_size) + 1 then
												l_break := True
											end
										end
									end
								end
								if not (l_return or l_break) then
									if l_uep.item.ue_size = 1 then
										if l_uep.item.ue_top = a_top then
											if l_i___0 > 0 then
												u_getbot;
												(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_synced := 0
												l_prev_uep.item.ue_next := l_uep.item.ue_next
												l_uep.item.ue_next := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead).item.uh_entry;
												((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead).item.uh_entry := l_uep
											end
											if a_newbot /= 0 then
												l_uep.item.ue_bot := a_newbot
											elseif a_bot > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
												l_uep.item.ue_bot := (0).to_integer_32
											else
												l_uep.item.ue_lcount := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count;
												((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead).item.uh_getbot_entry := l_uep
											end
											Result := 1
											l_return := True
										end
									end
									if not l_return then
										l_prev_uep := l_uep
										l_uep := l_uep.item.ue_next
										l_i___0 := l_i___0 + 1
									end
								end
							end
							if not l_return then
								l_break := False
							end
						end
						if not l_return then
							u_getbot
						end
				when 6 then -- if done | if done
					if l_return then
						l_pos := -1 + 18 -- skip if block
					end
				when 7 then -- if:
						l_uep := create {CE_CLASS_POINTER [PD_U_ENTRY]}.make_cast (((create {P_MISC2_STATIC}).lalloc (((create {PD_U_ENTRY}.make).structure_size.to_natural_32).to_natural_32, 0)))
						if l_uep.is_void then
							l_pos := -1 + 19 -- goto nomem
						end
				when 8 then
						memset (create {CE_VOID_POINTER}.make_cast (l_uep), 0, (create {PD_U_ENTRY}.make).structure_size.to_natural_32).do_nothing
						l_uep.item.ue_size := l_size
						l_uep.item.ue_top := a_top
						if a_newbot /= 0 then
							l_uep.item.ue_bot := a_newbot
						elseif a_bot > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							l_uep.item.ue_bot := (0).to_integer_32
						else
							l_uep.item.ue_lcount := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count;
							((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead).item.uh_getbot_entry := l_uep
						end
						if not (l_size > 0) then
							l_pos := -1 + 17 -- skip if block
						end
				when 9 then -- if:
						l_tmp___13 := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (((create {P_MISC2_STATIC}).lalloc (({PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32 * l_size.to_natural_32, 0)))
						l_uep.item.ue_array := l_tmp___13
						if l_tmp___13.is_void then
							l_uep.item.u_freeentry (0)
							l_pos := -1 + 19 -- goto nomem
						end
				when 10 then
						l_i___0 := 0
						l_lnum := a_top + 1
				when 11 then -- loop condition:
						if not (not (l_return) and then (l_i___0 < l_size)) then
							l_pos := -1 + 16 -- skip loop
						end
				when 12 then -- loop body:;
						(create {P_MISC1_STATIC}).fast_breakcheck
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_uep.item.u_freeentry (l_i___0)
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_tmp___16 := l_lnum
						l_lnum := l_lnum + 1
						l_tmp___15 := u_save_line (l_tmp___16)
						l_uep.item.ue_array[l_i___0] := l_tmp___15
						if l_tmp___15.is_void then
							l_uep.item.u_freeentry (l_i___0)
							l_pos := -1 + 19 -- goto nomem
						end
				when 14 then
						l_i___0 := l_i___0 + 1
				when 15 then -- if done
						l_pos := -1 + 11 -- back to loop condition
				when 16 then -- loop done | if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						l_uep.item.ue_array := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
				when 18 then -- if done | if done
					if not l_return then
						l_uep.item.ue_next := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead).item.uh_entry;
						((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead).item.uh_entry := l_uep;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_synced := 0
						undo_undoes.item := 0
						Result := 1
						l_return := True
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 19 then -- if: | nomem:;
						(create {P_GLOBALS_STATIC}).msg_silent.item := 0
						if ((create {P_MISC1_STATIC}).ask_yesno (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("No undo possible; continue anyway")))), 1)) = 121 then
							(create {P_GLOBALS_STATIC}).undo_off.item := 1
							Result := 1
							l_return := True
						end
				when 20 then -- if done
					if not l_return then
						(create {P_MISC2_STATIC}).do_outofmem_msg ((0).to_natural_32)
						Result := 0
					end
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	u_get_undo_file_name (a_buf_ffname: CE_POINTER [NATURAL_8]; a_reading: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_dirp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_dir_name: CE_ARRAY [NATURAL_8]
			l_munged_name: CE_POINTER [NATURAL_8]
			l_undo_file_name: CE_POINTER [NATURAL_8]
			l_dir_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_st: CE_ARRAY [SD_STAT]
			l_ffname: CE_POINTER [NATURAL_8]
			l_fname_buf: CE_ARRAY [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_dirp.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_dir_name.make (<<1_026>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_fname_buf.make (<<4_096>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_munged_name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_undo_file_name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_ffname := a_buf_ffname
					if l_ffname.is_void then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_MEMLINE_STATIC}).resolve_symlink (l_ffname, l_fname_buf)) = 1 then
							l_ffname := l_fname_buf
						end
						l_dirp.item := (create {P_OPTION_STATIC}).p_udir.item.item
				when 2 then -- loop condition:
						if not (not (l_return or l_break) and then ((l_dirp.item.item).to_integer_32 /= 0)) then
							l_pos := -1 + 8 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_dir_len := (create {P_MISC2_STATIC}).copy_option_part (l_dirp, l_dir_name, 1_025, ce_string (","))
						if l_dir_len /= 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (l_dir_name[0]).to_integer_32 = 46 then
							l_undo_file_name := (create {P_MISC2_STATIC}).vim_strnsave (l_ffname, ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ffname))) + {NATURAL_32} 5).to_integer_32)
							if l_undo_file_name.is_void then
								l_break := True
							end
							if not (l_return or l_break) then
								l_p___0 := (create {P_MISC1_STATIC}).gettail (l_undo_file_name)
								memmove (create {CE_VOID_POINTER}.make_cast ((l_p___0 + 1)), create {CE_VOID_POINTER}.make_cast (l_p___0), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))) + {NATURAL_32} 1).do_nothing
								l_p___0.item := (('.').code).to_natural_8
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string (".un~")).do_nothing
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_dir_name[l_dir_len] := (('%/0/').code).to_natural_8
						if ((create {P_OS_UNIX_STATIC}).mch_isdir (l_dir_name)).to_boolean then
							if l_munged_name.is_void then
								l_munged_name := (create {P_MISC2_STATIC}).vim_strsave (l_ffname)
								if l_munged_name.is_void then
									Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
									l_return := True
								end
								if not l_return then
									l_p___0 := l_munged_name
									from
									until
										(l_p___0.item).to_integer_32 = 0
									loop
										if ((create {P_MISC1_STATIC}).vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
											l_p___0.item := (('%%').code).to_natural_8
										end
										if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
											l_tmp___3 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
										else
											l_tmp___3 := 1
										end
										l_p___0 := l_p___0 + l_tmp___3
									end
								end
							end
							if not l_return then
								l_undo_file_name := (create {P_MISC1_STATIC}).concat_fnames (l_dir_name, l_munged_name, 1)
							end
						end
				when 7 then
						if not (l_return or l_break) and then (not l_undo_file_name.is_void) then
							if not a_reading.to_boolean then
								l_break := True
							elseif (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_undo_file_name), l_st)) >= 0 then
								l_break := True
							end
						end
						if not (l_return or l_break) then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_undo_file_name))
							l_undo_file_name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
						l_pos := -1 + 2 -- back to loop condition
				when 8 then -- loop done | if done
					if not l_return then
						l_break := False;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_munged_name))
						Result := l_undo_file_name
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	corruption_error (a_mesg: CE_POINTER [INTEGER_8]; a_file_name: CE_POINTER [NATURAL_8])
		do
			(create {P_MISC2_STATIC}).emsg3 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E825: Corrupted undo file (%%s): %%s")))), create {CE_NATURAL_8_POINTER}.make_cast (a_mesg), a_file_name).do_nothing
		end

	read_string_decrypt (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_fd: CE_POINTER [SD_IO_FILE]; a_len: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_ptr: CE_POINTER [NATURAL_8]
		do
			l_ptr := (create {P_MISC2_STATIC}).read_string (a_fd, a_len)
			if not l_ptr.is_void then
				if ((a_buf___6.item.b_p_key).item).to_integer_32 /= 0 then
					(create {P_MISC2_STATIC}).crypt_decode (l_ptr, a_len.to_integer_32)
				end
			end
			Result := l_ptr
		end

	serialize_header (a_fp: CE_POINTER [SD_IO_FILE]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_hash: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_len: INTEGER_32
			l_header: CE_POINTER [NATURAL_8]
			l_header_len: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_header_len.make (<<1>>)

			if (fwrite (create {CE_VOID_POINTER}.make_cast (ce_string ("Vim%/159/UnDo%/229/")), (9).to_natural_32, (1).to_natural_32, a_fp)) /= {NATURAL_32} 1 then
				Result := 0
				l_return := True
			end
			if not l_return then
				if ((a_buf___6.item.b_p_key).item).to_integer_32 /= 0 then
					(create {P_MISC2_STATIC}).put_bytes (a_fp, (32_770).to_natural_32, 2).do_nothing
					l_header := a_buf___6.item.prepare_crypt_write (l_header_len)
					if l_header.is_void then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_len := (fwrite (create {CE_VOID_POINTER}.make_cast (l_header), (l_header_len.item).to_natural_32, (1).to_natural_32, a_fp)).to_integer_32;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_header))
						if l_len /= 1 then
							(create {P_MISC2_STATIC}).crypt_pop_state
							Result := 0
							l_return := True
						end
					end
				else
					(create {P_MISC2_STATIC}).put_bytes (a_fp, (2).to_natural_32, 2).do_nothing
				end
			end
			if not l_return then
				if (fwrite (create {CE_VOID_POINTER}.make_cast (a_hash), (32).to_natural_32, (1).to_natural_32, a_fp)) /= {NATURAL_32} 1 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_buf___6.item.b_ml.ml_line_count).to_natural_32, 4).do_nothing
				if not (a_buf___6.item.b_u_line_ptr).is_void then
					l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6.item.b_u_line_ptr))).to_integer_32
				else
					l_len := 0
				end
				(create {P_MISC2_STATIC}).put_bytes (a_fp, l_len.to_natural_32, 4).do_nothing
				if l_len > 0 then
					if (a_buf___6.item.fwrite_crypt (a_buf___6.item.b_u_line_ptr, l_len.to_natural_32, a_fp)) /= {NATURAL_32} 1 then
						Result := 0
						l_return := True
					end
				end
			end
			if not l_return then
				(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_buf___6.item.b_u_line_lnum).to_natural_32, 4).do_nothing;
				(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_buf___6.item.b_u_line_colnr).to_natural_32, 4).do_nothing
				put_header_ptr (a_fp, a_buf___6.item.b_u_oldhead)
				put_header_ptr (a_fp, a_buf___6.item.b_u_newhead)
				put_header_ptr (a_fp, a_buf___6.item.b_u_curhead);
				(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_buf___6.item.b_u_numhead).to_natural_32, 4).do_nothing;
				(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_buf___6.item.b_u_seq_last).to_natural_32, 4).do_nothing;
				(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_buf___6.item.b_u_seq_cur).to_natural_32, 4).do_nothing;
				(create {P_MISC2_STATIC}).put_time (a_fp, a_buf___6.item.b_u_time_cur)
				IO_putc (4, a_fp).do_nothing
				IO_putc (1, a_fp).do_nothing;
				(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_buf___6.item.b_u_save_nr_last).to_natural_32, 4).do_nothing
				IO_putc (0, a_fp).do_nothing
				Result := 1
			end
		end

	serialize_uhp (a_fp: CE_POINTER [SD_IO_FILE]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_uhp: CE_POINTER [PD_U_HEADER]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_uep: CE_POINTER [PD_U_ENTRY]
			l_return: BOOLEAN
		do
			if ((create {P_MISC2_STATIC}).put_bytes (a_fp, (24_528).to_natural_32, 2)) = 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				put_header_ptr (a_fp, a_uhp.item.uh_next.ptr)
				put_header_ptr (a_fp, a_uhp.item.uh_prev.ptr)
				put_header_ptr (a_fp, a_uhp.item.uh_alt_next.ptr)
				put_header_ptr (a_fp, a_uhp.item.uh_alt_prev.ptr);
				(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_uhp.item.uh_seq).to_natural_32, 4).do_nothing
				serialize_pos ((a_uhp.item.uh_cursor).twin, a_fp);
				(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_uhp.item.uh_cursor_vcol).to_natural_32, 4).do_nothing;
				(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_uhp.item.uh_flags).to_natural_32, 2).do_nothing
				l_i___0 := 0
				from
				until
					not (l_i___0 < 26)
				loop
					serialize_pos ((a_uhp.item.uh_namedm[l_i___0]).twin, a_fp)
					l_i___0 := l_i___0 + 1
				end
				(create {CE_CLASS_POINTER [PD_VISUALINFO_T]}.make_shared (a_uhp.c_pointer + (create {PD_U_HEADER}.make).offset_of ("uh_visual"))).item.serialize_visualinfo (a_fp);
				(create {P_MISC2_STATIC}).put_time (a_fp, a_uhp.item.uh_time)
				IO_putc (4, a_fp).do_nothing
				IO_putc (1, a_fp).do_nothing;
				(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_uhp.item.uh_save_nr).to_natural_32, 4).do_nothing
				IO_putc (0, a_fp).do_nothing
				l_uep := a_uhp.item.uh_entry
				from
				until
					not (not (l_return) and then (not l_uep.is_void))
				loop
					(create {P_MISC2_STATIC}).put_bytes (a_fp, (62_744).to_natural_32, 2).do_nothing
					if (serialize_uep (a_fp, a_buf___6, l_uep)) = 0 then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_uep := l_uep.item.ue_next
					end
				end
			end
			if not l_return then
				(create {P_MISC2_STATIC}).put_bytes (a_fp, (13_697).to_natural_32, 2).do_nothing
				Result := 1
			end
		end

	unserialize_uhp (a_fp: CE_POINTER [SD_IO_FILE]; a_file_name: CE_POINTER [NATURAL_8]): CE_POINTER [PD_U_HEADER]
		local
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_i___0: INTEGER_32
			l_uep: CE_POINTER [PD_U_ENTRY]
			l_last_uep: CE_POINTER [PD_U_ENTRY]
			l_c: INTEGER_32
			l_error: CE_ARRAY [INTEGER_32]
			l_len: INTEGER_32
			l_what: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_error.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_uhp := create {CE_CLASS_POINTER [PD_U_HEADER]}.make_cast (((create {P_MISC2_STATIC}).lalloc (((create {PD_U_HEADER}.make).structure_size.to_natural_32).to_natural_32, 0)))
					if l_uhp.is_void then
						Result := (create {CE_CLASS_POINTER [PD_U_HEADER]}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						memset (create {CE_VOID_POINTER}.make_cast (l_uhp), 0, (create {PD_U_HEADER}.make).structure_size.to_natural_32).do_nothing
						l_uhp.item.uh_next.seq := ((create {P_MISC2_STATIC}).get4c (a_fp)).to_integer_32
						l_uhp.item.uh_prev.seq := ((create {P_MISC2_STATIC}).get4c (a_fp)).to_integer_32
						l_uhp.item.uh_alt_next.seq := ((create {P_MISC2_STATIC}).get4c (a_fp)).to_integer_32
						l_uhp.item.uh_alt_prev.seq := ((create {P_MISC2_STATIC}).get4c (a_fp)).to_integer_32
						l_uhp.item.uh_seq := ((create {P_MISC2_STATIC}).get4c (a_fp)).to_integer_32
						if l_uhp.item.uh_seq <= 0 then
							corruption_error (ce_string ("uh_seq"), a_file_name);
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_uhp))
							Result := (create {CE_CLASS_POINTER [PD_U_HEADER]}.make_shared (default_pointer))
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:;
						(create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (l_uhp.c_pointer + (create {PD_U_HEADER}.make).offset_of ("uh_cursor"))).item.unserialize_pos (a_fp)
						l_uhp.item.uh_cursor_vcol := ((create {P_MISC2_STATIC}).get4c (a_fp)).to_integer_32
						l_uhp.item.uh_flags := (create {P_MISC2_STATIC}).get2c (a_fp)
						l_i___0 := 0
						from
						until
							not (l_i___0 < 26)
						loop
							(create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (l_uhp.c_pointer + (create {PD_U_HEADER}.make).offset_of ("uh_namedm") + (create {PD_POS_T}.make).structure_size * (l_i___0))).item.unserialize_pos (a_fp)
							l_i___0 := l_i___0 + 1
						end
						(create {CE_CLASS_POINTER [PD_VISUALINFO_T]}.make_shared (l_uhp.c_pointer + (create {PD_U_HEADER}.make).offset_of ("uh_visual"))).item.unserialize_visualinfo (a_fp)
						l_uhp.item.uh_time := (create {P_MISC2_STATIC}).get8ctime (a_fp)
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 8 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_len := (IO_getc (a_fp))
						if l_len = 0 then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 7 -- skip if block
						end
				when 4 then -- if:
						l_what := IO_getc (a_fp)
						inspect l_what -- switch 1 head
						when 1 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 5 then -- switch 1, case 1
						l_uhp.item.uh_save_nr := ((create {P_MISC2_STATIC}).get4c (a_fp)).to_integer_32
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
						from
						until
							(l_break)
						loop
							l_break := False
							l_len := l_len - 1
							if not (l_len >= 0) then
								l_break := True
							end
							if not (l_break) then
								IO_getc (a_fp).do_nothing
							end
						end
						l_break := False
				when 7 then -- switch 1, done: | if done
						l_pos := -1 + 2 -- back to loop condition
				when 8 then -- loop done
						l_break := False
						l_last_uep := create {CE_CLASS_POINTER [PD_U_ENTRY]}.make_shared (default_pointer)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_c := (create {P_MISC2_STATIC}).get2c (a_fp)
							if l_c /= 62_744 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_error.item := 0
								l_uep := unserialize_uep (a_fp, l_error, a_file_name)
								if l_last_uep.is_void then
									l_uhp.item.uh_entry := l_uep
								else
									l_last_uep.item.ue_next := l_uep
								end
								l_last_uep := l_uep
								if l_uep.is_void then
									l_uhp.item.u_free_uhp
									Result := (create {CE_CLASS_POINTER [PD_U_HEADER]}.make_shared (default_pointer))
									l_return := True
								elseif (l_error.item).to_boolean then
									l_uhp.item.u_free_uhp
									Result := (create {CE_CLASS_POINTER [PD_U_HEADER]}.make_shared (default_pointer))
									l_return := True
								end
							end
						end
				when 9 then -- if done
					if not l_return then
						l_break := False
						if l_c /= 13_697 then
							corruption_error (ce_string ("entry end"), a_file_name)
							l_uhp.item.u_free_uhp
							Result := (create {CE_CLASS_POINTER [PD_U_HEADER]}.make_shared (default_pointer))
							l_return := True
						end
					end
					if not l_return then
						Result := l_uhp
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	serialize_uep (a_fp: CE_POINTER [SD_IO_FILE]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_uep: CE_POINTER [PD_U_ENTRY]): INTEGER_32
		require
			not a_uep.is_void
		local
			l_i___0: INTEGER_32
			l_len: NATURAL_32
			l_return: BOOLEAN
		do
			(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_uep.item.ue_top).to_natural_32, 4).do_nothing;
			(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_uep.item.ue_bot).to_natural_32, 4).do_nothing;
			(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_uep.item.ue_lcount).to_natural_32, 4).do_nothing;
			(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_uep.item.ue_size).to_natural_32, 4).do_nothing
			l_i___0 := 0
			from
			until
				not (not (l_return) and then (l_i___0.to_integer_32 < a_uep.item.ue_size))
			loop
				l_len := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_uep.item.ue_array[l_i___0]))
				if ((create {P_MISC2_STATIC}).put_bytes (a_fp, l_len.to_natural_32, 4)) = 0 then
					Result := 0
					l_return := True
				end
				if not l_return and then (l_len > {NATURAL_32} 0) then
					if (a_buf___6.item.fwrite_crypt (a_uep.item.ue_array[l_i___0], l_len, a_fp)) /= {NATURAL_32} 1 then
						Result := 0
						l_return := True
					end
				end
				if not l_return then
					l_i___0 := l_i___0 + 1
				end
			end
			if not l_return then
				Result := 1
			end
		end

	unserialize_uep (a_fp: CE_POINTER [SD_IO_FILE]; a_error: CE_POINTER [INTEGER_32]; a_file_name: CE_POINTER [NATURAL_8]): CE_POINTER [PD_U_ENTRY]
		local
			l_i___0: INTEGER_32
			l_uep: CE_POINTER [PD_U_ENTRY]
			l_array: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_line: CE_POINTER [NATURAL_8]
			l_line_len: INTEGER_32
			l_return: BOOLEAN
		do
			l_uep := create {CE_CLASS_POINTER [PD_U_ENTRY]}.make_cast (((create {P_MISC2_STATIC}).lalloc (((create {PD_U_ENTRY}.make).structure_size.to_natural_32).to_natural_32, 0)))
			if l_uep.is_void then
				Result := (create {CE_CLASS_POINTER [PD_U_ENTRY]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				memset (create {CE_VOID_POINTER}.make_cast (l_uep), 0, (create {PD_U_ENTRY}.make).structure_size.to_natural_32).do_nothing
				l_uep.item.ue_top := ((create {P_MISC2_STATIC}).get4c (a_fp)).to_integer_32
				l_uep.item.ue_bot := ((create {P_MISC2_STATIC}).get4c (a_fp)).to_integer_32
				l_uep.item.ue_lcount := ((create {P_MISC2_STATIC}).get4c (a_fp)).to_integer_32
				l_uep.item.ue_size := ((create {P_MISC2_STATIC}).get4c (a_fp)).to_integer_32
				if l_uep.item.ue_size > 0 then
					l_array := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (((create {P_MISC2_STATIC}).lalloc (({PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32 * (l_uep.item.ue_size).to_natural_32, 0)))
					if l_array.is_void then
						a_error.item := 1
						Result := l_uep
						l_return := True
					end
					if not l_return then
						memset (create {CE_VOID_POINTER}.make_cast (l_array), 0, (({PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32 * (l_uep.item.ue_size).to_natural_32).to_natural_32).do_nothing
					end
				else
					l_array := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
				end
			end
			if not l_return then
				l_uep.item.ue_array := l_array
				l_i___0 := 0
				from
				until
					not (not (l_return) and then (l_i___0.to_integer_32 < l_uep.item.ue_size))
				loop
					l_line_len := (create {P_MISC2_STATIC}).get4c (a_fp)
					if l_line_len >= 0 then
						l_line := read_string_decrypt ((create {P_GLOBALS_STATIC}).curbuf.item, a_fp, l_line_len)
					else
						l_line := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						corruption_error (ce_string ("line length"), a_file_name)
					end
					if l_line.is_void then
						a_error.item := 1
						Result := l_uep
						l_return := True
					end
					if not l_return then
						l_array[l_i___0] := l_line
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not l_return then
				Result := l_uep
			end
		end

	serialize_pos (a_pos___3: PD_POS_T; a_fp: CE_POINTER [SD_IO_FILE])
		do
			(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_pos___3.lnum).to_natural_32, 4).do_nothing;
			(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_pos___3.col).to_natural_32, 4).do_nothing;
			(create {P_MISC2_STATIC}).put_bytes (a_fp, (a_pos___3.coladd).to_natural_32, 4).do_nothing
		end

	put_header_ptr (a_fp: CE_POINTER [SD_IO_FILE]; a_uhp: CE_POINTER [PD_U_HEADER])
		local
			l_tmp: INTEGER_32
		do
			if not a_uhp.is_void then
				l_tmp := a_uhp.item.uh_seq
			else
				l_tmp := 0
			end
			(create {P_MISC2_STATIC}).put_bytes (a_fp, l_tmp.to_natural_32, 4).do_nothing
		end

	u_write_undo (a_name___1: CE_POINTER [NATURAL_8]; a_forceit: INTEGER_32; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_hash: CE_POINTER [NATURAL_8])
		local
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_file_name: CE_POINTER [NATURAL_8]
			l_mark: INTEGER_32
			l_fd: INTEGER_32
			l_fp: CE_POINTER [SD_IO_FILE]
			l_perm: INTEGER_32
			l_write_ok: INTEGER_32
			l_st_old_valid: INTEGER_32
			l_st_old: CE_ARRAY [SD_STAT]
			l_st_new: CE_ARRAY [SD_STAT]
			l_do_crypt: INTEGER_32
			l_mbuf: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_acl: CE_POINTER [ANY]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_st_old.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st_new.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_mbuf.make (<<9>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fp := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
					l_write_ok := 0
					l_st_old_valid := 0
					l_do_crypt := 0
					if a_name___1.is_void then
						l_file_name := u_get_undo_file_name (a_buf___6.item.b_ffname, 0)
						if l_file_name.is_void then
							if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
								(create {P_MESSAGE_STATIC}).verbose_enter;
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Cannot write undo file in any directory in %'undodir%'"))))]).do_nothing;
								(create {P_MESSAGE_STATIC}).verbose_leave
							end
							l_return := True
						end
					else
						l_file_name := a_name___1
					end
					if l_return then
						l_pos := -1 + 46 -- skip if block
					end
				when 1 then -- if:
						l_perm := 384
						if not (a_buf___6.item.b_ffname).is_void then
							if (stat (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6.item.b_ffname), l_st_old)) >= 0 then
								l_perm := (l_st_old.item.st_mode).to_integer_32
								l_st_old_valid := 1
							end
						end
						l_perm := (l_perm).bit_and ((511))
						if not (((create {P_OS_UNIX_STATIC}).mch_getperm (l_file_name)) >= 0) then
							l_pos := -1 + 25 -- skip if block
						end
				when 2 then -- if:
						if not (a_name___1.is_void) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L___2
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 5 then -- else:
						if a_forceit.to_boolean then
							l_pos := -1 + 24 -- skip if block
						end
				when 6 then -- if: | _L___2:
						l_fd := open ([create {CE_INTEGER_8_POINTER}.make_cast (l_file_name), 0, 0])
						if not (l_fd < 0) then
							l_pos := -1 + 14 -- skip if block
						end
				when 7 then -- if:
						if a_name___1.is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if not ((create {P_OPTION_STATIC}).p_verbose.item.item > 0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						if a_name___1.is_void then
							(create {P_MESSAGE_STATIC}).verbose_enter
						end
						(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Will not overwrite with undo file, cannot read: %%s")))), l_file_name]).do_nothing
						if a_name___1.is_void then
							(create {P_MESSAGE_STATIC}).verbose_leave
						end
				when 12 then -- if done
						l_pos := -1 + 45 -- goto theend
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 14 then -- else:
						l_len := read (l_fd, create {CE_VOID_POINTER}.make_cast (l_mbuf), (9).to_natural_32)
						close (l_fd).do_nothing
						if not (l_len < 9) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L___1
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 17 then -- else:
						if (memcmp (create {CE_VOID_POINTER}.make_cast (l_mbuf), create {CE_VOID_POINTER}.make_cast (ce_string ("Vim%/159/UnDo%/229/")), (9).to_natural_32)) = 0 then
							l_pos := -1 + 24 -- skip if block
						end
				when 18 then -- if: | _L___1:
						if a_name___1.is_void then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L___0
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 21 then -- else:
						if not ((create {P_OPTION_STATIC}).p_verbose.item.item > 0) then
							l_pos := -1 + 23 -- skip if block
						end
				when 22 then -- if: | _L___0:
						if a_name___1.is_void then
							(create {P_MESSAGE_STATIC}).verbose_enter
						end
						(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Will not overwrite, this is not an undo file: %%s")))), l_file_name]).do_nothing
						if a_name___1.is_void then
							(create {P_MESSAGE_STATIC}).verbose_leave
						end
				when 23 then -- if done
						l_pos := -1 + 45 -- goto theend
				when 24 then -- if done | if done | if done | if done
						unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_file_name)).do_nothing
				when 25 then -- if done
						if a_buf___6.item.b_u_numhead = 0 then
							if (a_buf___6.item.b_u_line_ptr).is_void then
								if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
									(create {P_MESSAGE_STATIC}).verb_msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Skipping undo file write, nothing to undo"))))).do_nothing
								end
								l_pos := -1 + 45 -- goto theend
							end
						end
				when 26 then
						l_fd := open ([create {CE_INTEGER_8_POINTER}.make_cast (l_file_name), 131_265, l_perm])
						if l_fd < 0 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (e_not_open.item)))), l_file_name).do_nothing
							l_pos := -1 + 45 -- goto theend
						end
				when 27 then;
						(create {P_OS_UNIX_STATIC}).mch_setperm (l_file_name, l_perm.to_integer_32).do_nothing
						if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
							(create {P_MESSAGE_STATIC}).verbose_enter;
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Writing undo file: %%s")))), l_file_name]).do_nothing;
							(create {P_MESSAGE_STATIC}).verbose_leave
						end
						if l_st_old_valid.to_boolean then
							if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_file_name), l_st_new)) >= 0 then
								if l_st_new.item.st_gid /= l_st_old.item.st_gid then
									if (fchown (l_fd, (-1).to_natural_32, l_st_old.item.st_gid)) /= 0 then
										(create {P_OS_UNIX_STATIC}).mch_setperm (l_file_name, ((((l_perm).bit_and (455))).bit_or (((((l_perm).bit_and (7))).bit_shift_left (3)))).to_integer_32).do_nothing
									end
								end
							end
						end
						l_fp := fdopen (l_fd, ce_string ("w"))
						if l_fp.is_void then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (e_not_open.item)))), l_file_name).do_nothing
							close (l_fd).do_nothing
							unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_file_name)).do_nothing
							l_pos := -1 + 45 -- goto theend
						end
				when 28 then
						u_sync (1)
						if (serialize_header (l_fp, a_buf___6, a_hash)) = 0 then
							l_pos := -1 + 44 -- goto write_error
						end
				when 29 then
						if ((a_buf___6.item.b_p_key).item).to_integer_32 /= 0 then
							l_do_crypt := 1
						end
						lastmark.item := lastmark.item + 1
						l_mark := lastmark.item
						l_uhp := a_buf___6.item.b_u_oldhead
				when 30 then -- loop condition:
						if l_uhp.is_void then
							l_pos := -1 + 43 -- skip loop
						end
				when 31 then -- loop body:
						if l_uhp.item.uh_walk /= l_mark then
							l_uhp.item.uh_walk := l_mark
							if (serialize_uhp (l_fp, a_buf___6, l_uhp)) = 0 then
								l_pos := -1 + 44 -- goto write_error
							end
						end
				when 32 then
						if (l_uhp.item.uh_prev.ptr).is_void then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						if (l_uhp.item.uh_prev.ptr).item.uh_walk /= l_mark then
							l_uhp := l_uhp.item.uh_prev.ptr
						else
							l_pos := -1 + 35 -- goto _L___6
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 35 then -- else: | _L___6:
						if (l_uhp.item.uh_alt_next.ptr).is_void then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						if (l_uhp.item.uh_alt_next.ptr).item.uh_walk /= l_mark then
							l_uhp := l_uhp.item.uh_alt_next.ptr
						else
							l_pos := -1 + 38 -- goto _L___5
						end
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 38 then -- else: | _L___5:
						if (l_uhp.item.uh_next.ptr).is_void then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						if (l_uhp.item.uh_alt_prev.ptr).is_void then
							if (l_uhp.item.uh_next.ptr).item.uh_walk /= l_mark then
								l_uhp := l_uhp.item.uh_next.ptr
							else
								l_pos := -1 + 41 -- goto _L___4
							end
						else
							l_pos := -1 + 41 -- goto _L___4
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else: | _L___4:
						if not (l_uhp.item.uh_alt_prev.ptr).is_void then
							l_uhp := l_uhp.item.uh_alt_prev.ptr
						else
							l_uhp := l_uhp.item.uh_next.ptr
						end
				when 42 then -- if done | if done
						l_pos := -1 + 30 -- back to loop condition
				when 43 then -- loop done
						if ((create {P_MISC2_STATIC}).put_bytes (l_fp, (59_306).to_natural_32, 2)) = 1 then
							l_write_ok := 1
						end
				when 44 then -- write_error:
						fclose (l_fp).do_nothing
						if not l_write_ok.to_boolean then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E829: write error in undo file: %%s")))), l_file_name).do_nothing
						end
						if not (a_buf___6.item.b_ffname).is_void then
							l_acl := (create {P_OS_UNIX_STATIC}).mch_get_acl (a_buf___6.item.b_ffname);
							(create {P_OS_UNIX_STATIC}).mch_set_acl (l_file_name, l_acl)
						end
				when 45 then -- theend:
						if l_do_crypt.to_boolean then
							(create {P_MISC2_STATIC}).crypt_pop_state
						end
						if not l_file_name.is_equal (a_name___1) then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_file_name))
						end
				when 46 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	u_read_undo (a_name___1, a_hash, a_orig_name: CE_POINTER [NATURAL_8])
		local
			l_file_name: CE_POINTER [NATURAL_8]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_version: INTEGER_32
			l_str_len: INTEGER_32
			l_line_ptr: CE_POINTER [NATURAL_8]
			l_line_lnum: INTEGER_32
			l_line_colnr: INTEGER_32
			l_line_count: INTEGER_32
			l_num_head: INTEGER_32
			l_old_header_seq: INTEGER_32
			l_new_header_seq: INTEGER_32
			l_cur_header_seq: INTEGER_32
			l_seq_last: INTEGER_32
			l_seq_cur: INTEGER_32
			l_last_save_nr: INTEGER_32
			l_old_idx: INTEGER_16
			l_new_idx: INTEGER_16
			l_cur_idx: INTEGER_16
			l_num_read_uhps: INTEGER_32
			l_seq_time: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_c: INTEGER_32
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_uhp_table: CE_POINTER [CE_POINTER [PD_U_HEADER]]
			l_read_hash: CE_ARRAY [NATURAL_8]
			l_magic_buf: CE_ARRAY [NATURAL_8]
			l_st_orig: CE_ARRAY [SD_STAT]
			l_st_undo: CE_ARRAY [SD_STAT]
			l_do_decrypt: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_len: INTEGER_32
			l_what: INTEGER_32
			l_tmp___27: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_read_hash.make (<<32>>)
			create {CE_NATURAL_8_ARRAY} l_magic_buf.make (<<9>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st_orig.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st_undo.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line_ptr := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_num_head := 0
					l_last_save_nr := 0
					l_old_idx := (-1).to_integer_16
					l_new_idx := (-1).to_integer_16
					l_cur_idx := (-1).to_integer_16
					l_num_read_uhps := 0
					l_uhp_table := create {CE_POINTER_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
					l_do_decrypt := 0
					if a_name___1.is_void then
						l_file_name := u_get_undo_file_name ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname, 1)
						if l_file_name.is_void then
							l_return := True
						end
						if not l_return then
							if (stat (create {CE_INTEGER_8_POINTER}.make_cast (a_orig_name), l_st_orig)) >= 0 then
								if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_file_name), l_st_undo)) >= 0 then
									if l_st_orig.item.st_uid /= l_st_undo.item.st_uid then
										if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
											(create {P_MESSAGE_STATIC}).verbose_enter;
											(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Not reading undo file, owner differs: %%s")))), l_file_name]).do_nothing;
											(create {P_MESSAGE_STATIC}).verbose_leave
										end
										l_return := True
									end
								end
							end
						end
					else
						l_file_name := a_name___1
					end
					if l_return then
						l_pos := -1 + 50 -- skip if block
					end
				when 1 then -- if:
						if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
							(create {P_MESSAGE_STATIC}).verbose_enter;
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Reading undo file: %%s")))), l_file_name]).do_nothing;
							(create {P_MESSAGE_STATIC}).verbose_leave
						end
						l_fp := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_file_name), ce_string ("r"))
						if l_fp.is_void then
							if not a_name___1.is_void then
								l_tmp___3 := gettext (ce_string ("E822: Cannot open undo file for reading: %%s"));
								(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___3), l_file_name).do_nothing
							elseif (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
								l_tmp___3 := gettext (ce_string ("E822: Cannot open undo file for reading: %%s"));
								(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___3), l_file_name).do_nothing
							end
							l_pos := -1 + 48 -- goto error
						end
				when 2 then
						if (fread (create {CE_VOID_POINTER}.make_cast (l_magic_buf), (9).to_natural_32, (1).to_natural_32, l_fp)) /= {NATURAL_32} 1 then
							l_tmp___4 := gettext (ce_string ("E823: Not an undo file: %%s"));
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___4), l_file_name).do_nothing
							l_pos := -1 + 48 -- goto error
						elseif (memcmp (create {CE_VOID_POINTER}.make_cast (l_magic_buf), create {CE_VOID_POINTER}.make_cast (ce_string ("Vim%/159/UnDo%/229/")), (9).to_natural_32)) /= 0 then
							l_tmp___4 := gettext (ce_string ("E823: Not an undo file: %%s"));
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___4), l_file_name).do_nothing
							l_pos := -1 + 48 -- goto error
						end
				when 3 then
						l_version := ((create {P_MISC2_STATIC}).get2c (l_fp)).to_integer_32
						if l_version /= 32_770 then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_key).item).to_integer_32 = 0 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E832: Non-encrypted file has encrypted undo file: %%s")))), l_file_name).do_nothing
							l_pos := -1 + 48 -- goto error
						end
				when 5 then
						if ((create {P_FILEIO_STATIC}).prepare_crypt_read (l_fp)) = 0 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E826: Undo file decryption failed: %%s")))), l_file_name).do_nothing
							l_pos := -1 + 48 -- goto error
						end
				when 6 then
						l_do_decrypt := 1
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						if l_version /= 2 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E824: Incompatible undo file: %%s")))), l_file_name).do_nothing
							l_pos := -1 + 48 -- goto error
						end
				when 9 then
						if (fread (create {CE_VOID_POINTER}.make_cast (l_read_hash), (32).to_natural_32, (1).to_natural_32, l_fp)) /= {NATURAL_32} 1 then
							corruption_error (ce_string ("hash"), l_file_name)
							l_pos := -1 + 48 -- goto error
						end
				when 10 then
						l_line_count := ((create {P_MISC2_STATIC}).get4c (l_fp)).to_integer_32
						if (memcmp (create {CE_VOID_POINTER}.make_cast (a_hash), create {CE_VOID_POINTER}.make_cast (l_read_hash), (32).to_natural_32)) = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else:
						if l_line_count = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							l_pos := -1 + 20 -- skip if block
						end
				when 14 then -- if: | _L___0:
						if not ((create {P_OPTION_STATIC}).p_verbose.item.item > 0) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 17 then -- else:
						if a_name___1.is_void then
							l_pos := -1 + 19 -- skip if block
						end
				when 18 then -- if: | _L:
						if a_name___1.is_void then
							(create {P_MESSAGE_STATIC}).verbose_enter
						end
						(create {P_MESSAGE_STATIC}).give_warning (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("File contents changed, cannot use undo info")))), 1)
						if a_name___1.is_void then
							(create {P_MESSAGE_STATIC}).verbose_leave
						end
				when 19 then -- if done
						l_pos := -1 + 48 -- goto error
				when 20 then -- if done
						l_str_len := ((create {P_MISC2_STATIC}).get4c (l_fp)).to_integer_32
						if l_str_len < 0 then
							l_pos := -1 + 48 -- goto error
						end
				when 21 then
						if l_str_len > 0 then
							l_line_ptr := read_string_decrypt ((create {P_GLOBALS_STATIC}).curbuf.item, l_fp, l_str_len.to_integer_32)
						end
						l_line_lnum := ((create {P_MISC2_STATIC}).get4c (l_fp)).to_integer_32
						l_line_colnr := ((create {P_MISC2_STATIC}).get4c (l_fp))
						if l_line_lnum < 0 then
							corruption_error (ce_string ("line lnum/col"), l_file_name)
							l_pos := -1 + 48 -- goto error
						elseif l_line_colnr < 0 then
							corruption_error (ce_string ("line lnum/col"), l_file_name)
							l_pos := -1 + 48 -- goto error
						end
				when 22 then
						l_old_header_seq := ((create {P_MISC2_STATIC}).get4c (l_fp)).to_integer_32
						l_new_header_seq := ((create {P_MISC2_STATIC}).get4c (l_fp)).to_integer_32
						l_cur_header_seq := ((create {P_MISC2_STATIC}).get4c (l_fp)).to_integer_32
						l_num_head := (create {P_MISC2_STATIC}).get4c (l_fp)
						l_seq_last := ((create {P_MISC2_STATIC}).get4c (l_fp)).to_integer_32
						l_seq_cur := ((create {P_MISC2_STATIC}).get4c (l_fp)).to_integer_32
						l_seq_time := (create {P_MISC2_STATIC}).get8ctime (l_fp)
				when 23 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 29 -- skip loop
						end
				when 24 then -- loop body:
						l_break := False
						l_len := (IO_getc (l_fp))
						if l_len = 0 then
							l_break := True
						elseif l_len = -1 then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 28 -- skip if block
						end
				when 25 then -- if:
						l_what := IO_getc (l_fp)
						inspect l_what -- switch 1 head
						when 1 then l_pos := -1 + 26
						else l_pos := -1 + 27
						end
				when 26 then -- switch 1, case 1
						l_last_save_nr := ((create {P_MISC2_STATIC}).get4c (l_fp)).to_integer_32
						l_pos := -1 + 28 -- switch 1; break
				when 27 then -- switch 1, default:
						from
						until
							(l_break)
						loop
							l_break := False
							l_len := l_len - 1
							if not (l_len >= 0) then
								l_break := True
							end
							if not (l_break) then
								IO_getc (l_fp).do_nothing
							end
						end
						l_break := False
				when 28 then -- switch 1, done: | if done
						l_pos := -1 + 23 -- back to loop condition
				when 29 then -- loop done
						l_break := False
						if l_num_head > 0 then
							l_uhp_table := create {CE_POINTER_POINTER [PD_U_HEADER]}.make_cast (((create {P_MISC2_STATIC}).lalloc ((l_num_head.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32, 0)))
							if l_uhp_table.is_void then
								l_pos := -1 + 48 -- goto error
							end
						end
				when 30 then
						if (l_break) then
							l_pos := -1 + 36 -- skip loop
						end
				when 31 then -- loop body:
						l_break := False
						l_c := (create {P_MISC2_STATIC}).get2c (l_fp)
						if l_c /= 24_528 then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 35 -- skip if block
						end
				when 32 then -- if:
						if l_num_read_uhps >= l_num_head.to_integer_32 then
							corruption_error (ce_string ("num_head too small"), l_file_name)
							l_pos := -1 + 48 -- goto error
						end
				when 33 then
						l_uhp := unserialize_uhp (l_fp, l_file_name)
						if l_uhp.is_void then
							l_pos := -1 + 48 -- goto error
						end
				when 34 then
						l_tmp___27 := l_num_read_uhps
						l_num_read_uhps := l_num_read_uhps + 1
						l_uhp_table[l_tmp___27] := l_uhp
				when 35 then -- if done
						l_pos := -1 + 30 -- back to loop condition
				when 36 then -- loop done
						l_break := False
						if l_num_read_uhps /= l_num_head.to_integer_32 then
							corruption_error (ce_string ("num_head"), l_file_name)
							l_pos := -1 + 48 -- goto error
						end
				when 37 then
						if l_c /= 59_306 then
							corruption_error (ce_string ("end marker"), l_file_name)
							l_pos := -1 + 48 -- goto error
						end
				when 38 then
						l_i___0 := 0
				when 39 then -- loop condition:
						if not (not (l_return) and then (l_i___0 < l_num_head)) then
							l_pos := -1 + 47 -- skip loop
						end
				when 40 then -- loop body:
						l_continue := False
						l_uhp := l_uhp_table[l_i___0]
						if l_uhp.is_void then
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 46 -- skip if block
						end
				when 41 then -- if:
						l_j := 0
				when 42 then -- loop condition:
						if not (l_j < l_num_head) then
							l_pos := -1 + 45 -- skip loop
						end
				when 43 then -- loop body:
						if not (l_uhp_table[l_j]).is_void then
							if l_i___0 /= l_j then
								if (l_uhp_table[l_i___0]).item.uh_seq = (l_uhp_table[l_j]).item.uh_seq then
									corruption_error (ce_string ("duplicate uh_seq"), l_file_name)
									l_pos := -1 + 48 -- goto error
								end
							end
						end
				when 44 then
						l_j := l_j + 1
						l_pos := -1 + 42 -- back to loop condition
				when 45 then -- loop done
						l_j := 0
						from
						until
							not (not (l_break) and then (l_j < l_num_head))
						loop
							l_break := False
							if not (l_uhp_table[l_j]).is_void then
								if (l_uhp_table[l_j]).item.uh_seq = l_uhp.item.uh_next.seq then
									l_uhp.item.uh_next.ptr := l_uhp_table[l_j]
									l_break := True
								end
							end
							if not (l_return or l_break) then
								l_j := l_j + 1
							end
						end
						l_break := False
						l_j := 0
						from
						until
							not (not (l_break) and then (l_j < l_num_head))
						loop
							l_break := False
							if not (l_uhp_table[l_j]).is_void then
								if (l_uhp_table[l_j]).item.uh_seq = l_uhp.item.uh_prev.seq then
									l_uhp.item.uh_prev.ptr := l_uhp_table[l_j]
									l_break := True
								end
							end
							if not (l_return or l_break) then
								l_j := l_j + 1
							end
						end
						l_break := False
						l_j := 0
						from
						until
							not (not (l_break) and then (l_j < l_num_head))
						loop
							l_break := False
							if not (l_uhp_table[l_j]).is_void then
								if (l_uhp_table[l_j]).item.uh_seq = l_uhp.item.uh_alt_next.seq then
									l_uhp.item.uh_alt_next.ptr := l_uhp_table[l_j]
									l_break := True
								end
							end
							if not (l_return or l_break) then
								l_j := l_j + 1
							end
						end
						l_break := False
						l_j := 0
						from
						until
							not (not (l_break) and then (l_j < l_num_head))
						loop
							l_break := False
							if not (l_uhp_table[l_j]).is_void then
								if (l_uhp_table[l_j]).item.uh_seq = l_uhp.item.uh_alt_prev.seq then
									l_uhp.item.uh_alt_prev.ptr := l_uhp_table[l_j]
									l_break := True
								end
							end
							if not (l_return or l_break) then
								l_j := l_j + 1
							end
						end
						l_break := False
						if l_old_header_seq > 0 then
							if l_old_idx.to_integer_32 < 0 then
								if l_uhp.item.uh_seq = l_old_header_seq then
									l_old_idx := l_i___0.to_integer_16
								end
							end
						end
						if l_new_header_seq > 0 then
							if l_new_idx.to_integer_32 < 0 then
								if l_uhp.item.uh_seq = l_new_header_seq then
									l_new_idx := l_i___0.to_integer_16
								end
							end
						end
						if l_cur_header_seq > 0 then
							if l_cur_idx.to_integer_32 < 0 then
								if l_uhp.item.uh_seq = l_cur_header_seq then
									l_cur_idx := l_i___0.to_integer_16
								end
							end
						end
				when 46 then -- if done
						if (not l_return) then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 39 -- back to loop condition
				when 47 then -- loop done
						l_continue := False;
						((create {P_GLOBALS_STATIC}).curbuf.item).item.u_blockfree
						if l_old_idx.to_integer_32 < 0 then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_oldhead := create {CE_CLASS_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
						else
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_oldhead := l_uhp_table[l_old_idx.to_integer_32]
						end
						if l_new_idx.to_integer_32 < 0 then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead := create {CE_CLASS_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
						else
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead := l_uhp_table[l_new_idx.to_integer_32]
						end
						if l_cur_idx.to_integer_32 < 0 then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead := create {CE_CLASS_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
						else
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead := l_uhp_table[l_cur_idx.to_integer_32]
						end
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_line_ptr := l_line_ptr;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_line_lnum := l_line_lnum;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_line_colnr := l_line_colnr;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_numhead := l_num_head;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_seq_last := l_seq_last;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_seq_cur := l_seq_cur;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_time_cur := l_seq_time;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_save_nr_last := l_last_save_nr;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_synced := 1;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_uhp_table))
						if not a_name___1.is_void then
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Finished reading undo file %%s")))), l_file_name]).do_nothing
						end
						l_pos := -1 + 49 -- goto theend
				when 48 then -- error:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_line_ptr))
						if not l_uhp_table.is_void then
							l_i___0 := 0
							from
							until
								not (l_i___0.to_integer_32 < l_num_read_uhps)
							loop
								if not (l_uhp_table[l_i___0]).is_void then
									(l_uhp_table[l_i___0]).item.u_free_uhp
								end
								l_i___0 := l_i___0 + 1
							end
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_uhp_table))
						end
				when 49 then -- theend:
						if l_do_decrypt.to_boolean then
							(create {P_MISC2_STATIC}).crypt_pop_state
						end
						if not l_fp.is_void then
							fclose (l_fp).do_nothing
						end
						if not l_file_name.is_equal (a_name___1) then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_file_name))
						end
				when 50 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	u_undo (a_count___2: INTEGER_32)
		local
			l_count___2: INTEGER_32
		do
			l_count___2 := a_count___2
			if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_synced = 0 then
				u_sync (1)
				l_count___2 := 1
			end
			if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('u').code)).is_void then
				undo_undoes.item := 1
			else
				undo_undoes.item := (not undo_undoes.item.to_boolean).to_integer
			end
			u_doit (l_count___2)
		end

	u_redo (a_count___2: INTEGER_32)
		do
			if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('u').code)).is_void then
				undo_undoes.item := 0
			end
			u_doit (a_count___2)
		end

	u_doit (a_startcount: INTEGER_32)
		local
			l_count___2: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_startcount
					if not (undo_allowed).to_boolean then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						u_newcount.item := 0
						u_oldcount.item := 0
						if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_and (1)).to_boolean then
							u_oldcount.item := -1
						end
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 19 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_tmp___2 := l_count___2
						l_count___2 := l_count___2 - 1
						if not l_tmp___2.to_boolean then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 18 -- skip if block
						end
				when 4 then -- if:;
						(create {P_MISC1_STATIC}).change_warning (0)
						if not (undo_undoes.item.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if:
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead).is_void then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead
						elseif (create {P_OPTION_STATIC}).p_ul.item.item > 0 then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead).item.uh_next.ptr
						end
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_numhead /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead).is_void) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_oldhead;
						(create {P_MISC1_STATIC}).beep_flush
						if l_count___2 = a_startcount - 1 then
							(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Already at oldest change"))))).do_nothing
							l_return := True
						end
						if not l_return then
							l_break := True
						end
				when 10 then -- if done
						if not (l_return or l_break) then
							u_undoredo (1)
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 12 then -- else:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead).is_void) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if not ((create {P_OPTION_STATIC}).p_ul.item.item <= 0) then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L___0:;
						(create {P_MISC1_STATIC}).beep_flush
						if l_count___2 = a_startcount - 1 then
							(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Already at newest change"))))).do_nothing
							l_return := True
						end
						if not l_return then
							l_break := True
						end
				when 17 then -- if done
						if not (l_return or l_break) then
							u_undoredo (0)
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead).item.uh_prev.ptr).is_void then
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead
							end
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead).item.uh_prev.ptr
						end
				when 18 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 19 then -- loop done | if done
					if not l_return then
						l_break := False
						u_undo_end (undo_undoes.item, 0)
					end
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	undo_time (a_step: INTEGER_32; a_sec, a_file, a_absolute: INTEGER_32)
		local
			l_target: INTEGER_32
			l_closest: INTEGER_32
			l_closest_start: INTEGER_32
			l_closest_seq: INTEGER_32
			l_val___0: INTEGER_32
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_last: CE_POINTER [PD_U_HEADER]
			l_mark: INTEGER_32
			l_nomark: INTEGER_32
			l_round: INTEGER_32
			l_dosec: INTEGER_32
			l_dofile: INTEGER_32
			l_above: INTEGER_32
			l_did_undo: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [PD_U_HEADER]} l_uhp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_closest_seq := 0
					l_dosec := a_sec
					l_dofile := a_file
					l_above := 0
					l_did_undo := 1
					if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_synced = 0 then
						u_sync (1)
					end
					u_newcount.item := 0
					u_oldcount.item := 0
					if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_and (1)).to_boolean then
						u_oldcount.item := -1
					end
					if a_absolute.to_boolean then
						l_target := a_step
						l_closest := -1
					else
						if l_dosec.to_boolean then
							l_target := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_time_cur - (create {P_GLOBALS_STATIC}).starttime.item) + a_step
						elseif l_dofile.to_boolean then
							if a_step < 0 then
								l_uhp := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead
								if not l_uhp.is_void then
									l_uhp := l_uhp.item.uh_next.ptr
								else
									l_uhp := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead
								end
								if not l_uhp.is_void then
									if l_uhp.item.uh_save_nr /= 0 then
										l_target := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_save_nr_cur + a_step
									else
										l_target := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_save_nr_cur + a_step) + 1
									end
								else
									l_target := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_save_nr_cur + a_step) + 1
								end
								if l_target <= 0 then
									l_dofile := 0
								end
							else
								l_target := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_save_nr_cur + a_step
								if l_target > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_save_nr_last then
									l_target := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_seq_last + 1
									l_dofile := 0
								end
							end
						else
							l_target := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_seq_cur + a_step
						end
						if a_step < 0 then
							if l_target < 0 then
								l_target := 0
							end
							l_closest := -1
						else
							if l_dosec.to_boolean then
								l_closest := ((time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))) - (create {P_GLOBALS_STATIC}).starttime.item) + 1
							elseif l_dofile.to_boolean then
								l_closest := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_save_nr_last + 2
							else
								l_closest := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_seq_last + 2
							end
							if l_target >= l_closest then
								l_target := l_closest - 1
							end
						end
					end
					l_closest_start := l_closest
					l_closest_seq := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_seq_cur
					l_round := 1
				when 1 then -- loop condition:
					if not (not (l_return or l_break) and then (l_round <= 2)) then
						l_pos := -1 + 27 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						lastmark.item := lastmark.item + 1
						l_mark := lastmark.item
						lastmark.item := lastmark.item + 1
						l_nomark := lastmark.item
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead).is_void then
							l_uhp := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead
						else
							l_uhp := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead
						end
				when 3 then -- loop condition:
						if not (not (l_break) and then (not l_uhp.is_void)) then
							l_pos := -1 + 26 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						l_uhp.item.uh_walk := l_mark
						if l_dosec.to_boolean then
							l_val___0 := l_uhp.item.uh_time - (create {P_GLOBALS_STATIC}).starttime.item
						elseif l_dofile.to_boolean then
							l_val___0 := l_uhp.item.uh_save_nr
						else
							l_val___0 := l_uhp.item.uh_seq
						end
						if l_round /= 1 then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						if not (l_dofile.to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_val___0 /= 0 then
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 8 then -- else: | _L___0:
						if a_step < 0 then
							l_tmp___0 := (l_uhp.item.uh_seq <= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_seq_cur).to_integer
						else
							l_tmp___0 := (l_uhp.item.uh_seq > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_seq_cur).to_integer
						end
						if not (l_tmp___0.to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if:
						if not (l_dosec.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_val___0 = l_closest then
							if a_step < 0 then
								l_tmp___1 := (l_uhp.item.uh_seq < l_closest_seq).to_integer
							else
								l_tmp___1 := (l_uhp.item.uh_seq > l_closest_seq).to_integer
							end
							l_tmp___6 := l_tmp___1
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if l_closest = l_closest_start then
							l_tmp___5 := 1
						else
							if l_val___0 > l_target then
								if l_closest > l_target then
									l_tmp___2 := (l_val___0 - l_target <= l_closest - l_target).to_integer
								else
									l_tmp___2 := (l_val___0 - l_target <= l_target - l_closest).to_integer
								end
								l_tmp___4 := l_tmp___2
							else
								if l_closest > l_target then
									l_tmp___3 := (l_target - l_val___0 <= l_closest - l_target).to_integer
								else
									l_tmp___3 := (l_target - l_val___0 <= l_target - l_closest).to_integer
								end
								l_tmp___4 := l_tmp___3
							end
							if l_tmp___4.to_boolean then
								l_tmp___5 := 1
							else
								l_tmp___5 := 0
							end
						end
						l_tmp___6 := l_tmp___5
				when 13 then
						if l_tmp___6.to_boolean then
							l_closest := l_val___0
							l_closest_seq := l_uhp.item.uh_seq
						end
				when 14 then -- if done | if done
						if l_target = l_val___0 then
							if not l_dosec.to_boolean then
								l_target := l_uhp.item.uh_seq
								l_break := True
							end
						end
						if (l_break) then
							l_pos := -1 + 25 -- skip if block
						end
				when 15 then -- if:
						if (l_uhp.item.uh_prev.ptr).is_void then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if (l_uhp.item.uh_prev.ptr).item.uh_walk /= l_nomark then
							if (l_uhp.item.uh_prev.ptr).item.uh_walk /= l_mark then
								l_uhp := l_uhp.item.uh_prev.ptr
							else
								l_pos := -1 + 18 -- goto _L___7
							end
						else
							l_pos := -1 + 18 -- goto _L___7
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 18 then -- else: | _L___7:
						if (l_uhp.item.uh_alt_next.ptr).is_void then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if (l_uhp.item.uh_alt_next.ptr).item.uh_walk /= l_nomark then
							if (l_uhp.item.uh_alt_next.ptr).item.uh_walk /= l_mark then
								l_uhp := l_uhp.item.uh_alt_next.ptr
							else
								l_pos := -1 + 21 -- goto _L___5
							end
						else
							l_pos := -1 + 21 -- goto _L___5
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else: | _L___5:
						if (l_uhp.item.uh_next.ptr).is_void then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if (l_uhp.item.uh_alt_prev.ptr).is_void then
							if (l_uhp.item.uh_next.ptr).item.uh_walk /= l_nomark then
								if (l_uhp.item.uh_next.ptr).item.uh_walk /= l_mark then
									if l_uhp.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead) then
										l_uhp.item.uh_walk := l_nomark
									end
									l_uhp := l_uhp.item.uh_next.ptr
								else
									l_pos := -1 + 24 -- goto _L___3
								end
							else
								l_pos := -1 + 24 -- goto _L___3
							end
						else
							l_pos := -1 + 24 -- goto _L___3
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L___3:
						l_uhp.item.uh_walk := l_nomark
						if not (l_uhp.item.uh_alt_prev.ptr).is_void then
							l_uhp := l_uhp.item.uh_alt_prev.ptr
						else
							l_uhp := l_uhp.item.uh_next.ptr
						end
				when 25 then -- if done | if done | if done
						l_pos := -1 + 3 -- back to loop condition
				when 26 then -- loop done
						l_break := False
						if not l_uhp.is_void then
							l_break := True
						end
						if not (l_return or l_break) then
							if a_absolute.to_boolean then
								(create {P_MISC2_STATIC}).emsgn (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E830: Undo number %%ld not found")))), a_step).do_nothing
								l_return := True
							end
							if not l_return and then (l_closest = l_closest_start) then
								if a_step < 0 then
									(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Already at oldest change"))))).do_nothing
								else
									(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Already at newest change"))))).do_nothing
								end
								l_return := True
							end
							if not l_return then
								l_target := l_closest_seq
								l_dosec := 0
								l_dofile := 0
								if a_step < 0 then
									l_above := 1
								end
								l_round := l_round + 1
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 27 then -- loop done
					if not l_return then
						l_break := False
						if not l_uhp.is_void then
							from
							until
								not (not (l_break) and then (not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean))
							loop
								l_break := False;
								(create {P_MISC1_STATIC}).change_warning (0)
								l_uhp := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead
								if l_uhp.is_void then
									l_uhp := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead
								else
									l_uhp := l_uhp.item.uh_next.ptr
								end
								if l_uhp.is_void then
									l_break := True
								elseif l_uhp.item.uh_walk /= l_mark then
									l_break := True
								elseif l_uhp.item.uh_seq = l_target then
									if not l_above.to_boolean then
										l_break := True
									end
								end
								if not (l_return or l_break) then
									(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead := l_uhp
									u_undoredo (1)
									l_uhp.item.uh_walk := l_nomark
								end
							end
							l_break := False
							from
							until
								not (not (l_return or l_break) and then (not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean))
							loop
								l_break := False;
								(create {P_MISC1_STATIC}).change_warning (0)
								l_uhp := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead
								if l_uhp.is_void then
									l_break := True
								end
								if not (l_return or l_break) then
									from
									until
										(l_break)
									loop
										l_break := False
										if not (l_uhp.item.uh_alt_prev.ptr).is_void then
											if (l_uhp.item.uh_alt_prev.ptr).item.uh_walk /= l_mark then
												l_break := True
											end
										else
											l_break := True
										end
										if not (l_return or l_break) then
											l_uhp := l_uhp.item.uh_alt_prev.ptr
										end
									end
									l_break := False
									l_last := l_uhp
									from
									until
										(l_break)
									loop
										l_break := False
										if not (l_last.item.uh_alt_next.ptr).is_void then
											if (l_last.item.uh_alt_next.ptr).item.uh_walk /= l_mark then
												l_break := True
											end
										else
											l_break := True
										end
										if not (l_return or l_break) then
											l_last := l_last.item.uh_alt_next.ptr
										end
									end
									l_break := False
									if not l_last.is_equal (l_uhp) then
										from
										until
											(l_uhp.item.uh_alt_prev.ptr).is_void
										loop
											l_uhp := l_uhp.item.uh_alt_prev.ptr
										end
										if not (l_last.item.uh_alt_next.ptr).is_void then
											(l_last.item.uh_alt_next.ptr).item.uh_alt_prev.ptr := l_last.item.uh_alt_prev.ptr
										end
										(l_last.item.uh_alt_prev.ptr).item.uh_alt_next.ptr := l_last.item.uh_alt_next.ptr
										l_last.item.uh_alt_prev.ptr := create {CE_CLASS_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
										l_last.item.uh_alt_next.ptr := l_uhp
										l_uhp.item.uh_alt_prev.ptr := l_last
										if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_oldhead).is_equal (l_uhp) then
											(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_oldhead := l_last
										end
										l_uhp := l_last
										if not (l_uhp.item.uh_next.ptr).is_void then
											(l_uhp.item.uh_next.ptr).item.uh_prev.ptr := l_uhp
										end
									end
									(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead := l_uhp
									if l_uhp.item.uh_walk /= l_mark then
										l_break := True
									end
								end
								if not (l_return or l_break) and then (l_uhp.item.uh_seq = l_target) then
									if l_above.to_boolean then
										(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_seq_cur := l_target - 1
										l_break := True
									end
								end
								if not (l_return or l_break) then
									u_undoredo (0)
									if (l_uhp.item.uh_prev.ptr).is_void then
										(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead := l_uhp
									end
									(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead := l_uhp.item.uh_prev.ptr
									l_did_undo := 0
									if l_uhp.item.uh_seq = l_target then
										l_break := True
									end
								end
								if not (l_return or l_break) then
									l_uhp := l_uhp.item.uh_prev.ptr
									if l_uhp.is_void then
										l_tmp___10 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_intern2.item)));
										(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___10), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("undo_time()"))).do_nothing
										l_break := True
									elseif l_uhp.item.uh_walk /= l_mark then
										l_tmp___10 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_intern2.item)));
										(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___10), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("undo_time()"))).do_nothing
										l_break := True
									end
								end
							end
							l_break := False
						end
						u_undo_end (l_did_undo, a_absolute)
					end
				when 28 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	u_undoredo (a_undo: INTEGER_32)
		local
			l_newarray: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_oldsize: INTEGER_32
			l_newsize: INTEGER_32
			l_top: INTEGER_32
			l_bot: INTEGER_32
			l_lnum: INTEGER_32
			l_newlnum: INTEGER_32
			l_i___0: INTEGER_32
			l_uep: CE_POINTER [PD_U_ENTRY]
			l_nuep: CE_POINTER [PD_U_ENTRY]
			l_newlist: CE_POINTER [PD_U_ENTRY]
			l_old_flags: INTEGER_32
			l_new_flags: INTEGER_32
			l_namedm: CE_ARRAY [PD_POS_T]
			l_visualinfo: PD_VISUALINFO_T
			l_empty_buffer: INTEGER_32
			l_curhead: CE_POINTER [PD_U_HEADER]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_namedm.make (<<26>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_newarray := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_newlnum := 2_147_483_647
					l_newlist := create {CE_CLASS_POINTER [PD_U_ENTRY]}.make_shared (default_pointer)
					l_curhead := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead;
					(create {P_FILEIO_STATIC}).block_autocmds
					l_old_flags := l_curhead.item.uh_flags
					if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changed).to_boolean then
						l_tmp := 1
					else
						l_tmp := 0
					end
					if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_and (1)).to_boolean then
						l_tmp___0 := 2
					else
						l_tmp___0 := 0
					end
					l_new_flags := l_tmp + l_tmp___0;
					(create {P_MARK_STATIC}).setpcmark
					memmove (create {CE_VOID_POINTER}.make_cast (l_namedm), create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_namedm)), (create {PD_POS_T}.make).structure_size.to_natural_32 * {NATURAL_32} 26).do_nothing
					l_visualinfo := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual).twin;
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count;
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.col := 0;
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.lnum := (0).to_integer_32;
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.col := 0
					l_uep := l_curhead.item.uh_entry
				when 1 then -- loop condition:
					if not (not (l_return or l_break) and then (not l_uep.is_void)) then
						l_pos := -1 + 18 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_top := l_uep.item.ue_top
						l_bot := l_uep.item.ue_bot
						if l_bot = 0 then
							l_bot := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count + 1
						end
						if l_top > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							(create {P_FILEIO_STATIC}).unblock_autocmds
							l_tmp___1 := gettext (ce_string ("E438: u_undo: line numbers wrong"));
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing;
							(create {P_MISC1_STATIC}).changed
							l_return := True
						elseif l_top >= l_bot then
							(create {P_FILEIO_STATIC}).unblock_autocmds
							l_tmp___1 := gettext (ce_string ("E438: u_undo: line numbers wrong"));
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing;
							(create {P_MISC1_STATIC}).changed
							l_return := True
						elseif l_bot > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count + 1 then
							(create {P_FILEIO_STATIC}).unblock_autocmds
							l_tmp___1 := gettext (ce_string ("E438: u_undo: line numbers wrong"));
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing;
							(create {P_MISC1_STATIC}).changed
							l_return := True
						end
						if l_return then
							l_pos := -1 + 17 -- skip if block
						end
				when 3 then -- if:
						l_oldsize := (l_bot - l_top) - 1
						l_newsize := l_uep.item.ue_size
						if not (l_top < l_newlnum) then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						l_lnum := l_curhead.item.uh_cursor.lnum
						if not (l_lnum >= l_top) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_lnum <= (l_top + l_newsize) + 1 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_curhead.item.uh_cursor).twin
							l_newlnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1
						else
							l_pos := -1 + 7 -- goto _L___1
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else: | _L___1:
						l_i___0 := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if l_i___0 < l_newsize then
								if not (l_i___0 < l_oldsize) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_uep.item.ue_array[l_i___0]), create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MEMLINE_STATIC}).ml_get ((l_top + 1) + l_i___0))))) /= 0 then
									l_break := True
								end
							end
							if not (l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						if l_i___0 /= l_newsize then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_newlnum = 2_147_483_647 then
							if (l_uep.item.ue_next).is_void then
								l_newlnum := l_top;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_newlnum + 1
							else
								l_pos := -1 + 10 -- goto _L___0
							end
						else
							l_pos := -1 + 10 -- goto _L___0
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___0:
						if l_i___0 < l_newsize then
							l_newlnum := l_top + l_i___0;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_newlnum + 1
						end
				when 11 then -- if done | if done
						l_empty_buffer := 0
						if l_oldsize > 0 then
							l_newarray := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (((create {P_MISC2_STATIC}).lalloc (({PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32 * l_oldsize.to_natural_32, 0)))
							if l_newarray.is_void then
								(create {P_MISC2_STATIC}).do_outofmem_msg (({PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32 * l_oldsize.to_natural_32)
								from
								until
									l_uep.is_void
								loop
									l_nuep := l_uep.item.ue_next
									l_uep.item.u_freeentry (l_uep.item.ue_size)
									l_uep := l_nuep
								end
								l_break := True
							end
							if not (l_return or l_break) then
								l_lnum := l_bot - 1
								l_i___0 := l_oldsize
								from
								until
									(l_break)
								loop
									l_break := False
									l_i___0 := l_i___0 - 1
									if not (l_i___0 >= 0) then
										l_break := True
									end
									if not (l_break) then
										l_tmp___5 := u_save_line (l_lnum)
										l_newarray[l_i___0] := l_tmp___5
										if l_tmp___5.is_void then
											(create {P_MISC2_STATIC}).do_outofmem_msg ((0).to_natural_32)
										end
										if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count = 1 then
											l_empty_buffer := 1
										end
										(create {P_MEMLINE_STATIC}).ml_delete (l_lnum, 0).do_nothing
										l_lnum := l_lnum - 1
									end
								end
								l_break := False
							end
						else
							l_newarray := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
						end
						if (l_return or l_break) then
							l_pos := -1 + 17 -- skip if block
						end
				when 12 then -- if:
						if l_newsize.to_boolean then
							l_lnum := l_top
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_newsize)
							loop
								if l_empty_buffer.to_boolean then
									if l_lnum = 0 then
										(create {P_MEMLINE_STATIC}).ml_replace ((1).to_integer_32, l_uep.item.ue_array[l_i___0], 1).do_nothing
									else
										(create {P_MEMLINE_STATIC}).ml_append (l_lnum, l_uep.item.ue_array[l_i___0], 0, 0).do_nothing
									end
								else
									(create {P_MEMLINE_STATIC}).ml_append (l_lnum, l_uep.item.ue_array[l_i___0], 0, 0).do_nothing
								end
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_uep.item.ue_array[l_i___0]))
								l_i___0 := l_i___0 + 1
								l_lnum := l_lnum + 1
							end
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_uep.item.ue_array))
						end
						if l_oldsize /= l_newsize then
							(create {P_MARK_STATIC}).mark_adjust (l_top + 1, l_top + l_oldsize, 2_147_483_647, l_newsize - l_oldsize)
							if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum > l_top + l_oldsize then
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum + (l_newsize - l_oldsize)
							end
							if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.lnum > l_top + l_oldsize then
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.lnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.lnum + (l_newsize - l_oldsize)
							end
						end
						(create {P_MISC1_STATIC}).changed_lines (l_top + 1, 0, l_bot, l_newsize - l_oldsize)
						if l_top + 1 < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum := l_top + 1
						end
						if l_newsize /= 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_top + 1 > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.lnum then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.lnum := l_top + 1
						else
							l_pos := -1 + 15 -- goto _L___2
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L___2:
						if l_top + l_newsize > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.lnum then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.lnum := l_top + l_newsize
						end
				when 16 then
						u_newcount.item := u_newcount.item + l_newsize
						u_oldcount.item := u_oldcount.item + l_oldsize
						l_uep.item.ue_size := l_oldsize
						l_uep.item.ue_array := l_newarray
						l_uep.item.ue_bot := (l_top + l_newsize) + 1
						l_nuep := l_uep.item.ue_next
						l_uep.item.ue_next := l_newlist
						l_newlist := l_uep
						l_uep := l_nuep
				when 17 then -- if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 18 then -- loop done
					if not l_return then
						l_break := False
						l_curhead.item.uh_entry := l_newlist
						l_curhead.item.uh_flags := l_new_flags
						if ((l_old_flags).bit_and (2)).to_boolean then
							if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count = 1 then
								if (((create {P_MEMLINE_STATIC}).ml_get ((1).to_integer_32)).item).to_integer_32 = 0 then
									(create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_or ((1))
								end
							end
						end
						if ((l_old_flags).bit_and (1)).to_boolean then
							(create {P_MISC1_STATIC}).changed
						elseif not ((create {P_NETBEANS_STATIC}).isNetbeansModified ((create {P_GLOBALS_STATIC}).curbuf.item)).to_boolean then
							((create {P_GLOBALS_STATIC}).curbuf.item).item.unchanged (0)
						end
						l_i___0 := 0
						from
						until
							not (l_i___0 < 26)
						loop
							if l_curhead.item.uh_namedm[l_i___0].lnum /= 0 then
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_namedm[l_i___0] := (l_curhead.item.uh_namedm[l_i___0]).twin
								l_curhead.item.uh_namedm[l_i___0] := (l_namedm[l_i___0]).twin
							end
							l_i___0 := l_i___0 + 1
						end
						if l_curhead.item.uh_visual.vi_start.lnum /= 0 then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual := (l_curhead.item.uh_visual).twin
							l_curhead.item.uh_visual := l_visualinfo.twin
						end
						if l_curhead.item.uh_cursor.lnum + 1 = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > 1 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1
							end
						end
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum <= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							if l_curhead.item.uh_cursor.lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_curhead.item.uh_cursor.col
								if ((create {P_MISC2_STATIC}).virtual_active).to_boolean then
									if l_curhead.item.uh_cursor_vcol >= 0 then
										(create {P_MISC2_STATIC}).coladvance ((l_curhead.item.uh_cursor_vcol).to_integer_32).do_nothing
									else
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0
									end
								else
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0
								end
							else
								(create {P_EDIT_STATIC}).beginline (6)
							end
						else
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0
						end
						(create {P_MISC2_STATIC}).check_cursor;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_seq_cur := l_curhead.item.uh_seq
						if a_undo.to_boolean then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_seq_cur := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_seq_cur) - 1
						end
						if l_curhead.item.uh_save_nr /= 0 then
							if a_undo.to_boolean then
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_save_nr_cur := l_curhead.item.uh_save_nr - 1
							else
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_save_nr_cur := l_curhead.item.uh_save_nr
							end
						end
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_time_cur := l_curhead.item.uh_time;
						(create {P_FILEIO_STATIC}).unblock_autocmds
					end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	u_undo_end (a_did_undo, a_absolute: INTEGER_32)
		local
			l_did_undo: INTEGER_32
			l_msgstr: CE_POINTER [INTEGER_8]
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_msgbuf: CE_ARRAY [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_msgbuf.make (<<80>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_did_undo := a_did_undo
					if (((create {P_OPTION_STATIC}).fdo_flags.item.item).bit_and ({NATURAL_32} 512)).to_boolean then
						if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
							(create {P_FOLD_STATIC}).foldOpenCursor
						end
					end
					if ((create {P_GLOBALS_STATIC}).global_busy.item).to_boolean then
						l_return := True
					elseif not ((create {P_SCREEN_STATIC}).messaging).to_boolean then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_and (1)).to_boolean then
							u_newcount.item := u_newcount.item - 1
						end
						u_oldcount.item := u_oldcount.item - u_newcount.item
						if u_oldcount.item = -1 then
							l_msgstr := ce_string ("more line")
						elseif u_oldcount.item < 0 then
							l_msgstr := ce_string ("more lines")
						elseif u_oldcount.item = 1 then
							l_msgstr := ce_string ("line less")
						elseif u_oldcount.item > 1 then
							l_msgstr := ce_string ("fewer lines")
						else
							u_oldcount.item := u_newcount.item
							if u_newcount.item = 1 then
								l_msgstr := ce_string ("change")
							else
								l_msgstr := ce_string ("changes")
							end
						end
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead).is_void then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if not (a_absolute.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead).item.uh_next.ptr).is_void then
							l_uhp := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead).item.uh_next.ptr
							l_did_undo := 0
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if l_did_undo.to_boolean then
							l_uhp := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead
						else
							l_uhp := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead).item.uh_next.ptr
						end
				when 6 then -- if done | if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_uhp := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead
				when 8 then
						if l_uhp.is_void then
							l_msgbuf[0] := (('%/0/').code).to_natural_8
						else
							u_add_time (l_msgbuf, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (80).to_natural_32), l_uhp.item.uh_time)
						end
						if l_uhp.is_void then
							l_tmp___0 := 0
						else
							l_tmp___0 := l_uhp.item.uh_seq
						end
						if l_did_undo.to_boolean then
							l_tmp___3 := (gettext (ce_string ("before")))
						else
							l_tmp___3 := (gettext (ce_string ("after")))
						end
						l_tmp___4 := gettext (l_msgstr)
						if u_oldcount.item < 0 then
							l_tmp___5 := -u_oldcount.item
						else
							l_tmp___5 := u_oldcount.item
						end
						(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%%ld %%s; %%s #%%ld  %%s")))), l_tmp___5, l_tmp___4, l_tmp___3, l_tmp___0, l_msgbuf]).do_nothing
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	u_sync (a_force: INTEGER_32)
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_synced).to_boolean then
				l_return := True
			elseif not a_force.to_boolean then
				if (create {P_GLOBALS_STATIC}).no_u_sync.item > 0 then
					l_return := True
				end
			end
			if not l_return then
				if ((create {P_MBYTE_STATIC}).im_is_preediting).to_boolean then
					l_return := True
				end
			end
			if not l_return then
				if (create {P_OPTION_STATIC}).p_ul.item.item < 0 then
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_synced := 1
				else
					u_getbot;
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead := create {CE_CLASS_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
				end
			end
		end

	ex_undolist (a_eap: CE_POINTER [PD_EXARG])
		local
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_mark: INTEGER_32
			l_nomark: INTEGER_32
			l_changes: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_changes := 1
					lastmark.item := lastmark.item + 1
					l_mark := lastmark.item
					lastmark.item := lastmark.item + 1
					l_nomark := lastmark.item
					l_ga.item.ga_init2 (({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 20)
					l_uhp := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_oldhead
				when 1 then -- loop condition:
					if not (not (l_return or l_break) and then (not l_uhp.is_void)) then
						l_pos := -1 + 14 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if (l_uhp.item.uh_prev.ptr).is_void then
							if l_uhp.item.uh_walk /= l_nomark then
								if l_uhp.item.uh_walk /= l_mark then
									if (l_ga.item.ga_grow (1)) = 0 then
										l_break := True
									end
									if not (l_return or l_break) then
										(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, ce_string ("%%6ld %%7ld  "), l_uhp.item.uh_seq, l_changes]).do_nothing
										l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item))
										u_add_time ((create {P_GLOBALS_STATIC}).IObuff.item + (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item))).to_integer_32, {NATURAL_32} 1_025 - l_tmp___0, l_uhp.item.uh_time)
										if l_uhp.item.uh_save_nr > 0 then
											from
											until
												(l_break)
											loop
												l_break := False
												if not ((strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item))) < {NATURAL_32} 32) then
													l_break := True
												end
												if not (l_break) then
													strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), ce_string (" ")).do_nothing
												end
											end
											l_break := False;
											(create {P_MESSAGE_STATIC}).vim_snprintf_add ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, ce_string ("  %%3ld"), l_uhp.item.uh_save_nr]).do_nothing
										end
										l_tmp___3 := l_ga.item.ga_len
										l_ga.item.ga_len := (l_ga.item.ga_len) + 1
										create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data)[l_tmp___3] := (create {P_MISC2_STATIC}).vim_strsave ((create {P_GLOBALS_STATIC}).IObuff.item)
									end
								end
							end
						end
						if (l_return or l_break) then
							l_pos := -1 + 13 -- skip if block
						end
				when 3 then -- if:
						l_uhp.item.uh_walk := l_mark
						if (l_uhp.item.uh_prev.ptr).is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (l_uhp.item.uh_prev.ptr).item.uh_walk /= l_nomark then
							if (l_uhp.item.uh_prev.ptr).item.uh_walk /= l_mark then
								l_uhp := l_uhp.item.uh_prev.ptr
								l_changes := l_changes + 1
							else
								l_pos := -1 + 6 -- goto _L___5
							end
						else
							l_pos := -1 + 6 -- goto _L___5
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else: | _L___5:
						if (l_uhp.item.uh_alt_next.ptr).is_void then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (l_uhp.item.uh_alt_next.ptr).item.uh_walk /= l_nomark then
							if (l_uhp.item.uh_alt_next.ptr).item.uh_walk /= l_mark then
								l_uhp := l_uhp.item.uh_alt_next.ptr
							else
								l_pos := -1 + 9 -- goto _L___3
							end
						else
							l_pos := -1 + 9 -- goto _L___3
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else: | _L___3:
						if (l_uhp.item.uh_next.ptr).is_void then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if (l_uhp.item.uh_alt_prev.ptr).is_void then
							if (l_uhp.item.uh_next.ptr).item.uh_walk /= l_nomark then
								if (l_uhp.item.uh_next.ptr).item.uh_walk /= l_mark then
									l_uhp := l_uhp.item.uh_next.ptr
									l_changes := l_changes - 1
								else
									l_pos := -1 + 12 -- goto _L___1
								end
							else
								l_pos := -1 + 12 -- goto _L___1
							end
						else
							l_pos := -1 + 12 -- goto _L___1
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___1:
						l_uhp.item.uh_walk := l_nomark
						if not (l_uhp.item.uh_alt_prev.ptr).is_void then
							l_uhp := l_uhp.item.uh_alt_prev.ptr
						else
							l_uhp := l_uhp.item.uh_next.ptr
							l_changes := l_changes - 1
						end
				when 13 then -- if done | if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 14 then -- loop done
					l_break := False
					if l_ga.item.ga_len = 0 then
						(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Nothing to undo"))))).do_nothing
					else
						(create {P_MISC2_STATIC}).sort_strings (create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data), l_ga.item.ga_len);
						(create {P_MESSAGE_STATIC}).msg_start;
						(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("number changes  time            saved")))), (create {P_GLOBALS_STATIC}).highlight_attr.item[14])
						l_i___0 := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if l_i___0 < l_ga.item.ga_len then
								if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
								if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
									l_break := True
								end
							end
							if not (l_return or l_break) then
								(create {P_MESSAGE_STATIC}).msg_puts (create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data)[l_i___0])
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False;
						(create {P_MESSAGE_STATIC}).msg_end.do_nothing
						l_ga.item.ga_clear_strings
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	u_add_time (a_buf___6: CE_POINTER [NATURAL_8]; a_buflen: NATURAL_32; a_tt: INTEGER_32)
		local
			l_tt: CE_ARRAY [INTEGER_32]
			l_curtime: CE_POINTER [SD_TM]
			l_tmp: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_tt.make (<<1>>)

			l_tt.item := a_tt
			if (time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))) - l_tt.item >= 100 then
				l_curtime := localtime (l_tt)
				strftime (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), a_buflen, ce_string ("%%H:%%M:%%S"), l_curtime).do_nothing
			else
				l_tmp := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer));
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), a_buflen, (gettext (ce_string ("%%ld seconds ago"))), l_tmp - l_tt.item]).do_nothing
			end
		end

	ex_undojoin (a_eap: CE_POINTER [PD_EXARG])
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead).is_void then
				l_return := True
			end
			if not l_return and then (not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead).is_void) then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E790: undojoin is not allowed after undo"))))).do_nothing
				l_return := True
			end
			if not l_return and then (not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_synced).to_boolean) then
				l_return := True
			end
			if not l_return then
				if (create {P_OPTION_STATIC}).p_ul.item.item < 0 then
					l_return := True
				else
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead;
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_synced := 0
				end
			end
			if not l_return then
			end
		end

	u_find_first_changed
		local
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_uep: CE_POINTER [PD_U_ENTRY]
			l_lnum: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_uhp := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead
			if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead).is_void then
				l_return := True
			elseif l_uhp.is_void then
				l_return := True
			end
			if not l_return then
				l_uep := l_uhp.item.uh_entry
				if l_uep.item.ue_top /= 0 then
					l_return := True
				elseif l_uep.item.ue_bot /= 0 then
					l_return := True
				end
			end
			if not l_return then
				l_lnum := (1).to_integer_32
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if l_lnum < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
						if not (l_lnum <= l_uep.item.ue_size) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_return or l_break) then
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_get_buf (l_lnum, 0))), create {CE_INTEGER_8_POINTER}.make_cast (l_uep.item.ue_array[(l_lnum - 1)]))) /= 0 then
							l_uhp.item.uh_cursor.lnum := (0).to_integer_32
							l_uhp.item.uh_cursor.col := 0
							l_uhp.item.uh_cursor.coladd := 0
							l_uhp.item.uh_cursor.lnum := l_lnum
							l_return := True
						end
						if not l_return then
							l_lnum := l_lnum + 1
						end
					end
				end
			end
			if not l_return then
				l_break := False
				if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count /= l_uep.item.ue_size then
					l_uhp.item.uh_cursor.lnum := (0).to_integer_32
					l_uhp.item.uh_cursor.col := 0
					l_uhp.item.uh_cursor.coladd := 0
					l_uhp.item.uh_cursor.lnum := l_lnum
				end
			end
		end

	u_get_headentry: CE_POINTER [PD_U_ENTRY]
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead).is_void then
				l_tmp := gettext (ce_string ("E439: undo list corrupt"));
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
				Result := (create {CE_CLASS_POINTER [PD_U_ENTRY]}.make_shared (default_pointer))
				l_return := True
			elseif (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead).item.uh_entry).is_void then
				l_tmp := gettext (ce_string ("E439: undo list corrupt"));
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
				Result := (create {CE_CLASS_POINTER [PD_U_ENTRY]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead).item.uh_entry)
			end
		end

	u_getbot
		local
			l_uep: CE_POINTER [PD_U_ENTRY]
			l_extra: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_uep := u_get_headentry
			if l_uep.is_void then
				l_return := True
			end
			if not l_return then
				l_uep := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead).item.uh_getbot_entry
				if not l_uep.is_void then
					l_extra := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count - l_uep.item.ue_lcount
					l_uep.item.ue_bot := ((l_uep.item.ue_top + l_uep.item.ue_size) + 1) + l_extra
					if l_uep.item.ue_bot < 1 then
						l_tmp := gettext (ce_string ("E440: undo line missing"));
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
						l_uep.item.ue_bot := l_uep.item.ue_top + 1
					elseif l_uep.item.ue_bot > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
						l_tmp := gettext (ce_string ("E440: undo line missing"));
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
						l_uep.item.ue_bot := l_uep.item.ue_top + 1
					end
					((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead).item.uh_getbot_entry := create {CE_CLASS_POINTER [PD_U_ENTRY]}.make_shared (default_pointer)
				end
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_synced := 1
			end
		end

	u_saveline (a_lnum: INTEGER_32)
		local
			l_tmp: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			if a_lnum = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_line_lnum then
				l_return := True
			end
			if not l_return then
				if a_lnum < 1 then
					l_return := True
				elseif a_lnum > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
					l_return := True
				end
			end
			if not l_return then
				u_clearline;
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_line_lnum := a_lnum
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = a_lnum then
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_line_colnr := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
				else
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_line_colnr := 0
				end
				l_tmp := u_save_line (a_lnum);
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_line_ptr := l_tmp
				if l_tmp.is_void then
					(create {P_MISC2_STATIC}).do_outofmem_msg ((0).to_natural_32)
				end
			end
		end

	u_clearline
		do
			if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_line_ptr).is_void then
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_line_ptr));
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_line_ptr := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_line_lnum := (0).to_integer_32
			end
		end

	u_save_line (a_lnum: INTEGER_32): CE_POINTER [NATURAL_8]
		do
			Result := ((create {P_MISC2_STATIC}).vim_strsave (((create {P_MEMLINE_STATIC}).ml_get (a_lnum))))
		end

	curbufIsChanged: INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (((create {P_GLOBALS_STATIC}).curbuf.item).item.bt_dontwrite).to_boolean then
				l_tmp___1 := 0
			elseif ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changed).to_boolean then
				l_tmp___1 := 1
			elseif (((create {P_GLOBALS_STATIC}).curbuf.item).item.file_ff_differs).to_boolean then
				l_tmp___1 := 1
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	u_eval_tree (a_first_uhp: CE_POINTER [PD_U_HEADER]; a_list: CE_POINTER [PD_LISTVAR_S])
		local
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_dict: CE_POINTER [PD_DICTVAR_S]
			l_alt_list: CE_POINTER [PD_LISTVAR_S]
			l_return: BOOLEAN
		do
			l_uhp := a_first_uhp
			from
			until
				not (not (l_return) and then (not l_uhp.is_void))
			loop
				l_dict := (create {P_EVAL_STATIC}).dict_alloc
				if l_dict.is_void then
					l_return := True
				end
				if not l_return then
					(create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("seq"), l_uhp.item.uh_seq, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)).do_nothing;
					(create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("time"), l_uhp.item.uh_time, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)).do_nothing
					if l_uhp.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_newhead) then
						(create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("newhead"), 1, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)).do_nothing
					end
					if l_uhp.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_u_curhead) then
						(create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("curhead"), 1, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)).do_nothing
					end
					if l_uhp.item.uh_save_nr > 0 then
						(create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("save"), l_uhp.item.uh_save_nr, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)).do_nothing
					end
					if not (l_uhp.item.uh_alt_next.ptr).is_void then
						l_alt_list := ((create {P_EVAL_STATIC}).list_alloc)
						if not l_alt_list.is_void then
							u_eval_tree (l_uhp.item.uh_alt_next.ptr, l_alt_list);
							(create {P_EVAL_STATIC}).dict_add_list (l_dict, ce_string ("alt"), l_alt_list).do_nothing
						end
					end
					(create {P_EVAL_STATIC}).list_append_dict (a_list, l_dict).do_nothing
					l_uhp := l_uhp.item.uh_prev.ptr
				end
			end
			if not l_return then
			end
		end

feature {ANY} -- routine addresses

	ex_undolist_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_undolist)
		end

	ex_undojoin_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_undojoin)
		end

end
