class
	PD_ACO_SAVE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_FILE_BUFFER]} save_curbuf.make
			create {CE_CLASS_POINTER [PD_WINDOW_S]} save_curwin.make
			create {CE_CLASS_POINTER [PD_WINDOW_S]} new_curwin.make
			create {CE_CLASS_POINTER [PD_FILE_BUFFER]} new_curbuf.make
			create {CE_NATURAL_8_POINTER} globaldir.make
		end

feature {ANY} -- fields

	save_curbuf: CE_POINTER [PD_FILE_BUFFER] assign set_save_curbuf

	use_aucmd_win: INTEGER_32 assign set_use_aucmd_win

	save_curwin: CE_POINTER [PD_WINDOW_S] assign set_save_curwin

	new_curwin: CE_POINTER [PD_WINDOW_S] assign set_new_curwin

	new_curbuf: CE_POINTER [PD_FILE_BUFFER] assign set_new_curbuf

	globaldir: CE_POINTER [NATURAL_8] assign set_globaldir

feature {ANY} -- field setters

	set_save_curbuf (a_save_curbuf: CE_POINTER [PD_FILE_BUFFER])
		do
			save_curbuf := a_save_curbuf
			update_memory_field ("save_curbuf")
		end

	set_use_aucmd_win (a_use_aucmd_win: INTEGER_32)
		do
			use_aucmd_win := a_use_aucmd_win
			update_memory_field ("use_aucmd_win")
		end

	set_save_curwin (a_save_curwin: CE_POINTER [PD_WINDOW_S])
		do
			save_curwin := a_save_curwin
			update_memory_field ("save_curwin")
		end

	set_new_curwin (a_new_curwin: CE_POINTER [PD_WINDOW_S])
		do
			new_curwin := a_new_curwin
			update_memory_field ("new_curwin")
		end

	set_new_curbuf (a_new_curbuf: CE_POINTER [PD_FILE_BUFFER])
		do
			new_curbuf := a_new_curbuf
			update_memory_field ("new_curbuf")
		end

	set_globaldir (a_globaldir: CE_POINTER [NATURAL_8])
		do
			globaldir := a_globaldir
			update_memory_field ("globaldir")
		end

feature {PD_ACO_SAVE_T} -- private attributes

	aucmd_win_used: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	aucmd_prepbuf (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_win: CE_POINTER [PD_WINDOW_S]
			l_save_ea: INTEGER_32
			l_break: BOOLEAN
		do
			if a_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
				l_win := (create {P_GLOBALS_STATIC}).curwin.item
			else
				l_win := (create {P_GLOBALS_STATIC}).firstwin.item
				from
				until
					not (not (l_break) and then (not l_win.is_void))
				loop
					l_break := False
					if (l_win.item.w_buffer).is_equal (a_buf___6) then
						l_break := True
					end
					if not (l_break) then
						l_win := l_win.item.w_next
					end
				end
				l_break := False
			end
			if l_win.is_void then
				if ((create {P_GLOBALS_STATIC}).aucmd_win.item).is_void then
					win_alloc_aucmd_win
					update_class_fields -- Current might have been changed; synchronize
					if ((create {P_GLOBALS_STATIC}).aucmd_win.item).is_void then
						l_win := (create {P_GLOBALS_STATIC}).curwin.item
					end
				end
			end
			if l_win.is_void then
				if aucmd_win_used.item.to_boolean then
					l_win := (create {P_GLOBALS_STATIC}).curwin.item
				end
			end
			Current.save_curwin := (create {P_GLOBALS_STATIC}).curwin.item
			update_class_fields -- Current might have been changed; synchronize
			Current.save_curbuf := (create {P_GLOBALS_STATIC}).curbuf.item
			update_class_fields -- Current might have been changed; synchronize
			if not l_win.is_void then
				Current.use_aucmd_win := 0
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).curwin.item := l_win
				update_class_fields -- Current might have been changed; synchronize
			else
				Current.use_aucmd_win := 1
				update_class_fields -- Current might have been changed; synchronize
				aucmd_win_used.item := 1;
				(create {P_GLOBALS_STATIC}).aucmd_win.item.item.w_buffer := a_buf___6
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).aucmd_win.item.item.w_s := create {CE_CLASS_POINTER [PD_SYNBLOCK_T]}.make_shared (a_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_s"))
				update_class_fields -- Current might have been changed; synchronize
				a_buf___6.item.b_nwindows := (a_buf___6.item.b_nwindows) + 1
				update_class_fields; -- Current might have been changed; synchronize
				((create {P_GLOBALS_STATIC}).aucmd_win.item).item.win_init_empty
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).aucmd_win.item.item.w_localdir))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).aucmd_win.item.item.w_localdir := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).aucmd_win.item.item.w_localdir := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				Current.globaldir := (create {P_GLOBALS_STATIC}).globaldir.item
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).globaldir.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_FILEIO_STATIC}).block_autocmds
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_WINDOW_STATIC}).make_snapshot (1)
				update_class_fields -- Current might have been changed; synchronize
				l_save_ea := (create {P_OPTION_STATIC}).p_ea.item.item;
				(create {P_OPTION_STATIC}).p_ea.item.item := 0
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_WINDOW_STATIC}).win_split_ins (0, 4, (create {P_GLOBALS_STATIC}).aucmd_win.item, 0).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_WINDOW_STATIC}).win_comp_pos.do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_OPTION_STATIC}).p_ea.item.item := l_save_ea
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_FILEIO_STATIC}).unblock_autocmds
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).curwin.item := (create {P_GLOBALS_STATIC}).aucmd_win.item
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_GLOBALS_STATIC}).curbuf.item := a_buf___6
			update_class_fields -- Current might have been changed; synchronize
			Current.new_curwin := (create {P_GLOBALS_STATIC}).curwin.item
			update_class_fields -- Current might have been changed; synchronize
			Current.new_curbuf := (create {P_GLOBALS_STATIC}).curbuf.item
			update_class_fields -- Current might have been changed; synchronize
		end

	aucmd_restbuf
		local
			l_dummy___0: CE_ARRAY [INTEGER_32]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_dummy___0.make (<<1>>)

			if use_aucmd_win.to_boolean then
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_nwindows := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_nwindows) - 1
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_FILEIO_STATIC}).block_autocmds
				update_class_fields -- Current might have been changed; synchronize
				if not ((create {P_GLOBALS_STATIC}).curwin.item).is_equal ((create {P_GLOBALS_STATIC}).aucmd_win.item) then
					l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
					from
					until
						not (not (l_return) and then (not l_tp.is_void))
					loop
						if l_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
							l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
						else
							l_wp___0 := l_tp.item.tp_firstwin
						end
						from
						until
							not (not (l_break) and then (not l_wp___0.is_void))
						loop
							l_break := False
							if l_wp___0.is_equal ((create {P_GLOBALS_STATIC}).aucmd_win.item) then
								if not l_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
									(create {P_WINDOW_STATIC}).goto_tabpage_tp (l_tp)
									update_class_fields -- Current might have been changed; synchronize
								end
								(create {P_WINDOW_STATIC}).win_goto ((create {P_GLOBALS_STATIC}).aucmd_win.item)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							if not (l_break) then
								l_wp___0 := l_wp___0.item.w_next
							end
						end
						l_break := False
						l_tp := l_tp.item.tp_next
					end
				end
				((create {P_GLOBALS_STATIC}).curwin.item).item.winframe_remove (l_dummy___0, create {CE_CLASS_POINTER [PD_TABPAGE_S]}.make_shared (default_pointer)).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				((create {P_GLOBALS_STATIC}).curwin.item).item.win_remove (create {CE_CLASS_POINTER [PD_TABPAGE_S]}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				aucmd_win_used.item := 0;
				(create {P_WINDOW_STATIC}).last_status (0)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_WINDOW_STATIC}).restore_snapshot (1, 0)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_WINDOW_STATIC}).win_comp_pos.do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_FILEIO_STATIC}).unblock_autocmds
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := (create {P_WINDOW_STATIC}).win_valid (save_curwin)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					(create {P_GLOBALS_STATIC}).curwin.item := save_curwin
					update_class_fields -- Current might have been changed; synchronize
				else
					(create {P_GLOBALS_STATIC}).curwin.item := (create {P_GLOBALS_STATIC}).firstwin.item
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared ((create {P_GLOBALS_STATIC}).aucmd_win.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_vars") + (create {PD_DICTVAR_S}.make).offset_of ("dv_hashtab"))).item.vars_clear
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared ((create {P_GLOBALS_STATIC}).aucmd_win.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_vars") + (create {PD_DICTVAR_S}.make).offset_of ("dv_hashtab"))).item.hash_init
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).globaldir.item))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).globaldir.item := globaldir
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).check_cursor
				update_class_fields -- Current might have been changed; synchronize
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := 0
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared ((create {P_GLOBALS_STATIC}).aucmd_win.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (0))).item.gui_mch_enable_scrollbar (0)
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared ((create {P_GLOBALS_STATIC}).aucmd_win.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (1))).item.gui_mch_enable_scrollbar (0)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GUI_STATIC}).gui_may_update_scrollbars
				update_class_fields -- Current might have been changed; synchronize
			else
				l_tmp___1 := (create {P_WINDOW_STATIC}).win_valid (save_curwin)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___1.to_boolean then
					if ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (new_curwin) then
						if not ((create {P_GLOBALS_STATIC}).curbuf.item).is_equal (new_curbuf) then
							l_tmp___0 := (create {P_BUFFER_STATIC}).buf_valid (new_curbuf)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___0.to_boolean then
								if not (new_curbuf.item.b_ml.ml_mfp).is_void then
									(create {P_GLOBALS_STATIC}).curbuf.item.item.b_nwindows := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_nwindows) - 1
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_GLOBALS_STATIC}).curbuf.item := new_curbuf
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer := (create {P_GLOBALS_STATIC}).curbuf.item
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_GLOBALS_STATIC}).curbuf.item.item.b_nwindows := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_nwindows) + 1
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
					end
					(create {P_GLOBALS_STATIC}).curwin.item := save_curwin
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

feature {PD_ACO_SAVE_T} -- private routines

	win_alloc_aucmd_win
		do
			(create {P_GLOBALS_STATIC}).aucmd_win.item := (create {P_WINDOW_STATIC}).win_alloc (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer), 1)
			if not ((create {P_GLOBALS_STATIC}).aucmd_win.item).is_void then
				((create {P_GLOBALS_STATIC}).aucmd_win.item).item.win_init_some ((create {P_GLOBALS_STATIC}).curwin.item);
				(create {P_GLOBALS_STATIC}).aucmd_win.item.item.w_onebuf_opt.wo_scb := 0;
				((create {P_GLOBALS_STATIC}).aucmd_win.item).item.new_frame
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			save_curbuf := a_other.save_curbuf
			use_aucmd_win := a_other.use_aucmd_win
			save_curwin := a_other.save_curwin
			new_curwin := a_other.new_curwin
			new_curbuf := a_other.new_curbuf
			globaldir := a_other.globaldir
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				save_curbuf.is_equal (a_other.save_curbuf) and
				use_aucmd_win = a_other.use_aucmd_win and
				save_curwin.is_equal (a_other.save_curwin) and
				new_curwin.is_equal (a_other.new_curwin) and
				new_curbuf.is_equal (a_other.new_curbuf) and
				globaldir.is_equal (a_other.globaldir)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("save_curbuf"),
					create {CE_STRUCTURE_FIELD}.make ("use_aucmd_win"),
					create {CE_STRUCTURE_FIELD}.make ("save_curwin"),
					create {CE_STRUCTURE_FIELD}.make ("new_curwin"),
					create {CE_STRUCTURE_FIELD}.make ("new_curbuf"),
					create {CE_STRUCTURE_FIELD}.make ("globaldir")
				>>)
			init_structure_info
		end

end
