class
	PD_AE_U

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	term: PD_TERM assign set_term

	cterm: PD_CTERM assign set_cterm

	gui: PD_GUI2 assign set_gui

feature {ANY} -- field setters

	set_term (a_term: PD_TERM)
		do
			term := a_term
			update_memory_field ("term")
		end

	set_cterm (a_cterm: PD_CTERM)
		do
			cterm := a_cterm
			update_memory_field ("cterm")
		end

	set_gui (a_gui: PD_GUI2)
		do
			gui := a_gui
			update_memory_field ("gui")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			term := a_other.term.twin
			cterm := a_other.cterm.twin
			gui := a_other.gui.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				term.is_equal (a_other.term) and
				cterm.is_equal (a_other.cterm) and
				gui.is_equal (a_other.gui)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("term"),
					create {CE_STRUCTURE_FIELD}.make ("cterm"),
					create {CE_STRUCTURE_FIELD}.make ("gui")
				>>)
			init_structure_info
		end

end
