class
	PD_ARGLIST

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create al_ga.make
		end

feature {ANY} -- fields

	al_ga: PD_GROWARRAY assign set_al_ga

	al_refcount: INTEGER_32 assign set_al_refcount

feature {ANY} -- field setters

	set_al_ga (a_al_ga: PD_GROWARRAY)
		do
			al_ga := a_al_ga
			update_memory_field ("al_ga")
		end

	set_al_refcount (a_al_refcount: INTEGER_32)
		do
			al_refcount := a_al_refcount
			update_memory_field ("al_refcount")
		end

feature {ANY} -- public routines

	alist_clear
		local
			l_break: BOOLEAN
		do
			from
			until
				(l_break)
			loop
				l_break := False
				al_ga.ga_len := (al_ga.ga_len) - 1
				update_class_fields -- Current might have been changed; synchronize
				if not (al_ga.ga_len >= 0) then
					l_break := True
				end
				if not (l_break) then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_ARGENTRY]}.make_cast (al_ga.ga_data) + al_ga.ga_len).item.ae_fname))
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_break := False;
			(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_ARGLIST}.make).offset_of ("al_ga"))).item.ga_clear
			update_class_fields -- Current might have been changed; synchronize
		end

	alist_set (a_count___2: INTEGER_32; a_files: CE_POINTER [CE_POINTER [NATURAL_8]]; a_use_curbuf: INTEGER_32; a_fnum_list: CE_POINTER [INTEGER_32]; a_fnum_len: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			((create {CE_CLASS_POINTER [PD_ARGLIST]}.make_shared (c_pointer))).item.alist_clear
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___1 := (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_ARGLIST}.make).offset_of ("al_ga"))).item.ga_grow (a_count___2)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___1 = 1 then
				l_i___0 := 0
				from
				until
					not (not (l_return or l_break) and then (l_i___0 < a_count___2))
				loop
					l_break := False
					if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						from
						until
							not (l_i___0 < a_count___2)
						loop
							l_tmp := l_i___0
							l_i___0 := l_i___0 + 1;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_files[l_tmp]))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_break := True
					end
					if not (l_return or l_break) then
						if not a_fnum_list.is_void then
							if l_i___0 < a_fnum_len then
								buf_set_name (a_fnum_list[l_i___0], a_files[l_i___0])
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if a_use_curbuf.to_boolean then
							l_tmp___0 := 2
						else
							l_tmp___0 := 1
						end
						((create {CE_CLASS_POINTER [PD_ARGLIST]}.make_shared (c_pointer))).item.alist_add (a_files[l_i___0], l_tmp___0)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_UI_STATIC}).ui_breakcheck
						update_class_fields -- Current might have been changed; synchronize
						l_i___0 := l_i___0 + 1
					end
				end
				l_break := False;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_files))
				update_class_fields -- Current might have been changed; synchronize
			else
				(create {P_MISC1_STATIC}).FreeWild (a_count___2, a_files)
				update_class_fields -- Current might have been changed; synchronize
			end
			if (c_pointer = ((create {P_GLOBALS_STATIC}).global_alist.item).c_pointer) then
				(create {P_GLOBALS_STATIC}).arg_had_last.item := 0
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	alist_add (a_fname: CE_POINTER [NATURAL_8]; a_set_fnum: INTEGER_32)
		local
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			if a_fname.is_void then
				l_return := True
			end
			if not l_return then
				(create {CE_CLASS_POINTER [PD_ARGENTRY]}.make_cast (al_ga.ga_data) + al_ga.ga_len).item.ae_fname := a_fname
				update_class_fields -- Current might have been changed; synchronize
				if a_set_fnum > 0 then
					if a_set_fnum = 2 then
						l_tmp := 1
					else
						l_tmp := 0
					end
					(create {CE_CLASS_POINTER [PD_ARGENTRY]}.make_cast (al_ga.ga_data) + al_ga.ga_len).item.ae_fnum := (create {P_BUFFER_STATIC}).buflist_add (a_fname, (2).bit_or (l_tmp))
					update_class_fields -- Current might have been changed; synchronize
				end
				al_ga.ga_len := (al_ga.ga_len) + 1
				update_class_fields -- Current might have been changed; synchronize
			end
		end

feature {PD_ARGLIST} -- private routines

	buf_set_name (a_fnum___0: INTEGER_32; a_name___1: CE_POINTER [NATURAL_8])
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
		do
			l_buf___6 := (create {P_BUFFER_STATIC}).buflist_findnr (a_fnum___0)
			if not l_buf___6.is_void then
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6.item.b_sfname));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6.item.b_ffname))
				l_buf___6.item.b_ffname := (create {P_MISC2_STATIC}).vim_strsave (a_name___1)
				l_buf___6.item.b_sfname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
				(create {P_BUFFER_STATIC}).fname_expand (l_buf___6, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_ffname")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_sfname")))
				l_buf___6.item.b_fname := l_buf___6.item.b_sfname
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			al_ga := a_other.al_ga.twin
			al_refcount := a_other.al_refcount
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				al_ga.is_equal (a_other.al_ga) and
				al_refcount = a_other.al_refcount
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("al_ga"),
					create {CE_STRUCTURE_FIELD}.make ("al_refcount")
				>>)
			init_structure_info
		end

end
