class
	PD_BALLOONEVALSTRUCT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_GTK_GTK_STATIC
		redefine
			copy,
			is_equal
		end
	S_GLIB_OBJECT_STATIC
		redefine
			copy,
			is_equal
		end
	S_GDK_GDK_STATIC
		redefine
			copy,
			is_equal
		end
	S_PANGO_PANGO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} target.make
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} balloonShell.make
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} balloonLabel.make
			create {CE_NATURAL_8_POINTER} msg.make
			create msgCB.make
			create {CE_VOID_POINTER} clientData.make
			Precursor
		end

feature {ANY} -- fields

	target: CE_POINTER [SD_GTKWIDGET] assign set_target

	balloonShell: CE_POINTER [SD_GTKWIDGET] assign set_balloonShell

	balloonLabel: CE_POINTER [SD_GTKWIDGET] assign set_balloonLabel

	timerID: NATURAL_32 assign set_timerID

	showState: NATURAL_32 assign set_showState

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	state: NATURAL_32 assign set_state

	ts: INTEGER_32 assign set_ts

	msg: CE_POINTER [NATURAL_8] assign set_msg

	msgCB: CE_ROUTINE assign set_msgCB

	clientData: CE_POINTER [ANY] assign set_clientData

feature {ANY} -- field setters

	set_target (a_target: CE_POINTER [SD_GTKWIDGET])
		do
			target := a_target
			update_memory_field ("target")
		end

	set_balloonShell (a_balloonShell: CE_POINTER [SD_GTKWIDGET])
		do
			balloonShell := a_balloonShell
			update_memory_field ("balloonShell")
		end

	set_balloonLabel (a_balloonLabel: CE_POINTER [SD_GTKWIDGET])
		do
			balloonLabel := a_balloonLabel
			update_memory_field ("balloonLabel")
		end

	set_timerID (a_timerID: NATURAL_32)
		do
			timerID := a_timerID
			update_memory_field ("timerID")
		end

	set_showState (a_showState: NATURAL_32)
		do
			showState := a_showState
			update_memory_field ("showState")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_ts (a_ts: INTEGER_32)
		do
			ts := a_ts
			update_memory_field ("ts")
		end

	set_msg (a_msg: CE_POINTER [NATURAL_8])
		do
			msg := a_msg
			update_memory_field ("msg")
		end

	set_msgCB (a_msgCB: CE_ROUTINE)
		do
			msgCB := a_msgCB
			update_memory_field ("msgCB")
		end

	set_clientData (a_clientData: CE_POINTER [ANY])
		do
			clientData := a_clientData
			update_memory_field ("clientData")
		end

feature {ANY} -- public routines

	get_beval_info (a_getword: INTEGER_32; a_winp: CE_POINTER [CE_POINTER [PD_WINDOW_S]]; a_lnump: CE_POINTER [INTEGER_32]; a_textp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_colp: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_textp.is_void
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_row: CE_ARRAY [INTEGER_32]
			l_col: CE_ARRAY [INTEGER_32]
			l_lbuf: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_lnum: CE_ARRAY [INTEGER_32]
			l_len: INTEGER_32
			l_spos: CE_POINTER [PD_POS_T]
			l_epos: CE_POINTER [PD_POS_T]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_row.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_lbuf.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_lnum.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_textp.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					l_row.item := (y - (create {P_GUI_STATIC}).gui.item.item.border_offset) // (create {P_GUI_STATIC}).gui.item.item.char_height
					update_class_fields -- Current might have been changed; synchronize
					l_col.item := (x - (create {P_GUI_STATIC}).gui.item.item.border_offset) // (create {P_GUI_STATIC}).gui.item.item.char_width
					update_class_fields -- Current might have been changed; synchronize
					l_wp___0 := (create {P_UI_STATIC}).mouse_find_win (l_row, l_col)
					update_class_fields -- Current might have been changed; synchronize
					if l_wp___0.is_void then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if not (l_row.item < l_wp___0.item.w_height) then
							l_pos := -1 + 11 -- skip if block
						end
				when 2 then -- if:
						if not (l_col.item < l_wp___0.item.w_width) then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						l_tmp___5 := l_wp___0.item.mouse_comp_pos (l_row, l_col, l_lnum)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___5.to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						l_lbuf.item := (l_wp___0.item.w_buffer).item.ml_get_buf (l_lnum.item, 0)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___4 := (create {P_CHARSET_STATIC}).win_linetabsize (l_wp___0, l_lbuf.item, (2_147_483_647).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_col.item <= l_tmp___4) then
							l_pos := -1 + 11 -- skip if block
						end
				when 5 then -- if:
						if not (a_getword.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 6 then -- if:
						l_spos := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer)
						l_epos := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer)
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							if (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
								l_tmp___0 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum).to_integer
							else
								if (create {P_GLOBALS_STATIC}).VIsual.item.item.col /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
									l_tmp := ((create {P_GLOBALS_STATIC}).VIsual.item.item.col < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col).to_integer
								else
									l_tmp := ((create {P_GLOBALS_STATIC}).VIsual.item.item.coladd < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd).to_integer
								end
								l_tmp___0 := l_tmp
							end
							if l_tmp___0.to_boolean then
								l_spos := (create {P_GLOBALS_STATIC}).VIsual.item
								l_epos := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
							else
								l_spos := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
								l_epos := (create {P_GLOBALS_STATIC}).VIsual.item
							end
						end
						l_tmp___1 := l_wp___0.item.vcol2col (l_lnum.item, l_col.item)
						update_class_fields -- Current might have been changed; synchronize
						l_col.item := l_tmp___1 - 1
						update_class_fields -- Current might have been changed; synchronize
						if not (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (l_wp___0.item.w_buffer).is_equal ((create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer) then
							if l_lnum.item = l_spos.item.lnum then
								l_tmp___2 := (l_col.item >= l_spos.item.col).to_integer
							else
								l_tmp___2 := (l_lnum.item > l_spos.item.lnum).to_integer
							end
							if l_tmp___2.to_boolean then
								if l_lnum.item = l_epos.item.lnum then
									l_tmp___3 := (l_col.item <= l_epos.item.col).to_integer
								else
									l_tmp___3 := (l_lnum.item < l_epos.item.lnum).to_integer
								end
								if l_tmp___3.to_boolean then
									if l_spos.item.lnum /= l_epos.item.lnum then
										Result := 0
										l_return := True
									elseif l_spos.item.col = l_epos.item.col then
										Result := 0
										l_return := True
									end
									if not l_return then
										l_lbuf.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer).item.ml_get_buf ((create {P_GLOBALS_STATIC}).VIsual.item.item.lnum, 0)
										update_class_fields -- Current might have been changed; synchronize
										l_lbuf.item := (create {P_MISC2_STATIC}).vim_strnsave (l_lbuf.item + l_spos.item.col, (l_epos.item.col - l_spos.item.col) + (((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 /= 101).to_integer)
										update_class_fields -- Current might have been changed; synchronize
										l_lnum.item := l_spos.item.lnum
										update_class_fields -- Current might have been changed; synchronize
										l_col.item := l_spos.item.col
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									l_pos := -1 + 9 -- goto _L___1
								end
							else
								l_pos := -1 + 9 -- goto _L___1
							end
						else
							l_pos := -1 + 9 -- goto _L___1
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___1:;
						(create {P_GLOBALS_STATIC}).emsg_off.item := (create {P_GLOBALS_STATIC}).emsg_off.item + 1
						update_class_fields -- Current might have been changed; synchronize
						l_len := l_wp___0.item.find_ident_at_pos (l_lnum.item, l_col.item, l_lbuf, 7)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).emsg_off.item := (create {P_GLOBALS_STATIC}).emsg_off.item - 1
						update_class_fields -- Current might have been changed; synchronize
						if l_len = 0 then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_lbuf.item := (create {P_MISC2_STATIC}).vim_strnsave (l_lbuf.item, l_len)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 10 then -- if done
						if not l_return then
							a_winp.item := l_wp___0
							update_class_fields -- Current might have been changed; synchronize
							a_lnump.item := l_lnum.item
							update_class_fields -- Current might have been changed; synchronize
							a_textp.item := l_lbuf.item
							update_class_fields -- Current might have been changed; synchronize
							a_colp.item := l_col.item
							update_class_fields -- Current might have been changed; synchronize
							Current.ts := ((l_wp___0.item.w_buffer).item.b_p_ts).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							Result := 1
							l_return := True
						end
				when 11 then -- if done | if done | if done | if done | if done
					if not l_return then
						Result := 0
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_mch_post_balloon (a_mesg: CE_POINTER [NATURAL_8])
		do
			Current.msg := a_mesg
			update_class_fields -- Current might have been changed; synchronize
			if not a_mesg.is_void then
				((create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_shared (c_pointer))).item.drawBalloon
				update_class_fields -- Current might have been changed; synchronize
			else
				((create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_shared (c_pointer))).item.undrawBalloon
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	removeEventHandler
		local
			l_tmp: INTEGER_32
		do
			gtk_signal_compat_matched (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (target), ((create {P_GUI_BEVAL_STATIC}).target_event_cb_address), create {CE_VOID_POINTER}.make_shared (c_pointer), (24).to_natural_32, (0).to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			if (create {P_GLOBALS_STATIC}).gtk_socket_id.item = {NATURAL_32} 0 then
				if not ((create {P_GUI_STATIC}).gui.item.item.mainwin).is_void then
					l_tmp := gtk_widget_is_ancestor (target, (create {P_GUI_STATIC}).gui.item.item.mainwin)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						gtk_signal_compat_matched (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast ((create {P_GUI_STATIC}).gui.item.item.mainwin), ((create {P_GUI_BEVAL_STATIC}).mainwin_event_cb_address), create {CE_VOID_POINTER}.make_shared (c_pointer), (24).to_natural_32, (0).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
		end

	pointer_event (a_x___0, a_y: INTEGER_32; a_state: NATURAL_32)
		local
			l_distance: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			if a_x___0 - x < 0 then
				l_tmp := -(a_x___0 - x)
			else
				l_tmp := a_x___0 - x
			end
			if a_y - y < 0 then
				l_tmp___0 := -(a_y - y)
			else
				l_tmp___0 := a_y - y
			end
			l_distance := l_tmp + l_tmp___0
			if l_distance > 4 then
				Current.state := a_state
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_shared (c_pointer))).item.cancelBalloon
				update_class_fields -- Current might have been changed; synchronize
				if not ((a_state).bit_and ({NATURAL_32} 1_792)).to_boolean then
					Current.x := a_x___0
					update_class_fields -- Current might have been changed; synchronize
					Current.y := a_y
					update_class_fields -- Current might have been changed; synchronize
					if ((a_state).bit_and ({NATURAL_32} 8)).to_boolean then
						if not msgCB.is_void then
							Current.showState := {PC_BESTATE}.ShS_PENDING
							update_class_fields -- Current might have been changed; synchronize
							msgCB.call ([(create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_shared (c_pointer)), a_state.to_integer_32])
							update_class_fields -- Current might have been changed; synchronize
						end
					else
						Current.timerID := gtk_timeout_add (((create {P_OPTION_STATIC}).p_bdlay.item.item).to_natural_32, (create {P_GUI_BEVAL_STATIC}).timeout_cb_address, create {CE_VOID_POINTER}.make_shared (c_pointer))
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
		end

	key_event (a_keyval: NATURAL_32; a_is_keypress: INTEGER_32)
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if showState /= {NATURAL_32} 3 then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if msgCB.is_void then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						inspect a_keyval.to_integer_32 -- switch 1 head
						when 65505 then l_pos := -1 + 3
						when 65506 then l_pos := -1 + 3
						when 65507 then l_pos := -1 + 4
						when 65508 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 3 then -- switch 1, case 65505 | switch 1, case 65506
						Current.showState := {PC_BESTATE}.ShS_UPDATE_PENDING
						update_class_fields -- Current might have been changed; synchronize
						if a_is_keypress.to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
						msgCB.call ([(create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_shared (c_pointer)), l_tmp])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 65507 | switch 1, case 65508
						Current.showState := {PC_BESTATE}.ShS_UPDATE_PENDING
						update_class_fields -- Current might have been changed; synchronize
						if a_is_keypress.to_boolean then
							l_tmp___0 := 4
						else
							l_tmp___0 := 0
						end
						msgCB.call ([(create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_shared (c_pointer)), l_tmp___0])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
						if a_is_keypress.to_boolean then
							((create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_shared (c_pointer))).item.cancelBalloon
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:;
						((create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_shared (c_pointer))).item.cancelBalloon
						update_class_fields -- Current might have been changed; synchronize
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:;
						((create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_shared (c_pointer))).item.cancelBalloon
						update_class_fields -- Current might have been changed; synchronize
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	requestBalloon
		do
			if showState /= {NATURAL_32} 1 then
				if not msgCB.is_void then
					Current.showState := {PC_BESTATE}.ShS_PENDING
					update_class_fields -- Current might have been changed; synchronize
					msgCB.call ([(create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_shared (c_pointer)), state.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
				elseif not msg.is_void then
					((create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_shared (c_pointer))).item.drawBalloon
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	drawBalloon
		local
			l_requisition: CE_ARRAY [SD_GTKREQUISITION]
			l_screen_w: INTEGER_32
			l_screen_h: INTEGER_32
			l_x___0: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_x_offset: INTEGER_32
			l_y_offset: INTEGER_32
			l_layout: CE_POINTER [ANY]
			l_screen: CE_POINTER [SD_GDKSCREEN]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___1: NATURAL_32
			l_tmp___2: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___3: NATURAL_32
			l_tmp___4: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_GTKREQUISITION]} l_requisition.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_x___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)

			if not msg.is_void then
				l_x_offset := 15
				l_y_offset := 10
				l_screen := gtk_widget_get_screen (target)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := gtk_window_get_type
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (balloonShell), l_tmp)
				update_class_fields -- Current might have been changed; synchronize
				gtk_window_set_screen (create {CE_CLASS_POINTER [SD_GTKWINDOW]}.make_cast (l_tmp___0), l_screen)
				update_class_fields -- Current might have been changed; synchronize
				l_screen_w := gdk_screen_get_width (l_screen)
				update_class_fields -- Current might have been changed; synchronize
				l_screen_h := gdk_screen_get_height (l_screen)
				update_class_fields -- Current might have been changed; synchronize
				gtk_widget_ensure_style (balloonShell)
				update_class_fields -- Current might have been changed; synchronize
				gtk_widget_ensure_style (balloonLabel)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___1 := gtk_label_get_type
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___2 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (balloonLabel), l_tmp___1)
				update_class_fields -- Current might have been changed; synchronize
				set_printable_label_text (create {CE_CLASS_POINTER [SD_GTKLABEL]}.make_cast (l_tmp___2), msg)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___3 := gtk_label_get_type
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___4 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (balloonLabel), l_tmp___3)
				update_class_fields -- Current might have been changed; synchronize
				l_layout := gtk_label_get_layout (create {CE_CLASS_POINTER [SD_GTKLABEL]}.make_cast (l_tmp___4))
				update_class_fields -- Current might have been changed; synchronize
				pango_layout_set_wrap (l_layout, {SC_PANGOWRAPMODE}.PANGO_WRAP_WORD)
				update_class_fields -- Current might have been changed; synchronize
				if 20 > l_screen_w - 20 then
					l_tmp___9 := 20
				else
					l_tmp___9 := l_screen_w - 20
				end
				if (create {P_GUI_STATIC}).gui.item.item.num_cols * (create {P_GUI_STATIC}).gui.item.item.char_width > l_tmp___9 then
					if 20 > l_screen_w - 20 then
						l_tmp___6 := 20
					else
						l_tmp___6 := l_screen_w - 20
					end
					l_tmp___8 := l_tmp___6
				else
					if (create {P_GUI_STATIC}).gui.item.item.num_cols * (create {P_GUI_STATIC}).gui.item.item.char_width < l_screen_w // 2 then
						l_tmp___7 := l_screen_w // 2
					else
						l_tmp___7 := (create {P_GUI_STATIC}).gui.item.item.num_cols * (create {P_GUI_STATIC}).gui.item.item.char_width
					end
					l_tmp___8 := l_tmp___7
				end
				pango_layout_set_width (l_layout, 1_024 * l_tmp___8)
				update_class_fields -- Current might have been changed; synchronize
				gtk_widget_size_request (balloonShell, l_requisition)
				update_class_fields -- Current might have been changed; synchronize
				gdk_window_get_origin (target.item.window, l_x___0, l_y).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_x___0.item := l_x___0.item + x
				update_class_fields -- Current might have been changed; synchronize
				l_y.item := l_y.item + y
				update_class_fields -- Current might have been changed; synchronize
				if (l_x___0.item + l_x_offset) + l_requisition.item.width > l_screen_w then
					l_y_offset := l_y_offset + (15)
				end
				if (l_y.item + l_y_offset) + l_requisition.item.height > l_screen_h then
					l_y_offset := -l_requisition.item.height - 10
				end
				if 0 > l_screen_w - l_requisition.item.width then
					l_tmp___13 := 0
				else
					l_tmp___13 := l_screen_w - l_requisition.item.width
				end
				if l_x___0.item + l_x_offset > l_tmp___13 then
					if 0 > l_screen_w - l_requisition.item.width then
						l_tmp___11 := 0
					else
						l_tmp___11 := l_screen_w - l_requisition.item.width
					end
					l_x___0.item := l_tmp___11
					update_class_fields -- Current might have been changed; synchronize
				else
					if l_x___0.item + l_x_offset < 0 then
						l_tmp___12 := 0
					else
						l_tmp___12 := l_x___0.item + l_x_offset
					end
					l_x___0.item := l_tmp___12
					update_class_fields -- Current might have been changed; synchronize
				end
				if 0 > l_screen_h - l_requisition.item.height then
					l_tmp___17 := 0
				else
					l_tmp___17 := l_screen_h - l_requisition.item.height
				end
				if l_y.item + l_y_offset > l_tmp___17 then
					if 0 > l_screen_h - l_requisition.item.height then
						l_tmp___15 := 0
					else
						l_tmp___15 := l_screen_h - l_requisition.item.height
					end
					l_y.item := l_tmp___15
					update_class_fields -- Current might have been changed; synchronize
				else
					if l_y.item + l_y_offset < 0 then
						l_tmp___16 := 0
					else
						l_tmp___16 := l_y.item + l_y_offset
					end
					l_y.item := l_tmp___16
					update_class_fields -- Current might have been changed; synchronize
				end
				gtk_widget_set_uposition (balloonShell, l_x___0.item, l_y.item)
				update_class_fields -- Current might have been changed; synchronize
				gtk_widget_show (balloonShell)
				update_class_fields -- Current might have been changed; synchronize
				Current.showState := {PC_BESTATE}.ShS_SHOWING
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	undrawBalloon
		do
			if not balloonShell.is_void then
				gtk_widget_hide (balloonShell)
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.showState := {PC_BESTATE}.ShS_NEUTRAL
			update_class_fields -- Current might have been changed; synchronize
		end

	cancelBalloon
		do
			if showState = {NATURAL_32} 3 then
				((create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_shared (c_pointer))).item.undrawBalloon
				update_class_fields -- Current might have been changed; synchronize
			elseif showState = {NATURAL_32} 2 then
				((create {CE_CLASS_POINTER [PD_BALLOONEVALSTRUCT]}.make_shared (c_pointer))).item.undrawBalloon
				update_class_fields -- Current might have been changed; synchronize
			end
			if timerID /= {NATURAL_32} 0 then
				gtk_timeout_remove (timerID)
				update_class_fields -- Current might have been changed; synchronize
				Current.timerID := {NATURAL_32} 0
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.showState := {PC_BESTATE}.ShS_NEUTRAL
			update_class_fields -- Current might have been changed; synchronize
		end

	createBalloonEvalWindow
		local
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___1: NATURAL_32
			l_tmp___2: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___3: NATURAL_32
			l_tmp___4: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___5: NATURAL_32
			l_tmp___6: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___7: NATURAL_32
			l_tmp___8: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___9: NATURAL_32
			l_tmp___10: CE_POINTER [SD_GTYPEINSTANCE]
		do
			Current.balloonShell := gtk_window_new ({SC_GTKWINDOWTYPE}.GTK_WINDOW_POPUP)
			update_class_fields -- Current might have been changed; synchronize
			gtk_widget_set_app_paintable (balloonShell, 1)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := gtk_window_get_type
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (balloonShell), l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			gtk_window_set_policy (create {CE_CLASS_POINTER [SD_GTKWINDOW]}.make_cast (l_tmp___0), 0, 0, 1)
			update_class_fields -- Current might have been changed; synchronize
			gtk_widget_set_name (balloonShell, ce_string ("gtk-tooltips"))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___1 := gtk_container_get_type
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___2 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (balloonShell), l_tmp___1)
			update_class_fields -- Current might have been changed; synchronize
			gtk_container_set_border_width (create {CE_CLASS_POINTER [SD_GTKCONTAINER]}.make_cast (l_tmp___2), (4).to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (balloonShell), ce_string ("expose_event"), ((create {P_GUI_BEVAL_STATIC}).balloon_expose_event_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Current.balloonLabel := gtk_label_new (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___3 := gtk_label_get_type
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___4 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (balloonLabel), l_tmp___3)
			update_class_fields -- Current might have been changed; synchronize
			gtk_label_set_line_wrap (create {CE_CLASS_POINTER [SD_GTKLABEL]}.make_cast (l_tmp___4), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___5 := gtk_label_get_type
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___6 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (balloonLabel), l_tmp___5)
			update_class_fields -- Current might have been changed; synchronize
			gtk_label_set_justify (create {CE_CLASS_POINTER [SD_GTKLABEL]}.make_cast (l_tmp___6), {SC_GTKJUSTIFICATION}.GTK_JUSTIFY_LEFT)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___7 := gtk_misc_get_type
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___8 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (balloonLabel), l_tmp___7)
			update_class_fields -- Current might have been changed; synchronize
			gtk_misc_set_alignment (create {CE_CLASS_POINTER [SD_GTKMISC]}.make_cast (l_tmp___8), {REAL_32} 0.5, {REAL_32} 0.5)
			update_class_fields -- Current might have been changed; synchronize
			gtk_widget_set_name (balloonLabel, ce_string ("vim-balloon-label"))
			update_class_fields -- Current might have been changed; synchronize
			gtk_widget_show (balloonLabel)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___9 := gtk_container_get_type
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___10 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (balloonShell), l_tmp___9)
			update_class_fields -- Current might have been changed; synchronize
			gtk_container_add (create {CE_CLASS_POINTER [SD_GTKCONTAINER]}.make_cast (l_tmp___10), balloonLabel)
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_BALLOONEVALSTRUCT} -- private routines

	set_printable_label_text (a_label: CE_POINTER [SD_GTKLABEL]; a_text: CE_POINTER [NATURAL_8])
		local
			l_text: CE_POINTER [NATURAL_8]
			l_convbuf: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_pdest: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_charlen: INTEGER_32
			l_uc: INTEGER_32
			l_attr_list: CE_POINTER [ANY]
			l_tmp: INTEGER_32
			l_aep: CE_POINTER [PD_ATTR_ENTRY]
			l_attr: CE_POINTER [SD_PANGOATTRIBUTE]
			l_pixel: INTEGER_32
			l_color: CE_ARRAY [SD_GDKCOLOR]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_outlen: INTEGER_32
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_GDKCOLOR]} l_color.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_text := a_text
					l_convbuf := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type /= 0 then
						l_convbuf := (create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, l_text, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						if not l_convbuf.is_void then
							l_text := l_convbuf
						end
					end
					l_len := {NATURAL_32} 0
					l_p___0 := l_text
				when 1 then -- loop condition:
					if (l_p___0.item).to_integer_32 = 0 then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						if (((l_p___0.item).to_integer_32).bit_and (128)) /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						l_charlen := 1
						if not ((l_p___0.item).to_integer_32 < 32) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (l_p___0.item).to_integer_32 /= 9 then
							if (l_p___0.item).to_integer_32 /= 10 then
								l_tmp := 2
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						if (l_p___0.item).to_integer_32 = 127 then
							l_tmp := 2
						else
							l_tmp := 1
						end
				when 7 then
						l_len := l_len + l_tmp.to_natural_32
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_charlen := (create {P_MBYTE_STATIC}).utf_ptr2len (l_p___0)
						l_uc := (create {P_MBYTE_STATIC}).utf_ptr2char (l_p___0)
						if l_charlen /= ((create {P_MBYTE_STATIC}).utf_char2len (l_uc)) then
							l_charlen := 1
						end
						if l_charlen = 1 then
							l_len := l_len + ({NATURAL_32} 4)
						elseif l_uc < 160 then
							l_len := l_len + ({NATURAL_32} 4)
						elseif ((create {P_MBYTE_STATIC}).utf_printable (l_uc)).to_boolean then
							l_len := l_len + l_charlen.to_natural_32
						else
							l_len := l_len + ({NATURAL_32} 6)
						end
				when 10 then -- if done
						l_p___0 := l_p___0 + l_charlen
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
					l_attr_list := pango_attr_list_new
					l_buf___6 := (create {P_MISC2_STATIC}).alloc (l_len + {NATURAL_32} 1)
					if l_buf___6.is_void then
						l_pos := -1 + 36 -- skip if block
					end
				when 12 then -- if:
						l_color.item.pixel := (0).to_natural_32
						l_color.item.red := (0).to_natural_16
						l_color.item.green := (0).to_natural_16
						l_color.item.blue := (0).to_natural_16
						l_aep := (create {P_SYNTAX_STATIC}).syn_gui_attr2entry ((create {P_GLOBALS_STATIC}).highlight_attr.item[0])
						if not l_aep.is_void then
							l_pixel := l_aep.item.ae_u.gui.fg_color
						else
							l_pixel := (-11_111).to_integer_32
						end
						if l_pixel /= -11_111 then
							gdk_colormap_query_color ((gtk_widget_get_colormap ((create {P_GUI_STATIC}).gui.item.item.drawarea)), l_pixel.to_natural_32, l_color)
						end
						l_pdest := l_buf___6
						l_p___0 := l_text
				when 13 then -- loop condition:
						if not (not (l_return) and then ((l_p___0.item).to_integer_32 /= 0)) then
							l_pos := -1 + 35 -- skip loop
						end
				when 14 then -- loop body:
						if (((l_p___0.item).to_integer_32).bit_and (128)) /= 0 then
							l_pos := -1 + 20 -- skip if block
						end
				when 15 then -- if:
						if not ((l_p___0.item).to_integer_32 < 32) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if (l_p___0.item).to_integer_32 /= 9 then
							if (l_p___0.item).to_integer_32 /= 10 then
								l_pos := -1 + 20 -- goto _L___3
							else
								l_pos := -1 + 18 -- goto _L___5
							end
						else
							l_pos := -1 + 18 -- goto _L___5
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L___5:
						if (l_p___0.item).to_integer_32 = 127 then
							l_pos := -1 + 20 -- goto _L___3
						else
							l_tmp___3 := l_pdest
							l_pdest := l_pdest + 1
							l_tmp___4 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___3.item := l_tmp___4.item
						end
				when 19 then -- if done | if block done, skip else block:
						l_pos := -1 + 34
				when 20 then -- else: | _L___3:
						l_charlen := (create {P_MBYTE_STATIC}).utf_ptr2len (l_p___0)
						l_uc := (create {P_MBYTE_STATIC}).utf_ptr2char (l_p___0)
						if l_charlen /= ((create {P_MBYTE_STATIC}).utf_char2len (l_uc)) then
							l_charlen := 1
						end
						if l_charlen /= 1 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 29 -- goto _L___2
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 23 then -- else:
						if not (l_uc < 160) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 29 -- goto _L___2
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 26 then -- else:
						if not (((create {P_MBYTE_STATIC}).utf_printable (l_uc)).to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___6 := l_pdest
							l_pdest := l_pdest + 1
							l_tmp___7 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___6.item := l_tmp___7.item
							l_charlen := l_charlen - 1
							if l_charlen = 0 then
								l_break := True
							end
						end
						l_break := False
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 29 then -- else: | _L___2:
						if not ((((l_p___0.item).to_integer_32).bit_and (128)).to_boolean) then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						if l_charlen = 1 then
							(create {P_CHARSET_STATIC}).transchar_hex (l_pdest, (l_p___0.item).to_integer_32)
							l_outlen := 4
						else
							l_pos := -1 + 32 -- goto _L___1
						end
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else: | _L___1:
						if l_uc >= 128 then
							(create {P_CHARSET_STATIC}).transchar_hex (l_pdest, l_uc)
							if l_uc < 256 then
								l_outlen := 4
							else
								l_outlen := 6
							end
						else
							(create {P_CHARSET_STATIC}).transchar_nonprint (l_pdest, (l_p___0.item).to_integer_32)
							l_outlen := 2
						end
				when 33 then
						if l_pixel /= -11_111 then
							l_attr := pango_attr_foreground_new (l_color.item.red, l_color.item.green, l_color.item.blue)
							l_attr.item.start_index := (l_pdest.distance (l_buf___6)).to_natural_32
							l_attr.item.end_index := ((l_pdest.distance (l_buf___6)) + l_outlen).to_natural_32
							pango_attr_list_insert (l_attr_list, l_attr)
						end
						l_pdest := l_pdest + l_outlen
						l_p___0 := l_p___0 + l_charlen
				when 34 then -- if done | if done | if done
						l_pos := -1 + 13 -- back to loop condition
				when 35 then -- loop done
						l_pdest.item := (('%/0/').code).to_natural_8
				when 36 then -- if done;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_convbuf))
					gtk_label_set_text (a_label, create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
					gtk_label_set_attributes (a_label, l_attr_list)
					pango_attr_list_unref (l_attr_list)
				when 37 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			target := a_other.target
			balloonShell := a_other.balloonShell
			balloonLabel := a_other.balloonLabel
			timerID := a_other.timerID
			showState := a_other.showState
			x := a_other.x
			y := a_other.y
			state := a_other.state
			ts := a_other.ts
			msg := a_other.msg
			msgCB := a_other.msgCB
			clientData := a_other.clientData
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				target.is_equal (a_other.target) and
				balloonShell.is_equal (a_other.balloonShell) and
				balloonLabel.is_equal (a_other.balloonLabel) and
				timerID = a_other.timerID and
				showState = a_other.showState and
				x = a_other.x and
				y = a_other.y and
				state = a_other.state and
				ts = a_other.ts and
				msg.is_equal (a_other.msg) and
				msgCB.is_equal (a_other.msgCB) and
				clientData.is_equal (a_other.clientData)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("target"),
					create {CE_STRUCTURE_FIELD}.make ("balloonShell"),
					create {CE_STRUCTURE_FIELD}.make ("balloonLabel"),
					create {CE_STRUCTURE_FIELD}.make ("timerID"),
					create {CE_STRUCTURE_FIELD}.make ("showState"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("ts"),
					create {CE_STRUCTURE_FIELD}.make ("msg"),
					create {CE_STRUCTURE_FIELD}.make ("msgCB"),
					create {CE_STRUCTURE_FIELD}.make ("clientData")
				>>)
			init_structure_info
		end

end
