class
	PD_BLOCK_DEF

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} textstart.make
		end

feature {ANY} -- fields

	startspaces: INTEGER_32 assign set_startspaces

	endspaces: INTEGER_32 assign set_endspaces

	textlen: INTEGER_32 assign set_textlen

	textstart: CE_POINTER [NATURAL_8] assign set_textstart

	textcol: INTEGER_32 assign set_textcol

	start_vcol: INTEGER_32 assign set_start_vcol

	end_vcol: INTEGER_32 assign set_end_vcol

	is_short: INTEGER_32 assign set_is_short

	is_MAX: INTEGER_32 assign set_is_MAX

	is_oneChar: INTEGER_32 assign set_is_oneChar

	pre_whitesp: INTEGER_32 assign set_pre_whitesp

	pre_whitesp_c: INTEGER_32 assign set_pre_whitesp_c

	end_char_vcols: INTEGER_32 assign set_end_char_vcols

	start_char_vcols: INTEGER_32 assign set_start_char_vcols

feature {ANY} -- field setters

	set_startspaces (a_startspaces: INTEGER_32)
		do
			startspaces := a_startspaces
			update_memory_field ("startspaces")
		end

	set_endspaces (a_endspaces: INTEGER_32)
		do
			endspaces := a_endspaces
			update_memory_field ("endspaces")
		end

	set_textlen (a_textlen: INTEGER_32)
		do
			textlen := a_textlen
			update_memory_field ("textlen")
		end

	set_textstart (a_textstart: CE_POINTER [NATURAL_8])
		do
			textstart := a_textstart
			update_memory_field ("textstart")
		end

	set_textcol (a_textcol: INTEGER_32)
		do
			textcol := a_textcol
			update_memory_field ("textcol")
		end

	set_start_vcol (a_start_vcol: INTEGER_32)
		do
			start_vcol := a_start_vcol
			update_memory_field ("start_vcol")
		end

	set_end_vcol (a_end_vcol: INTEGER_32)
		do
			end_vcol := a_end_vcol
			update_memory_field ("end_vcol")
		end

	set_is_short (a_is_short: INTEGER_32)
		do
			is_short := a_is_short
			update_memory_field ("is_short")
		end

	set_is_MAX (a_is_MAX: INTEGER_32)
		do
			is_MAX := a_is_MAX
			update_memory_field ("is_MAX")
		end

	set_is_oneChar (a_is_oneChar: INTEGER_32)
		do
			is_oneChar := a_is_oneChar
			update_memory_field ("is_oneChar")
		end

	set_pre_whitesp (a_pre_whitesp: INTEGER_32)
		do
			pre_whitesp := a_pre_whitesp
			update_memory_field ("pre_whitesp")
		end

	set_pre_whitesp_c (a_pre_whitesp_c: INTEGER_32)
		do
			pre_whitesp_c := a_pre_whitesp_c
			update_memory_field ("pre_whitesp_c")
		end

	set_end_char_vcols (a_end_char_vcols: INTEGER_32)
		do
			end_char_vcols := a_end_char_vcols
			update_memory_field ("end_char_vcols")
		end

	set_start_char_vcols (a_start_char_vcols: INTEGER_32)
		do
			start_char_vcols := a_start_char_vcols
			update_memory_field ("start_char_vcols")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			startspaces := a_other.startspaces
			endspaces := a_other.endspaces
			textlen := a_other.textlen
			textstart := a_other.textstart
			textcol := a_other.textcol
			start_vcol := a_other.start_vcol
			end_vcol := a_other.end_vcol
			is_short := a_other.is_short
			is_MAX := a_other.is_MAX
			is_oneChar := a_other.is_oneChar
			pre_whitesp := a_other.pre_whitesp
			pre_whitesp_c := a_other.pre_whitesp_c
			end_char_vcols := a_other.end_char_vcols
			start_char_vcols := a_other.start_char_vcols
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				startspaces = a_other.startspaces and
				endspaces = a_other.endspaces and
				textlen = a_other.textlen and
				textstart.is_equal (a_other.textstart) and
				textcol = a_other.textcol and
				start_vcol = a_other.start_vcol and
				end_vcol = a_other.end_vcol and
				is_short = a_other.is_short and
				is_MAX = a_other.is_MAX and
				is_oneChar = a_other.is_oneChar and
				pre_whitesp = a_other.pre_whitesp and
				pre_whitesp_c = a_other.pre_whitesp_c and
				end_char_vcols = a_other.end_char_vcols and
				start_char_vcols = a_other.start_char_vcols
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("startspaces"),
					create {CE_STRUCTURE_FIELD}.make ("endspaces"),
					create {CE_STRUCTURE_FIELD}.make ("textlen"),
					create {CE_STRUCTURE_FIELD}.make ("textstart"),
					create {CE_STRUCTURE_FIELD}.make ("textcol"),
					create {CE_STRUCTURE_FIELD}.make ("start_vcol"),
					create {CE_STRUCTURE_FIELD}.make ("end_vcol"),
					create {CE_STRUCTURE_FIELD}.make ("is_short"),
					create {CE_STRUCTURE_FIELD}.make ("is_MAX"),
					create {CE_STRUCTURE_FIELD}.make ("is_oneChar"),
					create {CE_STRUCTURE_FIELD}.make ("pre_whitesp"),
					create {CE_STRUCTURE_FIELD}.make ("pre_whitesp_c"),
					create {CE_STRUCTURE_FIELD}.make ("end_char_vcols"),
					create {CE_STRUCTURE_FIELD}.make ("start_char_vcols")
				>>)
			init_structure_info
		end

end
