class
	PD_BUFFHEADER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create bh_first.make
			create {CE_CLASS_POINTER [PD_BUFFBLOCK]} bh_curr.make
			Precursor
		end

feature {ANY} -- fields

	bh_first: PD_BUFFBLOCK assign set_bh_first

	bh_curr: CE_POINTER [PD_BUFFBLOCK] assign set_bh_curr

	bh_index: INTEGER_32 assign set_bh_index

	bh_space: INTEGER_32 assign set_bh_space

feature {ANY} -- field setters

	set_bh_first (a_bh_first: PD_BUFFBLOCK)
		do
			bh_first := a_bh_first
			update_memory_field ("bh_first")
		end

	set_bh_curr (a_bh_curr: CE_POINTER [PD_BUFFBLOCK])
		do
			bh_curr := a_bh_curr
			update_memory_field ("bh_curr")
		end

	set_bh_index (a_bh_index: INTEGER_32)
		do
			bh_index := a_bh_index
			update_memory_field ("bh_index")
		end

	set_bh_space (a_bh_space: INTEGER_32)
		do
			bh_space := a_bh_space
			update_memory_field ("bh_space")
		end

feature {ANY} -- public routines

	free_buff
		local
			l_p___0: CE_POINTER [PD_BUFFBLOCK]
			l_np: CE_POINTER [PD_BUFFBLOCK]
		do
			l_p___0 := bh_first.b_next
			from
			until
				l_p___0.is_void
			loop
				l_np := l_p___0.item.b_next;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
				update_class_fields -- Current might have been changed; synchronize
				l_p___0 := l_np
			end
			bh_first.b_next := create {CE_CLASS_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
		end

	get_buffcont (a_dozero: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_count___2: NATURAL_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_p2: CE_POINTER [NATURAL_8]
			l_str___1: CE_POINTER [NATURAL_8]
			l_bp___0: CE_POINTER [PD_BUFFBLOCK]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := (0).to_natural_32
					l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_bp___0 := bh_first.b_next
					from
					until
						l_bp___0.is_void
					loop
						l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_bp___0.item.b_str)))
						update_class_fields -- Current might have been changed; synchronize
						l_count___2 := l_count___2 + l_tmp.to_natural_32
						l_bp___0 := l_bp___0.item.b_next
					end
					if not (l_count___2.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_dozero.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_p___0 := (create {P_MISC2_STATIC}).lalloc (l_count___2 + {NATURAL_32} 1, 1)
						update_class_fields -- Current might have been changed; synchronize
						if not l_p___0.is_void then
							l_p2 := l_p___0
							l_bp___0 := bh_first.b_next
							from
							until
								not (not (l_return) and then (not l_bp___0.is_void))
							loop
								l_str___1 := l_bp___0.item.b_str
								from
								until
									not ((l_str___1.item).to_boolean)
								loop
									l_tmp___0 := l_p2
									l_p2 := l_p2 + 1
									l_tmp___1 := l_str___1
									l_str___1 := l_str___1 + 1
									l_tmp___0.item := l_tmp___1.item
									update_class_fields -- Current might have been changed; synchronize
								end
								l_bp___0 := l_bp___0.item.b_next
							end
							l_p2.item := (('%/0/').code).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
						end
				when 5 then -- if done
					Result := l_p___0
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			bh_first := a_other.bh_first.twin
			bh_curr := a_other.bh_curr
			bh_index := a_other.bh_index
			bh_space := a_other.bh_space
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				bh_first.is_equal (a_other.bh_first) and
				bh_curr.is_equal (a_other.bh_curr) and
				bh_index = a_other.bh_index and
				bh_space = a_other.bh_space
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("bh_first"),
					create {CE_STRUCTURE_FIELD}.make ("bh_curr"),
					create {CE_STRUCTURE_FIELD}.make ("bh_index"),
					create {CE_STRUCTURE_FIELD}.make ("bh_space")
				>>)
			init_structure_info
		end

end
