class
	PD_CLEANUP_STUFF

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_VIM_EXCEPTION]} exception.make
		end

feature {ANY} -- fields

	pending: INTEGER_32 assign set_pending

	exception: CE_POINTER [PD_VIM_EXCEPTION] assign set_exception

feature {ANY} -- field setters

	set_pending (a_pending: INTEGER_32)
		do
			pending := a_pending
			update_memory_field ("pending")
		end

	set_exception (a_exception: CE_POINTER [PD_VIM_EXCEPTION])
		do
			exception := a_exception
			update_memory_field ("exception")
		end

feature {ANY} -- public routines

	enter_cleanup
		local
			l_pending: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pending := 0
					if not (((create {P_GLOBALS_STATIC}).did_emsg.item).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if not (((create {P_GLOBALS_STATIC}).got_int.item).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not (((create {P_GLOBALS_STATIC}).did_throw.item).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not (((create {P_GLOBALS_STATIC}).need_rethrow.item).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						if ((create {P_GLOBALS_STATIC}).did_emsg.item).to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_tmp___0 := 2
						else
							l_tmp___0 := 0
						end
						if ((create {P_GLOBALS_STATIC}).did_throw.item).to_boolean then
							l_tmp___1 := 4
						else
							l_tmp___1 := 0
						end
						if ((create {P_GLOBALS_STATIC}).need_rethrow.item).to_boolean then
							l_tmp___2 := 4
						else
							l_tmp___2 := 0
						end
						Current.pending := (((((l_tmp).bit_or (l_tmp___0))).bit_or (l_tmp___1))).bit_or (l_tmp___2)
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_GLOBALS_STATIC}).did_throw.item).to_boolean then
							Current.exception := (create {P_GLOBALS_STATIC}).current_exception.item
							update_class_fields -- Current might have been changed; synchronize
						elseif ((create {P_GLOBALS_STATIC}).need_rethrow.item).to_boolean then
							Current.exception := (create {P_GLOBALS_STATIC}).current_exception.item
							update_class_fields -- Current might have been changed; synchronize
						else
							Current.exception := create {CE_CLASS_POINTER [PD_VIM_EXCEPTION]}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
							if ((create {P_GLOBALS_STATIC}).did_emsg.item).to_boolean then
								(create {P_GLOBALS_STATIC}).force_abort.item := ((create {P_GLOBALS_STATIC}).force_abort.item).bit_or (((create {P_EX_EVAL_STATIC}).cause_abort.item))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_EX_EVAL_STATIC}).cause_abort.item := 0
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						(create {P_GLOBALS_STATIC}).need_rethrow.item := 0
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).did_throw.item := (create {P_GLOBALS_STATIC}).need_rethrow.item
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).got_int.item := (create {P_GLOBALS_STATIC}).did_throw.item
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).did_emsg.item := (create {P_GLOBALS_STATIC}).got_int.item
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_EX_EVAL_STATIC}).report_make_pending (l_pending, create {CE_VOID_POINTER}.make_cast (exception))
						update_class_fields -- Current might have been changed; synchronize
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						Current.pending := 0
						update_class_fields -- Current might have been changed; synchronize
						Current.exception := create {CE_CLASS_POINTER [PD_VIM_EXCEPTION]}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
				when 13 then -- if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	leave_cleanup
		local
			l_pending: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pending := pending
					if l_pending = 0 then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						l_tmp___0 := (create {P_EX_EVAL_STATIC}).aborting
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___0.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (((create {P_GLOBALS_STATIC}).need_rethrow.item).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if ((l_pending).bit_and (4)).to_boolean then
							(create {P_EX_EVAL_STATIC}).discard_exception (exception, 0)
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_EX_EVAL_STATIC}).report_discard_pending (l_pending, create {CE_VOID_POINTER}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
						end
						if not ((create {P_GLOBALS_STATIC}).msg_list.item).is_void then
							(create {P_EX_EVAL_STATIC}).free_msglist ((create {P_GLOBALS_STATIC}).msg_list.item.item)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).msg_list.item.item := create {CE_CLASS_POINTER [PD_MSGLIST]}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						if ((l_pending).bit_and (4)).to_boolean then
							(create {P_GLOBALS_STATIC}).current_exception.item := exception
							update_class_fields -- Current might have been changed; synchronize
						elseif ((l_pending).bit_and (1)).to_boolean then
							(create {P_EX_EVAL_STATIC}).cause_abort.item := (create {P_GLOBALS_STATIC}).force_abort.item
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).force_abort.item := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						if ((l_pending).bit_and (1)).to_boolean then
							(create {P_GLOBALS_STATIC}).did_emsg.item := 1
							update_class_fields -- Current might have been changed; synchronize
						end
						if ((l_pending).bit_and (2)).to_boolean then
							(create {P_GLOBALS_STATIC}).got_int.item := 1
							update_class_fields -- Current might have been changed; synchronize
						end
						if ((l_pending).bit_and (4)).to_boolean then
							(create {P_GLOBALS_STATIC}).need_rethrow.item := 1
							update_class_fields -- Current might have been changed; synchronize
						end
						if ((l_pending).bit_and (4)).to_boolean then
							l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).current_exception.item)
						else
							l_tmp := create {CE_VOID_POINTER}.make_shared (default_pointer)
						end
						(create {P_EX_EVAL_STATIC}).report_resume_pending (l_pending, l_tmp)
						update_class_fields -- Current might have been changed; synchronize
				when 8 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pending := a_other.pending
			exception := a_other.exception
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pending = a_other.pending and
				exception.is_equal (a_other.exception)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pending"),
					create {CE_STRUCTURE_FIELD}.make ("exception")
				>>)
			init_structure_info
		end

end
