class
	PD_COMPL_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_COMPL_S]} cp_next.make
			create {CE_CLASS_POINTER [PD_COMPL_S]} cp_prev.make
			create {CE_NATURAL_8_POINTER} cp_str.make
			create {CE_POINTER_ARRAY [NATURAL_8]} cp_text.make (<<4>>)
			create {CE_NATURAL_8_POINTER} cp_fname.make
			Precursor
		end

feature {ANY} -- fields

	cp_next: CE_POINTER [PD_COMPL_S] assign set_cp_next

	cp_prev: CE_POINTER [PD_COMPL_S] assign set_cp_prev

	cp_str: CE_POINTER [NATURAL_8] assign set_cp_str

	cp_icase: INTEGER_8 assign set_cp_icase

	cp_text: CE_ARRAY [CE_POINTER [NATURAL_8]]

	cp_fname: CE_POINTER [NATURAL_8] assign set_cp_fname

	cp_flags: INTEGER_32 assign set_cp_flags

	cp_number: INTEGER_32 assign set_cp_number

feature {ANY} -- field setters

	set_cp_next (a_cp_next: CE_POINTER [PD_COMPL_S])
		do
			cp_next := a_cp_next
			update_memory_field ("cp_next")
		end

	set_cp_prev (a_cp_prev: CE_POINTER [PD_COMPL_S])
		do
			cp_prev := a_cp_prev
			update_memory_field ("cp_prev")
		end

	set_cp_str (a_cp_str: CE_POINTER [NATURAL_8])
		do
			cp_str := a_cp_str
			update_memory_field ("cp_str")
		end

	set_cp_icase (a_cp_icase: INTEGER_8)
		do
			cp_icase := a_cp_icase
			update_memory_field ("cp_icase")
		end

	set_cp_fname (a_cp_fname: CE_POINTER [NATURAL_8])
		do
			cp_fname := a_cp_fname
			update_memory_field ("cp_fname")
		end

	set_cp_flags (a_cp_flags: INTEGER_32)
		do
			cp_flags := a_cp_flags
			update_memory_field ("cp_flags")
		end

	set_cp_number (a_cp_number: INTEGER_32)
		do
			cp_number := a_cp_number
			update_memory_field ("cp_number")
		end

feature {ANY} -- public routines

	ins_compl_equal (a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			if cp_icase.to_boolean then
				l_tmp := strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (cp_str), create {CE_INTEGER_8_POINTER}.make_cast (a_str___1), a_len.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				Result := (l_tmp = 0).to_integer
				l_return := True
			end
			if not l_return then
				l_tmp___0 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (cp_str), create {CE_INTEGER_8_POINTER}.make_cast (a_str___1), a_len.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				Result := (l_tmp___0 = 0).to_integer
			end
		end

	ins_compl_longest_match
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_c1: INTEGER_32
			l_c2: INTEGER_32
			l_had_match: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_break: BOOLEAN
		do
			if ((create {P_EDIT_STATIC}).compl_leader.item).is_void then
				(create {P_EDIT_STATIC}).compl_leader.item := (create {P_MISC2_STATIC}).vim_strsave (cp_str)
				update_class_fields -- Current might have been changed; synchronize
				if not ((create {P_EDIT_STATIC}).compl_leader.item).is_void then
					l_had_match := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > (create {P_EDIT_STATIC}).compl_col.item).to_integer;
					(create {P_EDIT_STATIC}).ins_compl_delete
					update_class_fields -- Current might have been changed; synchronize
					l_tmp := (create {P_EDIT_STATIC}).ins_compl_len
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MISC1_STATIC}).ins_bytes ((create {P_EDIT_STATIC}).compl_leader.item + l_tmp)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_EDIT_STATIC}).ins_redraw (0)
					update_class_fields -- Current might have been changed; synchronize
					if not l_had_match.to_boolean then
						(create {P_EDIT_STATIC}).ins_compl_delete
						update_class_fields -- Current might have been changed; synchronize
					end
					(create {P_EDIT_STATIC}).compl_used_match.item := 0
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				l_p___0 := (create {P_EDIT_STATIC}).compl_leader.item
				l_s := cp_str
				from
				until
					not (not (l_break) and then ((l_p___0.item).to_integer_32 /= 0))
				loop
					l_break := False
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_c1 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0])
						update_class_fields -- Current might have been changed; synchronize
						l_c2 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_s])
						update_class_fields -- Current might have been changed; synchronize
					else
						l_c1 := (l_p___0.item).to_integer_32
						l_c2 := (l_s.item).to_integer_32
					end
					if cp_icase.to_boolean then
						l_tmp___0 := (create {P_CHARSET_STATIC}).vim_tolower (l_c1)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := (create {P_CHARSET_STATIC}).vim_tolower (l_c2)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := (l_tmp___0 /= l_tmp___1).to_integer
					else
						l_tmp___2 := (l_c1 /= l_c2).to_integer
					end
					if l_tmp___2.to_boolean then
						l_break := True
					end
					if not (l_break) then
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___3 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___4 := l_tmp___3
							else
								l_tmp___4 := 1
							end
							l_p___0 := l_p___0 + l_tmp___4
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___5 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s])
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___6 := l_tmp___5
							else
								l_tmp___6 := 1
							end
							l_s := l_s + l_tmp___6
						else
							l_p___0 := l_p___0 + 1
							l_s := l_s + 1
						end
					end
				end
				l_break := False
				if (l_p___0.item).to_integer_32 /= 0 then
					l_p___0.item := (('%/0/').code).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					l_had_match := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > (create {P_EDIT_STATIC}).compl_col.item).to_integer;
					(create {P_EDIT_STATIC}).ins_compl_delete
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___7 := (create {P_EDIT_STATIC}).ins_compl_len
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MISC1_STATIC}).ins_bytes ((create {P_EDIT_STATIC}).compl_leader.item + l_tmp___7)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_EDIT_STATIC}).ins_redraw (0)
					update_class_fields -- Current might have been changed; synchronize
					if not l_had_match.to_boolean then
						(create {P_EDIT_STATIC}).ins_compl_delete
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				(create {P_EDIT_STATIC}).compl_used_match.item := 0
				update_class_fields -- Current might have been changed; synchronize
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			cp_next := a_other.cp_next
			cp_prev := a_other.cp_prev
			cp_str := a_other.cp_str
			cp_icase := a_other.cp_icase
			cp_text := a_other.cp_text.twin
			cp_fname := a_other.cp_fname
			cp_flags := a_other.cp_flags
			cp_number := a_other.cp_number
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				cp_next.is_equal (a_other.cp_next) and
				cp_prev.is_equal (a_other.cp_prev) and
				cp_str.is_equal (a_other.cp_str) and
				cp_icase = a_other.cp_icase and
				cp_text.is_equal (a_other.cp_text) and
				cp_fname.is_equal (a_other.cp_fname) and
				cp_flags = a_other.cp_flags and
				cp_number = a_other.cp_number
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("cp_next"),
					create {CE_STRUCTURE_FIELD}.make ("cp_prev"),
					create {CE_STRUCTURE_FIELD}.make ("cp_str"),
					create {CE_STRUCTURE_FIELD}.make ("cp_icase"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cp_text", <<4>>),
					create {CE_STRUCTURE_FIELD}.make ("cp_fname"),
					create {CE_STRUCTURE_FIELD}.make ("cp_flags"),
					create {CE_STRUCTURE_FIELD}.make ("cp_number")
				>>)
			init_structure_info
		end

end
