class
	PD_DIFFBLOCK_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_DIFFBLOCK_S]} df_next.make
			create {CE_INTEGER_32_ARRAY} df_lnum.make (<<4>>)
			create {CE_INTEGER_32_ARRAY} df_count.make (<<4>>)
		end

feature {ANY} -- fields

	df_next: CE_POINTER [PD_DIFFBLOCK_S] assign set_df_next

	df_lnum: CE_ARRAY [INTEGER_32]

	df_count: CE_ARRAY [INTEGER_32]

feature {ANY} -- field setters

	set_df_next (a_df_next: CE_POINTER [PD_DIFFBLOCK_S])
		do
			df_next := a_df_next
			update_memory_field ("df_next")
		end

feature {ANY} -- public routines

	diff_equal_entry (a_idx1, a_idx2: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_cmp: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			if df_count[a_idx1] /= df_count[a_idx2] then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_tmp := (create {P_DIFF_STATIC}).diff_check_sanity ((create {P_GLOBALS_STATIC}).curtab.item, (create {CE_CLASS_POINTER [PD_DIFFBLOCK_S]}.make_shared (c_pointer)))
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp = 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_i___0 := 0
				from
				until
					not (not (l_return) and then (l_i___0.to_integer_32 < df_count[a_idx1]))
				loop
					l_tmp___0 := ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[a_idx1]).item.ml_get_buf (df_lnum[a_idx1] + l_i___0.to_integer_32, 0)
					update_class_fields -- Current might have been changed; synchronize
					l_line := (create {P_MISC2_STATIC}).vim_strsave (l_tmp___0)
					update_class_fields -- Current might have been changed; synchronize
					if l_line.is_void then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_tmp___1 := ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[a_idx2]).item.ml_get_buf (df_lnum[a_idx2] + l_i___0.to_integer_32, 0)
						update_class_fields -- Current might have been changed; synchronize
						l_cmp := (create {P_DIFF_STATIC}).diff_cmp (l_line, l_tmp___1)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_line))
						update_class_fields -- Current might have been changed; synchronize
						if l_cmp /= 0 then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not l_return then
				Result := 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			df_next := a_other.df_next
			df_lnum := a_other.df_lnum.twin
			df_count := a_other.df_count.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				df_next.is_equal (a_other.df_next) and
				df_lnum.is_equal (a_other.df_lnum) and
				df_count.is_equal (a_other.df_count)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("df_next"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("df_lnum", <<4>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("df_count", <<4>>)
				>>)
			init_structure_info
		end

end
