class
	PD_ENC_CANON_TABLE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} name.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	prop: INTEGER_32 assign set_prop

	codepage: INTEGER_32 assign set_codepage

feature {ANY} -- field setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_prop (a_prop: INTEGER_32)
		do
			prop := a_prop
			update_memory_field ("prop")
		end

	set_codepage (a_codepage: INTEGER_32)
		do
			codepage := a_codepage
			update_memory_field ("codepage")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			prop := a_other.prop
			codepage := a_other.codepage
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				prop = a_other.prop and
				codepage = a_other.codepage
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("prop"),
					create {CE_STRUCTURE_FIELD}.make ("codepage")
				>>)
			init_structure_info
		end

end
