class
	PD_FF_STACK

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_FF_STACK]} ffs_prev.make
			create {CE_NATURAL_8_POINTER} ffs_fix_path.make
			create {CE_NATURAL_8_POINTER} ffs_wc_path.make
			create {CE_POINTER_POINTER [NATURAL_8]} ffs_filearray.make
		end

feature {ANY} -- fields

	ffs_prev: CE_POINTER [PD_FF_STACK] assign set_ffs_prev

	ffs_fix_path: CE_POINTER [NATURAL_8] assign set_ffs_fix_path

	ffs_wc_path: CE_POINTER [NATURAL_8] assign set_ffs_wc_path

	ffs_filearray: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_ffs_filearray

	ffs_filearray_size: INTEGER_32 assign set_ffs_filearray_size

	ffs_filearray_cur: NATURAL_8 assign set_ffs_filearray_cur

	ffs_stage: INTEGER_32 assign set_ffs_stage

	ffs_level: INTEGER_32 assign set_ffs_level

	ffs_star_star_empty: INTEGER_32 assign set_ffs_star_star_empty

feature {ANY} -- field setters

	set_ffs_prev (a_ffs_prev: CE_POINTER [PD_FF_STACK])
		do
			ffs_prev := a_ffs_prev
			update_memory_field ("ffs_prev")
		end

	set_ffs_fix_path (a_ffs_fix_path: CE_POINTER [NATURAL_8])
		do
			ffs_fix_path := a_ffs_fix_path
			update_memory_field ("ffs_fix_path")
		end

	set_ffs_wc_path (a_ffs_wc_path: CE_POINTER [NATURAL_8])
		do
			ffs_wc_path := a_ffs_wc_path
			update_memory_field ("ffs_wc_path")
		end

	set_ffs_filearray (a_ffs_filearray: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			ffs_filearray := a_ffs_filearray
			update_memory_field ("ffs_filearray")
		end

	set_ffs_filearray_size (a_ffs_filearray_size: INTEGER_32)
		do
			ffs_filearray_size := a_ffs_filearray_size
			update_memory_field ("ffs_filearray_size")
		end

	set_ffs_filearray_cur (a_ffs_filearray_cur: NATURAL_8)
		do
			ffs_filearray_cur := a_ffs_filearray_cur
			update_memory_field ("ffs_filearray_cur")
		end

	set_ffs_stage (a_ffs_stage: INTEGER_32)
		do
			ffs_stage := a_ffs_stage
			update_memory_field ("ffs_stage")
		end

	set_ffs_level (a_ffs_level: INTEGER_32)
		do
			ffs_level := a_ffs_level
			update_memory_field ("ffs_level")
		end

	set_ffs_star_star_empty (a_ffs_star_star_empty: INTEGER_32)
		do
			ffs_star_star_empty := a_ffs_star_star_empty
			update_memory_field ("ffs_star_star_empty")
		end

feature {ANY} -- public routines

	ff_free_stack_element
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (ffs_fix_path))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (ffs_wc_path))
			update_class_fields -- Current might have been changed; synchronize
			if not ffs_filearray.is_void then
				(create {P_MISC1_STATIC}).FreeWild (ffs_filearray_size, ffs_filearray)
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ffs_prev := a_other.ffs_prev
			ffs_fix_path := a_other.ffs_fix_path
			ffs_wc_path := a_other.ffs_wc_path
			ffs_filearray := a_other.ffs_filearray
			ffs_filearray_size := a_other.ffs_filearray_size
			ffs_filearray_cur := a_other.ffs_filearray_cur
			ffs_stage := a_other.ffs_stage
			ffs_level := a_other.ffs_level
			ffs_star_star_empty := a_other.ffs_star_star_empty
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ffs_prev.is_equal (a_other.ffs_prev) and
				ffs_fix_path.is_equal (a_other.ffs_fix_path) and
				ffs_wc_path.is_equal (a_other.ffs_wc_path) and
				ffs_filearray.is_equal (a_other.ffs_filearray) and
				ffs_filearray_size = a_other.ffs_filearray_size and
				ffs_filearray_cur = a_other.ffs_filearray_cur and
				ffs_stage = a_other.ffs_stage and
				ffs_level = a_other.ffs_level and
				ffs_star_star_empty = a_other.ffs_star_star_empty
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ffs_prev"),
					create {CE_STRUCTURE_FIELD}.make ("ffs_fix_path"),
					create {CE_STRUCTURE_FIELD}.make ("ffs_wc_path"),
					create {CE_STRUCTURE_FIELD}.make ("ffs_filearray"),
					create {CE_STRUCTURE_FIELD}.make ("ffs_filearray_size"),
					create {CE_STRUCTURE_FIELD}.make ("ffs_filearray_cur"),
					create {CE_STRUCTURE_FIELD}.make ("ffs_stage"),
					create {CE_STRUCTURE_FIELD}.make ("ffs_level"),
					create {CE_STRUCTURE_FIELD}.make ("ffs_star_star_empty")
				>>)
			init_structure_info
		end

end
