class
	PD_FILEMARK

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create mark.make
		end

feature {ANY} -- fields

	mark: PD_POS_T assign set_mark

	fnum: INTEGER_32 assign set_fnum

feature {ANY} -- field setters

	set_mark (a_mark: PD_POS_T)
		do
			mark := a_mark
			update_memory_field ("mark")
		end

	set_fnum (a_fnum: INTEGER_32)
		do
			fnum := a_fnum
			update_memory_field ("fnum")
		end

feature {ANY} -- public routines

	fm_getname (a_lead_len: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			if fnum = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum then
				l_tmp := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (c_pointer + (create {PD_FILEMARK}.make).offset_of ("mark"))).item.mark_line (a_lead_len)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp
				l_return := True
			end
			if not l_return then
				l_tmp___0 := (create {P_BUFFER_STATIC}).buflist_nr2name (fnum, 0, 1)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___0
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mark := a_other.mark.twin
			fnum := a_other.fnum
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mark.is_equal (a_other.mark) and
				fnum = a_other.fnum
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("mark"),
					create {CE_STRUCTURE_FIELD}.make ("fnum")
				>>)
			init_structure_info
		end

end
