class
	PD_FRAME_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_FRAME_S]} fr_parent.make
			create {CE_CLASS_POINTER [PD_FRAME_S]} fr_next.make
			create {CE_CLASS_POINTER [PD_FRAME_S]} fr_prev.make
			create {CE_CLASS_POINTER [PD_FRAME_S]} fr_child.make
			create {CE_CLASS_POINTER [PD_WINDOW_S]} fr_win.make
			Precursor
		end

feature {ANY} -- fields

	fr_layout: INTEGER_8 assign set_fr_layout

	fr_width: INTEGER_32 assign set_fr_width

	fr_newwidth: INTEGER_32 assign set_fr_newwidth

	fr_height: INTEGER_32 assign set_fr_height

	fr_newheight: INTEGER_32 assign set_fr_newheight

	fr_parent: CE_POINTER [PD_FRAME_S] assign set_fr_parent

	fr_next: CE_POINTER [PD_FRAME_S] assign set_fr_next

	fr_prev: CE_POINTER [PD_FRAME_S] assign set_fr_prev

	fr_child: CE_POINTER [PD_FRAME_S] assign set_fr_child

	fr_win: CE_POINTER [PD_WINDOW_S] assign set_fr_win

feature {ANY} -- field setters

	set_fr_layout (a_fr_layout: INTEGER_8)
		do
			fr_layout := a_fr_layout
			update_memory_field ("fr_layout")
		end

	set_fr_width (a_fr_width: INTEGER_32)
		do
			fr_width := a_fr_width
			update_memory_field ("fr_width")
		end

	set_fr_newwidth (a_fr_newwidth: INTEGER_32)
		do
			fr_newwidth := a_fr_newwidth
			update_memory_field ("fr_newwidth")
		end

	set_fr_height (a_fr_height: INTEGER_32)
		do
			fr_height := a_fr_height
			update_memory_field ("fr_height")
		end

	set_fr_newheight (a_fr_newheight: INTEGER_32)
		do
			fr_newheight := a_fr_newheight
			update_memory_field ("fr_newheight")
		end

	set_fr_parent (a_fr_parent: CE_POINTER [PD_FRAME_S])
		do
			fr_parent := a_fr_parent
			update_memory_field ("fr_parent")
		end

	set_fr_next (a_fr_next: CE_POINTER [PD_FRAME_S])
		do
			fr_next := a_fr_next
			update_memory_field ("fr_next")
		end

	set_fr_prev (a_fr_prev: CE_POINTER [PD_FRAME_S])
		do
			fr_prev := a_fr_prev
			update_memory_field ("fr_prev")
		end

	set_fr_child (a_fr_child: CE_POINTER [PD_FRAME_S])
		do
			fr_child := a_fr_child
			update_memory_field ("fr_child")
		end

	set_fr_win (a_fr_win: CE_POINTER [PD_WINDOW_S])
		do
			fr_win := a_fr_win
			update_memory_field ("fr_win")
		end

feature {ANY} -- public routines

	frame_has_win (a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_p___0: CE_POINTER [PD_FRAME_S]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			if fr_layout.to_integer_32 = 0 then
				Result := (fr_win.is_equal (a_wp___0)).to_integer
				l_return := True
			end
			if not l_return then
				l_p___0 := fr_child
				from
				until
					not (not (l_return) and then (not l_p___0.is_void))
				loop
					l_tmp := l_p___0.item.frame_has_win (a_wp___0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						Result := 1
						l_return := True
					end
					if not l_return then
						l_p___0 := l_p___0.item.fr_next
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	frame_new_height (a_height, a_topfirst, a_wfh: INTEGER_32)
		local
			l_height: INTEGER_32
			l_frp: CE_POINTER [PD_FRAME_S]
			l_extra_lines: INTEGER_32
			l_h: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_height := a_height
			if not fr_win.is_void then
				fr_win.item.win_new_height (l_height - fr_win.item.w_status_height)
				update_class_fields -- Current might have been changed; synchronize
			elseif fr_layout.to_integer_32 = 1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_frp := fr_child
					from
					until
						not (not (l_break) and then (not l_frp.is_void))
					loop
						l_break := False
						l_frp.item.frame_new_height (l_height, a_topfirst, a_wfh)
						update_class_fields -- Current might have been changed; synchronize
						if l_frp.item.fr_height > l_height then
							l_height := l_frp.item.fr_height
							l_break := True
						end
						if not (l_break) then
							l_frp := l_frp.item.fr_next
						end
					end
					l_break := False
					if l_frp.is_void then
						l_break := True
					end
				end
				l_break := False
			else
				l_frp := fr_child
				if a_wfh.to_boolean then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_tmp := (create {P_WINDOW_STATIC}).frame_fixed_height (l_frp)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp.to_boolean then
							l_break := True
						end
						if not (l_return or l_break) then
							l_frp := l_frp.item.fr_next
							if l_frp.is_void then
								l_return := True
							end
						end
					end
					if not l_return then
						l_break := False
					end
				end
				if not l_return then
					if not a_topfirst.to_boolean then
						from
						until
							(l_frp.item.fr_next).is_void
						loop
							l_frp := l_frp.item.fr_next
						end
						if a_wfh.to_boolean then
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___0 := (create {P_WINDOW_STATIC}).frame_fixed_height (l_frp)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___0.to_boolean then
									l_break := True
								end
								if not (l_return or l_break) then
									l_frp := l_frp.item.fr_prev
								end
							end
							l_break := False
						end
					end
					l_extra_lines := l_height - fr_height
					if l_extra_lines < 0 then
						from
						until
							not (not (l_return or l_break) and then (not l_frp.is_void))
						loop
							l_break := False
							l_h := l_frp.item.frame_minheight (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
							if l_frp.item.fr_height + l_extra_lines < l_h then
								l_extra_lines := l_extra_lines + (l_frp.item.fr_height - l_h)
								l_frp.item.frame_new_height (l_h, a_topfirst, a_wfh)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_frp.item.frame_new_height (l_frp.item.fr_height + l_extra_lines, a_topfirst, a_wfh)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							if not (l_return or l_break) then
								if a_topfirst.to_boolean then
									from
									until
										(l_break)
									loop
										l_break := False
										l_frp := l_frp.item.fr_next
										if a_wfh.to_boolean then
											if not l_frp.is_void then
												l_tmp___1 := (create {P_WINDOW_STATIC}).frame_fixed_height (l_frp)
												update_class_fields -- Current might have been changed; synchronize
												if not l_tmp___1.to_boolean then
													l_break := True
												end
											else
												l_break := True
											end
										else
											l_break := True
										end
									end
									l_break := False
								else
									from
									until
										(l_break)
									loop
										l_break := False
										l_frp := l_frp.item.fr_prev
										if a_wfh.to_boolean then
											if not l_frp.is_void then
												l_tmp___2 := (create {P_WINDOW_STATIC}).frame_fixed_height (l_frp)
												update_class_fields -- Current might have been changed; synchronize
												if not l_tmp___2.to_boolean then
													l_break := True
												end
											else
												l_break := True
											end
										else
											l_break := True
										end
									end
									l_break := False
								end
								if l_frp.is_void then
									l_height := l_height - l_extra_lines
								end
							end
						end
						l_break := False
					elseif l_extra_lines > 0 then
						l_frp.item.frame_new_height (l_frp.item.fr_height + l_extra_lines, a_topfirst, a_wfh)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				Current.fr_height := l_height
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	frame_new_width (a_width, a_leftfirst, a_wfw: INTEGER_32)
		local
			l_width: INTEGER_32
			l_frp: CE_POINTER [PD_FRAME_S]
			l_extra_cols: INTEGER_32
			l_w: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_width := a_width
			if fr_layout.to_integer_32 = 0 then
				l_wp___0 := fr_win
				l_frp := (create {CE_CLASS_POINTER [PD_FRAME_S]}.make_shared (c_pointer))
				from
				until
					not (not (l_break) and then (not (l_frp.item.fr_parent).is_void))
				loop
					l_break := False
					if ((l_frp.item.fr_parent).item.fr_layout).to_integer_32 = 1 then
						if not (l_frp.item.fr_next).is_void then
							l_break := True
						end
					end
					if not (l_break) then
						l_frp := l_frp.item.fr_parent
					end
				end
				l_break := False
				if (l_frp.item.fr_parent).is_void then
					l_wp___0.item.w_vsep_width := 0
					update_class_fields -- Current might have been changed; synchronize
				end
				l_wp___0.item.win_new_width (l_width - l_wp___0.item.w_vsep_width)
				update_class_fields -- Current might have been changed; synchronize
			elseif fr_layout.to_integer_32 = 2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_frp := fr_child
					from
					until
						not (not (l_break) and then (not l_frp.is_void))
					loop
						l_break := False
						l_frp.item.frame_new_width (l_width, a_leftfirst, a_wfw)
						update_class_fields -- Current might have been changed; synchronize
						if l_frp.item.fr_width > l_width then
							l_width := l_frp.item.fr_width
							l_break := True
						end
						if not (l_break) then
							l_frp := l_frp.item.fr_next
						end
					end
					l_break := False
					if l_frp.is_void then
						l_break := True
					end
				end
				l_break := False
			else
				l_frp := fr_child
				if a_wfw.to_boolean then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_tmp := (create {P_WINDOW_STATIC}).frame_fixed_width (l_frp)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp.to_boolean then
							l_break := True
						end
						if not (l_return or l_break) then
							l_frp := l_frp.item.fr_next
							if l_frp.is_void then
								l_return := True
							end
						end
					end
					if not l_return then
						l_break := False
					end
				end
				if not l_return then
					if not a_leftfirst.to_boolean then
						from
						until
							(l_frp.item.fr_next).is_void
						loop
							l_frp := l_frp.item.fr_next
						end
						if a_wfw.to_boolean then
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___0 := (create {P_WINDOW_STATIC}).frame_fixed_width (l_frp)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___0.to_boolean then
									l_break := True
								end
								if not (l_return or l_break) then
									l_frp := l_frp.item.fr_prev
								end
							end
							l_break := False
						end
					end
					l_extra_cols := l_width - fr_width
					if l_extra_cols < 0 then
						from
						until
							not (not (l_return or l_break) and then (not l_frp.is_void))
						loop
							l_break := False
							l_w := l_frp.item.frame_minwidth (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
							if l_frp.item.fr_width + l_extra_cols < l_w then
								l_extra_cols := l_extra_cols + (l_frp.item.fr_width - l_w)
								l_frp.item.frame_new_width (l_w, a_leftfirst, a_wfw)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_frp.item.frame_new_width (l_frp.item.fr_width + l_extra_cols, a_leftfirst, a_wfw)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							if not (l_return or l_break) then
								if a_leftfirst.to_boolean then
									from
									until
										(l_break)
									loop
										l_break := False
										l_frp := l_frp.item.fr_next
										if a_wfw.to_boolean then
											if not l_frp.is_void then
												l_tmp___1 := (create {P_WINDOW_STATIC}).frame_fixed_width (l_frp)
												update_class_fields -- Current might have been changed; synchronize
												if not l_tmp___1.to_boolean then
													l_break := True
												end
											else
												l_break := True
											end
										else
											l_break := True
										end
									end
									l_break := False
								else
									from
									until
										(l_break)
									loop
										l_break := False
										l_frp := l_frp.item.fr_prev
										if a_wfw.to_boolean then
											if not l_frp.is_void then
												l_tmp___2 := (create {P_WINDOW_STATIC}).frame_fixed_width (l_frp)
												update_class_fields -- Current might have been changed; synchronize
												if not l_tmp___2.to_boolean then
													l_break := True
												end
											else
												l_break := True
											end
										else
											l_break := True
										end
									end
									l_break := False
								end
								if l_frp.is_void then
									l_width := l_width - l_extra_cols
								end
							end
						end
						l_break := False
					elseif l_extra_cols > 0 then
						l_frp.item.frame_new_width (l_frp.item.fr_width + l_extra_cols, a_leftfirst, a_wfw)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				Current.fr_width := l_width
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	frame_minheight (a_next_curwin: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_frp: CE_POINTER [PD_FRAME_S]
			l_m: INTEGER_32
			l_n: INTEGER_32
			l_tmp: INTEGER_32
		do
			if not fr_win.is_void then
				if fr_win.is_equal (a_next_curwin) then
					l_m := ((create {P_OPTION_STATIC}).p_wh.item.item + (fr_win.item.w_status_height).to_integer_32).to_integer_32
				else
					l_m := ((create {P_OPTION_STATIC}).p_wmh.item.item + (fr_win.item.w_status_height).to_integer_32).to_integer_32
					if (create {P_OPTION_STATIC}).p_wmh.item.item = 0 then
						if fr_win.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
							if a_next_curwin.is_void then
								l_m := l_m + 1
							end
						end
					end
				end
			elseif fr_layout.to_integer_32 = 1 then
				l_m := 0
				l_frp := fr_child
				from
				until
					l_frp.is_void
				loop
					l_n := l_frp.item.frame_minheight (a_next_curwin)
					update_class_fields -- Current might have been changed; synchronize
					if l_n > l_m then
						l_m := l_n
					end
					l_frp := l_frp.item.fr_next
				end
			else
				l_m := 0
				l_frp := fr_child
				from
				until
					l_frp.is_void
				loop
					l_tmp := l_frp.item.frame_minheight (a_next_curwin)
					update_class_fields -- Current might have been changed; synchronize
					l_m := l_m + l_tmp
					l_frp := l_frp.item.fr_next
				end
			end
			Result := l_m
		end

	frame_minwidth (a_next_curwin: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_frp: CE_POINTER [PD_FRAME_S]
			l_m: INTEGER_32
			l_n: INTEGER_32
			l_tmp: INTEGER_32
		do
			if not fr_win.is_void then
				if fr_win.is_equal (a_next_curwin) then
					l_m := ((create {P_OPTION_STATIC}).p_wiw.item.item + (fr_win.item.w_vsep_width).to_integer_32).to_integer_32
				else
					l_m := ((create {P_OPTION_STATIC}).p_wmw.item.item + (fr_win.item.w_vsep_width).to_integer_32).to_integer_32
					if (create {P_OPTION_STATIC}).p_wmw.item.item = 0 then
						if fr_win.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
							if a_next_curwin.is_void then
								l_m := l_m + 1
							end
						end
					end
				end
			elseif fr_layout.to_integer_32 = 2 then
				l_m := 0
				l_frp := fr_child
				from
				until
					l_frp.is_void
				loop
					l_n := l_frp.item.frame_minwidth (a_next_curwin)
					update_class_fields -- Current might have been changed; synchronize
					if l_n > l_m then
						l_m := l_n
					end
					l_frp := l_frp.item.fr_next
				end
			else
				l_m := 0
				l_frp := fr_child
				from
				until
					l_frp.is_void
				loop
					l_tmp := l_frp.item.frame_minwidth (a_next_curwin)
					update_class_fields -- Current might have been changed; synchronize
					l_m := l_m + l_tmp
					l_frp := l_frp.item.fr_next
				end
			end
			Result := l_m
		end

	frame_append (a_frp: CE_POINTER [PD_FRAME_S])
		require
			not a_frp.is_void
		do
			a_frp.item.fr_next := fr_next
			update_class_fields -- Current might have been changed; synchronize
			Current.fr_next := a_frp
			update_class_fields -- Current might have been changed; synchronize
			if not (a_frp.item.fr_next).is_void then
				(a_frp.item.fr_next).item.fr_prev := a_frp
				update_class_fields -- Current might have been changed; synchronize
			end
			a_frp.item.fr_prev := (create {CE_CLASS_POINTER [PD_FRAME_S]}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	frame_insert (a_frp: CE_POINTER [PD_FRAME_S])
		require
			not a_frp.is_void
		do
			a_frp.item.fr_next := (create {CE_CLASS_POINTER [PD_FRAME_S]}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
			a_frp.item.fr_prev := fr_prev
			update_class_fields -- Current might have been changed; synchronize
			Current.fr_prev := a_frp
			update_class_fields -- Current might have been changed; synchronize
			if not (a_frp.item.fr_prev).is_void then
				(a_frp.item.fr_prev).item.fr_next := a_frp
				update_class_fields -- Current might have been changed; synchronize
			else
				(a_frp.item.fr_parent).item.fr_child := a_frp
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	frame_remove
		do
			if not fr_prev.is_void then
				fr_prev.item.fr_next := fr_next
				update_class_fields -- Current might have been changed; synchronize
			else
				fr_parent.item.fr_child := fr_next
				update_class_fields -- Current might have been changed; synchronize
			end
			if not fr_next.is_void then
				fr_next.item.fr_prev := fr_prev
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	frame_comp_pos (a_row, a_col: CE_POINTER [INTEGER_32])
		require
			not a_row.is_void
			not a_col.is_void
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_frp: CE_POINTER [PD_FRAME_S]
			l_startcol: INTEGER_32
			l_startrow: INTEGER_32
		do
			l_wp___0 := fr_win
			if not l_wp___0.is_void then
				if l_wp___0.item.w_winrow /= a_row.item then
					l_wp___0.item.w_winrow := a_row.item
					update_class_fields -- Current might have been changed; synchronize
					l_wp___0.item.w_wincol := a_col.item
					update_class_fields -- Current might have been changed; synchronize
					l_wp___0.item.redraw_win_later (40)
					update_class_fields -- Current might have been changed; synchronize
					l_wp___0.item.w_redr_status := 1
					update_class_fields -- Current might have been changed; synchronize
				elseif l_wp___0.item.w_wincol /= a_col.item then
					l_wp___0.item.w_winrow := a_row.item
					update_class_fields -- Current might have been changed; synchronize
					l_wp___0.item.w_wincol := a_col.item
					update_class_fields -- Current might have been changed; synchronize
					l_wp___0.item.redraw_win_later (40)
					update_class_fields -- Current might have been changed; synchronize
					l_wp___0.item.w_redr_status := 1
					update_class_fields -- Current might have been changed; synchronize
				end
				a_row.item := a_row.item + (l_wp___0.item.w_height + l_wp___0.item.w_status_height)
				update_class_fields -- Current might have been changed; synchronize
				a_col.item := a_col.item + (l_wp___0.item.w_width + l_wp___0.item.w_vsep_width)
				update_class_fields -- Current might have been changed; synchronize
			else
				l_startrow := a_row.item
				l_startcol := a_col.item
				l_frp := fr_child
				from
				until
					l_frp.is_void
				loop
					if fr_layout.to_integer_32 = 1 then
						a_row.item := l_startrow
						update_class_fields -- Current might have been changed; synchronize
					else
						a_col.item := l_startcol
						update_class_fields -- Current might have been changed; synchronize
					end
					l_frp.item.frame_comp_pos (a_row, a_col)
					update_class_fields -- Current might have been changed; synchronize
					l_frp := l_frp.item.fr_next
				end
			end
		end

	frame_setwidth (a_width: INTEGER_32)
		local
			l_width: INTEGER_32
			l_room: INTEGER_32
			l_take: INTEGER_32
			l_run: INTEGER_32
			l_frp: CE_POINTER [PD_FRAME_S]
			l_w: INTEGER_32
			l_room_reserved: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_width := a_width
					if fr_width = l_width then
						l_return := True
					end
					if not l_return and then (fr_parent.is_void) then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 25 -- skip if block
					end
				when 1 then -- if:
						if (fr_parent.item.fr_layout).to_integer_32 /= 2 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_w := fr_parent.item.frame_minwidth (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if l_width < l_w then
							l_width := l_w
						end
						fr_parent.item.frame_setwidth (l_width)
						update_class_fields -- Current might have been changed; synchronize
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 4 then -- else:
						l_run := 1
				when 5 then -- loop condition:
						if not (not (l_return or l_break) and then (l_run <= 2)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						l_room := 0
						l_room_reserved := 0
						l_frp := fr_parent.item.fr_child
						from
						until
							l_frp.is_void
						loop
							if not (l_frp.c_pointer = c_pointer) then
								if not (l_frp.item.fr_win).is_void then
									if ((l_frp.item.fr_win).item.w_onebuf_opt.wo_wfw).to_boolean then
										l_room_reserved := l_room_reserved + (l_frp.item.fr_width)
									end
								end
							end
							l_room := l_room + (l_frp.item.fr_width)
							if not (l_frp.c_pointer = c_pointer) then
								l_tmp := l_frp.item.frame_minwidth (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
								l_room := l_room - l_tmp
							end
							l_frp := l_frp.item.fr_next
						end
						if l_width <= l_room then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if l_run /= 2 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						l_tmp___0 := (create {P_WINDOW_STATIC}).tabline_height
						update_class_fields -- Current might have been changed; synchronize
						if not (fr_height.to_integer_32 >= ((create {P_GLOBALS_STATIC}).Rows.item.item - (create {P_OPTION_STATIC}).p_ch.item.item) - l_tmp___0.to_integer_32) then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						if l_width > l_room then
							l_width := l_room
						end
						l_break := True
				when 12 then -- if done | if done
						if not (l_return or l_break) then
							l_tmp___1 := fr_parent.item.frame_minwidth (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer + -1))
							update_class_fields -- Current might have been changed; synchronize
							fr_parent.item.frame_setwidth (((l_width + l_tmp___1) - ((create {P_OPTION_STATIC}).p_wmw.item.item).to_integer_32) - 1)
							update_class_fields -- Current might have been changed; synchronize
							l_run := l_run + 1
						end
						l_pos := -1 + 5 -- back to loop condition
				when 13 then -- loop done
						l_break := False
						l_take := l_width - fr_width
						if l_width > l_room - l_room_reserved then
							l_room_reserved := l_room - l_width
						end
						if l_take < 0 then
							if l_room - fr_width < l_room_reserved then
								l_room_reserved := 0
							end
						end
						((create {CE_CLASS_POINTER [PD_FRAME_S]}.make_shared (c_pointer))).item.frame_new_width (l_width, 0, 0)
						update_class_fields -- Current might have been changed; synchronize
						l_run := 0
				when 14 then -- loop condition:
						if not (not (l_return) and then (l_run < 2)) then
							l_pos := -1 + 25 -- skip loop
						end
				when 15 then -- loop body:
						if l_run = 0 then
							l_frp := fr_next
						else
							l_frp := fr_prev
						end
				when 16 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 24 -- skip loop
						end
				when 17 then -- loop body:
						l_break := False
						if not l_frp.is_void then
							if l_take = 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 23 -- skip if block
						end
				when 18 then -- if:
						l_w := l_frp.item.frame_minwidth (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if not (l_room_reserved > 0) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if not (l_frp.item.fr_win).is_void then
							if ((l_frp.item.fr_win).item.w_onebuf_opt.wo_wfw).to_boolean then
								if l_room_reserved >= l_frp.item.fr_width then
									l_room_reserved := l_room_reserved - (l_frp.item.fr_width)
								else
									if l_frp.item.fr_width - l_room_reserved > l_take then
										l_room_reserved := l_frp.item.fr_width - l_take
									end
									l_take := l_take - (l_frp.item.fr_width - l_room_reserved)
									l_frp.item.frame_new_width (l_room_reserved, 0, 0)
									update_class_fields -- Current might have been changed; synchronize
									l_room_reserved := 0
								end
							else
								l_pos := -1 + 21 -- goto _L___1
							end
						else
							l_pos := -1 + 21 -- goto _L___1
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else: | _L___1:
						if l_frp.item.fr_width - l_take < l_w then
							l_take := l_take - (l_frp.item.fr_width - l_w)
							l_frp.item.frame_new_width (l_w, 0, 0)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_frp.item.frame_new_width (l_frp.item.fr_width - l_take, 0, 0)
							update_class_fields -- Current might have been changed; synchronize
							l_take := 0
						end
				when 22 then
						if l_run = 0 then
							l_frp := l_frp.item.fr_next
						else
							l_frp := l_frp.item.fr_prev
						end
				when 23 then -- if done
						l_pos := -1 + 16 -- back to loop condition
				when 24 then -- loop done
						l_break := False
						l_run := l_run + 1
						l_pos := -1 + 14 -- back to loop condition
				when 25 then -- loop done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	last_status_rec (a_statusline: INTEGER_32)
		local
			l_fp: CE_POINTER [PD_FRAME_S]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if fr_layout.to_integer_32 /= 0 then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_wp___0 := fr_win
						if l_wp___0.item.w_status_height = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not a_statusline.to_boolean then
							l_wp___0.item.win_new_height (l_wp___0.item.w_height + 1)
							update_class_fields -- Current might have been changed; synchronize
							l_wp___0.item.w_status_height := 0
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_OPTION_STATIC}).comp_col
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_wp___0.item.w_status_height = 0 then
							if a_statusline.to_boolean then
								l_fp := (create {CE_CLASS_POINTER [PD_FRAME_S]}.make_shared (c_pointer))
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_tmp___0 := l_fp.item.frame_minheight (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
									update_class_fields -- Current might have been changed; synchronize
									if not (l_fp.item.fr_height <= l_tmp___0) then
										l_break := True
									end
									if not (l_return or l_break) then
										if l_fp.is_equal ((create {P_GLOBALS_STATIC}).topframe.item) then
											l_tmp := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_noroom.item)))
											update_class_fields; -- Current might have been changed; synchronize
											(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
											update_class_fields -- Current might have been changed; synchronize
											l_return := True
										end
										if not l_return then
											if ((l_fp.item.fr_parent).item.fr_layout).to_integer_32 = 2 then
												if not (l_fp.item.fr_prev).is_void then
													l_fp := l_fp.item.fr_prev
												else
													l_fp := l_fp.item.fr_parent
												end
											else
												l_fp := l_fp.item.fr_parent
											end
										end
									end
								end
								if not l_return then
									l_break := False
									l_wp___0.item.w_status_height := 1
									update_class_fields -- Current might have been changed; synchronize
									if not (l_fp.c_pointer = c_pointer) then
										l_fp.item.frame_new_height (l_fp.item.fr_height - 1, 0, 0)
										update_class_fields -- Current might have been changed; synchronize
										l_wp___0.item.frame_fix_height
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_WINDOW_STATIC}).win_comp_pos.do_nothing
										update_class_fields -- Current might have been changed; synchronize
									else
										l_wp___0.item.win_new_height (l_wp___0.item.w_height - 1)
										update_class_fields -- Current might have been changed; synchronize
									end
									(create {P_OPTION_STATIC}).comp_col
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_SCREEN_STATIC}).redraw_all_later (35)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
				when 5 then -- if done | if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if fr_layout.to_integer_32 = 1 then
							l_fp := fr_child
							from
							until
								l_fp.is_void
							loop
								l_fp.item.last_status_rec (a_statusline)
								update_class_fields -- Current might have been changed; synchronize
								l_fp := l_fp.item.fr_next
							end
						else
							l_fp := fr_child
							from
							until
								(l_fp.item.fr_next).is_void
							loop
								l_fp := l_fp.item.fr_next
							end
							l_fp.item.last_status_rec (a_statusline)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 7 then
					if not l_return then
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	make_snapshot_rec (a_frp: CE_POINTER [CE_POINTER [PD_FRAME_S]])
		require
			not a_frp.is_void
		local
			l_tmp: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_tmp := (create {P_MISC2_STATIC}).alloc_clear ((create {PD_FRAME_S}.make).structure_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			a_frp.item := create {CE_CLASS_POINTER [PD_FRAME_S]}.make_cast (l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			if (a_frp.item).is_void then
				l_return := True
			end
			if not l_return then
				(a_frp.item).item.fr_layout := fr_layout
				update_class_fields; -- Current might have been changed; synchronize
				(a_frp.item).item.fr_width := fr_width
				update_class_fields; -- Current might have been changed; synchronize
				(a_frp.item).item.fr_height := fr_height
				update_class_fields -- Current might have been changed; synchronize
				if not fr_next.is_void then
					fr_next.item.make_snapshot_rec (create {CE_POINTER_POINTER [PD_FRAME_S]}.make_shared ((a_frp.item).c_pointer + (create {PD_FRAME_S}.make).offset_of ("fr_next")))
					update_class_fields -- Current might have been changed; synchronize
				end
				if not fr_child.is_void then
					fr_child.item.make_snapshot_rec (create {CE_POINTER_POINTER [PD_FRAME_S]}.make_shared ((a_frp.item).c_pointer + (create {PD_FRAME_S}.make).offset_of ("fr_child")))
					update_class_fields -- Current might have been changed; synchronize
				end
				if fr_layout.to_integer_32 = 0 then
					if fr_win.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
						(a_frp.item).item.fr_win := (create {P_GLOBALS_STATIC}).curwin.item
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
		end

	check_snapshot_rec (a_fr: CE_POINTER [PD_FRAME_S]): INTEGER_32
		require
			not a_fr.is_void
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if fr_layout.to_integer_32 = (a_fr.item.fr_layout).to_integer_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Result := 0
						l_return := True
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if (fr_next.is_void) = ((a_fr.item.fr_next).is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := 0
						l_return := True
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if (fr_child.is_void) = ((a_fr.item.fr_child).is_void) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						Result := 0
						l_return := True
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if fr_next.is_void then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_tmp := fr_next.item.check_snapshot_rec (a_fr.item.fr_next)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp = 0 then
							Result := 0
							l_return := True
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if not fr_child.is_void then
							l_tmp___0 := fr_child.item.check_snapshot_rec (a_fr.item.fr_child)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___0 = 0 then
								Result := 0
								l_return := True
							end
						end
				when 13 then -- if done | if done | if done
					if not l_return then
						Result := 1
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	restore_snapshot_rec (a_fr: CE_POINTER [PD_FRAME_S]): CE_POINTER [PD_WINDOW_S]
		require
			not a_fr.is_void
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_wp2: CE_POINTER [PD_WINDOW_S]
		do
			l_wp___0 := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
			a_fr.item.fr_height := fr_height
			update_class_fields -- Current might have been changed; synchronize
			a_fr.item.fr_width := fr_width
			update_class_fields -- Current might have been changed; synchronize
			if (a_fr.item.fr_layout).to_integer_32 = 0 then
				a_fr.item.frame_new_height (a_fr.item.fr_height, 0, 0)
				update_class_fields -- Current might have been changed; synchronize
				a_fr.item.frame_new_width (a_fr.item.fr_width, 0, 0)
				update_class_fields -- Current might have been changed; synchronize
				l_wp___0 := fr_win
			end
			if not fr_next.is_void then
				l_wp2 := fr_next.item.restore_snapshot_rec (a_fr.item.fr_next)
				update_class_fields -- Current might have been changed; synchronize
				if not l_wp2.is_void then
					l_wp___0 := l_wp2
				end
			end
			if not fr_child.is_void then
				l_wp2 := fr_child.item.restore_snapshot_rec (a_fr.item.fr_child)
				update_class_fields -- Current might have been changed; synchronize
				if not l_wp2.is_void then
					l_wp___0 := l_wp2
				end
			end
			Result := l_wp___0
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fr_layout := a_other.fr_layout
			fr_width := a_other.fr_width
			fr_newwidth := a_other.fr_newwidth
			fr_height := a_other.fr_height
			fr_newheight := a_other.fr_newheight
			fr_parent := a_other.fr_parent
			fr_next := a_other.fr_next
			fr_prev := a_other.fr_prev
			fr_child := a_other.fr_child
			fr_win := a_other.fr_win
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fr_layout = a_other.fr_layout and
				fr_width = a_other.fr_width and
				fr_newwidth = a_other.fr_newwidth and
				fr_height = a_other.fr_height and
				fr_newheight = a_other.fr_newheight and
				fr_parent.is_equal (a_other.fr_parent) and
				fr_next.is_equal (a_other.fr_next) and
				fr_prev.is_equal (a_other.fr_prev) and
				fr_child.is_equal (a_other.fr_child) and
				fr_win.is_equal (a_other.fr_win)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fr_layout"),
					create {CE_STRUCTURE_FIELD}.make ("fr_width"),
					create {CE_STRUCTURE_FIELD}.make ("fr_newwidth"),
					create {CE_STRUCTURE_FIELD}.make ("fr_height"),
					create {CE_STRUCTURE_FIELD}.make ("fr_newheight"),
					create {CE_STRUCTURE_FIELD}.make ("fr_parent"),
					create {CE_STRUCTURE_FIELD}.make ("fr_next"),
					create {CE_STRUCTURE_FIELD}.make ("fr_prev"),
					create {CE_STRUCTURE_FIELD}.make ("fr_child"),
					create {CE_STRUCTURE_FIELD}.make ("fr_win")
				>>)
			init_structure_info
		end

end
