class
	PD_FUNCDICT_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_DICTVAR_S]} fd_dict.make
			create {CE_NATURAL_8_POINTER} fd_newkey.make
			create {CE_CLASS_POINTER [PD_DICTITEM_S]} fd_di.make
		end

feature {ANY} -- fields

	fd_dict: CE_POINTER [PD_DICTVAR_S] assign set_fd_dict

	fd_newkey: CE_POINTER [NATURAL_8] assign set_fd_newkey

	fd_di: CE_POINTER [PD_DICTITEM_S] assign set_fd_di

feature {ANY} -- field setters

	set_fd_dict (a_fd_dict: CE_POINTER [PD_DICTVAR_S])
		do
			fd_dict := a_fd_dict
			update_memory_field ("fd_dict")
		end

	set_fd_newkey (a_fd_newkey: CE_POINTER [NATURAL_8])
		do
			fd_newkey := a_fd_newkey
			update_memory_field ("fd_newkey")
		end

	set_fd_di (a_fd_di: CE_POINTER [PD_DICTITEM_S])
		do
			fd_di := a_fd_di
			update_memory_field ("fd_di")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fd_dict := a_other.fd_dict
			fd_newkey := a_other.fd_newkey
			fd_di := a_other.fd_di
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fd_dict.is_equal (a_other.fd_dict) and
				fd_newkey.is_equal (a_other.fd_newkey) and
				fd_di.is_equal (a_other.fd_di)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fd_dict"),
					create {CE_STRUCTURE_FIELD}.make ("fd_newkey"),
					create {CE_STRUCTURE_FIELD}.make ("fd_di")
				>>)
			init_structure_info
		end

end
