class
	PD_HASHITEM_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} hi_key.make
		end

feature {ANY} -- fields

	hi_hash: NATURAL_32 assign set_hi_hash

	hi_key: CE_POINTER [NATURAL_8] assign set_hi_key

feature {ANY} -- field setters

	set_hi_hash (a_hi_hash: NATURAL_32)
		do
			hi_hash := a_hi_hash
			update_memory_field ("hi_hash")
		end

	set_hi_key (a_hi_key: CE_POINTER [NATURAL_8])
		do
			hi_key := a_hi_key
			update_memory_field ("hi_key")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			hi_hash := a_other.hi_hash
			hi_key := a_other.hi_key
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				hi_hash = a_other.hi_hash and
				hi_key.is_equal (a_other.hi_key)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("hi_hash"),
					create {CE_STRUCTURE_FIELD}.make ("hi_key")
				>>)
			init_structure_info
		end

end
