class
	PD_HASHTABLE_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_HASHITEM_S]} ht_array.make
			create {CE_CLASS_ARRAY [PD_HASHITEM_S]} ht_smallarray.make (<<16>>)
			Precursor
		end

feature {ANY} -- fields

	ht_mask: NATURAL_32 assign set_ht_mask

	ht_used: NATURAL_32 assign set_ht_used

	ht_filled: NATURAL_32 assign set_ht_filled

	ht_locked: INTEGER_32 assign set_ht_locked

	ht_error: INTEGER_32 assign set_ht_error

	ht_array: CE_POINTER [PD_HASHITEM_S] assign set_ht_array

	ht_smallarray: CE_ARRAY [PD_HASHITEM_S]

feature {ANY} -- field setters

	set_ht_mask (a_ht_mask: NATURAL_32)
		do
			ht_mask := a_ht_mask
			update_memory_field ("ht_mask")
		end

	set_ht_used (a_ht_used: NATURAL_32)
		do
			ht_used := a_ht_used
			update_memory_field ("ht_used")
		end

	set_ht_filled (a_ht_filled: NATURAL_32)
		do
			ht_filled := a_ht_filled
			update_memory_field ("ht_filled")
		end

	set_ht_locked (a_ht_locked: INTEGER_32)
		do
			ht_locked := a_ht_locked
			update_memory_field ("ht_locked")
		end

	set_ht_error (a_ht_error: INTEGER_32)
		do
			ht_error := a_ht_error
			update_memory_field ("ht_error")
		end

	set_ht_array (a_ht_array: CE_POINTER [PD_HASHITEM_S])
		do
			ht_array := a_ht_array
			update_memory_field ("ht_array")
		end

feature {ANY} -- public routines

	set_ref_in_ht (a_copyID: INTEGER_32)
		local
			l_todo: INTEGER_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
		do
			l_todo := ht_used.to_integer_32
			l_hi___1 := ht_array
			from
			until
				not (l_todo > 0)
			loop
				if not ((l_hi___1.item.hi_key).is_void) then
					if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
						l_todo := l_todo - 1;
						(create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared ((create {CE_CLASS_POINTER [PD_DICTITEM_S]}.make_cast ((l_hi___1.item.hi_key - (((create {P_EVAL_STATIC}).dumdi.item.item.di_key).distance ((create {CE_NATURAL_8_POINTER}.make_cast (((create {P_EVAL_STATIC}).dumdi.item)))))))).c_pointer + (create {PD_DICTITEM_S}.make).offset_of ("di_tv"))).item.set_ref_in_item (a_copyID)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_hi___1 := l_hi___1 + 1
			end
		end

	vars_clear_ext (a_free_val: INTEGER_32)
		local
			l_todo: INTEGER_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_v: CE_POINTER [PD_DICTITEM_S]
		do
			((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer))).item.hash_lock
			update_class_fields -- Current might have been changed; synchronize
			l_todo := ht_used.to_integer_32
			l_hi___1 := ht_array
			from
			until
				not (l_todo > 0)
			loop
				if not ((l_hi___1.item.hi_key).is_void) then
					if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
						l_todo := l_todo - 1
						l_v := create {CE_CLASS_POINTER [PD_DICTITEM_S]}.make_cast ((l_hi___1.item.hi_key - (((create {P_EVAL_STATIC}).dumdi.item.item.di_key).distance ((create {CE_NATURAL_8_POINTER}.make_cast (((create {P_EVAL_STATIC}).dumdi.item)))))))
						if a_free_val.to_boolean then
							(create {P_EVAL_STATIC}).clear_tv (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (l_v.c_pointer + (create {PD_DICTITEM_S}.make).offset_of ("di_tv")))
							update_class_fields -- Current might have been changed; synchronize
						end
						if (((l_v.item.di_flags).to_integer_32).bit_and (4)) = 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_v))
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				end
				l_hi___1 := l_hi___1 + 1
			end
			((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer))).item.hash_clear
			update_class_fields -- Current might have been changed; synchronize
			Current.ht_used := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
		end

	hash_init
		do
			memset (create {CE_VOID_POINTER}.make_shared (c_pointer), 0, (create {PD_HASHTABLE_S}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Current.ht_array := ht_smallarray
			update_class_fields -- Current might have been changed; synchronize
			Current.ht_mask := (15).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
		end

	hash_clear
		do
			if not ht_array.is_equal (ht_smallarray) then
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (ht_array))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	hash_clear_all (a_off___0: INTEGER_32)
		local
			l_todo: INTEGER_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
		do
			l_todo := ht_used.to_integer_32
			l_hi___1 := ht_array
			from
			until
				not (l_todo > 0)
			loop
				if not ((l_hi___1.item.hi_key).is_void) then
					if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((l_hi___1.item.hi_key - a_off___0)))
						update_class_fields -- Current might have been changed; synchronize
						l_todo := l_todo - 1
					end
				end
				l_hi___1 := l_hi___1 + 1
			end
			((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer))).item.hash_clear
			update_class_fields -- Current might have been changed; synchronize
		end

	hash_lookup (a_key: CE_POINTER [NATURAL_8]; a_hash: NATURAL_32): CE_POINTER [PD_HASHITEM_S]
		local
			l_perturb: NATURAL_32
			l_freeitem: CE_POINTER [PD_HASHITEM_S]
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_idx: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [PD_HASHITEM_S]
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			l_idx := ((a_hash).bit_and (ht_mask)).to_integer_32
			l_hi___1 := ht_array + l_idx
			if (l_hi___1.item.hi_key).is_void then
				Result := l_hi___1
				l_return := True
			end
			if not l_return then
				if (l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item) then
					l_freeitem := l_hi___1
				elseif l_hi___1.item.hi_hash = a_hash then
					l_tmp := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_hi___1.item.hi_key), create {CE_INTEGER_8_POINTER}.make_cast (a_key))
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp = 0 then
						Result := l_hi___1
						l_return := True
					else
						l_freeitem := create {CE_CLASS_POINTER [PD_HASHITEM_S]}.make_shared (default_pointer)
					end
				else
					l_freeitem := create {CE_CLASS_POINTER [PD_HASHITEM_S]}.make_shared (default_pointer)
				end
			end
			if not l_return then
				l_perturb := a_hash
				from
				until
					(l_return)
				loop
					l_idx := (((((l_idx).bit_shift_left (2)) + l_idx).to_natural_32 + l_perturb) + {NATURAL_32} 1).to_integer_32
					l_hi___1 := ht_array + ((l_idx.to_natural_32).bit_and (ht_mask)).to_integer_32
					if (l_hi___1.item.hi_key).is_void then
						if l_freeitem.is_void then
							l_tmp___0 := l_hi___1
						else
							l_tmp___0 := l_freeitem
						end
						Result := l_tmp___0
						l_return := True
					end
					if not l_return and then (l_hi___1.item.hi_hash = a_hash) then
						if not (l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item) then
							l_tmp___1 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_hi___1.item.hi_key), create {CE_INTEGER_8_POINTER}.make_cast (a_key))
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___1 = 0 then
								Result := l_hi___1
								l_return := True
							end
						end
					end
					if not l_return then
						if (l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item) then
							if l_freeitem.is_void then
								l_freeitem := l_hi___1
							end
						end
						l_perturb := (l_perturb).bit_shift_right ((5))
					end
				end
			end
		end

	hash_add (a_key: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_hash: NATURAL_32
			l_tmp: NATURAL_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			l_tmp := (create {P_HASHTAB_STATIC}).hash_hash (a_key)
			update_class_fields -- Current might have been changed; synchronize
			l_hash := l_tmp
			l_hi___1 := ((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer))).item.hash_lookup (a_key, l_hash)
			update_class_fields -- Current might have been changed; synchronize
			if not ((l_hi___1.item.hi_key).is_void) then
				if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
					l_tmp___0 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_intern2.item)))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("hash_add()"))).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_tmp___1 := ((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer))).item.hash_add_item (l_hi___1, a_key, l_hash)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___1
			end
		end

	hash_add_item (a_hi___1: CE_POINTER [PD_HASHITEM_S]; a_key: CE_POINTER [NATURAL_8]; a_hash: NATURAL_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			if ht_error.to_boolean then
				l_tmp := ((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer))).item.hash_may_resize (0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp = 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Current.ht_used := ht_used + 1
				update_class_fields -- Current might have been changed; synchronize
				if (a_hi___1.item.hi_key).is_void then
					Current.ht_filled := ht_filled + 1
					update_class_fields -- Current might have been changed; synchronize
				end
				a_hi___1.item.hi_key := a_key
				update_class_fields -- Current might have been changed; synchronize
				a_hi___1.item.hi_hash := a_hash
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := ((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer))).item.hash_may_resize (0)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___0
			end
		end

	hash_remove (a_hi___1: CE_POINTER [PD_HASHITEM_S])
		require
			not a_hi___1.is_void
		do
			Current.ht_used := ht_used - 1
			update_class_fields -- Current might have been changed; synchronize
			a_hi___1.item.hi_key := (create {P_GLOBALS_STATIC}).hash_removed.item
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer))).item.hash_may_resize (0).do_nothing
			update_class_fields -- Current might have been changed; synchronize
		end

	hash_lock
		do
			Current.ht_locked := ht_locked + 1
			update_class_fields -- Current might have been changed; synchronize
		end

	hash_unlock
		do
			Current.ht_locked := ht_locked - 1
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer))).item.hash_may_resize (0).do_nothing
			update_class_fields -- Current might have been changed; synchronize
		end

	hash_may_resize (a_minitems: INTEGER_32): INTEGER_32
		local
			l_minitems: INTEGER_32
			l_temparray: CE_ARRAY [PD_HASHITEM_S]
			l_oldarray: CE_POINTER [PD_HASHITEM_S]
			l_newarray: CE_POINTER [PD_HASHITEM_S]
			l_olditem: CE_POINTER [PD_HASHITEM_S]
			l_newitem: CE_POINTER [PD_HASHITEM_S]
			l_newi: INTEGER_32
			l_todo: INTEGER_32
			l_oldsize: NATURAL_32
			l_newsize: NATURAL_32
			l_minsize: NATURAL_32
			l_newmask: NATURAL_32
			l_perturb: NATURAL_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_HASHITEM_S]} l_temparray.make (<<16>>)

			l_minitems := a_minitems
			if ht_locked > 0 then
				Result := 1
				l_return := True
			end
			if not l_return then
				if l_minitems = 0 then
					if ht_filled < {NATURAL_32} 15 then
						if ht_array.is_equal (ht_smallarray) then
							Result := 1
							l_return := True
						end
					end
					if not l_return then
						l_oldsize := ht_mask + {NATURAL_32} 1
						if ht_filled * {NATURAL_32} 3 < l_oldsize * {NATURAL_32} 2 then
							if ht_used > l_oldsize // {NATURAL_32} 5 then
								Result := 1
								l_return := True
							end
						end
					end
					if not l_return then
						if ht_used > {NATURAL_32} 1_000 then
							l_minsize := ht_used * {NATURAL_32} 2
						else
							l_minsize := ht_used * {NATURAL_32} 4
						end
					end
				else
					if l_minitems.to_natural_32 < ht_used then
						l_minitems := ht_used.to_integer_32
					end
					l_minsize := ((l_minitems * 3) // 2).to_natural_32
				end
			end
			if not l_return then
				l_newsize := (16).to_natural_32
				from
				until
					not (not (l_return) and then (l_newsize < l_minsize))
				loop
					l_newsize := (l_newsize).bit_shift_left ((1))
					if l_newsize = {NATURAL_32} 0 then
						Result := 0
						l_return := True
					end
				end
			end
			if not l_return then
				if l_newsize = {NATURAL_32} 16 then
					l_newarray := ht_smallarray
					if ht_array.is_equal (l_newarray) then
						memmove (create {CE_VOID_POINTER}.make_cast (l_temparray), create {CE_VOID_POINTER}.make_cast (l_newarray), ((create {PD_HASHITEM_S}.make).structure_size.to_natural_32 * (16).to_natural_32)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_oldarray := l_temparray
					else
						l_oldarray := ht_array
					end
				else
					l_tmp := (create {P_MISC2_STATIC}).alloc ((((create {PD_HASHITEM_S}.make).structure_size.to_natural_32).to_natural_32 * l_newsize).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_newarray := create {CE_CLASS_POINTER [PD_HASHITEM_S]}.make_cast (l_tmp)
					if l_newarray.is_void then
						if ht_filled < ht_mask then
							Result := 1
							l_return := True
						end
						if not l_return then
							Current.ht_error := 1
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_oldarray := ht_array
					end
				end
			end
			if not l_return then
				memset (create {CE_VOID_POINTER}.make_cast (l_newarray), 0, (((create {PD_HASHITEM_S}.make).structure_size.to_natural_32).to_natural_32 * l_newsize).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_newmask := l_newsize - {NATURAL_32} 1
				l_todo := ht_used.to_integer_32
				l_olditem := l_oldarray
				from
				until
					not (not (l_return) and then (l_todo > 0))
				loop
					if not ((l_olditem.item.hi_key).is_void) then
						if not ((l_olditem.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
							l_newi := ((l_olditem.item.hi_hash).bit_and (l_newmask)).to_integer_32
							l_newitem := l_newarray + l_newi
							if not (l_newitem.item.hi_key).is_void then
								l_perturb := l_olditem.item.hi_hash
								from
								until
									(l_break)
								loop
									l_break := False
									l_newi := (((((l_newi).bit_shift_left (2)) + l_newi).to_natural_32 + l_perturb) + {NATURAL_32} 1).to_integer_32
									l_newitem := l_newarray + ((l_newi.to_natural_32).bit_and (l_newmask)).to_integer_32
									if (l_newitem.item.hi_key).is_void then
										l_break := True
									end
									if not (l_return or l_break) then
										l_perturb := (l_perturb).bit_shift_right ((5))
									end
								end
								l_break := False
							end
							l_newitem.item := (l_olditem.item).twin
							update_class_fields -- Current might have been changed; synchronize
							l_todo := l_todo - 1
						end
					end
					l_olditem := l_olditem + 1
				end
				if not ht_array.is_equal (ht_smallarray) then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (ht_array))
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.ht_array := l_newarray
				update_class_fields -- Current might have been changed; synchronize
				Current.ht_mask := l_newmask
				update_class_fields -- Current might have been changed; synchronize
				Current.ht_filled := ht_used
				update_class_fields -- Current might have been changed; synchronize
				Current.ht_error := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
			end
		end

	vars_clear
		do
			((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer))).item.vars_clear_ext (1)
			update_class_fields -- Current might have been changed; synchronize
		end

	delete_var (a_hi___1: CE_POINTER [PD_HASHITEM_S])
		require
			not a_hi___1.is_void
		local
			l_di: CE_POINTER [PD_DICTITEM_S]
		do
			l_di := create {CE_CLASS_POINTER [PD_DICTITEM_S]}.make_cast ((a_hi___1.item.hi_key - (((create {P_EVAL_STATIC}).dumdi.item.item.di_key).distance ((create {CE_NATURAL_8_POINTER}.make_cast (((create {P_EVAL_STATIC}).dumdi.item)))))));
			((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer))).item.hash_remove (a_hi___1)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_EVAL_STATIC}).clear_tv (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (l_di.c_pointer + (create {PD_DICTITEM_S}.make).offset_of ("di_tv")))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_di))
			update_class_fields -- Current might have been changed; synchronize
		end

	hash_find (a_key: CE_POINTER [NATURAL_8]): CE_POINTER [PD_HASHITEM_S]
		local
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [PD_HASHITEM_S]
		do
			l_tmp := (create {P_HASHTAB_STATIC}).hash_hash (a_key)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := ((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer))).item.hash_lookup (a_key, l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp___0
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ht_mask := a_other.ht_mask
			ht_used := a_other.ht_used
			ht_filled := a_other.ht_filled
			ht_locked := a_other.ht_locked
			ht_error := a_other.ht_error
			ht_array := a_other.ht_array
			ht_smallarray := a_other.ht_smallarray.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ht_mask = a_other.ht_mask and
				ht_used = a_other.ht_used and
				ht_filled = a_other.ht_filled and
				ht_locked = a_other.ht_locked and
				ht_error = a_other.ht_error and
				ht_array.is_equal (a_other.ht_array) and
				ht_smallarray.is_equal (a_other.ht_smallarray)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ht_mask"),
					create {CE_STRUCTURE_FIELD}.make ("ht_used"),
					create {CE_STRUCTURE_FIELD}.make ("ht_filled"),
					create {CE_STRUCTURE_FIELD}.make ("ht_locked"),
					create {CE_STRUCTURE_FIELD}.make ("ht_error"),
					create {CE_STRUCTURE_FIELD}.make ("ht_array"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ht_smallarray", <<16>>)
				>>)
			init_structure_info
		end

end
