class
	PD_HIST_ENTRY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} hisstr.make
		end

feature {ANY} -- fields

	hisnum: INTEGER_32 assign set_hisnum

	hisstr: CE_POINTER [NATURAL_8] assign set_hisstr

feature {ANY} -- field setters

	set_hisnum (a_hisnum: INTEGER_32)
		do
			hisnum := a_hisnum
			update_memory_field ("hisnum")
		end

	set_hisstr (a_hisstr: CE_POINTER [NATURAL_8])
		do
			hisstr := a_hisstr
			update_memory_field ("hisstr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			hisnum := a_other.hisnum
			hisstr := a_other.hisstr
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				hisnum = a_other.hisnum and
				hisstr.is_equal (a_other.hisstr)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("hisnum"),
					create {CE_STRUCTURE_FIELD}.make ("hisstr")
				>>)
			init_structure_info
		end

end
