class
	PD_KEYENTRY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_KEYENTRY]} ke_next.make
			create k_syn.make
			create {CE_INTEGER_16_POINTER} next_list.make
			create {CE_NATURAL_8_ARRAY} keyword.make (<<1>>)
		end

feature {ANY} -- fields

	ke_next: CE_POINTER [PD_KEYENTRY] assign set_ke_next

	k_syn: PD_SP_SYN assign set_k_syn

	next_list: CE_POINTER [INTEGER_16] assign set_next_list

	flags: INTEGER_32 assign set_flags

	k_char: INTEGER_32 assign set_k_char

	keyword: CE_ARRAY [NATURAL_8]

feature {ANY} -- field setters

	set_ke_next (a_ke_next: CE_POINTER [PD_KEYENTRY])
		do
			ke_next := a_ke_next
			update_memory_field ("ke_next")
		end

	set_k_syn (a_k_syn: PD_SP_SYN)
		do
			k_syn := a_k_syn
			update_memory_field ("k_syn")
		end

	set_next_list (a_next_list: CE_POINTER [INTEGER_16])
		do
			next_list := a_next_list
			update_memory_field ("next_list")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_k_char (a_k_char: INTEGER_32)
		do
			k_char := a_k_char
			update_memory_field ("k_char")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ke_next := a_other.ke_next
			k_syn := a_other.k_syn.twin
			next_list := a_other.next_list
			flags := a_other.flags
			k_char := a_other.k_char
			keyword := a_other.keyword.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ke_next.is_equal (a_other.ke_next) and
				k_syn.is_equal (a_other.k_syn) and
				next_list.is_equal (a_other.next_list) and
				flags = a_other.flags and
				k_char = a_other.k_char and
				keyword.is_equal (a_other.keyword)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ke_next"),
					create {CE_STRUCTURE_FIELD}.make ("k_syn"),
					create {CE_STRUCTURE_FIELD}.make ("next_list"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("k_char"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("keyword", <<1>>)
				>>)
			init_structure_info
		end

end
