class
	PD_MATCHITEM

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_MATCHITEM]} next.make
			create {CE_NATURAL_8_POINTER} pattern.make
			create match.make
			create hl.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_MATCHITEM] assign set_next

	id: INTEGER_32 assign set_id

	priority: INTEGER_32 assign set_priority

	pattern: CE_POINTER [NATURAL_8] assign set_pattern

	hlg_id: INTEGER_32 assign set_hlg_id

	match: PD_REGMMATCH_T assign set_match

	hl: PD_MATCH_T assign set_hl

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_MATCHITEM])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_id (a_id: INTEGER_32)
		do
			id := a_id
			update_memory_field ("id")
		end

	set_priority (a_priority: INTEGER_32)
		do
			priority := a_priority
			update_memory_field ("priority")
		end

	set_pattern (a_pattern: CE_POINTER [NATURAL_8])
		do
			pattern := a_pattern
			update_memory_field ("pattern")
		end

	set_hlg_id (a_hlg_id: INTEGER_32)
		do
			hlg_id := a_hlg_id
			update_memory_field ("hlg_id")
		end

	set_match (a_match: PD_REGMMATCH_T)
		do
			match := a_match
			update_memory_field ("match")
		end

	set_hl (a_hl: PD_MATCH_T)
		do
			hl := a_hl
			update_memory_field ("hl")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			id := a_other.id
			priority := a_other.priority
			pattern := a_other.pattern
			hlg_id := a_other.hlg_id
			match := a_other.match.twin
			hl := a_other.hl.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				id = a_other.id and
				priority = a_other.priority and
				pattern.is_equal (a_other.pattern) and
				hlg_id = a_other.hlg_id and
				match.is_equal (a_other.match) and
				hl.is_equal (a_other.hl)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("id"),
					create {CE_STRUCTURE_FIELD}.make ("priority"),
					create {CE_STRUCTURE_FIELD}.make ("pattern"),
					create {CE_STRUCTURE_FIELD}.make ("hlg_id"),
					create {CE_STRUCTURE_FIELD}.make ("match"),
					create {CE_STRUCTURE_FIELD}.make ("hl")
				>>)
			init_structure_info
		end

end
