class
	PD_MOUSETABLE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	pseudo_code: INTEGER_32 assign set_pseudo_code

	button: INTEGER_32 assign set_button

	is_click: INTEGER_32 assign set_is_click

	is_drag: INTEGER_32 assign set_is_drag

feature {ANY} -- field setters

	set_pseudo_code (a_pseudo_code: INTEGER_32)
		do
			pseudo_code := a_pseudo_code
			update_memory_field ("pseudo_code")
		end

	set_button (a_button: INTEGER_32)
		do
			button := a_button
			update_memory_field ("button")
		end

	set_is_click (a_is_click: INTEGER_32)
		do
			is_click := a_is_click
			update_memory_field ("is_click")
		end

	set_is_drag (a_is_drag: INTEGER_32)
		do
			is_drag := a_is_drag
			update_memory_field ("is_drag")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pseudo_code := a_other.pseudo_code
			button := a_other.button
			is_click := a_other.is_click
			is_drag := a_other.is_drag
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pseudo_code = a_other.pseudo_code and
				button = a_other.button and
				is_click = a_other.is_click and
				is_drag = a_other.is_drag
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pseudo_code"),
					create {CE_STRUCTURE_FIELD}.make ("button"),
					create {CE_STRUCTURE_FIELD}.make ("is_click"),
					create {CE_STRUCTURE_FIELD}.make ("is_drag")
				>>)
			init_structure_info
		end

end
