class
	PD_MPARM_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_UNISTD_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_SYS_STAT_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_POINTER_POINTER [INTEGER_8]} argv.make
			create {CE_NATURAL_8_POINTER} use_vimrc.make
			create {CE_POINTER_ARRAY [NATURAL_8]} commands.make (<<10>>)
			create {CE_NATURAL_8_ARRAY} cmds_tofree.make (<<10>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} pre_commands.make (<<10>>)
			create {CE_NATURAL_8_POINTER} tagname.make
			create {CE_NATURAL_8_POINTER} use_ef.make
			create {CE_NATURAL_8_POINTER} term.make
			create {CE_NATURAL_8_POINTER} serverName_arg.make
			create {CE_NATURAL_8_POINTER} serverStr.make
			create {CE_NATURAL_8_POINTER} serverStrEnc.make
			create {CE_NATURAL_8_POINTER} servername.make
			Precursor
		end

feature {ANY} -- fields

	argc: INTEGER_32 assign set_argc

	argv: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_argv

	evim_mode: INTEGER_32 assign set_evim_mode

	use_vimrc: CE_POINTER [NATURAL_8] assign set_use_vimrc

	n_commands: INTEGER_32 assign set_n_commands

	commands: CE_ARRAY [CE_POINTER [NATURAL_8]]

	cmds_tofree: CE_ARRAY [NATURAL_8]

	n_pre_commands: INTEGER_32 assign set_n_pre_commands

	pre_commands: CE_ARRAY [CE_POINTER [NATURAL_8]]

	edit_type: INTEGER_32 assign set_edit_type

	tagname: CE_POINTER [NATURAL_8] assign set_tagname

	use_ef: CE_POINTER [NATURAL_8] assign set_use_ef

	want_full_screen: INTEGER_32 assign set_want_full_screen

	stdout_isatty: INTEGER_32 assign set_stdout_isatty

	term: CE_POINTER [NATURAL_8] assign set_term

	ask_for_key: INTEGER_32 assign set_ask_for_key

	no_swap_file: INTEGER_32 assign set_no_swap_file

	use_debug_break_level: INTEGER_32 assign set_use_debug_break_level

	window_count: INTEGER_32 assign set_window_count

	window_layout: INTEGER_32 assign set_window_layout

	serverArg: INTEGER_32 assign set_serverArg

	serverName_arg: CE_POINTER [NATURAL_8] assign set_serverName_arg

	serverStr: CE_POINTER [NATURAL_8] assign set_serverStr

	serverStrEnc: CE_POINTER [NATURAL_8] assign set_serverStrEnc

	servername: CE_POINTER [NATURAL_8] assign set_servername

	diff_mode: INTEGER_32 assign set_diff_mode

feature {ANY} -- field setters

	set_argc (a_argc: INTEGER_32)
		do
			argc := a_argc
			update_memory_field ("argc")
		end

	set_argv (a_argv: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			argv := a_argv
			update_memory_field ("argv")
		end

	set_evim_mode (a_evim_mode: INTEGER_32)
		do
			evim_mode := a_evim_mode
			update_memory_field ("evim_mode")
		end

	set_use_vimrc (a_use_vimrc: CE_POINTER [NATURAL_8])
		do
			use_vimrc := a_use_vimrc
			update_memory_field ("use_vimrc")
		end

	set_n_commands (a_n_commands: INTEGER_32)
		do
			n_commands := a_n_commands
			update_memory_field ("n_commands")
		end

	set_n_pre_commands (a_n_pre_commands: INTEGER_32)
		do
			n_pre_commands := a_n_pre_commands
			update_memory_field ("n_pre_commands")
		end

	set_edit_type (a_edit_type: INTEGER_32)
		do
			edit_type := a_edit_type
			update_memory_field ("edit_type")
		end

	set_tagname (a_tagname: CE_POINTER [NATURAL_8])
		do
			tagname := a_tagname
			update_memory_field ("tagname")
		end

	set_use_ef (a_use_ef: CE_POINTER [NATURAL_8])
		do
			use_ef := a_use_ef
			update_memory_field ("use_ef")
		end

	set_want_full_screen (a_want_full_screen: INTEGER_32)
		do
			want_full_screen := a_want_full_screen
			update_memory_field ("want_full_screen")
		end

	set_stdout_isatty (a_stdout_isatty: INTEGER_32)
		do
			stdout_isatty := a_stdout_isatty
			update_memory_field ("stdout_isatty")
		end

	set_term (a_term: CE_POINTER [NATURAL_8])
		do
			term := a_term
			update_memory_field ("term")
		end

	set_ask_for_key (a_ask_for_key: INTEGER_32)
		do
			ask_for_key := a_ask_for_key
			update_memory_field ("ask_for_key")
		end

	set_no_swap_file (a_no_swap_file: INTEGER_32)
		do
			no_swap_file := a_no_swap_file
			update_memory_field ("no_swap_file")
		end

	set_use_debug_break_level (a_use_debug_break_level: INTEGER_32)
		do
			use_debug_break_level := a_use_debug_break_level
			update_memory_field ("use_debug_break_level")
		end

	set_window_count (a_window_count: INTEGER_32)
		do
			window_count := a_window_count
			update_memory_field ("window_count")
		end

	set_window_layout (a_window_layout: INTEGER_32)
		do
			window_layout := a_window_layout
			update_memory_field ("window_layout")
		end

	set_serverArg (a_serverArg: INTEGER_32)
		do
			serverArg := a_serverArg
			update_memory_field ("serverArg")
		end

	set_serverName_arg (a_serverName_arg: CE_POINTER [NATURAL_8])
		do
			serverName_arg := a_serverName_arg
			update_memory_field ("serverName_arg")
		end

	set_serverStr (a_serverStr: CE_POINTER [NATURAL_8])
		do
			serverStr := a_serverStr
			update_memory_field ("serverStr")
		end

	set_serverStrEnc (a_serverStrEnc: CE_POINTER [NATURAL_8])
		do
			serverStrEnc := a_serverStrEnc
			update_memory_field ("serverStrEnc")
		end

	set_servername (a_servername: CE_POINTER [NATURAL_8])
		do
			servername := a_servername
			update_memory_field ("servername")
		end

	set_diff_mode (a_diff_mode: INTEGER_32)
		do
			diff_mode := a_diff_mode
			update_memory_field ("diff_mode")
		end

feature {PD_MPARM_T} -- private attributes

	e_nohebrew: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('E').code).to_natural_8, (('2').code).to_natural_8, (('6').code).to_natural_8, ((':').code).to_natural_8,
					((' ').code).to_natural_8, (('H').code).to_natural_8, (('e').code).to_natural_8, (('b').code).to_natural_8,
					(('r').code).to_natural_8, (('e').code).to_natural_8, (('w').code).to_natural_8, ((' ').code).to_natural_8,
					(('c').code).to_natural_8, (('a').code).to_natural_8, (('n').code).to_natural_8, (('n').code).to_natural_8,
					(('o').code).to_natural_8, (('t').code).to_natural_8, ((' ').code).to_natural_8, (('b').code).to_natural_8,
					(('e').code).to_natural_8, ((' ').code).to_natural_8, (('u').code).to_natural_8, (('s').code).to_natural_8,
					(('e').code).to_natural_8, (('d').code).to_natural_8, ((':').code).to_natural_8, ((' ').code).to_natural_8,
					(('N').code).to_natural_8, (('o').code).to_natural_8, (('t').code).to_natural_8, ((' ').code).to_natural_8,
					(('e').code).to_natural_8, (('n').code).to_natural_8, (('a').code).to_natural_8, (('b').code).to_natural_8,
					(('l').code).to_natural_8, (('e').code).to_natural_8, (('d').code).to_natural_8, ((' ').code).to_natural_8,
					(('a').code).to_natural_8, (('t').code).to_natural_8, ((' ').code).to_natural_8, (('c').code).to_natural_8,
					(('o').code).to_natural_8, (('m').code).to_natural_8, (('p').code).to_natural_8, (('i').code).to_natural_8,
					(('l').code).to_natural_8, (('e').code).to_natural_8, ((' ').code).to_natural_8, (('t').code).to_natural_8,
					(('i').code).to_natural_8, (('m').code).to_natural_8, (('e').code).to_natural_8, (('%N').code).to_natural_8,
					(('%/0/').code).to_natural_8
				>>)
		end

	e_nofarsi: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('E').code).to_natural_8, (('2').code).to_natural_8, (('7').code).to_natural_8, ((':').code).to_natural_8,
					((' ').code).to_natural_8, (('F').code).to_natural_8, (('a').code).to_natural_8, (('r').code).to_natural_8,
					(('s').code).to_natural_8, (('i').code).to_natural_8, ((' ').code).to_natural_8, (('c').code).to_natural_8,
					(('a').code).to_natural_8, (('n').code).to_natural_8, (('n').code).to_natural_8, (('o').code).to_natural_8,
					(('t').code).to_natural_8, ((' ').code).to_natural_8, (('b').code).to_natural_8, (('e').code).to_natural_8,
					((' ').code).to_natural_8, (('u').code).to_natural_8, (('s').code).to_natural_8, (('e').code).to_natural_8,
					(('d').code).to_natural_8, ((':').code).to_natural_8, ((' ').code).to_natural_8, (('N').code).to_natural_8,
					(('o').code).to_natural_8, (('t').code).to_natural_8, ((' ').code).to_natural_8, (('e').code).to_natural_8,
					(('n').code).to_natural_8, (('a').code).to_natural_8, (('b').code).to_natural_8, (('l').code).to_natural_8,
					(('e').code).to_natural_8, (('d').code).to_natural_8, ((' ').code).to_natural_8, (('a').code).to_natural_8,
					(('t').code).to_natural_8, ((' ').code).to_natural_8, (('c').code).to_natural_8, (('o').code).to_natural_8,
					(('m').code).to_natural_8, (('p').code).to_natural_8, (('i').code).to_natural_8, (('l').code).to_natural_8,
					(('e').code).to_natural_8, ((' ').code).to_natural_8, (('t').code).to_natural_8, (('i').code).to_natural_8,
					(('m').code).to_natural_8, (('e').code).to_natural_8, (('%N').code).to_natural_8, (('%/0/').code).to_natural_8
				>>)
		end

	e_noarabic: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('E').code).to_natural_8, (('8').code).to_natural_8, (('0').code).to_natural_8, (('0').code).to_natural_8,
					((':').code).to_natural_8, ((' ').code).to_natural_8, (('A').code).to_natural_8, (('r').code).to_natural_8,
					(('a').code).to_natural_8, (('b').code).to_natural_8, (('i').code).to_natural_8, (('c').code).to_natural_8,
					((' ').code).to_natural_8, (('c').code).to_natural_8, (('a').code).to_natural_8, (('n').code).to_natural_8,
					(('n').code).to_natural_8, (('o').code).to_natural_8, (('t').code).to_natural_8, ((' ').code).to_natural_8,
					(('b').code).to_natural_8, (('e').code).to_natural_8, ((' ').code).to_natural_8, (('u').code).to_natural_8,
					(('s').code).to_natural_8, (('e').code).to_natural_8, (('d').code).to_natural_8, ((':').code).to_natural_8,
					((' ').code).to_natural_8, (('N').code).to_natural_8, (('o').code).to_natural_8, (('t').code).to_natural_8,
					((' ').code).to_natural_8, (('e').code).to_natural_8, (('n').code).to_natural_8, (('a').code).to_natural_8,
					(('b').code).to_natural_8, (('l').code).to_natural_8, (('e').code).to_natural_8, (('d').code).to_natural_8,
					((' ').code).to_natural_8, (('a').code).to_natural_8, (('t').code).to_natural_8, ((' ').code).to_natural_8,
					(('c').code).to_natural_8, (('o').code).to_natural_8, (('m').code).to_natural_8, (('p').code).to_natural_8,
					(('i').code).to_natural_8, (('l').code).to_natural_8, (('e').code).to_natural_8, ((' ').code).to_natural_8,
					(('t').code).to_natural_8, (('i').code).to_natural_8, (('m').code).to_natural_8, (('e').code).to_natural_8,
					(('%N').code).to_natural_8, (('%/0/').code).to_natural_8
				>>)
		end

	use: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("[file ..]       edit specified file(s)"),
					ce_string ("-               read text from stdin"),
					ce_string ("-t tag          edit file where tag is defined"),
					ce_string ("-q [errorfile]  edit file with first error")
				>>)
		end

	main_errors: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("Unknown option argument"),
					ce_string ("Too many edit arguments"),
					ce_string ("Argument missing after"),
					ce_string ("Garbage after option argument"),
					ce_string ("Too many %"+command%", %"-c command%" or %"--cmd command%" arguments"),
					ce_string ("Invalid argument for")
				>>)
		end

feature {ANY} -- public routines

	parse_command_name
		local
			l_initstr: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
		do
			l_initstr := (create {P_MISC1_STATIC}).gettail (create {CE_NATURAL_8_POINTER}.make_cast (argv[0]))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_EVAL_STATIC}).set_vim_var_string (26, l_initstr, -1)
			update_class_fields -- Current might have been changed; synchronize
			if (l_initstr[0]).to_integer_32 < 65 then
				l_tmp := (l_initstr[0]).to_integer_32
			elseif (l_initstr[0]).to_integer_32 > 90 then
				l_tmp := (l_initstr[0]).to_integer_32
			else
				l_tmp := (l_initstr[0]).to_integer_32 + 32
			end
			if l_tmp = 114 then
				(create {P_GLOBALS_STATIC}).restricted.item := 1
				update_class_fields -- Current might have been changed; synchronize
				l_initstr := l_initstr + 1
			end
			if (l_initstr[0]).to_integer_32 < 65 then
				l_tmp___0 := (l_initstr[0]).to_integer_32
			elseif (l_initstr[0]).to_integer_32 > 90 then
				l_tmp___0 := (l_initstr[0]).to_integer_32
			else
				l_tmp___0 := (l_initstr[0]).to_integer_32 + 32
			end
			if l_tmp___0 = 101 then
				if (l_initstr[1]).to_integer_32 < 65 then
					l_tmp___1 := (l_initstr[1]).to_integer_32
				elseif (l_initstr[1]).to_integer_32 > 90 then
					l_tmp___1 := (l_initstr[1]).to_integer_32
				else
					l_tmp___1 := (l_initstr[1]).to_integer_32 + 32
				end
				if l_tmp___1 = 118 then
					(create {P_GUI_STATIC}).gui.item.item.starting := 1
					update_class_fields -- Current might have been changed; synchronize
					Current.evim_mode := 1
					update_class_fields -- Current might have been changed; synchronize
					l_initstr := l_initstr + 1
				else
					if (l_initstr[1]).to_integer_32 < 65 then
						l_tmp___2 := (l_initstr[1]).to_integer_32
					elseif (l_initstr[1]).to_integer_32 > 90 then
						l_tmp___2 := (l_initstr[1]).to_integer_32
					else
						l_tmp___2 := (l_initstr[1]).to_integer_32 + 32
					end
					if l_tmp___2 = 103 then
						(create {P_GUI_STATIC}).gui.item.item.starting := 1
						update_class_fields -- Current might have been changed; synchronize
						Current.evim_mode := 1
						update_class_fields -- Current might have been changed; synchronize
						l_initstr := l_initstr + 1
					end
				end
			end
			if (l_initstr[0]).to_integer_32 < 65 then
				l_tmp___3 := (l_initstr[0]).to_integer_32
			elseif (l_initstr[0]).to_integer_32 > 90 then
				l_tmp___3 := (l_initstr[0]).to_integer_32
			else
				l_tmp___3 := (l_initstr[0]).to_integer_32 + 32
			end
			if l_tmp___3 = 103 then
				main_start_gui
				update_class_fields -- Current might have been changed; synchronize
				l_initstr := l_initstr + 1
			end
			l_tmp___5 := strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_initstr), ce_string ("view"), (4).to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___5 = 0 then
				(create {P_GLOBALS_STATIC}).readonlymode.item := 1
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro := 1
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_OPTION_STATIC}).p_uc.item.item := 10_000
				update_class_fields -- Current might have been changed; synchronize
				l_initstr := l_initstr + (4)
			else
				l_tmp___4 := strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_initstr), ce_string ("vim"), (3).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___4 = 0 then
					l_initstr := l_initstr + (3)
				end
			end
			l_tmp___6 := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_initstr), ce_string ("diff"))
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___6 = 0 then
				Current.diff_mode := 1
				update_class_fields -- Current might have been changed; synchronize
			end
			l_tmp___8 := strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_initstr), ce_string ("ex"), (2).to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___8 = 0 then
				l_tmp___7 := strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_initstr + 2)), ce_string ("im"), (2).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___7 = 0 then
					(create {P_GLOBALS_STATIC}).exmode_active.item := 2
					update_class_fields -- Current might have been changed; synchronize
				else
					(create {P_GLOBALS_STATIC}).exmode_active.item := 1
					update_class_fields -- Current might have been changed; synchronize
				end
				change_compatible (1)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	early_arg_scan
		local
			l_argc: INTEGER_32
			l_argv: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_i___0: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_id: CE_ARRAY [NATURAL_32]
			l_count___2: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_id.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_argc := argc
					l_argv := argv
					l_i___0 := 1
				when 1 then -- loop condition:
					if not (not (l_break) and then (l_i___0 < l_argc)) then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_tmp___8 := strcmp (l_argv[l_i___0], ce_string ("--"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___8 /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_break := True
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 5 then -- else:
						l_tmp___6 := strcasecmp (l_argv[l_i___0], ce_string ("-display"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___6 /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						l_tmp___7 := strcasecmp (l_argv[l_i___0], ce_string ("--display"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___7 /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | _L:
						if l_i___0 = l_argc - 1 then
							mainerr_arg_missing (create {CE_NATURAL_8_POINTER}.make_cast (l_argv[l_i___0]))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_i___0 := l_i___0 + 1;
						(create {P_GLOBALS_STATIC}).xterm_display.item := l_argv[l_i___0]
						update_class_fields -- Current might have been changed; synchronize
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_tmp___5 := strcasecmp (l_argv[l_i___0], ce_string ("--servername"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___5 = 0 then
							if l_i___0 = l_argc - 1 then
								mainerr_arg_missing (create {CE_NATURAL_8_POINTER}.make_cast (l_argv[l_i___0]))
								update_class_fields -- Current might have been changed; synchronize
							end
							l_i___0 := l_i___0 + 1
							Current.serverName_arg := create {CE_NATURAL_8_POINTER}.make_cast (l_argv[l_i___0])
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___4 := strcasecmp (l_argv[l_i___0], ce_string ("--serverlist"))
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___4 = 0 then
								Current.serverArg := 1
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___3 := strncasecmp (l_argv[l_i___0], ce_string ("--remote"), (8).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___3 = 0 then
									Current.serverArg := 1
									update_class_fields -- Current might have been changed; synchronize
									l_tmp := strstr (l_argv[l_i___0], ce_string ("-wait"))
									update_class_fields -- Current might have been changed; synchronize
									if not l_tmp.is_void then
										(create {P_GUI_STATIC}).gui.item.item.dofork := 0
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									l_tmp___2 := strcasecmp (l_argv[l_i___0], ce_string ("--socketid"))
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___2 = 0 then
										if l_i___0 = l_argc - 1 then
											mainerr_arg_missing (create {CE_NATURAL_8_POINTER}.make_cast (l_argv[l_i___0]))
											update_class_fields -- Current might have been changed; synchronize
										end
										l_tmp___0 := strncasecmp (l_argv[(l_i___0 + 1)], ce_string ("0x"), (2).to_natural_32)
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___0 = 0 then
											l_count___2 := sscanf ([(l_argv[(l_i___0 + 1)] + 2), ce_string ("%%lx"), l_id])
											update_class_fields -- Current might have been changed; synchronize
										else
											l_count___2 := sscanf ([l_argv[(l_i___0 + 1)], ce_string ("%%lu"), l_id])
											update_class_fields -- Current might have been changed; synchronize
										end
										if l_count___2 /= 1 then
											mainerr (5, create {CE_NATURAL_8_POINTER}.make_cast (l_argv[l_i___0]))
											update_class_fields -- Current might have been changed; synchronize
										else
											(create {P_GLOBALS_STATIC}).gtk_socket_id.item := (l_id.item).to_natural_32
											update_class_fields -- Current might have been changed; synchronize
										end
										l_i___0 := l_i___0 + 1
									else
										l_tmp___1 := strcasecmp (l_argv[l_i___0], ce_string ("--echo-wid"))
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___1 = 0 then
											(create {P_GLOBALS_STATIC}).echo_wid_arg.item := 1
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								end
							end
						end
				when 12 then -- if done | if done
						if not (l_break) then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					l_break := False
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	command_line_scan
		local
			l_argc: INTEGER_32
			l_argv: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_argv_idx: CE_ARRAY [INTEGER_32]
			l_had_minmin: INTEGER_32
			l_want_argument: INTEGER_32
			l_c: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: INTEGER_32
			l_tmp___18: NATURAL_32
			l_tmp___19: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_a: CE_POINTER [INTEGER_8]
			l_tmp___22: NATURAL_32
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			l_tmp___25: INTEGER_32
			l_tmp___26: CE_POINTER [INTEGER_8]
			l_tmp___27: CE_POINTER [INTEGER_8]
			l_tmp___28: INTEGER_32
			l_tmp___29: INTEGER_32
			l_tmp___30: INTEGER_32
			l_tmp___31: INTEGER_32
			l_tmp___32: CE_POINTER [INTEGER_8]
			l_tmp___33: CE_POINTER [INTEGER_8]
			l_tmp___34: INTEGER_32
			l_r: CE_POINTER [NATURAL_8]
			l_tmp___35: CE_POINTER [NATURAL_8]
			l_tmp___36: CE_POINTER [NATURAL_8]
			l_tmp___37: INTEGER_32
			l_tmp___38: CE_POINTER [NATURAL_8]
			l_tmp___39: INTEGER_32
			l_tmp___40: NATURAL_32
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_argv_idx.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_argc := argc
					l_argv := argv
					l_had_minmin := 0
					l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_argc := l_argc - 1
					l_argv := l_argv + 1
					l_argv_idx.item := 1
					update_class_fields -- Current might have been changed; synchronize
				when 1 then -- loop condition:
					if not (l_argc > 0) then
						l_pos := -1 + 94 -- skip loop
					end
				when 2 then -- loop body:
						if ((l_argv[0])[0]).to_integer_32 /= 43 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if not l_had_minmin.to_boolean then
							if n_commands >= 10 then
								mainerr (4, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
							end
							l_argv_idx.item := -1
							update_class_fields -- Current might have been changed; synchronize
							if ((l_argv[0])[1]).to_integer_32 = 0 then
								l_tmp := n_commands
								Current.n_commands := n_commands + 1
								update_class_fields -- Current might have been changed; synchronize
								commands[l_tmp] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("$"))
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___0 := n_commands
								Current.n_commands := n_commands + 1
								update_class_fields -- Current might have been changed; synchronize
								commands[l_tmp___0] := create {CE_NATURAL_8_POINTER}.make_cast ((l_argv[0] + 1))
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_pos := -1 + 5 -- goto _L___1
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 93
				when 5 then -- else: | _L___1:
						if ((l_argv[0])[0]).to_integer_32 /= 45 then
							l_pos := -1 + 92 -- skip if block
						end
				when 6 then -- if:
						if l_had_minmin.to_boolean then
							l_pos := -1 + 90 -- skip if block
						end
				when 7 then -- if:
						l_want_argument := 0
						l_tmp___1 := l_argv_idx.item
						l_argv_idx.item := l_argv_idx.item + 1
						update_class_fields -- Current might have been changed; synchronize
						l_c := ((l_argv[0])[l_tmp___1]).to_integer_32
						inspect l_c -- switch 1 head
						when 0 then l_pos := -1 + 8
						when 45 then l_pos := -1 + 9
						when 65 then l_pos := -1 + 37
						when 98 then l_pos := -1 + 38
						when 67 then l_pos := -1 + 39
						when 101 then l_pos := -1 + 40
						when 69 then l_pos := -1 + 41
						when 102 then l_pos := -1 + 42
						when 103 then l_pos := -1 + 43
						when 70 then l_pos := -1 + 44
						when 104 then l_pos := -1 + 45
						when 72 then l_pos := -1 + 46
						when 108 then l_pos := -1 + 47
						when 77 then l_pos := -1 + 48
						when 109 then l_pos := -1 + 49
						when 121 then l_pos := -1 + 50
						when 78 then l_pos := -1 + 51
						when 110 then l_pos := -1 + 52
						when 112 then l_pos := -1 + 53
						when 111 then l_pos := -1 + 54
						when 79 then l_pos := -1 + 55
						when 113 then l_pos := -1 + 56
						when 82 then l_pos := -1 + 57
						when 114 then l_pos := -1 + 58
						when 76 then l_pos := -1 + 58
						when 115 then l_pos := -1 + 59
						when 116 then l_pos := -1 + 60
						when 68 then l_pos := -1 + 61
						when 100 then l_pos := -1 + 62
						when 86 then l_pos := -1 + 63
						when 118 then l_pos := -1 + 64
						when 119 then l_pos := -1 + 65
						when 120 then l_pos := -1 + 67
						when 88 then l_pos := -1 + 68
						when 90 then l_pos := -1 + 69
						when 99 then l_pos := -1 + 70
						when 83 then l_pos := -1 + 71
						when 105 then l_pos := -1 + 71
						when 84 then l_pos := -1 + 71
						when 117 then l_pos := -1 + 71
						when 85 then l_pos := -1 + 71
						when 87 then l_pos := -1 + 71
						else l_pos := -1 + 72
						end
				when 8 then -- switch 1, case 0
						if ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
							(create {P_GLOBALS_STATIC}).silent_mode.item := 1
							update_class_fields -- Current might have been changed; synchronize
						else
							if edit_type /= 0 then
								mainerr (1, create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]))
								update_class_fields -- Current might have been changed; synchronize
							end
							Current.edit_type := 2
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).read_cmd_fd.item := 2
							update_class_fields -- Current might have been changed; synchronize
						end
						l_argv_idx.item := -1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 9 then -- switch 1, case 45
						l_tmp___13 := strcasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("help"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___13 /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						usage
						update_class_fields -- Current might have been changed; synchronize
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 12 then -- else:
						l_tmp___12 := strcasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("version"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___12 /= 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:;
						(create {P_GLOBALS_STATIC}).Columns.item.item := 80
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).info_message.item := 1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_VERSION_STATIC}).list_version
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).msg_didout.item := 0
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_OS_UNIX_STATIC}).mch_exit (0)
						update_class_fields -- Current might have been changed; synchronize
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 15 then -- else:
						l_tmp___11 := strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("literal"), (7).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if (l_tmp___11 = 0) then
							l_pos := -1 + 36 -- skip if block
						end
				when 16 then -- if:
						l_tmp___10 := strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("nofork"), (6).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___10 /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:;
						(create {P_GUI_STATIC}).gui.item.item.dofork := 0
						update_class_fields -- Current might have been changed; synchronize
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 19 then -- else:
						l_tmp___9 := strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("noplugin"), (8).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___9 /= 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:;
						(create {P_OPTION_STATIC}).p_lpl.item.item := 0
						update_class_fields -- Current might have been changed; synchronize
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 22 then -- else:
						l_tmp___8 := strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("cmd"), (3).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___8 /= 0 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_want_argument := 1
						l_argv_idx.item := l_argv_idx.item + (3)
						update_class_fields -- Current might have been changed; synchronize
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 25 then -- else:
						l_tmp___7 := strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("startuptime"), (11).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___7 /= 0 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_want_argument := 1
						l_argv_idx.item := l_argv_idx.item + (11)
						update_class_fields -- Current might have been changed; synchronize
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 28 then -- else:
						l_tmp___6 := strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("serverlist"), (10).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if (l_tmp___6 = 0) then
							l_pos := -1 + 36 -- skip if block
						end
				when 29 then -- if:
						l_tmp___4 := strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("servername"), (10).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___4 /= 0 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 33 -- goto _L
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 32 then -- else:
						l_tmp___5 := strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("serversend"), (10).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___5 /= 0 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if: | _L:
						if l_argc > 1 then
							l_argc := l_argc - 1
							l_argv := l_argv + 1
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else:
						l_tmp___3 := strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("socketid"), (8).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___3 = 0 then
							if l_argc > 1 then
								l_argc := l_argc - 1
								l_argv := l_argv + 1
							end
						else
							l_tmp___2 := strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("echo-wid"), (8).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___2 /= 0 then
								if ((l_argv[0])[l_argv_idx.item]).to_boolean then
									mainerr (0, create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]))
									update_class_fields -- Current might have been changed; synchronize
								end
								l_had_minmin := 1
							end
						end
				when 36 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not l_want_argument.to_boolean then
							l_argv_idx.item := -1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 73 -- switch 1; break
				when 37 then -- switch 1, case 65
						l_tmp___14 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (e_noarabic.item))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).mch_errmsg (l_tmp___14)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_OS_UNIX_STATIC}).mch_exit (2)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 38 then -- switch 1, case 98;
						(create {P_OPTION_STATIC}).set_options_bin ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bin, 1, 0)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bin := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 39 then -- switch 1, case 67
						change_compatible (1)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 40 then -- switch 1, case 101;
						(create {P_GLOBALS_STATIC}).exmode_active.item := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 41 then -- switch 1, case 69;
						(create {P_GLOBALS_STATIC}).exmode_active.item := 2
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 42 then -- switch 1, case 102;
						(create {P_GUI_STATIC}).gui.item.item.dofork := 0
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 43 then -- switch 1, case 103
						main_start_gui
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 44 then -- switch 1, case 70
						l_tmp___15 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (e_nofarsi.item))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).mch_errmsg (l_tmp___15)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_OS_UNIX_STATIC}).mch_exit (2)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 45 then -- switch 1, case 104
						usage
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 46 then -- switch 1, case 72
						l_tmp___16 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (e_nohebrew.item))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).mch_errmsg (l_tmp___16)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_OS_UNIX_STATIC}).mch_exit (2)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 47 then -- switch 1, case 108;
						(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lisp")), 1, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_OPTION_STATIC}).p_sm.item.item := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 48 then -- switch 1, case 77
						reset_modifiable
						update_class_fields -- Current might have been changed; synchronize
				when 49 then -- switch 1, case 109;
						(create {P_OPTION_STATIC}).p_write.item.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 50 then -- switch 1, case 121;
						(create {P_GUI_STATIC}).gui.item.item.starting := 1
						update_class_fields -- Current might have been changed; synchronize
						Current.evim_mode := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 51 then -- switch 1, case 78
						change_compatible (0)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 52 then -- switch 1, case 110
						if ((l_argv[0])[l_argv_idx.item]).to_integer_32 = 98 then
							(create {P_GLOBALS_STATIC}).netbeansArg.item := l_argv[0]
							update_class_fields -- Current might have been changed; synchronize
							l_argv_idx.item := -1
							update_class_fields -- Current might have been changed; synchronize
						else
							Current.no_swap_file := 1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 73 -- switch 1; break
				when 53 then -- switch 1, case 112
						Current.window_count := get_number_arg (create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]), l_argv_idx, 0)
						update_class_fields -- Current might have been changed; synchronize
						Current.window_layout := 3
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 54 then -- switch 1, case 111
						Current.window_count := get_number_arg (create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]), l_argv_idx, 0)
						update_class_fields -- Current might have been changed; synchronize
						Current.window_layout := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 55 then -- switch 1, case 79
						Current.window_count := get_number_arg (create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]), l_argv_idx, 0)
						update_class_fields -- Current might have been changed; synchronize
						Current.window_layout := 2
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 56 then -- switch 1, case 113
						if edit_type /= 0 then
							mainerr (1, create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]))
							update_class_fields -- Current might have been changed; synchronize
						end
						Current.edit_type := 4
						update_class_fields -- Current might have been changed; synchronize
						if ((l_argv[0])[l_argv_idx.item]).to_boolean then
							Current.use_ef := create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]) + l_argv_idx.item
							update_class_fields -- Current might have been changed; synchronize
							l_argv_idx.item := -1
							update_class_fields -- Current might have been changed; synchronize
						elseif l_argc > 1 then
							l_want_argument := 1
						end
						l_pos := -1 + 73 -- switch 1; break
				when 57 then -- switch 1, case 82;
						(create {P_GLOBALS_STATIC}).readonlymode.item := 1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro := 1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_OPTION_STATIC}).p_uc.item.item := 10_000
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 58 then -- switch 1, case 114 | switch 1, case 76;
						(create {P_GLOBALS_STATIC}).recoverymode.item := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 59 then -- switch 1, case 115
						if ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
							(create {P_GLOBALS_STATIC}).silent_mode.item := 1
							update_class_fields -- Current might have been changed; synchronize
						else
							l_want_argument := 1
						end
						l_pos := -1 + 73 -- switch 1; break
				when 60 then -- switch 1, case 116
						if edit_type /= 0 then
							mainerr (1, create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]))
							update_class_fields -- Current might have been changed; synchronize
						end
						Current.edit_type := 3
						update_class_fields -- Current might have been changed; synchronize
						if ((l_argv[0])[l_argv_idx.item]).to_boolean then
							Current.tagname := create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]) + l_argv_idx.item
							update_class_fields -- Current might have been changed; synchronize
							l_argv_idx.item := -1
							update_class_fields -- Current might have been changed; synchronize
						else
							l_want_argument := 1
						end
						l_pos := -1 + 73 -- switch 1; break
				when 61 then -- switch 1, case 68
						Current.use_debug_break_level := 9_999
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 62 then -- switch 1, case 100
						Current.diff_mode := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 63 then -- switch 1, case 86
						l_tmp___17 := get_number_arg (create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]), l_argv_idx, 10)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_OPTION_STATIC}).p_verbose.item.item := l_tmp___17.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						if ((l_argv[0])[l_argv_idx.item]).to_integer_32 /= 0 then
							(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("verbosefile")), 0, create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]) + l_argv_idx.item, 0)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___18 := strlen (l_argv[0])
							update_class_fields -- Current might have been changed; synchronize
							l_argv_idx.item := l_tmp___18.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 73 -- switch 1; break
				when 64 then -- switch 1, case 118;
						(create {P_GLOBALS_STATIC}).exmode_active.item := 0
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GUI_STATIC}).gui.item.item.starting := 0
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 65 then -- switch 1, case 119
						l_tmp___20 := (create {P_CHARSET_STATIC}).vim_isdigit ((create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0])[l_argv_idx.item]).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___20.to_boolean then
							l_tmp___19 := get_number_arg (create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]), l_argv_idx, 10)
							update_class_fields -- Current might have been changed; synchronize
							l_n := l_tmp___19.to_integer_32;
							(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("window")), l_n, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0)
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 73 -- switch 1; break
						end
				when 66 then
						l_want_argument := 1
						l_pos := -1 + 73 -- switch 1; break
				when 67 then -- switch 1, case 120
						Current.ask_for_key := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 68 then -- switch 1, case 88;
						(create {P_GLOBALS_STATIC}).x_no_connect.item := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 69 then -- switch 1, case 90;
						(create {P_GLOBALS_STATIC}).restricted.item := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 73 -- switch 1; break
				when 70 then -- switch 1, case 99
						if ((l_argv[0])[l_argv_idx.item]).to_integer_32 /= 0 then
							if n_commands >= 10 then
								mainerr (4, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
							end
							l_tmp___21 := n_commands
							Current.n_commands := n_commands + 1
							update_class_fields -- Current might have been changed; synchronize
							commands[l_tmp___21] := create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]) + l_argv_idx.item
							update_class_fields -- Current might have been changed; synchronize
							l_argv_idx.item := -1
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 73 -- switch 1; break
						end
				when 71 then -- switch 1, case 83 | switch 1, case 105 | switch 1, case 84 | switch 1, case 117 | switch 1, case 85 | switch 1, case 87
						l_want_argument := 1
						l_pos := -1 + 73 -- switch 1; break
				when 72 then -- switch 1, default:
						mainerr (0, create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]))
						update_class_fields -- Current might have been changed; synchronize
				when 73 then -- switch 1, done:
						if not (l_want_argument.to_boolean) then
							l_pos := -1 + 89 -- skip if block
						end
				when 74 then -- if:
						if ((l_argv[0])[l_argv_idx.item]).to_integer_32 /= 0 then
							mainerr (3, create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_argc := l_argc - 1
						if l_argc < 1 then
							if l_c /= 83 then
								mainerr_arg_missing (create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_argv := l_argv + 1
						l_argv_idx.item := -1
						update_class_fields -- Current might have been changed; synchronize
						inspect l_c -- switch 2 head
						when 99 then l_pos := -1 + 75
						when 83 then l_pos := -1 + 75
						when 45 then l_pos := -1 + 76
						when 113 then l_pos := -1 + 77
						when 105 then l_pos := -1 + 78
						when 115 then l_pos := -1 + 79
						when 116 then l_pos := -1 + 82
						when 84 then l_pos := -1 + 83
						when 117 then l_pos := -1 + 84
						when 85 then l_pos := -1 + 85
						when 119 then l_pos := -1 + 86
						when 87 then l_pos := -1 + 87
						else l_pos := -1 + 89
						end
				when 75 then -- switch 2, case 99 | switch 2, case 83
						if n_commands >= 10 then
							mainerr (4, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_c = 83 then
							if l_argc < 1 then
								l_a := ce_string ("Session.vim")
							elseif ((l_argv[0])[0]).to_integer_32 = 45 then
								l_a := ce_string ("Session.vim")
								l_argc := l_argc + 1
								l_argv := l_argv - 1
							else
								l_a := l_argv[0]
							end
							l_tmp___22 := strlen (l_a)
							update_class_fields -- Current might have been changed; synchronize
							l_p___0 := (create {P_MISC2_STATIC}).alloc (l_tmp___22 + {NATURAL_32} 4)
							update_class_fields -- Current might have been changed; synchronize
							if l_p___0.is_void then
								(create {P_OS_UNIX_STATIC}).mch_exit (2)
								update_class_fields -- Current might have been changed; synchronize
							end
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("so %%s"), l_a]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							cmds_tofree[n_commands] := (1).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___23 := n_commands
							Current.n_commands := n_commands + 1
							update_class_fields -- Current might have been changed; synchronize
							commands[l_tmp___23] := l_p___0
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___24 := n_commands
							Current.n_commands := n_commands + 1
							update_class_fields -- Current might have been changed; synchronize
							commands[l_tmp___24] := create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 89 -- switch 2; break
				when 76 then -- switch 2, case 45
						if ((l_argv[-1])[2]).to_integer_32 = 99 then
							if n_pre_commands >= 10 then
								mainerr (4, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
							end
							l_tmp___25 := n_pre_commands
							Current.n_pre_commands := n_pre_commands + 1
							update_class_fields -- Current might have been changed; synchronize
							pre_commands[l_tmp___25] := create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 89 -- switch 2; break
				when 77 then -- switch 2, case 113
						Current.use_ef := create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 89 -- switch 2; break
				when 78 then -- switch 2, case 105;
						(create {P_GLOBALS_STATIC}).use_viminfo.item := create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 89 -- switch 2; break
				when 79 then -- switch 2, case 115
						if ((create {P_GLOBALS_STATIC}).scriptin.item[0]).is_void then
							l_pos := -1 + 81 -- skip if block
						end
				when 80 then -- if: | scripterror:
						l_tmp___26 := gettext (ce_string ("Attempt to open script file again: %""))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).mch_errmsg (l_tmp___26)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).mch_errmsg (l_argv[-1])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).mch_errmsg (ce_string (" "))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).mch_errmsg (l_argv[0])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).mch_errmsg (ce_string ("%"%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_OS_UNIX_STATIC}).mch_exit (2)
						update_class_fields -- Current might have been changed; synchronize
				when 81 then -- if done;
						(create {P_GLOBALS_STATIC}).scriptin.item[0] := fopen (l_argv[0], ce_string ("r"))
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_GLOBALS_STATIC}).scriptin.item[0]).is_void then
							l_tmp___27 := gettext (ce_string ("Cannot open for reading: %""))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).mch_errmsg (l_tmp___27)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).mch_errmsg (l_argv[0])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).mch_errmsg (ce_string ("%"%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_OS_UNIX_STATIC}).mch_exit (2)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tmp___28 := (create {P_GETCHAR_STATIC}).save_typebuf
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___28 = 0 then
							(create {P_OS_UNIX_STATIC}).mch_exit (2)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 89 -- switch 2; break
				when 82 then -- switch 2, case 116
						Current.tagname := create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 89 -- switch 2; break
				when 83 then -- switch 2, case 84
						l_tmp___29 := (create {P_TERM_STATIC}).term_is_gui (create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___29.to_boolean then
							(create {P_GUI_STATIC}).gui.item.item.starting := 1
							update_class_fields -- Current might have been changed; synchronize
						else
							Current.term := create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 89 -- switch 2; break
				when 84 then -- switch 2, case 117
						Current.use_vimrc := create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 89 -- switch 2; break
				when 85 then -- switch 2, case 85;
						(create {P_GLOBALS_STATIC}).use_gvimrc.item := create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 89 -- switch 2; break
				when 86 then -- switch 2, case 119
						l_tmp___31 := (create {P_CHARSET_STATIC}).vim_isdigit (((create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0])).item).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___31.to_boolean then
							l_argv_idx.item := 0
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___30 := get_number_arg (create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]), l_argv_idx, 10)
							update_class_fields -- Current might have been changed; synchronize
							l_n := l_tmp___30.to_integer_32;
							(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("window")), l_n, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0)
							update_class_fields -- Current might have been changed; synchronize
							l_argv_idx.item := -1
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 89 -- switch 2; break
						end
				when 87 then -- switch 2, case 87
						if not ((create {P_GLOBALS_STATIC}).scriptout.item).is_void then
							l_pos := -1 + 80 -- goto scripterror
						end
				when 88 then
						if l_c = 119 then
							l_tmp___33 := ce_string ("a")
						else
							l_tmp___33 := ce_string ("w")
						end
						(create {P_GLOBALS_STATIC}).scriptout.item := fopen (l_argv[0], l_tmp___33)
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_GLOBALS_STATIC}).scriptout.item).is_void then
							l_tmp___32 := gettext (ce_string ("Cannot open for script output: %""))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).mch_errmsg (l_tmp___32)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).mch_errmsg (l_argv[0])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).mch_errmsg (ce_string ("%"%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_OS_UNIX_STATIC}).mch_exit (2)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 89 -- switch 2; break
				when 89 then -- switch 2, done: | if done | if block done, skip else block:
						l_pos := -1 + 91
				when 90 then -- else:
						l_pos := -1 + 92 -- goto _L___0
				when 91 then -- if done | if block done, skip else block:
						l_pos := -1 + 93
				when 92 then -- else: | _L___0:
						l_argv_idx.item := -1
						update_class_fields -- Current might have been changed; synchronize
						if edit_type /= 0 then
							if edit_type /= 1 then
								mainerr (1, create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						Current.edit_type := 1
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___34 := (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared ((create {P_GLOBALS_STATIC}).global_alist.item.item.c_pointer + (create {PD_ARGLIST}.make).offset_of ("al_ga"))).item.ga_grow (1)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___34 = 0 then
							(create {P_OS_UNIX_STATIC}).mch_exit (2)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_p___0 := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (l_argv[0]))
							update_class_fields -- Current might have been changed; synchronize
							if l_p___0.is_void then
								(create {P_OS_UNIX_STATIC}).mch_exit (2)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if diff_mode.to_boolean then
							l_tmp___37 := (create {P_OS_UNIX_STATIC}).mch_isdir (l_p___0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___37.to_boolean then
								if (create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_len > 0 then
									l_tmp___38 := (create {CE_CLASS_POINTER [PD_ARGENTRY]}.make_cast ((create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_data) + 0).item.alist_name
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___39 := (create {P_OS_UNIX_STATIC}).mch_isdir (l_tmp___38)
									update_class_fields -- Current might have been changed; synchronize
									if not l_tmp___39.to_boolean then
										l_tmp___35 := (create {CE_CLASS_POINTER [PD_ARGENTRY]}.make_cast ((create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_data) + 0).item.alist_name
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___36 := (create {P_MISC1_STATIC}).gettail (l_tmp___35)
										update_class_fields -- Current might have been changed; synchronize
										l_r := (create {P_MISC1_STATIC}).concat_fnames (l_p___0, l_tmp___36, 1)
										update_class_fields -- Current might have been changed; synchronize
										if not l_r.is_void then
											(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
											update_class_fields -- Current might have been changed; synchronize
											l_p___0 := l_r
										end
									end
								end
							end
						end
						((create {P_GLOBALS_STATIC}).global_alist.item).item.alist_add (l_p___0, 2)
						update_class_fields -- Current might have been changed; synchronize
				when 93 then -- if done
						if l_argv_idx.item <= 0 then
							l_argc := l_argc - 1
							l_argv := l_argv + 1
							l_argv_idx.item := 1
							update_class_fields -- Current might have been changed; synchronize
						elseif ((l_argv[0])[l_argv_idx.item]).to_integer_32 = 0 then
							l_argc := l_argc - 1
							l_argv := l_argv + 1
							l_argv_idx.item := 1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 1 -- back to loop condition
				when 94 then -- loop done
					if n_commands > 0 then
						l_tmp___40 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (commands[0]))
						update_class_fields -- Current might have been changed; synchronize
						l_p___0 := (create {P_MISC2_STATIC}).alloc (l_tmp___40 + {NATURAL_32} 3)
						update_class_fields -- Current might have been changed; synchronize
						if not l_p___0.is_void then
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string (":%%s%R"), commands[0]]).do_nothing
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_EVAL_STATIC}).set_vim_var_string (47, l_p___0, -1)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				when 95 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	create_windows
		local
			l_dorewind: INTEGER_32
			l_done___2: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_done___2 := 0
			if window_count = -1 then
				Current.window_count := 1
				update_class_fields -- Current might have been changed; synchronize
			end
			if window_count = 0 then
				Current.window_count := (create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_len
				update_class_fields -- Current might have been changed; synchronize
			end
			if window_count > 1 then
				if window_layout = 0 then
					Current.window_layout := 1
					update_class_fields -- Current might have been changed; synchronize
				end
				if window_layout = 3 then
					Current.window_count := make_tabpages (window_count)
					update_class_fields -- Current might have been changed; synchronize
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						(create {P_MAIN_STATIC}).time_msg (ce_string ("making tab pages"), create {CE_VOID_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
					end
				elseif ((create {P_GLOBALS_STATIC}).firstwin.item.item.w_next).is_void then
					Current.window_count := make_windows (window_count, (window_layout = 2).to_integer)
					update_class_fields -- Current might have been changed; synchronize
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						(create {P_MAIN_STATIC}).time_msg (ce_string ("making windows"), create {CE_VOID_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					Current.window_count := (create {P_WINDOW_STATIC}).win_count
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				Current.window_count := 1
				update_class_fields -- Current might have been changed; synchronize
			end
			if ((create {P_GLOBALS_STATIC}).recoverymode.item).to_boolean then
				(create {P_GLOBALS_STATIC}).msg_scroll.item := 1
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MEMLINE_STATIC}).ml_recover
				update_class_fields -- Current might have been changed; synchronize
				if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_mfp).is_void then
					(create {P_MAIN_STATIC}).getout (1)
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_BUFFER_STATIC}).do_modelines (0)
				update_class_fields -- Current might have been changed; synchronize
			else
				(create {P_GLOBALS_STATIC}).autocmd_no_enter.item := (create {P_GLOBALS_STATIC}).autocmd_no_enter.item + 1
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).autocmd_no_leave.item := (create {P_GLOBALS_STATIC}).autocmd_no_leave.item + 1
				update_class_fields -- Current might have been changed; synchronize
				l_dorewind := 1
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___0 := l_done___2
					l_done___2 := l_done___2 + 1
					if not (l_tmp___0 < 1_000) then
						l_break := True
					end
					if not (l_break) then
						if l_dorewind.to_boolean then
							if window_layout = 3 then
								(create {P_WINDOW_STATIC}).goto_tabpage (1)
								update_class_fields -- Current might have been changed; synchronize
							else
								(create {P_GLOBALS_STATIC}).curwin.item := (create {P_GLOBALS_STATIC}).firstwin.item
								update_class_fields -- Current might have been changed; synchronize
							end
						elseif window_layout = 3 then
							if ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_next).is_void then
								l_break := True
							end
							if not (l_break) then
								(create {P_WINDOW_STATIC}).goto_tabpage (0)
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_next).is_void then
								l_break := True
							end
							if not (l_break) then
								(create {P_GLOBALS_STATIC}).curwin.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_next
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
					if not (l_break) then
						l_dorewind := 0;
						(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_mfp).is_void then
							if (create {P_OPTION_STATIC}).p_fdls.item.item >= 0 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_fdl := (create {P_OPTION_STATIC}).p_fdls.item.item
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_GLOBALS_STATIC}).swap_exists_action.item := 1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_BUFFER_STATIC}).set_buflisted (1)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_BUFFER_STATIC}).open_buffer (0, create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), 0).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							if (create {P_GLOBALS_STATIC}).swap_exists_action.item = 2 then
								if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
									(create {P_GLOBALS_STATIC}).did_emsg.item := 0
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MAIN_STATIC}).getout (1)
									update_class_fields -- Current might have been changed; synchronize
								else
									l_tmp := (create {P_WINDOW_STATIC}).only_one_window
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp.to_boolean then
										(create {P_GLOBALS_STATIC}).did_emsg.item := 0
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_MAIN_STATIC}).getout (1)
										update_class_fields -- Current might have been changed; synchronize
									end
								end
								(create {P_BUFFER_STATIC}).setfname ((create {P_GLOBALS_STATIC}).curbuf.item, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0).do_nothing
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_arg_idx := -1
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_GLOBALS_STATIC}).swap_exists_action.item := 0
								update_class_fields -- Current might have been changed; synchronize
							else
								(create {P_BUFFER_STATIC}).handle_swap_exists (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
							end
							l_dorewind := 1
						end
						(create {P_UI_STATIC}).ui_breakcheck
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							(create {P_GETCHAR_STATIC}).vgetc.do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
					end
				end
				l_break := False
				if window_layout = 3 then
					(create {P_WINDOW_STATIC}).goto_tabpage (1)
					update_class_fields -- Current might have been changed; synchronize
				else
					(create {P_GLOBALS_STATIC}).curwin.item := (create {P_GLOBALS_STATIC}).firstwin.item
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).autocmd_no_enter.item := (create {P_GLOBALS_STATIC}).autocmd_no_enter.item - 1
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).autocmd_no_leave.item := (create {P_GLOBALS_STATIC}).autocmd_no_leave.item - 1
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	edit_buffers
		local
			l_arg_idx: INTEGER_32
			l_i___0: INTEGER_32
			l_advance: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_advance := 1;
					(create {P_GLOBALS_STATIC}).autocmd_no_enter.item := (create {P_GLOBALS_STATIC}).autocmd_no_enter.item + 1
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GLOBALS_STATIC}).autocmd_no_leave.item := (create {P_GLOBALS_STATIC}).autocmd_no_leave.item + 1
					update_class_fields -- Current might have been changed; synchronize
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_arg_idx = -1 then
						(create {P_WINDOW_STATIC}).win_close ((create {P_GLOBALS_STATIC}).curwin.item, 1)
						update_class_fields -- Current might have been changed; synchronize
						l_advance := 0
					end
					l_arg_idx := 1
					l_i___0 := 1
				when 1 then -- loop condition:
					if not (not (l_break) and then (l_i___0 < window_count)) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_arg_idx = -1 then
							l_arg_idx := l_arg_idx + 1;
							(create {P_WINDOW_STATIC}).win_close ((create {P_GLOBALS_STATIC}).curwin.item, 1)
							update_class_fields -- Current might have been changed; synchronize
							l_advance := 0
							l_continue := True
						end
						if not (l_break or l_continue) and then (l_advance.to_boolean) then
							if window_layout = 3 then
								if ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_next).is_void then
									l_break := True
								end
								if not (l_break or l_continue) then
									(create {P_WINDOW_STATIC}).goto_tabpage (0)
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_next).is_void then
									l_break := True
								end
								if not (l_break or l_continue) then
									(create {P_WINDOW_STATIC}).win_enter ((create {P_GLOBALS_STATIC}).curwin.item.item.w_next, 0)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if (l_break or l_continue) then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						l_advance := 1
						if not (((create {P_GLOBALS_STATIC}).curbuf.item).is_equal ((create {P_GLOBALS_STATIC}).firstwin.item.item.w_buffer)) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void) then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_arg_idx := l_arg_idx
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).swap_exists_did_quit.item := 0
						update_class_fields -- Current might have been changed; synchronize
						if l_arg_idx < (create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_len then
							l_tmp := (create {CE_CLASS_POINTER [PD_ARGENTRY]}.make_cast ((create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_data) + l_arg_idx).item.alist_name
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___0 := l_tmp
						else
							l_tmp___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
						(create {P_EX_CMDS_STATIC}).do_ecmd (0, l_tmp___0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), (0).to_integer_32, 1, (create {P_GLOBALS_STATIC}).curwin.item).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_GLOBALS_STATIC}).swap_exists_did_quit.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								(create {P_GLOBALS_STATIC}).did_emsg.item := 0
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MAIN_STATIC}).getout (1)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___1 := (create {P_WINDOW_STATIC}).only_one_window
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___1.to_boolean then
									(create {P_GLOBALS_STATIC}).did_emsg.item := 0
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MAIN_STATIC}).getout (1)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							(create {P_WINDOW_STATIC}).win_close ((create {P_GLOBALS_STATIC}).curwin.item, 1)
							update_class_fields -- Current might have been changed; synchronize
							l_advance := 0
						end
						if l_arg_idx = (create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_len - 1 then
							(create {P_GLOBALS_STATIC}).arg_had_last.item := 1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_arg_idx := l_arg_idx + 1
				when 8 then -- if done;
						(create {P_UI_STATIC}).ui_breakcheck
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							(create {P_GETCHAR_STATIC}).vgetc.do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
				when 9 then -- if done
						if (not l_break) then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					l_break := False
					l_continue := False
					if window_layout = 3 then
						(create {P_WINDOW_STATIC}).goto_tabpage (1)
						update_class_fields -- Current might have been changed; synchronize
					end
					(create {P_GLOBALS_STATIC}).autocmd_no_enter.item := (create {P_GLOBALS_STATIC}).autocmd_no_enter.item - 1
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_WINDOW_STATIC}).win_enter ((create {P_GLOBALS_STATIC}).firstwin.item, 0)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GLOBALS_STATIC}).autocmd_no_leave.item := (create {P_GLOBALS_STATIC}).autocmd_no_leave.item - 1
					update_class_fields -- Current might have been changed; synchronize
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						(create {P_MAIN_STATIC}).time_msg (ce_string ("editing files in windows"), create {CE_VOID_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
					end
					if window_count > 1 then
						if window_layout /= 3 then
							(create {P_WINDOW_STATIC}).win_equal ((create {P_GLOBALS_STATIC}).curwin.item, 0, ('b').code)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	exe_pre_commands
		local
			l_cmds___0: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_cnt: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
		do
			l_cmds___0 := pre_commands
			l_cnt := n_pre_commands
			if l_cnt > 0 then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := gettext (ce_string ("pre-vimrc command line"))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).sourcing_name.item := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).current_SID.item := -2
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := 0
				from
				until
					not (l_i___0 < l_cnt)
				loop
					(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd (l_cmds___0[l_i___0]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := l_i___0 + 1
				end
				(create {P_GLOBALS_STATIC}).sourcing_name.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).current_SID.item := 0
				update_class_fields -- Current might have been changed; synchronize
				if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
					(create {P_MAIN_STATIC}).time_msg (ce_string ("--cmd commands"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	exe_commands
		local
			l_i___0: INTEGER_32
		do
			(create {P_GLOBALS_STATIC}).msg_scroll.item := 1
			update_class_fields -- Current might have been changed; synchronize
			if tagname.is_void then
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum <= 1 then
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (0).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			(create {P_GLOBALS_STATIC}).sourcing_name.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("command line"))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).current_SID.item := -3
			update_class_fields -- Current might have been changed; synchronize
			l_i___0 := 0
			from
			until
				not (l_i___0 < n_commands)
			loop
				(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd (commands[l_i___0]).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				if (cmds_tofree[l_i___0]).to_boolean then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (commands[l_i___0]))
					update_class_fields -- Current might have been changed; synchronize
				end
				l_i___0 := l_i___0 + 1
			end
			(create {P_GLOBALS_STATIC}).sourcing_name.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).current_SID.item := 0
			update_class_fields -- Current might have been changed; synchronize
			if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = 0 then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (1).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
			if not ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
				(create {P_GLOBALS_STATIC}).msg_scroll.item := 0
				update_class_fields -- Current might have been changed; synchronize
			end
			if edit_type = 4 then
				(create {P_QUICKFIX_STATIC}).qf_jump (create {CE_CLASS_POINTER [PD_QF_INFO_S]}.make_shared (default_pointer), 0, 0, 0)
				update_class_fields -- Current might have been changed; synchronize
			end
			if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
				(create {P_MAIN_STATIC}).time_msg (ce_string ("executing command arguments"), create {CE_VOID_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	source_startup_scripts
		local
			l_i___0: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if evim_mode.to_boolean then
						(create {P_EX_CMDS2_STATIC}).do_source (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("$VIMRUNTIME/evim.vim")), 0, 0).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
							(create {P_MAIN_STATIC}).time_msg (ce_string ("source evim file"), create {CE_VOID_POINTER}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if use_vimrc.is_void then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_tmp___1 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (use_vimrc), ce_string ("NONE"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1 /= 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						l_tmp___2 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (use_vimrc), ce_string ("NORC"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2 /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if ((create {P_GLOBALS_STATIC}).use_gvimrc.item).is_void then
							(create {P_GLOBALS_STATIC}).use_gvimrc.item := use_vimrc
							update_class_fields -- Current might have been changed; synchronize
						end
						if (use_vimrc[2]).to_integer_32 = 78 then
							(create {P_OPTION_STATIC}).p_lpl.item.item := 0
							update_class_fields -- Current might have been changed; synchronize
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_tmp___0 := (create {P_EX_CMDS2_STATIC}).do_source (use_vimrc, 0, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0 /= 1 then
							l_tmp := gettext (ce_string ("E282: Cannot read from %"%%s%""))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp), use_vimrc).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
				when 8 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						if not ((create {P_GLOBALS_STATIC}).silent_mode.item).to_boolean then
							(create {P_EX_CMDS2_STATIC}).do_source (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("$VIM/vimrc")), 0, 0).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___7 := (create {P_MAIN_STATIC}).process_env (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("VIMINIT")), 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___7 /= 1 then
								l_tmp___3 := (create {P_EX_CMDS2_STATIC}).do_source (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("$HOME/.vimrc")), 1, 1)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___3 = 0 then
									l_tmp___4 := (create {P_MAIN_STATIC}).process_env (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("EXINIT")), 0)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___4 = 0 then
										l_tmp___5 := (create {P_EX_CMDS2_STATIC}).do_source (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("$HOME/.exrc")), 0, 0)
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___5 = 0 then
											l_tmp___6 := 1
										else
											l_tmp___6 := 0
										end
									else
										l_tmp___6 := 0
									end
								else
									l_tmp___6 := 0
								end
							end
							if ((create {P_OPTION_STATIC}).p_exrc.item.item).to_boolean then
								l_tmp___8 := file_owned (ce_string (".vimrc"))
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___8.to_boolean then
									(create {P_GLOBALS_STATIC}).secure.item := (create {P_OPTION_STATIC}).p_secure.item.item
									update_class_fields -- Current might have been changed; synchronize
								end
								l_i___0 := 0
								l_tmp___9 := (create {P_MISC1_STATIC}).fullpathcmp (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("$HOME/.vimrc")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".vimrc")), 0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___9 /= 1 then
									l_tmp___10 := (create {P_MISC1_STATIC}).fullpathcmp (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("$VIM/vimrc")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".vimrc")), 0)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___10 /= 1 then
										l_i___0 := (create {P_EX_CMDS2_STATIC}).do_source (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".vimrc")), 1, 1)
										update_class_fields -- Current might have been changed; synchronize
									end
								end
								if l_i___0 = 0 then
									l_tmp___11 := file_owned (ce_string (".exrc"))
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___11.to_boolean then
										(create {P_GLOBALS_STATIC}).secure.item := 0
										update_class_fields -- Current might have been changed; synchronize
									else
										(create {P_GLOBALS_STATIC}).secure.item := (create {P_OPTION_STATIC}).p_secure.item.item
										update_class_fields -- Current might have been changed; synchronize
									end
									l_tmp___12 := (create {P_MISC1_STATIC}).fullpathcmp (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("$HOME/.exrc")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".exrc")), 0)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___12 /= 1 then
										(create {P_EX_CMDS2_STATIC}).do_source (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".exrc")), 0, 0).do_nothing
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
							if (create {P_GLOBALS_STATIC}).secure.item = 2 then
								(create {P_GLOBALS_STATIC}).need_wait_return.item := 1
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_GLOBALS_STATIC}).secure.item := 0
							update_class_fields -- Current might have been changed; synchronize
						end
				when 10 then
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						(create {P_MAIN_STATIC}).time_msg (ce_string ("sourcing vimrc file(s)"), create {CE_VOID_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	exec_on_server
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (serverName_arg.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if (serverName_arg.item).to_integer_32 = 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if serverArg.to_boolean then
							cmdsrv_main (create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_MPARM_T}.make).offset_of ("argc")), argv, serverName_arg, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (c_pointer + (create {PD_MPARM_T}.make).offset_of ("serverStr")))
							update_class_fields -- Current might have been changed; synchronize
							Current.serverStrEnc := (create {P_MISC2_STATIC}).vim_strsave ((create {P_OPTION_STATIC}).p_enc.item.item)
							update_class_fields -- Current might have been changed; synchronize
						end
						Current.servername := serverMakeName (serverName_arg, argv[0])
						update_class_fields -- Current might have been changed; synchronize
				when 5 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	prepare_server
		local
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: NATURAL_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
						l_tmp___1 := (create {P_GUI_GTK_X11_STATIC}).gui_mch_get_display
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := l_tmp___1
					else
						l_tmp___2 := (create {P_GLOBALS_STATIC}).xterm_dpy.item.item
					end
					if l_tmp___2.is_void then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if servername.is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						if not (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_tmp___3 := getuid
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___3 /= {NATURAL_32} 0 then
							l_pos := -1 + 6 -- goto _L
						else
							l_pos := -1 + 5 -- goto _L___0
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else: | _L___0:
						if serverName_arg.is_void then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L:
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							l_tmp := (create {P_GUI_GTK_X11_STATIC}).gui_mch_get_display
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___0 := l_tmp
						else
							l_tmp___0 := (create {P_GLOBALS_STATIC}).xterm_dpy.item.item
						end
						(create {P_IF_XCMDSRV_STATIC}).serverRegisterName (l_tmp___0, servername).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (servername))
						update_class_fields -- Current might have been changed; synchronize
						if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
							(create {P_MAIN_STATIC}).time_msg (ce_string ("register server name"), create {CE_VOID_POINTER}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:;
						(create {P_GLOBALS_STATIC}).serverDelayedStartName.item := servername
						update_class_fields -- Current might have been changed; synchronize
				when 9 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:;
						(create {P_GLOBALS_STATIC}).serverDelayedStartName.item := servername
						update_class_fields -- Current might have been changed; synchronize
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:;
						(create {P_GLOBALS_STATIC}).serverDelayedStartName.item := servername
						update_class_fields -- Current might have been changed; synchronize
				when 13 then
					if not serverStr.is_void then
						l_tmp___4 := (create {P_MAIN_STATIC}).serverConvert (serverStrEnc, serverStr, l_p___0)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MAIN_STATIC}).server_to_input_buf (l_tmp___4)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0.item))
						update_class_fields -- Current might have been changed; synchronize
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {PD_MPARM_T} -- private routines

	main_start_gui
		do
			(create {P_GUI_STATIC}).gui.item.item.starting := 1
		end

	change_compatible (a_on: INTEGER_32)
		local
			l_opt_idx: INTEGER_32
		do
			if (create {P_OPTION_STATIC}).p_cp.item.item /= a_on then
				(create {P_OPTION_STATIC}).p_cp.item.item := a_on;
				(create {P_OPTION_STATIC}).compatible_set
			end
			l_opt_idx := (create {P_OPTION_STATIC}).findoption (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cp")))
			if l_opt_idx >= 0 then
				(create {P_OPTION_STATIC}).options.item[l_opt_idx].flags := ((create {P_OPTION_STATIC}).options.item[l_opt_idx].flags).bit_or (({NATURAL_32} 256))
			end
		end

	get_number_arg (a_p___0: CE_POINTER [NATURAL_8]; a_idx: CE_POINTER [INTEGER_32]; a_def: INTEGER_32): INTEGER_32
		require
			not a_p___0.is_void
			not a_idx.is_void
		local
			l_def: INTEGER_32
			l_break: BOOLEAN
		do
			l_def := a_def
			if ((create {P_CHARSET_STATIC}).vim_isdigit ((a_p___0[a_idx.item]).to_integer_32)).to_boolean then
				l_def := atoi (create {CE_INTEGER_8_POINTER}.make_cast ((a_p___0 + a_idx.item)))
				from
				until
					(l_break)
				loop
					l_break := False
					if not ((create {P_CHARSET_STATIC}).vim_isdigit ((a_p___0[a_idx.item]).to_integer_32)).to_boolean then
						l_break := True
					end
					if not (l_break) then
						a_idx.item := (a_idx.item) + 1
					end
				end
				l_break := False
			end
			Result := l_def
		end

	file_owned (a_fname: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_fname.is_void
		local
			l_s: CE_ARRAY [SD_STAT]
			l_uid: NATURAL_32
			l_tmp___2: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_s.make (<<1>>)

			l_uid := (getuid)
			if (stat (a_fname, l_s)) /= 0 then
				l_tmp___2 := 0
			elseif l_s.item.st_uid /= l_uid then
				l_tmp___2 := 0
			elseif (lstat (a_fname, l_s)) /= 0 then
				l_tmp___2 := 0
			elseif l_s.item.st_uid /= l_uid then
				l_tmp___2 := 0
			else
				l_tmp___2 := 1
			end
			Result := l_tmp___2
		end

	usage
		local
			l_i___0: INTEGER_32
			l_break: BOOLEAN
		do
			(create {P_OS_UNIX_STATIC}).reset_signals;
			(create {P_MESSAGE_STATIC}).mch_msg ((create {P_VERSION_STATIC}).longVersion.item);
			(create {P_MESSAGE_STATIC}).mch_msg ((gettext (ce_string ("%N%Nusage:"))))
			l_i___0 := 0
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_MESSAGE_STATIC}).mch_msg ((gettext (ce_string (" vim [arguments] "))));
				(create {P_MESSAGE_STATIC}).mch_msg ((gettext (use.item[l_i___0])))
				if l_i___0.to_natural_32 = ({PLATFORM}.Pointer_bytes.to_natural_32 * (4).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32 - {NATURAL_32} 1 then
					l_break := True
				end
				if not (l_break) then
					(create {P_MESSAGE_STATIC}).mch_msg ((gettext (ce_string ("%N   or:"))))
					l_i___0 := l_i___0 + 1
				end
			end
			l_break := False;
			(create {P_MESSAGE_STATIC}).mch_msg ((gettext (ce_string ("%N%NArguments:%N"))))
			main_msg ((gettext (ce_string ("--%T%T%TOnly file names after this"))))
			main_msg ((gettext (ce_string ("-g%T%T%TRun using GUI (like %"gvim%")"))))
			main_msg ((gettext (ce_string ("-f  or  --nofork%TForeground: Don%'t fork when starting GUI"))))
			main_msg ((gettext (ce_string ("-v%T%T%TVi mode (like %"vi%")"))))
			main_msg ((gettext (ce_string ("-e%T%T%TEx mode (like %"ex%")"))))
			main_msg ((gettext (ce_string ("-s%T%T%TSilent (batch) mode (only for %"ex%")"))))
			main_msg ((gettext (ce_string ("-d%T%T%TDiff mode (like %"vimdiff%")"))))
			main_msg ((gettext (ce_string ("-y%T%T%TEasy mode (like %"evim%", modeless)"))))
			main_msg ((gettext (ce_string ("-R%T%T%TReadonly mode (like %"view%")"))))
			main_msg ((gettext (ce_string ("-Z%T%T%TRestricted mode (like %"rvim%")"))))
			main_msg ((gettext (ce_string ("-m%T%T%TModifications (writing files) not allowed"))))
			main_msg ((gettext (ce_string ("-M%T%T%TModifications in text not allowed"))))
			main_msg ((gettext (ce_string ("-b%T%T%TBinary mode"))))
			main_msg ((gettext (ce_string ("-l%T%T%TLisp mode"))))
			main_msg ((gettext (ce_string ("-C%T%T%TCompatible with Vi: %'compatible%'"))))
			main_msg ((gettext (ce_string ("-N%T%T%TNot fully Vi compatible: %'nocompatible%'"))))
			main_msg ((gettext (ce_string ("-V[N][fname]%T%TBe verbose [level N] [log messages to fname]"))))
			main_msg ((gettext (ce_string ("-D%T%T%TDebugging mode"))))
			main_msg ((gettext (ce_string ("-n%T%T%TNo swap file, use memory only"))))
			main_msg ((gettext (ce_string ("-r%T%T%TList swap files and exit"))))
			main_msg ((gettext (ce_string ("-r (with file name)%TRecover crashed session"))))
			main_msg ((gettext (ce_string ("-L%T%T%TSame as -r"))))
			main_msg ((gettext (ce_string ("-T <terminal>%TSet terminal type to <terminal>"))))
			main_msg ((gettext (ce_string ("-u <vimrc>%T%TUse <vimrc> instead of any .vimrc"))))
			main_msg ((gettext (ce_string ("-U <gvimrc>%T%TUse <gvimrc> instead of any .gvimrc"))))
			main_msg ((gettext (ce_string ("--noplugin%T%TDon%'t load plugin scripts"))))
			main_msg ((gettext (ce_string ("-p[N]%T%TOpen N tab pages (default: one for each file)"))))
			main_msg ((gettext (ce_string ("-o[N]%T%TOpen N windows (default: one for each file)"))))
			main_msg ((gettext (ce_string ("-O[N]%T%TLike -o but split vertically"))))
			main_msg ((gettext (ce_string ("+%T%T%TStart at end of file"))))
			main_msg ((gettext (ce_string ("+<lnum>%T%TStart at line <lnum>"))))
			main_msg ((gettext (ce_string ("--cmd <command>%TExecute <command> before loading any vimrc file"))))
			main_msg ((gettext (ce_string ("-c <command>%T%TExecute <command> after loading the first file"))))
			main_msg ((gettext (ce_string ("-S <session>%T%TSource file <session> after loading the first file"))))
			main_msg ((gettext (ce_string ("-s <scriptin>%TRead Normal mode commands from file <scriptin>"))))
			main_msg ((gettext (ce_string ("-w <scriptout>%TAppend all typed commands to file <scriptout>"))))
			main_msg ((gettext (ce_string ("-W <scriptout>%TWrite all typed commands to file <scriptout>"))))
			main_msg ((gettext (ce_string ("-x%T%T%TEdit encrypted files"))))
			main_msg ((gettext (ce_string ("-X%T%T%TDo not connect to X server"))))
			main_msg ((gettext (ce_string ("--remote <files>%TEdit <files> in a Vim server if possible"))))
			main_msg ((gettext (ce_string ("--remote-silent <files>  Same, don%'t complain if there is no server"))))
			main_msg ((gettext (ce_string ("--remote-wait <files>  As --remote but wait for files to have been edited"))))
			main_msg ((gettext (ce_string ("--remote-wait-silent <files>  Same, don%'t complain if there is no server"))))
			main_msg ((gettext (ce_string ("--remote-tab[-wait][-silent] <files>  As --remote but use tab page per file"))))
			main_msg ((gettext (ce_string ("--remote-send <keys>%TSend <keys> to a Vim server and exit"))))
			main_msg ((gettext (ce_string ("--remote-expr <expr>%TEvaluate <expr> in a Vim server and print result"))))
			main_msg ((gettext (ce_string ("--serverlist%T%TList available Vim server names and exit"))))
			main_msg ((gettext (ce_string ("--servername <name>%TSend to/become the Vim server <name>"))))
			main_msg ((gettext (ce_string ("--startuptime <file>%TWrite startup timing messages to <file>"))))
			main_msg ((gettext (ce_string ("-i <viminfo>%T%TUse <viminfo> instead of .viminfo"))))
			main_msg ((gettext (ce_string ("-h  or  --help%TPrint Help (this message) and exit"))))
			main_msg ((gettext (ce_string ("--version%T%TPrint version information and exit"))));
			(create {P_MESSAGE_STATIC}).mch_msg ((gettext (ce_string ("%NArguments recognised by gvim (GTK+ version):%N"))))
			main_msg ((gettext (ce_string ("-font <font>%T%TUse <font> for normal text (also: -fn)"))))
			main_msg ((gettext (ce_string ("-geometry <geom>%TUse <geom> for initial geometry (also: -geom)"))))
			main_msg ((gettext (ce_string ("-reverse%T%TUse reverse video (also: -rv)"))))
			main_msg ((gettext (ce_string ("-display <display>%TRun vim on <display> (also: --display)"))))
			main_msg ((gettext (ce_string ("--role <role>%TSet a unique role to identify the main window"))))
			main_msg ((gettext (ce_string ("--socketid <xid>%TOpen Vim inside another GTK widget"))));
			(create {P_OS_UNIX_STATIC}).mch_exit (0)
		end

	main_msg (a_s: CE_POINTER [INTEGER_8])
		do
			(create {P_MESSAGE_STATIC}).mch_msg (ce_string ("   "));
			(create {P_MESSAGE_STATIC}).mch_msg (a_s);
			(create {P_MESSAGE_STATIC}).mch_msg (ce_string ("%N"))
		end

	cmdsrv_main (a_argc: CE_POINTER [INTEGER_32]; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]; a_serverName_arg: CE_POINTER [NATURAL_8]; a_serverStr: CE_POINTER [CE_POINTER [NATURAL_8]])
		require
			not a_argc.is_void
			not a_argv.is_void
		local
			l_res: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_i___0: INTEGER_32
			l_sname: CE_POINTER [NATURAL_8]
			l_ret: INTEGER_32
			l_didone: INTEGER_32
			l_exiterr: INTEGER_32
			l_newArgV: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_newArgC: INTEGER_32
			l_Argc: INTEGER_32
			l_argtype: INTEGER_32
			l_silent: INTEGER_32
			l_tabs: INTEGER_32
			l_srv: CE_ARRAY [NATURAL_32]
			l_tmp: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_p___0: CE_POINTER [INTEGER_8]
			l_numFiles: INTEGER_32
			l_j: INTEGER_32
			l_done___2: CE_POINTER [NATURAL_8]
			l_p___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___15: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_res.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_srv.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___1.make (<<1>>)

			l_didone := 0
			l_exiterr := 0
			l_newArgV := a_argv + 1
			l_newArgC := 1
			l_Argc := a_argc.item
			l_silent := 0
			l_tabs := 0;
			(create {P_OS_UNIX_STATIC}).setup_term_clip
			l_sname := serverMakeName (a_serverName_arg, a_argv[0])
			if l_sname.is_void then
				l_return := True
			end
			if not l_return then
				l_i___0 := 1
				from
				until
					not (not (l_return or l_break) and then (l_i___0 < l_Argc))
				loop
					l_break := False
					l_continue := False
					l_res.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					if (strcmp (a_argv[l_i___0], ce_string ("--"))) = 0 then
						from
						until
							not (l_i___0 < a_argc.item)
						loop
							l_tmp := l_newArgV
							l_newArgV := l_newArgV + 1
							l_tmp.item := a_argv[l_i___0]
							l_newArgC := l_newArgC + 1
							l_i___0 := l_i___0 + 1
						end
						l_break := True
					end
					if not (l_return or l_break or l_continue) then
						if (strcasecmp (a_argv[l_i___0], ce_string ("--remote-send"))) = 0 then
							l_argtype := 3
						elseif (strncasecmp (a_argv[l_i___0], ce_string ("--remote"), (8).to_natural_32)) = 0 then
							l_p___0 := a_argv[l_i___0] + 8
							l_argtype := 1
							from
							until
								not (not (l_break) and then ((l_p___0[0]).to_integer_32 /= 0))
							loop
								l_break := False
								if (strncasecmp (l_p___0, ce_string ("-wait"), (5).to_natural_32)) = 0 then
									l_argtype := 2
									l_p___0 := l_p___0 + (5)
								elseif (strncasecmp (l_p___0, ce_string ("-silent"), (7).to_natural_32)) = 0 then
									l_silent := 1
									l_p___0 := l_p___0 + (7)
								elseif (strncasecmp (l_p___0, ce_string ("-tab"), (4).to_natural_32)) = 0 then
									l_tabs := 1
									l_p___0 := l_p___0 + (4)
								else
									l_argtype := 0
									l_break := True
								end
							end
							l_break := False
						else
							l_argtype := 0
						end
						if l_argtype /= 0 then
							if l_i___0 = a_argc.item - 1 then
								mainerr_arg_missing (create {CE_NATURAL_8_POINTER}.make_cast (a_argv[l_i___0]))
							end
							if l_argtype = 3 then
								a_serverStr.item := create {CE_NATURAL_8_POINTER}.make_cast (a_argv[(l_i___0 + 1)])
								l_i___0 := l_i___0 + 1
							else
								a_serverStr.item := build_drop_cmd ((a_argc.item - l_i___0) - 1, (a_argv + l_i___0) + 1, l_tabs, (l_argtype = 2).to_integer)
								if (a_serverStr.item).is_void then
									l_didone := 1
									l_exiterr := 1
									l_break := True
								end
								if not (l_return or l_break or l_continue) then
									l_Argc := l_i___0
								end
							end
							if not (l_return or l_break or l_continue) then
								if ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item).is_void then
									(create {P_MESSAGE_STATIC}).mch_errmsg ((gettext (ce_string ("No display"))))
									l_ret := -1
								else
									l_ret := (create {P_IF_XCMDSRV_STATIC}).serverSendToVim ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item, l_sname, a_serverStr.item, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), l_srv, 0, 0, l_silent)
								end
								if l_ret < 0 then
									if l_argtype = 3 then
										(create {P_MESSAGE_STATIC}).mch_errmsg ((gettext (ce_string (": Send failed.%N"))))
										l_didone := 1
										l_exiterr := 1
									elseif not l_silent.to_boolean then
										(create {P_MESSAGE_STATIC}).mch_errmsg ((gettext (ce_string (": Send failed. Trying to execute locally%N"))))
									end
									l_break := True
								end
							end
							if not (l_return or l_break or l_continue) and then (l_ret >= 0) then
								if l_argtype = 2 then
									l_numFiles := (a_argc.item - l_i___0) - 1
									l_done___2 := ((create {P_MISC2_STATIC}).alloc (l_numFiles.to_natural_32))
									if l_numFiles > 0 then
										if ((a_argv[(l_i___0 + 1)])[0]).to_integer_32 = 43 then
											l_numFiles := l_numFiles - 1
										end
									end
									memset (create {CE_VOID_POINTER}.make_cast (l_done___2), 0, l_numFiles.to_natural_32).do_nothing
									from
									until
										(l_break)
									loop
										l_break := False
										if (memchr (create {CE_VOID_POINTER}.make_cast (l_done___2), 0, l_numFiles.to_natural_32)).is_void then
											l_break := True
										end
										if not (l_break) then
											if ((create {P_IF_XCMDSRV_STATIC}).serverReadReply ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item, l_srv.item, l_p___1, 1)) < 0 then
												l_break := True
											end
										end
										if not (l_break) then
											l_j := atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_p___1.item))
											if l_j >= 0 then
												if l_j < l_numFiles then
													l_done___2[l_j] := (1).to_natural_8
												end
											end
										end
									end
									l_break := False
								end
							end
						elseif (strcasecmp (a_argv[l_i___0], ce_string ("--remote-expr"))) = 0 then
							if l_i___0 = a_argc.item - 1 then
								mainerr_arg_missing (create {CE_NATURAL_8_POINTER}.make_cast (a_argv[l_i___0]))
							end
							if ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item).is_void then
								(create {P_MESSAGE_STATIC}).mch_errmsg ((gettext (ce_string ("No display: Send expression failed.%N"))))
							elseif ((create {P_IF_XCMDSRV_STATIC}).serverSendToVim ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item, l_sname, create {CE_NATURAL_8_POINTER}.make_cast (a_argv[(l_i___0 + 1)]), l_res, create {CE_NATURAL_32_POINTER}.make_shared (default_pointer), 1, 1, 0)) < 0 then
								if not (l_res.item).is_void then
									if (l_res.item.item).to_integer_32 /= 0 then
										(create {P_MESSAGE_STATIC}).mch_errmsg (create {CE_INTEGER_8_POINTER}.make_cast (l_res.item));
										(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_res.item))
										l_res.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
									end
								end
								(create {P_MESSAGE_STATIC}).mch_errmsg ((gettext (ce_string (": Send expression failed.%N"))))
							end
						elseif (strcasecmp (a_argv[l_i___0], ce_string ("--serverlist"))) = 0 then
							if not ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item).is_void then
								l_res.item := (create {P_IF_XCMDSRV_STATIC}).serverGetVimNames ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item)
							end
							if ((create {P_GLOBALS_STATIC}).called_emsg.item).to_boolean then
								(create {P_MESSAGE_STATIC}).mch_errmsg (ce_string ("%N"))
							end
						elseif (strcasecmp (a_argv[l_i___0], ce_string ("--servername"))) = 0 then
							l_i___0 := l_i___0 + 1
							l_continue := True
						else
							l_tmp___15 := l_newArgV
							l_newArgV := l_newArgV + 1
							l_tmp___15.item := a_argv[l_i___0]
							l_newArgC := l_newArgC + 1
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) then
						l_didone := 1
						if not (l_res.item).is_void then
							if (l_res.item.item).to_integer_32 /= 0 then
								(create {P_MESSAGE_STATIC}).mch_msg (create {CE_INTEGER_8_POINTER}.make_cast (l_res.item))
								if (l_res.item[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_res.item))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 10 then
									(create {P_MESSAGE_STATIC}).mch_msg (ce_string ("%N"))
								end
							end
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_res.item))
					end
					if (not l_return and not l_break) then
						l_i___0 := l_i___0 + 1
					end
				end
				l_break := False
				l_continue := False
				if l_didone.to_boolean then
					(create {P_GUI_STATIC}).display_errors
					exit (l_exiterr)
				end
				a_argc.item := l_newArgC;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_sname))
			end
		end

	serverMakeName (a_arg: CE_POINTER [NATURAL_8]; a_cmd: CE_POINTER [INTEGER_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_arg.is_void then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_arg.item).to_integer_32 /= 0 then
							l_p___0 := (create {P_MISC2_STATIC}).vim_strsave_up (a_arg)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_p___0 := (create {P_MISC2_STATIC}).vim_strsave_up (((create {P_MISC1_STATIC}).gettail (create {CE_NATURAL_8_POINTER}.make_cast (a_cmd))))
						if not l_p___0.is_void then
							if not ((create {P_MISC2_STATIC}).vim_strchr (l_p___0, ('.').code)).is_void then
								((create {P_MISC2_STATIC}).vim_strchr (l_p___0, ('.').code)).item := (('%/0/').code).to_natural_8
							end
						end
				when 4 then
					Result := l_p___0
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	build_drop_cmd (a_filec: INTEGER_32; a_filev: CE_POINTER [CE_POINTER [INTEGER_8]]; a_tabs, a_sendReply: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_filec: INTEGER_32
			l_filev: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_i___0: INTEGER_32
			l_inicmd: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_cwd: CE_ARRAY [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_cwd.make (<<4_096>>)

			l_filec := a_filec
			l_filev := a_filev
			l_inicmd := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if l_filec > 0 then
				if ((l_filev[0])[0]).to_integer_32 = 43 then
					l_inicmd := create {CE_NATURAL_8_POINTER}.make_cast (l_filev[0]) + 1
					l_filev := l_filev + 1
					l_filec := l_filec - 1
				end
			end
			if l_filec <= 0 then
				mainerr_arg_missing (create {CE_NATURAL_8_POINTER}.make_cast (l_filev[-1]))
			end
			if ((create {P_OS_UNIX_STATIC}).mch_dirname (l_cwd, 4_096)) /= 1 then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_p___0 := (create {P_MISC2_STATIC}).vim_strsave_escaped_ext (l_cwd, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" %T%N*?[{`$\%%#%'%"|!<")), ('\').code, 1)
				if l_p___0.is_void then
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_ga.item.ga_init2 (1, 100)
				l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<C-\><C-N>:cd ")))
				l_ga.item.ga_concat (l_p___0);
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
				l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<CR>:if exists(%'*inputsave%')|call inputsave()|endif|")))
				if a_tabs.to_boolean then
					l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tab ")))
				end
				l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("drop")))
				l_i___0 := 0
				from
				until
					not (not (l_return) and then (l_i___0 < l_filec))
				loop
					l_p___0 := (create {P_MISC2_STATIC}).vim_strsave_escaped (create {CE_NATURAL_8_POINTER}.make_cast (l_filev[l_i___0]), create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" %T%N*?[{`$\%%#%'%"|!<")))
					if l_p___0.is_void then
						(create {P_MISC2_STATIC}).vim_free (l_ga.item.ga_data)
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
						l_ga.item.ga_concat (l_p___0);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not l_return then
				l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("|if exists(%'*inputrestore%')|call inputrestore()|endif<CR>")))
				l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<C-\><C-N>:cd -")))
				if a_sendReply.to_boolean then
					l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<CR>:call SetupRemoteReplies()")))
				end
				l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<CR>:")))
				if not l_inicmd.is_void then
					l_ga.item.ga_concat (l_inicmd)
					l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("|")))
				end
				l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cal foreground()|if &im|star|en|redr|f<CR>")))
				l_ga.item.ga_append (('%/0/').code)
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data))
			end
		end

	mainerr_arg_missing (a_str___1: CE_POINTER [NATURAL_8])
		do
			mainerr (2, a_str___1)
		end

	mainerr (a_n: INTEGER_32; a_str___1: CE_POINTER [NATURAL_8])
		do
			(create {P_OS_UNIX_STATIC}).reset_signals;
			(create {P_MESSAGE_STATIC}).mch_errmsg ((create {P_VERSION_STATIC}).longVersion.item);
			(create {P_MESSAGE_STATIC}).mch_errmsg (ce_string ("%N"));
			(create {P_MESSAGE_STATIC}).mch_errmsg ((gettext (main_errors.item[a_n])))
			if not a_str___1.is_void then
				(create {P_MESSAGE_STATIC}).mch_errmsg (ce_string (": %""));
				(create {P_MESSAGE_STATIC}).mch_errmsg (create {CE_INTEGER_8_POINTER}.make_cast (a_str___1));
				(create {P_MESSAGE_STATIC}).mch_errmsg (ce_string ("%""))
			end
			(create {P_MESSAGE_STATIC}).mch_errmsg ((gettext (ce_string ("%NMore info with: %"vim -h%"%N"))));
			(create {P_OS_UNIX_STATIC}).mch_exit (1)
		end

	reset_modifiable
		local
			l_opt_idx: INTEGER_32
		do
			(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ma := 0;
			(create {P_OPTION_STATIC}).p_ma.item.item := 0
			l_opt_idx := (create {P_OPTION_STATIC}).findoption (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ma")))
			if l_opt_idx >= 0 then
				(create {P_OPTION_STATIC}).options.item[l_opt_idx].def_val[0] := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			end
		end

	make_windows (a_count___2, a_vertical: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_maxcount: INTEGER_32
			l_todo: INTEGER_32
			l_break: BOOLEAN
		do
			l_count___2 := a_count___2
			if a_vertical.to_boolean then
				l_maxcount := ((((create {P_GLOBALS_STATIC}).curwin.item.item.w_width + (create {P_GLOBALS_STATIC}).curwin.item.item.w_vsep_width).to_integer_32 - ((create {P_OPTION_STATIC}).p_wiw.item.item - (create {P_OPTION_STATIC}).p_wmw.item.item)) // ((create {P_OPTION_STATIC}).p_wmw.item.item + 1)).to_integer_32
			else
				l_maxcount := ((((create {P_GLOBALS_STATIC}).curwin.item.item.w_height + (create {P_GLOBALS_STATIC}).curwin.item.item.w_status_height).to_integer_32 - ((create {P_OPTION_STATIC}).p_wh.item.item - (create {P_OPTION_STATIC}).p_wmh.item.item)) // ((create {P_OPTION_STATIC}).p_wmh.item.item + 1)).to_integer_32
			end
			if l_maxcount < 2 then
				l_maxcount := 2
			end
			if l_count___2 > l_maxcount then
				l_count___2 := l_maxcount
			end
			if l_count___2 > 1 then
				(create {P_WINDOW_STATIC}).last_status (1)
			end
			(create {P_FILEIO_STATIC}).block_autocmds
			l_todo := l_count___2 - 1
			from
			until
				not (not (l_break) and then (l_todo > 0))
			loop
				l_break := False
				if a_vertical.to_boolean then
					if ((create {P_WINDOW_STATIC}).win_split (((create {P_GLOBALS_STATIC}).curwin.item.item.w_width - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_width - l_todo) // (l_todo + 1)) - 1, 66)) = 0 then
						l_break := True
					end
				elseif ((create {P_WINDOW_STATIC}).win_split (((create {P_GLOBALS_STATIC}).curwin.item.item.w_height - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_height - l_todo) // (l_todo + 1)) - 1, 64)) = 0 then
					l_break := True
				end
				if not (l_break) then
					l_todo := l_todo - 1
				end
			end
			l_break := False;
			(create {P_FILEIO_STATIC}).unblock_autocmds
			Result := (l_count___2 - l_todo)
		end

	make_tabpages (a_maxcount: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_todo: INTEGER_32
			l_break: BOOLEAN
		do
			l_count___2 := a_maxcount
			if l_count___2.to_integer_32 > (create {P_OPTION_STATIC}).p_tpm.item.item then
				l_count___2 := ((create {P_OPTION_STATIC}).p_tpm.item.item).to_integer_32
			end
			(create {P_FILEIO_STATIC}).block_autocmds
			l_todo := l_count___2 - 1
			from
			until
				not (not (l_break) and then (l_todo > 0))
			loop
				l_break := False
				if ((create {P_WINDOW_STATIC}).win_new_tabpage (0)) = 0 then
					l_break := True
				end
				if not (l_break) then
					l_todo := l_todo - 1
				end
			end
			l_break := False;
			(create {P_FILEIO_STATIC}).unblock_autocmds
			Result := (l_count___2 - l_todo)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			argc := a_other.argc
			argv := a_other.argv
			evim_mode := a_other.evim_mode
			use_vimrc := a_other.use_vimrc
			n_commands := a_other.n_commands
			commands := a_other.commands.twin
			cmds_tofree := a_other.cmds_tofree.twin
			n_pre_commands := a_other.n_pre_commands
			pre_commands := a_other.pre_commands.twin
			edit_type := a_other.edit_type
			tagname := a_other.tagname
			use_ef := a_other.use_ef
			want_full_screen := a_other.want_full_screen
			stdout_isatty := a_other.stdout_isatty
			term := a_other.term
			ask_for_key := a_other.ask_for_key
			no_swap_file := a_other.no_swap_file
			use_debug_break_level := a_other.use_debug_break_level
			window_count := a_other.window_count
			window_layout := a_other.window_layout
			serverArg := a_other.serverArg
			serverName_arg := a_other.serverName_arg
			serverStr := a_other.serverStr
			serverStrEnc := a_other.serverStrEnc
			servername := a_other.servername
			diff_mode := a_other.diff_mode
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				argc = a_other.argc and
				argv.is_equal (a_other.argv) and
				evim_mode = a_other.evim_mode and
				use_vimrc.is_equal (a_other.use_vimrc) and
				n_commands = a_other.n_commands and
				commands.is_equal (a_other.commands) and
				cmds_tofree.is_equal (a_other.cmds_tofree) and
				n_pre_commands = a_other.n_pre_commands and
				pre_commands.is_equal (a_other.pre_commands) and
				edit_type = a_other.edit_type and
				tagname.is_equal (a_other.tagname) and
				use_ef.is_equal (a_other.use_ef) and
				want_full_screen = a_other.want_full_screen and
				stdout_isatty = a_other.stdout_isatty and
				term.is_equal (a_other.term) and
				ask_for_key = a_other.ask_for_key and
				no_swap_file = a_other.no_swap_file and
				use_debug_break_level = a_other.use_debug_break_level and
				window_count = a_other.window_count and
				window_layout = a_other.window_layout and
				serverArg = a_other.serverArg and
				serverName_arg.is_equal (a_other.serverName_arg) and
				serverStr.is_equal (a_other.serverStr) and
				serverStrEnc.is_equal (a_other.serverStrEnc) and
				servername.is_equal (a_other.servername) and
				diff_mode = a_other.diff_mode
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("argc"),
					create {CE_STRUCTURE_FIELD}.make ("argv"),
					create {CE_STRUCTURE_FIELD}.make ("evim_mode"),
					create {CE_STRUCTURE_FIELD}.make ("use_vimrc"),
					create {CE_STRUCTURE_FIELD}.make ("n_commands"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("commands", <<10>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cmds_tofree", <<10>>),
					create {CE_STRUCTURE_FIELD}.make ("n_pre_commands"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("pre_commands", <<10>>),
					create {CE_STRUCTURE_FIELD}.make ("edit_type"),
					create {CE_STRUCTURE_FIELD}.make ("tagname"),
					create {CE_STRUCTURE_FIELD}.make ("use_ef"),
					create {CE_STRUCTURE_FIELD}.make ("want_full_screen"),
					create {CE_STRUCTURE_FIELD}.make ("stdout_isatty"),
					create {CE_STRUCTURE_FIELD}.make ("term"),
					create {CE_STRUCTURE_FIELD}.make ("ask_for_key"),
					create {CE_STRUCTURE_FIELD}.make ("no_swap_file"),
					create {CE_STRUCTURE_FIELD}.make ("use_debug_break_level"),
					create {CE_STRUCTURE_FIELD}.make ("window_count"),
					create {CE_STRUCTURE_FIELD}.make ("window_layout"),
					create {CE_STRUCTURE_FIELD}.make ("serverArg"),
					create {CE_STRUCTURE_FIELD}.make ("serverName_arg"),
					create {CE_STRUCTURE_FIELD}.make ("serverStr"),
					create {CE_STRUCTURE_FIELD}.make ("serverStrEnc"),
					create {CE_STRUCTURE_FIELD}.make ("servername"),
					create {CE_STRUCTURE_FIELD}.make ("diff_mode")
				>>)
			init_structure_info
		end

end
