class
	PD_MSGLIST

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} msg.make
			create {CE_NATURAL_8_POINTER} throw_msg.make
			create {CE_CLASS_POINTER [PD_MSGLIST]} next.make
		end

feature {ANY} -- fields

	msg: CE_POINTER [NATURAL_8] assign set_msg

	throw_msg: CE_POINTER [NATURAL_8] assign set_throw_msg

	next: CE_POINTER [PD_MSGLIST] assign set_next

feature {ANY} -- field setters

	set_msg (a_msg: CE_POINTER [NATURAL_8])
		do
			msg := a_msg
			update_memory_field ("msg")
		end

	set_throw_msg (a_throw_msg: CE_POINTER [NATURAL_8])
		do
			throw_msg := a_throw_msg
			update_memory_field ("throw_msg")
		end

	set_next (a_next: CE_POINTER [PD_MSGLIST])
		do
			next := a_next
			update_memory_field ("next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			msg := a_other.msg
			throw_msg := a_other.throw_msg
			next := a_other.next
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				msg.is_equal (a_other.msg) and
				throw_msg.is_equal (a_other.throw_msg) and
				next.is_equal (a_other.next)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("msg"),
					create {CE_STRUCTURE_FIELD}.make ("throw_msg"),
					create {CE_STRUCTURE_FIELD}.make ("next")
				>>)
			init_structure_info
		end

end
