class
	PD_POINTER_BLOCK

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_ARRAY [PD_POINTER_ENTRY]} pb_pointer.make (<<1>>)
		end

feature {ANY} -- fields

	pb_id: NATURAL_16 assign set_pb_id

	pb_count: NATURAL_16 assign set_pb_count

	pb_count_max: NATURAL_16 assign set_pb_count_max

	pb_pointer: CE_ARRAY [PD_POINTER_ENTRY]

feature {ANY} -- field setters

	set_pb_id (a_pb_id: NATURAL_16)
		do
			pb_id := a_pb_id
			update_memory_field ("pb_id")
		end

	set_pb_count (a_pb_count: NATURAL_16)
		do
			pb_count := a_pb_count
			update_memory_field ("pb_count")
		end

	set_pb_count_max (a_pb_count_max: NATURAL_16)
		do
			pb_count_max := a_pb_count_max
			update_memory_field ("pb_count_max")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pb_id := a_other.pb_id
			pb_count := a_other.pb_count
			pb_count_max := a_other.pb_count_max
			pb_pointer := a_other.pb_pointer.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pb_id = a_other.pb_id and
				pb_count = a_other.pb_count and
				pb_count_max = a_other.pb_count_max and
				pb_pointer.is_equal (a_other.pb_pointer)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pb_id"),
					create {CE_STRUCTURE_FIELD}.make ("pb_count"),
					create {CE_STRUCTURE_FIELD}.make ("pb_count_max"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("pb_pointer", <<1>>)
				>>)
			init_structure_info
		end

end
