class
	PD_PRT_PS_CHARSET_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} charset.make
			create {CE_INTEGER_8_POINTER} cmap_charset.make
		end

feature {ANY} -- fields

	charset: CE_POINTER [INTEGER_8] assign set_charset

	cmap_charset: CE_POINTER [INTEGER_8] assign set_cmap_charset

	has_charset: INTEGER_32 assign set_has_charset

feature {ANY} -- field setters

	set_charset (a_charset: CE_POINTER [INTEGER_8])
		do
			charset := a_charset
			update_memory_field ("charset")
		end

	set_cmap_charset (a_cmap_charset: CE_POINTER [INTEGER_8])
		do
			cmap_charset := a_cmap_charset
			update_memory_field ("cmap_charset")
		end

	set_has_charset (a_has_charset: INTEGER_32)
		do
			has_charset := a_has_charset
			update_memory_field ("has_charset")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			charset := a_other.charset
			cmap_charset := a_other.cmap_charset
			has_charset := a_other.has_charset
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				charset.is_equal (a_other.charset) and
				cmap_charset.is_equal (a_other.cmap_charset) and
				has_charset = a_other.has_charset
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("charset"),
					create {CE_STRUCTURE_FIELD}.make ("cmap_charset"),
					create {CE_STRUCTURE_FIELD}.make ("has_charset")
				>>)
			init_structure_info
		end

end
