class
	PD_QF_INFO_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_ARRAY [PD_QF_LIST_S]} qf_lists.make (<<10>>)
			Precursor
		end

feature {ANY} -- fields

	qf_refcount: INTEGER_32 assign set_qf_refcount

	qf_listcount: INTEGER_32 assign set_qf_listcount

	qf_curlist: INTEGER_32 assign set_qf_curlist

	qf_lists: CE_ARRAY [PD_QF_LIST_S]

feature {ANY} -- field setters

	set_qf_refcount (a_qf_refcount: INTEGER_32)
		do
			qf_refcount := a_qf_refcount
			update_memory_field ("qf_refcount")
		end

	set_qf_listcount (a_qf_listcount: INTEGER_32)
		do
			qf_listcount := a_qf_listcount
			update_memory_field ("qf_listcount")
		end

	set_qf_curlist (a_qf_curlist: INTEGER_32)
		do
			qf_curlist := a_qf_curlist
			update_memory_field ("qf_curlist")
		end

feature {ANY} -- public routines

	qf_new_list (a_qf_title: CE_POINTER [NATURAL_8])
		local
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [NATURAL_8]
		do
			from
			until
				not (qf_listcount > qf_curlist + 1)
			loop
				Current.qf_listcount := qf_listcount - 1
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_QF_INFO_S]}.make_shared (c_pointer))).item.qf_free (qf_listcount)
				update_class_fields -- Current might have been changed; synchronize
			end
			if qf_listcount = 10 then
				((create {CE_CLASS_POINTER [PD_QF_INFO_S]}.make_shared (c_pointer))).item.qf_free (0)
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := 1
				from
				until
					not (l_i___0 < 10)
				loop
					qf_lists[l_i___0 - 1] := (qf_lists[l_i___0]).twin
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := l_i___0 + 1
				end
				Current.qf_curlist := 9
				update_class_fields -- Current might have been changed; synchronize
			else
				l_tmp := qf_listcount
				Current.qf_listcount := qf_listcount + 1
				update_class_fields -- Current might have been changed; synchronize
				Current.qf_curlist := l_tmp
				update_class_fields -- Current might have been changed; synchronize
			end
			qf_lists[qf_curlist].qf_index := 0
			update_class_fields -- Current might have been changed; synchronize
			qf_lists[qf_curlist].qf_count := 0
			update_class_fields -- Current might have been changed; synchronize
			if not a_qf_title.is_void then
				l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_qf_title))
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___1 := (create {P_MISC2_STATIC}).alloc ((l_tmp___0.to_integer_32 + 2).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_p___0 := l_tmp___1
				qf_lists[qf_curlist].qf_title := l_p___0
				update_class_fields -- Current might have been changed; synchronize
				if not l_p___0.is_void then
					sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string (":%%s"), create {CE_INTEGER_8_POINTER}.make_cast (a_qf_title)]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				qf_lists[qf_curlist].qf_title := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	qf_free (a_idx: INTEGER_32)
		local
			l_qfp: CE_POINTER [PD_QFLINE_S]
		do
			from
			until
				not ((qf_lists[a_idx].qf_count).to_boolean)
			loop
				l_qfp := (qf_lists[a_idx].qf_start).item.qf_next;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((qf_lists[a_idx].qf_start).item.qf_text))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((qf_lists[a_idx].qf_start).item.qf_pattern))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (qf_lists[a_idx].qf_start))
				update_class_fields -- Current might have been changed; synchronize
				qf_lists[a_idx].qf_start := l_qfp
				update_class_fields -- Current might have been changed; synchronize
				qf_lists[a_idx].qf_count := (qf_lists[a_idx].qf_count) - 1
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (qf_lists[a_idx].qf_title))
			update_class_fields -- Current might have been changed; synchronize
		end

	qf_win_pos_update (a_old_qf_index: INTEGER_32): INTEGER_32
		local
			l_win: CE_POINTER [PD_WINDOW_S]
			l_qf_index: INTEGER_32
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
		do
			l_qf_index := qf_lists[qf_curlist].qf_index
			l_win := (create {P_QUICKFIX_STATIC}).qf_find_win ((create {CE_CLASS_POINTER [PD_QF_INFO_S]}.make_shared (c_pointer)))
			update_class_fields -- Current might have been changed; synchronize
			if not l_win.is_void then
				if l_qf_index.to_integer_32 <= (l_win.item.w_buffer).item.b_ml.ml_line_count then
					if a_old_qf_index /= l_qf_index then
						l_old_curwin___1 := (create {P_GLOBALS_STATIC}).curwin.item;
						(create {P_GLOBALS_STATIC}).curwin.item := l_win
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).curbuf.item := l_win.item.w_buffer
						update_class_fields -- Current might have been changed; synchronize
						if l_qf_index > a_old_qf_index then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_redraw_top := a_old_qf_index.to_integer_32
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_redraw_bot := l_qf_index.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_redraw_top := l_qf_index.to_integer_32
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_redraw_bot := a_old_qf_index.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_qf_index.to_integer_32
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MOVE_STATIC}).update_topline
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SCREEN_STATIC}).redraw_later (10)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_redr_status := 1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).curwin.item := l_old_curwin___1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			Result := (not l_win.is_void).to_integer
		end

	qf_fill_buffer
		local
			l_lnum: INTEGER_32
			l_qfp: CE_POINTER [PD_QFLINE_S]
			l_errbuf___0: CE_POINTER [PD_FILE_BUFFER]
			l_len: INTEGER_32
			l_old_KeyTyped: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_tmp___2: NATURAL_32
			l_tmp___3: NATURAL_32
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: NATURAL_32
			l_tmp___6: NATURAL_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: NATURAL_32
			l_tmp___12: INTEGER_32
			l_break: BOOLEAN
		do
			l_old_KeyTyped := (create {P_GLOBALS_STATIC}).KeyTyped.item
			from
			until
				(((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_and (1)) /= 0
			loop
				(create {P_MEMLINE_STATIC}).ml_delete ((1).to_integer_32, 0).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			if qf_curlist < qf_listcount then
				l_qfp := qf_lists[qf_curlist].qf_start
				l_lnum := (0).to_integer_32
				from
				until
					not (not (l_break) and then (l_lnum < (qf_lists[qf_curlist].qf_count).to_integer_32))
				loop
					l_break := False
					if l_qfp.item.qf_fnum /= 0 then
						l_errbuf___0 := (create {P_BUFFER_STATIC}).buflist_findnr (l_qfp.item.qf_fnum)
						update_class_fields -- Current might have been changed; synchronize
						if not l_errbuf___0.is_void then
							if not (l_errbuf___0.item.b_fname).is_void then
								if (l_qfp.item.qf_type).to_integer_32 = 1 then
									l_tmp := (create {P_MISC1_STATIC}).gettail (l_errbuf___0.item.b_fname)
									update_class_fields -- Current might have been changed; synchronize
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								else
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), create {CE_INTEGER_8_POINTER}.make_cast (l_errbuf___0.item.b_fname)).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
								l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item))
								update_class_fields -- Current might have been changed; synchronize
								l_len := l_tmp___0.to_integer_32
							else
								l_len := 0
							end
						else
							l_len := 0
						end
					else
						l_len := 0
					end
					l_tmp___1 := l_len
					l_len := l_len + 1;
					(create {P_GLOBALS_STATIC}).IObuff.item[l_tmp___1] := (('|').code).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					if l_qfp.item.qf_lnum > 0 then
						sprintf ([(create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item) + l_len), ce_string ("%%ld"), l_qfp.item.qf_lnum]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).IObuff.item + l_len)))
						update_class_fields -- Current might have been changed; synchronize
						l_len := l_len + l_tmp___2.to_integer_32
						if l_qfp.item.qf_col > 0 then
							sprintf ([(create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item) + l_len), ce_string (" col %%d"), l_qfp.item.qf_col]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___3 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).IObuff.item + l_len)))
							update_class_fields -- Current might have been changed; synchronize
							l_len := l_len + l_tmp___3.to_integer_32
						end
						l_tmp___4 := (create {P_QUICKFIX_STATIC}).qf_types ((l_qfp.item.qf_type).to_integer_32, l_qfp.item.qf_nr)
						update_class_fields -- Current might have been changed; synchronize
						sprintf ([(create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item) + l_len), ce_string ("%%s"), create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___4)]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___5 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).IObuff.item + l_len)))
						update_class_fields -- Current might have been changed; synchronize
						l_len := l_len + l_tmp___5.to_integer_32
					elseif not (l_qfp.item.qf_pattern).is_void then
						(create {P_QUICKFIX_STATIC}).qf_fmt_text (l_qfp.item.qf_pattern, (create {P_GLOBALS_STATIC}).IObuff.item + l_len, 1_025 - l_len)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___6 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).IObuff.item + l_len)))
						update_class_fields -- Current might have been changed; synchronize
						l_len := l_len + l_tmp___6.to_integer_32
					end
					l_tmp___7 := l_len
					l_len := l_len + 1;
					(create {P_GLOBALS_STATIC}).IObuff.item[l_tmp___7] := (('|').code).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___8 := l_len
					l_len := l_len + 1;
					(create {P_GLOBALS_STATIC}).IObuff.item[l_tmp___8] := ((' ').code).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					if l_len > 3 then
						l_tmp___9 := (create {P_CHARSET_STATIC}).skipwhite (l_qfp.item.qf_text)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___10 := l_tmp___9
					else
						l_tmp___10 := l_qfp.item.qf_text
					end
					(create {P_QUICKFIX_STATIC}).qf_fmt_text (l_tmp___10, (create {P_GLOBALS_STATIC}).IObuff.item + l_len, 1_025 - l_len)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___11 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item))
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___12 := (create {P_MEMLINE_STATIC}).ml_append (l_lnum, (create {P_GLOBALS_STATIC}).IObuff.item, l_tmp___11.to_integer_32 + 1, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___12 = 0 then
						l_break := True
					end
					if not (l_break) then
						l_qfp := l_qfp.item.qf_next
						l_lnum := l_lnum + 1
					end
				end
				l_break := False;
				(create {P_MEMLINE_STATIC}).ml_delete (l_lnum + 1, 0).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_WINDOW_STATIC}).check_lnums (1)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ft")), 0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("qf")), 4)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ma := 0
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).keep_filetype.item := 1
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFREADPOST, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("quickfix")), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFWINENTER, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("quickfix")), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).keep_filetype.item := 0
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SCREEN_STATIC}).redraw_curbuf_later (40)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).KeyTyped.item := l_old_KeyTyped
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			qf_refcount := a_other.qf_refcount
			qf_listcount := a_other.qf_listcount
			qf_curlist := a_other.qf_curlist
			qf_lists := a_other.qf_lists.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				qf_refcount = a_other.qf_refcount and
				qf_listcount = a_other.qf_listcount and
				qf_curlist = a_other.qf_curlist and
				qf_lists.is_equal (a_other.qf_lists)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("qf_refcount"),
					create {CE_STRUCTURE_FIELD}.make ("qf_listcount"),
					create {CE_STRUCTURE_FIELD}.make ("qf_curlist"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("qf_lists", <<10>>)
				>>)
			init_structure_info
		end

end
