class
	PD_REGMATCH_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_REGPROG_T]} regprog.make
			create {CE_POINTER_ARRAY [NATURAL_8]} startp.make (<<10>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} endp.make (<<10>>)
		end

feature {ANY} -- fields

	regprog: CE_POINTER [PD_REGPROG_T] assign set_regprog

	startp: CE_ARRAY [CE_POINTER [NATURAL_8]]

	endp: CE_ARRAY [CE_POINTER [NATURAL_8]]

	rm_ic: INTEGER_32 assign set_rm_ic

feature {ANY} -- field setters

	set_regprog (a_regprog: CE_POINTER [PD_REGPROG_T])
		do
			regprog := a_regprog
			update_memory_field ("regprog")
		end

	set_rm_ic (a_rm_ic: INTEGER_32)
		do
			rm_ic := a_rm_ic
			update_memory_field ("rm_ic")
		end

feature {ANY} -- public routines

	vim_regexec (a_line: CE_POINTER [NATURAL_8]; a_col: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			(create {P_REGEXP_STATIC}).reg_match.item := (create {CE_CLASS_POINTER [PD_REGMATCH_T]}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).reg_mmatch.item := create {CE_CLASS_POINTER [PD_REGMMATCH_T]}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).reg_maxline.item := (0).to_integer_32
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).reg_line_lbr.item := 0
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).reg_win.item := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).ireg_ic.item := rm_ic
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).ireg_icombine.item := 0
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).ireg_maxcol.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_REGEXP_STATIC}).vim_regexec_both (a_line, a_col, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
			Result := (l_tmp /= 0).to_integer
		end

	vim_regexec_nl (a_line: CE_POINTER [NATURAL_8]; a_col: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			(create {P_REGEXP_STATIC}).reg_match.item := (create {CE_CLASS_POINTER [PD_REGMATCH_T]}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).reg_mmatch.item := create {CE_CLASS_POINTER [PD_REGMMATCH_T]}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).reg_maxline.item := (0).to_integer_32
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).reg_line_lbr.item := 1
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).reg_win.item := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).ireg_ic.item := rm_ic
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).ireg_icombine.item := 0
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).ireg_maxcol.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_REGEXP_STATIC}).vim_regexec_both (a_line, a_col, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
			Result := (l_tmp /= 0).to_integer
		end

feature {ANY}

	copy (a_other: like Current)
		do
			regprog := a_other.regprog
			startp := a_other.startp.twin
			endp := a_other.endp.twin
			rm_ic := a_other.rm_ic
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				regprog.is_equal (a_other.regprog) and
				startp.is_equal (a_other.startp) and
				endp.is_equal (a_other.endp) and
				rm_ic = a_other.rm_ic
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("regprog"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("startp", <<10>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("endp", <<10>>),
					create {CE_STRUCTURE_FIELD}.make ("rm_ic")
				>>)
			init_structure_info
		end

end
