class
	PD_REGSTAR_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	nextb: INTEGER_32 assign set_nextb

	nextb_ic: INTEGER_32 assign set_nextb_ic

	count: INTEGER_32 assign set_count

	minval: INTEGER_32 assign set_minval

	maxval: INTEGER_32 assign set_maxval

feature {ANY} -- field setters

	set_nextb (a_nextb: INTEGER_32)
		do
			nextb := a_nextb
			update_memory_field ("nextb")
		end

	set_nextb_ic (a_nextb_ic: INTEGER_32)
		do
			nextb_ic := a_nextb_ic
			update_memory_field ("nextb_ic")
		end

	set_count (a_count: INTEGER_32)
		do
			count := a_count
			update_memory_field ("count")
		end

	set_minval (a_minval: INTEGER_32)
		do
			minval := a_minval
			update_memory_field ("minval")
		end

	set_maxval (a_maxval: INTEGER_32)
		do
			maxval := a_maxval
			update_memory_field ("maxval")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			nextb := a_other.nextb
			nextb_ic := a_other.nextb_ic
			count := a_other.count
			minval := a_other.minval
			maxval := a_other.maxval
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				nextb = a_other.nextb and
				nextb_ic = a_other.nextb_ic and
				count = a_other.count and
				minval = a_other.minval and
				maxval = a_other.maxval
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("nextb"),
					create {CE_STRUCTURE_FIELD}.make ("nextb_ic"),
					create {CE_STRUCTURE_FIELD}.make ("count"),
					create {CE_STRUCTURE_FIELD}.make ("minval"),
					create {CE_STRUCTURE_FIELD}.make ("maxval")
				>>)
			init_structure_info
		end

end
