class
	PD_SLANG_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_WCTYPE_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_SLANG_S]} sl_next.make
			create {CE_NATURAL_8_POINTER} sl_name.make
			create {CE_NATURAL_8_POINTER} sl_fname.make
			create {CE_NATURAL_8_POINTER} sl_fbyts.make
			create {CE_INTEGER_32_POINTER} sl_fidxs.make
			create {CE_NATURAL_8_POINTER} sl_kbyts.make
			create {CE_INTEGER_32_POINTER} sl_kidxs.make
			create {CE_NATURAL_8_POINTER} sl_pbyts.make
			create {CE_INTEGER_32_POINTER} sl_pidxs.make
			create {CE_NATURAL_8_POINTER} sl_info.make
			create {CE_NATURAL_8_ARRAY} sl_regions.make (<<17>>)
			create {CE_NATURAL_8_POINTER} sl_midword.make
			create sl_wordcount.make
			create sl_comppat.make
			create {CE_CLASS_POINTER [PD_REGPROG_T]} sl_compprog.make
			create {CE_NATURAL_8_POINTER} sl_comprules.make
			create {CE_NATURAL_8_POINTER} sl_compstartflags.make
			create {CE_NATURAL_8_POINTER} sl_compallflags.make
			create {CE_NATURAL_8_POINTER} sl_syllable.make
			create sl_syl_items.make
			create {CE_POINTER_POINTER [PD_REGPROG_T]} sl_prefprog.make
			create sl_rep.make
			create {CE_INTEGER_16_ARRAY} sl_rep_first.make (<<256>>)
			create sl_sal.make
			create {CE_INTEGER_32_ARRAY} sl_sal_first.make (<<256>>)
			create sl_repsal.make
			create {CE_INTEGER_16_ARRAY} sl_repsal_first.make (<<256>>)
			create {CE_NATURAL_8_POINTER} sl_sbyts.make
			create {CE_INTEGER_32_POINTER} sl_sidxs.make
			create {CE_CLASS_POINTER [PD_FILE_BUFFER]} sl_sugbuf.make
			create sl_map_hash.make
			create {CE_INTEGER_32_ARRAY} sl_map_array.make (<<256>>)
			create sl_sounddone.make
			Precursor
		end

feature {ANY} -- fields

	sl_next: CE_POINTER [PD_SLANG_S] assign set_sl_next

	sl_name: CE_POINTER [NATURAL_8] assign set_sl_name

	sl_fname: CE_POINTER [NATURAL_8] assign set_sl_fname

	sl_add: INTEGER_32 assign set_sl_add

	sl_fbyts: CE_POINTER [NATURAL_8] assign set_sl_fbyts

	sl_fidxs: CE_POINTER [INTEGER_32] assign set_sl_fidxs

	sl_kbyts: CE_POINTER [NATURAL_8] assign set_sl_kbyts

	sl_kidxs: CE_POINTER [INTEGER_32] assign set_sl_kidxs

	sl_pbyts: CE_POINTER [NATURAL_8] assign set_sl_pbyts

	sl_pidxs: CE_POINTER [INTEGER_32] assign set_sl_pidxs

	sl_info: CE_POINTER [NATURAL_8] assign set_sl_info

	sl_regions: CE_ARRAY [NATURAL_8]

	sl_midword: CE_POINTER [NATURAL_8] assign set_sl_midword

	sl_wordcount: PD_HASHTABLE_S assign set_sl_wordcount

	sl_compmax: INTEGER_32 assign set_sl_compmax

	sl_compminlen: INTEGER_32 assign set_sl_compminlen

	sl_compsylmax: INTEGER_32 assign set_sl_compsylmax

	sl_compoptions: INTEGER_32 assign set_sl_compoptions

	sl_comppat: PD_GROWARRAY assign set_sl_comppat

	sl_compprog: CE_POINTER [PD_REGPROG_T] assign set_sl_compprog

	sl_comprules: CE_POINTER [NATURAL_8] assign set_sl_comprules

	sl_compstartflags: CE_POINTER [NATURAL_8] assign set_sl_compstartflags

	sl_compallflags: CE_POINTER [NATURAL_8] assign set_sl_compallflags

	sl_nobreak: NATURAL_8 assign set_sl_nobreak

	sl_syllable: CE_POINTER [NATURAL_8] assign set_sl_syllable

	sl_syl_items: PD_GROWARRAY assign set_sl_syl_items

	sl_prefixcnt: INTEGER_32 assign set_sl_prefixcnt

	sl_prefprog: CE_POINTER [CE_POINTER [PD_REGPROG_T]] assign set_sl_prefprog

	sl_rep: PD_GROWARRAY assign set_sl_rep

	sl_rep_first: CE_ARRAY [INTEGER_16]

	sl_sal: PD_GROWARRAY assign set_sl_sal

	sl_sal_first: CE_ARRAY [INTEGER_32]

	sl_followup: INTEGER_32 assign set_sl_followup

	sl_collapse: INTEGER_32 assign set_sl_collapse

	sl_rem_accents: INTEGER_32 assign set_sl_rem_accents

	sl_sofo: INTEGER_32 assign set_sl_sofo

	sl_repsal: PD_GROWARRAY assign set_sl_repsal

	sl_repsal_first: CE_ARRAY [INTEGER_16]

	sl_nosplitsugs: INTEGER_32 assign set_sl_nosplitsugs

	sl_sugtime: INTEGER_32 assign set_sl_sugtime

	sl_sbyts: CE_POINTER [NATURAL_8] assign set_sl_sbyts

	sl_sidxs: CE_POINTER [INTEGER_32] assign set_sl_sidxs

	sl_sugbuf: CE_POINTER [PD_FILE_BUFFER] assign set_sl_sugbuf

	sl_sugloaded: INTEGER_32 assign set_sl_sugloaded

	sl_has_map: INTEGER_32 assign set_sl_has_map

	sl_map_hash: PD_HASHTABLE_S assign set_sl_map_hash

	sl_map_array: CE_ARRAY [INTEGER_32]

	sl_sounddone: PD_HASHTABLE_S assign set_sl_sounddone

feature {ANY} -- field setters

	set_sl_next (a_sl_next: CE_POINTER [PD_SLANG_S])
		do
			sl_next := a_sl_next
			update_memory_field ("sl_next")
		end

	set_sl_name (a_sl_name: CE_POINTER [NATURAL_8])
		do
			sl_name := a_sl_name
			update_memory_field ("sl_name")
		end

	set_sl_fname (a_sl_fname: CE_POINTER [NATURAL_8])
		do
			sl_fname := a_sl_fname
			update_memory_field ("sl_fname")
		end

	set_sl_add (a_sl_add: INTEGER_32)
		do
			sl_add := a_sl_add
			update_memory_field ("sl_add")
		end

	set_sl_fbyts (a_sl_fbyts: CE_POINTER [NATURAL_8])
		do
			sl_fbyts := a_sl_fbyts
			update_memory_field ("sl_fbyts")
		end

	set_sl_fidxs (a_sl_fidxs: CE_POINTER [INTEGER_32])
		do
			sl_fidxs := a_sl_fidxs
			update_memory_field ("sl_fidxs")
		end

	set_sl_kbyts (a_sl_kbyts: CE_POINTER [NATURAL_8])
		do
			sl_kbyts := a_sl_kbyts
			update_memory_field ("sl_kbyts")
		end

	set_sl_kidxs (a_sl_kidxs: CE_POINTER [INTEGER_32])
		do
			sl_kidxs := a_sl_kidxs
			update_memory_field ("sl_kidxs")
		end

	set_sl_pbyts (a_sl_pbyts: CE_POINTER [NATURAL_8])
		do
			sl_pbyts := a_sl_pbyts
			update_memory_field ("sl_pbyts")
		end

	set_sl_pidxs (a_sl_pidxs: CE_POINTER [INTEGER_32])
		do
			sl_pidxs := a_sl_pidxs
			update_memory_field ("sl_pidxs")
		end

	set_sl_info (a_sl_info: CE_POINTER [NATURAL_8])
		do
			sl_info := a_sl_info
			update_memory_field ("sl_info")
		end

	set_sl_midword (a_sl_midword: CE_POINTER [NATURAL_8])
		do
			sl_midword := a_sl_midword
			update_memory_field ("sl_midword")
		end

	set_sl_wordcount (a_sl_wordcount: PD_HASHTABLE_S)
		do
			sl_wordcount := a_sl_wordcount
			update_memory_field ("sl_wordcount")
		end

	set_sl_compmax (a_sl_compmax: INTEGER_32)
		do
			sl_compmax := a_sl_compmax
			update_memory_field ("sl_compmax")
		end

	set_sl_compminlen (a_sl_compminlen: INTEGER_32)
		do
			sl_compminlen := a_sl_compminlen
			update_memory_field ("sl_compminlen")
		end

	set_sl_compsylmax (a_sl_compsylmax: INTEGER_32)
		do
			sl_compsylmax := a_sl_compsylmax
			update_memory_field ("sl_compsylmax")
		end

	set_sl_compoptions (a_sl_compoptions: INTEGER_32)
		do
			sl_compoptions := a_sl_compoptions
			update_memory_field ("sl_compoptions")
		end

	set_sl_comppat (a_sl_comppat: PD_GROWARRAY)
		do
			sl_comppat := a_sl_comppat
			update_memory_field ("sl_comppat")
		end

	set_sl_compprog (a_sl_compprog: CE_POINTER [PD_REGPROG_T])
		do
			sl_compprog := a_sl_compprog
			update_memory_field ("sl_compprog")
		end

	set_sl_comprules (a_sl_comprules: CE_POINTER [NATURAL_8])
		do
			sl_comprules := a_sl_comprules
			update_memory_field ("sl_comprules")
		end

	set_sl_compstartflags (a_sl_compstartflags: CE_POINTER [NATURAL_8])
		do
			sl_compstartflags := a_sl_compstartflags
			update_memory_field ("sl_compstartflags")
		end

	set_sl_compallflags (a_sl_compallflags: CE_POINTER [NATURAL_8])
		do
			sl_compallflags := a_sl_compallflags
			update_memory_field ("sl_compallflags")
		end

	set_sl_nobreak (a_sl_nobreak: NATURAL_8)
		do
			sl_nobreak := a_sl_nobreak
			update_memory_field ("sl_nobreak")
		end

	set_sl_syllable (a_sl_syllable: CE_POINTER [NATURAL_8])
		do
			sl_syllable := a_sl_syllable
			update_memory_field ("sl_syllable")
		end

	set_sl_syl_items (a_sl_syl_items: PD_GROWARRAY)
		do
			sl_syl_items := a_sl_syl_items
			update_memory_field ("sl_syl_items")
		end

	set_sl_prefixcnt (a_sl_prefixcnt: INTEGER_32)
		do
			sl_prefixcnt := a_sl_prefixcnt
			update_memory_field ("sl_prefixcnt")
		end

	set_sl_prefprog (a_sl_prefprog: CE_POINTER [CE_POINTER [PD_REGPROG_T]])
		do
			sl_prefprog := a_sl_prefprog
			update_memory_field ("sl_prefprog")
		end

	set_sl_rep (a_sl_rep: PD_GROWARRAY)
		do
			sl_rep := a_sl_rep
			update_memory_field ("sl_rep")
		end

	set_sl_sal (a_sl_sal: PD_GROWARRAY)
		do
			sl_sal := a_sl_sal
			update_memory_field ("sl_sal")
		end

	set_sl_followup (a_sl_followup: INTEGER_32)
		do
			sl_followup := a_sl_followup
			update_memory_field ("sl_followup")
		end

	set_sl_collapse (a_sl_collapse: INTEGER_32)
		do
			sl_collapse := a_sl_collapse
			update_memory_field ("sl_collapse")
		end

	set_sl_rem_accents (a_sl_rem_accents: INTEGER_32)
		do
			sl_rem_accents := a_sl_rem_accents
			update_memory_field ("sl_rem_accents")
		end

	set_sl_sofo (a_sl_sofo: INTEGER_32)
		do
			sl_sofo := a_sl_sofo
			update_memory_field ("sl_sofo")
		end

	set_sl_repsal (a_sl_repsal: PD_GROWARRAY)
		do
			sl_repsal := a_sl_repsal
			update_memory_field ("sl_repsal")
		end

	set_sl_nosplitsugs (a_sl_nosplitsugs: INTEGER_32)
		do
			sl_nosplitsugs := a_sl_nosplitsugs
			update_memory_field ("sl_nosplitsugs")
		end

	set_sl_sugtime (a_sl_sugtime: INTEGER_32)
		do
			sl_sugtime := a_sl_sugtime
			update_memory_field ("sl_sugtime")
		end

	set_sl_sbyts (a_sl_sbyts: CE_POINTER [NATURAL_8])
		do
			sl_sbyts := a_sl_sbyts
			update_memory_field ("sl_sbyts")
		end

	set_sl_sidxs (a_sl_sidxs: CE_POINTER [INTEGER_32])
		do
			sl_sidxs := a_sl_sidxs
			update_memory_field ("sl_sidxs")
		end

	set_sl_sugbuf (a_sl_sugbuf: CE_POINTER [PD_FILE_BUFFER])
		do
			sl_sugbuf := a_sl_sugbuf
			update_memory_field ("sl_sugbuf")
		end

	set_sl_sugloaded (a_sl_sugloaded: INTEGER_32)
		do
			sl_sugloaded := a_sl_sugloaded
			update_memory_field ("sl_sugloaded")
		end

	set_sl_has_map (a_sl_has_map: INTEGER_32)
		do
			sl_has_map := a_sl_has_map
			update_memory_field ("sl_has_map")
		end

	set_sl_map_hash (a_sl_map_hash: PD_HASHTABLE_S)
		do
			sl_map_hash := a_sl_map_hash
			update_memory_field ("sl_map_hash")
		end

	set_sl_sounddone (a_sl_sounddone: PD_HASHTABLE_S)
		do
			sl_sounddone := a_sl_sounddone
			update_memory_field ("sl_sounddone")
		end

feature {ANY} -- public routines

	can_compound (a_word, a_flags___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_uflags: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_REGMATCH_T]} l_regmatch___0.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_uflags.make (<<500>>)

			if sl_compprog.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
					l_p___0 := l_uflags
					l_i___0 := 0
					from
					until
						(a_flags___0[l_i___0]).to_integer_32 = 0
					loop
						l_tmp := (create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([(a_flags___0[l_i___0]).to_integer_32, l_p___0])
						update_class_fields -- Current might have been changed; synchronize
						l_p___0 := l_p___0 + l_tmp
						l_i___0 := l_i___0 + 1
					end
					l_p___0.item := (('%/0/').code).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					l_p___0 := l_uflags
				else
					l_p___0 := a_flags___0
				end
				l_regmatch___0.item.regprog := sl_compprog
				update_class_fields -- Current might have been changed; synchronize
				l_regmatch___0.item.rm_ic := 0
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := l_regmatch___0.item.vim_regexec (l_p___0, 0)
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp___0.to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return and then (sl_compsylmax < 250) then
				l_tmp___2 := ((create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (c_pointer))).item.count_syllables (a_word)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___2 > sl_compsylmax then
					l_tmp___1 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_flags___0))
					update_class_fields -- Current might have been changed; synchronize
					Result := (l_tmp___1.to_integer_32 < sl_compmax).to_integer
					l_return := True
				end
			end
			if not l_return then
				Result := 1
			end
		end

	match_compoundrule (a_compflags: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_c: INTEGER_32
			l_match: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			l_p___0 := sl_comprules
			from
			until
				not (not (l_return or l_break) and then ((l_p___0.item).to_integer_32 /= 0))
			loop
				l_break := False
				l_i___0 := 0
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_c := (a_compflags[l_i___0]).to_integer_32
					if l_c = 0 then
						Result := 1
						l_return := True
					end
					if not l_return then
						if (l_p___0.item).to_integer_32 = 47 then
							l_break := True
						elseif (l_p___0.item).to_integer_32 = 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							if (l_p___0.item).to_integer_32 = 91 then
								l_match := 0
								l_p___0 := l_p___0 + 1
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_p___0.item).to_integer_32 /= 93 then
										if (l_p___0.item).to_integer_32 = 0 then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_tmp := l_p___0
										l_p___0 := l_p___0 + 1
										if (l_tmp.item).to_integer_32 = l_c then
											l_match := 1
										end
									end
								end
								l_break := False
								if not l_match.to_boolean then
									l_break := True
								end
							elseif (l_p___0.item).to_integer_32 /= l_c then
								l_break := True
							end
						end
						if not (l_return or l_break) then
							l_p___0 := l_p___0 + 1
							l_i___0 := l_i___0 + 1
						end
					end
				end
				if not l_return then
					l_break := False
					l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (l_p___0, ('/').code)
					update_class_fields -- Current might have been changed; synchronize
					if l_p___0.is_void then
						l_break := True
					end
					if not (l_return or l_break) then
						l_p___0 := l_p___0 + 1
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 0
			end
		end

	slang_free
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_name))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_fname))
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (c_pointer))).item.slang_clear
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	slang_clear
		local
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_ftp: CE_POINTER [PD_FROMTO_S]
			l_smp: CE_POINTER [PD_SALITEM_S]
			l_i___0: INTEGER_32
			l_round: INTEGER_32
			l_return: BOOLEAN
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_fbyts))
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_fbyts := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_kbyts))
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_kbyts := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_pbyts))
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_pbyts := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_fidxs))
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_fidxs := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_kidxs))
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_kidxs := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_pidxs))
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_pidxs := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_round := 1
			from
			until
				not (not (l_return) and then (l_round <= 2))
			loop
				if l_round = 1 then
					l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_rep"))
				else
					l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_repsal"))
				end
				from
				until
					not (l_gap.item.ga_len > 0)
				loop
					l_gap.item.ga_len := (l_gap.item.ga_len) - 1
					update_class_fields -- Current might have been changed; synchronize
					l_ftp := create {CE_CLASS_POINTER [PD_FROMTO_S]}.make_cast (l_gap.item.ga_data) + l_gap.item.ga_len;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ftp.item.ft_from))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ftp.item.ft_to))
					update_class_fields -- Current might have been changed; synchronize
				end
				l_gap.item.ga_clear
				update_class_fields -- Current might have been changed; synchronize
				l_round := l_round + 1
			end
			l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sal"))
			if sl_sofo.to_boolean then
				if not (l_gap.item.ga_data).is_void then
					l_i___0 := 0
					from
					until
						not (l_i___0 < l_gap.item.ga_len)
					loop
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (create {CE_POINTER_POINTER [INTEGER_32]}.make_cast (l_gap.item.ga_data)[l_i___0]))
						update_class_fields -- Current might have been changed; synchronize
						l_i___0 := l_i___0 + 1
					end
				end
			else
				from
				until
					not (l_gap.item.ga_len > 0)
				loop
					l_gap.item.ga_len := (l_gap.item.ga_len) - 1
					update_class_fields -- Current might have been changed; synchronize
					l_smp := create {CE_CLASS_POINTER [PD_SALITEM_S]}.make_cast (l_gap.item.ga_data) + l_gap.item.ga_len;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_smp.item.sm_lead))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_smp.item.sm_to))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_smp.item.sm_lead_w))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_smp.item.sm_oneof_w))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_smp.item.sm_to_w))
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_gap.item.ga_clear
			update_class_fields -- Current might have been changed; synchronize
			l_i___0 := 0
			from
			until
				not (l_i___0 < sl_prefixcnt)
			loop
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_prefprog[l_i___0]))
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := l_i___0 + 1
			end
			Current.sl_prefixcnt := 0
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_prefprog))
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_prefprog := create {CE_POINTER_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_info))
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_info := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_midword))
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_midword := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_compprog))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_comprules))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_compstartflags))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_compallflags))
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_compprog := create {CE_CLASS_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_comprules := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_compstartflags := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_compallflags := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_syllable))
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_syllable := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_syl_items"))).item.ga_clear
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_comppat"))).item.ga_clear_strings
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_wordcount"))).item.hash_clear_all (((((create {P_SPELL_STATIC}).dumwc.item.item.wc_word).distance ((create {CE_NATURAL_8_POINTER}.make_cast (((create {P_SPELL_STATIC}).dumwc.item))))).to_natural_32).to_integer_32)
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_wordcount"))).item.hash_init
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_map_hash"))).item.hash_clear_all (0)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (c_pointer))).item.slang_clear_sug
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_compmax := 250
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_compminlen := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_compsylmax := 250
			update_class_fields -- Current might have been changed; synchronize
			sl_regions[0] := (('%/0/').code).to_natural_8
			update_class_fields -- Current might have been changed; synchronize
		end

	slang_clear_sug
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_sbyts))
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_sbyts := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (sl_sidxs))
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_sidxs := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SPELL_STATIC}).close_spellbuf (sl_sugbuf)
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_sugbuf := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_sugloaded := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.sl_sugtime := (0).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	read_region_section (a_fd: CE_POINTER [SD_IO_FILE]; a_len: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			if a_len > 16 then
				Result := (-2)
				l_return := True
			end
			if not l_return then
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_len)
				loop
					l_tmp := IO_getc (a_fd)
					update_class_fields -- Current might have been changed; synchronize
					sl_regions[l_i___0] := l_tmp.to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := l_i___0 + 1
				end
				sl_regions[a_len] := (('%/0/').code).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

	read_sal_section (a_fd: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_cnt: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_smp: CE_POINTER [PD_SALITEM_S]
			l_ccnt: CE_ARRAY [INTEGER_32]
			l_p___0: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: INTEGER_32
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_ccnt.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := ('%/0/').code
					Current.sl_sofo := 0
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := IO_getc (a_fd)
					update_class_fields -- Current might have been changed; synchronize
					if ((l_i___0).bit_and (1)).to_boolean then
						Current.sl_followup := 1
						update_class_fields -- Current might have been changed; synchronize
					end
					if ((l_i___0).bit_and (2)).to_boolean then
						Current.sl_collapse := 1
						update_class_fields -- Current might have been changed; synchronize
					end
					if ((l_i___0).bit_and (4)).to_boolean then
						Current.sl_rem_accents := 1
						update_class_fields -- Current might have been changed; synchronize
					end
					l_cnt := (create {P_MISC2_STATIC}).get2c (a_fd)
					update_class_fields -- Current might have been changed; synchronize
					if l_cnt < 0 then
						Result := (-1)
						l_return := True
					end
					if not l_return then
						l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sal"))
						l_gap.item.ga_init2 (((create {PD_SALITEM_S}.make).structure_size.to_natural_32).to_integer_32, 10)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp := l_gap.item.ga_grow (l_cnt + 1)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp = 0 then
							Result := (-3)
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not (l_return) and then (l_gap.item.ga_len < l_cnt)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 2 then -- loop body:
						l_smp := create {CE_CLASS_POINTER [PD_SALITEM_S]}.make_cast (l_gap.item.ga_data) + l_gap.item.ga_len
						l_ccnt.item := IO_getc (a_fd)
						update_class_fields -- Current might have been changed; synchronize
						if l_ccnt.item < 0 then
							Result := (-1)
							l_return := True
						end
						if not l_return then
							l_p___0 := (create {P_MISC2_STATIC}).alloc ((l_ccnt.item + 2).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_p___0.is_void then
								Result := (-3)
								l_return := True
							end
						end
						if not l_return then
							l_smp.item.sm_lead := l_p___0
							update_class_fields -- Current might have been changed; synchronize
							l_i___0 := 0
							from
							until
								not (not (l_break) and then (l_i___0 < l_ccnt.item))
							loop
								l_break := False
								l_c := IO_getc (a_fd)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___0 := (create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("0123456789(-<^$")), l_c)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___0.is_void then
									l_break := True
								end
								if not (l_break) then
									l_tmp___1 := l_p___0
									l_p___0 := l_p___0 + 1
									l_tmp___1.item := l_c.to_natural_8
									update_class_fields -- Current might have been changed; synchronize
									l_i___0 := l_i___0 + 1
								end
							end
							l_break := False
							l_smp.item.sm_leadlen := l_p___0.distance ((l_smp.item.sm_lead))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___2 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___2.item := (('%/0/').code).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
							if l_c = 40 then
								l_smp.item.sm_oneof := l_p___0
								update_class_fields -- Current might have been changed; synchronize
								l_i___0 := l_i___0 + 1
								from
								until
									not (not (l_break) and then (l_i___0 < l_ccnt.item))
								loop
									l_break := False
									l_c := IO_getc (a_fd)
									update_class_fields -- Current might have been changed; synchronize
									if l_c = 41 then
										l_break := True
									end
									if not (l_break) then
										l_tmp___3 := l_p___0
										l_p___0 := l_p___0 + 1
										l_tmp___3.item := l_c.to_natural_8
										update_class_fields -- Current might have been changed; synchronize
										l_i___0 := l_i___0 + 1
									end
								end
								l_break := False
								l_tmp___4 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___4.item := (('%/0/').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_i___0 := l_i___0 + 1
								if l_i___0 < l_ccnt.item then
									l_c := IO_getc (a_fd)
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_smp.item.sm_oneof := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_smp.item.sm_rules := l_p___0
							update_class_fields -- Current might have been changed; synchronize
							if l_i___0 < l_ccnt.item then
								l_tmp___5 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___5.item := l_c.to_natural_8
								update_class_fields -- Current might have been changed; synchronize
							end
							l_i___0 := l_i___0 + 1
							from
							until
								not (l_i___0 < l_ccnt.item)
							loop
								l_tmp___6 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___7 := IO_getc (a_fd)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___6.item := l_tmp___7.to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_i___0 := l_i___0 + 1
							end
							l_tmp___8 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___8.item := (('%/0/').code).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
							l_smp.item.sm_to := (create {P_SPELL_STATIC}).read_cnt_string (a_fd, 1, l_ccnt)
							update_class_fields -- Current might have been changed; synchronize
							if l_ccnt.item < 0 then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_smp.item.sm_lead))
								update_class_fields -- Current might have been changed; synchronize
								Result := (l_ccnt.item)
								l_return := True
							end
						end
						if not (not l_return and then (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean)) then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if:
						l_smp.item.sm_lead_w := mb_str2wide (l_smp.item.sm_lead)
						update_class_fields -- Current might have been changed; synchronize
						l_smp.item.sm_leadlen := (create {P_MBYTE_STATIC}).mb_charlen (l_smp.item.sm_lead)
						update_class_fields -- Current might have been changed; synchronize
						if (l_smp.item.sm_oneof).is_void then
							l_smp.item.sm_oneof_w := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_smp.item.sm_oneof_w := mb_str2wide (l_smp.item.sm_oneof)
							update_class_fields -- Current might have been changed; synchronize
						end
						if (l_smp.item.sm_to).is_void then
							l_smp.item.sm_to_w := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_smp.item.sm_to_w := mb_str2wide (l_smp.item.sm_to)
							update_class_fields -- Current might have been changed; synchronize
						end
						if not ((l_smp.item.sm_lead_w).is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 6 then -- else:
						if not ((l_smp.item.sm_oneof_w).is_void) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if not (l_smp.item.sm_oneof).is_void then
							l_pos := -1 + 11 -- goto _L
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 9 then -- else: | _L___0:
						if not ((l_smp.item.sm_to_w).is_void) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if (l_smp.item.sm_to).is_void then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_smp.item.sm_lead))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_smp.item.sm_to))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_smp.item.sm_lead_w))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_smp.item.sm_oneof_w))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_smp.item.sm_to_w))
						update_class_fields -- Current might have been changed; synchronize
						Result := (-3)
						l_return := True
				when 12 then -- if done | if done | if done | if done
						if not l_return then
							l_gap.item.ga_len := (l_gap.item.ga_len) + 1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done | if done
					if not l_return and then (l_gap.item.ga_len > 0) then
						l_smp := create {CE_CLASS_POINTER [PD_SALITEM_S]}.make_cast (l_gap.item.ga_data) + l_gap.item.ga_len
						l_p___0 := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 1)
						update_class_fields -- Current might have been changed; synchronize
						if l_p___0.is_void then
							Result := (-3)
							l_return := True
						end
						if not l_return then
							l_p___0[0] := (('%/0/').code).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
							l_smp.item.sm_lead := l_p___0
							update_class_fields -- Current might have been changed; synchronize
							l_smp.item.sm_leadlen := 0
							update_class_fields -- Current might have been changed; synchronize
							l_smp.item.sm_oneof := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
							l_smp.item.sm_rules := l_p___0
							update_class_fields -- Current might have been changed; synchronize
							l_smp.item.sm_to := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_smp.item.sm_lead_w := mb_str2wide (l_smp.item.sm_lead)
								update_class_fields -- Current might have been changed; synchronize
								l_smp.item.sm_leadlen := 0
								update_class_fields -- Current might have been changed; synchronize
								l_smp.item.sm_oneof_w := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
								update_class_fields -- Current might have been changed; synchronize
								l_smp.item.sm_to_w := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_gap.item.ga_len := (l_gap.item.ga_len) + 1
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if not l_return then
						((create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (c_pointer))).item.set_sal_first
						update_class_fields -- Current might have been changed; synchronize
						Result := 0
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	read_sofo_section (a_fd: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_cnt: CE_ARRAY [INTEGER_32]
			l_from: CE_POINTER [NATURAL_8]
			l_to: CE_POINTER [NATURAL_8]
			l_res: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_cnt.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					Current.sl_sofo := 1
					update_class_fields -- Current might have been changed; synchronize
					l_from := (create {P_SPELL_STATIC}).read_cnt_string (a_fd, 2, l_cnt)
					update_class_fields -- Current might have been changed; synchronize
					if l_cnt.item < 0 then
						Result := (l_cnt.item)
						l_return := True
					end
					if not l_return then
						l_to := (create {P_SPELL_STATIC}).read_cnt_string (a_fd, 2, l_cnt)
						update_class_fields -- Current might have been changed; synchronize
						if l_cnt.item < 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_from))
							update_class_fields -- Current might have been changed; synchronize
							Result := (l_cnt.item)
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if l_from.is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not l_to.is_void then
							l_res := set_sofo ((create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (c_pointer)), l_from, l_to)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if not l_from.is_void then
							l_res := -2
						elseif not l_to.is_void then
							l_res := -2
						else
							l_res := 0
						end
				when 5 then;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_from))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_to))
						update_class_fields -- Current might have been changed; synchronize
						Result := l_res
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	init_syl_tab: INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_syl: CE_POINTER [PD_SYL_ITEM_S]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_syl_items"))).item.ga_init2 (((create {PD_SYL_ITEM_S}.make).structure_size.to_natural_32).to_integer_32, 4)
			update_class_fields -- Current might have been changed; synchronize
			l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (sl_syllable, ('/').code)
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				not (not (l_return or l_break) and then (not l_p___0.is_void))
			loop
				l_break := False
				l_tmp := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp.item := (('%/0/').code).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				if (l_p___0.item).to_integer_32 = 0 then
					l_break := True
				end
				if not (l_return or l_break) then
					l_s := l_p___0
					l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (l_p___0, ('/').code)
					update_class_fields -- Current might have been changed; synchronize
					if l_p___0.is_void then
						l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))
						update_class_fields -- Current might have been changed; synchronize
						l_l := l_tmp___0.to_integer_32
					else
						l_l := l_p___0.distance (l_s)
					end
					if l_l >= 30 then
						Result := (-2)
						l_return := True
					end
					if not l_return then
						l_tmp___1 := (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_syl_items"))).item.ga_grow (1)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1 = 0 then
							Result := (-3)
							l_return := True
						end
					end
					if not l_return then
						l_tmp___2 := sl_syl_items.ga_len
						sl_syl_items.ga_len := (sl_syl_items.ga_len) + 1
						update_class_fields -- Current might have been changed; synchronize
						l_syl := create {CE_CLASS_POINTER [PD_SYL_ITEM_S]}.make_cast (sl_syl_items.ga_data) + l_tmp___2;
						(create {P_MISC2_STATIC}).vim_strncpy (l_syl.item.sy_chars, l_s, l_l.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_syl.item.sy_len := l_l
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 1
			end
		end

	count_syllables (a_word: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_cnt: INTEGER_32
			l_skip___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_syl: CE_POINTER [PD_SYL_ITEM_S]
			l_c: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return, l_continue: BOOLEAN
		do
			l_cnt := 0
			l_skip___0 := 0
			if sl_syllable.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_p___0 := a_word
				from
				until
					not (not (l_return) and then ((l_p___0.item).to_integer_32 /= 0))
				loop
					l_continue := False
					if (l_p___0.item).to_integer_32 = 32 then
						l_len := 1
						l_cnt := 0
						l_continue := True
					end
					if not (l_return or l_continue) then
						l_len := 0
						l_i___0 := 0
						from
						until
							not (l_i___0 < sl_syl_items.ga_len)
						loop
							l_syl := create {CE_CLASS_POINTER [PD_SYL_ITEM_S]}.make_cast (sl_syl_items.ga_data) + l_i___0
							if l_syl.item.sy_len > l_len then
								l_tmp := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), create {CE_INTEGER_8_POINTER}.make_cast ((l_syl.item.sy_chars)), (l_syl.item.sy_len).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp = 0 then
									l_len := l_syl.item.sy_len
								end
							end
							l_i___0 := l_i___0 + 1
						end
						if l_len /= 0 then
							l_cnt := l_cnt + 1
							l_skip___0 := 0
						else
							l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0])
							update_class_fields -- Current might have been changed; synchronize
							l_len := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___0 := (create {P_MISC2_STATIC}).vim_strchr (sl_syllable, l_c)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___0.is_void then
								l_skip___0 := 0
							elseif not l_skip___0.to_boolean then
								l_cnt := l_cnt + 1
								l_skip___0 := 1
							end
						end
					end
					if (not l_return) then
						l_p___0 := l_p___0 + l_len
					end
				end
				l_continue := False
				Result := l_cnt
			end
		end

	set_sal_first
		local
			l_sfirst: CE_POINTER [INTEGER_32]
			l_i___0: INTEGER_32
			l_smp: CE_POINTER [PD_SALITEM_S]
			l_c: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_n: INTEGER_32
			l_tsal: PD_SALITEM_S
			l_return, l_break: BOOLEAN
		do
			l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sal"))
			l_sfirst := sl_sal_first
			l_i___0 := 0
			from
			until
				not (l_i___0 < 256)
			loop
				l_sfirst[l_i___0] := -1
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := l_i___0 + 1
			end
			l_smp := create {CE_CLASS_POINTER [PD_SALITEM_S]}.make_cast (l_gap.item.ga_data)
			l_i___0 := 0
			from
			until
				not (not (l_return) and then (l_i___0 < l_gap.item.ga_len))
			loop
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					l_c := (((l_smp + l_i___0).item.sm_lead_w).item).bit_and (255)
				else
					l_c := (((l_smp + l_i___0).item.sm_lead).item).to_integer_32
				end
				if l_sfirst[l_c] = -1 then
					l_sfirst[l_c] := l_i___0
					update_class_fields -- Current might have been changed; synchronize
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						from
						until
							(l_break)
						loop
							l_break := False
							if l_i___0 + 1 < l_gap.item.ga_len then
								if ((((l_smp + (l_i___0 + 1)).item.sm_lead_w).item).bit_and (255)) /= l_c then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						l_n := 1
						from
						until
							not (l_i___0 + l_n < l_gap.item.ga_len)
						loop
							if ((((l_smp + (l_i___0 + l_n)).item.sm_lead_w).item).bit_and (255)) = l_c then
								l_i___0 := l_i___0 + 1
								l_n := l_n - 1
								l_tsal := (l_smp[(l_i___0 + l_n)]).twin
								memmove (create {CE_VOID_POINTER}.make_cast (((l_smp + l_i___0) + 1)), create {CE_VOID_POINTER}.make_cast ((l_smp + l_i___0)), (create {PD_SALITEM_S}.make).structure_size.to_natural_32 * l_n.to_natural_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_smp[l_i___0] := l_tsal.twin
								update_class_fields -- Current might have been changed; synchronize
							end
							l_n := l_n + 1
						end
					end
				end
				l_i___0 := l_i___0 + 1
			end
		end

	use_midword (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_l: INTEGER_32
			l_n: INTEGER_32
			l_bp___0: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if sl_midword.is_void then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_p___0 := sl_midword
				when 2 then -- loop condition:
						if (l_p___0.item).to_integer_32 = 0 then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0])
						update_class_fields -- Current might have been changed; synchronize
						l_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
						update_class_fields -- Current might have been changed; synchronize
						if not (l_c < 256) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_l <= 2 then
							(a_wp___0.item.w_s).item.b_spell_ismw[l_c] := (1).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if ((a_wp___0.item.w_s).item.b_spell_ismw_mb).is_void then
							(a_wp___0.item.w_s).item.b_spell_ismw_mb := (create {P_MISC2_STATIC}).vim_strnsave (l_p___0, l_l)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((a_wp___0.item.w_s).item.b_spell_ismw_mb))
							update_class_fields -- Current might have been changed; synchronize
							l_n := l_tmp.to_integer_32
							l_bp___0 := (create {P_MISC2_STATIC}).vim_strnsave ((a_wp___0.item.w_s).item.b_spell_ismw_mb, l_n + l_l)
							update_class_fields -- Current might have been changed; synchronize
							if not l_bp___0.is_void then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((a_wp___0.item.w_s).item.b_spell_ismw_mb))
								update_class_fields; -- Current might have been changed; synchronize
								(a_wp___0.item.w_s).item.b_spell_ismw_mb := l_bp___0
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MISC2_STATIC}).vim_strncpy (l_bp___0 + l_n, l_p___0, l_l.to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 8 then
						l_p___0 := l_p___0 + l_l
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_tmp___0 := l_p___0
						l_p___0 := l_p___0 + 1;
						(a_wp___0.item.w_s).item.b_spell_ismw[(l_tmp___0.item).to_integer_32] := (1).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
				when 11 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- loop done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_map_str (a_map: CE_POINTER [NATURAL_8])
		require
			not a_map.is_void
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_headc: INTEGER_32
			l_c: INTEGER_32
			l_i___0: INTEGER_32
			l_cl: INTEGER_32
			l_tmp: INTEGER_32
			l_headcl: INTEGER_32
			l_tmp___0: INTEGER_32
			l_b: CE_POINTER [NATURAL_8]
			l_hash: NATURAL_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			l_headc := 0
			if (a_map.item).to_integer_32 = 0 then
				Current.sl_has_map := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				Current.sl_has_map := 1
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := 0
				from
				until
					not (l_i___0 < 256)
				loop
					sl_map_array[l_i___0] := 0
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := l_i___0 + 1
				end
				(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_map_hash"))).item.hash_init
				update_class_fields -- Current might have been changed; synchronize
				l_p___0.item := a_map
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					not (not (l_return) and then ((l_p___0.item.item).to_integer_32 /= 0))
				loop
					l_c := (create {P_MBYTE_STATIC}).mb_cptr2char_adv (l_p___0)
					update_class_fields -- Current might have been changed; synchronize
					if l_c = 47 then
						l_headc := 0
					else
						if l_headc = 0 then
							l_headc := l_c
						end
						if l_c >= 256 then
							l_tmp := (create {P_GLOBALS_STATIC}).mb_char2len.item.integer_32_item ([l_c])
							update_class_fields -- Current might have been changed; synchronize
							l_cl := l_tmp
							l_tmp___0 := (create {P_GLOBALS_STATIC}).mb_char2len.item.integer_32_item ([l_headc])
							update_class_fields -- Current might have been changed; synchronize
							l_headcl := l_tmp___0
							l_b := (create {P_MISC2_STATIC}).alloc (((l_cl + l_headcl) + 2).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_b.is_void then
								l_return := True
							end
							if not l_return then
								(create {P_GLOBALS_STATIC}).mb_char2bytes.item.call ([l_c, l_b])
								update_class_fields -- Current might have been changed; synchronize
								l_b[l_cl] := (('%/0/').code).to_natural_8
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_GLOBALS_STATIC}).mb_char2bytes.item.call ([l_headc, (l_b + l_cl) + 1])
								update_class_fields -- Current might have been changed; synchronize
								l_b[((l_cl + 1) + l_headcl)] := (('%/0/').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_hash := (create {P_HASHTAB_STATIC}).hash_hash (l_b)
								update_class_fields -- Current might have been changed; synchronize
								l_hi___1 := (create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_map_hash"))).item.hash_lookup (l_b, l_hash)
								update_class_fields -- Current might have been changed; synchronize
								if (l_hi___1.item.hi_key).is_void then
									(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_map_hash"))).item.hash_add_item (l_hi___1, l_b, l_hash).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								elseif (l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item) then
									(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_map_hash"))).item.hash_add_item (l_hi___1, l_b, l_hash).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								else
									l_tmp___1 := gettext (ce_string ("E783: duplicate char in MAP entry"))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_b))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						else
							sl_map_array[l_c] := l_headc
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				end
			end
			if not l_return then
			end
		end

	spell_soundfold (a_inword: CE_POINTER [NATURAL_8]; a_folded: INTEGER_32; a_res: CE_POINTER [NATURAL_8])
		local
			l_fword: CE_ARRAY [NATURAL_8]
			l_word: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
		do
			create {CE_NATURAL_8_ARRAY} l_fword.make (<<250>>)

			if sl_sofo.to_boolean then
				spell_soundfold_sofo ((create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (c_pointer)), a_inword, a_res)
				update_class_fields -- Current might have been changed; synchronize
			else
				if a_folded.to_boolean then
					l_word := a_inword
				else
					l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_inword))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_SPELL_STATIC}).spell_casefold (a_inword, l_tmp.to_integer_32, l_fword, 250).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_word := l_fword
				end
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					((create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (c_pointer))).item.spell_soundfold_wsal (l_word, a_res)
					update_class_fields -- Current might have been changed; synchronize
				else
					((create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (c_pointer))).item.spell_soundfold_sal (l_word, a_res)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	spell_soundfold_sal (a_inword, a_res: CE_POINTER [NATURAL_8])
		require
			not a_res.is_void
		local
			l_smp: CE_POINTER [PD_SALITEM_S]
			l_word: CE_ARRAY [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_t: CE_POINTER [NATURAL_8]
			l_pf: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_z: INTEGER_32
			l_reslen: INTEGER_32
			l_n: INTEGER_32
			l_k: INTEGER_32
			l_z0: INTEGER_32
			l_k0: INTEGER_32
			l_n0: INTEGER_32
			l_c: INTEGER_32
			l_pri: INTEGER_32
			l_p0: INTEGER_32
			l_c0: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: NATURAL_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: NATURAL_32
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_word.make (<<250>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_inword
					l_k := 0
					l_p0 := -333
					if sl_rem_accents.to_boolean then
						l_t := l_word
						from
						until
							(l_s.item).to_integer_32 = 0
						loop
							if (l_s.item).to_integer_32 = 32 then
								l_tmp := l_t
								l_t := l_t + 1
								l_tmp.item := ((' ').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_s := (create {P_CHARSET_STATIC}).skipwhite (l_s)
								update_class_fields -- Current might have been changed; synchronize
							elseif (l_s.item).to_integer_32 = 9 then
								l_tmp := l_t
								l_t := l_t + 1
								l_tmp.item := ((' ').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_s := (create {P_CHARSET_STATIC}).skipwhite (l_s)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___1 := (create {P_SPELL_STATIC}).spell_iswordp_nmw (l_s)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___1.to_boolean then
									l_tmp___0 := l_t
									l_t := l_t + 1
									l_tmp___0.item := l_s.item
									update_class_fields -- Current might have been changed; synchronize
								end
								l_s := l_s + 1
							end
						end
						l_t.item := (('%/0/').code).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
					else
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_word), create {CE_INTEGER_8_POINTER}.make_cast (l_s)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					l_smp := create {CE_CLASS_POINTER [PD_SALITEM_S]}.make_cast (sl_sal.ga_data)
					l_z := 0
					l_reslen := l_z
					l_i___0 := l_reslen
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 52 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_c := (l_word[l_i___0]).to_integer_32
						if l_c = 0 then
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 51 -- skip if block
						end
				when 3 then -- if:
						l_n := sl_sal_first[l_c]
						l_z0 := 0
						if not (l_n >= 0) then
							l_pos := -1 + 49 -- skip if block
						end
				when 4 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 47 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						l_continue := False
						l_s := (l_smp + l_n).item.sm_lead
						if (l_s[0]).to_integer_32 /= l_c then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_k := (l_smp + l_n).item.sm_leadlen
							if l_k > 1 then
								if (l_word[l_i___0 + 1]).to_integer_32 /= (l_s[1]).to_integer_32 then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) and then (l_k > 2) then
									l_j := 2
									from
									until
										not (not (l_break) and then (l_j < l_k))
									loop
										l_break := False
										if (l_word[l_i___0 + l_j]).to_integer_32 /= (l_s[l_j]).to_integer_32 then
											l_break := True
										end
										if not (l_break) then
											l_j := l_j + 1
										end
									end
									l_break := False
									if l_j < l_k then
										l_continue := True
									end
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_pf := (l_smp + l_n).item.sm_oneof
							if not l_pf.is_void then
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_pf.item).to_integer_32 /= 0 then
										if (l_pf.item).to_integer_32 = (l_word[l_i___0 + l_k]).to_integer_32 then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_pf := l_pf + 1
									end
								end
								l_break := False
								if (l_pf.item).to_integer_32 = 0 then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_k := l_k + 1
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 46 -- skip if block
						end
				when 6 then -- if:
						l_s := (l_smp + l_n).item.sm_rules
						l_pri := 5
						l_p0 := (l_s.item).to_integer_32
						l_k0 := l_k
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_s.item).to_integer_32 = 45 then
								if not (l_k > 1) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_k := l_k - 1
								l_s := l_s + 1
							end
						end
						l_break := False
						if (l_s.item).to_integer_32 = 60 then
							l_s := l_s + 1
						end
						if (l_s.item).to_integer_32 >= 48 then
							if (l_s.item).to_integer_32 <= 57 then
								l_pri := (l_s.item).to_integer_32 - 48
								l_s := l_s + 1
							end
						end
						if (l_s.item).to_integer_32 = 94 then
							if (l_s[1]).to_integer_32 = 94 then
								l_s := l_s + 1
							end
						end
						if (l_s.item).to_integer_32 /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 25 -- goto _L___1
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 9 then -- else:
						if (l_s.item).to_integer_32 /= 94 then
							l_pos := -1 + 21 -- skip if block
						end
				when 10 then -- if:
						if l_i___0 /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 19 -- goto _L___4
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else:
						if (l_word[l_i___0 - 1]).to_integer_32 /= 32 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 21 -- goto _L___3
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else:
						l_tmp___11 := ((create {P_GLOBALS_STATIC}).curwin.item).item.spell_iswordp ((l_word + l_i___0) - 1)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___11.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 21 -- goto _L___3
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___4:
						if (l_s[1]).to_integer_32 /= 36 then
							l_pos := -1 + 25 -- goto _L___1
						else
							l_tmp___12 := ((create {P_GLOBALS_STATIC}).curwin.item).item.spell_iswordp ((l_word + l_i___0) + l_k0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___12.to_boolean then
								l_pos := -1 + 21 -- goto _L___3
							else
								l_pos := -1 + 25 -- goto _L___1
							end
						end
				when 20 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 46
				when 21 then -- else: | _L___3:
						if (l_s.item).to_integer_32 /= 36 then
							l_pos := -1 + 46 -- skip if block
						end
				when 22 then -- if:
						if not (l_i___0 > 0) then
							l_pos := -1 + 46 -- skip if block
						end
				when 23 then -- if:
						l_tmp___13 := ((create {P_GLOBALS_STATIC}).curwin.item).item.spell_iswordp ((l_word + l_i___0) - 1)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___13.to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 24 then -- if:
						l_tmp___14 := ((create {P_GLOBALS_STATIC}).curwin.item).item.spell_iswordp ((l_word + l_i___0) + l_k0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___14.to_boolean then
							l_pos := -1 + 46 -- skip if block
						end
				when 25 then -- if: | _L___1:
						l_c0 := (l_word[(l_i___0 + l_k) - 1]).to_integer_32
						l_n0 := sl_sal_first[l_c0]
						if not (sl_followup.to_boolean) then
							l_pos := -1 + 40 -- skip if block
						end
				when 26 then -- if:
						if not (l_k > 1) then
							l_pos := -1 + 40 -- skip if block
						end
				when 27 then -- if:
						if not (l_n0 >= 0) then
							l_pos := -1 + 40 -- skip if block
						end
				when 28 then -- if:
						if l_p0 = 45 then
							l_pos := -1 + 40 -- skip if block
						end
				when 29 then -- if:
						if (l_word[l_i___0 + l_k]).to_integer_32 = 0 then
							l_pos := -1 + 40 -- skip if block
						end
				when 30 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 39 -- skip loop
						end
				when 31 then -- loop body:
						l_break := False
						l_continue := False
						l_s := (l_smp + l_n0).item.sm_lead
						if (l_s[0]).to_integer_32 /= l_c0 then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_k0 := (l_smp + l_n0).item.sm_leadlen
							if l_k0 > 1 then
								if (l_word[l_i___0 + l_k]).to_integer_32 /= (l_s[1]).to_integer_32 then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) and then (l_k0 > 2) then
									l_pf := ((l_word + l_i___0) + l_k) + 1
									l_j := 2
									from
									until
										not (not (l_break) and then (l_j < l_k0))
									loop
										l_break := False
										l_tmp___2 := l_pf
										l_pf := l_pf + 1
										if (l_tmp___2.item).to_integer_32 /= (l_s[l_j]).to_integer_32 then
											l_break := True
										end
										if not (l_break) then
											l_j := l_j + 1
										end
									end
									l_break := False
									if l_j < l_k0 then
										l_continue := True
									end
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_k0 := l_k0 + (l_k - 1)
							l_pf := (l_smp + l_n0).item.sm_oneof
							if not l_pf.is_void then
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_pf.item).to_integer_32 /= 0 then
										if (l_pf.item).to_integer_32 = (l_word[l_i___0 + l_k0]).to_integer_32 then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_pf := l_pf + 1
									end
								end
								l_break := False
								if (l_pf.item).to_integer_32 = 0 then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_k0 := l_k0 + 1
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 38 -- skip if block
						end
				when 32 then -- if:
						l_p0 := 5
						l_s := (l_smp + l_n0).item.sm_rules
						from
						until
							(l_s.item).to_integer_32 /= 45
						loop
							l_s := l_s + 1
						end
						if (l_s.item).to_integer_32 = 60 then
							l_s := l_s + 1
						end
						if (l_s.item).to_integer_32 >= 48 then
							if (l_s.item).to_integer_32 <= 57 then
								l_p0 := (l_s.item).to_integer_32 - 48
								l_s := l_s + 1
							end
						end
						if (l_s.item).to_integer_32 /= 0 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 37 -- goto _L
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 35 then -- else:
						if (l_s.item).to_integer_32 /= 36 then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						l_tmp___3 := ((create {P_GLOBALS_STATIC}).curwin.item).item.spell_iswordp ((l_word + l_i___0) + l_k0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___3.to_boolean then
							l_pos := -1 + 38 -- skip if block
						end
				when 37 then -- if: | _L:
						if l_k0 = l_k then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) and then (l_p0 < l_pri) then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							l_break := True
						end
				when 38 then -- if done | if done | if done
						if (not l_return and not l_break) then
							l_n0 := l_n0 + 1
						end
						l_pos := -1 + 30 -- back to loop condition
				when 39 then -- loop done
						l_break := False
						l_continue := False
						if l_p0 >= l_pri then
							if ((l_smp + l_n0).item.sm_lead[0]).to_integer_32 = l_c0 then
								l_continue := True
							end
						end
				when 40 then -- if done | if done | if done | if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 46 -- skip if block
						end
				when 41 then -- if:
						l_s := (l_smp + l_n).item.sm_to
						if l_s.is_void then
							l_s := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
						end
						l_pf := (l_smp + l_n).item.sm_rules
						l_tmp___5 := (create {P_MISC2_STATIC}).vim_strchr (l_pf, ('<').code)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___5.is_void then
							l_p0 := 1
						else
							l_p0 := 0
						end
						if l_p0 /= 1 then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						if l_z = 0 then
							if l_reslen > 0 then
								if (l_s.item).to_integer_32 /= 0 then
									if (a_res[(l_reslen - 1)]).to_integer_32 = l_c then
										l_reslen := l_reslen - 1
									elseif (a_res[(l_reslen - 1)]).to_integer_32 = (l_s.item).to_integer_32 then
										l_reslen := l_reslen - 1
									end
								end
							end
							l_z0 := 1
							l_z := 1
							l_k0 := 0
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_s.item).to_integer_32 /= 0 then
									if (l_word[l_i___0 + l_k0]).to_integer_32 = 0 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break or l_continue) then
									l_word[l_i___0 + l_k0] := l_s.item
									update_class_fields -- Current might have been changed; synchronize
									l_k0 := l_k0 + 1
									l_s := l_s + 1
								end
							end
							l_break := False
							if l_k > l_k0 then
								l_tmp___6 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (((l_word + l_i___0) + l_k)))
								update_class_fields -- Current might have been changed; synchronize
								memmove (create {CE_VOID_POINTER}.make_cast (((l_word + l_i___0) + l_k0)), create {CE_VOID_POINTER}.make_cast (((l_word + l_i___0) + l_k)), l_tmp___6 + {NATURAL_32} 1).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
							l_c := (l_word[l_i___0]).to_integer_32
						else
							l_pos := -1 + 44 -- goto _L___0
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else: | _L___0:
						l_i___0 := l_i___0 + (l_k - 1)
						l_z := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_s.item).to_integer_32 /= 0 then
								if (l_s[1]).to_integer_32 /= 0 then
									if not (l_reslen < 250) then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								if l_reslen = 0 then
									l_tmp___7 := l_reslen
									l_reslen := l_reslen + 1
									a_res[l_tmp___7] := l_s.item
									update_class_fields -- Current might have been changed; synchronize
								elseif (a_res[(l_reslen - 1)]).to_integer_32 /= (l_s.item).to_integer_32 then
									l_tmp___7 := l_reslen
									l_reslen := l_reslen + 1
									a_res[l_tmp___7] := l_s.item
									update_class_fields -- Current might have been changed; synchronize
								end
								l_s := l_s + 1
							end
						end
						l_break := False
						l_c := (l_s.item).to_integer_32
						l_tmp___10 := strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_pf), ce_string ("^^"))
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___10.is_void then
							if l_c /= 0 then
								l_tmp___8 := l_reslen
								l_reslen := l_reslen + 1
								a_res[l_tmp___8] := l_c.to_natural_8
								update_class_fields -- Current might have been changed; synchronize
							end
							l_tmp___9 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (((l_word + l_i___0) + 1)))
							update_class_fields -- Current might have been changed; synchronize
							memmove (create {CE_VOID_POINTER}.make_cast (l_word), create {CE_VOID_POINTER}.make_cast (((l_word + l_i___0) + 1)), l_tmp___9 + {NATURAL_32} 1).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_i___0 := 0
							l_z0 := 1
						end
				when 45 then
						l_break := True
				when 46 then -- if done | if done | if done | if done | if done | if done | if done
						if (not l_return and not l_break) then
							l_n := l_n + 1
						end
						l_pos := -1 + 4 -- back to loop condition
				when 47 then -- loop done
						l_break := False
						l_continue := False
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else:
						if l_c = 32 then
							l_c := (' ').code
							l_k := 1
						elseif l_c = 9 then
							l_c := (' ').code
							l_k := 1
						end
				when 50 then -- if done
						if l_z0 = 0 then
							if l_k.to_boolean then
								if not l_p0.to_boolean then
									if l_reslen < 250 then
										if l_c /= 0 then
											if not sl_collapse.to_boolean then
												l_tmp___15 := l_reslen
												l_reslen := l_reslen + 1
												a_res[l_tmp___15] := l_c.to_natural_8
												update_class_fields -- Current might have been changed; synchronize
											elseif l_reslen = 0 then
												l_tmp___15 := l_reslen
												l_reslen := l_reslen + 1
												a_res[l_tmp___15] := l_c.to_natural_8
												update_class_fields -- Current might have been changed; synchronize
											elseif (a_res[(l_reslen - 1)]).to_integer_32 /= l_c then
												l_tmp___15 := l_reslen
												l_reslen := l_reslen + 1
												a_res[l_tmp___15] := l_c.to_natural_8
												update_class_fields -- Current might have been changed; synchronize
											end
										end
									end
								end
							end
							l_i___0 := l_i___0 + 1
							l_z := 0
							l_k := 0
						end
				when 51 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 52 then -- loop done
					l_break := False
					a_res[l_reslen] := (('%/0/').code).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
				when 53 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_soundfold_wsal (a_inword, a_res: CE_POINTER [NATURAL_8])
		require
			not a_res.is_void
		local
			l_smp: CE_POINTER [PD_SALITEM_S]
			l_word: CE_ARRAY [INTEGER_32]
			l_wres: CE_ARRAY [INTEGER_32]
			l_l: INTEGER_32
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_ws: CE_POINTER [INTEGER_32]
			l_t: CE_POINTER [NATURAL_8]
			l_pf: CE_POINTER [INTEGER_32]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_z: INTEGER_32
			l_reslen: INTEGER_32
			l_n: INTEGER_32
			l_k: INTEGER_32
			l_z0: INTEGER_32
			l_k0: INTEGER_32
			l_n0: INTEGER_32
			l_c: INTEGER_32
			l_pri: INTEGER_32
			l_p0: INTEGER_32
			l_c0: INTEGER_32
			l_did_white: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_32]
			l_tmp___5: INTEGER_32
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: NATURAL_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: NATURAL_32
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_word.make (<<250>>)
			create {CE_INTEGER_32_ARRAY} l_wres.make (<<250>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_smp := create {CE_CLASS_POINTER [PD_SALITEM_S]}.make_cast (sl_sal.ga_data)
					l_k := 0
					l_p0 := -333
					l_did_white := 0
					l_n := 0
					l_s.item := a_inword
					update_class_fields -- Current might have been changed; synchronize
					from
					until
						(l_s.item.item).to_integer_32 = 0
					loop
						l_continue := False
						l_t := l_s.item
						l_c := (create {P_MBYTE_STATIC}).mb_cptr2char_adv (l_s)
						update_class_fields -- Current might have been changed; synchronize
						if sl_rem_accents.to_boolean then
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								l_tmp___0 := (create {P_MBYTE_STATIC}).utf_class (l_c)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___2 := (l_tmp___0 = 0).to_integer
							else
								if l_c = 32 then
									l_tmp___1 := 1
								elseif l_c = 9 then
									l_tmp___1 := 1
								else
									l_tmp___1 := 0
								end
								l_tmp___2 := l_tmp___1
							end
							if l_tmp___2.to_boolean then
								if l_did_white.to_boolean then
									l_continue := True
								end
								if not (l_continue) then
									l_c := (' ').code
									l_did_white := 1
								end
							else
								l_did_white := 0
								l_tmp := (create {P_SPELL_STATIC}).spell_iswordp_nmw (l_t)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp.to_boolean then
									l_continue := True
								end
							end
						end
						if not (l_continue) then
							l_tmp___3 := l_n
							l_n := l_n + 1
							l_word[l_tmp___3] := l_c
							update_class_fields -- Current might have been changed; synchronize
						end
						
					end
					l_continue := False
					l_word[l_n] := ('%/0/').code
					update_class_fields -- Current might have been changed; synchronize
					l_z := 0
					l_reslen := l_z
					l_i___0 := l_reslen
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 52 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_c := l_word[l_i___0]
						if l_c = 0 then
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 51 -- skip if block
						end
				when 3 then -- if:
						l_n := sl_sal_first[(l_c).bit_and (255)]
						l_z0 := 0
						if not (l_n >= 0) then
							l_pos := -1 + 49 -- skip if block
						end
				when 4 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 47 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						l_continue := False
						l_ws := (l_smp + l_n).item.sm_lead_w
						if ((l_ws[0]).bit_and (255)) = ((l_c).bit_and (255)) then
							if l_ws[0] = 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_return or l_break or l_continue) and then (l_c /= l_ws[0]) then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							l_k := (l_smp + l_n).item.sm_leadlen
							if l_k > 1 then
								if l_word[l_i___0 + 1] /= l_ws[1] then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) and then (l_k > 2) then
									l_j := 2
									from
									until
										not (not (l_break) and then (l_j < l_k))
									loop
										l_break := False
										if l_word[l_i___0 + l_j] /= l_ws[l_j] then
											l_break := True
										end
										if not (l_break or l_continue) then
											l_j := l_j + 1
										end
									end
									l_break := False
									if l_j < l_k then
										l_continue := True
									end
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_pf := (l_smp + l_n).item.sm_oneof_w
							if not l_pf.is_void then
								from
								until
									(l_break)
								loop
									l_break := False
									if l_pf.item /= 0 then
										if l_pf.item = l_word[l_i___0 + l_k] then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break or l_continue) then
										l_pf := l_pf + 1
									end
								end
								l_break := False
								if l_pf.item = 0 then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_k := l_k + 1
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 46 -- skip if block
						end
				when 6 then -- if:
						l_s.item := (l_smp + l_n).item.sm_rules
						update_class_fields -- Current might have been changed; synchronize
						l_pri := 5
						l_p0 := (l_s.item.item).to_integer_32
						l_k0 := l_k
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_s.item.item).to_integer_32 = 45 then
								if not (l_k > 1) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break or l_continue) then
								l_k := l_k - 1
								l_s.item := l_s.item + 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						if (l_s.item.item).to_integer_32 = 60 then
							l_s.item := l_s.item + 1
							update_class_fields -- Current might have been changed; synchronize
						end
						if (l_s.item.item).to_integer_32 >= 48 then
							if (l_s.item.item).to_integer_32 <= 57 then
								l_pri := (l_s.item.item).to_integer_32 - 48
								l_s.item := l_s.item + 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if (l_s.item.item).to_integer_32 = 94 then
							if (l_s.item[1]).to_integer_32 = 94 then
								l_s.item := l_s.item + 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if (l_s.item.item).to_integer_32 /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 25 -- goto _L___1
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 9 then -- else:
						if (l_s.item.item).to_integer_32 /= 94 then
							l_pos := -1 + 21 -- skip if block
						end
				when 10 then -- if:
						if l_i___0 /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 19 -- goto _L___4
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else:
						if l_word[l_i___0 - 1] /= 32 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 21 -- goto _L___3
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else:
						l_tmp___13 := spell_iswordp_w ((l_word + l_i___0) - 1, (create {P_GLOBALS_STATIC}).curwin.item)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___13.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 21 -- goto _L___3
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___4:
						if (l_s.item[1]).to_integer_32 /= 36 then
							l_pos := -1 + 25 -- goto _L___1
						else
							l_tmp___14 := spell_iswordp_w ((l_word + l_i___0) + l_k0, (create {P_GLOBALS_STATIC}).curwin.item)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___14.to_boolean then
								l_pos := -1 + 21 -- goto _L___3
							else
								l_pos := -1 + 25 -- goto _L___1
							end
						end
				when 20 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 46
				when 21 then -- else: | _L___3:
						if (l_s.item.item).to_integer_32 /= 36 then
							l_pos := -1 + 46 -- skip if block
						end
				when 22 then -- if:
						if not (l_i___0 > 0) then
							l_pos := -1 + 46 -- skip if block
						end
				when 23 then -- if:
						l_tmp___15 := spell_iswordp_w ((l_word + l_i___0) - 1, (create {P_GLOBALS_STATIC}).curwin.item)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___15.to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 24 then -- if:
						l_tmp___16 := spell_iswordp_w ((l_word + l_i___0) + l_k0, (create {P_GLOBALS_STATIC}).curwin.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___16.to_boolean then
							l_pos := -1 + 46 -- skip if block
						end
				when 25 then -- if: | _L___1:
						l_c0 := l_word[(l_i___0 + l_k) - 1]
						l_n0 := sl_sal_first[(l_c0).bit_and (255)]
						if not (sl_followup.to_boolean) then
							l_pos := -1 + 40 -- skip if block
						end
				when 26 then -- if:
						if not (l_k > 1) then
							l_pos := -1 + 40 -- skip if block
						end
				when 27 then -- if:
						if not (l_n0 >= 0) then
							l_pos := -1 + 40 -- skip if block
						end
				when 28 then -- if:
						if l_p0 = 45 then
							l_pos := -1 + 40 -- skip if block
						end
				when 29 then -- if:
						if l_word[l_i___0 + l_k] = 0 then
							l_pos := -1 + 40 -- skip if block
						end
				when 30 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 39 -- skip loop
						end
				when 31 then -- loop body:
						l_break := False
						l_continue := False
						l_ws := (l_smp + l_n0).item.sm_lead_w
						if ((l_ws[0]).bit_and (255)) /= ((l_c0).bit_and (255)) then
							l_break := True
						end
						if not (l_return or l_break or l_continue) and then (l_c0 /= l_ws[0]) then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							l_k0 := (l_smp + l_n0).item.sm_leadlen
							if l_k0 > 1 then
								if l_word[l_i___0 + l_k] /= l_ws[1] then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) and then (l_k0 > 2) then
									l_pf := ((l_word + l_i___0) + l_k) + 1
									l_j := 2
									from
									until
										not (not (l_break) and then (l_j < l_k0))
									loop
										l_break := False
										l_tmp___4 := l_pf
										l_pf := l_pf + 1
										if l_tmp___4.item /= l_ws[l_j] then
											l_break := True
										end
										if not (l_break or l_continue) then
											l_j := l_j + 1
										end
									end
									l_break := False
									if l_j < l_k0 then
										l_continue := True
									end
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_k0 := l_k0 + (l_k - 1)
							l_pf := (l_smp + l_n0).item.sm_oneof_w
							if not l_pf.is_void then
								from
								until
									(l_break)
								loop
									l_break := False
									if l_pf.item /= 0 then
										if l_pf.item = l_word[l_i___0 + l_k0] then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break or l_continue) then
										l_pf := l_pf + 1
									end
								end
								l_break := False
								if l_pf.item = 0 then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_k0 := l_k0 + 1
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 38 -- skip if block
						end
				when 32 then -- if:
						l_p0 := 5
						l_s.item := (l_smp + l_n0).item.sm_rules
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_s.item.item).to_integer_32 /= 45
						loop
							l_s.item := l_s.item + 1
							update_class_fields -- Current might have been changed; synchronize
						end
						if (l_s.item.item).to_integer_32 = 60 then
							l_s.item := l_s.item + 1
							update_class_fields -- Current might have been changed; synchronize
						end
						if (l_s.item.item).to_integer_32 >= 48 then
							if (l_s.item.item).to_integer_32 <= 57 then
								l_p0 := (l_s.item.item).to_integer_32 - 48
								l_s.item := l_s.item + 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if (l_s.item.item).to_integer_32 /= 0 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 37 -- goto _L
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 35 then -- else:
						if (l_s.item.item).to_integer_32 /= 36 then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						l_tmp___5 := spell_iswordp_w ((l_word + l_i___0) + l_k0, (create {P_GLOBALS_STATIC}).curwin.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___5.to_boolean then
							l_pos := -1 + 38 -- skip if block
						end
				when 37 then -- if: | _L:
						if l_k0 = l_k then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) and then (l_p0 < l_pri) then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							l_break := True
						end
				when 38 then -- if done | if done | if done
						if (not l_return and not l_break) then
							l_n0 := l_n0 + 1
						end
						l_pos := -1 + 30 -- back to loop condition
				when 39 then -- loop done
						l_break := False
						l_continue := False
						if l_p0 >= l_pri then
							if (((l_smp + l_n0).item.sm_lead_w[0]).bit_and (255)) = ((l_c0).bit_and (255)) then
								l_continue := True
							end
						end
				when 40 then -- if done | if done | if done | if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 46 -- skip if block
						end
				when 41 then -- if:
						l_ws := (l_smp + l_n).item.sm_to_w
						l_s.item := (l_smp + l_n).item.sm_rules
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___7 := (create {P_MISC2_STATIC}).vim_strchr (l_s.item, ('<').code)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___7.is_void then
							l_p0 := 1
						else
							l_p0 := 0
						end
						if l_p0 /= 1 then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						if l_z = 0 then
							if l_reslen > 0 then
								if not l_ws.is_void then
									if l_ws.item /= 0 then
										if l_wres[l_reslen - 1] = l_c then
											l_reslen := l_reslen - 1
										elseif l_wres[l_reslen - 1] = l_ws.item then
											l_reslen := l_reslen - 1
										end
									end
								end
							end
							l_z0 := 1
							l_z := 1
							l_k0 := 0
							if not l_ws.is_void then
								from
								until
									(l_break)
								loop
									l_break := False
									if l_ws.item /= 0 then
										if l_word[l_i___0 + l_k0] = 0 then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										l_word[l_i___0 + l_k0] := l_ws.item
										update_class_fields -- Current might have been changed; synchronize
										l_k0 := l_k0 + 1
										l_ws := l_ws + 1
									end
								end
								l_break := False
							end
							if l_k > l_k0 then
								l_tmp___8 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (((l_word + l_i___0) + l_k)))
								update_class_fields -- Current might have been changed; synchronize
								memmove (create {CE_VOID_POINTER}.make_cast (((l_word + l_i___0) + l_k0)), create {CE_VOID_POINTER}.make_cast (((l_word + l_i___0) + l_k)), {PLATFORM}.Integer_32_bytes.to_natural_32 * (l_tmp___8 + {NATURAL_32} 1)).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
							l_c := l_word[l_i___0]
						else
							l_pos := -1 + 44 -- goto _L___0
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else: | _L___0:
						l_i___0 := l_i___0 + (l_k - 1)
						l_z := 0
						if not l_ws.is_void then
							from
							until
								(l_break)
							loop
								l_break := False
								if l_ws.item /= 0 then
									if l_ws[1] /= 0 then
										if not (l_reslen < 250) then
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break or l_continue) then
									if l_reslen = 0 then
										l_tmp___9 := l_reslen
										l_reslen := l_reslen + 1
										l_wres[l_tmp___9] := l_ws.item
										update_class_fields -- Current might have been changed; synchronize
									elseif l_wres[l_reslen - 1] /= l_ws.item then
										l_tmp___9 := l_reslen
										l_reslen := l_reslen + 1
										l_wres[l_tmp___9] := l_ws.item
										update_class_fields -- Current might have been changed; synchronize
									end
									l_ws := l_ws + 1
								end
							end
							l_break := False
						end
						if l_ws.is_void then
							l_c := ('%/0/').code
						else
							l_c := l_ws.item
						end
						l_tmp___12 := strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_s.item), ce_string ("^^"))
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___12.is_void then
							if l_c /= 0 then
								l_tmp___10 := l_reslen
								l_reslen := l_reslen + 1
								l_wres[l_tmp___10] := l_c
								update_class_fields -- Current might have been changed; synchronize
							end
							l_tmp___11 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (((l_word + l_i___0) + 1)))
							update_class_fields -- Current might have been changed; synchronize
							memmove (create {CE_VOID_POINTER}.make_cast (l_word), create {CE_VOID_POINTER}.make_cast (((l_word + l_i___0) + 1)), {PLATFORM}.Integer_32_bytes.to_natural_32 * (l_tmp___11 + {NATURAL_32} 1)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_i___0 := 0
							l_z0 := 1
						end
				when 45 then
						l_break := True
				when 46 then -- if done | if done | if done | if done | if done | if done | if done
						if (not l_return and not l_break) then
							l_n := l_n + 1
						end
						l_pos := -1 + 4 -- back to loop condition
				when 47 then -- loop done
						l_break := False
						l_continue := False
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else:
						if l_c = 32 then
							l_c := (' ').code
							l_k := 1
						elseif l_c = 9 then
							l_c := (' ').code
							l_k := 1
						end
				when 50 then -- if done
						if l_z0 = 0 then
							if l_k.to_boolean then
								if not l_p0.to_boolean then
									if l_reslen < 250 then
										if l_c /= 0 then
											if not sl_collapse.to_boolean then
												l_tmp___17 := l_reslen
												l_reslen := l_reslen + 1
												l_wres[l_tmp___17] := l_c
												update_class_fields -- Current might have been changed; synchronize
											elseif l_reslen = 0 then
												l_tmp___17 := l_reslen
												l_reslen := l_reslen + 1
												l_wres[l_tmp___17] := l_c
												update_class_fields -- Current might have been changed; synchronize
											elseif l_wres[l_reslen - 1] /= l_c then
												l_tmp___17 := l_reslen
												l_reslen := l_reslen + 1
												l_wres[l_tmp___17] := l_c
												update_class_fields -- Current might have been changed; synchronize
											end
										end
									end
								end
							end
							l_i___0 := l_i___0 + 1
							l_z := 0
							l_k := 0
						end
				when 51 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 52 then -- loop done
					l_break := False
					l_l := 0
					l_n := 0
					from
					until
						not (not (l_break) and then (l_n < l_reslen))
					loop
						l_break := False
						l_tmp___18 := (create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([l_wres[l_n], a_res + l_l])
						update_class_fields -- Current might have been changed; synchronize
						l_l := l_l + l_tmp___18
						if l_l + 21 > 250 then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_n := l_n + 1
						end
					end
					l_break := False
					a_res[l_l] := (('%/0/').code).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
				when 53 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dump_prefixes (a_word, a_pat: CE_POINTER [NATURAL_8]; a_dir___0: CE_POINTER [INTEGER_32]; a_dumpflags, a_flags___0: INTEGER_32; a_startlnum: INTEGER_32): INTEGER_32
		local
			l_arridx: CE_ARRAY [INTEGER_32]
			l_curi: CE_ARRAY [INTEGER_32]
			l_prefix: CE_ARRAY [NATURAL_8]
			l_word_up: CE_ARRAY [NATURAL_8]
			l_has_word_up: INTEGER_32
			l_c: INTEGER_32
			l_byts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_lnum: INTEGER_32
			l_depth___1: INTEGER_32
			l_n: INTEGER_32
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_arridx.make (<<250>>)
			create {CE_INTEGER_32_ARRAY} l_curi.make (<<250>>)
			create {CE_NATURAL_8_ARRAY} l_prefix.make (<<250>>)
			create {CE_NATURAL_8_ARRAY} l_word_up.make (<<250>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_has_word_up := 0
					l_lnum := a_startlnum
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([a_word])
						update_class_fields -- Current might have been changed; synchronize
						l_c := l_tmp
					else
						l_c := (a_word.item).to_integer_32
					end
					if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_c >= 128 then
							l_tmp___0 := (create {P_MBYTE_STATIC}).utf_toupper (l_c)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___3 := l_tmp___0
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if l_c < 256 then
							l_tmp___2 := ((create {P_SPELL_STATIC}).spelltab.item.item.st_upper[l_c]).to_integer_32
						else
							l_tmp___1 := towupper (l_c.to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___2 := l_tmp___1.to_integer_32
						end
						l_tmp___3 := l_tmp___2
				when 4 then
					if l_tmp___3 /= l_c then
						(create {P_SPELL_STATIC}).onecap_copy (a_word, l_word_up, 1)
						update_class_fields -- Current might have been changed; synchronize
						l_has_word_up := 1
					end
					l_byts := sl_pbyts
					l_idxs := sl_pidxs
					if not l_byts.is_void then
						l_depth___1 := 0
						l_arridx[0] := 0
						update_class_fields -- Current might have been changed; synchronize
						l_curi[0] := 1
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_depth___1 >= 0 then
								if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_n := l_arridx[l_depth___1]
								l_len := (l_byts[l_n]).to_integer_32
								if l_curi[l_depth___1] > l_len then
									l_depth___1 := l_depth___1 - 1;
									(create {P_MISC1_STATIC}).line_breakcheck
									update_class_fields -- Current might have been changed; synchronize
								else
									l_n := l_n + (l_curi[l_depth___1])
									l_curi[l_depth___1] := (l_curi[l_depth___1]) + 1
									update_class_fields -- Current might have been changed; synchronize
									l_c := (l_byts[l_n]).to_integer_32
									if l_c = 0 then
										l_i___0 := 1
										from
										until
											not (not (l_break) and then (l_i___0 < l_len))
										loop
											l_break := False
											if (l_byts[(l_n + l_i___0)]).to_integer_32 /= 0 then
												l_break := True
											end
											if not (l_break) then
												l_i___0 := l_i___0 + 1
											end
										end
										l_break := False
										l_curi[l_depth___1] := l_curi[l_depth___1] + (l_i___0 - 1)
										update_class_fields -- Current might have been changed; synchronize
										l_c := (create {P_SPELL_STATIC}).valid_word_prefix (l_i___0, l_n, a_flags___0, a_word, (create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (c_pointer)), 0)
										update_class_fields -- Current might have been changed; synchronize
										if l_c /= 0 then
											(create {P_MISC2_STATIC}).vim_strncpy (l_prefix + l_depth___1, a_word, ((250 - l_depth___1) - 1).to_natural_32)
											update_class_fields -- Current might have been changed; synchronize
											if ((l_c).bit_and (((1).bit_shift_left (24)))).to_boolean then
												l_tmp___4 := (a_flags___0).bit_or (8)
											else
												l_tmp___4 := a_flags___0
											end
											(create {P_SPELL_STATIC}).dump_word ((create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (c_pointer)), l_prefix, a_pat, a_dir___0, a_dumpflags, l_tmp___4, l_lnum)
											update_class_fields -- Current might have been changed; synchronize
											if l_lnum /= 0 then
												l_lnum := l_lnum + 1
											end
										end
										if l_has_word_up.to_boolean then
											l_c := (create {P_SPELL_STATIC}).valid_word_prefix (l_i___0, l_n, a_flags___0, l_word_up, (create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (c_pointer)), 1)
											update_class_fields -- Current might have been changed; synchronize
											if l_c /= 0 then
												(create {P_MISC2_STATIC}).vim_strncpy (l_prefix + l_depth___1, l_word_up, ((250 - l_depth___1) - 1).to_natural_32)
												update_class_fields -- Current might have been changed; synchronize
												if ((l_c).bit_and (((1).bit_shift_left (24)))).to_boolean then
													l_tmp___5 := (a_flags___0).bit_or (8)
												else
													l_tmp___5 := a_flags___0
												end
												(create {P_SPELL_STATIC}).dump_word ((create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (c_pointer)), l_prefix, a_pat, a_dir___0, a_dumpflags, l_tmp___5, l_lnum)
												update_class_fields -- Current might have been changed; synchronize
												if l_lnum /= 0 then
													l_lnum := l_lnum + 1
												end
											end
										end
									else
										l_tmp___6 := l_depth___1
										l_depth___1 := l_depth___1 + 1
										l_prefix[l_tmp___6] := l_c.to_natural_8
										update_class_fields -- Current might have been changed; synchronize
										l_arridx[l_depth___1] := l_idxs[l_n]
										update_class_fields -- Current might have been changed; synchronize
										l_curi[l_depth___1] := 1
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
						end
						l_break := False
					end
					Result := l_lnum
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {PD_SLANG_S} -- private routines

	set_sofo (a_lp: CE_POINTER [PD_SLANG_S]; a_from, a_to: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_c: INTEGER_32
			l_inp: CE_POINTER [INTEGER_32]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_32]
			l_tmp___5: CE_POINTER [INTEGER_32]
			l_tmp___6: CE_POINTER [INTEGER_32]
			l_tmp___7: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sal"))
				l_gap.item.ga_init2 (({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 1)
				if (l_gap.item.ga_grow (256)) = 0 then
					Result := (-3)
					l_return := True
				end
				if not l_return then
					memset (l_gap.item.ga_data, 0, {PLATFORM}.Pointer_bytes.to_natural_32 * {NATURAL_32} 256).do_nothing
					l_gap.item.ga_len := 256
					l_p___0.item := a_from
					l_s.item := a_to
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_p___0.item.item).to_integer_32 /= 0 then
							if (l_s.item.item).to_integer_32 = 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_c := (create {P_MBYTE_STATIC}).mb_cptr2char_adv (l_p___0)
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								l_tmp___3 := ((create {P_MBYTE_STATIC}).utf_ptr2len (l_s.item))
							else
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___2 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s.item]))
								else
									l_tmp___2 := 1
								end
								l_tmp___3 := l_tmp___2
							end
							l_s.item := l_s.item + l_tmp___3
							if l_c >= 256 then
								a_lp.item.sl_sal_first[(l_c).bit_and (255)] := (a_lp.item.sl_sal_first[(l_c).bit_and (255)]) + 1
							end
						end
					end
					l_break := False
					if (l_p___0.item.item).to_integer_32 /= 0 then
						Result := (-2)
						l_return := True
					elseif (l_s.item.item).to_integer_32 /= 0 then
						Result := (-2)
						l_return := True
					end
				end
				if not l_return then
					l_i___0 := 0
					from
					until
						not (not (l_return) and then (l_i___0 < 256))
					loop
						if a_lp.item.sl_sal_first[l_i___0] > 0 then
							l_p___0.item := (create {P_MISC2_STATIC}).alloc ({PLATFORM}.Integer_32_bytes.to_natural_32 * (a_lp.item.sl_sal_first[l_i___0] * 2 + 1).to_natural_32)
							if (l_p___0.item).is_void then
								Result := (-3)
								l_return := True
							end
							if not l_return then
								create {CE_POINTER_POINTER [INTEGER_32]}.make_cast (l_gap.item.ga_data)[l_i___0] := create {CE_INTEGER_32_POINTER}.make_cast (l_p___0.item);
								(create {CE_INTEGER_32_POINTER}.make_cast (l_p___0.item)).item := 0
							end
						end
						if not l_return then
							l_i___0 := l_i___0 + 1
						end
					end
				end
				if not l_return then
					memset (create {CE_VOID_POINTER}.make_cast ((a_lp.item.sl_sal_first)), 0, {PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 256).do_nothing
					l_p___0.item := a_from
					l_s.item := a_to
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if (l_p___0.item.item).to_integer_32 /= 0 then
							if (l_s.item.item).to_integer_32 = 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_return or l_break) then
							l_c := (create {P_MBYTE_STATIC}).mb_cptr2char_adv (l_p___0)
							l_i___0 := (create {P_MBYTE_STATIC}).mb_cptr2char_adv (l_s)
							if l_c >= 256 then
								l_inp := create {CE_POINTER_POINTER [INTEGER_32]}.make_cast (l_gap.item.ga_data)[((l_c).bit_and (255))]
								from
								until
									l_inp.item = 0
								loop
									l_inp := l_inp + 1
								end
								l_tmp___4 := l_inp
								l_inp := l_inp + 1
								l_tmp___4.item := l_c
								l_tmp___5 := l_inp
								l_inp := l_inp + 1
								l_tmp___5.item := l_i___0
								l_tmp___6 := l_inp
								l_inp := l_inp + 1
								l_tmp___6.item := ('%/0/').code
							else
								a_lp.item.sl_sal_first[l_c] := l_i___0
							end
						end
					end
					l_break := False
				end
			else
				l_tmp___7 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_from))
				if l_tmp___7 /= (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_to))) then
					Result := (-2)
					l_return := True
				end
				if not l_return then
					l_i___0 := 0
					from
					until
						(a_to[l_i___0]).to_integer_32 = 0
					loop
						a_lp.item.sl_sal_first[(a_from[l_i___0]).to_integer_32] := (a_to[l_i___0]).to_integer_32
						l_i___0 := l_i___0 + 1
					end
					a_lp.item.sl_sal.ga_len := 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	mb_str2wide (a_s: CE_POINTER [NATURAL_8]): CE_POINTER [INTEGER_32]
		local
			l_res: CE_POINTER [INTEGER_32]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_i___0: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			l_i___0 := 0
			l_res := create {CE_INTEGER_32_POINTER}.make_cast (((create {P_MISC2_STATIC}).alloc ({PLATFORM}.Integer_32_bytes.to_natural_32 * (((create {P_MBYTE_STATIC}).mb_charlen (a_s)) + 1).to_natural_32)))
			if not l_res.is_void then
				l_p___0.item := a_s
				from
				until
					(l_p___0.item.item).to_integer_32 = 0
				loop
					l_tmp___1 := l_i___0
					l_i___0 := l_i___0 + 1
					l_res[l_tmp___1] := (create {P_MBYTE_STATIC}).mb_ptr2char_adv (l_p___0)
				end
				l_res[l_i___0] := ('%/0/').code
			end
			Result := l_res
		end

	spell_iswordp_w (a_p___0: CE_POINTER [INTEGER_32]; a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		require
			not a_p___0.is_void
			not a_wp___0.is_void
		local
			l_s: CE_POINTER [INTEGER_32]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			if a_p___0.item < 256 then
				l_tmp___1 := ((a_wp___0.item.w_s).item.b_spell_ismw[a_p___0.item]).to_integer_32
			else
				if not ((a_wp___0.item.w_s).item.b_spell_ismw_mb).is_void then
					if not ((create {P_MISC2_STATIC}).vim_strchr ((a_wp___0.item.w_s).item.b_spell_ismw_mb, a_p___0.item)).is_void then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 0
				end
				l_tmp___1 := l_tmp___0
			end
			if l_tmp___1.to_boolean then
				l_s := a_p___0 + 1
			else
				l_s := a_p___0
			end
			if l_s.item > 255 then
				if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
					Result := ((create {P_SPELL_STATIC}).spell_mb_isword_class (((create {P_MBYTE_STATIC}).utf_class (l_s.item))))
					l_return := True
				end
				if not l_return and then (((create {P_GLOBALS_STATIC}).enc_dbcs.item).to_boolean) then
					Result := (((create {P_MBYTE_STATIC}).dbcs_class (((l_s.item).to_natural_32).bit_shift_right (8), ((l_s.item).bit_and (255)).to_natural_32)) >= 2).to_integer
					l_return := True
				end
				if not l_return then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := ((create {P_SPELL_STATIC}).spelltab.item.item.st_isw[l_s.item]).to_integer_32
			end
		end

	spell_soundfold_sofo (a_slang: CE_POINTER [PD_SLANG_S]; a_inword, a_res: CE_POINTER [NATURAL_8])
		require
			not a_res.is_void
		local
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_ri: INTEGER_32
			l_c: INTEGER_32
			l_prevc: INTEGER_32
			l_ip: CE_POINTER [INTEGER_32]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s.make (<<1>>)

			l_ri := 0
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				l_prevc := 0
				l_s.item := a_inword
				from
				until
					not (not (l_return or l_break) and then ((l_s.item.item).to_integer_32 /= 0))
				loop
					l_break := False
					l_c := (create {P_MBYTE_STATIC}).mb_cptr2char_adv (l_s)
					if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
						l_tmp___1 := (((create {P_MBYTE_STATIC}).utf_class (l_c)) = 0).to_integer
					else
						if l_c = 32 then
							l_tmp___0 := 1
						elseif l_c = 9 then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
						l_tmp___1 := l_tmp___0
					end
					if l_tmp___1.to_boolean then
						l_c := (' ').code
					elseif l_c < 256 then
						l_c := a_slang.item.sl_sal_first[l_c]
					else
						l_ip := create {CE_POINTER_POINTER [INTEGER_32]}.make_cast (a_slang.item.sl_sal.ga_data)[((l_c).bit_and (255))]
						if l_ip.is_void then
							l_c := ('%/0/').code
						else
							from
							until
								(l_break)
							loop
								l_break := False
								if l_ip.item = 0 then
									l_c := ('%/0/').code
									l_break := True
								end
								if not (l_break) and then (l_ip.item = l_c) then
									l_c := l_ip[1]
									l_break := True
								end
								if not (l_break) then
									l_ip := l_ip + (2)
								end
							end
							l_break := False
						end
					end
					if l_c /= 0 then
						if l_c /= l_prevc then
							l_ri := l_ri + ((create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([l_c, a_res + l_ri]))
							if l_ri + 21 > 250 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_prevc := l_c
							end
						end
					end
				end
				l_break := False
			else
				l_s.item := a_inword
				from
				until
					(l_break)
				loop
					l_break := False
					l_c := (l_s.item.item).to_integer_32
					if l_c = 0 then
						l_break := True
					end
					if not (l_return or l_break) then
						if l_c = 32 then
							l_c := (' ').code
						elseif l_c = 9 then
							l_c := (' ').code
						else
							l_c := a_slang.item.sl_sal_first[l_c]
						end
						if l_c /= 0 then
							if l_ri = 0 then
								l_tmp___3 := l_ri
								l_ri := l_ri + 1
								a_res[l_tmp___3] := l_c.to_natural_8
							elseif (a_res[(l_ri - 1)]).to_integer_32 /= l_c then
								l_tmp___3 := l_ri
								l_ri := l_ri + 1
								a_res[l_tmp___3] := l_c.to_natural_8
							end
						end
						l_s.item := l_s.item + 1
					end
				end
				l_break := False
			end
			a_res[l_ri] := (('%/0/').code).to_natural_8
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sl_next := a_other.sl_next
			sl_name := a_other.sl_name
			sl_fname := a_other.sl_fname
			sl_add := a_other.sl_add
			sl_fbyts := a_other.sl_fbyts
			sl_fidxs := a_other.sl_fidxs
			sl_kbyts := a_other.sl_kbyts
			sl_kidxs := a_other.sl_kidxs
			sl_pbyts := a_other.sl_pbyts
			sl_pidxs := a_other.sl_pidxs
			sl_info := a_other.sl_info
			sl_regions := a_other.sl_regions.twin
			sl_midword := a_other.sl_midword
			sl_wordcount := a_other.sl_wordcount.twin
			sl_compmax := a_other.sl_compmax
			sl_compminlen := a_other.sl_compminlen
			sl_compsylmax := a_other.sl_compsylmax
			sl_compoptions := a_other.sl_compoptions
			sl_comppat := a_other.sl_comppat.twin
			sl_compprog := a_other.sl_compprog
			sl_comprules := a_other.sl_comprules
			sl_compstartflags := a_other.sl_compstartflags
			sl_compallflags := a_other.sl_compallflags
			sl_nobreak := a_other.sl_nobreak
			sl_syllable := a_other.sl_syllable
			sl_syl_items := a_other.sl_syl_items.twin
			sl_prefixcnt := a_other.sl_prefixcnt
			sl_prefprog := a_other.sl_prefprog
			sl_rep := a_other.sl_rep.twin
			sl_rep_first := a_other.sl_rep_first.twin
			sl_sal := a_other.sl_sal.twin
			sl_sal_first := a_other.sl_sal_first.twin
			sl_followup := a_other.sl_followup
			sl_collapse := a_other.sl_collapse
			sl_rem_accents := a_other.sl_rem_accents
			sl_sofo := a_other.sl_sofo
			sl_repsal := a_other.sl_repsal.twin
			sl_repsal_first := a_other.sl_repsal_first.twin
			sl_nosplitsugs := a_other.sl_nosplitsugs
			sl_sugtime := a_other.sl_sugtime
			sl_sbyts := a_other.sl_sbyts
			sl_sidxs := a_other.sl_sidxs
			sl_sugbuf := a_other.sl_sugbuf
			sl_sugloaded := a_other.sl_sugloaded
			sl_has_map := a_other.sl_has_map
			sl_map_hash := a_other.sl_map_hash.twin
			sl_map_array := a_other.sl_map_array.twin
			sl_sounddone := a_other.sl_sounddone.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sl_next.is_equal (a_other.sl_next) and
				sl_name.is_equal (a_other.sl_name) and
				sl_fname.is_equal (a_other.sl_fname) and
				sl_add = a_other.sl_add and
				sl_fbyts.is_equal (a_other.sl_fbyts) and
				sl_fidxs.is_equal (a_other.sl_fidxs) and
				sl_kbyts.is_equal (a_other.sl_kbyts) and
				sl_kidxs.is_equal (a_other.sl_kidxs) and
				sl_pbyts.is_equal (a_other.sl_pbyts) and
				sl_pidxs.is_equal (a_other.sl_pidxs) and
				sl_info.is_equal (a_other.sl_info) and
				sl_regions.is_equal (a_other.sl_regions) and
				sl_midword.is_equal (a_other.sl_midword) and
				sl_wordcount.is_equal (a_other.sl_wordcount) and
				sl_compmax = a_other.sl_compmax and
				sl_compminlen = a_other.sl_compminlen and
				sl_compsylmax = a_other.sl_compsylmax and
				sl_compoptions = a_other.sl_compoptions and
				sl_comppat.is_equal (a_other.sl_comppat) and
				sl_compprog.is_equal (a_other.sl_compprog) and
				sl_comprules.is_equal (a_other.sl_comprules) and
				sl_compstartflags.is_equal (a_other.sl_compstartflags) and
				sl_compallflags.is_equal (a_other.sl_compallflags) and
				sl_nobreak = a_other.sl_nobreak and
				sl_syllable.is_equal (a_other.sl_syllable) and
				sl_syl_items.is_equal (a_other.sl_syl_items) and
				sl_prefixcnt = a_other.sl_prefixcnt and
				sl_prefprog.is_equal (a_other.sl_prefprog) and
				sl_rep.is_equal (a_other.sl_rep) and
				sl_rep_first.is_equal (a_other.sl_rep_first) and
				sl_sal.is_equal (a_other.sl_sal) and
				sl_sal_first.is_equal (a_other.sl_sal_first) and
				sl_followup = a_other.sl_followup and
				sl_collapse = a_other.sl_collapse and
				sl_rem_accents = a_other.sl_rem_accents and
				sl_sofo = a_other.sl_sofo and
				sl_repsal.is_equal (a_other.sl_repsal) and
				sl_repsal_first.is_equal (a_other.sl_repsal_first) and
				sl_nosplitsugs = a_other.sl_nosplitsugs and
				sl_sugtime = a_other.sl_sugtime and
				sl_sbyts.is_equal (a_other.sl_sbyts) and
				sl_sidxs.is_equal (a_other.sl_sidxs) and
				sl_sugbuf.is_equal (a_other.sl_sugbuf) and
				sl_sugloaded = a_other.sl_sugloaded and
				sl_has_map = a_other.sl_has_map and
				sl_map_hash.is_equal (a_other.sl_map_hash) and
				sl_map_array.is_equal (a_other.sl_map_array) and
				sl_sounddone.is_equal (a_other.sl_sounddone)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sl_next"),
					create {CE_STRUCTURE_FIELD}.make ("sl_name"),
					create {CE_STRUCTURE_FIELD}.make ("sl_fname"),
					create {CE_STRUCTURE_FIELD}.make ("sl_add"),
					create {CE_STRUCTURE_FIELD}.make ("sl_fbyts"),
					create {CE_STRUCTURE_FIELD}.make ("sl_fidxs"),
					create {CE_STRUCTURE_FIELD}.make ("sl_kbyts"),
					create {CE_STRUCTURE_FIELD}.make ("sl_kidxs"),
					create {CE_STRUCTURE_FIELD}.make ("sl_pbyts"),
					create {CE_STRUCTURE_FIELD}.make ("sl_pidxs"),
					create {CE_STRUCTURE_FIELD}.make ("sl_info"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sl_regions", <<17>>),
					create {CE_STRUCTURE_FIELD}.make ("sl_midword"),
					create {CE_STRUCTURE_FIELD}.make ("sl_wordcount"),
					create {CE_STRUCTURE_FIELD}.make ("sl_compmax"),
					create {CE_STRUCTURE_FIELD}.make ("sl_compminlen"),
					create {CE_STRUCTURE_FIELD}.make ("sl_compsylmax"),
					create {CE_STRUCTURE_FIELD}.make ("sl_compoptions"),
					create {CE_STRUCTURE_FIELD}.make ("sl_comppat"),
					create {CE_STRUCTURE_FIELD}.make ("sl_compprog"),
					create {CE_STRUCTURE_FIELD}.make ("sl_comprules"),
					create {CE_STRUCTURE_FIELD}.make ("sl_compstartflags"),
					create {CE_STRUCTURE_FIELD}.make ("sl_compallflags"),
					create {CE_STRUCTURE_FIELD}.make ("sl_nobreak"),
					create {CE_STRUCTURE_FIELD}.make ("sl_syllable"),
					create {CE_STRUCTURE_FIELD}.make ("sl_syl_items"),
					create {CE_STRUCTURE_FIELD}.make ("sl_prefixcnt"),
					create {CE_STRUCTURE_FIELD}.make ("sl_prefprog"),
					create {CE_STRUCTURE_FIELD}.make ("sl_rep"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sl_rep_first", <<256>>),
					create {CE_STRUCTURE_FIELD}.make ("sl_sal"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sl_sal_first", <<256>>),
					create {CE_STRUCTURE_FIELD}.make ("sl_followup"),
					create {CE_STRUCTURE_FIELD}.make ("sl_collapse"),
					create {CE_STRUCTURE_FIELD}.make ("sl_rem_accents"),
					create {CE_STRUCTURE_FIELD}.make ("sl_sofo"),
					create {CE_STRUCTURE_FIELD}.make ("sl_repsal"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sl_repsal_first", <<256>>),
					create {CE_STRUCTURE_FIELD}.make ("sl_nosplitsugs"),
					create {CE_STRUCTURE_FIELD}.make ("sl_sugtime"),
					create {CE_STRUCTURE_FIELD}.make ("sl_sbyts"),
					create {CE_STRUCTURE_FIELD}.make ("sl_sidxs"),
					create {CE_STRUCTURE_FIELD}.make ("sl_sugbuf"),
					create {CE_STRUCTURE_FIELD}.make ("sl_sugloaded"),
					create {CE_STRUCTURE_FIELD}.make ("sl_has_map"),
					create {CE_STRUCTURE_FIELD}.make ("sl_map_hash"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sl_map_array", <<256>>),
					create {CE_STRUCTURE_FIELD}.make ("sl_sounddone")
				>>)
			init_structure_info
		end

end
