class
	PD_STL_ITEM

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} start.make
		end

feature {ANY} -- fields

	start: CE_POINTER [NATURAL_8] assign set_start

	minwid: INTEGER_32 assign set_minwid

	maxwid: INTEGER_32 assign set_maxwid

	type: NATURAL_32 assign set_type

feature {ANY} -- field setters

	set_start (a_start: CE_POINTER [NATURAL_8])
		do
			start := a_start
			update_memory_field ("start")
		end

	set_minwid (a_minwid: INTEGER_32)
		do
			minwid := a_minwid
			update_memory_field ("minwid")
		end

	set_maxwid (a_maxwid: INTEGER_32)
		do
			maxwid := a_maxwid
			update_memory_field ("maxwid")
		end

	set_type (a_type: NATURAL_32)
		do
			type := a_type
			update_memory_field ("type")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			start := a_other.start
			minwid := a_other.minwid
			maxwid := a_other.maxwid
			type := a_other.type
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				start.is_equal (a_other.start) and
				minwid = a_other.minwid and
				maxwid = a_other.maxwid and
				type = a_other.type
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("start"),
					create {CE_STRUCTURE_FIELD}.make ("minwid"),
					create {CE_STRUCTURE_FIELD}.make ("maxwid"),
					create {CE_STRUCTURE_FIELD}.make ("type")
				>>)
			init_structure_info
		end

end
