class
	PD_STRING_NAMES

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} name.make
		end

feature {ANY} -- fields

	dest: NATURAL_32 assign set_dest

	name: CE_POINTER [INTEGER_8] assign set_name

feature {ANY} -- field setters

	set_dest (a_dest: NATURAL_32)
		do
			dest := a_dest
			update_memory_field ("dest")
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			dest := a_other.dest
			name := a_other.name
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				dest = a_other.dest and
				name.is_equal (a_other.name)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("dest"),
					create {CE_STRUCTURE_FIELD}.make ("name")
				>>)
			init_structure_info
		end

end
