class
	PD_TERMCODE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_ARRAY} name.make (<<2>>)
			create {CE_NATURAL_8_POINTER} code.make
		end

feature {ANY} -- fields

	name: CE_ARRAY [NATURAL_8]

	code: CE_POINTER [NATURAL_8] assign set_code

	len: INTEGER_32 assign set_len

	modlen: INTEGER_32 assign set_modlen

feature {ANY} -- field setters

	set_code (a_code: CE_POINTER [NATURAL_8])
		do
			code := a_code
			update_memory_field ("code")
		end

	set_len (a_len: INTEGER_32)
		do
			len := a_len
			update_memory_field ("len")
		end

	set_modlen (a_modlen: INTEGER_32)
		do
			modlen := a_modlen
			update_memory_field ("modlen")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name.twin
			code := a_other.code
			len := a_other.len
			modlen := a_other.modlen
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				code.is_equal (a_other.code) and
				len = a_other.len and
				modlen = a_other.modlen
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("name", <<2>>),
					create {CE_STRUCTURE_FIELD}.make ("code"),
					create {CE_STRUCTURE_FIELD}.make ("len"),
					create {CE_STRUCTURE_FIELD}.make ("modlen")
				>>)
			init_structure_info
		end

end
