class
	PD_U_HEADER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create uh_next.make
			create uh_prev.make
			create uh_alt_next.make
			create uh_alt_prev.make
			create {CE_CLASS_POINTER [PD_U_ENTRY]} uh_entry.make
			create {CE_CLASS_POINTER [PD_U_ENTRY]} uh_getbot_entry.make
			create uh_cursor.make
			create {CE_CLASS_ARRAY [PD_POS_T]} uh_namedm.make (<<26>>)
			create uh_visual.make
		end

feature {ANY} -- fields

	uh_next: PD_UH_NEXT assign set_uh_next

	uh_prev: PD_UH_PREV assign set_uh_prev

	uh_alt_next: PD_UH_ALT_NEXT assign set_uh_alt_next

	uh_alt_prev: PD_UH_ALT_PREV assign set_uh_alt_prev

	uh_seq: INTEGER_32 assign set_uh_seq

	uh_walk: INTEGER_32 assign set_uh_walk

	uh_entry: CE_POINTER [PD_U_ENTRY] assign set_uh_entry

	uh_getbot_entry: CE_POINTER [PD_U_ENTRY] assign set_uh_getbot_entry

	uh_cursor: PD_POS_T assign set_uh_cursor

	uh_cursor_vcol: INTEGER_32 assign set_uh_cursor_vcol

	uh_flags: INTEGER_32 assign set_uh_flags

	uh_namedm: CE_ARRAY [PD_POS_T]

	uh_visual: PD_VISUALINFO_T assign set_uh_visual

	uh_time: INTEGER_32 assign set_uh_time

	uh_save_nr: INTEGER_32 assign set_uh_save_nr

feature {ANY} -- field setters

	set_uh_next (a_uh_next: PD_UH_NEXT)
		do
			uh_next := a_uh_next
			update_memory_field ("uh_next")
		end

	set_uh_prev (a_uh_prev: PD_UH_PREV)
		do
			uh_prev := a_uh_prev
			update_memory_field ("uh_prev")
		end

	set_uh_alt_next (a_uh_alt_next: PD_UH_ALT_NEXT)
		do
			uh_alt_next := a_uh_alt_next
			update_memory_field ("uh_alt_next")
		end

	set_uh_alt_prev (a_uh_alt_prev: PD_UH_ALT_PREV)
		do
			uh_alt_prev := a_uh_alt_prev
			update_memory_field ("uh_alt_prev")
		end

	set_uh_seq (a_uh_seq: INTEGER_32)
		do
			uh_seq := a_uh_seq
			update_memory_field ("uh_seq")
		end

	set_uh_walk (a_uh_walk: INTEGER_32)
		do
			uh_walk := a_uh_walk
			update_memory_field ("uh_walk")
		end

	set_uh_entry (a_uh_entry: CE_POINTER [PD_U_ENTRY])
		do
			uh_entry := a_uh_entry
			update_memory_field ("uh_entry")
		end

	set_uh_getbot_entry (a_uh_getbot_entry: CE_POINTER [PD_U_ENTRY])
		do
			uh_getbot_entry := a_uh_getbot_entry
			update_memory_field ("uh_getbot_entry")
		end

	set_uh_cursor (a_uh_cursor: PD_POS_T)
		do
			uh_cursor := a_uh_cursor
			update_memory_field ("uh_cursor")
		end

	set_uh_cursor_vcol (a_uh_cursor_vcol: INTEGER_32)
		do
			uh_cursor_vcol := a_uh_cursor_vcol
			update_memory_field ("uh_cursor_vcol")
		end

	set_uh_flags (a_uh_flags: INTEGER_32)
		do
			uh_flags := a_uh_flags
			update_memory_field ("uh_flags")
		end

	set_uh_visual (a_uh_visual: PD_VISUALINFO_T)
		do
			uh_visual := a_uh_visual
			update_memory_field ("uh_visual")
		end

	set_uh_time (a_uh_time: INTEGER_32)
		do
			uh_time := a_uh_time
			update_memory_field ("uh_time")
		end

	set_uh_save_nr (a_uh_save_nr: INTEGER_32)
		do
			uh_save_nr := a_uh_save_nr
			update_memory_field ("uh_save_nr")
		end

feature {ANY} -- public routines

	u_free_uhp
		local
			l_nuep: CE_POINTER [PD_U_ENTRY]
			l_uep: CE_POINTER [PD_U_ENTRY]
		do
			l_uep := uh_entry
			from
			until
				l_uep.is_void
			loop
				l_nuep := l_uep.item.ue_next
				l_uep.item.u_freeentry (l_uep.item.ue_size)
				update_class_fields -- Current might have been changed; synchronize
				l_uep := l_nuep
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			uh_next := a_other.uh_next.twin
			uh_prev := a_other.uh_prev.twin
			uh_alt_next := a_other.uh_alt_next.twin
			uh_alt_prev := a_other.uh_alt_prev.twin
			uh_seq := a_other.uh_seq
			uh_walk := a_other.uh_walk
			uh_entry := a_other.uh_entry
			uh_getbot_entry := a_other.uh_getbot_entry
			uh_cursor := a_other.uh_cursor.twin
			uh_cursor_vcol := a_other.uh_cursor_vcol
			uh_flags := a_other.uh_flags
			uh_namedm := a_other.uh_namedm.twin
			uh_visual := a_other.uh_visual.twin
			uh_time := a_other.uh_time
			uh_save_nr := a_other.uh_save_nr
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				uh_next.is_equal (a_other.uh_next) and
				uh_prev.is_equal (a_other.uh_prev) and
				uh_alt_next.is_equal (a_other.uh_alt_next) and
				uh_alt_prev.is_equal (a_other.uh_alt_prev) and
				uh_seq = a_other.uh_seq and
				uh_walk = a_other.uh_walk and
				uh_entry.is_equal (a_other.uh_entry) and
				uh_getbot_entry.is_equal (a_other.uh_getbot_entry) and
				uh_cursor.is_equal (a_other.uh_cursor) and
				uh_cursor_vcol = a_other.uh_cursor_vcol and
				uh_flags = a_other.uh_flags and
				uh_namedm.is_equal (a_other.uh_namedm) and
				uh_visual.is_equal (a_other.uh_visual) and
				uh_time = a_other.uh_time and
				uh_save_nr = a_other.uh_save_nr
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("uh_next"),
					create {CE_STRUCTURE_FIELD}.make ("uh_prev"),
					create {CE_STRUCTURE_FIELD}.make ("uh_alt_next"),
					create {CE_STRUCTURE_FIELD}.make ("uh_alt_prev"),
					create {CE_STRUCTURE_FIELD}.make ("uh_seq"),
					create {CE_STRUCTURE_FIELD}.make ("uh_walk"),
					create {CE_STRUCTURE_FIELD}.make ("uh_entry"),
					create {CE_STRUCTURE_FIELD}.make ("uh_getbot_entry"),
					create {CE_STRUCTURE_FIELD}.make ("uh_cursor"),
					create {CE_STRUCTURE_FIELD}.make ("uh_cursor_vcol"),
					create {CE_STRUCTURE_FIELD}.make ("uh_flags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("uh_namedm", <<26>>),
					create {CE_STRUCTURE_FIELD}.make ("uh_visual"),
					create {CE_STRUCTURE_FIELD}.make ("uh_time"),
					create {CE_STRUCTURE_FIELD}.make ("uh_save_nr")
				>>)
			init_structure_info
		end

end
