class
	PD_UFUNC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create uf_args.make
			create uf_lines.make
			create {CE_NATURAL_8_ARRAY} uf_name.make (<<1>>)
			Precursor
		end

feature {ANY} -- fields

	uf_varargs: INTEGER_32 assign set_uf_varargs

	uf_flags: INTEGER_32 assign set_uf_flags

	uf_calls: INTEGER_32 assign set_uf_calls

	uf_args: PD_GROWARRAY assign set_uf_args

	uf_lines: PD_GROWARRAY assign set_uf_lines

	uf_script_ID: INTEGER_32 assign set_uf_script_ID

	uf_refcount: INTEGER_32 assign set_uf_refcount

	uf_name: CE_ARRAY [NATURAL_8]

feature {ANY} -- field setters

	set_uf_varargs (a_uf_varargs: INTEGER_32)
		do
			uf_varargs := a_uf_varargs
			update_memory_field ("uf_varargs")
		end

	set_uf_flags (a_uf_flags: INTEGER_32)
		do
			uf_flags := a_uf_flags
			update_memory_field ("uf_flags")
		end

	set_uf_calls (a_uf_calls: INTEGER_32)
		do
			uf_calls := a_uf_calls
			update_memory_field ("uf_calls")
		end

	set_uf_args (a_uf_args: PD_GROWARRAY)
		do
			uf_args := a_uf_args
			update_memory_field ("uf_args")
		end

	set_uf_lines (a_uf_lines: PD_GROWARRAY)
		do
			uf_lines := a_uf_lines
			update_memory_field ("uf_lines")
		end

	set_uf_script_ID (a_uf_script_ID: INTEGER_32)
		do
			uf_script_ID := a_uf_script_ID
			update_memory_field ("uf_script_ID")
		end

	set_uf_refcount (a_uf_refcount: INTEGER_32)
		do
			uf_refcount := a_uf_refcount
			update_memory_field ("uf_refcount")
		end

feature {ANY} -- public routines

	cat_func_name (a_buf___6: CE_POINTER [NATURAL_8])
		do
			if (uf_name[0]).to_integer_32 = 128 then
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), ce_string ("<SNR>")).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				strcat (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), create {CE_INTEGER_8_POINTER}.make_cast ((uf_name + 3))).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			else
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (uf_name)).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	func_free
		local
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_tmp: CE_POINTER [INTEGER_8]
		do
			(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_UFUNC}.make).offset_of ("uf_args"))).item.ga_clear_strings
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_UFUNC}.make).offset_of ("uf_lines"))).item.ga_clear_strings
			update_class_fields -- Current might have been changed; synchronize
			l_hi___1 := ((create {P_EVAL_STATIC}).func_hashtab.item).item.hash_find (uf_name)
			update_class_fields -- Current might have been changed; synchronize
			if (l_hi___1.item.hi_key).is_void then
				l_tmp := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_intern2.item)))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("func_free()"))).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			elseif (l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item) then
				l_tmp := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_intern2.item)))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("func_free()"))).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			else
				((create {P_EVAL_STATIC}).func_hashtab.item).item.hash_remove (l_hi___1)
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			uf_varargs := a_other.uf_varargs
			uf_flags := a_other.uf_flags
			uf_calls := a_other.uf_calls
			uf_args := a_other.uf_args.twin
			uf_lines := a_other.uf_lines.twin
			uf_script_ID := a_other.uf_script_ID
			uf_refcount := a_other.uf_refcount
			uf_name := a_other.uf_name.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				uf_varargs = a_other.uf_varargs and
				uf_flags = a_other.uf_flags and
				uf_calls = a_other.uf_calls and
				uf_args.is_equal (a_other.uf_args) and
				uf_lines.is_equal (a_other.uf_lines) and
				uf_script_ID = a_other.uf_script_ID and
				uf_refcount = a_other.uf_refcount and
				uf_name.is_equal (a_other.uf_name)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("uf_varargs"),
					create {CE_STRUCTURE_FIELD}.make ("uf_flags"),
					create {CE_STRUCTURE_FIELD}.make ("uf_calls"),
					create {CE_STRUCTURE_FIELD}.make ("uf_args"),
					create {CE_STRUCTURE_FIELD}.make ("uf_lines"),
					create {CE_STRUCTURE_FIELD}.make ("uf_script_ID"),
					create {CE_STRUCTURE_FIELD}.make ("uf_refcount"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("uf_name", <<1>>)
				>>)
			init_structure_info
		end

end
