class
	PD_VIR_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_CTYPE_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} vir_line.make
			create {CE_CLASS_POINTER [SD_IO_FILE]} vir_fd.make
			create vir_conv.make
			Precursor
		end

feature {ANY} -- fields

	vir_line: CE_POINTER [NATURAL_8] assign set_vir_line

	vir_fd: CE_POINTER [SD_IO_FILE] assign set_vir_fd

	vir_conv: PD_VIMCONV_T assign set_vir_conv

feature {ANY} -- field setters

	set_vir_line (a_vir_line: CE_POINTER [NATURAL_8])
		do
			vir_line := a_vir_line
			update_memory_field ("vir_line")
		end

	set_vir_fd (a_vir_fd: CE_POINTER [SD_IO_FILE])
		do
			vir_fd := a_vir_fd
			update_memory_field ("vir_fd")
		end

	set_vir_conv (a_vir_conv: PD_VIMCONV_T)
		do
			vir_conv := a_vir_conv
			update_memory_field ("vir_conv")
		end

feature {PD_VIR_T} -- private attributes

	viminfo_hislen: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					0, 0, 0, 0, 0
				>>)
		end

	viminfo_history: CE_STATIC [CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [CE_POINTER [NATURAL_8]]}.make_initialized (<<
					create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer),
					create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer),
					create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer),
					create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer),
					create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
				>>)
		end

	viminfo_hisidx: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					0, 0, 0, 0, 0
				>>)
		end

	viminfo_add_at_front: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	hlsearch_on: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	viminfo_readline: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			l_tmp := (create {P_FILEIO_STATIC}).vim_fgets (vir_line, 512, vir_fd)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	viminfo_readstring (a_off___0, a_convert: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_retval: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (vir_line[a_off___0]).to_integer_32 /= 22 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_tmp := (create {P_CHARSET_STATIC}).vim_isdigit ((vir_line[(a_off___0 + 1)]).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp.to_boolean then
							l_len := atol (((create {CE_INTEGER_8_POINTER}.make_cast (vir_line) + a_off___0) + 1))
							update_class_fields -- Current might have been changed; synchronize
							l_retval := (create {P_MISC2_STATIC}).lalloc (l_len.to_natural_32, 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_retval.is_void then
								(create {P_FILEIO_STATIC}).vim_fgets (vir_line, 10, vir_fd).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
								l_return := True
							end
							if not l_return then
								(create {P_FILEIO_STATIC}).vim_fgets (l_retval, l_len.to_integer_32, vir_fd).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_s := l_retval + 1
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_retval := (create {P_MISC2_STATIC}).vim_strsave (vir_line + a_off___0)
						update_class_fields -- Current might have been changed; synchronize
						if l_retval.is_void then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return then
							l_s := l_retval
						end
				when 4 then
					if not l_return then
						l_d := l_retval
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_s.item).to_integer_32 /= 0 then
								if (l_s.item).to_integer_32 = 10 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								if (l_s[0]).to_integer_32 = 22 then
									if (l_s[1]).to_integer_32 /= 0 then
										if (l_s[1]).to_integer_32 = 110 then
											l_tmp___0 := l_d
											l_d := l_d + 1
											l_tmp___0.item := (('%N').code).to_natural_8
											update_class_fields -- Current might have been changed; synchronize
										else
											l_tmp___1 := l_d
											l_d := l_d + 1
											l_tmp___1.item := (22).to_natural_8
											update_class_fields -- Current might have been changed; synchronize
										end
										l_s := l_s + (2)
									else
										l_tmp___2 := l_d
										l_d := l_d + 1
										l_tmp___3 := l_s
										l_s := l_s + 1
										l_tmp___2.item := l_tmp___3.item
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									l_tmp___2 := l_d
									l_d := l_d + 1
									l_tmp___3 := l_s
									l_s := l_s + 1
									l_tmp___2.item := l_tmp___3.item
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						l_break := False
						l_d.item := (('%/0/').code).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						if a_convert.to_boolean then
							if vir_conv.vc_type /= 0 then
								if (l_retval.item).to_integer_32 /= 0 then
									l_d := (create {P_MBYTE_STATIC}).string_convert (create {CE_CLASS_POINTER [PD_VIMCONV_T]}.make_shared (c_pointer + (create {PD_VIR_T}.make).offset_of ("vir_conv")), l_retval, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
									update_class_fields -- Current might have been changed; synchronize
									if not l_d.is_void then
										(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_retval))
										update_class_fields -- Current might have been changed; synchronize
										l_retval := l_d
									end
								end
							end
						end
						Result := l_retval
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	read_viminfo_sub_string (a_force: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if not ((create {P_EX_CMDS_STATIC}).old_sub.item).is_void then
				if a_force.to_boolean then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_EX_CMDS_STATIC}).old_sub.item))
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if a_force.to_boolean then
				(create {P_EX_CMDS_STATIC}).old_sub.item := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readstring (1, 1)
				update_class_fields -- Current might have been changed; synchronize
			elseif ((create {P_EX_CMDS_STATIC}).old_sub.item).is_void then
				(create {P_EX_CMDS_STATIC}).old_sub.item := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readstring (1, 1)
				update_class_fields -- Current might have been changed; synchronize
			end
			l_tmp := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readline
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	read_viminfo_history: INTEGER_32
		local
			l_type: INTEGER_32
			l_len: NATURAL_32
			l_val___0: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
		do
			l_type := (create {P_EX_GETLN_STATIC}).hist_char2type ((vir_line[0]).to_integer_32)
			update_class_fields -- Current might have been changed; synchronize
			if viminfo_hisidx.item[l_type] < viminfo_hislen.item[l_type] then
				l_val___0 := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readstring (1, 1)
				update_class_fields -- Current might have been changed; synchronize
				if not l_val___0.is_void then
					if (l_val___0.item).to_integer_32 /= 0 then
						l_tmp___1 := (create {P_EX_GETLN_STATIC}).in_history (l_type, l_val___0 + (l_type = 1).to_integer, viminfo_add_at_front.item)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___1.to_boolean then
							l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_val___0))
							update_class_fields -- Current might have been changed; synchronize
							l_len := l_tmp.to_natural_32
							l_p___0 := (create {P_MISC2_STATIC}).lalloc (l_len + {NATURAL_32} 2, 1)
							update_class_fields -- Current might have been changed; synchronize
							if not l_p___0.is_void then
								if l_type = 1 then
									memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_val___0 + 1)), l_len.to_natural_32).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									if (l_val___0.item).to_integer_32 = 32 then
										l_p___0[l_len.to_integer_32] := (('%/0/').code).to_natural_8
										update_class_fields -- Current might have been changed; synchronize
									else
										l_p___0[l_len.to_integer_32] := l_val___0.item
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_val___0), l_len.to_natural_32 + {NATURAL_32} 1).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									l_p___0[(l_len + {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_natural_8
									update_class_fields -- Current might have been changed; synchronize
								end
								l_tmp___0 := viminfo_hisidx.item[l_type]
								viminfo_hisidx.item[l_type] := (viminfo_hisidx.item[l_type]) + 1
								update_class_fields; -- Current might have been changed; synchronize
								(viminfo_history.item[l_type])[l_tmp___0] := l_p___0
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_val___0))
				update_class_fields -- Current might have been changed; synchronize
			end
			l_tmp___2 := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readline
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp___2
		end

	read_viminfo_filemark (a_force: INTEGER_32): INTEGER_32
		local
			l_str___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_fm: CE_POINTER [PD_XFILEMARK]
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___1: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_str___1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str___1.item := vir_line + 1
					update_class_fields -- Current might have been changed; synchronize
					if not ((l_str___1.item.item).to_integer_32 <= 127) then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						if (vir_line.item).to_integer_32 /= 39 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if not ((l_str___1.item.item).to_integer_32 >= 48) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_str___1.item.item).to_integer_32 <= 57 then
							l_pos := -1 + 9 -- goto _L___0
						else
							l_pos := -1 + 5 -- goto _L___2
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L___2:
						l_tmp___0 := ctype_b_loc
						update_class_fields -- Current might have been changed; synchronize
						if (((l_tmp___0.item[(l_str___1.item.item).to_integer_32]).to_integer_32).bit_and (256)).to_boolean then
							l_pos := -1 + 9 -- goto _L___0
						else
							l_pos := -1 + 7 -- goto _L___1
						end
				when 6 then -- if done | if block done, skip else block:
						l_pos := -1 + 15
				when 7 then -- else: | _L___1:
						if (vir_line.item).to_integer_32 /= 45 then
							l_pos := -1 + 15 -- skip if block
						end
				when 8 then -- if:
						if (l_str___1.item.item).to_integer_32 /= 39 then
							l_pos := -1 + 15 -- skip if block
						end
				when 9 then -- if: | _L___0:
						if (l_str___1.item.item).to_integer_32 = 39 then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen = 100 then
								l_fm := create {CE_CLASS_POINTER [PD_XFILEMARK]}.make_shared (default_pointer)
							else
								l_i___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen
								from
								until
									not (l_i___0 > 0)
								loop
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_i___0] := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_i___0 - 1]).twin
									update_class_fields -- Current might have been changed; synchronize
									l_i___0 := l_i___0 - 1
								end
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistidx := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistidx) + 1
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen) + 1
								update_class_fields -- Current might have been changed; synchronize
								l_fm := create {CE_CLASS_POINTER [PD_XFILEMARK]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_jumplist") + (create {PD_XFILEMARK}.make).structure_size * (0))
								l_fm.item.fmark.mark.lnum := (0).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								l_fm.item.fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								update_class_fields -- Current might have been changed; synchronize
							end
						elseif (l_str___1.item.item).to_integer_32 >= 48 then
							if (l_str___1.item.item).to_integer_32 <= 57 then
								l_fm := (create {P_MARK_STATIC}).namedfm.item + ((l_str___1.item.item).to_integer_32 - 48) + 26
							else
								l_fm := (create {P_MARK_STATIC}).namedfm.item + (l_str___1.item.item).to_integer_32 - 65
							end
						else
							l_fm := (create {P_MARK_STATIC}).namedfm.item + (l_str___1.item.item).to_integer_32 - 65
						end
						if l_fm.is_void then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						if l_fm.item.fmark.mark.lnum /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if not (a_force.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						l_str___1.item := (create {P_CHARSET_STATIC}).skipwhite (l_str___1.item + 1)
						update_class_fields -- Current might have been changed; synchronize
						l_fm.item.fmark.mark.lnum := (create {P_CHARSET_STATIC}).getdigits (l_str___1)
						update_class_fields -- Current might have been changed; synchronize
						l_str___1.item := (create {P_CHARSET_STATIC}).skipwhite (l_str___1.item)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp := (create {P_CHARSET_STATIC}).getdigits (l_str___1)
						update_class_fields -- Current might have been changed; synchronize
						l_fm.item.fmark.mark.col := l_tmp.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_fm.item.fmark.mark.coladd := 0
						update_class_fields -- Current might have been changed; synchronize
						l_fm.item.fmark.fnum := 0
						update_class_fields -- Current might have been changed; synchronize
						l_str___1.item := (create {P_CHARSET_STATIC}).skipwhite (l_str___1.item)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fm.item.fname))
						update_class_fields -- Current might have been changed; synchronize
						l_fm.item.fname := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readstring ((l_str___1.item).distance (vir_line), 0)
						update_class_fields -- Current might have been changed; synchronize
				when 15 then -- if done | if done | if done | if done | if done | if done
					l_tmp___1 := (create {P_FILEIO_STATIC}).vim_fgets (vir_line, 512, vir_fd)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_tmp___1
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	copy_viminfo_marks (a_fp_out: CE_POINTER [SD_IO_FILE]; a_count___2, a_eof, a_flags___0: INTEGER_32)
		local
			l_count___2: INTEGER_32
			l_eof: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_num_marked_files: INTEGER_32
			l_load_marks: INTEGER_32
			l_copy_marks_out: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_name_buf: CE_POINTER [NATURAL_8]
			l_pos___3: CE_ARRAY [PD_POS_T]
			l_list: CE_POINTER [PD_LISTVAR_S]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_str___1.make
			create {CE_CLASS_ARRAY [PD_POS_T]} l_pos___3.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_count___2
					l_eof := a_eof
					l_line := vir_line
					l_list := create {CE_CLASS_POINTER [PD_LISTVAR_S]}.make_shared (default_pointer)
					l_name_buf := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 512)
					update_class_fields -- Current might have been changed; synchronize
					if l_name_buf.is_void then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 21 -- skip if block
					end
				when 1 then -- if:
						l_name_buf.item := (('%/0/').code).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						if a_fp_out.is_void then
							if ((a_flags___0).bit_and (12)).to_boolean then
								l_list := (create {P_EVAL_STATIC}).list_alloc
								update_class_fields -- Current might have been changed; synchronize
								if not l_list.is_void then
									set_vim_var_list (54, l_list)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						l_num_marked_files := (create {P_OPTION_STATIC}).get_viminfo_parameter (('%'').code)
						update_class_fields -- Current might have been changed; synchronize
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 20 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						if not l_eof.to_boolean then
							if not (l_count___2 < l_num_marked_files) then
								if not (a_fp_out.is_void) then
									l_break := True
								end
							end
						else
							l_break := True
						end
						if not (l_return or l_break or l_continue) and then ((l_line[0]).to_integer_32 /= 62) then
							if (l_line[0]).to_integer_32 /= 10 then
								if (l_line[0]).to_integer_32 /= 13 then
									if (l_line[0]).to_integer_32 /= 35 then
										l_tmp := gettext (ce_string ("Missing %'>%'"))
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___0 := viminfo_error (ce_string ("E576: "), l_tmp, l_line)
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___0.to_boolean then
											l_break := True
										end
									end
								end
							end
							if not (l_return or l_break or l_continue) then
								l_eof := (create {P_FILEIO_STATIC}).vim_fgets (l_line, 512, vir_fd)
								update_class_fields -- Current might have been changed; synchronize
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							l_str___1 := (create {P_CHARSET_STATIC}).skipwhite (l_line + 1)
							update_class_fields -- Current might have been changed; synchronize
							l_str___1 := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readstring (l_str___1.distance (vir_line), 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_str___1.is_void then
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 19 -- skip if block
						end
				when 4 then -- if:
						l_tmp___1 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_str___1))
						update_class_fields -- Current might have been changed; synchronize
						l_p___0 := l_str___1 + l_tmp___1.to_integer_32
						from
						until
							(l_break)
						loop
							l_break := False
							if not l_p___0.is_equal (l_str___1) then
								if (l_p___0.item).to_integer_32 /= 0 then
									l_tmp___2 := (create {P_MISC2_STATIC}).vim_isspace ((l_p___0.item).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									if not l_tmp___2.to_boolean then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_p___0 := l_p___0 - 1
							end
						end
						l_break := False
						if (l_p___0.item).to_boolean then
							l_p___0 := l_p___0 + 1
						end
						l_p___0.item := (('%/0/').code).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						if not l_list.is_void then
							(create {P_EVAL_STATIC}).list_append_string (l_list, l_str___1, -1).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						l_copy_marks_out := 0
						l_load_marks := l_copy_marks_out
						if a_fp_out.is_void then
							if ((a_flags___0).bit_and (2)).to_boolean then
								if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
									if (l_name_buf.item).to_integer_32 = 0 then
										(create {P_MISC1_STATIC}).home_replace (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname, l_name_buf, 512, 1)
										update_class_fields -- Current might have been changed; synchronize
									end
									l_tmp___3 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_str___1), create {CE_INTEGER_8_POINTER}.make_cast (l_name_buf))
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___3 = 0 then
										l_load_marks := 1
									end
								end
							end
						else
							l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
							from
							until
								not (not (l_break) and then (not l_buf___6.is_void))
							loop
								l_break := False
								if not (l_buf___6.item.b_ffname).is_void then
									(create {P_MISC1_STATIC}).home_replace (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_buf___6.item.b_ffname, l_name_buf, 512, 1)
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___4 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_str___1), create {CE_INTEGER_8_POINTER}.make_cast (l_name_buf))
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___4 = 0 then
										l_break := True
									end
								end
								if not (l_break) then
									l_buf___6 := l_buf___6.item.b_next
								end
							end
							l_break := False
							if l_buf___6.is_void then
								l_copy_marks_out := 1
								fputs (ce_string ("%N> "), a_fp_out).do_nothing
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_EX_CMDS_STATIC}).viminfo_writestring (a_fp_out, l_str___1)
								update_class_fields -- Current might have been changed; synchronize
								l_count___2 := l_count___2 + 1
							elseif not (l_buf___6.item.b_marks_read).to_boolean then
								l_copy_marks_out := 1
								fputs (ce_string ("%N> "), a_fp_out).do_nothing
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_EX_CMDS_STATIC}).viminfo_writestring (a_fp_out, l_str___1)
								update_class_fields -- Current might have been changed; synchronize
								l_count___2 := l_count___2 + 1
							end
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_str___1))
						update_class_fields -- Current might have been changed; synchronize
						l_pos___3.item.coladd := 0
						update_class_fields -- Current might have been changed; synchronize
				when 5 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 18 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						l_eof := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readline
						update_class_fields -- Current might have been changed; synchronize
						if l_eof.to_boolean then
							l_break := True
						elseif (l_line[0]).to_integer_32 /= 9 then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 17 -- skip if block
						end
				when 7 then -- if:
						if not (l_load_marks.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 8 then -- if:
						if (l_line[1]).to_integer_32 = 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 9 then -- if:
						sscanf ([(create {CE_INTEGER_8_POINTER}.make_cast (l_line) + 2), ce_string ("%%ld %%u"), create {CE_INTEGER_32_POINTER}.make_shared (l_pos___3.item.c_pointer + (create {PD_POS_T}.make).offset_of ("lnum")), create {CE_INTEGER_32_POINTER}.make_shared (l_pos___3.item.c_pointer + (create {PD_POS_T}.make).offset_of ("col"))]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						inspect (l_line[1]).to_integer_32 -- switch 1 head
						when 34 then l_pos := -1 + 10
						when 94 then l_pos := -1 + 11
						when 46 then l_pos := -1 + 12
						when 43 then l_pos := -1 + 13
						else l_pos := -1 + 14
						end
				when 10 then -- switch 1, case 34;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_last_cursor := (l_pos___3.item).twin
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 15 -- switch 1; break
				when 11 then -- switch 1, case 94;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_last_insert := (l_pos___3.item).twin
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 15 -- switch 1; break
				when 12 then -- switch 1, case 46;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_last_change := (l_pos___3.item).twin
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 15 -- switch 1; break
				when 13 then -- switch 1, case 43
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen = 100 then
							memmove (create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelist)), create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelist + 1)), (create {PD_POS_T}.make).structure_size.to_natural_32 * {NATURAL_32} 99).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen) + 1
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelist[(create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen - 1] := (l_pos___3.item).twin
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 15 -- switch 1; break
				when 14 then -- switch 1, default:
						l_i___0 := (l_line[1]).to_integer_32 - 97
						if l_i___0 >= 0 then
							if l_i___0 < 26 then
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_namedm[l_i___0] := (l_pos___3.item).twin
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 15 then -- switch 1, done: | if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						if l_copy_marks_out.to_boolean then
							fputs (create {CE_INTEGER_8_POINTER}.make_cast (l_line), a_fp_out).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
				when 17 then -- if done | if done
						l_pos := -1 + 5 -- back to loop condition
				when 18 then -- loop done
						l_break := False
						if l_load_marks.to_boolean then
							l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
							from
							until
								l_wp___0.is_void
							loop
								if (l_wp___0.item.w_buffer).is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
									l_wp___0.item.w_changelistidx := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen
									update_class_fields -- Current might have been changed; synchronize
								end
								l_wp___0 := l_wp___0.item.w_next
							end
							l_break := True
						end
				when 19 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 20 then -- loop done
						l_break := False
						l_continue := False;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_name_buf))
						update_class_fields -- Current might have been changed; synchronize
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	read_viminfo_register (a_force: INTEGER_32): INTEGER_32
		local
			l_eof: INTEGER_32
			l_do_it: INTEGER_32
			l_size: INTEGER_32
			l_limit: INTEGER_32
			l_i___0: INTEGER_32
			l_set_prev: INTEGER_32
			l_str___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_array: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: INTEGER_32
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: INTEGER_32
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_str___1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_do_it := 1
					l_set_prev := 0
					l_array := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_str___1.item := vir_line + 1
					update_class_fields -- Current might have been changed; synchronize
					if (l_str___1.item.item).to_integer_32 = 34 then
						l_set_prev := 1
						l_str___1.item := l_str___1.item + 1
						update_class_fields -- Current might have been changed; synchronize
					end
					if not ((l_str___1.item.item).to_integer_32 < 127) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_tmp___1 := ctype_b_loc
						update_class_fields -- Current might have been changed; synchronize
						if not (((l_tmp___1.item[(l_str___1.item.item).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (l_str___1.item.item).to_integer_32 /= 45 then
							l_tmp := gettext (ce_string ("Illegal register name"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___0 := viminfo_error (ce_string ("E577: "), l_tmp, vir_line)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___0.to_boolean then
								Result := 1
								l_return := True
							end
							if not l_return then
								l_do_it := 0
							end
						end
				when 4 then
					if not l_return then
						l_tmp___2 := l_str___1.item
						l_str___1.item := l_str___1.item + 1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_OPS_STATIC}).get_yank_register ((l_tmp___2.item).to_integer_32, 0)
						update_class_fields -- Current might have been changed; synchronize
						if not a_force.to_boolean then
							if not ((create {P_OPS_STATIC}).y_current.item.item.y_array).is_void then
								l_do_it := 0
							end
						end
						if (l_str___1.item.item).to_integer_32 = 64 then
							if a_force.to_boolean then
								(create {P_OPS_STATIC}).execreg_lastc.item := (l_str___1.item[-1]).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							elseif (create {P_OPS_STATIC}).execreg_lastc.item = 0 then
								(create {P_OPS_STATIC}).execreg_lastc.item := (l_str___1.item[-1]).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_size := 0
						l_limit := 100
						if l_do_it.to_boolean then
							if l_set_prev.to_boolean then
								(create {P_OPS_STATIC}).y_previous.item := (create {P_OPS_STATIC}).y_current.item
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_OPS_STATIC}).y_current.item.item.y_array))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___4 := (create {P_MISC2_STATIC}).alloc (l_limit.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___3 := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_tmp___4);
							(create {P_OPS_STATIC}).y_current.item.item.y_array := l_tmp___3
							update_class_fields -- Current might have been changed; synchronize
							l_array := l_tmp___3
							l_tmp___5 := (create {P_CHARSET_STATIC}).skiptowhite (l_str___1.item)
							update_class_fields -- Current might have been changed; synchronize
							l_str___1.item := (create {P_CHARSET_STATIC}).skipwhite (l_tmp___5)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___7 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_str___1.item), ce_string ("CHAR"), (4).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___7 = 0 then
								(create {P_OPS_STATIC}).y_current.item.item.y_type := (0).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___6 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_str___1.item), ce_string ("BLOCK"), (5).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___6 = 0 then
									(create {P_OPS_STATIC}).y_current.item.item.y_type := (2).to_natural_8
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_OPS_STATIC}).y_current.item.item.y_type := (1).to_natural_8
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_tmp___8 := (create {P_CHARSET_STATIC}).skiptowhite (l_str___1.item)
							update_class_fields -- Current might have been changed; synchronize
							l_str___1.item := (create {P_CHARSET_STATIC}).skipwhite (l_tmp___8)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___9 := (create {P_CHARSET_STATIC}).getdigits (l_str___1)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_OPS_STATIC}).y_current.item.item.y_width := l_tmp___9.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_eof := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readline
							update_class_fields -- Current might have been changed; synchronize
							if l_eof.to_boolean then
								l_break := True
							elseif (vir_line[0]).to_integer_32 /= 9 then
								if (vir_line[0]).to_integer_32 /= 60 then
									l_break := True
								end
							end
							if not (l_return or l_break) and then (l_do_it.to_boolean) then
								if l_size >= l_limit then
									l_tmp___10 := (create {P_MISC2_STATIC}).alloc ((l_limit * 2).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_OPS_STATIC}).y_current.item.item.y_array := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_tmp___10)
									update_class_fields -- Current might have been changed; synchronize
									l_i___0 := 0
									from
									until
										not (l_i___0 < l_limit)
									loop
										(create {P_OPS_STATIC}).y_current.item.item.y_array[l_i___0] := l_array[l_i___0]
										update_class_fields -- Current might have been changed; synchronize
										l_i___0 := l_i___0 + 1
									end
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_array))
									update_class_fields -- Current might have been changed; synchronize
									l_limit := l_limit * (2)
									l_array := (create {P_OPS_STATIC}).y_current.item.item.y_array
								end
								l_str___1.item := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readstring (1, 1)
								update_class_fields -- Current might have been changed; synchronize
								if not (l_str___1.item).is_void then
									l_tmp___11 := l_size
									l_size := l_size + 1
									l_array[l_tmp___11] := l_str___1.item
									update_class_fields -- Current might have been changed; synchronize
								else
									l_do_it := 0
								end
							end
						end
						l_break := False
						if l_do_it.to_boolean then
							if l_size = 0 then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_array))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_OPS_STATIC}).y_current.item.item.y_array := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
								update_class_fields -- Current might have been changed; synchronize
							elseif l_size < l_limit then
								l_tmp___12 := (create {P_MISC2_STATIC}).alloc (l_size.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_OPS_STATIC}).y_current.item.item.y_array := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_tmp___12)
								update_class_fields -- Current might have been changed; synchronize
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_size)
								loop
									(create {P_OPS_STATIC}).y_current.item.item.y_array[l_i___0] := l_array[l_i___0]
									update_class_fields -- Current might have been changed; synchronize
									l_i___0 := l_i___0 + 1
								end
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_array))
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_OPS_STATIC}).y_current.item.item.y_size := l_size.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
						Result := l_eof
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	read_viminfo_search_pattern (a_force: INTEGER_32): INTEGER_32
		local
			l_lp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_idx: INTEGER_32
			l_magic: INTEGER_32
			l_no_scs: INTEGER_32
			l_off_line: INTEGER_32
			l_off_end: INTEGER_32
			l_off___0: INTEGER_32
			l_setlast: INTEGER_32
			l_val___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_lp.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_idx := -1
					l_magic := 0
					l_no_scs := 0
					l_off_line := 0
					l_off_end := 0
					l_off___0 := 0
					l_setlast := 0
					l_lp.item := vir_line
					update_class_fields -- Current might have been changed; synchronize
					if (l_lp.item[0]).to_integer_32 /= 126 then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if (l_lp.item[1]).to_integer_32 /= 109 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (l_lp.item[1]).to_integer_32 /= 77 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (l_lp.item[1]).to_integer_32 = 77 then
							l_magic := 1
						end
						if (l_lp.item[2]).to_integer_32 = 115 then
							l_no_scs := 1
						end
						if (l_lp.item[3]).to_integer_32 = 76 then
							l_off_line := 1
						end
						if (l_lp.item[4]).to_integer_32 = 69 then
							l_off_end := 64
						end
						l_lp.item := l_lp.item + (5)
						update_class_fields -- Current might have been changed; synchronize
						l_off___0 := (create {P_CHARSET_STATIC}).getdigits (l_lp)
						update_class_fields -- Current might have been changed; synchronize
				when 6 then -- if done | if done
					if (l_lp.item[0]).to_integer_32 = 126 then
						l_setlast := 1
						l_lp.item := l_lp.item + 1
						update_class_fields -- Current might have been changed; synchronize
					end
					if (l_lp.item[0]).to_integer_32 = 47 then
						l_idx := 0
					elseif (l_lp.item[0]).to_integer_32 = 38 then
						l_idx := 1
					elseif (l_lp.item[0]).to_integer_32 = 104 then
						hlsearch_on.item := 0
					elseif (l_lp.item[0]).to_integer_32 = 72 then
						hlsearch_on.item := 1
					end
					if not (l_idx >= 0) then
						l_pos := -1 + 12 -- skip if block
					end
				when 7 then -- if:
						if not (a_force.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L___0
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if not (((create {P_SEARCH_STATIC}).spats.item[l_idx].pat).is_void) then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L___0:
						l_val___0 := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readstring (((l_lp.item).distance (vir_line)) + 1, 1)
						update_class_fields -- Current might have been changed; synchronize
						if not l_val___0.is_void then
							(create {P_SEARCH_STATIC}).set_last_search_pat (l_val___0, l_idx, l_magic, l_setlast)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_val___0))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_SEARCH_STATIC}).spats.item[l_idx].no_scs := l_no_scs
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_SEARCH_STATIC}).spats.item[l_idx].off.line := l_off_line
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_SEARCH_STATIC}).spats.item[l_idx].off.end2 := l_off_end
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_SEARCH_STATIC}).spats.item[l_idx].off.off := l_off___0
							update_class_fields -- Current might have been changed; synchronize
							if l_setlast.to_boolean then
								(create {P_GLOBALS_STATIC}).no_hlsearch.item := (not hlsearch_on.item.to_boolean).to_integer
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 12 then -- if done | if done
					l_tmp := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readline
					update_class_fields -- Current might have been changed; synchronize
					Result := l_tmp
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	read_viminfo_bufferlist (a_writing: INTEGER_32): INTEGER_32
		local
			l_tab___0: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_col: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_sfname: CE_POINTER [NATURAL_8]
			l_xline: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
		do
			l_xline := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readstring (1, 0)
			update_class_fields -- Current might have been changed; synchronize
			if not l_xline.is_void then
				if not a_writing.to_boolean then
					if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_alist).item.al_ga.ga_len = 0 then
						l_tmp___2 := (create {P_OPTION_STATIC}).find_viminfo_parameter (('%%').code)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___2.is_void then
							l_lnum := (0).to_integer_32
							l_col := 0
							l_tab___0 := (create {P_MISC2_STATIC}).vim_strrchr (l_xline, ('%T').code)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tab___0.is_void then
								l_tmp := l_tab___0
								l_tab___0 := l_tab___0 + 1
								l_tmp.item := (('%/0/').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___0 := atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_tab___0))
								update_class_fields -- Current might have been changed; synchronize
								l_col := l_tmp___0
								l_tab___0 := (create {P_MISC2_STATIC}).vim_strrchr (l_xline, ('%T').code)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tab___0.is_void then
									l_tmp___1 := l_tab___0
									l_tab___0 := l_tab___0 + 1
									l_tmp___1.item := (('%/0/').code).to_natural_8
									update_class_fields -- Current might have been changed; synchronize
									l_lnum := atol (create {CE_INTEGER_8_POINTER}.make_cast (l_tab___0))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							(create {P_MISC1_STATIC}).expand_env (l_xline, (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096)
							update_class_fields -- Current might have been changed; synchronize
							l_sfname := (create {P_FILEIO_STATIC}).shorten_fname1 ((create {P_GLOBALS_STATIC}).NameBuff.item.item)
							update_class_fields -- Current might have been changed; synchronize
							l_buf___6 := (create {P_BUFFER_STATIC}).buflist_new ((create {P_GLOBALS_STATIC}).NameBuff.item.item, l_sfname, (0).to_integer_32, 2)
							update_class_fields -- Current might have been changed; synchronize
							if not l_buf___6.is_void then
								l_buf___6.item.b_last_cursor.lnum := l_lnum
								update_class_fields -- Current might have been changed; synchronize
								l_buf___6.item.b_last_cursor.col := l_col
								update_class_fields -- Current might have been changed; synchronize
								l_buf___6.item.buflist_setfpos ((create {P_GLOBALS_STATIC}).curwin.item, l_lnum, l_col, 0)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
				end
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_xline))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___3 := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readline
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp___3
		end

	read_viminfo_varlist (a_writing: INTEGER_32): INTEGER_32
		local
			l_tab___0: CE_POINTER [NATURAL_8]
			l_type: INTEGER_32
			l_tv: CE_ARRAY [PD_TYPVAL_T]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_TYPVAL_T]} l_tv.make (<<1>>)

			l_type := 1
			if not a_writing.to_boolean then
				l_tmp___1 := (create {P_OPTION_STATIC}).find_viminfo_parameter (('!').code)
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp___1.is_void then
					l_tab___0 := (create {P_MISC2_STATIC}).vim_strchr (vir_line + 1, ('%T').code)
					update_class_fields -- Current might have been changed; synchronize
					if not l_tab___0.is_void then
						l_tmp := l_tab___0
						l_tab___0 := l_tab___0 + 1
						l_tmp.item := (('%/0/').code).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						if (l_tab___0.item).to_integer_32 = 83 then
							l_type := 2
						elseif (l_tab___0.item).to_integer_32 = 70 then
							l_type := 6
						end
						l_tab___0 := (create {P_MISC2_STATIC}).vim_strchr (l_tab___0, ('%T').code)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tab___0.is_void then
							l_tv.item.v_type := l_type.to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							if l_type = 2 then
								l_tv.item.vval.v_string := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readstring ((l_tab___0.distance (vir_line)) + 1, 1)
								update_class_fields -- Current might have been changed; synchronize
							elseif l_type = 6 then
								(create {P_EVAL_STATIC}).string2float (l_tab___0 + 1, create {CE_REAL_64_POINTER}.make_shared (l_tv.item.c_pointer + (create {PD_TYPVAL_T}.make).offset_of ("vval") + (create {PD_VVAL}.make).offset_of ("v_float"))).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___0 := atol ((create {CE_INTEGER_8_POINTER}.make_cast (l_tab___0) + 1))
								update_class_fields -- Current might have been changed; synchronize
								l_tv.item.vval.v_number := l_tmp___0.to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_EVAL_STATIC}).set_var (vir_line + 1, l_tv, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_type = 2 then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tv.item.vval.v_string))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
				end
			end
			l_tmp___2 := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readline
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp___2
		end

	read_viminfo_up_to_marks (a_forceit, a_writing: INTEGER_32): INTEGER_32
		local
			l_eof: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_forceit.to_boolean then
						l_tmp := 9_999
					else
						l_tmp := 0
					end
					prepare_viminfo_history (l_tmp)
					update_class_fields -- Current might have been changed; synchronize
					l_eof := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readline
					update_class_fields -- Current might have been changed; synchronize
				when 1 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if not l_eof.to_boolean then
							if (vir_line[0]).to_integer_32 = 62 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 14 -- skip if block
						end
				when 3 then -- if:
						inspect (vir_line[0]).to_integer_32 -- switch 1 head
						when 43 then l_pos := -1 + 4
						when 124 then l_pos := -1 + 4
						when 94 then l_pos := -1 + 4
						when 60 then l_pos := -1 + 4
						when 0 then l_pos := -1 + 4
						when 13 then l_pos := -1 + 4
						when 10 then l_pos := -1 + 4
						when 35 then l_pos := -1 + 4
						when 42 then l_pos := -1 + 5
						when 33 then l_pos := -1 + 6
						when 37 then l_pos := -1 + 7
						when 34 then l_pos := -1 + 8
						when 47 then l_pos := -1 + 9
						when 38 then l_pos := -1 + 9
						when 126 then l_pos := -1 + 9
						when 36 then l_pos := -1 + 10
						when 58 then l_pos := -1 + 11
						when 63 then l_pos := -1 + 11
						when 61 then l_pos := -1 + 11
						when 64 then l_pos := -1 + 11
						when 45 then l_pos := -1 + 12
						when 39 then l_pos := -1 + 12
						else l_pos := -1 + 13
						end
				when 4 then -- switch 1, case 43 | switch 1, case 124 | switch 1, case 94 | switch 1, case 60 | switch 1, case 0 | switch 1, case 13 | switch 1, case 10 | switch 1, case 35
						l_eof := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readline
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 14 -- switch 1; break
				when 5 then -- switch 1, case 42
						l_eof := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_encoding
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 14 -- switch 1; break
				when 6 then -- switch 1, case 33
						l_eof := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.read_viminfo_varlist (a_writing)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 14 -- switch 1; break
				when 7 then -- switch 1, case 37
						l_eof := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.read_viminfo_bufferlist (a_writing)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 14 -- switch 1; break
				when 8 then -- switch 1, case 34
						l_eof := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.read_viminfo_register (a_forceit)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 14 -- switch 1; break
				when 9 then -- switch 1, case 47 | switch 1, case 38 | switch 1, case 126
						l_eof := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.read_viminfo_search_pattern (a_forceit)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 14 -- switch 1; break
				when 10 then -- switch 1, case 36
						l_eof := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.read_viminfo_sub_string (a_forceit)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 14 -- switch 1; break
				when 11 then -- switch 1, case 58 | switch 1, case 63 | switch 1, case 61 | switch 1, case 64
						l_eof := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.read_viminfo_history
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 14 -- switch 1; break
				when 12 then -- switch 1, case 45 | switch 1, case 39
						l_eof := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.read_viminfo_filemark (a_forceit)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 14 -- switch 1; break
				when 13 then -- switch 1, default:
						l_tmp___0 := gettext (ce_string ("Illegal starting char"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := viminfo_error (ce_string ("E575: "), l_tmp___0, vir_line)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1.to_boolean then
							l_eof := 1
						else
							l_eof := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readline
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 14 -- switch 1; break
				when 14 then -- switch 1, done: | if done
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					l_break := False
					finish_viminfo_history
					update_class_fields -- Current might have been changed; synchronize
					l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
					from
					until
						l_buf___6.is_void
					loop
						l_buf___6.item.fmarks_check_names
						update_class_fields -- Current might have been changed; synchronize
						l_buf___6 := l_buf___6.item.b_next
					end
					Result := l_eof
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	viminfo_encoding: INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_break: BOOLEAN
		do
			l_tmp___0 := (create {P_OPTION_STATIC}).get_viminfo_parameter (('c').code)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___0 /= 0 then
				l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (vir_line, ('=').code)
				update_class_fields -- Current might have been changed; synchronize
				if not l_p___0.is_void then
					l_p___0 := l_p___0 + 1
					l_i___0 := 0
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp := (create {P_CHARSET_STATIC}).vim_isprintc ((l_p___0[l_i___0]).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp.to_boolean then
							l_break := True
						end
						if not (l_break) then
							l_i___0 := l_i___0 + 1
						end
					end
					l_break := False
					l_p___0[l_i___0] := (('%/0/').code).to_natural_8
					update_class_fields; -- Current might have been changed; synchronize
					(create {CE_CLASS_POINTER [PD_VIMCONV_T]}.make_shared (c_pointer + (create {PD_VIR_T}.make).offset_of ("vir_conv"))).item.convert_setup (l_p___0, (create {P_OPTION_STATIC}).p_enc.item.item).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_tmp___1 := ((create {CE_CLASS_POINTER [PD_VIR_T]}.make_shared (c_pointer))).item.viminfo_readline
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp___1
		end

feature {PD_VIR_T} -- private routines

	viminfo_error (a_errnum, a_message: CE_POINTER [INTEGER_8]; a_line: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_return: BOOLEAN
		do
			(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, (gettext (ce_string ("%%sviminfo: %%s in line: "))), a_errnum, a_message]).do_nothing
			strncat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), create {CE_INTEGER_8_POINTER}.make_cast (a_line), ({NATURAL_32} 1_025 - (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item)))) - {NATURAL_32} 1).do_nothing
			if ((create {P_GLOBALS_STATIC}).IObuff.item[((strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 10 then
				(create {P_GLOBALS_STATIC}).IObuff.item[((strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item))) - {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_natural_8
			end
			(create {P_MESSAGE_STATIC}).emsg ((create {P_GLOBALS_STATIC}).IObuff.item).do_nothing;
			(create {P_EX_CMDS_STATIC}).viminfo_errcnt.item := (create {P_EX_CMDS_STATIC}).viminfo_errcnt.item + 1
			if (create {P_EX_CMDS_STATIC}).viminfo_errcnt.item >= 10 then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E136: viminfo: Too many errors, skipping rest of file"))))).do_nothing
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	set_vim_var_list (a_idx: INTEGER_32; a_val___0: CE_POINTER [PD_LISTVAR_S])
		do
			(create {P_EVAL_STATIC}).list_unref ((create {P_EVAL_STATIC}).vimvars.item[a_idx].vv_di.di_tv.vval.v_list);
			(create {P_EVAL_STATIC}).vimvars.item[a_idx].vv_di.di_tv.vval.v_list := a_val___0
			if not a_val___0.is_void then
				a_val___0.item.lv_refcount := (a_val___0.item.lv_refcount) + 1
			end
		end

	prepare_viminfo_history (a_asklen: INTEGER_32)
		local
			l_asklen: INTEGER_32
			l_i___0: INTEGER_32
			l_num: INTEGER_32
			l_type: INTEGER_32
			l_len: INTEGER_32
			l_return: BOOLEAN
		do
			l_asklen := a_asklen;
			(create {P_EX_GETLN_STATIC}).init_history
			viminfo_add_at_front.item := (l_asklen /= 0).to_integer
			if l_asklen > (create {P_EX_GETLN_STATIC}).hislen.item then
				l_asklen := (create {P_EX_GETLN_STATIC}).hislen.item
			end
			l_type := 0
			from
			until
				not (not (l_return) and then (l_type < 5))
			loop
				l_i___0 := 0
				l_num := 0
				from
				until
					not (l_i___0 < (create {P_EX_GETLN_STATIC}).hislen.item)
				loop
					if (((create {P_EX_GETLN_STATIC}).history.item[l_type] + l_i___0).item.hisstr).is_void then
						l_num := l_num + 1
					end
					l_i___0 := l_i___0 + 1
				end
				l_len := l_asklen
				if l_num > l_len then
					l_len := l_num
				end
				if l_len <= 0 then
					viminfo_history.item[l_type] := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
				else
					viminfo_history.item[l_type] := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (((create {P_MISC2_STATIC}).lalloc ((l_len.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32, 0)))
				end
				if (viminfo_history.item[l_type]).is_void then
					l_len := 0
				end
				viminfo_hislen.item[l_type] := l_len
				viminfo_hisidx.item[l_type] := 0
				l_type := l_type + 1
			end
		end

	finish_viminfo_history
		local
			l_idx: INTEGER_32
			l_i___0: INTEGER_32
			l_type: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_type := 0
			from
			until
				not (not (l_return) and then (l_type < 5))
			loop
				if ((create {P_EX_GETLN_STATIC}).history.item[l_type]).is_void then
					l_return := True
				end
				if not l_return then
					l_idx := (create {P_EX_GETLN_STATIC}).hisidx.item[l_type] + viminfo_hisidx.item[l_type]
					if l_idx >= (create {P_EX_GETLN_STATIC}).hislen.item then
						l_idx := l_idx - ((create {P_EX_GETLN_STATIC}).hislen.item)
					elseif l_idx < 0 then
						l_idx := (create {P_EX_GETLN_STATIC}).hislen.item - 1
					end
					if viminfo_add_at_front.item.to_boolean then
						(create {P_EX_GETLN_STATIC}).hisidx.item[l_type] := l_idx
					else
						if (create {P_EX_GETLN_STATIC}).hisidx.item[l_type] = -1 then
							(create {P_EX_GETLN_STATIC}).hisidx.item[l_type] := (create {P_EX_GETLN_STATIC}).hislen.item - 1
						end
						from
						until
							not (not (l_break) and then ((((create {P_EX_GETLN_STATIC}).history.item[l_type] + l_idx).item.hisstr).is_void))
						loop
							l_break := False
							l_idx := l_idx + 1
							if l_idx = (create {P_EX_GETLN_STATIC}).hislen.item then
								l_idx := 0
							end
							if l_idx = (create {P_EX_GETLN_STATIC}).hisidx.item[l_type] then
								l_break := True
							end
						end
						l_break := False
						if l_idx /= (create {P_EX_GETLN_STATIC}).hisidx.item[l_type] then
							l_idx := l_idx - 1
							if l_idx < 0 then
								l_idx := (create {P_EX_GETLN_STATIC}).hislen.item - 1
							end
						end
					end
					l_i___0 := 0
					from
					until
						not (l_i___0 < viminfo_hisidx.item[l_type])
					loop
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (((create {P_EX_GETLN_STATIC}).history.item[l_type] + l_idx).item.hisstr));
						((create {P_EX_GETLN_STATIC}).history.item[l_type] + l_idx).item.hisstr := (viminfo_history.item[l_type])[l_i___0]
						l_idx := l_idx - 1
						if l_idx < 0 then
							l_idx := (create {P_EX_GETLN_STATIC}).hislen.item - 1
						end
						l_i___0 := l_i___0 + 1
					end
					l_idx := l_idx + 1
					l_idx := l_idx \\ ((create {P_EX_GETLN_STATIC}).hislen.item)
					l_i___0 := 0
					from
					until
						not (l_i___0 < viminfo_hisidx.item[l_type])
					loop
						l_tmp := l_idx
						l_idx := l_idx + 1;
						(create {P_EX_GETLN_STATIC}).hisnum.item[l_type] := ((create {P_EX_GETLN_STATIC}).hisnum.item[l_type]) + 1;
						((create {P_EX_GETLN_STATIC}).history.item[l_type] + l_tmp).item.hisnum := (create {P_EX_GETLN_STATIC}).hisnum.item[l_type]
						l_idx := l_idx \\ ((create {P_EX_GETLN_STATIC}).hislen.item)
						l_i___0 := l_i___0 + 1
					end
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (viminfo_history.item[l_type]))
					viminfo_history.item[l_type] := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_type := l_type + 1
				end
			end
			if not l_return then
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			vir_line := a_other.vir_line
			vir_fd := a_other.vir_fd
			vir_conv := a_other.vir_conv.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				vir_line.is_equal (a_other.vir_line) and
				vir_fd.is_equal (a_other.vir_fd) and
				vir_conv.is_equal (a_other.vir_conv)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("vir_line"),
					create {CE_STRUCTURE_FIELD}.make ("vir_fd"),
					create {CE_STRUCTURE_FIELD}.make ("vir_conv")
				>>)
			init_structure_info
		end

end
