class
	S_SIGNAL_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	signal (a___sig: INTEGER_32; a___handler: CE_ROUTINE): CE_ROUTINE
		do
			create Result.make_shared (c_signal (a___sig, a___handler.c_pointer))
		end

	c_signal (a___sig: INTEGER_32; a___handler: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)signal($a___sig, $a___handler);"
		end

	kill (a___pid: INTEGER_32; a___sig: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return kill($a___pid, $a___sig);"
		end

	sigemptyset (a___set: CE_POINTER [SD_SIGSET_T]): INTEGER_32
		require
			not a___set.is_void
		do
			Result := c_sigemptyset (a___set.c_pointer)
		end

	c_sigemptyset (a___set: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sigemptyset($a___set);"
		end

	sigaction (a___sig: INTEGER_32; a___act, a___oact: CE_POINTER [SD_SIGACTION]): INTEGER_32
		do
			Result := c_sigaction (a___sig, a___act.c_pointer, a___oact.c_pointer)
		end

	c_sigaction (a___sig: INTEGER_32; a___act: POINTER; a___oact: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sigaction($a___sig, $a___act, $a___oact);"
		end

	sigaltstack (a___ss, a___oss: CE_POINTER [SD_SIGALTSTACK]): INTEGER_32
		do
			Result := c_sigaltstack (a___ss.c_pointer, a___oss.c_pointer)
		end

	c_sigaltstack (a___ss: POINTER; a___oss: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sigaltstack($a___ss, $a___oss);"
		end

	sigset (a___sig: INTEGER_32; a_func: CE_ROUTINE): CE_ROUTINE
		do
			create Result.make_shared (c_sigset (a___sig, a_func.c_pointer))
		end

	c_sigset (a___sig: INTEGER_32; a_func: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)sigset($a___sig, $a_func);"
		end

end
