class
	SD_GDKEVENTEXPOSE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} window.make
			create area.make
			create {CE_VOID_POINTER} region.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window

	send_event: INTEGER_8 assign set_send_event

	area: SD_GDKRECTANGLE assign set_area

	region: CE_POINTER [ANY] assign set_region

	count: INTEGER_32 assign set_count

feature {ANY} -- field setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			window := a_window
			update_memory_field ("window")
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_area (a_area: SD_GDKRECTANGLE)
		do
			area := a_area
			update_memory_field ("area")
		end

	set_region (a_region: CE_POINTER [ANY])
		do
			region := a_region
			update_memory_field ("region")
		end

	set_count (a_count: INTEGER_32)
		do
			count := a_count
			update_memory_field ("count")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			window := a_other.window
			send_event := a_other.send_event
			area := a_other.area.twin
			region := a_other.region
			count := a_other.count
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				window.is_equal (a_other.window) and
				send_event = a_other.send_event and
				area.is_equal (a_other.area) and
				region.is_equal (a_other.region) and
				count = a_other.count
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("area"),
					create {CE_STRUCTURE_FIELD}.make ("region"),
					create {CE_STRUCTURE_FIELD}.make ("count")
				>>)
			init_structure_info
		end

end
