class
	SD_GDKPOINTERWINDOWINFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} toplevel_under_pointer.make
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} window_under_pointer.make
		end

feature {ANY} -- fields

	toplevel_under_pointer: CE_POINTER [SD_GDKDRAWABLE] assign set_toplevel_under_pointer

	window_under_pointer: CE_POINTER [SD_GDKDRAWABLE] assign set_window_under_pointer

	toplevel_x: REAL_64 assign set_toplevel_x

	toplevel_y: REAL_64 assign set_toplevel_y

	state: NATURAL_32 assign set_state

	button: NATURAL_32 assign set_button

	motion_hint_serial: NATURAL_32 assign set_motion_hint_serial

feature {ANY} -- field setters

	set_toplevel_under_pointer (a_toplevel_under_pointer: CE_POINTER [SD_GDKDRAWABLE])
		do
			toplevel_under_pointer := a_toplevel_under_pointer
			update_memory_field ("toplevel_under_pointer")
		end

	set_window_under_pointer (a_window_under_pointer: CE_POINTER [SD_GDKDRAWABLE])
		do
			window_under_pointer := a_window_under_pointer
			update_memory_field ("window_under_pointer")
		end

	set_toplevel_x (a_toplevel_x: REAL_64)
		do
			toplevel_x := a_toplevel_x
			update_memory_field ("toplevel_x")
		end

	set_toplevel_y (a_toplevel_y: REAL_64)
		do
			toplevel_y := a_toplevel_y
			update_memory_field ("toplevel_y")
		end

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_button (a_button: NATURAL_32)
		do
			button := a_button
			update_memory_field ("button")
		end

	set_motion_hint_serial (a_motion_hint_serial: NATURAL_32)
		do
			motion_hint_serial := a_motion_hint_serial
			update_memory_field ("motion_hint_serial")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			toplevel_under_pointer := a_other.toplevel_under_pointer
			window_under_pointer := a_other.window_under_pointer
			toplevel_x := a_other.toplevel_x
			toplevel_y := a_other.toplevel_y
			state := a_other.state
			button := a_other.button
			motion_hint_serial := a_other.motion_hint_serial
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				toplevel_under_pointer.is_equal (a_other.toplevel_under_pointer) and
				window_under_pointer.is_equal (a_other.window_under_pointer) and
				toplevel_x = a_other.toplevel_x and
				toplevel_y = a_other.toplevel_y and
				state = a_other.state and
				button = a_other.button and
				motion_hint_serial = a_other.motion_hint_serial
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("toplevel_under_pointer"),
					create {CE_STRUCTURE_FIELD}.make ("window_under_pointer"),
					create {CE_STRUCTURE_FIELD}.make ("toplevel_x"),
					create {CE_STRUCTURE_FIELD}.make ("toplevel_y"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("button"),
					create {CE_STRUCTURE_FIELD}.make ("motion_hint_serial")
				>>)
			init_structure_info
		end

end
