class
	SD_GPARAMSPEC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create g_type_instance.make
			create {CE_INTEGER_8_POINTER} name.make
			create {CE_INTEGER_8_POINTER} nick.make
			create {CE_INTEGER_8_POINTER} blurb.make
			create {CE_VOID_POINTER} qdata.make
		end

feature {ANY} -- fields

	g_type_instance: SD_GTYPEINSTANCE assign set_g_type_instance

	name: CE_POINTER [INTEGER_8] assign set_name

	flags: INTEGER_32 assign set_flags

	value_type: NATURAL_32 assign set_value_type

	owner_type: NATURAL_32 assign set_owner_type

	nick: CE_POINTER [INTEGER_8] assign set_nick

	blurb: CE_POINTER [INTEGER_8] assign set_blurb

	qdata: CE_POINTER [ANY] assign set_qdata

	ref_count: NATURAL_32 assign set_ref_count

	param_id: NATURAL_32 assign set_param_id

feature {ANY} -- field setters

	set_g_type_instance (a_g_type_instance: SD_GTYPEINSTANCE)
		do
			g_type_instance := a_g_type_instance
			update_memory_field ("g_type_instance")
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_value_type (a_value_type: NATURAL_32)
		do
			value_type := a_value_type
			update_memory_field ("value_type")
		end

	set_owner_type (a_owner_type: NATURAL_32)
		do
			owner_type := a_owner_type
			update_memory_field ("owner_type")
		end

	set_nick (a_nick: CE_POINTER [INTEGER_8])
		do
			nick := a_nick
			update_memory_field ("nick")
		end

	set_blurb (a_blurb: CE_POINTER [INTEGER_8])
		do
			blurb := a_blurb
			update_memory_field ("blurb")
		end

	set_qdata (a_qdata: CE_POINTER [ANY])
		do
			qdata := a_qdata
			update_memory_field ("qdata")
		end

	set_ref_count (a_ref_count: NATURAL_32)
		do
			ref_count := a_ref_count
			update_memory_field ("ref_count")
		end

	set_param_id (a_param_id: NATURAL_32)
		do
			param_id := a_param_id
			update_memory_field ("param_id")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			g_type_instance := a_other.g_type_instance.twin
			name := a_other.name
			flags := a_other.flags
			value_type := a_other.value_type
			owner_type := a_other.owner_type
			nick := a_other.nick
			blurb := a_other.blurb
			qdata := a_other.qdata
			ref_count := a_other.ref_count
			param_id := a_other.param_id
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				g_type_instance.is_equal (a_other.g_type_instance) and
				name.is_equal (a_other.name) and
				flags = a_other.flags and
				value_type = a_other.value_type and
				owner_type = a_other.owner_type and
				nick.is_equal (a_other.nick) and
				blurb.is_equal (a_other.blurb) and
				qdata.is_equal (a_other.qdata) and
				ref_count = a_other.ref_count and
				param_id = a_other.param_id
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("g_type_instance"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("value_type"),
					create {CE_STRUCTURE_FIELD}.make ("owner_type"),
					create {CE_STRUCTURE_FIELD}.make ("nick"),
					create {CE_STRUCTURE_FIELD}.make ("blurb"),
					create {CE_STRUCTURE_FIELD}.make ("qdata"),
					create {CE_STRUCTURE_FIELD}.make ("ref_count"),
					create {CE_STRUCTURE_FIELD}.make ("param_id")
				>>)
			init_structure_info
		end

end
