class
	SD_GTKCONTAINER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	widget: SD_GTKWIDGET assign set_widget

	focus_child: CE_POINTER [SD_GTKWIDGET] assign set_focus_child

	border_width: NATURAL_32 assign set_border_width

	need_resize: NATURAL_32 assign set_need_resize

	resize_mode: NATURAL_32 assign set_resize_mode

	reallocate_redraws: NATURAL_32 assign set_reallocate_redraws

	has_focus_chain: NATURAL_32 assign set_has_focus_chain

feature {ANY} -- field setters

	set_widget (a_widget: SD_GTKWIDGET)
		do
			widget := a_widget
			update_memory_field ("widget")
		end

	set_focus_child (a_focus_child: CE_POINTER [SD_GTKWIDGET])
		do
			focus_child := a_focus_child
			update_memory_field ("focus_child")
		end

	set_border_width (a_border_width: NATURAL_32)
		do
			border_width := a_border_width
			update_memory_field ("border_width")
		end

	set_need_resize (a_need_resize: NATURAL_32)
		do
			need_resize := a_need_resize
			update_memory_field ("need_resize")
		end

	set_resize_mode (a_resize_mode: NATURAL_32)
		do
			resize_mode := a_resize_mode
			update_memory_field ("resize_mode")
		end

	set_reallocate_redraws (a_reallocate_redraws: NATURAL_32)
		do
			reallocate_redraws := a_reallocate_redraws
			update_memory_field ("reallocate_redraws")
		end

	set_has_focus_chain (a_has_focus_chain: NATURAL_32)
		do
			has_focus_chain := a_has_focus_chain
			update_memory_field ("has_focus_chain")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			widget := a_other.widget.twin
			focus_child := a_other.focus_child
			border_width := a_other.border_width
			need_resize := a_other.need_resize
			resize_mode := a_other.resize_mode
			reallocate_redraws := a_other.reallocate_redraws
			has_focus_chain := a_other.has_focus_chain
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				widget.is_equal (a_other.widget) and
				focus_child.is_equal (a_other.focus_child) and
				border_width = a_other.border_width and
				need_resize = a_other.need_resize and
				resize_mode = a_other.resize_mode and
				reallocate_redraws = a_other.reallocate_redraws and
				has_focus_chain = a_other.has_focus_chain
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("widget"),
					create {CE_STRUCTURE_FIELD}.make ("focus_child"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("border_width"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("need_resize"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("resize_mode"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("reallocate_redraws"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("has_focus_chain")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkContainer);
				} else {
					struct _GtkContainer *p = (struct _GtkContainer *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "border_width") == 0) p->border_width = (unsigned int)$a_value;
						else if(strcmp(field_name, "need_resize") == 0) p->need_resize = (unsigned int)$a_value;
						else if(strcmp(field_name, "resize_mode") == 0) p->resize_mode = (unsigned int)$a_value;
						else if(strcmp(field_name, "reallocate_redraws") == 0) p->reallocate_redraws = (unsigned int)$a_value;
						else if(strcmp(field_name, "has_focus_chain") == 0) p->has_focus_chain = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "border_width") == 0) return p->border_width;
						if(strcmp(field_name, "need_resize") == 0) return p->need_resize;
						if(strcmp(field_name, "resize_mode") == 0) return p->resize_mode;
						if(strcmp(field_name, "reallocate_redraws") == 0) return p->reallocate_redraws;
						if(strcmp(field_name, "has_focus_chain") == 0) return p->has_focus_chain;
					}
				}
			]"
		end

end
