class
	SD_GTKFONTSELECTIONDIALOG

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create parent_instance.make
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} fontsel.make
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} main_vbox.make
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} action_area.make
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} ok_button.make
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} apply_button.make
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} cancel_button.make
		end

feature {ANY} -- fields

	parent_instance: SD_GTKDIALOG assign set_parent_instance

	fontsel: CE_POINTER [SD_GTKWIDGET] assign set_fontsel

	main_vbox: CE_POINTER [SD_GTKWIDGET] assign set_main_vbox

	action_area: CE_POINTER [SD_GTKWIDGET] assign set_action_area

	ok_button: CE_POINTER [SD_GTKWIDGET] assign set_ok_button

	apply_button: CE_POINTER [SD_GTKWIDGET] assign set_apply_button

	cancel_button: CE_POINTER [SD_GTKWIDGET] assign set_cancel_button

	dialog_width: INTEGER_32 assign set_dialog_width

	auto_resize: INTEGER_32 assign set_auto_resize

feature {ANY} -- field setters

	set_parent_instance (a_parent_instance: SD_GTKDIALOG)
		do
			parent_instance := a_parent_instance
			update_memory_field ("parent_instance")
		end

	set_fontsel (a_fontsel: CE_POINTER [SD_GTKWIDGET])
		do
			fontsel := a_fontsel
			update_memory_field ("fontsel")
		end

	set_main_vbox (a_main_vbox: CE_POINTER [SD_GTKWIDGET])
		do
			main_vbox := a_main_vbox
			update_memory_field ("main_vbox")
		end

	set_action_area (a_action_area: CE_POINTER [SD_GTKWIDGET])
		do
			action_area := a_action_area
			update_memory_field ("action_area")
		end

	set_ok_button (a_ok_button: CE_POINTER [SD_GTKWIDGET])
		do
			ok_button := a_ok_button
			update_memory_field ("ok_button")
		end

	set_apply_button (a_apply_button: CE_POINTER [SD_GTKWIDGET])
		do
			apply_button := a_apply_button
			update_memory_field ("apply_button")
		end

	set_cancel_button (a_cancel_button: CE_POINTER [SD_GTKWIDGET])
		do
			cancel_button := a_cancel_button
			update_memory_field ("cancel_button")
		end

	set_dialog_width (a_dialog_width: INTEGER_32)
		do
			dialog_width := a_dialog_width
			update_memory_field ("dialog_width")
		end

	set_auto_resize (a_auto_resize: INTEGER_32)
		do
			auto_resize := a_auto_resize
			update_memory_field ("auto_resize")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_instance := a_other.parent_instance.twin
			fontsel := a_other.fontsel
			main_vbox := a_other.main_vbox
			action_area := a_other.action_area
			ok_button := a_other.ok_button
			apply_button := a_other.apply_button
			cancel_button := a_other.cancel_button
			dialog_width := a_other.dialog_width
			auto_resize := a_other.auto_resize
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_instance.is_equal (a_other.parent_instance) and
				fontsel.is_equal (a_other.fontsel) and
				main_vbox.is_equal (a_other.main_vbox) and
				action_area.is_equal (a_other.action_area) and
				ok_button.is_equal (a_other.ok_button) and
				apply_button.is_equal (a_other.apply_button) and
				cancel_button.is_equal (a_other.cancel_button) and
				dialog_width = a_other.dialog_width and
				auto_resize = a_other.auto_resize
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_instance"),
					create {CE_STRUCTURE_FIELD}.make ("fontsel"),
					create {CE_STRUCTURE_FIELD}.make ("main_vbox"),
					create {CE_STRUCTURE_FIELD}.make ("action_area"),
					create {CE_STRUCTURE_FIELD}.make ("ok_button"),
					create {CE_STRUCTURE_FIELD}.make ("apply_button"),
					create {CE_STRUCTURE_FIELD}.make ("cancel_button"),
					create {CE_STRUCTURE_FIELD}.make ("dialog_width"),
					create {CE_STRUCTURE_FIELD}.make ("auto_resize")
				>>)
			init_structure_info
		end

end
