class
	SD_GTKIMAGEICONNAMEDATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} icon_name.make
			create {CE_VOID_POINTER} pixbuf.make
		end

feature {ANY} -- fields

	icon_name: CE_POINTER [INTEGER_8] assign set_icon_name

	pixbuf: CE_POINTER [ANY] assign set_pixbuf

	theme_change_id: NATURAL_32 assign set_theme_change_id

feature {ANY} -- field setters

	set_icon_name (a_icon_name: CE_POINTER [INTEGER_8])
		do
			icon_name := a_icon_name
			update_memory_field ("icon_name")
		end

	set_pixbuf (a_pixbuf: CE_POINTER [ANY])
		do
			pixbuf := a_pixbuf
			update_memory_field ("pixbuf")
		end

	set_theme_change_id (a_theme_change_id: NATURAL_32)
		do
			theme_change_id := a_theme_change_id
			update_memory_field ("theme_change_id")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			icon_name := a_other.icon_name
			pixbuf := a_other.pixbuf
			theme_change_id := a_other.theme_change_id
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				icon_name.is_equal (a_other.icon_name) and
				pixbuf.is_equal (a_other.pixbuf) and
				theme_change_id = a_other.theme_change_id
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("icon_name"),
					create {CE_STRUCTURE_FIELD}.make ("pixbuf"),
					create {CE_STRUCTURE_FIELD}.make ("theme_change_id")
				>>)
			init_structure_info
		end

end
