class
	SD_GTKRCSTYLE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	parent_instance: SD_GOBJECT assign set_parent_instance

	name: CE_POINTER [INTEGER_8] assign set_name

	bg_pixmap_name: CE_ARRAY [CE_POINTER [INTEGER_8]]

	font_desc: CE_POINTER [ANY] assign set_font_desc

	color_flags: CE_ARRAY [NATURAL_32]

	fg: CE_ARRAY [SD_GDKCOLOR]

	bg: CE_ARRAY [SD_GDKCOLOR]

	text: CE_ARRAY [SD_GDKCOLOR]

	base: CE_ARRAY [SD_GDKCOLOR]

	xthickness: INTEGER_32 assign set_xthickness

	ythickness: INTEGER_32 assign set_ythickness

	rc_properties: CE_POINTER [SD_GARRAY] assign set_rc_properties

	rc_style_lists: CE_POINTER [SD_GSLIST] assign set_rc_style_lists

	icon_factories: CE_POINTER [SD_GSLIST] assign set_icon_factories

	engine_specified: NATURAL_32 assign set_engine_specified

feature {ANY} -- field setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance := a_parent_instance
			update_memory_field ("parent_instance")
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_font_desc (a_font_desc: CE_POINTER [ANY])
		do
			font_desc := a_font_desc
			update_memory_field ("font_desc")
		end

	set_xthickness (a_xthickness: INTEGER_32)
		do
			xthickness := a_xthickness
			update_memory_field ("xthickness")
		end

	set_ythickness (a_ythickness: INTEGER_32)
		do
			ythickness := a_ythickness
			update_memory_field ("ythickness")
		end

	set_rc_properties (a_rc_properties: CE_POINTER [SD_GARRAY])
		do
			rc_properties := a_rc_properties
			update_memory_field ("rc_properties")
		end

	set_rc_style_lists (a_rc_style_lists: CE_POINTER [SD_GSLIST])
		do
			rc_style_lists := a_rc_style_lists
			update_memory_field ("rc_style_lists")
		end

	set_icon_factories (a_icon_factories: CE_POINTER [SD_GSLIST])
		do
			icon_factories := a_icon_factories
			update_memory_field ("icon_factories")
		end

	set_engine_specified (a_engine_specified: NATURAL_32)
		do
			engine_specified := a_engine_specified
			update_memory_field ("engine_specified")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_instance := a_other.parent_instance.twin
			name := a_other.name
			bg_pixmap_name := a_other.bg_pixmap_name.twin
			font_desc := a_other.font_desc
			color_flags := a_other.color_flags.twin
			fg := a_other.fg.twin
			bg := a_other.bg.twin
			text := a_other.text.twin
			base := a_other.base.twin
			xthickness := a_other.xthickness
			ythickness := a_other.ythickness
			rc_properties := a_other.rc_properties
			rc_style_lists := a_other.rc_style_lists
			icon_factories := a_other.icon_factories
			engine_specified := a_other.engine_specified
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_instance.is_equal (a_other.parent_instance) and
				name.is_equal (a_other.name) and
				bg_pixmap_name.is_equal (a_other.bg_pixmap_name) and
				font_desc.is_equal (a_other.font_desc) and
				color_flags.is_equal (a_other.color_flags) and
				fg.is_equal (a_other.fg) and
				bg.is_equal (a_other.bg) and
				text.is_equal (a_other.text) and
				base.is_equal (a_other.base) and
				xthickness = a_other.xthickness and
				ythickness = a_other.ythickness and
				rc_properties.is_equal (a_other.rc_properties) and
				rc_style_lists.is_equal (a_other.rc_style_lists) and
				icon_factories.is_equal (a_other.icon_factories) and
				engine_specified = a_other.engine_specified
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_instance"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("bg_pixmap_name", <<5>>),
					create {CE_STRUCTURE_FIELD}.make ("font_desc"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("color_flags", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("fg", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("bg", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("text", <<5>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("base", <<5>>),
					create {CE_STRUCTURE_FIELD}.make ("xthickness"),
					create {CE_STRUCTURE_FIELD}.make ("ythickness"),
					create {CE_STRUCTURE_FIELD}.make ("rc_properties"),
					create {CE_STRUCTURE_FIELD}.make ("rc_style_lists"),
					create {CE_STRUCTURE_FIELD}.make ("icon_factories"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("engine_specified")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkRcStyle);
				} else {
					struct _GtkRcStyle *p = (struct _GtkRcStyle *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "engine_specified") == 0) p->engine_specified = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "engine_specified") == 0) return p->engine_specified;
					}
				}
			]"
		end

end
