class
	SD_GTKTABLE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	container: SD_GTKCONTAINER assign set_container

	children: CE_POINTER [SD_GLIST] assign set_children

	rows: CE_POINTER [SD_GTKTABLEROWCOL] assign set_rows

	cols: CE_POINTER [SD_GTKTABLEROWCOL] assign set_cols

	nrows: NATURAL_16 assign set_nrows

	ncols: NATURAL_16 assign set_ncols

	column_spacing: NATURAL_16 assign set_column_spacing

	row_spacing: NATURAL_16 assign set_row_spacing

	homogeneous: NATURAL_32 assign set_homogeneous

feature {ANY} -- field setters

	set_container (a_container: SD_GTKCONTAINER)
		do
			container := a_container
			update_memory_field ("container")
		end

	set_children (a_children: CE_POINTER [SD_GLIST])
		do
			children := a_children
			update_memory_field ("children")
		end

	set_rows (a_rows: CE_POINTER [SD_GTKTABLEROWCOL])
		do
			rows := a_rows
			update_memory_field ("rows")
		end

	set_cols (a_cols: CE_POINTER [SD_GTKTABLEROWCOL])
		do
			cols := a_cols
			update_memory_field ("cols")
		end

	set_nrows (a_nrows: NATURAL_16)
		do
			nrows := a_nrows
			update_memory_field ("nrows")
		end

	set_ncols (a_ncols: NATURAL_16)
		do
			ncols := a_ncols
			update_memory_field ("ncols")
		end

	set_column_spacing (a_column_spacing: NATURAL_16)
		do
			column_spacing := a_column_spacing
			update_memory_field ("column_spacing")
		end

	set_row_spacing (a_row_spacing: NATURAL_16)
		do
			row_spacing := a_row_spacing
			update_memory_field ("row_spacing")
		end

	set_homogeneous (a_homogeneous: NATURAL_32)
		do
			homogeneous := a_homogeneous
			update_memory_field ("homogeneous")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			container := a_other.container.twin
			children := a_other.children
			rows := a_other.rows
			cols := a_other.cols
			nrows := a_other.nrows
			ncols := a_other.ncols
			column_spacing := a_other.column_spacing
			row_spacing := a_other.row_spacing
			homogeneous := a_other.homogeneous
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				container.is_equal (a_other.container) and
				children.is_equal (a_other.children) and
				rows.is_equal (a_other.rows) and
				cols.is_equal (a_other.cols) and
				nrows = a_other.nrows and
				ncols = a_other.ncols and
				column_spacing = a_other.column_spacing and
				row_spacing = a_other.row_spacing and
				homogeneous = a_other.homogeneous
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("container"),
					create {CE_STRUCTURE_FIELD}.make ("children"),
					create {CE_STRUCTURE_FIELD}.make ("rows"),
					create {CE_STRUCTURE_FIELD}.make ("cols"),
					create {CE_STRUCTURE_FIELD}.make ("nrows"),
					create {CE_STRUCTURE_FIELD}.make ("ncols"),
					create {CE_STRUCTURE_FIELD}.make ("column_spacing"),
					create {CE_STRUCTURE_FIELD}.make ("row_spacing"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("homogeneous")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkTable);
				} else {
					struct _GtkTable *p = (struct _GtkTable *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "homogeneous") == 0) p->homogeneous = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "homogeneous") == 0) return p->homogeneous;
					}
				}
			]"
		end

end
