class
	SD_GTKTOOLTIPS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	parent_instance: SD_GTKOBJECT assign set_parent_instance

	tip_window: CE_POINTER [SD_GTKWIDGET] assign set_tip_window

	tip_label: CE_POINTER [SD_GTKWIDGET] assign set_tip_label

	active_tips_data: CE_POINTER [SD_GTKTOOLTIPSDATA] assign set_active_tips_data

	tips_data_list: CE_POINTER [SD_GLIST] assign set_tips_data_list

	delay: NATURAL_32 assign set_delay

	enabled: NATURAL_32 assign set_enabled

	have_grab: NATURAL_32 assign set_have_grab

	use_sticky_delay: NATURAL_32 assign set_use_sticky_delay

	timer_tag: INTEGER_32 assign set_timer_tag

	last_popdown: SD_GTIMEVAL assign set_last_popdown

feature {ANY} -- field setters

	set_parent_instance (a_parent_instance: SD_GTKOBJECT)
		do
			parent_instance := a_parent_instance
			update_memory_field ("parent_instance")
		end

	set_tip_window (a_tip_window: CE_POINTER [SD_GTKWIDGET])
		do
			tip_window := a_tip_window
			update_memory_field ("tip_window")
		end

	set_tip_label (a_tip_label: CE_POINTER [SD_GTKWIDGET])
		do
			tip_label := a_tip_label
			update_memory_field ("tip_label")
		end

	set_active_tips_data (a_active_tips_data: CE_POINTER [SD_GTKTOOLTIPSDATA])
		do
			active_tips_data := a_active_tips_data
			update_memory_field ("active_tips_data")
		end

	set_tips_data_list (a_tips_data_list: CE_POINTER [SD_GLIST])
		do
			tips_data_list := a_tips_data_list
			update_memory_field ("tips_data_list")
		end

	set_delay (a_delay: NATURAL_32)
		do
			delay := a_delay
			update_memory_field ("delay")
		end

	set_enabled (a_enabled: NATURAL_32)
		do
			enabled := a_enabled
			update_memory_field ("enabled")
		end

	set_have_grab (a_have_grab: NATURAL_32)
		do
			have_grab := a_have_grab
			update_memory_field ("have_grab")
		end

	set_use_sticky_delay (a_use_sticky_delay: NATURAL_32)
		do
			use_sticky_delay := a_use_sticky_delay
			update_memory_field ("use_sticky_delay")
		end

	set_timer_tag (a_timer_tag: INTEGER_32)
		do
			timer_tag := a_timer_tag
			update_memory_field ("timer_tag")
		end

	set_last_popdown (a_last_popdown: SD_GTIMEVAL)
		do
			last_popdown := a_last_popdown
			update_memory_field ("last_popdown")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_instance := a_other.parent_instance.twin
			tip_window := a_other.tip_window
			tip_label := a_other.tip_label
			active_tips_data := a_other.active_tips_data
			tips_data_list := a_other.tips_data_list
			delay := a_other.delay
			enabled := a_other.enabled
			have_grab := a_other.have_grab
			use_sticky_delay := a_other.use_sticky_delay
			timer_tag := a_other.timer_tag
			last_popdown := a_other.last_popdown.twin
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_instance.is_equal (a_other.parent_instance) and
				tip_window.is_equal (a_other.tip_window) and
				tip_label.is_equal (a_other.tip_label) and
				active_tips_data.is_equal (a_other.active_tips_data) and
				tips_data_list.is_equal (a_other.tips_data_list) and
				delay = a_other.delay and
				enabled = a_other.enabled and
				have_grab = a_other.have_grab and
				use_sticky_delay = a_other.use_sticky_delay and
				timer_tag = a_other.timer_tag and
				last_popdown.is_equal (a_other.last_popdown)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_instance"),
					create {CE_STRUCTURE_FIELD}.make ("tip_window"),
					create {CE_STRUCTURE_FIELD}.make ("tip_label"),
					create {CE_STRUCTURE_FIELD}.make ("active_tips_data"),
					create {CE_STRUCTURE_FIELD}.make ("tips_data_list"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("delay"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("enabled"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("have_grab"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("use_sticky_delay"),
					create {CE_STRUCTURE_FIELD}.make ("timer_tag"),
					create {CE_STRUCTURE_FIELD}.make ("last_popdown")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkTooltips);
					if(strcmp(field_name, "timer_tag") == 0) return offsetof(struct _GtkTooltips, timer_tag);
				} else {
					struct _GtkTooltips *p = (struct _GtkTooltips *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "delay") == 0) p->delay = (unsigned int)$a_value;
						else if(strcmp(field_name, "enabled") == 0) p->enabled = (unsigned int)$a_value;
						else if(strcmp(field_name, "have_grab") == 0) p->have_grab = (unsigned int)$a_value;
						else if(strcmp(field_name, "use_sticky_delay") == 0) p->use_sticky_delay = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "delay") == 0) return p->delay;
						if(strcmp(field_name, "enabled") == 0) return p->enabled;
						if(strcmp(field_name, "have_grab") == 0) return p->have_grab;
						if(strcmp(field_name, "use_sticky_delay") == 0) return p->use_sticky_delay;
					}
				}
			]"
		end

end
