class
	SD_GTKTYPEINFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} type_name.make
			create class_init_func.make
			create object_init_func.make
			create {CE_VOID_POINTER} reserved_1.make
			create {CE_VOID_POINTER} reserved_2.make
			create base_class_init_func.make
		end

feature {ANY} -- fields

	type_name: CE_POINTER [INTEGER_8] assign set_type_name

	object_size: NATURAL_32 assign set_object_size

	class_size: NATURAL_32 assign set_class_size

	class_init_func: CE_ROUTINE assign set_class_init_func

	object_init_func: CE_ROUTINE assign set_object_init_func

	reserved_1: CE_POINTER [ANY] assign set_reserved_1

	reserved_2: CE_POINTER [ANY] assign set_reserved_2

	base_class_init_func: CE_ROUTINE assign set_base_class_init_func

feature {ANY} -- field setters

	set_type_name (a_type_name: CE_POINTER [INTEGER_8])
		do
			type_name := a_type_name
			update_memory_field ("type_name")
		end

	set_object_size (a_object_size: NATURAL_32)
		do
			object_size := a_object_size
			update_memory_field ("object_size")
		end

	set_class_size (a_class_size: NATURAL_32)
		do
			class_size := a_class_size
			update_memory_field ("class_size")
		end

	set_class_init_func (a_class_init_func: CE_ROUTINE)
		do
			class_init_func := a_class_init_func
			update_memory_field ("class_init_func")
		end

	set_object_init_func (a_object_init_func: CE_ROUTINE)
		do
			object_init_func := a_object_init_func
			update_memory_field ("object_init_func")
		end

	set_reserved_1 (a_reserved_1: CE_POINTER [ANY])
		do
			reserved_1 := a_reserved_1
			update_memory_field ("reserved_1")
		end

	set_reserved_2 (a_reserved_2: CE_POINTER [ANY])
		do
			reserved_2 := a_reserved_2
			update_memory_field ("reserved_2")
		end

	set_base_class_init_func (a_base_class_init_func: CE_ROUTINE)
		do
			base_class_init_func := a_base_class_init_func
			update_memory_field ("base_class_init_func")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type_name := a_other.type_name
			object_size := a_other.object_size
			class_size := a_other.class_size
			class_init_func := a_other.class_init_func
			object_init_func := a_other.object_init_func
			reserved_1 := a_other.reserved_1
			reserved_2 := a_other.reserved_2
			base_class_init_func := a_other.base_class_init_func
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type_name.is_equal (a_other.type_name) and
				object_size = a_other.object_size and
				class_size = a_other.class_size and
				class_init_func.is_equal (a_other.class_init_func) and
				object_init_func.is_equal (a_other.object_init_func) and
				reserved_1.is_equal (a_other.reserved_1) and
				reserved_2.is_equal (a_other.reserved_2) and
				base_class_init_func.is_equal (a_other.base_class_init_func)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type_name"),
					create {CE_STRUCTURE_FIELD}.make ("object_size"),
					create {CE_STRUCTURE_FIELD}.make ("class_size"),
					create {CE_STRUCTURE_FIELD}.make ("class_init_func"),
					create {CE_STRUCTURE_FIELD}.make ("object_init_func"),
					create {CE_STRUCTURE_FIELD}.make ("reserved_1"),
					create {CE_STRUCTURE_FIELD}.make ("reserved_2"),
					create {CE_STRUCTURE_FIELD}.make ("base_class_init_func")
				>>)
			init_structure_info
		end

end
