class
	SD_GTKWIDGET

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create object.make
			create {CE_INTEGER_8_POINTER} name.make
			create {CE_CLASS_POINTER [SD_GTKSTYLE]} style.make
			create requisition.make
			create allocation.make
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} window.make
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} parent.make
		end

feature {ANY} -- fields

	object: SD_GTKOBJECT assign set_object

	private_flags: NATURAL_16 assign set_private_flags

	state: NATURAL_8 assign set_state

	saved_state: NATURAL_8 assign set_saved_state

	name: CE_POINTER [INTEGER_8] assign set_name

	style: CE_POINTER [SD_GTKSTYLE] assign set_style

	requisition: SD_GTKREQUISITION assign set_requisition

	allocation: SD_GDKRECTANGLE assign set_allocation

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window

	parent: CE_POINTER [SD_GTKWIDGET] assign set_parent

feature {ANY} -- field setters

	set_object (a_object: SD_GTKOBJECT)
		do
			object := a_object
			update_memory_field ("object")
		end

	set_private_flags (a_private_flags: NATURAL_16)
		do
			private_flags := a_private_flags
			update_memory_field ("private_flags")
		end

	set_state (a_state: NATURAL_8)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_saved_state (a_saved_state: NATURAL_8)
		do
			saved_state := a_saved_state
			update_memory_field ("saved_state")
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_style (a_style: CE_POINTER [SD_GTKSTYLE])
		do
			style := a_style
			update_memory_field ("style")
		end

	set_requisition (a_requisition: SD_GTKREQUISITION)
		do
			requisition := a_requisition
			update_memory_field ("requisition")
		end

	set_allocation (a_allocation: SD_GDKRECTANGLE)
		do
			allocation := a_allocation
			update_memory_field ("allocation")
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			window := a_window
			update_memory_field ("window")
		end

	set_parent (a_parent: CE_POINTER [SD_GTKWIDGET])
		do
			parent := a_parent
			update_memory_field ("parent")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			object := a_other.object.twin
			private_flags := a_other.private_flags
			state := a_other.state
			saved_state := a_other.saved_state
			name := a_other.name
			style := a_other.style
			requisition := a_other.requisition.twin
			allocation := a_other.allocation.twin
			window := a_other.window
			parent := a_other.parent
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				object.is_equal (a_other.object) and
				private_flags = a_other.private_flags and
				state = a_other.state and
				saved_state = a_other.saved_state and
				name.is_equal (a_other.name) and
				style.is_equal (a_other.style) and
				requisition.is_equal (a_other.requisition) and
				allocation.is_equal (a_other.allocation) and
				window.is_equal (a_other.window) and
				parent.is_equal (a_other.parent)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("object"),
					create {CE_STRUCTURE_FIELD}.make ("private_flags"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("saved_state"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("style"),
					create {CE_STRUCTURE_FIELD}.make ("requisition"),
					create {CE_STRUCTURE_FIELD}.make ("allocation"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("parent")
				>>)
			init_structure_info
		end

end
