class
	SD_GTKWINDOW

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	bin: SD_GTKBIN assign set_bin

	title: CE_POINTER [INTEGER_8] assign set_title

	wmclass_name: CE_POINTER [INTEGER_8] assign set_wmclass_name

	wmclass_class: CE_POINTER [INTEGER_8] assign set_wmclass_class

	wm_role: CE_POINTER [INTEGER_8] assign set_wm_role

	focus_widget: CE_POINTER [SD_GTKWIDGET] assign set_focus_widget

	default_widget: CE_POINTER [SD_GTKWIDGET] assign set_default_widget

	transient_parent: CE_POINTER [SD_GTKWINDOW] assign set_transient_parent

	geometry_info: CE_POINTER [ANY] assign set_geometry_info

	frame: CE_POINTER [SD_GDKDRAWABLE] assign set_frame

	group: CE_POINTER [SD_GTKWINDOWGROUP] assign set_group

	configure_request_count: NATURAL_16 assign set_configure_request_count

	allow_shrink: NATURAL_32 assign set_allow_shrink

	allow_grow: NATURAL_32 assign set_allow_grow

	configure_notify_received: NATURAL_32 assign set_configure_notify_received

	need_default_position: NATURAL_32 assign set_need_default_position

	need_default_size: NATURAL_32 assign set_need_default_size

	position: NATURAL_32 assign set_position

	type: NATURAL_32 assign set_type

	has_user_ref_count: NATURAL_32 assign set_has_user_ref_count

	has_focus: NATURAL_32 assign set_has_focus

	modal: NATURAL_32 assign set_modal

	destroy_with_parent: NATURAL_32 assign set_destroy_with_parent

	has_frame: NATURAL_32 assign set_has_frame

	iconify_initially: NATURAL_32 assign set_iconify_initially

	stick_initially: NATURAL_32 assign set_stick_initially

	maximize_initially: NATURAL_32 assign set_maximize_initially

	decorated: NATURAL_32 assign set_decorated

	type_hint: NATURAL_32 assign set_type_hint

	gravity: NATURAL_32 assign set_gravity

	is_active: NATURAL_32 assign set_is_active

	has_toplevel_focus: NATURAL_32 assign set_has_toplevel_focus

	frame_left: NATURAL_32 assign set_frame_left

	frame_top: NATURAL_32 assign set_frame_top

	frame_right: NATURAL_32 assign set_frame_right

	frame_bottom: NATURAL_32 assign set_frame_bottom

	keys_changed_handler: NATURAL_32 assign set_keys_changed_handler

	mnemonic_modifier: NATURAL_32 assign set_mnemonic_modifier

	screen: CE_POINTER [SD_GDKSCREEN] assign set_screen

feature {ANY} -- field setters

	set_bin (a_bin: SD_GTKBIN)
		do
			bin := a_bin
			update_memory_field ("bin")
		end

	set_title (a_title: CE_POINTER [INTEGER_8])
		do
			title := a_title
			update_memory_field ("title")
		end

	set_wmclass_name (a_wmclass_name: CE_POINTER [INTEGER_8])
		do
			wmclass_name := a_wmclass_name
			update_memory_field ("wmclass_name")
		end

	set_wmclass_class (a_wmclass_class: CE_POINTER [INTEGER_8])
		do
			wmclass_class := a_wmclass_class
			update_memory_field ("wmclass_class")
		end

	set_wm_role (a_wm_role: CE_POINTER [INTEGER_8])
		do
			wm_role := a_wm_role
			update_memory_field ("wm_role")
		end

	set_focus_widget (a_focus_widget: CE_POINTER [SD_GTKWIDGET])
		do
			focus_widget := a_focus_widget
			update_memory_field ("focus_widget")
		end

	set_default_widget (a_default_widget: CE_POINTER [SD_GTKWIDGET])
		do
			default_widget := a_default_widget
			update_memory_field ("default_widget")
		end

	set_transient_parent (a_transient_parent: CE_POINTER [SD_GTKWINDOW])
		do
			transient_parent := a_transient_parent
			update_memory_field ("transient_parent")
		end

	set_geometry_info (a_geometry_info: CE_POINTER [ANY])
		do
			geometry_info := a_geometry_info
			update_memory_field ("geometry_info")
		end

	set_frame (a_frame: CE_POINTER [SD_GDKDRAWABLE])
		do
			frame := a_frame
			update_memory_field ("frame")
		end

	set_group (a_group: CE_POINTER [SD_GTKWINDOWGROUP])
		do
			group := a_group
			update_memory_field ("group")
		end

	set_configure_request_count (a_configure_request_count: NATURAL_16)
		do
			configure_request_count := a_configure_request_count
			update_memory_field ("configure_request_count")
		end

	set_allow_shrink (a_allow_shrink: NATURAL_32)
		do
			allow_shrink := a_allow_shrink
			update_memory_field ("allow_shrink")
		end

	set_allow_grow (a_allow_grow: NATURAL_32)
		do
			allow_grow := a_allow_grow
			update_memory_field ("allow_grow")
		end

	set_configure_notify_received (a_configure_notify_received: NATURAL_32)
		do
			configure_notify_received := a_configure_notify_received
			update_memory_field ("configure_notify_received")
		end

	set_need_default_position (a_need_default_position: NATURAL_32)
		do
			need_default_position := a_need_default_position
			update_memory_field ("need_default_position")
		end

	set_need_default_size (a_need_default_size: NATURAL_32)
		do
			need_default_size := a_need_default_size
			update_memory_field ("need_default_size")
		end

	set_position (a_position: NATURAL_32)
		do
			position := a_position
			update_memory_field ("position")
		end

	set_type (a_type: NATURAL_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_has_user_ref_count (a_has_user_ref_count: NATURAL_32)
		do
			has_user_ref_count := a_has_user_ref_count
			update_memory_field ("has_user_ref_count")
		end

	set_has_focus (a_has_focus: NATURAL_32)
		do
			has_focus := a_has_focus
			update_memory_field ("has_focus")
		end

	set_modal (a_modal: NATURAL_32)
		do
			modal := a_modal
			update_memory_field ("modal")
		end

	set_destroy_with_parent (a_destroy_with_parent: NATURAL_32)
		do
			destroy_with_parent := a_destroy_with_parent
			update_memory_field ("destroy_with_parent")
		end

	set_has_frame (a_has_frame: NATURAL_32)
		do
			has_frame := a_has_frame
			update_memory_field ("has_frame")
		end

	set_iconify_initially (a_iconify_initially: NATURAL_32)
		do
			iconify_initially := a_iconify_initially
			update_memory_field ("iconify_initially")
		end

	set_stick_initially (a_stick_initially: NATURAL_32)
		do
			stick_initially := a_stick_initially
			update_memory_field ("stick_initially")
		end

	set_maximize_initially (a_maximize_initially: NATURAL_32)
		do
			maximize_initially := a_maximize_initially
			update_memory_field ("maximize_initially")
		end

	set_decorated (a_decorated: NATURAL_32)
		do
			decorated := a_decorated
			update_memory_field ("decorated")
		end

	set_type_hint (a_type_hint: NATURAL_32)
		do
			type_hint := a_type_hint
			update_memory_field ("type_hint")
		end

	set_gravity (a_gravity: NATURAL_32)
		do
			gravity := a_gravity
			update_memory_field ("gravity")
		end

	set_is_active (a_is_active: NATURAL_32)
		do
			is_active := a_is_active
			update_memory_field ("is_active")
		end

	set_has_toplevel_focus (a_has_toplevel_focus: NATURAL_32)
		do
			has_toplevel_focus := a_has_toplevel_focus
			update_memory_field ("has_toplevel_focus")
		end

	set_frame_left (a_frame_left: NATURAL_32)
		do
			frame_left := a_frame_left
			update_memory_field ("frame_left")
		end

	set_frame_top (a_frame_top: NATURAL_32)
		do
			frame_top := a_frame_top
			update_memory_field ("frame_top")
		end

	set_frame_right (a_frame_right: NATURAL_32)
		do
			frame_right := a_frame_right
			update_memory_field ("frame_right")
		end

	set_frame_bottom (a_frame_bottom: NATURAL_32)
		do
			frame_bottom := a_frame_bottom
			update_memory_field ("frame_bottom")
		end

	set_keys_changed_handler (a_keys_changed_handler: NATURAL_32)
		do
			keys_changed_handler := a_keys_changed_handler
			update_memory_field ("keys_changed_handler")
		end

	set_mnemonic_modifier (a_mnemonic_modifier: NATURAL_32)
		do
			mnemonic_modifier := a_mnemonic_modifier
			update_memory_field ("mnemonic_modifier")
		end

	set_screen (a_screen: CE_POINTER [SD_GDKSCREEN])
		do
			screen := a_screen
			update_memory_field ("screen")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			bin := a_other.bin.twin
			title := a_other.title
			wmclass_name := a_other.wmclass_name
			wmclass_class := a_other.wmclass_class
			wm_role := a_other.wm_role
			focus_widget := a_other.focus_widget
			default_widget := a_other.default_widget
			transient_parent := a_other.transient_parent
			geometry_info := a_other.geometry_info
			frame := a_other.frame
			group := a_other.group
			configure_request_count := a_other.configure_request_count
			allow_shrink := a_other.allow_shrink
			allow_grow := a_other.allow_grow
			configure_notify_received := a_other.configure_notify_received
			need_default_position := a_other.need_default_position
			need_default_size := a_other.need_default_size
			position := a_other.position
			type := a_other.type
			has_user_ref_count := a_other.has_user_ref_count
			has_focus := a_other.has_focus
			modal := a_other.modal
			destroy_with_parent := a_other.destroy_with_parent
			has_frame := a_other.has_frame
			iconify_initially := a_other.iconify_initially
			stick_initially := a_other.stick_initially
			maximize_initially := a_other.maximize_initially
			decorated := a_other.decorated
			type_hint := a_other.type_hint
			gravity := a_other.gravity
			is_active := a_other.is_active
			has_toplevel_focus := a_other.has_toplevel_focus
			frame_left := a_other.frame_left
			frame_top := a_other.frame_top
			frame_right := a_other.frame_right
			frame_bottom := a_other.frame_bottom
			keys_changed_handler := a_other.keys_changed_handler
			mnemonic_modifier := a_other.mnemonic_modifier
			screen := a_other.screen
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				bin.is_equal (a_other.bin) and
				title.is_equal (a_other.title) and
				wmclass_name.is_equal (a_other.wmclass_name) and
				wmclass_class.is_equal (a_other.wmclass_class) and
				wm_role.is_equal (a_other.wm_role) and
				focus_widget.is_equal (a_other.focus_widget) and
				default_widget.is_equal (a_other.default_widget) and
				transient_parent.is_equal (a_other.transient_parent) and
				geometry_info.is_equal (a_other.geometry_info) and
				frame.is_equal (a_other.frame) and
				group.is_equal (a_other.group) and
				configure_request_count = a_other.configure_request_count and
				allow_shrink = a_other.allow_shrink and
				allow_grow = a_other.allow_grow and
				configure_notify_received = a_other.configure_notify_received and
				need_default_position = a_other.need_default_position and
				need_default_size = a_other.need_default_size and
				position = a_other.position and
				type = a_other.type and
				has_user_ref_count = a_other.has_user_ref_count and
				has_focus = a_other.has_focus and
				modal = a_other.modal and
				destroy_with_parent = a_other.destroy_with_parent and
				has_frame = a_other.has_frame and
				iconify_initially = a_other.iconify_initially and
				stick_initially = a_other.stick_initially and
				maximize_initially = a_other.maximize_initially and
				decorated = a_other.decorated and
				type_hint = a_other.type_hint and
				gravity = a_other.gravity and
				is_active = a_other.is_active and
				has_toplevel_focus = a_other.has_toplevel_focus and
				frame_left = a_other.frame_left and
				frame_top = a_other.frame_top and
				frame_right = a_other.frame_right and
				frame_bottom = a_other.frame_bottom and
				keys_changed_handler = a_other.keys_changed_handler and
				mnemonic_modifier = a_other.mnemonic_modifier and
				screen.is_equal (a_other.screen)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("bin"),
					create {CE_STRUCTURE_FIELD}.make ("title"),
					create {CE_STRUCTURE_FIELD}.make ("wmclass_name"),
					create {CE_STRUCTURE_FIELD}.make ("wmclass_class"),
					create {CE_STRUCTURE_FIELD}.make ("wm_role"),
					create {CE_STRUCTURE_FIELD}.make ("focus_widget"),
					create {CE_STRUCTURE_FIELD}.make ("default_widget"),
					create {CE_STRUCTURE_FIELD}.make ("transient_parent"),
					create {CE_STRUCTURE_FIELD}.make ("geometry_info"),
					create {CE_STRUCTURE_FIELD}.make ("frame"),
					create {CE_STRUCTURE_FIELD}.make ("group"),
					create {CE_STRUCTURE_FIELD}.make ("configure_request_count"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("allow_shrink"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("allow_grow"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("configure_notify_received"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("need_default_position"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("need_default_size"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("position"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("type"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("has_user_ref_count"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("has_focus"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("modal"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("destroy_with_parent"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("has_frame"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("iconify_initially"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("stick_initially"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("maximize_initially"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("decorated"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("type_hint"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("gravity"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("is_active"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("has_toplevel_focus"),
					create {CE_STRUCTURE_FIELD}.make ("frame_left"),
					create {CE_STRUCTURE_FIELD}.make ("frame_top"),
					create {CE_STRUCTURE_FIELD}.make ("frame_right"),
					create {CE_STRUCTURE_FIELD}.make ("frame_bottom"),
					create {CE_STRUCTURE_FIELD}.make ("keys_changed_handler"),
					create {CE_STRUCTURE_FIELD}.make ("mnemonic_modifier"),
					create {CE_STRUCTURE_FIELD}.make ("screen")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkWindow);
					if(strcmp(field_name, "frame_left") == 0) return offsetof(struct _GtkWindow, frame_left);
				} else {
					struct _GtkWindow *p = (struct _GtkWindow *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "allow_shrink") == 0) p->allow_shrink = (unsigned int)$a_value;
						else if(strcmp(field_name, "allow_grow") == 0) p->allow_grow = (unsigned int)$a_value;
						else if(strcmp(field_name, "configure_notify_received") == 0) p->configure_notify_received = (unsigned int)$a_value;
						else if(strcmp(field_name, "need_default_position") == 0) p->need_default_position = (unsigned int)$a_value;
						else if(strcmp(field_name, "need_default_size") == 0) p->need_default_size = (unsigned int)$a_value;
						else if(strcmp(field_name, "position") == 0) p->position = (unsigned int)$a_value;
						else if(strcmp(field_name, "type") == 0) p->type = (unsigned int)$a_value;
						else if(strcmp(field_name, "has_user_ref_count") == 0) p->has_user_ref_count = (unsigned int)$a_value;
						else if(strcmp(field_name, "has_focus") == 0) p->has_focus = (unsigned int)$a_value;
						else if(strcmp(field_name, "modal") == 0) p->modal = (unsigned int)$a_value;
						else if(strcmp(field_name, "destroy_with_parent") == 0) p->destroy_with_parent = (unsigned int)$a_value;
						else if(strcmp(field_name, "has_frame") == 0) p->has_frame = (unsigned int)$a_value;
						else if(strcmp(field_name, "iconify_initially") == 0) p->iconify_initially = (unsigned int)$a_value;
						else if(strcmp(field_name, "stick_initially") == 0) p->stick_initially = (unsigned int)$a_value;
						else if(strcmp(field_name, "maximize_initially") == 0) p->maximize_initially = (unsigned int)$a_value;
						else if(strcmp(field_name, "decorated") == 0) p->decorated = (unsigned int)$a_value;
						else if(strcmp(field_name, "type_hint") == 0) p->type_hint = (unsigned int)$a_value;
						else if(strcmp(field_name, "gravity") == 0) p->gravity = (unsigned int)$a_value;
						else if(strcmp(field_name, "is_active") == 0) p->is_active = (unsigned int)$a_value;
						else if(strcmp(field_name, "has_toplevel_focus") == 0) p->has_toplevel_focus = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "allow_shrink") == 0) return p->allow_shrink;
						if(strcmp(field_name, "allow_grow") == 0) return p->allow_grow;
						if(strcmp(field_name, "configure_notify_received") == 0) return p->configure_notify_received;
						if(strcmp(field_name, "need_default_position") == 0) return p->need_default_position;
						if(strcmp(field_name, "need_default_size") == 0) return p->need_default_size;
						if(strcmp(field_name, "position") == 0) return p->position;
						if(strcmp(field_name, "type") == 0) return p->type;
						if(strcmp(field_name, "has_user_ref_count") == 0) return p->has_user_ref_count;
						if(strcmp(field_name, "has_focus") == 0) return p->has_focus;
						if(strcmp(field_name, "modal") == 0) return p->modal;
						if(strcmp(field_name, "destroy_with_parent") == 0) return p->destroy_with_parent;
						if(strcmp(field_name, "has_frame") == 0) return p->has_frame;
						if(strcmp(field_name, "iconify_initially") == 0) return p->iconify_initially;
						if(strcmp(field_name, "stick_initially") == 0) return p->stick_initially;
						if(strcmp(field_name, "maximize_initially") == 0) return p->maximize_initially;
						if(strcmp(field_name, "decorated") == 0) return p->decorated;
						if(strcmp(field_name, "type_hint") == 0) return p->type_hint;
						if(strcmp(field_name, "gravity") == 0) return p->gravity;
						if(strcmp(field_name, "is_active") == 0) return p->is_active;
						if(strcmp(field_name, "has_toplevel_focus") == 0) return p->has_toplevel_focus;
					}
				}
			]"
		end

end
