class
	SD_PANGOATTRCLASS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create copy2.make
			create destroy.make
			create equal2.make
		end

feature {ANY} -- fields

	type: NATURAL_32 assign set_type

	copy2: CE_ROUTINE assign set_copy2

	destroy: CE_ROUTINE assign set_destroy

	equal2: CE_ROUTINE assign set_equal2

feature {ANY} -- field setters

	set_type (a_type: NATURAL_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_copy2 (a_copy2: CE_ROUTINE)
		do
			copy2 := a_copy2
			update_memory_field ("copy2")
		end

	set_destroy (a_destroy: CE_ROUTINE)
		do
			destroy := a_destroy
			update_memory_field ("destroy")
		end

	set_equal2 (a_equal2: CE_ROUTINE)
		do
			equal2 := a_equal2
			update_memory_field ("equal2")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			copy2 := a_other.copy2
			destroy := a_other.destroy
			equal2 := a_other.equal2
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				copy2.is_equal (a_other.copy2) and
				destroy.is_equal (a_other.destroy) and
				equal2.is_equal (a_other.equal2)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("copy2"),
					create {CE_STRUCTURE_FIELD}.make ("destroy"),
					create {CE_STRUCTURE_FIELD}.make ("equal2")
				>>)
			init_structure_info
		end

end
