class
	SD_PANGOATTRIBUTE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_PANGOATTRCLASS]} klass.make
		end

feature {ANY} -- fields

	klass: CE_POINTER [SD_PANGOATTRCLASS] assign set_klass

	start_index: NATURAL_32 assign set_start_index

	end_index: NATURAL_32 assign set_end_index

feature {ANY} -- field setters

	set_klass (a_klass: CE_POINTER [SD_PANGOATTRCLASS])
		do
			klass := a_klass
			update_memory_field ("klass")
		end

	set_start_index (a_start_index: NATURAL_32)
		do
			start_index := a_start_index
			update_memory_field ("start_index")
		end

	set_end_index (a_end_index: NATURAL_32)
		do
			end_index := a_end_index
			update_memory_field ("end_index")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			klass := a_other.klass
			start_index := a_other.start_index
			end_index := a_other.end_index
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				klass.is_equal (a_other.klass) and
				start_index = a_other.start_index and
				end_index = a_other.end_index
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("klass"),
					create {CE_STRUCTURE_FIELD}.make ("start_index"),
					create {CE_STRUCTURE_FIELD}.make ("end_index")
				>>)
			init_structure_info
		end

end
