class
	SD_SIGALTSTACK

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} ss_sp.make
		end

feature {ANY} -- fields

	ss_sp: CE_POINTER [ANY] assign set_ss_sp

	ss_flags: INTEGER_32 assign set_ss_flags

	ss_size: NATURAL_32 assign set_ss_size

feature {ANY} -- field setters

	set_ss_sp (a_ss_sp: CE_POINTER [ANY])
		do
			ss_sp := a_ss_sp
			update_memory_field ("ss_sp")
		end

	set_ss_flags (a_ss_flags: INTEGER_32)
		do
			ss_flags := a_ss_flags
			update_memory_field ("ss_flags")
		end

	set_ss_size (a_ss_size: NATURAL_32)
		do
			ss_size := a_ss_size
			update_memory_field ("ss_size")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ss_sp := a_other.ss_sp
			ss_flags := a_other.ss_flags
			ss_size := a_other.ss_size
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ss_sp.is_equal (a_other.ss_sp) and
				ss_flags = a_other.ss_flags and
				ss_size = a_other.ss_size
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ss_sp"),
					create {CE_STRUCTURE_FIELD}.make ("ss_flags"),
					create {CE_STRUCTURE_FIELD}.make ("ss_size")
				>>)
			init_structure_info
		end

end
