class
	SD_SIGVAL

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	sival_int: INTEGER_32 assign set_sival_int

	sival_ptr: CE_POINTER [ANY] assign set_sival_ptr

feature {ANY} -- field setters

	set_sival_int (a_sival_int: INTEGER_32)
		do
			sival_int := a_sival_int
			update_memory_field ("sival_int")
		end

	set_sival_ptr (a_sival_ptr: CE_POINTER [ANY])
		do
			sival_ptr := a_sival_ptr
			update_memory_field ("sival_ptr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sival_int := a_other.sival_int
			sival_ptr := a_other.sival_ptr
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sival_int = a_other.sival_int and
				sival_ptr.is_equal (a_other.sival_ptr)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("sival_int"),
					create {CE_STRUCTURE_FIELD}.make ("sival_ptr")
				>>)
			init_structure_info
		end

end
