class
	SD_TIMEVAL

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	tv_sec: INTEGER_32 assign set_tv_sec

	tv_usec: INTEGER_32 assign set_tv_usec

feature {ANY} -- field setters

	set_tv_sec (a_tv_sec: INTEGER_32)
		do
			tv_sec := a_tv_sec
			update_memory_field ("tv_sec")
		end

	set_tv_usec (a_tv_usec: INTEGER_32)
		do
			tv_usec := a_tv_usec
			update_memory_field ("tv_usec")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tv_sec := a_other.tv_sec
			tv_usec := a_other.tv_usec
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tv_sec = a_other.tv_sec and
				tv_usec = a_other.tv_usec
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tv_sec"),
					create {CE_STRUCTURE_FIELD}.make ("tv_usec")
				>>)
			init_structure_info
		end

end
