class
	SD_WAIT_TERMINATED

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	w_termsig: NATURAL_32 assign set_w_termsig

	w_coredump: NATURAL_32 assign set_w_coredump

	w_retcode: NATURAL_32 assign set_w_retcode

feature {ANY} -- field setters

	set_w_termsig (a_w_termsig: NATURAL_32)
		do
			w_termsig := a_w_termsig
			update_memory_field ("w_termsig")
		end

	set_w_coredump (a_w_coredump: NATURAL_32)
		do
			w_coredump := a_w_coredump
			update_memory_field ("w_coredump")
		end

	set_w_retcode (a_w_retcode: NATURAL_32)
		do
			w_retcode := a_w_retcode
			update_memory_field ("w_retcode")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			w_termsig := a_other.w_termsig
			w_coredump := a_other.w_coredump
			w_retcode := a_other.w_retcode
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				w_termsig = a_other.w_termsig and
				w_coredump = a_other.w_coredump and
				w_retcode = a_other.w_retcode
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_bitfield ("w_termsig"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("w_coredump"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("w_retcode")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline"
		alias
			"[
				struct __anonstruct___wait_terminated_22 {
					unsigned int __w_termsig : 7;
					unsigned int __w_coredump : 1;
					unsigned int __w_retcode : 8;
					unsigned int : 16;
				};
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct __anonstruct___wait_terminated_22);
				} else {
					struct __anonstruct___wait_terminated_22 *p = (struct __anonstruct___wait_terminated_22 *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "w_termsig") == 0) p->__w_termsig = (unsigned int)$a_value;
						else if(strcmp(field_name, "w_coredump") == 0) p->__w_coredump = (unsigned int)$a_value;
						else if(strcmp(field_name, "w_retcode") == 0) p->__w_retcode = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "w_termsig") == 0) return p->__w_termsig;
						if(strcmp(field_name, "w_coredump") == 0) return p->__w_coredump;
						if(strcmp(field_name, "w_retcode") == 0) return p->__w_retcode;
					}
				}
			]"
		end

end
