class
	SD_WINSIZE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	ws_row: NATURAL_16 assign set_ws_row

	ws_col: NATURAL_16 assign set_ws_col

	ws_xpixel: NATURAL_16 assign set_ws_xpixel

	ws_ypixel: NATURAL_16 assign set_ws_ypixel

feature {ANY} -- field setters

	set_ws_row (a_ws_row: NATURAL_16)
		do
			ws_row := a_ws_row
			update_memory_field ("ws_row")
		end

	set_ws_col (a_ws_col: NATURAL_16)
		do
			ws_col := a_ws_col
			update_memory_field ("ws_col")
		end

	set_ws_xpixel (a_ws_xpixel: NATURAL_16)
		do
			ws_xpixel := a_ws_xpixel
			update_memory_field ("ws_xpixel")
		end

	set_ws_ypixel (a_ws_ypixel: NATURAL_16)
		do
			ws_ypixel := a_ws_ypixel
			update_memory_field ("ws_ypixel")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ws_row := a_other.ws_row
			ws_col := a_other.ws_col
			ws_xpixel := a_other.ws_xpixel
			ws_ypixel := a_other.ws_ypixel
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ws_row = a_other.ws_row and
				ws_col = a_other.ws_col and
				ws_xpixel = a_other.ws_xpixel and
				ws_ypixel = a_other.ws_ypixel
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ws_row"),
					create {CE_STRUCTURE_FIELD}.make ("ws_col"),
					create {CE_STRUCTURE_FIELD}.make ("ws_xpixel"),
					create {CE_STRUCTURE_FIELD}.make ("ws_ypixel")
				>>)
			init_structure_info
		end

end
