class
	SD_XSELECTIONREQUESTEVENT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} display.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	serial: NATURAL_32 assign set_serial

	send_event: INTEGER_32 assign set_send_event

	display: CE_POINTER [ANY] assign set_display

	owner: NATURAL_32 assign set_owner

	requestor: NATURAL_32 assign set_requestor

	selection: NATURAL_32 assign set_selection

	target: NATURAL_32 assign set_target

	property: NATURAL_32 assign set_property

	time: NATURAL_32 assign set_time

feature {ANY} -- field setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_serial (a_serial: NATURAL_32)
		do
			serial := a_serial
			update_memory_field ("serial")
		end

	set_send_event (a_send_event: INTEGER_32)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			display := a_display
			update_memory_field ("display")
		end

	set_owner (a_owner: NATURAL_32)
		do
			owner := a_owner
			update_memory_field ("owner")
		end

	set_requestor (a_requestor: NATURAL_32)
		do
			requestor := a_requestor
			update_memory_field ("requestor")
		end

	set_selection (a_selection: NATURAL_32)
		do
			selection := a_selection
			update_memory_field ("selection")
		end

	set_target (a_target: NATURAL_32)
		do
			target := a_target
			update_memory_field ("target")
		end

	set_property (a_property: NATURAL_32)
		do
			property := a_property
			update_memory_field ("property")
		end

	set_time (a_time: NATURAL_32)
		do
			time := a_time
			update_memory_field ("time")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			serial := a_other.serial
			send_event := a_other.send_event
			display := a_other.display
			owner := a_other.owner
			requestor := a_other.requestor
			selection := a_other.selection
			target := a_other.target
			property := a_other.property
			time := a_other.time
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				serial = a_other.serial and
				send_event = a_other.send_event and
				display.is_equal (a_other.display) and
				owner = a_other.owner and
				requestor = a_other.requestor and
				selection = a_other.selection and
				target = a_other.target and
				property = a_other.property and
				time = a_other.time
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("serial"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("display"),
					create {CE_STRUCTURE_FIELD}.make ("owner"),
					create {CE_STRUCTURE_FIELD}.make ("requestor"),
					create {CE_STRUCTURE_FIELD}.make ("selection"),
					create {CE_STRUCTURE_FIELD}.make ("target"),
					create {CE_STRUCTURE_FIELD}.make ("property"),
					create {CE_STRUCTURE_FIELD}.make ("time")
				>>)
			init_structure_info
		end

end
