class
	P_FTP_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	Curl_handler_ftp: CE_STATIC [CE_ARRAY [PD_CURL_HANDLER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					create {PD_CURL_HANDLER}.make_initialized ([ce_string ("FTP"), (create {PD_CONNECTDATA_STATIC}).ftp_setup_connection_address, (create {PD_CONNECTDATA_STATIC}).ftp_do_address, (create {PD_CONNECTDATA_STATIC}).ftp_done_address, (create {PD_CONNECTDATA_STATIC}).ftp_nextconnect_address, (create {PD_CONNECTDATA_STATIC}).ftp_connect_address, ftp_multi_statemach_address, ftp_doing_address, ftp_getsock_address, ftp_getsock_address, create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).ftp_disconnect_address, 21, ((1).bit_shift_left (2)).to_integer_32])
				>>)
		end

feature {ANY} -- public routines

	ftp_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		do
			Result := ((create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc") + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_getsock (a_socks, a_numsocks))
		end

	ftp_multi_statemach (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_result: NATURAL_32
		do
			l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
			l_result := ((create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_multi_statemach)
			a_done.item := (l_ftpc.item.state = {NATURAL_32} 0)
			Result := l_result
		end

	wc_data_dtor (a_ptr: CE_POINTER [ANY])
		local
			l_tmp: CE_POINTER [PD_FTP_WC_TMPDATA]
		do
			l_tmp := create {CE_CLASS_POINTER [PD_FTP_WC_TMPDATA]}.make_cast (a_ptr)
			if (not l_tmp.is_void) then
				(create {P_FTPLISTPARSER_STATIC}).Curl_ftp_parselist_data_free (create {CE_POINTER_POINTER [PD_FTP_PARSELIST_DATA]}.make_shared (l_tmp.c_pointer + (create {PD_FTP_WC_TMPDATA}.make).offset_of ("parser")))
			end
			(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_tmp))
		end

	ftp_doing (a_conn: CE_POINTER [PD_CONNECTDATA]; a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_dophase_done.is_void
		local
			l_result: NATURAL_32
		do
			l_result := ftp_multi_statemach (a_conn, a_dophase_done)
			if a_dophase_done.item then
				l_result := a_conn.item.ftp_dophase_done ((0).to_boolean)
			end
			Result := l_result
		end

feature {ANY} -- routine addresses

	ftp_getsock_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ftp_getsock)
		end

	ftp_multi_statemach_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ftp_multi_statemach)
		end

	wc_data_dtor_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent wc_data_dtor)
		end

	ftp_doing_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ftp_doing)
		end

end
