class
	P_HASH_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC

feature {ANY} -- public routines

	hash_element_dtor (a_user, a_element: CE_POINTER [ANY])
		local
			l_h: CE_POINTER [PD_CURL_HASH]
			l_e: CE_POINTER [PD_CURL_HASH_ELEMENT]
		do
			l_h := create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_cast (a_user)
			l_e := create {CE_CLASS_POINTER [PD_CURL_HASH_ELEMENT]}.make_cast (a_element)
			if (not (l_e.item.key).is_void) then
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_e.item.key)])
			end
			if (not (l_e.item.ptr).is_void) then
				(l_h.item.dtor).call ([l_e.item.ptr])
			end
			(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_e)])
		end

	Curl_hash_alloc (a_slots: INTEGER_32; a_hfunc, a_comparator, a_dtor: CE_ROUTINE): CE_POINTER [PD_CURL_HASH]
		local
			l_h: CE_POINTER [PD_CURL_HASH]
			l_return: BOOLEAN
		do
			if not a_slots.to_boolean then
				Result := (create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (default_pointer))
				l_return := True
			elseif a_hfunc.is_void then
				Result := (create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (default_pointer))
				l_return := True
			elseif a_comparator.is_void then
				Result := (create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (default_pointer))
				l_return := True
			elseif a_dtor.is_void then
				Result := (create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_h := create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(create {PD_CURL_HASH}.make).structure_size.to_natural_32]))))
				if (not l_h.is_void) then
					if (l_h.item.Curl_hash_init (a_slots, a_hfunc, a_comparator, a_dtor)).to_boolean then
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_h)])
						l_h := create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (default_pointer)
					end
				end
				Result := l_h
			end
		end

	Curl_hash_destroy (a_h: CE_POINTER [PD_CURL_HASH])
		local
			l_return: BOOLEAN
		do
			if a_h.is_void then
				l_return := True
			end
			if not l_return then
				a_h.item.Curl_hash_clean;
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_h)])
			end
		end

	Curl_hash_str (a_key: CE_POINTER [ANY]; a_key_length, a_slots_num: NATURAL_32): NATURAL_32
		local
			l_key_str: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_h: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_8]
		do
			l_key_str := create {CE_INTEGER_8_POINTER}.make_cast (a_key)
			l_end := l_key_str + a_key_length.to_integer_32
			l_h := {NATURAL_32} 5_381
			from
			until
				not ((l_key_str.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32)
			loop
				l_h := l_h + ((l_h).bit_shift_left (5))
				l_tmp := l_key_str
				l_key_str := l_key_str + 1
				l_h := (l_h).bit_xor ((l_tmp[0]).to_natural_32)
			end
			Result := (l_h \\ a_slots_num.to_natural_32).to_natural_32
		end

	Curl_str_key_compare (a_k1: CE_POINTER [ANY]; a_key1_len: NATURAL_32; a_k2: CE_POINTER [ANY]; a_key2_len: NATURAL_32): NATURAL_32
		local
			l_key1: CE_POINTER [INTEGER_8]
			l_key2: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_key1 := create {CE_INTEGER_8_POINTER}.make_cast (a_k1)
			l_key2 := create {CE_INTEGER_8_POINTER}.make_cast (a_k2)
			if a_key1_len = a_key2_len then
				if (l_key1[0]).to_integer_32 = (l_key2[0]).to_integer_32 then
					if (memcmp (create {CE_VOID_POINTER}.make_cast (l_key1), create {CE_VOID_POINTER}.make_cast (l_key2), a_key1_len)) = 0 then
						Result := (1).to_natural_32
						l_return := True
					end
				end
			end
			if not l_return then
				Result := (0).to_natural_32
			end
		end

feature {ANY} -- routine addresses

	hash_element_dtor_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent hash_element_dtor)
		end

	Curl_hash_str_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent Curl_hash_str)
		end

	Curl_str_key_compare_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent Curl_str_key_compare)
		end

end
