class
	P_HOSTIP4_STATIC

inherit
	CE_UTILITIES
	S_ARPA_INET_STATIC
	S_STRING_STATIC

feature {ANY} -- public routines

	Curl_ipv4_resolve_r (a_hostname: CE_POINTER [INTEGER_8]; a_port: INTEGER_32): CE_POINTER [PD_CURL_ADDRINFO]
		local
			l_ai: CE_ARRAY [CE_POINTER [PD_CURL_ADDRINFO]]
			l_h: CE_POINTER [SD_HOSTENT]
			l_in: CE_ARRAY [SD_IN_ADDR]
			l_buf: CE_POINTER [SD_HOSTENT]
			l_hints: CE_ARRAY [SD_ADDRINFO]
			l_sbuf: CE_ARRAY [INTEGER_8]
			l_sbufptr: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_CURL_ADDRINFO]} l_ai.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_IN_ADDR]} l_in.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_ADDRINFO]} l_hints.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_sbuf.make (<<32>>)

			l_ai.item := create {CE_CLASS_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
			l_h := create {CE_CLASS_POINTER [SD_HOSTENT]}.make_shared (default_pointer)
			l_buf := create {CE_CLASS_POINTER [SD_HOSTENT]}.make_shared (default_pointer)
			if (inet_pton (2, a_hostname, create {CE_VOID_POINTER}.make_cast (l_in))) > 0 then
				Result := ((create {P_CURL_ADDRINFO_STATIC}).Curl_ip2addr (2, create {CE_VOID_POINTER}.make_cast (l_in), a_hostname, a_port))
				l_return := True
			else
				l_sbufptr := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				memset (create {CE_VOID_POINTER}.make_cast (l_hints), 0, (create {SD_ADDRINFO}.make).structure_size.to_natural_32).do_nothing
				l_hints.item.ai_family := 2
				l_hints.item.ai_socktype := 1
				if a_port.to_boolean then
					(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_sbuf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (32).to_natural_32), ce_string ("%%d"), a_port]).do_nothing
					l_sbufptr := l_sbuf
				end
				(create {P_CURL_ADDRINFO_STATIC}).Curl_getaddrinfo_ex (a_hostname, l_sbufptr, l_hints, l_ai).do_nothing
			end
			if not l_return then
				if (not l_h.is_void) then
					l_ai.item := (create {P_CURL_ADDRINFO_STATIC}).Curl_he2ai (l_h, a_port)
					if (not l_buf.is_void) then
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_buf)])
					end
				end
				Result := (l_ai.item)
			end
		end

end
