class
	P_SHARE_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	curl_share_init: CE_POINTER [ANY]
		local
			l_share: CE_POINTER [PD_CURL_SHARE]
		do
			l_share := create {CE_CLASS_POINTER [PD_CURL_SHARE]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_CURL_SHARE}.make).structure_size.to_natural_32]))))
			if (not l_share.is_void) then
				l_share.item.specifier := (l_share.item.specifier).bit_or (((1).bit_shift_left (1)).to_natural_32)
			end
			Result := (create {CE_VOID_POINTER}.make_cast (l_share))
		end

	curl_share_setopt (a_args: TUPLE [a_sh: CE_POINTER [ANY]; a_option: NATURAL_32]): NATURAL_32
		local
			l_share: CE_POINTER [PD_CURL_SHARE]
			l_param: CE_VA_LIST
			l_type: INTEGER_32
			l_lockfunc: CE_ROUTINE
			l_unlockfunc: CE_ROUTINE
			l_ptr: CE_POINTER [ANY]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create l_param.make_shared (default_pointer)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_share := create {CE_CLASS_POINTER [PD_CURL_SHARE]}.make_cast (a_args.a_sh)
					if (l_share.item.dirty).to_boolean then
						Result := ({PC_CURLSHCODE}.CURLSHE_IN_USE)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						l_param := create {CE_VA_LIST}.make (a_args, agent curl_share_setopt)
						inspect a_args.a_option.to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 7
						when 3 then l_pos := -1 + 14
						when 4 then l_pos := -1 + 15
						when 5 then l_pos := -1 + 16
						else l_pos := -1 + 17
						end
				when 2 then -- switch 1, case 1
						l_type := l_param.integer_32_item
						l_share.item.specifier := (l_share.item.specifier).bit_or (((1).bit_shift_left (l_type)).to_natural_32)
						inspect l_type -- switch 2 head
						when 3 then l_pos := -1 + 3
						when 2 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 3 then -- switch 2, case 3
						if (l_share.item.hostcache).is_void then
							l_share.item.hostcache := (create {P_HOSTIP_STATIC}).Curl_mk_dnscache
							if (l_share.item.hostcache).is_void then
								Result := ({PC_CURLSHCODE}.CURLSHE_NOMEM)
								l_return := True
							end
						end
						l_pos := -1 + 6 -- switch 2; break
				when 4 then -- switch 2, case 2
						if (l_share.item.cookies).is_void then
							l_share.item.cookies := (create {P_COOKIE_STATIC}).Curl_cookie_init (create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (default_pointer), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_COOKIEINFO]}.make_shared (default_pointer), (1).to_boolean)
							if (l_share.item.cookies).is_void then
								Result := ({PC_CURLSHCODE}.CURLSHE_NOMEM)
								l_return := True
							end
						end
						l_pos := -1 + 6 -- switch 2; break
				when 5 then -- switch 2, default:
						Result := ({PC_CURLSHCODE}.CURLSHE_BAD_OPTION)
						l_return := True
				when 6 then -- switch 2, done:
						l_pos := -1 + 18 -- switch 1; break
				when 7 then -- switch 1, case 2
						l_type := l_param.integer_32_item
						l_share.item.specifier := (l_share.item.specifier).bit_and (((((1).bit_shift_left (l_type))).bit_not).to_natural_32)
						inspect l_type -- switch 3 head
						when 3 then l_pos := -1 + 8
						when 2 then l_pos := -1 + 9
						when 4 then l_pos := -1 + 10
						when 5 then l_pos := -1 + 11
						else l_pos := -1 + 12
						end
				when 8 then -- switch 3, case 3
						if (not (l_share.item.hostcache).is_void) then
							(create {P_HASH_STATIC}).Curl_hash_destroy (l_share.item.hostcache)
							l_share.item.hostcache := create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (default_pointer)
						end
						l_pos := -1 + 13 -- switch 3; break
				when 9 then -- switch 3, case 2
						if (not (l_share.item.cookies).is_void) then
							(create {P_COOKIE_STATIC}).Curl_cookie_cleanup (l_share.item.cookies)
							l_share.item.cookies := create {CE_CLASS_POINTER [PD_COOKIEINFO]}.make_shared (default_pointer)
						end
						l_pos := -1 + 13 -- switch 3; break
				when 10 then -- switch 3, case 4
						l_pos := -1 + 13 -- switch 3; break
				when 11 then -- switch 3, case 5
						l_pos := -1 + 13 -- switch 3; break
				when 12 then -- switch 3, default:
						Result := ({PC_CURLSHCODE}.CURLSHE_BAD_OPTION)
						l_return := True
				when 13 then -- switch 3, done:
						l_pos := -1 + 18 -- switch 1; break
				when 14 then -- switch 1, case 3
						l_lockfunc := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_share.item.lockfunc := l_lockfunc
						l_pos := -1 + 18 -- switch 1; break
				when 15 then -- switch 1, case 4
						l_unlockfunc := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_share.item.unlockfunc := l_unlockfunc
						l_pos := -1 + 18 -- switch 1; break
				when 16 then -- switch 1, case 5
						l_ptr := (create {CE_VOID_POINTER}.make_cast (l_param.pointer_item))
						l_share.item.clientdata := l_ptr
						l_pos := -1 + 18 -- switch 1; break
				when 17 then -- switch 1, default:
						Result := ({PC_CURLSHCODE}.CURLSHE_BAD_OPTION)
						l_return := True
				when 18 then -- switch 1, done: | if done
					if not l_return then
						Result := ({PC_CURLSHCODE}.CURLSHE_OK)
					end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	curl_share_cleanup (a_sh: CE_POINTER [ANY]): NATURAL_32
		local
			l_share: CE_POINTER [PD_CURL_SHARE]
			l_return: BOOLEAN
		do
			l_share := create {CE_CLASS_POINTER [PD_CURL_SHARE]}.make_cast (a_sh)
			if l_share.is_void then
				Result := ({PC_CURLSHCODE}.CURLSHE_INVALID)
				l_return := True
			end
			if not l_return then
				if (not (l_share.item.lockfunc).is_void) then
					(l_share.item.lockfunc).call ([create {CE_VOID_POINTER}.make_shared (default_pointer), {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_SHARE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE, l_share.item.clientdata])
				end
				if (l_share.item.dirty).to_boolean then
					if (not (l_share.item.unlockfunc).is_void) then
						(l_share.item.unlockfunc).call ([create {CE_VOID_POINTER}.make_shared (default_pointer), {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_SHARE, l_share.item.clientdata])
					end
					Result := ({PC_CURLSHCODE}.CURLSHE_IN_USE)
					l_return := True
				end
			end
			if not l_return then
				if (not (l_share.item.hostcache).is_void) then
					(create {P_HASH_STATIC}).Curl_hash_destroy (l_share.item.hostcache)
					l_share.item.hostcache := create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (default_pointer)
				end
				if (not (l_share.item.cookies).is_void) then
					(create {P_COOKIE_STATIC}).Curl_cookie_cleanup (l_share.item.cookies)
				end
				if (not (l_share.item.unlockfunc).is_void) then
					(l_share.item.unlockfunc).call ([create {CE_VOID_POINTER}.make_shared (default_pointer), {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_SHARE, l_share.item.clientdata])
				end
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_share)])
				Result := ({PC_CURLSHCODE}.CURLSHE_OK)
			end
		end

end
