class
	P_TRANSFER_STATIC

inherit
	CE_UTILITIES
	S_STDIO_STATIC
	S_STRING_STATIC

feature {ANY} -- public routines

	Curl_sleep_time (a_rate_bps, a_cur_rate_bps: INTEGER_64; a_pkt_size: INTEGER_32): INTEGER_32
		local
			l_rate_bps: INTEGER_64
			l_min_sleep: INTEGER_64
			l_rv: INTEGER_64
			l_return: BOOLEAN
		do
			l_rate_bps := a_rate_bps
			l_min_sleep := (0).to_integer_64
			l_rv := (0).to_integer_64
			if l_rate_bps = {INTEGER_64} 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				if a_cur_rate_bps > l_rate_bps + ((l_rate_bps).bit_shift_right (10)) then
					l_rate_bps := l_rate_bps - ((l_rate_bps).bit_shift_right (6))
					l_min_sleep := (1).to_integer_64
				elseif a_cur_rate_bps < l_rate_bps - ((l_rate_bps).bit_shift_right (10)) then
					l_rate_bps := l_rate_bps + ((l_rate_bps).bit_shift_right (6))
				end
				l_rv := ((a_pkt_size * 8) * 1_000).to_integer_64 // l_rate_bps
				if l_rv < l_min_sleep then
					l_rv := l_min_sleep
				end
				if l_rv > {INTEGER_64} 2_147_483_647 then
					l_rv := (2_147_483_647).to_integer_64
				end
				Result := l_rv.to_integer_32
			end
		end

	strlen_url (a_url: CE_POINTER [INTEGER_8]): NATURAL_32
		require
			not a_url.is_void
		local
			l_ptr: CE_POINTER [INTEGER_8]
			l_newlen: NATURAL_32
			l_left: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_newlen := (0).to_natural_32
					l_left := (1).to_boolean
					l_ptr := a_url
				when 1 then -- loop condition:
					if not ((l_ptr[0]).to_boolean) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						inspect (l_ptr[0]).to_integer_32 -- switch 1 head
						when 63 then l_pos := -1 + 3
						when 32 then l_pos := -1 + 5
						else l_pos := -1 + 4
						end
				when 3 then -- switch 1, case 63
						l_left := (0).to_boolean
				when 4 then -- switch 1, default:
						l_newlen := l_newlen + 1
						l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, case 32
						if l_left then
							l_newlen := l_newlen + ({NATURAL_32} 3)
						else
							l_newlen := l_newlen + 1
						end
						l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
						l_ptr := l_ptr + 1
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					Result := l_newlen
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	strcpy_url (a_output, a_url: CE_POINTER [INTEGER_8])
		require
			not a_output.is_void
			not a_url.is_void
		local
			l_left: BOOLEAN
			l_iptr: CE_POINTER [INTEGER_8]
			l_optr: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_left := (1).to_boolean
					l_optr := a_output
					l_iptr := a_url
				when 1 then -- loop condition:
					if not ((l_iptr[0]).to_boolean) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						inspect (l_iptr[0]).to_integer_32 -- switch 1 head
						when 63 then l_pos := -1 + 3
						when 32 then l_pos := -1 + 5
						else l_pos := -1 + 4
						end
				when 3 then -- switch 1, case 63
						l_left := (0).to_boolean
				when 4 then -- switch 1, default:
						l_tmp := l_optr
						l_optr := l_optr + 1
						l_tmp[0] := l_iptr[0]
						l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, case 32
						if l_left then
							l_tmp___0 := l_optr
							l_optr := l_optr + 1
							l_tmp___0[0] := (('%%').code).to_integer_8
							l_tmp___1 := l_optr
							l_optr := l_optr + 1
							l_tmp___1[0] := (('2').code).to_integer_8
							l_tmp___2 := l_optr
							l_optr := l_optr + 1
							l_tmp___2[0] := (('0').code).to_integer_8
						else
							l_tmp___3 := l_optr
							l_optr := l_optr + 1
							l_tmp___3[0] := (('+').code).to_integer_8
						end
						l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
						l_iptr := l_iptr + 1
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					l_optr[0] := (0).to_integer_8
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	is_absolute_url (a_url: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_prot: CE_ARRAY [INTEGER_8]
			l_letter: CE_ARRAY [INTEGER_8]
		do
			create {CE_INTEGER_8_ARRAY} l_prot.make (<<16>>)
			create {CE_INTEGER_8_ARRAY} l_letter.make (<<1>>)

			Result := (2 = (sscanf ([a_url, ce_string ("%%15[^?&/:]://%%c"), l_prot, l_letter])))
		end

	concat_url (a_base, a_relurl: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_newest: CE_POINTER [INTEGER_8]
			l_protsep: CE_POINTER [INTEGER_8]
			l_pathsep: CE_POINTER [INTEGER_8]
			l_newlen: NATURAL_32
			l_useurl: CE_POINTER [INTEGER_8]
			l_urllen: NATURAL_32
			l_url_clone: CE_POINTER [INTEGER_8]
			l_level: INTEGER_32
			l_tmp___0: INTEGER_32
			l_sep: CE_POINTER [INTEGER_8]
			l_tmp___3: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_useurl := a_relurl
					l_url_clone := (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([a_base])))
					if l_url_clone.is_void then
						Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						l_protsep := strstr (l_url_clone, ce_string ("//"))
						if l_protsep.is_void then
							l_protsep := l_url_clone
						else
							l_protsep := l_protsep + (2)
						end
						if 47 /= (a_relurl[0]).to_integer_32 then
							l_level := 0
							l_pathsep := strchr (l_protsep, ('?').code)
							if (not l_pathsep.is_void) then
								l_pathsep[0] := (0).to_integer_8
							end
							if (l_useurl[0]).to_integer_32 /= 63 then
								l_pathsep := strrchr (l_protsep, ('/').code)
								if (not l_pathsep.is_void) then
									l_pathsep[0] := (0).to_integer_8
								end
							end
							l_pathsep := strchr (l_protsep, ('/').code)
							if (not l_pathsep.is_void) then
								l_protsep := l_pathsep + 1
							else
								l_protsep := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							end
							if (l_useurl[0]).to_integer_32 = 46 then
								if (l_useurl[1]).to_integer_32 = 47 then
									l_useurl := l_useurl + (2)
								end
							end
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_useurl[0]).to_integer_32 = 46 then
									if (l_useurl[1]).to_integer_32 = 46 then
										if (l_useurl[2]).to_integer_32 /= 47 then
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_level := l_level + 1
									l_useurl := l_useurl + (3)
								end
							end
							l_break := False
							if (not l_protsep.is_void) then
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___0 := l_level
									l_level := l_level - 1
									if not l_tmp___0.to_boolean then
										l_break := True
									end
									if not (l_break) then
										l_pathsep := strrchr (l_protsep, ('/').code)
										if (not l_pathsep.is_void) then
											l_pathsep[0] := (0).to_integer_8
										else
											l_protsep[0] := (0).to_integer_8
											l_break := True
										end
									end
								end
								l_break := False
							end
						else
							l_pathsep := strchr (l_protsep, ('/').code)
							if (not l_pathsep.is_void) then
								l_sep := (strchr (l_protsep, ('?').code))
								if (not l_sep.is_void) then
									if (l_sep.c_pointer.to_integer_32).to_natural_32 < (l_pathsep.c_pointer.to_integer_32).to_natural_32 then
										l_pathsep := l_sep
									end
								end
								l_pathsep[0] := (0).to_integer_8
							else
								l_pathsep := strchr (l_protsep, ('?').code)
								if (not l_pathsep.is_void) then
									l_pathsep[0] := (0).to_integer_8
								end
							end
						end
						l_newlen := strlen_url (l_useurl)
						l_urllen := strlen (l_url_clone)
						l_newest := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([((l_urllen + {NATURAL_32} 1) + l_newlen) + {NATURAL_32} 1]))))
						if l_newest.is_void then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_url_clone)])
							Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						memcpy (create {CE_VOID_POINTER}.make_cast (l_newest), create {CE_VOID_POINTER}.make_cast (l_url_clone), l_urllen).do_nothing
						if (47 = (l_useurl[0]).to_integer_32) then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						if l_protsep.is_void then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_protsep[0]).to_boolean then
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if 63 /= (l_useurl[0]).to_integer_32 then
							l_tmp___3 := l_urllen
							l_urllen := l_urllen + 1
							l_newest[l_tmp___3.to_integer_32] := (('/').code).to_integer_8
						end
				when 6 then -- if done
						strcpy_url (l_newest + l_urllen.to_integer_32, l_useurl);
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_url_clone)])
						Result := l_newest
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_follow (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_newurl: CE_POINTER [INTEGER_8]; a_type: NATURAL_32): NATURAL_32
		local
			l_newurl: CE_POINTER [INTEGER_8]
			l_disallowport: BOOLEAN
			l_absolute: CE_POINTER [INTEGER_8]
			l_newest: CE_POINTER [INTEGER_8]
			l_newlen: NATURAL_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_newurl := a_newurl
					l_disallowport := (0).to_boolean
					if a_type = {NATURAL_32} 3 then
						if a_data.item.set.maxredirs /= -1 then
							if a_data.item.set.followlocation >= a_data.item.set.maxredirs then
								a_data.item.Curl_failf ([ce_string ("Maximum (%%ld) redirects followed"), a_data.item.set.maxredirs])
								Result := ({PC_CURLCODE}.CURLE_TOO_MANY_REDIRECTS)
								l_return := True
							end
						end
						if not l_return then
							a_data.item.state.this_is_a_follow := (1).to_boolean
							a_data.item.set.followlocation := (a_data.item.set.followlocation) + 1
							if a_data.item.set.http_auto_referer then
								if a_data.item.change.referer_alloc then
									(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_data.item.change.referer)])
								end
								a_data.item.change.referer := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([a_data.item.change.url]))
								if (a_data.item.change.referer).is_void then
									a_data.item.change.referer_alloc := (0).to_boolean
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									l_return := True
								end
								if not l_return then
									a_data.item.change.referer_alloc := (1).to_boolean
								end
							end
						end
					end
					if not l_return then
						if (is_absolute_url (l_newurl)) then
							l_disallowport := (1).to_boolean
							if (not (strchr (l_newurl, (' ').code)).is_void) then
								l_newlen := (strlen_url (l_newurl))
								l_newest := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([l_newlen + {NATURAL_32} 1]))))
								if l_newest.is_void then
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									l_return := True
								end
								if not l_return then
									strcpy_url (l_newest, l_newurl);
									(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_newurl)])
									l_newurl := l_newest
								end
							end
						else
							l_absolute := (concat_url (a_data.item.change.url, l_newurl))
							if l_absolute.is_void then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								l_return := True
							end
							if not l_return then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_newurl)])
								l_newurl := l_absolute
							end
						end
					end
					if not l_return and then (a_type = {NATURAL_32} 1) then
						a_data.item.info.wouldredirect := l_newurl
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						if l_disallowport then
							a_data.item.state.allow_port := (0).to_boolean
						end
						if a_data.item.change.url_alloc then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_data.item.change.url)])
						else
							a_data.item.change.url_alloc := (1).to_boolean
						end
						a_data.item.change.url := l_newurl
						l_newurl := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer);
						(create {P_SENDF_STATIC}).Curl_infof ([a_data, ce_string ("Issue another request to this URL: %'%%s%'%N"), a_data.item.change.url])
						inspect a_data.item.info.httpcode -- switch 1 head
						when 301 then l_pos := -1 + 3
						when 302 then l_pos := -1 + 9
						when 303 then l_pos := -1 + 15
						when 304 then l_pos := -1 + 16
						when 305 then l_pos := -1 + 17
						else l_pos := -1 + 2
						end
				when 2 then -- switch 1, default:
						l_pos := -1 + 18 -- switch 1; break
				when 3 then -- switch 1, case 301
						if a_data.item.set.httpreq /= {NATURAL_32} 2 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if a_data.item.set.httpreq /= {NATURAL_32} 3 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if not a_data.item.set.post301 then
							(create {P_SENDF_STATIC}).Curl_infof ([a_data, ce_string ("Violate RFC 2616/10.3.2 and switch from POST to GET%N")])
							a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_GET
						end
				when 8 then -- if done
						l_pos := -1 + 18 -- switch 1; break
				when 9 then -- switch 1, case 302
						if a_data.item.set.httpreq /= {NATURAL_32} 2 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L___0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 12 then -- else:
						if a_data.item.set.httpreq /= {NATURAL_32} 3 then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L___0:
						if not a_data.item.set.post302 then
							(create {P_SENDF_STATIC}).Curl_infof ([a_data, ce_string ("Violate RFC 2616/10.3.3 and switch from POST to GET%N")])
							a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_GET
						end
				when 14 then -- if done
						l_pos := -1 + 18 -- switch 1; break
				when 15 then -- switch 1, case 303
						if a_data.item.set.httpreq /= {NATURAL_32} 1 then
							a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_GET
							if a_data.item.set.opt_no_body then
								l_tmp___4 := ce_string ("HEAD")
							else
								l_tmp___4 := ce_string ("GET")
							end
							(create {P_SENDF_STATIC}).Curl_infof ([a_data, ce_string ("Disables POST, goes with %%s%N"), l_tmp___4])
						end
						l_pos := -1 + 18 -- switch 1; break
				when 16 then -- switch 1, case 304
						l_pos := -1 + 18 -- switch 1; break
				when 17 then -- switch 1, case 305
						l_pos := -1 + 18 -- switch 1; break
				when 18 then -- switch 1, done:;
						(create {P_PROGRESS_STATIC}).Curl_pgrsTime (a_data, {PC_TIMERID}.TIMER_REDIRECT)
						a_data.item.Curl_pgrsResetTimes
						Result := ({PC_CURLCODE}.CURLE_OK)
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_reconnect_request (a_connp: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]): NATURAL_32
		require
			not a_connp.is_void
		local
			l_result: NATURAL_32
			l_conn: CE_ARRAY [CE_POINTER [PD_CONNECTDATA]]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_async: CE_ARRAY [BOOLEAN]
			l_protocol_done: CE_ARRAY [BOOLEAN]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_CONNECTDATA]} l_conn.make (<<1>>)
			create {CE_BOOLEAN_ARRAY} l_async.make (<<1>>)
			create {CE_BOOLEAN_ARRAY} l_protocol_done.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_conn.item := a_connp.item
					l_data := l_conn.item.item.data;
					(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Re-used connection seems dead, get a new one%N")])
					l_conn.item.item.bits.close := (1).to_boolean
					l_result := (create {P_URL_STATIC}).Curl_done (l_conn, l_result, (0).to_boolean)
					if {NATURAL_32} 0 /= l_result then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if {NATURAL_32} 55 /= l_result then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_protocol_done.item := (1).to_boolean
						l_result := l_data.item.Curl_connect (a_connp, l_async, l_protocol_done)
						if {NATURAL_32} 0 = l_result then
							l_conn.item := a_connp.item
							if l_async.item then
								l_result := (create {P_HOSTSYN_STATIC}).Curl_wait_for_resolv (l_conn.item, create {CE_POINTER_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer))
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
								if not l_return then
									l_result := (create {P_URL_STATIC}).Curl_async_resolved (l_conn.item, l_protocol_done)
									if l_result.to_boolean then
										Result := l_result
										l_return := True
									end
								end
							end
						end
				when 5 then -- if done
					if not l_return then
						Result := l_result
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
