class
	P_URL_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_STDIO_STATIC
	S_UNISTD_STATIC

feature {ANY} -- public routines

	Curl_safefree (a_ptr: CE_POINTER [ANY])
		do
			if (not a_ptr.is_void) then
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([a_ptr])
			end
		end

	Curl_freeset (a_data: CE_POINTER [PD_SESSIONHANDLE])
		local
			l_i: NATURAL_32
		do
			l_i := {PC_DUPSTRING}.STRING_CERT
			from
			until
				not (l_i < {NATURAL_32} 37)
			loop
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_data.item.set.str[l_i.to_integer_32]))
				l_i := (l_i + {NATURAL_32} 1)
			end
		end

	setstropt (a_charp: CE_POINTER [CE_POINTER [INTEGER_8]]; a_s: CE_POINTER [INTEGER_8]): NATURAL_32
		require
			not a_charp.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_s := a_s
			if (not (a_charp.item).is_void) then
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_charp.item)])
				a_charp.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			end
			if (not l_s.is_void) then
				l_s := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_s]))
				if l_s.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
				if not l_return then
					a_charp.item := l_s
				end
			end
			if not l_return then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	setstropt_userpwd (a_option: CE_POINTER [INTEGER_8]; a_user_storage, a_pwd_storage: CE_POINTER [CE_POINTER [INTEGER_8]]): NATURAL_32
		local
			l_separator: CE_POINTER [INTEGER_8]
			l_result: NATURAL_32
			l_p: CE_POINTER [INTEGER_8]
			l_username_len: NATURAL_32
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			if a_option.is_void then
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_user_storage.item))
				a_user_storage.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_pwd_storage.item))
				a_pwd_storage.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				Result := ({PC_CURLCODE}.CURLE_OK)
				l_return := True
			end
			if not l_return then
				l_separator := strchr (a_option, (':').code)
				if not l_separator.is_void then
					l_username_len := (l_separator.distance (a_option)).to_natural_32
					l_p := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([l_username_len + {NATURAL_32} 1]))))
					if l_p.is_void then
						l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
					else
						memcpy (create {CE_VOID_POINTER}.make_cast (l_p), create {CE_VOID_POINTER}.make_cast (a_option), l_username_len).do_nothing
						l_p[l_username_len.to_integer_32] := (('%/0/').code).to_integer_8
						Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_user_storage.item))
						a_user_storage.item := l_p
					end
					if l_result = {NATURAL_32} 0 then
						l_result := setstropt (a_pwd_storage, l_separator + 1)
					end
				else
					l_result := setstropt (a_user_storage, a_option)
				end
				Result := l_result
			end
		end

	Curl_mk_connc (a_type: INTEGER_32; a_amount: INTEGER_32): CE_POINTER [PD_CONNCACHE]
		local
			l_c: CE_POINTER [PD_CONNCACHE]
			l_default_amount: INTEGER_32
			l_max_amount: INTEGER_32
			l_return: BOOLEAN
		do
			l_max_amount := ({NATURAL_32} 2_147_483_647 // {PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32
			if a_type = 0 then
				if a_amount < 1 then
					l_default_amount := 5
				else
					l_default_amount := a_amount
				end
			elseif a_amount < 1 then
				l_default_amount := 10
			else
				l_default_amount := a_amount
			end
			if l_default_amount > l_max_amount then
				l_default_amount := l_max_amount
			end
			l_c := create {CE_CLASS_POINTER [PD_CONNCACHE]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_CONNCACHE}.make).structure_size.to_natural_32]))))
			if l_c.is_void then
				Result := (create {CE_CLASS_POINTER [PD_CONNCACHE]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_c.item.connects := create {CE_POINTER_POINTER [PD_CONNECTDATA]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([l_default_amount.to_natural_32, {PLATFORM}.Pointer_bytes.to_natural_32]))))
				if (l_c.item.connects).is_void then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_c)])
					Result := (create {CE_CLASS_POINTER [PD_CONNCACHE]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_c.item.num := l_default_amount
				Result := l_c
			end
		end

	Curl_ch_connc (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_c: CE_POINTER [PD_CONNCACHE]; a_newamount: INTEGER_32): NATURAL_32
		local
			l_newamount: INTEGER_32
			l_i: INTEGER_32
			l_newptr: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]
			l_max_amount: INTEGER_32
			l_return: BOOLEAN
		do
			l_newamount := a_newamount
			l_max_amount := ({NATURAL_32} 2_147_483_647 // {PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32
			if l_newamount < 1 then
				l_newamount := 1
			end
			if a_c.is_void then
				a_data.item.state.connc := Curl_mk_connc (0, l_newamount)
				if (a_data.item.state.connc).is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
				if not l_return then
					Result := ({PC_CURLCODE}.CURLE_OK)
					l_return := True
				end
			end
			if not l_return then
				if l_newamount < a_c.item.num then
					l_i := l_newamount
					from
					until
						not (l_i < a_c.item.num)
					loop
						Curl_disconnect (a_c.item.connects[l_i]).do_nothing
						l_i := l_i + 1
					end
					if a_data.item.state.lastconnect <= l_newamount then
						a_data.item.state.lastconnect := -1
					end
				end
				if l_newamount > 0 then
					if l_newamount > l_max_amount then
						l_newamount := l_max_amount
					end
					l_newptr := create {CE_POINTER_POINTER [PD_CONNECTDATA]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_crealloc.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (a_c.item.connects), (({PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32 * l_newamount.to_natural_32).to_natural_32]))))
					if l_newptr.is_void then
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						l_return := True
					end
					if not l_return then
						l_i := a_c.item.num
						from
						until
							not (l_i < l_newamount)
						loop
							l_newptr[l_i] := create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
							l_i := l_i + 1
						end
						a_c.item.connects := l_newptr
						a_c.item.num := l_newamount
					end
				end
			end
			if not l_return then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_open (a_curl: CE_POINTER [CE_POINTER [PD_SESSIONHANDLE]]): NATURAL_32
		local
			l_res: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_return: BOOLEAN
		do
			l_res := {PC_CURLCODE}.CURLE_OK
			l_data := create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_SESSIONHANDLE}.make).structure_size.to_natural_32]))))
			if l_data.is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				l_return := True
			end
			if not l_return then
				l_data.item.magic := {NATURAL_32} 3_235_830_701
				l_data.item.state.headerbuff := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(256).to_natural_32]))))
				if (l_data.item.state.headerbuff).is_void then
					l_res := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
				else
					l_data.item.Curl_easy_initHandleData
					l_res := (create {CE_CLASS_POINTER [PD_USERDEFINED]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set"))).item.Curl_init_userdefined
					l_data.item.state.headersize := (256).to_natural_32
					l_data.item.state.lastconnect := -1
					l_data.item.progress.flags := (l_data.item.progress.flags).bit_or (((1).bit_shift_left (4)))
					l_data.item.state.current_speed := (-1).to_integer_64
					l_data.item.wildcard.state := {PC_CURL_WILDCARD_STATES}.CURLWC_INIT
					l_data.item.wildcard.filelist := create {CE_CLASS_POINTER [PD_CURL_LLIST]}.make_shared (default_pointer)
					l_data.item.set.fnmatch := create {CE_ROUTINE}.make_shared (default_pointer)
				end
				if l_res.to_boolean then
					if (not (l_data.item.state.headerbuff).is_void) then
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_data.item.state.headerbuff)])
					end
					Curl_freeset (l_data);
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_data)])
					l_data := create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (default_pointer)
				else
					a_curl.item := l_data
				end
				Result := l_res
			end
		end

	Curl_setopt (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_option: NATURAL_32; a_param: CE_VA_LIST): NATURAL_32
		local
			l_param: CE_VA_LIST
			l_argptr: CE_POINTER [INTEGER_8]
			l_result: NATURAL_32
			l_bigsize: INTEGER_64
			l_use_cache: INTEGER_32
			l_tmp___24: CE_POINTER [INTEGER_8]
			l_postRedir: INTEGER_32
			l_tmp___28: INTEGER_32
			l_tmp___29: INTEGER_32
			l_p: CE_POINTER [INTEGER_8]
			l_tmp___31: INTEGER_64
			l_cl: CE_POINTER [PD_CURL_SLIST]
			l_auth: INTEGER_32
			l_tmp___46: INTEGER_32
			l_auth___0: INTEGER_32
			l_tmp___50: INTEGER_32
			l_set: CE_POINTER [PD_CURL_SHARE]
			l_curl_rtspreq: INTEGER_32
			l_rtspreq: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_param := a_param.twin
					l_result := {PC_CURLCODE}.CURLE_OK
					inspect a_option.to_integer_32 -- switch 1 head
					when 92 then l_pos := -1 + 1
					when 91 then l_pos := -1 + 2
					when 10083 then l_pos := -1 + 3
					when 10076 then l_pos := -1 + 4
					when 10077 then l_pos := -1 + 5
					when 71 then l_pos := -1 + 6
					when 75 then l_pos := -1 + 7
					when 74 then l_pos := -1 + 8
					when 41 then l_pos := -1 + 9
					when 42 then l_pos := -1 + 10
					when 43 then l_pos := -1 + 11
					when 44 then l_pos := -1 + 12
					when 45 then l_pos := -1 + 13
					when 46 then l_pos := -1 + 14
					when 54 then l_pos := -1 + 14
					when 69 then l_pos := -1 + 15
					when 110 then l_pos := -1 + 16
					when 112 then l_pos := -1 + 17
					when 178 then l_pos := -1 + 18
					when 48 then l_pos := -1 + 19
					when 50 then l_pos := -1 + 20
					when 138 then l_pos := -1 + 21
					when 51 then l_pos := -1 + 22
					when 10118 then l_pos := -1 + 23
					when 53 then l_pos := -1 + 24
					when 33 then l_pos := -1 + 25
					when 34 then l_pos := -1 + 26
					when 32 then l_pos := -1 + 27
					when 58 then l_pos := -1 + 28
					when 10102 then l_pos := -1 + 29
					when 52 then l_pos := -1 + 30
					when 105 then l_pos := -1 + 31
					when 68 then l_pos := -1 + 32
					when 161 then l_pos := -1 + 33
					when 47 then l_pos := -1 + 34
					when 10165 then l_pos := -1 + 35
					when 10015 then l_pos := -1 + 49
					when 60 then l_pos := -1 + 50
					when 30120 then l_pos := -1 + 51
					when 10024 then l_pos := -1 + 52
					when 10016 then l_pos := -1 + 53
					when 10018 then l_pos := -1 + 54
					when 10023 then l_pos := -1 + 55
					when 10104 then l_pos := -1 + 56
					when 10022 then l_pos := -1 + 57
					when 10031 then l_pos := -1 + 58
					when 10082 then l_pos := -1 + 59
					when 96 then l_pos := -1 + 60
					when 10135 then l_pos := -1 + 61
					when 80 then l_pos := -1 + 65
					when 84 then l_pos := -1 + 66
					when 107 then l_pos := -1 + 67
					when 10036 then l_pos := -1 + 68
					when 61 then l_pos := -1 + 69
					when 59 then l_pos := -1 + 70
					when 111 then l_pos := -1 + 71
					when 10004 then l_pos := -1 + 72
					when 101 then l_pos := -1 + 73
					when 166 then l_pos := -1 + 74
					when 10029 then l_pos := -1 + 79
					when 10010 then l_pos := -1 + 80
					when 10001 then l_pos := -1 + 81
					when 10017 then l_pos := -1 + 82
					when 106 then l_pos := -1 + 83
					when 85 then l_pos := -1 + 84
					when 188 then l_pos := -1 + 85
					when 154 then l_pos := -1 + 86
					when 137 then l_pos := -1 + 87
					when 10009 then l_pos := -1 + 88
					when 14 then l_pos := -1 + 89
					when 30115 then l_pos := -1 + 90
					when 19 then l_pos := -1 + 91
					when 30145 then l_pos := -1 + 92
					when 30146 then l_pos := -1 + 93
					when 20 then l_pos := -1 + 94
					when 10002 then l_pos := -1 + 95
					when 3 then l_pos := -1 + 96
					when 13 then l_pos := -1 + 97
					when 155 then l_pos := -1 + 98
					when 78 then l_pos := -1 + 99
					when 156 then l_pos := -1 + 100
					when 10005 then l_pos := -1 + 101
					when 10173 then l_pos := -1 + 102
					when 10174 then l_pos := -1 + 103
					when 10039 then l_pos := -1 + 104
					when 10093 then l_pos := -1 + 105
					when 10028 then l_pos := -1 + 106
					when 20056 then l_pos := -1 + 107
					when 10057 then l_pos := -1 + 108
					when 10006 then l_pos := -1 + 109
					when 10175 then l_pos := -1 + 110
					when 10176 then l_pos := -1 + 111
					when 10177 then l_pos := -1 + 112
					when 10007 then l_pos := -1 + 113
					when 21 then l_pos := -1 + 114
					when 30116 then l_pos := -1 + 115
					when 20094 then l_pos := -1 + 116
					when 10095 then l_pos := -1 + 117
					when 10037 then l_pos := -1 + 118
					when 20079 then l_pos := -1 + 119
					when 20011 then l_pos := -1 + 120
					when 20012 then l_pos := -1 + 121
					when 20167 then l_pos := -1 + 122
					when 10168 then l_pos := -1 + 123
					when 20142 then l_pos := -1 + 124
					when 20143 then l_pos := -1 + 125
					when 20144 then l_pos := -1 + 126
					when 20130 then l_pos := -1 + 127
					when 10131 then l_pos := -1 + 128
					when 10025 then l_pos := -1 + 129
					when 10086 then l_pos := -1 + 130
					when 10087 then l_pos := -1 + 131
					when 10088 then l_pos := -1 + 132
					when 10026 then l_pos := -1 + 133
					when 10089 then l_pos := -1 + 134
					when 90 then l_pos := -1 + 135
					when 27 then l_pos := -1 + 136
					when 10062 then l_pos := -1 + 137
					when 139 then l_pos := -1 + 138
					when 140 then l_pos := -1 + 139
					when 10063 then l_pos := -1 + 140
					when 64 then l_pos := -1 + 141
					when 81 then l_pos := -1 + 142
					when 10065 then l_pos := -1 + 143
					when 10097 then l_pos := -1 + 144
					when 10169 then l_pos := -1 + 145
					when 10170 then l_pos := -1 + 146
					when 10070 then l_pos := -1 + 147
					when 98 then l_pos := -1 + 148
					when 99 then l_pos := -1 + 149
					when 10100 then l_pos := -1 + 150
					when 10103 then l_pos := -1 + 151
					when 114 then l_pos := -1 + 152
					when 119 then l_pos := -1 + 153
					when 129 then l_pos := -1 + 154
					when 113 then l_pos := -1 + 155
					when 30117 then l_pos := -1 + 156
					when 121 then l_pos := -1 + 157
					when 10134 then l_pos := -1 + 158
					when 136 then l_pos := -1 + 159
					when 141 then l_pos := -1 + 160
					when 10147 then l_pos := -1 + 161
					when 20148 then l_pos := -1 + 162
					when 10149 then l_pos := -1 + 163
					when 20163 then l_pos := -1 + 164
					when 10164 then l_pos := -1 + 165
					when 150 then l_pos := -1 + 166
					when 157 then l_pos := -1 + 167
					when 158 then l_pos := -1 + 168
					when 159 then l_pos := -1 + 169
					when 160 then l_pos := -1 + 170
					when 171 then l_pos := -1 + 171
					when 181 then l_pos := -1 + 172
					when 182 then l_pos := -1 + 173
					when 10186 then l_pos := -1 + 174
					when 10187 then l_pos := -1 + 175
					when 189 then l_pos := -1 + 176
					when 10190 then l_pos := -1 + 190
					when 10191 then l_pos := -1 + 191
					when 10192 then l_pos := -1 + 192
					when 193 then l_pos := -1 + 193
					when 194 then l_pos := -1 + 194
					when 10195 then l_pos := -1 + 195
					when 20196 then l_pos := -1 + 196
					when 197 then l_pos := -1 + 197
					when 20198 then l_pos := -1 + 198
					when 20199 then l_pos := -1 + 199
					when 20200 then l_pos := -1 + 200
					when 10201 then l_pos := -1 + 201
					when 10202 then l_pos := -1 + 202
					else l_pos := -1 + 203
					end
				when 1 then -- switch 1, case 92
					a_data.item.set.dns_cache_timeout := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 2 then -- switch 1, case 91
					l_use_cache := (l_param.integer_32_item)
					a_data.item.set.global_dns_cache := (0 /= l_use_cache)
					l_pos := -1 + 204 -- switch 1; break
				when 3 then -- switch 1, case 10083
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (22)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 4 then -- switch 1, case 10076
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (24)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 5 then -- switch 1, case 10077
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (23)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 6 then -- switch 1, case 71
					l_result := Curl_ch_connc (a_data, a_data.item.state.connc, (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 7 then -- switch 1, case 75
					a_data.item.set.reuse_forbid := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 8 then -- switch 1, case 74
					a_data.item.set.reuse_fresh := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 9 then -- switch 1, case 41
					a_data.item.set.verbose := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 10 then -- switch 1, case 42
					a_data.item.set.include_header := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 11 then -- switch 1, case 43
					a_data.item.set.hide_progress := (0 /= (l_param.integer_32_item))
					if a_data.item.set.hide_progress then
						a_data.item.progress.flags := (a_data.item.progress.flags).bit_or (((1).bit_shift_left (4)))
					else
						a_data.item.progress.flags := (a_data.item.progress.flags).bit_and (((((1).bit_shift_left (4))).bit_not))
					end
					l_pos := -1 + 204 -- switch 1; break
				when 12 then -- switch 1, case 44
					a_data.item.set.opt_no_body := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 13 then -- switch 1, case 45
					a_data.item.set.http_fail_on_error := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 14 then -- switch 1, case 46 | switch 1, case 54
					a_data.item.set.upload := (0 /= (l_param.integer_32_item))
					if a_data.item.set.upload then
						a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_PUT
						a_data.item.set.opt_no_body := (0).to_boolean
					else
						a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_GET
					end
					l_pos := -1 + 204 -- switch 1; break
				when 15 then -- switch 1, case 69
					a_data.item.set.get_filetime := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 16 then -- switch 1, case 110
					a_data.item.set.ftp_create_missing_dirs := (l_param.integer_32_item).to_integer_32
					l_pos := -1 + 204 -- switch 1; break
				when 17 then -- switch 1, case 112
					a_data.item.set.server_response_timeout := (l_param.integer_32_item) * 1_000
					l_pos := -1 + 204 -- switch 1; break
				when 18 then -- switch 1, case 178
					a_data.item.set.tftp_blksize := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 19 then -- switch 1, case 48
					a_data.item.set.ftp_list_only := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 20 then -- switch 1, case 50
					a_data.item.set.ftp_append := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 21 then -- switch 1, case 138
					a_data.item.set.ftp_filemethod := (l_param.integer_32_item).to_natural_32
					l_pos := -1 + 204 -- switch 1; break
				when 22 then -- switch 1, case 51
					a_data.item.set.use_netrc := (l_param.integer_32_item).to_natural_32
					l_pos := -1 + 204 -- switch 1; break
				when 23 then -- switch 1, case 10118
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (14)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 24 then -- switch 1, case 53
					a_data.item.set.prefer_ascii := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 25 then -- switch 1, case 33
					a_data.item.set.timecondition := (l_param.integer_32_item).to_natural_32
					l_pos := -1 + 204 -- switch 1; break
				when 26 then -- switch 1, case 34
					a_data.item.set.timevalue := (l_param.integer_32_item)
					l_pos := -1 + 204 -- switch 1; break
				when 27 then -- switch 1, case 32
					a_data.item.set.ssl.version := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 28 then -- switch 1, case 58
					a_data.item.set.http_auto_referer := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 29 then -- switch 1, case 10102
					l_argptr := (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item))
					if (not l_argptr.is_void) then
						if not (l_argptr[0]).to_boolean then
							l_tmp___24 := ce_string ("identity")
						else
							l_tmp___24 := l_argptr
						end
					else
						l_tmp___24 := l_argptr
					end
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (6)), l_tmp___24)
					l_pos := -1 + 204 -- switch 1; break
				when 30 then -- switch 1, case 52
					a_data.item.set.http_follow_location := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 31 then -- switch 1, case 105
					a_data.item.set.http_disable_hostname_check_before_authentication := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 32 then -- switch 1, case 68
					a_data.item.set.maxredirs := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 33 then -- switch 1, case 161
					l_postRedir := (l_param.integer_32_item)
					if ((l_postRedir).bit_and (1)).to_boolean then
						l_tmp___28 := 1
					else
						l_tmp___28 := 0
					end
					a_data.item.set.post301 := l_tmp___28.to_boolean
					if ((l_postRedir).bit_and (2)).to_boolean then
						l_tmp___29 := 1
					else
						l_tmp___29 := 0
					end
					a_data.item.set.post302 := l_tmp___29.to_boolean
					l_pos := -1 + 204 -- switch 1; break
				when 34 then -- switch 1, case 47
					if (l_param.integer_32_item).to_boolean then
						a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_POST
						a_data.item.set.opt_no_body := (0).to_boolean
					else
						a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_GET
					end
					l_pos := -1 + 204 -- switch 1; break
				when 35 then -- switch 1, case 10165
					l_argptr := (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item))
					if (not l_argptr.is_void) then
						l_pos := -1 + 38 -- skip if block
					end
				when 36 then -- if:
						l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (15)), l_argptr)
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 38 then -- else:
						if a_data.item.set.postfieldsize /= -{INTEGER_64} 1 then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (15)), l_argptr)
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 41 then -- else:
						if not (a_data.item.set.postfieldsize < {INTEGER_64} 0) then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 44 then -- else:
						if {PLATFORM}.Integer_64_bytes.to_natural_32 = {PLATFORM}.Natural_32_bytes.to_natural_32 then
							l_pos := -1 + 47 -- skip if block
						end
				when 45 then -- if:
						if a_data.item.set.postfieldsize > {INTEGER_64} 4_294_967_295 then
							l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
						else
							l_pos := -1 + 47 -- goto _L
						end
				when 46 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 47 then -- else: | _L:
						setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (15)), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)).do_nothing
						if (a_data.item.set.postfieldsize).to_boolean then
							l_tmp___31 := a_data.item.set.postfieldsize
						else
							l_tmp___31 := (1).to_integer_64
						end
						l_p := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([l_tmp___31.to_natural_32]))))
						if l_p.is_void then
							l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
						else
							if (a_data.item.set.postfieldsize).to_boolean then
								memcpy (create {CE_VOID_POINTER}.make_cast (l_p), create {CE_VOID_POINTER}.make_cast (l_argptr), (a_data.item.set.postfieldsize).to_natural_32).do_nothing
							end
							a_data.item.set.str[15] := l_p
						end
				when 48 then -- if done | if done | if done
					a_data.item.set.postfields := create {CE_VOID_POINTER}.make_cast (a_data.item.set.str[15])
					a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_POST
					l_pos := -1 + 204 -- switch 1; break
				when 49 then -- switch 1, case 10015
					a_data.item.set.postfields := (create {CE_VOID_POINTER}.make_cast (l_param.pointer_item))
					setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (15)), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)).do_nothing
					a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_POST
					l_pos := -1 + 204 -- switch 1; break
				when 50 then -- switch 1, case 60
					l_bigsize := l_param.integer_32_item
					if a_data.item.set.postfieldsize < l_bigsize then
						if (a_data.item.set.postfields).is_equal (a_data.item.set.str[15]) then
							setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (15)), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)).do_nothing
							a_data.item.set.postfields := create {CE_VOID_POINTER}.make_shared (default_pointer)
						end
					end
					a_data.item.set.postfieldsize := l_bigsize
					l_pos := -1 + 204 -- switch 1; break
				when 51 then -- switch 1, case 30120
					l_bigsize := l_param.integer_64_item
					if a_data.item.set.postfieldsize < l_bigsize then
						if (a_data.item.set.postfields).is_equal (a_data.item.set.str[15]) then
							setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (15)), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)).do_nothing
							a_data.item.set.postfields := create {CE_VOID_POINTER}.make_shared (default_pointer)
						end
					end
					a_data.item.set.postfieldsize := l_bigsize
					l_pos := -1 + 204 -- switch 1; break
				when 52 then -- switch 1, case 10024
					a_data.item.set.httppost := (create {CE_CLASS_POINTER [PD_CURL_HTTPPOST]}.make_cast (l_param.pointer_item))
					a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_POST_FORM
					a_data.item.set.opt_no_body := (0).to_boolean
					l_pos := -1 + 204 -- switch 1; break
				when 53 then -- switch 1, case 10016
					if a_data.item.change.referer_alloc then
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_data.item.change.referer)])
						a_data.item.change.referer_alloc := (0).to_boolean
					end
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (18)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					a_data.item.change.referer := a_data.item.set.str[18]
					l_pos := -1 + 204 -- switch 1; break
				when 54 then -- switch 1, case 10018
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (25)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 55 then -- switch 1, case 10023
					a_data.item.set.headers := (create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 56 then -- switch 1, case 10104
					a_data.item.set.http200aliases := (create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 57 then -- switch 1, case 10022
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (2)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 58 then -- switch 1, case 10031
					l_argptr := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast (l_param.pointer_item)))
					if (not l_argptr.is_void) then
						l_cl := (create {P_SLIST_STATIC}).curl_slist_append (a_data.item.change.cookielist, l_argptr)
						if l_cl.is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							a_data.item.change.cookielist := l_cl
						end
					end
					l_pos := -1 + 204 -- switch 1; break
				when 59 then -- switch 1, case 10082
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (3)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					a_data.item.cookies := (create {P_COOKIE_STATIC}).Curl_cookie_init (a_data, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), a_data.item.cookies, a_data.item.set.cookiesession)
					l_pos := -1 + 204 -- switch 1; break
				when 60 then -- switch 1, case 96
					a_data.item.set.cookiesession := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 61 then -- switch 1, case 10135
					l_argptr := (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item))
					if l_argptr.is_void then
						l_pos := -1 + 204 -- switch 1; break
					end
				when 62 then
					if ((create {P_RAWSTR_STATIC}).Curl_raw_equal (l_argptr, ce_string ("ALL"))).to_boolean then
						(create {P_COOKIE_STATIC}).Curl_cookie_clearall (a_data.item.cookies)
						l_pos := -1 + 204 -- switch 1; break
					elseif ((create {P_RAWSTR_STATIC}).Curl_raw_equal (l_argptr, ce_string ("SESS"))).to_boolean then
						(create {P_COOKIE_STATIC}).Curl_cookie_clearsess (a_data.item.cookies)
						l_pos := -1 + 204 -- switch 1; break
					elseif ((create {P_RAWSTR_STATIC}).Curl_raw_equal (l_argptr, ce_string ("FLUSH"))).to_boolean then
						a_data.item.flush_cookies (0)
						l_pos := -1 + 204 -- switch 1; break
					end
				when 63 then
					if (a_data.item.cookies).is_void then
						a_data.item.cookies := (create {P_COOKIE_STATIC}).Curl_cookie_init (a_data, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_COOKIEINFO]}.make_shared (default_pointer), (1).to_boolean)
					end
					l_argptr := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_argptr]))
					if l_argptr.is_void then
						l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
						l_pos := -1 + 204 -- switch 1; break
					end
				when 64 then
					if ((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Set-Cookie:"), l_argptr, (strlen (ce_string ("Set-Cookie:"))))).to_boolean then
						(create {P_COOKIE_STATIC}).Curl_cookie_add (a_data, a_data.item.cookies, (1).to_boolean, l_argptr + 11, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)).do_nothing
					else
						(create {P_COOKIE_STATIC}).Curl_cookie_add (a_data, a_data.item.cookies, (0).to_boolean, l_argptr, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)).do_nothing
					end
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_argptr)])
					l_pos := -1 + 204 -- switch 1; break
				when 65 then -- switch 1, case 80
					if (l_param.integer_32_item).to_boolean then
						a_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_GET
						a_data.item.set.upload := (0).to_boolean
						a_data.item.set.opt_no_body := (0).to_boolean
					end
					l_pos := -1 + 204 -- switch 1; break
				when 66 then -- switch 1, case 84
					a_data.item.set.httpversion := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 67 then -- switch 1, case 107
					l_auth := (l_param.integer_32_item)
					if ((l_auth).bit_and (((1).bit_shift_left (4)).to_integer_32)).to_boolean then
						l_tmp___46 := 1
					else
						l_tmp___46 := 0
					end
					a_data.item.state.authhost.iestyle := l_tmp___46.to_boolean
					if ((l_auth).bit_and (((1).bit_shift_left (4)).to_integer_32)).to_boolean then
						l_auth := (l_auth).bit_or (((1).bit_shift_left (1)).to_integer_32)
						l_auth := (l_auth).bit_and (((((1).bit_shift_left (4))).bit_not).to_integer_32)
					end
					l_auth := (l_auth).bit_and (((((1).bit_shift_left (3))).bit_not).to_integer_32)
					l_auth := (l_auth).bit_and (((((1).bit_shift_left (2))).bit_not).to_integer_32)
					if not l_auth.to_boolean then
						Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
						l_return := True
					end
					if not l_return then
						a_data.item.set.httpauth := l_auth
					end
					l_pos := -1 + 204 -- switch 1; break
				when 68 then -- switch 1, case 10036
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (4)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 69 then -- switch 1, case 61
					a_data.item.set.tunnel_thru_httpproxy := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 70 then -- switch 1, case 59
					a_data.item.set.proxyport := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 71 then -- switch 1, case 111
					l_auth___0 := (l_param.integer_32_item)
					if ((l_auth___0).bit_and (((1).bit_shift_left (4)).to_integer_32)).to_boolean then
						l_tmp___50 := 1
					else
						l_tmp___50 := 0
					end
					a_data.item.state.authproxy.iestyle := l_tmp___50.to_boolean
					if ((l_auth___0).bit_and (((1).bit_shift_left (4)).to_integer_32)).to_boolean then
						l_auth___0 := (l_auth___0).bit_or (((1).bit_shift_left (1)).to_integer_32)
						l_auth___0 := (l_auth___0).bit_and (((((1).bit_shift_left (4))).bit_not).to_integer_32)
					end
					l_auth___0 := (l_auth___0).bit_and (((((1).bit_shift_left (3))).bit_not).to_integer_32)
					l_auth___0 := (l_auth___0).bit_and (((((1).bit_shift_left (2))).bit_not).to_integer_32)
					if not l_auth___0.to_boolean then
						Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
						l_return := True
					end
					if not l_return then
						a_data.item.set.proxyauth := l_auth___0
					end
					l_pos := -1 + 204 -- switch 1; break
				when 72 then -- switch 1, case 10004
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (16)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 73 then -- switch 1, case 101
					a_data.item.set.proxytype := (l_param.integer_32_item).to_natural_32
					l_pos := -1 + 204 -- switch 1; break
				when 74 then -- switch 1, case 166
					inspect (l_param.integer_32_item).to_integer_32 -- switch 2 head
					when 0 then l_pos := -1 + 75
					when 1 then l_pos := -1 + 76
					else l_pos := -1 + 77
					end
				when 75 then -- switch 2, case 0
					a_data.item.set.proxy_transfer_mode := (0).to_boolean
					l_pos := -1 + 78 -- switch 2; break
				when 76 then -- switch 2, case 1
					a_data.item.set.proxy_transfer_mode := (1).to_boolean
					l_pos := -1 + 78 -- switch 2; break
				when 77 then -- switch 2, default:
					l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
					l_pos := -1 + 78 -- switch 2; break
				when 78 then -- switch 2, done:
					l_pos := -1 + 204 -- switch 1; break
				when 79 then -- switch 1, case 10029
					a_data.item.set.writeheader := (create {CE_VOID_POINTER}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 80 then -- switch 1, case 10010
					a_data.item.set.errorbuffer := (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 81 then -- switch 1, case 10001
					a_data.item.set.out2 := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 82 then -- switch 1, case 10017
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (9)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					a_data.item.set.ftp_use_port := (not (a_data.item.set.str[9]).is_void)
					l_pos := -1 + 204 -- switch 1; break
				when 83 then -- switch 1, case 106
					a_data.item.set.ftp_use_eprt := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 84 then -- switch 1, case 85
					a_data.item.set.ftp_use_epsv := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 85 then -- switch 1, case 188
					a_data.item.set.ftp_use_pret := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 86 then -- switch 1, case 154
					a_data.item.set.ftp_ccc := (l_param.integer_32_item).to_natural_32
					l_pos := -1 + 204 -- switch 1; break
				when 87 then -- switch 1, case 137
					a_data.item.set.ftp_skip_ip := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 88 then -- switch 1, case 10009
					a_data.item.set.in := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 89 then -- switch 1, case 14
					a_data.item.set.infilesize := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 90 then -- switch 1, case 30115
					a_data.item.set.infilesize := l_param.integer_64_item
					l_pos := -1 + 204 -- switch 1; break
				when 91 then -- switch 1, case 19
					a_data.item.set.low_speed_limit := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 92 then -- switch 1, case 30145
					a_data.item.set.max_send_speed := l_param.integer_64_item
					l_pos := -1 + 204 -- switch 1; break
				when 93 then -- switch 1, case 30146
					a_data.item.set.max_recv_speed := l_param.integer_64_item
					l_pos := -1 + 204 -- switch 1; break
				when 94 then -- switch 1, case 20
					a_data.item.set.low_speed_time := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 95 then -- switch 1, case 10002
					if a_data.item.change.url_alloc then
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_data.item.change.url)])
						a_data.item.change.url_alloc := (0).to_boolean
					end
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (19)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					a_data.item.change.url := a_data.item.set.str[19]
					l_pos := -1 + 204 -- switch 1; break
				when 96 then -- switch 1, case 3
					a_data.item.set.use_port := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 97 then -- switch 1, case 13
					a_data.item.set.timeout := (l_param.integer_32_item) * 1_000
					l_pos := -1 + 204 -- switch 1; break
				when 98 then -- switch 1, case 155
					a_data.item.set.timeout := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 99 then -- switch 1, case 78
					a_data.item.set.connecttimeout := (l_param.integer_32_item) * 1_000
					l_pos := -1 + 204 -- switch 1; break
				when 100 then -- switch 1, case 156
					a_data.item.set.connecttimeout := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 101 then -- switch 1, case 10005
					l_result := setstropt_userpwd ((create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (28)), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (29)))
					l_pos := -1 + 204 -- switch 1; break
				when 102 then -- switch 1, case 10173
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (28)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 103 then -- switch 1, case 10174
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (29)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 104 then -- switch 1, case 10039
					a_data.item.set.postquote := (create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 105 then -- switch 1, case 10093
					a_data.item.set.prequote := (create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 106 then -- switch 1, case 10028
					a_data.item.set.quote := (create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 107 then -- switch 1, case 20056
					a_data.item.set.fprogress := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
					if (not (a_data.item.set.fprogress).is_void) then
						a_data.item.progress.callback := (1).to_boolean
					else
						a_data.item.progress.callback := (0).to_boolean
					end
					l_pos := -1 + 204 -- switch 1; break
				when 108 then -- switch 1, case 10057
					a_data.item.set.progress_client := (create {CE_VOID_POINTER}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 109 then -- switch 1, case 10006
					l_result := setstropt_userpwd ((create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (30)), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (31)))
					l_pos := -1 + 204 -- switch 1; break
				when 110 then -- switch 1, case 10175
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (30)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 111 then -- switch 1, case 10176
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (31)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 112 then -- switch 1, case 10177
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (32)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 113 then -- switch 1, case 10007
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (17)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 114 then -- switch 1, case 21
					a_data.item.set.set_resume_from := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 115 then -- switch 1, case 30116
					a_data.item.set.set_resume_from := l_param.integer_64_item
					l_pos := -1 + 204 -- switch 1; break
				when 116 then -- switch 1, case 20094
					a_data.item.set.fdebug := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 117 then -- switch 1, case 10095
					a_data.item.set.debugdata := (create {CE_VOID_POINTER}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 118 then -- switch 1, case 10037
					a_data.item.set.err := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (l_param.pointer_item))
					if (a_data.item.set.err).is_void then
						a_data.item.set.err := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))
					end
					l_pos := -1 + 204 -- switch 1; break
				when 119 then -- switch 1, case 20079
					a_data.item.set.fwrite_header := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 120 then -- switch 1, case 20011
					a_data.item.set.fwrite_func := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
					if (a_data.item.set.fwrite_func).is_void then
						a_data.item.set.is_fwrite_set := 0
						a_data.item.set.fwrite_func := (fwrite_address)
					else
						a_data.item.set.is_fwrite_set := 1
					end
					l_pos := -1 + 204 -- switch 1; break
				when 121 then -- switch 1, case 20012
					a_data.item.set.fread_func := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
					if (a_data.item.set.fread_func).is_void then
						a_data.item.set.is_fread_set := 0
						a_data.item.set.fread_func := (fread_address)
					else
						a_data.item.set.is_fread_set := 1
					end
					l_pos := -1 + 204 -- switch 1; break
				when 122 then -- switch 1, case 20167
					a_data.item.set.seek_func := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 123 then -- switch 1, case 10168
					a_data.item.set.seek_client := (create {CE_VOID_POINTER}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 124 then -- switch 1, case 20142
					a_data.item.set.convfromnetwork := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 125 then -- switch 1, case 20143
					a_data.item.set.convtonetwork := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 126 then -- switch 1, case 20144
					a_data.item.set.convfromutf8 := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 127 then -- switch 1, case 20130
					a_data.item.set.ioctl_func := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 128 then -- switch 1, case 10131
					a_data.item.set.ioctl_client := (create {CE_VOID_POINTER}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 129 then -- switch 1, case 10025
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (0)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 130 then -- switch 1, case 10086
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (1)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 131 then -- switch 1, case 10087
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (10)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 132 then -- switch 1, case 10088
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (12)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 133 then -- switch 1, case 10026
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (11)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 134 then -- switch 1, case 10089
					l_argptr := (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item))
					if (not l_argptr.is_void) then
						if (l_argptr[0]).to_boolean then
							l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
						end
					end
					l_pos := -1 + 204 -- switch 1; break
				when 135 then -- switch 1, case 90
					l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
					l_pos := -1 + 204 -- switch 1; break
				when 136 then -- switch 1, case 27
					a_data.item.set.crlf := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 137 then -- switch 1, case 10062
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (5)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 138 then -- switch 1, case 139
					a_data.item.set.localport := (l_param.integer_32_item).to_natural_16
					l_pos := -1 + 204 -- switch 1; break
				when 139 then -- switch 1, case 140
					a_data.item.set.localportrange := (l_param.integer_32_item).to_integer_32
					l_pos := -1 + 204 -- switch 1; break
				when 140 then -- switch 1, case 10063
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (13)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					a_data.item.set.krb := (not (a_data.item.set.str[13]).is_void)
					l_pos := -1 + 204 -- switch 1; break
				when 141 then -- switch 1, case 64
					a_data.item.set.ssl.verifypeer := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 142 then -- switch 1, case 81
					a_data.item.set.ssl.verifyhost := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 143 then -- switch 1, case 10065
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (21)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 144 then -- switch 1, case 10097
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (20)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 145 then -- switch 1, case 10169
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (26)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 146 then -- switch 1, case 10170
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (27)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 147 then -- switch 1, case 10070
					a_data.item.set.telnet_options := (create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 148 then -- switch 1, case 98
					a_data.item.set.buffer_size := l_param.integer_32_item
					if a_data.item.set.buffer_size > 16_383 then
						a_data.item.set.buffer_size := 0
					elseif a_data.item.set.buffer_size < 1 then
						a_data.item.set.buffer_size := 0
					end
					l_pos := -1 + 204 -- switch 1; break
				when 149 then -- switch 1, case 99
					a_data.item.set.no_signal := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 150 then -- switch 1, case 10100
					l_set := (create {CE_CLASS_POINTER [PD_CURL_SHARE]}.make_cast (l_param.pointer_item))
					if (not (a_data.item.share).is_void) then
						a_data.item.Curl_share_lock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_SHARE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
						if a_data.item.dns.hostcachetype = {NATURAL_32} 4 then
							a_data.item.dns.hostcache := create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (default_pointer)
							a_data.item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_NONE
						end
						if ((a_data.item.share).item.cookies).is_equal (a_data.item.cookies) then
							a_data.item.cookies := create {CE_CLASS_POINTER [PD_COOKIEINFO]}.make_shared (default_pointer)
						end
						(a_data.item.share).item.dirty := (a_data.item.share).item.dirty - (1).to_natural_32
						a_data.item.Curl_share_unlock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_SHARE).do_nothing
						a_data.item.share := create {CE_CLASS_POINTER [PD_CURL_SHARE]}.make_shared (default_pointer)
					end
					a_data.item.share := l_set
					if (not (a_data.item.share).is_void) then
						a_data.item.Curl_share_lock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_SHARE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing;
						(a_data.item.share).item.dirty := (a_data.item.share).item.dirty + (1).to_natural_32
						if (not ((a_data.item.share).item.hostcache).is_void) then
							if a_data.item.dns.hostcachetype = {NATURAL_32} 1 then
								(create {P_HASH_STATIC}).Curl_hash_destroy (a_data.item.dns.hostcache)
							end
							a_data.item.dns.hostcache := (a_data.item.share).item.hostcache
							a_data.item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_SHARED
						end
						if (not ((a_data.item.share).item.cookies).is_void) then
							if (not (a_data.item.cookies).is_void) then
								(create {P_COOKIE_STATIC}).Curl_cookie_cleanup (a_data.item.cookies)
							end
							a_data.item.cookies := (a_data.item.share).item.cookies
						end
						a_data.item.Curl_share_unlock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_SHARE).do_nothing
					end
					l_pos := -1 + 204 -- switch 1; break
				when 151 then -- switch 1, case 10103
					a_data.item.set.private_data := (create {CE_VOID_POINTER}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 152 then -- switch 1, case 114
					a_data.item.set.max_filesize := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 153 then -- switch 1, case 119
					a_data.item.set.ftp_ssl := (l_param.integer_32_item).to_natural_32
					l_pos := -1 + 204 -- switch 1; break
				when 154 then -- switch 1, case 129
					a_data.item.set.ftpsslauth := (l_param.integer_32_item).to_natural_32
					l_pos := -1 + 204 -- switch 1; break
				when 155 then -- switch 1, case 113
					a_data.item.set.ip_version := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 156 then -- switch 1, case 30117
					a_data.item.set.max_filesize := l_param.integer_64_item
					l_pos := -1 + 204 -- switch 1; break
				when 157 then -- switch 1, case 121
					a_data.item.set.tcp_nodelay := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 158 then -- switch 1, case 10134
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (7)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 159 then -- switch 1, case 136
					a_data.item.set.ignorecl := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 160 then -- switch 1, case 141
					a_data.item.set.connect_only := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 161 then -- switch 1, case 10147
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (8)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 162 then -- switch 1, case 20148
					a_data.item.set.fsockopt := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 163 then -- switch 1, case 10149
					a_data.item.set.sockopt_client := (create {CE_VOID_POINTER}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 164 then -- switch 1, case 20163
					a_data.item.set.fopensocket := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 165 then -- switch 1, case 10164
					a_data.item.set.opensocket_client := (create {CE_VOID_POINTER}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 166 then -- switch 1, case 150
					a_data.item.set.ssl.sessionid := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 167 then -- switch 1, case 157
					a_data.item.set.http_te_skip := (0 = (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 168 then -- switch 1, case 158
					a_data.item.set.http_ce_skip := (0 = (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 169 then -- switch 1, case 159
					a_data.item.set.new_file_perms := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 170 then -- switch 1, case 160
					a_data.item.set.new_directory_perms := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 171 then -- switch 1, case 171
					a_data.item.set.scope := (l_param.integer_32_item).to_natural_32
					l_pos := -1 + 204 -- switch 1; break
				when 172 then -- switch 1, case 181
					a_data.item.set.allowed_protocols := ((l_param.integer_32_item)).bit_and (67_108_863)
					l_pos := -1 + 204 -- switch 1; break
				when 173 then -- switch 1, case 182
					a_data.item.set.redir_protocols := ((l_param.integer_32_item)).bit_and (67_108_863)
					l_pos := -1 + 204 -- switch 1; break
				when 174 then -- switch 1, case 10186
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (36)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 175 then -- switch 1, case 10187
					a_data.item.set.mail_rcpt := (create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 176 then -- switch 1, case 189
					l_curl_rtspreq := (l_param.integer_32_item)
					l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_NONE
					inspect l_curl_rtspreq.to_integer_32 -- switch 3 head
					when 1 then l_pos := -1 + 177
					when 2 then l_pos := -1 + 178
					when 3 then l_pos := -1 + 179
					when 4 then l_pos := -1 + 180
					when 5 then l_pos := -1 + 181
					when 6 then l_pos := -1 + 182
					when 7 then l_pos := -1 + 183
					when 8 then l_pos := -1 + 184
					when 9 then l_pos := -1 + 185
					when 10 then l_pos := -1 + 186
					when 11 then l_pos := -1 + 187
					else l_pos := -1 + 188
					end
				when 177 then -- switch 3, case 1
					l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_OPTIONS
					l_pos := -1 + 189 -- switch 3; break
				when 178 then -- switch 3, case 2
					l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_DESCRIBE
					l_pos := -1 + 189 -- switch 3; break
				when 179 then -- switch 3, case 3
					l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_ANNOUNCE
					l_pos := -1 + 189 -- switch 3; break
				when 180 then -- switch 3, case 4
					l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_SETUP
					l_pos := -1 + 189 -- switch 3; break
				when 181 then -- switch 3, case 5
					l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_PLAY
					l_pos := -1 + 189 -- switch 3; break
				when 182 then -- switch 3, case 6
					l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_PAUSE
					l_pos := -1 + 189 -- switch 3; break
				when 183 then -- switch 3, case 7
					l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_TEARDOWN
					l_pos := -1 + 189 -- switch 3; break
				when 184 then -- switch 3, case 8
					l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_GET_PARAMETER
					l_pos := -1 + 189 -- switch 3; break
				when 185 then -- switch 3, case 9
					l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_SET_PARAMETER
					l_pos := -1 + 189 -- switch 3; break
				when 186 then -- switch 3, case 10
					l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_RECORD
					l_pos := -1 + 189 -- switch 3; break
				when 187 then -- switch 3, case 11
					l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_RECEIVE
					l_pos := -1 + 189 -- switch 3; break
				when 188 then -- switch 3, default:
					l_rtspreq := {PC_CURL_RTSPREQ}.RTSPREQ_NONE
				when 189 then -- switch 3, done:
					a_data.item.set.rtspreq := l_rtspreq
					l_pos := -1 + 204 -- switch 1; break
				when 190 then -- switch 1, case 10190
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (33)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 191 then -- switch 1, case 10191
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (34)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 192 then -- switch 1, case 10192
					l_result := setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (35)), (create {CE_INTEGER_8_POINTER}.make_cast (l_param.pointer_item)))
					l_pos := -1 + 204 -- switch 1; break
				when 193 then -- switch 1, case 193
					a_data.item.state.rtsp_next_client_CSeq := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 194 then -- switch 1, case 194
					a_data.item.state.rtsp_next_client_CSeq := l_param.integer_32_item
					l_pos := -1 + 204 -- switch 1; break
				when 195 then -- switch 1, case 10195
					a_data.item.set.rtp_out := (create {CE_VOID_POINTER}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 196 then -- switch 1, case 20196
					a_data.item.set.fwrite_rtp := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 197 then -- switch 1, case 197
					a_data.item.set.wildcardmatch := (0 /= (l_param.integer_32_item))
					l_pos := -1 + 204 -- switch 1; break
				when 198 then -- switch 1, case 20198
					a_data.item.set.chunk_bgn := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 199 then -- switch 1, case 20199
					a_data.item.set.chunk_end := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 200 then -- switch 1, case 20200
					a_data.item.set.fnmatch := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 201 then -- switch 1, case 10201
					a_data.item.wildcard.customptr := (create {CE_VOID_POINTER}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 202 then -- switch 1, case 10202
					a_data.item.set.fnmatch_data := (create {CE_VOID_POINTER}.make_cast (l_param.pointer_item))
					l_pos := -1 + 204 -- switch 1; break
				when 203 then -- switch 1, default:
					l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
					l_pos := -1 + 204 -- switch 1; break
				when 204 then -- switch 1, done:
					if not l_return then
						Result := l_result
					end
				when 205 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	conn_free (a_conn: CE_POINTER [PD_CONNECTDATA])
		local
			l_return: BOOLEAN
		do
			if a_conn.is_void then
				l_return := True
			end
			if not l_return then
				if -1 /= a_conn.item.sock[1] then
					close (a_conn.item.sock[1]).do_nothing
				end
				if -1 /= a_conn.item.sock[0] then
					close (a_conn.item.sock[0]).do_nothing
				end
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.user))
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.passwd))
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.proxyuser))
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.proxypasswd))
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.allocptr.proxyuserpwd))
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.allocptr.uagent))
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.allocptr.userpwd))
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.allocptr.accept_encoding))
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.allocptr.rangeline))
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.allocptr.ref))
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.allocptr.host))
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.allocptr.cookiehost))
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.allocptr.rtsp_transport))
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.trailer))
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.host.rawalloc))
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.proxy.rawalloc))
				Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.master_buffer));
				(create {P_LLIST_STATIC}).Curl_llist_destroy (a_conn.item.send_pipe, create {CE_VOID_POINTER}.make_shared (default_pointer));
				(create {P_LLIST_STATIC}).Curl_llist_destroy (a_conn.item.recv_pipe, create {CE_VOID_POINTER}.make_shared (default_pointer));
				(create {P_LLIST_STATIC}).Curl_llist_destroy (a_conn.item.pend_pipe, create {CE_VOID_POINTER}.make_shared (default_pointer));
				(create {P_LLIST_STATIC}).Curl_llist_destroy (a_conn.item.done_pipe, create {CE_VOID_POINTER}.make_shared (default_pointer));
				(create {CE_CLASS_POINTER [PD_SSL_CONFIG_DATA]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("ssl_config"))).item.Curl_free_ssl_config;
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_conn)])
			end
		end

	Curl_disconnect (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_has_host_ntlm: INTEGER_32
			l_has_proxy_ntlm: INTEGER_32
			l_return: BOOLEAN
		do
			if a_conn.is_void then
				Result := ({PC_CURLCODE}.CURLE_OK)
				l_return := True
			end
			if not l_return then
				l_data := a_conn.item.data
				if l_data.is_void then
					Result := ({PC_CURLCODE}.CURLE_OK)
					l_return := True
				end
			end
			if not l_return then
				if not (a_conn.item.dns_entry).is_void then
					l_data.item.Curl_resolv_unlock (a_conn.item.dns_entry)
					a_conn.item.dns_entry := create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer)
				end
				l_data.item.Curl_hostcache_prune
				l_has_host_ntlm := (a_conn.item.ntlm.state /= {NATURAL_32} 0).to_integer
				l_has_proxy_ntlm := (a_conn.item.proxyntlm.state /= {NATURAL_32} 0).to_integer
				if l_has_host_ntlm.to_boolean then
					l_data.item.state.authhost.done := (0).to_boolean
					l_data.item.state.authhost.picked := l_data.item.state.authhost.want
				end
				if l_has_proxy_ntlm.to_boolean then
					l_data.item.state.authproxy.done := (0).to_boolean
					l_data.item.state.authproxy.picked := l_data.item.state.authproxy.want
				end
				if l_has_host_ntlm.to_boolean then
					l_data.item.state.authproblem := (0).to_boolean
				elseif l_has_proxy_ntlm.to_boolean then
					l_data.item.state.authproblem := (0).to_boolean
				end
				if (not (l_data.item.req.newurl).is_void) then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_data.item.req.newurl)])
					l_data.item.req.newurl := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				end
				if (not ((a_conn.item.handler).item.disconnect).is_void) then
					((a_conn.item.handler).item.disconnect).call ([a_conn])
				end
				if -1 /= a_conn.item.connectindex then
					(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Closing connection #%%ld%N"), a_conn.item.connectindex])
					if (not (l_data.item.state.connc).is_void) then
						(l_data.item.state.connc).item.connects[a_conn.item.connectindex] := create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
					end
				end
				if (l_data.item.Curl_isPipeliningEnabled) then
					signalPipeClose (a_conn.item.send_pipe, (1).to_boolean)
					signalPipeClose (a_conn.item.recv_pipe, (1).to_boolean)
					signalPipeClose (a_conn.item.pend_pipe, (1).to_boolean)
					signalPipeClose (a_conn.item.done_pipe, (0).to_boolean)
				end
				conn_free (a_conn)
				l_data.item.state.current_conn := create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_removeHandleFromPipeline (a_handle: CE_POINTER [PD_SESSIONHANDLE]; a_pipeline: CE_POINTER [PD_CURL_LLIST]): INTEGER_32
		require
			not a_pipeline.is_void
		local
			l_curr: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_return: BOOLEAN
		do
			l_curr := a_pipeline.item.head
			from
			until
				not (not (l_return) and then (not l_curr.is_void))
			loop
				if (l_curr.item.ptr).is_equal (a_handle) then
					a_pipeline.item.Curl_llist_remove (l_curr, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
					Result := 1
					l_return := True
				end
				if not l_return then
					l_curr := l_curr.item.next
				end
			end
			if not l_return then
				Result := 0
			end
		end

	Curl_getoff_all_pipelines (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA])
		require
			not a_conn.is_void
		local
			l_recv_head: BOOLEAN
			l_tmp___0: INTEGER_32
			l_send_head: BOOLEAN
			l_tmp___2: INTEGER_32
		do
			if a_conn.item.readchannel_inuse then
				if ((a_conn.item.recv_pipe).item.gethandleathead).is_equal (a_data) then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			l_recv_head := l_tmp___0.to_boolean
			if a_conn.item.writechannel_inuse then
				if ((a_conn.item.send_pipe).item.gethandleathead).is_equal (a_data) then
					l_tmp___2 := 1
				else
					l_tmp___2 := 0
				end
			else
				l_tmp___2 := 0
			end
			l_send_head := l_tmp___2.to_boolean
			if (Curl_removeHandleFromPipeline (a_data, a_conn.item.recv_pipe)).to_boolean then
				if l_recv_head then
					a_conn.item.readchannel_inuse := (0).to_boolean
				end
			end
			if (Curl_removeHandleFromPipeline (a_data, a_conn.item.send_pipe)).to_boolean then
				if l_send_head then
					a_conn.item.writechannel_inuse := (0).to_boolean
				end
			end
			Curl_removeHandleFromPipeline (a_data, a_conn.item.pend_pipe).do_nothing
			Curl_removeHandleFromPipeline (a_data, a_conn.item.done_pipe).do_nothing
		end

	signalPipeClose (a_pipeline: CE_POINTER [PD_CURL_LLIST]; a_pipe_broke: BOOLEAN)
		local
			l_curr: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_next: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_return: BOOLEAN
		do
			if a_pipeline.is_void then
				l_return := True
			end
			if not l_return then
				l_curr := a_pipeline.item.head
				from
				until
					l_curr.is_void
				loop
					l_next := l_curr.item.next
					l_data := create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_cast (l_curr.item.ptr)
					if a_pipe_broke then
						l_data.item.state.pipe_broke := (1).to_boolean
					end
					l_data.item.Curl_multi_handlePipeBreak
					a_pipeline.item.Curl_llist_remove (l_curr, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
					l_curr := l_next
				end
			end
		end

	llist_dtor (a_user, a_element: CE_POINTER [ANY])
		do
		end

	check_noproxy (a_name, a_no_proxy: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_tok_start: NATURAL_32
			l_tok_end: NATURAL_32
			l_separator: CE_POINTER [INTEGER_8]
			l_no_proxy_len: NATURAL_32
			l_namelen: NATURAL_32
			l_endptr: CE_POINTER [INTEGER_8]
			l_checkn: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			l_separator := ce_string (", ")
			if (not a_no_proxy.is_void) then
				if (a_no_proxy[0]).to_boolean then
					if ((create {P_RAWSTR_STATIC}).Curl_raw_equal (ce_string ("*"), a_no_proxy)).to_boolean then
						Result := (1).to_boolean
						l_return := True
					end
					if not l_return then
						l_no_proxy_len := strlen (a_no_proxy)
						l_endptr := strchr (a_name, (':').code)
						if (not l_endptr.is_void) then
							l_namelen := (l_endptr.distance (a_name)).to_natural_32
						else
							l_namelen := strlen (a_name)
						end
						l_tok_start := (0).to_natural_32
						from
						until
							not (not (l_return or l_break) and then (l_tok_start < l_no_proxy_len))
						loop
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								if l_tok_start < l_no_proxy_len then
									if (strchr (l_separator, (a_no_proxy[l_tok_start.to_integer_32]).to_integer_32)).is_void then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_tok_start := l_tok_start + 1
								end
							end
							l_break := False
							if l_tok_start = l_no_proxy_len then
								l_break := True
							end
							if not (l_return or l_break) then
								l_tok_end := l_tok_start
								from
								until
									(l_break)
								loop
									l_break := False
									if l_tok_end < l_no_proxy_len then
										if not ((strchr (l_separator, (a_no_proxy[l_tok_end.to_integer_32]).to_integer_32)).is_void) then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_tok_end := l_tok_end + 1
									end
								end
								l_break := False
								if (a_no_proxy[l_tok_start.to_integer_32]).to_integer_32 = 46 then
									l_tok_start := l_tok_start + 1
								end
								if l_tok_end - l_tok_start <= l_namelen then
									l_checkn := (a_name + l_namelen.to_integer_32) - (l_tok_end - l_tok_start).to_integer_32
									if ((create {P_RAWSTR_STATIC}).Curl_raw_nequal (a_no_proxy + l_tok_start.to_integer_32, l_checkn, l_tok_end - l_tok_start)).to_boolean then
										if l_tok_end - l_tok_start = l_namelen then
											Result := (1).to_boolean
											l_return := True
										elseif (l_checkn[-1]).to_integer_32 = 46 then
											Result := (1).to_boolean
											l_return := True
										end
									end
								end
								if not l_return then
									l_tok_start := l_tok_end + {NATURAL_32} 1
								end
							end
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := (0).to_boolean
			end
		end

	Curl_async_resolved (a_conn: CE_POINTER [PD_CONNECTDATA]; a_protocol_done: CE_POINTER [BOOLEAN]): NATURAL_32
		do
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	Curl_done (a_connp: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]; a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
		require
			not a_connp.is_void
		local
			l_result: NATURAL_32
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_res2: NATURAL_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_conn := a_connp.item
					l_data := l_conn.item.data
					if l_conn.item.bits.done then
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
					end
					if not l_return then
						Curl_getoff_all_pipelines (l_data, l_conn)
						if (l_conn.item.send_pipe).item.size + (l_conn.item.recv_pipe).item.size /= {NATURAL_32} 0 then
							if not l_data.item.set.reuse_forbid then
								if not l_conn.item.bits.close then
									Result := ({PC_CURLCODE}.CURLE_OK)
									l_return := True
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_conn.item.bits.done := (1).to_boolean
						if (not (l_data.item.req.newurl).is_void) then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_data.item.req.newurl)])
							l_data.item.req.newurl := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						end
						if (not (l_data.item.req.location).is_void) then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_data.item.req.location)])
							l_data.item.req.location := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						end
						if (not (l_conn.item.dns_entry).is_void) then
							l_data.item.Curl_resolv_unlock (l_conn.item.dns_entry)
							l_conn.item.dns_entry := create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer)
						end
						if (not ((l_conn.item.handler).item.done).is_void) then
							l_result := ((l_conn.item.handler).item.done).natural_32_item ([l_conn, a_status, a_premature])
						else
							l_result := {PC_CURLCODE}.CURLE_OK
						end
						l_conn.item.Curl_pgrsDone
						if (not (l_data.item.state.tempwrite).is_void) then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_data.item.state.tempwrite)])
							l_data.item.state.tempwrite := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						end
						if not (l_data.item.set.reuse_forbid) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						if not (l_conn.item.bits.close) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else:
						if not a_premature then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if -1 /= l_conn.item.connectindex then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if: | _L:
						l_res2 := (Curl_disconnect (l_conn))
						if not l_result.to_boolean then
							if l_res2.to_boolean then
								l_result := l_res2
							end
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						l_conn.item.ConnectionDone
						l_data.item.state.lastconnect := l_conn.item.connectindex
						if l_conn.item.bits.httpproxy then
							l_tmp___0 := l_conn.item.proxy.dispname
						else
							l_tmp___0 := l_conn.item.host.dispname
						end
						(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Connection #%%ld to host %%s left intact%N"), l_conn.item.connectindex, l_tmp___0])
				when 14 then -- if done | if done | if done
						a_connp.item := create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
						Result := l_result
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_do (a_connp: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_connp.is_void
		local
			l_result: NATURAL_32
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_conn := a_connp.item
			l_data := l_conn.item.data
			l_conn.item.do_init.do_nothing
			if (not ((l_conn.item.handler).item.do_it).is_void) then
				l_result := ((l_conn.item.handler).item.do_it).natural_32_item ([l_conn, a_done])
				if {NATURAL_32} 55 = l_result then
					if l_conn.item.bits.reuse then
						if (l_data.item.multi).is_void then
							l_result := (create {P_TRANSFER_STATIC}).Curl_reconnect_request (a_connp)
							if l_result = {NATURAL_32} 0 then
								l_result := ((l_conn.item.handler).item.do_it).natural_32_item ([l_conn, a_done])
							end
						else
							Result := l_result
							l_return := True
						end
					end
				end
				if not l_return and then (l_result = {NATURAL_32} 0) then
					if a_done.item then
						l_conn.item.do_complete
					end
				end
			end
			if not l_return then
				Result := l_result
			end
		end

feature {ANY} -- routine addresses

	llist_dtor_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent llist_dtor)
		end

end
