class
	P_VERSION_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC

feature {ANY} -- public attributes

	version: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<200>>)
		end

	protocols___0: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("dict"),
					ce_string ("file"),
					ce_string ("ftp"),
					ce_string ("gopher"),
					ce_string ("http"),
					ce_string ("imap"),
					ce_string ("pop3"),
					ce_string ("rtsp"),
					ce_string ("smtp"),
					ce_string ("telnet"),
					ce_string ("tftp"),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				>>)
		end

	version_info: CE_STATIC [CE_ARRAY [PD_CURL_VERSION_INFO_DATA]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_VERSION_INFO_DATA]}.make_initialized (<<
					create {PD_CURL_VERSION_INFO_DATA}.make_initialized ([{PC_CURLVERSION}.CURLVERSION_FOURTH, ce_string ("7.21.2"), {NATURAL_32} 464_130, ce_string ("i686-pc-linux-gnu"), 1, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), 0, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), protocols___0.item, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), 0, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), 0, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)])
				>>)
		end

feature {ANY} -- public routines

	curl_version: CE_POINTER [INTEGER_8]
		local
			l_ptr: CE_POINTER [INTEGER_8]
			l_len: NATURAL_32
			l_left: NATURAL_32
		do
			l_ptr := version.item
			l_left := ({PLATFORM}.Integer_8_bytes.to_natural_32 * (200).to_natural_32)
			strcpy (l_ptr, ce_string ("libcurl/7.21.2")).do_nothing
			l_len := strlen (l_ptr)
			l_left := l_left - l_len
			l_ptr := l_ptr + l_len.to_integer_32
			if l_left > {NATURAL_32} 1 then
				l_len := (0).to_natural_32
				if l_len > {NATURAL_32} 0 then
					l_ptr[0] := ((' ').code).to_integer_8
					l_len := l_len + 1
					l_left := l_left - l_len
					l_ptr := l_ptr + l_len.to_integer_32
				end
			end
			Result := version.item
		end

	curl_version_info (a_stamp: NATURAL_32): CE_POINTER [PD_CURL_VERSION_INFO_DATA]
		do
			Result := version_info.item
		end

end
