class
	PD_CURL_CERTINFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_POINTER_POINTER [PD_CURL_SLIST]} certinfo.make
		end

feature {ANY} -- fields

	num_of_certs: INTEGER_32 assign set_num_of_certs

	certinfo: CE_POINTER [CE_POINTER [PD_CURL_SLIST]] assign set_certinfo

feature {ANY} -- field setters

	set_num_of_certs (a_num_of_certs: INTEGER_32)
		do
			num_of_certs := a_num_of_certs
			update_memory_field ("num_of_certs")
		end

	set_certinfo (a_certinfo: CE_POINTER [CE_POINTER [PD_CURL_SLIST]])
		do
			certinfo := a_certinfo
			update_memory_field ("certinfo")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			num_of_certs := a_other.num_of_certs
			certinfo := a_other.certinfo
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				num_of_certs = a_other.num_of_certs and
				certinfo.is_equal (a_other.certinfo)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("num_of_certs"),
					create {CE_STRUCTURE_FIELD}.make ("certinfo")
				>>)
			init_structure_info
		end

end
