class
	PD_CURL_DNS_ENTRY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_CURL_ADDRINFO]} addr.make
		end

feature {ANY} -- fields

	addr: CE_POINTER [PD_CURL_ADDRINFO] assign set_addr

	timestamp: INTEGER_32 assign set_timestamp

	inuse: INTEGER_32 assign set_inuse

feature {ANY} -- field setters

	set_addr (a_addr: CE_POINTER [PD_CURL_ADDRINFO])
		do
			addr := a_addr
			update_memory_field ("addr")
		end

	set_timestamp (a_timestamp: INTEGER_32)
		do
			timestamp := a_timestamp
			update_memory_field ("timestamp")
		end

	set_inuse (a_inuse: INTEGER_32)
		do
			inuse := a_inuse
			update_memory_field ("inuse")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			addr := a_other.addr
			timestamp := a_other.timestamp
			inuse := a_other.inuse
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				addr.is_equal (a_other.addr) and
				timestamp = a_other.timestamp and
				inuse = a_other.inuse
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("addr"),
					create {CE_STRUCTURE_FIELD}.make ("timestamp"),
					create {CE_STRUCTURE_FIELD}.make ("inuse")
				>>)
			init_structure_info
		end

end
