class
	PD_CURL_SEND_BUFFER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} buffer.make
		end

feature {ANY} -- fields

	buffer: CE_POINTER [INTEGER_8] assign set_buffer

	size_max: NATURAL_32 assign set_size_max

	size_used: NATURAL_32 assign set_size_used

feature {ANY} -- field setters

	set_buffer (a_buffer: CE_POINTER [INTEGER_8])
		do
			buffer := a_buffer
			update_memory_field ("buffer")
		end

	set_size_max (a_size_max: NATURAL_32)
		do
			size_max := a_size_max
			update_memory_field ("size_max")
		end

	set_size_used (a_size_used: NATURAL_32)
		do
			size_used := a_size_used
			update_memory_field ("size_used")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			buffer := a_other.buffer
			size_max := a_other.size_max
			size_used := a_other.size_used
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				buffer.is_equal (a_other.buffer) and
				size_max = a_other.size_max and
				size_used = a_other.size_used
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("buffer"),
					create {CE_STRUCTURE_FIELD}.make ("size_max"),
					create {CE_STRUCTURE_FIELD}.make ("size_used")
				>>)
			init_structure_info
		end

end
