class
	PD_CURL_SH_ENTRY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_SESSIONHANDLE]} easy.make
			create {CE_VOID_POINTER} socketp.make
		end

feature {ANY} -- fields

	easy: CE_POINTER [PD_SESSIONHANDLE] assign set_easy

	timestamp: INTEGER_32 assign set_timestamp

	action: INTEGER_32 assign set_action

	socket: INTEGER_32 assign set_socket

	socketp: CE_POINTER [ANY] assign set_socketp

feature {ANY} -- field setters

	set_easy (a_easy: CE_POINTER [PD_SESSIONHANDLE])
		do
			easy := a_easy
			update_memory_field ("easy")
		end

	set_timestamp (a_timestamp: INTEGER_32)
		do
			timestamp := a_timestamp
			update_memory_field ("timestamp")
		end

	set_action (a_action: INTEGER_32)
		do
			action := a_action
			update_memory_field ("action")
		end

	set_socket (a_socket: INTEGER_32)
		do
			socket := a_socket
			update_memory_field ("socket")
		end

	set_socketp (a_socketp: CE_POINTER [ANY])
		do
			socketp := a_socketp
			update_memory_field ("socketp")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			easy := a_other.easy
			timestamp := a_other.timestamp
			action := a_other.action
			socket := a_other.socket
			socketp := a_other.socketp
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				easy.is_equal (a_other.easy) and
				timestamp = a_other.timestamp and
				action = a_other.action and
				socket = a_other.socket and
				socketp.is_equal (a_other.socketp)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("easy"),
					create {CE_STRUCTURE_FIELD}.make ("timestamp"),
					create {CE_STRUCTURE_FIELD}.make ("action"),
					create {CE_STRUCTURE_FIELD}.make ("socket"),
					create {CE_STRUCTURE_FIELD}.make ("socketp")
				>>)
			init_structure_info
		end

end
