class
	PD_CURL_SSL_SESSION

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} name.make
			create {CE_VOID_POINTER} sessionid.make
			create ssl_config.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	sessionid: CE_POINTER [ANY] assign set_sessionid

	idsize: NATURAL_32 assign set_idsize

	age: INTEGER_32 assign set_age

	remote_port: NATURAL_16 assign set_remote_port

	ssl_config: PD_SSL_CONFIG_DATA assign set_ssl_config

feature {ANY} -- field setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_sessionid (a_sessionid: CE_POINTER [ANY])
		do
			sessionid := a_sessionid
			update_memory_field ("sessionid")
		end

	set_idsize (a_idsize: NATURAL_32)
		do
			idsize := a_idsize
			update_memory_field ("idsize")
		end

	set_age (a_age: INTEGER_32)
		do
			age := a_age
			update_memory_field ("age")
		end

	set_remote_port (a_remote_port: NATURAL_16)
		do
			remote_port := a_remote_port
			update_memory_field ("remote_port")
		end

	set_ssl_config (a_ssl_config: PD_SSL_CONFIG_DATA)
		do
			ssl_config := a_ssl_config
			update_memory_field ("ssl_config")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			sessionid := a_other.sessionid
			idsize := a_other.idsize
			age := a_other.age
			remote_port := a_other.remote_port
			ssl_config := a_other.ssl_config.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				sessionid.is_equal (a_other.sessionid) and
				idsize = a_other.idsize and
				age = a_other.age and
				remote_port = a_other.remote_port and
				ssl_config.is_equal (a_other.ssl_config)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("sessionid"),
					create {CE_STRUCTURE_FIELD}.make ("idsize"),
					create {CE_STRUCTURE_FIELD}.make ("age"),
					create {CE_STRUCTURE_FIELD}.make ("remote_port"),
					create {CE_STRUCTURE_FIELD}.make ("ssl_config")
				>>)
			init_structure_info
		end

end
