class
	PD_FORMDATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_FORMDATA]} next.make
			create {CE_INTEGER_8_POINTER} line.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_FORMDATA] assign set_next

	type: NATURAL_32 assign set_type

	line: CE_POINTER [INTEGER_8] assign set_line

	length: NATURAL_32 assign set_length

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_FORMDATA])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_type (a_type: NATURAL_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_line (a_line: CE_POINTER [INTEGER_8])
		do
			line := a_line
			update_memory_field ("line")
		end

	set_length (a_length: NATURAL_32)
		do
			length := a_length
			update_memory_field ("length")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			type := a_other.type
			line := a_other.line
			length := a_other.length
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				type = a_other.type and
				line.is_equal (a_other.line) and
				length = a_other.length
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("line"),
					create {CE_STRUCTURE_FIELD}.make ("length")
				>>)
			init_structure_info
		end

end
