class
	PD_FTP_PARSELIST_DATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create state.make
			create {CE_CLASS_POINTER [PD_CURL_FILEINFO]} file_data.make
			create offsets.make
		end

feature {ANY} -- fields

	os_type: NATURAL_32 assign set_os_type

	state: PD_STATE assign set_state

	error: NATURAL_32 assign set_error

	file_data: CE_POINTER [PD_CURL_FILEINFO] assign set_file_data

	item_length: NATURAL_32 assign set_item_length

	item_offset: NATURAL_32 assign set_item_offset

	offsets: PD_OFFSETS assign set_offsets

feature {ANY} -- field setters

	set_os_type (a_os_type: NATURAL_32)
		do
			os_type := a_os_type
			update_memory_field ("os_type")
		end

	set_state (a_state: PD_STATE)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_error (a_error: NATURAL_32)
		do
			error := a_error
			update_memory_field ("error")
		end

	set_file_data (a_file_data: CE_POINTER [PD_CURL_FILEINFO])
		do
			file_data := a_file_data
			update_memory_field ("file_data")
		end

	set_item_length (a_item_length: NATURAL_32)
		do
			item_length := a_item_length
			update_memory_field ("item_length")
		end

	set_item_offset (a_item_offset: NATURAL_32)
		do
			item_offset := a_item_offset
			update_memory_field ("item_offset")
		end

	set_offsets (a_offsets: PD_OFFSETS)
		do
			offsets := a_offsets
			update_memory_field ("offsets")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			os_type := a_other.os_type
			state := a_other.state.twin
			error := a_other.error
			file_data := a_other.file_data
			item_length := a_other.item_length
			item_offset := a_other.item_offset
			offsets := a_other.offsets.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				os_type = a_other.os_type and
				state.is_equal (a_other.state) and
				error = a_other.error and
				file_data.is_equal (a_other.file_data) and
				item_length = a_other.item_length and
				item_offset = a_other.item_offset and
				offsets.is_equal (a_other.offsets)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("os_type"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("error"),
					create {CE_STRUCTURE_FIELD}.make ("file_data"),
					create {CE_STRUCTURE_FIELD}.make ("item_length"),
					create {CE_STRUCTURE_FIELD}.make ("item_offset"),
					create {CE_STRUCTURE_FIELD}.make ("offsets")
				>>)
			init_structure_info
		end

end
