class
	PD_HTTP

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_FORMDATA]} sendit.make
			create {CE_INTEGER_8_POINTER} postdata.make
			create {CE_INTEGER_8_POINTER} p_pragma.make
			create {CE_INTEGER_8_POINTER} p_accept.make
			create form.make
			create backup.make
			create {CE_VOID_POINTER} send_buffer.make
		end

feature {ANY} -- fields

	sendit: CE_POINTER [PD_FORMDATA] assign set_sendit

	postsize: INTEGER_64 assign set_postsize

	postdata: CE_POINTER [INTEGER_8] assign set_postdata

	p_pragma: CE_POINTER [INTEGER_8] assign set_p_pragma

	p_accept: CE_POINTER [INTEGER_8] assign set_p_accept

	readbytecount: INTEGER_64 assign set_readbytecount

	writebytecount: INTEGER_64 assign set_writebytecount

	form: PD_FORM assign set_form

	backup: PD_BACK assign set_backup

	sending: NATURAL_32 assign set_sending

	send_buffer: CE_POINTER [ANY] assign set_send_buffer

feature {ANY} -- field setters

	set_sendit (a_sendit: CE_POINTER [PD_FORMDATA])
		do
			sendit := a_sendit
			update_memory_field ("sendit")
		end

	set_postsize (a_postsize: INTEGER_64)
		do
			postsize := a_postsize
			update_memory_field ("postsize")
		end

	set_postdata (a_postdata: CE_POINTER [INTEGER_8])
		do
			postdata := a_postdata
			update_memory_field ("postdata")
		end

	set_p_pragma (a_p_pragma: CE_POINTER [INTEGER_8])
		do
			p_pragma := a_p_pragma
			update_memory_field ("p_pragma")
		end

	set_p_accept (a_p_accept: CE_POINTER [INTEGER_8])
		do
			p_accept := a_p_accept
			update_memory_field ("p_accept")
		end

	set_readbytecount (a_readbytecount: INTEGER_64)
		do
			readbytecount := a_readbytecount
			update_memory_field ("readbytecount")
		end

	set_writebytecount (a_writebytecount: INTEGER_64)
		do
			writebytecount := a_writebytecount
			update_memory_field ("writebytecount")
		end

	set_form (a_form: PD_FORM)
		do
			form := a_form
			update_memory_field ("form")
		end

	set_backup (a_backup: PD_BACK)
		do
			backup := a_backup
			update_memory_field ("backup")
		end

	set_sending (a_sending: NATURAL_32)
		do
			sending := a_sending
			update_memory_field ("sending")
		end

	set_send_buffer (a_send_buffer: CE_POINTER [ANY])
		do
			send_buffer := a_send_buffer
			update_memory_field ("send_buffer")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sendit := a_other.sendit
			postsize := a_other.postsize
			postdata := a_other.postdata
			p_pragma := a_other.p_pragma
			p_accept := a_other.p_accept
			readbytecount := a_other.readbytecount
			writebytecount := a_other.writebytecount
			form := a_other.form.twin
			backup := a_other.backup.twin
			sending := a_other.sending
			send_buffer := a_other.send_buffer
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sendit.is_equal (a_other.sendit) and
				postsize = a_other.postsize and
				postdata.is_equal (a_other.postdata) and
				p_pragma.is_equal (a_other.p_pragma) and
				p_accept.is_equal (a_other.p_accept) and
				readbytecount = a_other.readbytecount and
				writebytecount = a_other.writebytecount and
				form.is_equal (a_other.form) and
				backup.is_equal (a_other.backup) and
				sending = a_other.sending and
				send_buffer.is_equal (a_other.send_buffer)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sendit"),
					create {CE_STRUCTURE_FIELD}.make ("postsize"),
					create {CE_STRUCTURE_FIELD}.make ("postdata"),
					create {CE_STRUCTURE_FIELD}.make ("p_pragma"),
					create {CE_STRUCTURE_FIELD}.make ("p_accept"),
					create {CE_STRUCTURE_FIELD}.make ("readbytecount"),
					create {CE_STRUCTURE_FIELD}.make ("writebytecount"),
					create {CE_STRUCTURE_FIELD}.make ("form"),
					create {CE_STRUCTURE_FIELD}.make ("backup"),
					create {CE_STRUCTURE_FIELD}.make ("sending"),
					create {CE_STRUCTURE_FIELD}.make ("send_buffer")
				>>)
			init_structure_info
		end

end
