class
	PD_PINGPONG

inherit
	PD_PINGPONG_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_CTYPE_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} cache.make
			create {CE_INTEGER_8_POINTER} linestart_resp.make
			create {CE_INTEGER_8_POINTER} sendthis.make
			create response.make
			create {CE_CLASS_POINTER [PD_CONNECTDATA]} conn.make
			create statemach_act.make
			create endofresp.make
			Precursor
		end

feature {ANY} -- fields

	cache: CE_POINTER [INTEGER_8] assign set_cache

	cache_size: NATURAL_32 assign set_cache_size

	nread_resp: NATURAL_32 assign set_nread_resp

	linestart_resp: CE_POINTER [INTEGER_8] assign set_linestart_resp

	pending_resp: BOOLEAN assign set_pending_resp

	sendthis: CE_POINTER [INTEGER_8] assign set_sendthis

	sendleft: NATURAL_32 assign set_sendleft

	sendsize: NATURAL_32 assign set_sendsize

	response: SD_TIMEVAL assign set_response

	response_time: INTEGER_32 assign set_response_time

	conn: CE_POINTER [PD_CONNECTDATA] assign set_conn

	statemach_act: CE_ROUTINE assign set_statemach_act

	endofresp: CE_ROUTINE assign set_endofresp

feature {ANY} -- field setters

	set_cache (a_cache: CE_POINTER [INTEGER_8])
		do
			cache := a_cache
			update_memory_field ("cache")
		end

	set_cache_size (a_cache_size: NATURAL_32)
		do
			cache_size := a_cache_size
			update_memory_field ("cache_size")
		end

	set_nread_resp (a_nread_resp: NATURAL_32)
		do
			nread_resp := a_nread_resp
			update_memory_field ("nread_resp")
		end

	set_linestart_resp (a_linestart_resp: CE_POINTER [INTEGER_8])
		do
			linestart_resp := a_linestart_resp
			update_memory_field ("linestart_resp")
		end

	set_pending_resp (a_pending_resp: BOOLEAN)
		do
			pending_resp := a_pending_resp
			update_memory_field ("pending_resp")
		end

	set_sendthis (a_sendthis: CE_POINTER [INTEGER_8])
		do
			sendthis := a_sendthis
			update_memory_field ("sendthis")
		end

	set_sendleft (a_sendleft: NATURAL_32)
		do
			sendleft := a_sendleft
			update_memory_field ("sendleft")
		end

	set_sendsize (a_sendsize: NATURAL_32)
		do
			sendsize := a_sendsize
			update_memory_field ("sendsize")
		end

	set_response (a_response: SD_TIMEVAL)
		do
			response := a_response
			update_memory_field ("response")
		end

	set_response_time (a_response_time: INTEGER_32)
		do
			response_time := a_response_time
			update_memory_field ("response_time")
		end

	set_conn (a_conn: CE_POINTER [PD_CONNECTDATA])
		do
			conn := a_conn
			update_memory_field ("conn")
		end

	set_statemach_act (a_statemach_act: CE_ROUTINE)
		do
			statemach_act := a_statemach_act
			update_memory_field ("statemach_act")
		end

	set_endofresp (a_endofresp: CE_ROUTINE)
		do
			endofresp := a_endofresp
			update_memory_field ("endofresp")
		end

feature {ANY} -- public routines

	ftp_endofresp (a_code: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_line: CE_POINTER [INTEGER_8]
			l_len: NATURAL_32
			l_tmp: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___0: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___1: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_return: BOOLEAN
		do
			l_line := linestart_resp
			l_len := nread_resp
			if l_len > {NATURAL_32} 3 then
				l_tmp := ctype_b_loc
				update_class_fields -- Current might have been changed; synchronize
				if (((l_tmp.item[((l_line[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
					l_tmp___0 := ctype_b_loc
					update_class_fields -- Current might have been changed; synchronize
					if (((l_tmp___0.item[((l_line[1]).to_natural_8).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
						l_tmp___1 := ctype_b_loc
						update_class_fields -- Current might have been changed; synchronize
						if (((l_tmp___1.item[((l_line[2]).to_natural_8).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
							if 32 = (l_line[3]).to_integer_32 then
								a_code.item := atoi (l_line)
								update_class_fields -- Current might have been changed; synchronize
								Result := 1
								l_return := True
							end
						end
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	imap_endofresp (a_resp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_line: CE_POINTER [INTEGER_8]
			l_len: NATURAL_32
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_id: CE_POINTER [INTEGER_8]
			l_id_len: NATURAL_32
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line := linestart_resp
					l_len := nread_resp
					l_imapc := create {CE_CLASS_POINTER [PD_IMAP_CONN]}.make_shared (conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("imapc"))
					l_id := l_imapc.item.idstr
					l_tmp := strlen (l_id)
					update_class_fields -- Current might have been changed; synchronize
					l_id_len := l_tmp
					if not (l_len >= l_id_len + {NATURAL_32} 3) then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_tmp___1 := memcmp (create {CE_VOID_POINTER}.make_cast (l_id), create {CE_VOID_POINTER}.make_cast (l_line), l_id_len)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___1.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if: | _L:
						if l_imapc.item.state = {NATURAL_32} 5 then
							l_tmp___0 := memcmp (create {CE_VOID_POINTER}.make_cast (ce_string ("* ")), create {CE_VOID_POINTER}.make_cast (l_line), (2).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___0.to_boolean then
								a_resp.item := ('*').code
								update_class_fields -- Current might have been changed; synchronize
								Result := 1
								l_return := True
							end
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else:
						if (l_line[l_id_len.to_integer_32]).to_integer_32 = 32 then
							a_resp.item := (l_line[(l_id_len + {NATURAL_32} 1).to_integer_32]).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							Result := 1
							l_return := True
						else
							l_pos := -1 + 2 -- goto _L
						end
				when 5 then -- if done
					if not l_return then
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	pop3_endofresp (a_resp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_line: CE_POINTER [INTEGER_8]
			l_len: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line := linestart_resp
					l_len := nread_resp
					if not (l_len >= {NATURAL_32} 3) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_tmp := memcmp (create {CE_VOID_POINTER}.make_cast (ce_string ("+OK")), create {CE_VOID_POINTER}.make_cast (l_line), (3).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp.to_boolean then
							l_pos := -1 + 3 -- goto _L
						else
							a_resp.item := (l_line[1]).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							Result := 1
							l_return := True
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if l_len >= {NATURAL_32} 4 then
							l_tmp___0 := memcmp (create {CE_VOID_POINTER}.make_cast (ce_string ("-ERR")), create {CE_VOID_POINTER}.make_cast (l_line), (4).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___0.to_boolean then
								a_resp.item := (l_line[1]).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								Result := 1
								l_return := True
							end
						end
				when 4 then
					if not l_return then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	smtp_endofresp (a_resp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_line: CE_POINTER [INTEGER_8]
			l_len: NATURAL_32
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_result: INTEGER_32
			l_wordlen: NATURAL_32
			l_tmp: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___0: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___1: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line := linestart_resp
					l_len := nread_resp
					l_conn := conn
					l_smtpc := create {CE_CLASS_POINTER [PD_SMTP_CONN]}.make_shared (l_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
					if l_len < {NATURAL_32} 4 then
						Result := 0
						l_return := True
					else
						l_tmp := ctype_b_loc
						update_class_fields -- Current might have been changed; synchronize
						if (((l_tmp.item[((l_line[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
							l_tmp___0 := ctype_b_loc
							update_class_fields -- Current might have been changed; synchronize
							if (((l_tmp___0.item[((l_line[1]).to_natural_8).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
								l_tmp___1 := ctype_b_loc
								update_class_fields -- Current might have been changed; synchronize
								if not (((l_tmp___1.item[((l_line[2]).to_natural_8).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
									Result := 0
									l_return := True
								end
							else
								Result := 0
								l_return := True
							end
						else
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 27 -- skip if block
					end
				when 1 then -- if:
						l_result := ((l_line[3]).to_integer_32 = 32).to_integer
						if l_result.to_boolean then
							a_resp.item := atoi (l_line)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_line := l_line + (4)
						l_len := l_len - ({NATURAL_32} 4)
						if l_smtpc.item.state /= {NATURAL_32} 2 then
							l_pos := -1 + 26 -- skip if block
						end
				when 2 then -- if:
						if not (l_len >= {NATURAL_32} 5) then
							l_pos := -1 + 26 -- skip if block
						end
				when 3 then -- if:
						l_tmp___8 := memcmp (create {CE_VOID_POINTER}.make_cast (l_line), create {CE_VOID_POINTER}.make_cast (ce_string ("AUTH ")), (5).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___8.to_boolean then
							l_pos := -1 + 26 -- skip if block
						end
				when 4 then -- if:
						l_line := l_line + (5)
						l_len := l_len - ({NATURAL_32} 5)
				when 5 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 25 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if l_len.to_boolean then
								if (l_line[0]).to_integer_32 /= 32 then
									if (l_line[0]).to_integer_32 /= 9 then
										if (l_line[0]).to_integer_32 /= 13 then
											if (l_line[0]).to_integer_32 /= 10 then
												l_break := True
											end
										end
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_line := l_line + 1
								l_len := l_len - 1
							end
						end
						l_break := False
						if not l_len.to_boolean then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 24 -- skip if block
						end
				when 7 then -- if:
						l_wordlen := (0).to_natural_32
						from
						until
							(l_break)
						loop
							l_break := False
							if l_wordlen < l_len then
								if (l_line[l_wordlen.to_integer_32]).to_integer_32 /= 32 then
									if (l_line[l_wordlen.to_integer_32]).to_integer_32 /= 9 then
										if (l_line[l_wordlen.to_integer_32]).to_integer_32 /= 13 then
											if (l_line[l_wordlen.to_integer_32]).to_integer_32 = 10 then
												l_break := True
											end
										else
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_wordlen := l_wordlen + 1
							end
						end
						l_break := False
						if l_wordlen /= {NATURAL_32} 5 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_tmp___7 := memcmp (create {CE_VOID_POINTER}.make_cast (l_line), create {CE_VOID_POINTER}.make_cast (ce_string ("LOGIN")), (5).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___7.to_boolean then
							l_pos := -1 + 10 -- goto _L___3
						else
							l_smtpc.item.authmechs := (l_smtpc.item.authmechs).bit_or (({NATURAL_32} 1))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 10 then -- else: | _L___3:
						if l_wordlen /= {NATURAL_32} 5 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_tmp___6 := memcmp (create {CE_VOID_POINTER}.make_cast (l_line), create {CE_VOID_POINTER}.make_cast (ce_string ("PLAIN")), (5).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___6.to_boolean then
							l_pos := -1 + 13 -- goto _L___2
						else
							l_smtpc.item.authmechs := (l_smtpc.item.authmechs).bit_or (({NATURAL_32} 2))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 13 then -- else: | _L___2:
						if l_wordlen /= {NATURAL_32} 8 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_tmp___5 := memcmp (create {CE_VOID_POINTER}.make_cast (l_line), create {CE_VOID_POINTER}.make_cast (ce_string ("CRAM-MD5")), (8).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___5.to_boolean then
							l_pos := -1 + 16 -- goto _L___1
						else
							l_smtpc.item.authmechs := (l_smtpc.item.authmechs).bit_or (({NATURAL_32} 4))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 16 then -- else: | _L___1:
						if l_wordlen /= {NATURAL_32} 10 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_tmp___4 := memcmp (create {CE_VOID_POINTER}.make_cast (l_line), create {CE_VOID_POINTER}.make_cast (ce_string ("DIGEST-MD5")), (10).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___4.to_boolean then
							l_pos := -1 + 19 -- goto _L___0
						else
							l_smtpc.item.authmechs := (l_smtpc.item.authmechs).bit_or (({NATURAL_32} 8))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 19 then -- else: | _L___0:
						if l_wordlen /= {NATURAL_32} 6 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_tmp___3 := memcmp (create {CE_VOID_POINTER}.make_cast (l_line), create {CE_VOID_POINTER}.make_cast (ce_string ("GSSAPI")), (6).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___3.to_boolean then
							l_pos := -1 + 22 -- goto _L
						else
							l_smtpc.item.authmechs := (l_smtpc.item.authmechs).bit_or (({NATURAL_32} 16))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else: | _L:
						if l_wordlen = {NATURAL_32} 8 then
							l_tmp___2 := memcmp (create {CE_VOID_POINTER}.make_cast (l_line), create {CE_VOID_POINTER}.make_cast (ce_string ("EXTERNAL")), (8).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___2.to_boolean then
								l_smtpc.item.authmechs := (l_smtpc.item.authmechs).bit_or (({NATURAL_32} 32))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 23 then -- if done | if done | if done | if done
						l_line := l_line + l_wordlen.to_integer_32
						l_len := l_len - l_wordlen
				when 24 then -- if done
						l_pos := -1 + 5 -- back to loop condition
				when 25 then -- loop done
						l_break := False
				when 26 then -- if done | if done | if done
						Result := l_result
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_pp_state_timeout: INTEGER_32
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_timeout_ms: INTEGER_32
			l_timeout2_ms: INTEGER_32
			l_response_time: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: SD_TIMEVAL
			l_tmp___1: INTEGER_32
			l_tmp___2: SD_TIMEVAL
			l_tmp___3: INTEGER_32
		do
			l_conn := conn
			l_data := l_conn.item.data
			if (l_data.item.set.server_response_timeout).to_boolean then
				l_tmp := l_data.item.set.server_response_timeout
			else
				l_tmp := response_time
			end
			l_response_time := l_tmp
			l_tmp___0 := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___1 := (create {P_TIMEVAL_STATIC}).curlx_tvdiff (l_tmp___0.twin, response.twin)
			update_class_fields -- Current might have been changed; synchronize
			l_timeout_ms := l_response_time - l_tmp___1
			if (l_data.item.set.timeout).to_boolean then
				l_tmp___2 := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___3 := (create {P_TIMEVAL_STATIC}).curlx_tvdiff (l_tmp___2.twin, (l_conn.item.now).twin)
				update_class_fields -- Current might have been changed; synchronize
				l_timeout2_ms := l_data.item.set.timeout - l_tmp___3
				if l_timeout_ms < l_timeout2_ms then
					l_timeout_ms := l_timeout_ms
				else
					l_timeout_ms := l_timeout2_ms
				end
			end
			Result := l_timeout_ms
		end

	Curl_pp_multi_statemach: NATURAL_32
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_sock: INTEGER_32
			l_rc: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_result: NATURAL_32
			l_timeout_ms: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			l_conn := conn
			l_sock := l_conn.item.sock[0]
			l_data := l_conn.item.data
			l_result := {PC_CURLCODE}.CURLE_OK
			l_tmp := ((create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer))).item.Curl_pp_state_timeout
			update_class_fields -- Current might have been changed; synchronize
			l_timeout_ms := l_tmp
			if l_timeout_ms <= 0 then
				l_data.item.Curl_failf ([ce_string ("server response timeout")])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
				l_return := True
			end
			if not l_return then
				if sendleft.to_boolean then
					l_tmp___0 := l_sock
				else
					l_tmp___0 := -1
				end
				if sendleft.to_boolean then
					l_tmp___1 := -1
				else
					l_tmp___1 := l_sock
				end
				l_rc := (create {P_SELECT_STATIC}).Curl_socket_ready (l_tmp___1, l_tmp___0, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_rc = -1 then
					l_data.item.Curl_failf ([ce_string ("select/poll error")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				elseif l_rc /= 0 then
					l_result := statemach_act.natural_32_item ([l_conn])
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				Result := l_result
			end
		end

	Curl_pp_easy_statemach: NATURAL_32
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_sock: INTEGER_32
			l_rc: INTEGER_32
			l_interval_ms: INTEGER_32
			l_timeout_ms: INTEGER_32
			l_tmp: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_result: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: SD_TIMEVAL
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			l_conn := conn
			l_sock := l_conn.item.sock[0]
			l_tmp := ((create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer))).item.Curl_pp_state_timeout
			update_class_fields -- Current might have been changed; synchronize
			l_timeout_ms := l_tmp
			l_data := l_conn.item.data
			if l_timeout_ms <= 0 then
				l_data.item.Curl_failf ([ce_string ("server response timeout")])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
				l_return := True
			end
			if not l_return then
				l_interval_ms := 1_000
				if l_timeout_ms < l_interval_ms then
					l_interval_ms := l_timeout_ms
				end
				if sendleft.to_boolean then
					l_tmp___0 := l_sock
				else
					l_tmp___0 := -1
				end
				if sendleft.to_boolean then
					l_tmp___1 := -1
				else
					l_tmp___1 := l_sock
				end
				l_rc := (create {P_SELECT_STATIC}).Curl_socket_ready (l_tmp___1, l_tmp___0, l_interval_ms.to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___3 := l_conn.item.Curl_pgrsUpdate
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___3.to_boolean then
					l_result := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
				else
					l_tmp___2 := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
					update_class_fields -- Current might have been changed; synchronize
					l_result := l_data.item.Curl_speedcheck (l_tmp___2.twin)
					update_class_fields -- Current might have been changed; synchronize
				end
				if not l_result.to_boolean then
					if l_rc = -1 then
						l_data.item.Curl_failf ([ce_string ("select/poll error")])
						update_class_fields -- Current might have been changed; synchronize
						l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
					elseif l_rc.to_boolean then
						l_result := statemach_act.natural_32_item ([l_conn])
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				Result := l_result
			end
		end

	Curl_pp_init
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
		do
			l_conn := conn
			Current.nread_resp := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Current.linestart_resp := (l_conn.item.data).item.state.buffer
			update_class_fields -- Current might have been changed; synchronize
			Current.pending_resp := (1).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			Current.response := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
			update_class_fields -- Current might have been changed; synchronize
		end

	Curl_pp_vsendf (a_fmt: CE_POINTER [INTEGER_8]; a_args: CE_VA_LIST): NATURAL_32
		local
			l_args: CE_VA_LIST
			l_bytes_written: CE_ARRAY [INTEGER_32]
			l_s: CE_ARRAY [INTEGER_8]
			l_write_len: NATURAL_32
			l_sptr: CE_POINTER [INTEGER_8]
			l_res: NATURAL_32
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_bytes_written.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_s.make (<<1_024>>)

			l_args := a_args.twin
			l_sptr := l_s
			l_res := {PC_CURLCODE}.CURLE_OK
			l_conn := conn
			l_data := l_conn.item.data;
			(create {P_MPRINTF_STATIC}).curl_mvsnprintf (l_s, (1_021).to_natural_32, a_fmt, l_args.twin).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			strcat (l_s, ce_string ("%R%N")).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_bytes_written.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_write_len := strlen (l_s)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer))).item.Curl_pp_init
			update_class_fields -- Current might have been changed; synchronize
			l_res := l_conn.item.Curl_write (l_conn.item.sock[0], create {CE_VOID_POINTER}.make_cast (l_sptr), l_write_len, l_bytes_written)
			update_class_fields -- Current might have been changed; synchronize
			if {NATURAL_32} 0 /= l_res then
				Result := l_res
				l_return := True
			end
			if not l_return then
				if (l_conn.item.data).item.set.verbose then
					(l_conn.item.data).item.Curl_debug ({PC_CURL_INFOTYPE}.CURLINFO_HEADER_OUT, l_sptr, (l_bytes_written.item).to_natural_32, l_conn).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				if l_bytes_written.item /= l_write_len.to_integer_32 then
					l_write_len := l_write_len - (l_bytes_written.item).to_natural_32
					l_sptr := l_sptr + (l_bytes_written.item)
					l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([l_write_len]))
					update_class_fields -- Current might have been changed; synchronize
					Current.sendthis := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)
					update_class_fields -- Current might have been changed; synchronize
					if (not sendthis.is_void) then
						memcpy (create {CE_VOID_POINTER}.make_cast (sendthis), create {CE_VOID_POINTER}.make_cast (l_sptr), l_write_len).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := l_write_len
						Current.sendleft := l_tmp___0
						update_class_fields -- Current might have been changed; synchronize
						Current.sendsize := l_tmp___0
						update_class_fields -- Current might have been changed; synchronize
					else
						l_data.item.Curl_failf ([ce_string ("out of memory")])
						update_class_fields -- Current might have been changed; synchronize
						l_res := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
					end
				else
					Current.response := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_res
			end
		end

	Curl_pp_sendf (a_args: TUPLE [a_fmt: CE_POINTER [INTEGER_8]]): NATURAL_32
		local
			l_res: NATURAL_32
			l_ap: CE_VA_LIST
		do
			create l_ap.make_shared (default_pointer)

			l_ap := create {CE_VA_LIST}.make (a_args, agent Curl_pp_sendf)
			l_res := ((create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer))).item.Curl_pp_vsendf (a_args.a_fmt, l_ap.twin)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_res
		end

	Curl_pp_getsock (a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_return: BOOLEAN
		do
			l_conn := conn
			if not a_numsocks.to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				a_socks[0] := l_conn.item.sock[0]
				update_class_fields -- Current might have been changed; synchronize
				if sendleft.to_boolean then
					Result := ((1).bit_shift_left (16))
					l_return := True
				end
			end
			if not l_return then
				Result := 1
			end
		end

	Curl_pp_disconnect: NATURAL_32
		do
			if (not cache.is_void) then
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (cache)])
				update_class_fields -- Current might have been changed; synchronize
				Current.cache := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			cache := a_other.cache
			cache_size := a_other.cache_size
			nread_resp := a_other.nread_resp
			linestart_resp := a_other.linestart_resp
			pending_resp := a_other.pending_resp
			sendthis := a_other.sendthis
			sendleft := a_other.sendleft
			sendsize := a_other.sendsize
			response := a_other.response.twin
			response_time := a_other.response_time
			conn := a_other.conn
			statemach_act := a_other.statemach_act
			endofresp := a_other.endofresp
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				cache.is_equal (a_other.cache) and
				cache_size = a_other.cache_size and
				nread_resp = a_other.nread_resp and
				linestart_resp.is_equal (a_other.linestart_resp) and
				pending_resp = a_other.pending_resp and
				sendthis.is_equal (a_other.sendthis) and
				sendleft = a_other.sendleft and
				sendsize = a_other.sendsize and
				response.is_equal (a_other.response) and
				response_time = a_other.response_time and
				conn.is_equal (a_other.conn) and
				statemach_act.is_equal (a_other.statemach_act) and
				endofresp.is_equal (a_other.endofresp)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("cache"),
					create {CE_STRUCTURE_FIELD}.make ("cache_size"),
					create {CE_STRUCTURE_FIELD}.make ("nread_resp"),
					create {CE_STRUCTURE_FIELD}.make ("linestart_resp"),
					create {CE_STRUCTURE_FIELD}.make ("pending_resp"),
					create {CE_STRUCTURE_FIELD}.make ("sendthis"),
					create {CE_STRUCTURE_FIELD}.make ("sendleft"),
					create {CE_STRUCTURE_FIELD}.make ("sendsize"),
					create {CE_STRUCTURE_FIELD}.make ("response"),
					create {CE_STRUCTURE_FIELD}.make ("response_time"),
					create {CE_STRUCTURE_FIELD}.make ("conn"),
					create {CE_STRUCTURE_FIELD}.make ("statemach_act"),
					create {CE_STRUCTURE_FIELD}.make ("endofresp")
				>>)
			init_structure_info
		end

end
