class
	PD_VA_STACK_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create data.make
		end

feature {ANY} -- fields

	type: NATURAL_32 assign set_type

	flags: INTEGER_32 assign set_flags

	width: INTEGER_32 assign set_width

	precision: INTEGER_32 assign set_precision

	data: PD_DATA assign set_data

feature {ANY} -- field setters

	set_type (a_type: NATURAL_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_precision (a_precision: INTEGER_32)
		do
			precision := a_precision
			update_memory_field ("precision")
		end

	set_data (a_data: PD_DATA)
		do
			data := a_data
			update_memory_field ("data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			flags := a_other.flags
			width := a_other.width
			precision := a_other.precision
			data := a_other.data.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				flags = a_other.flags and
				width = a_other.width and
				precision = a_other.precision and
				data.is_equal (a_other.data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("precision"),
					create {CE_STRUCTURE_FIELD}.make ("data")
				>>)
			init_structure_info
		end

end
