class
	S_STDLIB_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	strtoll (a___nptr: CE_POINTER [INTEGER_8]; a___endptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a___base: INTEGER_32): INTEGER_64
		require
			not a___nptr.is_void
		do
			Result := c_strtoll (a___nptr.c_pointer, a___endptr.c_pointer, a___base)
		end

	c_strtoll (a___nptr: POINTER; a___endptr: POINTER; a___base: INTEGER_32): INTEGER_64
		external
			"C inline use <libcurl.h>"
		alias
			"return strtoll($a___nptr, $a___endptr, $a___base);"
		end

	atoi (a___nptr: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a___nptr.is_void
		do
			Result := c_atoi (a___nptr.c_pointer)
		end

	c_atoi (a___nptr: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return atoi($a___nptr);"
		end

	qsort (a___base: CE_POINTER [ANY]; a___nmemb, a___size: NATURAL_32; a___compar: CE_ROUTINE)
		require
			not a___base.is_void
			not a___compar.is_void
		do
			c_qsort (a___base.c_pointer, a___nmemb, a___size, a___compar.c_pointer)
		end

	c_qsort (a___base: POINTER; a___nmemb: NATURAL_32; a___size: NATURAL_32; a___compar: POINTER)
		external
			"C inline use <libcurl.h>"
		alias
			"qsort($a___base, $a___nmemb, $a___size, $a___compar);"
		end

	strtoul (a___nptr: CE_POINTER [INTEGER_8]; a___endptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a___base: INTEGER_32): NATURAL_32
		require
			not a___nptr.is_void
		do
			Result := c_strtoul (a___nptr.c_pointer, a___endptr.c_pointer, a___base)
		end

	c_strtoul (a___nptr: POINTER; a___endptr: POINTER; a___base: INTEGER_32): NATURAL_32
		external
			"C inline use <libcurl.h>"
		alias
			"return strtoul($a___nptr, $a___endptr, $a___base);"
		end

	malloc (a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared_with_count (
					default_pointer.memory_alloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	free (a___ptr: CE_POINTER [ANY])
		do
			c_free (a___ptr.c_pointer)
		end

	c_free (a___ptr: POINTER)
		external
			"C inline use <libcurl.h>"
		alias
			"free($a___ptr);"
		end

	getenv (a___name: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a___name.is_void
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_getenv (a___name.c_pointer))
		end

	c_getenv (a___name: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return (EIF_POINTER)getenv($a___name);"
		end

	strtol (a___nptr: CE_POINTER [INTEGER_8]; a___endptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a___base: INTEGER_32): INTEGER_32
		require
			not a___nptr.is_void
		do
			Result := c_strtol (a___nptr.c_pointer, a___endptr.c_pointer, a___base)
		end

	c_strtol (a___nptr: POINTER; a___endptr: POINTER; a___base: INTEGER_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return strtol($a___nptr, $a___endptr, $a___base);"
		end

	calloc (a_nmemb: NATURAL_32; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared_with_count (
					default_pointer.memory_calloc (a_nmemb.to_integer_32, a_size.to_integer_32),
					(a_nmemb * a_size).to_integer_32
				)
		end

	realloc (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared_with_count (
					a_ptr.c_pointer.memory_realloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

feature {ANY} -- routine addresses

	malloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent malloc)
		end

	free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent free)
		end

	calloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent calloc)
		end

	realloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent realloc)
		end

end
