class
	SD_SOCKADDR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_ARRAY} sa_data.make (<<14>>)
		end

feature {ANY} -- fields

	sa_family: NATURAL_16 assign set_sa_family

	sa_data: CE_ARRAY [INTEGER_8]

feature {ANY} -- field setters

	set_sa_family (a_sa_family: NATURAL_16)
		do
			sa_family := a_sa_family
			update_memory_field ("sa_family")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sa_family := a_other.sa_family
			sa_data := a_other.sa_data.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sa_family = a_other.sa_family and
				sa_data.is_equal (a_other.sa_data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sa_family"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sa_data", <<14>>)
				>>)
			init_structure_info
		end

end
