class
	SD_SOCKADDR_IN6

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create sin6_addr.make
		end

feature {ANY} -- fields

	sin6_family: NATURAL_16 assign set_sin6_family

	sin6_port: NATURAL_16 assign set_sin6_port

	sin6_flowinfo: NATURAL_32 assign set_sin6_flowinfo

	sin6_addr: SD_IN6_ADDR assign set_sin6_addr

	sin6_scope_id: NATURAL_32 assign set_sin6_scope_id

feature {ANY} -- field setters

	set_sin6_family (a_sin6_family: NATURAL_16)
		do
			sin6_family := a_sin6_family
			update_memory_field ("sin6_family")
		end

	set_sin6_port (a_sin6_port: NATURAL_16)
		do
			sin6_port := a_sin6_port
			update_memory_field ("sin6_port")
		end

	set_sin6_flowinfo (a_sin6_flowinfo: NATURAL_32)
		do
			sin6_flowinfo := a_sin6_flowinfo
			update_memory_field ("sin6_flowinfo")
		end

	set_sin6_addr (a_sin6_addr: SD_IN6_ADDR)
		do
			sin6_addr := a_sin6_addr
			update_memory_field ("sin6_addr")
		end

	set_sin6_scope_id (a_sin6_scope_id: NATURAL_32)
		do
			sin6_scope_id := a_sin6_scope_id
			update_memory_field ("sin6_scope_id")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sin6_family := a_other.sin6_family
			sin6_port := a_other.sin6_port
			sin6_flowinfo := a_other.sin6_flowinfo
			sin6_addr := a_other.sin6_addr.twin
			sin6_scope_id := a_other.sin6_scope_id
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sin6_family = a_other.sin6_family and
				sin6_port = a_other.sin6_port and
				sin6_flowinfo = a_other.sin6_flowinfo and
				sin6_addr.is_equal (a_other.sin6_addr) and
				sin6_scope_id = a_other.sin6_scope_id
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sin6_family"),
					create {CE_STRUCTURE_FIELD}.make ("sin6_port"),
					create {CE_STRUCTURE_FIELD}.make ("sin6_flowinfo"),
					create {CE_STRUCTURE_FIELD}.make ("sin6_addr"),
					create {CE_STRUCTURE_FIELD}.make ("sin6_scope_id")
				>>)
			init_structure_info
		end

end
