class
	P_CONG_2EXP_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_congruent_2exp_p (a_a, a_c: CE_POINTER [PD_MPZ_STRUCT]; a_d: NATURAL_32): INTEGER_32
		require
			not a_a.is_void
			not a_c.is_void
		local
			l_a: CE_POINTER [PD_MPZ_STRUCT]
			l_c: CE_POINTER [PD_MPZ_STRUCT]
			l_i: INTEGER_32
			l_dlimbs: INTEGER_32
			l_dbits: NATURAL_32
			l_ap: CE_POINTER [NATURAL_32]
			l_cp: CE_POINTER [NATURAL_32]
			l_dmask: NATURAL_32
			l_alimb: NATURAL_32
			l_climb: NATURAL_32
			l_sum: NATURAL_32
			l_asize_signed: INTEGER_32
			l_csize_signed: INTEGER_32
			l_asize: INTEGER_32
			l_csize: INTEGER_32
			l___mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a := a_a
					l_c := a_c
					if l_a.item.mp_size >= 0 then
						l_tmp := l_a.item.mp_size
					else
						l_tmp := -l_a.item.mp_size
					end
					if l_c.item.mp_size >= 0 then
						l_tmp___0 := l_c.item.mp_size
					else
						l_tmp___0 := -l_c.item.mp_size
					end
					if l_tmp < l_tmp___0 then
						from
						until
							(l_break)
						loop
							l_break := False
							l___mpz_srcptr_swap__tmp := l_a
							l_a := l_c
							l_c := l___mpz_srcptr_swap__tmp
							l_break := True
						end
						l_break := False
					end
					l_dlimbs := (a_d // {NATURAL_32} 32).to_integer_32
					l_dbits := (a_d \\ {NATURAL_32} 32).to_natural_32
					l_dmask := (({NATURAL_32} 1).bit_shift_left (l_dbits.to_integer_32)) - {NATURAL_32} 1
					l_ap := l_a.item.mp_d
					l_cp := l_c.item.mp_d
					l_asize_signed := (l_a.item.mp_size).to_integer_32
					if l_asize_signed >= 0 then
						l_asize := l_asize_signed
					else
						l_asize := -l_asize_signed
					end
					l_csize_signed := (l_c.item.mp_size).to_integer_32
					if l_csize_signed >= 0 then
						l_csize := l_csize_signed
					else
						l_csize := -l_csize_signed
					end
					if l_csize_signed = 0 then
						l_pos := -1 + 3 -- goto a_zeros
					end
				when 1 then
					if not (((l_asize_signed).bit_xor (l_csize_signed)) >= 0) then
						l_pos := -1 + 6 -- skip if block
					end
				when 2 then -- if:
						if l_csize < l_dlimbs then
							l_tmp___1 := l_csize
						else
							l_tmp___1 := l_dlimbs
						end
						if ((create {P_GMP_STATIC}).gmpn_cmp (l_ap, l_cp, l_tmp___1)) /= 0 then
							Result := 0
							l_return := True
						end
						if not l_return and then (l_csize > l_dlimbs) then
							Result := ((((l_ap[l_dlimbs] - l_cp[l_dlimbs])).bit_and (l_dmask)) = {NATURAL_32} 0).to_integer
							l_return := True
						end
						if l_return then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | a_zeros:
						if l_asize <= l_dlimbs then
							Result := (l_asize = l_csize).to_integer
							l_return := True
						end
				when 4 then -- if done
						if not l_return then
							l_i := l_csize
							from
							until
								not (not (l_return) and then (l_i < l_dlimbs))
							loop
								if l_ap[l_i] /= {NATURAL_32} 0 then
									Result := 0
									l_return := True
								end
								if not l_return then
									l_i := l_i + 1
								end
							end
						end
						if not l_return then
							Result := (((l_ap[l_dlimbs]).bit_and (l_dmask)) = {NATURAL_32} 0).to_integer
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_i := (0).to_integer_32
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_alimb := l_ap[l_i]
							l_climb := l_cp[l_i]
							l_sum := ((l_alimb + l_climb)).bit_and ({NATURAL_32} 4_294_967_295)
							if l_i >= l_dlimbs then
								Result := (((l_sum).bit_and (l_dmask)) = {NATURAL_32} 0).to_integer
								l_return := True
							end
							if not l_return then
								l_i := l_i + 1
								if l_sum /= {NATURAL_32} 0 then
									Result := 0
									l_return := True
								end
							end
							if not l_return and then (l_alimb /= {NATURAL_32} 0) then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
							from
							until
								not (not (l_return) and then (not (l_i >= l_csize)))
							loop
								l_alimb := l_ap[l_i]
								l_climb := l_cp[l_i]
								l_sum := (((l_alimb + l_climb) + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
								if l_i >= l_dlimbs then
									Result := (((l_sum).bit_and (l_dmask)) = {NATURAL_32} 0).to_integer
									l_return := True
								end
								if not l_return and then (l_sum /= {NATURAL_32} 0) then
									Result := 0
									l_return := True
								end
								if not l_return then
									l_i := l_i + 1
								end
							end
						end
						if not l_return and then (l_asize < l_dlimbs) then
							Result := 0
							l_return := True
						end
						if not l_return then
							from
							until
								not (not (l_return) and then (l_i < l_dlimbs))
							loop
								if l_ap[l_i] /= {NATURAL_32} 4_294_967_295 then
									Result := 0
									l_return := True
								end
								if not l_return then
									l_i := l_i + 1
								end
							end
						end
						if not l_return and then (l_dbits = {NATURAL_32} 0) then
							Result := 1
							l_return := True
						end
						if not l_return and then (l_asize = l_dlimbs) then
							Result := 0
							l_return := True
						end
						if not l_return then
							Result := ((((l_ap[l_dlimbs] + {NATURAL_32} 1)).bit_and (l_dmask)) = {NATURAL_32} 0).to_integer
						end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
