class
	P_GMP_IMPL_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	gmp_junk: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	gmp_binvert_limb_table: CE_ARRAY [NATURAL_8] assign set_gmp_binvert_limb_table
		do
			create {CE_NATURAL_8_ARRAY} Result.make_shared (c_gmp_binvert_limb_table, <<128>>)
		end

	c_gmp_binvert_limb_table: POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return (EIF_POINTER)__gmp_binvert_limb_table;"
		end

	set_gmp_binvert_limb_table (a_gmp_binvert_limb_table: CE_ARRAY [NATURAL_8])
		do
			c_set_gmp_binvert_limb_table (a_gmp_binvert_limb_table.c_pointer)
		end

	c_set_gmp_binvert_limb_table (a_gmp_binvert_limb_table: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"printf(%"NATIVE_FUNCTIONS_WRITER.write_native_variable: AST_ARRAY_TYPE\n%");"
		end

	gmp_rands: CE_STATIC [CE_ARRAY [PD_GMP_RANDSTATE_STRUCT]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GMP_RANDSTATE_STRUCT]}.make (<<1>>)
		end

feature {ANY} -- public routines

	gmpn_bdiv_dbm1c (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4, a_arg5: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_bdiv_dbm1c (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4, a_arg5)
		end

	c_gmpn_bdiv_dbm1c (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32; a_arg5: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_bdiv_dbm1c($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	gmpn_divexact_1 (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32)
		do
			c_gmpn_divexact_1 (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_divexact_1 (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32)
		external
			"C inline use <libgmp.h>"
		alias
			"__gmpn_divexact_1($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_modexact_1_odd (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_modexact_1_odd (a_arg1.c_pointer, a_arg2, a_arg3)
		end

	c_gmpn_modexact_1_odd (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_modexact_1_odd($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_mod_1s_4p_cps (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: NATURAL_32)
		do
			c_gmpn_mod_1s_4p_cps (a_arg1.c_pointer, a_arg2)
		end

	c_gmpn_mod_1s_4p_cps (a_arg1: POINTER; a_arg2: NATURAL_32)
		external
			"C inline use <libgmp.h>"
		alias
			"__gmpn_mod_1s_4p_cps($a_arg1, $a_arg2);"
		end

	gmpn_mod_1s_4p (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3: NATURAL_32; a_arg4: CE_POINTER [NATURAL_32]): NATURAL_32
		do
			Result := c_gmpn_mod_1s_4p (a_arg1.c_pointer, a_arg2, a_arg3, a_arg4.c_pointer)
		end

	c_gmpn_mod_1s_4p (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: NATURAL_32; a_arg4: POINTER): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_mod_1s_4p($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_invert_limb (a_arg1: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_invert_limb($a_arg1);"
		end

	gmpn_mul_basecase (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: CE_POINTER [NATURAL_32]; a_arg5: INTEGER_32)
		do
			c_gmpn_mul_basecase (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4.c_pointer, a_arg5)
		end

	c_gmpn_mul_basecase (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: POINTER; a_arg5: INTEGER_32)
		external
			"C inline use <libgmp.h>"
		alias
			"__gmpn_mul_basecase($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	mpn_toom6h_mul_itch (a_an, a_bn: INTEGER_32): INTEGER_32
		local
			l_estimatedN: INTEGER_32
		do
			l_estimatedN := ((a_an + a_bn).to_natural_32 // {NATURAL_32} 10 + {NATURAL_32} 1).to_integer_32
			Result := ((l_estimatedN * 6 - 252) * 2 + 788)
		end

	mpn_toom8h_mul_itch (a_an, a_bn: INTEGER_32): INTEGER_32
		local
			l_estimatedN: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_estimatedN := ((a_an + a_bn).to_natural_32 // {NATURAL_32} 14 + {NATURAL_32} 1).to_integer_32
			if ((5_715).bit_shift_right (3)) + 192 > 1_046 then
				l_tmp := ((5_715).bit_shift_right (3)) + 192
			else
				l_tmp := 1_046
			end
			Result := (((((l_estimatedN * 8) * 15).bit_shift_right (3)) - ((5_715).bit_shift_right (3)).to_integer_32) + l_tmp.to_integer_32)
		end

	gmpn_sqr_basecase (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32)
		do
			c_gmpn_sqr_basecase (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_gmpn_sqr_basecase (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32)
		external
			"C inline use <libgmp.h>"
		alias
			"__gmpn_sqr_basecase($a_arg1, $a_arg2, $a_arg3);"
		end

	mpn_mulmod_bnm1_itch (a_rn, a_an, a_bn: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_itch: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_n := (a_rn).bit_shift_right (1)
			if a_an > l_n then
				if a_bn > l_n then
					l_tmp := a_rn
				else
					l_tmp := l_n
				end
				l_tmp___0 := l_tmp
			else
				l_tmp___0 := (0).to_integer_32
			end
			l_itch := (a_rn + 4) + l_tmp___0
			Result := l_itch
		end

	mpn_sqrmod_bnm1_itch (a_rn, a_an: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_itch: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_n := (a_rn).bit_shift_right (1)
			if a_an > l_n then
				l_tmp := a_an
			else
				l_tmp := (0).to_integer_32
			end
			l_itch := (a_rn + 3) + l_tmp
			Result := l_itch
		end

	gmpn_preinv_divrem_1 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32; a_arg5, a_arg6: NATURAL_32; a_arg7: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_preinv_divrem_1 (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4, a_arg5, a_arg6, a_arg7)
		end

	c_gmpn_preinv_divrem_1 (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER; a_arg4: INTEGER_32; a_arg5: NATURAL_32; a_arg6: NATURAL_32; a_arg7: INTEGER_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_preinv_divrem_1($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7);"
		end

	mpn_zero_p (a_ap: CE_POINTER [NATURAL_32]; a_n: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_return: BOOLEAN
		do
			l_i := a_n - 1
			from
			until
				not (not (l_return) and then (l_i >= 0))
			loop
				if a_ap[l_i] /= {NATURAL_32} 0 then
					Result := 0
					l_return := True
				end
				if not l_return then
					l_i := l_i - 1
				end
			end
			if not l_return then
				Result := 1
			end
		end

	gmpn_add_nc (a_arg1, a_arg2, a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32; a_arg5: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_add_nc (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4, a_arg5)
		end

	c_gmpn_add_nc (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: INTEGER_32; a_arg5: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_add_nc($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	gmpn_sub_nc (a_arg1, a_arg2, a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32; a_arg5: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_sub_nc (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4, a_arg5)
		end

	c_gmpn_sub_nc (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: INTEGER_32; a_arg5: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_sub_nc($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

end
