class
	P_INVERTAPPR_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	mpn_bc_invertappr (a_ip, a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_n: CE_ARRAY [INTEGER_32]
			l_dp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_ip: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_xp: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l___d: CE_POINTER [NATURAL_32]
			l___s: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_tmp___0: CE_POINTER [NATURAL_32]
			l_inv: PD_GMP_PI1_T
			l_v: CE_ARRAY [NATURAL_32]
			l_p: NATURAL_32
			l_t1: CE_ARRAY [NATURAL_32]
			l_t0: CE_ARRAY [NATURAL_32]
			l_mask: NATURAL_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_n.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_dp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_ip.make (<<1>>)
			create l_inv.make
			create {CE_NATURAL_32_ARRAY} l_v.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_t1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_t0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			l_n.item := a_n
			l_dp.item := a_dp
			l_ip.item := a_ip
			if l_n.item = 1 then
				from
				until
					(l_break)
				loop
					l_break := False
					l_ip.item.item := (create {P_GMP_IMPL_STATIC}).gmpn_invert_limb (l_dp.item.item)
					l_break := True
				end
				l_break := False
			else
				l_xp := (a_tp + l_n.item) + 2
				l_i := l_n.item - 1
				from
				until
					not (l_i >= 0)
				loop
					l_xp[l_i] := {NATURAL_32} 4_294_967_295
					l_i := l_i - 1
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___d := l_xp + l_n.item
					l___s := l_dp.item
					l___n := l_n.item
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp := l___d
						l___d := l___d + 1
						l_tmp___0 := l___s
						l___s := l___s + 1
						l_tmp.item := (((l_tmp___0.item).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
						l___n := l___n - 1
						if not l___n.to_boolean then
							l_break := True
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				if l_n.item = 2 then
					(create {P_GMP_STATIC}).gmpn_divrem_2 (l_ip.item, (0).to_integer_32, l_xp, (4).to_integer_32, l_dp.item).do_nothing
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							l_v.item := (create {P_GMP_IMPL_STATIC}).gmpn_invert_limb (l_dp.item[(l_n.item - 1)])
							l_break := True
						end
						l_break := False
						l_p := (l_dp.item[(l_n.item - 1)] * l_v.item)
						l_p := l_p + (l_dp.item[(l_n.item - 2)])
						if l_p < l_dp.item[(l_n.item - 2)] then
							l_v.item := l_v.item - 1
							l_mask := (-(l_p >= l_dp.item[(l_n.item - 1)]).to_integer).to_integer.to_natural_32
							l_p := l_p - (l_dp.item[(l_n.item - 1)])
							l_v.item := l_v.item + l_mask
							l_p := l_p - ((l_mask).bit_and (l_dp.item[(l_n.item - 1)]))
						end
						asm210 (l_t0, l_t1, l_dp, l_n, l_v)
						l_p := l_p + (l_t1.item)
						if l_p < l_t1.item then
							l_v.item := l_v.item - 1
							if (builtin_expect ((l_p >= l_dp.item[(l_n.item - 1)]).to_integer, 0)).to_boolean then
								if l_p > l_dp.item[(l_n.item - 1)] then
									l_v.item := l_v.item - 1
								elseif l_t0.item >= l_dp.item[(l_n.item - 2)] then
									l_v.item := l_v.item - 1
								end
							end
						end
						l_inv.inv32 := l_v.item
						l_break := True
					end
					l_break := False;
					(create {P_SBPI1_DIVAPPR_Q_STATIC}).gmpn_sbpi1_divappr_q (l_ip.item, l_xp, 2 * l_n.item, l_dp.item, l_n.item, l_inv.inv32).do_nothing
					from
					until
						(l_break)
					loop
						l_break := False
						asm211 (l___ptr_dummy, l_ip)
						l_break := True
					end
					l_break := False
					Result := (1).to_natural_32
					l_return := True
				end
			end
			if not l_return then
				Result := (0).to_natural_32
			end
		end

	gmpn_ni_invertappr (a_ip, a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		require
			not a_scratch.is_void
		local
			l_ip: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_dp: CE_POINTER [NATURAL_32]
			l_n: CE_ARRAY [INTEGER_32]
			l_cy: CE_ARRAY [NATURAL_32]
			l_xp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_rn: CE_ARRAY [INTEGER_32]
			l_mn: CE_ARRAY [INTEGER_32]
			l_sizes: CE_ARRAY [INTEGER_32]
			l_sizp: CE_POINTER [INTEGER_32]
			l_tp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___5: CE_POINTER [ANY]
			l_method: CE_ARRAY [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___d: CE_POINTER [NATURAL_32]
			l___s: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___11: CE_POINTER [NATURAL_32]
			l_tmp___12: CE_POINTER [NATURAL_32]
			l___ptr_dummy___4: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___5: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___6: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_ip.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_n.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_xp.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rn.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_mn.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_sizes.make (<<({NATURAL_32} 8 * {PLATFORM}.Integer_32_bytes.to_natural_32 - {NATURAL_32} 7).to_integer_32>>)
			create {CE_NATURAL_32_POINTER} l_tp.make
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_method.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___2.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___3.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___4.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___5.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___6.make (<<1>>)

			l_ip.item := a_ip
			l_dp := a_dp
			l_n.item := a_n
			l_sizp := l_sizes
			l_rn.item := l_n.item
			from
			until
				(l_break)
			loop
				l_break := False
				l_sizp.item := l_rn.item
				l_rn.item := ((l_rn.item).bit_shift_right (1)) + 1
				l_sizp := l_sizp + 1
				if 81 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (l_rn.item >= 81) then
						l_break := True
					end
				else
					l_break := True
				end
			end
			l_break := False
			l_dp := l_dp + (l_n.item)
			l_ip.item := l_ip.item + (l_n.item)
			mpn_bc_invertappr (l_ip.item - l_rn.item, l_dp - l_rn.item, l_rn.item, a_scratch).do_nothing
			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			if 117 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_n.item >= 117 then
					l_mn.item := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (l_n.item + 1)
					if (builtin_expect ((((create {P_GMP_IMPL_STATIC}).mpn_mulmod_bnm1_itch (l_mn.item, l_n.item, ((l_n.item).bit_shift_right (1)) + 1)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___5 := (l_aaf.new ((((create {P_GMP_IMPL_STATIC}).mpn_mulmod_bnm1_itch (l_mn.item, l_n.item, ((l_n.item).bit_shift_right (1)) + 1)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___5 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (((create {P_GMP_IMPL_STATIC}).mpn_mulmod_bnm1_itch (l_mn.item, l_n.item, ((l_n.item).bit_shift_right (1)) + 1)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___5)
				end
			end
			l_xp.item := (a_scratch + l_n.item) + 3
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_sizp := l_sizp - 1
				l_n.item := l_sizp.item
				if 117 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n.item >= 117 then
						l_mn.item := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (l_n.item + 1)
						if l_mn.item > l_n.item + l_rn.item then
							(create {P_MUL_STATIC}).gmpn_mul (l_xp.item, l_dp - l_n.item, l_n.item, (l_ip.item - l_rn.item), l_rn.item).do_nothing;
							(create {P_GMP_STATIC}).gmpn_add_n (l_xp.item + l_rn.item, (l_xp.item + l_rn.item), l_dp - l_n.item, (l_n.item - l_rn.item) + 1).do_nothing
							l_method.item := (1).to_natural_32
						else
							(create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1 (l_xp.item, l_mn.item, l_dp - l_n.item, l_n.item, (l_ip.item - l_rn.item), l_rn.item, l_tp)
							l_xp.item[l_mn.item] := {NATURAL_32} 1 + ((create {P_GMP_STATIC}).gmpn_add_n (l_xp.item + l_rn.item, (l_xp.item + l_rn.item), l_dp - l_n.item, l_mn.item - l_rn.item))
							l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_xp.item, l_xp.item, l_dp - (l_n.item - (l_mn.item - l_rn.item)), l_n.item - (l_mn.item - l_rn.item))
							from
							until
								(l_break)
							loop
								l_break := False
								asm212 (l___ptr_dummy, l_xp, l_n, l_mn, l_rn, l_cy)
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								asm213 (l___ptr_dummy___0, l_xp, l_rn, l_n, l_mn)
								l_break := True
							end
							l_break := False
							if (l_xp.item[l_mn.item]).to_boolean then
								from
								until
									(l_break)
								loop
									l_break := False
									asm214 (l___ptr_dummy___1, l_xp, l_mn)
									l_break := True
								end
								l_break := False
							else
								from
								until
									(l_break)
								loop
									l_break := False
									asm215 (l___ptr_dummy___2, l_xp)
									l_break := True
								end
								l_break := False
							end
							l_method.item := (0).to_natural_32
						end
					else
						(create {P_MUL_STATIC}).gmpn_mul (l_xp.item, l_dp - l_n.item, l_n.item, (l_ip.item - l_rn.item), l_rn.item).do_nothing;
						(create {P_GMP_STATIC}).gmpn_add_n (l_xp.item + l_rn.item, (l_xp.item + l_rn.item), l_dp - l_n.item, (l_n.item - l_rn.item) + 1).do_nothing
						l_method.item := (1).to_natural_32
					end
				else
					(create {P_MUL_STATIC}).gmpn_mul (l_xp.item, l_dp - l_n.item, l_n.item, (l_ip.item - l_rn.item), l_rn.item).do_nothing;
					(create {P_GMP_STATIC}).gmpn_add_n (l_xp.item + l_rn.item, (l_xp.item + l_rn.item), l_dp - l_n.item, (l_n.item - l_rn.item) + 1).do_nothing
					l_method.item := (1).to_natural_32
				end
				if l_xp.item[l_n.item] < {NATURAL_32} 2 then
					l_cy.item := (1).to_natural_32
					from
					until
						(l_break)
					loop
						l_break := False
						if not (l_xp.item[l_n.item]).to_boolean then
							if not (((create {P_GMP_STATIC}).gmpn_cmp (l_xp.item, l_dp - l_n.item, l_n.item)) > 0) then
								l_break := True
							end
						end
						if not (l_break) then
							l_xp.item[l_n.item] := l_xp.item[l_n.item] - ((create {P_GMP_STATIC}).gmpn_sub_n (l_xp.item, l_xp.item, l_dp - l_n.item, l_n.item))
							l_cy.item := l_cy.item + 1
						end
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						asm216 (l___ptr_dummy___3, l_ip, l_rn, l_cy)
						l_break := True
					end
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_sub_n (l_xp.item, l_dp - l_n.item, l_xp.item, l_n.item).do_nothing
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l___d := l_xp.item
						l___s := l_xp.item
						l___n := l_n.item + 1
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___11 := l___d
							l___d := l___d + 1
							l_tmp___12 := l___s
							l___s := l___s + 1
							l_tmp___11.item := (((l_tmp___12.item).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
							l___n := l___n - 1
							if not l___n.to_boolean then
								l_break := True
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						asm217 (l___ptr_dummy___4, l_xp, l_method)
						l_break := True
					end
					l_break := False
					if (l_xp.item[l_n.item]).to_boolean then
						from
						until
							(l_break)
						loop
							l_break := False
							asm218 (l___ptr_dummy___5, l_ip, l_rn)
							l_break := True
						end
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_sub_n (l_xp.item, l_xp.item, l_dp - l_n.item, l_n.item).do_nothing
					end
				end
				(create {P_MUL_N_STATIC}).gmpn_mul_n (a_scratch, ((l_xp.item + l_n.item) - l_rn.item), (l_ip.item - l_rn.item), l_rn.item)
				l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (a_scratch + l_rn.item, (a_scratch + l_rn.item), ((l_xp.item + l_n.item) - l_rn.item), 2 * l_rn.item - l_n.item)
				l_cy.item := (create {P_GMP_IMPL_STATIC}).gmpn_add_nc (l_ip.item - l_n.item, ((a_scratch + 3 * l_rn.item) - l_n.item), (l_xp.item + l_rn.item), l_n.item - l_rn.item, l_cy.item)
				from
				until
					(l_break)
				loop
					l_break := False
					asm219 (l___ptr_dummy___6, l_ip, l_rn, l_cy)
					l_break := True
				end
				l_break := False
				if l_sizp.is_equal (l_sizes) then
					l_cy.item := (a_scratch[((3 * l_rn.item - l_n.item) - 1)] > {NATURAL_32} 4_294_967_288).to_integer.to_natural_32
					l_break := True
				end
				if not (l_return or l_break) then
					l_rn.item := l_n.item
				end
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
				end
				l_break := True
			end
			l_break := False
			Result := (l_cy.item)
		end

	gmpn_invertappr (a_ip, a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_scratch: CE_POINTER [NATURAL_32]
			l_res: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_scratch := a_scratch
			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			if l_scratch.is_void then
				if (builtin_expect (((3 * a_n + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___2 := (l_aaf.new (((3 * a_n + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___2 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((3 * a_n + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_scratch := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
			end
			if 81 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if a_n >= 81 then
					l_res := gmpn_ni_invertappr (a_ip, a_dp, a_n, l_scratch)
				else
					l_res := mpn_bc_invertappr (a_ip, a_dp, a_n, l_scratch)
				end
			else
				l_res := mpn_bc_invertappr (a_ip, a_dp, a_n, l_scratch)
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
				end
				l_break := True
			end
			l_break := False
			Result := l_res
		end

end
