class
	P_MP_SET_FNS_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmp_set_memory_functions (a_alloc_func, a_realloc_func, a_free_func: CE_ROUTINE)
		local
			l_alloc_func: CE_ROUTINE
			l_realloc_func: CE_ROUTINE
			l_free_func: CE_ROUTINE
		do
			l_alloc_func := a_alloc_func
			l_realloc_func := a_realloc_func
			l_free_func := a_free_func
			if l_alloc_func.is_void then
				l_alloc_func := (create {P_MEMORY_STATIC}).gmp_default_allocate_address
			end
			if l_realloc_func.is_void then
				l_realloc_func := (create {P_MEMORY_STATIC}).gmp_default_reallocate_address
			end
			if l_free_func.is_void then
				l_free_func := (create {P_MEMORY_STATIC}).gmp_default_free_address
			end
			(create {P_MEMORY_STATIC}).gmp_allocate_func.item := l_alloc_func;
			(create {P_MEMORY_STATIC}).gmp_reallocate_func.item := l_realloc_func;
			(create {P_MEMORY_STATIC}).gmp_free_func.item := l_free_func
		end

end
