class
	P_MU_DIVAPPR_Q_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_mu_divappr_q (a_qp, a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_np: CE_POINTER [NATURAL_32]
			l_nn: INTEGER_32
			l_dp: CE_POINTER [NATURAL_32]
			l_dn: INTEGER_32
			l_qn: INTEGER_32
			l_in: INTEGER_32
			l_cy: NATURAL_32
			l_qh: NATURAL_32
			l_ip: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			l_np := a_np
			l_nn := a_nn
			l_dp := a_dp
			l_dn := a_dn
			l_qn := l_nn - l_dn
			if l_qn + 1 < l_dn then
				l_np := l_np + (l_dn - (l_qn + 1))
				l_nn := l_nn - (l_dn - (l_qn + 1))
				l_dp := l_dp + (l_dn - (l_qn + 1))
				l_dn := l_qn + 1
			end
			l_in := gmpn_mu_divappr_q_choose_in (l_qn, l_dn, 0)
			l_ip := a_scratch
			l_tp := (a_scratch + l_in) + 1
			if l_dn = l_in then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_tp + 1, l_dp, l_in)
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				l_tp[0] := (1).to_natural_32;
				(create {P_INVERTAPPR_STATIC}).gmpn_invertappr (l_ip, l_tp, l_in + 1, create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)).do_nothing
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (l_ip, (l_ip + 1), l_in)
					l_break := True
				end
				l_break := False
			else
				l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (l_tp, (l_dp + l_dn) - (l_in + 1), l_in + 1, (1).to_natural_32)
				if (builtin_expect ((l_cy /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_in /= 0 then
							l___dst := l_ip
							l___n := l_in
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp := l___dst
								l___dst := l___dst + 1
								l_tmp.item := (0).to_natural_32
								l___n := l___n - 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
				else
					(create {P_INVERTAPPR_STATIC}).gmpn_invertappr (l_ip, l_tp, l_in + 1, create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)).do_nothing
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_ip, (l_ip + 1), l_in)
						l_break := True
					end
					l_break := False
				end
			end
			l_qh := gmpn_preinv_mu_divappr_q (a_qp, l_np, l_nn, l_dp, l_dn, l_ip, l_in, a_scratch + l_in)
			Result := l_qh
		end

	gmpn_preinv_mu_divappr_q (a_qp, a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_ip: CE_POINTER [NATURAL_32]; a_in: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_scratch: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_dn: CE_ARRAY [INTEGER_32]
			l_qp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_np: CE_POINTER [NATURAL_32]
			l_ip: CE_POINTER [NATURAL_32]
			l_in: INTEGER_32
			l_qn: INTEGER_32
			l_cy: CE_ARRAY [NATURAL_32]
			l_cx: CE_ARRAY [NATURAL_32]
			l_qh: NATURAL_32
			l_r: NATURAL_32
			l_tn: INTEGER_32
			l_wn: INTEGER_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_i: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_scratch.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_dn.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_qp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cx.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___1.make (<<1>>)

			l_scratch.item := a_scratch
			l_dn.item := a_dn
			l_qp.item := a_qp
			l_np := a_np
			l_ip := a_ip
			l_in := a_in
			l_qn := a_nn - l_dn.item
			l_np := l_np + l_qn
			l_qp.item := l_qp.item + l_qn
			l_qh := (((create {P_GMP_STATIC}).gmpn_cmp (l_np, a_dp, l_dn.item)) >= 0).to_integer.to_natural_32
			if l_qh /= {NATURAL_32} 0 then
				(create {P_GMP_STATIC}).gmpn_sub_n (l_scratch.item, l_np, a_dp, l_dn.item).do_nothing
			else
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_scratch.item, l_np, l_dn.item)
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
			end
			if l_qn = 0 then
				Result := l_qh
				l_return := True
			end
			if not l_return then
				from
				until
					not (not (l_return or l_break) and then (l_qn > 0))
				loop
					l_break := False
					if l_qn < l_in then
						l_ip := l_ip + (l_in - l_qn)
						l_in := l_qn
					end
					l_np := l_np - l_in
					l_qp.item := l_qp.item - l_in;
					(create {P_MUL_N_STATIC}).gmpn_mul_n (l_scratch.item + l_dn.item, ((l_scratch.item + l_dn.item) - l_in), l_ip, l_in)
					l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_qp.item, ((l_scratch.item + l_dn.item) + l_in), ((l_scratch.item + l_dn.item) - l_in), l_in)
					from
					until
						(l_break)
					loop
						l_break := False
						if l_cy.item /= {NATURAL_32} 0 then
							(create {P_ASSERT_STATIC}).gmp_assert_fail (ce_string ("mu_divappr_q.c"), 195, ce_string ("cy == 0"))
						end
						l_break := True
					end
					l_break := False
					l_qn := l_qn - l_in
					if l_qn = 0 then
						l_break := True
					end
					if not (l_return or l_break) then
						if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_in >= 58 then
								l_tn := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (l_dn.item + 1);
								(create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1 (l_scratch.item + l_dn.item, l_tn, a_dp, l_dn.item, l_qp.item, l_in, (l_scratch.item + l_dn.item) + l_tn)
								l_wn := (l_dn.item + l_in) - l_tn
								if l_wn > 0 then
									l_cy.item := (create {P_GMP_STATIC}).gmpn_sub_n (l_scratch.item + l_dn.item, (l_scratch.item + l_dn.item), ((l_scratch.item + l_dn.item) - l_wn), l_wn)
									l_cy.item := (create {P_GMP_STATIC}).gmpn_sub_1 ((l_scratch.item + l_dn.item) + l_wn, ((l_scratch.item + l_dn.item) + l_wn), l_tn - l_wn, l_cy.item)
									l_cx.item := (((create {P_GMP_STATIC}).gmpn_cmp (((l_scratch.item + l_dn.item) - l_in), ((l_scratch.item + l_dn.item) + l_dn.item), l_tn - l_dn.item)) < 0).to_integer.to_natural_32
									from
									until
										(l_break)
									loop
										l_break := False
										if not (l_cx.item >= l_cy.item) then
											(create {P_ASSERT_STATIC}).gmp_assert_fail (ce_string ("mu_divappr_q.c"), 217, ce_string ("cx >= cy"))
										end
										l_break := True
									end
									l_break := False
									from
									until
										(l_break)
									loop
										l_break := False
										asm317 (l___ptr_dummy, l_scratch, l_dn, l_cx, l_cy)
										l_break := True
									end
									l_break := False
								end
							else
								(create {P_MUL_STATIC}).gmpn_mul (l_scratch.item + l_dn.item, a_dp, l_dn.item, l_qp.item, l_in).do_nothing
							end
						else
							(create {P_MUL_STATIC}).gmpn_mul (l_scratch.item + l_dn.item, a_dp, l_dn.item, l_qp.item, l_in).do_nothing
						end
						l_r := l_scratch.item[(l_dn.item - l_in)] - (l_scratch.item + l_dn.item)[l_dn.item]
						if l_dn.item /= l_in then
							l_cy.item := (create {P_GMP_STATIC}).gmpn_sub_n (l_scratch.item + l_dn.item, l_np, (l_scratch.item + l_dn.item), l_in)
							l_cy.item := (create {P_GMP_IMPL_STATIC}).gmpn_sub_nc ((l_scratch.item + l_dn.item) + l_in, l_scratch.item, ((l_scratch.item + l_dn.item) + l_in), l_dn.item - l_in, l_cy.item)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_scratch.item, (l_scratch.item + l_dn.item), l_dn.item)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						else
							l_cy.item := (create {P_GMP_STATIC}).gmpn_sub_n (l_scratch.item, l_np, (l_scratch.item + l_dn.item), l_in)
						end
						l_r := l_r - (l_cy.item)
						from
						until
							not (not (l_return) and then (l_r /= {NATURAL_32} 0))
						loop
							from
							until
								(l_break)
							loop
								l_break := False
								asm318 (l___ptr_dummy___0, l_qp)
								l_break := True
							end
							l_break := False
							l_cy.item := (create {P_GMP_STATIC}).gmpn_sub_n (l_scratch.item, l_scratch.item, a_dp, l_dn.item)
							l_r := l_r - (l_cy.item)
						end
						if ((create {P_GMP_STATIC}).gmpn_cmp (l_scratch.item, a_dp, l_dn.item)) >= 0 then
							from
							until
								(l_break)
							loop
								l_break := False
								asm319 (l___ptr_dummy___1, l_qp)
								l_break := True
							end
							l_break := False
							l_cy.item := (create {P_GMP_STATIC}).gmpn_sub_n (l_scratch.item, l_scratch.item, a_dp, l_dn.item)
						end
					end
				end
				l_break := False
				l_qn := a_nn - l_dn.item
				l_cy.item := l_cy.item + ((create {P_GMP_STATIC}).gmpn_add_1 (l_qp.item, l_qp.item, l_qn, (3).to_natural_32))
				if l_cy.item /= {NATURAL_32} 0 then
					if l_qh /= {NATURAL_32} 0 then
						l_i := (0).to_integer_32
						from
						until
							not (l_i < l_qn)
						loop
							l_qp.item[l_i] := {NATURAL_32} 4_294_967_295
							l_i := l_i + 1
						end
					else
						l_qh := (1).to_natural_32
					end
				end
				Result := l_qh
			end
		end

	gmpn_mu_divappr_q_choose_in (a_qn, a_dn: INTEGER_32; a_k: INTEGER_32): INTEGER_32
		local
			l_in: INTEGER_32
			l_b: INTEGER_32
			l_xn: INTEGER_32
		do
			if a_k = 0 then
				if a_qn > a_dn then
					l_b := (a_qn - 1) // a_dn + 1
					l_in := (a_qn - 1) // l_b + 1
				elseif 3 * a_qn > a_dn then
					l_in := (a_qn - 1) // 2 + 1
				else
					l_in := (a_qn - 1) + 1
				end
			else
				if a_dn < a_qn then
					l_xn := a_dn
				else
					l_xn := a_qn
				end
				l_in := (l_xn - 1) // a_k.to_integer_32 + 1
			end
			Result := l_in
		end

	gmpn_mu_divappr_q_itch (a_nn, a_dn: INTEGER_32; a_mua_k: INTEGER_32): INTEGER_32
		local
			l_dn: INTEGER_32
			l_qn: INTEGER_32
			l_in: INTEGER_32
			l_itch_local: INTEGER_32
			l_itch_out: INTEGER_32
		do
			l_dn := a_dn
			l_qn := a_nn - l_dn
			if l_qn + 1 < l_dn then
				l_dn := l_qn + 1
			end
			l_in := gmpn_mu_divappr_q_choose_in (l_qn, l_dn, a_mua_k)
			l_itch_local := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (l_dn + 1)
			l_itch_out := (create {P_GMP_IMPL_STATIC}).mpn_mulmod_bnm1_itch (l_itch_local, l_dn, l_in)
			Result := (((l_in + l_dn) + l_itch_local) + l_itch_out)
		end

end
