class
	P_MULLO_N_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	mpn_mullo_n_itch (a_n: INTEGER_32): INTEGER_32
		do
			Result := (2 * a_n)
		end

	mpn_dc_mullo_n (a_rp, a_xp, a_yp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_n2: INTEGER_32
			l_n1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if 110 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if a_n >= 110 then
					if 234 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if a_n >= 234 then
							if 423 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if a_n >= 423 then
									l_n1 := (a_n.to_natural_32 // {NATURAL_32} 10).to_integer_32
								else
									l_n1 := ((a_n * 7).to_natural_32 // {NATURAL_32} 39).to_integer_32
								end
							else
								l_n1 := ((a_n * 7).to_natural_32 // {NATURAL_32} 39).to_integer_32
							end
						else
							l_n1 := ((a_n * 9).to_natural_32 // {NATURAL_32} 40).to_integer_32
						end
					else
						l_n1 := ((a_n * 9).to_natural_32 // {NATURAL_32} 40).to_integer_32
					end
				else
					l_n1 := ((a_n * 11).to_natural_32 // {NATURAL_32} 36).to_integer_32
				end
			else
				l_n1 := ((a_n * 11).to_natural_32 // {NATURAL_32} 36).to_integer_32
			end
			l_n2 := a_n - l_n1;
			(create {P_MUL_N_STATIC}).gmpn_mul_n (a_tp, a_xp, a_yp, l_n2)
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (a_rp, a_tp, l_n2)
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			if 34 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_n1 >= 34 then
					mpn_dc_mullo_n (a_tp + a_n, a_xp + l_n2, a_yp, l_n1, a_tp + a_n)
				else
					(create {P_MULLO_BASECASE_STATIC}).gmpn_mullo_basecase (a_tp + a_n, a_xp + l_n2, a_yp, l_n1)
				end
			else
				(create {P_MULLO_BASECASE_STATIC}).gmpn_mullo_basecase (a_tp + a_n, a_xp + l_n2, a_yp, l_n1)
			end
			(create {P_GMP_STATIC}).gmpn_add_n (a_rp + l_n2, (a_tp + l_n2), (a_tp + a_n), l_n1).do_nothing
			if 34 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_n1 >= 34 then
					mpn_dc_mullo_n (a_tp + a_n, a_xp, a_yp + l_n2, l_n1, a_tp + a_n)
				else
					(create {P_MULLO_BASECASE_STATIC}).gmpn_mullo_basecase (a_tp + a_n, a_xp, a_yp + l_n2, l_n1)
				end
			else
				(create {P_MULLO_BASECASE_STATIC}).gmpn_mullo_basecase (a_tp + a_n, a_xp, a_yp + l_n2, l_n1)
			end
			(create {P_GMP_STATIC}).gmpn_add_n (a_rp + l_n2, (a_rp + l_n2), (a_tp + a_n), l_n1).do_nothing
		end

	gmpn_mullo_n (a_rp, a_xp, a_yp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32)
		local
			l_tp___0: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___5: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			if 34 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if a_n >= 34 then
					l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
					if (builtin_expect (((mpn_mullo_n_itch (a_n)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___5 := (l_aaf.new (((mpn_mullo_n_itch (a_n)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___5 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((mpn_mullo_n_itch (a_n)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_tp___0 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___5)
					if 8_907 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if a_n >= 8_907 then
							(create {P_NUSSBAUMER_MUL_STATIC}).gmpn_nussbaumer_mul (l_tp___0, a_xp, a_n, a_yp, a_n)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (a_rp, l_tp___0, a_n)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						else
							mpn_dc_mullo_n (a_rp, a_xp, a_yp, a_n, l_tp___0)
						end
					else
						mpn_dc_mullo_n (a_rp, a_xp, a_yp, a_n, l_tp___0)
					end
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
							(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						end
						l_break := True
					end
					l_break := False
				else
					(create {P_MULLO_BASECASE_STATIC}).gmpn_mullo_basecase (a_rp, a_xp, a_yp, a_n)
				end
			else
				(create {P_MULLO_BASECASE_STATIC}).gmpn_mullo_basecase (a_rp, a_xp, a_yp, a_n)
			end
		end

end
