class
	P_SSCANFFUNS_STATIC

inherit
	CE_UTILITIES
	S_STDIO_STATIC

feature {ANY} -- public attributes

	gmp_sscanf_funs: CE_STATIC [CE_ARRAY [PD_GMP_DOSCAN_FUNS_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GMP_DOSCAN_FUNS_T]}.make_initialized (<<
					create {PD_GMP_DOSCAN_FUNS_T}.make_initialized ([(scan_address), (step___0_address), (get_address), (unget_address)])
				>>)
		end

feature {ANY} -- public routines

	scan (a_args: TUPLE [a_sp: CE_POINTER [CE_POINTER [INTEGER_8]]; a_fmt: CE_POINTER [INTEGER_8]]): INTEGER_32
		require
			not a_args.a_sp.is_void
		local
			l_ap: CE_VA_LIST
			l_p1: CE_POINTER [ANY]
			l_p2: CE_POINTER [ANY]
			l_ret: INTEGER_32
		do
			create l_ap.make_shared (default_pointer)

			l_ap := create {CE_VA_LIST}.make (a_args, agent scan)
			l_p1 := (create {CE_VOID_POINTER}.make_cast (l_ap.pointer_item))
			l_p2 := (create {CE_VOID_POINTER}.make_cast (l_ap.pointer_item))
			l_ret := sscanf ([a_args.a_sp.item, a_args.a_fmt, l_p1, l_p2])
			Result := l_ret
		end

	step___0 (a_sp: CE_POINTER [CE_POINTER [INTEGER_8]]; a_n: INTEGER_32)
		require
			not a_sp.is_void
		do
			a_sp.item := a_sp.item + a_n
		end

	get (a_sp: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		require
			not a_sp.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_c: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_s := a_sp.item
			l_tmp := l_s
			l_s := l_s + 1
			l_c := ((l_tmp[0]).to_natural_8).to_integer_32
			if l_c = 0 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				a_sp.item := l_s
				Result := l_c
			end
		end

	unget (a_c: INTEGER_32; a_sp: CE_POINTER [CE_POINTER [INTEGER_8]])
		require
			not a_sp.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_s := a_sp.item
			if a_c = -1 then
				l_return := True
			end
			if not l_return then
				l_s := l_s - 1
				a_sp.item := l_s
			end
		end

feature {ANY} -- routine addresses

	scan_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent scan)
		end

	step___0_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent step___0)
		end

	get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent get)
		end

	unget_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent unget)
		end

end
