class
	P_TDIV_QR_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpz_tdiv_qr (a_quot, a_rem, a_num, a_den: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_rem.is_void
			not a_num.is_void
			not a_den.is_void
		local
			l_ql: INTEGER_32
			l_ns: INTEGER_32
			l_ds: INTEGER_32
			l_nl: INTEGER_32
			l_dl: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_np___0: CE_POINTER [NATURAL_32]
			l_rp___0: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp___4: CE_POINTER [ANY]
			l_tp___0: CE_POINTER [NATURAL_32]
			l_tmp___9: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ns := (a_num.item.mp_size).to_integer_32
					l_ds := (a_den.item.mp_size).to_integer_32
					if l_ns >= 0 then
						l_nl := l_ns
					else
						l_nl := -l_ns
					end
					if l_ds >= 0 then
						l_dl := l_ds
					else
						l_dl := -l_ds
					end
					l_ql := (l_nl - l_dl) + 1
					if l_dl = 0 then
						(create {P_ERRNO_STATIC}).gmp_divide_by_zero
					end
					if (builtin_expect ((l_dl > (a_rem.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						a_rem.item.gmpz_realloc (l_dl).do_nothing
					end
					if l_ql <= 0 then
						if not a_num.is_equal (a_rem) then
							l_np___0 := a_num.item.mp_d
							l_rp___0 := a_rem.item.mp_d
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_rp___0, l_np___0, l_nl)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							a_rem.item.mp_size := a_num.item.mp_size
						end
						a_quot.item.mp_size := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if (builtin_expect ((l_ql > (a_quot.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							a_quot.item.gmpz_realloc (l_ql).do_nothing
						end
						l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						l_qp := a_quot.item.mp_d
						l_rp := a_rem.item.mp_d
						l_np := a_num.item.mp_d
						l_dp := a_den.item.mp_d
						if not (l_dp.is_equal (l_rp)) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (l_dp.is_equal (l_qp)) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (builtin_expect ((l_dl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___4 := (l_aaf.new ((l_dl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___4 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_dl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___4)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_dp, l_dl)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_dp := l_tp
				when 6 then -- if done
						if not (l_np.is_equal (l_rp)) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if not (l_np.is_equal (l_qp)) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L___0:
						if (builtin_expect ((l_nl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___9 := (l_aaf.new ((l_nl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___9 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_nl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp___0 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___9)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_tp___0, l_np, l_nl)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_np := l_tp___0
				when 11 then -- if done
						gmpn_tdiv_qr (l_qp, l_rp, 0, l_np, l_nl, l_dp, l_dl)
						l_ql := l_ql - (l_qp[(l_ql - 1)] = {NATURAL_32} 0).to_integer
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_dl > 0))
							loop
								l_break := False
								if l_rp[(l_dl - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_dl := l_dl - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if ((l_ns).bit_xor (l_ds)) >= 0 then
							a_quot.item.mp_size := l_ql.to_integer_32
						else
							a_quot.item.mp_size := (-l_ql).to_integer_32
						end
						if l_ns >= 0 then
							a_rem.item.mp_size := l_dl.to_integer_32
						else
							a_rem.item.mp_size := (-l_dl).to_integer_32
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_tdiv_qr (a_qp, a_rp: CE_POINTER [NATURAL_32]; a_qxn: INTEGER_32; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32)
		require
			not a_dp.is_void
		local
			l_dn: CE_ARRAY [INTEGER_32]
			l_qp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_nn: INTEGER_32
			l_n2p: CE_POINTER [NATURAL_32]
			l_d2p: CE_POINTER [NATURAL_32]
			l_qhl: NATURAL_32
			l_cy: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_cnt: INTEGER_32
			l_dtmp: CE_ARRAY [NATURAL_32]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_adjust: INTEGER_32
			l_dinv: CE_ARRAY [PD_GMP_PI1_T]
			l___tmp_marker___0: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_n2p___0: CE_POINTER [NATURAL_32]
			l_d2p___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_cy___0: NATURAL_32
			l_cnt___0: INTEGER_32
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___18: CE_POINTER [ANY]
			l_tmp___23: CE_POINTER [ANY]
			l_v: CE_ARRAY [NATURAL_32]
			l_p: NATURAL_32
			l_t1: CE_ARRAY [NATURAL_32]
			l_t0: CE_ARRAY [NATURAL_32]
			l_mask: NATURAL_32
			l_itch: INTEGER_32
			l_scratch: CE_POINTER [NATURAL_32]
			l_tmp___30: CE_POINTER [ANY]
			l_qn: CE_ARRAY [INTEGER_32]
			l_n2p___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_d2p___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_tp: CE_POINTER [NATURAL_32]
			l_cy___1: NATURAL_32
			l_in: INTEGER_32
			l_rn: INTEGER_32
			l_quotient_too_large: NATURAL_32
			l_cnt___1: NATURAL_32
			l_tmp___38: CE_POINTER [ANY]
			l_tmp___43: CE_POINTER [ANY]
			l_tmp___48: CE_POINTER [ANY]
			l_q0: CE_ARRAY [NATURAL_32]
			l_r0: CE_ARRAY [NATURAL_32]
			l_v___0: CE_ARRAY [NATURAL_32]
			l_p___0: NATURAL_32
			l_t1___0: CE_ARRAY [NATURAL_32]
			l_t0___0: CE_ARRAY [NATURAL_32]
			l_mask___0: NATURAL_32
			l_itch___0: INTEGER_32
			l_scratch___0: CE_POINTER [NATURAL_32]
			l_tmp___55: CE_POINTER [ANY]
			l_r2p: CE_POINTER [NATURAL_32]
			l_dl: NATURAL_32
			l_x___2: CE_ARRAY [NATURAL_32]
			l_h: CE_ARRAY [NATURAL_32]
			l_dummy: CE_ARRAY [NATURAL_32]
			l_cy___2: NATURAL_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_cy1: NATURAL_32
			l_cy2: NATURAL_32
			l_tmp___60: CE_POINTER [ANY]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_INTEGER_32_ARRAY} l_dn.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_qp.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_dtmp.make (<<2>>)
			create {CE_CLASS_ARRAY [PD_GMP_PI1_T]} l_dinv.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_d2p___0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_v.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_t1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_t0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_qn.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_n2p___1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_d2p___1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_q0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_r0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_v___0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_t1___0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_t0___0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_x___2.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_h.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dn.item := a_dn
					l_qp.item := a_qp
					l_nn := a_nn
					from
					until
						(l_break)
					loop
						l_break := False
						if a_qxn /= 0 then
							(create {P_ASSERT_STATIC}).gmp_assert_fail (ce_string ("tdiv_qr.c"), 40, ce_string ("qxn == 0"))
						end
						l_break := True
					end
					l_break := False
					inspect (l_dn.item).to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 0;
					(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				when 2 then -- switch 1, case 1
					a_rp[0] := (create {P_GMP_STATIC}).gmpn_divrem_1 (l_qp.item, (0).to_integer_32, a_np, l_nn, a_dp[0])
					l_return := True
				when 3 then -- switch 1, case 2
					if not l_return then
						l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						if ((a_dp[1]).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))) = {NATURAL_32} 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_cnt := builtin_clzl (a_dp[1])
								l_break := True
							end
							l_break := False
							l_cnt := l_cnt
							l_d2p := l_dtmp
							l_d2p[1] := ((((a_dp[1]).bit_shift_left (l_cnt))).bit_or (((a_dp[0]).bit_shift_right ((32 - l_cnt)))))
							l_d2p[0] := ((((a_dp[0]).bit_shift_left (l_cnt))).bit_and ({NATURAL_32} 4_294_967_295))
							if (builtin_expect (((l_nn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___2 := (l_aaf.new (((l_nn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___2 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_nn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_n2p := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
							l_cy := (create {P_GMP_STATIC}).gmpn_lshift (l_n2p, a_np, l_nn, l_cnt.to_natural_32)
							l_n2p[l_nn] := l_cy
							l_qhl := (create {P_GMP_STATIC}).gmpn_divrem_2 (l_qp.item, 0, l_n2p, l_nn + (l_cy /= {NATURAL_32} 0).to_integer, l_d2p)
							if l_cy = {NATURAL_32} 0 then
								l_qp.item[(l_nn - 2)] := l_qhl
							end
							a_rp[0] := (((l_n2p[0]).bit_shift_right (l_cnt))).bit_or (((((l_n2p[1]).bit_shift_left ((32 - l_cnt)))).bit_and ({NATURAL_32} 4_294_967_295)))
							a_rp[1] := (l_n2p[1]).bit_shift_right (l_cnt)
						else
							l_d2p := a_dp
							if (builtin_expect ((l_nn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___7 := (l_aaf.new ((l_nn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___7 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_nn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_n2p := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___7)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_n2p, a_np, l_nn)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							l_qhl := (create {P_GMP_STATIC}).gmpn_divrem_2 (l_qp.item, 0, l_n2p, l_nn, l_d2p)
							l_qp.item[(l_nn - 2)] := l_qhl
							a_rp[0] := l_n2p[0]
							a_rp[1] := l_n2p[1]
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
						l_return := True
					end
				when 4 then -- switch 1, default:
					if not l_return then
						l___tmp_marker___0.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						l_adjust := (a_np[(l_nn - 1)] >= a_dp[(l_dn.item - 1)]).to_integer
						if l_nn + l_adjust.to_integer_32 >= 2 * l_dn.item then
							l_qp.item[(l_nn - l_dn.item)] := (0).to_natural_32
							if ((a_dp[(l_dn.item - 1)]).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))) = {NATURAL_32} 0 then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_cnt___0 := builtin_clzl (a_dp[(l_dn.item - 1)])
									l_break := True
								end
								l_break := False
								l_cnt___0 := l_cnt___0
								if (builtin_expect (((l_dn.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
									l_tmp___13 := (l_aaf.new (((l_dn.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								else
									l_tmp___13 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker___0, ((l_dn.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								end
								l_d2p___0.item := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___13);
								(create {P_GMP_STATIC}).gmpn_lshift (l_d2p___0.item, a_dp, l_dn.item, l_cnt___0.to_natural_32).do_nothing
								if (builtin_expect (((l_nn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
									l_tmp___18 := (l_aaf.new (((l_nn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								else
									l_tmp___18 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker___0, ((l_nn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								end
								l_n2p___0 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___18)
								l_cy___0 := (create {P_GMP_STATIC}).gmpn_lshift (l_n2p___0, a_np, l_nn, l_cnt___0.to_natural_32)
								l_n2p___0[l_nn] := l_cy___0
								l_nn := l_nn + l_adjust.to_integer_32
							else
								l_cnt___0 := 0
								l_d2p___0.item := a_dp
								if (builtin_expect (((l_nn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
									l_tmp___23 := (l_aaf.new (((l_nn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								else
									l_tmp___23 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker___0, ((l_nn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								end
								l_n2p___0 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___23)
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_n2p___0, a_np, l_nn)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								l_n2p___0[l_nn] := (0).to_natural_32
								l_nn := l_nn + l_adjust.to_integer_32
							end
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l_v.item := (create {P_GMP_IMPL_STATIC}).gmpn_invert_limb (l_d2p___0.item[(l_dn.item - 1)])
									l_break := True
								end
								l_break := False
								l_p := l_d2p___0.item[(l_dn.item - 1)] * l_v.item
								l_p := l_p + (l_d2p___0.item[(l_dn.item - 2)])
								if l_p < l_d2p___0.item[(l_dn.item - 2)] then
									l_v.item := l_v.item - 1
									l_mask := (-(l_p >= l_d2p___0.item[(l_dn.item - 1)]).to_integer).to_integer.to_natural_32
									l_p := l_p - (l_d2p___0.item[(l_dn.item - 1)])
									l_v.item := l_v.item + l_mask
									l_p := l_p - ((l_mask).bit_and (l_d2p___0.item[(l_dn.item - 1)]))
								end
								asm116 (l_t0, l_t1, l_d2p___0, l_dn, l_v)
								l_p := l_p + (l_t1.item)
								if l_p < l_t1.item then
									l_v.item := l_v.item - 1
									if (builtin_expect ((l_p >= l_d2p___0.item[(l_dn.item - 1)]).to_integer, 0)).to_boolean then
										if l_p > l_d2p___0.item[(l_dn.item - 1)] then
											l_v.item := l_v.item - 1
										elseif l_t0.item >= l_d2p___0.item[(l_dn.item - 2)] then
											l_v.item := l_v.item - 1
										end
									end
								end
								l_dinv.item.inv32 := l_v.item
								l_break := True
							end
							l_break := False
							if 19 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_dn.item >= 19 then
									if 62 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
										if l_dn.item >= 62 then
											if 2_616 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
												if l_nn >= 2_616 then
													if (2_492).to_double * (l_dn.item).to_double + (62).to_double * l_nn.to_double > (l_dn.item).to_double * l_nn.to_double then
														(create {P_DCPI1_DIV_QR_STATIC}).gmpn_dcpi1_div_qr (l_qp.item, l_n2p___0, l_nn, l_d2p___0.item, l_dn.item, l_dinv).do_nothing
													else
														l_itch := ((create {P_MU_DIV_QR_STATIC}).gmpn_mu_div_qr_itch (l_nn, l_dn.item, 0))
														if (builtin_expect ((l_itch.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
															l_tmp___30 := (l_aaf.new ((l_itch.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
														else
															l_tmp___30 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker___0, (l_itch.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
														end
														l_scratch := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___30);
														(create {P_MU_DIV_QR_STATIC}).gmpn_mu_div_qr (l_qp.item, a_rp, l_n2p___0, l_nn, l_d2p___0.item, l_dn.item, l_scratch).do_nothing
														l_n2p___0 := a_rp
													end
												else
													(create {P_DCPI1_DIV_QR_STATIC}).gmpn_dcpi1_div_qr (l_qp.item, l_n2p___0, l_nn, l_d2p___0.item, l_dn.item, l_dinv).do_nothing
												end
											else
												(create {P_DCPI1_DIV_QR_STATIC}).gmpn_dcpi1_div_qr (l_qp.item, l_n2p___0, l_nn, l_d2p___0.item, l_dn.item, l_dinv).do_nothing
											end
										else
											(create {P_DCPI1_DIV_QR_STATIC}).gmpn_dcpi1_div_qr (l_qp.item, l_n2p___0, l_nn, l_d2p___0.item, l_dn.item, l_dinv).do_nothing
										end
									else
										(create {P_DCPI1_DIV_QR_STATIC}).gmpn_dcpi1_div_qr (l_qp.item, l_n2p___0, l_nn, l_d2p___0.item, l_dn.item, l_dinv).do_nothing
									end
								else
									(create {P_SBPI1_DIV_QR_STATIC}).gmpn_sbpi1_div_qr (l_qp.item, l_n2p___0, l_nn, l_d2p___0.item, l_dn.item, l_dinv.item.inv32).do_nothing
								end
							else
								(create {P_SBPI1_DIV_QR_STATIC}).gmpn_sbpi1_div_qr (l_qp.item, l_n2p___0, l_nn, l_d2p___0.item, l_dn.item, l_dinv.item.inv32).do_nothing
							end
							if l_cnt___0 /= 0 then
								(create {P_GMP_STATIC}).gmpn_rshift (a_rp, l_n2p___0, l_dn.item, l_cnt___0.to_natural_32).do_nothing
							else
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (a_rp, l_n2p___0, l_dn.item)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
							end
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect ((not (l___tmp_marker___0.item).is_void).to_integer, 0)).to_boolean then
									(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker___0.item)
								end
								l_break := True
							end
							l_break := False
							l_return := True
						end
					end
					if not l_return then
						l_qn.item := l_nn - l_dn.item
						l_qp.item[l_qn.item] := (0).to_natural_32
						l_qn.item := l_qn.item + l_adjust.to_integer_32
						if l_qn.item = 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (a_rp, a_np, l_dn.item)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect ((not (l___tmp_marker___0.item).is_void).to_integer, 0)).to_boolean then
									(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker___0.item)
								end
								l_break := True
							end
							l_break := False
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 5 then -- if:
						l_in := l_dn.item - l_qn.item
						if ((a_dp[(l_dn.item - 1)]).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))) = {NATURAL_32} 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_cnt___1 := (builtin_clzl (a_dp[(l_dn.item - 1)])).to_natural_32
								l_break := True
							end
							l_break := False
							l_cnt___1 := l_cnt___1
							if (builtin_expect (((l_qn.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___38 := (l_aaf.new (((l_qn.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___38 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker___0, ((l_qn.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_d2p___1.item := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___38);
							(create {P_GMP_STATIC}).gmpn_lshift (l_d2p___1.item, a_dp + l_in, l_qn.item, l_cnt___1).do_nothing
							l_d2p___1.item[0] := (l_d2p___1.item[0]).bit_or (((a_dp[(l_in - 1)]).bit_shift_right (({NATURAL_32} 32 - l_cnt___1).to_integer_32)))
							if (builtin_expect (((2 * l_qn.item + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___43 := (l_aaf.new (((2 * l_qn.item + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___43 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker___0, ((2 * l_qn.item + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_n2p___1.item := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___43)
							l_cy___1 := (create {P_GMP_STATIC}).gmpn_lshift (l_n2p___1.item, (a_np + l_nn) - 2 * l_qn.item, 2 * l_qn.item, l_cnt___1)
							if l_adjust.to_boolean then
								l_n2p___1.item[2 * l_qn.item] := l_cy___1
								l_n2p___1.item := l_n2p___1.item + 1
							else
								l_n2p___1.item[0] := (l_n2p___1.item[0]).bit_or (((a_np[((l_nn - 2 * l_qn.item) - 1)]).bit_shift_right (({NATURAL_32} 32 - l_cnt___1).to_integer_32)))
							end
						else
							l_cnt___1 := {NATURAL_32} 0
							l_d2p___1.item := a_dp + l_in
							if (builtin_expect (((2 * l_qn.item + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___48 := (l_aaf.new (((2 * l_qn.item + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___48 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker___0, ((2 * l_qn.item + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_n2p___1.item := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___48)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_n2p___1.item, (a_np + l_nn) - 2 * l_qn.item, 2 * l_qn.item)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							if l_adjust.to_boolean then
								l_n2p___1.item[2 * l_qn.item] := (0).to_natural_32
								l_n2p___1.item := l_n2p___1.item + 1
							end
						end
						if l_qn.item = 1 then
							asm117 (l_q0, l_r0, l_n2p___1, l_d2p___1)
							l_n2p___1.item[0] := l_r0.item
							l_qp.item[0] := l_q0.item
						elseif l_qn.item = 2 then
							(create {P_GMP_STATIC}).gmpn_divrem_2 (l_qp.item, 0, l_n2p___1.item, 4, l_d2p___1.item).do_nothing
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l_v___0.item := (create {P_GMP_IMPL_STATIC}).gmpn_invert_limb (l_d2p___1.item[(l_qn.item - 1)])
									l_break := True
								end
								l_break := False
								l_p___0 := l_d2p___1.item[(l_qn.item - 1)] * l_v___0.item
								l_p___0 := l_p___0 + (l_d2p___1.item[(l_qn.item - 2)])
								if l_p___0 < l_d2p___1.item[(l_qn.item - 2)] then
									l_v___0.item := l_v___0.item - 1
									l_mask___0 := (-(l_p___0 >= l_d2p___1.item[(l_qn.item - 1)]).to_integer).to_integer.to_natural_32
									l_p___0 := l_p___0 - (l_d2p___1.item[(l_qn.item - 1)])
									l_v___0.item := l_v___0.item + l_mask___0
									l_p___0 := l_p___0 - ((l_mask___0).bit_and (l_d2p___1.item[(l_qn.item - 1)]))
								end
								asm118 (l_t0___0, l_t1___0, l_d2p___1, l_qn, l_v___0)
								l_p___0 := l_p___0 + (l_t1___0.item)
								if l_p___0 < l_t1___0.item then
									l_v___0.item := l_v___0.item - 1
									if (builtin_expect ((l_p___0 >= l_d2p___1.item[(l_qn.item - 1)]).to_integer, 0)).to_boolean then
										if l_p___0 > l_d2p___1.item[(l_qn.item - 1)] then
											l_v___0.item := l_v___0.item - 1
										elseif l_t0___0.item >= l_d2p___1.item[(l_qn.item - 2)] then
											l_v___0.item := l_v___0.item - 1
										end
									end
								end
								l_dinv.item.inv32 := l_v___0.item
								l_break := True
							end
							l_break := False
							if 19 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_qn.item >= 19 then
									if 1_308 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
										if l_qn.item >= 1_308 then
											l_itch___0 := ((create {P_MU_DIV_QR_STATIC}).gmpn_mu_div_qr_itch (2 * l_qn.item, l_qn.item, 0))
											if (builtin_expect ((l_itch___0.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
												l_tmp___55 := (l_aaf.new ((l_itch___0.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
											else
												l_tmp___55 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker___0, (l_itch___0.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
											end
											l_scratch___0 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___55)
											l_r2p := a_rp
											if a_np.is_equal (l_r2p) then
												l_r2p := l_r2p + (l_nn - l_qn.item)
											end
											(create {P_MU_DIV_QR_STATIC}).gmpn_mu_div_qr (l_qp.item, l_r2p, l_n2p___1.item, 2 * l_qn.item, l_d2p___1.item, l_qn.item, l_scratch___0).do_nothing
											from
											until
												(l_return or l_break)
											loop
												l_break := False
												from
												until
													(l_return or l_break)
												loop
													l_break := False;
													(create {P_GMP_STATIC}).gmpn_copyi (l_n2p___1.item, l_r2p, l_qn.item)
													l_break := True
												end
												l_break := False
												l_break := True
											end
											l_break := False
										else
											(create {P_DCPI1_DIV_QR_STATIC}).gmpn_dcpi1_div_qr (l_qp.item, l_n2p___1.item, 2 * l_qn.item, l_d2p___1.item, l_qn.item, l_dinv).do_nothing
										end
									else
										(create {P_DCPI1_DIV_QR_STATIC}).gmpn_dcpi1_div_qr (l_qp.item, l_n2p___1.item, 2 * l_qn.item, l_d2p___1.item, l_qn.item, l_dinv).do_nothing
									end
								else
									(create {P_SBPI1_DIV_QR_STATIC}).gmpn_sbpi1_div_qr (l_qp.item, l_n2p___1.item, 2 * l_qn.item, l_d2p___1.item, l_qn.item, l_dinv.item.inv32).do_nothing
								end
							else
								(create {P_SBPI1_DIV_QR_STATIC}).gmpn_sbpi1_div_qr (l_qp.item, l_n2p___1.item, 2 * l_qn.item, l_d2p___1.item, l_qn.item, l_dinv.item.inv32).do_nothing
							end
						end
						l_rn := l_qn.item
						if l_in - 2 < 0 then
							l_dl := (0).to_natural_32
						else
							l_dl := a_dp[(l_in - 2)]
						end
						l_x___2.item := ((((a_dp[(l_in - 1)]).bit_shift_left (l_cnt___1.to_integer_32))).bit_or (((((l_dl).bit_shift_right (1))).bit_shift_right (((l_cnt___1).bit_not \\ {NATURAL_32} 32).to_integer_32))))
						asm119 (l_dummy, l_h, l_x___2, l_qp, l_qn)
						if l_n2p___1.item[(l_qn.item - 1)] < l_h.item then
							from
							until
								(l_break)
							loop
								l_break := False
								asm120 (l___ptr_dummy, l_qp)
								l_break := True
							end
							l_break := False
							l_cy___2 := (create {P_GMP_STATIC}).gmpn_add_n (l_n2p___1.item, l_n2p___1.item, l_d2p___1.item, l_qn.item)
							if l_cy___2.to_boolean then
								l_n2p___1.item[l_qn.item] := l_cy___2
								l_rn := l_rn + 1
							end
						end
						l_quotient_too_large := (0).to_natural_32
						if l_cnt___1 /= {NATURAL_32} 0 then
							l_cy1 := (create {P_GMP_STATIC}).gmpn_lshift (l_n2p___1.item, l_n2p___1.item, l_rn, {NATURAL_32} 32 - l_cnt___1)
							l_n2p___1.item[0] := (l_n2p___1.item[0]).bit_or (((a_np[(l_in - 1)]).bit_and ((({NATURAL_32} 4_294_967_295).bit_shift_right (l_cnt___1.to_integer_32)))))
							l_cy2 := (create {P_GMP_STATIC}).gmpn_submul_1 (l_n2p___1.item, l_qp.item, l_qn.item, ((a_dp[(l_in - 1)]).bit_and ((({NATURAL_32} 4_294_967_295).bit_shift_right (l_cnt___1.to_integer_32)))))
							if l_qn.item /= l_rn then
								from
								until
									(l_break)
								loop
									l_break := False
									if not (l_n2p___1.item[l_qn.item] >= l_cy2) then
										(create {P_ASSERT_STATIC}).gmp_assert_fail (ce_string ("tdiv_qr.c"), 332, ce_string ("n2p[qn] >= cy2"))
									end
									l_break := True
								end
								l_break := False
								l_n2p___1.item[l_qn.item] := l_n2p___1.item[l_qn.item] - l_cy2
							else
								l_n2p___1.item[l_qn.item] := l_cy1 - l_cy2
								l_quotient_too_large := (l_cy1 < l_cy2).to_integer.to_natural_32
								l_rn := l_rn + 1
							end
							l_in := l_in - 1
						end
						if (builtin_expect (((l_dn.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___60 := (l_aaf.new (((l_dn.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___60 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker___0, ((l_dn.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___60)
						if not (l_in < l_qn.item) then
							l_pos := -1 + 9 -- skip if block
						end
				when 6 then -- if:
						if l_in = 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (a_rp, l_n2p___1.item, l_rn)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								if l_rn /= l_dn.item then
									(create {P_ASSERT_STATIC}).gmp_assert_fail (ce_string ("tdiv_qr.c"), 353, ce_string ("rn == dn"))
								end
								l_break := True
							end
							l_break := False
							l_pos := -1 + 11 -- goto foo
						end
				when 7 then;
						(create {P_MUL_STATIC}).gmpn_mul (l_tp, l_qp.item, l_qn.item, a_dp, l_in).do_nothing
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:;
						(create {P_MUL_STATIC}).gmpn_mul (l_tp, a_dp, l_in, l_qp.item, l_qn.item).do_nothing
				when 10 then -- if done
						l_cy___1 := (create {P_GMP_STATIC}).gmpn_sub (l_n2p___1.item, l_n2p___1.item, l_rn, (l_tp + l_in), l_qn.item)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_rp + l_in, l_n2p___1.item, l_dn.item - l_in)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_quotient_too_large := (l_quotient_too_large).bit_or (l_cy___1)
						l_cy___1 := (create {P_GMP_STATIC}).gmpn_sub_n (a_rp, a_np, l_tp, l_in)
						l_cy___1 := (create {P_GMP_STATIC}).gmpn_sub_1 (a_rp + l_in, (a_rp + l_in), l_rn, l_cy___1)
						l_quotient_too_large := (l_quotient_too_large).bit_or (l_cy___1)
				when 11 then -- foo:
						if l_quotient_too_large.to_boolean then
							from
							until
								(l_break)
							loop
								l_break := False
								asm121 (l___ptr_dummy___0, l_qp)
								l_break := True
							end
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_add_n (a_rp, a_rp, a_dp, l_dn.item).do_nothing
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l___tmp_marker___0.item).is_void).to_integer, 0)).to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker___0.item)
							end
							l_break := True
						end
						l_break := False
				when 12 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
