class
	P_TOOM63_MUL_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	abs_sub_n___0 (a_rp, a_ap, a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_x___2: NATURAL_32
			l_y: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_n := a_n
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_n := l_n - 1
				if not (l_n >= 0) then
					l_break := True
				end
				if not (l_return or l_break) then
					l_x___2 := a_ap[l_n]
					l_y := a_bp[l_n]
					if l_x___2 /= l_y then
						l_n := l_n + 1
						if l_x___2 > l_y then
							(create {P_GMP_STATIC}).gmpn_sub_n (a_rp, a_ap, a_bp, l_n).do_nothing
							Result := 0
							l_return := True
						else
							(create {P_GMP_STATIC}).gmpn_sub_n (a_rp, a_bp, a_ap, l_n).do_nothing
							Result := ((0).bit_not)
							l_return := True
						end
					end
					if not l_return then
						a_rp[l_n] := (0).to_natural_32
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 0
			end
		end

	abs_sub_add_n (a_rm, a_rp, a_rs: CE_POINTER [NATURAL_32]; a_n: INTEGER_32): INTEGER_32
		local
			l_result: INTEGER_32
		do
			l_result := abs_sub_n___0 (a_rm, a_rp, a_rs, a_n);
			(create {P_GMP_STATIC}).gmpn_add_n (a_rp, a_rp, a_rs, a_n).do_nothing
			Result := l_result
		end

	gmpn_toom63_mul (a_pp, a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		require
			not a_pp.is_void
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_t: INTEGER_32
			l_cy: NATURAL_32
			l_sign: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___3: NATURAL_32
			l_break: BOOLEAN
		do
			if a_an >= 2 * a_bn then
				l_tmp := (a_an - 1).to_natural_32 // {NATURAL_32} 6
			else
				l_tmp := (a_bn - 1).to_natural_32 // {NATURAL_32} 3
			end
			l_n := ({NATURAL_32} 1 + l_tmp).to_integer_32
			l_s := a_an - 5 * l_n
			l_t := a_bn - 2 * l_n
			l_sign := (create {P_TOOM_EVAL_PM2EXP_STATIC}).gmpn_toom_eval_pm2exp ((a_pp + 5 * l_n) + 2, a_pp + 3 * l_n, {NATURAL_32} 5, a_ap, l_n, l_s, {NATURAL_32} 2, a_pp)
			a_pp[l_n] := (create {P_GMP_STATIC}).gmpn_lshift (a_pp, a_bp + l_n, l_n, {NATURAL_32} 2);
			((a_pp + 6 * l_n) + 3)[l_t] := (create {P_GMP_STATIC}).gmpn_lshift ((a_pp + 6 * l_n) + 3, a_bp + 2 * l_n, l_t, {NATURAL_32} 4)
			if l_n = l_t then
				((a_pp + 6 * l_n) + 3)[l_n] := ((a_pp + 6 * l_n) + 3)[l_n] + ((create {P_GMP_STATIC}).gmpn_add_n ((a_pp + 6 * l_n) + 3, ((a_pp + 6 * l_n) + 3), a_bp + 0, l_n))
			else
				((a_pp + 6 * l_n) + 3)[l_n] := (create {P_GMP_STATIC}).gmpn_add ((a_pp + 6 * l_n) + 3, a_bp + 0, l_n, ((a_pp + 6 * l_n) + 3), l_t + 1)
			end
			l_sign := (l_sign).bit_xor ((abs_sub_add_n ((a_pp + 4 * l_n) + 1, (a_pp + 6 * l_n) + 3, a_pp, l_n + 1)))
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_MUL_N_STATIC}).gmpn_mul_n (a_pp, (a_pp + 3 * l_n), ((a_pp + 4 * l_n) + 1), l_n + 1)
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_MUL_N_STATIC}).gmpn_mul_n ((a_scratch + 3 * l_n) + 1, ((a_pp + 5 * l_n) + 2), ((a_pp + 6 * l_n) + 3), l_n + 1)
				l_break := True
			end
			l_break := False;
			(create {P_TOOM_COUPLE_HANDLING_STATIC}).gmpn_toom_couple_handling ((a_scratch + 3 * l_n) + 1, 2 * l_n + 1, a_pp, l_sign, l_n, 2, 4)
			l_sign := (create {P_TOOM_EVAL_PM1_STATIC}).gmpn_toom_eval_pm1 ((a_pp + 5 * l_n) + 2, a_pp + 3 * l_n, {NATURAL_32} 5, a_ap, l_n, l_s, a_pp)
			l_cy := (create {P_GMP_STATIC}).gmpn_add ((a_scratch + 6 * l_n) + 2, a_bp + 0, l_n, a_bp + 2 * l_n, l_t);
			((a_pp + 6 * l_n) + 3)[l_n] := l_cy + ((create {P_GMP_STATIC}).gmpn_add_n ((a_pp + 6 * l_n) + 3, ((a_scratch + 6 * l_n) + 2), a_bp + l_n, l_n))
			if l_cy = {NATURAL_32} 0 then
				if ((create {P_GMP_STATIC}).gmpn_cmp (((a_scratch + 6 * l_n) + 2), a_bp + l_n, l_n)) < 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n ((a_pp + 4 * l_n) + 1, a_bp + l_n, ((a_scratch + 6 * l_n) + 2), l_n).do_nothing;
					((a_pp + 4 * l_n) + 1)[l_n] := (0).to_natural_32
					l_sign := (l_sign).bit_not
				else
					l_tmp___3 := (create {P_GMP_STATIC}).gmpn_sub_n ((a_pp + 4 * l_n) + 1, ((a_scratch + 6 * l_n) + 2), a_bp + l_n, l_n)
					l_cy := l_cy - l_tmp___3;
					((a_pp + 4 * l_n) + 1)[l_n] := l_cy
				end
			else
				l_tmp___3 := (create {P_GMP_STATIC}).gmpn_sub_n ((a_pp + 4 * l_n) + 1, ((a_scratch + 6 * l_n) + 2), a_bp + l_n, l_n)
				l_cy := l_cy - l_tmp___3;
				((a_pp + 4 * l_n) + 1)[l_n] := l_cy
			end
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_MUL_N_STATIC}).gmpn_mul_n (a_pp, (a_pp + 3 * l_n), ((a_pp + 4 * l_n) + 1), l_n + 1)
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_MUL_N_STATIC}).gmpn_mul_n (a_scratch, ((a_pp + 5 * l_n) + 2), ((a_pp + 6 * l_n) + 3), l_n + 1)
				l_break := True
			end
			l_break := False;
			(create {P_TOOM_COUPLE_HANDLING_STATIC}).gmpn_toom_couple_handling (a_scratch, 2 * l_n + 1, a_pp, l_sign, l_n, 0, 0)
			l_sign := (create {P_TOOM_EVAL_PM2_STATIC}).gmpn_toom_eval_pm2 ((a_pp + 5 * l_n) + 2, a_pp + 3 * l_n, {NATURAL_32} 5, a_ap, l_n, l_s, a_pp)
			a_pp[l_n] := (create {P_GMP_STATIC}).gmpn_lshift (a_pp, a_bp + l_n, l_n, {NATURAL_32} 1);
			((a_pp + 6 * l_n) + 3)[l_t] := (create {P_GMP_STATIC}).gmpn_lshift ((a_pp + 6 * l_n) + 3, a_bp + 2 * l_n, l_t, {NATURAL_32} 2)
			if l_n = l_t then
				((a_pp + 6 * l_n) + 3)[l_n] := ((a_pp + 6 * l_n) + 3)[l_n] + ((create {P_GMP_STATIC}).gmpn_add_n ((a_pp + 6 * l_n) + 3, ((a_pp + 6 * l_n) + 3), a_bp + 0, l_n))
			else
				((a_pp + 6 * l_n) + 3)[l_n] := (create {P_GMP_STATIC}).gmpn_add ((a_pp + 6 * l_n) + 3, a_bp + 0, l_n, ((a_pp + 6 * l_n) + 3), l_t + 1)
			end
			l_sign := (l_sign).bit_xor ((abs_sub_add_n ((a_pp + 4 * l_n) + 1, (a_pp + 6 * l_n) + 3, a_pp, l_n + 1)))
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_MUL_N_STATIC}).gmpn_mul_n (a_pp, (a_pp + 3 * l_n), ((a_pp + 4 * l_n) + 1), l_n + 1)
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_MUL_N_STATIC}).gmpn_mul_n (a_pp + 3 * l_n, ((a_pp + 5 * l_n) + 2), ((a_pp + 6 * l_n) + 3), l_n + 1)
				l_break := True
			end
			l_break := False;
			(create {P_TOOM_COUPLE_HANDLING_STATIC}).gmpn_toom_couple_handling (a_pp + 3 * l_n, 2 * l_n + 1, a_pp, l_sign, l_n, 1, 2)
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_MUL_N_STATIC}).gmpn_mul_n (a_pp, a_ap, a_bp, l_n)
				l_break := True
			end
			l_break := False
			if l_s > l_t then
				from
				until
					(l_break)
				loop
					l_break := False;
					(create {P_MUL_STATIC}).gmpn_mul (a_pp + 7 * l_n, a_ap + 5 * l_n, l_s, a_bp + 2 * l_n, l_t).do_nothing
					l_break := True
				end
				l_break := False
			else
				from
				until
					(l_break)
				loop
					l_break := False;
					(create {P_MUL_STATIC}).gmpn_mul (a_pp + 7 * l_n, a_bp + 2 * l_n, l_t, a_ap + 5 * l_n, l_s).do_nothing
					l_break := True
				end
				l_break := False
			end
			(create {P_TOOM_INTERPOLATE_8PTS_STATIC}).gmpn_toom_interpolate_8pts (a_pp, l_n, (a_scratch + 3 * l_n) + 1, a_scratch, l_s + l_t, (a_scratch + 6 * l_n) + 2)
		end

end
