class
	PD_FFT_TABLE_NK

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	n: NATURAL_32 assign set_n

	k: NATURAL_32 assign set_k

feature {ANY} -- field setters

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_k (a_k: NATURAL_32)
		do
			k := a_k
			update_memory_field ("k")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			k := a_other.k
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				k = a_other.k
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_bitfield ("n"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("k")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline"
		alias
			"[
				struct fft_table_nk {
					unsigned int n : 27;
					unsigned int k : 5;
				};
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct fft_table_nk);
				} else {
					struct fft_table_nk *p = (struct fft_table_nk *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "n") == 0) p->n = (unsigned int)$a_value;
						else if(strcmp(field_name, "k") == 0) p->k = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "n") == 0) return p->n;
						if(strcmp(field_name, "k") == 0) return p->k;
					}
				}
			]"
		end

end
