class
	PD_GMP_ASPRINTF_T

inherit
	PD_GMP_ASPRINTF_T_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_POINTER_POINTER [INTEGER_8]} result2.make
			create {CE_INTEGER_8_POINTER} buf.make
			Precursor
		end

feature {ANY} -- fields

	result2: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_result2

	buf: CE_POINTER [INTEGER_8] assign set_buf

	size: NATURAL_32 assign set_size

	alloc: NATURAL_32 assign set_alloc

feature {ANY} -- field setters

	set_result2 (a_result2: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			result2 := a_result2
			update_memory_field ("result2")
		end

	set_buf (a_buf: CE_POINTER [INTEGER_8])
		do
			buf := a_buf
			update_memory_field ("buf")
		end

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_alloc (a_alloc: NATURAL_32)
		do
			alloc := a_alloc
			update_memory_field ("alloc")
		end

feature {ANY} -- public routines

	gmp_asprintf_memory (a_str: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): INTEGER_32
		local
			l_alloc: NATURAL_32
			l_newsize: NATURAL_32
			l_newalloc: NATURAL_32
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_alloc := alloc
				l_newsize := size + a_len
				if l_alloc <= l_newsize then
					l_newalloc := {NATURAL_32} 2 * l_newsize
					Current.alloc := l_newalloc
					update_class_fields -- Current might have been changed; synchronize
					l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (buf), l_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_newalloc * {PLATFORM}.Integer_8_bytes.to_natural_32]))
					update_class_fields -- Current might have been changed; synchronize
					Current.buf := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_break := True
			end
			l_break := False
			memcpy (create {CE_VOID_POINTER}.make_cast ((buf + size.to_integer_32)), create {CE_VOID_POINTER}.make_cast (a_str), a_len).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Current.size := size + a_len
			update_class_fields -- Current might have been changed; synchronize
			Result := a_len.to_integer_32
		end

	gmp_asprintf_reps (a_c, a_reps: INTEGER_32): INTEGER_32
		local
			l_alloc: NATURAL_32
			l_newsize: NATURAL_32
			l_newalloc: NATURAL_32
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_alloc := alloc
				l_newsize := size + a_reps.to_natural_32
				if l_alloc <= l_newsize then
					l_newalloc := {NATURAL_32} 2 * l_newsize
					Current.alloc := l_newalloc
					update_class_fields -- Current might have been changed; synchronize
					l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (buf), l_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_newalloc * {PLATFORM}.Integer_8_bytes.to_natural_32]))
					update_class_fields -- Current might have been changed; synchronize
					Current.buf := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_break := True
			end
			l_break := False
			memset (create {CE_VOID_POINTER}.make_cast ((buf + size.to_integer_32)), a_c, a_reps.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Current.size := size + a_reps.to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Result := a_reps
		end

	gmp_asprintf_final: INTEGER_32
		local
			l_buf: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [ANY]
			l_break: BOOLEAN
		do
			l_buf := buf
			l_buf[size.to_integer_32] := (('%/0/').code).to_integer_8
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				(l_break)
			loop
				l_break := False
				if alloc /= size + {NATURAL_32} 1 then
					l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_buf), alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, (size + {NATURAL_32} 1) * {PLATFORM}.Integer_8_bytes.to_natural_32]))
					update_class_fields -- Current might have been changed; synchronize
					l_buf := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)
				end
				l_break := True
			end
			l_break := False
			result2.item := l_buf
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	gmp_asprintf_format (a_fmt: CE_POINTER [INTEGER_8]; a_orig_ap: CE_VA_LIST): INTEGER_32
		local
			l_orig_ap: CE_VA_LIST
			l_ret: INTEGER_32
			l_ap: CE_VA_LIST
			l_space: NATURAL_32
			l_alloc: NATURAL_32
			l_newsize: NATURAL_32
			l_newalloc: NATURAL_32
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			l_orig_ap := a_orig_ap.twin
			l_space := (256).to_natural_32
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_alloc := alloc
					l_newsize := size + l_space
					if l_alloc <= l_newsize then
						l_newalloc := {NATURAL_32} 2 * l_newsize
						Current.alloc := l_newalloc
						update_class_fields -- Current might have been changed; synchronize
						l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (buf), l_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_newalloc * {PLATFORM}.Integer_8_bytes.to_natural_32]))
						update_class_fields -- Current might have been changed; synchronize
						Current.buf := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
				l_space := alloc - size
				l_ap := l_orig_ap.twin
				l_ret := vsnprintf ((buf + size.to_integer_32), l_space, a_fmt, l_ap.twin)
				update_class_fields -- Current might have been changed; synchronize
				if l_ret = -1 then
					l_ret := (l_space - {NATURAL_32} 1).to_integer_32
				end
				if l_ret.to_natural_32 < l_space - {NATURAL_32} 1 then
					l_break := True
				end
				if not (l_return or l_break) then
					if l_ret.to_natural_32 = l_space - {NATURAL_32} 1 then
						l_space := l_space * ({NATURAL_32} 2)
					else
						l_space := (l_ret + 2).to_natural_32
					end
				end
			end
			l_break := False
			Current.size := size + l_ret.to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Result := l_ret
		end

feature {ANY}

	copy (a_other: like Current)
		do
			result2 := a_other.result2
			buf := a_other.buf
			size := a_other.size
			alloc := a_other.alloc
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				result2.is_equal (a_other.result2) and
				buf.is_equal (a_other.buf) and
				size = a_other.size and
				alloc = a_other.alloc
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("result2"),
					create {CE_STRUCTURE_FIELD}.make ("buf"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("alloc")
				>>)
			init_structure_info
		end

end
