class
	PD_GMP_DOSCAN_FUNS_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_CTYPE_STATIC
		redefine
			copy,
			is_equal
		end
	S_LANGINFO_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_GCC_BUILTIN_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create scan.make
			create step.make
			create get.make
			create unget.make
			Precursor
		end

feature {ANY} -- fields

	scan: CE_ROUTINE assign set_scan

	step: CE_ROUTINE assign set_step

	get: CE_ROUTINE assign set_get

	unget: CE_ROUTINE assign set_unget

feature {ANY} -- field setters

	set_scan (a_scan: CE_ROUTINE)
		do
			scan := a_scan
			update_memory_field ("scan")
		end

	set_step (a_step: CE_ROUTINE)
		do
			step := a_step
			update_memory_field ("step")
		end

	set_get (a_get: CE_ROUTINE)
		do
			get := a_get
			update_memory_field ("get")
		end

	set_unget (a_unget: CE_ROUTINE)
		do
			unget := a_unget
			update_memory_field ("unget")
		end

feature {ANY} -- public routines

	gmpscan (a_data: CE_POINTER [ANY]; a_p: CE_POINTER [PD_GMP_DOSCAN_PARAMS_T]; a_dst: CE_POINTER [ANY]): INTEGER_32
		local
			l_chars: INTEGER_32
			l_c: INTEGER_32
			l_base: INTEGER_32
			l_first: INTEGER_32
			l_width: INTEGER_32
			l_seen_point: INTEGER_32
			l_seen_digit: INTEGER_32
			l_hexfloat: INTEGER_32
			l_s_upto: NATURAL_32
			l_s_alloc: NATURAL_32
			l_hexexp: NATURAL_32
			l_s: CE_POINTER [INTEGER_8]
			l_invalid: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_s_alloc_new: NATURAL_32
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: NATURAL_32
			l_s_alloc_new___0: NATURAL_32
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: NATURAL_32
			l_s_alloc_new___1: NATURAL_32
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___5: NATURAL_32
			l_tmp___6: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___7: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_s_alloc_new___2: NATURAL_32
			l_tmp___8: CE_POINTER [ANY]
			l_tmp___9: NATURAL_32
			l_point: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_pc: INTEGER_32
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_s_alloc_new___3: NATURAL_32
			l_tmp___12: CE_POINTER [ANY]
			l_tmp___13: NATURAL_32
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_s_alloc_new___4: NATURAL_32
			l_tmp___15: CE_POINTER [ANY]
			l_tmp___16: NATURAL_32
			l_s_alloc_new___5: NATURAL_32
			l_tmp___17: CE_POINTER [ANY]
			l_tmp___18: NATURAL_32
			l_f: CE_POINTER [PD_MPF_STRUCT]
			l_tmp___19: INTEGER_32
			l_dummy: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_exp: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_dummy.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_invalid := 0
					l_c := get.integer_32_item ([a_data])
					update_class_fields -- Current might have been changed; synchronize
					if l_c = -1 then
						Result := (-2)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 73 -- skip if block
					end
				when 1 then -- if:
						l_chars := 1
						l_first := 1
						l_seen_point := 0
						if a_p.item.width = 0 then
							l_width := -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) - 1
						else
							l_width := a_p.item.width
						end
						l_base := a_p.item.base
						l_s_alloc := (512).to_natural_32
						l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([l_s_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32]))
						update_class_fields -- Current might have been changed; synchronize
						l_s := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)
						l_s_upto := (0).to_natural_32
						l_hexfloat := 0
						l_hexexp := (0).to_natural_32
				when 2 then -- another:
						l_seen_digit := 0
						if l_c /= 45 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_s_upto >= l_s_alloc then
								l_s_alloc_new := l_s_alloc + {NATURAL_32} 512
								l_tmp___0 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_s), l_s_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_s_alloc_new * {PLATFORM}.Integer_8_bytes.to_natural_32]))
								update_class_fields -- Current might have been changed; synchronize
								l_s := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___0)
								l_s_alloc := l_s_alloc_new
							end
							l_tmp___1 := l_s_upto
							l_s_upto := l_s_upto + 1
							l_s[l_tmp___1.to_integer_32] := l_c.to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_pos := -1 + 6 -- goto get_for_sign
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 5 then -- else:
						if l_c /= 43 then
							l_pos := -1 + 10 -- skip if block
						end
				when 6 then -- if: | get_for_sign:
						if (l_return or l_break) then
							l_pos := -1 + 9 -- skip loop
						end
				when 7 then -- loop body:
						l_break := False
						l_chars := l_chars + 1
						if l_chars > l_width then
							l_pos := -1 + 64 -- goto convert
						end
				when 8 then
						l_c := get.integer_32_item ([a_data])
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
						l_pos := -1 + 6 -- back to loop condition
				when 9 then -- loop done
						l_break := False
				when 10 then -- if done
						if l_base /= 0 then
							l_pos := -1 + 25 -- skip if block
						end
				when 11 then -- if:
						l_base := 10
						if l_c /= 48 then
							l_pos := -1 + 25 -- skip if block
						end
				when 12 then -- if:
						l_seen_digit := 1
						if (a_p.item.type).to_integer_32 /= 70 then
							l_base := 8
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_s_upto >= l_s_alloc then
								l_s_alloc_new___0 := l_s_alloc + {NATURAL_32} 512
								l_tmp___2 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_s), l_s_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_s_alloc_new___0 * {PLATFORM}.Integer_8_bytes.to_natural_32]))
								update_class_fields -- Current might have been changed; synchronize
								l_s := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___2)
								l_s_alloc := l_s_alloc_new___0
							end
							l_tmp___3 := l_s_upto
							l_s_upto := l_s_upto + 1
							l_s[l_tmp___3.to_integer_32] := l_c.to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
				when 13 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 16 -- skip loop
						end
				when 14 then -- loop body:
						l_break := False
						l_chars := l_chars + 1
						if l_chars > l_width then
							l_pos := -1 + 64 -- goto convert
						end
				when 15 then
						l_c := get.integer_32_item ([a_data])
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
						l_pos := -1 + 13 -- back to loop condition
				when 16 then -- loop done
						l_break := False
						if l_c /= 120 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 19 then -- else:
						if l_c /= 88 then
							l_pos := -1 + 25 -- skip if block
						end
				when 20 then -- if: | _L:
						l_base := 16
						l_seen_digit := 0
						if (a_p.item.type).to_integer_32 = 70 then
							l_hexfloat := 1
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_s_upto >= l_s_alloc then
									l_s_alloc_new___1 := l_s_alloc + {NATURAL_32} 512
									l_tmp___4 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_s), l_s_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_s_alloc_new___1 * {PLATFORM}.Integer_8_bytes.to_natural_32]))
									update_class_fields -- Current might have been changed; synchronize
									l_s := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___4)
									l_s_alloc := l_s_alloc_new___1
								end
								l_tmp___5 := l_s_upto
								l_s_upto := l_s_upto + 1
								l_s[l_tmp___5.to_integer_32] := l_c.to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
						end
				when 21 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 24 -- skip loop
						end
				when 22 then -- loop body:
						l_break := False
						l_chars := l_chars + 1
						if l_chars > l_width then
							l_pos := -1 + 64 -- goto convert
						end
				when 23 then
						l_c := get.integer_32_item ([a_data])
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
						l_pos := -1 + 21 -- back to loop condition
				when 24 then -- loop done
						l_break := False
				when 25 then -- if done | if done | if done | digits:
						if (l_return or l_break) then
							l_pos := -1 + 33 -- skip loop
						end
				when 26 then -- loop body:
						l_break := False
						if l_base = 16 then
							l_tmp___6 := ctype_b_loc
							update_class_fields -- Current might have been changed; synchronize
							if not (((l_tmp___6.item[l_c]).to_integer_32).bit_and (4_096)).to_boolean then
								l_break := True
							end
						else
							l_tmp___7 := ctype_b_loc
							update_class_fields -- Current might have been changed; synchronize
							if not (((l_tmp___7.item[l_c]).to_integer_32).bit_and (2_048)).to_boolean then
								l_break := True
							end
							if not (l_return or l_break) and then (l_base = 8) then
								if l_c = 56 then
									l_break := True
								elseif l_c = 57 then
									l_break := True
								end
							end
						end
						if (l_return or l_break) then
							l_pos := -1 + 32 -- skip if block
						end
				when 27 then -- if:
						l_seen_digit := 1
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_s_upto >= l_s_alloc then
								l_s_alloc_new___2 := l_s_alloc + {NATURAL_32} 512
								l_tmp___8 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_s), l_s_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_s_alloc_new___2 * {PLATFORM}.Integer_8_bytes.to_natural_32]))
								update_class_fields -- Current might have been changed; synchronize
								l_s := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___8)
								l_s_alloc := l_s_alloc_new___2
							end
							l_tmp___9 := l_s_upto
							l_s_upto := l_s_upto + 1
							l_s[l_tmp___9.to_integer_32] := l_c.to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
				when 28 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 31 -- skip loop
						end
				when 29 then -- loop body:
						l_break := False
						l_chars := l_chars + 1
						if l_chars > l_width then
							l_pos := -1 + 64 -- goto convert
						end
				when 30 then
						l_c := get.integer_32_item ([a_data])
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
						l_pos := -1 + 28 -- back to loop condition
				when 31 then -- loop done
						l_break := False
				when 32 then -- if done
						l_pos := -1 + 25 -- back to loop condition
				when 33 then -- loop done
						l_break := False
						if not (l_first.to_boolean) then
							l_pos := -1 + 64 -- skip if block
						end
				when 34 then -- if:
						if (a_p.item.type).to_integer_32 /= 70 then
							l_pos := -1 + 45 -- skip if block
						end
				when 35 then -- if:
						if l_seen_point.to_boolean then
							l_pos := -1 + 45 -- skip if block
						end
				when 36 then -- if:
						l_tmp___10 := nl_langinfo (65_536)
						update_class_fields -- Current might have been changed; synchronize
						l_point := l_tmp___10
						l_tmp___11 := l_point
						l_point := l_point + 1
						l_pc := ((l_tmp___11[0]).to_natural_8).to_integer_32
						if l_c /= l_pc then
							l_pos := -1 + 45 -- skip if block
						end
				when 37 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 44 -- skip loop
						end
				when 38 then -- loop body:
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_s_upto >= l_s_alloc then
								l_s_alloc_new___3 := l_s_alloc + {NATURAL_32} 512
								l_tmp___12 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_s), l_s_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_s_alloc_new___3 * {PLATFORM}.Integer_8_bytes.to_natural_32]))
								update_class_fields -- Current might have been changed; synchronize
								l_s := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___12)
								l_s_alloc := l_s_alloc_new___3
							end
							l_tmp___13 := l_s_upto
							l_s_upto := l_s_upto + 1
							l_s[l_tmp___13.to_integer_32] := l_c.to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
				when 39 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 42 -- skip loop
						end
				when 40 then -- loop body:
						l_break := False
						l_chars := l_chars + 1
						if l_chars > l_width then
							l_pos := -1 + 64 -- goto convert
						end
				when 41 then
						l_c := get.integer_32_item ([a_data])
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
						l_pos := -1 + 39 -- back to loop condition
				when 42 then -- loop done
						l_break := False
						l_tmp___14 := l_point
						l_point := l_point + 1
						l_pc := ((l_tmp___14[0]).to_natural_8).to_integer_32
						if l_pc = 0 then
							l_break := True
						end
						if not (l_return or l_break) and then (l_c /= l_pc) then
							l_pos := -1 + 65 -- goto set_invalid
						end
				when 43 then
						l_pos := -1 + 37 -- back to loop condition
				when 44 then -- loop done
						l_break := False
						l_seen_point := 1
						l_pos := -1 + 25 -- goto digits
				when 45 then -- if done | if done
						if (a_p.item.type).to_integer_32 /= 70 then
							l_pos := -1 + 60 -- skip if block
						end
				when 46 then -- if:
						if not (l_hexfloat.to_boolean) then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						if l_c = 112 then
							l_hexexp := l_s_upto
							l_base := 10
							l_pos := -1 + 54 -- goto exponent
						elseif l_c = 80 then
							l_hexexp := l_s_upto
							l_base := 10
							l_pos := -1 + 54 -- goto exponent
						else
							l_pos := -1 + 49 -- goto _L___1
						end
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 60
				when 49 then -- else: | _L___1:
						if l_hexfloat.to_boolean then
							l_pos := -1 + 60 -- skip if block
						end
				when 50 then -- if:
						if l_c /= 101 then
							l_pos := -1 + 53 -- skip if block
						end
				when 51 then -- if:
						l_pos := -1 + 54 -- goto exponent
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 60
				when 53 then -- else:
						if l_c /= 69 then
							l_pos := -1 + 60 -- skip if block
						end
				when 54 then -- if: | exponent:
						if not l_seen_digit.to_boolean then
							l_pos := -1 + 65 -- goto set_invalid
						end
				when 55 then -- do_second:
						l_first := 0
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_s_upto >= l_s_alloc then
								l_s_alloc_new___4 := l_s_alloc + {NATURAL_32} 512
								l_tmp___15 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_s), l_s_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_s_alloc_new___4 * {PLATFORM}.Integer_8_bytes.to_natural_32]))
								update_class_fields -- Current might have been changed; synchronize
								l_s := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___15)
								l_s_alloc := l_s_alloc_new___4
							end
							l_tmp___16 := l_s_upto
							l_s_upto := l_s_upto + 1
							l_s[l_tmp___16.to_integer_32] := l_c.to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
				when 56 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 59 -- skip loop
						end
				when 57 then -- loop body:
						l_break := False
						l_chars := l_chars + 1
						if l_chars > l_width then
							l_pos := -1 + 64 -- goto convert
						end
				when 58 then
						l_c := get.integer_32_item ([a_data])
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
						l_pos := -1 + 56 -- back to loop condition
				when 59 then -- loop done
						l_break := False
						l_pos := -1 + 2 -- goto another
				when 60 then -- if done | if done | if done | if done
						if (a_p.item.type).to_integer_32 /= 81 then
							l_pos := -1 + 64 -- skip if block
						end
				when 61 then -- if:
						if l_c /= 47 then
							l_pos := -1 + 64 -- skip if block
						end
				when 62 then -- if:
						if not l_seen_digit.to_boolean then
							l_pos := -1 + 65 -- goto set_invalid
						end
				when 63 then
						l_seen_digit := 0
						l_base := a_p.item.base
						l_pos := -1 + 55 -- goto do_second
				when 64 then -- if done | if done | convert:
						if l_seen_digit.to_boolean then
							l_pos := -1 + 66 -- skip if block
						end
				when 65 then -- if: | set_invalid:
						l_invalid := 1
						l_pos := -1 + 72 -- goto done
				when 66 then
						if (a_p.item.ignore).to_boolean then
							l_pos := -1 + 72 -- skip if block
						end
				when 67 then -- if:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_s_upto >= l_s_alloc then
								l_s_alloc_new___5 := l_s_alloc + {NATURAL_32} 512
								l_tmp___17 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_s), l_s_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_s_alloc_new___5 * {PLATFORM}.Integer_8_bytes.to_natural_32]))
								update_class_fields -- Current might have been changed; synchronize
								l_s := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___17)
								l_s_alloc := l_s_alloc_new___5
							end
							l_tmp___18 := l_s_upto
							l_s_upto := l_s_upto + 1
							l_s[l_tmp___18.to_integer_32] := (('%/0/').code).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						inspect (a_p.item.type).to_integer_32 -- switch 1 head
						when 70 then l_pos := -1 + 68
						when 81 then l_pos := -1 + 69
						when 90 then l_pos := -1 + 70
						else l_pos := -1 + 71
						end
				when 68 then -- switch 1, case 70
						l_f := create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_cast (a_dst)
						if l_hexexp /= {NATURAL_32} 0 then
							l_s[l_hexexp.to_integer_32] := (('%/0/').code).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_hexfloat.to_boolean then
							l_tmp___19 := 16
						else
							l_tmp___19 := 10
						end
						(create {P_SET_STR_STATIC}).gmpf_set_str (l_f, l_s, l_tmp___19).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if l_hexexp /= {NATURAL_32} 0 then
							l_exp := strtol (((l_s + l_hexexp.to_integer_32) + 1), l_dummy, 10)
							update_class_fields -- Current might have been changed; synchronize
							if l_exp >= 0 then
								gmpf_mul_2exp (l_f, l_f, l_exp.to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
							else
								gmpf_div_2exp (l_f, l_f, (-(l_exp.to_natural_32).to_integer_32).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_pos := -1 + 72 -- switch 1; break
				when 69 then -- switch 1, case 81
						gmpq_set_str (create {CE_CLASS_POINTER [PD_MPQ_STRUCT]}.make_cast (a_dst), l_s, a_p.item.base).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 70 then -- switch 1, case 90;
						(create {P_SET_STR_STATIC}).gmpz_set_str (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (a_dst), l_s, a_p.item.base).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 72 -- switch 1; break
				when 71 then -- switch 1, default:
						l_pos := -1 + 72 -- switch 1; break
				when 72 then -- switch 1, done: | done:
						
						if l_chars /= l_width + 1 then
							unget.call ([l_c, a_data])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_chars := l_chars - 1;
						(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (l_s), l_s_alloc])
						update_class_fields -- Current might have been changed; synchronize
						if l_invalid.to_boolean then
							Result := (-1)
							l_return := True
						end
				when 73 then -- if done
					if not l_return then
						Result := l_chars
					end
				when 74 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	skip_white (a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_c: INTEGER_32
			l_ret: INTEGER_32
			l_tmp: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_break: BOOLEAN
		do
			l_ret := 0
			from
			until
				(l_break)
			loop
				l_break := False
				l_c := get.integer_32_item ([a_data])
				update_class_fields -- Current might have been changed; synchronize
				l_ret := l_ret + 1
				l_tmp := ctype_b_loc
				update_class_fields -- Current might have been changed; synchronize
				if not (((l_tmp.item[l_c]).to_integer_32).bit_and (8_192)).to_boolean then
					l_break := True
				end
			end
			l_break := False
			unget.call ([l_c, a_data])
			update_class_fields -- Current might have been changed; synchronize
			l_ret := l_ret - 1
			Result := l_ret
		end

feature {PD_GMP_DOSCAN_FUNS_T} -- private routines

	gmpf_mul_2exp (a_r, a_u: CE_POINTER [PD_MPF_STRUCT]; a_exp: NATURAL_32)
		require
			not a_r.is_void
			not a_u.is_void
		local
			l_up: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_prec: INTEGER_32
			l_uexp: INTEGER_32
			l_cy_limb: NATURAL_32
			l_adj: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_rp := a_r.item.mp_d
			l_prec := (a_r.item.mp_prec).to_integer_32
			l_uexp := a_u.item.mp_exp
			l_usize := (a_u.item.mp_size).to_integer_32
			if (builtin_expect ((l_usize = 0).to_integer, 0)).to_boolean then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				l_return := True
			end
			if not l_return then
				if l_usize >= 0 then
					l_abs_usize := l_usize
				else
					l_abs_usize := -l_usize
				end
				l_up := a_u.item.mp_d
				if a_exp \\ {NATURAL_32} 32 = {NATURAL_32} 0 then
					l_prec := l_prec + 1
					if l_abs_usize > l_prec then
						l_up := l_up + (l_abs_usize - l_prec)
						l_abs_usize := l_prec
					end
					if not l_rp.is_equal (l_up) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_up, l_abs_usize)
							l_break := True
						end
						l_break := False
					end
					a_r.item.mp_exp := (l_uexp.to_natural_32 + a_exp // {NATURAL_32} 32).to_integer_32
				else
					if l_abs_usize > l_prec then
						l_up := l_up + (l_abs_usize - l_prec)
						l_abs_usize := l_prec
						l_cy_limb := (create {P_GMP_STATIC}).gmpn_rshift (l_rp + 1, l_up, l_abs_usize, ({NATURAL_32} 32 - a_exp \\ {NATURAL_32} 32).to_natural_32)
						l_rp[0] := l_cy_limb
						l_adj := (l_rp[l_abs_usize] /= {NATURAL_32} 0).to_integer
					else
						l_cy_limb := (create {P_GMP_STATIC}).gmpn_lshift (l_rp, l_up, l_abs_usize, (a_exp \\ {NATURAL_32} 32).to_natural_32)
						l_rp[l_abs_usize] := l_cy_limb
						l_adj := (l_cy_limb /= {NATURAL_32} 0).to_integer
					end
					l_abs_usize := l_abs_usize + l_adj
					a_r.item.mp_exp := ((l_uexp.to_natural_32 + a_exp // {NATURAL_32} 32) + l_adj.to_natural_32).to_integer_32
				end
				if l_usize >= 0 then
					a_r.item.mp_size := l_abs_usize.to_integer_32
				else
					a_r.item.mp_size := (-l_abs_usize).to_integer_32
				end
			end
		end

	gmpf_div_2exp (a_r, a_u: CE_POINTER [PD_MPF_STRUCT]; a_exp: NATURAL_32)
		require
			not a_r.is_void
			not a_u.is_void
		local
			l_up: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_prec: INTEGER_32
			l_uexp: INTEGER_32
			l_cy_limb: NATURAL_32
			l_adj: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_rp := a_r.item.mp_d
			l_prec := (a_r.item.mp_prec).to_integer_32
			l_uexp := a_u.item.mp_exp
			l_usize := (a_u.item.mp_size).to_integer_32
			if (builtin_expect ((l_usize = 0).to_integer, 0)).to_boolean then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				l_return := True
			end
			if not l_return then
				if l_usize >= 0 then
					l_abs_usize := l_usize
				else
					l_abs_usize := -l_usize
				end
				l_up := a_u.item.mp_d
				if a_exp \\ {NATURAL_32} 32 = {NATURAL_32} 0 then
					l_prec := l_prec + 1
					if l_abs_usize > l_prec then
						l_up := l_up + (l_abs_usize - l_prec)
						l_abs_usize := l_prec
					end
					if not l_rp.is_equal (l_up) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_up, l_abs_usize)
							l_break := True
						end
						l_break := False
					end
					a_r.item.mp_exp := (l_uexp.to_natural_32 - a_exp // {NATURAL_32} 32).to_integer_32
				else
					if l_abs_usize > l_prec then
						l_up := l_up + (l_abs_usize - l_prec)
						l_abs_usize := l_prec
						l_cy_limb := (create {P_GMP_STATIC}).gmpn_rshift (l_rp + 1, l_up, l_abs_usize, (a_exp \\ {NATURAL_32} 32).to_natural_32)
						l_rp[0] := l_cy_limb
						l_adj := (l_rp[l_abs_usize] /= {NATURAL_32} 0).to_integer
					else
						l_cy_limb := (create {P_GMP_STATIC}).gmpn_lshift (l_rp, l_up, l_abs_usize, ({NATURAL_32} 32 - a_exp \\ {NATURAL_32} 32).to_natural_32)
						l_rp[l_abs_usize] := l_cy_limb
						l_adj := (l_cy_limb /= {NATURAL_32} 0).to_integer
					end
					l_abs_usize := l_abs_usize + l_adj
					a_r.item.mp_exp := (((l_uexp.to_natural_32 - a_exp // {NATURAL_32} 32) - {NATURAL_32} 1) + l_adj.to_natural_32).to_integer_32
				end
				if l_usize >= 0 then
					a_r.item.mp_size := l_abs_usize.to_integer_32
				else
					a_r.item.mp_size := (-l_abs_usize).to_integer_32
				end
			end
		end

	gmpq_set_str (a_q: CE_POINTER [PD_MPQ_STRUCT]; a_str: CE_POINTER [INTEGER_8]; a_base: INTEGER_32): INTEGER_32
		require
			not a_str.is_void
		local
			l_slash: CE_POINTER [INTEGER_8]
			l_num: CE_POINTER [INTEGER_8]
			l_numlen: NATURAL_32
			l_ret: INTEGER_32
			l_return: BOOLEAN
		do
			l_slash := (strchr (a_str, ('/').code))
			if l_slash.is_void then
				a_q.item.mp_den.mp_size := 1
				a_q.item.mp_den.mp_d[0] := (1).to_natural_32
				Result := ((create {P_SET_STR_STATIC}).gmpz_set_str (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), a_str, a_base))
				l_return := True
			end
			if not l_return then
				l_numlen := (l_slash.distance (a_str)).to_natural_32
				l_num := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([(l_numlen + {NATURAL_32} 1) * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
				memcpy (create {CE_VOID_POINTER}.make_cast (l_num), create {CE_VOID_POINTER}.make_cast (a_str), l_numlen).do_nothing
				l_num[l_numlen.to_integer_32] := (('%/0/').code).to_integer_8
				l_ret := (create {P_SET_STR_STATIC}).gmpz_set_str (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), l_num, a_base);
				(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (l_num), l_numlen + {NATURAL_32} 1])
				if l_ret /= 0 then
					Result := l_ret
					l_return := True
				end
			end
			if not l_return then
				Result := ((create {P_SET_STR_STATIC}).gmpz_set_str (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), l_slash + 1, a_base))
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			scan := a_other.scan
			step := a_other.step
			get := a_other.get
			unget := a_other.unget
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				scan.is_equal (a_other.scan) and
				step.is_equal (a_other.step) and
				get.is_equal (a_other.get) and
				unget.is_equal (a_other.unget)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("scan"),
					create {CE_STRUCTURE_FIELD}.make ("step"),
					create {CE_STRUCTURE_FIELD}.make ("get"),
					create {CE_STRUCTURE_FIELD}.make ("unget")
				>>)
			init_structure_info
		end

end
