class
	PD_GMP_DOSCAN_PARAMS_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	base: INTEGER_32 assign set_base

	ignore: INTEGER_32 assign set_ignore

	type: INTEGER_8 assign set_type

	width: INTEGER_32 assign set_width

feature {ANY} -- field setters

	set_base (a_base: INTEGER_32)
		do
			base := a_base
			update_memory_field ("base")
		end

	set_ignore (a_ignore: INTEGER_32)
		do
			ignore := a_ignore
			update_memory_field ("ignore")
		end

	set_type (a_type: INTEGER_8)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			base := a_other.base
			ignore := a_other.ignore
			type := a_other.type
			width := a_other.width
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				base = a_other.base and
				ignore = a_other.ignore and
				type = a_other.type and
				width = a_other.width
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("base"),
					create {CE_STRUCTURE_FIELD}.make ("ignore"),
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("width")
				>>)
			init_structure_info
		end

end
