class
	PD_GMP_PRIMES_PTAB

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	ppp: NATURAL_32 assign set_ppp

	cps: CE_ARRAY [NATURAL_32]

	idx: NATURAL_32 assign set_idx

	np: NATURAL_32 assign set_np

feature {ANY} -- field setters

	set_ppp (a_ppp: NATURAL_32)
		do
			ppp := a_ppp
			update_memory_field ("ppp")
		end

	set_idx (a_idx: NATURAL_32)
		do
			idx := a_idx
			update_memory_field ("idx")
		end

	set_np (a_np: NATURAL_32)
		do
			np := a_np
			update_memory_field ("np")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ppp := a_other.ppp
			cps := a_other.cps.twin
			idx := a_other.idx
			np := a_other.np
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ppp = a_other.ppp and
				cps.is_equal (a_other.cps) and
				idx = a_other.idx and
				np = a_other.np
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ppp"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cps", <<7>>),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("idx"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("np")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline"
		alias
			"[
				struct gmp_primes_ptab {
					unsigned long ppp;
					unsigned long cps[7];
					unsigned int idx : 24;
					unsigned int np : 8;
				};
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct gmp_primes_ptab);
				} else {
					struct gmp_primes_ptab *p = (struct gmp_primes_ptab *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "idx") == 0) p->idx = (unsigned int)$a_value;
						else if(strcmp(field_name, "np") == 0) p->np = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "idx") == 0) return p->idx;
						if(strcmp(field_name, "np") == 0) return p->np;
					}
				}
			]"
		end

end
