class
	PD_GMP_PRIMESIEVE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_ARRAY} s.make (<<513>>)
			Precursor
		end

feature {ANY} -- fields

	d: NATURAL_32 assign set_d

	s0: NATURAL_32 assign set_s0

	sqrt_s0: NATURAL_32 assign set_sqrt_s0

	s: CE_ARRAY [NATURAL_8]

feature {ANY} -- field setters

	set_d (a_d: NATURAL_32)
		do
			d := a_d
			update_memory_field ("d")
		end

	set_s0 (a_s0: NATURAL_32)
		do
			s0 := a_s0
			update_memory_field ("s0")
		end

	set_sqrt_s0 (a_sqrt_s0: NATURAL_32)
		do
			sqrt_s0 := a_sqrt_s0
			update_memory_field ("sqrt_s0")
		end

feature {PD_GMP_PRIMESIEVE_T} -- private attributes

	addtab: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					2, 4, 2, 4, 6, 2, 6, 4, 2, 4, 6, 6, 2, 6, 4, 2, 6, 4, 6, 8, 4, 2, 4, 2, 4, 8, 6, 4, 6, 2, 4, 6, 2,
					6, 6, 4, 2, 4, 6, 2, 6, 4, 2, 4, 2, 10, 2, 10
				>>)
		end

feature {ANY} -- public routines

	gmp_nextprime: NATURAL_32
		local
			l_p: NATURAL_32
			l_d: NATURAL_32
			l_pi: NATURAL_32
			l_sp: CE_POINTER [NATURAL_8]
			l_addp: CE_POINTER [NATURAL_8]
			l_ai: NATURAL_32
			l_tmp: NATURAL_32
			l_return: BOOLEAN
		do
			l_addp := addtab.item
			l_d := d
			l_sp := s + l_d.to_integer_32
			from
			until
				(l_sp.item).to_integer_32 = 0
			loop
				l_sp := l_sp + 1
			end
			if not l_sp.is_equal (s + 512) then
				l_d := (l_sp.distance (s)).to_natural_32
				Current.d := l_d + {NATURAL_32} 1
				update_class_fields -- Current might have been changed; synchronize
				Result := (s0 + {NATURAL_32} 2 * l_d)
				l_return := True
			end
			if not l_return and then (s0 < {NATURAL_32} 3) then
				Current.s0 := {NATURAL_32} 4_294_966_275
				update_class_fields -- Current might have been changed; synchronize
				Result := {NATURAL_32} 2
				l_return := True
			end
			if not l_return then
				memset (create {CE_VOID_POINTER}.make_cast (s), 0, (512).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Current.s0 := s0 + ({NATURAL_32} 1_024)
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					not ((sqrt_s0 + {NATURAL_32} 1) * (sqrt_s0 + {NATURAL_32} 1) <= (s0 + {NATURAL_32} 1_024) - {NATURAL_32} 1)
				loop
					Current.sqrt_s0 := sqrt_s0 + 1
					update_class_fields -- Current might have been changed; synchronize
				end
				l_pi := ((s0 + {NATURAL_32} 3) // {NATURAL_32} 2) \\ {NATURAL_32} 3
				if l_pi > {NATURAL_32} 0 then
					l_pi := {NATURAL_32} 3 - l_pi
				end
				if s0 + {NATURAL_32} 2 * l_pi <= {NATURAL_32} 3 then
					l_pi := l_pi + ({NATURAL_32} 3)
				end
				l_sp := s + l_pi.to_integer_32
				from
				until
					not ((l_sp.c_pointer.to_integer_32).to_natural_32 < ((s + 512).c_pointer.to_integer_32).to_natural_32)
				loop
					l_sp.item := (1).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					l_sp := l_sp + (3)
				end
				l_pi := ((s0 + {NATURAL_32} 5) // {NATURAL_32} 2) \\ {NATURAL_32} 5
				if l_pi > {NATURAL_32} 0 then
					l_pi := {NATURAL_32} 5 - l_pi
				end
				if s0 + {NATURAL_32} 2 * l_pi <= {NATURAL_32} 5 then
					l_pi := l_pi + ({NATURAL_32} 5)
				end
				l_sp := s + l_pi.to_integer_32
				from
				until
					not ((l_sp.c_pointer.to_integer_32).to_natural_32 < ((s + 512).c_pointer.to_integer_32).to_natural_32)
				loop
					l_sp.item := (1).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					l_sp := l_sp + (5)
				end
				l_pi := ((s0 + {NATURAL_32} 7) // {NATURAL_32} 2) \\ {NATURAL_32} 7
				if l_pi > {NATURAL_32} 0 then
					l_pi := {NATURAL_32} 7 - l_pi
				end
				if s0 + {NATURAL_32} 2 * l_pi <= {NATURAL_32} 7 then
					l_pi := l_pi + ({NATURAL_32} 7)
				end
				l_sp := s + l_pi.to_integer_32
				from
				until
					not ((l_sp.c_pointer.to_integer_32).to_natural_32 < ((s + 512).c_pointer.to_integer_32).to_natural_32)
				loop
					l_sp.item := (1).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					l_sp := l_sp + (7)
				end
				l_p := {NATURAL_32} 11
				l_ai := {NATURAL_32} 0
				from
				until
					not (not (l_return) and then (l_p <= sqrt_s0))
				loop
					l_pi := ((s0 + l_p) // {NATURAL_32} 2) \\ l_p
					if l_pi > {NATURAL_32} 0 then
						l_pi := l_p - l_pi
					end
					if s0 + {NATURAL_32} 2 * l_pi <= l_p then
						l_pi := l_pi + l_p
					end
					l_sp := s + l_pi.to_integer_32
					from
					until
						not ((l_sp.c_pointer.to_integer_32).to_natural_32 < ((s + 512).c_pointer.to_integer_32).to_natural_32)
					loop
						l_sp.item := (1).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_sp := l_sp + l_p.to_integer_32
					end
					l_p := l_p + (l_addp[l_ai.to_integer_32]).to_natural_32
					l_ai := (l_ai + {NATURAL_32} 1) \\ {NATURAL_32} 48
				end
				Current.d := {NATURAL_32} 0
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := ((create {CE_CLASS_POINTER [PD_GMP_PRIMESIEVE_T]}.make_shared (c_pointer))).item.gmp_nextprime
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			d := a_other.d
			s0 := a_other.s0
			sqrt_s0 := a_other.sqrt_s0
			s := a_other.s.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				d = a_other.d and
				s0 = a_other.s0 and
				sqrt_s0 = a_other.sqrt_s0 and
				s.is_equal (a_other.s)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("d"),
					create {CE_STRUCTURE_FIELD}.make ("s0"),
					create {CE_STRUCTURE_FIELD}.make ("sqrt_s0"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("s", <<513>>)
				>>)
			init_structure_info
		end

end
