class
	PD_MPF_STRUCT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_GCC_BUILTIN_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_LANGINFO_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBIO_STATIC
		redefine
			copy,
			is_equal
		end
	LIBGMP_ASSEMBLER
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_32_POINTER} mp_d.make
			Precursor
		end

feature {ANY} -- fields

	mp_prec: INTEGER_32 assign set_mp_prec

	mp_size: INTEGER_32 assign set_mp_size

	mp_exp: INTEGER_32 assign set_mp_exp

	mp_d: CE_POINTER [NATURAL_32] assign set_mp_d

feature {ANY} -- field setters

	set_mp_prec (a_mp_prec: INTEGER_32)
		do
			mp_prec := a_mp_prec
			update_memory_field ("mp_prec")
		end

	set_mp_size (a_mp_size: INTEGER_32)
		do
			mp_size := a_mp_size
			update_memory_field ("mp_size")
		end

	set_mp_exp (a_mp_exp: INTEGER_32)
		do
			mp_exp := a_mp_exp
			update_memory_field ("mp_exp")
		end

	set_mp_d (a_mp_d: CE_POINTER [NATURAL_32])
		do
			mp_d := a_mp_d
			update_memory_field ("mp_d")
		end

feature {ANY} -- public routines

	gmpf_init
		local
			l_prec: INTEGER_32
			l_tmp: CE_POINTER [ANY]
		do
			l_prec := (create {P_SET_DFL_PREC_STATIC}).gmp_default_fp_limb_precision.item
			Current.mp_size := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_exp := (0).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_prec := l_prec.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([((l_prec + 1) * 4).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpf_init2 (a_prec_in_bits: NATURAL_32)
		local
			l_prec: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [ANY]
		do
			if {NATURAL_32} 53 > a_prec_in_bits then
				l_tmp := (53).to_natural_32
			else
				l_tmp := a_prec_in_bits
			end
			l_prec := (((l_tmp + {NATURAL_32} 64) - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
			Current.mp_size := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_exp := (0).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_prec := l_prec.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([((l_prec + 1) * 4).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___0)
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpf_set (a_u: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_u.is_void
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_asize: INTEGER_32
			l_prec: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_prec := (mp_prec + 1).to_integer_32
			l_size := (a_u.item.mp_size).to_integer_32
			if l_size >= 0 then
				l_asize := l_size
			else
				l_asize := -l_size
			end
			l_rp := mp_d
			l_up := a_u.item.mp_d
			if l_asize > l_prec then
				l_up := l_up + (l_asize - l_prec)
				l_asize := l_prec
			end
			Current.mp_exp := a_u.item.mp_exp
			update_class_fields -- Current might have been changed; synchronize
			if l_size >= 0 then
				Current.mp_size := l_asize.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			else
				Current.mp_size := (-l_asize).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False;
				(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_up, l_asize)
				update_class_fields -- Current might have been changed; synchronize
				l_break := True
			end
			l_break := False
		end

	gmpf_set_ui (a_val: NATURAL_32)
		local
			l_size: INTEGER_32
			l_tmp: INTEGER_32
		do
			mp_d[0] := (a_val).bit_and ({NATURAL_32} 4_294_967_295)
			update_class_fields -- Current might have been changed; synchronize
			l_size := (a_val /= {NATURAL_32} 0).to_integer
			l_tmp := l_size.to_integer_32
			Current.mp_size := l_tmp
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_exp := l_tmp.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpf_set_si (a_val: INTEGER_32)
		local
			l_size: INTEGER_32
			l_vl: NATURAL_32
			l_tmp: INTEGER_32
		do
			if a_val >= 0 then
				l_tmp := a_val
			else
				l_tmp := -a_val
			end
			l_vl := l_tmp.to_natural_32
			mp_d[0] := (l_vl).bit_and ({NATURAL_32} 4_294_967_295)
			update_class_fields -- Current might have been changed; synchronize
			l_size := (l_vl /= {NATURAL_32} 0).to_integer
			Current.mp_exp := l_size
			update_class_fields -- Current might have been changed; synchronize
			if a_val >= 0 then
				Current.mp_size := l_size.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			else
				Current.mp_size := (-l_size).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	gmpf_set_d (a_d: REAL_64)
		local
			l_d: REAL_64
			l_negative: INTEGER_32
			l_u: PD_IEEE_DOUBLE_EXTRACT
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create l_u.make

			l_d := a_d
			from
			until
				(l_break)
			loop
				l_break := False
				l_u.d := l_d
				update_class_fields -- Current might have been changed; synchronize
				l_u.update_class_fields -- synchronize union
				l_tmp := builtin_expect ((l_u.s.exp = {NATURAL_32} 2_047).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					if l_u.s.manl = {NATURAL_32} 0 then
						if l_u.s.manh = {NATURAL_32} 0 then
							(create {P_INVALID_STATIC}).gmp_invalid_operation
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_INVALID_STATIC}).gmp_invalid_operation
							update_class_fields -- Current might have been changed; synchronize
						end
					else
						(create {P_INVALID_STATIC}).gmp_invalid_operation
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_break := True
			end
			l_break := False
			l_tmp___0 := builtin_expect ((l_d = (0).to_double).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___0.to_boolean then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_exp := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_negative := (l_d < (0).to_double).to_integer
				if l_d >= (0).to_double then
					l_d := l_d
				else
					l_d := -l_d
				end
				if l_negative.to_boolean then
					Current.mp_size := -3
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := 3
					update_class_fields -- Current might have been changed; synchronize
				end
				l_tmp___1 := (create {P_EXTRACT_DBL_STATIC}).gmp_extract_double (mp_d, l_d)
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_exp := l_tmp___1.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	gmpf_set_z (a_u: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_u.is_void
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_asize: INTEGER_32
			l_prec: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_prec := (mp_prec + 1).to_integer_32
			l_size := (a_u.item.mp_size).to_integer_32
			if l_size >= 0 then
				l_asize := l_size
			else
				l_asize := -l_size
			end
			l_rp := mp_d
			l_up := a_u.item.mp_d
			Current.mp_exp := l_asize
			update_class_fields -- Current might have been changed; synchronize
			if l_asize > l_prec then
				l_up := l_up + (l_asize - l_prec)
				l_asize := l_prec
			end
			if l_size >= 0 then
				Current.mp_size := l_asize.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			else
				Current.mp_size := (-l_asize).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_up, l_asize)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
		end

	gmpf_init_set (a_s: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_s.is_void
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_sp: CE_POINTER [NATURAL_32]
			l_ssize: INTEGER_32
			l_size: INTEGER_32
			l_prec: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			l_prec := (create {P_SET_DFL_PREC_STATIC}).gmp_default_fp_limb_precision.item
			l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([((l_prec + 1) * 4).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_prec := l_prec.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_prec := l_prec + 1
			l_ssize := (a_s.item.mp_size).to_integer_32
			if l_ssize >= 0 then
				l_size := l_ssize
			else
				l_size := -l_ssize
			end
			l_rp := mp_d
			l_sp := a_s.item.mp_d
			if l_size > l_prec then
				l_sp := l_sp + (l_size - l_prec)
				l_size := l_prec
			end
			Current.mp_exp := a_s.item.mp_exp
			update_class_fields -- Current might have been changed; synchronize
			if l_ssize >= 0 then
				Current.mp_size := l_size.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			else
				Current.mp_size := (-l_size).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_sp, l_size)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
		end

	gmpf_init_set_ui (a_val: NATURAL_32)
		local
			l_prec: INTEGER_32
			l_size: INTEGER_32
			l_tmp: CE_POINTER [ANY]
		do
			l_prec := (create {P_SET_DFL_PREC_STATIC}).gmp_default_fp_limb_precision.item
			Current.mp_prec := l_prec.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([((l_prec + 1) * 4).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			mp_d[0] := (a_val).bit_and ({NATURAL_32} 4_294_967_295)
			update_class_fields -- Current might have been changed; synchronize
			l_size := (a_val /= {NATURAL_32} 0).to_integer
			Current.mp_size := l_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_exp := l_size
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpf_init_set_si (a_val: INTEGER_32)
		local
			l_prec: INTEGER_32
			l_size: INTEGER_32
			l_vl: NATURAL_32
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
		do
			l_prec := (create {P_SET_DFL_PREC_STATIC}).gmp_default_fp_limb_precision.item
			Current.mp_prec := l_prec.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([((l_prec + 1) * 4).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			if a_val >= 0 then
				l_tmp___0 := a_val
			else
				l_tmp___0 := -a_val
			end
			l_vl := l_tmp___0.to_natural_32
			mp_d[0] := (l_vl).bit_and ({NATURAL_32} 4_294_967_295)
			update_class_fields -- Current might have been changed; synchronize
			l_size := (l_vl /= {NATURAL_32} 0).to_integer
			Current.mp_exp := l_size
			update_class_fields -- Current might have been changed; synchronize
			if a_val >= 0 then
				Current.mp_size := l_size.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			else
				Current.mp_size := (-l_size).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	gmpf_init_set_str (a_s: CE_POINTER [INTEGER_8]; a_base: INTEGER_32): INTEGER_32
		require
			not a_s.is_void
		local
			l_prec: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
		do
			l_prec := (create {P_SET_DFL_PREC_STATIC}).gmp_default_fp_limb_precision.item
			Current.mp_size := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_exp := (0).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_prec := l_prec.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([((l_prec + 1) * 4).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_SET_STR_STATIC}).gmpf_set_str ((create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_shared (c_pointer)), a_s, a_base)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp___0
		end

	gmpf_init_set_d (a_val: REAL_64)
		local
			l_prec: INTEGER_32
			l_tmp: CE_POINTER [ANY]
		do
			l_prec := (create {P_SET_DFL_PREC_STATIC}).gmp_default_fp_limb_precision.item
			Current.mp_prec := l_prec.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([((l_prec + 1) * 4).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_shared (c_pointer))).item.gmpf_set_d (a_val)
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpf_clear
		do
			(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (mp_d), ((mp_prec + 1) * 4).to_natural_32])
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpf_get_str (a_dbuf: CE_POINTER [INTEGER_8]; a_exp: CE_POINTER [INTEGER_32]; a_base: INTEGER_32; a_n_digits: NATURAL_32): CE_POINTER [INTEGER_8]
		local
			l_dbuf: CE_POINTER [INTEGER_8]
			l_base: INTEGER_32
			l_n_digits: NATURAL_32
			l_ue: INTEGER_32
			l_n_limbs_needed: INTEGER_32
			l_max_digits: NATURAL_32
			l_up: CE_POINTER [NATURAL_32]
			l_pp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_un: INTEGER_32
			l_pn: INTEGER_32
			l_tn: INTEGER_32
			l_tstr: CE_POINTER [NATURAL_8]
			l_exp_in_base: INTEGER_32
			l_n_digits_computed: NATURAL_32
			l_i: INTEGER_32
			l_num_to_text: CE_POINTER [INTEGER_8]
			l_alloc_size: NATURAL_32
			l_dp: CE_POINTER [INTEGER_8]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: INTEGER_32
			l_n_more_limbs_needed: INTEGER_32
			l_ign: CE_ARRAY [INTEGER_32]
			l_off: INTEGER_32
			l_e: NATURAL_32
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___8: CE_POINTER [ANY]
			l_tmp___9: INTEGER_32
			l_tmp___12: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___14: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___15: CE_POINTER [NATURAL_32]
			l_n_less_limbs_needed: INTEGER_32
			l_ign___0: CE_ARRAY [INTEGER_32]
			l_off___0: INTEGER_32
			l_xn: INTEGER_32
			l_e___0: NATURAL_32
			l_dummyp: CE_POINTER [NATURAL_32]
			l_xp: CE_POINTER [NATURAL_32]
			l_tmp___18: CE_POINTER [ANY]
			l_tmp___19: CE_POINTER [ANY]
			l_tmp___20: INTEGER_32
			l_tmp___23: CE_POINTER [ANY]
			l_tmp___24: CE_POINTER [ANY]
			l_tmp___25: INTEGER_32
			l_tmp___28: CE_POINTER [ANY]
			l_tmp___29: CE_POINTER [ANY]
			l_tmp___30: INTEGER_32
			l___dst___0: CE_POINTER [NATURAL_32]
			l___n___0: INTEGER_32
			l_tmp___31: CE_POINTER [NATURAL_32]
			l_tmp___34: CE_POINTER [ANY]
			l_tmp___35: CE_POINTER [ANY]
			l_tmp___36: INTEGER_32
			l_i___0: NATURAL_32
			l_x___2: NATURAL_32
			l_tmp___37: INTEGER_32
			l_tmp___38: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_ign.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_ign___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dbuf := a_dbuf
					l_base := a_base
					l_n_digits := a_n_digits
					l_alloc_size := (0).to_natural_32
					l_up := mp_d
					if mp_size >= 0 then
						l_un := mp_size.to_integer_32
					else
						l_un := (-mp_size).to_integer_32
					end
					l_ue := mp_exp
					if l_base >= 0 then
						l_num_to_text := ce_string ("0123456789abcdefghijklmnopqrstuvwxyz")
						if l_base = 0 then
							l_base := 10
						elseif l_base > 36 then
							l_num_to_text := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz")
							if l_base > 62 then
								Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
								l_return := True
							end
						end
					else
						l_base := -l_base
						l_num_to_text := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ")
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_max_digits := {NATURAL_32} 2 + (((mp_prec.to_natural_32 - {NATURAL_32} 1) * {NATURAL_32} 32).to_real_64 * (create {P_MP_BASES_STATIC}).gmpn_bases.item[l_base].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32
							l_break := True
						end
						l_break := False
						if l_n_digits = {NATURAL_32} 0 then
							l_n_digits := l_max_digits
						elseif l_n_digits > l_max_digits then
							l_n_digits := l_max_digits
						end
						if l_dbuf.is_void then
							l_alloc_size := l_n_digits + {NATURAL_32} 2
							l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([l_n_digits + {NATURAL_32} 2]))
							update_class_fields -- Current might have been changed; synchronize
							l_dbuf := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)
						end
						if l_un = 0 then
							a_exp.item := (0).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							l_dbuf[0] := (0).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							l_n_digits := (0).to_natural_32
							l_pos := -1 + 3 -- goto done
						end
				when 2 then
						l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___4 := builtin_expect (((l_n_digits + {NATURAL_32} 64) + {NATURAL_32} 3 < {NATURAL_32} 65_536).to_integer, 1)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___4.to_boolean then
							l_tmp___3 := (l_aaf.new ((l_n_digits + {NATURAL_32} 64) + {NATURAL_32} 3))
						else
							l_tmp___2 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_n_digits + {NATURAL_32} 64) + {NATURAL_32} 3)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___3 := l_tmp___2
						end
						l_tstr := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___3)
						l_n_limbs_needed := 2 + (l_n_digits.to_real_64 / ((32).to_double * (create {P_MP_BASES_STATIC}).gmpn_bases.item[l_base].chars_per_bit_exactly)).truncated_to_integer
						if l_ue <= l_n_limbs_needed then
							l_n_more_limbs_needed := l_n_limbs_needed - l_ue
							l_e := ((l_n_more_limbs_needed.to_natural_32).to_real_64 * ((32).to_double * (create {P_MP_BASES_STATIC}).gmpn_bases.item[l_base].chars_per_bit_exactly)).truncated_to_integer_64.to_natural_32
							if l_un > l_n_limbs_needed then
								l_up := l_up + (l_un - l_n_limbs_needed)
								l_un := l_n_limbs_needed
							end
							l_tmp___9 := builtin_expect (((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___9.to_boolean then
								l_tmp___8 := (l_aaf.new (((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___7 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___8 := l_tmp___7
							end
							l_pp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___8)
							l_tmp___14 := builtin_expect (((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___14.to_boolean then
								l_tmp___13 := (l_aaf.new (((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___12 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___13 := l_tmp___12
							end
							l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___13)
							l_pn := mpn_pow_1_highpart___0 (l_pp, l_ign, l_base.to_natural_32, l_e, l_n_limbs_needed, l_tp)
							update_class_fields -- Current might have been changed; synchronize
							if l_un > l_pn then
								(create {P_MUL_STATIC}).gmpn_mul (l_tp, l_up, l_un, l_pp, l_pn).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							else
								(create {P_MUL_STATIC}).gmpn_mul (l_tp, l_pp, l_pn, l_up, l_un).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
							l_tn := l_un + l_pn
							l_tn := l_tn - (l_tp[(l_tn - 1)] = {NATURAL_32} 0).to_integer
							l_off := (l_un - l_ue) - l_ign.item
							if l_off < 0 then
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyd (l_tp - l_off, l_tp, l_tn)
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if -l_off /= 0 then
										l___dst := l_tp
										l___n := -l_off
										from
										until
											(l_break)
										loop
											l_break := False
											l_tmp___15 := l___dst
											l___dst := l___dst + 1
											l_tmp___15.item := (0).to_natural_32
											update_class_fields -- Current might have been changed; synchronize
											l___n := l___n - 1
											if not l___n.to_boolean then
												l_break := True
											end
										end
										l_break := False
									end
									l_break := True
								end
								l_break := False
								l_tn := l_tn - l_off
								l_off := (0).to_integer_32
							end
							l_n_digits_computed := (create {P_GET_STR_STATIC}).gmpn_get_str (l_tstr, l_base, l_tp + l_off, l_tn - l_off)
							update_class_fields -- Current might have been changed; synchronize
							l_exp_in_base := (l_n_digits_computed.to_natural_32 - l_e).to_integer_32
						else
							l_n_less_limbs_needed := l_ue - l_n_limbs_needed
							l_e___0 := ((l_n_less_limbs_needed.to_natural_32).to_real_64 * ((32).to_double * (create {P_MP_BASES_STATIC}).gmpn_bases.item[l_base].chars_per_bit_exactly)).truncated_to_integer_64.to_natural_32
							if l_un > l_n_limbs_needed then
								l_up := l_up + (l_un - l_n_limbs_needed)
								l_un := l_n_limbs_needed
							end
							l_tmp___20 := builtin_expect (((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___20.to_boolean then
								l_tmp___19 := (l_aaf.new (((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___18 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___19 := l_tmp___18
							end
							l_pp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___19)
							l_tmp___25 := builtin_expect (((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___25.to_boolean then
								l_tmp___24 := (l_aaf.new (((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___23 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___24 := l_tmp___23
							end
							l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___24)
							l_pn := mpn_pow_1_highpart___0 (l_pp, l_ign___0, l_base.to_natural_32, l_e___0, l_n_limbs_needed, l_tp)
							update_class_fields -- Current might have been changed; synchronize
							l_xn := l_n_limbs_needed + (l_n_less_limbs_needed - l_ign___0.item)
							l_tmp___30 := builtin_expect ((l_xn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___30.to_boolean then
								l_tmp___29 := (l_aaf.new ((l_xn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___28 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_xn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___29 := l_tmp___28
							end
							l_xp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___29)
							l_off___0 := l_xn - l_un
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_off___0 /= 0 then
									l___dst___0 := l_xp
									l___n___0 := l_off___0
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp___31 := l___dst___0
										l___dst___0 := l___dst___0 + 1
										l_tmp___31.item := (0).to_natural_32
										update_class_fields -- Current might have been changed; synchronize
										l___n___0 := l___n___0 - 1
										if not l___n___0.to_boolean then
											l_break := True
										end
									end
									l_break := False
								end
								l_break := True
							end
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_xp + l_off___0, l_up, l_un)
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							l_tmp___36 := builtin_expect ((l_pn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___36.to_boolean then
								l_tmp___35 := (l_aaf.new ((l_pn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___34 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_pn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___35 := l_tmp___34
							end
							l_dummyp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___35);
							(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_tp, l_dummyp, (0).to_integer_32, l_xp, l_xn, l_pp, l_pn)
							update_class_fields -- Current might have been changed; synchronize
							l_tn := (l_xn - l_pn) + 1
							l_tn := l_tn - (l_tp[(l_tn - 1)] = {NATURAL_32} 0).to_integer
							l_n_digits_computed := (create {P_GET_STR_STATIC}).gmpn_get_str (l_tstr, l_base, l_tp, l_tn)
							update_class_fields -- Current might have been changed; synchronize
							l_exp_in_base := (l_n_digits_computed.to_natural_32 + l_e___0).to_integer_32
						end
						if l_n_digits_computed > l_n_digits then
							if (l_tstr[l_n_digits.to_integer_32]).to_integer_32 * 2 >= l_base then
								l_n_digits_computed := l_n_digits
								l_i___0 := l_n_digits - {NATURAL_32} 1
								from
								until
									(l_break)
								loop
									l_break := False
									l_tstr[l_i___0.to_integer_32] := ((l_tstr[l_i___0.to_integer_32]).to_integer_32 + 1).to_natural_8
									update_class_fields -- Current might have been changed; synchronize
									l_x___2 := (l_tstr[l_i___0.to_integer_32]).to_natural_32
									if l_x___2 /= l_base.to_natural_32 then
										l_break := True
									end
									if not (l_return or l_break) then
										l_n_digits_computed := l_n_digits_computed - 1
										if l_i___0 = {NATURAL_32} 0 then
											l_tstr[0] := (1).to_natural_8
											update_class_fields -- Current might have been changed; synchronize
											l_n_digits_computed := (1).to_natural_32
											l_exp_in_base := l_exp_in_base + 1
											l_break := True
										end
									end
									if not (l_return or l_break) then
										l_i___0 := l_i___0 - 1
									end
								end
								l_break := False
							end
						end
						if l_n_digits > l_n_digits_computed then
							l_n_digits := l_n_digits_computed
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if l_n_digits /= {NATURAL_32} 0 then
								if (l_tstr[(l_n_digits - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_n_digits := l_n_digits - 1
							end
						end
						l_break := False
						l_dp := l_dbuf + (mp_size < 0).to_integer
						l_i := (0).to_integer_32
						from
						until
							not (l_i.to_natural_32 < l_n_digits.to_natural_32)
						loop
							l_dp[l_i] := l_num_to_text[(l_tstr[l_i]).to_integer_32]
							update_class_fields -- Current might have been changed; synchronize
							l_i := l_i + 1
						end
						l_dp[l_n_digits.to_integer_32] := (0).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						a_exp.item := l_exp_in_base
						update_class_fields -- Current might have been changed; synchronize
						if mp_size < 0 then
							l_dbuf[0] := (('-').code).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							l_n_digits := l_n_digits + 1
						end
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___37 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___37.to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
				when 3 then -- done:
						if l_alloc_size /= {NATURAL_32} 0 then
							from
							until
								(l_break)
							loop
								l_break := False
								if l_alloc_size /= l_n_digits + {NATURAL_32} 1 then
									l_tmp___38 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_dbuf), l_alloc_size * {PLATFORM}.Integer_8_bytes.to_natural_32, (l_n_digits + {NATURAL_32} 1) * {PLATFORM}.Integer_8_bytes.to_natural_32]))
									update_class_fields -- Current might have been changed; synchronize
									l_dbuf := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___38)
								end
								l_break := True
							end
							l_break := False
						end
						Result := l_dbuf
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpf_dump
		local
			l_exp: CE_ARRAY [INTEGER_32]
			l_str: CE_POINTER [INTEGER_8]
			l_tmp: NATURAL_32
		do
			create {CE_INTEGER_32_ARRAY} l_exp.make (<<1>>)

			l_str := ((create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_shared (c_pointer))).item.gmpf_get_str (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), l_exp, 10, (0).to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			if (l_str[0]).to_integer_32 = 45 then
				printf ([ce_string ("-0.%%se%%ld%N"), l_str + 1, l_exp.item]).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			else
				printf ([ce_string ("0.%%se%%ld%N"), l_str, l_exp.item]).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			l_tmp := strlen (l_str)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (l_str), l_tmp + {NATURAL_32} 1])
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpf_size: NATURAL_32
		local
			l_tmp: INTEGER_32
		do
			if mp_size >= 0 then
				l_tmp := mp_size
			else
				l_tmp := -mp_size
			end
			Result := l_tmp.to_natural_32
		end

	gmpf_eq (a_v: CE_POINTER [PD_MPF_STRUCT]; a_n_bits: NATURAL_32): INTEGER_32
		require
			not a_v.is_void
		local
			l_n_bits: NATURAL_32
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_p: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_minsize: INTEGER_32
			l_maxsize: INTEGER_32
			l_n_limbs: INTEGER_32
			l_i: INTEGER_32
			l_size: INTEGER_32
			l_uexp: INTEGER_32
			l_vexp: INTEGER_32
			l_diff: NATURAL_32
			l_cnt: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_n_bits := a_n_bits
			l_uexp := mp_exp
			l_vexp := a_v.item.mp_exp
			l_usize := mp_size.to_integer_32
			l_vsize := (a_v.item.mp_size).to_integer_32
			if ((l_usize).bit_xor (l_vsize)) >= 0 then
				if l_usize = 0 then
					Result := (l_vsize = 0).to_integer
					l_return := True
				end
				if not l_return and then (l_vsize = 0) then
					Result := 0
					l_return := True
				end
			else
				Result := 0
				l_return := True
			end
			if not l_return and then (l_uexp /= l_vexp) then
				Result := 0
				l_return := True
			end
			if not l_return then
				if l_usize >= 0 then
					l_usize := l_usize
				else
					l_usize := -l_usize
				end
				if l_vsize >= 0 then
					l_vsize := l_vsize
				else
					l_vsize := -l_vsize
				end
				l_up := mp_d
				l_vp := a_v.item.mp_d
				l_up := l_up + l_usize
				l_vp := l_vp + l_vsize
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_cnt := builtin_clzl (l_up[-1])
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				if (l_vp[-1]).bit_shift_right ((31 - l_cnt)) /= {NATURAL_32} 1 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_n_bits := l_n_bits + l_cnt.to_natural_32
				l_n_limbs := (((l_n_bits + {NATURAL_32} 32) - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
				if l_usize < l_n_limbs then
					l_usize := l_usize
				else
					l_usize := l_n_limbs
				end
				if l_vsize < l_n_limbs then
					l_vsize := l_vsize
				else
					l_vsize := l_n_limbs
				end
				if l_usize < l_vsize then
					l_minsize := l_usize
				else
					l_minsize := l_vsize
				end
				l_maxsize := (l_usize + l_vsize) - l_minsize
				l_up := l_up - l_minsize
				l_vp := l_vp - l_minsize
				l_i := l_minsize - 1
				from
				until
					not (not (l_return) and then (l_i > 0))
				loop
					if l_up[l_i] /= l_vp[l_i] then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_i := l_i - 1
					end
				end
			end
			if not l_return then
				l_n_bits := l_n_bits - ((l_maxsize - 1) * 32).to_natural_32
				l_size := l_maxsize - l_minsize
				if l_size /= 0 then
					if l_up[0] /= l_vp[0] then
						Result := 0
						l_return := True
					end
					if not l_return then
						if l_usize > l_vsize then
							l_p := l_up - l_size
						else
							l_p := l_vp - l_size
						end
						l_i := l_size - 1
						from
						until
							not (not (l_return) and then (l_i > 0))
						loop
							if l_p[l_i] /= {NATURAL_32} 0 then
								Result := 0
								l_return := True
							end
							if not l_return then
								l_i := l_i - 1
							end
						end
					end
					if not l_return then
						l_diff := l_p[0]
					end
				else
					l_diff := ((l_up[0]).bit_xor (l_vp[0]))
				end
			end
			if not l_return then
				if l_n_bits < {NATURAL_32} 32 then
					l_diff := (l_diff).bit_shift_right (({NATURAL_32} 32 - l_n_bits).to_integer_32)
				end
				Result := (l_diff = {NATURAL_32} 0).to_integer
			end
		end

	gmpf_reldiff (a_x___2, a_y: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_x___2.is_void
		local
			l_tmp: INTEGER_32
			l_dprec: INTEGER_32
			l_d: CE_ARRAY [PD_MPF_STRUCT]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___0: INTEGER_32
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [PD_MPF_STRUCT]} l_d.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_tmp___7 := builtin_expect ((a_x___2.item.mp_size = 0).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___7.to_boolean then
				if a_y.item.mp_size < 0 then
					l_tmp := -1
				else
					l_tmp := (a_y.item.mp_size > 0).to_integer
				end
				((create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_shared (c_pointer))).item.gmpf_set_ui ((l_tmp /= 0).to_integer.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
			else
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				if a_x___2.item.mp_size >= 0 then
					l_tmp___0 := a_x___2.item.mp_size
				else
					l_tmp___0 := -a_x___2.item.mp_size
				end
				l_dprec := (mp_prec + l_tmp___0).to_integer_32
				l_d[0].mp_prec := l_dprec.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___5 := builtin_expect (((l_dprec + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___5.to_boolean then
					l_tmp___4 := (l_aaf.new (((l_dprec + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___3 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_dprec + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___4 := l_tmp___3
				end
				l_d[0].mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___4)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SUB_STATIC}).gmpf_sub (l_d, a_x___2, a_y)
				update_class_fields -- Current might have been changed; synchronize
				if l_d[0].mp_size >= 0 then
					l_d[0].mp_size := l_d[0].mp_size
					update_class_fields -- Current might have been changed; synchronize
				else
					l_d[0].mp_size := -l_d[0].mp_size
					update_class_fields -- Current might have been changed; synchronize
				end
				((create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_shared (c_pointer))).item.gmpf_div (create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_cast (l_d), a_x___2)
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___6 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___6.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpf_sqrt (a_u: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_u.is_void
		local
			l_usize: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_prec: INTEGER_32
			l_tsize: INTEGER_32
			l_uexp: INTEGER_32
			l_expodd: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			l_tmp___5: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize <= 0 then
				if l_usize < 0 then
					(create {P_ERRNO_STATIC}).gmp_sqrt_of_negative
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_exp := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_uexp := a_u.item.mp_exp
				l_prec := mp_prec.to_integer_32
				l_up := a_u.item.mp_d
				l_expodd := (l_uexp).bit_and (1)
				l_tsize := 2 * l_prec - l_expodd
				Current.mp_size := l_prec.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_exp := (l_uexp + l_expodd) // 2
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___3 := builtin_expect ((l_tsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___3.to_boolean then
					l_tmp___2 := (l_aaf.new ((l_tsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___1 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_tsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := l_tmp___1
				end
				l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
				if l_usize > l_tsize then
					l_up := l_up + (l_usize - l_tsize)
					l_usize := l_tsize
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_up, l_tsize)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_tsize - l_usize /= 0 then
							l___dst := l_tp
							l___n := l_tsize - l_usize
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___4 := l___dst
								l___dst := l___dst + 1
								l_tmp___4.item := (0).to_natural_32
								update_class_fields -- Current might have been changed; synchronize
								l___n := l___n - 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_tp + (l_tsize - l_usize), l_up, l_usize)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				end
				(create {P_SQRTREM_STATIC}).gmpn_sqrtrem (mp_d, create {CE_NATURAL_32_POINTER}.make_shared (default_pointer), l_tp, l_tsize).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___5 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___5.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpf_random2 (a_xs, a_exp: INTEGER_32)
		local
			l_exp: INTEGER_32
			l_xn: INTEGER_32
			l_prec: INTEGER_32
			l_elimb: CE_ARRAY [NATURAL_32]
			l___rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_elimb.make (<<1>>)

			l_exp := a_exp
			if a_xs >= 0 then
				l_xn := a_xs
			else
				l_xn := -a_xs
			end
			l_prec := mp_prec.to_integer_32
			if l_xn = 0 then
				Current.mp_exp := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				if l_xn > l_prec + 1 then
					l_xn := l_prec + 1
				end
				(create {P_RANDOM2_STATIC}).gmpn_random2 (mp_d, l_xn)
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					if not ((create {P_RANDS_STATIC}).gmp_rands_initialized.item).to_boolean then
						(create {P_RANDS_STATIC}).gmp_rands_initialized.item := (1).to_integer_8
						update_class_fields; -- Current might have been changed; synchronize
						(create {CE_CLASS_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (((create {P_GMP_IMPL_STATIC}).gmp_rands.item))).item.gmp_randinit_mt_noseed
						update_class_fields -- Current might have been changed; synchronize
					end
					l___rstate := (create {P_GMP_IMPL_STATIC}).gmp_rands.item;
					((create {CE_CLASS_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate, l_elimb, {NATURAL_32} 32])
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				if l_exp >= 0 then
					l_exp := l_exp
				else
					l_exp := -l_exp
				end
				l_exp := (l_elimb.item \\ (2 * l_exp + 1).to_natural_32 - l_exp.to_natural_32).to_integer_32
				Current.mp_exp := l_exp
				update_class_fields -- Current might have been changed; synchronize
				if a_xs < 0 then
					Current.mp_size := (-l_xn).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := l_xn.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	gmpf_out_str (a_stream: CE_POINTER [SD_IO_FILE]; a_base: INTEGER_32; a_n_digits: NATURAL_32): NATURAL_32
		local
			l_stream: CE_POINTER [SD_IO_FILE]
			l_base: INTEGER_32
			l_n_digits: NATURAL_32
			l_str: CE_POINTER [INTEGER_8]
			l_exp: CE_ARRAY [INTEGER_32]
			l_written: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: INTEGER_32
			l_point: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_pointlen: NATURAL_32
			l_tmp___5: NATURAL_32
			l_fwret: NATURAL_32
			l_fpret: INTEGER_32
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: INTEGER_32
			l_tmp___9: NATURAL_32
			l_tmp___10: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_INTEGER_32_ARRAY} l_exp.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_stream := a_stream
			l_base := a_base
			l_n_digits := a_n_digits
			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			if l_base = 0 then
				l_base := 10
			end
			if l_n_digits = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_n_digits := {NATURAL_32} 2 + (((mp_prec.to_natural_32 - {NATURAL_32} 1) * {NATURAL_32} 32).to_real_64 * (create {P_MP_BASES_STATIC}).gmpn_bases.item[l_base].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32
					l_break := True
				end
				l_break := False
			end
			if l_stream.is_void then
				l_stream := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))
			end
			l_tmp___3 := builtin_expect ((l_n_digits + {NATURAL_32} 2 < {NATURAL_32} 65_536).to_integer, 1)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___3.to_boolean then
				l_tmp___2 := (l_aaf.new (l_n_digits + {NATURAL_32} 2))
			else
				l_tmp___1 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, l_n_digits + {NATURAL_32} 2)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___2 := l_tmp___1
			end
			l_str := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___2);
			((create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_shared (c_pointer))).item.gmpf_get_str (l_str, l_exp, l_base, l_n_digits).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_n_digits := strlen (l_str)
			update_class_fields -- Current might have been changed; synchronize
			l_written := (0).to_natural_32
			if (l_str[0]).to_integer_32 = 45 then
				l_str := l_str + 1
				fputc (('-').code, l_stream).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_written := (1).to_natural_32
				l_n_digits := l_n_digits - 1
			end
			l_tmp___4 := nl_langinfo (65_536)
			update_class_fields -- Current might have been changed; synchronize
			l_point := l_tmp___4
			l_tmp___5 := strlen (l_point)
			update_class_fields -- Current might have been changed; synchronize
			l_pointlen := l_tmp___5
			IO_putc (('0').code, l_stream).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			fwrite (create {CE_VOID_POINTER}.make_cast (l_point), (1).to_natural_32, l_pointlen, l_stream).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_written := l_written + (l_pointlen + {NATURAL_32} 1)
			l_fwret := fwrite (create {CE_VOID_POINTER}.make_cast (l_str), (1).to_natural_32, l_n_digits, l_stream)
			update_class_fields -- Current might have been changed; synchronize
			l_written := l_written + l_fwret
			if l_base <= 10 then
				l_tmp___6 := ce_string ("e%%ld")
			else
				l_tmp___6 := ce_string ("@%%ld")
			end
			l_fpret := fprintf ([l_stream, l_tmp___6, l_exp.item])
			update_class_fields -- Current might have been changed; synchronize
			l_written := l_written + l_fpret.to_natural_32
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp___7 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___7.to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_break := True
			end
			l_break := False
			l_tmp___10 := ferror (l_stream)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___10.to_boolean then
				l_tmp___9 := (0).to_natural_32
			else
				l_tmp___9 := l_written
			end
			Result := l_tmp___9
		end

	gmpf_add_ui (a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: NATURAL_32)
		require
			not a_u.is_void
		local
			l_up: CE_POINTER [NATURAL_32]
			l_sump: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_sumsize: INTEGER_32
			l_prec: INTEGER_32
			l_uexp: INTEGER_32
			l_u_negated: CE_ARRAY [PD_MPF_STRUCT]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_cy_limb: NATURAL_32
			l___dst___0: CE_POINTER [NATURAL_32]
			l___n___0: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_MPF_STRUCT]} l_u_negated.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_up := a_u.item.mp_d
					l_sump := mp_d
					l_prec := mp_prec.to_integer_32
					l_uexp := a_u.item.mp_exp
					l_usize := (a_u.item.mp_size).to_integer_32
					if l_usize <= 0 then
						if l_usize = 0 then
							((create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_shared (c_pointer))).item.gmpf_set_ui (a_v)
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						else
							l_u_negated.item.mp_size := (-l_usize).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							l_u_negated.item.mp_exp := a_u.item.mp_exp
							update_class_fields -- Current might have been changed; synchronize
							l_u_negated.item.mp_d := a_u.item.mp_d
							update_class_fields -- Current might have been changed; synchronize
							gmpf_sub_ui ((create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_shared (c_pointer)), l_u_negated, a_v)
							update_class_fields -- Current might have been changed; synchronize
							Current.mp_size := -mp_size
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if not (not l_return and then (a_v = {NATURAL_32} 0)) then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | sum_is_u:
						if not (a_u.c_pointer = c_pointer) then
							if l_usize < l_prec + 1 then
								l_sumsize := l_usize
							else
								l_sumsize := l_prec + 1
							end
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (mp_d, (l_up + l_usize) - l_sumsize, l_sumsize)
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							Current.mp_size := l_sumsize.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							Current.mp_exp := a_u.item.mp_exp
							update_class_fields -- Current might have been changed; synchronize
						end
						l_return := True
				when 2 then -- if done
					if not l_return then
						if l_uexp > 0 then
							if l_uexp > l_prec then
								l_pos := -1 + 1 -- goto sum_is_u
							elseif l_uexp > l_usize then
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyd ((l_sump + l_uexp) - l_usize, l_up, l_usize)
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
								l_break := False
								l_sump[0] := a_v
								update_class_fields -- Current might have been changed; synchronize
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (l_uexp - l_usize) - 1 /= 0 then
										l___dst := l_sump + 1
										l___n := (l_uexp - l_usize) - 1
										from
										until
											(l_break)
										loop
											l_break := False
											l_tmp := l___dst
											l___dst := l___dst + 1
											l_tmp.item := (0).to_natural_32
											update_class_fields -- Current might have been changed; synchronize
											l___n := l___n - 1
											if not l___n.to_boolean then
												l_break := True
											end
										end
										l_break := False
									end
									l_break := True
								end
								l_break := False
								Current.mp_size := l_uexp.to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								Current.mp_exp := l_uexp
								update_class_fields -- Current might have been changed; synchronize
							else
								if l_usize > l_prec then
									l_up := l_up + (l_usize - l_prec)
									l_usize := l_usize - (l_usize - l_prec)
								end
								if not l_sump.is_equal (l_up) then
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_sump, l_up, l_usize - l_uexp)
										update_class_fields -- Current might have been changed; synchronize
										l_break := True
									end
									l_break := False
								end
								l_cy_limb := (create {P_GMP_STATIC}).gmpn_add_1 ((l_sump + l_usize) - l_uexp, (l_up + l_usize) - l_uexp, l_uexp, a_v)
								update_class_fields -- Current might have been changed; synchronize
								l_sump[l_usize] := l_cy_limb
								update_class_fields -- Current might have been changed; synchronize
								Current.mp_size := (l_usize.to_natural_32 + l_cy_limb).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								Current.mp_exp := (l_uexp.to_natural_32 + l_cy_limb).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							end
						elseif -l_uexp >= l_prec then
							l_sump[0] := a_v
							update_class_fields -- Current might have been changed; synchronize
							Current.mp_size := 1
							update_class_fields -- Current might have been changed; synchronize
							Current.mp_exp := (1).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						else
							if (l_usize + -l_uexp) + 1 > l_prec then
								l_up := l_up + (((l_usize + -l_uexp) + 1) - l_prec)
								l_usize := l_usize - (((l_usize + -l_uexp) + 1) - l_prec)
							end
							if not l_sump.is_equal (l_up) then
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_sump, l_up, l_usize)
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
								l_break := False
							end
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if -l_uexp /= 0 then
									l___dst___0 := l_sump + l_usize
									l___n___0 := -l_uexp
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp___0 := l___dst___0
										l___dst___0 := l___dst___0 + 1
										l_tmp___0.item := (0).to_natural_32
										update_class_fields -- Current might have been changed; synchronize
										l___n___0 := l___n___0 - 1
										if not l___n___0.to_boolean then
											l_break := True
										end
									end
									l_break := False
								end
								l_break := True
							end
							l_break := False
							l_sump[(l_usize + -l_uexp)] := a_v
							update_class_fields -- Current might have been changed; synchronize
							Current.mp_size := ((l_usize + -l_uexp) + 1).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							Current.mp_exp := (1).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpf_mul (a_u, a_v: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_u.is_void
			not a_v.is_void
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_sign_product: INTEGER_32
			l_prec: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_rsize: INTEGER_32
			l_cy_limb: NATURAL_32
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_adj: INTEGER_32
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: INTEGER_32
			l_tmp___4: NATURAL_32
			l_tmp___5: NATURAL_32
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_prec := mp_prec.to_integer_32
			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_usize := (a_u.item.mp_size).to_integer_32
			l_vsize := (a_v.item.mp_size).to_integer_32
			l_sign_product := (l_usize).bit_xor (l_vsize)
			if l_usize >= 0 then
				l_usize := l_usize
			else
				l_usize := -l_usize
			end
			if l_vsize >= 0 then
				l_vsize := l_vsize
			else
				l_vsize := -l_vsize
			end
			l_up := a_u.item.mp_d
			l_vp := a_v.item.mp_d
			if l_usize > l_prec then
				l_up := l_up + (l_usize - l_prec)
				l_usize := l_prec
			end
			if l_vsize > l_prec then
				l_vp := l_vp + (l_vsize - l_prec)
				l_vsize := l_prec
			end
			if l_usize = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_exp := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			elseif l_vsize = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_exp := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			else
				l_rsize := l_usize + l_vsize
				l_tmp___3 := builtin_expect ((l_rsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___3.to_boolean then
					l_tmp___2 := (l_aaf.new ((l_rsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___1 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_rsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := l_tmp___1
				end
				l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
				if l_usize >= l_vsize then
					l_tmp___4 := (create {P_MUL_STATIC}).gmpn_mul (l_tp, l_up, l_usize, l_vp, l_vsize)
					update_class_fields -- Current might have been changed; synchronize
					l_cy_limb := l_tmp___4
				else
					l_tmp___5 := (create {P_MUL_STATIC}).gmpn_mul (l_tp, l_vp, l_vsize, l_up, l_usize)
					update_class_fields -- Current might have been changed; synchronize
					l_cy_limb := l_tmp___5
				end
				l_adj := (l_cy_limb = {NATURAL_32} 0).to_integer
				l_rsize := l_rsize - l_adj
				l_prec := l_prec + 1
				if l_rsize > l_prec then
					l_tp := l_tp + (l_rsize - l_prec)
					l_rsize := l_prec
				end
				l_rp := mp_d
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_tp, l_rsize)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				Current.mp_exp := ((a_u.item.mp_exp + a_v.item.mp_exp) - l_adj)
				update_class_fields -- Current might have been changed; synchronize
				if l_sign_product >= 0 then
					Current.mp_size := l_rsize.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_rsize).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp___6 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___6.to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_break := True
			end
			l_break := False
		end

	gmpf_mul_ui (a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: NATURAL_32)
		require
			not a_u.is_void
		local
			l_up: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_usize: INTEGER_32
			l_size: INTEGER_32
			l_prec: INTEGER_32
			l_excess: INTEGER_32
			l_cy_limb: NATURAL_32
			l_vl: NATURAL_32
			l_cbit: NATURAL_32
			l_cin: CE_ARRAY [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_vl_shifted: CE_ARRAY [NATURAL_32]
			l_hi: CE_ARRAY [NATURAL_32]
			l_lo: CE_ARRAY [NATURAL_32]
			l_next_lo: CE_ARRAY [NATURAL_32]
			l_sum: NATURAL_32
			l_i: CE_ARRAY [INTEGER_32]
			l___x: NATURAL_32
			l___y: NATURAL_32
			l___w: NATURAL_32
			l_tmp___1: INTEGER_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_r: NATURAL_32
			l___gmp_j: INTEGER_32
			l___gmp_j___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_up.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cin.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_vl_shifted.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_hi.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_lo.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_next_lo.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_i.make (<<1>>)

			l_usize := (a_u.item.mp_size).to_integer_32
			l_tmp := builtin_expect ((a_v = {NATURAL_32} 0).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_exp := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			else
				l_tmp___0 := builtin_expect ((l_usize = 0).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					Current.mp_size := 0
					update_class_fields -- Current might have been changed; synchronize
					Current.mp_exp := (0).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
				if l_usize >= 0 then
					l_size := l_usize
				else
					l_size := -l_usize
				end
				l_prec := mp_prec.to_integer_32
				l_up.item := a_u.item.mp_d
				update_class_fields -- Current might have been changed; synchronize
				l_vl := a_v
				l_excess := l_size - l_prec
				l_cin.item := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				if l_excess > 0 then
					l_vl_shifted.item := l_vl
					update_class_fields -- Current might have been changed; synchronize
					l_i.item := l_excess - 1
					update_class_fields -- Current might have been changed; synchronize
					asm1 (l_lo, l_cin, l_up, l_i, l_vl_shifted)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_i.item := l_i.item - 1
						update_class_fields -- Current might have been changed; synchronize
						if l_i.item < 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							asm2 (l_next_lo, l_hi, l_up, l_i, l_vl_shifted)
							l_lo.item := l_lo.item
							update_class_fields -- Current might have been changed; synchronize
							from
							until
								(l_break)
							loop
								l_break := False
								l___x := l_hi.item
								l___y := l_lo.item
								l___w := l___x + l___y
								l_sum := l___w
								l_cbit := (l___w < l___x).to_integer.to_natural_32
								l_break := True
							end
							l_break := False
							l_cin.item := l_cin.item + l_cbit
							update_class_fields -- Current might have been changed; synchronize
							l_lo.item := l_next_lo.item
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___1 := builtin_expect ((l_sum /= {NATURAL_32} 4_294_967_295).to_integer, 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___1.to_boolean then
								l_break := True
							end
						end
					end
					l_break := False
					l_up.item := l_up.item + l_excess
					update_class_fields -- Current might have been changed; synchronize
					l_size := l_prec
				end
				l_rp := mp_d
				l_cy_limb := (create {P_GMP_STATIC}).gmpn_mul_1 (l_rp, l_up.item, l_size, l_vl)
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___gmp_x := l_rp[0]
					l___gmp_r := l___gmp_x + l_cin.item
					l_rp[0] := l___gmp_r
					update_class_fields -- Current might have been changed; synchronize
					if l___gmp_r < l_cin.item then
						l_cbit := (1).to_natural_32
						l___gmp_i := (1).to_integer_32
						from
						until
							not (not (l_return or l_break) and then (l___gmp_i < l_size))
						loop
							l_break := False
							l___gmp_x := l_rp[l___gmp_i]
							l___gmp_r := l___gmp_x + {NATURAL_32} 1
							l_rp[l___gmp_i] := l___gmp_r
							update_class_fields -- Current might have been changed; synchronize
							l___gmp_i := l___gmp_i + 1
							if not (l___gmp_r < {NATURAL_32} 1) then
								if not l_rp.is_equal (l_rp) then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										l___gmp_j := l___gmp_i
										from
										until
											not (l___gmp_j < l_size)
										loop
											l_rp[l___gmp_j] := l_rp[l___gmp_j]
											update_class_fields -- Current might have been changed; synchronize
											l___gmp_j := l___gmp_j + 1
										end
										l_break := True
									end
									l_break := False
								end
								l_cbit := (0).to_natural_32
								l_break := True
							end
						end
						l_break := False
					else
						if not l_rp.is_equal (l_rp) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l___gmp_j___0 := (1).to_integer_32
								from
								until
									not (l___gmp_j___0 < l_size)
								loop
									l_rp[l___gmp_j___0] := l_rp[l___gmp_j___0]
									update_class_fields -- Current might have been changed; synchronize
									l___gmp_j___0 := l___gmp_j___0 + 1
								end
								l_break := True
							end
							l_break := False
						end
						l_cbit := (0).to_natural_32
					end
					l_break := True
				end
				l_break := False
				l_cy_limb := l_cy_limb + l_cbit
				l_rp[l_size] := l_cy_limb
				update_class_fields -- Current might have been changed; synchronize
				l_cy_limb := (l_cy_limb /= {NATURAL_32} 0).to_integer.to_natural_32
				Current.mp_exp := ((a_u.item.mp_exp).to_natural_32 + l_cy_limb).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_size := (l_size.to_natural_32 + l_cy_limb).to_integer_32
				if l_usize >= 0 then
					Current.mp_size := l_size.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_size).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	gmpf_div (a_u, a_v: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_u.is_void
			not a_v.is_void
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_new_vp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_rsize: INTEGER_32
			l_prospective_rsize: INTEGER_32
			l_tsize: INTEGER_32
			l_zeros: INTEGER_32
			l_sign_quotient: INTEGER_32
			l_prec: INTEGER_32
			l_high_zero: INTEGER_32
			l_chop: INTEGER_32
			l_rexp: INTEGER_32
			l_copy_u: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_32]
			l_tmp___8: CE_POINTER [ANY]
			l_tmp___9: CE_POINTER [ANY]
			l_tmp___10: INTEGER_32
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___14: CE_POINTER [ANY]
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_usize := (a_u.item.mp_size).to_integer_32
			l_vsize := (a_v.item.mp_size).to_integer_32
			l_sign_quotient := (l_usize).bit_xor (l_vsize)
			if l_usize >= 0 then
				l_usize := l_usize
			else
				l_usize := -l_usize
			end
			if l_vsize >= 0 then
				l_vsize := l_vsize
			else
				l_vsize := -l_vsize
			end
			l_prec := mp_prec.to_integer_32
			if l_vsize = 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_usize = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_exp := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_rexp := ((a_u.item.mp_exp - a_v.item.mp_exp) + 1)
				l_rp := mp_d
				l_up := a_u.item.mp_d
				l_vp := a_v.item.mp_d
				l_prospective_rsize := (l_usize - l_vsize) + 1
				l_rsize := l_prec + 1
				l_zeros := l_rsize - l_prospective_rsize
				if l_zeros > 0 then
					l_tmp := 1
				elseif l_rp.is_equal (l_up) then
					l_tmp := 1
				else
					l_tmp := 0
				end
				l_copy_u := l_tmp
				if -l_zeros > 0 then
					l_chop := -l_zeros
				else
					l_chop := (0).to_integer_32
				end
				l_up := l_up + l_chop
				l_usize := l_usize - l_chop
				l_zeros := l_zeros + l_chop
				l_tsize := l_usize + l_zeros
				if l_copy_u.to_boolean then
					l_tmp___4 := builtin_expect (((l_tsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___4.to_boolean then
						l_tmp___3 := (l_aaf.new (((l_tsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___2 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_tsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___3 := l_tmp___2
					end
					l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___3)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_zeros /= 0 then
							l___dst := l_tp
							l___n := l_zeros
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___5 := l___dst
								l___dst := l___dst + 1
								l_tmp___5.item := (0).to_natural_32
								update_class_fields -- Current might have been changed; synchronize
								l___n := l___n - 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_tp + l_zeros, l_up, l_usize)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_up := l_tp
					l_usize := l_tsize
				else
					l_tmp___10 := builtin_expect (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___10.to_boolean then
						l_tmp___9 := (l_aaf.new (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___8 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___9 := l_tmp___8
					end
					l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___9)
				end
				if l_rp.is_equal (l_vp) then
					l_tmp___15 := builtin_expect ((l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___15.to_boolean then
						l_tmp___14 := (l_aaf.new ((l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___13 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___14 := l_tmp___13
					end
					l_new_vp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___14)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_new_vp, l_vp, l_vsize)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_vp := l_new_vp
				end
				(create {P_DIV_Q_STATIC}).gmpn_div_q (l_rp, l_up, l_usize, l_vp, l_vsize, l_tp)
				update_class_fields -- Current might have been changed; synchronize
				l_high_zero := (l_rp[(l_rsize - 1)] = {NATURAL_32} 0).to_integer
				l_rsize := l_rsize - l_high_zero
				l_rexp := l_rexp - l_high_zero
				if l_sign_quotient >= 0 then
					Current.mp_size := l_rsize.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_rsize).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.mp_exp := l_rexp
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___16 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___16.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpf_div_ui (a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: NATURAL_32)
		require
			not a_u.is_void
		local
			l_up: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_rtp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_rsize: INTEGER_32
			l_tsize: INTEGER_32
			l_sign_quotient: INTEGER_32
			l_prec: INTEGER_32
			l_q_limb: NATURAL_32
			l_rexp: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			l_tmp___5: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_usize := (a_u.item.mp_size).to_integer_32
			l_sign_quotient := l_usize
			if l_usize >= 0 then
				l_usize := l_usize
			else
				l_usize := -l_usize
			end
			l_prec := mp_prec.to_integer_32
			if a_v = {NATURAL_32} 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_usize = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_exp := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_rp := mp_d
				l_up := a_u.item.mp_d
				l_tsize := 1 + l_prec
				l_tmp___3 := builtin_expect (((l_tsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___3.to_boolean then
					l_tmp___2 := (l_aaf.new (((l_tsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___1 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_tsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := l_tmp___1
				end
				l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
				if l_usize > l_tsize then
					l_up := l_up + (l_usize - l_tsize)
					l_usize := l_tsize
					l_rtp := l_tp
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_tsize - l_usize /= 0 then
							l___dst := l_tp
							l___n := l_tsize - l_usize
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___4 := l___dst
								l___dst := l___dst + 1
								l_tmp___4.item := (0).to_natural_32
								update_class_fields -- Current might have been changed; synchronize
								l___n := l___n - 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					l_rtp := l_tp + (l_tsize - l_usize)
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_rtp, l_up, l_usize)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False;
				(create {P_GMP_STATIC}).gmpn_divrem_1 (l_rp, (0).to_integer_32, l_tp, l_tsize, a_v).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_q_limb := l_rp[(l_tsize - 1)]
				l_rsize := l_tsize - (l_q_limb = {NATURAL_32} 0).to_integer
				l_rexp := (a_u.item.mp_exp - (l_q_limb = {NATURAL_32} 0).to_integer)
				if l_sign_quotient >= 0 then
					Current.mp_size := l_rsize.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_rsize).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.mp_exp := l_rexp
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___5 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___5.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpf_cmp (a_v: CE_POINTER [PD_MPF_STRUCT]): INTEGER_32
		require
			not a_v.is_void
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_uexp: INTEGER_32
			l_vexp: INTEGER_32
			l_cmp: INTEGER_32
			l_usign: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_uexp := mp_exp
			l_vexp := a_v.item.mp_exp
			l_usize := mp_size.to_integer_32
			l_vsize := (a_v.item.mp_size).to_integer_32
			if ((l_usize).bit_xor (l_vsize)) >= 0 then
				if l_usize = 0 then
					Result := (-(l_vsize /= 0).to_integer).to_integer
					l_return := True
				end
				if not l_return and then (l_vsize = 0) then
					Result := (l_usize /= 0).to_integer
					l_return := True
				end
			else
				if l_usize >= 0 then
					l_tmp := 1
				else
					l_tmp := -1
				end
				Result := l_tmp
				l_return := True
			end
			if not l_return then
				if l_usize >= 0 then
					l_usign := 1
				else
					l_usign := -1
				end
				if l_uexp > l_vexp then
					Result := l_usign
					l_return := True
				end
			end
			if not l_return and then (l_uexp < l_vexp) then
				Result := (-l_usign)
				l_return := True
			end
			if not l_return then
				if l_usize >= 0 then
					l_usize := l_usize
				else
					l_usize := -l_usize
				end
				if l_vsize >= 0 then
					l_vsize := l_vsize
				else
					l_vsize := -l_vsize
				end
				l_up := mp_d
				l_vp := a_v.item.mp_d
				from
				until
					l_up[0] /= {NATURAL_32} 0
				loop
					l_up := l_up + 1
					l_usize := l_usize - 1
				end
				from
				until
					l_vp[0] /= {NATURAL_32} 0
				loop
					l_vp := l_vp + 1
					l_vsize := l_vsize - 1
				end
				if l_usize > l_vsize then
					l_cmp := (create {P_GMP_STATIC}).gmpn_cmp ((l_up + l_usize) - l_vsize, l_vp, l_vsize)
					update_class_fields -- Current might have been changed; synchronize
					if l_cmp = 0 then
						Result := l_usign
						l_return := True
					end
				elseif l_vsize > l_usize then
					l_cmp := (create {P_GMP_STATIC}).gmpn_cmp (l_up, (l_vp + l_vsize) - l_usize, l_usize)
					update_class_fields -- Current might have been changed; synchronize
					if l_cmp = 0 then
						Result := (-l_usign)
						l_return := True
					end
				else
					l_cmp := (create {P_GMP_STATIC}).gmpn_cmp (l_up, l_vp, l_usize)
					update_class_fields -- Current might have been changed; synchronize
					if l_cmp = 0 then
						Result := 0
						l_return := True
					end
				end
			end
			if not l_return then
				if l_cmp > 0 then
					l_tmp___0 := l_usign
				else
					l_tmp___0 := -l_usign
				end
				Result := l_tmp___0
			end
		end

	gmpf_cmp_ui (a_vval: NATURAL_32): INTEGER_32
		local
			l_up: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_uexp: INTEGER_32
			l_ulimb: NATURAL_32
			l_return: BOOLEAN
		do
			l_uexp := mp_exp
			l_usize := mp_size.to_integer_32
			if l_usize < 0 then
				Result := (-1)
				l_return := True
			end
			if not l_return and then (a_vval = {NATURAL_32} 0) then
				Result := (l_usize /= 0).to_integer
				l_return := True
			end
			if not l_return and then (l_uexp > 1) then
				Result := 1
				l_return := True
			end
			if not l_return and then (l_uexp < 1) then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_up := mp_d
				l_ulimb := l_up[(l_usize - 1)]
				l_usize := l_usize - 1
				if l_ulimb > a_vval then
					Result := 1
					l_return := True
				elseif l_ulimb < a_vval then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				from
				until
					l_up.item /= {NATURAL_32} 0
				loop
					l_up := l_up + 1
					l_usize := l_usize - 1
				end
				if l_usize > 0 then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gmpf_cmp_si (a_vval: INTEGER_32): INTEGER_32
		local
			l_vval: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_uexp: INTEGER_32
			l_ulimb: NATURAL_32
			l_usign: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_vval := a_vval
			l_uexp := mp_exp
			l_usize := mp_size.to_integer_32
			if (l_usize < 0) = (l_vval < 0) then
				if l_usize = 0 then
					Result := (-(l_vval /= 0).to_integer).to_integer
					l_return := True
				end
				if not l_return and then (l_vval = 0) then
					Result := (l_usize /= 0).to_integer
					l_return := True
				end
			else
				if l_usize >= 0 then
					l_tmp := 1
				else
					l_tmp := -1
				end
				Result := l_tmp
				l_return := True
			end
			if not l_return then
				if l_usize >= 0 then
					l_usign := 1
				else
					l_usign := -1
				end
				if l_usize >= 0 then
					l_usize := l_usize
				else
					l_usize := -l_usize
				end
				if l_vval >= 0 then
					l_vval := l_vval
				else
					l_vval := -l_vval
				end
				if l_uexp > 1 then
					Result := l_usign
					l_return := True
				end
			end
			if not l_return and then (l_uexp < 1) then
				Result := (-l_usign)
				l_return := True
			end
			if not l_return then
				l_up := mp_d
				l_ulimb := l_up[(l_usize - 1)]
				l_usize := l_usize - 1
				if l_ulimb > l_vval.to_natural_32 then
					Result := l_usign
					l_return := True
				elseif l_ulimb < l_vval.to_natural_32 then
					Result := (-l_usign)
					l_return := True
				end
			end
			if not l_return then
				from
				until
					l_up.item /= {NATURAL_32} 0
				loop
					l_up := l_up + 1
					l_usize := l_usize - 1
				end
				if l_usize > 0 then
					Result := l_usign
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gmpf_abs (a_u: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_u.is_void
		local
			l_size: INTEGER_32
			l_prec: INTEGER_32
			l_rp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			if a_u.item.mp_size >= 0 then
				l_size := (a_u.item.mp_size).to_integer_32
			else
				l_size := (-a_u.item.mp_size).to_integer_32
			end
			if not (c_pointer = (a_u).c_pointer) then
				l_prec := (mp_prec + 1).to_integer_32
				l_rp := mp_d
				l_up := a_u.item.mp_d
				if l_size > l_prec then
					l_up := l_up + (l_size - l_prec)
					l_size := l_prec
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_up, l_size)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				Current.mp_exp := a_u.item.mp_exp
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.mp_size := l_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpf_neg (a_u: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_u.is_void
		local
			l_size: INTEGER_32
			l_prec: INTEGER_32
			l_asize: INTEGER_32
			l_rp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			l_size := (-a_u.item.mp_size).to_integer_32
			if not (c_pointer = (a_u).c_pointer) then
				l_prec := (mp_prec + 1).to_integer_32
				if l_size >= 0 then
					l_asize := l_size
				else
					l_asize := -l_size
				end
				l_rp := mp_d
				l_up := a_u.item.mp_d
				if l_asize > l_prec then
					l_up := l_up + (l_asize - l_prec)
					l_asize := l_prec
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_up, l_asize)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				Current.mp_exp := a_u.item.mp_exp
				update_class_fields -- Current might have been changed; synchronize
				if l_size >= 0 then
					l_size := l_asize
				else
					l_size := -l_asize
				end
			end
			Current.mp_size := l_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpf_set_q (a_q: CE_POINTER [PD_MPQ_STRUCT])
		require
			not a_q.is_void
		local
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_prec: INTEGER_32
			l_nsize: INTEGER_32
			l_dsize: INTEGER_32
			l_qsize: INTEGER_32
			l_prospective_qsize: INTEGER_32
			l_tsize: INTEGER_32
			l_zeros: INTEGER_32
			l_sign_quotient: INTEGER_32
			l_high_zero: INTEGER_32
			l_qp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_remp: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_size: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___14: CE_POINTER [ANY]
			l_tmp___15: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___16: CE_POINTER [NATURAL_32]
			l_tmp___17: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_nsize := (a_q.item.mp_num.mp_size).to_integer_32
			l_dsize := (a_q.item.mp_den.mp_size).to_integer_32
			l_tmp := builtin_expect ((l_nsize = 0).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_exp := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_prec := mp_prec.to_integer_32
				l_qp := mp_d
				l_sign_quotient := l_nsize
				if l_nsize >= 0 then
					l_nsize := l_nsize
				else
					l_nsize := -l_nsize
				end
				l_np := a_q.item.mp_num.mp_d
				l_dp := a_q.item.mp_den.mp_d
				l_prospective_qsize := (l_nsize - l_dsize) + 1
				l_exp := l_prospective_qsize
				l_qsize := l_prec + 1
				l_zeros := l_qsize - l_prospective_qsize
				l_tsize := l_nsize + l_zeros
				if l_zeros > 0 then
					l_tmp___10 := l_tsize
				else
					l_tmp___10 := (0).to_integer_32
				end
				l_size := l_dsize + l_tmp___10
				l_tmp___15 := builtin_expect ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___15.to_boolean then
					l_tmp___14 := (l_aaf.new ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___13 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___14 := l_tmp___13
				end
				l_remp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___14)
				l_tp := l_remp + l_dsize
				if l_zeros > 0 then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_zeros /= 0 then
							l___dst := l_tp
							l___n := l_zeros
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___16 := l___dst
								l___dst := l___dst + 1
								l_tmp___16.item := (0).to_natural_32
								update_class_fields -- Current might have been changed; synchronize
								l___n := l___n - 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_tp + l_zeros, l_np, l_nsize)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_np := l_tp
					l_nsize := l_tsize
				else
					l_nsize := l_nsize + l_zeros
					l_np := l_np - l_zeros
				end
				(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_qp, l_remp, (0).to_integer_32, l_np, l_nsize, l_dp, l_dsize)
				update_class_fields -- Current might have been changed; synchronize
				l_high_zero := (l_qp[(l_qsize - 1)] = {NATURAL_32} 0).to_integer
				l_qsize := l_qsize - l_high_zero
				l_exp := l_exp - l_high_zero
				Current.mp_exp := l_exp
				update_class_fields -- Current might have been changed; synchronize
				if l_sign_quotient >= 0 then
					Current.mp_size := l_qsize.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_qsize).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___17 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___17.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpf_get_d: REAL_64
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_exp: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: REAL_64
			l_return: BOOLEAN
		do
			l_size := mp_size.to_integer_32
			l_tmp := builtin_expect ((l_size = 0).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				if l_size >= 0 then
					l_abs_size := l_size
				else
					l_abs_size := -l_size
				end
				l_exp := ((mp_exp - l_abs_size) * 32)
				l_tmp___0 := (create {P_GET_D_STATIC}).gmpn_get_d (mp_d, l_abs_size, l_size, l_exp)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___0
			end
		end

	gmpf_get_d_2exp (a_exp2: CE_POINTER [INTEGER_32]): REAL_64
		require
			not a_exp2.is_void
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_32]
			l_cnt: INTEGER_32
			l_exp: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: REAL_64
			l_return, l_break: BOOLEAN
		do
			l_size := mp_size.to_integer_32
			l_tmp := builtin_expect ((l_size = 0).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				a_exp2.item := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				l_ptr := mp_d
				if l_size >= 0 then
					l_abs_size := l_size
				else
					l_abs_size := -l_size
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_cnt := builtin_clzl (l_ptr[(l_abs_size - 1)])
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_cnt := l_cnt
				l_exp := (mp_exp * 32 - l_cnt.to_integer_32)
				a_exp2.item := l_exp
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := (create {P_GET_D_STATIC}).gmpn_get_d (l_ptr, l_abs_size, (0).to_integer_32, -(l_abs_size * 32 - l_cnt.to_integer_32))
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___0
			end
		end

	gmpf_set_prec (a_new_prec_in_bits: NATURAL_32)
		local
			l_old_prec: INTEGER_32
			l_new_prec: INTEGER_32
			l_new_prec_plus1: INTEGER_32
			l_size: INTEGER_32
			l_sign: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			if {NATURAL_32} 53 > a_new_prec_in_bits then
				l_tmp := (53).to_natural_32
			else
				l_tmp := a_new_prec_in_bits
			end
			l_new_prec := (((l_tmp + {NATURAL_32} 64) - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
			l_old_prec := mp_prec.to_integer_32
			if l_new_prec = l_old_prec then
				l_return := True
			end
			if not l_return then
				Current.mp_prec := l_new_prec.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_new_prec_plus1 := l_new_prec + 1
				l_sign := mp_size.to_integer_32
				if l_sign >= 0 then
					l_size := l_sign
				else
					l_size := -l_sign
				end
				l_xp := mp_d
				if l_size > l_new_prec_plus1 then
					if l_sign >= 0 then
						Current.mp_size := l_new_prec_plus1.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					else
						Current.mp_size := (-l_new_prec_plus1).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_xp, ((l_xp + l_size) - l_new_prec_plus1), l_new_prec_plus1)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
				end
				l_tmp___0 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_xp), ((l_old_prec + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32, (l_new_prec_plus1.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32]))
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___0)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	gmpf_set_prec_raw (a_prec_in_bits: NATURAL_32)
		local
			l_tmp: NATURAL_32
		do
			if {NATURAL_32} 53 > a_prec_in_bits then
				l_tmp := (53).to_natural_32
			else
				l_tmp := a_prec_in_bits
			end
			Current.mp_prec := ((((l_tmp + {NATURAL_32} 64) - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpf_get_prec: NATURAL_32
		do
			Result := (mp_prec.to_natural_32 * {NATURAL_32} 32 - {NATURAL_32} 32)
		end

	gmpf_ui_div (a_u: NATURAL_32; a_v: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_v.is_void
		local
			l_vp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_remp: CE_POINTER [NATURAL_32]
			l_new_vp: CE_POINTER [NATURAL_32]
			l_vsize: INTEGER_32
			l_rsize: INTEGER_32
			l_prospective_rsize: INTEGER_32
			l_zeros: INTEGER_32
			l_tsize: INTEGER_32
			l_high_zero: INTEGER_32
			l_sign_quotient: INTEGER_32
			l_prec: INTEGER_32
			l_rexp: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_size: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___19: CE_POINTER [ANY]
			l_tmp___20: CE_POINTER [ANY]
			l_tmp___21: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___22: CE_POINTER [NATURAL_32]
			l_tmp___23: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_vsize := (a_v.item.mp_size).to_integer_32
			l_sign_quotient := l_vsize
			if l_vsize >= 0 then
				l_vsize := l_vsize
			else
				l_vsize := -l_vsize
			end
			l_prec := mp_prec.to_integer_32
			l_tmp := builtin_expect ((l_vsize = 0).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_tmp___0 := builtin_expect ((a_u = {NATURAL_32} 0).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___0.to_boolean then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_exp := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_rexp := ((1 - a_v.item.mp_exp) + 1)
				l_rp := mp_d
				l_vp := a_v.item.mp_d
				l_prospective_rsize := (1 - l_vsize) + 1
				l_rsize := l_prec + 1
				l_zeros := l_rsize - l_prospective_rsize
				l_tsize := 1 + l_zeros
				if l_rp.is_equal (l_vp) then
					l_tmp___16 := l_vsize
				else
					l_tmp___16 := (0).to_integer_32
				end
				l_size := (l_vsize + l_tsize) + l_tmp___16
				l_tmp___21 := builtin_expect ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___21.to_boolean then
					l_tmp___20 := (l_aaf.new ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___19 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___20 := l_tmp___19
				end
				l_remp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___20)
				l_tp := l_remp + l_vsize
				l_new_vp := l_tp + l_tsize
				if l_rp.is_equal (l_vp) then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_new_vp, l_vp, l_vsize)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_vp := l_new_vp
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if l_tsize - 1 /= 0 then
						l___dst := l_tp
						l___n := l_tsize - 1
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___22 := l___dst
							l___dst := l___dst + 1
							l_tmp___22.item := (0).to_natural_32
							update_class_fields -- Current might have been changed; synchronize
							l___n := l___n - 1
							if not l___n.to_boolean then
								l_break := True
							end
						end
						l_break := False
					end
					l_break := True
				end
				l_break := False
				l_tp[(l_tsize - 1)] := (a_u).bit_and ({NATURAL_32} 4_294_967_295)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_rp, l_remp, (0).to_integer_32, l_tp, l_tsize, l_vp, l_vsize)
				update_class_fields -- Current might have been changed; synchronize
				l_high_zero := (l_rp[(l_rsize - 1)] = {NATURAL_32} 0).to_integer
				l_rsize := l_rsize - l_high_zero
				l_rexp := l_rexp - l_high_zero
				if l_sign_quotient >= 0 then
					Current.mp_size := l_rsize.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_rsize).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.mp_exp := l_rexp
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___23 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___23.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpf_sqrt_ui (a_u: NATURAL_32)
		local
			l_rsize: INTEGER_32
			l_zeros: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_prec: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_32]
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_tmp := builtin_expect ((a_u = {NATURAL_32} 0).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_exp := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_prec := mp_prec.to_integer_32
				l_zeros := 2 * l_prec - 2
				l_rsize := l_zeros + 1
				l_tmp___4 := builtin_expect ((l_rsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___4.to_boolean then
					l_tmp___3 := (l_aaf.new ((l_rsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___2 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_rsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___3 := l_tmp___2
				end
				l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___3)
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if l_zeros /= 0 then
						l___dst := l_tp
						l___n := l_zeros
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___5 := l___dst
							l___dst := l___dst + 1
							l_tmp___5.item := (0).to_natural_32
							update_class_fields -- Current might have been changed; synchronize
							l___n := l___n - 1
							if not l___n.to_boolean then
								l_break := True
							end
						end
						l_break := False
					end
					l_break := True
				end
				l_break := False
				l_tp[l_zeros] := (a_u).bit_and ({NATURAL_32} 4_294_967_295)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SQRTREM_STATIC}).gmpn_sqrtrem (mp_d, create {CE_NATURAL_32_POINTER}.make_shared (default_pointer), l_tp, l_rsize).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_size := l_prec.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_exp := (1).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___6 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___6.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpf_ceil_or_floor (a_dir: INTEGER_32; a_u: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_u.is_void
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_p: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_asize: INTEGER_32
			l_prec: INTEGER_32
			l_exp: INTEGER_32
			l_tmp: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_POINTER} l_rp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_size := (a_u.item.mp_size).to_integer_32
					if l_size /= 0 then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | zero:
						Current.mp_size := 0
						update_class_fields -- Current might have been changed; synchronize
						Current.mp_exp := (0).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
				when 2 then -- if done
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 3 then -- if:
						l_rp := mp_d
						l_exp := a_u.item.mp_exp
						if not (l_exp <= 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if ((l_size).bit_xor (a_dir.to_integer_32)) < 0 then
							l_pos := -1 + 1 -- goto zero
						end
				when 5 then
						l_rp[0] := (1).to_natural_32
						update_class_fields -- Current might have been changed; synchronize
						Current.mp_exp := (1).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						Current.mp_size := a_dir
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
				when 6 then -- if done | if done
					if not l_return then
						Current.mp_exp := l_exp
						update_class_fields -- Current might have been changed; synchronize
						l_up := a_u.item.mp_d
						if l_size >= 0 then
							l_asize := l_size
						else
							l_asize := -l_size
						end
						l_up := l_up + l_asize
						if l_asize < l_exp then
							l_asize := l_asize
						else
							l_asize := l_exp
						end
						l_prec := (mp_prec + 1).to_integer_32
						if l_asize < l_prec then
							l_asize := l_asize
						else
							l_asize := l_prec
						end
						l_up := l_up - l_asize
						if ((l_size).bit_xor (a_dir.to_integer_32)) >= 0 then
							l_p := a_u.item.mp_d
							from
							until
								not (not (l_return) and then (not l_p.is_equal (l_up)))
							loop
								if l_p.item /= {NATURAL_32} 0 then
									l_tmp := (create {P_GMP_STATIC}).gmpn_add_1 (l_rp, l_up, l_asize, (1).to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp.to_boolean then
										l_rp[0] := (1).to_natural_32
										update_class_fields -- Current might have been changed; synchronize
										l_asize := (1).to_integer_32
										Current.mp_exp := mp_exp + 1
										update_class_fields -- Current might have been changed; synchronize
									end
									if l_size >= 0 then
										Current.mp_size := l_asize.to_integer_32
										update_class_fields -- Current might have been changed; synchronize
									else
										Current.mp_size := (-l_asize).to_integer_32
										update_class_fields -- Current might have been changed; synchronize
									end
									l_return := True
								end
								if not l_return then
									l_p := l_p + 1
								end
							end
						end
					end
					if not l_return then
						if l_size >= 0 then
							Current.mp_size := l_asize.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						else
							Current.mp_size := (-l_asize).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
						if not l_rp.is_equal (l_up) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_up, l_asize)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
						end
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpf_ceil (a_u: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_u.is_void
		do
			((create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_shared (c_pointer))).item.gmpf_ceil_or_floor (1, a_u)
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpf_floor (a_u: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_u.is_void
		do
			((create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_shared (c_pointer))).item.gmpf_ceil_or_floor (-1, a_u)
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpf_trunc (a_u: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_u.is_void
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_asize: INTEGER_32
			l_prec: INTEGER_32
			l_exp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_exp := a_u.item.mp_exp
			l_size := (a_u.item.mp_size).to_integer_32
			if l_size = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_exp := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			elseif l_exp <= 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_exp := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_up := a_u.item.mp_d
				Current.mp_exp := l_exp
				update_class_fields -- Current might have been changed; synchronize
				if l_size >= 0 then
					l_asize := l_size
				else
					l_asize := -l_size
				end
				l_up := l_up + l_asize
				if l_asize < l_exp then
					l_asize := l_asize
				else
					l_asize := l_exp
				end
				l_prec := (mp_prec + 1).to_integer_32
				if l_asize < l_prec then
					l_asize := l_asize
				else
					l_asize := l_prec
				end
				l_up := l_up - l_asize
				l_rp := mp_d
				if l_size >= 0 then
					Current.mp_size := l_asize.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_asize).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				if not l_rp.is_equal (l_up) then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_up, l_asize)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
				end
			end
		end

	gmpf_pow_ui (a_b: CE_POINTER [PD_MPF_STRUCT]; a_e: NATURAL_32)
		require
			not a_b.is_void
		local
			l_b2: CE_ARRAY [PD_MPF_STRUCT]
			l_e2: NATURAL_32
			l_tmp: NATURAL_32
		do
			create {CE_CLASS_ARRAY [PD_MPF_STRUCT]} l_b2.make (<<1>>)

			l_tmp := ((create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_shared (c_pointer))).item.gmpf_get_prec
			update_class_fields -- Current might have been changed; synchronize
			l_b2.item.gmpf_init2 (l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			l_b2.item.gmpf_set (a_b)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_shared (c_pointer))).item.gmpf_set_ui ({NATURAL_32} 1)
			update_class_fields -- Current might have been changed; synchronize
			if ((a_e).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
				((create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_shared (c_pointer))).item.gmpf_set (create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_cast (l_b2))
				update_class_fields -- Current might have been changed; synchronize
			end
			l_e2 := (a_e).bit_shift_right (1)
			from
			until
				l_e2 = {NATURAL_32} 0
			loop
				l_b2.item.gmpf_mul (create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_cast (l_b2), create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_cast (l_b2))
				update_class_fields -- Current might have been changed; synchronize
				if ((l_e2).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
					((create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_shared (c_pointer))).item.gmpf_mul ((create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_cast (l_b2))
					update_class_fields -- Current might have been changed; synchronize
				end
				l_e2 := (l_e2).bit_shift_right ((1))
			end
			l_b2.item.gmpf_clear
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpf_urandomb (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_nbits: NATURAL_32)
		require
			not a_rstate.is_void
		local
			l_nbits: NATURAL_32
			l_rp: CE_POINTER [NATURAL_32]
			l_nlimbs: INTEGER_32
			l_exp: INTEGER_32
			l_prec: INTEGER_32
			l___rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_break: BOOLEAN
		do
			l_nbits := a_nbits
			l_rp := mp_d
			l_nlimbs := ((l_nbits + {NATURAL_32} 31) // {NATURAL_32} 32).to_integer_32
			l_prec := mp_prec.to_integer_32
			if l_nlimbs > l_prec + 1 then
				l_nlimbs := l_prec + 1
				l_nbits := (l_nlimbs * 32).to_natural_32
			elseif l_nlimbs = 0 then
				l_nlimbs := l_prec + 1
				l_nbits := (l_nlimbs * 32).to_natural_32
			end
			from
			until
				(l_break)
			loop
				l_break := False
				l___rstate := a_rstate;
				((create {CE_CLASS_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate, l_rp, l_nbits])
				update_class_fields -- Current might have been changed; synchronize
				l_break := True
			end
			l_break := False
			if l_nbits \\ {NATURAL_32} 32 /= {NATURAL_32} 0 then
				(create {P_GMP_STATIC}).gmpn_lshift (l_rp, l_rp, l_nlimbs, ({NATURAL_32} 32 - l_nbits \\ {NATURAL_32} 32).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			l_exp := (0).to_integer_32
			from
			until
				(l_break)
			loop
				l_break := False
				if l_nlimbs /= 0 then
					if l_rp[(l_nlimbs - 1)] /= {NATURAL_32} 0 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_nlimbs := l_nlimbs - 1
					l_exp := l_exp - 1
				end
			end
			l_break := False
			Current.mp_exp := l_exp
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_size := l_nlimbs.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpf_swap (a_v: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_v.is_void
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_uprec: INTEGER_32
			l_vprec: INTEGER_32
			l_uexp: INTEGER_32
			l_vexp: INTEGER_32
		do
			l_uprec := mp_prec.to_integer_32
			l_vprec := (a_v.item.mp_prec).to_integer_32
			a_v.item.mp_prec := l_uprec.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_prec := l_vprec.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_usize := mp_size.to_integer_32
			l_vsize := (a_v.item.mp_size).to_integer_32
			a_v.item.mp_size := l_usize.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_size := l_vsize.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_uexp := mp_exp
			l_vexp := a_v.item.mp_exp
			a_v.item.mp_exp := l_uexp
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_exp := l_vexp
			update_class_fields -- Current might have been changed; synchronize
			l_up := mp_d
			l_vp := a_v.item.mp_d
			a_v.item.mp_d := l_up
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_d := l_vp
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpf_fits_sint_p: INTEGER_32
		local
			l_fs: INTEGER_32
			l_fn: INTEGER_32
			l_fp: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l_fl: NATURAL_32
			l_tmp: NATURAL_32
			l_return: BOOLEAN
		do
			l_fs := mp_size.to_integer_32
			if l_fs = 0 then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_exp := mp_exp
				if l_exp < 1 then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				l_fp := mp_d
				if l_fs >= 0 then
					l_fn := l_fs
				else
					l_fn := -l_fs
				end
				if l_exp = 1 then
					l_fl := l_fp[(l_fn - 1)]
				else
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if l_fs >= 0 then
					l_tmp := (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)).to_natural_32
				else
					l_tmp := (-(((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32).to_natural_32).to_integer_32).to_natural_32
				end
				Result := (l_fl <= l_tmp).to_integer
			end
		end

	gmpf_fits_slong_p: INTEGER_32
		local
			l_fs: INTEGER_32
			l_fn: INTEGER_32
			l_fp: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l_fl: NATURAL_32
			l_tmp: NATURAL_32
			l_return: BOOLEAN
		do
			l_fs := mp_size.to_integer_32
			if l_fs = 0 then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_exp := mp_exp
				if l_exp < 1 then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				l_fp := mp_d
				if l_fs >= 0 then
					l_fn := l_fs
				else
					l_fn := -l_fs
				end
				if l_exp = 1 then
					l_fl := l_fp[(l_fn - 1)]
				else
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if l_fs >= 0 then
					l_tmp := (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)).to_natural_32
				else
					l_tmp := (-(((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32).to_natural_32).to_integer_32).to_natural_32
				end
				Result := (l_fl <= l_tmp).to_integer
			end
		end

	gmpf_fits_sshort_p: INTEGER_32
		local
			l_fs: INTEGER_32
			l_fn: INTEGER_32
			l_fp: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l_fl: NATURAL_32
			l_tmp: NATURAL_32
			l_return: BOOLEAN
		do
			l_fs := mp_size.to_integer_32
			if l_fs = 0 then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_exp := mp_exp
				if l_exp < 1 then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				l_fp := mp_d
				if l_fs >= 0 then
					l_fn := l_fs
				else
					l_fn := -l_fs
				end
				if l_exp = 1 then
					l_fl := l_fp[(l_fn - 1)]
				else
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if l_fs >= 0 then
					l_tmp := ((-(((((65_535).bit_xor (((65_535).bit_shift_right (1)))).to_natural_16).to_integer_16).to_integer_32 + 1)).to_integer_16).to_natural_32
				else
					l_tmp := (-(((((65_535).bit_xor (((65_535).bit_shift_right (1)))).to_natural_16).to_integer_16).to_natural_32).to_integer_32).to_natural_32
				end
				Result := (l_fl <= l_tmp).to_integer
			end
		end

	gmpf_fits_uint_p: INTEGER_32
		local
			l_fn: INTEGER_32
			l_fp: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l_fl: NATURAL_32
			l_return: BOOLEAN
		do
			l_fn := mp_size.to_integer_32
			if l_fn <= 0 then
				Result := (l_fn = 0).to_integer
				l_return := True
			end
			if not l_return then
				l_exp := mp_exp
				if l_exp < 1 then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				l_fp := mp_d
				if l_exp = 1 then
					l_fl := l_fp[(l_fn - 1)]
				else
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := (l_fl <= {NATURAL_32} 4_294_967_295).to_integer
			end
		end

	gmpf_fits_ulong_p: INTEGER_32
		local
			l_fn: INTEGER_32
			l_fp: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l_fl: NATURAL_32
			l_return: BOOLEAN
		do
			l_fn := mp_size.to_integer_32
			if l_fn <= 0 then
				Result := (l_fn = 0).to_integer
				l_return := True
			end
			if not l_return then
				l_exp := mp_exp
				if l_exp < 1 then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				l_fp := mp_d
				if l_exp = 1 then
					l_fl := l_fp[(l_fn - 1)]
				else
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := (l_fl <= {NATURAL_32} 4_294_967_295).to_integer
			end
		end

	gmpf_fits_ushort_p: INTEGER_32
		local
			l_fn: INTEGER_32
			l_fp: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l_fl: NATURAL_32
			l_return: BOOLEAN
		do
			l_fn := mp_size.to_integer_32
			if l_fn <= 0 then
				Result := (l_fn = 0).to_integer
				l_return := True
			end
			if not l_return then
				l_exp := mp_exp
				if l_exp < 1 then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				l_fp := mp_d
				if l_exp = 1 then
					l_fl := l_fp[(l_fn - 1)]
				else
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := (l_fl <= {NATURAL_32} 65_535).to_integer
			end
		end

	gmpf_get_si: INTEGER_32
		local
			l_exp: INTEGER_32
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_fp: CE_POINTER [NATURAL_32]
			l_fl: NATURAL_32
			l_return: BOOLEAN
		do
			l_exp := mp_exp
			l_size := mp_size.to_integer_32
			l_fp := mp_d
			if l_exp <= 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_fl := (0).to_natural_32
				if l_size >= 0 then
					l_abs_size := l_size
				else
					l_abs_size := -l_size
				end
				if l_abs_size >= l_exp then
					l_fl := l_fp[(l_abs_size - l_exp)]
				end
				if l_size > 0 then
					Result := ((l_fl).bit_and ((-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)).to_natural_32)).to_integer_32
				else
					Result := (((((l_fl - {NATURAL_32} 1)).bit_and ((-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)).to_natural_32))).bit_not).to_integer_32
				end
			end
		end

	gmpf_get_ui: NATURAL_32
		local
			l_size: INTEGER_32
			l_exp: INTEGER_32
			l_fp: CE_POINTER [NATURAL_32]
			l_fl: NATURAL_32
		do
			l_exp := mp_exp
			l_size := mp_size.to_integer_32
			l_fp := mp_d
			l_fl := (0).to_natural_32
			if l_exp > 0 then
				if l_size >= 0 then
					l_size := l_size
				else
					l_size := -l_size
				end
				if l_size >= l_exp then
					l_fl := l_fp[(l_size - l_exp)]
				end
			end
			Result := l_fl
		end

	gmpf_integer_p: INTEGER_32
		local
			l_ptr: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l_size: INTEGER_32
			l_frac: INTEGER_32
			l_i: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_size := mp_size.to_integer_32
			if l_size = 0 then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_exp := mp_exp
				if l_exp <= 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if l_size >= 0 then
					l_tmp := l_size
				else
					l_tmp := -l_size
				end
				l_frac := l_tmp - l_exp
				l_ptr := mp_d
				l_i := (0).to_integer_32
				from
				until
					not (not (l_return) and then (l_i < l_frac))
				loop
					if l_ptr[l_i] /= {NATURAL_32} 0 then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 1
			end
		end

feature {PD_MPF_STRUCT} -- private routines

	mpn_pow_1_highpart___0 (a_rp: CE_POINTER [NATURAL_32]; a_ignp: CE_POINTER [INTEGER_32]; a_base, a_exp: NATURAL_32; a_prec: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		require
			not a_rp.is_void
			not a_ignp.is_void
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_ign: INTEGER_32
			l_off: INTEGER_32
			l_passed_rp: CE_POINTER [NATURAL_32]
			l_rn: INTEGER_32
			l_cnt: INTEGER_32
			l_i: INTEGER_32
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_rp := a_rp
			l_tp := a_tp
			l_passed_rp := l_rp
			if a_exp = {NATURAL_32} 0 then
				l_rp[0] := (1).to_natural_32
				a_ignp.item := (0).to_integer_32
				Result := (1).to_integer_32
				l_return := True
			end
			if not l_return then
				l_rp[0] := a_base
				l_rn := (1).to_integer_32
				l_off := (0).to_integer_32
				l_ign := (0).to_integer_32
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_cnt := builtin_clzl (a_exp)
					l_break := True
				end
				l_break := False
				l_i := (32 - l_cnt) - 2
				from
				until
					not (not (l_return) and then (l_i >= 0))
				loop
					(create {P_SQR_STATIC}).gmpn_sqr (l_tp, (l_rp + l_off), l_rn)
					l_rn := 2 * l_rn
					l_rn := l_rn - (l_tp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
					l_ign := (l_ign).bit_shift_left ((1))
					l_off := (0).to_integer_32
					if l_rn > a_prec then
						l_ign := l_ign + (l_rn - a_prec)
						l_off := l_rn - a_prec
						l_rn := a_prec
					end
					from
					until
						(l_break)
					loop
						l_break := False
						l___mp_ptr_swap__tmp := l_rp
						l_rp := l_tp
						l_tp := l___mp_ptr_swap__tmp
						l_break := True
					end
					l_break := False
					if ((((a_exp).bit_shift_right (l_i))).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
						l_cy := (create {P_GMP_STATIC}).gmpn_mul_1 (l_rp, (l_rp + l_off), l_rn, a_base)
						l_rp[l_rn] := l_cy
						l_rn := l_rn + (l_cy /= {NATURAL_32} 0).to_integer
						l_off := (0).to_integer_32
					end
					l_i := l_i - 1
				end
				if l_rn > a_prec then
					l_ign := l_ign + (l_rn - a_prec)
					l_rp := l_rp + (l_rn - a_prec)
					l_rn := a_prec
				end
				if not l_passed_rp.is_equal (l_rp + l_off) then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_passed_rp, (l_rp + l_off), l_rn)
						l_break := True
					end
					l_break := False
				end
				a_ignp.item := l_ign
				Result := l_rn
			end
		end

	gmpf_sub_ui (a_sum, a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: NATURAL_32)
		require
			not a_u.is_void
		local
			l_vv: CE_ARRAY [PD_MPF_STRUCT]
			l_vl: CE_ARRAY [NATURAL_32]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_MPF_STRUCT]} l_vv.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_vl.make (<<1>>)

			if a_v = {NATURAL_32} 0 then
				a_sum.item.gmpf_set (a_u)
				l_return := True
			end
			if not l_return then
				l_vl.item := a_v
				l_vv.item.mp_size := 1
				l_vv.item.mp_d := l_vl
				l_vv.item.mp_exp := (1).to_integer_32;
				(create {P_SUB_STATIC}).gmpf_sub (a_sum, a_u, l_vv)
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mp_prec := a_other.mp_prec
			mp_size := a_other.mp_size
			mp_exp := a_other.mp_exp
			mp_d := a_other.mp_d
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mp_prec = a_other.mp_prec and
				mp_size = a_other.mp_size and
				mp_exp = a_other.mp_exp and
				mp_d.is_equal (a_other.mp_d)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("mp_prec"),
					create {CE_STRUCTURE_FIELD}.make ("mp_size"),
					create {CE_STRUCTURE_FIELD}.make ("mp_exp"),
					create {CE_STRUCTURE_FIELD}.make ("mp_d")
				>>)
			init_structure_info
		end

end
