class
	S_STDIO_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	fprintf (a_args: TUPLE [a___stream: CE_POINTER [SD_IO_FILE]; a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fprintf)).integer_32_item (a_args)
		end

	c_fprintf: POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return (EIF_POINTER)&fprintf;"
		end

	printf (a_args: TUPLE [a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_printf)).integer_32_item (a_args)
		end

	c_printf: POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return (EIF_POINTER)&printf;"
		end

	ungetc (a___c: INTEGER_32; a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_ungetc (a___c, a___stream.c_pointer)
		end

	c_ungetc (a___c: INTEGER_32; a___stream: POINTER): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return ungetc($a___c, $a___stream);"
		end

	fputc (a___c: INTEGER_32; a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputc (a___c, a___stream.c_pointer)
		end

	c_fputc (a___c: INTEGER_32; a___stream: POINTER): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return fputc($a___c, $a___stream);"
		end

	fwrite (a___ptr: CE_POINTER [ANY]; a___size, a___n: NATURAL_32; a___s: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fwrite (a___ptr.c_pointer, a___size, a___n, a___s.c_pointer)
		end

	c_fwrite (a___ptr: POINTER; a___size: NATURAL_32; a___n: NATURAL_32; a___s: POINTER): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return fwrite($a___ptr, $a___size, $a___n, $a___s);"
		end

	ferror (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_ferror (a___stream.c_pointer)
		end

	c_ferror (a___stream: POINTER): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return ferror($a___stream);"
		end

	fread (a___ptr: CE_POINTER [ANY]; a___size, a___n: NATURAL_32; a___stream: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fread (a___ptr.c_pointer, a___size, a___n, a___stream.c_pointer)
		end

	c_fread (a___ptr: POINTER; a___size: NATURAL_32; a___n: NATURAL_32; a___stream: POINTER): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return fread($a___ptr, $a___size, $a___n, $a___stream);"
		end

	snprintf (a_args: TUPLE [a___s: CE_POINTER [INTEGER_8]; a___maxlen: NATURAL_32; a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_snprintf)).integer_32_item (a_args)
		end

	c_snprintf: POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return (EIF_POINTER)&snprintf;"
		end

	obstack_vprintf (a___obstack: CE_POINTER [SD_OBSTACK]; a___format: CE_POINTER [INTEGER_8]; a___args: CE_VA_LIST): INTEGER_32
		do
			Result := c_obstack_vprintf (a___obstack.c_pointer, a___format.c_pointer, a___args.c_pointer)
		end

	c_obstack_vprintf (a___obstack: POINTER; a___format: POINTER; a___args: POINTER): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return obstack_vprintf($a___obstack, $a___format, $a___args);"
		end

	vfprintf (a___s: CE_POINTER [SD_IO_FILE]; a___format: CE_POINTER [INTEGER_8]; a___arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vfprintf (a___s.c_pointer, a___format.c_pointer, a___arg.c_pointer)
		end

	c_vfprintf (a___s: POINTER; a___format: POINTER; a___arg: POINTER): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return vfprintf($a___s, $a___format, $a___arg);"
		end

	vsnprintf (a___s: CE_POINTER [INTEGER_8]; a___maxlen: NATURAL_32; a___format: CE_POINTER [INTEGER_8]; a___arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vsnprintf (a___s.c_pointer, a___maxlen, a___format.c_pointer, a___arg.c_pointer)
		end

	c_vsnprintf (a___s: POINTER; a___maxlen: NATURAL_32; a___format: POINTER; a___arg: POINTER): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return vsnprintf($a___s, $a___maxlen, $a___format, $a___arg);"
		end

	vsprintf (a___s, a___format: CE_POINTER [INTEGER_8]; a___arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vsprintf (a___s.c_pointer, a___format.c_pointer, a___arg.c_pointer)
		end

	c_vsprintf (a___s: POINTER; a___format: POINTER; a___arg: POINTER): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return vsprintf($a___s, $a___format, $a___arg);"
		end

	fscanf (a_args: TUPLE [a___stream: CE_POINTER [SD_IO_FILE]; a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fscanf)).integer_32_item (a_args)
		end

	c_fscanf: POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return (EIF_POINTER)&fscanf;"
		end

	fgetc (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fgetc (a___stream.c_pointer)
		end

	c_fgetc (a___stream: POINTER): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return fgetc($a___stream);"
		end

	sscanf (a_args: TUPLE [a___s, a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sscanf)).integer_32_item (a_args)
		end

	c_sscanf: POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return (EIF_POINTER)&sscanf;"
		end

feature {ANY} -- routine addresses

	ungetc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ungetc)
		end

	obstack_vprintf_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent obstack_vprintf)
		end

	vfprintf_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent vfprintf)
		end

	fscanf_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_shared (c_fscanf)
		end

	fgetc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent fgetc)
		end

end
