class
	S_STDLIB_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	abort
		external
			"C inline use <libgmp.h>"
		alias
			"abort();"
		ensure
			False
		end

	malloc (a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared_with_count (
					default_pointer.memory_alloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	realloc (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared_with_count (
					a_ptr.c_pointer.memory_realloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	free (a___ptr: CE_POINTER [ANY])
		do
			c_free (a___ptr.c_pointer)
		end

	c_free (a___ptr: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"free($a___ptr);"
		end

	strtol (a___nptr: CE_POINTER [INTEGER_8]; a___endptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a___base: INTEGER_32): INTEGER_32
		require
			not a___nptr.is_void
		do
			Result := c_strtol (a___nptr.c_pointer, a___endptr.c_pointer, a___base)
		end

	c_strtol (a___nptr: POINTER; a___endptr: POINTER; a___base: INTEGER_32): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return strtol($a___nptr, $a___endptr, $a___base);"
		end

end
