class
	P_AKIMA_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_MATH_STATIC

feature {ANY} -- public attributes

	akima_type: CE_STATIC [CE_ARRAY [PD_GSL_INTERP_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_INTERP_TYPE]}.make_initialized (<<
					create {PD_GSL_INTERP_TYPE}.make_initialized ([ce_string ("akima"), {NATURAL_32} 5, akima_alloc_address, akima_init_address, akima_eval_address, akima_eval_deriv_address, akima_eval_deriv2_address, akima_eval_integ_address, akima_free_address])
				>>)
		end

	gsl_interp_akima: CE_STATIC [CE_POINTER [PD_GSL_INTERP_TYPE]]
		once ("PROCESS")
			Result.item := akima_type.item
		end

	akima_periodic_type: CE_STATIC [CE_ARRAY [PD_GSL_INTERP_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_INTERP_TYPE]}.make_initialized (<<
					create {PD_GSL_INTERP_TYPE}.make_initialized ([ce_string ("akima-periodic"), {NATURAL_32} 5, akima_alloc_address, akima_init_periodic_address, akima_eval_address, akima_eval_deriv_address, akima_eval_deriv2_address, akima_eval_integ_address, akima_free_address])
				>>)
		end

	gsl_interp_akima_periodic: CE_STATIC [CE_POINTER [PD_GSL_INTERP_TYPE]]
		once ("PROCESS")
			Result.item := akima_periodic_type.item
		end

feature {ANY} -- public routines

	akima_alloc (a_size: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_AKIMA_STATE_T]
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_AKIMA_STATE_T]}.make_cast ((malloc ((create {PD_AKIMA_STATE_T}.make).structure_size.to_natural_32)))
			if l_state.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for state"), ce_string ("akima.c"), 46, 8)
					Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.b := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_size * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.b).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for b"), ce_string ("akima.c"), 54, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.c := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_size * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.c).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.b))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for c"), ce_string ("akima.c"), 63, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.d := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_size * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.d).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.c))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.b))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for d"), ce_string ("akima.c"), 73, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.m := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_size + {NATURAL_32} 4) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.m).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.d))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.c))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.b))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for _m"), ce_string ("akima.c"), 84, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := (create {CE_VOID_POINTER}.make_cast (l_state))
			end
		end

	akima_calc (a_x_array, a_b___0, a_c___1, a_d: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_m___4: CE_POINTER [REAL_64])
		local
			l_i: NATURAL_32
			l_NE: REAL_64
			l_tmp: REAL_64
			l_h_i: REAL_64
			l_NE_next: REAL_64
			l_tmp___1: REAL_64
			l_alpha_i: REAL_64
			l_alpha_ip1: REAL_64
			l_tL_ip1: REAL_64
		do
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size - {NATURAL_32} 1)
			loop
				l_tmp := fabs (a_m___4[(l_i + {NATURAL_32} 1).to_integer_32] - a_m___4[l_i.to_integer_32])
				l_NE := l_tmp + (fabs (a_m___4[(l_i - {NATURAL_32} 1).to_integer_32] - a_m___4[(l_i - {NATURAL_32} 2).to_integer_32]))
				if l_NE = 0.0 then
					a_b___0[l_i.to_integer_32] := a_m___4[l_i.to_integer_32]
					a_c___1[l_i.to_integer_32] := 0.0
					a_d[l_i.to_integer_32] := 0.0
				else
					l_h_i := (a_x_array[(l_i + {NATURAL_32} 1).to_integer_32] - a_x_array[l_i.to_integer_32])
					l_tmp___1 := fabs (a_m___4[(l_i + {NATURAL_32} 2).to_integer_32] - a_m___4[(l_i + {NATURAL_32} 1).to_integer_32])
					l_NE_next := l_tmp___1 + (fabs (a_m___4[l_i.to_integer_32] - a_m___4[(l_i - {NATURAL_32} 1).to_integer_32]))
					l_alpha_i := (fabs (a_m___4[(l_i - {NATURAL_32} 1).to_integer_32] - a_m___4[(l_i - {NATURAL_32} 2).to_integer_32])) / l_NE
					if l_NE_next = 0.0 then
						l_tL_ip1 := a_m___4[l_i.to_integer_32]
					else
						l_alpha_ip1 := (fabs (a_m___4[l_i.to_integer_32] - a_m___4[(l_i - {NATURAL_32} 1).to_integer_32])) / l_NE_next
						l_tL_ip1 := (1.0 - l_alpha_ip1) * a_m___4[l_i.to_integer_32] + l_alpha_ip1 * a_m___4[(l_i + {NATURAL_32} 1).to_integer_32]
					end
					a_b___0[l_i.to_integer_32] := (1.0 - l_alpha_i) * a_m___4[(l_i - {NATURAL_32} 1).to_integer_32] + l_alpha_i * a_m___4[l_i.to_integer_32]
					a_c___1[l_i.to_integer_32] := ((3.0 * a_m___4[l_i.to_integer_32] - 2.0 * a_b___0[l_i.to_integer_32]) - l_tL_ip1) / l_h_i
					a_d[l_i.to_integer_32] := ((a_b___0[l_i.to_integer_32] + l_tL_ip1) - 2.0 * a_m___4[l_i.to_integer_32]) / (l_h_i * l_h_i)
				end
				l_i := l_i + 1
			end
		end

	akima_init (a_vstate: CE_POINTER [ANY]; a_x_array, a_y_array: CE_POINTER [REAL_64]; a_size: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_AKIMA_STATE_T]
			l_m___4: CE_POINTER [REAL_64]
			l_i: NATURAL_32
		do
			l_state := create {CE_CLASS_POINTER [PD_AKIMA_STATE_T]}.make_cast (a_vstate)
			l_m___4 := l_state.item.m + 2
			l_i := (0).to_natural_32
			from
			until
				not (l_i <= a_size - {NATURAL_32} 2)
			loop
				l_m___4[l_i.to_integer_32] := ((a_y_array[(l_i + {NATURAL_32} 1).to_integer_32] - a_y_array[l_i.to_integer_32]) / (a_x_array[(l_i + {NATURAL_32} 1).to_integer_32] - a_x_array[l_i.to_integer_32]))
				l_i := l_i + 1
			end
			l_m___4[-2] := 3.0 * l_m___4[0] - 2.0 * l_m___4[1]
			l_m___4[-1] := 2.0 * l_m___4[0] - l_m___4[1]
			l_m___4[(a_size - {NATURAL_32} 1).to_integer_32] := 2.0 * l_m___4[(a_size - {NATURAL_32} 2).to_integer_32] - l_m___4[(a_size - {NATURAL_32} 3).to_integer_32]
			l_m___4[a_size.to_integer_32] := 3.0 * l_m___4[(a_size - {NATURAL_32} 2).to_integer_32] - 2.0 * l_m___4[(a_size - {NATURAL_32} 3).to_integer_32]
			akima_calc (a_x_array, l_state.item.b, l_state.item.c, l_state.item.d, a_size, l_m___4)
			Result := 0
		end

	akima_init_periodic (a_vstate: CE_POINTER [ANY]; a_x_array, a_y_array: CE_POINTER [REAL_64]; a_size: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_AKIMA_STATE_T]
			l_m___4: CE_POINTER [REAL_64]
			l_i: NATURAL_32
		do
			l_state := create {CE_CLASS_POINTER [PD_AKIMA_STATE_T]}.make_cast (a_vstate)
			l_m___4 := l_state.item.m + 2
			l_i := (0).to_natural_32
			from
			until
				not (l_i <= a_size - {NATURAL_32} 2)
			loop
				l_m___4[l_i.to_integer_32] := ((a_y_array[(l_i + {NATURAL_32} 1).to_integer_32] - a_y_array[l_i.to_integer_32]) / (a_x_array[(l_i + {NATURAL_32} 1).to_integer_32] - a_x_array[l_i.to_integer_32]))
				l_i := l_i + 1
			end
			l_m___4[-2] := l_m___4[((a_size - {NATURAL_32} 1) - {NATURAL_32} 2).to_integer_32]
			l_m___4[-1] := l_m___4[((a_size - {NATURAL_32} 1) - {NATURAL_32} 1).to_integer_32]
			l_m___4[(a_size - {NATURAL_32} 1).to_integer_32] := l_m___4[0]
			l_m___4[a_size.to_integer_32] := l_m___4[1]
			akima_calc (a_x_array, l_state.item.b, l_state.item.c, l_state.item.d, a_size, l_m___4)
			Result := 0
		end

	akima_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_AKIMA_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_AKIMA_STATE_T]}.make_cast (a_vstate)
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.b))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.c))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.d))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.m))
			free (create {CE_VOID_POINTER}.make_cast (l_state))
		end

	akima_eval (a_vstate: CE_POINTER [ANY]; a_x_array, a_y_array: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_x: REAL_64; a_a___5: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_y: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_x_array.is_void
			not a_y_array.is_void
			not a_y.is_void
		local
			l_state: CE_POINTER [PD_AKIMA_STATE_T]
			l_index: NATURAL_32
			l_x_lo: REAL_64
			l_delx: REAL_64
			l_b___0: REAL_64
			l_c___1: REAL_64
			l_d: REAL_64
		do
			l_state := create {CE_CLASS_POINTER [PD_AKIMA_STATE_T]}.make_cast (a_vstate)
			if not a_a___5.is_void then
				l_index := a_a___5.item.gsl_interp_accel_find (a_x_array, a_size, a_x)
			else
				l_index := (create {P_GSL_GSL_INTERP_STATIC}).gsl_interp_bsearch (a_x_array, a_x, (0).to_natural_32, a_size - {NATURAL_32} 1)
			end
			l_x_lo := a_x_array[l_index.to_integer_32]
			l_delx := a_x - l_x_lo
			l_b___0 := l_state.item.b[l_index.to_integer_32]
			l_c___1 := l_state.item.c[l_index.to_integer_32]
			l_d := l_state.item.d[l_index.to_integer_32]
			a_y.item := (a_y_array[l_index.to_integer_32] + (l_delx * (l_b___0 + l_delx * (l_c___1 + l_d * l_delx))))
			Result := 0
		end

	akima_eval_deriv (a_vstate: CE_POINTER [ANY]; a_x_array, a_y_array: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_x: REAL_64; a_a___5: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_dydx: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_x_array.is_void
			not a_dydx.is_void
		local
			l_state: CE_POINTER [PD_AKIMA_STATE_T]
			l_index: NATURAL_32
			l_tmp: INTEGER_32
			l_x_lo: REAL_64
			l_delx: REAL_64
			l_b___0: REAL_64
			l_c___1: REAL_64
			l_d: REAL_64
			l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_AKIMA_STATE_T]}.make_cast (a_vstate)
			from
			until
				(l_break)
			loop
				l_break := False
				if (not a_y_array.is_void) then
					l_tmp := 0
				else
					l_tmp := 0
				end
				if not l_tmp.to_boolean then
					l_break := True
				end
			end
			l_break := False
			if not a_a___5.is_void then
				l_index := a_a___5.item.gsl_interp_accel_find (a_x_array, a_size, a_x)
			else
				l_index := (create {P_GSL_GSL_INTERP_STATIC}).gsl_interp_bsearch (a_x_array, a_x, (0).to_natural_32, a_size - {NATURAL_32} 1)
			end
			l_x_lo := a_x_array[l_index.to_integer_32]
			l_delx := a_x - l_x_lo
			l_b___0 := l_state.item.b[l_index.to_integer_32]
			l_c___1 := l_state.item.c[l_index.to_integer_32]
			l_d := l_state.item.d[l_index.to_integer_32]
			a_dydx.item := l_b___0 + l_delx * (2.0 * l_c___1 + (3.0 * l_d) * l_delx)
			Result := 0
		end

	akima_eval_deriv2 (a_vstate: CE_POINTER [ANY]; a_x_array, a_y_array: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_x: REAL_64; a_a___5: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_y_pp: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_x_array.is_void
			not a_y_pp.is_void
		local
			l_state: CE_POINTER [PD_AKIMA_STATE_T]
			l_index: NATURAL_32
			l_tmp: INTEGER_32
			l_x_lo: REAL_64
			l_delx: REAL_64
			l_c___1: REAL_64
			l_d: REAL_64
			l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_AKIMA_STATE_T]}.make_cast (a_vstate)
			from
			until
				(l_break)
			loop
				l_break := False
				if (not a_y_array.is_void) then
					l_tmp := 0
				else
					l_tmp := 0
				end
				if not l_tmp.to_boolean then
					l_break := True
				end
			end
			l_break := False
			if not a_a___5.is_void then
				l_index := a_a___5.item.gsl_interp_accel_find (a_x_array, a_size, a_x)
			else
				l_index := (create {P_GSL_GSL_INTERP_STATIC}).gsl_interp_bsearch (a_x_array, a_x, (0).to_natural_32, a_size - {NATURAL_32} 1)
			end
			l_x_lo := a_x_array[l_index.to_integer_32]
			l_delx := a_x - l_x_lo
			l_c___1 := l_state.item.c[l_index.to_integer_32]
			l_d := l_state.item.d[l_index.to_integer_32]
			a_y_pp.item := 2.0 * l_c___1 + (6.0 * l_d) * l_delx
			Result := 0
		end

	akima_eval_integ (a_vstate: CE_POINTER [ANY]; a_x_array, a_y_array: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_acc: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_a___5, a_b___0: REAL_64; a_result: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_result.is_void
		local
			l_state: CE_POINTER [PD_AKIMA_STATE_T]
			l_i: NATURAL_32
			l_index_a: NATURAL_32
			l_index_b: NATURAL_32
			l_x_hi: REAL_64
			l_x_lo: REAL_64
			l_y_lo: REAL_64
			l_dx: REAL_64
			l_x1___0: REAL_64
			l_tmp: REAL_64
			l_x2___1: REAL_64
			l_tmp___0: REAL_64
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state := create {CE_CLASS_POINTER [PD_AKIMA_STATE_T]}.make_cast (a_vstate)
					if not a_acc.is_void then
						l_index_a := a_acc.item.gsl_interp_accel_find (a_x_array, a_size, a_a___5)
						l_index_b := a_acc.item.gsl_interp_accel_find (a_x_array, a_size, a_b___0)
					else
						l_index_a := (create {P_GSL_GSL_INTERP_STATIC}).gsl_interp_bsearch (a_x_array, a_a___5, (0).to_natural_32, a_size - {NATURAL_32} 1)
						l_index_b := (create {P_GSL_GSL_INTERP_STATIC}).gsl_interp_bsearch (a_x_array, a_b___0, (0).to_natural_32, a_size - {NATURAL_32} 1)
					end
					a_result.item := 0.0
					l_i := l_index_a
				when 1 then -- loop condition:
					if not (not (l_return) and then (l_i <= l_index_b)) then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						l_x_hi := a_x_array[(l_i + {NATURAL_32} 1).to_integer_32]
						l_x_lo := a_x_array[l_i.to_integer_32]
						l_y_lo := a_y_array[l_i.to_integer_32]
						l_dx := l_x_hi - l_x_lo
						if l_dx = 0.0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if l_i /= l_index_a then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if l_i /= l_index_b then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						if l_i = l_index_a then
							l_tmp := a_a___5
						else
							l_tmp := l_x_lo
						end
						l_x1___0 := l_tmp
						if l_i = l_index_b then
							l_tmp___0 := a_b___0
						else
							l_tmp___0 := l_x_hi
						end
						l_x2___1 := l_tmp___0
						a_result.item := a_result.item + ((create {P_INTEG_EVAL_STATIC}).integ_eval (l_y_lo, l_state.item.b[l_i.to_integer_32], l_state.item.c[l_i.to_integer_32], l_state.item.d[l_i.to_integer_32], l_x_lo, l_x1___0, l_x2___1))
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						a_result.item := a_result.item + (l_dx * (l_y_lo + l_dx * (0.5 * l_state.item.b[l_i.to_integer_32] + l_dx * (l_state.item.c[l_i.to_integer_32] / 3.0 + (0.25 * l_state.item.d[l_i.to_integer_32]) * l_dx))))
				when 10 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						a_result.item := 0.0
						Result := (-1)
						l_return := True
				when 12 then
						if not l_return then
							l_i := l_i + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					if not l_return then
						Result := 0
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	akima_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent akima_alloc)
		end

	akima_init_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent akima_init)
		end

	akima_init_periodic_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent akima_init_periodic)
		end

	akima_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent akima_free)
		end

	akima_eval_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent akima_eval)
		end

	akima_eval_deriv_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent akima_eval_deriv)
		end

	akima_eval_deriv2_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent akima_eval_deriv2)
		end

	akima_eval_integ_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent akima_eval_integ)
		end

end
