class
	P_BESSEL_I_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_sf_bessel_il_scaled_array (a_lmax: INTEGER_32; a_x: REAL_64; a_result_array: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_result_array.is_void
		local
			l_ell: INTEGER_32
			l_ell___0: INTEGER_32
			l_r_iellp1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_iell: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_0: INTEGER_32
			l_stat_1: INTEGER_32
			l_iellp1: REAL_64
			l_iell: REAL_64
			l_iellm1: REAL_64
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_r_iellp1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_r_iell.make (<<1>>)

			if a_x = 0.0 then
				a_result_array[0] := 1.0
				l_ell := a_lmax
				from
				until
					not (l_ell >= 1)
				loop
					a_result_array[l_ell] := 0.0
					l_ell := l_ell - 1
				end
				Result := 0
			else
				l_stat_0 := (l_r_iellp1.item.gsl_sf_bessel_il_scaled_e (a_lmax + 1, a_x))
				l_stat_1 := (l_r_iell.item.gsl_sf_bessel_il_scaled_e (a_lmax, a_x))
				l_iellp1 := l_r_iellp1.item.val
				l_iell := l_r_iell.item.val
				a_result_array[a_lmax] := l_iell
				l_ell___0 := a_lmax
				from
				until
					not (l_ell___0 >= 1)
				loop
					l_iellm1 := l_iellp1 + ((2 * l_ell___0 + 1).to_double / a_x) * l_iell
					l_iellp1 := l_iell
					l_iell := l_iellm1
					a_result_array[(l_ell___0 - 1)] := l_iellm1
					l_ell___0 := l_ell___0 - 1
				end
				if l_stat_0 /= 0 then
					l_tmp___2 := l_stat_0
				else
					if l_stat_1 /= 0 then
						l_tmp___1 := l_stat_1
					else
						l_tmp___1 := 0
					end
					l_tmp___2 := l_tmp___1
				end
				Result := l_tmp___2
			end
		end

	gsl_sf_bessel_i0_scaled (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_bessel_i0_scaled_e (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_bessel_i0_scaled_e(x, &result)"), ce_string ("bessel_i.c"), 312, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_bessel_i1_scaled (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_bessel_i1_scaled_e (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_bessel_i1_scaled_e(x, &result)"), ce_string ("bessel_i.c"), 317, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_bessel_i2_scaled (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_bessel_i2_scaled_e (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_bessel_i2_scaled_e(x, &result)"), ce_string ("bessel_i.c"), 322, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_bessel_il_scaled (a_l: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_bessel_il_scaled_e (a_l, a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_bessel_il_scaled_e(l, x, &result)"), ce_string ("bessel_i.c"), 327, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

end
