class
	P_BESSEL_JN_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_sf_bessel_Jn_array (a_nmin, a_nmax: INTEGER_32; a_x: REAL_64; a_result_array: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_n: INTEGER_32
			l_n___0: INTEGER_32
			l_r_Jnp1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_Jn: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_np1: INTEGER_32
			l_stat_n: INTEGER_32
			l_stat: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_Jnp1: REAL_64
			l_Jn: REAL_64
			l_Jnm1: REAL_64
			l_n___1: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_r_Jnp1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_r_Jn.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_nmin < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_nmax < a_nmin) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_n := a_nmax
						from
						until
							not (l_n >= a_nmin)
						loop
							a_result_array[(l_n - a_nmin)] := 0.0
							l_n := l_n - 1
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("domain error"), ce_string ("bessel_Jn.c"), 152, 1)
							Result := 1
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_x = 0.0 then
							l_n___0 := a_nmax
							from
							until
								not (l_n___0 >= a_nmin)
							loop
								a_result_array[(l_n___0 - a_nmin)] := 0.0
								l_n___0 := l_n___0 - 1
							end
							if a_nmin = 0 then
								a_result_array[0] := 1.0
							end
							Result := 0
							l_return := True
						else
							l_stat_np1 := (l_r_Jnp1.item.gsl_sf_bessel_Jn_e (a_nmax + 1, a_x))
							l_stat_n := (l_r_Jn.item.gsl_sf_bessel_Jn_e (a_nmax, a_x))
							if l_stat_np1 /= 0 then
								l_tmp___2 := l_stat_np1
							else
								if l_stat_n /= 0 then
									l_tmp___1 := l_stat_n
								else
									l_tmp___1 := 0
								end
								l_tmp___2 := l_tmp___1
							end
							l_stat := l_tmp___2
							l_Jnp1 := l_r_Jnp1.item.val
							l_Jn := l_r_Jn.item.val
							if l_stat = 0 then
								l_n___1 := a_nmax
								from
								until
									not (l_n___1 >= a_nmin)
								loop
									a_result_array[(l_n___1 - a_nmin)] := l_Jn
									l_Jnm1 := -l_Jnp1 + ((2.0 * l_n___1.to_double) / a_x) * l_Jn
									l_Jnp1 := l_Jn
									l_Jn := l_Jnm1
									l_n___1 := l_n___1 - 1
								end
							else
								l_n___1 := a_nmax
								from
								until
									not (l_n___1 >= a_nmin)
								loop
									a_result_array[(l_n___1 - a_nmin)] := 0.0
									l_n___1 := l_n___1 - 1
								end
							end
							Result := l_stat
							l_return := True
						end
				when 7 then -- if done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_bessel_Jn (a_n: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_bessel_Jn_e (a_n, a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_bessel_Jn_e(n, x, &result)"), ce_string ("bessel_Jn.c"), 198, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

end
