class
	P_BESSEL_YN_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_sf_bessel_Yn_array (a_nmin, a_nmax: INTEGER_32; a_x: REAL_64; a_result_array: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_j: INTEGER_32
			l_r_Ynm1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_Yn: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_nm1: INTEGER_32
			l_stat_n: INTEGER_32
			l_Ynp1: REAL_64
			l_Yn: REAL_64
			l_Ynm1: REAL_64
			l_n: INTEGER_32
			l_stat: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_r_Ynm1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_r_Yn.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_nmin < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if not (a_nmax < a_nmin) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (a_x <= 0.0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						l_j := 0
						from
						until
							not (l_j <= a_nmax - a_nmin)
						loop
							a_result_array[l_j] := 0.0
							l_j := l_j + 1
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("error"), ce_string ("bessel_Yn.c"), 176, 1)
							Result := 1
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_stat_nm1 := (l_r_Ynm1.item.gsl_sf_bessel_Yn_e (a_nmin, a_x))
						l_stat_n := (l_r_Yn.item.gsl_sf_bessel_Yn_e (a_nmin + 1, a_x))
						l_Yn := l_r_Yn.item.val
						l_Ynm1 := l_r_Ynm1.item.val
						if l_stat_nm1 /= 0 then
							l_tmp___2 := l_stat_nm1
						else
							if l_stat_n /= 0 then
								l_tmp___1 := l_stat_n
							else
								l_tmp___1 := 0
							end
							l_tmp___2 := l_tmp___1
						end
						l_stat := l_tmp___2
						if l_stat = 0 then
							l_n := a_nmin + 1
							from
							until
								not (l_n <= a_nmax + 1)
							loop
								a_result_array[((l_n - a_nmin) - 1)] := l_Ynm1
								l_Ynp1 := -l_Ynm1 + ((2.0 * l_n.to_double) / a_x) * l_Yn
								l_Ynm1 := l_Yn
								l_Yn := l_Ynp1
								l_n := l_n + 1
							end
						else
							l_n := a_nmin
							from
							until
								not (l_n <= a_nmax)
							loop
								a_result_array[(l_n - a_nmin)] := 0.0
								l_n := l_n + 1
							end
						end
						Result := l_stat
						l_return := True
				when 10 then -- if done | if done
					if not l_return then
						Result := 0
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_bessel_Yn (a_n: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_bessel_Yn_e (a_n, a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_bessel_Yn_e(n, x, &result)"), ce_string ("bessel_Yn.c"), 215, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

end
