class
	P_BETAINV_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	bisect (a_x, a_P___2, a_a___5, a_b___0, a_xtol, a_Ptol: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_x0: REAL_64
			l_x1___0: REAL_64
			l_Px: REAL_64
			l_return, l_break: BOOLEAN
		do
			l_x := a_x
			l_x0 := (0).to_double
			l_x1___0 := (1).to_double
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if not ((fabs (l_x1___0 - l_x0)) > a_xtol) then
					l_break := True
				end
				if not (l_return or l_break) then
					l_Px := (create {P_BETA_STATIC}).gsl_cdf_beta_P (l_x, a_a___5, a_b___0)
					if (fabs (l_Px - a_P___2)) < a_Ptol then
						Result := l_x
						l_return := True
					elseif l_Px < a_P___2 then
						l_x0 := l_x
					elseif l_Px > a_P___2 then
						l_x1___0 := l_x
					end
					if not l_return then
						l_x := 0.5 * (l_x0 + l_x1___0)
					end
				end
			end
			if not l_return then
				l_break := False
				Result := l_x
			end
		end

	gsl_cdf_beta_Pinv (a_P___2, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_mean: REAL_64
			l_lg_ab: REAL_64
			l_lg_a: REAL_64
			l_lg_b: REAL_64
			l_lx: REAL_64
			l_tmp___6: REAL_64
			l_lambda: REAL_64
			l_dP: REAL_64
			l_phi: REAL_64
			l_n: NATURAL_32
			l_tmp___10: NATURAL_32
			l_tmp___13: REAL_64
			l_step0: REAL_64
			l_step1: REAL_64
			l_step: REAL_64
			l_tmp___16: REAL_64
			l_tmp___18: REAL_64
			l_tmp___19: REAL_64
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_P___2 < 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_P___2 > 1.0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("P must be in range 0 < P < 1"), ce_string ("betainv.c"), 77, 1)
							Result := (builtin_nanf (ce_string (""))).to_double
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if done
					if not l_return and then (a_a___5 < 0.0) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("a < 0"), ce_string ("betainv.c"), 82, 1)
							Result := (builtin_nanf (ce_string (""))).to_double
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return and then (a_b___0 < 0.0) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("b < 0"), ce_string ("betainv.c"), 87, 1)
							Result := (builtin_nanf (ce_string (""))).to_double
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return and then (a_P___2 = 0.0) then
						Result := (0.0)
						l_return := True
					end
					if not l_return and then (a_P___2 = 1.0) then
						Result := (1.0)
						l_return := True
					end
					if not l_return and then (a_P___2 > 0.5) then
						Result := (gsl_cdf_beta_Qinv ((1).to_double - a_P___2, a_a___5, a_b___0))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 6 then -- if:
						l_mean := a_a___5 / (a_a___5 + a_b___0)
						if a_P___2 < 0.1 then
							l_lg_ab := ((create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_a___5 + a_b___0))
							l_lg_a := ((create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_a___5))
							l_lg_b := ((create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_b___0))
							l_tmp___6 := log (a_a___5)
							l_lx := ((((l_tmp___6 + l_lg_a) + l_lg_b) - l_lg_ab) + (log (a_P___2))) / a_a___5
							if l_lx <= (0).to_double then
								l_x := exp (l_lx)
								l_x := l_x * (pow ((1).to_double - l_x, -(a_b___0 - (1).to_double) / a_a___5))
							else
								l_x := l_mean
							end
							if l_x > l_mean then
								l_x := l_mean
							end
						else
							l_x := l_mean
						end
						l_x := bisect (l_x, a_P___2, a_a___5, a_b___0, 0.01, 0.01)
						l_n := {NATURAL_32} 0
				when 7 then -- start:
						l_dP := a_P___2 - ((create {P_BETA_STATIC}).gsl_cdf_beta_P (l_x, a_a___5, a_b___0))
						l_phi := (create {P_BETA_STATIC}).gsl_ran_beta_pdf (l_x, a_a___5, a_b___0)
						if l_dP = 0.0 then
							l_pos := -1 + 9 -- goto end
						else
							l_tmp___10 := l_n
							l_n := l_n + 1
							if l_tmp___10 > {NATURAL_32} 64 then
								l_pos := -1 + 9 -- goto end
							end
						end
				when 8 then
						if (2).to_double * (fabs (l_dP / l_x)) > l_phi then
							l_tmp___13 := (2).to_double * (fabs (l_dP / l_x))
						else
							l_tmp___13 := l_phi
						end
						l_lambda := l_dP / l_tmp___13
						l_step0 := l_lambda
						l_step1 := ((-((a_a___5 - (1).to_double) / l_x - (a_b___0 - (1).to_double) / ((1).to_double - l_x)) * l_lambda) * l_lambda) / (2).to_double
						l_step := l_step0
						l_tmp___16 := fabs (l_step1)
						if l_tmp___16 < (fabs (l_step0)) then
							l_step := l_step + l_step1
						else
							l_step := l_step * ((2).to_double * (fabs (l_step0 / l_step1)))
						end
						if l_x + l_step > (0).to_double then
							if l_x + l_step < (1).to_double then
								l_x := l_x + l_step
							else
								l_tmp___18 := sqrt (l_x)
								l_tmp___19 := sqrt (l_mean)
								l_x := l_tmp___18 * l_tmp___19
							end
						else
							l_tmp___18 := sqrt (l_x)
							l_tmp___19 := sqrt (l_mean)
							l_x := l_tmp___18 * l_tmp___19
						end
						if (fabs (l_step0)) > 1.e-10 * l_x then
							l_pos := -1 + 7 -- goto start
						end
				when 9 then -- end:
						if (fabs (l_dP)) > 1.4901161193847656e-08 * a_P___2 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("inverse failed to converge"), ce_string ("betainv.c"), 181, 5)
								Result := (builtin_nanf (ce_string (""))).to_double
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
				when 10 then -- if done
					if not l_return then
						Result := l_x
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_cdf_beta_Qinv (a_Q___1, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_Q___1 < 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_Q___1 > 1.0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("Q must be inside range 0 < Q < 1"), ce_string ("betainv.c"), 194, 1)
							Result := (builtin_nanf (ce_string (""))).to_double
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if done
					if not l_return and then (a_a___5 < 0.0) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("a < 0"), ce_string ("betainv.c"), 199, 1)
							Result := (builtin_nanf (ce_string (""))).to_double
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return and then (a_b___0 < 0.0) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("b < 0"), ce_string ("betainv.c"), 204, 1)
							Result := (builtin_nanf (ce_string (""))).to_double
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return and then (a_Q___1 = 0.0) then
						Result := (1.0)
						l_return := True
					end
					if not l_return and then (a_Q___1 = 1.0) then
						Result := (0.0)
						l_return := True
					end
					if not l_return then
						if a_Q___1 > 0.5 then
							Result := (gsl_cdf_beta_Pinv ((1).to_double - a_Q___1, a_a___5, a_b___0))
						else
							Result := ((1).to_double - (gsl_cdf_beta_Pinv (a_Q___1, a_b___0, a_a___5)))
						end
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
