class
	P_BLAS_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_blas_srotg (a_a___5, a_b___0, a_c___1, a_s: CE_POINTER [REAL_32]): INTEGER_32
		do
			(create {P_SROTG_STATIC}).cblas_srotg (a_a___5, a_b___0, a_c___1, a_s)
			Result := 0
		end

	gsl_blas_drotg (a_a___5, a_b___0, a_c___1, a_s: CE_POINTER [REAL_64]): INTEGER_32
		do
			(create {P_DROTG_STATIC}).cblas_drotg (a_a___5, a_b___0, a_c___1, a_s)
			Result := 0
		end

	gsl_blas_srotmg (a_d1, a_d2, a_b1___0: CE_POINTER [REAL_32]; a_b2: REAL_32; a_P___2: CE_POINTER [REAL_32]): INTEGER_32
		do
			(create {P_SROTMG_STATIC}).cblas_srotmg (a_d1, a_d2, a_b1___0, a_b2, a_P___2)
			Result := 0
		end

	gsl_blas_drotmg (a_d1, a_d2, a_b1___0: CE_POINTER [REAL_64]; a_b2: REAL_64; a_P___2: CE_POINTER [REAL_64]): INTEGER_32
		do
			(create {P_DROTMG_STATIC}).cblas_drotmg (a_d1, a_d2, a_b1___0, a_b2, a_P___2)
			Result := 0
		end

	gsl_blas_cher (a_Uplo: NATURAL_32; a_alpha: REAL_32; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_A___0.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 1_120, 20)
					Result := 20
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_X.item.size /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1_124, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				(create {P_CHER_STATIC}).cblas_cher ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_M.to_integer_32, a_alpha, create {CE_VOID_POINTER}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_VOID_POINTER}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_zher (a_Uplo: NATURAL_32; a_alpha: REAL_64; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		require
			not a_A___0.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 1_142, 20)
					Result := 20
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_X.item.size /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1_146, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				(create {P_ZHER_STATIC}).cblas_zher ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, a_alpha, create {CE_VOID_POINTER}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_VOID_POINTER}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_cher2 (a_Uplo: NATURAL_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_X, a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_A___0.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 1_168, 20)
							Result := 20
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if a_X.item.size = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if a_Y.item.size = l_N then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1_172, 19)
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 8 then -- if done | if done
					if not l_return then
						(create {P_CHER2_STATIC}).cblas_cher2 ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_VOID_POINTER}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32, create {CE_VOID_POINTER}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32)
						Result := 0
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_ssyr (a_Uplo: NATURAL_32; a_alpha: REAL_32; a_X: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_A___0: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		require
			not a_A___0.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 1_217, 20)
					Result := 20
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_X.item.size /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1_221, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				(create {P_SSYR_STATIC}).cblas_ssyr ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, a_alpha, a_X.item.data, (a_X.item.stride).to_integer_32, a_A___0.item.data, (a_A___0.item.tda).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_dsyr (a_Uplo: NATURAL_32; a_alpha: REAL_64; a_X: CE_POINTER [PD_GSL_VECTOR]; a_A___0: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		require
			not a_A___0.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 1_239, 20)
					Result := 20
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_X.item.size /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1_243, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				(create {P_DSYR_STATIC}).cblas_dsyr ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, a_alpha, a_X.item.data, (a_X.item.stride).to_integer_32, a_A___0.item.data, (a_A___0.item.tda).to_integer_32)
				Result := 0
			end
		end

	gsl_blas_ssyr2 (a_Uplo: NATURAL_32; a_alpha: REAL_32; a_X, a_Y: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_A___0: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		require
			not a_A___0.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 1_263, 20)
							Result := 20
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if a_X.item.size = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if a_Y.item.size = l_N then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1_267, 19)
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 8 then -- if done | if done
					if not l_return then
						(create {P_SSYR2_STATIC}).cblas_ssyr2 ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, a_alpha, a_X.item.data, (a_X.item.stride).to_integer_32, a_Y.item.data, (a_Y.item.stride).to_integer_32, a_A___0.item.data, (a_A___0.item.tda).to_integer_32)
						Result := 0
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
