class
	P_DD_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_poly_dd_init (a_dd, a_xa, a_ya: CE_POINTER [REAL_64]; a_size: NATURAL_32): INTEGER_32
		require
			not a_dd.is_void
			not a_ya.is_void
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_return: BOOLEAN
		do
			a_dd[0] := a_ya[0]
			l_j := a_size - {NATURAL_32} 1
			from
			until
				not (l_j >= {NATURAL_32} 1)
			loop
				a_dd[l_j.to_integer_32] := ((a_ya[l_j.to_integer_32] - a_ya[(l_j - {NATURAL_32} 1).to_integer_32]) / (a_xa[l_j.to_integer_32] - a_xa[(l_j - {NATURAL_32} 1).to_integer_32]))
				l_j := l_j - 1
			end
			l_i := (2).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_size))
			loop
				l_j := a_size - {NATURAL_32} 1
				from
				until
					not (l_j >= l_i)
				loop
					a_dd[l_j.to_integer_32] := (a_dd[l_j.to_integer_32] - a_dd[(l_j - {NATURAL_32} 1).to_integer_32]) / (a_xa[l_j.to_integer_32] - a_xa[(l_j - l_i).to_integer_32])
					l_j := l_j - 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_poly_dd_taylor (a_c___1: CE_POINTER [REAL_64]; a_xp: REAL_64; a_dd, a_xa: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_w: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_c___1.is_void
			not a_dd.is_void
			not a_w.is_void
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				a_c___1[l_i.to_integer_32] := 0.0
				a_w[l_i.to_integer_32] := 0.0
				l_i := l_i + 1
			end
			a_w[(a_size - {NATURAL_32} 1).to_integer_32] := 1.0
			a_c___1[0] := a_dd[0]
			l_i := a_size - {NATURAL_32} 1
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_tmp := l_i
				l_i := l_i - 1
				if not (l_tmp > {NATURAL_32} 0) then
					l_break := True
				end
				if not (l_return or l_break) then
					a_w[l_i.to_integer_32] := -a_w[(l_i + {NATURAL_32} 1).to_integer_32] * (a_xa[((a_size - {NATURAL_32} 2) - l_i).to_integer_32] - a_xp)
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (l_j < a_size - {NATURAL_32} 1)
					loop
						a_w[l_j.to_integer_32] := a_w[l_j.to_integer_32] - (a_w[(l_j + {NATURAL_32} 1).to_integer_32] * (a_xa[((a_size - {NATURAL_32} 2) - l_i).to_integer_32] - a_xp))
						l_j := l_j + 1
					end
					l_j := l_i
					from
					until
						not (l_j < a_size)
					loop
						a_c___1[(l_j - l_i).to_integer_32] := a_c___1[(l_j - l_i).to_integer_32] + (a_w[l_j.to_integer_32] * a_dd[((a_size - l_i) - {NATURAL_32} 1).to_integer_32])
						l_j := l_j + 1
					end
				end
			end
			l_break := False
			Result := 0
		end

end
