class
	P_DEFAULT_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC
	S_STDIO_STATIC

feature {ANY} -- public routines

	gsl_rng_env_setup: CE_POINTER [PD_GSL_RNG_TYPE]
		local
			l_seed: NATURAL_32
			l_p: CE_POINTER [INTEGER_8]
			l_t: CE_POINTER [CE_POINTER [PD_GSL_RNG_TYPE]]
			l_t0: CE_POINTER [CE_POINTER [PD_GSL_RNG_TYPE]]
			l_i: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_seed := {NATURAL_32} 0
			l_p := (getenv (ce_string ("GSL_RNG_TYPE")))
			if (not l_p.is_void) then
				l_t0 := ((create {P_TYPES_STATIC}).gsl_rng_types_setup);
				(create {P_MT_STATIC}).gsl_rng_default.item := create {CE_CLASS_POINTER [PD_GSL_RNG_TYPE]}.make_shared (default_pointer)
				l_t := l_t0
				from
				until
					not (not (l_break) and then (not (l_t.item).is_void))
				loop
					l_break := False
					if (strcmp (l_p, (l_t.item).item.name)) = 0 then
						(create {P_MT_STATIC}).gsl_rng_default.item := l_t.item
						l_break := True
					end
					if not (l_break) then
						l_t := l_t + 1
					end
				end
				l_break := False
				if ((create {P_MT_STATIC}).gsl_rng_default.item).is_void then
					l_i := 0
					Io.error.put_string ("GSL_RNG_TYPE=" + eif_string (l_p) + " not recognized%N")
					Io.error.put_string ("Valid generator types are:%N")
					l_t := l_t0
					from
					until
						(l_t.item).is_void
					loop
						fprintf ([(create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), ce_string (" %%18s"), (l_t.item).item.name]).do_nothing
						l_i := l_i + 1
						if l_i \\ 4 = 0 then
							fputc (('%N').code, (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))).do_nothing
						end
						l_t := l_t + 1
					end
					fputc (('%N').code, (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))).do_nothing
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("unknown generator"), ce_string ("default.c"), 72, 4)
						Result := (create {CE_CLASS_POINTER [PD_GSL_RNG_TYPE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
				if not l_return then
					Io.error.put_string ("GSL_RNG_TYPE=" + eif_string ((create {P_MT_STATIC}).gsl_rng_default.item.item.name) + "%N")
				end
			else
				(create {P_MT_STATIC}).gsl_rng_default.item := (create {P_MT_STATIC}).gsl_rng_mt19937.item
			end
			if not l_return then
				l_p := (getenv (ce_string ("GSL_RNG_SEED")))
				if (not l_p.is_void) then
					l_seed := strtoul (l_p, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 0)
					fprintf ([(create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), ce_string ("GSL_RNG_SEED=%%lu%N"), l_seed]).do_nothing
				end
				(create {P_MT_STATIC}).gsl_rng_default_seed.item := l_seed
				Result := ((create {P_MT_STATIC}).gsl_rng_default.item)
			end
		end

end
