class
	P_ERROR_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public attributes

	gsl_error_handler: CE_STATIC [CE_ROUTINE]
		once ("PROCESS")
			Result.item := create {CE_ROUTINE}.make_shared (default_pointer)
		end

feature {ANY} -- public routines

	gsl_error (a_reason, a_file: CE_POINTER [INTEGER_8]; a_line, a_gsl_errno: INTEGER_32)
		local
			l_return: BOOLEAN
		do
			if (not gsl_error_handler.item.is_void) then
				gsl_error_handler.item.call ([a_reason, a_file, a_line, a_gsl_errno])
				l_return := True
			end
			if not l_return then
				(create {P_STREAM_STATIC}).gsl_stream_printf (ce_string ("ERROR"), a_file, a_line, a_reason)
				Io.standard_default.flush
				Io.error.put_string ("Default GSL error handler invoked.%N")
				Io.error.flush
				abort
			end
		end

	gsl_set_error_handler (a_new_handler: CE_ROUTINE): CE_ROUTINE
		local
			l_previous_handler: CE_ROUTINE
		do
			l_previous_handler := gsl_error_handler.item
			gsl_error_handler.item := a_new_handler
			Result := l_previous_handler
		end

	gsl_set_error_handler_off: CE_ROUTINE
		local
			l_previous_handler: CE_ROUTINE
		do
			l_previous_handler := gsl_error_handler.item
			gsl_error_handler.item := no_error_handler_address
			Result := l_previous_handler
		end

	no_error_handler (a_reason, a_file: CE_POINTER [INTEGER_8]; a_line, a_gsl_errno: INTEGER_32)
		local
			l_reason: CE_POINTER [INTEGER_8]
			l_file: CE_POINTER [INTEGER_8]
			l_line: INTEGER_32
			l_gsl_errno: INTEGER_32
		do
			l_reason := a_reason
			l_file := a_file
			l_line := a_line
			l_gsl_errno := a_gsl_errno
			l_reason := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_file := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_line := 0
			l_gsl_errno := 0
		end

feature {ANY} -- routine addresses

	no_error_handler_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent no_error_handler)
		end

end
