class
	P_FDFSOLVER_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_multifit_fdfsolver_alloc (a_T: CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER_TYPE]; a_n, a_p: NATURAL_32): CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]
		local
			l_status: INTEGER_32
			l_s: CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]
			l_return, l_break: BOOLEAN
		do
			if a_n < a_p then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("insufficient data points, n < p"), ce_string ("fdfsolver.c"), 36, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s := create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_cast ((malloc ((create {PD_GSL_MULTIFIT_FDFSOLVER}.make).structure_size.to_natural_32)))
				if l_s.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for multifit solver struct"), ce_string ("fdfsolver.c"), 44, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.x := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_p)
				if (l_s.item.x).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for x"), ce_string ("fdfsolver.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.f := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_s.item.f).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for f"), ce_string ("fdfsolver.c"), 61, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.J := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_calloc (a_n, a_p)
				if (l_s.item.J).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.f)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for g"), ce_string ("fdfsolver.c"), 71, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.dx := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_p)
				if (l_s.item.dx).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_s.item.J);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.f)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for dx"), ce_string ("fdfsolver.c"), 82, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.state := malloc (a_T.item.size)
				if (l_s.item.state).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.dx);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.f);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_s.item.J)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for multifit solver state"), ce_string ("fdfsolver.c"), 96, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.type := a_T
				l_status := ((l_s.item.type).item.alloc).integer_32_item ([l_s.item.state, a_n, a_p])
				if l_status /= 0 then
					free (l_s.item.state);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.dx);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.f);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_s.item.J)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to set solver"), ce_string ("fdfsolver.c"), 112, l_status)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FDFSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.fdf := create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT]}.make_shared (default_pointer)
				Result := l_s
			end
		end

	gsl_multifit_fdfsolver_free (a_s: CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER])
		local
			l_return: BOOLEAN
		do
			if a_s.is_void then
				l_return := True
			end
			if not l_return then
				((a_s.item.type).item.free).call ([a_s.item.state])
				free (a_s.item.state);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_s.item.dx);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_s.item.x);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_s.item.f);
				(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (a_s.item.J)
				free (create {CE_VOID_POINTER}.make_cast (a_s))
			end
		end

	gsl_multiroot_fdfsolver_alloc (a_T: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]; a_n: NATURAL_32): CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]
		local
			l_status: INTEGER_32
			l_s: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]
			l_return, l_break: BOOLEAN
		do
			l_s := create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]}.make_cast ((malloc ((create {PD_GSL_MULTIROOT_FDFSOLVER}.make).structure_size.to_natural_32)))
			if l_s.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for multiroot solver struct"), ce_string ("fdfsolver.c"), 39, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s.item.x := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_s.item.x).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for x"), ce_string ("fdfsolver.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.f := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_s.item.f).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for f"), ce_string ("fdfsolver.c"), 56, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.J := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_calloc (a_n, a_n)
				if (l_s.item.J).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.f)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for g"), ce_string ("fdfsolver.c"), 66, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.dx := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_s.item.dx).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_s.item.J);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.f)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for dx"), ce_string ("fdfsolver.c"), 77, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.state := malloc (a_T.item.size)
				if (l_s.item.state).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.dx);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.f);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_s.item.J)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for multiroot solver state"), ce_string ("fdfsolver.c"), 91, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.type := a_T
				l_status := ((l_s.item.type).item.alloc).integer_32_item ([l_s.item.state, a_n])
				if l_status /= 0 then
					free (l_s.item.state);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.dx);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.f);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_s.item.J)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to set solver"), ce_string ("fdfsolver.c"), 107, l_status)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FDFSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.fdf := create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]}.make_shared (default_pointer)
				Result := l_s
			end
		end

	gsl_multiroot_fdfsolver_free (a_s: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER])
		local
			l_return: BOOLEAN
		do
			if a_s.is_void then
				l_return := True
			end
			if not l_return then
				((a_s.item.type).item.free).call ([a_s.item.state])
				free (a_s.item.state);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_s.item.dx);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_s.item.x);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_s.item.f);
				(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (a_s.item.J)
				free (create {CE_VOID_POINTER}.make_cast (a_s))
			end
		end

	gsl_root_fdfsolver_alloc (a_T: CE_POINTER [PD_GSL_ROOT_FDFSOLVER_TYPE]): CE_POINTER [PD_GSL_ROOT_FDFSOLVER]
		local
			l_s: CE_POINTER [PD_GSL_ROOT_FDFSOLVER]
			l_return, l_break: BOOLEAN
		do
			l_s := create {CE_CLASS_POINTER [PD_GSL_ROOT_FDFSOLVER]}.make_cast ((malloc ((create {PD_GSL_ROOT_FDFSOLVER}.make).structure_size.to_natural_32)))
			if l_s.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for root solver struct"), ce_string ("fdfsolver.c"), 35, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_ROOT_FDFSOLVER]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s.item.state := malloc (a_T.item.size)
				if (l_s.item.state).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for root solver state"), ce_string ("fdfsolver.c"), 45, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_ROOT_FDFSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.type := a_T
				l_s.item.fdf := create {CE_CLASS_POINTER [PD_GSL_FUNCTION_FDF_STRUCT]}.make_shared (default_pointer)
				Result := l_s
			end
		end

	gsl_root_fdfsolver_free (a_s: CE_POINTER [PD_GSL_ROOT_FDFSOLVER])
		local
			l_return: BOOLEAN
		do
			if a_s.is_void then
				l_return := True
			end
			if not l_return then
				free (a_s.item.state)
				free (create {CE_VOID_POINTER}.make_cast (a_s))
			end
		end

end
