class
	P_FDIST_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_fdist_pdf (a_x, a_nu1, a_nu2: REAL_64): REAL_64
		local
			l_p: REAL_64
			l_lglg: REAL_64
			l_tmp: REAL_64
			l_lg12: REAL_64
			l_lg1: REAL_64
			l_lg2: REAL_64
			l_tmp___4: REAL_64
		do
			if a_x < (0).to_double then
				Result := (0).to_double
			else
				l_tmp := log (a_nu1)
				l_lglg := (a_nu1 / (2).to_double) * l_tmp + (a_nu2 / (2).to_double) * (log (a_nu2))
				l_lg12 := ((create {P_GAMMA_STATIC}).gsl_sf_lngamma ((a_nu1 + a_nu2) / (2).to_double))
				l_lg1 := ((create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_nu1 / (2).to_double))
				l_lg2 := ((create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_nu2 / (2).to_double))
				l_tmp___4 := log (a_x)
				l_p := exp (((((l_lglg + l_lg12) - l_lg1) - l_lg2) + (a_nu1 / (2).to_double - (1).to_double) * l_tmp___4) - ((a_nu1 + a_nu2) / (2).to_double) * (log (a_nu2 + a_nu1 * a_x)))
				Result := l_p
			end
		end

	gsl_cdf_fdist_P (a_x, a_nu1, a_nu2: REAL_64): REAL_64
		local
			l_P___2: REAL_64
			l_r___3: REAL_64
			l_u: REAL_64
			l_u___0: REAL_64
		do
			l_r___3 := a_nu2 / a_nu1
			if a_x < l_r___3 then
				l_u := a_x / (l_r___3 + a_x)
				l_P___2 := (create {P_BETA_INC_STATIC}).beta_inc_AXPY (1.0, 0.0, a_nu1 / 2.0, a_nu2 / 2.0, l_u)
			else
				l_u___0 := l_r___3 / (l_r___3 + a_x)
				l_P___2 := (create {P_BETA_INC_STATIC}).beta_inc_AXPY (-1.0, 1.0, a_nu2 / 2.0, a_nu1 / 2.0, l_u___0)
			end
			Result := l_P___2
		end

	gsl_cdf_fdist_Q (a_x, a_nu1, a_nu2: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
			l_r___3: REAL_64
			l_u: REAL_64
			l_u___0: REAL_64
		do
			l_r___3 := a_nu2 / a_nu1
			if a_x < l_r___3 then
				l_u := a_x / (l_r___3 + a_x)
				l_Q___1 := (create {P_BETA_INC_STATIC}).beta_inc_AXPY (-1.0, 1.0, a_nu1 / 2.0, a_nu2 / 2.0, l_u)
			else
				l_u___0 := l_r___3 / (l_r___3 + a_x)
				l_Q___1 := (create {P_BETA_INC_STATIC}).beta_inc_AXPY (1.0, 0.0, a_nu2 / 2.0, a_nu1 / 2.0, l_u___0)
			end
			Result := l_Q___1
		end

end
