class
	P_FDISTINV_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gsl_cdf_fdist_Pinv (a_P___2, a_nu1, a_nu2: REAL_64): REAL_64
		local
			l_result: REAL_64
			l_y: REAL_64
			l_return, l_break: BOOLEAN
		do
			if a_P___2 < 0.0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("P < 0.0"), ce_string ("fdistinv.c"), 36, 1)
					Result := (builtin_nanf (ce_string (""))).to_double
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_P___2 > 1.0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("P > 1.0"), ce_string ("fdistinv.c"), 40, 1)
					Result := (builtin_nanf (ce_string (""))).to_double
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_nu1 < 1.0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("nu1 < 1"), ce_string ("fdistinv.c"), 44, 1)
					Result := (builtin_nanf (ce_string (""))).to_double
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_nu2 < 1.0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("nu2 < 1"), ce_string ("fdistinv.c"), 48, 1)
					Result := (builtin_nanf (ce_string (""))).to_double
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				if a_P___2 < 0.5 then
					l_y := (create {P_BETAINV_STATIC}).gsl_cdf_beta_Pinv (a_P___2, a_nu1 / 2.0, a_nu2 / 2.0)
					l_result := (a_nu2 * l_y) / (a_nu1 * (1.0 - l_y))
				else
					l_y := (create {P_BETAINV_STATIC}).gsl_cdf_beta_Qinv (a_P___2, a_nu2 / 2.0, a_nu1 / 2.0)
					l_result := (a_nu2 * ((1).to_double - l_y)) / (a_nu1 * l_y)
				end
				Result := l_result
			end
		end

	gsl_cdf_fdist_Qinv (a_Q___1, a_nu1, a_nu2: REAL_64): REAL_64
		local
			l_result: REAL_64
			l_y: REAL_64
			l_return, l_break: BOOLEAN
		do
			if a_Q___1 < 0.0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("Q < 0.0"), ce_string ("fdistinv.c"), 75, 1)
					Result := (builtin_nanf (ce_string (""))).to_double
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_Q___1 > 1.0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("Q > 1.0"), ce_string ("fdistinv.c"), 79, 1)
					Result := (builtin_nanf (ce_string (""))).to_double
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_nu1 < 1.0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("nu1 < 1"), ce_string ("fdistinv.c"), 83, 1)
					Result := (builtin_nanf (ce_string (""))).to_double
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_nu2 < 1.0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("nu2 < 1"), ce_string ("fdistinv.c"), 87, 1)
					Result := (builtin_nanf (ce_string (""))).to_double
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				if a_Q___1 > 0.5 then
					l_y := (create {P_BETAINV_STATIC}).gsl_cdf_beta_Qinv (a_Q___1, a_nu1 / 2.0, a_nu2 / 2.0)
					l_result := (a_nu2 * l_y) / (a_nu1 * (1.0 - l_y))
				else
					l_y := (create {P_BETAINV_STATIC}).gsl_cdf_beta_Pinv (a_Q___1, a_nu2 / 2.0, a_nu1 / 2.0)
					l_result := (a_nu2 * ((1).to_double - l_y)) / (a_nu1 * l_y)
				end
				Result := l_result
			end
		end

end
