class
	P_GAMMAINV_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_cdf_gamma_Pinv (a_P___2, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_x0: REAL_64
			l_tmp___0: REAL_64
			l_x0___0: REAL_64
			l_tmp___3: REAL_64
			l_xg: REAL_64
			l_x0___1: REAL_64
			l_tmp___8: REAL_64
			l_lambda: REAL_64
			l_dP: REAL_64
			l_phi: REAL_64
			l_n: NATURAL_32
			l_tmp___11: NATURAL_32
			l_tmp___14: REAL_64
			l_step0: REAL_64
			l_step1: REAL_64
			l_step: REAL_64
			l_tmp___16: REAL_64
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_P___2 = 1.0 then
						Result := (builtin_inff).to_double
						l_return := True
					elseif a_P___2 = 0.0 then
						Result := (0.0)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if a_P___2 < 0.05 then
							l_tmp___0 := (create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_a___5)
							l_x0 := (exp ((l_tmp___0 + (log (a_P___2))) / a_a___5))
							l_x := l_x0
						elseif a_P___2 > 0.95 then
							l_tmp___3 := log1p (-a_P___2)
							l_x0___0 := -l_tmp___3 + ((create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_a___5))
							l_x := l_x0___0
						else
							l_xg := ((create {P_GAUSSINV_STATIC}).gsl_cdf_ugaussian_Pinv (a_P___2))
							if l_xg < -0.5 * (sqrt (a_a___5)) then
								l_tmp___8 := a_a___5
							else
								l_tmp___8 := (sqrt (a_a___5)) * l_xg + a_a___5
							end
							l_x0___1 := l_tmp___8
							l_x := l_x0___1
						end
						l_n := {NATURAL_32} 0
				when 2 then -- start:
						l_dP := a_P___2 - ((create {P_GAMMA_STATIC}).gsl_cdf_gamma_P (l_x, a_a___5, 1.0))
						l_phi := (create {P_GAMMA_STATIC}).gsl_ran_gamma_pdf (l_x, a_a___5, 1.0)
						if l_dP = 0.0 then
							l_pos := -1 + 4 -- goto end
						else
							l_tmp___11 := l_n
							l_n := l_n + 1
							if l_tmp___11 > {NATURAL_32} 32 then
								l_pos := -1 + 4 -- goto end
							end
						end
				when 3 then
						if (2).to_double * (fabs (l_dP / l_x)) > l_phi then
							l_tmp___14 := (2).to_double * (fabs (l_dP / l_x))
						else
							l_tmp___14 := l_phi
						end
						l_lambda := l_dP / l_tmp___14
						l_step0 := l_lambda
						l_step1 := ((-((a_a___5 - (1).to_double) / l_x - (1).to_double) * l_lambda) * l_lambda) / 4.0
						l_step := l_step0
						l_tmp___16 := fabs (l_step1)
						if l_tmp___16 < 0.5 * (fabs (l_step0)) then
							l_step := l_step + l_step1
						end
						if l_x + l_step > (0).to_double then
							l_x := l_x + l_step
						else
							l_x := l_x / (2.0)
						end
						if (fabs (l_step0)) > 1.e-10 * l_x then
							l_pos := -1 + 2 -- goto start
						elseif (fabs (l_step0 * l_phi)) > 1.e-10 * a_P___2 then
							l_pos := -1 + 2 -- goto start
						end
				when 4 then -- end:
						if (fabs (l_dP)) > 1.4901161193847656e-08 * a_P___2 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("inverse failed to converge"), ce_string ("gammainv.c"), 111, 5)
								Result := (builtin_nanf (ce_string (""))).to_double
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
				when 5 then -- if done
					if not l_return then
						Result := (a_b___0 * l_x)
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_cdf_gamma_Qinv (a_Q___1, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_x0: REAL_64
			l_tmp___0: REAL_64
			l_x0___0: REAL_64
			l_tmp___2: REAL_64
			l_xg: REAL_64
			l_x0___1: REAL_64
			l_tmp___8: REAL_64
			l_lambda: REAL_64
			l_dQ: REAL_64
			l_phi: REAL_64
			l_n: NATURAL_32
			l_tmp___11: NATURAL_32
			l_tmp___14: REAL_64
			l_step0: REAL_64
			l_step1: REAL_64
			l_step: REAL_64
			l_tmp___16: REAL_64
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_Q___1 = 1.0 then
						Result := (0.0)
						l_return := True
					elseif a_Q___1 = 0.0 then
						Result := (builtin_inff).to_double
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if a_Q___1 < 0.05 then
							l_tmp___0 := log (a_Q___1)
							l_x0 := -l_tmp___0 + ((create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_a___5))
							l_x := l_x0
						elseif a_Q___1 > 0.95 then
							l_tmp___2 := (create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_a___5)
							l_x0___0 := (exp ((l_tmp___2 + (log1p (-a_Q___1))) / a_a___5))
							l_x := l_x0___0
						else
							l_xg := ((create {P_GAUSSINV_STATIC}).gsl_cdf_ugaussian_Qinv (a_Q___1))
							if l_xg < -0.5 * (sqrt (a_a___5)) then
								l_tmp___8 := a_a___5
							else
								l_tmp___8 := (sqrt (a_a___5)) * l_xg + a_a___5
							end
							l_x0___1 := l_tmp___8
							l_x := l_x0___1
						end
						l_n := {NATURAL_32} 0
				when 2 then -- start:
						l_dQ := a_Q___1 - ((create {P_GAMMA_STATIC}).gsl_cdf_gamma_Q (l_x, a_a___5, 1.0))
						l_phi := (create {P_GAMMA_STATIC}).gsl_ran_gamma_pdf (l_x, a_a___5, 1.0)
						if l_dQ = 0.0 then
							l_pos := -1 + 4 -- goto end
						else
							l_tmp___11 := l_n
							l_n := l_n + 1
							if l_tmp___11 > {NATURAL_32} 32 then
								l_pos := -1 + 4 -- goto end
							end
						end
				when 3 then
						if (2).to_double * (fabs (l_dQ / l_x)) > l_phi then
							l_tmp___14 := (2).to_double * (fabs (l_dQ / l_x))
						else
							l_tmp___14 := l_phi
						end
						l_lambda := -l_dQ / l_tmp___14
						l_step0 := l_lambda
						l_step1 := ((-((a_a___5 - (1).to_double) / l_x - (1).to_double) * l_lambda) * l_lambda) / 4.0
						l_step := l_step0
						l_tmp___16 := fabs (l_step1)
						if l_tmp___16 < 0.5 * (fabs (l_step0)) then
							l_step := l_step + l_step1
						end
						if l_x + l_step > (0).to_double then
							l_x := l_x + l_step
						else
							l_x := l_x / (2.0)
						end
						if (fabs (l_step0)) > 1.e-10 * l_x then
							l_pos := -1 + 2 -- goto start
						end
				when 4 then -- end:
						Result := (a_b___0 * l_x)
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
