class
	P_GEN_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_eigen_gen_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension must be positive integer"), ce_string ("gen.c"), 118, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_w := create {CE_CLASS_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]}.make_cast ((calloc ((1).to_natural_32, (create {PD_GSL_EIGEN_GEN_WORKSPACE}.make).structure_size.to_natural_32)))
				if l_w.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for workspace"), ce_string ("gen.c"), 125, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.size := a_n
				l_w.item.max_iterations := {NATURAL_32} 30 * a_n
				l_w.item.n_evals := (0).to_natural_32
				l_w.item.n_iter := (0).to_natural_32
				l_w.item.needtop := 0
				l_w.item.atol := 0.0
				l_w.item.btol := 0.0
				l_w.item.ascale := 0.0
				l_w.item.bscale := 0.0
				l_w.item.eshift := 0.0
				l_w.item.H := create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
				l_w.item.R := create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
				l_w.item.compute_s := 0
				l_w.item.compute_t := 0
				l_w.item.Q := create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
				l_w.item.Z := create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
				l_w.item.work := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_n)
				if (l_w.item.work).is_void then
					gsl_eigen_gen_free (l_w)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for additional workspace"), ce_string ("gen.c"), 150, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := l_w
			end
		end

	gsl_eigen_gen_free (a_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE])
		local
			l_return: BOOLEAN
		do
			if a_w.is_void then
				l_return := True
			end
			if not l_return then
				if (not (a_w.item.work).is_void) then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_w.item.work)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_w))
			end
		end

end
