class
	P_GFSR4_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	gfsr4_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("gfsr4"), {NATURAL_32} 4_294_967_295, {NATURAL_32} 0, (create {PD_GFSR4_STATE_T}.make).structure_size.to_natural_32, gfsr4_set_address, gfsr4_get_address, gfsr4_get_double_address])
				>>)
		end

	gsl_rng_gfsr4: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := gfsr4_type.item
		end

feature {ANY} -- public routines

	gfsr4_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_GFSR4_STATE_T]
			l_tmp: NATURAL_32
		do
			l_state := create {CE_CLASS_POINTER [PD_GFSR4_STATE_T]}.make_cast (a_vstate)
			l_state.item.nd := ((l_state.item.nd + 1)).bit_and (16_383)
			l_tmp := (((((l_state.item.ra[((l_state.item.nd + 15_913)).bit_and (16_383)]).bit_xor (l_state.item.ra[((l_state.item.nd + 14_798)).bit_and (16_383)]))).bit_xor (l_state.item.ra[((l_state.item.nd + 9_396)).bit_and (16_383)]))).bit_xor (l_state.item.ra[((l_state.item.nd + 6_695)).bit_and (16_383)])
			l_state.item.ra[l_state.item.nd] := l_tmp
			Result := l_tmp
		end

	gfsr4_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((gfsr4_get (a_vstate)).to_real_64 / 4294967296.0)
		end

	gfsr4_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_GFSR4_STATE_T]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_msb: NATURAL_32
			l_mask___0: NATURAL_32
			l_t: NATURAL_32
			l_bit: NATURAL_32
			l_k: INTEGER_32
			l_return: BOOLEAN
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_GFSR4_STATE_T]}.make_cast (a_vstate)
			l_msb := {NATURAL_32} 2_147_483_648
			l_mask___0 := {NATURAL_32} 4_294_967_295
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 4_357
			end
			l_i := 0
			from
			until
				not (not (l_return) and then (l_i <= 16_383))
			loop
				l_t := {NATURAL_32} 0
				l_bit := l_msb
				l_j := 0
				from
				until
					not (l_j < 32)
				loop
					l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
					if ((l_s).bit_and (l_msb)).to_boolean then
						l_t := (l_t).bit_or (l_bit)
					end
					l_bit := (l_bit).bit_shift_right ((1))
					l_j := l_j + 1
				end
				l_state.item.ra[l_i] := l_t
				l_i := l_i + 1
			end
			l_i := 0
			from
			until
				not (l_i < 32)
			loop
				l_k := 7 + l_i * 3
				l_state.item.ra[l_k] := (l_state.item.ra[l_k]).bit_and (l_mask___0)
				l_state.item.ra[l_k] := (l_state.item.ra[l_k]).bit_or (l_msb)
				l_mask___0 := (l_mask___0).bit_shift_right ((1))
				l_msb := (l_msb).bit_shift_right ((1))
				l_i := l_i + 1
			end
			l_state.item.nd := l_i
		end

feature {ANY} -- routine addresses

	gfsr4_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gfsr4_get)
		end

	gfsr4_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gfsr4_get_double)
		end

	gfsr4_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gfsr4_set)
		end

end
