class
	P_HAAR_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	ch_2: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					0.70710678118654752440, 0.70710678118654752440
				>>)
		end

	cg_2: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					0.70710678118654752440, (-0.70710678118654752440)
				>>)
		end

	haar_type: CE_STATIC [CE_ARRAY [PD_GSL_WAVELET_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_WAVELET_TYPE]}.make_initialized (<<
					create {PD_GSL_WAVELET_TYPE}.make_initialized ([ce_string ("haar"), haar_init_address])
				>>)
		end

	haar_centered_type: CE_STATIC [CE_ARRAY [PD_GSL_WAVELET_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_WAVELET_TYPE]}.make_initialized (<<
					create {PD_GSL_WAVELET_TYPE}.make_initialized ([ce_string ("haar-centered"), haar_centered_init_address])
				>>)
		end

	gsl_wavelet_haar: CE_STATIC [CE_POINTER [PD_GSL_WAVELET_TYPE]]
		once ("PROCESS")
			Result.item := haar_type.item
		end

	gsl_wavelet_haar_centered: CE_STATIC [CE_POINTER [PD_GSL_WAVELET_TYPE]]
		once ("PROCESS")
			Result.item := haar_centered_type.item
		end

feature {ANY} -- public routines

	haar_init (a_h1, a_g1, a_h2, a_g2: CE_POINTER [CE_POINTER [REAL_64]]; a_nc, a_offset: CE_POINTER [NATURAL_32]; a_member: NATURAL_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_member /= {NATURAL_32} 2 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				a_h1.item := ch_2.item
				a_g1.item := cg_2.item
				a_h2.item := ch_2.item
				a_g2.item := cg_2.item
				a_nc.item := (2).to_natural_32
				a_offset.item := (0).to_natural_32
				Result := 0
			end
		end

	haar_centered_init (a_h1, a_g1, a_h2, a_g2: CE_POINTER [CE_POINTER [REAL_64]]; a_nc, a_offset: CE_POINTER [NATURAL_32]; a_member: NATURAL_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_member /= {NATURAL_32} 2 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				a_h1.item := ch_2.item
				a_g1.item := cg_2.item
				a_h2.item := ch_2.item
				a_g2.item := cg_2.item
				a_nc.item := (2).to_natural_32
				a_offset.item := (1).to_natural_32
				Result := 0
			end
		end

feature {ANY} -- routine addresses

	haar_init_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent haar_init)
		end

	haar_centered_init_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent haar_centered_init)
		end

end
