class
	P_HC_INIT_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_fft_halfcomplex_wavetable_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE]
		local
			l_status: INTEGER_32
			l_i: NATURAL_32
			l_n_factors: CE_ARRAY [NATURAL_32]
			l_t: NATURAL_32
			l_product: NATURAL_32
			l_product_1: NATURAL_32
			l_q___3: NATURAL_32
			l_d_theta: REAL_64
			l_wavetable: CE_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE]
			l_j: NATURAL_32
			l_factor: NATURAL_32
			l_k: NATURAL_32
			l_m___4: NATURAL_32
			l_theta: REAL_64
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_n_factors.make (<<1>>)

			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("length n must be positive integer"), ce_string ("hc_init.c"), 33, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_wavetable := create {CE_CLASS_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE]}.make_cast ((malloc ((create {PD_GSL_FFT_HALFCOMPLEX_WAVETABLE}.make).structure_size.to_natural_32)))
				if l_wavetable.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate struct"), ce_string ("hc_init.c"), 41, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_wavetable.item.trig := create {CE_CLASS_POINTER [PD_GSL_COMPLEX]}.make_cast ((malloc (a_n * (create {PD_GSL_COMPLEX}.make).structure_size.to_natural_32)))
				if (l_wavetable.item.trig).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_wavetable))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate trigonometric lookup table"), ce_string ("hc_init.c"), 53, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_wavetable.item.n := a_n
				l_status := (create {P_FACTORIZE_STATIC}).fft_halfcomplex_factorize (a_n, l_n_factors, l_wavetable.item.factor)
				if l_status.to_boolean then
					free (create {CE_VOID_POINTER}.make_cast (l_wavetable.item.trig))
					free (create {CE_VOID_POINTER}.make_cast (l_wavetable))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("factorization failed"), ce_string ("hc_init.c"), 67, 6)
						Result := (create {CE_CLASS_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_wavetable.item.nf := l_n_factors.item
				l_d_theta := (2.0 * 3.14159265358979323846) / a_n.to_real_64
				l_t := (0).to_natural_32
				l_product := (1).to_natural_32
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_n_factors.item))
				loop
					l_factor := l_wavetable.item.factor[l_i.to_integer_32]
					l_wavetable.item.twiddle[l_i.to_integer_32] := l_wavetable.item.trig + l_t.to_integer_32
					l_product_1 := l_product
					l_product := l_product * l_factor
					l_q___3 := a_n // l_product
					l_j := (1).to_natural_32
					from
					until
						not (not (l_return) and then (l_j < l_factor))
					loop
						l_m___4 := (0).to_natural_32
						l_k := (1).to_natural_32
						from
						until
							not (l_k < (l_q___3 + {NATURAL_32} 1) // {NATURAL_32} 2)
						loop
							l_m___4 := l_m___4 + (l_j * l_product_1)
							l_m___4 := l_m___4 \\ a_n
							l_theta := l_d_theta * l_m___4.to_real_64;
							(l_wavetable.item.trig + l_t.to_integer_32).item.dat[0] := cos (l_theta);
							(l_wavetable.item.trig + l_t.to_integer_32).item.dat[1] := sin (l_theta)
							l_t := l_t + 1
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				if l_t > a_n // {NATURAL_32} 2 then
					free (create {CE_VOID_POINTER}.make_cast (l_wavetable.item.trig))
					free (create {CE_VOID_POINTER}.make_cast (l_wavetable))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("overflowed trigonometric lookup table"), ce_string ("hc_init.c"), 110, 7)
						Result := (create {CE_CLASS_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := l_wavetable
			end
		end

	gsl_fft_halfcomplex_wavetable_free (a_wavetable: CE_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE])
		local
			l_return: BOOLEAN
		do
			if a_wavetable.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_wavetable.item.trig))
				a_wavetable.item.trig := create {CE_CLASS_POINTER [PD_GSL_COMPLEX]}.make_shared (default_pointer)
				free (create {CE_VOID_POINTER}.make_cast (a_wavetable))
			end
		end

	gsl_fft_halfcomplex_wavetable_float_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE_FLOAT]
		local
			l_status: INTEGER_32
			l_i: NATURAL_32
			l_n_factors: CE_ARRAY [NATURAL_32]
			l_t: NATURAL_32
			l_product: NATURAL_32
			l_product_1: NATURAL_32
			l_q___3: NATURAL_32
			l_d_theta: REAL_64
			l_wavetable: CE_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE_FLOAT]
			l_j: NATURAL_32
			l_factor: NATURAL_32
			l_k: NATURAL_32
			l_m___4: NATURAL_32
			l_theta: REAL_64
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_n_factors.make (<<1>>)

			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("length n must be positive integer"), ce_string ("hc_init.c"), 33, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE_FLOAT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_wavetable := create {CE_CLASS_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE_FLOAT]}.make_cast ((malloc ((create {PD_GSL_FFT_HALFCOMPLEX_WAVETABLE_FLOAT}.make).structure_size.to_natural_32)))
				if l_wavetable.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate struct"), ce_string ("hc_init.c"), 41, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE_FLOAT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_wavetable.item.trig := create {CE_CLASS_POINTER [PD_GSL_COMPLEX_FLOAT]}.make_cast ((malloc (a_n * (create {PD_GSL_COMPLEX_FLOAT}.make).structure_size.to_natural_32)))
				if (l_wavetable.item.trig).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_wavetable))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate trigonometric lookup table"), ce_string ("hc_init.c"), 53, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE_FLOAT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_wavetable.item.n := a_n
				l_status := (create {P_FACTORIZE_STATIC}).fft_halfcomplex_factorize (a_n, l_n_factors, l_wavetable.item.factor)
				if l_status.to_boolean then
					free (create {CE_VOID_POINTER}.make_cast (l_wavetable.item.trig))
					free (create {CE_VOID_POINTER}.make_cast (l_wavetable))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("factorization failed"), ce_string ("hc_init.c"), 67, 6)
						Result := (create {CE_CLASS_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE_FLOAT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_wavetable.item.nf := l_n_factors.item
				l_d_theta := (2.0 * 3.14159265358979323846) / a_n.to_real_64
				l_t := (0).to_natural_32
				l_product := (1).to_natural_32
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_n_factors.item))
				loop
					l_factor := l_wavetable.item.factor[l_i.to_integer_32]
					l_wavetable.item.twiddle[l_i.to_integer_32] := l_wavetable.item.trig + l_t.to_integer_32
					l_product_1 := l_product
					l_product := l_product * l_factor
					l_q___3 := a_n // l_product
					l_j := (1).to_natural_32
					from
					until
						not (not (l_return) and then (l_j < l_factor))
					loop
						l_m___4 := (0).to_natural_32
						l_k := (1).to_natural_32
						from
						until
							not (l_k < (l_q___3 + {NATURAL_32} 1) // {NATURAL_32} 2)
						loop
							l_m___4 := l_m___4 + (l_j * l_product_1)
							l_m___4 := l_m___4 \\ a_n
							l_theta := l_d_theta * l_m___4.to_real_64;
							(l_wavetable.item.trig + l_t.to_integer_32).item.dat[0] := (cos (l_theta)).truncated_to_real;
							(l_wavetable.item.trig + l_t.to_integer_32).item.dat[1] := (sin (l_theta)).truncated_to_real
							l_t := l_t + 1
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				if l_t > a_n // {NATURAL_32} 2 then
					free (create {CE_VOID_POINTER}.make_cast (l_wavetable.item.trig))
					free (create {CE_VOID_POINTER}.make_cast (l_wavetable))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("overflowed trigonometric lookup table"), ce_string ("hc_init.c"), 110, 7)
						Result := (create {CE_CLASS_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE_FLOAT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := l_wavetable
			end
		end

	gsl_fft_halfcomplex_wavetable_float_free (a_wavetable: CE_POINTER [PD_GSL_FFT_HALFCOMPLEX_WAVETABLE_FLOAT])
		local
			l_return: BOOLEAN
		do
			if a_wavetable.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_wavetable.item.trig))
				a_wavetable.item.trig := create {CE_CLASS_POINTER [PD_GSL_COMPLEX_FLOAT]}.make_shared (default_pointer)
				free (create {CE_VOID_POINTER}.make_cast (a_wavetable))
			end
		end

end
