class
	P_HERMV_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_eigen_hermv_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension must be positive integer"), ce_string ("hermv.c"), 44, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_w := create {CE_CLASS_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]}.make_cast ((malloc ((create {PD_GSL_EIGEN_HERMV_WORKSPACE}.make).structure_size.to_natural_32)))
				if l_w.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for workspace"), ce_string ("hermv.c"), 51, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.d := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.d).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for diagonal"), ce_string ("hermv.c"), 59, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.sd := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.sd).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.d))
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for subdiagonal"), ce_string ("hermv.c"), 68, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.tau := create {CE_REAL_64_POINTER}.make_cast ((malloc (({NATURAL_32} 2 * a_n) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.tau).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.sd))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.d))
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for tau"), ce_string ("hermv.c"), 78, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.gc := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.gc).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.tau))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.sd))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.d))
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for cosines"), ce_string ("hermv.c"), 89, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.gs := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.gs).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.gc))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.tau))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.sd))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.d))
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for sines"), ce_string ("hermv.c"), 101, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.size := a_n
				Result := l_w
			end
		end

	gsl_eigen_hermv_free (a_w: CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE])
		local
			l_return: BOOLEAN
		do
			if a_w.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_w.item.gs))
				free (create {CE_VOID_POINTER}.make_cast (a_w.item.gc))
				free (create {CE_VOID_POINTER}.make_cast (a_w.item.tau))
				free (create {CE_VOID_POINTER}.make_cast (a_w.item.sd))
				free (create {CE_VOID_POINTER}.make_cast (a_w.item.d))
				free (create {CE_VOID_POINTER}.make_cast (a_w))
			end
		end

end
