class
	P_HYPOT_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_hypot (a_x, a_y: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_min: REAL_64
			l_max: REAL_64
			l_u: REAL_64
			l_return: BOOLEAN
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			if l_xabs < l_yabs then
				l_min := l_xabs
				l_max := l_yabs
			else
				l_min := l_yabs
				l_max := l_xabs
			end
			if l_min = (0).to_double then
				Result := l_max
				l_return := True
			end
			if not l_return then
				l_u := l_min / l_max
				Result := (l_max * (sqrt ((1).to_double + l_u * l_u)))
			end
		end

	xhypot (a_x, a_y: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_min: REAL_64
			l_max: REAL_64
			l_u: REAL_64
			l_return: BOOLEAN
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			if l_xabs < l_yabs then
				l_min := l_xabs
				l_max := l_yabs
			else
				l_min := l_yabs
				l_max := l_xabs
			end
			if l_min = (0).to_double then
				Result := l_max
				l_return := True
			end
			if not l_return then
				l_u := l_min / l_max
				Result := (l_max * (sqrt ((1).to_double + l_u * l_u)))
			end
		end

	xhypot___0 (a_x, a_y: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_min: REAL_64
			l_max: REAL_64
			l_u: REAL_64
			l_return: BOOLEAN
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			if l_xabs < l_yabs then
				l_min := l_xabs
				l_max := l_yabs
			else
				l_min := l_yabs
				l_max := l_xabs
			end
			if l_min = (0).to_double then
				Result := l_max
				l_return := True
			end
			if not l_return then
				l_u := l_min / l_max
				Result := (l_max * (sqrt ((1).to_double + l_u * l_u)))
			end
		end

	xhypot___3 (a_x, a_y: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_min: REAL_64
			l_max: REAL_64
			l_u: REAL_64
			l_return: BOOLEAN
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			if l_xabs < l_yabs then
				l_min := l_xabs
				l_max := l_yabs
			else
				l_min := l_yabs
				l_max := l_xabs
			end
			if l_min = (0).to_double then
				Result := l_max
				l_return := True
			end
			if not l_return then
				l_u := l_min / l_max
				Result := (l_max * (sqrt ((1).to_double + l_u * l_u)))
			end
		end

	xhypot___4 (a_x, a_y: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_min: REAL_64
			l_max: REAL_64
			l_u: REAL_64
			l_return: BOOLEAN
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			if l_xabs < l_yabs then
				l_min := l_xabs
				l_max := l_yabs
			else
				l_min := l_yabs
				l_max := l_xabs
			end
			if l_min = (0).to_double then
				Result := l_max
				l_return := True
			end
			if not l_return then
				l_u := l_min / l_max
				Result := (l_max * (sqrt ((1).to_double + l_u * l_u)))
			end
		end

end
