class
	P_LANDAU_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public attributes

	P1: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					0.4259894875e0, -0.1249762550e0, 0.3984243700e-1, -0.6298287635e-2, 0.1511162253e-2
				>>)
		end

	P2: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					0.1788541609e0, 0.1173957403e0, 0.1488850518e-1, -0.1394989411e-2, 0.1283617211e-3
				>>)
		end

	P3: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					0.1788544503e0, 0.9359161662e-1, 0.6325387654e-2, 0.6611667319e-4, -0.2031049101e-5
				>>)
		end

	P4: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					0.9874054407e0, 0.1186723273e3, 0.8492794360e3, -0.7437792444e3, 0.4270262186e3
				>>)
		end

	P5: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					0.1003675074e1, 0.1675702434e3, 0.4789711289e4, 0.2121786767e5, -0.2232494910e5
				>>)
		end

	P6: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					0.1000827619e1, 0.6649143136e3, 0.6297292665e5, 0.4755546998e6, -0.5743609109e7
				>>)
		end

	Q1: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					1.0, -0.3388260629e0, 0.9594393323e-1, -0.1608042283e-1, 0.3778942063e-2
				>>)
		end

	Q2: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					1.0, 0.7428795082e0, 0.3153932961e0, 0.6694219548e-1, 0.8790609714e-2
				>>)
		end

	Q3: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					1.0, 0.6097809921e0, 0.2560616665e0, 0.4746722384e-1, 0.6957301675e-2
				>>)
		end

	Q4: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					1.0, 0.1068615961e3, 0.3376496214e3, 0.2016712389e4, 0.1597063511e4
				>>)
		end

	Q5: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					1.0, 0.1569424537e3, 0.3745310488e4, 0.9834698876e4, 0.6692428357e5
				>>)
		end

	Q6: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					1.0, 0.6514101098e3, 0.5697473333e5, 0.1659174725e6, -0.2815759939e7
				>>)
		end

	A1: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					0.4166666667e-1, -0.1996527778e-1, 0.2709538966e-1
				>>)
		end

	A2: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					-0.1845568670e1, -0.4284640743e1
				>>)
		end

feature {ANY} -- public routines

	gsl_ran_landau_pdf (a_x: REAL_64): REAL_64
		local
			l_U: REAL_64
			l_V: REAL_64
			l_DENLAN: REAL_64
			l_tmp: REAL_64
			l_tmp___1: REAL_64
		do
			l_V := a_x
			if l_V < -5.5 then
				l_U := exp (l_V + 1.0)
				l_tmp := exp ((-1).to_double / l_U)
				l_DENLAN := (0.3989422803 * (l_tmp / (sqrt (l_U)))) * ((1).to_double + (A1.item[0] + (A1.item[1] + A1.item[2] * l_U) * l_U) * l_U)
			elseif l_V < (-1).to_double then
				l_U := exp (-l_V - (1).to_double)
				l_tmp___1 := exp (-l_U)
				l_DENLAN := ((l_tmp___1 * (sqrt (l_U))) * (P1.item[0] + (P1.item[1] + (P1.item[2] + (P1.item[3] + P1.item[4] * l_V) * l_V) * l_V) * l_V)) / (Q1.item[0] + (Q1.item[1] + (Q1.item[2] + (Q1.item[3] + Q1.item[4] * l_V) * l_V) * l_V) * l_V)
			elseif l_V < (1).to_double then
				l_DENLAN := (P2.item[0] + (P2.item[1] + (P2.item[2] + (P2.item[3] + P2.item[4] * l_V) * l_V) * l_V) * l_V) / (Q2.item[0] + (Q2.item[1] + (Q2.item[2] + (Q2.item[3] + Q2.item[4] * l_V) * l_V) * l_V) * l_V)
			elseif l_V < (5).to_double then
				l_DENLAN := (P3.item[0] + (P3.item[1] + (P3.item[2] + (P3.item[3] + P3.item[4] * l_V) * l_V) * l_V) * l_V) / (Q3.item[0] + (Q3.item[1] + (Q3.item[2] + (Q3.item[3] + Q3.item[4] * l_V) * l_V) * l_V) * l_V)
			elseif l_V < (12).to_double then
				l_U := (1).to_double / l_V
				l_DENLAN := ((l_U * l_U) * (P4.item[0] + (P4.item[1] + (P4.item[2] + (P4.item[3] + P4.item[4] * l_U) * l_U) * l_U) * l_U)) / (Q4.item[0] + (Q4.item[1] + (Q4.item[2] + (Q4.item[3] + Q4.item[4] * l_U) * l_U) * l_U) * l_U)
			elseif l_V < (50).to_double then
				l_U := (1).to_double / l_V
				l_DENLAN := ((l_U * l_U) * (P5.item[0] + (P5.item[1] + (P5.item[2] + (P5.item[3] + P5.item[4] * l_U) * l_U) * l_U) * l_U)) / (Q5.item[0] + (Q5.item[1] + (Q5.item[2] + (Q5.item[3] + Q5.item[4] * l_U) * l_U) * l_U) * l_U)
			elseif l_V < (300).to_double then
				l_U := (1).to_double / l_V
				l_DENLAN := ((l_U * l_U) * (P6.item[0] + (P6.item[1] + (P6.item[2] + (P6.item[3] + P6.item[4] * l_U) * l_U) * l_U) * l_U)) / (Q6.item[0] + (Q6.item[1] + (Q6.item[2] + (Q6.item[3] + Q6.item[4] * l_U) * l_U) * l_U) * l_U)
			else
				l_U := (1).to_double / (l_V - (l_V * (log (l_V))) / (l_V + (1).to_double))
				l_DENLAN := (l_U * l_U) * ((1).to_double + (A2.item[0] + A2.item[1] * l_U) * l_U)
			end
			Result := l_DENLAN
		end

end
