class
	P_LINEAR_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public attributes

	linear_type: CE_STATIC [CE_ARRAY [PD_GSL_INTERP_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_INTERP_TYPE]}.make_initialized (<<
					create {PD_GSL_INTERP_TYPE}.make_initialized ([ce_string ("linear"), {NATURAL_32} 2, create {CE_ROUTINE}.make_shared (default_pointer), linear_init_address, linear_eval_address, linear_eval_deriv_address, linear_eval_deriv2_address, linear_eval_integ_address, create {CE_ROUTINE}.make_shared (default_pointer)])
				>>)
		end

	gsl_interp_linear: CE_STATIC [CE_POINTER [PD_GSL_INTERP_TYPE]]
		once ("PROCESS")
			Result.item := linear_type.item
		end

feature {ANY} -- public routines

	gsl_fit_linear (a_x: CE_POINTER [REAL_64]; a_xstride: NATURAL_32; a_y: CE_POINTER [REAL_64]; a_ystride, a_n: NATURAL_32; a_c0___0, a_c1___2, a_cov_00, a_cov_01, a_cov_11, a_sumsq: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_c0___0.is_void
			not a_c1___2.is_void
			not a_cov_00.is_void
			not a_cov_01.is_void
			not a_cov_11.is_void
			not a_sumsq.is_void
		local
			l_m_x: REAL_64
			l_m_y: REAL_64
			l_m_dx2: REAL_64
			l_m_dxdy: REAL_64
			l_i: NATURAL_32
			l_dx: REAL_64
			l_dy: REAL_64
			l_s2: REAL_64
			l_d2: REAL_64
			l_b___0: REAL_64
			l_a___5: REAL_64
			l_dx___0: REAL_64
			l_dy___0: REAL_64
			l_d: REAL_64
		do
			l_m_x := (0).to_double
			l_m_y := (0).to_double
			l_m_dx2 := (0).to_double
			l_m_dxdy := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_m_x := l_m_x + ((a_x[(l_i * a_xstride).to_integer_32] - l_m_x) / (l_i.to_real_64 + 1.0))
				l_m_y := l_m_y + ((a_y[(l_i * a_ystride).to_integer_32] - l_m_y) / (l_i.to_real_64 + 1.0))
				l_i := l_i + 1
			end
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_dx := (a_x[(l_i * a_xstride).to_integer_32] - l_m_x)
				l_dy := (a_y[(l_i * a_ystride).to_integer_32] - l_m_y)
				l_m_dx2 := l_m_dx2 + ((l_dx * l_dx - l_m_dx2) / (l_i.to_real_64 + 1.0))
				l_m_dxdy := l_m_dxdy + ((l_dx * l_dy - l_m_dxdy) / (l_i.to_real_64 + 1.0))
				l_i := l_i + 1
			end
			l_s2 := (0).to_double
			l_d2 := (0).to_double
			l_b___0 := l_m_dxdy / l_m_dx2
			l_a___5 := l_m_y - l_m_x * l_b___0
			a_c0___0.item := l_a___5
			a_c1___2.item := l_b___0
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_dx___0 := (a_x[(l_i * a_xstride).to_integer_32] - l_m_x)
				l_dy___0 := (a_y[(l_i * a_ystride).to_integer_32] - l_m_y)
				l_d := l_dy___0 - l_b___0 * l_dx___0
				l_d2 := l_d2 + (l_d * l_d)
				l_i := l_i + 1
			end
			l_s2 := l_d2 / (a_n.to_real_64 - 2.0)
			a_cov_00.item := (l_s2 * (1.0 / a_n.to_real_64)) * ((1).to_double + (l_m_x * l_m_x) / l_m_dx2)
			a_cov_11.item := (l_s2 * 1.0) / (a_n.to_real_64 * l_m_dx2)
			a_cov_01.item := (l_s2 * -l_m_x) / (a_n.to_real_64 * l_m_dx2)
			a_sumsq.item := l_d2
			Result := 0
		end

	gsl_fit_wlinear (a_x: CE_POINTER [REAL_64]; a_xstride: NATURAL_32; a_w: CE_POINTER [REAL_64]; a_wstride: NATURAL_32; a_y: CE_POINTER [REAL_64]; a_ystride, a_n: NATURAL_32; a_c0___0, a_c1___2, a_cov_00, a_cov_01, a_cov_11, a_chisq: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_c0___0.is_void
			not a_c1___2.is_void
			not a_cov_00.is_void
			not a_cov_01.is_void
			not a_cov_11.is_void
			not a_chisq.is_void
		local
			l_W: REAL_64
			l_wm_x: REAL_64
			l_wm_y: REAL_64
			l_wm_dx2: REAL_64
			l_wm_dxdy: REAL_64
			l_i: NATURAL_32
			l_wi: REAL_64
			l_wi___0: REAL_64
			l_dx: REAL_64
			l_dy: REAL_64
			l_d2: REAL_64
			l_b___0: REAL_64
			l_a___5: REAL_64
			l_wi___1: REAL_64
			l_dx___0: REAL_64
			l_dy___0: REAL_64
			l_d: REAL_64
		do
			l_W := (0).to_double
			l_wm_x := (0).to_double
			l_wm_y := (0).to_double
			l_wm_dx2 := (0).to_double
			l_wm_dxdy := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_wi := a_w[(l_i * a_wstride).to_integer_32]
				if l_wi > (0).to_double then
					l_W := l_W + l_wi
					l_wm_x := l_wm_x + ((a_x[(l_i * a_xstride).to_integer_32] - l_wm_x) * (l_wi / l_W))
					l_wm_y := l_wm_y + ((a_y[(l_i * a_ystride).to_integer_32] - l_wm_y) * (l_wi / l_W))
				end
				l_i := l_i + 1
			end
			l_W := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_wi___0 := a_w[(l_i * a_wstride).to_integer_32]
				if l_wi___0 > (0).to_double then
					l_dx := (a_x[(l_i * a_xstride).to_integer_32] - l_wm_x)
					l_dy := (a_y[(l_i * a_ystride).to_integer_32] - l_wm_y)
					l_W := l_W + l_wi___0
					l_wm_dx2 := l_wm_dx2 + ((l_dx * l_dx - l_wm_dx2) * (l_wi___0 / l_W))
					l_wm_dxdy := l_wm_dxdy + ((l_dx * l_dy - l_wm_dxdy) * (l_wi___0 / l_W))
				end
				l_i := l_i + 1
			end
			l_d2 := (0).to_double
			l_b___0 := l_wm_dxdy / l_wm_dx2
			l_a___5 := l_wm_y - l_wm_x * l_b___0
			a_c0___0.item := l_a___5
			a_c1___2.item := l_b___0
			a_cov_00.item := ((1).to_double / l_W) * ((1).to_double + (l_wm_x * l_wm_x) / l_wm_dx2)
			a_cov_11.item := (1).to_double / (l_W * l_wm_dx2)
			a_cov_01.item := -l_wm_x / (l_W * l_wm_dx2)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_wi___1 := a_w[(l_i * a_wstride).to_integer_32]
				if l_wi___1 > (0).to_double then
					l_dx___0 := (a_x[(l_i * a_xstride).to_integer_32] - l_wm_x)
					l_dy___0 := (a_y[(l_i * a_ystride).to_integer_32] - l_wm_y)
					l_d := l_dy___0 - l_b___0 * l_dx___0
					l_d2 := l_d2 + ((l_wi___1 * l_d) * l_d)
				end
				l_i := l_i + 1
			end
			a_chisq.item := l_d2
			Result := 0
		end

	gsl_fit_linear_est (a_x, a_c0___0, a_c1___2, a_cov00, a_cov01, a_cov11: REAL_64; a_y, a_y_err: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_y.is_void
			not a_y_err.is_void
		do
			a_y.item := a_c0___0 + a_c1___2 * a_x
			a_y_err.item := sqrt (a_cov00 + a_x * ((2).to_double * a_cov01 + a_cov11 * a_x))
			Result := 0
		end

	gsl_fit_mul (a_x: CE_POINTER [REAL_64]; a_xstride: NATURAL_32; a_y: CE_POINTER [REAL_64]; a_ystride, a_n: NATURAL_32; a_c1___2, a_cov_11, a_sumsq: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_c1___2.is_void
			not a_cov_11.is_void
			not a_sumsq.is_void
		local
			l_m_x: REAL_64
			l_m_y: REAL_64
			l_m_dx2: REAL_64
			l_m_dxdy: REAL_64
			l_i: NATURAL_32
			l_dx: REAL_64
			l_dy: REAL_64
			l_s2: REAL_64
			l_d2: REAL_64
			l_b___0: REAL_64
			l_dx___0: REAL_64
			l_dy___0: REAL_64
			l_d: REAL_64
		do
			l_m_x := (0).to_double
			l_m_y := (0).to_double
			l_m_dx2 := (0).to_double
			l_m_dxdy := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_m_x := l_m_x + ((a_x[(l_i * a_xstride).to_integer_32] - l_m_x) / (l_i.to_real_64 + 1.0))
				l_m_y := l_m_y + ((a_y[(l_i * a_ystride).to_integer_32] - l_m_y) / (l_i.to_real_64 + 1.0))
				l_i := l_i + 1
			end
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_dx := (a_x[(l_i * a_xstride).to_integer_32] - l_m_x)
				l_dy := (a_y[(l_i * a_ystride).to_integer_32] - l_m_y)
				l_m_dx2 := l_m_dx2 + ((l_dx * l_dx - l_m_dx2) / (l_i.to_real_64 + 1.0))
				l_m_dxdy := l_m_dxdy + ((l_dx * l_dy - l_m_dxdy) / (l_i.to_real_64 + 1.0))
				l_i := l_i + 1
			end
			l_s2 := (0).to_double
			l_d2 := (0).to_double
			l_b___0 := (l_m_x * l_m_y + l_m_dxdy) / (l_m_x * l_m_x + l_m_dx2)
			a_c1___2.item := l_b___0
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_dx___0 := (a_x[(l_i * a_xstride).to_integer_32] - l_m_x)
				l_dy___0 := (a_y[(l_i * a_ystride).to_integer_32] - l_m_y)
				l_d := ((l_m_y - l_b___0 * l_m_x) + l_dy___0) - l_b___0 * l_dx___0
				l_d2 := l_d2 + (l_d * l_d)
				l_i := l_i + 1
			end
			l_s2 := l_d2 / (a_n.to_real_64 - 1.0)
			a_cov_11.item := (l_s2 * 1.0) / (a_n.to_real_64 * (l_m_x * l_m_x + l_m_dx2))
			a_sumsq.item := l_d2
			Result := 0
		end

	gsl_fit_wmul (a_x: CE_POINTER [REAL_64]; a_xstride: NATURAL_32; a_w: CE_POINTER [REAL_64]; a_wstride: NATURAL_32; a_y: CE_POINTER [REAL_64]; a_ystride, a_n: NATURAL_32; a_c1___2, a_cov_11, a_chisq: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_c1___2.is_void
			not a_cov_11.is_void
			not a_chisq.is_void
		local
			l_W: REAL_64
			l_wm_x: REAL_64
			l_wm_y: REAL_64
			l_wm_dx2: REAL_64
			l_wm_dxdy: REAL_64
			l_i: NATURAL_32
			l_wi: REAL_64
			l_wi___0: REAL_64
			l_dx: REAL_64
			l_dy: REAL_64
			l_d2: REAL_64
			l_b___0: REAL_64
			l_wi___1: REAL_64
			l_dx___0: REAL_64
			l_dy___0: REAL_64
			l_d: REAL_64
		do
			l_W := (0).to_double
			l_wm_x := (0).to_double
			l_wm_y := (0).to_double
			l_wm_dx2 := (0).to_double
			l_wm_dxdy := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_wi := a_w[(l_i * a_wstride).to_integer_32]
				if l_wi > (0).to_double then
					l_W := l_W + l_wi
					l_wm_x := l_wm_x + ((a_x[(l_i * a_xstride).to_integer_32] - l_wm_x) * (l_wi / l_W))
					l_wm_y := l_wm_y + ((a_y[(l_i * a_ystride).to_integer_32] - l_wm_y) * (l_wi / l_W))
				end
				l_i := l_i + 1
			end
			l_W := (0).to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_wi___0 := a_w[(l_i * a_wstride).to_integer_32]
				if l_wi___0 > (0).to_double then
					l_dx := (a_x[(l_i * a_xstride).to_integer_32] - l_wm_x)
					l_dy := (a_y[(l_i * a_ystride).to_integer_32] - l_wm_y)
					l_W := l_W + l_wi___0
					l_wm_dx2 := l_wm_dx2 + ((l_dx * l_dx - l_wm_dx2) * (l_wi___0 / l_W))
					l_wm_dxdy := l_wm_dxdy + ((l_dx * l_dy - l_wm_dxdy) * (l_wi___0 / l_W))
				end
				l_i := l_i + 1
			end
			l_d2 := (0).to_double
			l_b___0 := (l_wm_x * l_wm_y + l_wm_dxdy) / (l_wm_x * l_wm_x + l_wm_dx2)
			a_c1___2.item := l_b___0
			a_cov_11.item := (1).to_double / (l_W * (l_wm_x * l_wm_x + l_wm_dx2))
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_wi___1 := a_w[(l_i * a_wstride).to_integer_32]
				if l_wi___1 > (0).to_double then
					l_dx___0 := (a_x[(l_i * a_xstride).to_integer_32] - l_wm_x)
					l_dy___0 := (a_y[(l_i * a_ystride).to_integer_32] - l_wm_y)
					l_d := (l_wm_y - l_b___0 * l_wm_x) + (l_dy___0 - l_b___0 * l_dx___0)
					l_d2 := l_d2 + ((l_wi___1 * l_d) * l_d)
				end
				l_i := l_i + 1
			end
			a_chisq.item := l_d2
			Result := 0
		end

	gsl_fit_mul_est (a_x, a_c1___2, a_cov11: REAL_64; a_y, a_y_err: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_y.is_void
			not a_y_err.is_void
		local
			l_tmp: REAL_64
		do
			a_y.item := a_c1___2 * a_x
			l_tmp := sqrt (a_cov11)
			a_y_err.item := l_tmp * (fabs (a_x))
			Result := 0
		end

	linear_init (a_vstate: CE_POINTER [ANY]; a_x_array, a_y_array: CE_POINTER [REAL_64]; a_size: NATURAL_32): INTEGER_32
		do
			Result := 0
		end

	linear_eval (a_vstate: CE_POINTER [ANY]; a_x_array, a_y_array: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_x: REAL_64; a_a___5: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_y: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_x_array.is_void
			not a_y_array.is_void
			not a_y.is_void
		local
			l_x_lo: REAL_64
			l_x_hi: REAL_64
			l_y_lo: REAL_64
			l_y_hi: REAL_64
			l_dx: REAL_64
			l_index: NATURAL_32
		do
			if not a_a___5.is_void then
				l_index := a_a___5.item.gsl_interp_accel_find (a_x_array, a_size, a_x)
			else
				l_index := (create {P_GSL_GSL_INTERP_STATIC}).gsl_interp_bsearch (a_x_array, a_x, (0).to_natural_32, a_size - {NATURAL_32} 1)
			end
			l_x_lo := a_x_array[l_index.to_integer_32]
			l_x_hi := a_x_array[(l_index + {NATURAL_32} 1).to_integer_32]
			l_y_lo := a_y_array[l_index.to_integer_32]
			l_y_hi := a_y_array[(l_index + {NATURAL_32} 1).to_integer_32]
			l_dx := l_x_hi - l_x_lo
			if l_dx > 0.0 then
				a_y.item := l_y_lo + ((a_x - l_x_lo) / l_dx) * (l_y_hi - l_y_lo)
				Result := 0
			else
				a_y.item := 0.0
				Result := 4
			end
		end

	linear_eval_deriv (a_vstate: CE_POINTER [ANY]; a_x_array, a_y_array: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_x: REAL_64; a_a___5: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_dydx: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_x_array.is_void
			not a_y_array.is_void
			not a_dydx.is_void
		local
			l_x_lo: REAL_64
			l_x_hi: REAL_64
			l_y_lo: REAL_64
			l_y_hi: REAL_64
			l_dx: REAL_64
			l_dy: REAL_64
			l_index: NATURAL_32
		do
			if not a_a___5.is_void then
				l_index := a_a___5.item.gsl_interp_accel_find (a_x_array, a_size, a_x)
			else
				l_index := (create {P_GSL_GSL_INTERP_STATIC}).gsl_interp_bsearch (a_x_array, a_x, (0).to_natural_32, a_size - {NATURAL_32} 1)
			end
			l_x_lo := a_x_array[l_index.to_integer_32]
			l_x_hi := a_x_array[(l_index + {NATURAL_32} 1).to_integer_32]
			l_y_lo := a_y_array[l_index.to_integer_32]
			l_y_hi := a_y_array[(l_index + {NATURAL_32} 1).to_integer_32]
			l_dx := l_x_hi - l_x_lo
			l_dy := l_y_hi - l_y_lo
			if l_dx > 0.0 then
				a_dydx.item := l_dy / l_dx
				Result := 0
			else
				a_dydx.item := 0.0
				Result := 4
			end
		end

	linear_eval_deriv2 (a_vstate: CE_POINTER [ANY]; a_x_array, a_y_array: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_x: REAL_64; a_a___5: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_y_pp: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_y_pp.is_void
		do
			a_y_pp.item := 0.0
			Result := 0
		end

	linear_eval_integ (a_vstate: CE_POINTER [ANY]; a_x_array, a_y_array: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_acc: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_a___5, a_b___0: REAL_64; a_result: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_result.is_void
		local
			l_i: NATURAL_32
			l_index_a: NATURAL_32
			l_index_b: NATURAL_32
			l_x_hi: REAL_64
			l_x_lo: REAL_64
			l_y_lo: REAL_64
			l_y_hi: REAL_64
			l_dx: REAL_64
			l_x1___0: REAL_64
			l_tmp: REAL_64
			l_x2___1: REAL_64
			l_tmp___0: REAL_64
			l_D: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not a_acc.is_void then
						l_index_a := a_acc.item.gsl_interp_accel_find (a_x_array, a_size, a_a___5)
						l_index_b := a_acc.item.gsl_interp_accel_find (a_x_array, a_size, a_b___0)
					else
						l_index_a := (create {P_GSL_GSL_INTERP_STATIC}).gsl_interp_bsearch (a_x_array, a_a___5, (0).to_natural_32, a_size - {NATURAL_32} 1)
						l_index_b := (create {P_GSL_GSL_INTERP_STATIC}).gsl_interp_bsearch (a_x_array, a_b___0, (0).to_natural_32, a_size - {NATURAL_32} 1)
					end
					a_result.item := 0.0
					l_i := l_index_a
				when 1 then -- loop condition:
					if not (l_i <= l_index_b) then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						l_x_hi := a_x_array[(l_i + {NATURAL_32} 1).to_integer_32]
						l_x_lo := a_x_array[l_i.to_integer_32]
						l_y_lo := a_y_array[l_i.to_integer_32]
						l_y_hi := a_y_array[(l_i + {NATURAL_32} 1).to_integer_32]
						l_dx := l_x_hi - l_x_lo
						if l_dx = 0.0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						if l_i /= l_index_a then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if l_i /= l_index_b then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						if l_i = l_index_a then
							l_tmp := a_a___5
						else
							l_tmp := l_x_lo
						end
						l_x1___0 := l_tmp
						if l_i = l_index_b then
							l_tmp___0 := a_b___0
						else
							l_tmp___0 := l_x_hi
						end
						l_x2___1 := l_tmp___0
						l_D := (l_y_hi - l_y_lo) / l_dx
						a_result.item := a_result.item + ((l_x2___1 - l_x1___0) * (l_y_lo + (0.5 * l_D) * ((l_x2___1 - l_x_lo) + (l_x1___0 - l_x_lo))))
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						a_result.item := a_result.item + ((0.5 * l_dx) * (l_y_lo + l_y_hi))
				when 10 then -- if done | if done
						l_i := l_i + 1
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
					Result := 0
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	linear_init_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent linear_init)
		end

	linear_eval_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent linear_eval)
		end

	linear_eval_deriv_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent linear_eval_deriv)
		end

	linear_eval_deriv2_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent linear_eval_deriv2)
		end

	linear_eval_integ_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent linear_eval_integ)
		end

end
