class
	P_LOGISTIC_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_logistic_pdf (a_x, a_a___5: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_p: REAL_64
		do
			l_u := (exp (-(fabs (a_x)) / a_a___5))
			l_p := l_u / (((fabs (a_a___5)) * ((1).to_double + l_u)) * ((1).to_double + l_u))
			Result := l_p
		end

	gsl_cdf_logistic_P (a_x, a_a___5: REAL_64): REAL_64
		local
			l_P___2: REAL_64
			l_u: REAL_64
			l_tmp___0: REAL_64
		do
			l_u := a_x / a_a___5
			if l_u >= (0).to_double then
				l_P___2 := (1).to_double / ((1).to_double + (exp (-l_u)))
			else
				l_tmp___0 := exp (l_u)
				l_P___2 := l_tmp___0 / ((1).to_double + (exp (l_u)))
			end
			Result := l_P___2
		end

	gsl_cdf_logistic_Q (a_x, a_a___5: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
			l_u: REAL_64
			l_tmp: REAL_64
		do
			l_u := a_x / a_a___5
			if l_u >= (0).to_double then
				l_tmp := exp (-l_u)
				l_Q___1 := l_tmp / ((1).to_double + (exp (-l_u)))
			else
				l_Q___1 := (1).to_double / ((1).to_double + (exp (l_u)))
			end
			Result := l_Q___1
		end

end
