class
	P_MATHIEU_RADFUNC_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_sf_mathieu_Mc (a_kind, a_order: INTEGER_32; a_qq, a_zz: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_even_odd: INTEGER_32
			l_kk: INTEGER_32
			l_mm: INTEGER_32
			l_status: INTEGER_32
			l_maxerr: REAL_64
			l_amax: REAL_64
			l_pi: REAL_64
			l_fn: REAL_64
			l_factor: REAL_64
			l_coeff: CE_ARRAY [REAL_64]
			l_fc: REAL_64
			l_j1c: REAL_64
			l_z2c: REAL_64
			l_j1pc: REAL_64
			l_z2pc: REAL_64
			l_u1: REAL_64
			l_u2: REAL_64
			l_aa: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp: REAL_64
			l_tmp___1: REAL_64
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_REAL_64_ARRAY} l_coeff.make (<<100>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_aa.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_maxerr := 1.e-14
					l_pi := 3.14159265358979323846
					if a_qq <= 0.0 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("q must be greater than zero"), ce_string ("mathieu_radfunc.c"), 44, 4)
							Result := 4
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (a_kind < 1) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_kind > 2) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("kind must be 1 or 2"), ce_string ("mathieu_radfunc.c"), 48, 4)
							Result := 4
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 6 then -- if done | if done
					if not l_return then
						l_mm := 0
						l_amax := 0.0
						l_fn := 0.0
						l_tmp := sqrt (a_qq)
						l_u1 := l_tmp * (exp (-1.0 * a_zz))
						l_tmp___1 := sqrt (a_qq)
						l_u2 := l_tmp___1 * (exp (a_zz))
						l_even_odd := 0
						if a_order \\ 2 /= 0 then
							l_even_odd := 1
						end
						l_status := (create {P_MATHIEU_CHARV_STATIC}).gsl_sf_mathieu_a (a_order, a_qq, l_aa)
						if l_status /= 0 then
							Result := l_status
							l_return := True
						end
					end
					if not l_return then
						l_status := (create {P_MATHIEU_COEFF_STATIC}).gsl_sf_mathieu_a_coeff (a_order, a_qq, l_aa.item.val, l_coeff)
						if l_status /= 0 then
							Result := l_status
							l_return := True
						end
					end
					if not l_return then
						if l_even_odd = 0 then
							l_kk := 0
							from
							until
								not (not (l_break) and then (l_kk < 100))
							loop
								l_break := False
								if l_amax > (fabs (l_coeff[l_kk])) then
									l_amax := l_amax
								else
									l_amax := (fabs (l_coeff[l_kk]))
								end
								if (fabs (l_coeff[l_kk])) / l_amax < l_maxerr then
									l_break := True
								end
								if not (l_return or l_break) then
									l_j1c := (create {P_BESSEL_JN_STATIC}).gsl_sf_bessel_Jn (l_kk, l_u1)
									if a_kind = 1 then
										l_z2c := (create {P_BESSEL_JN_STATIC}).gsl_sf_bessel_Jn (l_kk, l_u2)
									else
										l_z2c := (create {P_BESSEL_YN_STATIC}).gsl_sf_bessel_Yn (l_kk, l_u2)
									end
									l_fc := (pow (-1.0, 0.5 * a_order.to_double + l_kk.to_double)) * l_coeff[l_kk]
									l_fn := l_fn + ((l_fc * l_j1c) * l_z2c)
									l_kk := l_kk + 1
								end
							end
							l_break := False
							l_fn := l_fn * ((sqrt (l_pi / 2.0)) / l_coeff[0])
						else
							l_kk := 0
							from
							until
								not (not (l_break) and then (l_kk < 100))
							loop
								l_break := False
								if l_amax > (fabs (l_coeff[l_kk])) then
									l_amax := l_amax
								else
									l_amax := (fabs (l_coeff[l_kk]))
								end
								if (fabs (l_coeff[l_kk])) / l_amax < l_maxerr then
									l_break := True
								end
								if not (l_return or l_break) then
									l_j1c := (create {P_BESSEL_JN_STATIC}).gsl_sf_bessel_Jn (l_kk, l_u1)
									l_j1pc := (create {P_BESSEL_JN_STATIC}).gsl_sf_bessel_Jn (l_kk + 1, l_u1)
									if a_kind = 1 then
										l_z2c := (create {P_BESSEL_JN_STATIC}).gsl_sf_bessel_Jn (l_kk, l_u2)
										l_z2pc := (create {P_BESSEL_JN_STATIC}).gsl_sf_bessel_Jn (l_kk + 1, l_u2)
									else
										l_z2c := (create {P_BESSEL_YN_STATIC}).gsl_sf_bessel_Yn (l_kk, l_u2)
										l_z2pc := (create {P_BESSEL_YN_STATIC}).gsl_sf_bessel_Yn (l_kk + 1, l_u2)
									end
									l_fc := (pow (-1.0, 0.5 * (a_order - 1).to_double + l_kk.to_double)) * l_coeff[l_kk]
									l_fn := l_fn + (l_fc * (l_j1c * l_z2pc + l_j1pc * l_z2c))
									l_kk := l_kk + 1
								end
							end
							l_break := False
							l_fn := l_fn * ((sqrt (l_pi / 2.0)) / l_coeff[0])
						end
						a_result.item.val := l_fn
						a_result.item.err := 2.0 * 2.2204460492503131e-16
						l_factor := fabs (l_fn)
						if l_factor > 1.0 then
							a_result.item.err := a_result.item.err * l_factor
						end
						Result := 0
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_mathieu_Ms (a_kind, a_order: INTEGER_32; a_qq, a_zz: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_even_odd: INTEGER_32
			l_kk: INTEGER_32
			l_mm: INTEGER_32
			l_status: INTEGER_32
			l_maxerr: REAL_64
			l_amax: REAL_64
			l_pi: REAL_64
			l_fn: REAL_64
			l_factor: REAL_64
			l_coeff: CE_ARRAY [REAL_64]
			l_fc: REAL_64
			l_j1c: REAL_64
			l_z2c: REAL_64
			l_j1mc: REAL_64
			l_z2mc: REAL_64
			l_j1pc: REAL_64
			l_z2pc: REAL_64
			l_u1: REAL_64
			l_u2: REAL_64
			l_aa: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp: REAL_64
			l_tmp___1: REAL_64
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_REAL_64_ARRAY} l_coeff.make (<<100>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_aa.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_maxerr := 1.e-14
					l_pi := 3.14159265358979323846
					if a_qq <= 0.0 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("q must be greater than zero"), ce_string ("mathieu_radfunc.c"), 150, 4)
							Result := 4
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (a_kind < 1) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_kind > 2) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("kind must be 1 or 2"), ce_string ("mathieu_radfunc.c"), 154, 4)
							Result := 4
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 6 then -- if done | if done
					if not l_return then
						l_mm := 0
						l_amax := 0.0
						l_fn := 0.0
						l_tmp := sqrt (a_qq)
						l_u1 := l_tmp * (exp (-1.0 * a_zz))
						l_tmp___1 := sqrt (a_qq)
						l_u2 := l_tmp___1 * (exp (a_zz))
						l_even_odd := 0
						if a_order \\ 2 /= 0 then
							l_even_odd := 1
						end
						l_status := (create {P_MATHIEU_CHARV_STATIC}).gsl_sf_mathieu_b (a_order, a_qq, l_aa)
						if l_status /= 0 then
							Result := l_status
							l_return := True
						end
					end
					if not l_return then
						l_status := (create {P_MATHIEU_COEFF_STATIC}).gsl_sf_mathieu_b_coeff (a_order, a_qq, l_aa.item.val, l_coeff)
						if l_status /= 0 then
							Result := l_status
							l_return := True
						end
					end
					if not l_return then
						if l_even_odd = 0 then
							l_kk := 0
							from
							until
								not (not (l_break) and then (l_kk < 100))
							loop
								l_break := False
								if l_amax > (fabs (l_coeff[l_kk])) then
									l_amax := l_amax
								else
									l_amax := (fabs (l_coeff[l_kk]))
								end
								if (fabs (l_coeff[l_kk])) / l_amax < l_maxerr then
									l_break := True
								end
								if not (l_return or l_break) then
									l_j1mc := (create {P_BESSEL_JN_STATIC}).gsl_sf_bessel_Jn (l_kk, l_u1)
									l_j1pc := (create {P_BESSEL_JN_STATIC}).gsl_sf_bessel_Jn (l_kk + 2, l_u1)
									if a_kind = 1 then
										l_z2mc := (create {P_BESSEL_JN_STATIC}).gsl_sf_bessel_Jn (l_kk, l_u2)
										l_z2pc := (create {P_BESSEL_JN_STATIC}).gsl_sf_bessel_Jn (l_kk + 2, l_u2)
									else
										l_z2mc := (create {P_BESSEL_YN_STATIC}).gsl_sf_bessel_Yn (l_kk, l_u2)
										l_z2pc := (create {P_BESSEL_YN_STATIC}).gsl_sf_bessel_Yn (l_kk + 2, l_u2)
									end
									l_fc := (pow (-1.0, (0.5 * a_order.to_double + l_kk.to_double) + (1).to_double)) * l_coeff[l_kk]
									l_fn := l_fn + (l_fc * (l_j1mc * l_z2pc - l_j1pc * l_z2mc))
									l_kk := l_kk + 1
								end
							end
							l_break := False
							l_fn := l_fn * ((sqrt (l_pi / 2.0)) / l_coeff[0])
						else
							l_kk := 0
							from
							until
								not (not (l_break) and then (l_kk < 100))
							loop
								l_break := False
								if l_amax > (fabs (l_coeff[l_kk])) then
									l_amax := l_amax
								else
									l_amax := (fabs (l_coeff[l_kk]))
								end
								if (fabs (l_coeff[l_kk])) / l_amax < l_maxerr then
									l_break := True
								end
								if not (l_return or l_break) then
									l_j1c := (create {P_BESSEL_JN_STATIC}).gsl_sf_bessel_Jn (l_kk, l_u1)
									l_j1pc := (create {P_BESSEL_JN_STATIC}).gsl_sf_bessel_Jn (l_kk + 1, l_u1)
									if a_kind = 1 then
										l_z2c := (create {P_BESSEL_JN_STATIC}).gsl_sf_bessel_Jn (l_kk, l_u2)
										l_z2pc := (create {P_BESSEL_JN_STATIC}).gsl_sf_bessel_Jn (l_kk + 1, l_u2)
									else
										l_z2c := (create {P_BESSEL_YN_STATIC}).gsl_sf_bessel_Yn (l_kk, l_u2)
										l_z2pc := (create {P_BESSEL_YN_STATIC}).gsl_sf_bessel_Yn (l_kk + 1, l_u2)
									end
									l_fc := (pow (-1.0, 0.5 * (a_order - 1).to_double + l_kk.to_double)) * l_coeff[l_kk]
									l_fn := l_fn + (l_fc * (l_j1c * l_z2pc - l_j1pc * l_z2c))
									l_kk := l_kk + 1
								end
							end
							l_break := False
							l_fn := l_fn * ((sqrt (l_pi / 2.0)) / l_coeff[0])
						end
						a_result.item.val := l_fn
						a_result.item.err := 2.0 * 2.2204460492503131e-16
						l_factor := fabs (l_fn)
						if l_factor > 1.0 then
							a_result.item.err := a_result.item.err * l_factor
						end
						Result := 0
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
