class
	P_MEDIAN_SOURCE_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_stats_long_double_median_from_sorted_data (a_sorted_data: CE_POINTER [REAL_96]; a_stride, a_n: NATURAL_32): REAL_64
		local
			l_median: REAL_64
			l_lhs: NATURAL_32
			l_rhs: NATURAL_32
			l_return: BOOLEAN
		do
			l_lhs := (a_n - {NATURAL_32} 1) // {NATURAL_32} 2
			l_rhs := a_n // {NATURAL_32} 2
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				if l_lhs = l_rhs then
					l_median := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).truncated_to_real_64
				else
					l_median := ((a_sorted_data[(l_lhs * a_stride).to_integer_32] + a_sorted_data[(l_rhs * a_stride).to_integer_32]) / real_96_from_real_64 (2.0)).truncated_to_real_64
				end
				Result := l_median
			end
		end

	gsl_stats_median_from_sorted_data (a_sorted_data: CE_POINTER [REAL_64]; a_stride, a_n: NATURAL_32): REAL_64
		local
			l_median: REAL_64
			l_lhs: NATURAL_32
			l_rhs: NATURAL_32
			l_return: BOOLEAN
		do
			l_lhs := (a_n - {NATURAL_32} 1) // {NATURAL_32} 2
			l_rhs := a_n // {NATURAL_32} 2
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				if l_lhs = l_rhs then
					l_median := a_sorted_data[(l_lhs * a_stride).to_integer_32]
				else
					l_median := ((a_sorted_data[(l_lhs * a_stride).to_integer_32] + a_sorted_data[(l_rhs * a_stride).to_integer_32]) / 2.0)
				end
				Result := l_median
			end
		end

	gsl_stats_float_median_from_sorted_data (a_sorted_data: CE_POINTER [REAL_32]; a_stride, a_n: NATURAL_32): REAL_64
		local
			l_median: REAL_64
			l_lhs: NATURAL_32
			l_rhs: NATURAL_32
			l_return: BOOLEAN
		do
			l_lhs := (a_n - {NATURAL_32} 1) // {NATURAL_32} 2
			l_rhs := a_n // {NATURAL_32} 2
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				if l_lhs = l_rhs then
					l_median := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_double
				else
					l_median := (a_sorted_data[(l_lhs * a_stride).to_integer_32] + a_sorted_data[(l_rhs * a_stride).to_integer_32]).to_double / 2.0
				end
				Result := l_median
			end
		end

	gsl_stats_ulong_median_from_sorted_data (a_sorted_data: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32): REAL_64
		local
			l_median: REAL_64
			l_lhs: NATURAL_32
			l_rhs: NATURAL_32
			l_return: BOOLEAN
		do
			l_lhs := (a_n - {NATURAL_32} 1) // {NATURAL_32} 2
			l_rhs := a_n // {NATURAL_32} 2
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				if l_lhs = l_rhs then
					l_median := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_real_64
				else
					l_median := (a_sorted_data[(l_lhs * a_stride).to_integer_32] + a_sorted_data[(l_rhs * a_stride).to_integer_32]).to_real_64 / 2.0
				end
				Result := l_median
			end
		end

	gsl_stats_long_median_from_sorted_data (a_sorted_data: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32): REAL_64
		local
			l_median: REAL_64
			l_lhs: NATURAL_32
			l_rhs: NATURAL_32
			l_return: BOOLEAN
		do
			l_lhs := (a_n - {NATURAL_32} 1) // {NATURAL_32} 2
			l_rhs := a_n // {NATURAL_32} 2
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				if l_lhs = l_rhs then
					l_median := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_double
				else
					l_median := (a_sorted_data[(l_lhs * a_stride).to_integer_32] + a_sorted_data[(l_rhs * a_stride).to_integer_32]).to_double / 2.0
				end
				Result := l_median
			end
		end

	gsl_stats_uint_median_from_sorted_data (a_sorted_data: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32): REAL_64
		local
			l_median: REAL_64
			l_lhs: NATURAL_32
			l_rhs: NATURAL_32
			l_return: BOOLEAN
		do
			l_lhs := (a_n - {NATURAL_32} 1) // {NATURAL_32} 2
			l_rhs := a_n // {NATURAL_32} 2
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				if l_lhs = l_rhs then
					l_median := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_real_64
				else
					l_median := (a_sorted_data[(l_lhs * a_stride).to_integer_32] + a_sorted_data[(l_rhs * a_stride).to_integer_32]).to_real_64 / 2.0
				end
				Result := l_median
			end
		end

	gsl_stats_int_median_from_sorted_data (a_sorted_data: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32): REAL_64
		local
			l_median: REAL_64
			l_lhs: NATURAL_32
			l_rhs: NATURAL_32
			l_return: BOOLEAN
		do
			l_lhs := (a_n - {NATURAL_32} 1) // {NATURAL_32} 2
			l_rhs := a_n // {NATURAL_32} 2
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				if l_lhs = l_rhs then
					l_median := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_double
				else
					l_median := (a_sorted_data[(l_lhs * a_stride).to_integer_32] + a_sorted_data[(l_rhs * a_stride).to_integer_32]).to_double / 2.0
				end
				Result := l_median
			end
		end

	gsl_stats_ushort_median_from_sorted_data (a_sorted_data: CE_POINTER [NATURAL_16]; a_stride, a_n: NATURAL_32): REAL_64
		local
			l_median: REAL_64
			l_lhs: NATURAL_32
			l_rhs: NATURAL_32
			l_return: BOOLEAN
		do
			l_lhs := (a_n - {NATURAL_32} 1) // {NATURAL_32} 2
			l_rhs := a_n // {NATURAL_32} 2
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				if l_lhs = l_rhs then
					l_median := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_real_64
				else
					l_median := ((a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_integer_32 + (a_sorted_data[(l_rhs * a_stride).to_integer_32]).to_integer_32).to_double / 2.0
				end
				Result := l_median
			end
		end

	gsl_stats_short_median_from_sorted_data (a_sorted_data: CE_POINTER [INTEGER_16]; a_stride, a_n: NATURAL_32): REAL_64
		local
			l_median: REAL_64
			l_lhs: NATURAL_32
			l_rhs: NATURAL_32
			l_return: BOOLEAN
		do
			l_lhs := (a_n - {NATURAL_32} 1) // {NATURAL_32} 2
			l_rhs := a_n // {NATURAL_32} 2
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				if l_lhs = l_rhs then
					l_median := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_double
				else
					l_median := ((a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_integer_32 + (a_sorted_data[(l_rhs * a_stride).to_integer_32]).to_integer_32).to_double / 2.0
				end
				Result := l_median
			end
		end

	gsl_stats_uchar_median_from_sorted_data (a_sorted_data: CE_POINTER [NATURAL_8]; a_stride, a_n: NATURAL_32): REAL_64
		local
			l_median: REAL_64
			l_lhs: NATURAL_32
			l_rhs: NATURAL_32
			l_return: BOOLEAN
		do
			l_lhs := (a_n - {NATURAL_32} 1) // {NATURAL_32} 2
			l_rhs := a_n // {NATURAL_32} 2
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				if l_lhs = l_rhs then
					l_median := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_real_64
				else
					l_median := ((a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_integer_32 + (a_sorted_data[(l_rhs * a_stride).to_integer_32]).to_integer_32).to_double / 2.0
				end
				Result := l_median
			end
		end

	gsl_stats_char_median_from_sorted_data (a_sorted_data: CE_POINTER [INTEGER_8]; a_stride, a_n: NATURAL_32): REAL_64
		local
			l_median: REAL_64
			l_lhs: NATURAL_32
			l_rhs: NATURAL_32
			l_return: BOOLEAN
		do
			l_lhs := (a_n - {NATURAL_32} 1) // {NATURAL_32} 2
			l_rhs := a_n // {NATURAL_32} 2
			if a_n = {NATURAL_32} 0 then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				if l_lhs = l_rhs then
					l_median := (a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_double
				else
					l_median := ((a_sorted_data[(l_lhs * a_stride).to_integer_32]).to_integer_32 + (a_sorted_data[(l_rhs * a_stride).to_integer_32]).to_integer_32).to_double / 2.0
				end
				Result := l_median
			end
		end

end
