class
	P_MISER_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC
	S_STDLIB_STATIC
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gsl_monte_miser_integrate (a_f: CE_POINTER [PD_GSL_MONTE_FUNCTION_STRUCT]; a_xl, a_xu: CE_POINTER [REAL_64]; a_dim, a_calls: NATURAL_32; a_r___3: CE_POINTER [PD_GSL_RNG]; a_state: CE_POINTER [PD_GSL_MONTE_MISER_STATE]; a_result, a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_state.is_void
		local
			l_calls: NATURAL_32
			l_n: NATURAL_32
			l_estimate_calls: NATURAL_32
			l_calls_l: NATURAL_32
			l_calls_r: NATURAL_32
			l_min_calls: NATURAL_32
			l_i: NATURAL_32
			l_i_bisect: NATURAL_32
			l_found_best: INTEGER_32
			l_res_est: CE_ARRAY [REAL_64]
			l_err_est: CE_ARRAY [REAL_64]
			l_res_r: CE_ARRAY [REAL_64]
			l_err_r: CE_ARRAY [REAL_64]
			l_res_l: CE_ARRAY [REAL_64]
			l_err_l: CE_ARRAY [REAL_64]
			l_xbi_l: REAL_64
			l_xbi_m: REAL_64
			l_xbi_r: REAL_64
			l_s: REAL_64
			l_vol: REAL_64
			l_weight_l: REAL_64
			l_weight_r: REAL_64
			l_x: CE_POINTER [REAL_64]
			l_xmid: CE_POINTER [REAL_64]
			l_sigma_l: CE_POINTER [REAL_64]
			l_sigma_r: CE_POINTER [REAL_64]
			l_m___4: REAL_64
			l_q___3: REAL_64
			l_fval: REAL_64
			l_d: REAL_64
			l_best_var: REAL_64
			l_beta: REAL_64
			l_var: REAL_64
			l_tmp___4: REAL_64
			l_fraction_l: REAL_64
			l_fraction_r: REAL_64
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_status: INTEGER_32
			l_xu_tmp: CE_POINTER [REAL_64]
			l_status___0: INTEGER_32
			l_xl_tmp: CE_POINTER [REAL_64]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_REAL_64_ARRAY} l_res_est.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_err_est.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_res_r.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_err_r.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_res_l.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_err_l.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_calls := a_calls
					l_min_calls := a_state.item.min_calls
					l_res_est.item := (0).to_double
					l_err_est.item := (0).to_double
					l_res_r.item := (0).to_double
					l_err_r.item := (0).to_double
					l_res_l.item := (0).to_double
					l_err_l.item := (0).to_double
					l_x := a_state.item.x
					l_xmid := a_state.item.xmid
					l_sigma_l := a_state.item.sigma_l
					l_sigma_r := a_state.item.sigma_r
					if a_dim /= a_state.item.dim then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("number of dimensions must match allocated size"), ce_string ("miser.c"), 79, 4)
							Result := 4
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_i < a_dim))
						loop
							if a_xu[l_i.to_integer_32] <= a_xl[l_i.to_integer_32] then
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_ERROR_STATIC}).gsl_error (ce_string ("xu must be greater than xl"), ce_string ("miser.c"), 86, 4)
									Result := 4
									l_return := True
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							end
							if not l_return and then (a_xu[l_i.to_integer_32] - a_xl[l_i.to_integer_32] > 1.7976931348623157e+308) then
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_ERROR_STATIC}).gsl_error (ce_string ("Range of integration is too large, please rescale"), ce_string ("miser.c"), 92, 4)
									Result := 4
									l_return := True
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							end
							if not l_return then
								l_i := l_i + 1
							end
						end
					end
					if not l_return and then (a_state.item.alpha < (0).to_double) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("alpha must be non-negative"), ce_string ("miser.c"), 98, 4)
							Result := 4
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_vol := (1).to_double
						l_i := (0).to_natural_32
						from
						until
							not (l_i < a_dim)
						loop
							l_vol := l_vol * (a_xu[l_i.to_integer_32] - a_xl[l_i.to_integer_32])
							l_i := l_i + 1
						end
						if l_calls < a_state.item.min_calls_per_bisection then
							l_m___4 := 0.0
							l_q___3 := 0.0
							if l_calls < {NATURAL_32} 2 then
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_ERROR_STATIC}).gsl_error (ce_string ("insufficient calls for subvolume"), ce_string ("miser.c"), 116, 5)
									Result := 5
									l_return := True
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							end
							if not l_return then
								l_n := (0).to_natural_32
								from
								until
									not (not (l_return) and then (l_n < l_calls))
								loop
									l_i := (0).to_natural_32
									from
									until
										not (l_i < a_dim)
									loop
										l_x[l_i.to_integer_32] := (a_xl[l_i.to_integer_32] + ((a_r___3.item.gsl_rng_uniform_pos) * (a_xu[l_i.to_integer_32] - a_xl[l_i.to_integer_32])))
										l_i := l_i + 1
									end
									l_fval := ((a_f.item.f).real_64_item ([l_x, a_f.item.dim, a_f.item.params]))
									l_d := l_fval - l_m___4
									l_m___4 := l_m___4 + (l_d / (l_n.to_real_64 + 1.0))
									l_q___3 := l_q___3 + ((l_d * l_d) * (l_n.to_real_64 / (l_n.to_real_64 + 1.0)))
									l_n := l_n + 1
								end
								a_result.item := l_vol * l_m___4
								a_abserr.item := l_vol * (sqrt (l_q___3 / (l_calls.to_real_64 * (l_calls.to_real_64 - 1.0))))
								Result := 0
								l_return := True
							end
						end
					end
					if not l_return then
						if l_min_calls.to_real_64 > l_calls.to_real_64 * a_state.item.estimate_frac then
							l_estimate_calls := l_min_calls
						else
							l_estimate_calls := (l_calls.to_real_64 * a_state.item.estimate_frac).truncated_to_integer_64.to_natural_32
						end
						if l_estimate_calls < {NATURAL_32} 4 * a_dim then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("insufficient calls to sample all halfspaces"), ce_string ("miser.c"), 150, 7)
								Result := 7
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						l_i := (0).to_natural_32
						from
						until
							not (l_i < a_dim)
						loop
							if (a_r___3.item.gsl_rng_uniform) - 0.5 >= 0.0 then
								l_s := a_state.item.dither
							else
								l_s := -a_state.item.dither
							end
							a_state.item.xmid[l_i.to_integer_32] := (0.5 + l_s) * a_xl[l_i.to_integer_32] + (0.5 - l_s) * a_xu[l_i.to_integer_32]
							l_i := l_i + 1
						end
						estimate_corrmc (a_f, a_xl, a_xu, a_dim, l_estimate_calls, a_r___3, a_state, l_res_est, l_err_est, l_xmid, l_sigma_l, l_sigma_r).do_nothing
						l_calls := l_calls - l_estimate_calls
						l_best_var := 1.7976931348623157e+308
						l_beta := 2.0 / (1.0 + a_state.item.alpha)
						l_found_best := 0
						l_i_bisect := (0).to_natural_32
						l_weight_r := 1.0
						l_weight_l := l_weight_r
						l_i := (0).to_natural_32
				when 2 then -- loop condition:
						if not (not (l_return) and then (l_i < a_dim)) then
							l_pos := -1 + 8 -- skip loop
						end
				when 3 then -- loop body:
						if not (l_sigma_l[l_i.to_integer_32] >= (0).to_double) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_sigma_r[l_i.to_integer_32] >= (0).to_double then
							l_tmp___4 := pow (l_sigma_l[l_i.to_integer_32], l_beta)
							l_var := l_tmp___4 + (pow (l_sigma_r[l_i.to_integer_32], l_beta))
							if l_var <= l_best_var then
								l_found_best := 1
								l_best_var := l_var
								l_i_bisect := l_i
								l_weight_l := pow (l_sigma_l[l_i.to_integer_32], l_beta)
								l_weight_r := pow (l_sigma_r[l_i.to_integer_32], l_beta)
								if l_weight_l = (0).to_double then
									if l_weight_r = (0).to_double then
										l_weight_l := (1).to_double
										l_weight_r := (1).to_double
									end
								end
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if l_sigma_l[l_i.to_integer_32] < (0).to_double then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("no points in left-half space!"), ce_string ("miser.c"), 209, 7)
								Result := 7
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
						if not l_return and then (l_sigma_r[l_i.to_integer_32] < (0).to_double) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("no points in right-half space!"), ce_string ("miser.c"), 213, 7)
								Result := 7
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
				when 7 then
						if not l_return then
							l_i := l_i + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 8 then -- loop done | if done
					if not l_return then
						if not l_found_best.to_boolean then
							l_i_bisect := (a_r___3.item.gsl_rng_uniform_int (a_dim.to_natural_32)).to_natural_32
						end
						l_xbi_l := a_xl[l_i_bisect.to_integer_32]
						l_xbi_m := l_xmid[l_i_bisect.to_integer_32]
						l_xbi_r := a_xu[l_i_bisect.to_integer_32]
						l_fraction_l := (fabs ((l_xbi_m - l_xbi_l) / (l_xbi_r - l_xbi_l)))
						l_fraction_r := (1).to_double - l_fraction_l
						l_a___5 := l_fraction_l * l_weight_l
						l_b___0 := l_fraction_r * l_weight_r
						l_calls_l := (l_min_calls.to_real_64 + ((l_calls - {NATURAL_32} 2 * l_min_calls).to_real_64 * l_a___5) / (l_a___5 + l_b___0)).truncated_to_integer_64.to_natural_32
						l_calls_r := (l_min_calls.to_real_64 + ((l_calls - {NATURAL_32} 2 * l_min_calls).to_real_64 * l_b___0) / (l_a___5 + l_b___0)).truncated_to_integer_64.to_natural_32
						l_xu_tmp := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
						if l_xu_tmp.is_void then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("out of memory for left workspace"), ce_string ("miser.c"), 256, 8)
								Result := 0
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_i := (0).to_natural_32
						from
						until
							not (l_i < a_dim)
						loop
							l_xu_tmp[l_i.to_integer_32] := a_xu[l_i.to_integer_32]
							l_i := l_i + 1
						end
						l_xu_tmp[l_i_bisect.to_integer_32] := l_xbi_m
						l_status := gsl_monte_miser_integrate (a_f, a_xl, l_xu_tmp, a_dim, l_calls_l, a_r___3, a_state, l_res_l, l_err_l)
						free (create {CE_VOID_POINTER}.make_cast (l_xu_tmp))
						if l_status /= 0 then
							Result := l_status
							l_return := True
						end
					end
					if not l_return then
						l_xl_tmp := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
						if l_xl_tmp.is_void then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("out of memory for right workspace"), ce_string ("miser.c"), 286, 8)
								Result := 0
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_i := (0).to_natural_32
						from
						until
							not (l_i < a_dim)
						loop
							l_xl_tmp[l_i.to_integer_32] := a_xl[l_i.to_integer_32]
							l_i := l_i + 1
						end
						l_xl_tmp[l_i_bisect.to_integer_32] := l_xbi_m
						l_status___0 := gsl_monte_miser_integrate (a_f, l_xl_tmp, a_xu, a_dim, l_calls_r, a_r___3, a_state, l_res_r, l_err_r)
						free (create {CE_VOID_POINTER}.make_cast (l_xl_tmp))
						if l_status___0 /= 0 then
							Result := l_status___0
							l_return := True
						end
					end
					if not l_return then
						a_result.item := l_res_l.item + l_res_r.item
						a_abserr.item := sqrt (l_err_l.item * l_err_l.item + l_err_r.item * l_err_r.item)
						Result := 0
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_monte_miser_alloc (a_dim: NATURAL_32): CE_POINTER [PD_GSL_MONTE_MISER_STATE]
		local
			l_s: CE_POINTER [PD_GSL_MONTE_MISER_STATE]
			l_return, l_break: BOOLEAN
		do
			l_s := create {CE_CLASS_POINTER [PD_GSL_MONTE_MISER_STATE]}.make_cast ((malloc ((create {PD_GSL_MONTE_MISER_STATE}.make).structure_size.to_natural_32)))
			if l_s.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for miser state struct"), ce_string ("miser.c"), 322, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MONTE_MISER_STATE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s.item.x := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_s.item.x).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for x"), ce_string ("miser.c"), 330, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MONTE_MISER_STATE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.xmid := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_s.item.xmid).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.x))
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for xmid"), ce_string ("miser.c"), 339, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MONTE_MISER_STATE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.sigma_l := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_s.item.sigma_l).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.xmid))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.x))
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for sigma_l"), ce_string ("miser.c"), 349, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MONTE_MISER_STATE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.sigma_r := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_s.item.sigma_r).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.xmid))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.x))
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for sigma_r"), ce_string ("miser.c"), 360, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MONTE_MISER_STATE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.fmax_l := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_s.item.fmax_l).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.xmid))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.x))
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for fmax_l"), ce_string ("miser.c"), 372, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MONTE_MISER_STATE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.fmax_r := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_s.item.fmax_r).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.xmid))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.x))
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for fmax_r"), ce_string ("miser.c"), 385, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MONTE_MISER_STATE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.fmin_l := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_s.item.fmin_l).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.xmid))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.x))
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for fmin_l"), ce_string ("miser.c"), 399, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MONTE_MISER_STATE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.fmin_r := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_s.item.fmin_r).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmin_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.xmid))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.x))
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for fmin_r"), ce_string ("miser.c"), 414, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MONTE_MISER_STATE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.fsum_l := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_s.item.fsum_l).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmin_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmin_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.xmid))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.x))
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for fsum_l"), ce_string ("miser.c"), 430, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MONTE_MISER_STATE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.fsum_r := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_s.item.fsum_r).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fsum_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmin_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmin_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.xmid))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.x))
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for fsum_r"), ce_string ("miser.c"), 447, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MONTE_MISER_STATE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.fsum2_l := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_s.item.fsum2_l).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fsum_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fsum_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmin_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmin_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.xmid))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.x))
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for fsum2_l"), ce_string ("miser.c"), 465, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MONTE_MISER_STATE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.fsum2_r := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_s.item.fsum2_r).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fsum2_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fsum_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fsum_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmin_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmin_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.xmid))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.x))
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for fsum2_r"), ce_string ("miser.c"), 484, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MONTE_MISER_STATE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.hits_r := create {CE_NATURAL_32_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Natural_32_bytes.to_natural_32)))
				if (l_s.item.hits_r).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fsum2_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fsum2_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fsum_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fsum_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmin_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmin_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.xmid))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.x))
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for fsum2_r"), ce_string ("miser.c"), 505, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MONTE_MISER_STATE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.hits_l := create {CE_NATURAL_32_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Natural_32_bytes.to_natural_32)))
				if (l_s.item.hits_l).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.hits_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fsum2_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fsum2_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fsum_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fsum_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmin_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmin_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.fmax_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_r))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.sigma_l))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.xmid))
					free (create {CE_VOID_POINTER}.make_cast (l_s.item.x))
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for fsum2_r"), ce_string ("miser.c"), 526, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MONTE_MISER_STATE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.dim := a_dim
				l_s.item.gsl_monte_miser_init.do_nothing
				Result := l_s
			end
		end

	gsl_monte_miser_free (a_s: CE_POINTER [PD_GSL_MONTE_MISER_STATE])
		local
			l_return: BOOLEAN
		do
			if a_s.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_s.item.hits_r))
				free (create {CE_VOID_POINTER}.make_cast (a_s.item.hits_l))
				free (create {CE_VOID_POINTER}.make_cast (a_s.item.fsum2_r))
				free (create {CE_VOID_POINTER}.make_cast (a_s.item.fsum2_l))
				free (create {CE_VOID_POINTER}.make_cast (a_s.item.fsum_r))
				free (create {CE_VOID_POINTER}.make_cast (a_s.item.fsum_l))
				free (create {CE_VOID_POINTER}.make_cast (a_s.item.fmin_r))
				free (create {CE_VOID_POINTER}.make_cast (a_s.item.fmin_l))
				free (create {CE_VOID_POINTER}.make_cast (a_s.item.fmax_r))
				free (create {CE_VOID_POINTER}.make_cast (a_s.item.fmax_l))
				free (create {CE_VOID_POINTER}.make_cast (a_s.item.sigma_r))
				free (create {CE_VOID_POINTER}.make_cast (a_s.item.sigma_l))
				free (create {CE_VOID_POINTER}.make_cast (a_s.item.xmid))
				free (create {CE_VOID_POINTER}.make_cast (a_s.item.x))
				free (create {CE_VOID_POINTER}.make_cast (a_s))
			end
		end

	estimate_corrmc (a_f: CE_POINTER [PD_GSL_MONTE_FUNCTION_STRUCT]; a_xl, a_xu: CE_POINTER [REAL_64]; a_dim, a_calls: NATURAL_32; a_r___3: CE_POINTER [PD_GSL_RNG]; a_state: CE_POINTER [PD_GSL_MONTE_MISER_STATE]; a_result, a_abserr, a_xmid, a_sigma_l, a_sigma_r: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_state.is_void
			not a_result.is_void
			not a_abserr.is_void
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_x: CE_POINTER [REAL_64]
			l_fsum_l: CE_POINTER [REAL_64]
			l_fsum_r: CE_POINTER [REAL_64]
			l_fsum2_l: CE_POINTER [REAL_64]
			l_fsum2_r: CE_POINTER [REAL_64]
			l_hits_l: CE_POINTER [NATURAL_32]
			l_hits_r: CE_POINTER [NATURAL_32]
			l_m___4: REAL_64
			l_q___3: REAL_64
			l_vol: REAL_64
			l_tmp: NATURAL_32
			l_tmp___0: REAL_64
			l_tmp___1: REAL_64
			l_tmp___2: REAL_64
			l_fval: REAL_64
			l_j: NATURAL_32
			l_side: NATURAL_32
			l_z: REAL_64
			l_d: REAL_64
			l_fraction_l: REAL_64
			l_return: BOOLEAN
		do
			l_x := a_state.item.x
			l_fsum_l := a_state.item.fsum_l
			l_fsum_r := a_state.item.fsum_r
			l_fsum2_l := a_state.item.fsum2_l
			l_fsum2_r := a_state.item.fsum2_r
			l_hits_l := a_state.item.hits_l
			l_hits_r := a_state.item.hits_r
			l_m___4 := 0.0
			l_q___3 := 0.0
			l_vol := 1.0
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_dim)
			loop
				l_vol := l_vol * (a_xu[l_i.to_integer_32] - a_xl[l_i.to_integer_32])
				l_tmp := (0).to_natural_32
				l_hits_r[l_i.to_integer_32] := l_tmp
				l_hits_l[l_i.to_integer_32] := l_tmp
				l_tmp___0 := 0.0
				l_fsum_r[l_i.to_integer_32] := l_tmp___0
				l_fsum_l[l_i.to_integer_32] := l_tmp___0
				l_tmp___1 := 0.0
				l_fsum2_r[l_i.to_integer_32] := l_tmp___1
				l_fsum2_l[l_i.to_integer_32] := l_tmp___1
				l_tmp___2 := (-1).to_double
				a_sigma_r[l_i.to_integer_32] := l_tmp___2
				a_sigma_l[l_i.to_integer_32] := l_tmp___2
				l_i := l_i + 1
			end
			l_n := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_n < a_calls))
			loop
				l_j := (l_n // {NATURAL_32} 2) \\ a_dim
				l_side := l_n \\ {NATURAL_32} 2
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_z := (a_r___3.item.gsl_rng_uniform_pos)
					if l_i /= l_j then
						l_x[l_i.to_integer_32] := (a_xl[l_i.to_integer_32] + (l_z * (a_xu[l_i.to_integer_32] - a_xl[l_i.to_integer_32])))
					elseif l_side = {NATURAL_32} 0 then
						l_x[l_i.to_integer_32] := (a_xmid[l_i.to_integer_32] + (l_z * (a_xu[l_i.to_integer_32] - a_xmid[l_i.to_integer_32])))
					else
						l_x[l_i.to_integer_32] := (a_xl[l_i.to_integer_32] + (l_z * (a_xmid[l_i.to_integer_32] - a_xl[l_i.to_integer_32])))
					end
					l_i := l_i + 1
				end
				l_fval := (a_f.item.f).real_64_item ([l_x, a_f.item.dim, a_f.item.params])
				l_d := l_fval - l_m___4
				l_m___4 := l_m___4 + (l_d / (l_n.to_real_64 + 1.0))
				l_q___3 := l_q___3 + ((l_d * l_d) * (l_n.to_real_64 / (l_n.to_real_64 + 1.0)))
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					if l_x[l_i.to_integer_32] <= a_xmid[l_i.to_integer_32] then
						l_fsum_l[l_i.to_integer_32] := l_fsum_l[l_i.to_integer_32] + l_fval
						l_fsum2_l[l_i.to_integer_32] := l_fsum2_l[l_i.to_integer_32] + (l_fval * l_fval)
						l_hits_l[l_i.to_integer_32] := (l_hits_l[l_i.to_integer_32]) + 1
					else
						l_fsum_r[l_i.to_integer_32] := l_fsum_r[l_i.to_integer_32] + l_fval
						l_fsum2_r[l_i.to_integer_32] := l_fsum2_r[l_i.to_integer_32] + (l_fval * l_fval)
						l_hits_r[l_i.to_integer_32] := (l_hits_r[l_i.to_integer_32]) + 1
					end
					l_i := l_i + 1
				end
				l_n := l_n + 1
			end
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_dim)
			loop
				l_fraction_l := ((a_xmid[l_i.to_integer_32] - a_xl[l_i.to_integer_32]) / (a_xu[l_i.to_integer_32] - a_xl[l_i.to_integer_32]))
				if l_hits_l[l_i.to_integer_32] > {NATURAL_32} 0 then
					l_fsum_l[l_i.to_integer_32] := l_fsum_l[l_i.to_integer_32] / (l_hits_l[l_i.to_integer_32]).to_real_64
					a_sigma_l[l_i.to_integer_32] := sqrt (l_fsum2_l[l_i.to_integer_32] - (l_fsum_l[l_i.to_integer_32] * l_fsum_l[l_i.to_integer_32]) / (l_hits_l[l_i.to_integer_32]).to_real_64)
					a_sigma_l[l_i.to_integer_32] := a_sigma_l[l_i.to_integer_32] * ((l_fraction_l * l_vol) / (l_hits_l[l_i.to_integer_32]).to_real_64)
				end
				if l_hits_r[l_i.to_integer_32] > {NATURAL_32} 0 then
					l_fsum_r[l_i.to_integer_32] := l_fsum_r[l_i.to_integer_32] / (l_hits_r[l_i.to_integer_32]).to_real_64
					a_sigma_r[l_i.to_integer_32] := sqrt (l_fsum2_r[l_i.to_integer_32] - (l_fsum_r[l_i.to_integer_32] * l_fsum_r[l_i.to_integer_32]) / (l_hits_r[l_i.to_integer_32]).to_real_64)
					a_sigma_r[l_i.to_integer_32] := a_sigma_r[l_i.to_integer_32] * ((((1).to_double - l_fraction_l) * l_vol) / (l_hits_r[l_i.to_integer_32]).to_real_64)
				end
				l_i := l_i + 1
			end
			a_result.item := l_vol * l_m___4
			if a_calls < {NATURAL_32} 2 then
				a_abserr.item := (builtin_inff).to_double
			else
				a_abserr.item := l_vol * (sqrt (l_q___3 / (a_calls.to_real_64 * (a_calls.to_real_64 - 1.0))))
			end
			Result := 0
		end

end
