class
	P_NBINOMIAL_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gsl_ran_negative_binomial_pdf (a_k: NATURAL_32; a_p, a_n: REAL_64): REAL_64
		local
			l_P___2: REAL_64
			l_f: REAL_64
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_tmp___2: REAL_64
			l_tmp___3: REAL_64
		do
			l_f := ((create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_k.to_real_64 + a_n))
			l_a___5 := ((create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_n))
			l_b___0 := ((create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_k.to_real_64 + 1.0))
			l_tmp___2 := exp ((l_f - l_a___5) - l_b___0)
			l_tmp___3 := pow (a_p, a_n)
			l_P___2 := (l_tmp___2 * l_tmp___3) * (pow ((1).to_double - a_p, a_k.to_real_64))
			Result := l_P___2
		end

	gsl_cdf_negative_binomial_P (a_k: NATURAL_32; a_p, a_n: REAL_64): REAL_64
		local
			l_P___2: REAL_64
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_p > 1.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_p < 0.0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("p < 0 or p > 1"), ce_string ("nbinomial.c"), 42, 1)
							Result := (builtin_nanf (ce_string (""))).to_double
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if done
					if not l_return and then (a_n < (0).to_double) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("n < 0"), ce_string ("nbinomial.c"), 47, 1)
							Result := (builtin_nanf (ce_string (""))).to_double
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_a___5 := a_n
						l_b___0 := a_k.to_real_64 + 1.0
						l_P___2 := (create {P_BETA_STATIC}).gsl_cdf_beta_P (a_p, l_a___5, l_b___0)
						Result := l_P___2
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_cdf_negative_binomial_Q (a_k: NATURAL_32; a_p, a_n: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_p > 1.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_p < 0.0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("p < 0 or p > 1"), ce_string ("nbinomial.c"), 70, 1)
							Result := (builtin_nanf (ce_string (""))).to_double
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if done
					if not l_return and then (a_n < (0).to_double) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("n < 0"), ce_string ("nbinomial.c"), 75, 1)
							Result := (builtin_nanf (ce_string (""))).to_double
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_a___5 := a_n
						l_b___0 := a_k.to_real_64 + 1.0
						l_Q___1 := (create {P_BETA_STATIC}).gsl_cdf_beta_Q (a_p, l_a___5, l_b___0)
						Result := l_Q___1
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
