class
	P_NEWTON_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	newton_type: CE_STATIC [CE_ARRAY [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]}.make_initialized (<<
					create {PD_GSL_MULTIROOT_FDFSOLVER_TYPE}.make_initialized ([ce_string ("newton"), (create {PD_NEWTON_STATE_T}.make).structure_size.to_natural_32, newton_alloc_address, (create {PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT_STATIC}).newton_set_address, (create {PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT_STATIC}).newton_iterate_address, newton_free_address])
				>>)
		end

	gsl_multiroot_fdfsolver_newton: CE_STATIC [CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := newton_type.item
		end

	newton_type___0: CE_STATIC [CE_ARRAY [PD_GSL_ROOT_FDFSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_ROOT_FDFSOLVER_TYPE]}.make_initialized (<<
					create {PD_GSL_ROOT_FDFSOLVER_TYPE}.make_initialized ([ce_string ("newton"), (create {PD_NEWTON_STATE_T2}.make).structure_size.to_natural_32, (create {PD_GSL_FUNCTION_FDF_STRUCT_STATIC}).newton_init_address, newton_iterate___0_address])
				>>)
		end

	gsl_root_fdfsolver_newton: CE_STATIC [CE_POINTER [PD_GSL_ROOT_FDFSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := newton_type___0.item
		end

feature {ANY} -- public routines

	newton_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_NEWTON_STATE_T]
			l_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX]
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_NEWTON_STATE_T]}.make_cast (a_vstate)
			l_m___4 := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_calloc (a_n, a_n)
			if l_m___4.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for lu"), ce_string ("newton.c"), 56, 8)
					Result := 8
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.lu := l_m___4
				l_p := (create {P_INIT_STATIC}).gsl_permutation_calloc (a_n)
				if l_p.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_m___4)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for permutation"), ce_string ("newton.c"), 67, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.permutation := l_p
				Result := 0
			end
		end

	newton_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_NEWTON_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_NEWTON_STATE_T]}.make_cast (a_vstate);
			(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_state.item.lu);
			(create {P_INIT_STATIC}).gsl_permutation_free (l_state.item.permutation)
		end

	newton_iterate___0 (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_FUNCTION_FDF_STRUCT]; a_root: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_NEWTON_STATE_T2]
			l_root_new: REAL_64
			l_f_new: CE_ARRAY [REAL_64]
			l_df_new: CE_ARRAY [REAL_64]
			l_return, l_break: BOOLEAN
		do
			create {CE_REAL_64_ARRAY} l_f_new.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_df_new.make (<<1>>)

			l_state := create {CE_CLASS_POINTER [PD_NEWTON_STATE_T2]}.make_cast (a_vstate)
			if l_state.item.df = 0.0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("derivative is zero"), ce_string ("newton.c"), 74, 12)
					Result := 12
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_root_new := a_root.item - l_state.item.f / l_state.item.df
				a_root.item := l_root_new;
				(a_fdf.item.fdf).call ([l_root_new, a_fdf.item.params, l_f_new, l_df_new])
				l_state.item.f := l_f_new.item
				l_state.item.df := l_df_new.item
				if not ((create {P_INFNAN_STATIC}).gsl_finite (l_f_new.item)).to_boolean then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("function value is not finite"), ce_string ("newton.c"), 88, 9)
						Result := 9
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				if not ((create {P_INFNAN_STATIC}).gsl_finite (l_df_new.item)).to_boolean then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("derivative value is not finite"), ce_string ("newton.c"), 93, 9)
						Result := 9
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

feature {ANY} -- routine addresses

	newton_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent newton_alloc)
		end

	newton_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent newton_free)
		end

	newton_iterate___0_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent newton_iterate___0)
		end

end
