class
	P_NONSYMMV_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_eigen_nonsymmv_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_n = {NATURAL_32} 0 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension must be positive integer"), ce_string ("nonsymmv.c"), 73, 4)
							Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE]}.make_shared (default_pointer))
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_w := create {CE_CLASS_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE]}.make_cast ((calloc ((1).to_natural_32, (create {PD_GSL_EIGEN_NONSYMMV_WORKSPACE}.make).structure_size.to_natural_32)))
						if l_w.is_void then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for workspace"), ce_string ("nonsymmv.c"), 81, 8)
								Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE]}.make_shared (default_pointer))
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_w.item.size := a_n
						l_w.item.Z := create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
						l_w.item.nonsymm_workspace_p := (create {P_NONSYMM_STATIC}).gsl_eigen_nonsymm_alloc (a_n)
						if (l_w.item.nonsymm_workspace_p).is_void then
							gsl_eigen_nonsymmv_free (l_w)
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for nonsymm workspace"), ce_string ("nonsymmv.c"), 91, 8)
								Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE]}.make_shared (default_pointer))
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:;
						(l_w.item.nonsymm_workspace_p).item.gsl_eigen_nonsymm_params (1, 1)
						l_w.item.work := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_n)
						l_w.item.work2 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_n)
						l_w.item.work3 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_n)
						if not ((l_w.item.work).is_void) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 4 then -- else:
						if not ((l_w.item.work2).is_void) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if not ((l_w.item.work3).is_void) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						gsl_eigen_nonsymmv_free (l_w)
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for nonsymmv additional workspace"), ce_string ("nonsymmv.c"), 106, 8)
							Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE]}.make_shared (default_pointer))
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 9 then -- if done | if done | if done
					if not l_return then
						Result := l_w
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_eigen_nonsymmv_free (a_w: CE_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE])
		local
			l_return: BOOLEAN
		do
			if a_w.is_void then
				l_return := True
			end
			if not l_return then
				if (not (a_w.item.nonsymm_workspace_p).is_void) then
					(create {P_NONSYMM_STATIC}).gsl_eigen_nonsymm_free (a_w.item.nonsymm_workspace_p)
				end
				if (not (a_w.item.work).is_void) then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_w.item.work)
				end
				if (not (a_w.item.work2).is_void) then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_w.item.work2)
				end
				if (not (a_w.item.work3).is_void) then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_w.item.work3)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_w))
			end
		end

end
