class
	P_NTUPLE_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STDIO_STATIC

feature {ANY} -- public routines

	gsl_ntuple_create (a_filename: CE_POINTER [INTEGER_8]; a_ntuple_data: CE_POINTER [ANY]; a_size: NATURAL_32): CE_POINTER [PD_GSL_NTUPLE]
		local
			l_ntuple: CE_POINTER [PD_GSL_NTUPLE]
			l_return, l_break: BOOLEAN
		do
			l_ntuple := create {CE_CLASS_POINTER [PD_GSL_NTUPLE]}.make_cast ((malloc ((create {PD_GSL_NTUPLE}.make).structure_size.to_natural_32)))
			if l_ntuple.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for ntuple struct"), ce_string ("ntuple.c"), 40, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_NTUPLE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_ntuple.item.ntuple_data := a_ntuple_data
				l_ntuple.item.size := a_size
				l_ntuple.item.file := fopen (a_filename, ce_string ("wb"))
				if (l_ntuple.item.file).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_ntuple))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("unable to create ntuple file"), ce_string ("ntuple.c"), 51, 5)
						Result := (create {CE_CLASS_POINTER [PD_GSL_NTUPLE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := l_ntuple
			end
		end

	gsl_ntuple_open (a_filename: CE_POINTER [INTEGER_8]; a_ntuple_data: CE_POINTER [ANY]; a_size: NATURAL_32): CE_POINTER [PD_GSL_NTUPLE]
		local
			l_ntuple: CE_POINTER [PD_GSL_NTUPLE]
			l_return, l_break: BOOLEAN
		do
			l_ntuple := create {CE_CLASS_POINTER [PD_GSL_NTUPLE]}.make_cast ((malloc ((create {PD_GSL_NTUPLE}.make).structure_size.to_natural_32)))
			if l_ntuple.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for ntuple struct"), ce_string ("ntuple.c"), 70, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_NTUPLE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_ntuple.item.ntuple_data := a_ntuple_data
				l_ntuple.item.size := a_size
				l_ntuple.item.file := fopen (a_filename, ce_string ("rb"))
				if (l_ntuple.item.file).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_ntuple))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("unable to open ntuple file for reading"), ce_string ("ntuple.c"), 82, 5)
						Result := (create {CE_CLASS_POINTER [PD_GSL_NTUPLE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := l_ntuple
			end
		end

	gsl_ntuple_project (a_h: CE_POINTER [PD_GSL_HISTOGRAM]; a_ntuple: CE_POINTER [PD_GSL_NTUPLE]; a_value_func: CE_POINTER [PD_GSL_NTUPLE_VALUE_FN]; a_select_func: CE_POINTER [PD_GSL_NTUPLE_SELECT_FN]): INTEGER_32
		require
			not a_ntuple.is_void
		local
			l_nread: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_nread := fread (a_ntuple.item.ntuple_data, a_ntuple.item.size, (1).to_natural_32, a_ntuple.item.file)
				if l_nread = {NATURAL_32} 0 then
					if (feof (a_ntuple.item.file)).to_boolean then
						l_break := True
					end
				end
				if not (l_return or l_break) then
					if l_nread /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to read ntuple for projection"), ce_string ("ntuple.c"), 170, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						if ((a_select_func.item.function).integer_32_item ([a_ntuple.item.ntuple_data, a_select_func.item.params])).to_boolean then
							a_h.item.gsl_histogram_increment (((a_value_func.item.function).real_64_item ([a_ntuple.item.ntuple_data, a_value_func.item.params]))).do_nothing
						end
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 0
			end
		end

end
