class
	P_P_VARIANCE_SOURCE_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_stats_long_double_pvariance (a_data1: CE_POINTER [REAL_96]; a_stride1, a_n1: NATURAL_32; a_data2: CE_POINTER [REAL_96]; a_stride2, a_n2: NATURAL_32): REAL_64
		local
			l_var1: REAL_64
			l_var2: REAL_64
			l_pooled_variance: REAL_64
		do
			l_var1 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_long_double_variance (a_data1, a_stride1, a_n1))
			l_var2 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_long_double_variance (a_data2, a_stride2, a_n2))
			l_pooled_variance := ((a_n1 - {NATURAL_32} 1).to_real_64 * l_var1 + (a_n2 - {NATURAL_32} 1).to_real_64 * l_var2) / ((a_n1 + a_n2) - {NATURAL_32} 2).to_real_64
			Result := l_pooled_variance
		end

	gsl_stats_pvariance (a_data1: CE_POINTER [REAL_64]; a_stride1, a_n1: NATURAL_32; a_data2: CE_POINTER [REAL_64]; a_stride2, a_n2: NATURAL_32): REAL_64
		local
			l_var1: REAL_64
			l_var2: REAL_64
			l_pooled_variance: REAL_64
		do
			l_var1 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_variance (a_data1, a_stride1, a_n1))
			l_var2 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_variance (a_data2, a_stride2, a_n2))
			l_pooled_variance := ((a_n1 - {NATURAL_32} 1).to_real_64 * l_var1 + (a_n2 - {NATURAL_32} 1).to_real_64 * l_var2) / ((a_n1 + a_n2) - {NATURAL_32} 2).to_real_64
			Result := l_pooled_variance
		end

	gsl_stats_float_pvariance (a_data1: CE_POINTER [REAL_32]; a_stride1, a_n1: NATURAL_32; a_data2: CE_POINTER [REAL_32]; a_stride2, a_n2: NATURAL_32): REAL_64
		local
			l_var1: REAL_64
			l_var2: REAL_64
			l_pooled_variance: REAL_64
		do
			l_var1 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_float_variance (a_data1, a_stride1, a_n1))
			l_var2 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_float_variance (a_data2, a_stride2, a_n2))
			l_pooled_variance := ((a_n1 - {NATURAL_32} 1).to_real_64 * l_var1 + (a_n2 - {NATURAL_32} 1).to_real_64 * l_var2) / ((a_n1 + a_n2) - {NATURAL_32} 2).to_real_64
			Result := l_pooled_variance
		end

	gsl_stats_ulong_pvariance (a_data1: CE_POINTER [NATURAL_32]; a_stride1, a_n1: NATURAL_32; a_data2: CE_POINTER [NATURAL_32]; a_stride2, a_n2: NATURAL_32): REAL_64
		local
			l_var1: REAL_64
			l_var2: REAL_64
			l_pooled_variance: REAL_64
		do
			l_var1 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_ulong_variance (a_data1, a_stride1, a_n1))
			l_var2 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_ulong_variance (a_data2, a_stride2, a_n2))
			l_pooled_variance := ((a_n1 - {NATURAL_32} 1).to_real_64 * l_var1 + (a_n2 - {NATURAL_32} 1).to_real_64 * l_var2) / ((a_n1 + a_n2) - {NATURAL_32} 2).to_real_64
			Result := l_pooled_variance
		end

	gsl_stats_long_pvariance (a_data1: CE_POINTER [INTEGER_32]; a_stride1, a_n1: NATURAL_32; a_data2: CE_POINTER [INTEGER_32]; a_stride2, a_n2: NATURAL_32): REAL_64
		local
			l_var1: REAL_64
			l_var2: REAL_64
			l_pooled_variance: REAL_64
		do
			l_var1 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_long_variance (a_data1, a_stride1, a_n1))
			l_var2 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_long_variance (a_data2, a_stride2, a_n2))
			l_pooled_variance := ((a_n1 - {NATURAL_32} 1).to_real_64 * l_var1 + (a_n2 - {NATURAL_32} 1).to_real_64 * l_var2) / ((a_n1 + a_n2) - {NATURAL_32} 2).to_real_64
			Result := l_pooled_variance
		end

	gsl_stats_uint_pvariance (a_data1: CE_POINTER [NATURAL_32]; a_stride1, a_n1: NATURAL_32; a_data2: CE_POINTER [NATURAL_32]; a_stride2, a_n2: NATURAL_32): REAL_64
		local
			l_var1: REAL_64
			l_var2: REAL_64
			l_pooled_variance: REAL_64
		do
			l_var1 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_uint_variance (a_data1, a_stride1, a_n1))
			l_var2 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_uint_variance (a_data2, a_stride2, a_n2))
			l_pooled_variance := ((a_n1 - {NATURAL_32} 1).to_real_64 * l_var1 + (a_n2 - {NATURAL_32} 1).to_real_64 * l_var2) / ((a_n1 + a_n2) - {NATURAL_32} 2).to_real_64
			Result := l_pooled_variance
		end

	gsl_stats_int_pvariance (a_data1: CE_POINTER [INTEGER_32]; a_stride1, a_n1: NATURAL_32; a_data2: CE_POINTER [INTEGER_32]; a_stride2, a_n2: NATURAL_32): REAL_64
		local
			l_var1: REAL_64
			l_var2: REAL_64
			l_pooled_variance: REAL_64
		do
			l_var1 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_int_variance (a_data1, a_stride1, a_n1))
			l_var2 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_int_variance (a_data2, a_stride2, a_n2))
			l_pooled_variance := ((a_n1 - {NATURAL_32} 1).to_real_64 * l_var1 + (a_n2 - {NATURAL_32} 1).to_real_64 * l_var2) / ((a_n1 + a_n2) - {NATURAL_32} 2).to_real_64
			Result := l_pooled_variance
		end

	gsl_stats_ushort_pvariance (a_data1: CE_POINTER [NATURAL_16]; a_stride1, a_n1: NATURAL_32; a_data2: CE_POINTER [NATURAL_16]; a_stride2, a_n2: NATURAL_32): REAL_64
		local
			l_var1: REAL_64
			l_var2: REAL_64
			l_pooled_variance: REAL_64
		do
			l_var1 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_ushort_variance (a_data1, a_stride1, a_n1))
			l_var2 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_ushort_variance (a_data2, a_stride2, a_n2))
			l_pooled_variance := ((a_n1 - {NATURAL_32} 1).to_real_64 * l_var1 + (a_n2 - {NATURAL_32} 1).to_real_64 * l_var2) / ((a_n1 + a_n2) - {NATURAL_32} 2).to_real_64
			Result := l_pooled_variance
		end

	gsl_stats_short_pvariance (a_data1: CE_POINTER [INTEGER_16]; a_stride1, a_n1: NATURAL_32; a_data2: CE_POINTER [INTEGER_16]; a_stride2, a_n2: NATURAL_32): REAL_64
		local
			l_var1: REAL_64
			l_var2: REAL_64
			l_pooled_variance: REAL_64
		do
			l_var1 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_short_variance (a_data1, a_stride1, a_n1))
			l_var2 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_short_variance (a_data2, a_stride2, a_n2))
			l_pooled_variance := ((a_n1 - {NATURAL_32} 1).to_real_64 * l_var1 + (a_n2 - {NATURAL_32} 1).to_real_64 * l_var2) / ((a_n1 + a_n2) - {NATURAL_32} 2).to_real_64
			Result := l_pooled_variance
		end

	gsl_stats_uchar_pvariance (a_data1: CE_POINTER [NATURAL_8]; a_stride1, a_n1: NATURAL_32; a_data2: CE_POINTER [NATURAL_8]; a_stride2, a_n2: NATURAL_32): REAL_64
		local
			l_var1: REAL_64
			l_var2: REAL_64
			l_pooled_variance: REAL_64
		do
			l_var1 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_uchar_variance (a_data1, a_stride1, a_n1))
			l_var2 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_uchar_variance (a_data2, a_stride2, a_n2))
			l_pooled_variance := ((a_n1 - {NATURAL_32} 1).to_real_64 * l_var1 + (a_n2 - {NATURAL_32} 1).to_real_64 * l_var2) / ((a_n1 + a_n2) - {NATURAL_32} 2).to_real_64
			Result := l_pooled_variance
		end

	gsl_stats_char_pvariance (a_data1: CE_POINTER [INTEGER_8]; a_stride1, a_n1: NATURAL_32; a_data2: CE_POINTER [INTEGER_8]; a_stride2, a_n2: NATURAL_32): REAL_64
		local
			l_var1: REAL_64
			l_var2: REAL_64
			l_pooled_variance: REAL_64
		do
			l_var1 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_char_variance (a_data1, a_stride1, a_n1))
			l_var2 := ((create {P_VARIANCE_SOURCE_STATIC}).gsl_stats_char_variance (a_data2, a_stride2, a_n2))
			l_pooled_variance := ((a_n1 - {NATURAL_32} 1).to_real_64 * l_var1 + (a_n2 - {NATURAL_32} 1).to_real_64 * l_var2) / ((a_n1 + a_n2) - {NATURAL_32} 2).to_real_64
			Result := l_pooled_variance
		end

end
