class
	P_PARETO_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_pareto_pdf (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_p: REAL_64
		do
			if a_x >= a_b___0 then
				l_p := (a_a___5 / a_b___0) / (pow (a_x / a_b___0, a_a___5 + (1).to_double))
				Result := l_p
			else
				Result := (0).to_double
			end
		end

	gsl_cdf_pareto_P (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_P___2: REAL_64
		do
			if a_x < a_b___0 then
				l_P___2 := (0).to_double
			else
				l_P___2 := (1).to_double - (pow (a_b___0 / a_x, a_a___5))
			end
			Result := l_P___2
		end

	gsl_cdf_pareto_Q (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
		do
			if a_x < a_b___0 then
				l_Q___1 := (1).to_double
			else
				l_Q___1 := pow (a_b___0 / a_x, a_a___5)
			end
			Result := l_Q___1
		end

end
