class
	P_QAWF_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_integration_qawf (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5, a_epsabs: REAL_64; a_limit: NATURAL_32; a_workspace, a_cycle_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]; a_wf: CE_POINTER [PD_GSL_INTEGRATION_QAWO_TABLE]; a_result, a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_workspace.is_void
			not a_wf.is_void
			not a_result.is_void
			not a_abserr.is_void
		local
			l_area: REAL_64
			l_errsum: REAL_64
			l_res_ext: REAL_64
			l_err_ext: REAL_64
			l_correc: REAL_64
			l_total_error: REAL_64
			l_truncation_error: REAL_64
			l_ktmin: NATURAL_32
			l_iteration: NATURAL_32
			l_table: CE_ARRAY [PD_EXTRAPOLATION_TABLE]
			l_cycle: REAL_64
			l_omega: REAL_64
			l_p: REAL_64
			l_factor: REAL_64
			l_initial_eps: REAL_64
			l_eps: REAL_64
			l_error_type: INTEGER_32
			l_status: INTEGER_32
			l_tmp___1: REAL_64
			l_area1: CE_ARRAY [REAL_64]
			l_error1: CE_ARRAY [REAL_64]
			l_reseps: CE_ARRAY [REAL_64]
			l_erreps: CE_ARRAY [REAL_64]
			l_a1___4: REAL_64
			l_b1___0: REAL_64
			l_epsabs1: REAL_64
			l_status___0: INTEGER_32
			l_tmp___5: REAL_64
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_EXTRAPOLATION_TABLE]} l_table.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_area1.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_error1.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_reseps.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_erreps.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_total_error := 0.0
					l_ktmin := (0).to_natural_32
					l_iteration := (0).to_natural_32
					l_omega := a_wf.item.omega
					l_p := 0.9
					l_factor := (1).to_double
					l_error_type := 0
					a_workspace.item.initialise (a_a___5, a_a___5)
					a_result.item := (0).to_double
					a_abserr.item := (0).to_double
					if a_limit > a_workspace.item.limit then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("iteration limit exceeds available workspace"), ce_string ("qawf.c"), 67, 4)
							Result := 4
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return and then (a_epsabs <= (0).to_double) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("absolute tolerance epsabs must be positive"), ce_string ("qawf.c"), 74, 13)
							Result := 13
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return and then (l_omega = 0.0) then
						if a_wf.item.sine = {NATURAL_32} 1 then
							a_result.item := (0).to_double
							a_abserr.item := (0).to_double
							Result := 0
							l_return := True
						else
							l_status := ((create {P_QAGS_STATIC}).gsl_integration_qagiu (a_f, a_a___5, a_epsabs, 0.0, a_cycle_workspace.item.limit, a_cycle_workspace, a_result, a_abserr))
							Result := l_status
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_epsabs > 2.2250738585072014e-308 / ((1).to_double - l_p) then
							l_eps := a_epsabs * ((1).to_double - l_p)
						else
							l_eps := a_epsabs
						end
						l_initial_eps := l_eps
						l_area := (0).to_double
						l_errsum := (0).to_double
						l_res_ext := (0).to_double
						l_err_ext := 1.7976931348623157e+308
						l_correc := (0).to_double
						l_tmp___1 := floor ((fabs (l_omega)))
						l_cycle := (((2).to_double * l_tmp___1 + (1).to_double) * 3.14159265358979323846) / (fabs (l_omega))
						a_wf.item.gsl_integration_qawo_table_set_length (l_cycle).do_nothing
						l_table.item.initialise_table___0
						l_iteration := (0).to_natural_32
				when 2 then -- loop condition:
						if not (not (l_break) and then (l_iteration < a_limit)) then
							l_pos := -1 + 6 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						l_a1___4 := a_a___5 + l_iteration.to_real_64 * l_cycle
						l_b1___0 := l_a1___4 + l_cycle
						l_epsabs1 := l_eps * l_factor
						l_status___0 := ((create {P_QAWO_STATIC}).gsl_integration_qawo (a_f, l_a1___4, l_epsabs1, 0.0, a_limit, a_cycle_workspace, a_wf, l_area1, l_error1))
						a_workspace.item.append_interval (l_a1___4, l_b1___0, l_area1.item, l_error1.item)
						l_factor := l_factor * l_p
						l_area := l_area + (l_area1.item)
						l_errsum := l_errsum + (l_error1.item)
						l_truncation_error := (50).to_double * (fabs (l_area1.item))
						l_total_error := l_errsum + l_truncation_error
						if l_total_error < a_epsabs then
							if l_iteration > {NATURAL_32} 4 then
								l_pos := -1 + 14 -- goto compute_result
							end
						end
				when 4 then
						if l_error1.item > l_correc then
							l_correc := l_error1.item
						end
						if l_status___0.to_boolean then
							l_eps := (create {P_GSL_GSL_MINMAX_STATIC}).GSL_MAX_DBL (l_initial_eps, l_correc * (1.0 - l_p))
						end
						if l_status___0.to_boolean then
							if l_total_error < (10).to_double * l_correc then
								if l_iteration > {NATURAL_32} 3 then
									l_pos := -1 + 14 -- goto compute_result
								end
							end
						end
				when 5 then
						l_table.item.append_table___0 (l_area)
						if l_table.item.n < {NATURAL_32} 2 then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							l_table.item.qelg (l_reseps, l_erreps)
							l_ktmin := l_ktmin + 1
							if l_ktmin >= {NATURAL_32} 15 then
								if l_err_ext < 0.001 * l_total_error then
									l_error_type := 4
								end
							end
							if l_erreps.item < l_err_ext then
								l_ktmin := (0).to_natural_32
								l_err_ext := l_erreps.item
								l_res_ext := l_reseps.item
								if l_err_ext + (10).to_double * l_correc <= a_epsabs then
									l_break := True
								end
								if not (l_return or l_break or l_continue) and then (l_err_ext <= a_epsabs) then
									if (10).to_double * l_correc >= a_epsabs then
										l_break := True
									end
								end
							end
						end
						if (not l_break) then
							l_iteration := l_iteration + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 6 then -- loop done
						l_break := False
						l_continue := False
						if l_iteration = a_limit then
							l_error_type := 1
						end
						if l_err_ext = 1.7976931348623157e+308 then
							l_pos := -1 + 14 -- goto compute_result
						end
				when 7 then
						l_err_ext := l_err_ext + ((10).to_double * l_correc)
						a_result.item := l_res_ext
						a_abserr.item := l_err_ext
						if l_error_type = 0 then
							Result := 0
							l_return := True
						end
				when 8 then -- if done
					if l_return then
						l_pos := -1 + 16 -- skip if block
					end
				when 9 then -- if:
						if l_res_ext = 0.0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_area /= 0.0 then
							l_tmp___5 := fabs (l_res_ext)
							if l_err_ext / l_tmp___5 > l_errsum / (fabs (l_area)) then
								l_pos := -1 + 14 -- goto compute_result
							end
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if l_err_ext > l_errsum then
							l_pos := -1 + 14 -- goto compute_result
						elseif l_area = 0.0 then
							l_pos := -1 + 15 -- goto return_error
						end
				when 13 then
						if l_error_type = 4 then
							l_err_ext := l_err_ext + l_truncation_error
						end
						l_pos := -1 + 15 -- goto return_error
				when 14 then -- compute_result:
						a_result.item := l_area
						a_abserr.item := l_total_error
				when 15 then -- return_error:
						if l_error_type > 2 then
							l_error_type := l_error_type - 1
						end
						if l_error_type = 0 then
							Result := 0
							l_return := True
						elseif l_error_type = 1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("number of iterations was insufficient"), ce_string ("qawf.c"), 253, 11)
								Result := 11
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						elseif l_error_type = 2 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("cannot reach tolerance because of roundoff error"), ce_string ("qawf.c"), 258, 18)
								Result := 18
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						elseif l_error_type = 3 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("bad integrand behavior found in the integration interval"), ce_string ("qawf.c"), 263, 21)
								Result := 21
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						elseif l_error_type = 4 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("roundoff error detected in the extrapolation table"), ce_string ("qawf.c"), 268, 18)
								Result := 18
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						elseif l_error_type = 5 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("integral is divergent, or slowly convergent"), ce_string ("qawf.c"), 273, 22)
								Result := 22
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("could not integrate function"), ce_string ("qawf.c"), 277, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
				when 16 then -- if done
					if not l_return then
						Result := 0
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
