class
	P_QUAD_GOLDEN_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	quad_golden_type: CE_STATIC [CE_ARRAY [PD_GSL_MIN_FMINIMIZER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_MIN_FMINIMIZER_TYPE]}.make_initialized (<<
					create {PD_GSL_MIN_FMINIMIZER_TYPE}.make_initialized ([ce_string ("quad-golden"), (create {PD_QUAD_GOLDEN_STATE_T}.make).structure_size.to_natural_32, quad_golden_init_address, (create {PD_GSL_FUNCTION_STRUCT_STATIC}).quad_golden_iterate_address])
				>>)
		end

	gsl_min_fminimizer_quad_golden: CE_STATIC [CE_POINTER [PD_GSL_MIN_FMINIMIZER_TYPE]]
		once ("PROCESS")
			Result.item := quad_golden_type.item
		end

feature {ANY} -- public routines

	quad_golden_init (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x_minimum, a_f_minimum, a_x_lower, a_f_lower, a_x_upper, a_f_upper: REAL_64): INTEGER_32
		local
			l_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]
			l_x_lower: REAL_64
			l_f_lower: REAL_64
			l_x_upper: REAL_64
			l_f_upper: REAL_64
			l_state: CE_POINTER [PD_QUAD_GOLDEN_STATE_T]
		do
			l_f := a_f
			l_x_lower := a_x_lower
			l_f_lower := a_f_lower
			l_x_upper := a_x_upper
			l_f_upper := a_f_upper
			l_state := create {CE_CLASS_POINTER [PD_QUAD_GOLDEN_STATE_T]}.make_cast (a_vstate)
			l_state.item.x_prev_small := a_x_minimum
			l_state.item.x_small := a_x_minimum
			l_state.item.f_prev_small := a_f_minimum
			l_state.item.f_small := a_f_minimum
			l_state.item.step_size := 0.0
			l_state.item.stored_step := 0.0
			l_state.item.prev_stored_step := 0.0
			l_state.item.num_iter := {NATURAL_32} 0
			l_x_lower := (0).to_double
			l_x_upper := (0).to_double
			l_f_lower := (0).to_double
			l_f_upper := (0).to_double
			l_f := create {CE_CLASS_POINTER [PD_GSL_FUNCTION_STRUCT]}.make_shared (default_pointer)
			Result := 0
		end

feature {ANY} -- routine addresses

	quad_golden_init_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent quad_golden_init)
		end

end
