class
	P_RAND_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	rand_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("rand"), {NATURAL_32} 2_147_483_647, {NATURAL_32} 0, (create {PD_RAND_STATE_T}.make).structure_size.to_natural_32, rand_set_address, rand_get_address, rand_get_double_address])
				>>)
		end

	gsl_rng_rand: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := rand_type.item
		end

feature {ANY} -- public routines

	rand_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAND_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RAND_STATE_T]}.make_cast (a_vstate)
			l_state.item.x := (({NATURAL_32} 1_103_515_245 * l_state.item.x + {NATURAL_32} 12_345)).bit_and ({NATURAL_32} 2_147_483_647)
			Result := (l_state.item.x)
		end

	rand_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((rand_get (a_vstate)).to_real_64 / 2147483648.0)
		end

	rand_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RAND_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RAND_STATE_T]}.make_cast (a_vstate)
			l_state.item.x := a_s
		end

feature {ANY} -- routine addresses

	rand_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rand_get)
		end

	rand_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rand_get_double)
		end

	rand_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rand_set)
		end

end
