class
	P_RANDU_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	a3: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (65_539).to_integer_32
		end

	randu_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("randu"), {NATURAL_32} 2_147_483_647, {NATURAL_32} 1, (create {PD_RANDU_STATE_T}.make).structure_size.to_natural_32, randu_set_address, randu_get_address, randu_get_double_address])
				>>)
		end

	gsl_rng_randu: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := randu_type.item
		end

feature {ANY} -- public routines

	randu_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RANDU_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RANDU_STATE_T]}.make_cast (a_vstate)
			l_state.item.x := (a3.item.to_natural_32 * l_state.item.x).bit_and ({NATURAL_32} 2_147_483_647)
			Result := (l_state.item.x)
		end

	randu_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((randu_get (a_vstate)).to_real_64 / 2147483648.0)
		end

	randu_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RANDU_STATE_T]
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_RANDU_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := l_s
		end

feature {ANY} -- routine addresses

	randu_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent randu_get)
		end

	randu_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent randu_get_double)
		end

	randu_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent randu_set)
		end

end
