class
	P_RANF_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public attributes

	a0: CE_STATIC [NATURAL_16]
		once ("PROCESS")
			Result.item := (45_429).to_natural_16
		end

	a1___0: CE_STATIC [NATURAL_16]
		once ("PROCESS")
			Result.item := (41_703).to_natural_16
		end

	a2___0: CE_STATIC [NATURAL_16]
		once ("PROCESS")
			Result.item := (10_357).to_natural_16
		end

	ranf_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("ranf"), {NATURAL_32} 4_294_967_295, {NATURAL_32} 0, (create {PD_RANF_STATE_T}.make).structure_size.to_natural_32, ranf_set_address, ranf_get_address, ranf_get_double_address])
				>>)
		end

	gsl_rng_ranf: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ranf_type.item
		end

feature {ANY} -- public routines

	ranf_advance (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_RANF_STATE_T]
			l_x0: NATURAL_32
			l_x1___0: NATURAL_32
			l_x2___1: NATURAL_32
			l_r___3: NATURAL_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RANF_STATE_T]}.make_cast (a_vstate)
			l_x0 := (l_state.item.x0).to_natural_32
			l_x1___0 := (l_state.item.x1).to_natural_32
			l_x2___1 := (l_state.item.x2).to_natural_32
			l_r___3 := a0.item.to_natural_32 * l_x0
			l_state.item.x0 := ((l_r___3).bit_and ({NATURAL_32} 65_535)).to_natural_16
			l_r___3 := (l_r___3).bit_shift_right ((16))
			l_r___3 := l_r___3 + (a0.item.to_natural_32 * l_x1___0 + a1___0.item.to_natural_32 * l_x0)
			l_state.item.x1 := ((l_r___3).bit_and ({NATURAL_32} 65_535)).to_natural_16
			l_r___3 := (l_r___3).bit_shift_right ((16))
			l_r___3 := l_r___3 + ((a0.item.to_natural_32 * l_x2___1 + a1___0.item.to_natural_32 * l_x1___0) + a2___0.item.to_natural_32 * l_x0)
			l_state.item.x2 := ((l_r___3).bit_and ({NATURAL_32} 65_535)).to_natural_16
		end

	ranf_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_x1___0: NATURAL_32
			l_x2___1: NATURAL_32
			l_state: CE_POINTER [PD_RANF_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RANF_STATE_T]}.make_cast (a_vstate)
			ranf_advance (create {CE_VOID_POINTER}.make_cast (l_state))
			l_x1___0 := (l_state.item.x1).to_natural_32
			l_x2___1 := (l_state.item.x2).to_natural_32
			Result := (((l_x2___1).bit_shift_left (16)) + l_x1___0)
		end

	ranf_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RANF_STATE_T]
			l_tmp: REAL_64
			l_tmp___0: REAL_64
		do
			l_state := create {CE_CLASS_POINTER [PD_RANF_STATE_T]}.make_cast (a_vstate)
			ranf_advance (create {CE_VOID_POINTER}.make_cast (l_state))
			l_tmp := ldexp ((l_state.item.x2).to_real_64, -16)
			l_tmp___0 := ldexp ((l_state.item.x1).to_real_64, -32)
			Result := ((l_tmp + l_tmp___0) + (ldexp ((l_state.item.x0).to_real_64, -48)))
		end

	ranf_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RANF_STATE_T]
			l_x0: NATURAL_16
			l_x1___0: NATURAL_16
			l_x2___1: NATURAL_16
			l_r___3: NATURAL_32
			l_b0: NATURAL_32
			l_b1___0: NATURAL_32
			l_b2: NATURAL_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RANF_STATE_T]}.make_cast (a_vstate)
			l_b0 := {NATURAL_32} 55_005
			l_b1___0 := {NATURAL_32} 47_252
			l_b2 := {NATURAL_32} 23_790
			if a_s = {NATURAL_32} 0 then
				l_x0 := (40_145).to_natural_16
				l_x1___0 := (21_500).to_natural_16
				l_x2___1 := (38_018).to_natural_16
			else
				l_x0 := ((((a_s).bit_or ({NATURAL_32} 1))).bit_and ({NATURAL_32} 65_535)).to_natural_16
				l_x1___0 := ((((a_s).bit_shift_right (16))).bit_and ({NATURAL_32} 65_535)).to_natural_16
				l_x2___1 := (0).to_natural_16
			end
			l_r___3 := l_b0 * l_x0.to_natural_32
			l_state.item.x0 := ((l_r___3).bit_and ({NATURAL_32} 65_535)).to_natural_16
			l_r___3 := (l_r___3).bit_shift_right ((16))
			l_r___3 := l_r___3 + (l_b0 * l_x1___0.to_natural_32 + l_b1___0 * l_x0.to_natural_32)
			l_state.item.x1 := ((l_r___3).bit_and ({NATURAL_32} 65_535)).to_natural_16
			l_r___3 := (l_r___3).bit_shift_right ((16))
			l_r___3 := l_r___3 + ((l_b0 * l_x2___1.to_natural_32 + l_b1___0 * l_x1___0.to_natural_32) + l_b2 * l_x0.to_natural_32)
			l_state.item.x2 := ((l_r___3).bit_and ({NATURAL_32} 65_535)).to_natural_16
		end

feature {ANY} -- routine addresses

	ranf_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranf_get)
		end

	ranf_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranf_get_double)
		end

	ranf_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranf_set)
		end

end
