class
	P_RANLXS_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	snext: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 0
				>>)
		end

	one_bit: CE_STATIC [REAL_64]
		once ("PROCESS")
			Result.item := (1.0 / 281474976710656.0)
		end

	ranlxs0_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("ranlxs0"), {NATURAL_32} 16_777_215, {NATURAL_32} 0, (create {PD_RANLXS_STATE_T}.make).structure_size.to_natural_32, ranlxs0_set_address, ranlxs_get_address, ranlxs_get_double_address])
				>>)
		end

	ranlxs1_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("ranlxs1"), {NATURAL_32} 16_777_215, {NATURAL_32} 0, (create {PD_RANLXS_STATE_T}.make).structure_size.to_natural_32, ranlxs1_set_address, ranlxs_get_address, ranlxs_get_double_address])
				>>)
		end

	ranlxs2_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("ranlxs2"), {NATURAL_32} 16_777_215, {NATURAL_32} 0, (create {PD_RANLXS_STATE_T}.make).structure_size.to_natural_32, ranlxs2_set_address, ranlxs_get_address, ranlxs_get_double_address])
				>>)
		end

	gsl_rng_ranlxs0: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ranlxs0_type.item
		end

	gsl_rng_ranlxs1: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ranlxs1_type.item
		end

	gsl_rng_ranlxs2: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ranlxs2_type.item
		end

feature {ANY} -- public routines

	ranlxs_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RANLXS_STATE_T]
			l_is: NATURAL_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RANLXS_STATE_T]}.make_cast (a_vstate)
			l_is := (snext.item[(l_state.item.is).to_integer_32]).to_natural_32
			l_state.item.is := l_is
			if l_is = l_state.item.is_old then
				l_state.item.increment_state
			end
			Result := (l_state.item.xflt[(l_state.item.is).to_integer_32]).to_double
		end

	ranlxs_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		do
			Result := ((ranlxs_get_double (a_vstate)) * 16777216.0).truncated_to_integer_64.to_natural_32
		end

	ranlxs_set_lux (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32; a_luxury: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RANLXS_STATE_T]
			l_ibit: INTEGER_32
			l_jbit: INTEGER_32
			l_i: INTEGER_32
			l_k: INTEGER_32
			l_m___4: INTEGER_32
			l_xbit: CE_ARRAY [INTEGER_32]
			l_x: REAL_64
			l_y: REAL_64
			l_seed: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_xbit.make (<<31>>)

			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_RANLXS_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_seed := l_s.to_integer_32
			l_i := ((l_seed.to_natural_32).bit_and ({NATURAL_32} 4_294_967_295)).to_integer_32
			l_k := 0
			from
			until
				not (l_k < 31)
			loop
				l_xbit[l_k] := l_i \\ 2
				l_i := l_i // (2)
				l_k := l_k + 1
			end
			l_ibit := 0
			l_jbit := 18
			l_k := 0
			from
			until
				not (not (l_return) and then (l_k < 12))
			loop
				l_x := (0).to_double
				l_m___4 := 1
				from
				until
					not (l_m___4 <= 48)
				loop
					l_y := (l_xbit[l_ibit]).to_double
					l_x := l_x + (l_x + l_y)
					l_xbit[l_ibit] := (l_xbit[l_ibit] + l_xbit[l_jbit]) \\ 2
					l_ibit := (l_ibit + 1) \\ 31
					l_jbit := (l_jbit + 1) \\ 31
					l_m___4 := l_m___4 + 1
				end
				l_state.item.xdbl[l_k] := (one_bit.item * l_x)
				l_k := l_k + 1
			end
			l_state.item.carry := (0).to_double
			l_state.item.ir := {NATURAL_32} 0
			l_state.item.jr := {NATURAL_32} 7
			l_state.item.is := {NATURAL_32} 23
			l_state.item.is_old := {NATURAL_32} 0
			l_state.item.pr := a_luxury
		end

	ranlxs0_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		do
			ranlxs_set_lux (a_vstate, a_s, {NATURAL_32} 109)
		end

	ranlxs1_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		do
			ranlxs_set_lux (a_vstate, a_s, {NATURAL_32} 202)
		end

	ranlxs2_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		do
			ranlxs_set_lux (a_vstate, a_s, {NATURAL_32} 397)
		end

feature {ANY} -- routine addresses

	ranlxs_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranlxs_get_double)
		end

	ranlxs_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranlxs_get)
		end

	ranlxs0_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranlxs0_set)
		end

	ranlxs1_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranlxs1_set)
		end

	ranlxs2_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranlxs2_set)
		end

end
