class
	P_RK4IMP_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	rk4imp_type: CE_STATIC [CE_ARRAY [PD_GSL_ODEIV_STEP_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_ODEIV_STEP_TYPE]}.make_initialized (<<
					create {PD_GSL_ODEIV_STEP_TYPE}.make_initialized ([ce_string ("rk4imp"), 1, 1, rk4imp_alloc_address, rk4imp_apply_address, rk4imp_reset_address, rk4imp_order_address, rk4imp_free_address])
				>>)
		end

	gsl_odeiv_step_rk4imp: CE_STATIC [CE_POINTER [PD_GSL_ODEIV_STEP_TYPE]]
		once ("PROCESS")
			Result.item := rk4imp_type.item
		end

feature {ANY} -- public routines

	rk4imp_alloc (a_dim: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_RK4IMP_STATE_T]
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_RK4IMP_STATE_T]}.make_cast ((malloc ((create {PD_RK4IMP_STATE_T}.make).structure_size.to_natural_32)))
			if l_state.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for rk4imp_state"), ce_string ("rk4imp.c"), 60, 8)
					Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.k1nu := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k1nu).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for k1nu"), ce_string ("rk4imp.c"), 68, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.k2nu := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k2nu).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1nu))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for k2nu"), ce_string ("rk4imp.c"), 77, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.ytmp1 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.ytmp1).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k2nu))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1nu))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for ytmp1"), ce_string ("rk4imp.c"), 87, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.ytmp2 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.ytmp2).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp1))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k2nu))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1nu))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for ytmp2"), ce_string ("rk4imp.c"), 98, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.y0 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp2))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp1))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k2nu))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1nu))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for y0"), ce_string ("rk4imp.c"), 110, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.y0_orig := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0_orig).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp2))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp1))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k2nu))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1nu))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for y0_orig"), ce_string ("rk4imp.c"), 123, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.y_onestep := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y_onestep).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0_orig))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp2))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp1))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k2nu))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1nu))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for y_onestep"), ce_string ("rk4imp.c"), 137, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := (create {CE_VOID_POINTER}.make_cast (l_state))
			end
		end

	rk4imp_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t, a_h: REAL_64; a_y, a_yerr, a_dydt_in, a_dydt_out: CE_POINTER [REAL_64]; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK4IMP_STATE_T]
			l_i: NATURAL_32
			l_y0___0: CE_POINTER [REAL_64]
			l_y0_orig: CE_POINTER [REAL_64]
			l_y_onestep: CE_POINTER [REAL_64]
			l_k1nu: CE_POINTER [REAL_64]
			l_k2nu: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_s___0: INTEGER_32
			l_s___1: INTEGER_32
			l_s___2: INTEGER_32
			l_s___3: INTEGER_32
			l_s___4: INTEGER_32
			l_return: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_RK4IMP_STATE_T]}.make_cast (a_vstate)
			l_y0___0 := l_state.item.y0
			l_y0_orig := l_state.item.y0_orig
			l_y_onestep := l_state.item.y_onestep
			l_k1nu := l_state.item.k1nu
			l_k2nu := l_state.item.k2nu
			memcpy (create {CE_VOID_POINTER}.make_cast (l_y0___0), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memcpy (create {CE_VOID_POINTER}.make_cast (l_y0_orig), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			if not a_dydt_in.is_void then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_k1nu), create {CE_VOID_POINTER}.make_cast (a_dydt_in), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			else
				l_s := ((a_sys.item.function).integer_32_item ([a_t, a_y, l_k1nu, a_sys.item.params]))
				if l_s /= 0 then
					Result := l_s
					l_return := True
				end
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_k2nu), create {CE_VOID_POINTER}.make_cast (l_k1nu), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				memcpy (create {CE_VOID_POINTER}.make_cast (l_y_onestep), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___0 := (l_state.item.rk4imp_step (l_y_onestep, a_h, a_t, a_dim, a_sys))
				if l_s___0 /= 0 then
					Result := l_s___0
					l_return := True
				end
			end
			if not l_return then
				l_s___1 := (l_state.item.rk4imp_step (a_y, a_h / 2.0, a_t, a_dim, a_sys))
				if l_s___1 /= 0 then
					memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___1
					l_return := True
				end
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_y0___0), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___2 := ((a_sys.item.function).integer_32_item ([a_t + a_h / 2.0, a_y, l_k1nu, a_sys.item.params]))
				if l_s___2 /= 0 then
					memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___2
					l_return := True
				end
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_k2nu), create {CE_VOID_POINTER}.make_cast (l_k1nu), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___3 := (l_state.item.rk4imp_step (a_y, a_h / 2.0, a_t + a_h / 2.0, a_dim, a_sys))
				if l_s___3 /= 0 then
					memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___3
					l_return := True
				end
			end
			if not l_return and then (not a_dydt_out.is_void) then
				l_s___4 := ((a_sys.item.function).integer_32_item ([a_t + a_h, a_y, a_dydt_out, a_sys.item.params]))
				if l_s___4 /= 0 then
					memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___4
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_yerr[l_i.to_integer_32] := ((8.0 * 0.5) * (a_y[l_i.to_integer_32] - l_y_onestep[l_i.to_integer_32])) / 15.0
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	rk4imp_reset (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK4IMP_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RK4IMP_STATE_T]}.make_cast (a_vstate)
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.y_onestep), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.y0_orig), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.y0), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.k1nu), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.k2nu), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp1), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp2), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			Result := 0
		end

	rk4imp_order (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RK4IMP_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RK4IMP_STATE_T]}.make_cast (a_vstate)
			l_state := create {CE_CLASS_POINTER [PD_RK4IMP_STATE_T]}.make_shared (default_pointer)
			Result := {NATURAL_32} 4
		end

	rk4imp_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_RK4IMP_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RK4IMP_STATE_T]}.make_cast (a_vstate)
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y_onestep))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0_orig))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1nu))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.k2nu))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp1))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp2))
			free (create {CE_VOID_POINTER}.make_cast (l_state))
		end

feature {ANY} -- routine addresses

	rk4imp_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk4imp_alloc)
		end

	rk4imp_apply_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk4imp_apply)
		end

	rk4imp_reset_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk4imp_reset)
		end

	rk4imp_order_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk4imp_order)
		end

	rk4imp_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk4imp_free)
		end

end
