class
	P_RK8PD_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	rk8pd_type: CE_STATIC [CE_ARRAY [PD_GSL_ODEIV_STEP_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_ODEIV_STEP_TYPE]}.make_initialized (<<
					create {PD_GSL_ODEIV_STEP_TYPE}.make_initialized ([ce_string ("rk8pd"), 1, 1, rk8pd_alloc_address, (create {PD_GSL_ODEIV_SYSTEM_STATIC}).rk8pd_apply_address, rk8pd_reset_address, rk8pd_order_address, rk8pd_free_address])
				>>)
		end

	gsl_odeiv_step_rk8pd: CE_STATIC [CE_POINTER [PD_GSL_ODEIV_STEP_TYPE]]
		once ("PROCESS")
			Result.item := rk8pd_type.item
		end

feature {ANY} -- public routines

	rk8pd_alloc (a_dim: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_RK8PD_STATE_T]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_RK8PD_STATE_T]}.make_cast ((malloc ((create {PD_RK8PD_STATE_T}.make).structure_size.to_natural_32)))
			if l_state.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for rk8pd_state"), ce_string ("rk8pd.c"), 182, 8)
					Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.ytmp := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.ytmp).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for ytmp"), ce_string ("rk8pd.c"), 190, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.y0 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for y0"), ce_string ("rk8pd.c"), 199, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_i := 0
				from
				until
					not (not (l_return) and then (l_i < 13))
				loop
					l_state.item.k[l_i] := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
					if (l_state.item.k[l_i]).is_void then
						l_j := 0
						from
						until
							not (l_j < l_i)
						loop
							free (create {CE_VOID_POINTER}.make_cast (l_state.item.k[l_j]))
							l_j := l_j + 1
						end
						free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
						free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp))
						free (create {CE_VOID_POINTER}.make_cast (l_state))
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for k%'s"), ce_string ("rk8pd.c"), 215, 8)
							Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := (create {CE_VOID_POINTER}.make_cast (l_state))
			end
		end

	rk8pd_reset (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK8PD_STATE_T]
			l_i: INTEGER_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RK8PD_STATE_T]}.make_cast (a_vstate)
			l_i := 0
			from
			until
				not (l_i < 13)
			loop
				memset (create {CE_VOID_POINTER}.make_cast (l_state.item.k[l_i]), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_i := l_i + 1
			end
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.y0), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			Result := 0
		end

	rk8pd_order (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RK8PD_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RK8PD_STATE_T]}.make_cast (a_vstate)
			l_state := create {CE_CLASS_POINTER [PD_RK8PD_STATE_T]}.make_shared (default_pointer)
			Result := {NATURAL_32} 8
		end

	rk8pd_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_RK8PD_STATE_T]
			l_i: INTEGER_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RK8PD_STATE_T]}.make_cast (a_vstate)
			l_i := 0
			from
			until
				not (l_i < 13)
			loop
				free (create {CE_VOID_POINTER}.make_cast (l_state.item.k[l_i]))
				l_i := l_i + 1
			end
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp))
			free (create {CE_VOID_POINTER}.make_cast (l_state))
		end

feature {ANY} -- routine addresses

	rk8pd_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk8pd_alloc)
		end

	rk8pd_reset_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk8pd_reset)
		end

	rk8pd_order_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk8pd_order)
		end

	rk8pd_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk8pd_free)
		end

end
