class
	P_RKCK_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	rkck_type: CE_STATIC [CE_ARRAY [PD_GSL_ODEIV_STEP_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_ODEIV_STEP_TYPE]}.make_initialized (<<
					create {PD_GSL_ODEIV_STEP_TYPE}.make_initialized ([ce_string ("rkck"), 1, 1, rkck_alloc_address, (create {PD_GSL_ODEIV_SYSTEM_STATIC}).rkck_apply_address, rkck_reset_address, rkck_order_address, rkck_free_address])
				>>)
		end

	gsl_odeiv_step_rkck: CE_STATIC [CE_POINTER [PD_GSL_ODEIV_STEP_TYPE]]
		once ("PROCESS")
			Result.item := rkck_type.item
		end

feature {ANY} -- public routines

	rkck_alloc (a_dim: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_RKCK_STATE_T]
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_RKCK_STATE_T]}.make_cast ((malloc ((create {PD_RKCK_STATE_T}.make).structure_size.to_natural_32)))
			if l_state.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for rkck_state"), ce_string ("rkck.c"), 81, 8)
					Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.k1 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k1).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for k1"), ce_string ("rkck.c"), 89, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.k2 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k2).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for k2"), ce_string ("rkck.c"), 98, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.k3 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k3).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k2))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for k3"), ce_string ("rkck.c"), 108, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.k4 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k4).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k3))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k2))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for k4"), ce_string ("rkck.c"), 119, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.k5 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k5).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k4))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k3))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k2))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for k5"), ce_string ("rkck.c"), 131, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.k6 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k6).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k5))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k4))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k3))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k2))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for k6"), ce_string ("rkck.c"), 144, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.y0 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k6))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k5))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k4))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k3))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k2))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for y0"), ce_string ("rkck.c"), 158, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.ytmp := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.ytmp).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k6))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k5))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k4))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k3))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k2))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for ytmp"), ce_string ("rkck.c"), 173, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := (create {CE_VOID_POINTER}.make_cast (l_state))
			end
		end

	rkck_reset (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_RKCK_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RKCK_STATE_T]}.make_cast (a_vstate)
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.k1), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.k2), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.k3), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.k4), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.k5), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.k6), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.y0), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			Result := 0
		end

	rkck_order (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RKCK_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RKCK_STATE_T]}.make_cast (a_vstate)
			l_state := create {CE_CLASS_POINTER [PD_RKCK_STATE_T]}.make_shared (default_pointer)
			Result := {NATURAL_32} 5
		end

	rkck_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_RKCK_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RKCK_STATE_T]}.make_cast (a_vstate)
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.k6))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.k5))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.k4))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.k3))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.k2))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1))
			free (create {CE_VOID_POINTER}.make_cast (l_state))
		end

feature {ANY} -- routine addresses

	rkck_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rkck_alloc)
		end

	rkck_reset_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rkck_reset)
		end

	rkck_order_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rkck_order)
		end

	rkck_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rkck_free)
		end

end
