class
	P_SECANT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	secant_type: CE_STATIC [CE_ARRAY [PD_GSL_ROOT_FDFSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_ROOT_FDFSOLVER_TYPE]}.make_initialized (<<
					create {PD_GSL_ROOT_FDFSOLVER_TYPE}.make_initialized ([ce_string ("secant"), (create {PD_SECANT_STATE_T}.make).structure_size.to_natural_32, (create {PD_GSL_FUNCTION_FDF_STRUCT_STATIC}).secant_init_address, secant_iterate_address])
				>>)
		end

	gsl_root_fdfsolver_secant: CE_STATIC [CE_POINTER [PD_GSL_ROOT_FDFSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := secant_type.item
		end

feature {ANY} -- public routines

	secant_iterate (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_FUNCTION_FDF_STRUCT]; a_root: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_root.is_void
		local
			l_state: CE_POINTER [PD_SECANT_STATE_T]
			l_x: REAL_64
			l_f: REAL_64
			l_df: REAL_64
			l_x_new: REAL_64
			l_f_new: REAL_64
			l_df_new: REAL_64
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_SECANT_STATE_T]}.make_cast (a_vstate)
			l_x := a_root.item
			l_f := l_state.item.f
			l_df := l_state.item.df
			if l_state.item.df = 0.0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("derivative is zero"), ce_string ("secant.c"), 84, 12)
					Result := 12
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_x_new := l_x - l_f / l_df
				l_f_new := (a_fdf.item.f).real_64_item ([l_x_new, a_fdf.item.params])
				l_df_new := (l_f_new - l_f) / (l_x_new - l_x)
				a_root.item := l_x_new
				l_state.item.f := l_f_new
				l_state.item.df := l_df_new
				if not ((create {P_INFNAN_STATIC}).gsl_finite (l_f_new)).to_boolean then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("function value is not finite"), ce_string ("secant.c"), 99, 9)
						Result := 9
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				if not ((create {P_INFNAN_STATIC}).gsl_finite (l_df_new)).to_boolean then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("derivative value is not finite"), ce_string ("secant.c"), 104, 9)
						Result := 9
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

feature {ANY} -- routine addresses

	secant_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent secant_iterate)
		end

end
