class
	P_STEEPEST_DESCENT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	steepest_descent_type: CE_STATIC [CE_ARRAY [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE]}.make_initialized (<<
					create {PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE}.make_initialized ([ce_string ("steepest_descent"), (create {PD_STEEPEST_DESCENT_STATE_T}.make).structure_size.to_natural_32, steepest_descent_alloc_address, (create {PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT_STATIC}).steepest_descent_set_address, steepest_descent_iterate_address, steepest_descent_restart_address, steepest_descent_free_address])
				>>)
		end

	gsl_multimin_fdfminimizer_steepest_descent: CE_STATIC [CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE]]
		once ("PROCESS")
			Result.item := steepest_descent_type.item
		end

feature {ANY} -- public routines

	steepest_descent_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_STEEPEST_DESCENT_STATE_T]
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_STEEPEST_DESCENT_STATE_T]}.make_cast (a_vstate)
			l_state.item.x1 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_n)
			if (l_state.item.x1).is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for x1"), ce_string ("steepest_descent.c"), 48, 8)
					Result := 8
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.g1 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_n)
				if (l_state.item.g1).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x1)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for g1"), ce_string ("steepest_descent.c"), 56, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	steepest_descent_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_STEEPEST_DESCENT_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_STEEPEST_DESCENT_STATE_T]}.make_cast (a_vstate);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x1);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.g1)
		end

	steepest_descent_restart (a_vstate: CE_POINTER [ANY]): INTEGER_32
		local
			l_state: CE_POINTER [PD_STEEPEST_DESCENT_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_STEEPEST_DESCENT_STATE_T]}.make_cast (a_vstate)
			l_state.item.step := l_state.item.max_step
			Result := 0
		end

	steepest_descent_iterate (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient, a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		require
			not a_f.is_void
			not a_gradient.is_void
		local
			l_state: CE_POINTER [PD_STEEPEST_DESCENT_STATE_T]
			l_x1___0: CE_POINTER [PD_GSL_VECTOR]
			l_g1: CE_POINTER [PD_GSL_VECTOR]
			l_f0: REAL_64
			l_f1: CE_ARRAY [REAL_64]
			l_step: REAL_64
			l_tol: REAL_64
			l_failed___0: INTEGER_32
			l_gnorm: REAL_64
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_REAL_64_ARRAY} l_f1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state := create {CE_CLASS_POINTER [PD_STEEPEST_DESCENT_STATE_T]}.make_cast (a_vstate)
					l_x1___0 := l_state.item.x1
					l_g1 := l_state.item.g1
					l_f0 := a_f.item
					l_step := l_state.item.step
					l_tol := l_state.item.tol
					l_failed___0 := 0
					l_gnorm := (a_gradient.item.gsl_blas_dnrm2)
					if l_gnorm = 0.0 then
						a_dx.item.gsl_vector_set_zero
						Result := 27
						l_return := True
					end
					if l_return then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if: | trial:
						a_dx.item.gsl_vector_set_zero
						a_gradient.item.gsl_blas_daxpy (-l_step / l_gnorm, a_dx).do_nothing
						l_x1___0.item.gsl_vector_memcpy (a_x).do_nothing
						a_dx.item.gsl_blas_daxpy (1.0, l_x1___0).do_nothing;
						(a_fdf.item.fdf).call ([l_x1___0, a_fdf.item.params, l_f1, l_g1])
						if l_f1.item > l_f0 then
							l_failed___0 := 1
							l_step := l_step * l_tol
							l_pos := -1 + 1 -- goto trial
						end
				when 2 then
						if l_failed___0.to_boolean then
							l_step := l_step * l_tol
						else
							l_step := l_step * (2.0)
						end
						l_state.item.step := l_step
						a_x.item.gsl_vector_memcpy (l_x1___0).do_nothing
						a_gradient.item.gsl_vector_memcpy (l_g1).do_nothing
						a_f.item := l_f1.item
						Result := 0
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	steepest_descent_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent steepest_descent_alloc)
		end

	steepest_descent_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent steepest_descent_free)
		end

	steepest_descent_restart_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent steepest_descent_restart)
		end

	steepest_descent_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent steepest_descent_iterate)
		end

end
