class
	P_TRANSPUTER_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	transputer_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("transputer"), {NATURAL_32} 4_294_967_295, {NATURAL_32} 1, (create {PD_TRANSPUTER_STATE_T}.make).structure_size.to_natural_32, transputer_set_address, transputer_get_address, transputer_get_double_address])
				>>)
		end

	gsl_rng_transputer: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := transputer_type.item
		end

feature {ANY} -- public routines

	transputer_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_TRANSPUTER_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_TRANSPUTER_STATE_T]}.make_cast (a_vstate)
			l_state.item.x := ({NATURAL_32} 1_664_525 * l_state.item.x).bit_and ({NATURAL_32} 4_294_967_295)
			Result := (l_state.item.x)
		end

	transputer_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((transputer_get (a_vstate)).to_real_64 / 4294967296.0)
		end

	transputer_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_TRANSPUTER_STATE_T]
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_TRANSPUTER_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := l_s
		end

feature {ANY} -- routine addresses

	transputer_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent transputer_get)
		end

	transputer_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent transputer_get_double)
		end

	transputer_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent transputer_set)
		end

end
