class
	P_UNI32_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	m1: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (2_147_483_647).to_natural_32
		end

	m2: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (65_536).to_natural_32
		end

	uni32_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("uni32"), {NATURAL_32} 2_147_483_646, {NATURAL_32} 0, (create {PD_UNI32_STATE_T}.make).structure_size.to_natural_32, uni32_set_address, uni32_get_address, uni32_get_double_address])
				>>)
		end

	gsl_rng_uni32: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := uni32_type.item
		end

feature {ANY} -- public routines

	uni32_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_UNI32_STATE_T]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
		do
			l_state := create {CE_CLASS_POINTER [PD_UNI32_STATE_T]}.make_cast (a_vstate)
			l_i := (l_state.item.i).to_integer_32
			l_j := (l_state.item.j).to_integer_32
			l_k := (l_state.item.m[l_i] - l_state.item.m[l_j]).to_integer_32
			if l_k < 0 then
				l_k := (l_k.to_natural_32 + m1.item).to_integer_32
			end
			l_state.item.m[l_j] := l_k.to_natural_32
			if l_i = 0 then
				l_state.item.i := 16
			else
				l_state.item.i := (l_state.item.i) - 1
			end
			if l_j = 0 then
				l_state.item.j := 16
			else
				l_state.item.j := (l_state.item.j) - 1
			end
			Result := l_k.to_natural_32
		end

	uni32_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((uni32_get (a_vstate)).to_real_64 / 2147483647.0)
		end

	uni32_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_seed: INTEGER_32
			l_k0: INTEGER_32
			l_k1: INTEGER_32
			l_j0: INTEGER_32
			l_j1: INTEGER_32
			l_i: INTEGER_32
			l_state: CE_POINTER [PD_UNI32_STATE_T]
			l_tmp: INTEGER_32
		do
			l_state := create {CE_CLASS_POINTER [PD_UNI32_STATE_T]}.make_cast (a_vstate)
			if a_s < m1.item then
				l_seed := a_s.to_integer_32
			else
				l_seed := m1.item.to_integer_32
			end
			if l_seed \\ 2 = 0 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			l_seed := l_seed - l_tmp.to_integer_32
			l_k0 := ({NATURAL_32} 9_069 \\ m2.item).to_integer_32
			l_k1 := ({NATURAL_32} 9_069 // m2.item).to_integer_32
			l_j0 := (l_seed.to_natural_32 \\ m2.item).to_integer_32
			l_j1 := (l_seed.to_natural_32 // m2.item).to_integer_32
			l_i := 0
			from
			until
				not (l_i < 17)
			loop
				l_seed := l_j0 * l_k0
				l_j1 := (((l_seed.to_natural_32 // m2.item + (l_j0 * l_k1).to_natural_32) + (l_j1 * l_k0).to_natural_32) \\ (m2.item // {NATURAL_32} 2)).to_integer_32
				l_j0 := (l_seed.to_natural_32 \\ m2.item).to_integer_32
				l_state.item.m[l_i] := (l_j0.to_natural_32 + m2.item * l_j1.to_natural_32)
				l_i := l_i + 1
			end
			l_state.item.i := 4
			l_state.item.j := 16
		end

feature {ANY} -- routine addresses

	uni32_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent uni32_get)
		end

	uni32_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent uni32_get_double)
		end

	uni32_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent uni32_set)
		end

end
