class
	P_VAX_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	vax_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("vax"), {NATURAL_32} 4_294_967_295, {NATURAL_32} 0, (create {PD_VAX_STATE_T}.make).structure_size.to_natural_32, vax_set_address, vax_get_address, vax_get_double_address])
				>>)
		end

	gsl_rng_vax: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := vax_type.item
		end

feature {ANY} -- public routines

	vax_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_VAX_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_VAX_STATE_T]}.make_cast (a_vstate)
			l_state.item.x := (({NATURAL_32} 69_069 * l_state.item.x + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
			Result := (l_state.item.x)
		end

	vax_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((vax_get (a_vstate)).to_real_64 / 4294967296.0)
		end

	vax_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_VAX_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_VAX_STATE_T]}.make_cast (a_vstate)
			l_state.item.x := a_s
		end

feature {ANY} -- routine addresses

	vax_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent vax_get)
		end

	vax_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent vax_get_double)
		end

	vax_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent vax_set)
		end

end
