class
	P_ZUF_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	zuf_randmax: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (16_777_216).to_natural_32
		end

	zuf_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("zuf"), {NATURAL_32} 16_777_215, {NATURAL_32} 0, (create {PD_ZUF_STATE_T}.make).structure_size.to_natural_32, zuf_set_address, zuf_get_address, zuf_get_double_address])
				>>)
		end

	gsl_rng_zuf: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := zuf_type.item
		end

feature {ANY} -- public routines

	zuf_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_ZUF_STATE_T]
			l_n: INTEGER_32
			l_m___4: INTEGER_32
			l_t: NATURAL_32
		do
			l_state := create {CE_CLASS_POINTER [PD_ZUF_STATE_T]}.make_cast (a_vstate)
			l_n := l_state.item.n
			l_m___4 := ((l_n - 273) + 607) \\ 607
			l_t := l_state.item.u[l_n] + l_state.item.u[l_m___4]
			from
			until
				not (l_t > zuf_randmax.item)
			loop
				l_t := l_t - zuf_randmax.item
			end
			l_state.item.u[l_n] := l_t
			if l_n = 606 then
				l_state.item.n := 0
			else
				l_state.item.n := l_n + 1
			end
			Result := l_t
		end

	zuf_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((zuf_get (a_vstate)).to_real_64 / 16777216.0)
		end

	zuf_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_kl: INTEGER_32
			l_ij: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_l: INTEGER_32
			l_m___4: INTEGER_32
			l_x: REAL_64
			l_y: REAL_64
			l_ii: INTEGER_32
			l_jj: INTEGER_32
			l_state: CE_POINTER [PD_ZUF_STATE_T]
			l_return: BOOLEAN
		do
			l_s := a_s
			l_kl := 9_373
			l_ij := 1_802
			l_state := create {CE_CLASS_POINTER [PD_ZUF_STATE_T]}.make_cast (a_vstate)
			l_state.item.n := 0
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1_802
			end
			l_ij := l_s.to_integer_32
			l_i := (l_ij // 177) \\ 177 + 2
			l_j := l_ij \\ 177 + 2
			l_k := (l_kl // 169) \\ 178 + 1
			l_l := l_kl \\ 169
			l_ii := 0
			from
			until
				not (not (l_return) and then (l_ii < 607))
			loop
				l_x := 0.0
				l_y := 0.5
				l_jj := 1
				from
				until
					not (l_jj <= 24)
				loop
					l_m___4 := (((l_i * l_j) \\ 179) * l_k) \\ 179
					l_i := l_j
					l_j := l_k
					l_k := l_m___4
					l_l := (l_l * 53 + 1) \\ 169
					if (l_l * l_m___4) \\ 64 >= 32 then
						l_x := l_x + l_y
					end
					l_y := l_y * (0.5)
					l_jj := l_jj + 1
				end
				l_state.item.u[l_ii] := (l_x * zuf_randmax.item.to_real_64).truncated_to_integer_64.to_natural_32
				l_ii := l_ii + 1
			end
		end

feature {ANY} -- routine addresses

	zuf_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent zuf_get)
		end

	zuf_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent zuf_get_double)
		end

	zuf_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent zuf_set)
		end

end
