class
	PD_BROYDEN_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} H.make
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} lu.make
			create {CE_CLASS_POINTER [PD_GSL_PERMUTATION_STRUCT]} permutation.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} v.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} w.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} y.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} p.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} fnew.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} x_trial.make
		end

feature {ANY} -- fields

	H: CE_POINTER [PD_GSL_MATRIX] assign set_H

	lu: CE_POINTER [PD_GSL_MATRIX] assign set_lu

	permutation: CE_POINTER [PD_GSL_PERMUTATION_STRUCT] assign set_permutation

	v: CE_POINTER [PD_GSL_VECTOR] assign set_v

	w: CE_POINTER [PD_GSL_VECTOR] assign set_w

	y: CE_POINTER [PD_GSL_VECTOR] assign set_y

	p: CE_POINTER [PD_GSL_VECTOR] assign set_p

	fnew: CE_POINTER [PD_GSL_VECTOR] assign set_fnew

	x_trial: CE_POINTER [PD_GSL_VECTOR] assign set_x_trial

	phi: REAL_64 assign set_phi

feature {ANY} -- field setters

	set_H (a_H: CE_POINTER [PD_GSL_MATRIX])
		do
			H := a_H
			update_memory_field ("H")
		end

	set_lu (a_lu: CE_POINTER [PD_GSL_MATRIX])
		do
			lu := a_lu
			update_memory_field ("lu")
		end

	set_permutation (a_permutation: CE_POINTER [PD_GSL_PERMUTATION_STRUCT])
		do
			permutation := a_permutation
			update_memory_field ("permutation")
		end

	set_v (a_v: CE_POINTER [PD_GSL_VECTOR])
		do
			v := a_v
			update_memory_field ("v")
		end

	set_w (a_w: CE_POINTER [PD_GSL_VECTOR])
		do
			w := a_w
			update_memory_field ("w")
		end

	set_y (a_y: CE_POINTER [PD_GSL_VECTOR])
		do
			y := a_y
			update_memory_field ("y")
		end

	set_p (a_p: CE_POINTER [PD_GSL_VECTOR])
		do
			p := a_p
			update_memory_field ("p")
		end

	set_fnew (a_fnew: CE_POINTER [PD_GSL_VECTOR])
		do
			fnew := a_fnew
			update_memory_field ("fnew")
		end

	set_x_trial (a_x_trial: CE_POINTER [PD_GSL_VECTOR])
		do
			x_trial := a_x_trial
			update_memory_field ("x_trial")
		end

	set_phi (a_phi: REAL_64)
		do
			phi := a_phi
			update_memory_field ("phi")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			H := a_other.H
			lu := a_other.lu
			permutation := a_other.permutation
			v := a_other.v
			w := a_other.w
			y := a_other.y
			p := a_other.p
			fnew := a_other.fnew
			x_trial := a_other.x_trial
			phi := a_other.phi
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				H.is_equal (a_other.H) and
				lu.is_equal (a_other.lu) and
				permutation.is_equal (a_other.permutation) and
				v.is_equal (a_other.v) and
				w.is_equal (a_other.w) and
				y.is_equal (a_other.y) and
				p.is_equal (a_other.p) and
				fnew.is_equal (a_other.fnew) and
				x_trial.is_equal (a_other.x_trial) and
				phi = a_other.phi
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("H"),
					create {CE_STRUCTURE_FIELD}.make ("lu"),
					create {CE_STRUCTURE_FIELD}.make ("permutation"),
					create {CE_STRUCTURE_FIELD}.make ("v"),
					create {CE_STRUCTURE_FIELD}.make ("w"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("p"),
					create {CE_STRUCTURE_FIELD}.make ("fnew"),
					create {CE_STRUCTURE_FIELD}.make ("x_trial"),
					create {CE_STRUCTURE_FIELD}.make ("phi")
				>>)
			init_structure_info
		end

end
