class
	PD_BSIMP_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} d.make
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} a_mat.make
			create {CE_CLASS_POINTER [PD_GSL_PERMUTATION_STRUCT]} p_vec.make
			create {CE_REAL_64_ARRAY} x.make (<<7>>)
			create {CE_REAL_64_POINTER} yp.make
			create {CE_REAL_64_POINTER} y_save.make
			create {CE_REAL_64_POINTER} yerr_save.make
			create {CE_REAL_64_POINTER} y_extrap_save.make
			create {CE_REAL_64_POINTER} y_extrap_sequence.make
			create {CE_REAL_64_POINTER} extrap_work.make
			create {CE_REAL_64_POINTER} dfdt.make
			create {CE_REAL_64_POINTER} y_temp.make
			create {CE_REAL_64_POINTER} delta_temp.make
			create {CE_REAL_64_POINTER} weight.make
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} dfdy.make
			create {CE_REAL_64_POINTER} rhs_temp.make
			create {CE_REAL_64_POINTER} delta.make
		end

feature {ANY} -- fields

	d: CE_POINTER [PD_GSL_MATRIX] assign set_d

	a_mat: CE_POINTER [PD_GSL_MATRIX] assign set_a_mat

	p_vec: CE_POINTER [PD_GSL_PERMUTATION_STRUCT] assign set_p_vec

	x: CE_ARRAY [REAL_64]

	k_current: NATURAL_32 assign set_k_current

	k_choice: NATURAL_32 assign set_k_choice

	h_next: REAL_64 assign set_h_next

	eps: REAL_64 assign set_eps

	yp: CE_POINTER [REAL_64] assign set_yp

	y_save: CE_POINTER [REAL_64] assign set_y_save

	yerr_save: CE_POINTER [REAL_64] assign set_yerr_save

	y_extrap_save: CE_POINTER [REAL_64] assign set_y_extrap_save

	y_extrap_sequence: CE_POINTER [REAL_64] assign set_y_extrap_sequence

	extrap_work: CE_POINTER [REAL_64] assign set_extrap_work

	dfdt: CE_POINTER [REAL_64] assign set_dfdt

	y_temp: CE_POINTER [REAL_64] assign set_y_temp

	delta_temp: CE_POINTER [REAL_64] assign set_delta_temp

	weight: CE_POINTER [REAL_64] assign set_weight

	dfdy: CE_POINTER [PD_GSL_MATRIX] assign set_dfdy

	rhs_temp: CE_POINTER [REAL_64] assign set_rhs_temp

	delta: CE_POINTER [REAL_64] assign set_delta

	order: NATURAL_32 assign set_order

feature {ANY} -- field setters

	set_d (a_d: CE_POINTER [PD_GSL_MATRIX])
		do
			d := a_d
			update_memory_field ("d")
		end

	set_a_mat (a_a_mat: CE_POINTER [PD_GSL_MATRIX])
		do
			a_mat := a_a_mat
			update_memory_field ("a_mat")
		end

	set_p_vec (a_p_vec: CE_POINTER [PD_GSL_PERMUTATION_STRUCT])
		do
			p_vec := a_p_vec
			update_memory_field ("p_vec")
		end

	set_k_current (a_k_current: NATURAL_32)
		do
			k_current := a_k_current
			update_memory_field ("k_current")
		end

	set_k_choice (a_k_choice: NATURAL_32)
		do
			k_choice := a_k_choice
			update_memory_field ("k_choice")
		end

	set_h_next (a_h_next: REAL_64)
		do
			h_next := a_h_next
			update_memory_field ("h_next")
		end

	set_eps (a_eps: REAL_64)
		do
			eps := a_eps
			update_memory_field ("eps")
		end

	set_yp (a_yp: CE_POINTER [REAL_64])
		do
			yp := a_yp
			update_memory_field ("yp")
		end

	set_y_save (a_y_save: CE_POINTER [REAL_64])
		do
			y_save := a_y_save
			update_memory_field ("y_save")
		end

	set_yerr_save (a_yerr_save: CE_POINTER [REAL_64])
		do
			yerr_save := a_yerr_save
			update_memory_field ("yerr_save")
		end

	set_y_extrap_save (a_y_extrap_save: CE_POINTER [REAL_64])
		do
			y_extrap_save := a_y_extrap_save
			update_memory_field ("y_extrap_save")
		end

	set_y_extrap_sequence (a_y_extrap_sequence: CE_POINTER [REAL_64])
		do
			y_extrap_sequence := a_y_extrap_sequence
			update_memory_field ("y_extrap_sequence")
		end

	set_extrap_work (a_extrap_work: CE_POINTER [REAL_64])
		do
			extrap_work := a_extrap_work
			update_memory_field ("extrap_work")
		end

	set_dfdt (a_dfdt: CE_POINTER [REAL_64])
		do
			dfdt := a_dfdt
			update_memory_field ("dfdt")
		end

	set_y_temp (a_y_temp: CE_POINTER [REAL_64])
		do
			y_temp := a_y_temp
			update_memory_field ("y_temp")
		end

	set_delta_temp (a_delta_temp: CE_POINTER [REAL_64])
		do
			delta_temp := a_delta_temp
			update_memory_field ("delta_temp")
		end

	set_weight (a_weight: CE_POINTER [REAL_64])
		do
			weight := a_weight
			update_memory_field ("weight")
		end

	set_dfdy (a_dfdy: CE_POINTER [PD_GSL_MATRIX])
		do
			dfdy := a_dfdy
			update_memory_field ("dfdy")
		end

	set_rhs_temp (a_rhs_temp: CE_POINTER [REAL_64])
		do
			rhs_temp := a_rhs_temp
			update_memory_field ("rhs_temp")
		end

	set_delta (a_delta: CE_POINTER [REAL_64])
		do
			delta := a_delta
			update_memory_field ("delta")
		end

	set_order (a_order: NATURAL_32)
		do
			order := a_order
			update_memory_field ("order")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			d := a_other.d
			a_mat := a_other.a_mat
			p_vec := a_other.p_vec
			x := a_other.x.twin
			k_current := a_other.k_current
			k_choice := a_other.k_choice
			h_next := a_other.h_next
			eps := a_other.eps
			yp := a_other.yp
			y_save := a_other.y_save
			yerr_save := a_other.yerr_save
			y_extrap_save := a_other.y_extrap_save
			y_extrap_sequence := a_other.y_extrap_sequence
			extrap_work := a_other.extrap_work
			dfdt := a_other.dfdt
			y_temp := a_other.y_temp
			delta_temp := a_other.delta_temp
			weight := a_other.weight
			dfdy := a_other.dfdy
			rhs_temp := a_other.rhs_temp
			delta := a_other.delta
			order := a_other.order
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				d.is_equal (a_other.d) and
				a_mat.is_equal (a_other.a_mat) and
				p_vec.is_equal (a_other.p_vec) and
				x.is_equal (a_other.x) and
				k_current = a_other.k_current and
				k_choice = a_other.k_choice and
				h_next = a_other.h_next and
				eps = a_other.eps and
				yp.is_equal (a_other.yp) and
				y_save.is_equal (a_other.y_save) and
				yerr_save.is_equal (a_other.yerr_save) and
				y_extrap_save.is_equal (a_other.y_extrap_save) and
				y_extrap_sequence.is_equal (a_other.y_extrap_sequence) and
				extrap_work.is_equal (a_other.extrap_work) and
				dfdt.is_equal (a_other.dfdt) and
				y_temp.is_equal (a_other.y_temp) and
				delta_temp.is_equal (a_other.delta_temp) and
				weight.is_equal (a_other.weight) and
				dfdy.is_equal (a_other.dfdy) and
				rhs_temp.is_equal (a_other.rhs_temp) and
				delta.is_equal (a_other.delta) and
				order = a_other.order
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("d"),
					create {CE_STRUCTURE_FIELD}.make ("a_mat"),
					create {CE_STRUCTURE_FIELD}.make ("p_vec"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("x", <<7>>),
					create {CE_STRUCTURE_FIELD}.make ("k_current"),
					create {CE_STRUCTURE_FIELD}.make ("k_choice"),
					create {CE_STRUCTURE_FIELD}.make ("h_next"),
					create {CE_STRUCTURE_FIELD}.make ("eps"),
					create {CE_STRUCTURE_FIELD}.make ("yp"),
					create {CE_STRUCTURE_FIELD}.make ("y_save"),
					create {CE_STRUCTURE_FIELD}.make ("yerr_save"),
					create {CE_STRUCTURE_FIELD}.make ("y_extrap_save"),
					create {CE_STRUCTURE_FIELD}.make ("y_extrap_sequence"),
					create {CE_STRUCTURE_FIELD}.make ("extrap_work"),
					create {CE_STRUCTURE_FIELD}.make ("dfdt"),
					create {CE_STRUCTURE_FIELD}.make ("y_temp"),
					create {CE_STRUCTURE_FIELD}.make ("delta_temp"),
					create {CE_STRUCTURE_FIELD}.make ("weight"),
					create {CE_STRUCTURE_FIELD}.make ("dfdy"),
					create {CE_STRUCTURE_FIELD}.make ("rhs_temp"),
					create {CE_STRUCTURE_FIELD}.make ("delta"),
					create {CE_STRUCTURE_FIELD}.make ("order")
				>>)
			init_structure_info
		end

end
