class
	PD_FN_CAUCHY_PARAMS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_FUNCTION_STRUCT]} function.make
		end

feature {ANY} -- fields

	function: CE_POINTER [PD_GSL_FUNCTION_STRUCT] assign set_function

	singularity: REAL_64 assign set_singularity

feature {ANY} -- field setters

	set_function (a_function: CE_POINTER [PD_GSL_FUNCTION_STRUCT])
		do
			function := a_function
			update_memory_field ("function")
		end

	set_singularity (a_singularity: REAL_64)
		do
			singularity := a_singularity
			update_memory_field ("singularity")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			function := a_other.function
			singularity := a_other.singularity
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				function.is_equal (a_other.function) and
				singularity = a_other.singularity
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("function"),
					create {CE_STRUCTURE_FIELD}.make ("singularity")
				>>)
			init_structure_info
		end

end
