class
	PD_GSL_EIGEN_FRANCIS_WORKSPACE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} H.make
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} Z.make
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	max_iterations: NATURAL_32 assign set_max_iterations

	n_iter: NATURAL_32 assign set_n_iter

	n_evals: NATURAL_32 assign set_n_evals

	compute_t: INTEGER_32 assign set_compute_t

	H: CE_POINTER [PD_GSL_MATRIX] assign set_H

	Z: CE_POINTER [PD_GSL_MATRIX] assign set_Z

feature {ANY} -- field setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_max_iterations (a_max_iterations: NATURAL_32)
		do
			max_iterations := a_max_iterations
			update_memory_field ("max_iterations")
		end

	set_n_iter (a_n_iter: NATURAL_32)
		do
			n_iter := a_n_iter
			update_memory_field ("n_iter")
		end

	set_n_evals (a_n_evals: NATURAL_32)
		do
			n_evals := a_n_evals
			update_memory_field ("n_evals")
		end

	set_compute_t (a_compute_t: INTEGER_32)
		do
			compute_t := a_compute_t
			update_memory_field ("compute_t")
		end

	set_H (a_H: CE_POINTER [PD_GSL_MATRIX])
		do
			H := a_H
			update_memory_field ("H")
		end

	set_Z (a_Z: CE_POINTER [PD_GSL_MATRIX])
		do
			Z := a_Z
			update_memory_field ("Z")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			max_iterations := a_other.max_iterations
			n_iter := a_other.n_iter
			n_evals := a_other.n_evals
			compute_t := a_other.compute_t
			H := a_other.H
			Z := a_other.Z
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				max_iterations = a_other.max_iterations and
				n_iter = a_other.n_iter and
				n_evals = a_other.n_evals and
				compute_t = a_other.compute_t and
				H.is_equal (a_other.H) and
				Z.is_equal (a_other.Z)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("max_iterations"),
					create {CE_STRUCTURE_FIELD}.make ("n_iter"),
					create {CE_STRUCTURE_FIELD}.make ("n_evals"),
					create {CE_STRUCTURE_FIELD}.make ("compute_t"),
					create {CE_STRUCTURE_FIELD}.make ("H"),
					create {CE_STRUCTURE_FIELD}.make ("Z")
				>>)
			init_structure_info
		end

end
