class
	PD_GSL_EIGEN_GENHERMV_WORKSPACE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]} hermv_workspace_p.make
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	hermv_workspace_p: CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE] assign set_hermv_workspace_p

feature {ANY} -- field setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_hermv_workspace_p (a_hermv_workspace_p: CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE])
		do
			hermv_workspace_p := a_hermv_workspace_p
			update_memory_field ("hermv_workspace_p")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			hermv_workspace_p := a_other.hermv_workspace_p
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				hermv_workspace_p.is_equal (a_other.hermv_workspace_p)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("hermv_workspace_p")
				>>)
			init_structure_info
		end

end
