class
	PD_GSL_EIGEN_GENV_WORKSPACE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} work1.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} work2.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} work3.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} work4.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} work5.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} work6.make
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} Q.make
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} Z.make
			create {CE_CLASS_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]} gen_workspace_p.make
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	work1: CE_POINTER [PD_GSL_VECTOR] assign set_work1

	work2: CE_POINTER [PD_GSL_VECTOR] assign set_work2

	work3: CE_POINTER [PD_GSL_VECTOR] assign set_work3

	work4: CE_POINTER [PD_GSL_VECTOR] assign set_work4

	work5: CE_POINTER [PD_GSL_VECTOR] assign set_work5

	work6: CE_POINTER [PD_GSL_VECTOR] assign set_work6

	Q: CE_POINTER [PD_GSL_MATRIX] assign set_Q

	Z: CE_POINTER [PD_GSL_MATRIX] assign set_Z

	gen_workspace_p: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE] assign set_gen_workspace_p

feature {ANY} -- field setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_work1 (a_work1: CE_POINTER [PD_GSL_VECTOR])
		do
			work1 := a_work1
			update_memory_field ("work1")
		end

	set_work2 (a_work2: CE_POINTER [PD_GSL_VECTOR])
		do
			work2 := a_work2
			update_memory_field ("work2")
		end

	set_work3 (a_work3: CE_POINTER [PD_GSL_VECTOR])
		do
			work3 := a_work3
			update_memory_field ("work3")
		end

	set_work4 (a_work4: CE_POINTER [PD_GSL_VECTOR])
		do
			work4 := a_work4
			update_memory_field ("work4")
		end

	set_work5 (a_work5: CE_POINTER [PD_GSL_VECTOR])
		do
			work5 := a_work5
			update_memory_field ("work5")
		end

	set_work6 (a_work6: CE_POINTER [PD_GSL_VECTOR])
		do
			work6 := a_work6
			update_memory_field ("work6")
		end

	set_Q (a_Q: CE_POINTER [PD_GSL_MATRIX])
		do
			Q := a_Q
			update_memory_field ("Q")
		end

	set_Z (a_Z: CE_POINTER [PD_GSL_MATRIX])
		do
			Z := a_Z
			update_memory_field ("Z")
		end

	set_gen_workspace_p (a_gen_workspace_p: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE])
		do
			gen_workspace_p := a_gen_workspace_p
			update_memory_field ("gen_workspace_p")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			work1 := a_other.work1
			work2 := a_other.work2
			work3 := a_other.work3
			work4 := a_other.work4
			work5 := a_other.work5
			work6 := a_other.work6
			Q := a_other.Q
			Z := a_other.Z
			gen_workspace_p := a_other.gen_workspace_p
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				work1.is_equal (a_other.work1) and
				work2.is_equal (a_other.work2) and
				work3.is_equal (a_other.work3) and
				work4.is_equal (a_other.work4) and
				work5.is_equal (a_other.work5) and
				work6.is_equal (a_other.work6) and
				Q.is_equal (a_other.Q) and
				Z.is_equal (a_other.Z) and
				gen_workspace_p.is_equal (a_other.gen_workspace_p)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("work1"),
					create {CE_STRUCTURE_FIELD}.make ("work2"),
					create {CE_STRUCTURE_FIELD}.make ("work3"),
					create {CE_STRUCTURE_FIELD}.make ("work4"),
					create {CE_STRUCTURE_FIELD}.make ("work5"),
					create {CE_STRUCTURE_FIELD}.make ("work6"),
					create {CE_STRUCTURE_FIELD}.make ("Q"),
					create {CE_STRUCTURE_FIELD}.make ("Z"),
					create {CE_STRUCTURE_FIELD}.make ("gen_workspace_p")
				>>)
			init_structure_info
		end

end
