class
	PD_GSL_INTERP

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_INTERP_TYPE]} type.make
			create {CE_VOID_POINTER} state.make
		end

feature {ANY} -- fields

	type: CE_POINTER [PD_GSL_INTERP_TYPE] assign set_type

	xmin: REAL_64 assign set_xmin

	xmax: REAL_64 assign set_xmax

	size: NATURAL_32 assign set_size

	state: CE_POINTER [ANY] assign set_state

feature {ANY} -- field setters

	set_type (a_type: CE_POINTER [PD_GSL_INTERP_TYPE])
		do
			type := a_type
			update_memory_field ("type")
		end

	set_xmin (a_xmin: REAL_64)
		do
			xmin := a_xmin
			update_memory_field ("xmin")
		end

	set_xmax (a_xmax: REAL_64)
		do
			xmax := a_xmax
			update_memory_field ("xmax")
		end

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			state := a_state
			update_memory_field ("state")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			xmin := a_other.xmin
			xmax := a_other.xmax
			size := a_other.size
			state := a_other.state
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type.is_equal (a_other.type) and
				xmin = a_other.xmin and
				xmax = a_other.xmax and
				size = a_other.size and
				state.is_equal (a_other.state)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("xmin"),
					create {CE_STRUCTURE_FIELD}.make ("xmax"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("state")
				>>)
			init_structure_info
		end

end
