class
	PD_GSL_MONTE_VEGAS_STATE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_MATH_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_REAL_64_POINTER} xi.make
			create {CE_REAL_64_POINTER} xin.make
			create {CE_REAL_64_POINTER} delx.make
			create {CE_REAL_64_POINTER} weight.make
			create {CE_REAL_64_POINTER} x.make
			create {CE_INTEGER_32_POINTER} bin.make
			create {CE_INTEGER_32_POINTER} box.make
			create {CE_REAL_64_POINTER} d.make
			create {CE_CLASS_POINTER [SD_IO_FILE]} ostream.make
			Precursor
		end

feature {ANY} -- fields

	dim: NATURAL_32 assign set_dim

	bins_max: NATURAL_32 assign set_bins_max

	bins: NATURAL_32 assign set_bins

	boxes: NATURAL_32 assign set_boxes

	xi: CE_POINTER [REAL_64] assign set_xi

	xin: CE_POINTER [REAL_64] assign set_xin

	delx: CE_POINTER [REAL_64] assign set_delx

	weight: CE_POINTER [REAL_64] assign set_weight

	vol: REAL_64 assign set_vol

	x: CE_POINTER [REAL_64] assign set_x

	bin: CE_POINTER [INTEGER_32] assign set_bin

	box: CE_POINTER [INTEGER_32] assign set_box

	d: CE_POINTER [REAL_64] assign set_d

	alpha: REAL_64 assign set_alpha

	mode: INTEGER_32 assign set_mode

	verbose: INTEGER_32 assign set_verbose

	iterations: NATURAL_32 assign set_iterations

	stage: INTEGER_32 assign set_stage

	jac: REAL_64 assign set_jac

	wtd_int_sum: REAL_64 assign set_wtd_int_sum

	sum_wgts: REAL_64 assign set_sum_wgts

	chi_sum: REAL_64 assign set_chi_sum

	chisq: REAL_64 assign set_chisq

	result2: REAL_64 assign set_result2

	sigma: REAL_64 assign set_sigma

	it_start: NATURAL_32 assign set_it_start

	it_num: NATURAL_32 assign set_it_num

	samples: NATURAL_32 assign set_samples

	calls_per_box: NATURAL_32 assign set_calls_per_box

	ostream: CE_POINTER [SD_IO_FILE] assign set_ostream

feature {ANY} -- field setters

	set_dim (a_dim: NATURAL_32)
		do
			dim := a_dim
			update_memory_field ("dim")
		end

	set_bins_max (a_bins_max: NATURAL_32)
		do
			bins_max := a_bins_max
			update_memory_field ("bins_max")
		end

	set_bins (a_bins: NATURAL_32)
		do
			bins := a_bins
			update_memory_field ("bins")
		end

	set_boxes (a_boxes: NATURAL_32)
		do
			boxes := a_boxes
			update_memory_field ("boxes")
		end

	set_xi (a_xi: CE_POINTER [REAL_64])
		do
			xi := a_xi
			update_memory_field ("xi")
		end

	set_xin (a_xin: CE_POINTER [REAL_64])
		do
			xin := a_xin
			update_memory_field ("xin")
		end

	set_delx (a_delx: CE_POINTER [REAL_64])
		do
			delx := a_delx
			update_memory_field ("delx")
		end

	set_weight (a_weight: CE_POINTER [REAL_64])
		do
			weight := a_weight
			update_memory_field ("weight")
		end

	set_vol (a_vol: REAL_64)
		do
			vol := a_vol
			update_memory_field ("vol")
		end

	set_x (a_x: CE_POINTER [REAL_64])
		do
			x := a_x
			update_memory_field ("x")
		end

	set_bin (a_bin: CE_POINTER [INTEGER_32])
		do
			bin := a_bin
			update_memory_field ("bin")
		end

	set_box (a_box: CE_POINTER [INTEGER_32])
		do
			box := a_box
			update_memory_field ("box")
		end

	set_d (a_d: CE_POINTER [REAL_64])
		do
			d := a_d
			update_memory_field ("d")
		end

	set_alpha (a_alpha: REAL_64)
		do
			alpha := a_alpha
			update_memory_field ("alpha")
		end

	set_mode (a_mode: INTEGER_32)
		do
			mode := a_mode
			update_memory_field ("mode")
		end

	set_verbose (a_verbose: INTEGER_32)
		do
			verbose := a_verbose
			update_memory_field ("verbose")
		end

	set_iterations (a_iterations: NATURAL_32)
		do
			iterations := a_iterations
			update_memory_field ("iterations")
		end

	set_stage (a_stage: INTEGER_32)
		do
			stage := a_stage
			update_memory_field ("stage")
		end

	set_jac (a_jac: REAL_64)
		do
			jac := a_jac
			update_memory_field ("jac")
		end

	set_wtd_int_sum (a_wtd_int_sum: REAL_64)
		do
			wtd_int_sum := a_wtd_int_sum
			update_memory_field ("wtd_int_sum")
		end

	set_sum_wgts (a_sum_wgts: REAL_64)
		do
			sum_wgts := a_sum_wgts
			update_memory_field ("sum_wgts")
		end

	set_chi_sum (a_chi_sum: REAL_64)
		do
			chi_sum := a_chi_sum
			update_memory_field ("chi_sum")
		end

	set_chisq (a_chisq: REAL_64)
		do
			chisq := a_chisq
			update_memory_field ("chisq")
		end

	set_result2 (a_result2: REAL_64)
		do
			result2 := a_result2
			update_memory_field ("result2")
		end

	set_sigma (a_sigma: REAL_64)
		do
			sigma := a_sigma
			update_memory_field ("sigma")
		end

	set_it_start (a_it_start: NATURAL_32)
		do
			it_start := a_it_start
			update_memory_field ("it_start")
		end

	set_it_num (a_it_num: NATURAL_32)
		do
			it_num := a_it_num
			update_memory_field ("it_num")
		end

	set_samples (a_samples: NATURAL_32)
		do
			samples := a_samples
			update_memory_field ("samples")
		end

	set_calls_per_box (a_calls_per_box: NATURAL_32)
		do
			calls_per_box := a_calls_per_box
			update_memory_field ("calls_per_box")
		end

	set_ostream (a_ostream: CE_POINTER [SD_IO_FILE])
		do
			ostream := a_ostream
			update_memory_field ("ostream")
		end

feature {ANY} -- public routines

	gsl_monte_vegas_init: INTEGER_32
		do
			Current.stage := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.alpha := 1.5
			update_class_fields -- Current might have been changed; synchronize
			Current.verbose := -1
			update_class_fields -- Current might have been changed; synchronize
			Current.iterations := {NATURAL_32} 5
			update_class_fields -- Current might have been changed; synchronize
			Current.mode := 1
			update_class_fields -- Current might have been changed; synchronize
			Current.chisq := (0).to_double
			update_class_fields -- Current might have been changed; synchronize
			Current.bins := bins_max
			update_class_fields -- Current might have been changed; synchronize
			Current.ostream := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	gsl_monte_vegas_chisq: REAL_64
		do
			Result := chisq
		end

	gsl_monte_vegas_runval (a_result, a_sigma: CE_POINTER [REAL_64])
		require
			not a_result.is_void
			not a_sigma.is_void
		do
			a_result.item := result2
			update_class_fields -- Current might have been changed; synchronize
			a_sigma.item := sigma
			update_class_fields -- Current might have been changed; synchronize
		end

	gsl_monte_vegas_params_get (a_p: CE_POINTER [PD_GSL_MONTE_VEGAS_PARAMS])
		require
			not a_p.is_void
		do
			a_p.item.alpha := alpha
			update_class_fields -- Current might have been changed; synchronize
			a_p.item.iterations := iterations
			update_class_fields -- Current might have been changed; synchronize
			a_p.item.stage := stage
			update_class_fields -- Current might have been changed; synchronize
			a_p.item.mode := mode
			update_class_fields -- Current might have been changed; synchronize
			a_p.item.verbose := verbose
			update_class_fields -- Current might have been changed; synchronize
			a_p.item.ostream := ostream
			update_class_fields -- Current might have been changed; synchronize
		end

	gsl_monte_vegas_params_set (a_p: CE_POINTER [PD_GSL_MONTE_VEGAS_PARAMS])
		require
			not a_p.is_void
		do
			Current.alpha := a_p.item.alpha
			update_class_fields -- Current might have been changed; synchronize
			Current.iterations := a_p.item.iterations
			update_class_fields -- Current might have been changed; synchronize
			Current.stage := a_p.item.stage
			update_class_fields -- Current might have been changed; synchronize
			Current.mode := a_p.item.mode
			update_class_fields -- Current might have been changed; synchronize
			Current.verbose := a_p.item.verbose
			update_class_fields -- Current might have been changed; synchronize
			Current.ostream := a_p.item.ostream
			update_class_fields -- Current might have been changed; synchronize
		end

	init_box_coord (a_box: CE_POINTER [INTEGER_32])
		local
			l_i: NATURAL_32
			l_dim: NATURAL_32
		do
			l_dim := dim
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_dim)
			loop
				a_box[l_i.to_integer_32] := 0
				update_class_fields -- Current might have been changed; synchronize
				l_i := l_i + 1
			end
		end

	change_box_coord (a_box: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_j: INTEGER_32
			l_ng: INTEGER_32
			l_return: BOOLEAN
		do
			l_j := (dim - {NATURAL_32} 1).to_integer_32
			l_ng := boxes.to_integer_32
			from
			until
				not (not (l_return) and then (l_j >= 0))
			loop
				a_box[l_j] := (a_box[l_j] + 1) \\ l_ng
				update_class_fields -- Current might have been changed; synchronize
				if a_box[l_j] /= 0 then
					Result := 1
					l_return := True
				end
				if not l_return then
					l_j := l_j - 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	init_grid (a_xl, a_xu: CE_POINTER [REAL_64]; a_dim: NATURAL_32)
		local
			l_j: NATURAL_32
			l_vol: REAL_64
			l_dx: REAL_64
		do
			l_vol := 1.0
			Current.bins := {NATURAL_32} 1
			update_class_fields -- Current might have been changed; synchronize
			l_j := (0).to_natural_32
			from
			until
				not (l_j < a_dim)
			loop
				l_dx := a_xu[l_j.to_integer_32] - a_xl[l_j.to_integer_32]
				delx[l_j.to_integer_32] := l_dx
				update_class_fields -- Current might have been changed; synchronize
				l_vol := l_vol * l_dx
				xi[l_j.to_integer_32] := 0.0
				update_class_fields -- Current might have been changed; synchronize
				xi[(dim + l_j).to_integer_32] := 1.0
				update_class_fields -- Current might have been changed; synchronize
				l_j := l_j + 1
			end
			Current.vol := l_vol
			update_class_fields -- Current might have been changed; synchronize
		end

	reset_grid_values
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_dim: NATURAL_32
			l_bins: NATURAL_32
			l_return: BOOLEAN
		do
			l_dim := dim
			l_bins := bins
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_bins))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_dim)
				loop
					d[(l_i * dim + l_j).to_integer_32] := 0.0
					update_class_fields -- Current might have been changed; synchronize
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
		end

	accumulate_distribution (a_bin: CE_POINTER [INTEGER_32]; a_y: REAL_64)
		local
			l_j: NATURAL_32
			l_dim: NATURAL_32
			l_i: INTEGER_32
		do
			l_dim := dim
			l_j := (0).to_natural_32
			from
			until
				not (l_j < l_dim)
			loop
				l_i := a_bin[l_j.to_integer_32]
				d[(l_i.to_natural_32 * dim + l_j).to_integer_32] := d[(l_i.to_natural_32 * dim + l_j).to_integer_32] + a_y
				update_class_fields -- Current might have been changed; synchronize
				l_j := l_j + 1
			end
		end

	random_point (a_x: CE_POINTER [REAL_64]; a_bin: CE_POINTER [INTEGER_32]; a_bin_vol: CE_POINTER [REAL_64]; a_box: CE_POINTER [INTEGER_32]; a_xl, a_xu: CE_POINTER [REAL_64]; a_r___3: CE_POINTER [PD_GSL_RNG])
		require
			not a_bin_vol.is_void
		local
			l_vol: REAL_64
			l_j: NATURAL_32
			l_dim: NATURAL_32
			l_bins: NATURAL_32
			l_boxes: NATURAL_32
			l_tmp: INTEGER_32
			l_z: REAL_64
			l_tmp___0: REAL_64
			l_k: INTEGER_32
			l_y: REAL_64
			l_bin_width: REAL_64
			l_break: BOOLEAN
		do
			l_vol := 1.0
			l_dim := dim
			l_bins := bins
			l_boxes := boxes
			from
			until
				(l_break)
			loop
				l_break := False
				if (not a_xu.is_void) then
					l_tmp := 0
				else
					l_tmp := 0
				end
				if not l_tmp.to_boolean then
					l_break := True
				end
			end
			l_break := False
			l_j := (0).to_natural_32
			from
			until
				not (l_j < l_dim)
			loop
				l_tmp___0 := a_r___3.item.gsl_rng_uniform_pos
				update_class_fields -- Current might have been changed; synchronize
				l_z := (((a_box[l_j.to_integer_32]).to_double + l_tmp___0) / l_boxes.to_real_64) * l_bins.to_real_64
				l_k := l_z.truncated_to_integer
				a_bin[l_j.to_integer_32] := l_k
				update_class_fields -- Current might have been changed; synchronize
				if l_k = 0 then
					l_bin_width := xi[(dim + l_j).to_integer_32]
					l_y := l_z * l_bin_width
				else
					l_bin_width := xi[((l_k + 1).to_natural_32 * dim + l_j).to_integer_32] - xi[(l_k.to_natural_32 * dim + l_j).to_integer_32]
					l_y := xi[(l_k.to_natural_32 * dim + l_j).to_integer_32] + (l_z - l_k.to_double) * l_bin_width
				end
				a_x[l_j.to_integer_32] := (a_xl[l_j.to_integer_32] + (l_y * delx[l_j.to_integer_32]))
				update_class_fields -- Current might have been changed; synchronize
				l_vol := l_vol * l_bin_width
				l_j := l_j + 1
			end
			a_bin_vol.item := l_vol
			update_class_fields -- Current might have been changed; synchronize
		end

	resize_grid (a_bins: NATURAL_32)
		local
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_dim: NATURAL_32
			l_pts_per_bin: REAL_64
			l_xold: REAL_64
			l_xnew: REAL_64
			l_dw: REAL_64
			l_i: INTEGER_32
			l_return: BOOLEAN
		do
			l_dim := dim
			l_pts_per_bin := bins.to_real_64 / a_bins.to_real_64
			l_j := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_j < l_dim))
			loop
				l_xnew := (0).to_double
				l_dw := (0).to_double
				l_i := 1
				l_k := (1).to_natural_32
				from
				until
					not (not (l_return) and then (l_k <= bins))
				loop
					l_dw := l_dw + (1.0)
					l_xold := l_xnew
					l_xnew := xi[(l_k * dim + l_j).to_integer_32]
					from
					until
						not (l_dw > l_pts_per_bin)
					loop
						l_dw := l_dw - l_pts_per_bin
						xin[l_i] := l_xnew - (l_xnew - l_xold) * l_dw
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i + 1
					end
					l_k := l_k + 1
				end
				l_k := (1).to_natural_32
				from
				until
					not (l_k < a_bins)
				loop
					xi[(l_k * dim + l_j).to_integer_32] := xin[l_k.to_integer_32]
					update_class_fields -- Current might have been changed; synchronize
					l_k := l_k + 1
				end
				xi[(a_bins * dim + l_j).to_integer_32] := (1).to_double
				update_class_fields -- Current might have been changed; synchronize
				l_j := l_j + 1
			end
			Current.bins := a_bins
			update_class_fields -- Current might have been changed; synchronize
		end

	refine_grid
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_dim: NATURAL_32
			l_bins: NATURAL_32
			l_grid_tot_j: REAL_64
			l_tot_weight: REAL_64
			l_weight: CE_POINTER [REAL_64]
			l_oldg: REAL_64
			l_newg: REAL_64
			l_rc: REAL_64
			l_tmp: REAL_64
			l_pts_per_bin: REAL_64
			l_xold: REAL_64
			l_xnew: REAL_64
			l_dw: REAL_64
			l_return: BOOLEAN
		do
			l_dim := dim
			l_bins := bins
			l_j := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_j < l_dim))
			loop
				l_weight := weight
				l_oldg := d[l_j.to_integer_32]
				l_newg := d[(dim + l_j).to_integer_32]
				d[l_j.to_integer_32] := (l_oldg + l_newg) / (2).to_double
				update_class_fields -- Current might have been changed; synchronize
				l_grid_tot_j := d[l_j.to_integer_32]
				l_i := (1).to_natural_32
				from
				until
					not (l_i < l_bins - {NATURAL_32} 1)
				loop
					l_rc := l_oldg + l_newg
					l_oldg := l_newg
					l_newg := d[((l_i + {NATURAL_32} 1) * dim + l_j).to_integer_32]
					d[(l_i * dim + l_j).to_integer_32] := (l_rc + l_newg) / (3).to_double
					update_class_fields -- Current might have been changed; synchronize
					l_grid_tot_j := l_grid_tot_j + (d[(l_i * dim + l_j).to_integer_32])
					l_i := l_i + 1
				end
				d[((l_bins - {NATURAL_32} 1) * dim + l_j).to_integer_32] := (l_newg + l_oldg) / (2).to_double
				update_class_fields -- Current might have been changed; synchronize
				l_grid_tot_j := l_grid_tot_j + (d[((l_bins - {NATURAL_32} 1) * dim + l_j).to_integer_32])
				l_tot_weight := (0).to_double
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_bins)
				loop
					l_weight[l_i.to_integer_32] := (0).to_double
					update_class_fields -- Current might have been changed; synchronize
					if d[(l_i * dim + l_j).to_integer_32] > (0).to_double then
						l_oldg := l_grid_tot_j / d[(l_i * dim + l_j).to_integer_32]
						l_tmp := log (l_oldg)
						update_class_fields -- Current might have been changed; synchronize
						l_weight[l_i.to_integer_32] := pow (((l_oldg - (1).to_double) / l_oldg) / l_tmp, alpha)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_tot_weight := l_tot_weight + (l_weight[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_pts_per_bin := l_tot_weight / l_bins.to_real_64
				l_xnew := (0).to_double
				l_dw := (0).to_double
				l_i := (1).to_natural_32
				l_k := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_k < l_bins))
				loop
					l_dw := l_dw + (l_weight[l_k.to_integer_32])
					l_xold := l_xnew
					l_xnew := xi[((l_k + {NATURAL_32} 1) * dim + l_j).to_integer_32]
					from
					until
						not (l_dw > l_pts_per_bin)
					loop
						l_dw := l_dw - l_pts_per_bin
						xin[l_i.to_integer_32] := l_xnew - ((l_xnew - l_xold) * l_dw) / l_weight[l_k.to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i + 1
					end
					l_k := l_k + 1
				end
				l_k := (1).to_natural_32
				from
				until
					not (l_k < l_bins)
				loop
					xi[(l_k * dim + l_j).to_integer_32] := xin[l_k.to_integer_32]
					update_class_fields -- Current might have been changed; synchronize
					l_k := l_k + 1
				end
				xi[(l_bins * dim + l_j).to_integer_32] := (1).to_double
				update_class_fields -- Current might have been changed; synchronize
				l_j := l_j + 1
			end
		end

	print_lim (a_xl, a_xu: CE_POINTER [REAL_64]; a_dim: NATURAL_32)
		local
			l_j: NATURAL_32
		do
			fprintf ([ostream, ce_string ("The limits of integration are:%N")]).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_j := {NATURAL_32} 0
			from
			until
				not (l_j < a_dim)
			loop
				fprintf ([ostream, ce_string ("%Nxl[%%lu]=%%f    xu[%%lu]=%%f"), l_j, a_xl[l_j.to_integer_32], l_j, a_xu[l_j.to_integer_32]]).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_j := l_j + 1
			end
			fprintf ([ostream, ce_string ("%N")]).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			fflush (ostream).do_nothing
			update_class_fields -- Current might have been changed; synchronize
		end

	print_head (a_num_dim, a_calls: NATURAL_32; a_it_num, a_bins, a_boxes: NATURAL_32)
		do
			fprintf ([ostream, ce_string ("%Nnum_dim=%%lu, calls=%%lu, it_num=%%d, max_it_num=%%d "), a_num_dim, a_calls, a_it_num, iterations]).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			fprintf ([ostream, ce_string ("verb=%%d, alph=%%.2f,%Nmode=%%d, bins=%%d, boxes=%%d%N"), verbose, alpha, mode, a_bins, a_boxes]).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			fprintf ([ostream, ce_string ("%N       single.......iteration                   ")]).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			fprintf ([ostream, ce_string ("accumulated......results   %N")]).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			fprintf ([ostream, ce_string ("iteration     integral    sigma             integral   ")]).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			fprintf ([ostream, ce_string ("      sigma     chi-sq/it%N%N")]).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			fflush (ostream).do_nothing
			update_class_fields -- Current might have been changed; synchronize
		end

	print_res (a_itr: NATURAL_32; a_res, a_err, a_cum_res, a_cum_err, a_chi_sq: REAL_64)
		do
			fprintf ([ostream, ce_string ("%%4d        %%6.4e %%10.2e          %%6.4e      %%8.2e  %%10.2e%N"), a_itr, a_res, a_err, a_cum_res, a_cum_err, a_chi_sq]).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			fflush (ostream).do_nothing
			update_class_fields -- Current might have been changed; synchronize
		end

	print_dist (a_dim: NATURAL_32)
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_p: INTEGER_32
			l_return: BOOLEAN
		do
			l_p := verbose
			if l_p < 1 then
				l_return := True
			end
			if not l_return then
				l_j := {NATURAL_32} 0
				from
				until
					not (not (l_return) and then (l_j < a_dim))
				loop
					fprintf ([ostream, ce_string ("%N axis %%lu %N"), l_j]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					fprintf ([ostream, ce_string ("      x   g%N")]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_i := {NATURAL_32} 0
					from
					until
						not (l_i < bins.to_natural_32)
					loop
						fprintf ([ostream, ce_string ("weight [%%11.2e , %%11.2e] = "), xi[(l_i * dim.to_natural_32 + l_j).to_integer_32], xi[((l_i + {NATURAL_32} 1) * dim.to_natural_32 + l_j).to_integer_32]]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						fprintf ([ostream, ce_string (" %%11.2e%N"), d[(l_i * dim.to_natural_32 + l_j).to_integer_32]]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i + 1
					end
					fprintf ([ostream, ce_string ("%N")]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_j := l_j + 1
				end
				fprintf ([ostream, ce_string ("%N")]).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				fflush (ostream).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	print_grid (a_dim: NATURAL_32)
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_p: INTEGER_32
			l_return: BOOLEAN
		do
			l_p := verbose
			if l_p < 1 then
				l_return := True
			end
			if not l_return then
				l_j := {NATURAL_32} 0
				from
				until
					not (not (l_return) and then (l_j < a_dim))
				loop
					fprintf ([ostream, ce_string ("%N axis %%lu %N"), l_j]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					fprintf ([ostream, ce_string ("      x   %N")]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_i := {NATURAL_32} 0
					from
					until
						not (l_i <= bins.to_natural_32)
					loop
						fprintf ([ostream, ce_string ("%%11.2e"), xi[(l_i * dim.to_natural_32 + l_j).to_integer_32]]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if l_i \\ {NATURAL_32} 5 = {NATURAL_32} 4 then
							fprintf ([ostream, ce_string ("%N")]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						l_i := l_i + 1
					end
					fprintf ([ostream, ce_string ("%N")]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_j := l_j + 1
				end
				fprintf ([ostream, ce_string ("%N")]).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				fflush (ostream).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			dim := a_other.dim
			bins_max := a_other.bins_max
			bins := a_other.bins
			boxes := a_other.boxes
			xi := a_other.xi
			xin := a_other.xin
			delx := a_other.delx
			weight := a_other.weight
			vol := a_other.vol
			x := a_other.x
			bin := a_other.bin
			box := a_other.box
			d := a_other.d
			alpha := a_other.alpha
			mode := a_other.mode
			verbose := a_other.verbose
			iterations := a_other.iterations
			stage := a_other.stage
			jac := a_other.jac
			wtd_int_sum := a_other.wtd_int_sum
			sum_wgts := a_other.sum_wgts
			chi_sum := a_other.chi_sum
			chisq := a_other.chisq
			result2 := a_other.result2
			sigma := a_other.sigma
			it_start := a_other.it_start
			it_num := a_other.it_num
			samples := a_other.samples
			calls_per_box := a_other.calls_per_box
			ostream := a_other.ostream
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				dim = a_other.dim and
				bins_max = a_other.bins_max and
				bins = a_other.bins and
				boxes = a_other.boxes and
				xi.is_equal (a_other.xi) and
				xin.is_equal (a_other.xin) and
				delx.is_equal (a_other.delx) and
				weight.is_equal (a_other.weight) and
				vol = a_other.vol and
				x.is_equal (a_other.x) and
				bin.is_equal (a_other.bin) and
				box.is_equal (a_other.box) and
				d.is_equal (a_other.d) and
				alpha = a_other.alpha and
				mode = a_other.mode and
				verbose = a_other.verbose and
				iterations = a_other.iterations and
				stage = a_other.stage and
				jac = a_other.jac and
				wtd_int_sum = a_other.wtd_int_sum and
				sum_wgts = a_other.sum_wgts and
				chi_sum = a_other.chi_sum and
				chisq = a_other.chisq and
				result2 = a_other.result2 and
				sigma = a_other.sigma and
				it_start = a_other.it_start and
				it_num = a_other.it_num and
				samples = a_other.samples and
				calls_per_box = a_other.calls_per_box and
				ostream.is_equal (a_other.ostream)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("dim"),
					create {CE_STRUCTURE_FIELD}.make ("bins_max"),
					create {CE_STRUCTURE_FIELD}.make ("bins"),
					create {CE_STRUCTURE_FIELD}.make ("boxes"),
					create {CE_STRUCTURE_FIELD}.make ("xi"),
					create {CE_STRUCTURE_FIELD}.make ("xin"),
					create {CE_STRUCTURE_FIELD}.make ("delx"),
					create {CE_STRUCTURE_FIELD}.make ("weight"),
					create {CE_STRUCTURE_FIELD}.make ("vol"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("bin"),
					create {CE_STRUCTURE_FIELD}.make ("box"),
					create {CE_STRUCTURE_FIELD}.make ("d"),
					create {CE_STRUCTURE_FIELD}.make ("alpha"),
					create {CE_STRUCTURE_FIELD}.make ("mode"),
					create {CE_STRUCTURE_FIELD}.make ("verbose"),
					create {CE_STRUCTURE_FIELD}.make ("iterations"),
					create {CE_STRUCTURE_FIELD}.make ("stage"),
					create {CE_STRUCTURE_FIELD}.make ("jac"),
					create {CE_STRUCTURE_FIELD}.make ("wtd_int_sum"),
					create {CE_STRUCTURE_FIELD}.make ("sum_wgts"),
					create {CE_STRUCTURE_FIELD}.make ("chi_sum"),
					create {CE_STRUCTURE_FIELD}.make ("chisq"),
					create {CE_STRUCTURE_FIELD}.make ("result2"),
					create {CE_STRUCTURE_FIELD}.make ("sigma"),
					create {CE_STRUCTURE_FIELD}.make ("it_start"),
					create {CE_STRUCTURE_FIELD}.make ("it_num"),
					create {CE_STRUCTURE_FIELD}.make ("samples"),
					create {CE_STRUCTURE_FIELD}.make ("calls_per_box"),
					create {CE_STRUCTURE_FIELD}.make ("ostream")
				>>)
			init_structure_info
		end

end
