class
	PD_GSL_MULTIMIN_FDFMINIMIZER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE]} type.make
			create {CE_CLASS_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]} fdf.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} x.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} gradient.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} dx.make
			create {CE_VOID_POINTER} state.make
		end

feature {ANY} -- fields

	type: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE] assign set_type

	fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT] assign set_fdf

	f: REAL_64 assign set_f

	x: CE_POINTER [PD_GSL_VECTOR] assign set_x

	gradient: CE_POINTER [PD_GSL_VECTOR] assign set_gradient

	dx: CE_POINTER [PD_GSL_VECTOR] assign set_dx

	state: CE_POINTER [ANY] assign set_state

feature {ANY} -- field setters

	set_type (a_type: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE])
		do
			type := a_type
			update_memory_field ("type")
		end

	set_fdf (a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT])
		do
			fdf := a_fdf
			update_memory_field ("fdf")
		end

	set_f (a_f: REAL_64)
		do
			f := a_f
			update_memory_field ("f")
		end

	set_x (a_x: CE_POINTER [PD_GSL_VECTOR])
		do
			x := a_x
			update_memory_field ("x")
		end

	set_gradient (a_gradient: CE_POINTER [PD_GSL_VECTOR])
		do
			gradient := a_gradient
			update_memory_field ("gradient")
		end

	set_dx (a_dx: CE_POINTER [PD_GSL_VECTOR])
		do
			dx := a_dx
			update_memory_field ("dx")
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			state := a_state
			update_memory_field ("state")
		end

feature {ANY} -- public routines

	gsl_multimin_fdfminimizer_set (a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_step_size, a_tol: REAL_64): INTEGER_32
		require
			not a_fdf.is_void
		local
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if x.item.size /= a_fdf.item.n then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("function incompatible with solver size"), ce_string ("fdfminimizer.c"), 104, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_x.item.size /= a_fdf.item.n) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length not compatible with function"), ce_string ("fdfminimizer.c"), 109, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Current.fdf := a_fdf
				update_class_fields -- Current might have been changed; synchronize
				x.item.gsl_vector_memcpy (a_x).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				dx.item.gsl_vector_set_zero
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := (type.item.set).integer_32_item ([state, fdf, x, create {CE_REAL_64_POINTER}.make_shared (c_pointer + (create {PD_GSL_MULTIMIN_FDFMINIMIZER}.make).offset_of ("f")), gradient, a_step_size, a_tol])
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp
			end
		end

	gsl_multimin_fdfminimizer_iterate: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			l_tmp := (type.item.iterate).integer_32_item ([state, fdf, x, create {CE_REAL_64_POINTER}.make_shared (c_pointer + (create {PD_GSL_MULTIMIN_FDFMINIMIZER}.make).offset_of ("f")), gradient, dx])
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	gsl_multimin_fdfminimizer_restart: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			l_tmp := (type.item.restart).integer_32_item ([state])
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	gsl_multimin_fdfminimizer_name: CE_POINTER [INTEGER_8]
		do
			Result := (type.item.name)
		end

	gsl_multimin_fdfminimizer_x: CE_POINTER [PD_GSL_VECTOR]
		do
			Result := x
		end

	gsl_multimin_fdfminimizer_dx: CE_POINTER [PD_GSL_VECTOR]
		do
			Result := dx
		end

	gsl_multimin_fdfminimizer_gradient: CE_POINTER [PD_GSL_VECTOR]
		do
			Result := gradient
		end

	gsl_multimin_fdfminimizer_minimum: REAL_64
		do
			Result := f
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			fdf := a_other.fdf
			f := a_other.f
			x := a_other.x
			gradient := a_other.gradient
			dx := a_other.dx
			state := a_other.state
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type.is_equal (a_other.type) and
				fdf.is_equal (a_other.fdf) and
				f = a_other.f and
				x.is_equal (a_other.x) and
				gradient.is_equal (a_other.gradient) and
				dx.is_equal (a_other.dx) and
				state.is_equal (a_other.state)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("fdf"),
					create {CE_STRUCTURE_FIELD}.make ("f"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("gradient"),
					create {CE_STRUCTURE_FIELD}.make ("dx"),
					create {CE_STRUCTURE_FIELD}.make ("state")
				>>)
			init_structure_info
		end

end
