class
	PD_GSL_ODEIV_CONTROL_TYPE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} name.make
			create alloc.make
			create init.make
			create hadjust.make
			create free.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	alloc: CE_ROUTINE assign set_alloc

	init: CE_ROUTINE assign set_init

	hadjust: CE_ROUTINE assign set_hadjust

	free: CE_ROUTINE assign set_free

feature {ANY} -- field setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_alloc (a_alloc: CE_ROUTINE)
		do
			alloc := a_alloc
			update_memory_field ("alloc")
		end

	set_init (a_init: CE_ROUTINE)
		do
			init := a_init
			update_memory_field ("init")
		end

	set_hadjust (a_hadjust: CE_ROUTINE)
		do
			hadjust := a_hadjust
			update_memory_field ("hadjust")
		end

	set_free (a_free: CE_ROUTINE)
		do
			free := a_free
			update_memory_field ("free")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			alloc := a_other.alloc
			init := a_other.init
			hadjust := a_other.hadjust
			free := a_other.free
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				alloc.is_equal (a_other.alloc) and
				init.is_equal (a_other.init) and
				hadjust.is_equal (a_other.hadjust) and
				free.is_equal (a_other.free)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("alloc"),
					create {CE_STRUCTURE_FIELD}.make ("init"),
					create {CE_STRUCTURE_FIELD}.make ("hadjust"),
					create {CE_STRUCTURE_FIELD}.make ("free")
				>>)
			init_structure_info
		end

end
