class
	PD_GSL_ROOT_FDFSOLVER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_ROOT_FDFSOLVER_TYPE]} type.make
			create {CE_CLASS_POINTER [PD_GSL_FUNCTION_FDF_STRUCT]} fdf.make
			create {CE_VOID_POINTER} state.make
		end

feature {ANY} -- fields

	type: CE_POINTER [PD_GSL_ROOT_FDFSOLVER_TYPE] assign set_type

	fdf: CE_POINTER [PD_GSL_FUNCTION_FDF_STRUCT] assign set_fdf

	root: REAL_64 assign set_root

	state: CE_POINTER [ANY] assign set_state

feature {ANY} -- field setters

	set_type (a_type: CE_POINTER [PD_GSL_ROOT_FDFSOLVER_TYPE])
		do
			type := a_type
			update_memory_field ("type")
		end

	set_fdf (a_fdf: CE_POINTER [PD_GSL_FUNCTION_FDF_STRUCT])
		do
			fdf := a_fdf
			update_memory_field ("fdf")
		end

	set_root (a_root: REAL_64)
		do
			root := a_root
			update_memory_field ("root")
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			state := a_state
			update_memory_field ("state")
		end

feature {ANY} -- public routines

	gsl_root_fdfsolver_set (a_f: CE_POINTER [PD_GSL_FUNCTION_FDF_STRUCT]; a_root: REAL_64): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			Current.fdf := a_f
			update_class_fields -- Current might have been changed; synchronize
			Current.root := a_root
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (type.item.set).integer_32_item ([state, fdf, create {CE_REAL_64_POINTER}.make_shared (c_pointer + (create {PD_GSL_ROOT_FDFSOLVER}.make).offset_of ("root"))])
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	gsl_root_fdfsolver_iterate: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			l_tmp := (type.item.iterate).integer_32_item ([state, fdf, create {CE_REAL_64_POINTER}.make_shared (c_pointer + (create {PD_GSL_ROOT_FDFSOLVER}.make).offset_of ("root"))])
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	gsl_root_fdfsolver_name: CE_POINTER [INTEGER_8]
		do
			Result := (type.item.name)
		end

	gsl_root_fdfsolver_root: REAL_64
		do
			Result := root
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			fdf := a_other.fdf
			root := a_other.root
			state := a_other.state
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type.is_equal (a_other.type) and
				fdf.is_equal (a_other.fdf) and
				root = a_other.root and
				state.is_equal (a_other.state)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("fdf"),
					create {CE_STRUCTURE_FIELD}.make ("root"),
					create {CE_STRUCTURE_FIELD}.make ("state")
				>>)
			init_structure_info
		end

end
