class
	PD_LMDER_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} r.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} tau.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} diag.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} qtf.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} newton.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} gradient.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} x_trial.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} f_trial.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} df.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} sdiag.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} rptdx.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} w.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} work1.make
			create {CE_CLASS_POINTER [PD_GSL_PERMUTATION_STRUCT]} perm.make
		end

feature {ANY} -- fields

	iter: NATURAL_32 assign set_iter

	xnorm: REAL_64 assign set_xnorm

	fnorm: REAL_64 assign set_fnorm

	delta: REAL_64 assign set_delta

	par: REAL_64 assign set_par

	r: CE_POINTER [PD_GSL_MATRIX] assign set_r

	tau: CE_POINTER [PD_GSL_VECTOR] assign set_tau

	diag: CE_POINTER [PD_GSL_VECTOR] assign set_diag

	qtf: CE_POINTER [PD_GSL_VECTOR] assign set_qtf

	newton: CE_POINTER [PD_GSL_VECTOR] assign set_newton

	gradient: CE_POINTER [PD_GSL_VECTOR] assign set_gradient

	x_trial: CE_POINTER [PD_GSL_VECTOR] assign set_x_trial

	f_trial: CE_POINTER [PD_GSL_VECTOR] assign set_f_trial

	df: CE_POINTER [PD_GSL_VECTOR] assign set_df

	sdiag: CE_POINTER [PD_GSL_VECTOR] assign set_sdiag

	rptdx: CE_POINTER [PD_GSL_VECTOR] assign set_rptdx

	w: CE_POINTER [PD_GSL_VECTOR] assign set_w

	work1: CE_POINTER [PD_GSL_VECTOR] assign set_work1

	perm: CE_POINTER [PD_GSL_PERMUTATION_STRUCT] assign set_perm

feature {ANY} -- field setters

	set_iter (a_iter: NATURAL_32)
		do
			iter := a_iter
			update_memory_field ("iter")
		end

	set_xnorm (a_xnorm: REAL_64)
		do
			xnorm := a_xnorm
			update_memory_field ("xnorm")
		end

	set_fnorm (a_fnorm: REAL_64)
		do
			fnorm := a_fnorm
			update_memory_field ("fnorm")
		end

	set_delta (a_delta: REAL_64)
		do
			delta := a_delta
			update_memory_field ("delta")
		end

	set_par (a_par: REAL_64)
		do
			par := a_par
			update_memory_field ("par")
		end

	set_r (a_r: CE_POINTER [PD_GSL_MATRIX])
		do
			r := a_r
			update_memory_field ("r")
		end

	set_tau (a_tau: CE_POINTER [PD_GSL_VECTOR])
		do
			tau := a_tau
			update_memory_field ("tau")
		end

	set_diag (a_diag: CE_POINTER [PD_GSL_VECTOR])
		do
			diag := a_diag
			update_memory_field ("diag")
		end

	set_qtf (a_qtf: CE_POINTER [PD_GSL_VECTOR])
		do
			qtf := a_qtf
			update_memory_field ("qtf")
		end

	set_newton (a_newton: CE_POINTER [PD_GSL_VECTOR])
		do
			newton := a_newton
			update_memory_field ("newton")
		end

	set_gradient (a_gradient: CE_POINTER [PD_GSL_VECTOR])
		do
			gradient := a_gradient
			update_memory_field ("gradient")
		end

	set_x_trial (a_x_trial: CE_POINTER [PD_GSL_VECTOR])
		do
			x_trial := a_x_trial
			update_memory_field ("x_trial")
		end

	set_f_trial (a_f_trial: CE_POINTER [PD_GSL_VECTOR])
		do
			f_trial := a_f_trial
			update_memory_field ("f_trial")
		end

	set_df (a_df: CE_POINTER [PD_GSL_VECTOR])
		do
			df := a_df
			update_memory_field ("df")
		end

	set_sdiag (a_sdiag: CE_POINTER [PD_GSL_VECTOR])
		do
			sdiag := a_sdiag
			update_memory_field ("sdiag")
		end

	set_rptdx (a_rptdx: CE_POINTER [PD_GSL_VECTOR])
		do
			rptdx := a_rptdx
			update_memory_field ("rptdx")
		end

	set_w (a_w: CE_POINTER [PD_GSL_VECTOR])
		do
			w := a_w
			update_memory_field ("w")
		end

	set_work1 (a_work1: CE_POINTER [PD_GSL_VECTOR])
		do
			work1 := a_work1
			update_memory_field ("work1")
		end

	set_perm (a_perm: CE_POINTER [PD_GSL_PERMUTATION_STRUCT])
		do
			perm := a_perm
			update_memory_field ("perm")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			iter := a_other.iter
			xnorm := a_other.xnorm
			fnorm := a_other.fnorm
			delta := a_other.delta
			par := a_other.par
			r := a_other.r
			tau := a_other.tau
			diag := a_other.diag
			qtf := a_other.qtf
			newton := a_other.newton
			gradient := a_other.gradient
			x_trial := a_other.x_trial
			f_trial := a_other.f_trial
			df := a_other.df
			sdiag := a_other.sdiag
			rptdx := a_other.rptdx
			w := a_other.w
			work1 := a_other.work1
			perm := a_other.perm
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				iter = a_other.iter and
				xnorm = a_other.xnorm and
				fnorm = a_other.fnorm and
				delta = a_other.delta and
				par = a_other.par and
				r.is_equal (a_other.r) and
				tau.is_equal (a_other.tau) and
				diag.is_equal (a_other.diag) and
				qtf.is_equal (a_other.qtf) and
				newton.is_equal (a_other.newton) and
				gradient.is_equal (a_other.gradient) and
				x_trial.is_equal (a_other.x_trial) and
				f_trial.is_equal (a_other.f_trial) and
				df.is_equal (a_other.df) and
				sdiag.is_equal (a_other.sdiag) and
				rptdx.is_equal (a_other.rptdx) and
				w.is_equal (a_other.w) and
				work1.is_equal (a_other.work1) and
				perm.is_equal (a_other.perm)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("iter"),
					create {CE_STRUCTURE_FIELD}.make ("xnorm"),
					create {CE_STRUCTURE_FIELD}.make ("fnorm"),
					create {CE_STRUCTURE_FIELD}.make ("delta"),
					create {CE_STRUCTURE_FIELD}.make ("par"),
					create {CE_STRUCTURE_FIELD}.make ("r"),
					create {CE_STRUCTURE_FIELD}.make ("tau"),
					create {CE_STRUCTURE_FIELD}.make ("diag"),
					create {CE_STRUCTURE_FIELD}.make ("qtf"),
					create {CE_STRUCTURE_FIELD}.make ("newton"),
					create {CE_STRUCTURE_FIELD}.make ("gradient"),
					create {CE_STRUCTURE_FIELD}.make ("x_trial"),
					create {CE_STRUCTURE_FIELD}.make ("f_trial"),
					create {CE_STRUCTURE_FIELD}.make ("df"),
					create {CE_STRUCTURE_FIELD}.make ("sdiag"),
					create {CE_STRUCTURE_FIELD}.make ("rptdx"),
					create {CE_STRUCTURE_FIELD}.make ("w"),
					create {CE_STRUCTURE_FIELD}.make ("work1"),
					create {CE_STRUCTURE_FIELD}.make ("perm")
				>>)
			init_structure_info
		end

end
