class
	PD_RANDOM32_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_32_ARRAY} x.make (<<7>>)
		end

feature {ANY} -- fields

	i: INTEGER_32 assign set_i

	j: INTEGER_32 assign set_j

	x: CE_ARRAY [INTEGER_32]

feature {ANY} -- field setters

	set_i (a_i: INTEGER_32)
		do
			i := a_i
			update_memory_field ("i")
		end

	set_j (a_j: INTEGER_32)
		do
			j := a_j
			update_memory_field ("j")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			i := a_other.i
			j := a_other.j
			x := a_other.x.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				i = a_other.i and
				j = a_other.j and
				x.is_equal (a_other.x)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("i"),
					create {CE_STRUCTURE_FIELD}.make ("j"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("x", <<7>>)
				>>)
			init_structure_info
		end

end
