class
	PD_RANLUX_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_32_ARRAY} u.make (<<24>>)
		end

feature {ANY} -- fields

	i: NATURAL_32 assign set_i

	j: NATURAL_32 assign set_j

	n: NATURAL_32 assign set_n

	skip: NATURAL_32 assign set_skip

	carry: NATURAL_32 assign set_carry

	u: CE_ARRAY [NATURAL_32]

feature {ANY} -- field setters

	set_i (a_i: NATURAL_32)
		do
			i := a_i
			update_memory_field ("i")
		end

	set_j (a_j: NATURAL_32)
		do
			j := a_j
			update_memory_field ("j")
		end

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_skip (a_skip: NATURAL_32)
		do
			skip := a_skip
			update_memory_field ("skip")
		end

	set_carry (a_carry: NATURAL_32)
		do
			carry := a_carry
			update_memory_field ("carry")
		end

feature {PD_RANLUX_STATE_T} -- private attributes

	mask_lo: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := {NATURAL_32} 16_777_215
		end

feature {ANY} -- public routines

	increment_state___1: NATURAL_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_delta___0: INTEGER_32
		do
			l_i := i
			l_j := j
			l_delta___0 := ((u[l_j.to_integer_32] - u[l_i.to_integer_32]) - carry.to_natural_32).to_integer_32
			if ((l_delta___0.to_natural_32).bit_and ((create {P_RANLUX_STATIC}).mask_hi.item)).to_boolean then
				Current.carry := {NATURAL_32} 1
				update_class_fields -- Current might have been changed; synchronize
				l_delta___0 := ((l_delta___0.to_natural_32).bit_and (mask_lo.item)).to_integer_32
			else
				Current.carry := {NATURAL_32} 0
				update_class_fields -- Current might have been changed; synchronize
			end
			u[l_i.to_integer_32] := l_delta___0.to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			if l_i = {NATURAL_32} 0 then
				l_i := {NATURAL_32} 23
			else
				l_i := l_i - 1
			end
			Current.i := l_i
			update_class_fields -- Current might have been changed; synchronize
			if l_j = {NATURAL_32} 0 then
				l_j := {NATURAL_32} 23
			else
				l_j := l_j - 1
			end
			Current.j := l_j
			update_class_fields -- Current might have been changed; synchronize
			Result := l_delta___0.to_natural_32
		end

feature {ANY}

	copy (a_other: like Current)
		do
			i := a_other.i
			j := a_other.j
			n := a_other.n
			skip := a_other.skip
			carry := a_other.carry
			u := a_other.u.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				i = a_other.i and
				j = a_other.j and
				n = a_other.n and
				skip = a_other.skip and
				carry = a_other.carry and
				u.is_equal (a_other.u)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("i"),
					create {CE_STRUCTURE_FIELD}.make ("j"),
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("skip"),
					create {CE_STRUCTURE_FIELD}.make ("carry"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("u", <<24>>)
				>>)
			init_structure_info
		end

end
