class
	PD_RANLXD_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_REAL_64_ARRAY} xdbl.make (<<12>>)
		end

feature {ANY} -- fields

	xdbl: CE_ARRAY [REAL_64]

	carry: REAL_64 assign set_carry

	ir: NATURAL_32 assign set_ir

	jr: NATURAL_32 assign set_jr

	ir_old: NATURAL_32 assign set_ir_old

	pr: NATURAL_32 assign set_pr

feature {ANY} -- field setters

	set_carry (a_carry: REAL_64)
		do
			carry := a_carry
			update_memory_field ("carry")
		end

	set_ir (a_ir: NATURAL_32)
		do
			ir := a_ir
			update_memory_field ("ir")
		end

	set_jr (a_jr: NATURAL_32)
		do
			jr := a_jr
			update_memory_field ("jr")
		end

	set_ir_old (a_ir_old: NATURAL_32)
		do
			ir_old := a_ir_old
			update_memory_field ("ir_old")
		end

	set_pr (a_pr: NATURAL_32)
		do
			pr := a_pr
			update_memory_field ("pr")
		end

feature {ANY} -- public routines

	increment_state___0
		local
			l_k: INTEGER_32
			l_kmax___0: INTEGER_32
			l_y1: REAL_64
			l_y2: REAL_64
			l_y3: REAL_64
			l_xdbl: CE_POINTER [REAL_64]
			l_carry: REAL_64
			l_ir: NATURAL_32
			l_jr: NATURAL_32
		do
			l_xdbl := xdbl
			l_carry := carry
			l_ir := ir
			l_jr := jr
			l_k := 0
			from
			until
				not (l_ir > {NATURAL_32} 0)
			loop
				l_y1 := l_xdbl[l_jr.to_integer_32] - l_xdbl[l_ir.to_integer_32]
				l_y2 := l_y1 - l_carry
				if l_y2 < (0).to_double then
					l_carry := (create {P_RANLXD_STATIC}).one_bit___0.item
					l_y2 := l_y2 + (1).to_double
				else
					l_carry := (0).to_double
				end
				l_xdbl[l_ir.to_integer_32] := l_y2
				update_class_fields -- Current might have been changed; synchronize
				l_ir := ((create {P_RANLXD_STATIC}).next___0.item[l_ir.to_integer_32]).to_natural_32
				l_jr := ((create {P_RANLXD_STATIC}).next___0.item[l_jr.to_integer_32]).to_natural_32
				l_k := l_k + 1
			end
			l_kmax___0 := (pr - {NATURAL_32} 12).to_integer_32
			from
			until
				not (l_k <= l_kmax___0)
			loop
				l_y1 := l_xdbl[7] - l_xdbl[0]
				l_y1 := l_y1 - l_carry
				l_y2 := l_xdbl[8] - l_xdbl[1]
				if l_y1 < (0).to_double then
					l_y2 := l_y2 - ((create {P_RANLXD_STATIC}).one_bit___0.item)
					l_y1 := l_y1 + (1).to_double
				end
				l_xdbl[0] := l_y1
				update_class_fields -- Current might have been changed; synchronize
				l_y3 := l_xdbl[9] - l_xdbl[2]
				if l_y2 < (0).to_double then
					l_y3 := l_y3 - ((create {P_RANLXD_STATIC}).one_bit___0.item)
					l_y2 := l_y2 + (1).to_double
				end
				l_xdbl[1] := l_y2
				update_class_fields -- Current might have been changed; synchronize
				l_y1 := l_xdbl[10] - l_xdbl[3]
				if l_y3 < (0).to_double then
					l_y1 := l_y1 - ((create {P_RANLXD_STATIC}).one_bit___0.item)
					l_y3 := l_y3 + (1).to_double
				end
				l_xdbl[2] := l_y3
				update_class_fields -- Current might have been changed; synchronize
				l_y2 := l_xdbl[11] - l_xdbl[4]
				if l_y1 < (0).to_double then
					l_y2 := l_y2 - ((create {P_RANLXD_STATIC}).one_bit___0.item)
					l_y1 := l_y1 + (1).to_double
				end
				l_xdbl[3] := l_y1
				update_class_fields -- Current might have been changed; synchronize
				l_y3 := l_xdbl[0] - l_xdbl[5]
				if l_y2 < (0).to_double then
					l_y3 := l_y3 - ((create {P_RANLXD_STATIC}).one_bit___0.item)
					l_y2 := l_y2 + (1).to_double
				end
				l_xdbl[4] := l_y2
				update_class_fields -- Current might have been changed; synchronize
				l_y1 := l_xdbl[1] - l_xdbl[6]
				if l_y3 < (0).to_double then
					l_y1 := l_y1 - ((create {P_RANLXD_STATIC}).one_bit___0.item)
					l_y3 := l_y3 + (1).to_double
				end
				l_xdbl[5] := l_y3
				update_class_fields -- Current might have been changed; synchronize
				l_y2 := l_xdbl[2] - l_xdbl[7]
				if l_y1 < (0).to_double then
					l_y2 := l_y2 - ((create {P_RANLXD_STATIC}).one_bit___0.item)
					l_y1 := l_y1 + (1).to_double
				end
				l_xdbl[6] := l_y1
				update_class_fields -- Current might have been changed; synchronize
				l_y3 := l_xdbl[3] - l_xdbl[8]
				if l_y2 < (0).to_double then
					l_y3 := l_y3 - ((create {P_RANLXD_STATIC}).one_bit___0.item)
					l_y2 := l_y2 + (1).to_double
				end
				l_xdbl[7] := l_y2
				update_class_fields -- Current might have been changed; synchronize
				l_y1 := l_xdbl[4] - l_xdbl[9]
				if l_y3 < (0).to_double then
					l_y1 := l_y1 - ((create {P_RANLXD_STATIC}).one_bit___0.item)
					l_y3 := l_y3 + (1).to_double
				end
				l_xdbl[8] := l_y3
				update_class_fields -- Current might have been changed; synchronize
				l_y2 := l_xdbl[5] - l_xdbl[10]
				if l_y1 < (0).to_double then
					l_y2 := l_y2 - ((create {P_RANLXD_STATIC}).one_bit___0.item)
					l_y1 := l_y1 + (1).to_double
				end
				l_xdbl[9] := l_y1
				update_class_fields -- Current might have been changed; synchronize
				l_y3 := l_xdbl[6] - l_xdbl[11]
				if l_y2 < (0).to_double then
					l_y3 := l_y3 - ((create {P_RANLXD_STATIC}).one_bit___0.item)
					l_y2 := l_y2 + (1).to_double
				end
				l_xdbl[10] := l_y2
				update_class_fields -- Current might have been changed; synchronize
				if l_y3 < (0).to_double then
					l_carry := (create {P_RANLXD_STATIC}).one_bit___0.item
					l_y3 := l_y3 + (1).to_double
				else
					l_carry := (0).to_double
				end
				l_xdbl[11] := l_y3
				update_class_fields -- Current might have been changed; synchronize
				l_k := l_k + (12)
			end
			l_kmax___0 := pr.to_integer_32
			from
			until
				not (l_k < l_kmax___0)
			loop
				l_y1 := l_xdbl[l_jr.to_integer_32] - l_xdbl[l_ir.to_integer_32]
				l_y2 := l_y1 - l_carry
				if l_y2 < (0).to_double then
					l_carry := (create {P_RANLXD_STATIC}).one_bit___0.item
					l_y2 := l_y2 + (1).to_double
				else
					l_carry := (0).to_double
				end
				l_xdbl[l_ir.to_integer_32] := l_y2
				update_class_fields -- Current might have been changed; synchronize
				l_ir := ((create {P_RANLXD_STATIC}).next___0.item[l_ir.to_integer_32]).to_natural_32
				l_jr := ((create {P_RANLXD_STATIC}).next___0.item[l_jr.to_integer_32]).to_natural_32
				l_k := l_k + 1
			end
			Current.ir := l_ir
			update_class_fields -- Current might have been changed; synchronize
			Current.ir_old := l_ir
			update_class_fields -- Current might have been changed; synchronize
			Current.jr := l_jr
			update_class_fields -- Current might have been changed; synchronize
			Current.carry := l_carry
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			xdbl := a_other.xdbl.twin
			carry := a_other.carry
			ir := a_other.ir
			jr := a_other.jr
			ir_old := a_other.ir_old
			pr := a_other.pr
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				xdbl.is_equal (a_other.xdbl) and
				carry = a_other.carry and
				ir = a_other.ir and
				jr = a_other.jr and
				ir_old = a_other.ir_old and
				pr = a_other.pr
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("xdbl", <<12>>),
					create {CE_STRUCTURE_FIELD}.make ("carry"),
					create {CE_STRUCTURE_FIELD}.make ("ir"),
					create {CE_STRUCTURE_FIELD}.make ("jr"),
					create {CE_STRUCTURE_FIELD}.make ("ir_old"),
					create {CE_STRUCTURE_FIELD}.make ("pr")
				>>)
			init_structure_info
		end

end
