class
	PD_RKCK_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_REAL_64_POINTER} k1.make
			create {CE_REAL_64_POINTER} k2.make
			create {CE_REAL_64_POINTER} k3.make
			create {CE_REAL_64_POINTER} k4.make
			create {CE_REAL_64_POINTER} k5.make
			create {CE_REAL_64_POINTER} k6.make
			create {CE_REAL_64_POINTER} y0.make
			create {CE_REAL_64_POINTER} ytmp.make
		end

feature {ANY} -- fields

	k1: CE_POINTER [REAL_64] assign set_k1

	k2: CE_POINTER [REAL_64] assign set_k2

	k3: CE_POINTER [REAL_64] assign set_k3

	k4: CE_POINTER [REAL_64] assign set_k4

	k5: CE_POINTER [REAL_64] assign set_k5

	k6: CE_POINTER [REAL_64] assign set_k6

	y0: CE_POINTER [REAL_64] assign set_y0

	ytmp: CE_POINTER [REAL_64] assign set_ytmp

feature {ANY} -- field setters

	set_k1 (a_k1: CE_POINTER [REAL_64])
		do
			k1 := a_k1
			update_memory_field ("k1")
		end

	set_k2 (a_k2: CE_POINTER [REAL_64])
		do
			k2 := a_k2
			update_memory_field ("k2")
		end

	set_k3 (a_k3: CE_POINTER [REAL_64])
		do
			k3 := a_k3
			update_memory_field ("k3")
		end

	set_k4 (a_k4: CE_POINTER [REAL_64])
		do
			k4 := a_k4
			update_memory_field ("k4")
		end

	set_k5 (a_k5: CE_POINTER [REAL_64])
		do
			k5 := a_k5
			update_memory_field ("k5")
		end

	set_k6 (a_k6: CE_POINTER [REAL_64])
		do
			k6 := a_k6
			update_memory_field ("k6")
		end

	set_y0 (a_y0: CE_POINTER [REAL_64])
		do
			y0 := a_y0
			update_memory_field ("y0")
		end

	set_ytmp (a_ytmp: CE_POINTER [REAL_64])
		do
			ytmp := a_ytmp
			update_memory_field ("ytmp")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			k1 := a_other.k1
			k2 := a_other.k2
			k3 := a_other.k3
			k4 := a_other.k4
			k5 := a_other.k5
			k6 := a_other.k6
			y0 := a_other.y0
			ytmp := a_other.ytmp
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				k1.is_equal (a_other.k1) and
				k2.is_equal (a_other.k2) and
				k3.is_equal (a_other.k3) and
				k4.is_equal (a_other.k4) and
				k5.is_equal (a_other.k5) and
				k6.is_equal (a_other.k6) and
				y0.is_equal (a_other.y0) and
				ytmp.is_equal (a_other.ytmp)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("k1"),
					create {CE_STRUCTURE_FIELD}.make ("k2"),
					create {CE_STRUCTURE_FIELD}.make ("k3"),
					create {CE_STRUCTURE_FIELD}.make ("k4"),
					create {CE_STRUCTURE_FIELD}.make ("k5"),
					create {CE_STRUCTURE_FIELD}.make ("k6"),
					create {CE_STRUCTURE_FIELD}.make ("y0"),
					create {CE_STRUCTURE_FIELD}.make ("ytmp")
				>>)
			init_structure_info
		end

end
