class
	PD_WRAPPER_T

inherit
	PD_WRAPPER_T_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create fdf_linear.make
			create {CE_CLASS_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]} fdf.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} x.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} g.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} p.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} x_alpha.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} g_alpha.make
		end

feature {ANY} -- fields

	fdf_linear: PD_GSL_FUNCTION_FDF_STRUCT assign set_fdf_linear

	fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT] assign set_fdf

	x: CE_POINTER [PD_GSL_VECTOR] assign set_x

	g: CE_POINTER [PD_GSL_VECTOR] assign set_g

	p: CE_POINTER [PD_GSL_VECTOR] assign set_p

	f_alpha: REAL_64 assign set_f_alpha

	df_alpha: REAL_64 assign set_df_alpha

	x_alpha: CE_POINTER [PD_GSL_VECTOR] assign set_x_alpha

	g_alpha: CE_POINTER [PD_GSL_VECTOR] assign set_g_alpha

	f_cache_key: REAL_64 assign set_f_cache_key

	df_cache_key: REAL_64 assign set_df_cache_key

	x_cache_key: REAL_64 assign set_x_cache_key

	g_cache_key: REAL_64 assign set_g_cache_key

feature {ANY} -- field setters

	set_fdf_linear (a_fdf_linear: PD_GSL_FUNCTION_FDF_STRUCT)
		do
			fdf_linear := a_fdf_linear
			update_memory_field ("fdf_linear")
		end

	set_fdf (a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT])
		do
			fdf := a_fdf
			update_memory_field ("fdf")
		end

	set_x (a_x: CE_POINTER [PD_GSL_VECTOR])
		do
			x := a_x
			update_memory_field ("x")
		end

	set_g (a_g: CE_POINTER [PD_GSL_VECTOR])
		do
			g := a_g
			update_memory_field ("g")
		end

	set_p (a_p: CE_POINTER [PD_GSL_VECTOR])
		do
			p := a_p
			update_memory_field ("p")
		end

	set_f_alpha (a_f_alpha: REAL_64)
		do
			f_alpha := a_f_alpha
			update_memory_field ("f_alpha")
		end

	set_df_alpha (a_df_alpha: REAL_64)
		do
			df_alpha := a_df_alpha
			update_memory_field ("df_alpha")
		end

	set_x_alpha (a_x_alpha: CE_POINTER [PD_GSL_VECTOR])
		do
			x_alpha := a_x_alpha
			update_memory_field ("x_alpha")
		end

	set_g_alpha (a_g_alpha: CE_POINTER [PD_GSL_VECTOR])
		do
			g_alpha := a_g_alpha
			update_memory_field ("g_alpha")
		end

	set_f_cache_key (a_f_cache_key: REAL_64)
		do
			f_cache_key := a_f_cache_key
			update_memory_field ("f_cache_key")
		end

	set_df_cache_key (a_df_cache_key: REAL_64)
		do
			df_cache_key := a_df_cache_key
			update_memory_field ("df_cache_key")
		end

	set_x_cache_key (a_x_cache_key: REAL_64)
		do
			x_cache_key := a_x_cache_key
			update_memory_field ("x_cache_key")
		end

	set_g_cache_key (a_g_cache_key: REAL_64)
		do
			g_cache_key := a_g_cache_key
			update_memory_field ("g_cache_key")
		end

feature {ANY} -- public routines

	moveto (a_alpha: REAL_64)
		local
			l_return: BOOLEAN
		do
			if a_alpha = x_cache_key then
				l_return := True
			end
			if not l_return then
				x_alpha.item.gsl_vector_memcpy (x).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				p.item.gsl_blas_daxpy (a_alpha, x_alpha).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Current.x_cache_key := a_alpha
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	slope: REAL_64
		local
			l_df: CE_ARRAY [REAL_64]
		do
			create {CE_REAL_64_ARRAY} l_df.make (<<1>>)

			g_alpha.item.gsl_blas_ddot (p, l_df).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Result := (l_df.item)
		end

	update_position (a_alpha: REAL_64; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_g: CE_POINTER [PD_GSL_VECTOR])
		require
			not a_x.is_void
			not a_f.is_void
			not a_g.is_void
		local
			l_f_alpha: CE_ARRAY [REAL_64]
			l_df_alpha: CE_ARRAY [REAL_64]
		do
			create {CE_REAL_64_ARRAY} l_f_alpha.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_df_alpha.make (<<1>>)

			wrap_fdf (a_alpha, create {CE_VOID_POINTER}.make_shared (c_pointer), l_f_alpha, l_df_alpha)
			update_class_fields -- Current might have been changed; synchronize
			a_f.item := f_alpha
			update_class_fields -- Current might have been changed; synchronize
			a_x.item.gsl_vector_memcpy (x_alpha).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			a_g.item.gsl_vector_memcpy (g_alpha).do_nothing
			update_class_fields -- Current might have been changed; synchronize
		end

	change_direction
		do
			x_alpha.item.gsl_vector_memcpy (x).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Current.x_cache_key := 0.0
			update_class_fields -- Current might have been changed; synchronize
			Current.f_cache_key := 0.0
			update_class_fields -- Current might have been changed; synchronize
			g_alpha.item.gsl_vector_memcpy (g).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Current.g_cache_key := 0.0
			update_class_fields -- Current might have been changed; synchronize
			Current.df_alpha := ((create {CE_CLASS_POINTER [PD_WRAPPER_T]}.make_shared (c_pointer))).item.slope
			update_class_fields -- Current might have been changed; synchronize
			Current.df_cache_key := 0.0
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_WRAPPER_T_STATIC} -- private routines

	wrap_fdf (a_alpha: REAL_64; a_params: CE_POINTER [ANY]; a_f, a_df: CE_POINTER [REAL_64])
		require
			not a_f.is_void
			not a_df.is_void
		local
			l_w: CE_POINTER [PD_WRAPPER_T]
			l_return: BOOLEAN
		do
			l_w := create {CE_CLASS_POINTER [PD_WRAPPER_T]}.make_cast (a_params)
			if a_alpha = l_w.item.f_cache_key then
				if a_alpha = l_w.item.df_cache_key then
					a_f.item := l_w.item.f_alpha
					a_df.item := l_w.item.df_alpha
					l_return := True
				end
			end
			if not l_return then
				if a_alpha = l_w.item.f_cache_key then
					a_f.item := wrap_f (a_alpha, a_params)
					a_df.item := wrap_df (a_alpha, a_params)
					l_return := True
				elseif a_alpha = l_w.item.df_cache_key then
					a_f.item := wrap_f (a_alpha, a_params)
					a_df.item := wrap_df (a_alpha, a_params)
					l_return := True
				end
			end
			if not l_return then
				l_w.item.moveto (a_alpha);
				((l_w.item.fdf).item.fdf).call ([l_w.item.x_alpha, (l_w.item.fdf).item.params, create {CE_REAL_64_POINTER}.make_shared (l_w.c_pointer + (create {PD_WRAPPER_T}.make).offset_of ("f_alpha")), l_w.item.g_alpha])
				l_w.item.f_cache_key := a_alpha
				l_w.item.g_cache_key := a_alpha
				l_w.item.df_alpha := l_w.item.slope
				l_w.item.df_cache_key := a_alpha
				a_f.item := l_w.item.f_alpha
				a_df.item := l_w.item.df_alpha
			end
		end

	wrap_f (a_alpha: REAL_64; a_params: CE_POINTER [ANY]): REAL_64
		local
			l_w: CE_POINTER [PD_WRAPPER_T]
			l_return: BOOLEAN
		do
			l_w := create {CE_CLASS_POINTER [PD_WRAPPER_T]}.make_cast (a_params)
			if a_alpha = l_w.item.f_cache_key then
				Result := (l_w.item.f_alpha)
				l_return := True
			end
			if not l_return then
				l_w.item.moveto (a_alpha)
				l_w.item.f_alpha := ((l_w.item.fdf).item.f).real_64_item ([l_w.item.x_alpha, (l_w.item.fdf).item.params])
				l_w.item.f_cache_key := a_alpha
				Result := (l_w.item.f_alpha)
			end
		end

	wrap_df (a_alpha: REAL_64; a_params: CE_POINTER [ANY]): REAL_64
		local
			l_w: CE_POINTER [PD_WRAPPER_T]
			l_return: BOOLEAN
		do
			l_w := create {CE_CLASS_POINTER [PD_WRAPPER_T]}.make_cast (a_params)
			if a_alpha = l_w.item.df_cache_key then
				Result := (l_w.item.df_alpha)
				l_return := True
			end
			if not l_return then
				l_w.item.moveto (a_alpha)
				if a_alpha /= l_w.item.g_cache_key then
					((l_w.item.fdf).item.df).call ([l_w.item.x_alpha, (l_w.item.fdf).item.params, l_w.item.g_alpha])
					l_w.item.g_cache_key := a_alpha
				end
				l_w.item.df_alpha := l_w.item.slope
				l_w.item.df_cache_key := a_alpha
				Result := (l_w.item.df_alpha)
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fdf_linear := a_other.fdf_linear.twin
			fdf := a_other.fdf
			x := a_other.x
			g := a_other.g
			p := a_other.p
			f_alpha := a_other.f_alpha
			df_alpha := a_other.df_alpha
			x_alpha := a_other.x_alpha
			g_alpha := a_other.g_alpha
			f_cache_key := a_other.f_cache_key
			df_cache_key := a_other.df_cache_key
			x_cache_key := a_other.x_cache_key
			g_cache_key := a_other.g_cache_key
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fdf_linear.is_equal (a_other.fdf_linear) and
				fdf.is_equal (a_other.fdf) and
				x.is_equal (a_other.x) and
				g.is_equal (a_other.g) and
				p.is_equal (a_other.p) and
				f_alpha = a_other.f_alpha and
				df_alpha = a_other.df_alpha and
				x_alpha.is_equal (a_other.x_alpha) and
				g_alpha.is_equal (a_other.g_alpha) and
				f_cache_key = a_other.f_cache_key and
				df_cache_key = a_other.df_cache_key and
				x_cache_key = a_other.x_cache_key and
				g_cache_key = a_other.g_cache_key
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fdf_linear"),
					create {CE_STRUCTURE_FIELD}.make ("fdf"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("g"),
					create {CE_STRUCTURE_FIELD}.make ("p"),
					create {CE_STRUCTURE_FIELD}.make ("f_alpha"),
					create {CE_STRUCTURE_FIELD}.make ("df_alpha"),
					create {CE_STRUCTURE_FIELD}.make ("x_alpha"),
					create {CE_STRUCTURE_FIELD}.make ("g_alpha"),
					create {CE_STRUCTURE_FIELD}.make ("f_cache_key"),
					create {CE_STRUCTURE_FIELD}.make ("df_cache_key"),
					create {CE_STRUCTURE_FIELD}.make ("x_cache_key"),
					create {CE_STRUCTURE_FIELD}.make ("g_cache_key")
				>>)
			init_structure_info
		end

end
