class
	S_STDLIB_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	malloc (a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared_with_count (
					default_pointer.memory_alloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	free (a___ptr: CE_POINTER [ANY])
		do
			c_free (a___ptr.c_pointer)
		end

	c_free (a___ptr: POINTER)
		external
			"C inline use <libgsl.h>"
		alias
			"free($a___ptr);"
		end

	calloc (a_nmemb: NATURAL_32; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared_with_count (
					default_pointer.memory_calloc (a_nmemb.to_integer_32, a_size.to_integer_32),
					(a_nmemb * a_size).to_integer_32
				)
		end

	abort
		external
			"C inline use <libgsl.h>"
		alias
			"abort();"
		ensure
			False
		end

	getenv (a___name: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a___name.is_void
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_getenv (a___name.c_pointer))
		end

	c_getenv (a___name: POINTER): POINTER
		external
			"C inline use <libgsl.h>"
		alias
			"return (EIF_POINTER)getenv($a___name);"
		end

	abs (a___x: INTEGER_32): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return abs($a___x);"
		end

	strtoul (a___nptr: CE_POINTER [INTEGER_8]; a___endptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a___base: INTEGER_32): NATURAL_32
		require
			not a___nptr.is_void
		do
			Result := c_strtoul (a___nptr.c_pointer, a___endptr.c_pointer, a___base)
		end

	c_strtoul (a___nptr: POINTER; a___endptr: POINTER; a___base: INTEGER_32): NATURAL_32
		external
			"C inline use <libgsl.h>"
		alias
			"return strtoul($a___nptr, $a___endptr, $a___base);"
		end

end
