class
	S_STRING_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	memcpy (a___dest, a___src: CE_POINTER [ANY]; a___n: NATURAL_32): CE_POINTER [ANY]
		require
			a___n > 0 implies (not a___dest.is_void and not a___src.is_void)
		do
			create {CE_VOID_POINTER} Result.make_shared (c_memcpy (a___dest.c_pointer, a___src.c_pointer, a___n))
		end

	c_memcpy (a___dest: POINTER; a___src: POINTER; a___n: NATURAL_32): POINTER
		external
			"C inline use <libgsl.h>"
		alias
			"return (EIF_POINTER)memcpy($a___dest, $a___src, $a___n);"
		end

	strcpy (a___dest, a___src: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a___dest.is_void
			not a___src.is_void
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strcpy (a___dest.c_pointer, a___src.c_pointer))
		end

	c_strcpy (a___dest: POINTER; a___src: POINTER): POINTER
		external
			"C inline use <libgsl.h>"
		alias
			"return (EIF_POINTER)strcpy($a___dest, $a___src);"
		end

	strcmp (a___s1, a___s2: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a___s1.is_void
			not a___s2.is_void
		do
			Result := c_strcmp (a___s1.c_pointer, a___s2.c_pointer)
		end

	c_strcmp (a___s1: POINTER; a___s2: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return strcmp($a___s1, $a___s2);"
		end

	strchr (a___s: CE_POINTER [INTEGER_8]; a___c: INTEGER_32): CE_POINTER [INTEGER_8]
		require
			not a___s.is_void
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strchr (a___s.c_pointer, a___c))
		end

	c_strchr (a___s: POINTER; a___c: INTEGER_32): POINTER
		external
			"C inline use <libgsl.h>"
		alias
			"return (EIF_POINTER)strchr($a___s, $a___c);"
		end

	strlen (a___s: CE_POINTER [INTEGER_8]): NATURAL_32
		require
			not a___s.is_void
		do
			Result := c_strlen (a___s.c_pointer)
		end

	c_strlen (a___s: POINTER): NATURAL_32
		external
			"C inline use <libgsl.h>"
		alias
			"return strlen($a___s);"
		end

	memset (a___s: CE_POINTER [ANY]; a___c: INTEGER_32; a___n: NATURAL_32): CE_POINTER [ANY]
		require
			not a___s.is_void
		do
			create {CE_VOID_POINTER} Result.make_shared (c_memset (a___s.c_pointer, a___c, a___n))
		end

	c_memset (a___s: POINTER; a___c: INTEGER_32; a___n: NATURAL_32): POINTER
		external
			"C inline use <libgsl.h>"
		alias
			"return (EIF_POINTER)memset($a___s, $a___c, $a___n);"
		end

end
