class
	PD_URL

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_ASSERT_STATIC
		redefine
			copy,
			is_equal
		end
	S_BITS_ERRNO_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_GCC_BUILTIN_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_TIME_STATIC
		redefine
			copy,
			is_equal
		end
	S_SYS_STAT_STATIC
		redefine
			copy,
			is_equal
		end
	S_UNISTD_STATIC
		redefine
			copy,
			is_equal
		end
	S_FNMATCH_STATIC
		redefine
			copy,
			is_equal
		end
	S_SYS_SOCKET_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_SYS_SELECT_STATIC
		redefine
			copy,
			is_equal
		end
	WGET_ASSEMBLER
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} url.make
			create {CE_INTEGER_8_POINTER} host.make
			create {CE_INTEGER_8_POINTER} path.make
			create {CE_INTEGER_8_POINTER} params.make
			create {CE_INTEGER_8_POINTER} query.make
			create {CE_INTEGER_8_POINTER} fragment.make
			create {CE_INTEGER_8_POINTER} dir.make
			create {CE_INTEGER_8_POINTER} file.make
			create {CE_INTEGER_8_POINTER} user.make
			create {CE_INTEGER_8_POINTER} passwd.make
			Precursor
		end

feature {ANY} -- fields

	url: CE_POINTER [INTEGER_8] assign set_url

	scheme: NATURAL_32 assign set_scheme

	host: CE_POINTER [INTEGER_8] assign set_host

	port: INTEGER_32 assign set_port

	path: CE_POINTER [INTEGER_8] assign set_path

	params: CE_POINTER [INTEGER_8] assign set_params

	query: CE_POINTER [INTEGER_8] assign set_query

	fragment: CE_POINTER [INTEGER_8] assign set_fragment

	dir: CE_POINTER [INTEGER_8] assign set_dir

	file: CE_POINTER [INTEGER_8] assign set_file

	user: CE_POINTER [INTEGER_8] assign set_user

	passwd: CE_POINTER [INTEGER_8] assign set_passwd

feature {ANY} -- field setters

	set_url (a_url: CE_POINTER [INTEGER_8])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_scheme (a_scheme: NATURAL_32)
		do
			scheme := a_scheme
			update_memory_field ("scheme")
		end

	set_host (a_host: CE_POINTER [INTEGER_8])
		do
			host := a_host
			update_memory_field ("host")
		end

	set_port (a_port: INTEGER_32)
		do
			port := a_port
			update_memory_field ("port")
		end

	set_path (a_path: CE_POINTER [INTEGER_8])
		do
			path := a_path
			update_memory_field ("path")
		end

	set_params (a_params: CE_POINTER [INTEGER_8])
		do
			params := a_params
			update_memory_field ("params")
		end

	set_query (a_query: CE_POINTER [INTEGER_8])
		do
			query := a_query
			update_memory_field ("query")
		end

	set_fragment (a_fragment: CE_POINTER [INTEGER_8])
		do
			fragment := a_fragment
			update_memory_field ("fragment")
		end

	set_dir (a_dir: CE_POINTER [INTEGER_8])
		do
			dir := a_dir
			update_memory_field ("dir")
		end

	set_file (a_file: CE_POINTER [INTEGER_8])
		do
			file := a_file
			update_memory_field ("file")
		end

	set_user (a_user: CE_POINTER [INTEGER_8])
		do
			user := a_user
			update_memory_field ("user")
		end

	set_passwd (a_passwd: CE_POINTER [INTEGER_8])
		do
			passwd := a_passwd
			update_memory_field ("passwd")
		end

feature {PD_URL} -- private attributes

	known_toplevel_domains: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string (".com"),
					ce_string (".edu"),
					ce_string (".net"),
					ce_string (".org"),
					ce_string (".gov"),
					ce_string (".mil"),
					ce_string (".int")
				>>)
		end

	depth: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	skey_head: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("331 s/key "),
					ce_string ("331 opiekey ")
				>>)
		end

	ftp_last_respline: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<128>>)
		end

	months: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("Jan"),
					ce_string ("Feb"),
					ce_string ("Mar"),
					ce_string ("Apr"),
					ce_string ("May"),
					ce_string ("Jun"),
					ce_string ("Jul"),
					ce_string ("Aug"),
					ce_string ("Sep"),
					ce_string ("Oct"),
					ce_string ("Nov"),
					ce_string ("Dec")
				>>)
		end

	months___0: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("Jan"),
					ce_string ("Feb"),
					ce_string ("Mar"),
					ce_string ("Apr"),
					ce_string ("May"),
					ce_string ("Jun"),
					ce_string ("Jul"),
					ce_string ("Aug"),
					ce_string ("Sep"),
					ce_string ("Oct"),
					ce_string ("Nov"),
					ce_string ("Dec")
				>>)
		end

	basic_authed_hosts: CE_STATIC [CE_POINTER [PD_HASH_TABLE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make
		end

	last_info___1: CE_STATIC [CE_POINTER [PD_TRANSPORT_INFO]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_TRANSPORT_INFO]}.make
		end

	last_fd___1: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	last_tick___1: CE_STATIC [NATURAL_32]
		once ("PROCESS")
		end

	chunk: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<8_192>>)
		end

	pconn_active: CE_STATIC [BOOLEAN]
		once ("PROCESS")
		end

	hfmt: CE_STATIC [CE_ARRAY [CE_ARRAY [CE_POINTER [INTEGER_8]]]]
		once ("PROCESS")
			Result.item := create {CE_ARRAY_ARRAY [CE_POINTER [INTEGER_8]]}.make_initialized (<<
					create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
							ce_string ("%%s"),
							ce_string ("[%%s]")
						>>),
					create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
							ce_string ("%%s:%%d"),
							ce_string ("[%%s]:%%d")
						>>)
				>>)
		end

	options: CE_STATIC [CE_ARRAY [PD_OPTIONS2]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_OPTIONS2]}.make_initialized (<<
					create {PD_OPTIONS2}.make_initialized ([ce_string ("realm"), realm.item]),
					create {PD_OPTIONS2}.make_initialized ([ce_string ("opaque"), opaque.item]),
					create {PD_OPTIONS2}.make_initialized ([ce_string ("nonce"), nonce.item])
				>>)
		end

	realm: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make (<<1>>)
		end

	opaque: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make (<<1>>)
		end

	nonce: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make (<<1>>)
		end

	netrc_list: CE_STATIC [CE_POINTER [PD_ACC_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_ACC_T]}.make
		end

	processed_netrc: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	limit_data: CE_STATIC [CE_ARRAY [PD_LIMIT_DATA]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIMIT_DATA]}.make (<<1>>)
		end

	dlbuf: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<16_384>>)
		end

	last_info: CE_STATIC [CE_POINTER [PD_TRANSPORT_INFO]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_TRANSPORT_INFO]}.make
		end

	last_fd: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	last_tick: CE_STATIC [NATURAL_32]
		once ("PROCESS")
		end

	last_info___0: CE_STATIC [CE_POINTER [PD_TRANSPORT_INFO]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_TRANSPORT_INFO]}.make
		end

	last_fd___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	last_tick___0: CE_STATIC [NATURAL_32]
		once ("PROCESS")
		end

	filechr_table: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					7, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 0,
					0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 2, 2, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 4, 4, 4, 4, 4,
					4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
				>>)
		end

	char_prop: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2,
					1, 0, 1, 16, 1, 1, 1, 1, 1, 0, 1, 1, 16, 4, 0, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 0, 1, 1, 1,
					1, 1, 1, 80, 80, 80, 80, 80, 80, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,
					16, 16, 16, 16, 1, 0, 1, 1, 16, 1, 96, 96, 96, 96, 96, 96, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32,
					32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 1, 0, 1, 17, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
					8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8
				>>)
		end

	tbl: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/")
		end

	Wp: CE_STATIC [CE_ARRAY [CE_ARRAY [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_ARRAY_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("A%/0/%/0/%/0/"),
					ce_string ("ABE%/0/"),
					ce_string ("ACE%/0/"),
					ce_string ("ACT%/0/"),
					ce_string ("AD%/0/%/0/"),
					ce_string ("ADA%/0/"),
					ce_string ("ADD%/0/"),
					ce_string ("AGO%/0/"),
					ce_string ("AID%/0/"),
					ce_string ("AIM%/0/"),
					ce_string ("AIR%/0/"),
					ce_string ("ALL%/0/"),
					ce_string ("ALP%/0/"),
					ce_string ("AM%/0/%/0/"),
					ce_string ("AMY%/0/"),
					ce_string ("AN%/0/%/0/"),
					ce_string ("ANA%/0/"),
					ce_string ("AND%/0/"),
					ce_string ("ANN%/0/"),
					ce_string ("ANT%/0/"),
					ce_string ("ANY%/0/"),
					ce_string ("APE%/0/"),
					ce_string ("APS%/0/"),
					ce_string ("APT%/0/"),
					ce_string ("ARC%/0/"),
					ce_string ("ARE%/0/"),
					ce_string ("ARK%/0/"),
					ce_string ("ARM%/0/"),
					ce_string ("ART%/0/"),
					ce_string ("AS%/0/%/0/"),
					ce_string ("ASH%/0/"),
					ce_string ("ASK%/0/"),
					ce_string ("AT%/0/%/0/"),
					ce_string ("ATE%/0/"),
					ce_string ("AUG%/0/"),
					ce_string ("AUK%/0/"),
					ce_string ("AVE%/0/"),
					ce_string ("AWE%/0/"),
					ce_string ("AWK%/0/"),
					ce_string ("AWL%/0/"),
					ce_string ("AWN%/0/"),
					ce_string ("AX%/0/%/0/"),
					ce_string ("AYE%/0/"),
					ce_string ("BAD%/0/"),
					ce_string ("BAG%/0/"),
					ce_string ("BAH%/0/"),
					ce_string ("BAM%/0/"),
					ce_string ("BAN%/0/"),
					ce_string ("BAR%/0/"),
					ce_string ("BAT%/0/"),
					ce_string ("BAY%/0/"),
					ce_string ("BE%/0/%/0/"),
					ce_string ("BED%/0/"),
					ce_string ("BEE%/0/"),
					ce_string ("BEG%/0/"),
					ce_string ("BEN%/0/"),
					ce_string ("BET%/0/"),
					ce_string ("BEY%/0/"),
					ce_string ("BIB%/0/"),
					ce_string ("BID%/0/"),
					ce_string ("BIG%/0/"),
					ce_string ("BIN%/0/"),
					ce_string ("BIT%/0/"),
					ce_string ("BOB%/0/"),
					ce_string ("BOG%/0/"),
					ce_string ("BON%/0/"),
					ce_string ("BOO%/0/"),
					ce_string ("BOP%/0/"),
					ce_string ("BOW%/0/"),
					ce_string ("BOY%/0/"),
					ce_string ("BUB%/0/"),
					ce_string ("BUD%/0/"),
					ce_string ("BUG%/0/"),
					ce_string ("BUM%/0/"),
					ce_string ("BUN%/0/"),
					ce_string ("BUS%/0/"),
					ce_string ("BUT%/0/"),
					ce_string ("BUY%/0/"),
					ce_string ("BY%/0/%/0/"),
					ce_string ("BYE%/0/"),
					ce_string ("CAB%/0/"),
					ce_string ("CAL%/0/"),
					ce_string ("CAM%/0/"),
					ce_string ("CAN%/0/"),
					ce_string ("CAP%/0/"),
					ce_string ("CAR%/0/"),
					ce_string ("CAT%/0/"),
					ce_string ("CAW%/0/"),
					ce_string ("COD%/0/"),
					ce_string ("COG%/0/"),
					ce_string ("COL%/0/"),
					ce_string ("CON%/0/"),
					ce_string ("COO%/0/"),
					ce_string ("COP%/0/"),
					ce_string ("COT%/0/"),
					ce_string ("COW%/0/"),
					ce_string ("COY%/0/"),
					ce_string ("CRY%/0/"),
					ce_string ("CUB%/0/"),
					ce_string ("CUE%/0/"),
					ce_string ("CUP%/0/"),
					ce_string ("CUR%/0/"),
					ce_string ("CUT%/0/"),
					ce_string ("DAB%/0/"),
					ce_string ("DAD%/0/"),
					ce_string ("DAM%/0/"),
					ce_string ("DAN%/0/"),
					ce_string ("DAR%/0/"),
					ce_string ("DAY%/0/"),
					ce_string ("DEE%/0/"),
					ce_string ("DEL%/0/"),
					ce_string ("DEN%/0/"),
					ce_string ("DES%/0/"),
					ce_string ("DEW%/0/"),
					ce_string ("DID%/0/"),
					ce_string ("DIE%/0/"),
					ce_string ("DIG%/0/"),
					ce_string ("DIN%/0/"),
					ce_string ("DIP%/0/"),
					ce_string ("DO%/0/%/0/"),
					ce_string ("DOE%/0/"),
					ce_string ("DOG%/0/"),
					ce_string ("DON%/0/"),
					ce_string ("DOT%/0/"),
					ce_string ("DOW%/0/"),
					ce_string ("DRY%/0/"),
					ce_string ("DUB%/0/"),
					ce_string ("DUD%/0/"),
					ce_string ("DUE%/0/"),
					ce_string ("DUG%/0/"),
					ce_string ("DUN%/0/"),
					ce_string ("EAR%/0/"),
					ce_string ("EAT%/0/"),
					ce_string ("ED%/0/%/0/"),
					ce_string ("EEL%/0/"),
					ce_string ("EGG%/0/"),
					ce_string ("EGO%/0/"),
					ce_string ("ELI%/0/"),
					ce_string ("ELK%/0/"),
					ce_string ("ELM%/0/"),
					ce_string ("ELY%/0/"),
					ce_string ("EM%/0/%/0/"),
					ce_string ("END%/0/"),
					ce_string ("EST%/0/"),
					ce_string ("ETC%/0/"),
					ce_string ("EVA%/0/"),
					ce_string ("EVE%/0/"),
					ce_string ("EWE%/0/"),
					ce_string ("EYE%/0/"),
					ce_string ("FAD%/0/"),
					ce_string ("FAN%/0/"),
					ce_string ("FAR%/0/"),
					ce_string ("FAT%/0/"),
					ce_string ("FAY%/0/"),
					ce_string ("FED%/0/"),
					ce_string ("FEE%/0/"),
					ce_string ("FEW%/0/"),
					ce_string ("FIB%/0/"),
					ce_string ("FIG%/0/"),
					ce_string ("FIN%/0/"),
					ce_string ("FIR%/0/"),
					ce_string ("FIT%/0/"),
					ce_string ("FLO%/0/"),
					ce_string ("FLY%/0/"),
					ce_string ("FOE%/0/"),
					ce_string ("FOG%/0/"),
					ce_string ("FOR%/0/"),
					ce_string ("FRY%/0/"),
					ce_string ("FUM%/0/"),
					ce_string ("FUN%/0/"),
					ce_string ("FUR%/0/"),
					ce_string ("GAB%/0/"),
					ce_string ("GAD%/0/"),
					ce_string ("GAG%/0/"),
					ce_string ("GAL%/0/"),
					ce_string ("GAM%/0/"),
					ce_string ("GAP%/0/"),
					ce_string ("GAS%/0/"),
					ce_string ("GAY%/0/"),
					ce_string ("GEE%/0/"),
					ce_string ("GEL%/0/"),
					ce_string ("GEM%/0/"),
					ce_string ("GET%/0/"),
					ce_string ("GIG%/0/"),
					ce_string ("GIL%/0/"),
					ce_string ("GIN%/0/"),
					ce_string ("GO%/0/%/0/"),
					ce_string ("GOT%/0/"),
					ce_string ("GUM%/0/"),
					ce_string ("GUN%/0/"),
					ce_string ("GUS%/0/"),
					ce_string ("GUT%/0/"),
					ce_string ("GUY%/0/"),
					ce_string ("GYM%/0/"),
					ce_string ("GYP%/0/"),
					ce_string ("HA%/0/%/0/"),
					ce_string ("HAD%/0/"),
					ce_string ("HAL%/0/"),
					ce_string ("HAM%/0/"),
					ce_string ("HAN%/0/"),
					ce_string ("HAP%/0/"),
					ce_string ("HAS%/0/"),
					ce_string ("HAT%/0/"),
					ce_string ("HAW%/0/"),
					ce_string ("HAY%/0/"),
					ce_string ("HE%/0/%/0/"),
					ce_string ("HEM%/0/"),
					ce_string ("HEN%/0/"),
					ce_string ("HER%/0/"),
					ce_string ("HEW%/0/"),
					ce_string ("HEY%/0/"),
					ce_string ("HI%/0/%/0/"),
					ce_string ("HID%/0/"),
					ce_string ("HIM%/0/"),
					ce_string ("HIP%/0/"),
					ce_string ("HIS%/0/"),
					ce_string ("HIT%/0/"),
					ce_string ("HO%/0/%/0/"),
					ce_string ("HOB%/0/"),
					ce_string ("HOC%/0/"),
					ce_string ("HOE%/0/"),
					ce_string ("HOG%/0/"),
					ce_string ("HOP%/0/"),
					ce_string ("HOT%/0/"),
					ce_string ("HOW%/0/"),
					ce_string ("HUB%/0/"),
					ce_string ("HUE%/0/"),
					ce_string ("HUG%/0/"),
					ce_string ("HUH%/0/"),
					ce_string ("HUM%/0/"),
					ce_string ("HUT%/0/"),
					ce_string ("I%/0/%/0/%/0/"),
					ce_string ("ICY%/0/"),
					ce_string ("IDA%/0/"),
					ce_string ("IF%/0/%/0/"),
					ce_string ("IKE%/0/"),
					ce_string ("ILL%/0/"),
					ce_string ("INK%/0/"),
					ce_string ("INN%/0/"),
					ce_string ("IO%/0/%/0/"),
					ce_string ("ION%/0/"),
					ce_string ("IQ%/0/%/0/"),
					ce_string ("IRA%/0/"),
					ce_string ("IRE%/0/"),
					ce_string ("IRK%/0/"),
					ce_string ("IS%/0/%/0/"),
					ce_string ("IT%/0/%/0/"),
					ce_string ("ITS%/0/"),
					ce_string ("IVY%/0/"),
					ce_string ("JAB%/0/"),
					ce_string ("JAG%/0/"),
					ce_string ("JAM%/0/"),
					ce_string ("JAN%/0/"),
					ce_string ("JAR%/0/"),
					ce_string ("JAW%/0/"),
					ce_string ("JAY%/0/"),
					ce_string ("JET%/0/"),
					ce_string ("JIG%/0/"),
					ce_string ("JIM%/0/"),
					ce_string ("JO%/0/%/0/"),
					ce_string ("JOB%/0/"),
					ce_string ("JOE%/0/"),
					ce_string ("JOG%/0/"),
					ce_string ("JOT%/0/"),
					ce_string ("JOY%/0/"),
					ce_string ("JUG%/0/"),
					ce_string ("JUT%/0/"),
					ce_string ("KAY%/0/"),
					ce_string ("KEG%/0/"),
					ce_string ("KEN%/0/"),
					ce_string ("KEY%/0/"),
					ce_string ("KID%/0/"),
					ce_string ("KIM%/0/"),
					ce_string ("KIN%/0/"),
					ce_string ("KIT%/0/"),
					ce_string ("LA%/0/%/0/"),
					ce_string ("LAB%/0/"),
					ce_string ("LAC%/0/"),
					ce_string ("LAD%/0/"),
					ce_string ("LAG%/0/"),
					ce_string ("LAM%/0/"),
					ce_string ("LAP%/0/"),
					ce_string ("LAW%/0/"),
					ce_string ("LAY%/0/"),
					ce_string ("LEA%/0/"),
					ce_string ("LED%/0/"),
					ce_string ("LEE%/0/"),
					ce_string ("LEG%/0/"),
					ce_string ("LEN%/0/"),
					ce_string ("LEO%/0/"),
					ce_string ("LET%/0/"),
					ce_string ("LEW%/0/"),
					ce_string ("LID%/0/"),
					ce_string ("LIE%/0/"),
					ce_string ("LIN%/0/"),
					ce_string ("LIP%/0/"),
					ce_string ("LIT%/0/"),
					ce_string ("LO%/0/%/0/"),
					ce_string ("LOB%/0/"),
					ce_string ("LOG%/0/"),
					ce_string ("LOP%/0/"),
					ce_string ("LOS%/0/"),
					ce_string ("LOT%/0/"),
					ce_string ("LOU%/0/"),
					ce_string ("LOW%/0/"),
					ce_string ("LOY%/0/"),
					ce_string ("LUG%/0/"),
					ce_string ("LYE%/0/"),
					ce_string ("MA%/0/%/0/"),
					ce_string ("MAC%/0/"),
					ce_string ("MAD%/0/"),
					ce_string ("MAE%/0/"),
					ce_string ("MAN%/0/"),
					ce_string ("MAO%/0/"),
					ce_string ("MAP%/0/"),
					ce_string ("MAT%/0/"),
					ce_string ("MAW%/0/"),
					ce_string ("MAY%/0/"),
					ce_string ("ME%/0/%/0/"),
					ce_string ("MEG%/0/"),
					ce_string ("MEL%/0/"),
					ce_string ("MEN%/0/"),
					ce_string ("MET%/0/"),
					ce_string ("MEW%/0/"),
					ce_string ("MID%/0/"),
					ce_string ("MIN%/0/"),
					ce_string ("MIT%/0/"),
					ce_string ("MOB%/0/"),
					ce_string ("MOD%/0/"),
					ce_string ("MOE%/0/"),
					ce_string ("MOO%/0/"),
					ce_string ("MOP%/0/"),
					ce_string ("MOS%/0/"),
					ce_string ("MOT%/0/"),
					ce_string ("MOW%/0/"),
					ce_string ("MUD%/0/"),
					ce_string ("MUG%/0/"),
					ce_string ("MUM%/0/"),
					ce_string ("MY%/0/%/0/"),
					ce_string ("NAB%/0/"),
					ce_string ("NAG%/0/"),
					ce_string ("NAN%/0/"),
					ce_string ("NAP%/0/"),
					ce_string ("NAT%/0/"),
					ce_string ("NAY%/0/"),
					ce_string ("NE%/0/%/0/"),
					ce_string ("NED%/0/"),
					ce_string ("NEE%/0/"),
					ce_string ("NET%/0/"),
					ce_string ("NEW%/0/"),
					ce_string ("NIB%/0/"),
					ce_string ("NIL%/0/"),
					ce_string ("NIP%/0/"),
					ce_string ("NIT%/0/"),
					ce_string ("NO%/0/%/0/"),
					ce_string ("NOB%/0/"),
					ce_string ("NOD%/0/"),
					ce_string ("NON%/0/"),
					ce_string ("NOR%/0/"),
					ce_string ("NOT%/0/"),
					ce_string ("NOV%/0/"),
					ce_string ("NOW%/0/"),
					ce_string ("NU%/0/%/0/"),
					ce_string ("NUN%/0/"),
					ce_string ("NUT%/0/"),
					ce_string ("O%/0/%/0/%/0/"),
					ce_string ("OAF%/0/"),
					ce_string ("OAK%/0/"),
					ce_string ("OAR%/0/"),
					ce_string ("OAT%/0/"),
					ce_string ("ODD%/0/"),
					ce_string ("ODE%/0/"),
					ce_string ("OF%/0/%/0/"),
					ce_string ("OFF%/0/"),
					ce_string ("OFT%/0/"),
					ce_string ("OH%/0/%/0/"),
					ce_string ("OIL%/0/"),
					ce_string ("OK%/0/%/0/"),
					ce_string ("OLD%/0/"),
					ce_string ("ON%/0/%/0/"),
					ce_string ("ONE%/0/"),
					ce_string ("OR%/0/%/0/"),
					ce_string ("ORB%/0/"),
					ce_string ("ORE%/0/"),
					ce_string ("ORR%/0/"),
					ce_string ("OS%/0/%/0/"),
					ce_string ("OTT%/0/"),
					ce_string ("OUR%/0/"),
					ce_string ("OUT%/0/"),
					ce_string ("OVA%/0/"),
					ce_string ("OW%/0/%/0/"),
					ce_string ("OWE%/0/"),
					ce_string ("OWL%/0/"),
					ce_string ("OWN%/0/"),
					ce_string ("OX%/0/%/0/"),
					ce_string ("PA%/0/%/0/"),
					ce_string ("PAD%/0/"),
					ce_string ("PAL%/0/"),
					ce_string ("PAM%/0/"),
					ce_string ("PAN%/0/"),
					ce_string ("PAP%/0/"),
					ce_string ("PAR%/0/"),
					ce_string ("PAT%/0/"),
					ce_string ("PAW%/0/"),
					ce_string ("PAY%/0/"),
					ce_string ("PEA%/0/"),
					ce_string ("PEG%/0/"),
					ce_string ("PEN%/0/"),
					ce_string ("PEP%/0/"),
					ce_string ("PER%/0/"),
					ce_string ("PET%/0/"),
					ce_string ("PEW%/0/"),
					ce_string ("PHI%/0/"),
					ce_string ("PI%/0/%/0/"),
					ce_string ("PIE%/0/"),
					ce_string ("PIN%/0/"),
					ce_string ("PIT%/0/"),
					ce_string ("PLY%/0/"),
					ce_string ("PO%/0/%/0/"),
					ce_string ("POD%/0/"),
					ce_string ("POE%/0/"),
					ce_string ("POP%/0/"),
					ce_string ("POT%/0/"),
					ce_string ("POW%/0/"),
					ce_string ("PRO%/0/"),
					ce_string ("PRY%/0/"),
					ce_string ("PUB%/0/"),
					ce_string ("PUG%/0/"),
					ce_string ("PUN%/0/"),
					ce_string ("PUP%/0/"),
					ce_string ("PUT%/0/"),
					ce_string ("QUO%/0/"),
					ce_string ("RAG%/0/"),
					ce_string ("RAM%/0/"),
					ce_string ("RAN%/0/"),
					ce_string ("RAP%/0/"),
					ce_string ("RAT%/0/"),
					ce_string ("RAW%/0/"),
					ce_string ("RAY%/0/"),
					ce_string ("REB%/0/"),
					ce_string ("RED%/0/"),
					ce_string ("REP%/0/"),
					ce_string ("RET%/0/"),
					ce_string ("RIB%/0/"),
					ce_string ("RID%/0/"),
					ce_string ("RIG%/0/"),
					ce_string ("RIM%/0/"),
					ce_string ("RIO%/0/"),
					ce_string ("RIP%/0/"),
					ce_string ("ROB%/0/"),
					ce_string ("ROD%/0/"),
					ce_string ("ROE%/0/"),
					ce_string ("RON%/0/"),
					ce_string ("ROT%/0/"),
					ce_string ("ROW%/0/"),
					ce_string ("ROY%/0/"),
					ce_string ("RUB%/0/"),
					ce_string ("RUE%/0/"),
					ce_string ("RUG%/0/"),
					ce_string ("RUM%/0/"),
					ce_string ("RUN%/0/"),
					ce_string ("RYE%/0/"),
					ce_string ("SAC%/0/"),
					ce_string ("SAD%/0/"),
					ce_string ("SAG%/0/"),
					ce_string ("SAL%/0/"),
					ce_string ("SAM%/0/"),
					ce_string ("SAN%/0/"),
					ce_string ("SAP%/0/"),
					ce_string ("SAT%/0/"),
					ce_string ("SAW%/0/"),
					ce_string ("SAY%/0/"),
					ce_string ("SEA%/0/"),
					ce_string ("SEC%/0/"),
					ce_string ("SEE%/0/"),
					ce_string ("SEN%/0/"),
					ce_string ("SET%/0/"),
					ce_string ("SEW%/0/"),
					ce_string ("SHE%/0/"),
					ce_string ("SHY%/0/"),
					ce_string ("SIN%/0/"),
					ce_string ("SIP%/0/"),
					ce_string ("SIR%/0/"),
					ce_string ("SIS%/0/"),
					ce_string ("SIT%/0/"),
					ce_string ("SKI%/0/"),
					ce_string ("SKY%/0/"),
					ce_string ("SLY%/0/"),
					ce_string ("SO%/0/%/0/"),
					ce_string ("SOB%/0/"),
					ce_string ("SOD%/0/"),
					ce_string ("SON%/0/"),
					ce_string ("SOP%/0/"),
					ce_string ("SOW%/0/"),
					ce_string ("SOY%/0/"),
					ce_string ("SPA%/0/"),
					ce_string ("SPY%/0/"),
					ce_string ("SUB%/0/"),
					ce_string ("SUD%/0/"),
					ce_string ("SUE%/0/"),
					ce_string ("SUM%/0/"),
					ce_string ("SUN%/0/"),
					ce_string ("SUP%/0/"),
					ce_string ("TAB%/0/"),
					ce_string ("TAD%/0/"),
					ce_string ("TAG%/0/"),
					ce_string ("TAN%/0/"),
					ce_string ("TAP%/0/"),
					ce_string ("TAR%/0/"),
					ce_string ("TEA%/0/"),
					ce_string ("TED%/0/"),
					ce_string ("TEE%/0/"),
					ce_string ("TEN%/0/"),
					ce_string ("THE%/0/"),
					ce_string ("THY%/0/"),
					ce_string ("TIC%/0/"),
					ce_string ("TIE%/0/"),
					ce_string ("TIM%/0/"),
					ce_string ("TIN%/0/"),
					ce_string ("TIP%/0/"),
					ce_string ("TO%/0/%/0/"),
					ce_string ("TOE%/0/"),
					ce_string ("TOG%/0/"),
					ce_string ("TOM%/0/"),
					ce_string ("TON%/0/"),
					ce_string ("TOO%/0/"),
					ce_string ("TOP%/0/"),
					ce_string ("TOW%/0/"),
					ce_string ("TOY%/0/"),
					ce_string ("TRY%/0/"),
					ce_string ("TUB%/0/"),
					ce_string ("TUG%/0/"),
					ce_string ("TUM%/0/"),
					ce_string ("TUN%/0/"),
					ce_string ("TWO%/0/"),
					ce_string ("UN%/0/%/0/"),
					ce_string ("UP%/0/%/0/"),
					ce_string ("US%/0/%/0/"),
					ce_string ("USE%/0/"),
					ce_string ("VAN%/0/"),
					ce_string ("VAT%/0/"),
					ce_string ("VET%/0/"),
					ce_string ("VIE%/0/"),
					ce_string ("WAD%/0/"),
					ce_string ("WAG%/0/"),
					ce_string ("WAR%/0/"),
					ce_string ("WAS%/0/"),
					ce_string ("WAY%/0/"),
					ce_string ("WE%/0/%/0/"),
					ce_string ("WEB%/0/"),
					ce_string ("WED%/0/"),
					ce_string ("WEE%/0/"),
					ce_string ("WET%/0/"),
					ce_string ("WHO%/0/"),
					ce_string ("WHY%/0/"),
					ce_string ("WIN%/0/"),
					ce_string ("WIT%/0/"),
					ce_string ("WOK%/0/"),
					ce_string ("WON%/0/"),
					ce_string ("WOO%/0/"),
					ce_string ("WOW%/0/"),
					ce_string ("WRY%/0/"),
					ce_string ("WU%/0/%/0/"),
					ce_string ("YAM%/0/"),
					ce_string ("YAP%/0/"),
					ce_string ("YAW%/0/"),
					ce_string ("YE%/0/%/0/"),
					ce_string ("YEA%/0/"),
					ce_string ("YES%/0/"),
					ce_string ("YET%/0/"),
					ce_string ("YOU%/0/"),
					ce_string ("ABED"),
					ce_string ("ABEL"),
					ce_string ("ABET"),
					ce_string ("ABLE"),
					ce_string ("ABUT"),
					ce_string ("ACHE"),
					ce_string ("ACID"),
					ce_string ("ACME"),
					ce_string ("ACRE"),
					ce_string ("ACTA"),
					ce_string ("ACTS"),
					ce_string ("ADAM"),
					ce_string ("ADDS"),
					ce_string ("ADEN"),
					ce_string ("AFAR"),
					ce_string ("AFRO"),
					ce_string ("AGEE"),
					ce_string ("AHEM"),
					ce_string ("AHOY"),
					ce_string ("AIDA"),
					ce_string ("AIDE"),
					ce_string ("AIDS"),
					ce_string ("AIRY"),
					ce_string ("AJAR"),
					ce_string ("AKIN"),
					ce_string ("ALAN"),
					ce_string ("ALEC"),
					ce_string ("ALGA"),
					ce_string ("ALIA"),
					ce_string ("ALLY"),
					ce_string ("ALMA"),
					ce_string ("ALOE"),
					ce_string ("ALSO"),
					ce_string ("ALTO"),
					ce_string ("ALUM"),
					ce_string ("ALVA"),
					ce_string ("AMEN"),
					ce_string ("AMES"),
					ce_string ("AMID"),
					ce_string ("AMMO"),
					ce_string ("AMOK"),
					ce_string ("AMOS"),
					ce_string ("AMRA"),
					ce_string ("ANDY"),
					ce_string ("ANEW"),
					ce_string ("ANNA"),
					ce_string ("ANNE"),
					ce_string ("ANTE"),
					ce_string ("ANTI"),
					ce_string ("AQUA"),
					ce_string ("ARAB"),
					ce_string ("ARCH"),
					ce_string ("AREA"),
					ce_string ("ARGO"),
					ce_string ("ARID"),
					ce_string ("ARMY"),
					ce_string ("ARTS"),
					ce_string ("ARTY"),
					ce_string ("ASIA"),
					ce_string ("ASKS"),
					ce_string ("ATOM"),
					ce_string ("AUNT"),
					ce_string ("AURA"),
					ce_string ("AUTO"),
					ce_string ("AVER"),
					ce_string ("AVID"),
					ce_string ("AVIS"),
					ce_string ("AVON"),
					ce_string ("AVOW"),
					ce_string ("AWAY"),
					ce_string ("AWRY"),
					ce_string ("BABE"),
					ce_string ("BABY"),
					ce_string ("BACH"),
					ce_string ("BACK"),
					ce_string ("BADE"),
					ce_string ("BAIL"),
					ce_string ("BAIT"),
					ce_string ("BAKE"),
					ce_string ("BALD"),
					ce_string ("BALE"),
					ce_string ("BALI"),
					ce_string ("BALK"),
					ce_string ("BALL"),
					ce_string ("BALM"),
					ce_string ("BAND"),
					ce_string ("BANE"),
					ce_string ("BANG"),
					ce_string ("BANK"),
					ce_string ("BARB"),
					ce_string ("BARD"),
					ce_string ("BARE"),
					ce_string ("BARK"),
					ce_string ("BARN"),
					ce_string ("BARR"),
					ce_string ("BASE"),
					ce_string ("BASH"),
					ce_string ("BASK"),
					ce_string ("BASS"),
					ce_string ("BATE"),
					ce_string ("BATH"),
					ce_string ("BAWD"),
					ce_string ("BAWL"),
					ce_string ("BEAD"),
					ce_string ("BEAK"),
					ce_string ("BEAM"),
					ce_string ("BEAN"),
					ce_string ("BEAR"),
					ce_string ("BEAT"),
					ce_string ("BEAU"),
					ce_string ("BECK"),
					ce_string ("BEEF"),
					ce_string ("BEEN"),
					ce_string ("BEER"),
					ce_string ("BEET"),
					ce_string ("BELA"),
					ce_string ("BELL"),
					ce_string ("BELT"),
					ce_string ("BEND"),
					ce_string ("BENT"),
					ce_string ("BERG"),
					ce_string ("BERN"),
					ce_string ("BERT"),
					ce_string ("BESS"),
					ce_string ("BEST"),
					ce_string ("BETA"),
					ce_string ("BETH"),
					ce_string ("BHOY"),
					ce_string ("BIAS"),
					ce_string ("BIDE"),
					ce_string ("BIEN"),
					ce_string ("BILE"),
					ce_string ("BILK"),
					ce_string ("BILL"),
					ce_string ("BIND"),
					ce_string ("BING"),
					ce_string ("BIRD"),
					ce_string ("BITE"),
					ce_string ("BITS"),
					ce_string ("BLAB"),
					ce_string ("BLAT"),
					ce_string ("BLED"),
					ce_string ("BLEW"),
					ce_string ("BLOB"),
					ce_string ("BLOC"),
					ce_string ("BLOT"),
					ce_string ("BLOW"),
					ce_string ("BLUE"),
					ce_string ("BLUM"),
					ce_string ("BLUR"),
					ce_string ("BOAR"),
					ce_string ("BOAT"),
					ce_string ("BOCA"),
					ce_string ("BOCK"),
					ce_string ("BODE"),
					ce_string ("BODY"),
					ce_string ("BOGY"),
					ce_string ("BOHR"),
					ce_string ("BOIL"),
					ce_string ("BOLD"),
					ce_string ("BOLO"),
					ce_string ("BOLT"),
					ce_string ("BOMB"),
					ce_string ("BONA"),
					ce_string ("BOND"),
					ce_string ("BONE"),
					ce_string ("BONG"),
					ce_string ("BONN"),
					ce_string ("BONY"),
					ce_string ("BOOK"),
					ce_string ("BOOM"),
					ce_string ("BOON"),
					ce_string ("BOOT"),
					ce_string ("BORE"),
					ce_string ("BORG"),
					ce_string ("BORN"),
					ce_string ("BOSE"),
					ce_string ("BOSS"),
					ce_string ("BOTH"),
					ce_string ("BOUT"),
					ce_string ("BOWL"),
					ce_string ("BOYD"),
					ce_string ("BRAD"),
					ce_string ("BRAE"),
					ce_string ("BRAG"),
					ce_string ("BRAN"),
					ce_string ("BRAY"),
					ce_string ("BRED"),
					ce_string ("BREW"),
					ce_string ("BRIG"),
					ce_string ("BRIM"),
					ce_string ("BROW"),
					ce_string ("BUCK"),
					ce_string ("BUDD"),
					ce_string ("BUFF"),
					ce_string ("BULB"),
					ce_string ("BULK"),
					ce_string ("BULL"),
					ce_string ("BUNK"),
					ce_string ("BUNT"),
					ce_string ("BUOY"),
					ce_string ("BURG"),
					ce_string ("BURL"),
					ce_string ("BURN"),
					ce_string ("BURR"),
					ce_string ("BURT"),
					ce_string ("BURY"),
					ce_string ("BUSH"),
					ce_string ("BUSS"),
					ce_string ("BUST"),
					ce_string ("BUSY"),
					ce_string ("BYTE"),
					ce_string ("CADY"),
					ce_string ("CAFE"),
					ce_string ("CAGE"),
					ce_string ("CAIN"),
					ce_string ("CAKE"),
					ce_string ("CALF"),
					ce_string ("CALL"),
					ce_string ("CALM"),
					ce_string ("CAME"),
					ce_string ("CANE"),
					ce_string ("CANT"),
					ce_string ("CARD"),
					ce_string ("CARE"),
					ce_string ("CARL"),
					ce_string ("CARR"),
					ce_string ("CART"),
					ce_string ("CASE"),
					ce_string ("CASH"),
					ce_string ("CASK"),
					ce_string ("CAST"),
					ce_string ("CAVE"),
					ce_string ("CEIL"),
					ce_string ("CELL"),
					ce_string ("CENT"),
					ce_string ("CERN"),
					ce_string ("CHAD"),
					ce_string ("CHAR"),
					ce_string ("CHAT"),
					ce_string ("CHAW"),
					ce_string ("CHEF"),
					ce_string ("CHEN"),
					ce_string ("CHEW"),
					ce_string ("CHIC"),
					ce_string ("CHIN"),
					ce_string ("CHOU"),
					ce_string ("CHOW"),
					ce_string ("CHUB"),
					ce_string ("CHUG"),
					ce_string ("CHUM"),
					ce_string ("CITE"),
					ce_string ("CITY"),
					ce_string ("CLAD"),
					ce_string ("CLAM"),
					ce_string ("CLAN"),
					ce_string ("CLAW"),
					ce_string ("CLAY"),
					ce_string ("CLOD"),
					ce_string ("CLOG"),
					ce_string ("CLOT"),
					ce_string ("CLUB"),
					ce_string ("CLUE"),
					ce_string ("COAL"),
					ce_string ("COAT"),
					ce_string ("COCA"),
					ce_string ("COCK"),
					ce_string ("COCO"),
					ce_string ("CODA"),
					ce_string ("CODE"),
					ce_string ("CODY"),
					ce_string ("COED"),
					ce_string ("COIL"),
					ce_string ("COIN"),
					ce_string ("COKE"),
					ce_string ("COLA"),
					ce_string ("COLD"),
					ce_string ("COLT"),
					ce_string ("COMA"),
					ce_string ("COMB"),
					ce_string ("COME"),
					ce_string ("COOK"),
					ce_string ("COOL"),
					ce_string ("COON"),
					ce_string ("COOT"),
					ce_string ("CORD"),
					ce_string ("CORE"),
					ce_string ("CORK"),
					ce_string ("CORN"),
					ce_string ("COST"),
					ce_string ("COVE"),
					ce_string ("COWL"),
					ce_string ("CRAB"),
					ce_string ("CRAG"),
					ce_string ("CRAM"),
					ce_string ("CRAY"),
					ce_string ("CREW"),
					ce_string ("CRIB"),
					ce_string ("CROW"),
					ce_string ("CRUD"),
					ce_string ("CUBA"),
					ce_string ("CUBE"),
					ce_string ("CUFF"),
					ce_string ("CULL"),
					ce_string ("CULT"),
					ce_string ("CUNY"),
					ce_string ("CURB"),
					ce_string ("CURD"),
					ce_string ("CURE"),
					ce_string ("CURL"),
					ce_string ("CURT"),
					ce_string ("CUTS"),
					ce_string ("DADE"),
					ce_string ("DALE"),
					ce_string ("DAME"),
					ce_string ("DANA"),
					ce_string ("DANE"),
					ce_string ("DANG"),
					ce_string ("DANK"),
					ce_string ("DARE"),
					ce_string ("DARK"),
					ce_string ("DARN"),
					ce_string ("DART"),
					ce_string ("DASH"),
					ce_string ("DATA"),
					ce_string ("DATE"),
					ce_string ("DAVE"),
					ce_string ("DAVY"),
					ce_string ("DAWN"),
					ce_string ("DAYS"),
					ce_string ("DEAD"),
					ce_string ("DEAF"),
					ce_string ("DEAL"),
					ce_string ("DEAN"),
					ce_string ("DEAR"),
					ce_string ("DEBT"),
					ce_string ("DECK"),
					ce_string ("DEED"),
					ce_string ("DEEM"),
					ce_string ("DEER"),
					ce_string ("DEFT"),
					ce_string ("DEFY"),
					ce_string ("DELL"),
					ce_string ("DENT"),
					ce_string ("DENY"),
					ce_string ("DESK"),
					ce_string ("DIAL"),
					ce_string ("DICE"),
					ce_string ("DIED"),
					ce_string ("DIET"),
					ce_string ("DIME"),
					ce_string ("DINE"),
					ce_string ("DING"),
					ce_string ("DINT"),
					ce_string ("DIRE"),
					ce_string ("DIRT"),
					ce_string ("DISC"),
					ce_string ("DISH"),
					ce_string ("DISK"),
					ce_string ("DIVE"),
					ce_string ("DOCK"),
					ce_string ("DOES"),
					ce_string ("DOLE"),
					ce_string ("DOLL"),
					ce_string ("DOLT"),
					ce_string ("DOME"),
					ce_string ("DONE"),
					ce_string ("DOOM"),
					ce_string ("DOOR"),
					ce_string ("DORA"),
					ce_string ("DOSE"),
					ce_string ("DOTE"),
					ce_string ("DOUG"),
					ce_string ("DOUR"),
					ce_string ("DOVE"),
					ce_string ("DOWN"),
					ce_string ("DRAB"),
					ce_string ("DRAG"),
					ce_string ("DRAM"),
					ce_string ("DRAW"),
					ce_string ("DREW"),
					ce_string ("DRUB"),
					ce_string ("DRUG"),
					ce_string ("DRUM"),
					ce_string ("DUAL"),
					ce_string ("DUCK"),
					ce_string ("DUCT"),
					ce_string ("DUEL"),
					ce_string ("DUET"),
					ce_string ("DUKE"),
					ce_string ("DULL"),
					ce_string ("DUMB"),
					ce_string ("DUNE"),
					ce_string ("DUNK"),
					ce_string ("DUSK"),
					ce_string ("DUST"),
					ce_string ("DUTY"),
					ce_string ("EACH"),
					ce_string ("EARL"),
					ce_string ("EARN"),
					ce_string ("EASE"),
					ce_string ("EAST"),
					ce_string ("EASY"),
					ce_string ("EBEN"),
					ce_string ("ECHO"),
					ce_string ("EDDY"),
					ce_string ("EDEN"),
					ce_string ("EDGE"),
					ce_string ("EDGY"),
					ce_string ("EDIT"),
					ce_string ("EDNA"),
					ce_string ("EGAN"),
					ce_string ("ELAN"),
					ce_string ("ELBA"),
					ce_string ("ELLA"),
					ce_string ("ELSE"),
					ce_string ("EMIL"),
					ce_string ("EMIT"),
					ce_string ("EMMA"),
					ce_string ("ENDS"),
					ce_string ("ERIC"),
					ce_string ("EROS"),
					ce_string ("EVEN"),
					ce_string ("EVER"),
					ce_string ("EVIL"),
					ce_string ("EYED"),
					ce_string ("FACE"),
					ce_string ("FACT"),
					ce_string ("FADE"),
					ce_string ("FAIL"),
					ce_string ("FAIN"),
					ce_string ("FAIR"),
					ce_string ("FAKE"),
					ce_string ("FALL"),
					ce_string ("FAME"),
					ce_string ("FANG"),
					ce_string ("FARM"),
					ce_string ("FAST"),
					ce_string ("FATE"),
					ce_string ("FAWN"),
					ce_string ("FEAR"),
					ce_string ("FEAT"),
					ce_string ("FEED"),
					ce_string ("FEEL"),
					ce_string ("FEET"),
					ce_string ("FELL"),
					ce_string ("FELT"),
					ce_string ("FEND"),
					ce_string ("FERN"),
					ce_string ("FEST"),
					ce_string ("FEUD"),
					ce_string ("FIEF"),
					ce_string ("FIGS"),
					ce_string ("FILE"),
					ce_string ("FILL"),
					ce_string ("FILM"),
					ce_string ("FIND"),
					ce_string ("FINE"),
					ce_string ("FINK"),
					ce_string ("FIRE"),
					ce_string ("FIRM"),
					ce_string ("FISH"),
					ce_string ("FISK"),
					ce_string ("FIST"),
					ce_string ("FITS"),
					ce_string ("FIVE"),
					ce_string ("FLAG"),
					ce_string ("FLAK"),
					ce_string ("FLAM"),
					ce_string ("FLAT"),
					ce_string ("FLAW"),
					ce_string ("FLEA"),
					ce_string ("FLED"),
					ce_string ("FLEW"),
					ce_string ("FLIT"),
					ce_string ("FLOC"),
					ce_string ("FLOG"),
					ce_string ("FLOW"),
					ce_string ("FLUB"),
					ce_string ("FLUE"),
					ce_string ("FOAL"),
					ce_string ("FOAM"),
					ce_string ("FOGY"),
					ce_string ("FOIL"),
					ce_string ("FOLD"),
					ce_string ("FOLK"),
					ce_string ("FOND"),
					ce_string ("FONT"),
					ce_string ("FOOD"),
					ce_string ("FOOL"),
					ce_string ("FOOT"),
					ce_string ("FORD"),
					ce_string ("FORE"),
					ce_string ("FORK"),
					ce_string ("FORM"),
					ce_string ("FORT"),
					ce_string ("FOSS"),
					ce_string ("FOUL"),
					ce_string ("FOUR"),
					ce_string ("FOWL"),
					ce_string ("FRAU"),
					ce_string ("FRAY"),
					ce_string ("FRED"),
					ce_string ("FREE"),
					ce_string ("FRET"),
					ce_string ("FREY"),
					ce_string ("FROG"),
					ce_string ("FROM"),
					ce_string ("FUEL"),
					ce_string ("FULL"),
					ce_string ("FUME"),
					ce_string ("FUND"),
					ce_string ("FUNK"),
					ce_string ("FURY"),
					ce_string ("FUSE"),
					ce_string ("FUSS"),
					ce_string ("GAFF"),
					ce_string ("GAGE"),
					ce_string ("GAIL"),
					ce_string ("GAIN"),
					ce_string ("GAIT"),
					ce_string ("GALA"),
					ce_string ("GALE"),
					ce_string ("GALL"),
					ce_string ("GALT"),
					ce_string ("GAME"),
					ce_string ("GANG"),
					ce_string ("GARB"),
					ce_string ("GARY"),
					ce_string ("GASH"),
					ce_string ("GATE"),
					ce_string ("GAUL"),
					ce_string ("GAUR"),
					ce_string ("GAVE"),
					ce_string ("GAWK"),
					ce_string ("GEAR"),
					ce_string ("GELD"),
					ce_string ("GENE"),
					ce_string ("GENT"),
					ce_string ("GERM"),
					ce_string ("GETS"),
					ce_string ("GIBE"),
					ce_string ("GIFT"),
					ce_string ("GILD"),
					ce_string ("GILL"),
					ce_string ("GILT"),
					ce_string ("GINA"),
					ce_string ("GIRD"),
					ce_string ("GIRL"),
					ce_string ("GIST"),
					ce_string ("GIVE"),
					ce_string ("GLAD"),
					ce_string ("GLEE"),
					ce_string ("GLEN"),
					ce_string ("GLIB"),
					ce_string ("GLOB"),
					ce_string ("GLOM"),
					ce_string ("GLOW"),
					ce_string ("GLUE"),
					ce_string ("GLUM"),
					ce_string ("GLUT"),
					ce_string ("GOAD"),
					ce_string ("GOAL"),
					ce_string ("GOAT"),
					ce_string ("GOER"),
					ce_string ("GOES"),
					ce_string ("GOLD"),
					ce_string ("GOLF"),
					ce_string ("GONE"),
					ce_string ("GONG"),
					ce_string ("GOOD"),
					ce_string ("GOOF"),
					ce_string ("GORE"),
					ce_string ("GORY"),
					ce_string ("GOSH"),
					ce_string ("GOUT"),
					ce_string ("GOWN"),
					ce_string ("GRAB"),
					ce_string ("GRAD"),
					ce_string ("GRAY"),
					ce_string ("GREG"),
					ce_string ("GREW"),
					ce_string ("GREY"),
					ce_string ("GRID"),
					ce_string ("GRIM"),
					ce_string ("GRIN"),
					ce_string ("GRIT"),
					ce_string ("GROW"),
					ce_string ("GRUB"),
					ce_string ("GULF"),
					ce_string ("GULL"),
					ce_string ("GUNK"),
					ce_string ("GURU"),
					ce_string ("GUSH"),
					ce_string ("GUST"),
					ce_string ("GWEN"),
					ce_string ("GWYN"),
					ce_string ("HAAG"),
					ce_string ("HAAS"),
					ce_string ("HACK"),
					ce_string ("HAIL"),
					ce_string ("HAIR"),
					ce_string ("HALE"),
					ce_string ("HALF"),
					ce_string ("HALL"),
					ce_string ("HALO"),
					ce_string ("HALT"),
					ce_string ("HAND"),
					ce_string ("HANG"),
					ce_string ("HANK"),
					ce_string ("HANS"),
					ce_string ("HARD"),
					ce_string ("HARK"),
					ce_string ("HARM"),
					ce_string ("HART"),
					ce_string ("HASH"),
					ce_string ("HAST"),
					ce_string ("HATE"),
					ce_string ("HATH"),
					ce_string ("HAUL"),
					ce_string ("HAVE"),
					ce_string ("HAWK"),
					ce_string ("HAYS"),
					ce_string ("HEAD"),
					ce_string ("HEAL"),
					ce_string ("HEAR"),
					ce_string ("HEAT"),
					ce_string ("HEBE"),
					ce_string ("HECK"),
					ce_string ("HEED"),
					ce_string ("HEEL"),
					ce_string ("HEFT"),
					ce_string ("HELD"),
					ce_string ("HELL"),
					ce_string ("HELM"),
					ce_string ("HERB"),
					ce_string ("HERD"),
					ce_string ("HERE"),
					ce_string ("HERO"),
					ce_string ("HERS"),
					ce_string ("HESS"),
					ce_string ("HEWN"),
					ce_string ("HICK"),
					ce_string ("HIDE"),
					ce_string ("HIGH"),
					ce_string ("HIKE"),
					ce_string ("HILL"),
					ce_string ("HILT"),
					ce_string ("HIND"),
					ce_string ("HINT"),
					ce_string ("HIRE"),
					ce_string ("HISS"),
					ce_string ("HIVE"),
					ce_string ("HOBO"),
					ce_string ("HOCK"),
					ce_string ("HOFF"),
					ce_string ("HOLD"),
					ce_string ("HOLE"),
					ce_string ("HOLM"),
					ce_string ("HOLT"),
					ce_string ("HOME"),
					ce_string ("HONE"),
					ce_string ("HONK"),
					ce_string ("HOOD"),
					ce_string ("HOOF"),
					ce_string ("HOOK"),
					ce_string ("HOOT"),
					ce_string ("HORN"),
					ce_string ("HOSE"),
					ce_string ("HOST"),
					ce_string ("HOUR"),
					ce_string ("HOVE"),
					ce_string ("HOWE"),
					ce_string ("HOWL"),
					ce_string ("HOYT"),
					ce_string ("HUCK"),
					ce_string ("HUED"),
					ce_string ("HUFF"),
					ce_string ("HUGE"),
					ce_string ("HUGH"),
					ce_string ("HUGO"),
					ce_string ("HULK"),
					ce_string ("HULL"),
					ce_string ("HUNK"),
					ce_string ("HUNT"),
					ce_string ("HURD"),
					ce_string ("HURL"),
					ce_string ("HURT"),
					ce_string ("HUSH"),
					ce_string ("HYDE"),
					ce_string ("HYMN"),
					ce_string ("IBIS"),
					ce_string ("ICON"),
					ce_string ("IDEA"),
					ce_string ("IDLE"),
					ce_string ("IFFY"),
					ce_string ("INCA"),
					ce_string ("INCH"),
					ce_string ("INTO"),
					ce_string ("IONS"),
					ce_string ("IOTA"),
					ce_string ("IOWA"),
					ce_string ("IRIS"),
					ce_string ("IRMA"),
					ce_string ("IRON"),
					ce_string ("ISLE"),
					ce_string ("ITCH"),
					ce_string ("ITEM"),
					ce_string ("IVAN"),
					ce_string ("JACK"),
					ce_string ("JADE"),
					ce_string ("JAIL"),
					ce_string ("JAKE"),
					ce_string ("JANE"),
					ce_string ("JAVA"),
					ce_string ("JEAN"),
					ce_string ("JEFF"),
					ce_string ("JERK"),
					ce_string ("JESS"),
					ce_string ("JEST"),
					ce_string ("JIBE"),
					ce_string ("JILL"),
					ce_string ("JILT"),
					ce_string ("JIVE"),
					ce_string ("JOAN"),
					ce_string ("JOBS"),
					ce_string ("JOCK"),
					ce_string ("JOEL"),
					ce_string ("JOEY"),
					ce_string ("JOHN"),
					ce_string ("JOIN"),
					ce_string ("JOKE"),
					ce_string ("JOLT"),
					ce_string ("JOVE"),
					ce_string ("JUDD"),
					ce_string ("JUDE"),
					ce_string ("JUDO"),
					ce_string ("JUDY"),
					ce_string ("JUJU"),
					ce_string ("JUKE"),
					ce_string ("JULY"),
					ce_string ("JUNE"),
					ce_string ("JUNK"),
					ce_string ("JUNO"),
					ce_string ("JURY"),
					ce_string ("JUST"),
					ce_string ("JUTE"),
					ce_string ("KAHN"),
					ce_string ("KALE"),
					ce_string ("KANE"),
					ce_string ("KANT"),
					ce_string ("KARL"),
					ce_string ("KATE"),
					ce_string ("KEEL"),
					ce_string ("KEEN"),
					ce_string ("KENO"),
					ce_string ("KENT"),
					ce_string ("KERN"),
					ce_string ("KERR"),
					ce_string ("KEYS"),
					ce_string ("KICK"),
					ce_string ("KILL"),
					ce_string ("KIND"),
					ce_string ("KING"),
					ce_string ("KIRK"),
					ce_string ("KISS"),
					ce_string ("KITE"),
					ce_string ("KLAN"),
					ce_string ("KNEE"),
					ce_string ("KNEW"),
					ce_string ("KNIT"),
					ce_string ("KNOB"),
					ce_string ("KNOT"),
					ce_string ("KNOW"),
					ce_string ("KOCH"),
					ce_string ("KONG"),
					ce_string ("KUDO"),
					ce_string ("KURD"),
					ce_string ("KURT"),
					ce_string ("KYLE"),
					ce_string ("LACE"),
					ce_string ("LACK"),
					ce_string ("LACY"),
					ce_string ("LADY"),
					ce_string ("LAID"),
					ce_string ("LAIN"),
					ce_string ("LAIR"),
					ce_string ("LAKE"),
					ce_string ("LAMB"),
					ce_string ("LAME"),
					ce_string ("LAND"),
					ce_string ("LANE"),
					ce_string ("LANG"),
					ce_string ("LARD"),
					ce_string ("LARK"),
					ce_string ("LASS"),
					ce_string ("LAST"),
					ce_string ("LATE"),
					ce_string ("LAUD"),
					ce_string ("LAVA"),
					ce_string ("LAWN"),
					ce_string ("LAWS"),
					ce_string ("LAYS"),
					ce_string ("LEAD"),
					ce_string ("LEAF"),
					ce_string ("LEAK"),
					ce_string ("LEAN"),
					ce_string ("LEAR"),
					ce_string ("LEEK"),
					ce_string ("LEER"),
					ce_string ("LEFT"),
					ce_string ("LEND"),
					ce_string ("LENS"),
					ce_string ("LENT"),
					ce_string ("LEON"),
					ce_string ("LESK"),
					ce_string ("LESS"),
					ce_string ("LEST"),
					ce_string ("LETS"),
					ce_string ("LIAR"),
					ce_string ("LICE"),
					ce_string ("LICK"),
					ce_string ("LIED"),
					ce_string ("LIEN"),
					ce_string ("LIES"),
					ce_string ("LIEU"),
					ce_string ("LIFE"),
					ce_string ("LIFT"),
					ce_string ("LIKE"),
					ce_string ("LILA"),
					ce_string ("LILT"),
					ce_string ("LILY"),
					ce_string ("LIMA"),
					ce_string ("LIMB"),
					ce_string ("LIME"),
					ce_string ("LIND"),
					ce_string ("LINE"),
					ce_string ("LINK"),
					ce_string ("LINT"),
					ce_string ("LION"),
					ce_string ("LISA"),
					ce_string ("LIST"),
					ce_string ("LIVE"),
					ce_string ("LOAD"),
					ce_string ("LOAF"),
					ce_string ("LOAM"),
					ce_string ("LOAN"),
					ce_string ("LOCK"),
					ce_string ("LOFT"),
					ce_string ("LOGE"),
					ce_string ("LOIS"),
					ce_string ("LOLA"),
					ce_string ("LONE"),
					ce_string ("LONG"),
					ce_string ("LOOK"),
					ce_string ("LOON"),
					ce_string ("LOOT"),
					ce_string ("LORD"),
					ce_string ("LORE"),
					ce_string ("LOSE"),
					ce_string ("LOSS"),
					ce_string ("LOST"),
					ce_string ("LOUD"),
					ce_string ("LOVE"),
					ce_string ("LOWE"),
					ce_string ("LUCK"),
					ce_string ("LUCY"),
					ce_string ("LUGE"),
					ce_string ("LUKE"),
					ce_string ("LULU"),
					ce_string ("LUND"),
					ce_string ("LUNG"),
					ce_string ("LURA"),
					ce_string ("LURE"),
					ce_string ("LURK"),
					ce_string ("LUSH"),
					ce_string ("LUST"),
					ce_string ("LYLE"),
					ce_string ("LYNN"),
					ce_string ("LYON"),
					ce_string ("LYRA"),
					ce_string ("MACE"),
					ce_string ("MADE"),
					ce_string ("MAGI"),
					ce_string ("MAID"),
					ce_string ("MAIL"),
					ce_string ("MAIN"),
					ce_string ("MAKE"),
					ce_string ("MALE"),
					ce_string ("MALI"),
					ce_string ("MALL"),
					ce_string ("MALT"),
					ce_string ("MANA"),
					ce_string ("MANN"),
					ce_string ("MANY"),
					ce_string ("MARC"),
					ce_string ("MARE"),
					ce_string ("MARK"),
					ce_string ("MARS"),
					ce_string ("MART"),
					ce_string ("MARY"),
					ce_string ("MASH"),
					ce_string ("MASK"),
					ce_string ("MASS"),
					ce_string ("MAST"),
					ce_string ("MATE"),
					ce_string ("MATH"),
					ce_string ("MAUL"),
					ce_string ("MAYO"),
					ce_string ("MEAD"),
					ce_string ("MEAL"),
					ce_string ("MEAN"),
					ce_string ("MEAT"),
					ce_string ("MEEK"),
					ce_string ("MEET"),
					ce_string ("MELD"),
					ce_string ("MELT"),
					ce_string ("MEMO"),
					ce_string ("MEND"),
					ce_string ("MENU"),
					ce_string ("MERT"),
					ce_string ("MESH"),
					ce_string ("MESS"),
					ce_string ("MICE"),
					ce_string ("MIKE"),
					ce_string ("MILD"),
					ce_string ("MILE"),
					ce_string ("MILK"),
					ce_string ("MILL"),
					ce_string ("MILT"),
					ce_string ("MIMI"),
					ce_string ("MIND"),
					ce_string ("MINE"),
					ce_string ("MINI"),
					ce_string ("MINK"),
					ce_string ("MINT"),
					ce_string ("MIRE"),
					ce_string ("MISS"),
					ce_string ("MIST"),
					ce_string ("MITE"),
					ce_string ("MITT"),
					ce_string ("MOAN"),
					ce_string ("MOAT"),
					ce_string ("MOCK"),
					ce_string ("MODE"),
					ce_string ("MOLD"),
					ce_string ("MOLE"),
					ce_string ("MOLL"),
					ce_string ("MOLT"),
					ce_string ("MONA"),
					ce_string ("MONK"),
					ce_string ("MONT"),
					ce_string ("MOOD"),
					ce_string ("MOON"),
					ce_string ("MOOR"),
					ce_string ("MOOT"),
					ce_string ("MORE"),
					ce_string ("MORN"),
					ce_string ("MORT"),
					ce_string ("MOSS"),
					ce_string ("MOST"),
					ce_string ("MOTH"),
					ce_string ("MOVE"),
					ce_string ("MUCH"),
					ce_string ("MUCK"),
					ce_string ("MUDD"),
					ce_string ("MUFF"),
					ce_string ("MULE"),
					ce_string ("MULL"),
					ce_string ("MURK"),
					ce_string ("MUSH"),
					ce_string ("MUST"),
					ce_string ("MUTE"),
					ce_string ("MUTT"),
					ce_string ("MYRA"),
					ce_string ("MYTH"),
					ce_string ("NAGY"),
					ce_string ("NAIL"),
					ce_string ("NAIR"),
					ce_string ("NAME"),
					ce_string ("NARY"),
					ce_string ("NASH"),
					ce_string ("NAVE"),
					ce_string ("NAVY"),
					ce_string ("NEAL"),
					ce_string ("NEAR"),
					ce_string ("NEAT"),
					ce_string ("NECK"),
					ce_string ("NEED"),
					ce_string ("NEIL"),
					ce_string ("NELL"),
					ce_string ("NEON"),
					ce_string ("NERO"),
					ce_string ("NESS"),
					ce_string ("NEST"),
					ce_string ("NEWS"),
					ce_string ("NEWT"),
					ce_string ("NIBS"),
					ce_string ("NICE"),
					ce_string ("NICK"),
					ce_string ("NILE"),
					ce_string ("NINA"),
					ce_string ("NINE"),
					ce_string ("NOAH"),
					ce_string ("NODE"),
					ce_string ("NOEL"),
					ce_string ("NOLL"),
					ce_string ("NONE"),
					ce_string ("NOOK"),
					ce_string ("NOON"),
					ce_string ("NORM"),
					ce_string ("NOSE"),
					ce_string ("NOTE"),
					ce_string ("NOUN"),
					ce_string ("NOVA"),
					ce_string ("NUDE"),
					ce_string ("NULL"),
					ce_string ("NUMB"),
					ce_string ("OATH"),
					ce_string ("OBEY"),
					ce_string ("OBOE"),
					ce_string ("ODIN"),
					ce_string ("OHIO"),
					ce_string ("OILY"),
					ce_string ("OINT"),
					ce_string ("OKAY"),
					ce_string ("OLAF"),
					ce_string ("OLDY"),
					ce_string ("OLGA"),
					ce_string ("OLIN"),
					ce_string ("OMAN"),
					ce_string ("OMEN"),
					ce_string ("OMIT"),
					ce_string ("ONCE"),
					ce_string ("ONES"),
					ce_string ("ONLY"),
					ce_string ("ONTO"),
					ce_string ("ONUS"),
					ce_string ("ORAL"),
					ce_string ("ORGY"),
					ce_string ("OSLO"),
					ce_string ("OTIS"),
					ce_string ("OTTO"),
					ce_string ("OUCH"),
					ce_string ("OUST"),
					ce_string ("OUTS"),
					ce_string ("OVAL"),
					ce_string ("OVEN"),
					ce_string ("OVER"),
					ce_string ("OWLY"),
					ce_string ("OWNS"),
					ce_string ("QUAD"),
					ce_string ("QUIT"),
					ce_string ("QUOD"),
					ce_string ("RACE"),
					ce_string ("RACK"),
					ce_string ("RACY"),
					ce_string ("RAFT"),
					ce_string ("RAGE"),
					ce_string ("RAID"),
					ce_string ("RAIL"),
					ce_string ("RAIN"),
					ce_string ("RAKE"),
					ce_string ("RANK"),
					ce_string ("RANT"),
					ce_string ("RARE"),
					ce_string ("RASH"),
					ce_string ("RATE"),
					ce_string ("RAVE"),
					ce_string ("RAYS"),
					ce_string ("READ"),
					ce_string ("REAL"),
					ce_string ("REAM"),
					ce_string ("REAR"),
					ce_string ("RECK"),
					ce_string ("REED"),
					ce_string ("REEF"),
					ce_string ("REEK"),
					ce_string ("REEL"),
					ce_string ("REID"),
					ce_string ("REIN"),
					ce_string ("RENA"),
					ce_string ("REND"),
					ce_string ("RENT"),
					ce_string ("REST"),
					ce_string ("RICE"),
					ce_string ("RICH"),
					ce_string ("RICK"),
					ce_string ("RIDE"),
					ce_string ("RIFT"),
					ce_string ("RILL"),
					ce_string ("RIME"),
					ce_string ("RING"),
					ce_string ("RINK"),
					ce_string ("RISE"),
					ce_string ("RISK"),
					ce_string ("RITE"),
					ce_string ("ROAD"),
					ce_string ("ROAM"),
					ce_string ("ROAR"),
					ce_string ("ROBE"),
					ce_string ("ROCK"),
					ce_string ("RODE"),
					ce_string ("ROIL"),
					ce_string ("ROLL"),
					ce_string ("ROME"),
					ce_string ("ROOD"),
					ce_string ("ROOF"),
					ce_string ("ROOK"),
					ce_string ("ROOM"),
					ce_string ("ROOT"),
					ce_string ("ROSA"),
					ce_string ("ROSE"),
					ce_string ("ROSS"),
					ce_string ("ROSY"),
					ce_string ("ROTH"),
					ce_string ("ROUT"),
					ce_string ("ROVE"),
					ce_string ("ROWE"),
					ce_string ("ROWS"),
					ce_string ("RUBE"),
					ce_string ("RUBY"),
					ce_string ("RUDE"),
					ce_string ("RUDY"),
					ce_string ("RUIN"),
					ce_string ("RULE"),
					ce_string ("RUNG"),
					ce_string ("RUNS"),
					ce_string ("RUNT"),
					ce_string ("RUSE"),
					ce_string ("RUSH"),
					ce_string ("RUSK"),
					ce_string ("RUSS"),
					ce_string ("RUST"),
					ce_string ("RUTH"),
					ce_string ("SACK"),
					ce_string ("SAFE"),
					ce_string ("SAGE"),
					ce_string ("SAID"),
					ce_string ("SAIL"),
					ce_string ("SALE"),
					ce_string ("SALK"),
					ce_string ("SALT"),
					ce_string ("SAME"),
					ce_string ("SAND"),
					ce_string ("SANE"),
					ce_string ("SANG"),
					ce_string ("SANK"),
					ce_string ("SARA"),
					ce_string ("SAUL"),
					ce_string ("SAVE"),
					ce_string ("SAYS"),
					ce_string ("SCAN"),
					ce_string ("SCAR"),
					ce_string ("SCAT"),
					ce_string ("SCOT"),
					ce_string ("SEAL"),
					ce_string ("SEAM"),
					ce_string ("SEAR"),
					ce_string ("SEAT"),
					ce_string ("SEED"),
					ce_string ("SEEK"),
					ce_string ("SEEM"),
					ce_string ("SEEN"),
					ce_string ("SEES"),
					ce_string ("SELF"),
					ce_string ("SELL"),
					ce_string ("SEND"),
					ce_string ("SENT"),
					ce_string ("SETS"),
					ce_string ("SEWN"),
					ce_string ("SHAG"),
					ce_string ("SHAM"),
					ce_string ("SHAW"),
					ce_string ("SHAY"),
					ce_string ("SHED"),
					ce_string ("SHIM"),
					ce_string ("SHIN"),
					ce_string ("SHOD"),
					ce_string ("SHOE"),
					ce_string ("SHOT"),
					ce_string ("SHOW"),
					ce_string ("SHUN"),
					ce_string ("SHUT"),
					ce_string ("SICK"),
					ce_string ("SIDE"),
					ce_string ("SIFT"),
					ce_string ("SIGH"),
					ce_string ("SIGN"),
					ce_string ("SILK"),
					ce_string ("SILL"),
					ce_string ("SILO"),
					ce_string ("SILT"),
					ce_string ("SINE"),
					ce_string ("SING"),
					ce_string ("SINK"),
					ce_string ("SIRE"),
					ce_string ("SITE"),
					ce_string ("SITS"),
					ce_string ("SITU"),
					ce_string ("SKAT"),
					ce_string ("SKEW"),
					ce_string ("SKID"),
					ce_string ("SKIM"),
					ce_string ("SKIN"),
					ce_string ("SKIT"),
					ce_string ("SLAB"),
					ce_string ("SLAM"),
					ce_string ("SLAT"),
					ce_string ("SLAY"),
					ce_string ("SLED"),
					ce_string ("SLEW"),
					ce_string ("SLID"),
					ce_string ("SLIM"),
					ce_string ("SLIT"),
					ce_string ("SLOB"),
					ce_string ("SLOG"),
					ce_string ("SLOT"),
					ce_string ("SLOW"),
					ce_string ("SLUG"),
					ce_string ("SLUM"),
					ce_string ("SLUR"),
					ce_string ("SMOG"),
					ce_string ("SMUG"),
					ce_string ("SNAG"),
					ce_string ("SNOB"),
					ce_string ("SNOW"),
					ce_string ("SNUB"),
					ce_string ("SNUG"),
					ce_string ("SOAK"),
					ce_string ("SOAR"),
					ce_string ("SOCK"),
					ce_string ("SODA"),
					ce_string ("SOFA"),
					ce_string ("SOFT"),
					ce_string ("SOIL"),
					ce_string ("SOLD"),
					ce_string ("SOME"),
					ce_string ("SONG"),
					ce_string ("SOON"),
					ce_string ("SOOT"),
					ce_string ("SORE"),
					ce_string ("SORT"),
					ce_string ("SOUL"),
					ce_string ("SOUR"),
					ce_string ("SOWN"),
					ce_string ("STAB"),
					ce_string ("STAG"),
					ce_string ("STAN"),
					ce_string ("STAR"),
					ce_string ("STAY"),
					ce_string ("STEM"),
					ce_string ("STEW"),
					ce_string ("STIR"),
					ce_string ("STOW"),
					ce_string ("STUB"),
					ce_string ("STUN"),
					ce_string ("SUCH"),
					ce_string ("SUDS"),
					ce_string ("SUIT"),
					ce_string ("SULK"),
					ce_string ("SUMS"),
					ce_string ("SUNG"),
					ce_string ("SUNK"),
					ce_string ("SURE"),
					ce_string ("SURF"),
					ce_string ("SWAB"),
					ce_string ("SWAG"),
					ce_string ("SWAM"),
					ce_string ("SWAN"),
					ce_string ("SWAT"),
					ce_string ("SWAY"),
					ce_string ("SWIM"),
					ce_string ("SWUM"),
					ce_string ("TACK"),
					ce_string ("TACT"),
					ce_string ("TAIL"),
					ce_string ("TAKE"),
					ce_string ("TALE"),
					ce_string ("TALK"),
					ce_string ("TALL"),
					ce_string ("TANK"),
					ce_string ("TASK"),
					ce_string ("TATE"),
					ce_string ("TAUT"),
					ce_string ("TEAL"),
					ce_string ("TEAM"),
					ce_string ("TEAR"),
					ce_string ("TECH"),
					ce_string ("TEEM"),
					ce_string ("TEEN"),
					ce_string ("TEET"),
					ce_string ("TELL"),
					ce_string ("TEND"),
					ce_string ("TENT"),
					ce_string ("TERM"),
					ce_string ("TERN"),
					ce_string ("TESS"),
					ce_string ("TEST"),
					ce_string ("THAN"),
					ce_string ("THAT"),
					ce_string ("THEE"),
					ce_string ("THEM"),
					ce_string ("THEN"),
					ce_string ("THEY"),
					ce_string ("THIN"),
					ce_string ("THIS"),
					ce_string ("THUD"),
					ce_string ("THUG"),
					ce_string ("TICK"),
					ce_string ("TIDE"),
					ce_string ("TIDY"),
					ce_string ("TIED"),
					ce_string ("TIER"),
					ce_string ("TILE"),
					ce_string ("TILL"),
					ce_string ("TILT"),
					ce_string ("TIME"),
					ce_string ("TINA"),
					ce_string ("TINE"),
					ce_string ("TINT"),
					ce_string ("TINY"),
					ce_string ("TIRE"),
					ce_string ("TOAD"),
					ce_string ("TOGO"),
					ce_string ("TOIL"),
					ce_string ("TOLD"),
					ce_string ("TOLL"),
					ce_string ("TONE"),
					ce_string ("TONG"),
					ce_string ("TONY"),
					ce_string ("TOOK"),
					ce_string ("TOOL"),
					ce_string ("TOOT"),
					ce_string ("TORE"),
					ce_string ("TORN"),
					ce_string ("TOTE"),
					ce_string ("TOUR"),
					ce_string ("TOUT"),
					ce_string ("TOWN"),
					ce_string ("TRAG"),
					ce_string ("TRAM"),
					ce_string ("TRAY"),
					ce_string ("TREE"),
					ce_string ("TREK"),
					ce_string ("TRIG"),
					ce_string ("TRIM"),
					ce_string ("TRIO"),
					ce_string ("TROD"),
					ce_string ("TROT"),
					ce_string ("TROY"),
					ce_string ("TRUE"),
					ce_string ("TUBA"),
					ce_string ("TUBE"),
					ce_string ("TUCK"),
					ce_string ("TUFT"),
					ce_string ("TUNA"),
					ce_string ("TUNE"),
					ce_string ("TUNG"),
					ce_string ("TURF"),
					ce_string ("TURN"),
					ce_string ("TUSK"),
					ce_string ("TWIG"),
					ce_string ("TWIN"),
					ce_string ("TWIT"),
					ce_string ("ULAN"),
					ce_string ("UNIT"),
					ce_string ("URGE"),
					ce_string ("USED"),
					ce_string ("USER"),
					ce_string ("USES"),
					ce_string ("UTAH"),
					ce_string ("VAIL"),
					ce_string ("VAIN"),
					ce_string ("VALE"),
					ce_string ("VARY"),
					ce_string ("VASE"),
					ce_string ("VAST"),
					ce_string ("VEAL"),
					ce_string ("VEDA"),
					ce_string ("VEIL"),
					ce_string ("VEIN"),
					ce_string ("VEND"),
					ce_string ("VENT"),
					ce_string ("VERB"),
					ce_string ("VERY"),
					ce_string ("VETO"),
					ce_string ("VICE"),
					ce_string ("VIEW"),
					ce_string ("VINE"),
					ce_string ("VISE"),
					ce_string ("VOID"),
					ce_string ("VOLT"),
					ce_string ("VOTE"),
					ce_string ("WACK"),
					ce_string ("WADE"),
					ce_string ("WAGE"),
					ce_string ("WAIL"),
					ce_string ("WAIT"),
					ce_string ("WAKE"),
					ce_string ("WALE"),
					ce_string ("WALK"),
					ce_string ("WALL"),
					ce_string ("WALT"),
					ce_string ("WAND"),
					ce_string ("WANE"),
					ce_string ("WANG"),
					ce_string ("WANT"),
					ce_string ("WARD"),
					ce_string ("WARM"),
					ce_string ("WARN"),
					ce_string ("WART"),
					ce_string ("WASH"),
					ce_string ("WAST"),
					ce_string ("WATS"),
					ce_string ("WATT"),
					ce_string ("WAVE"),
					ce_string ("WAVY"),
					ce_string ("WAYS"),
					ce_string ("WEAK"),
					ce_string ("WEAL"),
					ce_string ("WEAN"),
					ce_string ("WEAR"),
					ce_string ("WEED"),
					ce_string ("WEEK"),
					ce_string ("WEIR"),
					ce_string ("WELD"),
					ce_string ("WELL"),
					ce_string ("WELT"),
					ce_string ("WENT"),
					ce_string ("WERE"),
					ce_string ("WERT"),
					ce_string ("WEST"),
					ce_string ("WHAM"),
					ce_string ("WHAT"),
					ce_string ("WHEE"),
					ce_string ("WHEN"),
					ce_string ("WHET"),
					ce_string ("WHOA"),
					ce_string ("WHOM"),
					ce_string ("WICK"),
					ce_string ("WIFE"),
					ce_string ("WILD"),
					ce_string ("WILL"),
					ce_string ("WIND"),
					ce_string ("WINE"),
					ce_string ("WING"),
					ce_string ("WINK"),
					ce_string ("WINO"),
					ce_string ("WIRE"),
					ce_string ("WISE"),
					ce_string ("WISH"),
					ce_string ("WITH"),
					ce_string ("WOLF"),
					ce_string ("WONT"),
					ce_string ("WOOD"),
					ce_string ("WOOL"),
					ce_string ("WORD"),
					ce_string ("WORE"),
					ce_string ("WORK"),
					ce_string ("WORM"),
					ce_string ("WORN"),
					ce_string ("WOVE"),
					ce_string ("WRIT"),
					ce_string ("WYNN"),
					ce_string ("YALE"),
					ce_string ("YANG"),
					ce_string ("YANK"),
					ce_string ("YARD"),
					ce_string ("YARN"),
					ce_string ("YAWL"),
					ce_string ("YAWN"),
					ce_string ("YEAH"),
					ce_string ("YEAR"),
					ce_string ("YELL"),
					ce_string ("YOGA"),
					ce_string ("YOKE")
				>>)
		end

	english: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<30>>)
		end

feature {ANY} -- public routines

	getftp (a_passed_expected_bytes: INTEGER_64; a_qtyread: CE_POINTER [INTEGER_64]; a_restval: INTEGER_64; a_con: CE_POINTER [PD_CCON]): NATURAL_32
		require
			not a_qtyread.is_void
			not a_con.is_void
		local
			l_csock: INTEGER_32
			l_dtsock: INTEGER_32
			l_local_sock: CE_ARRAY [INTEGER_32]
			l_res___0: INTEGER_32
			l_err: NATURAL_32
			l_fp: CE_POINTER [SD_IO_FILE]
			l_user: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_passwd: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_respline: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_tms: CE_POINTER [INTEGER_8]
			l_tmrate: CE_POINTER [INTEGER_8]
			l_cmd: INTEGER_32
			l_pasv_mode_open: BOOLEAN
			l_expected_bytes: CE_ARRAY [INTEGER_64]
			l_rest_failed: BOOLEAN
			l_flags: INTEGER_32
			l_rd_size: CE_ARRAY [INTEGER_64]
			l_type_char: INTEGER_8
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_host: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_port: INTEGER_32
			l_tmp___2: INTEGER_32
			l_logname: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			l_tmp___6: CE_POINTER [INTEGER_32]
			l_tmp___7: BOOLEAN
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_tmp___18: CE_POINTER [INTEGER_8]
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___20: CE_POINTER [INTEGER_8]
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_tmp___22: CE_POINTER [INTEGER_8]
			l_tmp___23: CE_POINTER [INTEGER_8]
			l_tmp___24: CE_POINTER [INTEGER_8]
			l_tmp___25: CE_POINTER [INTEGER_8]
			l_targ: CE_POINTER [INTEGER_8]
			l_cwd_count: INTEGER_32
			l_cwd_end: INTEGER_32
			l_cwd_start: INTEGER_32
			l_target: CE_POINTER [INTEGER_8]
			l_tmp___26: INTEGER_32
			l_idlen: INTEGER_32
			l_tmp___27: NATURAL_32
			l_ntarget: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___28: NATURAL_32
			l_tmp___30: CE_POINTER [INTEGER_8]
			l_tmp___31: INTEGER_32
			l_tmp___32: INTEGER_32
			l_tmp___33: BOOLEAN
			l_tmp___34: INTEGER_32
			l_tmp___35: INTEGER_32
			l_tmp___36: CE_POINTER [INTEGER_8]
			l_tmp___37: CE_POINTER [INTEGER_8]
			l_tmp___38: CE_POINTER [INTEGER_8]
			l_tmp___39: CE_POINTER [INTEGER_8]
			l_tmp___40: CE_POINTER [INTEGER_8]
			l_tmp___41: CE_POINTER [INTEGER_8]
			l_tmp___42: CE_POINTER [INTEGER_8]
			l_tmp___43: CE_POINTER [INTEGER_8]
			l_tmp___44: CE_POINTER [INTEGER_8]
			l_tmp___45: CE_POINTER [INTEGER_8]
			l_tmp___46: CE_POINTER [INTEGER_8]
			l_tmp___47: CE_POINTER [INTEGER_8]
			l_tmp___48: CE_POINTER [INTEGER_8]
			l_passive_addr: CE_ARRAY [PD_IP_ADDRESS]
			l_passive_port: CE_ARRAY [INTEGER_32]
			l_tmp___49: CE_POINTER [INTEGER_8]
			l_tmp___50: CE_POINTER [INTEGER_8]
			l_tmp___51: CE_POINTER [INTEGER_8]
			l_tmp___52: CE_POINTER [INTEGER_8]
			l_tmp___53: CE_POINTER [INTEGER_8]
			l_tmp___54: INTEGER_32
			l_save_errno: INTEGER_32
			l_tmp___55: CE_POINTER [INTEGER_32]
			l_tmp___56: CE_POINTER [INTEGER_8]
			l_tmp___57: CE_POINTER [INTEGER_8]
			l_tmp___58: CE_POINTER [INTEGER_8]
			l_tmp___60: INTEGER_32
			l_tmp___61: BOOLEAN
			l_tmp___62: CE_POINTER [INTEGER_8]
			l_tmp___63: CE_POINTER [INTEGER_8]
			l_tmp___64: CE_POINTER [INTEGER_8]
			l_tmp___65: CE_POINTER [INTEGER_32]
			l_tmp___66: CE_POINTER [INTEGER_8]
			l_tmp___67: CE_POINTER [INTEGER_32]
			l_tmp___68: CE_POINTER [INTEGER_8]
			l_tmp___69: CE_POINTER [INTEGER_8]
			l_tmp___70: CE_POINTER [INTEGER_8]
			l_tmp___71: CE_POINTER [INTEGER_8]
			l_tmp___72: CE_POINTER [INTEGER_8]
			l_tmp___73: CE_POINTER [INTEGER_8]
			l_tmp___74: CE_POINTER [INTEGER_8]
			l_tmp___75: CE_POINTER [INTEGER_8]
			l_tmp___76: CE_POINTER [INTEGER_8]
			l_exists: BOOLEAN
			l_res___1: NATURAL_32
			l_f: CE_ARRAY [CE_POINTER [PD_FILEINFO]]
			l_tmp___77: INTEGER_32
			l_tmp___78: CE_POINTER [INTEGER_8]
			l_tmp___79: CE_POINTER [INTEGER_8]
			l_tmp___80: CE_POINTER [INTEGER_8]
			l_tmp___81: CE_POINTER [INTEGER_8]
			l_tmp___82: CE_POINTER [INTEGER_8]
			l_tmp___83: CE_POINTER [INTEGER_8]
			l_tmp___84: CE_POINTER [INTEGER_8]
			l_tmp___85: CE_POINTER [INTEGER_8]
			l_tmp___86: CE_POINTER [INTEGER_8]
			l_tmp___87: CE_POINTER [INTEGER_8]
			l_tmp___88: CE_POINTER [INTEGER_8]
			l_tmp___89: CE_POINTER [INTEGER_8]
			l_tmp___90: CE_POINTER [INTEGER_8]
			l_tmp___91: CE_POINTER [INTEGER_8]
			l_tmp___92: CE_POINTER [INTEGER_8]
			l_tmp___93: INTEGER_32
			l_tmp___94: CE_POINTER [INTEGER_32]
			l_tmp___95: CE_POINTER [INTEGER_8]
			l_tmp___96: CE_POINTER [INTEGER_8]
			l_tmp___97: CE_POINTER [INTEGER_32]
			l_tmp___98: CE_POINTER [INTEGER_32]
			l_tmp___99: CE_POINTER [INTEGER_8]
			l_tmp___100: INTEGER_64
			l_tmp___101: INTEGER_32
			l_tmp___102: CE_POINTER [INTEGER_32]
			l_tmp___103: CE_POINTER [INTEGER_8]
			l_tmp___104: CE_POINTER [INTEGER_8]
			l_tmp___105: CE_POINTER [INTEGER_8]
			l_tmp___106: CE_POINTER [INTEGER_8]
			l_tmp___107: CE_POINTER [INTEGER_8]
			l_tmp___108: CE_POINTER [INTEGER_8]
			l_tmp___109: CE_POINTER [INTEGER_32]
			l_tmp___110: CE_POINTER [INTEGER_8]
			l_line: CE_POINTER [INTEGER_8]
			l_p___1: CE_POINTER [INTEGER_8]
			l_tmp___111: CE_POINTER [INTEGER_8]
			l_tmp___112: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_INTEGER_32_ARRAY} l_local_sock.make (<<1>>)
			create {CE_CLASS_POINTER [SD_IO_FILE]} l_fp.make
			create {CE_POINTER_ARRAY [INTEGER_8]} l_user.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_passwd.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_respline.make (<<1>>)
			create {CE_INTEGER_64_ARRAY} l_expected_bytes.make (<<1>>)
			create {CE_INTEGER_64_ARRAY} l_rd_size.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_IP_ADDRESS]} l_passive_addr.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_passive_port.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_FILEINFO]} l_f.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_err := {PC_UERR_T}.RETROK
					l_cmd := a_con.item.cmd
					l_pasv_mode_open := (0).to_boolean
					l_expected_bytes.item := (0).to_integer_64
					update_class_fields -- Current might have been changed; synchronize
					l_rest_failed := (0).to_boolean
					if a_con.is_void then
						assert_fail (ce_string ("con != ((void *)0)"), ce_string ("ftp.c"), {NATURAL_32} 260, ce_string ("getftp"))
						update_class_fields -- Current might have been changed; synchronize
					end
					if (a_con.item.target).is_void then
						assert_fail (ce_string ("con->target != ((void *)0)"), ce_string ("ftp.c"), {NATURAL_32} 261, ce_string ("getftp"))
						update_class_fields -- Current might have been changed; synchronize
					end
					if ((l_cmd).bit_and (8)).to_boolean then
						if ((l_cmd).bit_and (4)).to_boolean then
							assert_fail (ce_string ("!((cmd & DO_LIST) && (cmd & DO_RETR))"), ce_string ("ftp.c"), {NATURAL_32} 266, ce_string ("getftp"))
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if ((l_cmd).bit_and (15)) = 0 then
						assert_fail (ce_string ("(cmd & (DO_LIST | DO_CWD | DO_RETR | DO_LOGIN)) != 0"), ce_string ("ftp.c"), {NATURAL_32} 268, ce_string ("getftp"))
						update_class_fields -- Current might have been changed; synchronize
					end
					a_qtyread.item := a_restval
					update_class_fields -- Current might have been changed; synchronize
					l_user.item := user
					update_class_fields -- Current might have been changed; synchronize
					l_passwd.item := passwd
					update_class_fields -- Current might have been changed; synchronize
					search_netrc (host, l_user, l_passwd, 1)
					update_class_fields -- Current might have been changed; synchronize
					if (not (l_user.item).is_void) then
						l_user.item := l_user.item
						update_class_fields -- Current might have been changed; synchronize
					else
						if (not ((create {P_OPTIONS_STATIC}).opt.item.item.ftp_user).is_void) then
							l_tmp := (create {P_OPTIONS_STATIC}).opt.item.item.ftp_user
						else
							l_tmp := (create {P_OPTIONS_STATIC}).opt.item.item.user
						end
						l_user.item := l_tmp
						update_class_fields -- Current might have been changed; synchronize
					end
					if (l_user.item).is_void then
						l_user.item := ce_string ("anonymous")
						update_class_fields -- Current might have been changed; synchronize
					end
					if (not (l_passwd.item).is_void) then
						l_passwd.item := l_passwd.item
						update_class_fields -- Current might have been changed; synchronize
					else
						if (not ((create {P_OPTIONS_STATIC}).opt.item.item.ftp_passwd).is_void) then
							l_tmp___0 := (create {P_OPTIONS_STATIC}).opt.item.item.ftp_passwd
						else
							l_tmp___0 := (create {P_OPTIONS_STATIC}).opt.item.item.passwd
						end
						l_passwd.item := l_tmp___0
						update_class_fields -- Current might have been changed; synchronize
					end
					if (l_passwd.item).is_void then
						l_passwd.item := ce_string ("-wget@")
						update_class_fields -- Current might have been changed; synchronize
					end
					l_dtsock := -1
					l_local_sock.item := -1
					update_class_fields -- Current might have been changed; synchronize
					a_con.item.dltime := (0).to_double
					update_class_fields -- Current might have been changed; synchronize
					if ((l_cmd).bit_and (1)).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_csock := a_con.item.csock
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 3 then -- else:
						if (not (a_con.item.proxy).is_void) then
							l_tmp___1 := (a_con.item.proxy).item.host
						else
							l_tmp___1 := host
						end
						l_host := l_tmp___1
						if (not (a_con.item.proxy).is_void) then
							l_tmp___2 := (a_con.item.proxy).item.port
						else
							l_tmp___2 := port
						end
						l_port := l_tmp___2
						l_logname := l_user.item
						if (not (a_con.item.proxy).is_void) then
							l_logname := (create {P_UTILS_STATIC}).concat_strings ([l_user.item, ce_string ("@"), host, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_csock := connect_to_host (l_host, l_port)
						update_class_fields -- Current might have been changed; synchronize
						if l_csock = -100 then
							Result := ({PC_UERR_T}.HOSTERR)
							l_return := True
						elseif l_csock < 0 then
							l_tmp___6 := errno_location
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___7 := retryable_socket_connect_error (l_tmp___6.item)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___7 then
								l_tmp___5 := 3
							else
								l_tmp___5 := 5
							end
							Result := l_tmp___5.to_natural_32
							l_return := True
						end
						if l_return then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if ((l_cmd).bit_and (16)).to_boolean then
							a_con.item.csock := l_csock
							update_class_fields -- Current might have been changed; synchronize
						else
							a_con.item.csock := -1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tmp___8 := (create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_user.item)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___9 := gettext (ce_string ("Logging in as %%s ... "))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___9, l_tmp___8])
						update_class_fields -- Current might have been changed; synchronize
						if (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_ALWAYS, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_err := ftp_login (l_csock, l_logname, l_passwd.item)
						update_class_fields -- Current might have been changed; synchronize
						if (not (a_con.item.proxy).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_logname))
							update_class_fields -- Current might have been changed; synchronize
						end
						inspect l_err.to_integer_32 -- switch 1 head
						when 18 then l_pos := -1 + 5
						when 20 then l_pos := -1 + 6
						when 52 then l_pos := -1 + 7
						when 12 then l_pos := -1 + 8
						when 11 then l_pos := -1 + 9
						when 10 then l_pos := -1 + 10
						else l_pos := -1 + 11
						end
				when 5 then -- switch 1, case 18;
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___10 := gettext (ce_string ("Error in server response, closing control connection.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___10)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_csock)
						update_class_fields -- Current might have been changed; synchronize
						a_con.item.csock := -1
						update_class_fields -- Current might have been changed; synchronize
						Result := l_err
						l_return := True
				when 6 then -- switch 1, case 20
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___11 := gettext (ce_string ("Error in server greeting.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___11)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields -- Current might have been changed; synchronize
							Result := l_err
							l_return := True
						end
				when 7 then -- switch 1, case 52
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___12 := gettext (ce_string ("Write failed, closing control connection.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___12)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields -- Current might have been changed; synchronize
							Result := l_err
							l_return := True
						end
				when 8 then -- switch 1, case 12
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___13 := gettext (ce_string ("The server refuses login.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___13)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_UERR_T}.FTPLOGREFUSED)
							l_return := True
						end
				when 9 then -- switch 1, case 11
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___14 := gettext (ce_string ("Login incorrect.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___14)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_UERR_T}.FTPLOGINC)
							l_return := True
						end
				when 10 then -- switch 1, case 10
						if not l_return and then (not (create {P_OPTIONS_STATIC}).opt.item.item.server_response) then
							l_tmp___15 := gettext (ce_string ("Logged in!%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___15)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 12 -- switch 1; break
				when 11 then -- switch 1, default:
						abort
						update_class_fields -- Current might have been changed; synchronize
				when 12 then -- switch 1, done: | if done
						if l_return then
							l_pos := -1 + 18 -- skip if block
						end
				when 13 then -- if:
						if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> SYST ... ")])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_err := ftp_syst (l_csock, create {CE_NATURAL_32_POINTER}.make_shared (a_con.c_pointer + (create {PD_CCON}.make).offset_of ("rs")))
						update_class_fields -- Current might have been changed; synchronize
						inspect l_err.to_integer_32 -- switch 2 head
						when 18 then l_pos := -1 + 14
						when 20 then l_pos := -1 + 15
						when 10 then l_pos := -1 + 16
						else l_pos := -1 + 17
						end
				when 14 then -- switch 2, case 18;
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___16 := gettext (ce_string ("Error in server response, closing control connection.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___16)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_csock)
						update_class_fields -- Current might have been changed; synchronize
						a_con.item.csock := -1
						update_class_fields -- Current might have been changed; synchronize
						Result := l_err
						l_return := True
				when 15 then -- switch 2, case 20
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___17 := gettext (ce_string ("Server error, can%'t determine system type.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___17)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 18 -- switch 2; break
				when 16 then -- switch 2, case 10
						l_pos := -1 + 18 -- switch 2; break
				when 17 then -- switch 2, default:
						abort
						update_class_fields -- Current might have been changed; synchronize
				when 18 then -- switch 2, done: | if done
						if l_return then
							l_pos := -1 + 24 -- skip if block
						end
				when 19 then -- if:
						if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
							if l_err /= {NATURAL_32} 20 then
								l_tmp___18 := gettext (ce_string ("done.    "))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___18)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> PWD ... ")])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_err := ftp_pwd (l_csock, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_con.c_pointer + (create {PD_CCON}.make).offset_of ("id")))
						update_class_fields -- Current might have been changed; synchronize
						inspect l_err.to_integer_32 -- switch 3 head
						when 18 then l_pos := -1 + 20
						when 20 then l_pos := -1 + 21
						when 10 then l_pos := -1 + 22
						else l_pos := -1 + 23
						end
				when 20 then -- switch 3, case 18;
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___19 := gettext (ce_string ("Error in server response, closing control connection.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___19)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_csock)
						update_class_fields -- Current might have been changed; synchronize
						a_con.item.csock := -1
						update_class_fields -- Current might have been changed; synchronize
						Result := l_err
						l_return := True
				when 21 then -- switch 3, case 20
						if not l_return then
							if (not (a_con.item.id).is_void) then
								free (create {CE_VOID_POINTER}.make_cast (a_con.item.id))
								update_class_fields -- Current might have been changed; synchronize
							end
							a_con.item.id := (create {P_XMALLOC_STATIC}).xstrdup (ce_string ("/"))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 24 -- switch 3; break
				when 22 then -- switch 3, case 10
						l_pos := -1 + 24 -- switch 3; break
				when 23 then -- switch 3, default:
						abort
						update_class_fields -- Current might have been changed; synchronize
				when 24 then -- switch 3, done: | if done
						if l_return then
							l_pos := -1 + 31 -- skip if block
						end
				when 25 then -- if:
						if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
							l_tmp___20 := gettext (ce_string ("done.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___20)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_type_char := ftp_process_type (params)
						update_class_fields -- Current might have been changed; synchronize
						if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> TYPE %%c ... "), l_type_char.to_integer_32])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_err := ftp_type (l_csock, l_type_char.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						inspect l_err.to_integer_32 -- switch 4 head
						when 18 then l_pos := -1 + 26
						when 52 then l_pos := -1 + 27
						when 17 then l_pos := -1 + 28
						when 10 then l_pos := -1 + 29
						else l_pos := -1 + 30
						end
				when 26 then -- switch 4, case 18;
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___21 := gettext (ce_string ("Error in server response, closing control connection.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___21)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_csock)
						update_class_fields -- Current might have been changed; synchronize
						a_con.item.csock := -1
						update_class_fields -- Current might have been changed; synchronize
						Result := l_err
						l_return := True
				when 27 then -- switch 4, case 52
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___22 := gettext (ce_string ("Write failed, closing control connection.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___22)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields -- Current might have been changed; synchronize
							Result := l_err
							l_return := True
						end
				when 28 then -- switch 4, case 17
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___23 := gettext (ce_string ("Unknown type `%%c%', closing control connection.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___23, l_type_char.to_integer_32])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields -- Current might have been changed; synchronize
							Result := l_err
							l_return := True
						end
				when 29 then -- switch 4, case 10
						l_pos := -1 + 31 -- switch 4; break
				when 30 then -- switch 4, default:
						abort
						update_class_fields -- Current might have been changed; synchronize
				when 31 then -- switch 4, done: | if done
						if not l_return and then (not (create {P_OPTIONS_STATIC}).opt.item.item.server_response) then
							l_tmp___24 := gettext (ce_string ("done.  "))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___24)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 32 then -- if done
					if l_return then
						l_pos := -1 + 58 -- skip if block
					end
				when 33 then -- if:
						if not (((l_cmd).bit_and (2)).to_boolean) then
							l_pos := -1 + 57 -- skip if block
						end
				when 34 then -- if:
						if (dir.item).to_boolean then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_tmp___25 := gettext (ce_string ("==> CWD not needed.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___25)
						update_class_fields -- Current might have been changed; synchronize
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 56
				when 37 then -- else:
						l_target := dir
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___26 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___26.to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("changing working directory%N")])
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
						if (l_target[0]).to_integer_32 = 47 then
							l_pos := -1 + 42 -- skip if block
						end
				when 38 then -- if:
						if a_con.item.rs = {NATURAL_32} 0 then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						l_tmp___33 := c2_isalpha ((l_target[0]).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___33 then
							if (l_target[1]).to_integer_32 /= 58 then
								l_pos := -1 + 41 -- goto _L___0
							end
						else
							l_pos := -1 + 41 -- goto _L___0
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else: | _L___0:
						if a_con.item.rs /= {NATURAL_32} 4 then
							if a_con.item.rs /= {NATURAL_32} 1 then
								l_tmp___27 := strlen (a_con.item.id)
								update_class_fields -- Current might have been changed; synchronize
								l_idlen := l_tmp___27.to_integer_32
								from
								until
									(l_break)
								loop
									l_break := False
									if l_idlen > 0 then
										if (a_con.item.id[(l_idlen - 1)]).to_integer_32 /= 47 then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_idlen := l_idlen - 1
									end
								end
								l_break := False
								l_tmp___28 := strlen (dir)
								update_class_fields -- Current might have been changed; synchronize
								l_ntarget := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new (((l_idlen + 1).to_natural_32 + l_tmp___28) + {NATURAL_32} 1)))
								l_p___0 := l_ntarget
								memcpy (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (a_con.item.id), l_idlen.to_natural_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_p___0 := l_p___0 + l_idlen
								l_tmp___30 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___30[0] := (('/').code).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								strcpy (l_p___0, l_target).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___31 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___31.to_boolean then
										(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Prepended initial PWD to relative path:%N")])
										update_class_fields -- Current might have been changed; synchronize
									end
									l_break := True
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___32 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___32.to_boolean then
										(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("   pwd: %'%%s%'%N   old: %'%%s%'%N  new: %'%%s%'%N"), a_con.item.id, l_target, l_ntarget])
										update_class_fields -- Current might have been changed; synchronize
									end
									l_break := True
								end
								l_break := False
								l_target := l_ntarget
							end
						end
				when 42 then -- if done
						if a_con.item.rs = {NATURAL_32} 1 then
							if (l_target[0]).to_integer_32 /= 47 then
								l_cwd_start := 0
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___34 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___34.to_boolean then
										(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Using two-step CWD for relative path.%N")])
										update_class_fields -- Current might have been changed; synchronize
									end
									l_break := True
								end
								l_break := False
							else
								l_cwd_start := 1
							end
						else
							l_cwd_start := 1
						end
						if a_con.item.rs = {NATURAL_32} 1 then
							l_tmp___36 := strchr (l_target, ('/').code)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___36.is_void then
								l_cwd_end := 3
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___35 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___35.to_boolean then
										(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Using extra %"CWD []%" step for VMS server.%N")])
										update_class_fields -- Current might have been changed; synchronize
									end
									l_break := True
								end
								l_break := False
							else
								l_cwd_end := 2
							end
						else
							l_cwd_end := 2
						end
						l_cwd_count := l_cwd_start
				when 43 then -- loop condition:
						if not (not (l_return) and then (l_cwd_count < l_cwd_end)) then
							l_pos := -1 + 56 -- skip loop
						end
				when 44 then -- loop body:
						inspect l_cwd_count -- switch 5 head
						when 0 then l_pos := -1 + 45
						when 1 then l_pos := -1 + 46
						when 2 then l_pos := -1 + 47
						else l_pos := -1 + 48
						end
				when 45 then -- switch 5, case 0
						l_targ := a_con.item.id
						l_pos := -1 + 49 -- switch 5; break
				when 46 then -- switch 5, case 1
						l_targ := l_target
						l_pos := -1 + 49 -- switch 5; break
				when 47 then -- switch 5, case 2
						l_targ := ce_string ("[]")
						l_pos := -1 + 49 -- switch 5; break
				when 48 then -- switch 5, default:
						
				when 49 then -- switch 5, done:
						if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
							l_tmp___37 := (create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_target)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> CWD (%%d) %%s ... "), l_cwd_count, l_tmp___37])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_err := ftp_cwd (l_csock, l_target)
						update_class_fields -- Current might have been changed; synchronize
						inspect l_err.to_integer_32 -- switch 6 head
						when 18 then l_pos := -1 + 50
						when 52 then l_pos := -1 + 51
						when 15 then l_pos := -1 + 52
						when 10 then l_pos := -1 + 53
						else l_pos := -1 + 54
						end
				when 50 then -- switch 6, case 18;
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___38 := gettext (ce_string ("Error in server response, closing control connection.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___38)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_csock)
						update_class_fields -- Current might have been changed; synchronize
						a_con.item.csock := -1
						update_class_fields -- Current might have been changed; synchronize
						Result := l_err
						l_return := True
				when 51 then -- switch 6, case 52
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___39 := gettext (ce_string ("Write failed, closing control connection.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___39)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields -- Current might have been changed; synchronize
							Result := l_err
							l_return := True
						end
				when 52 then -- switch 6, case 15
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___40 := (create {P_QUOTE_STATIC}).quote (dir)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___41 := gettext (ce_string ("No such directory %%s.%N%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___41, l_tmp___40])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields -- Current might have been changed; synchronize
							Result := l_err
							l_return := True
						end
				when 53 then -- switch 6, case 10
						l_pos := -1 + 55 -- switch 6; break
				when 54 then -- switch 6, default:
						abort
						update_class_fields -- Current might have been changed; synchronize
				when 55 then -- switch 6, done:
						if not l_return then
							if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
								l_tmp___42 := gettext (ce_string ("done.%N"))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___42)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_cwd_count := l_cwd_count + 1
						end
						l_pos := -1 + 43 -- back to loop condition
				when 56 then -- loop done | if done | if block done, skip else block:
						l_pos := -1 + 58
				when 57 then -- else:
						l_tmp___43 := gettext (ce_string ("==> CWD not required.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___43)
						update_class_fields -- Current might have been changed; synchronize
				when 58 then -- if done | if done
					if not (not l_return and then (((l_cmd).bit_and (4)).to_boolean)) then
						l_pos := -1 + 65 -- skip if block
					end
				when 59 then -- if:
						if a_passed_expected_bytes /= {INTEGER_64} 0 then
							l_pos := -1 + 65 -- skip if block
						end
				when 60 then -- if:
						if ((create {P_OPTIONS_STATIC}).opt.item.item.verbose).to_boolean then
							if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
								l_tmp___44 := (create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, file)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> SIZE %%s ... "), l_tmp___44])
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_err := ftp_size (l_csock, file, l_expected_bytes)
						update_class_fields -- Current might have been changed; synchronize
						inspect l_err.to_integer_32 -- switch 7 head
						when 18 then l_pos := -1 + 61
						when 20 then l_pos := -1 + 61
						when 10 then l_pos := -1 + 62
						else l_pos := -1 + 63
						end
				when 61 then -- switch 7, case 18 | switch 7, case 20;
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___45 := gettext (ce_string ("Error in server response, closing control connection.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___45)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_csock)
						update_class_fields -- Current might have been changed; synchronize
						a_con.item.csock := -1
						update_class_fields -- Current might have been changed; synchronize
						Result := l_err
						l_return := True
				when 62 then -- switch 7, case 10
						l_pos := -1 + 64 -- switch 7; break
				when 63 then -- switch 7, default:
						abort
						update_class_fields -- Current might have been changed; synchronize
				when 64 then -- switch 7, done:
						if not l_return and then (not (create {P_OPTIONS_STATIC}).opt.item.item.server_response) then
							l_tmp___46 := (create {P_UTILS_STATIC}).number_to_static_string (l_expected_bytes.item)
							update_class_fields -- Current might have been changed; synchronize
							if (l_expected_bytes.item).to_boolean then
								l_tmp___48 := ce_string ("%%s%N")
							else
								l_tmp___47 := gettext (ce_string ("done.%N"))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___48 := l_tmp___47
							end
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___48, l_tmp___46])
							update_class_fields -- Current might have been changed; synchronize
						end
				when 65 then -- if done | if done
					if not (not l_return and then (((l_cmd).bit_and (12)).to_boolean)) then
						l_pos := -1 + 85 -- skip if block
					end
				when 66 then -- if:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.ftp_pasv) then
							l_pos := -1 + 75 -- skip if block
						end
				when 67 then -- if:
						l_err := ftp_do_pasv (l_csock, l_passive_addr, l_passive_port)
						update_class_fields -- Current might have been changed; synchronize
						inspect l_err.to_integer_32 -- switch 8 head
						when 18 then l_pos := -1 + 68
						when 52 then l_pos := -1 + 69
						when 36 then l_pos := -1 + 70
						when 35 then l_pos := -1 + 71
						when 10 then l_pos := -1 + 72
						else l_pos := -1 + 73
						end
				when 68 then -- switch 8, case 18;
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___49 := gettext (ce_string ("Error in server response, closing control connection.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___49)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_csock)
						update_class_fields -- Current might have been changed; synchronize
						a_con.item.csock := -1
						update_class_fields -- Current might have been changed; synchronize
						Result := l_err
						l_return := True
				when 69 then -- switch 8, case 52
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___50 := gettext (ce_string ("Write failed, closing control connection.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___50)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields -- Current might have been changed; synchronize
							Result := l_err
							l_return := True
						end
				when 70 then -- switch 8, case 36
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___51 := gettext (ce_string ("Cannot initiate PASV transfer.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___51)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 74 -- switch 8; break
				when 71 then -- switch 8, case 35;
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___52 := gettext (ce_string ("Cannot parse PASV response.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___52)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 74 -- switch 8; break
				when 72 then -- switch 8, case 10
						l_pos := -1 + 74 -- switch 8; break
				when 73 then -- switch 8, default:
						abort
						update_class_fields -- Current might have been changed; synchronize
				when 74 then -- switch 8, done:
						if not l_return and then (l_err = {NATURAL_32} 10) then
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___54 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___54.to_boolean then
									l_tmp___53 := l_passive_addr.item.print_address
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("trying to connect to %%s port %%d%N"), l_tmp___53, l_passive_port.item])
									update_class_fields -- Current might have been changed; synchronize
								end
								l_break := True
							end
							l_break := False
							l_dtsock := l_passive_addr.item.connect_to_ip (l_passive_port.item, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
							if l_dtsock < 0 then
								l_tmp___55 := errno_location
								update_class_fields -- Current might have been changed; synchronize
								l_save_errno := l_tmp___55.item;
								(create {P_CONNECT_STATIC}).fd_close (l_csock)
								update_class_fields -- Current might have been changed; synchronize
								a_con.item.csock := -1
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___56 := strerror (l_save_errno)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___57 := l_passive_addr.item.print_address
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___58 := gettext (ce_string ("couldn%'t connect to %%s port %%d: %%s%N"))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___58, l_tmp___57, l_passive_port.item, l_tmp___56])
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___61 := retryable_socket_connect_error (l_save_errno)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___61 then
									l_tmp___60 := 3
								else
									l_tmp___60 := 5
								end
								Result := l_tmp___60.to_natural_32
								l_return := True
							end
							if not l_return then
								l_pasv_mode_open := (1).to_boolean
								if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
									l_tmp___62 := gettext (ce_string ("done.    "))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___62)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
				when 75 then -- if done
						if not (not l_return and then (not l_pasv_mode_open)) then
							l_pos := -1 + 85 -- skip if block
						end
				when 76 then -- if:
						l_err := ftp_do_port (l_csock, l_local_sock)
						update_class_fields -- Current might have been changed; synchronize
						inspect l_err.to_integer_32 -- switch 9 head
						when 18 then l_pos := -1 + 77
						when 52 then l_pos := -1 + 78
						when 2 then l_pos := -1 + 79
						when 14 then l_pos := -1 + 80
						when 13 then l_pos := -1 + 81
						when 10 then l_pos := -1 + 82
						else l_pos := -1 + 83
						end
				when 77 then -- switch 9, case 18;
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___63 := gettext (ce_string ("Error in server response, closing control connection.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___63)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_csock)
						update_class_fields -- Current might have been changed; synchronize
						a_con.item.csock := -1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_local_sock.item)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_err
						l_return := True
				when 78 then -- switch 9, case 52
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___64 := gettext (ce_string ("Write failed, closing control connection.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___64)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_local_sock.item)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_err
							l_return := True
						end
				when 79 then -- switch 9, case 2
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___65 := errno_location
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___66 := strerror (l_tmp___65.item)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("socket: %%s%N"), l_tmp___66])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_local_sock.item)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_err
							l_return := True
						end
				when 80 then -- switch 9, case 14
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___67 := errno_location
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___68 := strerror (l_tmp___67.item)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___69 := gettext (ce_string ("Bind error (%%s).%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___69, l_tmp___68])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_err
							l_return := True
						end
				when 81 then -- switch 9, case 13
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___70 := gettext (ce_string ("Invalid PORT.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___70)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_local_sock.item)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_err
							l_return := True
						end
				when 82 then -- switch 9, case 10
						l_pos := -1 + 84 -- switch 9; break
				when 83 then -- switch 9, default:
						abort
						update_class_fields -- Current might have been changed; synchronize
				when 84 then -- switch 9, done:
						if not l_return and then (not (create {P_OPTIONS_STATIC}).opt.item.item.server_response) then
							l_tmp___71 := gettext (ce_string ("done.    "))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___71)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 85 then -- if done | if done
					if not (not l_return and then (a_restval.to_boolean)) then
						l_pos := -1 + 94 -- skip if block
					end
				when 86 then -- if:
						if not (((l_cmd).bit_and (4)).to_boolean) then
							l_pos := -1 + 94 -- skip if block
						end
				when 87 then -- if:
						if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
							l_tmp___72 := (create {P_UTILS_STATIC}).number_to_static_string (a_restval)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> REST %%s ... "), l_tmp___72])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_err := ftp_rest (l_csock, a_restval)
						update_class_fields -- Current might have been changed; synchronize
						inspect l_err.to_integer_32 -- switch 10 head
						when 18 then l_pos := -1 + 88
						when 52 then l_pos := -1 + 89
						when 22 then l_pos := -1 + 90
						when 10 then l_pos := -1 + 91
						else l_pos := -1 + 92
						end
				when 88 then -- switch 10, case 18;
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___73 := gettext (ce_string ("Error in server response, closing control connection.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___73)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_csock)
						update_class_fields -- Current might have been changed; synchronize
						a_con.item.csock := -1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_local_sock.item)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_err
						l_return := True
				when 89 then -- switch 10, case 52
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___74 := gettext (ce_string ("Write failed, closing control connection.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___74)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_local_sock.item)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_err
							l_return := True
						end
				when 90 then -- switch 10, case 22
						if not l_return then
							l_tmp___75 := gettext (ce_string ("%NREST failed, starting from scratch.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___75)
							update_class_fields -- Current might have been changed; synchronize
							l_rest_failed := (1).to_boolean
						end
						l_pos := -1 + 93 -- switch 10; break
				when 91 then -- switch 10, case 10
						l_pos := -1 + 93 -- switch 10; break
				when 92 then -- switch 10, default:
						abort
						update_class_fields -- Current might have been changed; synchronize
				when 93 then -- switch 10, done:
						if not l_return and then (l_err /= {NATURAL_32} 22) then
							if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
								l_tmp___76 := gettext (ce_string ("done.    "))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___76)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 94 then -- if done | if done
					if not (not l_return and then (((l_cmd).bit_and (4)).to_boolean)) then
						l_pos := -1 + 103 -- skip if block
					end
				when 95 then -- if:
						if (create {P_OPTIONS_STATIC}).opt.item.item.spider then
							l_exists := (0).to_boolean
							l_res___1 := ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.ftp_get_listing (a_con, l_f)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.cmd := (a_con.item.cmd).bit_or ((4))
							update_class_fields -- Current might have been changed; synchronize
							if l_res___1 = {NATURAL_32} 31 then
								from
								until
									not (not (l_break) and then (not (l_f.item).is_void))
								loop
									l_break := False
									l_tmp___77 := strcmp (l_f.item.item.name, file)
									update_class_fields -- Current might have been changed; synchronize
									if not l_tmp___77.to_boolean then
										l_exists := (1).to_boolean
										l_break := True
									end
									if not (l_return or l_break) then
										l_f.item := l_f.item.item.next
										update_class_fields -- Current might have been changed; synchronize
									end
								end
								l_break := False
								if l_exists then
									(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___78 := (create {P_QUOTE_STATIC}).quote (file)
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___79 := gettext (ce_string ("File %%s exists.%N"))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___79, l_tmp___78])
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___80 := (create {P_QUOTE_STATIC}).quote (file)
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___81 := gettext (ce_string ("No such file %%s.%N"))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___81, l_tmp___80])
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_local_sock.item)
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_UERR_T}.RETRFINISHED)
							l_return := True
						end
						if l_return then
							l_pos := -1 + 102 -- skip if block
						end
				when 96 then -- if:
						if ((create {P_OPTIONS_STATIC}).opt.item.item.verbose).to_boolean then
							if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
								if a_restval.to_boolean then
									(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
									update_class_fields -- Current might have been changed; synchronize
								end
								l_tmp___82 := (create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, file)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> RETR %%s ... "), l_tmp___82])
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_err := ftp_retr (l_csock, file)
						update_class_fields -- Current might have been changed; synchronize
						inspect l_err.to_integer_32 -- switch 11 head
						when 18 then l_pos := -1 + 97
						when 52 then l_pos := -1 + 98
						when 15 then l_pos := -1 + 99
						when 10 then l_pos := -1 + 100
						else l_pos := -1 + 101
						end
				when 97 then -- switch 11, case 18;
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___83 := gettext (ce_string ("Error in server response, closing control connection.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___83)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_csock)
						update_class_fields -- Current might have been changed; synchronize
						a_con.item.csock := -1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_local_sock.item)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_err
						l_return := True
				when 98 then -- switch 11, case 52
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___84 := gettext (ce_string ("Write failed, closing control connection.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___84)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_local_sock.item)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_err
							l_return := True
						end
				when 99 then -- switch 11, case 15
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___85 := (create {P_QUOTE_STATIC}).quote (file)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___86 := gettext (ce_string ("No such file %%s.%N%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___86, l_tmp___85])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_local_sock.item)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_err
							l_return := True
						end
				when 100 then -- switch 11, case 10
						l_pos := -1 + 102 -- switch 11; break
				when 101 then -- switch 11, default:
						abort
						update_class_fields -- Current might have been changed; synchronize
				when 102 then -- switch 11, done: | if done
						if not l_return then
							if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
								l_tmp___87 := gettext (ce_string ("done.%N"))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___87)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_expected_bytes.item := ftp_expected_bytes (ftp_last_respline.item)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 103 then -- if done
					if not (not l_return and then (((l_cmd).bit_and (8)).to_boolean)) then
						l_pos := -1 + 111 -- skip if block
					end
				when 104 then -- if:
						if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> LIST ... "))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_err := ftp_list (l_csock, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), a_con.item.rs)
						update_class_fields -- Current might have been changed; synchronize
						inspect l_err.to_integer_32 -- switch 12 head
						when 18 then l_pos := -1 + 105
						when 52 then l_pos := -1 + 106
						when 15 then l_pos := -1 + 107
						when 10 then l_pos := -1 + 108
						else l_pos := -1 + 109
						end
				when 105 then -- switch 12, case 18;
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___88 := gettext (ce_string ("Error in server response, closing control connection.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___88)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_csock)
						update_class_fields -- Current might have been changed; synchronize
						a_con.item.csock := -1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_local_sock.item)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_err
						l_return := True
				when 106 then -- switch 12, case 52
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___89 := gettext (ce_string ("Write failed, closing control connection.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___89)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_local_sock.item)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_err
							l_return := True
						end
				when 107 then -- switch 12, case 15
						if not l_return then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___90 := (create {P_QUOTE_STATIC}).quote (ce_string ("."))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___91 := gettext (ce_string ("No such file or directory %%s.%N%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___91, l_tmp___90])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_local_sock.item)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_err
							l_return := True
						end
				when 108 then -- switch 12, case 10
						l_pos := -1 + 110 -- switch 12; break
				when 109 then -- switch 12, default:
						abort
						update_class_fields -- Current might have been changed; synchronize
				when 110 then -- switch 12, done:
						if not l_return then
							if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
								l_tmp___92 := gettext (ce_string ("done.%N"))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___92)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_expected_bytes.item := ftp_expected_bytes (ftp_last_respline.item)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 111 then -- if done
					if not l_return then
						if not ((l_cmd).bit_and (12)).to_boolean then
							Result := ({PC_UERR_T}.RETRFINISHED)
							l_return := True
						elseif (create {P_OPTIONS_STATIC}).opt.item.item.spider then
							if not ((l_cmd).bit_and (8)).to_boolean then
								Result := ({PC_UERR_T}.RETRFINISHED)
								l_return := True
							end
						end
					end
					if not l_return then
						if a_passed_expected_bytes.to_boolean then
							if a_restval.to_boolean then
								if (l_expected_bytes.item).to_boolean then
									if l_expected_bytes.item = a_passed_expected_bytes - a_restval then
										from
										until
											(l_break)
										loop
											l_break := False
											l_tmp___93 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
											update_class_fields -- Current might have been changed; synchronize
											if l_tmp___93.to_boolean then
												(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Lying FTP server found, adjusting.%N")])
												update_class_fields -- Current might have been changed; synchronize
											end
											l_break := True
										end
										l_break := False
										l_expected_bytes.item := a_passed_expected_bytes
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
						end
						if not l_pasv_mode_open then
							l_dtsock := accept_connection (l_local_sock.item)
							update_class_fields -- Current might have been changed; synchronize
							if l_dtsock < 0 then
								l_tmp___94 := errno_location
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___95 := strerror (l_tmp___94.item)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("accept: %%s%N"), l_tmp___95])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_UERR_T}.CONERROR)
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 123 -- skip if block
					end
				when 112 then -- if:
						if (not ((create {P_RETR_STATIC}).output_stream.item).is_void) then
							l_pos := -1 + 115 -- skip if block
						end
				when 113 then -- if:
						l_pos := -1 + 116 -- goto _L___2
				when 114 then -- if block done, skip else block:
						l_pos := -1 + 123
				when 115 then -- else:
						if not (((a_con.item.cmd).bit_and (8)).to_boolean) then
							l_pos := -1 + 122 -- skip if block
						end
				when 116 then -- if: | _L___2:
						mkalldirs (a_con.item.target).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if (create {P_OPTIONS_STATIC}).opt.item.item.backups then
							rotate_backups (a_con.item.target)
							update_class_fields -- Current might have been changed; synchronize
						end
						if not (a_restval.to_boolean) then
							l_pos := -1 + 119 -- skip if block
						end
				when 117 then -- if:
						if not ((a_con.item.cmd).bit_and (8)).to_boolean then
							l_fp := fopen (a_con.item.target, ce_string ("ab"))
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 119 -- goto _L___1
						end
				when 118 then -- if block done, skip else block:
						l_pos := -1 + 120
				when 119 then -- else: | _L___1:
						if (create {P_OPTIONS_STATIC}).opt.item.item.noclobber then
							l_fp := fopen (a_con.item.target, ce_string ("wb"))
							update_class_fields -- Current might have been changed; synchronize
						elseif (create {P_OPTIONS_STATIC}).opt.item.item.always_rest then
							l_fp := fopen (a_con.item.target, ce_string ("wb"))
							update_class_fields -- Current might have been changed; synchronize
						elseif (create {P_OPTIONS_STATIC}).opt.item.item.timestamping then
							l_fp := fopen (a_con.item.target, ce_string ("wb"))
							update_class_fields -- Current might have been changed; synchronize
						elseif (create {P_OPTIONS_STATIC}).opt.item.item.dirstruct then
							l_fp := fopen (a_con.item.target, ce_string ("wb"))
							update_class_fields -- Current might have been changed; synchronize
						elseif (not ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void) then
							l_fp := fopen (a_con.item.target, ce_string ("wb"))
							update_class_fields -- Current might have been changed; synchronize
						else
							l_fp := (create {P_UTILS_STATIC}).fopen_excl (a_con.item.target, 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_fp.is_void then
								l_tmp___97 := errno_location
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___97.item = 17 then
									l_tmp___96 := gettext (ce_string ("%%s has sprung into existence.%N"))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___96, a_con.item.target])
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_CONNECT_STATIC}).fd_close (l_csock)
									update_class_fields -- Current might have been changed; synchronize
									a_con.item.csock := -1
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_CONNECT_STATIC}).fd_close (l_local_sock.item)
									update_class_fields -- Current might have been changed; synchronize
									Result := ({PC_UERR_T}.FOPEN_EXCL_ERR)
									l_return := True
								end
							end
						end
				when 120 then
						if not l_return and then (l_fp.is_void) then
							l_tmp___98 := errno_location
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___99 := strerror (l_tmp___98.item)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_con.item.target, l_tmp___99])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_local_sock.item)
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_UERR_T}.FOPENERR)
							l_return := True
						end
				when 121 then -- if block done, skip else block:
						l_pos := -1 + 123
				when 122 then -- else:
						l_fp := (create {P_RETR_STATIC}).output_stream.item
				when 123 then -- if done | if done
					if not l_return then
						if a_passed_expected_bytes.to_boolean then
							print_length (a_passed_expected_bytes, a_restval, (1).to_boolean)
							update_class_fields -- Current might have been changed; synchronize
							l_expected_bytes.item := a_passed_expected_bytes
							update_class_fields -- Current might have been changed; synchronize
						elseif (l_expected_bytes.item).to_boolean then
							print_length (l_expected_bytes.item, a_restval, (0).to_boolean)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_flags := 0
						if a_restval.to_boolean then
							if l_rest_failed then
								l_flags := (l_flags).bit_or ((2))
							end
						end
						l_rd_size.item := (0).to_integer_64
						update_class_fields -- Current might have been changed; synchronize
						if (l_expected_bytes.item).to_boolean then
							l_tmp___100 := l_expected_bytes.item - a_restval
						else
							l_tmp___100 := (0).to_integer_64
						end
						l_res___0 := fd_read_body (l_dtsock, l_fp, l_tmp___100, a_restval, l_rd_size, a_qtyread, create {CE_REAL_64_POINTER}.make_shared (a_con.c_pointer + (create {PD_CCON}.make).offset_of ("dltime")), l_flags)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___101 := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_tms := (create {P_UTILS_STATIC}).datetime_str (l_tmp___101)
						update_class_fields -- Current might have been changed; synchronize
						l_tmrate := (create {P_RETR_STATIC}).retr_rate (l_rd_size.item, a_con.item.dltime)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_RETR_STATIC}).total_download_time.item := (create {P_RETR_STATIC}).total_download_time.item + (a_con.item.dltime)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).fd_close (l_local_sock.item)
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_RETR_STATIC}).output_stream.item).is_void then
							fclose (l_fp).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						elseif ((a_con.item.cmd).bit_and (8)).to_boolean then
							fclose (l_fp).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_res___0 = -2 then
							l_tmp___102 := errno_location
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___103 := strerror (l_tmp___102.item)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___104 := gettext (ce_string ("%%s: %%s, closing control connection.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___104, a_con.item.target, l_tmp___103])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_UERR_T}.FWRITEERR)
							l_return := True
						elseif l_res___0 = -1 then
							l_tmp___105 := fd_errstr (l_dtsock)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___106 := gettext (ce_string ("%%s (%%s) - Data connection: %%s; "))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___106, l_tms, l_tmrate, l_tmp___105])
							update_class_fields -- Current might have been changed; synchronize
							if (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
								(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_ALWAYS, ce_string ("%N"))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
					if not l_return then
						(create {P_CONNECT_STATIC}).fd_close (l_dtsock)
						update_class_fields -- Current might have been changed; synchronize
						l_err := ftp_response (l_csock, l_respline)
						update_class_fields -- Current might have been changed; synchronize
						if l_err /= {NATURAL_32} 10 then
							if l_res___0 /= -1 then
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s (%%s) - "), l_tms, l_tmrate])
								update_class_fields -- Current might have been changed; synchronize
							end
							l_tmp___107 := gettext (ce_string ("Control connection closed.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___107)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_UERR_T}.FTPRETRINT)
							l_return := True
						end
					end
					if not l_return and then ((l_respline.item[0]).to_integer_32 /= 50) then
						free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
						update_class_fields -- Current might have been changed; synchronize
						if l_res___0 /= -1 then
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s (%%s) - "), l_tms, l_tmrate])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tmp___108 := gettext (ce_string ("Data transfer aborted.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___108)
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_UERR_T}.FTPRETRINT)
						l_return := True
					end
					if not l_return then
						free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
						update_class_fields -- Current might have been changed; synchronize
						if l_res___0 = -1 then
							Result := ({PC_UERR_T}.FTPRETRINT)
							l_return := True
						end
					end
					if not l_return then
						if not ((l_cmd).bit_and (16)).to_boolean then
							(create {P_CONNECT_STATIC}).fd_close (l_csock)
							update_class_fields -- Current might have been changed; synchronize
							a_con.item.csock := -1
							update_class_fields -- Current might have been changed; synchronize
						end
						if (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
							if ((a_con.item.cmd).bit_and (8)).to_boolean then
								mkalldirs (a_con.item.target).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_fp := fopen (a_con.item.target, ce_string ("r"))
								update_class_fields -- Current might have been changed; synchronize
								if l_fp.is_void then
									l_tmp___109 := errno_location
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___110 := strerror (l_tmp___109.item)
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_ALWAYS, ce_string ("%%s: %%s%N"), a_con.item.target, l_tmp___110])
									update_class_fields -- Current might have been changed; synchronize
								else
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										l_line := (create {P_UTILS_STATIC}).read_whole_line (l_fp)
										update_class_fields -- Current might have been changed; synchronize
										if l_line.is_void then
											l_break := True
										end
										if not (l_return or l_break) then
											l_tmp___111 := strchr (l_line, ('%/0/').code)
											update_class_fields -- Current might have been changed; synchronize
											l_p___1 := l_tmp___111
											from
											until
												(l_break)
											loop
												l_break := False
												if (l_p___1.c_pointer.to_integer_32).to_natural_32 > (l_line.c_pointer.to_integer_32).to_natural_32 then
													if (l_p___1[-1]).to_integer_32 /= 10 then
														if (l_p___1[-1]).to_integer_32 /= 13 then
															l_break := True
														end
													end
												else
													l_break := True
												end
												if not (l_return or l_break) then
													l_p___1 := l_p___1 - 1
													l_p___1[0] := (('%/0/').code).to_integer_8
													update_class_fields -- Current might have been changed; synchronize
												end
											end
											l_break := False
											l_tmp___112 := (create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_line)
											update_class_fields; -- Current might have been changed; synchronize
											(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_ALWAYS, ce_string ("%%s%N"), l_tmp___112])
											update_class_fields -- Current might have been changed; synchronize
											free (create {CE_VOID_POINTER}.make_cast (l_line))
											update_class_fields -- Current might have been changed; synchronize
										end
									end
									l_break := False
									fclose (l_fp).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						Result := ({PC_UERR_T}.RETRFINISHED)
					end
				when 124 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_loop (a_dt: CE_POINTER [INTEGER_32]; a_proxy: CE_POINTER [PD_URL]; a_recursive, a_glob: BOOLEAN): NATURAL_32
		require
			not a_dt.is_void
		local
			l_con: CE_ARRAY [PD_CCON]
			l_res___0: NATURAL_32
			l_f: CE_ARRAY [CE_POINTER [PD_FILEINFO]]
			l_filename: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_st: CE_ARRAY [SD_STAT]
			l_sz: INTEGER_64
			l_tmp___4: INTEGER_32
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_ispattern: BOOLEAN
			l_file_part: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_CCON]} l_con.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_FILEINFO]} l_f.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_dt.item := 0
					update_class_fields -- Current might have been changed; synchronize
					memset (create {CE_VOID_POINTER}.make_cast (l_con), ('%/0/').code, (create {PD_CCON}.make).structure_size.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_con.item.csock := -1
					update_class_fields -- Current might have been changed; synchronize
					l_con.item.st := 1
					update_class_fields -- Current might have been changed; synchronize
					l_con.item.rs := {PC_STYPE}.ST_UNIX
					update_class_fields -- Current might have been changed; synchronize
					l_con.item.id := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					l_con.item.proxy := a_proxy
					update_class_fields -- Current might have been changed; synchronize
					if (file.item).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not a_recursive then
							l_res___0 := ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.ftp_get_listing (l_con, l_f)
							update_class_fields -- Current might have been changed; synchronize
							if l_res___0 = {NATURAL_32} 31 then
								if (create {P_OPTIONS_STATIC}).opt.item.item.htmlify then
									if not (create {P_OPTIONS_STATIC}).opt.item.item.spider then
										if (not ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void) then
											l_tmp := (create {P_XMALLOC_STATIC}).xstrdup ((create {P_OPTIONS_STATIC}).opt.item.item.output_document)
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___3 := l_tmp
										else
											if (not (l_con.item.target).is_void) then
												l_tmp___0 := (create {P_XMALLOC_STATIC}).xstrdup (l_con.item.target)
												update_class_fields -- Current might have been changed; synchronize
												l_tmp___2 := l_tmp___0
											else
												l_tmp___1 := ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.url_file_name
												update_class_fields -- Current might have been changed; synchronize
												l_tmp___2 := l_tmp___1
											end
											l_tmp___3 := l_tmp___2
										end
										l_filename := l_tmp___3
										l_res___0 := ftp_index (l_filename, (create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer)), l_f.item)
										update_class_fields -- Current might have been changed; synchronize
										if l_res___0 = {NATURAL_32} 10 then
											if ((create {P_OPTIONS_STATIC}).opt.item.item.verbose).to_boolean then
												if ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void then
													l_tmp___4 := stat (l_filename, l_st)
													update_class_fields -- Current might have been changed; synchronize
													if l_tmp___4 = 0 then
														l_sz := (l_st.item.st_size).to_integer_64
													else
														l_sz := (-1).to_integer_64
													end
													l_tmp___5 := (create {P_UTILS_STATIC}).number_to_static_string (l_sz)
													update_class_fields -- Current might have been changed; synchronize
													l_tmp___6 := (create {P_QUOTE_STATIC}).quote (l_filename)
													update_class_fields -- Current might have been changed; synchronize
													l_tmp___7 := gettext (ce_string ("Wrote HTML-ized index to %%s [%%s].%N"))
													update_class_fields; -- Current might have been changed; synchronize
													(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___7, l_tmp___6, l_tmp___5])
													update_class_fields -- Current might have been changed; synchronize
												else
													l_tmp___8 := (create {P_QUOTE_STATIC}).quote (l_filename)
													update_class_fields -- Current might have been changed; synchronize
													l_tmp___9 := gettext (ce_string ("Wrote HTML-ized index to %%s.%N"))
													update_class_fields; -- Current might have been changed; synchronize
													(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___9, l_tmp___8])
													update_class_fields -- Current might have been changed; synchronize
												end
											end
										end
										free (create {CE_VOID_POINTER}.make_cast (l_filename))
										update_class_fields -- Current might have been changed; synchronize
									end
								end
								freefileinfo (l_f.item)
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else: | _L___0:
						l_ispattern := (0).to_boolean
						if a_glob then
							l_tmp___10 := strrchr (path, ('/').code)
							update_class_fields -- Current might have been changed; synchronize
							l_file_part := l_tmp___10
							if l_file_part.is_void then
								l_file_part := path
							end
							l_ispattern := (create {P_UTILS_STATIC}).has_wildcards_p (l_file_part)
							update_class_fields -- Current might have been changed; synchronize
						end
						if not l_ispattern then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not a_recursive then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.timestamping) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						if l_ispattern then
							l_tmp___11 := 0
						else
							l_tmp___11 := 2
						end
						l_res___0 := ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.ftp_retrieve_glob (l_con, l_tmp___11)
						update_class_fields -- Current might have been changed; synchronize
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_res___0 := ftp_loop_internal ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer), l_con)
						update_class_fields -- Current might have been changed; synchronize
				when 13 then -- if done | if done | if done
					if l_res___0 = {NATURAL_32} 10 then
						l_res___0 := {PC_UERR_T}.RETROK
					end
					if l_res___0 = {NATURAL_32} 31 then
						a_dt.item := (a_dt.item).bit_or ((2))
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_con.item.csock /= -1 then
						(create {P_CONNECT_STATIC}).fd_close (l_con.item.csock)
						update_class_fields -- Current might have been changed; synchronize
					end
					if (not (l_con.item.id).is_void) then
						free (create {CE_VOID_POINTER}.make_cast (l_con.item.id))
						update_class_fields -- Current might have been changed; synchronize
					end
					l_con.item.id := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					if (not (l_con.item.target).is_void) then
						free (create {CE_VOID_POINTER}.make_cast (l_con.item.target))
						update_class_fields -- Current might have been changed; synchronize
					end
					l_con.item.target := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_res___0
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gethttp (a_hs: CE_POINTER [PD_HTTP_STAT]; a_dt: CE_POINTER [INTEGER_32]; a_proxy: CE_POINTER [PD_URL]; a_iri: CE_POINTER [PD_IRI]): NATURAL_32
		require
			not a_hs.is_void
			not a_dt.is_void
		local
			l_req: CE_POINTER [PD_REQUEST]
			l_type: CE_POINTER [INTEGER_8]
			l_user: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_passwd: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_proxyauth: CE_POINTER [INTEGER_8]
			l_statcode: INTEGER_32
			l_write_error: INTEGER_32
			l_contlen: INTEGER_64
			l_contrange: INTEGER_64
			l_conn: CE_POINTER [PD_URL]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_sock: INTEGER_32
			l_flags: INTEGER_32
			l_auth_finished: CE_ARRAY [BOOLEAN]
			l_basic_auth_finished: BOOLEAN
			l_ntlm_seen: BOOLEAN
			l_using_ssl: BOOLEAN
			l_head_only: BOOLEAN
			l_head: CE_POINTER [INTEGER_8]
			l_resp: CE_POINTER [PD_RESPONSE]
			l_hdrval: CE_ARRAY [INTEGER_8]
			l_message: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_keep_alive: BOOLEAN
			l_inhibit_keep_alive: BOOLEAN
			l_tmp: INTEGER_32
			l_post_data_size: INTEGER_64
			l_host_lookup_failed: CE_ARRAY [BOOLEAN]
			l_meth_arg: CE_POINTER [INTEGER_8]
			l_meth: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_add_port: INTEGER_32
			l_tmp___5: INTEGER_32
			l_add_squares: INTEGER_32
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: NATURAL_32
			l_tmp___10: CE_POINTER [INTEGER_32]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_proxy_user: CE_POINTER [INTEGER_8]
			l_proxy_passwd: CE_POINTER [INTEGER_8]
			l_relevant: CE_POINTER [PD_URL]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_tmp___18: INTEGER_32
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___20: CE_POINTER [INTEGER_8]
			l_tmp___21: BOOLEAN
			l_tmp___24: INTEGER_32
			l_tmp___25: CE_POINTER [INTEGER_32]
			l_tmp___26: BOOLEAN
			l_tmp___27: INTEGER_32
			l_tmp___28: CE_POINTER [INTEGER_8]
			l_tmp___29: CE_POINTER [INTEGER_8]
			l_tmp___30: CE_POINTER [INTEGER_8]
			l_tmp___31: CE_POINTER [INTEGER_8]
			l_tmp___32: CE_POINTER [INTEGER_8]
			l_tmp___33: CE_POINTER [INTEGER_32]
			l_tmp___34: INTEGER_32
			l_tmp___35: CE_POINTER [INTEGER_8]
			l_tmp___36: CE_POINTER [INTEGER_8]
			l_parsed: INTEGER_64
			l_tmp___37: CE_POINTER [INTEGER_32]
			l_tmp___38: CE_POINTER [INTEGER_32]
			l_tmp___39: BOOLEAN
			l_tmp___40: INTEGER_32
			l_tmp___41: BOOLEAN
			l_tmp___42: BOOLEAN
			l_scpos: INTEGER_32
			l_scbeg: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_scend: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_set_cookie: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_BTA_beg: CE_POINTER [INTEGER_8]
			l_BTA_len: INTEGER_32
			l_BTA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_tmp___44: BOOLEAN
			l_wapos: INTEGER_32
			l_wabeg: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_waend: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_www_authenticate: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_BTA_beg___0: CE_POINTER [INTEGER_8]
			l_BTA_len___0: INTEGER_32
			l_BTA_dest___0: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_tmp___46: BOOLEAN
			l_tmp___47: CE_POINTER [INTEGER_8]
			l_pth: CE_POINTER [INTEGER_8]
			l_tmp___48: CE_POINTER [INTEGER_8]
			l_tmp___49: CE_POINTER [INTEGER_8]
			l_tmp___50: INTEGER_32
			l_tmp___51: BOOLEAN
			l_tmp___52: INTEGER_32
			l_tmp___53: BOOLEAN
			l_tmp___54: INTEGER_32
			l_tmp___55: BOOLEAN
			l_tmp___56: CE_POINTER [INTEGER_8]
			l_tmp___57: BOOLEAN
			l_tmp___58: BOOLEAN
			l_tmp___59: CE_POINTER [INTEGER_8]
			l_tmp___60: CE_POINTER [INTEGER_8]
			l_tmp___61: BOOLEAN
			l_unique: CE_POINTER [INTEGER_8]
			l_tmp___62: CE_POINTER [INTEGER_8]
			l_tmp___63: BOOLEAN
			l_filename_len: NATURAL_32
			l_tmp___64: NATURAL_32
			l_filename_plus_orig_suffix: CE_POINTER [INTEGER_8]
			l_local_dot_orig_file_exists: BOOLEAN
			l_local_filename: CE_POINTER [INTEGER_8]
			l_st: CE_ARRAY [SD_STAT]
			l_tmp___66: INTEGER_32
			l_tmp___67: INTEGER_32
			l_tmp___68: CE_POINTER [INTEGER_8]
			l_tmp___69: CE_POINTER [INTEGER_8]
			l_tmp___70: CE_POINTER [INTEGER_8]
			l_tmp___71: CE_POINTER [INTEGER_8]
			l_tmp2: CE_POINTER [INTEGER_8]
			l_tmp___72: BOOLEAN
			l_first_byte_pos: CE_ARRAY [INTEGER_64]
			l_last_byte_pos: CE_ARRAY [INTEGER_64]
			l_entity_length: CE_ARRAY [INTEGER_64]
			l_tmp___73: BOOLEAN
			l_tmp___74: BOOLEAN
			l_tmp___75: CE_POINTER [INTEGER_8]
			l_tmp___76: CE_POINTER [INTEGER_8]
			l_tmp___77: CE_POINTER [INTEGER_8]
			l_tmp___78: CE_POINTER [INTEGER_8]
			l_tmp___79: CE_POINTER [INTEGER_8]
			l_tmp___80: CE_POINTER [INTEGER_8]
			l_tmp___81: BOOLEAN
			l_tmp___82: NATURAL_32
			l_tmp___83: INTEGER_32
			l_tmp___84: NATURAL_32
			l_tmp___85: INTEGER_32
			l_tmp___86: NATURAL_32
			l_tmp___87: INTEGER_32
			l_tmp___88: CE_POINTER [INTEGER_8]
			l_tmp___89: CE_POINTER [INTEGER_8]
			l_tmp___90: CE_POINTER [INTEGER_8]
			l_tmp___91: CE_POINTER [INTEGER_8]
			l_tmp___92: CE_POINTER [INTEGER_8]
			l_tmp___93: CE_POINTER [INTEGER_8]
			l_tmp___94: CE_POINTER [INTEGER_8]
			l_tmp___95: CE_POINTER [INTEGER_8]
			l_tmp___96: CE_POINTER [INTEGER_8]
			l_tmp___97: CE_POINTER [INTEGER_8]
			l_tmp___98: CE_POINTER [INTEGER_8]
			l_tmp___99: CE_POINTER [INTEGER_8]
			l_tmp___100: CE_POINTER [INTEGER_8]
			l_tmp___101: BOOLEAN
			l_tmp___102: CE_POINTER [INTEGER_8]
			l_tmp___103: CE_POINTER [INTEGER_32]
			l_tmp___104: CE_POINTER [INTEGER_32]
			l_tmp___105: CE_POINTER [INTEGER_8]
			l_tmp___106: CE_POINTER [INTEGER_8]
			l_tmp___107: CE_POINTER [INTEGER_8]
			l_tmp___108: CE_POINTER [INTEGER_8]
			l_tmp___109: CE_POINTER [INTEGER_8]
			l_tmp___110: NATURAL_32
			l_tmp___111: INTEGER_64
			l_tmp___112: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_INTEGER_8_POINTER} l_type.make
			create {CE_POINTER_ARRAY [INTEGER_8]} l_user.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_passwd.make (<<1>>)
			create {CE_BOOLEAN_ARRAY} l_auth_finished.make (<<1>>)
			create {CE_CLASS_POINTER [PD_RESPONSE]} l_resp.make
			create {CE_INTEGER_8_ARRAY} l_hdrval.make (<<256>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_message.make (<<1>>)
			create {CE_BOOLEAN_ARRAY} l_host_lookup_failed.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_scbeg.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_scend.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_set_cookie.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_wabeg.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_waend.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_www_authenticate.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)
			create {CE_INTEGER_64_ARRAY} l_first_byte_pos.make (<<1>>)
			create {CE_INTEGER_64_ARRAY} l_last_byte_pos.make (<<1>>)
			create {CE_INTEGER_64_ARRAY} l_entity_length.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sock := -1
					l_auth_finished.item := (0).to_boolean
					update_class_fields -- Current might have been changed; synchronize
					l_basic_auth_finished := (0).to_boolean
					l_ntlm_seen := (0).to_boolean
					l_using_ssl := (0).to_boolean
					l_head_only := (((a_dt.item).bit_and (4)).to_boolean)
					if not (create {P_OPTIONS_STATIC}).opt.item.item.http_keep_alive then
						l_tmp := 1
					elseif (create {P_OPTIONS_STATIC}).opt.item.item.ignore_length then
						l_tmp := 1
					elseif not a_proxy.is_void then
						l_tmp := 1
					else
						l_tmp := 0
					end
					l_inhibit_keep_alive := l_tmp.to_boolean
					l_post_data_size := (0).to_integer_64
					l_host_lookup_failed.item := (0).to_boolean
					update_class_fields -- Current might have been changed; synchronize
					a_hs.item.len := (0).to_integer_64
					update_class_fields -- Current might have been changed; synchronize
					a_hs.item.contlen := (-1).to_integer_64
					update_class_fields -- Current might have been changed; synchronize
					a_hs.item.res := -1
					update_class_fields -- Current might have been changed; synchronize
					a_hs.item.rderrmsg := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					a_hs.item.newloc := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					a_hs.item.remote_time := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					a_hs.item.error := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					a_hs.item.message := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					l_conn := (create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))
					l_req := request_new
					update_class_fields -- Current might have been changed; synchronize
					l_meth := ce_string ("GET")
					if l_head_only then
						l_meth := ce_string ("HEAD")
					elseif (not ((create {P_OPTIONS_STATIC}).opt.item.item.post_file_name).is_void) then
						l_meth := ce_string ("POST")
					elseif (not ((create {P_OPTIONS_STATIC}).opt.item.item.post_data).is_void) then
						l_meth := ce_string ("POST")
					end
					if (not a_proxy.is_void) then
						l_meth_arg := (create {P_XMALLOC_STATIC}).xstrdup (url)
						update_class_fields -- Current might have been changed; synchronize
					else
						l_meth_arg := ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.url_full_path
						update_class_fields -- Current might have been changed; synchronize
					end
					request_set_method (l_req, l_meth, l_meth_arg)
					update_class_fields -- Current might have been changed; synchronize
					request_set_header (l_req, ce_string ("Referer"), a_hs.item.referer, {PC_RP}.rel_none)
					update_class_fields -- Current might have been changed; synchronize
					if ((a_dt.item).bit_and (8)).to_boolean then
						request_set_header (l_req, ce_string ("Pragma"), ce_string ("no-cache"), {PC_RP}.rel_none)
						update_class_fields -- Current might have been changed; synchronize
					end
					if (a_hs.item.restval).to_boolean then
						l_tmp___0 := (create {P_UTILS_STATIC}).number_to_static_string (a_hs.item.restval)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := (create {P_UTILS_STATIC}).aprintf ([ce_string ("bytes=%%s-"), l_tmp___0])
						update_class_fields -- Current might have been changed; synchronize
						request_set_header (l_req, ce_string ("Range"), l_tmp___1, {PC_RP}.rel_value)
						update_class_fields -- Current might have been changed; synchronize
					end
					from
					until
						(l_break)
					loop
						l_break := False
						if ((create {P_OPTIONS_STATIC}).opt.item.item.useragent).is_void then
							l_tmp___2 := (create {P_UTILS_STATIC}).aprintf ([ce_string ("Wget/%%s (%%s)"), (create {P_VERSION_STATIC}).version_string.item, ce_string ("linux-gnu")])
							update_class_fields -- Current might have been changed; synchronize
							request_set_header (l_req, ce_string ("User-Agent"), l_tmp___2, {PC_RP}.rel_value)
							update_class_fields -- Current might have been changed; synchronize
						elseif (((create {P_OPTIONS_STATIC}).opt.item.item.useragent).item).to_boolean then
							request_set_header (l_req, ce_string ("User-Agent"), (create {P_OPTIONS_STATIC}).opt.item.item.useragent, {PC_RP}.rel_none)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_break := True
					end
					l_break := False
					request_set_header (l_req, ce_string ("Accept"), ce_string ("*/*"), {PC_RP}.rel_none)
					update_class_fields -- Current might have been changed; synchronize
					l_user.item := user
					update_class_fields -- Current might have been changed; synchronize
					l_passwd.item := passwd
					update_class_fields -- Current might have been changed; synchronize
					search_netrc (host, l_user, l_passwd, 0)
					update_class_fields -- Current might have been changed; synchronize
					if (not (l_user.item).is_void) then
						l_user.item := l_user.item
						update_class_fields -- Current might have been changed; synchronize
					else
						if (not ((create {P_OPTIONS_STATIC}).opt.item.item.http_user).is_void) then
							l_tmp___3 := (create {P_OPTIONS_STATIC}).opt.item.item.http_user
						else
							l_tmp___3 := (create {P_OPTIONS_STATIC}).opt.item.item.user
						end
						l_user.item := l_tmp___3
						update_class_fields -- Current might have been changed; synchronize
					end
					if (not (l_passwd.item).is_void) then
						l_passwd.item := l_passwd.item
						update_class_fields -- Current might have been changed; synchronize
					else
						if (not ((create {P_OPTIONS_STATIC}).opt.item.item.http_passwd).is_void) then
							l_tmp___4 := (create {P_OPTIONS_STATIC}).opt.item.item.http_passwd
						else
							l_tmp___4 := (create {P_OPTIONS_STATIC}).opt.item.item.passwd
						end
						l_passwd.item := l_tmp___4
						update_class_fields -- Current might have been changed; synchronize
					end
					if (not (l_user.item).is_void) then
						if (not (l_passwd.item).is_void) then
							if user.is_void then
								l_basic_auth_finished := maybe_send_basic_creds (host, l_user.item, l_passwd.item, l_req)
								update_class_fields -- Current might have been changed; synchronize
							elseif (create {P_OPTIONS_STATIC}).opt.item.item.auth_without_challenge then
								l_basic_auth_finished := maybe_send_basic_creds (host, l_user.item, l_passwd.item, l_req)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
					l_tmp___5 := (create {P_URL_STATIC}).scheme_default_port (scheme)
					update_class_fields -- Current might have been changed; synchronize
					l_add_port := (port /= l_tmp___5).to_integer
					l_tmp___6 := strchr (host, (':').code)
					update_class_fields -- Current might have been changed; synchronize
					l_add_squares := (not l_tmp___6.is_void).to_integer
					l_tmp___7 := (create {P_UTILS_STATIC}).aprintf ([(hfmt.item[l_add_port])[l_add_squares], host, port])
					update_class_fields -- Current might have been changed; synchronize
					request_set_header (l_req, ce_string ("Host"), l_tmp___7, {PC_RP}.rel_value)
					update_class_fields -- Current might have been changed; synchronize
					if not l_inhibit_keep_alive then
						request_set_header (l_req, ce_string ("Connection"), ce_string ("Keep-Alive"), {PC_RP}.rel_none)
						update_class_fields -- Current might have been changed; synchronize
					end
					if (create {P_OPTIONS_STATIC}).opt.item.item.cookies then
						l_tmp___8 := ((create {P_HTTP_STATIC}).wget_cookie_jar.item).item.cookie_header (host, port, path, (0).to_boolean)
						update_class_fields -- Current might have been changed; synchronize
						request_set_header (l_req, ce_string ("Cookie"), l_tmp___8, {PC_RP}.rel_value)
						update_class_fields -- Current might have been changed; synchronize
					end
					if ((create {P_OPTIONS_STATIC}).opt.item.item.post_data).is_void then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if ((create {P_OPTIONS_STATIC}).opt.item.item.post_file_name).is_void then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						request_set_header (l_req, ce_string ("Content-Type"), ce_string ("application/x-www-form-urlencoded"), {PC_RP}.rel_none)
						update_class_fields -- Current might have been changed; synchronize
						if (not ((create {P_OPTIONS_STATIC}).opt.item.item.post_data).is_void) then
							l_tmp___9 := strlen ((create {P_OPTIONS_STATIC}).opt.item.item.post_data)
							update_class_fields -- Current might have been changed; synchronize
							l_post_data_size := l_tmp___9.to_integer_64
						else
							l_post_data_size := file_size ((create {P_OPTIONS_STATIC}).opt.item.item.post_file_name)
							update_class_fields -- Current might have been changed; synchronize
							if l_post_data_size = -{INTEGER_64} 1 then
								l_tmp___10 := errno_location
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___11 := strerror (l_tmp___10.item)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___12 := (create {P_QUOTE_STATIC}).quote ((create {P_OPTIONS_STATIC}).opt.item.item.post_file_name)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___13 := gettext (ce_string ("POST data file %%s missing: %%s%N"))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___13, l_tmp___12, l_tmp___11])
								update_class_fields -- Current might have been changed; synchronize
								l_post_data_size := (0).to_integer_64
							end
						end
						l_tmp___14 := (create {P_UTILS_STATIC}).number_to_static_string (l_post_data_size)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___15 := (create {P_XMALLOC_STATIC}).xstrdup (l_tmp___14)
						update_class_fields -- Current might have been changed; synchronize
						request_set_header (l_req, ce_string ("Content-Length"), l_tmp___15, {PC_RP}.rel_value)
						update_class_fields -- Current might have been changed; synchronize
				when 5 then -- if done
					if (not ((create {P_OPTIONS_STATIC}).opt.item.item.user_headers).is_void) then
						l_i := 0
						from
						until
							((create {P_OPTIONS_STATIC}).opt.item.item.user_headers[l_i]).is_void
						loop
							request_set_user_header (l_req, (create {P_OPTIONS_STATIC}).opt.item.item.user_headers[l_i])
							update_class_fields -- Current might have been changed; synchronize
							l_i := l_i + 1
						end
					end
				when 6 then -- retry_with_auth:
					l_proxyauth := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					if (not a_proxy.is_void) then
						if (not ((create {P_OPTIONS_STATIC}).opt.item.item.proxy_user).is_void) then
							if (not ((create {P_OPTIONS_STATIC}).opt.item.item.proxy_passwd).is_void) then
								l_proxy_user := (create {P_OPTIONS_STATIC}).opt.item.item.proxy_user
								l_proxy_passwd := (create {P_OPTIONS_STATIC}).opt.item.item.proxy_passwd
							else
								l_proxy_user := a_proxy.item.user
								l_proxy_passwd := a_proxy.item.passwd
							end
						else
							l_proxy_user := a_proxy.item.user
							l_proxy_passwd := a_proxy.item.passwd
						end
						if (not l_proxy_user.is_void) then
							if (not l_proxy_passwd.is_void) then
								l_proxyauth := basic_authentication_encode (l_proxy_user, l_proxy_passwd)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_conn := a_proxy
						request_set_header (l_req, ce_string ("Proxy-Authorization"), l_proxyauth, {PC_RP}.rel_value)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_keep_alive := (0).to_boolean
					if not l_inhibit_keep_alive then
						l_relevant := l_conn
						l_tmp___21 := persistent_available_p (l_relevant.item.host, l_relevant.item.port, (0).to_boolean, l_host_lookup_failed)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___21 then
							l_sock := (create {P_HTTP_STATIC}).pconn.item.item.socket
							l_using_ssl := (create {P_HTTP_STATIC}).pconn.item.item.ssl
							l_tmp___16 := (create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, (create {P_HTTP_STATIC}).pconn.item.item.host)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___17 := gettext (ce_string ("Reusing existing connection to %%s:%%d.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___17, l_tmp___16, (create {P_HTTP_STATIC}).pconn.item.item.port])
							update_class_fields -- Current might have been changed; synchronize
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___18 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___18.to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Reusing fd %%d.%N"), l_sock])
									update_class_fields -- Current might have been changed; synchronize
								end
								l_break := True
							end
							l_break := False
							if (create {P_HTTP_STATIC}).pconn.item.item.authorized then
								request_remove_header (l_req, ce_string ("Authorization")).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
						elseif l_host_lookup_failed.item then
							request_free (l_req)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___19 := (create {P_QUOTE_STATIC}).quote (l_relevant.item.host)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___20 := gettext (ce_string ("%%s: unable to resolve host address %%s%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___20, (create {P_WGET_STATIC}).exec_name.item, l_tmp___19])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_UERR_T}.HOSTERR)
							l_return := True
						end
					end
					if not l_return and then (l_sock < 0) then
						l_sock := connect_to_host (l_conn.item.host, l_conn.item.port)
						update_class_fields -- Current might have been changed; synchronize
						if l_sock = -100 then
							request_free (l_req)
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_UERR_T}.HOSTERR)
							l_return := True
						elseif l_sock < 0 then
							request_free (l_req)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___25 := errno_location
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___26 := retryable_socket_connect_error (l_tmp___25.item)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___26 then
								l_tmp___24 := 3
							else
								l_tmp___24 := 5
							end
							Result := l_tmp___24.to_natural_32
							l_return := True
						end
					end
					if not l_return then
						l_write_error := request_send (l_req, l_sock)
						update_class_fields -- Current might have been changed; synchronize
						if l_write_error >= 0 then
							if (not ((create {P_OPTIONS_STATIC}).opt.item.item.post_data).is_void) then
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___27 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___27.to_boolean then
										(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("[POST data: %%s]%N"), (create {P_OPTIONS_STATIC}).opt.item.item.post_data])
										update_class_fields -- Current might have been changed; synchronize
									end
									l_break := True
								end
								l_break := False
								l_write_error := fd_write (l_sock, (create {P_OPTIONS_STATIC}).opt.item.item.post_data, l_post_data_size.to_integer_32, (-1).to_double)
								update_class_fields -- Current might have been changed; synchronize
							elseif (not ((create {P_OPTIONS_STATIC}).opt.item.item.post_file_name).is_void) then
								if l_post_data_size /= {INTEGER_64} 0 then
									l_write_error := post_file (l_sock, (create {P_OPTIONS_STATIC}).opt.item.item.post_file_name, l_post_data_size)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if l_write_error < 0 then
							from
							until
								(l_break)
							loop
								l_break := False
								if pconn_active.item then
									if l_sock = (create {P_HTTP_STATIC}).pconn.item.item.socket then
										invalidate_persistent
										update_class_fields -- Current might have been changed; synchronize
									else
										(create {P_CONNECT_STATIC}).fd_close (l_sock)
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									(create {P_CONNECT_STATIC}).fd_close (l_sock)
									update_class_fields -- Current might have been changed; synchronize
								end
								l_sock := -1
								l_break := True
							end
							l_break := False
							request_free (l_req)
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_UERR_T}.WRITEFAILED)
							l_return := True
						end
					end
					if not l_return then
						if (not a_proxy.is_void) then
							l_tmp___28 := ce_string ("Proxy")
						else
							l_tmp___28 := ce_string ("HTTP")
						end
						l_tmp___29 := gettext (ce_string ("%%s request sent, awaiting response... "))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___29, l_tmp___28])
						update_class_fields -- Current might have been changed; synchronize
						l_contlen := (-1).to_integer_64
						l_contrange := (0).to_integer_64
						a_dt.item := (a_dt.item).bit_and ((-3))
						update_class_fields -- Current might have been changed; synchronize
						l_head := read_http_response_head (l_sock)
						update_class_fields -- Current might have been changed; synchronize
						if l_head.is_void then
							l_tmp___33 := errno_location
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___33.item = 0 then
								l_tmp___30 := gettext (ce_string ("No data received.%N"))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___30)
								update_class_fields -- Current might have been changed; synchronize
								from
								until
									(l_break)
								loop
									l_break := False
									if pconn_active.item then
										if l_sock = (create {P_HTTP_STATIC}).pconn.item.item.socket then
											invalidate_persistent
											update_class_fields -- Current might have been changed; synchronize
										else
											(create {P_CONNECT_STATIC}).fd_close (l_sock)
											update_class_fields -- Current might have been changed; synchronize
										end
									else
										(create {P_CONNECT_STATIC}).fd_close (l_sock)
										update_class_fields -- Current might have been changed; synchronize
									end
									l_sock := -1
									l_break := True
								end
								l_break := False
								request_free (l_req)
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_UERR_T}.HEOF)
								l_return := True
							else
								l_tmp___31 := fd_errstr (l_sock)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___32 := gettext (ce_string ("Read error (%%s) in headers.%N"))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___32, l_tmp___31])
								update_class_fields -- Current might have been changed; synchronize
								from
								until
									(l_break)
								loop
									l_break := False
									if pconn_active.item then
										if l_sock = (create {P_HTTP_STATIC}).pconn.item.item.socket then
											invalidate_persistent
											update_class_fields -- Current might have been changed; synchronize
										else
											(create {P_CONNECT_STATIC}).fd_close (l_sock)
											update_class_fields -- Current might have been changed; synchronize
										end
									else
										(create {P_CONNECT_STATIC}).fd_close (l_sock)
										update_class_fields -- Current might have been changed; synchronize
									end
									l_sock := -1
									l_break := True
								end
								l_break := False
								request_free (l_req)
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_UERR_T}.HERR)
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 38 -- skip if block
					end
				when 7 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___34 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___34.to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%N---response begin---%N%%s---response end---%N"), l_head])
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
						l_resp := resp_new (l_head)
						update_class_fields -- Current might have been changed; synchronize
						l_message.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_statcode := resp_status (l_resp, l_message)
						update_class_fields -- Current might have been changed; synchronize
						a_hs.item.message := (create {P_XMALLOC_STATIC}).xstrdup (l_message.item)
						update_class_fields -- Current might have been changed; synchronize
						if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
							if (not (l_message.item).is_void) then
								l_tmp___35 := (create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_message.item)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___36 := l_tmp___35
							else
								l_tmp___36 := ce_string ("")
							end
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%%2d %%s%N"), l_statcode, l_tmp___36])
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N")])
							update_class_fields -- Current might have been changed; synchronize
							l_resp.item.print_server_response (ce_string ("  "))
							update_class_fields -- Current might have been changed; synchronize
						end
						if (create {P_OPTIONS_STATIC}).opt.item.item.ignore_length then
							l_pos := -1 + 13 -- skip if block
						end
				when 8 then -- if:
						l_tmp___39 := resp_header_copy (l_resp, ce_string ("Content-Length"), l_hdrval, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___39 then
							l_pos := -1 + 13 -- skip if block
						end
				when 9 then -- if:
						l_tmp___37 := errno_location
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___37.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_parsed := strtoll (l_hdrval, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10)
						update_class_fields -- Current might have been changed; synchronize
						if l_parsed /= (((-{INTEGER_64} 1).bit_shift_left (({PLATFORM}.Integer_64_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1).to_integer_32))).bit_not then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_tmp___38 := errno_location
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___38.item = 34 then
							l_contlen := (-1).to_integer_64
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						if l_parsed < {INTEGER_64} 0 then
							l_contlen := (-1).to_integer_64
						else
							l_contlen := l_parsed
						end
				when 13 then -- if done | if done
						if not l_inhibit_keep_alive then
							if l_contlen /= -{INTEGER_64} 1 then
								l_tmp___42 := resp_header_copy (l_resp, ce_string ("Keep-Alive"), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), 0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___42 then
									l_keep_alive := (1).to_boolean
								else
									l_tmp___41 := resp_header_copy (l_resp, ce_string ("Connection"), l_hdrval, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___41 then
										l_tmp___40 := strcasecmp (l_hdrval, ce_string ("Keep-Alive"))
										update_class_fields -- Current might have been changed; synchronize
										if 0 = l_tmp___40 then
											l_keep_alive := (1).to_boolean
										end
									end
								end
							end
						end
						if (create {P_OPTIONS_STATIC}).opt.item.item.cookies then
							if ((create {P_HTTP_STATIC}).wget_cookie_jar.item).is_void then
								assert_fail (ce_string ("wget_cookie_jar != ((void *)0)"), ce_string ("http.c"), {NATURAL_32} 1_885, ce_string ("gethttp"))
								update_class_fields -- Current might have been changed; synchronize
							end
							l_scpos := 0
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_scpos := resp_header_locate (l_resp, ce_string ("Set-Cookie"), l_scpos, l_scbeg, l_scend)
								update_class_fields -- Current might have been changed; synchronize
								if l_scpos = -1 then
									l_break := True
								end
								if not (l_return or l_break) then
									from
									until
										(l_break)
									loop
										l_break := False
										l_BTA_beg := l_scbeg.item
										l_BTA_len := (l_scend.item).distance (l_BTA_beg)
										l_BTA_dest := l_set_cookie
										l_BTA_dest.item := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new ((l_BTA_len + 1).to_natural_32)))
										update_class_fields -- Current might have been changed; synchronize
										memcpy (create {CE_VOID_POINTER}.make_cast (l_BTA_dest.item), create {CE_VOID_POINTER}.make_cast (l_BTA_beg), l_BTA_len.to_natural_32).do_nothing
										update_class_fields -- Current might have been changed; synchronize
										l_BTA_dest.item[l_BTA_len] := (('%/0/').code).to_integer_8
										update_class_fields -- Current might have been changed; synchronize
										l_break := True
									end
									l_break := False
									cookie_handle_set_cookie ((create {P_HTTP_STATIC}).wget_cookie_jar.item, host, port, path, l_set_cookie.item)
									update_class_fields -- Current might have been changed; synchronize
									l_scpos := l_scpos + 1
								end
							end
							l_break := False
						end
						if l_keep_alive then
							register_persistent (l_conn.item.host, l_conn.item.port, l_sock, l_using_ssl)
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_statcode /= 401 then
							l_pos := -1 + 37 -- skip if block
						end
				when 14 then -- if:
						if not l_keep_alive then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if not l_head_only then
							l_tmp___44 := skip_short_body (l_sock, l_contlen)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___44 then
								from
								until
									(l_break)
								loop
									l_break := False
									if not l_keep_alive then
										if pconn_active.item then
											if l_sock = (create {P_HTTP_STATIC}).pconn.item.item.socket then
												invalidate_persistent
												update_class_fields -- Current might have been changed; synchronize
											else
												(create {P_CONNECT_STATIC}).fd_close (l_sock)
												update_class_fields -- Current might have been changed; synchronize
												l_sock := -1
											end
										else
											(create {P_CONNECT_STATIC}).fd_close (l_sock)
											update_class_fields -- Current might have been changed; synchronize
											l_sock := -1
										end
									end
									l_break := True
								end
								l_break := False
							else
								l_pos := -1 + 17 -- goto _L___2
							end
						else
							l_pos := -1 + 17 -- goto _L___2
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L___2:
						from
						until
							(l_break)
						loop
							l_break := False
							if pconn_active.item then
								if l_sock = (create {P_HTTP_STATIC}).pconn.item.item.socket then
									invalidate_persistent
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_CONNECT_STATIC}).fd_close (l_sock)
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								(create {P_CONNECT_STATIC}).fd_close (l_sock)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_sock := -1
							l_break := True
						end
						l_break := False
				when 18 then;
						(create {P_HTTP_STATIC}).pconn.item.item.authorized := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						if l_auth_finished.item then
							l_pos := -1 + 35 -- skip if block
						end
				when 19 then -- if:
						if (l_user.item).is_void then
							l_pos := -1 + 35 -- skip if block
						end
				when 20 then -- if:
						if (l_passwd.item).is_void then
							l_pos := -1 + 35 -- skip if block
						end
				when 21 then -- if:
						l_www_authenticate.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_wapos := 0
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_wapos := resp_header_locate (l_resp, ce_string ("WWW-Authenticate"), l_wapos, l_wabeg, l_waend)
							update_class_fields -- Current might have been changed; synchronize
							if l_wapos = -1 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_tmp___46 := known_authentication_scheme_p (l_wabeg.item, l_waend.item)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___46 then
									from
									until
										(l_break)
									loop
										l_break := False
										l_BTA_beg___0 := l_wabeg.item
										l_BTA_len___0 := (l_waend.item).distance (l_BTA_beg___0)
										l_BTA_dest___0 := l_www_authenticate
										l_BTA_dest___0.item := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new ((l_BTA_len___0 + 1).to_natural_32)))
										update_class_fields -- Current might have been changed; synchronize
										memcpy (create {CE_VOID_POINTER}.make_cast (l_BTA_dest___0.item), create {CE_VOID_POINTER}.make_cast (l_BTA_beg___0), l_BTA_len___0.to_natural_32).do_nothing
										update_class_fields -- Current might have been changed; synchronize
										l_BTA_dest___0.item[l_BTA_len___0] := (('%/0/').code).to_integer_8
										update_class_fields -- Current might have been changed; synchronize
										l_break := True
									end
									l_break := False
									l_break := True
								end
							end
							if not (l_return or l_break) then
								l_wapos := l_wapos + 1
							end
						end
						l_break := False
						if (not (l_www_authenticate.item).is_void) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_tmp___47 := gettext (ce_string ("Unknown authentication scheme.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___47)
						update_class_fields -- Current might have been changed; synchronize
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 24 then -- else:
						if l_basic_auth_finished then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L___5
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 27 then -- else:
						l_tmp___54 := strncasecmp (l_www_authenticate.item, ce_string ("Basic"), (("Basic").count + 1).to_natural_32 - {NATURAL_32} 1)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___54.to_boolean) then
							l_pos := -1 + 34 -- skip if block
						end
				when 28 then -- if: | _L___5:
						l_pth := ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.url_full_path
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___48 := request_method (l_req)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___49 := create_authorization_line (l_www_authenticate.item, l_user.item, l_passwd.item, l_tmp___48, l_pth, l_auth_finished)
						update_class_fields -- Current might have been changed; synchronize
						request_set_header (l_req, ce_string ("Authorization"), l_tmp___49, {PC_RP}.rel_value)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___52 := strncasecmp (l_www_authenticate.item, ce_string ("NTLM"), (("NTLM").count + 1).to_natural_32 - {NATURAL_32} 1)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___52.to_boolean) then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if: | _L___3:
						if user.is_void then
							l_tmp___50 := strncasecmp (l_www_authenticate.item, ce_string ("Basic"), (("Basic").count + 1).to_natural_32 - {NATURAL_32} 1)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___50.to_boolean then
								l_tmp___51 := (create {P_C_CTYPE_STATIC}).c2_isspace ((l_www_authenticate.item[((("Basic").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32]).to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___51 then
									register_basic_auth_host (host)
									update_class_fields -- Current might have been changed; synchronize
								elseif not (l_www_authenticate.item[((("Basic").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32]).to_boolean then
									register_basic_auth_host (host)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else:
						l_tmp___53 := (create {P_C_CTYPE_STATIC}).c2_isspace ((l_www_authenticate.item[((("NTLM").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32]).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___53 then
							l_ntlm_seen := (1).to_boolean
						elseif not (l_www_authenticate.item[((("NTLM").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32]).to_boolean then
							l_ntlm_seen := (1).to_boolean
						else
							l_pos := -1 + 29 -- goto _L___3
						end
				when 32 then
						free (create {CE_VOID_POINTER}.make_cast (l_pth))
						update_class_fields -- Current might have been changed; synchronize
						if (not (l_message.item).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_message.item))
							update_class_fields -- Current might have been changed; synchronize
						end
						resp_free (l_resp)
						update_class_fields -- Current might have been changed; synchronize
						free (create {CE_VOID_POINTER}.make_cast (l_head))
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 6 -- goto retry_with_auth
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else:
						l_tmp___55 := (create {P_C_CTYPE_STATIC}).c2_isspace ((l_www_authenticate.item[((("Basic").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32]).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___55 then
							if (l_www_authenticate.item[((("Basic").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32]).to_boolean then
								l_pos := -1 + 28 -- goto _L___5
							end
						end
				when 35 then -- if done | if done | if done | if done | if done
						l_tmp___56 := gettext (ce_string ("Authorization failed.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___56)
						update_class_fields -- Current might have been changed; synchronize
						request_free (l_req)
						update_class_fields -- Current might have been changed; synchronize
						if (not (l_message.item).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_message.item))
							update_class_fields -- Current might have been changed; synchronize
						end
						resp_free (l_resp)
						update_class_fields -- Current might have been changed; synchronize
						free (create {CE_VOID_POINTER}.make_cast (l_head))
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_UERR_T}.AUTHFAILED)
						l_return := True
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else:
						if l_ntlm_seen then
							(create {P_HTTP_STATIC}).pconn.item.item.authorized := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
				when 38 then -- if done | if done
					if l_return then
						l_pos := -1 + 45 -- skip if block
					end
				when 39 then -- if:
						if (a_hs.item.local_file).is_void then
							if not (create {P_OPTIONS_STATIC}).opt.item.item.content_disposition then
								a_hs.item.local_file := ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.url_file_name
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___57 := resp_header_copy (l_resp, ce_string ("Content-Disposition"), l_hdrval, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32).to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___57 then
									l_tmp___58 := parse_content_disposition (l_hdrval, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (a_hs.c_pointer + (create {PD_HTTP_STAT}.make).offset_of ("local_file")))
									update_class_fields -- Current might have been changed; synchronize
									if not l_tmp___58 then
										a_hs.item.local_file := ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.url_file_name
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									a_hs.item.local_file := ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.url_file_name
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if a_hs.item.existence_checked then
							l_pos := -1 + 45 -- skip if block
						end
				when 40 then -- if:
						l_tmp___63 := (create {P_UTILS_STATIC}).file_exists_p (a_hs.item.local_file)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___63 then
							l_pos := -1 + 45 -- skip if block
						end
				when 41 then -- if:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.noclobber) then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						if ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void then
							l_tmp___59 := (create {P_QUOTE_STATIC}).quote (a_hs.item.local_file)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___60 := gettext (ce_string ("File %%s already there; not retrieving.%N%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___60, l_tmp___59])
							update_class_fields -- Current might have been changed; synchronize
							a_dt.item := (a_dt.item).bit_or ((2))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___61 := (create {P_UTILS_STATIC}).has_html_suffix_p (a_hs.item.local_file)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___61 then
								a_dt.item := (a_dt.item).bit_or ((1))
								update_class_fields -- Current might have been changed; synchronize
							end
							free (create {CE_VOID_POINTER}.make_cast (l_head))
							update_class_fields -- Current might have been changed; synchronize
							if (not (l_message.item).is_void) then
								free (create {CE_VOID_POINTER}.make_cast (l_message.item))
								update_class_fields -- Current might have been changed; synchronize
							end
							Result := ({PC_UERR_T}.RETRUNNEEDED)
							l_return := True
						else
							l_pos := -1 + 44 -- goto _L___6
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else: | _L___6:
						if not (create {P_OPTIONS_STATIC}).opt.item.item.noclobber then
							if not (create {P_OPTIONS_STATIC}).opt.item.item.always_rest then
								if not (create {P_OPTIONS_STATIC}).opt.item.item.timestamping then
									if not (create {P_OPTIONS_STATIC}).opt.item.item.dirstruct then
										if ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void then
											l_tmp___62 := (create {P_UTILS_STATIC}).unique_name (a_hs.item.local_file, (1).to_boolean)
											update_class_fields -- Current might have been changed; synchronize
											l_unique := l_tmp___62
											if not l_unique.is_equal (a_hs.item.local_file) then
												free (create {CE_VOID_POINTER}.make_cast (a_hs.item.local_file))
												update_class_fields -- Current might have been changed; synchronize
											end
											a_hs.item.local_file := l_unique
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								end
							end
						end
				when 45 then -- if done | if done | if done
					if l_return then
						l_pos := -1 + 67 -- skip if block
					end
				when 46 then -- if:
						a_hs.item.existence_checked := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						if (create {P_OPTIONS_STATIC}).opt.item.item.timestamping then
							if not a_hs.item.timestamp_checked then
								l_tmp___64 := strlen (a_hs.item.local_file)
								update_class_fields -- Current might have been changed; synchronize
								l_filename_len := l_tmp___64
								l_filename_plus_orig_suffix := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new (l_filename_len + ((".orig").count + 1).to_natural_32)))
								l_local_dot_orig_file_exists := (0).to_boolean
								l_local_filename := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								if (create {P_OPTIONS_STATIC}).opt.item.item.backup_converted then
									memcpy (create {CE_VOID_POINTER}.make_cast (l_filename_plus_orig_suffix), create {CE_VOID_POINTER}.make_cast (a_hs.item.local_file), l_filename_len).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									memcpy (create {CE_VOID_POINTER}.make_cast ((l_filename_plus_orig_suffix + l_filename_len.to_integer_32)), create {CE_VOID_POINTER}.make_cast (ce_string (".orig")), ((".orig").count + 1).to_natural_32).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___66 := stat (l_filename_plus_orig_suffix, l_st)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___66 = 0 then
										l_local_dot_orig_file_exists := (1).to_boolean
										l_local_filename := l_filename_plus_orig_suffix
									end
								end
								if not l_local_dot_orig_file_exists then
									l_tmp___67 := stat (a_hs.item.local_file, l_st)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___67 = 0 then
										l_local_filename := a_hs.item.local_file
									end
								end
								if not l_local_filename.is_void then
									a_hs.item.orig_file_name := (create {P_XMALLOC_STATIC}).xstrdup (l_local_filename)
									update_class_fields -- Current might have been changed; synchronize
									a_hs.item.orig_file_size := (l_st.item.st_size).to_integer_64
									update_class_fields -- Current might have been changed; synchronize
									a_hs.item.orig_file_tstamp := l_st.item.st_mtim.tv_sec
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						request_free (l_req)
						update_class_fields -- Current might have been changed; synchronize
						a_hs.item.statcode := l_statcode
						update_class_fields -- Current might have been changed; synchronize
						if l_statcode = -1 then
							l_tmp___68 := gettext (ce_string ("Malformed status line"))
							update_class_fields -- Current might have been changed; synchronize
							a_hs.item.error := (create {P_XMALLOC_STATIC}).xstrdup (l_tmp___68)
							update_class_fields -- Current might have been changed; synchronize
						elseif not (l_message.item[0]).to_boolean then
							l_tmp___69 := gettext (ce_string ("(no description)"))
							update_class_fields -- Current might have been changed; synchronize
							a_hs.item.error := (create {P_XMALLOC_STATIC}).xstrdup (l_tmp___69)
							update_class_fields -- Current might have been changed; synchronize
						else
							a_hs.item.error := (create {P_XMALLOC_STATIC}).xstrdup (l_message.item)
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not (l_message.item).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_message.item))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_type := resp_header_strdup (l_resp, ce_string ("Content-Type"))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_type.is_void) then
							l_tmp___71 := strchr (l_type, (';').code)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___70 := l_tmp___71
							if (not l_tmp___70.is_void) then
								l_tmp2 := l_tmp___70 + 1
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_tmp___70.c_pointer.to_integer_32).to_natural_32 > (l_type.c_pointer.to_integer_32).to_natural_32 then
										l_tmp___72 := (create {P_C_CTYPE_STATIC}).c2_isspace ((l_tmp___70[-1]).to_integer_32)
										update_class_fields -- Current might have been changed; synchronize
										if not l_tmp___72 then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_return or l_break) then
										l_tmp___70 := l_tmp___70 - 1
									end
								end
								l_break := False
								l_tmp___70[0] := (('%/0/').code).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								if (create {P_OPTIONS_STATIC}).opt.item.item.enable_iri then
									if ((create {P_OPTIONS_STATIC}).opt.item.item.encoding_remote).is_void then
										l_tmp___70 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									end
								end
							end
						end
						a_hs.item.newloc := resp_header_strdup (l_resp, ce_string ("Location"))
						update_class_fields -- Current might have been changed; synchronize
						a_hs.item.remote_time := resp_header_strdup (l_resp, ce_string ("Last-Modified"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___74 := resp_header_copy (l_resp, ce_string ("Content-Range"), l_hdrval, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___74 then
							l_tmp___73 := parse_content_range (l_hdrval, l_first_byte_pos, l_last_byte_pos, l_entity_length)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___73 then
								l_contrange := l_first_byte_pos.item
								l_contlen := (l_last_byte_pos.item - l_first_byte_pos.item) + {INTEGER_64} 1
							end
						end
						resp_free (l_resp)
						update_class_fields -- Current might have been changed; synchronize
						if l_statcode >= 200 then
							if l_statcode < 300 then
								a_dt.item := (a_dt.item).bit_or ((2))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if l_statcode /= 301 then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						l_pos := -1 + 59 -- goto _L___10
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 49 then -- else:
						if l_statcode /= 302 then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:
						l_pos := -1 + 59 -- goto _L___10
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 52 then -- else:
						if l_statcode /= 303 then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:
						l_pos := -1 + 59 -- goto _L___10
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 55 then -- else:
						if l_statcode /= 307 then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						l_pos := -1 + 59 -- goto _L___10
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 58 then -- else:
						if l_statcode /= 300 then
							l_pos := -1 + 67 -- skip if block
						end
				when 59 then -- if: | _L___10:
						if l_statcode /= 300 then
							l_pos := -1 + 62 -- skip if block
						end
				when 60 then -- if:
						if (a_hs.item.newloc).is_void then
							a_dt.item := (a_dt.item).bit_or ((2))
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 62 -- goto _L___9
						end
				when 61 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 62 then -- else: | _L___9:
						if (not (a_hs.item.newloc).is_void) then
							l_tmp___75 := gettext (ce_string (" [following]"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___76 := l_tmp___75
						else
							l_tmp___76 := ce_string ("")
						end
						if (not (a_hs.item.newloc).is_void) then
							l_tmp___77 := (create {P_LOG_STATIC}).escnonprint_uri (a_hs.item.newloc)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___79 := l_tmp___77
						else
							l_tmp___78 := gettext (ce_string ("unspecified"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___79 := l_tmp___78
						end
						l_tmp___80 := gettext (ce_string ("Location: %%s%%s%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___80, l_tmp___79, l_tmp___76])
						update_class_fields -- Current might have been changed; synchronize
						if not l_keep_alive then
							l_pos := -1 + 65 -- skip if block
						end
				when 63 then -- if:
						if not l_head_only then
							l_tmp___81 := skip_short_body (l_sock, l_contlen)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___81 then
								from
								until
									(l_break)
								loop
									l_break := False
									if not l_keep_alive then
										if pconn_active.item then
											if l_sock = (create {P_HTTP_STATIC}).pconn.item.item.socket then
												invalidate_persistent
												update_class_fields -- Current might have been changed; synchronize
											else
												(create {P_CONNECT_STATIC}).fd_close (l_sock)
												update_class_fields -- Current might have been changed; synchronize
												l_sock := -1
											end
										else
											(create {P_CONNECT_STATIC}).fd_close (l_sock)
											update_class_fields -- Current might have been changed; synchronize
											l_sock := -1
										end
									end
									l_break := True
								end
								l_break := False
							else
								l_pos := -1 + 65 -- goto _L___8
							end
						else
							l_pos := -1 + 65 -- goto _L___8
						end
				when 64 then -- if block done, skip else block:
						l_pos := -1 + 66
				when 65 then -- else: | _L___8:
						from
						until
							(l_break)
						loop
							l_break := False
							if pconn_active.item then
								if l_sock = (create {P_HTTP_STATIC}).pconn.item.item.socket then
									invalidate_persistent
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_CONNECT_STATIC}).fd_close (l_sock)
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								(create {P_CONNECT_STATIC}).fd_close (l_sock)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_sock := -1
							l_break := True
						end
						l_break := False
				when 66 then
						if (not l_type.is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_type))
							update_class_fields -- Current might have been changed; synchronize
						end
						free (create {CE_VOID_POINTER}.make_cast (l_head))
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_UERR_T}.NEWLOCATION)
						l_return := True
				when 67 then -- if done | if done | if done | if done | if done | if done
					if l_return then
						l_pos := -1 + 76 -- skip if block
					end
				when 68 then -- if:
						if l_type.is_void then
							a_dt.item := (a_dt.item).bit_or ((1))
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___82 := strlen (ce_string ("text/html"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___83 := strncasecmp (l_type, ce_string ("text/html"), l_tmp___82)
							update_class_fields -- Current might have been changed; synchronize
							if 0 = l_tmp___83 then
								a_dt.item := (a_dt.item).bit_or ((1))
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___84 := strlen (ce_string ("application/xhtml+xml"))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___85 := strncasecmp (l_type, ce_string ("application/xhtml+xml"), l_tmp___84)
								update_class_fields -- Current might have been changed; synchronize
								if 0 = l_tmp___85 then
									a_dt.item := (a_dt.item).bit_or ((1))
									update_class_fields -- Current might have been changed; synchronize
								else
									a_dt.item := (a_dt.item).bit_and ((-2))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if (not l_type.is_void) then
							l_tmp___86 := strlen (ce_string ("text/css"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___87 := strncasecmp (l_type, ce_string ("text/css"), l_tmp___86)
							update_class_fields -- Current might have been changed; synchronize
							if 0 = l_tmp___87 then
								a_dt.item := (a_dt.item).bit_or ((64))
								update_class_fields -- Current might have been changed; synchronize
							else
								a_dt.item := (a_dt.item).bit_and ((-65))
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							a_dt.item := (a_dt.item).bit_and ((-65))
							update_class_fields -- Current might have been changed; synchronize
						end
						if (create {P_OPTIONS_STATIC}).opt.item.item.adjust_extension then
							if ((a_dt.item).bit_and (1)).to_boolean then
								ensure_extension (a_hs, ce_string (".html"), a_dt)
								update_class_fields -- Current might have been changed; synchronize
							elseif ((a_dt.item).bit_and (64)).to_boolean then
								ensure_extension (a_hs, ce_string (".css"), a_dt)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if l_statcode /= 416 then
							l_pos := -1 + 71 -- skip if block
						end
				when 69 then -- if:
						l_pos := -1 + 75 -- goto _L___11
				when 70 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 71 then -- else:
						if not (a_hs.item.restval > {INTEGER_64} 0) then
							l_pos := -1 + 76 -- skip if block
						end
				when 72 then -- if:
						if l_statcode /= 200 then
							l_pos := -1 + 76 -- skip if block
						end
				when 73 then -- if:
						if l_contrange /= {INTEGER_64} 0 then
							l_pos := -1 + 76 -- skip if block
						end
				when 74 then -- if:
						if not (a_hs.item.restval >= l_contlen) then
							l_pos := -1 + 76 -- skip if block
						end
				when 75 then -- if: | _L___11:
						l_tmp___88 := gettext (ce_string ("%N    The file is already fully retrieved; nothing to do.%N%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___88)
						update_class_fields -- Current might have been changed; synchronize
						a_hs.item.len := l_contlen
						update_class_fields -- Current might have been changed; synchronize
						a_hs.item.res := 0
						update_class_fields -- Current might have been changed; synchronize
						a_dt.item := (a_dt.item).bit_or ((2))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_type.is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_type))
							update_class_fields -- Current might have been changed; synchronize
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if pconn_active.item then
								if l_sock = (create {P_HTTP_STATIC}).pconn.item.item.socket then
									invalidate_persistent
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_CONNECT_STATIC}).fd_close (l_sock)
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								(create {P_CONNECT_STATIC}).fd_close (l_sock)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_sock := -1
							l_break := True
						end
						l_break := False
						free (create {CE_VOID_POINTER}.make_cast (l_head))
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_UERR_T}.RETRUNNEEDED)
						l_return := True
				when 76 then -- if done | if done | if done | if done | if done
					if l_return then
						l_pos := -1 + 83 -- skip if block
					end
				when 77 then -- if:
						if l_contrange = {INTEGER_64} 0 then
							l_pos := -1 + 80 -- skip if block
						end
				when 78 then -- if:
						if l_contrange /= a_hs.item.restval then
							l_pos := -1 + 82 -- goto _L___12
						else
							l_pos := -1 + 80 -- goto _L___13
						end
				when 79 then -- if block done, skip else block:
						l_pos := -1 + 83
				when 80 then -- else: | _L___13:
						if l_statcode /= 206 then
							l_pos := -1 + 83 -- skip if block
						end
				when 81 then -- if:
						if l_contrange.to_boolean then
							l_pos := -1 + 83 -- skip if block
						end
				when 82 then -- if: | _L___12:
						if (not l_type.is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_type))
							update_class_fields -- Current might have been changed; synchronize
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if pconn_active.item then
								if l_sock = (create {P_HTTP_STATIC}).pconn.item.item.socket then
									invalidate_persistent
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_CONNECT_STATIC}).fd_close (l_sock)
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								(create {P_CONNECT_STATIC}).fd_close (l_sock)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_sock := -1
							l_break := True
						end
						l_break := False
						free (create {CE_VOID_POINTER}.make_cast (l_head))
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_UERR_T}.RANGEERR)
						l_return := True
				when 83 then -- if done | if done | if done
					if l_return then
						l_pos := -1 + 96 -- skip if block
					end
				when 84 then -- if:
						if l_contlen = -{INTEGER_64} 1 then
							a_hs.item.contlen := (-1).to_integer_64
							update_class_fields -- Current might have been changed; synchronize
						else
							a_hs.item.contlen := l_contlen + l_contrange
							update_class_fields -- Current might have been changed; synchronize
						end
						if ((create {P_OPTIONS_STATIC}).opt.item.item.verbose).to_boolean then
							if ((a_dt.item).bit_and (2)).to_boolean then
								l_tmp___89 := gettext (ce_string ("Length: "))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___89)
								update_class_fields -- Current might have been changed; synchronize
								if l_contlen /= -{INTEGER_64} 1 then
									l_tmp___90 := (create {P_UTILS_STATIC}).number_to_static_string (l_contlen + l_contrange)
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___90)
									update_class_fields -- Current might have been changed; synchronize
									if l_contlen + l_contrange >= {INTEGER_64} 1_024 then
										l_tmp___91 := (create {P_UTILS_STATIC}).human_readable (l_contlen + l_contrange)
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (" (%%s)"), l_tmp___91])
										update_class_fields -- Current might have been changed; synchronize
									end
									if l_contrange.to_boolean then
										if l_contlen >= {INTEGER_64} 1_024 then
											l_tmp___92 := (create {P_UTILS_STATIC}).human_readable (l_contlen)
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___93 := (create {P_UTILS_STATIC}).number_to_static_string (l_contlen)
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___94 := gettext (ce_string (", %%s (%%s) remaining"))
											update_class_fields; -- Current might have been changed; synchronize
											(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___94, l_tmp___93, l_tmp___92])
											update_class_fields -- Current might have been changed; synchronize
										else
											l_tmp___95 := (create {P_UTILS_STATIC}).number_to_static_string (l_contlen)
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___96 := gettext (ce_string (", %%s remaining"))
											update_class_fields; -- Current might have been changed; synchronize
											(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___96, l_tmp___95])
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								else
									if (create {P_OPTIONS_STATIC}).opt.item.item.ignore_length then
										l_tmp___97 := gettext (ce_string ("ignored"))
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___99 := l_tmp___97
									else
										l_tmp___98 := gettext (ce_string ("unspecified"))
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___99 := l_tmp___98
									end
									(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___99)
									update_class_fields -- Current might have been changed; synchronize
								end
								if (not l_type.is_void) then
									l_tmp___100 := (create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_type)
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (" [%%s]%N"), l_tmp___100])
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if (not l_type.is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_type))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_type := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						if ((a_dt.item).bit_and (2)).to_boolean then
							l_pos := -1 + 87 -- skip if block
						end
				when 85 then -- if:
						l_pos := -1 + 88 -- goto _L___15
				when 86 then -- if block done, skip else block:
						l_pos := -1 + 96
				when 87 then -- else:
						if not l_head_only then
							l_pos := -1 + 96 -- skip if block
						end
				when 88 then -- if: | _L___15:
						a_hs.item.len := (0).to_integer_64
						update_class_fields -- Current might have been changed; synchronize
						a_hs.item.res := 0
						update_class_fields -- Current might have been changed; synchronize
						if (not l_type.is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_type))
							update_class_fields -- Current might have been changed; synchronize
						end
						if not l_head_only then
							l_pos := -1 + 91 -- skip if block
						end
				when 89 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							if not l_keep_alive then
								if pconn_active.item then
									if l_sock = (create {P_HTTP_STATIC}).pconn.item.item.socket then
										invalidate_persistent
										update_class_fields -- Current might have been changed; synchronize
									else
										(create {P_CONNECT_STATIC}).fd_close (l_sock)
										update_class_fields -- Current might have been changed; synchronize
										l_sock := -1
									end
								else
									(create {P_CONNECT_STATIC}).fd_close (l_sock)
									update_class_fields -- Current might have been changed; synchronize
									l_sock := -1
								end
							end
							l_break := True
						end
						l_break := False
				when 90 then -- if block done, skip else block:
						l_pos := -1 + 95
				when 91 then -- else:
						if not l_keep_alive then
							l_pos := -1 + 94 -- skip if block
						end
				when 92 then -- if:
						l_tmp___101 := skip_short_body (l_sock, l_contlen)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___101 then
							from
							until
								(l_break)
							loop
								l_break := False
								if not l_keep_alive then
									if pconn_active.item then
										if l_sock = (create {P_HTTP_STATIC}).pconn.item.item.socket then
											invalidate_persistent
											update_class_fields -- Current might have been changed; synchronize
										else
											(create {P_CONNECT_STATIC}).fd_close (l_sock)
											update_class_fields -- Current might have been changed; synchronize
											l_sock := -1
										end
									else
										(create {P_CONNECT_STATIC}).fd_close (l_sock)
										update_class_fields -- Current might have been changed; synchronize
										l_sock := -1
									end
								end
								l_break := True
							end
							l_break := False
						else
							l_pos := -1 + 94 -- goto _L___14
						end
				when 93 then -- if block done, skip else block:
						l_pos := -1 + 95
				when 94 then -- else: | _L___14:
						from
						until
							(l_break)
						loop
							l_break := False
							if pconn_active.item then
								if l_sock = (create {P_HTTP_STATIC}).pconn.item.item.socket then
									invalidate_persistent
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_CONNECT_STATIC}).fd_close (l_sock)
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								(create {P_CONNECT_STATIC}).fd_close (l_sock)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_sock := -1
							l_break := True
						end
						l_break := False
				when 95 then -- if done
						free (create {CE_VOID_POINTER}.make_cast (l_head))
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_UERR_T}.RETRFINISHED)
						l_return := True
				when 96 then -- if done | if done
					if not l_return then
						if ((create {P_RETR_STATIC}).output_stream.item).is_void then
							mkalldirs (a_hs.item.local_file).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							if (create {P_OPTIONS_STATIC}).opt.item.item.backups then
								rotate_backups (a_hs.item.local_file)
								update_class_fields -- Current might have been changed; synchronize
							end
							if (a_hs.item.restval).to_boolean then
								l_fp := fopen (a_hs.item.local_file, ce_string ("ab"))
								update_class_fields -- Current might have been changed; synchronize
							elseif (create {P_OPTIONS_STATIC}).opt.item.item.noclobber then
								l_fp := fopen (a_hs.item.local_file, ce_string ("wb"))
								update_class_fields -- Current might have been changed; synchronize
							elseif (create {P_OPTIONS_STATIC}).opt.item.item.always_rest then
								l_fp := fopen (a_hs.item.local_file, ce_string ("wb"))
								update_class_fields -- Current might have been changed; synchronize
							elseif (create {P_OPTIONS_STATIC}).opt.item.item.timestamping then
								l_fp := fopen (a_hs.item.local_file, ce_string ("wb"))
								update_class_fields -- Current might have been changed; synchronize
							elseif (create {P_OPTIONS_STATIC}).opt.item.item.dirstruct then
								l_fp := fopen (a_hs.item.local_file, ce_string ("wb"))
								update_class_fields -- Current might have been changed; synchronize
							elseif (not ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void) then
								l_fp := fopen (a_hs.item.local_file, ce_string ("wb"))
								update_class_fields -- Current might have been changed; synchronize
							else
								l_fp := (create {P_UTILS_STATIC}).fopen_excl (a_hs.item.local_file, 1)
								update_class_fields -- Current might have been changed; synchronize
								if l_fp.is_void then
									l_tmp___103 := errno_location
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___103.item = 17 then
										l_tmp___102 := gettext (ce_string ("%%s has sprung into existence.%N"))
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___102, a_hs.item.local_file])
										update_class_fields -- Current might have been changed; synchronize
										from
										until
											(l_break)
										loop
											l_break := False
											if pconn_active.item then
												if l_sock = (create {P_HTTP_STATIC}).pconn.item.item.socket then
													invalidate_persistent
													update_class_fields -- Current might have been changed; synchronize
												else
													(create {P_CONNECT_STATIC}).fd_close (l_sock)
													update_class_fields -- Current might have been changed; synchronize
												end
											else
												(create {P_CONNECT_STATIC}).fd_close (l_sock)
												update_class_fields -- Current might have been changed; synchronize
											end
											l_sock := -1
											l_break := True
										end
										l_break := False
										free (create {CE_VOID_POINTER}.make_cast (l_head))
										update_class_fields -- Current might have been changed; synchronize
										Result := ({PC_UERR_T}.FOPEN_EXCL_ERR)
										l_return := True
									end
								end
							end
							if not l_return and then (l_fp.is_void) then
								l_tmp___104 := errno_location
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___105 := strerror (l_tmp___104.item)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_hs.item.local_file, l_tmp___105])
								update_class_fields -- Current might have been changed; synchronize
								from
								until
									(l_break)
								loop
									l_break := False
									if pconn_active.item then
										if l_sock = (create {P_HTTP_STATIC}).pconn.item.item.socket then
											invalidate_persistent
											update_class_fields -- Current might have been changed; synchronize
										else
											(create {P_CONNECT_STATIC}).fd_close (l_sock)
											update_class_fields -- Current might have been changed; synchronize
										end
									else
										(create {P_CONNECT_STATIC}).fd_close (l_sock)
										update_class_fields -- Current might have been changed; synchronize
									end
									l_sock := -1
									l_break := True
								end
								l_break := False
								free (create {CE_VOID_POINTER}.make_cast (l_head))
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_UERR_T}.FOPENERR)
								l_return := True
							end
						else
							l_fp := (create {P_RETR_STATIC}).output_stream.item
						end
					end
					if not l_return then
						if ((create {P_OPTIONS_STATIC}).opt.item.item.verbose).to_boolean then
							if ((a_hs.item.local_file).item).to_integer_32 = 45 then
								if not (a_hs.item.local_file[1]).to_boolean then
									l_tmp___106 := (create {P_QUOTE_STATIC}).quote (ce_string ("STDOUT"))
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___108 := l_tmp___106
								else
									l_tmp___107 := (create {P_QUOTE_STATIC}).quote (a_hs.item.local_file)
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___108 := l_tmp___107
								end
							else
								l_tmp___107 := (create {P_QUOTE_STATIC}).quote (a_hs.item.local_file)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___108 := l_tmp___107
							end
							l_tmp___109 := gettext (ce_string ("Saving to: %%s%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___109, l_tmp___108])
							update_class_fields -- Current might have been changed; synchronize
						end
						if (create {P_OPTIONS_STATIC}).opt.item.item.save_headers then
							if a_hs.item.restval = {INTEGER_64} 0 then
								l_tmp___110 := strlen (l_head)
								update_class_fields -- Current might have been changed; synchronize
								fwrite (create {CE_VOID_POINTER}.make_cast (l_head), (1).to_natural_32, l_tmp___110, l_fp).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						free (create {CE_VOID_POINTER}.make_cast (l_head))
						update_class_fields -- Current might have been changed; synchronize
						l_flags := 0
						if l_contlen /= -{INTEGER_64} 1 then
							l_flags := (l_flags).bit_or ((1))
						end
						if a_hs.item.restval > {INTEGER_64} 0 then
							if l_contrange = {INTEGER_64} 0 then
								l_flags := (l_flags).bit_or ((2))
							end
						end
						a_hs.item.len := a_hs.item.restval
						update_class_fields -- Current might have been changed; synchronize
						a_hs.item.rd_size := (0).to_integer_64
						update_class_fields -- Current might have been changed; synchronize
						if l_contlen /= -{INTEGER_64} 1 then
							l_tmp___111 := l_contlen
						else
							l_tmp___111 := (0).to_integer_64
						end
						a_hs.item.res := fd_read_body (l_sock, l_fp, l_tmp___111, a_hs.item.restval, create {CE_INTEGER_64_POINTER}.make_shared (a_hs.c_pointer + (create {PD_HTTP_STAT}.make).offset_of ("rd_size")), create {CE_INTEGER_64_POINTER}.make_shared (a_hs.c_pointer + (create {PD_HTTP_STAT}.make).offset_of ("len")), create {CE_REAL_64_POINTER}.make_shared (a_hs.c_pointer + (create {PD_HTTP_STAT}.make).offset_of ("dltime")), l_flags)
						update_class_fields -- Current might have been changed; synchronize
						if a_hs.item.res >= 0 then
							from
							until
								(l_break)
							loop
								l_break := False
								if not l_keep_alive then
									if pconn_active.item then
										if l_sock = (create {P_HTTP_STATIC}).pconn.item.item.socket then
											invalidate_persistent
											update_class_fields -- Current might have been changed; synchronize
										else
											(create {P_CONNECT_STATIC}).fd_close (l_sock)
											update_class_fields -- Current might have been changed; synchronize
											l_sock := -1
										end
									else
										(create {P_CONNECT_STATIC}).fd_close (l_sock)
										update_class_fields -- Current might have been changed; synchronize
										l_sock := -1
									end
								end
								l_break := True
							end
							l_break := False
						else
							if a_hs.item.res < 0 then
								l_tmp___112 := fd_errstr (l_sock)
								update_class_fields -- Current might have been changed; synchronize
								a_hs.item.rderrmsg := (create {P_XMALLOC_STATIC}).xstrdup (l_tmp___112)
								update_class_fields -- Current might have been changed; synchronize
							end
							from
							until
								(l_break)
							loop
								l_break := False
								if pconn_active.item then
									if l_sock = (create {P_HTTP_STATIC}).pconn.item.item.socket then
										invalidate_persistent
										update_class_fields -- Current might have been changed; synchronize
									else
										(create {P_CONNECT_STATIC}).fd_close (l_sock)
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									(create {P_CONNECT_STATIC}).fd_close (l_sock)
									update_class_fields -- Current might have been changed; synchronize
								end
								l_sock := -1
								l_break := True
							end
							l_break := False
						end
						if ((create {P_RETR_STATIC}).output_stream.item).is_void then
							fclose (l_fp).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						if a_hs.item.res = -2 then
							Result := ({PC_UERR_T}.FWRITEERR)
							l_return := True
						end
					end
					if not l_return then
						Result := ({PC_UERR_T}.RETRFINISHED)
					end
				when 97 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	retrieve_tree (a_pi: CE_POINTER [PD_IRI]): NATURAL_32
		local
			l_status: NATURAL_32
			l_queue: CE_POINTER [PD_URL_QUEUE]
			l_blacklist: CE_POINTER [PD_HASH_TABLE]
			l_i: CE_ARRAY [CE_POINTER [PD_IRI]]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_descend: BOOLEAN
			l_url: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_referer: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_file: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_depth___0: CE_ARRAY [INTEGER_32]
			l_html_allowed: CE_ARRAY [BOOLEAN]
			l_css_allowed: CE_ARRAY [BOOLEAN]
			l_is_css: BOOLEAN
			l_dash_p_leaf_HTML: BOOLEAN
			l_tmp___2: BOOLEAN
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_dt: CE_ARRAY [INTEGER_32]
			l_url_err: CE_ARRAY [INTEGER_32]
			l_redirected: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_url_parsed: CE_POINTER [PD_URL]
			l_tmp___7: CE_POINTER [PD_URL]
			l_tmp___8: BOOLEAN
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_meta_disallow_follow: CE_ARRAY [BOOLEAN]
			l_children: CE_POINTER [PD_URLPOS]
			l_tmp___11: CE_POINTER [PD_URLPOS]
			l_tmp___12: CE_POINTER [PD_URLPOS]
			l_tmp___13: CE_POINTER [PD_URLPOS]
			l_child: CE_POINTER [PD_URLPOS]
			l_url_parsed___0: CE_POINTER [PD_URL]
			l_tmp___14: CE_POINTER [PD_URL]
			l_ci: CE_POINTER [PD_IRI]
			l_referer_url: CE_POINTER [INTEGER_8]
			l_strip_auth: BOOLEAN
			l_tmp___15: INTEGER_32
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_tmp___18: BOOLEAN
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___20: CE_POINTER [INTEGER_8]
			l_tmp___21: INTEGER_32
			l_tmp___22: CE_POINTER [INTEGER_8]
			l_tmp___23: CE_POINTER [INTEGER_8]
			l_tmp___24: CE_POINTER [INTEGER_8]
			l_tmp___25: CE_POINTER [INTEGER_32]
			l_tmp___26: CE_POINTER [INTEGER_8]
			l_tmp___27: INTEGER_32
			l_tmp___28: BOOLEAN
			l_d1: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_d2: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_d3: CE_ARRAY [INTEGER_32]
			l_d4: CE_ARRAY [BOOLEAN]
			l_d5: CE_ARRAY [BOOLEAN]
			l_d6: CE_ARRAY [CE_POINTER [PD_IRI]]
			l_tmp___29: BOOLEAN
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_IRI]} l_i.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_url.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_referer.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_file.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_depth___0.make (<<1>>)
			create {CE_BOOLEAN_ARRAY} l_html_allowed.make (<<1>>)
			create {CE_BOOLEAN_ARRAY} l_css_allowed.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_dt.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_url_err.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_redirected.make (<<1>>)
			create {CE_BOOLEAN_ARRAY} l_meta_disallow_follow.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_d1.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_d2.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_d3.make (<<1>>)
			create {CE_BOOLEAN_ARRAY} l_d4.make (<<1>>)
			create {CE_BOOLEAN_ARRAY} l_d5.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_IRI]} l_d6.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_status := {PC_UERR_T}.RETROK
					l_i.item := (create {P_IRI_STATIC}).dummy_iri.item
					update_class_fields -- Current might have been changed; synchronize
					if (not a_pi.is_void) then
						if (not (a_pi.item.uri_encoding).is_void) then
							l_tmp := (create {P_XMALLOC_STATIC}).xstrdup (a_pi.item.uri_encoding)
							update_class_fields -- Current might have been changed; synchronize
							l_i.item.item.uri_encoding := l_tmp
							update_class_fields -- Current might have been changed; synchronize
						else
							l_i.item.item.uri_encoding := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not (a_pi.item.content_encoding).is_void) then
							l_tmp___0 := (create {P_XMALLOC_STATIC}).xstrdup (a_pi.item.content_encoding)
							update_class_fields -- Current might have been changed; synchronize
							l_i.item.item.content_encoding := l_tmp___0
							update_class_fields -- Current might have been changed; synchronize
						else
							l_i.item.item.content_encoding := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_i.item.item.utf8_encode := a_pi.item.utf8_encode
						update_class_fields -- Current might have been changed; synchronize
					end
					l_queue := url_queue_new
					update_class_fields -- Current might have been changed; synchronize
					l_blacklist := (create {P_HASH_STATIC}).make_string_hash_table (0)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___1 := (create {P_XMALLOC_STATIC}).xstrdup (url)
					update_class_fields -- Current might have been changed; synchronize
					url_enqueue (l_queue, l_i.item, l_tmp___1, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), 0, (1).to_boolean, (0).to_boolean)
					update_class_fields -- Current might have been changed; synchronize
					l_blacklist.item.string_set_add (url)
					update_class_fields -- Current might have been changed; synchronize
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 25 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_descend := (0).to_boolean
						l_file.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_is_css := (0).to_boolean
						l_dash_p_leaf_HTML := (0).to_boolean
						if ((create {P_OPTIONS_STATIC}).opt.item.item.quota).to_boolean then
							if (create {P_RETR_STATIC}).total_downloaded_bytes.item > (create {P_OPTIONS_STATIC}).opt.item.item.quota then
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) and then (l_status = {NATURAL_32} 26) then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_tmp___2 := url_dequeue (l_queue, l_i, l_url, l_referer, l_depth___0, l_html_allowed, l_css_allowed)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___2 then
								l_break := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 24 -- skip if block
						end
				when 3 then -- if:
						if ((create {P_CONVERT_STATIC}).dl_url_file_map.item).is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_tmp___9 := ((create {P_CONVERT_STATIC}).dl_url_file_map.item).item.hash_table_contains (create {CE_VOID_POINTER}.make_cast (l_url.item))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___9.to_boolean then
							l_tmp___3 := ((create {P_CONVERT_STATIC}).dl_url_file_map.item).item.hash_table_get (create {CE_VOID_POINTER}.make_cast (l_url.item))
							update_class_fields -- Current might have been changed; synchronize
							l_file.item := (create {P_XMALLOC_STATIC}).xstrdup (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___3))
							update_class_fields -- Current might have been changed; synchronize
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___4 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___4.to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Already downloaded %"%%s%", reusing it from %"%%s%".%N"), l_url.item, l_file.item])
									update_class_fields -- Current might have been changed; synchronize
								end
								l_break := True
							end
							l_break := False
							if l_html_allowed.item then
								if (not ((create {P_CONVERT_STATIC}).downloaded_html_set.item).is_void) then
									l_tmp___5 := ((create {P_CONVERT_STATIC}).downloaded_html_set.item).item.string_set_contains (l_file.item)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___5.to_boolean then
										l_descend := (1).to_boolean
										l_is_css := (0).to_boolean
									end
								end
							end
							if l_css_allowed.item then
								if (not ((create {P_CONVERT_STATIC}).downloaded_css_set.item).is_void) then
									l_tmp___6 := ((create {P_CONVERT_STATIC}).downloaded_css_set.item).item.string_set_contains (l_file.item)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___6.to_boolean then
										l_descend := (1).to_boolean
										l_is_css := (1).to_boolean
									end
								end
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_dt.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_redirected.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___7 := (create {P_URL_STATIC}).url_parse (l_url.item, l_url_err, l_i.item, (1).to_boolean)
						update_class_fields -- Current might have been changed; synchronize
						l_url_parsed := l_tmp___7
						l_status := (create {P_RETR_STATIC}).retrieve_url (l_url_parsed, l_url.item, l_file, l_redirected, l_referer.item, l_dt, (0).to_boolean, l_i.item, (1).to_boolean)
						update_class_fields -- Current might have been changed; synchronize
						if l_html_allowed.item then
							if (not (l_file.item).is_void) then
								if l_status = {NATURAL_32} 31 then
									if ((l_dt.item).bit_and (2)).to_boolean then
										if ((l_dt.item).bit_and (1)).to_boolean then
											l_descend := (1).to_boolean
											l_is_css := (0).to_boolean
										end
									end
								end
							end
						end
						if (not (l_file.item).is_void) then
							if l_status = {NATURAL_32} 31 then
								if ((l_dt.item).bit_and (2)).to_boolean then
									if ((l_dt.item).bit_and (64)).to_boolean then
										l_descend := (1).to_boolean
										l_is_css := (1).to_boolean
									elseif l_css_allowed.item then
										l_descend := (1).to_boolean
										l_is_css := (1).to_boolean
									end
								end
							end
						end
						if (not (l_redirected.item).is_void) then
							if l_descend then
								l_tmp___8 := descend_redirect_p (l_redirected.item, l_url_parsed, l_depth___0.item, (create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer)), l_blacklist, l_i.item)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___8 then
									l_blacklist.item.string_set_add (l_url.item)
									update_class_fields -- Current might have been changed; synchronize
								else
									l_descend := (0).to_boolean
								end
							end
							free (create {CE_VOID_POINTER}.make_cast (l_url.item))
							update_class_fields -- Current might have been changed; synchronize
							l_url.item := l_redirected.item
							update_class_fields -- Current might have been changed; synchronize
						else
							free (create {CE_VOID_POINTER}.make_cast (l_url.item))
							update_class_fields -- Current might have been changed; synchronize
							l_url.item := (create {P_XMALLOC_STATIC}).xstrdup (l_url_parsed.item.url)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_url_parsed.item.url_free
						update_class_fields -- Current might have been changed; synchronize
				when 7 then
						if not l_descend then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
						if not (l_depth___0.item >= (create {P_OPTIONS_STATIC}).opt.item.item.reclevel) then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if:
						if (create {P_OPTIONS_STATIC}).opt.item.item.reclevel = -1 then
							l_pos := -1 + 14 -- skip if block
						end
				when 10 then -- if:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.page_requisites) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_depth___0.item = (create {P_OPTIONS_STATIC}).opt.item.item.reclevel then
							l_dash_p_leaf_HTML := (1).to_boolean
						elseif l_depth___0.item = (create {P_OPTIONS_STATIC}).opt.item.item.reclevel + 1 then
							l_dash_p_leaf_HTML := (1).to_boolean
						else
							l_pos := -1 + 13 -- goto _L___0
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___0:
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___10 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___10.to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Not descending further; at depth %%d, max. %%d.%N"), l_depth___0.item, (create {P_OPTIONS_STATIC}).opt.item.item.reclevel])
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
						l_descend := (0).to_boolean
				when 14 then -- if done | if done | if done
						if l_descend then
							l_meta_disallow_follow.item := (0).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							if l_is_css then
								l_tmp___11 := (create {P_CSS_URL_STATIC}).get_urls_css_file (l_file.item, l_url.item)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___13 := l_tmp___11
							else
								l_tmp___12 := (create {P_HTML_URL_STATIC}).get_urls_html (l_file.item, l_url.item, l_meta_disallow_follow, l_i.item)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___13 := l_tmp___12
							end
							l_children := l_tmp___13
							if (create {P_OPTIONS_STATIC}).opt.item.item.use_robots then
								if l_meta_disallow_follow.item then
									(create {P_RETR_STATIC}).free_urlpos (l_children)
									update_class_fields -- Current might have been changed; synchronize
									l_children := create {CE_CLASS_POINTER [PD_URLPOS]}.make_shared (default_pointer)
								end
							end
							if (not l_children.is_void) then
								l_child := l_children
								l_tmp___14 := (create {P_URL_STATIC}).url_parse (l_url.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_i.item, (1).to_boolean)
								update_class_fields -- Current might have been changed; synchronize
								l_url_parsed___0 := l_tmp___14
								l_referer_url := l_url.item
								if not l_url_parsed___0.is_void then
									if not (l_url_parsed___0.item.user).is_void then
										l_tmp___15 := 1
									else
										l_tmp___15 := 0
									end
								else
									l_tmp___15 := 0
								end
								l_strip_auth := l_tmp___15.to_boolean
								if l_url_parsed___0.is_void then
									assert_fail (ce_string ("url_parsed != ((void *)0)"), ce_string ("recur.c"), {NATURAL_32} 388, ce_string ("retrieve_tree"))
									update_class_fields -- Current might have been changed; synchronize
								end
								if l_strip_auth then
									l_referer_url := l_url_parsed___0.item.url_string ({PC_URL_AUTH_MODE}.URL_AUTH_HIDE)
									update_class_fields -- Current might have been changed; synchronize
								end
								from
								until
									l_child.is_void
								loop
									l_continue := False
									if (l_child.item.ignore_when_downloading).to_boolean then
										l_continue := True
									end
									if not (l_break or l_continue) and then l_dash_p_leaf_HTML then
										if not (l_child.item.link_inline_p).to_boolean then
											l_continue := True
										end
									end
									if not (l_break or l_continue) then
										l_tmp___18 := l_child.item.download_child_p (l_url_parsed___0, l_depth___0.item, (create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer)), l_blacklist, l_i.item)
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___18 then
											l_ci := (create {P_IRI_STATIC}).dummy_iri.item
											l_tmp___16 := (create {P_XMALLOC_STATIC}).xstrdup (l_referer_url)
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___17 := (create {P_XMALLOC_STATIC}).xstrdup ((l_child.item.url).item.url)
											update_class_fields -- Current might have been changed; synchronize
											url_enqueue (l_queue, l_ci, l_tmp___17, l_tmp___16, l_depth___0.item + 1, (l_child.item.link_expect_html).to_boolean, (l_child.item.link_expect_css).to_boolean)
											update_class_fields -- Current might have been changed; synchronize
											l_blacklist.item.string_set_add ((l_child.item.url).item.url)
											update_class_fields -- Current might have been changed; synchronize
										end
									end
									l_child := l_child.item.next
								end
								l_continue := False
								if l_strip_auth then
									free (create {CE_VOID_POINTER}.make_cast (l_referer_url))
									update_class_fields -- Current might have been changed; synchronize
								end
								l_url_parsed___0.item.url_free
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_RETR_STATIC}).free_urlpos (l_children)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if (l_file.item).is_void then
							l_pos := -1 + 23 -- skip if block
						end
				when 15 then -- if:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.delete_after) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 22 -- goto _L___1
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 18 then -- else:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.spider) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L___1
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 21 then -- else:
						l_tmp___28 := (create {P_UTILS_STATIC}).acceptable (l_file.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___28 then
							l_pos := -1 + 23 -- skip if block
						end
				when 22 then -- if: | _L___1:
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___21 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___21.to_boolean then
								if (create {P_OPTIONS_STATIC}).opt.item.item.delete_after then
									l_tmp___20 := ce_string ("--delete-after")
								else
									if (create {P_OPTIONS_STATIC}).opt.item.item.spider then
										l_tmp___19 := ce_string ("--spider")
									else
										l_tmp___19 := ce_string ("recursive rejection criteria")
									end
									l_tmp___20 := l_tmp___19
								end
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Removing file due to %%s in recursive_retrieve():%N"), l_tmp___20])
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
						if (create {P_OPTIONS_STATIC}).opt.item.item.delete_after then
							l_tmp___22 := gettext (ce_string ("Removing %%s.%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___24 := l_tmp___22
						elseif (create {P_OPTIONS_STATIC}).opt.item.item.spider then
							l_tmp___22 := gettext (ce_string ("Removing %%s.%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___24 := l_tmp___22
						else
							l_tmp___23 := gettext (ce_string ("Removing %%s since it should be rejected.%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___24 := l_tmp___23
						end
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___24, l_file.item])
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___27 := unlink (l_file.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___27.to_boolean then
							l_tmp___25 := errno_location
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___26 := strerror (l_tmp___25.item)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("unlink: %%s%N"), l_tmp___26])
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						update_class_fields -- Current might have been changed; synchronize
						register_delete_file (l_file.item)
						update_class_fields -- Current might have been changed; synchronize
				when 23 then -- if done | if done | if done
						free (create {CE_VOID_POINTER}.make_cast (l_url.item))
						update_class_fields -- Current might have been changed; synchronize
						if (not (l_referer.item).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_referer.item))
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not (l_file.item).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_file.item))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 24 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 25 then -- loop done
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___29 := url_dequeue (l_queue, l_d6, l_d1, l_d2, l_d3, l_d4, l_d5)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___29 then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							free (create {CE_VOID_POINTER}.make_cast (l_d1.item))
							update_class_fields -- Current might have been changed; synchronize
							if (not (l_d2.item).is_void) then
								free (create {CE_VOID_POINTER}.make_cast (l_d2.item))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
					l_break := False
					url_queue_delete (l_queue)
					update_class_fields -- Current might have been changed; synchronize
					l_blacklist.item.string_set_free
					update_class_fields -- Current might have been changed; synchronize
					if not (((create {P_OPTIONS_STATIC}).opt.item.item.quota).to_boolean) then
						l_pos := -1 + 28 -- skip if block
					end
				when 26 then -- if:
						if (create {P_RETR_STATIC}).total_downloaded_bytes.item > (create {P_OPTIONS_STATIC}).opt.item.item.quota then
							Result := ({PC_UERR_T}.QUOTEXC)
						else
							l_pos := -1 + 28 -- goto _L___2
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else: | _L___2:
						if l_status = {NATURAL_32} 26 then
							Result := ({PC_UERR_T}.FWRITEERR)
						else
							Result := ({PC_UERR_T}.RETROK)
						end
				when 29 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	full_path_length: INTEGER_32
		local
			l_len: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: NATURAL_32
		do
			l_len := 0
			if (not path.is_void) then
				l_tmp := strlen (path)
				update_class_fields -- Current might have been changed; synchronize
				l_len := (l_len.to_natural_32 + ({NATURAL_32} 1 + l_tmp)).to_integer_32
			end
			if (not params.is_void) then
				l_tmp___0 := strlen (params)
				update_class_fields -- Current might have been changed; synchronize
				l_len := (l_len.to_natural_32 + ({NATURAL_32} 1 + l_tmp___0)).to_integer_32
			end
			if (not query.is_void) then
				l_tmp___1 := strlen (query)
				update_class_fields -- Current might have been changed; synchronize
				l_len := (l_len.to_natural_32 + ({NATURAL_32} 1 + l_tmp___1)).to_integer_32
			end
			Result := l_len
		end

	full_path_write (a_where: CE_POINTER [INTEGER_8])
		local
			l_where: CE_POINTER [INTEGER_8]
			l_f_el: CE_POINTER [INTEGER_8]
			l_l: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_f_el___0: CE_POINTER [INTEGER_8]
			l_l___0: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_f_el___1: CE_POINTER [INTEGER_8]
			l_l___1: INTEGER_32
			l_tmp___3: NATURAL_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
		do
			l_where := a_where
			from
			until
				(l_break)
			loop
				l_break := False
				l_f_el := path
				if (not l_f_el.is_void) then
					l_tmp := strlen (l_f_el)
					update_class_fields -- Current might have been changed; synchronize
					l_l := l_tmp.to_integer_32
					l_tmp___0 := l_where
					l_where := l_where + 1
					l_tmp___0[0] := (('/').code).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					memcpy (create {CE_VOID_POINTER}.make_cast (l_where), create {CE_VOID_POINTER}.make_cast (l_f_el), l_l.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_where := l_where + l_l
				end
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False
				l_f_el___0 := params
				if (not l_f_el___0.is_void) then
					l_tmp___1 := strlen (l_f_el___0)
					update_class_fields -- Current might have been changed; synchronize
					l_l___0 := l_tmp___1.to_integer_32
					l_tmp___2 := l_where
					l_where := l_where + 1
					l_tmp___2[0] := ((';').code).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					memcpy (create {CE_VOID_POINTER}.make_cast (l_where), create {CE_VOID_POINTER}.make_cast (l_f_el___0), l_l___0.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_where := l_where + l_l___0
				end
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False
				l_f_el___1 := query
				if (not l_f_el___1.is_void) then
					l_tmp___3 := strlen (l_f_el___1)
					update_class_fields -- Current might have been changed; synchronize
					l_l___1 := l_tmp___3.to_integer_32
					l_tmp___4 := l_where
					l_where := l_where + 1
					l_tmp___4[0] := (('?').code).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					memcpy (create {CE_VOID_POINTER}.make_cast (l_where), create {CE_VOID_POINTER}.make_cast (l_f_el___1), l_l___1.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_where := l_where + l_l___1
				end
				l_break := True
			end
			l_break := False
		end

	url_full_path: CE_POINTER [INTEGER_8]
		local
			l_length: INTEGER_32
			l_tmp: INTEGER_32
			l_full_path: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [ANY]
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.full_path_length
			update_class_fields -- Current might have been changed; synchronize
			l_length := l_tmp
			l_tmp___0 := (create {P_XMALLOC_STATIC}).xmalloc ((l_length + 1).to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_full_path := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___0);
			((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.full_path_write (l_full_path)
			update_class_fields -- Current might have been changed; synchronize
			l_full_path[l_length] := (('%/0/').code).to_integer_8
			update_class_fields -- Current might have been changed; synchronize
			Result := l_full_path
		end

	sync_path
		local
			l_newpath: CE_POINTER [INTEGER_8]
			l_efile: CE_POINTER [INTEGER_8]
			l_edir: CE_POINTER [INTEGER_8]
			l_dirlen: INTEGER_32
			l_tmp: NATURAL_32
			l_filelen: INTEGER_32
			l_tmp___0: NATURAL_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [INTEGER_8]
		do
			free (create {CE_VOID_POINTER}.make_cast (path))
			update_class_fields -- Current might have been changed; synchronize
			l_edir := url_escape_dir (dir)
			update_class_fields -- Current might have been changed; synchronize
			l_efile := url_escape_1 (file, (3).to_natural_8, (1).to_boolean)
			update_class_fields -- Current might have been changed; synchronize
			if not (l_edir[0]).to_boolean then
				l_newpath := (create {P_XMALLOC_STATIC}).xstrdup (l_efile)
				update_class_fields -- Current might have been changed; synchronize
			else
				l_tmp := strlen (l_edir)
				update_class_fields -- Current might have been changed; synchronize
				l_dirlen := l_tmp.to_integer_32
				l_tmp___0 := strlen (l_efile)
				update_class_fields -- Current might have been changed; synchronize
				l_filelen := l_tmp___0.to_integer_32
				l_tmp___1 := (create {P_XMALLOC_STATIC}).xmalloc ((((l_dirlen + 1) + l_filelen) + 1).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_newpath := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___1)
				l_p___0 := l_newpath
				memcpy (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_edir), l_dirlen.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_p___0 := l_p___0 + l_dirlen
				l_tmp___2 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___2[0] := (('/').code).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
				memcpy (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_efile), l_filelen.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_p___0 := l_p___0 + l_filelen
				l_p___0[0] := (('%/0/').code).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.path := l_newpath
			update_class_fields -- Current might have been changed; synchronize
			if not l_edir.is_equal (dir) then
				free (create {CE_VOID_POINTER}.make_cast (l_edir))
				update_class_fields -- Current might have been changed; synchronize
			end
			if not l_efile.is_equal (file) then
				free (create {CE_VOID_POINTER}.make_cast (l_efile))
				update_class_fields -- Current might have been changed; synchronize
			end
			free (create {CE_VOID_POINTER}.make_cast (url))
			update_class_fields -- Current might have been changed; synchronize
			Current.url := ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.url_string ({PC_URL_AUTH_MODE}.URL_AUTH_SHOW)
			update_class_fields -- Current might have been changed; synchronize
		end

	url_set_dir (a_newdir: CE_POINTER [INTEGER_8])
		do
			free (create {CE_VOID_POINTER}.make_cast (dir))
			update_class_fields -- Current might have been changed; synchronize
			Current.dir := (create {P_XMALLOC_STATIC}).xstrdup (a_newdir)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.sync_path
			update_class_fields -- Current might have been changed; synchronize
		end

	url_set_file (a_newfile: CE_POINTER [INTEGER_8])
		do
			free (create {CE_VOID_POINTER}.make_cast (file))
			update_class_fields -- Current might have been changed; synchronize
			Current.file := (create {P_XMALLOC_STATIC}).xstrdup (a_newfile)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.sync_path
			update_class_fields -- Current might have been changed; synchronize
		end

	url_free
		do
			free (create {CE_VOID_POINTER}.make_cast (host))
			update_class_fields -- Current might have been changed; synchronize
			free (create {CE_VOID_POINTER}.make_cast (path))
			update_class_fields -- Current might have been changed; synchronize
			free (create {CE_VOID_POINTER}.make_cast (url))
			update_class_fields -- Current might have been changed; synchronize
			if (not params.is_void) then
				free (create {CE_VOID_POINTER}.make_cast (params))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not query.is_void) then
				free (create {CE_VOID_POINTER}.make_cast (query))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not fragment.is_void) then
				free (create {CE_VOID_POINTER}.make_cast (fragment))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not user.is_void) then
				free (create {CE_VOID_POINTER}.make_cast (user))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not passwd.is_void) then
				free (create {CE_VOID_POINTER}.make_cast (passwd))
				update_class_fields -- Current might have been changed; synchronize
			end
			free (create {CE_VOID_POINTER}.make_cast (dir))
			update_class_fields -- Current might have been changed; synchronize
			free (create {CE_VOID_POINTER}.make_cast (file))
			update_class_fields -- Current might have been changed; synchronize
			free (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	append_dir_structure (a_dest: CE_POINTER [PD_GROWABLE])
		local
			l_pathel: CE_POINTER [INTEGER_8]
			l_next: CE_POINTER [INTEGER_8]
			l_cut: INTEGER_32
			l_tmp: INTEGER_32
			l_break, l_continue: BOOLEAN
		do
			l_cut := (create {P_OPTIONS_STATIC}).opt.item.item.cut_dirs
			l_pathel := path
			from
			until
				(l_break)
			loop
				l_break := False
				l_continue := False
				l_next := strchr (l_pathel, ('/').code)
				update_class_fields -- Current might have been changed; synchronize
				if l_next.is_void then
					l_break := True
				end
				if not (l_break or l_continue) then
					l_tmp := l_cut
					l_cut := l_cut - 1
					if l_tmp > 0 then
						l_continue := True
					end
				end
				if not (l_break or l_continue) and then (l_pathel.is_equal (l_next)) then
					l_continue := True
				end
				if not (l_break or l_continue) then
					if (a_dest.item.tail).to_boolean then
						append_char ((('/').code).to_integer_8, a_dest)
						update_class_fields -- Current might have been changed; synchronize
					end
					append_uri_pathel (l_pathel, l_next, (1).to_boolean, a_dest)
					update_class_fields -- Current might have been changed; synchronize
				end
				if (not l_break) then
					l_pathel := l_next + 1
				end
			end
			l_break := False
			l_continue := False
		end

	url_file_name: CE_POINTER [INTEGER_8]
		local
			l_fnres: CE_ARRAY [PD_GROWABLE]
			l_u_file: CE_POINTER [INTEGER_8]
			l_u_query: CE_POINTER [INTEGER_8]
			l_fname: CE_POINTER [INTEGER_8]
			l_unique: CE_POINTER [INTEGER_8]
			l_index_filename: CE_POINTER [INTEGER_8]
			l_tmp: INTEGER_32
			l_portstr: CE_ARRAY [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: NATURAL_32
			l_tmp___3: INTEGER_32
			l_tmp___4: NATURAL_32
			l_tmp___5: BOOLEAN
			l_tmp___6: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GROWABLE]} l_fnres.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_portstr.make (<<24>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_index_filename := ce_string ("index.html")
					l_fnres.item.base := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					l_fnres.item.size := 0
					update_class_fields -- Current might have been changed; synchronize
					l_fnres.item.tail := 0
					update_class_fields -- Current might have been changed; synchronize
					if (not ((create {P_OPTIONS_STATIC}).opt.item.item.default_page).is_void) then
						l_index_filename := (create {P_OPTIONS_STATIC}).opt.item.item.default_page
					end
					if (not ((create {P_OPTIONS_STATIC}).opt.item.item.dir_prefix).is_void) then
						append_string ((create {P_OPTIONS_STATIC}).opt.item.item.dir_prefix, l_fnres)
						update_class_fields -- Current might have been changed; synchronize
					end
					if (create {P_OPTIONS_STATIC}).opt.item.item.dirstruct then
						if (create {P_OPTIONS_STATIC}).opt.item.item.protocol_directories then
							if (l_fnres.item.tail).to_boolean then
								append_char ((('/').code).to_integer_8, l_fnres)
								update_class_fields -- Current might have been changed; synchronize
							end
							append_string ((create {P_URL_STATIC}).supported_schemes.item[scheme.to_integer_32].name, l_fnres)
							update_class_fields -- Current might have been changed; synchronize
						end
						if (create {P_OPTIONS_STATIC}).opt.item.item.add_hostdir then
							if (l_fnres.item.tail).to_boolean then
								append_char ((('/').code).to_integer_8, l_fnres)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_tmp := strcmp (host, ce_string (".."))
							update_class_fields -- Current might have been changed; synchronize
							if 0 /= l_tmp then
								append_string (host, l_fnres)
								update_class_fields -- Current might have been changed; synchronize
							else
								append_string (ce_string ("%%2E%%2E"), l_fnres)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_tmp___1 := (create {P_URL_STATIC}).scheme_default_port (scheme)
							update_class_fields -- Current might have been changed; synchronize
							if port /= l_tmp___1 then
								(create {P_UTILS_STATIC}).number_to_string (l_portstr, port.to_integer_64).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								if (create {P_OPTIONS_STATIC}).opt.item.item.restrict_files_os /= {NATURAL_32} 1 then
									l_tmp___0 := (':').code
								else
									l_tmp___0 := ('+').code
								end
								append_char (l_tmp___0.to_integer_8, l_fnres)
								update_class_fields -- Current might have been changed; synchronize
								append_string (l_portstr, l_fnres)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.append_dir_structure (l_fnres)
						update_class_fields -- Current might have been changed; synchronize
					end
					if (l_fnres.item.tail).to_boolean then
						append_char ((('/').code).to_integer_8, l_fnres)
						update_class_fields -- Current might have been changed; synchronize
					end
					if (file.item).to_boolean then
						l_u_file := file
					else
						l_u_file := l_index_filename
					end
					l_tmp___2 := strlen (l_u_file)
					update_class_fields -- Current might have been changed; synchronize
					append_uri_pathel (l_u_file, l_u_file + l_tmp___2.to_integer_32, (0).to_boolean, l_fnres)
					update_class_fields -- Current might have been changed; synchronize
					if (not query.is_void) then
						if (query.item).to_boolean then
							l_u_query := query
						else
							l_u_query := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						end
					else
						l_u_query := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					end
					if (not l_u_query.is_void) then
						if (create {P_OPTIONS_STATIC}).opt.item.item.restrict_files_os /= {NATURAL_32} 1 then
							l_tmp___3 := ('?').code
						else
							l_tmp___3 := ('@').code
						end
						append_char (l_tmp___3.to_integer_8, l_fnres)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___4 := strlen (l_u_query)
						update_class_fields -- Current might have been changed; synchronize
						append_uri_pathel (l_u_query, l_u_query + l_tmp___4.to_integer_32, (1).to_boolean, l_fnres)
						update_class_fields -- Current might have been changed; synchronize
					end
					append_char ((('%/0/').code).to_integer_8, l_fnres)
					update_class_fields -- Current might have been changed; synchronize
					l_fname := l_fnres.item.base
					if not ((create {P_OPTIONS_STATIC}).opt.item.item.noclobber) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.always_rest) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.timestamping) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.dirstruct) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L___0:
						l_tmp___5 := (create {P_UTILS_STATIC}).file_exists_p (l_fname)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___5 then
							l_tmp___6 := file_non_directory_p (l_fname)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___6 then
								l_unique := l_fname
							else
								l_pos := -1 + 12 -- goto _L
							end
						else
							l_unique := l_fname
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						l_unique := (create {P_UTILS_STATIC}).unique_name (l_fname, (1).to_boolean)
						update_class_fields -- Current might have been changed; synchronize
						if not l_unique.is_equal (l_fname) then
							free (create {CE_VOID_POINTER}.make_cast (l_fname))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 13 then -- if done | if done | if done
					Result := l_unique
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	url_string (a_auth_mode: NATURAL_32): CE_POINTER [INTEGER_8]
		local
			l_size: INTEGER_32
			l_result: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_quoted_host: CE_POINTER [INTEGER_8]
			l_quoted_user: CE_POINTER [INTEGER_8]
			l_quoted_passwd: CE_POINTER [INTEGER_8]
			l_scheme_port: INTEGER_32
			l_scheme_str: CE_POINTER [INTEGER_8]
			l_fplen: INTEGER_32
			l_tmp: INTEGER_32
			l_brackets_around_host: BOOLEAN
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: NATURAL_32
			l_tmp___6: NATURAL_32
			l_tmp___7: CE_POINTER [ANY]
			l_len: INTEGER_32
			l_tmp___8: NATURAL_32
			l_len___0: INTEGER_32
			l_tmp___9: NATURAL_32
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_len___1: INTEGER_32
			l_tmp___11: NATURAL_32
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_len___2: INTEGER_32
			l_tmp___14: NATURAL_32
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
		do
			l_quoted_user := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_quoted_passwd := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_scheme_port := (create {P_URL_STATIC}).supported_schemes.item[scheme.to_integer_32].default_port
			l_scheme_str := (create {P_URL_STATIC}).supported_schemes.item[scheme.to_integer_32].leading_string
			l_tmp := ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.full_path_length
			update_class_fields -- Current might have been changed; synchronize
			l_fplen := l_tmp
			if l_scheme_str.is_void then
				assert_fail (ce_string ("scheme_str != ((void *)0)"), ce_string ("url.c"), {NATURAL_32} 1_936, ce_string ("url_string"))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not user.is_void) then
				if a_auth_mode /= {NATURAL_32} 2 then
					l_quoted_user := url_escape_allow_passthrough (user)
					update_class_fields -- Current might have been changed; synchronize
					if (not passwd.is_void) then
						if a_auth_mode = {NATURAL_32} 1 then
							l_quoted_passwd := ce_string ("*password*")
						else
							l_quoted_passwd := url_escape_allow_passthrough (passwd)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				end
			end
			l_quoted_host := url_escape_allow_passthrough (host)
			update_class_fields -- Current might have been changed; synchronize
			if not l_quoted_host.is_equal (host) then
				unescape_single_char (l_quoted_host, ((':').code).to_integer_8)
				update_class_fields -- Current might have been changed; synchronize
			end
			l_tmp___0 := strchr (l_quoted_host, (':').code)
			update_class_fields -- Current might have been changed; synchronize
			l_brackets_around_host := (not l_tmp___0.is_void)
			l_tmp___1 := strlen (l_scheme_str)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___2 := strlen (l_quoted_host)
			update_class_fields -- Current might have been changed; synchronize
			if l_brackets_around_host then
				l_tmp___3 := 2
			else
				l_tmp___3 := 0
			end
			l_size := ((((l_tmp___1 + l_tmp___2) + l_tmp___3.to_natural_32) + l_fplen.to_natural_32) + {NATURAL_32} 1).to_integer_32
			if port /= l_scheme_port then
				l_tmp___4 := (create {P_UTILS_STATIC}).numdigit (port.to_integer_64)
				update_class_fields -- Current might have been changed; synchronize
				l_size := l_size + (1 + l_tmp___4)
			end
			if (not l_quoted_user.is_void) then
				l_tmp___5 := strlen (l_quoted_user)
				update_class_fields -- Current might have been changed; synchronize
				l_size := (l_size.to_natural_32 + ({NATURAL_32} 1 + l_tmp___5)).to_integer_32
				if (not l_quoted_passwd.is_void) then
					l_tmp___6 := strlen (l_quoted_passwd)
					update_class_fields -- Current might have been changed; synchronize
					l_size := (l_size.to_natural_32 + ({NATURAL_32} 1 + l_tmp___6)).to_integer_32
				end
			end
			l_tmp___7 := (create {P_XMALLOC_STATIC}).xmalloc (l_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_result := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___7)
			l_p___0 := l_result
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp___8 := strlen (l_scheme_str)
				update_class_fields -- Current might have been changed; synchronize
				l_len := l_tmp___8.to_integer_32
				memcpy (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_scheme_str), l_len.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_p___0 := l_p___0 + l_len
				l_break := True
			end
			l_break := False
			if (not l_quoted_user.is_void) then
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___9 := strlen (l_quoted_user)
					update_class_fields -- Current might have been changed; synchronize
					l_len___0 := l_tmp___9.to_integer_32
					memcpy (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_quoted_user), l_len___0.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_p___0 := l_p___0 + l_len___0
					l_break := True
				end
				l_break := False
				if (not l_quoted_passwd.is_void) then
					l_tmp___10 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___10[0] := ((':').code).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___11 := strlen (l_quoted_passwd)
						update_class_fields -- Current might have been changed; synchronize
						l_len___1 := l_tmp___11.to_integer_32
						memcpy (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_quoted_passwd), l_len___1.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_p___0 := l_p___0 + l_len___1
						l_break := True
					end
					l_break := False
				end
				l_tmp___12 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___12[0] := (('@').code).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_brackets_around_host then
				l_tmp___13 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___13[0] := (('[').code).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
			end
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp___14 := strlen (l_quoted_host)
				update_class_fields -- Current might have been changed; synchronize
				l_len___2 := l_tmp___14.to_integer_32
				memcpy (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_quoted_host), l_len___2.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_p___0 := l_p___0 + l_len___2
				l_break := True
			end
			l_break := False
			if l_brackets_around_host then
				l_tmp___15 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___15[0] := ((']').code).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
			end
			if port /= l_scheme_port then
				l_tmp___16 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___16[0] := ((':').code).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
				l_p___0 := (create {P_UTILS_STATIC}).number_to_string (l_p___0, port.to_integer_64)
				update_class_fields -- Current might have been changed; synchronize
			end
			((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.full_path_write (l_p___0)
			update_class_fields -- Current might have been changed; synchronize
			l_p___0 := l_p___0 + l_fplen
			l_tmp___17 := l_p___0
			l_p___0 := l_p___0 + 1
			l_tmp___17[0] := (('%/0/').code).to_integer_8
			update_class_fields -- Current might have been changed; synchronize
			if l_p___0.distance (l_result) /= l_size then
				assert_fail (ce_string ("p - result == size"), ce_string ("url.c"), {NATURAL_32} 2_008, ce_string ("url_string"))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not l_quoted_user.is_void) then
				if not l_quoted_user.is_equal (user) then
					free (create {CE_VOID_POINTER}.make_cast (l_quoted_user))
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if (not l_quoted_passwd.is_void) then
				if a_auth_mode = {NATURAL_32} 0 then
					if not l_quoted_passwd.is_equal (passwd) then
						free (create {CE_VOID_POINTER}.make_cast (l_quoted_passwd))
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_quoted_host.is_equal (host) then
				free (create {CE_VOID_POINTER}.make_cast (l_quoted_host))
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l_result
		end

	ftp_get_listing (a_con: CE_POINTER [PD_CCON]; a_f: CE_POINTER [CE_POINTER [PD_FILEINFO]]): NATURAL_32
		require
			not a_con.is_void
			not a_f.is_void
		local
			l_err: NATURAL_32
			l_uf: CE_POINTER [INTEGER_8]
			l_lf: CE_POINTER [INTEGER_8]
			l_old_target: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_32]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
			l_break: BOOLEAN
		do
			l_old_target := a_con.item.target
			a_con.item.st := (a_con.item.st).bit_and ((-2))
			update_class_fields -- Current might have been changed; synchronize
			a_con.item.cmd := (a_con.item.cmd).bit_or ((24))
			update_class_fields -- Current might have been changed; synchronize
			a_con.item.cmd := (a_con.item.cmd).bit_and ((-5))
			update_class_fields -- Current might have been changed; synchronize
			l_uf := ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.url_file_name
			update_class_fields -- Current might have been changed; synchronize
			l_lf := file_merge (l_uf, ce_string (".listing"))
			update_class_fields -- Current might have been changed; synchronize
			free (create {CE_VOID_POINTER}.make_cast (l_uf))
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp___1 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___1.to_boolean then
					l_tmp := (create {P_QUOTE_STATIC}).quote (l_lf)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := gettext (ce_string ("Using %%s as listing tmp file.%N"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LOG_STATIC}).debug_logprintf ([l_tmp___0, l_tmp])
					update_class_fields -- Current might have been changed; synchronize
				end
				l_break := True
			end
			l_break := False
			a_con.item.target := (create {P_XMALLOC_STATIC}).xstrdup (l_lf)
			update_class_fields -- Current might have been changed; synchronize
			free (create {CE_VOID_POINTER}.make_cast (l_lf))
			update_class_fields -- Current might have been changed; synchronize
			l_err := ftp_loop_internal ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer), a_con)
			update_class_fields -- Current might have been changed; synchronize
			l_lf := (create {P_XMALLOC_STATIC}).xstrdup (a_con.item.target)
			update_class_fields -- Current might have been changed; synchronize
			free (create {CE_VOID_POINTER}.make_cast (a_con.item.target))
			update_class_fields -- Current might have been changed; synchronize
			a_con.item.target := l_old_target
			update_class_fields -- Current might have been changed; synchronize
			if l_err = {NATURAL_32} 31 then
				a_f.item := ftp_parse_ls (l_lf, a_con.item.rs)
				update_class_fields -- Current might have been changed; synchronize
				if (create {P_OPTIONS_STATIC}).opt.item.item.remove_listing then
					l_tmp___6 := unlink (l_lf)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___6.to_boolean then
						l_tmp___2 := errno_location
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___3 := strerror (l_tmp___2.item)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("unlink: %%s%N"), l_tmp___3])
						update_class_fields -- Current might have been changed; synchronize
					else
						l_tmp___4 := (create {P_QUOTE_STATIC}).quote (l_lf)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___5 := gettext (ce_string ("Removed %%s.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___5, l_tmp___4])
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			else
				a_f.item := create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			free (create {CE_VOID_POINTER}.make_cast (l_lf))
			update_class_fields -- Current might have been changed; synchronize
			a_con.item.cmd := (a_con.item.cmd).bit_and ((-9))
			update_class_fields -- Current might have been changed; synchronize
			Result := l_err
		end

	ftp_retrieve_glob (a_con: CE_POINTER [PD_CCON]; a_action: INTEGER_32): NATURAL_32
		require
			not a_con.is_void
		local
			l_f: CE_POINTER [PD_FILEINFO]
			l_start: CE_ARRAY [CE_POINTER [PD_FILEINFO]]
			l_res___0: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: BOOLEAN
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: BOOLEAN
			l_matcher: CE_ROUTINE
			l_tmp___5: CE_ROUTINE
			l_matchres: INTEGER_32
			l_tmp___6: CE_POINTER [INTEGER_32]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_cmp: CE_ROUTINE
			l_tmp___10: CE_ROUTINE
			l_tmp___11: INTEGER_32
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_FILEINFO]} l_start.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_con.item.cmd := (a_con.item.cmd).bit_or ((16))
					update_class_fields -- Current might have been changed; synchronize
					l_res___0 := ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer))).item.ftp_get_listing (a_con, l_start)
					update_class_fields -- Current might have been changed; synchronize
					if l_res___0 /= {NATURAL_32} 31 then
						Result := l_res___0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_OPTIONS_STATIC}).opt.item.item.accepts).is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if ((create {P_OPTIONS_STATIC}).opt.item.item.rejects).is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_f := l_start.item
						from
						until
							l_f.is_void
						loop
							if l_f.item.type /= {NATURAL_32} 1 then
								l_tmp___1 := (create {P_UTILS_STATIC}).acceptable (l_f.item.name)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___1 then
									l_f := l_f.item.next
								else
									l_tmp := (create {P_QUOTE_STATIC}).quote (l_f.item.name)
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___0 := gettext (ce_string ("Rejecting %%s.%N"))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___0, l_tmp])
									update_class_fields -- Current might have been changed; synchronize
									l_f := delelement (l_f, l_start)
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_f := l_f.item.next
							end
						end
				when 6 then -- if done
						l_f := l_start.item
						from
						until
							l_f.is_void
						loop
							l_tmp___4 := has_insecure_name_p (l_f.item.name)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___4 then
								l_tmp___2 := (create {P_QUOTE_STATIC}).quote (l_f.item.name)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___3 := gettext (ce_string ("Rejecting %%s.%N"))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___3, l_tmp___2])
								update_class_fields -- Current might have been changed; synchronize
								l_f := delelement (l_f, l_start)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_f := l_f.item.next
							end
						end
						if (file.item).to_boolean then
							if a_action = 0 then
								if (create {P_OPTIONS_STATIC}).opt.item.item.ignore_case then
									l_tmp___5 := (create {P_UTILS_STATIC}).fnmatch_nocase_address
								else
									l_tmp___5 := fnmatch_address
								end
								l_matcher := l_tmp___5
								l_matchres := 0
								l_f := l_start.item
								from
								until
									not (not (l_break) and then (not l_f.is_void))
								loop
									l_break := False
									l_matchres := l_matcher.integer_32_item ([file, l_f.item.name, 0])
									update_class_fields -- Current might have been changed; synchronize
									if l_matchres = -1 then
										l_tmp___6 := errno_location
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___7 := strerror (l_tmp___6.item)
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___8 := (create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_f.item.name)
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___9 := gettext (ce_string ("Error matching %%s against %%s: %%s%N"))
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___9, file, l_tmp___8, l_tmp___7])
										update_class_fields -- Current might have been changed; synchronize
										l_break := True
									end
									if not (l_break) then
										if l_matchres = 1 then
											l_f := delelement (l_f, l_start)
											update_class_fields -- Current might have been changed; synchronize
										else
											l_f := l_f.item.next
										end
									end
								end
								l_break := False
								if l_matchres = -1 then
									freefileinfo (l_start.item)
									update_class_fields -- Current might have been changed; synchronize
									Result := ({PC_UERR_T}.RETRBADPATTERN)
									l_return := True
								end
							elseif a_action = 2 then
								if (create {P_OPTIONS_STATIC}).opt.item.item.ignore_case then
									l_tmp___10 := strcasecmp_address
								else
									l_tmp___10 := strcmp_address
								end
								l_cmp := l_tmp___10
								l_f := l_start.item
								from
								until
									l_f.is_void
								loop
									l_tmp___11 := l_cmp.integer_32_item ([file, l_f.item.name])
									update_class_fields -- Current might have been changed; synchronize
									if 0 /= l_tmp___11 then
										l_f := delelement (l_f, l_start)
										update_class_fields -- Current might have been changed; synchronize
									else
										l_f := l_f.item.next
									end
								end
							end
						end
				when 7 then -- if done
					if not l_return then
						if (not (l_start.item).is_void) then
							ftp_retrieve_list ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer)), l_start.item, a_con).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						elseif a_action = 0 then
							l_tmp___12 := (create {P_QUOTE_STATIC}).quote (file)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___13 := gettext (ce_string ("No matches on pattern %%s.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___13, l_tmp___12])
							update_class_fields -- Current might have been changed; synchronize
						elseif a_action = 2 then
							a_con.item.st := (a_con.item.st).bit_or ((1))
							update_class_fields -- Current might have been changed; synchronize
							l_res___0 := ftp_loop_internal ((create {CE_CLASS_POINTER [PD_URL]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer), a_con)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_res___0
							l_return := True
						end
					end
					if not l_return then
						freefileinfo (l_start.item)
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_OPTIONS_STATIC}).opt.item.item.quota).to_boolean then
							if (create {P_RETR_STATIC}).total_downloaded_bytes.item > (create {P_OPTIONS_STATIC}).opt.item.item.quota then
								Result := ({PC_UERR_T}.QUOTEXC)
							else
								Result := ({PC_UERR_T}.RETROK)
							end
						else
							Result := ({PC_UERR_T}.RETROK)
						end
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {PD_URL} -- private routines

	connect_to_host (a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_start: CE_ARRAY [INTEGER_32]
			l_end: CE_ARRAY [INTEGER_32]
			l_sock: INTEGER_32
			l_al: CE_POINTER [PD_ADDRESS_LIST]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_ip___0: CE_POINTER [PD_IP_ADDRESS]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_start.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_end.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_al := ((create {P_HOST_STATIC}).lookup_host (a_host, 0))
				when 1 then -- retry:
					if l_al.is_void then
						l_tmp___0 := (create {P_QUOTE_STATIC}).quote (a_host);
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s: unable to resolve host address %%s%N"))), (create {P_WGET_STATIC}).exec_name.item, l_tmp___0])
						Result := (-100)
						l_return := True
					end
					if not l_return then
						address_list_get_bounds (l_al, l_start, l_end)
						l_i := l_start.item
						from
						until
							not (not (l_return) and then (l_i < l_end.item))
						loop
							l_ip___0 := (l_al.item.address_list_address_at (l_i))
							l_sock := l_ip___0.item.connect_to_ip (a_port, a_host)
							if l_sock >= 0 then
								address_list_set_connected (l_al)
								l_al.item.address_list_release
								Result := l_sock
								l_return := True
							end
							if not l_return then
								address_list_set_faulty (l_al, l_i)
								l_i := l_i + 1
							end
						end
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						if (address_list_connected_p (l_al)) then
							l_al.item.address_list_release
							l_al := (create {P_HOST_STATIC}).lookup_host (a_host, 4)
							l_pos := -1 + 1 -- goto retry
						end
				when 3 then
						l_al.item.address_list_release
						Result := (-1)
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	retryable_socket_connect_error (a_err: INTEGER_32): BOOLEAN
		local
			l_return: BOOLEAN
		do
			if a_err = 97 then
				Result := (0).to_boolean
				l_return := True
			elseif a_err = 96 then
				Result := (0).to_boolean
				l_return := True
			elseif a_err = 94 then
				Result := (0).to_boolean
				l_return := True
			elseif a_err = 93 then
				Result := (0).to_boolean
				l_return := True
			elseif a_err = 92 then
				Result := (0).to_boolean
				l_return := True
			elseif a_err = 22 then
				Result := (0).to_boolean
				l_return := True
			end
			if not l_return and then (not (create {P_OPTIONS_STATIC}).opt.item.item.retry_connrefused) then
				if a_err = 111 then
					Result := (0).to_boolean
					l_return := True
				elseif a_err = 101 then
					Result := (0).to_boolean
					l_return := True
				elseif a_err = 113 then
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return then
				Result := (1).to_boolean
			end
		end

	freefileinfo (a_f: CE_POINTER [PD_FILEINFO])
		local
			l_f: CE_POINTER [PD_FILEINFO]
			l_next: CE_POINTER [PD_FILEINFO]
		do
			l_f := a_f
			from
			until
				l_f.is_void
			loop
				l_next := l_f.item.next
				free (create {CE_VOID_POINTER}.make_cast (l_f.item.name))
				if (not (l_f.item.linkto).is_void) then
					free (create {CE_VOID_POINTER}.make_cast (l_f.item.linkto))
				end
				free (create {CE_VOID_POINTER}.make_cast (l_f))
				l_f := l_next
			end
		end

	search_netrc (a_host: CE_POINTER [INTEGER_8]; a_acc, a_passwd: CE_POINTER [CE_POINTER [INTEGER_8]]; a_slack_default: INTEGER_32)
		local
			l_l: CE_POINTER [PD_ACC_T]
			l_home___0: CE_POINTER [INTEGER_8]
			l_err: INTEGER_32
			l_buf___6: CE_ARRAY [SD_STAT]
			l_path: CE_POINTER [INTEGER_8]
			l_tmp___0: NATURAL_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_buf___6.make (<<1>>)

			if not (create {P_OPTIONS_STATIC}).opt.item.item.netrc then
				l_return := True
			end
			if not l_return then
				if not processed_netrc.item.to_boolean then
					l_home___0 := ((create {P_INIT_STATIC}).home_dir)
					netrc_list.item := create {CE_CLASS_POINTER [PD_ACC_T]}.make_shared (default_pointer)
					processed_netrc.item := 1
					if (not l_home___0.is_void) then
						l_tmp___0 := strlen (l_home___0)
						l_path := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new (((l_tmp___0 + {NATURAL_32} 1) + (strlen (ce_string (".netrc")))) + {NATURAL_32} 1)))
						sprintf ([l_path, ce_string ("%%s/%%s"), l_home___0, ce_string (".netrc")]).do_nothing
						free (create {CE_VOID_POINTER}.make_cast (l_home___0))
						l_err := stat (l_path, l_buf___6)
						if l_err = 0 then
							netrc_list.item := parse_netrc (l_path)
						end
					end
				end
				if netrc_list.item.is_void then
					l_return := True
				end
			end
			if not l_return and then (not (a_acc.item).is_void) then
				if (not (a_passwd.item).is_void) then
					l_return := True
				end
			end
			if not l_return then
				l_l := netrc_list.item
				from
				until
					not (not (l_break) and then (not l_l.is_void))
				loop
					l_break := False
					if (not (l_l.item.host).is_void) then
						if not (strcasecmp (l_l.item.host, a_host)).to_boolean then
							l_break := True
						end
					end
					if (not l_break) then
						l_l := l_l.item.next
					end
				end
				l_break := False
				if (not l_l.is_void) then
					if (not (a_acc.item).is_void) then
						if (strcmp (l_l.item.acc, a_acc.item)).to_boolean then
							a_passwd.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							a_passwd.item := l_l.item.passwd
						end
					else
						a_acc.item := l_l.item.acc
						if (not (l_l.item.passwd).is_void) then
							a_passwd.item := l_l.item.passwd
						end
					end
				else
					if not a_slack_default.to_boolean then
						l_return := True
					end
					if not l_return and then (not (a_acc.item).is_void) then
						l_return := True
					end
					if not l_return then
						l_l := netrc_list.item
						from
						until
							not (not (l_break) and then (not l_l.is_void))
						loop
							l_break := False
							if (l_l.item.host).is_void then
								l_break := True
							end
							if not (l_break) then
								l_l := l_l.item.next
							end
						end
						l_break := False
						if l_l.is_void then
							l_return := True
						end
					end
					if not l_return then
						a_acc.item := l_l.item.acc
						if (a_passwd.item).is_void then
							a_passwd.item := l_l.item.passwd
						end
					end
				end
			end
		end

	fd_read_body (a_fd: INTEGER_32; a_out: CE_POINTER [SD_IO_FILE]; a_toread, a_startpos: INTEGER_64; a_qtyread, a_qtywritten: CE_POINTER [INTEGER_64]; a_elapsed: CE_POINTER [REAL_64]; a_flags: INTEGER_32): INTEGER_32
		local
			l_ret: INTEGER_32
			l_dlbufsize: INTEGER_32
			l_timer: CE_POINTER [PD_PTIMER]
			l_last_successful_read_tm: REAL_64
			l_progress: CE_POINTER [ANY]
			l_progress_interactive: BOOLEAN
			l_exact: BOOLEAN
			l_skip: CE_ARRAY [INTEGER_64]
			l_sum_read: INTEGER_64
			l_sum_written: CE_ARRAY [INTEGER_64]
			l_start: INTEGER_64
			l_tmp: INTEGER_64
			l_rdsize: INTEGER_32
			l_tmp___0: INTEGER_64
			l_tmp___1: INTEGER_64
			l_tmout: REAL_64
			l_waittm: REAL_64
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_64_ARRAY} l_skip.make (<<1>>)
			create {CE_INTEGER_64_ARRAY} l_sum_written.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ret := 0
					l_dlbufsize := ({PLATFORM}.Integer_8_bytes.to_natural_32 * (16_384).to_natural_32).to_integer_32
					l_timer := create {CE_CLASS_POINTER [PD_PTIMER]}.make_shared (default_pointer)
					l_last_successful_read_tm := (0).to_double
					l_progress := create {CE_VOID_POINTER}.make_shared (default_pointer)
					l_progress_interactive := (0).to_boolean
					l_exact := (((a_flags).bit_and (1)).to_boolean)
					l_skip.item := (0).to_integer_64
					l_sum_read := (0).to_integer_64
					l_sum_written.item := (0).to_integer_64
					if ((a_flags).bit_and (2)).to_boolean then
						l_skip.item := a_startpos
					end
					if ((create {P_OPTIONS_STATIC}).opt.item.item.verbose).to_boolean then
						if (l_skip.item).to_boolean then
							l_tmp := (0).to_integer_64
						else
							l_tmp := a_startpos
						end
						l_start := l_tmp
						l_progress := progress_create (l_start, l_start + a_toread)
						l_progress_interactive := progress_interactive_p (l_progress)
					end
					if ((create {P_OPTIONS_STATIC}).opt.item.item.limit_rate).to_boolean then
						limit_bandwidth_reset
					end
					if (not l_progress.is_void) then
						l_timer := (create {P_PTIMER_STATIC}).ptimer_new
						l_last_successful_read_tm := (0).to_double
					elseif ((create {P_OPTIONS_STATIC}).opt.item.item.limit_rate).to_boolean then
						l_timer := (create {P_PTIMER_STATIC}).ptimer_new
						l_last_successful_read_tm := (0).to_double
					elseif (not a_elapsed.is_void) then
						l_timer := (create {P_PTIMER_STATIC}).ptimer_new
						l_last_successful_read_tm := (0).to_double
					end
					if ((create {P_OPTIONS_STATIC}).opt.item.item.limit_rate).to_boolean then
						if (create {P_OPTIONS_STATIC}).opt.item.item.limit_rate < l_dlbufsize.to_integer_64 then
							l_dlbufsize := ((create {P_OPTIONS_STATIC}).opt.item.item.limit_rate).to_integer_32
						end
					end
				when 1 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 16 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if l_exact then
							if not (l_sum_read < a_toread) then
								l_break := True
							end
						end
						if not (l_break) then
							if l_exact then
								if a_toread - l_sum_read <= l_dlbufsize.to_integer_64 then
									l_tmp___0 := a_toread - l_sum_read
								else
									l_tmp___0 := l_dlbufsize.to_integer_64
								end
								l_tmp___1 := l_tmp___0
							else
								l_tmp___1 := l_dlbufsize.to_integer_64
							end
							l_rdsize := l_tmp___1.to_integer_32
							l_tmout := (create {P_OPTIONS_STATIC}).opt.item.item.read_timeout
							if l_progress_interactive then
								l_tmout := 0.95
								if ((create {P_OPTIONS_STATIC}).opt.item.item.read_timeout).truncated_to_integer.to_boolean then
									l_waittm := (ptimer_read (l_timer)) - l_last_successful_read_tm
									if l_waittm + l_tmout > (create {P_OPTIONS_STATIC}).opt.item.item.read_timeout then
										l_tmout := (create {P_OPTIONS_STATIC}).opt.item.item.read_timeout - l_waittm
										if l_tmout < (0).to_double then
											l_ret := -1;
											(errno_location).item := 110
											l_break := True
										end
									end
								end
							end
						end
						if (l_break) then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						l_ret := fd_read (a_fd, dlbuf.item, l_rdsize, l_tmout)
						if not l_progress_interactive then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_ret < 0 then
							if (errno_location).item = 110 then
								l_ret := 0
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						if l_ret <= 0 then
							l_break := True
						end
				when 7 then -- if done
						if (l_break) then
							l_pos := -1 + 15 -- skip if block
						end
				when 8 then -- if:
						if l_progress.is_void then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___1
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not (((create {P_OPTIONS_STATIC}).opt.item.item.limit_rate).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L___1:
						l_timer.item.ptimer_measure.do_nothing
						if l_ret > 0 then
							l_last_successful_read_tm := ptimer_read (l_timer)
						end
				when 13 then -- if done
						if l_ret > 0 then
							l_sum_read := l_sum_read + l_ret.to_integer_64
							if not (write_data (a_out, dlbuf.item, l_ret, l_skip, l_sum_written)).to_boolean then
								l_ret := -2
								l_pos := -1 + 17 -- goto out
							end
						end
				when 14 then
						if ((create {P_OPTIONS_STATIC}).opt.item.item.limit_rate).to_boolean then
							limit_bandwidth (l_ret.to_integer_64, l_timer)
						end
						if (not l_progress.is_void) then
							progress_update (l_progress, l_ret.to_integer_64, (ptimer_read (l_timer)))
						end
				when 15 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 16 then -- loop done
					l_break := False
					if l_ret < -1 then
						l_ret := -1
					end
				when 17 then -- out:
					if (not l_progress.is_void) then
						progress_finish (l_progress, (ptimer_read (l_timer)))
					end
					if (not a_elapsed.is_void) then
						a_elapsed.item := ptimer_read (l_timer)
					end
					if (not l_timer.is_void) then
						(create {P_PTIMER_STATIC}).ptimer_destroy (l_timer)
					end
					if (not a_qtyread.is_void) then
						a_qtyread.item := a_qtyread.item + l_sum_read
					end
					if (not a_qtywritten.is_void) then
						a_qtywritten.item := a_qtywritten.item + (l_sum_written.item)
					end
					Result := l_ret
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	rotate_backups (a_fname: CE_POINTER [INTEGER_8])
		require
			not a_fname.is_void
		local
			l_maxlen: INTEGER_32
			l_tmp: NATURAL_32
			l_from: CE_POINTER [INTEGER_8]
			l_to: CE_POINTER [INTEGER_8]
			l_sb: CE_ARRAY [SD_STAT]
			l_i: INTEGER_32
			l_return: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_sb.make (<<1>>)

			l_tmp := strlen (a_fname)
			l_maxlen := (((l_tmp + {NATURAL_32} 1) + ((create {P_UTILS_STATIC}).numdigit (((create {P_OPTIONS_STATIC}).opt.item.item.backups).to_integer.to_integer_64)).to_natural_32) + {NATURAL_32} 1).to_integer_32
			l_from := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new (l_maxlen.to_natural_32)))
			l_to := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new (l_maxlen.to_natural_32)))
			if (stat (a_fname, l_sb)) = 0 then
				if ((l_sb.item.st_mode).bit_and ({NATURAL_32} 61_440)) /= {NATURAL_32} 32_768 then
					l_return := True
				end
			end
			if not l_return then
				l_i := ((create {P_OPTIONS_STATIC}).opt.item.item.backups).to_integer
				from
				until
					not (l_i > 1)
				loop
					sprintf ([l_from, ce_string ("%%s.%%d"), a_fname, l_i - 1]).do_nothing
					sprintf ([l_to, ce_string ("%%s.%%d"), a_fname, l_i]).do_nothing
					rename2 (l_from, l_to).do_nothing
					l_i := l_i - 1
				end
				sprintf ([l_to, ce_string ("%%s.%%d"), a_fname, 1]).do_nothing
				rename2 (a_fname, l_to).do_nothing
			end
		end

	mkalldirs (a_path: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_path.is_void
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_t: CE_POINTER [INTEGER_8]
			l_st: CE_ARRAY [SD_STAT]
			l_res___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)

			l_p___0 := a_path + (strlen (a_path)).to_integer_32
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_p___0[0]).to_integer_32 /= 47 then
					if l_p___0.is_equal (a_path) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_p___0 := l_p___0 - 1
				end
			end
			l_break := False
			if l_p___0.is_equal (a_path) then
				if (l_p___0[0]).to_integer_32 /= 47 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_t := (create {P_UTILS_STATIC}).strdupdelim (a_path, l_p___0)
				if (stat (l_t, l_st)) = 0 then
					if ((l_st.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 16_384 then
						free (create {CE_VOID_POINTER}.make_cast (l_t))
						Result := 0
						l_return := True
					else
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Removing %%s because of directory danger!%N"), l_t])
							end
							l_break := True
						end
						l_break := False
						unlink (l_t).do_nothing
					end
				end
			end
			if not l_return then
				l_res___0 := make_directory (l_t)
				if l_res___0 /= 0 then
					(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s"), l_t, (strerror ((errno_location).item))])
				end
				free (create {CE_VOID_POINTER}.make_cast (l_t))
				Result := l_res___0
			end
		end

	append_char (a_ch: INTEGER_8; a_dest: CE_POINTER [PD_GROWABLE])
		require
			not a_dest.is_void
		local
			l_G_: CE_POINTER [PD_GROWABLE]
			l_DR_needed_size: INTEGER_32
			l_DR_newsize: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_G_ := a_dest
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_DR_needed_size := (l_G_.item.tail + 1).to_integer_32
					l_DR_newsize := 0
					from
					until
						not ((l_G_.item.size).to_integer_32 < l_DR_needed_size)
					loop
						l_DR_newsize := ((l_G_.item.size).bit_shift_left (1)).to_integer_32
						if l_DR_newsize < 16 then
							l_DR_newsize := 16
						end
						l_G_.item.size := l_DR_newsize.to_integer_32
					end
					if l_DR_newsize.to_boolean then
						l_G_.item.base := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_G_.item.base), (l_DR_newsize.to_natural_32 * ({PLATFORM}.Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			a_dest.item.base[a_dest.item.tail] := a_ch
			a_dest.item.tail := (a_dest.item.tail) + 1
		end

	append_uri_pathel (a_b, a_e: CE_POINTER [INTEGER_8]; a_escaped: BOOLEAN; a_dest: CE_POINTER [PD_GROWABLE])
		require
			not a_dest.is_void
		local
			l_b: CE_POINTER [INTEGER_8]
			l_e: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_quoted: INTEGER_32
			l_outlen: INTEGER_32
			l_mask: INTEGER_32
			l_unescaped: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_BTA_beg: CE_POINTER [INTEGER_8]
			l_BTA_len: INTEGER_32
			l_BTA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_G_: CE_POINTER [PD_GROWABLE]
			l_DR_needed_size: INTEGER_32
			l_DR_newsize: INTEGER_32
			l_q: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_ch: NATURAL_8
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_q___0: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_unescaped.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_b := a_b
					l_e := a_e
					if (create {P_OPTIONS_STATIC}).opt.item.item.restrict_files_os = {NATURAL_32} 0 then
						l_mask := 1
					else
						l_mask := 2
					end
					if (create {P_OPTIONS_STATIC}).opt.item.item.restrict_files_ctrl then
						l_mask := (l_mask).bit_or ((4))
					end
					if a_escaped then
						from
						until
							(l_break)
						loop
							l_break := False
							l_BTA_beg := l_b
							l_BTA_len := l_e.distance (l_BTA_beg)
							l_BTA_dest := l_unescaped
							l_BTA_dest.item := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new ((l_BTA_len + 1).to_natural_32)))
							memcpy (create {CE_VOID_POINTER}.make_cast (l_BTA_dest.item), create {CE_VOID_POINTER}.make_cast (l_BTA_beg), l_BTA_len.to_natural_32).do_nothing
							l_BTA_dest.item[l_BTA_len] := (('%/0/').code).to_integer_8
							l_break := True
						end
						l_break := False;
						(create {P_URL_STATIC}).url_unescape (l_unescaped.item)
						l_b := l_unescaped.item
						l_e := (l_unescaped.item + (strlen (l_unescaped.item)).to_integer_32)
					end
					if l_e.distance (l_b) = 2 then
						if (l_b[0]).to_integer_32 = 46 then
							if (l_b[1]).to_integer_32 = 46 then
								l_b := ce_string ("%%2E%%2E")
								l_e := l_b + 6
							end
						end
					end
					l_quoted := 0
					l_p___0 := l_b
				when 1 then -- loop condition:
					if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.restrict_files_nonascii) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (c2_isascii (((l_p___0[0]).to_natural_8).to_integer_32)) then
							l_pos := -1 + 5 -- goto _L
						else
							l_quoted := l_quoted + 1
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if (((filechr_table.item[((l_p___0[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (l_mask)).to_boolean then
							l_quoted := l_quoted + 1
						end
				when 6 then
						l_p___0 := l_p___0 + 1
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					l_outlen := (l_e.distance (l_b)) + 2 * l_quoted
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_G_ := a_dest
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_DR_needed_size := (l_G_.item.tail + l_outlen).to_integer_32
							l_DR_newsize := 0
							from
							until
								not ((l_G_.item.size).to_integer_32 < l_DR_needed_size)
							loop
								l_DR_newsize := ((l_G_.item.size).bit_shift_left (1)).to_integer_32
								if l_DR_newsize < 16 then
									l_DR_newsize := 16
								end
								l_G_.item.size := l_DR_newsize.to_integer_32
							end
							if l_DR_newsize.to_boolean then
								l_G_.item.base := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_G_.item.base), (l_DR_newsize.to_natural_32 * ({PLATFORM}.Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if l_quoted.to_boolean then
						l_pos := -1 + 10 -- skip if block
					end
				when 8 then -- if:
						memcpy (create {CE_VOID_POINTER}.make_cast ((a_dest.item.base + a_dest.item.tail)), create {CE_VOID_POINTER}.make_cast (l_b), l_outlen.to_natural_32).do_nothing
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 10 then -- else:
						l_q := a_dest.item.base + a_dest.item.tail
						l_p___0 := l_b
				when 11 then -- loop condition:
						if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 20 -- skip loop
						end
				when 12 then -- loop body:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.restrict_files_nonascii) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if (c2_isascii (((l_p___0[0]).to_natural_8).to_integer_32)) then
							l_pos := -1 + 15 -- goto _L___1
						else
							l_pos := -1 + 16 -- goto _L___0
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else: | _L___1:
						if not ((((filechr_table.item[((l_p___0[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (l_mask)).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if: | _L___0:
						l_ch := (l_p___0[0]).to_natural_8
						l_tmp___4 := l_q
						l_q := l_q + 1
						l_tmp___4[0] := (('%%').code).to_integer_8
						l_tmp___5 := l_q
						l_q := l_q + 1
						l_tmp___5[0] := (((ce_string ("0123456789ABCDEF") + ((l_ch.to_integer_32).bit_shift_right (4))).item).to_integer_32).to_integer_8
						l_tmp___6 := l_q
						l_q := l_q + 1
						l_tmp___6[0] := (((ce_string ("0123456789ABCDEF") + ((l_ch.to_integer_32).bit_and (15))).item).to_integer_32).to_integer_8
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_tmp___3 := l_q
						l_q := l_q + 1
						l_tmp___3[0] := l_p___0[0]
				when 19 then -- if done
						l_p___0 := l_p___0 + 1
						l_pos := -1 + 11 -- back to loop condition
				when 20 then -- loop done
						if l_q.distance ((a_dest.item.base + a_dest.item.tail)) /= l_outlen then
							assert_fail (ce_string ("q - ((dest)->base + (dest)->tail) == outlen"), ce_string ("url.c"), {NATURAL_32} 1_433, ce_string ("append_uri_pathel"))
						end
				when 21 then -- if done
					if (create {P_OPTIONS_STATIC}).opt.item.item.restrict_files_case /= {NATURAL_32} 1 then
						l_pos := -1 + 24 -- skip if block
					end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L___2
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 24 then -- else:
						if (create {P_OPTIONS_STATIC}).opt.item.item.restrict_files_case /= {NATURAL_32} 2 then
							l_pos := -1 + 26 -- skip if block
						end
				when 25 then -- if: | _L___2:
						l_q___0 := a_dest.item.base + a_dest.item.tail
						from
						until
							not ((l_q___0.c_pointer.to_integer_32).to_natural_32 < (((a_dest.item.base + a_dest.item.tail) + l_outlen).c_pointer.to_integer_32).to_natural_32)
						loop
							if (create {P_OPTIONS_STATIC}).opt.item.item.restrict_files_case = {NATURAL_32} 1 then
								l_q___0[0] := ((create {P_C_CTYPE_STATIC}).c2_tolower ((l_q___0[0]).to_integer_32)).to_integer_8
							else
								l_q___0[0] := ((create {P_C_CTYPE_STATIC}).c2_toupper ((l_q___0[0]).to_integer_32)).to_integer_8
							end
							l_q___0 := l_q___0 + 1
						end
				when 26 then -- if done
					a_dest.item.tail := a_dest.item.tail + l_outlen
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	accept_connection (a_local_sock: INTEGER_32): INTEGER_32
		local
			l_sock: INTEGER_32
			l_ss: CE_ARRAY [SD_SOCKADDR_STORAGE]
			l_sa: CE_POINTER [SD_SOCKADDR]
			l_addrlen: CE_ARRAY [NATURAL_32]
			l_test: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_SOCKADDR_STORAGE]} l_ss.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_addrlen.make (<<1>>)

			l_sa := create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_ss)
			l_addrlen.item := (create {SD_SOCKADDR_STORAGE}.make).structure_size.to_natural_32
			if ((create {P_OPTIONS_STATIC}).opt.item.item.connect_timeout).truncated_to_integer.to_boolean then
				l_test := (select_fd (a_local_sock, (create {P_OPTIONS_STATIC}).opt.item.item.connect_timeout, 1))
				if l_test = 0 then
					(errno_location).item := 110
				end
				if l_test <= 0 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_sock := accept (a_local_sock, l_sa, l_addrlen)
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Accepted client at socket %%d.%N"), l_sock])
					end
					l_break := True
				end
				l_break := False
				Result := l_sock
			end
		end

	register_delete_file (a_file: CE_POINTER [INTEGER_8])
		local
			l_old_url: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_old_file: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_old_url.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_old_file.make (<<1>>)

			from
			until
				(l_break)
			loop
				l_break := False
				if ((create {P_CONVERT_STATIC}).dl_file_url_map.item).is_void then
					(create {P_CONVERT_STATIC}).dl_file_url_map.item := (create {P_HASH_STATIC}).make_string_hash_table (0)
				end
				if ((create {P_CONVERT_STATIC}).dl_url_file_map.item).is_void then
					(create {P_CONVERT_STATIC}).dl_url_file_map.item := (create {P_HASH_STATIC}).make_string_hash_table (0)
				end
				l_break := True
			end
			l_break := False
			if not (((create {P_CONVERT_STATIC}).dl_file_url_map.item).item.hash_table_get_pair (create {CE_VOID_POINTER}.make_cast (a_file), create {CE_VOID_POINTER}.make_cast (l_old_file), create {CE_VOID_POINTER}.make_cast (l_old_url))).to_boolean then
				l_return := True
			end
			if not l_return then
				((create {P_CONVERT_STATIC}).dl_file_url_map.item).item.hash_table_remove (create {CE_VOID_POINTER}.make_cast (a_file)).do_nothing
				free (create {CE_VOID_POINTER}.make_cast (l_old_file.item))
				free (create {CE_VOID_POINTER}.make_cast (l_old_url.item));
				(create {P_CONVERT_STATIC}).dissociate_urls_from_file (a_file)
			end
		end

	cookie_handle_set_cookie (a_jar: CE_POINTER [PD_COOKIE_JAR]; a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32; a_path, a_set_cookie: CE_POINTER [INTEGER_8])
		require
			not a_path.is_void
		local
			l_path: CE_POINTER [INTEGER_8]
			l_cookie: CE_POINTER [PD_COOKIE]
			l_PS_newstr: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_trailing_slash: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_path := a_path;
					(create {P_COOKIES_STATIC}).cookies_now.item := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
					from
					until
						(l_break)
					loop
						l_break := False
						l_PS_newstr := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new (({NATURAL_32} 1 + (strlen (l_path))) + {NATURAL_32} 1)))
						l_PS_newstr[0] := (('/').code).to_integer_8
						strcpy ((l_PS_newstr + 1), l_path).do_nothing
						l_path := l_PS_newstr
						l_break := True
					end
					l_break := False
					l_cookie := parse_set_cookie (a_set_cookie, (0).to_boolean)
					if l_cookie.is_void then
						l_pos := -1 + 8 -- goto out
					end
				when 1 then
					if (not (l_cookie.item.domain).is_void) then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if: | copy_domain:
						l_cookie.item.domain := (create {P_XMALLOC_STATIC}).xstrdup (a_host)
						l_cookie.item.domain_exact := {NATURAL_32} 1
						if a_port /= 80 then
							if a_port /= 443 then
								l_cookie.item.port := a_port
							end
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else:
						if not (check_domain_match (l_cookie.item.domain, a_host)) then
							l_tmp___1 := (create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_cookie.item.domain)
							l_tmp___2 := (create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, a_host);
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cookie coming from %%s attempted to set domain to %%s%N"))), l_tmp___2, l_tmp___1])
							free (create {CE_VOID_POINTER}.make_cast (l_cookie.item.domain))
							l_pos := -1 + 2 -- goto copy_domain
						end
				when 5 then
					if (l_cookie.item.path).is_void then
						l_trailing_slash := (strrchr (l_path, ('/').code))
						if (not l_trailing_slash.is_void) then
							l_cookie.item.path := (create {P_UTILS_STATIC}).strdupdelim (l_path, (l_trailing_slash + 1))
						else
							l_cookie.item.path := (create {P_XMALLOC_STATIC}).xstrdup (l_path)
						end
					elseif not (check_path_match (l_cookie.item.path, l_path)) then
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Attempt to fake the path: %%s, %%s%N"), l_cookie.item.path, l_path])
							end
							l_break := True
						end
						l_break := False
						l_pos := -1 + 8 -- goto out
					end
				when 6 then
					if (l_cookie.item.discard_requested).to_boolean then
						discard_matching_cookie (a_jar, l_cookie)
						l_pos := -1 + 8 -- goto out
					end
				when 7 then
					a_jar.item.store_cookie (l_cookie)
					l_return := True
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 8 then -- if: | out:
						if (not l_cookie.is_void) then
							l_cookie.item.delete_cookie
						end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	discard_matching_cookie (a_jar: CE_POINTER [PD_COOKIE_JAR]; a_cookie: CE_POINTER [PD_COOKIE])
		require
			not a_jar.is_void
		local
			l_prev: CE_ARRAY [CE_POINTER [PD_COOKIE]]
			l_victim: CE_POINTER [PD_COOKIE]
			l_chain_key: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_res___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_COOKIE]} l_prev.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_chain_key.make (<<1>>)

			if not ((a_jar.item.chains).item.hash_table_count).to_boolean then
				l_return := True
			end
			if not l_return then
				l_victim := a_jar.item.find_matching_cookie (a_cookie, l_prev)
				if (not l_victim.is_void) then
					if (not (l_prev.item).is_void) then
						l_prev.item.item.next := l_victim.item.next
					else
						l_chain_key.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						l_res___0 := (a_jar.item.chains).item.hash_table_get_pair (create {CE_VOID_POINTER}.make_cast (l_victim.item.domain), create {CE_VOID_POINTER}.make_cast (l_chain_key), create {CE_VOID_POINTER}.make_shared (default_pointer))
						if l_res___0 = 0 then
							assert_fail (ce_string ("res != 0"), ce_string ("cookies.c"), {NATURAL_32} 302, ce_string ("discard_matching_cookie"))
						end
						if (l_victim.item.next).is_void then
							(a_jar.item.chains).item.hash_table_remove (create {CE_VOID_POINTER}.make_cast (l_victim.item.domain)).do_nothing
							free (create {CE_VOID_POINTER}.make_cast (l_chain_key.item))
						else
							(a_jar.item.chains).item.hash_table_put (create {CE_VOID_POINTER}.make_cast (l_chain_key.item), create {CE_VOID_POINTER}.make_cast (l_victim.item.next))
						end
					end
					l_victim.item.delete_cookie
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
							(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Discarded old cookie.%N")])
						end
						l_break := True
					end
					l_break := False
				end
			end
		end

	parse_set_cookie (a_set_cookie: CE_POINTER [INTEGER_8]; a_silent: BOOLEAN): CE_POINTER [PD_COOKIE]
		local
			l_ptr: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_cookie: CE_POINTER [PD_COOKIE]
			l_name: CE_ARRAY [PD_PARAM_TOKEN]
			l_value: CE_ARRAY [PD_PARAM_TOKEN]
			l_value_copy: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_expires: INTEGER_32
			l_BTA_beg: CE_POINTER [INTEGER_8]
			l_BTA_len: INTEGER_32
			l_BTA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_maxage: CE_ARRAY [REAL_64]
			l_value_copy___0: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_BTA_beg___0: CE_POINTER [INTEGER_8]
			l_BTA_len___0: INTEGER_32
			l_BTA_dest___0: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_ptr.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_PARAM_TOKEN]} l_name.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_PARAM_TOKEN]} l_value.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_value_copy.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_maxage.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_value_copy___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ptr.item := a_set_cookie
					l_cookie := ((create {P_COOKIES_STATIC}).cookie_new)
					if not (extract_param (l_ptr, l_name, l_value, ((';').code).to_integer_8)) then
						l_pos := -1 + 38 -- goto error
					end
				when 1 then
					if (l_value.item.b).is_void then
						l_pos := -1 + 38 -- goto error
					end
				when 2 then
					l_cookie.item.attr := (create {P_UTILS_STATIC}).strdupdelim (l_name.item.b, l_name.item.e)
					l_cookie.item.value := (create {P_UTILS_STATIC}).strdupdelim (l_value.item.b, l_value.item.e)
				when 3 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 36 -- skip loop
					end
				when 4 then -- loop body:
						l_break := False
						if not (extract_param (l_ptr, l_name, l_value, ((';').code).to_integer_8)) then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 35 -- skip if block
						end
				when 5 then -- if:
						if ((l_name.item.e).distance ((l_name.item.b))).to_natural_32 /= (("domain").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
						if not ((strncasecmp (l_name.item.b, ce_string ("domain"), (("domain").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 12 -- goto _L___2
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if not (l_value.item.b).is_void then
							if (l_value.item.b).is_equal (l_value.item.e) then
								l_pos := -1 + 38 -- goto error
							end
						else
							l_pos := -1 + 38 -- goto error
						end
				when 10 then
						if (not (l_cookie.item.domain).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_cookie.item.domain))
						end
						if ((l_value.item.b).item).to_integer_32 = 46 then
							l_value.item.b := (l_value.item.b) + 1
						end
						l_cookie.item.domain := (create {P_UTILS_STATIC}).strdupdelim (l_value.item.b, l_value.item.e)
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 35
				when 12 then -- else: | _L___2:
						if ((l_name.item.e).distance ((l_name.item.b))).to_natural_32 /= (("path").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 19 -- skip if block
						end
				when 13 then -- if:
						if not ((strncasecmp (l_name.item.b, ce_string ("path"), (("path").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 19 -- goto _L___1
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if not (l_value.item.b).is_void then
							if (l_value.item.b).is_equal (l_value.item.e) then
								l_pos := -1 + 38 -- goto error
							end
						else
							l_pos := -1 + 38 -- goto error
						end
				when 17 then
						if (not (l_cookie.item.path).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_cookie.item.path))
						end
						l_cookie.item.path := (create {P_UTILS_STATIC}).strdupdelim (l_value.item.b, l_value.item.e)
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 35
				when 19 then -- else: | _L___1:
						if ((l_name.item.e).distance ((l_name.item.b))).to_natural_32 /= (("expires").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 26 -- skip if block
						end
				when 20 then -- if:
						if not ((strncasecmp (l_name.item.b, ce_string ("expires"), (("expires").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 26 -- goto _L___0
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 23 then -- else:
						if not (l_value.item.b).is_void then
							if (l_value.item.b).is_equal (l_value.item.e) then
								l_pos := -1 + 38 -- goto error
							end
						else
							l_pos := -1 + 38 -- goto error
						end
				when 24 then
						from
						until
							(l_break)
						loop
							l_break := False
							l_BTA_beg := l_value.item.b
							l_BTA_len := (l_value.item.e).distance (l_BTA_beg)
							l_BTA_dest := l_value_copy
							l_BTA_dest.item := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new ((l_BTA_len + 1).to_natural_32)))
							memcpy (create {CE_VOID_POINTER}.make_cast (l_BTA_dest.item), create {CE_VOID_POINTER}.make_cast (l_BTA_beg), l_BTA_len.to_natural_32).do_nothing
							l_BTA_dest.item[l_BTA_len] := (('%/0/').code).to_integer_8
							l_break := True
						end
						l_break := False
						l_expires := (create {P_HTTP_STATIC}).http_atotm (l_value_copy.item)
						if l_expires /= -1 then
							l_cookie.item.permanent := {NATURAL_32} 1
							l_cookie.item.expiry_time := l_expires
							if l_cookie.item.expiry_time < (create {P_COOKIES_STATIC}).cookies_now.item then
								l_cookie.item.discard_requested := {NATURAL_32} 1
							end
						end
				when 25 then -- if done | if block done, skip else block:
						l_pos := -1 + 35
				when 26 then -- else: | _L___0:
						if ((l_name.item.e).distance ((l_name.item.b))).to_natural_32 /= (("max-age").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 34 -- skip if block
						end
				when 27 then -- if:
						if not ((strncasecmp (l_name.item.b, ce_string ("max-age"), (("max-age").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 34 -- goto _L
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 30 then -- else:
						l_maxage.item := (-1).to_double
						if not (l_value.item.b).is_void then
							if (l_value.item.b).is_equal (l_value.item.e) then
								l_pos := -1 + 38 -- goto error
							end
						else
							l_pos := -1 + 38 -- goto error
						end
				when 31 then
						from
						until
							(l_break)
						loop
							l_break := False
							l_BTA_beg___0 := l_value.item.b
							l_BTA_len___0 := (l_value.item.e).distance (l_BTA_beg___0)
							l_BTA_dest___0 := l_value_copy___0
							l_BTA_dest___0.item := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new ((l_BTA_len___0 + 1).to_natural_32)))
							memcpy (create {CE_VOID_POINTER}.make_cast (l_BTA_dest___0.item), create {CE_VOID_POINTER}.make_cast (l_BTA_beg___0), l_BTA_len___0.to_natural_32).do_nothing
							l_BTA_dest___0.item[l_BTA_len___0] := (('%/0/').code).to_integer_8
							l_break := True
						end
						l_break := False
						sscanf ([l_value_copy___0.item, ce_string ("%%lf"), l_maxage]).do_nothing
						if l_maxage.item = (-1).to_double then
							l_pos := -1 + 38 -- goto error
						end
				when 32 then
						l_cookie.item.permanent := {NATURAL_32} 1
						l_cookie.item.expiry_time := (((create {P_COOKIES_STATIC}).cookies_now.item).to_double + l_maxage.item).truncated_to_integer
						if l_maxage.item = (0).to_double then
							l_cookie.item.discard_requested := {NATURAL_32} 1
						end
				when 33 then -- if done | if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else: | _L:
						if ((l_name.item.e).distance ((l_name.item.b))).to_natural_32 = (("secure").count + 1).to_natural_32 - {NATURAL_32} 1 then
							if not (strncasecmp (l_name.item.b, ce_string ("secure"), (("secure").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
								l_cookie.item.secure := {NATURAL_32} 1
							end
						end
				when 35 then -- if done | if done | if done | if done
						l_pos := -1 + 3 -- back to loop condition
				when 36 then -- loop done
					l_break := False
					if (l_ptr.item[0]).to_boolean then
						l_pos := -1 + 38 -- goto error
					end
				when 37 then
					Result := l_cookie
					l_return := True
					if l_return then
						l_pos := -1 + 39 -- skip if block
					end
				when 38 then -- if: | error:
						if not a_silent then
							l_tmp___9 := (create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, a_set_cookie);
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Syntax error in Set-Cookie: %%s at position %%d.%N"))), l_tmp___9, (l_ptr.item).distance (a_set_cookie)])
						end
						l_cookie.item.delete_cookie
						Result := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer))
				when 39 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_domain_match (a_cookie_domain, a_host: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_cookie_domain.is_void
			not a_host.is_void
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_dccount: INTEGER_32
			l_ldcl: INTEGER_32
			l_nldcl: INTEGER_32
			l_out: INTEGER_32
			l_i: NATURAL_32
			l_known_toplevel: INTEGER_32
			l_dlen: INTEGER_32
			l_hlen: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
							(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("cdm: 1")])
						end
						l_break := True
					end
					l_break := False
					if ((create {P_COOKIES_STATIC}).numeric_address_p (a_cookie_domain)) then
						Result := (0 = (strcmp (a_cookie_domain, a_host)))
						l_return := True
					end
					if not l_return then
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string (" 2")])
							end
							l_break := True
						end
						l_break := False
						if 0 = (strcasecmp (a_cookie_domain, a_host)) then
							Result := (1).to_boolean
							l_return := True
						end
					end
					if not l_return then
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string (" 3")])
							end
							l_break := True
						end
						l_break := False
						if not ((create {P_UTILS_STATIC}).match_tail (a_host, a_cookie_domain, (1).to_boolean)) then
							Result := (0).to_boolean
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_p___0 := a_cookie_domain
						l_dccount := 1
						l_ldcl := 0
						l_nldcl := 0
						if (l_p___0[0]).to_integer_32 = 46 then
							l_p___0 := l_p___0 + 1
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string (" 4")])
							end
							l_break := True
						end
						l_break := False
						l_out := 0
				when 2 then -- loop condition:
						if not (not (l_return) and then (not l_out.to_boolean)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 3 then -- loop body:
						inspect (l_p___0[0]).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 4
						when 46 then l_pos := -1 + 5
						else l_pos := -1 + 9
						end
				when 4 then -- switch 1, case 0
						l_out := 1
						l_pos := -1 + 10 -- switch 1; break
				when 5 then -- switch 1, case 46
						if l_ldcl = 0 then
							Result := (0).to_boolean
							l_return := True
						end
						if l_return then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_p___0[1]).to_integer_32 = 0 then
							l_out := 1
							l_pos := -1 + 10 -- switch 1; break
						end
				when 7 then
						l_nldcl := l_ldcl
						l_ldcl := 0
						l_dccount := l_dccount + 1
				when 8 then -- if done
						l_pos := -1 + 10 -- switch 1; break
				when 9 then -- switch 1, default:
						l_ldcl := l_ldcl + 1
				when 10 then -- switch 1, done:
						if not l_return then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 11 then -- loop done | if done
					if not l_return then
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string (" 5")])
							end
							l_break := True
						end
						l_break := False
						if l_dccount < 2 then
							Result := (0).to_boolean
							l_return := True
						end
					end
					if not l_return then
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string (" 6")])
							end
							l_break := True
						end
						l_break := False
						if l_dccount = 2 then
							l_known_toplevel := 0
							l_i := (0).to_natural_32
							from
							until
								not (not (l_break) and then (l_i < ({PLATFORM}.Pointer_bytes.to_natural_32 * (7).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32))
							loop
								l_break := False
								if ((create {P_UTILS_STATIC}).match_tail (a_cookie_domain, known_toplevel_domains.item[l_i.to_integer_32], (1).to_boolean)) then
									l_known_toplevel := 1
									l_break := True
								end
								if not (l_return or l_break) then
									l_i := l_i + 1
								end
							end
							l_break := False
							if not l_known_toplevel.to_boolean then
								if l_nldcl <= 3 then
									Result := (0).to_boolean
									l_return := True
								end
							end
						end
					end
					if not l_return then
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string (" 7")])
							end
							l_break := True
						end
						l_break := False
						if (a_cookie_domain[0]).to_integer_32 /= 46 then
							l_dlen := (strlen (a_cookie_domain)).to_integer_32
							l_hlen := (strlen (a_host)).to_integer_32
							if l_hlen > l_dlen then
								if (a_host[((l_hlen - l_dlen) - 1)]).to_integer_32 /= 46 then
									Result := (0).to_boolean
									l_return := True
								end
							end
						end
					end
					if not l_return then
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string (" 8")])
							end
							l_break := True
						end
						l_break := False
						Result := (1).to_boolean
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_path_match (a_cookie_path, a_path: CE_POINTER [INTEGER_8]): BOOLEAN
		do
			Result := (((create {P_COOKIES_STATIC}).path_matches (a_path, a_cookie_path)) /= 0)
		end

	ftp_expected_bytes (a_s: CE_POINTER [INTEGER_8]): INTEGER_64
		local
			l_s: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_res___0: INTEGER_64
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_s.make (<<1>>)

			l_s.item := a_s
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_continue := False
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_s.item[0]).to_boolean then
						if (l_s.item[0]).to_integer_32 = 40 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_s.item := l_s.item + 1
					end
				end
				l_break := False
				if not (l_s.item[0]).to_boolean then
					Result := (0).to_integer_64
					l_return := True
				end
				if not l_return then
					l_s.item := l_s.item + 1
					l_res___0 := strtoll (l_s.item, l_s, 10)
					if not (l_s.item[0]).to_boolean then
						Result := (0).to_integer_64
						l_return := True
					end
				end
				if not l_return then
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_s.item[0]).to_boolean then
							if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_s.item[0]).to_integer_32)) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_s.item := l_s.item + 1
						end
					end
					l_break := False
					if not (l_s.item[0]).to_boolean then
						Result := (0).to_integer_64
						l_return := True
					end
				end
				if not l_return then
					if ((create {P_C_CTYPE_STATIC}).c2_tolower ((l_s.item[0]).to_integer_32)) /= 98 then
						l_continue := True
					end
					if not (l_return or l_break or l_continue) then
						if (strncasecmp (l_s.item, ce_string ("byte"), (4).to_natural_32)).to_boolean then
							l_continue := True
						else
							l_break := True
						end
					end
				end
			end
			if not l_return then
				l_break := False
				l_continue := False
				Result := l_res___0
			end
		end

	ftp_do_pasv (a_csock: INTEGER_32; a_addr: CE_POINTER [PD_IP_ADDRESS]; a_port: CE_POINTER [INTEGER_32]): NATURAL_32
		require
			not a_addr.is_void
		local
			l_err: NATURAL_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (socket_ip_address (a_csock, a_addr, 1)) then
						abort
					end
					inspect a_addr.item.family -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> PASV ... "))
					end
					l_err := ftp_pasv (a_csock, a_addr, a_port)
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 10
					if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> EPSV ... "))
					end
					l_err := ftp_epsv (a_csock, a_addr, a_port)
					if l_err = {NATURAL_32} 36 then
						if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> LPSV ... "))
						end
						l_err := ftp_lpsv (a_csock, a_addr, a_port)
					end
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					abort
				when 4 then -- switch 1, done:
					Result := l_err
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_do_port (a_csock: INTEGER_32; a_local_sock: CE_POINTER [INTEGER_32]): NATURAL_32
		local
			l_err: NATURAL_32
			l_cip: CE_ARRAY [PD_IP_ADDRESS]
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_IP_ADDRESS]} l_cip.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (socket_ip_address (a_csock, l_cip, 1)) then
						abort
					end
					inspect l_cip.item.family -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> PORT ... "))
					end
					l_err := ftp_port (a_csock, a_local_sock)
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 10
					if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> EPRT ... "))
					end
					l_err := ftp_eprt (a_csock, a_local_sock)
					if l_err = {NATURAL_32} 13 then
						if not (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> LPRT ... "))
						end
						l_err := ftp_lprt (a_csock, a_local_sock)
					end
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					abort
				when 4 then -- switch 1, done:
					Result := l_err
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	print_length (a_size, a_start: INTEGER_64; a_authoritative: BOOLEAN)
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
		do
			l_tmp := (create {P_UTILS_STATIC}).number_to_static_string (a_size);
			(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Length: %%s"))), l_tmp])
			if a_size >= {INTEGER_64} 1_024 then
				(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (" (%%s)"), ((create {P_UTILS_STATIC}).human_readable (a_size))])
			end
			if a_start > {INTEGER_64} 0 then
				if a_size - a_start >= {INTEGER_64} 1_024 then
					l_tmp___2 := (create {P_UTILS_STATIC}).human_readable (a_size - a_start)
					l_tmp___3 := (create {P_UTILS_STATIC}).number_to_static_string (a_size - a_start);
					(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string (", %%s (%%s) remaining"))), l_tmp___3, l_tmp___2])
				else
					l_tmp___5 := (create {P_UTILS_STATIC}).number_to_static_string (a_size - a_start);
					(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string (", %%s remaining"))), l_tmp___5])
				end
			end
			if not a_authoritative then
				l_tmp___8 := (gettext (ce_string (" (unauthoritative)%N")))
			else
				l_tmp___8 := ce_string ("%N")
			end
			(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___8)
		end

	ftp_retrieve_list (a_u: CE_POINTER [PD_URL]; a_f: CE_POINTER [PD_FILEINFO]; a_con: CE_POINTER [PD_CCON]): NATURAL_32
		local
			l_f: CE_POINTER [PD_FILEINFO]
			l_err: NATURAL_32
			l_orig: CE_POINTER [PD_FILEINFO]
			l_local_size: INTEGER_64
			l_tml: INTEGER_32
			l_dlthis: BOOLEAN
			l_actual_target: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_old_target: CE_POINTER [INTEGER_8]
			l_ofile: CE_POINTER [INTEGER_8]
			l_st: CE_ARRAY [SD_STAT]
			l_eq_size: BOOLEAN
			l_cor_val: BOOLEAN
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_st___0: CE_ARRAY [SD_STAT]
			l_rc: INTEGER_32
			l_len: NATURAL_32
			l_link_target: CE_POINTER [INTEGER_8]
			l_n: NATURAL_32
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___18: CE_POINTER [INTEGER_8]
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___24: CE_POINTER [INTEGER_8]
			l_tmp___26: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_POINTER [PD_FILEINFO]} l_orig.make
			create {CE_POINTER_ARRAY [INTEGER_8]} l_actual_target.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_f := a_f
					l_actual_target.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					depth.item := depth.item + 1
					if (create {P_OPTIONS_STATIC}).opt.item.item.reclevel /= -1 then
						if depth.item > (create {P_OPTIONS_STATIC}).opt.item.item.reclevel then
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([(gettext (ce_string ("Recursion depth %%d exceeded max. depth %%d.%N"))), depth.item, (create {P_OPTIONS_STATIC}).opt.item.item.reclevel])
								end
								l_break := True
							end
							l_break := False
							depth.item := depth.item - 1
							Result := ({PC_UERR_T}.RECLEVELEXC)
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 34 -- skip if block
					end
				when 1 then -- if:
						if l_f.is_void then
							assert_fail (ce_string ("f != ((void *)0)"), ce_string ("ftp.c"), {NATURAL_32} 1_670, ce_string ("ftp_retrieve_list"))
						end
						l_orig := l_f
						a_con.item.st := (a_con.item.st).bit_and ((-2))
						if not ((a_con.item.st).bit_and (2)).to_boolean then
							a_con.item.cmd := (a_con.item.cmd).bit_or ((2))
						else
							a_con.item.cmd := (a_con.item.cmd).bit_and ((-3))
						end
						a_con.item.cmd := (a_con.item.cmd).bit_or ((20))
						if a_con.item.csock < 0 then
							a_con.item.cmd := (a_con.item.cmd).bit_or ((1))
						else
							a_con.item.cmd := (a_con.item.cmd).bit_and ((-2))
						end
						l_err := {PC_UERR_T}.RETROK
				when 2 then -- loop condition:
						if not (not (l_return or l_break) and then (not l_f.is_void)) then
							l_pos := -1 + 34 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if ((create {P_OPTIONS_STATIC}).opt.item.item.quota).to_boolean then
							if (create {P_RETR_STATIC}).total_downloaded_bytes.item > (create {P_OPTIONS_STATIC}).opt.item.item.quota then
								depth.item := depth.item - 1
								Result := ({PC_UERR_T}.QUOTEXC)
								l_return := True
							end
						end
						if l_return then
							l_pos := -1 + 33 -- skip if block
						end
				when 4 then -- if:
						l_old_target := a_con.item.target
						l_ofile := (create {P_XMALLOC_STATIC}).xstrdup (a_u.item.file)
						a_u.item.url_set_file (l_f.item.name)
						a_con.item.target := a_u.item.url_file_name
						l_err := {PC_UERR_T}.RETROK
						l_dlthis := (1).to_boolean
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.timestamping) then
							l_pos := -1 + 11 -- skip if block
						end
				when 5 then -- if:
						if l_f.item.type /= {NATURAL_32} 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						if (stat (a_con.item.target, l_st)).to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 7 then -- if:
						l_local_size := (l_st.item.st_size).to_integer_64
						l_tml := l_st.item.st_mtim.tv_sec
						if a_con.item.rs = {NATURAL_32} 0 then
							l_tmp___1 := 1
						elseif a_con.item.rs = {NATURAL_32} 2 then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
						l_cor_val := l_tmp___1.to_boolean
						if l_cor_val then
							l_eq_size := (l_local_size = l_f.item.size)
						else
							l_eq_size := (1).to_boolean
						end
						if not (l_f.item.tstamp <= l_tml) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_eq_size then
							l_tmp___2 := (create {P_QUOTE_STATIC}).quote (a_con.item.target);
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Remote file no newer than local file %%s -- not retrieving.%N"))), l_tmp___2])
							l_dlthis := (0).to_boolean
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if l_eq_size then
							l_tmp___4 := (create {P_QUOTE_STATIC}).quote (a_con.item.target);
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Remote file is newer than local file %%s -- retrieving.%N%N"))), l_tmp___4])
						else
							l_tmp___6 := (create {P_UTILS_STATIC}).number_to_static_string (l_local_size);
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("The sizes do not match (local %%s) -- retrieving.%N%N"))), l_tmp___6])
						end
				when 11 then -- if done | if done | if done
						inspect (l_f.item.type).to_integer_32 -- switch 1 head
						when 2 then l_pos := -1 + 12
						when 1 then l_pos := -1 + 21
						when 0 then l_pos := -1 + 22
						when 3 then l_pos := -1 + 23
						else l_pos := -1 + 24
						end
				when 12 then -- switch 1, case 2
						if (create {P_OPTIONS_STATIC}).opt.item.item.retr_symlinks then
							l_pos := -1 + 19 -- skip if block
						end
				when 13 then -- if:
						if (not (l_f.item.linkto).is_void) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:;
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Invalid name of the symlink, skipping.%N"))))
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						l_rc := (lstat (a_con.item.target, l_st___0))
						if l_rc = 0 then
							l_len := (strlen (l_f.item.linkto)) + {NATURAL_32} 1
							if ((l_st___0.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 40_960 then
								l_link_target := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new (l_len)))
								l_n := (readlink (a_con.item.target, l_link_target, l_len)).to_natural_32
								if l_n = l_len - {NATURAL_32} 1 then
									if (memcmp (create {CE_VOID_POINTER}.make_cast (l_link_target), create {CE_VOID_POINTER}.make_cast (l_f.item.linkto), l_n)) = 0 then
										l_tmp___14 := (create {P_QUOTE_STATIC}).quote (l_f.item.linkto)
										l_tmp___15 := (create {P_QUOTE_STATIC}).quote (a_con.item.target);
										(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Already have correct symlink %%s -> %%s%N%N"))), l_tmp___15, l_tmp___14])
										l_dlthis := (0).to_boolean
										l_pos := -1 + 24 -- switch 1; break
									end
								end
							end
						end
				when 17 then
						l_tmp___18 := (create {P_QUOTE_STATIC}).quote (l_f.item.linkto)
						l_tmp___19 := (create {P_QUOTE_STATIC}).quote (a_con.item.target);
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Creating symlink %%s -> %%s%N"))), l_tmp___19, l_tmp___18])
						unlink (a_con.item.target).do_nothing
						if (symlink (l_f.item.linkto, a_con.item.target)) = -1 then
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("symlink: %%s%N"), (strerror ((errno_location).item))])
						end
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						if l_dlthis then
							l_err := ftp_loop_internal (a_u, l_f, a_con)
						end
				when 20 then -- if done
						l_pos := -1 + 24 -- switch 1; break
				when 21 then -- switch 1, case 1
						if not (create {P_OPTIONS_STATIC}).opt.item.item.recursive then
							l_tmp___24 := (create {P_QUOTE_STATIC}).quote (l_f.item.name);
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Skipping directory %%s.%N"))), l_tmp___24])
						end
						l_pos := -1 + 24 -- switch 1; break
				when 22 then -- switch 1, case 0
						if l_dlthis then
							l_err := ftp_loop_internal (a_u, l_f, a_con)
						end
						l_pos := -1 + 24 -- switch 1; break
				when 23 then -- switch 1, case 3
						l_tmp___26 := (create {P_QUOTE_STATIC}).quote (l_f.item.name);
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s: unknown/unsupported file type.%N"))), l_tmp___26])
						l_pos := -1 + 24 -- switch 1; break
				when 24 then -- switch 1, done:;
						(create {P_RETR_STATIC}).set_local_file (l_actual_target, a_con.item.target)
						if l_dlthis then
							if not (l_actual_target.item).is_void then
								if l_f.item.type = {NATURAL_32} 0 then
									if (l_f.item.perms).to_boolean then
										chmod (l_actual_target.item, (l_f.item.perms).to_natural_32).do_nothing
									else
										from
										until
											(l_break)
										loop
											l_break := False
											if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
												(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Unrecognized permissions for %%s.%N"), l_actual_target.item])
											end
											l_break := True
										end
										l_break := False
									end
								end
							end
						end
						if (l_actual_target.item).is_void then
							l_pos := -1 + 32 -- skip if block
						end
				when 25 then -- if:
						if l_f.item.type /= {NATURAL_32} 2 then
							l_pos := -1 + 31 -- skip if block
						end
				when 26 then -- if:
						if (create {P_OPTIONS_STATIC}).opt.item.item.retr_symlinks then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if: | _L___2:
						if l_f.item.tstamp = -1 then
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s: corrupt time-stamp.%N"))), l_actual_target.item])
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						l_pos := -1 + 31 -- goto _L___3
				when 30 then -- if done | if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else: | _L___3:
						if l_f.item.tstamp /= -1 then
							if l_dlthis then
								if ((create {P_UTILS_STATIC}).file_exists_p (a_con.item.target)) then
									(create {P_UTILS_STATIC}).touch (l_actual_target.item, l_f.item.tstamp)
								else
									l_pos := -1 + 27 -- goto _L___2
								end
							else
								l_pos := -1 + 27 -- goto _L___2
							end
						else
							l_pos := -1 + 27 -- goto _L___2
						end
				when 32 then -- if done
						free (create {CE_VOID_POINTER}.make_cast (a_con.item.target))
						a_con.item.target := l_old_target
						a_u.item.url_set_file (l_ofile)
						free (create {CE_VOID_POINTER}.make_cast (l_ofile))
						if l_err = {NATURAL_32} 51 then
							l_break := True
						elseif l_err = {NATURAL_32} 1 then
							l_break := True
						elseif l_err = {NATURAL_32} 26 then
							l_break := True
						end
						if not (l_return or l_break) then
							a_con.item.cmd := (a_con.item.cmd).bit_and ((-4))
							l_f := l_f.item.next
						end
				when 33 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 34 then -- loop done | if done
					if l_return then
						l_pos := -1 + 40 -- skip if block
					end
				when 35 then -- if:
						l_break := False
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.recursive) then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						if (create {P_OPTIONS_STATIC}).opt.item.item.reclevel /= -1 then
							if depth.item >= (create {P_OPTIONS_STATIC}).opt.item.item.reclevel then
								l_pos := -1 + 38 -- goto _L___4
							else
								l_err := ftp_retrieve_dirs (a_u, l_orig, a_con)
							end
						else
							l_err := ftp_retrieve_dirs (a_u, l_orig, a_con)
						end
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 38 then -- else: | _L___4:
						if (create {P_OPTIONS_STATIC}).opt.item.item.recursive then
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([(gettext (ce_string ("Will not retrieve dirs since depth is %%d (max %%d).%N"))), depth.item, (create {P_OPTIONS_STATIC}).opt.item.item.reclevel])
								end
								l_break := True
							end
							l_break := False
						end
				when 39 then
						depth.item := depth.item - 1
						Result := l_err
				when 40 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_loop_internal (a_u: CE_POINTER [PD_URL]; a_f: CE_POINTER [PD_FILEINFO]; a_con: CE_POINTER [PD_CCON]): NATURAL_32
		require
			not a_con.is_void
		local
			l_count: INTEGER_32
			l_orig_lp: INTEGER_32
			l_restval: INTEGER_64
			l_len: INTEGER_64
			l_qtyread: CE_ARRAY [INTEGER_64]
			l_tms: CE_POINTER [INTEGER_8]
			l_locf: CE_POINTER [INTEGER_8]
			l_tmrate: CE_POINTER [INTEGER_8]
			l_err: NATURAL_32
			l_st: CE_ARRAY [SD_STAT]
			l_tmp: CE_POINTER [INTEGER_8]
			l_hurl: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_ARRAY [INTEGER_8]
			l_write_to_stdout: BOOLEAN
			l_tmp___9: INTEGER_32
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_hurl___0: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_64_ARRAY} l_qtyread.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_tmp___5.make (<<256>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := (0).to_integer_64
					l_qtyread.item := (0).to_integer_64
					l_tmrate := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					if not (a_f.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (not (a_con.item.target).is_void) then
							l_locf := a_con.item.target
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						a_con.item.target := a_u.item.url_file_name
						if ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void then
							l_locf := a_con.item.target
						else
							l_locf := (create {P_OPTIONS_STATIC}).opt.item.item.output_document
						end
				when 4 then
					if (create {P_OPTIONS_STATIC}).opt.item.item.noclobber then
						if ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void then
							if ((create {P_UTILS_STATIC}).file_exists_p (a_con.item.target)) then
								l_tmp := (create {P_QUOTE_STATIC}).quote (a_con.item.target);
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("File %%s already there; not retrieving.%N"))), l_tmp])
								Result := ({PC_UERR_T}.RETROK)
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 22 -- skip if block
					end
				when 5 then -- if:
						remove_link (a_con.item.target).do_nothing
						l_count := 0
						if ((a_con.item.st).bit_and (1)).to_boolean then
							a_con.item.st := 1
						end
						if ((a_con.item.cmd).bit_and (16)).to_boolean then
							l_orig_lp := 1
						else
							l_orig_lp := 0
						end
				when 6 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 22 -- skip loop
						end
				when 7 then -- loop body:
						l_break := False
						l_continue := False
						l_count := l_count + 1;
						(create {P_RETR_STATIC}).sleep_between_retrievals (l_count)
						if ((a_con.item.st).bit_and (1)).to_boolean then
							a_con.item.cmd := 0
							a_con.item.cmd := (a_con.item.cmd).bit_or ((20))
							if a_con.item.csock /= -1 then
								a_con.item.cmd := (a_con.item.cmd).bit_and ((-4))
							else
								a_con.item.cmd := (a_con.item.cmd).bit_or ((3))
							end
						else
							if a_con.item.csock /= -1 then
								a_con.item.cmd := (a_con.item.cmd).bit_and ((-2))
							else
								a_con.item.cmd := (a_con.item.cmd).bit_or ((1))
							end
							if ((a_con.item.st).bit_and (2)).to_boolean then
								a_con.item.cmd := (a_con.item.cmd).bit_and ((-3))
							else
								a_con.item.cmd := (a_con.item.cmd).bit_or ((2))
							end
						end
						if not (((a_con.item.cmd).bit_and (8)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_restval := (0).to_integer_64
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.always_rest) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (stat (l_locf, l_st)) = 0 then
							if ((l_st.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 32_768 then
								l_restval := (l_st.item.st_size).to_integer_64
							else
								l_pos := -1 + 13 -- goto _L___1
							end
						else
							l_pos := -1 + 13 -- goto _L___1
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___1:
						if l_count > 1 then
							l_restval := l_qtyread.item
						else
							l_restval := (0).to_integer_64
						end
				when 14 then -- if done
						l_tms := (create {P_UTILS_STATIC}).datetime_str ((time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))))
						if ((create {P_OPTIONS_STATIC}).opt.item.item.verbose).to_boolean then
							l_hurl := (a_u.item.url_string ({PC_URL_AUTH_MODE}.URL_AUTH_HIDE_PASSWD))
							strcpy (l_tmp___5, ce_string ("        ")).do_nothing
							if l_count > 1 then
								sprintf ([l_tmp___5, (gettext (ce_string ("(try:%%2d)"))), l_count]).do_nothing
							end
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("--%%s--  %%s%N  %%s => %%s%N"), l_tms, l_hurl, l_tmp___5, ((create {P_QUOTE_STATIC}).quote (l_locf))])
							free (create {CE_VOID_POINTER}.make_cast (l_hurl))
						end
						if (not a_f.is_void) then
							l_len := a_f.item.size
						else
							l_len := (0).to_integer_64
						end
						l_err := a_u.item.getftp (l_len, l_qtyread, l_restval, a_con)
						if a_con.item.csock = -1 then
							a_con.item.st := (a_con.item.st).bit_and ((-3))
						else
							a_con.item.st := (a_con.item.st).bit_or ((2))
						end
						inspect l_err.to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 15
						when 5 then l_pos := -1 + 15
						when 26 then l_pos := -1 + 15
						when 24 then l_pos := -1 + 15
						when 15 then l_pos := -1 + 15
						when 11 then l_pos := -1 + 15
						when 36 then l_pos := -1 + 15
						when 37 then l_pos := -1 + 15
						when 2 then l_pos := -1 + 16
						when 3 then l_pos := -1 + 16
						when 20 then l_pos := -1 + 16
						when 18 then l_pos := -1 + 16
						when 52 then l_pos := -1 + 16
						when 17 then l_pos := -1 + 16
						when 14 then l_pos := -1 + 16
						when 13 then l_pos := -1 + 16
						when 12 then l_pos := -1 + 16
						when 35 then l_pos := -1 + 16
						when 25 then l_pos := -1 + 16
						when 21 then l_pos := -1 + 17
						when 39 then l_pos := -1 + 18
						else l_pos := -1 + 19
						end
				when 15 then -- switch 1, case 1 | switch 1, case 5 | switch 1, case 26 | switch 1, case 24 | switch 1, case 15 | switch 1, case 11 | switch 1, case 36 | switch 1, case 37
						Result := l_err
						l_return := True
				when 16 then -- switch 1, case 2 | switch 1, case 3 | switch 1, case 20 | switch 1, case 18 | switch 1, case 52 | switch 1, case 17 | switch 1, case 14 | switch 1, case 13 | switch 1, case 12 | switch 1, case 35 | switch 1, case 25
						if not l_return then
							(create {P_RETR_STATIC}).printwhat (l_count, (create {P_OPTIONS_STATIC}).opt.item.item.ntry)
							if l_err = {NATURAL_32} 25 then
								if (not (a_con.item.target).is_void) then
									free (create {CE_VOID_POINTER}.make_cast (a_con.item.target))
								end
								a_con.item.target := a_u.item.url_file_name
								l_locf := a_con.item.target
							end
							l_continue := True
						end
				when 17 then -- switch 1, case 21
						if not (l_return or l_break or l_continue) then
							if a_f.is_void then
								(create {P_RETR_STATIC}).printwhat (l_count, (create {P_OPTIONS_STATIC}).opt.item.item.ntry)
								l_continue := True
							elseif l_qtyread.item /= a_f.item.size then
								(create {P_RETR_STATIC}).printwhat (l_count, (create {P_OPTIONS_STATIC}).opt.item.item.ntry)
								l_continue := True
							end
						end
						l_pos := -1 + 20 -- switch 1; break
				when 18 then -- switch 1, case 39
						l_pos := -1 + 20 -- switch 1; break
				when 19 then -- switch 1, default:
						abort
				when 20 then -- switch 1, done:
						if not l_return then
							if not (l_return or l_break or l_continue) then
								l_tms := (create {P_UTILS_STATIC}).datetime_str ((time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))))
								if not (create {P_OPTIONS_STATIC}).opt.item.item.spider then
									l_tmrate := (create {P_RETR_STATIC}).retr_rate (l_qtyread.item - l_restval, a_con.item.dltime)
								end
								(create {P_CONVERT_STATIC}).downloaded_file ({PC_DOWNLOADED_FILE_T}.FILE_DOWNLOADED_NORMALLY, l_locf).do_nothing
								if ((a_con.item.st).bit_and (1)).to_boolean then
									(create {P_CONNECT_STATIC}).fd_close (a_con.item.csock)
									a_con.item.csock := -1
								end
								if not (create {P_OPTIONS_STATIC}).opt.item.item.spider then
									if (not ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void) then
										if (((create {P_OPTIONS_STATIC}).opt.item.item.output_document).item).to_integer_32 = 45 then
											if not ((create {P_OPTIONS_STATIC}).opt.item.item.output_document[1]).to_boolean then
												l_tmp___9 := 1
											else
												l_tmp___9 := 0
											end
										else
											l_tmp___9 := 0
										end
									else
										l_tmp___9 := 0
									end
									l_write_to_stdout := l_tmp___9.to_boolean
									l_tmp___10 := (create {P_UTILS_STATIC}).number_to_static_string (l_qtyread.item)
									if l_write_to_stdout then
										l_tmp___12 := ce_string ("")
									else
										l_tmp___12 := ((create {P_QUOTE_STATIC}).quote (l_locf))
									end
									if l_write_to_stdout then
										l_tmp___15 := (gettext (ce_string ("%%s (%%s) - written to stdout %%s[%%s]%N%N")))
									else
										l_tmp___15 := (gettext (ce_string ("%%s (%%s) - %%s saved [%%s]%N%N")))
									end
									(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___15, l_tms, l_tmrate, l_tmp___12, l_tmp___10])
								end
								if not ((create {P_OPTIONS_STATIC}).opt.item.item.verbose).to_boolean then
									if not (create {P_OPTIONS_STATIC}).opt.item.item.quiet then
										l_hurl___0 := (a_u.item.url_string ({PC_URL_AUTH_MODE}.URL_AUTH_HIDE_PASSWD));
										(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NONVERBOSE, ce_string ("%%s URL: %%s [%%s] -> %"%%s%" [%%d]%N"), l_tms, l_hurl___0, ((create {P_UTILS_STATIC}).number_to_static_string (l_qtyread.item)), l_locf, l_count])
										free (create {CE_VOID_POINTER}.make_cast (l_hurl___0))
									end
								end
								if ((a_con.item.cmd).bit_and (8)).to_boolean then
									if not (create {P_OPTIONS_STATIC}).opt.item.item.remove_listing then
										(create {P_RETR_STATIC}).total_downloaded_bytes.item := (create {P_RETR_STATIC}).total_downloaded_bytes.item + (l_qtyread.item);
										(create {P_MAIN_STATIC}).numurls.item := (create {P_MAIN_STATIC}).numurls.item + 1
									end
								elseif not (create {P_OPTIONS_STATIC}).opt.item.item.spider then
									(create {P_RETR_STATIC}).total_downloaded_bytes.item := (create {P_RETR_STATIC}).total_downloaded_bytes.item + (l_qtyread.item);
									(create {P_MAIN_STATIC}).numurls.item := (create {P_MAIN_STATIC}).numurls.item + 1
									if (create {P_OPTIONS_STATIC}).opt.item.item.delete_after then
										from
										until
											(l_break)
										loop
											l_break := False
											if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
												(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Removing file due to --delete-after in ftp_loop_internal():%N")])
											end
											l_break := True
										end
										l_break := False;
										(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Removing %%s.%N"))), l_locf])
										if (unlink (l_locf)).to_boolean then
											(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("unlink: %%s%N"), (strerror ((errno_location).item))])
										end
									end
								end
								if l_orig_lp.to_boolean then
									a_con.item.cmd := (a_con.item.cmd).bit_or ((16))
								else
									a_con.item.cmd := (a_con.item.cmd).bit_and ((-17))
								end
								Result := ({PC_UERR_T}.RETROK)
								l_return := True
							end
							if (not l_return and not l_break) and then (((create {P_OPTIONS_STATIC}).opt.item.item.ntry).to_boolean) then
								if not (l_count < (create {P_OPTIONS_STATIC}).opt.item.item.ntry) then
									l_pos := -1 + 22 -- break
								end
							end
						end
				when 21 then
						l_pos := -1 + 6 -- back to loop condition
				when 22 then -- loop done | if done
					if not l_return then
						l_break := False
						l_continue := False
						if a_con.item.csock /= -1 then
							if ((a_con.item.st).bit_and (1)).to_boolean then
								(create {P_CONNECT_STATIC}).fd_close (a_con.item.csock)
								a_con.item.csock := -1
							end
						end
						Result := ({PC_UERR_T}.TRYLIMEXC)
					end
				when 23 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_retrieve_dirs (a_u: CE_POINTER [PD_URL]; a_f: CE_POINTER [PD_FILEINFO]; a_con: CE_POINTER [PD_CCON]): NATURAL_32
		local
			l_f: CE_POINTER [PD_FILEINFO]
			l_container: CE_POINTER [INTEGER_8]
			l_container_size: INTEGER_32
			l_size: INTEGER_32
			l_odir: CE_POINTER [INTEGER_8]
			l_newdir: CE_POINTER [INTEGER_8]
			l_tmp: NATURAL_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_INTEGER_8_POINTER} l_newdir.make

			l_f := a_f
			l_container := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_container_size := 0
			from
			until
				not (not (l_return or l_break) and then (not l_f.is_void))
			loop
				l_break := False
				l_continue := False
				if ((create {P_OPTIONS_STATIC}).opt.item.item.quota).to_boolean then
					if (create {P_RETR_STATIC}).total_downloaded_bytes.item > (create {P_OPTIONS_STATIC}).opt.item.item.quota then
						l_break := True
					end
				end
				if not (l_return or l_break or l_continue) and then (l_f.item.type /= {NATURAL_32} 1) then
					l_continue := True
				end
				if not (l_return or l_break or l_continue) then
					l_tmp := strlen (a_u.item.dir)
					l_size := (((l_tmp + {NATURAL_32} 1) + (strlen (l_f.item.name))) + {NATURAL_32} 1).to_integer_32
					if l_size > l_container_size then
						l_container := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new (l_size.to_natural_32)))
					end
					l_newdir := l_container
					l_odir := a_u.item.dir
					if (l_odir[0]).to_integer_32 = 0 then
						sprintf ([l_newdir, ce_string ("%%s%%s"), l_odir, l_f.item.name]).do_nothing
					elseif (l_odir[0]).to_integer_32 = 47 then
						if (l_odir[1]).to_integer_32 = 0 then
							sprintf ([l_newdir, ce_string ("%%s%%s"), l_odir, l_f.item.name]).do_nothing
						else
							sprintf ([l_newdir, ce_string ("%%s/%%s"), l_odir, l_f.item.name]).do_nothing
						end
					else
						sprintf ([l_newdir, ce_string ("%%s/%%s"), l_odir, l_f.item.name]).do_nothing
					end
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
							(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Composing new CWD relative to the initial directory.%N")])
						end
						l_break := True
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
							(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("  odir = %'%%s%'%N  f->name = %'%%s%'%N  newdir = %'%%s%'%N%N"), l_odir, l_f.item.name, l_newdir])
						end
						l_break := True
					end
					l_break := False
					if not ((create {P_UTILS_STATIC}).accdir (l_newdir)) then
						l_tmp___4 := (create {P_QUOTE_STATIC}).quote (l_newdir);
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Not descending to %%s as it is excluded/not-included.%N"))), l_tmp___4])
						l_continue := True
					end
				end
				if not (l_return or l_break or l_continue) then
					a_con.item.st := (a_con.item.st).bit_and ((-3))
					l_odir := (create {P_XMALLOC_STATIC}).xstrdup (a_u.item.dir)
					a_u.item.url_set_dir (l_newdir)
					a_u.item.ftp_retrieve_glob (a_con, 1).do_nothing
					a_u.item.url_set_dir (l_odir)
					free (create {CE_VOID_POINTER}.make_cast (l_odir))
				end
				if (not l_return and not l_break) then
					l_f := l_f.item.next
				end
			end
			l_break := False
			l_continue := False
			if ((create {P_OPTIONS_STATIC}).opt.item.item.quota).to_boolean then
				if (create {P_RETR_STATIC}).total_downloaded_bytes.item > (create {P_OPTIONS_STATIC}).opt.item.item.quota then
					Result := ({PC_UERR_T}.QUOTEXC)
				else
					Result := ({PC_UERR_T}.RETROK)
				end
			else
				Result := ({PC_UERR_T}.RETROK)
			end
		end

	has_insecure_name_p (a_s: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_s.is_void
		local
			l_return: BOOLEAN
		do
			if (a_s[0]).to_integer_32 = 47 then
				Result := (1).to_boolean
				l_return := True
			end
			if not l_return then
				if not (strstr (a_s, ce_string ("../"))).is_void then
					Result := (1).to_boolean
					l_return := True
				end
			end
			if not l_return then
				Result := (0).to_boolean
			end
		end

	delelement (a_f: CE_POINTER [PD_FILEINFO]; a_start: CE_POINTER [CE_POINTER [PD_FILEINFO]]): CE_POINTER [PD_FILEINFO]
		require
			not a_f.is_void
		local
			l_prev: CE_POINTER [PD_FILEINFO]
			l_next: CE_POINTER [PD_FILEINFO]
		do
			l_prev := a_f.item.prev
			l_next := a_f.item.next
			free (create {CE_VOID_POINTER}.make_cast (a_f.item.name))
			if (not (a_f.item.linkto).is_void) then
				free (create {CE_VOID_POINTER}.make_cast (a_f.item.linkto))
			end
			free (create {CE_VOID_POINTER}.make_cast (a_f))
			if (not l_next.is_void) then
				l_next.item.prev := l_prev
			end
			if (not l_prev.is_void) then
				l_prev.item.next := l_next
			else
				a_start.item := l_next
			end
			Result := l_next
		end

	ftp_login (a_csock: INTEGER_32; a_acc, a_pass: CE_POINTER [INTEGER_8]): NATURAL_32
		local
			l_pass: CE_POINTER [INTEGER_8]
			l_err: NATURAL_32
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_nwritten: INTEGER_32
			l_i: NATURAL_32
			l_seed: CE_POINTER [INTEGER_8]
			l_l: INTEGER_32
			l_skey_sequence: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_respline.make (<<1>>)

			l_pass := a_pass
			l_err := ftp_response (a_csock, l_respline)
			if l_err /= {NATURAL_32} 10 then
				Result := l_err
				l_return := True
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 /= 50) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPSRVERR)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				l_request := ftp_request (ce_string ("USER"), a_acc)
				l_nwritten := fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
				if l_nwritten < 0 then
					free (create {CE_VOID_POINTER}.make_cast (l_request))
					Result := ({PC_UERR_T}.WRITEFAILED)
					l_return := True
				end
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline)
				if l_err /= {NATURAL_32} 10 then
					Result := l_err
					l_return := True
				end
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 = 50) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPOK)
				l_return := True
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 /= 51) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPLOGREFUSED)
				l_return := True
			end
			if not l_return then
				l_seed := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				l_i := (0).to_natural_32
				from
				until
					not (not (l_break) and then (l_i < ({PLATFORM}.Pointer_bytes.to_natural_32 * (2).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32))
				loop
					l_break := False
					l_l := (strlen (skey_head.item[l_i.to_integer_32])).to_integer_32
					if 0 = (strncasecmp (skey_head.item[l_i.to_integer_32], l_respline.item, l_l.to_natural_32)) then
						l_seed := (l_respline.item + l_l)
						l_break := True
					end
					if not (l_break) then
						l_i := l_i + 1
					end
				end
				l_break := False
				if (not l_seed.is_void) then
					l_skey_sequence := 0
					from
					until
						(l_break)
					loop
						l_break := False
						if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_seed[0]).to_integer_32)) then
							l_break := True
						end
						if not (l_break) then
							l_skey_sequence := (10 * l_skey_sequence + (l_seed[0]).to_integer_32) - 48
							l_seed := l_seed + 1
						end
					end
					l_break := False
					if (l_seed[0]).to_integer_32 = 32 then
						l_seed := l_seed + 1
					else
						free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
						Result := ({PC_UERR_T}.FTPLOGREFUSED)
						l_return := True
					end
					if not l_return then
						l_pass := skey_response (l_skey_sequence, l_seed, l_pass)
					end
				end
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				l_request := ftp_request (ce_string ("PASS"), l_pass)
				l_nwritten := fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
				if l_nwritten < 0 then
					free (create {CE_VOID_POINTER}.make_cast (l_request))
					Result := ({PC_UERR_T}.WRITEFAILED)
					l_return := True
				end
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline)
				if l_err /= {NATURAL_32} 10 then
					Result := l_err
					l_return := True
				end
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 /= 50) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPLOGINC)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_port (a_csock: INTEGER_32; a_local_sock: CE_POINTER [INTEGER_32]): NATURAL_32
		local
			l_err: NATURAL_32
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_addr: CE_ARRAY [PD_IP_ADDRESS]
			l_nwritten: INTEGER_32
			l_port: CE_ARRAY [INTEGER_32]
			l_bytes: CE_ARRAY [INTEGER_8]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_respline.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_IP_ADDRESS]} l_addr.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_port.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_bytes.make (<<25>>)

			if not (socket_ip_address (a_csock, l_addr, 0)) then
				Result := ({PC_UERR_T}.FTPSYSERR)
				l_return := True
			end
			if not l_return then
				if l_addr.item.family /= 2 then
					assert_fail (ce_string ("addr.family == 2"), ce_string ("ftp-basic.c"), {NATURAL_32} 282, ce_string ("ftp_port"))
				end
				l_port.item := 0
				a_local_sock.item := l_addr.item.bind_local (l_port)
				if a_local_sock.item < 0 then
					Result := ({PC_UERR_T}.FTPSYSERR)
					l_return := True
				end
			end
			if not l_return then
				ip_address_to_port_repr (l_addr, l_port.item, l_bytes, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (25).to_natural_32))
				l_request := ftp_request (ce_string ("PORT"), l_bytes)
				l_nwritten := fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
				if l_nwritten < 0 then
					free (create {CE_VOID_POINTER}.make_cast (l_request));
					(create {P_CONNECT_STATIC}).fd_close (a_local_sock.item)
					Result := ({PC_UERR_T}.WRITEFAILED)
					l_return := True
				end
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline)
				if l_err /= {NATURAL_32} 10 then
					(create {P_CONNECT_STATIC}).fd_close (a_local_sock.item)
					Result := l_err
					l_return := True
				end
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 /= 50) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item));
				(create {P_CONNECT_STATIC}).fd_close (a_local_sock.item)
				Result := ({PC_UERR_T}.FTPPORTERR)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ip_address_to_port_repr (a_addr: CE_POINTER [PD_IP_ADDRESS]; a_port: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_buflen: NATURAL_32)
		require
			not a_addr.is_void
			not a_buf___6.is_void
		local
			l_ptr: CE_POINTER [NATURAL_8]
		do
			if a_addr.item.family /= 2 then
				assert_fail (ce_string ("addr->family == 2"), ce_string ("ftp-basic.c"), {NATURAL_32} 254, ce_string ("ip_address_to_port_repr"))
			end
			if not (a_buflen >= {NATURAL_32} 24) then
				assert_fail (ce_string ("buflen >= 6 * 4"), ce_string ("ftp-basic.c"), {NATURAL_32} 256, ce_string ("ip_address_to_port_repr"))
			end
			l_ptr := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_DATA]}.make_shared (a_addr.c_pointer + (create {PD_IP_ADDRESS}.make).offset_of ("data"))))
			snprintf ([a_buf___6, a_buflen, ce_string ("%%d,%%d,%%d,%%d,%%d,%%d"), (l_ptr[0]).to_integer_32, (l_ptr[1]).to_integer_32, (l_ptr[2]).to_integer_32, (l_ptr[3]).to_integer_32, (((a_port).bit_and (65_280))).bit_shift_right (8), (a_port).bit_and (255)]).do_nothing
			a_buf___6[(a_buflen - {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_integer_8
		end

	ftp_lprt (a_csock: INTEGER_32; a_local_sock: CE_POINTER [INTEGER_32]): NATURAL_32
		local
			l_err: NATURAL_32
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_addr: CE_ARRAY [PD_IP_ADDRESS]
			l_nwritten: INTEGER_32
			l_port: CE_ARRAY [INTEGER_32]
			l_bytes: CE_ARRAY [INTEGER_8]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_respline.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_IP_ADDRESS]} l_addr.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_port.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_bytes.make (<<85>>)

			if not (socket_ip_address (a_csock, l_addr, 0)) then
				Result := ({PC_UERR_T}.FTPSYSERR)
				l_return := True
			end
			if not l_return then
				if l_addr.item.family /= 2 then
					if l_addr.item.family /= 10 then
						assert_fail (ce_string ("addr.family == 2 || addr.family == 10"), ce_string ("ftp-basic.c"), {NATURAL_32} 372, ce_string ("ftp_lprt"))
					end
				end
				l_port.item := 0
				a_local_sock.item := l_addr.item.bind_local (l_port)
				if a_local_sock.item < 0 then
					Result := ({PC_UERR_T}.FTPSYSERR)
					l_return := True
				end
			end
			if not l_return then
				ip_address_to_lprt_repr (l_addr, l_port.item, l_bytes, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (85).to_natural_32))
				l_request := ftp_request (ce_string ("LPRT"), l_bytes)
				l_nwritten := fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
				if l_nwritten < 0 then
					free (create {CE_VOID_POINTER}.make_cast (l_request));
					(create {P_CONNECT_STATIC}).fd_close (a_local_sock.item)
					Result := ({PC_UERR_T}.WRITEFAILED)
					l_return := True
				end
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline)
				if l_err /= {NATURAL_32} 10 then
					(create {P_CONNECT_STATIC}).fd_close (a_local_sock.item)
					Result := l_err
					l_return := True
				end
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 /= 50) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item));
				(create {P_CONNECT_STATIC}).fd_close (a_local_sock.item)
				Result := ({PC_UERR_T}.FTPPORTERR)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ip_address_to_lprt_repr (a_addr: CE_POINTER [PD_IP_ADDRESS]; a_port: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_buflen: NATURAL_32)
		require
			not a_addr.is_void
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ptr := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_DATA]}.make_shared (a_addr.c_pointer + (create {PD_IP_ADDRESS}.make).offset_of ("data"))))
					if not (a_buflen >= {NATURAL_32} 84) then
						assert_fail (ce_string ("buflen >= 21 * 4"), ce_string ("ftp-basic.c"), {NATURAL_32} 331, ce_string ("ip_address_to_lprt_repr"))
					end
					inspect a_addr.item.family -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					snprintf ([a_buf___6, a_buflen, ce_string ("%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d"), 4, 4, (l_ptr[0]).to_integer_32, (l_ptr[1]).to_integer_32, (l_ptr[2]).to_integer_32, (l_ptr[3]).to_integer_32, 2, (((a_port).bit_and (65_280))).bit_shift_right (8), (a_port).bit_and (255)]).do_nothing
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 10
					snprintf ([a_buf___6, a_buflen, ce_string ("%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d"), 6, 16, (l_ptr[0]).to_integer_32, (l_ptr[1]).to_integer_32, (l_ptr[2]).to_integer_32, (l_ptr[3]).to_integer_32, (l_ptr[4]).to_integer_32, (l_ptr[5]).to_integer_32, (l_ptr[6]).to_integer_32, (l_ptr[7]).to_integer_32, (l_ptr[8]).to_integer_32, (l_ptr[9]).to_integer_32, (l_ptr[10]).to_integer_32, (l_ptr[11]).to_integer_32, (l_ptr[12]).to_integer_32, (l_ptr[13]).to_integer_32, (l_ptr[14]).to_integer_32, (l_ptr[15]).to_integer_32, 2, (((a_port).bit_and (65_280))).bit_shift_right (8), (a_port).bit_and (255)]).do_nothing
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					abort
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_eprt (a_csock: INTEGER_32; a_local_sock: CE_POINTER [INTEGER_32]): NATURAL_32
		local
			l_err: NATURAL_32
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_addr: CE_ARRAY [PD_IP_ADDRESS]
			l_nwritten: INTEGER_32
			l_port: CE_ARRAY [INTEGER_32]
			l_bytes: CE_ARRAY [INTEGER_8]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_respline.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_IP_ADDRESS]} l_addr.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_port.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_bytes.make (<<57>>)

			if not (socket_ip_address (a_csock, l_addr, 0)) then
				Result := ({PC_UERR_T}.FTPSYSERR)
				l_return := True
			end
			if not l_return then
				l_port.item := 0
				a_local_sock.item := l_addr.item.bind_local (l_port)
				if a_local_sock.item < 0 then
					Result := ({PC_UERR_T}.FTPSYSERR)
					l_return := True
				end
			end
			if not l_return then
				ip_address_to_eprt_repr (l_addr, l_port.item, l_bytes, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (57).to_natural_32))
				l_request := ftp_request (ce_string ("EPRT"), l_bytes)
				l_nwritten := fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
				if l_nwritten < 0 then
					free (create {CE_VOID_POINTER}.make_cast (l_request));
					(create {P_CONNECT_STATIC}).fd_close (a_local_sock.item)
					Result := ({PC_UERR_T}.WRITEFAILED)
					l_return := True
				end
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline)
				if l_err /= {NATURAL_32} 10 then
					(create {P_CONNECT_STATIC}).fd_close (a_local_sock.item)
					Result := l_err
					l_return := True
				end
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 /= 50) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item));
				(create {P_CONNECT_STATIC}).fd_close (a_local_sock.item)
				Result := ({PC_UERR_T}.FTPPORTERR)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ip_address_to_eprt_repr (a_addr: CE_POINTER [PD_IP_ADDRESS]; a_port: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_buflen: NATURAL_32)
		require
			not a_addr.is_void
			not a_buf___6.is_void
		local
			l_afnum: INTEGER_32
		do
			if not (a_buflen >= {NATURAL_32} 56) then
				assert_fail (ce_string ("buflen >= 4 + 46 + 1 + 5"), ce_string ("ftp-basic.c"), {NATURAL_32} 421, ce_string ("ip_address_to_eprt_repr"))
			end
			if a_addr.item.family = 2 then
				l_afnum := 1
			else
				l_afnum := 2
			end
			snprintf ([a_buf___6, a_buflen, ce_string ("|%%d|%%s|%%d|"), l_afnum, (a_addr.item.print_address), a_port]).do_nothing
			a_buf___6[(a_buflen - {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_integer_8
		end

	ftp_pasv (a_csock: INTEGER_32; a_addr: CE_POINTER [PD_IP_ADDRESS]; a_port: CE_POINTER [INTEGER_32]): NATURAL_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_s: CE_POINTER [INTEGER_8]
			l_nwritten: INTEGER_32
			l_i: INTEGER_32
			l_err: NATURAL_32
			l_tmp: CE_ARRAY [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_respline.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_tmp.make (<<6>>)

			if a_addr.is_void then
				assert_fail (ce_string ("addr != ((void *)0)"), ce_string ("ftp-basic.c"), {NATURAL_32} 499, ce_string ("ftp_pasv"))
			end
			if a_port.is_void then
				assert_fail (ce_string ("port != ((void *)0)"), ce_string ("ftp-basic.c"), {NATURAL_32} 500, ce_string ("ftp_pasv"))
			end
			memset (create {CE_VOID_POINTER}.make_cast (a_addr), ('%/0/').code, (create {PD_IP_ADDRESS}.make).structure_size.to_natural_32).do_nothing
			l_request := ftp_request (ce_string ("PASV"), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
			l_nwritten := fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
			if l_nwritten < 0 then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				Result := ({PC_UERR_T}.WRITEFAILED)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline)
				if l_err /= {NATURAL_32} 10 then
					Result := l_err
					l_return := True
				end
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 /= 50) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPNOPASV)
				l_return := True
			end
			if not l_return then
				l_s := l_respline.item
				l_s := l_s + (4)
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_s[0]).to_boolean then
						if ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_s[0]).to_integer_32)) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_s := l_s + 1
					end
				end
				l_break := False
				if not (l_s[0]).to_boolean then
					Result := ({PC_UERR_T}.FTPINVPASV)
					l_return := True
				end
			end
			if not l_return then
				l_i := 0
				from
				until
					not (not (l_return) and then (l_i < 6))
				loop
					l_tmp[l_i] := (0).to_natural_8
					from
					until
						(l_break)
					loop
						l_break := False
						if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_s[0]).to_integer_32)) then
							l_break := True
						end
						if not (l_break) then
							l_tmp[l_i] := (((l_s[0]).to_integer_32 - 48) + 10 * (l_tmp[l_i]).to_integer_32).to_natural_8
							l_s := l_s + 1
						end
					end
					l_break := False
					if (l_s[0]).to_integer_32 = 44 then
						l_s := l_s + 1
					elseif l_i < 5 then
						free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
						Result := ({PC_UERR_T}.FTPINVPASV)
						l_return := True
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				a_addr.item.family := 2
				memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_DATA]}.make_shared (a_addr.c_pointer + (create {PD_IP_ADDRESS}.make).offset_of ("data")))), create {CE_VOID_POINTER}.make_cast (l_tmp), (4).to_natural_32).do_nothing
				a_port.item := (((((l_tmp[4]).to_integer_32).bit_shift_left (8))).bit_and (65_280)) + (l_tmp[5]).to_integer_32
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_lpsv (a_csock: INTEGER_32; a_addr: CE_POINTER [PD_IP_ADDRESS]; a_port: CE_POINTER [INTEGER_32]): NATURAL_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_s: CE_POINTER [INTEGER_8]
			l_nwritten: INTEGER_32
			l_i: INTEGER_32
			l_af: INTEGER_32
			l_addrlen: INTEGER_32
			l_portlen: INTEGER_32
			l_err: NATURAL_32
			l_tmp: CE_ARRAY [NATURAL_8]
			l_tmpprt: CE_ARRAY [NATURAL_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_respline.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_tmp.make (<<16>>)
			create {CE_NATURAL_8_ARRAY} l_tmpprt.make (<<2>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_addr.is_void then
						assert_fail (ce_string ("addr != ((void *)0)"), ce_string ("ftp-basic.c"), {NATURAL_32} 565, ce_string ("ftp_lpsv"))
					end
					if a_port.is_void then
						assert_fail (ce_string ("port != ((void *)0)"), ce_string ("ftp-basic.c"), {NATURAL_32} 566, ce_string ("ftp_lpsv"))
					end
					memset (create {CE_VOID_POINTER}.make_cast (a_addr), ('%/0/').code, (create {PD_IP_ADDRESS}.make).structure_size.to_natural_32).do_nothing
					l_request := ftp_request (ce_string ("LPSV"), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
					l_nwritten := fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
					if l_nwritten < 0 then
						free (create {CE_VOID_POINTER}.make_cast (l_request))
						Result := ({PC_UERR_T}.WRITEFAILED)
						l_return := True
					end
					if not l_return then
						free (create {CE_VOID_POINTER}.make_cast (l_request))
						l_err := ftp_response (a_csock, l_respline)
						if l_err /= {NATURAL_32} 10 then
							Result := l_err
							l_return := True
						end
					end
					if not l_return and then ((l_respline.item[0]).to_integer_32 /= 50) then
						free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
						Result := ({PC_UERR_T}.FTPNOPASV)
						l_return := True
					end
					if not l_return then
						l_s := l_respline.item
						l_s := l_s + (4)
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_s[0]).to_boolean then
								if ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_s[0]).to_integer_32)) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_s := l_s + 1
							end
						end
						l_break := False
						if not (l_s[0]).to_boolean then
							Result := ({PC_UERR_T}.FTPINVPASV)
							l_return := True
						end
					end
					if not l_return then
						l_af := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_s[0]).to_integer_32)) then
								l_break := True
							end
							if not (l_break) then
								l_af := ((l_s[0]).to_integer_32 - 48) + 10 * l_af
								l_s := l_s + 1
							end
						end
						l_break := False
						if l_af /= 4 then
							if l_af /= 6 then
								free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
								Result := ({PC_UERR_T}.FTPINVPASV)
								l_return := True
							end
						end
					end
					if not l_return then
						if not (l_s[0]).to_boolean then
							free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
							Result := ({PC_UERR_T}.FTPINVPASV)
							l_return := True
						else
							l_tmp___3 := l_s
							l_s := l_s + 1
							if (l_tmp___3[0]).to_integer_32 /= 44 then
								free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
								Result := ({PC_UERR_T}.FTPINVPASV)
								l_return := True
							end
						end
					end
					if not l_return then
						l_addrlen := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_s[0]).to_integer_32)) then
								l_break := True
							end
							if not (l_break) then
								l_addrlen := ((l_s[0]).to_integer_32 - 48) + 10 * l_addrlen
								l_s := l_s + 1
							end
						end
						l_break := False
						if not (l_s[0]).to_boolean then
							free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
							Result := ({PC_UERR_T}.FTPINVPASV)
							l_return := True
						else
							l_tmp___5 := l_s
							l_s := l_s + 1
							if (l_tmp___5[0]).to_integer_32 /= 44 then
								free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
								Result := ({PC_UERR_T}.FTPINVPASV)
								l_return := True
							end
						end
					end
					if not l_return and then (l_addrlen > 16) then
						free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
						Result := ({PC_UERR_T}.FTPINVPASV)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if l_af /= 4 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_addrlen /= 4 then
							free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
							Result := ({PC_UERR_T}.FTPINVPASV)
							l_return := True
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_af = 6 then
							if l_addrlen /= 16 then
								free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
								Result := ({PC_UERR_T}.FTPINVPASV)
								l_return := True
							end
						end
				when 5 then -- if done
					if not l_return then
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_addrlen))
						loop
							l_tmp[l_i] := (0).to_natural_8
							from
							until
								(l_break)
							loop
								l_break := False
								if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_s[0]).to_integer_32)) then
									l_break := True
								end
								if not (l_break) then
									l_tmp[l_i] := (((l_s[0]).to_integer_32 - 48) + 10 * (l_tmp[l_i]).to_integer_32).to_natural_8
									l_s := l_s + 1
								end
							end
							l_break := False
							if (l_s[0]).to_integer_32 = 44 then
								l_s := l_s + 1
							else
								free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
								Result := ({PC_UERR_T}.FTPINVPASV)
								l_return := True
							end
							if not l_return then
								l_i := l_i + 1
							end
						end
					end
					if not l_return then
						l_portlen := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_s[0]).to_integer_32)) then
								l_break := True
							end
							if not (l_return or l_break) then
								l_portlen := ((l_s[0]).to_integer_32 - 48) + 10 * l_portlen
								l_s := l_s + 1
							end
						end
						l_break := False
						if not (l_s[0]).to_boolean then
							free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
							Result := ({PC_UERR_T}.FTPINVPASV)
							l_return := True
						else
							l_tmp___8 := l_s
							l_s := l_s + 1
							if (l_tmp___8[0]).to_integer_32 /= 44 then
								free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
								Result := ({PC_UERR_T}.FTPINVPASV)
								l_return := True
							end
						end
					end
					if not l_return and then (l_portlen > 2) then
						free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
						Result := ({PC_UERR_T}.FTPINVPASV)
						l_return := True
					end
					if not l_return then
						l_tmpprt[0] := (0).to_natural_8
						from
						until
							(l_break)
						loop
							l_break := False
							if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_s[0]).to_integer_32)) then
								l_break := True
							end
							if not (l_return or l_break) then
								l_tmpprt[0] := (((l_s[0]).to_integer_32 - 48) + 10 * (l_tmpprt[0]).to_integer_32).to_natural_8
								l_s := l_s + 1
							end
						end
						l_break := False
						if not (l_s[0]).to_boolean then
							free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
							Result := ({PC_UERR_T}.FTPINVPASV)
							l_return := True
						else
							l_tmp___10 := l_s
							l_s := l_s + 1
							if (l_tmp___10[0]).to_integer_32 /= 44 then
								free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
								Result := ({PC_UERR_T}.FTPINVPASV)
								l_return := True
							end
						end
					end
					if not l_return then
						l_tmpprt[1] := (0).to_natural_8
						from
						until
							(l_break)
						loop
							l_break := False
							if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_s[0]).to_integer_32)) then
								l_break := True
							end
							if not (l_return or l_break) then
								l_tmpprt[1] := (((l_s[0]).to_integer_32 - 48) + 10 * (l_tmpprt[1]).to_integer_32).to_natural_8
								l_s := l_s + 1
							end
						end
						l_break := False
						if l_s.is_void then
							assert_fail (ce_string ("s != ((void *)0)"), ce_string ("ftp-basic.c"), {NATURAL_32} 687, ce_string ("ftp_lpsv"))
						end
						if l_af = 4 then
							a_addr.item.family := 2
							memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_DATA]}.make_shared (a_addr.c_pointer + (create {PD_IP_ADDRESS}.make).offset_of ("data")))), create {CE_VOID_POINTER}.make_cast (l_tmp), (4).to_natural_32).do_nothing
							a_port.item := (((((l_tmpprt[0]).to_integer_32).bit_shift_left (8))).bit_and (65_280)) + (l_tmpprt[1]).to_integer_32
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("lpsv addr is: %%s%N"), (a_addr.item.print_address)])
								end
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("tmpprt[0] is: %%d%N"), (l_tmpprt[0]).to_integer_32])
								end
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("tmpprt[1] is: %%d%N"), (l_tmpprt[1]).to_integer_32])
								end
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("*port is: %%d%N"), a_port.item])
								end
								l_break := True
							end
							l_break := False
						else
							if l_af /= 6 then
								assert_fail (ce_string ("af == 6"), ce_string ("ftp-basic.c"), {NATURAL_32} 701, ce_string ("ftp_lpsv"))
							end
							a_addr.item.family := 10
							memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_DATA]}.make_shared (a_addr.c_pointer + (create {PD_IP_ADDRESS}.make).offset_of ("data")))), create {CE_VOID_POINTER}.make_cast (l_tmp), (16).to_natural_32).do_nothing
							a_port.item := (((((l_tmpprt[0]).to_integer_32).bit_shift_left (8))).bit_and (65_280)) + (l_tmpprt[1]).to_integer_32
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("lpsv addr is: %%s%N"), (a_addr.item.print_address)])
								end
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("tmpprt[0] is: %%d%N"), (l_tmpprt[0]).to_integer_32])
								end
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("tmpprt[1] is: %%d%N"), (l_tmpprt[1]).to_integer_32])
								end
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("*port is: %%d%N"), a_port.item])
								end
								l_break := True
							end
							l_break := False
						end
						free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
						Result := ({PC_UERR_T}.FTPOK)
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_epsv (a_csock: INTEGER_32; a_ip___0: CE_POINTER [PD_IP_ADDRESS]; a_port: CE_POINTER [INTEGER_32]): NATURAL_32
		require
			not a_ip___0.is_void
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_start: CE_POINTER [INTEGER_8]
			l_delim: INTEGER_8
			l_s: CE_POINTER [INTEGER_8]
			l_nwritten: INTEGER_32
			l_i: INTEGER_32
			l_err: NATURAL_32
			l_tport: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_respline.make (<<1>>)

			if a_ip___0.is_void then
				assert_fail (ce_string ("ip != ((void *)0)"), ce_string ("ftp-basic.c"), {NATURAL_32} 726, ce_string ("ftp_epsv"))
			end
			if a_port.is_void then
				assert_fail (ce_string ("port != ((void *)0)"), ce_string ("ftp-basic.c"), {NATURAL_32} 727, ce_string ("ftp_epsv"))
			end
			if a_ip___0.item.family = 2 then
				l_tmp := ce_string ("1")
			else
				l_tmp := ce_string ("2")
			end
			l_request := ftp_request (ce_string ("EPSV"), l_tmp)
			l_nwritten := fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
			if l_nwritten < 0 then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				Result := ({PC_UERR_T}.WRITEFAILED)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline)
				if l_err /= {NATURAL_32} 10 then
					Result := l_err
					l_return := True
				end
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 /= 50) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPNOPASV)
				l_return := True
			end
			if not l_return then
				if (l_respline.item).is_void then
					assert_fail (ce_string ("respline != ((void *)0)"), ce_string ("ftp-basic.c"), {NATURAL_32} 755, ce_string ("ftp_epsv"))
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("respline is %%s%N"), l_respline.item])
					end
					l_break := True
				end
				l_break := False
				l_s := l_respline.item
				l_start := strchr (l_respline.item, ('(').code)
				if l_start.is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
					Result := ({PC_UERR_T}.FTPINVPASV)
					l_return := True
				end
			end
			if not l_return then
				l_s := l_start + 1
				l_tmp___2 := l_s
				l_s := l_s + 1
				l_delim := l_tmp___2[0]
				if l_delim.to_integer_32 < 33 then
					free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
					Result := ({PC_UERR_T}.FTPINVPASV)
					l_return := True
				elseif l_delim.to_integer_32 > 126 then
					free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
					Result := ({PC_UERR_T}.FTPINVPASV)
					l_return := True
				end
			end
			if not l_return then
				l_i := 0
				from
				until
					not (not (l_return) and then (l_i < 2))
				loop
					l_tmp___3 := l_s
					l_s := l_s + 1
					if (l_tmp___3[0]).to_integer_32 /= l_delim.to_integer_32 then
						free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
						Result := ({PC_UERR_T}.FTPINVPASV)
						l_return := True
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				l_tport := 0
				l_i := 1
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_s[0]).to_integer_32)) then
						l_break := True
					end
					if not (l_return or l_break) then
						if l_i > 5 then
							free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
							Result := ({PC_UERR_T}.FTPINVPASV)
							l_return := True
						end
						if not l_return then
							l_tport := ((l_s[0]).to_integer_32 - 48) + 10 * l_tport
							l_s := l_s + 1
						end
					end
				end
			end
			if not l_return then
				l_break := False
				l_tmp___5 := l_s
				l_s := l_s + 1
				if (l_tmp___5[0]).to_integer_32 /= l_delim.to_integer_32 then
					free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
					Result := ({PC_UERR_T}.FTPINVPASV)
					l_return := True
				end
			end
			if not l_return then
				l_tmp___6 := l_s
				l_s := l_s + 1
				if (l_tmp___6[0]).to_integer_32 /= 41 then
					free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
					Result := ({PC_UERR_T}.FTPINVPASV)
					l_return := True
				end
			end
			if not l_return then
				a_port.item := l_tport
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_type (a_csock, a_type: INTEGER_32): NATURAL_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_nwritten: INTEGER_32
			l_err: NATURAL_32
			l_stype: CE_ARRAY [INTEGER_8]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_respline.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_stype.make (<<2>>)

			l_stype[0] := a_type.to_integer_8
			l_stype[1] := (0).to_integer_8
			l_request := ftp_request (ce_string ("TYPE"), l_stype)
			l_nwritten := fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
			if l_nwritten < 0 then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				Result := ({PC_UERR_T}.WRITEFAILED)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline)
				if l_err /= {NATURAL_32} 10 then
					Result := l_err
					l_return := True
				end
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 /= 50) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPUNKNOWNTYPE)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_cwd (a_csock: INTEGER_32; a_dir: CE_POINTER [INTEGER_8]): NATURAL_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_nwritten: INTEGER_32
			l_err: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_respline.make (<<1>>)

			l_request := ftp_request (ce_string ("CWD"), a_dir)
			l_nwritten := fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
			if l_nwritten < 0 then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				Result := ({PC_UERR_T}.WRITEFAILED)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline)
				if l_err /= {NATURAL_32} 10 then
					Result := l_err
					l_return := True
				end
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 = 53) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPNSFOD)
				l_return := True
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 /= 50) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPRERR)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_rest (a_csock: INTEGER_32; a_offset: INTEGER_64): NATURAL_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_nwritten: INTEGER_32
			l_err: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_respline.make (<<1>>)

			l_request := ftp_request (ce_string ("REST"), ((create {P_UTILS_STATIC}).number_to_static_string (a_offset)))
			l_nwritten := fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
			if l_nwritten < 0 then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				Result := ({PC_UERR_T}.WRITEFAILED)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline)
				if l_err /= {NATURAL_32} 10 then
					Result := l_err
					l_return := True
				end
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 /= 51) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPRESTFAIL)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_retr (a_csock: INTEGER_32; a_file: CE_POINTER [INTEGER_8]): NATURAL_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_nwritten: INTEGER_32
			l_err: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_respline.make (<<1>>)

			l_request := ftp_request (ce_string ("RETR"), a_file)
			l_nwritten := fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
			if l_nwritten < 0 then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				Result := ({PC_UERR_T}.WRITEFAILED)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline)
				if l_err /= {NATURAL_32} 10 then
					Result := l_err
					l_return := True
				end
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 = 53) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPNSFOD)
				l_return := True
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 /= 49) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPRERR)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_list (a_csock: INTEGER_32; a_file: CE_POINTER [INTEGER_8]; a_rs: NATURAL_32): NATURAL_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_nwritten: INTEGER_32
			l_err: NATURAL_32
			l_ok: BOOLEAN
			l_i: NATURAL_32
			l_list_commands: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_respline.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_list_commands.make (<<2>>)

			l_ok := (0).to_boolean
			l_i := (0).to_natural_32
			l_list_commands[0] := ce_string ("LIST -a")
			l_list_commands[1] := ce_string ("LIST")
			if a_rs = {NATURAL_32} 1 then
				l_i := ({PLATFORM}.Pointer_bytes.to_natural_32 * (2).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32 - {NATURAL_32} 1
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_request := ftp_request (l_list_commands[l_i.to_integer_32], a_file)
				l_nwritten := fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
				if l_nwritten < 0 then
					free (create {CE_VOID_POINTER}.make_cast (l_request))
					Result := ({PC_UERR_T}.WRITEFAILED)
					l_return := True
				end
				if not l_return then
					free (create {CE_VOID_POINTER}.make_cast (l_request))
					l_err := ftp_response (a_csock, l_respline)
					if l_err = {NATURAL_32} 10 then
						if (l_respline.item[0]).to_integer_32 = 53 then
							l_err := {PC_UERR_T}.FTPNSFOD
						elseif (l_respline.item[0]).to_integer_32 = 49 then
							l_err := {PC_UERR_T}.FTPOK
							l_ok := (1).to_boolean
						else
							l_err := {PC_UERR_T}.FTPRERR
						end
						free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
					end
					l_i := l_i + 1
					if l_i < ({PLATFORM}.Pointer_bytes.to_natural_32 * (2).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32 then
						if l_ok then
							l_break := True
						end
					else
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				Result := l_err
			end
		end

	ftp_syst (a_csock: INTEGER_32; a_server_type: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_nwritten: INTEGER_32
			l_err: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_respline.make (<<1>>)

			l_request := ftp_request (ce_string ("SYST"), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
			l_nwritten := fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
			if l_nwritten < 0 then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				Result := ({PC_UERR_T}.WRITEFAILED)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline)
				if l_err /= {NATURAL_32} 10 then
					Result := l_err
					l_return := True
				end
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 = 53) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPSRVERR)
				l_return := True
			end
			if not l_return then
				strtok (l_respline.item, ce_string (" ")).do_nothing
				l_request := strtok (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string (" "))
				if l_request.is_void then
					a_server_type.item := {PC_STYPE}.ST_OTHER
				elseif (strcasecmp (l_request, ce_string ("VMS"))).to_boolean then
					if (strcasecmp (l_request, ce_string ("UNIX"))).to_boolean then
						if (strcasecmp (l_request, ce_string ("WINDOWS_NT"))).to_boolean then
							if (strcasecmp (l_request, ce_string ("WINDOWS2000"))).to_boolean then
								if (strcasecmp (l_request, ce_string ("MACOS"))).to_boolean then
									if (strcasecmp (l_request, ce_string ("OS/400"))).to_boolean then
										a_server_type.item := {PC_STYPE}.ST_OTHER
									else
										a_server_type.item := {PC_STYPE}.ST_OS400
									end
								else
									a_server_type.item := {PC_STYPE}.ST_MACOS
								end
							else
								a_server_type.item := {PC_STYPE}.ST_WINNT
							end
						else
							a_server_type.item := {PC_STYPE}.ST_WINNT
						end
					else
						a_server_type.item := {PC_STYPE}.ST_UNIX
					end
				else
					a_server_type.item := {PC_STYPE}.ST_VMS
				end
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_pwd (a_csock: INTEGER_32; a_pwd: CE_POINTER [CE_POINTER [INTEGER_8]]): NATURAL_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_nwritten: INTEGER_32
			l_err: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_respline.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_request := ftp_request (ce_string ("PWD"), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
					l_nwritten := fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
					if l_nwritten < 0 then
						free (create {CE_VOID_POINTER}.make_cast (l_request))
						Result := ({PC_UERR_T}.WRITEFAILED)
						l_return := True
					end
					if not l_return then
						free (create {CE_VOID_POINTER}.make_cast (l_request))
						l_err := ftp_response (a_csock, l_respline)
						if l_err /= {NATURAL_32} 10 then
							Result := l_err
							l_return := True
						end
					end
					if not (not l_return and then ((l_respline.item[0]).to_integer_32 = 53)) then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | err:
						free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
						Result := ({PC_UERR_T}.FTPSRVERR)
						l_return := True
				when 2 then -- if done
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 3 then -- if:
						strtok (l_respline.item, ce_string ("%"")).do_nothing
						l_request := strtok (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string ("%""))
						if l_request.is_void then
							l_pos := -1 + 1 -- goto err
						end
				when 4 then
						if (not (a_pwd.item).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (a_pwd.item))
						end
						a_pwd.item := (create {P_XMALLOC_STATIC}).xstrdup (l_request)
						free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
						Result := ({PC_UERR_T}.FTPOK)
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_size (a_csock: INTEGER_32; a_file: CE_POINTER [INTEGER_8]; a_size: CE_POINTER [INTEGER_64]): NATURAL_32
		require
			not a_size.is_void
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_nwritten: INTEGER_32
			l_err: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_respline.make (<<1>>)

			l_request := ftp_request (ce_string ("SIZE"), a_file)
			l_nwritten := fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
			if l_nwritten < 0 then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				a_size.item := (0).to_integer_64
				Result := ({PC_UERR_T}.WRITEFAILED)
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline)
				if l_err /= {NATURAL_32} 10 then
					a_size.item := (0).to_integer_64
					Result := l_err
					l_return := True
				end
			end
			if not l_return and then ((l_respline.item[0]).to_integer_32 = 53) then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				a_size.item := (0).to_integer_64
				Result := ({PC_UERR_T}.FTPOK)
				l_return := True
			end
			if not l_return then
				(errno_location).item := 0
				a_size.item := strtoll ((l_respline.item + 4), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10)
				if ((errno_location).item).to_boolean then
					free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
					a_size.item := (0).to_integer_64
					Result := ({PC_UERR_T}.FTPOK)
					l_return := True
				end
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (l_respline.item))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_response (a_fd: INTEGER_32; a_ret_line: CE_POINTER [CE_POINTER [INTEGER_8]]): NATURAL_32
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_line: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return)
			loop
				l_line := (fd_read_line (a_fd))
				if l_line.is_void then
					Result := ({PC_UERR_T}.FTPRERR)
					l_return := True
				end
				if not l_return then
					l_p___0 := strchr (l_line, ('%/0/').code)
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_line.c_pointer.to_integer_32).to_natural_32 then
						if (l_p___0[-1]).to_integer_32 = 10 then
							l_p___0 := l_p___0 - 1
							l_p___0[0] := (('%/0/').code).to_integer_8
						end
					end
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_line.c_pointer.to_integer_32).to_natural_32 then
						if (l_p___0[-1]).to_integer_32 = 13 then
							l_p___0 := l_p___0 - 1
							l_p___0[0] := (('%/0/').code).to_integer_8
						end
					end
					if (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s%N"), ((create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_line))])
					else
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%%s%N"), ((create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_line))])
							end
							l_break := True
						end
						l_break := False
					end
					if ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_line[0]).to_integer_32)) then
						if ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_line[1]).to_integer_32)) then
							if ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_line[2]).to_integer_32)) then
								if (l_line[3]).to_integer_32 = 32 then
									strncpy (ftp_last_respline.item, l_line, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (128).to_natural_32)).do_nothing
									ftp_last_respline.item[(({PLATFORM}.Integer_8_bytes.to_natural_32 * (128).to_natural_32) - {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_integer_8
									a_ret_line.item := l_line
									Result := ({PC_UERR_T}.FTPOK)
									l_return := True
								end
							end
						end
					end
				end
				if not l_return then
					free (create {CE_VOID_POINTER}.make_cast (l_line))
				end
			end
		end

	ftp_request (a_command, a_value: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_value: CE_POINTER [INTEGER_8]
			l_res___0: CE_POINTER [INTEGER_8]
			l_defanged: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_p___0: CE_POINTER [INTEGER_8]
			l_SA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_SA_src: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_defanged.make (<<1>>)

			l_value := a_value
			if (not l_value.is_void) then
				if (not (strpbrk (l_value, ce_string ("%R%N"))).is_void) then
					from
					until
						(l_break)
					loop
						l_break := False
						l_SA_dest := l_defanged
						l_SA_src := l_value
						l_SA_dest.item := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new ((strlen (l_SA_src)) + {NATURAL_32} 1)))
						strcpy (l_SA_dest.item, l_SA_src).do_nothing
						l_break := True
					end
					l_break := False
					l_p___0 := l_defanged.item
					from
					until
						not ((l_p___0[0]).to_boolean)
					loop
						if (l_p___0[0]).to_integer_32 = 13 then
							l_p___0[0] := ((' ').code).to_integer_8
						elseif (l_p___0[0]).to_integer_32 = 10 then
							l_p___0[0] := ((' ').code).to_integer_8
						end
						l_p___0 := l_p___0 + 1
					end
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
							l_tmp___1 := (create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_defanged.item);
							(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%NDetected newlines in %%s %"%%s%"; changing to %%s %"%%s%"%N"), a_command, ((create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_value)), a_command, l_tmp___1])
						end
						l_break := True
					end
					l_break := False
					l_value := l_defanged.item
				end
				l_res___0 := (create {P_UTILS_STATIC}).concat_strings ([a_command, ce_string (" "), l_value, ce_string ("%R%N"), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)])
			else
				l_res___0 := (create {P_UTILS_STATIC}).concat_strings ([a_command, ce_string ("%R%N"), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)])
			end
			if (create {P_OPTIONS_STATIC}).opt.item.item.server_response then
				if (strncmp (l_res___0, ce_string ("PASS"), (4).to_natural_32)) /= 0 then
					(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_ALWAYS, ce_string ("--> %%s%N"), l_res___0])
				else
					(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_ALWAYS, ce_string ("--> PASS Turtle Power!%N%N"))
				end
			else
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%N--> %%s%N"), l_res___0])
					end
					l_break := True
				end
				l_break := False
			end
			Result := l_res___0
		end

	ftp_process_type (a_params: CE_POINTER [INTEGER_8]): INTEGER_8
		do
			if (not a_params.is_void) then
				if 0 = (strncasecmp (a_params, ce_string ("type="), (5).to_natural_32)) then
					if (a_params[5]).to_integer_32 /= 0 then
						Result := ((create {P_C_CTYPE_STATIC}).c2_toupper ((a_params[5]).to_integer_32)).to_integer_8
					else
						Result := (('I').code).to_integer_8
					end
				else
					Result := (('I').code).to_integer_8
				end
			else
				Result := (('I').code).to_integer_8
			end
		end

	ftp_parse_ls (a_file: CE_POINTER [INTEGER_8]; a_system_type: NATURAL_32): CE_POINTER [PD_FILEINFO]
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_c: INTEGER_32
			l_tmp___3: CE_POINTER [PD_FILEINFO]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_system_type.to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 0
					Result := (ftp_parse_unix_ls (a_file, 0))
					l_return := True
				when 2 then -- switch 1, case 2
					if not l_return then
						l_fp := fopen (a_file, ce_string ("rb"))
						if l_fp.is_void then
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_file, (strerror ((errno_location).item))])
							Result := (create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer))
							l_return := True
						end
					end
					if not l_return then
						l_c := fgetc (l_fp)
						fclose (l_fp).do_nothing
						if l_c >= 48 then
							if l_c <= 57 then
								Result := (ftp_parse_winnt_ls (a_file))
								l_return := True
							else
								l_tmp___3 := ftp_parse_unix_ls (a_file, 1)
								Result := l_tmp___3
								l_return := True
							end
						else
							l_tmp___3 := ftp_parse_unix_ls (a_file, 1)
							Result := l_tmp___3
							l_return := True
						end
					end
				when 3 then -- switch 1, case 1
					if not l_return then
						Result := (ftp_parse_vms_ls (a_file))
						l_return := True
					end
				when 4 then -- switch 1, case 3
					if not l_return then
						Result := (ftp_parse_unix_ls (a_file, 1))
						l_return := True
					end
				when 5 then -- switch 1, default:
					if not l_return then
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Unsupported listing type, trying Unix listing parser.%N")))])
						Result := (ftp_parse_unix_ls (a_file, 0))
					end
				when 6 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_parse_unix_ls (a_file: CE_POINTER [INTEGER_8]; a_ignore_perms: INTEGER_32): CE_POINTER [PD_FILEINFO]
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_next: INTEGER_32
			l_len: INTEGER_32
			l_i: INTEGER_32
			l_error___0: INTEGER_32
			l_ignore: INTEGER_32
			l_year: INTEGER_32
			l_month: INTEGER_32
			l_day: INTEGER_32
			l_hour: INTEGER_32
			l_min: INTEGER_32
			l_sec: INTEGER_32
			l_timestruct: CE_ARRAY [SD_TM]
			l_tnow: CE_POINTER [SD_TM]
			l_timenow: CE_ARRAY [INTEGER_32]
			l_line: CE_POINTER [INTEGER_8]
			l_tok: CE_POINTER [INTEGER_8]
			l_ptok: CE_POINTER [INTEGER_8]
			l_dir: CE_POINTER [PD_FILEINFO]
			l_l: CE_POINTER [PD_FILEINFO]
			l_cur: CE_ARRAY [PD_FILEINFO]
			l_size: INTEGER_64
			l_fnlen: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___31: CE_POINTER [INTEGER_8]
			l_tmp___35: CE_POINTER [PD_FILEINFO]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_TM]} l_timestruct.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_timenow.make (<<1>>)
			create {CE_INTEGER_8_POINTER} l_tok.make
			create {CE_CLASS_ARRAY [PD_FILEINFO]} l_cur.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fp := fopen (a_file, ce_string ("rb"))
					if l_fp.is_void then
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_file, (strerror ((errno_location).item))])
						Result := (create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 58 -- skip if block
					end
				when 1 then -- if:
						l_l := create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
						l_dir := l_l
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 57 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						l_line := (create {P_UTILS_STATIC}).read_whole_line (l_fp)
						if l_line.is_void then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_len := clean_line (l_line)
							if not (strncasecmp (l_line, ce_string ("total"), (5).to_natural_32)).to_boolean then
								free (create {CE_VOID_POINTER}.make_cast (l_line))
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							l_tok := strtok (l_line, ce_string (" "))
							if l_tok.is_void then
								free (create {CE_VOID_POINTER}.make_cast (l_line))
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 56 -- skip if block
						end
				when 4 then -- if:
						l_cur.item.name := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						l_cur.item.linkto := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						inspect (l_tok[0]).to_integer_32 -- switch 1 head
						when 45 then l_pos := -1 + 5
						when 100 then l_pos := -1 + 6
						when 108 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 5 then -- switch 1, case 45
						l_cur.item.type := {PC_FTYPE}.FT_PLAINFILE
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("PLAINFILE; ")])
							end
							l_break := True
						end
						l_break := False
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 100
						l_cur.item.type := {PC_FTYPE}.FT_DIRECTORY
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("DIRECTORY; ")])
							end
							l_break := True
						end
						l_break := False
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 108
						l_cur.item.type := {PC_FTYPE}.FT_SYMLINK
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("SYMLINK; ")])
							end
							l_break := True
						end
						l_break := False
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, default:
						l_cur.item.type := {PC_FTYPE}.FT_UNKNOWN
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("UNKNOWN; ")])
							end
							l_break := True
						end
						l_break := False
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done:
						if not (a_ignore_perms.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 10 then -- if:
						inspect (l_cur.item.type).to_integer_32 -- switch 2 head
						when 0 then l_pos := -1 + 11
						when 1 then l_pos := -1 + 12
						else l_pos := -1 + 13
						end
				when 11 then -- switch 2, case 0
						l_cur.item.perms := 420
						l_pos := -1 + 14 -- switch 2; break
				when 12 then -- switch 2, case 1
						l_cur.item.perms := 493
						l_pos := -1 + 14 -- switch 2; break
				when 13 then -- switch 2, default:
						l_cur.item.perms := 420
				when 14 then -- switch 2, done:
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("implicit perms %%0o; "), l_cur.item.perms])
							end
							l_break := True
						end
						l_break := False
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_cur.item.perms := symperms ((l_tok + 1))
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("perms %%0o; "), l_cur.item.perms])
							end
							l_break := True
						end
						l_break := False
				when 17 then -- if done
						l_ignore := 0
						l_error___0 := l_ignore
						l_sec := 0
						l_min := l_sec
						l_hour := l_min
						l_year := l_hour
						l_day := 0
						l_month := l_day
						l_next := -1
						l_tok := l_line
				when 18 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 51 -- skip loop
						end
				when 19 then -- loop body:
						l_break := False
						l_ptok := l_tok
						l_tok := strtok (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string (" "))
						if l_tok.is_void then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 50 -- skip if block
						end
				when 20 then -- if:
						l_next := l_next - 1
						if not (l_next < 0) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_i := 0
						from
						until
							not (not (l_break) and then (l_i < 12))
						loop
							l_break := False
							if not (strcmp (l_tok, months.item[l_i])).to_boolean then
								l_break := True
							end
							if not (l_break) then
								l_i := l_i + 1
							end
						end
						l_break := False
						if l_i /= 12 then
							if l_ptok.is_equal (l_line) then
								l_error___0 := 1
								l_break := True
							end
							if not (l_return or l_break) then
								(errno_location).item := 0
								l_size := strtoll (l_ptok, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10)
								if l_size = (((-{INTEGER_64} 1).bit_shift_left (({PLATFORM}.Integer_64_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1).to_integer_32))).bit_not then
									if (errno_location).item = 34 then
										l_cur.item.size := (0).to_integer_64
									else
										l_cur.item.size := l_size
									end
								else
									l_cur.item.size := l_size
								end
								from
								until
									(l_break)
								loop
									l_break := False
									if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
										(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("size: %%s; "), ((create {P_UTILS_STATIC}).number_to_static_string (l_cur.item.size))])
									end
									l_break := True
								end
								l_break := False
								l_month := l_i
								l_next := 5
								from
								until
									(l_break)
								loop
									l_break := False
									if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
										(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("month: %%s; "), months.item[l_month]])
									end
									l_break := True
								end
								l_break := False
							end
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 23 then -- else:
						if l_next /= 4 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						if (l_tok[1]).to_boolean then
							l_day := (10 * ((l_tok[0]).to_integer_32 - 48) + (l_tok[1]).to_integer_32) - 48
						else
							l_day := (l_tok[0]).to_integer_32 - 48
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("day: %%d; "), l_day])
							end
							l_break := True
						end
						l_break := False
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 26 then -- else:
						if l_next /= 3 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						l_year := 0
						l_sec := 0
						l_hour := l_sec
						l_min := l_hour
						if ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_tok[0]).to_integer_32)) then
							from
							until
								(l_break)
							loop
								l_break := False
								if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_tok[0]).to_integer_32)) then
									l_break := True
								end
								if not (l_break) then
									l_year := ((l_tok[0]).to_integer_32 - 48) + 10 * l_year
									l_tok := l_tok + 1
								end
							end
							l_break := False
							if (l_tok[0]).to_integer_32 = 58 then
								l_hour := l_year
								l_year := 0
								l_tok := l_tok + 1
								from
								until
									(l_break)
								loop
									l_break := False
									if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_tok[0]).to_integer_32)) then
										l_break := True
									end
									if not (l_break) then
										l_min := ((l_tok[0]).to_integer_32 - 48) + 10 * l_min
										l_tok := l_tok + 1
									end
								end
								l_break := False
								if (l_tok[0]).to_integer_32 = 58 then
									l_tok := l_tok + 1
									from
									until
										(l_break)
									loop
										l_break := False
										if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_tok[0]).to_integer_32)) then
											l_break := True
										end
										if not (l_break) then
											l_sec := ((l_tok[0]).to_integer_32 - 48) + 10 * l_sec
											l_tok := l_tok + 1
										end
									end
									l_break := False
								end
							end
						end
						if l_year.to_boolean then
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("year: %%d (no tm); "), l_year])
								end
								l_break := True
							end
							l_break := False
						else
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("time: %%02d:%%02d:%%02d (no yr); "), l_hour, l_min, l_sec])
								end
								l_break := True
							end
							l_break := False
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 29 then -- else:
						if l_next /= 2 then
							l_pos := -1 + 49 -- skip if block
						end
				when 30 then -- if:
						l_fnlen := (strlen (l_tok)).to_integer_32
						if l_fnlen < l_len - (l_tok.distance (l_line)) then
							l_tok[l_fnlen] := ((' ').code).to_integer_8
							if l_cur.item.type = {NATURAL_32} 2 then
								l_p___0 := strstr (l_tok, ce_string (" -> "))
								if l_p___0.is_void then
									l_error___0 := 1
									l_break := True
								end
								if not (l_return or l_break) then
									l_cur.item.linkto := (create {P_XMALLOC_STATIC}).xstrdup ((l_p___0 + 4))
									from
									until
										(l_break)
									loop
										l_break := False
										if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
											(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("link to: %%s%N"), l_cur.item.linkto])
										end
										l_break := True
									end
									l_break := False
									l_p___0[0] := (('%/0/').code).to_integer_8
								end
							end
						end
						if (l_return or l_break) then
							l_pos := -1 + 36 -- skip if block
						end
				when 31 then -- if:
						if not ((strcmp (l_tok, ce_string ("."))).to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 32 then -- if:
						if (strcmp (l_tok, ce_string (".."))).to_boolean then
							l_pos := -1 + 34 -- skip if block
						end
				when 33 then -- if: | _L:
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%NIgnoring `.%' and `..%'; ")])
							end
							l_break := True
						end
						l_break := False
						l_ignore := 1
						l_break := True
				when 34 then -- if done | if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else:
						l_pos := -1 + 33 -- goto _L
				when 36 then -- if done
						if (l_return or l_break) then
							l_pos := -1 + 48 -- skip if block
						end
				when 37 then -- if:
						l_fnlen := (strlen (l_tok)).to_integer_32
						l_cur.item.name := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((l_fnlen + 1).to_natural_32)))
						memcpy (create {CE_VOID_POINTER}.make_cast (l_cur.item.name), create {CE_VOID_POINTER}.make_cast (l_tok), (l_fnlen + 1).to_natural_32).do_nothing
						if not (l_fnlen.to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 38 then -- if:
						if l_cur.item.type /= {NATURAL_32} 1 then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						if (l_cur.item.name[(l_fnlen - 1)]).to_integer_32 = 47 then
							l_cur.item.name[(l_fnlen - 1)] := (('%/0/').code).to_integer_8
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("trailing `/%' on dir.%N")])
								end
								l_break := True
							end
							l_break := False
						else
							l_pos := -1 + 41 -- goto _L___1
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 41 then -- else: | _L___1:
						if l_cur.item.type /= {NATURAL_32} 2 then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						if (l_cur.item.name[(l_fnlen - 1)]).to_integer_32 = 64 then
							l_cur.item.name[(l_fnlen - 1)] := (('%/0/').code).to_integer_8
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("trailing `@%' on link.%N")])
								end
								l_break := True
							end
							l_break := False
						else
							l_pos := -1 + 44 -- goto _L___0
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else: | _L___0:
						if l_cur.item.type = {NATURAL_32} 0 then
							if ((l_cur.item.perms).bit_and (73)).to_boolean then
								if (l_cur.item.name[(l_fnlen - 1)]).to_integer_32 = 42 then
									l_cur.item.name[(l_fnlen - 1)] := (('%/0/').code).to_integer_8
									from
									until
										(l_break)
									loop
										l_break := False
										if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
											(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("trailing `*%' on exec.%N")])
										end
										l_break := True
									end
									l_break := False
								end
							end
						end
				when 45 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else:
						l_error___0 := 1
				when 47 then
						l_break := True
				when 48 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else:
						abort
				when 50 then -- if done | if done | if done | if done | if done
						l_pos := -1 + 18 -- back to loop condition
				when 51 then -- loop done
						l_break := False
						if (l_cur.item.name).is_void then
							l_error___0 := 1
						elseif l_cur.item.type = {NATURAL_32} 2 then
							if (l_cur.item.linkto).is_void then
								l_error___0 := 1
							end
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								if (not (l_cur.item.name).is_void) then
									l_tmp___31 := l_cur.item.name
								else
									l_tmp___31 := ce_string ("")
								end
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%%s%N"), l_tmp___31])
							end
							l_break := True
						end
						l_break := False
						if not (l_error___0.to_boolean) then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
						l_pos := -1 + 55 -- goto _L___2
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 56
				when 54 then -- else:
						if not (l_ignore.to_boolean) then
							l_pos := -1 + 56 -- skip if block
						end
				when 55 then -- if: | _L___2:
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Skipping.%N")])
							end
							l_break := True
						end
						l_break := False
						if (not (l_cur.item.name).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_cur.item.name))
						end
						if (not (l_cur.item.linkto).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_cur.item.linkto))
						end
						free (create {CE_VOID_POINTER}.make_cast (l_line))
						l_continue := True
				when 56 then -- if done | if done
						if not (l_return or l_break or l_continue) then
							if l_dir.is_void then
								l_dir := create {CE_CLASS_POINTER [PD_FILEINFO]}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((create {PD_FILEINFO}.make).structure_size.to_natural_32)))
								l_l := l_dir
								memcpy (create {CE_VOID_POINTER}.make_cast (l_l), create {CE_VOID_POINTER}.make_cast (l_cur), (create {PD_FILEINFO}.make).structure_size.to_natural_32).do_nothing
								l_tmp___35 := create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
								l_l.item.next := l_tmp___35
								l_l.item.prev := l_tmp___35
							else
								l_cur.item.prev := l_l
								l_l.item.next := create {CE_CLASS_POINTER [PD_FILEINFO]}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((create {PD_FILEINFO}.make).structure_size.to_natural_32)))
								l_l := l_l.item.next
								memcpy (create {CE_VOID_POINTER}.make_cast (l_l), create {CE_VOID_POINTER}.make_cast (l_cur), (create {PD_FILEINFO}.make).structure_size.to_natural_32).do_nothing
								l_l.item.next := create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
							end
							l_timenow.item := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
							l_tnow := localtime (l_timenow)
							l_timestruct.item.tm_sec := l_sec
							l_timestruct.item.tm_min := l_min
							l_timestruct.item.tm_hour := l_hour
							l_timestruct.item.tm_mday := l_day
							l_timestruct.item.tm_mon := l_month
							if l_year = 0 then
								if l_month > l_tnow.item.tm_mon then
									l_timestruct.item.tm_year := l_tnow.item.tm_year - 1
								else
									l_timestruct.item.tm_year := l_tnow.item.tm_year
								end
							else
								l_timestruct.item.tm_year := l_year
							end
							if l_timestruct.item.tm_year >= 1_900 then
								l_timestruct.item.tm_year := l_timestruct.item.tm_year - (1_900)
							end
							l_timestruct.item.tm_wday := 0
							l_timestruct.item.tm_yday := 0
							l_timestruct.item.tm_isdst := -1
							l_l.item.tstamp := mktime (l_timestruct)
							free (create {CE_VOID_POINTER}.make_cast (l_line))
						end
						l_pos := -1 + 2 -- back to loop condition
				when 57 then -- loop done
						l_break := False
						l_continue := False
						fclose (l_fp).do_nothing
						Result := l_dir
				when 58 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	symperms (a_s: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_s.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_perms: INTEGER_32
			l_i: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_s := a_s
			l_perms := 0
			if (strlen (l_s)) < {NATURAL_32} 9 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_i := 0
				from
				until
					not (l_i < 3)
				loop
					l_perms := (l_perms).bit_shift_left ((3))
					if (l_s[2]).to_integer_32 = 120 then
						l_tmp___0 := 1
					elseif (l_s[2]).to_integer_32 = 115 then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
					l_perms := l_perms + ((((((l_s[0]).to_integer_32 = 114).to_integer).bit_shift_left (2)) + ((((l_s[1]).to_integer_32 = 119).to_integer).bit_shift_left (1))) + l_tmp___0)
					l_i := l_i + 1
					l_s := l_s + (3)
				end
				Result := l_perms
			end
		end

	ftp_parse_winnt_ls (a_file: CE_POINTER [INTEGER_8]): CE_POINTER [PD_FILEINFO]
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_len: INTEGER_32
			l_year: INTEGER_32
			l_month: INTEGER_32
			l_day: INTEGER_32
			l_hour: INTEGER_32
			l_min: INTEGER_32
			l_timestruct: CE_ARRAY [SD_TM]
			l_line: CE_POINTER [INTEGER_8]
			l_tok: CE_POINTER [INTEGER_8]
			l_dir: CE_POINTER [PD_FILEINFO]
			l_l: CE_POINTER [PD_FILEINFO]
			l_cur: CE_ARRAY [PD_FILEINFO]
			l_size: INTEGER_64
			l_tmp___11: CE_POINTER [PD_FILEINFO]
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_TM]} l_timestruct.make (<<1>>)
			create {CE_INTEGER_8_POINTER} l_tok.make
			create {CE_CLASS_ARRAY [PD_FILEINFO]} l_cur.make (<<1>>)

			l_fp := fopen (a_file, ce_string ("rb"))
			if l_fp.is_void then
				(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_file, (strerror ((errno_location).item))])
				Result := (create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_l := create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
				l_dir := l_l
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_continue := False
					l_line := (create {P_UTILS_STATIC}).read_whole_line (l_fp)
					if l_line.is_void then
						l_break := True
					end
					if not (l_return or l_break or l_continue) then
						l_len := clean_line (l_line)
						if l_len < 40 then
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) then
						l_tok := l_line + 39
						l_cur.item.name := (create {P_XMALLOC_STATIC}).xstrdup (l_tok)
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Name: %'%%s%'%N"), l_cur.item.name])
							end
							l_break := True
						end
						l_break := False
						l_tok := strtok (l_line, ce_string ("-"))
						if l_tok.is_void then
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) then
						l_month := (atoi (l_tok)) - 1
						if l_month < 0 then
							l_month := 0
						end
						l_tok := strtok (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string ("-"))
						if l_tok.is_void then
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) then
						l_day := atoi (l_tok)
						l_tok := strtok (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string (" "))
						if l_tok.is_void then
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) then
						l_year := atoi (l_tok)
						if l_year <= 70 then
							l_year := l_year + (100)
						end
						l_tok := strtok (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string (":"))
						if l_tok.is_void then
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) then
						l_hour := atoi (l_tok)
						l_tok := strtok (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string ("M"))
						if l_tok.is_void then
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) then
						l_min := atoi (l_tok)
						l_tok := l_tok + (2)
						if l_hour = 12 then
							l_hour := 0
						end
						if (l_tok[0]).to_integer_32 = 80 then
							l_hour := l_hour + (12)
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("YYYY/MM/DD HH:MM - %%d/%%02d/%%02d %%02d:%%02d%N"), l_year + 1_900, l_month, l_day, l_hour, l_min])
							end
							l_break := True
						end
						l_break := False
						l_timestruct.item.tm_sec := 0
						l_timestruct.item.tm_min := l_min
						l_timestruct.item.tm_hour := l_hour
						l_timestruct.item.tm_mday := l_day
						l_timestruct.item.tm_mon := l_month
						l_timestruct.item.tm_year := l_year
						l_timestruct.item.tm_wday := 0
						l_timestruct.item.tm_yday := 0
						l_timestruct.item.tm_isdst := -1
						l_cur.item.tstamp := mktime (l_timestruct)
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Timestamp: %%ld%N"), l_cur.item.tstamp])
							end
							l_break := True
						end
						l_break := False
						l_tok := strtok (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string (" "))
						if l_tok.is_void then
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) then
						from
						until
							(l_break)
						loop
							l_break := False
							if not l_tok.is_void then
								if (l_tok[0]).to_integer_32 /= 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_tok := strtok (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string (" "))
							end
						end
						l_break := False
						if l_tok.is_void then
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) then
						if (l_tok[0]).to_integer_32 = 60 then
							l_cur.item.type := {PC_FTYPE}.FT_DIRECTORY
							l_cur.item.size := (0).to_integer_64
							l_cur.item.perms := 493
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Directory%N")])
								end
								l_break := True
							end
							l_break := False
						else
							l_cur.item.type := {PC_FTYPE}.FT_PLAINFILE;
							(errno_location).item := 0
							l_size := strtoll (l_tok, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10)
							if l_size = (((-{INTEGER_64} 1).bit_shift_left (({PLATFORM}.Integer_64_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1).to_integer_32))).bit_not then
								if (errno_location).item = 34 then
									l_cur.item.size := (0).to_integer_64
								else
									l_cur.item.size := l_size
								end
							else
								l_cur.item.size := l_size
							end
							l_cur.item.perms := 420
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("File, size %%s bytes%N"), ((create {P_UTILS_STATIC}).number_to_static_string (l_cur.item.size))])
								end
								l_break := True
							end
							l_break := False
						end
						l_cur.item.linkto := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						if l_dir.is_void then
							l_dir := create {CE_CLASS_POINTER [PD_FILEINFO]}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((create {PD_FILEINFO}.make).structure_size.to_natural_32)))
							l_l := l_dir
							memcpy (create {CE_VOID_POINTER}.make_cast (l_l), create {CE_VOID_POINTER}.make_cast (l_cur), (create {PD_FILEINFO}.make).structure_size.to_natural_32).do_nothing
							l_tmp___11 := create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
							l_l.item.next := l_tmp___11
							l_l.item.prev := l_tmp___11
						else
							l_cur.item.prev := l_l
							l_l.item.next := create {CE_CLASS_POINTER [PD_FILEINFO]}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((create {PD_FILEINFO}.make).structure_size.to_natural_32)))
							l_l := l_l.item.next
							memcpy (create {CE_VOID_POINTER}.make_cast (l_l), create {CE_VOID_POINTER}.make_cast (l_cur), (create {PD_FILEINFO}.make).structure_size.to_natural_32).do_nothing
							l_l.item.next := create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
						end
						free (create {CE_VOID_POINTER}.make_cast (l_line))
					end
				end
				l_break := False
				l_continue := False
				fclose (l_fp).do_nothing
				Result := l_dir
			end
		end

	ftp_parse_vms_ls (a_file: CE_POINTER [INTEGER_8]): CE_POINTER [PD_FILEINFO]
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_dt: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_len: INTEGER_32
			l_perms: INTEGER_32
			l_timenow: CE_ARRAY [INTEGER_32]
			l_timestruct: CE_POINTER [SD_TM]
			l_date_str: CE_ARRAY [INTEGER_8]
			l_line: CE_POINTER [INTEGER_8]
			l_tok: CE_POINTER [INTEGER_8]
			l_dir: CE_POINTER [PD_FILEINFO]
			l_l: CE_POINTER [PD_FILEINFO]
			l_cur: CE_ARRAY [PD_FILEINFO]
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___36: CE_POINTER [PD_FILEINFO]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_timenow.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_date_str.make (<<32>>)
			create {CE_CLASS_ARRAY [PD_FILEINFO]} l_cur.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fp := fopen (a_file, ce_string ("r"))
					if l_fp.is_void then
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_file, (strerror ((errno_location).item))])
						Result := (create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 49 -- skip if block
					end
				when 1 then -- if:
						l_l := create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
						l_dir := l_l
						l_j := 0
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 15 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						l_line := (create {P_UTILS_STATIC}).read_whole_line (l_fp)
						if not (l_line.is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_break := True
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 6 then -- else:
						l_i := clean_line (l_line)
						if not (l_i <= 0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						free (create {CE_VOID_POINTER}.make_cast (l_line))
						l_continue := True
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if l_j /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if (l_line[(l_i - 1)]).to_integer_32 = 93 then
							l_j := 1
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if (strncmp (l_line, ce_string ("Total of "), (9).to_natural_32)).to_boolean then
							l_break := True
						else
							free (create {CE_VOID_POINTER}.make_cast (l_line))
							l_line := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_break := True
						end
				when 13 then -- if done
						if not (l_break or l_continue) then
							free (create {CE_VOID_POINTER}.make_cast (l_line))
						end
				when 14 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 15 then -- loop done
						l_break := False
						l_continue := False
				when 16 then -- loop condition:
						if not (not (l_return or l_break) and then (not l_line.is_void)) then
							l_pos := -1 + 48 -- skip loop
						end
				when 17 then -- loop body:
						l_break := False
						l_continue := False
						l_tok := strtok (l_line, ce_string (" "))
						if l_tok.is_void then
							l_tok := l_line
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("file name:   %'%%s%'%N"), l_tok])
							end
							l_break := True
						end
						l_break := False
						l_p___0 := l_tok + (strlen (l_tok)).to_integer_32
						from
						until
							(l_break)
						loop
							l_break := False
							l_p___0 := l_p___0 - 1
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_tok.c_pointer.to_integer_32).to_natural_32 then
								if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[0]).to_integer_32)) then
									l_break := True
								end
							else
								l_break := True
							end
						end
						l_break := False
						if (l_p___0[0]).to_integer_32 = 59 then
							if (l_p___0[-1]).to_integer_32 /= 94 then
								l_p___0[0] := (('%/0/').code).to_integer_8
							end
						end
						eat_carets (l_tok)
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("file name-^: %'%%s%'%N"), l_tok])
							end
							l_break := True
						end
						l_break := False
						l_len := (strlen (l_tok)).to_integer_32
						if (strncasecmp ((l_tok + (l_len - 4)), ce_string (".DIR"), (4).to_natural_32)).to_boolean then
							if (strncasecmp ((l_tok + (l_len - 6)), ce_string (".DIR;1"), (6).to_natural_32)).to_boolean then
								l_cur.item.type := {PC_FTYPE}.FT_PLAINFILE
								l_cur.item.perms := 420
								from
								until
									(l_break)
								loop
									l_break := False
									if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
										(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("File%N")])
									end
									l_break := True
								end
								l_break := False
							else
								l_len := l_len - (6)
								l_tok[l_len] := (('%/0/').code).to_integer_8
								l_cur.item.type := {PC_FTYPE}.FT_DIRECTORY
								l_cur.item.perms := 493
								from
								until
									(l_break)
								loop
									l_break := False
									if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
										(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Directory (v)%N")])
									end
									l_break := True
								end
								l_break := False
							end
						else
							l_len := l_len - (4)
							l_tok[l_len] := (('%/0/').code).to_integer_8
							l_cur.item.type := {PC_FTYPE}.FT_DIRECTORY
							l_cur.item.perms := 493
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Directory (nv)%N")])
								end
								l_break := True
							end
							l_break := False
						end
						l_cur.item.name := (create {P_XMALLOC_STATIC}).xstrdup (l_tok)
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Name: %'%%s%'%N"), l_cur.item.name])
							end
							l_break := True
						end
						l_break := False
						l_date_str[0] := (('%/0/').code).to_integer_8
						l_cur.item.linkto := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						l_cur.item.size := (0).to_integer_64
						l_tok := strtok (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string (" "))
						if l_tok.is_void then
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Getting additional line.%N")])
								end
								l_break := True
							end
							l_break := False
							free (create {CE_VOID_POINTER}.make_cast (l_line))
							l_line := (create {P_UTILS_STATIC}).read_whole_line (l_fp)
							if l_line.is_void then
								from
								until
									(l_break)
								loop
									l_break := False
									if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
										(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("EOF.  Leaving listing parser.%N")])
									end
									l_break := True
								end
								l_break := False
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								if l_i <= 0 then
									from
									until
										(l_break)
									loop
										l_break := False
										if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
											(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Blank line.  Leaving listing parser.%N")])
										end
										l_break := True
									end
									l_break := False
									free (create {CE_VOID_POINTER}.make_cast (l_line))
									l_break := True
								elseif (l_line[0]).to_integer_32 /= 32 then
									from
									until
										(l_break)
									loop
										l_break := False
										if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
											(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Non-blank in column 1.  Must be a new file name?%N")])
										end
										l_break := True
									end
									l_break := False
									l_continue := True
								else
									l_tok := strtok (l_line, ce_string (" "))
									if l_tok.is_void then
										from
										until
											(l_break)
										loop
											l_break := False
											if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
												(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Null token.  Leaving listing parser.%N")])
											end
											l_break := True
										end
										l_break := False
										free (create {CE_VOID_POINTER}.make_cast (l_line))
										l_break := True
									end
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 47 -- skip if block
						end
				when 18 then -- if: | loop condition:
						if not (not (l_return) and then (not l_tok.is_void)) then
							l_pos := -1 + 46 -- skip loop
						end
				when 19 then -- loop body:
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Token: >%%s<: "), l_tok])
							end
							l_break := True
						end
						l_break := False
						if not ((strlen (l_tok)) < {NATURAL_32} 12) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if not (strchr (l_tok, ('-').code)).is_void then
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Date.%N")])
								end
								l_break := True
							end
							l_break := False
							strcpy (l_date_str, l_tok).do_nothing
							strcat (l_date_str, ce_string (" ")).do_nothing
						else
							l_pos := -1 + 22 -- goto _L___1
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 22 then -- else: | _L___1:
						if not ((strlen (l_tok)) < {NATURAL_32} 12) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if not (strchr (l_tok, (':').code)).is_void then
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Time. ")])
								end
								l_break := True
							end
							l_break := False
							strncat (l_date_str, l_tok, (({PLATFORM}.Integer_8_bytes.to_natural_32 * (32).to_natural_32) - (strlen (l_date_str))) - {NATURAL_32} 1).do_nothing
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Date time: >%%s<%N"), l_date_str])
								end
								l_break := True
							end
							l_break := False
						else
							l_pos := -1 + 25 -- goto _L___0
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 25 then -- else: | _L___0:
						if (strchr (l_tok, ('[').code)).is_void then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Owner.%N")])
							end
							l_break := True
						end
						l_break := False
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 28 then -- else:
						if (strchr (l_tok, ('(').code)).is_void then
							l_pos := -1 + 44 -- skip if block
						end
				when 29 then -- if:
						l_perms := 0
						l_j := 0
						l_i := 0
				when 30 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 42 -- skip loop
						end
				when 31 then -- loop body:
						l_break := False
						if not (l_i.to_natural_32 < (strlen (l_tok))) then
							l_break := True
						end
						if (l_break or l_continue) then
							l_pos := -1 + 41 -- skip if block
						end
				when 32 then -- if:
						inspect (l_tok[l_i]).to_integer_32 -- switch 1 head
						when 40 then l_pos := -1 + 33
						when 41 then l_pos := -1 + 34
						when 44 then l_pos := -1 + 35
						when 82 then l_pos := -1 + 36
						when 87 then l_pos := -1 + 37
						when 69 then l_pos := -1 + 38
						when 68 then l_pos := -1 + 39
						else l_pos := -1 + 40
						end
				when 33 then -- switch 1, case 40
						l_pos := -1 + 40 -- switch 1; break
				when 34 then -- switch 1, case 41
						l_pos := -1 + 40 -- switch 1; break
				when 35 then -- switch 1, case 44
						if l_j = 0 then
							l_perms := 0
							l_j := 1
						else
							l_perms := (l_perms).bit_shift_left ((3))
						end
						l_pos := -1 + 40 -- switch 1; break
				when 36 then -- switch 1, case 82
						l_perms := (l_perms).bit_or ((4))
						l_pos := -1 + 40 -- switch 1; break
				when 37 then -- switch 1, case 87
						l_perms := (l_perms).bit_or ((2))
						l_pos := -1 + 40 -- switch 1; break
				when 38 then -- switch 1, case 69
						l_perms := (l_perms).bit_or ((1))
						l_pos := -1 + 40 -- switch 1; break
				when 39 then -- switch 1, case 68
						l_perms := (l_perms).bit_or ((2))
						l_pos := -1 + 40 -- switch 1; break
				when 40 then -- switch 1, done:
						l_i := l_i + 1
				when 41 then -- if done
						l_pos := -1 + 30 -- back to loop condition
				when 42 then -- loop done
						l_break := False
						l_cur.item.perms := l_perms
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Prot.  perms = %%0o.%N"), l_cur.item.perms])
							end
							l_break := True
						end
						l_break := False
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else:
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Ignored (size?).%N")])
							end
							l_break := True
						end
						l_break := False
				when 45 then -- if done | if done | if done
						l_tok := strtok (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string (" "))
						l_pos := -1 + 18 -- back to loop condition
				when 46 then -- loop done
						l_timenow.item := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						l_timestruct := localtime (l_timenow)
						strptime (l_date_str, ce_string ("%%d-%%b-%%Y %%H:%%M:%%S"), l_timestruct).do_nothing
						l_timenow.item := mktime (l_timestruct)
						l_tok := getenv (ce_string ("WGET_TIMEZONE_DIFFERENTIAL"))
						if not l_tok.is_void then
							l_dt := atoi (l_tok)
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Time differential = %%d.%N"), l_dt])
								end
								l_break := True
							end
							l_break := False
						else
							l_dt := 0
						end
						if l_dt >= 0 then
							l_timenow.item := l_timenow.item + l_dt.to_integer_32
						else
							l_timenow.item := l_timenow.item - (-l_dt).to_integer_32
						end
						l_cur.item.tstamp := l_timenow.item
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Timestamp: %%ld%N"), l_cur.item.tstamp])
							end
							l_break := True
						end
						l_break := False
						if l_dir.is_void then
							l_dir := create {CE_CLASS_POINTER [PD_FILEINFO]}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((create {PD_FILEINFO}.make).structure_size.to_natural_32)))
							l_l := l_dir
							memcpy (create {CE_VOID_POINTER}.make_cast (l_l), create {CE_VOID_POINTER}.make_cast (l_cur), (create {PD_FILEINFO}.make).structure_size.to_natural_32).do_nothing
							l_tmp___36 := create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
							l_l.item.next := l_tmp___36
							l_l.item.prev := l_tmp___36
						else
							l_cur.item.prev := l_l
							l_l.item.next := create {CE_CLASS_POINTER [PD_FILEINFO]}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((create {PD_FILEINFO}.make).structure_size.to_natural_32)))
							l_l := l_l.item.next
							memcpy (create {CE_VOID_POINTER}.make_cast (l_l), create {CE_VOID_POINTER}.make_cast (l_cur), (create {PD_FILEINFO}.make).structure_size.to_natural_32).do_nothing
							l_l.item.next := create {CE_CLASS_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
						end
						free (create {CE_VOID_POINTER}.make_cast (l_line))
						l_line := (create {P_UTILS_STATIC}).read_whole_line (l_fp)
						if not l_line.is_void then
							l_i := clean_line (l_line)
							if l_i <= 0 then
								free (create {CE_VOID_POINTER}.make_cast (l_line))
								l_break := True
							end
						end
				when 47 then -- if done
						l_pos := -1 + 16 -- back to loop condition
				when 48 then -- loop done
						l_break := False
						l_continue := False
						fclose (l_fp).do_nothing
						Result := l_dir
				when 49 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clean_line (a_line: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_line.is_void
		local
			l_line: CE_POINTER [INTEGER_8]
			l_len: INTEGER_32
			l_return: BOOLEAN
		do
			l_line := a_line
			l_len := (strlen (l_line)).to_integer_32
			if not l_len.to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				if (l_line[(l_len - 1)]).to_integer_32 = 10 then
					l_len := l_len - 1
					l_line[l_len] := (('%/0/').code).to_integer_8
				end
				if not l_len.to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if (l_line[(l_len - 1)]).to_integer_32 = 13 then
					l_len := l_len - 1
					l_line[l_len] := (('%/0/').code).to_integer_8
				end
				from
				until
					not ((l_line[0]).to_boolean)
				loop
					if (l_line[0]).to_integer_32 = 9 then
						l_line[0] := ((' ').code).to_integer_8
					end
					l_line := l_line + 1
				end
				Result := l_len
			end
		end

	eat_carets (a_str: CE_POINTER [INTEGER_8])
		require
			not a_str.is_void
		local
			l_str: CE_POINTER [INTEGER_8]
			l_strd: CE_POINTER [INTEGER_8]
			l_hdgt: INTEGER_8
			l_uchr: NATURAL_8
			l_prop: NATURAL_8
			l_break: BOOLEAN
		do
			l_str := a_str
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_str[0]).to_integer_32 /= 0 then
					if (l_str[0]).to_integer_32 = 94 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_str := l_str + 1
				end
			end
			l_break := False
			if (l_str[0]).to_integer_32 /= 0 then
				l_strd := l_str
				from
				until
					(l_str[0]).to_integer_32 = 0
				loop
					l_uchr := (l_str[0]).to_natural_8
					if l_uchr.to_integer_32 = 94 then
						l_str := l_str + 1
						l_uchr := (l_str[0]).to_natural_8
						l_prop := char_prop.item[l_uchr.to_integer_32]
						if ((l_prop.to_integer_32).bit_and (64)).to_boolean then
							if l_uchr.to_integer_32 <= 57 then
								l_hdgt := (l_uchr.to_integer_32 - 48).to_integer_8
							else
								l_hdgt := ((((l_uchr.to_integer_32 - 65)).bit_and (7)) + 10).to_integer_8
							end
							l_hdgt := ((l_hdgt.to_integer_32).bit_shift_left (4)).to_integer_8
							l_str := l_str + 1
							l_uchr := (l_str[0]).to_natural_8
							if l_uchr.to_integer_32 <= 57 then
								l_uchr := ((l_hdgt.to_integer_32 + l_uchr.to_integer_32) - 48).to_natural_8
							else
								l_uchr := ((l_hdgt.to_integer_32 + (((l_uchr.to_integer_32 - 65)).bit_and (15))) + 10).to_natural_8
							end
						elseif l_uchr.to_integer_32 = 95 then
							l_uchr := ((' ').code).to_natural_8
						elseif l_uchr.to_integer_32 = 47 then
							l_uchr := (('?').code).to_natural_8
						end
					end
					l_strd[0] := l_uchr.to_integer_8
					l_strd := l_strd + 1
					l_str := l_str + 1
				end
				l_strd[0] := (('%/0/').code).to_integer_8
			end
		end

	ftp_index (a_file: CE_POINTER [INTEGER_8]; a_u: CE_POINTER [PD_URL]; a_f: CE_POINTER [PD_FILEINFO]): NATURAL_32
		local
			l_f: CE_POINTER [PD_FILEINFO]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_upwd: CE_POINTER [INTEGER_8]
			l_htcldir: CE_POINTER [INTEGER_8]
			l_htclfile: CE_POINTER [INTEGER_8]
			l_urlclfile: CE_POINTER [INTEGER_8]
			l_tmpu: CE_POINTER [INTEGER_8]
			l_tmpp: CE_POINTER [INTEGER_8]
			l_tstamp: CE_ARRAY [INTEGER_32]
			l_ptm: CE_POINTER [SD_TM]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_tstamp.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_f := a_f
					if ((create {P_RETR_STATIC}).output_stream.item).is_void then
						l_fp := fopen (a_file, ce_string ("wb"))
						if l_fp.is_void then
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_file, (strerror ((errno_location).item))])
							Result := ({PC_UERR_T}.FOPENERR)
							l_return := True
						end
					else
						l_fp := (create {P_RETR_STATIC}).output_stream.item
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						if (not (a_u.item.user).is_void) then
							l_tmpu := url_escape (a_u.item.user)
							if (not (a_u.item.passwd).is_void) then
								l_tmpp := (url_escape (a_u.item.passwd))
							else
								l_tmpp := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							end
							if (not l_tmpp.is_void) then
								l_upwd := (create {P_UTILS_STATIC}).concat_strings ([l_tmpu, ce_string (":"), l_tmpp, ce_string ("@"), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)])
							else
								l_upwd := (create {P_UTILS_STATIC}).concat_strings ([l_tmpu, ce_string ("@"), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)])
							end
							free (create {CE_VOID_POINTER}.make_cast (l_tmpu))
							if (not l_tmpp.is_void) then
								free (create {CE_VOID_POINTER}.make_cast (l_tmpp))
							end
						else
							l_upwd := (create {P_XMALLOC_STATIC}).xstrdup (ce_string (""))
						end
						l_htcldir := (create {P_CONVERT_STATIC}).html_quote_string (a_u.item.dir)
						fprintf ([l_fp, ce_string ("<!DOCTYPE HTML PUBLIC %"-//IETF//DTD HTML 2.0//EN%">%N")]).do_nothing
						fprintf ([l_fp, ce_string ("<html>%N<head>%N<title>")]).do_nothing
						fprintf ([l_fp, (gettext (ce_string ("Index of /%%s on %%s:%%d"))), l_htcldir, a_u.item.host, a_u.item.port]).do_nothing
						fprintf ([l_fp, ce_string ("</title>%N</head>%N<body>%N<h1>")]).do_nothing
						fprintf ([l_fp, (gettext (ce_string ("Index of /%%s on %%s:%%d"))), l_htcldir, a_u.item.host, a_u.item.port]).do_nothing
						fprintf ([l_fp, ce_string ("</h1>%N<hr>%N<pre>%N")]).do_nothing
				when 2 then -- loop condition:
						if l_f.is_void then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						fprintf ([l_fp, ce_string ("  ")]).do_nothing
						if l_f.item.tstamp /= -1 then
							l_tstamp.item := l_f.item.tstamp
							l_ptm := (localtime (l_tstamp))
							fprintf ([l_fp, ce_string ("%%d %%s %%02d "), l_ptm.item.tm_year + 1_900, months___0.item[l_ptm.item.tm_mon], l_ptm.item.tm_mday]).do_nothing
							if (l_ptm.item.tm_hour).to_boolean then
								fprintf ([l_fp, ce_string ("%%02d:%%02d  "), l_ptm.item.tm_hour, l_ptm.item.tm_min]).do_nothing
							else
								fprintf ([l_fp, ce_string ("       ")]).do_nothing
							end
						else
							fprintf ([l_fp, (gettext (ce_string ("time unknown       ")))]).do_nothing
						end
						inspect (l_f.item.type).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 4
						when 1 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 4 then -- switch 1, case 0
						fprintf ([l_fp, (gettext (ce_string ("File        ")))]).do_nothing
						l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 1
						fprintf ([l_fp, (gettext (ce_string ("Directory   ")))]).do_nothing
						l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 2
						fprintf ([l_fp, (gettext (ce_string ("Link        ")))]).do_nothing
						l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, default:
						fprintf ([l_fp, (gettext (ce_string ("Not sure    ")))]).do_nothing
						l_pos := -1 + 8 -- switch 1; break
				when 8 then -- switch 1, done:
						l_htclfile := (create {P_CONVERT_STATIC}).html_quote_string (l_f.item.name)
						l_urlclfile := url_escape_unsafe_and_reserved (l_f.item.name)
						fprintf ([l_fp, ce_string ("<a href=%"ftp://%%s%%s:%%d"), l_upwd, a_u.item.host, a_u.item.port]).do_nothing
						if ((a_u.item.dir).item).to_integer_32 /= 47 then
							IO_putc (('/').code, l_fp).do_nothing
						end
						fprintf ([l_fp, ce_string ("%%s"), l_htcldir]).do_nothing
						if ((a_u.item.dir).item).to_boolean then
							IO_putc (('/').code, l_fp).do_nothing
						end
						fprintf ([l_fp, ce_string ("%%s"), l_urlclfile]).do_nothing
						if l_f.item.type = {NATURAL_32} 1 then
							IO_putc (('/').code, l_fp).do_nothing
						end
						fprintf ([l_fp, ce_string ("%">%%s"), l_htclfile]).do_nothing
						if l_f.item.type = {NATURAL_32} 1 then
							IO_putc (('/').code, l_fp).do_nothing
						end
						fprintf ([l_fp, ce_string ("</a> ")]).do_nothing
						if l_f.item.type = {NATURAL_32} 0 then
							l_tmp___10 := (create {P_UTILS_STATIC}).number_to_static_string (l_f.item.size)
							fprintf ([l_fp, (gettext (ce_string (" (%%s bytes)"))), l_tmp___10]).do_nothing
						elseif l_f.item.type = {NATURAL_32} 2 then
							if (not (l_f.item.linkto).is_void) then
								l_tmp___12 := l_f.item.linkto
							else
								l_tmp___12 := ce_string ("(nil)")
							end
							fprintf ([l_fp, ce_string ("-> %%s"), l_tmp___12]).do_nothing
						end
						IO_putc (('%N').code, l_fp).do_nothing
						free (create {CE_VOID_POINTER}.make_cast (l_htclfile))
						free (create {CE_VOID_POINTER}.make_cast (l_urlclfile))
						l_f := l_f.item.next
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done
						fprintf ([l_fp, ce_string ("</pre>%N</body>%N</html>%N")]).do_nothing
						free (create {CE_VOID_POINTER}.make_cast (l_htcldir))
						free (create {CE_VOID_POINTER}.make_cast (l_upwd))
						if ((create {P_RETR_STATIC}).output_stream.item).is_void then
							fclose (l_fp).do_nothing
						else
							fflush (l_fp).do_nothing
						end
						Result := ({PC_UERR_T}.FTPOK)
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	address_list_get_bounds (a_al: CE_POINTER [PD_ADDRESS_LIST]; a_start, a_end: CE_POINTER [INTEGER_32])
		require
			not a_al.is_void
			not a_start.is_void
			not a_end.is_void
		do
			a_start.item := a_al.item.faulty
			a_end.item := a_al.item.count
		end

	address_list_set_faulty (a_al: CE_POINTER [PD_ADDRESS_LIST]; a_index___0: INTEGER_32)
		require
			not a_al.is_void
		do
			if a_index___0 /= a_al.item.faulty then
				assert_fail (ce_string ("index == al->faulty"), ce_string ("host.c"), {NATURAL_32} 150, ce_string ("address_list_set_faulty"))
			end
			a_al.item.faulty := (a_al.item.faulty) + 1
			if a_al.item.faulty >= a_al.item.count then
				a_al.item.faulty := 0
			end
		end

	address_list_set_connected (a_al: CE_POINTER [PD_ADDRESS_LIST])
		require
			not a_al.is_void
		do
			a_al.item.connected := (1).to_boolean
		end

	address_list_connected_p (a_al: CE_POINTER [PD_ADDRESS_LIST]): BOOLEAN
		require
			not a_al.is_void
		do
			Result := (a_al.item.connected)
		end

	request_new: CE_POINTER [PD_REQUEST]
		local
			l_req: CE_POINTER [PD_REQUEST]
		do
			l_req := create {CE_CLASS_POINTER [PD_REQUEST]}.make_cast (((create {P_XMALLOC_STATIC}).xcalloc ((1).to_natural_32, (create {PD_REQUEST}.make).structure_size.to_natural_32)))
			l_req.item.hcapacity := 8
			l_req.item.headers := create {CE_CLASS_POINTER [PD_REQUEST_HEADER]}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((l_req.item.hcapacity).to_natural_32 * (create {PD_REQUEST_HEADER}.make).structure_size.to_natural_32)))
			Result := l_req
		end

	request_set_method (a_req: CE_POINTER [PD_REQUEST]; a_meth, a_arg: CE_POINTER [INTEGER_8])
		require
			not a_req.is_void
		do
			a_req.item.method := a_meth
			a_req.item.arg := a_arg
		end

	request_method (a_req: CE_POINTER [PD_REQUEST]): CE_POINTER [INTEGER_8]
		require
			not a_req.is_void
		do
			Result := (a_req.item.method)
		end

	request_set_user_header (a_req: CE_POINTER [PD_REQUEST]; a_header: CE_POINTER [INTEGER_8])
		require
			not a_header.is_void
		local
			l_name: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_p___0: CE_POINTER [INTEGER_8]
			l_BTA_beg: CE_POINTER [INTEGER_8]
			l_BTA_len: INTEGER_32
			l_BTA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_name.make (<<1>>)

			l_p___0 := (strchr (a_header, (':').code))
			if l_p___0.is_void then
				l_return := True
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					l_BTA_beg := a_header
					l_BTA_len := l_p___0.distance (l_BTA_beg)
					l_BTA_dest := l_name
					l_BTA_dest.item := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new ((l_BTA_len + 1).to_natural_32)))
					memcpy (create {CE_VOID_POINTER}.make_cast (l_BTA_dest.item), create {CE_VOID_POINTER}.make_cast (l_BTA_beg), l_BTA_len.to_natural_32).do_nothing
					l_BTA_dest.item[l_BTA_len] := (('%/0/').code).to_integer_8
					l_break := True
				end
				l_break := False
				l_p___0 := l_p___0 + 1
				from
				until
					(l_break)
				loop
					l_break := False
					if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
						l_break := True
					end
					if not (l_break) then
						l_p___0 := l_p___0 + 1
					end
				end
				l_break := False
				request_set_header (a_req, ((create {P_XMALLOC_STATIC}).xstrdup (l_name.item)), l_p___0, {PC_RP}.rel_name)
			end
		end

	request_remove_header (a_req: CE_POINTER [PD_REQUEST]; a_name: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_req.is_void
		local
			l_i: INTEGER_32
			l_hdr: CE_POINTER [PD_REQUEST_HEADER]
			l_return: BOOLEAN
		do
			l_i := 0
			from
			until
				not (not (l_return) and then (l_i < a_req.item.hcount))
			loop
				l_hdr := a_req.item.headers + l_i
				if 0 = (strcasecmp (a_name, l_hdr.item.name)) then
					release_header (l_hdr)
					if l_i < a_req.item.hcount - 1 then
						memmove (create {CE_VOID_POINTER}.make_cast (l_hdr), create {CE_VOID_POINTER}.make_cast ((l_hdr + 1)), ((a_req.item.hcount - l_i) - 1).to_natural_32 * (create {PD_REQUEST_HEADER}.make).structure_size.to_natural_32).do_nothing
					end
					a_req.item.hcount := (a_req.item.hcount) - 1
					Result := (1).to_boolean
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := (0).to_boolean
			end
		end

	request_send (a_req: CE_POINTER [PD_REQUEST]; a_fd: INTEGER_32): INTEGER_32
		require
			not a_req.is_void
		local
			l_request_string: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_size: INTEGER_32
			l_write_error: INTEGER_32
			l_tmp: NATURAL_32
			l_hdr: CE_POINTER [PD_REQUEST_HEADER]
			l_tmp___1: NATURAL_32
			l_A_len: INTEGER_32
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_A_len___0: INTEGER_32
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_hdr___0: CE_POINTER [PD_REQUEST_HEADER]
			l_A_len___1: INTEGER_32
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_A_len___2: INTEGER_32
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___18: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			l_size := 0
			l_tmp := strlen (a_req.item.method)
			l_size := (l_size.to_natural_32 + (((((l_tmp + {NATURAL_32} 1) + (strlen (a_req.item.arg))) + {NATURAL_32} 1) + {NATURAL_32} 8) + {NATURAL_32} 2)).to_integer_32
			l_i := 0
			from
			until
				not (l_i < a_req.item.hcount)
			loop
				l_hdr := a_req.item.headers + l_i
				l_tmp___1 := strlen (l_hdr.item.name)
				l_size := (l_size.to_natural_32 + (((l_tmp___1 + {NATURAL_32} 2) + (strlen (l_hdr.item.value))) + {NATURAL_32} 2)).to_integer_32
				l_i := l_i + 1
			end
			l_size := l_size + (3)
			l_request_string := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new (l_size.to_natural_32 * {PLATFORM}.Integer_8_bytes.to_natural_32)))
			l_p___0 := l_request_string
			from
			until
				(l_break)
			loop
				l_break := False
				l_A_len := (strlen (a_req.item.method)).to_integer_32
				memcpy (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (a_req.item.method), l_A_len.to_natural_32).do_nothing
				l_p___0 := l_p___0 + l_A_len
				l_break := True
			end
			l_break := False
			l_tmp___5 := l_p___0
			l_p___0 := l_p___0 + 1
			l_tmp___5[0] := ((' ').code).to_integer_8
			from
			until
				(l_break)
			loop
				l_break := False
				l_A_len___0 := (strlen (a_req.item.arg)).to_integer_32
				memcpy (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (a_req.item.arg), l_A_len___0.to_natural_32).do_nothing
				l_p___0 := l_p___0 + l_A_len___0
				l_break := True
			end
			l_break := False
			l_tmp___7 := l_p___0
			l_p___0 := l_p___0 + 1
			l_tmp___7[0] := ((' ').code).to_integer_8
			memcpy (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (ce_string ("HTTP/1.0%R%N")), (10).to_natural_32).do_nothing
			l_p___0 := l_p___0 + (10)
			l_i := 0
			from
			until
				not (not (l_return) and then (l_i < a_req.item.hcount))
			loop
				l_hdr___0 := a_req.item.headers + l_i
				from
				until
					(l_break)
				loop
					l_break := False
					l_A_len___1 := (strlen (l_hdr___0.item.name)).to_integer_32
					memcpy (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_hdr___0.item.name), l_A_len___1.to_natural_32).do_nothing
					l_p___0 := l_p___0 + l_A_len___1
					l_break := True
				end
				l_break := False
				l_tmp___9 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___9[0] := ((':').code).to_integer_8
				l_tmp___10 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___10[0] := ((' ').code).to_integer_8
				from
				until
					(l_break)
				loop
					l_break := False
					l_A_len___2 := (strlen (l_hdr___0.item.value)).to_integer_32
					memcpy (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_hdr___0.item.value), l_A_len___2.to_natural_32).do_nothing
					l_p___0 := l_p___0 + l_A_len___2
					l_break := True
				end
				l_break := False
				l_tmp___12 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___12[0] := (('%R').code).to_integer_8
				l_tmp___13 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___13[0] := (('%N').code).to_integer_8
				l_i := l_i + 1
			end
			l_tmp___14 := l_p___0
			l_p___0 := l_p___0 + 1
			l_tmp___14[0] := (('%R').code).to_integer_8
			l_tmp___15 := l_p___0
			l_p___0 := l_p___0 + 1
			l_tmp___15[0] := (('%N').code).to_integer_8
			l_tmp___16 := l_p___0
			l_p___0 := l_p___0 + 1
			l_tmp___16[0] := (('%/0/').code).to_integer_8
			if l_p___0.distance (l_request_string) /= l_size then
				assert_fail (ce_string ("p - request_string == size"), ce_string ("http.c"), {NATURAL_32} 367, ce_string ("request_send"))
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
					(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%N---request begin---%N%%s---request end---%N"), l_request_string])
				end
				l_break := True
			end
			l_break := False
			l_write_error := fd_write (a_fd, l_request_string, l_size - 1, (-1).to_double)
			if l_write_error < 0 then
				l_tmp___18 := fd_errstr (a_fd);
				(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Failed writing HTTP request: %%s.%N"))), l_tmp___18])
			end
			Result := l_write_error
		end

	request_free (a_req: CE_POINTER [PD_REQUEST])
		require
			not a_req.is_void
		local
			l_i: INTEGER_32
		do
			if (not (a_req.item.arg).is_void) then
				free (create {CE_VOID_POINTER}.make_cast (a_req.item.arg))
			end
			l_i := 0
			from
			until
				not (l_i < a_req.item.hcount)
			loop
				release_header (a_req.item.headers + l_i)
				l_i := l_i + 1
			end
			if (not (a_req.item.headers).is_void) then
				free (create {CE_VOID_POINTER}.make_cast (a_req.item.headers))
			end
			free (create {CE_VOID_POINTER}.make_cast (a_req))
		end

	maybe_send_basic_creds (a_hostname, a_user, a_passwd: CE_POINTER [INTEGER_8]; a_req: CE_POINTER [PD_REQUEST]): BOOLEAN
		local
			l_do_challenge: BOOLEAN
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_do_challenge := (0).to_boolean
					if not ((create {P_OPTIONS_STATIC}).opt.item.item.auth_without_challenge) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Auth-without-challenge set, sending Basic credentials.%N")])
							end
							l_break := True
						end
						l_break := False
						l_do_challenge := (1).to_boolean
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if basic_authed_hosts.item.is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (basic_authed_hosts.item.item.hash_table_contains (create {CE_VOID_POINTER}.make_cast (a_hostname))).to_boolean then
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Found %%s in basic_authed_hosts.%N"), ((create {P_QUOTE_STATIC}).quote (a_hostname))])
								end
								l_break := True
							end
							l_break := False
							l_do_challenge := (1).to_boolean
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Host %%s has not issued a general basic challenge.%N"), ((create {P_QUOTE_STATIC}).quote (a_hostname))])
							end
							l_break := True
						end
						l_break := False
				when 7 then -- if done
					if l_do_challenge then
						request_set_header (a_req, ce_string ("Authorization"), (basic_authentication_encode (a_user, a_passwd)), {PC_RP}.rel_value)
					end
					Result := l_do_challenge
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	request_set_header (a_req: CE_POINTER [PD_REQUEST]; a_name, a_value: CE_POINTER [INTEGER_8]; a_release_policy: NATURAL_32)
		local
			l_hdr: CE_POINTER [PD_REQUEST_HEADER]
			l_i: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			if a_value.is_void then
				if a_release_policy = {NATURAL_32} 1 then
					free (create {CE_VOID_POINTER}.make_cast (a_name))
				elseif a_release_policy = {NATURAL_32} 3 then
					free (create {CE_VOID_POINTER}.make_cast (a_name))
				end
				l_return := True
			end
			if not l_return then
				l_i := 0
				from
				until
					not (not (l_return) and then (l_i < a_req.item.hcount))
				loop
					l_hdr := a_req.item.headers + l_i
					if 0 = (strcasecmp (a_name, l_hdr.item.name)) then
						release_header (l_hdr)
						l_hdr.item.name := a_name
						l_hdr.item.value := a_value
						l_hdr.item.release_policy := a_release_policy
						l_return := True
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				if a_req.item.hcount >= a_req.item.hcapacity then
					a_req.item.hcapacity := (a_req.item.hcapacity).bit_shift_left ((1))
					a_req.item.headers := create {CE_CLASS_POINTER [PD_REQUEST_HEADER]}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (a_req.item.headers), (a_req.item.hcapacity).to_natural_32 * (create {PD_REQUEST_HEADER}.make).structure_size.to_natural_32)))
				end
				l_tmp___1 := a_req.item.hcount
				a_req.item.hcount := (a_req.item.hcount) + 1
				l_hdr := a_req.item.headers + l_tmp___1
				l_hdr.item.name := a_name
				l_hdr.item.value := a_value
				l_hdr.item.release_policy := a_release_policy
			end
		end

	release_header (a_hdr: CE_POINTER [PD_REQUEST_HEADER])
		require
			not a_hdr.is_void
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (a_hdr.item.release_policy).to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 0
					l_pos := -1 + 5 -- switch 1; break
				when 2 then -- switch 1, case 1
					free (create {CE_VOID_POINTER}.make_cast (a_hdr.item.name))
					l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 2
					free (create {CE_VOID_POINTER}.make_cast (a_hdr.item.value))
					l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, case 3
					free (create {CE_VOID_POINTER}.make_cast (a_hdr.item.name))
					free (create {CE_VOID_POINTER}.make_cast (a_hdr.item.value))
					l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	register_basic_auth_host (a_hostname: CE_POINTER [INTEGER_8])
		local
			l_break: BOOLEAN
		do
			if basic_authed_hosts.item.is_void then
				basic_authed_hosts.item := (create {P_HASH_STATIC}).make_nocase_string_hash_table (1)
			end
			if not (basic_authed_hosts.item.item.hash_table_contains (create {CE_VOID_POINTER}.make_cast (a_hostname))).to_boolean then
				basic_authed_hosts.item.item.hash_table_put (create {CE_VOID_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xstrdup (a_hostname))), create {CE_VOID_POINTER}.make_shared (default_pointer))
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Inserted %%s into basic_authed_hosts%N"), ((create {P_QUOTE_STATIC}).quote (a_hostname))])
					end
					l_break := True
				end
				l_break := False
			end
		end

	post_file (a_sock: INTEGER_32; a_file_name: CE_POINTER [INTEGER_8]; a_promised_size: INTEGER_64): INTEGER_32
		local
			l_written: INTEGER_64
			l_write_error: INTEGER_32
			l_fp: CE_POINTER [SD_IO_FILE]
			l_towrite: INTEGER_32
			l_length: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_written := (0).to_integer_64
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
					(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("[writing POST file %%s ... "), a_file_name])
				end
				l_break := True
			end
			l_break := False
			l_fp := fopen (a_file_name, ce_string ("rb"))
			if l_fp.is_void then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if (feof (l_fp)).to_boolean then
						l_break := True
					elseif not (l_written < a_promised_size) then
						l_break := True
					end
					if not (l_return or l_break) then
						l_length := (fread (create {CE_VOID_POINTER}.make_cast (chunk.item), (1).to_natural_32, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8_192).to_natural_32), l_fp)).to_integer_32
						if l_length = 0 then
							l_break := True
						end
					end
					if not (l_return or l_break) then
						if a_promised_size - l_written > l_length.to_integer_64 then
							l_towrite := l_length
						else
							l_towrite := (a_promised_size - l_written).to_integer_32
						end
						l_write_error := fd_write (a_sock, chunk.item, l_towrite, (-1).to_double)
						if l_write_error < 0 then
							fclose (l_fp).do_nothing
							Result := (-1)
							l_return := True
						end
						if not l_return then
							l_written := l_written + l_towrite.to_integer_64
						end
					end
				end
			end
			if not l_return then
				l_break := False
				fclose (l_fp).do_nothing
				if l_written < a_promised_size then
					(errno_location).item := 22
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				if l_written /= a_promised_size then
					assert_fail (ce_string ("written == promised_size"), ce_string ("http.c"), {NATURAL_32} 489, ce_string ("post_file"))
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("done]%N")])
					end
					l_break := True
				end
				l_break := False
				Result := 0
			end
		end

	fd_write (a_fd: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_bufsize___0: INTEGER_32; a_timeout: REAL_64): INTEGER_32
		local
			l_buf___6: CE_POINTER [INTEGER_8]
			l_bufsize___0: INTEGER_32
			l_res___0: INTEGER_32
			l_info: CE_POINTER [PD_TRANSPORT_INFO]
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			l_buf___6 := a_buf___6
			l_bufsize___0 := a_bufsize___0
			from
			until
				(l_break)
			loop
				l_break := False
				if ((create {P_CONNECT_STATIC}).transport_map.item).is_void then
					l_info := create {CE_CLASS_POINTER [PD_TRANSPORT_INFO]}.make_shared (default_pointer)
				elseif last_fd___1.item = a_fd then
					if last_tick___1.item = (create {P_CONNECT_STATIC}).transport_map_modified_tick.item then
						l_info := last_info___1.item
					else
						l_tmp := ((create {P_CONNECT_STATIC}).transport_map.item).item.hash_table_get (create {CE_VOID_POINTER}.make_shared (default_pointer + a_fd))
						l_info := create {CE_CLASS_POINTER [PD_TRANSPORT_INFO]}.make_cast (l_tmp)
						last_fd___1.item := a_fd
						last_info___1.item := l_info
						last_tick___1.item := (create {P_CONNECT_STATIC}).transport_map_modified_tick.item
					end
				else
					l_tmp := ((create {P_CONNECT_STATIC}).transport_map.item).item.hash_table_get (create {CE_VOID_POINTER}.make_shared (default_pointer + a_fd))
					l_info := create {CE_CLASS_POINTER [PD_TRANSPORT_INFO]}.make_cast (l_tmp)
					last_fd___1.item := a_fd
					last_info___1.item := l_info
					last_tick___1.item := (create {P_CONNECT_STATIC}).transport_map_modified_tick.item
				end
				l_break := True
			end
			l_break := False
			l_res___0 := 0
			from
			until
				not (not (l_return or l_break) and then (l_bufsize___0 > 0))
			loop
				l_break := False
				if not (poll_internal (a_fd, l_info, 2, a_timeout)) then
					Result := (-1)
					l_return := True
				end
				if not l_return then
					if (not l_info.is_void) then
						if (not ((l_info.item.imp).item.writer).is_void) then
							l_res___0 := ((l_info.item.imp).item.writer).integer_32_item ([a_fd, l_buf___6, l_bufsize___0, l_info.item.ctx])
						else
							l_res___0 := sock_write (a_fd, l_buf___6, l_bufsize___0)
						end
					else
						l_res___0 := sock_write (a_fd, l_buf___6, l_bufsize___0)
					end
					if l_res___0 <= 0 then
						l_break := True
					end
					if not (l_return or l_break) then
						l_buf___6 := l_buf___6 + l_res___0
						l_bufsize___0 := l_bufsize___0 - l_res___0
					end
				end
			end
			if not l_return then
				l_break := False
				Result := l_res___0
			end
		end

	sock_write (a_fd: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_bufsize___0: INTEGER_32): INTEGER_32
		local
			l_res___0: INTEGER_32
			l_break: BOOLEAN
		do
			from
			until
				(l_break)
			loop
				l_break := False
				l_res___0 := write (a_fd, create {CE_VOID_POINTER}.make_cast (a_buf___6), a_bufsize___0.to_natural_32)
				if l_res___0 = -1 then
					if (errno_location).item /= 4 then
						l_break := True
					end
				else
					l_break := True
				end
			end
			l_break := False
			Result := l_res___0
		end

	read_http_response_head (a_fd: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			Result := (fd_read_hunk (a_fd, (create {P_HTTP_STATIC}).response_head_terminator_address, 512, 65_536))
		end

	resp_new (a_head: CE_POINTER [INTEGER_8]): CE_POINTER [PD_RESPONSE]
		require
			not a_head.is_void
		local
			l_hdr: CE_POINTER [INTEGER_8]
			l_count: INTEGER_32
			l_size: INTEGER_32
			l_resp: CE_POINTER [PD_RESPONSE]
			l_DR_needed_size: INTEGER_32
			l_DR_newsize: INTEGER_32
			l_tmp___1: INTEGER_32
			l_end: CE_POINTER [INTEGER_8]
			l_DR_needed_size___0: INTEGER_32
			l_DR_newsize___0: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_resp := create {CE_CLASS_POINTER [PD_RESPONSE]}.make_cast (((create {P_XMALLOC_STATIC}).xcalloc ((1).to_natural_32, (create {PD_RESPONSE}.make).structure_size.to_natural_32)))
					l_resp.item.data := a_head
					if (a_head[0]).to_integer_32 = 0 then
						Result := l_resp
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_count := 0
						l_size := l_count
						l_hdr := a_head
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 11 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_DR_needed_size := (l_count + 1).to_integer_32
							l_DR_newsize := 0
							from
							until
								not (l_size.to_integer_32 < l_DR_needed_size)
							loop
								l_DR_newsize := ((l_size).bit_shift_left (1)).to_integer_32
								if l_DR_newsize < 16 then
									l_DR_newsize := 16
								end
								l_size := l_DR_newsize.to_integer_32
							end
							if l_DR_newsize.to_boolean then
								l_resp.item.headers := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_resp.item.headers), (l_DR_newsize.to_natural_32 * ({PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_break := True
						end
						l_break := False
						l_tmp___1 := l_count
						l_count := l_count + 1
						l_resp.item.headers[l_tmp___1] := l_hdr
						if (l_hdr[0]).to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_break := True
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if (l_hdr[0]).to_integer_32 /= 13 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (l_hdr[1]).to_integer_32 = 10 then
							l_break := True
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if (l_hdr[0]).to_integer_32 = 10 then
							l_break := True
						end
				when 10 then -- if done
						if not (l_return or l_break) then
							from
							until
								(l_break)
							loop
								l_break := False
								l_end := (strchr (l_hdr, ('%N').code))
								if (not l_end.is_void) then
									l_hdr := l_end + 1
								else
									l_hdr := l_hdr + (strlen (l_hdr)).to_integer_32
								end
								if (l_hdr[0]).to_integer_32 /= 32 then
									if (l_hdr[0]).to_integer_32 /= 9 then
										l_break := True
									end
								end
							end
							l_break := False
						end
						l_pos := -1 + 2 -- back to loop condition
				when 11 then -- loop done
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_DR_needed_size___0 := (l_count + 1).to_integer_32
							l_DR_newsize___0 := 0
							from
							until
								not (l_size.to_integer_32 < l_DR_needed_size___0)
							loop
								l_DR_newsize___0 := ((l_size).bit_shift_left (1)).to_integer_32
								if l_DR_newsize___0 < 16 then
									l_DR_newsize___0 := 16
								end
								l_size := l_DR_newsize___0.to_integer_32
							end
							if l_DR_newsize___0.to_boolean then
								l_resp.item.headers := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_resp.item.headers), (l_DR_newsize___0.to_natural_32 * ({PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_break := True
						end
						l_break := False
						l_resp.item.headers[l_count] := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						Result := l_resp
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	resp_header_copy (a_resp: CE_POINTER [PD_RESPONSE]; a_name, a_buf___6: CE_POINTER [INTEGER_8]; a_bufsize___0: INTEGER_32): BOOLEAN
		require
			not a_resp.is_void
		local
			l_b: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_e: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_len: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_b.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_e.make (<<1>>)

			if not (resp_header_get (a_resp, a_name, l_b, l_e)) then
				Result := (0).to_boolean
				l_return := True
			end
			if not l_return then
				if a_bufsize___0.to_boolean then
					if (l_e.item).distance ((l_b.item)) > a_bufsize___0 - 1 then
						l_tmp___0 := a_bufsize___0 - 1
					else
						l_tmp___0 := (l_e.item).distance ((l_b.item))
					end
					l_len := l_tmp___0
					memcpy (create {CE_VOID_POINTER}.make_cast (a_buf___6), create {CE_VOID_POINTER}.make_cast (l_b.item), l_len.to_natural_32).do_nothing
					a_buf___6[l_len] := (('%/0/').code).to_integer_8
				end
				Result := (1).to_boolean
			end
		end

	resp_header_strdup (a_resp: CE_POINTER [PD_RESPONSE]; a_name: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_resp.is_void
		local
			l_b: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_e: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_b.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_e.make (<<1>>)

			if not (resp_header_get (a_resp, a_name, l_b, l_e)) then
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := ((create {P_UTILS_STATIC}).strdupdelim (l_b.item, l_e.item))
			end
		end

	resp_header_get (a_resp: CE_POINTER [PD_RESPONSE]; a_name: CE_POINTER [INTEGER_8]; a_begptr, a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]): BOOLEAN
		require
			not a_resp.is_void
		local
			l_pos2: INTEGER_32
		do
			l_pos2 := (resp_header_locate (a_resp, a_name, 0, a_begptr, a_endptr))
			Result := (l_pos2 /= -1)
		end

	resp_header_locate (a_resp: CE_POINTER [PD_RESPONSE]; a_name: CE_POINTER [INTEGER_8]; a_start: INTEGER_32; a_begptr, a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		require
			not a_resp.is_void
		local
			l_i: INTEGER_32
			l_headers: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_name_len: INTEGER_32
			l_b: CE_POINTER [INTEGER_8]
			l_e: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			l_headers := a_resp.item.headers
			if l_headers.is_void then
				Result := (-1)
				l_return := True
			elseif (l_headers[1]).is_void then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_name_len := (strlen (a_name)).to_integer_32
				if a_start > 0 then
					l_i := a_start
				else
					l_i := 1
				end
				from
				until
					not (not (l_return) and then (not (l_headers[(l_i + 1)]).is_void))
				loop
					l_b := l_headers[l_i]
					l_e := l_headers[(l_i + 1)]
					if l_e.distance (l_b) > l_name_len then
						if (l_b[l_name_len]).to_integer_32 = 58 then
							if 0 = (strncasecmp (l_b, a_name, l_name_len.to_natural_32)) then
								l_b := l_b + (l_name_len + 1)
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_b.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32 then
										if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_b[0]).to_integer_32)) then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_b := l_b + 1
									end
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_b.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32 then
										if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_e[-1]).to_integer_32)) then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_e := l_e - 1
									end
								end
								l_break := False
								a_begptr.item := l_b
								a_endptr.item := l_e
								Result := l_i
								l_return := True
							end
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

	resp_status (a_resp: CE_POINTER [PD_RESPONSE]; a_message: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		require
			not a_resp.is_void
		local
			l_status: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			if (a_resp.item.headers).is_void then
				if (not a_message.is_void) then
					a_message.item := (create {P_XMALLOC_STATIC}).xstrdup ((gettext (ce_string ("No headers, assuming HTTP/0.9"))))
				end
				Result := 200
				l_return := True
			end
			if not l_return then
				l_p___0 := a_resp.item.headers[0]
				l_end := a_resp.item.headers[1]
				if l_end.is_void then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				if l_end.distance (l_p___0) < 4 then
					Result := (-1)
					l_return := True
				elseif 0 /= (strncmp (l_p___0, ce_string ("HTTP"), (4).to_natural_32)) then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_p___0 := l_p___0 + (4)
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
					if (l_p___0[0]).to_integer_32 = 47 then
						l_p___0 := l_p___0 + 1
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
								if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[0]).to_integer_32)) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
							if (l_p___0[0]).to_integer_32 = 46 then
								l_p___0 := l_p___0 + 1
							end
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
								if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[0]).to_integer_32)) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
					end
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
						if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_p___0 := l_p___0 + 1
					end
				end
				l_break := False
				if l_end.distance (l_p___0) < 3 then
					Result := (-1)
					l_return := True
				elseif ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[0]).to_integer_32)) then
					if ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[1]).to_integer_32)) then
						if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[2]).to_integer_32)) then
							Result := (-1)
							l_return := True
						end
					else
						Result := (-1)
						l_return := True
					end
				else
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_status := (100 * ((l_p___0[0]).to_integer_32 - 48) + 10 * ((l_p___0[1]).to_integer_32 - 48)) + ((l_p___0[2]).to_integer_32 - 48)
				l_p___0 := l_p___0 + (3)
				if (not a_message.is_void) then
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
							if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_p___0 := l_p___0 + 1
						end
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
							if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_end[-1]).to_integer_32)) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_end := l_end - 1
						end
					end
					l_break := False
					a_message.item := (create {P_UTILS_STATIC}).strdupdelim (l_p___0, l_end)
				end
				Result := l_status
			end
		end

	resp_free (a_resp: CE_POINTER [PD_RESPONSE])
		require
			not a_resp.is_void
		do
			if (not (a_resp.item.headers).is_void) then
				free (create {CE_VOID_POINTER}.make_cast (a_resp.item.headers))
			end
			free (create {CE_VOID_POINTER}.make_cast (a_resp))
		end

	parse_content_range (a_hdr: CE_POINTER [INTEGER_8]; a_first_byte_ptr, a_last_byte_ptr, a_entity_length_ptr: CE_POINTER [INTEGER_64]): BOOLEAN
		require
			not a_hdr.is_void
		local
			l_hdr: CE_POINTER [INTEGER_8]
			l_num: INTEGER_64
			l_return, l_break: BOOLEAN
		do
			l_hdr := a_hdr
			if 0 = (strncasecmp (l_hdr, ce_string ("bytes"), (5).to_natural_32)) then
				l_hdr := l_hdr + (5)
				if (l_hdr[0]).to_integer_32 = 58 then
					l_hdr := l_hdr + 1
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_hdr[0]).to_integer_32)) then
						l_break := True
					end
					if not (l_break) then
						l_hdr := l_hdr + 1
					end
				end
				l_break := False
				if not (l_hdr[0]).to_boolean then
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return then
				if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_hdr[0]).to_integer_32)) then
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return then
				l_num := (0).to_integer_64
				from
				until
					(l_break)
				loop
					l_break := False
					if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_hdr[0]).to_integer_32)) then
						l_break := True
					end
					if not (l_break) then
						l_num := {INTEGER_64} 10 * l_num + ((l_hdr[0]).to_integer_32 - 48).to_integer_64
						l_hdr := l_hdr + 1
					end
				end
				l_break := False
				if (l_hdr[0]).to_integer_32 /= 45 then
					Result := (0).to_boolean
					l_return := True
				elseif not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_hdr[1]).to_integer_32)) then
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return then
				a_first_byte_ptr.item := l_num
				l_hdr := l_hdr + 1
				l_num := (0).to_integer_64
				from
				until
					(l_break)
				loop
					l_break := False
					if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_hdr[0]).to_integer_32)) then
						l_break := True
					end
					if not (l_break) then
						l_num := {INTEGER_64} 10 * l_num + ((l_hdr[0]).to_integer_32 - 48).to_integer_64
						l_hdr := l_hdr + 1
					end
				end
				l_break := False
				if (l_hdr[0]).to_integer_32 /= 47 then
					Result := (0).to_boolean
					l_return := True
				elseif not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_hdr[1]).to_integer_32)) then
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return then
				a_last_byte_ptr.item := l_num
				l_hdr := l_hdr + 1
				if (l_hdr[0]).to_integer_32 = 42 then
					l_num := (-1).to_integer_64
				else
					l_num := (0).to_integer_64
					from
					until
						(l_break)
					loop
						l_break := False
						if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_hdr[0]).to_integer_32)) then
							l_break := True
						end
						if not (l_break) then
							l_num := {INTEGER_64} 10 * l_num + ((l_hdr[0]).to_integer_32 - 48).to_integer_64
							l_hdr := l_hdr + 1
						end
					end
					l_break := False
				end
				a_entity_length_ptr.item := l_num
				Result := (1).to_boolean
			end
		end

	skip_short_body (a_fd: INTEGER_32; a_contlen: INTEGER_64): BOOLEAN
		local
			l_contlen: INTEGER_64
			l_dlbuf___0: CE_ARRAY [INTEGER_8]
			l_ret: INTEGER_32
			l_tmp___1: INTEGER_64
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_dlbuf___0.make (<<513>>)

			l_contlen := a_contlen
			l_dlbuf___0[512] := (('%/0/').code).to_integer_8
			if l_contlen = -{INTEGER_64} 1 then
				assert_fail (ce_string ("contlen != -1"), ce_string ("http.c"), {NATURAL_32} 915, ce_string ("skip_short_body"))
			end
			if l_contlen > {INTEGER_64} 4_096 then
				Result := (0).to_boolean
				l_return := True
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Skipping %%s bytes of body: ["), ((create {P_UTILS_STATIC}).number_to_static_string (l_contlen))])
					end
					l_break := True
				end
				l_break := False
				from
				until
					not (not (l_return) and then (l_contlen > {INTEGER_64} 0))
				loop
					if l_contlen > {INTEGER_64} 512 then
						l_tmp___1 := (512).to_integer_64
					else
						l_tmp___1 := l_contlen
					end
					l_ret := (fd_read (a_fd, l_dlbuf___0, l_tmp___1.to_integer_32, (-1).to_double))
					if l_ret <= 0 then
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								if l_ret < 0 then
									l_tmp___4 := (fd_errstr (a_fd))
								else
									l_tmp___4 := ce_string ("EOF received")
								end
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("] aborting (%%s).%N"), l_tmp___4])
							end
							l_break := True
						end
						l_break := False
						Result := (0).to_boolean
						l_return := True
					end
					if not l_return then
						l_contlen := l_contlen - l_ret.to_integer_64
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%%.*s"), l_ret, l_dlbuf___0])
							end
							l_break := True
						end
						l_break := False
					end
				end
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("] done.%N")])
					end
					l_break := True
				end
				l_break := False
				Result := (1).to_boolean
			end
		end

	fd_errstr (a_fd: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_info: CE_POINTER [PD_TRANSPORT_INFO]
			l_err: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_info := create {CE_CLASS_POINTER [PD_TRANSPORT_INFO]}.make_shared (default_pointer)
			if (not ((create {P_CONNECT_STATIC}).transport_map.item).is_void) then
				l_info := create {CE_CLASS_POINTER [PD_TRANSPORT_INFO]}.make_cast ((((create {P_CONNECT_STATIC}).transport_map.item).item.hash_table_get (create {CE_VOID_POINTER}.make_shared (default_pointer + a_fd))))
			end
			if (not l_info.is_void) then
				if (not ((l_info.item.imp).item.errstr).is_void) then
					l_err := (create {CE_INTEGER_8_POINTER}.make_cast (((l_info.item.imp).item.errstr).pointer_item ([a_fd, l_info.item.ctx])))
					if (not l_err.is_void) then
						Result := l_err
						l_return := True
					end
				end
			end
			if not l_return then
				Result := (strerror ((errno_location).item))
			end
		end

	parse_content_disposition (a_hdr: CE_POINTER [INTEGER_8]; a_filename: CE_POINTER [CE_POINTER [INTEGER_8]]): BOOLEAN
		local
			l_hdr: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_name: CE_ARRAY [PD_PARAM_TOKEN]
			l_value: CE_ARRAY [PD_PARAM_TOKEN]
			l_last_slash: CE_POINTER [INTEGER_8]
			l_last_bs: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_prefix_length: INTEGER_32
			l_add_slash: BOOLEAN
			l_total_length: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_hdr.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_PARAM_TOKEN]} l_name.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_PARAM_TOKEN]} l_value.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_hdr.item := a_hdr
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						if not (extract_param (l_hdr, l_name, l_value, ((';').code).to_integer_8)) then
							l_break := True
						end
						if not (not (l_return or l_break or l_continue) and then (((l_name.item.e).distance ((l_name.item.b))).to_natural_32 = (("filename").count + 1).to_natural_32 - {NATURAL_32} 1)) then
							l_pos := -1 + 14 -- skip if block
						end
				when 3 then -- if:
						if (strncasecmp (l_name.item.b, ce_string ("filename"), (("filename").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
							l_pos := -1 + 14 -- skip if block
						end
				when 4 then -- if:
						if (l_value.item.b).is_void then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						l_last_slash := create {CE_INTEGER_8_POINTER}.make_cast ((memrchr (create {CE_VOID_POINTER}.make_cast (l_value.item.b), ('/').code, ((l_value.item.e).distance ((l_value.item.b))).to_natural_32)))
						l_last_bs := create {CE_INTEGER_8_POINTER}.make_cast ((memrchr (create {CE_VOID_POINTER}.make_cast (l_value.item.b), ('\').code, ((l_value.item.e).distance ((l_value.item.b))).to_natural_32)))
						if l_last_slash.is_void then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (not l_last_bs.is_void) then
							if (l_last_slash.c_pointer.to_integer_32).to_natural_32 > (l_last_bs.c_pointer.to_integer_32).to_natural_32 then
								l_tmp___1 := l_last_slash
							else
								l_tmp___1 := l_last_bs
							end
							l_value.item.b := l_tmp___1 + 1
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 8 then -- else: | _L___0:
						if l_last_slash.is_void then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if l_last_bs.is_void then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						if (not l_last_slash.is_void) then
							l_tmp___2 := l_last_slash
						else
							l_tmp___2 := l_last_bs
						end
						l_value.item.b := l_tmp___2 + 1
				when 13 then -- if done | if done
						if (l_value.item.b).is_equal (l_value.item.e) then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							if (not ((create {P_OPTIONS_STATIC}).opt.item.item.dir_prefix).is_void) then
								l_prefix_length := (strlen ((create {P_OPTIONS_STATIC}).opt.item.item.dir_prefix)).to_integer_32
								l_add_slash := (((create {P_OPTIONS_STATIC}).opt.item.item.dir_prefix[(l_prefix_length - 1)]).to_integer_32 /= 47)
								if l_add_slash then
									l_prefix_length := l_prefix_length + 1
								end
								l_total_length := l_prefix_length + ((l_value.item.e).distance ((l_value.item.b)))
								a_filename.item := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((l_total_length + 1).to_natural_32)))
								strcpy (a_filename.item, (create {P_OPTIONS_STATIC}).opt.item.item.dir_prefix).do_nothing
								if l_add_slash then
									a_filename.item[(l_prefix_length - 1)] := (('/').code).to_integer_8
								end
								memcpy (create {CE_VOID_POINTER}.make_cast ((a_filename.item + l_prefix_length)), create {CE_VOID_POINTER}.make_cast (l_value.item.b), ((l_value.item.e).distance ((l_value.item.b))).to_natural_32).do_nothing
								a_filename.item[l_total_length] := (('%/0/').code).to_integer_8
							else
								a_filename.item := (create {P_UTILS_STATIC}).strdupdelim (l_value.item.b, l_value.item.e)
							end
							Result := (1).to_boolean
							l_return := True
						end
				when 14 then -- if done | if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					if not l_return then
						l_break := False
						l_continue := False
						Result := (0).to_boolean
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	register_persistent (a_host: CE_POINTER [INTEGER_8]; a_port, a_fd: INTEGER_32; a_ssl: BOOLEAN)
		local
			l_return, l_break: BOOLEAN
		do
			if pconn_active.item then
				if (create {P_HTTP_STATIC}).pconn.item.item.socket = a_fd then
					l_return := True
				else
					invalidate_persistent
				end
			end
			if not l_return then
				pconn_active.item := (1).to_boolean;
				(create {P_HTTP_STATIC}).pconn.item.item.socket := a_fd;
				(create {P_HTTP_STATIC}).pconn.item.item.host := (create {P_XMALLOC_STATIC}).xstrdup (a_host);
				(create {P_HTTP_STATIC}).pconn.item.item.port := a_port;
				(create {P_HTTP_STATIC}).pconn.item.item.ssl := a_ssl;
				(create {P_HTTP_STATIC}).pconn.item.item.authorized := (0).to_boolean
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Registered socket %%d for persistent reuse.%N"), a_fd])
					end
					l_break := True
				end
				l_break := False
			end
		end

	persistent_available_p (a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32; a_ssl: BOOLEAN; a_host_lookup_failed: CE_POINTER [BOOLEAN]): BOOLEAN
		local
			l_found: BOOLEAN
			l_ip___0: CE_ARRAY [PD_IP_ADDRESS]
			l_al: CE_POINTER [PD_ADDRESS_LIST]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_IP_ADDRESS]} l_ip___0.make (<<1>>)

			if not pconn_active.item then
				Result := (0).to_boolean
				l_return := True
			end
			if not l_return and then (a_ssl.to_integer /= ((create {P_HTTP_STATIC}).pconn.item.item.ssl).to_integer) then
				Result := (0).to_boolean
				l_return := True
			end
			if not l_return and then (a_port /= (create {P_HTTP_STATIC}).pconn.item.item.port) then
				Result := (0).to_boolean
				l_return := True
			end
			if not l_return then
				if 0 /= (strcasecmp (a_host, (create {P_HTTP_STATIC}).pconn.item.item.host)) then
					if a_ssl then
						Result := (0).to_boolean
						l_return := True
					end
					if not l_return then
						if not (socket_ip_address ((create {P_HTTP_STATIC}).pconn.item.item.socket, l_ip___0, 1)) then
							invalidate_persistent
							Result := (0).to_boolean
							l_return := True
						end
					end
					if not l_return then
						l_al := (create {P_HOST_STATIC}).lookup_host (a_host, 0)
						if l_al.is_void then
							a_host_lookup_failed.item := (1).to_boolean
							Result := (0).to_boolean
							l_return := True
						end
					end
					if not l_return then
						l_found := address_list_contains (l_al, l_ip___0)
						l_al.item.address_list_release
						if not l_found then
							Result := (0).to_boolean
							l_return := True
						end
					end
				end
			end
			if not l_return then
				if not (test_socket_open ((create {P_HTTP_STATIC}).pconn.item.item.socket)) then
					invalidate_persistent
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return then
				Result := (1).to_boolean
			end
		end

	socket_ip_address (a_sock: INTEGER_32; a_ip___0: CE_POINTER [PD_IP_ADDRESS]; a_endpoint: INTEGER_32): BOOLEAN
		local
			l_storage: CE_ARRAY [SD_SOCKADDR_STORAGE]
			l_sockaddr: CE_POINTER [SD_SOCKADDR]
			l_addrlen: CE_ARRAY [NATURAL_32]
			l_ret: INTEGER_32
			l_sa6: CE_POINTER [SD_SOCKADDR_IN6]
			l_sa: CE_POINTER [SD_SOCKADDR_IN]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_SOCKADDR_STORAGE]} l_storage.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_addrlen.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sockaddr := create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_storage)
					l_addrlen.item := (create {SD_SOCKADDR_STORAGE}.make).structure_size.to_natural_32
					if a_endpoint = 0 then
						l_ret := getsockname (a_sock, l_sockaddr, l_addrlen)
					elseif a_endpoint = 1 then
						l_ret := getpeername (a_sock, l_sockaddr, l_addrlen)
					else
						abort
					end
					if l_ret < 0 then
						Result := (0).to_boolean
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						a_ip___0.item.family := (l_sockaddr.item.sa_family).to_integer_32
						inspect (l_sockaddr.item.sa_family).to_integer_32 -- switch 1 head
						when 10 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 2 then -- switch 1, case 10
						l_sa6 := create {CE_CLASS_POINTER [SD_SOCKADDR_IN6]}.make_cast (l_storage)
						a_ip___0.item.data.d6 := (l_sa6.item.sin6_addr).twin
						a_ip___0.item.ipv6_scope := (l_sa6.item.sin6_scope_id).to_integer_32
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("conaddr is: %%s%N"), (a_ip___0.item.print_address)])
							end
							l_break := True
						end
						l_break := False
						Result := (1).to_boolean
						l_return := True
				when 3 then -- switch 1, case 2
						if not l_return then
							l_sa := create {CE_CLASS_POINTER [SD_SOCKADDR_IN]}.make_cast (l_storage)
							a_ip___0.item.data.d4 := (l_sa.item.sin_addr).twin
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("conaddr is: %%s%N"), (a_ip___0.item.print_address)])
								end
								l_break := True
							end
							l_break := False
							Result := (1).to_boolean
							l_return := True
						end
				when 4 then -- switch 1, default:
						if not l_return then
							abort
						end
				when 5 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	invalidate_persistent
		local
			l_break: BOOLEAN
		do
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
					(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Disabling further reuse of socket %%d.%N"), (create {P_HTTP_STATIC}).pconn.item.item.socket])
				end
				l_break := True
			end
			l_break := False
			pconn_active.item := (0).to_boolean;
			(create {P_CONNECT_STATIC}).fd_close ((create {P_HTTP_STATIC}).pconn.item.item.socket)
			free (create {CE_VOID_POINTER}.make_cast ((create {P_HTTP_STATIC}).pconn.item.item.host))
			memset (create {CE_VOID_POINTER}.make_cast (((create {P_HTTP_STATIC}).pconn.item)), ('%/0/').code, (create {PD_PCONN}.make).structure_size.to_natural_32).do_nothing
		end

	test_socket_open (a_sock: INTEGER_32): BOOLEAN
		local
			l_sock: CE_ARRAY [INTEGER_32]
			l_check_set: CE_ARRAY [SD_FD_SET]
			l_to: CE_ARRAY [SD_TIMEVAL]
			l___d0: CE_ARRAY [INTEGER_32]
			l___d1: CE_ARRAY [INTEGER_32]
			l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_sock.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_FD_SET]} l_check_set.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_to.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d1.make (<<1>>)

			l_sock.item := a_sock
			from
			until
				(l_break)
			loop
				l_break := False
				asm3 (l___d0, l___d1, l_check_set)
				l_break := True
			end
			l_break := False
			asm4 (l_check_set, l_sock)
			l_to.item.tv_sec := (0).to_integer_32
			l_to.item.tv_usec := (1).to_integer_32
			if (select2 (l_sock.item + 1, l_check_set, create {CE_CLASS_POINTER [SD_FD_SET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_FD_SET]}.make_shared (default_pointer), l_to)) = 0 then
				Result := (1).to_boolean
			else
				Result := (0).to_boolean
			end
		end

	address_list_contains (a_al: CE_POINTER [PD_ADDRESS_LIST]; a_ip___0: CE_POINTER [PD_IP_ADDRESS]): BOOLEAN
		require
			not a_ip___0.is_void
		local
			l_i: INTEGER_32
			l_cur: CE_POINTER [PD_IP_ADDRESS]
			l_cur___0: CE_POINTER [PD_IP_ADDRESS]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_ip___0.item.family -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					l_i := 0
					from
					until
						not (not (l_return) and then (l_i < a_al.item.count))
					loop
						l_cur := (a_al.item.addresses + l_i)
						if l_cur.item.family = 2 then
							if l_cur.item.data.d4.s_addr = a_ip___0.item.data.d4.s_addr then
								Result := (1).to_boolean
								l_return := True
							end
						end
						if not l_return then
							l_i := l_i + 1
						end
					end
					if not l_return then
						Result := (0).to_boolean
						l_return := True
					end
				when 2 then -- switch 1, case 10
					if not l_return then
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < a_al.item.count))
						loop
							l_cur___0 := (a_al.item.addresses + l_i)
							if l_cur___0.item.family = 10 then
								if l_cur___0.item.ipv6_scope = a_ip___0.item.ipv6_scope then
									if create {CE_NATURAL_32_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN6_ADDR]}.make_shared (l_cur___0.c_pointer + (create {PD_IP_ADDRESS}.make).offset_of ("data") + (create {PD_DATA}.make).offset_of ("d6"))))[0] = create {CE_NATURAL_32_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN6_ADDR]}.make_shared (a_ip___0.c_pointer + (create {PD_IP_ADDRESS}.make).offset_of ("data") + (create {PD_DATA}.make).offset_of ("d6"))))[0] then
										if create {CE_NATURAL_32_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN6_ADDR]}.make_shared (l_cur___0.c_pointer + (create {PD_IP_ADDRESS}.make).offset_of ("data") + (create {PD_DATA}.make).offset_of ("d6"))))[1] = create {CE_NATURAL_32_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN6_ADDR]}.make_shared (a_ip___0.c_pointer + (create {PD_IP_ADDRESS}.make).offset_of ("data") + (create {PD_DATA}.make).offset_of ("d6"))))[1] then
											if create {CE_NATURAL_32_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN6_ADDR]}.make_shared (l_cur___0.c_pointer + (create {PD_IP_ADDRESS}.make).offset_of ("data") + (create {PD_DATA}.make).offset_of ("d6"))))[2] = create {CE_NATURAL_32_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN6_ADDR]}.make_shared (a_ip___0.c_pointer + (create {PD_IP_ADDRESS}.make).offset_of ("data") + (create {PD_DATA}.make).offset_of ("d6"))))[2] then
												if create {CE_NATURAL_32_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN6_ADDR]}.make_shared (l_cur___0.c_pointer + (create {PD_IP_ADDRESS}.make).offset_of ("data") + (create {PD_DATA}.make).offset_of ("d6"))))[3] = create {CE_NATURAL_32_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN6_ADDR]}.make_shared (a_ip___0.c_pointer + (create {PD_IP_ADDRESS}.make).offset_of ("data") + (create {PD_DATA}.make).offset_of ("d6"))))[3] then
													Result := (1).to_boolean
													l_return := True
												end
											end
										end
									end
								end
							end
							if not l_return then
								l_i := l_i + 1
							end
						end
					end
					if not l_return then
						Result := (0).to_boolean
						l_return := True
					end
				when 3 then -- switch 1, default:
					if not l_return then
						abort
					end
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	known_authentication_scheme_p (a_hdrbeg, a_hdrend: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_tmp___3: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((a_hdrend.c_pointer.to_integer_32).to_natural_32 > (a_hdrbeg.c_pointer.to_integer_32).to_natural_32) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_hdrend.distance (a_hdrbeg)).to_natural_32 >= (("Basic").count + 1).to_natural_32 - {NATURAL_32} 1 then
							if 0 = (strncasecmp (a_hdrbeg, ce_string ("Basic"), (("Basic").count + 1).to_natural_32 - {NATURAL_32} 1)) then
								if (a_hdrend.distance (a_hdrbeg)).to_natural_32 = (("Basic").count + 1).to_natural_32 - {NATURAL_32} 1 then
									l_tmp___3 := 1
								elseif ((create {P_C_CTYPE_STATIC}).c2_isspace ((a_hdrbeg[((("Basic").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32]).to_integer_32)) then
									l_tmp___3 := 1
								else
									l_pos := -1 + 3 -- goto _L___1
								end
							else
								l_pos := -1 + 3 -- goto _L___1
							end
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___1:
						if (a_hdrend.c_pointer.to_integer_32).to_natural_32 > (a_hdrbeg.c_pointer.to_integer_32).to_natural_32 then
							if (a_hdrend.distance (a_hdrbeg)).to_natural_32 >= (("Digest").count + 1).to_natural_32 - {NATURAL_32} 1 then
								if 0 = (strncasecmp (a_hdrbeg, ce_string ("Digest"), (("Digest").count + 1).to_natural_32 - {NATURAL_32} 1)) then
									if (a_hdrend.distance (a_hdrbeg)).to_natural_32 = (("Digest").count + 1).to_natural_32 - {NATURAL_32} 1 then
										l_tmp___3 := 1
									elseif ((create {P_C_CTYPE_STATIC}).c2_isspace ((a_hdrbeg[((("Digest").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32]).to_integer_32)) then
										l_tmp___3 := 1
									else
										l_tmp___3 := 0
									end
								else
									l_tmp___3 := 0
								end
							else
								l_tmp___3 := 0
							end
						else
							l_tmp___3 := 0
						end
				when 4 then
					Result := l_tmp___3.to_boolean
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	create_authorization_line (a_au, a_user, a_passwd, a_method, a_path: CE_POINTER [INTEGER_8]; a_finished: CE_POINTER [BOOLEAN]): CE_POINTER [INTEGER_8]
		require
			not a_au.is_void
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect ((create {P_C_CTYPE_STATIC}).c2_toupper ((a_au[0]).to_integer_32)) -- switch 1 head
					when 66 then l_pos := -1 + 1
					when 68 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 66
					a_finished.item := (1).to_boolean
					Result := (basic_authentication_encode (a_user, a_passwd))
					l_return := True
				when 2 then -- switch 1, case 68
					if not l_return then
						a_finished.item := (1).to_boolean
						Result := (digest_authentication_encode (a_au, a_user, a_passwd, a_method, a_path))
						l_return := True
					end
				when 3 then -- switch 1, default:
					if not l_return then
						abort
					end
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	basic_authentication_encode (a_user, a_passwd: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_user.is_void
			not a_passwd.is_void
		local
			l_t1: CE_POINTER [INTEGER_8]
			l_t2: CE_POINTER [INTEGER_8]
			l_len1: INTEGER_32
			l_tmp: NATURAL_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			l_tmp := strlen (a_user)
			l_len1 := ((l_tmp + {NATURAL_32} 1) + (strlen (a_passwd))).to_integer_32
			l_t1 := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new ((l_len1 + 1).to_natural_32)))
			sprintf ([l_t1, ce_string ("%%s:%%s"), a_user, a_passwd]).do_nothing
			l_t2 := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new ((4 * ((l_len1 + 2) // 3) + 1).to_natural_32)))
			base64_encode (create {CE_VOID_POINTER}.make_cast (l_t1), l_len1, l_t2).do_nothing
			Result := ((create {P_UTILS_STATIC}).concat_strings ([ce_string ("Basic "), l_t2, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)]))
		end

	digest_authentication_encode (a_au, a_user, a_passwd, a_method, a_path: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_au: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_res___0: CE_POINTER [INTEGER_8]
			l_name: CE_ARRAY [PD_PARAM_TOKEN]
			l_value: CE_ARRAY [PD_PARAM_TOKEN]
			l_i: NATURAL_32
			l_namelen: NATURAL_32
			l_ctx: CE_POINTER [PD_GEN_MD5_CONTEXT]
			l_hash: CE_ARRAY [NATURAL_8]
			l_a1buf: CE_ARRAY [INTEGER_8]
			l_a2buf: CE_ARRAY [INTEGER_8]
			l_response_digest: CE_ARRAY [INTEGER_8]
			l_tmp___10: NATURAL_32
			l_tmp___11: NATURAL_32
			l_tmp___12: NATURAL_32
			l_tmp___13: NATURAL_32
			l_tmp___14: NATURAL_32
			l_tmp___16: NATURAL_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_au.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_PARAM_TOKEN]} l_name.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_PARAM_TOKEN]} l_value.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_hash.make (<<16>>)
			create {CE_INTEGER_8_ARRAY} l_a1buf.make (<<33>>)
			create {CE_INTEGER_8_ARRAY} l_a2buf.make (<<33>>)
			create {CE_INTEGER_8_ARRAY} l_response_digest.make (<<33>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_au.item := a_au
					nonce.item.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					opaque.item.item := nonce.item.item
					realm.item.item := opaque.item.item
					l_au.item := l_au.item + (6)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if not (extract_param (l_au, l_name, l_value, ((',').code).to_integer_8)) then
							l_break := True
						end
						if not (l_return or l_break) then
							l_namelen := ((l_name.item.e).distance ((l_name.item.b))).to_natural_32
							l_i := (0).to_natural_32
							from
							until
								not (not (l_break) and then (l_i < ((create {PD_OPTIONS2}.make).structure_size.to_natural_32 * (3).to_natural_32) // (create {PD_OPTIONS2}.make).structure_size.to_natural_32))
							loop
								l_break := False
								if l_namelen = (strlen (options.item[l_i.to_integer_32].name)) then
									if 0 = (strncmp (l_name.item.b, options.item[l_i.to_integer_32].name, l_namelen)) then
										(options.item[l_i.to_integer_32].variable).item := (create {P_UTILS_STATIC}).strdupdelim (l_value.item.b, l_value.item.e)
										l_break := True
									end
								end
								if not (l_break) then
									l_i := l_i + 1
								end
							end
							l_break := False
						end
					end
					l_break := False
					if (not (realm.item.item).is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 3 then -- else:
						if (not (nonce.item.item).is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 6 then -- else:
						if (not a_user.is_void) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 9 then -- else:
						if (not a_passwd.is_void) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 12 then -- else:
						if (not a_path.is_void) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if (not a_method.is_void) then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L:
						if (not (realm.item.item).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (realm.item.item))
						end
						if (not (opaque.item.item).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (opaque.item.item))
						end
						if (not (nonce.item.item).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (nonce.item.item))
						end
						Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
						l_return := True
				when 17 then -- if done | if done | if done | if done | if done
					if not l_return then
						l_ctx := create {CE_CLASS_POINTER [PD_GEN_MD5_CONTEXT]}.make_cast ((l_aaf.new ((gen_md5_context_size).to_natural_32)))
						gen_md5_init (l_ctx)
						gen_md5_update (create {CE_NATURAL_8_POINTER}.make_cast (a_user), (strlen (a_user)).to_integer_32, l_ctx)
						gen_md5_update (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":")), 1, l_ctx)
						gen_md5_update (create {CE_NATURAL_8_POINTER}.make_cast (realm.item.item), (strlen (realm.item.item)).to_integer_32, l_ctx)
						gen_md5_update (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":")), 1, l_ctx)
						gen_md5_update (create {CE_NATURAL_8_POINTER}.make_cast (a_passwd), (strlen (a_passwd)).to_integer_32, l_ctx)
						gen_md5_finish (l_ctx, l_hash)
						dump_hash (l_a1buf, create {CE_NATURAL_8_POINTER}.make_cast (l_hash))
						gen_md5_init (l_ctx)
						gen_md5_update (create {CE_NATURAL_8_POINTER}.make_cast (a_method), (strlen (a_method)).to_integer_32, l_ctx)
						gen_md5_update (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":")), 1, l_ctx)
						gen_md5_update (create {CE_NATURAL_8_POINTER}.make_cast (a_path), (strlen (a_path)).to_integer_32, l_ctx)
						gen_md5_finish (l_ctx, l_hash)
						dump_hash (l_a2buf, create {CE_NATURAL_8_POINTER}.make_cast (l_hash))
						gen_md5_init (l_ctx)
						gen_md5_update (create {CE_NATURAL_8_POINTER}.make_cast (l_a1buf), 32, l_ctx)
						gen_md5_update (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":")), 1, l_ctx)
						gen_md5_update (create {CE_NATURAL_8_POINTER}.make_cast (nonce.item.item), (strlen (nonce.item.item)).to_integer_32, l_ctx)
						gen_md5_update (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":")), 1, l_ctx)
						gen_md5_update (create {CE_NATURAL_8_POINTER}.make_cast (l_a2buf), 32, l_ctx)
						gen_md5_finish (l_ctx, l_hash)
						dump_hash (l_response_digest, create {CE_NATURAL_8_POINTER}.make_cast (l_hash))
						l_tmp___10 := strlen (a_user)
						l_tmp___11 := strlen (a_user)
						l_tmp___12 := strlen (realm.item.item)
						l_tmp___13 := strlen (nonce.item.item)
						l_tmp___14 := strlen (a_path)
						if (not (opaque.item.item).is_void) then
							l_tmp___16 := (strlen (opaque.item.item))
						else
							l_tmp___16 := (0).to_natural_32
						end
						l_res___0 := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc (((((((l_tmp___10 + l_tmp___11) + l_tmp___12) + l_tmp___13) + l_tmp___14) + {NATURAL_32} 32) + l_tmp___16) + {NATURAL_32} 128)))
						sprintf ([l_res___0, ce_string ("Digest username=%"%%s%", realm=%"%%s%", nonce=%"%%s%", uri=%"%%s%", response=%"%%s%""), a_user, realm.item.item, nonce.item.item, a_path, l_response_digest]).do_nothing
						if (not (opaque.item.item).is_void) then
							l_p___0 := l_res___0 + (strlen (l_res___0)).to_integer_32
							strcat (l_p___0, ce_string (", opaque=%"")).do_nothing
							strcat (l_p___0, opaque.item.item).do_nothing
							strcat (l_p___0, ce_string ("%"")).do_nothing
						end
						Result := l_res___0
					end
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	extract_param (a_source: CE_POINTER [CE_POINTER [INTEGER_8]]; a_name, a_value: CE_POINTER [PD_PARAM_TOKEN]; a_separator: INTEGER_8): BOOLEAN
		require
			not a_source.is_void
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_source.item
					from
					until
						(l_break)
					loop
						l_break := False
						if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
							l_break := True
						end
						if not (l_break) then
							l_p___0 := l_p___0 + 1
						end
					end
					l_break := False
					if not (l_p___0[0]).to_boolean then
						a_source.item := l_p___0
						Result := (0).to_boolean
						l_return := True
					end
					if not l_return then
						a_name.item.b := l_p___0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0[0]).to_boolean then
								if ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
									l_break := True
								elseif (l_p___0[0]).to_integer_32 /= 61 then
									if (l_p___0[0]).to_integer_32 = a_separator.to_integer_32 then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						a_name.item.e := l_p___0
						if (a_name.item.b).is_equal (a_name.item.e) then
							Result := (0).to_boolean
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
								l_break := True
							end
							if not (l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						if (l_p___0[0]).to_integer_32 /= a_separator.to_integer_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (l_p___0[0]).to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						memset (create {CE_VOID_POINTER}.make_cast (a_value), ('%/0/').code, (create {PD_PARAM_TOKEN}.make).structure_size.to_natural_32).do_nothing
						if (l_p___0[0]).to_integer_32 = a_separator.to_integer_32 then
							l_p___0 := l_p___0 + 1
						end
						a_source.item := l_p___0
						Result := (1).to_boolean
						l_return := True
				when 6 then -- if done | if done
					if not l_return and then ((l_p___0[0]).to_integer_32 /= 61) then
						Result := (0).to_boolean
						l_return := True
					end
					if not l_return then
						l_p___0 := l_p___0 + 1
						from
						until
							(l_break)
						loop
							l_break := False
							if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
								l_break := True
							end
							if not (l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						if (l_p___0[0]).to_integer_32 = 34 then
							l_p___0 := l_p___0 + 1
							a_value.item.b := l_p___0
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_p___0[0]).to_boolean then
									if (l_p___0[0]).to_integer_32 = 34 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_p___0 := l_p___0 + 1
								end
							end
							l_break := False
							if not (l_p___0[0]).to_boolean then
								Result := (0).to_boolean
								l_return := True
							end
							if not l_return then
								l_tmp___3 := l_p___0
								l_p___0 := l_p___0 + 1
								a_value.item.e := l_tmp___3
								from
								until
									(l_break)
								loop
									l_break := False
									if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
										l_break := True
									end
									if not (l_break) then
										l_p___0 := l_p___0 + 1
									end
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_p___0[0]).to_boolean then
										if (l_p___0[0]).to_integer_32 = a_separator.to_integer_32 then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_p___0 := l_p___0 + 1
									end
								end
								l_break := False
								if (l_p___0[0]).to_integer_32 = a_separator.to_integer_32 then
									l_p___0 := l_p___0 + 1
								elseif (l_p___0[0]).to_boolean then
									Result := (0).to_boolean
									l_return := True
								end
							end
						else
							a_value.item.b := l_p___0
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_p___0[0]).to_boolean then
									if (l_p___0[0]).to_integer_32 = a_separator.to_integer_32 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_p___0 := l_p___0 + 1
								end
							end
							l_break := False
							a_value.item.e := l_p___0
							from
							until
								(l_break)
							loop
								l_break := False
								if not (a_value.item.e).is_equal (a_value.item.b) then
									if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((a_value.item.e[-1]).to_integer_32)) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									a_value.item.e := (a_value.item.e) - 1
								end
							end
							l_break := False
							if (l_p___0[0]).to_integer_32 = a_separator.to_integer_32 then
								l_p___0 := l_p___0 + 1
							end
						end
					end
					if not l_return then
						a_source.item := l_p___0
						Result := (1).to_boolean
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dump_hash (a_buf___6: CE_POINTER [INTEGER_8]; a_hash: CE_POINTER [NATURAL_8])
		require
			not a_buf___6.is_void
		local
			l_buf___6: CE_POINTER [INTEGER_8]
			l_hash: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			l_buf___6 := a_buf___6
			l_hash := a_hash
			l_i := 0
			from
			until
				not (l_i < 16)
			loop
				l_tmp := l_buf___6
				l_buf___6 := l_buf___6 + 1
				l_tmp[0] := (((ce_string ("0123456789abcdef") + (((l_hash.item).to_integer_32).bit_shift_right (4))).item).to_integer_32).to_integer_8
				l_tmp___0 := l_buf___6
				l_buf___6 := l_buf___6 + 1
				l_tmp___0[0] := (((ce_string ("0123456789abcdef") + (((l_hash.item).to_integer_32).bit_and (15))).item).to_integer_32).to_integer_8
				l_i := l_i + 1
				l_hash := l_hash + 1
			end
			l_buf___6[0] := (('%/0/').code).to_integer_8
		end

	ensure_extension (a_hs: CE_POINTER [PD_HTTP_STAT]; a_ext: CE_POINTER [INTEGER_8]; a_dt: CE_POINTER [INTEGER_32])
		require
			not a_hs.is_void
			not a_ext.is_void
		local
			l_last_period_in_local_filename: CE_POINTER [INTEGER_8]
			l_shortext: CE_ARRAY [INTEGER_8]
			l_len: INTEGER_32
			l_local_filename_len: INTEGER_32
			l_ext_num: INTEGER_32
			l_tmp___3: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_shortext.make (<<8>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_last_period_in_local_filename := (strrchr (a_hs.item.local_file, ('.').code))
					l_len := (strlen (a_ext)).to_integer_32
					if l_len = 5 then
						strncpy (l_shortext, a_ext, (l_len - 1).to_natural_32).do_nothing
						l_shortext[l_len - 2] := (('%/0/').code).to_integer_8
					end
					if not (l_last_period_in_local_filename.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 3 then -- else:
						if (0 = (strcasecmp (l_last_period_in_local_filename, l_shortext))) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (0 = (strcasecmp (l_last_period_in_local_filename, a_ext))) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_local_filename_len := (strlen (a_hs.item.local_file)).to_integer_32
						a_hs.item.local_file := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (a_hs.item.local_file), ((l_local_filename_len + 24) + l_len).to_natural_32)))
						strcpy ((a_hs.item.local_file + l_local_filename_len), a_ext).do_nothing
						if not (create {P_OPTIONS_STATIC}).opt.item.item.noclobber then
							if not (create {P_OPTIONS_STATIC}).opt.item.item.always_rest then
								if not (create {P_OPTIONS_STATIC}).opt.item.item.timestamping then
									if not (create {P_OPTIONS_STATIC}).opt.item.item.dirstruct then
										if ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void then
											if ((create {P_UTILS_STATIC}).file_exists_p (a_hs.item.local_file)) then
												l_ext_num := 1
												from
												until
													(l_break)
												loop
													l_break := False
													l_tmp___3 := l_ext_num
													l_ext_num := l_ext_num + 1
													sprintf ([(a_hs.item.local_file + l_local_filename_len), ce_string (".%%d%%s"), l_tmp___3, a_ext]).do_nothing
													if not ((create {P_UTILS_STATIC}).file_exists_p (a_hs.item.local_file)) then
														l_break := True
													end
												end
												l_break := False
											end
										end
									end
								end
							end
						end
						a_dt.item := (a_dt.item).bit_or ((32))
				when 6 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	parse_netrc (a_path: CE_POINTER [INTEGER_8]): CE_POINTER [PD_ACC_T]
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_line: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_tok: CE_POINTER [INTEGER_8]
			l_premature_token: CE_POINTER [INTEGER_8]
			l_current: CE_ARRAY [CE_POINTER [PD_ACC_T]]
			l_retval: CE_ARRAY [CE_POINTER [PD_ACC_T]]
			l_ln: INTEGER_32
			l_qmark: INTEGER_32
			l_last_token: NATURAL_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_saved_reference: CE_POINTER [PD_ACC_T]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_ACC_T]} l_current.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_ACC_T]} l_retval.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_last_token := {PC_LAST_TOKEN}.tok_nothing
					l_retval.item := create {CE_CLASS_POINTER [PD_ACC_T]}.make_shared (default_pointer)
					l_current.item := l_retval.item
					l_fp := fopen (a_path, ce_string ("r"))
					if l_fp.is_void then
						l_tmp___0 := strerror ((errno_location).item)
						fprintf ([(create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: Cannot read %%s (%%s).%N"))), (create {P_WGET_STATIC}).exec_name.item, a_path, l_tmp___0]).do_nothing
						Result := (l_retval.item)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						l_ln := 0
						l_premature_token := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 18 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_line := (create {P_UTILS_STATIC}).read_whole_line (l_fp)
						if l_line.is_void then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 17 -- skip if block
						end
				when 4 then -- if:
						l_ln := l_ln + 1
						l_p___0 := l_line
						l_qmark := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0[0]).to_boolean then
								if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						if l_last_token = {NATURAL_32} 3 then
							if not (l_p___0[0]).to_boolean then
								l_last_token := {PC_LAST_TOKEN}.tok_nothing
							end
						end
				when 5 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 16 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						if (l_p___0[0]).to_boolean then
							if l_last_token = {NATURAL_32} 3 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_return or l_break) then
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_p___0[0]).to_boolean then
									if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_p___0 := l_p___0 + 1
								end
							end
							l_break := False
							if (l_p___0[0]).to_integer_32 = 35 then
								l_break := True
							elseif not (l_p___0[0]).to_boolean then
								l_break := True
							end
						end
						if (l_return or l_break) then
							l_pos := -1 + 15 -- skip if block
						end
				when 7 then -- if:
						if (l_p___0[0]).to_integer_32 = 34 then
							l_qmark := 1
							shift_left (l_p___0)
						end
						l_tok := l_p___0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0[0]).to_boolean then
								if l_qmark.to_boolean then
									l_tmp___6 := ((l_p___0[0]).to_integer_32 /= 34).to_integer
								else
									if ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
										l_tmp___5 := 0
									else
										l_tmp___5 := 1
									end
									l_tmp___6 := l_tmp___5
								end
								if not l_tmp___6.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								if (l_p___0[0]).to_integer_32 = 92 then
									shift_left (l_p___0)
								end
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						if l_qmark.to_boolean then
							shift_left (l_p___0)
							l_qmark := 0
						end
						if (l_p___0[0]).to_boolean then
							l_tmp___7 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___7[0] := (('%/0/').code).to_integer_8
						end
						inspect l_last_token.to_integer_32 -- switch 1 head
						when 2 then l_pos := -1 + 8
						when 4 then l_pos := -1 + 9
						when 5 then l_pos := -1 + 10
						when 3 then l_pos := -1 + 11
						when 1 then l_pos := -1 + 12
						when 0 then l_pos := -1 + 13
						else l_pos := -1 + 14
						end
				when 8 then -- switch 1, case 2
						if (not (l_current.item).is_void) then
							l_current.item.item.acc := (create {P_XMALLOC_STATIC}).xstrdup (l_tok)
						else
							l_premature_token := ce_string ("login")
						end
						l_pos := -1 + 14 -- switch 1; break
				when 9 then -- switch 1, case 4
						maybe_add_to_list (l_current, l_retval)
						l_current.item.item.host := (create {P_XMALLOC_STATIC}).xstrdup (l_tok)
						l_pos := -1 + 14 -- switch 1; break
				when 10 then -- switch 1, case 5
						if (not (l_current.item).is_void) then
							l_current.item.item.passwd := (create {P_XMALLOC_STATIC}).xstrdup (l_tok)
						else
							l_premature_token := ce_string ("password")
						end
						l_pos := -1 + 14 -- switch 1; break
				when 11 then -- switch 1, case 3
						if (l_current.item).is_void then
							l_premature_token := ce_string ("macdef")
						end
						l_pos := -1 + 14 -- switch 1; break
				when 12 then -- switch 1, case 1
						if (l_current.item).is_void then
							l_premature_token := ce_string ("account")
						end
						l_pos := -1 + 14 -- switch 1; break
				when 13 then -- switch 1, case 0
						l_pos := -1 + 14 -- switch 1; break
				when 14 then -- switch 1, done:
						if (not l_premature_token.is_void) then
							l_tmp___8 := (create {P_QUOTE_STATIC}).quote (l_premature_token)
							fprintf ([(create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: %%s:%%d: warning: %%s token appears before any machine name%N"))), (create {P_WGET_STATIC}).exec_name.item, a_path, l_ln, l_tmp___8]).do_nothing
							l_premature_token := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						end
						if l_last_token /= {NATURAL_32} 0 then
							l_last_token := {PC_LAST_TOKEN}.tok_nothing
						elseif (strcmp (l_tok, ce_string ("account"))).to_boolean then
							if (strcmp (l_tok, ce_string ("default"))).to_boolean then
								if (strcmp (l_tok, ce_string ("login"))).to_boolean then
									if (strcmp (l_tok, ce_string ("macdef"))).to_boolean then
										if (strcmp (l_tok, ce_string ("machine"))).to_boolean then
											if (strcmp (l_tok, ce_string ("password"))).to_boolean then
												fprintf ([(create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: %%s:%%d: unknown token %"%%s%"%N"))), (create {P_WGET_STATIC}).exec_name.item, a_path, l_ln, l_tok]).do_nothing
											else
												l_last_token := {PC_LAST_TOKEN}.tok_password
											end
										else
											l_last_token := {PC_LAST_TOKEN}.tok_machine
										end
									else
										l_last_token := {PC_LAST_TOKEN}.tok_macdef
									end
								else
									l_last_token := {PC_LAST_TOKEN}.tok_login
								end
							else
								maybe_add_to_list (l_current, l_retval)
							end
						else
							l_last_token := {PC_LAST_TOKEN}.tok_account
						end
				when 15 then -- if done
						l_pos := -1 + 5 -- back to loop condition
				when 16 then -- loop done
						l_break := False
						free (create {CE_VOID_POINTER}.make_cast (l_line))
				when 17 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 18 then -- loop done
						l_break := False
						fclose (l_fp).do_nothing
						maybe_add_to_list (l_current, l_retval)
						free (create {CE_VOID_POINTER}.make_cast (l_current.item))
						l_current.item := l_retval.item
						l_retval.item := create {CE_CLASS_POINTER [PD_ACC_T]}.make_shared (default_pointer)
						from
						until
							(l_current.item).is_void
						loop
							l_saved_reference := l_current.item.item.next
							l_current.item.item.next := l_retval.item
							l_retval.item := l_current.item
							l_current.item := l_saved_reference
						end
						Result := (l_retval.item)
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	maybe_add_to_list (a_newentry, a_list: CE_POINTER [CE_POINTER [PD_ACC_T]])
		require
			not a_newentry.is_void
			not a_list.is_void
		local
			l_a: CE_POINTER [PD_ACC_T]
			l_l: CE_POINTER [PD_ACC_T]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a := a_newentry.item
					l_l := a_list.item
					if l_a.is_void then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (l_a.item.acc).is_void then
							if (not (l_a.item.host).is_void) then
								free (create {CE_VOID_POINTER}.make_cast (l_a.item.host))
							end
							if (not (l_a.item.acc).is_void) then
								free (create {CE_VOID_POINTER}.make_cast (l_a.item.acc))
							end
							if (not (l_a.item.passwd).is_void) then
								free (create {CE_VOID_POINTER}.make_cast (l_a.item.passwd))
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (not l_a.is_void) then
							l_a.item.next := l_l
							l_l := l_a
						end
						l_a := create {CE_CLASS_POINTER [PD_ACC_T]}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((create {PD_ACC_T}.make).structure_size.to_natural_32)))
				when 4 then
					memset (create {CE_VOID_POINTER}.make_cast (l_a), 0, (create {PD_ACC_T}.make).structure_size.to_natural_32).do_nothing
					a_newentry.item := l_a
					a_list.item := l_l
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	shift_left (a_string: CE_POINTER [INTEGER_8])
		require
			not a_string.is_void
		local
			l_p___0: CE_POINTER [INTEGER_8]
		do
			l_p___0 := a_string
			from
			until
				not ((l_p___0[0]).to_boolean)
			loop
				l_p___0[0] := l_p___0[1]
				l_p___0 := l_p___0 + 1
			end
		end

	progress_create (a_initial, a_total: INTEGER_64): CE_POINTER [ANY]
		do
			if ((create {P_PROGRESS_STATIC}).output_redirected.item).to_boolean then
				if not ((create {P_PROGRESS_STATIC}).current_impl_locked.item).to_boolean then
					(create {P_PROGRESS_STATIC}).set_progress_implementation (ce_string ("dot"))
				end
				(create {P_PROGRESS_STATIC}).output_redirected.item := 0
			end
			Result := (create {CE_VOID_POINTER}.make_cast (((create {P_PROGRESS_STATIC}).current_impl.item.item.create2).pointer_item ([a_initial, a_total])))
		end

	progress_interactive_p (a_progress: CE_POINTER [ANY]): BOOLEAN
		do
			Result := ((create {P_PROGRESS_STATIC}).current_impl.item.item.interactive)
		end

	progress_update (a_progress: CE_POINTER [ANY]; a_howmuch: INTEGER_64; a_dltime: REAL_64)
		do
			((create {P_PROGRESS_STATIC}).current_impl.item.item.update).call ([a_progress, a_howmuch, a_dltime])
		end

	progress_finish (a_progress: CE_POINTER [ANY]; a_dltime: REAL_64)
		do
			((create {P_PROGRESS_STATIC}).current_impl.item.item.finish).call ([a_progress, a_dltime])
		end

	url_queue_new: CE_POINTER [PD_URL_QUEUE]
		local
			l_queue: CE_POINTER [PD_URL_QUEUE]
		do
			l_queue := create {CE_CLASS_POINTER [PD_URL_QUEUE]}.make_cast (((create {P_XMALLOC_STATIC}).xcalloc ((1).to_natural_32, (create {PD_URL_QUEUE}.make).structure_size.to_natural_32)))
			Result := l_queue
		end

	url_queue_delete (a_queue: CE_POINTER [PD_URL_QUEUE])
		do
			free (create {CE_VOID_POINTER}.make_cast (a_queue))
		end

	url_enqueue (a_queue: CE_POINTER [PD_URL_QUEUE]; a_i: CE_POINTER [PD_IRI]; a_url, a_referer: CE_POINTER [INTEGER_8]; a_depth___0: INTEGER_32; a_html_allowed, a_css_allowed: BOOLEAN)
		require
			not a_queue.is_void
		local
			l_qel: CE_POINTER [PD_QUEUE_ELEMENT]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
		do
			l_qel := create {CE_CLASS_POINTER [PD_QUEUE_ELEMENT]}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((create {PD_QUEUE_ELEMENT}.make).structure_size.to_natural_32)))
			l_qel.item.iri := a_i
			l_qel.item.url := a_url
			l_qel.item.referer := a_referer
			l_qel.item.depth := a_depth___0
			l_qel.item.html_allowed := a_html_allowed
			l_qel.item.css_allowed := a_css_allowed
			l_qel.item.next := create {CE_CLASS_POINTER [PD_QUEUE_ELEMENT]}.make_shared (default_pointer)
			a_queue.item.count := (a_queue.item.count) + 1
			if a_queue.item.count > a_queue.item.maxcount then
				a_queue.item.maxcount := a_queue.item.count
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
					(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Enqueuing %%s at depth %%d%N"), ((create {P_QUOTEARG_STATIC}).quotearg_n_style (0, {PC_QUOTING_STYLE}.escape_quoting_style, a_url)), a_depth___0])
				end
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
					(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Queue count %%d, maxcount %%d.%N"), a_queue.item.count, a_queue.item.maxcount])
				end
				l_break := True
			end
			l_break := False
			if (not a_i.is_void) then
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
						if (not (a_i.item.uri_encoding).is_void) then
							l_tmp___4 := ((create {P_QUOTE_STATIC}).quote_n (1, a_i.item.uri_encoding))
						else
							l_tmp___4 := ce_string ("None")
						end
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("[IRI Enqueuing %%s with %%s%N"), ((create {P_QUOTE_STATIC}).quote_n (0, a_url)), l_tmp___4])
					end
					l_break := True
				end
				l_break := False
			end
			if (not (a_queue.item.tail).is_void) then
				(a_queue.item.tail).item.next := l_qel
			end
			a_queue.item.tail := l_qel
			if (a_queue.item.head).is_void then
				a_queue.item.head := a_queue.item.tail
			end
		end

	url_dequeue (a_queue: CE_POINTER [PD_URL_QUEUE]; a_i: CE_POINTER [CE_POINTER [PD_IRI]]; a_url, a_referer: CE_POINTER [CE_POINTER [INTEGER_8]]; a_depth___0: CE_POINTER [INTEGER_32]; a_html_allowed, a_css_allowed: CE_POINTER [BOOLEAN]): BOOLEAN
		require
			not a_queue.is_void
		local
			l_qel: CE_POINTER [PD_QUEUE_ELEMENT]
			l_return, l_break: BOOLEAN
		do
			l_qel := a_queue.item.head
			if l_qel.is_void then
				Result := (0).to_boolean
				l_return := True
			end
			if not l_return then
				a_queue.item.head := (a_queue.item.head).item.next
				if (a_queue.item.head).is_void then
					a_queue.item.tail := create {CE_CLASS_POINTER [PD_QUEUE_ELEMENT]}.make_shared (default_pointer)
				end
				a_i.item := l_qel.item.iri
				a_url.item := l_qel.item.url
				a_referer.item := l_qel.item.referer
				a_depth___0.item := l_qel.item.depth
				a_html_allowed.item := l_qel.item.html_allowed
				a_css_allowed.item := l_qel.item.css_allowed
				a_queue.item.count := (a_queue.item.count) - 1
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Dequeuing %%s at depth %%d%N"), ((create {P_QUOTEARG_STATIC}).quotearg_n_style (0, {PC_QUOTING_STYLE}.escape_quoting_style, l_qel.item.url)), l_qel.item.depth])
					end
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Queue count %%d, maxcount %%d.%N"), a_queue.item.count, a_queue.item.maxcount])
					end
					l_break := True
				end
				l_break := False
				free (create {CE_VOID_POINTER}.make_cast (l_qel))
				Result := (1).to_boolean
			end
		end

	descend_redirect_p (a_redirected: CE_POINTER [INTEGER_8]; a_orig_parsed: CE_POINTER [PD_URL]; a_depth___0: INTEGER_32; a_start_url_parsed: CE_POINTER [PD_URL]; a_blacklist: CE_POINTER [PD_HASH_TABLE]; a_iri: CE_POINTER [PD_IRI]): BOOLEAN
		require
			not a_blacklist.is_void
		local
			l_new_parsed: CE_POINTER [PD_URL]
			l_upos: CE_POINTER [PD_URLPOS]
			l_success: BOOLEAN
			l_break: BOOLEAN
		do
			if a_orig_parsed.is_void then
				assert_fail (ce_string ("orig_parsed != ((void *)0)"), ce_string ("recur.c"), {NATURAL_32} 694, ce_string ("descend_redirect_p"))
			end
			l_new_parsed := (create {P_URL_STATIC}).url_parse (a_redirected, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_IRI]}.make_shared (default_pointer), (0).to_boolean)
			if l_new_parsed.is_void then
				assert_fail (ce_string ("new_parsed != ((void *)0)"), ce_string ("recur.c"), {NATURAL_32} 697, ce_string ("descend_redirect_p"))
			end
			l_upos := create {CE_CLASS_POINTER [PD_URLPOS]}.make_cast (((create {P_XMALLOC_STATIC}).xcalloc ((1).to_natural_32, (create {PD_URLPOS}.make).structure_size.to_natural_32)))
			l_upos.item.url := l_new_parsed
			l_success := l_upos.item.download_child_p (a_orig_parsed, a_depth___0, a_start_url_parsed, a_blacklist, a_iri)
			l_new_parsed.item.url_free
			free (create {CE_VOID_POINTER}.make_cast (l_upos))
			if not l_success then
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Redirection %"%%s%" failed the test.%N"), a_redirected])
					end
					l_break := True
				end
				l_break := False
			end
			Result := l_success
		end

	limit_bandwidth_reset
		do
			memset (create {CE_VOID_POINTER}.make_cast (limit_data.item), ('%/0/').code, (create {PD_LIMIT_DATA}.make).structure_size.to_natural_32).do_nothing
		end

	limit_bandwidth (a_bytes: INTEGER_64; a_timer: CE_POINTER [PD_PTIMER])
		require
			not a_timer.is_void
		local
			l_delta_t: REAL_64
			l_expected: REAL_64
			l_slp: REAL_64
			l_t0: REAL_64
			l_t1: REAL_64
			l_return, l_break: BOOLEAN
		do
			l_delta_t := (ptimer_read (a_timer)) - limit_data.item.item.chunk_start
			limit_data.item.item.chunk_bytes := limit_data.item.item.chunk_bytes + a_bytes
			l_expected := (limit_data.item.item.chunk_bytes).to_double / ((create {P_OPTIONS_STATIC}).opt.item.item.limit_rate).to_double
			if l_expected > l_delta_t then
				l_slp := (l_expected - l_delta_t) + limit_data.item.item.sleep_adjust
				if l_slp < 0.2 then
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
							(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("deferring a %%.2f ms sleep (%%s/%%.2f).%N"), l_slp * (1_000).to_double, ((create {P_UTILS_STATIC}).number_to_static_string (limit_data.item.item.chunk_bytes)), l_delta_t])
						end
						l_break := True
					end
					l_break := False
					l_return := True
				end
				if not l_return then
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
							(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%Nsleeping %%.2f ms for %%s bytes, adjust %%.2f ms%N"), l_slp * (1_000).to_double, ((create {P_UTILS_STATIC}).number_to_static_string (limit_data.item.item.chunk_bytes)), limit_data.item.item.sleep_adjust])
						end
						l_break := True
					end
					l_break := False
					l_t0 := ptimer_read (a_timer);
					(create {P_UTILS_STATIC}).xsleep (l_slp)
					l_t1 := a_timer.item.ptimer_measure
					limit_data.item.item.sleep_adjust := l_slp - (l_t1 - l_t0)
					if limit_data.item.item.sleep_adjust > 0.5 then
						limit_data.item.item.sleep_adjust := 0.5
					elseif limit_data.item.item.sleep_adjust < -0.5 then
						limit_data.item.item.sleep_adjust := -0.5
					end
				end
			end
			if not l_return then
				limit_data.item.item.chunk_bytes := (0).to_integer_64
				limit_data.item.item.chunk_start := ptimer_read (a_timer)
			end
		end

	ptimer_read (a_pt: CE_POINTER [PD_PTIMER]): REAL_64
		require
			not a_pt.is_void
		do
			Result := (a_pt.item.elapsed_last)
		end

	write_data (a_out: CE_POINTER [SD_IO_FILE]; a_buf___6: CE_POINTER [INTEGER_8]; a_bufsize___0: INTEGER_32; a_skip, a_written: CE_POINTER [INTEGER_64]): INTEGER_32
		local
			l_buf___6: CE_POINTER [INTEGER_8]
			l_bufsize___0: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_buf___6 := a_buf___6
			l_bufsize___0 := a_bufsize___0
			if a_out.is_void then
				Result := 1
				l_return := True
			end
			if not l_return and then (a_skip.item > l_bufsize___0.to_integer_64) then
				a_skip.item := a_skip.item - l_bufsize___0.to_integer_64
				Result := 1
				l_return := True
			end
			if not l_return and then ((a_skip.item).to_boolean) then
				l_buf___6 := l_buf___6 + (a_skip.item).to_integer_32
				l_bufsize___0 := (l_bufsize___0.to_integer_64 - a_skip.item).to_integer_32
				a_skip.item := (0).to_integer_64
				if l_bufsize___0 = 0 then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				fwrite (create {CE_VOID_POINTER}.make_cast (l_buf___6), (1).to_natural_32, l_bufsize___0.to_natural_32, a_out).do_nothing
				a_written.item := a_written.item + l_bufsize___0.to_integer_64
				fflush (a_out).do_nothing
				if (ferror (a_out)).to_boolean then
					l_tmp___0 := 0
				else
					l_tmp___0 := 1
				end
				Result := l_tmp___0
			end
		end

	fd_read_line (a_fd: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			Result := (fd_read_hunk (a_fd, (create {P_RETR_STATIC}).line_terminator_address, 128, 4_096))
		end

	fd_read_hunk (a_fd: INTEGER_32; a_terminator: CE_ROUTINE; a_sizehint, a_maxsize: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_bufsize___0: INTEGER_32
			l_hunk: CE_POINTER [INTEGER_8]
			l_tail: INTEGER_32
			l_end: CE_POINTER [INTEGER_8]
			l_pklen: INTEGER_32
			l_rdlen: INTEGER_32
			l_remain: INTEGER_32
			l_return: BOOLEAN
		do
			l_bufsize___0 := a_sizehint
			l_hunk := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc (l_bufsize___0.to_natural_32)))
			l_tail := 0
			if a_maxsize.to_boolean then
				if not (a_maxsize >= l_bufsize___0) then
					assert_fail (ce_string ("!maxsize || maxsize >= bufsize"), ce_string ("retr.c"), {NATURAL_32} 410, ce_string ("fd_read_hunk"))
				end
			end
			from
			until
				(l_return)
			loop
				l_pklen := fd_peek (a_fd, l_hunk + l_tail, ((l_bufsize___0 - 1) - l_tail.to_integer_32).to_integer_32, (-1).to_double)
				if l_pklen < 0 then
					free (create {CE_VOID_POINTER}.make_cast (l_hunk))
					Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
				if not l_return then
					l_end := create {CE_INTEGER_8_POINTER}.make_cast (a_terminator.pointer_item ([l_hunk, (l_hunk + l_tail), l_pklen]))
					if (not l_end.is_void) then
						l_remain := l_end.distance ((l_hunk + l_tail))
						if not (l_remain >= 0) then
							assert_fail (ce_string ("remain >= 0"), ce_string ("retr.c"), {NATURAL_32} 431, ce_string ("fd_read_hunk"))
						end
						if l_remain = 0 then
							l_hunk[l_tail] := (('%/0/').code).to_integer_8
							Result := l_hunk
							l_return := True
						end
						if not l_return and then (l_bufsize___0 - 1 < (l_tail + l_remain).to_integer_32) then
							l_bufsize___0 := ((l_tail + l_remain) + 1).to_integer_32
							l_hunk := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_hunk), l_bufsize___0.to_natural_32)))
						end
					else
						l_remain := l_pklen
					end
				end
				if not l_return then
					l_rdlen := fd_read (a_fd, l_hunk + l_tail, l_remain, (0).to_double)
					if l_rdlen < 0 then
						if (not l_hunk.is_void) then
							free (create {CE_VOID_POINTER}.make_cast (l_hunk))
						end
						Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
				end
				if not l_return then
					l_tail := l_tail + l_rdlen
					l_hunk[l_tail] := (('%/0/').code).to_integer_8
					if l_rdlen = 0 then
						if l_tail = 0 then
							free (create {CE_VOID_POINTER}.make_cast (l_hunk));
							(errno_location).item := 0
							Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
							l_return := True
						else
							Result := l_hunk
							l_return := True
						end
					end
				end
				if not l_return and then (not l_end.is_void) then
					if l_rdlen = l_remain then
						Result := l_hunk
						l_return := True
					end
				end
				if not l_return and then (l_tail.to_integer_32 = l_bufsize___0 - 1) then
					if a_maxsize.to_boolean then
						if l_bufsize___0 >= a_maxsize then
							free (create {CE_VOID_POINTER}.make_cast (l_hunk));
							(errno_location).item := 12
							Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
					if not l_return then
						l_bufsize___0 := (l_bufsize___0).bit_shift_left ((1))
						if a_maxsize.to_boolean then
							if l_bufsize___0 > a_maxsize then
								l_bufsize___0 := a_maxsize
							end
						end
						l_hunk := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_hunk), l_bufsize___0.to_natural_32)))
					end
				end
			end
		end

	fd_read (a_fd: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_bufsize___0: INTEGER_32; a_timeout: REAL_64): INTEGER_32
		local
			l_info: CE_POINTER [PD_TRANSPORT_INFO]
			l_tmp: CE_POINTER [ANY]
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_break)
			loop
				l_break := False
				if ((create {P_CONNECT_STATIC}).transport_map.item).is_void then
					l_info := create {CE_CLASS_POINTER [PD_TRANSPORT_INFO]}.make_shared (default_pointer)
				elseif last_fd.item = a_fd then
					if last_tick.item = (create {P_CONNECT_STATIC}).transport_map_modified_tick.item then
						l_info := last_info.item
					else
						l_tmp := ((create {P_CONNECT_STATIC}).transport_map.item).item.hash_table_get (create {CE_VOID_POINTER}.make_shared (default_pointer + a_fd))
						l_info := create {CE_CLASS_POINTER [PD_TRANSPORT_INFO]}.make_cast (l_tmp)
						last_fd.item := a_fd
						last_info.item := l_info
						last_tick.item := (create {P_CONNECT_STATIC}).transport_map_modified_tick.item
					end
				else
					l_tmp := ((create {P_CONNECT_STATIC}).transport_map.item).item.hash_table_get (create {CE_VOID_POINTER}.make_shared (default_pointer + a_fd))
					l_info := create {CE_CLASS_POINTER [PD_TRANSPORT_INFO]}.make_cast (l_tmp)
					last_fd.item := a_fd
					last_info.item := l_info
					last_tick.item := (create {P_CONNECT_STATIC}).transport_map_modified_tick.item
				end
				l_break := True
			end
			l_break := False
			if not (poll_internal (a_fd, l_info, 1, a_timeout)) then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if (not l_info.is_void) then
					if (not ((l_info.item.imp).item.reader).is_void) then
						Result := (((l_info.item.imp).item.reader).integer_32_item ([a_fd, a_buf___6, a_bufsize___0, l_info.item.ctx]))
					else
						l_tmp___2 := sock_read (a_fd, a_buf___6, a_bufsize___0)
						Result := l_tmp___2
					end
				else
					l_tmp___2 := sock_read (a_fd, a_buf___6, a_bufsize___0)
					Result := l_tmp___2
				end
			end
		end

	sock_read (a_fd: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_bufsize___0: INTEGER_32): INTEGER_32
		local
			l_res___0: INTEGER_32
			l_break: BOOLEAN
		do
			from
			until
				(l_break)
			loop
				l_break := False
				l_res___0 := read (a_fd, create {CE_VOID_POINTER}.make_cast (a_buf___6), a_bufsize___0.to_natural_32)
				if l_res___0 = -1 then
					if (errno_location).item /= 4 then
						l_break := True
					end
				else
					l_break := True
				end
			end
			l_break := False
			Result := l_res___0
		end

	fd_peek (a_fd: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_bufsize___0: INTEGER_32; a_timeout: REAL_64): INTEGER_32
		local
			l_info: CE_POINTER [PD_TRANSPORT_INFO]
			l_tmp: CE_POINTER [ANY]
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_break)
			loop
				l_break := False
				if ((create {P_CONNECT_STATIC}).transport_map.item).is_void then
					l_info := create {CE_CLASS_POINTER [PD_TRANSPORT_INFO]}.make_shared (default_pointer)
				elseif last_fd___0.item = a_fd then
					if last_tick___0.item = (create {P_CONNECT_STATIC}).transport_map_modified_tick.item then
						l_info := last_info___0.item
					else
						l_tmp := ((create {P_CONNECT_STATIC}).transport_map.item).item.hash_table_get (create {CE_VOID_POINTER}.make_shared (default_pointer + a_fd))
						l_info := create {CE_CLASS_POINTER [PD_TRANSPORT_INFO]}.make_cast (l_tmp)
						last_fd___0.item := a_fd
						last_info___0.item := l_info
						last_tick___0.item := (create {P_CONNECT_STATIC}).transport_map_modified_tick.item
					end
				else
					l_tmp := ((create {P_CONNECT_STATIC}).transport_map.item).item.hash_table_get (create {CE_VOID_POINTER}.make_shared (default_pointer + a_fd))
					l_info := create {CE_CLASS_POINTER [PD_TRANSPORT_INFO]}.make_cast (l_tmp)
					last_fd___0.item := a_fd
					last_info___0.item := l_info
					last_tick___0.item := (create {P_CONNECT_STATIC}).transport_map_modified_tick.item
				end
				l_break := True
			end
			l_break := False
			if not (poll_internal (a_fd, l_info, 1, a_timeout)) then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if (not l_info.is_void) then
					if (not ((l_info.item.imp).item.peeker).is_void) then
						Result := (((l_info.item.imp).item.peeker).integer_32_item ([a_fd, a_buf___6, a_bufsize___0, l_info.item.ctx]))
					else
						l_tmp___2 := sock_peek (a_fd, a_buf___6, a_bufsize___0)
						Result := l_tmp___2
					end
				else
					l_tmp___2 := sock_peek (a_fd, a_buf___6, a_bufsize___0)
					Result := l_tmp___2
				end
			end
		end

	poll_internal (a_fd: INTEGER_32; a_info: CE_POINTER [PD_TRANSPORT_INFO]; a_wf: INTEGER_32; a_timeout: REAL_64): BOOLEAN
		local
			l_timeout: REAL_64
			l_test: INTEGER_32
			l_return: BOOLEAN
		do
			l_timeout := a_timeout
			if l_timeout = (-1).to_double then
				l_timeout := (create {P_OPTIONS_STATIC}).opt.item.item.read_timeout
			end
			if l_timeout.truncated_to_integer.to_boolean then
				if (not a_info.is_void) then
					if (not ((a_info.item.imp).item.poller).is_void) then
						l_test := ((a_info.item.imp).item.poller).integer_32_item ([a_fd, l_timeout, a_wf, a_info.item.ctx])
					else
						l_test := sock_poll (a_fd, l_timeout, a_wf)
					end
				else
					l_test := sock_poll (a_fd, l_timeout, a_wf)
				end
				if l_test = 0 then
					(errno_location).item := 110
				end
				if l_test <= 0 then
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return then
				Result := (1).to_boolean
			end
		end

	sock_poll (a_fd: INTEGER_32; a_timeout: REAL_64; a_wait_for: INTEGER_32): INTEGER_32
		do
			Result := (select_fd (a_fd, a_timeout, a_wait_for))
		end

	select_fd (a_fd: INTEGER_32; a_maxtime: REAL_64; a_wait_for: INTEGER_32): INTEGER_32
		local
			l_fd: CE_ARRAY [INTEGER_32]
			l_fdset: CE_ARRAY [SD_FD_SET]
			l_rd: CE_POINTER [SD_FD_SET]
			l_wr: CE_POINTER [SD_FD_SET]
			l_tmout: CE_ARRAY [SD_TIMEVAL]
			l_result: INTEGER_32
			l___d0: CE_ARRAY [INTEGER_32]
			l___d1: CE_ARRAY [INTEGER_32]
			l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_fd.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_FD_SET]} l_fdset.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_tmout.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d1.make (<<1>>)

			l_fd.item := a_fd
			l_rd := create {CE_CLASS_POINTER [SD_FD_SET]}.make_shared (default_pointer)
			l_wr := create {CE_CLASS_POINTER [SD_FD_SET]}.make_shared (default_pointer)
			from
			until
				(l_break)
			loop
				l_break := False
				asm1 (l___d0, l___d1, l_fdset)
				l_break := True
			end
			l_break := False
			asm2 (l_fdset, l_fd)
			if ((a_wait_for).bit_and (1)).to_boolean then
				l_rd := l_fdset
			end
			if ((a_wait_for).bit_and (2)).to_boolean then
				l_wr := l_fdset
			end
			l_tmout.item.tv_sec := a_maxtime.truncated_to_integer
			l_tmout.item.tv_usec := ((1_000_000).to_double * (a_maxtime - (a_maxtime.truncated_to_integer).to_double)).truncated_to_integer
			from
			until
				(l_break)
			loop
				l_break := False
				l_result := select2 (l_fd.item + 1, l_rd, l_wr, create {CE_CLASS_POINTER [SD_FD_SET]}.make_shared (default_pointer), l_tmout)
				if l_result < 0 then
					if (errno_location).item /= 4 then
						l_break := True
					end
				else
					l_break := True
				end
			end
			l_break := False
			Result := l_result
		end

	sock_peek (a_fd: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_bufsize___0: INTEGER_32): INTEGER_32
		local
			l_res___0: INTEGER_32
			l_break: BOOLEAN
		do
			from
			until
				(l_break)
			loop
				l_break := False
				l_res___0 := recv (a_fd, create {CE_VOID_POINTER}.make_cast (a_buf___6), a_bufsize___0.to_natural_32, 2)
				if l_res___0 = -1 then
					if (errno_location).item /= 4 then
						l_break := True
					end
				else
					l_break := True
				end
			end
			l_break := False
			Result := l_res___0
		end

	url_escape (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_s.is_void
		do
			Result := (url_escape_1 (a_s, (2).to_natural_8, (0).to_boolean))
		end

	url_escape_unsafe_and_reserved (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_s.is_void
		do
			Result := (url_escape_1 (a_s, (3).to_natural_8, (0).to_boolean))
		end

	url_escape_allow_passthrough (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_s.is_void
		do
			Result := (url_escape_1 (a_s, (2).to_natural_8, (1).to_boolean))
		end

	url_escape_dir (a_dir: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_dir.is_void
		local
			l_newdir: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_newdir := (url_escape_1 (a_dir, (3).to_natural_8, (1).to_boolean))
			if l_newdir.is_equal (a_dir) then
				Result := a_dir
				l_return := True
			end
			if not l_return then
				unescape_single_char (l_newdir, (('/').code).to_integer_8)
				Result := l_newdir
			end
		end

	url_escape_1 (a_s: CE_POINTER [INTEGER_8]; a_mask: NATURAL_8; a_allow_passthrough: BOOLEAN): CE_POINTER [INTEGER_8]
		require
			not a_s.is_void
		local
			l_p1: CE_POINTER [INTEGER_8]
			l_p2: CE_POINTER [INTEGER_8]
			l_newstr: CE_POINTER [INTEGER_8]
			l_newlen: INTEGER_32
			l_addition: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_c: NATURAL_8
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_addition := 0
			l_p1 := a_s
			from
			until
				not ((l_p1[0]).to_boolean)
			loop
				if ((((create {P_URL_STATIC}).urlchr_table.item[((l_p1[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (a_mask.to_integer_32)).to_boolean then
					l_addition := l_addition + (2)
				end
				l_p1 := l_p1 + 1
			end
			if not l_addition.to_boolean then
				if a_allow_passthrough then
					l_tmp___0 := a_s
				else
					l_tmp___0 := ((create {P_XMALLOC_STATIC}).xstrdup (a_s))
				end
				Result := l_tmp___0
				l_return := True
			end
			if not l_return then
				l_newlen := (l_p1.distance (a_s)) + l_addition
				l_newstr := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((l_newlen + 1).to_natural_32)))
				l_p1 := a_s
				l_p2 := l_newstr
				from
				until
					not ((l_p1[0]).to_boolean)
				loop
					if ((((create {P_URL_STATIC}).urlchr_table.item[((l_p1[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (a_mask.to_integer_32)).to_boolean then
						l_tmp___2 := l_p1
						l_p1 := l_p1 + 1
						l_c := (l_tmp___2[0]).to_natural_8
						l_tmp___3 := l_p2
						l_p2 := l_p2 + 1
						l_tmp___3[0] := (('%%').code).to_integer_8
						l_tmp___4 := l_p2
						l_p2 := l_p2 + 1
						l_tmp___4[0] := (((ce_string ("0123456789ABCDEF") + ((l_c.to_integer_32).bit_shift_right (4))).item).to_integer_32).to_integer_8
						l_tmp___5 := l_p2
						l_p2 := l_p2 + 1
						l_tmp___5[0] := (((ce_string ("0123456789ABCDEF") + ((l_c.to_integer_32).bit_and (15))).item).to_integer_32).to_integer_8
					else
						l_tmp___6 := l_p2
						l_p2 := l_p2 + 1
						l_tmp___7 := l_p1
						l_p1 := l_p1 + 1
						l_tmp___6[0] := l_tmp___7[0]
					end
				end
				if l_p2.distance (l_newstr) /= l_newlen then
					assert_fail (ce_string ("p2 - newstr == newlen"), ce_string ("url.c"), {NATURAL_32} 244, ce_string ("url_escape_1"))
				end
				l_p2[0] := (('%/0/').code).to_integer_8
				Result := l_newstr
			end
		end

	unescape_single_char (a_str: CE_POINTER [INTEGER_8]; a_chr: INTEGER_8)
		require
			not a_str.is_void
		local
			l_c1: INTEGER_8
			l_c2: INTEGER_8
			l_h: CE_POINTER [INTEGER_8]
			l_t: CE_POINTER [INTEGER_8]
		do
			l_c1 := (((ce_string ("0123456789ABCDEF") + ((a_chr.to_integer_32).bit_shift_right (4))).item).to_integer_32).to_integer_8
			l_c2 := (((ce_string ("0123456789ABCDEF") + ((a_chr.to_integer_32).bit_and (15))).item).to_integer_32).to_integer_8
			l_h := a_str
			l_t := a_str
			from
			until
				not ((l_h[0]).to_boolean)
			loop
				if (l_h[0]).to_integer_32 = 37 then
					if (l_h[1]).to_integer_32 = l_c1.to_integer_32 then
						if (l_h[2]).to_integer_32 = l_c2.to_integer_32 then
							l_t[0] := a_chr
							l_h := l_h + (2)
						else
							l_t[0] := l_h[0]
						end
					else
						l_t[0] := l_h[0]
					end
				else
					l_t[0] := l_h[0]
				end
				l_h := l_h + 1
				l_t := l_t + 1
			end
			l_t[0] := (('%/0/').code).to_integer_8
		end

	append_string (a_str: CE_POINTER [INTEGER_8]; a_dest: CE_POINTER [PD_GROWABLE])
		require
			not a_str.is_void
			not a_dest.is_void
		local
			l_l: INTEGER_32
			l_G_: CE_POINTER [PD_GROWABLE]
			l_DR_needed_size: INTEGER_32
			l_DR_newsize: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_l := (strlen (a_str)).to_integer_32
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_G_ := a_dest
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_DR_needed_size := (l_G_.item.tail + l_l).to_integer_32
					l_DR_newsize := 0
					from
					until
						not ((l_G_.item.size).to_integer_32 < l_DR_needed_size)
					loop
						l_DR_newsize := ((l_G_.item.size).bit_shift_left (1)).to_integer_32
						if l_DR_newsize < 16 then
							l_DR_newsize := 16
						end
						l_G_.item.size := l_DR_newsize.to_integer_32
					end
					if l_DR_newsize.to_boolean then
						l_G_.item.base := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_G_.item.base), (l_DR_newsize.to_natural_32 * ({PLATFORM}.Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			memcpy (create {CE_VOID_POINTER}.make_cast ((a_dest.item.base + a_dest.item.tail)), create {CE_VOID_POINTER}.make_cast (a_str), l_l.to_natural_32).do_nothing
			a_dest.item.tail := a_dest.item.tail + l_l
		end

	remove_link (a_file: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_file.is_void
		local
			l_err: INTEGER_32
			l_st: CE_ARRAY [SD_STAT]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)

			l_err := 0
			if (lstat (a_file, l_st)) = 0 then
				if ((l_st.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 40_960 then
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
							(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Unlinking %%s (symlink).%N"), a_file])
						end
						l_break := True
					end
					l_break := False
					l_err := unlink (a_file)
					if l_err /= 0 then
						l_tmp___1 := strerror ((errno_location).item)
						l_tmp___2 := (create {P_QUOTE_STATIC}).quote (a_file);
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Failed to unlink symlink %%s: %%s%N"))), l_tmp___2, l_tmp___1])
					end
				end
			end
			Result := l_err
		end

	file_non_directory_p (a_path: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_path.is_void
		local
			l_buf___6: CE_ARRAY [SD_STAT]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_buf___6.make (<<1>>)

			if (lstat (a_path, l_buf___6)) /= 0 then
				Result := (0).to_boolean
				l_return := True
			end
			if not l_return then
				if ((l_buf___6.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 16_384 then
					l_tmp___0 := 0
				else
					l_tmp___0 := 1
				end
				Result := l_tmp___0.to_boolean
			end
		end

	file_size (a_filename: CE_POINTER [INTEGER_8]): INTEGER_64
		local
			l_size: INTEGER_64
			l_fp: CE_POINTER [SD_IO_FILE]
			l_return: BOOLEAN
		do
			l_fp := (fopen (a_filename, ce_string ("rb")))
			if l_fp.is_void then
				Result := (-1).to_integer_64
				l_return := True
			end
			if not l_return then
				fseeko (l_fp, (0).to_integer_32, 2).do_nothing
				l_size := (ftello (l_fp)).to_integer_64
				fclose (l_fp).do_nothing
				Result := l_size
			end
		end

	make_directory (a_directory: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_directory.is_void
		local
			l_i: INTEGER_32
			l_ret: INTEGER_32
			l_quit: INTEGER_32
			l_dir: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_SA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_SA_src: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_dir.make (<<1>>)

			l_quit := 0
			from
			until
				(l_break)
			loop
				l_break := False
				l_SA_dest := l_dir
				l_SA_src := a_directory
				l_SA_dest.item := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new ((strlen (l_SA_src)) + {NATURAL_32} 1)))
				strcpy (l_SA_dest.item, l_SA_src).do_nothing
				l_break := True
			end
			l_break := False
			l_i := ((l_dir.item[0]).to_integer_32 = 47).to_integer
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_dir.item[l_i]).to_boolean then
						if (l_dir.item[l_i]).to_integer_32 = 47 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_i := l_i + 1
					end
				end
				l_break := False
				if not (l_dir.item[l_i]).to_boolean then
					l_quit := 1
				end
				l_dir.item[l_i] := (('%/0/').code).to_integer_8
				if ((create {P_UTILS_STATIC}).file_exists_p (l_dir.item)) then
					l_ret := 0
				else
					l_ret := mkdir (l_dir.item, (511).to_natural_32)
				end
				if l_quit.to_boolean then
					l_break := True
				else
					l_dir.item[l_i] := (('/').code).to_integer_8
				end
				if not (l_return or l_break) then
					l_i := l_i + 1
				end
			end
			l_break := False
			Result := l_ret
		end

	file_merge (a_base, a_file: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_base.is_void
		local
			l_result: CE_POINTER [INTEGER_8]
			l_cut: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_cut := (strrchr (a_base, ('/').code))
			if l_cut.is_void then
				Result := ((create {P_XMALLOC_STATIC}).xstrdup (a_file))
				l_return := True
			end
			if not l_return then
				l_result := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((((l_cut.distance (a_base)) + 1).to_natural_32 + (strlen (a_file))) + {NATURAL_32} 1)))
				memcpy (create {CE_VOID_POINTER}.make_cast (l_result), create {CE_VOID_POINTER}.make_cast (a_base), (l_cut.distance (a_base)).to_natural_32).do_nothing
				l_result[(l_cut.distance (a_base))] := (('/').code).to_integer_8
				strcpy (((l_result + (l_cut.distance (a_base))) + 1), a_file).do_nothing
				Result := l_result
			end
		end

	base64_encode (a_data: CE_POINTER [ANY]; a_length: INTEGER_32; a_dest: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_dest.is_void
		local
			l_s: CE_POINTER [NATURAL_8]
			l_end: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := create {CE_NATURAL_8_POINTER}.make_cast (a_data)
					l_end := (create {CE_NATURAL_8_POINTER}.make_cast (a_data) + a_length) - 2
					l_p___0 := a_dest
					from
					until
						not ((l_s.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32)
					loop
						l_tmp := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp[0] := tbl.item[((l_s[0]).to_integer_32).bit_shift_right (2)]
						l_tmp___0 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___0[0] := tbl.item[(((((l_s[0]).to_integer_32).bit_and (3))).bit_shift_left (4)) + (((l_s[1]).to_integer_32).bit_shift_right (4))]
						l_tmp___1 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___1[0] := tbl.item[(((((l_s[1]).to_integer_32).bit_and (15))).bit_shift_left (2)) + (((l_s[2]).to_integer_32).bit_shift_right (6))]
						l_tmp___2 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___2[0] := tbl.item[((l_s[2]).to_integer_32).bit_and (63)]
						l_s := l_s + (3)
					end
					inspect a_length \\ 3 -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 1
					l_tmp___3 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___3[0] := tbl.item[((l_s[0]).to_integer_32).bit_shift_right (2)]
					l_tmp___4 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___4[0] := tbl.item[((((l_s[0]).to_integer_32).bit_and (3))).bit_shift_left (4)]
					l_tmp___5 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___5[0] := (('=').code).to_integer_8
					l_tmp___6 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___6[0] := (('=').code).to_integer_8
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_tmp___7 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___7[0] := tbl.item[((l_s[0]).to_integer_32).bit_shift_right (2)]
					l_tmp___8 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___8[0] := tbl.item[(((((l_s[0]).to_integer_32).bit_and (3))).bit_shift_left (4)) + (((l_s[1]).to_integer_32).bit_shift_right (4))]
					l_tmp___9 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___9[0] := tbl.item[((((l_s[1]).to_integer_32).bit_and (15))).bit_shift_left (2)]
					l_tmp___10 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___10[0] := (('=').code).to_integer_8
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
					l_p___0[0] := (('%/0/').code).to_integer_8
					Result := (l_p___0.distance (a_dest))
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	skey_response (a_sequence: INTEGER_32; a_seed, a_pass: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_seed.is_void
			not a_pass.is_void
		local
			l_sequence: INTEGER_32
			l_key: CE_ARRAY [NATURAL_8]
			l_md5_ctx: CE_POINTER [PD_GEN_MD5_CONTEXT]
			l_checksum: CE_ARRAY [NATURAL_32]
			l_tmp___3: INTEGER_32
			l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_NATURAL_8_ARRAY} l_key.make (<<8>>)
			create {CE_NATURAL_32_ARRAY} l_checksum.make (<<4>>)

			l_sequence := a_sequence
			l_md5_ctx := create {CE_CLASS_POINTER [PD_GEN_MD5_CONTEXT]}.make_cast ((l_aaf.new ((gen_md5_context_size).to_natural_32)))
			gen_md5_init (l_md5_ctx)
			gen_md5_update (create {CE_NATURAL_8_POINTER}.make_cast (a_seed), (strlen (a_seed)).to_integer_32, l_md5_ctx)
			gen_md5_update (create {CE_NATURAL_8_POINTER}.make_cast (a_pass), (strlen (a_pass)).to_integer_32, l_md5_ctx)
			gen_md5_finish (l_md5_ctx, create {CE_NATURAL_8_POINTER}.make_cast (l_checksum))
			l_checksum[0] := (l_checksum[0]).bit_xor ((l_checksum[2]))
			l_checksum[1] := (l_checksum[1]).bit_xor ((l_checksum[3]))
			memcpy (create {CE_VOID_POINTER}.make_cast (l_key), create {CE_VOID_POINTER}.make_cast (l_checksum), (8).to_natural_32).do_nothing
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp___3 := l_sequence
				l_sequence := l_sequence - 1
				if not (l_tmp___3 > 0) then
					l_break := True
				end
				if not (l_break) then
					gen_md5_init (l_md5_ctx)
					gen_md5_update (create {CE_NATURAL_8_POINTER}.make_cast (l_key), 8, l_md5_ctx)
					gen_md5_finish (l_md5_ctx, create {CE_NATURAL_8_POINTER}.make_cast (l_checksum))
					l_checksum[0] := (l_checksum[0]).bit_xor ((l_checksum[2]))
					l_checksum[1] := (l_checksum[1]).bit_xor ((l_checksum[3]))
					memcpy (create {CE_VOID_POINTER}.make_cast (l_key), create {CE_VOID_POINTER}.make_cast (l_checksum), (8).to_natural_32).do_nothing
				end
			end
			l_break := False
			Result := (btoe (english.item, create {CE_NATURAL_8_POINTER}.make_cast (l_key)))
		end

	gen_md5_context_size: INTEGER_32
		do
			Result := ((create {PD_GEN_MD5_CONTEXT}.make).structure_size.to_natural_32).to_integer_32
		end

	gen_md5_init (a_ctx: CE_POINTER [PD_GEN_MD5_CONTEXT])
		local
			l_ctx_imp: CE_POINTER [PD_MD5_CTX]
		do
			l_ctx_imp := create {CE_CLASS_POINTER [PD_MD5_CTX]}.make_shared (a_ctx.c_pointer + (create {PD_GEN_MD5_CONTEXT}.make).offset_of ("imp"))
			l_ctx_imp.item.md5_init_ctx
		end

	gen_md5_update (a_buffer___0: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_ctx: CE_POINTER [PD_GEN_MD5_CONTEXT])
		local
			l_ctx_imp: CE_POINTER [PD_MD5_CTX]
		do
			l_ctx_imp := create {CE_CLASS_POINTER [PD_MD5_CTX]}.make_shared (a_ctx.c_pointer + (create {PD_GEN_MD5_CONTEXT}.make).offset_of ("imp"))
			l_ctx_imp.item.md5_process_bytes (create {CE_VOID_POINTER}.make_cast (a_buffer___0), a_len.to_natural_32)
		end

	gen_md5_finish (a_ctx: CE_POINTER [PD_GEN_MD5_CONTEXT]; a_result: CE_POINTER [NATURAL_8])
		local
			l_ctx_imp: CE_POINTER [PD_MD5_CTX]
		do
			l_ctx_imp := create {CE_CLASS_POINTER [PD_MD5_CTX]}.make_shared (a_ctx.c_pointer + (create {PD_GEN_MD5_CONTEXT}.make).offset_of ("imp"))
			l_ctx_imp.item.md5_finish_ctx (create {CE_VOID_POINTER}.make_cast (a_result)).do_nothing
		end

	btoe (a_store: CE_POINTER [INTEGER_8]; a_c: CE_POINTER [NATURAL_8]): CE_POINTER [INTEGER_8]
		require
			not a_store.is_void
		local
			l_store: CE_POINTER [INTEGER_8]
			l_cp: CE_ARRAY [CE_ARRAY [NATURAL_8]]
			l_p___0: INTEGER_32
			l_i: INTEGER_32
			l_store_beg: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___21: INTEGER_32
			l_tmp___22: INTEGER_32
			l_tmp___23: INTEGER_32
			l_tmp___24: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
		do
			create {CE_ARRAY_ARRAY [NATURAL_8]} l_cp.make (<<1, 10>>)

			l_store := a_store
			l_store_beg := l_store
			l_store[0] := (('%/0/').code).to_integer_8
			memset (create {CE_VOID_POINTER}.make_cast (l_cp), ('%/0/').code, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (10).to_natural_32)).do_nothing
			memcpy (create {CE_VOID_POINTER}.make_cast ((l_cp.item)), create {CE_VOID_POINTER}.make_cast (a_c), (8).to_natural_32).do_nothing
			l_p___0 := 0
			l_i := 0
			from
			until
				not (l_i < 64)
			loop
				l_p___0 := (l_p___0.to_natural_32 + (extract (create {CE_NATURAL_8_POINTER}.make_cast ((l_cp.item)), l_i, 2))).to_integer_32
				l_i := l_i + (2)
			end
			l_cp.item[8] := (((l_p___0.to_integer_8).to_integer_32).bit_shift_left (6)).to_natural_8
			memcpy (create {CE_VOID_POINTER}.make_cast (l_store), create {CE_VOID_POINTER}.make_cast ((Wp.item[(extract (create {CE_NATURAL_8_POINTER}.make_cast ((l_cp.item)), 0, 11)).to_integer_32] + 0)), (4).to_natural_32).do_nothing
			if not (l_store[1]).to_boolean then
				l_tmp___3 := 1
			else
				if not (l_store[2]).to_boolean then
					l_tmp___2 := 2
				else
					if not (l_store[3]).to_boolean then
						l_tmp___1 := 3
					else
						l_tmp___1 := 4
					end
					l_tmp___2 := l_tmp___1
				end
				l_tmp___3 := l_tmp___2
			end
			l_store := l_store + l_tmp___3
			l_tmp___4 := l_store
			l_store := l_store + 1
			l_tmp___4[0] := ((' ').code).to_integer_8
			memcpy (create {CE_VOID_POINTER}.make_cast (l_store), create {CE_VOID_POINTER}.make_cast ((Wp.item[(extract (create {CE_NATURAL_8_POINTER}.make_cast ((l_cp.item)), 11, 11)).to_integer_32] + 0)), (4).to_natural_32).do_nothing
			if not (l_store[1]).to_boolean then
				l_tmp___8 := 1
			else
				if not (l_store[2]).to_boolean then
					l_tmp___7 := 2
				else
					if not (l_store[3]).to_boolean then
						l_tmp___6 := 3
					else
						l_tmp___6 := 4
					end
					l_tmp___7 := l_tmp___6
				end
				l_tmp___8 := l_tmp___7
			end
			l_store := l_store + l_tmp___8
			l_tmp___9 := l_store
			l_store := l_store + 1
			l_tmp___9[0] := ((' ').code).to_integer_8
			memcpy (create {CE_VOID_POINTER}.make_cast (l_store), create {CE_VOID_POINTER}.make_cast ((Wp.item[(extract (create {CE_NATURAL_8_POINTER}.make_cast ((l_cp.item)), 22, 11)).to_integer_32] + 0)), (4).to_natural_32).do_nothing
			if not (l_store[1]).to_boolean then
				l_tmp___13 := 1
			else
				if not (l_store[2]).to_boolean then
					l_tmp___12 := 2
				else
					if not (l_store[3]).to_boolean then
						l_tmp___11 := 3
					else
						l_tmp___11 := 4
					end
					l_tmp___12 := l_tmp___11
				end
				l_tmp___13 := l_tmp___12
			end
			l_store := l_store + l_tmp___13
			l_tmp___14 := l_store
			l_store := l_store + 1
			l_tmp___14[0] := ((' ').code).to_integer_8
			memcpy (create {CE_VOID_POINTER}.make_cast (l_store), create {CE_VOID_POINTER}.make_cast ((Wp.item[(extract (create {CE_NATURAL_8_POINTER}.make_cast ((l_cp.item)), 33, 11)).to_integer_32] + 0)), (4).to_natural_32).do_nothing
			if not (l_store[1]).to_boolean then
				l_tmp___18 := 1
			else
				if not (l_store[2]).to_boolean then
					l_tmp___17 := 2
				else
					if not (l_store[3]).to_boolean then
						l_tmp___16 := 3
					else
						l_tmp___16 := 4
					end
					l_tmp___17 := l_tmp___16
				end
				l_tmp___18 := l_tmp___17
			end
			l_store := l_store + l_tmp___18
			l_tmp___19 := l_store
			l_store := l_store + 1
			l_tmp___19[0] := ((' ').code).to_integer_8
			memcpy (create {CE_VOID_POINTER}.make_cast (l_store), create {CE_VOID_POINTER}.make_cast ((Wp.item[(extract (create {CE_NATURAL_8_POINTER}.make_cast ((l_cp.item)), 44, 11)).to_integer_32] + 0)), (4).to_natural_32).do_nothing
			if not (l_store[1]).to_boolean then
				l_tmp___23 := 1
			else
				if not (l_store[2]).to_boolean then
					l_tmp___22 := 2
				else
					if not (l_store[3]).to_boolean then
						l_tmp___21 := 3
					else
						l_tmp___21 := 4
					end
					l_tmp___22 := l_tmp___21
				end
				l_tmp___23 := l_tmp___22
			end
			l_store := l_store + l_tmp___23
			l_tmp___24 := l_store
			l_store := l_store + 1
			l_tmp___24[0] := ((' ').code).to_integer_8
			memcpy (create {CE_VOID_POINTER}.make_cast (l_store), create {CE_VOID_POINTER}.make_cast ((Wp.item[(extract (create {CE_NATURAL_8_POINTER}.make_cast ((l_cp.item)), 55, 11)).to_integer_32] + 0)), (4).to_natural_32).do_nothing
			l_store[4] := (('%/0/').code).to_integer_8
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
					(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("wrote %%s to STORE%N"), ((create {P_QUOTE_STATIC}).quote (l_store_beg))])
				end
				l_break := True
			end
			l_break := False
			Result := l_store_beg
		end

	extract (a_s: CE_POINTER [NATURAL_8]; a_start, a_length: INTEGER_32): NATURAL_32
		require
			not a_s.is_void
		local
			l_cl: NATURAL_8
			l_cc: NATURAL_8
			l_cr: NATURAL_8
			l_x: NATURAL_32
		do
			l_cl := a_s[a_start // 8]
			l_cc := a_s[(a_start // 8 + 1)]
			l_cr := a_s[(a_start // 8 + 2)]
			l_x := (((((((l_cl.to_integer_32).bit_shift_left (8))).bit_or (l_cc.to_integer_32)).to_natural_32).bit_shift_left (8))).bit_or (l_cr.to_natural_32)
			l_x := (l_x).bit_shift_right ((24 - (a_length + a_start \\ 8)))
			l_x := (l_x).bit_and (((65_535).bit_shift_right ((16 - a_length))).to_natural_32)
			Result := l_x
		end

	c2_isascii (a_c: INTEGER_32): BOOLEAN
		local
			l_tmp: INTEGER_32
		do
			if a_c >= 0 then
				if a_c <= 127 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp.to_boolean
		end

	c2_isalpha (a_c: INTEGER_32): BOOLEAN
		local
			l_tmp: INTEGER_32
		do
			if ((a_c).bit_and (-33)) >= 65 then
				if ((a_c).bit_and (-33)) <= 90 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp.to_boolean
		end

feature {ANY}

	copy (a_other: like Current)
		do
			url := a_other.url
			scheme := a_other.scheme
			host := a_other.host
			port := a_other.port
			path := a_other.path
			params := a_other.params
			query := a_other.query
			fragment := a_other.fragment
			dir := a_other.dir
			file := a_other.file
			user := a_other.user
			passwd := a_other.passwd
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				url.is_equal (a_other.url) and
				scheme = a_other.scheme and
				host.is_equal (a_other.host) and
				port = a_other.port and
				path.is_equal (a_other.path) and
				params.is_equal (a_other.params) and
				query.is_equal (a_other.query) and
				fragment.is_equal (a_other.fragment) and
				dir.is_equal (a_other.dir) and
				file.is_equal (a_other.file) and
				user.is_equal (a_other.user) and
				passwd.is_equal (a_other.passwd)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("scheme"),
					create {CE_STRUCTURE_FIELD}.make ("host"),
					create {CE_STRUCTURE_FIELD}.make ("port"),
					create {CE_STRUCTURE_FIELD}.make ("path"),
					create {CE_STRUCTURE_FIELD}.make ("params"),
					create {CE_STRUCTURE_FIELD}.make ("query"),
					create {CE_STRUCTURE_FIELD}.make ("fragment"),
					create {CE_STRUCTURE_FIELD}.make ("dir"),
					create {CE_STRUCTURE_FIELD}.make ("file"),
					create {CE_STRUCTURE_FIELD}.make ("user"),
					create {CE_STRUCTURE_FIELD}.make ("passwd")
				>>)
			init_structure_info
		end

end
