class
	PD_SESSION

inherit
	PD_SESSION_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_UNISTD_STATIC
		redefine
			copy,
			is_equal
		end
	S_FCNTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_BITS_ERRNO_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_SESSION]} next.make
			create {CE_CLASS_POINTER [PD_SESSION]} prev.make
			create history.make
			create {CE_CLASS_POINTER [PD_TERMINAL]} term.make
			create {CE_CLASS_POINTER [PD_WINDOW]} win.make
			create {CE_CLASS_POINTER [PD_F_DATA_C]} screen.make
			create scrn_frames.make
			create loading.make
			create {CE_NATURAL_8_POINTER} wtd_target.make
			create {CE_NATURAL_8_POINTER} loading_url.make
			create more_files.make
			create {CE_NATURAL_8_POINTER} goto_position.make
			create {CE_NATURAL_8_POINTER} imgmap_href_base.make
			create {CE_NATURAL_8_POINTER} imgmap_target_base.make
			create ds.make
			create kbdprefix.make
			create tq.make
			create {CE_NATURAL_8_POINTER} tq_url.make
			create {CE_CLASS_POINTER [PD_CACHE_ENTRY]} tq_ce.make
			create {CE_NATURAL_8_POINTER} tq_goto_position.make
			create {CE_NATURAL_8_POINTER} tq_prog.make
			create {CE_NATURAL_8_POINTER} dn_url.make
			create {CE_NATURAL_8_POINTER} search_word.make
			create {CE_NATURAL_8_POINTER} last_search_word.make
			Precursor
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_SESSION] assign set_next

	prev: CE_POINTER [PD_SESSION] assign set_prev

	history: PD_LIST_HEAD assign set_history

	term: CE_POINTER [PD_TERMINAL] assign set_term

	win: CE_POINTER [PD_WINDOW] assign set_win

	id: INTEGER_32 assign set_id

	screen: CE_POINTER [PD_F_DATA_C] assign set_screen

	scrn_frames: PD_LIST_HEAD assign set_scrn_frames

	loading: PD_STATUS assign set_loading

	wtd: INTEGER_32 assign set_wtd

	wtd_target: CE_POINTER [NATURAL_8] assign set_wtd_target

	loading_url: CE_POINTER [NATURAL_8] assign set_loading_url

	display_timer: INTEGER_32 assign set_display_timer

	more_files: PD_LIST_HEAD assign set_more_files

	goto_position: CE_POINTER [NATURAL_8] assign set_goto_position

	imgmap_href_base: CE_POINTER [NATURAL_8] assign set_imgmap_href_base

	imgmap_target_base: CE_POINTER [NATURAL_8] assign set_imgmap_target_base

	ds: PD_DOCUMENT_SETUP assign set_ds

	kbdprefix: PD_KBDPREFIX assign set_kbdprefix

	reloadlevel: INTEGER_32 assign set_reloadlevel

	redirect_cnt: INTEGER_32 assign set_redirect_cnt

	tq: PD_STATUS assign set_tq

	tq_url: CE_POINTER [NATURAL_8] assign set_tq_url

	tq_ce: CE_POINTER [PD_CACHE_ENTRY] assign set_tq_ce

	tq_goto_position: CE_POINTER [NATURAL_8] assign set_tq_goto_position

	tq_prog: CE_POINTER [NATURAL_8] assign set_tq_prog

	tq_prog_flags: INTEGER_32 assign set_tq_prog_flags

	dn_url: CE_POINTER [NATURAL_8] assign set_dn_url

	search_word: CE_POINTER [NATURAL_8] assign set_search_word

	last_search_word: CE_POINTER [NATURAL_8] assign set_last_search_word

	search_direction: INTEGER_32 assign set_search_direction

	exit_query: INTEGER_32 assign set_exit_query

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_SESSION])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_SESSION])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_history (a_history: PD_LIST_HEAD)
		do
			history := a_history
			update_memory_field ("history")
		end

	set_term (a_term: CE_POINTER [PD_TERMINAL])
		do
			term := a_term
			update_memory_field ("term")
		end

	set_win (a_win: CE_POINTER [PD_WINDOW])
		do
			win := a_win
			update_memory_field ("win")
		end

	set_id (a_id: INTEGER_32)
		do
			id := a_id
			update_memory_field ("id")
		end

	set_screen (a_screen: CE_POINTER [PD_F_DATA_C])
		do
			screen := a_screen
			update_memory_field ("screen")
		end

	set_scrn_frames (a_scrn_frames: PD_LIST_HEAD)
		do
			scrn_frames := a_scrn_frames
			update_memory_field ("scrn_frames")
		end

	set_loading (a_loading: PD_STATUS)
		do
			loading := a_loading
			update_memory_field ("loading")
		end

	set_wtd (a_wtd: INTEGER_32)
		do
			wtd := a_wtd
			update_memory_field ("wtd")
		end

	set_wtd_target (a_wtd_target: CE_POINTER [NATURAL_8])
		do
			wtd_target := a_wtd_target
			update_memory_field ("wtd_target")
		end

	set_loading_url (a_loading_url: CE_POINTER [NATURAL_8])
		do
			loading_url := a_loading_url
			update_memory_field ("loading_url")
		end

	set_display_timer (a_display_timer: INTEGER_32)
		do
			display_timer := a_display_timer
			update_memory_field ("display_timer")
		end

	set_more_files (a_more_files: PD_LIST_HEAD)
		do
			more_files := a_more_files
			update_memory_field ("more_files")
		end

	set_goto_position (a_goto_position: CE_POINTER [NATURAL_8])
		do
			goto_position := a_goto_position
			update_memory_field ("goto_position")
		end

	set_imgmap_href_base (a_imgmap_href_base: CE_POINTER [NATURAL_8])
		do
			imgmap_href_base := a_imgmap_href_base
			update_memory_field ("imgmap_href_base")
		end

	set_imgmap_target_base (a_imgmap_target_base: CE_POINTER [NATURAL_8])
		do
			imgmap_target_base := a_imgmap_target_base
			update_memory_field ("imgmap_target_base")
		end

	set_ds (a_ds: PD_DOCUMENT_SETUP)
		do
			ds := a_ds
			update_memory_field ("ds")
		end

	set_kbdprefix (a_kbdprefix: PD_KBDPREFIX)
		do
			kbdprefix := a_kbdprefix
			update_memory_field ("kbdprefix")
		end

	set_reloadlevel (a_reloadlevel: INTEGER_32)
		do
			reloadlevel := a_reloadlevel
			update_memory_field ("reloadlevel")
		end

	set_redirect_cnt (a_redirect_cnt: INTEGER_32)
		do
			redirect_cnt := a_redirect_cnt
			update_memory_field ("redirect_cnt")
		end

	set_tq (a_tq: PD_STATUS)
		do
			tq := a_tq
			update_memory_field ("tq")
		end

	set_tq_url (a_tq_url: CE_POINTER [NATURAL_8])
		do
			tq_url := a_tq_url
			update_memory_field ("tq_url")
		end

	set_tq_ce (a_tq_ce: CE_POINTER [PD_CACHE_ENTRY])
		do
			tq_ce := a_tq_ce
			update_memory_field ("tq_ce")
		end

	set_tq_goto_position (a_tq_goto_position: CE_POINTER [NATURAL_8])
		do
			tq_goto_position := a_tq_goto_position
			update_memory_field ("tq_goto_position")
		end

	set_tq_prog (a_tq_prog: CE_POINTER [NATURAL_8])
		do
			tq_prog := a_tq_prog
			update_memory_field ("tq_prog")
		end

	set_tq_prog_flags (a_tq_prog_flags: INTEGER_32)
		do
			tq_prog_flags := a_tq_prog_flags
			update_memory_field ("tq_prog_flags")
		end

	set_dn_url (a_dn_url: CE_POINTER [NATURAL_8])
		do
			dn_url := a_dn_url
			update_memory_field ("dn_url")
		end

	set_search_word (a_search_word: CE_POINTER [NATURAL_8])
		do
			search_word := a_search_word
			update_memory_field ("search_word")
		end

	set_last_search_word (a_last_search_word: CE_POINTER [NATURAL_8])
		do
			last_search_word := a_last_search_word
			update_memory_field ("last_search_word")
		end

	set_search_direction (a_search_direction: INTEGER_32)
		do
			search_direction := a_search_direction
			update_memory_field ("search_direction")
		end

	set_exit_query (a_exit_query: INTEGER_32)
		do
			exit_query := a_exit_query
			update_memory_field ("exit_query")
		end

feature {PD_SESSION} -- private attributes

	main_menu: CE_STATIC [CE_ARRAY [PD_MENU_ITEM]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MENU_ITEM]}.make_initialized (<<
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 109, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 355, ((create {PD_TERMINAL_STATIC}).do_file_menu_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 1, 1]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 110, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 356, ((create {PD_TERMINAL_STATIC}).do_view_menu_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 1, 1]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 111, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 357, (link_menu_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 1, 1]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 112, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 358, ((create {P_MENU_STATIC}).downloads_menu_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 1, 1]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 113, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 359, ((create {PD_TERMINAL_STATIC}).do_setup_menu_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 1, 1]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 114, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 360, ((create {PD_TERMINAL_STATIC}).do_menu_address), create {CE_VOID_POINTER}.make_cast (help_menu.item), 1, 1]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0])
				>>)
		end

	help_menu: CE_STATIC [CE_ARRAY [PD_MENU_ITEM]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MENU_ITEM]}.make_initialized (<<
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 12, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 340, ((create {PD_TERMINAL_STATIC}).menu_about_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 15, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 341, ((create {PD_TERMINAL_STATIC}).menu_keys_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 289, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 343, ((create {P_MENU_STATIC}).menu_manual_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 17, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 342, ((create {PD_TERMINAL_STATIC}).menu_copying_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0])
				>>)
		end

feature {ANY} -- public routines

	add_frame_to_list (a_fd: CE_POINTER [PD_F_DATA_C])
		require
			not a_fd.is_void
		local
			l_f: CE_POINTER [PD_F_DATA_C]
			l_fp: CE_POINTER [PD_F_DATA_C]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_f := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_cast (scrn_frames.next)
				when 1 then -- loop condition:
					if not (not (l_return) and then (not l_f.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames"))))) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						if not (l_f.item.yp > a_fd.item.yp) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 5 then -- else:
						if l_f.item.yp /= a_fd.item.yp then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if not (l_f.item.xp > a_fd.item.xp) then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_f.item.prev))
							update_class_fields -- Current might have been changed; synchronize
							a_fd.item.next := (l_f.item.prev).item.next
							update_class_fields -- Current might have been changed; synchronize
							a_fd.item.prev := l_f.item.prev
							update_class_fields; -- Current might have been changed; synchronize
							(l_f.item.prev).item.next := a_fd
							update_class_fields; -- Current might have been changed; synchronize
							(a_fd.item.next).item.prev := a_fd
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_f.item.prev))
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_return := True
				when 8 then -- if done | if done
						if not l_return then
							l_f := l_f.item.next
						end
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					if not l_return then
						l_fp := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_cast (scrn_frames.prev)
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_fp))
							update_class_fields -- Current might have been changed; synchronize
							a_fd.item.next := l_fp.item.next
							update_class_fields -- Current might have been changed; synchronize
							a_fd.item.prev := l_fp
							update_class_fields -- Current might have been changed; synchronize
							l_fp.item.next := a_fd
							update_class_fields; -- Current might have been changed; synchronize
							(a_fd.item.next).item.prev := a_fd
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_fp))
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_fd (a_name: CE_POINTER [NATURAL_8]; a_depth___0, a_x, a_y: INTEGER_32): CE_POINTER [PD_F_DATA_C]
		local
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			l_fd := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_cast (scrn_frames.prev)
			from
			until
				not (not (l_return) and then (not l_fd.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))))
			loop
				l_tmp := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_fd.item.name), create {CE_INTEGER_8_POINTER}.make_cast (a_name))
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp.to_boolean then
					if not (l_fd.item.used).to_boolean then
						l_fd.item.used := 1
						update_class_fields -- Current might have been changed; synchronize
						l_fd.item.depth := a_depth___0
						update_class_fields -- Current might have been changed; synchronize
						Result := l_fd
						l_return := True
					end
				end
				if not l_return then
					l_fd := l_fd.item.prev
				end
			end
			if not l_return then
				l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_216, (create {PD_F_DATA_C}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_fd := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_cast (l_tmp___0)
				memset (create {CE_VOID_POINTER}.make_cast (l_fd), 0, (create {PD_F_DATA_C}.make).structure_size.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_fd.item.used := 1
				update_class_fields -- Current might have been changed; synchronize
				l_fd.item.name := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_219, a_name)
				update_class_fields -- Current might have been changed; synchronize
				l_fd.item.depth := a_depth___0
				update_class_fields -- Current might have been changed; synchronize
				l_fd.item.xp := a_x
				update_class_fields -- Current might have been changed; synchronize
				l_fd.item.yp := a_y
				update_class_fields -- Current might have been changed; synchronize
				l_fd.item.search_word := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("search_word"))
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.add_frame_to_list (l_fd)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_fd
			end
		end

	html_interpret
		local
			l_l: CE_POINTER [PD_VIEW_STATE]
			l_o: CE_ARRAY [PD_DOCUMENT_OPTIONS]
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_cf: CE_POINTER [PD_F_DATA_C]
			l_tmp: CE_POINTER [ANY]
			l_fdp: CE_POINTER [PD_F_DATA_C]
			l_n: INTEGER_32
			l_break, l_continue: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_DOCUMENT_OPTIONS]} l_o.make (<<1>>)

			l_cf := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (default_pointer)
			if screen.is_void then
				l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_296, (create {PD_F_DATA_C}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				Current.screen := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_cast (l_tmp)
				update_class_fields -- Current might have been changed; synchronize
				memset (create {CE_VOID_POINTER}.make_cast (screen), 0, (create {PD_F_DATA_C}.make).structure_size.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				screen.item.search_word := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("search_word"))
				update_class_fields -- Current might have been changed; synchronize
			end
			if not ((history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history")))) then
				l_l := create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared ((create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).c_pointer + (create {PD_LOCATION}.make).offset_of ("vs"))
			else
				l_l := create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (default_pointer)
			end
			l_o.item.xp := 0
			update_class_fields -- Current might have been changed; synchronize
			l_o.item.yp := 1
			update_class_fields -- Current might have been changed; synchronize
			l_o.item.xw := term.item.x
			update_class_fields -- Current might have been changed; synchronize
			if term.item.y < 2 then
				l_o.item.yw := 0
				update_class_fields -- Current might have been changed; synchronize
			else
				l_o.item.yw := term.item.y - 2
				update_class_fields -- Current might have been changed; synchronize
			end
			l_o.item.col := (term.item.spec).item.col
			update_class_fields -- Current might have been changed; synchronize
			l_o.item.cp := (term.item.spec).item.charset
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_DOCUMENT_SETUP]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("ds"))).item.ds2do (l_o)
			update_class_fields -- Current might have been changed; synchronize
			if (not l_l.is_void) then
				l_o.item.plain := l_l.item.plain
				update_class_fields -- Current might have been changed; synchronize
			else
				l_o.item.plain := 1
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_o.item.plain = -1 then
				l_o.item.plain := 0
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not l_l.is_void) then
				l_l.item.plain := l_o.item.plain
				update_class_fields -- Current might have been changed; synchronize
			end
			memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (l_o.item.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_fg")))), create {CE_VOID_POINTER}.make_cast (((create {P_DEFAULT_STATIC}).default_fg.item)), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (l_o.item.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_bg")))), create {CE_VOID_POINTER}.make_cast (((create {P_DEFAULT_STATIC}).default_bg.item)), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (l_o.item.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_link")))), create {CE_VOID_POINTER}.make_cast (((create {P_DEFAULT_STATIC}).default_link.item)), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (l_o.item.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_vlink")))), create {CE_VOID_POINTER}.make_cast (((create {P_DEFAULT_STATIC}).default_vlink.item)), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_o.item.framename := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
			update_class_fields -- Current might have been changed; synchronize
			l_fd := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_cast (scrn_frames.next)
			from
			until
				l_fd.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))
			loop
				l_fd.item.used := 0
				update_class_fields -- Current might have been changed; synchronize
				l_fd := l_fd.item.next
			end
			(create {P_HTML_R_STATIC}).cached_format_html (l_l, screen, l_o)
			update_class_fields -- Current might have been changed; synchronize
			if (not (screen.item.f_data).is_void) then
				if ((screen.item.f_data).item.frame).to_boolean then
					l_cf := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.current_frame
					update_class_fields -- Current might have been changed; synchronize
					format_frames ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), (screen.item.f_data).item.frame_desc, l_o, 0)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_fd := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_cast (scrn_frames.next)
			from
			until
				l_fd.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))
			loop
				if not (l_fd.item.used).to_boolean then
					l_fdp := l_fd.item.prev
					l_fd.item.detach_formatted
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_fd))
					update_class_fields; -- Current might have been changed; synchronize
					(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_fd.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_fd.item.prev)
					update_class_fields; -- Current might have been changed; synchronize
					(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_fd.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_fd.item.next)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_fd))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_327, create {CE_VOID_POINTER}.make_cast (l_fd))
					update_class_fields -- Current might have been changed; synchronize
					l_fd := l_fdp
				end
				l_fd := l_fd.item.next
			end
			if (not l_cf.is_void) then
				l_n := 0
				l_fd := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_cast (scrn_frames.next)
				from
				until
					not (not (l_break) and then (not l_fd.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))))
				loop
					l_break := False
					l_continue := False
					if (not (l_fd.item.f_data).is_void) then
						if ((l_fd.item.f_data).item.frame).to_boolean then
							l_continue := True
						end
					end
					if not (l_break or l_continue) and then (l_fd.is_equal (l_cf)) then
						(create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).item.vs.current_link := l_n
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					if not (l_break or l_continue) then
						l_n := l_n + 1
					end
					if (not l_break) then
						l_fd := l_fd.item.next
					end
				end
				l_break := False
				l_continue := False
			end
		end

	mms_func (a_url: CE_POINTER [NATURAL_8])
		local
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_tmp := check_shell_url (a_url)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				term.item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 304, 1, (create {P_LINKS_STATIC}).dummyarray.item + 300, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				(create {P_MAILTO_STATIC}).prog_func (term, (create {P_TYPES_STATIC}).mms_prog.item, a_url, (create {P_LINKS_STATIC}).dummyarray.item + 300)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	really_exit_prog
		do
			(create {P_SELECT_STATIC}).register_bottom_half (((create {PD_TERMINAL_STATIC}).destroy_terminal_address), create {CE_VOID_POINTER}.make_cast (term)).do_nothing
			update_class_fields -- Current might have been changed; synchronize
		end

	dont_exit_prog
		do
			Current.exit_query := 0
			update_class_fields -- Current might have been changed; synchronize
		end

	query_exit
		local
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
		do
			Current.exit_query := 1
			update_class_fields -- Current might have been changed; synchronize
			if (term.item.next).is_equal (term.item.prev) then
				l_tmp___1 := (create {P_SESSION_STATIC}).are_there_downloads
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___1.to_boolean then
					l_tmp___0 := (create {P_LINKS_STATIC}).dummyarray.item + 276
				else
					l_tmp___0 := (create {P_LINKS_STATIC}).dummyarray.item + 275
				end
			else
				l_tmp___0 := (create {P_LINKS_STATIC}).dummyarray.item + 275
			end
			term.item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 274, 1, l_tmp___0, (create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), 2, (create {P_LINKS_STATIC}).dummyarray.item + 166, (really_exit_prog_address), 1, (create {P_LINKS_STATIC}).dummyarray.item + 167, dont_exit_prog_address, 2])
			update_class_fields -- Current might have been changed; synchronize
		end

	html_refresh
		do
			ds.margin := atoi (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MENU_STATIC}).marg_str.item)))
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.html_interpret
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.draw_formatted
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SESSION_STATIC}).load_frames ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), screen)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SESSION_STATIC}).process_file_requests ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)))
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.print_screen_status
			update_class_fields -- Current might have been changed; synchronize
		end

	activate_bfu_technology (a_item: INTEGER_32)
		local
			l_term: CE_POINTER [PD_TERMINAL]
		do
			l_term := term
			do_mainmenu (l_term, main_menu.item, create {CE_VOID_POINTER}.make_shared (c_pointer), a_item)
			update_class_fields -- Current might have been changed; synchronize
		end

	dialog_goto_url (a_url: CE_POINTER [INTEGER_8])
		do
			input_field (term, create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 80, (create {P_LINKS_STATIC}).dummyarray.item + 115, (create {P_LINKS_STATIC}).dummyarray.item + 14, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (c_pointer), (create {P_MENU_STATIC}).goto_url_history.item, 4_096, create {CE_NATURAL_8_POINTER}.make_cast (a_url), 0, 0, create {CE_ROUTINE}.make_shared (default_pointer), ((create {P_SESSION_STATIC}).goto_url_address), create {CE_ROUTINE}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	dialog_save_url
		do
			input_field (term, create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 116, (create {P_LINKS_STATIC}).dummyarray.item + 115, (create {P_LINKS_STATIC}).dummyarray.item + 14, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (c_pointer), (create {P_MENU_STATIC}).goto_url_history.item, 4_096, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 0, 0, create {CE_ROUTINE}.make_shared (default_pointer), (save_url_address), create {CE_ROUTINE}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	query_file (a_url: CE_POINTER [NATURAL_8]; a_std, a_cancel: CE_ROUTINE)
		local
			l_file: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_def: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_dfl: CE_ARRAY [INTEGER_32]
			l_l: CE_ARRAY [INTEGER_32]
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_file.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_def.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_dfl.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)

			l_dfl.item := 0
			update_class_fields -- Current might have been changed; synchronize
			get_filename_from_url (a_url, l_file, l_l)
			update_class_fields -- Current might have been changed; synchronize
			l_def.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 1_262)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_def, l_dfl, (create {P_DEFAULT_STATIC}).download_dir.item)
			update_class_fields -- Current might have been changed; synchronize
			if (l_def.item.item).to_boolean then
				l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_def.item))
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := (create {P_OS_DEP_STATIC}).dir_sep ((l_def.item[(l_tmp - {NATURAL_32} 1).to_integer_32]).to_integer_8)
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp___0.to_boolean then
					(create {P_LINKS_STATIC}).add_chr_to_str (l_def, l_dfl, (('/').code).to_natural_8)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			(create {P_LINKS_STATIC}).add_bytes_to_str (l_def, l_dfl, l_file.item, l_l.item)
			update_class_fields -- Current might have been changed; synchronize
			input_field (term, create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 117, (create {P_LINKS_STATIC}).dummyarray.item + 118, (create {P_LINKS_STATIC}).dummyarray.item + 14, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (c_pointer), (create {P_MENU_STATIC}).file_history.item, 4_096, l_def.item, 0, 0, create {CE_ROUTINE}.make_shared (default_pointer), a_std, a_cancel)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 1_267, create {CE_VOID_POINTER}.make_cast (l_def.item))
			update_class_fields -- Current might have been changed; synchronize
		end

	search_back_dlg (a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		do
			input_field (term, create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 93, (create {P_LINKS_STATIC}).dummyarray.item + 119, (create {P_LINKS_STATIC}).dummyarray.item + 14, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (c_pointer), (create {P_MENU_STATIC}).search_history.item, 4_096, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 0, 0, create {CE_ROUTINE}.make_shared (default_pointer), (search_for_back_address), create {CE_ROUTINE}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	search_dlg (a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		do
			input_field (term, create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 92, (create {P_LINKS_STATIC}).dummyarray.item + 119, (create {P_LINKS_STATIC}).dummyarray.item + 14, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (c_pointer), (create {P_MENU_STATIC}).search_history.item, 4_096, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 0, 0, create {CE_ROUTINE}.make_shared (default_pointer), (search_for_address), create {CE_ROUTINE}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	print_screen_status
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_stat___0: CE_POINTER [PD_STATUS]
			l_m: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_ftl: CE_POINTER [PD_FILE_TO_LOAD]
			l_tmp: NATURAL_32
			l_p: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___1: NATURAL_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_m.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_term := term
					l_stat___0 := create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (default_pointer)
					l_term.item.fill_area (0, 0, l_term.item.x, 1, {NATURAL_32} 1_792)
					update_class_fields -- Current might have been changed; synchronize
					l_term.item.fill_area (0, l_term.item.y - 1, l_term.item.x, 1, {NATURAL_32} 1_792)
					update_class_fields -- Current might have been changed; synchronize
					if wtd.to_boolean then
						l_stat___0 := create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("loading"))
					elseif not ((history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history")))) then
						l_stat___0 := create {CE_CLASS_POINTER [PD_STATUS]}.make_shared ((create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).c_pointer + (create {PD_LOCATION}.make).offset_of ("stat"))
					end
					if (not l_stat___0.is_void) then
						if l_stat___0.item.state = -1_000 then
							l_ftl := create {CE_CLASS_POINTER [PD_FILE_TO_LOAD]}.make_cast (more_files.next)
							from
							until
								not (not (l_break) and then (not l_ftl.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("more_files")))))
							loop
								l_break := False
								if (l_ftl.item.req_sent).to_boolean then
									if l_ftl.item.stat.state >= 0 then
										l_stat___0 := create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (l_ftl.c_pointer + (create {PD_FILE_TO_LOAD}.make).offset_of ("stat"))
										l_break := True
									end
								end
								if not (l_break) then
									l_ftl := l_ftl.item.next
								end
							end
							l_break := False
						end
					end
					if l_stat___0.is_void then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if l_stat___0.item.state = -1_000 then
							l_m.item := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.print_current_link
							update_class_fields -- Current might have been changed; synchronize
							if (not (l_m.item).is_void) then
								l_pos := -1 + 3 -- goto p
							end
						end
				when 2 then
						l_m.item := get_stat_msg (l_stat___0, l_term)
						update_class_fields -- Current might have been changed; synchronize
						if (l_m.item).is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | p:
						l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_m.item))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_TERMINAL_STATIC}).print_text (l_term, 0, l_term.item.y - 1, l_tmp.to_integer_32, l_m.item, {NATURAL_32} 14_336)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 121, create {CE_VOID_POINTER}.make_cast (l_m.item))
						update_class_fields -- Current might have been changed; synchronize
				when 4 then -- if done
						l_m.item := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.print_current_title
						update_class_fields -- Current might have been changed; synchronize
						if (not (l_m.item).is_void) then
							l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_m.item))
							update_class_fields -- Current might have been changed; synchronize
							l_p := ((l_term.item.x - 1).to_natural_32 - l_tmp___0).to_integer_32
							if l_p < 0 then
								l_p := 0
							end
							l_tmp___1 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_m.item))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_TERMINAL_STATIC}).print_text (l_term, l_p, 0, l_tmp___1.to_integer_32, l_m.item, {NATURAL_32} 1_792)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 129, create {CE_VOID_POINTER}.make_cast (l_m.item))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_m.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 131, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Links")))
						update_class_fields -- Current might have been changed; synchronize
						if (not screen.is_void) then
							if (not (screen.item.f_data).is_void) then
								if (not ((screen.item.f_data).item.title).is_void) then
									if ((screen.item.f_data).item.title[0]).to_boolean then
										(create {P_LINKS_STATIC}).add_to_strn (l_m, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" - ")))
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_LINKS_STATIC}).add_to_strn (l_m, (screen.item.f_data).item.title)
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
						end
						set_terminal_title (l_term, l_m.item)
						update_class_fields -- Current might have been changed; synchronize
				when 5 then -- if done;
					(create {P_TERMINAL_STATIC}).redraw_from_window (win)
					update_class_fields -- Current might have been changed; synchronize
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	free_wtd
		local
			l_return: BOOLEAN
		do
			if not wtd.to_boolean then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).errline.item := 149
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("no WTD"))])
					update_class_fields -- Current might have been changed; synchronize
				end
				l_return := True
			end
			if not l_return then
				if (not goto_position.is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 152, create {CE_VOID_POINTER}.make_cast (goto_position))
					update_class_fields -- Current might have been changed; synchronize
					Current.goto_position := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 153, create {CE_VOID_POINTER}.make_cast (loading_url))
				update_class_fields -- Current might have been changed; synchronize
				Current.loading_url := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				Current.wtd := 0
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	abort_files_load
		local
			l_ftl: CE_POINTER [PD_FILE_TO_LOAD]
			l_q: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_q := 0
				l_ftl := create {CE_CLASS_POINTER [PD_FILE_TO_LOAD]}.make_cast (more_files.next)
				from
				until
					l_ftl.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("more_files")))
				loop
					if l_ftl.item.stat.state >= 0 then
						if (l_ftl.item.req_sent).to_boolean then
							l_q := 1;
							(create {P_SCHED_STATIC}).change_connection (create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (l_ftl.c_pointer + (create {PD_FILE_TO_LOAD}.make).offset_of ("stat")), create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_ftl := l_ftl.item.next
				end
				if not l_q.to_boolean then
					l_break := True
				end
			end
			l_break := False
		end

	free_files
		local
			l_ftl: CE_POINTER [PD_FILE_TO_LOAD]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.abort_files_load
			update_class_fields -- Current might have been changed; synchronize
			l_ftl := create {CE_CLASS_POINTER [PD_FILE_TO_LOAD]}.make_cast (more_files.next)
			from
			until
				l_ftl.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("more_files")))
			loop
				if (not (l_ftl.item.ce).is_void) then
					(l_ftl.item.ce).item.refcount := ((l_ftl.item.ce).item.refcount) - 1
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 179, create {CE_VOID_POINTER}.make_cast (l_ftl.item.url))
				update_class_fields -- Current might have been changed; synchronize
				l_ftl := l_ftl.item.next
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("more_files")))))
			update_class_fields -- Current might have been changed; synchronize
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (more_files.next)
			from
			until
				l_a__.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("more_files")))
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields -- Current might have been changed; synchronize
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (more_files.prev)
			from
			until
				l_a__.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("more_files")))
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields -- Current might have been changed; synchronize
				l_a__ := l_a__.item.prev
			end
			from
			until
				(more_files.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("more_files")))
			loop
				l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (more_files.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev)
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 181, create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("more_files")))))
			update_class_fields -- Current might have been changed; synchronize
		end

	ses_forward
		local
			l_l: CE_POINTER [PD_LOCATION]
			l_len: NATURAL_32
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [ANY]
			l_frm: CE_POINTER [PD_FRAME]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:;
					((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.free_files
					update_class_fields -- Current might have been changed; synchronize
					if not ((history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history")))) then
						l_l := create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)
					end
					if (not search_word.is_void) then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 205, create {CE_VOID_POINTER}.make_cast (search_word))
						update_class_fields -- Current might have been changed; synchronize
						Current.search_word := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
					end
				when 1 then -- x:
					l_len := strlen (create {CE_INTEGER_8_POINTER}.make_cast (loading_url))
					update_class_fields -- Current might have been changed; synchronize
					if not ((history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history")))) then
						l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).item.vs.url)))
						update_class_fields -- Current might have been changed; synchronize
						if l_len < l_tmp then
							l_len := strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).item.vs.url)))
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 210, ((create {PD_LOCATION}.make).structure_size.to_natural_32 + l_len) + {NATURAL_32} 1)
					update_class_fields -- Current might have been changed; synchronize
					l_l := create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (l_tmp___0)
					memset (create {CE_VOID_POINTER}.make_cast (l_l), 0, (create {PD_LOCATION}.make).structure_size.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("stat")))), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("loading")))), (create {PD_STATUS}.make).structure_size.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					if wtd_target.is_void then
						l_pos := -1 + 9 -- skip if block
					end
				when 2 then -- if:
						if not ((wtd_target.item).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						if (history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
							from
							until
								False
							loop
								(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c"))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).errline.item := 216
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("no history"))])
								update_class_fields -- Current might have been changed; synchronize
							end
							l_return := True
						end
						if l_return then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_l.item.copy_location (create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next))
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history")))))
							update_class_fields -- Current might have been changed; synchronize
							l_l.item.next := (create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))))).item.next
							update_class_fields -- Current might have been changed; synchronize
							l_l.item.prev := create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))))
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))))).item.next := l_l
							update_class_fields; -- Current might have been changed; synchronize
							(l_l.item.next).item.prev := l_l
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history")))))
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_frm := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.ses_change_frame_url (wtd_target, loading_url)
						update_class_fields -- Current might have been changed; synchronize
						if l_frm.is_void then
							l_l.item.destroy_location
							update_class_fields -- Current might have been changed; synchronize
							Current.wtd_target := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 1 -- goto x
						end
				when 5 then;
						(create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (l_frm.c_pointer + (create {PD_FRAME}.make).offset_of ("vs"))).item.destroy_vs
						update_class_fields; -- Current might have been changed; synchronize
						(create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (l_frm.c_pointer + (create {PD_FRAME}.make).offset_of ("vs"))).item.init_vs (loading_url)
						update_class_fields -- Current might have been changed; synchronize
						if (not goto_position.is_void) then
							if (not (l_frm.item.vs.goto_position).is_void) then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 230, create {CE_VOID_POINTER}.make_cast (l_frm.item.vs.goto_position))
								update_class_fields -- Current might have been changed; synchronize
							end
							l_frm.item.vs.goto_position := goto_position
							update_class_fields -- Current might have been changed; synchronize
							Current.goto_position := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 6 then -- if done | if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 9 -- goto _L
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))))
						update_class_fields -- Current might have been changed; synchronize
						l_l.item.frames.next := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames"))))
						update_class_fields -- Current might have been changed; synchronize
						l_l.item.frames.prev := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames"))))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))))
						update_class_fields; -- Current might have been changed; synchronize
						(create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("vs"))).item.init_vs (loading_url)
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history")))))
							update_class_fields -- Current might have been changed; synchronize
							l_l.item.next := (create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))))).item.next
							update_class_fields -- Current might have been changed; synchronize
							l_l.item.prev := create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))))
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))))).item.next := l_l
							update_class_fields; -- Current might have been changed; synchronize
							(l_l.item.next).item.prev := l_l
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history")))))
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						if (not goto_position.is_void) then
							l_l.item.vs.goto_position := goto_position
							update_class_fields -- Current might have been changed; synchronize
							Current.goto_position := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 10 then
					if not l_return then
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ses_imgmap
		local
			l_ce: CE_ARRAY [CE_POINTER [PD_CACHE_ENTRY]]
			l_fr: CE_POINTER [PD_FRAGMENT]
			l_ml: CE_ARRAY [CE_POINTER [PD_MEMORY_LIST]]
			l_menu: CE_ARRAY [CE_POINTER [PD_MENU_ITEM]]
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_CACHE_ENTRY]} l_ce.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_MEMORY_LIST]} l_ml.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_MENU_ITEM]} l_menu.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := (create {P_CACHE_STATIC}).find_in_cache (loading_url, l_ce)
					update_class_fields -- Current might have been changed; synchronize
					if not (l_tmp.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if (not (l_ce.item).is_void) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).errline.item := 254
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("can%'t find cache entry"))])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_return := True
				when 5 then -- if done
					if not l_return then
						(l_ce.item).item.defrag_entry
						update_class_fields -- Current might have been changed; synchronize
						l_fr := create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast (l_ce.item.item.frag.next)
						if l_fr.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_ce.item.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))) then
							l_return := True
						end
					end
					if not l_return then
						l_fd := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.current_frame
						update_class_fields -- Current might have been changed; synchronize
						if (not l_fd.is_void) then
							if (l_fd.item.f_data).is_void then
								l_return := True
							end
						else
							l_return := True
						end
					end
					if not l_return then
						(create {P_LINKS_STATIC}).d_opt.item := create {CE_CLASS_POINTER [PD_DOCUMENT_OPTIONS]}.make_shared ((l_fd.item.f_data).c_pointer + (create {PD_F_DATA}.make).offset_of ("opt"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := get_image_map (l_ce.item.item.head, l_fr.item.data, l_fr.item.data + l_fr.item.length, goto_position, l_menu, l_ml, imgmap_href_base, imgmap_target_base, (term.item.spec).item.charset, ds.assume_cp, ds.hard_assume)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0.to_boolean then
							l_return := True
						end
					end
					if not l_return then
						add_empty_window (term, ((create {P_BFU_STATIC}).freeml_address), create {CE_VOID_POINTER}.make_cast (l_ml.item))
						update_class_fields -- Current might have been changed; synchronize
						term.item.do_menu (l_menu.item, create {CE_VOID_POINTER}.make_shared (c_pointer))
						update_class_fields -- Current might have been changed; synchronize
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ses_back
		local
			l_loc: CE_POINTER [PD_LOCATION]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.free_files
			update_class_fields -- Current might have been changed; synchronize
			l_loc := create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)
			if (not search_word.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 278, create {CE_VOID_POINTER}.make_cast (search_word))
				update_class_fields -- Current might have been changed; synchronize
				Current.search_word := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_loc.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
				l_return := True
			end
			if not l_return then
				l_loc.item.destroy_location
				update_class_fields -- Current might have been changed; synchronize
				l_loc := create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)
				if l_loc.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
					l_return := True
				end
			end
			if not l_return then
				l_tmp := strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_loc.item.vs.url)), create {CE_INTEGER_8_POINTER}.make_cast (loading_url))
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp.to_boolean then
					l_return := True
				end
			end
			if not l_return then
				l_loc.item.destroy_location
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.ses_forward
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	start_download (a_file: CE_POINTER [NATURAL_8])
		local
			l_down___0: CE_POINTER [PD_DOWNLOAD]
			l_h: INTEGER_32
			l_url: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			l_url := dn_url
			if l_url.is_void then
				l_return := True
			end
			if not l_return then
				kill_downloads_to_file (a_file)
				update_class_fields -- Current might have been changed; synchronize
				l_h := create_download_file (term, a_file, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_h < 0 then
					l_return := True
				end
			end
			if not l_return then
				l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 711, (create {PD_DOWNLOAD}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_down___0 := create {CE_CLASS_POINTER [PD_DOWNLOAD]}.make_cast (l_tmp)
				memset (create {CE_VOID_POINTER}.make_cast (l_down___0), 0, (create {PD_DOWNLOAD}.make).structure_size.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_down___0.item.url := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 713, l_url)
				update_class_fields -- Current might have been changed; synchronize
				l_down___0.item.stat.end2 := ((create {PD_STATUS_STATIC}).download_data_address)
				update_class_fields -- Current might have been changed; synchronize
				l_down___0.item.stat.data := create {CE_VOID_POINTER}.make_cast (l_down___0)
				update_class_fields -- Current might have been changed; synchronize
				l_down___0.item.last_pos := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_down___0.item.file := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 717, a_file)
				update_class_fields -- Current might have been changed; synchronize
				l_down___0.item.handle := l_h
				update_class_fields -- Current might have been changed; synchronize
				l_down___0.item.ses := (create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
				l_down___0.item.remotetime := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_SESSION_STATIC}).downloads.item)))
					update_class_fields -- Current might have been changed; synchronize
					l_down___0.item.next := (create {CE_CLASS_POINTER [PD_DOWNLOAD]}.make_cast (((create {P_SESSION_STATIC}).downloads.item))).item.next
					update_class_fields -- Current might have been changed; synchronize
					l_down___0.item.prev := create {CE_CLASS_POINTER [PD_DOWNLOAD]}.make_cast (((create {P_SESSION_STATIC}).downloads.item))
					update_class_fields; -- Current might have been changed; synchronize
					(create {CE_CLASS_POINTER [PD_DOWNLOAD]}.make_cast (((create {P_SESSION_STATIC}).downloads.item))).item.next := l_down___0
					update_class_fields; -- Current might have been changed; synchronize
					(l_down___0.item.next).item.prev := l_down___0
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_SESSION_STATIC}).downloads.item)))
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False;
				(create {P_SCHED_STATIC}).load_url (l_url, create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (l_down___0.c_pointer + (create {PD_DOWNLOAD}.make).offset_of ("stat")), 0, 1).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				display_download (term, l_down___0, (create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	continue_download (a_file: CE_POINTER [NATURAL_8])
		local
			l_file: CE_POINTER [NATURAL_8]
			l_down___0: CE_POINTER [PD_DOWNLOAD]
			l_h: INTEGER_32
			l_namecount: INTEGER_32
			l_url: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_file := a_file
					l_namecount := 0
					l_url := tq_url
					if l_url.is_void then
						l_return := True
					end
					if not (not l_return and then (not tq_prog.is_void)) then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | new_name:
						l_file := get_temp_name (l_url)
						update_class_fields -- Current might have been changed; synchronize
						if l_file.is_void then
							((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.tp_cancel
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
				when 2 then -- if done
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 3 then -- if:
						kill_downloads_to_file (l_file)
						update_class_fields -- Current might have been changed; synchronize
						if tq_prog.is_void then
							kill_downloads_to_file (l_file)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_h := create_download_file (term, l_file, ((not tq_prog.is_void)).to_integer)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_h < 0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if l_h /= -2 then
							l_pos := -1 + 8 -- skip if block
						end
				when 5 then -- if:
						if tq_prog.is_void then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_namecount := l_namecount + 1
						if l_namecount < 10_000 then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 749, create {CE_VOID_POINTER}.make_cast (l_file))
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 1 -- goto new_name
						end
				when 7 then
						term.item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 168, 129, (create {P_LINKS_STATIC}).dummyarray.item + 172, create {CE_VOID_POINTER}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
						update_class_fields -- Current might have been changed; synchronize
				when 8 then -- if done | if done
						if (not tq_prog.is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 754, create {CE_VOID_POINTER}.make_cast (l_file))
							update_class_fields -- Current might have been changed; synchronize
						end
						((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.tp_cancel
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
				when 9 then -- if done | if done
					if not l_return then
						l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 758, (create {PD_DOWNLOAD}.make).structure_size.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_down___0 := create {CE_CLASS_POINTER [PD_DOWNLOAD]}.make_cast (l_tmp)
						memset (create {CE_VOID_POINTER}.make_cast (l_down___0), 0, (create {PD_DOWNLOAD}.make).structure_size.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_down___0.item.url := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 760, l_url)
						update_class_fields -- Current might have been changed; synchronize
						l_down___0.item.stat.end2 := ((create {PD_STATUS_STATIC}).download_data_address)
						update_class_fields -- Current might have been changed; synchronize
						l_down___0.item.stat.data := create {CE_VOID_POINTER}.make_cast (l_down___0)
						update_class_fields -- Current might have been changed; synchronize
						l_down___0.item.last_pos := (0).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_down___0.item.file := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 764, l_file)
						update_class_fields -- Current might have been changed; synchronize
						l_down___0.item.handle := l_h
						update_class_fields -- Current might have been changed; synchronize
						l_down___0.item.ses := (create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if (not tq_prog.is_void) then
							l_down___0.item.prog := (create {P_SESSION_STATIC}).subst_file (tq_prog, l_file)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 769, create {CE_VOID_POINTER}.make_cast (l_file))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 770, create {CE_VOID_POINTER}.make_cast (tq_prog))
							update_class_fields -- Current might have been changed; synchronize
							Current.tq_prog := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_down___0.item.prog_flags := tq_prog_flags
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_SESSION_STATIC}).downloads.item)))
							update_class_fields -- Current might have been changed; synchronize
							l_down___0.item.next := (create {CE_CLASS_POINTER [PD_DOWNLOAD]}.make_cast (((create {P_SESSION_STATIC}).downloads.item))).item.next
							update_class_fields -- Current might have been changed; synchronize
							l_down___0.item.prev := create {CE_CLASS_POINTER [PD_DOWNLOAD]}.make_cast (((create {P_SESSION_STATIC}).downloads.item))
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_DOWNLOAD]}.make_cast (((create {P_SESSION_STATIC}).downloads.item))).item.next := l_down___0
							update_class_fields; -- Current might have been changed; synchronize
							(l_down___0.item.next).item.prev := l_down___0
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_SESSION_STATIC}).downloads.item)))
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False;
						(create {P_SCHED_STATIC}).change_connection (create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("tq")), create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (l_down___0.c_pointer + (create {PD_DOWNLOAD}.make).offset_of ("stat")), 0)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.tp_free
						update_class_fields -- Current might have been changed; synchronize
						display_download (term, l_down___0, (create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)))
						update_class_fields -- Current might have been changed; synchronize
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tp_free
		do
			tq_ce.item.refcount := (tq_ce.item.refcount) - 1
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 783, create {CE_VOID_POINTER}.make_cast (tq_url))
			update_class_fields -- Current might have been changed; synchronize
			Current.tq_url := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			if (not tq_goto_position.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 785, create {CE_VOID_POINTER}.make_cast (tq_goto_position))
				update_class_fields -- Current might have been changed; synchronize
				Current.tq_goto_position := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.tq_ce := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
		end

	tp_cancel
		do
			(create {P_SCHED_STATIC}).change_connection (create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("tq")), create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.tp_free
			update_class_fields -- Current might have been changed; synchronize
		end

	tp_save
		do
			if (not tq_prog.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 797, create {CE_VOID_POINTER}.make_cast (tq_prog))
				update_class_fields -- Current might have been changed; synchronize
				Current.tq_prog := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.query_file (tq_url, continue_download_address, tp_cancel_address)
			update_class_fields -- Current might have been changed; synchronize
		end

	tp_open
		do
			((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.continue_download (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
			update_class_fields -- Current might have been changed; synchronize
		end

	tp_display
		local
			l_l: CE_POINTER [PD_LOCATION]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [ANY]
			l_break: BOOLEAN
		do
			l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (tq_url))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 811, (create {PD_LOCATION}.make).structure_size.to_natural_32 + l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			l_l := create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (l_tmp___0)
			memset (create {CE_VOID_POINTER}.make_cast (l_l), 0, (create {PD_LOCATION}.make).structure_size.to_natural_32).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item.frames.next := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames"))))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item.frames.prev := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames"))))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))))
			update_class_fields -- Current might have been changed; synchronize
			memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("stat")))), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("tq")))), (create {PD_STATUS}.make).structure_size.to_natural_32).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("vs"))).item.init_vs (tq_url)
			update_class_fields -- Current might have been changed; synchronize
			if (not tq_goto_position.is_void) then
				l_l.item.vs.goto_position := tq_goto_position
				update_class_fields -- Current might have been changed; synchronize
				Current.tq_goto_position := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history")))))
				update_class_fields -- Current might have been changed; synchronize
				l_l.item.next := (create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))))).item.next
				update_class_fields -- Current might have been changed; synchronize
				l_l.item.prev := create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))))
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))))).item.next := l_l
				update_class_fields; -- Current might have been changed; synchronize
				(l_l.item.next).item.prev := l_l
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history")))))
				update_class_fields -- Current might have been changed; synchronize
				l_break := True
			end
			l_break := False;
			(create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).item.stat.end2 := ((create {PD_STATUS_STATIC}).doc_end_load_address)
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).item.stat.data := create {CE_VOID_POINTER}.make_shared (c_pointer)
			update_class_fields -- Current might have been changed; synchronize
			if tq.state >= 0 then
				(create {P_SCHED_STATIC}).change_connection (create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("tq")), create {CE_CLASS_POINTER [PD_STATUS]}.make_shared ((create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).c_pointer + (create {PD_LOCATION}.make).offset_of ("stat")), 0)
				update_class_fields -- Current might have been changed; synchronize
			else
				(create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).item.stat.state := tq.state
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).item.vs.plain := 1
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.display_timer2
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.tp_free
			update_class_fields -- Current might have been changed; synchronize
		end

	type_query (a_ce: CE_POINTER [PD_CACHE_ENTRY]; a_ct: CE_POINTER [NATURAL_8]; a_a: CE_POINTER [PD_ASSOC])
		local
			l_m1: CE_POINTER [NATURAL_8]
			l_m2: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [PD_MEMORY_LIST]
			l_tmp___0: CE_POINTER [PD_MEMORY_LIST]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [PD_MEMORY_LIST]
			l_tmp___3: CE_POINTER [PD_MEMORY_LIST]
			l_return: BOOLEAN
		do
			if (not tq_prog.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 834, create {CE_VOID_POINTER}.make_cast (tq_prog))
				update_class_fields -- Current might have been changed; synchronize
				Current.tq_prog := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not a_a.is_void) then
				Current.tq_prog := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 835, a_a.item.prog)
				update_class_fields -- Current might have been changed; synchronize
				Current.tq_prog_flags := a_a.item.block
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not a_a.is_void) then
				if not (a_a.item.ask).to_boolean then
					((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.tp_open
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
				l_m1 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 840, a_ct)
				update_class_fields -- Current might have been changed; synchronize
				if a_a.is_void then
					if not ((create {P_DEFAULT_STATIC}).anonymous.item).to_boolean then
						l_tmp := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_m1), create {CE_VOID_POINTER}.make_shared (default_pointer)])
						update_class_fields -- Current might have been changed; synchronize
						term.item.msg_box ([l_tmp, (create {P_LINKS_STATIC}).dummyarray.item + 173, 129, (create {P_LINKS_STATIC}).dummyarray.item + 174, ce_string (" "), l_m1, ce_string (".%N"), (create {P_LINKS_STATIC}).dummyarray.item + 175, create {CE_VOID_POINTER}.make_shared (default_pointer), (create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), 3, (create {P_LINKS_STATIC}).dummyarray.item + 176, tp_save_address, 1, (create {P_LINKS_STATIC}).dummyarray.item + 177, tp_display_address, 0, (create {P_LINKS_STATIC}).dummyarray.item + 6, tp_cancel_address, 2])
						update_class_fields -- Current might have been changed; synchronize
					else
						l_tmp___0 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_m1), create {CE_VOID_POINTER}.make_shared (default_pointer)])
						update_class_fields -- Current might have been changed; synchronize
						term.item.msg_box ([l_tmp___0, (create {P_LINKS_STATIC}).dummyarray.item + 173, 129, (create {P_LINKS_STATIC}).dummyarray.item + 174, ce_string (" "), l_m1, ce_string (".%N"), (create {P_LINKS_STATIC}).dummyarray.item + 175, create {CE_VOID_POINTER}.make_shared (default_pointer), (create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), 2, (create {P_LINKS_STATIC}).dummyarray.item + 177, tp_display_address, 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, tp_cancel_address, 2])
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					if (not (a_a.item.label).is_void) then
						l_tmp___1 := a_a.item.label
					else
						l_tmp___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
					end
					l_m2 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 845, l_tmp___1)
					update_class_fields -- Current might have been changed; synchronize
					if not ((create {P_DEFAULT_STATIC}).anonymous.item).to_boolean then
						l_tmp___2 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_m1), l_m2, create {CE_VOID_POINTER}.make_shared (default_pointer)])
						update_class_fields -- Current might have been changed; synchronize
						term.item.msg_box ([l_tmp___2, (create {P_LINKS_STATIC}).dummyarray.item + 178, 129, (create {P_LINKS_STATIC}).dummyarray.item + 174, ce_string (" "), l_m1, ce_string (".%N"), (create {P_LINKS_STATIC}).dummyarray.item + 179, ce_string (" "), l_m2, ce_string (", "), (create {P_LINKS_STATIC}).dummyarray.item + 180, create {CE_VOID_POINTER}.make_shared (default_pointer), (create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), 4, (create {P_LINKS_STATIC}).dummyarray.item + 181, tp_open_address, 1, (create {P_LINKS_STATIC}).dummyarray.item + 176, tp_save_address, 0, (create {P_LINKS_STATIC}).dummyarray.item + 177, tp_display_address, 0, (create {P_LINKS_STATIC}).dummyarray.item + 6, tp_cancel_address, 2])
						update_class_fields -- Current might have been changed; synchronize
					else
						l_tmp___3 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_m1), l_m2, create {CE_VOID_POINTER}.make_shared (default_pointer)])
						update_class_fields -- Current might have been changed; synchronize
						term.item.msg_box ([l_tmp___3, (create {P_LINKS_STATIC}).dummyarray.item + 178, 129, (create {P_LINKS_STATIC}).dummyarray.item + 174, ce_string (" "), l_m1, ce_string (".%N"), (create {P_LINKS_STATIC}).dummyarray.item + 179, ce_string (" "), l_m2, ce_string (", "), (create {P_LINKS_STATIC}).dummyarray.item + 180, create {CE_VOID_POINTER}.make_shared (default_pointer), (create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), 3, (create {P_LINKS_STATIC}).dummyarray.item + 181, tp_open_address, 1, (create {P_LINKS_STATIC}).dummyarray.item + 177, tp_display_address, 0, (create {P_LINKS_STATIC}).dummyarray.item + 6, tp_cancel_address, 2])
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
		end

	ses_chktype (a_stat___0: CE_POINTER [CE_POINTER [PD_STATUS]]; a_ce: CE_POINTER [PD_CACHE_ENTRY]): INTEGER_32
		require
			not a_ce.is_void
		local
			l_a: CE_POINTER [PD_ASSOC]
			l_ct: CE_POINTER [NATURAL_8]
			l_r: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: NATURAL_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [PD_STATUS]
			l_tmp___5: CE_POINTER [PD_CACHE_ENTRY]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_r := 0
					l_ct := (create {P_TYPES_STATIC}).get_content_type (a_ce.item.head, a_ce.item.url)
					update_class_fields -- Current might have been changed; synchronize
					if l_ct.is_void then
						l_pos := -1 + 6 -- goto f
					end
				when 1 then
					l_tmp := is_html_type (l_ct)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						l_pos := -1 + 5 -- goto ff
					end
				when 2 then
					l_r := 1
					l_tmp___0 := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_ct), ce_string ("text/plain"))
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___0.to_boolean then
						l_tmp___1 := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_ct), ce_string ("file/txt"))
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___1.to_boolean then
							l_pos := -1 + 5 -- goto ff
						end
					else
						l_pos := -1 + 5 -- goto ff
					end
				when 3 then
					l_a := get_type_assoc (term, l_ct)
					update_class_fields -- Current might have been changed; synchronize
					if l_a.is_void then
						l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ct))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2 >= {NATURAL_32} 4 then
							l_tmp___3 := (create {P_LINKS_STATIC}).casecmp (l_ct, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("text")), (4).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___3.to_boolean then
								l_pos := -1 + 5 -- goto ff
							end
						end
					end
				when 4 then
					if (not tq_url.is_void) then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).errline.item := 861
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("type query to %%s already in prgress")), tq_url])
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					Current.tq_url := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 862, loading_url)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___4 := create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("tq"))
					a_stat___0.item := l_tmp___4
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_SCHED_STATIC}).change_connection (create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("loading")), l_tmp___4, 0)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___5 := a_ce
					Current.tq_ce := l_tmp___5
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___5.item.refcount := (l_tmp___5.item.refcount) + 1
					update_class_fields -- Current might have been changed; synchronize
					if (not tq_goto_position.is_void) then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 865, create {CE_VOID_POINTER}.make_cast (tq_goto_position))
						update_class_fields -- Current might have been changed; synchronize
					end
					Current.tq_goto_position := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 866, goto_position)
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.type_query (a_ce, l_ct, l_a)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 868, create {CE_VOID_POINTER}.make_cast (l_ct))
					update_class_fields -- Current might have been changed; synchronize
					Result := 1
					l_return := True
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 5 then -- if: | ff:;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 872, create {CE_VOID_POINTER}.make_cast (l_ct))
						update_class_fields -- Current might have been changed; synchronize
				when 6 then -- f:
						if (not wtd_target.is_void) then
							if l_r.to_boolean then
								wtd_target.item := (0).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.ses_forward
						update_class_fields; -- Current might have been changed; synchronize
						(create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).item.vs.plain := l_r
						update_class_fields -- Current might have been changed; synchronize
						Result := 0
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ses_goto (a_url, a_target: CE_POINTER [NATURAL_8]; a_pri, a_cache___0, a_wtd: INTEGER_32; a_pos___0: CE_POINTER [NATURAL_8]; a_fn: CE_ROUTINE; a_redir: INTEGER_32)
		local
			l_w: CE_POINTER [PD_WTD_DATA]
			l_m1: CE_POINTER [NATURAL_8]
			l_m2: CE_POINTER [NATURAL_8]
			l_e: CE_ARRAY [CE_POINTER [PD_CACHE_ENTRY]]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [PD_MEMORY_LIST]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_CACHE_ENTRY]} l_e.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := strchr (create {CE_INTEGER_8_POINTER}.make_cast (a_url), 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.is_void then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if a_cache___0 /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						l_tmp___0 := (create {P_CACHE_STATIC}).find_in_cache (a_url, l_e)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0.to_boolean then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_e.item.item.incomplete).to_boolean then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if (not goto_position.is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 921, create {CE_VOID_POINTER}.make_cast (goto_position))
							update_class_fields -- Current might have been changed; synchronize
						end
						Current.goto_position := a_pos___0
						update_class_fields -- Current might have been changed; synchronize
						loading.end2 := a_fn
						update_class_fields -- Current might have been changed; synchronize
						loading.data := create {CE_VOID_POINTER}.make_shared (c_pointer)
						update_class_fields -- Current might have been changed; synchronize
						Current.loading_url := a_url
						update_class_fields -- Current might have been changed; synchronize
						Current.wtd := a_wtd
						update_class_fields -- Current might have been changed; synchronize
						Current.wtd_target := a_target
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SCHED_STATIC}).load_url (a_url, create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("loading")), a_pri, a_cache___0).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
				when 5 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_pos := -1 + 4 -- goto _L
				when 7 then
					if not l_return then
						l_tmp___1 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 931, (create {PD_WTD_DATA}.make).structure_size.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_w := create {CE_CLASS_POINTER [PD_WTD_DATA]}.make_cast (l_tmp___1)
						l_w.item.ses := (create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_w.item.url := a_url
						update_class_fields -- Current might have been changed; synchronize
						l_w.item.pri := a_pri
						update_class_fields -- Current might have been changed; synchronize
						l_w.item.cache := a_cache___0
						update_class_fields -- Current might have been changed; synchronize
						l_w.item.wtd := a_wtd
						update_class_fields -- Current might have been changed; synchronize
						l_w.item.target := a_target
						update_class_fields -- Current might have been changed; synchronize
						l_w.item.pos := a_pos___0
						update_class_fields -- Current might have been changed; synchronize
						l_w.item.fn := a_fn
						update_class_fields -- Current might have been changed; synchronize
						if a_redir.to_boolean then
							l_m1 := (create {P_LINKS_STATIC}).dummyarray.item + 182
						elseif a_wtd = 1 then
							l_m1 := (create {P_LINKS_STATIC}).dummyarray.item + 183
						else
							l_m1 := (create {P_LINKS_STATIC}).dummyarray.item + 184
						end
						l_tmp___2 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (a_url), 1)
						update_class_fields -- Current might have been changed; synchronize
						l_m2 := (create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 943, a_url, (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___2)).distance (a_url))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___3 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_m2), l_w, l_w.item.url, l_w.item.pos, create {CE_VOID_POINTER}.make_shared (default_pointer)])
						update_class_fields -- Current might have been changed; synchronize
						term.item.msg_box ([l_tmp___3, (create {P_LINKS_STATIC}).dummyarray.item + 185, 129, l_m1, ce_string (" "), l_m2, ce_string ("?"), create {CE_VOID_POINTER}.make_shared (default_pointer), l_w, 3, (create {P_LINKS_STATIC}).dummyarray.item + 166, (create {PD_WTD_DATA_STATIC}).post_yes_address, 1, (create {P_LINKS_STATIC}).dummyarray.item + 167, (create {PD_WTD_DATA_STATIC}).post_no_address, 0, (create {P_LINKS_STATIC}).dummyarray.item + 6, (create {PD_WTD_DATA_STATIC}).post_cancel_address, 2])
						update_class_fields -- Current might have been changed; synchronize
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_move (a_stat___0: CE_POINTER [CE_POINTER [PD_STATUS]]): INTEGER_32
		local
			l_ce: CE_POINTER [PD_CACHE_ENTRY]
			l_u: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p: CE_POINTER [NATURAL_8]
			l_gp: CE_POINTER [NATURAL_8]
			l_pos___0: CE_POINTER [NATURAL_8]
			l_w: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: CE_POINTER [PD_STATUS]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_u.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ce := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
					if loading_url.is_void then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).errline.item := 951
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("no ses->loading_url"))])
							update_class_fields -- Current might have been changed; synchronize
						end
						Result := 0
						l_return := True
					end
					if not l_return then
						l_ce := (a_stat___0.item).item.ce
						if (not l_ce.is_void) then
							if wtd = 2 then
								if (a_stat___0.item).item.state >= 0 then
									Result := 0
									l_return := True
								end
							end
						else
							Result := 0
							l_return := True
						end
					end
					if not (not l_return and then (not (l_ce.item.redirect).is_void)) then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_tmp___3 := redirect_cnt
						Current.redirect_cnt := redirect_cnt + 1
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___3 < 10) then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						l_w := wtd
						if wtd = 4 then
							if ((create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).item.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
								l_pos := -1 + 11 -- goto b
							end
						end
				when 3 then
						l_u.item := (create {P_URL_STATIC}).join_urls (loading_url, l_ce.item.redirect)
						update_class_fields -- Current might have been changed; synchronize
						if (l_u.item).is_void then
							l_pos := -1 + 11 -- goto b
						end
				when 4 then
						if not ((create {P_DEFAULT_STATIC}).http_bugs.item.item.bug_302_redirect).to_boolean then
							if not (l_ce.item.redirect_get).to_boolean then
								l_tmp := strchr (create {CE_INTEGER_8_POINTER}.make_cast (loading_url), 1)
								update_class_fields -- Current might have been changed; synchronize
								l_p := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)
								if (not l_p.is_void) then
									(create {P_LINKS_STATIC}).add_to_strn (l_u, l_p)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						l_gp := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 966, goto_position)
						update_class_fields -- Current might have been changed; synchronize
						l_pos___0 := (create {P_URL_STATIC}).extract_position (l_u.item)
						update_class_fields -- Current might have been changed; synchronize
						if (not l_pos___0.is_void) then
							if l_gp.is_void then
								l_gp := l_pos___0
							else
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 969, create {CE_VOID_POINTER}.make_cast (l_pos___0))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.abort_loading
						update_class_fields -- Current might have been changed; synchronize
						if not ((history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history")))) then
							a_stat___0.item := create {CE_CLASS_POINTER [PD_STATUS]}.make_shared ((create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).c_pointer + (create {PD_LOCATION}.make).offset_of ("stat"))
							update_class_fields -- Current might have been changed; synchronize
						else
							a_stat___0.item := create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_w /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if l_w /= 2 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if redirect_cnt < 5 then
							l_tmp___0 := 1
						else
							l_tmp___0 := 3
						end
						((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.ses_goto (l_u.item, wtd_target, 0, l_tmp___0, l_w, l_gp, (create {P_SESSION_STATIC}).end_load_address, 1)
						update_class_fields -- Current might have been changed; synchronize
						Result := 2
						l_return := True
				when 9 then -- if done
						if not l_return then
							if (not l_gp.is_void) then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 978, create {CE_VOID_POINTER}.make_cast (l_gp))
								update_class_fields -- Current might have been changed; synchronize
							end
							if l_w = 4 then
								if redirect_cnt < 5 then
									l_tmp___1 := 1
								else
									l_tmp___1 := 3
								end
								((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.ses_goto (l_u.item, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, l_tmp___1, 3, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), (create {P_SESSION_STATIC}).end_load_address, 1)
								update_class_fields -- Current might have been changed; synchronize
								Result := 2
								l_return := True
							end
						end
						if not l_return and then (l_w = 3) then
							if redirect_cnt < 5 then
								if reloadlevel < 3 then
									l_tmp___2 := reloadlevel
								else
									l_tmp___2 := 3
								end
							else
								l_tmp___2 := 3
							end
							((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.ses_goto (l_u.item, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, l_tmp___2, 3, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), (create {P_SESSION_STATIC}).end_load_address, 1)
							update_class_fields -- Current might have been changed; synchronize
							Result := 2
							l_return := True
						end
				when 10 then -- if done | if done
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 11 then -- if: | b:
						if display_timer /= -1 then
							(create {P_SELECT_STATIC}).kill_timer (display_timer)
							update_class_fields -- Current might have been changed; synchronize
							Current.display_timer := -1
							update_class_fields -- Current might have been changed; synchronize
						end
						if wtd = 1 then
							l_tmp___4 := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.ses_chktype (a_stat___0, l_ce)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___4.to_boolean then
								((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.free_wtd
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.reload (1)
								update_class_fields -- Current might have been changed; synchronize
								Result := 2
								l_return := True
							end
						end
				when 12 then -- if done
					if not l_return then
						if wtd = 2 then
							((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.ses_imgmap
							update_class_fields -- Current might have been changed; synchronize
						end
						if wtd = 4 then
							((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.ses_back
							update_class_fields -- Current might have been changed; synchronize
						end
						if wtd = 3 then
							((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.ses_back
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.ses_forward
							update_class_fields -- Current might have been changed; synchronize
						end
						if (a_stat___0.item).item.state >= 0 then
							l_tmp___5 := create {CE_CLASS_POINTER [PD_STATUS]}.make_shared ((create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).c_pointer + (create {PD_LOCATION}.make).offset_of ("stat"))
							a_stat___0.item := l_tmp___5
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_SCHED_STATIC}).change_connection (create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("loading")), l_tmp___5, 0)
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).item.stat.state := loading.state
							update_class_fields -- Current might have been changed; synchronize
						end
						((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.free_wtd
						update_class_fields -- Current might have been changed; synchronize
						Result := 1
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	request_frame (a_name, a_uurl: CE_POINTER [NATURAL_8])
		local
			l_loc: CE_POINTER [PD_LOCATION]
			l_frm: CE_POINTER [PD_FRAME]
			l_url: CE_POINTER [NATURAL_8]
			l_pos___0: CE_POINTER [NATURAL_8]
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_loc := create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)
					if (history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).errline.item := 1_014
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("request_frame: no location"))])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_frm := create {CE_CLASS_POINTER [PD_FRAME]}.make_cast (l_loc.item.frames.next)
				when 2 then -- loop condition:
						if not (not (l_return) and then (not l_frm.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_loc.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames"))))) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						l_tmp := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_frm.item.name), create {CE_INTEGER_8_POINTER}.make_cast (a_name))
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp.to_boolean then
							l_fd := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_cast (scrn_frames.next)
							from
							until
								not (not (l_return) and then (not l_fd.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))))
							loop
								if (l_fd.item.vs).is_equal (create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (l_frm.c_pointer + (create {PD_FRAME}.make).offset_of ("vs"))) then
									if (not ((l_fd.item.f_data).item.frame_desc).is_void) then
										(create {P_SESSION_STATIC}).request_frameset ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), (l_fd.item.f_data).item.frame_desc)
										update_class_fields -- Current might have been changed; synchronize
										l_return := True
									end
								end
								if not l_return then
									l_fd := l_fd.item.next
								end
							end
							if not l_return then
								l_url := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_023, l_frm.item.vs.url)
								update_class_fields -- Current might have been changed; synchronize
								l_pos := -1 + 7 -- goto found
							end
						end
				when 4 then
						if not l_return then
							l_frm := l_frm.item.next
						end
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done | if done
					if not l_return then
						l_url := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_032, a_uurl)
						update_class_fields -- Current might have been changed; synchronize
						l_pos___0 := (create {P_URL_STATIC}).extract_position (l_url)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_url))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_034, ((create {PD_FRAME}.make).structure_size.to_natural_32 + l_tmp___0) + {NATURAL_32} 1)
						update_class_fields -- Current might have been changed; synchronize
						l_frm := create {CE_CLASS_POINTER [PD_FRAME]}.make_cast (l_tmp___1)
						memset (create {CE_VOID_POINTER}.make_cast (l_frm), 0, (create {PD_FRAME}.make).structure_size.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_036, a_name)
						update_class_fields -- Current might have been changed; synchronize
						l_frm.item.name := l_tmp___2
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2.is_void then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_037, create {CE_VOID_POINTER}.make_cast (l_frm))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_038, create {CE_VOID_POINTER}.make_cast (l_url))
							update_class_fields -- Current might have been changed; synchronize
							if (not l_pos___0.is_void) then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_039, create {CE_VOID_POINTER}.make_cast (l_pos___0))
								update_class_fields -- Current might have been changed; synchronize
							end
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 6 then -- if:;
						(create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (l_frm.c_pointer + (create {PD_FRAME}.make).offset_of ("vs"))).item.init_vs (l_url)
						update_class_fields -- Current might have been changed; synchronize
						if (not l_pos___0.is_void) then
							l_frm.item.vs.goto_position := l_pos___0
							update_class_fields -- Current might have been changed; synchronize
						end
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_loc.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))))
							update_class_fields -- Current might have been changed; synchronize
							l_frm.item.next := (create {CE_CLASS_POINTER [PD_FRAME]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_loc.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames"))))).item.next
							update_class_fields -- Current might have been changed; synchronize
							l_frm.item.prev := create {CE_CLASS_POINTER [PD_FRAME]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_loc.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames"))))
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_FRAME]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_loc.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames"))))).item.next := l_frm
							update_class_fields; -- Current might have been changed; synchronize
							(l_frm.item.next).item.prev := l_frm
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_loc.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))))
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
				when 7 then -- found:
						if (l_url.item).to_boolean then
							((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.request_additional_file (l_url, 1).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_047, create {CE_VOID_POINTER}.make_cast (l_url))
						update_class_fields -- Current might have been changed; synchronize
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	display_timer2
		local
			l_t: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_tmp := (create {P_SELECT_STATIC}).get_time
			update_class_fields -- Current might have been changed; synchronize
			l_t := l_tmp;
			((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.html_interpret
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.draw_formatted
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_SELECT_STATIC}).get_time
			update_class_fields -- Current might have been changed; synchronize
			l_t := (l_tmp___0 - l_t) * 20
			if l_t < 200 then
				l_t := (200).to_integer_32
			end
			Current.display_timer := (create {P_SELECT_STATIC}).install_timer (l_t, (display_timer2_address), create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SESSION_STATIC}).load_frames ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), screen)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SESSION_STATIC}).process_file_requests ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)))
			update_class_fields -- Current might have been changed; synchronize
		end

	request_additional_file (a_url: CE_POINTER [NATURAL_8]; a_pri: INTEGER_32): CE_POINTER [PD_FILE_TO_LOAD]
		local
			l_ftl: CE_POINTER [PD_FILE_TO_LOAD]
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			l_ftl := create {CE_CLASS_POINTER [PD_FILE_TO_LOAD]}.make_cast (more_files.next)
			from
			until
				not (not (l_return) and then (not l_ftl.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("more_files")))))
			loop
				l_tmp := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_ftl.item.url), create {CE_INTEGER_8_POINTER}.make_cast (a_url))
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp.to_boolean then
					if l_ftl.item.pri > a_pri then
						l_ftl.item.pri := a_pri
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SCHED_STATIC}).change_connection (create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (l_ftl.c_pointer + (create {PD_FILE_TO_LOAD}.make).offset_of ("stat")), create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (l_ftl.c_pointer + (create {PD_FILE_TO_LOAD}.make).offset_of ("stat")), a_pri)
						update_class_fields -- Current might have been changed; synchronize
					end
					Result := (create {CE_CLASS_POINTER [PD_FILE_TO_LOAD]}.make_shared (default_pointer))
					l_return := True
				end
				if not l_return then
					l_ftl := l_ftl.item.next
				end
			end
			if not l_return then
				l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_142, (create {PD_FILE_TO_LOAD}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_ftl := create {CE_CLASS_POINTER [PD_FILE_TO_LOAD]}.make_cast (l_tmp___0)
				l_ftl.item.url := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_143, a_url)
				update_class_fields -- Current might have been changed; synchronize
				l_ftl.item.stat.end2 := ((create {PD_STATUS_STATIC}).file_end_load_address)
				update_class_fields -- Current might have been changed; synchronize
				l_ftl.item.stat.data := create {CE_VOID_POINTER}.make_cast (l_ftl)
				update_class_fields -- Current might have been changed; synchronize
				l_ftl.item.req_sent := 0
				update_class_fields -- Current might have been changed; synchronize
				l_ftl.item.pri := a_pri
				update_class_fields -- Current might have been changed; synchronize
				l_ftl.item.ce := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_ftl.item.ses := (create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("more_files")))))
					update_class_fields -- Current might have been changed; synchronize
					l_ftl.item.next := (create {CE_CLASS_POINTER [PD_FILE_TO_LOAD]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("more_files"))))).item.next
					update_class_fields -- Current might have been changed; synchronize
					l_ftl.item.prev := create {CE_CLASS_POINTER [PD_FILE_TO_LOAD]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("more_files"))))
					update_class_fields; -- Current might have been changed; synchronize
					(create {CE_CLASS_POINTER [PD_FILE_TO_LOAD]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("more_files"))))).item.next := l_ftl
					update_class_fields; -- Current might have been changed; synchronize
					(l_ftl.item.next).item.prev := l_ftl
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("more_files")))))
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				Result := l_ftl
			end
		end

	request_additional_loading_file (a_url: CE_POINTER [NATURAL_8]; a_stat___0: CE_POINTER [PD_STATUS]; a_pri: INTEGER_32): CE_POINTER [PD_FILE_TO_LOAD]
		local
			l_ftl: CE_POINTER [PD_FILE_TO_LOAD]
			l_return: BOOLEAN
		do
			l_ftl := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.request_additional_file (a_url, a_pri)
			update_class_fields -- Current might have been changed; synchronize
			if l_ftl.is_void then
				(create {P_SCHED_STATIC}).change_connection (a_stat___0, create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
				update_class_fields -- Current might have been changed; synchronize
				Result := (create {CE_CLASS_POINTER [PD_FILE_TO_LOAD]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_ftl.item.req_sent := 1
				update_class_fields -- Current might have been changed; synchronize
				l_ftl.item.ce := a_stat___0.item.ce
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SCHED_STATIC}).change_connection (a_stat___0, create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (l_ftl.c_pointer + (create {PD_FILE_TO_LOAD}.make).offset_of ("stat")), a_pri)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_ftl
			end
		end

	abort_preloading
		do
			if wtd.to_boolean then
				(create {P_SCHED_STATIC}).change_connection (create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("loading")), create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.free_wtd
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	abort_loading
		local
			l_l: CE_POINTER [PD_LOCATION]
		do
			l_l := create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)
			if not l_l.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
				if l_l.item.stat.state >= 0 then
					(create {P_SCHED_STATIC}).change_connection (create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("stat")), create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
					update_class_fields -- Current might have been changed; synchronize
				end
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.abort_files_load
				update_class_fields -- Current might have been changed; synchronize
			end
			((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.abort_preloading
			update_class_fields -- Current might have been changed; synchronize
		end

	reload (a_no_cache: INTEGER_32)
		local
			l_no_cache: INTEGER_32
			l_l: CE_POINTER [PD_LOCATION]
			l_ftl: CE_POINTER [PD_FILE_TO_LOAD]
			l_continue: BOOLEAN
		do
			l_no_cache := a_no_cache;
			((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.abort_loading
			update_class_fields -- Current might have been changed; synchronize
			if l_no_cache = -1 then
				Current.reloadlevel := reloadlevel + 1
				update_class_fields -- Current might have been changed; synchronize
				l_no_cache := reloadlevel
			else
				Current.reloadlevel := l_no_cache
				update_class_fields -- Current might have been changed; synchronize
			end
			l_l := create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)
			if not l_l.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
				l_l.item.stat.data := create {CE_VOID_POINTER}.make_shared (c_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_l.item.stat.end2 := ((create {PD_STATUS_STATIC}).doc_end_load_address)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SCHED_STATIC}).load_url (l_l.item.vs.url, create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("stat")), 0, l_no_cache).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_ftl := create {CE_CLASS_POINTER [PD_FILE_TO_LOAD]}.make_cast (more_files.next)
				from
				until
					l_ftl.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("more_files")))
				loop
					l_continue := False
					if (l_ftl.item.req_sent).to_boolean then
						if l_ftl.item.stat.state >= 0 then
							l_continue := True
						end
					end
					if not (l_continue) then
						l_ftl.item.stat.data := create {CE_VOID_POINTER}.make_cast (l_ftl)
						update_class_fields -- Current might have been changed; synchronize
						l_ftl.item.stat.end2 := ((create {PD_STATUS_STATIC}).file_end_load_address)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SCHED_STATIC}).load_url (l_ftl.item.url, create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (l_ftl.c_pointer + (create {PD_FILE_TO_LOAD}.make).offset_of ("stat")), 1, l_no_cache).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					l_ftl := l_ftl.item.next
				end
				l_continue := False
			end
		end

	go_back
		local
			l_url: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			Current.reloadlevel := 1
			update_class_fields -- Current might have been changed; synchronize
			if wtd.to_boolean then
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.abort_loading
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.print_screen_status
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.reload (1)
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				if (history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
					l_return := True
				elseif (history.next).is_equal (history.prev) then
					l_return := True
				end
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.abort_loading
				update_class_fields -- Current might have been changed; synchronize
				l_url := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_417, ((create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).item.next).item.vs.url)
				update_class_fields -- Current might have been changed; synchronize
				Current.redirect_cnt := 0
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.ses_goto (l_url, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, 0, 4, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), (create {P_SESSION_STATIC}).end_load_address, 0)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	goto_imgmap (a_url, a_href, a_target: CE_POINTER [NATURAL_8])
		do
			if (not imgmap_href_base.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_465, create {CE_VOID_POINTER}.make_cast (imgmap_href_base))
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.imgmap_href_base := a_href
			update_class_fields -- Current might have been changed; synchronize
			if (not imgmap_target_base.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_467, create {CE_VOID_POINTER}.make_cast (imgmap_target_base))
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.imgmap_target_base := a_target
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SESSION_STATIC}).goto_url_w ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), a_url, a_target, 2)
			update_class_fields -- Current might have been changed; synchronize
		end

	ses_find_frame (a_name: CE_POINTER [NATURAL_8]): CE_POINTER [PD_FRAME]
		local
			l_l: CE_POINTER [PD_LOCATION]
			l_frm: CE_POINTER [PD_FRAME]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_l := create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)
			if (history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).errline.item := 1_477
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ses_request_frame: history empty"))])
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := (create {CE_CLASS_POINTER [PD_FRAME]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_frm := create {CE_CLASS_POINTER [PD_FRAME]}.make_cast (l_l.item.frames.prev)
				from
				until
					not (not (l_return) and then (not l_frm.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))))
				loop
					l_tmp := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_frm.item.name), create {CE_INTEGER_8_POINTER}.make_cast (a_name))
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp.to_boolean then
						Result := l_frm
						l_return := True
					end
					if not l_return then
						l_frm := l_frm.item.prev
					end
				end
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_FRAME]}.make_shared (default_pointer))
			end
		end

	ses_change_frame_url (a_name, a_url: CE_POINTER [NATURAL_8]): CE_POINTER [PD_FRAME]
		local
			l_l: CE_POINTER [PD_LOCATION]
			l_frm: CE_POINTER [PD_FRAME]
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_nf: CE_POINTER [PD_FRAME]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: CE_POINTER [PD_FRAME]
			l_tmp___2: NATURAL_32
			l_tmp___3: NATURAL_32
			l_tmp___4: INTEGER_32
			l_return: BOOLEAN
		do
			l_l := create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)
			if (history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).errline.item := 1_490
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ses_change_frame_url: history empty"))])
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := (create {CE_CLASS_POINTER [PD_FRAME]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_frm := create {CE_CLASS_POINTER [PD_FRAME]}.make_cast (l_l.item.frames.prev)
				from
				until
					not (not (l_return) and then (not l_frm.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))))
				loop
					l_tmp___4 := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_frm.item.name), create {CE_INTEGER_8_POINTER}.make_cast (a_name))
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp___4.to_boolean then
						l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_url))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___3 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_frm.item.vs.url)))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2 > l_tmp___3 then
							l_nf := l_frm
							l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_url))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_497, create {CE_VOID_POINTER}.make_cast (l_frm), ((create {PD_FRAME}.make).structure_size.to_natural_32 + l_tmp) + {NATURAL_32} 1)
							update_class_fields -- Current might have been changed; synchronize
							l_nf := create {CE_CLASS_POINTER [PD_FRAME]}.make_cast (l_tmp___0)
							l_tmp___1 := l_nf;
							(l_nf.item.next).item.prev := l_tmp___1
							update_class_fields; -- Current might have been changed; synchronize
							(l_nf.item.prev).item.next := l_tmp___1
							update_class_fields -- Current might have been changed; synchronize
							l_fd := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_cast (scrn_frames.next)
							from
							until
								l_fd.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))
							loop
								if (l_fd.item.vs).is_equal (create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (l_frm.c_pointer + (create {PD_FRAME}.make).offset_of ("vs"))) then
									l_fd.item.vs := create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (l_nf.c_pointer + (create {PD_FRAME}.make).offset_of ("vs"))
									update_class_fields -- Current might have been changed; synchronize
								end
								l_fd := l_fd.item.next
							end
							l_frm := l_nf
						end
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_frm.item.vs.url)), create {CE_INTEGER_8_POINTER}.make_cast (a_url)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Result := l_frm
						l_return := True
					end
					if not l_return then
						l_frm := l_frm.item.prev
					end
				end
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_FRAME]}.make_shared (default_pointer))
			end
		end

	draw_frames
		local
			l_n: INTEGER_32
			l_i: INTEGER_32
			l_d: INTEGER_32
			l_more: INTEGER_32
			l_l: CE_POINTER [INTEGER_32]
			l_f: CE_POINTER [PD_F_DATA_C]
			l_cf: CE_POINTER [PD_F_DATA_C]
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if not ((screen.item.f_data).item.frame).to_boolean then
				l_return := True
			end
			if not l_return then
				l_n := 0
				l_f := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_cast (scrn_frames.next)
				from
				until
					l_f.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))
				loop
					l_tmp := -1
					l_f.item.yl := l_tmp
					update_class_fields -- Current might have been changed; synchronize
					l_f.item.xl := l_tmp
					update_class_fields -- Current might have been changed; synchronize
					l_n := l_n + 1
					l_f := l_f.item.next
				end
				l_l := create {CE_INTEGER_32_POINTER}.make_shared ((create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).c_pointer + (create {PD_LOCATION}.make).offset_of ("vs") + (create {PD_VIEW_STATE}.make).offset_of ("current_link"))
				if l_l.item < 0 then
					l_l.item := 0
					update_class_fields -- Current might have been changed; synchronize
				end
				if not l_n.to_boolean then
					l_n := 1
				end
				l_l.item := l_l.item \\ l_n
				update_class_fields -- Current might have been changed; synchronize
				l_i := l_l.item
				l_cf := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.current_frame
				update_class_fields -- Current might have been changed; synchronize
				l_d := 0
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_more := 0
					l_f := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_cast (scrn_frames.next)
					from
					until
						l_f.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))
					loop
						if l_f.item.depth = l_d then
							(create {P_VIEW_STATIC}).draw_doc (term, l_f, (l_f.is_equal (l_cf)).to_integer)
							update_class_fields -- Current might have been changed; synchronize
						elseif l_f.item.depth > l_d then
							l_more := 1
						end
						l_f := l_f.item.next
					end
					l_d := l_d + 1
					if not l_more.to_boolean then
						l_break := True
					end
				end
				l_break := False
			end
		end

	draw_formatted
		local
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			if screen.is_void then
				term.item.fill_area (0, 1, term.item.x, term.item.y - 2, ((' ').code).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			elseif (screen.item.f_data).is_void then
				term.item.fill_area (0, 1, term.item.x, term.item.y - 2, ((' ').code).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				if (screen.item.vs).is_void then
					if not ((history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history")))) then
						screen.item.vs := create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared ((create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).c_pointer + (create {PD_LOCATION}.make).offset_of ("vs"))
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_tmp := -1
				screen.item.yl := l_tmp
				update_class_fields -- Current might have been changed; synchronize
				screen.item.xl := l_tmp
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_VIEW_STATIC}).draw_doc (term, screen, 1)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.draw_frames
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.print_screen_status
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_TERMINAL_STATIC}).redraw_from_window (win)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	set_frame (a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		local
			l_return: BOOLEAN
		do
			if a_f.is_equal (screen) then
				l_return := True
			end
			if not l_return then
				(create {P_SESSION_STATIC}).goto_url ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), (a_f.item.vs).item.url)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	toggle (a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		local
			l_return: BOOLEAN
		do
			if a_f.is_void then
				l_return := True
			elseif (a_f.item.vs).is_void then
				l_return := True
			end
			if not l_return then
				(a_f.item.vs).item.plain := (not ((a_f.item.vs).item.plain).to_boolean).to_integer
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.html_interpret
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.draw_formatted
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	back (a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		do
			((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.go_back
			update_class_fields -- Current might have been changed; synchronize
		end

	find_next (a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		require
			not a_f.is_void
		local
			l_min: CE_ARRAY [INTEGER_32]
			l_max: CE_ARRAY [INTEGER_32]
			l_c: INTEGER_32
			l_p: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_min.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_max.make (<<1>>)

			l_c := 0
			l_p := (a_f.item.vs).item.view_pos
			if not a_a.to_boolean then
				if (not search_word.is_void) then
					l_tmp := a_f.item.find_next_link_in_search (search_direction)
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp.to_boolean then
						l_return := True
					end
					if not l_return then
						l_p := l_p + (search_direction * a_f.item.yw)
					end
				end
			end
			if not l_return and then (search_word.is_void) then
				if last_search_word.is_void then
					term.item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 92, 1, (create {P_LINKS_STATIC}).dummyarray.item + 207, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
				if not l_return then
					Current.search_word := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_928, last_search_word)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				(a_f.item.f_data).item.get_search_data
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_tmp___0 := is_in_range (a_f.item.f_data, l_p, a_f.item.yw, search_word, l_min, l_max)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___0.to_boolean then
						(a_f.item.vs).item.view_pos := l_p
						update_class_fields -- Current might have been changed; synchronize
						if l_max.item >= l_min.item then
							if l_max.item > (a_f.item.vs).item.view_posx + a_f.item.xw then
								(a_f.item.vs).item.view_posx := l_max.item - a_f.item.xw
								update_class_fields -- Current might have been changed; synchronize
							end
							if l_min.item < (a_f.item.vs).item.view_posx then
								(a_f.item.vs).item.view_posx := l_min.item
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						(a_f.item.vs).item.orig_view_pos := (a_f.item.vs).item.view_pos
						update_class_fields; -- Current might have been changed; synchronize
						(a_f.item.vs).item.orig_view_posx := (a_f.item.vs).item.view_posx
						update_class_fields -- Current might have been changed; synchronize
						a_f.item.set_link
						update_class_fields -- Current might have been changed; synchronize
						a_f.item.find_next_link_in_search (search_direction * 2).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return then
						l_p := l_p + (search_direction * a_f.item.yw)
						if l_p > (a_f.item.f_data).item.y then
							l_p := 0
						end
						if l_p < 0 then
							l_p := 0
							from
							until
								not (l_p < (a_f.item.f_data).item.y)
							loop
								if (a_f.item.yw).to_boolean then
									l_tmp___1 := a_f.item.yw
								else
									l_tmp___1 := 1
								end
								l_p := l_p + l_tmp___1
							end
							l_p := l_p - (a_f.item.yw)
						end
						if (a_f.item.yw).to_boolean then
							l_tmp___2 := a_f.item.yw
						else
							l_tmp___2 := 1
						end
						l_c := l_c + l_tmp___2
						if not (l_c < (a_f.item.f_data).item.y + a_f.item.yw) then
							l_break := True
						end
					end
				end
			end
			if not l_return then
				l_break := False
				term.item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 92, 1, (create {P_LINKS_STATIC}).dummyarray.item + 208, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	find_next_back (a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		require
			not a_f.is_void
		do
			Current.search_direction := -search_direction
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.find_next (a_f, a_a)
			update_class_fields -- Current might have been changed; synchronize
			Current.search_direction := -search_direction
			update_class_fields -- Current might have been changed; synchronize
		end

	rep_ev (a_fd: CE_POINTER [PD_F_DATA_C]; a_f: CE_ROUTINE; a_a: INTEGER_32)
		local
			l_i: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
		do
			if (kbdprefix.rep).to_boolean then
				l_tmp := kbdprefix.rep_num
			else
				l_tmp := 1
			end
			l_i := l_tmp
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp___0 := l_i
				l_i := l_i - 1
				if not l_tmp___0.to_boolean then
					l_break := True
				end
				if not (l_break) then
					a_f.call ([(create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), a_fd, a_a])
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_break := False
		end

	current_frame: CE_POINTER [PD_F_DATA_C]
		local
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_i: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_continue: BOOLEAN
		do
			l_fd := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (default_pointer)
			if (history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
				Result := (create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).item.vs.current_link
				l_fd := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_cast (scrn_frames.next)
				from
				until
					not (not (l_return) and then (not l_fd.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))))
				loop
					l_continue := False
					if (not (l_fd.item.f_data).is_void) then
						if ((l_fd.item.f_data).item.frame).to_boolean then
							l_continue := True
						end
					end
					if not (l_return or l_continue) then
						l_tmp := l_i
						l_i := l_i - 1
						if not l_tmp.to_boolean then
							Result := l_fd
							l_return := True
						end
					end
					if (not l_return) then
						l_fd := l_fd.item.next
					end
				end
			end
			if not l_return then
				l_continue := False
				if screen.is_void then
					Result := (create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (default_pointer))
					l_return := True
				elseif (screen.item.f_data).is_void then
					Result := (create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (default_pointer))
					l_return := True
				elseif ((screen.item.f_data).item.frame).to_boolean then
					Result := (create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				Result := screen
			end
		end

	send_to_frame (a_ev: CE_POINTER [PD_EVENT]): INTEGER_32
		local
			l_r: INTEGER_32
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_return: BOOLEAN
		do
			l_fd := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.current_frame
			update_class_fields -- Current might have been changed; synchronize
			if l_fd.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_r := frame_ev ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), l_fd, a_ev)
				update_class_fields -- Current might have been changed; synchronize
				if l_r = 1 then
					(create {P_VIEW_STATIC}).draw_doc (term, l_fd, 1)
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.print_screen_status
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_TERMINAL_STATIC}).redraw_from_window (win)
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_r
			end
		end

	next_frame (a_p: INTEGER_32)
		local
			l_n: INTEGER_32
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_return: BOOLEAN
		do
			if (history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
				l_return := True
			elseif (not screen.is_void) then
				if (not (screen.item.f_data).is_void) then
					if not ((screen.item.f_data).item.frame).to_boolean then
						l_return := True
					end
				end
			end
			if not l_return then
				l_vs := create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared ((create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).c_pointer + (create {PD_LOCATION}.make).offset_of ("vs"))
				l_n := 0
				l_fd := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_cast (scrn_frames.next)
				from
				until
					l_fd.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))
				loop
					if (not (l_fd.item.f_data).is_void) then
						if not ((l_fd.item.f_data).item.frame).to_boolean then
							l_n := l_n + 1
						end
					else
						l_n := l_n + 1
					end
					l_fd := l_fd.item.next
				end
				l_vs.item.current_link := l_vs.item.current_link + a_p
				update_class_fields -- Current might have been changed; synchronize
				if not l_n.to_boolean then
					l_n := 1
				end
				from
				until
					not (l_vs.item.current_link < 0)
				loop
					l_vs.item.current_link := l_vs.item.current_link + l_n
					update_class_fields -- Current might have been changed; synchronize
				end
				l_vs.item.current_link := l_vs.item.current_link \\ l_n
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	do_for_frame (a_f: CE_ROUTINE; a_a: INTEGER_32)
		local
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_tmp: CE_POINTER [PD_F_DATA_C]
			l_return: BOOLEAN
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.current_frame
			update_class_fields -- Current might have been changed; synchronize
			l_fd := l_tmp
			if l_fd.is_void then
				l_return := True
			end
			if not l_return then
				a_f.call ([(create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), l_fd, a_a])
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_VIEW_STATIC}).draw_doc (term, l_fd, 1)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.print_screen_status
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_TERMINAL_STATIC}).redraw_from_window (win)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	do_mouse_event (a_ev: CE_POINTER [PD_EVENT])
		local
			l_evv: CE_ARRAY [PD_EVENT]
			l_fdd: CE_POINTER [PD_F_DATA_C]
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_tmp: CE_POINTER [PD_F_DATA_C]
			l_o: CE_POINTER [PD_DOCUMENT_OPTIONS]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_EVENT]} l_evv.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.current_frame
					update_class_fields -- Current might have been changed; synchronize
					l_fd := l_tmp
					if l_fd.is_void then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_o := create {CE_CLASS_POINTER [PD_DOCUMENT_OPTIONS]}.make_shared ((l_fd.item.f_data).c_pointer + (create {PD_F_DATA}.make).offset_of ("opt"))
						if a_ev.item.x >= (l_o.item.xp).to_integer_32 then
							if a_ev.item.x < (l_o.item.xp + l_o.item.xw).to_integer_32 then
								if a_ev.item.y >= (l_o.item.yp).to_integer_32 then
									if a_ev.item.y < (l_o.item.yp + l_o.item.yw).to_integer_32 then
										l_pos := -1 + 6 -- goto ok
									end
								end
							end
						end
				when 2 then -- r:;
						((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.next_frame (1)
						update_class_fields -- Current might have been changed; synchronize
						l_fdd := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.current_frame
						update_class_fields -- Current might have been changed; synchronize
						l_o := create {CE_CLASS_POINTER [PD_DOCUMENT_OPTIONS]}.make_shared ((l_fdd.item.f_data).c_pointer + (create {PD_F_DATA}.make).offset_of ("opt"))
						if a_ev.item.x >= (l_o.item.xp).to_integer_32 then
							if a_ev.item.x < (l_o.item.xp + l_o.item.xw).to_integer_32 then
								if a_ev.item.y >= (l_o.item.yp).to_integer_32 then
									if a_ev.item.y < (l_o.item.yp + l_o.item.yw).to_integer_32 then
										((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.draw_formatted
										update_class_fields -- Current might have been changed; synchronize
										l_fd := l_fdd
										l_pos := -1 + 6 -- goto ok
									end
								end
							end
						end
				when 3 then
						if not l_fdd.is_equal (l_fd) then
							l_pos := -1 + 2 -- goto r
						end
				when 4 then
						l_return := True
				when 5 then -- if done
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 6 then -- if: | ok:
						memcpy (create {CE_VOID_POINTER}.make_cast (l_evv), create {CE_VOID_POINTER}.make_cast (a_ev), (create {PD_EVENT}.make).structure_size.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_evv.item.x := l_evv.item.x - (l_fd.item.xp).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_evv.item.y := l_evv.item.y - (l_fd.item.yp).to_integer_32
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.send_to_frame (l_evv).do_nothing
						update_class_fields -- Current might have been changed; synchronize
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	frm_download (a_fd: CE_POINTER [PD_F_DATA_C])
		require
			not a_fd.is_void
		local
			l_link___0: CE_POINTER [PD_LINK]
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			if (a_fd.item.vs).item.current_link = -1 then
				l_return := True
			elseif (a_fd.item.vs).item.current_link >= (a_fd.item.f_data).item.nlinks then
				l_return := True
			end
			if not l_return then
				if (not dn_url.is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_319, create {CE_VOID_POINTER}.make_cast (dn_url))
					update_class_fields -- Current might have been changed; synchronize
					Current.dn_url := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_link___0 := (a_fd.item.f_data).item.links + (a_fd.item.vs).item.current_link
				if l_link___0.item.type /= 0 then
					if l_link___0.item.type /= 1 then
						l_return := True
					end
				end
			end
			if not l_return then
				l_tmp___0 := (create {P_VIEW_STATIC}).get_link_url ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), a_fd, l_link___0)
				update_class_fields -- Current might have been changed; synchronize
				Current.dn_url := l_tmp___0
				update_class_fields -- Current might have been changed; synchronize
				if (not l_tmp___0.is_void) then
					l_tmp := (create {P_LINKS_STATIC}).casecmp (dn_url, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("MAP@")), (4).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp.to_boolean then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_324, create {CE_VOID_POINTER}.make_cast (dn_url))
						update_class_fields -- Current might have been changed; synchronize
						Current.dn_url := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return then
						((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.query_file (dn_url, start_download_address, create {CE_ROUTINE}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
			end
		end

	save_url (a_url: CE_POINTER [NATURAL_8])
		require
			not a_url.is_void
		local
			l_u: CE_POINTER [NATURAL_8]
			l_stat___0: CE_ARRAY [PD_STATUS]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_STATUS]} l_stat___0.make (<<1>>)

			l_u := (create {P_URL_STATIC}).translate_url (a_url, term.item.cwd)
			update_class_fields -- Current might have been changed; synchronize
			if l_u.is_void then
				l_stat___0.item.next := create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_stat___0.item.prev := create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_stat___0.item.c := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_stat___0.item.ce := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_stat___0.item.state := -1_009
				update_class_fields -- Current might have been changed; synchronize
				l_stat___0.item.prev_error := 5
				update_class_fields -- Current might have been changed; synchronize
				l_stat___0.item.pri := 0
				update_class_fields -- Current might have been changed; synchronize
				l_stat___0.item.end2 := create {CE_ROUTINE}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_stat___0.item.data := create {CE_VOID_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_stat___0.item.prg := create {CE_CLASS_POINTER [PD_REMAINING_INFO]}.make_shared (default_pointer)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SESSION_STATIC}).print_error_dialog ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), l_stat___0, (create {P_LINKS_STATIC}).dummyarray.item + 186)
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				if (not dn_url.is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_421, create {CE_VOID_POINTER}.make_cast (dn_url))
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.dn_url := l_u
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.query_file (dn_url, start_download_address, create {CE_ROUTINE}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	save_formatted (a_file: CE_POINTER [NATURAL_8])
		local
			l_h: INTEGER_32
			l_f: CE_POINTER [PD_F_DATA_C]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_f := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.current_frame
			update_class_fields -- Current might have been changed; synchronize
			if (not l_f.is_void) then
				if (l_f.item.f_data).is_void then
					l_return := True
				end
			else
				l_return := True
			end
			if not l_return then
				l_h := create_download_file (term, a_file, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_h < 0 then
					l_return := True
				end
			end
			if not l_return then
				l_tmp := (l_f.item.f_data).item.dump_to_file (l_h)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					term.item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 209, 1, (create {P_LINKS_STATIC}).dummyarray.item + 210, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
					update_class_fields -- Current might have been changed; synchronize
				end
				close (l_h).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	print_current_link: CE_POINTER [NATURAL_8]
		local
			l_tmp: CE_POINTER [PD_F_DATA_C]
			l_tmp___0: CE_POINTER [NATURAL_8]
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.current_frame
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := print_current_linkx (l_tmp, term)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp___0
		end

	print_current_title: CE_POINTER [NATURAL_8]
		local
			l_tmp: CE_POINTER [PD_F_DATA_C]
			l_tmp___0: CE_POINTER [NATURAL_8]
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.current_frame
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := print_current_titlex (l_tmp, term.item.x)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp___0
		end

	state_msg
		local
			l_tmp: CE_POINTER [PD_F_DATA_C]
		do
			if (history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
				loc_msg (term, create {CE_CLASS_POINTER [PD_LOCATION]}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
			else
				l_tmp := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.current_frame
				update_class_fields -- Current might have been changed; synchronize
				loc_msg (term, create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next), l_tmp)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	head_msg
		local
			l_ce: CE_ARRAY [CE_POINTER [PD_CACHE_ENTRY]]
			l_s: CE_POINTER [NATURAL_8]
			l_ss: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: NATURAL_32
			l_tmp___3: NATURAL_32
			l_tmp___4: CE_POINTER [PD_MEMORY_LIST]
			l_tmp___5: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_CACHE_ENTRY]} l_ce.make (<<1>>)

			if (history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
				term.item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 239, 0, (create {P_LINKS_STATIC}).dummyarray.item + 240, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 14, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_tmp___5 := (create {P_CACHE_STATIC}).find_in_cache ((create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (history.next)).item.vs.url, l_ce)
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp___5.to_boolean then
					if (not (l_ce.item.item.head).is_void) then
						l_s := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_708, l_ce.item.item.head)
						update_class_fields -- Current might have been changed; synchronize
						l_ss := l_s
					else
						l_ss := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_709, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
						update_class_fields -- Current might have been changed; synchronize
						l_s := l_ss
					end
					l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))
					update_class_fields -- Current might have been changed; synchronize
					l_len := (l_tmp - {NATURAL_32} 1).to_integer_32
					if l_len > 0 then
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___1 := strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("%R%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_ss := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)
							if l_ss.is_void then
								l_break := True
							end
							if not (l_break) then
								l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ss))
								update_class_fields -- Current might have been changed; synchronize
								memmove (create {CE_VOID_POINTER}.make_cast (l_ss), create {CE_VOID_POINTER}.make_cast ((l_ss + 1)), l_tmp___0).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_s.item).to_boolean then
								l_tmp___3 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))
								update_class_fields -- Current might have been changed; synchronize
								if (l_s[(l_tmp___3 - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 10 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))
								update_class_fields -- Current might have been changed; synchronize
								l_s[(l_tmp___2 - {NATURAL_32} 1).to_integer_32] := (0).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
					end
					l_tmp___4 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_s), create {CE_VOID_POINTER}.make_shared (default_pointer)])
					update_class_fields -- Current might have been changed; synchronize
					term.item.msg_box ([l_tmp___4, (create {P_LINKS_STATIC}).dummyarray.item + 239, 0, l_s, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 14, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	format_frame (a_name, a_url: CE_POINTER [NATURAL_8]; a_o: CE_POINTER [PD_DOCUMENT_OPTIONS]; a_depth___0: INTEGER_32): CE_POINTER [PD_F_DATA_C]
		local
			l_ce: CE_ARRAY [CE_POINTER [PD_CACHE_ENTRY]]
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_fr: CE_POINTER [PD_FRAME]
			l_tmp: INTEGER_32
			l_u: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_CACHE_ENTRY]} l_ce.make (<<1>>)
			create {CE_CLASS_POINTER [PD_F_DATA_C]} l_fd.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start: | repeat:
					l_fr := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.ses_find_frame (a_name)
					update_class_fields -- Current might have been changed; synchronize
					if l_fr.is_void then
						Result := (create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						l_vs := create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (l_fr.c_pointer + (create {PD_FRAME}.make).offset_of ("vs"))
						l_tmp := (create {P_CACHE_STATIC}).find_in_cache (l_vs.item.url, l_ce)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp.to_boolean then
							Result := (create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (default_pointer))
							l_return := True
						elseif (l_ce.item).is_void then
							Result := (create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (default_pointer))
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (not (l_ce.item.item.redirect).is_void) then
							if l_fr.item.redirect_cnt < 10 then
								l_u := (create {P_URL_STATIC}).join_urls (l_vs.item.url, l_ce.item.item.redirect)
								update_class_fields -- Current might have been changed; synchronize
								if (not l_u.is_void) then
									l_fr.item.redirect_cnt := (l_fr.item.redirect_cnt) + 1
									update_class_fields; -- Current might have been changed; synchronize
									((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.ses_change_frame_url (a_name, l_u).do_nothing
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_243, create {CE_VOID_POINTER}.make_cast (l_u))
									update_class_fields -- Current might have been changed; synchronize
									l_pos := -1 + 0 -- goto repeat
								end
							end
						end
				when 2 then
						l_fd := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.find_fd (a_name, a_depth___0, a_o.item.xp, a_o.item.yp)
						update_class_fields -- Current might have been changed; synchronize
						if l_fd.is_void then
							Result := (create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (default_pointer))
							l_return := True
						end
				when 3 then -- if done
					if not l_return then
						(create {P_HTML_R_STATIC}).cached_format_html (l_vs, l_fd, a_o)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_fd
					end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_current_link_url (a_str: CE_POINTER [NATURAL_8]; a_str_size: NATURAL_32): CE_POINTER [NATURAL_8]
		local
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_l: CE_POINTER [PD_LINK]
			l_tmp: CE_POINTER [PD_F_DATA_C]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.current_frame
			update_class_fields -- Current might have been changed; synchronize
			l_fd := l_tmp
			if l_fd.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return and then ((l_fd.item.vs).item.current_link = -1) then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_l := (l_fd.item.f_data).item.links + (l_fd.item.vs).item.current_link
				if l_l.item.type /= 0 then
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				if (not (l_l.item.where).is_void) then
					l_tmp___0 := l_l.item.where
				else
					l_tmp___0 := l_l.item.where_img
				end
				l_tmp___1 := (create {P_LINKS_STATIC}).safe_strncpy (a_str, l_tmp___0, a_str_size)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___1
			end
		end

	search_for_back (a_str: CE_POINTER [NATURAL_8])
		local
			l_f: CE_POINTER [PD_F_DATA_C]
			l_tmp: CE_POINTER [PD_F_DATA_C]
			l_return: BOOLEAN
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.current_frame
			update_class_fields -- Current might have been changed; synchronize
			l_f := l_tmp
			if l_f.is_void then
				l_return := True
			elseif a_str.is_void then
				l_return := True
			elseif not (a_str[0]).to_boolean then
				l_return := True
			end
			if not l_return then
				if (not search_word.is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_848, create {CE_VOID_POINTER}.make_cast (search_word))
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.search_word := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_849, a_str)
				update_class_fields -- Current might have been changed; synchronize
				charset_upcase_string (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("search_word")), (term.item.spec).item.charset)
				update_class_fields -- Current might have been changed; synchronize
				if (not last_search_word.is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_851, create {CE_VOID_POINTER}.make_cast (last_search_word))
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.last_search_word := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_852, search_word)
				update_class_fields -- Current might have been changed; synchronize
				Current.search_direction := -1
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.find_next (l_f, 1)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	search_for (a_str: CE_POINTER [NATURAL_8])
		local
			l_f: CE_POINTER [PD_F_DATA_C]
			l_tmp: CE_POINTER [PD_F_DATA_C]
			l_return: BOOLEAN
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.current_frame
			update_class_fields -- Current might have been changed; synchronize
			l_f := l_tmp
			if l_f.is_void then
				l_return := True
			elseif a_str.is_void then
				l_return := True
			elseif not (a_str[0]).to_boolean then
				l_return := True
			end
			if not l_return then
				if (not search_word.is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_861, create {CE_VOID_POINTER}.make_cast (search_word))
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.search_word := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_862, a_str)
				update_class_fields -- Current might have been changed; synchronize
				charset_upcase_string (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (c_pointer + (create {PD_SESSION}.make).offset_of ("search_word")), (term.item.spec).item.charset)
				update_class_fields -- Current might have been changed; synchronize
				if (not last_search_word.is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_864, create {CE_VOID_POINTER}.make_cast (last_search_word))
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.last_search_word := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_865, search_word)
				update_class_fields -- Current might have been changed; synchronize
				Current.search_direction := 1
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.find_next (l_f, 1)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	goto_link_number (a_num: CE_POINTER [NATURAL_8])
		local
			l_n: INTEGER_32
			l_tmp: INTEGER_32
			l_f: CE_POINTER [PD_F_DATA_C]
			l_tmp___0: CE_POINTER [PD_F_DATA_C]
			l_link___0: CE_POINTER [PD_LINK]
			l_return: BOOLEAN
		do
			l_tmp := atoi (create {CE_INTEGER_8_POINTER}.make_cast (a_num))
			update_class_fields -- Current might have been changed; synchronize
			l_n := l_tmp
			l_tmp___0 := ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer))).item.current_frame
			update_class_fields -- Current might have been changed; synchronize
			l_f := l_tmp___0
			if l_f.is_void then
				l_return := True
			elseif (l_f.item.vs).is_void then
				l_return := True
			end
			if not l_return then
				if l_n < 0 then
					l_return := True
				elseif l_n > (l_f.item.f_data).item.nlinks then
					l_return := True
				end
			end
			if not l_return then
				(l_f.item.vs).item.current_link := l_n - 1
				update_class_fields; -- Current might have been changed; synchronize
				(l_f.item.vs).item.orig_link := (l_f.item.vs).item.current_link
				update_class_fields -- Current might have been changed; synchronize
				l_link___0 := (l_f.item.f_data).item.links + (l_f.item.vs).item.current_link
				l_f.item.check_vs
				update_class_fields; -- Current might have been changed; synchronize
				(l_f.item.vs).item.orig_view_pos := (l_f.item.vs).item.view_pos
				update_class_fields; -- Current might have been changed; synchronize
				(l_f.item.vs).item.orig_view_posx := (l_f.item.vs).item.view_posx
				update_class_fields -- Current might have been changed; synchronize
				if l_link___0.item.type /= 5 then
					if l_link___0.item.type /= 4 then
						enter ((create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (c_pointer)), l_f, 0).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
		end

feature {PD_SESSION_STATIC} -- private routines

	create_download_file (a_term: CE_POINTER [PD_TERMINAL]; a_fi: CE_POINTER [NATURAL_8]; a_safe: INTEGER_32): INTEGER_32
		local
			l_file: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_wd: CE_POINTER [NATURAL_8]
			l_h: INTEGER_32
			l_i: INTEGER_32
			l_sf: INTEGER_32
			l_h___0: CE_POINTER [NATURAL_8]
			l_fl: CE_ARRAY [INTEGER_32]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_msg: CE_POINTER [NATURAL_8]
			l_msge: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_file.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_fl.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_file.item := a_fi
					l_wd := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_sf := a_safe
					if not a_safe.to_boolean then
						l_wd := (create {P_TERMINAL_STATIC}).get_cwd
						set_cwd (a_term.item.cwd)
						if (l_file.item[0]).to_integer_32 = 126 then
							if ((create {P_OS_DEP_STATIC}).dir_sep ((l_file.item[1]).to_integer_8)).to_boolean then
								l_h___0 := create {CE_NATURAL_8_POINTER}.make_cast ((getenv (ce_string ("HOME"))))
								if (not l_h___0.is_void) then
									l_fl.item := 0
									l_file.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 612);
									(create {P_LINKS_STATIC}).add_to_str (l_file, l_fl, l_h___0);
									(create {P_LINKS_STATIC}).add_to_str (l_file, l_fl, a_fi + 1)
								end
							end
						end
					end
					if l_sf.to_boolean then
						l_tmp___1 := 384
					else
						l_tmp___1 := 438
					end
					if a_safe.to_boolean then
						l_tmp___2 := 128
					else
						l_tmp___2 := 0
					end
					l_h := open ([create {CE_INTEGER_8_POINTER}.make_cast (l_file.item), (577).bit_or (l_tmp___2), l_tmp___1])
					if l_h /= -1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (errno_location).item = 17 then
							if a_safe.to_boolean then
								l_h := -2
								l_pos := -1 + 9 -- goto x
							end
						end
				when 2 then
						l_msg := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 625, l_file.item)
						l_msge := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 626, create {CE_NATURAL_8_POINTER}.make_cast ((strerror ((errno_location).item))))
						a_term.item.msg_box ([((create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_msg), l_msge, create {CE_VOID_POINTER}.make_shared (default_pointer)])), (create {P_LINKS_STATIC}).dummyarray.item + 168, 129, (create {P_LINKS_STATIC}).dummyarray.item + 171, ce_string (" "), l_msg, ce_string (": "), l_msge, create {CE_VOID_POINTER}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
						l_pos := -1 + 9 -- goto x
				when 3 then;
					(create {P_OS_DEP_STATIC}).set_bin (l_h)
					if a_safe.to_boolean then
						l_pos := -1 + 9 -- goto x
					end
				when 4 then
					if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_file.item))) >= {NATURAL_32} 1_024 then
						memcpy (create {CE_VOID_POINTER}.make_cast (((create {P_DEFAULT_STATIC}).download_dir.item)), create {CE_VOID_POINTER}.make_cast (l_file.item), (1_023).to_natural_32).do_nothing;
						(create {P_DEFAULT_STATIC}).download_dir.item[1_023] := (0).to_natural_8
					else
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_DEFAULT_STATIC}).download_dir.item)), create {CE_INTEGER_8_POINTER}.make_cast (l_file.item)).do_nothing
					end
					l_i := ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_DEFAULT_STATIC}).download_dir.item)))) - {NATURAL_32} 1).to_integer_32
				when 5 then -- loop condition:
					if not (l_i >= 0) then
						l_pos := -1 + 8 -- skip loop
					end
				when 6 then -- loop body:
						if ((create {P_OS_DEP_STATIC}).dir_sep (((create {P_DEFAULT_STATIC}).download_dir.item[l_i]).to_integer_8)).to_boolean then
							(create {P_DEFAULT_STATIC}).download_dir.item[l_i + 1] := (0).to_natural_8
							l_pos := -1 + 9 -- goto x
						end
				when 7 then
						l_i := l_i - 1
						l_pos := -1 + 5 -- back to loop condition
				when 8 then -- loop done;
					(create {P_DEFAULT_STATIC}).download_dir.item[0] := (0).to_natural_8
				when 9 then -- x:
					if not (l_file.item).is_equal (a_fi) then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 640, create {CE_VOID_POINTER}.make_cast (l_file.item))
					end
					if (not l_wd.is_void) then
						set_cwd (l_wd);
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 641, create {CE_VOID_POINTER}.make_cast (l_wd))
					end
					Result := l_h
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	charset_upcase_string (a_chp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_cp: INTEGER_32)
		require
			not a_chp.is_void
		local
			l_ch: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
		do
			l_ch := a_chp.item
			l_i := 0
			from
			until
				not ((l_ch[l_i]).to_boolean)
			loop
				l_ch[l_i] := (create {P_CHARSETS_STATIC}).charset_upcase (l_ch[l_i], a_cp)
				l_i := l_i + 1
			end
		end

	kill_downloads_to_file (a_file: CE_POINTER [NATURAL_8])
		local
			l_down___0: CE_POINTER [PD_DOWNLOAD]
		do
			l_down___0 := create {CE_CLASS_POINTER [PD_DOWNLOAD]}.make_cast ((create {P_SESSION_STATIC}).downloads.item.item.next)
			from
			until
				l_down___0.is_equal ((create {P_SESSION_STATIC}).downloads.item)
			loop
				if not (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_down___0.item.file), create {CE_INTEGER_8_POINTER}.make_cast (a_file))).to_boolean then
					l_down___0 := l_down___0.item.prev;
					(l_down___0.item.next).item.abort_download
				end
				l_down___0 := l_down___0.item.next
			end
		end

	display_download (a_term: CE_POINTER [PD_TERMINAL]; a_down___0: CE_POINTER [PD_DOWNLOAD]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_dlg: CE_POINTER [PD_DIALOG]
			l_dd: CE_POINTER [PD_DOWNLOAD]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dd := create {CE_CLASS_POINTER [PD_DOWNLOAD]}.make_cast ((create {P_SESSION_STATIC}).downloads.item.item.next)
				when 1 then -- loop condition:
					if l_dd.is_equal ((create {P_SESSION_STATIC}).downloads.item) then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if l_dd.is_equal (a_down___0) then
							l_pos := -1 + 5 -- goto found
						end
				when 3 then
						l_dd := l_dd.item.next
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					l_return := True
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | found:
						l_dlg := create {CE_CLASS_POINTER [PD_DIALOG]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 447, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 3 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)))
						memset (create {CE_VOID_POINTER}.make_cast (l_dlg), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 3 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
						undisplay_download (a_down___0)
						a_down___0.item.ses := a_ses
						l_dlg.item.title := (create {P_LINKS_STATIC}).dummyarray.item + 117
						l_dlg.item.fn := (create {PD_DIALOG_DATA_STATIC}).download_window_function_address
						l_dlg.item.abort := (create {PD_DIALOG_DATA_STATIC}).download_abort_function_address
						l_dlg.item.udata := create {CE_VOID_POINTER}.make_cast (a_down___0)
						l_dlg.item.align := 1
						l_dlg.item.items[0].type := 4
						l_dlg.item.items[0].gid := 3
						l_dlg.item.items[0].fn := (create {PD_DIALOG_DATA_STATIC}).dlg_undisplay_download_address
						l_dlg.item.items[0].text := (create {P_LINKS_STATIC}).dummyarray.item + 164
						l_dlg.item.items[1].type := 4
						l_dlg.item.items[1].gid := 0
						l_dlg.item.items[1].fn := (create {PD_DIALOG_DATA_STATIC}).dlg_abort_download_address
						l_dlg.item.items[1].text := (create {P_LINKS_STATIC}).dummyarray.item + 165
						l_dlg.item.items[2].type := 0
						a_term.item.do_dialog (l_dlg, ((create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_dlg), create {CE_VOID_POINTER}.make_shared (default_pointer)])))
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_mainmenu (a_term: CE_POINTER [PD_TERMINAL]; a_items: CE_POINTER [PD_MENU_ITEM]; a_data: CE_POINTER [ANY]; a_sel: INTEGER_32)
		require
			not a_term.is_void
		local
			l_menu: CE_POINTER [PD_MAINMENU]
			l_ev: CE_ARRAY [PD_EVENT]
			l_win: CE_POINTER [PD_WINDOW]
		do
			create {CE_CLASS_ARRAY [PD_EVENT]} l_ev.make (<<1>>)

			l_menu := create {CE_CLASS_POINTER [PD_MAINMENU]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 291, (create {PD_MAINMENU}.make).structure_size.to_natural_32)))
			if a_sel = -1 then
				l_menu.item.selected := 0
			else
				l_menu.item.selected := a_sel
			end
			l_menu.item.items := a_items
			l_menu.item.data := a_data
			a_term.item.add_window ((create {PD_WINDOW_STATIC}).mainmenu_func_address, create {CE_VOID_POINTER}.make_cast (l_menu))
			if a_sel /= -1 then
				l_ev.item.ev := 1
				l_ev.item.x := 256
				l_ev.item.y := 0
				l_ev.item.b := 0
				l_win := create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast (a_term.item.windows.next);
				(l_win.item.handler).call ([l_win, l_ev, 0])
			end
		end

	get_image_map (a_head___0, a_s, a_eof, a_tag: CE_POINTER [NATURAL_8]; a_menu: CE_POINTER [CE_POINTER [PD_MENU_ITEM]]; a_ml: CE_POINTER [CE_POINTER [PD_MEMORY_LIST]]; a_href_base, a_target_base: CE_POINTER [NATURAL_8]; a_to, a_def, a_hdef: INTEGER_32): INTEGER_32
		require
			not a_menu.is_void
		local
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_name: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_attr: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_al: CE_POINTER [NATURAL_8]
			l_label: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_href: CE_POINTER [NATURAL_8]
			l_target: CE_POINTER [NATURAL_8]
			l_namelen: CE_ARRAY [INTEGER_32]
			l_lblen: CE_ARRAY [INTEGER_32]
			l_ld: CE_POINTER [PD_LINK_DEF]
			l_nm: CE_POINTER [PD_MENU_ITEM]
			l_nmenu: INTEGER_32
			l_i: INTEGER_32
			l_hd: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hdl: CE_ARRAY [INTEGER_32]
			l_ct: CE_POINTER [PD_CONV_TABLE]
			l_ss: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: CE_POINTER [NATURAL_8]
			l_tmp___18: CE_POINTER [NATURAL_8]
			l_ll: CE_POINTER [PD_LINK_DEF]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_name.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_attr.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_label.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_namelen.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_lblen.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_hd.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_hdl.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_ss.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.item := a_s
					l_nmenu := 0
					l_hd.item := ((create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_343))
					l_hdl.item := 0
					if (not a_head___0.is_void) then
						(create {P_LINKS_STATIC}).add_to_str (l_hd, l_hdl, a_head___0)
					end
					(create {P_HTML_STATIC}).scan_http_equiv (l_s.item, a_eof, l_hd, l_hdl, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_ct := (create {P_HTML_R_STATIC}).get_convert_table (l_hd.item, a_to, a_def, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), a_hdef);
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_349, create {CE_VOID_POINTER}.make_cast (l_hd.item))
					a_menu.item := create {CE_CLASS_POINTER [PD_MENU_ITEM]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_350, (create {PD_MENU_ITEM}.make).structure_size.to_natural_32)))
					memset (create {CE_VOID_POINTER}.make_cast (a_menu.item), 0, (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).do_nothing
				when 1 then -- se:
					if (l_break) then
						l_pos := -1 + 5 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if ((l_s.item).c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_s.item.item).to_integer_32 = 60 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | sp:
						l_s.item := l_s.item + 1
				when 4 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 5 then -- loop done
					l_break := False
					if ((l_s.item).c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_359, create {CE_VOID_POINTER}.make_cast (a_menu.item))
						Result := (-1)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 6 then -- if:
						if ((l_s.item + 2).c_pointer.to_integer_32).to_natural_32 <= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_s.item[1]).to_integer_32 = 33 then
								l_s.item := (create {P_HTML_STATIC}).skip_comment (l_s.item, a_eof)
								l_pos := -1 + 1 -- goto se
							elseif (l_s.item[1]).to_integer_32 = 63 then
								l_s.item := (create {P_HTML_STATIC}).skip_comment (l_s.item, a_eof)
								l_pos := -1 + 1 -- goto se
							end
						end
				when 7 then
						if ((create {P_HTML_STATIC}).parse_element (l_s.item, a_eof, l_name, l_namelen, l_attr, l_s)).to_boolean then
							l_pos := -1 + 3 -- goto sp
						end
				when 8 then
						if l_namelen.item /= 3 then
							l_pos := -1 + 1 -- goto se
						elseif ((create {P_LINKS_STATIC}).casecmp (l_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("MAP")), (3).to_natural_32)).to_boolean then
							l_pos := -1 + 1 -- goto se
						end
				when 9 then
						if a_tag.is_void then
							l_pos := -1 + 14 -- skip if block
						end
				when 10 then -- if:
						if not ((a_tag.item).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 11 then -- if:
						l_al := (create {P_HTML_STATIC}).get_attr_val (l_attr.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("name")))
						if l_al.is_void then
							l_pos := -1 + 1 -- goto se
						end
				when 12 then
						if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_al), create {CE_INTEGER_8_POINTER}.make_cast (a_tag))).to_boolean then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_371, create {CE_VOID_POINTER}.make_cast (l_al))
							l_pos := -1 + 1 -- goto se
						end
				when 13 then;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_374, create {CE_VOID_POINTER}.make_cast (l_al))
				when 14 then -- if done | if done
						a_ml.item := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_shared (default_pointer)])
				when 15 then -- se2:
						if (l_break) then
							l_pos := -1 + 19 -- skip loop
						end
				when 16 then -- loop body:
						l_break := False
						if ((l_s.item).c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_s.item.item).to_integer_32 = 60 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | sp2:
						l_s.item := l_s.item + 1
				when 18 then -- if done
						l_pos := -1 + 15 -- back to loop condition
				when 19 then -- loop done
						l_break := False
						if ((l_s.item).c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							(create {P_BFU_STATIC}).freeml (a_ml.item);
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_384, create {CE_VOID_POINTER}.make_cast (a_menu.item))
							Result := (-1)
							l_return := True
						end
				when 20 then -- if done
					if l_return then
						l_pos := -1 + 52 -- skip if block
					end
				when 21 then -- if:
						if ((l_s.item + 2).c_pointer.to_integer_32).to_natural_32 <= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_s.item[1]).to_integer_32 = 33 then
								l_s.item := (create {P_HTML_STATIC}).skip_comment (l_s.item, a_eof)
								l_pos := -1 + 15 -- goto se2
							elseif (l_s.item[1]).to_integer_32 = 63 then
								l_s.item := (create {P_HTML_STATIC}).skip_comment (l_s.item, a_eof)
								l_pos := -1 + 15 -- goto se2
							end
						end
				when 22 then
						if ((create {P_HTML_STATIC}).parse_element (l_s.item, a_eof, l_name, l_namelen, l_attr, l_s)).to_boolean then
							l_pos := -1 + 17 -- goto sp2
						end
				when 23 then
						if l_namelen.item /= 1 then
							l_pos := -1 + 48 -- skip if block
						end
				when 24 then -- if:
						if not (((create {P_LINKS_STATIC}).casecmp (l_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("A")), (1).to_natural_32)).to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 48 -- goto _L___5
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 27 then -- else:
						l_label.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_394)
						l_lblen.item := 0
				when 28 then -- se3:
						l_ss.item := l_s.item
						from
						until
							(l_break)
						loop
							l_break := False
							if ((l_ss.item).c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
								if (l_ss.item.item).to_integer_32 = 60 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_ss.item := l_ss.item + 1
							end
						end
						l_break := False
						if ((l_ss.item).c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_400, create {CE_VOID_POINTER}.make_cast (l_label.item));
							(create {P_BFU_STATIC}).freeml (a_ml.item);
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_402, create {CE_VOID_POINTER}.make_cast (a_menu.item))
							Result := (-1)
							l_return := True
						end
						if l_return then
							l_pos := -1 + 47 -- skip if block
						end
				when 29 then -- if:;
						(create {P_LINKS_STATIC}).add_bytes_to_str (l_label, l_lblen, l_s.item, (l_ss.item).distance ((l_s.item)))
						l_s.item := l_ss.item
						if ((l_s.item + 2).c_pointer.to_integer_32).to_natural_32 <= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_s.item[1]).to_integer_32 = 33 then
								l_s.item := (create {P_HTML_STATIC}).skip_comment (l_s.item, a_eof)
								l_pos := -1 + 28 -- goto se3
							elseif (l_s.item[1]).to_integer_32 = 63 then
								l_s.item := (create {P_HTML_STATIC}).skip_comment (l_s.item, a_eof)
								l_pos := -1 + 28 -- goto se3
							end
						end
				when 30 then
						if ((create {P_HTML_STATIC}).parse_element (l_s.item, a_eof, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), l_ss)).to_boolean then
							l_pos := -1 + 28 -- goto se3
						end
				when 31 then
						if l_namelen.item /= 1 then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						if ((create {P_LINKS_STATIC}).casecmp (l_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("A")), (1).to_natural_32)).to_boolean then
							l_pos := -1 + 34 -- goto _L___3
						end
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 34 then -- else: | _L___3:
						if l_namelen.item /= 2 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						if ((create {P_LINKS_STATIC}).casecmp (l_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/A")), (2).to_natural_32)).to_boolean then
							l_pos := -1 + 37 -- goto _L___2
						end
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 37 then -- else: | _L___2:
						if l_namelen.item /= 3 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if ((create {P_LINKS_STATIC}).casecmp (l_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("MAP")), (3).to_natural_32)).to_boolean then
							l_pos := -1 + 40 -- goto _L___1
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 40 then -- else: | _L___1:
						if l_namelen.item /= 4 then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						if ((create {P_LINKS_STATIC}).casecmp (l_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/MAP")), (4).to_natural_32)).to_boolean then
							l_pos := -1 + 43 -- goto _L___0
						end
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 43 then -- else: | _L___0:
						if l_namelen.item /= 4 then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						if ((create {P_LINKS_STATIC}).casecmp (l_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("AREA")), (4).to_natural_32)).to_boolean then
							l_pos := -1 + 46 -- goto _L
						end
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else: | _L:
						if l_namelen.item = 5 then
							if ((create {P_LINKS_STATIC}).casecmp (l_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/AREA")), (5).to_natural_32)).to_boolean then
								l_s.item := l_ss.item
								l_pos := -1 + 28 -- goto se3
							end
						else
							l_s.item := l_ss.item
							l_pos := -1 + 28 -- goto se3
						end
				when 47 then -- if done | if done | if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 52
				when 48 then -- else: | _L___5:
						if l_namelen.item /= 4 then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						if ((create {P_LINKS_STATIC}).casecmp (l_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("AREA")), (4).to_natural_32)).to_boolean then
							l_pos := -1 + 51 -- goto _L___4
						else
							l_l := ((create {P_HTML_STATIC}).get_attr_val (l_attr.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("alt"))))
							if (not l_l.is_void) then
								l_label.item := (create {P_CHARSETS_STATIC}).convert_string (l_ct, l_l, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_l))).to_integer_32);
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_423, create {CE_VOID_POINTER}.make_cast (l_l))
							else
								l_label.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							end
						end
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 51 then -- else: | _L___4:
						if l_namelen.item = 4 then
							if ((create {P_LINKS_STATIC}).casecmp (l_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/MAP")), (4).to_natural_32)).to_boolean then
								l_pos := -1 + 15 -- goto se2
							else
								l_pos := -1 + 62 -- goto done
							end
						else
							l_pos := -1 + 15 -- goto se2
						end
				when 52 then -- if done | if done
					if l_return then
						l_pos := -1 + 63 -- skip if block
					end
				when 53 then -- if:
						l_href := (create {P_HTML_STATIC}).get_url_val (l_attr.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("href")))
						if l_href.is_void then
							if (not (l_label.item).is_void) then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_428, create {CE_VOID_POINTER}.make_cast (l_label.item))
							end
							l_pos := -1 + 15 -- goto se2
						end
				when 54 then
						l_target := (create {P_HTML_STATIC}).get_target (l_attr.item)
						if l_target.is_void then
							l_target := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_431, a_target_base)
							if l_target.is_void then
								l_target := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_432, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
							end
						end
						l_ld := create {CE_CLASS_POINTER [PD_LINK_DEF]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_433, (create {PD_LINK_DEF}.make).structure_size.to_natural_32)))
						l_tmp___18 := (create {P_URL_STATIC}).join_urls (a_href_base, l_href)
						l_ld.item.link := l_tmp___18
						if (not l_tmp___18.is_void) then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_435, create {CE_VOID_POINTER}.make_cast (l_href));
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_436, create {CE_VOID_POINTER}.make_cast (l_target))
				when 56 then -- f:;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_438, create {CE_VOID_POINTER}.make_cast (l_ld))
						if (not (l_label.item).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_439, create {CE_VOID_POINTER}.make_cast (l_label.item))
						end
						l_pos := -1 + 15 -- goto se2
				when 57 then;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_442, create {CE_VOID_POINTER}.make_cast (l_href))
						l_ld.item.target := l_target
						l_i := 0
				when 58 then -- loop condition:
						if not (l_i < l_nmenu) then
							l_pos := -1 + 61 -- skip loop
						end
				when 59 then -- loop body:
						l_ll := create {CE_CLASS_POINTER [PD_LINK_DEF]}.make_cast ((a_menu.item + l_i).item.data)
						if not (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_ll.item.link), create {CE_INTEGER_8_POINTER}.make_cast (l_ld.item.link))).to_boolean then
							if not (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_ll.item.target), create {CE_INTEGER_8_POINTER}.make_cast (l_ld.item.target))).to_boolean then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_447, create {CE_VOID_POINTER}.make_cast (l_ld.item.link));
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_448, create {CE_VOID_POINTER}.make_cast (l_ld.item.target))
								l_pos := -1 + 56 -- goto f
							end
						end
				when 60 then
						l_i := l_i + 1
						l_pos := -1 + 58 -- back to loop condition
				when 61 then -- loop done
						if (not (l_label.item).is_void) then
							(create {P_HTML_STATIC}).clr_spaces (l_label.item)
						end
						if (not (l_label.item).is_void) then
							if not (l_label.item.item).to_boolean then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_453, create {CE_VOID_POINTER}.make_cast (l_label.item))
								l_label.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							end
						end
						if (l_label.item).is_void then
							l_label.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_454, l_ld.item.link)
						end
						if l_nmenu.to_natural_32 > {NATURAL_32} 2_147_483_647 // (create {PD_MENU_ITEM}.make).structure_size.to_natural_32 - {NATURAL_32} 2 then
							from
							until
								False
							loop
								(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html.c"), 2_455]);
								(create {P_KBD_STATIC}).fatal_tty_exit
								exit (4)
							end
						end
						l_nm := create {CE_CLASS_POINTER [PD_MENU_ITEM]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 2_456, create {CE_VOID_POINTER}.make_cast (a_menu.item), (l_nmenu + 2).to_natural_32 * (create {PD_MENU_ITEM}.make).structure_size.to_natural_32)))
						a_menu.item := l_nm
						memset (create {CE_VOID_POINTER}.make_cast ((l_nm + l_nmenu)), 0, {NATURAL_32} 2 * (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).do_nothing;
						(l_nm + l_nmenu).item.text := l_label.item;
						(l_nm + l_nmenu).item.rtext := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""));
						(l_nm + l_nmenu).item.hotkey := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""));
						(l_nm + l_nmenu).item.func := ((create {P_SESSION_STATIC}).map_selected_address);
						(l_nm + l_nmenu).item.data := create {CE_VOID_POINTER}.make_cast (l_ld)
						l_nmenu := l_nmenu + 1;
						(l_nm + l_nmenu).item.text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
						(create {P_BFU_STATIC}).add_to_ml ([a_ml, l_ld, l_ld.item.link, l_ld.item.target, l_label.item, create {CE_VOID_POINTER}.make_shared (default_pointer)])
						l_pos := -1 + 15 -- goto se2
				when 62 then -- done:;
						(create {P_BFU_STATIC}).add_to_ml ([a_ml, a_menu.item, create {CE_VOID_POINTER}.make_shared (default_pointer)])
						Result := 0
				when 63 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	format_frames (a_ses: CE_POINTER [PD_SESSION]; a_fsd: CE_POINTER [PD_FRAMESET_DESC]; a_op: CE_POINTER [PD_DOCUMENT_OPTIONS]; a_depth___0: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_n: INTEGER_32
			l_o: CE_ARRAY [PD_DOCUMENT_OPTIONS]
			l_fdc: CE_POINTER [PD_F_DATA_C]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_DOCUMENT_OPTIONS]} l_o.make (<<1>>)

			if a_depth___0 > 5 then
				l_return := True
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_o), create {CE_VOID_POINTER}.make_cast (a_op), (create {PD_DOCUMENT_OPTIONS}.make).structure_size.to_natural_32).do_nothing
				if (l_o.item.margin).to_boolean then
					l_o.item.margin := 1
				end
				l_n := 0
				l_j := 0
				from
				until
					not (not (l_return) and then (l_j < a_fsd.item.y))
				loop
					l_o.item.xp := a_op.item.xp
					l_i := 0
					from
					until
						not (l_i < a_fsd.item.x)
					loop
						l_o.item.xw := a_fsd.item.f[l_n].xw
						l_o.item.yw := a_fsd.item.f[l_n].yw
						l_o.item.framename := a_fsd.item.f[l_n].name
						if (not (a_fsd.item.f[l_n].subframe).is_void) then
							format_frames (a_ses, a_fsd.item.f[l_n].subframe, l_o, a_depth___0 + 1)
						elseif (not (a_fsd.item.f[l_n].name).is_void) then
							l_fdc := a_ses.item.format_frame (a_fsd.item.f[l_n].name, a_fsd.item.f[l_n].url, l_o, a_depth___0)
							if (not l_fdc.is_void) then
								if (not (l_fdc.item.f_data).is_void) then
									if ((l_fdc.item.f_data).item.frame).to_boolean then
										format_frames (a_ses, (l_fdc.item.f_data).item.frame_desc, l_o, a_depth___0 + 1)
									end
								end
							end
						end
						l_o.item.xp := l_o.item.xp + (l_o.item.xw + 1)
						l_n := l_n + 1
						l_i := l_i + 1
					end
					l_o.item.yp := l_o.item.yp + (l_o.item.yw + 1)
					l_j := l_j + 1
				end
			end
		end

	check_shell_url (a_url: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_url.is_void
		local
			l_url: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_url := a_url
			from
			until
				not (not (l_return) and then ((l_url.item).to_boolean))
			loop
				if not ((create {P_OS_DEP_STATIC}).is_safe_in_url (l_url.item)).to_boolean then
					Result := (-1)
					l_return := True
				end
				if not l_return then
					l_url := l_url + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	get_stat_msg (a_stat___0: CE_POINTER [PD_STATUS]; a_term: CE_POINTER [PD_TERMINAL]): CE_POINTER [NATURAL_8]
		require
			not a_stat___0.is_void
		local
			l_m: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_m.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)

			if a_stat___0.item.state = 8 then
				if ((a_stat___0.item.prg).item.elapsed // 100).to_boolean then
					l_m.item := ((create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 77))
					l_l.item := 0;
					(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 155, a_term)));
					(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")));
					(create {P_SESSION_STATIC}).add_xnum_to_str (l_m, l_l, (a_stat___0.item.prg).item.pos)
					if (a_stat___0.item.prg).item.size >= 0 then
						(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")));
						(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 156, a_term)));
						(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")));
						(create {P_SESSION_STATIC}).add_xnum_to_str (l_m, l_l, (a_stat___0.item.prg).item.size)
					end
					(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")))
					if (a_stat___0.item.prg).item.elapsed >= 10_000 then
						(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 157, a_term)));
						(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
					end
					(create {P_SESSION_STATIC}).add_xnum_to_str (l_m, l_l, ((((a_stat___0.item.prg).item.loaded).to_integer_64 * {INTEGER_64} 10) // ((a_stat___0.item.prg).item.elapsed // 100).to_integer_64).to_integer_32);
					(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/s")))
					if (a_stat___0.item.prg).item.elapsed >= 10_000 then
						(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")));
						(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 158, a_term)));
						(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")));
						(create {P_SESSION_STATIC}).add_xnum_to_str (l_m, l_l, (a_stat___0.item.prg).item.cur_loaded // 5);
						(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/s")))
					end
					Result := (l_m.item)
					l_return := True
				end
			end
			if not l_return then
				Result := ((create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 95, ((create {P_LANGUAGE_STATIC}).get_text_translation (((create {P_SESSION_STATIC}).get_err_msg (a_stat___0.item.state)), a_term))))
			end
		end

	undisplay_download (a_down___0: CE_POINTER [PD_DOWNLOAD])
		require
			not a_down___0.is_void
		do
			if (not (a_down___0.item.win).is_void) then
				(a_down___0.item.win).item.delete_window
			end
		end

	get_temp_name (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_l: CE_ARRAY [INTEGER_32]
			l_nl: CE_ARRAY [INTEGER_32]
			l_name: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_fn: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_fnn: CE_POINTER [NATURAL_8]
			l_fnnn: CE_POINTER [NATURAL_8]
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_nm: CE_POINTER [NATURAL_8]
			l_directory: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_nl.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_name.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_fn.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s.make (<<1>>)

			l_directory := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_nm := create {CE_NATURAL_8_POINTER}.make_cast ((tempnam (create {CE_INTEGER_8_POINTER}.make_cast (l_directory), ce_string ("links"))))
			if l_nm.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_name.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 660)
				l_nl.item := 0;
				(create {P_LINKS_STATIC}).add_to_str (l_name, l_nl, l_nm)
				free (create {CE_VOID_POINTER}.make_cast (l_nm))
				get_filename_from_url (a_url, l_fn, l_l)
				l_fnnn := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				l_fnn := l_fn.item
				from
				until
					not ((l_fnn.c_pointer.to_integer_32).to_natural_32 < ((l_fn.item + l_l.item).c_pointer.to_integer_32).to_natural_32)
				loop
					if (l_fnn.item).to_integer_32 = 46 then
						l_fnnn := l_fnn
					end
					l_fnn := l_fnn + 1
				end
				if (not l_fnnn.is_void) then
					l_s.item := (create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 668, l_fnnn, l_l.item - (l_fnnn.distance ((l_fn.item))));
					(create {P_OS_DEP_STATIC}).check_shell_security (l_s);
					(create {P_LINKS_STATIC}).add_to_str (l_name, l_nl, l_s.item);
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 671, create {CE_VOID_POINTER}.make_cast (l_s.item))
				end
				Result := (l_name.item)
			end
		end

	get_filename_from_url (a_url: CE_POINTER [NATURAL_8]; a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		require
			not a_s.is_void
			not a_l.is_void
		local
			l_url: CE_POINTER [NATURAL_8]
			l_lo: INTEGER_32
			l_tmp___0: INTEGER_32
			l_uu: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_break: BOOLEAN
		do
			l_url := a_url
			if ((create {P_LINKS_STATIC}).casecmp (l_url, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file://")), (7).to_natural_32)).to_boolean then
				l_tmp___0 := 0
			else
				l_tmp___0 := 1
			end
			l_lo := l_tmp___0
			l_uu := (create {P_URL_STATIC}).get_url_data (l_url)
			if (not l_uu.is_void) then
				l_url := l_uu
			end
			a_s.item := l_url
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_url.item).to_boolean then
					if ((create {P_LINKS_STATIC}).end_of_dir (l_url.item)).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					if l_lo.to_boolean then
						l_tmp___2 := ((create {P_OS_DEP_STATIC}).dir_sep ((l_url.item).to_integer_8))
					else
						l_tmp___2 := ((l_url.item).to_integer_32 = 47).to_integer
					end
					if l_tmp___2.to_boolean then
						a_s.item := l_url + 1
					end
					l_url := l_url + 1
				end
			end
			l_break := False
			a_l.item := l_url.distance ((a_s.item))
		end

	set_cwd (a_path: CE_POINTER [NATURAL_8])
		local
			l_break: BOOLEAN
		do
			if (not a_path.is_void) then
				from
				until
					(l_break)
				loop
					l_break := False
					if (chdir (create {CE_INTEGER_8_POINTER}.make_cast (a_path))).to_boolean then
						if (errno_location).item /= 4 then
							l_break := True
						end
					else
						l_break := True
					end
				end
				l_break := False
			end
		end

	set_terminal_title (a_term: CE_POINTER [PD_TERMINAL]; a_title: CE_POINTER [NATURAL_8])
		require
			not a_term.is_void
			not a_title.is_void
		local
			l_i: INTEGER_32
			l_a: CE_POINTER [NATURAL_8]
			l_b: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i := 0
				when 1 then -- loop condition:
					if not (l_i < 10_000) then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if not (a_title[l_i]).to_boolean then
							l_pos := -1 + 5 -- goto s
						end
				when 3 then
						l_i := l_i + 1
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					a_title[10_000] := (0).to_natural_8
				when 5 then -- s:
					if (not (strchr (create {CE_INTEGER_8_POINTER}.make_cast (a_title), 1)).is_void) then
						l_a := a_title
						l_b := a_title
						from
						until
							not ((l_a.item).to_boolean)
						loop
							if (l_a.item).to_integer_32 /= 1 then
								l_tmp := l_b
								l_b := l_b + 1
								l_tmp.item := l_a.item
							end
							l_a := l_a + 1
						end
						l_b.item := (0).to_natural_8
					end
					if (not (a_term.item.title).is_void) then
						if not (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_title), create {CE_INTEGER_8_POINTER}.make_cast (a_term.item.title))).to_boolean then
							l_pos := -1 + 7 -- goto ret
						end
					end
				when 6 then
					if (not (a_term.item.title).is_void) then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 782, create {CE_VOID_POINTER}.make_cast (a_term.item.title))
					end
					a_term.item.title := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 783, a_title);
					(create {P_TERMINAL_STATIC}).do_terminal_function (a_term, (1).to_natural_8, a_title)
				when 7 then -- ret:;
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 794, create {CE_VOID_POINTER}.make_cast (a_title))
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_type_assoc (a_term: CE_POINTER [PD_TERMINAL]; a_type: CE_POINTER [NATURAL_8]): CE_POINTER [PD_ASSOC]
		local
			l_a: CE_POINTER [PD_ASSOC]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_a := create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast ((create {P_TYPES_STATIC}).assoc.item.item.next)
			from
			until
				not (not (l_return) and then (not l_a.is_equal ((create {P_TYPES_STATIC}).assoc.item)))
			loop
				if l_a.item.system = 1 then
					if ((a_term.item.environment).bit_and (1)).to_boolean then
						l_tmp := l_a.item.xwin
					else
						l_tmp := l_a.item.cons
					end
					if l_tmp.to_boolean then
						if ((create {P_TYPES_STATIC}).is_in_list (l_a.item.ct, a_type, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_type))).to_integer_32)).to_boolean then
							Result := l_a
							l_return := True
						end
					end
				end
				if not l_return then
					l_a := l_a.item.next
				end
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_ASSOC]}.make_shared (default_pointer))
			end
		end

	is_html_type (a_ct: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___3: INTEGER_32
		do
			if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_ct), ce_string ("text/html"))).to_boolean then
				if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_ct), ce_string ("text/x-server-parsed-html"))).to_boolean then
					if ((create {P_LINKS_STATIC}).casecmp (a_ct, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("application/xhtml")), (strlen (ce_string ("application/xhtml"))))).to_boolean then
						l_tmp___3 := 0
					else
						l_tmp___3 := 1
					end
				else
					l_tmp___3 := 1
				end
			else
				l_tmp___3 := 1
			end
			Result := l_tmp___3
		end

	is_in_range (a_f: CE_POINTER [PD_F_DATA]; a_y, a_yw: INTEGER_32; a_txt: CE_POINTER [NATURAL_8]; a_min, a_max: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_found: INTEGER_32
			l_l: INTEGER_32
			l_s1: CE_ARRAY [CE_POINTER [PD_SEARCH]]
			l_s2: CE_ARRAY [CE_POINTER [PD_SEARCH]]
			l_i: INTEGER_32
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_SEARCH]} l_s1.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_SEARCH]} l_s2.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_found := 0
					l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_txt))).to_integer_32
					if (not a_min.is_void) then
						a_min.item := 2_147_483_647
						a_max.item := 0
					elseif (not a_max.is_void) then
						a_min.item := 2_147_483_647
						a_max.item := 0
					end
					if ((create {P_VIEW_STATIC}).get_range (a_f, a_y, a_yw, l_l, l_s1, l_s2)).to_boolean then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not (l_return) and then (((l_s1.item).c_pointer.to_integer_32).to_natural_32 <= ((l_s2.item).c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 17 -- skip loop
						end
				when 2 then -- loop body:
						l_continue := False
						if (l_s1.item.item.c).to_integer_32 = (a_txt[0]).to_integer_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | unable_to_handle_kernel_paging_request___oops:
						l_continue := True
				when 4 then -- if done
						if (l_return or l_continue) then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						l_i := 1
				when 6 then -- loop condition:
						if not (l_i < l_l) then
							l_pos := -1 + 9 -- skip loop
						end
				when 7 then -- loop body:
						if ((l_s1.item + l_i).item.c).to_integer_32 /= (a_txt[l_i]).to_integer_32 then
							l_pos := -1 + 3 -- goto unable_to_handle_kernel_paging_request___oops
						end
				when 8 then
						l_i := l_i + 1
						l_pos := -1 + 6 -- back to loop condition
				when 9 then -- loop done
						l_i := 0
				when 10 then -- loop condition:
						if not (l_i < l_l) then
							l_pos := -1 + 13 -- skip loop
						end
				when 11 then -- loop body:
						if (l_s1.item + l_i).item.y >= a_y then
							if (l_s1.item + l_i).item.y < a_y + a_yw then
								if ((l_s1.item + l_i).item.n).to_boolean then
									l_pos := -1 + 15 -- goto in_view
								end
							end
						end
				when 12 then
						l_i := l_i + 1
						l_pos := -1 + 10 -- back to loop condition
				when 13 then -- loop done
						l_continue := True
				when 14 then -- if done
						if (l_return or l_continue) then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | in_view:
						if a_min.is_void then
							if a_max.is_void then
								Result := 1
								l_return := True
							end
						end
						if not l_return then
							l_found := 1
							l_i := 0
							from
							until
								not (l_i < l_l)
							loop
								if ((l_s1.item + l_i).item.n).to_boolean then
									if (l_s1.item + l_i).item.x < a_min.item then
										a_min.item := (l_s1.item + l_i).item.x
									end
									if (l_s1.item + l_i).item.x + (l_s1.item + l_i).item.n > a_max.item then
										a_max.item := (l_s1.item + l_i).item.x + (l_s1.item + l_i).item.n
									end
								end
								l_i := l_i + 1
							end
						end
				when 16 then -- if done
						if (not l_return) then
							l_s1.item := l_s1.item + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 17 then -- loop done | if done
					if not l_return then
						l_continue := False
						Result := l_found
					end
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	frame_ev (a_ses: CE_POINTER [PD_SESSION]; a_fd: CE_POINTER [PD_F_DATA_C]; a_ev: CE_POINTER [PD_EVENT]): INTEGER_32
		require
			not a_fd.is_void
		local
			l_x: INTEGER_32
			l_tmp___0: INTEGER_32
			l_current_link: CE_POINTER [INTEGER_8]
			l_f_data: CE_POINTER [PD_F_DATA]
			l_nl: INTEGER_32
			l_lnl: INTEGER_32
			l_d: CE_ARRAY [NATURAL_8]
			l_l: CE_POINTER [PD_LINK]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_d.make (<<2>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_x := 1
					if not ((a_fd.item.vs).item.current_link >= 0) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if ((a_fd.item.f_data).item.links + (a_fd.item.vs).item.current_link).item.type /= 4 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if ((a_fd.item.f_data).item.links + (a_fd.item.vs).item.current_link).item.type /= 5 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if ((create {P_VIEW_STATIC}).field_op (a_ses, a_fd, (a_fd.item.f_data).item.links + (a_fd.item.vs).item.current_link, a_ev, 0)).to_boolean then
							Result := 1
							l_return := True
						end
				when 6 then -- if done | if done
					if not (not l_return and then (a_ev.item.ev = 1)) then
						l_pos := -1 + 14 -- skip if block
					end
				when 7 then -- if:
						if not (a_ev.item.x >= (48 + (not (a_ses.item.kbdprefix.rep).to_boolean).to_integer).to_integer_32) then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
						if not (a_ev.item.x <= 57) then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if:
						if ((a_fd.item.f_data).item.opt.num_links).to_boolean then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L___0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 12 then -- else:
						if not ((a_ev.item.y).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L___0:
						if not (a_ses.item.kbdprefix.rep).to_boolean then
							a_ses.item.kbdprefix.rep_num := 0
						end
						l_tmp___0 := (((a_ses.item.kbdprefix.rep_num * 10).to_integer_32 + a_ev.item.x) - 48).to_integer_32
						a_ses.item.kbdprefix.rep_num := l_tmp___0
						if l_tmp___0 > 65_536 then
							a_ses.item.kbdprefix.rep_num := 65_536
						end
						a_ses.item.kbdprefix.rep := 1
						Result := 1
						l_return := True
				when 14 then -- if done | if done | if done | if done
					if l_return then
						l_pos := -1 + 54 -- skip if block
					end
				when 15 then -- if:
						if a_ev.item.ev /= 1 then
							l_pos := -1 + 38 -- skip if block
						end
				when 16 then -- if:
						inspect (a_ev.item.kbd_action (0)) -- switch 1 head
						when 28 then l_pos := -1 + 17
						when 29 then l_pos := -1 + 18
						when 9 then l_pos := -1 + 19
						when 45 then l_pos := -1 + 20
						when 5 then l_pos := -1 + 21
						when 39 then l_pos := -1 + 22
						when 36 then l_pos := -1 + 23
						when 37 then l_pos := -1 + 24
						when 38 then l_pos := -1 + 25
						when 20 then l_pos := -1 + 26
						when 11 then l_pos := -1 + 27
						when 12 then l_pos := -1 + 28
						when 10 then l_pos := -1 + 29
						when 40 then l_pos := -1 + 30
						when 41 then l_pos := -1 + 31
						when 14 then l_pos := -1 + 32
						when 15 then l_pos := -1 + 33
						when 47 then l_pos := -1 + 34
						when 46 then l_pos := -1 + 35
						else l_pos := -1 + 36
						end
				when 17 then -- switch 1, case 28
						a_ses.item.rep_ev (a_fd, page_down_address, 0)
						l_pos := -1 + 37 -- switch 1; break
				when 18 then -- switch 1, case 29
						a_ses.item.rep_ev (a_fd, (create {P_VIEW_STATIC}).page_up_address, 0)
						l_pos := -1 + 37 -- switch 1; break
				when 19 then -- switch 1, case 9
						a_ses.item.rep_ev (a_fd, down_address, 0)
						l_pos := -1 + 37 -- switch 1; break
				when 20 then -- switch 1, case 45
						a_ses.item.rep_ev (a_fd, (create {P_VIEW_STATIC}).up_address, 0)
						l_pos := -1 + 37 -- switch 1; break
				when 21 then -- switch 1, case 5
						l_current_link := create {CE_INTEGER_8_POINTER}.make_cast ((a_ses.item.print_current_link))
						if (not l_current_link.is_void) then
							(create {P_OS_DEP_STATIC}).set_clipboard_text (l_current_link);
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_031, create {CE_VOID_POINTER}.make_cast (l_current_link))
						end
						l_pos := -1 + 37 -- switch 1; break
				when 22 then -- switch 1, case 39
						a_ses.item.rep_ev (a_fd, (create {P_VIEW_STATIC}).scroll_dirty_workaround_for_name_clash_with_libraries_on_macos_address, -1 - (not (a_ses.item.kbdprefix.rep).to_boolean).to_integer)
						l_pos := -1 + 37 -- switch 1; break
				when 23 then -- switch 1, case 36
						a_ses.item.rep_ev (a_fd, (create {P_VIEW_STATIC}).scroll_dirty_workaround_for_name_clash_with_libraries_on_macos_address, 1 + (not (a_ses.item.kbdprefix.rep).to_boolean).to_integer)
						l_pos := -1 + 37 -- switch 1; break
				when 24 then -- switch 1, case 37
						a_ses.item.rep_ev (a_fd, (create {P_VIEW_STATIC}).hscroll_address, -1 - 7 * (not (a_ses.item.kbdprefix.rep).to_boolean).to_integer)
						l_pos := -1 + 37 -- switch 1; break
				when 25 then -- switch 1, case 38
						a_ses.item.rep_ev (a_fd, (create {P_VIEW_STATIC}).hscroll_address, 1 + 7 * (not (a_ses.item.kbdprefix.rep).to_boolean).to_integer)
						l_pos := -1 + 37 -- switch 1; break
				when 26 then -- switch 1, case 20
						a_ses.item.rep_ev (a_fd, (create {P_VIEW_STATIC}).home_address, 0)
						l_pos := -1 + 37 -- switch 1; break
				when 27 then -- switch 1, case 11
						a_ses.item.rep_ev (a_fd, (create {P_VIEW_STATIC}).x_end_address, 0)
						l_pos := -1 + 37 -- switch 1; break
				when 28 then -- switch 1, case 12
						l_x := enter (a_ses, a_fd, 0)
						l_pos := -1 + 37 -- switch 1; break
				when 29 then -- switch 1, case 10
						if not ((create {P_DEFAULT_STATIC}).anonymous.item).to_boolean then
							a_ses.item.frm_download (a_fd)
						end
						l_pos := -1 + 37 -- switch 1; break
				when 30 then -- switch 1, case 40
						a_ses.item.search_dlg (a_fd, 0)
						l_pos := -1 + 37 -- switch 1; break
				when 31 then -- switch 1, case 41
						a_ses.item.search_back_dlg (a_fd, 0)
						l_pos := -1 + 37 -- switch 1; break
				when 32 then -- switch 1, case 14
						a_ses.item.find_next (a_fd, 0)
						l_pos := -1 + 37 -- switch 1; break
				when 33 then -- switch 1, case 15
						a_ses.item.find_next_back (a_fd, 0)
						l_pos := -1 + 37 -- switch 1; break
				when 34 then -- switch 1, case 47
						a_ses.item.set_frame (a_fd, 0)
						l_x := 2
						l_pos := -1 + 37 -- switch 1; break
				when 35 then -- switch 1, case 46
						send_image (a_ses.item.term, create {CE_VOID_POINTER}.make_shared (default_pointer), a_ses)
						l_pos := -1 + 37 -- switch 1; break
				when 36 then -- switch 1, default:
						if a_ev.item.x >= 49 then
							if a_ev.item.x <= 57 then
								if not (a_ev.item.y).to_boolean then
									l_f_data := a_fd.item.f_data
									l_d[0] := (a_ev.item.x).to_natural_8
									l_d[1] := (0).to_natural_8
									l_nl := l_f_data.item.nlinks
									l_lnl := 1
									from
									until
										not (l_nl.to_boolean)
									loop
										l_nl := l_nl // (10)
										l_lnl := l_lnl + 1
									end
									if l_lnl > 1 then
										input_field (a_ses.item.term, create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 258, (create {P_LINKS_STATIC}).dummyarray.item + 259, (create {P_LINKS_STATIC}).dummyarray.item + 14, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_cast (a_ses), create {CE_CLASS_POINTER [PD_HISTORY]}.make_shared (default_pointer), l_lnl, l_d, 1, l_f_data.item.nlinks, (create {P_BFU_STATIC}).check_number_address, (goto_link_number_address), create {CE_ROUTINE}.make_shared (default_pointer))
									end
								else
									l_x := 0
								end
							else
								l_x := 0
							end
						else
							l_x := 0
						end
				when 37 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 53
				when 38 then -- else:
						if a_ev.item.ev /= 2 then
							l_pos := -1 + 52 -- skip if block
						end
				when 39 then -- if:
						l_l := (choose_mouse_link (a_fd, a_ev))
						if l_l.is_void then
							l_pos := -1 + 51 -- skip if block
						end
				when 40 then -- if:
						l_x := 1;
						(a_fd.item.vs).item.current_link := l_l.distance (((a_fd.item.f_data).item.links));
						(a_fd.item.vs).item.orig_link := (a_fd.item.vs).item.current_link
						if l_l.item.type /= 0 then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						l_pos := -1 + 50 -- goto _L___1
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 51
				when 43 then -- else:
						if l_l.item.type /= 1 then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						l_pos := -1 + 50 -- goto _L___1
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 51
				when 46 then -- else:
						if l_l.item.type /= 2 then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						l_pos := -1 + 50 -- goto _L___1
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 51
				when 49 then -- else:
						if l_l.item.type /= 3 then
							l_pos := -1 + 51 -- skip if block
						end
				when 50 then -- if: | _L___1:
						if ((a_ev.item.b).bit_and (12)) = 4 then
							(create {P_VIEW_STATIC}).draw_doc (a_ses.item.term, a_fd, 1)
							a_ses.item.print_screen_status;
							(create {P_TERMINAL_STATIC}).redraw_from_window (a_ses.item.win)
							if ((a_ev.item.b).bit_and (3)) < 1 then
								l_x := enter (a_ses, a_fd, 0)
							else
								link_menu (a_ses.item.term, create {CE_VOID_POINTER}.make_shared (default_pointer), a_ses)
							end
						end
				when 51 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 53
				when 52 then -- else:
						l_x := 0
				when 53 then -- if done
						a_ses.item.kbdprefix.rep := 0
						Result := l_x
				when 54 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	input_field (a_term: CE_POINTER [PD_TERMINAL]; a_ml: CE_POINTER [PD_MEMORY_LIST]; a_title, a_text, a_okbutton, a_cancelbutton: CE_POINTER [NATURAL_8]; a_data: CE_POINTER [ANY]; a_history: CE_POINTER [PD_HISTORY]; a_l: INTEGER_32; a_def: CE_POINTER [NATURAL_8]; a_min, a_max: INTEGER_32; a_check, a_fn, a_cancelfn: CE_ROUTINE)
		require
			not a_term.is_void
		local
			l_ml: CE_ARRAY [CE_POINTER [PD_MEMORY_LIST]]
			l_dlg: CE_POINTER [PD_DIALOG]
			l_field: CE_POINTER [NATURAL_8]
		do
			create {CE_POINTER_ARRAY [PD_MEMORY_LIST]} l_ml.make (<<1>>)

			l_ml.item := a_ml
			if a_l.to_natural_32 > ({NATURAL_32} 2_147_483_647 - (create {PD_DIALOG}.make).structure_size.to_natural_32) + {NATURAL_32} 4 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 1_359]);
					(create {P_KBD_STATIC}).fatal_tty_exit
					exit (4)
				end
			end
			l_dlg := create {CE_CLASS_POINTER [PD_DIALOG]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 1_360, ((create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 4 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32) + a_l.to_natural_32)))
			memset (create {CE_VOID_POINTER}.make_cast (l_dlg), 0, ((create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 4 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32) + a_l.to_natural_32).do_nothing
			l_field := (create {CE_NATURAL_8_POINTER}.make_cast (l_dlg) + ((create {PD_DIALOG}.make).structure_size.to_natural_32).to_integer_32) + ({NATURAL_32} 4 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).to_integer_32
			l_field.item := (0).to_natural_8
			if (not a_def.is_void) then
				if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_def))) + {NATURAL_32} 1 > a_l.to_natural_32 then
					memcpy (create {CE_VOID_POINTER}.make_cast (l_field), create {CE_VOID_POINTER}.make_cast (a_def), (a_l - 1).to_natural_32).do_nothing
				else
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_field), create {CE_INTEGER_8_POINTER}.make_cast (a_def)).do_nothing
				end
			end
			l_dlg.item.title := a_title
			l_dlg.item.fn := (create {PD_DIALOG_DATA_STATIC}).input_field_fn_address
			l_dlg.item.udata := create {CE_VOID_POINTER}.make_cast (a_text)
			l_dlg.item.udata2 := a_data
			l_dlg.item.items[0].type := 2
			l_dlg.item.items[0].gid := a_min
			l_dlg.item.items[0].gnum := a_max
			l_dlg.item.items[0].fn := a_check
			l_dlg.item.items[0].history := a_history
			l_dlg.item.items[0].dlen := a_l
			l_dlg.item.items[0].data := l_field
			l_dlg.item.items[1].type := 4
			l_dlg.item.items[1].gid := 1
			l_dlg.item.items[1].fn := (create {PD_DIALOG_DATA_STATIC}).input_field_ok_address
			l_dlg.item.items[1].dlen := 0
			l_dlg.item.items[1].text := a_okbutton
			l_dlg.item.items[1].udata := create {CE_VOID_POINTER}.make_cast (a_fn)
			l_dlg.item.items[2].type := 4
			l_dlg.item.items[2].gid := 2
			l_dlg.item.items[2].fn := (create {PD_DIALOG_DATA_STATIC}).input_field_cancel_address
			l_dlg.item.items[2].dlen := 0
			l_dlg.item.items[2].text := a_cancelbutton
			l_dlg.item.items[2].udata := create {CE_VOID_POINTER}.make_cast (a_cancelfn)
			l_dlg.item.items[3].type := 0;
			(create {P_BFU_STATIC}).add_to_ml ([l_ml, l_dlg, create {CE_VOID_POINTER}.make_shared (default_pointer)])
			a_term.item.do_dialog (l_dlg, l_ml.item)
		end

	enter (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32): INTEGER_32
		require
			not a_f.is_void
		local
			l_link___0: CE_POINTER [PD_LINK]
			l_u: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_fs: CE_POINTER [PD_FORM_STATE]
			l_fc: CE_POINTER [PD_FORM_CONTROL]
			l_ffs___0: CE_POINTER [PD_FORM_STATE]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_f.item.vs).item.current_link = -1 then
						Result := 1
						l_return := True
					end
					if l_return then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_link___0 := (a_f.item.f_data).item.links + (a_f.item.vs).item.current_link
						if l_link___0.item.type /= 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto submit
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 4 then -- else:
						if l_link___0.item.type /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | submit:
						l_u := (create {P_VIEW_STATIC}).get_link_url (a_ses, a_f, l_link___0)
						if (not l_u.is_void) then
							if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_u))) >= {NATURAL_32} 4 then
								if ((create {P_LINKS_STATIC}).casecmp (l_u, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("MAP@")), (4).to_natural_32)).to_boolean then
									(create {P_SESSION_STATIC}).goto_url_f (a_ses, l_u, l_link___0.item.target)
								else
									l_tmp := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_571, l_link___0.item.target)
									a_ses.item.goto_imgmap (l_u + 4, ((create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_571, l_u + 4)), l_tmp)
								end
							else
								(create {P_SESSION_STATIC}).goto_url_f (a_ses, l_u, l_link___0.item.target)
							end
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_573, create {CE_VOID_POINTER}.make_cast (l_u))
							Result := 2
							l_return := True
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 7 then -- else:
						if l_link___0.item.type /= 4 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 10 then -- else:
						if l_link___0.item.type /= 5 then
							l_pos := -1 + 14 -- skip if block
						end
				when 11 then -- if: | _L:
						if not (has_form_submit (a_f.item.f_data, l_link___0.item.form)).to_boolean then
							l_pos := -1 + 5 -- goto submit
						end
				when 12 then
						down (a_ses, a_f, 0)
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						if l_link___0.item.type = 2 then
							l_fs := (a_f.item.find_form_state (l_link___0.item.form))
							if ((l_link___0.item.form).item.ro).to_boolean then
								Result := 1
								l_return := True
							end
							if not l_return then
								if (l_link___0.item.form).item.type = 5 then
									l_fs.item.state := (not (l_fs.item.state).to_boolean).to_integer
								else
									l_fc := create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_cast ((a_f.item.f_data).item.forms.next)
									from
									until
										l_fc.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((a_f.item.f_data).c_pointer + (create {PD_F_DATA}.make).offset_of ("forms")))
									loop
										if l_fc.item.form_num = (l_link___0.item.form).item.form_num then
											if l_fc.item.type = 6 then
												if not ((create {P_LINKS_STATIC}).xstrcmp (l_fc.item.name, (l_link___0.item.form).item.name)).to_boolean then
													l_ffs___0 := (a_f.item.find_form_state (l_fc))
													if (not l_ffs___0.is_void) then
														l_ffs___0.item.state := 0
													end
												end
											end
										end
										l_fc := l_fc.item.next
									end
									l_fs := a_f.item.find_form_state (l_link___0.item.form)
									l_fs.item.state := 1
								end
							end
						elseif l_link___0.item.type = 3 then
							if ((l_link___0.item.form).item.ro).to_boolean then
								Result := 1
								l_return := True
							end
							if not l_return then
								(a_f.item.f_data).item.refcount := ((a_f.item.f_data).item.refcount) + 1
								add_empty_window (a_ses.item.term, ((create {PD_F_DATA_STATIC}).decrement_fc_refcount_address), create {CE_VOID_POINTER}.make_cast (a_f.item.f_data));
								(a_ses.item.term).item.do_select_submenu ((l_link___0.item.form).item.menu, a_ses)
							end
						else
							from
							until
								False
							loop
								(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c"));
								(create {P_LINKS_STATIC}).errline.item := 1_598;
								(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bad link type %%d")), l_link___0.item.type])
							end
						end
				when 15 then -- if done | if done | if done | if done
					if not l_return then
						Result := 1
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	add_empty_window (a_term: CE_POINTER [PD_TERMINAL]; a_fn: CE_ROUTINE; a_data: CE_POINTER [ANY])
		require
			not a_term.is_void
		local
			l_ewd: CE_POINTER [PD_EWD]
		do
			l_ewd := create {CE_CLASS_POINTER [PD_EWD]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 260, (create {PD_EWD}.make).structure_size.to_natural_32)))
			l_ewd.item.fn := a_fn
			l_ewd.item.data := a_data
			l_ewd.item.b := 0
			a_term.item.add_window ((create {PD_WINDOW_STATIC}).empty_window_handler_address, create {CE_VOID_POINTER}.make_cast (l_ewd))
		end

	down (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		require
			not a_f.is_void
		local
			l_l: INTEGER_32
		do
			l_l := (a_f.item.vs).item.current_link
			if (a_f.item.vs).item.current_link = -1 then
				page_down (a_ses, a_f, 1)
			elseif not (a_f.item.next_in_view ((a_f.item.vs).item.current_link + 1, 1, (create {PD_F_DATA_C_STATIC}).in_viewy_address, (create {PD_F_DATA_C_STATIC}).set_pos_x_address)).to_boolean then
				page_down (a_ses, a_f, 1)
			end
			if l_l /= (a_f.item.vs).item.current_link then
				(create {P_VIEW_STATIC}).set_textarea (a_ses, a_f, 262)
			end
		end

	page_down (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		require
			not a_f.is_void
		do
			if (a_f.item.vs).item.view_pos + (a_f.item.f_data).item.opt.yw < (a_f.item.f_data).item.y then
				(a_f.item.vs).item.view_pos := (a_f.item.vs).item.view_pos + ((a_f.item.f_data).item.opt.yw);
				(a_f.item.vs).item.orig_view_pos := (a_f.item.vs).item.view_pos
				a_f.item.find_link (1, a_a)
			else
				a_f.item.find_link (-1, a_a)
			end
		end

	choose_mouse_link (a_f: CE_POINTER [PD_F_DATA_C]; a_ev: CE_POINTER [PD_EVENT]): CE_POINTER [PD_LINK]
		require
			not a_f.is_void
		local
			l_l1: CE_POINTER [PD_LINK]
			l_l2: CE_POINTER [PD_LINK]
			l_l: CE_POINTER [PD_LINK]
			l_i: INTEGER_32
			l_i___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_l1 := (a_f.item.f_data).item.links + (a_f.item.f_data).item.nlinks
			l_l2 := (a_f.item.f_data).item.links
			if not ((a_f.item.f_data).item.nlinks).to_boolean then
				Result := (create {CE_CLASS_POINTER [PD_LINK]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				if a_ev.item.x < 0 then
					Result := (create {CE_CLASS_POINTER [PD_LINK]}.make_shared (default_pointer))
					l_return := True
				elseif a_ev.item.y < 0 then
					Result := (create {CE_CLASS_POINTER [PD_LINK]}.make_shared (default_pointer))
					l_return := True
				elseif a_ev.item.x >= (a_f.item.xw).to_integer_32 then
					Result := (create {CE_CLASS_POINTER [PD_LINK]}.make_shared (default_pointer))
					l_return := True
				elseif a_ev.item.y >= (a_f.item.yw).to_integer_32 then
					Result := (create {CE_CLASS_POINTER [PD_LINK]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_i := (a_f.item.vs).item.view_pos
				from
				until
					(l_break)
				loop
					l_break := False
					if l_i < (a_f.item.f_data).item.y then
						if not (l_i < (a_f.item.vs).item.view_pos + a_f.item.yw) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						if (not ((a_f.item.f_data).item.lines1[l_i]).is_void) then
							if (((a_f.item.f_data).item.lines1[l_i]).c_pointer.to_integer_32).to_natural_32 < (l_l1.c_pointer.to_integer_32).to_natural_32 then
								l_l1 := (a_f.item.f_data).item.lines1[l_i]
							end
						end
						if (not ((a_f.item.f_data).item.lines2[l_i]).is_void) then
							if (((a_f.item.f_data).item.lines2[l_i]).c_pointer.to_integer_32).to_natural_32 > (l_l2.c_pointer.to_integer_32).to_natural_32 then
								l_l2 := (a_f.item.f_data).item.lines2[l_i]
							end
						end
						l_i := l_i + 1
					end
				end
				l_break := False
				l_l := l_l1
				from
				until
					not (not (l_return) and then ((l_l.c_pointer.to_integer_32).to_natural_32 <= (l_l2.c_pointer.to_integer_32).to_natural_32))
				loop
					l_i___0 := 0
					from
					until
						not (not (l_return) and then (l_i___0 < l_l.item.n))
					loop
						if ((l_l.item.pos + l_i___0).item.x - (a_f.item.vs).item.view_posx).to_integer_32 = a_ev.item.x then
							if ((l_l.item.pos + l_i___0).item.y - (a_f.item.vs).item.view_pos).to_integer_32 = a_ev.item.y then
								Result := l_l
								l_return := True
							end
						end
						if not l_return then
							l_i___0 := l_i___0 + 1
						end
					end
					if not l_return then
						l_l := l_l + 1
					end
				end
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_LINK]}.make_shared (default_pointer))
			end
		end

	send_image (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		require
			not a_ses.is_void
		local
			l_u: CE_POINTER [NATURAL_8]
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_return: BOOLEAN
		do
			l_fd := (a_ses.item.current_frame)
			if l_fd.is_void then
				l_return := True
			end
			if not l_return and then ((l_fd.item.vs).item.current_link = -1) then
				l_return := True
			end
			if not l_return then
				l_u := ((l_fd.item.f_data).item.links + (l_fd.item.vs).item.current_link).item.where_img
				if l_u.is_void then
					l_return := True
				end
			end
			if not l_return then
				(create {P_SESSION_STATIC}).goto_url (a_ses, l_u)
			end
		end

	link_menu (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		require
			not a_ses.is_void
		local
			l_f: CE_POINTER [PD_F_DATA_C]
			l_link___0: CE_POINTER [PD_LINK]
			l_mi: CE_ARRAY [CE_POINTER [PD_MENU_ITEM]]
			l_l: INTEGER_32
			l_c: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_c___0: INTEGER_32
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_MENU_ITEM]} l_mi.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_f := (a_ses.item.current_frame)
					l_l := 0
					l_mi.item := (create {P_BFU_STATIC}).new_menu (1)
					if (l_mi.item).is_void then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 23 -- skip if block
					end
				when 1 then -- if:
						if l_f.is_void then
							l_pos := -1 + 20 -- goto x
						end
				when 2 then
						if (l_f.item.vs).item.current_link = -1 then
							l_pos := -1 + 21 -- goto no_l
						end
				when 3 then
						l_link___0 := (l_f.item.f_data).item.links + (l_f.item.vs).item.current_link
						if l_link___0.item.type /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if (l_link___0.item.where).is_void then
							l_pos := -1 + 9 -- skip if block
						end
				when 5 then -- if:
						l_l := 1
						if not ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_link___0.item.where))) >= {NATURAL_32} 4) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if ((create {P_LINKS_STATIC}).casecmp (l_link___0.item.where, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("MAP@")), (4).to_natural_32)).to_boolean then
							l_pos := -1 + 8 -- goto _L
						else
							(create {P_BFU_STATIC}).add_to_menu (l_mi, (create {P_LINKS_STATIC}).dummyarray.item + 211, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">")), (create {P_LINKS_STATIC}).dummyarray.item + 361, ((create {P_VIEW_STATIC}).send_enter_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 1)
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						l_c := (a_term.item.can_open_in_new);
						(create {P_BFU_STATIC}).add_to_menu (l_mi, (create {P_LINKS_STATIC}).dummyarray.item + 212, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 362, ((create {P_VIEW_STATIC}).send_enter_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
						if l_c.to_boolean then
							if (l_c - 1).to_boolean then
								l_tmp___1 := ce_string (">")
							else
								l_tmp___1 := ce_string ("")
							end
							(create {P_BFU_STATIC}).add_to_menu (l_mi, (create {P_LINKS_STATIC}).dummyarray.item + 213, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1), (create {P_LINKS_STATIC}).dummyarray.item + 363, ((create {PD_TERMINAL_STATIC}).open_in_new_window_address), create {CE_VOID_POINTER}.make_cast (((create {P_VIEW_STATIC}).send_open_in_new_xterm_address)), l_c - 1)
						end
						if not ((create {P_DEFAULT_STATIC}).anonymous.item).to_boolean then
							(create {P_BFU_STATIC}).add_to_menu (l_mi, (create {P_LINKS_STATIC}).dummyarray.item + 214, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("d")), (create {P_LINKS_STATIC}).dummyarray.item + 364, ((create {P_VIEW_STATIC}).send_download_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
						end
				when 9 then -- if done | if done
						if l_link___0.item.type /= 1 then
							l_pos := -1 + 19 -- skip if block
						end
				when 10 then -- if:
						if (l_link___0.item.form).is_void then
							l_pos := -1 + 19 -- skip if block
						end
				when 11 then -- if:
						l_l := 1
						if (l_link___0.item.form).item.type /= 10 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:;
						(create {P_BFU_STATIC}).add_to_menu (l_mi, (create {P_LINKS_STATIC}).dummyarray.item + 215, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 365, ((create {P_VIEW_STATIC}).send_enter_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 14 then -- else:
						if (l_link___0.item.form).item.type /= 8 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L___0
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 17 then -- else:
						if (l_link___0.item.form).item.type /= 9 then
							l_pos := -1 + 19 -- skip if block
						end
				when 18 then -- if: | _L___0:
						l_c___0 := (a_term.item.can_open_in_new);
						(create {P_BFU_STATIC}).add_to_menu (l_mi, (create {P_LINKS_STATIC}).dummyarray.item + 216, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 366, ((create {P_VIEW_STATIC}).send_enter_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
						if l_c___0.to_boolean then
							if (l_link___0.item.form).item.method = 0 then
								if (l_c___0 - 1).to_boolean then
									l_tmp___5 := ce_string (">")
								else
									l_tmp___5 := ce_string ("")
								end
								(create {P_BFU_STATIC}).add_to_menu (l_mi, (create {P_LINKS_STATIC}).dummyarray.item + 217, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___5), (create {P_LINKS_STATIC}).dummyarray.item + 367, ((create {PD_TERMINAL_STATIC}).open_in_new_window_address), create {CE_VOID_POINTER}.make_cast (((create {P_VIEW_STATIC}).send_open_in_new_xterm_address)), l_c___0 - 1)
							end
						end
						if not ((create {P_DEFAULT_STATIC}).anonymous.item).to_boolean then
							(create {P_BFU_STATIC}).add_to_menu (l_mi, (create {P_LINKS_STATIC}).dummyarray.item + 218, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("d")), (create {P_LINKS_STATIC}).dummyarray.item + 368, ((create {P_VIEW_STATIC}).send_download_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
						end
				when 19 then -- if done | if done | if done | if done
						if (not (l_link___0.item.where_img).is_void) then
							l_l := 1;
							(create {P_BFU_STATIC}).add_to_menu (l_mi, (create {P_LINKS_STATIC}).dummyarray.item + 219, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 369, (send_image_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
							if not ((create {P_DEFAULT_STATIC}).anonymous.item).to_boolean then
								(create {P_BFU_STATIC}).add_to_menu (l_mi, (create {P_LINKS_STATIC}).dummyarray.item + 220, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 370, ((create {P_VIEW_STATIC}).send_download_image_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
							end
						end
				when 20 then -- x:
						if l_l.to_boolean then
							l_pos := -1 + 22 -- skip if block
						end
				when 21 then -- if: | no_l:;
						(create {P_BFU_STATIC}).add_to_menu (l_mi, (create {P_LINKS_STATIC}).dummyarray.item + 221, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_BFU_STATIC}).m_bar.item, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
				when 22 then -- if done
						a_term.item.do_menu (l_mi.item, create {CE_VOID_POINTER}.make_cast (a_ses))
				when 23 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	print_current_titlex (a_fd: CE_POINTER [PD_F_DATA_C]; a_w: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_w: INTEGER_32
			l_ml: CE_ARRAY [INTEGER_32]
			l_pl: CE_ARRAY [INTEGER_32]
			l_m: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pp: INTEGER_32
			l_pe: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_ml.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_pl.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_m.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p.make (<<1>>)

			l_w := a_w
			l_ml.item := 0
			l_pl.item := 0
			if a_fd.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_w := l_w - 1
				l_p.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_514)
				if a_fd.item.yw < (a_fd.item.f_data).item.y then
					if (a_fd.item.yw).to_boolean then
						l_pp := ((a_fd.item.vs).item.view_pos + a_fd.item.yw // 2) // a_fd.item.yw + 1
						l_pe := (((a_fd.item.f_data).item.y + a_fd.item.yw) - 1) // a_fd.item.yw
					else
						l_pe := 1
						l_pp := l_pe
					end
					if l_pp > l_pe then
						l_pp := l_pe
					end
					if (a_fd.item.vs).item.view_pos + a_fd.item.yw >= (a_fd.item.f_data).item.y then
						l_pp := l_pe
					end
					if (not ((a_fd.item.f_data).item.title).is_void) then
						(create {P_LINKS_STATIC}).add_chr_to_str (l_p, l_pl, ((' ').code).to_natural_8)
					end
					(create {P_LINKS_STATIC}).add_to_str (l_p, l_pl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("(p")));
					(create {P_LINKS_STATIC}).add_num_to_str (l_p, l_pl, l_pp.to_integer_32);
					(create {P_LINKS_STATIC}).add_to_str (l_p, l_pl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" of ")));
					(create {P_LINKS_STATIC}).add_num_to_str (l_p, l_pl, l_pe.to_integer_32);
					(create {P_LINKS_STATIC}).add_chr_to_str (l_p, l_pl, ((')').code).to_natural_8)
				end
				if ((a_fd.item.f_data).item.title).is_void then
					Result := (l_p.item)
					l_return := True
				end
			end
			if not l_return then
				l_m.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_531);
				(create {P_LINKS_STATIC}).add_to_str (l_m, l_ml, (a_fd.item.f_data).item.title)
				if l_ml.item + l_pl.item > l_w then
					l_ml.item := l_w - l_pl.item
					if l_ml.item < 0 then
						l_ml.item := 0
					end
				end
				(create {P_LINKS_STATIC}).add_to_str (l_m, l_ml, l_p.item);
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_535, create {CE_VOID_POINTER}.make_cast (l_p.item))
				Result := (l_m.item)
			end
		end

	loc_msg (a_term: CE_POINTER [PD_TERMINAL]; a_lo: CE_POINTER [PD_LOCATION]; a_frame: CE_POINTER [PD_F_DATA_C])
		require
			not a_term.is_void
		local
			l_ce: CE_ARRAY [CE_POINTER [PD_CACHE_ENTRY]]
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_a: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_CACHE_ENTRY]} l_ce.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)

			l_l.item := 0
			if a_lo.is_void then
				a_term.item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 238, 0, (create {P_LINKS_STATIC}).dummyarray.item + 240, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 14, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
				l_return := True
			elseif a_frame.is_void then
				a_term.item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 238, 0, (create {P_LINKS_STATIC}).dummyarray.item + 240, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 14, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
				l_return := True
			elseif (a_frame.item.f_data).is_void then
				a_term.item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 238, 0, (create {P_LINKS_STATIC}).dummyarray.item + 240, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 14, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
				l_return := True
			end
			if not l_return then
				l_s.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_633);
				(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 241, a_term)));
				(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (": ")))
				if (not (strchr (create {CE_INTEGER_8_POINTER}.make_cast ((a_lo.item.vs.url)), 1)).is_void) then
					(create {P_LINKS_STATIC}).add_bytes_to_str (l_s, l_l, a_lo.item.vs.url, (create {CE_NATURAL_8_POINTER}.make_cast ((strchr (create {CE_INTEGER_8_POINTER}.make_cast ((a_lo.item.vs.url)), 1)))).distance ((a_lo.item.vs.url)))
				else
					(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, a_lo.item.vs.url)
				end
				if not ((create {P_CACHE_STATIC}).get_cache_entry (a_lo.item.vs.url, l_ce)).to_boolean then
					(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")));
					(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 242, a_term)));
					(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (": ")));
					(create {P_LINKS_STATIC}).add_num_to_str (l_s, l_l, l_ce.item.item.length)
					if (l_ce.item.item.incomplete).to_boolean then
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" (")));
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 243, a_term)));
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (")")))
					end
					(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")));
					(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 244, a_term)));
					(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (": ")));
					(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, ((create {P_CHARSETS_STATIC}).get_cp_name ((a_frame.item.f_data).item.cp)))
					if (a_frame.item.f_data).item.ass = 1 then
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" (")));
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 245, a_term)));
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (")")))
					end
					if (a_frame.item.f_data).item.ass = 2 then
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" (")));
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 246, a_term)));
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (")")))
					end
					l_a := (create {P_HTTP_STATIC}).parse_http_header (l_ce.item.item.head, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Server")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if (not l_a.is_void) then
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")));
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 247, a_term)));
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (": ")));
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, l_a);
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_659, create {CE_VOID_POINTER}.make_cast (l_a))
					end
					l_a := (create {P_HTTP_STATIC}).parse_http_header (l_ce.item.item.head, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Date")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if (not l_a.is_void) then
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")));
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 248, a_term)));
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (": ")));
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, l_a);
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_666, create {CE_VOID_POINTER}.make_cast (l_a))
					end
					if (not (l_ce.item.item.last_modified).is_void) then
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")));
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 249, a_term)));
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (": ")));
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, l_ce.item.item.last_modified)
					end
				end
				l_a := print_current_linkx (a_frame, a_term)
				if (not l_a.is_void) then
					(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N%N")));
					(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 111, a_term)));
					(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (": ")));
					(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, l_a);
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_687, create {CE_VOID_POINTER}.make_cast (l_a))
				end
				a_term.item.msg_box ([((create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_s.item), create {CE_VOID_POINTER}.make_shared (default_pointer)])), (create {P_LINKS_STATIC}).dummyarray.item + 238, 0, l_s.item, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 14, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
			end
		end

	print_current_linkx (a_fd: CE_POINTER [PD_F_DATA_C]; a_term: CE_POINTER [PD_TERMINAL]): CE_POINTER [NATURAL_8]
		local
			l_ll: CE_ARRAY [INTEGER_32]
			l_l: CE_POINTER [PD_LINK]
			l_m: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_ll.make (<<1>>)
			create {CE_CLASS_POINTER [PD_LINK]} l_l.make
			create {CE_POINTER_ARRAY [NATURAL_8]} l_m.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ll.item := 0
					if a_fd.is_void then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						if (a_fd.item.vs).item.current_link = -1 then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						elseif (a_fd.item.vs).item.current_link >= (a_fd.item.f_data).item.nlinks then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						elseif ((a_fd.item.f_data).item.frame).to_boolean then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_l := (a_fd.item.f_data).item.links + (a_fd.item.vs).item.current_link
						if l_l.item.type /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						if (l_l.item.where).is_void then
							if (not (l_l.item.where_img).is_void) then
								l_m.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_549)
								l_ll.item := 0;
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 222, a_term)));
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")));
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, l_l.item.where_img)
								l_pos := -1 + 28 -- goto p
							end
						end
				when 3 then
						if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_l.item.where))) >= {NATURAL_32} 4 then
							if not ((create {P_LINKS_STATIC}).casecmp (l_l.item.where, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("MAP@")), (4).to_natural_32)).to_boolean then
								l_m.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_557)
								l_ll.item := 0;
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 223, a_term)));
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")));
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, l_l.item.where + 4)
								l_pos := -1 + 28 -- goto p
							end
						end
				when 4 then
						l_m.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_564, l_l.item.where)
						l_pos := -1 + 28 -- goto p
				when 5 then
						if (l_l.item.form).is_void then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
				when 6 then -- if done
					if not (not l_return and then (l_l.item.type = 1)) then
						l_pos := -1 + 9 -- skip if block
					end
				when 7 then -- if:
						if (l_l.item.form).item.type = 10 then
							l_m.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_570, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 215, a_term)))
							l_pos := -1 + 28 -- goto p
						end
				when 8 then
						if ((l_l.item.form).item.action).is_void then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return then
							l_m.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_574)
							l_ll.item := 0
							if (l_l.item.form).item.method = 0 then
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 224, a_term)))
							else
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 225, a_term)))
							end
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")));
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, (l_l.item.form).item.action)
							l_pos := -1 + 28 -- goto p
						end
				when 9 then
					if l_return then
						l_pos := -1 + 27 -- skip if block
					end
				when 10 then -- if:
						if l_l.item.type /= 2 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 13 then -- else:
						if l_l.item.type /= 3 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 16 then -- else:
						if l_l.item.type /= 4 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 19 then -- else:
						if l_l.item.type /= 5 then
							l_pos := -1 + 27 -- skip if block
						end
				when 20 then -- if: | _L___0:
						l_m.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_583)
						l_ll.item := 0
						if (l_l.item.form).item.type = 6 then
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 226, a_term)))
						elseif (l_l.item.form).item.type = 5 then
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 227, a_term)))
						elseif (l_l.item.form).item.type = 7 then
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 228, a_term)))
						elseif (l_l.item.form).item.type = 1 then
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 229, a_term)))
						elseif (l_l.item.form).item.type = 4 then
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 230, a_term)))
						elseif (l_l.item.form).item.type = 3 then
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 231, a_term)))
						elseif (l_l.item.form).item.type = 2 then
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 232, a_term)))
						else
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_593, create {CE_VOID_POINTER}.make_cast (l_m.item))
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
						if l_return then
							l_pos := -1 + 27 -- skip if block
						end
				when 21 then -- if:
						if (not ((l_l.item.form).item.name).is_void) then
							if ((l_l.item.form).item.name[0]).to_boolean then
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")));
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 233, a_term)));
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")));
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, (l_l.item.form).item.name)
							end
						end
						if (l_l.item.form).item.type /= 5 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 24 then -- else:
						if (l_l.item.form).item.type /= 6 then
							l_pos := -1 + 26 -- skip if block
						end
				when 25 then -- if: | _L:
						if (not ((l_l.item.form).item.default_value).is_void) then
							if ((l_l.item.form).item.default_value[0]).to_boolean then
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")));
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 234, a_term)));
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")));
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, (l_l.item.form).item.default_value)
							end
						end
				when 26 then -- if done
						if l_l.item.type = 4 then
							if not (has_form_submit (a_fd.item.f_data, l_l.item.form)).to_boolean then
								if (not ((l_l.item.form).item.action).is_void) then
									(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")));
									(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 235, a_term)));
									(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
									if (l_l.item.form).item.method = 0 then
										(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 236, a_term)))
									else
										(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, ((create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 237, a_term)))
									end
									(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")));
									(create {P_LINKS_STATIC}).add_to_str (l_m, l_ll, (l_l.item.form).item.action)
								end
							end
						end
						l_pos := -1 + 28 -- goto p
				when 27 then -- if done | if done | if done | if done | if done
					if l_return then
						l_pos := -1 + 29 -- skip if block
					end
				when 28 then -- if: | p:
						Result := (l_m.item)
				when 29 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	has_form_submit (a_f: CE_POINTER [PD_F_DATA]; a_form___0: CE_POINTER [PD_FORM_CONTROL]): INTEGER_32
		require
			not a_f.is_void
		local
			l_i: CE_POINTER [PD_FORM_CONTROL]
			l_q: INTEGER_32
			l_return: BOOLEAN
		do
			l_q := 0
			l_i := create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_cast (a_f.item.forms.next)
			from
			until
				not (not (l_return) and then (not l_i.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_f.c_pointer + (create {PD_F_DATA}.make).offset_of ("forms")))))
			loop
				if l_i.item.form_num = a_form___0.item.form_num then
					if l_i.item.type = 8 then
						Result := 1
						l_return := True
					elseif l_i.item.type = 9 then
						Result := 1
						l_return := True
					end
					if not l_return then
						l_q := 1
					end
				end
				if not l_return then
					l_i := l_i.item.next
				end
			end
			if not l_return then
				if not l_q.to_boolean then
					from
					until
						False
					loop
						(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c"));
						(create {P_LINKS_STATIC}).errline.item := 1_178;
						(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("form is not on list"))])
					end
				end
				Result := 0
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			history := a_other.history.twin
			term := a_other.term
			win := a_other.win
			id := a_other.id
			screen := a_other.screen
			scrn_frames := a_other.scrn_frames.twin
			loading := a_other.loading.twin
			wtd := a_other.wtd
			wtd_target := a_other.wtd_target
			loading_url := a_other.loading_url
			display_timer := a_other.display_timer
			more_files := a_other.more_files.twin
			goto_position := a_other.goto_position
			imgmap_href_base := a_other.imgmap_href_base
			imgmap_target_base := a_other.imgmap_target_base
			ds := a_other.ds.twin
			kbdprefix := a_other.kbdprefix.twin
			reloadlevel := a_other.reloadlevel
			redirect_cnt := a_other.redirect_cnt
			tq := a_other.tq.twin
			tq_url := a_other.tq_url
			tq_ce := a_other.tq_ce
			tq_goto_position := a_other.tq_goto_position
			tq_prog := a_other.tq_prog
			tq_prog_flags := a_other.tq_prog_flags
			dn_url := a_other.dn_url
			search_word := a_other.search_word
			last_search_word := a_other.last_search_word
			search_direction := a_other.search_direction
			exit_query := a_other.exit_query
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				history.is_equal (a_other.history) and
				term.is_equal (a_other.term) and
				win.is_equal (a_other.win) and
				id = a_other.id and
				screen.is_equal (a_other.screen) and
				scrn_frames.is_equal (a_other.scrn_frames) and
				loading.is_equal (a_other.loading) and
				wtd = a_other.wtd and
				wtd_target.is_equal (a_other.wtd_target) and
				loading_url.is_equal (a_other.loading_url) and
				display_timer = a_other.display_timer and
				more_files.is_equal (a_other.more_files) and
				goto_position.is_equal (a_other.goto_position) and
				imgmap_href_base.is_equal (a_other.imgmap_href_base) and
				imgmap_target_base.is_equal (a_other.imgmap_target_base) and
				ds.is_equal (a_other.ds) and
				kbdprefix.is_equal (a_other.kbdprefix) and
				reloadlevel = a_other.reloadlevel and
				redirect_cnt = a_other.redirect_cnt and
				tq.is_equal (a_other.tq) and
				tq_url.is_equal (a_other.tq_url) and
				tq_ce.is_equal (a_other.tq_ce) and
				tq_goto_position.is_equal (a_other.tq_goto_position) and
				tq_prog.is_equal (a_other.tq_prog) and
				tq_prog_flags = a_other.tq_prog_flags and
				dn_url.is_equal (a_other.dn_url) and
				search_word.is_equal (a_other.search_word) and
				last_search_word.is_equal (a_other.last_search_word) and
				search_direction = a_other.search_direction and
				exit_query = a_other.exit_query
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("history"),
					create {CE_STRUCTURE_FIELD}.make ("term"),
					create {CE_STRUCTURE_FIELD}.make ("win"),
					create {CE_STRUCTURE_FIELD}.make ("id"),
					create {CE_STRUCTURE_FIELD}.make ("screen"),
					create {CE_STRUCTURE_FIELD}.make ("scrn_frames"),
					create {CE_STRUCTURE_FIELD}.make ("loading"),
					create {CE_STRUCTURE_FIELD}.make ("wtd"),
					create {CE_STRUCTURE_FIELD}.make ("wtd_target"),
					create {CE_STRUCTURE_FIELD}.make ("loading_url"),
					create {CE_STRUCTURE_FIELD}.make ("display_timer"),
					create {CE_STRUCTURE_FIELD}.make ("more_files"),
					create {CE_STRUCTURE_FIELD}.make ("goto_position"),
					create {CE_STRUCTURE_FIELD}.make ("imgmap_href_base"),
					create {CE_STRUCTURE_FIELD}.make ("imgmap_target_base"),
					create {CE_STRUCTURE_FIELD}.make ("ds"),
					create {CE_STRUCTURE_FIELD}.make ("kbdprefix"),
					create {CE_STRUCTURE_FIELD}.make ("reloadlevel"),
					create {CE_STRUCTURE_FIELD}.make ("redirect_cnt"),
					create {CE_STRUCTURE_FIELD}.make ("tq"),
					create {CE_STRUCTURE_FIELD}.make ("tq_url"),
					create {CE_STRUCTURE_FIELD}.make ("tq_ce"),
					create {CE_STRUCTURE_FIELD}.make ("tq_goto_position"),
					create {CE_STRUCTURE_FIELD}.make ("tq_prog"),
					create {CE_STRUCTURE_FIELD}.make ("tq_prog_flags"),
					create {CE_STRUCTURE_FIELD}.make ("dn_url"),
					create {CE_STRUCTURE_FIELD}.make ("search_word"),
					create {CE_STRUCTURE_FIELD}.make ("last_search_word"),
					create {CE_STRUCTURE_FIELD}.make ("search_direction"),
					create {CE_STRUCTURE_FIELD}.make ("exit_query")
				>>)
			init_structure_info
		end

end
