class
	PD_TERMINAL

inherit
	PD_TERMINAL_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_UNISTD_STATIC
		redefine
			copy,
			is_equal
		end
	S_BITS_ERRNO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_TERMINAL]} next.make
			create {CE_CLASS_POINTER [PD_TERMINAL]} prev.make
			create {CE_NATURAL_8_ARRAY} term.make (<<32>>)
			create {CE_NATURAL_8_ARRAY} cwd.make (<<256>>)
			create {CE_NATURAL_32_POINTER} screen.make
			create {CE_NATURAL_32_POINTER} last_screen.make
			create {CE_CLASS_POINTER [PD_TERM_SPEC]} spec.make
			create {CE_NATURAL_8_POINTER} input_queue.make
			create windows.make
			create {CE_NATURAL_8_POINTER} title.make
			Precursor
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_TERMINAL] assign set_next

	prev: CE_POINTER [PD_TERMINAL] assign set_prev

	master: INTEGER_32 assign set_master

	fdin: INTEGER_32 assign set_fdin

	fdout: INTEGER_32 assign set_fdout

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	environment: INTEGER_32 assign set_environment

	term: CE_ARRAY [NATURAL_8]

	cwd: CE_ARRAY [NATURAL_8]

	screen: CE_POINTER [NATURAL_32] assign set_screen

	last_screen: CE_POINTER [NATURAL_32] assign set_last_screen

	spec: CE_POINTER [PD_TERM_SPEC] assign set_spec

	cx: INTEGER_32 assign set_cx

	cy: INTEGER_32 assign set_cy

	lcx: INTEGER_32 assign set_lcx

	lcy: INTEGER_32 assign set_lcy

	dirty: INTEGER_32 assign set_dirty

	redrawing: INTEGER_32 assign set_redrawing

	blocked: INTEGER_32 assign set_blocked

	input_queue: CE_POINTER [NATURAL_8] assign set_input_queue

	qlen: INTEGER_32 assign set_qlen

	windows: PD_LIST_HEAD assign set_windows

	title: CE_POINTER [NATURAL_8] assign set_title

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_TERMINAL])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_TERMINAL])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_master (a_master: INTEGER_32)
		do
			master := a_master
			update_memory_field ("master")
		end

	set_fdin (a_fdin: INTEGER_32)
		do
			fdin := a_fdin
			update_memory_field ("fdin")
		end

	set_fdout (a_fdout: INTEGER_32)
		do
			fdout := a_fdout
			update_memory_field ("fdout")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_environment (a_environment: INTEGER_32)
		do
			environment := a_environment
			update_memory_field ("environment")
		end

	set_screen (a_screen: CE_POINTER [NATURAL_32])
		do
			screen := a_screen
			update_memory_field ("screen")
		end

	set_last_screen (a_last_screen: CE_POINTER [NATURAL_32])
		do
			last_screen := a_last_screen
			update_memory_field ("last_screen")
		end

	set_spec (a_spec: CE_POINTER [PD_TERM_SPEC])
		do
			spec := a_spec
			update_memory_field ("spec")
		end

	set_cx (a_cx: INTEGER_32)
		do
			cx := a_cx
			update_memory_field ("cx")
		end

	set_cy (a_cy: INTEGER_32)
		do
			cy := a_cy
			update_memory_field ("cy")
		end

	set_lcx (a_lcx: INTEGER_32)
		do
			lcx := a_lcx
			update_memory_field ("lcx")
		end

	set_lcy (a_lcy: INTEGER_32)
		do
			lcy := a_lcy
			update_memory_field ("lcy")
		end

	set_dirty (a_dirty: INTEGER_32)
		do
			dirty := a_dirty
			update_memory_field ("dirty")
		end

	set_redrawing (a_redrawing: INTEGER_32)
		do
			redrawing := a_redrawing
			update_memory_field ("redrawing")
		end

	set_blocked (a_blocked: INTEGER_32)
		do
			blocked := a_blocked
			update_memory_field ("blocked")
		end

	set_input_queue (a_input_queue: CE_POINTER [NATURAL_8])
		do
			input_queue := a_input_queue
			update_memory_field ("input_queue")
		end

	set_qlen (a_qlen: INTEGER_32)
		do
			qlen := a_qlen
			update_memory_field ("qlen")
		end

	set_windows (a_windows: PD_LIST_HEAD)
		do
			windows := a_windows
			update_memory_field ("windows")
		end

	set_title (a_title: CE_POINTER [NATURAL_8])
		do
			title := a_title
			update_memory_field ("title")
		end

feature {PD_TERMINAL} -- private attributes

	resize_texts: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					(create {P_LINKS_STATIC}).dummyarray.item + 261,
					(create {P_LINKS_STATIC}).dummyarray.item + 262
				>>)
		end

	setup_menu: CE_STATIC [CE_ARRAY [PD_MENU_ITEM]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MENU_ITEM]}.make_initialized (<<
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 250, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">")), (create {P_LINKS_STATIC}).dummyarray.item + 347, ((create {P_MENU_STATIC}).menu_language_list_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 1, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 103, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">")), (create {P_LINKS_STATIC}).dummyarray.item + 348, ((create {P_MENU_STATIC}).charset_list_address), create {CE_VOID_POINTER}.make_shared (default_pointer + 1), 1, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 56, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 349, (terminal_options_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 67, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 350, net_options_address, create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 104, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 351, cache_opt_address, create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 105, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 325, net_programs_address, create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 106, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">")), (create {P_LINKS_STATIC}).dummyarray.item + 352, (do_menu_address), create {CE_VOID_POINTER}.make_cast (assoc_menu.item), 1, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 107, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">")), (create {P_LINKS_STATIC}).dummyarray.item + 353, (do_menu_address), create {CE_VOID_POINTER}.make_cast (ext_menu.item), 1, 0]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_BFU_STATIC}).m_bar.item, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 108, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 354, ((create {P_DEFAULT_STATIC}).write_config_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0])
				>>)
		end

	file_menu21: CE_STATIC [CE_ARRAY [PD_MENU_ITEM]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MENU_ITEM]}.make_initialized (<<
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_BFU_STATIC}).m_bar.item, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 84, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 318, ((create {P_VIEW_STATIC}).save_as_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 85, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 319, ((create {P_MENU_STATIC}).menu_save_url_as_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 86, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 320, ((create {P_VIEW_STATIC}).menu_save_formatted_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0])
				>>)
		end

	td_labels: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					(create {P_LINKS_STATIC}).dummyarray.item + 47,
					(create {P_LINKS_STATIC}).dummyarray.item + 48,
					(create {P_LINKS_STATIC}).dummyarray.item + 49,
					(create {P_LINKS_STATIC}).dummyarray.item + 50,
					(create {P_LINKS_STATIC}).dummyarray.item + 51,
					(create {P_LINKS_STATIC}).dummyarray.item + 52,
					(create {P_LINKS_STATIC}).dummyarray.item + 53,
					(create {P_LINKS_STATIC}).dummyarray.item + 54,
					(create {P_LINKS_STATIC}).dummyarray.item + 55,
					create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				>>)
		end

	cache_texts: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					(create {P_LINKS_STATIC}).dummyarray.item + 68,
					(create {P_LINKS_STATIC}).dummyarray.item + 69
				>>)
		end

	html_texts: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					(create {P_LINKS_STATIC}).dummyarray.item + 71,
					(create {P_LINKS_STATIC}).dummyarray.item + 72,
					(create {P_LINKS_STATIC}).dummyarray.item + 73,
					(create {P_LINKS_STATIC}).dummyarray.item + 74,
					(create {P_LINKS_STATIC}).dummyarray.item + 75,
					(create {P_LINKS_STATIC}).dummyarray.item + 76,
					create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")),
					(create {P_LINKS_STATIC}).dummyarray.item + 77
				>>)
		end

	file_menu11: CE_STATIC [CE_ARRAY [PD_MENU_ITEM]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MENU_ITEM]}.make_initialized (<<
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 80, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("g")), (create {P_LINKS_STATIC}).dummyarray.item + 314, ((create {P_MENU_STATIC}).menu_goto_url_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 81, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<-")), (create {P_LINKS_STATIC}).dummyarray.item + 315, ((create {P_MENU_STATIC}).menu_go_back_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 82, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">")), (create {P_LINKS_STATIC}).dummyarray.item + 316, ((create {P_MENU_STATIC}).history_menu_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 1, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 83, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Ctrl-R")), (create {P_LINKS_STATIC}).dummyarray.item + 317, ((create {P_MENU_STATIC}).menu_reload_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0])
				>>)
		end

	file_menu12: CE_STATIC [CE_ARRAY [PD_MENU_ITEM]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MENU_ITEM]}.make_initialized (<<
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 263, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("s")), (create {P_LINKS_STATIC}).dummyarray.item + 313, (menu_bookmark_manager_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 264, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("a")), (create {P_LINKS_STATIC}).dummyarray.item + 312, (launch_bm_add_doc_dialog_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0])
				>>)
		end

	file_menu22: CE_STATIC [CE_ARRAY [PD_MENU_ITEM]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MENU_ITEM]}.make_initialized (<<
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_BFU_STATIC}).m_bar.item, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 87, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 321, (create {P_MENU_STATIC}).menu_kill_background_connections_address, create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 88, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 322, (create {P_MENU_STATIC}).flush_caches_address, create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 89, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 323, (cache_inf_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 43, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 326, (memory_info_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_BFU_STATIC}).m_bar.item, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0])
				>>)
		end

	file_menu3: CE_STATIC [CE_ARRAY [PD_MENU_ITEM]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MENU_ITEM]}.make_initialized (<<
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_BFU_STATIC}).m_bar.item, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 91, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("q")), (create {P_LINKS_STATIC}).dummyarray.item + 329, ((create {P_MENU_STATIC}).exit_prog_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0])
				>>)
		end

	view_menu: CE_STATIC [CE_ARRAY [PD_MENU_ITEM]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MENU_ITEM]}.make_initialized (<<
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 92, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")), (create {P_LINKS_STATIC}).dummyarray.item + 330, ((create {P_MENU_STATIC}).menu_for_frame_address), create {CE_VOID_POINTER}.make_cast (((create {PD_SESSION_STATIC}).search_dlg_address)), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 93, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("?")), (create {P_LINKS_STATIC}).dummyarray.item + 331, ((create {P_MENU_STATIC}).menu_for_frame_address), create {CE_VOID_POINTER}.make_cast (((create {PD_SESSION_STATIC}).search_back_dlg_address)), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 94, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("n")), (create {P_LINKS_STATIC}).dummyarray.item + 332, ((create {P_MENU_STATIC}).menu_for_frame_address), create {CE_VOID_POINTER}.make_cast (((create {PD_SESSION_STATIC}).find_next_address)), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 95, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("N")), (create {P_LINKS_STATIC}).dummyarray.item + 333, ((create {P_MENU_STATIC}).menu_for_frame_address), create {CE_VOID_POINTER}.make_cast (((create {PD_SESSION_STATIC}).find_next_back_address)), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_BFU_STATIC}).m_bar.item, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 96, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("\")), (create {P_LINKS_STATIC}).dummyarray.item + 334, ((create {P_MENU_STATIC}).menu_toggle_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 97, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("=")), (create {P_LINKS_STATIC}).dummyarray.item + 335, ((create {P_MENU_STATIC}).menu_doc_info_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 239, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("|")), (create {P_LINKS_STATIC}).dummyarray.item + 336, ((create {P_MENU_STATIC}).menu_head_info_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 98, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("f")), (create {P_LINKS_STATIC}).dummyarray.item + 337, ((create {P_MENU_STATIC}).menu_for_frame_address), create {CE_VOID_POINTER}.make_cast (((create {PD_SESSION_STATIC}).set_frame_address)), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_BFU_STATIC}).m_bar.item, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 78, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 338, (menu_html_options_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 99, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 339, ((create {P_MENU_STATIC}).menu_save_html_options_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0])
				>>)
		end

	view_menu_anon: CE_STATIC [CE_ARRAY [PD_MENU_ITEM]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MENU_ITEM]}.make_initialized (<<
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 92, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")), (create {P_LINKS_STATIC}).dummyarray.item + 330, ((create {P_MENU_STATIC}).menu_for_frame_address), create {CE_VOID_POINTER}.make_cast (((create {PD_SESSION_STATIC}).search_dlg_address)), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 93, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("?")), (create {P_LINKS_STATIC}).dummyarray.item + 331, ((create {P_MENU_STATIC}).menu_for_frame_address), create {CE_VOID_POINTER}.make_cast (((create {PD_SESSION_STATIC}).search_back_dlg_address)), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 94, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("n")), (create {P_LINKS_STATIC}).dummyarray.item + 332, ((create {P_MENU_STATIC}).menu_for_frame_address), create {CE_VOID_POINTER}.make_cast (((create {PD_SESSION_STATIC}).find_next_address)), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 95, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("N")), (create {P_LINKS_STATIC}).dummyarray.item + 333, ((create {P_MENU_STATIC}).menu_for_frame_address), create {CE_VOID_POINTER}.make_cast (((create {PD_SESSION_STATIC}).find_next_back_address)), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_BFU_STATIC}).m_bar.item, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 96, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("\")), (create {P_LINKS_STATIC}).dummyarray.item + 334, ((create {P_MENU_STATIC}).menu_toggle_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 97, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("=")), (create {P_LINKS_STATIC}).dummyarray.item + 335, ((create {P_MENU_STATIC}).menu_doc_info_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 98, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("f")), (create {P_LINKS_STATIC}).dummyarray.item + 337, ((create {P_MENU_STATIC}).menu_for_frame_address), create {CE_VOID_POINTER}.make_cast (((create {PD_SESSION_STATIC}).set_frame_address)), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_BFU_STATIC}).m_bar.item, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 78, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 338, (menu_html_options_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0])
				>>)
		end

	assoc_menu: CE_STATIC [CE_ARRAY [PD_MENU_ITEM]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MENU_ITEM]}.make_initialized (<<
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 100, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 344, (create {P_TYPES_STATIC}).menu_add_ct_address, create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 101, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">")), (create {P_LINKS_STATIC}).dummyarray.item + 345, (create {P_TYPES_STATIC}).menu_list_assoc_address, create {CE_VOID_POINTER}.make_cast (((create {P_TYPES_STATIC}).menu_add_ct_address)), 1, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 102, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">")), (create {P_LINKS_STATIC}).dummyarray.item + 346, (create {P_TYPES_STATIC}).menu_list_assoc_address, create {CE_VOID_POINTER}.make_cast (((create {P_TYPES_STATIC}).menu_del_ct_address)), 1, 0]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0])
				>>)
		end

	ext_menu: CE_STATIC [CE_ARRAY [PD_MENU_ITEM]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MENU_ITEM]}.make_initialized (<<
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 100, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 344, (create {P_TYPES_STATIC}).menu_add_ext_address, create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 101, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">")), (create {P_LINKS_STATIC}).dummyarray.item + 345, (create {P_TYPES_STATIC}).menu_list_ext_address, create {CE_VOID_POINTER}.make_cast (((create {P_TYPES_STATIC}).menu_add_ext_address)), 1, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 102, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">")), (create {P_LINKS_STATIC}).dummyarray.item + 346, (create {P_TYPES_STATIC}).menu_list_ext_address, create {CE_VOID_POINTER}.make_cast (((create {P_TYPES_STATIC}).menu_del_ext_address)), 1, 0]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0])
				>>)
		end

	setup_menu_anon: CE_STATIC [CE_ARRAY [PD_MENU_ITEM]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MENU_ITEM]}.make_initialized (<<
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 250, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">")), (create {P_LINKS_STATIC}).dummyarray.item + 347, ((create {P_MENU_STATIC}).menu_language_list_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 1, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 103, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">")), (create {P_LINKS_STATIC}).dummyarray.item + 348, ((create {P_MENU_STATIC}).charset_list_address), create {CE_VOID_POINTER}.make_shared (default_pointer + 1), 1, 0]),
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 56, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_LINKS_STATIC}).dummyarray.item + 349, (terminal_options_address), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0])
				>>)
		end

	oinw: CE_STATIC [CE_ARRAY [PD_OINW]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_OINW]}.make_initialized (<<
					create {PD_OINW}.make_initialized ([1, (create {P_OS_DEP_STATIC}).open_in_new_xterm_address, (create {P_LINKS_STATIC}).dummyarray.item + 251, (create {P_LINKS_STATIC}).dummyarray.item + 371]),
					create {PD_OINW}.make_initialized ([16, (create {P_OS_DEP_STATIC}).open_in_new_twterm_address, (create {P_LINKS_STATIC}).dummyarray.item + 252, (create {P_LINKS_STATIC}).dummyarray.item + 372]),
					create {PD_OINW}.make_initialized ([2, (create {P_OS_DEP_STATIC}).open_in_new_screen_address, (create {P_LINKS_STATIC}).dummyarray.item + 253, (create {P_LINKS_STATIC}).dummyarray.item + 373]),
					create {PD_OINW}.make_initialized ([0, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)])
				>>)
		end

	frame_vt100: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('a').code).to_natural_8, (('a').code).to_natural_8, (('a').code).to_natural_8, (('x').code).to_natural_8,
					(('u').code).to_natural_8, (('u').code).to_natural_8, (('u').code).to_natural_8, (('k').code).to_natural_8,
					(('k').code).to_natural_8, (('u').code).to_natural_8, (('x').code).to_natural_8, (('k').code).to_natural_8,
					(('j').code).to_natural_8, (('j').code).to_natural_8, (('j').code).to_natural_8, (('k').code).to_natural_8,
					(('m').code).to_natural_8, (('v').code).to_natural_8, (('w').code).to_natural_8, (('t').code).to_natural_8,
					(('q').code).to_natural_8, (('n').code).to_natural_8, (('t').code).to_natural_8, (('t').code).to_natural_8,
					(('m').code).to_natural_8, (('l').code).to_natural_8, (('v').code).to_natural_8, (('w').code).to_natural_8,
					(('t').code).to_natural_8, (('q').code).to_natural_8, (('n').code).to_natural_8, (('v').code).to_natural_8,
					(('v').code).to_natural_8, (('w').code).to_natural_8, (('w').code).to_natural_8, (('m').code).to_natural_8,
					(('m').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8, (('n').code).to_natural_8,
					(('n').code).to_natural_8, (('j').code).to_natural_8, (('l').code).to_natural_8, (('a').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8
				>>)
		end

	frame_koi: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					144, 145, 146, 129, 135, 178, 180, 167, 166, 181, 161, 168, 174, 173, 172, 131, 132, 137, 136, 134,
					128, 138, 175, 176, 171, 165, 187, 184, 177, 160, 190, 185, 186, 182, 183, 170, 169, 162, 164, 189,
					188, 133, 130, 141, 140, 142, 143, 139
				>>)
		end

	frame_freebsd: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					130, 138, 128, 153, 150, 150, 150, 140, 140, 150, 153, 140, 139, 139, 139, 140, 142, 151, 152, 149,
					146, 143, 149, 149, 142, 141, 151, 152, 149, 146, 143, 151, 151, 152, 152, 142, 142, 141, 141, 143,
					143, 139, 141, 128, 128, 128, 128, 128
				>>)
		end

	frame_restrict: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					0, 0, 0, 0, 0, 179, 186, 186, 205, 0, 0, 0, 0, 186, 205, 0, 0, 0, 0, 0, 0, 0, 179, 186, 0, 0, 0,
					0, 0, 0, 0, 205, 196, 205, 196, 186, 205, 205, 186, 186, 179, 0, 0, 0, 0, 0, 0, 0
				>>)
		end

	p1: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					218, 191, 192, 217, 179, 196
				>>)
		end

	p2: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					201, 187, 200, 188, 186, 205
				>>)
		end

	fr_trans: CE_STATIC [CE_ARRAY [CE_ARRAY [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_ARRAY_ARRAY [NATURAL_8]}.make_initialized (<<
					create {CE_NATURAL_8_ARRAY}.make_initialized (<<
							179, 195, 180, 197
						>>),
					create {CE_NATURAL_8_ARRAY}.make_initialized (<<
							196, 194, 193, 197
						>>)
				>>)
		end

feature {ANY} -- public routines

	cache_inf (a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_a1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a2: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a3: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a4: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a5: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a6: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a7: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a8: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a9: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a10: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a11: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a12: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a13: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a14: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a15: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a16: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_r: CE_POINTER [PD_REFRESH]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: CE_POINTER [PD_MEMORY_LIST]
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a2.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a3.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a4.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a5.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a6.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a7.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a8.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a9.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a10.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a11.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a12.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a13.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a14.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a15.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a16.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)

			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 120, (create {PD_REFRESH}.make).structure_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_r := create {CE_CLASS_POINTER [PD_REFRESH]}.make_cast (l_tmp)
			l_r.item.term := (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.win := create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.ses := a_ses
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.fn := cache_inf_address
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.data := a_d
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.timer := -1
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a1.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 128)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a1, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (": ")))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := select_info (2)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_num_to_str (l_a1, l_l, l_tmp___0)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a1, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a2.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 129)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a2, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___1 := select_info (5)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_num_to_str (l_a2, l_l, l_tmp___1)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a2, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a3.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 130)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a3, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".%N")))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a4.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 132)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a4, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (": ")))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___2 := connect_info (2)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_num_to_str (l_a4, l_l, l_tmp___2)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a4, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a5.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 133)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a5, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___3 := connect_info (7)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_num_to_str (l_a5, l_l, l_tmp___3)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a5, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a6.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 134)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a6, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___4 := connect_info (6)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_num_to_str (l_a6, l_l, l_tmp___4)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a6, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a7.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 135)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a7, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___5 := connect_info (8)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_num_to_str (l_a7, l_l, l_tmp___5)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a7, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a8.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 136)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a8, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".%N")))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a9.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 138)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a9, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (": ")))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___6 := cache_info (1)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_num_to_str (l_a9, l_l, l_tmp___6)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a9, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a10.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 139)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a10, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___7 := cache_info (2)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_num_to_str (l_a10, l_l, l_tmp___7)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a10, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a11.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 140)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a11, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___8 := cache_info (3)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_num_to_str (l_a11, l_l, l_tmp___8)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a11, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a12.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 141)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a12, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___9 := cache_info (4)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_num_to_str (l_a12, l_l, l_tmp___9)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a12, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a13.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 142)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a13, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".%N")))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a14.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 144)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a14, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (": ")))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___10 := formatted_info (2)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_num_to_str (l_a14, l_l, l_tmp___10)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a14, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a15.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 145)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a15, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___11 := formatted_info (3)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_num_to_str (l_a15, l_l, l_tmp___11)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a15, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
			update_class_fields -- Current might have been changed; synchronize
			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a16.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 146)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_a16, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".")))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___12 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_a1.item), l_a2.item, l_a3.item, l_a4.item, l_a5.item, l_a6.item, l_a7.item, l_a8.item, l_a9.item, l_a10.item, l_a11.item, l_a12.item, l_a13.item, l_a14.item, l_a15.item, l_a16.item, create {CE_VOID_POINTER}.make_shared (default_pointer)])
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.msg_box ([l_tmp___12, (create {P_LINKS_STATIC}).dummyarray.item + 19, 128, (create {P_LINKS_STATIC}).dummyarray.item + 19, l_a1.item, (create {P_LINKS_STATIC}).dummyarray.item + 20, l_a2.item, (create {P_LINKS_STATIC}).dummyarray.item + 21, l_a3.item, (create {P_LINKS_STATIC}).dummyarray.item + 22, l_a4.item, (create {P_LINKS_STATIC}).dummyarray.item + 23, l_a5.item, (create {P_LINKS_STATIC}).dummyarray.item + 24, l_a6.item, (create {P_LINKS_STATIC}).dummyarray.item + 25, l_a7.item, (create {P_LINKS_STATIC}).dummyarray.item + 26, l_a8.item, (create {P_LINKS_STATIC}).dummyarray.item + 27, l_a9.item, (create {P_LINKS_STATIC}).dummyarray.item + 28, l_a10.item, (create {P_LINKS_STATIC}).dummyarray.item + 29, l_a11.item, (create {P_LINKS_STATIC}).dummyarray.item + 30, l_a12.item, (create {P_LINKS_STATIC}).dummyarray.item + 31, l_a13.item, (create {P_LINKS_STATIC}).dummyarray.item + 32, l_a14.item, (create {P_LINKS_STATIC}).dummyarray.item + 33, l_a15.item, (create {P_LINKS_STATIC}).dummyarray.item + 30, l_a16.item, create {CE_VOID_POINTER}.make_shared (default_pointer), l_r, 1, (create {P_LINKS_STATIC}).dummyarray.item + 14, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.win := create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast (windows.next)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_cast ((l_r.item.win).item.data)).item.dlg).item.abort := (create {PD_DIALOG_DATA_STATIC}).refresh_abort_address
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.timer := (create {P_SELECT_STATIC}).install_timer ((100).to_integer_32, ((create {PD_REFRESH_STATIC}).refresh_address), create {CE_VOID_POINTER}.make_cast (l_r))
			update_class_fields -- Current might have been changed; synchronize
		end

	list_cache (a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_a: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_r: CE_POINTER [PD_REFRESH]
			l_ce: CE_POINTER [PD_CACHE_ENTRY]
			l_cache___0: CE_POINTER [PD_CACHE_ENTRY]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [PD_MEMORY_LIST]
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)

			l_l.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_a.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 162)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 163, (create {PD_REFRESH}.make).structure_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_r := create {CE_CLASS_POINTER [PD_REFRESH]}.make_cast (l_tmp)
			l_r.item.term := (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.win := create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.ses := a_ses
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.fn := list_cache_address
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.data := a_d
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.timer := -1
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := cache_info (9)
			update_class_fields -- Current might have been changed; synchronize
			l_cache___0 := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer + l_tmp___0);
			(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":")))
			update_class_fields -- Current might have been changed; synchronize
			l_ce := l_cache___0.item.next
			from
			until
				l_ce.is_equal (l_cache___0)
			loop
				(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, l_ce.item.url)
				update_class_fields -- Current might have been changed; synchronize
				l_ce := l_ce.item.next
			end
			l_tmp___1 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_a.item), create {CE_VOID_POINTER}.make_shared (default_pointer)])
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.msg_box ([l_tmp___1, (create {P_LINKS_STATIC}).dummyarray.item + 34, 128, (create {P_LINKS_STATIC}).dummyarray.item + 35, l_a.item, create {CE_VOID_POINTER}.make_shared (default_pointer), l_r, 1, (create {P_LINKS_STATIC}).dummyarray.item + 14, (create {PD_DIALOG_DATA_STATIC}).end_refresh_address, 3])
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.win := create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast (windows.next)
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.timer := (create {P_SELECT_STATIC}).install_timer ((100).to_integer_32, ((create {PD_REFRESH_STATIC}).refresh_address), create {CE_VOID_POINTER}.make_cast (l_r))
			update_class_fields -- Current might have been changed; synchronize
		end

	memory_info (a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_message: CE_ARRAY [INTEGER_8]
			l_p: CE_POINTER [INTEGER_8]
			l_r: CE_POINTER [PD_REFRESH]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: NATURAL_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: NATURAL_32
			l_tmp___5: NATURAL_32
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [PD_MEMORY_LIST]
		do
			create {CE_INTEGER_8_ARRAY} l_message.make (<<2_000>>)

			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 199, (create {PD_REFRESH}.make).structure_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_r := create {CE_CLASS_POINTER [PD_REFRESH]}.make_cast (l_tmp)
			l_r.item.term := (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.win := create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.ses := a_ses
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.fn := memory_info_address
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.data := a_d
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.timer := -1
			update_class_fields -- Current might have been changed; synchronize
			l_p := l_message
			l_tmp___0 := (create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 36, (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer)))
			update_class_fields -- Current might have been changed; synchronize
			sprintf ([l_p, ce_string ("%%ld %%s"), (create {P_ERROR_STATIC}).mem_amount.item, l_tmp___0]).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___1 := strlen (l_p)
			update_class_fields -- Current might have been changed; synchronize
			l_p := l_p + l_tmp___1.to_integer_32
			if (create {P_ERROR_STATIC}).last_mem_amount.item /= -1 then
				l_tmp___2 := (create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 38, (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer)))
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___3 := (create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 37, (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer)))
				update_class_fields -- Current might have been changed; synchronize
				sprintf ([l_p, ce_string (", %%s %%ld, %%s %%ld"), l_tmp___3, (create {P_ERROR_STATIC}).last_mem_amount.item, l_tmp___2, (create {P_ERROR_STATIC}).mem_amount.item - (create {P_ERROR_STATIC}).last_mem_amount.item]).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___4 := strlen (l_p)
				update_class_fields -- Current might have been changed; synchronize
				l_p := l_p + l_tmp___4.to_integer_32
			end
			sprintf ([l_p, ce_string (".")]).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___5 := strlen (l_p)
			update_class_fields -- Current might have been changed; synchronize
			l_p := l_p + l_tmp___5.to_integer_32
			l_tmp___6 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 229, create {CE_NATURAL_8_POINTER}.make_cast (l_message))
			update_class_fields -- Current might have been changed; synchronize
			l_p := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___6)
			l_tmp___7 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_p), create {CE_VOID_POINTER}.make_shared (default_pointer)])
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.msg_box ([l_tmp___7, (create {P_LINKS_STATIC}).dummyarray.item + 43, 1, l_p, l_r, 1, (create {P_LINKS_STATIC}).dummyarray.item + 14, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.win := create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast (windows.next)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_cast ((l_r.item.win).item.data)).item.dlg).item.abort := (create {PD_DIALOG_DATA_STATIC}).refresh_abort_address
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.timer := (create {P_SELECT_STATIC}).install_timer ((100).to_integer_32, ((create {PD_REFRESH_STATIC}).refresh_address), create {CE_VOID_POINTER}.make_cast (l_r))
			update_class_fields -- Current might have been changed; synchronize
		end

	display_codepage (a_pcp: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_cp: INTEGER_32
			l_t: CE_POINTER [PD_TERM_SPEC]
			l_tmp: CE_POINTER [PD_TERM_SPEC]
		do
			l_cp := (a_pcp.c_pointer.to_integer_32).to_integer_32
			l_tmp := (create {P_TERMINAL_STATIC}).new_term_spec (term)
			update_class_fields -- Current might have been changed; synchronize
			l_t := l_tmp
			if (not l_t.is_void) then
				l_t.item.charset := l_cp
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_TERMINAL_STATIC}).cls_redraw_all_terminals
			update_class_fields -- Current might have been changed; synchronize
		end

	terminal_options (a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_d: CE_POINTER [PD_DIALOG]
			l_ts: CE_POINTER [PD_TERM_SPEC]
			l_tmp: CE_POINTER [PD_TERM_SPEC]
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: CE_POINTER [PD_MEMORY_LIST]
			l_return: BOOLEAN
		do
			l_tmp := (create {P_TERMINAL_STATIC}).new_term_spec (term)
			update_class_fields -- Current might have been changed; synchronize
			l_ts := l_tmp
			if l_ts.is_void then
				l_return := True
			end
			if not l_return then
				l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 389, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 12 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_d := create {CE_CLASS_POINTER [PD_DIALOG]}.make_cast (l_tmp___0)
				memset (create {CE_VOID_POINTER}.make_cast (l_d), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 12 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.title := (create {P_LINKS_STATIC}).dummyarray.item + 56
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.fn := (create {PD_DIALOG_DATA_STATIC}).checkbox_list_fn_address
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.udata := create {CE_VOID_POINTER}.make_cast (td_labels.item)
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.refresh := (create {P_MENU_STATIC}).terminal_options_ok_address
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[0].type := 1
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[0].gid := 1
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[0].gnum := 0
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[0].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[0].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("mode"))))
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[1].type := 1
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[1].gid := 1
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[1].gnum := 1
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[1].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[1].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("mode"))))
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[2].type := 1
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[2].gid := 1
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[2].gnum := 2
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[2].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[2].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("mode"))))
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[3].type := 1
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[3].gid := 1
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[3].gnum := 3
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[3].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[3].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("mode"))))
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[4].type := 1
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[4].gid := 1
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[4].gnum := 4
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[4].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[4].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("mode"))))
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[5].type := 1
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[5].gid := 0
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[5].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[5].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("m11_hack"))))
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[6].type := 1
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[6].gid := 0
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[6].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[6].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("restrict_852"))))
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[7].type := 1
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[7].gid := 0
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[7].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[7].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("block_cursor"))))
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[8].type := 1
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[8].gid := 0
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[8].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[8].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("col"))))
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[9].type := 4
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[9].gid := 1
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[9].fn := (create {PD_DIALOG_DATA_STATIC}).ok_dialog_address
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[9].text := (create {P_LINKS_STATIC}).dummyarray.item + 14
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[10].type := 4
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[10].gid := 2
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[10].fn := (create {PD_DIALOG_DATA_STATIC}).cancel_dialog_address
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[10].text := (create {P_LINKS_STATIC}).dummyarray.item + 6
				update_class_fields -- Current might have been changed; synchronize
				l_d.item.items[11].type := 0
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___1 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_d), create {CE_VOID_POINTER}.make_shared (default_pointer)])
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_dialog (l_d, l_tmp___1)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	dlg_resize_terminal (a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_d: CE_POINTER [PD_DIALOG]
			l_x: INTEGER_32
			l_tmp: INTEGER_32
			l_y: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [PD_MEMORY_LIST]
		do
			if x > 999 then
				l_tmp := 999
			else
				l_tmp := x
			end
			l_x := l_tmp
			if y > 999 then
				l_tmp___0 := 999
			else
				l_tmp___0 := y
			end
			l_y := l_tmp___0
			sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MENU_STATIC}).x_str.item)), ce_string ("%%d"), l_x]).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MENU_STATIC}).y_str.item)), ce_string ("%%d"), l_y]).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___1 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 1_009, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 5 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_d := create {CE_CLASS_POINTER [PD_DIALOG]}.make_cast (l_tmp___1)
			memset (create {CE_VOID_POINTER}.make_cast (l_d), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 5 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.title := (create {P_LINKS_STATIC}).dummyarray.item + 260
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.fn := (create {PD_DIALOG_DATA_STATIC}).group_fn_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.udata := create {CE_VOID_POINTER}.make_cast (resize_texts.item)
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.refresh := ((create {P_MENU_STATIC}).do_resize_terminal_address)
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.refresh_data := create {CE_VOID_POINTER}.make_shared (c_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].dlen := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].data := (create {P_MENU_STATIC}).x_str.item
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].fn := (create {P_BFU_STATIC}).check_number_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].gnum := 999
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].dlen := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].data := (create {P_MENU_STATIC}).y_str.item
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].fn := (create {P_BFU_STATIC}).check_number_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].gnum := 999
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].fn := (create {PD_DIALOG_DATA_STATIC}).ok_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].text := (create {P_LINKS_STATIC}).dummyarray.item + 14
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].gid := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].fn := (create {PD_DIALOG_DATA_STATIC}).cancel_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].text := (create {P_LINKS_STATIC}).dummyarray.item + 6
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].type := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___2 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_d), create {CE_VOID_POINTER}.make_shared (default_pointer)])
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_dialog (l_d, l_tmp___2)
			update_class_fields -- Current might have been changed; synchronize
		end

	do_file_menu (a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_x: INTEGER_32
			l_o: INTEGER_32
			l_file_menu: CE_POINTER [PD_MENU_ITEM]
			l_e: CE_POINTER [PD_MENU_ITEM]
			l_f: CE_POINTER [PD_MENU_ITEM]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 1_085, ((((((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (4).to_natural_32) + ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (2).to_natural_32)) + ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (4).to_natural_32)) + ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (6).to_natural_32)) + ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (3).to_natural_32)) + {NATURAL_32} 3 * (create {PD_MENU_ITEM}.make).structure_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_file_menu := create {CE_CLASS_POINTER [PD_MENU_ITEM]}.make_cast (l_tmp)
			l_e := l_file_menu
			memcpy (create {CE_VOID_POINTER}.make_cast (l_e), create {CE_VOID_POINTER}.make_cast (file_menu11.item), ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (4).to_natural_32)).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_e := l_e + (((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (4).to_natural_32) // (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).to_integer_32
			if not ((create {P_DEFAULT_STATIC}).anonymous.item).to_boolean then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_e), create {CE_VOID_POINTER}.make_cast (file_menu12.item), ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (2).to_natural_32)).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_e := l_e + (((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (2).to_natural_32) // (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).to_integer_32
			end
			l_o := ((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.can_open_in_new
			update_class_fields -- Current might have been changed; synchronize
			if l_o.to_boolean then
				l_e.item.text := (create {P_LINKS_STATIC}).dummyarray.item + 257
				update_class_fields -- Current might have been changed; synchronize
				if (l_o - 1).to_boolean then
					l_e.item.rtext := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">"))
					update_class_fields -- Current might have been changed; synchronize
				else
					l_e.item.rtext := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
					update_class_fields -- Current might have been changed; synchronize
				end
				l_e.item.hotkey := (create {P_LINKS_STATIC}).dummyarray.item + 377
				update_class_fields -- Current might have been changed; synchronize
				l_e.item.func := (open_in_new_window_address)
				update_class_fields -- Current might have been changed; synchronize
				l_e.item.data := create {CE_VOID_POINTER}.make_cast (((create {P_VIEW_STATIC}).send_open_new_xterm_address))
				update_class_fields -- Current might have been changed; synchronize
				l_e.item.in_m := l_o - 1
				update_class_fields -- Current might have been changed; synchronize
				l_e.item.free_i := 0
				update_class_fields -- Current might have been changed; synchronize
				l_e := l_e + 1
			end
			if not ((create {P_DEFAULT_STATIC}).anonymous.item).to_boolean then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_e), create {CE_VOID_POINTER}.make_cast (file_menu21.item), ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (4).to_natural_32)).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_e := l_e + (((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (4).to_natural_32) // (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).to_integer_32
			end
			memcpy (create {CE_VOID_POINTER}.make_cast (l_e), create {CE_VOID_POINTER}.make_cast (file_menu22.item), ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (6).to_natural_32)).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_e := l_e + (((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (6).to_natural_32) // (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).to_integer_32
			l_x := 1
			if not ((create {P_DEFAULT_STATIC}).anonymous.item).to_boolean then
				l_tmp___0 := can_open_os_shell (environment)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					l_e.item.text := (create {P_LINKS_STATIC}).dummyarray.item + 90
					update_class_fields -- Current might have been changed; synchronize
					l_e.item.rtext := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
					update_class_fields -- Current might have been changed; synchronize
					l_e.item.hotkey := (create {P_LINKS_STATIC}).dummyarray.item + 327
					update_class_fields -- Current might have been changed; synchronize
					l_e.item.func := (create {P_MENU_STATIC}).menu_shell_address
					update_class_fields -- Current might have been changed; synchronize
					l_e.item.data := create {CE_VOID_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					l_e.item.in_m := 0
					update_class_fields -- Current might have been changed; synchronize
					l_e.item.free_i := 0
					update_class_fields -- Current might have been changed; synchronize
					l_e := l_e + 1
					l_x := 0
				end
			end
			l_tmp___1 := can_resize_window (environment)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___1.to_boolean then
				l_e.item.text := (create {P_LINKS_STATIC}).dummyarray.item + 260
				update_class_fields -- Current might have been changed; synchronize
				l_e.item.rtext := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
				update_class_fields -- Current might have been changed; synchronize
				l_e.item.hotkey := (create {P_LINKS_STATIC}).dummyarray.item + 328
				update_class_fields -- Current might have been changed; synchronize
				l_e.item.func := (dlg_resize_terminal_address)
				update_class_fields -- Current might have been changed; synchronize
				l_e.item.data := create {CE_VOID_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_e.item.in_m := 0
				update_class_fields -- Current might have been changed; synchronize
				l_e.item.free_i := 0
				update_class_fields -- Current might have been changed; synchronize
				l_e := l_e + 1
				l_x := 0
			end
			memcpy (create {CE_VOID_POINTER}.make_cast (l_e), create {CE_VOID_POINTER}.make_cast ((file_menu3.item + l_x)), ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (3).to_natural_32) - l_x.to_natural_32 * (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_e := l_e + (((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (3).to_natural_32) // (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).to_integer_32
			l_f := l_file_menu
			from
			until
				not ((l_f.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32)
			loop
				l_f.item.free_i := 1
				update_class_fields -- Current might have been changed; synchronize
				l_f := l_f + 1
			end
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_menu (l_file_menu, create {CE_VOID_POINTER}.make_cast (a_ses))
			update_class_fields -- Current might have been changed; synchronize
		end

	alloc_term_screen (a_x, a_y: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_32]
			l_t: CE_POINTER [NATURAL_32]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [ANY]
		do
			if a_x.to_boolean then
				if (a_x.to_natural_32 * a_y.to_natural_32) // a_x.to_natural_32 /= a_y.to_natural_32 then
					from
					until
						False
					loop
						(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("terminal.c"), 62])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_KBD_STATIC}).fatal_tty_exit
						update_class_fields -- Current might have been changed; synchronize
						exit (4)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if a_x.to_natural_32 * a_y.to_natural_32 > {NATURAL_32} 2_147_483_647 // {PLATFORM}.Natural_32_bytes.to_natural_32 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("terminal.c"), 63])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_KBD_STATIC}).fatal_tty_exit
					update_class_fields -- Current might have been changed; synchronize
					exit (4)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 64, create {CE_VOID_POINTER}.make_cast (screen), (a_x * a_y).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_s := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
			l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 65, create {CE_VOID_POINTER}.make_cast (last_screen), (a_x * a_y).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_t := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___0)
			memset (create {CE_VOID_POINTER}.make_cast (l_t), -1, (a_x * a_y).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Current.x := a_x
			update_class_fields -- Current might have been changed; synchronize
			Current.y := a_y
			update_class_fields -- Current might have been changed; synchronize
			Current.last_screen := l_t
			update_class_fields -- Current might have been changed; synchronize
			memset (create {CE_VOID_POINTER}.make_cast (l_s), 0, (a_x * a_y).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Current.screen := l_s
			update_class_fields -- Current might have been changed; synchronize
			Current.dirty := 1
			update_class_fields -- Current might have been changed; synchronize
		end

	clear_terminal
		do
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.fill_area (0, 0, x, y, ((' ').code).to_natural_32)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.set_cursor (0, 0, 0, 0)
			update_class_fields -- Current might have been changed; synchronize
		end

	redraw_terminal_ev (a_e: INTEGER_32)
		local
			l_win: CE_POINTER [PD_WINDOW]
			l_ev: CE_ARRAY [PD_EVENT]
		do
			create {CE_CLASS_ARRAY [PD_EVENT]} l_ev.make (<<1>>)

			l_ev.item.ev := 0
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.x := 0
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.y := 0
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.b := 0
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.ev := a_e.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.x := x.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.y := y.to_integer_32
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.clear_terminal
			update_class_fields -- Current might have been changed; synchronize
			Current.redrawing := 2
			update_class_fields -- Current might have been changed; synchronize
			l_win := create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast (windows.prev)
			from
			until
				l_win.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows")))
			loop
				(l_win.item.handler).call ([l_win, l_ev, 0])
				update_class_fields -- Current might have been changed; synchronize
				l_win := l_win.item.prev
			end
			Current.redrawing := 0
			update_class_fields -- Current might have been changed; synchronize
		end

	redraw_terminal_all
		do
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.redraw_terminal_ev (4)
			update_class_fields -- Current might have been changed; synchronize
		end

	erase_screen
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if master.to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						l_tmp := (create {P_KBD_STATIC}).is_blocked
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp.to_boolean then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if master.to_boolean then
							(create {P_OS_DEP_STATIC}).want_draw
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_TERMINAL_STATIC}).hard_write (fdout, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/[2J%/27/[1;1H")), 10).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if master.to_boolean then
							(create {P_OS_DEP_STATIC}).done_draw
							update_class_fields -- Current might have been changed; synchronize
						end
				when 5 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	redraw_terminal_cls
		do
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.erase_screen
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.alloc_term_screen (x, y)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.redraw_terminal_all
			update_class_fields -- Current might have been changed; synchronize
		end

	add_window_at_pos (a_handler: CE_ROUTINE; a_data: CE_POINTER [ANY]; a_at: CE_POINTER [PD_WINDOW])
		require
			not a_at.is_void
		local
			l_ev: CE_ARRAY [PD_EVENT]
			l_win: CE_POINTER [PD_WINDOW]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_EVENT]} l_ev.make (<<1>>)

			l_ev.item.ev := 0
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.x := 0
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.y := 0
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.b := 0
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.x := x.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.y := y.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 168, (create {PD_WINDOW}.make).structure_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_win := create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast (l_tmp)
			l_win.item.handler := a_handler
			update_class_fields -- Current might have been changed; synchronize
			l_win.item.data := a_data
			update_class_fields -- Current might have been changed; synchronize
			l_win.item.term := (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := 0
			l_win.item.yp := l_tmp___0
			update_class_fields -- Current might have been changed; synchronize
			l_win.item.xp := l_tmp___0
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (a_at))
				update_class_fields -- Current might have been changed; synchronize
				l_win.item.next := a_at.item.next
				update_class_fields -- Current might have been changed; synchronize
				l_win.item.prev := a_at
				update_class_fields -- Current might have been changed; synchronize
				a_at.item.next := l_win
				update_class_fields; -- Current might have been changed; synchronize
				(l_win.item.next).item.prev := l_win
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (a_at))
				update_class_fields -- Current might have been changed; synchronize
				l_break := True
			end
			l_break := False;
			(l_win.item.handler).call ([l_win, l_ev, 0])
			update_class_fields -- Current might have been changed; synchronize
		end

	add_window (a_handler: CE_ROUTINE; a_data: CE_POINTER [ANY])
		do
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.add_window_at_pos (a_handler, a_data, create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows")))))
			update_class_fields -- Current might have been changed; synchronize
		end

	get_root_window: CE_POINTER [PD_WINDOW]
		local
			l_return: BOOLEAN
		do
			if (windows.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))) then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).errline.item := 219
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal has no windows"))])
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := (create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast (windows.prev))
			end
		end

	in_term
		local
			l_ev: CE_POINTER [PD_EVENT]
			l_r: INTEGER_32
			l_iq: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [INTEGER_32]
			l_tmp___1: CE_POINTER [INTEGER_32]
			l_init_len: INTEGER_32
			l_win: CE_POINTER [PD_WINDOW]
			l_tmp___2: NATURAL_8
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [PD_EVENT]} l_ev.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if qlen.to_natural_32 + {NATURAL_32} 64 > {NATURAL_32} 2_147_483_647 then
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("terminal.c"), 344])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_KBD_STATIC}).fatal_tty_exit
							update_class_fields -- Current might have been changed; synchronize
							exit (4)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_tmp := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 345, create {CE_VOID_POINTER}.make_cast (input_queue), (qlen + 64).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_iq := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)
					Current.input_queue := l_iq
					update_class_fields -- Current might have been changed; synchronize
					l_r := read (fdin, create {CE_VOID_POINTER}.make_cast ((l_iq + qlen)), (64).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_r <= 0 then
						if l_r = -1 then
							l_tmp___1 := errno_location
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___1.item /= 104 then
								l_tmp___0 := errno_location
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: error %%d on terminal: could not read event")), l_tmp___0.item])
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.destroy_terminal
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if l_return then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Current.qlen := qlen + l_r
						update_class_fields -- Current might have been changed; synchronize
				when 2 then -- test_queue:
						if qlen.to_natural_32 < (create {PD_EVENT}.make).structure_size.to_natural_32 then
							l_return := True
						end
				when 3 then -- if done
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 4 then -- if:
						l_ev := create {CE_CLASS_POINTER [PD_EVENT]}.make_cast (l_iq)
						l_r := ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32
						if l_ev.item.ev /= 0 then
							if l_ev.item.ev /= 4 then
								if l_ev.item.ev /= 3 then
									if l_ev.item.ev /= 1 then
										if l_ev.item.ev /= 2 then
											if l_ev.item.ev /= 5 then
												(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: error on terminal: bad event %%d")), l_ev.item.ev])
												update_class_fields -- Current might have been changed; synchronize
												l_pos := -1 + 26 -- goto mm
											end
										end
									end
								end
							end
						end
				when 5 then
						if l_ev.item.ev = 0 then
							if qlen.to_natural_32 < (((create {PD_EVENT}.make).structure_size.to_natural_32 + {NATURAL_32} 32) + {NATURAL_32} 256) + {NATURAL_32} 2 * {PLATFORM}.Integer_32_bytes.to_natural_32 then
								l_return := True
							end
							if not l_return then
								l_init_len := (create {CE_INTEGER_32_POINTER}.make_cast (((((l_iq + ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32) + 32) + 256) + ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32))).item
								if qlen.to_natural_32 < ((((create {PD_EVENT}.make).structure_size.to_natural_32 + {NATURAL_32} 32) + {NATURAL_32} 256) + {NATURAL_32} 2 * {PLATFORM}.Integer_32_bytes.to_natural_32) + l_init_len.to_natural_32 then
									l_return := True
								end
							end
							if not l_return then
								memcpy (create {CE_VOID_POINTER}.make_cast (term), create {CE_VOID_POINTER}.make_cast ((l_iq + ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32)), (32).to_natural_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								term[31] := (0).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								memcpy (create {CE_VOID_POINTER}.make_cast (cwd), create {CE_VOID_POINTER}.make_cast (((l_iq + ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32) + 32)), (256).to_natural_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								cwd[255] := (0).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								Current.environment := (create {CE_INTEGER_32_POINTER}.make_cast ((((l_iq + ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32) + 32) + 256))).item
								update_class_fields -- Current might have been changed; synchronize
								l_ev.item.b := (((((l_iq + ((create {PD_EVENT}.make).structure_size.to_natural_32).to_integer_32) + 32) + 256) + ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32).c_pointer.to_integer_32).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								l_r := (((((create {PD_EVENT}.make).structure_size.to_natural_32 + {NATURAL_32} 32) + {NATURAL_32} 256) + {NATURAL_32} 2 * {PLATFORM}.Integer_32_bytes.to_natural_32) + l_init_len.to_natural_32).to_integer_32;
								(create {P_TERMINAL_STATIC}).sync_term_specs
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 6 then -- if done
					if l_return then
						l_pos := -1 + 25 -- skip if block
					end
				when 7 then -- if:
						if l_ev.item.ev /= 3 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 14 -- goto send_redraw
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 10 then -- else:
						if l_ev.item.ev /= 4 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto send_redraw
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 13 then -- else:
						if l_ev.item.ev /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if: | send_redraw:
						if l_ev.item.x < 0 then
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: bad terminal size: %%d, %%d")), (l_ev.item.x).to_integer_32, (l_ev.item.y).to_integer_32])
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 26 -- goto mm
						elseif l_ev.item.y < 0 then
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: bad terminal size: %%d, %%d")), (l_ev.item.x).to_integer_32, (l_ev.item.y).to_integer_32])
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 26 -- goto mm
						end
				when 15 then;
						((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.alloc_term_screen ((l_ev.item.x).to_integer_32, (l_ev.item.y).to_integer_32)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.clear_terminal
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.erase_screen
						update_class_fields -- Current might have been changed; synchronize
						Current.redrawing := 1
						update_class_fields -- Current might have been changed; synchronize
						l_win := create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast (windows.prev)
						from
						until
							l_win.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows")))
						loop
							(l_win.item.handler).call ([l_win, l_ev, 0])
							update_class_fields -- Current might have been changed; synchronize
							l_win := l_win.item.prev
						end
						Current.redrawing := 0
						update_class_fields -- Current might have been changed; synchronize
				when 16 then -- if done | if done
						if l_ev.item.ev /= 1 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L___2
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 19 then -- else:
						if l_ev.item.ev /= 2 then
							l_pos := -1 + 24 -- skip if block
						end
				when 20 then -- if: | _L___2:
						if l_ev.item.ev /= 1 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_tmp___2 := (create {P_LINKS_STATIC}).upcase ((l_ev.item.x).to_natural_8)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2.to_integer_32 = 76 then
							if l_ev.item.y = 2 then
								l_ev.item.ev := 3
								update_class_fields -- Current might have been changed; synchronize
								l_ev.item.x := x.to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								l_ev.item.y := y.to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								l_pos := -1 + 14 -- goto send_redraw
							else
								l_pos := -1 + 23 -- goto _L___1
							end
						else
							l_pos := -1 + 23 -- goto _L___1
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else: | _L___1:
						if l_ev.item.ev = 1 then
							if l_ev.item.x = 512 then
								(((create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))))).item.prev).item.handler).call ([create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast (windows.prev), l_ev, 0])
								update_class_fields -- Current might have been changed; synchronize
							else
								(((create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))))).item.next).item.handler).call ([create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast (windows.next), l_ev, 0])
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							(((create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))))).item.next).item.handler).call ([create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast (windows.next), l_ev, 0])
							update_class_fields -- Current might have been changed; synchronize
						end
				when 24 then -- if done | if done
						if l_ev.item.ev = 5 then
							((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.destroy_terminal
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
				when 25 then -- if done
					if l_return then
						l_pos := -1 + 27 -- skip if block
					end
				when 26 then -- if: | mm:
						if qlen = l_r then
							Current.qlen := 0
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___3 := qlen - l_r
							Current.qlen := l_tmp___3
							update_class_fields -- Current might have been changed; synchronize
							memmove (create {CE_VOID_POINTER}.make_cast (l_iq), create {CE_VOID_POINTER}.make_cast ((l_iq + l_r)), l_tmp___3.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 2 -- goto test_queue
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	redraw_screen
		local
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_p: INTEGER_32
			l_cx: INTEGER_32
			l_cy: INTEGER_32
			l_a: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_attrib: INTEGER_32
			l_mode: INTEGER_32
			l_l: CE_ARRAY [INTEGER_32]
			l_s: CE_POINTER [PD_TERM_SPEC]
			l_tmp: INTEGER_32
			l_i: INTEGER_32
			l_ch: NATURAL_32
			l_c: NATURAL_8
			l_A2: NATURAL_8
			l_m: CE_ARRAY [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_ch___0: NATURAL_32
			l_c___0: NATURAL_8
			l_A___0: NATURAL_8
			l_m___0: CE_ARRAY [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_a.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_m.make (<<4>>)
			create {CE_NATURAL_8_ARRAY} l_m___0.make (<<4>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p := 0
					l_cx := lcx
					l_cy := lcy
					l_attrib := -1
					l_mode := -1
					l_l.item := 0
					update_class_fields -- Current might have been changed; synchronize
					if not dirty.to_boolean then
						l_return := True
					elseif master.to_boolean then
						l_tmp := (create {P_KBD_STATIC}).is_blocked
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp.to_boolean then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 80 -- skip if block
					end
				when 1 then -- if:
						l_a.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 505)
						update_class_fields -- Current might have been changed; synchronize
						l_s := spec
						l_y := 0
				when 2 then -- loop condition:
						if not (not (l_return) and then (l_y < y)) then
							l_pos := -1 + 74 -- skip loop
						end
				when 3 then -- loop body:
						l_x := 0
				when 4 then -- loop condition:
						if not (not (l_return or l_break) and then (l_x < x)) then
							l_pos := -1 + 73 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						l_continue := False
						if l_y = y - 1 then
							if l_x = x - 1 then
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) and then (screen[l_p] = last_screen[l_p]) then
							l_continue := True
						end
						if not (not (l_return or l_break or l_continue) and then (((screen[l_p]).bit_and ({NATURAL_32} 14_336)) = ((last_screen[l_p]).bit_and ({NATURAL_32} 14_336)))) then
							l_pos := -1 + 21 -- skip if block
						end
				when 6 then -- if:
						if ((screen[l_p]).bit_and ({NATURAL_32} 255)) /= {NATURAL_32} 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 13 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 9 then -- else:
						if ((screen[l_p]).bit_and ({NATURAL_32} 255)) /= {NATURAL_32} 1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L___0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 12 then -- else:
						if ((screen[l_p]).bit_and ({NATURAL_32} 255)) /= {NATURAL_32} 32 then
							l_pos := -1 + 21 -- skip if block
						end
				when 13 then -- if: | _L___0:
						if ((last_screen[l_p]).bit_and ({NATURAL_32} 255)) /= {NATURAL_32} 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 20 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 16 then -- else:
						if ((last_screen[l_p]).bit_and ({NATURAL_32} 255)) /= {NATURAL_32} 1 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 19 then -- else:
						if ((last_screen[l_p]).bit_and ({NATURAL_32} 255)) /= {NATURAL_32} 32 then
							l_pos := -1 + 21 -- skip if block
						end
				when 20 then -- if: | _L:
						if l_x /= cx then
							l_continue := True
						elseif l_y /= cy then
							l_continue := True
						end
				when 21 then -- if done | if done | if done | if done | if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 72 -- skip if block
						end
				when 22 then -- if:
						last_screen[l_p] := screen[l_p]
						update_class_fields -- Current might have been changed; synchronize
						if l_cx /= l_x then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if l_cy = l_y then
							l_pos := -1 + 54 -- goto pc
						else
							l_pos := -1 + 25 -- goto _L___17
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 25 then -- else: | _L___17:
						if l_cy /= l_y then
							l_pos := -1 + 53 -- skip if block
						end
				when 26 then -- if:
						if not (l_x - l_cx < 10) then
							l_pos := -1 + 51 -- skip if block
						end
				when 27 then -- if:
						if not (l_x - l_cx > 0) then
							l_pos := -1 + 49 -- skip if block
						end
				when 28 then -- if:
						l_i := l_x - l_cx
				when 29 then -- loop condition:
						if not (l_i >= 0) then
							l_pos := -1 + 48 -- skip loop
						end
				when 30 then -- loop body:
						l_ch := screen[(l_p - l_i)]
						l_c := ((l_ch).bit_and ({NATURAL_32} 255)).to_natural_8
						l_A2 := ((((l_ch).bit_shift_right (8))).bit_and ({NATURAL_32} 127)).to_natural_8
						if l_s.item.mode /= 2 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						if (l_s.item.m11_hack).to_boolean then
							if ((l_ch).bit_shift_right (15)).to_integer_32 /= l_mode then
								l_mode := ((l_ch).bit_shift_right (15)).to_integer_32
								if l_mode.to_boolean then
									(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/[11m")))
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/[10m")))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if (l_s.item.restrict_852).to_boolean then
							if ((l_ch).bit_shift_right (15)).to_boolean then
								if l_c.to_integer_32 >= 176 then
									if l_c.to_integer_32 < 224 then
										if (frame_restrict.item[l_c.to_integer_32 - 176]).to_boolean then
											l_c := frame_restrict.item[l_c.to_integer_32 - 176]
										end
									end
								end
							end
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 33 then -- else:
						if l_s.item.mode /= 1 then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						if ((l_ch).bit_shift_right (15)).to_integer_32 /= l_mode then
							l_mode := ((l_ch).bit_shift_right (15)).to_integer_32
							if l_mode.to_boolean then
								(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/14/")))
								update_class_fields -- Current might have been changed; synchronize
							else
								(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/15/")))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if l_mode.to_boolean then
							if l_c.to_integer_32 >= 176 then
								if l_c.to_integer_32 < 224 then
									l_c := frame_vt100.item[l_c.to_integer_32 - 176]
								end
							end
						end
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 36 then -- else:
						if l_s.item.mode /= 3 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if ((l_ch).bit_shift_right (15)).to_boolean then
							if l_c.to_integer_32 >= 176 then
								if l_c.to_integer_32 < 224 then
									l_c := frame_koi.item[l_c.to_integer_32 - 176]
								else
									l_pos := -1 + 39 -- goto _L___6
								end
							else
								l_pos := -1 + 39 -- goto _L___6
							end
						else
							l_pos := -1 + 39 -- goto _L___6
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 39 then -- else: | _L___6:
						if l_s.item.mode /= 4 then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						if ((l_ch).bit_shift_right (15)).to_boolean then
							if l_c.to_integer_32 >= 176 then
								if l_c.to_integer_32 < 224 then
									l_c := frame_freebsd.item[l_c.to_integer_32 - 176]
								else
									l_pos := -1 + 42 -- goto _L___3
								end
							else
								l_pos := -1 + 42 -- goto _L___3
							end
						else
							l_pos := -1 + 42 -- goto _L___3
						end
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 42 then -- else: | _L___3:
						if l_s.item.mode = 0 then
							if ((l_ch).bit_shift_right (15)).to_boolean then
								if l_c.to_integer_32 >= 176 then
									if l_c.to_integer_32 < 224 then
										l_c := (create {P_TERMINAL_STATIC}).frame_dumb.item[l_c.to_integer_32 - 176]
									end
								end
							end
						end
				when 43 then -- if done | if done | if done
						if not ((l_A2.to_integer_32).bit_and (64)).to_boolean then
							if (l_A2.to_integer_32).bit_shift_right (3) = ((l_A2.to_integer_32).bit_and (7)) then
								l_A2 := ((((l_A2.to_integer_32).bit_and (56))).bit_or (7 * (not ((l_A2.to_integer_32).bit_and (16)).to_boolean).to_integer)).to_natural_8
							end
						end
						if l_A2.to_integer_32 /= l_attrib then
							l_attrib := l_A2.to_integer_32;
							(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/[0")))
							update_class_fields -- Current might have been changed; synchronize
							if (l_s.item.col).to_boolean then
								l_m[0] := ((';').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_m[1] := (('3').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_m[3] := (0).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_m[2] := (((l_attrib).bit_and (7)) + 48).to_natural_8
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, l_m)
								update_class_fields -- Current might have been changed; synchronize
								l_m[1] := (('4').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_m[2] := (((((l_attrib).bit_shift_right (3))).bit_and (7)) + 48).to_natural_8
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, l_m)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___0 := getcompcode ((l_attrib).bit_and (7))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___1 := getcompcode ((((l_attrib).bit_shift_right (3))).bit_and (7))
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___0 < l_tmp___1 then
									(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (";7")))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							if ((l_attrib).bit_and (64)).to_boolean then
								(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (";1")))
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("m")))
							update_class_fields -- Current might have been changed; synchronize
						end
						if not (l_c.to_integer_32 >= 32) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						if l_c.to_integer_32 /= 127 then
							(create {P_LINKS_STATIC}).add_chr_to_str (l_a, l_l, l_c)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 46 -- goto _L___7
						end
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else: | _L___7:
						if not l_c.to_boolean then
							(create {P_LINKS_STATIC}).add_chr_to_str (l_a, l_l, ((' ').code).to_natural_8)
							update_class_fields -- Current might have been changed; synchronize
						elseif l_c.to_integer_32 = 1 then
							(create {P_LINKS_STATIC}).add_chr_to_str (l_a, l_l, ((' ').code).to_natural_8)
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_LINKS_STATIC}).add_chr_to_str (l_a, l_l, (('.').code).to_natural_8)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 47 then
						l_cx := l_cx + 1
						l_i := l_i - 1
						l_pos := -1 + 29 -- back to loop condition
				when 48 then -- loop done | if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else:
						l_pos := -1 + 53 -- goto _L___16
				when 50 then -- if done | if block done, skip else block:
						l_pos := -1 + 52
				when 51 then -- else:
						l_pos := -1 + 53 -- goto _L___16
				when 52 then -- if done | if block done, skip else block:
						l_pos := -1 + 72
				when 53 then -- else: | _L___16:;
						(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/[")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_num_to_str (l_a, l_l, (l_y + 1).to_integer_32)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (";")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_num_to_str (l_a, l_l, (l_x + 1).to_integer_32)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("H")))
						update_class_fields -- Current might have been changed; synchronize
						l_cx := l_x
						l_cy := l_y
				when 54 then -- pc:
						l_ch___0 := screen[l_p]
						l_c___0 := ((l_ch___0).bit_and ({NATURAL_32} 255)).to_natural_8
						l_A___0 := ((((l_ch___0).bit_shift_right (8))).bit_and ({NATURAL_32} 127)).to_natural_8
						if l_s.item.mode /= 2 then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						if (l_s.item.m11_hack).to_boolean then
							if ((l_ch___0).bit_shift_right (15)).to_integer_32 /= l_mode then
								l_mode := ((l_ch___0).bit_shift_right (15)).to_integer_32
								if l_mode.to_boolean then
									(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/[11m")))
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/[10m")))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if (l_s.item.restrict_852).to_boolean then
							if ((l_ch___0).bit_shift_right (15)).to_boolean then
								if l_c___0.to_integer_32 >= 176 then
									if l_c___0.to_integer_32 < 224 then
										if (frame_restrict.item[l_c___0.to_integer_32 - 176]).to_boolean then
											l_c___0 := frame_restrict.item[l_c___0.to_integer_32 - 176]
										end
									end
								end
							end
						end
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 57 then -- else:
						if l_s.item.mode /= 1 then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						if ((l_ch___0).bit_shift_right (15)).to_integer_32 /= l_mode then
							l_mode := ((l_ch___0).bit_shift_right (15)).to_integer_32
							if l_mode.to_boolean then
								(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/14/")))
								update_class_fields -- Current might have been changed; synchronize
							else
								(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/15/")))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if l_mode.to_boolean then
							if l_c___0.to_integer_32 >= 176 then
								if l_c___0.to_integer_32 < 224 then
									l_c___0 := frame_vt100.item[l_c___0.to_integer_32 - 176]
								end
							end
						end
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 60 then -- else:
						if l_s.item.mode /= 3 then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						if ((l_ch___0).bit_shift_right (15)).to_boolean then
							if l_c___0.to_integer_32 >= 176 then
								if l_c___0.to_integer_32 < 224 then
									l_c___0 := frame_koi.item[l_c___0.to_integer_32 - 176]
								else
									l_pos := -1 + 63 -- goto _L___13
								end
							else
								l_pos := -1 + 63 -- goto _L___13
							end
						else
							l_pos := -1 + 63 -- goto _L___13
						end
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 63 then -- else: | _L___13:
						if l_s.item.mode /= 4 then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						if ((l_ch___0).bit_shift_right (15)).to_boolean then
							if l_c___0.to_integer_32 >= 176 then
								if l_c___0.to_integer_32 < 224 then
									l_c___0 := frame_freebsd.item[l_c___0.to_integer_32 - 176]
								else
									l_pos := -1 + 66 -- goto _L___10
								end
							else
								l_pos := -1 + 66 -- goto _L___10
							end
						else
							l_pos := -1 + 66 -- goto _L___10
						end
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 66 then -- else: | _L___10:
						if l_s.item.mode = 0 then
							if ((l_ch___0).bit_shift_right (15)).to_boolean then
								if l_c___0.to_integer_32 >= 176 then
									if l_c___0.to_integer_32 < 224 then
										l_c___0 := (create {P_TERMINAL_STATIC}).frame_dumb.item[l_c___0.to_integer_32 - 176]
									end
								end
							end
						end
				when 67 then -- if done | if done | if done
						if not ((l_A___0.to_integer_32).bit_and (64)).to_boolean then
							if (l_A___0.to_integer_32).bit_shift_right (3) = ((l_A___0.to_integer_32).bit_and (7)) then
								l_A___0 := ((((l_A___0.to_integer_32).bit_and (56))).bit_or (7 * (not ((l_A___0.to_integer_32).bit_and (16)).to_boolean).to_integer)).to_natural_8
							end
						end
						if l_A___0.to_integer_32 /= l_attrib then
							l_attrib := l_A___0.to_integer_32;
							(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/[0")))
							update_class_fields -- Current might have been changed; synchronize
							if (l_s.item.col).to_boolean then
								l_m___0[0] := ((';').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_m___0[1] := (('3').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_m___0[3] := (0).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_m___0[2] := (((l_attrib).bit_and (7)) + 48).to_natural_8
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, l_m___0)
								update_class_fields -- Current might have been changed; synchronize
								l_m___0[1] := (('4').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_m___0[2] := (((((l_attrib).bit_shift_right (3))).bit_and (7)) + 48).to_natural_8
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, l_m___0)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___2 := getcompcode ((l_attrib).bit_and (7))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___3 := getcompcode ((((l_attrib).bit_shift_right (3))).bit_and (7))
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___2 < l_tmp___3 then
									(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (";7")))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							if ((l_attrib).bit_and (64)).to_boolean then
								(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (";1")))
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("m")))
							update_class_fields -- Current might have been changed; synchronize
						end
						if not (l_c___0.to_integer_32 >= 32) then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						if l_c___0.to_integer_32 /= 127 then
							(create {P_LINKS_STATIC}).add_chr_to_str (l_a, l_l, l_c___0)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 70 -- goto _L___14
						end
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 71
				when 70 then -- else: | _L___14:
						if not l_c___0.to_boolean then
							(create {P_LINKS_STATIC}).add_chr_to_str (l_a, l_l, ((' ').code).to_natural_8)
							update_class_fields -- Current might have been changed; synchronize
						elseif l_c___0.to_integer_32 = 1 then
							(create {P_LINKS_STATIC}).add_chr_to_str (l_a, l_l, ((' ').code).to_natural_8)
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_LINKS_STATIC}).add_chr_to_str (l_a, l_l, (('.').code).to_natural_8)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 71 then
						l_cx := l_cx + 1
				when 72 then -- if done | if done
						if (not l_return and not l_break) then
							l_x := l_x + 1
							l_p := l_p + 1
						end
						l_pos := -1 + 4 -- back to loop condition
				when 73 then -- loop done
						l_break := False
						l_continue := False
						l_y := l_y + 1
						l_pos := -1 + 2 -- back to loop condition
				when 74 then -- loop done
						if (l_l.item).to_boolean then
							if (l_s.item.col).to_boolean then
								(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/[37;40m")))
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/[0m")))
							update_class_fields -- Current might have been changed; synchronize
							if l_s.item.mode = 2 then
								if (l_s.item.m11_hack).to_boolean then
									(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/[10m")))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							if l_s.item.mode = 1 then
								(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/15/")))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						Current.lcx := l_cx
						update_class_fields -- Current might have been changed; synchronize
						Current.lcy := l_cy
						update_class_fields -- Current might have been changed; synchronize
						if cx = lcx then
							l_pos := -1 + 77 -- skip if block
						end
				when 75 then -- if:
						l_pos := -1 + 78 -- goto _L___18
				when 76 then -- if block done, skip else block:
						l_pos := -1 + 79
				when 77 then -- else:
						if cy = lcy then
							l_pos := -1 + 79 -- skip if block
						end
				when 78 then -- if: | _L___18:
						Current.lcx := cx
						update_class_fields -- Current might have been changed; synchronize
						Current.lcy := cy
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/[")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_num_to_str (l_a, l_l, (cy + 1).to_integer_32)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (";")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_num_to_str (l_a, l_l, (cx + 1).to_integer_32)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_a, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("H")))
						update_class_fields -- Current might have been changed; synchronize
				when 79 then -- if done
						if (l_l.item).to_boolean then
							if master.to_boolean then
								(create {P_OS_DEP_STATIC}).want_draw
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						(create {P_TERMINAL_STATIC}).hard_write (fdout, l_a.item, l_l.item).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if (l_l.item).to_boolean then
							if master.to_boolean then
								(create {P_OS_DEP_STATIC}).done_draw
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 548, create {CE_VOID_POINTER}.make_cast (l_a.item))
						update_class_fields -- Current might have been changed; synchronize
						Current.dirty := 0
						update_class_fields -- Current might have been changed; synchronize
				when 80 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	destroy_terminal
		local
			l_tmp: INTEGER_32
		do
			from
			until
				(windows.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows")))
			loop
				(create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast (windows.next)).item.delete_window
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not title.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 556, create {CE_VOID_POINTER}.make_cast (title))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 557, create {CE_VOID_POINTER}.make_cast (screen))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 558, create {CE_VOID_POINTER}.make_cast (last_screen))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SELECT_STATIC}).set_handlers (fdin, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 560, create {CE_VOID_POINTER}.make_cast (input_queue))
			update_class_fields -- Current might have been changed; synchronize
			if blocked /= -1 then
				close (blocked).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SELECT_STATIC}).set_handlers (blocked, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (next)).item.prev := create {CE_VOID_POINTER}.make_cast (prev)
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (prev)).item.next := create {CE_VOID_POINTER}.make_cast (next)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
			close (fdin).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			if fdout /= 1 then
				if fdout /= fdin then
					close (fdout).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				unhandle_terminal_signals ((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer)))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_KBD_STATIC}).free_all_itrms
				update_class_fields -- Current might have been changed; synchronize
				if not (((create {P_TERMINAL_STATIC}).terminals.item.item.next).is_equal ((create {P_TERMINAL_STATIC}).terminals.item)) then
					l_tmp := fork
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp > 0 then
						exit2 (0)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 578, create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
			check_if_no_terminal
			update_class_fields -- Current might have been changed; synchronize
		end

	set_char (a_x, a_y: INTEGER_32; a_c: NATURAL_32)
		do
			Current.dirty := 1
			update_class_fields -- Current might have been changed; synchronize
			if a_x >= 0 then
				if a_x < x then
					if a_y >= 0 then
						if a_y < y then
							screen[(a_x + x * a_y)] := a_c
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				end
			end
		end

	get_char (a_x, a_y: INTEGER_32): NATURAL_32
		local
			l_x: INTEGER_32
			l_y: INTEGER_32
		do
			l_x := a_x
			l_y := a_y
			if l_x >= x then
				l_x := x - 1
			end
			if l_x < 0 then
				l_x := 0
			end
			if l_y >= y then
				l_y := y - 1
			end
			if l_y < 0 then
				l_y := 0
			end
			Result := (screen[(l_x + x * l_y)])
		end

	set_color (a_x, a_y: INTEGER_32; a_c: NATURAL_32)
		do
			Current.dirty := 1
			update_class_fields -- Current might have been changed; synchronize
			if a_x >= 0 then
				if a_x < x then
					if a_y >= 0 then
						if a_y < y then
							screen[(a_x + x * a_y)] := (((screen[(a_x + x * a_y)]).bit_and ({NATURAL_32} 33_023))).bit_or (((a_c).bit_and ({NATURAL_32} 4_294_934_272)))
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				end
			end
		end

	set_only_char (a_x, a_y: INTEGER_32; a_c: NATURAL_32)
		do
			Current.dirty := 1
			update_class_fields -- Current might have been changed; synchronize
			if a_x >= 0 then
				if a_x < x then
					if a_y >= 0 then
						if a_y < y then
							screen[(a_x + x * a_y)] := (((screen[(a_x + x * a_y)]).bit_and ({NATURAL_32} 4_294_934_272))).bit_or (((a_c).bit_and ({NATURAL_32} 33_023)))
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				end
			end
		end

	set_line (a_x, a_y, a_l: INTEGER_32; a_line: CE_POINTER [NATURAL_16])
		local
			l_i: INTEGER_32
			l_tmp: INTEGER_32
			l_break: BOOLEAN
		do
			Current.dirty := 1
			update_class_fields -- Current might have been changed; synchronize
			if a_x >= 0 then
				l_i := 0
			else
				l_i := -a_x
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if a_x + a_l <= x then
					l_tmp := a_l
				else
					l_tmp := x - a_x
				end
				if not (l_i < l_tmp) then
					l_break := True
				end
				if not (l_break) then
					screen[((a_x + l_i) + x * a_y)] := (a_line[l_i]).to_natural_32
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
			end
			l_break := False
		end

	set_line_color (a_x, a_y, a_l: INTEGER_32; a_c: NATURAL_32)
		local
			l_i: INTEGER_32
			l_tmp: INTEGER_32
			l_break: BOOLEAN
		do
			Current.dirty := 1
			update_class_fields -- Current might have been changed; synchronize
			if a_x >= 0 then
				l_i := 0
			else
				l_i := -a_x
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if a_x + a_l <= x then
					l_tmp := a_l
				else
					l_tmp := x - a_x
				end
				if not (l_i < l_tmp) then
					l_break := True
				end
				if not (l_break) then
					screen[((a_x + l_i) + x * a_y)] := (((screen[((a_x + l_i) + x * a_y)]).bit_and ({NATURAL_32} 33_023))).bit_or (((a_c).bit_and ({NATURAL_32} 4_294_934_272)))
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
			end
			l_break := False
		end

	fill_area (a_x, a_y, a_xw, a_yw: INTEGER_32; a_c: NATURAL_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			Current.dirty := 1
			update_class_fields -- Current might have been changed; synchronize
			if a_y >= 0 then
				l_j := 0
			else
				l_j := -a_y
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if l_j < a_yw then
					if not (a_y + l_j < y) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_return or l_break) then
					if a_x >= 0 then
						l_i := 0
					else
						l_i := -a_x
					end
					from
					until
						(l_break)
					loop
						l_break := False
						if l_i < a_xw then
							if not (a_x + l_i < x) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							screen[((a_x + l_i) + x * (a_y + l_j))] := a_c
							update_class_fields -- Current might have been changed; synchronize
							l_i := l_i + 1
						end
					end
					l_break := False
					l_j := l_j + 1
				end
			end
			l_break := False
		end

	draw_frame (a_x, a_y, a_xw, a_yw: INTEGER_32; a_c: NATURAL_32; a_w: INTEGER_32)
		local
			l_c: NATURAL_32
			l_p: CE_POINTER [INTEGER_32]
			l_tmp: CE_POINTER [INTEGER_32]
		do
			l_c := a_c
			if a_w > 1 then
				l_tmp := p2.item
			else
				l_tmp := p1.item
			end
			l_p := l_tmp
			l_c := (l_c).bit_or (({NATURAL_32} 32_768));
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.set_char (a_x, a_y, l_c + (l_p[0]).to_natural_32)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.set_char ((a_x + a_xw) - 1, a_y, l_c + (l_p[1]).to_natural_32)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.set_char (a_x, (a_y + a_yw) - 1, l_c + (l_p[2]).to_natural_32)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.set_char ((a_x + a_xw) - 1, (a_y + a_yw) - 1, l_c + (l_p[3]).to_natural_32)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.fill_area (a_x, a_y + 1, 1, a_yw - 2, l_c + (l_p[4]).to_natural_32)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.fill_area ((a_x + a_xw) - 1, a_y + 1, 1, a_yw - 2, l_c + (l_p[4]).to_natural_32)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.fill_area (a_x + 1, a_y, a_xw - 2, 1, l_c + (l_p[5]).to_natural_32)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.fill_area (a_x + 1, (a_y + a_yw) - 1, a_xw - 2, 1, l_c + (l_p[5]).to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
		end

	set_cursor (a_x, a_y, a_altx, a_alty: INTEGER_32)
		local
			l_x: INTEGER_32
			l_y: INTEGER_32
		do
			l_x := a_x
			l_y := a_y
			Current.dirty := 1
			update_class_fields -- Current might have been changed; synchronize
			if (spec.item.block_cursor).to_boolean then
				l_x := a_altx
				l_y := a_alty
			end
			if l_x >= x then
				l_x := x - 1
			end
			if l_y >= y then
				l_y := y - 1
			end
			if l_x < 0 then
				l_x := 0
			end
			if l_y < 0 then
				l_y := 0
			end
			Current.cx := l_x
			update_class_fields -- Current might have been changed; synchronize
			Current.cy := l_y
			update_class_fields -- Current might have been changed; synchronize
		end

	unblock_terminal
		do
			(create {P_TERMINAL_STATIC}).close_handle (create {CE_VOID_POINTER}.make_shared (default_pointer + blocked))
			update_class_fields -- Current might have been changed; synchronize
			Current.blocked := -1
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SELECT_STATIC}).set_handlers (fdin, (in_term_address), create {CE_ROUTINE}.make_shared (default_pointer), (destroy_terminal_address), create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_KBD_STATIC}).unblock_itrm (fdin).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.redraw_terminal_cls
			update_class_fields -- Current might have been changed; synchronize
		end

	set_xchar (a_x, a_y: INTEGER_32; a_dir: NATURAL_32)
		local
			l_c: NATURAL_32
			l_return: BOOLEAN
		do
			if a_x < 0 then
				l_return := True
			elseif a_x >= x then
				l_return := True
			elseif a_y < 0 then
				l_return := True
			elseif a_y >= y then
				l_return := True
			end
			if not l_return then
				l_c := ((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.get_char (a_x, a_y)
				update_class_fields -- Current might have been changed; synchronize
				if not ((l_c).bit_and ({NATURAL_32} 32_768)).to_boolean then
					l_return := True
				end
			end
			if not l_return then
				l_c := (l_c).bit_and (({NATURAL_32} 255))
				if l_c = ((fr_trans.item[(a_dir // {NATURAL_32} 2).to_integer_32])[0]).to_natural_32 then
					((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.set_only_char (a_x, a_y, ((((fr_trans.item[(a_dir // {NATURAL_32} 2).to_integer_32])[({NATURAL_32} 1 + ((a_dir).bit_and ({NATURAL_32} 1))).to_integer_32]).to_integer_32).bit_or (32_768)).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
				elseif l_c = ((fr_trans.item[(a_dir // {NATURAL_32} 2).to_integer_32])[({NATURAL_32} 2 - ((a_dir).bit_and ({NATURAL_32} 1))).to_integer_32]).to_natural_32 then
					((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.set_only_char (a_x, a_y, ((((fr_trans.item[(a_dir // {NATURAL_32} 2).to_integer_32])[3]).to_integer_32).bit_or (32_768)).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	open_in_new_window (a_xxx: CE_ROUTINE; a_ses: CE_POINTER [PD_SESSION])
		local
			l_mi: CE_ARRAY [CE_POINTER [PD_MENU_ITEM]]
			l_oin: CE_POINTER [PD_OPEN_IN_NEW]
			l_oi: CE_POINTER [PD_OPEN_IN_NEW]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_MENU_ITEM]} l_mi.make (<<1>>)

			l_oin := get_open_in_new (environment)
			update_class_fields -- Current might have been changed; synchronize
			if l_oin.is_void then
				l_return := True
			end
			if not l_return and then (((l_oin + 1).item.text).is_void) then
				a_xxx.call ([(create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer)), (l_oin + 0).item.fn, a_ses])
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_389, create {CE_VOID_POINTER}.make_cast (l_oin))
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_mi.item := (create {P_BFU_STATIC}).new_menu (1)
				update_class_fields -- Current might have been changed; synchronize
				if (l_mi.item).is_void then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_393, create {CE_VOID_POINTER}.make_cast (l_oin))
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
				l_oi := l_oin
				from
				until
					(l_oi.item.text).is_void
				loop
					(create {P_BFU_STATIC}).add_to_menu (l_mi, l_oi.item.text, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), l_oi.item.hk, a_xxx, create {CE_VOID_POINTER}.make_cast (l_oi.item.fn), 0)
					update_class_fields -- Current might have been changed; synchronize
					l_oi := l_oi + 1
				end
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_397, create {CE_VOID_POINTER}.make_cast (l_oin))
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_menu (l_mi.item, create {CE_VOID_POINTER}.make_cast (a_ses))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	can_open_in_new: INTEGER_32
		local
			l_oin: CE_POINTER [PD_OPEN_IN_NEW]
			l_tmp: CE_POINTER [PD_OPEN_IN_NEW]
			l_return: BOOLEAN
		do
			l_tmp := get_open_in_new (environment)
			update_class_fields -- Current might have been changed; synchronize
			l_oin := l_tmp
			if l_oin.is_void then
				Result := 0
				l_return := True
			end
			if not l_return and then (((l_oin + 1).item.text).is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_406, create {CE_VOID_POINTER}.make_cast (l_oin))
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
				l_return := True
			end
			if not l_return then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_409, create {CE_VOID_POINTER}.make_cast (l_oin))
				update_class_fields -- Current might have been changed; synchronize
				Result := 2
			end
		end

	do_menu_selected (a_items: CE_POINTER [PD_MENU_ITEM]; a_data: CE_POINTER [ANY]; a_selected: INTEGER_32)
		local
			l_menu: CE_POINTER [PD_MENU]
			l_tmp: CE_POINTER [ANY]
		do
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 67, (create {PD_MENU}.make).structure_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_menu := create {CE_CLASS_POINTER [PD_MENU]}.make_cast (l_tmp)
			l_menu.item.selected := a_selected
			update_class_fields -- Current might have been changed; synchronize
			l_menu.item.view := 0
			update_class_fields -- Current might have been changed; synchronize
			l_menu.item.items := a_items
			update_class_fields -- Current might have been changed; synchronize
			l_menu.item.data := a_data
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.add_window ((create {PD_WINDOW_STATIC}).menu_func_address, create {CE_VOID_POINTER}.make_cast (l_menu))
			update_class_fields -- Current might have been changed; synchronize
		end

	do_menu (a_items: CE_POINTER [PD_MENU_ITEM]; a_data: CE_POINTER [ANY])
		do
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_menu_selected (a_items, a_data, 0)
			update_class_fields -- Current might have been changed; synchronize
		end

	do_dialog (a_dlg: CE_POINTER [PD_DIALOG]; a_ml: CE_POINTER [PD_MEMORY_LIST])
		require
			not a_dlg.is_void
		local
			l_dd: CE_POINTER [PD_DIALOG_DATA]
			l_d: CE_POINTER [PD_DIALOG_ITEM]
			l_n: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			l_n := 0
			l_d := a_dlg.item.items
			from
			until
				not (not (l_return) and then (l_d.item.type /= 0))
			loop
				if l_n = 2_147_483_647 then
					from
					until
						False
					loop
						(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 448])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_KBD_STATIC}).fatal_tty_exit
						update_class_fields -- Current might have been changed; synchronize
						exit (4)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_n := l_n + 1
				l_d := l_d + 1
			end
			if l_n.to_natural_32 > ({NATURAL_32} 2_147_483_647 - (create {PD_DIALOG_DATA}.make).structure_size.to_natural_32) // (create {PD_DIALOG_ITEM_DATA}.make).structure_size.to_natural_32 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 451])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_KBD_STATIC}).fatal_tty_exit
					update_class_fields -- Current might have been changed; synchronize
					exit (4)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 452, (create {PD_DIALOG_DATA}.make).structure_size.to_natural_32 + (create {PD_DIALOG_ITEM_DATA}.make).structure_size.to_natural_32 * l_n.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_dd := create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_cast (l_tmp)
			l_dd.item.dlg := a_dlg
			update_class_fields -- Current might have been changed; synchronize
			l_dd.item.n := l_n
			update_class_fields -- Current might have been changed; synchronize
			l_dd.item.ml := a_ml
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.add_window ((create {PD_WINDOW_STATIC}).dialog_func_address, create {CE_VOID_POINTER}.make_cast (l_dd))
			update_class_fields -- Current might have been changed; synchronize
		end

	msg_box (a_args: TUPLE [a_ml: CE_POINTER [PD_MEMORY_LIST]; a_title: CE_POINTER [NATURAL_8]; a_align: INTEGER_32])
		local
			l_ml: CE_ARRAY [CE_POINTER [PD_MEMORY_LIST]]
			l_dlg: CE_POINTER [PD_DIALOG]
			l_i: INTEGER_32
			l_n: INTEGER_32
			l_text: CE_POINTER [NATURAL_8]
			l_udata: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_udata2: CE_POINTER [ANY]
			l_udatan: INTEGER_32
			l_ap: CE_VA_LIST
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [ANY]
			l_m: CE_POINTER [NATURAL_8]
			l_fn: CE_ROUTINE
			l_flags: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_MEMORY_LIST]} l_ml.make (<<1>>)
			create l_ap.make_shared (default_pointer)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ml.item := a_args.a_ml
					update_class_fields -- Current might have been changed; synchronize
					l_ap := create {CE_VA_LIST}.make (a_args, agent msg_box)
					l_udata := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer + -1)
					l_udatan := 0
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 5 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_text := (create {CE_NATURAL_8_POINTER}.make_cast (l_ap.pointer_item))
				when 3 then -- na_kovarne__to_je_narez:
						l_udatan := l_udatan + 1
						if l_udatan.to_natural_32 > {NATURAL_32} 2_147_483_647 // {PLATFORM}.Pointer_bytes.to_natural_32 then
							from
							until
								False
							loop
								(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 1_230])
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_KBD_STATIC}).fatal_tty_exit
								update_class_fields -- Current might have been changed; synchronize
								exit (4)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_tmp := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 1_231, create {CE_VOID_POINTER}.make_cast (l_udata), l_udatan.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_udata := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_tmp)
						l_udata[(l_udatan - 1)] := l_text
						update_class_fields -- Current might have been changed; synchronize
						if (not l_text.is_void) then
							if not ((a_args.a_align).bit_and (128)).to_boolean then
								l_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								l_pos := -1 + 3 -- goto na_kovarne__to_je_narez
							end
						end
				when 4 then
						if l_text.is_void then
							l_break := True
						end
						l_pos := -1 + 1 -- back to loop condition
				when 5 then -- loop done
					l_break := False
					l_udata2 := (create {CE_VOID_POINTER}.make_cast (l_ap.pointer_item))
					l_n := l_ap.integer_32_item
					if l_n.to_natural_32 > ({NATURAL_32} 2_147_483_647 - (create {PD_DIALOG}.make).structure_size.to_natural_32) // (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32 - {NATURAL_32} 1 then
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 1_240])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_KBD_STATIC}).fatal_tty_exit
							update_class_fields -- Current might have been changed; synchronize
							exit (4)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 1_241, (create {PD_DIALOG}.make).structure_size.to_natural_32 + (l_n + 1).to_natural_32 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_dlg := create {CE_CLASS_POINTER [PD_DIALOG]}.make_cast (l_tmp___0)
					memset (create {CE_VOID_POINTER}.make_cast (l_dlg), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + (l_n + 1).to_natural_32 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_dlg.item.title := a_args.a_title
					update_class_fields -- Current might have been changed; synchronize
					l_dlg.item.fn := (create {PD_DIALOG_DATA_STATIC}).msg_box_fn_address
					update_class_fields -- Current might have been changed; synchronize
					l_dlg.item.udata := create {CE_VOID_POINTER}.make_cast (l_udata)
					update_class_fields -- Current might have been changed; synchronize
					l_dlg.item.udata2 := l_udata2
					update_class_fields -- Current might have been changed; synchronize
					l_dlg.item.align := a_args.a_align
					update_class_fields -- Current might have been changed; synchronize
					l_i := 0
					from
					until
						not (l_i < l_n)
					loop
						l_continue := False
						l_m := (create {CE_NATURAL_8_POINTER}.make_cast (l_ap.pointer_item))
						l_fn := (create {CE_ROUTINE}.make_cast (l_ap.pointer_item))
						l_flags := l_ap.integer_32_item
						if l_m.is_void then
							l_i := l_i - 1
							l_n := l_n - 1
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							l_dlg.item.items[l_i].type := 4
							update_class_fields -- Current might have been changed; synchronize
							l_dlg.item.items[l_i].gid := l_flags
							update_class_fields -- Current might have been changed; synchronize
							l_dlg.item.items[l_i].fn := (create {PD_DIALOG_DATA_STATIC}).msg_box_button_address
							update_class_fields -- Current might have been changed; synchronize
							l_dlg.item.items[l_i].dlen := 0
							update_class_fields -- Current might have been changed; synchronize
							l_dlg.item.items[l_i].text := l_m
							update_class_fields -- Current might have been changed; synchronize
							l_dlg.item.items[l_i].udata := create {CE_VOID_POINTER}.make_cast (l_fn)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_i := l_i + 1
					end
					l_continue := False
					l_dlg.item.items[l_i].type := 0
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_BFU_STATIC}).add_to_ml ([l_ml, l_dlg, l_udata, create {CE_VOID_POINTER}.make_shared (default_pointer)])
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_dialog (l_dlg, l_ml.item)
					update_class_fields -- Current might have been changed; synchronize
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_bookmark_manager (a_fcp: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_d: CE_POINTER [PD_DIALOG]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [PD_MEMORY_LIST]
		do
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 661, (((create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 7 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32) + (create {PD_BOOKMARK}.make).structure_size.to_natural_32) + {NATURAL_32} 2_048)
			update_class_fields -- Current might have been changed; synchronize
			l_d := create {CE_CLASS_POINTER [PD_DIALOG]}.make_cast (l_tmp)
			memset (create {CE_VOID_POINTER}.make_cast (l_d), 0, (((create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 7 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32) + (create {PD_BOOKMARK}.make).structure_size.to_natural_32) + {NATURAL_32} 2_048).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.title := (create {P_LINKS_STATIC}).dummyarray.item + 271
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.fn := (create {PD_DIALOG_DATA_STATIC}).layout_bookmark_manager_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.handle_event := (create {P_BOOKMARK_STATIC}).bookmark_dialog_event_handler_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.abort := (create {PD_DIALOG_DATA_STATIC}).bookmark_dialog_abort_handler_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.udata := create {CE_VOID_POINTER}.make_cast (a_ses)
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].fn := (create {PD_DIALOG_DATA_STATIC}).push_goto_button_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].udata := create {CE_VOID_POINTER}.make_cast (a_ses)
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].text := (create {P_LINKS_STATIC}).dummyarray.item + 265
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].fn := (create {PD_DIALOG_DATA_STATIC}).push_edit_button_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].udata := create {CE_VOID_POINTER}.make_cast (a_ses)
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].text := (create {P_LINKS_STATIC}).dummyarray.item + 266
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].fn := (create {PD_DIALOG_DATA_STATIC}).push_delete_button_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].text := (create {P_LINKS_STATIC}).dummyarray.item + 102
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].fn := (create {PD_DIALOG_DATA_STATIC}).push_add_button_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].text := (create {P_LINKS_STATIC}).dummyarray.item + 100
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].gid := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].fn := (create {PD_DIALOG_DATA_STATIC}).cancel_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].text := (create {P_LINKS_STATIC}).dummyarray.item + 267
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].type := 5
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].gid := 12
			update_class_fields -- Current might have been changed; synchronize
			bookmark_dlg_box_build (create {CE_POINTER_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (l_d.c_pointer + (create {PD_DIALOG}.make).offset_of ("items") + (create {PD_DIALOG_ITEM}.make).structure_size * (5) + (create {PD_DIALOG_ITEM}.make).offset_of ("data"))))).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].type := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_d), create {CE_VOID_POINTER}.make_shared (default_pointer)])
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_dialog (l_d, l_tmp___0)
			update_class_fields -- Current might have been changed; synchronize
		end

	bookmark_edit_dialog (a_title, a_src_name, a_src_url: CE_POINTER [NATURAL_8]; a_ses: CE_POINTER [PD_SESSION]; a_parent: CE_POINTER [PD_DIALOG_DATA]; a_when_done: CE_ROUTINE; a_done_data: CE_POINTER [ANY])
		local
			l_name: CE_POINTER [NATURAL_8]
			l_url: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [PD_DIALOG]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [PD_MEMORY_LIST]
		do
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 822, (((create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 5 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32) + (create {PD_EXTENSION}.make).structure_size.to_natural_32) + {NATURAL_32} 2_048)
			update_class_fields -- Current might have been changed; synchronize
			l_d := create {CE_CLASS_POINTER [PD_DIALOG]}.make_cast (l_tmp)
			memset (create {CE_VOID_POINTER}.make_cast (l_d), 0, (((create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 5 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32) + (create {PD_EXTENSION}.make).structure_size.to_natural_32) + {NATURAL_32} 2_048).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_name := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_DIALOG_ITEM]}.make_shared (l_d.c_pointer + (create {PD_DIALOG}.make).offset_of ("items") + (create {PD_DIALOG_ITEM}.make).structure_size * (5))))
			l_url := l_name + 1_024
			if a_src_name.is_void then
				get_current_title (a_ses, l_name, (1_024).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			else
				(create {P_LINKS_STATIC}).safe_strncpy (l_name, a_src_name, (1_024).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			if a_src_url.is_void then
				get_current_url (a_ses, l_url, (1_024).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			else
				(create {P_LINKS_STATIC}).safe_strncpy (l_url, a_src_url, (1_024).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			l_d.item.title := a_title
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.fn := (create {PD_DIALOG_DATA_STATIC}).layout_add_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.refresh := a_when_done
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.refresh_data := create {CE_VOID_POINTER}.make_cast (l_d)
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.udata := create {CE_VOID_POINTER}.make_cast (a_parent)
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.udata2 := a_done_data
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].dlen := 1_024
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].data := l_name
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].fn := (create {P_BFU_STATIC}).check_nonempty_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].dlen := 1_024
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].data := l_url
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].fn := (create {P_BFU_STATIC}).check_nonempty_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].fn := (create {PD_DIALOG_DATA_STATIC}).ok_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].text := (create {P_LINKS_STATIC}).dummyarray.item + 14
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].gid := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].text := (create {P_LINKS_STATIC}).dummyarray.item + 6
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].fn := (create {PD_DIALOG_DATA_STATIC}).cancel_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].type := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_d), create {CE_VOID_POINTER}.make_shared (default_pointer)])
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_dialog (l_d, l_tmp___0)
			update_class_fields -- Current might have been changed; synchronize
		end

	do_select_submenu (a_menu: CE_POINTER [PD_MENU_ITEM]; a_ses: CE_POINTER [PD_SESSION])
		require
			not a_menu.is_void
		local
			l_m: CE_POINTER [PD_MENU_ITEM]
			l_def: INTEGER_32
			l_tmp: INTEGER_32
			l_sel: INTEGER_32
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := get_current_state (a_ses)
					update_class_fields -- Current might have been changed; synchronize
					l_def := l_tmp
					l_sel := 0
					if l_def < 0 then
						l_def := 0
					end
					l_m := a_menu
				when 1 then -- loop condition:
					if (l_m.item.text).is_void then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						l_tmp___0 := menu_contains (l_m, l_def)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0.to_boolean then
							l_pos := -1 + 5 -- goto f
						end
				when 3 then
						l_m := l_m + 1
						l_sel := l_sel + 1
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					l_sel := 0
				when 5 then -- f:;
					((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_menu_selected (a_menu, create {CE_VOID_POINTER}.make_cast (a_ses), l_sel)
					update_class_fields -- Current might have been changed; synchronize
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_about (a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 12, 1, (create {P_LINKS_STATIC}).dummyarray.item + 13, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 14, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
			update_class_fields -- Current might have been changed; synchronize
		end

	menu_keys (a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 15, 0, (create {P_LINKS_STATIC}).dummyarray.item + 16, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 14, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
			update_class_fields -- Current might have been changed; synchronize
		end

	menu_copying (a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 17, 1, (create {P_LINKS_STATIC}).dummyarray.item + 18, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 14, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
			update_class_fields -- Current might have been changed; synchronize
		end

	assumed_codepage (a_pcp: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		require
			not a_ses.is_void
		local
			l_cp: INTEGER_32
		do
			l_cp := (a_pcp.c_pointer.to_integer_32).to_integer_32
			a_ses.item.ds.assume_cp := l_cp
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.redraw_terminal_cls
			update_class_fields -- Current might have been changed; synchronize
		end

	net_options (a_xxx, a_yyy: CE_POINTER [ANY])
		local
			l_d: CE_POINTER [PD_DIALOG]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [PD_MEMORY_LIST]
		do
			(create {P_LINKS_STATIC}).snprint ((create {P_MENU_STATIC}).max_c_str.item, 3, ((create {P_DEFAULT_STATIC}).max_connections.item.item).to_integer_32).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).snprint ((create {P_MENU_STATIC}).max_cth_str.item, 3, ((create {P_DEFAULT_STATIC}).max_connections_to_host.item.item).to_integer_32).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).snprint ((create {P_MENU_STATIC}).max_t_str.item, 3, ((create {P_DEFAULT_STATIC}).max_tries.item.item).to_integer_32).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).snprint ((create {P_MENU_STATIC}).time_str.item, 5, ((create {P_DEFAULT_STATIC}).receive_timeout.item.item).to_integer_32).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).snprint ((create {P_MENU_STATIC}).unrtime_str.item, 5, ((create {P_DEFAULT_STATIC}).unrestartable_receive_timeout.item.item).to_integer_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 657, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 14 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_d := create {CE_CLASS_POINTER [PD_DIALOG]}.make_cast (l_tmp)
			memset (create {CE_VOID_POINTER}.make_cast (l_d), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 14 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.title := (create {P_LINKS_STATIC}).dummyarray.item + 67
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.fn := (create {PD_DIALOG_DATA_STATIC}).netopt_fn_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.refresh := (create {P_MENU_STATIC}).refresh_net_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].dlen := 1_024
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].data := (create {P_DEFAULT_STATIC}).http_proxy.item
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].dlen := 1_024
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].data := (create {P_DEFAULT_STATIC}).ftp_proxy.item
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].data := (create {P_MENU_STATIC}).max_c_str.item
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].dlen := 3
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].fn := (create {P_BFU_STATIC}).check_number_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].gnum := 99
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].data := (create {P_MENU_STATIC}).max_cth_str.item
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].dlen := 3
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].fn := (create {P_BFU_STATIC}).check_number_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].gnum := 99
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].data := (create {P_MENU_STATIC}).max_t_str.item
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].dlen := 3
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].fn := (create {P_BFU_STATIC}).check_number_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].gid := 0
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].gnum := 16
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].data := (create {P_MENU_STATIC}).time_str.item
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].dlen := 5
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].fn := (create {P_BFU_STATIC}).check_number_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].gnum := 1_800
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].data := (create {P_MENU_STATIC}).unrtime_str.item
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].dlen := 5
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].fn := (create {P_BFU_STATIC}).check_number_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].gnum := 1_800
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[7].type := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[7].data := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_DEFAULT_STATIC}).async_lookup.item))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[7].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[8].type := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[8].data := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_DEFAULT_STATIC}).download_utime.item))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[8].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[9].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[9].gid := 0
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[9].fn := (create {PD_DIALOG_DATA_STATIC}).dlg_http_options_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[9].text := (create {P_LINKS_STATIC}).dummyarray.item + 277
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[9].data := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_DEFAULT_STATIC}).http_bugs.item))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[9].dlen := ((create {PD_HTTP_BUGS}.make).structure_size.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[10].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[10].gid := 0
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[10].fn := (create {PD_DIALOG_DATA_STATIC}).dlg_ftp_options_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[10].text := (create {P_LINKS_STATIC}).dummyarray.item + 278
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[10].data := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_DEFAULT_STATIC}).ftp_options.item))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[10].dlen := ((create {PD_FTP_OPTIONS}.make).structure_size.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[11].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[11].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[11].fn := (create {PD_DIALOG_DATA_STATIC}).ok_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[11].text := (create {P_LINKS_STATIC}).dummyarray.item + 14
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[12].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[12].gid := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[12].fn := (create {PD_DIALOG_DATA_STATIC}).cancel_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[12].text := (create {P_LINKS_STATIC}).dummyarray.item + 6
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[13].type := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_d), create {CE_VOID_POINTER}.make_shared (default_pointer)])
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_dialog (l_d, l_tmp___0)
			update_class_fields -- Current might have been changed; synchronize
		end

	net_programs (a_xxx, a_yyy: CE_POINTER [ANY])
		local
			l_d: CE_POINTER [PD_DIALOG]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [PD_MEMORY_LIST]
		do
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 791, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 7 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_d := create {CE_CLASS_POINTER [PD_DIALOG]}.make_cast (l_tmp)
			memset (create {CE_VOID_POINTER}.make_cast (l_d), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 7 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.title := (create {P_LINKS_STATIC}).dummyarray.item + 294
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.fn := (create {PD_DIALOG_DATA_STATIC}).netprog_fn_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].dlen := 1_024
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].data := ((create {P_TYPES_STATIC}).mailto_prog.item).item.get_prog
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].dlen := 1_024
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].data := ((create {P_TYPES_STATIC}).telnet_prog.item).item.get_prog
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].dlen := 1_024
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].data := ((create {P_TYPES_STATIC}).tn3270_prog.item).item.get_prog
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].dlen := 1_024
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].data := ((create {P_TYPES_STATIC}).mms_prog.item).item.get_prog
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].fn := (create {PD_DIALOG_DATA_STATIC}).ok_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].text := (create {P_LINKS_STATIC}).dummyarray.item + 14
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].gid := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].fn := (create {PD_DIALOG_DATA_STATIC}).cancel_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].text := (create {P_LINKS_STATIC}).dummyarray.item + 6
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].type := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_d), create {CE_VOID_POINTER}.make_shared (default_pointer)])
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_dialog (l_d, l_tmp___0)
			update_class_fields -- Current might have been changed; synchronize
		end

	cache_opt (a_xxx, a_yyy: CE_POINTER [ANY])
		local
			l_d: CE_POINTER [PD_DIALOG]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [PD_MEMORY_LIST]
		do
			(create {P_LINKS_STATIC}).snprint ((create {P_MENU_STATIC}).mc_str.item, 8, (create {P_DEFAULT_STATIC}).memory_cache_size.item.item // 1_024).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).snprint ((create {P_MENU_STATIC}).doc_str.item, 4, ((create {P_DEFAULT_STATIC}).max_format_cache_entries.item.item).to_integer_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 846, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 5 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_d := create {CE_CLASS_POINTER [PD_DIALOG]}.make_cast (l_tmp)
			memset (create {CE_VOID_POINTER}.make_cast (l_d), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 5 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.title := (create {P_LINKS_STATIC}).dummyarray.item + 70
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.fn := (create {PD_DIALOG_DATA_STATIC}).group_fn_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.udata := create {CE_VOID_POINTER}.make_cast (cache_texts.item)
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.refresh := (create {P_MENU_STATIC}).cache_refresh_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].dlen := 8
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].data := (create {P_MENU_STATIC}).mc_str.item
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].fn := (create {P_BFU_STATIC}).check_number_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].gid := 0
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].gnum := 2_147_483_647
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].dlen := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].data := (create {P_MENU_STATIC}).doc_str.item
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].fn := (create {P_BFU_STATIC}).check_number_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].gid := 0
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].gnum := 256
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].fn := (create {PD_DIALOG_DATA_STATIC}).ok_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].text := (create {P_LINKS_STATIC}).dummyarray.item + 14
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].gid := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].fn := (create {PD_DIALOG_DATA_STATIC}).cancel_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].text := (create {P_LINKS_STATIC}).dummyarray.item + 6
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].type := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_d), create {CE_VOID_POINTER}.make_shared (default_pointer)])
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_dialog (l_d, l_tmp___0)
			update_class_fields -- Current might have been changed; synchronize
		end

	menu_html_options (a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		require
			not a_ses.is_void
		local
			l_d: CE_POINTER [PD_DIALOG]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [PD_MEMORY_LIST]
		do
			(create {P_LINKS_STATIC}).snprint ((create {P_MENU_STATIC}).marg_str.item, 2, (a_ses.item.ds.margin).to_integer_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 918, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 11 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_d := create {CE_CLASS_POINTER [PD_DIALOG]}.make_cast (l_tmp)
			memset (create {CE_VOID_POINTER}.make_cast (l_d), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 11 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.title := (create {P_LINKS_STATIC}).dummyarray.item + 78
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.fn := (create {PD_DIALOG_DATA_STATIC}).group_fn_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.udata := create {CE_VOID_POINTER}.make_cast (html_texts.item)
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.udata2 := create {CE_VOID_POINTER}.make_cast (a_ses)
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.refresh := ((create {PD_SESSION_STATIC}).html_refresh_address)
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.refresh_data := create {CE_VOID_POINTER}.make_cast (a_ses)
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].type := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("ds") + (create {PD_DOCUMENT_SETUP}.make).offset_of ("tables"))))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].type := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("ds") + (create {PD_DOCUMENT_SETUP}.make).offset_of ("frames"))))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].type := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("ds") + (create {PD_DOCUMENT_SETUP}.make).offset_of ("images"))))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].type := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("ds") + (create {PD_DOCUMENT_SETUP}.make).offset_of ("table_order"))))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].type := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("ds") + (create {PD_DOCUMENT_SETUP}.make).offset_of ("num_links"))))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].dlen := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].data := (create {P_MENU_STATIC}).marg_str.item
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].fn := (create {P_BFU_STATIC}).check_number_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].gid := 0
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].gnum := 9
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].gid := 0
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].fn := (create {PD_DIALOG_DATA_STATIC}).dlg_assume_cp_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].text := (create {P_LINKS_STATIC}).dummyarray.item + 79
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("ds") + (create {PD_DOCUMENT_SETUP}.make).offset_of ("assume_cp"))))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[7].type := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[7].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("ds") + (create {PD_DOCUMENT_SETUP}.make).offset_of ("hard_assume"))))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[7].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[8].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[8].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[8].fn := (create {PD_DIALOG_DATA_STATIC}).ok_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[8].text := (create {P_LINKS_STATIC}).dummyarray.item + 14
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[9].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[9].gid := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[9].fn := (create {PD_DIALOG_DATA_STATIC}).cancel_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[9].text := (create {P_LINKS_STATIC}).dummyarray.item + 6
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[10].type := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_d), create {CE_VOID_POINTER}.make_shared (default_pointer)])
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_dialog (l_d, l_tmp___0)
			update_class_fields -- Current might have been changed; synchronize
		end

	do_view_menu (a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			if not ((create {P_DEFAULT_STATIC}).anonymous.item).to_boolean then
				((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_menu (view_menu.item, create {CE_VOID_POINTER}.make_cast (a_ses))
				update_class_fields -- Current might have been changed; synchronize
			else
				((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_menu (view_menu_anon.item, create {CE_VOID_POINTER}.make_cast (a_ses))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	do_setup_menu (a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			if not ((create {P_DEFAULT_STATIC}).anonymous.item).to_boolean then
				((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_menu (setup_menu.item, create {CE_VOID_POINTER}.make_cast (a_ses))
				update_class_fields -- Current might have been changed; synchronize
			else
				((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.do_menu (setup_menu_anon.item, create {CE_VOID_POINTER}.make_cast (a_ses))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	launch_bm_add_doc_dialog (a_parent: CE_POINTER [PD_DIALOG_DATA]; a_ses: CE_POINTER [PD_SESSION])
		do
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.bookmark_edit_dialog ((create {P_LINKS_STATIC}).dummyarray.item + 264, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), a_ses, a_parent, (create {PD_DIALOG_STATIC}).bookmark_add_add_address, create {CE_VOID_POINTER}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	launch_bm_add_link_dialog (a_parent: CE_POINTER [PD_DIALOG_DATA]; a_ses: CE_POINTER [PD_SESSION])
		require
			not a_ses.is_void
		local
			l_url: CE_ARRAY [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_url.make (<<1_024>>)

			l_tmp := a_ses.item.get_current_link_url (l_url, (1_024).to_natural_32)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (c_pointer))).item.bookmark_edit_dialog ((create {P_LINKS_STATIC}).dummyarray.item + 264, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_tmp, a_ses, a_parent, (create {PD_DIALOG_STATIC}).bookmark_add_add_address, create {CE_VOID_POINTER}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_TERMINAL} -- private routines

	cache_info (a_type: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_ce: CE_POINTER [PD_CACHE_ENTRY]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i := 0
					inspect a_type -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 4 then l_pos := -1 + 4
					when 9 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 1
					Result := ((create {P_CACHE_STATIC}).cache_size.item)
					l_return := True
				when 2 then -- switch 1, case 2
					if not l_return then
						l_ce := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_cast ((create {P_CACHE_STATIC}).cache.item.item.next)
						from
						until
							l_ce.is_equal ((create {P_CACHE_STATIC}).cache.item)
						loop
							l_i := l_i + 1
							l_ce := l_ce.item.next
						end
						Result := l_i.to_integer_32
						l_return := True
					end
				when 3 then -- switch 1, case 3
					if not l_return then
						l_ce := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_cast ((create {P_CACHE_STATIC}).cache.item.item.next)
						from
						until
							l_ce.is_equal ((create {P_CACHE_STATIC}).cache.item)
						loop
							l_i := l_i + ((l_ce.item.refcount).to_boolean).to_integer
							l_ce := l_ce.item.next
						end
						Result := l_i.to_integer_32
						l_return := True
					end
				when 4 then -- switch 1, case 4
					if not l_return then
						l_ce := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_cast ((create {P_CACHE_STATIC}).cache.item.item.next)
						from
						until
							l_ce.is_equal ((create {P_CACHE_STATIC}).cache.item)
						loop
							l_i := l_i + ((create {P_SCHED_STATIC}).is_entry_used (l_ce))
							l_ce := l_ce.item.next
						end
						Result := l_i.to_integer_32
						l_return := True
					end
				when 5 then -- switch 1, case 9
					if not l_return then
						Result := (((create {P_CACHE_STATIC}).cache.item).c_pointer.to_integer_32).to_integer_32
						l_return := True
					end
				when 6 then -- switch 1, default:
					if not l_return then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c"));
							(create {P_LINKS_STATIC}).errline.item := 28;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache_info: bad request"))])
						end
					end
				when 7 then -- switch 1, done:
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_open_in_new (a_environment: INTEGER_32): CE_POINTER [PD_OPEN_IN_NEW]
		local
			l_i: INTEGER_32
			l_oin: CE_POINTER [PD_OPEN_IN_NEW]
			l_noin: INTEGER_32
			l_return: BOOLEAN
		do
			l_oin := create {CE_CLASS_POINTER [PD_OPEN_IN_NEW]}.make_shared (default_pointer + -1)
			l_noin := 0
			if ((create {P_DEFAULT_STATIC}).anonymous.item).to_boolean then
				Result := (create {CE_CLASS_POINTER [PD_OPEN_IN_NEW]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := 0
				from
				until
					not (not (l_return) and then ((oinw.item[l_i].env).to_boolean))
				loop
					if ((a_environment).bit_and (oinw.item[l_i].env)) = oinw.item[l_i].env then
						if l_noin.to_natural_32 > {NATURAL_32} 2_147_483_647 // (create {PD_OPEN_IN_NEW}.make).structure_size.to_natural_32 - {NATURAL_32} 2 then
							from
							until
								False
							loop
								(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("os_dep.c"), 1_738]);
								(create {P_KBD_STATIC}).fatal_tty_exit
								exit (4)
							end
						end
						l_oin := create {CE_CLASS_POINTER [PD_OPEN_IN_NEW]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("os_dep.c")), 1_739, create {CE_VOID_POINTER}.make_cast (l_oin), (l_noin + 2).to_natural_32 * (create {PD_OPEN_IN_NEW}.make).structure_size.to_natural_32)));
						(l_oin + l_noin).item.text := oinw.item[l_i].text;
						(l_oin + l_noin).item.hk := oinw.item[l_i].hk;
						(l_oin + l_noin).item.fn := oinw.item[l_i].fn
						l_noin := l_noin + 1;
						(l_oin + l_noin).item.text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
						(l_oin + l_noin).item.hk := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
						(l_oin + l_noin).item.fn := create {CE_ROUTINE}.make_shared (default_pointer)
					end
					l_i := l_i + 1
				end
				if (l_oin.c_pointer.to_integer_32).to_natural_32 = ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
					Result := (create {CE_CLASS_POINTER [PD_OPEN_IN_NEW]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				Result := l_oin
			end
		end

	bookmark_dlg_box_build (a_box: CE_POINTER [CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]]): CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]
		require
			not a_box.is_void
		do
			a_box.item := create {CE_CLASS_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 293, (create {PD_DLG_DATA_ITEM_DATA_BOX}.make).structure_size.to_natural_32)))
			memset (create {CE_VOID_POINTER}.make_cast (a_box.item), 0, (create {PD_DLG_DATA_ITEM_DATA_BOX}.make).structure_size.to_natural_32).do_nothing;
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((a_box.item).c_pointer + (create {PD_DLG_DATA_ITEM_DATA_BOX}.make).offset_of ("items")))));
			(a_box.item).item.items.next := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((a_box.item).c_pointer + (create {PD_DLG_DATA_ITEM_DATA_BOX}.make).offset_of ("items"))));
			(a_box.item).item.items.prev := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((a_box.item).c_pointer + (create {PD_DLG_DATA_ITEM_DATA_BOX}.make).offset_of ("items"))));
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((a_box.item).c_pointer + (create {PD_DLG_DATA_ITEM_DATA_BOX}.make).offset_of ("items")))));
			(a_box.item).item.list_len := (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((a_box.item).c_pointer + (create {PD_DLG_DATA_ITEM_DATA_BOX}.make).offset_of ("items"))).item.bookmark_dlg_list_update
			Result := (a_box.item)
		end

	menu_contains (a_m: CE_POINTER [PD_MENU_ITEM]; a_f: INTEGER_32): INTEGER_32
		require
			not a_m.is_void
		local
			l_m: CE_POINTER [PD_MENU_ITEM]
			l_return: BOOLEAN
		do
			l_m := a_m
			if not (l_m.item.func).is_equal (do_select_submenu_address) then
				Result := (((l_m.item.data).c_pointer.to_integer_32).to_integer_32 = a_f).to_integer
				l_return := True
			end
			if not l_return then
				l_m := create {CE_CLASS_POINTER [PD_MENU_ITEM]}.make_cast (l_m.item.data)
				from
				until
					not (not (l_return) and then (not (l_m.item.text).is_void))
				loop
					if (menu_contains (l_m, a_f)).to_boolean then
						Result := 1
						l_return := True
					end
					if not l_return then
						l_m := l_m + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	formatted_info (a_type: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_ce: CE_POINTER [PD_F_DATA]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i := 0
					inspect a_type -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					l_ce := create {CE_CLASS_POINTER [PD_F_DATA]}.make_cast ((create {P_HTML_R_STATIC}).format_cache.item.item.next)
					from
					until
						l_ce.is_equal ((create {P_HTML_R_STATIC}).format_cache.item)
					loop
						l_i := l_i + 1
						l_ce := l_ce.item.next
					end
					Result := l_i.to_integer_32
					l_return := True
				when 2 then -- switch 1, case 3
					if not l_return then
						l_ce := create {CE_CLASS_POINTER [PD_F_DATA]}.make_cast ((create {P_HTML_R_STATIC}).format_cache.item.item.next)
						from
						until
							l_ce.is_equal ((create {P_HTML_R_STATIC}).format_cache.item)
						loop
							l_i := l_i + ((l_ce.item.refcount).to_boolean).to_integer
							l_ce := l_ce.item.next
						end
						Result := l_i.to_integer_32
						l_return := True
					end
				when 3 then -- switch 1, default:
					if not l_return then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c"));
							(create {P_LINKS_STATIC}).errline.item := 1_190;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("formatted_info: bad request"))])
						end
					end
				when 4 then -- switch 1, done:
					if not l_return then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	unhandle_terminal_signals (a_term: CE_POINTER [PD_TERMINAL])
		do
			(create {P_SELECT_STATIC}).install_signal_handler (1, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0);
			(create {P_SELECT_STATIC}).install_signal_handler (2, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0);
			(create {P_SELECT_STATIC}).install_signal_handler (20, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0);
			(create {P_SELECT_STATIC}).install_signal_handler (21, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0);
			(create {P_SELECT_STATIC}).install_signal_handler (22, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0);
			(create {P_SELECT_STATIC}).install_signal_handler (18, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
			if (create {P_MAIN_STATIC}).fg_poll_timer.item /= -1 then
				(create {P_SELECT_STATIC}).kill_timer ((create {P_MAIN_STATIC}).fg_poll_timer.item);
				(create {P_MAIN_STATIC}).fg_poll_timer.item := -1
			end
		end

	can_resize_window (a_environment: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((a_environment).bit_and (36)).to_boolean then
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	can_open_os_shell (a_environment: INTEGER_32): INTEGER_32
		do
			Result := 1
		end

	connect_info (a_type: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_ce: CE_POINTER [PD_CONNECTION]
			l_cee: CE_POINTER [PD_K_CONN]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i := 0
					inspect a_type -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 7 then l_pos := -1 + 2
					when 6 then l_pos := -1 + 3
					when 8 then l_pos := -1 + 4
					when 9 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 2
					l_ce := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast ((create {P_SCHED_STATIC}).queue.item.item.next)
					from
					until
						l_ce.is_equal ((create {P_SCHED_STATIC}).queue.item)
					loop
						l_i := l_i + 1
						l_ce := l_ce.item.next
					end
					Result := l_i.to_integer_32
					l_return := True
				when 2 then -- switch 1, case 7
					if not l_return then
						l_ce := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast ((create {P_SCHED_STATIC}).queue.item.item.next)
						from
						until
							l_ce.is_equal ((create {P_SCHED_STATIC}).queue.item)
						loop
							if l_ce.item.state > 0 then
								if l_ce.item.state < 8 then
									l_tmp := 1
								else
									l_tmp := 0
								end
							else
								l_tmp := 0
							end
							l_i := l_i + l_tmp
							l_ce := l_ce.item.next
						end
						Result := l_i.to_integer_32
						l_return := True
					end
				when 3 then -- switch 1, case 6
					if not l_return then
						l_ce := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast ((create {P_SCHED_STATIC}).queue.item.item.next)
						from
						until
							l_ce.is_equal ((create {P_SCHED_STATIC}).queue.item)
						loop
							l_i := l_i + (l_ce.item.state = 8).to_integer
							l_ce := l_ce.item.next
						end
						Result := l_i.to_integer_32
						l_return := True
					end
				when 4 then -- switch 1, case 8
					if not l_return then
						l_cee := create {CE_CLASS_POINTER [PD_K_CONN]}.make_cast ((create {P_SCHED_STATIC}).keepalive_connections.item.item.next)
						from
						until
							l_cee.is_equal ((create {P_SCHED_STATIC}).keepalive_connections.item)
						loop
							l_i := l_i + 1
							l_cee := l_cee.item.next
						end
						Result := l_i.to_integer_32
						l_return := True
					end
				when 5 then -- switch 1, case 9
					if not l_return then
						Result := (((create {P_SCHED_STATIC}).queue.item).c_pointer.to_integer_32).to_integer_32
						l_return := True
					end
				when 6 then -- switch 1, default:
					if not l_return then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c"));
							(create {P_LINKS_STATIC}).errline.item := 41;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache_info: bad request"))])
						end
					end
				when 7 then -- switch 1, done:
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	select_info (a_type: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_ce: CE_POINTER [PD_CACHE_ENTRY]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i := 0
					inspect a_type -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 5 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					l_j := 0
					from
					until
						not (l_j < 1_024)
					loop
						if (not ((create {P_SELECT_STATIC}).threads.item[l_j].read_func).is_void) then
							l_i := l_i + 1
						elseif (not ((create {P_SELECT_STATIC}).threads.item[l_j].write_func).is_void) then
							l_i := l_i + 1
						elseif (not ((create {P_SELECT_STATIC}).threads.item[l_j].error_func).is_void) then
							l_i := l_i + 1
						end
						l_j := l_j + 1
					end
					Result := l_i.to_integer_32
					l_return := True
				when 2 then -- switch 1, case 5
					if not l_return then
						l_ce := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_cast ((create {P_SELECT_STATIC}).timers.item.item.next)
						from
						until
							l_ce.is_equal ((create {P_SELECT_STATIC}).timers.item)
						loop
							l_i := l_i + 1
							l_ce := l_ce.item.next
						end
						Result := l_i.to_integer_32
						l_return := True
					end
				when 3 then -- switch 1, default:
					if not l_return then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("select.c"));
							(create {P_LINKS_STATIC}).errline.item := 55;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache_info: bad request"))])
						end
					end
				when 4 then -- switch 1, done:
					if not l_return then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_current_url (a_ses: CE_POINTER [PD_SESSION]; a_str: CE_POINTER [NATURAL_8]; a_str_size: NATURAL_32): CE_POINTER [NATURAL_8]
		require
			not a_ses.is_void
		local
			l_here: CE_POINTER [NATURAL_8]
			l_end_of_url: CE_POINTER [NATURAL_8]
			l_url_len: NATURAL_32
			l_return: BOOLEAN
		do
			l_url_len := (0).to_natural_32
			if (a_ses.item.history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_here := (create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).item.vs.url
				l_end_of_url := create {CE_NATURAL_8_POINTER}.make_cast ((strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_here), 1)))
				if (not l_end_of_url.is_void) then
					l_url_len := (l_end_of_url.distance (l_here)).to_natural_32
				else
					l_url_len := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_here))
				end
				if l_url_len >= a_str_size then
					l_url_len := a_str_size - {NATURAL_32} 1
				end
				strncpy (create {CE_INTEGER_8_POINTER}.make_cast (a_str), create {CE_INTEGER_8_POINTER}.make_cast (l_here), l_url_len).do_nothing
				a_str[l_url_len.to_integer_32] := (('%/0/').code).to_natural_8
				Result := a_str
			end
		end

	get_current_title (a_ses: CE_POINTER [PD_SESSION]; a_str: CE_POINTER [NATURAL_8]; a_str_size: NATURAL_32): CE_POINTER [NATURAL_8]
		require
			not a_ses.is_void
		local
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_return: BOOLEAN
		do
			l_fd := (a_ses.item.current_frame)
			if l_fd.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := ((create {P_LINKS_STATIC}).safe_strncpy (a_str, (l_fd.item.f_data).item.title, a_str_size))
			end
		end

	getcompcode (a_c: INTEGER_32): INTEGER_32
		do
			Result := ((((((a_c).bit_shift_left (1))).bit_or (((((a_c).bit_and (4))).bit_shift_right (2))))).bit_and (7))
		end

	check_if_no_terminal
		local
			l_return: BOOLEAN
		do
			if not (((create {P_TERMINAL_STATIC}).terminals.item.item.next).is_equal ((create {P_TERMINAL_STATIC}).terminals.item)) then
				l_return := True
			end
			if not l_return then
				(create {P_SELECT_STATIC}).terminate.item := 1
			end
		end

	get_current_state (a_ses: CE_POINTER [PD_SESSION]): INTEGER_32
		require
			not a_ses.is_void
		local
			l_f: CE_POINTER [PD_F_DATA_C]
			l_l: CE_POINTER [PD_LINK]
			l_fs: CE_POINTER [PD_FORM_STATE]
			l_return: BOOLEAN
		do
			l_f := (a_ses.item.current_frame)
			if l_f.is_void then
				Result := (-1)
				l_return := True
			end
			if not l_return and then ((l_f.item.vs).item.current_link = -1) then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_l := (l_f.item.f_data).item.links + (l_f.item.vs).item.current_link
				if l_l.item.type /= 3 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_fs := l_f.item.find_form_state (l_l.item.form)
				if (not l_fs.is_void) then
					Result := (l_fs.item.state)
					l_return := True
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			master := a_other.master
			fdin := a_other.fdin
			fdout := a_other.fdout
			x := a_other.x
			y := a_other.y
			environment := a_other.environment
			term := a_other.term.twin
			cwd := a_other.cwd.twin
			screen := a_other.screen
			last_screen := a_other.last_screen
			spec := a_other.spec
			cx := a_other.cx
			cy := a_other.cy
			lcx := a_other.lcx
			lcy := a_other.lcy
			dirty := a_other.dirty
			redrawing := a_other.redrawing
			blocked := a_other.blocked
			input_queue := a_other.input_queue
			qlen := a_other.qlen
			windows := a_other.windows.twin
			title := a_other.title
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				master = a_other.master and
				fdin = a_other.fdin and
				fdout = a_other.fdout and
				x = a_other.x and
				y = a_other.y and
				environment = a_other.environment and
				term.is_equal (a_other.term) and
				cwd.is_equal (a_other.cwd) and
				screen.is_equal (a_other.screen) and
				last_screen.is_equal (a_other.last_screen) and
				spec.is_equal (a_other.spec) and
				cx = a_other.cx and
				cy = a_other.cy and
				lcx = a_other.lcx and
				lcy = a_other.lcy and
				dirty = a_other.dirty and
				redrawing = a_other.redrawing and
				blocked = a_other.blocked and
				input_queue.is_equal (a_other.input_queue) and
				qlen = a_other.qlen and
				windows.is_equal (a_other.windows) and
				title.is_equal (a_other.title)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("master"),
					create {CE_STRUCTURE_FIELD}.make ("fdin"),
					create {CE_STRUCTURE_FIELD}.make ("fdout"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("environment"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("term", <<32>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cwd", <<256>>),
					create {CE_STRUCTURE_FIELD}.make ("screen"),
					create {CE_STRUCTURE_FIELD}.make ("last_screen"),
					create {CE_STRUCTURE_FIELD}.make ("spec"),
					create {CE_STRUCTURE_FIELD}.make ("cx"),
					create {CE_STRUCTURE_FIELD}.make ("cy"),
					create {CE_STRUCTURE_FIELD}.make ("lcx"),
					create {CE_STRUCTURE_FIELD}.make ("lcy"),
					create {CE_STRUCTURE_FIELD}.make ("dirty"),
					create {CE_STRUCTURE_FIELD}.make ("redrawing"),
					create {CE_STRUCTURE_FIELD}.make ("blocked"),
					create {CE_STRUCTURE_FIELD}.make ("input_queue"),
					create {CE_STRUCTURE_FIELD}.make ("qlen"),
					create {CE_STRUCTURE_FIELD}.make ("windows"),
					create {CE_STRUCTURE_FIELD}.make ("title")
				>>)
			init_structure_info
		end

end
