class
	P_FILEIO_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_LIBINTL_STATIC
	S_SYS_STAT_STATIC
	S_UNISTD_STATIC
	S_FCNTL_STATIC
	S_BITS_ERRNO_STATIC
	S_ICONV_STATIC
	S_STDIO_STATIC
	S_UTIME_STATIC
	S_STDLIB_STATIC

feature {ANY} -- public attributes

	crypt_magic: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("VimCrypt~01!"),
					ce_string ("VimCrypt~02!")
				>>)
		end

	crypt_magic_head: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("VimCrypt~%/0/")
		end

	crypt_salt_len: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					0, 8
				>>)
		end

	crypt_seed_len: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					0, 8
				>>)
		end

	e_auchangedbuf: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("E812: Autocommands changed buffer or buffer name")
		end

	err_readonly: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("is read-only (cannot override: %"W%" in %'cpoptions%')")
		end

	already_warned: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	temp_count: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	tempdirs: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("$TMPDIR"),
					ce_string ("/tmp"),
					ce_string ("."),
					ce_string ("$HOME")
				>>)
		end

	event_names: CE_STATIC [CE_ARRAY [PD_EVENT_NAME]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_EVENT_NAME]}.make_initialized (<<
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufAdd"), {PC_AUTO_EVENT}.EVENT_BUFADD]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufCreate"), {PC_AUTO_EVENT}.EVENT_BUFADD]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufDelete"), {PC_AUTO_EVENT}.EVENT_BUFDELETE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufEnter"), {PC_AUTO_EVENT}.EVENT_BUFENTER]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufFilePost"), {PC_AUTO_EVENT}.EVENT_BUFFILEPOST]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufFilePre"), {PC_AUTO_EVENT}.EVENT_BUFFILEPRE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufHidden"), {PC_AUTO_EVENT}.EVENT_BUFHIDDEN]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufLeave"), {PC_AUTO_EVENT}.EVENT_BUFLEAVE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufNew"), {PC_AUTO_EVENT}.EVENT_BUFNEW]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufNewFile"), {PC_AUTO_EVENT}.EVENT_BUFNEWFILE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufRead"), {PC_AUTO_EVENT}.EVENT_BUFREADPOST]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufReadCmd"), {PC_AUTO_EVENT}.EVENT_BUFREADCMD]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufReadPost"), {PC_AUTO_EVENT}.EVENT_BUFREADPOST]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufReadPre"), {PC_AUTO_EVENT}.EVENT_BUFREADPRE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufUnload"), {PC_AUTO_EVENT}.EVENT_BUFUNLOAD]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufWinEnter"), {PC_AUTO_EVENT}.EVENT_BUFWINENTER]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufWinLeave"), {PC_AUTO_EVENT}.EVENT_BUFWINLEAVE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufWipeout"), {PC_AUTO_EVENT}.EVENT_BUFWIPEOUT]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufWrite"), {PC_AUTO_EVENT}.EVENT_BUFWRITEPRE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufWritePost"), {PC_AUTO_EVENT}.EVENT_BUFWRITEPOST]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufWritePre"), {PC_AUTO_EVENT}.EVENT_BUFWRITEPRE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("BufWriteCmd"), {PC_AUTO_EVENT}.EVENT_BUFWRITECMD]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("CmdwinEnter"), {PC_AUTO_EVENT}.EVENT_CMDWINENTER]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("CmdwinLeave"), {PC_AUTO_EVENT}.EVENT_CMDWINLEAVE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("ColorScheme"), {PC_AUTO_EVENT}.EVENT_COLORSCHEME]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("CursorHold"), {PC_AUTO_EVENT}.EVENT_CURSORHOLD]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("CursorHoldI"), {PC_AUTO_EVENT}.EVENT_CURSORHOLDI]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("CursorMoved"), {PC_AUTO_EVENT}.EVENT_CURSORMOVED]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("CursorMovedI"), {PC_AUTO_EVENT}.EVENT_CURSORMOVEDI]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("EncodingChanged"), {PC_AUTO_EVENT}.EVENT_ENCODINGCHANGED]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FileEncoding"), {PC_AUTO_EVENT}.EVENT_ENCODINGCHANGED]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FileAppendPost"), {PC_AUTO_EVENT}.EVENT_FILEAPPENDPOST]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FileAppendPre"), {PC_AUTO_EVENT}.EVENT_FILEAPPENDPRE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FileAppendCmd"), {PC_AUTO_EVENT}.EVENT_FILEAPPENDCMD]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FileChangedShell"), {PC_AUTO_EVENT}.EVENT_FILECHANGEDSHELL]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FileChangedShellPost"), {PC_AUTO_EVENT}.EVENT_FILECHANGEDSHELLPOST]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FileChangedRO"), {PC_AUTO_EVENT}.EVENT_FILECHANGEDRO]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FileReadPost"), {PC_AUTO_EVENT}.EVENT_FILEREADPOST]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FileReadPre"), {PC_AUTO_EVENT}.EVENT_FILEREADPRE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FileReadCmd"), {PC_AUTO_EVENT}.EVENT_FILEREADCMD]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FileType"), {PC_AUTO_EVENT}.EVENT_FILETYPE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FileWritePost"), {PC_AUTO_EVENT}.EVENT_FILEWRITEPOST]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FileWritePre"), {PC_AUTO_EVENT}.EVENT_FILEWRITEPRE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FileWriteCmd"), {PC_AUTO_EVENT}.EVENT_FILEWRITECMD]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FilterReadPost"), {PC_AUTO_EVENT}.EVENT_FILTERREADPOST]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FilterReadPre"), {PC_AUTO_EVENT}.EVENT_FILTERREADPRE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FilterWritePost"), {PC_AUTO_EVENT}.EVENT_FILTERWRITEPOST]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FilterWritePre"), {PC_AUTO_EVENT}.EVENT_FILTERWRITEPRE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FocusGained"), {PC_AUTO_EVENT}.EVENT_FOCUSGAINED]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FocusLost"), {PC_AUTO_EVENT}.EVENT_FOCUSLOST]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("FuncUndefined"), {PC_AUTO_EVENT}.EVENT_FUNCUNDEFINED]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("GUIEnter"), {PC_AUTO_EVENT}.EVENT_GUIENTER]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("GUIFailed"), {PC_AUTO_EVENT}.EVENT_GUIFAILED]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("InsertChange"), {PC_AUTO_EVENT}.EVENT_INSERTCHANGE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("InsertEnter"), {PC_AUTO_EVENT}.EVENT_INSERTENTER]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("InsertLeave"), {PC_AUTO_EVENT}.EVENT_INSERTLEAVE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("MenuPopup"), {PC_AUTO_EVENT}.EVENT_MENUPOPUP]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("QuickFixCmdPost"), {PC_AUTO_EVENT}.EVENT_QUICKFIXCMDPOST]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("QuickFixCmdPre"), {PC_AUTO_EVENT}.EVENT_QUICKFIXCMDPRE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("RemoteReply"), {PC_AUTO_EVENT}.EVENT_REMOTEREPLY]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("SessionLoadPost"), {PC_AUTO_EVENT}.EVENT_SESSIONLOADPOST]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("ShellCmdPost"), {PC_AUTO_EVENT}.EVENT_SHELLCMDPOST]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("ShellFilterPost"), {PC_AUTO_EVENT}.EVENT_SHELLFILTERPOST]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("SourcePre"), {PC_AUTO_EVENT}.EVENT_SOURCEPRE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("SourceCmd"), {PC_AUTO_EVENT}.EVENT_SOURCECMD]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("SpellFileMissing"), {PC_AUTO_EVENT}.EVENT_SPELLFILEMISSING]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("StdinReadPost"), {PC_AUTO_EVENT}.EVENT_STDINREADPOST]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("StdinReadPre"), {PC_AUTO_EVENT}.EVENT_STDINREADPRE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("SwapExists"), {PC_AUTO_EVENT}.EVENT_SWAPEXISTS]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("Syntax"), {PC_AUTO_EVENT}.EVENT_SYNTAX]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("TabEnter"), {PC_AUTO_EVENT}.EVENT_TABENTER]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("TabLeave"), {PC_AUTO_EVENT}.EVENT_TABLEAVE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("TermChanged"), {PC_AUTO_EVENT}.EVENT_TERMCHANGED]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("TermResponse"), {PC_AUTO_EVENT}.EVENT_TERMRESPONSE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("User"), {PC_AUTO_EVENT}.EVENT_USER]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("VimEnter"), {PC_AUTO_EVENT}.EVENT_VIMENTER]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("VimLeave"), {PC_AUTO_EVENT}.EVENT_VIMLEAVE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("VimLeavePre"), {PC_AUTO_EVENT}.EVENT_VIMLEAVEPRE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("WinEnter"), {PC_AUTO_EVENT}.EVENT_WINENTER]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("WinLeave"), {PC_AUTO_EVENT}.EVENT_WINLEAVE]),
					create {PD_EVENT_NAME}.make_initialized ([ce_string ("VimResized"), {PC_AUTO_EVENT}.EVENT_VIMRESIZED]),
					create {PD_EVENT_NAME}.make_initialized ([create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), {PC_AUTO_EVENT}.EVENT_BUFADD])
				>>)
		end

	first_autopat: CE_STATIC [CE_ARRAY [CE_POINTER [PD_AUTOPAT]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [PD_AUTOPAT]}.make (<<77>>)
			Result.item[0] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[1] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[2] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[3] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[4] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[5] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[6] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[7] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[8] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[9] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[10] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[11] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[12] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[13] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[14] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[15] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[16] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[17] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[18] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[19] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[20] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[21] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[22] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[23] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[24] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[25] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[26] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[27] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[28] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[29] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[30] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[31] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[32] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[33] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[34] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[35] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[36] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[37] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[38] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[39] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[40] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[41] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[42] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[43] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[44] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[45] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[46] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[47] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[48] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[49] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[50] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[51] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[52] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[53] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[54] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[55] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[56] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[57] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			Result.item[58] := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
		end

	active_apc_list: CE_STATIC [CE_POINTER [PD_AUTOPATCMD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_AUTOPATCMD]}.make_shared (default_pointer)
		end

	augroups: CE_STATIC [CE_ARRAY [PD_GROWARRAY]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GROWARRAY]}.make_initialized (<<
					create {PD_GROWARRAY}.make_initialized ([0, 0, ({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 10, create {CE_VOID_POINTER}.make_shared (default_pointer)])
				>>)
		end

	au_need_clean: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	autocmd_blocked: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	autocmd_nested: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	nesting: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	filechangeshell_busy: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	old_termresponse: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	include_groups: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	filemess (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_name___1, a_s: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32)
		local
			l_msg_scroll_save: INTEGER_32
			l_return: BOOLEAN
		do
			if (create {P_GLOBALS_STATIC}).msg_silent.item /= 0 then
				l_return := True
			end
			if not l_return then
				msg_add_fname (a_buf___6, a_name___1)
				if (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item))) > {NATURAL_32} 945 then
					(create {P_GLOBALS_STATIC}).IObuff.item[945] := (('%/0/').code).to_natural_8
				end
				strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), create {CE_INTEGER_8_POINTER}.make_cast (a_s)).do_nothing
				l_msg_scroll_save := (create {P_GLOBALS_STATIC}).msg_scroll.item
				if ((create {P_OPTION_STATIC}).shortmess (('O').code)).to_boolean then
					if not ((create {P_GLOBALS_STATIC}).exiting.item).to_boolean then
						if (create {P_OPTION_STATIC}).p_verbose.item.item = 0 then
							(create {P_GLOBALS_STATIC}).msg_scroll.item := 0
						end
					end
				end
				if not ((create {P_GLOBALS_STATIC}).msg_scroll.item).to_boolean then
					(create {P_SCREEN_STATIC}).check_for_delay (0)
				end
				(create {P_MESSAGE_STATIC}).msg_start;
				(create {P_GLOBALS_STATIC}).msg_scroll.item := l_msg_scroll_save;
				(create {P_GLOBALS_STATIC}).msg_scrolled_ign.item := 1;
				(create {P_MESSAGE_STATIC}).msg_outtrans_attr (((create {P_MESSAGE_STATIC}).msg_may_trunc (0, (create {P_GLOBALS_STATIC}).IObuff.item)), a_attr).do_nothing;
				(create {P_MESSAGE_STATIC}).msg_clr_eos;
				(create {P_TERM_STATIC}).out_flush;
				(create {P_GLOBALS_STATIC}).msg_scrolled_ign.item := 0
			end
		end

	readfile (a_fname, a_sfname: CE_POINTER [NATURAL_8]; a_from, a_lines_to_skip, a_lines_to_read: INTEGER_32; a_eap: CE_POINTER [PD_EXARG]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_sfname: CE_POINTER [NATURAL_8]
			l_fd: CE_ARRAY [INTEGER_32]
			l_newfile: INTEGER_32
			l_check_readonly___0: INTEGER_32
			l_filtering: INTEGER_32
			l_read_stdin___0: INTEGER_32
			l_read_buffer: INTEGER_32
			l_set_options: INTEGER_32
			l_tmp: INTEGER_32
			l_read_buf_lnum: INTEGER_32
			l_read_buf_col: INTEGER_32
			l_c: NATURAL_8
			l_lnum: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_buffer: CE_POINTER [NATURAL_8]
			l_new_buffer: CE_POINTER [NATURAL_8]
			l_line_start: CE_POINTER [NATURAL_8]
			l_wasempty: INTEGER_32
			l_len: INTEGER_32
			l_size: CE_ARRAY [INTEGER_32]
			l_p___0: CE_POINTER [NATURAL_8]
			l_filesize: CE_ARRAY [INTEGER_32]
			l_skip_read: INTEGER_32
			l_cryptkey: CE_POINTER [NATURAL_8]
			l_did_ask_for_key: CE_ARRAY [INTEGER_32]
			l_sha_ctx: CE_ARRAY [PD_CONTEXT_SHA256_T]
			l_read_undo_file: INTEGER_32
			l_split: INTEGER_32
			l_linecnt: INTEGER_32
			l_error: INTEGER_32
			l_ff_error: INTEGER_32
			l_linerest: INTEGER_32
			l_perm: INTEGER_32
			l_swap_mode: INTEGER_32
			l_fileformat: INTEGER_32
			l_keep_fileformat: INTEGER_32
			l_st: CE_ARRAY [SD_STAT]
			l_file_readonly: INTEGER_32
			l_skip_count: INTEGER_32
			l_read_count: INTEGER_32
			l_msg_save: INTEGER_32
			l_read_no_eol_lnum: INTEGER_32
			l_try_mac: INTEGER_32
			l_try_dos: INTEGER_32
			l_try_unix: INTEGER_32
			l_file_rewind: INTEGER_32
			l_can_retry: INTEGER_32
			l_conv_error: INTEGER_32
			l_illegal_byte: INTEGER_32
			l_keep_dest_enc: INTEGER_32
			l_bad_char_behavior: INTEGER_32
			l_tmpname: CE_POINTER [NATURAL_8]
			l_fio_flags: INTEGER_32
			l_fenc: CE_POINTER [NATURAL_8]
			l_fenc_alloced: INTEGER_32
			l_fenc_next: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_advance_fenc: INTEGER_32
			l_real_size: INTEGER_32
			l_iconv_fd: CE_POINTER [ANY]
			l_did_iconv: INTEGER_32
			l_converted: INTEGER_32
			l_notconverted: INTEGER_32
			l_conv_rest: CE_ARRAY [NATURAL_8]
			l_conv_restlen: INTEGER_32
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_old_b_ffname: CE_POINTER [NATURAL_8]
			l_old_b_fname: CE_POINTER [NATURAL_8]
			l_using_b_ffname: INTEGER_32
			l_using_b_fname: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_pos___3: PD_POS_T
			l_tmp___8: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_oldval: INTEGER_32
			l_tmp___25: INTEGER_32
			l_tmp___28: CE_POINTER [INTEGER_8]
			l_tmp___39: CE_POINTER [INTEGER_8]
			l_tmp___41: CE_POINTER [INTEGER_8]
			l_m: INTEGER_32
			l_n: INTEGER_32
			l_firstline: CE_ARRAY [NATURAL_8]
			l_fc: INTEGER_32
			l_tmp___53: INTEGER_32
			l_tmp___55: INTEGER_32
			l_tmp___58: CE_POINTER [NATURAL_8]
			l_tmp___61: INTEGER_32
			l_tmp___62: INTEGER_32
			l_n___0: INTEGER_32
			l_ni: INTEGER_32
			l_tlen: INTEGER_32
			l_tmp___65: INTEGER_32
			l_tmp___66: INTEGER_32
			l_tmp___67: INTEGER_32
			l_tmp___68: INTEGER_32
			l_tmp___69: INTEGER_32
			l_ccname: CE_POINTER [NATURAL_8]
			l_blen: CE_ARRAY [INTEGER_32]
			l_tmp___72: INTEGER_32
			l_fromp: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_top: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_from_size: CE_ARRAY [NATURAL_32]
			l_to_size: CE_ARRAY [NATURAL_32]
			l_tmp___73: CE_POINTER [INTEGER_8]
			l_tmp___74: CE_POINTER [INTEGER_8]
			l_u8c: INTEGER_32
			l_dest: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_u16c: INTEGER_32
			l_incomplete_tail: INTEGER_32
			l_todo: INTEGER_32
			l_l: INTEGER_32
			l_fdflags: INTEGER_32
			l_tmp___89: CE_POINTER [INTEGER_8]
			l_tmp___96: CE_POINTER [INTEGER_8]
			l_tmp___98: CE_POINTER [INTEGER_8]
			l_hash: CE_ARRAY [NATURAL_8]
			l_m___0: INTEGER_32
			l_n___1: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_fd.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_size.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_filesize.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_did_ask_for_key.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_CONTEXT_SHA256_T]} l_sha_ctx.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_fenc_next.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_conv_rest.make (<<30>>)
			create {CE_NATURAL_8_ARRAY} l_firstline.make (<<80>>)
			create {CE_INTEGER_32_ARRAY} l_blen.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_fromp.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_top.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_from_size.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_to_size.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_hash.make (<<32>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fname := a_fname
					l_sfname := a_sfname
					l_fd.item := 0
					l_newfile := (a_flags___0).bit_and (1)
					l_filtering := (a_flags___0).bit_and (2)
					l_read_stdin___0 := (a_flags___0).bit_and (4)
					l_read_buffer := (a_flags___0).bit_and (8)
					if l_newfile.to_boolean then
						l_tmp := 1
					elseif l_read_buffer.to_boolean then
						l_tmp := 1
					elseif not a_eap.is_void then
						if (a_eap.item.read_edit).to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_set_options := l_tmp
					l_read_buf_lnum := (1).to_integer_32
					l_read_buf_col := 0
					l_lnum := a_from
					l_ptr := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_buffer := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_new_buffer := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_line_start := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_size.item := 0
					l_filesize.item := (0).to_integer_32
					l_skip_read := 0
					l_cryptkey := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_did_ask_for_key.item := 0
					l_read_undo_file := 0
					l_split := 0
					l_error := 0
					l_ff_error := -1
					l_linerest := 0
					l_perm := 0
					l_swap_mode := -1
					l_fileformat := 0
					l_keep_fileformat := 0
					l_skip_count := (0).to_integer_32
					l_read_count := (0).to_integer_32
					l_msg_save := (create {P_GLOBALS_STATIC}).msg_scroll.item
					l_read_no_eol_lnum := (0).to_integer_32
					l_try_mac := (not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_ffs.item.item, ('m').code)).is_void).to_integer
					l_try_dos := (not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_ffs.item.item, ('d').code)).is_void).to_integer
					l_try_unix := (not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_ffs.item.item, ('x').code)).is_void).to_integer
					l_file_rewind := 0
					l_conv_error := (0).to_integer_32
					l_illegal_byte := (0).to_integer_32
					l_keep_dest_enc := 0
					l_bad_char_behavior := ('?').code
					l_tmpname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_fio_flags := 0
					l_fenc_next.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_advance_fenc := 0
					l_real_size := 0
					l_iconv_fd := create {CE_VOID_POINTER}.make_shared (default_pointer + -1)
					l_did_iconv := 0
					l_converted := 0
					l_notconverted := 0
					l_conv_restlen := 0;
					(create {P_GLOBALS_STATIC}).write_no_eol_lnum.item := (0).to_integer_32
					if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
						if not l_filtering.to_boolean then
							if not l_fname.is_void then
								if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('f').code)).is_void then
									if not ((a_flags___0).bit_and (16)).to_boolean then
										if (set_rw_fname (l_fname, l_sfname)) = 0 then
											Result := 0
											l_return := True
										end
									end
								end
							end
						end
					end
					if not l_return then
						l_old_curbuf := (create {P_GLOBALS_STATIC}).curbuf.item
						l_old_b_ffname := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname
						l_old_b_fname := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname
						if l_fname.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname) then
							l_tmp___5 := 1
						elseif l_sfname.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname) then
							l_tmp___5 := 1
						else
							l_tmp___5 := 0
						end
						l_using_b_ffname := l_tmp___5
						if l_fname.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname) then
							l_tmp___6 := 1
						elseif l_sfname.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname) then
							l_tmp___6 := 1
						else
							l_tmp___6 := 0
						end
						l_using_b_fname := l_tmp___6;
						(create {P_GLOBALS_STATIC}).ex_no_reprint.item := 1;
						(create {P_GLOBALS_STATIC}).need_fileinfo.item := 0
						if l_sfname.is_void then
							l_sfname := l_fname
						end
						l_fname := l_sfname
						if not l_filtering.to_boolean then
							if not l_read_stdin___0.to_boolean then
								if not l_read_buffer.to_boolean then
									l_pos___3 := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start).twin
									if a_from = 0 then
										(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum := (1).to_integer_32
									else
										(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum := a_from
									end
									(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.col := 0
									if l_newfile.to_boolean then
										if (apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_BUFREADCMD, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap)).to_boolean then
											if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
												l_tmp___8 := 0
											else
												l_tmp___8 := 1
											end
											Result := l_tmp___8
											l_return := True
										end
									elseif (apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEREADCMD, l_sfname, l_sfname, 0, create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), a_eap)).to_boolean then
										if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
											l_tmp___12 := 0
										else
											l_tmp___12 := 1
										end
										Result := l_tmp___12
										l_return := True
									end
									if not l_return then
										(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start := l_pos___3.twin
									end
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_OPTION_STATIC}).shortmess (('o').code)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_help).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if (create {P_OPTION_STATIC}).p_verbose.item.item = 0 then
							(create {P_GLOBALS_STATIC}).msg_scroll.item := 0
						else
							(create {P_GLOBALS_STATIC}).msg_scroll.item := 1
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:;
						(create {P_GLOBALS_STATIC}).msg_scroll.item := 1
				when 8 then -- if done
						if not l_fname.is_void then
							if (l_fname.item).to_integer_32 /= 0 then
								l_p___0 := l_fname + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fname))).to_integer_32
								if ((create {P_MISC2_STATIC}).after_pathsep (l_fname, l_p___0)).to_boolean then
									l_tmp___17 := gettext (ce_string ("Illegal file name"))
									filemess ((create {P_GLOBALS_STATIC}).curbuf.item, l_fname, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___17), 0);
									(create {P_MESSAGE_STATIC}).msg_end.do_nothing;
									(create {P_GLOBALS_STATIC}).msg_scroll.item := l_msg_save
									Result := 0
									l_return := True
								elseif (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fname))) >= {NATURAL_32} 4_096 then
									l_tmp___17 := gettext (ce_string ("Illegal file name"))
									filemess ((create {P_GLOBALS_STATIC}).curbuf.item, l_fname, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___17), 0);
									(create {P_MESSAGE_STATIC}).msg_end.do_nothing;
									(create {P_GLOBALS_STATIC}).msg_scroll.item := l_msg_save
									Result := 0
									l_return := True
								end
							end
						end
				when 9 then -- if done
					if not l_return and then (not l_read_stdin___0.to_boolean) then
						if not l_read_buffer.to_boolean then
							l_perm := ((create {P_OS_UNIX_STATIC}).mch_getperm (l_fname)).to_integer_32
							if l_perm >= 0 then
								if ((l_perm).bit_and (61_440)) /= 32_768 then
									if ((l_perm).bit_and (61_440)) /= 4_096 then
										if ((l_perm).bit_and (61_440)) /= 49_152 then
											if ((l_perm).bit_and (61_440)) = 16_384 then
												filemess ((create {P_GLOBALS_STATIC}).curbuf.item, l_fname, create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("is a directory")))), 0)
											else
												filemess ((create {P_GLOBALS_STATIC}).curbuf.item, l_fname, create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("is not a file")))), 0)
											end
											(create {P_MESSAGE_STATIC}).msg_end.do_nothing;
											(create {P_GLOBALS_STATIC}).msg_scroll.item := l_msg_save
											Result := 0
											l_return := True
										end
									end
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 33 -- skip if block
					end
				when 10 then -- if:
						if not (l_set_options.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 11 then -- if:
						if a_eap.is_void then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if a_eap.item.force_ff /= 0 then
							(create {P_MISC2_STATIC}).set_fileformat (((create {P_MISC2_STATIC}).get_fileformat_force ((create {P_GLOBALS_STATIC}).curbuf.item, a_eap)), 4)
						else
							l_pos := -1 + 14 -- goto _L___0
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L___0:
						if ((create {P_OPTION_STATIC}).p_ffs.item.item.item).to_integer_32 /= 0 then
							(create {P_MISC2_STATIC}).set_fileformat (((create {P_MISC2_STATIC}).default_fileformat), 4)
						end
				when 15 then -- if done
						if not a_eap.is_void then
							if a_eap.item.force_bin /= 0 then
								l_oldval := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bin;
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bin := (a_eap.item.force_bin = 1).to_integer;
								(create {P_OPTION_STATIC}).set_options_bin (l_oldval, (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bin, 4)
							end
						end
						if l_newfile.to_boolean then
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags).bit_and (2)).to_boolean then
								l_tmp___25 := 1
							else
								l_tmp___25 := 0
							end
						else
							l_tmp___25 := 0
						end
						l_check_readonly___0 := l_tmp___25
						if l_check_readonly___0.to_boolean then
							if not ((create {P_GLOBALS_STATIC}).readonlymode.item).to_boolean then
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro := 0
							end
						end
						if l_newfile.to_boolean then
							if not l_read_stdin___0.to_boolean then
								if not l_read_buffer.to_boolean then
									if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), l_st)) >= 0 then
										((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_store_time (l_st, l_fname);
										(create {P_GLOBALS_STATIC}).curbuf.item.item.b_mtime_read := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_mtime
										l_swap_mode := ((((l_st.item.st_mode).bit_and ({NATURAL_32} 420))).bit_or ({NATURAL_32} 384)).to_integer_32
									else
										(create {P_GLOBALS_STATIC}).curbuf.item.item.b_mtime := 0;
										(create {P_GLOBALS_STATIC}).curbuf.item.item.b_mtime_read := 0;
										(create {P_GLOBALS_STATIC}).curbuf.item.item.b_orig_size := (0).to_integer_32;
										(create {P_GLOBALS_STATIC}).curbuf.item.item.b_orig_mode := 0
									end
									(create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags).bit_and ((-49))
								end
							end
						end
						l_file_readonly := 0
						if not l_read_stdin___0.to_boolean then
							if not l_read_buffer.to_boolean then
								if not ((l_perm).bit_and (146)).to_boolean then
									l_file_readonly := 1
								elseif (access (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), 2)).to_boolean then
									l_file_readonly := 1
								end
								l_fd.item := open ([create {CE_INTEGER_8_POINTER}.make_cast (l_fname), 0, 0])
							end
						end
						if not (l_fd.item < 0) then
							l_pos := -1 + 33 -- skip if block
						end
				when 16 then -- if:;
						(create {P_GLOBALS_STATIC}).msg_scroll.item := l_msg_save
						if not (l_newfile.to_boolean) then
							l_pos := -1 + 32 -- skip if block
						end
				when 17 then -- if:
						if not (l_perm < 0) then
							l_pos := -1 + 31 -- skip if block
						end
				when 18 then -- if:
						if (errno_location).item /= 2 then
							l_pos := -1 + 29 -- skip if block
						end
				when 19 then -- if:;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags).bit_or ((16))
						if (((create {P_GLOBALS_STATIC}).curbuf.item).item.bt_dontwrite).to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 20 then -- if:;
						(create {P_MEMLINE_STATIC}).check_need_swap (l_newfile)
						if ((create {P_GLOBALS_STATIC}).curbuf.item).is_equal (l_old_curbuf) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_tmp___28 := gettext (e_auchangedbuf.item);
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___28)).do_nothing
						Result := 0
						l_return := True
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 23 then -- else:
						if not (l_using_b_ffname.to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						if not l_old_b_ffname.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname) then
							l_tmp___28 := gettext (e_auchangedbuf.item);
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___28)).do_nothing
							Result := 0
							l_return := True
						else
							l_pos := -1 + 26 -- goto _L___1
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else: | _L___1:
						if l_using_b_fname.to_boolean then
							if not l_old_b_fname.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname) then
								l_tmp___28 := gettext (e_auchangedbuf.item);
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___28)).do_nothing
								Result := 0
								l_return := True
							end
						end
				when 27 then -- if done | if done
						if not l_return then
							if ((create {P_MISC1_STATIC}).dir_of_file_exists (l_fname)).to_boolean then
								filemess ((create {P_GLOBALS_STATIC}).curbuf.item, l_sfname, create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("[New File]")))), 0)
							else
								filemess ((create {P_GLOBALS_STATIC}).curbuf.item, l_sfname, create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("[New DIRECTORY]")))), 0)
							end
							check_marks_read
							if not a_eap.is_void then
								if a_eap.item.force_enc /= 0 then
									l_fenc := (create {P_MBYTE_STATIC}).enc_canonize (a_eap.item.cmd + a_eap.item.force_enc)
									if not l_fenc.is_void then
										(create {P_OPTION_STATIC}).set_string_option_direct (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("fenc")), -1, l_fenc, 5, 0)
									end
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fenc))
								end
							end
							apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_BUFNEWFILE, l_sfname, l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing;
							((create {P_GLOBALS_STATIC}).curbuf.item).item.save_file_ff
							if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
								Result := 0
								l_return := True
							end
						end
						if not l_return then
							Result := 1
							l_return := True
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						l_pos := -1 + 31 -- goto _L___2
				when 30 then -- if done | if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else: | _L___2:
						if (errno_location).item = 27 then
							l_tmp___41 := (gettext (ce_string ("[File too big]")))
						else
							if (errno_location).item = 75 then
								l_tmp___39 := (gettext (ce_string ("[File too big]")))
							else
								l_tmp___39 := (gettext (ce_string ("[Permission Denied]")))
							end
							l_tmp___41 := l_tmp___39
						end
						filemess ((create {P_GLOBALS_STATIC}).curbuf.item, l_sfname, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___41), 0);
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro := 1
				when 32 then -- if done
						if not l_return then
							Result := 0
							l_return := True
						end
				when 33 then -- if done | if done
					if l_return then
						l_pos := -1 + 50 -- skip if block
					end
				when 34 then -- if:
						if not (l_check_readonly___0.to_boolean) then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						if l_file_readonly.to_boolean then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro := 1
						else
							l_pos := -1 + 37 -- goto _L___3
						end
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else: | _L___3:
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_help).to_boolean then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro := 1
						end
				when 38 then
						if l_set_options.to_boolean then
							if not l_read_buffer.to_boolean then
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_eol := 1;
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_start_eol := 1
							end
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bomb := 0;
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_start_bomb := 0
						end
						if (((create {P_GLOBALS_STATIC}).curbuf.item).item.bt_dontwrite).to_boolean then
							l_pos := -1 + 50 -- skip if block
						end
				when 39 then -- if:;
						(create {P_MEMLINE_STATIC}).check_need_swap (l_newfile)
						if l_read_stdin___0.to_boolean then
							l_pos := -1 + 49 -- skip if block
						end
				when 40 then -- if:
						if ((create {P_GLOBALS_STATIC}).curbuf.item).is_equal (l_old_curbuf) then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						l_pos := -1 + 48 -- goto _L___4
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 43 then -- else:
						if not (l_using_b_ffname.to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						if not l_old_b_ffname.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname) then
							l_pos := -1 + 48 -- goto _L___4
						else
							l_pos := -1 + 46 -- goto _L___5
						end
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 46 then -- else: | _L___5:
						if not (l_using_b_fname.to_boolean) then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						if l_old_b_fname.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname) then
							l_pos := -1 + 49 -- skip if block
						end
				when 48 then -- if: | _L___4:;
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (e_auchangedbuf.item)))).do_nothing
						if not l_read_buffer.to_boolean then
							close (l_fd.item).do_nothing
						end
						Result := 0
						l_return := True
				when 49 then -- if done | if done | if done | if done
						if not l_return and then (l_swap_mode > 0) then
							if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_mfp).is_void then
								if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_mfp).item.mf_fname).is_void then
									(create {P_OS_UNIX_STATIC}).mch_setperm (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_mfp).item.mf_fname, l_swap_mode.to_integer_32).do_nothing
								end
							end
						end
				when 50 then -- if done | if done
					if not l_return and then ((create {P_GLOBALS_STATIC}).swap_exists_action.item = 2) then
						if not l_read_buffer.to_boolean then
							if not l_read_stdin___0.to_boolean then
								close (l_fd.item).do_nothing
							end
						end
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 64 -- skip if block
					end
				when 51 then -- if:;
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item + 1
						if a_from = 0 then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum := (1).to_integer_32
						else
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum := a_from
						end
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.col := 0
						if l_read_buffer.to_boolean then
							l_pos := -1 + 64 -- skip if block
						end
				when 52 then -- if:
						l_m := (create {P_GLOBALS_STATIC}).msg_scroll.item
						l_n := (create {P_GLOBALS_STATIC}).msg_scrolled.item
						if not l_read_stdin___0.to_boolean then
							close (l_fd.item).do_nothing
						end
						(create {P_GLOBALS_STATIC}).msg_scroll.item := 1
						if l_filtering.to_boolean then
							apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILTERREADPRE, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
						elseif l_read_stdin___0.to_boolean then
							apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_STDINREADPRE, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
						elseif l_newfile.to_boolean then
							apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_BUFREADPRE, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
						else
							apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEREADPRE, l_sfname, l_sfname, 0, create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), a_eap).do_nothing
						end
						if (create {P_GLOBALS_STATIC}).msg_scrolled.item = l_n then
							(create {P_GLOBALS_STATIC}).msg_scroll.item := l_m
						end
						if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
							(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1;
							(create {P_GLOBALS_STATIC}).msg_scroll.item := l_msg_save;
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro := 1
							Result := 0
							l_return := True
						end
						if not (not l_return and then (not l_read_stdin___0.to_boolean)) then
							l_pos := -1 + 64 -- skip if block
						end
				when 53 then -- if:
						if ((create {P_GLOBALS_STATIC}).curbuf.item).is_equal (l_old_curbuf) then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if:
						l_pos := -1 + 63 -- goto _L___6
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 64
				when 56 then -- else:
						if not (l_using_b_ffname.to_boolean) then
							l_pos := -1 + 59 -- skip if block
						end
				when 57 then -- if:
						if not l_old_b_ffname.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname) then
							l_pos := -1 + 63 -- goto _L___6
						else
							l_pos := -1 + 59 -- goto _L___8
						end
				when 58 then -- if block done, skip else block:
						l_pos := -1 + 64
				when 59 then -- else: | _L___8:
						if not (l_using_b_fname.to_boolean) then
							l_pos := -1 + 62 -- skip if block
						end
				when 60 then -- if:
						if not l_old_b_fname.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname) then
							l_pos := -1 + 63 -- goto _L___6
						else
							l_pos := -1 + 62 -- goto _L___7
						end
				when 61 then -- if block done, skip else block:
						l_pos := -1 + 64
				when 62 then -- else: | _L___7:
						l_fd.item := open ([create {CE_INTEGER_8_POINTER}.make_cast (l_fname), 0, 0])
						if not (l_fd.item < 0) then
							l_pos := -1 + 64 -- skip if block
						end
				when 63 then -- if: | _L___6:;
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1;
						(create {P_GLOBALS_STATIC}).msg_scroll.item := l_msg_save
						if l_fd.item < 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E200: *ReadPre autocommands made the file unreadable"))))).do_nothing
						else
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E201: *ReadPre autocommands must not change current buffer"))))).do_nothing
						end
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro := 1
						Result := 0
						l_return := True
				when 64 then -- if done | if done | if done | if done | if done | if done
					if l_return then
						l_pos := -1 + 280 -- skip if block
					end
				when 65 then -- if:
						l_wasempty := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_and (1)
						if not ((create {P_GLOBALS_STATIC}).recoverymode.item).to_boolean then
							if not l_filtering.to_boolean then
								if not ((a_flags___0).bit_and (16)).to_boolean then
									if l_read_stdin___0.to_boolean then
										(create {P_MESSAGE_STATIC}).mch_msg ((gettext (ce_string ("Vim: Reading from stdin...%N"))))
										if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
											if not ((create {P_GUI_STATIC}).gui.item.item.dying).to_boolean then
												if not ((create {P_GUI_STATIC}).gui.item.item.starting).to_boolean then
													l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Reading from stdin..."))));
													(create {P_GUI_STATIC}).gui_write (l_p___0, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32)
												end
											end
										end
									elseif not l_read_buffer.to_boolean then
										filemess ((create {P_GLOBALS_STATIC}).curbuf.item, l_sfname, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 0)
									end
								end
							end
						end
						(create {P_GLOBALS_STATIC}).msg_scroll.item := 0
						l_linecnt := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
						if not a_eap.is_void then
							if a_eap.item.bad_char /= 0 then
								l_bad_char_behavior := a_eap.item.bad_char
								if l_set_options.to_boolean then
									(create {P_GLOBALS_STATIC}).curbuf.item.item.b_bad_char := a_eap.item.bad_char
								end
							else
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_bad_char := 0
							end
						else
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_bad_char := 0
						end
						if a_eap.is_void then
							l_pos := -1 + 68 -- skip if block
						end
				when 66 then -- if:
						if a_eap.item.force_enc /= 0 then
							l_fenc := (create {P_MBYTE_STATIC}).enc_canonize (a_eap.item.cmd + a_eap.item.force_enc)
							l_fenc_alloced := 1
							l_keep_dest_enc := 1
						else
							l_pos := -1 + 68 -- goto _L___9
						end
				when 67 then -- if block done, skip else block:
						l_pos := -1 + 69
				when 68 then -- else: | _L___9:
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bin).to_boolean then
							l_fenc := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
							l_fenc_alloced := 0
						elseif ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_help).to_boolean then
							l_fenc := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("latin1"))
							l_c := ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_natural_8
							if not l_c.to_boolean then
								if not l_read_stdin___0.to_boolean then
									l_fc := (l_fname[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fname))) - {NATURAL_32} 1).to_integer_32]).to_integer_32
									if l_fc < 65 then
										l_tmp___53 := l_fc
									elseif l_fc > 90 then
										l_tmp___53 := l_fc
									else
										l_tmp___53 := l_fc + 32
									end
									if l_tmp___53 = 120 then
										l_len := read (l_fd.item, create {CE_VOID_POINTER}.make_cast (l_firstline), (80).to_natural_32)
										lseek (l_fd.item, 0, 0).do_nothing
										l_p___0 := l_firstline
										from
										until
											not (not (l_break) and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_firstline + l_len).c_pointer.to_integer_32).to_natural_32))
										loop
											l_break := False
											if (l_p___0.item).to_integer_32 >= 128 then
												l_c := (1).to_natural_8
												l_break := True
											end
											if not (l_break) then
												l_p___0 := l_p___0 + 1
											end
										end
										l_break := False
									end
								end
							end
							if l_c.to_boolean then
								l_fenc_next.item := l_fenc
								l_fenc := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("utf-8"))
								if not ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_keep_dest_enc := 1
								end
							end
							l_fenc_alloced := 0
						elseif ((create {P_OPTION_STATIC}).p_fencs.item.item.item).to_integer_32 = 0 then
							l_fenc := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_fenc
							l_fenc_alloced := 0
						else
							l_fenc_next.item := (create {P_OPTION_STATIC}).p_fencs.item.item
							l_fenc := next_fenc (l_fenc_next)
							l_fenc_alloced := 1
						end
				when 69 then -- retry:
						if not (l_file_rewind.to_boolean) then
							l_pos := -1 + 72 -- skip if block
						end
				when 70 then -- if:
						if l_read_buffer.to_boolean then
							l_read_buf_lnum := (1).to_integer_32
							l_read_buf_col := 0
						elseif l_read_stdin___0.to_boolean then
							l_error := 1
							l_pos := -1 + 268 -- goto failed
						elseif (lseek (l_fd.item, 0, 0)) /= 0 then
							l_error := 1
							l_pos := -1 + 268 -- goto failed
						end
				when 71 then
						from
						until
							not (l_lnum > a_from)
						loop
							l_tmp___55 := l_lnum
							l_lnum := l_lnum - 1;
							(create {P_MEMLINE_STATIC}).ml_delete (l_tmp___55, 0).do_nothing
						end
						l_file_rewind := 0
						if l_set_options.to_boolean then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bomb := 0;
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_start_bomb := 0
						end
						l_conv_error := (0).to_integer_32
				when 72 then -- if done
						if not l_cryptkey.is_void then
							(create {P_MISC2_STATIC}).crypt_pop_state
						end
						if not (l_keep_fileformat.to_boolean) then
							l_pos := -1 + 75 -- skip if block
						end
				when 73 then -- if:
						l_keep_fileformat := 0
				when 74 then -- if block done, skip else block:
						l_pos := -1 + 79
				when 75 then -- else:
						if a_eap.is_void then
							l_pos := -1 + 78 -- skip if block
						end
				when 76 then -- if:
						if a_eap.item.force_ff /= 0 then
							l_fileformat := (create {P_MISC2_STATIC}).get_fileformat_force ((create {P_GLOBALS_STATIC}).curbuf.item, a_eap)
							l_try_mac := 0
							l_try_dos := l_try_mac
							l_try_unix := l_try_dos
						else
							l_pos := -1 + 78 -- goto _L___10
						end
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 79
				when 78 then -- else: | _L___10:
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bin).to_boolean then
							l_fileformat := 0
						elseif ((create {P_OPTION_STATIC}).p_ffs.item.item.item).to_integer_32 = 0 then
							l_fileformat := ((create {P_GLOBALS_STATIC}).curbuf.item).item.get_fileformat
						else
							l_fileformat := -1
						end
				when 79 then -- if done
						if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
							iconv_close (l_iconv_fd).do_nothing
							l_iconv_fd := create {CE_VOID_POINTER}.make_shared (default_pointer + -1)
						end
						if not (l_advance_fenc.to_boolean) then
							l_pos := -1 + 85 -- skip if block
						end
				when 80 then -- if:
						l_advance_fenc := 0
						if a_eap.is_void then
							l_pos := -1 + 83 -- skip if block
						end
				when 81 then -- if:
						if a_eap.item.force_enc /= 0 then
							l_notconverted := 1
							l_conv_error := (0).to_integer_32
							if l_fenc_alloced.to_boolean then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fenc))
							end
							l_fenc := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
							l_fenc_alloced := 0
						else
							l_pos := -1 + 83 -- goto _L___11
						end
				when 82 then -- if block done, skip else block:
						l_pos := -1 + 84
				when 83 then -- else: | _L___11:
						if l_fenc_alloced.to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fenc))
						end
						if not (l_fenc_next.item).is_void then
							l_fenc := next_fenc (l_fenc_next)
							l_fenc_alloced := (not (l_fenc_next.item).is_void).to_integer
						else
							l_fenc := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
							l_fenc_alloced := 0
						end
				when 84 then
						if not l_tmpname.is_void then
							unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tmpname)).do_nothing;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tmpname))
							l_tmpname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
				when 85 then -- if done
						l_fio_flags := 0
						l_converted := need_conversion (l_fenc)
						if not (l_converted.to_boolean) then
							l_pos := -1 + 105 -- skip if block
						end
				when 86 then -- if:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_fenc), ce_string ("ucs-bom"))) = 0 then
							l_fio_flags := 16_384
						elseif ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							l_fio_flags := get_fio_flags (l_fenc)
						elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_enc.item.item), ce_string ("latin1"))) = 0 then
							l_fio_flags := get_fio_flags (l_fenc)
						end
						if l_fio_flags = 0 then
							if not l_did_iconv.to_boolean then
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_tmp___58 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("utf-8"))
								else
									l_tmp___58 := (create {P_OPTION_STATIC}).p_enc.item.item
								end
								l_iconv_fd := ((create {P_MBYTE_STATIC}).my_iconv_open (l_tmp___58, l_fenc))
							end
						end
						if l_fio_flags /= 0 then
							l_pos := -1 + 104 -- skip if block
						end
				when 87 then -- if:
						if l_read_stdin___0.to_boolean then
							l_pos := -1 + 102 -- skip if block
						end
				when 88 then -- if:
						if l_read_buffer.to_boolean then
							l_pos := -1 + 100 -- skip if block
						end
				when 89 then -- if:
						if ((create {P_OPTION_STATIC}).p_ccv.item.item.item).to_integer_32 = 0 then
							l_pos := -1 + 98 -- skip if block
						end
				when 90 then -- if:
						if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 96 -- skip if block
						end
				when 91 then -- if:
						l_did_iconv := 0
						if not (l_tmpname.is_void) then
							l_pos := -1 + 95 -- skip if block
						end
				when 92 then -- if:
						l_tmpname := readfile_charconvert (l_fname, l_fenc, l_fd)
						if not (l_tmpname.is_void) then
							l_pos := -1 + 95 -- skip if block
						end
				when 93 then -- if:
						l_advance_fenc := 1
						if l_fd.item < 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E202: Conversion made file unreadable!"))))).do_nothing
							l_error := 1
							l_pos := -1 + 268 -- goto failed
						end
				when 94 then
						l_pos := -1 + 69 -- goto retry
				when 95 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 97
				when 96 then -- else:
						l_pos := -1 + 104 -- goto _L___15
				when 97 then -- if done | if block done, skip else block:
						l_pos := -1 + 99
				when 98 then -- else:
						l_pos := -1 + 104 -- goto _L___15
				when 99 then -- if done | if block done, skip else block:
						l_pos := -1 + 101
				when 100 then -- else:
						l_pos := -1 + 104 -- goto _L___15
				when 101 then -- if done | if block done, skip else block:
						l_pos := -1 + 103
				when 102 then -- else:
						l_pos := -1 + 104 -- goto _L___15
				when 103 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 104 then -- else: | _L___15:
						if l_fio_flags = 0 then
							if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 = ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
								l_advance_fenc := 1
								l_pos := -1 + 69 -- goto retry
							end
						end
				when 105 then -- if done
						if (l_fenc.item).to_integer_32 /= 0 then
							if not l_read_stdin___0.to_boolean then
								if not l_keep_dest_enc.to_boolean then
									l_tmp___61 := 1
								else
									l_tmp___61 := 0
								end
							else
								l_tmp___61 := 0
							end
						else
							l_tmp___61 := 0
						end
						l_can_retry := l_tmp___61
						if not l_skip_read.to_boolean then
							l_linerest := 0
							l_filesize.item := (0).to_integer_32
							l_skip_count := a_lines_to_skip
							l_read_count := a_lines_to_read
							l_conv_restlen := 0
							if l_newfile.to_boolean then
								if ((a_flags___0).bit_and (32)) = 0 then
									if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
										if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_udf).to_boolean then
											if not l_filtering.to_boolean then
												if not l_read_stdin___0.to_boolean then
													if not l_read_buffer.to_boolean then
														l_tmp___62 := 1
													else
														l_tmp___62 := 0
													end
												else
													l_tmp___62 := 0
												end
											else
												l_tmp___62 := 0
											end
										else
											l_tmp___62 := 0
										end
									else
										l_tmp___62 := 0
									end
								else
									l_tmp___62 := 0
								end
							else
								l_tmp___62 := 0
							end
							l_read_undo_file := l_tmp___62
							if l_read_undo_file.to_boolean then
								l_sha_ctx.item.sha256_start
							end
						end
				when 106 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 267 -- skip loop
						end
				when 107 then -- loop body:
						l_break := False
						if not l_error.to_boolean then
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if not (not (l_return or l_break or l_continue) and then (not l_skip_read.to_boolean)) then
							l_pos := -1 + 132 -- skip if block
						end
				when 108 then -- if:
						l_size.item := 65_536
						from
						until
							not (not (l_break) and then (l_size.item >= 10))
						loop
							l_break := False
							l_new_buffer := (create {P_MISC2_STATIC}).lalloc (((l_size.item + l_linerest) + 1).to_natural_32, 0)
							if not l_new_buffer.is_void then
								l_break := True
							end
							if not (l_break) then
								l_size.item := (((l_size.item).to_natural_32).bit_shift_right (1)).to_integer_32
							end
						end
						l_break := False
						if l_new_buffer.is_void then
							(create {P_MISC2_STATIC}).do_outofmem_msg (((l_size.item * 2 + l_linerest) + 1).to_natural_32)
							l_error := 1
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 132 -- skip if block
						end
				when 109 then -- if:
						if l_linerest.to_boolean then
							memmove (create {CE_VOID_POINTER}.make_cast (l_new_buffer), create {CE_VOID_POINTER}.make_cast ((l_ptr - l_linerest)), l_linerest.to_natural_32).do_nothing
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buffer))
						l_buffer := l_new_buffer
						l_ptr := l_buffer + l_linerest
						l_line_start := l_buffer
						l_real_size := ((l_size.item).to_integer_32).to_integer_32
						if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
							l_size.item := l_size.item // (8)
						elseif ((l_fio_flags).bit_and (1)).to_boolean then
							l_size.item := l_size.item // (2)
						elseif ((l_fio_flags).bit_and (20)).to_boolean then
							l_size.item := ((l_size.item * 2) // 3).bit_and (-2)
						elseif ((l_fio_flags).bit_and (8)).to_boolean then
							l_size.item := ((l_size.item * 2) // 3).bit_and (-4)
						elseif l_fio_flags = 16_384 then
							l_size.item := l_size.item // (8)
						end
						if l_conv_restlen > 0 then
							memmove (create {CE_VOID_POINTER}.make_cast (l_ptr), create {CE_VOID_POINTER}.make_cast (l_conv_rest), l_conv_restlen.to_natural_32).do_nothing
							l_ptr := l_ptr + l_conv_restlen
							l_size.item := l_size.item - l_conv_restlen.to_integer_32
						end
						if l_read_buffer.to_boolean then
							if l_read_buf_lnum > a_from then
								l_size.item := 0
							else
								l_tlen := 0
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_p___0 := ((create {P_MEMLINE_STATIC}).ml_get (l_read_buf_lnum)) + l_read_buf_col
									l_n___0 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32
									if ((l_tlen.to_integer_32 + l_n___0) + 1).to_integer_32 > l_size.item then
										l_n___0 := (l_size.item - l_tlen).to_integer_32
										l_ni := 0
										from
										until
											not (l_ni < l_n___0)
										loop
											if (l_p___0[l_ni]).to_integer_32 = 10 then
												l_tmp___65 := l_tlen
												l_tlen := l_tlen + 1
												l_ptr[l_tmp___65] := (('%/0/').code).to_natural_8
											else
												l_tmp___66 := l_tlen
												l_tlen := l_tlen + 1
												l_ptr[l_tmp___66] := l_p___0[l_ni]
											end
											l_ni := l_ni + 1
										end
										l_read_buf_col := l_read_buf_col + l_n___0
										l_break := True
									else
										l_ni := 0
										from
										until
											not (l_ni < l_n___0)
										loop
											if (l_p___0[l_ni]).to_integer_32 = 10 then
												l_tmp___67 := l_tlen
												l_tlen := l_tlen + 1
												l_ptr[l_tmp___67] := (('%/0/').code).to_natural_8
											else
												l_tmp___68 := l_tlen
												l_tlen := l_tlen + 1
												l_ptr[l_tmp___68] := l_p___0[l_ni]
											end
											l_ni := l_ni + 1
										end
										l_tmp___69 := l_tlen
										l_tlen := l_tlen + 1
										l_ptr[l_tmp___69] := (('%N').code).to_natural_8
										l_read_buf_col := 0
										l_read_buf_lnum := l_read_buf_lnum + 1
										if l_read_buf_lnum > a_from then
											if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_eol).to_boolean then
												l_tlen := l_tlen - 1
											end
											l_size.item := l_tlen
											l_break := True
										end
									end
								end
								l_break := False
							end
						else
							l_size.item := (read (l_fd.item, create {CE_VOID_POINTER}.make_cast (l_ptr), (l_size.item).to_natural_32)).to_integer_32
						end
						if not (l_size.item <= 0) then
							l_pos := -1 + 131 -- skip if block
						end
				when 110 then -- if:
						if not (l_size.item < 0) then
							l_pos := -1 + 113 -- skip if block
						end
				when 111 then -- if:
						l_error := 1
				when 112 then -- if block done, skip else block:
						l_pos := -1 + 131
				when 113 then -- else:
						if not (l_conv_restlen > 0) then
							l_pos := -1 + 131 -- skip if block
						end
				when 114 then -- if:
						if l_fio_flags = 0 then
							l_pos := -1 + 117 -- skip if block
						end
				when 115 then -- if:
						l_pos := -1 + 118 -- goto _L___16
				when 116 then -- if block done, skip else block:
						l_pos := -1 + 121
				when 117 then -- else:
						if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 = ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 120 -- skip if block
						end
				when 118 then -- if: | _L___16:
						if l_conv_error = 0 then
							l_conv_error := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count - l_linecnt) + 1
						end
				when 119 then -- if block done, skip else block:
						l_pos := -1 + 121
				when 120 then -- else:
						if l_illegal_byte = 0 then
							l_illegal_byte := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count - l_linecnt) + 1
						end
				when 121 then -- if done
						if l_bad_char_behavior /= -2 then
							l_pos := -1 + 124 -- skip if block
						end
				when 122 then -- if:
						l_ptr[-l_conv_restlen] := (('%/0/').code).to_natural_8
						l_conv_restlen := 0
				when 123 then -- if block done, skip else block:
						l_pos := -1 + 131
				when 124 then -- else:
						if l_bad_char_behavior = -1 then
							l_pos := -1 + 130 -- skip if block
						end
				when 125 then -- if:
						if l_fio_flags = 0 then
							l_pos := -1 + 128 -- skip if block
						end
				when 126 then -- if:
						l_pos := -1 + 129 -- goto _L___17
				when 127 then -- if block done, skip else block:
						l_pos := -1 + 130
				when 128 then -- else:
						if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 = ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 130 -- skip if block
						end
				when 129 then -- if: | _L___17:
						from
						until
							not (l_conv_restlen > 0)
						loop
							l_ptr := l_ptr - 1
							l_ptr.item := l_bad_char_behavior.to_natural_8
							l_conv_restlen := l_conv_restlen - 1
						end
				when 130 then -- if done | if done
						l_fio_flags := 0
						if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
							iconv_close (l_iconv_fd).do_nothing
							l_iconv_fd := create {CE_VOID_POINTER}.make_shared (default_pointer + -1)
						end
				when 131 then -- if done | if done | if done | if done
						if l_filesize.item = 0 then
							l_cryptkey := check_for_cryptkey (l_cryptkey, l_ptr, l_size, l_filesize, l_newfile, l_sfname, l_did_ask_for_key)
						end
						if not l_cryptkey.is_void then
							if l_size.item > 0 then
								(create {P_MISC2_STATIC}).crypt_decode (l_ptr, l_size.item)
							end
						end
				when 132 then -- if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 150 -- skip if block
						end
				when 133 then -- if:
						l_skip_read := 0
						if l_filesize.item /= 0 then
							l_pos := -1 + 136 -- skip if block
						end
				when 134 then -- if:
						l_pos := -1 + 138 -- goto _L___20
				when 135 then -- if block done, skip else block:
						l_pos := -1 + 149
				when 136 then -- else:
						if l_filesize.item /= ((12 + crypt_salt_len.item[(create {P_GLOBALS_STATIC}).use_crypt_method.item]) + crypt_seed_len.item[(create {P_GLOBALS_STATIC}).use_crypt_method.item]).to_integer_32 then
							l_pos := -1 + 149 -- skip if block
						end
				when 137 then -- if:
						if l_cryptkey.is_void then
							l_pos := -1 + 149 -- skip if block
						end
				when 138 then -- if: | _L___20:
						if l_fio_flags /= 16_384 then
							l_pos := -1 + 141 -- skip if block
						end
				when 139 then -- if:
						l_pos := -1 + 148 -- goto _L___19
				when 140 then -- if block done, skip else block:
						l_pos := -1 + 149
				when 141 then -- else:
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bomb).to_boolean then
							l_pos := -1 + 149 -- skip if block
						end
				when 142 then -- if:
						if not (l_tmpname.is_void) then
							l_pos := -1 + 149 -- skip if block
						end
				when 143 then -- if:
						if (l_fenc.item).to_integer_32 /= 117 then
							l_pos := -1 + 146 -- skip if block
						end
				when 144 then -- if:
						l_pos := -1 + 148 -- goto _L___19
				when 145 then -- if block done, skip else block:
						l_pos := -1 + 149
				when 146 then -- else:
						if (l_fenc.item).to_integer_32 /= 0 then
							l_pos := -1 + 149 -- skip if block
						end
				when 147 then -- if:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 149 -- skip if block
						end
				when 148 then -- if: | _L___19:
						if l_size.item < 2 then
							l_ccname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						elseif ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bin).to_boolean then
							l_ccname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						else
							if l_fio_flags = 16_384 then
								l_tmp___72 := -1
							else
								l_tmp___72 := (get_fio_flags (l_fenc))
							end
							l_ccname := check_for_bom (l_ptr, l_size.item, l_blen, l_tmp___72)
						end
						if not l_ccname.is_void then
							l_filesize.item := l_filesize.item + (l_blen.item).to_integer_32
							l_size.item := l_size.item - (l_blen.item).to_integer_32
							memmove (create {CE_VOID_POINTER}.make_cast (l_ptr), create {CE_VOID_POINTER}.make_cast ((l_ptr + l_blen.item)), (l_size.item).to_natural_32).do_nothing
							if l_set_options.to_boolean then
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bomb := 1;
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_start_bomb := 1
							end
						end
						if l_fio_flags = 16_384 then
							if l_ccname.is_void then
								l_advance_fenc := 1
							else
								if l_fenc_alloced.to_boolean then
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fenc))
								end
								l_fenc := l_ccname
								l_fenc_alloced := 0
							end
							l_skip_read := 1
							l_pos := -1 + 69 -- goto retry
						end
				when 149 then -- if done | if done | if done | if done | if done | if done | if done | if done
						l_ptr := l_ptr - l_conv_restlen
						l_size.item := l_size.item + l_conv_restlen.to_integer_32
						l_conv_restlen := 0
						if l_size.item <= 0 then
							l_break := True
						end
				when 150 then -- if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 266 -- skip if block
						end
				when 151 then -- if:
						if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 = ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 163 -- skip if block
						end
				when 152 then -- if:
						l_fromp.item := create {CE_INTEGER_8_POINTER}.make_cast (l_ptr)
						l_from_size.item := (l_size.item).to_natural_32
						l_ptr := l_ptr + (l_size.item)
						l_top.item := create {CE_INTEGER_8_POINTER}.make_cast (l_ptr)
						l_to_size.item := (l_real_size - l_size.item).to_natural_32
				when 153 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 162 -- skip loop
						end
				when 154 then -- loop body:
						l_break := False
						if (iconv (l_iconv_fd, l_fromp, l_from_size, l_top, l_to_size)) /= {NATURAL_32} 4_294_967_295 then
							l_pos := -1 + 157 -- skip if block
						end
				when 155 then -- if:
						if (errno_location).item = 22 then
							l_pos := -1 + 157 -- goto _L___21
						end
				when 156 then -- if block done, skip else block:
						l_pos := -1 + 158
				when 157 then -- else: | _L___21:
						if not (l_from_size.item > {NATURAL_32} 30) then
							l_break := True
						end
				when 158 then
						if (l_return or l_break) then
							l_pos := -1 + 161 -- skip if block
						end
				when 159 then -- if:
						if l_can_retry.to_boolean then
							l_pos := -1 + 228 -- goto rewind_retry
						end
				when 160 then
						if l_conv_error = 0 then
							l_conv_error := readfile_linenr (l_linecnt, l_ptr, create {CE_NATURAL_8_POINTER}.make_cast (l_top.item))
						end
						l_fromp.item := l_fromp.item + 1
						l_from_size.item := l_from_size.item - 1
						if l_bad_char_behavior = -1 then
							l_tmp___73 := l_top.item
							l_top.item := l_top.item + 1
							l_tmp___73[0] := l_fromp.item[-1]
							l_to_size.item := l_to_size.item - 1
						elseif l_bad_char_behavior /= -2 then
							l_tmp___74 := l_top.item
							l_top.item := l_top.item + 1
							l_tmp___74[0] := l_bad_char_behavior.to_integer_8
							l_to_size.item := l_to_size.item - 1
						end
				when 161 then -- if done
						l_pos := -1 + 153 -- back to loop condition
				when 162 then -- loop done
						l_break := False
						if l_from_size.item > {NATURAL_32} 0 then
							memmove (create {CE_VOID_POINTER}.make_cast (l_conv_rest), create {CE_VOID_POINTER}.make_cast (l_fromp.item), l_from_size.item).do_nothing
							l_conv_restlen := (l_from_size.item).to_integer_32
						end
						l_line_start := l_ptr - l_linerest
						memmove (create {CE_VOID_POINTER}.make_cast (l_line_start), create {CE_VOID_POINTER}.make_cast (l_buffer), l_linerest.to_natural_32).do_nothing
						l_size.item := ((create {CE_NATURAL_8_POINTER}.make_cast (l_top.item)).distance (l_ptr)).to_integer_32
				when 163 then -- if done
						if l_fio_flags = 0 then
							l_pos := -1 + 212 -- skip if block
						end
				when 164 then -- if:
						l_tail := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_dest := l_ptr + l_real_size
						if l_fio_flags /= 1 then
							l_pos := -1 + 167 -- skip if block
						end
				when 165 then -- if:
						l_pos := -1 + 168 -- goto _L___22
				when 166 then -- if block done, skip else block:
						l_pos := -1 + 171
				when 167 then -- else:
						if l_fio_flags /= 2 then
							l_pos := -1 + 170 -- skip if block
						end
				when 168 then -- if: | _L___22:
						l_p___0 := l_ptr + l_size.item
						if l_fio_flags = 2 then
							l_tail := (l_ptr + l_size.item) - 1
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_tail.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
									if (((l_tail.item).to_integer_32).bit_and (192)) /= 128 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_tail := l_tail - 1
								end
							end
							l_break := False
							if ((l_tail + ((create {P_MBYTE_STATIC}).utf_byte2len ((l_tail.item).to_integer_32))).c_pointer.to_integer_32).to_natural_32 <= ((l_ptr + l_size.item).c_pointer.to_integer_32).to_natural_32 then
								l_tail := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							else
								l_p___0 := l_tail
							end
						end
				when 169 then -- if block done, skip else block:
						l_pos := -1 + 171
				when 170 then -- else:
						if ((l_fio_flags).bit_and (20)).to_boolean then
							l_p___0 := l_ptr + ((l_size.item).bit_and (-2))
							if ((l_size.item).bit_and (1)).to_boolean then
								l_tail := l_p___0
							end
							if ((l_fio_flags).bit_and (16)).to_boolean then
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
									if ((l_fio_flags).bit_and (128)).to_boolean then
										l_p___0 := l_p___0 - 1
										l_u8c := ((l_p___0.item).to_integer_32).bit_shift_left (8)
										l_p___0 := l_p___0 - 1
										l_u8c := l_u8c + (l_p___0.item).to_integer_32
									else
										l_p___0 := l_p___0 - 1
										l_u8c := (l_p___0.item).to_integer_32
										l_p___0 := l_p___0 - 1
										l_u8c := l_u8c + (((l_p___0.item).to_integer_32).bit_shift_left (8))
									end
									if l_u8c >= 55_296 then
										if l_u8c <= 56_319 then
											l_tail := l_p___0
										else
											l_p___0 := l_p___0 + (2)
										end
									else
										l_p___0 := l_p___0 + (2)
									end
								end
							end
						else
							l_p___0 := l_ptr + ((l_size.item).bit_and (-4))
							if ((l_size.item).bit_and (3)).to_boolean then
								l_tail := l_p___0
							end
						end
				when 171 then -- if done
						if not l_tail.is_void then
							l_conv_restlen := (l_ptr + l_size.item).distance (l_tail)
							memmove (create {CE_VOID_POINTER}.make_cast (l_conv_rest), create {CE_VOID_POINTER}.make_cast (l_tail), l_conv_restlen.to_natural_32).do_nothing
							l_size.item := l_size.item - l_conv_restlen.to_integer_32
						end
				when 172 then -- loop condition:
						if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 210 -- skip loop
						end
				when 173 then -- loop body:
						l_continue := False
						if not (((l_fio_flags).bit_and (1)).to_boolean) then
							l_pos := -1 + 176 -- skip if block
						end
				when 174 then -- if:
						l_p___0 := l_p___0 - 1
						l_u8c := (l_p___0.item).to_integer_32
				when 175 then -- if block done, skip else block:
						l_pos := -1 + 200
				when 176 then -- else:
						if not (((l_fio_flags).bit_and (20)).to_boolean) then
							l_pos := -1 + 191 -- skip if block
						end
				when 177 then -- if:
						if ((l_fio_flags).bit_and (128)).to_boolean then
							l_p___0 := l_p___0 - 1
							l_u8c := ((l_p___0.item).to_integer_32).bit_shift_left (8)
							l_p___0 := l_p___0 - 1
							l_u8c := l_u8c + (l_p___0.item).to_integer_32
						else
							l_p___0 := l_p___0 - 1
							l_u8c := (l_p___0.item).to_integer_32
							l_p___0 := l_p___0 - 1
							l_u8c := l_u8c + (((l_p___0.item).to_integer_32).bit_shift_left (8))
						end
						if not (((l_fio_flags).bit_and (16)).to_boolean) then
							l_pos := -1 + 190 -- skip if block
						end
				when 178 then -- if:
						if not (l_u8c >= 56_320) then
							l_pos := -1 + 190 -- skip if block
						end
				when 179 then -- if:
						if not (l_u8c <= 57_343) then
							l_pos := -1 + 190 -- skip if block
						end
				when 180 then -- if:
						if not (l_p___0.is_equal (l_ptr)) then
							l_pos := -1 + 183 -- skip if block
						end
				when 181 then -- if:
						if l_can_retry.to_boolean then
							l_pos := -1 + 228 -- goto rewind_retry
						end
				when 182 then
						if l_conv_error = 0 then
							l_conv_error := readfile_linenr (l_linecnt, l_ptr, l_p___0)
						end
						if l_bad_char_behavior = -2 then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) and then (l_bad_char_behavior /= -1) then
							l_u8c := l_bad_char_behavior
						end
				when 183 then -- if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 190 -- skip if block
						end
				when 184 then -- if:
						if ((l_fio_flags).bit_and (128)).to_boolean then
							l_p___0 := l_p___0 - 1
							l_u16c := ((l_p___0.item).to_integer_32).bit_shift_left (8)
							l_p___0 := l_p___0 - 1
							l_u16c := l_u16c + (l_p___0.item).to_integer_32
						else
							l_p___0 := l_p___0 - 1
							l_u16c := (l_p___0.item).to_integer_32
							l_p___0 := l_p___0 - 1
							l_u16c := l_u16c + (((l_p___0.item).to_integer_32).bit_shift_left (8))
						end
						l_u8c := (65_536 + ((((l_u16c).bit_and (1_023))).bit_shift_left (10))) + ((l_u8c).bit_and (1_023))
						if not (l_u16c < 55_296) then
							l_pos := -1 + 187 -- skip if block
						end
				when 185 then -- if:
						l_pos := -1 + 188 -- goto _L___23
				when 186 then -- if block done, skip else block:
						l_pos := -1 + 190
				when 187 then -- else:
						if not (l_u16c > 56_319) then
							l_pos := -1 + 190 -- skip if block
						end
				when 188 then -- if: | _L___23:
						if l_can_retry.to_boolean then
							l_pos := -1 + 228 -- goto rewind_retry
						end
				when 189 then
						if l_conv_error = 0 then
							l_conv_error := readfile_linenr (l_linecnt, l_ptr, l_p___0)
						end
						if l_bad_char_behavior = -2 then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) and then (l_bad_char_behavior /= -1) then
							l_u8c := l_bad_char_behavior
						end
				when 190 then -- if done | if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 200
				when 191 then -- else:
						if not (((l_fio_flags).bit_and (8)).to_boolean) then
							l_pos := -1 + 194 -- skip if block
						end
				when 192 then -- if:
						if ((l_fio_flags).bit_and (128)).to_boolean then
							l_p___0 := l_p___0 - 1
							l_u8c := ((l_p___0.item).to_integer_32).bit_shift_left (24)
							l_p___0 := l_p___0 - 1
							l_u8c := l_u8c + (((l_p___0.item).to_integer_32).bit_shift_left (16))
							l_p___0 := l_p___0 - 1
							l_u8c := l_u8c + (((l_p___0.item).to_integer_32).bit_shift_left (8))
							l_p___0 := l_p___0 - 1
							l_u8c := l_u8c + (l_p___0.item).to_integer_32
						else
							l_p___0 := l_p___0 - 1
							l_u8c := (l_p___0.item).to_integer_32
							l_p___0 := l_p___0 - 1
							l_u8c := l_u8c + (((l_p___0.item).to_integer_32).bit_shift_left (8))
							l_p___0 := l_p___0 - 1
							l_u8c := l_u8c + (((l_p___0.item).to_integer_32).bit_shift_left (16))
							l_p___0 := l_p___0 - 1
							l_u8c := l_u8c + (((l_p___0.item).to_integer_32).bit_shift_left (24))
						end
				when 193 then -- if block done, skip else block:
						l_pos := -1 + 200
				when 194 then -- else:
						l_p___0 := l_p___0 - 1
						if not ((l_p___0.item).to_integer_32 < 128) then
							l_pos := -1 + 197 -- skip if block
						end
				when 195 then -- if:
						l_u8c := (l_p___0.item).to_integer_32
				when 196 then -- if block done, skip else block:
						l_pos := -1 + 200
				when 197 then -- else:
						l_len := (create {P_MBYTE_STATIC}).utf_head_off (l_ptr, l_p___0)
						l_p___0 := l_p___0 - l_len
						l_u8c := (create {P_MBYTE_STATIC}).utf_ptr2char (l_p___0)
						if l_len /= 0 then
							l_pos := -1 + 200 -- skip if block
						end
				when 198 then -- if:
						if l_can_retry.to_boolean then
							l_pos := -1 + 228 -- goto rewind_retry
						end
				when 199 then
						if l_conv_error = 0 then
							l_conv_error := readfile_linenr (l_linecnt, l_ptr, l_p___0)
						end
						if l_bad_char_behavior = -2 then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) and then (l_bad_char_behavior /= -1) then
							l_u8c := l_bad_char_behavior
						end
				when 200 then -- if done | if done | if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 209 -- skip if block
						end
				when 201 then -- if:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 204 -- skip if block
						end
				when 202 then -- if:
						l_dest := l_dest - ((create {P_MBYTE_STATIC}).utf_char2len (l_u8c));
						(create {P_MBYTE_STATIC}).utf_char2bytes (l_u8c, l_dest).do_nothing
				when 203 then -- if block done, skip else block:
						l_pos := -1 + 209
				when 204 then -- else:
						l_dest := l_dest - 1
						if not (l_u8c >= 256) then
							l_pos := -1 + 208 -- skip if block
						end
				when 205 then -- if:
						if l_can_retry.to_boolean then
							l_pos := -1 + 228 -- goto rewind_retry
						end
				when 206 then
						if l_conv_error = 0 then
							l_conv_error := readfile_linenr (l_linecnt, l_ptr, l_p___0)
						end
						if l_bad_char_behavior = -2 then
							l_dest := l_dest + 1
						elseif l_bad_char_behavior = -1 then
							l_dest.item := l_u8c.to_natural_8
						elseif not a_eap.is_void then
							if a_eap.item.bad_char /= 0 then
								l_dest.item := l_bad_char_behavior.to_natural_8
							else
								l_dest.item := (191).to_natural_8
							end
						else
							l_dest.item := (191).to_natural_8
						end
				when 207 then -- if block done, skip else block:
						l_pos := -1 + 209
				when 208 then -- else:
						l_dest.item := l_u8c.to_natural_8
				when 209 then -- if done | if done | if done
						l_pos := -1 + 172 -- back to loop condition
				when 210 then -- loop done
						l_continue := False
						l_line_start := l_dest - l_linerest
						memmove (create {CE_VOID_POINTER}.make_cast (l_line_start), create {CE_VOID_POINTER}.make_cast (l_buffer), l_linerest.to_natural_32).do_nothing
						l_size.item := ((l_ptr + l_real_size).distance (l_dest)).to_integer_32
						l_ptr := l_dest
				when 211 then -- if block done, skip else block:
						l_pos := -1 + 229
				when 212 then -- else:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 229 -- skip if block
						end
				when 213 then -- if:
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bin).to_boolean then
							l_pos := -1 + 229 -- skip if block
						end
				when 214 then -- if:
						l_incomplete_tail := 0
						l_p___0 := l_ptr
				when 215 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 226 -- skip loop
						end
				when 216 then -- loop body:
						l_break := False
						l_todo := (l_ptr + l_size.item).distance (l_p___0)
						if l_todo <= 0 then
							l_break := True
						end
						if not (not (l_return or l_break or l_continue) and then ((l_p___0.item).to_integer_32 >= 128)) then
							l_pos := -1 + 225 -- skip if block
						end
				when 217 then -- if:
						l_l := (create {P_MBYTE_STATIC}).utf_ptr2len_len (l_p___0, l_todo)
						if l_l > l_todo then
							if not l_incomplete_tail.to_boolean then
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
									l_incomplete_tail := 1
								elseif l_filesize.item > 0 then
									l_incomplete_tail := 1
								end
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
									l_conv_restlen := l_todo
									memmove (create {CE_VOID_POINTER}.make_cast (l_conv_rest), create {CE_VOID_POINTER}.make_cast (l_p___0), l_conv_restlen.to_natural_32).do_nothing
									l_size.item := l_size.item - l_conv_restlen.to_integer_32
									l_break := True
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 225 -- skip if block
						end
				when 218 then -- if:
						if l_l /= 1 then
							l_pos := -1 + 221 -- skip if block
						end
				when 219 then -- if:
						l_pos := -1 + 222 -- goto _L___24
				when 220 then -- if block done, skip else block:
						l_pos := -1 + 225
				when 221 then -- else:
						if not (l_l > l_todo) then
							l_pos := -1 + 224 -- skip if block
						end
				when 222 then -- if: | _L___24:
						if l_can_retry.to_boolean then
							if not l_incomplete_tail.to_boolean then
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
								if l_conv_error = 0 then
									l_conv_error := readfile_linenr (l_linecnt, l_ptr, l_p___0)
								end
							end
							if l_conv_error = 0 then
								if l_illegal_byte = 0 then
									l_illegal_byte := readfile_linenr (l_linecnt, l_ptr, l_p___0)
								end
							end
							if l_bad_char_behavior = -2 then
								memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + 1)), (l_todo - 1).to_natural_32).do_nothing
								l_p___0 := l_p___0 - 1
								l_size.item := l_size.item - 1
							elseif l_bad_char_behavior /= -1 then
								l_p___0.item := l_bad_char_behavior.to_natural_8
							end
						end
				when 223 then -- if block done, skip else block:
						l_pos := -1 + 225
				when 224 then -- else:
						l_p___0 := l_p___0 + (l_l - 1)
				when 225 then -- if done | if done | if done
						if not (l_return or l_break or l_continue) then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 215 -- back to loop condition
				when 226 then -- loop done
						l_break := False
						if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_ptr + l_size.item).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 229 -- skip if block
						end
				when 227 then -- if:
						if l_incomplete_tail.to_boolean then
							l_pos := -1 + 229 -- skip if block
						end
				when 228 then -- if: | rewind_retry:
						if ((create {P_OPTION_STATIC}).p_ccv.item.item.item).to_integer_32 /= 0 then
							if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
								l_did_iconv := 1
							else
								l_advance_fenc := 1
							end
						else
							l_advance_fenc := 1
						end
						l_file_rewind := 1
						l_pos := -1 + 69 -- goto retry
				when 229 then -- if done | if done | if done | if done
						l_filesize.item := l_filesize.item + (l_size.item)
						if l_fileformat /= -1 then
							l_pos := -1 + 236 -- skip if block
						end
				when 230 then -- if:
						if not (l_try_dos.to_boolean) then
							l_pos := -1 + 233 -- skip if block
						end
				when 231 then -- if:
						l_pos := -1 + 234 -- goto _L___25
				when 232 then -- if block done, skip else block:
						l_pos := -1 + 235
				when 233 then -- else:
						if not (l_try_unix.to_boolean) then
							l_pos := -1 + 235 -- skip if block
						end
				when 234 then -- if: | _L___25:
						l_p___0 := l_ptr
						from
						until
							not (not (l_break) and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_ptr + l_size.item).c_pointer.to_integer_32).to_natural_32))
						loop
							l_break := False
							if (l_p___0.item).to_integer_32 = 10 then
								if not l_try_unix.to_boolean then
									l_fileformat := 1
								elseif l_try_dos.to_boolean then
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
										if (l_p___0[-1]).to_integer_32 = 13 then
											l_fileformat := 1
										else
											l_fileformat := 0
										end
									else
										l_fileformat := 0
									end
								else
									l_fileformat := 0
								end
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						if l_fileformat = 0 then
							if l_try_mac.to_boolean then
								l_try_mac := 1
								l_try_unix := 1
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_ptr.c_pointer.to_integer_32).to_natural_32 then
										if (l_p___0.item).to_integer_32 = 13 then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										l_p___0 := l_p___0 - 1
									end
								end
								l_break := False
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_ptr.c_pointer.to_integer_32).to_natural_32 then
									l_p___0 := l_ptr
									from
									until
										not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_ptr + l_size.item).c_pointer.to_integer_32).to_natural_32)
									loop
										if (l_p___0.item).to_integer_32 = 10 then
											l_try_unix := l_try_unix + 1
										elseif (l_p___0.item).to_integer_32 = 13 then
											l_try_mac := l_try_mac + 1
										end
										l_p___0 := l_p___0 + 1
									end
									if l_try_mac > l_try_unix then
										l_fileformat := 2
									end
								end
							end
						end
				when 235 then -- if done
						if l_fileformat = -1 then
							if l_try_mac.to_boolean then
								l_fileformat := 2
							end
						end
						if l_fileformat = -1 then
							l_fileformat := (create {P_MISC2_STATIC}).default_fileformat
						end
						if l_set_options.to_boolean then
							(create {P_MISC2_STATIC}).set_fileformat (l_fileformat, 4)
						end
				when 236 then -- if done
						if l_fileformat /= 2 then
							l_pos := -1 + 239 -- skip if block
						end
				when 237 then -- if:
						l_ptr := l_ptr - 1
						from
						until
							(l_break)
						loop
							l_break := False
							l_continue := False
							l_ptr := l_ptr + 1
							l_size.item := l_size.item - 1
							if not (l_size.item >= 0) then
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_c := l_ptr.item
								if l_c.to_integer_32 /= 0 then
									if l_c.to_integer_32 /= 13 then
										if l_c.to_integer_32 /= 10 then
											l_continue := True
										end
									end
								end
							end
							if not (l_return or l_break or l_continue) then
								if l_c.to_integer_32 = 0 then
									l_ptr.item := (('%N').code).to_natural_8
								elseif l_c.to_integer_32 = 10 then
									l_ptr.item := (('%R').code).to_natural_8
								else
									if l_skip_count = 0 then
										l_ptr.item := (('%/0/').code).to_natural_8
										l_len := (l_ptr.distance (l_line_start)) + 1
										if ((create {P_MEMLINE_STATIC}).ml_append (l_lnum, l_line_start, l_len, l_newfile)) = 0 then
											l_error := 1
											l_break := True
										end
										if not (l_return or l_break or l_continue) then
											if l_read_undo_file.to_boolean then
												(create {P_SHA256_STATIC}).sha256_update (l_sha_ctx, l_line_start, l_len.to_natural_32)
											end
											l_lnum := l_lnum + 1
											l_read_count := l_read_count - 1
											if l_read_count = 0 then
												l_error := 1
												l_line_start := l_ptr
												l_break := True
											end
										end
									else
										l_skip_count := l_skip_count - 1
									end
									if not (l_return or l_break or l_continue) then
										l_line_start := l_ptr + 1
									end
								end
							end
						end
						l_break := False
						l_continue := False
				when 238 then -- if block done, skip else block:
						l_pos := -1 + 265
				when 239 then -- else:
						l_ptr := l_ptr - 1
				when 240 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 264 -- skip loop
						end
				when 241 then -- loop body:
						l_break := False
						l_continue := False
						l_ptr := l_ptr + 1
						l_size.item := l_size.item - 1
						if not (l_size.item >= 0) then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_c := l_ptr.item
							if l_c.to_integer_32 /= 0 then
								if l_c.to_integer_32 /= 10 then
									l_continue := True
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 263 -- skip if block
						end
				when 242 then -- if:
						if l_c.to_integer_32 /= 0 then
							l_pos := -1 + 245 -- skip if block
						end
				when 243 then -- if:
						l_ptr.item := (('%N').code).to_natural_8
				when 244 then -- if block done, skip else block:
						l_pos := -1 + 263
				when 245 then -- else:
						if l_skip_count /= 0 then
							l_pos := -1 + 261 -- skip if block
						end
				when 246 then -- if:
						l_ptr.item := (('%/0/').code).to_natural_8
						l_len := (l_ptr.distance (l_line_start)) + 1
						if l_fileformat /= 1 then
							l_pos := -1 + 259 -- skip if block
						end
				when 247 then -- if:
						if (l_ptr[-1]).to_integer_32 /= 13 then
							l_pos := -1 + 250 -- skip if block
						end
				when 248 then -- if:
						l_ptr[-1] := (('%/0/').code).to_natural_8
						l_len := l_len - 1
				when 249 then -- if block done, skip else block:
						l_pos := -1 + 259
				when 250 then -- else:
						if l_ff_error = 1 then
							l_pos := -1 + 259 -- skip if block
						end
				when 251 then -- if:
						if not (l_try_unix.to_boolean) then
							l_pos := -1 + 258 -- skip if block
						end
				when 252 then -- if:
						if l_read_stdin___0.to_boolean then
							l_pos := -1 + 258 -- skip if block
						end
				when 253 then -- if:
						if not (l_read_buffer.to_boolean) then
							l_pos := -1 + 256 -- skip if block
						end
				when 254 then -- if:
						l_pos := -1 + 257 -- goto _L___26
				when 255 then -- if block done, skip else block:
						l_pos := -1 + 258
				when 256 then -- else:
						if (lseek (l_fd.item, 0, 0)) /= 0 then
							l_pos := -1 + 258 -- skip if block
						end
				when 257 then -- if: | _L___26:
						l_fileformat := 0
						if l_set_options.to_boolean then
							(create {P_MISC2_STATIC}).set_fileformat (0, 4)
						end
						l_file_rewind := 1
						l_keep_fileformat := 1
						l_pos := -1 + 69 -- goto retry
				when 258 then -- if done | if done | if done
						l_ff_error := 1
				when 259 then -- if done | if done | if done
						if ((create {P_MEMLINE_STATIC}).ml_append (l_lnum, l_line_start, l_len, l_newfile)) = 0 then
							l_error := 1
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							if l_read_undo_file.to_boolean then
								(create {P_SHA256_STATIC}).sha256_update (l_sha_ctx, l_line_start, l_len.to_natural_32)
							end
							l_lnum := l_lnum + 1
							l_read_count := l_read_count - 1
							if l_read_count = 0 then
								l_error := 1
								l_line_start := l_ptr
								l_break := True
							end
						end
				when 260 then -- if block done, skip else block:
						l_pos := -1 + 262
				when 261 then -- else:
						l_skip_count := l_skip_count - 1
				when 262 then -- if done
						if not (l_return or l_break or l_continue) then
							l_line_start := l_ptr + 1
						end
				when 263 then -- if done | if done
						l_pos := -1 + 240 -- back to loop condition
				when 264 then -- loop done
						l_break := False
						l_continue := False
				when 265 then -- if done
						l_linerest := (l_ptr.distance (l_line_start)).to_integer_32;
						(create {P_UI_STATIC}).ui_breakcheck
				when 266 then -- if done
						l_pos := -1 + 106 -- back to loop condition
				when 267 then -- loop done
						l_break := False
				when 268 then -- failed:
						if l_error.to_boolean then
							if l_read_count = 0 then
								l_error := 0
							end
						end
						if l_error.to_boolean then
							l_pos := -1 + 275 -- skip if block
						end
				when 269 then -- if:
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_pos := -1 + 275 -- skip if block
						end
				when 270 then -- if:
						if l_linerest = 0 then
							l_pos := -1 + 275 -- skip if block
						end
				when 271 then -- if:
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bin).to_boolean then
							l_pos := -1 + 274 -- skip if block
						end
				when 272 then -- if:
						if l_fileformat = 1 then
							if (l_line_start.item).to_integer_32 = 26 then
								if not (l_ptr.is_equal (l_line_start + 1)) then
									l_pos := -1 + 274 -- goto _L___29
								end
							else
								l_pos := -1 + 274 -- goto _L___29
							end
						else
							l_pos := -1 + 274 -- goto _L___29
						end
				when 273 then -- if block done, skip else block:
						l_pos := -1 + 275
				when 274 then -- else: | _L___29:
						if l_set_options.to_boolean then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_eol := 0
						end
						l_ptr.item := (('%/0/').code).to_natural_8
						l_len := (l_ptr.distance (l_line_start)) + 1
						if ((create {P_MEMLINE_STATIC}).ml_append (l_lnum, l_line_start, l_len, l_newfile)) = 0 then
							l_error := 1
						else
							if l_read_undo_file.to_boolean then
								(create {P_SHA256_STATIC}).sha256_update (l_sha_ctx, l_line_start, l_len.to_natural_32)
							end
							l_lnum := l_lnum + 1
							l_read_no_eol_lnum := l_lnum
						end
				when 275 then -- if done | if done | if done
						if l_set_options.to_boolean then
							((create {P_GLOBALS_STATIC}).curbuf.item).item.save_file_ff
						end
						if not l_cryptkey.is_void then
							(create {P_MISC2_STATIC}).crypt_pop_state
							if not l_cryptkey.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_key) then
								(create {P_MISC2_STATIC}).free_crypt_key (l_cryptkey)
							end
						end
						if l_set_options.to_boolean then
							(create {P_OPTION_STATIC}).set_string_option_direct (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("fenc")), -1, l_fenc, 5, 0)
						end
						if l_fenc_alloced.to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fenc))
						end
						if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
							iconv_close (l_iconv_fd).do_nothing
							l_iconv_fd := create {CE_VOID_POINTER}.make_shared (default_pointer + -1)
						end
						if l_read_buffer.to_boolean then
							l_pos := -1 + 278 -- skip if block
						end
				when 276 then -- if:
						if not l_read_stdin___0.to_boolean then
							close (l_fd.item).do_nothing
						else
							l_pos := -1 + 278 -- goto _L___30
						end
				when 277 then -- if block done, skip else block:
						l_pos := -1 + 279
				when 278 then -- else: | _L___30:
						l_fdflags := (fcntl ([l_fd.item, 1]))
						if l_fdflags >= 0 then
							if ((l_fdflags).bit_and (1)) = 0 then
								fcntl ([l_fd.item, 2, (l_fdflags).bit_or (1)]).do_nothing
							end
						end
				when 279 then;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buffer))
						if l_read_stdin___0.to_boolean then
							close (0).do_nothing;
							(create {P_GLOBALS_STATIC}).ignored.item := dup (2)
						end
						if not l_tmpname.is_void then
							unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tmpname)).do_nothing;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tmpname))
						end
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1
						if not ((create {P_GLOBALS_STATIC}).recoverymode.item).to_boolean then
							if l_newfile.to_boolean then
								if l_wasempty.to_boolean then
									if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_and (1)).to_boolean then
										(create {P_GLOBALS_STATIC}).netbeansFireChanges.item := 0;
										(create {P_MEMLINE_STATIC}).ml_delete ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count, 0).do_nothing;
										(create {P_GLOBALS_STATIC}).netbeansFireChanges.item := 1
										l_linecnt := l_linecnt - 1
									end
								end
							end
							l_linecnt := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count - l_linecnt
							if l_filesize.item = 0 then
								l_linecnt := (0).to_integer_32
							end
							if l_newfile.to_boolean then
								(create {P_SCREEN_STATIC}).redraw_curbuf_later (40);
								(create {P_DIFF_STATIC}).diff_invalidate ((create {P_GLOBALS_STATIC}).curbuf.item);
								((create {P_GLOBALS_STATIC}).curwin.item).item.foldUpdateAll
							elseif l_read_buffer.to_boolean then
								(create {P_SCREEN_STATIC}).redraw_curbuf_later (40);
								(create {P_DIFF_STATIC}).diff_invalidate ((create {P_GLOBALS_STATIC}).curbuf.item);
								((create {P_GLOBALS_STATIC}).curwin.item).item.foldUpdateAll
							elseif l_linecnt.to_boolean then
								(create {P_MISC1_STATIC}).appended_lines_mark (a_from, l_linecnt)
							end
							if l_read_stdin___0.to_boolean then
								(create {P_TERM_STATIC}).settmode (2);
								(create {P_TERM_STATIC}).starttermcap;
								(create {P_SCREEN_STATIC}).screenclear
							end
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								if not ((a_flags___0).bit_and (16)).to_boolean then
									filemess ((create {P_GLOBALS_STATIC}).curbuf.item, l_sfname, create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_interr.item))))), 0)
									if l_newfile.to_boolean then
										(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro := 1
									end
								end
								(create {P_GLOBALS_STATIC}).msg_scroll.item := l_msg_save
								check_marks_read
								Result := 1
								l_return := True
							end
							if not l_return then
								if not l_filtering.to_boolean then
									if not ((a_flags___0).bit_and (16)).to_boolean then
										msg_add_fname ((create {P_GLOBALS_STATIC}).curbuf.item, l_sfname)
										l_c := (0).to_natural_8
										if ((l_perm).bit_and (61_440)) = 4_096 then
											strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("[fifo/socket]")))).do_nothing
											l_c := (1).to_natural_8
										end
										if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro).to_boolean then
											if ((create {P_OPTION_STATIC}).shortmess (('r').code)).to_boolean then
												l_tmp___89 := (gettext (ce_string ("[RO]")))
											else
												l_tmp___89 := (gettext (ce_string ("[readonly]")))
											end
											strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), l_tmp___89).do_nothing
											l_c := (1).to_natural_8
										end
										if l_read_no_eol_lnum.to_boolean then
											msg_add_eol
											l_c := (1).to_natural_8
										end
										if l_ff_error = 1 then
											strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("[CR missing]")))).do_nothing
											l_c := (1).to_natural_8
										end
										if l_split.to_boolean then
											strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("[long lines split]")))).do_nothing
											l_c := (1).to_natural_8
										end
										if l_notconverted.to_boolean then
											strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("[NOT converted]")))).do_nothing
											l_c := (1).to_natural_8
										elseif l_converted.to_boolean then
											strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("[converted]")))).do_nothing
											l_c := (1).to_natural_8
										end
										if not l_cryptkey.is_void then
											strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("[crypted]")))).do_nothing
											l_c := (1).to_natural_8
										end
										if l_conv_error /= 0 then
											l_tmp___96 := gettext (ce_string ("[CONVERSION ERROR in line %%ld]"))
											sprintf ([(create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item))).to_integer_32), l_tmp___96, l_conv_error]).do_nothing
											l_c := (1).to_natural_8
										elseif l_illegal_byte > 0 then
											l_tmp___98 := gettext (ce_string ("[ILLEGAL BYTE in line %%ld]"))
											sprintf ([(create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item))).to_integer_32), l_tmp___98, l_illegal_byte]).do_nothing
											l_c := (1).to_natural_8
										elseif l_error.to_boolean then
											strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("[READ ERRORS]")))).do_nothing
											l_c := (1).to_natural_8
										end
										if (msg_add_fileformat (l_fileformat)).to_boolean then
											l_c := (1).to_natural_8
										end
										if not l_cryptkey.is_void then
											msg_add_lines (l_c.to_integer_32, l_linecnt, ((l_filesize.item - 12) - (crypt_salt_len.item[(create {P_GLOBALS_STATIC}).use_crypt_method.item]).to_integer_32) - (crypt_seed_len.item[(create {P_GLOBALS_STATIC}).use_crypt_method.item]).to_integer_32)
										else
											msg_add_lines (l_c.to_integer_32, l_linecnt, l_filesize.item)
										end
										(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).keep_msg.item));
										(create {P_GLOBALS_STATIC}).keep_msg.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
										(create {P_GLOBALS_STATIC}).msg_scrolled_ign.item := 1
										l_p___0 := (create {P_MESSAGE_STATIC}).msg_trunc_attr ((create {P_GLOBALS_STATIC}).IObuff.item, 0, 0)
										if l_read_stdin___0.to_boolean then
											(create {P_MESSAGE_STATIC}).set_keep_msg (l_p___0, 0)
										elseif l_read_buffer.to_boolean then
											(create {P_MESSAGE_STATIC}).set_keep_msg (l_p___0, 0)
										elseif (create {P_GLOBALS_STATIC}).restart_edit.item /= 0 then
											(create {P_MESSAGE_STATIC}).set_keep_msg (l_p___0, 0)
										elseif (create {P_GLOBALS_STATIC}).msg_scrolled.item /= 0 then
											if not ((create {P_GLOBALS_STATIC}).need_wait_return.item).to_boolean then
												(create {P_MESSAGE_STATIC}).set_keep_msg (l_p___0, 0)
											end
										end
										(create {P_GLOBALS_STATIC}).msg_scrolled_ign.item := 0
									end
								end
								if l_newfile.to_boolean then
									if l_error.to_boolean then
										(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro := 1
									elseif l_conv_error /= 0 then
										(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro := 1
									elseif l_illegal_byte > 0 then
										if l_bad_char_behavior /= -1 then
											(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro := 1
										end
									end
								end
								(create {P_UNDO_STATIC}).u_clearline
								if ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := a_from + l_linecnt
								else
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := a_from + 1
								end
								(create {P_MISC2_STATIC}).check_cursor_lnum;
								(create {P_EDIT_STATIC}).beginline (5);
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum := a_from + 1;
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.col := 0;
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.lnum := a_from + l_linecnt;
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.col := 0
							end
						end
				when 280 then -- if done
					if not l_return then
						(create {P_GLOBALS_STATIC}).msg_scroll.item := l_msg_save
						check_marks_read;
						(create {P_GLOBALS_STATIC}).write_no_eol_lnum.item := l_read_no_eol_lnum
						if ((a_flags___0).bit_and (32)).to_boolean then
							(create {P_UNDO_STATIC}).u_find_first_changed
						end
						if l_read_undo_file.to_boolean then
							l_sha_ctx.item.sha256_finish (create {CE_NATURAL_8_POINTER}.make_cast (l_hash));
							(create {P_UNDO_STATIC}).u_read_undo (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_hash, l_fname)
						end
						if not l_read_stdin___0.to_boolean then
							if not l_read_buffer.to_boolean then
								l_m___0 := (create {P_GLOBALS_STATIC}).msg_scroll.item
								l_n___1 := (create {P_GLOBALS_STATIC}).msg_scrolled.item
								if l_set_options.to_boolean then
									((create {P_GLOBALS_STATIC}).curbuf.item).item.save_file_ff
								end
								(create {P_GLOBALS_STATIC}).msg_scroll.item := 1
								if l_filtering.to_boolean then
									apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILTERREADPOST, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
								elseif l_newfile.to_boolean then
									apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_BUFREADPOST, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
								else
									apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEREADPOST, l_sfname, l_sfname, 0, create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), a_eap).do_nothing
								end
								if (create {P_GLOBALS_STATIC}).msg_scrolled.item = l_n___1 then
									(create {P_GLOBALS_STATIC}).msg_scroll.item := l_m___0
								end
								if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
									Result := 0
									l_return := True
								end
							end
						end
					end
					if not l_return and then (((create {P_GLOBALS_STATIC}).recoverymode.item).to_boolean) then
						if l_error.to_boolean then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						Result := 1
					end
				when 281 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	readfile_linenr (a_linecnt: INTEGER_32; a_p___0, a_endp: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
		do
			l_lnum := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count - a_linecnt) + 1
			l_s := a_p___0
			from
			until
				not ((l_s.c_pointer.to_integer_32).to_natural_32 < (a_endp.c_pointer.to_integer_32).to_natural_32)
			loop
				if (l_s.item).to_integer_32 = 10 then
					l_lnum := l_lnum + 1
				end
				l_s := l_s + 1
			end
			Result := l_lnum
		end

	next_fenc (a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [NATURAL_8]
		require
			not a_pp.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_r: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			if ((a_pp.item).item).to_integer_32 = 0 then
				a_pp.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
				l_return := True
			end
			if not l_return then
				l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (a_pp.item, (',').code)
				if l_p___0.is_void then
					l_r := (create {P_MBYTE_STATIC}).enc_canonize (a_pp.item)
					a_pp.item := a_pp.item + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_pp.item))).to_integer_32
				else
					l_r := (create {P_MISC2_STATIC}).vim_strnsave (a_pp.item, l_p___0.distance ((a_pp.item)))
					a_pp.item := l_p___0 + 1
					if not l_r.is_void then
						l_p___0 := (create {P_MBYTE_STATIC}).enc_canonize (l_r);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_r))
						l_r := l_p___0
					end
				end
				if l_r.is_void then
					l_r := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
					a_pp.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				end
				Result := l_r
			end
		end

	readfile_charconvert (a_fname, a_fenc: CE_POINTER [NATURAL_8]; a_fdp: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		require
			not a_fdp.is_void
		local
			l_tmpname: CE_POINTER [NATURAL_8]
			l_errmsg: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___4: INTEGER_32
		do
			l_errmsg := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_tmpname := vim_tempname (('r').code)
			if l_tmpname.is_void then
				l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Can%'t find temp file for conversion"))))
			else
				close (a_fdp.item).do_nothing
				a_fdp.item := -1
				if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
					l_tmp___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("utf-8"))
				else
					l_tmp___1 := (create {P_OPTION_STATIC}).p_enc.item.item
				end
				if ((create {P_EVAL_STATIC}).eval_charconvert (a_fenc, l_tmp___1, a_fname, l_tmpname)) = 0 then
					l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Conversion with %'charconvert%' failed"))))
				end
				if l_errmsg.is_void then
					l_tmp___4 := open ([create {CE_INTEGER_8_POINTER}.make_cast (l_tmpname), 0, 0])
					a_fdp.item := l_tmp___4
					if l_tmp___4 < 0 then
						l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("can%'t read output of %'charconvert%'"))))
					end
				end
			end
			if not l_errmsg.is_void then
				(create {P_MESSAGE_STATIC}).msg (l_errmsg).do_nothing
				if not l_tmpname.is_void then
					unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tmpname)).do_nothing;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tmpname))
					l_tmpname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				end
			end
			if a_fdp.item < 0 then
				a_fdp.item := open ([create {CE_INTEGER_8_POINTER}.make_cast (a_fname), 0, 0])
			end
			Result := l_tmpname
		end

	check_marks_read
		do
			if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_marks_read).to_boolean then
				if ((create {P_OPTION_STATIC}).get_viminfo_parameter (('%'').code)) > 0 then
					if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
						(create {P_EX_CMDS_STATIC}).read_viminfo (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 2).do_nothing
					end
				end
			end
			(create {P_GLOBALS_STATIC}).curbuf.item.item.b_marks_read := 1
		end

	crypt_method_from_magic (a_ptr: CE_POINTER [INTEGER_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_return, l_continue: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				not (not (l_return) and then (l_i___0 < (({PLATFORM}.Pointer_bytes.to_natural_32 * (2).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32))
			loop
				l_continue := False
				if a_len < (12 + crypt_salt_len.item[l_i___0]) + crypt_seed_len.item[l_i___0] then
					l_continue := True
				end
				if not (l_return or l_continue) then
					if (memcmp (create {CE_VOID_POINTER}.make_cast (a_ptr), create {CE_VOID_POINTER}.make_cast (crypt_magic.item[l_i___0]), (12).to_natural_32)) = 0 then
						Result := l_i___0
						l_return := True
					end
				end
				if (not l_return) then
					l_i___0 := l_i___0 + 1
				end
			end
			if not l_return then
				l_continue := False
				l_i___0 := (strlen (crypt_magic_head.item)).to_integer_32
				if a_len >= l_i___0 then
					if (memcmp (create {CE_VOID_POINTER}.make_cast (a_ptr), create {CE_VOID_POINTER}.make_cast (crypt_magic_head.item), l_i___0.to_natural_32)) = 0 then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E821: File is encrypted with unknown method"))))).do_nothing
					end
				end
				Result := (-1)
			end
		end

	check_for_cryptkey (a_cryptkey, a_ptr: CE_POINTER [NATURAL_8]; a_sizep, a_filesizep: CE_POINTER [INTEGER_32]; a_newfile: INTEGER_32; a_fname: CE_POINTER [NATURAL_8]; a_did_ask: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		require
			not a_sizep.is_void
		local
			l_cryptkey: CE_POINTER [NATURAL_8]
			l_method: INTEGER_32
			l_seed_len: INTEGER_32
			l_salt_len: INTEGER_32
		do
			l_cryptkey := a_cryptkey
			l_method := (crypt_method_from_magic (create {CE_INTEGER_8_POINTER}.make_cast (a_ptr), (a_sizep.item).to_integer_32))
			if l_method >= 0 then
				((create {P_GLOBALS_STATIC}).curbuf.item).item.set_crypt_method (l_method)
				if l_method > 0 then
					(create {P_BLOWFISH_STATIC}).blowfish_self_test.do_nothing
				end
				if l_cryptkey.is_void then
					if not (a_did_ask.item).to_boolean then
						if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_key).item).to_boolean then
							l_cryptkey := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_key
						else
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (((create {P_GLOBALS_STATIC}).need_key_msg.item)))), a_fname]).do_nothing;
							(create {P_GLOBALS_STATIC}).msg_scroll.item := 1
							l_cryptkey := (create {P_MISC2_STATIC}).get_crypt_key (a_newfile, 0)
							a_did_ask.item := 1
							if not l_cryptkey.is_void then
								if (l_cryptkey.item).to_integer_32 = 0 then
									if not l_cryptkey.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_key) then
										(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cryptkey))
									end
									l_cryptkey := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								end
							end
						end
					end
				end
				if not l_cryptkey.is_void then
					l_seed_len := crypt_seed_len.item[l_method]
					l_salt_len := crypt_salt_len.item[l_method];
					(create {P_MISC2_STATIC}).crypt_push_state;
					(create {P_GLOBALS_STATIC}).use_crypt_method.item := l_method
					if l_method = 0 then
						(create {P_MISC2_STATIC}).crypt_init_keys (l_cryptkey)
					else
						(create {P_BLOWFISH_STATIC}).bf_key_init (l_cryptkey, a_ptr + 12, l_salt_len);
						(create {P_BLOWFISH_STATIC}).bf_ofb_init ((a_ptr + 12) + l_salt_len, l_seed_len)
					end
					a_filesizep.item := a_filesizep.item + ((12 + l_salt_len) + l_seed_len).to_integer_32
					a_sizep.item := a_sizep.item - ((12 + l_salt_len) + l_seed_len).to_integer_32
					memmove (create {CE_VOID_POINTER}.make_cast (a_ptr), create {CE_VOID_POINTER}.make_cast ((((a_ptr + 12) + l_salt_len) + l_seed_len)), (a_sizep.item).to_natural_32).do_nothing
				end
			elseif a_newfile.to_boolean then
				if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_key).item).to_integer_32 /= 0 then
					if not ((create {P_GLOBALS_STATIC}).starting.item).to_boolean then
						(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("key")), 0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 4)
					end
				end
			end
			Result := l_cryptkey
		end

	prepare_crypt_read (a_fp: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_method: INTEGER_32
			l_buffer: CE_ARRAY [NATURAL_8]
			l_salt_len: INTEGER_32
			l_seed_len: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_buffer.make (<<30>>)

			if (fread (create {CE_VOID_POINTER}.make_cast (l_buffer), (12).to_natural_32, (1).to_natural_32, a_fp)) /= {NATURAL_32} 1 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_method := crypt_method_from_magic (create {CE_INTEGER_8_POINTER}.make_cast (l_buffer), 28)
				if l_method < 0 then
					Result := 0
					l_return := True
				elseif l_method /= (((create {P_GLOBALS_STATIC}).curbuf.item).item.get_crypt_method) then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				(create {P_MISC2_STATIC}).crypt_push_state
				if l_method = 0 then
					(create {P_MISC2_STATIC}).crypt_init_keys ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_key)
				else
					l_salt_len := crypt_salt_len.item[l_method]
					l_seed_len := crypt_seed_len.item[l_method]
					if (fread (create {CE_VOID_POINTER}.make_cast (l_buffer), (l_salt_len + l_seed_len).to_natural_32, (1).to_natural_32, a_fp)) /= {NATURAL_32} 1 then
						Result := 0
						l_return := True
					end
					if not l_return then
						(create {P_BLOWFISH_STATIC}).bf_key_init ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_key, l_buffer, l_salt_len);
						(create {P_BLOWFISH_STATIC}).bf_ofb_init (l_buffer + l_salt_len, l_seed_len)
					end
				end
			end
			if not l_return then
				Result := 1
			end
		end

	set_file_time (a_fname: CE_POINTER [NATURAL_8]; a_atime, a_mtime: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [SD_UTIMBUF]
		do
			create {CE_CLASS_ARRAY [SD_UTIMBUF]} l_buf___6.make (<<1>>)

			l_buf___6.item.actime := a_atime
			l_buf___6.item.modtime := a_mtime
			utime (create {CE_INTEGER_8_POINTER}.make_cast (a_fname), l_buf___6).do_nothing
		end

	check_file_readonly (a_fname: CE_POINTER [NATURAL_8]; a_perm: INTEGER_32): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if ((a_perm).bit_and (146)) = 0 then
				l_tmp___0 := 1
			elseif (access (create {CE_INTEGER_8_POINTER}.make_cast (a_fname), 2)).to_boolean then
				l_tmp___0 := 1
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	buf_write (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_fname, a_sfname: CE_POINTER [NATURAL_8]; a_start___1, a_end: INTEGER_32; a_eap: CE_POINTER [PD_EXARG]; a_append, a_forceit, a_reset_changed, a_filtering: INTEGER_32): INTEGER_32
		require
			not a_buf___6.is_void
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_fname: CE_POINTER [NATURAL_8]
			l_sfname: CE_POINTER [NATURAL_8]
			l_start___1: INTEGER_32
			l_end: INTEGER_32
			l_fd: INTEGER_32
			l_backup: CE_POINTER [NATURAL_8]
			l_backup_copy: INTEGER_32
			l_dobackup: INTEGER_32
			l_ffname: CE_POINTER [NATURAL_8]
			l_wfname: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_c: NATURAL_8
			l_len: INTEGER_32
			l_lnum: INTEGER_32
			l_nchars: INTEGER_32
			l_errmsg: CE_POINTER [NATURAL_8]
			l_errmsg_allocated: INTEGER_32
			l_errnum: CE_POINTER [NATURAL_8]
			l_buffer: CE_POINTER [NATURAL_8]
			l_smallbuf: CE_ARRAY [NATURAL_8]
			l_backup_ext: CE_POINTER [NATURAL_8]
			l_bufsize: INTEGER_32
			l_perm: INTEGER_32
			l_retval: INTEGER_32
			l_newfile: INTEGER_32
			l_msg_save: INTEGER_32
			l_overwriting: INTEGER_32
			l_no_eol: INTEGER_32
			l_device: INTEGER_32
			l_st_old: CE_ARRAY [SD_STAT]
			l_prev_got_int: INTEGER_32
			l_file_readonly: INTEGER_32
			l_made_writable: INTEGER_32
			l_whole: INTEGER_32
			l_tmp: INTEGER_32
			l_old_line_count: INTEGER_32
			l_attr: INTEGER_32
			l_fileformat: INTEGER_32
			l_write_bin: INTEGER_32
			l_write_info: CE_ARRAY [PD_BW_INFO]
			l_converted: INTEGER_32
			l_notconverted: INTEGER_32
			l_fenc: CE_POINTER [NATURAL_8]
			l_fenc_tofree: CE_POINTER [NATURAL_8]
			l_wb_flags: INTEGER_32
			l_acl: CE_POINTER [ANY]
			l_write_undo_file: INTEGER_32
			l_sha_ctx: CE_ARRAY [PD_CONTEXT_SHA256_T]
			l_aco: CE_ARRAY [PD_ACO_SAVE_T]
			l_buf_ffname: INTEGER_32
			l_buf_sfname: INTEGER_32
			l_buf_fname_f: INTEGER_32
			l_buf_fname_s: INTEGER_32
			l_did_cmd: INTEGER_32
			l_nofile_err: INTEGER_32
			l_empty_memline: INTEGER_32
			l_tmp___33: INTEGER_32
			l_st: CE_ARRAY [SD_STAT]
			l_i___0: INTEGER_32
			l_lstat_res: INTEGER_32
			l_bfd: INTEGER_32
			l_copybuf: CE_POINTER [NATURAL_8]
			l_wp___0: CE_POINTER [NATURAL_8]
			l_some_error: INTEGER_32
			l_st_new: CE_ARRAY [SD_STAT]
			l_dirp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_rootname: CE_POINTER [NATURAL_8]
			l_did_set_shortname: INTEGER_32
			l_tmp___39: INTEGER_32
			l_tmp___40: NATURAL_32
			l_dirp___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_rootname___0: CE_POINTER [NATURAL_8]
			l_tmp___54: INTEGER_32
			l_tmp___55: NATURAL_32
			l_tmp___66: CE_POINTER [NATURAL_8]
			l_st___0: CE_ARRAY [SD_STAT]
			l_tmp___70: CE_POINTER [INTEGER_8]
			l_st___1: CE_ARRAY [SD_STAT]
			l_tmp___79: INTEGER_32
			l_tmp___80: INTEGER_32
			l_tmp___81: INTEGER_32
			l_header: CE_POINTER [NATURAL_8]
			l_header_len: CE_ARRAY [INTEGER_32]
			l_tmp___84: INTEGER_32
			l_tmp___88: CE_POINTER [NATURAL_8]
			l_tmp___89: CE_POINTER [NATURAL_8]
			l_tmp___91: CE_POINTER [NATURAL_8]
			l_st___2: CE_ARRAY [SD_STAT]
			l_tmp___99: CE_POINTER [NATURAL_8]
			l_tmp___117: CE_POINTER [INTEGER_8]
			l_tmp___124: CE_POINTER [INTEGER_8]
			l_tmp___129: CE_POINTER [INTEGER_8]
			l_org: CE_POINTER [INTEGER_8]
			l_tmp___134: INTEGER_32
			l_st___3: CE_ARRAY [SD_STAT]
			l_empty_fd: INTEGER_32
			l_tmp___138: CE_POINTER [INTEGER_8]
			l_tmp___139: INTEGER_32
			l_numlen: INTEGER_32
			l_tmp___144: INTEGER_32
			l_tmp___146: NATURAL_32
			l_hash: CE_ARRAY [NATURAL_8]
			l_aco___0: CE_ARRAY [PD_ACO_SAVE_T]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_ffname.make
			create {CE_NATURAL_8_ARRAY} l_smallbuf.make (<<256>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st_old.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_BW_INFO]} l_write_info.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_CONTEXT_SHA256_T]} l_sha_ctx.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_ACO_SAVE_T]} l_aco.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st_new.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_dirp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_dirp___0.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st___0.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st___1.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_header_len.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st___2.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st___3.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_hash.make (<<32>>)
			create {CE_CLASS_ARRAY [PD_ACO_SAVE_T]} l_aco___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6 := a_buf___6
					l_fname := a_fname
					l_sfname := a_sfname
					l_start___1 := a_start___1
					l_end := a_end
					l_backup := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_backup_copy := 0
					l_wfname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_errmsg := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_errmsg_allocated := 0
					l_errnum := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_retval := 1
					l_newfile := 0
					l_msg_save := (create {P_GLOBALS_STATIC}).msg_scroll.item
					l_no_eol := 0
					l_device := 0
					l_prev_got_int := (create {P_GLOBALS_STATIC}).got_int.item
					l_file_readonly := 0
					l_made_writable := 0
					if l_start___1 = 1 then
						if l_end = l_buf___6.item.b_ml.ml_line_count then
							l_tmp := 1
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_whole := l_tmp
					l_old_line_count := l_buf___6.item.b_ml.ml_line_count
					l_converted := 0
					l_notconverted := 0
					l_fenc_tofree := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_wb_flags := 0
					l_acl := create {CE_VOID_POINTER}.make_shared (default_pointer)
					l_write_undo_file := 0
					if l_fname.is_void then
						Result := 0
						l_return := True
					elseif (l_fname.item).to_integer_32 = 0 then
						Result := 0
						l_return := True
					end
					if not l_return and then ((l_buf___6.item.b_ml.ml_mfp).is_void) then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_emptybuf.item)))))).do_nothing
						Result := 0
						l_return := True
					end
					if not l_return then
						if ((create {P_EX_CMDS_STATIC}).check_secure).to_boolean then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fname))) >= {NATURAL_32} 4_096 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_longname.item)))))).do_nothing
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_write_info.item.bw_conv_buf := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_write_info.item.bw_conv_error := 0
						l_write_info.item.bw_conv_error_lnum := (0).to_integer_32
						l_write_info.item.bw_restlen := 0
						l_write_info.item.bw_iconv_fd := create {CE_VOID_POINTER}.make_shared (default_pointer + -1);
						(create {P_GLOBALS_STATIC}).ex_no_reprint.item := 1
						if not ((l_buf___6.item.b_ffname).is_void) then
							l_pos := -1 + 12 -- skip if block
						end
				when 2 then -- if:
						if not (a_reset_changed.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if:
						if not (l_whole.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if not (l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item)) then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if:
						if (l_buf___6.item.bt_nofile).to_boolean then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
						if a_filtering.to_boolean then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if a_append.to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('P').code)).is_void then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('F').code)).is_void then
							if (set_rw_fname (l_fname, l_sfname)) = 0 then
								Result := 0
								l_return := True
							end
							if not l_return then
								l_buf___6 := (create {P_GLOBALS_STATIC}).curbuf.item
							end
						end
				when 12 then -- if done | if done | if done | if done | if done | if done | if done | if done
					if l_return then
						l_pos := -1 + 37 -- skip if block
					end
				when 13 then -- if:
						if l_sfname.is_void then
							l_sfname := l_fname
						end
						l_ffname := l_fname
						l_fname := l_sfname
						if not (l_buf___6.item.b_ffname).is_void then
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_ffname), create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6.item.b_ffname))) = 0 then
								l_overwriting := 1
							else
								l_overwriting := 0
							end
						else
							l_overwriting := 0
						end
						if ((create {P_GLOBALS_STATIC}).exiting.item).to_boolean then
							(create {P_TERM_STATIC}).settmode (0)
						end
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item + 1
						l_buf___6.item.b_op_start.lnum := l_start___1
						l_buf___6.item.b_op_start.col := 0
						l_buf___6.item.b_op_end.lnum := l_end
						l_buf___6.item.b_op_end.col := 0
						l_buf_ffname := 0
						l_buf_sfname := 0
						l_buf_fname_f := 0
						l_buf_fname_s := 0
						l_did_cmd := 0
						l_nofile_err := 0
						l_empty_memline := ((l_buf___6.item.b_ml.ml_mfp).is_void).to_integer
						if l_ffname.is_equal (l_buf___6.item.b_ffname) then
							l_buf_ffname := 1
						end
						if l_sfname.is_equal (l_buf___6.item.b_sfname) then
							l_buf_sfname := 1
						end
						if l_fname.is_equal (l_buf___6.item.b_ffname) then
							l_buf_fname_f := 1
						end
						if l_fname.is_equal (l_buf___6.item.b_sfname) then
							l_buf_fname_s := 1
						end
						l_aco.item.aucmd_prepbuf (l_buf___6)
						if not (a_append.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_did_cmd := apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEAPPENDCMD, l_sfname, l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap)
						if not l_did_cmd.to_boolean then
							if l_overwriting.to_boolean then
								if (((create {P_GLOBALS_STATIC}).curbuf.item).item.bt_nofile).to_boolean then
									l_nofile_err := 1
								else
									apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEAPPENDPRE, l_sfname, l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
								end
							else
								apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEAPPENDPRE, l_sfname, l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
							end
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 16 then -- else:
						if not (a_filtering.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILTERWRITEPRE, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 19 then -- else:
						if not (a_reset_changed.to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if l_whole.to_boolean then
							l_did_cmd := apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_BUFWRITECMD, l_sfname, l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap)
							if not l_did_cmd.to_boolean then
								if l_overwriting.to_boolean then
									if (((create {P_GLOBALS_STATIC}).curbuf.item).item.bt_nofile).to_boolean then
										l_nofile_err := 1
									else
										apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_BUFWRITEPRE, l_sfname, l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
									end
								else
									apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_BUFWRITEPRE, l_sfname, l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
								end
							end
						else
							l_pos := -1 + 22 -- goto _L___0
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else: | _L___0:
						l_did_cmd := apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEWRITECMD, l_sfname, l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap)
						if not l_did_cmd.to_boolean then
							if l_overwriting.to_boolean then
								if (((create {P_GLOBALS_STATIC}).curbuf.item).item.bt_nofile).to_boolean then
									l_nofile_err := 1
								else
									apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEWRITEPRE, l_sfname, l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
								end
							else
								apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEWRITEPRE, l_sfname, l_sfname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
							end
						end
				when 23 then -- if done | if done
						l_aco.item.aucmd_restbuf
						if not ((create {P_BUFFER_STATIC}).buf_valid (l_buf___6)).to_boolean then
							l_buf___6 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
						end
						if not (l_buf___6.is_void) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 36 -- goto _L___1
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 26 then -- else:
						if not ((l_buf___6.item.b_ml.ml_mfp).is_void) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						if not l_empty_memline.to_boolean then
							l_pos := -1 + 36 -- goto _L___1
						else
							l_pos := -1 + 29 -- goto _L___2
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 29 then -- else: | _L___2:
						if not (l_did_cmd.to_boolean) then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 36 -- goto _L___1
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 32 then -- else:
						if not (l_nofile_err.to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 36 -- goto _L___1
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 35 then -- else:
						if not (((create {P_EX_EVAL_STATIC}).aborting).to_boolean) then
							l_pos := -1 + 37 -- skip if block
						end
				when 36 then -- if: | _L___1:;
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1;
						(create {P_GLOBALS_STATIC}).msg_scroll.item := l_msg_save
						if l_nofile_err.to_boolean then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E676: No matching autocommands for acwrite buffer"))))).do_nothing
						end
						if l_nofile_err.to_boolean then
							Result := 0
							l_return := True
						elseif ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
							Result := 0
							l_return := True
						end
						if not l_return and then (l_did_cmd.to_boolean) then
							if l_buf___6.is_void then
								Result := 1
								l_return := True
							end
							if not l_return then
								if l_overwriting.to_boolean then
									l_buf___6.item.ml_timestamp
									if a_append.to_boolean then
										l_buf___6.item.b_flags := (l_buf___6.item.b_flags).bit_and ((-17))
									else
										l_buf___6.item.b_flags := (l_buf___6.item.b_flags).bit_and ((-89))
									end
								end
								if a_reset_changed.to_boolean then
									if (l_buf___6.item.b_changed).to_boolean then
										if not a_append.to_boolean then
											if l_overwriting.to_boolean then
												Result := 0
												l_return := True
											elseif not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('+').code)).is_void then
												Result := 0
												l_return := True
											end
										end
									end
								end
							end
							if not l_return then
								Result := 1
								l_return := True
							end
						end
						if not l_return then
							if not ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E203: Autocommands deleted or unloaded buffer to be written"))))).do_nothing
							end
							Result := 0
							l_return := True
						end
				when 37 then -- if done | if done | if done | if done | if done
					if not l_return and then (l_buf___6.item.b_ml.ml_line_count /= l_old_line_count) then
						if l_whole.to_boolean then
							l_end := l_buf___6.item.b_ml.ml_line_count
						elseif l_buf___6.item.b_ml.ml_line_count > l_old_line_count then
							l_end := l_end + (l_buf___6.item.b_ml.ml_line_count - l_old_line_count)
						else
							l_end := l_end - (l_old_line_count - l_buf___6.item.b_ml.ml_line_count)
							if l_end < l_start___1 then
								(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1;
								(create {P_GLOBALS_STATIC}).msg_scroll.item := l_msg_save;
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E204: Autocommand changed number of lines in unexpected way"))))).do_nothing
								Result := 0
								l_return := True
							end
						end
					end
					if not l_return then
						if l_buf_ffname.to_boolean then
							l_ffname := l_buf___6.item.b_ffname
						end
						if l_buf_sfname.to_boolean then
							l_sfname := l_buf___6.item.b_sfname
						end
						if l_buf_fname_f.to_boolean then
							l_fname := l_buf___6.item.b_ffname
						end
						if l_buf_fname_s.to_boolean then
							l_fname := l_buf___6.item.b_sfname
						end
						if ((create {P_NETBEANS_STATIC}).netbeans_active).to_boolean then
							if ((create {P_NETBEANS_STATIC}).isNetbeansBuffer (l_buf___6)).to_boolean then
								if l_whole.to_boolean then
									if (l_buf___6.item.b_changed).to_boolean then
										(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1;
										(create {P_GLOBALS_STATIC}).msg_scroll.item := l_msg_save;
										(create {P_NETBEANS_STATIC}).netbeans_save_buffer (l_buf___6)
										Result := l_retval
										l_return := True
									elseif ((create {P_NETBEANS_STATIC}).isNetbeansModified (l_buf___6)).to_boolean then
										(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1;
										(create {P_GLOBALS_STATIC}).msg_scroll.item := l_msg_save;
										(create {P_NETBEANS_STATIC}).netbeans_save_buffer (l_buf___6)
										Result := l_retval
										l_return := True
									else
										l_errnum := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E656: "))
										l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("NetBeans disallows writes of unmodified buffers"))))
										l_buffer := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
										l_pos := -1 + 140 -- goto fail
									end
								else
									l_errnum := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E657: "))
									l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Partial writes disallowed for NetBeans buffers"))))
									l_buffer := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
									l_pos := -1 + 140 -- goto fail
								end
							end
						end
					end
				when 38 then
					if l_return then
						l_pos := -1 + 142 -- skip if block
					end
				when 39 then -- if:
						if ((create {P_OPTION_STATIC}).shortmess (('o').code)).to_boolean then
							if not ((create {P_GLOBALS_STATIC}).exiting.item).to_boolean then
								(create {P_GLOBALS_STATIC}).msg_scroll.item := 0
							else
								(create {P_GLOBALS_STATIC}).msg_scroll.item := 1
							end
						else
							(create {P_GLOBALS_STATIC}).msg_scroll.item := 1
						end
						if not a_filtering.to_boolean then
							filemess (l_buf___6, l_fname, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 0)
						end
						(create {P_GLOBALS_STATIC}).msg_scroll.item := 0
						l_buffer := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 8_192)
						if l_buffer.is_void then
							l_buffer := l_smallbuf
							l_bufsize := 256
						else
							l_bufsize := 8_192
						end
						l_st_old.item.st_dev := (0).to_natural_64
						l_st_old.item.st_ino := (0).to_natural_32
						l_perm := -1
						if not ((stat (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), l_st_old)) < 0) then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						l_newfile := 1
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 42 then -- else:
						l_perm := (l_st_old.item.st_mode).to_integer_32
						if (((l_st_old.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 32_768) then
							l_pos := -1 + 46 -- skip if block
						end
				when 43 then -- if:
						if ((l_st_old.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 16_384 then
							l_errnum := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E502: "))
							l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("is a directory"))))
							l_pos := -1 + 140 -- goto fail
						end
				when 44 then
						if ((create {P_OS_UNIX_STATIC}).mch_nodetype (l_fname)) /= 1 then
							l_errnum := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E503: "))
							l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("is not a file or writable device"))))
							l_pos := -1 + 140 -- goto fail
						end
				when 45 then
						l_device := 1
						l_newfile := 1
						l_perm := -1
				when 46 then -- if done | if done
						if l_device.to_boolean then
							l_pos := -1 + 50 -- skip if block
						end
				when 47 then -- if:
						if l_newfile.to_boolean then
							l_pos := -1 + 50 -- skip if block
						end
				when 48 then -- if:
						l_file_readonly := check_file_readonly (l_fname, l_perm.to_integer_32)
						if not a_forceit.to_boolean then
							if l_file_readonly.to_boolean then
								if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('W').code)).is_void then
									l_errnum := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E504: "))
									l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (err_readonly.item)))
								else
									l_errnum := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E505: "))
									l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("is read-only (add ! to override)"))))
								end
								l_pos := -1 + 140 -- goto fail
							end
						end
				when 49 then
						if l_overwriting.to_boolean then
							l_retval := l_buf___6.item.check_mtime (l_st_old)
							if l_retval = 0 then
								l_pos := -1 + 140 -- goto fail
							end
						end
				when 50 then -- if done
						if not l_newfile.to_boolean then
							l_acl := (create {P_OS_UNIX_STATIC}).mch_get_acl (l_fname)
						end
						if ((create {P_OPTION_STATIC}).p_wb.item.item).to_boolean then
							l_tmp___33 := 1
						elseif ((create {P_OPTION_STATIC}).p_bk.item.item).to_boolean then
							l_tmp___33 := 1
						elseif ((create {P_OPTION_STATIC}).p_pm.item.item.item).to_integer_32 /= 0 then
							l_tmp___33 := 1
						else
							l_tmp___33 := 0
						end
						l_dobackup := l_tmp___33
						if l_dobackup.to_boolean then
							if ((create {P_OPTION_STATIC}).p_bsk.item.item.item).to_integer_32 /= 0 then
								if (match_file_list ((create {P_OPTION_STATIC}).p_bsk.item.item, l_sfname, l_ffname)).to_boolean then
									l_dobackup := 0
								end
							end
						end
						l_prev_got_int := (create {P_GLOBALS_STATIC}).got_int.item;
						(create {P_GLOBALS_STATIC}).got_int.item := 0
						l_buf___6.item.b_saving := 1
						if not (a_append.to_boolean) then
							l_pos := -1 + 53 -- skip if block
						end
				when 51 then -- if:
						if ((create {P_OPTION_STATIC}).p_pm.item.item.item).to_integer_32 /= 0 then
							l_pos := -1 + 53 -- goto _L___6
						end
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 84
				when 53 then -- else: | _L___6:
						if a_filtering.to_boolean then
							l_pos := -1 + 84 -- skip if block
						end
				when 54 then -- if:
						if not (l_perm >= 0) then
							l_pos := -1 + 84 -- skip if block
						end
				when 55 then -- if:
						if not (l_dobackup.to_boolean) then
							l_pos := -1 + 84 -- skip if block
						end
				when 56 then -- if:
						if (((create {P_OPTION_STATIC}).bkc_flags.item.item).bit_and ({NATURAL_32} 1)).to_boolean then
							l_backup_copy := 1
						elseif a_append.to_boolean then
							l_backup_copy := 1
						elseif (((create {P_OPTION_STATIC}).bkc_flags.item.item).bit_and ({NATURAL_32} 2)).to_boolean then
							if l_st_old.item.st_nlink > {NATURAL_32} 1 then
								l_backup_copy := 1
							elseif (lstat (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), l_st)) < 0 then
								l_backup_copy := 1
							elseif l_st.item.st_dev /= l_st_old.item.st_dev then
								l_backup_copy := 1
							elseif l_st.item.st_ino /= l_st_old.item.st_ino then
								l_backup_copy := 1
							else
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), create {CE_INTEGER_8_POINTER}.make_cast (l_fname)).do_nothing
								l_i___0 := 4_913
								from
								until
									(l_break)
								loop
									l_break := False
									sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC1_STATIC}).gettail ((create {P_GLOBALS_STATIC}).IObuff.item))), ce_string ("%%d"), l_i___0]).do_nothing
									if (lstat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), l_st)) < 0 then
										l_break := True
									end
									if not (l_break) then
										l_i___0 := l_i___0 + (123)
									end
								end
								l_break := False
								l_fd := open ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), 131_265, l_perm])
								if l_fd < 0 then
									l_backup_copy := 1
								else
									(create {P_GLOBALS_STATIC}).ignored.item := fchown (l_fd, l_st_old.item.st_uid, l_st_old.item.st_gid)
									if (stat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), l_st)) < 0 then
										l_backup_copy := 1
									elseif l_st.item.st_uid /= l_st_old.item.st_uid then
										l_backup_copy := 1
									elseif l_st.item.st_gid /= l_st_old.item.st_gid then
										l_backup_copy := 1
									elseif (l_st.item.st_mode).to_integer_32 /= l_perm then
										l_backup_copy := 1
									end
									close (l_fd).do_nothing
									unlink (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item)).do_nothing
								end
							end
						end
						if not ((((create {P_OPTION_STATIC}).bkc_flags.item.item).bit_and ({NATURAL_32} 8)).to_boolean) then
							l_pos := -1 + 59 -- skip if block
						end
				when 57 then -- if:
						l_pos := -1 + 60 -- goto _L___3
				when 58 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 59 then -- else:
						if not ((((create {P_OPTION_STATIC}).bkc_flags.item.item).bit_and ({NATURAL_32} 16)).to_boolean) then
							l_pos := -1 + 61 -- skip if block
						end
				when 60 then -- if: | _L___3:
						l_lstat_res := lstat (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), l_st)
						if (((create {P_OPTION_STATIC}).bkc_flags.item.item).bit_and ({NATURAL_32} 8)).to_boolean then
							if l_lstat_res = 0 then
								if l_st.item.st_ino /= l_st_old.item.st_ino then
									l_backup_copy := 0
								end
							end
						end
						if (((create {P_OPTION_STATIC}).bkc_flags.item.item).bit_and ({NATURAL_32} 16)).to_boolean then
							if l_st_old.item.st_nlink > {NATURAL_32} 1 then
								if l_lstat_res /= 0 then
									l_backup_copy := 0
								elseif l_st.item.st_ino = l_st_old.item.st_ino then
									l_backup_copy := 0
								end
							end
						end
				when 61 then -- if done
						if ((create {P_OPTION_STATIC}).p_bex.item.item.item).to_integer_32 = 0 then
							l_backup_ext := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".bak"))
						else
							l_backup_ext := (create {P_OPTION_STATIC}).p_bex.item.item
						end
						if not (l_backup_copy.to_boolean) then
							l_pos := -1 + 82 -- skip if block
						end
				when 62 then -- if:
						l_fd := open ([create {CE_INTEGER_8_POINTER}.make_cast (l_fname), 0, 0])
						if not (l_fd >= 0) then
							l_pos := -1 + 80 -- skip if block
						end
				when 63 then -- if:
						l_some_error := 0
						l_copybuf := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 8_193)
						if l_copybuf.is_void then
							l_some_error := 1
							l_pos := -1 + 73 -- goto nobackup
						end
				when 64 then
						l_dirp.item := (create {P_OPTION_STATIC}).p_bdir.item.item
				when 65 then -- loop condition:
						if not (not (l_return or l_break) and then ((l_dirp.item.item).to_boolean)) then
							l_pos := -1 + 72 -- skip loop
						end
				when 66 then -- loop body:
						l_break := False
						l_st_new.item.st_ino := (0).to_natural_32
						l_st_new.item.st_dev := (0).to_natural_64
						l_st_new.item.st_gid := (0).to_natural_32;
						(create {P_MISC2_STATIC}).copy_option_part (l_dirp, l_copybuf, 8_192, ce_string (",")).do_nothing
						l_rootname := (create {P_MEMLINE_STATIC}).get_file_in_dir (l_fname, l_copybuf)
						if l_rootname.is_void then
							l_some_error := 1
							l_pos := -1 + 73 -- goto nobackup
						end
				when 67 then
						l_did_set_shortname := 0
				when 68 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 71 -- skip loop
						end
				when 69 then -- loop body:
						l_break := False
						l_continue := False
						if (l_buf___6.item.b_p_sn).to_boolean then
							l_tmp___39 := 1
						elseif (l_buf___6.item.b_shortname).to_boolean then
							l_tmp___39 := 1
						else
							l_tmp___39 := 0
						end
						l_backup := buf_modname (l_tmp___39, l_rootname, l_backup_ext, 0)
						if l_backup.is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_rootname))
							l_some_error := 1
							l_pos := -1 + 73 -- goto nobackup
						end
				when 70 then
						if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_backup), l_st_new)) >= 0 then
							if l_st_new.item.st_dev = l_st_old.item.st_dev then
								if l_st_new.item.st_ino = l_st_old.item.st_ino then
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_backup))
									l_backup := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
									if not (l_buf___6.item.b_shortname).to_boolean then
										if not (l_buf___6.item.b_p_sn).to_boolean then
											l_buf___6.item.b_shortname := 1
											l_did_set_shortname := 1
											l_continue := True
										end
									end
									if not (l_return or l_break or l_continue) then
										if l_did_set_shortname.to_boolean then
											l_buf___6.item.b_shortname := 0
										end
										l_break := True
									end
								end
							end
							if not (l_return or l_break or l_continue) and then (not ((create {P_OPTION_STATIC}).p_bk.item.item).to_boolean) then
								l_tmp___40 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_backup))
								l_wp___0 := ((l_backup + l_tmp___40.to_integer_32) - 1) - (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_backup_ext))).to_integer_32
								if (l_wp___0.c_pointer.to_integer_32).to_natural_32 < (l_backup.c_pointer.to_integer_32).to_natural_32 then
									l_wp___0 := l_backup
								end
								l_wp___0.item := (('z').code).to_natural_8
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_wp___0.item).to_integer_32 > 97 then
										if not ((stat (create {CE_INTEGER_8_POINTER}.make_cast (l_backup), l_st_new)) >= 0) then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_wp___0.item := ((l_wp___0.item).to_integer_32 - 1).to_natural_8
									end
								end
								l_break := False
								if (l_wp___0.item).to_integer_32 = 97 then
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_backup))
									l_backup := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_break := True
						end
						if (not l_return and not l_break) then
							
						end
						l_pos := -1 + 68 -- back to loop condition
				when 71 then -- loop done
						l_break := False
						l_continue := False;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_rootname))
						if not l_backup.is_void then
							unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_backup)).do_nothing
							l_bfd := open ([create {CE_INTEGER_8_POINTER}.make_cast (l_backup), 131_265, (l_perm).bit_and (511)])
							if l_bfd < 0 then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_backup))
								l_backup := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							else
								(create {P_OS_UNIX_STATIC}).mch_setperm (l_backup, (l_perm).bit_and (511)).do_nothing
								if l_st_new.item.st_gid /= l_st_old.item.st_gid then
									if (fchown (l_bfd, (-1).to_natural_32, l_st_old.item.st_gid)) /= 0 then
										(create {P_OS_UNIX_STATIC}).mch_setperm (l_backup, (((l_perm).bit_and (455))).bit_or (((((l_perm).bit_and (7))).bit_shift_left (3)))).do_nothing
									end
								end
								l_write_info.item.bw_fd := l_bfd
								l_write_info.item.bw_buf := l_copybuf
								l_write_info.item.bw_flags := 8_192
								from
								until
									(l_break)
								loop
									l_break := False
									l_write_info.item.bw_len := read (l_fd, create {CE_VOID_POINTER}.make_cast (l_copybuf), (8_192).to_natural_32)
									if not (l_write_info.item.bw_len > 0) then
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										if (l_write_info.item.buf_write_bytes) = 0 then
											l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E506: Can%'t write to backup file (add ! to override)"))))
											l_break := True
										end
									end
									if not (l_return or l_break or l_continue) then
										(create {P_UI_STATIC}).ui_breakcheck
										if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
											l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_interr.item)))))
											l_break := True
										end
									end
								end
								l_break := False
								if (close (l_bfd)) < 0 then
									if l_errmsg.is_void then
										l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E507: Close error for backup file (add ! to override)"))))
									end
								end
								if l_write_info.item.bw_len < 0 then
									l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E508: Can%'t read file for backup (add ! to override)"))))
								end
								set_file_time (l_backup, l_st_old.item.st_atim.tv_sec, l_st_old.item.st_mtim.tv_sec);
								(create {P_OS_UNIX_STATIC}).mch_set_acl (l_backup, l_acl)
								l_break := True
							end
						end
						l_pos := -1 + 65 -- back to loop condition
				when 72 then -- loop done
						l_break := False
				when 73 then -- nobackup:
						close (l_fd).do_nothing;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_copybuf))
						if l_backup.is_void then
							if l_errmsg.is_void then
								l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E509: Cannot create backup file (add ! to override)"))))
							end
						end
						if not (l_some_error.to_boolean) then
							l_pos := -1 + 76 -- skip if block
						end
				when 74 then -- if:
						l_pos := -1 + 77 -- goto _L___4
				when 75 then -- if block done, skip else block:
						l_pos := -1 + 78
				when 76 then -- else:
						if l_errmsg.is_void then
							l_pos := -1 + 78 -- skip if block
						end
				when 77 then -- if: | _L___4:
						if not a_forceit.to_boolean then
							l_retval := 0
							l_pos := -1 + 140 -- goto fail
						end
				when 78 then -- if done
						l_errmsg := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				when 79 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 80 then -- else:
						l_pos := -1 + 82 -- goto _L___5
				when 81 then -- if done | if block done, skip else block:
						l_pos := -1 + 84
				when 82 then -- else: | _L___5:
						if l_file_readonly.to_boolean then
							if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('W').code)).is_void then
								l_errnum := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E504: "))
								l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (err_readonly.item)))
								l_pos := -1 + 140 -- goto fail
							end
						end
				when 83 then
						l_dirp___0.item := (create {P_OPTION_STATIC}).p_bdir.item.item
						from
						until
							not (not (l_return or l_break) and then ((l_dirp___0.item.item).to_boolean))
						loop
							l_break := False;
							(create {P_MISC2_STATIC}).copy_option_part (l_dirp___0, (create {P_GLOBALS_STATIC}).IObuff.item, 1_025, ce_string (",")).do_nothing
							l_rootname___0 := (create {P_MEMLINE_STATIC}).get_file_in_dir (l_fname, (create {P_GLOBALS_STATIC}).IObuff.item)
							if l_rootname___0.is_void then
								l_backup := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							else
								if (l_buf___6.item.b_p_sn).to_boolean then
									l_tmp___54 := 1
								elseif (l_buf___6.item.b_shortname).to_boolean then
									l_tmp___54 := 1
								else
									l_tmp___54 := 0
								end
								l_backup := buf_modname (l_tmp___54, l_rootname___0, l_backup_ext, 0);
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_rootname___0))
							end
							if not l_backup.is_void then
								if not ((create {P_OPTION_STATIC}).p_bk.item.item).to_boolean then
									if ((create {P_OS_UNIX_STATIC}).mch_getperm (l_backup)) >= 0 then
										l_tmp___55 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_backup))
										l_p___0 := ((l_backup + l_tmp___55.to_integer_32) - 1) - (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_backup_ext))).to_integer_32
										if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_backup.c_pointer.to_integer_32).to_natural_32 then
											l_p___0 := l_backup
										end
										l_p___0.item := (('z').code).to_natural_8
										from
										until
											(l_break)
										loop
											l_break := False
											if (l_p___0.item).to_integer_32 > 97 then
												if not (((create {P_OS_UNIX_STATIC}).mch_getperm (l_backup)) >= 0) then
													l_break := True
												end
											else
												l_break := True
											end
											if not (l_return or l_break or l_continue) then
												l_p___0.item := ((l_p___0.item).to_integer_32 - 1).to_natural_8
											end
										end
										l_break := False
										if (l_p___0.item).to_integer_32 = 97 then
											(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_backup))
											l_backup := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
										end
									end
								end
							end
							if not l_backup.is_void then
								if (vim_rename (l_fname, l_backup)) = 0 then
									l_break := True
								end
								if not (l_return or l_break or l_continue) then
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_backup))
									l_backup := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								end
							end
						end
						l_break := False
						if l_backup.is_void then
							if not a_forceit.to_boolean then
								l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E510: Can%'t make backup file (add ! to override)"))))
								l_pos := -1 + 140 -- goto fail
							end
						end
				when 84 then -- if done | if done | if done | if done
						if a_forceit.to_boolean then
							if l_perm >= 0 then
								if not ((l_perm).bit_and (128)).to_boolean then
									if l_st_old.item.st_uid = (getuid) then
										if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('W').code)).is_void then
											l_perm := (l_perm).bit_or ((128));
											(create {P_OS_UNIX_STATIC}).mch_setperm (l_fname, l_perm).do_nothing
											l_made_writable := 1
										end
									end
								end
							end
						end
						if a_forceit.to_boolean then
							if l_overwriting.to_boolean then
								if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('Z').code)).is_void then
									l_buf___6.item.b_p_ro := 0;
									(create {P_GLOBALS_STATIC}).need_maketitle.item := 1;
									(create {P_SCREEN_STATIC}).status_redraw_all
								end
							end
						end
						if l_end > l_buf___6.item.b_ml.ml_line_count then
							l_end := l_buf___6.item.b_ml.ml_line_count
						end
						if ((l_buf___6.item.b_ml.ml_flags).bit_and (1)).to_boolean then
							l_start___1 := l_end + 1
						end
						if not (a_reset_changed.to_boolean) then
							l_pos := -1 + 91 -- skip if block
						end
				when 85 then -- if:
						if l_newfile.to_boolean then
							l_pos := -1 + 91 -- skip if block
						end
				when 86 then -- if:
						if not (l_overwriting.to_boolean) then
							l_pos := -1 + 91 -- skip if block
						end
				when 87 then -- if:
						if not (((create {P_GLOBALS_STATIC}).exiting.item).to_boolean) then
							l_pos := -1 + 90 -- skip if block
						end
				when 88 then -- if:
						if l_backup.is_void then
							l_pos := -1 + 90 -- goto _L___7
						end
				when 89 then -- if block done, skip else block:
						l_pos := -1 + 91
				when 90 then -- else: | _L___7:
						l_buf___6.item.ml_preserve (0)
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_interr.item)))))
							l_pos := -1 + 114 -- goto restore_backup
						end
				when 91 then -- if done | if done | if done
						l_wfname := l_fname
						if not a_eap.is_void then
							if a_eap.item.force_enc /= 0 then
								l_fenc := a_eap.item.cmd + a_eap.item.force_enc
								l_fenc := (create {P_MBYTE_STATIC}).enc_canonize (l_fenc)
								l_fenc_tofree := l_fenc
							else
								l_fenc := l_buf___6.item.b_p_fenc
							end
						else
							l_fenc := l_buf___6.item.b_p_fenc
						end
						l_converted := need_conversion (l_fenc)
						if not (l_converted.to_boolean) then
							l_pos := -1 + 97 -- skip if block
						end
				when 92 then -- if:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 95 -- skip if block
						end
				when 93 then -- if:
						l_pos := -1 + 96 -- goto _L___8
				when 94 then -- if block done, skip else block:
						l_pos := -1 + 97
				when 95 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_enc.item.item), ce_string ("latin1"))) /= 0 then
							l_pos := -1 + 97 -- skip if block
						end
				when 96 then -- if: | _L___8:
						l_wb_flags := get_fio_flags (l_fenc)
						if ((l_wb_flags).bit_and (30)).to_boolean then
							if ((l_wb_flags).bit_and (22)).to_boolean then
								l_write_info.item.bw_conv_buflen := l_bufsize * 2
							else
								l_write_info.item.bw_conv_buflen := l_bufsize * 4
							end
							l_write_info.item.bw_conv_buf := (create {P_MISC2_STATIC}).lalloc ((l_write_info.item.bw_conv_buflen).to_natural_32, 1)
							if (l_write_info.item.bw_conv_buf).is_void then
								l_end := (0).to_integer_32
							end
						end
				when 97 then -- if done | if done
						if l_converted.to_boolean then
							if l_wb_flags = 0 then
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_tmp___66 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("utf-8"))
								else
									l_tmp___66 := (create {P_OPTION_STATIC}).p_enc.item.item
								end
								l_write_info.item.bw_iconv_fd := ((create {P_MBYTE_STATIC}).my_iconv_open (l_fenc, l_tmp___66))
								if ((l_write_info.item.bw_iconv_fd).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
									l_write_info.item.bw_conv_buflen := l_bufsize * 8
									l_write_info.item.bw_conv_buf := (create {P_MISC2_STATIC}).lalloc ((l_write_info.item.bw_conv_buflen).to_natural_32, 1)
									if (l_write_info.item.bw_conv_buf).is_void then
										l_end := (0).to_integer_32
									end
									l_write_info.item.bw_first := 1
								elseif ((create {P_OPTION_STATIC}).p_ccv.item.item.item).to_integer_32 /= 0 then
									l_wfname := vim_tempname (('w').code)
									if l_wfname.is_void then
										l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E214: Can%'t find temp file for writing"))))
										l_pos := -1 + 114 -- goto restore_backup
									end
								end
							end
						end
				when 98 then
						if not (l_converted.to_boolean) then
							l_pos := -1 + 104 -- skip if block
						end
				when 99 then -- if:
						if l_wb_flags /= 0 then
							l_pos := -1 + 104 -- skip if block
						end
				when 100 then -- if:
						if ((l_write_info.item.bw_iconv_fd).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 104 -- skip if block
						end
				when 101 then -- if:
						if not (l_wfname.is_equal (l_fname)) then
							l_pos := -1 + 104 -- skip if block
						end
				when 102 then -- if:
						if not a_forceit.to_boolean then
							l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E213: Cannot convert (add ! to write without conversion)"))))
							l_pos := -1 + 114 -- goto restore_backup
						end
				when 103 then
						l_notconverted := 1
				when 104 then -- if done | if done | if done | if done
						if (l_break) then
							l_pos := -1 + 116 -- skip loop
						end
				when 105 then -- loop body:
						l_break := False
						l_continue := False
						if l_perm < 0 then
							l_tmp___79 := 438
						else
							l_tmp___79 := (l_perm).bit_and (511)
						end
						if a_append.to_boolean then
							if a_forceit.to_boolean then
								l_tmp___80 := 1_088
							else
								l_tmp___80 := 1_024
							end
							l_tmp___81 := l_tmp___80
						else
							l_tmp___81 := 576
						end
						l_fd := open ([create {CE_INTEGER_8_POINTER}.make_cast (l_wfname), (1).bit_or (l_tmp___81), l_tmp___79])
						if not (l_fd < 0) then
							l_break := True
						end
						if not (not (l_return or l_break or l_continue) and then (l_errmsg.is_void)) then
							l_pos := -1 + 113 -- skip if block
						end
				when 106 then -- if:
						if l_newfile.to_boolean then
							l_pos := -1 + 109 -- skip if block
						end
				when 107 then -- if:
						if l_st_old.item.st_nlink > {NATURAL_32} 1 then
							l_tmp___70 := gettext (ce_string ("E166: Can%'t open linked file for writing"))
							l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___70)
						else
							l_pos := -1 + 109 -- goto _L___10
						end
				when 108 then -- if block done, skip else block:
						l_pos := -1 + 113
				when 109 then -- else: | _L___10:
						if (lstat (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), l_st___0)) /= 0 then
							l_pos := -1 + 112 -- skip if block
						end
				when 110 then -- if:
						if l_st___0.item.st_dev /= l_st_old.item.st_dev then
							l_tmp___70 := gettext (ce_string ("E166: Can%'t open linked file for writing"))
							l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___70)
						elseif l_st___0.item.st_ino /= l_st_old.item.st_ino then
							l_tmp___70 := gettext (ce_string ("E166: Can%'t open linked file for writing"))
							l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___70)
						else
							l_pos := -1 + 112 -- goto _L___9
						end
				when 111 then -- if block done, skip else block:
						l_pos := -1 + 113
				when 112 then -- else: | _L___9:
						l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E212: Can%'t open file for writing"))))
						if a_forceit.to_boolean then
							if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('W').code)).is_void then
								if l_perm >= 0 then
									if not ((l_perm).bit_and (128)).to_boolean then
										l_made_writable := 1
									end
									l_perm := (l_perm).bit_or ((128))
									if l_st_old.item.st_uid /= (getuid) then
										l_perm := (l_perm).bit_and ((511))
									elseif l_st_old.item.st_gid /= (getgid) then
										l_perm := (l_perm).bit_and ((511))
									end
									if not a_append.to_boolean then
										unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_wfname)).do_nothing
									end
									l_continue := True
								end
							end
						end
				when 113 then -- if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 115 -- skip if block
						end
				when 114 then -- if: | restore_backup:
						if not l_backup.is_void then
							if l_wfname.is_equal (l_fname) then
								if l_backup_copy.to_boolean then
									if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), l_st___1)) < 0 then
										vim_rename (l_backup, l_fname).do_nothing
									end
									if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), l_st___1)) >= 0 then
										unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_backup)).do_nothing
									end
								else
									vim_rename (l_backup, l_fname).do_nothing
								end
							end
						end
						if not l_newfile.to_boolean then
							if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), l_st___1)) < 0 then
								l_end := (0).to_integer_32
							end
						end
						if not l_wfname.is_equal (l_fname) then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_wfname))
						end
						l_pos := -1 + 140 -- goto fail
				when 115 then
						l_pos := -1 + 104 -- back to loop condition
				when 116 then -- loop done
						l_break := False
						l_continue := False
						l_errmsg := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_write_info.item.bw_fd := l_fd
						if ((l_buf___6.item.b_p_key).item).to_integer_32 /= 0 then
							if not a_filtering.to_boolean then
								l_header := l_buf___6.item.prepare_crypt_write (l_header_len)
								if l_header.is_void then
									l_end := (0).to_integer_32
								else
									l_write_info.item.bw_buf := l_header
									l_write_info.item.bw_len := l_header_len.item
									l_write_info.item.bw_flags := 8_192
									if (l_write_info.item.buf_write_bytes) = 0 then
										l_end := (0).to_integer_32
									end
									l_wb_flags := (l_wb_flags).bit_or ((4_096));
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_header))
								end
							end
						end
						l_write_info.item.bw_buf := l_buffer
						l_nchars := 0
						if not a_eap.is_void then
							if a_eap.item.force_bin /= 0 then
								l_write_bin := (a_eap.item.force_bin = 1).to_integer
							else
								l_write_bin := l_buf___6.item.b_p_bin
							end
						else
							l_write_bin := l_buf___6.item.b_p_bin
						end
						if not ((l_buf___6.item.b_p_bomb).to_boolean) then
							l_pos := -1 + 123 -- skip if block
						end
				when 117 then -- if:
						if l_write_bin.to_boolean then
							l_pos := -1 + 123 -- skip if block
						end
				when 118 then -- if:
						if a_append.to_boolean then
							l_pos := -1 + 121 -- skip if block
						end
				when 119 then -- if:
						l_pos := -1 + 122 -- goto _L___11
				when 120 then -- if block done, skip else block:
						l_pos := -1 + 123
				when 121 then -- else:
						if not (l_perm < 0) then
							l_pos := -1 + 123 -- skip if block
						end
				when 122 then -- if: | _L___11:
						l_write_info.item.bw_len := make_bom (l_buffer, l_fenc)
						if l_write_info.item.bw_len > 0 then
							l_write_info.item.bw_flags := (8_192).bit_or (l_wb_flags)
							if (l_write_info.item.buf_write_bytes) = 0 then
								l_end := (0).to_integer_32
							else
								l_nchars := l_nchars + (l_write_info.item.bw_len).to_integer_32
							end
						end
				when 123 then -- if done | if done | if done
						l_write_info.item.bw_start_lnum := l_start___1
						if (l_buf___6.item.b_p_udf).to_boolean then
							if l_overwriting.to_boolean then
								if not a_append.to_boolean then
									if not a_filtering.to_boolean then
										if a_reset_changed.to_boolean then
											l_tmp___84 := 1
										else
											l_tmp___84 := 0
										end
									else
										l_tmp___84 := 0
									end
								else
									l_tmp___84 := 0
								end
							else
								l_tmp___84 := 0
							end
						else
							l_tmp___84 := 0
						end
						l_write_undo_file := l_tmp___84
						if l_write_undo_file.to_boolean then
							l_sha_ctx.item.sha256_start
						end
						l_write_info.item.bw_len := l_bufsize
						l_write_info.item.bw_flags := l_wb_flags
						l_fileformat := (create {P_MISC2_STATIC}).get_fileformat_force (l_buf___6, a_eap)
						l_s := l_buffer
						l_len := 0
						l_lnum := l_start___1
						from
						until
							not (not (l_return or l_break) and then (l_lnum <= l_end))
						loop
							l_break := False
							l_ptr := (l_buf___6.item.ml_get_buf (l_lnum, 0)) - 1
							if l_write_undo_file.to_boolean then
								(create {P_SHA256_STATIC}).sha256_update (l_sha_ctx, l_ptr + 1, (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_ptr + 1)))) + {NATURAL_32} 1)
							end
							from
							until
								(l_break)
							loop
								l_break := False
								l_continue := False
								l_ptr := l_ptr + 1
								l_c := l_ptr.item
								if l_c.to_integer_32 = 0 then
									l_break := True
								end
								if not (l_return or l_break or l_continue) then
									if l_c.to_integer_32 = 10 then
										l_s.item := (('%/0/').code).to_natural_8
									elseif l_c.to_integer_32 = 13 then
										if l_fileformat = 2 then
											l_s.item := (('%N').code).to_natural_8
										else
											l_s.item := l_c
										end
									else
										l_s.item := l_c
									end
									l_s := l_s + 1
									l_len := l_len + 1
									if l_len /= l_bufsize then
										l_continue := True
									end
								end
								if not (l_return or l_break or l_continue) then
									if (l_write_info.item.buf_write_bytes) = 0 then
										l_end := (0).to_integer_32
										l_break := True
									end
								end
								if not (l_return or l_break or l_continue) then
									l_nchars := l_nchars + l_bufsize.to_integer_32
									l_s := l_buffer
									l_len := 0
									l_write_info.item.bw_start_lnum := l_lnum
								end
							end
							l_break := False
							l_continue := False
							if l_end = 0 then
								l_lnum := l_lnum + 1
								l_no_eol := 1
								l_break := True
							elseif l_lnum = l_end then
								if l_write_bin.to_boolean then
									if l_lnum = (create {P_GLOBALS_STATIC}).write_no_eol_lnum.item then
										l_lnum := l_lnum + 1
										l_no_eol := 1
										l_break := True
									elseif l_lnum = l_buf___6.item.b_ml.ml_line_count then
										if not (l_buf___6.item.b_p_eol).to_boolean then
											l_lnum := l_lnum + 1
											l_no_eol := 1
											l_break := True
										end
									end
								end
							end
							if not (l_return or l_break or l_continue) then
								if l_fileformat = 0 then
									l_tmp___88 := l_s
									l_s := l_s + 1
									l_tmp___88.item := (('%N').code).to_natural_8
								else
									l_tmp___89 := l_s
									l_s := l_s + 1
									l_tmp___89.item := (('%R').code).to_natural_8
									if l_fileformat = 1 then
										l_len := l_len + 1
										if l_len = l_bufsize then
											if (l_write_info.item.buf_write_bytes) = 0 then
												l_end := (0).to_integer_32
												l_break := True
											end
											if not (l_return or l_break or l_continue) then
												l_nchars := l_nchars + l_bufsize.to_integer_32
												l_s := l_buffer
												l_len := 0
											end
										end
										if not (l_return or l_break or l_continue) then
											l_tmp___91 := l_s
											l_s := l_s + 1
											l_tmp___91.item := (('%N').code).to_natural_8
										end
									end
								end
							end
							if not (l_return or l_break or l_continue) then
								l_len := l_len + 1
								if l_len = l_bufsize then
									if l_end.to_boolean then
										if (l_write_info.item.buf_write_bytes) = 0 then
											l_end := (0).to_integer_32
											l_break := True
										end
										if not (l_return or l_break or l_continue) then
											l_nchars := l_nchars + l_bufsize.to_integer_32
											l_s := l_buffer
											l_len := 0;
											(create {P_UI_STATIC}).ui_breakcheck
											if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
												l_end := (0).to_integer_32
												l_break := True
											end
										end
									end
								end
							end
							if not (l_return or l_break or l_continue) then
								l_lnum := l_lnum + 1
							end
						end
						l_break := False
						if l_len > 0 then
							if l_end > 0 then
								l_write_info.item.bw_len := l_len
								if (l_write_info.item.buf_write_bytes) = 0 then
									l_end := (0).to_integer_32
								end
								l_nchars := l_nchars + l_len.to_integer_32
							end
						end
						if ((create {P_OPTION_STATIC}).p_fs.item.item).to_boolean then
							if (fsync (l_fd)) /= 0 then
								if not l_device.to_boolean then
									l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E667: Fsync failed"))))
									l_end := (0).to_integer_32
								end
							end
						end
						if l_backup.is_void then
							l_pos := -1 + 137 -- skip if block
						end
				when 124 then -- if:
						if l_backup_copy.to_boolean then
							l_pos := -1 + 135 -- skip if block
						end
				when 125 then -- if:
						if not ((stat (create {CE_INTEGER_8_POINTER}.make_cast (l_wfname), l_st___2)) < 0) then
							l_pos := -1 + 128 -- skip if block
						end
				when 126 then -- if:
						l_pos := -1 + 132 -- goto _L___12
				when 127 then -- if block done, skip else block:
						l_pos := -1 + 133
				when 128 then -- else:
						if l_st___2.item.st_uid = l_st_old.item.st_uid then
							l_pos := -1 + 131 -- skip if block
						end
				when 129 then -- if:
						l_pos := -1 + 132 -- goto _L___12
				when 130 then -- if block done, skip else block:
						l_pos := -1 + 133
				when 131 then -- else:
						if l_st___2.item.st_gid = l_st_old.item.st_gid then
							l_pos := -1 + 133 -- skip if block
						end
				when 132 then -- if: | _L___12:;
						(create {P_GLOBALS_STATIC}).ignored.item := fchown (l_fd, l_st_old.item.st_uid, l_st_old.item.st_gid)
						if l_perm >= 0 then
							(create {P_OS_UNIX_STATIC}).mch_setperm (l_wfname, l_perm).do_nothing
						end
				when 133 then -- if done | if done
						l_buf___6.item.buf_setino
				when 134 then -- if block done, skip else block:
						l_pos := -1 + 136
				when 135 then -- else:
						l_pos := -1 + 137 -- goto _L___13
				when 136 then -- if done | if block done, skip else block:
						l_pos := -1 + 138
				when 137 then -- else: | _L___13:
						if not (l_buf___6.item.b_dev_valid).to_boolean then
							l_buf___6.item.buf_setino
						end
				when 138 then
						if (close (l_fd)) /= 0 then
							l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E512: Close failed"))))
							l_end := (0).to_integer_32
						end
						if l_made_writable.to_boolean then
							l_perm := (l_perm).bit_and ((-129))
						end
						if l_perm >= 0 then
							(create {P_OS_UNIX_STATIC}).mch_setperm (l_wfname, l_perm).do_nothing
						end
						if not l_backup_copy.to_boolean then
							(create {P_OS_UNIX_STATIC}).mch_set_acl (l_wfname, l_acl)
						end
						if ((l_wb_flags).bit_and (4_096)).to_boolean then
							(create {P_MISC2_STATIC}).crypt_pop_state
						end
						if not l_wfname.is_equal (l_fname) then
							if l_end /= 0 then
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_tmp___99 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("utf-8"))
								else
									l_tmp___99 := (create {P_OPTION_STATIC}).p_enc.item.item
								end
								if ((create {P_EVAL_STATIC}).eval_charconvert (l_tmp___99, l_fenc, l_wfname, l_fname)) = 0 then
									l_write_info.item.bw_conv_error := 1
									l_end := (0).to_integer_32
								end
							end
							unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_wfname)).do_nothing;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_wfname))
						end
						if l_end = 0 then
							if l_errmsg.is_void then
								if (l_write_info.item.bw_conv_error).to_boolean then
									if l_write_info.item.bw_conv_error_lnum = 0 then
										l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E513: write error, conversion failed (make %'fenc%' empty to override)"))))
									else
										l_errmsg_allocated := 1
										l_errmsg := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 300);
										(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_errmsg), (300).to_natural_32, (gettext (ce_string ("E513: write error, conversion failed in line %%ld (make %'fenc%' empty to override)"))), l_write_info.item.bw_conv_error_lnum]).do_nothing
									end
								elseif ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
									l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_interr.item)))))
								else
									l_errmsg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E514: write error (file system full?)"))))
								end
							end
							if not l_backup.is_void then
								if l_backup_copy.to_boolean then
									if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
										(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_interr.item)))))).do_nothing;
										(create {P_TERM_STATIC}).out_flush
									end
									l_fd := open ([create {CE_INTEGER_8_POINTER}.make_cast (l_backup), 0, 0])
									if l_fd >= 0 then
										l_write_info.item.bw_fd := open ([create {CE_INTEGER_8_POINTER}.make_cast (l_fname), 577, (l_perm).bit_and (511)])
										if l_write_info.item.bw_fd >= 0 then
											l_write_info.item.bw_buf := l_smallbuf
											l_write_info.item.bw_flags := 8_192
											from
											until
												(l_break)
											loop
												l_break := False
												l_write_info.item.bw_len := read (l_fd, create {CE_VOID_POINTER}.make_cast (l_smallbuf), (256).to_natural_32)
												if not (l_write_info.item.bw_len > 0) then
													l_break := True
												end
												if not (l_return or l_break or l_continue) then
													if (l_write_info.item.buf_write_bytes) = 0 then
														l_break := True
													end
												end
											end
											l_break := False
											if (close (l_write_info.item.bw_fd)) >= 0 then
												if l_write_info.item.bw_len = 0 then
													l_end := (1).to_integer_32
												end
											end
										end
										close (l_fd).do_nothing
									end
								elseif (vim_rename (l_backup, l_fname)) = 0 then
									l_end := (1).to_integer_32
								end
							end
							l_pos := -1 + 140 -- goto fail
						end
				when 139 then
						l_lnum := l_lnum - l_start___1;
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1
						if not a_filtering.to_boolean then
							msg_add_fname (l_buf___6, l_fname)
							l_c := (0).to_natural_8
							if (l_write_info.item.bw_conv_error).to_boolean then
								strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string (" CONVERSION ERROR")))).do_nothing
								l_c := (1).to_natural_8
								if l_write_info.item.bw_conv_error_lnum /= 0 then
									(create {P_MESSAGE_STATIC}).vim_snprintf_add ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, (gettext (ce_string (" in line %%ld;"))), l_write_info.item.bw_conv_error_lnum]).do_nothing
								end
							elseif l_notconverted.to_boolean then
								strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("[NOT converted]")))).do_nothing
								l_c := (1).to_natural_8
							elseif l_converted.to_boolean then
								strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("[converted]")))).do_nothing
								l_c := (1).to_natural_8
							end
							if l_device.to_boolean then
								strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("[Device]")))).do_nothing
								l_c := (1).to_natural_8
							elseif l_newfile.to_boolean then
								if ((create {P_OPTION_STATIC}).shortmess (('n').code)).to_boolean then
									l_tmp___117 := (gettext (ce_string ("[New]")))
								else
									l_tmp___117 := (gettext (ce_string ("[New File]")))
								end
								strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), l_tmp___117).do_nothing
								l_c := (1).to_natural_8
							end
							if l_no_eol.to_boolean then
								msg_add_eol
								l_c := (1).to_natural_8
							end
							if (msg_add_fileformat (l_fileformat)).to_boolean then
								l_c := (1).to_natural_8
							end
							if ((l_wb_flags).bit_and (4_096)).to_boolean then
								strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("[crypted]")))).do_nothing
								l_c := (1).to_natural_8
							end
							msg_add_lines (l_c.to_integer_32, l_lnum, l_nchars)
							if not ((create {P_OPTION_STATIC}).shortmess (('W').code)).to_boolean then
								if a_append.to_boolean then
									if ((create {P_OPTION_STATIC}).shortmess (('w').code)).to_boolean then
										l_tmp___124 := (gettext (ce_string (" [a]")))
									else
										l_tmp___124 := (gettext (ce_string (" appended")))
									end
									strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), l_tmp___124).do_nothing
								else
									if ((create {P_OPTION_STATIC}).shortmess (('w').code)).to_boolean then
										l_tmp___129 := (gettext (ce_string (" [w]")))
									else
										l_tmp___129 := (gettext (ce_string (" written")))
									end
									strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), l_tmp___129).do_nothing
								end
							end
							(create {P_MESSAGE_STATIC}).set_keep_msg (((create {P_MESSAGE_STATIC}).msg_trunc_attr ((create {P_GLOBALS_STATIC}).IObuff.item, 0, 0)), 0)
						end
						if a_reset_changed.to_boolean then
							if l_whole.to_boolean then
								if not a_append.to_boolean then
									if not (l_write_info.item.bw_conv_error).to_boolean then
										if l_overwriting.to_boolean then
											l_buf___6.item.unchanged (1)
											l_buf___6.item.u_unchanged
											l_buf___6.item.u_update_save_nr
										elseif not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('+').code)).is_void then
											l_buf___6.item.unchanged (1)
											l_buf___6.item.u_unchanged
											l_buf___6.item.u_update_save_nr
										end
									end
								end
							end
						end
						if l_overwriting.to_boolean then
							l_buf___6.item.ml_timestamp
							if a_append.to_boolean then
								l_buf___6.item.b_flags := (l_buf___6.item.b_flags).bit_and ((-17))
							else
								l_buf___6.item.b_flags := (l_buf___6.item.b_flags).bit_and ((-89))
							end
						end
						if ((create {P_OPTION_STATIC}).p_pm.item.item.item).to_boolean then
							if l_dobackup.to_boolean then
								if (l_buf___6.item.b_p_sn).to_boolean then
									l_tmp___134 := 1
								elseif (l_buf___6.item.b_shortname).to_boolean then
									l_tmp___134 := 1
								else
									l_tmp___134 := 0
								end
								l_org := create {CE_INTEGER_8_POINTER}.make_cast ((buf_modname (l_tmp___134, l_fname, (create {P_OPTION_STATIC}).p_pm.item.item, 0)))
								if not l_backup.is_void then
									if l_org.is_void then
										(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E205: Patchmode: can%'t save original file"))))).do_nothing
									elseif (stat (l_org, l_st___3)) < 0 then
										vim_rename (l_backup, create {CE_NATURAL_8_POINTER}.make_cast (l_org)).do_nothing;
										(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_backup))
										l_backup := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
										set_file_time (create {CE_NATURAL_8_POINTER}.make_cast (l_org), l_st_old.item.st_atim.tv_sec, l_st_old.item.st_mtim.tv_sec)
									end
								elseif l_org.is_void then
									l_tmp___138 := gettext (ce_string ("E206: patchmode: can%'t touch empty original file"));
									(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___138)).do_nothing
								else
									if l_perm < 0 then
										l_tmp___139 := 438
									else
										l_tmp___139 := (l_perm).bit_and (511)
									end
									l_empty_fd := open ([l_org, 131_264, l_tmp___139])
									if l_empty_fd < 0 then
										l_tmp___138 := gettext (ce_string ("E206: patchmode: can%'t touch empty original file"));
										(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___138)).do_nothing
									else
										close (l_empty_fd).do_nothing
									end
								end
								if not l_org.is_void then
									(create {P_OS_UNIX_STATIC}).mch_setperm (create {CE_NATURAL_8_POINTER}.make_cast (l_org), (((create {P_OS_UNIX_STATIC}).mch_getperm (l_fname))).bit_and (511)).do_nothing;
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_org))
								end
							end
						end
						if not ((create {P_OPTION_STATIC}).p_bk.item.item).to_boolean then
							if not l_backup.is_void then
								if (unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_backup))) /= 0 then
									(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E207: Can%'t delete backup file"))))).do_nothing
								end
							end
						end
						l_pos := -1 + 141 -- goto nofail
				when 140 then -- fail:;
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1
				when 141 then -- nofail:
						l_buf___6.item.b_saving := 0;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_backup))
						if not l_buffer.is_equal (l_smallbuf) then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buffer))
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fenc_tofree));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_write_info.item.bw_conv_buf))
						if ((l_write_info.item.bw_iconv_fd).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
							iconv_close (l_write_info.item.bw_iconv_fd).do_nothing
							l_write_info.item.bw_iconv_fd := create {CE_VOID_POINTER}.make_shared (default_pointer + -1)
						end
						(create {P_OS_UNIX_STATIC}).mch_free_acl (l_acl)
						if not l_errmsg.is_void then
							if not l_errnum.is_void then
								l_tmp___144 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_errnum))).to_integer_32
							else
								l_tmp___144 := 0
							end
							l_numlen := l_tmp___144
							l_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[3]
							msg_add_fname (l_buf___6, l_fname)
							l_tmp___146 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item))
							if (l_tmp___146 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_errmsg)))) + l_numlen.to_natural_32 >= {NATURAL_32} 1_025 then
								(create {P_GLOBALS_STATIC}).IObuff.item[((({NATURAL_32} 1_025 - (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_errmsg)))) - l_numlen.to_natural_32) - {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_natural_8
							end
							if not l_errnum.is_void then
								memmove (create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).IObuff.item + l_numlen)), create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item))) + {NATURAL_32} 1).do_nothing
								memmove (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), create {CE_VOID_POINTER}.make_cast (l_errnum), l_numlen.to_natural_32).do_nothing
							end
							strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), create {CE_INTEGER_8_POINTER}.make_cast (l_errmsg)).do_nothing;
							(create {P_MESSAGE_STATIC}).emsg ((create {P_GLOBALS_STATIC}).IObuff.item).do_nothing
							if l_errmsg_allocated.to_boolean then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_errmsg))
							end
							l_retval := 0
							if l_end = 0 then
								(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%NWARNING: Original file may be lost or damaged%N")))), (l_attr).bit_or (4_096));
								(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("don%'t quit the editor until the file is successfully written!")))), (l_attr).bit_or (4_096))
								if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), l_st_old)) >= 0 then
									l_buf___6.item.buf_store_time (l_st_old, l_fname)
									l_buf___6.item.b_mtime_read := l_buf___6.item.b_mtime
								end
							end
						end
						(create {P_GLOBALS_STATIC}).msg_scroll.item := l_msg_save
						if l_retval = 1 then
							if l_write_undo_file.to_boolean then
								l_sha_ctx.item.sha256_finish (create {CE_NATURAL_8_POINTER}.make_cast (l_hash));
								(create {P_UNDO_STATIC}).u_write_undo (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, l_buf___6, l_hash)
							end
						end
						if not ((create {P_EX_EVAL_STATIC}).should_abort (l_retval)).to_boolean then
							(create {P_GLOBALS_STATIC}).write_no_eol_lnum.item := (0).to_integer_32
							l_aco___0.item.aucmd_prepbuf (l_buf___6)
							if a_append.to_boolean then
								apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEAPPENDPOST, l_fname, l_fname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
							elseif a_filtering.to_boolean then
								apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILTERWRITEPOST, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_fname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
							elseif a_reset_changed.to_boolean then
								if l_whole.to_boolean then
									apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_BUFWRITEPOST, l_fname, l_fname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
								else
									apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEWRITEPOST, l_fname, l_fname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
								end
							else
								apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEWRITEPOST, l_fname, l_fname, 0, (create {P_GLOBALS_STATIC}).curbuf.item, a_eap).do_nothing
							end
							l_aco___0.item.aucmd_restbuf
							if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
								l_retval := 0
							end
						end
						(create {P_GLOBALS_STATIC}).got_int.item := ((create {P_GLOBALS_STATIC}).got_int.item).bit_or (l_prev_got_int)
						Result := l_retval
				when 142 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_rw_fname (a_fname, a_sfname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_return: BOOLEAN
		do
			l_buf___6 := (create {P_GLOBALS_STATIC}).curbuf.item
			if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bl).to_boolean then
				apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFDELETE, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
			end
			apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFWIPEOUT, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
			if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return and then (not ((create {P_GLOBALS_STATIC}).curbuf.item).is_equal (l_buf___6)) then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (e_auchangedbuf.item)))).do_nothing
				Result := 0
				l_return := True
			end
			if not l_return then
				if ((create {P_BUFFER_STATIC}).setfname ((create {P_GLOBALS_STATIC}).curbuf.item, a_fname, a_sfname, 0)) = 1 then
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags).bit_or ((8))
				end
				apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFNEW, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
				if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bl).to_boolean then
					apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFADD, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
				end
				if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ft).item).to_integer_32 = 0 then
					if (au_has_group (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("filetypedetect")))).to_boolean then
						do_doautocmd (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("filetypedetect BufRead")), 0).do_nothing
					end
					(create {P_BUFFER_STATIC}).do_modelines (0)
				end
				Result := 1
			end
		end

	msg_add_fname (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_fname: CE_POINTER [NATURAL_8])
		local
			l_fname: CE_POINTER [NATURAL_8]
		do
			l_fname := a_fname
			if l_fname.is_void then
				l_fname := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-stdin-"))
			end
			(create {P_MISC1_STATIC}).home_replace (a_buf___6, l_fname, (create {P_GLOBALS_STATIC}).IObuff.item + 1, 1_021, 1);
			(create {P_GLOBALS_STATIC}).IObuff.item[0] := (('%"').code).to_natural_8
			strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), ce_string ("%" ")).do_nothing
		end

	msg_add_fileformat (a_eol_type: INTEGER_32): INTEGER_32
		local
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			if a_eol_type = 1 then
				if ((create {P_OPTION_STATIC}).shortmess (('x').code)).to_boolean then
					l_tmp___2 := (gettext (ce_string ("[dos]")))
				else
					l_tmp___2 := (gettext (ce_string ("[dos format]")))
				end
				strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), l_tmp___2).do_nothing
				Result := 1
				l_return := True
			end
			if not l_return and then (a_eol_type = 2) then
				if ((create {P_OPTION_STATIC}).shortmess (('x').code)).to_boolean then
					l_tmp___7 := (gettext (ce_string ("[mac]")))
				else
					l_tmp___7 := (gettext (ce_string ("[mac format]")))
				end
				strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), l_tmp___7).do_nothing
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	msg_add_lines (a_insert_space: INTEGER_32; a_lnum, a_nchars: INTEGER_32)
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
		do
			l_p___0 := (create {P_GLOBALS_STATIC}).IObuff.item + (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item))).to_integer_32
			if a_insert_space.to_boolean then
				l_tmp___0 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___0.item := ((' ').code).to_natural_8
			end
			if ((create {P_OPTION_STATIC}).shortmess (('l').code)).to_boolean then
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("%%ldL, %%ldC"), a_lnum, a_nchars]).do_nothing
			else
				if a_lnum = 1 then
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), (gettext (ce_string ("1 line, ")))).do_nothing
				else
					sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), (gettext (ce_string ("%%ld lines, "))), a_lnum]).do_nothing
				end
				l_p___0 := l_p___0 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32
				if a_nchars = 1 then
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), (gettext (ce_string ("1 character")))).do_nothing
				else
					sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), (gettext (ce_string ("%%ld characters"))), a_nchars]).do_nothing
				end
			end
		end

	msg_add_eol
		local
			l_tmp___2: CE_POINTER [INTEGER_8]
		do
			if ((create {P_OPTION_STATIC}).shortmess (('i').code)).to_boolean then
				l_tmp___2 := (gettext (ce_string ("[noeol]")))
			else
				l_tmp___2 := (gettext (ce_string ("[Incomplete last line]")))
			end
			strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), l_tmp___2).do_nothing
		end

	ucs2bytes (a_c: NATURAL_32; a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_flags___0: INTEGER_32): INTEGER_32
		require
			not a_pp.is_void
		local
			l_c: NATURAL_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_error: INTEGER_32
			l_cc___0: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_tmp___15: CE_POINTER [NATURAL_8]
			l_tmp___16: CE_POINTER [NATURAL_8]
		do
			l_c := a_c
			l_p___0 := a_pp.item
			l_error := 0
			if ((a_flags___0).bit_and (8)).to_boolean then
				if ((a_flags___0).bit_and (128)).to_boolean then
					l_tmp := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp.item := l_c.to_natural_8
					l_tmp___0 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___0.item := ((l_c).bit_shift_right (8)).to_natural_8
					l_tmp___1 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___1.item := ((l_c).bit_shift_right (16)).to_natural_8
					l_tmp___2 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___2.item := ((l_c).bit_shift_right (24)).to_natural_8
				else
					l_tmp___3 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___3.item := ((l_c).bit_shift_right (24)).to_natural_8
					l_tmp___4 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___4.item := ((l_c).bit_shift_right (16)).to_natural_8
					l_tmp___5 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___5.item := ((l_c).bit_shift_right (8)).to_natural_8
					l_tmp___6 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___6.item := l_c.to_natural_8
				end
			elseif ((a_flags___0).bit_and (20)).to_boolean then
				if l_c >= {NATURAL_32} 65_536 then
					if ((a_flags___0).bit_and (16)).to_boolean then
						l_c := l_c - ({NATURAL_32} 65_536)
						if l_c >= {NATURAL_32} 1_048_576 then
							l_error := 1
						end
						l_cc___0 := (((((l_c).bit_shift_right (10))).bit_and ({NATURAL_32} 1_023)) + {NATURAL_32} 55_296).to_integer_32
						if ((a_flags___0).bit_and (128)).to_boolean then
							l_tmp___7 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___7.item := l_cc___0.to_natural_8
							l_tmp___8 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___8.item := ((l_cc___0.to_natural_32).bit_shift_right (8)).to_natural_8
						else
							l_tmp___9 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___9.item := ((l_cc___0.to_natural_32).bit_shift_right (8)).to_natural_8
							l_tmp___10 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___10.item := l_cc___0.to_natural_8
						end
						l_c := ((l_c).bit_and ({NATURAL_32} 1_023)) + {NATURAL_32} 56_320
					else
						l_error := 1
					end
				end
				if ((a_flags___0).bit_and (128)).to_boolean then
					l_tmp___11 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___11.item := l_c.to_natural_8
					l_tmp___12 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___12.item := ((l_c).bit_shift_right (8)).to_natural_8
				else
					l_tmp___13 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___13.item := ((l_c).bit_shift_right (8)).to_natural_8
					l_tmp___14 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___14.item := l_c.to_natural_8
				end
			elseif l_c >= {NATURAL_32} 256 then
				l_error := 1
				l_tmp___15 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___15.item := (191).to_natural_8
			else
				l_tmp___16 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___16.item := l_c.to_natural_8
			end
			a_pp.item := l_p___0
			Result := l_error
		end

	need_conversion (a_fenc: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_fenc.is_void
		local
			l_same_encoding: INTEGER_32
			l_enc_flags: INTEGER_32
			l_fenc_flags: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			if (a_fenc.item).to_integer_32 = 0 then
				l_same_encoding := 1
				l_fenc_flags := 0
			elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_enc.item.item), create {CE_INTEGER_8_POINTER}.make_cast (a_fenc))) = 0 then
				l_same_encoding := 1
				l_fenc_flags := 0
			else
				l_enc_flags := get_fio_flags ((create {P_OPTION_STATIC}).p_enc.item.item)
				l_fenc_flags := get_fio_flags (a_fenc)
				if l_enc_flags /= 0 then
					if l_fenc_flags = l_enc_flags then
						l_tmp := 1
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
				l_same_encoding := l_tmp
			end
			if l_same_encoding.to_boolean then
				Result := ((create {P_GLOBALS_STATIC}).enc_unicode.item /= 0).to_integer
				l_return := True
			end
			if not l_return then
				if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
					if l_fenc_flags = 2 then
						l_tmp___1 := 0
					else
						l_tmp___1 := 1
					end
				else
					l_tmp___1 := 1
				end
				Result := l_tmp___1
			end
		end

	get_fio_flags (a_ptr: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_ptr.is_void
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_prop: INTEGER_32
			l_return: BOOLEAN
		do
			l_ptr := a_ptr
			if (l_ptr.item).to_integer_32 = 0 then
				l_ptr := (create {P_OPTION_STATIC}).p_enc.item.item
			end
			l_prop := (create {P_MBYTE_STATIC}).enc_canon_props (l_ptr)
			if ((l_prop).bit_and (4)).to_boolean then
				if ((l_prop).bit_and (64)).to_boolean then
					if ((l_prop).bit_and (32)).to_boolean then
						Result := 132
						l_return := True
					end
					if not l_return then
						Result := 4
						l_return := True
					end
				end
				if not l_return and then (((l_prop).bit_and (128)).to_boolean) then
					if ((l_prop).bit_and (32)).to_boolean then
						Result := 136
						l_return := True
					end
					if not l_return then
						Result := 8
						l_return := True
					end
				end
				if not l_return and then (((l_prop).bit_and (256)).to_boolean) then
					if ((l_prop).bit_and (32)).to_boolean then
						Result := 144
						l_return := True
					end
					if not l_return then
						Result := 16
						l_return := True
					end
				end
				if not l_return then
					Result := 2
					l_return := True
				end
			end
			if not l_return and then (((l_prop).bit_and (512)).to_boolean) then
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	check_for_bom (a_p___0: CE_POINTER [NATURAL_8]; a_size: INTEGER_32; a_lenp: CE_POINTER [INTEGER_32]; a_flags___0: INTEGER_32): CE_POINTER [NATURAL_8]
		require
			not a_p___0.is_void
			not a_lenp.is_void
		local
			l_name___1: CE_POINTER [INTEGER_8]
			l_len: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_name___1 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_len := 2
					if (a_p___0[0]).to_integer_32 /= 239 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_p___0[1]).to_integer_32 = 187 then
							if a_size >= 3 then
								if (a_p___0[2]).to_integer_32 = 191 then
									if a_flags___0 = -1 then
										l_name___1 := ce_string ("utf-8")
										l_len := 3
									elseif a_flags___0 = 2 then
										l_name___1 := ce_string ("utf-8")
										l_len := 3
									elseif a_flags___0 = 0 then
										l_name___1 := ce_string ("utf-8")
										l_len := 3
									else
										l_pos := -1 + 3 -- goto _L___9
									end
								else
									l_pos := -1 + 3 -- goto _L___9
								end
							else
								l_pos := -1 + 3 -- goto _L___9
							end
						else
							l_pos := -1 + 3 -- goto _L___9
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 3 then -- else: | _L___9:
						if (a_p___0[0]).to_integer_32 /= 255 then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if (a_p___0[1]).to_integer_32 /= 254 then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if not (a_size >= 4) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (a_p___0[2]).to_integer_32 = 0 then
							if (a_p___0[3]).to_integer_32 = 0 then
								if a_flags___0 = -1 then
									l_name___1 := ce_string ("ucs-4le")
									l_len := 4
								elseif a_flags___0 = 136 then
									l_name___1 := ce_string ("ucs-4le")
									l_len := 4
								else
									l_pos := -1 + 8 -- goto _L___1
								end
							else
								l_pos := -1 + 8 -- goto _L___1
							end
						else
							l_pos := -1 + 8 -- goto _L___1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L___1:
						if a_flags___0 = 132 then
							l_name___1 := ce_string ("ucs-2le")
						elseif a_flags___0 = -1 then
							l_name___1 := ce_string ("utf-16le")
						elseif a_flags___0 = 144 then
							l_name___1 := ce_string ("utf-16le")
						end
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___5
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 28
				when 12 then -- else: | _L___5:
						if (a_p___0[0]).to_integer_32 /= 254 then
							l_pos := -1 + 27 -- skip if block
						end
				when 13 then -- if:
						if (a_p___0[1]).to_integer_32 /= 255 then
							l_pos := -1 + 25 -- skip if block
						end
				when 14 then -- if:
						if a_flags___0 /= -1 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 21 -- goto _L___3
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 17 then -- else:
						if a_flags___0 /= 4 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L___3
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 20 then -- else:
						if a_flags___0 /= 16 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if: | _L___3:
						if a_flags___0 = 4 then
							l_name___1 := ce_string ("ucs-2")
						else
							l_name___1 := ce_string ("utf-16")
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 27 -- goto _L___4
				when 24 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_pos := -1 + 27 -- goto _L___4
				when 26 then -- if done | if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else: | _L___4:
						if a_size >= 4 then
							if (a_p___0[0]).to_integer_32 = 0 then
								if (a_p___0[1]).to_integer_32 = 0 then
									if (a_p___0[2]).to_integer_32 = 254 then
										if (a_p___0[3]).to_integer_32 = 255 then
											if a_flags___0 = -1 then
												l_name___1 := ce_string ("ucs-4")
												l_len := 4
											elseif a_flags___0 = 8 then
												l_name___1 := ce_string ("ucs-4")
												l_len := 4
											end
										end
									end
								end
							end
						end
				when 28 then -- if done | if done
					a_lenp.item := l_len
					Result := (create {CE_NATURAL_8_POINTER}.make_cast (l_name___1))
				when 29 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	make_bom (a_buf___6, a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_name___1.is_void
		local
			l_flags___0: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			l_flags___0 := get_fio_flags (a_name___1)
			if l_flags___0 = 1 then
				Result := 0
				l_return := True
			elseif l_flags___0 = 0 then
				Result := 0
				l_return := True
			end
			if not l_return and then (l_flags___0 = 2) then
				a_buf___6[0] := (239).to_natural_8
				a_buf___6[1] := (187).to_natural_8
				a_buf___6[2] := (191).to_natural_8
				Result := 3
				l_return := True
			end
			if not l_return then
				l_p___0.item := a_buf___6
				ucs2bytes ({NATURAL_32} 65_279, l_p___0, l_flags___0).do_nothing
				Result := ((l_p___0.item).distance (a_buf___6))
			end
		end

	shorten_fname1 (a_full_path: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_dirname: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_dirname.make (<<4_096>>)

			l_p___0 := a_full_path
			if ((create {P_OS_UNIX_STATIC}).mch_dirname (l_dirname, 4_096)) = 1 then
				l_p___0 := shorten_fname (a_full_path, l_dirname)
				if l_p___0.is_void then
					l_p___0 := a_full_path
				elseif (l_p___0.item).to_integer_32 = 0 then
					l_p___0 := a_full_path
				end
			end
			Result := l_p___0
		end

	shorten_fname (a_full_path, a_dir_name: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			if a_full_path.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_dir_name))).to_integer_32
				if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (a_dir_name), create {CE_INTEGER_8_POINTER}.make_cast (a_full_path), l_len.to_natural_32)) = 0 then
					l_p___0 := a_full_path + l_len
					if ((create {P_MISC1_STATIC}).vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
						l_p___0 := l_p___0 + 1
					else
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
				else
					l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				end
				Result := l_p___0
			end
		end

	shorten_fnames (a_force: INTEGER_32)
		local
			l_dirname: CE_ARRAY [NATURAL_8]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_p___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_dirname.make (<<4_096>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:;
					(create {P_OS_UNIX_STATIC}).mch_dirname (l_dirname, 4_096).do_nothing
					l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
				when 1 then -- loop condition:
					if l_buf___6.is_void then
						l_pos := -1 + 14 -- skip loop
					end
				when 2 then -- loop body:
						if (l_buf___6.item.b_fname).is_void then
							l_pos := -1 + 13 -- skip if block
						end
				when 3 then -- if:
						if (l_buf___6.item.bt_nofile).to_boolean then
							l_pos := -1 + 13 -- skip if block
						end
				when 4 then -- if:
						if ((create {P_WINDOW_STATIC}).path_with_url (l_buf___6.item.b_fname)).to_boolean then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if not (a_force.to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 8 then -- else:
						if not ((l_buf___6.item.b_sfname).is_void) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not (((create {P_OS_UNIX_STATIC}).mch_isFullName (l_buf___6.item.b_sfname)).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6.item.b_sfname))
						l_buf___6.item.b_sfname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_p___0 := shorten_fname (l_buf___6.item.b_ffname, l_dirname)
						if not l_p___0.is_void then
							l_buf___6.item.b_sfname := (create {P_MISC2_STATIC}).vim_strsave (l_p___0)
							l_buf___6.item.b_fname := l_buf___6.item.b_sfname
						end
						if l_p___0.is_void then
							l_buf___6.item.b_fname := l_buf___6.item.b_ffname
						elseif (l_buf___6.item.b_fname).is_void then
							l_buf___6.item.b_fname := l_buf___6.item.b_ffname
						end
				when 13 then -- if done | if done | if done | if done | if done;
						(create {P_MEMFILE_STATIC}).mf_fullname (l_buf___6.item.b_ml.ml_mfp)
						l_buf___6 := l_buf___6.item.b_next
						l_pos := -1 + 1 -- back to loop condition
				when 14 then -- loop done;
					(create {P_SCREEN_STATIC}).status_redraw_all;
					(create {P_GLOBALS_STATIC}).redraw_tabline.item := 1
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	shorten_filenames (a_fnames: CE_POINTER [CE_POINTER [NATURAL_8]]; a_count___2: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_dirname: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_dirname.make (<<4_096>>)

			if a_fnames.is_void then
				l_return := True
			elseif a_count___2 < 1 then
				l_return := True
			end
			if not l_return then
				(create {P_OS_UNIX_STATIC}).mch_dirname (l_dirname, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32).to_integer_32).do_nothing
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_count___2)
				loop
					l_p___0 := shorten_fname (a_fnames[l_i___0], l_dirname)
					if not l_p___0.is_void then
						l_p___0 := (create {P_MISC2_STATIC}).vim_strsave (l_p___0);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_fnames[l_i___0]))
						a_fnames[l_i___0] := l_p___0
					end
					l_i___0 := l_i___0 + 1
				end
			end
		end

	modname (a_fname, a_ext: CE_POINTER [NATURAL_8]; a_prepend_dot: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_tmp: INTEGER_32
		do
			if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sn).to_boolean then
				l_tmp := 1
			elseif ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_shortname).to_boolean then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := (buf_modname (l_tmp, a_fname, a_ext, a_prepend_dot))
		end

	buf_modname (a_shortname: INTEGER_32; a_fname, a_ext: CE_POINTER [NATURAL_8]; a_prepend_dot: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_prepend_dot: INTEGER_32
			l_retval: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_fnamelen: INTEGER_32
			l_extlen: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_prepend_dot := a_prepend_dot
					l_extlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_ext))).to_integer_32
					if not (a_fname.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (a_fname.item).to_integer_32 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_retval := (create {P_MISC2_STATIC}).alloc (((4_096 + l_extlen) + 3).to_natural_32)
						if l_retval.is_void then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return then
							if ((create {P_OS_UNIX_STATIC}).mch_dirname (l_retval, 4_096)) = 0 then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_retval))
								Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
								l_return := True
							else
								l_fnamelen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_retval))).to_integer_32
								if l_fnamelen = 0 then
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_retval))
									Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
									l_return := True
								end
							end
						end
						if not l_return then
							if not ((create {P_MISC2_STATIC}).after_pathsep (l_retval, l_retval + l_fnamelen)).to_boolean then
								l_tmp___2 := l_fnamelen
								l_fnamelen := l_fnamelen + 1
								l_retval[l_tmp___2] := (('/').code).to_natural_8
								l_retval[l_fnamelen] := (('%/0/').code).to_natural_8
							end
							l_prepend_dot := 0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_fnamelen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_fname))).to_integer_32
						l_retval := (create {P_MISC2_STATIC}).alloc (((l_fnamelen + l_extlen) + 3).to_natural_32)
						if l_retval.is_void then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_retval), create {CE_INTEGER_8_POINTER}.make_cast (a_fname)).do_nothing
						end
				when 7 then -- if done
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 8 then -- if:
						l_ptr := l_retval + l_fnamelen
						from
						until
							not (not (l_break) and then ((l_ptr.c_pointer.to_integer_32).to_natural_32 > (l_retval.c_pointer.to_integer_32).to_natural_32))
						loop
							l_break := False
							if (a_ext.item).to_integer_32 = 46 then
								if a_shortname.to_boolean then
									if (l_ptr.item).to_integer_32 = 46 then
										l_ptr.item := (('_').code).to_natural_8
									end
								end
							end
							if ((create {P_MISC1_STATIC}).vim_ispathsep ((l_ptr.item).to_integer_32)).to_boolean then
								l_ptr := l_ptr + 1
								l_break := True
							end
							if not (l_break) then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___6 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_retval, l_ptr - 1])) + 1
								else
									l_tmp___6 := 1
								end
								l_ptr := l_ptr - l_tmp___6
							end
						end
						l_break := False
						if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr))) > {NATURAL_32} 250 then
							l_ptr[250] := (('%/0/').code).to_natural_8
						end
						l_s := l_ptr + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr))).to_integer_32
						if not (a_shortname.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 9 then -- if:
						if not (a_fname.is_void) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 12 then -- else:
						if (a_fname.item).to_integer_32 /= 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else:
						if not (((create {P_MISC1_STATIC}).vim_ispathsep ((a_fname[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_fname))) - {NATURAL_32} 1).to_integer_32]).to_integer_32)).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if: | _L___0:
						if (a_ext.item).to_integer_32 = 46 then
							l_tmp___10 := l_s
							l_s := l_s + 1
							l_tmp___10.item := (('_').code).to_natural_8
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						if (a_ext.item).to_integer_32 = 46 then
							if (l_s.distance (l_ptr)).to_natural_32 > {NATURAL_32} 8 then
								l_s := l_ptr + 8
								l_s.item := (('%/0/').code).to_natural_8
							end
						else
							l_e := (create {P_MISC2_STATIC}).vim_strchr (l_ptr, ('.').code)
							if l_e.is_void then
								l_tmp___11 := l_s
								l_s := l_s + 1
								l_tmp___11.item := (('.').code).to_natural_8
							elseif (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_e))).to_integer_32 + l_extlen > 4 then
								l_s := (l_e + 4) - l_extlen
							end
						end
				when 19 then -- if done | if done | if done
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_s), create {CE_INTEGER_8_POINTER}.make_cast (a_ext)).do_nothing
						if l_prepend_dot.to_boolean then
							if not a_shortname.to_boolean then
								l_e := (create {P_MISC1_STATIC}).gettail (l_retval)
								if (l_e.item).to_integer_32 /= 46 then
									memmove (create {CE_VOID_POINTER}.make_cast ((l_e + 1)), create {CE_VOID_POINTER}.make_cast (l_e), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_e))) + {NATURAL_32} 1).do_nothing
									l_e.item := (('.').code).to_natural_8
								end
							end
						end
						if not a_fname.is_void then
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_fname), create {CE_INTEGER_8_POINTER}.make_cast (l_retval))) = 0 then
								from
								until
									(l_break)
								loop
									l_break := False
									l_s := l_s - 1
									if not ((l_s.c_pointer.to_integer_32).to_natural_32 >= (l_ptr.c_pointer.to_integer_32).to_natural_32) then
										l_break := True
									end
									if not (l_break) and then ((l_s.item).to_integer_32 /= 95) then
										l_s.item := (('_').code).to_natural_8
										l_break := True
									end
								end
								l_break := False
								if (l_s.c_pointer.to_integer_32).to_natural_32 < (l_ptr.c_pointer.to_integer_32).to_natural_32 then
									l_ptr.item := (('v').code).to_natural_8
								end
							end
						end
						Result := l_retval
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vim_fgets (a_buf___6: CE_POINTER [NATURAL_8]; a_size: INTEGER_32; a_fp: CE_POINTER [SD_IO_FILE]): INTEGER_32
		require
			not a_buf___6.is_void
		local
			l_eof: CE_POINTER [INTEGER_8]
			l_tbuf: CE_ARRAY [INTEGER_8]
			l_break: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_tbuf.make (<<200>>)

			a_buf___6[(a_size - 2)] := (('%/0/').code).to_natural_8
			l_eof := fgets (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), a_size, a_fp)
			if (a_buf___6[(a_size - 2)]).to_integer_32 /= 0 then
				if (a_buf___6[(a_size - 2)]).to_integer_32 /= 10 then
					a_buf___6[(a_size - 1)] := (('%/0/').code).to_natural_8
					from
					until
						(l_break)
					loop
						l_break := False
						l_tbuf[198] := (('%/0/').code).to_integer_8;
						(create {P_GLOBALS_STATIC}).ignoredp.item := fgets (l_tbuf, 200, a_fp)
						if (l_tbuf[198]).to_integer_32 /= 0 then
							if (l_tbuf[198]).to_integer_32 = 10 then
								l_break := True
							end
						else
							l_break := True
						end
					end
					l_break := False
				end
			end
			Result := (l_eof.is_void).to_integer
		end

	vim_rename (a_from, a_to: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_to: CE_POINTER [NATURAL_8]
			l_fd_in: INTEGER_32
			l_fd_out: INTEGER_32
			l_n: INTEGER_32
			l_errmsg: CE_POINTER [INTEGER_8]
			l_buffer: CE_POINTER [INTEGER_8]
			l_st: CE_ARRAY [SD_STAT]
			l_perm: INTEGER_32
			l_acl: CE_POINTER [ANY]
			l_use_tmp_file: INTEGER_32
			l_st_to: CE_ARRAY [SD_STAT]
			l_tempname: CE_ARRAY [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st_to.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_tempname.make (<<4_097>>)

			l_to := a_to
			l_errmsg := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_use_tmp_file := 0
			if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_from), create {CE_INTEGER_8_POINTER}.make_cast (l_to))) = 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				if (stat (create {CE_INTEGER_8_POINTER}.make_cast (a_from), l_st)) < 0 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_to), l_st_to)) >= 0 then
					if l_st.item.st_dev = l_st_to.item.st_dev then
						if l_st.item.st_ino = l_st_to.item.st_ino then
							l_use_tmp_file := 1
						end
					end
				end
				if l_use_tmp_file.to_boolean then
					if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_from))) >= {NATURAL_32} 4_091 then
						Result := (-1)
						l_return := True
					end
					if not l_return then
						strcpy (l_tempname, create {CE_INTEGER_8_POINTER}.make_cast (a_from)).do_nothing
						l_n := 123
						from
						until
							not (not (l_return) and then (l_n < 99_999))
						loop
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC1_STATIC}).gettail (create {CE_NATURAL_8_POINTER}.make_cast (l_tempname)))), ce_string ("%%d"), l_n]).do_nothing
							if (stat (l_tempname, l_st)) < 0 then
								if (rename2 (create {CE_INTEGER_8_POINTER}.make_cast (a_from), l_tempname)) = 0 then
									if (rename2 (l_tempname, create {CE_INTEGER_8_POINTER}.make_cast (l_to))) = 0 then
										Result := 0
										l_return := True
									end
									if not l_return then
										rename2 (l_tempname, create {CE_INTEGER_8_POINTER}.make_cast (a_from)).do_nothing
										Result := (-1)
										l_return := True
									end
								end
								if not l_return then
									Result := (-1)
									l_return := True
								end
							end
							if not l_return then
								l_n := l_n + 1
							end
						end
					end
					if not l_return then
						Result := (-1)
						l_return := True
					end
				end
			end
			if not l_return then
				unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_to)).do_nothing
				if (rename2 (create {CE_INTEGER_8_POINTER}.make_cast (a_from), create {CE_INTEGER_8_POINTER}.make_cast (l_to))) = 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_perm := (create {P_OS_UNIX_STATIC}).mch_getperm (a_from)
				l_acl := (create {P_OS_UNIX_STATIC}).mch_get_acl (a_from)
				l_fd_in := open ([create {CE_INTEGER_8_POINTER}.make_cast (a_from), 0, 0])
				if l_fd_in = -1 then
					(create {P_OS_UNIX_STATIC}).mch_free_acl (l_acl)
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_fd_out := open ([create {CE_INTEGER_8_POINTER}.make_cast (l_to), 131_265, l_perm.to_integer_32])
				if l_fd_out = -1 then
					close (l_fd_in).do_nothing;
					(create {P_OS_UNIX_STATIC}).mch_free_acl (l_acl)
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_buffer := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC2_STATIC}).alloc ({NATURAL_32} 8_192)))
				if l_buffer.is_void then
					close (l_fd_out).do_nothing
					close (l_fd_in).do_nothing;
					(create {P_OS_UNIX_STATIC}).mch_free_acl (l_acl)
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					l_n := read (l_fd_in, create {CE_VOID_POINTER}.make_cast (l_buffer), (8_192).to_natural_32)
					if not (l_n > 0) then
						l_break := True
					end
					if not (l_return or l_break) then
						if (write (l_fd_out, create {CE_VOID_POINTER}.make_cast (l_buffer), l_n.to_natural_32)) /= l_n then
							l_errmsg := gettext (ce_string ("E208: Error writing to %"%%s%""))
							l_break := True
						end
					end
				end
				l_break := False;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buffer))
				close (l_fd_in).do_nothing
				if (close (l_fd_out)) < 0 then
					l_errmsg := gettext (ce_string ("E209: Error closing %"%%s%""))
				end
				if l_n < 0 then
					l_errmsg := gettext (ce_string ("E210: Error reading %"%%s%""))
					l_to := a_from
				end
				(create {P_OS_UNIX_STATIC}).mch_set_acl (l_to, l_acl);
				(create {P_OS_UNIX_STATIC}).mch_free_acl (l_acl)
				if not l_errmsg.is_void then
					(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_errmsg), l_to).do_nothing
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				unlink (create {CE_INTEGER_8_POINTER}.make_cast (a_from)).do_nothing
				Result := 0
			end
		end

	check_timestamps (a_focus: INTEGER_32): INTEGER_32
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_didit: INTEGER_32
			l_n: INTEGER_32
			l_return, l_continue: BOOLEAN
		do
			l_didit := 0
			if (create {P_GLOBALS_STATIC}).no_check_timestamps.item > 0 then
				Result := 0
				l_return := True
			end
			if not l_return and then (a_focus.to_boolean) then
				if ((create {P_GLOBALS_STATIC}).did_check_timestamps.item).to_boolean then
					(create {P_GLOBALS_STATIC}).need_check_timestamps.item := 1
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if ((create {P_GETCHAR_STATIC}).stuff_empty).to_boolean then
					if ((create {P_GLOBALS_STATIC}).global_busy.item).to_boolean then
						(create {P_GLOBALS_STATIC}).need_check_timestamps.item := 1
					elseif ((create {P_GETCHAR_STATIC}).typebuf_typed).to_boolean then
						if ((create {P_GLOBALS_STATIC}).autocmd_busy.item).to_boolean then
							(create {P_GLOBALS_STATIC}).need_check_timestamps.item := 1
						elseif (create {P_GLOBALS_STATIC}).curbuf_lock.item > 0 then
							(create {P_GLOBALS_STATIC}).need_check_timestamps.item := 1
						elseif (create {P_GLOBALS_STATIC}).allbuf_lock.item > 0 then
							(create {P_GLOBALS_STATIC}).need_check_timestamps.item := 1
						else
							(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item + 1;
							(create {P_GLOBALS_STATIC}).did_check_timestamps.item := 1
							already_warned.item := 0
							l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
							from
							until
								l_buf___6.is_void
							loop
								l_continue := False
								if l_buf___6.item.b_nwindows > 0 then
									l_n := l_buf___6.item.buf_check_timestamp (a_focus)
									if l_didit < l_n then
										l_didit := l_n
									end
									if l_n > 0 then
										if not ((create {P_BUFFER_STATIC}).buf_valid (l_buf___6)).to_boolean then
											l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
											l_continue := True
										end
									end
								end
								if not (l_continue) then
									l_buf___6 := l_buf___6.item.b_next
								end
								
							end
							l_continue := False;
							(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1;
							(create {P_GLOBALS_STATIC}).need_check_timestamps.item := 0
							if ((create {P_GLOBALS_STATIC}).need_wait_return.item).to_boolean then
								if l_didit = 2 then
									(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")));
									(create {P_TERM_STATIC}).out_flush
								end
							end
						end
					else
						(create {P_GLOBALS_STATIC}).need_check_timestamps.item := 1
					end
				else
					(create {P_GLOBALS_STATIC}).need_check_timestamps.item := 1
				end
				Result := l_didit
			end
		end

	vim_deltempdir
		local
			l_files: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_file_count: CE_ARRAY [INTEGER_32]
			l_i___0: INTEGER_32
		do
			create {CE_POINTER_ARRAY [CE_POINTER [NATURAL_8]]} l_files.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_file_count.make (<<1>>)

			if not ((create {P_GLOBALS_STATIC}).vim_tempdir.item).is_void then
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item), ce_string ("%%s*"), (create {P_GLOBALS_STATIC}).vim_tempdir.item]).do_nothing
				if ((create {P_MISC1_STATIC}).gen_expand_wildcards (1, (create {P_GLOBALS_STATIC}).NameBuff.item, l_file_count, l_files, 35)) = 1 then
					l_i___0 := 0
					from
					until
						not (l_i___0 < l_file_count.item)
					loop
						unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_files.item[l_i___0])).do_nothing
						l_i___0 := l_i___0 + 1
					end
					(create {P_MISC1_STATIC}).FreeWild (l_file_count.item, l_files.item)
				end
				((create {P_MISC1_STATIC}).gettail ((create {P_GLOBALS_STATIC}).NameBuff.item.item))[-1] := (('%/0/').code).to_natural_8
				rmdir (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item)).do_nothing;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).vim_tempdir.item));
				(create {P_GLOBALS_STATIC}).vim_tempdir.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			end
		end

	vim_settempdir (a_tempdir: CE_POINTER [NATURAL_8])
		local
			l_buf___6: CE_POINTER [NATURAL_8]
		do
			l_buf___6 := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 4_098)
			if not l_buf___6.is_void then
				if ((create {P_WINDOW_STATIC}).vim_FullName (a_tempdir, l_buf___6, 4_096, 0)) = 0 then
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (a_tempdir)).do_nothing
				end
				(create {P_MISC1_STATIC}).add_pathsep (l_buf___6);
				(create {P_GLOBALS_STATIC}).vim_tempdir.item := (create {P_MISC2_STATIC}).vim_strsave (l_buf___6);
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
			end
		end

	vim_tempname (a_extra_char: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_itmp: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_itmp.make (<<256>>)

			if ((create {P_GLOBALS_STATIC}).vim_tempdir.item).is_void then
				l_i___0 := 0
				from
				until
					not (not (l_break) and then (l_i___0 < (({PLATFORM}.Pointer_bytes.to_natural_32 * (4).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32))
				loop
					l_break := False;
					(create {P_MISC1_STATIC}).expand_env (create {CE_NATURAL_8_POINTER}.make_cast (tempdirs.item[l_i___0]), l_itmp, 236)
					if ((create {P_OS_UNIX_STATIC}).mch_isdir (l_itmp)).to_boolean then
						(create {P_MISC1_STATIC}).add_pathsep (l_itmp)
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_itmp), ce_string ("vXXXXXX")).do_nothing
						if not (mkdtemp (create {CE_INTEGER_8_POINTER}.make_cast (l_itmp))).is_void then
							vim_settempdir (l_itmp)
						end
						if not ((create {P_GLOBALS_STATIC}).vim_tempdir.item).is_void then
							l_break := True
						end
					end
					if not (l_break) then
						l_i___0 := l_i___0 + 1
					end
				end
				l_break := False
			end
			if not ((create {P_GLOBALS_STATIC}).vim_tempdir.item).is_void then
				l_tmp___1 := temp_count.item
				temp_count.item := temp_count.item + 1
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_itmp), ce_string ("%%s%%ld"), (create {P_GLOBALS_STATIC}).vim_tempdir.item, l_tmp___1]).do_nothing
				Result := ((create {P_MISC2_STATIC}).vim_strsave (l_itmp))
				l_return := True
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
		end

	au_cleanup
		local
			l_ap___0: CE_POINTER [PD_AUTOPAT]
			l_prev_ap: CE_POINTER [CE_POINTER [PD_AUTOPAT]]
			l_ac: CE_POINTER [PD_AUTOCMD]
			l_prev_ac: CE_POINTER [CE_POINTER [PD_AUTOCMD]]
			l_event: NATURAL_32
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).autocmd_busy.item).to_boolean then
				l_return := True
			elseif not au_need_clean.item.to_boolean then
				l_return := True
			end
			if not l_return then
				l_event := {PC_AUTO_EVENT}.EVENT_BUFADD
				from
				until
					not (not (l_return) and then (l_event.to_integer_32 < 77))
				loop
					l_prev_ap := first_autopat.item + l_event.to_integer_32
					l_ap___0 := l_prev_ap.item
					from
					until
						not (not (l_return) and then (not l_ap___0.is_void))
					loop
						l_prev_ac := create {CE_POINTER_POINTER [PD_AUTOCMD]}.make_shared (l_ap___0.c_pointer + (create {PD_AUTOPAT}.make).offset_of ("cmds"))
						l_ac := l_prev_ac.item
						from
						until
							l_ac.is_void
						loop
							if (l_ap___0.item.pat).is_void then
								l_prev_ac.item := l_ac.item.next;
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ac.item.cmd));
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ac))
							elseif (l_ac.item.cmd).is_void then
								l_prev_ac.item := l_ac.item.next;
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ac.item.cmd));
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ac))
							else
								l_prev_ac := create {CE_POINTER_POINTER [PD_AUTOCMD]}.make_shared (l_ac.c_pointer + (create {PD_AUTOCMD}.make).offset_of ("next"))
							end
							l_ac := l_prev_ac.item
						end
						if (l_ap___0.item.pat).is_void then
							l_prev_ap.item := l_ap___0.item.next;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ap___0.item.reg_prog));
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ap___0))
						else
							l_prev_ap := create {CE_POINTER_POINTER [PD_AUTOPAT]}.make_shared (l_ap___0.c_pointer + (create {PD_AUTOPAT}.make).offset_of ("next"))
						end
						l_ap___0 := l_prev_ap.item
					end
					l_event := (l_event.to_integer_32 + 1).to_natural_32
				end
				au_need_clean.item := 0
			end
		end

	aubuflocal_remove (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_ap___0: CE_POINTER [PD_AUTOPAT]
			l_event: NATURAL_32
			l_apc: CE_POINTER [PD_AUTOPATCMD]
			l_tmp: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_apc := active_apc_list.item
			from
			until
				l_apc.is_void
			loop
				if a_buf___6.item.b_fnum = l_apc.item.arg_bufnr then
					l_apc.item.arg_bufnr := 0
				end
				l_apc := l_apc.item.next
			end
			l_event := {PC_AUTO_EVENT}.EVENT_BUFADD
			from
			until
				not (not (l_return) and then (l_event.to_integer_32 < 77))
			loop
				l_ap___0 := first_autopat.item[l_event.to_integer_32]
				from
				until
					l_ap___0.is_void
				loop
					if l_ap___0.item.buflocal_nr = a_buf___6.item.b_fnum then
						l_ap___0.item.au_remove_pat
						if (create {P_OPTION_STATIC}).p_verbose.item.item >= 6 then
							(create {P_MESSAGE_STATIC}).verbose_enter
							l_tmp := event_nr2name (l_event);
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("auto-removing autocommand: %%s <buffer=%%d>")))), l_tmp, a_buf___6.item.b_fnum]).do_nothing;
							(create {P_MESSAGE_STATIC}).verbose_leave
						end
					end
					l_ap___0 := l_ap___0.item.next
				end
				l_event := (l_event.to_integer_32 + 1).to_natural_32
			end
			au_cleanup
		end

	au_find_group (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				not (not (l_return) and then (l_i___0 < augroups.item.item.ga_len))
			loop
				if not (create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (augroups.item.item.ga_data)[l_i___0]).is_void then
					if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (augroups.item.item.ga_data)[l_i___0]), create {CE_INTEGER_8_POINTER}.make_cast (a_name___1))) = 0 then
						Result := l_i___0
						l_return := True
					end
				end
				if not l_return then
					l_i___0 := l_i___0 + 1
				end
			end
			if not l_return then
				Result := (-2)
			end
		end

	au_has_group (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := ((au_find_group (a_name___1)) /= -2).to_integer
		end

	event_name2nr (a_start___1: CE_POINTER [NATURAL_8]; a_end: CE_POINTER [CE_POINTER [NATURAL_8]]): NATURAL_32
		require
			not a_start___1.is_void
			not a_end.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_p___0 := a_start___1
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_p___0.item).to_boolean then
					if (l_p___0.item).to_integer_32 = 32 then
						l_break := True
					elseif (l_p___0.item).to_integer_32 = 9 then
						l_break := True
					elseif (l_p___0.item).to_integer_32 = 44 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_p___0 := l_p___0 + 1
				end
			end
			l_break := False
			l_i___0 := 0
			from
			until
				not (not (l_break) and then (not (event_names.item[l_i___0].name).is_void))
			loop
				l_break := False
				l_len := (strlen (event_names.item[l_i___0].name)).to_integer_32
				if l_len = l_p___0.distance (a_start___1) then
					if (strncasecmp (event_names.item[l_i___0].name, create {CE_INTEGER_8_POINTER}.make_cast (a_start___1), l_len.to_natural_32)) = 0 then
						l_break := True
					end
				end
				if not (l_break) then
					l_i___0 := l_i___0 + 1
				end
			end
			l_break := False
			if (l_p___0.item).to_integer_32 = 44 then
				l_p___0 := l_p___0 + 1
			end
			a_end.item := l_p___0
			if (event_names.item[l_i___0].name).is_void then
				Result := ({PC_AUTO_EVENT}.NUM_EVENTS)
				l_return := True
			end
			if not l_return then
				Result := (event_names.item[l_i___0].event)
			end
		end

	event_nr2name (a_event: NATURAL_32): CE_POINTER [NATURAL_8]
		local
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				not (not (l_return) and then (not (event_names.item[l_i___0].name).is_void))
			loop
				if event_names.item[l_i___0].event = a_event then
					Result := (create {CE_NATURAL_8_POINTER}.make_cast (event_names.item[l_i___0].name))
					l_return := True
				end
				if not l_return then
					l_i___0 := l_i___0 + 1
				end
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Unknown")))
			end
		end

	find_end_event (a_arg: CE_POINTER [NATURAL_8]; a_have_group: INTEGER_32): CE_POINTER [NATURAL_8]
		require
			not a_arg.is_void
		local
			l_pat: CE_POINTER [NATURAL_8]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			if (a_arg.item).to_integer_32 = 42 then
				if (a_arg[1]).to_boolean then
					if (a_arg[1]).to_integer_32 /= 32 then
						if (a_arg[1]).to_integer_32 /= 9 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E215: Illegal character after *: %%s")))), a_arg).do_nothing
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
				end
				if not l_return then
					l_pat := a_arg + 1
				end
			else
				l_pat := a_arg
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if (l_pat.item).to_boolean then
						if (l_pat.item).to_integer_32 = 32 then
							l_break := True
						elseif (l_pat.item).to_integer_32 = 9 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_return or l_break) then
						if (event_name2nr (l_pat, l_p___0)).to_integer_32 >= 77 then
							if a_have_group.to_boolean then
								(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E216: No such event: %%s")))), l_pat).do_nothing
							else
								(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E216: No such group or event: %%s")))), l_pat).do_nothing
							end
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return then
							l_pat := l_p___0.item
						end
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := l_pat
			end
		end

	event_ignored (a_event: NATURAL_32): INTEGER_32
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			l_p___0.item := (create {P_OPTION_STATIC}).p_ei.item.item
			from
			until
				not (not (l_return) and then ((l_p___0.item.item).to_integer_32 /= 0))
			loop
				if (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), ce_string ("all"), (3).to_natural_32)) = 0 then
					if (l_p___0.item[3]).to_integer_32 = 0 then
						Result := 1
						l_return := True
					elseif (l_p___0.item[3]).to_integer_32 = 44 then
						Result := 1
						l_return := True
					end
				end
				if not l_return then
					if (event_name2nr (l_p___0.item, l_p___0)) = a_event then
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	check_ei: INTEGER_32
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.item := (create {P_OPTION_STATIC}).p_ei.item.item
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_p___0.item.item).to_boolean)) then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						if (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), ce_string ("all"), (3).to_natural_32)) /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if (l_p___0.item[3]).to_integer_32 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if (l_p___0.item[3]).to_integer_32 /= 44 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___0:
						l_p___0.item := l_p___0.item + (3)
						if (l_p___0.item.item).to_integer_32 = 44 then
							l_p___0.item := l_p___0.item + 1
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 11 -- goto _L
				when 10 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L:
						if (event_name2nr (l_p___0.item, l_p___0)) = {NATURAL_32} 77 then
							Result := 0
							l_return := True
						end
				when 12 then
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					if not l_return then
						Result := 1
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	au_get_grouparg (a_argp: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		require
			not a_argp.is_void
		local
			l_group_name: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_arg: CE_POINTER [NATURAL_8]
			l_group: INTEGER_32
			l_return: BOOLEAN
		do
			l_arg := a_argp.item
			l_group := -3
			l_p___0 := (create {P_CHARSET_STATIC}).skiptowhite (l_arg)
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_arg.c_pointer.to_integer_32).to_natural_32 then
				l_group_name := (create {P_MISC2_STATIC}).vim_strnsave (l_arg, l_p___0.distance (l_arg))
				if l_group_name.is_void then
					Result := (-2)
					l_return := True
				end
				if not l_return then
					l_group := au_find_group (l_group_name)
					if l_group = -2 then
						l_group := -3
					else
						a_argp.item := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
					end
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_group_name))
				end
			end
			if not l_return then
				Result := l_group
			end
		end

	do_doautocmd (a_arg: CE_POINTER [NATURAL_8]; a_do_msg: INTEGER_32): INTEGER_32
		local
			l_arg: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_fname: CE_POINTER [NATURAL_8]
			l_nothing_done: INTEGER_32
			l_group: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_arg.make (<<1>>)

			l_arg.item := a_arg
			l_nothing_done := 1
			l_group := au_get_grouparg (l_arg)
			if (l_arg.item).is_void then
				Result := 0
				l_return := True
			end
			if not l_return and then ((l_arg.item.item).to_integer_32 = 42) then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E217: Can%'t execute autocommands for ALL events"))))).do_nothing
				Result := 0
				l_return := True
			end
			if not l_return then
				l_fname := find_end_event (l_arg.item, (l_group /= -3).to_integer)
				if l_fname.is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_fname := (create {P_CHARSET_STATIC}).skipwhite (l_fname)
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_arg.item.item).to_boolean then
						if (l_arg.item.item).to_integer_32 = 32 then
							l_break := True
						elseif (l_arg.item.item).to_integer_32 = 9 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						if (apply_autocmds_group ((event_name2nr (l_arg.item, l_arg)), l_fname, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 1, l_group, (create {P_GLOBALS_STATIC}).curbuf.item, create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer))).to_boolean then
							l_nothing_done := 0
						end
					end
				end
				l_break := False
				if l_nothing_done.to_boolean then
					if a_do_msg.to_boolean then
						(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("No matching autocommands"))))).do_nothing
					end
				end
				if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
					l_tmp___4 := 0
				else
					l_tmp___4 := 1
				end
				Result := l_tmp___4
			end
		end

	ex_doautoall (a_eap: CE_POINTER [PD_EXARG])
		local
			l_retval: INTEGER_32
			l_aco: CE_ARRAY [PD_ACO_SAVE_T]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp: INTEGER_32
			l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_ACO_SAVE_T]} l_aco.make (<<1>>)

			l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
			from
			until
				not (not (l_break) and then (not l_buf___6.is_void))
			loop
				l_break := False
				if not (l_buf___6.item.b_ml.ml_mfp).is_void then
					l_aco.item.aucmd_prepbuf (l_buf___6)
					l_retval := do_doautocmd (a_eap.item.arg, 0)
					if ((create {P_GLOBALS_STATIC}).curwin.item).is_equal ((create {P_GLOBALS_STATIC}).aucmd_win.item) then
						l_tmp := 32
					else
						l_tmp := 0
					end
					(create {P_BUFFER_STATIC}).do_modelines (l_tmp)
					l_aco.item.aucmd_restbuf
					if l_retval = 0 then
						l_break := True
					elseif not ((create {P_BUFFER_STATIC}).buf_valid (l_buf___6)).to_boolean then
						l_break := True
					end
				end
				if not (l_break) then
					l_buf___6 := l_buf___6.item.b_next
				end
			end
			l_break := False;
			(create {P_MISC2_STATIC}).check_cursor
		end

	apply_autocmds (a_event: NATURAL_32; a_fname, a_fname_io: CE_POINTER [NATURAL_8]; a_force: INTEGER_32; a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		do
			Result := (apply_autocmds_group (a_event, a_fname, a_fname_io, a_force, -3, a_buf___6, create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer)))
		end

	apply_autocmds_exarg (a_event: NATURAL_32; a_fname, a_fname_io: CE_POINTER [NATURAL_8]; a_force: INTEGER_32; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_eap: CE_POINTER [PD_EXARG]): INTEGER_32
		do
			Result := (apply_autocmds_group (a_event, a_fname, a_fname_io, a_force, -3, a_buf___6, a_eap))
		end

	apply_autocmds_retval (a_event: NATURAL_32; a_fname, a_fname_io: CE_POINTER [NATURAL_8]; a_force: INTEGER_32; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_retval: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_retval.is_void
		local
			l_did_cmd: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_EX_EVAL_STATIC}).should_abort (a_retval.item)).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_did_cmd := apply_autocmds_group (a_event, a_fname, a_fname_io, a_force, -3, a_buf___6, create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer))
				if l_did_cmd.to_boolean then
					if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
						a_retval.item := 0
					end
				end
				Result := l_did_cmd
			end
		end

	has_cursorhold: INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if ((create {P_MISC2_STATIC}).get_real_state) = 257 then
				l_tmp___0 := 63
			else
				l_tmp___0 := 64
			end
			Result := (not (first_autopat.item[l_tmp___0]).is_void).to_integer
		end

	trigger_cursorhold: INTEGER_32
		local
			l_state: INTEGER_32
			l_return: BOOLEAN
		do
			if not ((create {P_GLOBALS_STATIC}).did_cursorhold.item).to_boolean then
				if (has_cursorhold).to_boolean then
					if not ((create {P_GLOBALS_STATIC}).Recording.item).to_boolean then
						if not ((create {P_EDIT_STATIC}).ins_compl_active).to_boolean then
							l_state := (create {P_MISC2_STATIC}).get_real_state
							if l_state = 257 then
								Result := 1
								l_return := True
							elseif ((l_state).bit_and (16)) /= 0 then
								Result := 1
								l_return := True
							end
						end
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	has_cursormoved: INTEGER_32
		do
			Result := (not (first_autopat.item[71]).is_void).to_integer
		end

	has_cursormovedI: INTEGER_32
		do
			Result := (not (first_autopat.item[72]).is_void).to_integer
		end

	apply_autocmds_group (a_event: NATURAL_32; a_fname, a_fname_io: CE_POINTER [NATURAL_8]; a_force, a_group: INTEGER_32; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_eap: CE_POINTER [PD_EXARG]): INTEGER_32
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_sfname: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_save_changed: INTEGER_32
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_retval: INTEGER_32
			l_save_sourcing_name: CE_POINTER [NATURAL_8]
			l_save_sourcing_lnum: INTEGER_32
			l_save_autocmd_fname: CE_POINTER [NATURAL_8]
			l_save_autocmd_fname_full: INTEGER_32
			l_save_autocmd_bufnr: INTEGER_32
			l_save_autocmd_match: CE_POINTER [NATURAL_8]
			l_save_autocmd_busy: INTEGER_32
			l_save_autocmd_nested: INTEGER_32
			l_patcmd: CE_ARRAY [PD_AUTOPATCMD]
			l_ap___0: CE_POINTER [PD_AUTOPAT]
			l_save_current_SID: INTEGER_32
			l_save_funccalp: CE_POINTER [ANY]
			l_save_cmdarg: CE_POINTER [NATURAL_8]
			l_save_cmdbang: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_AUTOPATCMD]} l_patcmd.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fname := a_fname
					l_sfname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_retval := 0
					if (first_autopat.item[a_event.to_integer_32]).is_void then
						l_pos := -1 + 41 -- goto BYPASS_AU
					elseif autocmd_blocked.item > 0 then
						l_pos := -1 + 41 -- goto BYPASS_AU
					end
				when 1 then
					if ((create {P_GLOBALS_STATIC}).autocmd_busy.item).to_boolean then
						if not a_force.to_boolean then
							if not autocmd_nested.item.to_boolean then
								l_pos := -1 + 41 -- goto BYPASS_AU
							end
						end
					end
				when 2 then
					if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
						l_pos := -1 + 41 -- goto BYPASS_AU
					end
				when 3 then
					if filechangeshell_busy.item.to_boolean then
						if a_event = {NATURAL_32} 25 then
							l_pos := -1 + 41 -- goto BYPASS_AU
						elseif a_event = {NATURAL_32} 26 then
							l_pos := -1 + 41 -- goto BYPASS_AU
						end
					end
				when 4 then
					if (event_ignored (a_event)).to_boolean then
						l_pos := -1 + 41 -- goto BYPASS_AU
					end
				when 5 then
					if nesting.item = 10 then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E218: autocommand nesting too deep"))))).do_nothing
						l_pos := -1 + 41 -- goto BYPASS_AU
					end
				when 6 then
					if not (((create {P_GLOBALS_STATIC}).autocmd_no_enter.item).to_boolean) then
						l_pos := -1 + 9 -- skip if block
					end
				when 7 then -- if:
						if a_event = {NATURAL_32} 60 then
							l_pos := -1 + 41 -- goto BYPASS_AU
						elseif a_event = {NATURAL_32} 4 then
							l_pos := -1 + 41 -- goto BYPASS_AU
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if ((create {P_GLOBALS_STATIC}).autocmd_no_leave.item).to_boolean then
							if a_event = {NATURAL_32} 61 then
								l_pos := -1 + 41 -- goto BYPASS_AU
							elseif a_event = {NATURAL_32} 7 then
								l_pos := -1 + 41 -- goto BYPASS_AU
							end
						end
				when 10 then
					l_save_autocmd_fname := (create {P_GLOBALS_STATIC}).autocmd_fname.item
					l_save_autocmd_fname_full := (create {P_GLOBALS_STATIC}).autocmd_fname_full.item
					l_save_autocmd_bufnr := (create {P_GLOBALS_STATIC}).autocmd_bufnr.item
					l_save_autocmd_match := (create {P_GLOBALS_STATIC}).autocmd_match.item
					l_save_autocmd_busy := (create {P_GLOBALS_STATIC}).autocmd_busy.item
					l_save_autocmd_nested := autocmd_nested.item
					l_save_changed := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_changed
					l_old_curbuf := (create {P_GLOBALS_STATIC}).curbuf.item
					if not (a_fname_io.is_void) then
						l_pos := -1 + 16 -- skip if block
					end
				when 11 then -- if:
						if l_fname.is_void then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (l_fname.item).to_integer_32 /= 0 then
							(create {P_GLOBALS_STATIC}).autocmd_fname.item := l_fname
						else
							l_pos := -1 + 14 -- goto _L___0
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L___0:
						if not a_buf___6.is_void then
							(create {P_GLOBALS_STATIC}).autocmd_fname.item := a_buf___6.item.b_ffname
						else
							(create {P_GLOBALS_STATIC}).autocmd_fname.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:;
						(create {P_GLOBALS_STATIC}).autocmd_fname.item := a_fname_io
				when 17 then
					if not ((create {P_GLOBALS_STATIC}).autocmd_fname.item).is_void then
						(create {P_GLOBALS_STATIC}).autocmd_fname.item := (create {P_MISC2_STATIC}).vim_strsave ((create {P_GLOBALS_STATIC}).autocmd_fname.item)
					end
					(create {P_GLOBALS_STATIC}).autocmd_fname_full.item := 0
					if a_buf___6.is_void then
						(create {P_GLOBALS_STATIC}).autocmd_bufnr.item := 0
					else
						(create {P_GLOBALS_STATIC}).autocmd_bufnr.item := a_buf___6.item.b_fnum
					end
					if not (l_fname.is_void) then
						l_pos := -1 + 20 -- skip if block
					end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L___1
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 20 then -- else:
						if (l_fname.item).to_integer_32 /= 0 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if: | _L___1:
						if a_buf___6.is_void then
							l_fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						elseif a_event = {NATURAL_32} 52 then
							l_fname := a_buf___6.item.b_p_syn
						elseif a_event = {NATURAL_32} 31 then
							l_fname := a_buf___6.item.b_p_ft
						else
							if not (a_buf___6.item.b_sfname).is_void then
								l_sfname := (create {P_MISC2_STATIC}).vim_strsave (a_buf___6.item.b_sfname)
							end
							l_fname := a_buf___6.item.b_ffname
						end
						if l_fname.is_void then
							l_fname := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
						end
						l_fname := (create {P_MISC2_STATIC}).vim_strsave (l_fname)
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_sfname := (create {P_MISC2_STATIC}).vim_strsave (l_fname)
						if a_event = {NATURAL_32} 31 then
							l_fname := (create {P_MISC2_STATIC}).vim_strsave (l_fname)
						elseif a_event = {NATURAL_32} 52 then
							l_fname := (create {P_MISC2_STATIC}).vim_strsave (l_fname)
						elseif a_event = {NATURAL_32} 65 then
							l_fname := (create {P_MISC2_STATIC}).vim_strsave (l_fname)
						elseif a_event = {NATURAL_32} 66 then
							l_fname := (create {P_MISC2_STATIC}).vim_strsave (l_fname)
						elseif a_event = {NATURAL_32} 70 then
							l_fname := (create {P_MISC2_STATIC}).vim_strsave (l_fname)
						elseif a_event = {NATURAL_32} 48 then
							l_fname := (create {P_MISC2_STATIC}).vim_strsave (l_fname)
						elseif a_event = {NATURAL_32} 47 then
							l_fname := (create {P_MISC2_STATIC}).vim_strsave (l_fname)
						else
							l_fname := (create {P_MISC1_STATIC}).FullName_save (l_fname, 0)
						end
				when 24 then -- if done
					if l_fname.is_void then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_sfname))
						l_retval := 0
						l_pos := -1 + 41 -- goto BYPASS_AU
					end
				when 25 then;
					(create {P_GLOBALS_STATIC}).autocmd_match.item := l_fname;
					(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item + 1
					l_save_sourcing_name := (create {P_GLOBALS_STATIC}).sourcing_name.item;
					(create {P_GLOBALS_STATIC}).sourcing_name.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_save_sourcing_lnum := (create {P_GLOBALS_STATIC}).sourcing_lnum.item;
					(create {P_GLOBALS_STATIC}).sourcing_lnum.item := (0).to_integer_32
					l_save_current_SID := (create {P_GLOBALS_STATIC}).current_SID.item
					l_save_funccalp := (create {P_EVAL_STATIC}).save_funccal
					if not ((create {P_GLOBALS_STATIC}).autocmd_busy.item).to_boolean then
						(create {P_SEARCH_STATIC}).save_search_patterns;
						(create {P_GETCHAR_STATIC}).saveRedobuff;
						(create {P_GLOBALS_STATIC}).did_filetype.item := (create {P_GLOBALS_STATIC}).keep_filetype.item
					end
					(create {P_GLOBALS_STATIC}).autocmd_busy.item := 1
					filechangeshell_busy.item := (a_event = {NATURAL_32} 25).to_integer
					nesting.item := nesting.item + 1
					if a_event = {NATURAL_32} 31 then
						(create {P_GLOBALS_STATIC}).did_filetype.item := 1
					end
					l_tail := (create {P_MISC1_STATIC}).gettail (l_fname)
					l_patcmd.item.curpat := first_autopat.item[a_event.to_integer_32]
					l_patcmd.item.nextcmd := create {CE_CLASS_POINTER [PD_AUTOCMD]}.make_shared (default_pointer)
					l_patcmd.item.group := a_group
					l_patcmd.item.fname := l_fname
					l_patcmd.item.sfname := l_sfname
					l_patcmd.item.tail := l_tail
					l_patcmd.item.event := a_event
					l_patcmd.item.arg_bufnr := (create {P_GLOBALS_STATIC}).autocmd_bufnr.item
					l_patcmd.item.next := create {CE_CLASS_POINTER [PD_AUTOPATCMD]}.make_shared (default_pointer)
					l_patcmd.item.auto_next_pat (0)
					if not (l_patcmd.item.curpat).is_void then
						l_patcmd.item.next := active_apc_list.item
						active_apc_list.item := l_patcmd
						l_save_cmdbang := (create {P_EVAL_STATIC}).get_vim_var_nr (32)
						if not a_eap.is_void then
							l_save_cmdarg := (create {P_EVAL_STATIC}).set_cmdarg (a_eap, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer));
							(create {P_EVAL_STATIC}).set_vim_var_nr (32, (a_eap.item.forceit).to_integer_32)
						else
							l_save_cmdarg := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
						l_retval := 1
						l_ap___0 := l_patcmd.item.curpat
						from
						until
							(l_ap___0.item.next).is_void
						loop
							l_ap___0.item.last := (0).to_integer_8
							l_ap___0 := l_ap___0.item.next
						end
						l_ap___0.item.last := (1).to_integer_8;
						(create {P_WINDOW_STATIC}).check_lnums (1);
						(create {P_EX_DOCMD_STATIC}).do_cmdline (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), getnextac_address, create {CE_VOID_POINTER}.make_cast (l_patcmd), 7).do_nothing
						if not a_eap.is_void then
							(create {P_EVAL_STATIC}).set_cmdarg (create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), l_save_cmdarg).do_nothing;
							(create {P_EVAL_STATIC}).set_vim_var_nr (32, l_save_cmdbang)
						end
						if active_apc_list.item.is_equal (l_patcmd) then
							active_apc_list.item := l_patcmd.item.next
						end
					end
					(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item - 1;
					(create {P_GLOBALS_STATIC}).autocmd_busy.item := l_save_autocmd_busy
					filechangeshell_busy.item := 0
					autocmd_nested.item := l_save_autocmd_nested;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).sourcing_name.item));
					(create {P_GLOBALS_STATIC}).sourcing_name.item := l_save_sourcing_name;
					(create {P_GLOBALS_STATIC}).sourcing_lnum.item := l_save_sourcing_lnum;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).autocmd_fname.item));
					(create {P_GLOBALS_STATIC}).autocmd_fname.item := l_save_autocmd_fname;
					(create {P_GLOBALS_STATIC}).autocmd_fname_full.item := l_save_autocmd_fname_full;
					(create {P_GLOBALS_STATIC}).autocmd_bufnr.item := l_save_autocmd_bufnr;
					(create {P_GLOBALS_STATIC}).autocmd_match.item := l_save_autocmd_match;
					(create {P_GLOBALS_STATIC}).current_SID.item := l_save_current_SID;
					(create {P_EVAL_STATIC}).restore_funccal (l_save_funccalp);
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fname));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_sfname))
					nesting.item := nesting.item - 1
					if not ((create {P_GLOBALS_STATIC}).autocmd_busy.item).to_boolean then
						(create {P_SEARCH_STATIC}).restore_search_patterns;
						(create {P_GETCHAR_STATIC}).restoreRedobuff;
						(create {P_GLOBALS_STATIC}).did_filetype.item := 0
					end
					if not (((create {P_GLOBALS_STATIC}).curbuf.item).is_equal (l_old_curbuf)) then
						l_pos := -1 + 40 -- skip if block
					end
				when 26 then -- if:
						if a_event /= {NATURAL_32} 9 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						l_pos := -1 + 39 -- goto _L___2
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 29 then -- else:
						if a_event /= {NATURAL_32} 16 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 39 -- goto _L___2
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 32 then -- else:
						if a_event /= {NATURAL_32} 22 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 39 -- goto _L___2
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 35 then -- else:
						if a_event /= {NATURAL_32} 57 then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						l_pos := -1 + 39 -- goto _L___2
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 38 then -- else:
						if a_event /= {NATURAL_32} 58 then
							l_pos := -1 + 40 -- skip if block
						end
				when 39 then -- if: | _L___2:
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_changed /= l_save_changed then
							(create {P_GLOBALS_STATIC}).need_maketitle.item := 1
						end
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_changed := l_save_changed
				when 40 then -- if done | if done | if done | if done | if done
					au_cleanup
				when 41 then -- BYPASS_AU:
					if a_event = {NATURAL_32} 3 then
						if not a_buf___6.is_void then
							aubuflocal_remove (a_buf___6)
						end
					end
					Result := l_retval
				when 42 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	block_autocmds
		do
			if autocmd_blocked.item = 0 then
				old_termresponse.item := (create {P_EVAL_STATIC}).get_vim_var_str (10)
			end
			autocmd_blocked.item := autocmd_blocked.item + 1
		end

	unblock_autocmds
		do
			autocmd_blocked.item := autocmd_blocked.item - 1
			if autocmd_blocked.item = 0 then
				if not ((create {P_EVAL_STATIC}).get_vim_var_str (10)).is_equal (old_termresponse.item) then
					apply_autocmds ({PC_AUTO_EVENT}.EVENT_TERMRESPONSE, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
				end
			end
		end

	getnextac (a_c: INTEGER_32; a_cookie: CE_POINTER [ANY]; a_indent: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_acp: CE_POINTER [PD_AUTOPATCMD]
			l_retval: CE_POINTER [NATURAL_8]
			l_ac: CE_POINTER [PD_AUTOCMD]
			l_return, l_break: BOOLEAN
		do
			l_acp := create {CE_CLASS_POINTER [PD_AUTOPATCMD]}.make_cast (a_cookie)
			if (l_acp.item.curpat).is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if not (l_acp.item.nextcmd).is_void then
							if not (((l_acp.item.nextcmd).item.cmd).is_void) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							if ((l_acp.item.nextcmd).item.last).to_boolean then
								l_acp.item.nextcmd := create {CE_CLASS_POINTER [PD_AUTOCMD]}.make_shared (default_pointer)
							else
								l_acp.item.nextcmd := (l_acp.item.nextcmd).item.next
							end
						end
					end
					l_break := False
					if not (l_acp.item.nextcmd).is_void then
						l_break := True
					end
					if not (l_return or l_break) then
						if ((l_acp.item.curpat).item.last).to_boolean then
							l_acp.item.curpat := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
						else
							l_acp.item.curpat := (l_acp.item.curpat).item.next
						end
						if not (l_acp.item.curpat).is_void then
							l_acp.item.auto_next_pat (1)
						end
						if (l_acp.item.curpat).is_void then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
				end
			end
			if not l_return then
				l_break := False
				l_ac := l_acp.item.nextcmd
				if (create {P_OPTION_STATIC}).p_verbose.item.item >= 9 then
					(create {P_MESSAGE_STATIC}).verbose_enter_scroll;
					(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("autocommand %%s")))), l_ac.item.cmd]).do_nothing;
					(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")));
					(create {P_MESSAGE_STATIC}).verbose_leave_scroll
				end
				l_retval := (create {P_MISC2_STATIC}).vim_strsave (l_ac.item.cmd)
				autocmd_nested.item := (l_ac.item.nested).to_integer_32;
				(create {P_GLOBALS_STATIC}).current_SID.item := l_ac.item.scriptID
				if (l_ac.item.last).to_boolean then
					l_acp.item.nextcmd := create {CE_CLASS_POINTER [PD_AUTOCMD]}.make_shared (default_pointer)
				else
					l_acp.item.nextcmd := l_ac.item.next
				end
				Result := l_retval
			end
		end

	has_autocmd (a_event: NATURAL_32; a_sfname: CE_POINTER [NATURAL_8]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_ap___0: CE_POINTER [PD_AUTOPAT]
			l_fname: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_tail := ((create {P_MISC1_STATIC}).gettail (a_sfname))
			l_retval := 0
			l_fname := (create {P_MISC1_STATIC}).FullName_save (a_sfname, 0)
			if l_fname.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_ap___0 := first_autopat.item[a_event.to_integer_32]
				from
				until
					not (not (l_break) and then (not l_ap___0.is_void))
				loop
					l_break := False
					if not (l_ap___0.item.pat).is_void then
						if not (l_ap___0.item.cmds).is_void then
							if l_ap___0.item.buflocal_nr = 0 then
								l_tmp___2 := (match_file_pat (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_ap___0.item.reg_prog, l_fname, a_sfname, l_tail, (l_ap___0.item.allow_dirs).to_integer_32))
							else
								if not a_buf___6.is_void then
									if l_ap___0.item.buflocal_nr = a_buf___6.item.b_fnum then
										l_tmp___1 := 1
									else
										l_tmp___1 := 0
									end
								else
									l_tmp___1 := 0
								end
								l_tmp___2 := l_tmp___1
							end
							if l_tmp___2.to_boolean then
								l_retval := 1
								l_break := True
							end
						end
					end
					if not (l_break) then
						l_ap___0 := l_ap___0.item.next
					end
				end
				l_break := False;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fname))
				Result := l_retval
			end
		end

	get_augroup_name (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_return: BOOLEAN
		do
			if a_idx = augroups.item.item.ga_len then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("END")))
				l_return := True
			end
			if not l_return and then (a_idx >= augroups.item.item.ga_len) then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return and then ((create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (augroups.item.item.ga_data)[a_idx]).is_void) then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
				l_return := True
			end
			if not l_return then
				Result := (create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (augroups.item.item.ga_data)[a_idx])
			end
		end

	get_event_name (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_return: BOOLEAN
		do
			if a_idx < augroups.item.item.ga_len then
				if not include_groups.item.to_boolean then
					Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
					l_return := True
				elseif (create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (augroups.item.item.ga_data)[a_idx]).is_void then
					Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
					l_return := True
				end
				if not l_return then
					Result := (create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (augroups.item.item.ga_data)[a_idx])
					l_return := True
				end
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (event_names.item[a_idx - augroups.item.item.ga_len].name))
			end
		end

	autocmd_supported (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_name___1.is_void
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			Result := ((event_name2nr (a_name___1, l_p___0)) /= {NATURAL_32} 77).to_integer
		end

	au_exists (a_arg: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_arg_save: CE_POINTER [NATURAL_8]
			l_pattern: CE_POINTER [NATURAL_8]
			l_event_name: CE_POINTER [NATURAL_8]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_event: NATURAL_32
			l_ap___0: CE_POINTER [PD_AUTOPAT]
			l_buflocal_buf: CE_POINTER [PD_FILE_BUFFER]
			l_group: INTEGER_32
			l_retval: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pattern := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_buflocal_buf := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
					l_retval := 0
					l_arg_save := (create {P_MISC2_STATIC}).vim_strsave (a_arg)
					if l_arg_save.is_void then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						l_p___0.item := (create {P_MISC2_STATIC}).vim_strchr (l_arg_save, ('#').code)
						if not (l_p___0.item).is_void then
							l_tmp := l_p___0.item
							l_p___0.item := l_p___0.item + 1
							l_tmp.item := (('%/0/').code).to_natural_8
						end
						l_group := au_find_group (l_arg_save)
						if l_group /= -2 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_group := -3
						l_event_name := l_arg_save
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (l_p___0.item).is_void then
							l_retval := 1
							l_pos := -1 + 19 -- goto theend
						end
				when 5 then
						l_event_name := l_p___0.item
						l_p___0.item := (create {P_MISC2_STATIC}).vim_strchr (l_event_name, ('#').code)
						if not (l_p___0.item).is_void then
							l_tmp___0 := l_p___0.item
							l_p___0.item := l_p___0.item + 1
							l_tmp___0.item := (('%/0/').code).to_natural_8
						end
				when 6 then -- if done
						l_pattern := l_p___0.item
						l_event := event_name2nr (l_event_name, l_p___0)
						if l_event = {NATURAL_32} 77 then
							l_pos := -1 + 19 -- goto theend
						end
				when 7 then
						l_ap___0 := first_autopat.item[l_event.to_integer_32]
						if l_ap___0.is_void then
							l_pos := -1 + 19 -- goto theend
						end
				when 8 then
						if not l_pattern.is_void then
							if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_pattern), ce_string ("<buffer>"))) = 0 then
								l_buflocal_buf := (create {P_GLOBALS_STATIC}).curbuf.item
							end
						end
				when 9 then -- loop condition:
						if not (not (l_break) and then (not l_ap___0.is_void)) then
							l_pos := -1 + 18 -- skip loop
						end
				when 10 then -- loop body:
						l_break := False
						if (l_ap___0.item.pat).is_void then
							l_pos := -1 + 17 -- skip if block
						end
				when 11 then -- if:
						if (l_ap___0.item.cmds).is_void then
							l_pos := -1 + 17 -- skip if block
						end
				when 12 then -- if:
						if l_group /= -3 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if l_ap___0.item.group /= l_group then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L:
						if l_pattern.is_void then
							l_retval := 1
							l_break := True
						else
							if l_buflocal_buf.is_void then
								l_tmp___3 := ((strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_ap___0.item.pat), create {CE_INTEGER_8_POINTER}.make_cast (l_pattern))) = 0).to_integer
							else
								l_tmp___3 := (l_ap___0.item.buflocal_nr = l_buflocal_buf.item.b_fnum).to_integer
							end
							if l_tmp___3.to_boolean then
								l_retval := 1
								l_break := True
							end
						end
				when 17 then -- if done | if done | if done
						if not (l_break) then
							l_ap___0 := l_ap___0.item.next
						end
						l_pos := -1 + 9 -- back to loop condition
				when 18 then -- loop done
						l_break := False
				when 19 then -- theend:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_arg_save))
						Result := l_retval
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	match_file_pat (a_pattern: CE_POINTER [NATURAL_8]; a_prog: CE_POINTER [PD_REGPROG_T]; a_fname, a_sfname, a_tail: CE_POINTER [NATURAL_8]; a_allow_dirs: INTEGER_32): INTEGER_32
		local
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_result___2: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_REGMATCH_T]} l_regmatch___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result___2 := 0
					l_regmatch___0.item.rm_ic := 0
					if not a_prog.is_void then
						l_regmatch___0.item.regprog := a_prog
					else
						l_regmatch___0.item.regprog := (create {P_REGEXP_STATIC}).vim_regcomp (a_pattern, 1)
					end
					if (l_regmatch___0.item.regprog).is_void then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if not (a_allow_dirs.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (l_regmatch___0.item.vim_regexec (a_fname, 0)).to_boolean then
							l_result___2 := 1
						elseif not a_sfname.is_void then
							if (l_regmatch___0.item.vim_regexec (a_sfname, 0)).to_boolean then
								l_result___2 := 1
							else
								l_pos := -1 + 4 -- goto _L
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if not a_allow_dirs.to_boolean then
							if (l_regmatch___0.item.vim_regexec (a_tail, 0)).to_boolean then
								l_result___2 := 1
							end
						end
				when 5 then -- if done
					if a_prog.is_void then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_regmatch___0.item.regprog))
					end
					Result := l_result___2
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	match_file_list (a_list, a_sfname, a_ffname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_regpat: CE_POINTER [NATURAL_8]
			l_allow_dirs: CE_ARRAY [INTEGER_8]
			l_match: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<100>>)
			create {CE_INTEGER_8_ARRAY} l_allow_dirs.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			l_tail := (create {P_MISC1_STATIC}).gettail (a_sfname)
			l_p___0.item := a_list
			from
			until
				not (not (l_return or l_break) and then ((l_p___0.item.item).to_boolean))
			loop
				l_break := False;
				(create {P_MISC2_STATIC}).copy_option_part (l_p___0, l_buf___6, 100, ce_string (",")).do_nothing
				l_regpat := file_pat_to_reg_pat (l_buf___6, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_allow_dirs, 0)
				if l_regpat.is_void then
					l_break := True
				end
				if not (l_return or l_break) then
					l_match := match_file_pat (l_regpat, create {CE_CLASS_POINTER [PD_REGPROG_T]}.make_shared (default_pointer), a_ffname, a_sfname, l_tail, (l_allow_dirs.item).to_integer_32);
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_regpat))
					if l_match.to_boolean then
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 0
			end
		end

	file_pat_to_reg_pat (a_pat, a_pat_end: CE_POINTER [NATURAL_8]; a_allow_dirs: CE_POINTER [INTEGER_8]; a_no_bslash: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_pat: CE_POINTER [NATURAL_8]
			l_pat_end: CE_POINTER [NATURAL_8]
			l_size: INTEGER_32
			l_endp: CE_POINTER [NATURAL_8]
			l_reg_pat: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_nested___0: INTEGER_32
			l_add_dollar: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: CE_POINTER [NATURAL_8]
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pat := a_pat
					l_pat_end := a_pat_end
					l_nested___0 := 0
					l_add_dollar := 1
					if not a_allow_dirs.is_void then
						a_allow_dirs[0] := (0).to_integer_8
					end
					if l_pat_end.is_void then
						l_pat_end := l_pat + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_pat))).to_integer_32
					end
					l_size := 2
					l_p___0 := l_pat
				when 1 then -- loop condition:
					if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_pat_end.c_pointer.to_integer_32).to_natural_32) then
						l_pos := -1 + 6 -- skip loop
					end
				when 2 then -- loop body:
						inspect (l_p___0.item).to_integer_32 -- switch 1 head
						when 42 then l_pos := -1 + 3
						when 46 then l_pos := -1 + 3
						when 44 then l_pos := -1 + 3
						when 123 then l_pos := -1 + 3
						when 125 then l_pos := -1 + 3
						when 126 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 3 then -- switch 1, case 42 | switch 1, case 46 | switch 1, case 44 | switch 1, case 123 | switch 1, case 125 | switch 1, case 126
						l_size := l_size + (2)
						l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:
						l_size := l_size + 1
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 0 then
							if ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])) > 1 then
								l_p___0 := l_p___0 + 1
								l_size := l_size + 1
							end
						end
						l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
						l_p___0 := l_p___0 + 1
						l_pos := -1 + 1 -- back to loop condition
				when 6 then -- loop done
					l_reg_pat := (create {P_MISC2_STATIC}).alloc ((l_size + 1).to_natural_32)
					if l_reg_pat.is_void then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 27 -- skip if block
					end
				when 7 then -- if:
						l_i___0 := 0
						if (l_pat[0]).to_integer_32 = 42 then
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_pat[0]).to_integer_32 = 42 then
									if not ((l_pat.c_pointer.to_integer_32).to_natural_32 < ((l_pat_end - 1).c_pointer.to_integer_32).to_natural_32) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_pat := l_pat + 1
								end
							end
							l_break := False
						else
							l_tmp___1 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___1] := (('^').code).to_natural_8
						end
						l_endp := l_pat_end - 1
						if (l_endp.item).to_integer_32 = 42 then
							from
							until
								(l_break)
							loop
								l_break := False
								if l_endp.distance (l_pat) > 0 then
									if (l_endp.item).to_integer_32 /= 42 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_endp := l_endp - 1
								end
							end
							l_break := False
							l_add_dollar := 0
						end
						l_p___0 := l_pat
				when 8 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 26 -- skip loop
						end
				when 9 then -- loop body:
						l_break := False
						if (l_p___0.item).to_boolean then
							if l_nested___0 >= 0 then
								if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 <= (l_endp.c_pointer.to_integer_32).to_natural_32) then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 25 -- skip if block
						end
				when 10 then -- if:
						inspect (l_p___0.item).to_integer_32 -- switch 2 head
						when 42 then l_pos := -1 + 11
						when 46 then l_pos := -1 + 12
						when 126 then l_pos := -1 + 12
						when 63 then l_pos := -1 + 13
						when 92 then l_pos := -1 + 14
						when 123 then l_pos := -1 + 16
						when 125 then l_pos := -1 + 17
						when 44 then l_pos := -1 + 18
						else l_pos := -1 + 19
						end
				when 11 then -- switch 2, case 42
						l_tmp___2 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___2] := (('.').code).to_natural_8
						l_tmp___3 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___3] := (('*').code).to_natural_8
						from
						until
							(l_p___0[1]).to_integer_32 /= 42
						loop
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 24 -- switch 2; break
				when 12 then -- switch 2, case 46 | switch 2, case 126
						l_tmp___4 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___4] := (('\').code).to_natural_8
						l_tmp___5 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___5] := l_p___0.item
						l_pos := -1 + 24 -- switch 2; break
				when 13 then -- switch 2, case 63
						l_tmp___6 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___6] := (('.').code).to_natural_8
						l_pos := -1 + 24 -- switch 2; break
				when 14 then -- switch 2, case 92
						if (l_p___0[1]).to_integer_32 = 0 then
							l_pos := -1 + 24 -- switch 2; break
						end
				when 15 then
						l_p___0 := l_p___0 + 1
						if (l_p___0.item).to_integer_32 = 63 then
							l_tmp___7 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___7] := (('?').code).to_natural_8
						elseif (l_p___0.item).to_integer_32 = 44 then
							l_tmp___8 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___8] := l_p___0.item
						elseif (l_p___0.item).to_integer_32 = 37 then
							l_tmp___8 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___8] := l_p___0.item
						elseif (l_p___0.item).to_integer_32 = 35 then
							l_tmp___8 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___8] := l_p___0.item
						elseif (l_p___0.item).to_integer_32 = 32 then
							l_tmp___8 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___8] := l_p___0.item
						else
							if not a_allow_dirs.is_void then
								if ((create {P_MISC1_STATIC}).vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
									a_allow_dirs[0] := (1).to_integer_8
								end
							end
							l_tmp___10 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___10] := (('\').code).to_natural_8
							l_tmp___11 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___11] := l_p___0.item
						end
						l_pos := -1 + 24 -- switch 2; break
				when 16 then -- switch 2, case 123
						l_tmp___12 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___12] := (('\').code).to_natural_8
						l_tmp___13 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___13] := (('(').code).to_natural_8
						l_nested___0 := l_nested___0 + 1
						l_pos := -1 + 24 -- switch 2; break
				when 17 then -- switch 2, case 125
						l_tmp___14 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___14] := (('\').code).to_natural_8
						l_tmp___15 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___15] := ((')').code).to_natural_8
						l_nested___0 := l_nested___0 - 1
						l_pos := -1 + 24 -- switch 2; break
				when 18 then -- switch 2, case 44
						if l_nested___0.to_boolean then
							l_tmp___16 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___16] := (('\').code).to_natural_8
							l_tmp___17 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___17] := (('|').code).to_natural_8
						else
							l_tmp___18 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___18] := ((',').code).to_natural_8
						end
						l_pos := -1 + 24 -- switch 2; break
				when 19 then -- switch 2, default:
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])) > 1 then
							l_tmp___19 := l_i___0
							l_i___0 := l_i___0 + 1
							l_tmp___20 := l_p___0
							l_p___0 := l_p___0 + 1
							l_reg_pat[l_tmp___19] := l_tmp___20.item
						else
							l_pos := -1 + 22 -- goto _L
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else: | _L:
						if not a_allow_dirs.is_void then
							if ((create {P_MISC1_STATIC}).vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
								a_allow_dirs[0] := (1).to_integer_8
							end
						end
				when 23 then
						l_tmp___23 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___23] := l_p___0.item
						l_pos := -1 + 24 -- switch 2; break
				when 24 then -- switch 2, done:
						l_p___0 := l_p___0 + 1
				when 25 then -- if done
						l_pos := -1 + 8 -- back to loop condition
				when 26 then -- loop done
						l_break := False
						if l_add_dollar.to_boolean then
							l_tmp___24 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___24] := (('$').code).to_natural_8
						end
						l_reg_pat[l_i___0] := (('%/0/').code).to_natural_8
						if l_nested___0 /= 0 then
							if l_nested___0 < 0 then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E219: Missing {."))))).do_nothing
							else
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E220: Missing }."))))).do_nothing
							end
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_reg_pat))
							l_reg_pat := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
						Result := l_reg_pat
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	ex_doautoall_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_doautoall)
		end

	getnextac_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent getnextac)
		end

	get_augroup_name_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent get_augroup_name)
		end

	get_event_name_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent get_event_name)
		end

end
