class
	P_OS_UNIX_STATIC

inherit
	CE_UTILITIES
	S_UNISTD_STATIC
	S_SYS_SYSINFO_STATIC
	S_SYS_RESOURCE_STATIC
	S_TIME_STATIC
	S_SIGNAL_STATIC
	S_STDLIB_STATIC
	S_LIBINTL_STATIC
	S_STDIO_STATIC
	S_X11_XLIB_STATIC
	S_SYS_TIME_STATIC
	S_STRING_STATIC
	S_X11_XUTIL_STATIC
	S_PWD_STATIC
	S_SYS_UTSNAME_STATIC
	S_BITS_ERRNO_STATIC
	S_FCNTL_STATIC
	S_SYS_STAT_STATIC
	S_TERMIOS_STATIC
	S_SYS_IOCTL_STATIC
	S_SYS_WAIT_STATIC
	S_SYS_SELECT_STATIC
	S_DLFCN_STATIC
	S_X11_INTRINSIC_STATIC
	S_X11_SHELL_STATIC
	S_X11_STRINGDEFS_STATIC
	S_X11_SM_SMLIB_STATIC
	S_X11_ICE_ICELIB_STATIC
	VIM_ASSEMBLER

feature {ANY} -- public attributes

	xterm_Shell: CE_STATIC [CE_POINTER [ANY]]
		once ("PROCESS")
			Result.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
		end

	x11_window: CE_STATIC [CE_ARRAY [NATURAL_32]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_32_ARRAY}.make_initialized (<<
					(0).to_natural_32
				>>)
		end

	x11_display: CE_STATIC [CE_ARRAY [CE_POINTER [ANY]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [ANY]}.make_initialized (<<
					create {CE_VOID_POINTER}.make_shared (default_pointer)
				>>)
		end

	oldtitle: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	did_set_title___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	oldicon: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	did_set_icon: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	do_resize: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	extra_shell_arg: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	show_shell_mess: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 1
		end

	deadly_signal: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	in_mch_delay: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	curr_tmode: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	xsmp: CE_STATIC [CE_ARRAY [PD_XSMP_CONFIG_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_XSMP_CONFIG_T]}.make (<<1>>)
		end

	signal_info: CE_STATIC [CE_ARRAY [PD_SIGNALINFO]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_SIGNALINFO]}.make_initialized (<<
					create {PD_SIGNALINFO}.make_initialized ([1, ce_string ("HUP"), (1).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([3, ce_string ("QUIT"), (1).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([4, ce_string ("ILL"), (1).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([5, ce_string ("TRAP"), (1).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([6, ce_string ("ABRT"), (1).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([8, ce_string ("FPE"), (1).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([7, ce_string ("BUS"), (1).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([11, ce_string ("SEGV"), (1).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([31, ce_string ("SYS"), (1).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([14, ce_string ("ALRM"), (0).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([15, ce_string ("TERM"), (1).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([26, ce_string ("VTALRM"), (1).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([27, ce_string ("PROF"), (1).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([24, ce_string ("XCPU"), (1).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([25, ce_string ("XFSZ"), (1).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([10, ce_string ("USR1"), (1).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([12, ce_string ("USR2"), (1).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([2, ce_string ("INT"), (0).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([28, ce_string ("WINCH"), (0).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([20, ce_string ("TSTP"), (0).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([13, ce_string ("PIPE"), (0).to_integer_8]),
					create {PD_SIGNALINFO}.make_initialized ([-1, ce_string ("Unknown!"), (0).to_integer_8])
				>>)
		end

	sigstk: CE_STATIC [CE_ARRAY [SD_SIGALTSTACK]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [SD_SIGALTSTACK]}.make (<<1>>)
		end

	signal_stack: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	entered___2: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	sigcont_received: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	got_signal: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	blocked: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 1
		end

	got_x_error___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	result2: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	x11_display_from: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	did_set_error_handler: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	recursive___3: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	dont_fchdir: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	first: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 1
		end

	told: CE_STATIC [CE_ARRAY [SD_TERMIOS]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [SD_TERMIOS]}.make (<<1>>)
		end

	ison: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	busy___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	did_find_nul: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	sh_vimglob_func: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("vimglob() { while [ $# -ge 1 ]; do echo %"$1%"; shift; done }; vimglob >")
		end

	xterm_trace: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	xterm_button: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	mouse_code: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	mouse_name: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					251, (('X').code).to_natural_8
				>>)
		end

	prev_row: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	prev_col: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	xterm_hints: CE_STATIC [CE_ARRAY [SD_XSIZEHINTS]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [SD_XSIZEHINTS]}.make (<<1>>)
		end

	dummy: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

feature {ANY} -- public routines

	mch_chdir (a_path: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_path.is_void
		do
			if (create {P_OPTION_STATIC}).p_verbose.item.item >= 5 then
				(create {P_MESSAGE_STATIC}).verbose_enter;
				(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("chdir(%%s)")), a_path]).do_nothing;
				(create {P_MESSAGE_STATIC}).verbose_leave
			end
			Result := (chdir (a_path))
		end

	mch_write (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		do
			(create {P_GLOBALS_STATIC}).ignored.item := (write (1, create {CE_VOID_POINTER}.make_cast (a_s), a_len.to_natural_32))
			if ((create {P_OPTION_STATIC}).p_wd.item.item).to_boolean then
				RealWaitForChar ((create {P_GLOBALS_STATIC}).read_cmd_fd.item, (create {P_OPTION_STATIC}).p_wd.item.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing
			end
		end

	mch_inchar (a_buf___6: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32; a_wtime: INTEGER_32; a_tb_change_cnt: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			(create {P_NETBEANS_STATIC}).netbeans_parse_messages
			from
			until
				not (do_resize.item.to_boolean)
			loop
				handle_resize
			end
			if a_wtime >= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if (WaitForChar (a_wtime)) /= 0 then
						l_break := True
					end
					if not (l_return or l_break) then
						if not do_resize.item.to_boolean then
							Result := 0
							l_return := True
						end
						if not l_return then
							handle_resize;
							(create {P_NETBEANS_STATIC}).netbeans_parse_messages
						end
					end
				end
				if not l_return then
					l_break := False
				end
			elseif (WaitForChar ((create {P_OPTION_STATIC}).p_ut.item.item)) = 0 then
				if ((create {P_FILEIO_STATIC}).trigger_cursorhold).to_boolean then
					if a_maxlen >= 3 then
						if not ((create {P_GETCHAR_STATIC}).typebuf_changed (a_tb_change_cnt)).to_boolean then
							a_buf___6[0] := (128).to_natural_8
							a_buf___6[1] := (253).to_natural_8
							a_buf___6[2] := (96).to_natural_8
							Result := 3
							l_return := True
						end
					end
				end
				if not l_return then
					(create {P_GETCHAR_STATIC}).before_blocking
				end
			end
			if not l_return then
				from
				until
					(l_return)
				loop
					from
					until
						not (do_resize.item.to_boolean)
					loop
						handle_resize
					end
					(create {P_NETBEANS_STATIC}).netbeans_parse_messages
					if (WaitForChar (-1)) = 0 then
						if do_resize.item.to_boolean then
							handle_resize
						end
						Result := 0
						l_return := True
					end
					if not l_return then
						if ((create {P_GETCHAR_STATIC}).typebuf_changed (a_tb_change_cnt)).to_boolean then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_len := (create {P_UI_STATIC}).read_from_input_buf (a_buf___6, a_maxlen.to_integer_32)
						if l_len > 0 then
							Result := l_len
							l_return := True
						end
					end
				end
			end
		end

	handle_resize
		do
			do_resize.item := 0;
			(create {P_TERM_STATIC}).shell_resized
		end

	mch_char_avail: INTEGER_32
		do
			Result := (WaitForChar (0))
		end

	mch_total_mem (a_special: INTEGER_32): NATURAL_32
		local
			l_mem: NATURAL_32
			l_shiftright: NATURAL_32
			l_sinfo: CE_ARRAY [SD_SYSINFO]
			l_pagesize: INTEGER_32
			l_pagecount: INTEGER_32
			l_rlp: CE_ARRAY [SD_RLIMIT]
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_SYSINFO]} l_sinfo.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_RLIMIT]} l_rlp.make (<<1>>)

			l_mem := (0).to_natural_32
			l_shiftright := (10).to_natural_32
			if l_mem = {NATURAL_32} 0 then
				if (sysinfo (l_sinfo)) = 0 then
					from
					until
						(l_break)
					loop
						l_break := False
						if l_shiftright > {NATURAL_32} 0 then
							if ((l_sinfo.item.mem_unit).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_sinfo.item.mem_unit := (l_sinfo.item.mem_unit).bit_shift_right ((1))
							l_shiftright := l_shiftright - 1
						end
					end
					l_break := False
					l_mem := l_sinfo.item.totalram * (l_sinfo.item.mem_unit).to_natural_32
				end
			end
			if l_mem = {NATURAL_32} 0 then
				l_pagesize := sysconf (30)
				l_pagecount := sysconf (85)
				if l_pagesize > 0 then
					if l_pagecount > 0 then
						from
						until
							(l_break)
						loop
							l_break := False
							if l_shiftright > {NATURAL_32} 0 then
								if ((l_pagesize).bit_and (1)) /= 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_pagesize := ((l_pagesize.to_natural_32).bit_shift_right (1)).to_integer_32
								l_shiftright := l_shiftright - 1
							end
						end
						l_break := False
						l_mem := l_pagesize.to_natural_32 * l_pagecount.to_natural_32
					end
				end
			end
			if (getrlimit ({SC_RLIMIT_RESOURCE}.RLIMIT_DATA, l_rlp)) = 0 then
				if l_rlp.item.rlim_cur < ({NATURAL_32} 1).bit_shift_left (({PLATFORM}.Natural_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1).to_integer_32) then
					if l_rlp.item.rlim_cur /= {NATURAL_32} 4_294_967_295 then
						if (l_rlp.item.rlim_cur).bit_shift_right (10) < (l_mem).bit_shift_right (l_shiftright.to_integer_32) then
							l_mem := l_rlp.item.rlim_cur
							l_shiftright := (10).to_natural_32
						end
					end
				end
			end
			if l_mem > {NATURAL_32} 0 then
				Result := ((l_mem).bit_shift_right (l_shiftright.to_integer_32))
				l_return := True
			end
			if not l_return then
				Result := (2_097_151).to_natural_32
			end
		end

	mch_delay (a_msec: INTEGER_32; a_ignoreinput: INTEGER_32)
		local
			l_old_tmode: INTEGER_32
			l_ts: CE_ARRAY [SD_TIMESPEC]
		do
			create {CE_CLASS_ARRAY [SD_TIMESPEC]} l_ts.make (<<1>>)

			if a_ignoreinput.to_boolean then
				in_mch_delay.item := 1
				l_old_tmode := curr_tmode.item
				if curr_tmode.item = 2 then
					(create {P_TERM_STATIC}).settmode (1)
				end
				l_ts.item.tv_sec := a_msec // 1_000
				l_ts.item.tv_nsec := (a_msec \\ 1_000) * 1_000_000
				nanosleep (l_ts, create {CE_CLASS_POINTER [SD_TIMESPEC]}.make_shared (default_pointer)).do_nothing;
				(create {P_TERM_STATIC}).settmode (l_old_tmode)
				in_mch_delay.item := 0
			else
				WaitForChar (a_msec).do_nothing
			end
		end

	init_signal_stack
		do
			if not signal_stack.item.is_void then
				sigstk.item.item.ss_sp := create {CE_VOID_POINTER}.make_cast (signal_stack.item)
				sigstk.item.item.ss_size := (8_192).to_natural_32
				sigstk.item.item.ss_flags := 0
				sigaltstack (sigstk.item, create {CE_CLASS_POINTER [SD_SIGALTSTACK]}.make_shared (default_pointer)).do_nothing
			end
		end

	sig_winch (a_sigarg: INTEGER_32)
		do
			sigset (28, (sig_winch_address)).do_nothing
			do_resize.item := 1
		end

	catch_sigint (a_sigarg: INTEGER_32)
		do
			sigset (2, (catch_sigint_address)).do_nothing;
			(create {P_GLOBALS_STATIC}).got_int.item := 1
		end

	catch_sigpwr (a_sigarg: INTEGER_32)
		do
			sigset (30, (catch_sigpwr_address)).do_nothing;
			(create {P_MEMLINE_STATIC}).ml_sync_all (0, 0)
		end

	mch_startjmp
		do
			(create {P_GLOBALS_STATIC}).lc_signal.item := 0;
			(create {P_GLOBALS_STATIC}).lc_active.item := 1
		end

	mch_endjmp
		do
			(create {P_GLOBALS_STATIC}).lc_active.item := 0
		end

	mch_didjmp
		do
			init_signal_stack
		end

	deathtrap (a_sigarg: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_GLOBALS_STATIC}).lc_active.item).to_boolean then
						(create {P_GLOBALS_STATIC}).lc_signal.item := a_sigarg;
						(create {P_GLOBALS_STATIC}).lc_active.item := 0;
						(create {P_GLOBALS_STATIC}).lc_jump_env.item.raise (1)
					end
					if in_mch_delay.item.to_boolean then
						if a_sigarg = 3 then
							l_return := True
						end
					end
					if not (not l_return and then (entered___2.item = 0)) then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						if a_sigarg /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 4 then -- else:
						if a_sigarg /= 3 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 7 then -- else:
						if a_sigarg /= 15 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 10 then -- else:
						if a_sigarg /= 30 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 13 then -- else:
						if a_sigarg /= 10 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if a_sigarg /= 12 then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L:
						if not (vim_handle_signal (a_sigarg)).to_boolean then
							l_return := True
						end
				when 18 then -- if done | if done | if done | if done | if done | if done
					if not l_return then
						entered___2.item := entered___2.item + 1;
						(create {P_EVAL_STATIC}).set_vim_var_nr (28, entered___2.item.to_integer_32)
						l_i___0 := 0
						from
						until
							not (not (l_break) and then (signal_info.item[l_i___0].sig /= -1))
						loop
							l_break := False
							if a_sigarg = signal_info.item[l_i___0].sig then
								l_break := True
							end
							if not (l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						deadly_signal.item := a_sigarg;
						(create {P_GLOBALS_STATIC}).full_screen.item := 0
						if entered___2.item >= 3 then
							reset_signals
							may_core_dump
							if entered___2.item >= 4 then
								exit2 (8)
							end
							exit (7)
						end
						if entered___2.item = 2 then
							(create {P_TERM_STATIC}).out_str (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Vim: Double signal, exiting%N")))));
							(create {P_TERM_STATIC}).out_flush;
							(create {P_MAIN_STATIC}).getout (1)
						end
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("Vim: Caught deadly signal %%s%N"))), signal_info.item[l_i___0].name]).do_nothing;
						(create {P_MISC1_STATIC}).preserve_exit
					end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	sigcont_handler (a_sigarg: INTEGER_32)
		do
			sigcont_received.item := 1
		end

	mch_suspend
		local
			l_wait_time: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:;
					(create {P_TERM_STATIC}).out_flush;
					(create {P_TERM_STATIC}).settmode (0);
					(create {P_TERM_STATIC}).out_flush
					if not (((create {P_GLOBALS_STATIC}).clip_star.item.item.owned).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (((create {P_GLOBALS_STATIC}).clip_plus.item.item.owned).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:;
						(create {P_OPS_STATIC}).x11_export_final_selection
						if ((create {P_GLOBALS_STATIC}).clip_star.item.item.owned).to_boolean then
							((create {P_GLOBALS_STATIC}).clip_star.item).item.clip_lose_selection
						end
						if ((create {P_GLOBALS_STATIC}).clip_plus.item.item.owned).to_boolean then
							((create {P_GLOBALS_STATIC}).clip_plus.item).item.clip_lose_selection
						end
						if not (x11_display.item.item).is_void then
							XFlush (x11_display.item.item).do_nothing
						end
				when 5 then -- if done
					sigcont_received.item := 0
					kill (0, 20).do_nothing
					l_wait_time := 0
					from
					until
						(l_break)
					loop
						l_break := False
						if not sigcont_received.item.to_boolean then
							if not (l_wait_time <= 3) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							mch_delay (l_wait_time, 0)
							l_wait_time := l_wait_time + 1
						end
					end
					l_break := False;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (oldtitle.item))
					oldtitle.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
					(create {P_TERM_STATIC}).settmode (2);
					(create {P_GLOBALS_STATIC}).need_check_timestamps.item := 1;
					(create {P_GLOBALS_STATIC}).did_check_timestamps.item := 0
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mch_init
		do
			(create {P_GLOBALS_STATIC}).Columns.item.item := 80;
			(create {P_GLOBALS_STATIC}).Rows.item.item := 24;
			(create {P_TERM_STATIC}).out_flush
			set_signals
		end

	set_signals
		local
			l_tmp: CE_ROUTINE
		do
			sigset (28, (sig_winch_address)).do_nothing
			if ((create {P_GLOBALS_STATIC}).restricted.item).to_boolean then
				l_tmp := create {CE_ROUTINE}.make_shared (default_pointer + 1)
			else
				l_tmp := create {CE_ROUTINE}.make_shared (default_pointer)
			end
			sigset (20, l_tmp).do_nothing
			sigset (18, sigcont_handler_address).do_nothing
			sigset (13, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
			catch_int_signal
			sigset (14, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
			sigset (30, (catch_sigpwr_address)).do_nothing
			catch_signals ((deathtrap_address), create {CE_ROUTINE}.make_shared (default_pointer + -1))
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				sigset (1, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
			end
		end

	catch_int_signal
		do
			sigset (2, (catch_sigint_address)).do_nothing
		end

	reset_signals
		do
			catch_signals (create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer))
			sigset (18, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
		end

	catch_signals (a_func_deadly, a_func_other: CE_ROUTINE)
		local
			l_i___0: INTEGER_32
			l_sa: CE_ARRAY [SD_SIGACTION]
		do
			create {CE_CLASS_ARRAY [SD_SIGACTION]} l_sa.make (<<1>>)

			l_i___0 := 0
			from
			until
				signal_info.item[l_i___0].sig = -1
			loop
				if (signal_info.item[l_i___0].deadly).to_boolean then
					l_sa.item.sigaction_handler.sa_handler := a_func_deadly
					sigemptyset (create {CE_CLASS_POINTER [SD_SIGSET_T]}.make_shared (l_sa.item.c_pointer + (create {SD_SIGACTION}.make).offset_of ("sa_mask"))).do_nothing
					l_sa.item.sa_flags := 0
					sigaction (signal_info.item[l_i___0].sig, l_sa, create {CE_CLASS_POINTER [SD_SIGACTION]}.make_shared (default_pointer)).do_nothing
				elseif (a_func_other.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_ROUTINE}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
					sigset (signal_info.item[l_i___0].sig, a_func_other).do_nothing
				end
				l_i___0 := l_i___0 + 1
			end
		end

	vim_handle_signal (a_sig: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_sig -- switch 1 head
					when -1 then l_pos := -1 + 1 -- -1
					when -2 then l_pos := -1 + 2 -- -2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case -1
					blocked.item := 1
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case -2
					blocked.item := 0
					if got_signal.item /= 0 then
						kill ((getpid), got_signal.item).do_nothing
						got_signal.item := 0
					end
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					if not blocked.item.to_boolean then
						Result := 1
						l_return := True
					end
					if not l_return then
						got_signal.item := a_sig
						if a_sig /= 30 then
							(create {P_GLOBALS_STATIC}).got_int.item := 1
						end
					end
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					if not l_return then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mch_check_win (a_argc: INTEGER_32; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (isatty (1)).to_boolean then
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	mch_input_isatty: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (isatty ((create {P_GLOBALS_STATIC}).read_cmd_fd.item)).to_boolean then
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	xopen_message (a_tvp: CE_POINTER [SD_TIMEVAL])
		require
			not a_tvp.is_void
		local
			l_end_tv: CE_ARRAY [SD_TIMEVAL]
		do
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_end_tv.make (<<1>>)

			gettimeofday (l_end_tv, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing;
			(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Opening the X display took %%ld msec")))), (l_end_tv.item.tv_sec - a_tvp.item.tv_sec) * 1_000 + (l_end_tv.item.tv_usec - a_tvp.item.tv_usec) // 1_000]).do_nothing
		end

	x_error_handler (a_dpy: CE_POINTER [ANY]; a_error_event: CE_POINTER [SD_XERROREVENT]): INTEGER_32
		require
			not a_error_event.is_void
		do
			XGetErrorText (a_dpy, (a_error_event.item.error_code).to_integer_32, create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), 1_025).do_nothing
			strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("%NVim: Got X error%N")))).do_nothing;
			(create {P_MISC1_STATIC}).preserve_exit
			Result := 0
		end

	x_error_check___0 (a_dpy: CE_POINTER [ANY]; a_error_event: CE_POINTER [SD_XERROREVENT]): INTEGER_32
		do
			got_x_error___0.item := 1
			Result := 0
		end

	x_IOerror_check (a_dpy: CE_POINTER [ANY]): INTEGER_32
		do
			(create {P_GLOBALS_STATIC}).lc_jump_env.item.raise (1)
		end

	x_IOerror_handler (a_dpy: CE_POINTER [ANY]): INTEGER_32
		do
			(create {P_GLOBALS_STATIC}).xterm_dpy.item.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
			x11_window.item.item := (0).to_natural_32
			x11_display.item.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
			xterm_Shell.item := create {CE_VOID_POINTER}.make_shared (default_pointer);
			(create {P_GLOBALS_STATIC}).x_jump_env.item.raise (1)
		end

	x_connect_to_server: INTEGER_32
		local
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_REGMATCH_T]} l_regmatch___0.make (<<1>>)

			if ((create {P_GLOBALS_STATIC}).x_force_connect.item).to_boolean then
				Result := 1
				l_return := True
			end
			if not l_return and then (((create {P_GLOBALS_STATIC}).x_no_connect.item).to_boolean) then
				Result := 0
				l_return := True
			end
			if not l_return and then (not ((create {P_GLOBALS_STATIC}).clip_exclude_prog.item).is_void) then
				l_regmatch___0.item.rm_ic := 0
				l_regmatch___0.item.regprog := (create {P_GLOBALS_STATIC}).clip_exclude_prog.item
				if (l_regmatch___0.item.vim_regexec ((create {P_TERM_STATIC}).term_strings.item[0], 0)).to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := 1
			end
		end

	test_x11_window (a_dpy: CE_POINTER [ANY]): INTEGER_32
		local
			l_old_handler: CE_ROUTINE
			l_text_prop: CE_ARRAY [SD_XTEXTPROPERTY]
			l_tmp___2: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_XTEXTPROPERTY]} l_text_prop.make (<<1>>)

			l_old_handler := (XSetErrorHandler (x_error_check___0_address))
			got_x_error___0.item := 0
			if (XGetWMName (a_dpy, x11_window.item.item, l_text_prop)).to_boolean then
				XFree (create {CE_VOID_POINTER}.make_cast (l_text_prop.item.value)).do_nothing
			end
			XSync (a_dpy, 0).do_nothing
			XSetErrorHandler (l_old_handler).do_nothing
			if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
				if got_x_error___0.item.to_boolean then
					(create {P_MESSAGE_STATIC}).verb_msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Testing the X display failed"))))).do_nothing
				end
			end
			if got_x_error___0.item.to_boolean then
				l_tmp___2 := 0
			else
				l_tmp___2 := 1
			end
			Result := l_tmp___2
		end

	get_x11_windis: INTEGER_32
		local
			l_winid: CE_POINTER [INTEGER_8]
			l_start_tv: CE_ARRAY [SD_TIMEVAL]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_start_tv.make (<<1>>)

			if not did_set_error_handler.item.to_boolean then
				XSetErrorHandler (x_error_handler_address).do_nothing
				did_set_error_handler.item := 1
			end
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				if x11_display_from.item = 1 then
					if not (x11_display.item.item).is_void then
						XCloseDisplay (x11_display.item.item).do_nothing
						x11_display_from.item := 0
					end
				end
				if ((create {P_GUI_GTK_X11_STATIC}).gui_get_x11_windis (x11_window.item, x11_display.item)) = 1 then
					x11_display_from.item := 2
					Result := 1
					l_return := True
				end
				if not l_return then
					x11_display.item.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
					Result := 0
					l_return := True
				end
			elseif x11_display_from.item = 2 then
				x11_window.item.item := (0).to_natural_32
				x11_display.item.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
				x11_display_from.item := 0
			end
			if not l_return then
				if not (x_connect_to_server).to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if x11_window.item.item = {NATURAL_32} 0 then
					l_winid := getenv (ce_string ("WINDOWID"))
					if not l_winid.is_void then
						x11_window.item.item := (atol (l_winid)).to_natural_32
					end
				end
				if not ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item).is_void then
					if x11_window.item.item /= {NATURAL_32} 0 then
						if x11_display_from.item /= 3 then
							if x11_display_from.item = 1 then
								if not (x11_display.item.item).is_void then
									XCloseDisplay (x11_display.item.item).do_nothing
								end
							end
							x11_display.item.item := (create {P_GLOBALS_STATIC}).xterm_dpy.item.item
							x11_display_from.item := 3
						end
						if (test_x11_window (x11_display.item.item)) = 0 then
							x11_window.item.item := (0).to_natural_32
							x11_display.item.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
							x11_display_from.item := 0
							Result := 0
							l_return := True
						end
						if not l_return then
							Result := 1
							l_return := True
						end
					end
				end
			end
			if not l_return then
				if x11_window.item.item = {NATURAL_32} 0 then
					result2.item := -1
				elseif (x11_display.item.item).is_void then
					result2.item := -1
				end
				if result2.item /= -1 then
					Result := result2.item
					l_return := True
				end
			end
			if not l_return then
				if x11_window.item.item /= {NATURAL_32} 0 then
					if (x11_display.item.item).is_void then
						if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
							gettimeofday (l_start_tv, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
						end
						x11_display.item.item := XOpenDisplay (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
						if not (x11_display.item.item).is_void then
							if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
								(create {P_MESSAGE_STATIC}).verbose_enter
								xopen_message (l_start_tv);
								(create {P_MESSAGE_STATIC}).verbose_leave
							end
							if (test_x11_window (x11_display.item.item)) = 0 then
								x11_window.item.item := (0).to_natural_32
								XCloseDisplay (x11_display.item.item).do_nothing
								x11_display.item.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
							else
								x11_display_from.item := 1
							end
						end
					end
				end
				if x11_window.item.item = {NATURAL_32} 0 then
					result2.item := 0
					Result := result2.item
					l_return := True
				elseif (x11_display.item.item).is_void then
					result2.item := 0
					Result := result2.item
					l_return := True
				end
			end
			if not l_return then
				result2.item := 1
				Result := result2.item
			end
		end

	get_x11_title (a_test_only: INTEGER_32): INTEGER_32
		do
			Result := (get_x11_thing (1, a_test_only))
		end

	get_x11_icon (a_test_only: INTEGER_32): INTEGER_32
		local
			l_retval: INTEGER_32
		do
			l_retval := 0
			l_retval := get_x11_thing (0, a_test_only)
			if oldicon.item.is_void then
				if not a_test_only.to_boolean then
					if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_TERM_STATIC}).term_strings.item[0]), ce_string ("builtin_"), (8).to_natural_32)) = 0 then
						oldicon.item := (create {P_MISC2_STATIC}).vim_strsave ((create {P_TERM_STATIC}).term_strings.item[0] + 8)
					else
						oldicon.item := (create {P_MISC2_STATIC}).vim_strsave ((create {P_TERM_STATIC}).term_strings.item[0])
					end
				end
			end
			Result := l_retval
		end

	get_x11_thing (a_get_title, a_test_only: INTEGER_32): INTEGER_32
		local
			l_text_prop: CE_ARRAY [SD_XTEXTPROPERTY]
			l_retval: INTEGER_32
			l_status: INTEGER_32
			l_root: CE_ARRAY [NATURAL_32]
			l_parent: CE_ARRAY [NATURAL_32]
			l_win: NATURAL_32
			l_children: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_num_children: CE_ARRAY [NATURAL_32]
			l_cl: CE_ARRAY [CE_POINTER [CE_POINTER [INTEGER_8]]]
			l_transform_status: INTEGER_32
			l_n: CE_ARRAY [INTEGER_32]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_XTEXTPROPERTY]} l_text_prop.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_root.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_parent.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_children.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_num_children.make (<<1>>)
			create {CE_POINTER_ARRAY [CE_POINTER [INTEGER_8]]} l_cl.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_n.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := 0
					if (get_x11_windis) /= 1 then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if a_get_title.to_boolean then
							l_status := XGetWMName (x11_display.item.item, x11_window.item.item, l_text_prop)
						else
							l_status := XGetWMIconName (x11_display.item.item, x11_window.item.item, l_text_prop)
						end
						l_win := x11_window.item.item
						from
						until
							(l_break)
						loop
							l_break := False
							if l_status.to_boolean then
								if not ((l_text_prop.item.value).is_void) then
									l_break := True
								end
							end
							if not (l_break) then
								if not (XQueryTree (x11_display.item.item, l_win, l_root, l_parent, l_children, l_num_children)).to_boolean then
									l_break := True
								end
							end
							if not (l_break) then
								if (not (l_children.item).is_void) then
									XFree (create {CE_VOID_POINTER}.make_cast (l_children.item)).do_nothing
								end
								if l_parent.item = l_root.item then
									l_break := True
								elseif l_parent.item = {NATURAL_32} 0 then
									l_break := True
								end
							end
							if not (l_break) then
								l_win := l_parent.item
								if a_get_title.to_boolean then
									l_status := XGetWMName (x11_display.item.item, l_win, l_text_prop)
								else
									l_status := XGetWMIconName (x11_display.item.item, l_win, l_text_prop)
								end
							end
						end
						l_break := False
						if not (l_status.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 2 then -- if:
						if (l_text_prop.item.value).is_void then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if:
						l_retval := 1
						if a_test_only.to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						if l_text_prop.item.encoding /= {NATURAL_32} 31 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							if a_get_title.to_boolean then
								oldtitle.item := (create {P_MISC2_STATIC}).vim_strsave (l_text_prop.item.value)
							else
								oldicon.item := (create {P_MISC2_STATIC}).vim_strsave (l_text_prop.item.value)
							end
						else
							l_pos := -1 + 7 -- goto _L___1
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else: | _L___1:
						l_n.item := 0
						l_transform_status := XmbTextPropertyToTextList (x11_display.item.item, l_text_prop, l_cl, l_n)
						if not (l_transform_status >= 0) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_n.item > 0 then
							if (not (l_cl.item[0]).is_void) then
								if a_get_title.to_boolean then
									oldtitle.item := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (l_cl.item[0]))
								else
									oldicon.item := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (l_cl.item[0]))
								end
								XFreeStringList (l_cl.item)
							else
								l_pos := -1 + 10 -- goto _L___0
							end
						else
							l_pos := -1 + 10 -- goto _L___0
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___0:
						if a_get_title.to_boolean then
							oldtitle.item := (create {P_MISC2_STATIC}).vim_strsave (l_text_prop.item.value)
						else
							oldicon.item := (create {P_MISC2_STATIC}).vim_strsave (l_text_prop.item.value)
						end
				when 11 then -- if done | if done
						XFree (create {CE_VOID_POINTER}.make_cast (l_text_prop.item.value)).do_nothing
				when 12 then -- if done | if done | if done
					Result := l_retval
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_x11_title (a_title: CE_POINTER [NATURAL_8])
		local
			l_text_prop: CE_ARRAY [SD_XTEXTPROPERTY]
			l_c_title: CE_ARRAY [CE_POINTER [INTEGER_8]]
		do
			create {CE_CLASS_ARRAY [SD_XTEXTPROPERTY]} l_text_prop.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_c_title.make (<<1>>)

			if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
				Xutf8SetWMProperties (x11_display.item.item, x11_window.item.item, create {CE_INTEGER_8_POINTER}.make_cast (a_title), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 0, create {CE_CLASS_POINTER [SD_XSIZEHINTS]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_XWMHINTS]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_XCLASSHINT]}.make_shared (default_pointer))
			else
				l_c_title.item := create {CE_INTEGER_8_POINTER}.make_cast (a_title)
				XStringListToTextProperty (l_c_title, 1, l_text_prop).do_nothing
				XSetWMProperties (x11_display.item.item, x11_window.item.item, l_text_prop, create {CE_CLASS_POINTER [SD_XTEXTPROPERTY]}.make_shared (default_pointer), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 0, create {CE_CLASS_POINTER [SD_XSIZEHINTS]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_XWMHINTS]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_XCLASSHINT]}.make_shared (default_pointer))
			end
			XFlush (x11_display.item.item).do_nothing
		end

	set_x11_icon (a_icon: CE_POINTER [NATURAL_8])
		local
			l_text_prop: CE_ARRAY [SD_XTEXTPROPERTY]
			l_c_icon: CE_ARRAY [CE_POINTER [INTEGER_8]]
		do
			create {CE_CLASS_ARRAY [SD_XTEXTPROPERTY]} l_text_prop.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_c_icon.make (<<1>>)

			if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
				Xutf8SetWMProperties (x11_display.item.item, x11_window.item.item, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), create {CE_INTEGER_8_POINTER}.make_cast (a_icon), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 0, create {CE_CLASS_POINTER [SD_XSIZEHINTS]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_XWMHINTS]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_XCLASSHINT]}.make_shared (default_pointer))
			else
				l_c_icon.item := create {CE_INTEGER_8_POINTER}.make_cast (a_icon)
				XStringListToTextProperty (l_c_icon, 1, l_text_prop).do_nothing
				XSetWMProperties (x11_display.item.item, x11_window.item.item, create {CE_CLASS_POINTER [SD_XTEXTPROPERTY]}.make_shared (default_pointer), l_text_prop, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 0, create {CE_CLASS_POINTER [SD_XSIZEHINTS]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_XWMHINTS]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_XCLASSHINT]}.make_shared (default_pointer))
			end
			XFlush (x11_display.item.item).do_nothing
		end

	mch_can_restore_title: INTEGER_32
		do
			Result := (get_x11_title (1))
		end

	mch_can_restore_icon: INTEGER_32
		do
			Result := (get_x11_icon (1))
		end

	mch_settitle (a_title, a_icon: CE_POINTER [NATURAL_8])
		local
			l_type: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_type := 0
					if ((create {P_TERM_STATIC}).term_strings.item[0]).is_void then
						l_return := True
					end
					if not l_return and then (a_title.is_void) then
						if a_icon.is_void then
							l_return := True
						end
					end
					if not l_return and then (recursive___3.item.to_boolean) then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						recursive___3.item := recursive___3.item + 1
						if (get_x11_windis) = 1 then
							l_type := 1
						end
						if not (l_type.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (((create {P_TERM_STATIC}).term_strings.item[48]).item).to_integer_32 = 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if not a_title.is_void then
							if oldtitle.item.is_void then
								if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
									get_x11_title (0).do_nothing
								end
							end
							if (((create {P_TERM_STATIC}).term_strings.item[48]).item).to_integer_32 /= 0 then
								(create {P_TERM_STATIC}).term_settitle (a_title)
							elseif not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
								set_x11_title (a_title)
							else
								(create {P_GUI_GTK_X11_STATIC}).gui_mch_settitle (a_title, a_icon)
							end
							did_set_title___0.item := 1
						end
				when 6 then -- if done
						if not (l_type.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if (((create {P_TERM_STATIC}).term_strings.item[46]).item).to_integer_32 = 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L___0:
						if not a_icon.is_void then
							if oldicon.item.is_void then
								if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
									get_x11_icon (0).do_nothing
								end
							end
							if (((create {P_TERM_STATIC}).term_strings.item[46]).item).to_integer_32 /= 0 then
								(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[46]);
								(create {P_TERM_STATIC}).out_str_nf (a_icon);
								(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[47]);
								(create {P_TERM_STATIC}).out_flush
							elseif not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
								set_x11_icon (a_icon)
							end
							did_set_icon.item := 1
						end
				when 11 then -- if done
						recursive___3.item := recursive___3.item - 1
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mch_restore_title (a_which: INTEGER_32)
		local
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
		do
			if ((a_which).bit_and (2)).to_boolean then
				if did_set_icon.item.to_boolean then
					l_tmp := oldicon.item
				else
					l_tmp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				end
			else
				l_tmp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			end
			if ((a_which).bit_and (1)).to_boolean then
				if did_set_title___0.item.to_boolean then
					if (not oldtitle.item.is_void) then
						l_tmp___0 := oldtitle.item
					else
						l_tmp___0 := (create {P_OPTION_STATIC}).p_titleold.item.item
					end
					l_tmp___1 := l_tmp___0
				else
					l_tmp___1 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				end
			else
				l_tmp___1 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			end
			mch_settitle (l_tmp___1, l_tmp)
		end

	vim_is_xterm (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___5: INTEGER_32
			l_return: BOOLEAN
		do
			if a_name___1.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				if (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("xterm"), (5).to_natural_32)) = 0 then
					l_tmp___5 := 1
				elseif (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("nxterm"), (6).to_natural_32)) = 0 then
					l_tmp___5 := 1
				elseif (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("kterm"), (5).to_natural_32)) = 0 then
					l_tmp___5 := 1
				elseif (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("mlterm"), (6).to_natural_32)) = 0 then
					l_tmp___5 := 1
				elseif (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("rxvt"), (4).to_natural_32)) = 0 then
					l_tmp___5 := 1
				elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("builtin_xterm"))) = 0 then
					l_tmp___5 := 1
				else
					l_tmp___5 := 0
				end
				Result := l_tmp___5
			end
		end

	use_xterm_like_mouse (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if not a_name___1.is_void then
				if ((create {P_GLOBALS_STATIC}).term_is_xterm.item).to_boolean then
					l_tmp___0 := 1
				elseif (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("screen"), (6).to_natural_32)) = 0 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	use_xterm_mouse: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (create {P_OPTION_STATIC}).ttym_flags.item.item = {NATURAL_32} 2 then
				Result := 2
				l_return := True
			end
			if not l_return and then ((create {P_OPTION_STATIC}).ttym_flags.item.item = {NATURAL_32} 1) then
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	vim_is_iris (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			if a_name___1.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				if (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("iris-ansi"), (9).to_natural_32)) = 0 then
					l_tmp___1 := 1
				elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("builtin_iris-ansi"))) = 0 then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
				Result := l_tmp___1
			end
		end

	vim_is_vt300 (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_name___1.is_void then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("vt"), (2).to_natural_32)) /= 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("12345")), (a_name___1[2]).to_integer_32)).is_void then
							l_tmp___2 := 1
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("builtin_vt320"))) = 0 then
							l_tmp___2 := 1
						else
							l_tmp___2 := 0
						end
				when 5 then
						Result := l_tmp___2
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vim_is_fastterm (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___6: INTEGER_32
			l_return: BOOLEAN
		do
			if a_name___1.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				if (vim_is_xterm (a_name___1)).to_boolean then
					Result := 1
					l_return := True
				elseif (vim_is_vt300 (a_name___1)).to_boolean then
					Result := 1
					l_return := True
				elseif (vim_is_iris (a_name___1)).to_boolean then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				if (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("hpterm"), (6).to_natural_32)) = 0 then
					l_tmp___6 := 1
				elseif (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("sun-cmd"), (7).to_natural_32)) = 0 then
					l_tmp___6 := 1
				elseif (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("screen"), (6).to_natural_32)) = 0 then
					l_tmp___6 := 1
				elseif (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("dtterm"), (6).to_natural_32)) = 0 then
					l_tmp___6 := 1
				else
					l_tmp___6 := 0
				end
				Result := l_tmp___6
			end
		end

	mch_get_user_name (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		do
			Result := (mch_get_uname ((getuid), a_s, a_len))
		end

	mch_get_uname (a_uid: NATURAL_32; a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_pw: CE_POINTER [SD_PASSWD]
			l_return: BOOLEAN
		do
			l_pw := getpwuid (a_uid)
			if not l_pw.is_void then
				if not (l_pw.item.pw_name).is_void then
					if ((l_pw.item.pw_name).item).to_integer_32 /= 0 then
						(create {P_MISC2_STATIC}).vim_strncpy (a_s, create {CE_NATURAL_8_POINTER}.make_cast (l_pw.item.pw_name), (a_len - 1).to_natural_32)
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return then
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (a_s), ce_string ("%%d"), a_uid.to_integer_32]).do_nothing
				Result := 0
			end
		end

	mch_get_host_name (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		require
			not a_s.is_void
		local
			l_vutsname: CE_ARRAY [SD_UTSNAME]
		do
			create {CE_CLASS_ARRAY [SD_UTSNAME]} l_vutsname.make (<<1>>)

			if (uname (l_vutsname)) < 0 then
				a_s.item := (('%/0/').code).to_natural_8
			else
				(create {P_MISC2_STATIC}).vim_strncpy (a_s, create {CE_NATURAL_8_POINTER}.make_cast ((l_vutsname.item.nodename)), (a_len - 1).to_natural_32)
			end
		end

	mch_get_pid: INTEGER_32
		do
			Result := (getpid).to_integer_32
		end

	mch_dirname (a_buf___6: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (getcwd (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), a_len.to_natural_32)).is_void then
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), (strerror ((errno_location).item))).do_nothing
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := 1
			end
		end

	mch_FullName (a_fname, a_buf___6: CE_POINTER [NATURAL_8]; a_len, a_force: INTEGER_32): INTEGER_32
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_fd: INTEGER_32
			l_olddir: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_tmp___8: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_olddir.make (<<4_096>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fname := a_fname
					l_fd := -1
					l_retval := 1
					if not (a_force.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if (mch_isFullName (l_fname)).to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if: | _L___0:
						l_p___0 := (create {P_MISC2_STATIC}).vim_strrchr (l_fname, ('/').code)
						if l_p___0.is_void then
							l_pos := -1 + 9 -- skip if block
						end
				when 5 then -- if:
						if not dont_fchdir.item.to_boolean then
							l_fd := open ([ce_string ("."), 0, 0])
							if l_fd >= 0 then
								if (fchdir (l_fd)) < 0 then
									close (l_fd).do_nothing
									l_fd := -1
									dont_fchdir.item := 1
								end
							end
						end
						if not (l_fd < 0) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (mch_dirname (l_olddir, 4_096)) = 0 then
							l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							l_retval := 0
						elseif (mch_chdir (create {CE_INTEGER_8_POINTER}.make_cast (l_olddir))) /= 0 then
							l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							l_retval := 0
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if l_p___0.distance (l_fname) >= a_len then
							l_retval := 0
						else
							(create {P_MISC2_STATIC}).vim_strncpy (a_buf___6, l_fname, (l_p___0.distance (l_fname)).to_natural_32)
							if (mch_chdir (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6))).to_boolean then
								l_retval := 0
							else
								l_fname := l_p___0 + 1
							end
							a_buf___6.item := (('%/0/').code).to_natural_8
						end
				when 9 then -- if done
						if (mch_dirname (a_buf___6, a_len)) = 0 then
							l_retval := 0
							a_buf___6.item := (('%/0/').code).to_natural_8
						end
						if not l_p___0.is_void then
							if l_fd >= 0 then
								if (create {P_OPTION_STATIC}).p_verbose.item.item >= 5 then
									(create {P_MESSAGE_STATIC}).verbose_enter;
									(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("fchdir() to previous dir"))).do_nothing;
									(create {P_MESSAGE_STATIC}).verbose_leave
								end
								l_l := fchdir (l_fd)
								close (l_fd).do_nothing
							else
								l_l := mch_chdir (create {CE_INTEGER_8_POINTER}.make_cast (l_olddir))
							end
							if l_l /= 0 then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_prev_dir.item)))))).do_nothing
							end
						end
						l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6))).to_integer_32
						if l_l >= a_len then
							l_retval := 0
						elseif l_l > 0 then
							if (a_buf___6[(l_l - 1)]).to_integer_32 /= 47 then
								if (l_fname.item).to_integer_32 /= 0 then
									if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), ce_string ("."))) /= 0 then
										strcat (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), ce_string ("/")).do_nothing
									end
								end
							end
						end
				when 10 then -- if done
					if l_retval = 0 then
						Result := 0
						l_return := True
					else
						l_tmp___8 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6))
						if (l_tmp___8 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fname)))).to_integer_32 >= a_len then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), ce_string ("."))) /= 0 then
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (l_fname)).do_nothing
						end
						Result := 1
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mch_isFullName (a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_fname.is_void
		local
			l_tmp: INTEGER_32
		do
			if (a_fname.item).to_integer_32 = 47 then
				l_tmp := 1
			elseif (a_fname.item).to_integer_32 = 126 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	mch_getperm (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_statb: CE_ARRAY [SD_STAT]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_statb.make (<<1>>)

			if (stat (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), l_statb)).to_boolean then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				Result := (l_statb.item.st_mode).to_integer_32
			end
		end

	mch_setperm (a_name___1: CE_POINTER [NATURAL_8]; a_perm: INTEGER_32): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (chmod (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), a_perm.to_natural_32)) = 0 then
				l_tmp___0 := 1
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	mch_get_acl (a_fname: CE_POINTER [NATURAL_8]): CE_POINTER [ANY]
		local
			l_ret: CE_POINTER [ANY]
		do
			l_ret := create {CE_VOID_POINTER}.make_shared (default_pointer)
			Result := l_ret
		end

	mch_set_acl (a_fname: CE_POINTER [NATURAL_8]; a_aclent: CE_POINTER [ANY])
		local
			l_return: BOOLEAN
		do
			if a_aclent.is_void then
				l_return := True
			end
			if not l_return then
			end
		end

	mch_free_acl (a_aclent: CE_POINTER [ANY])
		local
			l_return: BOOLEAN
		do
			if a_aclent.is_void then
				l_return := True
			end
			if not l_return then
			end
		end

	mch_isdir (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_name___1.is_void
		local
			l_statb: CE_ARRAY [SD_STAT]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_statb.make (<<1>>)

			if (a_name___1.item).to_integer_32 = 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				if (stat (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), l_statb)).to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if ((l_statb.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 16_384 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
				Result := l_tmp___0
			end
		end

	executable_file (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_st: CE_ARRAY [SD_STAT]
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)

			if (stat (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), l_st)).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				if ((l_st.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 32_768 then
					if (access (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), 1)) = 0 then
						l_tmp___1 := 1
					else
						l_tmp___1 := 0
					end
				else
					l_tmp___1 := 0
				end
				Result := l_tmp___1
			end
		end

	mch_can_exe (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_name___1.is_void
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___2: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if (mch_isFullName (a_name___1)).to_boolean then
				l_tmp := executable_file (a_name___1)
				Result := l_tmp
				l_return := True
			elseif (a_name___1[0]).to_integer_32 = 46 then
				if (a_name___1[1]).to_integer_32 = 47 then
					l_tmp := executable_file (a_name___1)
					Result := l_tmp
					l_return := True
				elseif (a_name___1[1]).to_integer_32 = 46 then
					if (a_name___1[2]).to_integer_32 = 47 then
						l_tmp := executable_file (a_name___1)
						Result := l_tmp
						l_return := True
					end
				end
			end
			if not l_return then
				l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast ((getenv (ce_string ("PATH"))))
				if l_p___0.is_void then
					Result := (-1)
					l_return := True
				elseif (l_p___0.item).to_integer_32 = 0 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1))
				l_buf___6 := (create {P_MISC2_STATIC}).alloc ((l_tmp___2 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0)))) + {NATURAL_32} 2)
				if l_buf___6.is_void then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					l_e := create {CE_NATURAL_8_POINTER}.make_cast ((strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), (':').code)))
					if l_e.is_void then
						l_e := l_p___0 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32
					end
					if l_e.distance (l_p___0) <= 1 then
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("./")).do_nothing
					else
						(create {P_MISC2_STATIC}).vim_strncpy (l_buf___6, l_p___0, (l_e.distance (l_p___0)).to_natural_32);
						(create {P_MISC1_STATIC}).add_pathsep (l_buf___6)
					end
					strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (a_name___1)).do_nothing
					l_retval := executable_file (l_buf___6)
					if l_retval = 1 then
						l_break := True
					end
					if not (l_break) and then ((l_e.item).to_integer_32 /= 58) then
						l_break := True
					end
					if not (l_break) then
						l_p___0 := l_e + 1
					end
				end
				l_break := False;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
				Result := l_retval
			end
		end

	mch_nodetype (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_st: CE_ARRAY [SD_STAT]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)

			if (stat (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), l_st)).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				if ((l_st.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 32_768 then
					Result := 0
					l_return := True
				elseif ((l_st.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 16_384 then
					Result := 0
					l_return := True
				end
			end
			if not l_return and then (((l_st.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 24_576) then
				Result := 2
				l_return := True
			end
			if not l_return then
				Result := 1
			end
		end

	mch_early_init
		do
			signal_stack.item := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC2_STATIC}).alloc ({NATURAL_32} 8_192)))
			init_signal_stack
		end

	exit_scroll
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_GLOBALS_STATIC}).silent_mode.item).to_boolean then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_GLOBALS_STATIC}).newline_on_exit.item).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (((create {P_GLOBALS_STATIC}).msg_didout.item).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if ((create {P_MESSAGE_STATIC}).msg_use_printf).to_boolean then
							if ((create {P_GLOBALS_STATIC}).info_message.item).to_boolean then
								(create {P_MESSAGE_STATIC}).mch_msg (ce_string ("%N"))
							else
								(create {P_MESSAGE_STATIC}).mch_errmsg (ce_string ("%R%N"))
							end
						else
							(create {P_TERM_STATIC}).out_char ((('%N').code).to_natural_32)
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:;
						(create {P_SYNTAX_STATIC}).restore_cterm_colors;
						(create {P_MESSAGE_STATIC}).msg_clr_eos_force;
						(create {P_SCREEN_STATIC}).windgoto (((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 1, 0)
				when 8 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mch_exit (a_r: INTEGER_32)
		do
			(create {P_GLOBALS_STATIC}).exiting.item := 1;
			(create {P_OPS_STATIC}).x11_export_final_selection
			if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_TERM_STATIC}).settmode (0)
				mch_restore_title (3)
				if ((create {P_TERM_STATIC}).swapping_screen).to_boolean then
					if not ((create {P_GLOBALS_STATIC}).newline_on_exit.item).to_boolean then
						exit_scroll
					end
				end
				(create {P_TERM_STATIC}).stoptermcap
				if ((create {P_TERM_STATIC}).swapping_screen).to_boolean then
					if ((create {P_GLOBALS_STATIC}).newline_on_exit.item).to_boolean then
						exit_scroll
					end
				else
					exit_scroll
				end
				if ((create {P_GLOBALS_STATIC}).full_screen.item).to_boolean then
					(create {P_TERM_STATIC}).cursor_on
				end
			end
			(create {P_TERM_STATIC}).out_flush;
			(create {P_MEMLINE_STATIC}).ml_close_all (1)
			may_core_dump
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_GUI_STATIC}).gui_exit (a_r)
			end
			(create {P_NETBEANS_STATIC}).netbeans_send_disconnect
			exit (a_r)
		end

	may_core_dump
		do
			if deadly_signal.item /= 0 then
				sigset (deadly_signal.item, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
				kill ((getpid), deadly_signal.item).do_nothing
			end
		end

	mch_settmode (a_tmode: INTEGER_32)
		local
			l_tnew: CE_ARRAY [SD_TERMIOS]
			l_n: INTEGER_32
			l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_TERMIOS]} l_tnew.make (<<1>>)

			if first.item.to_boolean then
				first.item := 0
				tcgetattr ((create {P_GLOBALS_STATIC}).read_cmd_fd.item, told.item).do_nothing
			end
			l_tnew.item := (told.item.item).twin
			if a_tmode = 2 then
				l_tnew.item.c2_iflag := (l_tnew.item.c2_iflag).bit_and (({NATURAL_32} 4_294_967_039))
				l_tnew.item.c2_lflag := (l_tnew.item.c2_lflag).bit_and (({NATURAL_32} 4_294_934_500))
				l_tnew.item.c2_oflag := (l_tnew.item.c2_oflag).bit_and (({NATURAL_32} 4_294_967_291))
				l_tnew.item.c2_cc[6] := (1).to_natural_8
				l_tnew.item.c2_cc[5] := (0).to_natural_8
			elseif a_tmode = 1 then
				l_tnew.item.c2_lflag := (l_tnew.item.c2_lflag).bit_and (({NATURAL_32} 4_294_967_287))
			end
			l_n := 10
			from
			until
				(l_break)
			loop
				l_break := False
				if (tcsetattr ((create {P_GLOBALS_STATIC}).read_cmd_fd.item, 0, l_tnew)) = -1 then
					if (errno_location).item = 4 then
						if not (l_n > 0) then
							l_break := True
						end
					else
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_n := l_n - 1
				end
			end
			l_break := False
			curr_tmode.item := a_tmode
		end

	get_stty
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_keys___0: CE_ARRAY [SD_TERMIOS]
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<2>>)
			create {CE_CLASS_ARRAY [SD_TERMIOS]} l_keys___0.make (<<1>>)

			if (tcgetattr ((create {P_GLOBALS_STATIC}).read_cmd_fd.item, l_keys___0)) /= -1 then
				l_buf___6[0] := l_keys___0.item.c2_cc[2];
				(create {P_GLOBALS_STATIC}).intr_char.item := (l_keys___0.item.c2_cc[0]).to_integer_32
				l_buf___6[1] := (('%/0/').code).to_natural_8;
				(create {P_TERM_STATIC}).add_termcode (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kb")), l_buf___6, 0)
				l_p___0 := (create {P_TERM_STATIC}).find_termcode (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kD")))
				if not l_p___0.is_void then
					if (l_p___0[0]).to_integer_32 = (l_buf___6[0]).to_integer_32 then
						if (l_p___0[1]).to_integer_32 = (l_buf___6[1]).to_integer_32 then
							(create {P_EX_CMDS_STATIC}).do_fixdel (create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer))
						end
					end
				end
			end
		end

	mch_setmouse (a_on: INTEGER_32)
		local
			l_xterm_mouse_vers: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			if a_on = ison.item then
				l_return := True
			end
			if not l_return then
				l_xterm_mouse_vers := use_xterm_mouse
				if l_xterm_mouse_vers > 0 then
					if a_on.to_boolean then
						if l_xterm_mouse_vers > 1 then
							l_tmp := ce_string ("%/27/[?1002h")
						else
							l_tmp := ce_string ("%/27/[?1000h")
						end
						(create {P_TERM_STATIC}).out_str_nf (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp))
					else
						if l_xterm_mouse_vers > 1 then
							l_tmp___0 := ce_string ("%/27/[?1002l")
						else
							l_tmp___0 := ce_string ("%/27/[?1000l")
						end
						(create {P_TERM_STATIC}).out_str_nf (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0))
					end
					ison.item := a_on
				end
			end
		end

	check_mouse_termcode
		local
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			if (use_xterm_mouse).to_boolean then
				if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
					if ((create {P_TERM_STATIC}).term_is_8bit ((create {P_TERM_STATIC}).term_strings.item[0])).to_boolean then
						l_tmp___0 := ce_string ("%/155/M")
					else
						l_tmp___0 := ce_string ("%/27/[M")
					end
					(create {P_TERM_STATIC}).set_mouse_termcode (251, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0))
					if ((create {P_OPTION_STATIC}).p_mouse.item.item.item).to_integer_32 /= 0 then
						mch_setmouse (0);
						(create {P_TERM_STATIC}).setmouse
					end
				else
					(create {P_TERM_STATIC}).del_mouse_termcode (251)
				end
			else
				(create {P_TERM_STATIC}).del_mouse_termcode (251)
			end
		end

	mch_get_shellsize: INTEGER_32
		local
			l_rows: CE_ARRAY [INTEGER_32]
			l_columns: CE_ARRAY [INTEGER_32]
			l_p___0: CE_POINTER [NATURAL_8]
			l_ws: CE_ARRAY [SD_WINSIZE]
			l_fd: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_rows.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_columns.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_WINSIZE]} l_ws.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_rows.item := 0
					l_columns.item := 0
					l_fd := 1
					if not (isatty (l_fd)).to_boolean then
						if (isatty ((create {P_GLOBALS_STATIC}).read_cmd_fd.item)).to_boolean then
							l_fd := (create {P_GLOBALS_STATIC}).read_cmd_fd.item
						end
					end
					if (ioctl ([l_fd, {NATURAL_32} 21_523, l_ws])) = 0 then
						l_columns.item := (l_ws.item.ws_col).to_integer_32
						l_rows.item := (l_ws.item.ws_row).to_integer_32
					end
					if l_columns.item /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if l_rows.item /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('|').code)).is_void then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast ((getenv (ce_string ("LINES"))))
						if (not l_p___0.is_void) then
							l_rows.item := (atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32
						end
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast ((getenv (ce_string ("COLUMNS"))))
						if (not l_p___0.is_void) then
							l_columns.item := (atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32
						end
				when 8 then -- if done | if done
					if l_columns.item = 0 then
						(create {P_TERM_STATIC}).getlinecol (l_columns, l_rows)
					elseif l_rows.item = 0 then
						(create {P_TERM_STATIC}).getlinecol (l_columns, l_rows)
					end
					if l_columns.item <= 0 then
						Result := 0
						l_return := True
					elseif l_rows.item <= 0 then
						Result := 0
						l_return := True
					end
					if not l_return then
						(create {P_GLOBALS_STATIC}).Rows.item.item := l_rows.item;
						(create {P_GLOBALS_STATIC}).Columns.item.item := l_columns.item
						Result := 1
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mch_set_shellsize
		do
			if (((create {P_TERM_STATIC}).term_strings.item[51]).item).to_boolean then
				(create {P_TERM_STATIC}).term_set_winsize (((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32);
				(create {P_TERM_STATIC}).out_flush;
				(create {P_SCREEN_STATIC}).screen_start
			end
		end

	mch_new_shellsize
		do
		end

	mch_call_shell (a_cmd: CE_POINTER [NATURAL_8]; a_options___0: INTEGER_32): INTEGER_32
		local
			l_tmode: INTEGER_32
			l_newcmd: CE_POINTER [NATURAL_8]
			l_pid: INTEGER_32
			l_wpid: INTEGER_32
			l_wait_pid: INTEGER_32
			l_status: CE_ARRAY [INTEGER_32]
			l_retval: INTEGER_32
			l_argv: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_argc: INTEGER_32
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_inquote: INTEGER_32
			l_pty_master_fd: INTEGER_32
			l_pty_slave_fd: INTEGER_32
			l_tty_name: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_fd_toshell: CE_ARRAY [INTEGER_32]
			l_fd_fromshell: CE_ARRAY [INTEGER_32]
			l_pipe_error: INTEGER_32
			l_envbuf: CE_ARRAY [INTEGER_8]
			l_did_settmode: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_fd: INTEGER_32
			l_buffer: CE_ARRAY [NATURAL_8]
			l_buffer_off: INTEGER_32
			l_ta_buf: CE_ARRAY [NATURAL_8]
			l_ta_len___0: INTEGER_32
			l_len: INTEGER_32
			l_p_more_save: INTEGER_32
			l_old_State: INTEGER_32
			l_c: INTEGER_32
			l_toshell_fd: INTEGER_32
			l_fromshell_fd: INTEGER_32
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_noread_cnt: INTEGER_32
			l_start_tv: CE_ARRAY [SD_TIMEVAL]
			l_lnum: INTEGER_32
			l_written: INTEGER_32
			l_lp: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_l: NATURAL_32
			l_tmp___10: NATURAL_32
			l_l___0: INTEGER_32
			l_l___1: INTEGER_32
			l_now_tv: CE_ARRAY [SD_TIMEVAL]
			l_msec: INTEGER_32
			l___constr_expr_0: PD_ANONYMOUS
			l___constr_expr_1: PD_ANONYMOUS2
			l___constr_expr_2: PD_ANONYMOUS3
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_status.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_tty_name.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_fd_toshell.make (<<2>>)
			create {CE_INTEGER_32_ARRAY} l_fd_fromshell.make (<<2>>)
			create {CE_INTEGER_8_ARRAY} l_envbuf.make (<<50>>)
			create {CE_NATURAL_8_ARRAY} l_buffer.make (<<101>>)
			create {CE_NATURAL_8_ARRAY} l_ta_buf.make (<<101>>)
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_start_tv.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_now_tv.make (<<1>>)
			create l___constr_expr_0.make
			create l___constr_expr_1.make
			create l___constr_expr_2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmode := (create {P_GLOBALS_STATIC}).cur_tmode.item
					l_newcmd := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_wpid := 0
					l_wait_pid := 0
					l_status.item := -1
					l_retval := -1
					l_argv := create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_pty_master_fd := -1
					l_pty_slave_fd := -1
					l_pipe_error := 0
					l_did_settmode := 0;
					(create {P_TERM_STATIC}).out_flush
					if ((a_options___0).bit_and (4)).to_boolean then
						(create {P_TERM_STATIC}).settmode (0)
					end
					l_newcmd := (create {P_MISC2_STATIC}).vim_strsave ((create {P_OPTION_STATIC}).p_sh.item.item)
					if l_newcmd.is_void then
						l_pos := -1 + 100 -- goto error
					end
				when 1 then
					l_i___0 := 0
				when 2 then -- loop condition:
					if not (not (l_return) and then (l_i___0 < 2)) then
						l_pos := -1 + 5 -- skip loop
					end
				when 3 then -- loop body:
						l_p___0 := l_newcmd
						l_inquote := 0
						l_argc := 0
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i___0 = 1 then
								l_argv[l_argc] := create {CE_INTEGER_8_POINTER}.make_cast (l_p___0)
							end
							l_argc := l_argc + 1
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_p___0.item).to_boolean then
									if not l_inquote.to_boolean then
										if (l_p___0.item).to_integer_32 /= 32 then
											if (l_p___0.item).to_integer_32 = 9 then
												l_break := True
											end
										else
											l_break := True
										end
									end
								else
									l_break := True
								end
								if not (l_break) then
									if (l_p___0.item).to_integer_32 = 34 then
										l_inquote := (not l_inquote.to_boolean).to_integer
									end
									l_p___0 := l_p___0 + 1
								end
							end
							l_break := False
							if (l_p___0.item).to_integer_32 = 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								if l_i___0 = 1 then
									l_tmp := l_p___0
									l_p___0 := l_p___0 + 1
									l_tmp.item := (('%/0/').code).to_natural_8
								end
								l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
							end
						end
						l_break := False
						if l_argv.is_void then
							l_argv := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (((create {P_MISC2_STATIC}).alloc ((l_argc + 4).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
							if l_argv.is_void then
								l_pos := -1 + 100 -- goto error
							end
						end
				when 4 then
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
					if not a_cmd.is_void then
						if not extra_shell_arg.item.is_void then
							l_tmp___1 := l_argc
							l_argc := l_argc + 1
							l_argv[l_tmp___1] := create {CE_INTEGER_8_POINTER}.make_cast (extra_shell_arg.item)
						end
						l_tmp___2 := l_argc
						l_argc := l_argc + 1
						l_argv[l_tmp___2] := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_shcf.item.item)
						l_tmp___3 := l_argc
						l_argc := l_argc + 1
						l_argv[l_tmp___3] := create {CE_INTEGER_8_POINTER}.make_cast (a_cmd)
					end
					l_argv[l_argc] := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					if not (((a_options___0).bit_and (96)).to_boolean) then
						l_pos := -1 + 8 -- skip if block
					end
				when 6 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 8 then -- else:
						if not (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if not (show_shell_mess.item.to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						if ((create {P_OPTION_STATIC}).p_guipty.item.item).to_boolean then
							if not ((a_options___0).bit_and (96)).to_boolean then
								l_pty_master_fd := (create {P_PTY_STATIC}).OpenPTY (l_tty_name)
								if l_pty_master_fd >= 0 then
									l_pty_slave_fd := open ([l_tty_name.item, 2, 0])
									if l_pty_slave_fd < 0 then
										close (l_pty_master_fd).do_nothing
										l_pty_master_fd := -1
									end
								end
							end
						end
						if l_pty_master_fd < 0 then
							l_pipe_error := ((pipe (create {CE_INTEGER_32_POINTER}.make_cast (l_fd_toshell))) < 0).to_integer
							if not l_pipe_error.to_boolean then
								l_pipe_error := ((pipe (create {CE_INTEGER_32_POINTER}.make_cast (l_fd_fromshell))) < 0).to_integer
								if l_pipe_error.to_boolean then
									close (l_fd_toshell[0]).do_nothing
									close (l_fd_toshell[1]).do_nothing
								end
							end
							if l_pipe_error.to_boolean then
								(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%NCannot create pipes%N")))));
								(create {P_TERM_STATIC}).out_flush
							end
						end
				when 11 then -- if done | if done
					if l_pipe_error.to_boolean then
						l_pos := -1 + 99 -- skip if block
					end
				when 12 then -- if:
						l_pid := fork
						if l_pid /= -1 then
							l_pos := -1 + 20 -- skip if block
						end
				when 13 then -- if:;
						(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%NCannot fork%N")))))
						if not (((a_options___0).bit_and (96)).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 18 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 16 then -- else:
						if not (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if not (show_shell_mess.item.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 18 then -- if: | _L___0:
						if l_pty_master_fd >= 0 then
							close (l_pty_master_fd).do_nothing
							close (l_pty_slave_fd).do_nothing
						else
							close (l_fd_toshell[0]).do_nothing
							close (l_fd_toshell[1]).do_nothing
							close (l_fd_fromshell[0]).do_nothing
							close (l_fd_fromshell[1]).do_nothing
						end
				when 19 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 99
				when 20 then -- else:
						if l_pid /= 0 then
							l_pos := -1 + 34 -- skip if block
						end
				when 21 then -- if:
						reset_signals
						if show_shell_mess.item.to_boolean then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L___2
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 24 then -- else:
						if not (((a_options___0).bit_and (2)).to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if: | _L___2:
						l_fd := open ([ce_string ("/dev/null"), 2, 0])
						fclose ((create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer))).do_nothing
						fclose ((create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
						fclose ((create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))).do_nothing
						if l_fd >= 0 then
							(create {P_GLOBALS_STATIC}).ignored.item := dup (l_fd);
							(create {P_GLOBALS_STATIC}).ignored.item := dup (l_fd);
							(create {P_GLOBALS_STATIC}).ignored.item := dup (l_fd)
							close (l_fd).do_nothing
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 27 then -- else:
						if not (((a_options___0).bit_and (96)).to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 31 -- goto _L___1
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 30 then -- else:
						if not (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
							l_pos := -1 + 32 -- skip if block
						end
				when 31 then -- if: | _L___1:
						if ((create {P_OPTION_STATIC}).p_stmp.item.item).to_boolean then
							setsid.do_nothing
							sigset (1, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
						end
						if l_pty_slave_fd >= 0 then
							if ((a_options___0).bit_and (4)).to_boolean then
								(create {P_PTY_STATIC}).SetupSlavePTY (l_pty_slave_fd).do_nothing
							end
							ioctl ([l_pty_slave_fd, {NATURAL_32} 21_518, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)]).do_nothing
						end
						setenv (ce_string ("TERM"), ce_string ("dumb"), 1).do_nothing
						sprintf ([l_envbuf, ce_string ("%%ld"), (create {P_GLOBALS_STATIC}).Rows.item.item]).do_nothing
						setenv (ce_string ("ROWS"), l_envbuf, 1).do_nothing
						sprintf ([l_envbuf, ce_string ("%%ld"), (create {P_GLOBALS_STATIC}).Rows.item.item]).do_nothing
						setenv (ce_string ("LINES"), l_envbuf, 1).do_nothing
						sprintf ([l_envbuf, ce_string ("%%ld"), (create {P_GLOBALS_STATIC}).Columns.item.item]).do_nothing
						setenv (ce_string ("COLUMNS"), l_envbuf, 1).do_nothing
						if l_pty_master_fd >= 0 then
							close (l_pty_master_fd).do_nothing
							close (0).do_nothing;
							(create {P_GLOBALS_STATIC}).ignored.item := dup (l_pty_slave_fd)
							close (1).do_nothing;
							(create {P_GLOBALS_STATIC}).ignored.item := dup (l_pty_slave_fd)
							if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
								close (2).do_nothing;
								(create {P_GLOBALS_STATIC}).ignored.item := dup (l_pty_slave_fd)
							end
							close (l_pty_slave_fd).do_nothing
						else
							close (l_fd_toshell[1]).do_nothing
							close (0).do_nothing;
							(create {P_GLOBALS_STATIC}).ignored.item := dup (l_fd_toshell[0])
							close (l_fd_toshell[0]).do_nothing
							close (l_fd_fromshell[0]).do_nothing
							close (1).do_nothing;
							(create {P_GLOBALS_STATIC}).ignored.item := dup (l_fd_fromshell[1])
							close (l_fd_fromshell[1]).do_nothing
							if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
								close (2).do_nothing;
								(create {P_GLOBALS_STATIC}).ignored.item := dup (1)
							end
						end
				when 32 then -- if done | if done | if done
						execvp (l_argv[0], l_argv).do_nothing
						exit2 (122)
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 99
				when 34 then -- else:
						catch_signals (create {CE_ROUTINE}.make_shared (default_pointer + 1), create {CE_ROUTINE}.make_shared (default_pointer + -1))
						catch_int_signal
						if not (((a_options___0).bit_and (96)).to_boolean) then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_pos := -1 + 39 -- goto _L___11
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 98
				when 37 then -- else:
						if not (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
							l_pos := -1 + 98 -- skip if block
						end
				when 38 then -- if:
						if not (show_shell_mess.item.to_boolean) then
							l_pos := -1 + 98 -- skip if block
						end
				when 39 then -- if: | _L___11:
						l_buffer_off := 0
						l_ta_len___0 := 0
						if l_pty_master_fd >= 0 then
							close (l_pty_slave_fd).do_nothing
							l_fromshell_fd := l_pty_master_fd
							l_toshell_fd := dup (l_pty_master_fd)
						else
							close (l_fd_toshell[0]).do_nothing
							close (l_fd_fromshell[1]).do_nothing
							l_toshell_fd := l_fd_toshell[1]
							l_fromshell_fd := l_fd_fromshell[0]
						end
						l_p_more_save := (create {P_OPTION_STATIC}).p_more.item.item;
						(create {P_OPTION_STATIC}).p_more.item.item := 0
						l_old_State := (create {P_GLOBALS_STATIC}).State.item;
						(create {P_GLOBALS_STATIC}).State.item := 1_536
						if ((a_options___0).bit_and (64)).to_boolean then
							if l_toshell_fd >= 0 then
								l_wpid := fork
								if l_wpid = -1 then
									(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%NCannot fork%N")))))
								elseif l_wpid = 0 then
									l_lnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum
									l_written := 0
									l_lp := ((create {P_MEMLINE_STATIC}).ml_get (l_lnum))
									close (l_fromshell_fd).do_nothing
									from
									until
										(l_break)
									loop
										l_break := False
										l_l := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_lp + l_written)))
										if l_l = {NATURAL_32} 0 then
											l_len := 0
										elseif (l_lp[l_written]).to_integer_32 = 10 then
											l_len := write (l_toshell_fd, create {CE_VOID_POINTER}.make_cast (ce_string ("")), (1).to_natural_32)
										else
											l_s := (create {P_MISC2_STATIC}).vim_strchr (l_lp + l_written, ('%N').code)
											if l_s.is_void then
												l_tmp___10 := l_l
											else
												l_tmp___10 := (l_s.distance ((l_lp + l_written))).to_natural_32
											end
											l_len := write (l_toshell_fd, create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (l_lp) + l_written)), l_tmp___10)
										end
										if l_len = l_l.to_integer_32 then
											if l_lnum /= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.lnum then
												(create {P_GLOBALS_STATIC}).ignored.item := write (l_toshell_fd, create {CE_VOID_POINTER}.make_cast (ce_string ("%N")), (1).to_natural_32)
											elseif not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bin).to_boolean then
												(create {P_GLOBALS_STATIC}).ignored.item := write (l_toshell_fd, create {CE_VOID_POINTER}.make_cast (ce_string ("%N")), (1).to_natural_32)
											elseif l_lnum /= (create {P_GLOBALS_STATIC}).write_no_eol_lnum.item then
												if l_lnum /= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
													(create {P_GLOBALS_STATIC}).ignored.item := write (l_toshell_fd, create {CE_VOID_POINTER}.make_cast (ce_string ("%N")), (1).to_natural_32)
												elseif ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_eol).to_boolean then
													(create {P_GLOBALS_STATIC}).ignored.item := write (l_toshell_fd, create {CE_VOID_POINTER}.make_cast (ce_string ("%N")), (1).to_natural_32)
												end
											end
											l_lnum := l_lnum + 1
											if l_lnum > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.lnum then
												close (l_toshell_fd).do_nothing
												l_toshell_fd := -1
												l_break := True
											end
											if not (l_return or l_break) then
												l_lp := (create {P_MEMLINE_STATIC}).ml_get (l_lnum)
												l_written := 0
											end
										elseif l_len > 0 then
											l_written := l_written + l_len
										end
									end
									l_break := False
									exit2 (0)
								else
									close (l_toshell_fd).do_nothing
									l_toshell_fd := -1
								end
							end
						end
						if ((a_options___0).bit_and (32)).to_boolean then
							l_ga.item.ga_init2 (1, 100)
						end
						l_noread_cnt := 0
						gettimeofday (l_start_tv, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
				when 40 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 96 -- skip loop
						end
				when 41 then -- loop body:
						l_break := False
						l_len := 0
						if ((a_options___0).bit_and (2)).to_boolean then
							l_pos := -1 + 84 -- skip if block
						end
				when 42 then -- if:
						if ((a_options___0).bit_and (100)) = 100 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						l_pos := -1 + 46 -- goto _L___9
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 84
				when 45 then -- else:
						if not (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
							l_pos := -1 + 84 -- skip if block
						end
				when 46 then -- if: | _L___9:
						if l_wait_pid /= 0 then
							l_pos := -1 + 84 -- skip if block
						end
				when 47 then -- if:
						if not (l_ta_len___0 > 0) then
							l_pos := -1 + 50 -- skip if block
						end
				when 48 then -- if:
						l_pos := -1 + 51 -- goto _L___8
				when 49 then -- if block done, skip else block:
						l_pos := -1 + 84
				when 50 then -- else:
						if not (l_noread_cnt > 4) then
							l_pos := -1 + 84 -- skip if block
						end
				when 51 then -- if: | _L___8:
						if l_ta_len___0 = 0 then
							l_noread_cnt := 0
							gettimeofday (l_start_tv, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
							l_len := (create {P_UI_STATIC}).ui_inchar (l_ta_buf, 100, 10, 0)
						end
						if not (l_ta_len___0 > 0) then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
						l_pos := -1 + 55 -- goto _L___7
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 84
				when 54 then -- else:
						if not (l_len > 0) then
							l_pos := -1 + 84 -- skip if block
						end
				when 55 then -- if: | _L___7:
						if l_len /= 1 then
							l_pos := -1 + 66 -- skip if block
						end
				when 56 then -- if:
						if not (l_pty_master_fd < 0) then
							l_pos := -1 + 59 -- skip if block
						end
				when 57 then -- if:
						l_pos := -1 + 60 -- goto _L___4
				when 58 then -- if block done, skip else block:
						l_pos := -1 + 66
				when 59 then -- else:
						if a_cmd.is_void then
							l_pos := -1 + 66 -- skip if block
						end
				when 60 then -- if: | _L___4:
						if (l_ta_buf[l_ta_len___0]).to_integer_32 /= 3 then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						l_pos := -1 + 64 -- goto _L___3
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 65
				when 63 then -- else:
						if (l_ta_buf[l_ta_len___0]).to_integer_32 /= (create {P_GLOBALS_STATIC}).intr_char.item then
							l_pos := -1 + 65 -- skip if block
						end
				when 64 then -- if: | _L___3:
						kill (-l_pid, 2).do_nothing
						if l_wpid > 0 then
							kill (l_wpid, 2).do_nothing
						end
				when 65 then -- if done
						if l_pty_master_fd < 0 then
							if l_toshell_fd >= 0 then
								if (l_ta_buf[l_ta_len___0]).to_integer_32 = 4 then
									close (l_toshell_fd).do_nothing
									l_toshell_fd := -1
								end
							end
						end
				when 66 then -- if done | if done
						l_i___0 := l_ta_len___0
				when 67 then -- loop condition:
						if not (l_i___0 < l_ta_len___0 + l_len) then
							l_pos := -1 + 83 -- skip loop
						end
				when 68 then -- loop body:
						if (l_ta_buf[l_i___0]).to_integer_32 /= 155 then
							l_pos := -1 + 81 -- skip if block
						end
				when 69 then -- if:
						if not (l_len - l_i___0 > 2) then
							l_pos := -1 + 79 -- skip if block
						end
				when 70 then -- if:
						l_c := -((l_ta_buf[l_i___0 + 1]).to_integer_32 + (((l_ta_buf[l_i___0 + 2]).to_integer_32).bit_shift_left (8)))
						if l_c /= -(107 + ((68).bit_shift_left (8))) then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if:
						l_pos := -1 + 77 -- goto _L___5
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 78
				when 73 then -- else:
						if l_c /= -(253 + ((80).bit_shift_left (8))) then
							l_pos := -1 + 76 -- skip if block
						end
				when 74 then -- if:
						l_pos := -1 + 77 -- goto _L___5
				when 75 then -- if block done, skip else block:
						l_pos := -1 + 78
				when 76 then -- else:
						if l_c /= -(107 + ((98).bit_shift_left (8))) then
							l_pos := -1 + 78 -- skip if block
						end
				when 77 then -- if: | _L___5:
						memmove (create {CE_VOID_POINTER}.make_cast (((l_ta_buf + l_i___0) + 1)), create {CE_VOID_POINTER}.make_cast (((l_ta_buf + l_i___0) + 3)), ((l_len - l_i___0) - 2).to_natural_32).do_nothing
						if l_c = -(107 + ((68).bit_shift_left (8))) then
							l_ta_buf[l_i___0] := (127).to_natural_8
						elseif l_c = -(253 + ((80).bit_shift_left (8))) then
							l_ta_buf[l_i___0] := (127).to_natural_8
						else
							l_ta_buf[l_i___0] := (8).to_natural_8
						end
						l_len := l_len - (2)
				when 78 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 80
				when 79 then -- else:
						l_pos := -1 + 81 -- goto _L___6
				when 80 then -- if done | if block done, skip else block:
						l_pos := -1 + 82
				when 81 then -- else: | _L___6:
						if (l_ta_buf[l_i___0]).to_integer_32 = 13 then
							l_ta_buf[l_i___0] := (('%N').code).to_natural_8
						end
				when 82 then
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_i___0 := l_i___0 + (((create {P_GLOBALS_STATIC}).mb_ptr2len_len.item.integer_32_item ([l_ta_buf + l_i___0, (l_ta_len___0 + l_len) - l_i___0])) - 1)
						end
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 67 -- back to loop condition
				when 83 then -- loop done
						if l_pty_master_fd < 0 then
							l_i___0 := l_ta_len___0
							from
							until
								not (l_i___0 < l_ta_len___0 + l_len)
							loop
								if (l_ta_buf[l_i___0]).to_integer_32 = 10 then
									(create {P_MESSAGE_STATIC}).msg_putchar ((l_ta_buf[l_i___0]).to_integer_32)
								elseif (l_ta_buf[l_i___0]).to_integer_32 = 8 then
									(create {P_MESSAGE_STATIC}).msg_putchar ((l_ta_buf[l_i___0]).to_integer_32)
								elseif ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_l___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ta_buf + l_i___0]));
									(create {P_MESSAGE_STATIC}).msg_outtrans_len (l_ta_buf + l_i___0, l_l___0).do_nothing
									l_i___0 := l_i___0 + (l_l___0 - 1)
								else
									(create {P_MESSAGE_STATIC}).msg_outtrans_len (l_ta_buf + l_i___0, 1).do_nothing
								end
								l_i___0 := l_i___0 + 1
							end
							(create {P_SCREEN_STATIC}).windgoto ((create {P_GLOBALS_STATIC}).msg_row.item, (create {P_GLOBALS_STATIC}).msg_col.item);
							(create {P_TERM_STATIC}).out_flush
						end
						l_ta_len___0 := l_ta_len___0 + l_len
						if ((a_options___0).bit_and (64)).to_boolean then
							l_ta_len___0 := 0
						elseif l_toshell_fd >= 0 then
							l_len := write (l_toshell_fd, create {CE_VOID_POINTER}.make_cast (l_ta_buf), (1).to_natural_32)
							if l_len > 0 then
								l_ta_len___0 := l_ta_len___0 - l_len
								memmove (create {CE_VOID_POINTER}.make_cast (l_ta_buf), create {CE_VOID_POINTER}.make_cast ((l_ta_buf + l_len)), l_ta_len___0.to_natural_32).do_nothing
							end
						end
				when 84 then -- if done | if done | if done | if done | if done | if done | if done
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							kill (-l_pid, 2).do_nothing
							if l_wpid > 0 then
								kill (l_wpid, 2).do_nothing
							end
							(create {P_GLOBALS_STATIC}).got_int.item := 0
						end
						l_noread_cnt := l_noread_cnt + 1
				when 85 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 90 -- skip loop
						end
				when 86 then -- loop body:
						l_break := False
						l_continue := False
						if not (RealWaitForChar (l_fromshell_fd, 10, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))).to_boolean then
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 89 -- skip if block
						end
				when 87 then -- if:
						l_len := read (l_fromshell_fd, create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (l_buffer) + l_buffer_off)), (100 - l_buffer_off).to_natural_32)
						if l_len <= 0 then
							l_pos := -1 + 97 -- goto finished
						end
				when 88 then
						l_noread_cnt := 0
						if ((a_options___0).bit_and (32)).to_boolean then
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_len)
							loop
								if (l_buffer[l_i___0]).to_integer_32 = 10 then
									l_ga.item.append_ga_line
								elseif (l_buffer[l_i___0]).to_integer_32 = 0 then
									l_ga.item.ga_append (('%N').code)
								else
									l_ga.item.ga_append ((l_buffer[l_i___0]).to_integer_32)
								end
								l_i___0 := l_i___0 + 1
							end
						elseif ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_len := l_len + l_buffer_off
							l_buffer[l_len] := (('%/0/').code).to_natural_8
							l_p___0 := l_buffer
							from
							until
								not (not (l_break) and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_buffer + l_len).c_pointer.to_integer_32).to_natural_32))
							loop
								l_break := False
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_l___1 := ((create {P_MBYTE_STATIC}).utf_ptr2len (l_p___0))
								else
									l_l___1 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
								end
								if l_l___1 = 0 then
									l_l___1 := 1
								elseif ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_p___0.item).to_integer_32]).to_integer_32 /= l_l___1 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_p___0 := l_p___0 + l_l___1
								end
							end
							l_break := False
							if l_p___0.is_equal (l_buffer) then
								if l_len >= 12 then
									l_p___0 := l_p___0 + 1
								else
									l_buffer_off := l_len
									l_continue := True
								end
							end
							if not (l_return or l_break or l_continue) then
								l_c := (l_p___0.item).to_integer_32
								l_p___0.item := (('%/0/').code).to_natural_8;
								(create {P_MESSAGE_STATIC}).msg_puts (l_buffer)
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_buffer + l_len).c_pointer.to_integer_32).to_natural_32 then
									l_p___0.item := l_c.to_natural_8
									l_buffer_off := (l_buffer + l_len).distance (l_p___0)
									memmove (create {CE_VOID_POINTER}.make_cast (l_buffer), create {CE_VOID_POINTER}.make_cast (l_p___0), l_buffer_off.to_natural_32).do_nothing
									l_continue := True
								end
							end
							if not (l_return or l_break or l_continue) then
								l_buffer_off := 0
							end
						else
							l_buffer[l_len] := (('%/0/').code).to_natural_8;
							(create {P_MESSAGE_STATIC}).msg_puts (l_buffer)
						end
				when 89 then -- if done
						if not (l_return or l_break or l_continue) then
							(create {P_SCREEN_STATIC}).windgoto ((create {P_GLOBALS_STATIC}).msg_row.item, (create {P_GLOBALS_STATIC}).msg_col.item);
							(create {P_TERM_STATIC}).cursor_on;
							(create {P_TERM_STATIC}).out_flush
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) then
							gettimeofday (l_now_tv, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
							l_msec := (l_now_tv.item.tv_sec - l_start_tv.item.tv_sec) * 1_000 + (l_now_tv.item.tv_usec - l_start_tv.item.tv_usec) // 1_000
							if l_msec > 2_000 then
								l_noread_cnt := 5
								l_break := True
							end
						end
						l_pos := -1 + 85 -- back to loop condition
				when 90 then -- loop done
						l_break := False
						l_continue := False
						if l_wait_pid = l_pid then
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 95 -- skip if block
						end
				when 91 then -- if:
						l_wait_pid := waitpid (l_pid, l_status, 1)
						if l_wait_pid /= -1 then
							l_pos := -1 + 94 -- skip if block
						end
				when 92 then -- if:
						if (errno_location).item = 10 then
							l_wait_pid := l_pid
						else
							l_pos := -1 + 94 -- goto _L___10
						end
				when 93 then -- if block done, skip else block:
						l_pos := -1 + 95
				when 94 then -- else: | _L___10:
						if l_wait_pid = l_pid then
							l___constr_expr_0.in := l_status.item
							l___constr_expr_0.update_class_fields -- synchronize union
							if ((l___constr_expr_0.i).bit_and (127)) = 0 then
								l_wait_pid := l_pid
							else
								l_wait_pid := 0
							end
						else
							l_wait_pid := 0
						end
				when 95 then -- if done
						l_pos := -1 + 40 -- back to loop condition
				when 96 then -- loop done
						l_break := False
				when 97 then -- finished:;
						(create {P_OPTION_STATIC}).p_more.item.item := l_p_more_save
						if ((a_options___0).bit_and (32)).to_boolean then
							if l_ga.item.ga_len > 0 then
								l_ga.item.append_ga_line;
								(create {P_GLOBALS_STATIC}).write_no_eol_lnum.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
							else
								(create {P_GLOBALS_STATIC}).write_no_eol_lnum.item := (0).to_integer_32
							end
							l_ga.item.ga_clear
						end
						if l_ta_len___0.to_boolean then
							(create {P_UI_STATIC}).ui_inchar_undo (l_ta_buf, l_ta_len___0)
						end
						(create {P_GLOBALS_STATIC}).State.item := l_old_State
						if l_toshell_fd >= 0 then
							close (l_toshell_fd).do_nothing
						end
						close (l_fromshell_fd).do_nothing
				when 98 then -- if done | if done
						from
						until
							not (not (l_break) and then (l_wait_pid /= l_pid))
						loop
							l_break := False
							l_wait_pid := wait (create {CE_CLASS_POINTER [SD_WAIT]}.make_cast (l_status))
							if l_wait_pid <= 0 then
								if (errno_location).item = 10 then
									l_break := True
								end
							end
						end
						l_break := False
						if l_wpid > 0 then
							kill (l_wpid, 9).do_nothing
						end
						if l_tmode = 2 then
							(create {P_TERM_STATIC}).settmode (2)
						end
						l_did_settmode := 1
						set_signals
						l___constr_expr_2.in := l_status.item
						l___constr_expr_2.update_class_fields -- synchronize union
						if ((l___constr_expr_2.i).bit_and (127)) = 0 then
							l___constr_expr_1.in := l_status.item
							l___constr_expr_1.update_class_fields -- synchronize union
							l_retval := (((l___constr_expr_1.i).bit_and (65_280))).bit_shift_right (8)
							if l_retval.to_boolean then
								if not ((create {P_GLOBALS_STATIC}).emsg_silent.item).to_boolean then
									if l_retval = 122 then
										(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%NCannot execute shell ")))));
										(create {P_MESSAGE_STATIC}).msg_outtrans ((create {P_OPTION_STATIC}).p_sh.item.item).do_nothing;
										(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
									elseif not ((a_options___0).bit_and (16)).to_boolean then
										(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%Nshell returned ")))));
										(create {P_MESSAGE_STATIC}).msg_outnum (l_retval.to_integer_32);
										(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
									end
								end
							end
						else
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%NCommand terminated%N")))))
						end
				when 99 then -- if done | if done;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_argv))
				when 100 then -- error:
					if not l_did_settmode.to_boolean then
						if l_tmode = 2 then
							(create {P_TERM_STATIC}).settmode (2)
						end
					end
					(create {P_BUFFER_STATIC}).resettitle;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_newcmd))
					Result := l_retval
				when 101 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mch_breakcheck
		do
			if curr_tmode.item = 2 then
				if (RealWaitForChar ((create {P_GLOBALS_STATIC}).read_cmd_fd.item, 0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))).to_boolean then
					(create {P_UI_STATIC}).fill_input_buf (0)
				end
			end
		end

	WaitForChar (a_msec: INTEGER_32): INTEGER_32
		local
			l_msec: INTEGER_32
			l_rest___0: INTEGER_32
			l_avail: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_msec := a_msec
			if ((create {P_GETCHAR_STATIC}).input_available).to_boolean then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_rest___0 := 0
				if (do_xterm_trace).to_boolean then
					l_rest___0 := l_msec.to_integer_32
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if l_rest___0 /= 0 then
						l_msec := 50
						if l_rest___0 >= 0 then
							if l_rest___0 < 50 then
								l_msec := l_rest___0.to_integer_32
							end
						end
						if l_rest___0 >= 0 then
							l_rest___0 := (l_rest___0.to_integer_32 - l_msec).to_integer_32
						end
					end
					l_avail := RealWaitForChar ((create {P_GLOBALS_STATIC}).read_cmd_fd.item, l_msec, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
					if not l_avail.to_boolean then
						if ((create {P_GETCHAR_STATIC}).input_available).to_boolean then
							Result := 1
							l_return := True
						end
						if not l_return then
							if l_rest___0 = 0 then
								l_break := True
							elseif not (do_xterm_trace).to_boolean then
								l_break := True
							end
						end
					end
					if not (l_return or l_break) then
						if not l_avail.to_boolean then
							if l_rest___0 = 0 then
								l_break := True
							end
						else
							l_break := True
						end
					end
				end
			end
			if not l_return then
				l_break := False
				Result := l_avail
			end
		end

	RealWaitForChar (a_fd: INTEGER_32; a_msec: INTEGER_32; a_check_for_gpm: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_fd: CE_ARRAY [INTEGER_32]
			l_msec: INTEGER_32
			l_ret: INTEGER_32
			l_nb_fd: CE_ARRAY [INTEGER_32]
			l_start_tv: CE_ARRAY [SD_TIMEVAL]
			l_finished: INTEGER_32
			l_tv: CE_ARRAY [SD_TIMEVAL]
			l_tvp: CE_POINTER [SD_TIMEVAL]
			l_rfds: CE_ARRAY [SD_FD_SET]
			l_efds: CE_ARRAY [SD_FD_SET]
			l_maxfd: INTEGER_32
			l_towait: INTEGER_32
			l___d0: CE_ARRAY [INTEGER_32]
			l___d1: CE_ARRAY [INTEGER_32]
			l___d0___0: CE_ARRAY [INTEGER_32]
			l___d1___0: CE_ARRAY [INTEGER_32]
			l___result: CE_ARRAY [INTEGER_8]
			l___result___0: CE_ARRAY [INTEGER_8]
			l___result___1: CE_ARRAY [INTEGER_8]
			l___result___2: CE_ARRAY [INTEGER_8]
			l_mtv: CE_ARRAY [SD_TIMEVAL]
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_fd.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_nb_fd.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_start_tv.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_tv.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_FD_SET]} l_rfds.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_FD_SET]} l_efds.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d1.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d0___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d1___0.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l___result.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l___result___0.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l___result___1.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l___result___2.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_mtv.make (<<1>>)

			l_fd.item := a_fd
			l_msec := a_msec
			l_nb_fd.item := ((create {P_NETBEANS_STATIC}).netbeans_filedesc)
			if l_msec > 0 then
				if not xterm_Shell.item.is_void then
					gettimeofday (l_start_tv, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
				elseif (create {P_GLOBALS_STATIC}).xsmp_icefd.item.item /= -1 then
					gettimeofday (l_start_tv, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
				end
			end
			if busy___0.item.to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_finished := 1
					l_towait := l_msec
					if l_towait >= 0 then
						l_tv.item.tv_sec := l_towait // 1_000
						l_tv.item.tv_usec := (l_towait \\ 1_000) * 1_000
						l_tvp := l_tv
					else
						l_tvp := create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer)
					end
					from
					until
						(l_break)
					loop
						l_break := False
						asm3 (l___d0, l___d1, l_rfds)
						l_break := True
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						asm4 (l___d0___0, l___d1___0, l_efds)
						l_break := True
					end
					l_break := False
					asm5 (l_rfds, l_fd)
					asm6 (l_efds, l_fd)
					l_maxfd := l_fd.item
					if not xterm_Shell.item.is_void then
						asm7 (l_rfds, (create {P_GLOBALS_STATIC}).xterm_dpy.item)
						if l_maxfd < (create {CE_CLASS_POINTER [SD_XPRIVDISPLAY]}.make_cast ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item)).item.fd then
							l_maxfd := (create {CE_CLASS_POINTER [SD_XPRIVDISPLAY]}.make_cast ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item)).item.fd
						end
					end
					if (create {P_GLOBALS_STATIC}).xsmp_icefd.item.item /= -1 then
						asm8 (l_rfds, (create {P_GLOBALS_STATIC}).xsmp_icefd.item)
						asm9 (l_efds, (create {P_GLOBALS_STATIC}).xsmp_icefd.item)
						if l_maxfd < (create {P_GLOBALS_STATIC}).xsmp_icefd.item.item then
							l_maxfd := (create {P_GLOBALS_STATIC}).xsmp_icefd.item.item
						end
					end
					if l_nb_fd.item /= -1 then
						asm10 (l_rfds, l_nb_fd)
						if l_maxfd < l_nb_fd.item then
							l_maxfd := l_nb_fd.item
						end
					end
					l_ret := select2 (l_maxfd + 1, l_rfds, create {CE_CLASS_POINTER [SD_FD_SET]}.make_shared (default_pointer), l_efds, l_tvp)
					if l_ret > 0 then
						if not xterm_Shell.item.is_void then
							asm11 (l___result, (create {P_GLOBALS_STATIC}).xterm_dpy.item, l_rfds)
							if (l___result.item).to_boolean then
								xterm_update
								l_ret := l_ret - 1
								if l_ret = 0 then
									if not ((create {P_GETCHAR_STATIC}).input_available).to_boolean then
										l_finished := 0
									end
								end
							end
						end
					end
					if l_ret > 0 then
						if (create {P_GLOBALS_STATIC}).xsmp_icefd.item.item /= -1 then
							asm12 (l___result___1, (create {P_GLOBALS_STATIC}).xsmp_icefd.item, l_efds)
							if (l___result___1.item).to_boolean then
								if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
									(create {P_MESSAGE_STATIC}).verb_msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("XSMP lost ICE connection"))))).do_nothing
								end
								xsmp_close
								l_ret := l_ret - 1
								if l_ret = 0 then
									l_finished := 0
								end
							else
								asm13 (l___result___0, (create {P_GLOBALS_STATIC}).xsmp_icefd.item, l_rfds)
								if (l___result___0.item).to_boolean then
									busy___0.item := 1
									xsmp_handle_requests.do_nothing
									busy___0.item := 0
									l_ret := l_ret - 1
									if l_ret = 0 then
										l_finished := 0
									end
								end
							end
						end
					end
					if l_ret > 0 then
						if l_nb_fd.item /= -1 then
							asm14 (l___result___2, l_nb_fd, l_rfds)
							if (l___result___2.item).to_boolean then
								(create {P_NETBEANS_STATIC}).netbeans_read
								l_ret := l_ret - 1
							end
						end
					end
					if l_finished.to_boolean then
						l_break := True
					elseif l_msec = 0 then
						l_break := True
					end
					if not (l_return or l_break) and then (l_msec > 0) then
						gettimeofday (l_mtv, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
						l_msec := l_msec - ((l_mtv.item.tv_sec - l_start_tv.item.tv_sec) * 1_000 + (l_mtv.item.tv_usec - l_start_tv.item.tv_usec) // 1_000)
						if l_msec <= 0 then
							l_break := True
						end
					end
				end
				l_break := False
				Result := (l_ret > 0).to_integer
			end
		end

	mch_expand_wildcards (a_num_pat: INTEGER_32; a_pat: CE_POINTER [CE_POINTER [NATURAL_8]]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_flags___0: INTEGER_32): INTEGER_32
		require
			not a_num_file.is_void
			not a_file.is_void
		local
			l_i___0: INTEGER_32
			l_len: NATURAL_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_dir___0: INTEGER_32
			l_j: INTEGER_32
			l_tempname: CE_POINTER [NATURAL_8]
			l_command: CE_POINTER [NATURAL_8]
			l_fd: CE_POINTER [SD_IO_FILE]
			l_buffer: CE_POINTER [NATURAL_8]
			l_shell_style: INTEGER_32
			l_check_spaces: INTEGER_32
			l_ampersent: INTEGER_32
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_intick: INTEGER_32
			l_tmp___16: CE_POINTER [NATURAL_8]
			l_tmp___17: CE_POINTER [NATURAL_8]
			l_tmp___19: CE_POINTER [NATURAL_8]
			l_tmp___21: CE_POINTER [NATURAL_8]
			l_tmp___30: CE_POINTER [NATURAL_8]
			l_tmp___34: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_command.make
			create {CE_CLASS_POINTER [SD_IO_FILE]} l_fd.make
			create {CE_NATURAL_8_POINTER} l_buffer.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_shell_style := 0
					l_ampersent := 0
					a_num_file.item := 0
					a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
					if not (have_wildcard (a_num_pat, a_pat)).to_boolean then
						Result := (save_patterns (a_num_pat, a_pat, a_num_file, a_file))
						l_return := True
					end
					if not l_return and then ((create {P_GLOBALS_STATIC}).sandbox.item /= 0) then
						if ((create {P_EX_CMDS_STATIC}).check_secure).to_boolean then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_GLOBALS_STATIC}).secure.item).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (((create {P_GLOBALS_STATIC}).restricted.item).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_i___0 := 0
						from
						until
							not (not (l_return) and then (l_i___0 < a_num_pat))
						loop
							if not ((create {P_MISC2_STATIC}).vim_strchr (a_pat[l_i___0], ('`').code)).is_void then
								if ((create {P_EX_CMDS_STATIC}).check_restricted).to_boolean then
									Result := 0
									l_return := True
								elseif ((create {P_EX_CMDS_STATIC}).check_secure).to_boolean then
									Result := 0
									l_return := True
								end
							end
							if not l_return then
								l_i___0 := l_i___0 + 1
							end
						end
				when 6 then -- if done | if done
					if not l_return then
						l_tempname := (create {P_FILEIO_STATIC}).vim_tempname (('o').code)
						if l_tempname.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_notmp.item)))))).do_nothing
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 7 then -- if:
						if a_num_pat /= 1 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if ((a_pat[0]).item).to_integer_32 = 96 then
							l_len := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_pat[0]))
							if l_len > {NATURAL_32} 2 then
								if ((a_pat[0] + l_len.to_integer_32)[-1]).to_integer_32 = 96 then
									l_shell_style := 4
								else
									l_pos := -1 + 10 -- goto _L___2
								end
							else
								l_pos := -1 + 10 -- goto _L___2
							end
						else
							l_pos := -1 + 10 -- goto _L___2
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___2:
						l_len := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_sh.item.item))
						if l_len >= {NATURAL_32} 3 then
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((((create {P_OPTION_STATIC}).p_sh.item.item + l_len.to_integer_32) - 3)), ce_string ("csh"))) = 0 then
								l_shell_style := 1
							elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((((create {P_OPTION_STATIC}).p_sh.item.item + l_len.to_integer_32) - 3)), ce_string ("zsh"))) = 0 then
								l_shell_style := 3
							end
						end
				when 11 then
						if l_shell_style = 0 then
							if not (strstr (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC1_STATIC}).gettail ((create {P_OPTION_STATIC}).p_sh.item.item))), ce_string ("sh"))).is_void then
								l_shell_style := 2
							end
						end
						l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tempname))) + {NATURAL_32} 29
						if l_shell_style = 2 then
							l_len := l_len + (strlen (sh_vimglob_func.item))
						end
						l_i___0 := 0
						from
						until
							not (not (l_return) and then (l_i___0 < a_num_pat))
						loop
							l_len := l_len + 1
							l_j := 0
							from
							until
								((a_pat[l_i___0])[l_j]).to_integer_32 = 0
							loop
								if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%T %"&%'$;<>()\|")), ((a_pat[l_i___0])[l_j]).to_integer_32)).is_void then
									l_len := l_len + 1
								end
								l_len := l_len + 1
								l_j := l_j + 1
							end
							l_i___0 := l_i___0 + 1
						end
						l_command := (create {P_MISC2_STATIC}).alloc (l_len)
						if l_command.is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tempname))
							Result := 0
							l_return := True
						end
				when 12 then -- if done
					if l_return then
						l_pos := -1 + 28 -- skip if block
					end
				when 13 then -- if:
						if l_shell_style = 4 then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_command), ce_string ("(")).do_nothing
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_command), create {CE_INTEGER_8_POINTER}.make_cast ((a_pat[0] + 1))).do_nothing
							l_p___0 := (l_command + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_command))).to_integer_32) - 1
							l_tmp___14 := l_p___0
							l_p___0 := l_p___0 - 1
							l_tmp___14.item := ((')').code).to_natural_8
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_command.c_pointer.to_integer_32).to_natural_32 then
									if (l_p___0.item).to_integer_32 /= 32 then
										if (l_p___0.item).to_integer_32 /= 9 then
											l_break := True
										end
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_p___0 := l_p___0 - 1
								end
							end
							l_break := False
							if (l_p___0.item).to_integer_32 = 38 then
								l_ampersent := 1
								l_p___0.item := ((' ').code).to_natural_8
							end
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_command), ce_string (">")).do_nothing
						else
							if ((a_flags___0).bit_and (4)).to_boolean then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_command), ce_string ("set nonomatch; ")).do_nothing
							else
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_command), ce_string ("unset nonomatch; ")).do_nothing
							end
							if l_shell_style = 1 then
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_command), ce_string ("glob >")).do_nothing
							elseif l_shell_style = 3 then
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_command), ce_string ("print -N >")).do_nothing
							elseif l_shell_style = 2 then
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_command), sh_vimglob_func.item).do_nothing
							else
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_command), ce_string ("echo >")).do_nothing
							end
						end
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_command), create {CE_INTEGER_8_POINTER}.make_cast (l_tempname)).do_nothing
						if l_shell_style = 4 then
							l_pos := -1 + 27 -- skip if block
						end
				when 14 then -- if:
						l_i___0 := 0
				when 15 then -- loop condition:
						if not (not (l_return) and then (l_i___0 < a_num_pat)) then
							l_pos := -1 + 27 -- skip loop
						end
				when 16 then -- loop body:
						l_intick := 0
						l_p___0 := l_command + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_command))).to_integer_32
						l_tmp___16 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___16.item := ((' ').code).to_natural_8
						l_j := 0
				when 17 then -- loop condition:
						if ((a_pat[l_i___0])[l_j]).to_integer_32 = 0 then
							l_pos := -1 + 26 -- skip loop
						end
				when 18 then -- loop body:
						if ((a_pat[l_i___0])[l_j]).to_integer_32 /= 96 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_intick := (not l_intick.to_boolean).to_integer
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else:
						if ((a_pat[l_i___0])[l_j]).to_integer_32 /= 92 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if ((a_pat[l_i___0])[(l_j + 1)]).to_integer_32 /= 0 then
							if l_intick.to_boolean then
								l_tmp___17 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___17.item := (('\').code).to_natural_8
							elseif not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%T %"&%'$;<>()\|")), ((a_pat[l_i___0])[(l_j + 1)]).to_integer_32)).is_void then
								l_tmp___17 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___17.item := (('\').code).to_natural_8
							elseif ((a_pat[l_i___0])[(l_j + 1)]).to_integer_32 = 96 then
								l_tmp___17 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___17.item := (('\').code).to_natural_8
							end
							l_j := l_j + 1
						else
							l_pos := -1 + 24 -- goto _L___3
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L___3:
						if not l_intick.to_boolean then
							if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%T %"&%'$;<>()\|")), ((a_pat[l_i___0])[l_j]).to_integer_32)).is_void then
								l_tmp___19 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___19.item := (('\').code).to_natural_8
							end
						end
				when 25 then -- if done
						l_tmp___21 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___21.item := (a_pat[l_i___0])[l_j]
						l_j := l_j + 1
						l_pos := -1 + 17 -- back to loop condition
				when 26 then -- loop done
						l_p___0.item := (('%/0/').code).to_natural_8
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 15 -- back to loop condition
				when 27 then -- loop done | if done
						if ((a_flags___0).bit_and (32)).to_boolean then
							show_shell_mess.item := 0
						end
						if l_ampersent.to_boolean then
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_command), ce_string ("&")).do_nothing
						end
						if l_shell_style = 3 then
							extra_shell_arg.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-G"))
						elseif l_shell_style = 1 then
							if not (have_dollars (a_num_pat, a_pat)).to_boolean then
								extra_shell_arg.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-f"))
							end
						end
						l_i___0 := (create {P_MISC2_STATIC}).call_shell (l_command, 18)
						if l_ampersent.to_boolean then
							mch_delay (10, 1)
						end
						extra_shell_arg.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						show_shell_mess.item := 1;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_command))
						if l_i___0 /= 0 then
							unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tempname)).do_nothing;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tempname))
							if not ((a_flags___0).bit_and (32)).to_boolean then
								(create {P_SCREEN_STATIC}).redraw_later_clear;
								(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code);
								(create {P_GLOBALS_STATIC}).cmdline_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32;
								(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_wildexpand.item)))))).do_nothing;
								(create {P_MESSAGE_STATIC}).msg_start
							end
							if l_shell_style = 4 then
								Result := 0
								l_return := True
							end
							if not l_return then
								l_pos := -1 + 75 -- goto notfound
							end
						end
				when 28 then
					if l_return then
						l_pos := -1 + 31 -- skip if block
					end
				when 29 then -- if:
						l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_tempname), ce_string ("r"))
						if l_fd.is_void then
							if not ((a_flags___0).bit_and (32)).to_boolean then
								(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_wildexpand.item)))))).do_nothing;
								(create {P_MESSAGE_STATIC}).msg_start
							end
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tempname))
							l_pos := -1 + 75 -- goto notfound
						end
				when 30 then
						fseek (l_fd, 0, 2).do_nothing
						l_len := (ftell (l_fd)).to_natural_32
						fseek (l_fd, 0, 0).do_nothing
						l_buffer := (create {P_MISC2_STATIC}).alloc (l_len + {NATURAL_32} 1)
						if l_buffer.is_void then
							unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tempname)).do_nothing;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tempname))
							fclose (l_fd).do_nothing
							Result := 0
							l_return := True
						end
				when 31 then -- if done
					if not l_return then
						l_i___0 := (fread (create {CE_VOID_POINTER}.make_cast (l_buffer), (1).to_natural_32, l_len, l_fd)).to_integer_32
						fclose (l_fd).do_nothing
						unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tempname)).do_nothing
						if l_i___0 /= l_len.to_integer_32 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_notread.item))))), l_tempname).do_nothing;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tempname));
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buffer))
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 44 -- skip if block
					end
				when 32 then -- if:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tempname))
						if l_shell_style /= 0 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_buffer[l_len.to_integer_32] := (('%N').code).to_natural_8
						l_p___0 := l_buffer
						l_i___0 := 0
						from
						until
							not (not (l_return) and then ((l_p___0.item).to_integer_32 /= 10))
						loop
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_p___0.item).to_integer_32 /= 32 then
									if (l_p___0.item).to_integer_32 = 10 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_p___0 := l_p___0 + 1
								end
							end
							l_break := False
							l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
							l_i___0 := l_i___0 + 1
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 35 then -- else:
						if l_shell_style /= 4 then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						l_pos := -1 + 39 -- goto _L___4
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 38 then -- else:
						if l_shell_style /= 2 then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if: | _L___4:
						l_buffer[l_len.to_integer_32] := (('%/0/').code).to_natural_8
						l_p___0 := l_buffer
						l_i___0 := 0
						from
						until
							not (not (l_return) and then ((l_p___0.item).to_integer_32 /= 0))
						loop
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_p___0.item).to_integer_32 /= 10 then
									if (l_p___0.item).to_integer_32 = 0 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_p___0 := l_p___0 + 1
								end
							end
							l_break := False
							if (l_p___0.item).to_integer_32 /= 0 then
								l_p___0 := l_p___0 + 1
							end
							l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
							l_i___0 := l_i___0 + 1
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else:
						l_check_spaces := 0
						if l_shell_style = 3 then
							if not did_find_nul.item.to_boolean then
								if l_len.to_boolean then
									if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buffer))).to_integer_32 < l_len.to_integer_32 - 1 then
										did_find_nul.item := 1
									else
										l_check_spaces := 1
									end
								else
									l_check_spaces := 1
								end
							end
						end
						if l_len.to_boolean then
							if (l_buffer[(l_len - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 0 then
								l_len := l_len - 1
							else
								l_buffer[l_len.to_integer_32] := (('%/0/').code).to_natural_8
							end
						else
							l_buffer[l_len.to_integer_32] := (('%/0/').code).to_natural_8
						end
						l_i___0 := 0
						l_p___0 := l_buffer
						from
						until
							not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_buffer + l_len.to_integer_32).c_pointer.to_integer_32).to_natural_32)
						loop
							if (l_p___0.item).to_integer_32 = 0 then
								l_i___0 := l_i___0 + 1
								l_p___0.item := (('%/0/').code).to_natural_8
							elseif (l_p___0.item).to_integer_32 = 32 then
								if l_check_spaces.to_boolean then
									l_i___0 := l_i___0 + 1
									l_p___0.item := (('%/0/').code).to_natural_8
								end
							end
							l_p___0 := l_p___0 + 1
						end
						if l_len.to_boolean then
							l_i___0 := l_i___0 + 1
						end
				when 42 then -- if done | if done
						if l_i___0 = 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buffer))
							l_pos := -1 + 75 -- goto notfound
						end
				when 43 then
						a_num_file.item := l_i___0
						a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (((create {P_MISC2_STATIC}).alloc ({PLATFORM}.Pointer_bytes.to_natural_32 * l_i___0.to_natural_32)))
						if (a_file.item).is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buffer))
							Result := 0
							l_return := True
						end
				when 44 then -- if done
					if l_return then
						l_pos := -1 + 74 -- skip if block
					end
				when 45 then -- if:
						l_p___0 := l_buffer
						l_i___0 := 0
				when 46 then -- loop condition:
						if not (not (l_return) and then (l_i___0 < a_num_file.item)) then
							l_pos := -1 + 64 -- skip loop
						end
				when 47 then -- loop body:
						a_file.item[l_i___0] := l_p___0
						if l_shell_style /= 0 then
							l_pos := -1 + 50 -- skip if block
						end
				when 48 then -- if:
						l_pos := -1 + 54 -- goto _L___6
				when 49 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 50 then -- else:
						if l_shell_style /= 4 then
							l_pos := -1 + 53 -- skip if block
						end
				when 51 then -- if:
						l_pos := -1 + 54 -- goto _L___6
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 53 then -- else:
						if l_shell_style /= 2 then
							l_pos := -1 + 62 -- skip if block
						end
				when 54 then -- if: | _L___6:
						if (l_break) then
							l_pos := -1 + 60 -- skip loop
						end
				when 55 then -- loop body:
						l_break := False
						if l_shell_style /= 0 then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						if (l_p___0.item).to_integer_32 = 32 then
							l_break := True
						else
							l_pos := -1 + 58 -- goto _L___5
						end
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 59
				when 58 then -- else: | _L___5:
						if (l_p___0.item).to_integer_32 /= 10 then
							if (l_p___0.item).to_integer_32 = 0 then
								l_break := True
							end
						else
							l_break := True
						end
				when 59 then
						if not (l_return or l_break) then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 54 -- back to loop condition
				when 60 then -- loop done
						l_break := False
						if l_p___0.is_equal (l_buffer + l_len.to_integer_32) then
							l_p___0.item := (('%/0/').code).to_natural_8
						else
							l_tmp___30 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___30.item := (('%/0/').code).to_natural_8
							l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
						end
				when 61 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 62 then -- else:
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0.item).to_boolean then
								if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_buffer + l_len.to_integer_32).c_pointer.to_integer_32).to_natural_32) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						l_p___0 := l_p___0 + 1
				when 63 then -- if done | if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 46 -- back to loop condition
				when 64 then -- loop done
						l_j := 0
						l_i___0 := 0
				when 65 then -- loop condition:
						if not (l_i___0 < a_num_file.item) then
							l_pos := -1 + 72 -- skip loop
						end
				when 66 then -- loop body:
						l_continue := False
						if not ((a_flags___0).bit_and (4)).to_boolean then
							if (mch_getperm (a_file.item[l_i___0])) < 0 then
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 71 -- skip if block
						end
				when 67 then -- if:
						l_dir___0 := mch_isdir (a_file.item[l_i___0])
						if not (l_dir___0.to_boolean) then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						if not ((a_flags___0).bit_and (1)).to_boolean then
							l_continue := True
						else
							l_pos := -1 + 70 -- goto _L___7
						end
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 71
				when 70 then -- else: | _L___7:
						if not l_dir___0.to_boolean then
							if not ((a_flags___0).bit_and (2)).to_boolean then
								l_continue := True
							end
						end
				when 71 then -- if done
						if not (l_return or l_break or l_continue) and then (not l_dir___0.to_boolean) then
							if ((a_flags___0).bit_and (64)).to_boolean then
								if not (mch_can_exe (a_file.item[l_i___0])).to_boolean then
									l_continue := True
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_p___0 := (create {P_MISC2_STATIC}).alloc (((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_file.item[l_i___0]))) + {NATURAL_32} 1) + l_dir___0.to_natural_32)
							if (not l_p___0.is_void) then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), create {CE_INTEGER_8_POINTER}.make_cast (a_file.item[l_i___0])).do_nothing
								if l_dir___0.to_boolean then
									(create {P_MISC1_STATIC}).add_pathsep (l_p___0)
								end
								l_tmp___34 := l_j
								l_j := l_j + 1
								a_file.item[l_tmp___34] := l_p___0
							end
						end
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 65 -- back to loop condition
				when 72 then -- loop done
						l_continue := False;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buffer))
						a_num_file.item := l_j
						if a_num_file.item = 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_file.item))
							a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
							l_pos := -1 + 75 -- goto notfound
						end
				when 73 then
						Result := 1
						l_return := True
				when 74 then -- if done
					if l_return then
						l_pos := -1 + 76 -- skip if block
					end
				when 75 then -- if: | notfound:
						if ((a_flags___0).bit_and (4)).to_boolean then
							Result := (save_patterns (a_num_pat, a_pat, a_num_file, a_file))
							l_return := True
						end
				when 76 then -- if done
					if not l_return then
						Result := 0
					end
				when 77 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	save_patterns (a_num_pat: INTEGER_32; a_pat: CE_POINTER [CE_POINTER [NATURAL_8]]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		require
			not a_file.is_void
		local
			l_i___0: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (((create {P_MISC2_STATIC}).alloc (a_num_pat.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
			if (a_file.item).is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_num_pat)
				loop
					l_s := (create {P_MISC2_STATIC}).vim_strsave (a_pat[l_i___0])
					if not l_s.is_void then
						(create {P_CHARSET_STATIC}).backslash_halve (l_s)
					end
					a_file.item[l_i___0] := l_s
					l_i___0 := l_i___0 + 1
				end
				a_num_file.item := a_num_pat
				Result := 1
			end
		end

	mch_has_exp_wildcard (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_p___0
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_p___0.item).to_boolean)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						if (l_p___0.item).to_integer_32 /= 92 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_p___0 := l_p___0 + 1
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("*?[{%'")), (l_p___0.item).to_integer_32)).is_void then
							Result := 1
							l_return := True
						end
				when 6 then
						if not l_return then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
							else
								l_tmp___0 := 1
							end
							l_p___0 := l_p___0 + l_tmp___0
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mch_has_wildcard (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_p___0
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_p___0.item).to_boolean)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						if (l_p___0.item).to_integer_32 /= 92 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_p___0 := l_p___0 + 1
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("*?[{`%'$")), (l_p___0.item).to_integer_32)).is_void then
							Result := 1
							l_return := True
						elseif (l_p___0.item).to_integer_32 = 126 then
							if (l_p___0[1]).to_integer_32 /= 0 then
								Result := 1
								l_return := True
							end
						end
				when 6 then
						if not l_return then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
							else
								l_tmp___0 := 1
							end
							l_p___0 := l_p___0 + l_tmp___0
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	have_wildcard (a_num: INTEGER_32; a_file: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				not (not (l_return) and then (l_i___0 < a_num))
			loop
				if (mch_has_wildcard (a_file[l_i___0])).to_boolean then
					Result := 1
					l_return := True
				end
				if not l_return then
					l_i___0 := l_i___0 + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	have_dollars (a_num: INTEGER_32; a_file: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				not (not (l_return) and then (l_i___0 < a_num))
			loop
				if not ((create {P_MISC2_STATIC}).vim_strchr (a_file[l_i___0], ('$').code)).is_void then
					Result := 1
					l_return := True
				end
				if not l_return then
					l_i___0 := l_i___0 + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	mch_libcall (a_libname, a_funcname, a_argstring: CE_POINTER [NATURAL_8]; a_argint: INTEGER_32; a_string_result: CE_POINTER [CE_POINTER [NATURAL_8]]; a_number_result: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_hinstLib: CE_POINTER [ANY]
			l_dlerr: CE_POINTER [INTEGER_8]
			l_ProcAdd: CE_ROUTINE
			l_ProcAddI: CE_ROUTINE
			l_retval_str: CE_POINTER [NATURAL_8]
			l_retval_int: INTEGER_32
			l_success___0: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_i___0: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dlerr := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_retval_str := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_retval_int := 0
					l_success___0 := 0
					dlerror.do_nothing
					l_hinstLib := dlopen (create {CE_INTEGER_8_POINTER}.make_cast (a_libname), 1)
					if l_hinstLib.is_void then
						l_dlerr := (dlerror)
						if not l_dlerr.is_void then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("dlerror = %"%%s%"")))), create {CE_NATURAL_8_POINTER}.make_cast (l_dlerr)).do_nothing
						end
					end
					if l_hinstLib.is_void then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						mch_startjmp;
						(create {P_GLOBALS_STATIC}).lc_jump_env.item := create {CE_EXCEPTION}.make ($mch_libcall, l_pos, $l_tmp___7)
				when 2 then -- continue here on raising lc_jump_env:
						if l_tmp___7 /= 0 then
							l_success___0 := 0
							l_dlerr := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							mch_didjmp
						else
							l_retval_str := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							l_retval_int := 0
							if not a_argstring.is_void then
								l_ProcAdd := create {CE_ROUTINE}.make_cast ((dlsym (l_hinstLib, create {CE_INTEGER_8_POINTER}.make_cast (a_funcname))))
								l_dlerr := (dlerror)
								if not l_ProcAdd.is_void then
									if l_dlerr.is_void then
										l_tmp___3 := 1
									else
										l_tmp___3 := 0
									end
								else
									l_tmp___3 := 0
								end
								l_success___0 := l_tmp___3
								if l_success___0.to_boolean then
									if a_string_result.is_void then
										l_retval_int := l_ProcAdd.integer_32_item ([a_argstring])
									else
										l_retval_str := create {CE_NATURAL_8_POINTER}.make_cast (l_ProcAdd.pointer_item ([a_argstring]))
									end
								end
							else
								l_ProcAddI := create {CE_ROUTINE}.make_cast ((dlsym (l_hinstLib, create {CE_INTEGER_8_POINTER}.make_cast (a_funcname))))
								l_dlerr := (dlerror)
								if not l_ProcAddI.is_void then
									if l_dlerr.is_void then
										l_tmp___6 := 1
									else
										l_tmp___6 := 0
									end
								else
									l_tmp___6 := 0
								end
								l_success___0 := l_tmp___6
								if l_success___0.to_boolean then
									if a_string_result.is_void then
										l_retval_int := l_ProcAddI.integer_32_item ([a_argint])
									else
										l_retval_str := create {CE_NATURAL_8_POINTER}.make_cast (l_ProcAddI.pointer_item ([a_argint]))
									end
								end
							end
							if a_string_result.is_void then
								a_number_result.item := l_retval_int
							elseif not l_retval_str.is_void then
								if (l_retval_str.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_NATURAL_8_POINTER}.make_shared (default_pointer + 1)).c_pointer.to_integer_32).to_natural_32 then
									if (l_retval_str.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_NATURAL_8_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
										a_string_result.item := (create {P_MISC2_STATIC}).vim_strsave (l_retval_str)
									end
								end
							end
						end
						mch_endjmp
						if (create {P_GLOBALS_STATIC}).lc_signal.item /= 0 then
							l_i___0 := 0
							from
							until
								not (not (l_break) and then (signal_info.item[l_i___0].sig /= -1))
							loop
								l_break := False
								if (create {P_GLOBALS_STATIC}).lc_signal.item = signal_info.item[l_i___0].sig then
									l_break := True
								end
								if not (l_break) then
									l_i___0 := l_i___0 + 1
								end
							end
							l_break := False;
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E368: got SIG%%s in libcall()")), create {CE_NATURAL_8_POINTER}.make_cast (signal_info.item[l_i___0].name)).do_nothing
						end
						if not l_dlerr.is_void then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("dlerror = %"%%s%"")))), create {CE_NATURAL_8_POINTER}.make_cast (l_dlerr)).do_nothing
						end
						dlclose (l_hinstLib).do_nothing
				when 3 then -- if done
					if not l_success___0.to_boolean then
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_libcall.item))))), a_funcname).do_nothing
						Result := 0
						l_return := True
					end
					if not l_return then
						Result := 1
					end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		rescue
			if attached {CE_EXCEPTION} (create {EXCEPTION_MANAGER}).last_exception as ex then
				if ex.routine = $mch_libcall then
					l_pos := ex.position + 1
					retry
				end
				ex.re_raise
			end
		end

	setup_term_clip
		local
			l_z: CE_ARRAY [INTEGER_32]
			l_strp: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_AppShell: CE_POINTER [ANY]
			l_oldhandler: CE_ROUTINE
			l_oldIOhandler: CE_ROUTINE
			l_start_tv: CE_ARRAY [SD_TIMEVAL]
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_z.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_strp.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_start_tv.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_z.item := 0
					l_strp.item := ce_string ("")
					if not (x_connect_to_server).to_boolean then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:;
						(create {P_UI_STATIC}).open_app_context
						if ((create {P_GLOBALS_STATIC}).app_context.item).is_void then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						if not (xterm_Shell.item.is_void) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
							gettimeofday (l_start_tv, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
						end
						l_oldhandler := (XSetErrorHandler (x_error_check___0_address))
						l_oldIOhandler := (XSetIOErrorHandler (x_IOerror_check_address))
						mch_startjmp;
						(create {P_GLOBALS_STATIC}).lc_jump_env.item := create {CE_EXCEPTION}.make ($setup_term_clip, l_pos, $l_tmp___2)
				when 4 then -- continue here on raising lc_jump_env:
						if l_tmp___2 /= 0 then
							mch_didjmp;
							(create {P_GLOBALS_STATIC}).xterm_dpy.item.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
						else
							(create {P_GLOBALS_STATIC}).xterm_dpy.item.item := XtOpenDisplay ((create {P_GLOBALS_STATIC}).app_context.item, (create {P_GLOBALS_STATIC}).xterm_display.item, ce_string ("vim_xterm"), ce_string ("Vim_xterm"), create {CE_CLASS_POINTER [SD_XRMOPTIONDESCREC]}.make_shared (default_pointer), (0).to_natural_32, l_z, l_strp)
							mch_endjmp
						end
						XSetIOErrorHandler (l_oldIOhandler).do_nothing
						XSetErrorHandler (l_oldhandler).do_nothing
						if ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item).is_void then
							if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
								(create {P_MESSAGE_STATIC}).verb_msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Opening the X display failed"))))).do_nothing
							end
							l_return := True
						end
						if not l_return then
							XSetIOErrorHandler (x_IOerror_handler_address).do_nothing
							if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
								(create {P_MESSAGE_STATIC}).verbose_enter
								xopen_message (l_start_tv);
								(create {P_MESSAGE_STATIC}).verbose_leave
							end
							l_AppShell := XtVaAppCreateShell ([ce_string ("vim_xterm"), ce_string ("Vim_xterm"), applicationShellWidgetClass, (create {P_GLOBALS_STATIC}).xterm_dpy.item.item, create {CE_VOID_POINTER}.make_shared (default_pointer)])
							if l_AppShell.is_void then
								l_return := True
							end
						end
						if not l_return then
							xterm_Shell.item := XtVaCreatePopupShell ([ce_string ("VIM"), topLevelShellWidgetClass, l_AppShell, (XtStrings + 453), 0, (XtStrings + 872), 1, (XtStrings + 234), 1, create {CE_VOID_POINTER}.make_shared (default_pointer)])
							if xterm_Shell.item.is_void then
								l_return := True
							end
						end
						if not l_return then
							(create {P_UI_STATIC}).x11_setup_atoms ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item);
							(create {P_UI_STATIC}).x11_setup_selection (xterm_Shell.item)
							if (x11_display.item.item).is_void then
								x11_display.item.item := (create {P_GLOBALS_STATIC}).xterm_dpy.item.item
							end
							XtRealizeWidget (xterm_Shell.item)
							XSync ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item, 0).do_nothing
							xterm_update
						end
				when 5 then -- if done | if done | if done
					if not l_return and then (not xterm_Shell.item.is_void) then
						(create {P_UI_STATIC}).clip_init (1)
						if x11_window.item.item = {NATURAL_32} 0 then
							l_strp.item := getenv (ce_string ("WINDOWID"))
							if not (l_strp.item).is_void then
								x11_window.item.item := (atol (l_strp.item)).to_natural_32
							end
						end
						if (test_x11_window ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item)) = 0 then
							x11_window.item.item := (0).to_natural_32
						end
						if x11_window.item.item /= {NATURAL_32} 0 then
							xterm_trace.item := 0
						end
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		rescue
			if attached {CE_EXCEPTION} (create {EXCEPTION_MANAGER}).last_exception as ex then
				if ex.routine = $setup_term_clip then
					l_pos := ex.position + 1
					retry
				end
				ex.re_raise
			end
		end

	start_xterm_trace (a_button: INTEGER_32)
		local
			l_return: BOOLEAN
		do
			if x11_window.item.item = {NATURAL_32} 0 then
				l_return := True
			elseif xterm_trace.item < 0 then
				l_return := True
			elseif xterm_Shell.item.is_void then
				l_return := True
			end
			if not l_return then
				xterm_trace.item := 1
				xterm_button.item := a_button
				do_xterm_trace.do_nothing
			end
		end

	stop_xterm_trace
		local
			l_return: BOOLEAN
		do
			if xterm_trace.item < 0 then
				l_return := True
			end
			if not l_return then
				xterm_trace.item := 0
			end
		end

	do_xterm_trace: INTEGER_32
		local
			l_root: CE_ARRAY [NATURAL_32]
			l_child: CE_ARRAY [NATURAL_32]
			l_root_x: CE_ARRAY [INTEGER_32]
			l_root_y: CE_ARRAY [INTEGER_32]
			l_win_x: CE_ARRAY [INTEGER_32]
			l_win_y: CE_ARRAY [INTEGER_32]
			l_row: INTEGER_32
			l_col: INTEGER_32
			l_mask_return: CE_ARRAY [NATURAL_32]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_strp: CE_POINTER [NATURAL_8]
			l_got_hints: CE_ARRAY [INTEGER_32]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_root.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_child.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_root_x.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_root_y.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_win_x.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_win_y.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_mask_return.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<50>>)
			create {CE_INTEGER_32_ARRAY} l_got_hints.make (<<1>>)

			if xterm_trace.item <= 0 then
				Result := 0
				l_return := True
			end
			if not l_return and then (xterm_trace.item = 1) then
				if (XGetWMNormalHints ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item, x11_window.item.item, xterm_hints.item, l_got_hints)).to_boolean then
					if not ((l_got_hints.item).bit_and (((1).bit_shift_left (6)))).to_boolean then
						xterm_trace.item := -1
						Result := 0
						l_return := True
					elseif xterm_hints.item.item.width_inc <= 1 then
						xterm_trace.item := -1
						Result := 0
						l_return := True
					elseif xterm_hints.item.item.height_inc <= 1 then
						xterm_trace.item := -1
						Result := 0
						l_return := True
					end
				else
					xterm_trace.item := -1
					Result := 0
					l_return := True
				end
				if not l_return then
					mouse_code.item := (create {P_TERM_STATIC}).find_termcode (mouse_name.item)
					prev_row.item := (create {P_GLOBALS_STATIC}).mouse_row.item
					prev_row.item := (create {P_GLOBALS_STATIC}).mouse_col.item
					xterm_trace.item := 2
					XQueryPointer ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item, x11_window.item.item, l_root, l_child, l_root_x, l_root_y, l_win_x, l_win_y, l_mask_return).do_nothing
					xterm_hints.item.item.y := (l_win_y.item - xterm_hints.item.item.height_inc * (create {P_GLOBALS_STATIC}).mouse_row.item) - xterm_hints.item.item.height_inc // 2
					if xterm_hints.item.item.y <= xterm_hints.item.item.height_inc // 2 then
						xterm_hints.item.item.y := 2
					end
					xterm_hints.item.item.x := (l_win_x.item - xterm_hints.item.item.width_inc * (create {P_GLOBALS_STATIC}).mouse_col.item) - xterm_hints.item.item.width_inc // 2
					if xterm_hints.item.item.x <= xterm_hints.item.item.width_inc // 2 then
						xterm_hints.item.item.x := 2
					end
					Result := 1
					l_return := True
				end
			end
			if not l_return and then (mouse_code.item.is_void) then
				xterm_trace.item := 0
				Result := 0
				l_return := True
			end
			if not l_return then
				XQueryPointer ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item, x11_window.item.item, l_root, l_child, l_root_x, l_root_y, l_win_x, l_win_y, l_mask_return).do_nothing
				l_row := (create {P_UI_STATIC}).check_row ((l_win_y.item - xterm_hints.item.item.y) // xterm_hints.item.item.height_inc)
				l_col := (create {P_UI_STATIC}).check_col ((l_win_x.item - xterm_hints.item.item.x) // xterm_hints.item.item.width_inc)
				if l_row = prev_row.item then
					if l_col = prev_col.item then
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return then
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (mouse_code.item)).do_nothing
				l_strp := l_buf___6 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))).to_integer_32
				l_tmp___1 := l_strp
				l_strp := l_strp + 1
				l_tmp___1.item := ((((xterm_button.item).bit_or (67))).bit_and (-33)).to_natural_8
				l_tmp___2 := l_strp
				l_strp := l_strp + 1
				l_tmp___2.item := ((l_col + 32) + 1).to_natural_8
				l_tmp___3 := l_strp
				l_strp := l_strp + 1
				l_tmp___3.item := ((l_row + 32) + 1).to_natural_8
				l_strp.item := (0).to_natural_8;
				(create {P_UI_STATIC}).add_to_input_buf (l_buf___6, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))).to_integer_32)
				prev_row.item := l_row
				prev_col.item := l_col
				Result := 1
			end
		end

	clear_xterm_clip
		do
			if not xterm_Shell.item.is_void then
				XtDestroyWidget (xterm_Shell.item)
				xterm_Shell.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
			end
			if not ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item).is_void then
				if (x11_display.item.item).is_equal ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item) then
					x11_display.item.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
				end
				(create {P_GLOBALS_STATIC}).xterm_dpy.item.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
			end
		end

	xterm_update
		local
			l_event: CE_ARRAY [SD_XEVENT]
			l_e: CE_POINTER [SD_XPROPERTYEVENT]
			l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_XEVENT]} l_event.make (<<1>>)

			from
			until
				(l_break)
			loop
				l_break := False
				if (XtAppPending ((create {P_GLOBALS_STATIC}).app_context.item)).to_boolean then
					if ((create {P_UI_STATIC}).vim_is_input_buf_full).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					XtAppNextEvent ((create {P_GLOBALS_STATIC}).app_context.item, l_event)
					l_e := create {CE_CLASS_POINTER [SD_XPROPERTYEVENT]}.make_cast (l_event)
					if l_e.item.type = 28 then
						if l_e.item.window = (create {P_GLOBALS_STATIC}).commWindow.item then
							if l_e.item.atom = (create {P_GLOBALS_STATIC}).commProperty.item then
								if l_e.item.state = 0 then
									(create {P_IF_XCMDSRV_STATIC}).serverEventProc ((create {P_GLOBALS_STATIC}).xterm_dpy.item.item, l_event)
								end
							end
						end
					end
					XtDispatchEvent (l_event).do_nothing
				end
			end
			l_break := False
		end

	clip_xterm_set_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
			(create {P_UI_STATIC}).clip_x11_set_selection (a_cbd)
		end

	xsmp_handle_interaction (a_smc_conn, a_client_data: CE_POINTER [ANY])
		local
			l_save_cmdmod: PD_CMDMOD_T
			l_cancel_shutdown: INTEGER_32
		do
			l_cancel_shutdown := 0
			l_save_cmdmod := ((create {P_GLOBALS_STATIC}).cmdmod.item.item).twin;
			(create {P_GLOBALS_STATIC}).cmdmod.item.item.confirm := 1
			if ((create {P_EX_CMDS2_STATIC}).check_changed_any (0)).to_boolean then
				l_cancel_shutdown := 1
			end
			(create {P_GLOBALS_STATIC}).cmdmod.item.item := l_save_cmdmod.twin;
			(create {P_SCREEN_STATIC}).setcursor;
			(create {P_TERM_STATIC}).out_flush
			SmcInteractDone (a_smc_conn, l_cancel_shutdown)
			if not l_cancel_shutdown.to_boolean then
				xsmp.item.item.save_yourself := 0
				SmcSaveYourselfDone (a_smc_conn, 1)
			end
		end

	xsmp_handle_save_yourself (a_smc_conn, a_client_data: CE_POINTER [ANY]; a_save_type, a_shutdown, a_interact_style, a_fast: INTEGER_32)
		do
			if (xsmp.item.item.save_yourself).to_boolean then
				SmcSaveYourselfDone (a_smc_conn, 1)
			end
			xsmp.item.item.save_yourself := 1
			xsmp.item.item.shutdown := a_shutdown;
			(create {P_TERM_STATIC}).out_flush;
			(create {P_MEMLINE_STATIC}).ml_sync_all (0, 0)
			if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
				(create {P_MESSAGE_STATIC}).verb_msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("XSMP handling save-yourself request"))))).do_nothing
			end
			if a_shutdown.to_boolean then
				if not a_fast.to_boolean then
					if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
						SmcInteractRequest (a_smc_conn, 0, xsmp_handle_interaction_address, a_client_data).do_nothing
					else
						SmcSaveYourselfDone (a_smc_conn, 1)
						xsmp.item.item.save_yourself := 0
					end
				else
					SmcSaveYourselfDone (a_smc_conn, 1)
					xsmp.item.item.save_yourself := 0
				end
			else
				SmcSaveYourselfDone (a_smc_conn, 1)
				xsmp.item.item.save_yourself := 0
			end
		end

	xsmp_die (a_smc_conn, a_client_data: CE_POINTER [ANY])
		do
			xsmp_close;
			(create {P_MAIN_STATIC}).getout_preserve_modified (0)
		end

	xsmp_save_complete (a_smc_conn, a_client_data: CE_POINTER [ANY])
		do
			xsmp.item.item.save_yourself := 0
		end

	xsmp_shutdown_cancelled (a_smc_conn, a_client_data: CE_POINTER [ANY])
		do
			if (xsmp.item.item.save_yourself).to_boolean then
				SmcSaveYourselfDone (a_smc_conn, 1)
			end
			xsmp.item.item.save_yourself := 0
			xsmp.item.item.shutdown := 0
		end

	xsmp_ice_connection (a_iceConn, a_clientData: CE_POINTER [ANY]; a_opening: INTEGER_32; a_watchData: CE_POINTER [CE_POINTER [ANY]])
		do
			if a_opening.to_boolean then
				(create {P_GLOBALS_STATIC}).xsmp_icefd.item.item := IceConnectionNumber (a_iceConn)
				IceRemoveConnectionWatch (xsmp_ice_connection_address, create {CE_VOID_POINTER}.make_shared (default_pointer))
			end
		end

	xsmp_handle_requests: INTEGER_32
		local
			l_rep: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_rep.make (<<1>>)

			if (IceProcessMessages (xsmp.item.item.iceconn, create {CE_CLASS_POINTER [SD_ICEREPLYWAITINFO]}.make_shared (default_pointer), l_rep)) = {NATURAL_32} 1 then
				if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
					(create {P_MESSAGE_STATIC}).verb_msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("XSMP lost ICE connection"))))).do_nothing
				end
				xsmp_close
				Result := 0
			else
				Result := 1
			end
		end

	xsmp_init
		local
			l_errorstring: CE_ARRAY [INTEGER_8]
			l_smcallbacks: CE_ARRAY [SD_SMCCALLBACKS]
			l_errorreport: CE_ARRAY [INTEGER_8]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_errorstring.make (<<80>>)
			create {CE_CLASS_ARRAY [SD_SMCCALLBACKS]} l_smcallbacks.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_errorreport.make (<<132>>)

			if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
				(create {P_MESSAGE_STATIC}).verb_msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("XSMP opening connection"))))).do_nothing
			end
			xsmp.item.item.shutdown := 0
			xsmp.item.item.save_yourself := xsmp.item.item.shutdown
			l_smcallbacks.item.save_yourself.callback := xsmp_handle_save_yourself_address
			l_smcallbacks.item.save_yourself.client_data := create {CE_VOID_POINTER}.make_shared (default_pointer)
			l_smcallbacks.item.die.callback := xsmp_die_address
			l_smcallbacks.item.die.client_data := create {CE_VOID_POINTER}.make_shared (default_pointer)
			l_smcallbacks.item.save_complete.callback := xsmp_save_complete_address
			l_smcallbacks.item.save_complete.client_data := create {CE_VOID_POINTER}.make_shared (default_pointer)
			l_smcallbacks.item.shutdown_cancelled.callback := xsmp_shutdown_cancelled_address
			l_smcallbacks.item.shutdown_cancelled.client_data := create {CE_VOID_POINTER}.make_shared (default_pointer)
			if (IceAddConnectionWatch (xsmp_ice_connection_address, create {CE_VOID_POINTER}.make_cast (dummy.item))) = 0 then
				if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
					(create {P_MESSAGE_STATIC}).verb_msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("XSMP ICE connection watch failed"))))).do_nothing
				end
				l_return := True
			end
			if not l_return then
				xsmp.item.item.smcconn := SmcOpenConnection (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 1, 0, ((((((1).bit_or (((1).bit_shift_left (1))))).bit_or (((1).bit_shift_left (2))))).bit_or (((1).bit_shift_left (3)))).to_natural_32, l_smcallbacks, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (xsmp.item.item.c_pointer + (create {PD_XSMP_CONFIG_T}.make).offset_of ("clientid")), ({PLATFORM}.Integer_8_bytes.to_natural_32 * (80).to_natural_32).to_integer_32, l_errorstring)
				if (xsmp.item.item.smcconn).is_void then
					if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
						(create {P_MESSAGE_STATIC}).vim_snprintf ([l_errorreport, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (132).to_natural_32), (gettext (ce_string ("XSMP SmcOpenConnection failed: %%s"))), l_errorstring]).do_nothing;
						(create {P_MESSAGE_STATIC}).verb_msg (create {CE_NATURAL_8_POINTER}.make_cast (l_errorreport)).do_nothing
					end
					l_return := True
				end
			end
			if not l_return then
				xsmp.item.item.iceconn := SmcGetIceConnection (xsmp.item.item.smcconn)
			end
		end

	xsmp_close
		do
			if (create {P_GLOBALS_STATIC}).xsmp_icefd.item.item /= -1 then
				SmcCloseConnection (xsmp.item.item.smcconn, 0, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer)).do_nothing
				if not (xsmp.item.item.clientid).is_void then
					free (create {CE_VOID_POINTER}.make_cast (xsmp.item.item.clientid))
				end
				xsmp.item.item.clientid := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer);
				(create {P_GLOBALS_STATIC}).xsmp_icefd.item.item := -1
			end
		end

feature {ANY} -- routine addresses

	sig_winch_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent sig_winch)
		end

	catch_sigint_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent catch_sigint)
		end

	catch_sigpwr_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent catch_sigpwr)
		end

	deathtrap_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent deathtrap)
		end

	sigcont_handler_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent sigcont_handler)
		end

	x_error_handler_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent x_error_handler)
		end

	x_error_check___0_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent x_error_check___0)
		end

	x_IOerror_check_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent x_IOerror_check)
		end

	x_IOerror_handler_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent x_IOerror_handler)
		end

	xsmp_handle_interaction_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent xsmp_handle_interaction)
		end

	xsmp_handle_save_yourself_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent xsmp_handle_save_yourself)
		end

	xsmp_die_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent xsmp_die)
		end

	xsmp_save_complete_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent xsmp_save_complete)
		end

	xsmp_shutdown_cancelled_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent xsmp_shutdown_cancelled)
		end

	xsmp_ice_connection_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent xsmp_ice_connection)
		end

end
