class
	P_SYNTAX_STATIC

inherit
	CE_UTILITIES
	S_LIBINTL_STATIC
	S_STRING_STATIC
	S_STDIO_STATIC
	S_STDLIB_STATIC
	S_CTYPE_STATIC

feature {ANY} -- public attributes

	highlight_ga: CE_STATIC [CE_ARRAY [PD_GROWARRAY]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GROWARRAY]}.make (<<1>>)
		end

	include_none: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	include_default: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	include_link: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	hl_name_table: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("bold"),
					ce_string ("standout"),
					ce_string ("underline"),
					ce_string ("undercurl"),
					ce_string ("italic"),
					ce_string ("reverse"),
					ce_string ("inverse"),
					ce_string ("NONE")
				>>)
		end

	hl_attr_table: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					2, 32, 8, 16, 4, 1, 1, 0
				>>)
		end

	dumkey: CE_STATIC [CE_ARRAY [PD_KEYENTRY]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_KEYENTRY]}.make (<<1>>)
		end

	keepend_level: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	next_match_col: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	next_match_idx: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	syn_win: CE_STATIC [CE_POINTER [PD_WINDOW_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make
		end

	syn_buf: CE_STATIC [CE_POINTER [PD_FILE_BUFFER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make
		end

	syn_block: CE_STATIC [CE_POINTER [PD_SYNBLOCK_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_SYNBLOCK_T]}.make
		end

	current_lnum: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (0).to_integer_32
		end

	current_col: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	current_state: CE_STATIC [CE_ARRAY [PD_GROWARRAY]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GROWARRAY]}.make_initialized (<<
					create {PD_GROWARRAY}.make_initialized ([0, 0, 0, 0, create {CE_VOID_POINTER}.make_shared (default_pointer)])
				>>)
		end

	current_next_list: CE_STATIC [CE_POINTER [INTEGER_16]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
		end

	current_next_flags: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	last_matchgroup: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	subcommands: CE_STATIC [CE_ARRAY [PD_SUBCOMMAND]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_SUBCOMMAND]}.make_initialized (<<
					create {PD_SUBCOMMAND}.make_initialized ([ce_string ("case"), (create {PD_EXARG_STATIC}).syn_cmd_case_address]),
					create {PD_SUBCOMMAND}.make_initialized ([ce_string ("clear"), (create {PD_EXARG_STATIC}).syn_cmd_clear_address]),
					create {PD_SUBCOMMAND}.make_initialized ([ce_string ("cluster"), (create {PD_EXARG_STATIC}).syn_cmd_cluster_address]),
					create {PD_SUBCOMMAND}.make_initialized ([ce_string ("conceal"), syn_cmd_conceal_address]),
					create {PD_SUBCOMMAND}.make_initialized ([ce_string ("enable"), (create {PD_EXARG_STATIC}).syn_cmd_enable_address]),
					create {PD_SUBCOMMAND}.make_initialized ([ce_string ("include"), (create {PD_EXARG_STATIC}).syn_cmd_include_address]),
					create {PD_SUBCOMMAND}.make_initialized ([ce_string ("keyword"), (create {PD_EXARG_STATIC}).syn_cmd_keyword_address]),
					create {PD_SUBCOMMAND}.make_initialized ([ce_string ("list"), (create {PD_EXARG_STATIC}).syn_cmd_list_address]),
					create {PD_SUBCOMMAND}.make_initialized ([ce_string ("manual"), (create {PD_EXARG_STATIC}).syn_cmd_manual_address]),
					create {PD_SUBCOMMAND}.make_initialized ([ce_string ("match"), (create {PD_EXARG_STATIC}).syn_cmd_match_address]),
					create {PD_SUBCOMMAND}.make_initialized ([ce_string ("on"), (create {PD_EXARG_STATIC}).syn_cmd_on_address]),
					create {PD_SUBCOMMAND}.make_initialized ([ce_string ("off"), (create {PD_EXARG_STATIC}).syn_cmd_off_address]),
					create {PD_SUBCOMMAND}.make_initialized ([ce_string ("region"), (create {PD_EXARG_STATIC}).syn_cmd_region_address]),
					create {PD_SUBCOMMAND}.make_initialized ([ce_string ("reset"), (create {PD_EXARG_STATIC}).syn_cmd_reset_address]),
					create {PD_SUBCOMMAND}.make_initialized ([ce_string ("spell"), (create {PD_EXARG_STATIC}).syn_cmd_spell_address]),
					create {PD_SUBCOMMAND}.make_initialized ([ce_string ("sync"), (create {PD_EXARG_STATIC}).syn_cmd_sync_address]),
					create {PD_SUBCOMMAND}.make_initialized ([ce_string (""), (create {PD_EXARG_STATIC}).syn_cmd_list_address]),
					create {PD_SUBCOMMAND}.make_initialized ([create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer)])
				>>)
		end

	expand_what___0: CE_STATIC [NATURAL_32]
		once ("PROCESS")
		end

	case_args: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("match"),
					ce_string ("ignore"),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				>>)
		end

	highlight_init_both: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("ErrorMsg term=standout ctermbg=DarkRed ctermfg=White guibg=Red guifg=White"),
					ce_string ("IncSearch term=reverse cterm=reverse gui=reverse"),
					ce_string ("ModeMsg term=bold cterm=bold gui=bold"),
					ce_string ("NonText term=bold ctermfg=Blue gui=bold guifg=Blue"),
					ce_string ("StatusLine term=reverse,bold cterm=reverse,bold gui=reverse,bold"),
					ce_string ("StatusLineNC term=reverse cterm=reverse gui=reverse"),
					ce_string ("VertSplit term=reverse cterm=reverse gui=reverse"),
					ce_string ("VisualNOS term=underline,bold cterm=underline,bold gui=underline,bold"),
					ce_string ("DiffText term=reverse cterm=bold ctermbg=Red gui=bold guibg=Red"),
					ce_string ("PmenuThumb cterm=reverse gui=reverse"),
					ce_string ("PmenuSbar ctermbg=Grey guibg=Grey"),
					ce_string ("TabLineSel term=bold cterm=bold gui=bold"),
					ce_string ("TabLineFill term=reverse cterm=reverse gui=reverse"),
					ce_string ("Cursor guibg=fg guifg=bg"),
					ce_string ("lCursor guibg=fg guifg=bg"),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				>>)
		end

	highlight_init_light: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("Directory term=bold ctermfg=DarkBlue guifg=Blue"),
					ce_string ("LineNr term=underline ctermfg=Brown guifg=Brown"),
					ce_string ("MoreMsg term=bold ctermfg=DarkGreen gui=bold guifg=SeaGreen"),
					ce_string ("Question term=standout ctermfg=DarkGreen gui=bold guifg=SeaGreen"),
					ce_string ("Search term=reverse ctermbg=Yellow ctermfg=NONE guibg=Yellow guifg=NONE"),
					ce_string ("SpellBad term=reverse ctermbg=LightRed guisp=Red gui=undercurl"),
					ce_string ("SpellCap term=reverse ctermbg=LightBlue guisp=Blue gui=undercurl"),
					ce_string ("SpellRare term=reverse ctermbg=LightMagenta guisp=Magenta gui=undercurl"),
					ce_string ("SpellLocal term=underline ctermbg=Cyan guisp=DarkCyan gui=undercurl"),
					ce_string ("Pmenu ctermbg=LightMagenta guibg=LightMagenta"),
					ce_string ("PmenuSel ctermbg=LightGrey guibg=Grey"),
					ce_string ("SpecialKey term=bold ctermfg=DarkBlue guifg=Blue"),
					ce_string ("Title term=bold ctermfg=DarkMagenta gui=bold guifg=Magenta"),
					ce_string ("WarningMsg term=standout ctermfg=DarkRed guifg=Red"),
					ce_string ("WildMenu term=standout ctermbg=Yellow ctermfg=Black guibg=Yellow guifg=Black"),
					ce_string ("Folded term=standout ctermbg=Grey ctermfg=DarkBlue guibg=LightGrey guifg=DarkBlue"),
					ce_string ("FoldColumn term=standout ctermbg=Grey ctermfg=DarkBlue guibg=Grey guifg=DarkBlue"),
					ce_string ("SignColumn term=standout ctermbg=Grey ctermfg=DarkBlue guibg=Grey guifg=DarkBlue"),
					ce_string ("Visual term=reverse guibg=LightGrey"),
					ce_string ("DiffAdd term=bold ctermbg=LightBlue guibg=LightBlue"),
					ce_string ("DiffChange term=bold ctermbg=LightMagenta guibg=LightMagenta"),
					ce_string ("DiffDelete term=bold ctermfg=Blue ctermbg=LightCyan gui=bold guifg=Blue guibg=LightCyan"),
					ce_string ("TabLine term=underline cterm=underline ctermfg=black ctermbg=LightGrey gui=underline guibg=LightGrey"),
					ce_string ("CursorColumn term=reverse ctermbg=LightGrey guibg=Grey90"),
					ce_string ("CursorLine term=underline cterm=underline guibg=Grey90"),
					ce_string ("ColorColumn term=reverse ctermbg=LightRed guibg=LightRed"),
					ce_string ("MatchParen term=reverse ctermbg=Cyan guibg=Cyan"),
					ce_string ("Normal gui=NONE"),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				>>)
		end

	highlight_init_dark: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("Directory term=bold ctermfg=LightCyan guifg=Cyan"),
					ce_string ("LineNr term=underline ctermfg=Yellow guifg=Yellow"),
					ce_string ("MoreMsg term=bold ctermfg=LightGreen gui=bold guifg=SeaGreen"),
					ce_string ("Question term=standout ctermfg=LightGreen gui=bold guifg=Green"),
					ce_string ("Search term=reverse ctermbg=Yellow ctermfg=Black guibg=Yellow guifg=Black"),
					ce_string ("SpecialKey term=bold ctermfg=LightBlue guifg=Cyan"),
					ce_string ("SpellBad term=reverse ctermbg=Red guisp=Red gui=undercurl"),
					ce_string ("SpellCap term=reverse ctermbg=Blue guisp=Blue gui=undercurl"),
					ce_string ("SpellRare term=reverse ctermbg=Magenta guisp=Magenta gui=undercurl"),
					ce_string ("SpellLocal term=underline ctermbg=Cyan guisp=Cyan gui=undercurl"),
					ce_string ("Pmenu ctermbg=Magenta guibg=Magenta"),
					ce_string ("PmenuSel ctermbg=DarkGrey guibg=DarkGrey"),
					ce_string ("Title term=bold ctermfg=LightMagenta gui=bold guifg=Magenta"),
					ce_string ("WarningMsg term=standout ctermfg=LightRed guifg=Red"),
					ce_string ("WildMenu term=standout ctermbg=Yellow ctermfg=Black guibg=Yellow guifg=Black"),
					ce_string ("Folded term=standout ctermbg=DarkGrey ctermfg=Cyan guibg=DarkGrey guifg=Cyan"),
					ce_string ("FoldColumn term=standout ctermbg=DarkGrey ctermfg=Cyan guibg=Grey guifg=Cyan"),
					ce_string ("SignColumn term=standout ctermbg=DarkGrey ctermfg=Cyan guibg=Grey guifg=Cyan"),
					ce_string ("Visual term=reverse guibg=DarkGrey"),
					ce_string ("DiffAdd term=bold ctermbg=DarkBlue guibg=DarkBlue"),
					ce_string ("DiffChange term=bold ctermbg=DarkMagenta guibg=DarkMagenta"),
					ce_string ("DiffDelete term=bold ctermfg=Blue ctermbg=DarkCyan gui=bold guifg=Blue guibg=DarkCyan"),
					ce_string ("TabLine term=underline cterm=underline ctermfg=white ctermbg=DarkGrey gui=underline guibg=DarkGrey"),
					ce_string ("CursorColumn term=reverse ctermbg=DarkGrey guibg=Grey40"),
					ce_string ("CursorLine term=underline cterm=underline guibg=Grey40"),
					ce_string ("ColorColumn term=reverse ctermbg=DarkRed guibg=DarkRed"),
					ce_string ("MatchParen term=reverse ctermbg=DarkCyan guibg=DarkCyan"),
					ce_string ("Normal gui=NONE"),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				>>)
		end

	had_both: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	recursive___6: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	recursive___7: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	color_names: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("Black"),
					ce_string ("DarkBlue"),
					ce_string ("DarkGreen"),
					ce_string ("DarkCyan"),
					ce_string ("DarkRed"),
					ce_string ("DarkMagenta"),
					ce_string ("Brown"),
					ce_string ("DarkYellow"),
					ce_string ("Gray"),
					ce_string ("Grey"),
					ce_string ("LightGray"),
					ce_string ("LightGrey"),
					ce_string ("DarkGray"),
					ce_string ("DarkGrey"),
					ce_string ("Blue"),
					ce_string ("LightBlue"),
					ce_string ("Green"),
					ce_string ("LightGreen"),
					ce_string ("Cyan"),
					ce_string ("LightCyan"),
					ce_string ("Red"),
					ce_string ("LightRed"),
					ce_string ("Magenta"),
					ce_string ("LightMagenta"),
					ce_string ("Yellow"),
					ce_string ("LightYellow"),
					ce_string ("White"),
					ce_string ("NONE")
				>>)
		end

	color_numbers_16: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					0, 1, 2, 3, 4, 5, 6, 6, 7, 7, 7, 7, 8, 8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 13, 14, 14, 15, -1
				>>)
		end

	color_numbers_88: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					0, 4, 2, 6, 1, 5, 32, 72, 84, 84, 7, 7, 82, 82, 12, 43, 10, 61, 14, 63, 9, 74, 13, 75, 11, 78, 15,
					-1
				>>)
		end

	color_numbers_256: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					0, 4, 2, 6, 1, 5, 130, 130, 248, 248, 7, 7, 242, 242, 12, 81, 10, 121, 14, 159, 9, 224, 13, 225,
					11, 229, 15, -1
				>>)
		end

	color_numbers_8: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					0, 4, 2, 6, 1, 5, 3, 3, 7, 7, 7, 7, 8, 8, 12, 12, 10, 10, 14, 14, 9, 9, 13, 13, 11, 11, 15, -1
				>>)
		end

	term_attr_table: CE_STATIC [CE_ARRAY [PD_GROWARRAY]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GROWARRAY]}.make_initialized (<<
					create {PD_GROWARRAY}.make_initialized ([0, 0, 0, 0, create {CE_VOID_POINTER}.make_shared (default_pointer)])
				>>)
		end

	cterm_attr_table: CE_STATIC [CE_ARRAY [PD_GROWARRAY]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GROWARRAY]}.make_initialized (<<
					create {PD_GROWARRAY}.make_initialized ([0, 0, 0, 0, create {CE_VOID_POINTER}.make_shared (default_pointer)])
				>>)
		end

	gui_attr_table: CE_STATIC [CE_ARRAY [PD_GROWARRAY]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GROWARRAY]}.make_initialized (<<
					create {PD_GROWARRAY}.make_initialized ([0, 0, 0, 0, create {CE_VOID_POINTER}.make_shared (default_pointer)])
				>>)
		end

	name___0: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<20>>)
		end

	buf___3: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<10>>)
		end

	hl_flags: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					('8').code, ('@').code, ('d').code, ('e').code, ('h').code, ('i').code, ('l').code, ('m').code, ('M').code,
					('n').code, ('r').code, ('s').code, ('S').code, ('c').code, ('t').code, ('v').code, ('V').code, ('w').code,
					('W').code, ('f').code, ('F').code, ('A').code, ('C').code, ('D').code, ('T').code, ('-').code, ('>').code,
					('B').code, ('P').code, ('R').code, ('L').code, ('+').code, ('=').code, ('x').code, ('X').code, ('*').code,
					('#').code, ('_').code, ('!').code, ('.').code, ('o').code
				>>)
		end

feature {ANY} -- public routines

	clear_current_state
		local
			l_i___0: INTEGER_32
			l_sip: CE_POINTER [PD_STATE_ITEM]
		do
			l_sip := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast (current_state.item.item.ga_data)
			l_i___0 := 0
			from
			until
				not (l_i___0 < current_state.item.item.ga_len)
			loop
				(create {P_REGEXP_STATIC}).unref_extmatch ((l_sip + l_i___0).item.si_extmatch)
				l_i___0 := l_i___0 + 1
			end
			current_state.item.item.ga_clear
		end

	syn_update_ends (a_startofline: INTEGER_32)
		local
			l_cur_si: CE_POINTER [PD_STATE_ITEM]
			l_i___0: INTEGER_32
			l_seen_keepend: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_startofline.to_boolean then
						l_i___0 := 0
						from
						until
							not (l_i___0 < current_state.item.item.ga_len)
						loop
							l_cur_si := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast (current_state.item.item.ga_data) + l_i___0
							if l_cur_si.item.si_idx >= 0 then
								if ((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast (syn_block.item.item.b_syn_patterns.ga_data) + l_cur_si.item.si_idx).item.sp_type).to_integer_32 = 1 then
									if l_cur_si.item.si_m_endpos.lnum < current_lnum.item then
										l_cur_si.item.si_flags := (l_cur_si.item.si_flags).bit_or ((32_768))
										l_cur_si.item.si_m_endpos.lnum := (0).to_integer_32
										l_cur_si.item.si_m_endpos.col := 0
										l_cur_si.item.si_h_endpos := (l_cur_si.item.si_m_endpos).twin
										l_cur_si.item.si_ends := 1
									end
								end
							end
							l_i___0 := l_i___0 + 1
						end
					end
					l_i___0 := current_state.item.item.ga_len - 1
					if keepend_level.item >= 0 then
						from
						until
							not (not (l_break) and then (l_i___0 > keepend_level.item))
						loop
							l_break := False
							if (((create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast (current_state.item.item.ga_data) + l_i___0).item.si_flags).bit_and (16_384)).to_boolean then
								l_break := True
							end
							if not (l_break) then
								l_i___0 := l_i___0 - 1
							end
						end
						l_break := False
					end
					l_seen_keepend := 0
				when 1 then -- loop condition:
					if not (l_i___0 < current_state.item.item.ga_len) then
						l_pos := -1 + 12 -- skip loop
					end
				when 2 then -- loop body:
						l_cur_si := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast (current_state.item.item.ga_data) + l_i___0
						if not (((l_cur_si.item.si_flags).bit_and (1_024)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 5 then -- else:
						if not (l_seen_keepend.to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if not a_startofline.to_boolean then
							l_pos := -1 + 10 -- goto _L
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 8 then -- else: | _L___0:
						if l_i___0 /= current_state.item.item.ga_len - 1 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if not (a_startofline.to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						l_cur_si.item.si_h_startpos.col := 0
						l_cur_si.item.si_h_startpos.lnum := current_lnum.item
						if not ((l_cur_si.item.si_flags).bit_and (32_768)).to_boolean then
							l_cur_si.item.update_si_end (current_col.item, (not a_startofline.to_boolean).to_integer)
						end
						if not a_startofline.to_boolean then
							if ((l_cur_si.item.si_flags).bit_and (1_024)).to_boolean then
								l_seen_keepend := 1
							end
						end
				when 11 then -- if done | if done | if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 1 -- back to loop condition
				when 12 then -- loop done
					check_keepend
					check_state_ends
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	syn_stack_apply_changes (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			(create {CE_CLASS_POINTER [PD_SYNBLOCK_T]}.make_shared (a_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_s"))).item.syn_stack_apply_changes_block (a_buf___6)
			l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
			from
			until
				l_wp___0.is_void
			loop
				if (l_wp___0.item.w_buffer).is_equal (a_buf___6) then
					if not (l_wp___0.item.w_s).is_equal (create {CE_CLASS_POINTER [PD_SYNBLOCK_T]}.make_shared (a_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_s"))) then
						(l_wp___0.item.w_s).item.syn_stack_apply_changes_block (a_buf___6)
					end
				end
				l_wp___0 := l_wp___0.item.w_next
			end
		end

	invalidate_current_state
		do
			clear_current_state
			current_state.item.item.ga_itemsize := 0
			current_next_list.item := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
			keepend_level.item := -1
		end

	check_state_ends
		local
			l_cur_si: CE_POINTER [PD_STATE_ITEM]
			l_had_extend: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_had_extend := 0
					l_cur_si := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast (current_state.item.item.ga_data) + (current_state.item.item.ga_len - 1)
				when 1 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 28 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if not ((l_cur_si.item.si_ends).to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 3 then -- if:
						if not (l_cur_si.item.si_m_endpos.lnum < current_lnum.item) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 8 -- goto _L___1
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 6 then -- else:
						if l_cur_si.item.si_m_endpos.lnum /= current_lnum.item then
							l_pos := -1 + 24 -- skip if block
						end
				when 7 then -- if:
						if not (l_cur_si.item.si_m_endpos.col <= current_col.item) then
							l_pos := -1 + 22 -- skip if block
						end
				when 8 then -- if: | _L___1:
						if not ((l_cur_si.item.si_end_idx).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 9 then -- if:
						if not (l_cur_si.item.si_eoe_pos.lnum > current_lnum.item) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 14 -- goto _L___0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 12 then -- else:
						if l_cur_si.item.si_eoe_pos.lnum /= current_lnum.item then
							l_pos := -1 + 18 -- skip if block
						end
				when 13 then -- if:
						if not (l_cur_si.item.si_eoe_pos.col > current_col.item) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if: | _L___0:
						l_cur_si.item.si_idx := l_cur_si.item.si_end_idx
						l_cur_si.item.si_end_idx := 0
						l_cur_si.item.si_m_endpos := (l_cur_si.item.si_eoe_pos).twin
						l_cur_si.item.si_h_endpos := (l_cur_si.item.si_eoe_pos).twin
						l_cur_si.item.si_flags := (l_cur_si.item.si_flags).bit_or ((64))
						update_si_attr (current_state.item.item.ga_len - 1)
						next_match_idx.item := 0
						next_match_col.item := 2_147_483_647
						l_break := True
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 20 -- goto _L
				when 17 then -- if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_pos := -1 + 20 -- goto _L
				when 19 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else: | _L:
						current_next_list.item := l_cur_si.item.si_next_list
						current_next_flags.item := (l_cur_si.item.si_flags).to_integer_32
						if not ((current_next_flags.item).bit_and (640)).to_boolean then
							if ((syn_getcurline)[current_col.item]).to_integer_32 = 0 then
								current_next_list.item := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
							end
						end
						if ((l_cur_si.item.si_flags).bit_and (16_384)).to_boolean then
							l_had_extend := 1
						end
						pop_current_state
						if current_state.item.item.ga_len = 0 then
							l_break := True
						end
						if not (l_break) and then (l_had_extend.to_boolean) then
							if keepend_level.item >= 0 then
								syn_update_ends (0)
								if current_state.item.item.ga_len = 0 then
									l_break := True
								end
							end
						end
						if not (l_break) then
							l_cur_si := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast (current_state.item.item.ga_data) + (current_state.item.item.ga_len - 1)
							if l_cur_si.item.si_idx >= 0 then
								if ((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast (syn_block.item.item.b_syn_patterns.ga_data) + l_cur_si.item.si_idx).item.sp_type).to_integer_32 = 2 then
									if not ((l_cur_si.item.si_flags).bit_and (1_088)).to_boolean then
										l_cur_si.item.update_si_end (current_col.item, 1)
										check_keepend
										if ((current_next_flags.item).bit_and (8)).to_boolean then
											if keepend_level.item < 0 then
												if ((syn_getcurline)[current_col.item]).to_integer_32 = 0 then
													l_break := True
												end
											end
										end
									end
								end
							end
						end
				when 21 then -- if done | if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_break := True
				when 23 then -- if done | if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						l_break := True
				when 25 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						l_break := True
				when 27 then
						l_pos := -1 + 1 -- back to loop condition
				when 28 then -- loop done
					l_break := False
				when 29 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	update_si_attr (a_idx: INTEGER_32)
		local
			l_sip: CE_POINTER [PD_STATE_ITEM]
			l_spp: CE_POINTER [PD_SYN_PATTERN]
			l_return: BOOLEAN
		do
			l_sip := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast (current_state.item.item.ga_data) + a_idx
			if l_sip.item.si_idx < 0 then
				l_return := True
			end
			if not l_return then
				l_spp := create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast (syn_block.item.item.b_syn_patterns.ga_data) + l_sip.item.si_idx
				if ((l_sip.item.si_flags).bit_and (64)).to_boolean then
					l_sip.item.si_id := (l_spp.item.sp_syn_match_id).to_integer_32
				else
					l_sip.item.si_id := (l_spp.item.sp_syn.id).to_integer_32
				end
				l_sip.item.si_attr := syn_id2attr (l_sip.item.si_id)
				l_sip.item.si_trans_id := l_sip.item.si_id
				if ((l_sip.item.si_flags).bit_and (64)).to_boolean then
					l_sip.item.si_cont_list := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
				else
					l_sip.item.si_cont_list := l_spp.item.sp_cont_list
				end
				if ((l_spp.item.sp_flags).bit_and (2)).to_boolean then
					if not ((l_sip.item.si_flags).bit_and (64)).to_boolean then
						if a_idx = 0 then
							l_sip.item.si_attr := 0
							l_sip.item.si_trans_id := 0
							if (l_sip.item.si_cont_list).is_void then
								l_sip.item.si_cont_list := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer + -1)
							end
						else
							l_sip.item.si_attr := (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast (current_state.item.item.ga_data) + (a_idx - 1)).item.si_attr
							l_sip.item.si_trans_id := (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast (current_state.item.item.ga_data) + (a_idx - 1)).item.si_trans_id
							l_sip.item.si_h_startpos := ((create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast (current_state.item.item.ga_data) + (a_idx - 1)).item.si_h_startpos).twin
							l_sip.item.si_h_endpos := ((create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast (current_state.item.item.ga_data) + (a_idx - 1)).item.si_h_endpos).twin
							if (l_sip.item.si_cont_list).is_void then
								l_sip.item.si_flags := (l_sip.item.si_flags).bit_or ((65_536))
								l_sip.item.si_cont_list := (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast (current_state.item.item.ga_data) + (a_idx - 1)).item.si_cont_list
							end
						end
					end
				end
			end
		end

	check_keepend
		local
			l_i___0: INTEGER_32
			l_maxpos: CE_ARRAY [PD_LPOS_T]
			l_maxpos_h: CE_ARRAY [PD_LPOS_T]
			l_sip: CE_POINTER [PD_STATE_ITEM]
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_LPOS_T]} l_maxpos.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_LPOS_T]} l_maxpos_h.make (<<1>>)

			if keepend_level.item < 0 then
				l_return := True
			end
			if not l_return then
				l_i___0 := current_state.item.item.ga_len - 1
				from
				until
					not (not (l_break) and then (l_i___0 > keepend_level.item))
				loop
					l_break := False
					if (((create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast (current_state.item.item.ga_data) + l_i___0).item.si_flags).bit_and (16_384)).to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_i___0 := l_i___0 - 1
					end
				end
				l_break := False
				l_maxpos.item.lnum := (0).to_integer_32
				l_maxpos.item.col := 0
				l_maxpos_h.item.lnum := (0).to_integer_32
				l_maxpos_h.item.col := 0
				from
				until
					not (l_i___0 < current_state.item.item.ga_len)
				loop
					l_sip := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast (current_state.item.item.ga_data) + l_i___0
					if l_maxpos.item.lnum /= 0 then
						limit_pos_zero (create {CE_CLASS_POINTER [PD_LPOS_T]}.make_shared (l_sip.c_pointer + (create {PD_STATE_ITEM}.make).offset_of ("si_m_endpos")), l_maxpos)
						limit_pos_zero (create {CE_CLASS_POINTER [PD_LPOS_T]}.make_shared (l_sip.c_pointer + (create {PD_STATE_ITEM}.make).offset_of ("si_h_endpos")), l_maxpos_h)
						limit_pos_zero (create {CE_CLASS_POINTER [PD_LPOS_T]}.make_shared (l_sip.c_pointer + (create {PD_STATE_ITEM}.make).offset_of ("si_eoe_pos")), l_maxpos)
						l_sip.item.si_ends := 1
					end
					if (l_sip.item.si_ends).to_boolean then
						if ((l_sip.item.si_flags).bit_and (1_024)).to_boolean then
							if l_maxpos.item.lnum = 0 then
								l_maxpos.item := (l_sip.item.si_m_endpos).twin
							elseif l_maxpos.item.lnum > l_sip.item.si_m_endpos.lnum then
								l_maxpos.item := (l_sip.item.si_m_endpos).twin
							elseif l_maxpos.item.lnum = l_sip.item.si_m_endpos.lnum then
								if l_maxpos.item.col > l_sip.item.si_m_endpos.col then
									l_maxpos.item := (l_sip.item.si_m_endpos).twin
								end
							end
							if l_maxpos_h.item.lnum = 0 then
								l_maxpos_h.item := (l_sip.item.si_h_endpos).twin
							elseif l_maxpos_h.item.lnum > l_sip.item.si_h_endpos.lnum then
								l_maxpos_h.item := (l_sip.item.si_h_endpos).twin
							elseif l_maxpos_h.item.lnum = l_sip.item.si_h_endpos.lnum then
								if l_maxpos_h.item.col > l_sip.item.si_h_endpos.col then
									l_maxpos_h.item := (l_sip.item.si_h_endpos).twin
								end
							end
						end
					end
					l_i___0 := l_i___0 + 1
				end
			end
		end

	pop_current_state
		do
			if (current_state.item.item.ga_len).to_boolean then
				(create {P_REGEXP_STATIC}).unref_extmatch ((create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast (current_state.item.item.ga_data) + (current_state.item.item.ga_len - 1)).item.si_extmatch)
				current_state.item.item.ga_len := (current_state.item.item.ga_len) - 1
			end
			next_match_idx.item := -1
			if keepend_level.item >= current_state.item.item.ga_len then
				keepend_level.item := -1
			end
		end

	find_endpos (a_idx: INTEGER_32; a_startpos, a_m_endpos, a_hl_endpos: CE_POINTER [PD_LPOS_T]; a_flagsp: CE_POINTER [INTEGER_32]; a_end_endpos: CE_POINTER [PD_LPOS_T]; a_end_idx: CE_POINTER [INTEGER_32]; a_start_ext: CE_POINTER [PD_REG_EXTMATCH_T])
		local
			l_idx: INTEGER_32
			l_matchcol: INTEGER_32
			l_spp: CE_POINTER [PD_SYN_PATTERN]
			l_spp_skip: CE_POINTER [PD_SYN_PATTERN]
			l_start_idx: INTEGER_32
			l_best_idx: INTEGER_32
			l_regmatch___0: CE_ARRAY [PD_REGMMATCH_T]
			l_best_regmatch: CE_ARRAY [PD_REGMMATCH_T]
			l_pos___3: CE_ARRAY [PD_LPOS_T]
			l_line: CE_POINTER [NATURAL_8]
			l_had_match: INTEGER_32
			l_lc_col: INTEGER_32
			l_lc_col___0: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_REGMMATCH_T]} l_regmatch___0.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_REGMMATCH_T]} l_best_regmatch.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_LPOS_T]} l_pos___3.make (<<1>>)

			l_idx := a_idx
			l_had_match := 0
			if l_idx < 0 then
				l_return := True
			end
			if not l_return then
				l_spp := create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast (syn_block.item.item.b_syn_patterns.ga_data) + l_idx
				if (l_spp.item.sp_type).to_integer_32 /= 2 then
					a_hl_endpos.item := (a_startpos.item).twin
					l_return := True
				end
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					l_spp := create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast (syn_block.item.item.b_syn_patterns.ga_data) + l_idx
					if (l_spp.item.sp_type).to_integer_32 /= 2 then
						l_break := True
					end
					if not (l_break) then
						l_idx := l_idx + 1
					end
				end
				l_break := False
				if (l_spp.item.sp_type).to_integer_32 = 4 then
					l_spp_skip := l_spp
					l_idx := l_idx + 1
				else
					l_spp_skip := create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_shared (default_pointer)
				end
				(create {P_REGEXP_STATIC}).unref_extmatch ((create {P_GLOBALS_STATIC}).re_extmatch_in.item);
				(create {P_GLOBALS_STATIC}).re_extmatch_in.item := (create {P_REGEXP_STATIC}).ref_extmatch (a_start_ext)
				l_matchcol := a_startpos.item.col
				l_start_idx := l_idx
				l_best_regmatch.item.startpos[0].col := 0
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_continue := False
					l_best_idx := -1
					l_idx := l_start_idx
					from
					until
						not (not (l_break) and then (l_idx < syn_block.item.item.b_syn_patterns.ga_len))
					loop
						l_break := False
						l_lc_col := l_matchcol
						l_spp := create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast (syn_block.item.item.b_syn_patterns.ga_data) + l_idx
						if (l_spp.item.sp_type).to_integer_32 /= 3 then
							l_break := True
						end
						if not (l_break) then
							l_lc_col := l_lc_col - (l_spp.item.sp_offsets[6])
							if l_lc_col < 0 then
								l_lc_col := 0
							end
							l_regmatch___0.item.rmm_ic := l_spp.item.sp_ic
							l_regmatch___0.item.regprog := l_spp.item.sp_prog
							if (l_regmatch___0.item.syn_regexec (a_startpos.item.lnum, l_lc_col)).to_boolean then
								if l_best_idx = -1 then
									l_best_idx := l_idx
									l_best_regmatch.item.startpos[0] := (l_regmatch___0.item.startpos[0]).twin
									l_best_regmatch.item.endpos[0] := (l_regmatch___0.item.endpos[0]).twin
								elseif l_regmatch___0.item.startpos[0].col < l_best_regmatch.item.startpos[0].col then
									l_best_idx := l_idx
									l_best_regmatch.item.startpos[0] := (l_regmatch___0.item.startpos[0]).twin
									l_best_regmatch.item.endpos[0] := (l_regmatch___0.item.endpos[0]).twin
								end
							end
							l_idx := l_idx + 1
						end
					end
					l_break := False
					if l_best_idx = -1 then
						l_break := True
					end
					if not (l_return or l_break or l_continue) and then (not l_spp_skip.is_void) then
						l_lc_col___0 := l_matchcol - l_spp_skip.item.sp_offsets[6]
						if l_lc_col___0 < 0 then
							l_lc_col___0 := 0
						end
						l_regmatch___0.item.rmm_ic := l_spp_skip.item.sp_ic
						l_regmatch___0.item.regprog := l_spp_skip.item.sp_prog
						if (l_regmatch___0.item.syn_regexec (a_startpos.item.lnum, l_lc_col___0)).to_boolean then
							if l_regmatch___0.item.startpos[0].col <= l_best_regmatch.item.startpos[0].col then
								l_pos___3.item.syn_add_end_off (l_regmatch___0, l_spp_skip, 1, 1)
								if l_pos___3.item.lnum > a_startpos.item.lnum then
									l_break := True
								end
								if not (l_return or l_break or l_continue) then
									l_line := syn_buf.item.item.ml_get_buf (a_startpos.item.lnum, 0)
									if l_pos___3.item.col <= l_matchcol then
										l_matchcol := l_matchcol + 1
									elseif l_pos___3.item.col <= l_regmatch___0.item.endpos[0].col then
										l_matchcol := l_pos___3.item.col
									else
										l_matchcol := l_regmatch___0.item.endpos[0].col
										from
										until
											(l_break)
										loop
											l_break := False
											if (l_line[l_matchcol]).to_integer_32 /= 0 then
												if not (l_matchcol < l_pos___3.item.col) then
													l_break := True
												end
											else
												l_break := True
											end
											if not (l_break) then
												l_matchcol := l_matchcol + 1
											end
										end
										l_break := False
									end
									if (l_line[l_matchcol]).to_integer_32 = 0 then
										l_break := True
									end
								end
								if not (l_return or l_break or l_continue) then
									l_continue := True
								end
							end
						end
					end
					if not (l_return or l_break or l_continue) then
						l_spp := create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast (syn_block.item.item.b_syn_patterns.ga_data) + l_best_idx
						a_m_endpos.item.syn_add_end_off (l_best_regmatch, l_spp, 1, 1)
						if a_m_endpos.item.lnum = a_startpos.item.lnum then
							if a_m_endpos.item.col < a_startpos.item.col then
								a_m_endpos.item.col := a_startpos.item.col
							end
						end
						a_end_endpos.item.syn_add_end_off (l_best_regmatch, l_spp, 3, 1)
						if a_end_endpos.item.lnum = a_startpos.item.lnum then
							if a_end_endpos.item.col < a_startpos.item.col then
								a_end_endpos.item.col := a_startpos.item.col
							end
						end
						limit_pos (a_end_endpos, a_m_endpos)
						if (l_spp.item.sp_syn_match_id).to_integer_32 /= (l_spp.item.sp_syn.id).to_integer_32 then
							if (l_spp.item.sp_syn_match_id).to_integer_32 /= 0 then
								a_end_idx.item := l_best_idx
								if (((l_spp.item.sp_off_flags).to_integer_32).bit_and (((1).bit_shift_left (12)))).to_boolean then
									a_hl_endpos.item.lnum := l_best_regmatch.item.endpos[0].lnum
									a_hl_endpos.item.col := l_best_regmatch.item.endpos[0].col
								else
									a_hl_endpos.item.lnum := l_best_regmatch.item.startpos[0].lnum
									a_hl_endpos.item.col := l_best_regmatch.item.startpos[0].col
								end
								a_hl_endpos.item.col := a_hl_endpos.item.col + (l_spp.item.sp_offsets[5])
								if a_hl_endpos.item.lnum = a_startpos.item.lnum then
									if a_hl_endpos.item.col < a_startpos.item.col then
										a_hl_endpos.item.col := a_startpos.item.col
									end
								end
								limit_pos (a_hl_endpos, a_m_endpos)
								a_m_endpos.item := (a_hl_endpos.item).twin
							else
								a_end_idx.item := 0
								a_hl_endpos.item := (a_end_endpos.item).twin
							end
						else
							a_end_idx.item := 0
							a_hl_endpos.item := (a_end_endpos.item).twin
						end
						a_flagsp.item := (l_spp.item.sp_flags).to_integer_32
						l_had_match := 1
						l_break := True
					end
					if (not l_return and not l_break) then
						
					end
				end
				l_break := False
				l_continue := False
				if not l_had_match.to_boolean then
					a_m_endpos.item.lnum := (0).to_integer_32
				end
				(create {P_REGEXP_STATIC}).unref_extmatch ((create {P_GLOBALS_STATIC}).re_extmatch_in.item);
				(create {P_GLOBALS_STATIC}).re_extmatch_in.item := create {CE_CLASS_POINTER [PD_REG_EXTMATCH_T]}.make_shared (default_pointer)
			end
		end

	limit_pos (a_pos___3, a_limit: CE_POINTER [PD_LPOS_T])
		require
			not a_pos___3.is_void
			not a_limit.is_void
		do
			if a_pos___3.item.lnum > a_limit.item.lnum then
				a_pos___3.item := (a_limit.item).twin
			elseif a_pos___3.item.lnum = a_limit.item.lnum then
				if a_pos___3.item.col > a_limit.item.col then
					a_pos___3.item.col := a_limit.item.col
				end
			end
		end

	limit_pos_zero (a_pos___3, a_limit: CE_POINTER [PD_LPOS_T])
		require
			not a_pos___3.is_void
			not a_limit.is_void
		do
			if a_pos___3.item.lnum = 0 then
				a_pos___3.item := (a_limit.item).twin
			else
				limit_pos (a_pos___3, a_limit)
			end
		end

	syn_getcurline: CE_POINTER [NATURAL_8]
		do
			Result := (syn_buf.item.item.ml_get_buf (current_lnum.item, 0))
		end

	syn_cmd_conceal (a_eap: CE_POINTER [PD_EXARG]; a_syncing: INTEGER_32)
		do
		end

	syn_compare_stub (a_v1, a_v2: CE_POINTER [ANY]): INTEGER_32
		local
			l_s1: CE_POINTER [INTEGER_16]
			l_s2: CE_POINTER [INTEGER_16]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_s1 := create {CE_INTEGER_16_POINTER}.make_cast (a_v1)
			l_s2 := create {CE_INTEGER_16_POINTER}.make_cast (a_v2)
			if (l_s1.item).to_integer_32 > (l_s2.item).to_integer_32 then
				l_tmp___0 := 1
			else
				if (l_s1.item).to_integer_32 < (l_s2.item).to_integer_32 then
					l_tmp := -1
				else
					l_tmp := 0
				end
				l_tmp___0 := l_tmp
			end
			Result := l_tmp___0
		end

	get_syntax_name (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_return: BOOLEAN
		do
			if expand_what___0.item = {NATURAL_32} 0 then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (subcommands.item[a_idx].name))
				l_return := True
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (case_args.item[a_idx]))
			end
		end

	syn_get_stack_item (a_i___0: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_i___0 >= current_state.item.item.ga_len then
				invalidate_current_state
				current_col.item := (2_147_483_647).to_integer_32
				Result := (-1)
				l_return := True
			end
			if not l_return then
				Result := ((create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast (current_state.item.item.ga_data) + a_i___0).item.si_id)
			end
		end

	init_highlight (a_both, a_reset: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_pp: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_p___0 := (create {P_EVAL_STATIC}).get_var_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("g:colors_name")))
			if not l_p___0.is_void then
				if (load_colors (l_p___0)) = 1 then
					l_return := True
				end
			end
			if not l_return then
				if a_both.to_boolean then
					had_both.item := 1
					l_pp := highlight_init_both.item
					l_i___0 := 0
					from
					until
						(l_pp[l_i___0]).is_void
					loop
						do_highlight (create {CE_NATURAL_8_POINTER}.make_cast (l_pp[l_i___0]), a_reset, 1)
						l_i___0 := l_i___0 + 1
					end
				elseif not had_both.item.to_boolean then
					l_return := True
				end
			end
			if not l_return then
				if ((create {P_OPTION_STATIC}).p_bg.item.item.item).to_integer_32 = 108 then
					l_pp := highlight_init_light.item
				else
					l_pp := highlight_init_dark.item
				end
				l_i___0 := 0
				from
				until
					(l_pp[l_i___0]).is_void
				loop
					do_highlight (create {CE_NATURAL_8_POINTER}.make_cast (l_pp[l_i___0]), a_reset, 1)
					l_i___0 := l_i___0 + 1
				end
				if (create {P_GLOBALS_STATIC}).t_colors.item > 8 then
					if ((create {P_OPTION_STATIC}).p_bg.item.item.item).to_integer_32 = 108 then
						l_tmp___0 := ce_string ("Visual cterm=NONE ctermbg=LightGrey")
					else
						l_tmp___0 := ce_string ("Visual cterm=NONE ctermbg=DarkGrey")
					end
					do_highlight (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0), 0, 1)
				else
					do_highlight (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Visual cterm=reverse ctermbg=NONE")), 0, 1)
					if ((create {P_OPTION_STATIC}).p_bg.item.item.item).to_integer_32 = 108 then
						do_highlight (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Search ctermfg=black")), 0, 1)
					end
				end
				if not ((create {P_EVAL_STATIC}).get_var_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("g:syntax_on")))).is_void then
					if recursive___6.item >= 5 then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E679: recursive loop loading syncolor.vim"))))).do_nothing
					else
						recursive___6.item := recursive___6.item + 1;
						(create {P_EX_CMDS2_STATIC}).source_runtime (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("syntax/syncolor.vim")), 1).do_nothing
						recursive___6.item := recursive___6.item - 1
					end
				end
			end
		end

	load_colors (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_return: BOOLEAN
		do
			l_retval := 0
			if recursive___7.item.to_boolean then
				Result := 1
				l_return := True
			end
			if not l_return then
				recursive___7.item := 1
				l_buf___6 := (create {P_MISC2_STATIC}).alloc ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1))) + {NATURAL_32} 12)
				if not l_buf___6.is_void then
					sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("colors/%%s.vim"), a_name___1]).do_nothing
					l_retval := (create {P_EX_CMDS2_STATIC}).source_runtime (l_buf___6, 0);
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6));
					(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_COLORSCHEME, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
				end
				recursive___7.item := 0
				Result := l_retval
			end
		end

	do_highlight (a_line: CE_POINTER [NATURAL_8]; a_forceit, a_init: INTEGER_32)
		require
			not a_line.is_void
		local
			l_line: CE_POINTER [NATURAL_8]
			l_name_end: CE_POINTER [NATURAL_8]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_linep: CE_POINTER [NATURAL_8]
			l_key_start: CE_POINTER [NATURAL_8]
			l_arg_start: CE_POINTER [NATURAL_8]
			l_key: CE_POINTER [NATURAL_8]
			l_arg: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_off___0: INTEGER_32
			l_len: INTEGER_32
			l_attr: INTEGER_32
			l_id: INTEGER_32
			l_idx: INTEGER_32
			l_dodefault: INTEGER_32
			l_doclear: INTEGER_32
			l_dolink: INTEGER_32
			l_error: INTEGER_32
			l_color: INTEGER_32
			l_is_normal_group: INTEGER_32
			l_from_start: CE_POINTER [NATURAL_8]
			l_from_end: CE_POINTER [NATURAL_8]
			l_to_start: CE_POINTER [NATURAL_8]
			l_to_end: CE_POINTER [NATURAL_8]
			l_from_id: INTEGER_32
			l_to_id: INTEGER_32
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_temp_sg_font: CE_POINTER [ANY]
			l_tmp___32: INTEGER_32
			l_tmp___33: INTEGER_32
			l_tmp___34: CE_POINTER [NATURAL_8]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_tname: CE_POINTER [NATURAL_8]
			l_tmp___42: NATURAL_32
			l_tmp___44: INTEGER_32
			l_tmp___45: CE_POINTER [NATURAL_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_NATURAL_8_POINTER} l_key_start.make
			create {CE_NATURAL_8_POINTER} l_arg_start.make
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<100>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line := a_line
					l_key := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_arg := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_dodefault := 0
					l_doclear := 0
					l_dolink := 0
					l_error := 0
					l_is_normal_group := 0
					if ((create {P_EX_DOCMD_STATIC}).ends_excmd ((l_line.item).to_integer_32)).to_boolean then
						l_i___0 := 1
						from
						until
							(l_break)
						loop
							l_break := False
							if l_i___0 <= (highlight_ga.item.item.ga_len).to_integer_32 then
								if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								highlight_list_one (l_i___0.to_integer_32)
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						l_return := True
					end
					if not l_return then
						l_name_end := (create {P_CHARSET_STATIC}).skiptowhite (l_line)
						l_linep := (create {P_CHARSET_STATIC}).skipwhite (l_name_end)
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_line), ce_string ("default"), (l_name_end.distance (l_line)).to_natural_32)) = 0 then
							l_dodefault := 1
							l_line := l_linep
							l_name_end := (create {P_CHARSET_STATIC}).skiptowhite (l_line)
							l_linep := (create {P_CHARSET_STATIC}).skipwhite (l_name_end)
						end
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_line), ce_string ("clear"), (l_name_end.distance (l_line)).to_natural_32)) = 0 then
							l_doclear := 1
						end
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_line), ce_string ("link"), (l_name_end.distance (l_line)).to_natural_32)) = 0 then
							l_dolink := 1
						end
						if not l_doclear.to_boolean then
							if not l_dolink.to_boolean then
								if ((create {P_EX_DOCMD_STATIC}).ends_excmd ((l_linep.item).to_integer_32)).to_boolean then
									l_id := syn_namen2id (l_line, l_name_end.distance (l_line))
									if l_id = 0 then
										(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E411: highlight group not found: %%s")))), l_line).do_nothing
									else
										highlight_list_one (l_id)
									end
									l_return := True
								end
							end
						end
					end
					if not (not l_return and then (l_dolink.to_boolean)) then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_from_start := l_linep
						l_from_end := (create {P_CHARSET_STATIC}).skiptowhite (l_from_start)
						l_to_start := (create {P_CHARSET_STATIC}).skipwhite (l_from_end)
						l_to_end := (create {P_CHARSET_STATIC}).skiptowhite (l_to_start)
						if ((create {P_EX_DOCMD_STATIC}).ends_excmd ((l_from_start.item).to_integer_32)).to_boolean then
							l_tmp___5 := gettext (ce_string ("E412: Not enough arguments: %":highlight link %%s%""));
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___5), l_from_start).do_nothing
							l_return := True
						elseif ((create {P_EX_DOCMD_STATIC}).ends_excmd ((l_to_start.item).to_integer_32)).to_boolean then
							l_tmp___5 := gettext (ce_string ("E412: Not enough arguments: %":highlight link %%s%""));
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___5), l_from_start).do_nothing
							l_return := True
						end
						if not l_return then
							if not ((create {P_EX_DOCMD_STATIC}).ends_excmd ((((create {P_CHARSET_STATIC}).skipwhite (l_to_end)).item).to_integer_32)).to_boolean then
								(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E413: Too many arguments: %":highlight link %%s%"")))), l_from_start).do_nothing
								l_return := True
							end
						end
						if l_return then
							l_pos := -1 + 12 -- skip if block
						end
				when 2 then -- if:
						l_from_id := syn_check_group (l_from_start, l_from_end.distance (l_from_start))
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_to_start), ce_string ("NONE"), (4).to_natural_32)) = 0 then
							l_to_id := 0
						else
							l_to_id := syn_check_group (l_to_start, l_to_end.distance (l_to_start))
						end
						if not (l_from_id > 0) then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if a_init.to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___2
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_from_id - 1)).item.sg_set /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 7 then -- if: | _L___2:
						if not (l_to_id > 0) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if not a_forceit.to_boolean then
							if not a_init.to_boolean then
								if (hl_has_settings (l_from_id - 1, l_dodefault)).to_boolean then
									if ((create {P_GLOBALS_STATIC}).sourcing_name.item).is_void then
										if not l_dodefault.to_boolean then
											(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E414: group has settings, highlight link ignored"))))).do_nothing
										end
									end
								else
									l_pos := -1 + 10 -- goto _L___1
								end
							else
								l_pos := -1 + 10 -- goto _L___1
							end
						else
							l_pos := -1 + 10 -- goto _L___1
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___1:
						if not a_init.to_boolean then
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_from_id - 1)).item.sg_set := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_from_id - 1)).item.sg_set).bit_or ((8))
						end
						(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_from_id - 1)).item.sg_link := l_to_id;
						(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_from_id - 1)).item.sg_scriptID := (create {P_GLOBALS_STATIC}).current_SID.item;
						(create {P_SCREEN_STATIC}).redraw_all_later (35)
				when 11 then -- if done | if done | if done;
						(create {P_GLOBALS_STATIC}).need_highlight_changed.item := 1
						l_return := True
				when 12 then -- if done | if done
					if not l_return and then (l_doclear.to_boolean) then
						l_line := l_linep
						if ((create {P_EX_DOCMD_STATIC}).ends_excmd ((l_line.item).to_integer_32)).to_boolean then
							(create {P_EVAL_STATIC}).do_unlet (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("colors_name")), 1).do_nothing
							restore_cterm_colors
							l_idx := 0
							from
							until
								not (l_idx < highlight_ga.item.item.ga_len)
							loop
								highlight_clear (l_idx)
								l_idx := l_idx + 1
							end
							init_highlight (1, 1)
							if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
								highlight_gui_started
							end
							highlight_changed.do_nothing;
							(create {P_SCREEN_STATIC}).redraw_later_clear
							l_return := True
						end
						if not l_return then
							l_name_end := (create {P_CHARSET_STATIC}).skiptowhite (l_line)
							l_linep := (create {P_CHARSET_STATIC}).skipwhite (l_name_end)
						end
					end
					if not l_return then
						l_id := syn_check_group (l_line, l_name_end.distance (l_line))
						if l_id = 0 then
							l_return := True
						end
					end
					if not l_return then
						l_idx := l_id - 1
						if l_dodefault.to_boolean then
							if (hl_has_settings (l_idx, 1)).to_boolean then
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 154 -- skip if block
					end
				when 13 then -- if:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_name_u), ce_string ("NORMAL"))) = 0 then
							l_is_normal_group := 1
						end
						if not (l_doclear.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 18 -- goto _L___3
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 16 then -- else:
						if not (a_forceit.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if not (a_init.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 18 then -- if: | _L___3:
						highlight_clear (l_idx)
						if not l_doclear.to_boolean then
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set := 0
						end
				when 19 then -- if done | if done
						if l_doclear.to_boolean then
							l_pos := -1 + 149 -- skip if block
						end
				when 20 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 148 -- skip loop
						end
				when 21 then -- loop body:
						l_break := False
						l_continue := False
						if ((create {P_EX_DOCMD_STATIC}).ends_excmd ((l_linep.item).to_integer_32)).to_boolean then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_key_start := l_linep
							if (l_linep.item).to_integer_32 = 61 then
								(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E415: unexpected equal sign: %%s")))), l_key_start).do_nothing
								l_error := 1
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) then
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_linep.item).to_boolean then
									if (l_linep.item).to_integer_32 = 32 then
										l_break := True
									elseif (l_linep.item).to_integer_32 = 9 then
										l_break := True
									elseif (l_linep.item).to_integer_32 = 61 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_linep := l_linep + 1
								end
							end
							l_break := False;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_key))
							l_key := (create {P_MISC2_STATIC}).vim_strnsave_up (l_key_start, l_linep.distance (l_key_start))
							if l_key.is_void then
								l_error := 1
								l_break := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 29 -- skip if block
						end
				when 22 then -- if:
						l_linep := (create {P_CHARSET_STATIC}).skipwhite (l_linep)
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_key), ce_string ("NONE"))) /= 0 then
							l_pos := -1 + 29 -- skip if block
						end
				when 23 then -- if:
						if a_init.to_boolean then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 27 -- goto _L___4
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 26 then -- else:
						if (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set /= 0 then
							l_pos := -1 + 28 -- skip if block
						end
				when 27 then -- if: | _L___4:
						if not a_init.to_boolean then
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_or ((7))
						end
						highlight_clear (l_idx)
				when 28 then -- if done
						l_continue := True
				when 29 then -- if done | if done
						if not (l_return or l_break or l_continue) and then ((l_linep.item).to_integer_32 /= 61) then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E416: missing equal sign: %%s")))), l_key_start).do_nothing
							l_error := 1
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_linep := l_linep + 1
							l_linep := (create {P_CHARSET_STATIC}).skipwhite (l_linep)
							if (l_linep.item).to_integer_32 = 39 then
								l_linep := l_linep + 1
								l_arg_start := l_linep
								l_linep := (create {P_MISC2_STATIC}).vim_strchr (l_linep, ('%'').code)
								if l_linep.is_void then
									(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_invarg2.item))))), l_key_start).do_nothing
									l_error := 1
									l_break := True
								end
							else
								l_arg_start := l_linep
								l_linep := (create {P_CHARSET_STATIC}).skiptowhite (l_linep)
							end
						end
						if not (l_return or l_break or l_continue) and then (l_linep.is_equal (l_arg_start)) then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E417: missing argument: %%s")))), l_key_start).do_nothing
							l_error := 1
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_arg))
							l_arg := (create {P_MISC2_STATIC}).vim_strnsave (l_arg_start, l_linep.distance (l_arg_start))
							if l_arg.is_void then
								l_error := 1
								l_break := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 147 -- skip if block
						end
				when 30 then -- if:
						if (l_linep.item).to_integer_32 = 39 then
							l_linep := l_linep + 1
						end
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_key), ce_string ("TERM"))) /= 0 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						l_pos := -1 + 37 -- goto _L___19
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 147
				when 33 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_key), ce_string ("CTERM"))) /= 0 then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_pos := -1 + 37 -- goto _L___19
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 147
				when 36 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_key), ce_string ("GUI"))) /= 0 then
							l_pos := -1 + 58 -- skip if block
						end
				when 37 then -- if: | _L___19:
						l_attr := 0
						l_off___0 := 0
						from
						until
							not (not (l_return or l_break) and then ((l_arg[l_off___0]).to_integer_32 /= 0))
						loop
							l_break := False
							l_i___0 := (({PLATFORM}.Integer_32_bytes.to_natural_32 * (8).to_natural_32) // {PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
							from
							until
								(l_break)
							loop
								l_break := False
								l_i___0 := l_i___0 - 1
								if not (l_i___0 >= 0) then
									l_break := True
								end
								if not (l_break) then
									l_len := (strlen (hl_name_table.item[l_i___0])).to_integer_32
									if (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_arg + l_off___0)), hl_name_table.item[l_i___0], l_len.to_natural_32)) = 0 then
										l_attr := (l_attr).bit_or ((hl_attr_table.item[l_i___0]))
										l_off___0 := l_off___0 + l_len
										l_break := True
									end
								end
							end
							l_break := False
							if l_i___0 < 0 then
								(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E418: Illegal value: %%s")))), l_arg).do_nothing
								l_error := 1
								l_break := True
							end
							if not (l_return or l_break) and then ((l_arg[l_off___0]).to_integer_32 = 44) then
								l_off___0 := l_off___0 + 1
							end
						end
						l_break := False
						if l_error.to_boolean then
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 57 -- skip if block
						end
				when 38 then -- if:
						if (l_key.item).to_integer_32 /= 84 then
							l_pos := -1 + 45 -- skip if block
						end
				when 39 then -- if:
						if a_init.to_boolean then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						l_pos := -1 + 43 -- goto _L___5
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 42 then -- else:
						if (((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_and (1)).to_boolean then
							l_pos := -1 + 44 -- skip if block
						end
				when 43 then -- if: | _L___5:
						if not a_init.to_boolean then
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_or ((1))
						end
						(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_term := l_attr
				when 44 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 57
				when 45 then -- else:
						if (l_key.item).to_integer_32 /= 67 then
							l_pos := -1 + 52 -- skip if block
						end
				when 46 then -- if:
						if a_init.to_boolean then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						l_pos := -1 + 50 -- goto _L___6
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 51
				when 49 then -- else:
						if (((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_and (2)).to_boolean then
							l_pos := -1 + 51 -- skip if block
						end
				when 50 then -- if: | _L___6:
						if not a_init.to_boolean then
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_or ((2))
						end
						(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_cterm := l_attr;
						(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_cterm_bold := 0
				when 51 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 57
				when 52 then -- else:
						if a_init.to_boolean then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:
						l_pos := -1 + 56 -- goto _L___7
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 55 then -- else:
						if (((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_and (4)).to_boolean then
							l_pos := -1 + 57 -- skip if block
						end
				when 56 then -- if: | _L___7:
						if not a_init.to_boolean then
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_or ((4))
						end
						(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui := l_attr
				when 57 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 147
				when 58 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_key), ce_string ("FONT"))) /= 0 then
							l_pos := -1 + 61 -- skip if block
						end
				when 59 then -- if:
						if not ((create {P_GUI_STATIC}).gui.item.item.shell_created).to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_font_name));
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_font_name := (create {P_MISC2_STATIC}).vim_strsave (l_arg)
						else
							l_temp_sg_font := (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_font;
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_font := create {CE_VOID_POINTER}.make_shared (default_pointer)
							hl_do_font (l_idx, l_arg, l_is_normal_group, 0, 0)
							if not ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_font).is_void then
								(create {P_GUI_GTK_X11_STATIC}).gui_mch_free_font (l_temp_sg_font);
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_font_name));
								(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_font_name := (create {P_MISC2_STATIC}).vim_strsave (l_arg)
							else
								(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_font := l_temp_sg_font
							end
						end
				when 60 then -- if block done, skip else block:
						l_pos := -1 + 147
				when 61 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_key), ce_string ("CTERMFG"))) /= 0 then
							l_pos := -1 + 64 -- skip if block
						end
				when 62 then -- if:
						l_pos := -1 + 65 -- goto _L___18
				when 63 then -- if block done, skip else block:
						l_pos := -1 + 147
				when 64 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_key), ce_string ("CTERMBG"))) /= 0 then
							l_pos := -1 + 98 -- skip if block
						end
				when 65 then -- if: | _L___18:
						if a_init.to_boolean then
							l_pos := -1 + 68 -- skip if block
						end
				when 66 then -- if:
						l_pos := -1 + 69 -- goto _L___10
				when 67 then -- if block done, skip else block:
						l_pos := -1 + 97
				when 68 then -- else:
						if (((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_and (2)).to_boolean then
							l_pos := -1 + 97 -- skip if block
						end
				when 69 then -- if: | _L___10:
						if not a_init.to_boolean then
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_or ((2))
						end
						if (l_key[5]).to_integer_32 = 70 then
							if ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_cterm_bold).to_boolean then
								(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_cterm := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_cterm).bit_and ((-3));
								(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_cterm_bold := 0
							end
						end
						if not ((l_arg.item).to_integer_32 >= 48) then
							l_pos := -1 + 72 -- skip if block
						end
				when 70 then -- if:
						if (l_arg.item).to_integer_32 <= 57 then
							l_color := atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_arg))
						else
							l_pos := -1 + 72 -- goto _L___9
						end
				when 71 then -- if block done, skip else block:
						l_pos := -1 + 96
				when 72 then -- else: | _L___9:
						if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("fg"))) /= 0 then
							l_pos := -1 + 75 -- skip if block
						end
				when 73 then -- if:
						if ((create {P_GLOBALS_STATIC}).cterm_normal_fg_color.item).to_boolean then
							l_color := (create {P_GLOBALS_STATIC}).cterm_normal_fg_color.item - 1
						else
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E419: FG color unknown"))))).do_nothing
							l_error := 1
							l_break := True
						end
				when 74 then -- if block done, skip else block:
						l_pos := -1 + 96
				when 75 then -- else:
						if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("bg"))) /= 0 then
							l_pos := -1 + 78 -- skip if block
						end
				when 76 then -- if:
						if (create {P_GLOBALS_STATIC}).cterm_normal_bg_color.item > 0 then
							l_color := (create {P_GLOBALS_STATIC}).cterm_normal_bg_color.item - 1
						else
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E420: BG color unknown"))))).do_nothing
							l_error := 1
							l_break := True
						end
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 96
				when 78 then -- else:
						if (l_arg.item).to_integer_32 < 97 then
							l_off___0 := (l_arg.item).to_integer_32
						elseif (l_arg.item).to_integer_32 > 122 then
							l_off___0 := (l_arg.item).to_integer_32
						else
							l_off___0 := (l_arg.item).to_integer_32 - 32
						end
						l_i___0 := (({PLATFORM}.Pointer_bytes.to_natural_32 * (28).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32
						from
						until
							(l_break)
						loop
							l_break := False
							l_i___0 := l_i___0 - 1
							if not (l_i___0 >= 0) then
								l_break := True
							end
							if not (l_return or l_break) and then (l_off___0 = ((color_names.item[l_i___0])[0]).to_integer_32) then
								if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_arg + 1)), (color_names.item[l_i___0] + 1))) = 0 then
									l_break := True
								end
							end
						end
						l_break := False
						if l_i___0 < 0 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E421: Color name or number not recognized: %%s")))), l_key_start).do_nothing
							l_error := 1
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 96 -- skip if block
						end
				when 79 then -- if:
						l_color := color_numbers_16.item[l_i___0]
						if not (l_color >= 0) then
							l_pos := -1 + 96 -- skip if block
						end
				when 80 then -- if:
						if (create {P_GLOBALS_STATIC}).t_colors.item /= 8 then
							l_pos := -1 + 83 -- skip if block
						end
				when 81 then -- if:
						l_color := color_numbers_8.item[l_i___0]
						if (l_key[5]).to_integer_32 = 70 then
							if ((l_color).bit_and (8)).to_boolean then
								(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_cterm := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_cterm).bit_or ((2));
								(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_cterm_bold := 1
							else
								(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_cterm := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_cterm).bit_and ((-3))
							end
						end
						l_color := (l_color).bit_and ((7))
				when 82 then -- if block done, skip else block:
						l_pos := -1 + 96
				when 83 then -- else:
						if (create {P_GLOBALS_STATIC}).t_colors.item /= 16 then
							l_pos := -1 + 86 -- skip if block
						end
				when 84 then -- if:
						l_pos := -1 + 90 -- goto _L___8
				when 85 then -- if block done, skip else block:
						l_pos := -1 + 96
				when 86 then -- else:
						if (create {P_GLOBALS_STATIC}).t_colors.item /= 88 then
							l_pos := -1 + 89 -- skip if block
						end
				when 87 then -- if:
						l_pos := -1 + 90 -- goto _L___8
				when 88 then -- if block done, skip else block:
						l_pos := -1 + 96
				when 89 then -- else:
						if (create {P_GLOBALS_STATIC}).t_colors.item /= 256 then
							l_pos := -1 + 96 -- skip if block
						end
				when 90 then -- if: | _L___8:
						if (((create {P_TERM_STATIC}).term_strings.item[42]).item).to_integer_32 /= 0 then
							l_p___0.item := (create {P_TERM_STATIC}).term_strings.item[42]
						else
							l_p___0.item := (create {P_TERM_STATIC}).term_strings.item[38]
						end
						if (l_p___0.item.item).to_integer_32 = 0 then
							l_pos := -1 + 96 -- skip if block
						end
				when 91 then -- if:
						if ((l_p___0.item + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item))).to_integer_32)[-1]).to_integer_32 /= 109 then
							l_pos := -1 + 96 -- skip if block
						end
				when 92 then -- if:
						inspect (create {P_GLOBALS_STATIC}).t_colors.item -- switch 1 head
						when 16 then l_pos := -1 + 93
						when 88 then l_pos := -1 + 94
						when 256 then l_pos := -1 + 95
						else l_pos := -1 + 96
						end
				when 93 then -- switch 1, case 16
						l_color := color_numbers_8.item[l_i___0]
						l_pos := -1 + 96 -- switch 1; break
				when 94 then -- switch 1, case 88
						l_color := color_numbers_88.item[l_i___0]
						l_pos := -1 + 96 -- switch 1; break
				when 95 then -- switch 1, case 256
						l_color := color_numbers_256.item[l_i___0]
						l_pos := -1 + 96 -- switch 1; break
				when 96 then -- switch 1, done: | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not (l_return or l_break or l_continue) then
							if (l_key[5]).to_integer_32 = 70 then
								(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_cterm_fg := l_color + 1
								if l_is_normal_group.to_boolean then
									(create {P_GLOBALS_STATIC}).cterm_normal_fg_color.item := l_color + 1;
									(create {P_GLOBALS_STATIC}).cterm_normal_fg_bold.item := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_cterm).bit_and (2)
									if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
										if not ((create {P_GUI_STATIC}).gui.item.item.starting).to_boolean then
											(create {P_GLOBALS_STATIC}).must_redraw.item := 50
											if ((create {P_GLOBALS_STATIC}).termcap_active.item).to_boolean then
												if l_color >= 0 then
													(create {P_TERM_STATIC}).term_fg_color (l_color)
												end
											end
										end
									end
								end
							else
								(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_cterm_bg := l_color + 1
								if l_is_normal_group.to_boolean then
									(create {P_GLOBALS_STATIC}).cterm_normal_bg_color.item := l_color + 1
									if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
										if not ((create {P_GUI_STATIC}).gui.item.item.starting).to_boolean then
											(create {P_GLOBALS_STATIC}).must_redraw.item := 50
											if l_color >= 0 then
												if ((create {P_GLOBALS_STATIC}).termcap_active.item).to_boolean then
													(create {P_TERM_STATIC}).term_bg_color (l_color)
												end
												if (create {P_GLOBALS_STATIC}).t_colors.item < 16 then
													if l_color = 0 then
														l_tmp___32 := 1
													elseif l_color = 4 then
														l_tmp___32 := 1
													else
														l_tmp___32 := 0
													end
													l_i___0 := l_tmp___32.to_integer_32
												else
													if l_color < 7 then
														l_tmp___33 := 1
													elseif l_color = 8 then
														l_tmp___33 := 1
													else
														l_tmp___33 := 0
													end
													l_i___0 := l_tmp___33.to_integer_32
												end
												if l_i___0 /= (((create {P_OPTION_STATIC}).p_bg.item.item.item).to_integer_32 = 100).to_integer then
													if l_i___0.to_boolean then
														l_tmp___34 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("dark"))
													else
														l_tmp___34 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("light"))
													end
													(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bg")), 0, l_tmp___34, 0)
												end
											end
										end
									end
								end
							end
						end
				when 97 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 147
				when 98 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_key), ce_string ("GUIFG"))) /= 0 then
							l_pos := -1 + 112 -- skip if block
						end
				when 99 then -- if:
						if a_init.to_boolean then
							l_pos := -1 + 102 -- skip if block
						end
				when 100 then -- if:
						l_pos := -1 + 103 -- goto _L___12
				when 101 then -- if block done, skip else block:
						l_pos := -1 + 111
				when 102 then -- else:
						if (((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_and (4)).to_boolean then
							l_pos := -1 + 111 -- skip if block
						end
				when 103 then -- if: | _L___12:
						if not a_init.to_boolean then
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_or ((4))
						end
						l_i___0 := color_name2handle (l_arg)
						if l_i___0 = -11_111 then
							l_pos := -1 + 106 -- skip if block
						end
				when 104 then -- if:
						l_pos := -1 + 110 -- goto _L___11
				when 105 then -- if block done, skip else block:
						l_pos := -1 + 111
				when 106 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("NONE"))) /= 0 then
							l_pos := -1 + 109 -- skip if block
						end
				when 107 then -- if:
						l_pos := -1 + 110 -- goto _L___11
				when 108 then -- if block done, skip else block:
						l_pos := -1 + 111
				when 109 then -- else:
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							l_pos := -1 + 111 -- skip if block
						end
				when 110 then -- if: | _L___11:;
						(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_fg := l_i___0;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_fg_name))
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("NONE"))).to_boolean then
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_fg_name := (create {P_MISC2_STATIC}).vim_strsave (l_arg)
						else
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_fg_name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
				when 111 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 147
				when 112 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_key), ce_string ("GUIBG"))) /= 0 then
							l_pos := -1 + 126 -- skip if block
						end
				when 113 then -- if:
						if a_init.to_boolean then
							l_pos := -1 + 116 -- skip if block
						end
				when 114 then -- if:
						l_pos := -1 + 117 -- goto _L___14
				when 115 then -- if block done, skip else block:
						l_pos := -1 + 125
				when 116 then -- else:
						if (((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_and (4)).to_boolean then
							l_pos := -1 + 125 -- skip if block
						end
				when 117 then -- if: | _L___14:
						if not a_init.to_boolean then
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_or ((4))
						end
						l_i___0 := color_name2handle (l_arg)
						if l_i___0 = -11_111 then
							l_pos := -1 + 120 -- skip if block
						end
				when 118 then -- if:
						l_pos := -1 + 124 -- goto _L___13
				when 119 then -- if block done, skip else block:
						l_pos := -1 + 125
				when 120 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("NONE"))) /= 0 then
							l_pos := -1 + 123 -- skip if block
						end
				when 121 then -- if:
						l_pos := -1 + 124 -- goto _L___13
				when 122 then -- if block done, skip else block:
						l_pos := -1 + 125
				when 123 then -- else:
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							l_pos := -1 + 125 -- skip if block
						end
				when 124 then -- if: | _L___13:;
						(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_bg := l_i___0;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_bg_name))
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("NONE"))) /= 0 then
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_bg_name := (create {P_MISC2_STATIC}).vim_strsave (l_arg)
						else
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_bg_name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
				when 125 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 147
				when 126 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_key), ce_string ("GUISP"))) /= 0 then
							l_pos := -1 + 140 -- skip if block
						end
				when 127 then -- if:
						if a_init.to_boolean then
							l_pos := -1 + 130 -- skip if block
						end
				when 128 then -- if:
						l_pos := -1 + 131 -- goto _L___16
				when 129 then -- if block done, skip else block:
						l_pos := -1 + 139
				when 130 then -- else:
						if (((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_and (4)).to_boolean then
							l_pos := -1 + 139 -- skip if block
						end
				when 131 then -- if: | _L___16:
						if not a_init.to_boolean then
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_or ((4))
						end
						l_i___0 := color_name2handle (l_arg)
						if l_i___0 = -11_111 then
							l_pos := -1 + 134 -- skip if block
						end
				when 132 then -- if:
						l_pos := -1 + 138 -- goto _L___15
				when 133 then -- if block done, skip else block:
						l_pos := -1 + 139
				when 134 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("NONE"))) /= 0 then
							l_pos := -1 + 137 -- skip if block
						end
				when 135 then -- if:
						l_pos := -1 + 138 -- goto _L___15
				when 136 then -- if block done, skip else block:
						l_pos := -1 + 139
				when 137 then -- else:
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							l_pos := -1 + 139 -- skip if block
						end
				when 138 then -- if: | _L___15:;
						(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_sp := l_i___0;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_sp_name))
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("NONE"))) /= 0 then
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_sp_name := (create {P_MISC2_STATIC}).vim_strsave (l_arg)
						else
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_sp_name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
				when 139 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 147
				when 140 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_key), ce_string ("START"))) /= 0 then
							l_pos := -1 + 143 -- skip if block
						end
				when 141 then -- if:
						l_pos := -1 + 144 -- goto _L___17
				when 142 then -- if block done, skip else block:
						l_pos := -1 + 147
				when 143 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_key), ce_string ("STOP"))) /= 0 then
							l_pos := -1 + 146 -- skip if block
						end
				when 144 then -- if: | _L___17:
						if not a_init.to_boolean then
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_or ((1))
						end
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("t_"), (2).to_natural_32)) = 0 then
							l_off___0 := 0
							l_buf___6[0] := (0).to_natural_8
							from
							until
								not (not (l_return or l_break) and then ((l_arg[l_off___0]).to_integer_32 /= 0))
							loop
								l_break := False
								l_len := 0
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_arg[(l_off___0 + l_len)]).to_boolean then
										if (l_arg[(l_off___0 + l_len)]).to_integer_32 = 44 then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_return or l_break) then
										l_len := l_len + 1
									end
								end
								l_break := False
								l_tname := (create {P_MISC2_STATIC}).vim_strnsave (l_arg + l_off___0, l_len)
								if l_tname.is_void then
									l_error := 1
									l_break := True
								end
								if not (l_return or l_break) then
									l_p___0.item := (create {P_OPTION_STATIC}).get_term_code (l_tname);
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tname))
									if (l_p___0.item).is_void then
										l_p___0.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
									end
									l_tmp___42 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))
									if (l_tmp___42 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item)))).to_integer_32 >= 99 then
										(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E422: terminal code too long: %%s")))), l_arg).do_nothing
										l_error := 1
										l_break := True
									end
								end
								if not (l_return or l_break) then
									strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item)).do_nothing
									l_off___0 := l_off___0 + l_len
									if (l_arg[l_off___0]).to_integer_32 = 44 then
										l_off___0 := l_off___0 + 1
									end
								end
							end
							l_break := False
						else
							l_p___0.item := l_arg
							l_off___0 := 0
							from
							until
								(l_break)
							loop
								l_break := False
								if l_off___0 < 100 then
									if not (l_p___0.item.item).to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_len := (create {P_MISC2_STATIC}).trans_special (l_p___0, l_buf___6 + l_off___0, 0)
									if l_len.to_boolean then
										l_off___0 := l_off___0 + l_len
									else
										l_tmp___44 := l_off___0
										l_off___0 := l_off___0 + 1
										l_tmp___45 := l_p___0.item
										l_p___0.item := l_p___0.item + 1
										l_buf___6[l_tmp___44] := l_tmp___45.item
									end
								end
							end
							l_break := False
							l_buf___6[l_off___0] := (('%/0/').code).to_natural_8
						end
						if l_error.to_boolean then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("NONE"))) = 0 then
								l_p___0.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							else
								l_p___0.item := (create {P_MISC2_STATIC}).vim_strsave (l_buf___6)
							end
							if (l_key[2]).to_integer_32 = 65 then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_start));
								(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_start := l_p___0.item
							else
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_stop));
								(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_stop := l_p___0.item
							end
						end
				when 145 then -- if block done, skip else block:
						l_pos := -1 + 147
				when 146 then -- else:;
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E423: Illegal argument: %%s")))), l_key_start).do_nothing
						l_error := 1
						l_break := True
				when 147 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not (l_return or l_break or l_continue) then
							if not a_init.to_boolean then
								(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_link := 0
							elseif not (((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_set).bit_and (8)).to_boolean then
								(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_link := 0
							end
							l_linep := (create {P_CHARSET_STATIC}).skipwhite (l_linep)
						end
						l_pos := -1 + 20 -- back to loop condition
				when 148 then -- loop done
						l_break := False
						l_continue := False
				when 149 then -- if done
						if not (l_error.to_boolean) then
							l_pos := -1 + 152 -- skip if block
						end
				when 150 then -- if:
						if l_idx = highlight_ga.item.item.ga_len then
							syn_unadd_group
						else
							l_pos := -1 + 152 -- goto _L___20
						end
				when 151 then -- if block done, skip else block:
						l_pos := -1 + 153
				when 152 then -- else: | _L___20:
						if l_is_normal_group.to_boolean then
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_term_attr := 0;
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_cterm_attr := 0;
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_attr := 0
							if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
								highlight_gui_started
							end
						else
							set_hl_attr (l_idx)
						end
						(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_scriptID := (create {P_GLOBALS_STATIC}).current_SID.item;
						(create {P_SCREEN_STATIC}).redraw_all_later (40)
				when 153 then;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_key));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_arg));
						(create {P_GLOBALS_STATIC}).need_highlight_changed.item := 1
				when 154 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	restore_cterm_colors
		do
			(create {P_GLOBALS_STATIC}).cterm_normal_fg_color.item := 0;
			(create {P_GLOBALS_STATIC}).cterm_normal_fg_bold.item := 0;
			(create {P_GLOBALS_STATIC}).cterm_normal_bg_color.item := 0
		end

	hl_has_settings (a_idx, a_check_link: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_term_attr /= 0 then
				l_tmp := 1
			elseif (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_cterm_attr /= 0 then
				l_tmp := 1
			elseif (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_attr /= 0 then
				l_tmp := 1
			elseif a_check_link.to_boolean then
				if (((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_set).bit_and (8)).to_boolean then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	highlight_clear (a_idx: INTEGER_32)
		do
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_term := 0;
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_start));
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_start := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_stop));
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_stop := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_term_attr := 0;
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_cterm := 0;
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_cterm_bold := 0;
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_cterm_fg := 0;
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_cterm_bg := 0;
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_cterm_attr := 0;
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui := 0;
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_fg_name));
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_fg_name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_bg_name));
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_bg_name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_sp_name));
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_sp_name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_fg := (-11_111).to_integer_32;
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_bg := (-11_111).to_integer_32;
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_sp := (-11_111).to_integer_32;
			(create {P_GUI_GTK_X11_STATIC}).gui_mch_free_font ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_font);
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_font := create {CE_VOID_POINTER}.make_shared (default_pointer);
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_font_name));
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_font_name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_attr := 0
			if (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_link = 0 then
				(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_scriptID := 0
			end
		end

	set_normal_colors
		do
			if (set_group_colors (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Normal")), create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GUI_STATIC}).gui.item.item.c_pointer + (create {PD_GUI}.make).offset_of ("norm_pixel")), create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GUI_STATIC}).gui.item.item.c_pointer + (create {PD_GUI}.make).offset_of ("back_pixel")), 0, 1, 0)).to_boolean then
				(create {P_GUI_GTK_X11_STATIC}).gui_mch_new_colors;
				(create {P_GLOBALS_STATIC}).must_redraw.item := 50
			end
		end

	set_group_colors (a_name___1: CE_POINTER [NATURAL_8]; a_fgp, a_bgp: CE_POINTER [INTEGER_32]; a_do_menu, a_use_norm, a_do_tooltip: INTEGER_32): INTEGER_32
		local
			l_idx: INTEGER_32
			l_return: BOOLEAN
		do
			l_idx := (syn_name2id (a_name___1)) - 1
			if l_idx >= 0 then
				gui_do_one_color (l_idx, a_do_menu, a_do_tooltip)
				if (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_fg /= -11_111 then
					a_fgp.item := (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_fg
				elseif a_use_norm.to_boolean then
					a_fgp.item := (create {P_GUI_STATIC}).gui.item.item.def_norm_pixel
				end
				if (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_bg /= -11_111 then
					a_bgp.item := (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_gui_bg
				elseif a_use_norm.to_boolean then
					a_bgp.item := (create {P_GUI_STATIC}).gui.item.item.def_back_pixel
				end
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	hl_get_font_name: CE_POINTER [NATURAL_8]
		local
			l_id: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_id := syn_name2id (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Normal")))
			if l_id > 0 then
				l_s := (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_id - 1)).item.sg_font_name
				if not l_s.is_void then
					Result := l_s
					l_return := True
				end
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
			end
		end

	hl_set_font_name (a_font_name: CE_POINTER [NATURAL_8])
		local
			l_id: INTEGER_32
		do
			l_id := syn_name2id (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Normal")))
			if l_id > 0 then
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_id - 1)).item.sg_font_name));
				(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_id - 1)).item.sg_font_name := (create {P_MISC2_STATIC}).vim_strsave (a_font_name)
			end
		end

	hl_set_bg_color_name (a_name___1: CE_POINTER [NATURAL_8])
		local
			l_id: INTEGER_32
		do
			if not a_name___1.is_void then
				l_id := syn_name2id (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Normal")))
				if l_id > 0 then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_id - 1)).item.sg_gui_bg_name));
					(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_id - 1)).item.sg_gui_bg_name := a_name___1
				end
			end
		end

	hl_set_fg_color_name (a_name___1: CE_POINTER [NATURAL_8])
		local
			l_id: INTEGER_32
		do
			if not a_name___1.is_void then
				l_id := syn_name2id (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Normal")))
				if l_id > 0 then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_id - 1)).item.sg_gui_fg_name));
					(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_id - 1)).item.sg_gui_fg_name := a_name___1
				end
			end
		end

	color_name2handle (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("NONE"))) = 0 then
				Result := (-11_111).to_integer_32
				l_return := True
			end
			if not l_return then
				if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("fg"))) = 0 then
					Result := ((create {P_GUI_STATIC}).gui.item.item.norm_pixel)
					l_return := True
				elseif (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("foreground"))) = 0 then
					Result := ((create {P_GUI_STATIC}).gui.item.item.norm_pixel)
					l_return := True
				end
			end
			if not l_return then
				if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("bg"))) = 0 then
					Result := ((create {P_GUI_STATIC}).gui.item.item.back_pixel)
					l_return := True
				elseif (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("background"))) = 0 then
					Result := ((create {P_GUI_STATIC}).gui.item.item.back_pixel)
					l_return := True
				end
			end
			if not l_return then
				Result := ((create {P_GUI_STATIC}).gui_get_color (a_name___1))
			end
		end

	font_name2handle (a_name___1: CE_POINTER [NATURAL_8]): CE_POINTER [ANY]
		local
			l_return: BOOLEAN
		do
			if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("NONE"))) = 0 then
				Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := ((create {P_GUI_GTK_X11_STATIC}).gui_mch_get_font (a_name___1, 1))
			end
		end

	hl_do_font (a_idx: INTEGER_32; a_arg: CE_POINTER [NATURAL_8]; a_do_normal, a_do_menu, a_do_tooltip: INTEGER_32)
		do
			(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_font := font_name2handle (a_arg)
			if not ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_font).is_void then
				if a_do_normal.to_boolean then
					(create {P_GUI_STATIC}).gui_init_font (a_arg, 0).do_nothing
				end
			end
		end

	hl_combine_attr (a_char_attr, a_prim_attr: INTEGER_32): INTEGER_32
		local
			l_char_aep: CE_POINTER [PD_ATTR_ENTRY]
			l_spell_aep: CE_POINTER [PD_ATTR_ENTRY]
			l_new_en: CE_ARRAY [PD_ATTR_ENTRY]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_ATTR_ENTRY]} l_new_en.make (<<1>>)

			l_char_aep := create {CE_CLASS_POINTER [PD_ATTR_ENTRY]}.make_shared (default_pointer)
			if a_char_attr = 0 then
				Result := a_prim_attr
				l_return := True
			end
			if not l_return and then (a_char_attr <= 63) then
				if a_prim_attr <= 63 then
					Result := ((a_char_attr).bit_or (a_prim_attr))
					l_return := True
				end
			end
			if not l_return and then (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
				if a_char_attr > 63 then
					l_char_aep := syn_gui_attr2entry (a_char_attr)
				end
				if not l_char_aep.is_void then
					l_new_en.item := (l_char_aep.item).twin
				else
					memset (create {CE_VOID_POINTER}.make_cast (l_new_en), 0, (create {PD_ATTR_ENTRY}.make).structure_size.to_natural_32).do_nothing
					l_new_en.item.ae_u.gui.fg_color := (-11_111).to_integer_32
					l_new_en.item.ae_u.gui.bg_color := (-11_111).to_integer_32
					l_new_en.item.ae_u.gui.sp_color := (-11_111).to_integer_32
					if a_char_attr <= 63 then
						l_new_en.item.ae_attr := a_char_attr.to_integer_16
					end
				end
				if a_prim_attr <= 63 then
					l_new_en.item.ae_attr := (((l_new_en.item.ae_attr).to_integer_32).bit_or (a_prim_attr)).to_integer_16
				else
					l_spell_aep := syn_gui_attr2entry (a_prim_attr)
					if not l_spell_aep.is_void then
						l_new_en.item.ae_attr := (((l_new_en.item.ae_attr).to_integer_32).bit_or ((l_spell_aep.item.ae_attr).to_integer_32)).to_integer_16
						if l_spell_aep.item.ae_u.gui.fg_color /= -11_111 then
							l_new_en.item.ae_u.gui.fg_color := l_spell_aep.item.ae_u.gui.fg_color
						end
						if l_spell_aep.item.ae_u.gui.bg_color /= -11_111 then
							l_new_en.item.ae_u.gui.bg_color := l_spell_aep.item.ae_u.gui.bg_color
						end
						if l_spell_aep.item.ae_u.gui.sp_color /= -11_111 then
							l_new_en.item.ae_u.gui.sp_color := l_spell_aep.item.ae_u.gui.sp_color
						end
						if not (l_spell_aep.item.ae_u.gui.font).is_void then
							l_new_en.item.ae_u.gui.font := l_spell_aep.item.ae_u.gui.font
						end
					end
				end
				Result := (gui_attr_table.item.item.get_attr_entry (l_new_en))
				l_return := True
			end
			if not l_return and then ((create {P_GLOBALS_STATIC}).t_colors.item > 1) then
				if a_char_attr > 63 then
					l_char_aep := syn_cterm_attr2entry (a_char_attr)
				end
				if not l_char_aep.is_void then
					l_new_en.item := (l_char_aep.item).twin
				else
					memset (create {CE_VOID_POINTER}.make_cast (l_new_en), 0, (create {PD_ATTR_ENTRY}.make).structure_size.to_natural_32).do_nothing
					if a_char_attr <= 63 then
						l_new_en.item.ae_attr := a_char_attr.to_integer_16
					end
				end
				if a_prim_attr <= 63 then
					l_new_en.item.ae_attr := (((l_new_en.item.ae_attr).to_integer_32).bit_or (a_prim_attr)).to_integer_16
				else
					l_spell_aep := syn_cterm_attr2entry (a_prim_attr)
					if not l_spell_aep.is_void then
						l_new_en.item.ae_attr := (((l_new_en.item.ae_attr).to_integer_32).bit_or ((l_spell_aep.item.ae_attr).to_integer_32)).to_integer_16
						if (l_spell_aep.item.ae_u.cterm.fg_color).to_integer_32 > 0 then
							l_new_en.item.ae_u.cterm.fg_color := l_spell_aep.item.ae_u.cterm.fg_color
						end
						if (l_spell_aep.item.ae_u.cterm.bg_color).to_integer_32 > 0 then
							l_new_en.item.ae_u.cterm.bg_color := l_spell_aep.item.ae_u.cterm.bg_color
						end
					end
				end
				Result := (cterm_attr_table.item.item.get_attr_entry (l_new_en))
				l_return := True
			end
			if not l_return then
				if a_char_attr > 63 then
					l_char_aep := syn_term_attr2entry (a_char_attr)
				end
				if not l_char_aep.is_void then
					l_new_en.item := (l_char_aep.item).twin
				else
					memset (create {CE_VOID_POINTER}.make_cast (l_new_en), 0, (create {PD_ATTR_ENTRY}.make).structure_size.to_natural_32).do_nothing
					if a_char_attr <= 63 then
						l_new_en.item.ae_attr := a_char_attr.to_integer_16
					end
				end
				if a_prim_attr <= 63 then
					l_new_en.item.ae_attr := (((l_new_en.item.ae_attr).to_integer_32).bit_or (a_prim_attr)).to_integer_16
				else
					l_spell_aep := syn_term_attr2entry (a_prim_attr)
					if not l_spell_aep.is_void then
						l_new_en.item.ae_attr := (((l_new_en.item.ae_attr).to_integer_32).bit_or ((l_spell_aep.item.ae_attr).to_integer_32)).to_integer_16
						if not (l_spell_aep.item.ae_u.term.start).is_void then
							l_new_en.item.ae_u.term.start := l_spell_aep.item.ae_u.term.start
							l_new_en.item.ae_u.term.stop := l_spell_aep.item.ae_u.term.stop
						end
					end
				end
				Result := (term_attr_table.item.item.get_attr_entry (l_new_en))
			end
		end

	syn_gui_attr2entry (a_attr: INTEGER_32): CE_POINTER [PD_ATTR_ENTRY]
		local
			l_attr: INTEGER_32
			l_return: BOOLEAN
		do
			l_attr := a_attr
			l_attr := l_attr - (64)
			if l_attr >= gui_attr_table.item.item.ga_len then
				Result := (create {CE_CLASS_POINTER [PD_ATTR_ENTRY]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_ATTR_ENTRY]}.make_cast (gui_attr_table.item.item.ga_data) + l_attr)
			end
		end

	syn_attr2attr (a_attr: INTEGER_32): INTEGER_32
		local
			l_aep: CE_POINTER [PD_ATTR_ENTRY]
			l_return: BOOLEAN
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				l_aep := syn_gui_attr2entry (a_attr)
			elseif (create {P_GLOBALS_STATIC}).t_colors.item > 1 then
				l_aep := syn_cterm_attr2entry (a_attr)
			else
				l_aep := syn_term_attr2entry (a_attr)
			end
			if l_aep.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := (l_aep.item.ae_attr).to_integer_32
			end
		end

	syn_term_attr2entry (a_attr: INTEGER_32): CE_POINTER [PD_ATTR_ENTRY]
		local
			l_attr: INTEGER_32
			l_return: BOOLEAN
		do
			l_attr := a_attr
			l_attr := l_attr - (64)
			if l_attr >= term_attr_table.item.item.ga_len then
				Result := (create {CE_CLASS_POINTER [PD_ATTR_ENTRY]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_ATTR_ENTRY]}.make_cast (term_attr_table.item.item.ga_data) + l_attr)
			end
		end

	syn_cterm_attr2entry (a_attr: INTEGER_32): CE_POINTER [PD_ATTR_ENTRY]
		local
			l_attr: INTEGER_32
			l_return: BOOLEAN
		do
			l_attr := a_attr
			l_attr := l_attr - (64)
			if l_attr >= cterm_attr_table.item.item.ga_len then
				Result := (create {CE_CLASS_POINTER [PD_ATTR_ENTRY]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_ATTR_ENTRY]}.make_cast (cterm_attr_table.item.item.ga_data) + l_attr)
			end
		end

	highlight_list_one (a_id: INTEGER_32)
		local
			l_sgp: CE_POINTER [PD_HL_GROUP]
			l_didh: INTEGER_32
		do
			l_didh := 0
			l_sgp := create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (a_id - 1)
			l_didh := highlight_list_arg (a_id, l_didh, 1, l_sgp.item.sg_term, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), ce_string ("term"))
			l_didh := highlight_list_arg (a_id, l_didh, 2, 0, l_sgp.item.sg_start, ce_string ("start"))
			l_didh := highlight_list_arg (a_id, l_didh, 2, 0, l_sgp.item.sg_stop, ce_string ("stop"))
			l_didh := highlight_list_arg (a_id, l_didh, 1, l_sgp.item.sg_cterm, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), ce_string ("cterm"))
			l_didh := highlight_list_arg (a_id, l_didh, 3, l_sgp.item.sg_cterm_fg, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), ce_string ("ctermfg"))
			l_didh := highlight_list_arg (a_id, l_didh, 3, l_sgp.item.sg_cterm_bg, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), ce_string ("ctermbg"))
			l_didh := highlight_list_arg (a_id, l_didh, 1, l_sgp.item.sg_gui, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), ce_string ("gui"))
			l_didh := highlight_list_arg (a_id, l_didh, 2, 0, l_sgp.item.sg_gui_fg_name, ce_string ("guifg"))
			l_didh := highlight_list_arg (a_id, l_didh, 2, 0, l_sgp.item.sg_gui_bg_name, ce_string ("guibg"))
			l_didh := highlight_list_arg (a_id, l_didh, 2, 0, l_sgp.item.sg_gui_sp_name, ce_string ("guisp"))
			l_didh := highlight_list_arg (a_id, l_didh, 2, 0, l_sgp.item.sg_font_name, ce_string ("font"))
			if (l_sgp.item.sg_link).to_boolean then
				if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
					syn_list_header (l_didh, 9_999, a_id).do_nothing
					l_didh := 1;
					(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("links to")), (create {P_GLOBALS_STATIC}).highlight_attr.item[2]);
					(create {P_MESSAGE_STATIC}).msg_putchar ((' ').code);
					(create {P_MESSAGE_STATIC}).msg_outtrans ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_link - 1)).item.sg_name).do_nothing
				end
			end
			if not l_didh.to_boolean then
				highlight_list_arg (a_id, l_didh, 2, 0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cleared")), ce_string ("")).do_nothing
			end
			if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
				(create {P_EVAL_STATIC}).last_set_msg (l_sgp.item.sg_scriptID)
			end
		end

	highlight_list_arg (a_id, a_didh, a_type, a_iarg: INTEGER_32; a_sarg: CE_POINTER [NATURAL_8]; a_name___1: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_didh: INTEGER_32
			l_iarg: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_ts: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<100>>)

			l_didh := a_didh
			l_iarg := a_iarg
			if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				if a_type = 2 then
					l_tmp___1 := (not a_sarg.is_void).to_integer
				else
					l_tmp___1 := (l_iarg /= 0).to_integer
				end
				if l_tmp___1.to_boolean then
					l_ts := l_buf___6
					if a_type = 3 then
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("%%d"), l_iarg - 1]).do_nothing
					elseif a_type = 2 then
						l_ts := a_sarg
					else
						l_buf___6[0] := (('%/0/').code).to_natural_8
						l_i___0 := 0
						from
						until
							hl_attr_table.item[l_i___0] = 0
						loop
							if ((l_iarg).bit_and (hl_attr_table.item[l_i___0])).to_boolean then
								if (l_buf___6[0]).to_integer_32 /= 0 then
									strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string (",")).do_nothing
								end
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), hl_name_table.item[l_i___0]).do_nothing
								l_iarg := (l_iarg).bit_and (((hl_attr_table.item[l_i___0]).bit_not))
							end
							l_i___0 := l_i___0 + 1
						end
					end
					l_tmp := (create {P_CHARSET_STATIC}).vim_strsize (l_ts)
					syn_list_header (l_didh, ((l_tmp.to_natural_32 + (strlen (a_name___1))) + {NATURAL_32} 1).to_integer_32, a_id).do_nothing
					l_didh := 1
					if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						if (a_name___1[0]).to_integer_32 /= 0 then
							(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast (a_name___1), (create {P_GLOBALS_STATIC}).highlight_attr.item[2]);
							(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("=")), (create {P_GLOBALS_STATIC}).highlight_attr.item[2])
						end
						(create {P_MESSAGE_STATIC}).msg_outtrans (l_ts).do_nothing
					end
				end
				Result := l_didh
			end
		end

	highlight_has_attr (a_id, a_flag, a_modec: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_attr: INTEGER_32
			l_return: BOOLEAN
		do
			if a_id <= 0 then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			elseif a_id > highlight_ga.item.item.ga_len then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				if a_modec = 103 then
					l_attr := (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_gui
				elseif a_modec = 99 then
					l_attr := (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_cterm
				else
					l_attr := (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_term
				end
				if ((l_attr).bit_and (a_flag)).to_boolean then
					Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("1")))
					l_return := True
				end
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
		end

	highlight_color (a_id: INTEGER_32; a_what: CE_POINTER [NATURAL_8]; a_modec: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_n: INTEGER_32
			l_fg: INTEGER_32
			l_sp: INTEGER_32
			l_font: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_color: INTEGER_32
			l_rgb: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fg := 0
					l_sp := 0
					l_font := 0
					if a_id <= 0 then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					elseif a_id > highlight_ga.item.item.ga_len then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if (a_what[0]).to_integer_32 < 65 then
							l_tmp___7 := (a_what[0]).to_integer_32
						elseif (a_what[0]).to_integer_32 > 90 then
							l_tmp___7 := (a_what[0]).to_integer_32
						else
							l_tmp___7 := (a_what[0]).to_integer_32 + 32
						end
						if l_tmp___7 /= 102 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (a_what[1]).to_integer_32 < 65 then
							l_tmp___8 := (a_what[1]).to_integer_32
						elseif (a_what[1]).to_integer_32 > 90 then
							l_tmp___8 := (a_what[1]).to_integer_32
						else
							l_tmp___8 := (a_what[1]).to_integer_32 + 32
						end
						if l_tmp___8 = 103 then
							l_fg := 1
						else
							l_pos := -1 + 4 -- goto _L___3
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else: | _L___3:
						if (a_what[0]).to_integer_32 < 65 then
							l_tmp___3 := (a_what[0]).to_integer_32
						elseif (a_what[0]).to_integer_32 > 90 then
							l_tmp___3 := (a_what[0]).to_integer_32
						else
							l_tmp___3 := (a_what[0]).to_integer_32 + 32
						end
						if l_tmp___3 /= 102 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (a_what[1]).to_integer_32 < 65 then
							l_tmp___4 := (a_what[1]).to_integer_32
						elseif (a_what[1]).to_integer_32 > 90 then
							l_tmp___4 := (a_what[1]).to_integer_32
						else
							l_tmp___4 := (a_what[1]).to_integer_32 + 32
						end
						if l_tmp___4 = 111 then
							if (a_what[2]).to_integer_32 < 65 then
								l_tmp___5 := (a_what[2]).to_integer_32
							elseif (a_what[2]).to_integer_32 > 90 then
								l_tmp___5 := (a_what[2]).to_integer_32
							else
								l_tmp___5 := (a_what[2]).to_integer_32 + 32
							end
							if l_tmp___5 = 110 then
								if (a_what[3]).to_integer_32 < 65 then
									l_tmp___6 := (a_what[3]).to_integer_32
								elseif (a_what[3]).to_integer_32 > 90 then
									l_tmp___6 := (a_what[3]).to_integer_32
								else
									l_tmp___6 := (a_what[3]).to_integer_32 + 32
								end
								if l_tmp___6 = 116 then
									l_font := 1
								else
									l_pos := -1 + 7 -- goto _L___2
								end
							else
								l_pos := -1 + 7 -- goto _L___2
							end
						else
							l_pos := -1 + 7 -- goto _L___2
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else: | _L___2:
						if (a_what[0]).to_integer_32 < 65 then
							l_tmp___1 := (a_what[0]).to_integer_32
						elseif (a_what[0]).to_integer_32 > 90 then
							l_tmp___1 := (a_what[0]).to_integer_32
						else
							l_tmp___1 := (a_what[0]).to_integer_32 + 32
						end
						if l_tmp___1 /= 115 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if (a_what[1]).to_integer_32 < 65 then
							l_tmp___2 := (a_what[1]).to_integer_32
						elseif (a_what[1]).to_integer_32 > 90 then
							l_tmp___2 := (a_what[1]).to_integer_32
						else
							l_tmp___2 := (a_what[1]).to_integer_32 + 32
						end
						if l_tmp___2 = 112 then
							l_sp := 1
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if (a_what[0]).to_integer_32 < 65 then
							l_tmp := (a_what[0]).to_integer_32
						elseif (a_what[0]).to_integer_32 > 90 then
							l_tmp := (a_what[0]).to_integer_32
						else
							l_tmp := (a_what[0]).to_integer_32 + 32
						end
						if l_tmp = 98 then
							if (a_what[1]).to_integer_32 < 65 then
								l_tmp___0 := (a_what[1]).to_integer_32
							elseif (a_what[1]).to_integer_32 > 90 then
								l_tmp___0 := (a_what[1]).to_integer_32
							else
								l_tmp___0 := (a_what[1]).to_integer_32 + 32
							end
							if l_tmp___0 /= 103 then
								Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
								l_return := True
							end
						else
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
				when 11 then -- if done | if done | if done
					if not l_return and then (a_modec = 103) then
						if l_font.to_boolean then
							Result := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_font_name)
							l_return := True
						end
						if not l_return and then (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
							if (a_what[2]).to_integer_32 = 35 then
								if l_fg.to_boolean then
									l_color := (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_gui_fg
								elseif l_sp.to_boolean then
									l_color := (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_gui_sp
								else
									l_color := (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_gui_bg
								end
								if l_color = -11_111 then
									Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
									l_return := True
								end
								if not l_return then
									l_rgb := (create {P_GUI_GTK_X11_STATIC}).gui_mch_get_rgb (l_color)
									sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (buf___3.item), ce_string ("#%%02x%%02x%%02x"), ((l_rgb).bit_shift_right (16)).to_natural_32, (((l_rgb).bit_shift_right (8)).to_natural_32).bit_and ({NATURAL_32} 255), (l_rgb.to_natural_32).bit_and ({NATURAL_32} 255)]).do_nothing
									Result := buf___3.item
									l_return := True
								end
							end
						end
						if not l_return and then (l_fg.to_boolean) then
							Result := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_gui_fg_name)
							l_return := True
						end
						if not l_return and then (l_sp.to_boolean) then
							Result := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_gui_sp_name)
							l_return := True
						end
						if not l_return then
							Result := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_gui_bg_name)
							l_return := True
						end
					end
					if not l_return then
						if l_font.to_boolean then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						elseif l_sp.to_boolean then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
					if not l_return and then (a_modec = 99) then
						if l_fg.to_boolean then
							l_n := (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_cterm_fg - 1
						else
							l_n := (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_cterm_bg - 1
						end
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (name___0.item), ce_string ("%%d"), l_n]).do_nothing
						Result := name___0.item
						l_return := True
					end
					if not l_return then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	syn_list_header (a_did_header, a_outlen, a_id: INTEGER_32): INTEGER_32
		local
			l_endcol: INTEGER_32
			l_newline: INTEGER_32
			l_return: BOOLEAN
		do
			l_endcol := 19
			l_newline := 1
			if not a_did_header.to_boolean then
				(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
				if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
					Result := 1
					l_return := True
				end
				if not l_return then
					(create {P_MESSAGE_STATIC}).msg_outtrans ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_name).do_nothing
					l_endcol := 15
				end
			elseif (((create {P_GLOBALS_STATIC}).msg_col.item + a_outlen) + 1).to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item then
				(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
				if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
					Result := 1
					l_return := True
				end
			elseif (create {P_GLOBALS_STATIC}).msg_col.item >= l_endcol then
				l_newline := 0
			end
			if not l_return then
				if (create {P_GLOBALS_STATIC}).msg_col.item >= l_endcol then
					l_endcol := (create {P_GLOBALS_STATIC}).msg_col.item + 1
				end
				if (create {P_GLOBALS_STATIC}).Columns.item.item <= l_endcol.to_integer_32 then
					l_endcol := ((create {P_GLOBALS_STATIC}).Columns.item.item - 1).to_integer_32
				end
				(create {P_MESSAGE_STATIC}).msg_advance (l_endcol)
				if not a_did_header.to_boolean then
					(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("xxx")), (syn_id2attr (a_id)));
					(create {P_MESSAGE_STATIC}).msg_putchar ((' ').code)
				end
				Result := l_newline
			end
		end

	set_hl_attr (a_idx: INTEGER_32)
		local
			l_at_en: CE_ARRAY [PD_ATTR_ENTRY]
			l_sgp: CE_POINTER [PD_HL_GROUP]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_ATTR_ENTRY]} l_at_en.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sgp := create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx
					if not (l_sgp.item.sg_name_u).is_void then
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_sgp.item.sg_name_u), ce_string ("NORMAL"))) = 0 then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if l_sgp.item.sg_gui_fg /= -11_111 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_sgp.item.sg_gui_bg = -11_111 then
							if l_sgp.item.sg_gui_sp = -11_111 then
								if (l_sgp.item.sg_font).is_void then
									l_sgp.item.sg_gui_attr := l_sgp.item.sg_gui
								else
									l_pos := -1 + 4 -- goto _L___1
								end
							else
								l_pos := -1 + 4 -- goto _L___1
							end
						else
							l_pos := -1 + 4 -- goto _L___1
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L___1:
						l_at_en.item.ae_attr := (l_sgp.item.sg_gui).to_integer_16
						l_at_en.item.ae_u.gui.fg_color := l_sgp.item.sg_gui_fg
						l_at_en.item.ae_u.gui.bg_color := l_sgp.item.sg_gui_bg
						l_at_en.item.ae_u.gui.sp_color := l_sgp.item.sg_gui_sp
						l_at_en.item.ae_u.gui.font := l_sgp.item.sg_font
						l_sgp.item.sg_gui_attr := gui_attr_table.item.item.get_attr_entry (l_at_en)
				when 5 then
						if (l_sgp.item.sg_start).is_void then
							if (l_sgp.item.sg_stop).is_void then
								l_sgp.item.sg_term_attr := l_sgp.item.sg_term
							else
								l_at_en.item.ae_attr := (l_sgp.item.sg_term).to_integer_16
								l_at_en.item.ae_u.term.start := l_sgp.item.sg_start
								l_at_en.item.ae_u.term.stop := l_sgp.item.sg_stop
								l_sgp.item.sg_term_attr := term_attr_table.item.item.get_attr_entry (l_at_en)
							end
						else
							l_at_en.item.ae_attr := (l_sgp.item.sg_term).to_integer_16
							l_at_en.item.ae_u.term.start := l_sgp.item.sg_start
							l_at_en.item.ae_u.term.stop := l_sgp.item.sg_stop
							l_sgp.item.sg_term_attr := term_attr_table.item.item.get_attr_entry (l_at_en)
						end
						if l_sgp.item.sg_cterm_fg = 0 then
							if l_sgp.item.sg_cterm_bg = 0 then
								l_sgp.item.sg_cterm_attr := l_sgp.item.sg_cterm
							else
								l_at_en.item.ae_attr := (l_sgp.item.sg_cterm).to_integer_16
								l_at_en.item.ae_u.cterm.fg_color := (l_sgp.item.sg_cterm_fg).to_natural_16
								l_at_en.item.ae_u.cterm.bg_color := (l_sgp.item.sg_cterm_bg).to_natural_16
								l_sgp.item.sg_cterm_attr := cterm_attr_table.item.item.get_attr_entry (l_at_en)
							end
						else
							l_at_en.item.ae_attr := (l_sgp.item.sg_cterm).to_integer_16
							l_at_en.item.ae_u.cterm.fg_color := (l_sgp.item.sg_cterm_fg).to_natural_16
							l_at_en.item.ae_u.cterm.bg_color := (l_sgp.item.sg_cterm_bg).to_natural_16
							l_sgp.item.sg_cterm_attr := cterm_attr_table.item.item.get_attr_entry (l_at_en)
						end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	syn_name2id (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_name_u: CE_ARRAY [NATURAL_8]
			l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_name_u.make (<<200>>);

			(create {P_MISC2_STATIC}).vim_strncpy (l_name_u, a_name___1, (199).to_natural_32);
			(create {P_MISC2_STATIC}).vim_strup (l_name_u)
			l_i___0 := highlight_ga.item.item.ga_len
			from
			until
				(l_break)
			loop
				l_break := False
				l_i___0 := l_i___0 - 1
				if not (l_i___0 >= 0) then
					l_break := True
				end
				if not (l_break) and then (not ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_i___0).item.sg_name_u).is_void) then
					if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_name_u), create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_i___0).item.sg_name_u))) = 0 then
						l_break := True
					end
				end
			end
			l_break := False
			Result := (l_i___0 + 1)
		end

	highlight_exists (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := ((syn_name2id (a_name___1)) > 0).to_integer
		end

	syn_id2name (a_id: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_return: BOOLEAN
		do
			if a_id <= 0 then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
				l_return := True
			elseif a_id > highlight_ga.item.item.ga_len then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
				l_return := True
			end
			if not l_return then
				Result := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_name)
			end
		end

	syn_namen2id (a_linep: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_id: INTEGER_32
		do
			l_id := 0
			l_name___1 := (create {P_MISC2_STATIC}).vim_strnsave (a_linep, a_len)
			if not l_name___1.is_void then
				l_id := syn_name2id (l_name___1);
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_name___1))
			end
			Result := l_id
		end

	syn_check_group (a_pp: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_id: INTEGER_32
			l_name___1: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_name___1 := (create {P_MISC2_STATIC}).vim_strnsave (a_pp, a_len)
			if l_name___1.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_id := syn_name2id (l_name___1)
				if l_id = 0 then
					l_id := syn_add_group (l_name___1)
				else
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_name___1))
				end
				Result := l_id
			end
		end

	syn_add_group (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_name___1.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_name___1
				when 1 then -- loop condition:
					if not (not (l_return or l_break) and then ((l_p___0.item).to_integer_32 /= 0)) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if not (((create {P_CHARSET_STATIC}).vim_isprintc ((l_p___0.item).to_integer_32)).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if not ((l_p___0.item).to_integer_32 < 127) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if (l_p___0.item).to_integer_32 /= 95 then
							(create {P_MESSAGE_STATIC}).msg_source ((create {P_GLOBALS_STATIC}).highlight_attr.item[17]);
							(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("W18: Invalid character in group name"))))).do_nothing
							l_break := True
						end
				when 7 then -- if done | if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:;
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E669: Unprintable character in group name"))))).do_nothing;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_name___1))
						Result := 0
						l_return := True
				when 9 then
						if not (l_return or l_break) then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					if not l_return then
						l_break := False
						if (highlight_ga.item.item.ga_data).is_void then
							highlight_ga.item.item.ga_itemsize := ((create {PD_HL_GROUP}.make).structure_size.to_natural_32).to_integer_32
							highlight_ga.item.item.ga_growsize := 10
						end
						if (highlight_ga.item.item.ga_grow (1)) = 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_name___1))
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						memset (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + highlight_ga.item.item.ga_len)), 0, (create {PD_HL_GROUP}.make).structure_size.to_natural_32).do_nothing;
						(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + highlight_ga.item.item.ga_len).item.sg_name := a_name___1;
						(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + highlight_ga.item.item.ga_len).item.sg_name_u := (create {P_MISC2_STATIC}).vim_strsave_up (a_name___1);
						(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + highlight_ga.item.item.ga_len).item.sg_gui_bg := (-11_111).to_integer_32;
						(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + highlight_ga.item.item.ga_len).item.sg_gui_fg := (-11_111).to_integer_32;
						(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + highlight_ga.item.item.ga_len).item.sg_gui_sp := (-11_111).to_integer_32
						highlight_ga.item.item.ga_len := (highlight_ga.item.item.ga_len) + 1
						Result := (highlight_ga.item.item.ga_len)
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	syn_unadd_group
		do
			highlight_ga.item.item.ga_len := (highlight_ga.item.item.ga_len) - 1;
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + highlight_ga.item.item.ga_len).item.sg_name));
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + highlight_ga.item.item.ga_len).item.sg_name_u))
		end

	syn_id2attr (a_hl_id: INTEGER_32): INTEGER_32
		local
			l_hl_id: INTEGER_32
			l_attr: INTEGER_32
			l_sgp: CE_POINTER [PD_HL_GROUP]
		do
			l_hl_id := a_hl_id
			l_hl_id := syn_get_final_id (l_hl_id)
			l_sgp := create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_hl_id - 1)
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				l_attr := l_sgp.item.sg_gui_attr
			elseif (create {P_GLOBALS_STATIC}).t_colors.item > 1 then
				l_attr := l_sgp.item.sg_cterm_attr
			else
				l_attr := l_sgp.item.sg_term_attr
			end
			Result := l_attr
		end

	syn_id2colors (a_hl_id: INTEGER_32; a_fgp, a_bgp: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_fgp.is_void
			not a_bgp.is_void
		local
			l_hl_id: INTEGER_32
			l_sgp: CE_POINTER [PD_HL_GROUP]
		do
			l_hl_id := a_hl_id
			l_hl_id := syn_get_final_id (l_hl_id)
			l_sgp := create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_hl_id - 1)
			a_fgp.item := l_sgp.item.sg_gui_fg
			a_bgp.item := l_sgp.item.sg_gui_bg
			Result := (l_sgp.item.sg_gui)
		end

	syn_get_final_id (a_hl_id: INTEGER_32): INTEGER_32
		local
			l_hl_id: INTEGER_32
			l_count___2: INTEGER_32
			l_sgp: CE_POINTER [PD_HL_GROUP]
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_POINTER [PD_HL_GROUP]} l_sgp.make

			l_hl_id := a_hl_id
			if l_hl_id > highlight_ga.item.item.ga_len then
				Result := 0
				l_return := True
			elseif l_hl_id < 1 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_count___2 := 100
				from
				until
					(l_break)
				loop
					l_break := False
					l_count___2 := l_count___2 - 1
					if not (l_count___2 >= 0) then
						l_break := True
					end
					if not (l_break) then
						l_sgp := create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_hl_id - 1)
						if l_sgp.item.sg_link = 0 then
							l_break := True
						elseif l_sgp.item.sg_link > highlight_ga.item.item.ga_len then
							l_break := True
						end
					end
					if not (l_break) then
						l_hl_id := l_sgp.item.sg_link
					end
				end
				l_break := False
				Result := l_hl_id
			end
		end

	highlight_gui_started
		local
			l_idx: INTEGER_32
		do
			set_normal_colors
			l_idx := 0
			from
			until
				not (l_idx < highlight_ga.item.item.ga_len)
			loop
				gui_do_one_color (l_idx, 0, 0)
				l_idx := l_idx + 1
			end
			highlight_changed.do_nothing
		end

	gui_do_one_color (a_idx, a_do_menu, a_do_tooltip: INTEGER_32)
		local
			l_didit: INTEGER_32
		do
			l_didit := 0
			if not ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_font_name).is_void then
				hl_do_font (a_idx, (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_font_name, 0, a_do_menu, a_do_tooltip)
				l_didit := 1
			end
			if not ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_fg_name).is_void then
				(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_fg := color_name2handle ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_fg_name)
				l_didit := 1
			end
			if not ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_bg_name).is_void then
				(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_bg := color_name2handle ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_bg_name)
				l_didit := 1
			end
			if not ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_sp_name).is_void then
				(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_sp := color_name2handle ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_gui_sp_name)
				l_didit := 1
			end
			if l_didit.to_boolean then
				set_hl_attr (a_idx)
			end
		end

	highlight_changed: INTEGER_32
		local
			l_hlf: INTEGER_32
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_attr: INTEGER_32
			l_end: CE_POINTER [NATURAL_8]
			l_id: INTEGER_32
			l_userhl: CE_ARRAY [NATURAL_8]
			l_id_SNC: INTEGER_32
			l_id_S: INTEGER_32
			l_hlcnt: INTEGER_32
			l_hlt: CE_POINTER [PD_HL_GROUP]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_userhl.make (<<10>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_id_SNC := -1
					l_id_S := -1;
					(create {P_GLOBALS_STATIC}).need_highlight_changed.item := 0
					l_hlf := 0
					from
					until
						not (l_hlf < 41)
					loop
						(create {P_GLOBALS_STATIC}).highlight_attr.item[l_hlf] := 0
						l_hlf := l_hlf + 1
					end
					l_i___0 := 0
				when 1 then -- loop condition:
					if not (not (l_return) and then (l_i___0 < 2)) then
						l_pos := -1 + 22 -- skip loop
					end
				when 2 then -- loop body:
						l_continue := False
						if l_i___0.to_boolean then
							l_p___0 := (create {P_OPTION_STATIC}).p_hl.item.item
						else
							l_p___0 := (create {P_OPTION_STATIC}).get_highlight_default
						end
						if l_p___0.is_void then
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 21 -- skip if block
						end
				when 3 then -- if: | loop condition:
						if not (not (l_return) and then ((l_p___0.item).to_boolean)) then
							l_pos := -1 + 21 -- skip loop
						end
				when 4 then -- loop body:
						l_hlf := 0
						from
						until
							not (not (l_break) and then (l_hlf < 41))
						loop
							l_break := False
							if hl_flags.item[l_hlf] = (l_p___0.item).to_integer_32 then
								l_break := True
							end
							if not (l_break) then
								l_hlf := l_hlf + 1
							end
						end
						l_break := False
						l_p___0 := l_p___0 + 1
						if l_hlf = 41 then
							Result := 0
							l_return := True
						elseif (l_p___0.item).to_integer_32 = 0 then
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 20 -- skip if block
						end
				when 5 then -- if:
						l_attr := 0
				when 6 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 20 -- skip loop
						end
				when 7 then -- loop body:
						l_break := False
						l_continue := False
						if (l_p___0.item).to_boolean then
							if (l_p___0.item).to_integer_32 = 44 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							if (l_p___0.item).to_integer_32 = 32 then
								l_continue := True
							elseif (l_p___0.item).to_integer_32 = 9 then
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 19 -- skip if block
						end
				when 8 then -- if:
						if l_attr > 63 then
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 19 -- skip if block
						end
				when 9 then -- if:
						inspect (l_p___0.item).to_integer_32 -- switch 1 head
						when 98 then l_pos := -1 + 10
						when 105 then l_pos := -1 + 11
						when 45 then l_pos := -1 + 12
						when 110 then l_pos := -1 + 12
						when 114 then l_pos := -1 + 13
						when 115 then l_pos := -1 + 14
						when 117 then l_pos := -1 + 15
						when 99 then l_pos := -1 + 16
						when 58 then l_pos := -1 + 17
						else l_pos := -1 + 18
						end
				when 10 then -- switch 1, case 98
						l_attr := (l_attr).bit_or ((2))
						l_pos := -1 + 19 -- switch 1; break
				when 11 then -- switch 1, case 105
						l_attr := (l_attr).bit_or ((4))
						l_pos := -1 + 19 -- switch 1; break
				when 12 then -- switch 1, case 45 | switch 1, case 110
						l_pos := -1 + 19 -- switch 1; break
				when 13 then -- switch 1, case 114
						l_attr := (l_attr).bit_or ((1))
						l_pos := -1 + 19 -- switch 1; break
				when 14 then -- switch 1, case 115
						l_attr := (l_attr).bit_or ((32))
						l_pos := -1 + 19 -- switch 1; break
				when 15 then -- switch 1, case 117
						l_attr := (l_attr).bit_or ((8))
						l_pos := -1 + 19 -- switch 1; break
				when 16 then -- switch 1, case 99
						l_attr := (l_attr).bit_or ((16))
						l_pos := -1 + 19 -- switch 1; break
				when 17 then -- switch 1, case 58
						l_p___0 := l_p___0 + 1
						if l_attr.to_boolean then
							Result := 0
							l_return := True
						elseif (l_p___0.item).to_integer_32 = 0 then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_end := (create {P_MISC2_STATIC}).vim_strchr (l_p___0, (',').code)
							if l_end.is_void then
								l_end := l_p___0 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32
							end
							l_id := syn_check_group (l_p___0, l_end.distance (l_p___0))
							if l_id = 0 then
								Result := 0
								l_return := True
							end
						end
						if not l_return then
							l_attr := syn_id2attr (l_id)
							l_p___0 := l_end - 1
							if l_hlf = 12 then
								l_id_SNC := syn_get_final_id (l_id)
							elseif l_hlf = 11 then
								l_id_S := syn_get_final_id (l_id)
							end
						end
						l_pos := -1 + 19 -- switch 1; break
				when 18 then -- switch 1, default:
						Result := 0
						l_return := True
				when 19 then -- switch 1, done: | if done | if done
						if (not l_return and not l_break) then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 6 -- back to loop condition
				when 20 then -- loop done | if done
						if not l_return then
							l_break := False
							l_continue := False;
							(create {P_GLOBALS_STATIC}).highlight_attr.item[l_hlf] := l_attr
							l_p___0 := (create {P_MISC1_STATIC}).skip_to_option_part (l_p___0)
						end
						l_pos := -1 + 3 -- back to loop condition
				when 21 then -- loop done | if done
						if (not l_return) then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 22 then -- loop done
					if not l_return then
						l_continue := False
						if (highlight_ga.item.item.ga_grow (10)) = 0 then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_hlcnt := highlight_ga.item.item.ga_len
						if l_id_S = 0 then
							memset (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_hlcnt + 9))), 0, (create {PD_HL_GROUP}.make).structure_size.to_natural_32).do_nothing;
							(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + (l_hlcnt + 9)).item.sg_term := (create {P_GLOBALS_STATIC}).highlight_attr.item[11]
							l_id_S := l_hlcnt + 10
						end
						l_i___0 := 0
						from
						until
							not (l_i___0 < 9)
						loop
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_userhl), ce_string ("User%%d"), l_i___0 + 1]).do_nothing
							l_id := syn_name2id (l_userhl)
							if l_id = 0 then
								(create {P_GLOBALS_STATIC}).highlight_user.item[l_i___0] := 0;
								(create {P_GLOBALS_STATIC}).highlight_stlnc.item[l_i___0] := 0
							else
								l_hlt := create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data);
								(create {P_GLOBALS_STATIC}).highlight_user.item[l_i___0] := syn_id2attr (l_id)
								if l_id_SNC = 0 then
									memset (create {CE_VOID_POINTER}.make_cast ((l_hlt + (l_hlcnt + l_i___0))), 0, (create {PD_HL_GROUP}.make).structure_size.to_natural_32).do_nothing;
									(l_hlt + (l_hlcnt + l_i___0)).item.sg_term := (create {P_GLOBALS_STATIC}).highlight_attr.item[12];
									(l_hlt + (l_hlcnt + l_i___0)).item.sg_cterm := (create {P_GLOBALS_STATIC}).highlight_attr.item[12];
									(l_hlt + (l_hlcnt + l_i___0)).item.sg_gui := (create {P_GLOBALS_STATIC}).highlight_attr.item[12]
								else
									memmove (create {CE_VOID_POINTER}.make_cast ((l_hlt + (l_hlcnt + l_i___0))), create {CE_VOID_POINTER}.make_cast ((l_hlt + (l_id_SNC - 1))), (create {PD_HL_GROUP}.make).structure_size.to_natural_32).do_nothing
								end
								(l_hlt + (l_hlcnt + l_i___0)).item.sg_link := 0;
								(l_hlt + (l_hlcnt + l_i___0)).item.sg_term := ((l_hlt + (l_hlcnt + l_i___0)).item.sg_term).bit_xor ((((l_hlt + (l_id - 1)).item.sg_term).bit_xor ((l_hlt + (l_id_S - 1)).item.sg_term)))
								if not ((l_hlt + (l_id - 1)).item.sg_start).is_equal ((l_hlt + (l_id_S - 1)).item.sg_start) then
									(l_hlt + (l_hlcnt + l_i___0)).item.sg_start := (l_hlt + (l_id - 1)).item.sg_start
								end
								if not ((l_hlt + (l_id - 1)).item.sg_stop).is_equal ((l_hlt + (l_id_S - 1)).item.sg_stop) then
									(l_hlt + (l_hlcnt + l_i___0)).item.sg_stop := (l_hlt + (l_id - 1)).item.sg_stop
								end
								(l_hlt + (l_hlcnt + l_i___0)).item.sg_cterm := ((l_hlt + (l_hlcnt + l_i___0)).item.sg_cterm).bit_xor ((((l_hlt + (l_id - 1)).item.sg_cterm).bit_xor ((l_hlt + (l_id_S - 1)).item.sg_cterm)))
								if (l_hlt + (l_id - 1)).item.sg_cterm_fg /= (l_hlt + (l_id_S - 1)).item.sg_cterm_fg then
									(l_hlt + (l_hlcnt + l_i___0)).item.sg_cterm_fg := (l_hlt + (l_id - 1)).item.sg_cterm_fg
								end
								if (l_hlt + (l_id - 1)).item.sg_cterm_bg /= (l_hlt + (l_id_S - 1)).item.sg_cterm_bg then
									(l_hlt + (l_hlcnt + l_i___0)).item.sg_cterm_bg := (l_hlt + (l_id - 1)).item.sg_cterm_bg
								end
								(l_hlt + (l_hlcnt + l_i___0)).item.sg_gui := ((l_hlt + (l_hlcnt + l_i___0)).item.sg_gui).bit_xor ((((l_hlt + (l_id - 1)).item.sg_gui).bit_xor ((l_hlt + (l_id_S - 1)).item.sg_gui)))
								if (l_hlt + (l_id - 1)).item.sg_gui_fg /= (l_hlt + (l_id_S - 1)).item.sg_gui_fg then
									(l_hlt + (l_hlcnt + l_i___0)).item.sg_gui_fg := (l_hlt + (l_id - 1)).item.sg_gui_fg
								end
								if (l_hlt + (l_id - 1)).item.sg_gui_bg /= (l_hlt + (l_id_S - 1)).item.sg_gui_bg then
									(l_hlt + (l_hlcnt + l_i___0)).item.sg_gui_bg := (l_hlt + (l_id - 1)).item.sg_gui_bg
								end
								if (l_hlt + (l_id - 1)).item.sg_gui_sp /= (l_hlt + (l_id_S - 1)).item.sg_gui_sp then
									(l_hlt + (l_hlcnt + l_i___0)).item.sg_gui_sp := (l_hlt + (l_id - 1)).item.sg_gui_sp
								end
								if not ((l_hlt + (l_id - 1)).item.sg_font).is_equal ((l_hlt + (l_id_S - 1)).item.sg_font) then
									(l_hlt + (l_hlcnt + l_i___0)).item.sg_font := (l_hlt + (l_id - 1)).item.sg_font
								end
								highlight_ga.item.item.ga_len := (l_hlcnt + l_i___0) + 1
								set_hl_attr (l_hlcnt + l_i___0);
								(create {P_GLOBALS_STATIC}).highlight_stlnc.item[l_i___0] := syn_id2attr ((l_hlcnt + l_i___0) + 1)
							end
							l_i___0 := l_i___0 + 1
						end
						highlight_ga.item.item.ga_len := l_hlcnt
						Result := 1
					end
				when 23 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_highlight_name (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_return: BOOLEAN
		do
			if a_idx = highlight_ga.item.item.ga_len then
				if include_none.item /= 0 then
					Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("none")))
					l_return := True
				end
			end
			if not l_return and then (a_idx = highlight_ga.item.item.ga_len + include_none.item) then
				if include_default.item /= 0 then
					Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("default")))
					l_return := True
				end
			end
			if not l_return and then (a_idx = (highlight_ga.item.item.ga_len + include_none.item) + include_default.item) then
				if include_link.item /= 0 then
					Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("link")))
					l_return := True
				end
			end
			if not l_return and then (a_idx = ((highlight_ga.item.item.ga_len + include_none.item) + include_default.item) + 1) then
				if include_link.item /= 0 then
					Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("clear")))
					l_return := True
				end
			end
			if not l_return then
				if a_idx < 0 then
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				elseif a_idx >= highlight_ga.item.item.ga_len then
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				Result := ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + a_idx).item.sg_name)
			end
		end

	free_highlight_fonts
		local
			l_idx: INTEGER_32
		do
			l_idx := 0
			from
			until
				not (l_idx < highlight_ga.item.item.ga_len)
			loop
				(create {P_GUI_GTK_X11_STATIC}).gui_mch_free_font ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_font);
				(create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast (highlight_ga.item.item.ga_data) + l_idx).item.sg_font := create {CE_VOID_POINTER}.make_shared (default_pointer)
				l_idx := l_idx + 1
			end
			(create {P_GUI_GTK_X11_STATIC}).gui_mch_free_font ((create {P_GUI_STATIC}).gui.item.item.norm_font)
		end

feature {ANY} -- routine addresses

	syn_cmd_conceal_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent syn_cmd_conceal)
		end

	syn_compare_stub_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent syn_compare_stub)
		end

	get_syntax_name_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent get_syntax_name)
		end

	get_highlight_name_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent get_highlight_name)
		end

end
