class
	PD_CONNECTDATA

inherit
	PD_CONNECTDATA_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_CTYPE_STATIC
		redefine
			copy,
			is_equal
		end
	S_UNISTD_STATIC
		redefine
			copy,
			is_equal
		end
	S_FCNTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_SYS_STAT_STATIC
		redefine
			copy,
			is_equal
		end
	S_TIME_STATIC
		redefine
			copy,
			is_equal
		end
	S_SYS_SOCKET_STATIC
		redefine
			copy,
			is_equal
		end
	S_BITS_ERRNO_STATIC
		redefine
			copy,
			is_equal
		end
	S_ARPA_INET_STATIC
		redefine
			copy,
			is_equal
		end
	S_NETINET_IN_STATIC
		redefine
			copy,
			is_equal
		end
	S_IFADDRS_STATIC
		redefine
			copy,
			is_equal
		end
	S_SYS_POLL_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_SESSIONHANDLE]} data.make
			create chunk.make
			create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]} dns_entry.make
			create {CE_CLASS_POINTER [PD_CURL_ADDRINFO]} ip_addr.make
			create {CE_INTEGER_8_ARRAY} ip_addr_str.make (<<((("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255").count + 1).to_natural_32).to_integer_32>>)
			create host.make
			create proxy.make
			create {CE_INTEGER_8_POINTER} user.make
			create {CE_INTEGER_8_POINTER} passwd.make
			create {CE_INTEGER_8_POINTER} proxyuser.make
			create {CE_INTEGER_8_POINTER} proxypasswd.make
			create now.make
			create created.make
			create {CE_INTEGER_32_ARRAY} sock.make (<<2>>)
			create {CE_ROUTINE_ARRAY} recv2.make (<<2>>)
			create {CE_ROUTINE_ARRAY} send2.make (<<2>>)
			create {CE_CLASS_ARRAY [PD_SSL_CONNECT_DATA]} ssl.make (<<2>>)
			create ssl_config.make
			create bits.make
			create {CE_CLASS_POINTER [PD_CURL_HANDLER]} handler.make
			create allocptr.make
			create {CE_CLASS_POINTER [PD_CURL_LLIST]} send_pipe.make
			create {CE_CLASS_POINTER [PD_CURL_LLIST]} recv_pipe.make
			create {CE_CLASS_POINTER [PD_CURL_LLIST]} pend_pipe.make
			create {CE_CLASS_POINTER [PD_CURL_LLIST]} done_pipe.make
			create {CE_INTEGER_8_POINTER} master_buffer.make
			create seek_func.make
			create {CE_VOID_POINTER} seek_client.make
			create fread_func.make
			create {CE_VOID_POINTER} fread_in.make
			create ntlm.make
			create proxyntlm.make
			create {CE_INTEGER_8_ARRAY} syserr_buf.make (<<256>>)
			create {CE_INTEGER_8_POINTER} trailer.make
			create proto.make
			Precursor
		end

feature {ANY} -- fields

	data: CE_POINTER [PD_SESSIONHANDLE] assign set_data

	chunk: PD_CURL_CHUNKER assign set_chunk

	inuse: BOOLEAN assign set_inuse

	connectindex: INTEGER_32 assign set_connectindex

	protocol: INTEGER_32 assign set_protocol

	dns_entry: CE_POINTER [PD_CURL_DNS_ENTRY] assign set_dns_entry

	ip_addr: CE_POINTER [PD_CURL_ADDRINFO] assign set_ip_addr

	ip_addr_str: CE_ARRAY [INTEGER_8]

	scope: NATURAL_32 assign set_scope

	socktype: INTEGER_32 assign set_socktype

	host: PD_HOSTNAME assign set_host

	proxy: PD_HOSTNAME assign set_proxy

	port: INTEGER_32 assign set_port

	remote_port: NATURAL_16 assign set_remote_port

	user: CE_POINTER [INTEGER_8] assign set_user

	passwd: CE_POINTER [INTEGER_8] assign set_passwd

	proxyuser: CE_POINTER [INTEGER_8] assign set_proxyuser

	proxypasswd: CE_POINTER [INTEGER_8] assign set_proxypasswd

	proxytype: NATURAL_32 assign set_proxytype

	httpversion: INTEGER_32 assign set_httpversion

	rtspversion: INTEGER_32 assign set_rtspversion

	now: SD_TIMEVAL assign set_now

	created: SD_TIMEVAL assign set_created

	sock: CE_ARRAY [INTEGER_32]

	recv2: CE_ARRAY [CE_ROUTINE]

	send2: CE_ARRAY [CE_ROUTINE]

	ssl: CE_ARRAY [PD_SSL_CONNECT_DATA]

	ssl_config: PD_SSL_CONFIG_DATA assign set_ssl_config

	bits: PD_CONNECTBITS assign set_bits

	handler: CE_POINTER [PD_CURL_HANDLER] assign set_handler

	sockfd: INTEGER_32 assign set_sockfd

	writesockfd: INTEGER_32 assign set_writesockfd

	allocptr: PD_DYNAMICALLY_ALLOCATED_DATA assign set_allocptr

	sec_complete: INTEGER_32 assign set_sec_complete

	readchannel_inuse: BOOLEAN assign set_readchannel_inuse

	writechannel_inuse: BOOLEAN assign set_writechannel_inuse

	server_supports_pipelining: BOOLEAN assign set_server_supports_pipelining

	send_pipe: CE_POINTER [PD_CURL_LLIST] assign set_send_pipe

	recv_pipe: CE_POINTER [PD_CURL_LLIST] assign set_recv_pipe

	pend_pipe: CE_POINTER [PD_CURL_LLIST] assign set_pend_pipe

	done_pipe: CE_POINTER [PD_CURL_LLIST] assign set_done_pipe

	master_buffer: CE_POINTER [INTEGER_8] assign set_master_buffer

	read_pos: NATURAL_32 assign set_read_pos

	buf_len: NATURAL_32 assign set_buf_len

	seek_func: CE_ROUTINE assign set_seek_func

	seek_client: CE_POINTER [ANY] assign set_seek_client

	fread_func: CE_ROUTINE assign set_fread_func

	fread_in: CE_POINTER [ANY] assign set_fread_in

	ntlm: PD_NTLMDATA assign set_ntlm

	proxyntlm: PD_NTLMDATA assign set_proxyntlm

	syserr_buf: CE_ARRAY [INTEGER_8]

	trailer: CE_POINTER [INTEGER_8] assign set_trailer

	trlMax: INTEGER_32 assign set_trlMax

	trlPos: INTEGER_32 assign set_trlPos

	proto: PD_PROTO assign set_proto

	cselect_bits: INTEGER_32 assign set_cselect_bits

	waitfor: INTEGER_32 assign set_waitfor

	verifypeer: INTEGER_32 assign set_verifypeer

	verifyhost: INTEGER_32 assign set_verifyhost

feature {ANY} -- field setters

	set_data (a_data: CE_POINTER [PD_SESSIONHANDLE])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_chunk (a_chunk: PD_CURL_CHUNKER)
		do
			chunk := a_chunk
			update_memory_field ("chunk")
		end

	set_inuse (a_inuse: BOOLEAN)
		do
			inuse := a_inuse
			update_memory_field ("inuse")
		end

	set_connectindex (a_connectindex: INTEGER_32)
		do
			connectindex := a_connectindex
			update_memory_field ("connectindex")
		end

	set_protocol (a_protocol: INTEGER_32)
		do
			protocol := a_protocol
			update_memory_field ("protocol")
		end

	set_dns_entry (a_dns_entry: CE_POINTER [PD_CURL_DNS_ENTRY])
		do
			dns_entry := a_dns_entry
			update_memory_field ("dns_entry")
		end

	set_ip_addr (a_ip_addr: CE_POINTER [PD_CURL_ADDRINFO])
		do
			ip_addr := a_ip_addr
			update_memory_field ("ip_addr")
		end

	set_scope (a_scope: NATURAL_32)
		do
			scope := a_scope
			update_memory_field ("scope")
		end

	set_socktype (a_socktype: INTEGER_32)
		do
			socktype := a_socktype
			update_memory_field ("socktype")
		end

	set_host (a_host: PD_HOSTNAME)
		do
			host := a_host
			update_memory_field ("host")
		end

	set_proxy (a_proxy: PD_HOSTNAME)
		do
			proxy := a_proxy
			update_memory_field ("proxy")
		end

	set_port (a_port: INTEGER_32)
		do
			port := a_port
			update_memory_field ("port")
		end

	set_remote_port (a_remote_port: NATURAL_16)
		do
			remote_port := a_remote_port
			update_memory_field ("remote_port")
		end

	set_user (a_user: CE_POINTER [INTEGER_8])
		do
			user := a_user
			update_memory_field ("user")
		end

	set_passwd (a_passwd: CE_POINTER [INTEGER_8])
		do
			passwd := a_passwd
			update_memory_field ("passwd")
		end

	set_proxyuser (a_proxyuser: CE_POINTER [INTEGER_8])
		do
			proxyuser := a_proxyuser
			update_memory_field ("proxyuser")
		end

	set_proxypasswd (a_proxypasswd: CE_POINTER [INTEGER_8])
		do
			proxypasswd := a_proxypasswd
			update_memory_field ("proxypasswd")
		end

	set_proxytype (a_proxytype: NATURAL_32)
		do
			proxytype := a_proxytype
			update_memory_field ("proxytype")
		end

	set_httpversion (a_httpversion: INTEGER_32)
		do
			httpversion := a_httpversion
			update_memory_field ("httpversion")
		end

	set_rtspversion (a_rtspversion: INTEGER_32)
		do
			rtspversion := a_rtspversion
			update_memory_field ("rtspversion")
		end

	set_now (a_now: SD_TIMEVAL)
		do
			now := a_now
			update_memory_field ("now")
		end

	set_created (a_created: SD_TIMEVAL)
		do
			created := a_created
			update_memory_field ("created")
		end

	set_ssl_config (a_ssl_config: PD_SSL_CONFIG_DATA)
		do
			ssl_config := a_ssl_config
			update_memory_field ("ssl_config")
		end

	set_bits (a_bits: PD_CONNECTBITS)
		do
			bits := a_bits
			update_memory_field ("bits")
		end

	set_handler (a_handler: CE_POINTER [PD_CURL_HANDLER])
		do
			handler := a_handler
			update_memory_field ("handler")
		end

	set_sockfd (a_sockfd: INTEGER_32)
		do
			sockfd := a_sockfd
			update_memory_field ("sockfd")
		end

	set_writesockfd (a_writesockfd: INTEGER_32)
		do
			writesockfd := a_writesockfd
			update_memory_field ("writesockfd")
		end

	set_allocptr (a_allocptr: PD_DYNAMICALLY_ALLOCATED_DATA)
		do
			allocptr := a_allocptr
			update_memory_field ("allocptr")
		end

	set_sec_complete (a_sec_complete: INTEGER_32)
		do
			sec_complete := a_sec_complete
			update_memory_field ("sec_complete")
		end

	set_readchannel_inuse (a_readchannel_inuse: BOOLEAN)
		do
			readchannel_inuse := a_readchannel_inuse
			update_memory_field ("readchannel_inuse")
		end

	set_writechannel_inuse (a_writechannel_inuse: BOOLEAN)
		do
			writechannel_inuse := a_writechannel_inuse
			update_memory_field ("writechannel_inuse")
		end

	set_server_supports_pipelining (a_server_supports_pipelining: BOOLEAN)
		do
			server_supports_pipelining := a_server_supports_pipelining
			update_memory_field ("server_supports_pipelining")
		end

	set_send_pipe (a_send_pipe: CE_POINTER [PD_CURL_LLIST])
		do
			send_pipe := a_send_pipe
			update_memory_field ("send_pipe")
		end

	set_recv_pipe (a_recv_pipe: CE_POINTER [PD_CURL_LLIST])
		do
			recv_pipe := a_recv_pipe
			update_memory_field ("recv_pipe")
		end

	set_pend_pipe (a_pend_pipe: CE_POINTER [PD_CURL_LLIST])
		do
			pend_pipe := a_pend_pipe
			update_memory_field ("pend_pipe")
		end

	set_done_pipe (a_done_pipe: CE_POINTER [PD_CURL_LLIST])
		do
			done_pipe := a_done_pipe
			update_memory_field ("done_pipe")
		end

	set_master_buffer (a_master_buffer: CE_POINTER [INTEGER_8])
		do
			master_buffer := a_master_buffer
			update_memory_field ("master_buffer")
		end

	set_read_pos (a_read_pos: NATURAL_32)
		do
			read_pos := a_read_pos
			update_memory_field ("read_pos")
		end

	set_buf_len (a_buf_len: NATURAL_32)
		do
			buf_len := a_buf_len
			update_memory_field ("buf_len")
		end

	set_seek_func (a_seek_func: CE_ROUTINE)
		do
			seek_func := a_seek_func
			update_memory_field ("seek_func")
		end

	set_seek_client (a_seek_client: CE_POINTER [ANY])
		do
			seek_client := a_seek_client
			update_memory_field ("seek_client")
		end

	set_fread_func (a_fread_func: CE_ROUTINE)
		do
			fread_func := a_fread_func
			update_memory_field ("fread_func")
		end

	set_fread_in (a_fread_in: CE_POINTER [ANY])
		do
			fread_in := a_fread_in
			update_memory_field ("fread_in")
		end

	set_ntlm (a_ntlm: PD_NTLMDATA)
		do
			ntlm := a_ntlm
			update_memory_field ("ntlm")
		end

	set_proxyntlm (a_proxyntlm: PD_NTLMDATA)
		do
			proxyntlm := a_proxyntlm
			update_memory_field ("proxyntlm")
		end

	set_trailer (a_trailer: CE_POINTER [INTEGER_8])
		do
			trailer := a_trailer
			update_memory_field ("trailer")
		end

	set_trlMax (a_trlMax: INTEGER_32)
		do
			trlMax := a_trlMax
			update_memory_field ("trlMax")
		end

	set_trlPos (a_trlPos: INTEGER_32)
		do
			trlPos := a_trlPos
			update_memory_field ("trlPos")
		end

	set_proto (a_proto: PD_PROTO)
		do
			proto := a_proto
			update_memory_field ("proto")
		end

	set_cselect_bits (a_cselect_bits: INTEGER_32)
		do
			cselect_bits := a_cselect_bits
			update_memory_field ("cselect_bits")
		end

	set_waitfor (a_waitfor: INTEGER_32)
		do
			waitfor := a_waitfor
			update_memory_field ("waitfor")
		end

	set_verifypeer (a_verifypeer: INTEGER_32)
		do
			verifypeer := a_verifypeer
			update_memory_field ("verifypeer")
		end

	set_verifyhost (a_verifyhost: INTEGER_32)
		do
			verifyhost := a_verifyhost
			update_memory_field ("verifyhost")
		end

feature {PD_CONNECTDATA} -- private attributes

	table64: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/%/0/")
		end

	Curl_handler_ftp_proxy: CE_STATIC [CE_ARRAY [PD_CURL_HANDLER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					create {PD_CURL_HANDLER}.make_initialized ([ce_string ("FTP"), create {CE_ROUTINE}.make_shared (default_pointer), Curl_http_address, Curl_http_done_address, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 21, 1])
				>>)
		end

	mode: CE_STATIC [CE_ARRAY [CE_ARRAY [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_ARRAY_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("EPRT%/0/"),
					ce_string ("PORT%/0/")
				>>)
		end

	mode___0: CE_STATIC [CE_ARRAY [CE_ARRAY [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_ARRAY_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("EPSV%/0/"),
					ce_string ("PASV%/0/")
				>>)
		end

	ftpauth: CE_STATIC [CE_ARRAY [CE_ARRAY [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_ARRAY_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("SSL%/0/"),
					ce_string ("TLS%/0/")
				>>)
		end

	Curl_HMAC_MD5: CE_STATIC [CE_ARRAY [PD_HMAC_PARAMS]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_HMAC_PARAMS]}.make_initialized (<<
					create {PD_HMAC_PARAMS}.make_initialized ([(MD5_Init_address), ((create {PD_MD5_CTX_STATIC}).MD5_Update_address), ((create {PD_MD5_CTX_STATIC}).MD5_Final_address), (create {PD_MD5_CTX}.make).structure_size.to_natural_32, {NATURAL_32} 64, {NATURAL_32} 16])
				>>)
		end

	Curl_handler_imap_proxy: CE_STATIC [CE_ARRAY [PD_CURL_HANDLER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					create {PD_CURL_HANDLER}.make_initialized ([ce_string ("IMAP"), create {CE_ROUTINE}.make_shared (default_pointer), Curl_http_address, Curl_http_done_address, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 143, 1])
				>>)
		end

	Curl_handler_pop3_proxy: CE_STATIC [CE_ARRAY [PD_CURL_HANDLER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					create {PD_CURL_HANDLER}.make_initialized ([ce_string ("POP3"), create {CE_ROUTINE}.make_shared (default_pointer), Curl_http_address, Curl_http_done_address, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 110, 1])
				>>)
		end

	Curl_handler_smtp_proxy: CE_STATIC [CE_ARRAY [PD_CURL_HANDLER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					create {PD_CURL_HANDLER}.make_initialized ([ce_string ("SMTP"), create {CE_ROUTINE}.make_shared (default_pointer), Curl_http_address, Curl_http_done_address, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 25, 1])
				>>)
		end

feature {ANY} -- public routines

	file_range: NATURAL_32
		local
			l_from: INTEGER_64
			l_to: INTEGER_64
			l_totalsize: INTEGER_64
			l_ptr: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_ptr2: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_tmp: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_ptr.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_ptr2.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_totalsize := (-1).to_integer_64
					l_data := data
					if not (l_data.item.state.use_range) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if (l_data.item.state.range).is_void then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						l_from := strtoll (l_data.item.state.range, l_ptr, 0)
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_ptr.item[0]).to_boolean then
								l_tmp := ctype_b_loc
								update_class_fields -- Current might have been changed; synchronize
								if not (((l_tmp.item[(l_ptr.item[0]).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
									if (l_ptr.item[0]).to_integer_32 /= 45 then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_ptr.item := l_ptr.item + 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						l_to := strtoll (l_ptr.item, l_ptr2, 0)
						update_class_fields -- Current might have been changed; synchronize
						if (l_ptr.item).is_equal (l_ptr2.item) then
							l_to := (-1).to_integer_64
						end
						if -{INTEGER_64} 1 /= l_to then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_from >= {INTEGER_64} 0 then
							l_data.item.state.resume_from := l_from
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if l_from < {INTEGER_64} 0 then
							l_data.item.req.maxdownload := -l_from
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.state.resume_from := l_from
							update_class_fields -- Current might have been changed; synchronize
						else
							l_totalsize := l_to - l_from
							l_data.item.req.maxdownload := l_totalsize + {INTEGER_64} 1
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.state.resume_from := l_from
							update_class_fields -- Current might have been changed; synchronize
						end
				when 6 then -- if done | if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_data.item.req.maxdownload := (-1).to_integer_64
						update_class_fields -- Current might have been changed; synchronize
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_data.item.req.maxdownload := (-1).to_integer_64
						update_class_fields -- Current might have been changed; synchronize
				when 10 then
					Result := ({PC_CURLCODE}.CURLE_OK)
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	file_connect (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_real_path: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_file: CE_POINTER [PD_FILEPROTO]
			l_fd: INTEGER_32
			l_tmp___0: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			l_data := data
			l_tmp := (create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_cast (l_data), l_data.item.state.path, 0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
			l_real_path := l_tmp
			if l_real_path.is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				l_return := True
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_reset_reqproto
				update_class_fields -- Current might have been changed; synchronize
				if (l_data.item.state.proto.file).is_void then
					l_tmp___0 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_FILEPROTO}.make).structure_size.to_natural_32]))
					update_class_fields -- Current might have been changed; synchronize
					l_file := create {CE_CLASS_POINTER [PD_FILEPROTO]}.make_cast (l_tmp___0)
					if l_file.is_void then
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_real_path)])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						l_return := True
					end
					if not l_return then
						l_data.item.state.proto.file := l_file
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					l_file := l_data.item.state.proto.file;
					(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_file.item.freepath))
					update_class_fields -- Current might have been changed; synchronize
					if l_file.item.fd /= -1 then
						close (l_file.item.fd).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					l_file.item.path := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					l_file.item.freepath := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					l_file.item.fd := -1
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				l_fd := open ([l_real_path, 0])
				update_class_fields -- Current might have been changed; synchronize
				l_file.item.path := l_real_path
				update_class_fields -- Current might have been changed; synchronize
				l_file.item.freepath := l_real_path
				update_class_fields -- Current might have been changed; synchronize
				l_file.item.fd := l_fd
				update_class_fields -- Current might have been changed; synchronize
				if not l_data.item.set.upload then
					if l_fd = -1 then
						l_data.item.Curl_failf ([ce_string ("Couldn%'t open file %%s"), l_data.item.state.path])
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.file_done ({PC_CURLCODE}.CURLE_FILE_COULDNT_READ_FILE, (0).to_boolean).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_FILE_COULDNT_READ_FILE)
						l_return := True
					end
				end
			end
			if not l_return then
				a_done.item := (1).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	file_done (a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
		local
			l_file: CE_POINTER [PD_FILEPROTO]
		do
			l_file := data.item.state.proto.file;
			(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_file.item.freepath))
			update_class_fields -- Current might have been changed; synchronize
			if l_file.item.fd /= -1 then
				close (l_file.item.fd).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	file_upload: NATURAL_32
		local
			l_file: CE_POINTER [PD_FILEPROTO]
			l_dir: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_res: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_buf: CE_POINTER [INTEGER_8]
			l_nread: NATURAL_32
			l_nwrite: NATURAL_32
			l_bytecount: INTEGER_64
			l_now: SD_TIMEVAL
			l_tmp___0: SD_TIMEVAL
			l_file_stat: CE_ARRAY [SD_STAT]
			l_buf2: CE_POINTER [INTEGER_8]
			l_fd: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_readcount: CE_ARRAY [INTEGER_32]
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_file_stat.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_readcount.make (<<1>>)

			l_file := data.item.state.proto.file
			l_tmp := strchr (l_file.item.path, ('/').code)
			update_class_fields -- Current might have been changed; synchronize
			l_dir := l_tmp
			l_res := {PC_CURLCODE}.CURLE_OK
			l_data := data
			l_buf := l_data.item.state.buffer
			l_bytecount := (0).to_integer_64
			l_tmp___0 := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
			update_class_fields -- Current might have been changed; synchronize
			l_now := l_tmp___0.twin
			Current.fread_func := l_data.item.set.fread_func
			update_class_fields -- Current might have been changed; synchronize
			Current.fread_in := l_data.item.set.in
			update_class_fields -- Current might have been changed; synchronize
			data.item.req.upload_fromhere := l_buf
			update_class_fields -- Current might have been changed; synchronize
			if l_dir.is_void then
				Result := ({PC_CURLCODE}.CURLE_FILE_COULDNT_READ_FILE)
				l_return := True
			end
			if not l_return and then (not (l_dir[1]).to_boolean) then
				Result := ({PC_CURLCODE}.CURLE_FILE_COULDNT_READ_FILE)
				l_return := True
			end
			if not l_return then
				if (l_data.item.state.resume_from).to_boolean then
					l_fp := fopen (l_file.item.path, ce_string ("ab"))
					update_class_fields -- Current might have been changed; synchronize
				else
					l_fd := open ([l_file.item.path, 577, data.item.set.new_file_perms])
					update_class_fields -- Current might have been changed; synchronize
					if l_fd < 0 then
						l_data.item.Curl_failf ([ce_string ("Can%'t open %%s for writing"), l_file.item.path])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
						l_return := True
					end
					if not l_return then
						close (l_fd).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_fp := fopen (l_file.item.path, ce_string ("wb"))
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return and then (l_fp.is_void) then
				l_data.item.Curl_failf ([ce_string ("Can%'t open %%s for writing"), l_file.item.path])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
				l_return := True
			end
			if not l_return then
				if -{INTEGER_64} 1 /= l_data.item.set.infilesize then
					l_data.item.Curl_pgrsSetUploadSize (l_data.item.set.infilesize)
					update_class_fields -- Current might have been changed; synchronize
				end
				if l_data.item.state.resume_from < {INTEGER_64} 0 then
					l_tmp___1 := fileno (l_fp)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := fstat (l_tmp___1, l_file_stat)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___2.to_boolean then
						fclose (l_fp).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.Curl_failf ([ce_string ("Can%'t get the size of %%s"), l_file.item.path])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
						l_return := True
					else
						l_data.item.state.resume_from := (l_file_stat.item.st_size).to_integer_64
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				from
				until
					not (not (l_break) and then (l_res = {NATURAL_32} 0))
				loop
					l_break := False
					l_res := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_fillreadbuffer (16_384, l_readcount)
					update_class_fields -- Current might have been changed; synchronize
					if l_res.to_boolean then
						l_break := True
					end
					if not (l_break) and then (l_readcount.item <= 0) then
						l_break := True
					end
					if not (l_break) then
						l_nread := (l_readcount.item).to_natural_32
						if (l_data.item.state.resume_from).to_boolean then
							if l_nread.to_integer_64 <= l_data.item.state.resume_from then
								l_data.item.state.resume_from := l_data.item.state.resume_from - l_nread.to_integer_64
								update_class_fields -- Current might have been changed; synchronize
								l_nread := (0).to_natural_32
								l_buf2 := l_buf
							else
								l_buf2 := (l_buf + (l_data.item.state.resume_from).to_integer_32)
								l_nread := l_nread - (l_data.item.state.resume_from).to_natural_32
								l_data.item.state.resume_from := (0).to_integer_64
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_buf2 := l_buf
						end
						l_nwrite := fwrite (create {CE_VOID_POINTER}.make_cast (l_buf2), (1).to_natural_32, l_nread, l_fp)
						update_class_fields -- Current might have been changed; synchronize
						if l_nwrite /= l_nread then
							l_res := {PC_CURLCODE}.CURLE_SEND_ERROR
							l_break := True
						end
					end
					if not (l_break) then
						l_bytecount := l_bytecount + l_nread.to_integer_64
						l_data.item.Curl_pgrsSetUploadCounter (l_bytecount)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___3 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pgrsUpdate
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___3.to_boolean then
							l_res := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
						else
							l_res := l_data.item.Curl_speedcheck (l_now.twin)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				end
				l_break := False
				if not l_res.to_boolean then
					l_tmp___4 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pgrsUpdate
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___4.to_boolean then
						l_res := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
					end
				end
				fclose (l_fp).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Result := l_res
			end
		end

	file_do (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_res: NATURAL_32
			l_statbuf: CE_ARRAY [SD_STAT]
			l_expected_size: INTEGER_64
			l_fstated: BOOLEAN
			l_nread: INTEGER_32
			l_bytestoread: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_buf: CE_POINTER [INTEGER_8]
			l_bytecount: INTEGER_64
			l_fd: INTEGER_32
			l_now: SD_TIMEVAL
			l_tmp: SD_TIMEVAL
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_result: NATURAL_32
			l_tm: CE_POINTER [SD_TM]
			l_filetime: CE_ARRAY [INTEGER_32]
			l_buffer: CE_ARRAY [SD_TM]
			l_tmp___2: CE_POINTER [SD_TM]
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_statbuf.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_filetime.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TM]} l_buffer.make (<<1>>)

			l_res := {PC_CURLCODE}.CURLE_OK
			l_expected_size := (0).to_integer_64
			l_fstated := (0).to_boolean
			l_data := data
			l_buf := l_data.item.state.buffer
			l_bytecount := (0).to_integer_64
			l_tmp := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
			update_class_fields -- Current might have been changed; synchronize
			l_now := l_tmp.twin
			a_done.item := (1).to_boolean
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GETINFO_STATIC}).Curl_initinfo (l_data).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsStartNow
			update_class_fields -- Current might have been changed; synchronize
			if l_data.item.set.upload then
				l_tmp___0 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.file_upload
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___0
				l_return := True
			end
			if not l_return then
				l_fd := (data.item.state.proto.file).item.fd
				l_tmp___1 := fstat (l_fd, l_statbuf)
				update_class_fields -- Current might have been changed; synchronize
				if -1 /= l_tmp___1 then
					l_expected_size := (l_statbuf.item.st_size).to_integer_64
					l_data.item.info.filetime := l_statbuf.item.st_mtim.tv_sec
					update_class_fields -- Current might have been changed; synchronize
					l_fstated := (1).to_boolean
				end
				if l_data.item.set.opt_no_body then
					if l_data.item.set.include_header then
						if l_fstated then
							(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_buf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (16_385).to_natural_32), ce_string ("Content-Length: %%lld%R%N"), l_expected_size]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write ((1).bit_or (((1).bit_shift_left (1))), l_buf, (0).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
							if not l_return then
								l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write ((1).bit_or (((1).bit_shift_left (1))), ce_string ("Accept-ranges: bytes%R%N"), (0).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
							end
							if not l_return then
								if l_fstated then
									l_filetime.item := l_statbuf.item.st_mtim.tv_sec
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___2 := gmtime_r (l_filetime, l_buffer)
									update_class_fields -- Current might have been changed; synchronize
									l_tm := l_tmp___2
									if (l_tm.item.tm_wday).to_boolean then
										l_tmp___3 := l_tm.item.tm_wday - 1
									else
										l_tmp___3 := 6
									end
									(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_buf, (16_383).to_natural_32, ce_string ("Last-Modified: %%s, %%02d %%s %%4d %%02d:%%02d:%%02d GMT%R%N"), (create {P_PARSEDATE_STATIC}).Curl_wkday.item[l_tmp___3], l_tm.item.tm_mday, (create {P_PARSEDATE_STATIC}).Curl_month.item[l_tm.item.tm_mon], l_tm.item.tm_year + 1_900, l_tm.item.tm_hour, l_tm.item.tm_min, l_tm.item.tm_sec]).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write ((1).bit_or (((1).bit_shift_left (1))), l_buf, (0).to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
								end
								if l_fstated then
									l_data.item.Curl_pgrsSetDownloadSize (l_expected_size)
									update_class_fields -- Current might have been changed; synchronize
								end
								Result := l_result
								l_return := True
							end
						end
					end
				end
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.file_range.do_nothing
				update_class_fields -- Current might have been changed; synchronize
				if l_data.item.state.resume_from < {INTEGER_64} 0 then
					if not l_fstated then
						l_data.item.Curl_failf ([ce_string ("Can%'t get the size of file.")])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_READ_ERROR)
						l_return := True
					else
						l_data.item.state.resume_from := l_data.item.state.resume_from + (l_statbuf.item.st_size).to_integer_64
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				if l_data.item.state.resume_from <= l_expected_size then
					l_expected_size := l_expected_size - (l_data.item.state.resume_from)
				else
					l_data.item.Curl_failf ([ce_string ("failed to resume file:// transfer")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_BAD_DOWNLOAD_RESUME)
					l_return := True
				end
			end
			if not l_return then
				if l_data.item.req.maxdownload > {INTEGER_64} 0 then
					l_expected_size := l_data.item.req.maxdownload
				end
				if l_fstated then
					if l_expected_size = {INTEGER_64} 0 then
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
					end
				end
			end
			if not l_return then
				if l_fstated then
					l_data.item.Curl_pgrsSetDownloadSize (l_expected_size)
					update_class_fields -- Current might have been changed; synchronize
				end
				if (l_data.item.state.resume_from).to_boolean then
					l_tmp___4 := lseek (l_fd, (l_data.item.state.resume_from).to_integer_32, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_data.item.state.resume_from /= l_tmp___4.to_integer_64 then
						Result := ({PC_CURLCODE}.CURLE_BAD_DOWNLOAD_RESUME)
						l_return := True
					end
				end
			end
			if not l_return then
				(create {P_PROGRESS_STATIC}).Curl_pgrsTime (l_data, {PC_TIMERID}.TIMER_STARTTRANSFER)
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					not (not (l_return or l_break) and then (l_res = {NATURAL_32} 0))
				loop
					l_break := False
					if l_expected_size < {INTEGER_64} 16_383 then
						l_bytestoread := l_expected_size.to_natural_32
					else
						l_bytestoread := (16_383).to_natural_32
					end
					l_nread := read (l_fd, create {CE_VOID_POINTER}.make_cast (l_buf), l_bytestoread)
					update_class_fields -- Current might have been changed; synchronize
					if l_nread > 0 then
						l_buf[l_nread] := (0).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_nread <= 0 then
						l_break := True
					elseif l_expected_size = {INTEGER_64} 0 then
						l_break := True
					end
					if not (l_return or l_break) then
						l_bytecount := l_bytecount + l_nread.to_integer_64
						l_expected_size := l_expected_size - l_nread.to_integer_64
						l_res := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write (1, l_buf, l_nread.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_res.to_boolean then
							Result := l_res
							l_return := True
						end
						if not l_return then
							l_data.item.Curl_pgrsSetDownloadCounter (l_bytecount)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___5 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pgrsUpdate
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___5.to_boolean then
								l_res := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
							else
								l_res := l_data.item.Curl_speedcheck (l_now.twin)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
				end
			end
			if not l_return then
				l_break := False
				l_tmp___6 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pgrsUpdate
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___6.to_boolean then
					l_res := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
				end
				Result := l_res
			end
		end

	Curl_resolv (a_hostname: CE_POINTER [INTEGER_8]; a_port: INTEGER_32; a_entry: CE_POINTER [CE_POINTER [PD_CURL_DNS_ENTRY]]): INTEGER_32
		require
			not a_entry.is_void
		local
			l_entry_id: CE_POINTER [INTEGER_8]
			l_dns: CE_ARRAY [CE_POINTER [PD_CURL_DNS_ENTRY]]
			l_entry_len: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_result: NATURAL_32
			l_rc: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
			l_addr: CE_POINTER [PD_CURL_ADDRINFO]
			l_respwait: CE_ARRAY [INTEGER_32]
			l_tmp___1: BOOLEAN
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_CURL_DNS_ENTRY]} l_dns.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_respwait.make (<<1>>)

			l_entry_id := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_dns.item := create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_data := data
			l_rc := -1
			a_entry.item := create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_entry_id := create_hostcache_id (a_hostname, a_port)
			update_class_fields -- Current might have been changed; synchronize
			if l_entry_id.is_void then
				Result := l_rc
				l_return := True
			end
			if not l_return then
				l_entry_len := strlen (l_entry_id)
				update_class_fields -- Current might have been changed; synchronize
				if (not (l_data.item.share).is_void) then
					l_data.item.Curl_share_lock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_DNS, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_tmp := (l_data.item.dns.hostcache).item.Curl_hash_pick (create {CE_VOID_POINTER}.make_cast (l_entry_id), l_entry_len + {NATURAL_32} 1)
				update_class_fields -- Current might have been changed; synchronize
				l_dns.item := create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_cast (l_tmp)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := l_data.item.remove_entry_if_stale (l_dns.item)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					l_dns.item := create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
				end
				if (not (l_dns.item).is_void) then
					l_dns.item.item.inuse := (l_dns.item.item.inuse) + 1
					update_class_fields -- Current might have been changed; synchronize
					l_rc := 0
				end
				if (not (l_data.item.share).is_void) then
					l_data.item.Curl_share_unlock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_DNS).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_entry_id)])
				update_class_fields -- Current might have been changed; synchronize
				if (l_dns.item).is_void then
					l_tmp___1 := Curl_ipvalid (l_data)
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp___1 then
						Result := (-1)
						l_return := True
					end
					if not l_return then
						l_addr := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_getaddrinfo (a_hostname, a_port, l_respwait)
						update_class_fields -- Current might have been changed; synchronize
						if l_addr.is_void then
							if (l_respwait.item).to_boolean then
								l_result := (create {P_HOSTSYN_STATIC}).Curl_is_resolved ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_dns)
								update_class_fields -- Current might have been changed; synchronize
								if l_result.to_boolean then
									Result := (-1)
									l_return := True
								end
								if not l_return then
									if (not (l_dns.item).is_void) then
										l_rc := 0
									else
										l_rc := 1
									end
								end
							end
						else
							if (not (l_data.item.share).is_void) then
								l_data.item.Curl_share_lock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_DNS, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
							l_dns.item := Curl_cache_addr (l_data, l_addr, a_hostname, a_port)
							update_class_fields -- Current might have been changed; synchronize
							if (not (l_data.item.share).is_void) then
								l_data.item.Curl_share_unlock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_DNS).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
							if (l_dns.item).is_void then
								(create {P_CURL_ADDRINFO_STATIC}).Curl_freeaddrinfo (l_addr)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_rc := 0
							end
						end
					end
				end
			end
			if not l_return then
				a_entry.item := l_dns.item
				update_class_fields -- Current might have been changed; synchronize
				Result := l_rc
			end
		end

	Curl_pgrsDone
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			l_data := data
			l_data.item.progress.lastshow := 0
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pgrsUpdate.do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.progress.speeder_c := 0
			update_class_fields -- Current might have been changed; synchronize
		end

	Curl_pgrsUpdate: INTEGER_32
		local
			l_now: SD_TIMEVAL
			l_result: INTEGER_32
			l_max5: CE_ARRAY [CE_ARRAY [INTEGER_8]]
			l_dlpercen: INTEGER_64
			l_ulpercen: INTEGER_64
			l_total_percen: INTEGER_64
			l_total_transfer: INTEGER_64
			l_total_expected_transfer: INTEGER_64
			l_timespent: INTEGER_64
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_nowindex: INTEGER_32
			l_checkindex: INTEGER_32
			l_countindex: INTEGER_32
			l_time_left: CE_ARRAY [INTEGER_8]
			l_time_total: CE_ARRAY [INTEGER_8]
			l_time_spent: CE_ARRAY [INTEGER_8]
			l_ulestimate: INTEGER_64
			l_dlestimate: INTEGER_64
			l_total_estimate: INTEGER_64
			l_shownow: BOOLEAN
			l_tmp: REAL_64
			l_tmp___0: REAL_64
			l_tmp___1: INTEGER_32
			l_span_ms: INTEGER_32
			l_amount: INTEGER_64
			l_tmp___2: INTEGER_64
			l_tmp___3: INTEGER_64
			l_tmp___4: INTEGER_64
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			create {CE_ARRAY_ARRAY [INTEGER_8]} l_max5.make (<<6, 10>>)
			create {CE_INTEGER_8_ARRAY} l_time_left.make (<<10>>)
			create {CE_INTEGER_8_ARRAY} l_time_total.make (<<10>>)
			create {CE_INTEGER_8_ARRAY} l_time_spent.make (<<10>>)

			l_dlpercen := (0).to_integer_64
			l_ulpercen := (0).to_integer_64
			l_total_percen := (0).to_integer_64
			l_data := data
			l_nowindex := l_data.item.progress.speeder_c \\ 6
			l_ulestimate := (0).to_integer_64
			l_dlestimate := (0).to_integer_64
			l_shownow := (0).to_boolean
			l_now := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.progress.timespent := (l_now.tv_sec - l_data.item.progress.start.tv_sec).to_double + (l_now.tv_usec - l_data.item.progress.start.tv_usec).to_double / 1000000.0
			update_class_fields -- Current might have been changed; synchronize
			l_timespent := (l_data.item.progress.timespent).truncated_to_integer_64
			if l_data.item.progress.timespent > (0).to_double then
				l_tmp := l_data.item.progress.timespent
			else
				l_tmp := (1).to_double
			end
			l_data.item.progress.dlspeed := ((l_data.item.progress.downloaded).to_double / l_tmp).truncated_to_integer_64
			update_class_fields -- Current might have been changed; synchronize
			if l_data.item.progress.timespent > (0).to_double then
				l_tmp___0 := l_data.item.progress.timespent
			else
				l_tmp___0 := (1).to_double
			end
			l_data.item.progress.ulspeed := ((l_data.item.progress.uploaded).to_double / l_tmp___0).truncated_to_integer_64
			update_class_fields -- Current might have been changed; synchronize
			if l_data.item.progress.lastshow /= l_now.tv_sec then
				l_shownow := (1).to_boolean
				l_data.item.progress.lastshow := l_now.tv_sec
				update_class_fields -- Current might have been changed; synchronize
				if l_data.item.progress.downloaded > l_data.item.progress.uploaded then
					l_data.item.progress.speeder[l_nowindex] := l_data.item.progress.downloaded
					update_class_fields -- Current might have been changed; synchronize
				else
					l_data.item.progress.speeder[l_nowindex] := l_data.item.progress.uploaded
					update_class_fields -- Current might have been changed; synchronize
				end
				l_data.item.progress.speeder_time[l_nowindex] := l_now.twin
				update_class_fields -- Current might have been changed; synchronize
				l_data.item.progress.speeder_c := (l_data.item.progress.speeder_c) + 1
				update_class_fields -- Current might have been changed; synchronize
				if l_data.item.progress.speeder_c >= 6 then
					l_tmp___1 := 6
				else
					l_tmp___1 := l_data.item.progress.speeder_c
				end
				l_countindex := l_tmp___1 - 1
				if l_countindex.to_boolean then
					if l_data.item.progress.speeder_c >= 6 then
						l_checkindex := l_data.item.progress.speeder_c \\ 6
					else
						l_checkindex := 0
					end
					l_span_ms := (create {P_TIMEVAL_STATIC}).curlx_tvdiff (l_now.twin, (l_data.item.progress.speeder_time[l_checkindex]).twin)
					update_class_fields -- Current might have been changed; synchronize
					if 0 = l_span_ms then
						l_span_ms := 1
					end
					l_amount := l_data.item.progress.speeder[l_nowindex] - l_data.item.progress.speeder[l_checkindex]
					if l_amount > {INTEGER_64} 4_294_967 then
						l_data.item.progress.current_speed := (l_amount.to_double / (l_span_ms.to_double / 1000.0)).truncated_to_integer_64
						update_class_fields -- Current might have been changed; synchronize
					else
						l_data.item.progress.current_speed := (l_amount * {INTEGER_64} 1_000) // l_span_ms.to_integer_64
						update_class_fields -- Current might have been changed; synchronize
					end
				elseif l_data.item.progress.ulspeed > l_data.item.progress.dlspeed then
					l_data.item.progress.current_speed := l_data.item.progress.ulspeed
					update_class_fields -- Current might have been changed; synchronize
				else
					l_data.item.progress.current_speed := l_data.item.progress.dlspeed
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not ((l_data.item.progress.flags).bit_and (((1).bit_shift_left (4)))).to_boolean then
				if (not (l_data.item.set.fprogress).is_void) then
					l_result := (l_data.item.set.fprogress).integer_32_item ([l_data.item.set.progress_client, (l_data.item.progress.size_dl).to_double, (l_data.item.progress.downloaded).to_double, (l_data.item.progress.size_ul).to_double, (l_data.item.progress.uploaded).to_double])
					update_class_fields -- Current might have been changed; synchronize
					if l_result.to_boolean then
						l_data.item.Curl_failf ([ce_string ("Callback aborted")])
						update_class_fields -- Current might have been changed; synchronize
					end
					Result := l_result
					l_return := True
				end
				if not l_return and then (not l_shownow) then
					Result := 0
					l_return := True
				end
				if not l_return then
					if not ((l_data.item.progress.flags).bit_and (((1).bit_shift_left (7)))).to_boolean then
						if (l_data.item.state.resume_from).to_boolean then
							(create {P_MPRINTF_STATIC}).curl_mfprintf ([l_data.item.set.err, ce_string ("** Resuming transfer from byte position %%lld%N"), l_data.item.state.resume_from]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_MPRINTF_STATIC}).curl_mfprintf ([l_data.item.set.err, ce_string ("  %%%% Total    %%%% Received %%%% Xferd  Average Speed   Time    Time     Time  Current%N                                 Dload  Upload   Total   Spent    Left  Speed%N")]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.progress.flags := (l_data.item.progress.flags).bit_or (((1).bit_shift_left (7)))
						update_class_fields -- Current might have been changed; synchronize
					end
					if ((l_data.item.progress.flags).bit_and (((1).bit_shift_left (5)))).to_boolean then
						if l_data.item.progress.ulspeed > {INTEGER_64} 0 then
							l_ulestimate := l_data.item.progress.size_ul // l_data.item.progress.ulspeed
							if l_data.item.progress.size_ul > {INTEGER_64} 10_000 then
								l_ulpercen := l_data.item.progress.uploaded // (l_data.item.progress.size_ul // {INTEGER_64} 100)
							elseif l_data.item.progress.size_ul > {INTEGER_64} 0 then
								l_ulpercen := (l_data.item.progress.uploaded * {INTEGER_64} 100) // l_data.item.progress.size_ul
							end
						end
					end
					if ((l_data.item.progress.flags).bit_and (((1).bit_shift_left (6)))).to_boolean then
						if l_data.item.progress.dlspeed > {INTEGER_64} 0 then
							l_dlestimate := l_data.item.progress.size_dl // l_data.item.progress.dlspeed
							if l_data.item.progress.size_dl > {INTEGER_64} 10_000 then
								l_dlpercen := l_data.item.progress.downloaded // (l_data.item.progress.size_dl // {INTEGER_64} 100)
							elseif l_data.item.progress.size_dl > {INTEGER_64} 0 then
								l_dlpercen := (l_data.item.progress.downloaded * {INTEGER_64} 100) // l_data.item.progress.size_dl
							end
						end
					end
					if l_ulestimate > l_dlestimate then
						l_total_estimate := l_ulestimate
					else
						l_total_estimate := l_dlestimate
					end
					if l_total_estimate > {INTEGER_64} 0 then
						l_tmp___2 := l_total_estimate - l_timespent
					else
						l_tmp___2 := (0).to_integer_64
					end
					time2str (l_time_left, l_tmp___2)
					update_class_fields -- Current might have been changed; synchronize
					time2str (l_time_total, l_total_estimate)
					update_class_fields -- Current might have been changed; synchronize
					time2str (l_time_spent, l_timespent)
					update_class_fields -- Current might have been changed; synchronize
					if ((l_data.item.progress.flags).bit_and (((1).bit_shift_left (5)))).to_boolean then
						l_tmp___3 := l_data.item.progress.size_ul
					else
						l_tmp___3 := l_data.item.progress.uploaded
					end
					if ((l_data.item.progress.flags).bit_and (((1).bit_shift_left (6)))).to_boolean then
						l_tmp___4 := l_data.item.progress.size_dl
					else
						l_tmp___4 := l_data.item.progress.downloaded
					end
					l_total_expected_transfer := l_tmp___3 + l_tmp___4
					l_total_transfer := l_data.item.progress.downloaded + l_data.item.progress.uploaded
					if l_total_expected_transfer > {INTEGER_64} 10_000 then
						l_total_percen := l_total_transfer // (l_total_expected_transfer // {INTEGER_64} 100)
					elseif l_total_expected_transfer > {INTEGER_64} 0 then
						l_total_percen := (l_total_transfer * {INTEGER_64} 100) // l_total_expected_transfer
					end
					l_tmp___5 := max5data (l_data.item.progress.current_speed, l_max5[5])
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___6 := max5data (l_data.item.progress.ulspeed, l_max5[4])
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___7 := max5data (l_data.item.progress.dlspeed, l_max5[3])
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___8 := max5data (l_data.item.progress.uploaded, l_max5[1])
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___9 := max5data (l_data.item.progress.downloaded, l_max5[0])
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___10 := max5data (l_total_expected_transfer, l_max5[2])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MPRINTF_STATIC}).curl_mfprintf ([l_data.item.set.err, ce_string ("%R%%3lld %%s  %%3lld %%s  %%3lld %%s  %%s  %%s %%s %%s %%s %%s"), l_total_percen, l_tmp___10, l_dlpercen, l_tmp___9, l_ulpercen, l_tmp___8, l_tmp___7, l_tmp___6, l_time_total, l_time_spent, l_time_left, l_tmp___5]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					fflush (l_data.item.set.err).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				Result := 0
			end
		end

	http_output_basic (a_proxy: BOOLEAN): NATURAL_32
		local
			l_authorization: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_userp: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_user: CE_POINTER [INTEGER_8]
			l_pwd: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: NATURAL_32
			l_tmp___1: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_authorization.make (<<1>>)

			l_data := data
			if a_proxy then
				l_userp := create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("allocptr") + (create {PD_DYNAMICALLY_ALLOCATED_DATA}.make).offset_of ("proxyuserpwd"))
				l_user := proxyuser
				l_pwd := proxypasswd
			else
				l_userp := create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("allocptr") + (create {PD_DYNAMICALLY_ALLOCATED_DATA}.make).offset_of ("userpwd"))
				l_user := user
				l_pwd := passwd
			end
			(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_data.item.state.buffer, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (16_385).to_natural_32), ce_string ("%%s:%%s"), l_user, l_pwd]).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := strlen ((l_data.item.state.buffer))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___1 := Curl_base64_encode (l_data, (l_data.item.state.buffer), l_tmp___0, l_authorization)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___1 > {NATURAL_32} 0 then
				if (not (l_userp.item).is_void) then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_userp.item)])
					update_class_fields -- Current might have been changed; synchronize
				end
				if a_proxy then
					l_tmp := ce_string ("Proxy-")
				else
					l_tmp := ce_string ("")
				end
				l_userp.item := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%sAuthorization: Basic %%s%R%N"), l_tmp, l_authorization.item])
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_authorization.item)])
				update_class_fields -- Current might have been changed; synchronize
				if (l_userp.item).is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			else
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				l_return := True
			end
			if not l_return then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_http_perhapsrewind: NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_http: CE_POINTER [PD_HTTP]
			l_bytessent: INTEGER_64
			l_expectsend: INTEGER_64
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					l_http := l_data.item.state.proto.http
					l_expectsend := (-1).to_integer_64
					if l_http.is_void then
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
					elseif not ((protocol).bit_and (1)).to_boolean then
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						inspect (l_data.item.set.httpreq).to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 5 then l_pos := -1 + 2
						else l_pos := -1 + 3
						end
				when 2 then -- switch 1, case 1 | switch 1, case 5
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
				when 3 then -- switch 1, default:
						l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done: | if done
					if l_return then
						l_pos := -1 + 28 -- skip if block
					end
				when 5 then -- if:
						l_bytessent := l_http.item.writebytecount
						if not (bits.authneg) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_expectsend := (0).to_integer_64
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 8 then -- else:
						inspect (l_data.item.set.httpreq).to_integer_32 -- switch 2 head
						when 2 then l_pos := -1 + 9
						when 4 then l_pos := -1 + 10
						when 3 then l_pos := -1 + 11
						else l_pos := -1 + 12
						end
				when 9 then -- switch 2, case 2
						if l_data.item.set.postfieldsize /= -{INTEGER_64} 1 then
							l_expectsend := l_data.item.set.postfieldsize
						elseif (not (l_data.item.set.postfields).is_void) then
							l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_data.item.set.postfields))
							update_class_fields -- Current might have been changed; synchronize
							l_expectsend := l_tmp.to_integer_64
						end
						l_pos := -1 + 13 -- switch 2; break
				when 10 then -- switch 2, case 4
						if l_data.item.set.infilesize /= -{INTEGER_64} 1 then
							l_expectsend := l_data.item.set.infilesize
						end
						l_pos := -1 + 13 -- switch 2; break
				when 11 then -- switch 2, case 3
						l_expectsend := l_http.item.postsize
						l_pos := -1 + 13 -- switch 2; break
				when 12 then -- switch 2, default:
						l_pos := -1 + 13 -- switch 2; break
				when 13 then -- switch 2, done: | if done
						bits.rewindaftersend := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						if l_expectsend /= -{INTEGER_64} 1 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___1
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 16 then -- else:
						if not (l_expectsend > l_bytessent) then
							l_pos := -1 + 28 -- skip if block
						end
				when 17 then -- if: | _L___1:
						if l_data.item.state.authproxy.picked /= ((1).bit_shift_left (3)).to_integer_32 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 20 then -- else:
						if l_data.item.state.authhost.picked /= ((1).bit_shift_left (3)).to_integer_32 then
							l_pos := -1 + 27 -- skip if block
						end
				when 21 then -- if: | _L___0:
						if not (l_expectsend - l_bytessent < {INTEGER_64} 2_000) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 24 then -- else:
						if ntlm.state = {NATURAL_32} 0 then
							l_pos := -1 + 26 -- skip if block
						end
				when 25 then -- if: | _L:
						if not bits.authneg then
							bits.rewindaftersend := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
				when 26 then -- if done
						if not l_return and then (bits.close) then
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						end
						if not l_return then
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("NTLM send, close instead of sending %%lld bytes%N"), l_expectsend - l_bytessent])
							update_class_fields -- Current might have been changed; synchronize
						end
				when 27 then -- if done
						if not l_return then
							bits.close := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.req.size := (0).to_integer_64
							update_class_fields -- Current might have been changed; synchronize
						end
				when 28 then -- if done | if done
					if not l_return and then (l_bytessent.to_boolean) then
						l_tmp___0 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_readrewind
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___0
						l_return := True
					end
					if not l_return then
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 29 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_http_auth_act: NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pickhost: BOOLEAN
			l_pickproxy: BOOLEAN
			l_code: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					l_pickhost := (0).to_boolean
					l_pickproxy := (0).to_boolean
					l_code := {PC_CURLCODE}.CURLE_OK
					if 100 <= l_data.item.req.httpcode then
						if 199 >= l_data.item.req.httpcode then
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						end
					end
					if not l_return and then (l_data.item.state.authproblem) then
						if l_data.item.set.http_fail_on_error then
							l_tmp := 22
						else
							l_tmp := 0
						end
						Result := l_tmp.to_natural_32
						l_return := True
					end
					if l_return then
						l_pos := -1 + 22 -- skip if block
					end
				when 1 then -- if:
						if not (bits.user_passwd) then
							l_pos := -1 + 8 -- skip if block
						end
				when 2 then -- if:
						if l_data.item.req.httpcode /= 401 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 5 then -- else:
						if not (bits.authneg) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if not (l_data.item.req.httpcode < 300) then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_pickhost := pickoneauth (create {CE_CLASS_POINTER [PD_AUTH]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("authhost")))
						update_class_fields -- Current might have been changed; synchronize
						if not l_pickhost then
							l_data.item.state.authproblem := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
				when 8 then -- if done | if done | if done
						if not (bits.proxy_user_passwd) then
							l_pos := -1 + 15 -- skip if block
						end
				when 9 then -- if:
						if l_data.item.req.httpcode /= 407 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 14 -- goto _L___0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 12 then -- else:
						if not (bits.authneg) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if not (l_data.item.req.httpcode < 300) then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L___0:
						l_pickproxy := pickoneauth (create {CE_CLASS_POINTER [PD_AUTH]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("authproxy")))
						update_class_fields -- Current might have been changed; synchronize
						if not l_pickproxy then
							l_data.item.state.authproblem := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
				when 15 then -- if done | if done | if done
						if not l_pickhost then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L___1
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else:
						if not l_pickproxy then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if: | _L___1:;
						(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_data.item.req.newurl))
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.req.newurl := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_data.item.change.url]))
						update_class_fields -- Current might have been changed; synchronize
						if (l_data.item.req.newurl).is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return and then (l_data.item.set.httpreq /= {NATURAL_32} 1) then
							if l_data.item.set.httpreq /= {NATURAL_32} 5 then
								if not bits.rewindaftersend then
									l_code := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_http_perhapsrewind
									update_class_fields -- Current might have been changed; synchronize
									if l_code.to_boolean then
										Result := l_code
										l_return := True
									end
								end
							end
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						if l_data.item.req.httpcode < 300 then
							if not l_data.item.state.authhost.done then
								if bits.authneg then
									if l_data.item.set.httpreq /= {NATURAL_32} 1 then
										if l_data.item.set.httpreq /= {NATURAL_32} 5 then
											l_data.item.req.newurl := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_data.item.change.url]))
											update_class_fields -- Current might have been changed; synchronize
											if (l_data.item.req.newurl).is_void then
												Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
												l_return := True
											end
											if not l_return then
												l_data.item.state.authhost.done := (1).to_boolean
												update_class_fields -- Current might have been changed; synchronize
											end
										end
									end
								end
							end
						end
				when 22 then -- if done | if done
					if not l_return then
						l_tmp___0 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_http_should_fail
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0.to_boolean then
							l_data.item.Curl_failf ([ce_string ("The requested URL returned error: %%d"), l_data.item.req.httpcode])
							update_class_fields -- Current might have been changed; synchronize
							l_code := {PC_CURLCODE}.CURLE_HTTP_RETURNED_ERROR
						end
						Result := l_code
					end
				when 23 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	output_auth_headers (a_authstatus: CE_POINTER [PD_AUTH]; a_request, a_path: CE_POINTER [INTEGER_8]; a_proxy: BOOLEAN): NATURAL_32
		require
			not a_authstatus.is_void
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_auth: CE_POINTER [INTEGER_8]
			l_result: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					l_auth := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_result := {PC_CURLCODE}.CURLE_OK
					if a_authstatus.item.picked /= ((1).bit_shift_left (1)).to_integer_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_auth := ce_string ("Digest")
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_output_digest (a_proxy, create {CE_NATURAL_8_POINTER}.make_cast (a_request), create {CE_NATURAL_8_POINTER}.make_cast (a_path))
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 3 then -- else:
						if a_authstatus.item.picked /= 1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if not a_proxy then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if bits.proxy_user_passwd then
							l_tmp := Curl_checkheaders (l_data, ce_string ("Proxy-authorization:"))
							update_class_fields -- Current might have been changed; synchronize
							if (not l_tmp.is_void) then
								l_pos := -1 + 7 -- goto _L___1
							else
								l_pos := -1 + 10 -- goto _L
							end
						else
							l_pos := -1 + 7 -- goto _L___1
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else: | _L___1:
						if a_proxy then
							l_pos := -1 + 11 -- skip if block
						end
				when 8 then -- if:
						if not (bits.user_passwd) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_tmp___0 := Curl_checkheaders (l_data, ce_string ("Authorization:"))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp___0.is_void) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						l_auth := ce_string ("Basic")
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.http_output_basic (a_proxy)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
				when 11 then -- if done | if done | if done
						if not l_return then
							a_authstatus.item.done := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
				when 12 then -- if done | if done
					if not l_return then
						if (not l_auth.is_void) then
							if a_proxy then
								if (not proxyuser.is_void) then
									l_tmp___1 := proxyuser
								else
									l_tmp___1 := ce_string ("")
								end
								l_tmp___3 := l_tmp___1
							else
								if (not user.is_void) then
									l_tmp___2 := user
								else
									l_tmp___2 := ce_string ("")
								end
								l_tmp___3 := l_tmp___2
							end
							if a_proxy then
								l_tmp___4 := ce_string ("Proxy")
							else
								l_tmp___4 := ce_string ("Server")
							end
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("%%s auth using %%s with user %'%%s%'%N"), l_tmp___4, l_auth, l_tmp___3])
							update_class_fields -- Current might have been changed; synchronize
							a_authstatus.item.multi := (not a_authstatus.item.done)
							update_class_fields -- Current might have been changed; synchronize
						else
							a_authstatus.item.multi := (0).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	http_output_auth (a_request, a_path: CE_POINTER [INTEGER_8]; a_proxytunnel: BOOLEAN): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_authhost: CE_POINTER [PD_AUTH]
			l_authproxy: CE_POINTER [PD_AUTH]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data := data
					l_authhost := create {CE_CLASS_POINTER [PD_AUTH]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("authhost"))
					l_authproxy := create {CE_CLASS_POINTER [PD_AUTH]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("authproxy"))
					if not (bits.httpproxy) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not bits.proxy_user_passwd then
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if not bits.user_passwd then
							l_authhost.item.done := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							l_authproxy.item.done := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						end
				when 4 then
					if not l_return then
						if (l_authhost.item.want).to_boolean then
							if not (l_authhost.item.picked).to_boolean then
								l_authhost.item.picked := l_authhost.item.want
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if (l_authproxy.item.want).to_boolean then
							if not (l_authproxy.item.picked).to_boolean then
								l_authproxy.item.picked := l_authproxy.item.want
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if bits.httpproxy then
							if (bits.tunnel_proxy).to_integer = a_proxytunnel.to_integer then
								l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.output_auth_headers (l_authproxy, a_request, a_path, (1).to_boolean)
								update_class_fields -- Current might have been changed; synchronize
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
							else
								l_authproxy.item.done := (1).to_boolean
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_authproxy.item.done := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if not l_return then
						if not l_data.item.state.this_is_a_follow then
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.output_auth_headers (l_authhost, a_request, a_path, (0).to_boolean)
							update_class_fields -- Current might have been changed; synchronize
						elseif bits.netrc then
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.output_auth_headers (l_authhost, a_request, a_path, (0).to_boolean)
							update_class_fields -- Current might have been changed; synchronize
						elseif (l_data.item.state.first_host).is_void then
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.output_auth_headers (l_authhost, a_request, a_path, (0).to_boolean)
							update_class_fields -- Current might have been changed; synchronize
						elseif l_data.item.set.http_disable_hostname_check_before_authentication then
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.output_auth_headers (l_authhost, a_request, a_path, (0).to_boolean)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_data.item.state.first_host, host.name)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp.to_boolean then
								l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.output_auth_headers (l_authhost, a_request, a_path, (0).to_boolean)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_authhost.item.done := (1).to_boolean
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						Result := l_result
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_http_input_auth (a_httpcode: INTEGER_32; a_header: CE_POINTER [INTEGER_8]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_availp: CE_POINTER [INTEGER_32]
			l_start: CE_POINTER [INTEGER_8]
			l_authp: CE_POINTER [PD_AUTH]
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_dig: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___3: INTEGER_32
			l_tmp___4: NATURAL_32
			l_tmp___5: INTEGER_32
			l_break: BOOLEAN
		do
			l_data := data
			if a_httpcode = 407 then
				l_tmp := strlen (ce_string ("Proxy-authenticate:"))
				update_class_fields -- Current might have been changed; synchronize
				l_start := a_header + l_tmp.to_integer_32
				l_availp := create {CE_INTEGER_32_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("info") + (create {PD_PUREINFO}.make).offset_of ("proxyauthavail"))
				l_authp := create {CE_CLASS_POINTER [PD_AUTH]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("authproxy"))
			else
				l_tmp___0 := strlen (ce_string ("WWW-Authenticate:"))
				update_class_fields -- Current might have been changed; synchronize
				l_start := a_header + l_tmp___0.to_integer_32
				l_availp := create {CE_INTEGER_32_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("info") + (create {PD_PUREINFO}.make).offset_of ("httpauthavail"))
				l_authp := create {CE_CLASS_POINTER [PD_AUTH]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("authhost"))
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_start[0]).to_boolean then
					l_tmp___1 := ctype_b_loc
					update_class_fields -- Current might have been changed; synchronize
					if not (((l_tmp___1.item[((l_start[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_start := l_start + 1
				end
			end
			l_break := False
			l_tmp___4 := strlen (ce_string ("Digest"))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___5 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Digest"), l_start, l_tmp___4)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___5.to_boolean then
				if ((l_authp.item.avail).bit_and (((1).bit_shift_left (1)).to_integer_32)) /= 0 then
					(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Ignoring duplicate digest auth header.%N")])
					update_class_fields -- Current might have been changed; synchronize
				else
					l_availp.item := (l_availp.item).bit_or (((1).bit_shift_left (1)).to_integer_32)
					update_class_fields -- Current might have been changed; synchronize
					l_authp.item.avail := (l_authp.item.avail).bit_or (((1).bit_shift_left (1)).to_integer_32)
					update_class_fields -- Current might have been changed; synchronize
					l_dig := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_input_digest ((a_httpcode = 407), l_start)
					update_class_fields -- Current might have been changed; synchronize
					if {NATURAL_32} 4 /= l_dig then
						(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Authentication problem. Ignoring this.%N")])
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.state.authproblem := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			else
				l_tmp___2 := strlen (ce_string ("Basic"))
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___3 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Basic"), l_start, l_tmp___2)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___3.to_boolean then
					l_availp.item := (l_availp.item).bit_or ((1))
					update_class_fields -- Current might have been changed; synchronize
					l_authp.item.avail := (l_authp.item.avail).bit_or ((1))
					update_class_fields -- Current might have been changed; synchronize
					if l_authp.item.picked = 1 then
						l_authp.item.avail := 0
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Authentication problem. Ignoring this.%N")])
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.state.authproblem := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	Curl_http_should_fail: INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_httpcode: INTEGER_32
			l_return: BOOLEAN
		do
			l_data := data
			l_httpcode := l_data.item.req.httpcode
			if not l_data.item.set.http_fail_on_error then
				Result := 0
				l_return := True
			end
			if not l_return and then (l_httpcode < 400) then
				Result := 0
				l_return := True
			end
			if not l_return and then ((l_data.item.state.resume_from).to_boolean) then
				if l_data.item.set.httpreq = {NATURAL_32} 1 then
					if l_httpcode = 416 then
						Result := 0
						l_return := True
					end
				end
			end
			if not l_return and then (l_httpcode /= 401) then
				if l_httpcode /= 407 then
					Result := 1
					l_return := True
				end
			end
			if not l_return and then (l_httpcode = 401) then
				if not bits.user_passwd then
					Result := 1
					l_return := True
				end
			end
			if not l_return and then (l_httpcode = 407) then
				if not bits.proxy_user_passwd then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				Result := (l_data.item.state.authproblem).to_integer
			end
		end

	Curl_proxyCONNECT (a_sockindex: INTEGER_32; a_hostname: CE_POINTER [INTEGER_8]; a_remote_port: NATURAL_16): NATURAL_32
		local
			l_subversion: CE_ARRAY [INTEGER_32]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_result: NATURAL_32
			l_timeout: INTEGER_32
			l_tmp: INTEGER_32
			l_tunnelsocket: INTEGER_32
			l_cl: INTEGER_64
			l_closeConnection: BOOLEAN
			l_chunked_encoding: BOOLEAN
			l_check: INTEGER_32
			l_error: INTEGER_32
			l_host_port: CE_POINTER [INTEGER_8]
			l_req_buffer: CE_POINTER [PD_CURL_SEND_BUFFER]
			l_host: CE_POINTER [INTEGER_8]
			l_proxyconn: CE_POINTER [INTEGER_8]
			l_useragent: CE_POINTER [INTEGER_8]
			l_http: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: SD_TIMEVAL
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_nread: NATURAL_32
			l_perline: INTEGER_32
			l_keepon: INTEGER_32
			l_gotbytes: CE_ARRAY [INTEGER_32]
			l_ptr: CE_POINTER [INTEGER_8]
			l_line_start: CE_POINTER [INTEGER_8]
			l_tmp___8: SD_TIMEVAL
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_i: INTEGER_32
			l_r: INTEGER_32
			l_tookcareof: CE_ARRAY [INTEGER_32]
			l_letter: INTEGER_8
			l_writetype: INTEGER_32
			l_r___0: INTEGER_32
			l_tmp___12: NATURAL_32
			l_tmp___13: INTEGER_32
			l_tmp___14: BOOLEAN
			l_tmp___15: BOOLEAN
			l_tmp___16: BOOLEAN
			l_tmp___17: NATURAL_32
			l_tmp___18: INTEGER_32
			l_tmp___19: NATURAL_32
			l_tmp___20: INTEGER_32
			l_tmp___21: NATURAL_32
			l_tmp___22: INTEGER_32
			l_tmp___23: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_subversion.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_gotbytes.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_tookcareof.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_subversion.item := 0
					update_class_fields -- Current might have been changed; synchronize
					l_data := data
					l_k := create {CE_CLASS_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
					if (l_data.item.set.timeout).to_boolean then
						l_tmp := l_data.item.set.timeout
					else
						l_tmp := 3_600_000
					end
					l_timeout := l_tmp
					l_tunnelsocket := sock[a_sockindex]
					l_cl := (0).to_integer_64
					l_closeConnection := (0).to_boolean
					l_chunked_encoding := (0).to_boolean
					l_error := 0
					bits.proxy_connect_closed := (0).to_boolean
					update_class_fields -- Current might have been changed; synchronize
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 47 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if not bits.tunnel_connecting then
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Establish HTTP proxy tunnel to %%s:%%hu%N"), a_hostname, a_remote_port.to_integer_32])
							update_class_fields -- Current might have been changed; synchronize
							if (not (l_data.item.req.newurl).is_void) then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_data.item.req.newurl)])
								update_class_fields -- Current might have been changed; synchronize
								l_data.item.req.newurl := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_req_buffer := Curl_add_buffer_init
							update_class_fields -- Current might have been changed; synchronize
							if l_req_buffer.is_void then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								l_return := True
							end
							if not l_return then
								l_host_port := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%s:%%hu"), a_hostname, a_remote_port.to_integer_32])
								update_class_fields -- Current might have been changed; synchronize
								if l_host_port.is_void then
									(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_req_buffer)])
									update_class_fields -- Current might have been changed; synchronize
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									l_return := True
								end
							end
							if not l_return then
								l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.http_output_auth (ce_string ("CONNECT"), l_host_port, (1).to_boolean)
								update_class_fields -- Current might have been changed; synchronize
								if {NATURAL_32} 0 = l_result then
									l_host := ce_string ("")
									l_proxyconn := ce_string ("")
									l_useragent := ce_string ("")
									if proxytype = {NATURAL_32} 1 then
										l_tmp___0 := ce_string ("1.0")
									else
										l_tmp___0 := ce_string ("1.1")
									end
									l_http := l_tmp___0
									l_tmp___1 := Curl_checkheaders (l_data, ce_string ("Host:"))
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___1.is_void then
										l_host := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("Host: %%s%R%N"), l_host_port])
										update_class_fields -- Current might have been changed; synchronize
										if l_host.is_void then
											(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_req_buffer)])
											update_class_fields; -- Current might have been changed; synchronize
											(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_host_port)])
											update_class_fields -- Current might have been changed; synchronize
											Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
											l_return := True
										end
									end
									if not l_return then
										l_tmp___2 := Curl_checkheaders (l_data, ce_string ("Proxy-Connection:"))
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___2.is_void then
											l_proxyconn := ce_string ("Proxy-Connection: Keep-Alive%R%N")
										end
										l_tmp___3 := Curl_checkheaders (l_data, ce_string ("User-Agent:"))
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___3.is_void then
											if (not (l_data.item.set.str[25]).is_void) then
												l_useragent := allocptr.uagent
											end
										end
										if (not (allocptr.proxyuserpwd).is_void) then
											l_tmp___4 := allocptr.proxyuserpwd
										else
											l_tmp___4 := ce_string ("")
										end
										l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("CONNECT %%s:%%hu HTTP/%%s%R%N%%s%%s%%s%%s"), a_hostname, a_remote_port.to_integer_32, l_http, l_host, l_tmp___4, l_useragent, l_proxyconn])
										update_class_fields -- Current might have been changed; synchronize
										if (not l_host.is_void) then
											if (l_host[0]).to_boolean then
												(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_host)])
												update_class_fields -- Current might have been changed; synchronize
											end
										end
										if {NATURAL_32} 0 = l_result then
											l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_add_custom_headers (l_req_buffer)
											update_class_fields -- Current might have been changed; synchronize
										end
										if {NATURAL_32} 0 = l_result then
											l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("%R%N")])
											update_class_fields -- Current might have been changed; synchronize
										end
										if {NATURAL_32} 0 = l_result then
											l_result := Curl_add_buffer_send (l_req_buffer, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), create {CE_INTEGER_32_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("info") + (create {PD_PUREINFO}.make).offset_of ("request_size")), (0).to_natural_32, a_sockindex)
											update_class_fields -- Current might have been changed; synchronize
										end
										l_req_buffer := create {CE_CLASS_POINTER [PD_CURL_SEND_BUFFER]}.make_shared (default_pointer)
										if l_result.to_boolean then
											l_data.item.Curl_failf ([ce_string ("Failed sending CONNECT to proxy")])
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								end
							end
							if not l_return then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_host_port)])
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_req_buffer))
								update_class_fields -- Current might have been changed; synchronize
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
							end
							if not l_return then
								bits.tunnel_connecting := (1).to_boolean
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if not l_return then
							l_tmp___5 := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___6 := (create {P_TIMEVAL_STATIC}).curlx_tvdiff (l_tmp___5.twin, now.twin)
							update_class_fields -- Current might have been changed; synchronize
							l_check := l_timeout - l_tmp___6
							if l_check <= 0 then
								l_data.item.Curl_failf ([ce_string ("Proxy CONNECT aborted due to timeout")])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
								l_return := True
							end
						end
						if not l_return then
							if {NATURAL_32} 2 = l_data.item.state.used_interface then
								l_tmp___7 := (create {P_SELECT_STATIC}).Curl_socket_ready (l_tunnelsocket, -1, 0)
								update_class_fields -- Current might have been changed; synchronize
								if 0 = l_tmp___7 then
									Result := ({PC_CURLCODE}.CURLE_OK)
									l_return := True
								else
								end
							else
							end
						end
						if l_return then
							l_pos := -1 + 46 -- skip if block
						end
				when 3 then -- if:
						bits.tunnel_connecting := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						l_keepon := 1
						l_ptr := l_data.item.state.buffer
						l_line_start := l_ptr
						l_nread := (0).to_natural_32
						l_perline := 0
						l_keepon := 1
				when 4 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 46 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						l_continue := False
						if l_nread < {NATURAL_32} 16_384 then
							if l_keepon.to_boolean then
								if l_error.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_tmp___8 := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___9 := (create {P_TIMEVAL_STATIC}).curlx_tvdiff (l_tmp___8.twin, now.twin)
							update_class_fields -- Current might have been changed; synchronize
							l_check := l_timeout - l_tmp___9
							if l_check <= 0 then
								l_data.item.Curl_failf ([ce_string ("Proxy CONNECT aborted due to timeout")])
								update_class_fields -- Current might have been changed; synchronize
								l_error := 2
								l_break := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 45 -- skip if block
						end
				when 6 then -- if:
						if l_check < 1_000 then
							l_tmp___10 := l_check.to_integer_32
						else
							l_tmp___10 := 1_000
						end
						l_tmp___11 := (create {P_SELECT_STATIC}).Curl_socket_ready (l_tunnelsocket, -1, l_tmp___10)
						update_class_fields -- Current might have been changed; synchronize
						inspect l_tmp___11 -- switch 1 head
						when -1 then l_pos := -1 + 7 -- -1
						when 0 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 7 then -- switch 1, case -1
						l_error := 1
						l_data.item.Curl_failf ([ce_string ("Proxy CONNECT aborted due to select/poll error")])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 45 -- switch 1; break
				when 8 then -- switch 1, case 0
						l_pos := -1 + 45 -- switch 1; break
				when 9 then -- switch 1, default:
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_read (l_tunnelsocket, l_ptr, {NATURAL_32} 16_384 - l_nread, l_gotbytes)
						update_class_fields -- Current might have been changed; synchronize
						if l_result /= {NATURAL_32} 81 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_continue := True
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 12 then -- else:
						if not (l_result.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_keepon := 0
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 15 then -- else:
						if not (l_gotbytes.item <= 0) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_keepon := 0
						if (l_data.item.set.proxyauth).to_boolean then
							if (l_data.item.state.authproxy.avail).to_boolean then
								bits.proxy_connect_closed := (1).to_boolean
								update_class_fields -- Current might have been changed; synchronize
							else
								l_error := 1
								l_data.item.Curl_failf ([ce_string ("Proxy CONNECT aborted")])
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_error := 1
							l_data.item.Curl_failf ([ce_string ("Proxy CONNECT aborted")])
							update_class_fields -- Current might have been changed; synchronize
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 18 then -- else:
						l_nread := l_nread + (l_gotbytes.item).to_natural_32
						if not (l_keepon > 1) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_nread := (0).to_natural_32
						l_ptr := l_data.item.state.buffer
						if l_cl.to_boolean then
							l_cl := l_cl - (l_gotbytes.item).to_integer_64
							if l_cl <= {INTEGER_64} 0 then
								l_keepon := 0
								l_pos := -1 + 45 -- switch 1; break
							end
						else
							l_tookcareof.item := 0
							update_class_fields -- Current might have been changed; synchronize
							l_r := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_httpchunk_read (l_ptr, l_gotbytes.item, l_tookcareof)
							update_class_fields -- Current might have been changed; synchronize
							if l_r = -1 then
								(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("chunk reading DONE%N")])
								update_class_fields -- Current might have been changed; synchronize
								l_keepon := 0
							else
								(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Read %%zd bytes of chunk, continue%N"), l_tookcareof.item])
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 21 then -- else:
						l_i := 0
				when 22 then -- loop condition:
						if not (not (l_return or l_break) and then (l_i < l_gotbytes.item)) then
							l_pos := -1 + 43 -- skip loop
						end
				when 23 then -- loop body:
						l_break := False
						l_perline := l_perline + 1
						if (l_ptr[0]).to_integer_32 /= 10 then
							l_pos := -1 + 42 -- skip if block
						end
				when 24 then -- if:
						if l_data.item.set.verbose then
							l_data.item.Curl_debug ({PC_CURL_INFOTYPE}.CURLINFO_HEADER_IN, l_line_start, l_perline.to_natural_32, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						l_writetype := (1).bit_shift_left (1)
						if l_data.item.set.include_header then
							l_writetype := (l_writetype).bit_or ((1))
						end
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write (l_writetype, l_line_start, l_perline.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
						if l_return then
							l_pos := -1 + 42 -- skip if block
						end
				when 25 then -- if:
						if 13 /= (l_line_start[0]).to_integer_32 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 28 then -- else:
						if 10 /= (l_line_start[0]).to_integer_32 then
							l_pos := -1 + 30 -- skip if block
						end
				when 29 then -- if: | _L:
						l_nread := (0).to_natural_32
						l_ptr := l_data.item.state.buffer
						if 407 = l_k.item.httpcode then
							if not l_data.item.state.authproblem then
								l_keepon := 2
								if l_cl.to_boolean then
									(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Ignore %%lld bytes of response-body%N"), l_cl])
									update_class_fields -- Current might have been changed; synchronize
									l_cl := l_cl - (l_gotbytes.item - l_i).to_integer_64
									if l_cl <= {INTEGER_64} 0 then
										l_keepon := 0
									end
								elseif l_chunked_encoding then
									l_k.item.ignorebody := (1).to_boolean
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("%%zd bytes of chunk left%N"), l_gotbytes.item - l_i])
									update_class_fields -- Current might have been changed; synchronize
									if (l_line_start[1]).to_integer_32 = 10 then
										l_line_start := l_line_start + 1
										l_i := l_i + 1
									end
									l_r___0 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_httpchunk_read (l_line_start + 1, l_gotbytes.item - l_i, l_gotbytes)
									update_class_fields -- Current might have been changed; synchronize
									if l_r___0 = -1 then
										(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("chunk reading DONE%N")])
										update_class_fields -- Current might have been changed; synchronize
										l_keepon := 0
									else
										(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Read %%zd bytes of chunk, continue%N"), l_gotbytes.item])
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									l_keepon := 0
								end
							else
								l_keepon := 0
							end
						else
							l_keepon := 0
						end
						l_break := True
				when 30 then -- if done
						if (l_return or l_break) then
							l_pos := -1 + 42 -- skip if block
						end
				when 31 then -- if:
						l_letter := l_line_start[l_perline]
						l_line_start[l_perline] := (0).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___19 := strlen (ce_string ("WWW-Authenticate:"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___20 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("WWW-Authenticate:"), l_line_start, l_tmp___19)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___20.to_boolean) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						if 401 = l_k.item.httpcode then
							l_pos := -1 + 36 -- goto _L___0
						else
							l_pos := -1 + 34 -- goto _L___2
						end
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 34 then -- else: | _L___2:
						l_tmp___21 := strlen (ce_string ("Proxy-authenticate:"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___22 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Proxy-authenticate:"), l_line_start, l_tmp___21)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___22.to_boolean) then
							l_pos := -1 + 40 -- skip if block
						end
				when 35 then -- if:
						if 407 /= l_k.item.httpcode then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if: | _L___0:
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_http_input_auth (l_k.item.httpcode, l_line_start)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 38 then -- else:
						l_pos := -1 + 40 -- goto _L___1
				when 39 then -- if done | if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else: | _L___1:
						l_tmp___17 := strlen (ce_string ("Content-Length:"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___18 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Content-Length:"), l_line_start, l_tmp___17)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___18.to_boolean then
							l_tmp___12 := strlen (ce_string ("Content-Length:"))
							update_class_fields -- Current might have been changed; synchronize
							l_cl := strtoll ((l_line_start + l_tmp___12.to_integer_32), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___16 := (create {P_HTTP_STATIC}).Curl_compareheader (l_line_start, ce_string ("Connection:"), ce_string ("close"))
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___16 then
								l_closeConnection := (1).to_boolean
							else
								l_tmp___15 := (create {P_HTTP_STATIC}).Curl_compareheader (l_line_start, ce_string ("Transfer-Encoding:"), ce_string ("chunked"))
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___15 then
									(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("CONNECT responded chunked%N")])
									update_class_fields -- Current might have been changed; synchronize
									l_chunked_encoding := (1).to_boolean;
									(create {P_HTTP_CHUNKS_STATIC}).Curl_httpchunk_init ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
									update_class_fields -- Current might have been changed; synchronize
								else
									l_tmp___14 := (create {P_HTTP_STATIC}).Curl_compareheader (l_line_start, ce_string ("Proxy-Connection:"), ce_string ("close"))
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___14 then
										l_closeConnection := (1).to_boolean
									else
										l_tmp___13 := sscanf ([l_line_start, ce_string ("HTTP/1.%%d %%d"), l_subversion, create {CE_INTEGER_32_POINTER}.make_shared (l_k.c_pointer + (create {PD_SINGLEREQUEST}.make).offset_of ("httpcode"))])
										update_class_fields -- Current might have been changed; synchronize
										if 2 = l_tmp___13 then
											l_data.item.info.httpproxycode := l_k.item.httpcode
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								end
							end
						end
				when 41 then -- if done
						if not l_return then
							l_line_start[l_perline] := l_letter
							update_class_fields -- Current might have been changed; synchronize
							l_perline := 0
							l_line_start := l_ptr + 1
						end
				when 42 then -- if done | if done | if done
						if not (l_return or l_break) then
							l_ptr := l_ptr + 1
							l_i := l_i + 1
						end
						l_pos := -1 + 22 -- back to loop condition
				when 43 then -- loop done
						if not l_return then
							l_break := False
						end
				when 44 then -- if done | if done | if done
						l_pos := -1 + 45 -- switch 1; break
				when 45 then -- switch 1, done: | if done
						if not (l_return or l_break or l_continue) then
							l_tmp___23 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pgrsUpdate
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___23.to_boolean then
								Result := ({PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK)
								l_return := True
							end
						end
						l_pos := -1 + 4 -- back to loop condition
				when 46 then -- loop done | if done
						if not l_return then
							l_break := False
							l_continue := False
							if l_error.to_boolean then
								Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
								l_return := True
							end
						end
						if not l_return and then (l_data.item.info.httpproxycode /= 200) then
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_http_auth_act
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
							if not l_return and then (bits.close) then
								l_closeConnection := (1).to_boolean
							end
						end
						if not l_return then
							if l_closeConnection then
								if (not (l_data.item.req.newurl).is_void) then
									close (sock[a_sockindex]).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									sock[a_sockindex] := -1
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
							end
							if not (l_return or l_break or l_continue) and then ((l_data.item.req.newurl).is_void) then
								l_break := True
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 47 then -- loop done
					if not l_return then
						l_break := False
						if 200 /= l_data.item.req.httpcode then
							l_data.item.Curl_failf ([ce_string ("Received HTTP code %%d from proxy after CONNECT"), l_data.item.req.httpcode])
							update_class_fields -- Current might have been changed; synchronize
							if l_closeConnection then
								if (not (l_data.item.req.newurl).is_void) then
									bits.proxy_connect_closed := (1).to_boolean
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
							l_return := True
						end
					end
					if not l_return then
						(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (allocptr.proxyuserpwd))
						update_class_fields -- Current might have been changed; synchronize
						allocptr.proxyuserpwd := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.state.authproxy.done := (1).to_boolean
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Proxy replied OK to CONNECT request%N")])
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.req.ignorebody := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 48 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_http_connect (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_result: NATURAL_32
			l_return: BOOLEAN
		do
			l_data := data
			bits.close := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			if bits.tunnel_proxy then
				if bits.httpproxy then
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_proxyCONNECT (0, host.name, remote_port)
					update_class_fields -- Current might have been changed; synchronize
					if {NATURAL_32} 0 /= l_result then
						Result := l_result
						l_return := True
					end
				end
			end
			if not l_return and then (bits.tunnel_connecting) then
				Result := ({PC_CURLCODE}.CURLE_OK)
				l_return := True
			end
			if not l_return then
				if ((protocol).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean then
					if l_data.item.state.used_interface = {NATURAL_32} 2 then
						l_result := {PC_CURLCODE}.CURLE_COULDNT_CONNECT
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					else
						l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
						if not l_return then
							a_done.item := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				else
					a_done.item := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	http_getsock_do (a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		require
			not a_socks.is_void
		do
			a_socks[0] := sock[0]
			update_class_fields -- Current might have been changed; synchronize
			Result := ((1).bit_shift_left (16))
		end

	Curl_http_done (a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_http: CE_POINTER [PD_HTTP]
			l_buff: CE_POINTER [PD_CURL_SEND_BUFFER]
			l_return: BOOLEAN
		do
			l_data := data
			l_http := l_data.item.state.proto.http
			Current.fread_func := l_data.item.set.fread_func
			update_class_fields -- Current might have been changed; synchronize
			Current.fread_in := l_data.item.set.in
			update_class_fields -- Current might have been changed; synchronize
			Current.seek_func := l_data.item.set.seek_func
			update_class_fields -- Current might have been changed; synchronize
			Current.seek_client := l_data.item.set.seek_client
			update_class_fields -- Current might have been changed; synchronize
			if l_http.is_void then
				Result := ({PC_CURLCODE}.CURLE_OK)
				l_return := True
			end
			if not l_return then
				if (not (l_http.item.send_buffer).is_void) then
					l_buff := create {CE_CLASS_POINTER [PD_CURL_SEND_BUFFER]}.make_cast (l_http.item.send_buffer);
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_buff.item.buffer)])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_buff)])
					update_class_fields -- Current might have been changed; synchronize
					l_http.item.send_buffer := create {CE_VOID_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
				end
				if {NATURAL_32} 3 = l_data.item.set.httpreq then
					l_data.item.req.bytecount := l_http.item.readbytecount + l_http.item.writebytecount
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_FORMDATA_STATIC}).Curl_formclean (create {CE_POINTER_POINTER [PD_FORMDATA]}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("sendit")))
					update_class_fields -- Current might have been changed; synchronize
					if (not (l_http.item.form.fp).is_void) then
						fclose (l_http.item.form.fp).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_http.item.form.fp := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
					end
				elseif {NATURAL_32} 4 = l_data.item.set.httpreq then
					l_data.item.req.bytecount := l_http.item.readbytecount + l_http.item.writebytecount
					update_class_fields -- Current might have been changed; synchronize
				end
				if a_status /= {NATURAL_32} 0 then
					Result := a_status
					l_return := True
				end
			end
			if not l_return and then (not a_premature) then
				if not bits.retry2 then
					if (l_http.item.readbytecount + (l_data.item.req.headerbytecount).to_integer_64) - (l_data.item.req.deductheadercount).to_integer_64 <= {INTEGER_64} 0 then
						l_data.item.Curl_failf ([ce_string ("Empty reply from server")])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_GOT_NOTHING)
						l_return := True
					end
				end
			end
			if not l_return then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_add_custom_headers (a_req_buffer: CE_POINTER [PD_CURL_SEND_BUFFER]): NATURAL_32
		local
			l_ptr: CE_POINTER [INTEGER_8]
			l_headers: CE_POINTER [PD_CURL_SLIST]
			l_tmp: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_result: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: NATURAL_32
			l_tmp___2: INTEGER_32
			l_tmp___3: NATURAL_32
			l_tmp___4: INTEGER_32
			l_tmp___5: NATURAL_32
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_headers := data.item.set.headers
				when 1 then -- loop condition:
					if not (not (l_return) and then (not l_headers.is_void)) then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						l_ptr := strchr (l_headers.item.data, (':').code)
						update_class_fields -- Current might have been changed; synchronize
						if l_ptr.is_void then
							l_pos := -1 + 14 -- skip if block
						end
				when 3 then -- if:
						l_ptr := l_ptr + 1
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_ptr[0]).to_boolean then
								l_tmp := ctype_b_loc
								update_class_fields -- Current might have been changed; synchronize
								if not (((l_tmp.item[((l_ptr[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_ptr := l_ptr + 1
							end
						end
						l_break := False
						if not ((l_ptr[0]).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 4 then -- if:
						if (allocptr.host).is_void then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_tmp___5 := strlen (ce_string ("Host:"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___6 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Host:"), l_headers.item.data, l_tmp___5)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___6.to_boolean then
							l_pos := -1 + 7 -- goto _L___1
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else: | _L___1:
						if data.item.set.httpreq /= {NATURAL_32} 3 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_tmp___3 := strlen (ce_string ("Content-Type:"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___4 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Content-Type:"), l_headers.item.data, l_tmp___3)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___4.to_boolean then
							l_pos := -1 + 10 -- goto _L___0
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else: | _L___0:
						if not (bits.authneg) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_tmp___1 := strlen (ce_string ("Content-Length"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Content-Length"), l_headers.item.data, l_tmp___1)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___2.to_boolean then
							l_pos := -1 + 13 -- goto _L
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						l_tmp___0 := Curl_add_bufferf ([a_req_buffer, ce_string ("%%s%R%N"), l_headers.item.data])
						update_class_fields -- Current might have been changed; synchronize
						l_result := l_tmp___0
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
				when 14 then -- if done | if done | if done | if done
						if not l_return then
							l_headers := l_headers.item.next
						end
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					if not l_return then
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_http (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_result: NATURAL_32
			l_http: CE_POINTER [PD_HTTP]
			l_ppath: CE_POINTER [INTEGER_8]
			l_paste_ftp_userpwd: BOOLEAN
			l_ftp_typecode: CE_ARRAY [INTEGER_8]
			l_host: CE_POINTER [INTEGER_8]
			l_te: CE_POINTER [INTEGER_8]
			l_ptr: CE_POINTER [INTEGER_8]
			l_request: CE_POINTER [INTEGER_8]
			l_httpreq: NATURAL_32
			l_addcookies: CE_POINTER [INTEGER_8]
			l_included_body: INTEGER_64
			l_httpstring: CE_POINTER [INTEGER_8]
			l_req_buffer: CE_POINTER [PD_CURL_SEND_BUFFER]
			l_postsize: INTEGER_64
			l_seekerr: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: BOOLEAN
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_cookiehost: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_colon: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: INTEGER_32
			l_url: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_currlen: NATURAL_32
			l_tmp___15: NATURAL_32
			l_newlen: NATURAL_32
			l_tmp___16: NATURAL_32
			l_urllen: NATURAL_32
			l_tmp___17: NATURAL_32
			l_newurl: CE_POINTER [INTEGER_8]
			l_tmp___18: CE_POINTER [ANY]
			l_type: CE_POINTER [INTEGER_8]
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___20: INTEGER_8
			l_p: CE_POINTER [INTEGER_8]
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_tmp___22: NATURAL_32
			l_tmp___23: INTEGER_32
			l_tmp___24: NATURAL_32
			l_tmp___25: INTEGER_32
			l_tmp___26: CE_POINTER [INTEGER_8]
			l_tmp___28: CE_POINTER [INTEGER_8]
			l_passed: INTEGER_64
			l_readthisamountnow: NATURAL_32
			l_actuallyread: NATURAL_32
			l_total_expected_size: INTEGER_64
			l_tmp___29: CE_POINTER [INTEGER_8]
			l_tmp___30: CE_POINTER [INTEGER_8]
			l_tmp___32: BOOLEAN
			l_tmp___33: NATURAL_32
			l_tmp___35: CE_POINTER [INTEGER_8]
			l_tmp___36: CE_POINTER [INTEGER_8]
			l_tmp___37: CE_POINTER [INTEGER_8]
			l_tmp___38: CE_POINTER [INTEGER_8]
			l_tmp___39: CE_POINTER [INTEGER_8]
			l_tmp___40: CE_POINTER [INTEGER_8]
			l_tmp___41: CE_POINTER [INTEGER_8]
			l_tmp___42: CE_POINTER [INTEGER_8]
			l_tmp___43: CE_POINTER [INTEGER_8]
			l_tmp___44: CE_POINTER [INTEGER_8]
			l_co: CE_POINTER [PD_COOKIE]
			l_count: INTEGER_32
			l_tmp___45: INTEGER_32
			l_tmp___46: CE_POINTER [INTEGER_8]
			l_store: CE_POINTER [PD_COOKIE]
			l_tmp___47: CE_POINTER [INTEGER_8]
			l_tmp___48: CE_POINTER [INTEGER_8]
			l_tmp___49: INTEGER_32
			l_contentType: CE_POINTER [INTEGER_8]
			l_linelength: CE_ARRAY [NATURAL_32]
			l_tmp___50: CE_POINTER [INTEGER_64]
			l_tmp___51: INTEGER_32
			l_tmp___52: NATURAL_32
			l_tmp___53: INTEGER_64
			l_tmp___54: CE_POINTER [INTEGER_8]
			l_tmp___55: CE_POINTER [INTEGER_8]
			l_tmp___56: CE_POINTER [INTEGER_8]
			l_tmp___57: INTEGER_64
			l_tmp___58: CE_POINTER [INTEGER_64]
			l_tmp___59: INTEGER_32
			l_tmp___60: CE_POINTER [INTEGER_64]
			l_tmp___61: INTEGER_32
			l_tmp___62: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_ftp_typecode.make (<<((("/;type=?").count + 1).to_natural_32).to_integer_32>>)
			create {CE_INTEGER_8_POINTER} l_request.make
			create {CE_NATURAL_32_ARRAY} l_linelength.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					l_result := {PC_CURLCODE}.CURLE_OK
					l_ppath := l_data.item.state.path
					l_paste_ftp_userpwd := (0).to_boolean
					l_ftp_typecode[0] := (('%/0/').code).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_ftp_typecode[1] := (0).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_ftp_typecode[2] := (0).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_ftp_typecode[3] := (0).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_ftp_typecode[4] := (0).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_ftp_typecode[5] := (0).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_ftp_typecode[6] := (0).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_ftp_typecode[7] := (0).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_ftp_typecode[8] := (0).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_host := host.name
					l_te := ce_string ("")
					l_httpreq := l_data.item.set.httpreq
					l_addcookies := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_included_body := (0).to_integer_64
					l_seekerr := 0
					a_done.item := (1).to_boolean
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_reset_reqproto
					update_class_fields -- Current might have been changed; synchronize
					if (l_data.item.state.proto.http).is_void then
						l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_HTTP}.make).structure_size.to_natural_32]))
						update_class_fields -- Current might have been changed; synchronize
						l_http := create {CE_CLASS_POINTER [PD_HTTP]}.make_cast (l_tmp)
						if l_http.is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							l_data.item.state.proto.http := l_http
							update_class_fields -- Current might have been changed; synchronize
						end
					else
						l_http := l_data.item.state.proto.http
					end
					if not l_return and then (not l_data.item.state.this_is_a_follow) then
						if (not (l_data.item.state.first_host).is_void) then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_data.item.state.first_host)])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_data.item.state.first_host := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([host.name]))
						update_class_fields -- Current might have been changed; synchronize
						if (l_data.item.state.first_host).is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if ((protocol).bit_and (((1).bit_or (((1).bit_shift_left (2)))).to_integer_32)).to_boolean then
							if l_data.item.set.upload then
								l_httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_PUT
							end
						end
						if (l_data.item.set.str[4]).is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_request := l_data.item.set.str[4]
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 4 then -- else:
						if not (l_data.item.set.opt_no_body) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_request := ce_string ("HEAD")
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 7 then -- else:
						inspect l_httpreq.to_integer_32 -- switch 1 head
						when 2 then l_pos := -1 + 8
						when 3 then l_pos := -1 + 8
						when 4 then l_pos := -1 + 9
						when 5 then l_pos := -1 + 11
						else l_pos := -1 + 10
						end
				when 8 then -- switch 1, case 2 | switch 1, case 3
						l_request := ce_string ("POST")
						l_pos := -1 + 12 -- switch 1; break
				when 9 then -- switch 1, case 4
						l_request := ce_string ("PUT")
						l_pos := -1 + 12 -- switch 1; break
				when 10 then -- switch 1, default:
						l_request := ce_string ("GET")
						l_pos := -1 + 12 -- switch 1; break
				when 11 then -- switch 1, case 5
						l_request := ce_string ("HEAD")
						l_pos := -1 + 12 -- switch 1; break
				when 12 then -- switch 1, done: | if done | if done
						l_tmp___0 := Curl_checkheaders (l_data, ce_string ("User-Agent:"))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp___0.is_void) then
							if (not (allocptr.uagent).is_void) then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (allocptr.uagent)])
								update_class_fields -- Current might have been changed; synchronize
								allocptr.uagent := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.http_output_auth (l_request, l_ppath, (0).to_boolean)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
				when 13 then -- if done
					if l_return then
						l_pos := -1 + 22 -- skip if block
					end
				when 14 then -- if:
						if not (l_data.item.state.authhost.multi) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 17 then -- else:
						if not (l_data.item.state.authproxy.multi) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if: | _L:
						if l_httpreq /= {NATURAL_32} 1 then
							if l_httpreq /= {NATURAL_32} 5 then
								bits.authneg := (1).to_boolean
								update_class_fields -- Current might have been changed; synchronize
							else
								bits.authneg := (0).to_boolean
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							bits.authneg := (0).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						bits.authneg := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
				when 21 then -- if done;
						(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (allocptr.ref))
						update_class_fields -- Current might have been changed; synchronize
						if (not (l_data.item.change.referer).is_void) then
							l_tmp___1 := Curl_checkheaders (l_data, ce_string ("Referer:"))
							update_class_fields -- Current might have been changed; synchronize
							if (not l_tmp___1.is_void) then
								allocptr.ref := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								update_class_fields -- Current might have been changed; synchronize
							else
								allocptr.ref := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("Referer: %%s%R%N"), l_data.item.change.referer])
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							allocptr.ref := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not (l_data.item.set.str[2]).is_void) then
							l_tmp___2 := Curl_checkheaders (l_data, ce_string ("Cookie:"))
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___2.is_void then
								l_addcookies := l_data.item.set.str[2]
							end
						end
						l_tmp___3 := Curl_checkheaders (l_data, ce_string ("Accept-Encoding:"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___3.is_void then
							if (not (l_data.item.set.str[6]).is_void) then
								(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (allocptr.accept_encoding))
								update_class_fields -- Current might have been changed; synchronize
								allocptr.accept_encoding := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("Accept-Encoding: %%s%R%N"), l_data.item.set.str[6]])
								update_class_fields -- Current might have been changed; synchronize
								if (allocptr.accept_encoding).is_void then
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									l_return := True
								end
							end
						end
				when 22 then -- if done
					if not l_return then
						l_tmp___4 := Curl_checkheaders (l_data, ce_string ("Transfer-Encoding:"))
						update_class_fields -- Current might have been changed; synchronize
						l_ptr := l_tmp___4
						if (not l_ptr.is_void) then
							l_data.item.req.upload_chunky := (create {P_HTTP_STATIC}).Curl_compareheader (l_ptr, ce_string ("Transfer-Encoding:"), ce_string ("chunked"))
							update_class_fields -- Current might have been changed; synchronize
						else
							if ((protocol).bit_and (1)).to_boolean then
								if l_data.item.set.upload then
									if l_data.item.set.infilesize = -{INTEGER_64} 1 then
										if not bits.authneg then
											l_tmp___5 := use_http_1_1 (l_data, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
											update_class_fields -- Current might have been changed; synchronize
											if l_tmp___5 then
												l_data.item.req.upload_chunky := (1).to_boolean
												update_class_fields -- Current might have been changed; synchronize
											else
												l_data.item.Curl_failf ([ce_string ("Chunky upload is not supported by HTTP 1.0")])
												update_class_fields -- Current might have been changed; synchronize
												Result := ({PC_CURLCODE}.CURLE_UPLOAD_FAILED)
												l_return := True
											end
										end
									else
										l_data.item.req.upload_chunky := (0).to_boolean
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									l_data.item.req.upload_chunky := (0).to_boolean
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_data.item.req.upload_chunky := (0).to_boolean
								update_class_fields -- Current might have been changed; synchronize
							end
							if not l_return and then (l_data.item.req.upload_chunky) then
								l_te := ce_string ("Transfer-Encoding: chunked%R%N")
							end
						end
					end
					if l_return then
						l_pos := -1 + 43 -- skip if block
					end
				when 23 then -- if:;
						(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (allocptr.host))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___6 := Curl_checkheaders (l_data, ce_string ("Host:"))
						update_class_fields -- Current might have been changed; synchronize
						l_ptr := l_tmp___6
						if l_ptr.is_void then
							l_pos := -1 + 32 -- skip if block
						end
				when 24 then -- if:
						if l_data.item.state.this_is_a_follow then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L___4
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 27 then -- else:
						l_tmp___13 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_data.item.state.first_host, host.name)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___13.to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if: | _L___4:
						l_tmp___7 := (create {P_HTTP_STATIC}).Curl_copy_header_value (l_ptr)
						update_class_fields -- Current might have been changed; synchronize
						l_cookiehost := l_tmp___7
						if l_cookiehost.is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							if not (l_cookiehost[0]).to_boolean then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_cookiehost)])
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___8 := strchr (l_cookiehost, (':').code)
								update_class_fields -- Current might have been changed; synchronize
								l_colon := l_tmp___8
								if (not l_colon.is_void) then
									l_colon[0] := (0).to_integer_8
									update_class_fields -- Current might have been changed; synchronize
								end
								(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (allocptr.cookiehost))
								update_class_fields -- Current might have been changed; synchronize
								allocptr.cookiehost := l_cookiehost
								update_class_fields -- Current might have been changed; synchronize
							end
							allocptr.host := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else:
						l_pos := -1 + 32 -- goto _L___3
				when 31 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 43
				when 32 then -- else: | _L___3:
						if not (((protocol).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						if remote_port.to_integer_32 = 443 then
							l_pos := -1 + 37 -- goto _L___0
						else
							l_pos := -1 + 35 -- goto _L___2
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 35 then -- else: | _L___2:
						if ((protocol).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean then
							l_pos := -1 + 41 -- skip if block
						end
				when 36 then -- if:
						if remote_port.to_integer_32 /= 80 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if: | _L___0:
						if bits.ipv6_ip then
							l_tmp___9 := ce_string ("]")
						else
							l_tmp___9 := ce_string ("")
						end
						if bits.ipv6_ip then
							l_tmp___10 := ce_string ("[")
						else
							l_tmp___10 := ce_string ("")
						end
						allocptr.host := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("Host: %%s%%s%%s%R%N"), l_tmp___10, l_host, l_tmp___9])
						update_class_fields -- Current might have been changed; synchronize
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 39 then -- else:
						l_pos := -1 + 41 -- goto _L___1
				when 40 then -- if done | if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else: | _L___1:
						if bits.ipv6_ip then
							l_tmp___11 := ce_string ("]")
						else
							l_tmp___11 := ce_string ("")
						end
						if bits.ipv6_ip then
							l_tmp___12 := ce_string ("[")
						else
							l_tmp___12 := ce_string ("")
						end
						allocptr.host := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("Host: %%s%%s%%s:%%hu%R%N"), l_tmp___12, l_host, l_tmp___11, remote_port.to_integer_32])
						update_class_fields -- Current might have been changed; synchronize
				when 42 then -- if done
						if (allocptr.host).is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
				when 43 then -- if done
					if not (not l_return and then (bits.httpproxy)) then
						l_pos := -1 + 56 -- skip if block
					end
				when 44 then -- if:
						if bits.tunnel_proxy then
							l_pos := -1 + 56 -- skip if block
						end
				when 45 then -- if:
						if not (host.dispname).is_equal (host.name) then
							l_url := l_data.item.change.url
							l_tmp___14 := strstr (l_url, host.dispname)
							update_class_fields -- Current might have been changed; synchronize
							l_ptr := l_tmp___14
							if (not l_ptr.is_void) then
								l_tmp___15 := strlen (host.dispname)
								update_class_fields -- Current might have been changed; synchronize
								l_currlen := l_tmp___15
								l_tmp___16 := strlen (host.name)
								update_class_fields -- Current might have been changed; synchronize
								l_newlen := l_tmp___16
								l_tmp___17 := strlen (l_url)
								update_class_fields -- Current might have been changed; synchronize
								l_urllen := l_tmp___17
								l_tmp___18 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([((l_urllen + l_newlen) - l_currlen) + {NATURAL_32} 1]))
								update_class_fields -- Current might have been changed; synchronize
								l_newurl := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___18)
								if (not l_newurl.is_void) then
									memcpy (create {CE_VOID_POINTER}.make_cast (l_newurl), create {CE_VOID_POINTER}.make_cast (l_url), (l_ptr.distance (l_url)).to_natural_32).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									memcpy (create {CE_VOID_POINTER}.make_cast ((l_newurl + (l_ptr.distance (l_url)))), create {CE_VOID_POINTER}.make_cast (host.name), l_newlen).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									memcpy (create {CE_VOID_POINTER}.make_cast (((l_newurl + l_newlen.to_integer_32) + (l_ptr.distance (l_url)))), create {CE_VOID_POINTER}.make_cast ((l_ptr + l_currlen.to_integer_32)), ((l_urllen - (l_ptr.distance (l_url)).to_natural_32) - l_currlen) + {NATURAL_32} 1).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									if l_data.item.change.url_alloc then
										(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_data.item.change.url)])
										update_class_fields -- Current might have been changed; synchronize
									end
									l_data.item.change.url := l_newurl
									update_class_fields -- Current might have been changed; synchronize
									l_data.item.change.url_alloc := (1).to_boolean
									update_class_fields -- Current might have been changed; synchronize
								else
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									l_return := True
								end
							end
						end
						if l_return then
							l_pos := -1 + 56 -- skip if block
						end
				when 46 then -- if:
						l_ppath := l_data.item.change.url
						l_tmp___24 := strlen (ce_string ("ftp://"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___25 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("ftp://"), l_ppath, l_tmp___24)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___25.to_boolean) then
							l_pos := -1 + 56 -- skip if block
						end
				when 47 then -- if:
						if not (l_data.item.set.proxy_transfer_mode) then
							l_pos := -1 + 55 -- skip if block
						end
				when 48 then -- if:
						l_tmp___19 := strstr (l_ppath, ce_string (";type="))
						update_class_fields -- Current might have been changed; synchronize
						l_type := l_tmp___19
						if l_type.is_void then
							l_pos := -1 + 54 -- skip if block
						end
				when 49 then -- if:
						if not ((l_type[6]).to_boolean) then
							l_pos := -1 + 54 -- skip if block
						end
				when 50 then -- if:
						if (l_type[7]).to_integer_32 /= 0 then
							l_pos := -1 + 54 -- skip if block
						end
				when 51 then -- if:
						l_tmp___20 := (create {P_RAWSTR_STATIC}).Curl_raw_toupper (l_type[6])
						update_class_fields -- Current might have been changed; synchronize
						inspect l_tmp___20.to_integer_32 -- switch 2 head
						when 65 then l_pos := -1 + 52
						when 68 then l_pos := -1 + 52
						when 73 then l_pos := -1 + 52
						else l_pos := -1 + 53
						end
				when 52 then -- switch 2, case 65 | switch 2, case 68 | switch 2, case 73
						l_pos := -1 + 54 -- switch 2; break
				when 53 then -- switch 2, default:
						l_type := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				when 54 then -- switch 2, done: | if done | if done | if done
						if l_type.is_void then
							l_p := l_ftp_typecode
							if not ((l_data.item.state.path).item).to_boolean then
								l_tmp___22 := strlen (l_ppath)
								update_class_fields -- Current might have been changed; synchronize
								if (l_ppath[(l_tmp___22 - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 47 then
									l_tmp___21 := l_p
									l_p := l_p + 1
									l_tmp___21[0] := (('/').code).to_integer_8
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							if l_data.item.set.prefer_ascii then
								l_tmp___23 := ('a').code
							else
								l_tmp___23 := ('i').code
							end
							(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_p, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (("/;type=?").count + 1).to_natural_32) - {NATURAL_32} 1, ce_string (";type=%%c"), l_tmp___23]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
				when 55 then -- if done
						if bits.user_passwd then
							if not bits.userpwd_in_url then
								l_paste_ftp_userpwd := (1).to_boolean
							end
						end
				when 56 then -- if done | if done | if done | if done
					if not l_return and then ({NATURAL_32} 3 = l_httpreq) then
						l_tmp___26 := Curl_checkheaders (l_data, ce_string ("Content-Type:"))
						update_class_fields -- Current might have been changed; synchronize
						l_result := (create {P_FORMDATA_STATIC}).Curl_getFormData (create {CE_POINTER_POINTER [PD_FORMDATA]}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("sendit")), l_data.item.set.httppost, l_tmp___26, create {CE_INTEGER_64_POINTER}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("postsize")))
						update_class_fields -- Current might have been changed; synchronize
						if {NATURAL_32} 0 /= l_result then
							l_data.item.Curl_failf ([ce_string ("failed creating formpost data")])
							update_class_fields -- Current might have been changed; synchronize
							Result := l_result
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 65 -- skip if block
					end
				when 57 then -- if:
						l_tmp___28 := Curl_checkheaders (l_data, ce_string ("Accept:"))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp___28.is_void) then
							l_http.item.p_accept := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_http.item.p_accept := ce_string ("Accept: */*%R%N")
							update_class_fields -- Current might have been changed; synchronize
						end
						if {NATURAL_32} 2 /= l_httpreq then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						l_pos := -1 + 64 -- goto _L___5
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 65
				when 60 then -- else:
						if {NATURAL_32} 3 /= l_httpreq then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						l_pos := -1 + 64 -- goto _L___5
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 65
				when 63 then -- else:
						if {NATURAL_32} 4 /= l_httpreq then
							l_pos := -1 + 65 -- skip if block
						end
				when 64 then -- if: | _L___5:
						if (l_data.item.state.resume_from).to_boolean then
							if l_data.item.state.resume_from < {INTEGER_64} 0 then
								l_data.item.state.resume_from := (0).to_integer_64
								update_class_fields -- Current might have been changed; synchronize
							end
							if (l_data.item.state.resume_from).to_boolean then
								if not l_data.item.state.this_is_a_follow then
									if (not seek_func.is_void) then
										l_seekerr := seek_func.integer_32_item ([seek_client, l_data.item.state.resume_from, 0])
										update_class_fields -- Current might have been changed; synchronize
									end
									if l_seekerr /= 0 then
										if l_seekerr /= 2 then
											l_data.item.Curl_failf ([ce_string ("Could not seek stream")])
											update_class_fields -- Current might have been changed; synchronize
											Result := ({PC_CURLCODE}.CURLE_READ_ERROR)
											l_return := True
										else
											l_passed := (0).to_integer_64
											from
											until
												(l_return or l_break)
											loop
												l_break := False
												l_readthisamountnow := (l_data.item.state.resume_from - l_passed).to_natural_32
												if l_readthisamountnow > {NATURAL_32} 16_384 then
													l_readthisamountnow := (16_384).to_natural_32
												end
												l_actuallyread := (l_data.item.set.fread_func).natural_32_item ([l_data.item.state.buffer, (1).to_natural_32, l_readthisamountnow, l_data.item.set.in])
												update_class_fields -- Current might have been changed; synchronize
												l_passed := l_passed + l_actuallyread.to_integer_64
												if l_actuallyread /= l_readthisamountnow then
													l_data.item.Curl_failf ([ce_string ("Could only read %%lld bytes from the input"), l_passed])
													update_class_fields -- Current might have been changed; synchronize
													Result := ({PC_CURLCODE}.CURLE_READ_ERROR)
													l_return := True
												end
												if not l_return and then (l_passed = l_data.item.state.resume_from) then
													l_break := True
												end
											end
											if not l_return then
												l_break := False
											end
										end
									end
									if not l_return and then (l_data.item.set.infilesize > {INTEGER_64} 0) then
										l_data.item.set.infilesize := l_data.item.set.infilesize - (l_data.item.state.resume_from)
										update_class_fields -- Current might have been changed; synchronize
										if l_data.item.set.infilesize <= {INTEGER_64} 0 then
											l_data.item.Curl_failf ([ce_string ("File already completely uploaded")])
											update_class_fields -- Current might have been changed; synchronize
											Result := ({PC_CURLCODE}.CURLE_PARTIAL_FILE)
											l_return := True
										end
									end
								end
							end
						end
				when 65 then -- if done | if done | if done
					if not (not l_return and then (l_data.item.state.use_range)) then
						l_pos := -1 + 73 -- skip if block
					end
				when 66 then -- if:
						if l_httpreq /= {NATURAL_32} 1 then
							l_pos := -1 + 69 -- skip if block
						end
				when 67 then -- if:
						l_pos := -1 + 70 -- goto _L___7
				when 68 then -- if block done, skip else block:
						l_pos := -1 + 73
				when 69 then -- else:
						if l_httpreq /= {NATURAL_32} 5 then
							l_pos := -1 + 72 -- skip if block
						end
				when 70 then -- if: | _L___7:
						l_tmp___30 := Curl_checkheaders (l_data, ce_string ("Range:"))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp___30.is_void) then
							l_pos := -1 + 72 -- goto _L___6
						else
							if (not (allocptr.rangeline).is_void) then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (allocptr.rangeline)])
								update_class_fields -- Current might have been changed; synchronize
							end
							allocptr.rangeline := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("Range: bytes=%%s%R%N"), l_data.item.state.range])
							update_class_fields -- Current might have been changed; synchronize
						end
				when 71 then -- if block done, skip else block:
						l_pos := -1 + 73
				when 72 then -- else: | _L___6:
						if l_httpreq /= {NATURAL_32} 1 then
							l_tmp___29 := Curl_checkheaders (l_data, ce_string ("Content-Range:"))
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___29.is_void then
								if (not (allocptr.rangeline).is_void) then
									(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (allocptr.rangeline)])
									update_class_fields -- Current might have been changed; synchronize
								end
								if l_data.item.set.set_resume_from < {INTEGER_64} 0 then
									allocptr.rangeline := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("Content-Range: bytes 0-%%lld/%%lld%R%N"), l_data.item.set.infilesize - {INTEGER_64} 1, l_data.item.set.infilesize])
									update_class_fields -- Current might have been changed; synchronize
								elseif (l_data.item.state.resume_from).to_boolean then
									l_total_expected_size := l_data.item.state.resume_from + l_data.item.set.infilesize
									allocptr.rangeline := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("Content-Range: bytes %%s%%lld/%%lld%R%N"), l_data.item.state.range, l_total_expected_size - {INTEGER_64} 1, l_total_expected_size])
									update_class_fields -- Current might have been changed; synchronize
								else
									allocptr.rangeline := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("Content-Range: bytes %%s/%%lld%R%N"), l_data.item.state.range, l_data.item.set.infilesize])
									update_class_fields -- Current might have been changed; synchronize
								end
								if (allocptr.rangeline).is_void then
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									l_return := True
								end
							end
						end
				when 73 then -- if done | if done
					if not l_return then
						l_tmp___32 := use_http_1_1 (l_data, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___32 then
							l_httpstring := ce_string ("1.1")
						else
							l_httpstring := ce_string ("1.0")
						end
						l_req_buffer := Curl_add_buffer_init
						update_class_fields -- Current might have been changed; synchronize
						if l_req_buffer.is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
					end
					if not l_return then
						l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("%%s "), l_request])
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if not l_return then
						if l_paste_ftp_userpwd then
							l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("ftp://%%s:%%s@%%s"), user, passwd, (l_ppath + ((("ftp://").count + 1).to_natural_32).to_integer_32) - 1])
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___33 := strlen (l_ppath)
							update_class_fields -- Current might have been changed; synchronize
							l_result := Curl_add_buffer (l_req_buffer, create {CE_VOID_POINTER}.make_cast (l_ppath), l_tmp___33)
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if not l_return then
						if bits.httpproxy then
							if not bits.tunnel_proxy then
								l_tmp___36 := Curl_checkheaders (l_data, ce_string ("Proxy-Connection:"))
								update_class_fields -- Current might have been changed; synchronize
								if (not l_tmp___36.is_void) then
									l_tmp___35 := ce_string ("")
								else
									l_tmp___35 := ce_string ("Proxy-Connection: Keep-Alive%R%N")
								end
							else
								l_tmp___35 := ce_string ("")
							end
						else
							l_tmp___35 := ce_string ("")
						end
						if (not (l_data.item.change.referer).is_void) then
							if (not (allocptr.ref).is_void) then
								l_tmp___37 := allocptr.ref
							else
								l_tmp___37 := ce_string ("")
							end
						else
							l_tmp___37 := ce_string ("")
						end
						if (not (l_data.item.set.str[6]).is_void) then
							if ((l_data.item.set.str[6]).item).to_boolean then
								if (not (allocptr.accept_encoding).is_void) then
									l_tmp___38 := allocptr.accept_encoding
								else
									l_tmp___38 := ce_string ("")
								end
							else
								l_tmp___38 := ce_string ("")
							end
						else
							l_tmp___38 := ce_string ("")
						end
						if (not (l_http.item.p_accept).is_void) then
							l_tmp___39 := l_http.item.p_accept
						else
							l_tmp___39 := ce_string ("")
						end
						if (not (allocptr.host).is_void) then
							l_tmp___40 := allocptr.host
						else
							l_tmp___40 := ce_string ("")
						end
						if (not (l_data.item.set.str[25]).is_void) then
							if ((l_data.item.set.str[25]).item).to_boolean then
								if (not (allocptr.uagent).is_void) then
									l_tmp___41 := allocptr.uagent
								else
									l_tmp___41 := ce_string ("")
								end
							else
								l_tmp___41 := ce_string ("")
							end
						else
							l_tmp___41 := ce_string ("")
						end
						if l_data.item.state.use_range then
							if (not (allocptr.rangeline).is_void) then
								l_tmp___42 := allocptr.rangeline
							else
								l_tmp___42 := ce_string ("")
							end
						else
							l_tmp___42 := ce_string ("")
						end
						if (not (allocptr.userpwd).is_void) then
							l_tmp___43 := allocptr.userpwd
						else
							l_tmp___43 := ce_string ("")
						end
						if (not (allocptr.proxyuserpwd).is_void) then
							l_tmp___44 := allocptr.proxyuserpwd
						else
							l_tmp___44 := ce_string ("")
						end
						l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("%%s HTTP/%%s%R%N%%s%%s%%s%%s%%s%%s%%s%%s%%s%%s"), l_ftp_typecode, l_httpstring, l_tmp___44, l_tmp___43, l_tmp___42, l_tmp___41, l_tmp___40, l_tmp___39, l_tmp___38, l_tmp___37, l_tmp___35, l_te])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (allocptr.userpwd))
						update_class_fields -- Current might have been changed; synchronize
						allocptr.userpwd := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 79 -- skip if block
					end
				when 74 then -- if:
						if (l_data.item.cookies).is_void then
							l_pos := -1 + 77 -- skip if block
						end
				when 75 then -- if:
						l_pos := -1 + 78 -- goto _L___8
				when 76 then -- if block done, skip else block:
						l_pos := -1 + 79
				when 77 then -- else:
						if l_addcookies.is_void then
							l_pos := -1 + 79 -- skip if block
						end
				when 78 then -- if: | _L___8:
						l_co := create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer)
						l_count := 0
						if (not (l_data.item.cookies).is_void) then
							l_data.item.Curl_share_lock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							if ((protocol).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean then
								l_tmp___45 := 1
							else
								l_tmp___45 := 0
							end
							if (not (allocptr.cookiehost).is_void) then
								l_tmp___46 := allocptr.cookiehost
							else
								l_tmp___46 := l_host
							end
							l_co := Curl_cookie_getlist (l_data.item.cookies, l_tmp___46, l_data.item.state.path, l_tmp___45.to_boolean)
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.Curl_share_unlock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not l_co.is_void) then
							l_store := l_co
							from
							until
								not (not (l_break) and then (not l_co.is_void))
							loop
								l_break := False
								if (not (l_co.item.value).is_void) then
									if 0 = l_count then
										l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Cookie: ")])
										update_class_fields -- Current might have been changed; synchronize
										if l_result.to_boolean then
											l_break := True
										end
									end
									if not (l_return or l_break) then
										if l_count.to_boolean then
											l_tmp___47 := ce_string ("; ")
										else
											l_tmp___47 := ce_string ("")
										end
										l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("%%s%%s=%%s"), l_tmp___47, l_co.item.name, l_co.item.value])
										update_class_fields -- Current might have been changed; synchronize
										if l_result.to_boolean then
											l_break := True
										end
									end
									if not (l_return or l_break) then
										l_count := l_count + 1
									end
								end
								if not (l_return or l_break) then
									l_co := l_co.item.next
								end
							end
							l_break := False;
							(create {P_COOKIE_STATIC}).Curl_cookie_freelist (l_store, (0).to_boolean)
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not l_addcookies.is_void) then
							if {NATURAL_32} 0 = l_result then
								if not l_count.to_boolean then
									l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Cookie: ")])
									update_class_fields -- Current might have been changed; synchronize
								end
								if {NATURAL_32} 0 = l_result then
									if l_count.to_boolean then
										l_tmp___48 := ce_string ("; ")
									else
										l_tmp___48 := ce_string ("")
									end
									l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("%%s%%s"), l_tmp___48, l_addcookies])
									update_class_fields -- Current might have been changed; synchronize
									l_count := l_count + 1
								end
							end
						end
						if l_count.to_boolean then
							if {NATURAL_32} 0 = l_result then
								l_result := Curl_add_buffer (l_req_buffer, create {CE_VOID_POINTER}.make_cast (ce_string ("%R%N")), (2).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
				when 79 then -- if done | if done
					if not l_return and then ((l_data.item.set.timecondition).to_boolean) then
						l_result := Curl_add_timecondition (l_data, l_req_buffer)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if not l_return then
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_add_custom_headers (l_req_buffer)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 119 -- skip if block
					end
				when 80 then -- if:
						l_http.item.postdata := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.Curl_pgrsSetUploadSize ((0).to_integer_64)
						update_class_fields -- Current might have been changed; synchronize
						inspect l_httpreq.to_integer_32 -- switch 3 head
						when 3 then l_pos := -1 + 81
						when 4 then l_pos := -1 + 87
						when 2 then l_pos := -1 + 88
						else l_pos := -1 + 118
						end
				when 81 then -- switch 3, case 3
						if (not (l_http.item.sendit).is_void) then
							l_pos := -1 + 84 -- skip if block
						end
				when 82 then -- if:
						l_pos := -1 + 85 -- goto _L___9
				when 83 then -- if block done, skip else block:
						l_pos := -1 + 86
				when 84 then -- else:
						if not (bits.authneg) then
							l_pos := -1 + 86 -- skip if block
						end
				when 85 then -- if: | _L___9:
						l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Content-Length: 0%R%N%R%N")])
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
						if not l_return then
							l_result := Curl_add_buffer_send (l_req_buffer, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), create {CE_INTEGER_32_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("info") + (create {PD_PUREINFO}.make).offset_of ("request_size")), (0).to_natural_32, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								l_data.item.Curl_failf ([ce_string ("Failed sending POST request")])
								update_class_fields -- Current might have been changed; synchronize
							else
								((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (0, (-1).to_integer_64, (1).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("readbytecount")), -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_pos := -1 + 119 -- switch 3; break
				when 86 then -- if done
						if not l_return then
							l_tmp___49 := (create {CE_CLASS_POINTER [PD_FORM]}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("form"))).item.Curl_FormInit (l_http.item.sendit)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___49.to_boolean then
								l_data.item.Curl_failf ([ce_string ("Internal HTTP POST error!")])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_HTTP_POST_ERROR)
								l_return := True
							end
						end
						if not l_return then
							l_http.item.form.fread_func := fread_func
							update_class_fields -- Current might have been changed; synchronize
							Current.fread_func := ((create {P_FORMDATA_STATIC}).Curl_FormReader_address)
							update_class_fields -- Current might have been changed; synchronize
							Current.fread_in := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_FORM]}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("form"))))
							update_class_fields -- Current might have been changed; synchronize
							l_http.item.sending := {PC_SENDING}.HTTPSEND_BODY
							update_class_fields -- Current might have been changed; synchronize
							if not l_data.item.req.upload_chunky then
								l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Content-Length: %%lld%R%N"), l_http.item.postsize])
								update_class_fields -- Current might have been changed; synchronize
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
							end
						end
						if not l_return then
							l_result := expect100 (l_data, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_req_buffer)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
						if not l_return then
							l_linelength.item := (0).to_natural_32
							update_class_fields -- Current might have been changed; synchronize
							l_contentType := Curl_formpostheader (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_FORM]}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("form")))), l_linelength)
							update_class_fields -- Current might have been changed; synchronize
							if l_contentType.is_void then
								l_data.item.Curl_failf ([ce_string ("Could not get Content-Type header line!")])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_HTTP_POST_ERROR)
								l_return := True
							end
						end
						if not l_return then
							l_result := Curl_add_buffer (l_req_buffer, create {CE_VOID_POINTER}.make_cast (l_contentType), l_linelength.item)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
						if not l_return then
							l_result := Curl_add_buffer (l_req_buffer, create {CE_VOID_POINTER}.make_cast (ce_string ("%R%N")), (2).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
						if not l_return then
							l_data.item.Curl_pgrsSetUploadSize (l_http.item.postsize)
							update_class_fields -- Current might have been changed; synchronize
							l_result := Curl_add_buffer_send (l_req_buffer, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), create {CE_INTEGER_32_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("info") + (create {PD_PUREINFO}.make).offset_of ("request_size")), (0).to_natural_32, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								l_data.item.Curl_failf ([ce_string ("Failed sending POST request")])
								update_class_fields -- Current might have been changed; synchronize
							else
								((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (0, (-1).to_integer_64, (1).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("readbytecount")), 0, create {CE_INTEGER_64_POINTER}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("writebytecount")))
								update_class_fields -- Current might have been changed; synchronize
							end
							if l_result.to_boolean then
								(create {P_FORMDATA_STATIC}).Curl_formclean (create {CE_POINTER_POINTER [PD_FORMDATA]}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("sendit")))
								update_class_fields -- Current might have been changed; synchronize
								Result := l_result
								l_return := True
							end
						end
						l_pos := -1 + 119 -- switch 3; break
				when 87 then -- switch 3, case 4
						if bits.authneg then
							l_postsize := (0).to_integer_64
						else
							l_postsize := l_data.item.set.infilesize
						end
						if l_postsize /= -{INTEGER_64} 1 then
							if not l_data.item.req.upload_chunky then
								l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Content-Length: %%lld%R%N"), l_postsize])
								update_class_fields -- Current might have been changed; synchronize
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
							end
						end
						if not l_return then
							l_result := expect100 (l_data, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_req_buffer)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
						if not l_return then
							l_result := Curl_add_buffer (l_req_buffer, create {CE_VOID_POINTER}.make_cast (ce_string ("%R%N")), (2).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
						if not l_return then
							l_data.item.Curl_pgrsSetUploadSize (l_postsize)
							update_class_fields -- Current might have been changed; synchronize
							l_result := Curl_add_buffer_send (l_req_buffer, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), create {CE_INTEGER_32_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("info") + (create {PD_PUREINFO}.make).offset_of ("request_size")), (0).to_natural_32, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								l_data.item.Curl_failf ([ce_string ("Failed sending PUT request")])
								update_class_fields -- Current might have been changed; synchronize
							else
								if l_postsize.to_boolean then
									l_tmp___50 := create {CE_INTEGER_64_POINTER}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("writebytecount"))
								else
									l_tmp___50 := create {CE_INTEGER_64_POINTER}.make_shared (default_pointer)
								end
								if l_postsize.to_boolean then
									l_tmp___51 := 0
								else
									l_tmp___51 := -1
								end
								((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (0, (-1).to_integer_64, (1).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("readbytecount")), l_tmp___51, l_tmp___50)
								update_class_fields -- Current might have been changed; synchronize
							end
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
						l_pos := -1 + 119 -- switch 3; break
				when 88 then -- switch 3, case 2
						if bits.authneg then
							l_postsize := (0).to_integer_64
						elseif l_data.item.set.postfieldsize /= -{INTEGER_64} 1 then
							l_postsize := l_data.item.set.postfieldsize
						else
							if (not (l_data.item.set.postfields).is_void) then
								l_tmp___52 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_data.item.set.postfields))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___53 := l_tmp___52.to_integer_64
							else
								l_tmp___53 := (-1).to_integer_64
							end
							l_postsize := l_tmp___53
						end
						if l_data.item.req.upload_chunky then
							l_pos := -1 + 94 -- skip if block
						end
				when 89 then -- if:
						if not (bits.authneg) then
							l_pos := -1 + 92 -- skip if block
						end
				when 90 then -- if:
						l_pos := -1 + 93 -- goto _L___10
				when 91 then -- if block done, skip else block:
						l_pos := -1 + 94
				when 92 then -- else:
						l_tmp___54 := Curl_checkheaders (l_data, ce_string ("Content-Length:"))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp___54.is_void) then
							l_pos := -1 + 94 -- skip if block
						end
				when 93 then -- if: | _L___10:
						l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Content-Length: %%lld%R%N"), l_postsize])
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
				when 94 then -- if done | if done
						if not l_return then
							l_tmp___55 := Curl_checkheaders (l_data, ce_string ("Content-Type:"))
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___55.is_void then
								l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Content-Type: application/x-www-form-urlencoded%R%N")])
								update_class_fields -- Current might have been changed; synchronize
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
							end
						end
						if l_return then
							l_pos := -1 + 105 -- skip if block
						end
				when 95 then -- if:
						l_tmp___56 := Curl_checkheaders (l_data, ce_string ("Expect:"))
						update_class_fields -- Current might have been changed; synchronize
						l_ptr := l_tmp___56
						if l_ptr.is_void then
							l_pos := -1 + 98 -- skip if block
						end
				when 96 then -- if:
						l_data.item.state.expect100header := (create {P_HTTP_STATIC}).Curl_compareheader (l_ptr, ce_string ("Expect:"), ce_string ("100-continue"))
						update_class_fields -- Current might have been changed; synchronize
				when 97 then -- if block done, skip else block:
						l_pos := -1 + 105
				when 98 then -- else:
						if not (l_postsize > {INTEGER_64} 1_024) then
							l_pos := -1 + 101 -- skip if block
						end
				when 99 then -- if:
						l_pos := -1 + 102 -- goto _L___11
				when 100 then -- if block done, skip else block:
						l_pos := -1 + 105
				when 101 then -- else:
						if not (l_postsize < {INTEGER_64} 0) then
							l_pos := -1 + 104 -- skip if block
						end
				when 102 then -- if: | _L___11:
						l_result := expect100 (l_data, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_req_buffer)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
				when 103 then -- if block done, skip else block:
						l_pos := -1 + 105
				when 104 then -- else:
						l_data.item.state.expect100header := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
				when 105 then -- if done | if done | if done
						if l_return then
							l_pos := -1 + 117 -- skip if block
						end
				when 106 then -- if:
						if (l_data.item.set.postfields).is_void then
							l_pos := -1 + 112 -- skip if block
						end
				when 107 then -- if:
						if l_data.item.state.expect100header then
							l_pos := -1 + 110 -- skip if block
						end
				when 108 then -- if:
						if l_postsize < {INTEGER_64} 65_536 then
							l_result := Curl_add_buffer (l_req_buffer, create {CE_VOID_POINTER}.make_cast (ce_string ("%R%N")), (2).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
							if not l_return then
								if not l_data.item.req.upload_chunky then
									l_result := Curl_add_buffer (l_req_buffer, l_data.item.set.postfields, l_postsize.to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
									l_included_body := l_postsize
								else
									l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("%%x%R%N"), l_postsize.to_integer_32])
									update_class_fields -- Current might have been changed; synchronize
									if {NATURAL_32} 0 = l_result then
										l_result := Curl_add_buffer (l_req_buffer, l_data.item.set.postfields, l_postsize.to_natural_32)
										update_class_fields -- Current might have been changed; synchronize
									end
									if {NATURAL_32} 0 = l_result then
										l_result := Curl_add_buffer (l_req_buffer, create {CE_VOID_POINTER}.make_cast (ce_string ("%R%N0%R%N%R%N")), (7).to_natural_32)
										update_class_fields -- Current might have been changed; synchronize
									end
									l_included_body := l_postsize + {INTEGER_64} 7
								end
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
							end
							if not l_return then
								l_data.item.Curl_pgrsSetUploadSize (l_postsize)
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_pos := -1 + 110 -- goto _L___12
						end
				when 109 then -- if block done, skip else block:
						l_pos := -1 + 111
				when 110 then -- else: | _L___12:
						l_http.item.postsize := l_postsize
						update_class_fields -- Current might have been changed; synchronize
						l_http.item.postdata := create {CE_INTEGER_8_POINTER}.make_cast (l_data.item.set.postfields)
						update_class_fields -- Current might have been changed; synchronize
						l_http.item.sending := {PC_SENDING}.HTTPSEND_BODY
						update_class_fields -- Current might have been changed; synchronize
						Current.fread_func := (create {P_HTTP_STATIC}).readmoredata_address
						update_class_fields -- Current might have been changed; synchronize
						Current.fread_in := create {CE_VOID_POINTER}.make_shared (c_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.Curl_pgrsSetUploadSize (l_http.item.postsize)
						update_class_fields -- Current might have been changed; synchronize
						l_result := Curl_add_buffer (l_req_buffer, create {CE_VOID_POINTER}.make_cast (ce_string ("%R%N")), (2).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
				when 111 then -- if done | if block done, skip else block:
						l_pos := -1 + 117
				when 112 then -- else:
						l_result := Curl_add_buffer (l_req_buffer, create {CE_VOID_POINTER}.make_cast (ce_string ("%R%N")), (2).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
						if l_return then
							l_pos := -1 + 117 -- skip if block
						end
				when 113 then -- if:
						if not (l_data.item.req.upload_chunky) then
							l_pos := -1 + 116 -- skip if block
						end
				when 114 then -- if:
						if bits.authneg then
							l_result := Curl_add_buffer (l_req_buffer, create {CE_VOID_POINTER}.make_cast (ce_string ("%R%N0%R%N%R%N")), (7).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						else
							l_pos := -1 + 116 -- goto _L___13
						end
				when 115 then -- if block done, skip else block:
						l_pos := -1 + 117
				when 116 then -- else: | _L___13:
						if (l_data.item.set.postfieldsize).to_boolean then
							if l_postsize.to_boolean then
								l_tmp___57 := l_postsize
							else
								l_tmp___57 := (-1).to_integer_64
							end
							l_data.item.Curl_pgrsSetUploadSize (l_tmp___57)
							update_class_fields -- Current might have been changed; synchronize
							if not bits.authneg then
								l_http.item.postdata := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("postdata"))))
								update_class_fields -- Current might have been changed; synchronize
								l_http.item.postsize := l_postsize
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 117 then -- if done | if done | if done
						if not l_return then
							l_result := Curl_add_buffer_send (l_req_buffer, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), create {CE_INTEGER_32_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("info") + (create {PD_PUREINFO}.make).offset_of ("request_size")), l_included_body.to_natural_32, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								l_data.item.Curl_failf ([ce_string ("Failed sending HTTP POST request")])
								update_class_fields -- Current might have been changed; synchronize
							else
								if (not (l_http.item.postdata).is_void) then
									l_tmp___58 := create {CE_INTEGER_64_POINTER}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("writebytecount"))
								else
									l_tmp___58 := create {CE_INTEGER_64_POINTER}.make_shared (default_pointer)
								end
								if (not (l_http.item.postdata).is_void) then
									l_tmp___59 := 0
								else
									l_tmp___59 := -1
								end
								((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (0, (-1).to_integer_64, (1).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("readbytecount")), l_tmp___59, l_tmp___58)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_pos := -1 + 119 -- switch 3; break
				when 118 then -- switch 3, default:
						l_result := Curl_add_buffer (l_req_buffer, create {CE_VOID_POINTER}.make_cast (ce_string ("%R%N")), (2).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
						if not l_return then
							l_result := Curl_add_buffer_send (l_req_buffer, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), create {CE_INTEGER_32_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("info") + (create {PD_PUREINFO}.make).offset_of ("request_size")), (0).to_natural_32, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								l_data.item.Curl_failf ([ce_string ("Failed sending HTTP request")])
								update_class_fields -- Current might have been changed; synchronize
							else
								if (not (l_http.item.postdata).is_void) then
									l_tmp___60 := create {CE_INTEGER_64_POINTER}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("writebytecount"))
								else
									l_tmp___60 := create {CE_INTEGER_64_POINTER}.make_shared (default_pointer)
								end
								if (not (l_http.item.postdata).is_void) then
									l_tmp___61 := 0
								else
									l_tmp___61 := -1
								end
								((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (0, (-1).to_integer_64, (1).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("readbytecount")), l_tmp___61, l_tmp___60)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 119 then -- switch 3, done: | if done
					if not l_return and then (l_result.to_boolean) then
						Result := l_result
						l_return := True
					end
					if not l_return then
						if (l_http.item.writebytecount).to_boolean then
							l_data.item.Curl_pgrsSetUploadCounter (l_http.item.writebytecount)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___62 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pgrsUpdate
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___62.to_boolean then
								l_result := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
							end
						end
						Result := l_result
					end
				when 120 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_sendf (a_args: TUPLE [a_sockfd: INTEGER_32; a_fmt: CE_POINTER [INTEGER_8]]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_bytes_written: CE_ARRAY [INTEGER_32]
			l_write_len: NATURAL_32
			l_res: NATURAL_32
			l_s: CE_POINTER [INTEGER_8]
			l_sptr: CE_POINTER [INTEGER_8]
			l_ap: CE_VA_LIST
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_bytes_written.make (<<1>>)
			create l_ap.make_shared (default_pointer)

			l_data := data
			l_res := {PC_CURLCODE}.CURLE_OK
			l_ap := create {CE_VA_LIST}.make (a_args, agent Curl_sendf)
			l_s := curl_mvaprintf (a_args.a_fmt, l_ap.twin)
			update_class_fields -- Current might have been changed; synchronize
			if l_s.is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				l_return := True
			end
			if not l_return then
				l_bytes_written.item := 0
				update_class_fields -- Current might have been changed; synchronize
				l_write_len := strlen (l_s)
				update_class_fields -- Current might have been changed; synchronize
				l_sptr := l_s
				from
				until
					(l_break)
				loop
					l_break := False
					l_res := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_write (a_args.a_sockfd, create {CE_VOID_POINTER}.make_cast (l_sptr), l_write_len, l_bytes_written)
					update_class_fields -- Current might have been changed; synchronize
					if {NATURAL_32} 0 /= l_res then
						l_break := True
					end
					if not (l_break) then
						if l_data.item.set.verbose then
							l_data.item.Curl_debug ({PC_CURL_INFOTYPE}.CURLINFO_DATA_OUT, l_sptr, (l_bytes_written.item).to_natural_32, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						if (l_bytes_written.item).to_natural_32 /= l_write_len then
							l_write_len := l_write_len - (l_bytes_written.item).to_natural_32
							l_sptr := l_sptr + (l_bytes_written.item)
						else
							l_break := True
						end
					end
				end
				l_break := False;
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_s)])
				update_class_fields -- Current might have been changed; synchronize
				Result := l_res
			end
		end

	Curl_write (a_sockfd: INTEGER_32; a_mem: CE_POINTER [ANY]; a_len: NATURAL_32; a_written: CE_POINTER [INTEGER_32]): NATURAL_32
		require
			not a_written.is_void
		local
			l_bytes_written: INTEGER_32
			l_curlcode: CE_ARRAY [NATURAL_32]
			l_num: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_curlcode.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_curlcode.item := {PC_CURLCODE}.CURLE_OK
					update_class_fields -- Current might have been changed; synchronize
					l_num := (a_sockfd = sock[1]).to_integer
					l_bytes_written := (send2[l_num]).integer_32_item ([(create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_num, a_mem, a_len, l_curlcode])
					update_class_fields -- Current might have been changed; synchronize
					a_written.item := l_bytes_written
					update_class_fields -- Current might have been changed; synchronize
					if l_bytes_written >= 0 then
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						inspect (l_curlcode.item).to_integer_32 -- switch 1 head
						when 81 then l_pos := -1 + 2
						when 0 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 2 then -- switch 1, case 81
						a_written.item := 0
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
				when 3 then -- switch 1, case 0
						if not l_return then
							Result := ({PC_CURLCODE}.CURLE_SEND_ERROR)
							l_return := True
						end
				when 4 then -- switch 1, default:
						if not l_return then
							Result := (l_curlcode.item)
						end
				when 5 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_send_plain (a_num: INTEGER_32; a_mem: CE_POINTER [ANY]; a_len: NATURAL_32; a_code: CE_POINTER [NATURAL_32]): INTEGER_32
		require
			not a_code.is_void
		local
			l_sockfd: INTEGER_32
			l_bytes_written: INTEGER_32
			l_tmp: INTEGER_32
			l_err: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_32]
			l_tmp___1: CE_POINTER [INTEGER_8]
		do
			l_sockfd := sock[a_num]
			l_tmp := send (l_sockfd, a_mem, a_len, 16_384)
			update_class_fields -- Current might have been changed; synchronize
			l_bytes_written := l_tmp
			a_code.item := {PC_CURLCODE}.CURLE_OK
			update_class_fields -- Current might have been changed; synchronize
			if -1 = l_bytes_written then
				l_tmp___0 := errno_location
				update_class_fields -- Current might have been changed; synchronize
				l_err := l_tmp___0.item
				if 11 = l_err then
					l_bytes_written := 0
					a_code.item := {PC_CURLCODE}.CURLE_AGAIN
					update_class_fields -- Current might have been changed; synchronize
				elseif 11 = l_err then
					l_bytes_written := 0
					a_code.item := {PC_CURLCODE}.CURLE_AGAIN
					update_class_fields -- Current might have been changed; synchronize
				elseif 4 = l_err then
					l_bytes_written := 0
					a_code.item := {PC_CURLCODE}.CURLE_AGAIN
					update_class_fields -- Current might have been changed; synchronize
				else
					l_tmp___1 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_err)
					update_class_fields -- Current might have been changed; synchronize
					data.item.Curl_failf ([ce_string ("Send failure: %%s"), l_tmp___1])
					update_class_fields -- Current might have been changed; synchronize
					a_code.item := {PC_CURLCODE}.CURLE_SEND_ERROR
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			Result := l_bytes_written
		end

	Curl_write_plain (a_sockfd: INTEGER_32; a_mem: CE_POINTER [ANY]; a_len: NATURAL_32; a_written: CE_POINTER [INTEGER_32]): NATURAL_32
		require
			not a_written.is_void
		local
			l_bytes_written: INTEGER_32
			l_retcode: CE_ARRAY [NATURAL_32]
			l_num: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_retcode.make (<<1>>)

			l_num := (a_sockfd = sock[1]).to_integer
			l_bytes_written := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_send_plain (l_num, a_mem, a_len, l_retcode)
			update_class_fields -- Current might have been changed; synchronize
			a_written.item := l_bytes_written
			update_class_fields -- Current might have been changed; synchronize
			Result := (l_retcode.item)
		end

	Curl_recv_plain (a_num: INTEGER_32; a_buf: CE_POINTER [INTEGER_8]; a_len: NATURAL_32; a_code: CE_POINTER [NATURAL_32]): INTEGER_32
		require
			not a_code.is_void
		local
			l_sockfd: INTEGER_32
			l_nread: INTEGER_32
			l_tmp: INTEGER_32
			l_err: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_32]
			l_tmp___1: CE_POINTER [INTEGER_8]
		do
			l_sockfd := sock[a_num]
			l_tmp := recv (l_sockfd, create {CE_VOID_POINTER}.make_cast (a_buf), a_len, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_nread := l_tmp
			a_code.item := {PC_CURLCODE}.CURLE_OK
			update_class_fields -- Current might have been changed; synchronize
			if -1 = l_nread then
				l_tmp___0 := errno_location
				update_class_fields -- Current might have been changed; synchronize
				l_err := l_tmp___0.item
				if 11 = l_err then
					a_code.item := {PC_CURLCODE}.CURLE_AGAIN
					update_class_fields -- Current might have been changed; synchronize
				elseif 11 = l_err then
					a_code.item := {PC_CURLCODE}.CURLE_AGAIN
					update_class_fields -- Current might have been changed; synchronize
				elseif 4 = l_err then
					a_code.item := {PC_CURLCODE}.CURLE_AGAIN
					update_class_fields -- Current might have been changed; synchronize
				else
					l_tmp___1 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_err)
					update_class_fields -- Current might have been changed; synchronize
					data.item.Curl_failf ([ce_string ("Recv failure: %%s"), l_tmp___1])
					update_class_fields -- Current might have been changed; synchronize
					a_code.item := {PC_CURLCODE}.CURLE_RECV_ERROR
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			Result := l_nread
		end

	Curl_client_write (a_type: INTEGER_32; a_ptr: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): NATURAL_32
		local
			l_len: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_wrote: NATURAL_32
			l_newlen: NATURAL_32
			l_newptr: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: NATURAL_32
			l_writeit: CE_ROUTINE
			l_tmp___1: CE_ROUTINE
			l_tmp___2: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := a_len
					l_data := data
					if {NATURAL_32} 0 = l_len then
						l_len := strlen (a_ptr)
						update_class_fields -- Current might have been changed; synchronize
					end
					if ((l_data.item.req.keepon).bit_and (((1).bit_shift_left (4)))).to_boolean then
						if a_type /= l_data.item.state.tempwritetype then
							Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
							l_return := True
						end
						if not l_return then
							l_newlen := l_len + l_data.item.state.tempwritesize
							l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_crealloc.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_data.item.state.tempwrite), l_newlen]))
							update_class_fields -- Current might have been changed; synchronize
							l_newptr := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)
							if l_newptr.is_void then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								l_return := True
							end
						end
						if not l_return then
							memcpy (create {CE_VOID_POINTER}.make_cast ((l_newptr + (l_data.item.state.tempwritesize).to_integer_32)), create {CE_VOID_POINTER}.make_cast (a_ptr), l_len).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.state.tempwrite := l_newptr
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.state.tempwritesize := l_newlen
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						end
					end
					if not l_return and then (((a_type).bit_and (1)).to_boolean) then
						if ((protocol).bit_and (((1).bit_shift_left (2)).to_integer_32)).to_boolean then
							if (proto.ftpc.transfertype).to_integer_32 = 65 then
								l_len := convert_lineends (l_data, a_ptr, l_len)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if l_len.to_boolean then
							l_wrote := (l_data.item.set.fwrite_func).natural_32_item ([a_ptr, (1).to_natural_32, l_len, l_data.item.set.out2])
							update_class_fields -- Current might have been changed; synchronize
						else
							l_wrote := l_len
						end
						if {NATURAL_32} 268_435_457 = l_wrote then
							l_tmp___0 := pausewrite (l_data, a_type, a_ptr, l_len)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp___0
							l_return := True
						end
						if not l_return and then (l_wrote /= l_len) then
							l_data.item.Curl_failf ([ce_string ("Failed writing body (%%zu != %%zu)"), l_wrote, l_len])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
							l_return := True
						end
					end
					if not (not l_return and then (((a_type).bit_and (((1).bit_shift_left (1)))).to_boolean)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if (l_data.item.set.fwrite_header).is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (l_data.item.set.writeheader).is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (not (l_data.item.set.fwrite_header).is_void) then
							l_tmp___1 := l_data.item.set.fwrite_header
						else
							l_tmp___1 := l_data.item.set.fwrite_func
						end
						l_writeit := l_tmp___1
						l_wrote := l_writeit.natural_32_item ([a_ptr, (1).to_natural_32, l_len, l_data.item.set.writeheader])
						update_class_fields -- Current might have been changed; synchronize
						if {NATURAL_32} 268_435_457 = l_wrote then
							l_tmp___2 := pausewrite (l_data, (1).bit_shift_left (1), a_ptr, l_len)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp___2
							l_return := True
						end
						if not l_return and then (l_wrote /= l_len) then
							l_data.item.Curl_failf ([ce_string ("Failed writing header")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
							l_return := True
						end
				when 6 then -- if done | if done
					if not l_return then
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_read (a_sockfd: INTEGER_32; a_buf: CE_POINTER [INTEGER_8]; a_sizerequested: NATURAL_32; a_n: CE_POINTER [INTEGER_32]): NATURAL_32
		require
			not a_n.is_void
		local
			l_curlcode: CE_ARRAY [NATURAL_32]
			l_nread: INTEGER_32
			l_bytesfromsocket: NATURAL_32
			l_buffertofill: CE_POINTER [INTEGER_8]
			l_pipelining: BOOLEAN
			l_tmp: BOOLEAN
			l_tmp___0: INTEGER_32
			l_num: INTEGER_32
			l_bytestocopy: NATURAL_32
			l_tmp___1: NATURAL_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_curlcode.make (<<1>>)

			l_curlcode.item := {PC_CURLCODE}.CURLE_RECV_ERROR
			update_class_fields -- Current might have been changed; synchronize
			l_nread := 0
			l_bytesfromsocket := (0).to_natural_32
			l_buffertofill := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			if (not (data.item.multi).is_void) then
				l_tmp := (data.item.multi).item.Curl_multi_canPipeline
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			l_pipelining := l_tmp___0.to_boolean
			l_num := (a_sockfd = sock[1]).to_integer
			a_n.item := 0
			update_class_fields -- Current might have been changed; synchronize
			if l_pipelining then
				if buf_len - read_pos < a_sizerequested then
					l_tmp___1 := buf_len - read_pos
				else
					l_tmp___1 := a_sizerequested
				end
				l_bytestocopy := l_tmp___1
				if l_bytestocopy > {NATURAL_32} 0 then
					memcpy (create {CE_VOID_POINTER}.make_cast (a_buf), create {CE_VOID_POINTER}.make_cast ((master_buffer + read_pos.to_integer_32)), l_bytestocopy).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					Current.read_pos := read_pos + l_bytestocopy
					update_class_fields -- Current might have been changed; synchronize
					bits.stream_was_rewound := (0).to_boolean
					update_class_fields -- Current might have been changed; synchronize
					a_n.item := l_bytestocopy.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_OK)
					l_return := True
				end
				if not l_return then
					if a_sizerequested < {NATURAL_32} 16_384 * {PLATFORM}.Integer_8_bytes.to_natural_32 then
						l_bytesfromsocket := a_sizerequested
					else
						l_bytesfromsocket := {NATURAL_32} 16_384 * {PLATFORM}.Integer_8_bytes.to_natural_32
					end
					l_buffertofill := master_buffer
				end
			else
				if (data.item.set.buffer_size).to_boolean then
					l_tmp___4 := data.item.set.buffer_size
				else
					l_tmp___4 := 16_384
				end
				if a_sizerequested.to_integer_32 < l_tmp___4 then
					l_bytesfromsocket := (a_sizerequested.to_integer_32).to_natural_32
				else
					if (data.item.set.buffer_size).to_boolean then
						l_tmp___3 := data.item.set.buffer_size
					else
						l_tmp___3 := 16_384
					end
					l_bytesfromsocket := l_tmp___3.to_natural_32
				end
				l_buffertofill := a_buf
			end
			if not l_return then
				l_nread := (recv2[l_num]).integer_32_item ([(create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_num, l_buffertofill, l_bytesfromsocket, l_curlcode])
				update_class_fields -- Current might have been changed; synchronize
				if l_nread < 0 then
					Result := (l_curlcode.item)
					l_return := True
				end
			end
			if not l_return then
				if l_pipelining then
					memcpy (create {CE_VOID_POINTER}.make_cast (a_buf), create {CE_VOID_POINTER}.make_cast (master_buffer), l_nread.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					Current.buf_len := l_nread.to_natural_32
					update_class_fields -- Current might have been changed; synchronize
					Current.read_pos := l_nread.to_natural_32
					update_class_fields -- Current might have been changed; synchronize
				end
				a_n.item := a_n.item + l_nread
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	AllowServerConnect: NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_sock: INTEGER_32
			l_timeout_ms: INTEGER_32
			l_interval_ms: INTEGER_32
			l_s: INTEGER_32
			l_add: CE_ARRAY [PD_CURL_SOCKADDR_STORAGE]
			l_size: CE_ARRAY [NATURAL_32]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_CURL_SOCKADDR_STORAGE]} l_add.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_size.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					l_sock := sock[1]
					l_s := -1
					l_size.item := (create {PD_CURL_SOCKADDR_STORAGE}.make).structure_size.to_natural_32
					update_class_fields -- Current might have been changed; synchronize
				when 1 then -- loop condition:
					if (l_return) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						l_timeout_ms := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_timeleft (create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer), (1).to_boolean)
						update_class_fields -- Current might have been changed; synchronize
						if l_timeout_ms < 0 then
							l_data.item.Curl_failf ([ce_string ("Timeout while waiting for server connect")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
							l_return := True
						end
						if l_return then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						l_interval_ms := 1_000
						if l_timeout_ms < l_interval_ms then
							l_interval_ms := l_timeout_ms
						end
						l_tmp := (create {P_SELECT_STATIC}).Curl_socket_ready (l_sock, -1, l_interval_ms.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						inspect l_tmp -- switch 1 head
						when -1 then l_pos := -1 + 4 -- -1
						when 0 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 4 then -- switch 1, case -1
						l_data.item.Curl_failf ([ce_string ("Error while waiting for server connect")])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_FTP_PORT_FAILED)
						l_return := True
				when 5 then -- switch 1, case 0
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
						l_tmp___0 := getsockname (l_sock, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_add), l_size)
						update_class_fields -- Current might have been changed; synchronize
						if 0 = l_tmp___0 then
							l_size.item := (create {PD_CURL_SOCKADDR_STORAGE}.make).structure_size.to_natural_32
							update_class_fields -- Current might have been changed; synchronize
							l_s := accept (l_sock, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_add), l_size)
							update_class_fields -- Current might have been changed; synchronize
						end
						close (l_sock).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if -1 = l_s then
							l_data.item.Curl_failf ([ce_string ("Error accept()ing server connect")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_FTP_PORT_FAILED)
							l_return := True
						end
						if not l_return then
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Connection accepted from server%N")])
							update_class_fields -- Current might have been changed; synchronize
							sock[1] := l_s
							update_class_fields -- Current might have been changed; synchronize
							curlx_nonblock (l_s, 1).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						end
				when 7 then -- switch 1, done: | if done
						l_pos := -1 + 1 -- back to loop condition
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_GetFTPResponse (a_nreadp, a_ftpcode: CE_POINTER [INTEGER_32]): NATURAL_32
		require
			not a_nreadp.is_void
		local
			l_ftpcode: CE_POINTER [INTEGER_32]
			l_sockfd: INTEGER_32
			l_timeout: INTEGER_32
			l_interval_ms: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_result: NATURAL_32
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_nread: CE_ARRAY [NATURAL_32]
			l_cache_skip: INTEGER_32
			l_value_to_be_ignored: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_32]
			l_tmp___1: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_nread.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_value_to_be_ignored.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ftpcode := a_ftpcode
					l_sockfd := sock[0]
					l_data := data
					l_result := {PC_CURLCODE}.CURLE_OK
					l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
					l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))
					l_cache_skip := 0
					l_value_to_be_ignored.item := 0
					update_class_fields -- Current might have been changed; synchronize
					if (not l_ftpcode.is_void) then
						l_ftpcode.item := 0
						update_class_fields -- Current might have been changed; synchronize
					else
						l_ftpcode := l_value_to_be_ignored
					end
					a_nreadp.item := 0
					update_class_fields -- Current might have been changed; synchronize
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						if not (l_ftpcode.item).to_boolean then
							if l_result.to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if:
						l_timeout := l_pp.item.Curl_pp_state_timeout
						update_class_fields -- Current might have been changed; synchronize
						if l_timeout <= 0 then
							l_data.item.Curl_failf ([ce_string ("FTP response timeout")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
							l_return := True
						end
						if l_return then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						l_interval_ms := 1_000
						if l_timeout < l_interval_ms then
							l_interval_ms := l_timeout
						end
						if (l_pp.item.cache).is_void then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not (l_cache_skip < 2) then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else: | _L:
						l_tmp := (create {P_SELECT_STATIC}).Curl_socket_ready (l_sockfd, -1, l_interval_ms.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						inspect l_tmp -- switch 1 head
						when -1 then l_pos := -1 + 8 -- -1
						when 0 then l_pos := -1 + 9
						else l_pos := -1 + 10
						end
				when 8 then -- switch 1, case -1
						l_tmp___0 := errno_location
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.Curl_failf ([ce_string ("FTP response aborted due to select/poll error: %%d"), l_tmp___0.item])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
						l_return := True
				when 9 then -- switch 1, case 0
						if not l_return then
							l_tmp___1 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pgrsUpdate
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___1.to_boolean then
								Result := ({PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK)
								l_return := True
							end
						end
						if not l_return then
							l_continue := True
						end
				when 10 then -- switch 1, default:
						l_pos := -1 + 11 -- switch 1; break
				when 11 then -- switch 1, done:
						if not (l_return or l_break or l_continue) then
							l_result := ftp_readresp (l_sockfd, l_pp, l_ftpcode, l_nread)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if not (l_nread.item).to_boolean then
								if (not (l_pp.item.cache).is_void) then
									l_cache_skip := l_cache_skip + 1
								else
									l_cache_skip := 0
								end
							else
								l_cache_skip := 0
							end
							a_nreadp.item := ((a_nreadp.item).to_natural_32 + l_nread.item).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
				when 12 then -- if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					if not l_return then
						l_break := False
						l_continue := False
						l_pp.item.pending_resp := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						Result := l_result
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_state_user: NATURAL_32
		local
			l_result: NATURAL_32
			l_ftp: CE_POINTER [PD_FTP]
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_ftp := data.item.state.proto.ftp
			if (not (l_ftp.item.user).is_void) then
				l_tmp := l_ftp.item.user
			else
				l_tmp := ce_string ("")
			end
			l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc") + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("USER %%s"), l_tmp])
			update_class_fields -- Current might have been changed; synchronize
			if l_result /= {NATURAL_32} 0 then
				Result := l_result
				l_return := True
			end
			if not l_return then
				state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_USER)
				update_class_fields -- Current might have been changed; synchronize
				data.item.state.ftp_trying_alternative := (0).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	ftp_state_use_port (a_fcmd: NATURAL_32): NATURAL_32
		local
			l_fcmd: NATURAL_32
			l_result: NATURAL_32
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_portsock: INTEGER_32
			l_myhost: CE_ARRAY [INTEGER_8]
			l_ss: CE_ARRAY [PD_CURL_SOCKADDR_STORAGE]
			l_res: CE_POINTER [PD_CURL_ADDRINFO]
			l_ai: CE_POINTER [PD_CURL_ADDRINFO]
			l_sslen: CE_ARRAY [NATURAL_32]
			l_hbuf: CE_ARRAY [INTEGER_8]
			l_sa: CE_POINTER [SD_SOCKADDR]
			l_sa4: CE_POINTER [SD_SOCKADDR_IN]
			l_sa6: CE_POINTER [SD_SOCKADDR_IN6]
			l_tmp: CE_ARRAY [INTEGER_8]
			l_rc: INTEGER_32
			l_error: INTEGER_32
			l_host: CE_POINTER [INTEGER_8]
			l_string_ftpport: CE_POINTER [INTEGER_8]
			l_h: CE_ARRAY [CE_POINTER [PD_CURL_DNS_ENTRY]]
			l_port_min: NATURAL_16
			l_port_max: NATURAL_16
			l_port: NATURAL_16
			l_addr: CE_POINTER [INTEGER_8]
			l_addrlen: NATURAL_32
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___3: NATURAL_32
			l_ip_start: CE_POINTER [INTEGER_8]
			l_ip_end: CE_POINTER [INTEGER_8]
			l_port_start: CE_POINTER [INTEGER_8]
			l_port_sep: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___5: INTEGER_32
			l_tmp___6: NATURAL_32
			l_tmp___7: NATURAL_32
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: NATURAL_32
			l_tmp___10: CE_POINTER [INTEGER_32]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: INTEGER_32
			l_tmp___13: CE_POINTER [INTEGER_32]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_32]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: CE_POINTER [INTEGER_32]
			l_tmp___18: CE_POINTER [INTEGER_8]
			l_tmp___19: INTEGER_32
			l_tmp___20: CE_POINTER [INTEGER_8]
			l_tmp___21: INTEGER_32
			l_tmp___22: CE_POINTER [INTEGER_32]
			l_tmp___23: CE_POINTER [INTEGER_8]
			l_tmp___24: INTEGER_32
			l_tmp___25: CE_POINTER [INTEGER_32]
			l_tmp___26: CE_POINTER [INTEGER_8]
			l_tmp___27: INTEGER_32
			l_tmp___28: INTEGER_32
			l_source: CE_POINTER [INTEGER_8]
			l_dest: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_myhost.make (<<256>>)
			create {CE_CLASS_ARRAY [PD_CURL_SOCKADDR_STORAGE]} l_ss.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_sslen.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_hbuf.make (<<1_025>>)
			create {CE_INTEGER_8_ARRAY} l_tmp.make (<<1_024>>)
			create {CE_POINTER_ARRAY [PD_CURL_DNS_ENTRY]} l_h.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fcmd := a_fcmd
					l_result := {PC_CURLCODE}.CURLE_OK
					l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
					l_data := data
					l_portsock := -1
					l_myhost[0] := (('%/0/').code).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_sa := create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_ss)
					l_sa4 := create {CE_CLASS_POINTER [SD_SOCKADDR_IN]}.make_cast (l_sa)
					l_sa6 := create {CE_CLASS_POINTER [SD_SOCKADDR_IN6]}.make_cast (l_sa)
					l_host := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_string_ftpport := l_data.item.set.str[9]
					l_h.item := create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					l_port_min := (0).to_natural_16
					l_port_max := (0).to_natural_16
					l_addr := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					if (not (l_data.item.set.str[9]).is_void) then
						l_tmp___9 := strlen (l_data.item.set.str[9])
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___9 > {NATURAL_32} 1 then
							l_tmp___3 := strlen (l_string_ftpport)
							update_class_fields -- Current might have been changed; synchronize
							if {NATURAL_32} 46 > l_tmp___3 then
								l_tmp___2 := (46).to_natural_32
							else
								l_tmp___1 := strlen (l_string_ftpport)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___2 := l_tmp___1
							end
							l_addrlen := l_tmp___2
							l_ip_start := l_string_ftpport
							l_ip_end := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_port_start := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_port_sep := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_tmp___4 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([l_addrlen + {NATURAL_32} 1, (1).to_natural_32]))
							update_class_fields -- Current might have been changed; synchronize
							l_addr := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___4)
							if l_addr.is_void then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								l_return := True
							end
							if not l_return then
								if (l_string_ftpport[0]).to_integer_32 = 91 then
									l_ip_start := l_string_ftpport + 1
									l_ip_end := strchr (l_string_ftpport, (']').code)
									update_class_fields -- Current might have been changed; synchronize
									if not l_ip_end.is_void then
										strncpy (l_addr, l_ip_start, (l_ip_end.distance (l_ip_start)).to_natural_32).do_nothing
										update_class_fields -- Current might have been changed; synchronize
									end
								elseif (l_string_ftpport[0]).to_integer_32 = 58 then
									l_ip_end := l_string_ftpport
								else
									l_ip_end := strchr (l_string_ftpport, (':').code)
									update_class_fields -- Current might have been changed; synchronize
									if not l_ip_end.is_void then
										l_tmp___5 := inet_pton (10, l_string_ftpport, create {CE_VOID_POINTER}.make_cast (l_sa6))
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___5 = 1 then
											l_port_max := (0).to_natural_16
											l_port_min := l_port_max
											strcpy (l_addr, l_string_ftpport).do_nothing
											update_class_fields -- Current might have been changed; synchronize
											l_ip_end := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
										else
											strncpy (l_addr, l_string_ftpport, (l_ip_end.distance (l_ip_start)).to_natural_32).do_nothing
											update_class_fields -- Current might have been changed; synchronize
										end
									else
										strcpy (l_addr, l_string_ftpport).do_nothing
										update_class_fields -- Current might have been changed; synchronize
									end
								end
								if not l_ip_end.is_void then
									l_port_start := strchr (l_ip_end, (':').code)
									update_class_fields -- Current might have been changed; synchronize
									if not l_port_start.is_void then
										l_tmp___6 := strtoul ((l_port_start + 1), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10)
										update_class_fields -- Current might have been changed; synchronize
										l_port_min := (create {P_WARNLESS_STATIC}).curlx_ultous (l_tmp___6)
										update_class_fields -- Current might have been changed; synchronize
										l_port_sep := strchr (l_port_start, ('-').code)
										update_class_fields -- Current might have been changed; synchronize
										if not l_port_sep.is_void then
											l_tmp___7 := strtoul ((l_port_sep + 1), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10)
											update_class_fields -- Current might have been changed; synchronize
											l_port_max := (create {P_WARNLESS_STATIC}).curlx_ultous (l_tmp___7)
											update_class_fields -- Current might have been changed; synchronize
										else
											l_port_max := l_port_min
										end
									end
								end
								if l_port_min.to_integer_32 > l_port_max.to_integer_32 then
									l_port_max := (0).to_natural_16
									l_port_min := l_port_max
								end
								if (l_addr[0]).to_integer_32 /= 0 then
									l_tmp___8 := Curl_if2ip (ip_addr.item.ai_family, l_addr, l_hbuf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (1_025).to_natural_32).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									if (not l_tmp___8.is_void) then
										l_host := l_hbuf
									else
										l_host := l_addr
									end
								else
									l_host := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								end
							end
						end
					end
					if not (not l_return and then (l_host.is_void)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_sslen.item := (create {PD_CURL_SOCKADDR_STORAGE}.make).structure_size.to_natural_32
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___12 := getsockname (sock[0], l_sa, l_sslen)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___12.to_boolean then
							l_tmp___10 := errno_location
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___11 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_tmp___10.item)
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.Curl_failf ([ce_string ("getsockname() failed: %%s"), l_tmp___11])
							update_class_fields -- Current might have been changed; synchronize
							if (not l_addr.is_void) then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_addr)])
								update_class_fields -- Current might have been changed; synchronize
							end
							Result := ({PC_CURLCODE}.CURLE_FTP_PORT_FAILED)
							l_return := True
						end
						if l_return then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						inspect (l_sa.item.sa_family).to_integer_32 -- switch 1 head
						when 10 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 3 then -- switch 1, case 10
						inet_ntop ((l_sa.item.sa_family).to_integer_32, create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN6_ADDR]}.make_shared (l_sa6.c_pointer + (create {SD_SOCKADDR_IN6}.make).offset_of ("sin6_addr")))), l_hbuf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (1_025).to_natural_32)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:
						inet_ntop ((l_sa.item.sa_family).to_integer_32, create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN_ADDR]}.make_shared (l_sa4.c_pointer + (create {SD_SOCKADDR_IN}.make).offset_of ("sin_addr")))), l_hbuf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (1_025).to_natural_32)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
						l_host := l_hbuf
				when 6 then -- if done | if done
					if not l_return then
						l_rc := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_resolv (l_host, 0, l_h)
						update_class_fields -- Current might have been changed; synchronize
						if l_rc = 1 then
							(create {P_HOSTSYN_STATIC}).Curl_wait_for_resolv ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_h).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not (l_h.item).is_void) then
							l_res := l_h.item.item.addr
							l_data.item.Curl_resolv_unlock (l_h.item)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_res := create {CE_CLASS_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
						end
						if (not l_addr.is_void) then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_addr)])
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_res.is_void then
							l_data.item.Curl_failf ([ce_string ("Curl_resolv failed, we can not recover!")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_FTP_PORT_FAILED)
							l_return := True
						end
					end
					if not l_return then
						l_portsock := -1
						l_error := 0
						l_ai := l_res
						from
						until
							not (not (l_break) and then (not l_ai.is_void))
						loop
							l_break := False
							l_continue := False
							if l_ai.item.ai_socktype = 0 then
								l_ai.item.ai_socktype := socktype
								update_class_fields -- Current might have been changed; synchronize
							end
							l_portsock := socket (l_ai.item.ai_family, l_ai.item.ai_socktype, l_ai.item.ai_protocol)
							update_class_fields -- Current might have been changed; synchronize
							if l_portsock = -1 then
								l_tmp___13 := errno_location
								update_class_fields -- Current might have been changed; synchronize
								l_error := l_tmp___13.item
								l_continue := True
							end
							if not (l_break or l_continue) then
								l_break := True
							end
							if (not l_break) then
								l_ai := l_ai.item.ai_next
							end
						end
						l_break := False
						l_continue := False
						if l_ai.is_void then
							l_tmp___14 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_error)
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.Curl_failf ([ce_string ("socket failure: %%s"), l_tmp___14])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_FTP_PORT_FAILED)
							l_return := True
						end
					end
					if not l_return then
						memcpy (create {CE_VOID_POINTER}.make_cast (l_sa), create {CE_VOID_POINTER}.make_cast (l_ai.item.ai_addr), l_ai.item.ai_addrlen).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_sslen.item := l_ai.item.ai_addrlen
						update_class_fields -- Current might have been changed; synchronize
						l_port := l_port_min
						from
						until
							not (not (l_return or l_break) and then (l_port.to_integer_32 <= l_port_max.to_integer_32))
						loop
							l_break := False
							l_continue := False
							if (l_sa.item.sa_family).to_integer_32 = 2 then
								l_sa4.item.sin_port := htons (l_port)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_sa6.item.sin6_port := htons (l_port)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_tmp___21 := bind (l_portsock, l_sa, l_sslen.item)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___21.to_boolean then
								l_tmp___15 := errno_location
								update_class_fields -- Current might have been changed; synchronize
								l_error := l_tmp___15.item
								if l_error = 99 then
									l_tmp___16 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_error)
									update_class_fields -- Current might have been changed; synchronize
									l_data.item.Curl_failf ([ce_string ("bind(port=%%hu) failed: %%s"), l_port.to_integer_32, l_tmp___16])
									update_class_fields -- Current might have been changed; synchronize
									l_sslen.item := (create {PD_CURL_SOCKADDR_STORAGE}.make).structure_size.to_natural_32
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___19 := getsockname (sock[0], l_sa, l_sslen)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___19.to_boolean then
										l_tmp___17 := errno_location
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___18 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_tmp___17.item)
										update_class_fields -- Current might have been changed; synchronize
										l_data.item.Curl_failf ([ce_string ("getsockname() failed: %%s"), l_tmp___18])
										update_class_fields -- Current might have been changed; synchronize
										close (l_portsock).do_nothing
										update_class_fields -- Current might have been changed; synchronize
										Result := ({PC_CURLCODE}.CURLE_FTP_PORT_FAILED)
										l_return := True
									end
									if not l_return then
										l_port := l_port_min
										l_continue := True
									end
								elseif l_error /= 98 then
									if l_error /= 13 then
										l_tmp___20 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_error)
										update_class_fields -- Current might have been changed; synchronize
										l_data.item.Curl_failf ([ce_string ("bind(port=%%hu) failed: %%s"), l_port.to_integer_32, l_tmp___20])
										update_class_fields -- Current might have been changed; synchronize
										close (l_portsock).do_nothing
										update_class_fields -- Current might have been changed; synchronize
										Result := ({PC_CURLCODE}.CURLE_FTP_PORT_FAILED)
										l_return := True
									end
								end
							else
								l_break := True
							end
							if not l_return then
								if not (l_return or l_break or l_continue) then
									l_port := (l_port.to_integer_32 + 1).to_natural_16
								end
								if (not l_return and not l_break) then
									
								end
							end
						end
					end
					if not l_return then
						l_break := False
						l_continue := False
						if l_port.to_integer_32 > l_port_max.to_integer_32 then
							l_data.item.Curl_failf ([ce_string ("bind() failed, we ran out of ports!")])
							update_class_fields -- Current might have been changed; synchronize
							close (l_portsock).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_FTP_PORT_FAILED)
							l_return := True
						end
					end
					if not l_return then
						l_sslen.item := (create {PD_CURL_SOCKADDR_STORAGE}.make).structure_size.to_natural_32
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___24 := getsockname (l_portsock, l_sa, l_sslen)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___24.to_boolean then
							l_tmp___22 := errno_location
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___23 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_tmp___22.item)
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.Curl_failf ([ce_string ("getsockname() failed: %%s"), l_tmp___23])
							update_class_fields -- Current might have been changed; synchronize
							close (l_portsock).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_FTP_PORT_FAILED)
							l_return := True
						end
					end
					if not l_return then
						l_tmp___27 := listen (l_portsock, 1)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___27.to_boolean then
							l_tmp___25 := errno_location
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___26 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_tmp___25.item)
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.Curl_failf ([ce_string ("socket failure: %%s"), l_tmp___26])
							update_class_fields -- Current might have been changed; synchronize
							close (l_portsock).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_FTP_PORT_FAILED)
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 15 -- skip if block
					end
				when 7 then -- if:
						Curl_printable_address (l_ai, l_myhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if not bits.ftp_use_eprt then
							if bits.ipv6 then
								bits.ftp_use_eprt := (1).to_boolean
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 8 then -- loop condition:
						if not (not (l_return or l_break) and then (l_fcmd /= {NATURAL_32} 2)) then
							l_pos := -1 + 15 -- skip loop
						end
				when 9 then -- loop body:
						l_break := False
						l_continue := False
						if not bits.ftp_use_eprt then
							if {NATURAL_32} 0 = l_fcmd then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) and then ({NATURAL_32} 1 = l_fcmd) then
							if (l_sa.item.sa_family).to_integer_32 /= 2 then
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 14 -- skip if block
						end
				when 10 then -- if:
						inspect (l_sa.item.sa_family).to_integer_32 -- switch 2 head
						when 2 then l_pos := -1 + 11
						when 10 then l_pos := -1 + 12
						else l_pos := -1 + 13
						end
				when 11 then -- switch 2, case 2
						l_port := ntohs (l_sa4.item.sin_port)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 14 -- switch 2; break
				when 12 then -- switch 2, case 10
						l_port := ntohs (l_sa6.item.sin6_port)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 14 -- switch 2; break
				when 13 then -- switch 2, default:
						l_continue := True
				when 14 then -- switch 2, done: | if done
						if not (l_return or l_break or l_continue) then
							if {NATURAL_32} 0 = l_fcmd then
								if (l_sa.item.sa_family).to_integer_32 = 2 then
									l_tmp___28 := 1
								else
									l_tmp___28 := 2
								end
								l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("%%s |%%d|%%s|%%hu|"), mode.item[l_fcmd.to_integer_32], l_tmp___28, l_myhost, l_port.to_integer_32])
								update_class_fields -- Current might have been changed; synchronize
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
								if not l_return then
									l_break := True
								end
							elseif {NATURAL_32} 1 = l_fcmd then
								l_source := l_myhost
								l_dest := l_tmp
								from
								until
									(l_break)
								loop
									l_break := False
									if (not l_source.is_void) then
										if not (l_source[0]).to_boolean then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										if (l_source[0]).to_integer_32 = 46 then
											l_dest[0] := ((',').code).to_integer_8
											update_class_fields -- Current might have been changed; synchronize
										else
											l_dest[0] := l_source[0]
											update_class_fields -- Current might have been changed; synchronize
										end
										l_dest := l_dest + 1
										l_source := l_source + 1
									end
								end
								l_break := False
								l_dest[0] := (0).to_integer_8
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_dest, (20).to_natural_32, ce_string (",%%d,%%d"), (l_port.to_integer_32).bit_shift_right (8), (l_port.to_integer_32).bit_and (255)]).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("%%s %%s"), mode.item[l_fcmd.to_integer_32], l_tmp])
								update_class_fields -- Current might have been changed; synchronize
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
								if not l_return then
									l_break := True
								end
							end
						end
						if (not l_return and not l_break) then
							l_fcmd := (l_fcmd + {NATURAL_32} 1)
						end
						l_pos := -1 + 8 -- back to loop condition
				when 15 then -- loop done | if done
					if not l_return then
						l_break := False
						l_continue := False
						l_ftpc.item.count1 := l_fcmd.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						if -1 /= sock[1] then
							close (sock[1]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						sock[1] := l_portsock
						update_class_fields -- Current might have been changed; synchronize
						bits.tcpconnect := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_PORT)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_result
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_state_use_pasv: NATURAL_32
		local
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_result: NATURAL_32
			l_modeoff: INTEGER_32
			l_return: BOOLEAN
		do
			l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
			l_result := {PC_CURLCODE}.CURLE_OK
			if not bits.ftp_use_epsv then
				if bits.ipv6 then
					bits.ftp_use_epsv := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if bits.ftp_use_epsv then
				l_modeoff := 0
			else
				l_modeoff := 1
			end
			l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("%%s"), mode___0.item[l_modeoff]])
			update_class_fields -- Current might have been changed; synchronize
			if l_result /= {NATURAL_32} 0 then
				Result := l_result
				l_return := True
			end
			if not l_return then
				l_ftpc.item.count1 := l_modeoff
				update_class_fields -- Current might have been changed; synchronize
				state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_PASV)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SENDF_STATIC}).Curl_infof ([data, ce_string ("Connect data stream passively%N")])
				update_class_fields -- Current might have been changed; synchronize
				Result := l_result
			end
		end

	ftp_state_post_rest: NATURAL_32
		local
			l_result: NATURAL_32
			l_ftp: CE_POINTER [PD_FTP]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_ftp := data.item.state.proto.ftp
			l_data := data
			if l_ftp.item.transfer /= {NATURAL_32} 0 then
				state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_RETR_PREQUOTE)
				update_class_fields -- Current might have been changed; synchronize
				l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_quote ((1).to_boolean, {PC_FTPSTATE}.FTP_RETR_PREQUOTE)
				update_class_fields -- Current might have been changed; synchronize
			elseif l_data.item.set.ftp_use_port then
				l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_use_port ({PC_FTPPORT}.EPRT)
				update_class_fields -- Current might have been changed; synchronize
			elseif l_data.item.set.ftp_use_pret then
				if (proto.ftpc.file).is_void then
					if (not (l_data.item.set.str[4]).is_void) then
						l_tmp___0 := l_data.item.set.str[4]
					else
						if l_data.item.set.ftp_list_only then
							l_tmp := ce_string ("NLST")
						else
							l_tmp := ce_string ("LIST")
						end
						l_tmp___0 := l_tmp
					end
					l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc") + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("PRET %%s"), l_tmp___0])
					update_class_fields -- Current might have been changed; synchronize
					if l_result /= {NATURAL_32} 0 then
						Result := l_result
						l_return := True
					end
				elseif l_data.item.set.upload then
					l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc") + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("PRET STOR %%s"), proto.ftpc.file])
					update_class_fields -- Current might have been changed; synchronize
					if l_result /= {NATURAL_32} 0 then
						Result := l_result
						l_return := True
					end
				else
					l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc") + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("PRET RETR %%s"), proto.ftpc.file])
					update_class_fields -- Current might have been changed; synchronize
					if l_result /= {NATURAL_32} 0 then
						Result := l_result
						l_return := True
					end
				end
				if not l_return then
					state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_PRET)
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_use_pasv
				update_class_fields -- Current might have been changed; synchronize
			end
			if not l_return then
				Result := l_result
			end
		end

	ftp_state_post_size: NATURAL_32
		local
			l_result: NATURAL_32
			l_ftp: CE_POINTER [PD_FTP]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_ftp := data.item.state.proto.ftp
			l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
			if l_ftp.item.transfer /= {NATURAL_32} 0 then
				if (not (l_ftpc.item.file).is_void) then
					l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc") + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("REST %%d"), 0])
					update_class_fields -- Current might have been changed; synchronize
					if l_result /= {NATURAL_32} 0 then
						Result := l_result
						l_return := True
					end
					if not l_return then
						state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_REST)
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_rest
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_rest
				update_class_fields -- Current might have been changed; synchronize
			end
			if not l_return then
				Result := l_result
			end
		end

	ftp_state_post_type: NATURAL_32
		local
			l_result: NATURAL_32
			l_ftp: CE_POINTER [PD_FTP]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_ftp := data.item.state.proto.ftp
			l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
			if l_ftp.item.transfer = {NATURAL_32} 1 then
				if (not (l_ftpc.item.file).is_void) then
					l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("SIZE %%s"), l_ftpc.item.file])
					update_class_fields -- Current might have been changed; synchronize
					if l_result /= {NATURAL_32} 0 then
						Result := l_result
						l_return := True
					end
					if not l_return then
						state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_SIZE)
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_size
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_size
				update_class_fields -- Current might have been changed; synchronize
			end
			if not l_return then
				Result := l_result
			end
		end

	ftp_state_post_listtype: NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_cmd: CE_POINTER [INTEGER_8]
			l_lstArg: CE_POINTER [INTEGER_8]
			l_slashPos: CE_POINTER [INTEGER_8]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			l_lstArg := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			if l_data.item.set.ftp_filemethod = {NATURAL_32} 2 then
				if (not (l_data.item.state.path).is_void) then
					if (l_data.item.state.path[0]).to_boolean then
						l_tmp___0 := strchr (l_data.item.state.path, ('/').code)
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp___0.is_void) then
							l_lstArg := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_data.item.state.path]))
							update_class_fields -- Current might have been changed; synchronize
							if l_lstArg.is_void then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								l_return := True
							end
							if not l_return then
								l_tmp := strlen (l_lstArg)
								update_class_fields -- Current might have been changed; synchronize
								if (l_lstArg[(l_tmp - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 47 then
									l_slashPos := strrchr (l_lstArg, ('/').code)
									update_class_fields -- Current might have been changed; synchronize
									if (not l_slashPos.is_void) then
										l_slashPos[1] := (('%/0/').code).to_integer_8
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
						end
					end
				end
			end
			if not l_return then
				if (not l_lstArg.is_void) then
					l_tmp___1 := l_lstArg
				else
					l_tmp___1 := ce_string ("")
				end
				if (not l_lstArg.is_void) then
					l_tmp___2 := ce_string (" ")
				else
					l_tmp___2 := ce_string ("")
				end
				if (not (l_data.item.set.str[4]).is_void) then
					l_tmp___4 := l_data.item.set.str[4]
				else
					if l_data.item.set.ftp_list_only then
						l_tmp___3 := ce_string ("NLST")
					else
						l_tmp___3 := ce_string ("LIST")
					end
					l_tmp___4 := l_tmp___3
				end
				l_cmd := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%s%%s%%s"), l_tmp___4, l_tmp___2, l_tmp___1])
				update_class_fields -- Current might have been changed; synchronize
				if l_cmd.is_void then
					if (not l_lstArg.is_void) then
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_lstArg)])
						update_class_fields -- Current might have been changed; synchronize
					end
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc") + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("%%s"), l_cmd])
				update_class_fields -- Current might have been changed; synchronize
				if l_result /= {NATURAL_32} 0 then
					Result := l_result
					l_return := True
				end
			end
			if not l_return then
				if (not l_lstArg.is_void) then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_lstArg)])
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_cmd)])
				update_class_fields -- Current might have been changed; synchronize
				state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_LIST)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_result
			end
		end

	ftp_state_post_mdtm: NATURAL_32
		local
			l_result: NATURAL_32
			l_ftp: CE_POINTER [PD_FTP]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_ftp := data.item.state.proto.ftp
			l_data := data
			l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
			if l_data.item.set.opt_no_body then
				if (not (l_ftpc.item.file).is_void) then
					l_tmp := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_need_type (l_data.item.set.prefer_ascii)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						l_ftp.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_INFO
						update_class_fields -- Current might have been changed; synchronize
						l_result := ftp_nb_type ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_data.item.set.prefer_ascii, {PC_FTPSTATE}.FTP_TYPE)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					else
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_type
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_type
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_type
				update_class_fields -- Current might have been changed; synchronize
			end
			if not l_return then
				Result := l_result
			end
		end

	ftp_state_post_cwd: NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data := data
					l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
					if not (l_data.item.set.get_filetime) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not ((l_data.item.set.timecondition).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if (not (l_ftpc.item.file).is_void) then
							l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("MDTM %%s"), l_ftpc.item.file])
							update_class_fields -- Current might have been changed; synchronize
							if l_result /= {NATURAL_32} 0 then
								Result := l_result
								l_return := True
							end
							if not l_return then
								state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_MDTM)
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_mdtm
							update_class_fields -- Current might have been changed; synchronize
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_mdtm
						update_class_fields -- Current might have been changed; synchronize
				when 7 then -- if done
					if not l_return then
						Result := l_result
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_state_ul_setup (a_sizechecked: BOOLEAN): NATURAL_32
		local
			l_result: NATURAL_32
			l_ftp: CE_POINTER [PD_FTP]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_seekerr: INTEGER_32
			l_passed: INTEGER_64
			l_readthisamountnow: INTEGER_64
			l_actuallyread: INTEGER_64
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_ftp := data.item.state.proto.ftp
					l_data := data
					l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
					l_seekerr := 0
					if not ((l_data.item.state.resume_from).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not a_sizechecked then
							l_pos := -1 + 5 -- goto _L
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 3 then -- else: | _L___0:
						if not (l_data.item.state.resume_from > {INTEGER_64} 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not a_sizechecked then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if l_data.item.state.resume_from < {INTEGER_64} 0 then
							l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("SIZE %%s"), l_ftpc.item.file])
							update_class_fields -- Current might have been changed; synchronize
							if l_result /= {NATURAL_32} 0 then
								Result := l_result
								l_return := True
							end
							if not l_return then
								state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_STOR_SIZE)
								update_class_fields -- Current might have been changed; synchronize
								Result := l_result
								l_return := True
							end
						end
						if not l_return then
							l_data.item.set.ftp_append := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							if (not seek_func.is_void) then
								l_seekerr := seek_func.integer_32_item ([seek_client, l_data.item.state.resume_from, 0])
								update_class_fields -- Current might have been changed; synchronize
							end
							if l_seekerr /= 0 then
								if l_seekerr /= 2 then
									l_data.item.Curl_failf ([ce_string ("Could not seek stream")])
									update_class_fields -- Current might have been changed; synchronize
									Result := ({PC_CURLCODE}.CURLE_FTP_COULDNT_USE_REST)
									l_return := True
								else
									l_passed := (0).to_integer_64
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										l_readthisamountnow := l_data.item.state.resume_from - l_passed
										if l_readthisamountnow > {INTEGER_64} 16_384 then
											l_readthisamountnow := (16_384).to_integer_64
										end
										l_tmp := fread_func.natural_32_item ([l_data.item.state.buffer, (1).to_natural_32, l_readthisamountnow.to_natural_32, fread_in])
										update_class_fields -- Current might have been changed; synchronize
										l_actuallyread := l_tmp.to_integer_64
										l_passed := l_passed + l_actuallyread
										if l_actuallyread <= {INTEGER_64} 0 then
											l_data.item.Curl_failf ([ce_string ("Failed to read data")])
											update_class_fields -- Current might have been changed; synchronize
											Result := ({PC_CURLCODE}.CURLE_FTP_COULDNT_USE_REST)
											l_return := True
										elseif l_actuallyread > l_readthisamountnow then
											l_data.item.Curl_failf ([ce_string ("Failed to read data")])
											update_class_fields -- Current might have been changed; synchronize
											Result := ({PC_CURLCODE}.CURLE_FTP_COULDNT_USE_REST)
											l_return := True
										end
										if not l_return and then (not (l_passed < l_data.item.state.resume_from)) then
											l_break := True
										end
									end
									if not l_return then
										l_break := False
									end
								end
							end
						end
						if not l_return and then (l_data.item.set.infilesize > {INTEGER_64} 0) then
							l_data.item.set.infilesize := l_data.item.set.infilesize - (l_data.item.state.resume_from)
							update_class_fields -- Current might have been changed; synchronize
							if l_data.item.set.infilesize <= {INTEGER_64} 0 then
								(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("File already completely uploaded%N")])
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (-1, (-1).to_integer_64, (0).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer), -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
								l_ftp.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_NONE
								update_class_fields -- Current might have been changed; synchronize
								state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_STOP)
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_OK)
								l_return := True
							end
						end
				when 6 then -- if done | if done
					if not l_return then
						if l_data.item.set.ftp_append then
							l_tmp___0 := ce_string ("APPE %%s")
						else
							l_tmp___0 := ce_string ("STOR %%s")
						end
						l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([l_tmp___0, l_ftpc.item.file])
						update_class_fields -- Current might have been changed; synchronize
						if l_result /= {NATURAL_32} 0 then
							Result := l_result
							l_return := True
						end
					end
					if not l_return then
						state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_STOR)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_result
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_state_quote (a_init: BOOLEAN; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ftp: CE_POINTER [PD_FTP]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_quote: BOOLEAN
			l_item: CE_POINTER [PD_CURL_SLIST]
			l_i: INTEGER_32
			l_cmd: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data := data
					l_ftp := l_data.item.state.proto.ftp
					l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
					l_quote := (0).to_boolean
					inspect a_instate.to_integer_32 -- switch 1 head
					when 13 then l_pos := -1 + 2
					when 14 then l_pos := -1 + 2
					when 15 then l_pos := -1 + 3
					else l_pos := -1 + 1
					end
				when 1 then -- switch 1, default:
					l_item := l_data.item.set.quote
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 13 | switch 1, case 14
					l_item := l_data.item.set.prequote
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 15
					l_item := l_data.item.set.postquote
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					if a_init then
						l_ftpc.item.count1 := 0
						update_class_fields -- Current might have been changed; synchronize
					else
						l_ftpc.item.count1 := (l_ftpc.item.count1) + 1
						update_class_fields -- Current might have been changed; synchronize
					end
					if (not l_item.is_void) then
						l_i := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if l_i < l_ftpc.item.count1 then
								if l_item.is_void then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_item := l_item.item.next
								l_i := l_i + 1
							end
						end
						l_break := False
						if (not l_item.is_void) then
							l_cmd := l_item.item.data
							if (l_cmd[0]).to_integer_32 = 42 then
								l_cmd := l_cmd + 1
								l_ftpc.item.count2 := 1
								update_class_fields -- Current might have been changed; synchronize
							else
								l_ftpc.item.count2 := 0
								update_class_fields -- Current might have been changed; synchronize
							end
							l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("%%s"), l_cmd])
							update_class_fields -- Current might have been changed; synchronize
							if l_result /= {NATURAL_32} 0 then
								Result := l_result
								l_return := True
							end
							if not l_return then
								state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), a_instate)
								update_class_fields -- Current might have been changed; synchronize
								l_quote := (1).to_boolean
							end
						end
					end
					if not (not l_return and then (not l_quote)) then
						l_pos := -1 + 10 -- skip if block
					end
				when 5 then -- if:
						inspect a_instate.to_integer_32 -- switch 2 head
						when 13 then l_pos := -1 + 7
						when 14 then l_pos := -1 + 8
						when 15 then l_pos := -1 + 9
						else l_pos := -1 + 6
						end
				when 6 then -- switch 2, default:
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_cwd
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 10 -- switch 2; break
				when 7 then -- switch 2, case 13
						if l_ftp.item.transfer /= {NATURAL_32} 0 then
							state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_STOP)
							update_class_fields -- Current might have been changed; synchronize
						elseif l_ftpc.item.known_filesize /= -{INTEGER_64} 1 then
							l_data.item.Curl_pgrsSetDownloadSize (l_ftpc.item.known_filesize)
							update_class_fields -- Current might have been changed; synchronize
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_retr_size (l_ftpc.item.known_filesize)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("SIZE %%s"), l_ftpc.item.file])
							update_class_fields -- Current might have been changed; synchronize
							if l_result /= {NATURAL_32} 0 then
								Result := l_result
								l_return := True
							end
							if not l_return then
								state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_RETR_SIZE)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_pos := -1 + 10 -- switch 2; break
				when 8 then -- switch 2, case 14
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_ul_setup ((0).to_boolean)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 10 -- switch 2; break
				when 9 then -- switch 2, case 15
						l_pos := -1 + 10 -- switch 2; break
				when 10 then -- switch 2, done: | if done
					if not l_return then
						Result := l_result
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_state_pasv_resp (a_ftpcode: INTEGER_32): NATURAL_32
		local
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_conninfo: CE_ARRAY [CE_POINTER [PD_CURL_ADDRINFO]]
			l_addr: CE_ARRAY [CE_POINTER [PD_CURL_DNS_ENTRY]]
			l_rc: INTEGER_32
			l_connectport: NATURAL_16
			l_newport: NATURAL_16
			l_connected: CE_ARRAY [BOOLEAN]
			l_newhost: CE_ARRAY [INTEGER_8]
			l_str: CE_POINTER [INTEGER_8]
			l_ptr: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_num: CE_ARRAY [NATURAL_32]
			l_separator: CE_ARRAY [INTEGER_8]
			l_sep1: INTEGER_8
			l_i: INTEGER_32
			l_tmp___0: INTEGER_32
			l_ip: CE_ARRAY [INTEGER_32]
			l_port: CE_ARRAY [INTEGER_32]
			l_tmp___1: INTEGER_32
			l_http_proxy: CE_ARRAY [PD_HTTP]
			l_ftp_save: CE_POINTER [PD_FTP]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_CURL_ADDRINFO]} l_conninfo.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_CURL_DNS_ENTRY]} l_addr.make (<<1>>)
			create {CE_BOOLEAN_ARRAY} l_connected.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_newhost.make (<<48>>)
			create {CE_NATURAL_32_ARRAY} l_num.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_separator.make (<<4>>)
			create {CE_INTEGER_32_ARRAY} l_ip.make (<<4>>)
			create {CE_INTEGER_32_ARRAY} l_port.make (<<2>>)
			create {CE_CLASS_ARRAY [PD_HTTP]} l_http_proxy.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
					l_data := data
					l_addr.item := create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					l_newport := (0).to_natural_16
					l_str := create {CE_INTEGER_8_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("buffer") + {PLATFORM}.Integer_8_bytes * (4))
					if l_ftpc.item.count1 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_ftpcode = 229 then
							l_tmp := strchr (l_str, ('(').code)
							update_class_fields -- Current might have been changed; synchronize
							l_ptr := l_tmp
							if (not l_ptr.is_void) then
								l_ptr := l_ptr + 1
								l_tmp___0 := sscanf ([l_ptr, ce_string ("%%c%%c%%c%%u%%c"), l_separator + 0, l_separator + 1, l_separator + 2, l_num, l_separator + 3])
								update_class_fields -- Current might have been changed; synchronize
								if 5 = l_tmp___0 then
									l_sep1 := l_separator[0]
									l_i := 1
									from
									until
										not (not (l_break) and then (l_i < 4))
									loop
										l_break := False
										if (l_separator[l_i]).to_integer_32 /= l_sep1.to_integer_32 then
											l_ptr := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											l_break := True
										end
										if not (l_break) then
											l_i := l_i + 1
										end
									end
									l_break := False
									if (not l_ptr.is_void) then
										l_newport := ((l_num.item).bit_and ({NATURAL_32} 65_535)).to_natural_16
										if bits.tunnel_proxy then
											(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_newhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (48).to_natural_32), ce_string ("%%s"), host.name]).do_nothing
											update_class_fields -- Current might have been changed; synchronize
										elseif l_data.item.set.proxytype = {NATURAL_32} 5 then
											(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_newhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (48).to_natural_32), ce_string ("%%s"), host.name]).do_nothing
											update_class_fields -- Current might have been changed; synchronize
										elseif l_data.item.set.proxytype = {NATURAL_32} 7 then
											(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_newhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (48).to_natural_32), ce_string ("%%s"), host.name]).do_nothing
											update_class_fields -- Current might have been changed; synchronize
										elseif l_data.item.set.proxytype = {NATURAL_32} 4 then
											(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_newhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (48).to_natural_32), ce_string ("%%s"), host.name]).do_nothing
											update_class_fields -- Current might have been changed; synchronize
										elseif l_data.item.set.proxytype = {NATURAL_32} 6 then
											(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_newhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (48).to_natural_32), ce_string ("%%s"), host.name]).do_nothing
											update_class_fields -- Current might have been changed; synchronize
										else
											(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_newhost, (48).to_natural_32, ce_string ("%%s"), ip_addr_str]).do_nothing
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								else
									l_ptr := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								end
							end
							if l_ptr.is_void then
								l_data.item.Curl_failf ([ce_string ("Weirdly formatted EPSV reply")])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_FTP_WEIRD_PASV_REPLY)
								l_return := True
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else: | _L___0:
						if l_ftpc.item.count1 /= 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_ftpcode = 227 then
							from
							until
								not (not (l_break) and then ((l_str[0]).to_boolean))
							loop
								l_break := False
								l_tmp___1 := sscanf ([l_str, ce_string ("%%d,%%d,%%d,%%d,%%d,%%d"), l_ip + 0, l_ip + 1, l_ip + 2, l_ip + 3, l_port + 0, l_port + 1])
								update_class_fields -- Current might have been changed; synchronize
								if 6 = l_tmp___1 then
									l_break := True
								end
								if not (l_break) then
									l_str := l_str + 1
								end
							end
							l_break := False
							if not (l_str[0]).to_boolean then
								l_data.item.Curl_failf ([ce_string ("Couldn%'t interpret the 227-response")])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_FTP_WEIRD_227_FORMAT)
								l_return := True
							end
							if not l_return then
								if l_data.item.set.ftp_skip_ip then
									(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Skips %%d.%%d.%%d.%%d for data connection, uses %%s instead%N"), l_ip[0], l_ip[1], l_ip[2], l_ip[3], ip_addr_str])
									update_class_fields -- Current might have been changed; synchronize
									if bits.tunnel_proxy then
										(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_newhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (48).to_natural_32), ce_string ("%%s"), host.name]).do_nothing
										update_class_fields -- Current might have been changed; synchronize
									elseif l_data.item.set.proxytype = {NATURAL_32} 5 then
										(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_newhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (48).to_natural_32), ce_string ("%%s"), host.name]).do_nothing
										update_class_fields -- Current might have been changed; synchronize
									elseif l_data.item.set.proxytype = {NATURAL_32} 7 then
										(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_newhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (48).to_natural_32), ce_string ("%%s"), host.name]).do_nothing
										update_class_fields -- Current might have been changed; synchronize
									elseif l_data.item.set.proxytype = {NATURAL_32} 4 then
										(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_newhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (48).to_natural_32), ce_string ("%%s"), host.name]).do_nothing
										update_class_fields -- Current might have been changed; synchronize
									elseif l_data.item.set.proxytype = {NATURAL_32} 6 then
										(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_newhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (48).to_natural_32), ce_string ("%%s"), host.name]).do_nothing
										update_class_fields -- Current might have been changed; synchronize
									else
										(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_newhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (48).to_natural_32), ce_string ("%%s"), ip_addr_str]).do_nothing
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_newhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (48).to_natural_32), ce_string ("%%d.%%d.%%d.%%d"), l_ip[0], l_ip[1], l_ip[2], l_ip[3]]).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
								l_newport := (((((l_port[0]).bit_shift_left (8)) + l_port[1])).bit_and (65_535)).to_natural_16
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if l_ftpc.item.count1 = 0 then
							bits.ftp_use_epsv := (0).to_boolean
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("disabling EPSV usage%N")])
							update_class_fields -- Current might have been changed; synchronize
							l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("PASV"), create {CE_VOID_POINTER}.make_shared (default_pointer)])
							update_class_fields -- Current might have been changed; synchronize
							if l_result /= {NATURAL_32} 0 then
								Result := l_result
								l_return := True
							end
							if not l_return then
								l_ftpc.item.count1 := (l_ftpc.item.count1) + 1
								update_class_fields -- Current might have been changed; synchronize
								Result := l_result
								l_return := True
							end
						else
							l_data.item.Curl_failf ([ce_string ("Bad PASV/EPSV response: %%03d"), a_ftpcode])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_FTP_WEIRD_PASV_REPLY)
							l_return := True
						end
				when 7 then -- if done
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 8 then -- if:
						if (l_data.item.set.str[16]).is_void then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if ((l_data.item.set.str[16]).item).to_boolean then
							l_rc := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_resolv (proxy.name, port.to_integer_32, l_addr)
							update_class_fields -- Current might have been changed; synchronize
							if l_rc = 1 then
								(create {P_HOSTSYN_STATIC}).Curl_wait_for_resolv ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_addr).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
							l_connectport := port.to_natural_16
							if (l_addr.item).is_void then
								l_data.item.Curl_failf ([ce_string ("Can%'t resolve proxy host %%s:%%hu"), proxy.name, l_connectport.to_integer_32])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_FTP_CANT_GET_HOST)
								l_return := True
							end
						else
							l_pos := -1 + 11 -- goto _L___1
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L___1:
						l_rc := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_resolv (l_newhost, l_newport.to_integer_32, l_addr)
						update_class_fields -- Current might have been changed; synchronize
						if l_rc = 1 then
							(create {P_HOSTSYN_STATIC}).Curl_wait_for_resolv ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_addr).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						l_connectport := l_newport
						if (l_addr.item).is_void then
							l_data.item.Curl_failf ([ce_string ("Can%'t resolve new host %%s:%%hu"), l_newhost, l_connectport.to_integer_32])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_FTP_CANT_GET_HOST)
							l_return := True
						end
				when 12 then -- if done
					if not l_return then
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_connecthost (l_addr.item, create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("sock") + {PLATFORM}.Integer_32_bytes * (1)), l_conninfo, l_connected)
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.Curl_resolv_unlock (l_addr.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							if l_ftpc.item.count1 = 0 then
								if a_ftpcode = 229 then
									(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("got positive EPSV response, but can%'t connect. Disabling EPSV%N")])
									update_class_fields -- Current might have been changed; synchronize
									bits.ftp_use_epsv := (0).to_boolean
									update_class_fields -- Current might have been changed; synchronize
									l_data.item.state.errorbuf := (0).to_boolean
									update_class_fields -- Current might have been changed; synchronize
									l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("PASV"), create {CE_VOID_POINTER}.make_shared (default_pointer)])
									update_class_fields -- Current might have been changed; synchronize
									if l_result /= {NATURAL_32} 0 then
										Result := l_result
										l_return := True
									end
									if not l_return then
										l_ftpc.item.count1 := (l_ftpc.item.count1) + 1
										update_class_fields -- Current might have been changed; synchronize
										Result := l_result
										l_return := True
									end
								end
							end
						end
					end
					if not l_return and then (l_result.to_boolean) then
						Result := l_result
						l_return := True
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 13 then -- if:
						bits.tcpconnect := l_connected.item
						update_class_fields -- Current might have been changed; synchronize
						if l_data.item.set.verbose then
							((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_pasv_verbose (l_conninfo.item, l_newhost, l_connectport.to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
						end
						inspect (l_data.item.set.proxytype).to_integer_32 -- switch 1 head
						when 5 then l_pos := -1 + 14
						when 7 then l_pos := -1 + 14
						when 4 then l_pos := -1 + 15
						when 6 then l_pos := -1 + 16
						when 0 then l_pos := -1 + 17
						when 1 then l_pos := -1 + 17
						else l_pos := -1 + 18
						end
				when 14 then -- switch 1, case 5 | switch 1, case 7
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_SOCKS5 (proxyuser, proxypasswd, l_newhost, l_newport.to_integer_32, 1)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 19 -- switch 1; break
				when 15 then -- switch 1, case 4
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_SOCKS4 (proxyuser, l_newhost, l_newport.to_integer_32, 1, (0).to_boolean)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 19 -- switch 1; break
				when 16 then -- switch 1, case 6
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_SOCKS4 (proxyuser, l_newhost, l_newport.to_integer_32, 1, (1).to_boolean)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 19 -- switch 1; break
				when 17 then -- switch 1, case 0 | switch 1, case 1
						l_pos := -1 + 19 -- switch 1; break
				when 18 then -- switch 1, default:
						l_data.item.Curl_failf ([ce_string ("unknown proxytype option given")])
						update_class_fields -- Current might have been changed; synchronize
						l_result := {PC_CURLCODE}.CURLE_COULDNT_CONNECT
						l_pos := -1 + 19 -- switch 1; break
				when 19 then -- switch 1, done:
						if bits.tunnel_proxy then
							if bits.httpproxy then
								l_ftp_save := l_data.item.state.proto.ftp
								memset (create {CE_VOID_POINTER}.make_cast (l_http_proxy), 0, (create {PD_HTTP}.make).structure_size.to_natural_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_data.item.state.proto.http := l_http_proxy
								update_class_fields -- Current might have been changed; synchronize
								l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_proxyCONNECT (1, l_newhost, l_newport)
								update_class_fields -- Current might have been changed; synchronize
								l_data.item.state.proto.ftp := l_ftp_save
								update_class_fields -- Current might have been changed; synchronize
								if {NATURAL_32} 0 /= l_result then
									Result := l_result
									l_return := True
								end
							end
						end
				when 20 then -- if done
					if not l_return then
						state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_STOP)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_result
					end
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_state_port_resp (a_ftpcode: INTEGER_32): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_fcmd: NATURAL_32
			l_result: NATURAL_32
		do
			l_data := data
			l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
			l_fcmd := (l_ftpc.item.count1).to_natural_32
			l_result := {PC_CURLCODE}.CURLE_OK
			if a_ftpcode /= 200 then
				if {NATURAL_32} 0 = l_fcmd then
					(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("disabling EPRT usage%N")])
					update_class_fields -- Current might have been changed; synchronize
					bits.ftp_use_eprt := (0).to_boolean
					update_class_fields -- Current might have been changed; synchronize
				end
				l_fcmd := (l_fcmd + {NATURAL_32} 1)
				if l_fcmd = {NATURAL_32} 2 then
					l_data.item.Curl_failf ([ce_string ("Failed to do PORT")])
					update_class_fields -- Current might have been changed; synchronize
					l_result := {PC_CURLCODE}.CURLE_FTP_PORT_FAILED
				else
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_use_port (l_fcmd)
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Connect data stream actively%N")])
				update_class_fields -- Current might have been changed; synchronize
				state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_STOP)
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l_result
		end

	ftp_state_mdtm_resp (a_ftpcode: INTEGER_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ftp: CE_POINTER [PD_FTP]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_year: CE_ARRAY [INTEGER_32]
			l_month: CE_ARRAY [INTEGER_32]
			l_day: CE_ARRAY [INTEGER_32]
			l_hour: CE_ARRAY [INTEGER_32]
			l_minute: CE_ARRAY [INTEGER_32]
			l_second: CE_ARRAY [INTEGER_32]
			l_buf: CE_POINTER [INTEGER_8]
			l_secs: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tm: CE_POINTER [SD_TM]
			l_filetime: CE_ARRAY [INTEGER_32]
			l_buffer: CE_ARRAY [SD_TM]
			l_tmp___2: CE_POINTER [SD_TM]
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_year.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_month.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_day.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_hour.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_minute.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_second.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_secs.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_filetime.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TM]} l_buffer.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data := data
					l_ftp := l_data.item.state.proto.ftp
					l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
					inspect a_ftpcode -- switch 1 head
					when 213 then l_pos := -1 + 1
					when 550 then l_pos := -1 + 3
					else l_pos := -1 + 2
					end
				when 1 then -- switch 1, case 213
					l_buf := l_data.item.state.buffer
					l_tmp___1 := sscanf ([(l_buf + 4), ce_string ("%%04d%%02d%%02d%%02d%%02d%%02d"), l_year, l_month, l_day, l_hour, l_minute, l_second])
					update_class_fields -- Current might have been changed; synchronize
					if 6 = l_tmp___1 then
						l_tmp := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_secs.item := l_tmp
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_buf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (16_385).to_natural_32), ce_string ("%%04d%%02d%%02d %%02d:%%02d:%%02d GMT"), l_year.item, l_month.item, l_day.item, l_hour.item, l_minute.item, l_second.item]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := (create {P_PARSEDATE_STATIC}).curl_getdate (l_buf, l_secs)
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.info.filetime := l_tmp___0
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_data.item.set.opt_no_body then
						if (not (l_ftpc.item.file).is_void) then
							if l_data.item.set.get_filetime then
								if l_data.item.info.filetime >= 0 then
									l_filetime.item := l_data.item.info.filetime
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___2 := gmtime_r (l_filetime, l_buffer)
									update_class_fields -- Current might have been changed; synchronize
									l_tm := l_tmp___2
									if (l_tm.item.tm_wday).to_boolean then
										l_tmp___3 := l_tm.item.tm_wday - 1
									else
										l_tmp___3 := 6
									end
									(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_buf, (16_383).to_natural_32, ce_string ("Last-Modified: %%s, %%02d %%s %%4d %%02d:%%02d:%%02d GMT%R%N"), (create {P_PARSEDATE_STATIC}).Curl_wkday.item[l_tmp___3], l_tm.item.tm_mday, (create {P_PARSEDATE_STATIC}).Curl_month.item[l_tm.item.tm_mon], l_tm.item.tm_year + 1_900, l_tm.item.tm_hour, l_tm.item.tm_min, l_tm.item.tm_sec]).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write ((1).bit_or (((1).bit_shift_left (1))), l_buf, (0).to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
									if l_result.to_boolean then
										Result := l_result
										l_return := True
									end
								end
							end
						end
					end
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, default:;
					(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("unsupported MDTM reply format%N")])
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 550
					l_data.item.Curl_failf ([ce_string ("Given file does not exist")])
					update_class_fields -- Current might have been changed; synchronize
					l_result := {PC_CURLCODE}.CURLE_FTP_COULDNT_RETR_FILE
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					if not (not l_return and then ((l_data.item.set.timecondition).to_boolean)) then
						l_pos := -1 + 14 -- skip if block
					end
				when 5 then -- if:
						if not (l_data.item.info.filetime > 0) then
							l_pos := -1 + 13 -- skip if block
						end
				when 6 then -- if:
						if not (l_data.item.set.timevalue > 0) then
							l_pos := -1 + 11 -- skip if block
						end
				when 7 then -- if:
						inspect (l_data.item.set.timecondition).to_integer_32 -- switch 2 head
						when 2 then l_pos := -1 + 9
						else l_pos := -1 + 8
						end
				when 8 then -- switch 2, default:
						if l_data.item.info.filetime <= l_data.item.set.timevalue then
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("The requested document is not new enough%N")])
							update_class_fields -- Current might have been changed; synchronize
							l_ftp.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_NONE
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.info.timecond := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_STOP)
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						end
						l_pos := -1 + 10 -- switch 2; break
				when 9 then -- switch 2, case 2
						if l_data.item.info.filetime > l_data.item.set.timevalue then
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("The requested document is not old enough%N")])
							update_class_fields -- Current might have been changed; synchronize
							l_ftp.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_NONE
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.info.timecond := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_STOP)
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						end
						l_pos := -1 + 10 -- switch 2; break
				when 10 then -- switch 2, done: | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:;
						(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Skipping time comparison%N")])
						update_class_fields -- Current might have been changed; synchronize
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:;
						(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Skipping time comparison%N")])
						update_class_fields -- Current might have been changed; synchronize
				when 14 then -- if done | if done
					if not l_return then
						if not l_result.to_boolean then
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_mdtm
							update_class_fields -- Current might have been changed; synchronize
						end
						Result := l_result
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_state_type_resp (a_ftpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			if a_ftpcode // 100 /= 2 then
				l_data.item.Curl_failf ([ce_string ("Couldn%'t set desired mode")])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_FTP_COULDNT_SET_TYPE)
				l_return := True
			end
			if not l_return then
				if a_ftpcode /= 200 then
					(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Got a %%03d response code instead of the assumed 200%N"), a_ftpcode])
					update_class_fields -- Current might have been changed; synchronize
				end
				if a_instate = {NATURAL_32} 19 then
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_type
					update_class_fields -- Current might have been changed; synchronize
				elseif a_instate = {NATURAL_32} 20 then
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_listtype
					update_class_fields -- Current might have been changed; synchronize
				elseif a_instate = {NATURAL_32} 21 then
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_retrtype
					update_class_fields -- Current might have been changed; synchronize
				elseif a_instate = {NATURAL_32} 22 then
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_stortype
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_result
			end
		end

	ftp_state_post_retr_size (a_filesize: INTEGER_64): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ftp: CE_POINTER [PD_FTP]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			l_ftp := l_data.item.state.proto.ftp
			l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
			if (l_data.item.set.max_filesize).to_boolean then
				if a_filesize > l_data.item.set.max_filesize then
					l_data.item.Curl_failf ([ce_string ("Maximum file size exceeded")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_FILESIZE_EXCEEDED)
					l_return := True
				end
			end
			if not l_return then
				l_ftp.item.downloadsize := a_filesize
				update_class_fields -- Current might have been changed; synchronize
				if (l_data.item.state.resume_from).to_boolean then
					if a_filesize = -{INTEGER_64} 1 then
						(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("ftp server doesn%'t support SIZE%N")])
						update_class_fields -- Current might have been changed; synchronize
					elseif l_data.item.state.resume_from < {INTEGER_64} 0 then
						if a_filesize < -l_data.item.state.resume_from then
							l_data.item.Curl_failf ([ce_string ("Offset (%%lld) was beyond file size (%%lld)"), l_data.item.state.resume_from, a_filesize])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_BAD_DOWNLOAD_RESUME)
							l_return := True
						end
						if not l_return then
							l_ftp.item.downloadsize := -l_data.item.state.resume_from
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.state.resume_from := a_filesize - l_ftp.item.downloadsize
							update_class_fields -- Current might have been changed; synchronize
						end
					else
						if a_filesize < l_data.item.state.resume_from then
							l_data.item.Curl_failf ([ce_string ("Offset (%%lld) was beyond file size (%%lld)"), l_data.item.state.resume_from, a_filesize])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_BAD_DOWNLOAD_RESUME)
							l_return := True
						end
						if not l_return then
							l_ftp.item.downloadsize := a_filesize - l_data.item.state.resume_from
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if not l_return and then (l_ftp.item.downloadsize = {INTEGER_64} 0) then
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (-1, (-1).to_integer_64, (0).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer), -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("File already completely downloaded%N")])
						update_class_fields -- Current might have been changed; synchronize
						l_ftp.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_NONE
						update_class_fields -- Current might have been changed; synchronize
						state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_STOP)
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
					end
					if not l_return then
						(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Instructs server to resume from offset %%lld%N"), l_data.item.state.resume_from])
						update_class_fields -- Current might have been changed; synchronize
						l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("REST %%lld"), l_data.item.state.resume_from])
						update_class_fields -- Current might have been changed; synchronize
						if l_result /= {NATURAL_32} 0 then
							Result := l_result
							l_return := True
						end
					end
					if not l_return then
						state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_RETR_REST)
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("RETR %%s"), l_ftpc.item.file])
					update_class_fields -- Current might have been changed; synchronize
					if l_result /= {NATURAL_32} 0 then
						Result := l_result
						l_return := True
					end
					if not l_return then
						state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_RETR)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				Result := l_result
			end
		end

	ftp_state_size_resp (a_ftpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_filesize: INTEGER_64
			l_buf: CE_POINTER [INTEGER_8]
			l_tmp: INTEGER_64
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			l_buf := l_data.item.state.buffer
			if a_ftpcode = 213 then
				l_tmp := strtoll ((l_buf + 4), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 0)
				update_class_fields -- Current might have been changed; synchronize
				l_filesize := l_tmp
			else
				l_filesize := (-1).to_integer_64
			end
			if a_instate = {NATURAL_32} 23 then
				if -{INTEGER_64} 1 /= l_filesize then
					(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_buf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (16_385).to_natural_32), ce_string ("Content-Length: %%lld%R%N"), l_filesize]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write ((1).bit_or (((1).bit_shift_left (1))), l_buf, (0).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_result.to_boolean then
						Result := l_result
						l_return := True
					end
				end
				if not l_return then
					l_data.item.Curl_pgrsSetDownloadSize (l_filesize)
					update_class_fields -- Current might have been changed; synchronize
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_size
					update_class_fields -- Current might have been changed; synchronize
				end
			elseif a_instate = {NATURAL_32} 24 then
				l_data.item.Curl_pgrsSetDownloadSize (l_filesize)
				update_class_fields -- Current might have been changed; synchronize
				l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_retr_size (l_filesize)
				update_class_fields -- Current might have been changed; synchronize
			elseif a_instate = {NATURAL_32} 25 then
				l_data.item.state.resume_from := l_filesize
				update_class_fields -- Current might have been changed; synchronize
				l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_ul_setup ((1).to_boolean)
				update_class_fields -- Current might have been changed; synchronize
			end
			if not l_return then
				Result := l_result
			end
		end

	ftp_state_stor_resp (a_ftpcode: INTEGER_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ftp: CE_POINTER [PD_FTP]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			l_ftp := l_data.item.state.proto.ftp
			if a_ftpcode >= 400 then
				l_data.item.Curl_failf ([ce_string ("Failed FTP upload: %%0d"), a_ftpcode])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_UPLOAD_FAILED)
				l_return := True
			end
			if not l_return and then (l_data.item.set.ftp_use_port) then
				l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.AllowServerConnect
				update_class_fields -- Current might have been changed; synchronize
				if l_result.to_boolean then
					Result := l_result
					l_return := True
				end
			end
			if not l_return and then (ssl[1].use) then
				(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Doing the SSL/TLS handshake on the data stream%N")])
				update_class_fields -- Current might have been changed; synchronize
				l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
				if l_result.to_boolean then
					Result := l_result
					l_return := True
				end
			end
			if not l_return then
				(l_ftp.item.bytecountp).item := (0).to_integer_64
				update_class_fields -- Current might have been changed; synchronize
				l_data.item.Curl_pgrsSetUploadSize (l_data.item.set.infilesize)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (-1, (-1).to_integer_64, (0).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer), 1, l_ftp.item.bytecountp)
				update_class_fields -- Current might have been changed; synchronize
				state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_STOP)
				update_class_fields -- Current might have been changed; synchronize
				proto.ftpc.pp.pending_resp := (1).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				Result := l_result
			end
		end

	ftp_state_get_resp (a_ftpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ftp: CE_POINTER [PD_FTP]
			l_buf: CE_POINTER [INTEGER_8]
			l_size: INTEGER_64
			l_bytes: CE_POINTER [INTEGER_8]
			l_in: INTEGER_32
			l_tmp: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_64
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data := data
					l_ftp := l_data.item.state.proto.ftp
					l_buf := l_data.item.state.buffer
					if a_ftpcode /= 150 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___3
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 3 then -- else:
						if a_ftpcode /= 125 then
							l_pos := -1 + 15 -- skip if block
						end
				when 4 then -- if: | _L___3:
						l_size := (-1).to_integer_64
						if a_instate = {NATURAL_32} 31 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not l_data.item.set.prefer_ascii then
							if l_ftp.item.downloadsize < {INTEGER_64} 1 then
								l_bytes := strstr (l_buf, ce_string (" bytes"))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___1 := l_bytes
								l_bytes := l_bytes - 1
								if (not l_tmp___1.is_void) then
									l_in := (l_bytes.distance (l_buf)).to_integer_32
									from
									until
										(l_break)
									loop
										l_break := False
										l_in := l_in - 1
										if not l_in.to_boolean then
											l_break := True
										end
										if not (l_break) and then (40 = (l_bytes[0]).to_integer_32) then
											l_break := True
										end
										if not (l_break) then
											l_tmp := ctype_b_loc
											update_class_fields -- Current might have been changed; synchronize
											if not (((l_tmp.item[((l_bytes[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
												l_bytes := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
												l_break := True
											end
										end
										if not (l_break) then
											l_bytes := l_bytes - 1
										end
									end
									l_break := False
									l_tmp___0 := l_bytes
									l_bytes := l_bytes + 1
									if (not l_tmp___0.is_void) then
										l_size := strtoll (l_bytes, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 0)
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							else
								l_pos := -1 + 7 -- goto _L___0
							end
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L___0:
						if l_ftp.item.downloadsize > -{INTEGER_64} 1 then
							l_size := l_ftp.item.downloadsize
						end
				when 8 then
						if l_data.item.set.ftp_use_port then
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.AllowServerConnect
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
						if not l_return and then (ssl[1].use) then
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Doing the SSL/TLS handshake on the data stream%N")])
							update_class_fields -- Current might have been changed; synchronize
							l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
						if l_return then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if:
						if not (l_size > l_data.item.req.maxdownload) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_data.item.req.maxdownload > {INTEGER_64} 0 then
							l_tmp___2 := l_data.item.req.maxdownload
							l_data.item.req.size := l_tmp___2
							update_class_fields -- Current might have been changed; synchronize
							l_size := l_tmp___2
						else
							l_pos := -1 + 12 -- goto _L___1
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___1:
						if a_instate /= {NATURAL_32} 31 then
							if l_data.item.set.prefer_ascii then
								l_size := (-1).to_integer_64
							end
						end
				when 13 then;
						(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Maxdownload = %%lld%N"), l_data.item.req.maxdownload])
						update_class_fields -- Current might have been changed; synchronize
						if a_instate /= {NATURAL_32} 31 then
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Getting file with size: %%lld%N"), l_size])
							update_class_fields -- Current might have been changed; synchronize
						end
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (1, l_size, (0).to_boolean, l_ftp.item.bytecountp, -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						proto.ftpc.pp.pending_resp := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_STOP)
						update_class_fields -- Current might have been changed; synchronize
				when 14 then -- if done | if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else:
						if a_instate /= {NATURAL_32} 31 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if a_ftpcode = 450 then
							l_ftp.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_NONE
							update_class_fields -- Current might have been changed; synchronize
							state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_STOP)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 18 -- goto _L___2
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L___2:
						l_data.item.Curl_failf ([ce_string ("RETR response: %%03d"), a_ftpcode])
						update_class_fields -- Current might have been changed; synchronize
						if a_instate = {NATURAL_32} 32 then
							if a_ftpcode = 550 then
								l_tmp___3 := 78
							else
								l_tmp___3 := 19
							end
						else
							l_tmp___3 := 19
						end
						Result := l_tmp___3.to_natural_32
						l_return := True
				when 19 then -- if done | if done
					if not l_return then
						Result := l_result
					end
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_state_loggedin: NATURAL_32
		local
			l_result: NATURAL_32
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			if ssl[0].use then
				l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc") + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("PBSZ %%d"), 0])
				update_class_fields -- Current might have been changed; synchronize
				if l_result /= {NATURAL_32} 0 then
					Result := l_result
					l_return := True
				end
				if not l_return then
					state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_PBSZ)
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				l_result := ftp_state_pwd ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
				update_class_fields -- Current might have been changed; synchronize
			end
			if not l_return then
				Result := l_result
			end
		end

	ftp_state_user_resp (a_ftpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ftp: CE_POINTER [PD_FTP]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data := data
					l_ftp := l_data.item.state.proto.ftp
					l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
					if a_ftpcode /= 331 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_ftpc.item.state = {NATURAL_32} 3 then
							if (not (l_ftp.item.passwd).is_void) then
								l_tmp := l_ftp.item.passwd
							else
								l_tmp := ce_string ("")
							end
							l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("PASS %%s"), l_tmp])
							update_class_fields -- Current might have been changed; synchronize
							if l_result /= {NATURAL_32} 0 then
								Result := l_result
								l_return := True
							end
							if not l_return then
								state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_PASS)
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if a_ftpcode // 100 = 2 then
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_loggedin
							update_class_fields -- Current might have been changed; synchronize
						elseif a_ftpcode = 332 then
							if (not (l_data.item.set.str[7]).is_void) then
								l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("ACCT %%s"), l_data.item.set.str[7]])
								update_class_fields -- Current might have been changed; synchronize
								if l_result /= {NATURAL_32} 0 then
									Result := l_result
									l_return := True
								end
								if not l_return then
									state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_ACCT)
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_data.item.Curl_failf ([ce_string ("ACCT requested but none available")])
								update_class_fields -- Current might have been changed; synchronize
								l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
							end
						elseif (not (data.item.set.str[8]).is_void) then
							if not data.item.state.ftp_trying_alternative then
								l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc") + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("%%s"), data.item.set.str[8]])
								update_class_fields -- Current might have been changed; synchronize
								if l_result /= {NATURAL_32} 0 then
									Result := l_result
									l_return := True
								end
								if not l_return then
									data.item.state.ftp_trying_alternative := (1).to_boolean
									update_class_fields -- Current might have been changed; synchronize
									state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_USER)
									update_class_fields -- Current might have been changed; synchronize
									l_result := {PC_CURLCODE}.CURLE_OK
								end
							else
								l_data.item.Curl_failf ([ce_string ("Access denied: %%03d"), a_ftpcode])
								update_class_fields -- Current might have been changed; synchronize
								l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
							end
						else
							l_data.item.Curl_failf ([ce_string ("Access denied: %%03d"), a_ftpcode])
							update_class_fields -- Current might have been changed; synchronize
							l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
						end
				when 4 then
					if not l_return then
						Result := l_result
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_state_acct_resp (a_ftpcode: INTEGER_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			if a_ftpcode /= 230 then
				l_data.item.Curl_failf ([ce_string ("ACCT rejected by server: %%03d"), a_ftpcode])
				update_class_fields -- Current might have been changed; synchronize
				l_result := {PC_CURLCODE}.CURLE_FTP_WEIRD_PASS_REPLY
			else
				l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_loggedin
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l_result
		end

	ftp_statemach_act: NATURAL_32
		local
			l_result: NATURAL_32
			l_sock: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ftpcode: CE_ARRAY [INTEGER_32]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_nread: CE_ARRAY [NATURAL_32]
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_ptr: CE_POINTER [INTEGER_8]
			l_dir: CE_POINTER [INTEGER_8]
			l_store: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [ANY]
			l_ptr___0: CE_POINTER [INTEGER_8]
			l_os: CE_POINTER [INTEGER_8]
			l_store___0: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_ftpcode.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_nread.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sock := sock[0]
					l_data := data
					l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
					l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))
					l_nread.item := (0).to_natural_32
					update_class_fields -- Current might have been changed; synchronize
					if (l_pp.item.sendleft).to_boolean then
						l_tmp := Curl_pp_flushsend (l_pp)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp
						l_return := True
					end
					if not l_return then
						l_result := ftp_readresp (l_sock, l_pp, l_ftpcode, l_nread)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if not (not l_return and then ((l_ftpcode.item).to_boolean)) then
						l_pos := -1 + 47 -- skip if block
					end
				when 1 then -- if:
						inspect (l_ftpc.item.state).to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 15
						when 3 then l_pos := -1 + 23
						when 4 then l_pos := -1 + 23
						when 5 then l_pos := -1 + 24
						when 6 then l_pos := -1 + 25
						when 7 then l_pos := -1 + 26
						when 8 then l_pos := -1 + 27
						when 9 then l_pos := -1 + 28
						when 10 then l_pos := -1 + 30
						when 11 then l_pos := -1 + 32
						when 12 then l_pos := -1 + 34
						when 15 then l_pos := -1 + 34
						when 13 then l_pos := -1 + 34
						when 14 then l_pos := -1 + 34
						when 16 then l_pos := -1 + 35
						when 17 then l_pos := -1 + 36
						when 18 then l_pos := -1 + 37
						when 19 then l_pos := -1 + 38
						when 20 then l_pos := -1 + 38
						when 21 then l_pos := -1 + 38
						when 22 then l_pos := -1 + 38
						when 23 then l_pos := -1 + 39
						when 24 then l_pos := -1 + 39
						when 25 then l_pos := -1 + 39
						when 26 then l_pos := -1 + 40
						when 27 then l_pos := -1 + 40
						when 29 then l_pos := -1 + 41
						when 30 then l_pos := -1 + 42
						when 28 then l_pos := -1 + 43
						when 31 then l_pos := -1 + 44
						when 32 then l_pos := -1 + 44
						when 33 then l_pos := -1 + 45
						else l_pos := -1 + 46
						end
				when 2 then -- switch 1, case 1
						if l_ftpcode.item /= 220 then
							l_data.item.Curl_failf ([ce_string ("Got a %%03d ftp-server response when 220 was expected"), l_ftpcode.item])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_FTP_WEIRD_SERVER_REPLY)
							l_return := True
						end
						if l_return then
							l_pos := -1 + 14 -- skip if block
						end
				when 3 then -- if:
						if not ((l_data.item.set.ftp_ssl).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 4 then -- if:
						if ssl[0].use then
							l_pos := -1 + 11 -- skip if block
						end
				when 5 then -- if:
						l_ftpc.item.count3 := 0
						update_class_fields -- Current might have been changed; synchronize
						inspect (l_data.item.set.ftpsslauth).to_integer_32 -- switch 2 head
						when 0 then l_pos := -1 + 6
						when 1 then l_pos := -1 + 6
						when 2 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 6 then -- switch 2, case 0 | switch 2, case 1
						l_ftpc.item.count2 := 1
						update_class_fields -- Current might have been changed; synchronize
						l_ftpc.item.count1 := 0
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 9 -- switch 2; break
				when 7 then -- switch 2, case 2
						l_ftpc.item.count2 := -1
						update_class_fields -- Current might have been changed; synchronize
						l_ftpc.item.count1 := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 9 -- switch 2; break
				when 8 then -- switch 2, default:
						l_data.item.Curl_failf ([ce_string ("unsupported parameter to CURLOPT_FTPSSLAUTH: %%d"), (l_data.item.set.ftpsslauth).to_integer_32])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
						l_return := True
				when 9 then -- switch 2, done:
						if not l_return then
							l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("AUTH %%s"), ftpauth.item[l_ftpc.item.count1]])
							update_class_fields -- Current might have been changed; synchronize
							if l_result /= {NATURAL_32} 0 then
								Result := l_result
								l_return := True
							end
						end
						if not l_return then
							state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_AUTH)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_pos := -1 + 13 -- goto _L
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_user
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
				when 14 then -- if done
						l_pos := -1 + 47 -- switch 1; break
				when 15 then -- switch 1, case 2
						if l_ftpcode.item /= 234 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L___0
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else:
						if l_ftpcode.item /= 334 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if: | _L___0:
						l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
						if {NATURAL_32} 0 = l_result then
							Current.protocol := (protocol).bit_or (((1).bit_shift_left (3)).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							ssl[1].use := (0).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_user
							update_class_fields -- Current might have been changed; synchronize
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						if l_ftpc.item.count3 < 1 then
							l_ftpc.item.count3 := (l_ftpc.item.count3) + 1
							update_class_fields -- Current might have been changed; synchronize
							l_ftpc.item.count1 := l_ftpc.item.count1 + (l_ftpc.item.count2)
							update_class_fields -- Current might have been changed; synchronize
							l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("AUTH %%s"), ftpauth.item[l_ftpc.item.count1]])
							update_class_fields -- Current might have been changed; synchronize
						elseif l_data.item.set.ftp_ssl > {NATURAL_32} 1 then
							l_result := {PC_CURLCODE}.CURLE_USE_SSL_FAILED
						else
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_user
							update_class_fields -- Current might have been changed; synchronize
						end
				when 22 then -- if done
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
						l_pos := -1 + 47 -- switch 1; break
				when 23 then -- switch 1, case 3 | switch 1, case 4
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_user_resp (l_ftpcode.item, l_ftpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 47 -- switch 1; break
				when 24 then -- switch 1, case 5
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_acct_resp (l_ftpcode.item)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 47 -- switch 1; break
				when 25 then -- switch 1, case 6
						if l_data.item.set.ftp_ssl = {NATURAL_32} 2 then
							l_tmp___0 := ('C').code
						else
							l_tmp___0 := ('P').code
						end
						l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("PROT %%c"), l_tmp___0])
						update_class_fields -- Current might have been changed; synchronize
						if l_result /= {NATURAL_32} 0 then
							Result := l_result
							l_return := True
						end
						if not l_return then
							state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_PROT)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 47 -- switch 1; break
				when 26 then -- switch 1, case 7
						if l_ftpcode.item // 100 = 2 then
							ssl[1].use := (l_data.item.set.ftp_ssl /= {NATURAL_32} 2)
							update_class_fields -- Current might have been changed; synchronize
						elseif l_data.item.set.ftp_ssl > {NATURAL_32} 2 then
							Result := ({PC_CURLCODE}.CURLE_USE_SSL_FAILED)
							l_return := True
						end
						if not l_return then
							if (l_data.item.set.ftp_ccc).to_boolean then
								l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("CCC"), create {CE_VOID_POINTER}.make_shared (default_pointer)])
								update_class_fields -- Current might have been changed; synchronize
								if l_result /= {NATURAL_32} 0 then
									Result := l_result
									l_return := True
								end
								if not l_return then
									state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_CCC)
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_result := ftp_state_pwd ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
								update_class_fields -- Current might have been changed; synchronize
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
							end
						end
						l_pos := -1 + 47 -- switch 1; break
				when 27 then -- switch 1, case 8
						if l_ftpcode.item < 500 then
							l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
							if l_result.to_boolean then
								data.item.Curl_failf ([ce_string ("Failed to clear the command channel (CCC)")])
								update_class_fields -- Current might have been changed; synchronize
								Result := l_result
								l_return := True
							end
						end
						if not l_return then
							l_result := ftp_state_pwd ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
						l_pos := -1 + 47 -- switch 1; break
				when 28 then -- switch 1, case 9
						if l_ftpcode.item = 257 then
							l_ptr := create {CE_INTEGER_8_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("buffer") + {PLATFORM}.Integer_8_bytes * (4))
							l_tmp___1 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([l_nread.item + {NATURAL_32} 1]))
							update_class_fields -- Current might have been changed; synchronize
							l_dir := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___1)
							if l_dir.is_void then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								l_return := True
							end
							if not l_return then
								if 34 = (l_ptr[0]).to_integer_32 then
									l_ptr := l_ptr + 1
									l_store := l_dir
									from
									until
										not (not (l_break) and then ((l_ptr[0]).to_boolean))
									loop
										l_break := False
										if 34 = (l_ptr[0]).to_integer_32 then
											if 34 = (l_ptr[1]).to_integer_32 then
												l_store[0] := l_ptr[1]
												update_class_fields -- Current might have been changed; synchronize
												l_ptr := l_ptr + 1
											else
												l_store[0] := (('%/0/').code).to_integer_8
												update_class_fields -- Current might have been changed; synchronize
												l_break := True
											end
										else
											l_store[0] := l_ptr[0]
											update_class_fields -- Current might have been changed; synchronize
										end
										if not (l_break) then
											l_store := l_store + 1
											l_ptr := l_ptr + 1
										end
									end
									l_break := False
									if (not (l_ftpc.item.entrypath).is_void) then
										(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_ftpc.item.entrypath)])
										update_class_fields -- Current might have been changed; synchronize
									end
									l_ftpc.item.entrypath := l_dir
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Entry path is %'%%s%'%N"), l_ftpc.item.entrypath])
									update_class_fields -- Current might have been changed; synchronize
									l_data.item.state.most_recent_ftp_entrypath := l_ftpc.item.entrypath
									update_class_fields -- Current might have been changed; synchronize
									if (l_ftpc.item.server_os).is_void then
										if (l_ftpc.item.entrypath[0]).to_integer_32 /= 47 then
											l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("SYST"), create {CE_VOID_POINTER}.make_shared (default_pointer)])
											update_class_fields -- Current might have been changed; synchronize
											if l_result /= {NATURAL_32} 0 then
												Result := l_result
												l_return := True
											end
											if not l_return then
												state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_SYST)
												update_class_fields -- Current might have been changed; synchronize
											end
											l_pos := -1 + 47 -- switch 1; break
										end
									end
								else
									(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_dir)])
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Failed to figure out path%N")])
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
				when 29 then
						if not l_return then
							state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_STOP)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 47 -- switch 1; break
				when 30 then -- switch 1, case 10
						if l_ftpcode.item = 215 then
							l_ptr___0 := create {CE_INTEGER_8_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("buffer") + {PLATFORM}.Integer_8_bytes * (4))
							l_tmp___2 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([l_nread.item + {NATURAL_32} 1]))
							update_class_fields -- Current might have been changed; synchronize
							l_os := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___2)
							if l_os.is_void then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								l_return := True
							end
							if not l_return then
								from
								until
									(l_ptr___0[0]).to_integer_32 /= 32
								loop
									l_ptr___0 := l_ptr___0 + 1
								end
								l_store___0 := l_os
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_ptr___0[0]).to_boolean then
										if (l_ptr___0[0]).to_integer_32 = 32 then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_tmp___3 := l_store___0
										l_store___0 := l_store___0 + 1
										l_tmp___4 := l_ptr___0
										l_ptr___0 := l_ptr___0 + 1
										l_tmp___3[0] := l_tmp___4[0]
										update_class_fields -- Current might have been changed; synchronize
									end
								end
								l_break := False
								l_store___0[0] := (('%/0/').code).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_ftpc.item.server_os := l_os
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___5 := (create {P_STREQUAL_STATIC}).curl_strequal (l_ftpc.item.server_os, ce_string ("OS/400"))
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___5.to_boolean then
									l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("SITE NAMEFMT 1"), create {CE_VOID_POINTER}.make_shared (default_pointer)])
									update_class_fields -- Current might have been changed; synchronize
									if l_result /= {NATURAL_32} 0 then
										Result := l_result
										l_return := True
									end
									if not l_return then
										state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_NAMEFMT)
										update_class_fields -- Current might have been changed; synchronize
									end
									l_pos := -1 + 47 -- switch 1; break
								end
							end
						end
				when 31 then
						if not l_return then
							state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_STOP)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 47 -- switch 1; break
				when 32 then -- switch 1, case 11
						if l_ftpcode.item = 250 then
							ftp_state_pwd ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 47 -- switch 1; break
						end
				when 33 then
						state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_STOP)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 47 -- switch 1; break
				when 34 then -- switch 1, case 12 | switch 1, case 15 | switch 1, case 13 | switch 1, case 14
						if l_ftpcode.item >= 400 then
							if not (l_ftpc.item.count2).to_boolean then
								data.item.Curl_failf ([ce_string ("QUOT command failed with %%03d"), l_ftpcode.item])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_QUOTE_ERROR)
								l_return := True
							end
						end
						if not l_return then
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_quote ((0).to_boolean, l_ftpc.item.state)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
						l_pos := -1 + 47 -- switch 1; break
				when 35 then -- switch 1, case 16
						if l_ftpcode.item // 100 /= 2 then
							if (data.item.set.ftp_create_missing_dirs).to_boolean then
								if (l_ftpc.item.count1).to_boolean then
									if not (l_ftpc.item.count2).to_boolean then
										l_ftpc.item.count2 := (l_ftpc.item.count2) + 1
										update_class_fields -- Current might have been changed; synchronize
										l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("MKD %%s"), l_ftpc.item.dirs[(l_ftpc.item.count1 - 1)]])
										update_class_fields -- Current might have been changed; synchronize
										if l_result /= {NATURAL_32} 0 then
											Result := l_result
											l_return := True
										end
										if not l_return then
											state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_MKD)
											update_class_fields -- Current might have been changed; synchronize
										end
									else
										l_data.item.Curl_failf ([ce_string ("Server denied you to change to the given directory")])
										update_class_fields -- Current might have been changed; synchronize
										l_ftpc.item.cwdfail := (1).to_boolean
										update_class_fields -- Current might have been changed; synchronize
										Result := ({PC_CURLCODE}.CURLE_REMOTE_ACCESS_DENIED)
										l_return := True
									end
								else
									l_data.item.Curl_failf ([ce_string ("Server denied you to change to the given directory")])
									update_class_fields -- Current might have been changed; synchronize
									l_ftpc.item.cwdfail := (1).to_boolean
									update_class_fields -- Current might have been changed; synchronize
									Result := ({PC_CURLCODE}.CURLE_REMOTE_ACCESS_DENIED)
									l_return := True
								end
							else
								l_data.item.Curl_failf ([ce_string ("Server denied you to change to the given directory")])
								update_class_fields -- Current might have been changed; synchronize
								l_ftpc.item.cwdfail := (1).to_boolean
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_REMOTE_ACCESS_DENIED)
								l_return := True
							end
						else
							l_ftpc.item.count2 := 0
							update_class_fields -- Current might have been changed; synchronize
							l_ftpc.item.count1 := (l_ftpc.item.count1) + 1
							update_class_fields -- Current might have been changed; synchronize
							if l_ftpc.item.count1 <= l_ftpc.item.dirdepth then
								l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("CWD %%s"), l_ftpc.item.dirs[(l_ftpc.item.count1 - 1)]])
								update_class_fields -- Current might have been changed; synchronize
								if l_result /= {NATURAL_32} 0 then
									Result := l_result
									l_return := True
								end
							else
								l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_cwd
								update_class_fields -- Current might have been changed; synchronize
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
							end
						end
						l_pos := -1 + 47 -- switch 1; break
				when 36 then -- switch 1, case 17
						if l_ftpcode.item // 100 /= 2 then
							l_tmp___6 := l_ftpc.item.count3
							l_ftpc.item.count3 := (l_ftpc.item.count3) - 1
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___6.to_boolean then
								l_data.item.Curl_failf ([ce_string ("Failed to MKD dir: %%03d"), l_ftpcode.item])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_REMOTE_ACCESS_DENIED)
								l_return := True
							end
						end
						if not l_return then
							state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_CWD)
							update_class_fields -- Current might have been changed; synchronize
							l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("CWD %%s"), l_ftpc.item.dirs[(l_ftpc.item.count1 - 1)]])
							update_class_fields -- Current might have been changed; synchronize
							if l_result /= {NATURAL_32} 0 then
								Result := l_result
								l_return := True
							end
						end
						l_pos := -1 + 47 -- switch 1; break
				when 37 then -- switch 1, case 18
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_mdtm_resp (l_ftpcode.item)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 47 -- switch 1; break
				when 38 then -- switch 1, case 19 | switch 1, case 20 | switch 1, case 21 | switch 1, case 22
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_type_resp (l_ftpcode.item, l_ftpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 47 -- switch 1; break
				when 39 then -- switch 1, case 23 | switch 1, case 24 | switch 1, case 25
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_size_resp (l_ftpcode.item, l_ftpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 47 -- switch 1; break
				when 40 then -- switch 1, case 26 | switch 1, case 27
						l_result := ftp_state_rest_resp ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_ftpcode.item, l_ftpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 47 -- switch 1; break
				when 41 then -- switch 1, case 29
						if l_ftpcode.item /= 200 then
							l_data.item.Curl_failf ([ce_string ("PRET command not accepted: %%03d"), l_ftpcode.item])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_FTP_PRET_FAILED)
							l_return := True
						end
						if not l_return then
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_use_pasv
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 47 -- switch 1; break
				when 42 then -- switch 1, case 30
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_pasv_resp (l_ftpcode.item)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 47 -- switch 1; break
				when 43 then -- switch 1, case 28
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_port_resp (l_ftpcode.item)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 47 -- switch 1; break
				when 44 then -- switch 1, case 31 | switch 1, case 32
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_get_resp (l_ftpcode.item, l_ftpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 47 -- switch 1; break
				when 45 then -- switch 1, case 33
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_stor_resp (l_ftpcode.item)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 47 -- switch 1; break
				when 46 then -- switch 1, default:
						state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_STOP)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 47 -- switch 1; break
				when 47 then -- switch 1, done: | if done
					if not l_return then
						Result := l_result
					end
				when 48 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_init: NATURAL_32
		local
			l_ftp: CE_POINTER [PD_FTP]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: BOOLEAN
			l_tmp___1: BOOLEAN
			l_return: BOOLEAN
		do
			if (data.item.state.proto.ftp).is_void then
				l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(create {PD_FTP}.make).structure_size.to_natural_32]))
				update_class_fields -- Current might have been changed; synchronize
				data.item.state.proto.ftp := create {CE_CLASS_POINTER [PD_FTP]}.make_cast (l_tmp)
				update_class_fields -- Current might have been changed; synchronize
				if (data.item.state.proto.ftp).is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				l_ftp := data.item.state.proto.ftp
				l_ftp.item.bytecountp := create {CE_INTEGER_64_POINTER}.make_shared (data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req") + (create {PD_SINGLEREQUEST}.make).offset_of ("bytecount"))
				update_class_fields -- Current might have been changed; synchronize
				l_ftp.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_BODY
				update_class_fields -- Current might have been changed; synchronize
				l_ftp.item.downloadsize := (0).to_integer_64
				update_class_fields -- Current might have been changed; synchronize
				l_ftp.item.user := user
				update_class_fields -- Current might have been changed; synchronize
				l_ftp.item.passwd := passwd
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := isBadFtpString (l_ftp.item.user)
				update_class_fields -- Current might have been changed; synchronize
				if 1 = l_tmp___0.to_integer then
					Result := ({PC_CURLCODE}.CURLE_URL_MALFORMAT)
					l_return := True
				end
			end
			if not l_return then
				l_tmp___1 := isBadFtpString (l_ftp.item.passwd)
				update_class_fields -- Current might have been changed; synchronize
				if 1 = l_tmp___1.to_integer then
					Result := ({PC_CURLCODE}.CURLE_URL_MALFORMAT)
					l_return := True
				end
			end
			if not l_return then
				proto.ftpc.known_filesize := (-1).to_integer_64
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	ftp_connect (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_result: NATURAL_32
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_http_proxy: CE_ARRAY [PD_HTTP]
			l_ftp_save: CE_POINTER [PD_FTP]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_HTTP]} l_http_proxy.make (<<1>>)

			l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
			l_data := data
			l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))
			a_done.item := (0).to_boolean
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_reset_reqproto
			update_class_fields -- Current might have been changed; synchronize
			l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_init
			update_class_fields -- Current might have been changed; synchronize
			if {NATURAL_32} 0 /= l_result then
				Result := l_result
				l_return := True
			end
			if not l_return then
				bits.close := (0).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.response_time := 1_800_000
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.statemach_act := ftp_statemach_act_address
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.endofresp := (create {PD_PINGPONG_STATIC}).ftp_endofresp_address
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.conn := (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
				if bits.tunnel_proxy then
					if bits.httpproxy then
						l_ftp_save := l_data.item.state.proto.ftp
						memset (create {CE_VOID_POINTER}.make_cast (l_http_proxy), 0, (create {PD_HTTP}.make).structure_size.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.state.proto.http := l_http_proxy
						update_class_fields -- Current might have been changed; synchronize
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_proxyCONNECT (0, host.name, remote_port)
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.state.proto.ftp := l_ftp_save
						update_class_fields -- Current might have been changed; synchronize
						if {NATURAL_32} 0 /= l_result then
							Result := l_result
							l_return := True
						end
					end
				end
			end
			if not l_return and then (((protocol).bit_and (((1).bit_shift_left (3)).to_integer_32)).to_boolean) then
				l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
				if l_result.to_boolean then
					Result := l_result
					l_return := True
				end
			end
			if not l_return then
				l_pp.item.Curl_pp_init
				update_class_fields -- Current might have been changed; synchronize
				state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_WAIT220)
				update_class_fields -- Current might have been changed; synchronize
				if l_data.item.state.used_interface = {NATURAL_32} 2 then
					l_result := (create {P_FTP_STATIC}).ftp_multi_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), a_done)
					update_class_fields -- Current might have been changed; synchronize
				else
					l_result := ftp_easy_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
					if not l_result.to_boolean then
						a_done.item := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				Result := l_result
			end
		end

	ftp_done (a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ftp: CE_POINTER [PD_FTP]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_nread: CE_ARRAY [INTEGER_32]
			l_ftpcode: CE_ARRAY [INTEGER_32]
			l_result: NATURAL_32
			l_was_ctl_valid: BOOLEAN
			l_path: CE_POINTER [INTEGER_8]
			l_path_to_use: CE_POINTER [INTEGER_8]
			l_flen: NATURAL_32
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_dlen: NATURAL_32
			l_tmp___1: NATURAL_32
			l_old_time: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_nread.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_ftpcode.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					l_ftp := l_data.item.state.proto.ftp
					l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
					l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))
					l_result := {PC_CURLCODE}.CURLE_OK
					l_was_ctl_valid := l_ftpc.item.ctl_valid
					l_path_to_use := l_data.item.state.path
					if l_ftp.is_void then
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						inspect a_status.to_integer_32 -- switch 1 head
						when 36 then l_pos := -1 + 2
						when 13 then l_pos := -1 + 2
						when 30 then l_pos := -1 + 2
						when 17 then l_pos := -1 + 2
						when 19 then l_pos := -1 + 2
						when 25 then l_pos := -1 + 2
						when 9 then l_pos := -1 + 2
						when 63 then l_pos := -1 + 2
						when 78 then l_pos := -1 + 2
						when 23 then l_pos := -1 + 2
						when 0 then l_pos := -1 + 2
						else l_pos := -1 + 3
						end
				when 2 then -- switch 1, case 36 | switch 1, case 13 | switch 1, case 30 | switch 1, case 17 | switch 1, case 19 | switch 1, case 25 | switch 1, case 9 | switch 1, case 63 | switch 1, case 78 | switch 1, case 23 | switch 1, case 0
						if not a_premature then
							l_ftpc.item.ctl_valid := l_was_ctl_valid
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 4 -- switch 1; break
						end
				when 3 then -- switch 1, default:
						l_ftpc.item.ctl_valid := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						l_ftpc.item.cwdfail := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						bits.close := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						l_result := a_status
						l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
						if (not (l_ftpc.item.prevpath).is_void) then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_ftpc.item.prevpath)])
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_data.item.set.wildcardmatch then
							if (not (l_data.item.set.chunk_end).is_void) then
								if (not (l_ftpc.item.file).is_void) then
									(l_data.item.set.chunk_end).call ([l_data.item.wildcard.customptr])
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_ftpc.item.known_filesize := (-1).to_integer_64
							update_class_fields -- Current might have been changed; synchronize
						end
						l_path := (create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_cast (l_data), l_path_to_use, 0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if l_path.is_void then
							l_ftpc.item.prevpath := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						else
							if (not (l_ftpc.item.file).is_void) then
								l_tmp := strlen (l_ftpc.item.file)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___0 := l_tmp
							else
								l_tmp___0 := (0).to_natural_32
							end
							l_flen := l_tmp___0
							l_tmp___1 := strlen (l_path)
							update_class_fields -- Current might have been changed; synchronize
							l_dlen := l_tmp___1 - l_flen
							if not l_ftpc.item.cwdfail then
								if l_dlen.to_boolean then
									if l_data.item.set.ftp_filemethod /= {NATURAL_32} 2 then
										l_ftpc.item.prevpath := l_path
										update_class_fields -- Current might have been changed; synchronize
										if l_flen.to_boolean then
											l_ftpc.item.prevpath[l_dlen.to_integer_32] := (0).to_integer_8
											update_class_fields -- Current might have been changed; synchronize
										end
									else
										l_ftpc.item.prevpath := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([ce_string ("")]))
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_path)])
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									l_ftpc.item.prevpath := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([ce_string ("")]))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_path)])
									update_class_fields -- Current might have been changed; synchronize
								end
								if (not (l_ftpc.item.prevpath).is_void) then
									(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Remembering we are in dir %"%%s%"%N"), l_ftpc.item.prevpath])
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_ftpc.item.prevpath := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_path)])
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						freedirs (l_ftpc)
						update_class_fields -- Current might have been changed; synchronize
						if sock[1] /= -1 then
							if -1 /= sock[1] then
								close (sock[1]).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								sock[1] := -1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if l_ftp.item.transfer = {NATURAL_32} 0 then
							if l_ftpc.item.ctl_valid then
								if l_pp.item.pending_resp then
									if not a_premature then
										l_old_time := l_pp.item.response_time
										l_pp.item.response_time := 60_000
										update_class_fields -- Current might have been changed; synchronize
										l_pp.item.response := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
										update_class_fields -- Current might have been changed; synchronize
										l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_GetFTPResponse (l_nread, l_ftpcode)
										update_class_fields -- Current might have been changed; synchronize
										l_pp.item.response_time := l_old_time
										update_class_fields -- Current might have been changed; synchronize
										if not (l_nread.item).to_boolean then
											if {NATURAL_32} 28 = l_result then
												l_data.item.Curl_failf ([ce_string ("control connection looks dead")])
												update_class_fields -- Current might have been changed; synchronize
												l_ftpc.item.ctl_valid := (0).to_boolean
												update_class_fields -- Current might have been changed; synchronize
												bits.close := (1).to_boolean
												update_class_fields -- Current might have been changed; synchronize
											end
										end
										if l_result.to_boolean then
											Result := l_result
											l_return := True
										end
										if not l_return and then (not l_ftpc.item.dont_check) then
											if l_ftpcode.item /= 226 then
												if l_ftpcode.item /= 250 then
													l_data.item.Curl_failf ([ce_string ("server did not report OK, got %%d"), l_ftpcode.item])
													update_class_fields -- Current might have been changed; synchronize
													l_result := {PC_CURLCODE}.CURLE_PARTIAL_FILE
												end
											end
										end
									end
								end
							end
						end
				when 5 then -- if done
					if l_return then
						l_pos := -1 + 16 -- skip if block
					end
				when 6 then -- if:
						if l_result.to_boolean then
							l_pos := -1 + 15 -- skip if block
						end
				when 7 then -- if:
						if a_premature then
							l_pos := -1 + 15 -- skip if block
						end
				when 8 then -- if:
						if not (l_data.item.set.upload) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if -{INTEGER_64} 1 /= l_data.item.set.infilesize then
							if l_data.item.set.infilesize /= (l_ftp.item.bytecountp).item then
								if not l_data.item.set.crlf then
									if l_ftp.item.transfer = {NATURAL_32} 0 then
										l_data.item.Curl_failf ([ce_string ("Uploaded unaligned file size (%%lld out of %%lld bytes)"), (l_ftp.item.bytecountp).item, l_data.item.set.infilesize])
										update_class_fields -- Current might have been changed; synchronize
										l_result := {PC_CURLCODE}.CURLE_PARTIAL_FILE
									end
								end
							end
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 11 then -- else:
						if -{INTEGER_64} 1 = l_data.item.req.size then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if l_data.item.req.size /= (l_ftp.item.bytecountp).item then
							if l_data.item.req.size + l_data.item.state.crlf_conversions /= (l_ftp.item.bytecountp).item then
								if l_data.item.req.maxdownload /= (l_ftp.item.bytecountp).item then
									l_data.item.Curl_failf ([ce_string ("Received only partial file: %%lld bytes"), (l_ftp.item.bytecountp).item])
									update_class_fields -- Current might have been changed; synchronize
									l_result := {PC_CURLCODE}.CURLE_PARTIAL_FILE
								else
									l_pos := -1 + 14 -- goto _L___1
								end
							else
								l_pos := -1 + 14 -- goto _L___1
							end
						else
							l_pos := -1 + 14 -- goto _L___1
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L___1:
						if not l_ftpc.item.dont_check then
							if not ((l_ftp.item.bytecountp).item).to_boolean then
								if l_data.item.req.size > {INTEGER_64} 0 then
									l_data.item.Curl_failf ([ce_string ("No data was received!")])
									update_class_fields -- Current might have been changed; synchronize
									l_result := {PC_CURLCODE}.CURLE_FTP_COULDNT_RETR_FILE
								end
							end
						end
				when 15 then -- if done | if done | if done
						l_ftp.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_BODY
						update_class_fields -- Current might have been changed; synchronize
						l_ftpc.item.dont_check := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						if not a_status.to_boolean then
							if not l_result.to_boolean then
								if not a_premature then
									if (not (l_data.item.set.postquote).is_void) then
										l_result := ftp_sendquote ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_data.item.set.postquote)
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
						end
						Result := l_result
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_need_type (a_ascii_wanted: BOOLEAN): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_ascii_wanted then
				l_tmp := ('A').code
			else
				l_tmp := ('I').code
			end
			Result := ((proto.ftpc.transfertype).to_integer_32 /= l_tmp).to_integer
		end

	ftp_pasv_verbose (a_ai: CE_POINTER [PD_CURL_ADDRINFO]; a_newhost: CE_POINTER [INTEGER_8]; a_port: INTEGER_32)
		require
			not a_ai.is_void
		local
			l_buf: CE_ARRAY [INTEGER_8]
		do
			create {CE_INTEGER_8_ARRAY} l_buf.make (<<256>>)

			Curl_printable_address (a_ai, l_buf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32)).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SENDF_STATIC}).Curl_infof ([data, ce_string ("Connecting to %%s (%%s) port %%d%N"), a_newhost, l_buf, a_port])
			update_class_fields -- Current might have been changed; synchronize
		end

	ftp_range: NATURAL_32
		local
			l_from: INTEGER_64
			l_to: INTEGER_64
			l_ptr: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_ptr2: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_tmp: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_ptr.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_ptr2.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
					if not (l_data.item.state.use_range) then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						if (l_data.item.state.range).is_void then
							l_pos := -1 + 8 -- skip if block
						end
				when 2 then -- if:
						l_from := strtoll (l_data.item.state.range, l_ptr, 0)
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_ptr.item[0]).to_boolean then
								l_tmp := ctype_b_loc
								update_class_fields -- Current might have been changed; synchronize
								if not (((l_tmp.item[((l_ptr.item[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
									if (l_ptr.item[0]).to_integer_32 /= 45 then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_ptr.item := l_ptr.item + 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						l_to := strtoll (l_ptr.item, l_ptr2, 0)
						update_class_fields -- Current might have been changed; synchronize
						if (l_ptr.item).is_equal (l_ptr2.item) then
							l_to := (-1).to_integer_64
						end
						if -{INTEGER_64} 1 /= l_to then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_from >= {INTEGER_64} 0 then
							l_data.item.state.resume_from := l_from
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if l_from < {INTEGER_64} 0 then
							l_data.item.req.maxdownload := -l_from
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.state.resume_from := l_from
							update_class_fields -- Current might have been changed; synchronize
						else
							l_data.item.req.maxdownload := (l_to - l_from) + {INTEGER_64} 1
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.state.resume_from := l_from
							update_class_fields -- Current might have been changed; synchronize
						end
				when 6 then
						l_ftpc.item.dont_check := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_data.item.req.maxdownload := (-1).to_integer_64
						update_class_fields -- Current might have been changed; synchronize
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_data.item.req.maxdownload := (-1).to_integer_64
						update_class_fields -- Current might have been changed; synchronize
				when 11 then -- if done
					Result := ({PC_CURLCODE}.CURLE_OK)
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_nextconnect: NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_result: NATURAL_32
			l_ftp: CE_POINTER [PD_FTP]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
					l_result := {PC_CURLCODE}.CURLE_OK
					l_ftp := l_data.item.state.proto.ftp
					if not (l_ftp.item.transfer <= {NATURAL_32} 1) then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if not (l_data.item.set.upload) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_result := ftp_nb_type ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_data.item.set.prefer_ascii, {PC_FTPSTATE}.FTP_STOR_TYPE)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 4 then -- else:
						l_ftp.item.downloadsize := (-1).to_integer_64
						update_class_fields -- Current might have been changed; synchronize
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_range
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if:
						if not (l_data.item.set.ftp_list_only) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if (not (l_ftpc.item.file).is_void) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | _L:
						if l_ftp.item.transfer = {NATURAL_32} 0 then
							l_result := ftp_nb_type ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), (1).to_boolean, {PC_FTPSTATE}.FTP_LIST_TYPE)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_result := ftp_nb_type ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_data.item.set.prefer_ascii, {PC_FTPSTATE}.FTP_RETR_TYPE)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
				when 12 then -- if done | if done | if done
						if not l_return then
							l_result := ftp_easy_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 13 then -- if done
					if not l_return then
						if l_result = {NATURAL_32} 0 then
							if l_ftp.item.transfer /= {NATURAL_32} 0 then
								((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (-1, (-1).to_integer_64, (0).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer), -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						Result := l_result
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_perform (a_connected, a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_dophase_done.is_void
		local
			l_result: NATURAL_32
			l_ftp: CE_POINTER [PD_FTP]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			if data.item.set.opt_no_body then
				l_ftp := data.item.state.proto.ftp
				l_ftp.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_INFO
				update_class_fields -- Current might have been changed; synchronize
			end
			a_dophase_done.item := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_quote ((1).to_boolean, {PC_FTPSTATE}.FTP_QUOTE)
			update_class_fields -- Current might have been changed; synchronize
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				if data.item.state.used_interface = {NATURAL_32} 2 then
					l_result := (create {P_FTP_STATIC}).ftp_multi_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), a_dophase_done)
					update_class_fields -- Current might have been changed; synchronize
				else
					l_result := ftp_easy_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
					a_dophase_done.item := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
				end
				a_connected.item := bits.tcpconnect
				update_class_fields -- Current might have been changed; synchronize
				if a_dophase_done.item then
				end
				Result := l_result
			end
		end

	init_wc_data: NATURAL_32
		local
			l_last_slash: CE_POINTER [INTEGER_8]
			l_path: CE_POINTER [INTEGER_8]
			l_wildcard: CE_POINTER [PD_WILDCARDDATA]
			l_ret: NATURAL_32
			l_ftp_tmp: CE_POINTER [PD_FTP_WC_TMPDATA]
			l_tmp: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			l_path := data.item.state.path
			l_wildcard := create {CE_CLASS_POINTER [PD_WILDCARDDATA]}.make_shared (data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("wildcard"))
			l_ret := {PC_CURLCODE}.CURLE_OK
			l_last_slash := strrchr (data.item.state.path, ('/').code)
			update_class_fields -- Current might have been changed; synchronize
			if (not l_last_slash.is_void) then
				l_last_slash := l_last_slash + 1
				if (l_last_slash[0]).to_integer_32 = 0 then
					l_wildcard.item.state := {PC_CURL_WILDCARD_STATES}.CURLWC_CLEAN
					update_class_fields -- Current might have been changed; synchronize
					l_ret := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_parse_url_path
					update_class_fields -- Current might have been changed; synchronize
					Result := l_ret
					l_return := True
				else
					l_wildcard.item.pattern := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_last_slash]))
					update_class_fields -- Current might have been changed; synchronize
					if (l_wildcard.item.pattern).is_void then
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						l_return := True
					end
					if not l_return then
						l_last_slash[0] := (('%/0/').code).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			elseif (l_path[0]).to_boolean then
				l_wildcard.item.pattern := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_path]))
				update_class_fields -- Current might have been changed; synchronize
				if (l_wildcard.item.pattern).is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
				if not l_return then
					l_path[0] := (('%/0/').code).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				l_wildcard.item.state := {PC_CURL_WILDCARD_STATES}.CURLWC_CLEAN
				update_class_fields -- Current might have been changed; synchronize
				l_ret := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_parse_url_path
				update_class_fields -- Current might have been changed; synchronize
				Result := l_ret
				l_return := True
			end
			if not l_return then
				l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(create {PD_FTP_WC_TMPDATA}.make).structure_size.to_natural_32]))
				update_class_fields -- Current might have been changed; synchronize
				l_ftp_tmp := create {CE_CLASS_POINTER [PD_FTP_WC_TMPDATA]}.make_cast (l_tmp)
				if l_ftp_tmp.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				l_ftp_tmp.item.parser := Curl_ftp_parselist_data_alloc
				update_class_fields -- Current might have been changed; synchronize
				if (l_ftp_tmp.item.parser).is_void then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_ftp_tmp)])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				l_wildcard.item.tmp := create {CE_VOID_POINTER}.make_cast (l_ftp_tmp)
				update_class_fields -- Current might have been changed; synchronize
				l_wildcard.item.tmp_dtor := (create {P_FTP_STATIC}).wc_data_dtor_address
				update_class_fields -- Current might have been changed; synchronize
				if data.item.set.ftp_filemethod = {NATURAL_32} 2 then
					data.item.set.ftp_filemethod := {PC_CURL_FTPFILE}.FTPFILE_MULTICWD
					update_class_fields -- Current might have been changed; synchronize
				end
				l_ret := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_parse_url_path
				update_class_fields -- Current might have been changed; synchronize
				if l_ret.to_boolean then
					Result := l_ret
					l_return := True
				end
			end
			if not l_return then
				l_ftp_tmp.item.backup.write_function := data.item.set.fwrite_func
				update_class_fields -- Current might have been changed; synchronize
				data.item.set.fwrite_func := (create {P_FTPLISTPARSER_STATIC}).Curl_ftp_parselist_address
				update_class_fields -- Current might have been changed; synchronize
				l_ftp_tmp.item.backup.file_descriptor := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (data.item.set.out2)
				update_class_fields -- Current might have been changed; synchronize
				data.item.set.out2 := create {CE_VOID_POINTER}.make_shared (c_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_wildcard.item.path := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([data.item.state.path]))
				update_class_fields -- Current might have been changed; synchronize
				if (l_wildcard.item.path).is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				(create {P_SENDF_STATIC}).Curl_infof ([data, ce_string ("Wildcard - Parsing started%N")])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	wc_statemach: NATURAL_32
		local
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_wildcard: CE_POINTER [PD_WILDCARDDATA]
			l_ftp_tmp: CE_POINTER [PD_FTP_WC_TMPDATA]
			l_tmp_path: CE_POINTER [INTEGER_8]
			l_ret: NATURAL_32
			l_userresponse: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_finfo: CE_POINTER [PD_CURL_FILEINFO]
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: NATURAL_32
			l_tmp___5: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
					l_wildcard := create {CE_CLASS_POINTER [PD_WILDCARDDATA]}.make_shared (data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("wildcard"))
					l_ftp_tmp := create {CE_CLASS_POINTER [PD_FTP_WC_TMPDATA]}.make_cast (l_wildcard.item.tmp)
					l_ret := {PC_CURLCODE}.CURLE_OK
					l_userresponse := 0
					inspect (l_wildcard.item.state).to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 3
					when 2 then l_pos := -1 + 4
					when 4 then l_pos := -1 + 10
					when 3 then l_pos := -1 + 11
					when 6 then l_pos := -1 + 12
					when 5 then l_pos := -1 + 12
					else l_pos := -1 + 13
					end
				when 1 then -- switch 1, case 0
					l_ret := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.init_wc_data
					update_class_fields -- Current might have been changed; synchronize
					if l_wildcard.item.state = {NATURAL_32} 3 then
						l_pos := -1 + 13 -- switch 1; break
					elseif l_ret.to_boolean then
						l_wildcard.item.state := {PC_CURL_WILDCARD_STATES}.CURLWC_ERROR
						update_class_fields -- Current might have been changed; synchronize
					else
						l_wildcard.item.state := {PC_CURL_WILDCARD_STATES}.CURLWC_MATCHING
						update_class_fields -- Current might have been changed; synchronize
					end
				when 2 then
					l_pos := -1 + 13 -- switch 1; break
				when 3 then -- switch 1, case 1
					l_ftp_tmp := create {CE_CLASS_POINTER [PD_FTP_WC_TMPDATA]}.make_cast (l_wildcard.item.tmp)
					data.item.set.fwrite_func := l_ftp_tmp.item.backup.write_function
					update_class_fields -- Current might have been changed; synchronize
					data.item.set.out2 := create {CE_VOID_POINTER}.make_cast (l_ftp_tmp.item.backup.file_descriptor)
					update_class_fields -- Current might have been changed; synchronize
					l_wildcard.item.state := {PC_CURL_WILDCARD_STATES}.CURLWC_DOWNLOADING
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := Curl_ftp_parselist_geterror (l_ftp_tmp.item.parser)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___0.to_boolean then
						l_wildcard.item.state := {PC_CURL_WILDCARD_STATES}.CURLWC_CLEAN
						update_class_fields -- Current might have been changed; synchronize
						l_tmp := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.wc_statemach
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp
						l_return := True
					elseif (l_wildcard.item.filelist).item.size = {NATURAL_32} 0 then
						l_wildcard.item.state := {PC_CURL_WILDCARD_STATES}.CURLWC_CLEAN
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_REMOTE_FILE_NOT_FOUND)
						l_return := True
					end
					if not l_return then
						l_ret := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.wc_statemach
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 13 -- switch 1; break
				when 4 then -- switch 1, case 2
					l_finfo := create {CE_CLASS_POINTER [PD_CURL_FILEINFO]}.make_cast (((l_wildcard.item.filelist).item.head).item.ptr)
					l_tmp___1 := strlen (data.item.state.path)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := strlen (l_finfo.item.filename)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___3 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(l_tmp___1 + l_tmp___2) + {NATURAL_32} 1]))
					update_class_fields -- Current might have been changed; synchronize
					l_tmp_path := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___3)
					if l_tmp_path.is_void then
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 5 then -- if:
						l_tmp_path[0] := (0).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						strcat (l_tmp_path, l_wildcard.item.path).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						strcat (l_tmp_path, l_finfo.item.filename).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if (not (data.item.state.pathbuffer).is_void) then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (data.item.state.pathbuffer)])
							update_class_fields -- Current might have been changed; synchronize
						end
						data.item.state.pathbuffer := l_tmp_path
						update_class_fields -- Current might have been changed; synchronize
						data.item.state.path := l_tmp_path
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SENDF_STATIC}).Curl_infof ([data, ce_string ("Wildcard - START of %"%%s%"%N"), l_finfo.item.filename])
						update_class_fields -- Current might have been changed; synchronize
						if (data.item.set.chunk_bgn).is_void then
							l_pos := -1 + 9 -- skip if block
						end
				when 6 then -- if:
						l_userresponse := (data.item.set.chunk_bgn).integer_32_item ([create {CE_VOID_POINTER}.make_cast (l_finfo), l_wildcard.item.customptr, ((l_wildcard.item.filelist).item.size).to_integer_32])
						update_class_fields -- Current might have been changed; synchronize
						inspect l_userresponse.to_integer_32 -- switch 2 head
						when 2 then l_pos := -1 + 7
						when 1 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 7 then -- switch 2, case 2;
						(create {P_SENDF_STATIC}).Curl_infof ([data, ce_string ("Wildcard - %"%%s%" skipped by user%N"), l_finfo.item.filename])
						update_class_fields -- Current might have been changed; synchronize
						l_wildcard.item.state := {PC_CURL_WILDCARD_STATES}.CURLWC_SKIP
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___4 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.wc_statemach
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___4
						l_return := True
				when 8 then -- switch 2, case 1
						if not l_return then
							Result := ({PC_CURLCODE}.CURLE_CHUNK_FAILED)
							l_return := True
						end
				when 9 then -- switch 2, done: | if done | if done
					if not l_return and then (l_finfo.item.filetype /= {NATURAL_32} 0) then
						l_wildcard.item.state := {PC_CURL_WILDCARD_STATES}.CURLWC_SKIP
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___5 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.wc_statemach
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___5
						l_return := True
					end
					if not l_return then
						if ((l_finfo.item.flags).bit_and (((1).bit_shift_left (6)).to_natural_32)).to_boolean then
							l_ftpc.item.known_filesize := l_finfo.item.size
							update_class_fields -- Current might have been changed; synchronize
						end
						l_ret := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_parse_url_path
						update_class_fields -- Current might have been changed; synchronize
						if l_ret.to_boolean then
							Result := l_ret
							l_return := True
						end
					end
					if not l_return then
						(l_wildcard.item.filelist).item.Curl_llist_remove ((l_wildcard.item.filelist).item.head, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if (l_wildcard.item.filelist).item.size = {NATURAL_32} 0 then
							l_wildcard.item.state := {PC_CURL_WILDCARD_STATES}.CURLWC_CLEAN
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						end
					end
					l_pos := -1 + 13 -- switch 1; break
				when 10 then -- switch 1, case 4
					if (not (data.item.set.chunk_end).is_void) then
						(data.item.set.chunk_end).call ([data.item.wildcard.customptr])
						update_class_fields -- Current might have been changed; synchronize
					end
					(l_wildcard.item.filelist).item.Curl_llist_remove ((l_wildcard.item.filelist).item.head, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					if (l_wildcard.item.filelist).item.size = {NATURAL_32} 0 then
						l_wildcard.item.state := {PC_CURL_WILDCARD_STATES}.CURLWC_CLEAN
						update_class_fields -- Current might have been changed; synchronize
					else
						l_wildcard.item.state := {PC_CURL_WILDCARD_STATES}.CURLWC_DOWNLOADING
						update_class_fields -- Current might have been changed; synchronize
					end
					l_ret := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.wc_statemach
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 13 -- switch 1; break
				when 11 then -- switch 1, case 3
					l_ret := {PC_CURLCODE}.CURLE_OK
					if (not l_ftp_tmp.is_void) then
						l_ret := Curl_ftp_parselist_geterror (l_ftp_tmp.item.parser)
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_ret.to_boolean then
						l_wildcard.item.state := {PC_CURL_WILDCARD_STATES}.CURLWC_ERROR
						update_class_fields -- Current might have been changed; synchronize
					else
						l_wildcard.item.state := {PC_CURL_WILDCARD_STATES}.CURLWC_DONE
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 13 -- switch 1; break
				when 12 then -- switch 1, case 6 | switch 1, case 5
					l_pos := -1 + 13 -- switch 1; break
				when 13 then -- switch 1, done:
					if not l_return then
						Result := l_ret
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_do (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_retcode: NATURAL_32
			l_return: BOOLEAN
		do
			l_retcode := {PC_CURLCODE}.CURLE_OK
			a_done.item := (0).to_boolean
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_reset_reqproto
			update_class_fields -- Current might have been changed; synchronize
			l_retcode := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_init
			update_class_fields -- Current might have been changed; synchronize
			if l_retcode.to_boolean then
				Result := l_retcode
				l_return := True
			end
			if not l_return then
				if data.item.set.wildcardmatch then
					l_retcode := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.wc_statemach
					update_class_fields -- Current might have been changed; synchronize
					if data.item.wildcard.state = {NATURAL_32} 4 then
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
					elseif data.item.wildcard.state = {NATURAL_32} 6 then
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
					end
					if not l_return and then (l_retcode.to_boolean) then
						Result := l_retcode
						l_return := True
					end
				else
					l_retcode := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_parse_url_path
					update_class_fields -- Current might have been changed; synchronize
					if l_retcode.to_boolean then
						Result := l_retcode
						l_return := True
					end
				end
			end
			if not l_return then
				l_retcode := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_regular_transfer (a_done)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_retcode
			end
		end

	Curl_ftpsendf (a_args: TUPLE [a_fmt: CE_POINTER [INTEGER_8]]): NATURAL_32
		local
			l_bytes_written: CE_ARRAY [INTEGER_32]
			l_s: CE_ARRAY [INTEGER_8]
			l_write_len: NATURAL_32
			l_sptr: CE_POINTER [INTEGER_8]
			l_res: NATURAL_32
			l_ap: CE_VA_LIST
			l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_bytes_written.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_s.make (<<1_024>>)
			create l_ap.make_shared (default_pointer)

			l_sptr := l_s
			l_res := {PC_CURLCODE}.CURLE_OK
			l_ap := create {CE_VA_LIST}.make (a_args, agent Curl_ftpsendf);
			(create {P_MPRINTF_STATIC}).curl_mvsnprintf (l_s, (1_021).to_natural_32, a_args.a_fmt, l_ap.twin).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			strcat (l_s, ce_string ("%R%N")).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_bytes_written.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_write_len := strlen (l_s)
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				(l_break)
			loop
				l_break := False
				l_res := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_write (sock[0], create {CE_VOID_POINTER}.make_cast (l_sptr), l_write_len, l_bytes_written)
				update_class_fields -- Current might have been changed; synchronize
				if {NATURAL_32} 0 /= l_res then
					l_break := True
				end
				if not (l_break) then
					if data.item.set.verbose then
						data.item.Curl_debug ({PC_CURL_INFOTYPE}.CURLINFO_HEADER_OUT, l_sptr, (l_bytes_written.item).to_natural_32, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_bytes_written.item /= l_write_len.to_integer_32 then
						l_write_len := l_write_len - (l_bytes_written.item).to_natural_32
						l_sptr := l_sptr + (l_bytes_written.item)
					else
						l_break := True
					end
				end
			end
			l_break := False
			Result := l_res
		end

	ftp_quit: NATURAL_32
		local
			l_result: NATURAL_32
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			if proto.ftpc.ctl_valid then
				l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc") + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("QUIT"), create {CE_VOID_POINTER}.make_shared (default_pointer)])
				update_class_fields -- Current might have been changed; synchronize
				if l_result /= {NATURAL_32} 0 then
					Result := l_result
					l_return := True
				end
				if not l_return then
					state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_QUIT)
					update_class_fields -- Current might have been changed; synchronize
					l_result := ftp_easy_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				Result := l_result
			end
		end

	ftp_disconnect: NATURAL_32
		local
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
			l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"));
			((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_quit.do_nothing
			update_class_fields -- Current might have been changed; synchronize
			if (not (l_ftpc.item.entrypath).is_void) then
				l_data := data
				if (l_data.item.state.most_recent_ftp_entrypath).is_equal (l_ftpc.item.entrypath) then
					l_data.item.state.most_recent_ftp_entrypath := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_ftpc.item.entrypath)])
				update_class_fields -- Current might have been changed; synchronize
				l_ftpc.item.entrypath := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			freedirs (l_ftpc)
			update_class_fields -- Current might have been changed; synchronize
			if (not (l_ftpc.item.prevpath).is_void) then
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_ftpc.item.prevpath)])
				update_class_fields -- Current might have been changed; synchronize
				l_ftpc.item.prevpath := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not (l_ftpc.item.server_os).is_void) then
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_ftpc.item.server_os)])
				update_class_fields -- Current might have been changed; synchronize
				l_ftpc.item.server_os := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			l_pp.item.Curl_pp_disconnect.do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	ftp_parse_url_path: NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ftp: CE_POINTER [PD_FTP]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_slash_pos: CE_POINTER [INTEGER_8]
			l_path_to_use: CE_POINTER [INTEGER_8]
			l_cur_pos: CE_POINTER [INTEGER_8]
			l_filename: CE_POINTER [INTEGER_8]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [ANY]
			l_absolute_dir: BOOLEAN
			l_tmp___5: INTEGER_32
			l_len: INTEGER_32
			l_tmp___6: BOOLEAN
			l_bigger: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: INTEGER_32
			l_tmp___10: BOOLEAN
			l_dlen: CE_ARRAY [INTEGER_32]
			l_path: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: NATURAL_32
			l_tmp___13: INTEGER_32
			l_tmp___14: NATURAL_32
			l_tmp___15: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_dlen.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					l_ftp := l_data.item.state.proto.ftp
					l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
					l_path_to_use := l_data.item.state.path
					l_filename := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_cur_pos := l_path_to_use
					l_ftpc.item.ctl_valid := (0).to_boolean
					update_class_fields -- Current might have been changed; synchronize
					l_ftpc.item.cwdfail := (0).to_boolean
					update_class_fields -- Current might have been changed; synchronize
					inspect (l_data.item.set.ftp_filemethod).to_integer_32 -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 2
					else l_pos := -1 + 11
					end
				when 1 then -- switch 1, case 2
					if (not (l_data.item.state.path).is_void) then
						if (l_data.item.state.path[0]).to_boolean then
							l_tmp := strlen (l_data.item.state.path)
							update_class_fields -- Current might have been changed; synchronize
							if (l_data.item.state.path[(l_tmp - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 47 then
								l_filename := l_data.item.state.path
							end
						end
					end
					l_pos := -1 + 12 -- switch 1; break
				when 2 then -- switch 1, case 3
					if not (l_path_to_use[0]).to_boolean then
						l_ftpc.item.dirdepth := 0
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 12 -- switch 1; break
					end
				when 3 then
					l_tmp___0 := strrchr (l_cur_pos, ('/').code)
					update_class_fields -- Current might have been changed; synchronize
					l_slash_pos := l_tmp___0
					if l_slash_pos.is_void then
						l_pos := -1 + 6 -- skip if block
					end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if (l_cur_pos[0]).to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						l_tmp___1 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, {PLATFORM}.Pointer_bytes.to_natural_32]))
						update_class_fields -- Current might have been changed; synchronize
						l_ftpc.item.dirs := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (l_tmp___1)
						update_class_fields -- Current might have been changed; synchronize
						if (l_ftpc.item.dirs).is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							if (not l_slash_pos.is_void) then
								l_tmp___2 := l_slash_pos.distance (l_cur_pos)
							else
								l_tmp___2 := 1
							end
							if (not l_slash_pos.is_void) then
								l_tmp___3 := l_cur_pos
							else
								l_tmp___3 := ce_string ("/")
							end
							l_ftpc.item.dirs[0] := (create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_cast (data), l_tmp___3, l_tmp___2, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
							if (l_ftpc.item.dirs[0]).is_void then
								freedirs (l_ftpc)
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								l_return := True
							end
						end
						if not l_return then
							l_ftpc.item.dirdepth := 1
							update_class_fields -- Current might have been changed; synchronize
							if (not l_slash_pos.is_void) then
								l_filename := l_slash_pos + 1
							else
								l_filename := l_cur_pos
							end
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_filename := l_cur_pos
				when 10 then -- if done
					l_pos := -1 + 12 -- switch 1; break
				when 11 then -- switch 1, default:
					l_ftpc.item.dirdepth := 0
					update_class_fields -- Current might have been changed; synchronize
					l_ftpc.item.diralloc := 5
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___4 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(l_ftpc.item.diralloc).to_natural_32, {PLATFORM}.Pointer_bytes.to_natural_32]))
					update_class_fields -- Current might have been changed; synchronize
					l_ftpc.item.dirs := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (l_tmp___4)
					update_class_fields -- Current might have been changed; synchronize
					if (l_ftpc.item.dirs).is_void then
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						l_return := True
					end
					if not l_return then
						l_tmp___9 := (create {P_STREQUAL_STATIC}).curl_strequal (l_path_to_use, ce_string ("/"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___9.to_boolean then
							l_cur_pos := l_cur_pos + 1
							l_ftpc.item.dirs[0] := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([ce_string ("/")]))
							update_class_fields -- Current might have been changed; synchronize
							l_ftpc.item.dirdepth := (l_ftpc.item.dirdepth) + 1
							update_class_fields -- Current might have been changed; synchronize
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_continue := False
								l_tmp___8 := strchr (l_cur_pos, ('/').code)
								update_class_fields -- Current might have been changed; synchronize
								l_slash_pos := l_tmp___8
								if l_slash_pos.is_void then
									l_break := True
								end
								if not (l_return or l_break or l_continue) then
									if l_cur_pos.distance ((l_data.item.state.path)) > 0 then
										if l_ftpc.item.dirdepth = 0 then
											l_tmp___5 := 1
										else
											l_tmp___5 := 0
										end
									else
										l_tmp___5 := 0
									end
									l_absolute_dir := l_tmp___5.to_boolean
									if (l_slash_pos.distance (l_cur_pos)).to_boolean then
										l_len := (l_slash_pos.distance (l_cur_pos)) + l_absolute_dir.to_integer
										l_ftpc.item.dirs[l_ftpc.item.dirdepth] := (create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_cast (data), l_cur_pos - l_absolute_dir.to_integer, l_len, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
										update_class_fields -- Current might have been changed; synchronize
										if (l_ftpc.item.dirs[l_ftpc.item.dirdepth]).is_void then
											l_data.item.Curl_failf ([ce_string ("no memory")])
											update_class_fields -- Current might have been changed; synchronize
											freedirs (l_ftpc)
											update_class_fields -- Current might have been changed; synchronize
											Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
											l_return := True
										end
										if not l_return then
											l_tmp___6 := isBadFtpString (l_ftpc.item.dirs[l_ftpc.item.dirdepth])
											update_class_fields -- Current might have been changed; synchronize
											if l_tmp___6 then
												(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_ftpc.item.dirs[l_ftpc.item.dirdepth])])
												update_class_fields -- Current might have been changed; synchronize
												freedirs (l_ftpc)
												update_class_fields -- Current might have been changed; synchronize
												Result := ({PC_CURLCODE}.CURLE_URL_MALFORMAT)
												l_return := True
											end
										end
									else
										l_cur_pos := l_slash_pos + 1
										l_continue := True
									end
								end
								if not (l_return or l_break or l_continue) then
									l_cur_pos := l_slash_pos + 1
									l_ftpc.item.dirdepth := (l_ftpc.item.dirdepth) + 1
									update_class_fields -- Current might have been changed; synchronize
									if l_ftpc.item.dirdepth >= l_ftpc.item.diralloc then
										l_ftpc.item.diralloc := l_ftpc.item.diralloc * (2)
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___7 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_crealloc.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_ftpc.item.dirs), (l_ftpc.item.diralloc).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32]))
										update_class_fields -- Current might have been changed; synchronize
										l_bigger := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___7)
										if l_bigger.is_void then
											freedirs (l_ftpc)
											update_class_fields -- Current might have been changed; synchronize
											Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
											l_return := True
										end
										if not l_return then
											l_ftpc.item.dirs := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (l_bigger)
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								end
							end
							if not l_return then
								l_break := False
								l_continue := False
							end
						end
					end
					if not l_return then
						l_filename := l_cur_pos
					end
					l_pos := -1 + 12 -- switch 1; break
				when 12 then -- switch 1, done:
					if not l_return then
						if (not l_filename.is_void) then
							if (l_filename[0]).to_boolean then
								l_ftpc.item.file := (create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_cast (data), l_filename, 0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
								if (l_ftpc.item.file).is_void then
									freedirs (l_ftpc)
									update_class_fields -- Current might have been changed; synchronize
									l_data.item.Curl_failf ([ce_string ("no memory")])
									update_class_fields -- Current might have been changed; synchronize
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									l_return := True
								end
								if not l_return then
									l_tmp___10 := isBadFtpString (l_ftpc.item.file)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___10 then
										freedirs (l_ftpc)
										update_class_fields -- Current might have been changed; synchronize
										Result := ({PC_CURLCODE}.CURLE_URL_MALFORMAT)
										l_return := True
									end
								end
							else
								l_ftpc.item.file := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_ftpc.item.file := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if not l_return and then (l_data.item.set.upload) then
						if (l_ftpc.item.file).is_void then
							if l_ftp.item.transfer = {NATURAL_32} 0 then
								l_data.item.Curl_failf ([ce_string ("Uploading to a URL without a file name!")])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_URL_MALFORMAT)
								l_return := True
							end
						end
					end
					if not l_return then
						l_ftpc.item.cwddone := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						if (not (l_ftpc.item.prevpath).is_void) then
							l_tmp___11 := (create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_cast (data), l_data.item.state.path, 0, l_dlen)
							update_class_fields -- Current might have been changed; synchronize
							l_path := l_tmp___11
							if l_path.is_void then
								freedirs (l_ftpc)
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								l_return := True
							end
							if not l_return then
								if (not (l_ftpc.item.file).is_void) then
									l_tmp___12 := strlen (l_ftpc.item.file)
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___13 := l_tmp___12.to_integer_32
								else
									l_tmp___13 := 0
								end
								l_dlen.item := l_dlen.item - l_tmp___13
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___14 := strlen (l_ftpc.item.prevpath)
								update_class_fields -- Current might have been changed; synchronize
								if l_dlen.item = l_tmp___14.to_integer_32 then
									l_tmp___15 := curl_strnequal (l_path, l_ftpc.item.prevpath, (l_dlen.item).to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___15.to_boolean then
										(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Request has same path as previous transfer%N")])
										update_class_fields -- Current might have been changed; synchronize
										l_ftpc.item.cwddone := (1).to_boolean
										update_class_fields -- Current might have been changed; synchronize
									end
								end
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_path)])
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
					if not l_return then
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_dophase_done (a_connected: BOOLEAN): NATURAL_32
		local
			l_result: NATURAL_32
			l_ftp: CE_POINTER [PD_FTP]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_ftp := data.item.state.proto.ftp
			l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
			if a_connected then
				l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_nextconnect
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_result.to_boolean then
				if sock[1] /= -1 then
					close (sock[1]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					sock[1] := -1
					update_class_fields -- Current might have been changed; synchronize
					Result := l_result
					l_return := True
				end
			end
			if not l_return then
				if l_ftp.item.transfer /= {NATURAL_32} 0 then
					((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (-1, (-1).to_integer_64, (0).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer), -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
					update_class_fields -- Current might have been changed; synchronize
				elseif not a_connected then
					bits.do_more := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
				end
				l_ftpc.item.ctl_valid := (1).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				Result := l_result
			end
		end

	ftp_regular_transfer (a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_dophase_done.is_void
		local
			l_result: NATURAL_32
			l_connected: CE_ARRAY [BOOLEAN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_return: BOOLEAN
		do
			create {CE_BOOLEAN_ARRAY} l_connected.make (<<1>>)

			l_result := {PC_CURLCODE}.CURLE_OK
			l_connected.item := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			l_data := data
			l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
			l_data.item.req.size := (-1).to_integer_64
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetUploadCounter ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetDownloadCounter ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetUploadSize ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetDownloadSize ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_ftpc.item.ctl_valid := (1).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_perform (l_connected, a_dophase_done)
			update_class_fields -- Current might have been changed; synchronize
			if {NATURAL_32} 0 = l_result then
				if not a_dophase_done.item then
					Result := ({PC_CURLCODE}.CURLE_OK)
					l_return := True
				end
				if not l_return then
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_dophase_done (l_connected.item)
					update_class_fields -- Current might have been changed; synchronize
					if l_result.to_boolean then
						Result := l_result
						l_return := True
					end
				end
			else
				freedirs (l_ftpc)
				update_class_fields -- Current might have been changed; synchronize
			end
			if not l_return then
				Result := l_result
			end
		end

	ftp_setup_connection: NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_type: CE_POINTER [INTEGER_8]
			l_command: INTEGER_8
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					if bits.httpproxy then
						if not l_data.item.set.tunnel_thru_httpproxy then
							if handler.is_equal ((create {P_FTP_STATIC}).Curl_handler_ftp.item) then
								Current.handler := Curl_handler_ftp_proxy.item
								update_class_fields -- Current might have been changed; synchronize
							else
								l_data.item.Curl_failf ([ce_string ("FTPS not supported!")])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_UNSUPPORTED_PROTOCOL)
								l_return := True
							end
							if not l_return then
								bits.close := (0).to_boolean
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_data.item.state.path := (l_data.item.state.path) + 1
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.state.slash_removed := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						l_type := strstr (l_data.item.state.path, ce_string (";type="))
						update_class_fields -- Current might have been changed; synchronize
						if l_type.is_void then
							l_type := strstr (host.rawalloc, ce_string (";type="))
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_type.is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						l_type[0] := (0).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_command := (create {P_RAWSTR_STATIC}).Curl_raw_toupper (l_type[6])
						update_class_fields -- Current might have been changed; synchronize
						bits.type_set := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						inspect l_command.to_integer_32 -- switch 1 head
						when 65 then l_pos := -1 + 3
						when 68 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 3 then -- switch 1, case 65
						l_data.item.set.prefer_ascii := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 68
						l_data.item.set.ftp_list_only := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
						l_data.item.set.prefer_ascii := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done: | if done
						Result := ({PC_CURLCODE}.CURLE_OK)
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ConnectionDone
		do
			Current.inuse := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
		end

	Curl_connected_proxy: NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data := data
					inspect (l_data.item.set.proxytype).to_integer_32 -- switch 1 head
					when 5 then l_pos := -1 + 1
					when 7 then l_pos := -1 + 1
					when 4 then l_pos := -1 + 2
					when 6 then l_pos := -1 + 3
					when 0 then l_pos := -1 + 4
					when 1 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 5 | switch 1, case 7
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_SOCKS5 (proxyuser, proxypasswd, host.name, remote_port.to_integer_32, 0)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 6 -- switch 1; break
				when 2 then -- switch 1, case 4
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_SOCKS4 (proxyuser, host.name, remote_port.to_integer_32, 0, (0).to_boolean)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 6
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_SOCKS4 (proxyuser, host.name, remote_port.to_integer_32, 0, (1).to_boolean)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 0 | switch 1, case 1
					l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
					l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
					Result := l_result
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_verboseconnect
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			if data.item.set.verbose then
				if bits.proxy then
					l_tmp := proxy.dispname
				else
					l_tmp := host.dispname
				end
				(create {P_SENDF_STATIC}).Curl_infof ([data, ce_string ("Connected to %%s (%%s) port %%ld (#%%ld)%N"), l_tmp, ip_addr_str, port, connectindex])
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	Curl_protocol_connect (a_protocol_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_protocol_done.is_void
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			a_protocol_done.item := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			if bits.tcpconnect then
				if bits.protoconnstart then
					if (handler.item.connecting).is_void then
						a_protocol_done.item := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
					end
					Result := ({PC_CURLCODE}.CURLE_OK)
					l_return := True
				end
			end
			if not l_return then
				if not bits.tcpconnect then
					(create {P_PROGRESS_STATIC}).Curl_pgrsTime (l_data, {PC_TIMERID}.TIMER_CONNECT)
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_verboseconnect
					update_class_fields -- Current might have been changed; synchronize
				end
				if not bits.protoconnstart then
					if (not (handler.item.connect_it).is_void) then
						Current.now := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
						update_class_fields -- Current might have been changed; synchronize
						l_result := (handler.item.connect_it).natural_32_item ([(create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), a_protocol_done])
						update_class_fields -- Current might have been changed; synchronize
					else
						a_protocol_done.item := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
					end
					if not l_result.to_boolean then
						bits.protoconnstart := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				Result := l_result
			end
		end

	detect_proxy: CE_POINTER [INTEGER_8]
		local
			l_proxy: CE_POINTER [INTEGER_8]
			l_no_proxy: CE_POINTER [INTEGER_8]
			l_proxy_env: CE_ARRAY [INTEGER_8]
			l_protop: CE_POINTER [INTEGER_8]
			l_envp: CE_POINTER [INTEGER_8]
			l_prox: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_proxy_env.make (<<128>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_proxy := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_no_proxy := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_no_proxy := (create {P_GETENV_STATIC}).curl_getenv (ce_string ("no_proxy"))
					update_class_fields -- Current might have been changed; synchronize
					if l_no_proxy.is_void then
						l_no_proxy := (create {P_GETENV_STATIC}).curl_getenv (ce_string ("NO_PROXY"))
						update_class_fields -- Current might have been changed; synchronize
					end
					l_tmp___3 := (create {P_URL_STATIC}).check_noproxy (host.name, l_no_proxy)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___3 then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_protop := handler.item.scheme
						l_envp := l_proxy_env
						from
						until
							not ((l_protop[0]).to_boolean)
						loop
							l_tmp := l_envp
							l_envp := l_envp + 1
							l_tmp___0 := l_protop
							l_protop := l_protop + 1
							l_tmp___1 := tolower ((l_tmp___0[0]).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp[0] := l_tmp___1.to_integer_8
							update_class_fields -- Current might have been changed; synchronize
						end
						strcpy (l_envp, ce_string ("_proxy")).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_prox := (create {P_GETENV_STATIC}).curl_getenv (l_proxy_env)
						update_class_fields -- Current might have been changed; synchronize
						if l_prox.is_void then
							l_tmp___2 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (ce_string ("http_proxy"), l_proxy_env)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___2.to_boolean then
								Curl_strntoupper (l_proxy_env, l_proxy_env, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (128).to_natural_32))
								update_class_fields -- Current might have been changed; synchronize
								l_prox := (create {P_GETENV_STATIC}).curl_getenv (l_proxy_env)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if l_prox.is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (l_prox[0]).to_boolean then
							l_proxy := l_prox
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_proxy := (create {P_GETENV_STATIC}).curl_getenv (ce_string ("all_proxy"))
						update_class_fields -- Current might have been changed; synchronize
						if l_proxy.is_void then
							l_proxy := (create {P_GETENV_STATIC}).curl_getenv (ce_string ("ALL_PROXY"))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 5 then -- if done
					if (not l_no_proxy.is_void) then
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_no_proxy)])
						update_class_fields -- Current might have been changed; synchronize
					end
					Result := l_proxy
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	setup_conn (a_protocol_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_protocol_done.is_void
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_connected: CE_ARRAY [BOOLEAN]
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_BOOLEAN_ARRAY} l_connected.make (<<1>>)

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data;
			(create {P_PROGRESS_STATIC}).Curl_pgrsTime (l_data, {PC_TIMERID}.TIMER_NAMELOOKUP)
			update_class_fields -- Current might have been changed; synchronize
			if ((protocol).bit_and (((1).bit_shift_left (10)).to_integer_32)).to_boolean then
				a_protocol_done.item := (1).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				Result := l_result
				l_return := True
			end
			if not l_return then
				a_protocol_done.item := (0).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				bits.proxy_connect_closed := (0).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				if (not (l_data.item.set.str[25]).is_void) then
					(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (allocptr.uagent))
					update_class_fields -- Current might have been changed; synchronize
					allocptr.uagent := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("User-Agent: %%s%R%N"), l_data.item.set.str[25]])
					update_class_fields -- Current might have been changed; synchronize
					if (allocptr.uagent).is_void then
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						l_return := True
					end
				end
			end
			if not l_return then
				l_data.item.req.headerbytecount := 0
				update_class_fields -- Current might have been changed; synchronize
				l_data.item.state.crlf_conversions := (0).to_integer_64
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_continue := False
					if -1 = sock[0] then
						l_connected.item := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						l_result := ConnectPlease (l_data, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_connected)
						update_class_fields -- Current might have been changed; synchronize
						if l_connected.item then
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_protocol_connect (a_protocol_done)
							update_class_fields -- Current might have been changed; synchronize
							if {NATURAL_32} 0 = l_result then
								bits.tcpconnect := (1).to_boolean
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							bits.tcpconnect := (0).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
						if bits.proxy_connect_closed then
							if (not (l_data.item.set.errorbuffer).is_void) then
								l_data.item.set.errorbuffer[0] := (('%/0/').code).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
							end
							l_data.item.state.errorbuf := (0).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							l_continue := True
						end
						if not (l_return or l_break or l_continue) and then ({NATURAL_32} 0 /= l_result) then
							Result := l_result
							l_return := True
						end
					else
						(create {P_PROGRESS_STATIC}).Curl_pgrsTime (l_data, {PC_TIMERID}.TIMER_CONNECT)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_PROGRESS_STATIC}).Curl_pgrsTime (l_data, {PC_TIMERID}.TIMER_APPCONNECT)
						update_class_fields -- Current might have been changed; synchronize
						bits.tcpconnect := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						a_protocol_done.item := (1).to_boolean
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_verboseconnect
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_updateconninfo (sock[0])
						update_class_fields -- Current might have been changed; synchronize
					end
					if not l_return then
						if not (l_return or l_break or l_continue) then
							l_break := True
						end
						if (not l_return and not l_break) then
							
						end
					end
				end
			end
			if not l_return then
				l_break := False
				l_continue := False
				Current.now := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_result
			end
		end

	do_init: NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
		do
			l_data := data
			l_k := create {CE_CLASS_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
			bits.done := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			bits.do_more := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.state.expect100header := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			if l_data.item.set.opt_no_body then
				l_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_HEAD
				update_class_fields -- Current might have been changed; synchronize
			elseif {NATURAL_32} 5 = l_data.item.set.httpreq then
				l_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_GET
				update_class_fields -- Current might have been changed; synchronize
			end
			l_data.item.Curl_easy_initHandleData
			update_class_fields -- Current might have been changed; synchronize
			l_k.item.start := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
			update_class_fields -- Current might have been changed; synchronize
			l_k.item.now := (l_k.item.start).twin
			update_class_fields -- Current might have been changed; synchronize
			l_k.item.header := (1).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			l_k.item.bytecount := (0).to_integer_64
			update_class_fields -- Current might have been changed; synchronize
			l_k.item.buf := l_data.item.state.buffer
			update_class_fields -- Current might have been changed; synchronize
			l_k.item.uploadbuf := l_data.item.state.uploadbuffer
			update_class_fields -- Current might have been changed; synchronize
			l_k.item.hbufp := l_data.item.state.headerbuff
			update_class_fields -- Current might have been changed; synchronize
			l_k.item.ignorebody := (0).to_boolean
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_PROGRESS_STATIC}).Curl_pgrsTime (l_data, {PC_TIMERID}.TIMER_PRETRANSFER)
			update_class_fields -- Current might have been changed; synchronize
			Curl_speedinit (l_data)
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetUploadCounter ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetDownloadCounter ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	do_complete
		local
			l_tmp: INTEGER_32
		do
			data.item.req.chunk := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			if sockfd > writesockfd then
				l_tmp := sockfd
			else
				l_tmp := writesockfd
			end
			data.item.req.maxfd := l_tmp + 1
			update_class_fields -- Current might have been changed; synchronize
		end

	Curl_reset_reqproto
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			l_data := data
			if (not (l_data.item.state.proto.generic).is_void) then
				if not ((l_data.item.state.current_conn).c_pointer = c_pointer) then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([l_data.item.state.proto.generic])
					update_class_fields -- Current might have been changed; synchronize
					l_data.item.state.proto.generic := create {CE_VOID_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_data.item.state.current_conn := (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	dict_do (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_word: CE_POINTER [INTEGER_8]
			l_eword: CE_POINTER [INTEGER_8]
			l_ppath: CE_POINTER [INTEGER_8]
			l_database: CE_POINTER [INTEGER_8]
			l_strategy: CE_POINTER [INTEGER_8]
			l_nthdef: CE_POINTER [INTEGER_8]
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_sockfd: INTEGER_32
			l_path: CE_POINTER [INTEGER_8]
			l_bytecount: CE_POINTER [INTEGER_64]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_database := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_strategy := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_nthdef := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data := data
					l_sockfd := sock[0]
					l_path := l_data.item.state.path
					l_bytecount := create {CE_INTEGER_64_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req") + (create {PD_SINGLEREQUEST}.make).offset_of ("bytecount"))
					a_done.item := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___5 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (l_path, ce_string ("/MATCH:"), (("/MATCH:").count + 1).to_natural_32 - {NATURAL_32} 1)
					update_class_fields -- Current might have been changed; synchronize
					if not (l_tmp___5.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 3 then -- else:
						l_tmp___6 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (l_path, ce_string ("/M:"), (("/M:").count + 1).to_natural_32 - {NATURAL_32} 1)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___6.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else:
						l_tmp___7 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (l_path, ce_string ("/FIND:"), (("/FIND:").count + 1).to_natural_32 - {NATURAL_32} 1)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___7.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___0:
						l_word := strchr (l_path, (':').code)
						update_class_fields -- Current might have been changed; synchronize
						if (not l_word.is_void) then
							l_word := l_word + 1
							l_database := strchr (l_word, (':').code)
							update_class_fields -- Current might have been changed; synchronize
							if (not l_database.is_void) then
								l_tmp := l_database
								l_database := l_database + 1
								l_tmp[0] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_strategy := strchr (l_database, (':').code)
								update_class_fields -- Current might have been changed; synchronize
								if (not l_strategy.is_void) then
									l_tmp___0 := l_strategy
									l_strategy := l_strategy + 1
									l_tmp___0[0] := (0).to_integer_8
									update_class_fields -- Current might have been changed; synchronize
									l_nthdef := strchr (l_strategy, (':').code)
									update_class_fields -- Current might have been changed; synchronize
									if (not l_nthdef.is_void) then
										l_nthdef[0] := (0).to_integer_8
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
						end
						if l_word.is_void then
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("lookup word is missing")])
							update_class_fields -- Current might have been changed; synchronize
							l_word := ce_string ("default")
						elseif (l_word[0]).to_integer_32 = 0 then
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("lookup word is missing")])
							update_class_fields -- Current might have been changed; synchronize
							l_word := ce_string ("default")
						end
						if l_database.is_void then
							l_database := ce_string ("!")
						elseif (l_database[0]).to_integer_32 = 0 then
							l_database := ce_string ("!")
						end
						if l_strategy.is_void then
							l_strategy := ce_string (".")
						elseif (l_strategy[0]).to_integer_32 = 0 then
							l_strategy := ce_string (".")
						end
						l_eword := unescape_word (l_data, l_word)
						update_class_fields -- Current might have been changed; synchronize
						if l_eword.is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_sendf ([l_sockfd, ce_string ("CLIENT libcurl 7.21.2%R%NMATCH %%s %%s %%s%R%NQUIT%R%N"), l_database, l_strategy, l_eword])
							update_class_fields -- Current might have been changed; synchronize
							free (create {CE_VOID_POINTER}.make_cast (l_eword))
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								l_data.item.Curl_failf ([ce_string ("Failed sending DICT request")])
								update_class_fields -- Current might have been changed; synchronize
								Result := l_result
								l_return := True
							end
						end
						if not l_return then
							((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (0, (-1).to_integer_64, (0).to_boolean, l_bytecount, -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 9 then -- else:
						l_tmp___2 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (l_path, ce_string ("/DEFINE:"), (("/DEFINE:").count + 1).to_natural_32 - {NATURAL_32} 1)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___2.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 12 then -- else:
						l_tmp___3 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (l_path, ce_string ("/D:"), (("/D:").count + 1).to_natural_32 - {NATURAL_32} 1)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___3.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else:
						l_tmp___4 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (l_path, ce_string ("/LOOKUP:"), (("/LOOKUP:").count + 1).to_natural_32 - {NATURAL_32} 1)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___4.to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if: | _L:
						l_word := strchr (l_path, (':').code)
						update_class_fields -- Current might have been changed; synchronize
						if (not l_word.is_void) then
							l_word := l_word + 1
							l_database := strchr (l_word, (':').code)
							update_class_fields -- Current might have been changed; synchronize
							if (not l_database.is_void) then
								l_tmp___1 := l_database
								l_database := l_database + 1
								l_tmp___1[0] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_nthdef := strchr (l_database, (':').code)
								update_class_fields -- Current might have been changed; synchronize
								if (not l_nthdef.is_void) then
									l_nthdef[0] := (0).to_integer_8
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if l_word.is_void then
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("lookup word is missing")])
							update_class_fields -- Current might have been changed; synchronize
							l_word := ce_string ("default")
						elseif (l_word[0]).to_integer_32 = 0 then
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("lookup word is missing")])
							update_class_fields -- Current might have been changed; synchronize
							l_word := ce_string ("default")
						end
						if l_database.is_void then
							l_database := ce_string ("!")
						elseif (l_database[0]).to_integer_32 = 0 then
							l_database := ce_string ("!")
						end
						l_eword := unescape_word (l_data, l_word)
						update_class_fields -- Current might have been changed; synchronize
						if l_eword.is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_sendf ([l_sockfd, ce_string ("CLIENT libcurl 7.21.2%R%NDEFINE %%s %%s%R%NQUIT%R%N"), l_database, l_eword])
							update_class_fields -- Current might have been changed; synchronize
							free (create {CE_VOID_POINTER}.make_cast (l_eword))
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								l_data.item.Curl_failf ([ce_string ("Failed sending DICT request")])
								update_class_fields -- Current might have been changed; synchronize
								Result := l_result
								l_return := True
							end
						end
						if not l_return then
							((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (0, (-1).to_integer_64, (0).to_boolean, l_bytecount, -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_ppath := strchr (l_path, ('/').code)
						update_class_fields -- Current might have been changed; synchronize
						if (not l_ppath.is_void) then
							l_ppath := l_ppath + 1
							l_i := 0
							from
							until
								not ((l_ppath[l_i]).to_boolean)
							loop
								if (l_ppath[l_i]).to_integer_32 = 58 then
									l_ppath[l_i] := ((' ').code).to_integer_8
									update_class_fields -- Current might have been changed; synchronize
								end
								l_i := l_i + 1
							end
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_sendf ([l_sockfd, ce_string ("CLIENT libcurl 7.21.2%R%N%%s%R%NQUIT%R%N"), l_ppath])
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								l_data.item.Curl_failf ([ce_string ("Failed sending DICT request")])
								update_class_fields -- Current might have been changed; synchronize
								Result := l_result
								l_return := True
							end
							if not l_return then
								((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (0, (-1).to_integer_64, (0).to_boolean, l_bytecount, -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 19 then -- if done | if done | if done | if done | if done
					if not l_return then
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	negotiate
		local
			l_i: INTEGER_32
			l_tn: CE_POINTER [PD_TELNET]
		do
			l_tn := create {CE_CLASS_POINTER [PD_TELNET]}.make_cast (data.item.state.proto.telnet)
			l_i := 0
			from
			until
				not (l_i < 40)
			loop
				if l_tn.item.us_preferred[l_i] = 1 then
					((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.set_local_option (l_i, 1)
					update_class_fields -- Current might have been changed; synchronize
				end
				if l_tn.item.him_preferred[l_i] = 1 then
					((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.set_remote_option (l_i, 1)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_i := l_i + 1
			end
		end

	send_negotiation (a_cmd, a_option: INTEGER_32)
		local
			l_buf: CE_ARRAY [NATURAL_8]
			l_bytes_written: INTEGER_32
			l_err: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_32]
		do
			create {CE_NATURAL_8_ARRAY} l_buf.make (<<3>>)

			l_data := data
			l_buf[0] := (255).to_natural_8
			update_class_fields -- Current might have been changed; synchronize
			l_buf[1] := a_cmd.to_natural_8
			update_class_fields -- Current might have been changed; synchronize
			l_buf[2] := a_option.to_natural_8
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := send (sock[0], create {CE_VOID_POINTER}.make_cast (l_buf), (3).to_natural_32, 16_384)
			update_class_fields -- Current might have been changed; synchronize
			l_bytes_written := l_tmp
			if l_bytes_written < 0 then
				l_tmp___0 := errno_location
				update_class_fields -- Current might have been changed; synchronize
				l_err := l_tmp___0.item
				l_data.item.Curl_failf ([ce_string ("Sending data failed (%%d)"), l_err])
				update_class_fields -- Current might have been changed; synchronize
			end
			data.item.printoption (ce_string ("SENT"), a_cmd, a_option)
			update_class_fields -- Current might have been changed; synchronize
		end

	set_remote_option (a_option, a_newstate: INTEGER_32)
		local
			l_tn: CE_POINTER [PD_TELNET]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tn := create {CE_CLASS_POINTER [PD_TELNET]}.make_cast (data.item.state.proto.telnet)
					if a_newstate /= 1 then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						inspect l_tn.item.him[a_option] -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						when 2 then l_pos := -1 + 8
						else l_pos := -1 + 12
						end
				when 2 then -- switch 1, case 0
						l_tn.item.him[a_option] := 2
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.send_negotiation (253, a_option)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 12 -- switch 1; break
				when 3 then -- switch 1, case 1
						l_pos := -1 + 12 -- switch 1; break
				when 4 then -- switch 1, case 3
						inspect l_tn.item.himq[a_option] -- switch 2 head
						when 0 then l_pos := -1 + 5
						when 1 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 5 then -- switch 2, case 0
						l_tn.item.himq[a_option] := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 7 -- switch 2; break
				when 6 then -- switch 2, case 1
						l_pos := -1 + 7 -- switch 2; break
				when 7 then -- switch 2, done:
						l_pos := -1 + 12 -- switch 1; break
				when 8 then -- switch 1, case 2
						inspect l_tn.item.himq[a_option] -- switch 3 head
						when 0 then l_pos := -1 + 9
						when 1 then l_pos := -1 + 10
						else l_pos := -1 + 11
						end
				when 9 then -- switch 3, case 0
						l_pos := -1 + 11 -- switch 3; break
				when 10 then -- switch 3, case 1
						l_tn.item.himq[a_option] := 0
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 11 -- switch 3; break
				when 11 then -- switch 3, done:
						l_pos := -1 + 12 -- switch 1; break
				when 12 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 24
				when 13 then -- else:
						inspect l_tn.item.him[a_option] -- switch 4 head
						when 0 then l_pos := -1 + 14
						when 1 then l_pos := -1 + 15
						when 3 then l_pos := -1 + 16
						when 2 then l_pos := -1 + 20
						else l_pos := -1 + 24
						end
				when 14 then -- switch 4, case 0
						l_pos := -1 + 24 -- switch 4; break
				when 15 then -- switch 4, case 1
						l_tn.item.him[a_option] := 3
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.send_negotiation (254, a_option)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 24 -- switch 4; break
				when 16 then -- switch 4, case 3
						inspect l_tn.item.himq[a_option] -- switch 5 head
						when 0 then l_pos := -1 + 17
						when 1 then l_pos := -1 + 18
						else l_pos := -1 + 19
						end
				when 17 then -- switch 5, case 0
						l_pos := -1 + 19 -- switch 5; break
				when 18 then -- switch 5, case 1
						l_tn.item.himq[a_option] := 0
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 19 -- switch 5; break
				when 19 then -- switch 5, done:
						l_pos := -1 + 24 -- switch 4; break
				when 20 then -- switch 4, case 2
						inspect l_tn.item.himq[a_option] -- switch 6 head
						when 0 then l_pos := -1 + 21
						when 1 then l_pos := -1 + 22
						else l_pos := -1 + 23
						end
				when 21 then -- switch 6, case 0
						l_tn.item.himq[a_option] := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 23 -- switch 6; break
				when 22 then -- switch 6, case 1
						l_pos := -1 + 23 -- switch 6; break
				when 23 then -- switch 6, done:
						l_pos := -1 + 24 -- switch 4; break
				when 24 then -- switch 4, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	rec_will (a_option: INTEGER_32)
		local
			l_tn: CE_POINTER [PD_TELNET]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tn := create {CE_CLASS_POINTER [PD_TELNET]}.make_cast (data.item.state.proto.telnet)
					inspect l_tn.item.him[a_option] -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 2 then l_pos := -1 + 7
					else l_pos := -1 + 11
					end
				when 1 then -- switch 1, case 0
					if l_tn.item.him_preferred[a_option] = 1 then
						l_tn.item.him[a_option] := 1
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.send_negotiation (253, a_option)
						update_class_fields -- Current might have been changed; synchronize
					else
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.send_negotiation (254, a_option)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 11 -- switch 1; break
				when 2 then -- switch 1, case 1
					l_pos := -1 + 11 -- switch 1; break
				when 3 then -- switch 1, case 3
					inspect l_tn.item.himq[a_option] -- switch 2 head
					when 0 then l_pos := -1 + 4
					when 1 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 4 then -- switch 2, case 0
					l_tn.item.him[a_option] := 0
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 6 -- switch 2; break
				when 5 then -- switch 2, case 1
					l_tn.item.him[a_option] := 1
					update_class_fields -- Current might have been changed; synchronize
					l_tn.item.himq[a_option] := 0
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 6 -- switch 2; break
				when 6 then -- switch 2, done:
					l_pos := -1 + 11 -- switch 1; break
				when 7 then -- switch 1, case 2
					inspect l_tn.item.himq[a_option] -- switch 3 head
					when 0 then l_pos := -1 + 8
					when 1 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 8 then -- switch 3, case 0
					l_tn.item.him[a_option] := 1
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 10 -- switch 3; break
				when 9 then -- switch 3, case 1
					l_tn.item.him[a_option] := 3
					update_class_fields -- Current might have been changed; synchronize
					l_tn.item.himq[a_option] := 0
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.send_negotiation (254, a_option)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 10 -- switch 3; break
				when 10 then -- switch 3, done:
					l_pos := -1 + 11 -- switch 1; break
				when 11 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	rec_wont (a_option: INTEGER_32)
		local
			l_tn: CE_POINTER [PD_TELNET]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tn := create {CE_CLASS_POINTER [PD_TELNET]}.make_cast (data.item.state.proto.telnet)
					inspect l_tn.item.him[a_option] -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 2 then l_pos := -1 + 7
					else l_pos := -1 + 11
					end
				when 1 then -- switch 1, case 0
					l_pos := -1 + 11 -- switch 1; break
				when 2 then -- switch 1, case 1
					l_tn.item.him[a_option] := 0
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.send_negotiation (254, a_option)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 11 -- switch 1; break
				when 3 then -- switch 1, case 3
					inspect l_tn.item.himq[a_option] -- switch 2 head
					when 0 then l_pos := -1 + 4
					when 1 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 4 then -- switch 2, case 0
					l_tn.item.him[a_option] := 0
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 6 -- switch 2; break
				when 5 then -- switch 2, case 1
					l_tn.item.him[a_option] := 2
					update_class_fields -- Current might have been changed; synchronize
					l_tn.item.himq[a_option] := 0
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.send_negotiation (253, a_option)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 6 -- switch 2; break
				when 6 then -- switch 2, done:
					l_pos := -1 + 11 -- switch 1; break
				when 7 then -- switch 1, case 2
					inspect l_tn.item.himq[a_option] -- switch 3 head
					when 0 then l_pos := -1 + 8
					when 1 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 8 then -- switch 3, case 0
					l_tn.item.him[a_option] := 0
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 10 -- switch 3; break
				when 9 then -- switch 3, case 1
					l_tn.item.him[a_option] := 0
					update_class_fields -- Current might have been changed; synchronize
					l_tn.item.himq[a_option] := 0
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 10 -- switch 3; break
				when 10 then -- switch 3, done:
					l_pos := -1 + 11 -- switch 1; break
				when 11 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_local_option (a_option, a_newstate: INTEGER_32)
		local
			l_tn: CE_POINTER [PD_TELNET]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tn := create {CE_CLASS_POINTER [PD_TELNET]}.make_cast (data.item.state.proto.telnet)
					if a_newstate /= 1 then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						inspect l_tn.item.us[a_option] -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						when 2 then l_pos := -1 + 8
						else l_pos := -1 + 12
						end
				when 2 then -- switch 1, case 0
						l_tn.item.us[a_option] := 2
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.send_negotiation (251, a_option)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 12 -- switch 1; break
				when 3 then -- switch 1, case 1
						l_pos := -1 + 12 -- switch 1; break
				when 4 then -- switch 1, case 3
						inspect l_tn.item.usq[a_option] -- switch 2 head
						when 0 then l_pos := -1 + 5
						when 1 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 5 then -- switch 2, case 0
						l_tn.item.usq[a_option] := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 7 -- switch 2; break
				when 6 then -- switch 2, case 1
						l_pos := -1 + 7 -- switch 2; break
				when 7 then -- switch 2, done:
						l_pos := -1 + 12 -- switch 1; break
				when 8 then -- switch 1, case 2
						inspect l_tn.item.usq[a_option] -- switch 3 head
						when 0 then l_pos := -1 + 9
						when 1 then l_pos := -1 + 10
						else l_pos := -1 + 11
						end
				when 9 then -- switch 3, case 0
						l_pos := -1 + 11 -- switch 3; break
				when 10 then -- switch 3, case 1
						l_tn.item.usq[a_option] := 0
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 11 -- switch 3; break
				when 11 then -- switch 3, done:
						l_pos := -1 + 12 -- switch 1; break
				when 12 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 24
				when 13 then -- else:
						inspect l_tn.item.us[a_option] -- switch 4 head
						when 0 then l_pos := -1 + 14
						when 1 then l_pos := -1 + 15
						when 3 then l_pos := -1 + 16
						when 2 then l_pos := -1 + 20
						else l_pos := -1 + 24
						end
				when 14 then -- switch 4, case 0
						l_pos := -1 + 24 -- switch 4; break
				when 15 then -- switch 4, case 1
						l_tn.item.us[a_option] := 3
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.send_negotiation (252, a_option)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 24 -- switch 4; break
				when 16 then -- switch 4, case 3
						inspect l_tn.item.usq[a_option] -- switch 5 head
						when 0 then l_pos := -1 + 17
						when 1 then l_pos := -1 + 18
						else l_pos := -1 + 19
						end
				when 17 then -- switch 5, case 0
						l_pos := -1 + 19 -- switch 5; break
				when 18 then -- switch 5, case 1
						l_tn.item.usq[a_option] := 0
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 19 -- switch 5; break
				when 19 then -- switch 5, done:
						l_pos := -1 + 24 -- switch 4; break
				when 20 then -- switch 4, case 2
						inspect l_tn.item.usq[a_option] -- switch 6 head
						when 0 then l_pos := -1 + 21
						when 1 then l_pos := -1 + 22
						else l_pos := -1 + 23
						end
				when 21 then -- switch 6, case 0
						l_tn.item.usq[a_option] := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 23 -- switch 6; break
				when 22 then -- switch 6, case 1
						l_pos := -1 + 23 -- switch 6; break
				when 23 then -- switch 6, done:
						l_pos := -1 + 24 -- switch 4; break
				when 24 then -- switch 4, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	rec_do (a_option: INTEGER_32)
		local
			l_tn: CE_POINTER [PD_TELNET]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tn := create {CE_CLASS_POINTER [PD_TELNET]}.make_cast (data.item.state.proto.telnet)
					inspect l_tn.item.us[a_option] -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 2 then l_pos := -1 + 7
					else l_pos := -1 + 11
					end
				when 1 then -- switch 1, case 0
					if l_tn.item.us_preferred[a_option] = 1 then
						l_tn.item.us[a_option] := 1
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.send_negotiation (251, a_option)
						update_class_fields -- Current might have been changed; synchronize
					else
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.send_negotiation (252, a_option)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 11 -- switch 1; break
				when 2 then -- switch 1, case 1
					l_pos := -1 + 11 -- switch 1; break
				when 3 then -- switch 1, case 3
					inspect l_tn.item.usq[a_option] -- switch 2 head
					when 0 then l_pos := -1 + 4
					when 1 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 4 then -- switch 2, case 0
					l_tn.item.us[a_option] := 0
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 6 -- switch 2; break
				when 5 then -- switch 2, case 1
					l_tn.item.us[a_option] := 1
					update_class_fields -- Current might have been changed; synchronize
					l_tn.item.usq[a_option] := 0
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 6 -- switch 2; break
				when 6 then -- switch 2, done:
					l_pos := -1 + 11 -- switch 1; break
				when 7 then -- switch 1, case 2
					inspect l_tn.item.usq[a_option] -- switch 3 head
					when 0 then l_pos := -1 + 8
					when 1 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 8 then -- switch 3, case 0
					l_tn.item.us[a_option] := 1
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 10 -- switch 3; break
				when 9 then -- switch 3, case 1
					l_tn.item.us[a_option] := 3
					update_class_fields -- Current might have been changed; synchronize
					l_tn.item.himq[a_option] := 0
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.send_negotiation (252, a_option)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 10 -- switch 3; break
				when 10 then -- switch 3, done:
					l_pos := -1 + 11 -- switch 1; break
				when 11 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	rec_dont (a_option: INTEGER_32)
		local
			l_tn: CE_POINTER [PD_TELNET]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tn := create {CE_CLASS_POINTER [PD_TELNET]}.make_cast (data.item.state.proto.telnet)
					inspect l_tn.item.us[a_option] -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 2 then l_pos := -1 + 7
					else l_pos := -1 + 11
					end
				when 1 then -- switch 1, case 0
					l_pos := -1 + 11 -- switch 1; break
				when 2 then -- switch 1, case 1
					l_tn.item.us[a_option] := 0
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.send_negotiation (252, a_option)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 11 -- switch 1; break
				when 3 then -- switch 1, case 3
					inspect l_tn.item.usq[a_option] -- switch 2 head
					when 0 then l_pos := -1 + 4
					when 1 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 4 then -- switch 2, case 0
					l_tn.item.us[a_option] := 0
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 6 -- switch 2; break
				when 5 then -- switch 2, case 1
					l_tn.item.us[a_option] := 2
					update_class_fields -- Current might have been changed; synchronize
					l_tn.item.usq[a_option] := 0
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.send_negotiation (251, a_option)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 6 -- switch 2; break
				when 6 then -- switch 2, done:
					l_pos := -1 + 11 -- switch 1; break
				when 7 then -- switch 1, case 2
					inspect l_tn.item.usq[a_option] -- switch 3 head
					when 0 then l_pos := -1 + 8
					when 1 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 8 then -- switch 3, case 0
					l_tn.item.us[a_option] := 0
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 10 -- switch 3; break
				when 9 then -- switch 3, case 1
					l_tn.item.us[a_option] := 0
					update_class_fields -- Current might have been changed; synchronize
					l_tn.item.usq[a_option] := 0
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 10 -- switch 3; break
				when 10 then -- switch 3, done:
					l_pos := -1 + 11 -- switch 1; break
				when 11 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_telnet_options: NATURAL_32
		local
			l_head: CE_POINTER [PD_CURL_SLIST]
			l_option_keyword: CE_ARRAY [INTEGER_8]
			l_option_arg: CE_ARRAY [INTEGER_8]
			l_buf: CE_POINTER [INTEGER_8]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_tn: CE_POINTER [PD_TELNET]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_continue: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_option_keyword.make (<<128>>)
			create {CE_INTEGER_8_ARRAY} l_option_arg.make (<<256>>)

			l_data := data
			l_tn := create {CE_CLASS_POINTER [PD_TELNET]}.make_cast (data.item.state.proto.telnet)
			if bits.user_passwd then
				(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_option_arg, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32), ce_string ("USER,%%s"), user]).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_tn.item.telnet_vars := (create {P_SLIST_STATIC}).curl_slist_append (l_tn.item.telnet_vars, l_option_arg)
				update_class_fields -- Current might have been changed; synchronize
				l_tn.item.us_preferred[39] := 1
				update_class_fields -- Current might have been changed; synchronize
			end
			l_head := l_data.item.set.telnet_options
			from
			until
				not (not (l_return) and then (not l_head.is_void))
			loop
				l_continue := False
				l_tmp___2 := sscanf ([l_head.item.data, ce_string ("%%127[^= ]%%*[ =]%%255s"), l_option_keyword, l_option_arg])
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___2 = 2 then
					l_tmp := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_option_keyword, ce_string ("TTYPE"))
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						strncpy ((l_tn.item.subopt_ttype), l_option_arg, (31).to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_tn.item.subopt_ttype[31] := (0).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_tn.item.us_preferred[24] := 1
						update_class_fields -- Current might have been changed; synchronize
						l_continue := True
					end
					if not (l_return or l_continue) then
						l_tmp___0 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_option_keyword, ce_string ("XDISPLOC"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0.to_boolean then
							strncpy ((l_tn.item.subopt_xdisploc), l_option_arg, (127).to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_tn.item.subopt_xdisploc[127] := (0).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							l_tn.item.us_preferred[35] := 1
							update_class_fields -- Current might have been changed; synchronize
							l_continue := True
						end
					end
					if not (l_return or l_continue) then
						l_tmp___1 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_option_keyword, ce_string ("NEW_ENV"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1.to_boolean then
							l_buf := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_option_arg]))
							update_class_fields -- Current might have been changed; synchronize
							if l_buf.is_void then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								l_return := True
							end
							if not l_return then
								l_tn.item.telnet_vars := (create {P_SLIST_STATIC}).curl_slist_append (l_tn.item.telnet_vars, l_buf)
								update_class_fields -- Current might have been changed; synchronize
								l_tn.item.us_preferred[39] := 1
								update_class_fields -- Current might have been changed; synchronize
								l_continue := True
							end
						end
					end
					if not (l_return or l_continue) then
						l_data.item.Curl_failf ([ce_string ("Unknown telnet option %%s"), l_head.item.data])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_UNKNOWN_TELNET_OPTION)
						l_return := True
					end
				else
					l_data.item.Curl_failf ([ce_string ("Syntax error in telnet option: %%s"), l_head.item.data])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_TELNET_OPTION_SYNTAX)
					l_return := True
				end
				if (not l_return) then
					l_head := l_head.item.next
				end
			end
			if not l_return then
				l_continue := False
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	suboption
		local
			l_v: CE_POINTER [PD_CURL_SLIST]
			l_temp: CE_ARRAY [NATURAL_8]
			l_bytes_written: INTEGER_32
			l_len: NATURAL_32
			l_tmplen: NATURAL_32
			l_err: INTEGER_32
			l_varname: CE_ARRAY [INTEGER_8]
			l_varval: CE_ARRAY [INTEGER_8]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_tn: CE_POINTER [PD_TELNET]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_32]
			l_tmp___3: NATURAL_32
			l_tmp___4: INTEGER_32
			l_tmp___5: CE_POINTER [INTEGER_32]
			l_tmp___6: NATURAL_32
			l_tmp___7: INTEGER_32
			l_tmp___8: CE_POINTER [INTEGER_32]
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_temp.make (<<2_048>>)
			create {CE_INTEGER_8_ARRAY} l_varname.make (<<128>>)
			create {CE_INTEGER_8_ARRAY} l_varval.make (<<128>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					l_tn := create {CE_CLASS_POINTER [PD_TELNET]}.make_cast (l_data.item.state.proto.telnet)
					l_data.item.printsub (('<').code, l_tn.item.subbuffer, (((l_tn.item.subend).distance ((l_tn.item.subpointer))) + 2).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp := l_tn.item.subpointer
					l_tn.item.subpointer := (l_tn.item.subpointer) + 1
					update_class_fields -- Current might have been changed; synchronize
					inspect ((l_tmp.item).to_integer_32).bit_and (255) -- switch 1 head
					when 24 then l_pos := -1 + 1
					when 35 then l_pos := -1 + 2
					when 39 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 24
					l_tmp___0 := strlen ((l_tn.item.subopt_ttype))
					update_class_fields -- Current might have been changed; synchronize
					l_len := (l_tmp___0 + {NATURAL_32} 4) + {NATURAL_32} 2;
					(create {P_MPRINTF_STATIC}).curl_msnprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_temp), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_048).to_natural_32), ce_string ("%%c%%c%%c%%c%%s%%c%%c"), 255, 250, 24, 0, l_tn.item.subopt_ttype, 255, 240]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___1 := send (sock[0], create {CE_VOID_POINTER}.make_cast (l_temp), l_len, 16_384)
					update_class_fields -- Current might have been changed; synchronize
					l_bytes_written := l_tmp___1
					if l_bytes_written < 0 then
						l_tmp___2 := errno_location
						update_class_fields -- Current might have been changed; synchronize
						l_err := l_tmp___2.item
						l_data.item.Curl_failf ([ce_string ("Sending data failed (%%d)"), l_err])
						update_class_fields -- Current might have been changed; synchronize
					end
					l_data.item.printsub (('>').code, l_temp + 2, l_len - {NATURAL_32} 2)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 35
					l_tmp___3 := strlen ((l_tn.item.subopt_xdisploc))
					update_class_fields -- Current might have been changed; synchronize
					l_len := (l_tmp___3 + {NATURAL_32} 4) + {NATURAL_32} 2;
					(create {P_MPRINTF_STATIC}).curl_msnprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_temp), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_048).to_natural_32), ce_string ("%%c%%c%%c%%c%%s%%c%%c"), 255, 250, 35, 0, l_tn.item.subopt_xdisploc, 255, 240]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___4 := send (sock[0], create {CE_VOID_POINTER}.make_cast (l_temp), l_len, 16_384)
					update_class_fields -- Current might have been changed; synchronize
					l_bytes_written := l_tmp___4
					if l_bytes_written < 0 then
						l_tmp___5 := errno_location
						update_class_fields -- Current might have been changed; synchronize
						l_err := l_tmp___5.item
						l_data.item.Curl_failf ([ce_string ("Sending data failed (%%d)"), l_err])
						update_class_fields -- Current might have been changed; synchronize
					end
					l_data.item.printsub (('>').code, l_temp + 2, l_len - {NATURAL_32} 2)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 39;
					(create {P_MPRINTF_STATIC}).curl_msnprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_temp), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_048).to_natural_32), ce_string ("%%c%%c%%c%%c"), 255, 250, 39, 0]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_len := (4).to_natural_32
					l_v := l_tn.item.telnet_vars
					from
					until
						l_v.is_void
					loop
						l_tmp___6 := strlen (l_v.item.data)
						update_class_fields -- Current might have been changed; synchronize
						l_tmplen := l_tmp___6 + {NATURAL_32} 1
						if l_len + l_tmplen < (({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_048).to_natural_32).to_integer_32 - 6).to_natural_32 then
							sscanf ([l_v.item.data, ce_string ("%%127[^,],%%127s"), l_varname, l_varval]).do_nothing
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MPRINTF_STATIC}).curl_msnprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((l_temp + l_len.to_integer_32)), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_048).to_natural_32) - l_len, ce_string ("%%c%%s%%c%%s"), 0, l_varname, 1, l_varval]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_len := l_len + l_tmplen
						end
						l_v := l_v.item.next
					end
					(create {P_MPRINTF_STATIC}).curl_msnprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((l_temp + l_len.to_integer_32)), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (2_048).to_natural_32) - l_len, ce_string ("%%c%%c"), 255, 240]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_len := l_len + ({NATURAL_32} 2)
					l_tmp___7 := send (sock[0], create {CE_VOID_POINTER}.make_cast (l_temp), l_len, 16_384)
					update_class_fields -- Current might have been changed; synchronize
					l_bytes_written := l_tmp___7
					if l_bytes_written < 0 then
						l_tmp___8 := errno_location
						update_class_fields -- Current might have been changed; synchronize
						l_err := l_tmp___8.item
						l_data.item.Curl_failf ([ce_string ("Sending data failed (%%d)"), l_err])
						update_class_fields -- Current might have been changed; synchronize
					end
					l_data.item.printsub (('>').code, l_temp + 2, l_len - {NATURAL_32} 2)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	telrcv (a_inbuf: CE_POINTER [NATURAL_8]; a_count: INTEGER_32): NATURAL_32
		local
			l_count: INTEGER_32
			l_c: NATURAL_8
			l_result: NATURAL_32
			l_in: INTEGER_32
			l_startwrite: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_tn: CE_POINTER [PD_TELNET]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count := a_count
					l_in := 0
					l_startwrite := -1
					l_data := data
					l_tn := create {CE_CLASS_POINTER [PD_TELNET]}.make_cast (l_data.item.state.proto.telnet)
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 30 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_tmp___5 := l_count
						l_count := l_count - 1
						if not l_tmp___5.to_boolean then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 29 -- skip if block
						end
				when 3 then -- if:
						l_c := a_inbuf[l_in]
						inspect (l_tn.item.telrcv_state).to_integer_32 -- switch 1 head
						when 6 then l_pos := -1 + 4
						when 0 then l_pos := -1 + 6
						when 1 then l_pos := -1 + 8
						when 2 then l_pos := -1 + 17
						when 3 then l_pos := -1 + 18
						when 4 then l_pos := -1 + 19
						when 5 then l_pos := -1 + 20
						when 7 then l_pos := -1 + 21
						when 8 then l_pos := -1 + 22
						else l_pos := -1 + 28
						end
				when 4 then -- switch 1, case 6
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
						update_class_fields -- Current might have been changed; synchronize
						if l_c.to_integer_32 = 0 then
							if l_startwrite >= 0 then
								l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write (1, create {CE_INTEGER_8_POINTER}.make_cast ((a_inbuf + l_startwrite)), (l_in - l_startwrite).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_result /= {NATURAL_32} 0 then
									Result := l_result
									l_return := True
								end
							end
							if not l_return then
								l_startwrite := -1
							end
							l_pos := -1 + 28 -- switch 1; break
						end
				when 5 then
						if not l_return and then (l_startwrite < 0) then
							l_startwrite := l_in
						end
						l_pos := -1 + 28 -- switch 1; break
				when 6 then -- switch 1, case 0
						if l_c.to_integer_32 = 255 then
							l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_IAC
							update_class_fields -- Current might have been changed; synchronize
							if l_startwrite >= 0 then
								l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write (1, create {CE_INTEGER_8_POINTER}.make_cast ((a_inbuf + l_startwrite)), (l_in - l_startwrite).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_result /= {NATURAL_32} 0 then
									Result := l_result
									l_return := True
								end
							end
							if not l_return then
								l_startwrite := -1
							end
							l_pos := -1 + 28 -- switch 1; break
						elseif l_c.to_integer_32 = 13 then
							l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_CR
							update_class_fields -- Current might have been changed; synchronize
						end
				when 7 then
						if not l_return and then (l_startwrite < 0) then
							l_startwrite := l_in
						end
						l_pos := -1 + 28 -- switch 1; break
				when 8 then -- process_iac: | switch 1, case 1
						inspect l_c.to_integer_32 -- switch 2 head
						when 251 then l_pos := -1 + 9
						when 252 then l_pos := -1 + 10
						when 253 then l_pos := -1 + 11
						when 254 then l_pos := -1 + 12
						when 250 then l_pos := -1 + 13
						when 255 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 9 then -- switch 2, case 251
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_WILL
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 2; break
				when 10 then -- switch 2, case 252
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_WONT
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 2; break
				when 11 then -- switch 2, case 253
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DO
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 2; break
				when 12 then -- switch 2, case 254
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DONT
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 2; break
				when 13 then -- switch 2, case 250
						l_tn.item.subpointer := l_tn.item.subbuffer
						update_class_fields -- Current might have been changed; synchronize
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_SB
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 2; break
				when 14 then -- switch 2, case 255
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
						update_class_fields -- Current might have been changed; synchronize
						if l_startwrite < 0 then
							l_startwrite := l_in
						end
						l_pos := -1 + 16 -- switch 2; break
				when 15 then -- switch 2, default:
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.printoption (ce_string ("RCVD"), 255, l_c.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 2; break
				when 16 then -- switch 2, done:
						l_pos := -1 + 28 -- switch 1; break
				when 17 then -- switch 1, case 2
						l_data.item.printoption (ce_string ("RCVD"), 251, l_c.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tn.item.please_negotiate := 1
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.rec_will (l_c.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 28 -- switch 1; break
				when 18 then -- switch 1, case 3
						l_data.item.printoption (ce_string ("RCVD"), 252, l_c.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tn.item.please_negotiate := 1
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.rec_wont (l_c.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 28 -- switch 1; break
				when 19 then -- switch 1, case 4
						l_data.item.printoption (ce_string ("RCVD"), 253, l_c.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tn.item.please_negotiate := 1
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.rec_do (l_c.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 28 -- switch 1; break
				when 20 then -- switch 1, case 5
						l_data.item.printoption (ce_string ("RCVD"), 254, l_c.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tn.item.please_negotiate := 1
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.rec_dont (l_c.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 28 -- switch 1; break
				when 21 then -- switch 1, case 7
						if l_c.to_integer_32 = 255 then
							l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_SE
							update_class_fields -- Current might have been changed; synchronize
						elseif ((l_tn.item.subpointer).c_pointer.to_integer_32).to_natural_32 < ((l_tn.item.subbuffer + ({PLATFORM}.Natural_8_bytes.to_natural_32 * (512).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
							l_tmp := l_tn.item.subpointer
							l_tn.item.subpointer := (l_tn.item.subpointer) + 1
							update_class_fields -- Current might have been changed; synchronize
							l_tmp.item := l_c
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 28 -- switch 1; break
				when 22 then -- switch 1, case 8
						if l_c.to_integer_32 = 240 then
							l_pos := -1 + 26 -- skip if block
						end
				when 23 then -- if:
						if l_c.to_integer_32 /= 255 then
							if ((l_tn.item.subpointer).c_pointer.to_integer_32).to_natural_32 < ((l_tn.item.subbuffer + ({PLATFORM}.Natural_8_bytes.to_natural_32 * (512).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
								l_tmp___0 := l_tn.item.subpointer
								l_tn.item.subpointer := (l_tn.item.subpointer) + 1
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___0.item := (255).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
							end
							if ((l_tn.item.subpointer).c_pointer.to_integer_32).to_natural_32 < ((l_tn.item.subbuffer + ({PLATFORM}.Natural_8_bytes.to_natural_32 * (512).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
								l_tmp___1 := l_tn.item.subpointer
								l_tn.item.subpointer := (l_tn.item.subpointer) + 1
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___1.item := l_c
								update_class_fields -- Current might have been changed; synchronize
							end
							l_tn.item.subpointer := l_tn.item.subpointer - (2)
							update_class_fields -- Current might have been changed; synchronize
							l_tn.item.subend := l_tn.item.subpointer
							update_class_fields -- Current might have been changed; synchronize
							l_tn.item.subpointer := l_tn.item.subbuffer
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.printoption (ce_string ("In SUBOPTION processing, RCVD"), 255, l_c.to_integer_32)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.suboption
							update_class_fields -- Current might have been changed; synchronize
							l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_IAC
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 8 -- goto process_iac
						end
				when 24 then
						if ((l_tn.item.subpointer).c_pointer.to_integer_32).to_natural_32 < ((l_tn.item.subbuffer + ({PLATFORM}.Natural_8_bytes.to_natural_32 * (512).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___2 := l_tn.item.subpointer
							l_tn.item.subpointer := (l_tn.item.subpointer) + 1
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___2.item := l_c
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_SB
						update_class_fields -- Current might have been changed; synchronize
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						if ((l_tn.item.subpointer).c_pointer.to_integer_32).to_natural_32 < ((l_tn.item.subbuffer + ({PLATFORM}.Natural_8_bytes.to_natural_32 * (512).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___3 := l_tn.item.subpointer
							l_tn.item.subpointer := (l_tn.item.subpointer) + 1
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___3.item := (255).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
						end
						if ((l_tn.item.subpointer).c_pointer.to_integer_32).to_natural_32 < ((l_tn.item.subbuffer + ({PLATFORM}.Natural_8_bytes.to_natural_32 * (512).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___4 := l_tn.item.subpointer
							l_tn.item.subpointer := (l_tn.item.subpointer) + 1
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___4.item := (240).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tn.item.subpointer := l_tn.item.subpointer - (2)
						update_class_fields -- Current might have been changed; synchronize
						l_tn.item.subend := l_tn.item.subpointer
						update_class_fields -- Current might have been changed; synchronize
						l_tn.item.subpointer := l_tn.item.subbuffer
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.suboption
						update_class_fields -- Current might have been changed; synchronize
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
						update_class_fields -- Current might have been changed; synchronize
				when 27 then -- if done
						l_pos := -1 + 28 -- switch 1; break
				when 28 then -- switch 1, done:
						if not l_return then
							l_in := l_in + 1
						end
				when 29 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 30 then -- loop done
					if not l_return then
						l_break := False
						if l_startwrite >= 0 then
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write (1, create {CE_INTEGER_8_POINTER}.make_cast ((a_inbuf + l_startwrite)), (l_in - l_startwrite).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_result /= {NATURAL_32} 0 then
								Result := l_result
								l_return := True
							end
						end
					end
					if not l_return then
						l_startwrite := -1
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 31 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	telnet_done (a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
		local
			l_tn: CE_POINTER [PD_TELNET]
		do
			l_tn := create {CE_CLASS_POINTER [PD_TELNET]}.make_cast (data.item.state.proto.telnet);
			(create {P_SLIST_STATIC}).curl_slist_free_all (l_tn.item.telnet_vars)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_EASY_STATIC}).Curl_cfree.item.call ([data.item.state.proto.telnet])
			update_class_fields -- Current might have been changed; synchronize
			data.item.state.proto.telnet := create {CE_VOID_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	telnet_do (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_code: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_sockfd: INTEGER_32
			l_interval_ms: INTEGER_32
			l_pfd: CE_ARRAY [SD_POLLFD]
			l_poll_cnt: INTEGER_32
			l_total_dl: INTEGER_64
			l_total_ul: INTEGER_64
			l_nread: CE_ARRAY [INTEGER_32]
			l_now: SD_TIMEVAL
			l_keepon: BOOLEAN
			l_buf: CE_POINTER [INTEGER_8]
			l_tn: CE_POINTER [PD_TELNET]
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_POLLFD]} l_pfd.make (<<2>>)
			create {CE_INTEGER_32_ARRAY} l_nread.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					l_sockfd := sock[0]
					l_total_dl := (0).to_integer_64
					l_total_ul := (0).to_integer_64
					l_keepon := (1).to_boolean
					l_buf := l_data.item.state.buffer
					a_done.item := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
					l_code := init_telnet ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
					if l_code.to_boolean then
						Result := l_code
						l_return := True
					end
					if not l_return then
						l_tn := create {CE_CLASS_POINTER [PD_TELNET]}.make_cast (l_data.item.state.proto.telnet)
						l_code := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.check_telnet_options
						update_class_fields -- Current might have been changed; synchronize
						if l_code.to_boolean then
							Result := l_code
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 24 -- skip if block
					end
				when 1 then -- if:
						l_pfd[0].fd := l_sockfd
						update_class_fields -- Current might have been changed; synchronize
						l_pfd[0].events := (1).to_integer_16
						update_class_fields -- Current might have been changed; synchronize
						if (l_data.item.set.is_fread_set).to_boolean then
							l_poll_cnt := 1
							l_interval_ms := 100
						else
							l_pfd[1].fd := 0
							update_class_fields -- Current might have been changed; synchronize
							l_pfd[1].events := (1).to_integer_16
							update_class_fields -- Current might have been changed; synchronize
							l_poll_cnt := 2
							l_interval_ms := 1_000
						end
				when 2 then -- loop condition:
						if not (not (l_break) and then l_keepon) then
							l_pos := -1 + 23 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						l_tmp := Curl_poll (l_pfd, l_poll_cnt.to_natural_32, l_interval_ms)
						update_class_fields -- Current might have been changed; synchronize
						inspect l_tmp -- switch 1 head
						when -1 then l_pos := -1 + 4 -- -1
						when 0 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 4 then -- switch 1, case -1
						l_keepon := (0).to_boolean
						l_continue := True
				when 5 then -- switch 1, case 0
						if not (l_break or l_continue) then
							l_pfd[0].revents := (0).to_integer_16
							update_class_fields -- Current might have been changed; synchronize
							l_pfd[1].revents := (0).to_integer_16
							update_class_fields -- Current might have been changed; synchronize
						end
				when 6 then -- switch 1, default:
						if (l_break or l_continue) then
							l_pos := -1 + 21 -- skip if block
						end
				when 7 then -- if:
						if not ((((l_pfd[0].revents).to_integer_32).bit_and (1)).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 8 then -- if:
						l_code := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_read (l_sockfd, l_buf, (16_383).to_natural_32, l_nread)
						update_class_fields -- Current might have been changed; synchronize
						if l_code = {NATURAL_32} 81 then
							l_pos := -1 + 22 -- switch 1; break
						elseif l_code.to_boolean then
							l_keepon := (0).to_boolean
							l_pos := -1 + 22 -- switch 1; break
						elseif l_nread.item <= 0 then
							l_keepon := (0).to_boolean
							l_pos := -1 + 22 -- switch 1; break
						end
				when 9 then
						l_total_dl := l_total_dl + (l_nread.item).to_integer_64
						l_data.item.Curl_pgrsSetDownloadCounter (l_total_dl)
						update_class_fields -- Current might have been changed; synchronize
						l_code := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.telrcv (create {CE_NATURAL_8_POINTER}.make_cast (l_buf), l_nread.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_code.to_boolean then
							l_keepon := (0).to_boolean
							l_pos := -1 + 22 -- switch 1; break
						end
				when 10 then
						if (l_tn.item.please_negotiate).to_boolean then
							if not (l_tn.item.already_negotiated).to_boolean then
								((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.negotiate
								update_class_fields -- Current might have been changed; synchronize
								l_tn.item.already_negotiated := 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 11 then -- if done
						l_nread.item := 0
						update_class_fields -- Current might have been changed; synchronize
						if l_poll_cnt /= 2 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (((l_pfd[1].revents).to_integer_32).bit_and (1)).to_boolean then
							l_nread.item := read (0, create {CE_VOID_POINTER}.make_cast (l_buf), (16_383).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else:
						l_tmp___0 := fread_func.natural_32_item ([l_buf, (1).to_natural_32, (16_383).to_natural_32, fread_in])
						update_class_fields -- Current might have been changed; synchronize
						l_nread.item := l_tmp___0.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						if l_nread.item = 268_435_456 then
							l_keepon := (0).to_boolean
							l_pos := -1 + 22 -- switch 1; break
						end
				when 15 then
						if l_nread.item = 268_435_457 then
							l_pos := -1 + 22 -- switch 1; break
						end
				when 16 then
						if not (l_nread.item > 0) then
							l_pos := -1 + 20 -- skip if block
						end
				when 17 then -- if:
						l_code := send_telnet_data ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_buf, l_nread.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_code.to_boolean then
							l_keepon := (0).to_boolean
							l_pos := -1 + 22 -- switch 1; break
						end
				when 18 then
						l_total_ul := l_total_ul + (l_nread.item).to_integer_64
						l_data.item.Curl_pgrsSetUploadCounter (l_total_ul)
						update_class_fields -- Current might have been changed; synchronize
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						if l_nread.item < 0 then
							l_keepon := (0).to_boolean
						end
				when 21 then -- if done | if done
						l_pos := -1 + 22 -- switch 1; break
				when 22 then -- switch 1, done:
						if not (l_break or l_continue) then
							if (l_data.item.set.timeout).to_boolean then
								l_now := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___1 := (create {P_TIMEVAL_STATIC}).curlx_tvdiff (l_now.twin, created.twin)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___1 >= l_data.item.set.timeout then
									l_data.item.Curl_failf ([ce_string ("Time-out")])
									update_class_fields -- Current might have been changed; synchronize
									l_code := {PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT
									l_keepon := (0).to_boolean
								end
							end
							l_tmp___2 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pgrsUpdate
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___2.to_boolean then
								l_code := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
								l_break := True
							end
						end
						l_pos := -1 + 2 -- back to loop condition
				when 23 then -- loop done
						l_break := False
						l_continue := False;
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (-1, (-1).to_integer_64, (0).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer), -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						Result := l_code
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_fillreadbuffer (a_bytes: INTEGER_32; a_nreadp: CE_POINTER [INTEGER_32]): NATURAL_32
		require
			not a_nreadp.is_void
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_buffersize: NATURAL_32
			l_nread: INTEGER_32
			l_tmp: NATURAL_32
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_hexbuffer: CE_ARRAY [INTEGER_8]
			l_endofline_native: CE_POINTER [INTEGER_8]
			l_endofline_network: CE_POINTER [INTEGER_8]
			l_hexlen: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___1: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_hexbuffer.make (<<11>>)

			l_data := data
			l_buffersize := a_bytes.to_natural_32
			if l_data.item.req.upload_chunky then
				l_buffersize := l_buffersize - ({NATURAL_32} 12)
				l_data.item.req.upload_fromhere := l_data.item.req.upload_fromhere + (10)
				update_class_fields -- Current might have been changed; synchronize
			end
			l_tmp := fread_func.natural_32_item ([l_data.item.req.upload_fromhere, (1).to_natural_32, l_buffersize, fread_in])
			update_class_fields -- Current might have been changed; synchronize
			l_nread := l_tmp.to_integer_32
			if l_nread = 268_435_456 then
				l_data.item.Curl_failf ([ce_string ("operation aborted by callback")])
				update_class_fields -- Current might have been changed; synchronize
				a_nreadp.item := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK)
				l_return := True
			elseif l_nread = 268_435_457 then
				l_k := create {CE_CLASS_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
				l_k.item.keepon := (l_k.item.keepon).bit_or (((1).bit_shift_left (5)))
				update_class_fields -- Current might have been changed; synchronize
				if l_data.item.req.upload_chunky then
					l_data.item.req.upload_fromhere := l_data.item.req.upload_fromhere - (10)
					update_class_fields -- Current might have been changed; synchronize
				end
				a_nreadp.item := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
				l_return := True
			elseif l_nread.to_natural_32 > l_buffersize then
				a_nreadp.item := 0
				update_class_fields -- Current might have been changed; synchronize
				l_data.item.Curl_failf ([ce_string ("read function returned funny value")])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_READ_ERROR)
				l_return := True
			end
			if not l_return then
				if not l_data.item.req.forbidchunk then
					if l_data.item.req.upload_chunky then
						if l_data.item.set.crlf then
							l_endofline_native := ce_string ("%N")
							l_endofline_network := ce_string ("%N")
						elseif l_data.item.set.prefer_ascii then
							l_endofline_native := ce_string ("%N")
							l_endofline_network := ce_string ("%N")
						else
							l_endofline_native := ce_string ("%R%N")
							l_endofline_network := ce_string ("%R%N")
						end
						l_hexlen := (create {P_MPRINTF_STATIC}).curl_msnprintf ([l_hexbuffer, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (11).to_natural_32), ce_string ("%%x%%s"), l_nread, l_endofline_native])
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.req.upload_fromhere := l_data.item.req.upload_fromhere - l_hexlen
						update_class_fields -- Current might have been changed; synchronize
						l_nread := l_nread + l_hexlen
						memcpy (create {CE_VOID_POINTER}.make_cast (l_data.item.req.upload_fromhere), create {CE_VOID_POINTER}.make_cast (l_hexbuffer), l_hexlen.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := strlen (l_endofline_network)
						update_class_fields -- Current might have been changed; synchronize
						memcpy (create {CE_VOID_POINTER}.make_cast ((l_data.item.req.upload_fromhere + l_nread)), create {CE_VOID_POINTER}.make_cast (l_endofline_network), l_tmp___0).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if l_nread - l_hexlen = 0 then
							l_data.item.req.upload_done := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tmp___1 := strlen (l_endofline_native)
						update_class_fields -- Current might have been changed; synchronize
						l_nread := l_nread + l_tmp___1.to_integer_32
					end
				end
				a_nreadp.item := l_nread
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_readrewind: NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_err: INTEGER_32
			l_err___0: NATURAL_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_data := data
			bits.rewindaftersend := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.req.keepon := (l_data.item.req.keepon).bit_and (((((1).bit_shift_left (1))).bit_not))
			update_class_fields -- Current might have been changed; synchronize
			if (l_data.item.set.postfields).is_void then
				if l_data.item.set.httpreq /= {NATURAL_32} 3 then
					if (not (l_data.item.set.seek_func).is_void) then
						l_err := (l_data.item.set.seek_func).integer_32_item ([l_data.item.set.seek_client, (0).to_integer_64, 0])
						update_class_fields -- Current might have been changed; synchronize
						if l_err.to_boolean then
							l_data.item.Curl_failf ([ce_string ("seek callback returned error %%d"), l_err])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_SEND_FAIL_REWIND)
							l_return := True
						end
					elseif (not (l_data.item.set.ioctl_func).is_void) then
						l_err___0 := (l_data.item.set.ioctl_func).natural_32_item ([create {CE_VOID_POINTER}.make_cast (l_data), 1, l_data.item.set.ioctl_client])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("the ioctl callback returned %%d%N"), l_err___0.to_integer_32])
						update_class_fields -- Current might have been changed; synchronize
						if l_err___0.to_boolean then
							l_data.item.Curl_failf ([ce_string ("ioctl callback returned error %%d"), l_err___0.to_integer_32])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_SEND_FAIL_REWIND)
							l_return := True
						end
					else
						if (l_data.item.set.fread_func).is_equal (fread_address) then
							l_tmp := fseek (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (l_data.item.set.in), 0, 0)
							update_class_fields -- Current might have been changed; synchronize
							if -1 /= l_tmp then
								Result := ({PC_CURLCODE}.CURLE_OK)
								l_return := True
							end
						end
						if not l_return then
							l_data.item.Curl_failf ([ce_string ("necessary data rewind wasn%'t possible")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_SEND_FAIL_REWIND)
							l_return := True
						end
					end
				end
			end
			if not l_return then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_readwrite (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_result: NATURAL_32
			l_didwhat: CE_ARRAY [INTEGER_32]
			l_fd_read: INTEGER_32
			l_fd_write: INTEGER_32
			l_select_res: INTEGER_32
			l_ms: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_didwhat.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					l_k := create {CE_CLASS_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
					l_didwhat.item := 0
					update_class_fields -- Current might have been changed; synchronize
					l_select_res := cselect_bits
					Current.cselect_bits := 0
					update_class_fields -- Current might have been changed; synchronize
					if ((l_k.item.keepon).bit_and (((((1).bit_or (((1).bit_shift_left (2))))).bit_or (((1).bit_shift_left (4)))))) = 1 then
						l_fd_read := sockfd
					else
						l_fd_read := -1
					end
					if ((l_k.item.keepon).bit_and (((((((1).bit_shift_left (1))).bit_or (((1).bit_shift_left (3))))).bit_or (((1).bit_shift_left (5)))))) = (1).bit_shift_left (1) then
						l_fd_write := writesockfd
					else
						l_fd_write := -1
					end
					if not l_select_res.to_boolean then
						l_select_res := (create {P_SELECT_STATIC}).Curl_socket_ready (l_fd_read, l_fd_write, 0)
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_select_res = 4 then
						l_data.item.Curl_failf ([ce_string ("select/poll returned error")])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_SEND_ERROR)
						l_return := True
					end
					if not (not l_return and then (((l_k.item.keepon).bit_and (1)).to_boolean)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (((l_select_res).bit_and (1)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (bits.stream_was_rewound) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_result := l_data.item.readwrite_data ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_k, l_didwhat, a_done)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						elseif a_done.item then
							Result := l_result
							l_return := True
						end
				when 6 then -- if done | if done
					if not l_return and then (((l_k.item.keepon).bit_and (((1).bit_shift_left (1)))).to_boolean) then
						if ((l_select_res).bit_and (2)).to_boolean then
							l_result := readwrite_upload (l_data, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_k, l_didwhat)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
					end
					if not l_return then
						l_k.item.now := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
						update_class_fields -- Current might have been changed; synchronize
						if (l_didwhat.item).to_boolean then
							if (not (l_k.item.bytecountp).is_void) then
								(l_k.item.bytecountp).item := l_k.item.bytecount
								update_class_fields -- Current might have been changed; synchronize
							end
							if (not (l_k.item.writebytecountp).is_void) then
								(l_k.item.writebytecountp).item := l_k.item.writebytecount
								update_class_fields -- Current might have been changed; synchronize
							end
						elseif l_k.item.exp100 = {NATURAL_32} 1 then
							l_tmp := (create {P_TIMEVAL_STATIC}).curlx_tvdiff ((l_k.item.now).twin, (l_k.item.start100).twin)
							update_class_fields -- Current might have been changed; synchronize
							l_ms := l_tmp
							if l_ms > 1_000 then
								l_k.item.exp100 := {PC_EXPECT100}.EXP100_SEND_DATA
								update_class_fields -- Current might have been changed; synchronize
								l_k.item.keepon := (l_k.item.keepon).bit_or (((1).bit_shift_left (1)))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Done waiting for 100-continue%N")])
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_tmp___0 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pgrsUpdate
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0.to_boolean then
							l_result := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
						else
							l_result := l_data.item.Curl_speedcheck ((l_k.item.now).twin)
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 15 -- skip if block
					end
				when 7 then -- if:
						if not ((l_k.item.keepon).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_tmp___3 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_timeleft (create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (l_k.c_pointer + (create {PD_SINGLEREQUEST}.make).offset_of ("now")), (0).to_boolean)
						update_class_fields -- Current might have been changed; synchronize
						if 0 > l_tmp___3 then
							if l_k.item.size /= -{INTEGER_64} 1 then
								l_tmp___1 := (create {P_TIMEVAL_STATIC}).curlx_tvdiff ((l_k.item.now).twin, (l_data.item.progress.t_startsingle).twin)
								update_class_fields -- Current might have been changed; synchronize
								l_data.item.Curl_failf ([ce_string ("Operation timed out after %%ld milliseconds with %%lld out of %%lld bytes received"), l_tmp___1, l_k.item.bytecount, l_k.item.size])
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___2 := (create {P_TIMEVAL_STATIC}).curlx_tvdiff ((l_k.item.now).twin, (l_data.item.progress.t_startsingle).twin)
								update_class_fields -- Current might have been changed; synchronize
								l_data.item.Curl_failf ([ce_string ("Operation timed out after %%ld milliseconds with %%lld bytes received"), l_tmp___2, l_k.item.bytecount])
								update_class_fields -- Current might have been changed; synchronize
							end
							Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
							l_return := True
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 10 then -- else:
						if l_data.item.set.opt_no_body then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_k.item.size /= -{INTEGER_64} 1 then
							if l_k.item.bytecount /= l_k.item.size then
								if l_k.item.bytecount /= l_k.item.size + l_data.item.state.crlf_conversions then
									if (l_data.item.req.newurl).is_void then
										l_data.item.Curl_failf ([ce_string ("transfer closed with %%lld bytes remaining to read"), l_k.item.size - l_k.item.bytecount])
										update_class_fields -- Current might have been changed; synchronize
										Result := ({PC_CURLCODE}.CURLE_PARTIAL_FILE)
										l_return := True
									else
										l_pos := -1 + 13 -- goto _L___3
									end
								else
									l_pos := -1 + 13 -- goto _L___3
								end
							else
								l_pos := -1 + 13 -- goto _L___3
							end
						else
							l_pos := -1 + 13 -- goto _L___3
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___3:
						if not l_data.item.set.opt_no_body then
							if l_k.item.chunk then
								if chunk.state /= {NATURAL_32} 8 then
									l_data.item.Curl_failf ([ce_string ("transfer closed with outstanding read data remaining")])
									update_class_fields -- Current might have been changed; synchronize
									Result := ({PC_CURLCODE}.CURLE_PARTIAL_FILE)
									l_return := True
								end
							end
						end
				when 14 then
						if not l_return then
							l_tmp___4 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pgrsUpdate
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___4.to_boolean then
								Result := ({PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK)
								l_return := True
							end
						end
				when 15 then -- if done | if done
					if not l_return then
						a_done.item := (0 = ((l_k.item.keepon).bit_and (((((((1).bit_or (((1).bit_shift_left (1))))).bit_or (((1).bit_shift_left (4))))).bit_or (((1).bit_shift_left (5)))))))
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_retry_request (a_url: CE_POINTER [CE_POINTER [INTEGER_8]]): NATURAL_32
		require
			not a_url.is_void
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					a_url.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					if l_data.item.set.upload then
						if not ((protocol).bit_and (((1).bit_or (((1).bit_shift_left (18)))).to_integer_32)).to_boolean then
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (l_data.item.state.ssl_connect_retry) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 4 then -- else:
						if l_data.item.req.bytecount + (l_data.item.req.headerbytecount).to_integer_64 /= {INTEGER_64} 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 5 then -- if:
						if not (bits.reuse) then
							l_pos := -1 + 9 -- skip if block
						end
				when 6 then -- if:
						if l_data.item.set.opt_no_body then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_data.item.set.rtspreq = {NATURAL_32} 11 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:;
						(create {P_SENDF_STATIC}).Curl_infof ([data, ce_string ("Connection died, retrying a fresh connect%N")])
						update_class_fields -- Current might have been changed; synchronize
						a_url.item := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([data.item.change.url]))
						update_class_fields -- Current might have been changed; synchronize
						if (a_url.item).is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							bits.close := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							bits.retry2 := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
				when 9 then -- if done | if done | if done | if done | if done
					if not l_return then
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_setup_transfer (a_sockindex: INTEGER_32; a_size: INTEGER_64; a_getheader: BOOLEAN; a_bytecountp: CE_POINTER [INTEGER_64]; a_writesockindex: INTEGER_32; a_writecountp: CE_POINTER [INTEGER_64])
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					l_k := create {CE_CLASS_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
					if a_sockindex = -1 then
						Current.sockfd := -1
						update_class_fields -- Current might have been changed; synchronize
					else
						Current.sockfd := sock[a_sockindex]
						update_class_fields -- Current might have been changed; synchronize
					end
					if a_writesockindex = -1 then
						Current.writesockfd := -1
						update_class_fields -- Current might have been changed; synchronize
					else
						Current.writesockfd := sock[a_writesockindex]
						update_class_fields -- Current might have been changed; synchronize
					end
					l_k.item.getheader := a_getheader
					update_class_fields -- Current might have been changed; synchronize
					l_k.item.size := a_size
					update_class_fields -- Current might have been changed; synchronize
					l_k.item.bytecountp := a_bytecountp
					update_class_fields -- Current might have been changed; synchronize
					l_k.item.writebytecountp := a_writecountp
					update_class_fields -- Current might have been changed; synchronize
					if not l_k.item.getheader then
						l_k.item.header := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						if a_size > {INTEGER_64} 0 then
							l_data.item.Curl_pgrsSetDownloadSize (a_size)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if not (l_k.item.getheader) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 3 then -- else:
						if l_data.item.set.opt_no_body then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if: | _L___0:
						if sockfd /= -1 then
							l_k.item.keepon := (l_k.item.keepon).bit_or ((1))
							update_class_fields -- Current might have been changed; synchronize
						end
						if writesockfd = -1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 5 then -- if:
						if not (l_data.item.state.expect100header) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_data.item.state.proto.http).item.sending = {NATURAL_32} 2 then
							l_k.item.exp100 := {PC_EXPECT100}.EXP100_AWAITING_CONTINUE
							update_class_fields -- Current might have been changed; synchronize
							l_k.item.start100 := (l_k.item.start).twin
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.Curl_expire (1_000)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if l_data.item.state.expect100header then
							l_k.item.exp100 := {PC_EXPECT100}.EXP100_SENDING_REQUEST
							update_class_fields -- Current might have been changed; synchronize
						end
						l_k.item.keepon := (l_k.item.keepon).bit_or (((1).bit_shift_left (1)))
						update_class_fields -- Current might have been changed; synchronize
				when 9 then -- if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	PL_ERROR (a_err: NATURAL_32)
		local
			l_parser: CE_POINTER [PD_FTP_PARSELIST_DATA]
		do
			l_parser := (create {CE_CLASS_POINTER [PD_FTP_WC_TMPDATA]}.make_cast (data.item.wildcard.tmp)).item.parser
			if (not (l_parser.item.file_data).is_void) then
				(create {P_FILEINFO_STATIC}).Curl_fileinfo_dtor (create {CE_VOID_POINTER}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_cast (l_parser.item.file_data))
				update_class_fields -- Current might have been changed; synchronize
			end
			l_parser.item.file_data := create {CE_CLASS_POINTER [PD_CURL_FILEINFO]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_parser.item.error := a_err
			update_class_fields -- Current might have been changed; synchronize
		end

	ftp_pl_insert_finfo (a_finfo: CE_POINTER [PD_CURL_FILEINFO]): NATURAL_32
		require
			not a_finfo.is_void
		local
			l_compare: CE_ROUTINE
			l_wc: CE_POINTER [PD_WILDCARDDATA]
			l_tmpdata: CE_POINTER [PD_FTP_WC_TMPDATA]
			l_llist: CE_POINTER [PD_CURL_LLIST]
			l_parser: CE_POINTER [PD_FTP_PARSELIST_DATA]
			l_add: BOOLEAN
			l_str: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			l_wc := create {CE_CLASS_POINTER [PD_WILDCARDDATA]}.make_shared (data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("wildcard"))
			l_tmpdata := create {CE_CLASS_POINTER [PD_FTP_WC_TMPDATA]}.make_cast (l_wc.item.tmp)
			l_llist := l_wc.item.filelist
			l_parser := l_tmpdata.item.parser
			l_add := (1).to_boolean
			l_str := a_finfo.item.b_data
			a_finfo.item.filename := l_str + (l_parser.item.offsets.filename).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			if (l_parser.item.offsets.group).to_boolean then
				a_finfo.item.strings.group := l_str + (l_parser.item.offsets.group).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			else
				a_finfo.item.strings.group := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			if (l_parser.item.offsets.perm).to_boolean then
				a_finfo.item.strings.perm := l_str + (l_parser.item.offsets.perm).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			else
				a_finfo.item.strings.perm := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			if (l_parser.item.offsets.symlink_target).to_boolean then
				a_finfo.item.strings.target := l_str + (l_parser.item.offsets.symlink_target).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			else
				a_finfo.item.strings.target := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			a_finfo.item.strings.time := l_str + (l_parser.item.offsets.time).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			if (l_parser.item.offsets.user).to_boolean then
				a_finfo.item.strings.user := l_str + (l_parser.item.offsets.user).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			else
				a_finfo.item.strings.user := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			l_compare := data.item.set.fnmatch
			if l_compare.is_void then
				l_compare := (create {P_CURL_FNMATCH_STATIC}).Curl_fnmatch_address
			end
			l_tmp___0 := l_compare.integer_32_item ([data.item.set.fnmatch_data, l_wc.item.pattern, a_finfo.item.filename])
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___0 = 0 then
				if a_finfo.item.filetype = {NATURAL_32} 2 then
					if (not (a_finfo.item.strings.target).is_void) then
						l_tmp := strstr (a_finfo.item.strings.target, ce_string (" -> "))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp.is_void) then
							l_add := (0).to_boolean
						end
					end
				end
			else
				l_add := (0).to_boolean
			end
			if l_add then
				l_tmp___1 := (create {P_LLIST_STATIC}).Curl_llist_insert_next (l_llist, l_llist.item.tail, create {CE_VOID_POINTER}.make_cast (a_finfo))
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp___1.to_boolean then
					(create {P_FILEINFO_STATIC}).Curl_fileinfo_dtor (create {CE_VOID_POINTER}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_cast (a_finfo))
					update_class_fields; -- Current might have been changed; synchronize
					(l_tmpdata.item.parser).item.file_data := create {CE_CLASS_POINTER [PD_CURL_FILEINFO]}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			else
				(create {P_FILEINFO_STATIC}).Curl_fileinfo_dtor (create {CE_VOID_POINTER}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_cast (a_finfo))
				update_class_fields -- Current might have been changed; synchronize
			end
			if not l_return then
				(l_tmpdata.item.parser).item.file_data := create {CE_CLASS_POINTER [PD_CURL_FILEINFO]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_httpchunk_read (a_datap: CE_POINTER [INTEGER_8]; a_datalen: INTEGER_32; a_wrotep: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_datap: CE_POINTER [INTEGER_8]
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ch: CE_POINTER [PD_CURL_CHUNKER]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_piece: NATURAL_32
			l_length: NATURAL_32
			l_wrote: CE_POINTER [NATURAL_32]
			l_tmp: NATURAL_32
			l_tmp___0: BOOLEAN
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_ptr: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___5: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_datap := a_datap
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data := data
					l_ch := create {CE_CLASS_POINTER [PD_CURL_CHUNKER]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("chunk"))
					l_k := create {CE_CLASS_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
					l_length := a_datalen.to_natural_32
					l_wrote := create {CE_NATURAL_32_POINTER}.make_cast (a_wrotep)
					l_wrote.item := (0).to_natural_32
					update_class_fields -- Current might have been changed; synchronize
					if l_data.item.set.http_te_skip then
						if not l_k.item.ignorebody then
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write (1, l_datap, a_datalen.to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := ({PC_CHUNKCODE}.CHUNKE_WRITE_ERROR)
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not (l_return) and then (l_length.to_boolean)) then
							l_pos := -1 + 18 -- skip loop
						end
				when 2 then -- loop body:
						inspect (l_ch.item.state).to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 3
						when 2 then l_pos := -1 + 4
						when 3 then l_pos := -1 + 5
						when 4 then l_pos := -1 + 6
						when 5 then l_pos := -1 + 7
						when 6 then l_pos := -1 + 8
						when 9 then l_pos := -1 + 9
						when 10 then l_pos := -1 + 11
						when 11 then l_pos := -1 + 12
						when 7 then l_pos := -1 + 14
						when 8 then l_pos := -1 + 15
						else l_pos := -1 + 16
						end
				when 3 then -- switch 1, case 1
						l_tmp___0 := Curl_isxdigit (l_datap[0])
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0 then
							if l_ch.item.hexindex < 16 then
								l_ch.item.hexbuffer[l_ch.item.hexindex] := l_datap[0]
								update_class_fields -- Current might have been changed; synchronize
								l_datap := l_datap + 1
								l_length := l_length - 1
								l_ch.item.hexindex := (l_ch.item.hexindex) + 1
								update_class_fields -- Current might have been changed; synchronize
							else
								Result := ({PC_CHUNKCODE}.CHUNKE_TOO_LONG_HEX)
								l_return := True
							end
						else
							if 0 = l_ch.item.hexindex then
								Result := ({PC_CHUNKCODE}.CHUNKE_ILLEGAL_HEX)
								l_return := True
							end
							if not l_return then
								l_ch.item.hexbuffer[l_ch.item.hexindex] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_tmp := strtoul ((l_ch.item.hexbuffer), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 16)
								update_class_fields -- Current might have been changed; synchronize
								l_ch.item.datasize := l_tmp.to_natural_32
								update_class_fields -- Current might have been changed; synchronize
								l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_POSTHEX
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_pos := -1 + 17 -- switch 1; break
				when 4 then -- switch 1, case 2
						if (l_datap[0]).to_integer_32 = 13 then
							l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_CR
							update_class_fields -- Current might have been changed; synchronize
						end
						l_length := l_length - 1
						l_datap := l_datap + 1
						l_pos := -1 + 17 -- switch 1; break
				when 5 then -- switch 1, case 3
						if (l_datap[0]).to_integer_32 = 10 then
							if {NATURAL_32} 0 = l_ch.item.datasize then
								l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_TRAILER
								update_class_fields -- Current might have been changed; synchronize
								Current.trlPos := 0
								update_class_fields -- Current might have been changed; synchronize
							else
								l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_DATA
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_CR
							update_class_fields -- Current might have been changed; synchronize
						end
						l_datap := l_datap + 1
						l_length := l_length - 1
						l_pos := -1 + 17 -- switch 1; break
				when 6 then -- switch 1, case 4
						if l_ch.item.datasize >= l_length then
							l_piece := l_length
						else
							l_piece := l_ch.item.datasize
						end
						if not l_k.item.ignorebody then
							if not l_data.item.set.http_te_skip then
								l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write (1, l_datap, l_piece)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_result := {PC_CURLCODE}.CURLE_OK
							end
						end
						if l_result.to_boolean then
							Result := ({PC_CHUNKCODE}.CHUNKE_WRITE_ERROR)
							l_return := True
						end
						if not l_return then
							l_wrote.item := l_wrote.item + l_piece
							update_class_fields -- Current might have been changed; synchronize
							l_ch.item.datasize := l_ch.item.datasize - l_piece
							update_class_fields -- Current might have been changed; synchronize
							l_datap := l_datap + l_piece.to_integer_32
							l_length := l_length - l_piece
							if {NATURAL_32} 0 = l_ch.item.datasize then
								l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_POSTCR
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_pos := -1 + 17 -- switch 1; break
				when 7 then -- switch 1, case 5
						if (l_datap[0]).to_integer_32 = 13 then
							l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_POSTLF
							update_class_fields -- Current might have been changed; synchronize
							l_datap := l_datap + 1
							l_length := l_length - 1
						else
							Result := ({PC_CHUNKCODE}.CHUNKE_BAD_CHUNK)
							l_return := True
						end
						l_pos := -1 + 17 -- switch 1; break
				when 8 then -- switch 1, case 6
						if (l_datap[0]).to_integer_32 = 10 then
							(create {P_HTTP_CHUNKS_STATIC}).Curl_httpchunk_init ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
							update_class_fields -- Current might have been changed; synchronize
							l_datap := l_datap + 1
							l_length := l_length - 1
						else
							Result := ({PC_CHUNKCODE}.CHUNKE_BAD_CHUNK)
							l_return := True
						end
						l_pos := -1 + 17 -- switch 1; break
				when 9 then -- switch 1, case 9
						if (l_datap[0]).to_integer_32 = 13 then
							if trlPos.to_boolean then
								l_tmp___1 := trlPos
								Current.trlPos := trlPos + 1
								update_class_fields -- Current might have been changed; synchronize
								trailer[l_tmp___1] := (13).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___2 := trlPos
								Current.trlPos := trlPos + 1
								update_class_fields -- Current might have been changed; synchronize
								trailer[l_tmp___2] := (10).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								trailer[trlPos] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								if not l_data.item.set.http_te_skip then
									l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write ((1).bit_shift_left (1), trailer, trlPos.to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
									if l_result.to_boolean then
										Result := ({PC_CHUNKCODE}.CHUNKE_WRITE_ERROR)
										l_return := True
									end
								end
								if not l_return then
									Current.trlPos := 0
									update_class_fields -- Current might have been changed; synchronize
									l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_TRAILER_CR
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_TRAILER_POSTCR
								update_class_fields -- Current might have been changed; synchronize
								l_pos := -1 + 17 -- switch 1; break
							end
						else
							if trlPos >= trlMax then
								if trlMax.to_boolean then
									Current.trlMax := trlMax * (2)
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___3 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_crealloc.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (trailer), (trlMax + 3).to_natural_32]))
									update_class_fields -- Current might have been changed; synchronize
									l_ptr := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___3)
								else
									Current.trlMax := 128
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___4 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(trlMax + 3).to_natural_32]))
									update_class_fields -- Current might have been changed; synchronize
									l_ptr := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___4)
								end
								if l_ptr.is_void then
									Result := ({PC_CHUNKCODE}.CHUNKE_OUT_OF_MEMORY)
									l_return := True
								end
								if not l_return then
									Current.trailer := l_ptr
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							if not l_return then
								(create {P_MPRINTF_STATIC}).curl_mfprintf ([(create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), ce_string ("MOO: %%c%N"), (l_datap[0]).to_integer_32]).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___5 := trlPos
								Current.trlPos := trlPos + 1
								update_class_fields -- Current might have been changed; synchronize
								trailer[l_tmp___5] := l_datap[0]
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 10 then
						if not l_return then
							l_datap := l_datap + 1
							l_length := l_length - 1
						end
						l_pos := -1 + 17 -- switch 1; break
				when 11 then -- switch 1, case 10
						if (l_datap[0]).to_integer_32 = 10 then
							l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_TRAILER_POSTCR
							update_class_fields -- Current might have been changed; synchronize
							l_datap := l_datap + 1
							l_length := l_length - 1
						else
							Result := ({PC_CHUNKCODE}.CHUNKE_BAD_CHUNK)
							l_return := True
						end
						l_pos := -1 + 17 -- switch 1; break
				when 12 then -- switch 1, case 11
						if (l_datap[0]).to_integer_32 /= 13 then
							l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_TRAILER
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 17 -- switch 1; break
						end
				when 13 then
						l_datap := l_datap + 1
						l_length := l_length - 1
						l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_STOP
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 17 -- switch 1; break
				when 14 then -- switch 1, case 7
						if (l_datap[0]).to_integer_32 = 13 then
							l_ch.item.state := {PC_CHUNKYSTATE}.CHUNK_STOP
							update_class_fields -- Current might have been changed; synchronize
							l_datap := l_datap + 1
							l_length := l_length - 1
						else
							Result := ({PC_CHUNKCODE}.CHUNKE_BAD_CHUNK)
							l_return := True
						end
						l_pos := -1 + 17 -- switch 1; break
				when 15 then -- switch 1, case 8
						if (l_datap[0]).to_integer_32 = 10 then
							l_length := l_length - 1
							l_ch.item.dataleft := l_length
							update_class_fields -- Current might have been changed; synchronize
							Result := (-1)
							l_return := True
						else
							Result := ({PC_CHUNKCODE}.CHUNKE_BAD_CHUNK)
							l_return := True
						end
				when 16 then -- switch 1, default:
						if not l_return then
							Result := ({PC_CHUNKCODE}.CHUNKE_STATE_ERROR)
							l_return := True
						end
				when 17 then -- switch 1, done:
						l_pos := -1 + 1 -- back to loop condition
				when 18 then -- loop done | if done
					if not l_return then
						Result := ({PC_CHUNKCODE}.CHUNKE_OK)
					end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_timeleft (a_nowp: CE_POINTER [SD_TIMEVAL]; a_duringconnect: BOOLEAN): INTEGER_32
		local
			l_nowp: CE_POINTER [SD_TIMEVAL]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_timeout_set: INTEGER_32
			l_timeout_ms: INTEGER_32
			l_tmp: INTEGER_32
			l_now: CE_ARRAY [SD_TIMEVAL]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_now.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nowp := a_nowp
					l_data := data
					l_timeout_set := 0
					if a_duringconnect then
						l_tmp := 300_000
					else
						l_tmp := 0
					end
					l_timeout_ms := l_tmp.to_integer_32
					if l_data.item.set.timeout > 0 then
						l_timeout_set := (l_timeout_set).bit_or ((1))
					end
					if a_duringconnect then
						if l_data.item.set.connecttimeout > 0 then
							l_timeout_set := (l_timeout_set).bit_or ((2))
						end
					end
					inspect l_timeout_set -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 1
					l_timeout_ms := l_data.item.set.timeout
					l_pos := -1 + 5 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_timeout_ms := l_data.item.set.connecttimeout
					l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 3
					if l_data.item.set.timeout < l_data.item.set.connecttimeout then
						l_timeout_ms := l_data.item.set.timeout
					else
						l_timeout_ms := l_data.item.set.connecttimeout
					end
					l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:
					if not a_duringconnect then
						Result := 0
						l_return := True
					end
					l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
					if not l_return then
						if l_nowp.is_void then
							l_now.item := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
							update_class_fields -- Current might have been changed; synchronize
							l_nowp := l_now
						end
						l_tmp___0 := (create {P_TIMEVAL_STATIC}).curlx_tvdiff ((l_nowp.item).twin, (l_data.item.progress.t_startsingle).twin)
						update_class_fields -- Current might have been changed; synchronize
						l_timeout_ms := l_timeout_ms - l_tmp___0
						if not l_timeout_ms.to_boolean then
							Result := (-1)
							l_return := True
						end
					end
					if not l_return then
						Result := l_timeout_ms
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	waitconnect (a_sockfd: INTEGER_32; a_timeout_msec: INTEGER_32): INTEGER_32
		local
			l_timeout_msec: INTEGER_32
			l_rc: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			l_timeout_msec := a_timeout_msec
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_continue := False
				if l_timeout_msec > 1_000 then
					l_tmp := 1_000
				else
					l_tmp := l_timeout_msec
				end
				l_rc := (create {P_SELECT_STATIC}).Curl_socket_ready (-1, a_sockfd, l_tmp.to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pgrsUpdate
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					Result := 3
					l_return := True
				end
				if not l_return then
					if -1 = l_rc then
						Result := (-1)
						l_return := True
					elseif 0 = l_rc then
						l_timeout_msec := l_timeout_msec - (1_000)
						if l_timeout_msec <= 0 then
							Result := 1
							l_return := True
						end
						if not l_return then
							l_continue := True
						end
					end
				end
				if not l_return then
					if not (l_return or l_break or l_continue) then
						if ((l_rc).bit_and (4)).to_boolean then
							Result := 2
							l_return := True
						end
						if not l_return then
							l_break := True
						end
					end
					if (not l_return and not l_break) then
						
					end
				end
			end
			if not l_return then
				l_break := False
				l_continue := False
				Result := 0
			end
		end

	bindlocal (a_sockfd, a_af: INTEGER_32): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_sa: CE_ARRAY [PD_CURL_SOCKADDR_STORAGE]
			l_sock: CE_POINTER [SD_SOCKADDR]
			l_sizeof_sa: NATURAL_32
			l_si4: CE_POINTER [SD_SOCKADDR_IN]
			l_si6: CE_POINTER [SD_SOCKADDR_IN6]
			l_h: CE_ARRAY [CE_POINTER [PD_CURL_DNS_ENTRY]]
			l_port: NATURAL_16
			l_portnum: INTEGER_32
			l_dev: CE_POINTER [INTEGER_8]
			l_error: INTEGER_32
			l_myhost: CE_ARRAY [INTEGER_8]
			l_done: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_32]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: NATURAL_32
			l_tmp___2: INTEGER_32
			l_ipver: INTEGER_32
			l_rc: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: NATURAL_32
			l_add: CE_ARRAY [PD_CURL_SOCKADDR_STORAGE]
			l_size: CE_ARRAY [NATURAL_32]
			l_tmp___7: CE_POINTER [INTEGER_32]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: CE_POINTER [INTEGER_32]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_CURL_SOCKADDR_STORAGE]} l_sa.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_CURL_DNS_ENTRY]} l_h.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_myhost.make (<<256>>)
			create {CE_CLASS_ARRAY [PD_CURL_SOCKADDR_STORAGE]} l_add.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_size.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					l_sock := create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_sa)
					l_sizeof_sa := (0).to_natural_32
					l_si4 := create {CE_CLASS_POINTER [SD_SOCKADDR_IN]}.make_cast (l_sa)
					l_si6 := create {CE_CLASS_POINTER [SD_SOCKADDR_IN6]}.make_cast (l_sa)
					l_h.item := create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					l_port := l_data.item.set.localport
					l_portnum := l_data.item.set.localportrange
					l_dev := l_data.item.set.str[5]
					l_myhost[0] := (('%/0/').code).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_done := 0
					if l_dev.is_void then
						if not l_port.to_boolean then
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						memset (create {CE_VOID_POINTER}.make_cast (l_sa), 0, (create {PD_CURL_SOCKADDR_STORAGE}.make).structure_size.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if l_dev.is_void then
							l_pos := -1 + 12 -- skip if block
						end
				when 2 then -- if:
						l_tmp___6 := strlen (l_dev)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___6 < {NATURAL_32} 255) then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						l_tmp___3 := Curl_if2ip (a_af, l_dev, l_myhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp___3.is_void) then
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Local Interface %%s is ip %%s using address family %%i%N"), l_dev, l_myhost, a_af])
							update_class_fields -- Current might have been changed; synchronize
							l_done := 1
							l_tmp___1 := strlen (l_dev)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___2 := setsockopt (a_sockfd, 1, 25, create {CE_VOID_POINTER}.make_cast (l_dev), l_tmp___1 + {NATURAL_32} 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___2 /= 0 then
								l_tmp := errno_location
								update_class_fields -- Current might have been changed; synchronize
								l_error := l_tmp.item
								l_tmp___0 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_error)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("SO_BINDTODEVICE %%s failed with errno %%d: %%s; will do regular bind%N"), l_dev, l_error, l_tmp___0])
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_ipver := l_data.item.set.ip_version
							if a_af = 2 then
								l_data.item.set.ip_version := 1
								update_class_fields -- Current might have been changed; synchronize
							elseif a_af = 10 then
								l_data.item.set.ip_version := 2
								update_class_fields -- Current might have been changed; synchronize
							end
							l_rc := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_resolv (l_dev, 0, l_h)
							update_class_fields -- Current might have been changed; synchronize
							if l_rc = 1 then
								(create {P_HOSTSYN_STATIC}).Curl_wait_for_resolv ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_h).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
							l_data.item.set.ip_version := l_ipver
							update_class_fields -- Current might have been changed; synchronize
							if (not (l_h.item).is_void) then
								Curl_printable_address (l_h.item.item.addr, l_myhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32)).do_nothing
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Name %'%%s%' family %%i resolved to %'%%s%' family %%i%N"), l_dev, a_af, l_myhost, (l_h.item.item.addr).item.ai_family])
								update_class_fields -- Current might have been changed; synchronize
								l_data.item.Curl_resolv_unlock (l_h.item)
								update_class_fields -- Current might have been changed; synchronize
								l_done := 1
							else
								l_done := -1
							end
						end
						if not (l_done > 0) then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if a_af /= 10 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_tmp___5 := inet_pton (10, l_myhost, create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN6_ADDR]}.make_shared (l_si6.c_pointer + (create {SD_SOCKADDR_IN6}.make).offset_of ("sin6_addr")))))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___5 > 0 then
							l_si6.item.sin6_family := (10).to_natural_16
							update_class_fields -- Current might have been changed; synchronize
							l_si6.item.sin6_port := htons (l_port)
							update_class_fields -- Current might have been changed; synchronize
							l_sizeof_sa := (create {SD_SOCKADDR_IN6}.make).structure_size.to_natural_32
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if a_af = 2 then
							l_tmp___4 := inet_pton (2, l_myhost, create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN_ADDR]}.make_shared (l_si4.c_pointer + (create {SD_SOCKADDR_IN}.make).offset_of ("sin_addr")))))
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___4 > 0 then
								l_si4.item.sin_family := (2).to_natural_16
								update_class_fields -- Current might have been changed; synchronize
								l_si4.item.sin_port := htons (l_port)
								update_class_fields -- Current might have been changed; synchronize
								l_sizeof_sa := (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32
							end
						end
				when 8 then -- if done
						if l_done < 1 then
							l_data.item.Curl_failf ([ce_string ("Couldn%'t bind to %'%%s%'"), l_dev])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_INTERFACE_FAILED)
							l_return := True
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___0
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						if a_af = 10 then
							l_si6.item.sin6_family := (10).to_natural_16
							update_class_fields -- Current might have been changed; synchronize
							l_si6.item.sin6_port := htons (l_port)
							update_class_fields -- Current might have been changed; synchronize
							l_sizeof_sa := (create {SD_SOCKADDR_IN6}.make).structure_size.to_natural_32
						elseif a_af = 2 then
							l_si4.item.sin_family := (2).to_natural_16
							update_class_fields -- Current might have been changed; synchronize
							l_si4.item.sin_port := htons (l_port)
							update_class_fields -- Current might have been changed; synchronize
							l_sizeof_sa := (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32
						end
				when 13 then -- if done
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_tmp___10 := bind (a_sockfd, l_sock, l_sizeof_sa)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___10 >= 0 then
								l_size.item := (create {PD_CURL_SOCKADDR_STORAGE}.make).structure_size.to_natural_32
								update_class_fields -- Current might have been changed; synchronize
								memset (create {CE_VOID_POINTER}.make_cast (l_add), 0, (create {PD_CURL_SOCKADDR_STORAGE}.make).structure_size.to_natural_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___9 := getsockname (a_sockfd, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_add), l_size)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___9 < 0 then
									l_tmp___7 := errno_location
									update_class_fields -- Current might have been changed; synchronize
									l_error := l_tmp___7.item
									l_data.item.state.os_errno := l_error
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___8 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_error)
									update_class_fields -- Current might have been changed; synchronize
									l_data.item.Curl_failf ([ce_string ("getsockname() failed with errno %%d: %%s"), l_error, l_tmp___8])
									update_class_fields -- Current might have been changed; synchronize
									Result := ({PC_CURLCODE}.CURLE_INTERFACE_FAILED)
									l_return := True
								end
								if not l_return then
									(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Local port: %%hu%N"), l_port.to_integer_32])
									update_class_fields -- Current might have been changed; synchronize
									bits.bound := (1).to_boolean
									update_class_fields -- Current might have been changed; synchronize
									Result := ({PC_CURLCODE}.CURLE_OK)
									l_return := True
								end
							end
							if not l_return then
								l_portnum := l_portnum - 1
								if l_portnum > 0 then
									(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Bind to local port %%hu failed, trying next%N"), l_port.to_integer_32])
									update_class_fields -- Current might have been changed; synchronize
									l_port := (l_port.to_integer_32 + 1).to_natural_16
									if (l_sock.item.sa_family).to_integer_32 = 2 then
										l_si4.item.sin_port := ntohs (l_port)
										update_class_fields -- Current might have been changed; synchronize
									else
										l_si6.item.sin6_port := ntohs (l_port)
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									l_break := True
								end
							end
						end
					end
					if not l_return then
						l_break := False
						l_tmp___11 := errno_location
						update_class_fields -- Current might have been changed; synchronize
						l_error := l_tmp___11.item
						l_data.item.state.os_errno := l_error
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___12 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_error)
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.Curl_failf ([ce_string ("bind failed with errno %%d: %%s"), l_error, l_tmp___12])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_INTERFACE_FAILED)
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	trynextip (a_sockindex: INTEGER_32; a_connected: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_connected.is_void
		local
			l_sockfd: CE_ARRAY [INTEGER_32]
			l_ai: CE_POINTER [PD_CURL_ADDRINFO]
			l_fd_to_close: INTEGER_32
			l_res: NATURAL_32
			l_tmp: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_sockfd.make (<<1>>)

			l_fd_to_close := sock[a_sockindex]
			sock[a_sockindex] := -1
			update_class_fields -- Current might have been changed; synchronize
			a_connected.item := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			if a_sockindex /= 0 then
				close (l_fd_to_close).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
				l_return := True
			end
			if not l_return then
				l_ai := ip_addr.item.ai_next
				from
				until
					not (not (l_return) and then (not l_ai.is_void))
				loop
					l_tmp := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.singleipconnect (l_ai, 0, l_sockfd, a_connected)
					update_class_fields -- Current might have been changed; synchronize
					l_res := l_tmp
					if l_res.to_boolean then
						Result := l_res
						l_return := True
					end
					if not l_return and then (l_sockfd.item /= -1) then
						sock[a_sockindex] := l_sockfd.item
						update_class_fields -- Current might have been changed; synchronize
						Current.ip_addr := l_ai
						update_class_fields -- Current might have been changed; synchronize
						close (l_fd_to_close).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
					end
					if not l_return then
						l_ai := l_ai.item.ai_next
					end
				end
			end
			if not l_return then
				close (l_fd_to_close).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
			end
		end

	Curl_updateconninfo (a_sockfd: INTEGER_32)
		local
			l_error: INTEGER_32
			l_len: CE_ARRAY [NATURAL_32]
			l_ssrem: CE_ARRAY [PD_CURL_SOCKADDR_STORAGE]
			l_ssloc: CE_ARRAY [PD_CURL_SOCKADDR_STORAGE]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_info: CE_POINTER [PD_PUREINFO]
			l_tmp: CE_POINTER [INTEGER_32]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_32]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: INTEGER_32
			l_tmp___5: CE_POINTER [INTEGER_32]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: BOOLEAN
			l_tmp___8: CE_POINTER [INTEGER_32]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: BOOLEAN
			l_return: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_len.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_CURL_SOCKADDR_STORAGE]} l_ssrem.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_CURL_SOCKADDR_STORAGE]} l_ssloc.make (<<1>>)

			l_data := data
			l_info := create {CE_CLASS_POINTER [PD_PUREINFO]}.make_shared (data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("info"))
			if bits.reuse then
				l_return := True
			end
			if not l_return then
				l_len.item := (create {PD_CURL_SOCKADDR_STORAGE}.make).structure_size.to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___1 := getpeername (a_sockfd, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_ssrem), l_len)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___1.to_boolean then
					l_tmp := errno_location
					update_class_fields -- Current might have been changed; synchronize
					l_error := l_tmp.item
					l_tmp___0 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_error)
					update_class_fields -- Current might have been changed; synchronize
					l_data.item.Curl_failf ([ce_string ("getpeername() failed with errno %%d: %%s"), l_error, l_tmp___0])
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
				l_len.item := (create {PD_CURL_SOCKADDR_STORAGE}.make).structure_size.to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___4 := getsockname (a_sockfd, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_ssloc), l_len)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___4.to_boolean then
					l_tmp___2 := errno_location
					update_class_fields -- Current might have been changed; synchronize
					l_error := l_tmp___2.item
					l_tmp___3 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_error)
					update_class_fields -- Current might have been changed; synchronize
					l_data.item.Curl_failf ([ce_string ("getsockname() failed with errno %%d: %%s"), l_error, l_tmp___3])
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
				l_tmp___7 := getaddressinfo (create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_ssrem), l_info.item.ip, create {CE_INTEGER_32_POINTER}.make_shared (l_info.c_pointer + (create {PD_PUREINFO}.make).offset_of ("port")))
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp___7 then
					l_tmp___5 := errno_location
					update_class_fields -- Current might have been changed; synchronize
					l_error := l_tmp___5.item
					l_tmp___6 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_error)
					update_class_fields -- Current might have been changed; synchronize
					l_data.item.Curl_failf ([ce_string ("ssrem inet_ntop() failed with errno %%d: %%s"), l_error, l_tmp___6])
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
				l_tmp___10 := getaddressinfo (create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_ssloc), l_info.item.localip, create {CE_INTEGER_32_POINTER}.make_shared (l_info.c_pointer + (create {PD_PUREINFO}.make).offset_of ("localport")))
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp___10 then
					l_tmp___8 := errno_location
					update_class_fields -- Current might have been changed; synchronize
					l_error := l_tmp___8.item
					l_tmp___9 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_error)
					update_class_fields -- Current might have been changed; synchronize
					l_data.item.Curl_failf ([ce_string ("ssloc inet_ntop() failed with errno %%d: %%s"), l_error, l_tmp___9])
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
			end
		end

	Curl_is_connected (a_sockindex: INTEGER_32; a_connected: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_connected.is_void
		local
			l_rc: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_code: NATURAL_32
			l_sockfd: INTEGER_32
			l_allow: INTEGER_32
			l_error: CE_ARRAY [INTEGER_32]
			l_tmp: BOOLEAN
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_32]
			l_tmp___2: CE_POINTER [INTEGER_32]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_error.make (<<1>>)

			l_data := data
			l_code := {PC_CURLCODE}.CURLE_OK
			l_sockfd := sock[a_sockindex]
			l_allow := 300_000
			l_error.item := 0
			update_class_fields -- Current might have been changed; synchronize
			a_connected.item := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			if bits.tcpconnect then
				a_connected.item := (1).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
				l_return := True
			end
			if not l_return then
				l_allow := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_timeleft (create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer), (1).to_boolean)
				update_class_fields -- Current might have been changed; synchronize
				if l_allow < 0 then
					l_data.item.Curl_failf ([ce_string ("Connection time-out")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
					l_return := True
				end
			end
			if not l_return then
				l_rc := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.waitconnect (l_sockfd, 0)
				update_class_fields -- Current might have been changed; synchronize
				if 1 = l_rc then
					Result := l_code
					l_return := True
				end
			end
			if not l_return then
				if 0 = l_rc then
					l_tmp := verifyconnect (l_sockfd, l_error)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp then
						bits.tcpconnect := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						a_connected.item := (1).to_boolean
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_PROGRESS_STATIC}).Curl_pgrsTime (l_data, {PC_TIMERID}.TIMER_CONNECT)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_verboseconnect
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_updateconninfo (l_sockfd)
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
					end
				elseif 2 = l_rc then
					verifyconnect (l_sockfd, l_error).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_error.item)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("%%s%N"), l_tmp___0])
					update_class_fields -- Current might have been changed; synchronize
				else
					(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Connection failed%N")])
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				if (l_error.item).to_boolean then
					l_data.item.state.os_errno := l_error.item
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___1 := errno_location
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___1.item := l_error.item
					update_class_fields -- Current might have been changed; synchronize
				end
				l_code := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.trynextip (a_sockindex, a_connected)
				update_class_fields -- Current might have been changed; synchronize
				if l_code.to_boolean then
					l_tmp___2 := errno_location
					update_class_fields -- Current might have been changed; synchronize
					l_error.item := l_tmp___2.item
					update_class_fields -- Current might have been changed; synchronize
					l_data.item.state.os_errno := l_error.item
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___3 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_error.item)
					update_class_fields -- Current might have been changed; synchronize
					l_data.item.Curl_failf ([ce_string ("Failed connect to %%s:%%ld; %%s"), host.name, port, l_tmp___3])
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_code
			end
		end

	tcpnodelay (a_sockfd: INTEGER_32)
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_onoff: CE_ARRAY [NATURAL_32]
			l_proto: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_32]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_onoff.make (<<1>>)

			l_data := data
			l_onoff.item := (l_data.item.set.tcp_nodelay).to_integer.to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_proto := 6
			l_tmp___1 := setsockopt (a_sockfd, l_proto, 1, create {CE_VOID_POINTER}.make_cast (l_onoff), {PLATFORM}.Natural_32_bytes.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___1 < 0 then
				l_tmp := errno_location
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_tmp.item)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Could not set TCP_NODELAY: %%s%N"), l_tmp___0])
				update_class_fields -- Current might have been changed; synchronize
			else
				(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("TCP_NODELAY set%N")])
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	singleipconnect (a_ai: CE_POINTER [PD_CURL_ADDRINFO]; a_timeout_ms: INTEGER_32; a_sockp: CE_POINTER [INTEGER_32]; a_connected: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_ai.is_void
			not a_sockp.is_void
			not a_connected.is_void
		local
			l_addr: CE_ARRAY [PD_CURL_SOCKADDR_EX]
			l_addr_buf: CE_ARRAY [INTEGER_8]
			l_rc: INTEGER_32
			l_error: CE_ARRAY [INTEGER_32]
			l_isconnected: BOOLEAN
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_sockfd: INTEGER_32
			l_res: NATURAL_32
			l_iptoprint: CE_POINTER [ANY]
			l_sa4: CE_POINTER [SD_SOCKADDR_IN]
			l_sa6: CE_POINTER [SD_SOCKADDR_IN6]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_32]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_CURL_SOCKADDR_EX]} l_addr.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_addr_buf.make (<<128>>)
			create {CE_INTEGER_32_ARRAY} l_error.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					l_res := {PC_CURLCODE}.CURLE_OK
					l_sa4 := create {CE_CLASS_POINTER [SD_SOCKADDR_IN]}.make_cast ((create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_shared (l_addr.item.c_pointer + (create {PD_CURL_SOCKADDR_EX}.make).offset_of ("sa_ex_u") + (create {PD_SA_EX_U}.make).offset_of ("addr"))))
					l_sa6 := create {CE_CLASS_POINTER [SD_SOCKADDR_IN6]}.make_cast ((create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_shared (l_addr.item.c_pointer + (create {PD_CURL_SOCKADDR_EX}.make).offset_of ("sa_ex_u") + (create {PD_SA_EX_U}.make).offset_of ("addr"))))
					a_sockp.item := -1
					update_class_fields -- Current might have been changed; synchronize
					l_addr.item.family := a_ai.item.ai_family
					update_class_fields -- Current might have been changed; synchronize
					l_addr.item.socktype := socktype
					update_class_fields -- Current might have been changed; synchronize
					l_addr.item.protocol := a_ai.item.ai_protocol
					update_class_fields -- Current might have been changed; synchronize
					l_addr.item.addrlen := a_ai.item.ai_addrlen
					update_class_fields -- Current might have been changed; synchronize
					if l_addr.item.addrlen > (create {PD_CURL_SOCKADDR_STORAGE}.make).structure_size.to_natural_32 then
						l_addr.item.addrlen := (create {PD_CURL_SOCKADDR_STORAGE}.make).structure_size.to_natural_32
						update_class_fields -- Current might have been changed; synchronize
					end
					memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_shared (l_addr.item.c_pointer + (create {PD_CURL_SOCKADDR_EX}.make).offset_of ("sa_ex_u") + (create {PD_SA_EX_U}.make).offset_of ("addr")))), create {CE_VOID_POINTER}.make_cast (a_ai.item.ai_addr), l_addr.item.addrlen).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					a_connected.item := (0).to_boolean
					update_class_fields -- Current might have been changed; synchronize
					if (not (l_data.item.set.fopensocket).is_void) then
						l_sockfd := (l_data.item.set.fopensocket).integer_32_item ([l_data.item.set.opensocket_client, {PC_CURLSOCKTYPE}.CURLSOCKTYPE_IPCXN, create {CE_CLASS_POINTER [PD_CURL_SOCKADDR]}.make_cast (l_addr)])
						update_class_fields -- Current might have been changed; synchronize
					else
						l_sockfd := socket (l_addr.item.family, l_addr.item.socktype, l_addr.item.protocol)
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_sockfd = -1 then
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
					end
					if not l_return then
						if scope.to_boolean then
							if l_addr.item.family = 10 then
								l_sa6.item.sin6_scope_id := scope
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if l_addr.item.family = 1 then
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("  Trying %%s... "), (create {CE_CLASS_POINTER [SD_SOCKADDR_UN]}.make_cast ((create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_shared (l_addr.item.c_pointer + (create {PD_CURL_SOCKADDR_EX}.make).offset_of ("sa_ex_u") + (create {PD_SA_EX_U}.make).offset_of ("addr"))))).item.sun_path])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_data.item.info.ip, (("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255").count + 1).to_natural_32, ce_string ("%%s"), (create {CE_CLASS_POINTER [SD_SOCKADDR_UN]}.make_cast ((create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_shared (l_addr.item.c_pointer + (create {PD_CURL_SOCKADDR_EX}.make).offset_of ("sa_ex_u") + (create {PD_SA_EX_U}.make).offset_of ("addr"))))).item.sun_path]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							strcpy (ip_addr_str, (l_data.item.info.ip)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						else
							if l_addr.item.family = 10 then
								l_iptoprint := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN6_ADDR]}.make_shared (l_sa6.c_pointer + (create {SD_SOCKADDR_IN6}.make).offset_of ("sin6_addr"))))
								bits.ipv6 := (1).to_boolean
								update_class_fields -- Current might have been changed; synchronize
							else
								l_iptoprint := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN_ADDR]}.make_shared (l_sa4.c_pointer + (create {SD_SOCKADDR_IN}.make).offset_of ("sin_addr"))))
							end
							l_tmp := inet_ntop (l_addr.item.family, l_iptoprint, l_addr_buf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (128).to_natural_32))
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp.is_void then
								(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("  Trying %%s... "), l_addr_buf])
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_data.item.info.ip, (("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255").count + 1).to_natural_32, ce_string ("%%s"), l_addr_buf]).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								strcpy (ip_addr_str, (l_data.item.info.ip)).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if l_data.item.set.tcp_nodelay then
							((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.tcpnodelay (l_sockfd)
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not (l_data.item.set.fsockopt).is_void) then
							l_error.item := (l_data.item.set.fsockopt).integer_32_item ([l_data.item.set.sockopt_client, l_sockfd, {PC_CURLSOCKTYPE}.CURLSOCKTYPE_IPCXN])
							update_class_fields -- Current might have been changed; synchronize
							if (l_error.item).to_boolean then
								close (l_sockfd).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								Result := l_res
								l_return := True
							end
						end
					end
					if not l_return then
						l_res := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.bindlocal (l_sockfd, l_addr.item.family)
						update_class_fields -- Current might have been changed; synchronize
						if l_res.to_boolean then
							close (l_sockfd).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Result := l_res
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						curlx_nonblock (l_sockfd, 1).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if socktype = 1 then
							l_rc := connect (l_sockfd, (create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_shared (l_addr.item.c_pointer + (create {PD_CURL_SOCKADDR_EX}.make).offset_of ("sa_ex_u") + (create {PD_SA_EX_U}.make).offset_of ("addr"))), l_addr.item.addrlen)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_rc := 0
						end
						if -1 /= l_rc then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						l_tmp___0 := errno_location
						update_class_fields -- Current might have been changed; synchronize
						l_error.item := l_tmp___0.item
						update_class_fields -- Current might have been changed; synchronize
						inspect l_error.item -- switch 1 head
						when 115 then l_pos := -1 + 3
						when 11 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 3 then -- switch 1, case 115 | switch 1, case 11
						l_rc := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.waitconnect (l_sockfd, a_timeout_ms)
						update_class_fields -- Current might have been changed; synchronize
						if 3 = l_rc then
							close (l_sockfd).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK)
							l_return := True
						end
						l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:
						l_tmp___1 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_error.item)
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.Curl_failf ([ce_string ("Failed to connect to %%s: %%s"), l_addr_buf, l_tmp___1])
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.state.os_errno := l_error.item
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done: | if done | if done
					if not l_return and then (1 = l_rc) then
						if l_data.item.state.used_interface = {NATURAL_32} 2 then
							a_sockp.item := l_sockfd
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 6 then -- if:
						l_isconnected := verifyconnect (l_sockfd, l_error)
						update_class_fields -- Current might have been changed; synchronize
						if l_rc.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_isconnected then
							a_connected.item := (1).to_boolean
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("connected%N")])
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_updateconninfo (l_sockfd)
							update_class_fields -- Current might have been changed; synchronize
							a_sockp.item := l_sockfd
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if 1 = l_rc then
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Timeout%N")])
							update_class_fields -- Current might have been changed; synchronize
						else
							l_data.item.state.os_errno := l_error.item
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___2 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_error.item)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("%%s%N"), l_tmp___2])
							update_class_fields -- Current might have been changed; synchronize
						end
				when 10 then -- if done
					if not l_return then
						close (l_sockfd).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_connecthost (a_remotehost: CE_POINTER [PD_CURL_DNS_ENTRY]; a_sockconn: CE_POINTER [INTEGER_32]; a_addr: CE_POINTER [CE_POINTER [PD_CURL_ADDRINFO]]; a_connected: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_connected.is_void
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_sockfd: CE_ARRAY [INTEGER_32]
			l_aliasindex: INTEGER_32
			l_num_addr: INTEGER_32
			l_ai: CE_POINTER [PD_CURL_ADDRINFO]
			l_curr_addr: CE_POINTER [PD_CURL_ADDRINFO]
			l_after: SD_TIMEVAL
			l_before: CE_ARRAY [SD_TIMEVAL]
			l_tmp: SD_TIMEVAL
			l_timeout_ms: INTEGER_32
			l_timeout_per_addr: INTEGER_32
			l_res: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_sockfd.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_before.make (<<1>>)

			l_data := data
			l_sockfd.item := -1
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
			update_class_fields -- Current might have been changed; synchronize
			l_before.item := l_tmp.twin
			update_class_fields -- Current might have been changed; synchronize
			a_connected.item := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			l_timeout_ms := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_timeleft (l_before, (1).to_boolean)
			update_class_fields -- Current might have been changed; synchronize
			if l_timeout_ms < 0 then
				l_data.item.Curl_failf ([ce_string ("Connection time-out")])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
				l_return := True
			end
			if not l_return then
				l_num_addr := Curl_num_addresses (a_remotehost.item.addr)
				update_class_fields -- Current might have been changed; synchronize
				l_timeout_per_addr := l_timeout_ms // l_num_addr.to_integer_32
				l_ai := a_remotehost.item.addr
				if l_data.item.state.used_interface = {NATURAL_32} 2 then
					l_timeout_per_addr := 0
				end
				l_curr_addr := l_ai
				l_aliasindex := 0
				from
				until
					not (not (l_return or l_break) and then (not l_curr_addr.is_void))
				loop
					l_break := False
					l_tmp___0 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.singleipconnect (l_curr_addr, l_timeout_per_addr, l_sockfd, a_connected)
					update_class_fields -- Current might have been changed; synchronize
					l_res := l_tmp___0
					if l_res.to_boolean then
						Result := l_res
						l_return := True
					end
					if not l_return then
						if l_sockfd.item /= -1 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_after := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___1 := (create {P_TIMEVAL_STATIC}).curlx_tvdiff (l_after.twin, (l_before.item).twin)
							update_class_fields -- Current might have been changed; synchronize
							l_timeout_ms := l_timeout_ms - l_tmp___1
							if l_timeout_ms < 0 then
								l_data.item.Curl_failf ([ce_string ("connect() timed out!")])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
								l_return := True
							end
							if not l_return then
								l_before.item := l_after.twin
								update_class_fields -- Current might have been changed; synchronize
								l_curr_addr := l_curr_addr.item.ai_next
								l_aliasindex := l_aliasindex + 1
							end
						end
					end
				end
			end
			if not l_return then
				l_break := False
				a_sockconn.item := l_sockfd.item
				update_class_fields -- Current might have been changed; synchronize
				if l_sockfd.item = -1 then
					l_data.item.Curl_failf ([ce_string ("couldn%'t connect to host")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					l_return := True
				end
			end
			if not l_return then
				if (not a_addr.is_void) then
					a_addr.item := l_curr_addr
					update_class_fields -- Current might have been changed; synchronize
				end
				l_data.item.info.numconnects := (l_data.item.info.numconnects) + 1
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_input_digest (a_proxy: BOOLEAN; a_header: CE_POINTER [INTEGER_8]): NATURAL_32
		local
			l_header: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_token: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_foundAuth: BOOLEAN
			l_foundAuthInt: BOOLEAN
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_before: BOOLEAN
			l_d: CE_POINTER [PD_DIGESTDATA]
			l_tmp___0: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___1: NATURAL_32
			l_value: CE_ARRAY [INTEGER_8]
			l_content: CE_ARRAY [INTEGER_8]
			l_tmp___2: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___3: INTEGER_32
			l_tok_buf: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___16: NATURAL_32
			l_tmp___17: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_header.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_value.make (<<256>>)
			create {CE_INTEGER_8_ARRAY} l_content.make (<<1_024>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_tok_buf.make (<<1>>)

			l_header.item := a_header
			update_class_fields -- Current might have been changed; synchronize
			l_token := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_tmp := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_foundAuth := (0).to_boolean
			l_foundAuthInt := (0).to_boolean
			l_data := data
			l_before := (0).to_boolean
			if a_proxy then
				l_d := create {CE_CLASS_POINTER [PD_DIGESTDATA]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("proxydigest"))
			else
				l_d := create {CE_CLASS_POINTER [PD_DIGESTDATA]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("digest"))
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_header.item[0]).to_boolean then
					l_tmp___0 := ctype_b_loc
					update_class_fields -- Current might have been changed; synchronize
					if not (((l_tmp___0.item[((l_header.item[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_header.item := l_header.item + 1
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_break := False
			l_tmp___16 := strlen (ce_string ("Digest"))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___17 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Digest"), l_header.item, l_tmp___16)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___17.to_boolean then
				l_tmp___1 := strlen (ce_string ("Digest"))
				update_class_fields -- Current might have been changed; synchronize
				l_header.item := l_header.item + l_tmp___1.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				if (not (l_d.item.nonce).is_void) then
					l_before := (1).to_boolean
				end
				l_d.item.Curl_digest_cleanup_one
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_header.item[0]).to_boolean then
							l_tmp___2 := ctype_b_loc
							update_class_fields -- Current might have been changed; synchronize
							if not (((l_tmp___2.item[((l_header.item[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_header.item := l_header.item + 1
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_break := False
					l_tmp___14 := get_pair (l_header.item, l_value, l_content, l_header)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___14.to_boolean then
						l_break := True
					else
						l_tmp___13 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_value, ce_string ("nonce"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___13.to_boolean then
							l_d.item.nonce := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_content]))
							update_class_fields -- Current might have been changed; synchronize
							if (l_d.item.nonce).is_void then
								Result := ({PC_CURLDIGEST}.CURLDIGEST_NOMEM)
								l_return := True
							end
						else
							l_tmp___12 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_value, ce_string ("stale"))
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___12.to_boolean then
								l_tmp___3 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_content, ce_string ("true"))
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___3.to_boolean then
									l_d.item.stale := (1).to_boolean
									update_class_fields -- Current might have been changed; synchronize
									l_d.item.nc := 1
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_tmp___11 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_value, ce_string ("realm"))
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___11.to_boolean then
									l_d.item.realm := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_content]))
									update_class_fields -- Current might have been changed; synchronize
									if (l_d.item.realm).is_void then
										Result := ({PC_CURLDIGEST}.CURLDIGEST_NOMEM)
										l_return := True
									end
								else
									l_tmp___10 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_value, ce_string ("opaque"))
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___10.to_boolean then
										l_d.item.opaque := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_content]))
										update_class_fields -- Current might have been changed; synchronize
										if (l_d.item.opaque).is_void then
											Result := ({PC_CURLDIGEST}.CURLDIGEST_NOMEM)
											l_return := True
										end
									else
										l_tmp___9 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_value, ce_string ("qop"))
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___9.to_boolean then
											l_tmp := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_content]))
											update_class_fields -- Current might have been changed; synchronize
											if l_tmp.is_void then
												Result := ({PC_CURLDIGEST}.CURLDIGEST_NOMEM)
												l_return := True
											end
											if not l_return then
												l_token := strtok_r (l_tmp, ce_string (","), l_tok_buf)
												update_class_fields -- Current might have been changed; synchronize
												from
												until
													l_token.is_void
												loop
													l_tmp___5 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_token, ce_string ("auth"))
													update_class_fields -- Current might have been changed; synchronize
													if l_tmp___5.to_boolean then
														l_foundAuth := (1).to_boolean
													else
														l_tmp___4 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_token, ce_string ("auth-int"))
														update_class_fields -- Current might have been changed; synchronize
														if l_tmp___4.to_boolean then
															l_foundAuthInt := (1).to_boolean
														end
													end
													l_token := strtok_r (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string (","), l_tok_buf)
													update_class_fields -- Current might have been changed; synchronize
												end
												(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_tmp)])
												update_class_fields -- Current might have been changed; synchronize
												if l_foundAuth then
													l_d.item.qop := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([ce_string ("auth")]))
													update_class_fields -- Current might have been changed; synchronize
													if (l_d.item.qop).is_void then
														Result := ({PC_CURLDIGEST}.CURLDIGEST_NOMEM)
														l_return := True
													end
												elseif l_foundAuthInt then
													l_d.item.qop := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([ce_string ("auth-int")]))
													update_class_fields -- Current might have been changed; synchronize
													if (l_d.item.qop).is_void then
														Result := ({PC_CURLDIGEST}.CURLDIGEST_NOMEM)
														l_return := True
													end
												end
											end
										else
											l_tmp___8 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_value, ce_string ("algorithm"))
											update_class_fields -- Current might have been changed; synchronize
											if l_tmp___8.to_boolean then
												l_d.item.algorithm := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_content]))
												update_class_fields -- Current might have been changed; synchronize
												if (l_d.item.algorithm).is_void then
													Result := ({PC_CURLDIGEST}.CURLDIGEST_NOMEM)
													l_return := True
												end
												if not l_return then
													l_tmp___7 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_content, ce_string ("MD5-sess"))
													update_class_fields -- Current might have been changed; synchronize
													if l_tmp___7.to_boolean then
														l_d.item.algo := 1
														update_class_fields -- Current might have been changed; synchronize
													else
														l_tmp___6 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_content, ce_string ("MD5"))
														update_class_fields -- Current might have been changed; synchronize
														if l_tmp___6.to_boolean then
															l_d.item.algo := 0
															update_class_fields -- Current might have been changed; synchronize
														else
															Result := ({PC_CURLDIGEST}.CURLDIGEST_BADALGO)
															l_return := True
														end
													end
												end
											end
										end
									end
								end
							end
						end
					end
					if not (l_return or l_break) then
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_header.item[0]).to_boolean then
								l_tmp___15 := ctype_b_loc
								update_class_fields -- Current might have been changed; synchronize
								if not (((l_tmp___15.item[((l_header.item[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_header.item := l_header.item + 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						if 44 = (l_header.item[0]).to_integer_32 then
							l_header.item := l_header.item + 1
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				end
				if not l_return then
					l_break := False
					if l_before then
						if not l_d.item.stale then
							Result := ({PC_CURLDIGEST}.CURLDIGEST_BAD)
							l_return := True
						end
					end
				end
				if not l_return and then ((l_d.item.nonce).is_void) then
					Result := ({PC_CURLDIGEST}.CURLDIGEST_BAD)
					l_return := True
				end
			else
				Result := ({PC_CURLDIGEST}.CURLDIGEST_NONE)
				l_return := True
			end
			if not l_return then
				Result := ({PC_CURLDIGEST}.CURLDIGEST_FINE)
			end
		end

	Curl_output_digest (a_proxy: BOOLEAN; a_request, a_uripath: CE_POINTER [NATURAL_8]): NATURAL_32
		local
			l_md5buf: CE_ARRAY [NATURAL_8]
			l_request_digest: CE_ARRAY [NATURAL_8]
			l_md5this: CE_POINTER [NATURAL_8]
			l_ha1: CE_POINTER [NATURAL_8]
			l_ha2: CE_ARRAY [NATURAL_8]
			l_cnoncebuf: CE_ARRAY [INTEGER_8]
			l_cnonce: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_tmp: CE_POINTER [INTEGER_8]
			l_now: SD_TIMEVAL
			l_allocuserpwd: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_userp: CE_POINTER [INTEGER_8]
			l_passwdp: CE_POINTER [INTEGER_8]
			l_authp: CE_POINTER [PD_AUTH]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_d: CE_POINTER [PD_DIGESTDATA]
			l_tmp___0: NATURAL_32
			l_tmp___1: NATURAL_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: INTEGER_32
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: NATURAL_32
			l_tmp___14: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_md5buf.make (<<16>>)
			create {CE_NATURAL_8_ARRAY} l_request_digest.make (<<33>>)
			create {CE_NATURAL_8_ARRAY} l_ha2.make (<<33>>)
			create {CE_INTEGER_8_ARRAY} l_cnoncebuf.make (<<7>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_cnonce.make (<<1>>)

			l_tmp := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_data := data
			if a_proxy then
				l_d := create {CE_CLASS_POINTER [PD_DIGESTDATA]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("proxydigest"))
				l_allocuserpwd := create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("allocptr") + (create {PD_DYNAMICALLY_ALLOCATED_DATA}.make).offset_of ("proxyuserpwd"))
				l_userp := proxyuser
				l_passwdp := proxypasswd
				l_authp := create {CE_CLASS_POINTER [PD_AUTH]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("authproxy"))
			else
				l_d := create {CE_CLASS_POINTER [PD_DIGESTDATA]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("digest"))
				l_allocuserpwd := create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("allocptr") + (create {PD_DYNAMICALLY_ALLOCATED_DATA}.make).offset_of ("userpwd"))
				l_userp := user
				l_passwdp := passwd
				l_authp := create {CE_CLASS_POINTER [PD_AUTH]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("authhost"))
			end
			if (not (l_allocuserpwd.item).is_void) then
				(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_allocuserpwd.item))
				update_class_fields -- Current might have been changed; synchronize
				l_allocuserpwd.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_userp.is_void then
				l_userp := ce_string ("")
			end
			if l_passwdp.is_void then
				l_passwdp := ce_string ("")
			end
			if (l_d.item.nonce).is_void then
				l_authp.item.done := (0).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
				l_return := True
			end
			if not l_return then
				l_authp.item.done := (1).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				if not (l_d.item.nc).to_boolean then
					l_d.item.nc := 1
					update_class_fields -- Current might have been changed; synchronize
				end
				if (l_d.item.cnonce).is_void then
					l_now := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_cnoncebuf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (7).to_natural_32), ce_string ("%%06ld"), l_now.tv_sec]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := strlen (l_cnoncebuf)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___1 := Curl_base64_encode (l_data, l_cnoncebuf, l_tmp___0, l_cnonce)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___1.to_boolean then
						l_d.item.cnonce := l_cnonce.item
						update_class_fields -- Current might have been changed; synchronize
					else
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						l_return := True
					end
				end
			end
			if not l_return then
				l_tmp___2 := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%s:%%s:%%s"), l_userp, l_d.item.realm, l_passwdp])
				update_class_fields -- Current might have been changed; synchronize
				l_md5this := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___2)
				if l_md5this.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				Curl_md5it (l_md5buf, l_md5this)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_md5this)])
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___3 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(33).to_natural_32]))
				update_class_fields -- Current might have been changed; synchronize
				l_ha1 := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___3)
				if l_ha1.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				md5_to_ascii (l_md5buf, l_ha1)
				update_class_fields -- Current might have been changed; synchronize
				if l_d.item.algo = 1 then
					l_tmp := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%s:%%s:%%s"), l_ha1, l_d.item.nonce, l_d.item.cnonce])
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.is_void then
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						l_return := True
					end
					if not l_return then
						Curl_md5it (l_md5buf, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_tmp)])
						update_class_fields -- Current might have been changed; synchronize
						md5_to_ascii (l_md5buf, l_ha1)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				if l_authp.item.iestyle then
					l_tmp := strchr (create {CE_INTEGER_8_POINTER}.make_cast (a_uripath), ('?').code)
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp.is_void then
						l_tmp___4 := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%s:%%.*s"), a_request, l_tmp.distance ((create {CE_INTEGER_8_POINTER}.make_cast (a_uripath))), a_uripath])
						update_class_fields -- Current might have been changed; synchronize
						l_md5this := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___4)
					else
						l_tmp___5 := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%s:%%s"), a_request, a_uripath])
						update_class_fields -- Current might have been changed; synchronize
						l_md5this := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___5)
					end
				else
					l_tmp___5 := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%s:%%s"), a_request, a_uripath])
					update_class_fields -- Current might have been changed; synchronize
					l_md5this := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___5)
				end
				if l_md5this.is_void then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_ha1)])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				if (not (l_d.item.qop).is_void) then
					l_tmp___6 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_d.item.qop, ce_string ("auth-int"))
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___6.to_boolean then
						l_tmp___7 := 1
					else
						l_tmp___7 := 0
					end
				else
					l_tmp___7 := 0
				end
				Curl_md5it (l_md5buf, l_md5this)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_md5this)])
				update_class_fields -- Current might have been changed; synchronize
				md5_to_ascii (l_md5buf, l_ha2)
				update_class_fields -- Current might have been changed; synchronize
				if (not (l_d.item.qop).is_void) then
					l_tmp___8 := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%s:%%s:%%08x:%%s:%%s:%%s"), l_ha1, l_d.item.nonce, l_d.item.nc, l_d.item.cnonce, l_d.item.qop, l_ha2])
					update_class_fields -- Current might have been changed; synchronize
					l_md5this := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___8)
				else
					l_tmp___9 := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%s:%%s:%%s"), l_ha1, l_d.item.nonce, l_ha2])
					update_class_fields -- Current might have been changed; synchronize
					l_md5this := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___9)
				end
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_ha1)])
				update_class_fields -- Current might have been changed; synchronize
				if l_md5this.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				Curl_md5it (l_md5buf, l_md5this)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_md5this)])
				update_class_fields -- Current might have been changed; synchronize
				md5_to_ascii (l_md5buf, l_request_digest)
				update_class_fields -- Current might have been changed; synchronize
				if (not (l_d.item.qop).is_void) then
					if a_proxy then
						l_tmp___10 := ce_string ("Proxy-")
					else
						l_tmp___10 := ce_string ("")
					end
					l_allocuserpwd.item := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%sAuthorization: Digest username=%"%%s%", realm=%"%%s%", nonce=%"%%s%", uri=%"%%s%", cnonce=%"%%s%", nc=%%08x, qop=%"%%s%", response=%"%%s%""), l_tmp___10, l_userp, l_d.item.realm, l_d.item.nonce, a_uripath, l_d.item.cnonce, l_d.item.nc, l_d.item.qop, l_request_digest])
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___11 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_d.item.qop, ce_string ("auth"))
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___11.to_boolean then
						l_d.item.nc := (l_d.item.nc) + 1
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					if a_proxy then
						l_tmp___12 := ce_string ("Proxy-")
					else
						l_tmp___12 := ce_string ("")
					end
					l_allocuserpwd.item := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%sAuthorization: Digest username=%"%%s%", realm=%"%%s%", nonce=%"%%s%", uri=%"%%s%", response=%"%%s%""), l_tmp___12, l_userp, l_d.item.realm, l_d.item.nonce, a_uripath, l_request_digest])
					update_class_fields -- Current might have been changed; synchronize
				end
				if (l_allocuserpwd.item).is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return and then (not (l_d.item.opaque).is_void) then
				l_tmp := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%s, opaque=%"%%s%""), l_allocuserpwd.item, l_d.item.opaque])
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
				if not l_return then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_allocuserpwd.item)])
					update_class_fields -- Current might have been changed; synchronize
					l_allocuserpwd.item := l_tmp
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return and then (not (l_d.item.algorithm).is_void) then
				l_tmp := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%s, algorithm=%"%%s%""), l_allocuserpwd.item, l_d.item.algorithm])
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
				if not l_return then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_allocuserpwd.item)])
					update_class_fields -- Current might have been changed; synchronize
					l_allocuserpwd.item := l_tmp
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				l_tmp___13 := strlen (l_allocuserpwd.item)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___14 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_crealloc.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_allocuserpwd.item), l_tmp___13 + {NATURAL_32} 3]))
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___14)
				if l_tmp.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				strcat (l_tmp, ce_string ("%R%N")).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_allocuserpwd.item := l_tmp
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_strerror (a_err: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_buf: CE_POINTER [INTEGER_8]
			l_p: CE_POINTER [INTEGER_8]
			l_max: NATURAL_32
			l_old_errno: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_32]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_32]
			l_tmp___2: CE_POINTER [INTEGER_32]
		do
			l_tmp := errno_location
			update_class_fields -- Current might have been changed; synchronize
			l_old_errno := l_tmp.item
			l_buf := syserr_buf
			l_max := ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32) - {NATURAL_32} 1
			l_buf[0] := (('%/0/').code).to_integer_8
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := strerror_r (a_err, l_buf, l_max)
			update_class_fields -- Current might have been changed; synchronize
			if not l_tmp___0.is_void then
				if 0 = (l_buf[0]).to_integer_32 then
					(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_buf, l_max, ce_string ("Unknown error %%d"), a_err]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_buf[l_max.to_integer_32] := (('%/0/').code).to_integer_8
			update_class_fields -- Current might have been changed; synchronize
			l_p := strrchr (l_buf, ('%N').code)
			update_class_fields -- Current might have been changed; synchronize
			if not l_p.is_void then
				if l_p.distance (l_buf) >= 2 then
					l_p[0] := (('%/0/').code).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_p := strrchr (l_buf, ('%R').code)
			update_class_fields -- Current might have been changed; synchronize
			if not l_p.is_void then
				if l_p.distance (l_buf) >= 1 then
					l_p[0] := (('%/0/').code).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_tmp___2 := errno_location
			update_class_fields -- Current might have been changed; synchronize
			if l_old_errno /= l_tmp___2.item then
				l_tmp___1 := errno_location
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___1.item := l_old_errno
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l_buf
		end

	Curl_getaddrinfo (a_hostname: CE_POINTER [INTEGER_8]; a_port: INTEGER_32; a_waitp: CE_POINTER [INTEGER_32]): CE_POINTER [PD_CURL_ADDRINFO]
		require
			not a_waitp.is_void
		local
			l_hints: CE_ARRAY [SD_ADDRINFO]
			l_res: CE_ARRAY [CE_POINTER [PD_CURL_ADDRINFO]]
			l_error: INTEGER_32
			l_sbuf: CE_ARRAY [INTEGER_8]
			l_sbufptr: CE_POINTER [INTEGER_8]
			l_addrbuf: CE_ARRAY [INTEGER_8]
			l_pf: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_s: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_ADDRINFO]} l_hints.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_CURL_ADDRINFO]} l_res.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_sbuf.make (<<32>>)
			create {CE_INTEGER_8_ARRAY} l_addrbuf.make (<<128>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sbufptr := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_data := data
					a_waitp.item := 0
					update_class_fields -- Current might have been changed; synchronize
					inspect (l_data.item.set.ip_version).to_integer_32 -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 1
					l_pf := 2
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_pf := 10
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					l_pf := 0
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					if l_pf /= 2 then
						l_tmp := socket (10, 2, 0)
						update_class_fields -- Current might have been changed; synchronize
						l_s := l_tmp
						if l_s = -1 then
							l_pf := 2
						else
							close (l_s).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					memset (create {CE_VOID_POINTER}.make_cast (l_hints), 0, (create {SD_ADDRINFO}.make).structure_size.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_hints.item.ai_family := l_pf
					update_class_fields -- Current might have been changed; synchronize
					l_hints.item.ai_socktype := socktype
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := inet_pton (2, a_hostname, create {CE_VOID_POINTER}.make_cast (l_addrbuf))
					update_class_fields -- Current might have been changed; synchronize
					if 1 = l_tmp___0 then
						l_hints.item.ai_flags := 4
						update_class_fields -- Current might have been changed; synchronize
					else
						l_tmp___1 := inet_pton (10, a_hostname, create {CE_VOID_POINTER}.make_cast (l_addrbuf))
						update_class_fields -- Current might have been changed; synchronize
						if 1 = l_tmp___1 then
							l_hints.item.ai_flags := 4
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if a_port.to_boolean then
						(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_sbuf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (32).to_natural_32), ce_string ("%%d"), a_port]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_sbufptr := l_sbuf
					end
					l_error := (create {P_CURL_ADDRINFO_STATIC}).Curl_getaddrinfo_ex (a_hostname, l_sbufptr, l_hints, l_res)
					update_class_fields -- Current might have been changed; synchronize
					if l_error.to_boolean then
						(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("getaddrinfo(3) failed for %%s:%%d%N"), a_hostname, a_port])
						update_class_fields -- Current might have been changed; synchronize
						Result := (create {CE_CLASS_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						Result := (l_res.item)
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tftp_disconnect: NATURAL_32
		local
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
		do
			l_state___3 := proto.tftpc
			if (not l_state___3.is_void) then
				(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_state___3.item.rpacket.data))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_state___3.item.spacket.data))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_state___3)])
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	tftp_connect (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_code: NATURAL_32
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
			l_blksize: INTEGER_32
			l_rc: INTEGER_32
			l_tmp: CE_POINTER [PD_TFTP_STATE_DATA]
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: CE_POINTER [INTEGER_32]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_blksize := 512;
			((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_reset_reqproto
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_TFTP_STATE_DATA}.make).structure_size.to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := create {CE_CLASS_POINTER [PD_TFTP_STATE_DATA]}.make_cast (l_tmp___0)
			proto.tftpc := l_tmp
			update_class_fields -- Current might have been changed; synchronize
			l_state___3 := l_tmp
			if l_state___3.is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				l_return := True
			end
			if not l_return and then ((data.item.set.tftp_blksize).to_boolean) then
				l_blksize := (data.item.set.tftp_blksize).to_integer_32
				if l_blksize > 65_464 then
					Result := ({PC_CURLCODE}.CURLE_TFTP_ILLEGAL)
					l_return := True
				elseif l_blksize < 8 then
					Result := ({PC_CURLCODE}.CURLE_TFTP_ILLEGAL)
					l_return := True
				end
			end
			if not l_return and then ((l_state___3.item.rpacket.data).is_void) then
				l_tmp___1 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, ((l_blksize + 2) + 2).to_natural_32]))
				update_class_fields -- Current might have been changed; synchronize
				l_state___3.item.rpacket.data := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)
				update_class_fields -- Current might have been changed; synchronize
				if (l_state___3.item.rpacket.data).is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return and then ((l_state___3.item.spacket.data).is_void) then
				l_tmp___2 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, ((l_blksize + 2) + 2).to_natural_32]))
				update_class_fields -- Current might have been changed; synchronize
				l_state___3.item.spacket.data := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___2)
				update_class_fields -- Current might have been changed; synchronize
				if (l_state___3.item.spacket.data).is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				bits.close := (1).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				l_state___3.item.conn := (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
				l_state___3.item.sockfd := (l_state___3.item.conn).item.sock[0]
				update_class_fields -- Current might have been changed; synchronize
				l_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_START
				update_class_fields -- Current might have been changed; synchronize
				l_state___3.item.error := -100
				update_class_fields -- Current might have been changed; synchronize
				l_state___3.item.blksize := 512
				update_class_fields -- Current might have been changed; synchronize
				l_state___3.item.requested_blksize := l_blksize
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast ((create {CE_CLASS_POINTER [PD_CURL_SOCKADDR_STORAGE]}.make_shared (l_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("local_addr"))))).item.sa_family := (ip_addr.item.ai_family).to_natural_16
				update_class_fields -- Current might have been changed; synchronize
				l_state___3.item.tftp_set_timeouts.do_nothing
				update_class_fields -- Current might have been changed; synchronize
				if not bits.bound then
					l_rc := bind (l_state___3.item.sockfd, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast ((create {CE_CLASS_POINTER [PD_CURL_SOCKADDR_STORAGE]}.make_shared (l_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("local_addr")))), ip_addr.item.ai_addrlen)
					update_class_fields -- Current might have been changed; synchronize
					if l_rc.to_boolean then
						l_tmp___3 := errno_location
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___4 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_tmp___3.item)
						update_class_fields -- Current might have been changed; synchronize
						data.item.Curl_failf ([ce_string ("bind() failed; %%s"), l_tmp___4])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
						l_return := True
					end
					if not l_return then
						bits.bound := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				data.item.Curl_pgrsStartNow
				update_class_fields -- Current might have been changed; synchronize
				a_done.item := (1).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				l_code := {PC_CURLCODE}.CURLE_OK
				Result := l_code
			end
		end

	tftp_done (a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
		local
			l_code: NATURAL_32
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
		do
			l_code := {PC_CURLCODE}.CURLE_OK
			l_state___3 := proto.tftpc;
			((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pgrsDone
			update_class_fields -- Current might have been changed; synchronize
			l_code := tftp_translate_code (l_state___3.item.error)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_code
		end

	tftp_getsock (a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if not a_numsocks.to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				a_socks[0] := sock[0]
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
			end
		end

	tftp_receive_packet: NATURAL_32
		local
			l_fromaddr: CE_ARRAY [PD_CURL_SOCKADDR_STORAGE]
			l_fromlen: CE_ARRAY [NATURAL_32]
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_16
			l_tmp___1: NATURAL_16
			l_tmp___2: NATURAL_16
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_CURL_SOCKADDR_STORAGE]} l_fromaddr.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_fromlen.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data := data
					l_state___3 := proto.tftpc
					l_k := create {CE_CLASS_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
					l_fromlen.item := (create {PD_CURL_SOCKADDR_STORAGE}.make).structure_size.to_natural_32
					update_class_fields -- Current might have been changed; synchronize
					l_tmp := recvfrom (l_state___3.item.sockfd, create {CE_VOID_POINTER}.make_cast (l_state___3.item.rpacket.data), (l_state___3.item.blksize + 4).to_natural_32, 0, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_fromaddr), l_fromlen)
					update_class_fields -- Current might have been changed; synchronize
					l_state___3.item.rbytes := l_tmp
					update_class_fields -- Current might have been changed; synchronize
					if l_state___3.item.remote_addrlen = {NATURAL_32} 0 then
						memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_CURL_SOCKADDR_STORAGE]}.make_shared (l_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("remote_addr")))), create {CE_VOID_POINTER}.make_cast (l_fromaddr), l_fromlen.item).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_state___3.item.remote_addrlen := l_fromlen.item
						update_class_fields -- Current might have been changed; synchronize
					end
					if not (l_state___3.item.rbytes < 4) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_data.item.Curl_failf ([ce_string ("Received too short packet")])
						update_class_fields -- Current might have been changed; synchronize
						l_state___3.item.event := {PC_TFTP_EVENT_T}.TFTP_EVENT_TIMEOUT
						update_class_fields -- Current might have been changed; synchronize
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						l_tmp___0 := getrpacketevent ((create {CE_CLASS_POINTER [PD_TFTP_PACKET]}.make_shared (l_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("rpacket"))))
						update_class_fields -- Current might have been changed; synchronize
						l_state___3.item.event := l_tmp___0.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						inspect l_state___3.item.event -- switch 1 head
						when 3 then l_pos := -1 + 4
						when 5 then l_pos := -1 + 5
						when 4 then l_pos := -1 + 6
						when 6 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 4 then -- switch 1, case 3
						if l_state___3.item.rbytes > 4 then
							l_tmp___1 := (create {CE_CLASS_POINTER [PD_TFTP_PACKET]}.make_shared (l_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("rpacket"))).item.getrpacketblock
							update_class_fields -- Current might have been changed; synchronize
							if ((((l_state___3.item.block).to_integer_32 + 1)).bit_and (65_535)) = l_tmp___1.to_integer_32 then
								l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write (1, create {CE_INTEGER_8_POINTER}.make_cast (l_state___3.item.rpacket.data) + 4, (l_state___3.item.rbytes - 4).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_result.to_boolean then
									tftp_state_machine (l_state___3, {PC_TFTP_EVENT_T}.TFTP_EVENT_ERROR).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									Result := l_result
									l_return := True
								end
								if not l_return then
									l_k.item.bytecount := l_k.item.bytecount + (l_state___3.item.rbytes - 4).to_integer_64
									update_class_fields -- Current might have been changed; synchronize
									l_data.item.Curl_pgrsSetDownloadCounter (l_k.item.bytecount)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						l_pos := -1 + 9 -- switch 1; break
				when 5 then -- switch 1, case 5
						l_tmp___2 := (create {CE_CLASS_POINTER [PD_TFTP_PACKET]}.make_shared (l_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("rpacket"))).item.getrpacketblock
						update_class_fields -- Current might have been changed; synchronize
						l_state___3.item.error := l_tmp___2.to_integer_32
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("%%s%N"), create {CE_INTEGER_8_POINTER}.make_cast (l_state___3.item.rpacket.data) + 4])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 4
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 6
						l_result := l_state___3.item.tftp_parse_option_ack (create {CE_INTEGER_8_POINTER}.make_cast (l_state___3.item.rpacket.data) + 2, l_state___3.item.rbytes - 2)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, default:
						l_data.item.Curl_failf ([ce_string ("%%s"), ce_string ("Internal error: Unexpected packet")])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done:
						if not l_return then
							l_tmp___3 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pgrsUpdate
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___3.to_boolean then
								tftp_state_machine (l_state___3, {PC_TFTP_EVENT_T}.TFTP_EVENT_ERROR).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK)
								l_return := True
							end
						end
				when 10 then -- if done
					if not l_return then
						Result := l_result
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tftp_state_timeout (a_event: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_current: CE_ARRAY [INTEGER_32]
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_current.make (<<1>>)

			l_state___3 := proto.tftpc
			if (not a_event.is_void) then
				a_event.item := -1
				update_class_fields -- Current might have been changed; synchronize
			end
			time (l_current).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			if l_current.item > l_state___3.item.max_time then
				l_state___3.item.error := -99
				update_class_fields -- Current might have been changed; synchronize
				l_state___3.item.state := {PC_TFTP_STATE_T}.TFTP_STATE_FIN
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
				l_return := True
			elseif l_current.item > l_state___3.item.rx_time + (l_state___3.item.retry_time).to_integer_32 then
				if (not a_event.is_void) then
					a_event.item := {PC_TFTP_EVENT_T}.TFTP_EVENT_TIMEOUT
					update_class_fields -- Current might have been changed; synchronize
				end
				time (create {CE_INTEGER_32_POINTER}.make_shared (l_state___3.c_pointer + (create {PD_TFTP_STATE_DATA}.make).offset_of ("rx_time"))).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			if not l_return then
				Result := (l_state___3.item.max_time - l_current.item)
			end
		end

	tftp_easy_statemach: NATURAL_32
		local
			l_rc: INTEGER_32
			l_check_time: INTEGER_32
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
			l_fd_read: INTEGER_32
			l_timeout_ms: INTEGER_32
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_transaction_start: SD_TIMEVAL
			l_tmp: SD_TIMEVAL
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_error: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_32]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_rtms: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			l_check_time := 0
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			l_state___3 := proto.tftpc
			l_k := create {CE_CLASS_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
			l_tmp := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
			update_class_fields -- Current might have been changed; synchronize
			l_transaction_start := l_tmp.twin
			l_k.item.start := l_transaction_start.twin
			update_class_fields -- Current might have been changed; synchronize
			l_k.item.now := l_transaction_start.twin
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_continue := False
				if l_state___3.item.state /= {NATURAL_32} 3 then
					if l_result /= {NATURAL_32} 0 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_return or l_break or l_continue) then
					l_timeout_ms := (l_state___3.item.retry_time * 1_000).to_integer_32
					if l_data.item.set.upload then
						if (l_data.item.set.max_send_speed).to_boolean then
							if l_data.item.progress.ulspeed > l_data.item.set.max_send_speed then
								l_fd_read := -1
								l_timeout_ms := (create {P_TRANSFER_STATIC}).Curl_sleep_time (l_data.item.set.max_send_speed, l_data.item.progress.ulspeed, l_state___3.item.blksize)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_fd_read := l_state___3.item.sockfd
							end
						else
							l_fd_read := l_state___3.item.sockfd
						end
					elseif (l_data.item.set.max_recv_speed).to_boolean then
						if l_data.item.progress.dlspeed > l_data.item.set.max_recv_speed then
							l_fd_read := -1
							l_timeout_ms := (create {P_TRANSFER_STATIC}).Curl_sleep_time (l_data.item.set.max_recv_speed, l_data.item.progress.dlspeed, l_state___3.item.blksize)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_fd_read := l_state___3.item.sockfd
						end
					else
						l_fd_read := l_state___3.item.sockfd
					end
					if (l_data.item.set.timeout).to_boolean then
						l_tmp___0 := (create {P_TIMEVAL_STATIC}).curlx_tvdiff ((l_k.item.now).twin, (l_k.item.start).twin)
						update_class_fields -- Current might have been changed; synchronize
						l_timeout_ms := l_data.item.set.timeout - l_tmp___0
						if l_timeout_ms > (l_state___3.item.retry_time * 1_000).to_integer_32 then
							l_timeout_ms := (l_state___3.item.retry_time * 1_000).to_integer_32
						elseif l_timeout_ms < 0 then
							l_timeout_ms := 0
						end
					end
					l_rc := (create {P_SELECT_STATIC}).Curl_socket_ready (l_fd_read, -1, l_timeout_ms.to_integer_32)
					update_class_fields -- Current might have been changed; synchronize
					l_k.item.now := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := (create {P_TIMEVAL_STATIC}).curlx_tvdiff ((l_k.item.now).twin, (l_k.item.start).twin)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___2 >= l_data.item.set.timeout then
						l_tmp___1 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pgrsUpdate
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1.to_boolean then
							tftp_state_machine (l_state___3, {PC_TFTP_EVENT_T}.TFTP_EVENT_ERROR).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK)
							l_return := True
						end
						if not l_return then
							l_k.item.start := (l_k.item.now).twin
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if not l_return then
						if l_rc = -1 then
							l_tmp___3 := errno_location
							update_class_fields -- Current might have been changed; synchronize
							l_error := l_tmp___3.item
							l_tmp___4 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_error)
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.Curl_failf ([ce_string ("%%s"), l_tmp___4])
							update_class_fields -- Current might have been changed; synchronize
							l_state___3.item.event := {PC_TFTP_EVENT_T}.TFTP_EVENT_ERROR
							update_class_fields -- Current might have been changed; synchronize
						elseif l_rc = 0 then
							l_rtms := (l_state___3.item.retry_time * 1_000).to_integer_32
							l_tmp___5 := (create {P_TIMEVAL_STATIC}).curlx_tvdiff ((l_k.item.now).twin, l_transaction_start.twin)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___5 > l_rtms then
								l_state___3.item.event := {PC_TFTP_EVENT_T}.TFTP_EVENT_TIMEOUT
								update_class_fields -- Current might have been changed; synchronize
								l_check_time := 1
							else
								l_continue := True
							end
						else
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.tftp_receive_packet
							update_class_fields -- Current might have been changed; synchronize
							if l_result = {NATURAL_32} 0 then
								l_transaction_start := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
								update_class_fields -- Current might have been changed; synchronize
							end
							if (not (l_k.item.bytecountp).is_void) then
								(l_k.item.bytecountp).item := l_k.item.bytecount
								update_class_fields -- Current might have been changed; synchronize
							end
							if (not (l_k.item.writebytecountp).is_void) then
								(l_k.item.writebytecountp).item := l_k.item.writebytecount
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if not (l_return or l_break or l_continue) then
							if l_check_time.to_boolean then
								((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.tftp_state_timeout (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_check_time := 0
							end
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
							if not l_return then
								l_result := tftp_state_machine (l_state___3, l_state___3.item.event)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
				end
				if (not l_return and not l_break) then
					
				end
			end
			if not l_return then
				l_break := False
				l_continue := False;
				((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (-1, (-1).to_integer_64, (0).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer), -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				Result := l_result
			end
		end

	tftp_multi_statemach (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_rc: INTEGER_32
			l_event: CE_ARRAY [INTEGER_32]
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
			l_timeout_ms: INTEGER_32
			l_tmp: INTEGER_32
			l_error: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_32]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_event.make (<<1>>)

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			l_state___3 := proto.tftpc
			l_tmp := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.tftp_state_timeout (l_event)
			update_class_fields -- Current might have been changed; synchronize
			l_timeout_ms := l_tmp
			a_done.item := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			if l_timeout_ms <= 0 then
				l_data.item.Curl_failf ([ce_string ("TFTP response timeout")])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
				l_return := True
			elseif l_event.item /= -1 then
				l_result := tftp_state_machine (l_state___3, l_event.item)
				update_class_fields -- Current might have been changed; synchronize
				if l_result /= {NATURAL_32} 0 then
					Result := l_result
					l_return := True
				end
				if not l_return then
					a_done.item := (l_state___3.item.state = {NATURAL_32} 3)
					update_class_fields -- Current might have been changed; synchronize
					if a_done.item then
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (-1, (-1).to_integer_64, (0).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer), -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			else
				l_rc := (create {P_SELECT_STATIC}).Curl_socket_ready (l_state___3.item.sockfd, -1, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_rc = -1 then
					l_tmp___0 := errno_location
					update_class_fields -- Current might have been changed; synchronize
					l_error := l_tmp___0.item
					l_tmp___1 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_strerror (l_error)
					update_class_fields -- Current might have been changed; synchronize
					l_data.item.Curl_failf ([ce_string ("%%s"), l_tmp___1])
					update_class_fields -- Current might have been changed; synchronize
					l_state___3.item.event := {PC_TFTP_EVENT_T}.TFTP_EVENT_ERROR
					update_class_fields -- Current might have been changed; synchronize
				elseif l_rc /= 0 then
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.tftp_receive_packet
					update_class_fields -- Current might have been changed; synchronize
					if l_result /= {NATURAL_32} 0 then
						Result := l_result
						l_return := True
					end
					if not l_return then
						l_result := tftp_state_machine (l_state___3, l_state___3.item.event)
						update_class_fields -- Current might have been changed; synchronize
						if l_result /= {NATURAL_32} 0 then
							Result := l_result
							l_return := True
						end
					end
					if not l_return then
						a_done.item := (l_state___3.item.state = {NATURAL_32} 3)
						update_class_fields -- Current might have been changed; synchronize
						if a_done.item then
							((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (-1, (-1).to_integer_64, (0).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer), -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				end
			end
			if not l_return then
				Result := l_result
			end
		end

	tftp_doing (a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_dophase_done.is_void
		local
			l_result: NATURAL_32
		do
			l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.tftp_multi_statemach (a_dophase_done)
			update_class_fields -- Current might have been changed; synchronize
			if a_dophase_done.item then
			end
			Result := l_result
		end

	tftp_perform (a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_dophase_done.is_void
		local
			l_result: NATURAL_32
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_state___3 := proto.tftpc
			a_dophase_done.item := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			l_result := tftp_state_machine (l_state___3, {PC_TFTP_EVENT_T}.TFTP_EVENT_INIT)
			update_class_fields -- Current might have been changed; synchronize
			if l_state___3.item.state = {NATURAL_32} 3 then
				Result := l_result
				l_return := True
			elseif l_result /= {NATURAL_32} 0 then
				Result := l_result
				l_return := True
			end
			if not l_return then
				if data.item.state.used_interface = {NATURAL_32} 2 then
					((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.tftp_multi_statemach (a_dophase_done).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				else
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.tftp_easy_statemach
					update_class_fields -- Current might have been changed; synchronize
					a_dophase_done.item := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
				end
				if a_dophase_done.item then
				end
				Result := l_result
			end
		end

	tftp_do (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_state___3: CE_POINTER [PD_TFTP_STATE_DATA]
			l_code: NATURAL_32
			l_return: BOOLEAN
		do
			a_done.item := (0).to_boolean
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_reset_reqproto
			update_class_fields -- Current might have been changed; synchronize
			if (proto.tftpc).is_void then
				l_code := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.tftp_connect (a_done)
				update_class_fields -- Current might have been changed; synchronize
				if l_code.to_boolean then
					Result := l_code
					l_return := True
				end
			end
			if not l_return then
				l_state___3 := proto.tftpc
				l_code := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.tftp_perform (a_done)
				update_class_fields -- Current might have been changed; synchronize
				if l_code = {NATURAL_32} 0 then
					l_code := tftp_translate_code (l_state___3.item.error)
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_code
			end
		end

	tftp_setup_connection: NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_type: CE_POINTER [INTEGER_8]
			l_command: INTEGER_8
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					Current.socktype := 2
					update_class_fields -- Current might have been changed; synchronize
					l_type := strstr (l_data.item.state.path, ce_string (";mode="))
					update_class_fields -- Current might have been changed; synchronize
					if l_type.is_void then
						l_type := strstr (host.rawalloc, ce_string (";mode="))
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_type.is_void then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						l_type[0] := (0).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_command := (create {P_RAWSTR_STATIC}).Curl_raw_toupper (l_type[6])
						update_class_fields -- Current might have been changed; synchronize
						inspect l_command.to_integer_32 -- switch 1 head
						when 65 then l_pos := -1 + 2
						when 78 then l_pos := -1 + 2
						else l_pos := -1 + 3
						end
				when 2 then -- switch 1, case 65 | switch 1, case 78
						l_data.item.set.prefer_ascii := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
						l_data.item.set.prefer_ascii := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done: | if done
					Result := ({PC_CURLCODE}.CURLE_OK)
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_blockread_all (a_sockfd: INTEGER_32; a_buf: CE_POINTER [INTEGER_8]; a_buffersize: INTEGER_32; a_n: CE_POINTER [INTEGER_32]; a_conn_timeout: INTEGER_32): INTEGER_32
		require
			not a_n.is_void
		local
			l_buf: CE_POINTER [INTEGER_8]
			l_buffersize: INTEGER_32
			l_nread: CE_ARRAY [INTEGER_32]
			l_allread: INTEGER_32
			l_result: INTEGER_32
			l_tvnow: SD_TIMEVAL
			l_conntime: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l_break, l_continue: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_nread.make (<<1>>)

			l_buf := a_buf
			l_buffersize := a_buffersize
			l_allread := 0
			a_n.item := 0
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				(l_break)
			loop
				l_break := False
				l_continue := False
				l_tvnow := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
				update_class_fields -- Current might have been changed; synchronize
				l_conntime := (create {P_TIMEVAL_STATIC}).curlx_tvdiff (l_tvnow.twin, created.twin)
				update_class_fields -- Current might have been changed; synchronize
				if l_conntime > a_conn_timeout then
					l_result := 28
					l_break := True
				end
				if not (l_break or l_continue) then
					l_tmp := (create {P_SELECT_STATIC}).Curl_socket_ready (a_sockfd, -1, (a_conn_timeout - l_conntime).to_integer_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp <= 0 then
						l_result := (0).bit_not
						l_break := True
					end
				end
				if not (l_break or l_continue) then
					l_tmp___0 := Curl_read_plain (a_sockfd, l_buf, l_buffersize.to_natural_32, l_nread)
					update_class_fields -- Current might have been changed; synchronize
					l_result := l_tmp___0.to_integer_32
					if 81 = l_result then
						l_continue := True
					elseif l_result.to_boolean then
						l_break := True
					end
				end
				if not (l_break or l_continue) and then (l_buffersize = l_nread.item) then
					l_allread := l_allread + (l_nread.item)
					a_n.item := l_allread
					update_class_fields -- Current might have been changed; synchronize
					l_result := 0
					l_break := True
				end
				if not (l_break or l_continue) and then (not (l_nread.item).to_boolean) then
					l_result := (0).bit_not
					l_break := True
				end
				if not (l_break or l_continue) then
					l_buffersize := l_buffersize - (l_nread.item)
					l_buf := l_buf + (l_nread.item)
					l_allread := l_allread + (l_nread.item)
				end
				if (not l_break) then
					
				end
			end
			l_break := False
			l_continue := False
			Result := l_result
		end

	Curl_SOCKS4 (a_proxy_name, a_hostname: CE_POINTER [INTEGER_8]; a_remote_port, a_sockindex: INTEGER_32; a_protocol4a: BOOLEAN): NATURAL_32
		local
			l_socksreq: CE_ARRAY [NATURAL_8]
			l_result: INTEGER_32
			l_code: NATURAL_32
			l_sock: INTEGER_32
			l_timeout: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_dns: CE_ARRAY [CE_POINTER [PD_CURL_DNS_ENTRY]]
			l_hp: CE_POINTER [PD_CURL_ADDRINFO]
			l_rc: INTEGER_32
			l_buf: CE_ARRAY [INTEGER_8]
			l_ip: CE_ARRAY [NATURAL_16]
			l_tmp: INTEGER_32
			l_actualread: CE_ARRAY [INTEGER_32]
			l_written: CE_ARRAY [INTEGER_32]
			l_hostnamelen: INTEGER_32
			l_packetsize: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___3: NATURAL_16
			l_tmp___4: NATURAL_16
			l_tmp___5: NATURAL_16
			l_tmp___6: NATURAL_16
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_socksreq.make (<<262>>)
			create {CE_POINTER_ARRAY [PD_CURL_DNS_ENTRY]} l_dns.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_buf.make (<<64>>)
			create {CE_NATURAL_16_ARRAY} l_ip.make (<<4>>)
			create {CE_INTEGER_32_ARRAY} l_actualread.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_written.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sock := sock[a_sockindex]
					l_data := data
					l_timeout := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_timeleft (create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer), (1).to_boolean)
					update_class_fields -- Current might have been changed; synchronize
					if l_timeout < 0 then
						l_data.item.Curl_failf ([ce_string ("Connection time-out")])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
						l_return := True
					end
					if not l_return then
						curlx_nonblock (l_sock, 0).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_socksreq[0] := (4).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_socksreq[1] := (1).to_natural_8
						update_class_fields; -- Current might have been changed; synchronize
						(create {CE_NATURAL_16_POINTER}.make_cast ((l_socksreq + 2))).item := htons (a_remote_port.to_natural_16)
						update_class_fields -- Current might have been changed; synchronize
						if not a_protocol4a then
							l_hp := create {CE_CLASS_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
							l_rc := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_resolv (a_hostname, a_remote_port, l_dns)
							update_class_fields -- Current might have been changed; synchronize
							if l_rc = -1 then
								Result := ({PC_CURLCODE}.CURLE_COULDNT_RESOLVE_PROXY)
								l_return := True
							end
							if not l_return then
								if l_rc = 1 then
									(create {P_HOSTSYN_STATIC}).Curl_wait_for_resolv ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_dns).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
								if (not (l_dns.item).is_void) then
									l_hp := l_dns.item.item.addr
								end
								if (not l_hp.is_void) then
									Curl_printable_address (l_hp, l_buf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (64).to_natural_32)).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									l_tmp := sscanf ([l_buf, ce_string ("%%hu.%%hu.%%hu.%%hu"), l_ip + 0, l_ip + 1, l_ip + 2, l_ip + 3])
									update_class_fields -- Current might have been changed; synchronize
									if 4 = l_tmp then
										l_socksreq[4] := (l_ip[0]).to_natural_8
										update_class_fields -- Current might have been changed; synchronize
										l_socksreq[5] := (l_ip[1]).to_natural_8
										update_class_fields -- Current might have been changed; synchronize
										l_socksreq[6] := (l_ip[2]).to_natural_8
										update_class_fields -- Current might have been changed; synchronize
										l_socksreq[7] := (l_ip[3]).to_natural_8
										update_class_fields -- Current might have been changed; synchronize
									else
										l_hp := create {CE_CLASS_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
									end
									l_data.item.Curl_resolv_unlock (l_dns.item)
									update_class_fields -- Current might have been changed; synchronize
								end
								if l_hp.is_void then
									l_data.item.Curl_failf ([ce_string ("Failed to resolve %"%%s%" for SOCKS4 connect."), a_hostname])
									update_class_fields -- Current might have been changed; synchronize
									Result := ({PC_CURLCODE}.CURLE_COULDNT_RESOLVE_HOST)
									l_return := True
								end
							end
						end
					end
					if not l_return then
						l_socksreq[8] := (0).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						if (not a_proxy_name.is_void) then
							Curl_strlcat (create {CE_INTEGER_8_POINTER}.make_cast (l_socksreq) + 8, a_proxy_name, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (262).to_natural_32) - {NATURAL_32} 8).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						l_hostnamelen := 0
						l_tmp___0 := strlen ((create {CE_INTEGER_8_POINTER}.make_cast (l_socksreq) + 8))
						update_class_fields -- Current might have been changed; synchronize
						l_packetsize := 9 + l_tmp___0.to_integer_32
						if a_protocol4a then
							l_socksreq[4] := (0).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
							l_socksreq[5] := (0).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
							l_socksreq[6] := (0).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
							l_socksreq[7] := (1).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___1 := strlen (a_hostname)
							update_class_fields -- Current might have been changed; synchronize
							l_hostnamelen := l_tmp___1.to_integer_32 + 1
							if l_packetsize + l_hostnamelen <= 262 then
								strcpy ((create {CE_INTEGER_8_POINTER}.make_cast (l_socksreq) + l_packetsize), a_hostname).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							else
								l_hostnamelen := 0
							end
						end
						l_code := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_write_plain (l_sock, create {CE_VOID_POINTER}.make_cast (l_socksreq), (l_packetsize + l_hostnamelen).to_natural_32, l_written)
						update_class_fields -- Current might have been changed; synchronize
						if l_code /= {NATURAL_32} 0 then
							l_data.item.Curl_failf ([ce_string ("Failed to send SOCKS4 connect request.")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							l_return := True
						elseif l_written.item /= l_packetsize + l_hostnamelen then
							l_data.item.Curl_failf ([ce_string ("Failed to send SOCKS4 connect request.")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							l_return := True
						end
					end
					if not l_return and then a_protocol4a then
						if l_hostnamelen = 0 then
							l_tmp___2 := strlen (a_hostname)
							update_class_fields -- Current might have been changed; synchronize
							l_hostnamelen := l_tmp___2.to_integer_32 + 1
							l_code := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_write_plain (l_sock, create {CE_VOID_POINTER}.make_cast (a_hostname), l_hostnamelen.to_natural_32, l_written)
							update_class_fields -- Current might have been changed; synchronize
							if l_code /= {NATURAL_32} 0 then
								l_data.item.Curl_failf ([ce_string ("Failed to send SOCKS4 connect request.")])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
								l_return := True
							elseif l_written.item /= l_hostnamelen then
								l_data.item.Curl_failf ([ce_string ("Failed to send SOCKS4 connect request.")])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
								l_return := True
							end
						end
					end
					if not l_return then
						l_packetsize := 8
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_blockread_all (l_sock, create {CE_INTEGER_8_POINTER}.make_cast (l_socksreq), l_packetsize, l_actualread, l_timeout)
						update_class_fields -- Current might have been changed; synchronize
						if l_result /= 0 then
							l_data.item.Curl_failf ([ce_string ("Failed to receive SOCKS4 connect request ack.")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							l_return := True
						elseif l_actualread.item /= l_packetsize then
							l_data.item.Curl_failf ([ce_string ("Failed to receive SOCKS4 connect request ack.")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							l_return := True
						end
					end
					if not l_return and then ((l_socksreq[0]).to_integer_32 /= 0) then
						l_data.item.Curl_failf ([ce_string ("SOCKS4 reply has wrong version, version should be 4.")])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						inspect (l_socksreq[1]).to_integer_32 -- switch 1 head
						when 90 then l_pos := -1 + 2
						when 91 then l_pos := -1 + 3
						when 92 then l_pos := -1 + 4
						when 93 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 2 then -- switch 1, case 90
						if a_protocol4a then
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("SOCKS4a request granted.%N")])
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("SOCKS4 request granted.%N")])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 7 -- switch 1; break
				when 3 then -- switch 1, case 91
						l_tmp___3 := ntohs ((create {CE_NATURAL_16_POINTER}.make_cast ((l_socksreq + 8))).item)
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.Curl_failf ([ce_string ("Can%'t complete SOCKS4 connection to %%d.%%d.%%d.%%d:%%d. (%%d), request rejected or failed."), (l_socksreq[4]).to_integer_32, (l_socksreq[5]).to_integer_32, (l_socksreq[6]).to_integer_32, (l_socksreq[7]).to_integer_32, l_tmp___3.to_natural_32, (l_socksreq[1]).to_integer_32])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
						l_return := True
				when 4 then -- switch 1, case 92
						if not l_return then
							l_tmp___4 := ntohs ((create {CE_NATURAL_16_POINTER}.make_cast ((l_socksreq + 8))).item)
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.Curl_failf ([ce_string ("Can%'t complete SOCKS4 connection to %%d.%%d.%%d.%%d:%%d. (%%d), request rejected because SOCKS server cannot connect to identd on the client."), (l_socksreq[4]).to_integer_32, (l_socksreq[5]).to_integer_32, (l_socksreq[6]).to_integer_32, (l_socksreq[7]).to_integer_32, l_tmp___4.to_natural_32, (l_socksreq[1]).to_integer_32])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							l_return := True
						end
				when 5 then -- switch 1, case 93
						if not l_return then
							l_tmp___5 := ntohs ((create {CE_NATURAL_16_POINTER}.make_cast ((l_socksreq + 8))).item)
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.Curl_failf ([ce_string ("Can%'t complete SOCKS4 connection to %%d.%%d.%%d.%%d:%%d. (%%d), request rejected because the client program and identd report different user-ids."), (l_socksreq[4]).to_integer_32, (l_socksreq[5]).to_integer_32, (l_socksreq[6]).to_integer_32, (l_socksreq[7]).to_integer_32, l_tmp___5.to_natural_32, (l_socksreq[1]).to_integer_32])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							l_return := True
						end
				when 6 then -- switch 1, default:
						if not l_return then
							l_tmp___6 := ntohs ((create {CE_NATURAL_16_POINTER}.make_cast ((l_socksreq + 8))).item)
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.Curl_failf ([ce_string ("Can%'t complete SOCKS4 connection to %%d.%%d.%%d.%%d:%%d. (%%d), Unknown."), (l_socksreq[4]).to_integer_32, (l_socksreq[5]).to_integer_32, (l_socksreq[6]).to_integer_32, (l_socksreq[7]).to_integer_32, l_tmp___6.to_natural_32, (l_socksreq[1]).to_integer_32])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							l_return := True
						end
				when 7 then -- switch 1, done: | if done
					if not l_return then
						curlx_nonblock (l_sock, 1).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_SOCKS5 (a_proxy_name, a_proxy_password, a_hostname: CE_POINTER [INTEGER_8]; a_remote_port, a_sockindex: INTEGER_32): NATURAL_32
		require
			not a_hostname.is_void
		local
			l_socksreq: CE_ARRAY [NATURAL_8]
			l_actualread: CE_ARRAY [INTEGER_32]
			l_written: CE_ARRAY [INTEGER_32]
			l_result: INTEGER_32
			l_code: NATURAL_32
			l_sock: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_timeout: INTEGER_32
			l_socks5_resolve_local: BOOLEAN
			l_hostname_len: NATURAL_32
			l_tmp: NATURAL_32
			l_packetsize: INTEGER_32
			l_tmp___0: INTEGER_32
			l_userlen: NATURAL_32
			l_pwlen: NATURAL_32
			l_len: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_dns: CE_ARRAY [CE_POINTER [PD_CURL_DNS_ENTRY]]
			l_hp: CE_POINTER [PD_CURL_ADDRINFO]
			l_rc: INTEGER_32
			l_tmp___4: INTEGER_32
			l_buf: CE_ARRAY [INTEGER_8]
			l_ip: CE_ARRAY [NATURAL_16]
			l_tmp___5: INTEGER_32
			l_tmp___6: NATURAL_16
			l_addrlen: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_socksreq.make (<<600>>)
			create {CE_INTEGER_32_ARRAY} l_actualread.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_written.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_CURL_DNS_ENTRY]} l_dns.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_buf.make (<<64>>)
			create {CE_NATURAL_16_ARRAY} l_ip.make (<<4>>)

			l_sock := sock[a_sockindex]
			l_data := data
			l_socks5_resolve_local := (l_data.item.set.proxytype = {NATURAL_32} 5)
			l_tmp := strlen (a_hostname)
			update_class_fields -- Current might have been changed; synchronize
			l_hostname_len := l_tmp
			l_packetsize := 0
			if not l_socks5_resolve_local then
				if l_hostname_len > {NATURAL_32} 255 then
					(create {P_SENDF_STATIC}).Curl_infof ([data, ce_string ("SOCKS5: server resolving disabled for hostnames of length > 255 [actual len=%%zu]%N"), l_hostname_len])
					update_class_fields -- Current might have been changed; synchronize
					l_socks5_resolve_local := (1).to_boolean
				end
			end
			l_timeout := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_timeleft (create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer), (1).to_boolean)
			update_class_fields -- Current might have been changed; synchronize
			if l_timeout < 0 then
				l_data.item.Curl_failf ([ce_string ("Connection time-out")])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
				l_return := True
			end
			if not l_return then
				curlx_nonblock (l_sock, 1).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_result := (create {P_SELECT_STATIC}).Curl_socket_ready (-1, l_sock, l_timeout.to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				if -1 = l_result then
					data.item.Curl_failf ([ce_string ("SOCKS5: no connection here")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					l_return := True
				elseif 0 = l_result then
					data.item.Curl_failf ([ce_string ("SOCKS5: connection timeout")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
					l_return := True
				end
			end
			if not l_return and then (((l_result).bit_and (4)).to_boolean) then
				data.item.Curl_failf ([ce_string ("SOCKS5: error occured during connection")])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
				l_return := True
			end
			if not l_return then
				l_socksreq[0] := (5).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				if (not a_proxy_name.is_void) then
					l_tmp___0 := 2
				else
					l_tmp___0 := 1
				end
				l_socksreq[1] := (l_tmp___0.to_integer_8).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				l_socksreq[2] := (0).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				l_socksreq[3] := (2).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				curlx_nonblock (l_sock, 0).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_code := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_write_plain (l_sock, create {CE_VOID_POINTER}.make_cast (l_socksreq), (2 + (l_socksreq[1]).to_integer_32).to_natural_32, l_written)
				update_class_fields -- Current might have been changed; synchronize
				if l_code /= {NATURAL_32} 0 then
					l_data.item.Curl_failf ([ce_string ("Unable to send initial SOCKS5 request.")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					l_return := True
				elseif l_written.item /= 2 + (l_socksreq[1]).to_integer_32 then
					l_data.item.Curl_failf ([ce_string ("Unable to send initial SOCKS5 request.")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					l_return := True
				end
			end
			if not l_return then
				curlx_nonblock (l_sock, 1).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_result := (create {P_SELECT_STATIC}).Curl_socket_ready (l_sock, -1, l_timeout.to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				if -1 = l_result then
					data.item.Curl_failf ([ce_string ("SOCKS5 nothing to read")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					l_return := True
				elseif 0 = l_result then
					data.item.Curl_failf ([ce_string ("SOCKS5 read timeout")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
					l_return := True
				end
			end
			if not l_return and then (((l_result).bit_and (4)).to_boolean) then
				data.item.Curl_failf ([ce_string ("SOCKS5 read error occured")])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
				l_return := True
			end
			if not l_return then
				curlx_nonblock (l_sock, 0).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_blockread_all (l_sock, create {CE_INTEGER_8_POINTER}.make_cast (l_socksreq), 2, l_actualread, l_timeout)
				update_class_fields -- Current might have been changed; synchronize
				if l_result /= 0 then
					l_data.item.Curl_failf ([ce_string ("Unable to receive initial SOCKS5 response.")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					l_return := True
				elseif l_actualread.item /= 2 then
					l_data.item.Curl_failf ([ce_string ("Unable to receive initial SOCKS5 response.")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					l_return := True
				end
			end
			if not l_return and then ((l_socksreq[0]).to_integer_32 /= 5) then
				l_data.item.Curl_failf ([ce_string ("Received invalid version in initial SOCKS5 response.")])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
				l_return := True
			end
			if not l_return and then ((l_socksreq[1]).to_integer_32 /= 0) then
				if (l_socksreq[1]).to_integer_32 = 2 then
					if (not a_proxy_name.is_void) then
						if (not a_proxy_password.is_void) then
							l_userlen := strlen (a_proxy_name)
							update_class_fields -- Current might have been changed; synchronize
							l_pwlen := strlen (a_proxy_password)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_userlen := (0).to_natural_32
							l_pwlen := (0).to_natural_32
						end
					else
						l_userlen := (0).to_natural_32
						l_pwlen := (0).to_natural_32
					end
					l_len := 0
					l_tmp___1 := l_len
					l_len := l_len + 1
					l_socksreq[l_tmp___1] := (1).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := l_len
					l_len := l_len + 1
					l_socksreq[l_tmp___2] := l_userlen.to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					if (not a_proxy_name.is_void) then
						if l_userlen.to_boolean then
							memcpy (create {CE_VOID_POINTER}.make_cast ((l_socksreq + l_len)), create {CE_VOID_POINTER}.make_cast (a_proxy_name), l_userlen).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_len := l_len + l_userlen.to_integer_32
					l_tmp___3 := l_len
					l_len := l_len + 1
					l_socksreq[l_tmp___3] := l_pwlen.to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					if (not a_proxy_password.is_void) then
						if l_pwlen.to_boolean then
							memcpy (create {CE_VOID_POINTER}.make_cast ((l_socksreq + l_len)), create {CE_VOID_POINTER}.make_cast (a_proxy_password), l_pwlen).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_len := l_len + l_pwlen.to_integer_32
					l_code := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_write_plain (l_sock, create {CE_VOID_POINTER}.make_cast (l_socksreq), l_len.to_natural_32, l_written)
					update_class_fields -- Current might have been changed; synchronize
					if l_code /= {NATURAL_32} 0 then
						l_data.item.Curl_failf ([ce_string ("Failed to send SOCKS5 sub-negotiation request.")])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
						l_return := True
					elseif l_len /= l_written.item then
						l_data.item.Curl_failf ([ce_string ("Failed to send SOCKS5 sub-negotiation request.")])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
						l_return := True
					end
					if not l_return then
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_blockread_all (l_sock, create {CE_INTEGER_8_POINTER}.make_cast (l_socksreq), 2, l_actualread, l_timeout)
						update_class_fields -- Current might have been changed; synchronize
						if l_result /= 0 then
							l_data.item.Curl_failf ([ce_string ("Unable to receive SOCKS5 sub-negotiation response.")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							l_return := True
						elseif l_actualread.item /= 2 then
							l_data.item.Curl_failf ([ce_string ("Unable to receive SOCKS5 sub-negotiation response.")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
							l_return := True
						end
					end
					if not l_return and then ((l_socksreq[1]).to_integer_32 /= 0) then
						l_data.item.Curl_failf ([ce_string ("User was rejected by the SOCKS5 server (%%d %%d)."), (l_socksreq[0]).to_integer_32, (l_socksreq[1]).to_integer_32])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
						l_return := True
					end
				elseif (l_socksreq[1]).to_integer_32 = 1 then
					l_data.item.Curl_failf ([ce_string ("SOCKS5 GSSAPI per-message authentication is not supported.")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					l_return := True
				elseif (l_socksreq[1]).to_integer_32 = 255 then
					if a_proxy_name.is_void then
						l_data.item.Curl_failf ([ce_string ("No authentication method was acceptable. (It is quite likely that the SOCKS5 server wanted a username/password, since none was supplied to the server on this connection.)")])
						update_class_fields -- Current might have been changed; synchronize
					elseif not (a_proxy_name[0]).to_boolean then
						l_data.item.Curl_failf ([ce_string ("No authentication method was acceptable. (It is quite likely that the SOCKS5 server wanted a username/password, since none was supplied to the server on this connection.)")])
						update_class_fields -- Current might have been changed; synchronize
					else
						l_data.item.Curl_failf ([ce_string ("No authentication method was acceptable.")])
						update_class_fields -- Current might have been changed; synchronize
					end
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					l_return := True
				else
					l_data.item.Curl_failf ([ce_string ("Undocumented SOCKS5 mode attempted to be used by server.")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					l_return := True
				end
			end
			if not l_return then
				l_socksreq[0] := (5).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				l_socksreq[1] := (1).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				l_socksreq[2] := (0).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				if not l_socks5_resolve_local then
					l_packetsize := (({NATURAL_32} 5 + l_hostname_len) + {NATURAL_32} 2).to_integer_32
					l_socksreq[3] := (3).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					l_socksreq[4] := (l_hostname_len.to_integer_8).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					memcpy (create {CE_VOID_POINTER}.make_cast ((l_socksreq + 5)), create {CE_VOID_POINTER}.make_cast (a_hostname), l_hostname_len).do_nothing
					update_class_fields; -- Current might have been changed; synchronize
					(create {CE_NATURAL_16_POINTER}.make_cast ((l_socksreq + (l_hostname_len + {NATURAL_32} 5).to_integer_32))).item := htons (a_remote_port.to_natural_16)
					update_class_fields -- Current might have been changed; synchronize
				else
					l_hp := create {CE_CLASS_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
					l_tmp___4 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_resolv (a_hostname, a_remote_port, l_dns)
					update_class_fields -- Current might have been changed; synchronize
					l_rc := l_tmp___4
					l_packetsize := 10
					l_socksreq[3] := (1).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					if l_rc = -1 then
						Result := ({PC_CURLCODE}.CURLE_COULDNT_RESOLVE_HOST)
						l_return := True
					end
					if not l_return and then (l_rc = 1) then
						l_code := (create {P_HOSTSYN_STATIC}).Curl_wait_for_resolv ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_dns)
						update_class_fields -- Current might have been changed; synchronize
						if l_code /= {NATURAL_32} 0 then
							Result := l_code
							l_return := True
						end
					end
					if not l_return then
						if (not (l_dns.item).is_void) then
							l_hp := l_dns.item.item.addr
						end
						if (not l_hp.is_void) then
							Curl_printable_address (l_hp, l_buf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (64).to_natural_32)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___5 := sscanf ([l_buf, ce_string ("%%hu.%%hu.%%hu.%%hu"), l_ip + 0, l_ip + 1, l_ip + 2, l_ip + 3])
							update_class_fields -- Current might have been changed; synchronize
							if 4 = l_tmp___5 then
								l_socksreq[4] := (l_ip[0]).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_socksreq[5] := (l_ip[1]).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_socksreq[6] := (l_ip[2]).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_socksreq[7] := (l_ip[3]).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
							else
								l_hp := create {CE_CLASS_POINTER [PD_CURL_ADDRINFO]}.make_shared (default_pointer)
							end
							l_data.item.Curl_resolv_unlock (l_dns.item)
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_hp.is_void then
							l_data.item.Curl_failf ([ce_string ("Failed to resolve %"%%s%" for SOCKS5 connect."), a_hostname])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_COULDNT_RESOLVE_HOST)
							l_return := True
						end
					end
					if not l_return then
						(create {CE_NATURAL_16_POINTER}.make_cast ((l_socksreq + 8))).item := htons (a_remote_port.to_natural_16)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				l_code := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_write_plain (l_sock, create {CE_VOID_POINTER}.make_cast (l_socksreq), l_packetsize.to_natural_32, l_written)
				update_class_fields -- Current might have been changed; synchronize
				if l_code /= {NATURAL_32} 0 then
					l_data.item.Curl_failf ([ce_string ("Failed to send SOCKS5 connect request.")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					l_return := True
				elseif l_written.item /= l_packetsize then
					l_data.item.Curl_failf ([ce_string ("Failed to send SOCKS5 connect request.")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					l_return := True
				end
			end
			if not l_return then
				l_packetsize := 10
				l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_blockread_all (l_sock, create {CE_INTEGER_8_POINTER}.make_cast (l_socksreq), l_packetsize, l_actualread, l_timeout)
				update_class_fields -- Current might have been changed; synchronize
				if l_result /= 0 then
					l_data.item.Curl_failf ([ce_string ("Failed to receive SOCKS5 connect request ack.")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					l_return := True
				elseif l_actualread.item /= l_packetsize then
					l_data.item.Curl_failf ([ce_string ("Failed to receive SOCKS5 connect request ack.")])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
					l_return := True
				end
			end
			if not l_return and then ((l_socksreq[0]).to_integer_32 /= 5) then
				l_data.item.Curl_failf ([ce_string ("SOCKS5 reply has wrong version, version should be 5.")])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
				l_return := True
			end
			if not l_return and then ((l_socksreq[1]).to_integer_32 /= 0) then
				l_tmp___6 := ntohs ((create {CE_NATURAL_16_POINTER}.make_cast ((l_socksreq + 8))).item)
				update_class_fields -- Current might have been changed; synchronize
				l_data.item.Curl_failf ([ce_string ("Can%'t complete SOCKS5 connection to %%d.%%d.%%d.%%d:%%d. (%%d)"), (l_socksreq[4]).to_integer_32, (l_socksreq[5]).to_integer_32, (l_socksreq[6]).to_integer_32, (l_socksreq[7]).to_integer_32, l_tmp___6.to_natural_32, (l_socksreq[1]).to_integer_32])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
				l_return := True
			end
			if not l_return then
				if (l_socksreq[3]).to_integer_32 = 3 then
					l_addrlen := (l_socksreq[4]).to_integer_32
					l_packetsize := (5 + l_addrlen) + 2
				elseif (l_socksreq[3]).to_integer_32 = 4 then
					l_packetsize := 22
				end
				if l_packetsize > 10 then
					l_packetsize := l_packetsize - (10)
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_blockread_all (l_sock, create {CE_INTEGER_8_POINTER}.make_cast ((l_socksreq + 10)), l_packetsize, l_actualread, l_timeout)
					update_class_fields -- Current might have been changed; synchronize
					if l_result /= 0 then
						l_data.item.Curl_failf ([ce_string ("Failed to receive SOCKS5 connect request ack.")])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
						l_return := True
					elseif l_actualread.item /= l_packetsize then
						l_data.item.Curl_failf ([ce_string ("Failed to receive SOCKS5 connect request ack.")])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_COULDNT_CONNECT)
						l_return := True
					end
				end
			end
			if not l_return then
				curlx_nonblock (l_sock, 1).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	imap_state_login: NATURAL_32
		local
			l_result: NATURAL_32
			l_imap: CE_POINTER [PD_FTP]
			l_str: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_imap := data.item.state.proto.imap
			l_str := (create {P_IMAP_STATIC}).getcmdid ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
			update_class_fields -- Current might have been changed; synchronize
			if (not (l_imap.item.passwd).is_void) then
				l_tmp := l_imap.item.passwd
			else
				l_tmp := ce_string ("")
			end
			if (not (l_imap.item.user).is_void) then
				l_tmp___0 := l_imap.item.user
			else
				l_tmp___0 := ce_string ("")
			end
			l_result := (create {P_IMAP_STATIC}).imapsendf ([(create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_str, ce_string ("%%s LOGIN %%s %%s"), l_str, l_tmp___0, l_tmp])
			update_class_fields -- Current might have been changed; synchronize
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				(create {P_IMAP_STATIC}).state___0 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_IMAPSTATE}.IMAP_LOGIN)
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	imap_state_starttls_resp (a_imapcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			if a_imapcode /= 79 then
				l_data.item.Curl_failf ([ce_string ("STARTTLS denied. %%c"), a_imapcode])
				update_class_fields -- Current might have been changed; synchronize
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
				if {NATURAL_32} 0 = l_result then
					Current.protocol := (protocol).bit_or (((1).bit_shift_left (13)).to_integer_32)
					update_class_fields -- Current might have been changed; synchronize
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.imap_state_login
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			(create {P_IMAP_STATIC}).state___0 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_IMAPSTATE}.IMAP_STOP)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_result
		end

	imap_state_login_resp (a_imapcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			if a_imapcode /= 79 then
				l_data.item.Curl_failf ([ce_string ("Access denied. %%c"), a_imapcode])
				update_class_fields -- Current might have been changed; synchronize
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			end
			(create {P_IMAP_STATIC}).state___0 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_IMAPSTATE}.IMAP_STOP)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_result
		end

	imap_state_fetch_resp (a_imapcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_imap: CE_POINTER [PD_FTP]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_ptr: CE_POINTER [INTEGER_8]
			l_filesize: INTEGER_64
			l_tmp: INTEGER_64
			l_chunk: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			l_imapc := create {CE_CLASS_POINTER [PD_IMAP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("imapc"))
			l_imap := l_data.item.state.proto.imap
			l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_imapc.c_pointer + (create {PD_IMAP_CONN}.make).offset_of ("pp"))
			l_ptr := (l_data.item.state.buffer)
			if 42 /= a_imapcode then
				l_data.item.Curl_pgrsSetDownloadSize ((0).to_integer_64)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_IMAP_STATIC}).state___0 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_IMAPSTATE}.IMAP_STOP)
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
				l_return := True
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_ptr[0]).to_boolean then
						if (l_ptr[0]).to_integer_32 = 123 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_ptr := l_ptr + 1
					end
				end
				l_break := False
				if (l_ptr[0]).to_integer_32 = 123 then
					l_tmp := strtoll ((l_ptr + 1), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10)
					update_class_fields -- Current might have been changed; synchronize
					l_filesize := l_tmp
					if l_filesize.to_boolean then
						l_data.item.Curl_pgrsSetDownloadSize (l_filesize)
						update_class_fields -- Current might have been changed; synchronize
					end
					(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Found %%llu bytes to download%N"), l_filesize])
					update_class_fields -- Current might have been changed; synchronize
					if (not (l_pp.item.cache).is_void) then
						l_chunk := l_pp.item.cache_size
						if l_chunk > l_filesize.to_natural_32 then
							l_chunk := l_filesize.to_natural_32
						end
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write (1, l_pp.item.cache, l_chunk)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
						if not l_return then
							l_filesize := l_filesize - l_chunk.to_integer_64
							if l_pp.item.cache_size > l_chunk then
								memmove (create {CE_VOID_POINTER}.make_cast (l_pp.item.cache), create {CE_VOID_POINTER}.make_cast ((l_pp.item.cache + l_chunk.to_integer_32)), l_pp.item.cache_size - l_chunk).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_pp.item.cache_size := l_pp.item.cache_size - l_chunk
								update_class_fields -- Current might have been changed; synchronize
							else
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_pp.item.cache)])
								update_class_fields -- Current might have been changed; synchronize
								l_pp.item.cache := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								update_class_fields -- Current might have been changed; synchronize
								l_pp.item.cache_size := (0).to_natural_32
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
					if not l_return then
						(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Filesize left: %%lld%N"), l_filesize])
						update_class_fields -- Current might have been changed; synchronize
						if not l_filesize.to_boolean then
							((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (-1, (-1).to_integer_64, (0).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer), -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
						else
							((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (0, l_filesize, (0).to_boolean, l_imap.item.bytecountp, -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_data.item.req.maxdownload := l_filesize
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					l_result := {PC_CURLCODE}.CURLE_FTP_WEIRD_SERVER_REPLY
				end
			end
			if not l_return then
				(create {P_IMAP_STATIC}).state___0 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_IMAPSTATE}.IMAP_STOP)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_result
			end
		end

	imap_state_select_resp (a_imapcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			if a_imapcode /= 79 then
				l_data.item.Curl_failf ([ce_string ("Select failed")])
				update_class_fields -- Current might have been changed; synchronize
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				l_result := imap_fetch ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l_result
		end

	imap_statemach_act: NATURAL_32
		local
			l_result: NATURAL_32
			l_sock: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_imapcode: CE_ARRAY [INTEGER_32]
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_nread: CE_ARRAY [NATURAL_32]
			l_tmp: NATURAL_32
			l_str: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_imapcode.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_nread.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sock := sock[0]
					l_data := data
					l_imapc := create {CE_CLASS_POINTER [PD_IMAP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("imapc"))
					l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_imapc.c_pointer + (create {PD_IMAP_CONN}.make).offset_of ("pp"))
					l_nread.item := (0).to_natural_32
					update_class_fields -- Current might have been changed; synchronize
					if (l_pp.item.sendleft).to_boolean then
						l_tmp := Curl_pp_flushsend (l_pp)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp
						l_return := True
					end
					if not l_return then
						l_result := Curl_pp_readresp (l_sock, l_pp, l_imapcode, l_nread)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if not (not l_return and then ((l_imapcode.item).to_boolean)) then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						inspect (l_imapc.item.state).to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						when 5 then l_pos := -1 + 5
						when 4 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 2 then -- switch 1, case 1
						if l_imapcode.item /= 79 then
							l_data.item.Curl_failf ([ce_string ("Got unexpected imap-server response")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_FTP_WEIRD_SERVER_REPLY)
							l_return := True
						end
						if not l_return then
							if (l_data.item.set.ftp_ssl).to_boolean then
								if not ssl[0].use then
									l_str := (create {P_IMAP_STATIC}).getcmdid ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
									update_class_fields -- Current might have been changed; synchronize
									l_result := (create {P_IMAP_STATIC}).imapsendf ([(create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_str, ce_string ("%%s STARTTLS"), l_str])
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_IMAP_STATIC}).state___0 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_IMAPSTATE}.IMAP_STARTTLS)
									update_class_fields -- Current might have been changed; synchronize
								else
									l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.imap_state_login
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.imap_state_login
								update_class_fields -- Current might have been changed; synchronize
							end
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
						l_pos := -1 + 8 -- switch 1; break
				when 3 then -- switch 1, case 2
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.imap_state_login_resp (l_imapcode.item, l_imapc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 3
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.imap_state_starttls_resp (l_imapcode.item, l_imapc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 5
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.imap_state_fetch_resp (l_imapcode.item, l_imapc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 4
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.imap_state_select_resp (l_imapcode.item, l_imapc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, default:;
						(create {P_IMAP_STATIC}).state___0 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_IMAPSTATE}.IMAP_STOP)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 8 -- switch 1; break
				when 8 then -- switch 1, done: | if done
					if not l_return then
						Result := l_result
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	imap_init: NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_imap: CE_POINTER [PD_FTP]
			l_tmp: CE_POINTER [PD_FTP]
			l_tmp___0: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			l_data := data
			l_imap := l_data.item.state.proto.imap
			if l_imap.is_void then
				l_tmp___0 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(create {PD_FTP}.make).structure_size.to_natural_32, (1).to_natural_32]))
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := create {CE_CLASS_POINTER [PD_FTP]}.make_cast (l_tmp___0)
				l_data.item.state.proto.imap := l_tmp
				update_class_fields -- Current might have been changed; synchronize
				l_imap := l_tmp
				if l_imap.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				l_imap.item.bytecountp := create {CE_INTEGER_64_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req") + (create {PD_SINGLEREQUEST}.make).offset_of ("bytecount"))
				update_class_fields -- Current might have been changed; synchronize
				l_imap.item.user := user
				update_class_fields -- Current might have been changed; synchronize
				l_imap.item.passwd := passwd
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	imap_connect (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_result: NATURAL_32
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_http_proxy: CE_ARRAY [PD_HTTP]
			l_imap_save: CE_POINTER [PD_FTP]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_HTTP]} l_http_proxy.make (<<1>>)

			l_imapc := create {CE_CLASS_POINTER [PD_IMAP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("imapc"))
			l_data := data
			l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_imapc.c_pointer + (create {PD_IMAP_CONN}.make).offset_of ("pp"))
			a_done.item := (0).to_boolean
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_reset_reqproto
			update_class_fields -- Current might have been changed; synchronize
			l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.imap_init
			update_class_fields -- Current might have been changed; synchronize
			if {NATURAL_32} 0 /= l_result then
				Result := l_result
				l_return := True
			end
			if not l_return then
				bits.close := (0).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.response_time := 1_800_000
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.statemach_act := imap_statemach_act_address
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.endofresp := (create {PD_PINGPONG_STATIC}).imap_endofresp_address
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.conn := (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
				if bits.tunnel_proxy then
					if bits.httpproxy then
						l_imap_save := l_data.item.state.proto.imap
						memset (create {CE_VOID_POINTER}.make_cast (l_http_proxy), 0, (create {PD_HTTP}.make).structure_size.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.state.proto.http := l_http_proxy
						update_class_fields -- Current might have been changed; synchronize
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_proxyCONNECT (0, host.name, remote_port)
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.state.proto.imap := l_imap_save
						update_class_fields -- Current might have been changed; synchronize
						if {NATURAL_32} 0 /= l_result then
							Result := l_result
							l_return := True
						end
					end
				end
			end
			if not l_return and then (((protocol).bit_and (((1).bit_shift_left (13)).to_integer_32)).to_boolean) then
				l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
				if l_result.to_boolean then
					Result := l_result
					l_return := True
				end
			end
			if not l_return then
				l_pp.item.Curl_pp_init
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_IMAP_STATIC}).state___0 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_IMAPSTATE}.IMAP_SERVERGREET)
				update_class_fields -- Current might have been changed; synchronize
				l_imapc.item.idstr := ce_string ("*")
				update_class_fields -- Current might have been changed; synchronize
				if l_data.item.state.used_interface = {NATURAL_32} 2 then
					l_result := (create {P_IMAP_STATIC}).imap_multi_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), a_done)
					update_class_fields -- Current might have been changed; synchronize
				else
					l_result := (create {P_IMAP_STATIC}).imap_easy_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
					if not l_result.to_boolean then
						a_done.item := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				Result := l_result
			end
		end

	imap_done (a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_imap: CE_POINTER [PD_FTP]
			l_result: NATURAL_32
			l_return: BOOLEAN
		do
			l_data := data
			l_imap := l_data.item.state.proto.imap
			l_result := {PC_CURLCODE}.CURLE_OK
			if l_imap.is_void then
				Result := ({PC_CURLCODE}.CURLE_OK)
				l_return := True
			end
			if not l_return then
				if a_status.to_boolean then
					bits.close := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
					l_result := a_status
				end
				l_imap.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_BODY
				update_class_fields -- Current might have been changed; synchronize
				Result := l_result
			end
		end

	imap_perform (a_connected, a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_dophase_done.is_void
		local
			l_result: NATURAL_32
			l_imap: CE_POINTER [PD_FTP]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			if data.item.set.opt_no_body then
				l_imap := data.item.state.proto.imap
				l_imap.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_INFO
				update_class_fields -- Current might have been changed; synchronize
			end
			a_dophase_done.item := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			l_result := imap_select ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
			update_class_fields -- Current might have been changed; synchronize
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				if data.item.state.used_interface = {NATURAL_32} 2 then
					l_result := (create {P_IMAP_STATIC}).imap_multi_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), a_dophase_done)
					update_class_fields -- Current might have been changed; synchronize
				else
					l_result := (create {P_IMAP_STATIC}).imap_easy_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
					a_dophase_done.item := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
				end
				a_connected.item := bits.tcpconnect
				update_class_fields -- Current might have been changed; synchronize
				if a_dophase_done.item then
				end
				Result := l_result
			end
		end

	imap_do (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_retcode: NATURAL_32
			l_return: BOOLEAN
		do
			l_retcode := {PC_CURLCODE}.CURLE_OK
			a_done.item := (0).to_boolean
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_reset_reqproto
			update_class_fields -- Current might have been changed; synchronize
			l_retcode := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.imap_init
			update_class_fields -- Current might have been changed; synchronize
			if l_retcode.to_boolean then
				Result := l_retcode
				l_return := True
			end
			if not l_return then
				l_retcode := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.imap_parse_url_path
				update_class_fields -- Current might have been changed; synchronize
				if l_retcode.to_boolean then
					Result := l_retcode
					l_return := True
				end
			end
			if not l_return then
				l_retcode := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.imap_regular_transfer (a_done)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_retcode
			end
		end

	imap_parse_url_path: NATURAL_32
		local
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_path: CE_POINTER [INTEGER_8]
			l_len: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_len.make (<<1>>)

			l_imapc := create {CE_CLASS_POINTER [PD_IMAP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("imapc"))
			l_data := data
			l_path := l_data.item.state.path
			if not (l_path[0]).to_boolean then
				l_path := ce_string ("INBOX")
			end
			l_imapc.item.mailbox := (create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_cast (l_data), l_path, 0, l_len)
			update_class_fields -- Current might have been changed; synchronize
			if (l_imapc.item.mailbox).is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				l_return := True
			end
			if not l_return then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	imap_dophase_done (a_connected: BOOLEAN): NATURAL_32
		local
			l_imap: CE_POINTER [PD_FTP]
		do
			l_imap := data.item.state.proto.imap
			if l_imap.item.transfer /= {NATURAL_32} 0 then
				((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (-1, (-1).to_integer_64, (0).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer), -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	imap_regular_transfer (a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_dophase_done.is_void
		local
			l_result: NATURAL_32
			l_connected: CE_ARRAY [BOOLEAN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_return: BOOLEAN
		do
			create {CE_BOOLEAN_ARRAY} l_connected.make (<<1>>)

			l_result := {PC_CURLCODE}.CURLE_OK
			l_connected.item := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			l_data := data
			l_data.item.req.size := (-1).to_integer_64
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetUploadCounter ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetDownloadCounter ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetUploadSize ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetDownloadSize ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.imap_perform (l_connected, a_dophase_done)
			update_class_fields -- Current might have been changed; synchronize
			if {NATURAL_32} 0 = l_result then
				if not a_dophase_done.item then
					Result := ({PC_CURLCODE}.CURLE_OK)
					l_return := True
				end
				if not l_return then
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.imap_dophase_done (l_connected.item)
					update_class_fields -- Current might have been changed; synchronize
					if l_result.to_boolean then
						Result := l_result
						l_return := True
					end
				end
			end
			if not l_return then
				Result := l_result
			end
		end

	imap_setup_connection: NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_return: BOOLEAN
		do
			l_data := data
			if bits.httpproxy then
				if not l_data.item.set.tunnel_thru_httpproxy then
					if handler.is_equal ((create {P_IMAP_STATIC}).Curl_handler_imap.item) then
						Current.handler := Curl_handler_imap_proxy.item
						update_class_fields -- Current might have been changed; synchronize
					else
						l_data.item.Curl_failf ([ce_string ("IMAPS not supported!")])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_UNSUPPORTED_PROTOCOL)
						l_return := True
					end
					if not l_return then
						bits.close := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				l_data.item.state.path := (l_data.item.state.path) + 1
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	pop3_state_user: NATURAL_32
		local
			l_result: NATURAL_32
			l_pop3: CE_POINTER [PD_FTP]
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_pop3 := data.item.state.proto.pop3
			if (not (l_pop3.item.user).is_void) then
				l_tmp := l_pop3.item.user
			else
				l_tmp := ce_string ("")
			end
			l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c") + (create {PD_POP3_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("USER %%s"), l_tmp])
			update_class_fields -- Current might have been changed; synchronize
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				(create {P_POP3_STATIC}).state___1 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_POP3STATE}.POP3_USER)
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	pop3_state_starttls_resp (a_pop3code: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			if a_pop3code /= 79 then
				l_data.item.Curl_failf ([ce_string ("STARTTLS denied. %%c"), a_pop3code])
				update_class_fields -- Current might have been changed; synchronize
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
				if {NATURAL_32} 0 = l_result then
					Current.protocol := (protocol).bit_or (((1).bit_shift_left (15)).to_integer_32)
					update_class_fields -- Current might have been changed; synchronize
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.pop3_state_user
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			(create {P_POP3_STATIC}).state___1 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_POP3STATE}.POP3_STOP)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_result
		end

	pop3_state_user_resp (a_pop3code: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pop3: CE_POINTER [PD_FTP]
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			l_pop3 := l_data.item.state.proto.pop3
			if a_pop3code /= 79 then
				l_data.item.Curl_failf ([ce_string ("Access denied. %%c"), a_pop3code])
				update_class_fields -- Current might have been changed; synchronize
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				if (not (l_pop3.item.passwd).is_void) then
					l_tmp := l_pop3.item.passwd
				else
					l_tmp := ce_string ("")
				end
				l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c") + (create {PD_POP3_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("PASS %%s"), l_tmp])
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				(create {P_POP3_STATIC}).state___1 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_POP3STATE}.POP3_PASS)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_result
			end
		end

	pop3_state_pass_resp (a_pop3code: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			if a_pop3code /= 79 then
				l_data.item.Curl_failf ([ce_string ("Access denied. %%c"), a_pop3code])
				update_class_fields -- Current might have been changed; synchronize
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			end
			(create {P_POP3_STATIC}).state___1 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_POP3STATE}.POP3_STOP)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_result
		end

	pop3_state_retr_resp (a_pop3code: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pop3: CE_POINTER [PD_FTP]
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			l_pop3 := l_data.item.state.proto.pop3
			l_pop3c := create {CE_CLASS_POINTER [PD_POP3_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_pop3c.c_pointer + (create {PD_POP3_CONN}.make).offset_of ("pp"))
			if 79 /= a_pop3code then
				(create {P_POP3_STATIC}).state___1 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_POP3STATE}.POP3_STOP)
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
				l_return := True
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (0, (-1).to_integer_64, (0).to_boolean, l_pop3.item.bytecountp, -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				if (not (l_pp.item.cache).is_void) then
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pop3_write (l_pp.item.cache, l_pp.item.cache_size)
					update_class_fields -- Current might have been changed; synchronize
					if l_result.to_boolean then
						Result := l_result
						l_return := True
					end
					if not l_return then
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_pp.item.cache)])
						update_class_fields -- Current might have been changed; synchronize
						l_pp.item.cache := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_pp.item.cache_size := (0).to_natural_32
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				(create {P_POP3_STATIC}).state___1 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_POP3STATE}.POP3_STOP)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_result
			end
		end

	pop3_state_list_resp (a_pop3code: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pop3: CE_POINTER [PD_FTP]
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			l_pop3 := l_data.item.state.proto.pop3
			l_pop3c := create {CE_CLASS_POINTER [PD_POP3_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_pop3c.c_pointer + (create {PD_POP3_CONN}.make).offset_of ("pp"))
			if 79 /= a_pop3code then
				(create {P_POP3_STATIC}).state___1 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_POP3STATE}.POP3_STOP)
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
				l_return := True
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (0, (-1).to_integer_64, (0).to_boolean, l_pop3.item.bytecountp, -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				if (not (l_pp.item.cache).is_void) then
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pop3_write (l_pp.item.cache, l_pp.item.cache_size)
					update_class_fields -- Current might have been changed; synchronize
					if l_result.to_boolean then
						Result := l_result
						l_return := True
					end
					if not l_return then
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_pp.item.cache)])
						update_class_fields -- Current might have been changed; synchronize
						l_pp.item.cache := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_pp.item.cache_size := (0).to_natural_32
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				(create {P_POP3_STATIC}).state___1 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_POP3STATE}.POP3_STOP)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_result
			end
		end

	pop3_statemach_act: NATURAL_32
		local
			l_result: NATURAL_32
			l_sock: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pop3code: CE_ARRAY [INTEGER_32]
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_nread: CE_ARRAY [NATURAL_32]
			l_tmp: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_pop3code.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_nread.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sock := sock[0]
					l_data := data
					l_pop3c := create {CE_CLASS_POINTER [PD_POP3_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
					l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_pop3c.c_pointer + (create {PD_POP3_CONN}.make).offset_of ("pp"))
					l_nread.item := (0).to_natural_32
					update_class_fields -- Current might have been changed; synchronize
					if (l_pp.item.sendleft).to_boolean then
						l_tmp := Curl_pp_flushsend (l_pp)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp
						l_return := True
					end
					if not l_return then
						l_result := Curl_pp_readresp (l_sock, l_pp, l_pop3code, l_nread)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if not (not l_return and then ((l_pop3code.item).to_boolean)) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						inspect (l_pop3c.item.state).to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						when 4 then l_pos := -1 + 5
						when 6 then l_pos := -1 + 6
						when 5 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 2 then -- switch 1, case 1
						if l_pop3code.item /= 79 then
							l_data.item.Curl_failf ([ce_string ("Got unexpected pop3-server response")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_FTP_WEIRD_SERVER_REPLY)
							l_return := True
						end
						if not l_return then
							if (l_data.item.set.ftp_ssl).to_boolean then
								if not ssl[0].use then
									l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_pop3c.c_pointer + (create {PD_POP3_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("STARTTLS"), create {CE_VOID_POINTER}.make_shared (default_pointer)])
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_POP3_STATIC}).state___1 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_POP3STATE}.POP3_STARTTLS)
									update_class_fields -- Current might have been changed; synchronize
								else
									l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.pop3_state_user
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.pop3_state_user
								update_class_fields -- Current might have been changed; synchronize
							end
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
						l_pos := -1 + 9 -- switch 1; break
				when 3 then -- switch 1, case 2
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.pop3_state_user_resp (l_pop3code.item, l_pop3c.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 9 -- switch 1; break
				when 4 then -- switch 1, case 3
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.pop3_state_pass_resp (l_pop3code.item, l_pop3c.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 9 -- switch 1; break
				when 5 then -- switch 1, case 4
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.pop3_state_starttls_resp (l_pop3code.item, l_pop3c.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 6
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.pop3_state_retr_resp (l_pop3code.item, l_pop3c.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 5
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.pop3_state_list_resp (l_pop3code.item, l_pop3c.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, default:;
						(create {P_POP3_STATIC}).state___1 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_POP3STATE}.POP3_STOP)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done: | if done
					if not l_return then
						Result := l_result
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	pop3_init: NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pop3: CE_POINTER [PD_FTP]
			l_tmp: CE_POINTER [PD_FTP]
			l_tmp___0: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			l_data := data
			l_pop3 := l_data.item.state.proto.pop3
			if l_pop3.is_void then
				l_tmp___0 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(create {PD_FTP}.make).structure_size.to_natural_32, (1).to_natural_32]))
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := create {CE_CLASS_POINTER [PD_FTP]}.make_cast (l_tmp___0)
				l_data.item.state.proto.pop3 := l_tmp
				update_class_fields -- Current might have been changed; synchronize
				l_pop3 := l_tmp
				if l_pop3.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				l_pop3.item.bytecountp := create {CE_INTEGER_64_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req") + (create {PD_SINGLEREQUEST}.make).offset_of ("bytecount"))
				update_class_fields -- Current might have been changed; synchronize
				l_pop3.item.user := user
				update_class_fields -- Current might have been changed; synchronize
				l_pop3.item.passwd := passwd
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	pop3_connect (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_result: NATURAL_32
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_http_proxy: CE_ARRAY [PD_HTTP]
			l_pop3_save: CE_POINTER [PD_FTP]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_HTTP]} l_http_proxy.make (<<1>>)

			l_pop3c := create {CE_CLASS_POINTER [PD_POP3_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_data := data
			l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_pop3c.c_pointer + (create {PD_POP3_CONN}.make).offset_of ("pp"))
			a_done.item := (0).to_boolean
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_reset_reqproto
			update_class_fields -- Current might have been changed; synchronize
			l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.pop3_init
			update_class_fields -- Current might have been changed; synchronize
			if {NATURAL_32} 0 /= l_result then
				Result := l_result
				l_return := True
			end
			if not l_return then
				bits.close := (0).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.response_time := 1_800_000
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.statemach_act := pop3_statemach_act_address
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.endofresp := (create {PD_PINGPONG_STATIC}).pop3_endofresp_address
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.conn := (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
				if bits.tunnel_proxy then
					if bits.httpproxy then
						l_pop3_save := l_data.item.state.proto.pop3
						memset (create {CE_VOID_POINTER}.make_cast (l_http_proxy), 0, (create {PD_HTTP}.make).structure_size.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.state.proto.http := l_http_proxy
						update_class_fields -- Current might have been changed; synchronize
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_proxyCONNECT (0, host.name, remote_port)
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.state.proto.pop3 := l_pop3_save
						update_class_fields -- Current might have been changed; synchronize
						if {NATURAL_32} 0 /= l_result then
							Result := l_result
							l_return := True
						end
					end
				end
			end
			if not l_return and then (((protocol).bit_and (((1).bit_shift_left (15)).to_integer_32)).to_boolean) then
				l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
				if l_result.to_boolean then
					Result := l_result
					l_return := True
				end
			end
			if not l_return then
				l_pp.item.Curl_pp_init
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_POP3_STATIC}).state___1 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_POP3STATE}.POP3_SERVERGREET)
				update_class_fields -- Current might have been changed; synchronize
				if l_data.item.state.used_interface = {NATURAL_32} 2 then
					l_result := (create {P_POP3_STATIC}).pop3_multi_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), a_done)
					update_class_fields -- Current might have been changed; synchronize
				else
					l_result := (create {P_POP3_STATIC}).pop3_easy_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
					if not l_result.to_boolean then
						a_done.item := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				Result := l_result
			end
		end

	pop3_done (a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pop3: CE_POINTER [PD_FTP]
			l_result: NATURAL_32
			l_return: BOOLEAN
		do
			l_data := data
			l_pop3 := l_data.item.state.proto.pop3
			l_result := {PC_CURLCODE}.CURLE_OK
			if l_pop3.is_void then
				Result := ({PC_CURLCODE}.CURLE_OK)
				l_return := True
			end
			if not l_return then
				if a_status.to_boolean then
					bits.close := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
					l_result := a_status
				end
				l_pop3.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_BODY
				update_class_fields -- Current might have been changed; synchronize
				Result := l_result
			end
		end

	pop3_perform (a_connected, a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_dophase_done.is_void
		local
			l_result: NATURAL_32
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_pop3: CE_POINTER [PD_FTP]
			l_tmp: NATURAL_32
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_pop3c := create {CE_CLASS_POINTER [PD_POP3_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			if data.item.set.opt_no_body then
				l_pop3 := data.item.state.proto.pop3
				l_pop3.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_INFO
				update_class_fields -- Current might have been changed; synchronize
			end
			a_dophase_done.item := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := strlen (l_pop3c.item.mailbox)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				l_result := pop3_retr ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
				update_class_fields -- Current might have been changed; synchronize
			else
				l_result := pop3_list ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				if data.item.state.used_interface = {NATURAL_32} 2 then
					l_result := (create {P_POP3_STATIC}).pop3_multi_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), a_dophase_done)
					update_class_fields -- Current might have been changed; synchronize
				else
					l_result := (create {P_POP3_STATIC}).pop3_easy_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
					a_dophase_done.item := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
				end
				a_connected.item := bits.tcpconnect
				update_class_fields -- Current might have been changed; synchronize
				if a_dophase_done.item then
				end
				Result := l_result
			end
		end

	pop3_do (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_retcode: NATURAL_32
			l_return: BOOLEAN
		do
			l_retcode := {PC_CURLCODE}.CURLE_OK
			a_done.item := (0).to_boolean
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_reset_reqproto
			update_class_fields -- Current might have been changed; synchronize
			l_retcode := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.pop3_init
			update_class_fields -- Current might have been changed; synchronize
			if l_retcode.to_boolean then
				Result := l_retcode
				l_return := True
			end
			if not l_return then
				l_retcode := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.pop3_parse_url_path
				update_class_fields -- Current might have been changed; synchronize
				if l_retcode.to_boolean then
					Result := l_retcode
					l_return := True
				end
			end
			if not l_return then
				l_retcode := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.pop3_regular_transfer (a_done)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_retcode
			end
		end

	pop3_parse_url_path: NATURAL_32
		local
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_path: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_pop3c := create {CE_CLASS_POINTER [PD_POP3_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_data := data
			l_path := l_data.item.state.path
			l_pop3c.item.mailbox := (create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_cast (l_data), l_path, 0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
			if (l_pop3c.item.mailbox).is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				l_return := True
			end
			if not l_return then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	pop3_dophase_done (a_connected: BOOLEAN): NATURAL_32
		local
			l_pop3: CE_POINTER [PD_FTP]
			l_pop3c: CE_POINTER [PD_POP3_CONN]
		do
			l_pop3 := data.item.state.proto.pop3
			l_pop3c := create {CE_CLASS_POINTER [PD_POP3_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			if l_pop3.item.transfer /= {NATURAL_32} 0 then
				((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (-1, (-1).to_integer_64, (0).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer), -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_pop3c.item.mailbox)])
			update_class_fields -- Current might have been changed; synchronize
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	pop3_regular_transfer (a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_dophase_done.is_void
		local
			l_result: NATURAL_32
			l_connected: CE_ARRAY [BOOLEAN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_return: BOOLEAN
		do
			create {CE_BOOLEAN_ARRAY} l_connected.make (<<1>>)

			l_result := {PC_CURLCODE}.CURLE_OK
			l_connected.item := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			l_data := data
			l_data.item.req.size := (-1).to_integer_64
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetUploadCounter ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetDownloadCounter ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetUploadSize ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetDownloadSize ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.pop3_perform (l_connected, a_dophase_done)
			update_class_fields -- Current might have been changed; synchronize
			if {NATURAL_32} 0 = l_result then
				if not a_dophase_done.item then
					Result := ({PC_CURLCODE}.CURLE_OK)
					l_return := True
				end
				if not l_return then
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.pop3_dophase_done (l_connected.item)
					update_class_fields -- Current might have been changed; synchronize
					if l_result.to_boolean then
						Result := l_result
						l_return := True
					end
				end
			end
			if not l_return then
				Result := l_result
			end
		end

	pop3_setup_connection: NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_return: BOOLEAN
		do
			l_data := data
			if bits.httpproxy then
				if not l_data.item.set.tunnel_thru_httpproxy then
					if handler.is_equal ((create {P_POP3_STATIC}).Curl_handler_pop3.item) then
						Current.handler := Curl_handler_pop3_proxy.item
						update_class_fields -- Current might have been changed; synchronize
					else
						l_data.item.Curl_failf ([ce_string ("POP3S not supported!")])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_UNSUPPORTED_PROTOCOL)
						l_return := True
					end
					if not l_return then
						bits.close := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				l_data.item.state.path := (l_data.item.state.path) + 1
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_pop3_write (a_str: CE_POINTER [INTEGER_8]; a_nread: NATURAL_32): NATURAL_32
		local
			l_nread: NATURAL_32
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_checkmax: NATURAL_32
			l_tmp: NATURAL_32
			l_checkleft: NATURAL_32
			l_check: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			l_nread := a_nread
			l_data := data
			l_k := create {CE_CLASS_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
			l_pop3c := create {CE_CLASS_POINTER [PD_POP3_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			if l_nread >= {NATURAL_32} 5 then
				l_tmp := (5).to_natural_32
			else
				l_tmp := l_nread
			end
			l_checkmax := l_tmp
			l_checkleft := {NATURAL_32} 5 - l_pop3c.item.eob
			if l_checkmax >= l_checkleft then
				l_tmp___0 := l_checkleft
			else
				l_tmp___0 := l_checkmax
			end
			l_check := l_tmp___0
			l_tmp___1 := memcmp (create {CE_VOID_POINTER}.make_cast (ce_string ("%R%N.%R%N")), create {CE_VOID_POINTER}.make_cast ((a_str + (l_nread - l_check).to_integer_32)), l_check)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___1.to_boolean then
				if (l_pop3c.item.eob).to_boolean then
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write (1, ce_string ("%R%N.%R%N"), l_pop3c.item.eob)
					update_class_fields -- Current might have been changed; synchronize
					if l_result.to_boolean then
						Result := l_result
						l_return := True
					end
					if not l_return then
						l_pop3c.item.eob := (0).to_natural_32
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			else
				l_pop3c.item.eob := l_pop3c.item.eob + l_check
				update_class_fields -- Current might have been changed; synchronize
				if l_pop3c.item.eob = {NATURAL_32} 5 then
					a_str[(l_nread - l_check).to_integer_32] := (('%/0/').code).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_nread := l_nread - l_check
					l_k.item.keepon := (l_k.item.keepon).bit_and ((-2))
					update_class_fields -- Current might have been changed; synchronize
					l_pop3c.item.eob := (0).to_natural_32
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write (1, a_str, l_nread)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_result
			end
		end

	smtp_auth_plain_data (a_outptr: CE_POINTER [CE_POINTER [INTEGER_8]]): NATURAL_32
		local
			l_plainauth: CE_ARRAY [INTEGER_8]
			l_ulen: NATURAL_32
			l_plen: NATURAL_32
			l_tmp: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_plainauth.make (<<768>>)

			l_ulen := strlen (user)
			update_class_fields -- Current might have been changed; synchronize
			l_plen := strlen (passwd)
			update_class_fields -- Current might have been changed; synchronize
			if ({NATURAL_32} 2 * l_ulen + l_plen) + {NATURAL_32} 2 > ({PLATFORM}.Integer_8_bytes.to_natural_32 * (768).to_natural_32) then
				Result := (0).to_natural_32
				l_return := True
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_plainauth), create {CE_VOID_POINTER}.make_cast (user), l_ulen).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_plainauth[l_ulen.to_integer_32] := (('%/0/').code).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
				memcpy (create {CE_VOID_POINTER}.make_cast (((l_plainauth + l_ulen.to_integer_32) + 1)), create {CE_VOID_POINTER}.make_cast (user), l_ulen).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_plainauth[({NATURAL_32} 2 * l_ulen + {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
				memcpy (create {CE_VOID_POINTER}.make_cast (((l_plainauth + ({NATURAL_32} 2 * l_ulen).to_integer_32) + 2)), create {CE_VOID_POINTER}.make_cast (passwd), l_plen).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := Curl_base64_encode (data, l_plainauth, ({NATURAL_32} 2 * l_ulen + l_plen) + {NATURAL_32} 2, a_outptr)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp
			end
		end

	smtp_auth_login_user (a_outptr: CE_POINTER [CE_POINTER [INTEGER_8]]): NATURAL_32
		require
			not a_outptr.is_void
		local
			l_ulen: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l_return: BOOLEAN
		do
			l_ulen := strlen (user)
			update_class_fields -- Current might have been changed; synchronize
			if not l_ulen.to_boolean then
				a_outptr.item := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([ce_string ("=")]))
				update_class_fields -- Current might have been changed; synchronize
				if (not (a_outptr.item).is_void) then
					l_tmp := 1
				else
					l_tmp := 0
				end
				Result := l_tmp.to_natural_32
				l_return := True
			end
			if not l_return then
				l_tmp___0 := Curl_base64_encode (data, user, l_ulen, a_outptr)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___0
			end
		end

	smtp_authenticate: NATURAL_32
		local
			l_result: NATURAL_32
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_initresp: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_mech: CE_POINTER [INTEGER_8]
			l_l: NATURAL_32
			l_state1: NATURAL_32
			l_state2: NATURAL_32
			l_tmp: NATURAL_32
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_initresp.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_smtpc := create {CE_CLASS_POINTER [PD_SMTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
					if bits.user_passwd then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:;
						(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_STOP)
						update_class_fields -- Current might have been changed; synchronize
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 3 then -- else:
						l_initresp.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_l := (1).to_natural_32
						l_mech := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						l_state1 := {PC_SMTPSTATE}.SMTP_STOP
						l_state2 := {PC_SMTPSTATE}.SMTP_STOP
						if ((l_smtpc.item.authmechs).bit_and ({NATURAL_32} 4)).to_boolean then
							l_mech := ce_string ("CRAM-MD5")
							l_state1 := {PC_SMTPSTATE}.SMTP_AUTHCRAM
						elseif ((l_smtpc.item.authmechs).bit_and ({NATURAL_32} 2)).to_boolean then
							l_mech := ce_string ("PLAIN")
							l_state1 := {PC_SMTPSTATE}.SMTP_AUTHPLAIN
							l_state2 := {PC_SMTPSTATE}.SMTP_AUTH
							l_l := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_auth_plain_data (l_initresp)
							update_class_fields -- Current might have been changed; synchronize
						elseif ((l_smtpc.item.authmechs).bit_and ({NATURAL_32} 1)).to_boolean then
							l_mech := ce_string ("LOGIN")
							l_state1 := {PC_SMTPSTATE}.SMTP_AUTHLOGIN
							l_state2 := {PC_SMTPSTATE}.SMTP_AUTHPASSWD
							l_l := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_auth_login_user (l_initresp)
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_SENDF_STATIC}).Curl_infof ([data, ce_string ("No known auth mechanisms supported!%N")])
							update_class_fields -- Current might have been changed; synchronize
							l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
						end
						if l_result.to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						if l_l.to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if (l_initresp.item).is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_tmp := strlen (l_mech)
						update_class_fields -- Current might have been changed; synchronize
						if l_l + l_tmp <= {NATURAL_32} 504 then
							l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("AUTH %%s %%s"), l_mech, l_initresp.item])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_initresp.item)])
							update_class_fields -- Current might have been changed; synchronize
							if not l_result.to_boolean then
								(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_state2)
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:;
						(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_initresp.item))
						update_class_fields -- Current might have been changed; synchronize
						l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("AUTH %%s"), l_mech])
						update_class_fields -- Current might have been changed; synchronize
						if not l_result.to_boolean then
							(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_state1)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 11 then -- if done | if done | if done
					Result := l_result
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	smtp_state_starttls_resp (a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			if a_smtpcode /= 220 then
				if l_data.item.set.ftp_ssl /= {NATURAL_32} 1 then
					l_data.item.Curl_failf ([ce_string ("STARTTLS denied. %%c"), a_smtpcode])
					update_class_fields -- Current might have been changed; synchronize
					l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
				else
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_authenticate
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
				if {NATURAL_32} 0 = l_result then
					Current.protocol := (protocol).bit_or (((1).bit_shift_left (17)).to_integer_32)
					update_class_fields -- Current might have been changed; synchronize
					l_result := smtp_state_ehlo ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			Result := l_result
		end

	smtp_state_ehlo_resp (a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data := data
					if a_smtpcode // 100 = 2 then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (l_data.item.set.ftp_ssl <= {NATURAL_32} 1) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (ssl[0].use) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if not bits.user_passwd then
							l_result := smtp_state_helo ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
							update_class_fields -- Current might have been changed; synchronize
						else
							l_data.item.Curl_failf ([ce_string ("Access denied: %%d"), a_smtpcode])
							update_class_fields -- Current might have been changed; synchronize
							l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_data.item.Curl_failf ([ce_string ("Access denied: %%d"), a_smtpcode])
						update_class_fields -- Current might have been changed; synchronize
						l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
				when 8 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						if (l_data.item.set.ftp_ssl).to_boolean then
							if not ssl[0].use then
								l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("STARTTLS")])
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_STARTTLS)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_authenticate
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_authenticate
							update_class_fields -- Current might have been changed; synchronize
						end
				when 10 then
					Result := l_result
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	smtp_state_helo_resp (a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			if a_smtpcode // 100 /= 2 then
				l_data.item.Curl_failf ([ce_string ("Access denied: %%d"), a_smtpcode])
				update_class_fields -- Current might have been changed; synchronize
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_STOP)
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l_result
		end

	smtp_state_authplain_resp (a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_l: NATURAL_32
			l_plainauth: CE_ARRAY [CE_POINTER [INTEGER_8]]
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_plainauth.make (<<1>>)

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			if a_smtpcode /= 334 then
				l_data.item.Curl_failf ([ce_string ("Access denied: %%d"), a_smtpcode])
				update_class_fields -- Current might have been changed; synchronize
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				l_l := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_auth_plain_data (l_plainauth)
				update_class_fields -- Current might have been changed; synchronize
				if not l_l.to_boolean then
					l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
				else
					l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("%%s"), l_plainauth.item])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_plainauth.item)])
					update_class_fields -- Current might have been changed; synchronize
					if not l_result.to_boolean then
						(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_AUTH)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			Result := l_result
		end

	smtp_state_authlogin_resp (a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_l: NATURAL_32
			l_authuser: CE_ARRAY [CE_POINTER [INTEGER_8]]
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_authuser.make (<<1>>)

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			if a_smtpcode /= 334 then
				l_data.item.Curl_failf ([ce_string ("Access denied: %%d"), a_smtpcode])
				update_class_fields -- Current might have been changed; synchronize
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				l_l := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_auth_login_user (l_authuser)
				update_class_fields -- Current might have been changed; synchronize
				if not l_l.to_boolean then
					l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
				else
					l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("%%s"), l_authuser.item])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_authuser.item)])
					update_class_fields -- Current might have been changed; synchronize
					if not l_result.to_boolean then
						(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_AUTHPASSWD)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			Result := l_result
		end

	smtp_state_authpasswd_resp (a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_plen: NATURAL_32
			l_l: NATURAL_32
			l_authpasswd: CE_ARRAY [CE_POINTER [INTEGER_8]]
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_authpasswd.make (<<1>>)

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			if a_smtpcode /= 334 then
				l_data.item.Curl_failf ([ce_string ("Access denied: %%d"), a_smtpcode])
				update_class_fields -- Current might have been changed; synchronize
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				l_plen := strlen (passwd)
				update_class_fields -- Current might have been changed; synchronize
				if not l_plen.to_boolean then
					l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("=")])
					update_class_fields -- Current might have been changed; synchronize
				else
					l_l := Curl_base64_encode (l_data, passwd, l_plen, l_authpasswd)
					update_class_fields -- Current might have been changed; synchronize
					if not l_l.to_boolean then
						l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
					else
						l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("%%s"), l_authpasswd.item])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_authpasswd.item)])
						update_class_fields -- Current might have been changed; synchronize
						if not l_result.to_boolean then
							(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_AUTH)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				end
			end
			Result := l_result
		end

	smtp_state_authcram_resp (a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_chlg64: CE_POINTER [INTEGER_8]
			l_chlg: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_chlglen: NATURAL_32
			l_l: NATURAL_32
			l_rplyb64: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_ctxt: CE_POINTER [PD_HMAC_CONTEXT]
			l_digest: CE_ARRAY [NATURAL_8]
			l_reply: CE_ARRAY [INTEGER_8]
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_chlg.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_rplyb64.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_digest.make (<<16>>)
			create {CE_INTEGER_8_ARRAY} l_reply.make (<<289>>)

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			l_chlg64 := l_data.item.state.buffer
			if a_smtpcode /= 334 then
				l_data.item.Curl_failf ([ce_string ("Access denied: %%d"), a_smtpcode])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_LOGIN_DENIED)
				l_return := True
			end
			if not l_return then
				l_chlg64 := l_chlg64 + (4)
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_chlg64[0]).to_integer_32 /= 32 then
						if (l_chlg64[0]).to_integer_32 /= 9 then
							l_break := True
						end
					end
					if not (l_break) then
						l_chlg64 := l_chlg64 + 1
					end
				end
				l_break := False
				l_chlg.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_chlglen := (0).to_natural_32
				if (l_chlg64[0]).to_integer_32 /= 61 then
					l_l := strlen (l_chlg64)
					update_class_fields -- Current might have been changed; synchronize
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp := l_l
						l_l := l_l - 1
						if not l_tmp.to_boolean then
							l_break := True
						end
						if not (l_break) and then ((l_chlg64[l_l.to_integer_32]).to_integer_32 /= 13) then
							if (l_chlg64[l_l.to_integer_32]).to_integer_32 /= 10 then
								if (l_chlg64[l_l.to_integer_32]).to_integer_32 /= 32 then
									if (l_chlg64[l_l.to_integer_32]).to_integer_32 /= 9 then
										l_break := True
									end
								end
							end
						end
					end
					l_break := False
					l_l := l_l + 1
					if l_l.to_boolean then
						l_chlg64[l_l.to_integer_32] := (('%/0/').code).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_chlglen := Curl_base64_decode (l_chlg64, l_chlg)
						update_class_fields -- Current might have been changed; synchronize
						if not l_chlglen.to_boolean then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
					end
				end
			end
			if not l_return then
				l_tmp___0 := strlen (passwd)
				update_class_fields -- Current might have been changed; synchronize
				l_ctxt := Curl_HMAC_MD5.item.item.Curl_HMAC_init (create {CE_NATURAL_8_POINTER}.make_cast (passwd), l_tmp___0)
				update_class_fields -- Current might have been changed; synchronize
				if l_ctxt.is_void then
					if (not (l_chlg.item).is_void) then
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_chlg.item)])
						update_class_fields -- Current might have been changed; synchronize
					end
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				if l_chlglen > {NATURAL_32} 0 then
					Curl_HMAC_update (l_ctxt, l_chlg.item, l_chlglen).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				if (not (l_chlg.item).is_void) then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_chlg.item)])
					update_class_fields -- Current might have been changed; synchronize
				end
				Curl_HMAC_final (l_ctxt, l_digest).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_reply, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (289).to_natural_32), ce_string ("%%s %%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x%%02x"), user, (l_digest[0]).to_integer_32, (l_digest[1]).to_integer_32, (l_digest[2]).to_integer_32, (l_digest[3]).to_integer_32, (l_digest[4]).to_integer_32, (l_digest[5]).to_integer_32, (l_digest[6]).to_integer_32, (l_digest[7]).to_integer_32, (l_digest[8]).to_integer_32, (l_digest[9]).to_integer_32, (l_digest[10]).to_integer_32, (l_digest[11]).to_integer_32, (l_digest[12]).to_integer_32, (l_digest[13]).to_integer_32, (l_digest[14]).to_integer_32, (l_digest[15]).to_integer_32]).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_l := Curl_base64_encode (l_data, l_reply, (0).to_natural_32, l_rplyb64)
				update_class_fields -- Current might have been changed; synchronize
				if not l_l.to_boolean then
					l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
				else
					l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("%%s"), l_rplyb64.item])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_rplyb64.item)])
					update_class_fields -- Current might have been changed; synchronize
					if not l_result.to_boolean then
						(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_AUTH)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				Result := l_result
			end
		end

	smtp_state_auth_resp (a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			if a_smtpcode /= 235 then
				l_data.item.Curl_failf ([ce_string ("Authentication failed: %%d"), a_smtpcode])
				update_class_fields -- Current might have been changed; synchronize
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_STOP)
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l_result
		end

	smtp_mail: NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("MAIL FROM:%%s"), l_data.item.set.str[36]])
			update_class_fields -- Current might have been changed; synchronize
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_MAIL)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_result
			end
		end

	smtp_state_mail_resp (a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			if a_smtpcode // 100 /= 2 then
				l_data.item.Curl_failf ([ce_string ("Access denied: %%d"), a_smtpcode])
				update_class_fields -- Current might have been changed; synchronize
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED;
				(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_STOP)
				update_class_fields -- Current might have been changed; synchronize
			else
				l_smtpc := create {CE_CLASS_POINTER [PD_SMTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
				l_smtpc.item.rcpt := l_data.item.set.mail_rcpt
				update_class_fields -- Current might have been changed; synchronize
				l_result := smtp_rcpt_to ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l_result
		end

	smtp_state_rcpt_resp (a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			if a_smtpcode // 100 /= 2 then
				l_data.item.Curl_failf ([ce_string ("Access denied: %%d"), a_smtpcode])
				update_class_fields -- Current might have been changed; synchronize
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED;
				(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_STOP)
				update_class_fields -- Current might have been changed; synchronize
			else
				l_smtpc := create {CE_CLASS_POINTER [PD_SMTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
				if (not (l_smtpc.item.rcpt).is_void) then
					l_smtpc.item.rcpt := (l_smtpc.item.rcpt).item.next
					update_class_fields -- Current might have been changed; synchronize
					l_result := smtp_rcpt_to ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
					if l_result.to_boolean then
						Result := l_result
						l_return := True
					elseif (not (l_smtpc.item.rcpt).is_void) then
						Result := l_result
						l_return := True
					end
				end
				if not l_return then
					l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("DATA")])
					update_class_fields -- Current might have been changed; synchronize
					if l_result.to_boolean then
						Result := l_result
						l_return := True
					end
				end
				if not l_return then
					(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_DATA)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				Result := l_result
			end
		end

	smtp_state_data_resp (a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_smtp: CE_POINTER [PD_FTP]
			l_return: BOOLEAN
		do
			l_data := data
			l_smtp := l_data.item.state.proto.smtp
			if a_smtpcode /= 354 then
				(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_STOP)
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
				l_return := True
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (-1, (-1).to_integer_64, (0).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer), 0, l_smtp.item.bytecountp)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_STOP)
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	smtp_statemach_act: NATURAL_32
		local
			l_result: NATURAL_32
			l_sock: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_smtpcode: CE_ARRAY [INTEGER_32]
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_nread: CE_ARRAY [NATURAL_32]
			l_tmp: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_smtpcode.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_nread.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sock := sock[0]
					l_data := data
					l_smtpc := create {CE_CLASS_POINTER [PD_SMTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
					l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp"))
					l_nread.item := (0).to_natural_32
					update_class_fields -- Current might have been changed; synchronize
					if (l_pp.item.sendleft).to_boolean then
						l_tmp := Curl_pp_flushsend (l_pp)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp
						l_return := True
					end
					if not l_return then
						l_result := Curl_pp_readresp (l_sock, l_pp, l_smtpcode, l_nread)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if not (not l_return and then ((l_smtpcode.item).to_boolean)) then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						inspect (l_smtpc.item.state).to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						when 4 then l_pos := -1 + 5
						when 5 then l_pos := -1 + 6
						when 6 then l_pos := -1 + 7
						when 7 then l_pos := -1 + 8
						when 8 then l_pos := -1 + 9
						when 9 then l_pos := -1 + 10
						when 10 then l_pos := -1 + 11
						when 11 then l_pos := -1 + 12
						when 12 then l_pos := -1 + 13
						when 13 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 2 then -- switch 1, case 1
						if l_smtpcode.item // 100 /= 2 then
							l_data.item.Curl_failf ([ce_string ("Got unexpected smtp-server response: %%d"), l_smtpcode.item])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_FTP_WEIRD_SERVER_REPLY)
							l_return := True
						end
						if not l_return then
							l_result := smtp_state_ehlo ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
						l_pos := -1 + 16 -- switch 1; break
				when 3 then -- switch 1, case 2
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_state_ehlo_resp (l_smtpcode.item, l_smtpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 1; break
				when 4 then -- switch 1, case 3
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_state_helo_resp (l_smtpcode.item, l_smtpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 1; break
				when 5 then -- switch 1, case 4
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_state_starttls_resp (l_smtpcode.item, l_smtpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 1; break
				when 6 then -- switch 1, case 5
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_state_authplain_resp (l_smtpcode.item, l_smtpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 1; break
				when 7 then -- switch 1, case 6
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_state_authlogin_resp (l_smtpcode.item, l_smtpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 1; break
				when 8 then -- switch 1, case 7
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_state_authpasswd_resp (l_smtpcode.item, l_smtpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 1; break
				when 9 then -- switch 1, case 8
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_state_authcram_resp (l_smtpcode.item, l_smtpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 1; break
				when 10 then -- switch 1, case 9
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_state_auth_resp (l_smtpcode.item, l_smtpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 1; break
				when 11 then -- switch 1, case 10
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_state_mail_resp (l_smtpcode.item, l_smtpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 1; break
				when 12 then -- switch 1, case 11
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_state_rcpt_resp (l_smtpcode.item, l_smtpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 1; break
				when 13 then -- switch 1, case 12
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_state_data_resp (l_smtpcode.item, l_smtpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 1; break
				when 14 then -- switch 1, case 13
						l_result := smtp_state_postdata_resp ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), l_smtpcode.item, l_smtpc.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 1; break
				when 15 then -- switch 1, default:;
						(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_STOP)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 16 -- switch 1; break
				when 16 then -- switch 1, done: | if done
					if not l_return then
						Result := l_result
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	smtp_init: NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_smtp: CE_POINTER [PD_FTP]
			l_tmp: CE_POINTER [PD_FTP]
			l_tmp___0: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			l_data := data
			l_smtp := l_data.item.state.proto.smtp
			if l_smtp.is_void then
				l_tmp___0 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(create {PD_FTP}.make).structure_size.to_natural_32, (1).to_natural_32]))
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := create {CE_CLASS_POINTER [PD_FTP]}.make_cast (l_tmp___0)
				l_data.item.state.proto.smtp := l_tmp
				update_class_fields -- Current might have been changed; synchronize
				l_smtp := l_tmp
				if l_smtp.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				l_smtp.item.bytecountp := create {CE_INTEGER_64_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req") + (create {PD_SINGLEREQUEST}.make).offset_of ("bytecount"))
				update_class_fields -- Current might have been changed; synchronize
				l_smtp.item.user := user
				update_class_fields -- Current might have been changed; synchronize
				l_smtp.item.passwd := passwd
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	smtp_connect (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_result: NATURAL_32
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_path: CE_POINTER [INTEGER_8]
			l_len: CE_ARRAY [INTEGER_32]
			l_localhost: CE_ARRAY [INTEGER_8]
			l_http_proxy: CE_ARRAY [PD_HTTP]
			l_smtp_save: CE_POINTER [PD_FTP]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_len.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_localhost.make (<<1_025>>)
			create {CE_CLASS_ARRAY [PD_HTTP]} l_http_proxy.make (<<1>>)

			l_smtpc := create {CE_CLASS_POINTER [PD_SMTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			l_data := data
			l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp"))
			l_path := data.item.state.path
			a_done.item := (0).to_boolean
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_reset_reqproto
			update_class_fields -- Current might have been changed; synchronize
			l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_init
			update_class_fields -- Current might have been changed; synchronize
			if {NATURAL_32} 0 /= l_result then
				Result := l_result
				l_return := True
			end
			if not l_return then
				bits.close := (0).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.response_time := 1_800_000
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.statemach_act := smtp_statemach_act_address
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.endofresp := (create {PD_PINGPONG_STATIC}).smtp_endofresp_address
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.conn := (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
				if bits.tunnel_proxy then
					if bits.httpproxy then
						l_smtp_save := l_data.item.state.proto.smtp
						memset (create {CE_VOID_POINTER}.make_cast (l_http_proxy), 0, (create {PD_HTTP}.make).structure_size.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.state.proto.http := l_http_proxy
						update_class_fields -- Current might have been changed; synchronize
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_proxyCONNECT (0, host.name, remote_port)
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.state.proto.smtp := l_smtp_save
						update_class_fields -- Current might have been changed; synchronize
						if {NATURAL_32} 0 /= l_result then
							Result := l_result
							l_return := True
						end
					end
				end
			end
			if not l_return and then (((protocol).bit_and (((1).bit_shift_left (17)).to_integer_32)).to_boolean) then
				l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
				if l_result.to_boolean then
					Result := l_result
					l_return := True
				end
			end
			if not l_return then
				l_pp.item.Curl_pp_init
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.response_time := 1_800_000
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.statemach_act := smtp_statemach_act_address
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.endofresp := (create {PD_PINGPONG_STATIC}).smtp_endofresp_address
				update_class_fields -- Current might have been changed; synchronize
				l_pp.item.conn := (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
				if not (l_path[0]).to_boolean then
					l_tmp := Curl_gethostname (l_localhost, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (1_025).to_natural_32))
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						l_path := ce_string ("localhost")
					else
						l_path := l_localhost
					end
				end
				l_smtpc.item.domain := (create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_cast (data), l_path, 0, l_len)
				update_class_fields -- Current might have been changed; synchronize
				if (l_smtpc.item.domain).is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_SERVERGREET)
				update_class_fields -- Current might have been changed; synchronize
				if l_data.item.state.used_interface = {NATURAL_32} 2 then
					l_result := (create {P_SMTP_STATIC}).smtp_multi_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), a_done)
					update_class_fields -- Current might have been changed; synchronize
				else
					l_result := (create {P_SMTP_STATIC}).smtp_easy_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
					if not l_result.to_boolean then
						a_done.item := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				Result := l_result
			end
		end

	smtp_done (a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_smtp: CE_POINTER [PD_FTP]
			l_result: NATURAL_32
			l_bytes_written: CE_ARRAY [INTEGER_32]
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_bytes_written.make (<<1>>)

			l_data := data
			l_smtp := l_data.item.state.proto.smtp
			l_result := {PC_CURLCODE}.CURLE_OK
			if l_smtp.is_void then
				Result := ({PC_CURLCODE}.CURLE_OK)
				l_return := True
			end
			if not l_return then
				if a_status.to_boolean then
					bits.close := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
					l_result := a_status
				else
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_write (writesockfd, create {CE_VOID_POINTER}.make_cast (ce_string ("%R%N.%R%N")), (5).to_natural_32, l_bytes_written)
					update_class_fields -- Current might have been changed; synchronize
				end
				if a_status = {NATURAL_32} 0 then
					l_smtpc := create {CE_CLASS_POINTER [PD_SMTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
					l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp"))
					l_pp.item.response := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_SMTP_STATIC}).state___2 ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_SMTPSTATE}.SMTP_POSTDATA)
					update_class_fields -- Current might have been changed; synchronize
					l_result := (create {P_SMTP_STATIC}).smtp_easy_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
				end
				l_smtp.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_BODY
				update_class_fields -- Current might have been changed; synchronize
				Result := l_result
			end
		end

	smtp_perform (a_connected, a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_dophase_done.is_void
		local
			l_result: NATURAL_32
			l_smtp: CE_POINTER [PD_FTP]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			if data.item.set.opt_no_body then
				l_smtp := data.item.state.proto.smtp
				l_smtp.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_INFO
				update_class_fields -- Current might have been changed; synchronize
			end
			a_dophase_done.item := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_mail
			update_class_fields -- Current might have been changed; synchronize
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				if data.item.state.used_interface = {NATURAL_32} 2 then
					l_result := (create {P_SMTP_STATIC}).smtp_multi_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), a_dophase_done)
					update_class_fields -- Current might have been changed; synchronize
				else
					l_result := (create {P_SMTP_STATIC}).smtp_easy_statemach ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
					a_dophase_done.item := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
				end
				a_connected.item := bits.tcpconnect
				update_class_fields -- Current might have been changed; synchronize
				if a_dophase_done.item then
				end
				Result := l_result
			end
		end

	smtp_do (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_retcode: NATURAL_32
			l_return: BOOLEAN
		do
			l_retcode := {PC_CURLCODE}.CURLE_OK
			a_done.item := (0).to_boolean
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_reset_reqproto
			update_class_fields -- Current might have been changed; synchronize
			l_retcode := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_init
			update_class_fields -- Current might have been changed; synchronize
			if l_retcode.to_boolean then
				Result := l_retcode
				l_return := True
			end
			if not l_return then
				l_retcode := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_regular_transfer (a_done)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_retcode
			end
		end

	smtp_dophase_done (a_connected: BOOLEAN): NATURAL_32
		local
			l_smtp: CE_POINTER [PD_FTP]
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
		do
			l_smtp := data.item.state.proto.smtp
			l_smtpc := create {CE_CLASS_POINTER [PD_SMTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			if l_smtp.item.transfer /= {NATURAL_32} 0 then
				((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (-1, (-1).to_integer_64, (0).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer), -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_smtpc.item.domain)])
			update_class_fields -- Current might have been changed; synchronize
			l_smtpc.item.domain := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	smtp_regular_transfer (a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_dophase_done.is_void
		local
			l_result: NATURAL_32
			l_connected: CE_ARRAY [BOOLEAN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_return: BOOLEAN
		do
			create {CE_BOOLEAN_ARRAY} l_connected.make (<<1>>)

			l_result := {PC_CURLCODE}.CURLE_OK
			l_connected.item := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			l_data := data
			l_data.item.req.size := (-1).to_integer_64
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetUploadCounter ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetDownloadCounter ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetUploadSize ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_data.item.Curl_pgrsSetDownloadSize ((0).to_integer_64)
			update_class_fields -- Current might have been changed; synchronize
			l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_perform (l_connected, a_dophase_done)
			update_class_fields -- Current might have been changed; synchronize
			if {NATURAL_32} 0 = l_result then
				if not a_dophase_done.item then
					Result := ({PC_CURLCODE}.CURLE_OK)
					l_return := True
				end
				if not l_return then
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.smtp_dophase_done (l_connected.item)
					update_class_fields -- Current might have been changed; synchronize
					if l_result.to_boolean then
						Result := l_result
						l_return := True
					end
				end
			end
			if not l_return then
				Result := l_result
			end
		end

	smtp_setup_connection: NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_return: BOOLEAN
		do
			l_data := data
			if bits.httpproxy then
				if not l_data.item.set.tunnel_thru_httpproxy then
					if handler.is_equal ((create {P_SMTP_STATIC}).Curl_handler_smtp.item) then
						Current.handler := Curl_handler_smtp_proxy.item
						update_class_fields -- Current might have been changed; synchronize
					else
						l_data.item.Curl_failf ([ce_string ("SMTPS not supported!")])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_UNSUPPORTED_PROTOCOL)
						l_return := True
					end
					if not l_return then
						bits.close := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				l_data.item.state.path := (l_data.item.state.path) + 1
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_smtp_escape_eob (a_nread: INTEGER_32): NATURAL_32
		local
			l_nread: INTEGER_32
			l_i: INTEGER_32
			l_si: INTEGER_32
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_tmp: CE_POINTER [ANY]
			l_left: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			l_nread := a_nread
			l_smtpc := create {CE_CLASS_POINTER [PD_SMTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			l_data := data
			if (l_data.item.state.scratch).is_void then
				l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(32_768).to_natural_32]))
				update_class_fields -- Current might have been changed; synchronize
				l_data.item.state.scratch := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)
				update_class_fields -- Current might have been changed; synchronize
			end
			if (l_data.item.state.scratch).is_void then
				l_data.item.Curl_failf ([ce_string ("Failed to alloc scratch buffer!")])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				l_return := True
			end
			if not l_return then
				l_i := 0
				l_si := 0
				from
				until
					not (not (l_break) and then (l_i < l_nread))
				loop
					l_break := False
					l_continue := False
					l_left := l_nread - l_i
					if l_left >= ({NATURAL_32} 5 - l_smtpc.item.eob).to_integer_32 then
						l_tmp___0 := memcmp (create {CE_VOID_POINTER}.make_cast ((ce_string ("%R%N.%R%N") + (l_smtpc.item.eob).to_integer_32)), create {CE_VOID_POINTER}.make_cast ((l_data.item.req.upload_fromhere + l_i)), {NATURAL_32} 5 - l_smtpc.item.eob)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___0.to_boolean then
							memcpy (create {CE_VOID_POINTER}.make_cast ((l_data.item.state.scratch + l_si)), create {CE_VOID_POINTER}.make_cast (ce_string ("%R%N..")), (4).to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_si := l_si + (3)
							l_i := (l_i.to_natural_32 + ((({NATURAL_32} 5 - l_smtpc.item.eob) - {NATURAL_32} 1) - {NATURAL_32} 2)).to_integer_32
							l_smtpc.item.eob := (0).to_natural_32
							update_class_fields -- Current might have been changed; synchronize
							l_continue := True
						end
					else
						l_tmp___1 := memcmp (create {CE_VOID_POINTER}.make_cast ((ce_string ("%R%N.%R%N") + (l_smtpc.item.eob).to_integer_32)), create {CE_VOID_POINTER}.make_cast ((l_data.item.req.upload_fromhere + l_i)), l_left.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___1.to_boolean then
							l_smtpc.item.eob := l_smtpc.item.eob + l_left.to_natural_32
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
					end
					if not (l_break or l_continue) then
						l_data.item.state.scratch[l_si] := l_data.item.req.upload_fromhere[l_i]
						update_class_fields -- Current might have been changed; synchronize
					end
					if (not l_break) then
						l_i := l_i + 1
						l_si := l_si + 1
					end
				end
				l_break := False
				l_continue := False
				if l_si /= l_nread then
					l_nread := l_si
					l_data.item.req.upload_fromhere := l_data.item.state.scratch
					update_class_fields -- Current might have been changed; synchronize
					l_data.item.req.upload_present := l_nread
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	rtsp_getsock_do (a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		require
			not a_socks.is_void
		do
			a_socks[0] := sock[0]
			update_class_fields -- Current might have been changed; synchronize
			Result := ((1).bit_shift_left (16))
		end

	Curl_rtsp_connect (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		local
			l_httpStatus: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			l_data := data
			l_httpStatus := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_http_connect (a_done)
			update_class_fields -- Current might have been changed; synchronize
			if l_data.item.state.rtsp_next_client_CSeq = 0 then
				l_data.item.state.rtsp_next_client_CSeq := 1
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_data.item.state.rtsp_next_server_CSeq = 0 then
				l_data.item.state.rtsp_next_server_CSeq := 1
				update_class_fields -- Current might have been changed; synchronize
			end
			proto.rtspc.rtp_channel := -1
			update_class_fields -- Current might have been changed; synchronize
			Result := l_httpStatus
		end

	Curl_rtsp_disconnect: NATURAL_32
		do
			(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (proto.rtspc.rtp_buf))
			update_class_fields -- Current might have been changed; synchronize
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	Curl_rtsp_done (a_status: NATURAL_32; a_premature: BOOLEAN): NATURAL_32
		local
			l_premature: BOOLEAN
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_rtsp: CE_POINTER [PD_RTSP]
			l_httpStatus: NATURAL_32
			l_CSeq_sent: INTEGER_32
			l_CSeq_recv: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_premature := a_premature
					l_data := data
					l_rtsp := l_data.item.state.proto.rtsp
					if l_data.item.set.rtspreq = {NATURAL_32} 11 then
						l_premature := (1).to_boolean
					end
					l_httpStatus := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_http_done (a_status, l_premature)
					update_class_fields -- Current might have been changed; synchronize
					if l_rtsp.is_void then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_CSeq_sent := l_rtsp.item.CSeq_sent
						l_CSeq_recv := l_rtsp.item.CSeq_recv
						if l_data.item.set.rtspreq = {NATURAL_32} 11 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_CSeq_sent /= l_CSeq_recv then
							l_data.item.Curl_failf ([ce_string ("The CSeq of this request %%ld did not match the response %%ld"), l_CSeq_sent, l_CSeq_recv])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_RTSP_CSEQ_ERROR)
							l_return := True
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_data.item.set.rtspreq = {NATURAL_32} 11 then
							if proto.rtspc.rtp_channel = -1 then
								(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Got an RTP Receive with a CSeq of %%ld%N"), l_CSeq_recv])
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 5 then -- if done
					if not l_return then
						Result := l_httpStatus
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_rtsp (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_result: NATURAL_32
			l_rtspreq: NATURAL_32
			l_rtsp: CE_POINTER [PD_RTSP]
			l_http: CE_POINTER [PD_HTTP]
			l_req_buffer: CE_POINTER [PD_CURL_SEND_BUFFER]
			l_postsize: INTEGER_64
			l_putsize: INTEGER_64
			l_p_request: CE_POINTER [INTEGER_8]
			l_p_session_id: CE_POINTER [INTEGER_8]
			l_p_accept: CE_POINTER [INTEGER_8]
			l_p_accept_encoding: CE_POINTER [INTEGER_8]
			l_p_range: CE_POINTER [INTEGER_8]
			l_p_referrer: CE_POINTER [INTEGER_8]
			l_p_stream_uri: CE_POINTER [INTEGER_8]
			l_p_transport: CE_POINTER [INTEGER_8]
			l_p_uagent: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_tmp___18: NATURAL_32
			l_tmp___19: INTEGER_64
			l_tmp___20: INTEGER_64
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_tmp___22: CE_POINTER [INTEGER_8]
			l_tmp___23: CE_POINTER [INTEGER_8]
			l_tmp___24: CE_POINTER [INTEGER_64]
			l_tmp___25: INTEGER_32
			l_tmp___26: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [PD_HTTP]} l_http.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := data
					l_result := {PC_CURLCODE}.CURLE_OK
					l_rtspreq := l_data.item.set.rtspreq
					l_postsize := (0).to_integer_64
					l_putsize := (0).to_integer_64
					l_p_request := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_p_session_id := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_p_accept := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_p_accept_encoding := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_p_range := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_p_referrer := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_p_stream_uri := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_p_transport := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_p_uagent := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					a_done.item := (1).to_boolean
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_reset_reqproto
					update_class_fields -- Current might have been changed; synchronize
					if (l_data.item.state.proto.rtsp).is_void then
						l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_RTSP}.make).structure_size.to_natural_32]))
						update_class_fields -- Current might have been changed; synchronize
						l_rtsp := create {CE_CLASS_POINTER [PD_RTSP]}.make_cast (l_tmp)
						if l_rtsp.is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							l_data.item.state.proto.rtsp := l_rtsp
							update_class_fields -- Current might have been changed; synchronize
						end
					else
						l_rtsp := l_data.item.state.proto.rtsp
					end
					if l_return then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_http := create {CE_CLASS_POINTER [PD_HTTP]}.make_shared (l_rtsp.c_pointer + (create {PD_RTSP}.make).offset_of ("http_wrapper"))
						l_rtsp.item.CSeq_sent := l_data.item.state.rtsp_next_client_CSeq
						update_class_fields -- Current might have been changed; synchronize
						l_rtsp.item.CSeq_recv := 0
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.set.opt_no_body := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						inspect l_rtspreq.to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 3
						when 2 then l_pos := -1 + 4
						when 3 then l_pos := -1 + 5
						when 4 then l_pos := -1 + 6
						when 5 then l_pos := -1 + 7
						when 6 then l_pos := -1 + 8
						when 7 then l_pos := -1 + 9
						when 8 then l_pos := -1 + 10
						when 9 then l_pos := -1 + 11
						when 10 then l_pos := -1 + 12
						when 11 then l_pos := -1 + 13
						when 12 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 2 then -- switch 1, case 0
						l_data.item.Curl_failf ([ce_string ("Got invalid RTSP request: RTSPREQ_NONE")])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
						l_return := True
				when 3 then -- switch 1, case 1
						if not l_return then
							l_p_request := ce_string ("OPTIONS")
						end
						l_pos := -1 + 15 -- switch 1; break
				when 4 then -- switch 1, case 2
						l_p_request := ce_string ("DESCRIBE")
						l_data.item.set.opt_no_body := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 15 -- switch 1; break
				when 5 then -- switch 1, case 3
						l_p_request := ce_string ("ANNOUNCE")
						l_pos := -1 + 15 -- switch 1; break
				when 6 then -- switch 1, case 4
						l_p_request := ce_string ("SETUP")
						l_pos := -1 + 15 -- switch 1; break
				when 7 then -- switch 1, case 5
						l_p_request := ce_string ("PLAY")
						l_pos := -1 + 15 -- switch 1; break
				when 8 then -- switch 1, case 6
						l_p_request := ce_string ("PAUSE")
						l_pos := -1 + 15 -- switch 1; break
				when 9 then -- switch 1, case 7
						l_p_request := ce_string ("TEARDOWN")
						l_pos := -1 + 15 -- switch 1; break
				when 10 then -- switch 1, case 8
						l_p_request := ce_string ("GET_PARAMETER")
						l_pos := -1 + 15 -- switch 1; break
				when 11 then -- switch 1, case 9
						l_p_request := ce_string ("SET_PARAMETER")
						l_pos := -1 + 15 -- switch 1; break
				when 12 then -- switch 1, case 10
						l_p_request := ce_string ("RECORD")
						l_pos := -1 + 15 -- switch 1; break
				when 13 then -- switch 1, case 11
						l_p_request := ce_string ("")
						l_data.item.set.opt_no_body := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 15 -- switch 1; break
				when 14 then -- switch 1, case 12
						l_data.item.Curl_failf ([ce_string ("Got invalid RTSP request: RTSPREQ_LAST")])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
						l_return := True
				when 15 then -- switch 1, done: | if done
					if not l_return and then (l_rtspreq = {NATURAL_32} 11) then
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (0, (-1).to_integer_64, (1).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("readbytecount")), -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						Result := l_result
						l_return := True
					end
					if not l_return then
						l_p_session_id := l_data.item.set.str[33]
						if l_p_session_id.is_void then
							if ((l_rtspreq).bit_and ({NATURAL_32} 4_294_967_288)).to_boolean then
								if (not l_p_request.is_void) then
									l_tmp___0 := l_p_request
								else
									l_tmp___0 := ce_string ("")
								end
								l_data.item.Curl_failf ([ce_string ("Refusing to issue an RTSP request [%%s] without a session ID."), l_tmp___0])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
								l_return := True
							end
						end
					end
					if not l_return then
						if (not (l_data.item.set.str[34]).is_void) then
							l_p_stream_uri := l_data.item.set.str[34]
						else
							l_p_stream_uri := ce_string ("*")
						end
						l_tmp___1 := Curl_checkheaders (l_data, ce_string ("Transport:"))
						update_class_fields -- Current might have been changed; synchronize
						l_p_transport := l_tmp___1
						if l_rtspreq = {NATURAL_32} 4 then
							if l_p_transport.is_void then
								if (not (l_data.item.set.str[35]).is_void) then
									(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (allocptr.rtsp_transport))
									update_class_fields -- Current might have been changed; synchronize
									allocptr.rtsp_transport := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("Transport: %%s%R%N"), l_data.item.set.str[35]])
									update_class_fields -- Current might have been changed; synchronize
									if (allocptr.rtsp_transport).is_void then
										Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
										l_return := True
									end
								else
									l_data.item.Curl_failf ([ce_string ("Refusing to issue an RTSP SETUP without a Transport: header.")])
									update_class_fields -- Current might have been changed; synchronize
									Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
									l_return := True
								end
								if not l_return then
									l_p_transport := allocptr.rtsp_transport
								end
							end
						end
					end
					if not l_return and then (l_rtspreq = {NATURAL_32} 2) then
						l_tmp___3 := Curl_checkheaders (l_data, ce_string ("Accept:"))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp___3.is_void) then
							l_p_accept := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_p_accept := ce_string ("Accept: application/sdp%R%N")
						end
						l_tmp___4 := Curl_checkheaders (l_data, ce_string ("Accept-Encoding:"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___4.is_void then
							if (not (l_data.item.set.str[6]).is_void) then
								(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (allocptr.accept_encoding))
								update_class_fields -- Current might have been changed; synchronize
								allocptr.accept_encoding := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("Accept-Encoding: %%s%R%N"), l_data.item.set.str[6]])
								update_class_fields -- Current might have been changed; synchronize
								if (allocptr.accept_encoding).is_void then
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									l_return := True
								end
								if not l_return then
									l_p_accept_encoding := allocptr.accept_encoding
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 21 -- skip if block
					end
				when 16 then -- if:
						l_tmp___6 := Curl_checkheaders (l_data, ce_string ("User-Agent:"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___6.is_void then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if (not (allocptr.uagent).is_void) then
							(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (allocptr.uagent))
							update_class_fields -- Current might have been changed; synchronize
							allocptr.uagent := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 19 -- goto _L
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L:
						l_tmp___5 := Curl_checkheaders (l_data, ce_string ("User-Agent:"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___5.is_void then
							if (not (l_data.item.set.str[25]).is_void) then
								l_p_uagent := allocptr.uagent
							end
						end
				when 20 then;
						(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (allocptr.ref))
						update_class_fields -- Current might have been changed; synchronize
						if (not (l_data.item.change.referer).is_void) then
							l_tmp___7 := Curl_checkheaders (l_data, ce_string ("Referer:"))
							update_class_fields -- Current might have been changed; synchronize
							if (not l_tmp___7.is_void) then
								allocptr.ref := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								update_class_fields -- Current might have been changed; synchronize
							else
								allocptr.ref := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("Referer: %%s%R%N"), l_data.item.change.referer])
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							allocptr.ref := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_p_referrer := allocptr.ref
						if l_data.item.state.use_range then
							if ((l_rtspreq).bit_and ({NATURAL_32} 15)).to_boolean then
								l_tmp___8 := Curl_checkheaders (l_data, ce_string ("Range:"))
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___8.is_void then
									if (not (l_data.item.state.range).is_void) then
										(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (allocptr.rangeline))
										update_class_fields -- Current might have been changed; synchronize
										allocptr.rangeline := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("Range: %%s%R%N"), l_data.item.state.range])
										update_class_fields -- Current might have been changed; synchronize
										l_p_range := allocptr.rangeline
									end
								end
							end
						end
						l_tmp___9 := Curl_checkheaders (l_data, ce_string ("CSeq:"))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp___9.is_void) then
							l_data.item.Curl_failf ([ce_string ("CSeq cannot be set as a custom header.")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_RTSP_CSEQ_ERROR)
							l_return := True
						end
				when 21 then -- if done
					if not l_return then
						l_tmp___10 := Curl_checkheaders (l_data, ce_string ("Session:"))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp___10.is_void) then
							l_data.item.Curl_failf ([ce_string ("Session ID cannot be set as a custom header.")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
							l_return := True
						end
					end
					if not l_return then
						l_req_buffer := Curl_add_buffer_init
						update_class_fields -- Current might have been changed; synchronize
						if l_req_buffer.is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
					end
					if not l_return then
						if (not l_p_request.is_void) then
							l_tmp___11 := l_p_request
						else
							l_tmp___11 := ce_string ("")
						end
						l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("%%s %%s RTSP/1.0%R%NCSeq: %%ld%R%N"), l_tmp___11, l_p_stream_uri, l_rtsp.item.CSeq_sent])
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if not l_return and then (not l_p_session_id.is_void) then
						l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Session: %%s%R%N"), l_p_session_id])
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if not l_return then
						if (not l_p_uagent.is_void) then
							l_tmp___12 := l_p_uagent
						else
							l_tmp___12 := ce_string ("")
						end
						if (not l_p_referrer.is_void) then
							l_tmp___13 := l_p_referrer
						else
							l_tmp___13 := ce_string ("")
						end
						if (not l_p_range.is_void) then
							l_tmp___14 := l_p_range
						else
							l_tmp___14 := ce_string ("")
						end
						if (not l_p_accept_encoding.is_void) then
							l_tmp___15 := l_p_accept_encoding
						else
							l_tmp___15 := ce_string ("")
						end
						if (not l_p_accept.is_void) then
							l_tmp___16 := l_p_accept
						else
							l_tmp___16 := ce_string ("")
						end
						if (not l_p_transport.is_void) then
							l_tmp___17 := l_p_transport
						else
							l_tmp___17 := ce_string ("")
						end
						l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("%%s%%s%%s%%s%%s%%s"), l_tmp___17, l_tmp___16, l_tmp___15, l_tmp___14, l_tmp___13, l_tmp___12])
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 27 -- skip if block
					end
				when 22 then -- if:
						if l_rtspreq /= {NATURAL_32} 4 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L___0
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 25 then -- else:
						if l_rtspreq /= {NATURAL_32} 2 then
							l_pos := -1 + 27 -- skip if block
						end
				when 26 then -- if: | _L___0:
						l_result := Curl_add_timecondition (l_data, l_req_buffer)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
				when 27 then -- if done | if done
					if not l_return then
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_add_custom_headers (l_req_buffer)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 48 -- skip if block
					end
				when 28 then -- if:
						if l_rtspreq /= {NATURAL_32} 3 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						l_pos := -1 + 35 -- goto _L___3
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 31 then -- else:
						if l_rtspreq /= {NATURAL_32} 9 then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 35 -- goto _L___3
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 34 then -- else:
						if l_rtspreq /= {NATURAL_32} 8 then
							l_pos := -1 + 48 -- skip if block
						end
				when 35 then -- if: | _L___3:
						if l_data.item.set.upload then
							l_putsize := l_data.item.set.infilesize
							l_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_PUT
							update_class_fields -- Current might have been changed; synchronize
						else
							if l_data.item.set.postfieldsize /= -{INTEGER_64} 1 then
								l_postsize := l_data.item.set.postfieldsize
							else
								if (not (l_data.item.set.postfields).is_void) then
									l_tmp___18 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_data.item.set.postfields))
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___19 := l_tmp___18.to_integer_64
								else
									l_tmp___19 := (0).to_integer_64
								end
								l_postsize := l_tmp___19
							end
							l_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_POST
							update_class_fields -- Current might have been changed; synchronize
						end
						if not (l_putsize > {INTEGER_64} 0) then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						l_pos := -1 + 39 -- goto _L___2
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 38 then -- else:
						if not (l_postsize > {INTEGER_64} 0) then
							l_pos := -1 + 47 -- skip if block
						end
				when 39 then -- if: | _L___2:
						l_tmp___21 := Curl_checkheaders (l_data, ce_string ("Content-Length:"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___21.is_void then
							if l_data.item.set.upload then
								l_tmp___20 := l_putsize
							else
								l_tmp___20 := l_postsize
							end
							l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Content-Length: %%lld%R%N"), l_tmp___20])
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
						if l_return then
							l_pos := -1 + 45 -- skip if block
						end
				when 40 then -- if:
						if l_rtspreq /= {NATURAL_32} 9 then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						l_pos := -1 + 44 -- goto _L___1
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 43 then -- else:
						if l_rtspreq /= {NATURAL_32} 8 then
							l_pos := -1 + 45 -- skip if block
						end
				when 44 then -- if: | _L___1:
						l_tmp___22 := Curl_checkheaders (l_data, ce_string ("Content-Type:"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___22.is_void then
							l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Content-Type: text/parameters%R%N")])
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
				when 45 then -- if done | if done
						if not l_return and then (l_rtspreq = {NATURAL_32} 3) then
							l_tmp___23 := Curl_checkheaders (l_data, ce_string ("Content-Type:"))
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___23.is_void then
								l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Content-Type: application/sdp%R%N")])
								update_class_fields -- Current might have been changed; synchronize
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
							end
						end
						if not l_return then
							l_data.item.state.expect100header := (0).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
				when 46 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 47 then -- else:
						if l_rtspreq = {NATURAL_32} 8 then
							l_data.item.set.httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_HEAD
							update_class_fields -- Current might have been changed; synchronize
							l_data.item.set.opt_no_body := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
				when 48 then -- if done | if done | if done | if done | if done
					if not l_return then
						l_data.item.req.forbidchunk := (1).to_boolean
						update_class_fields -- Current might have been changed; synchronize
						l_result := Curl_add_buffer (l_req_buffer, create {CE_VOID_POINTER}.make_cast (ce_string ("%R%N")), (2).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if not l_return and then (l_postsize > {INTEGER_64} 0) then
						l_result := Curl_add_buffer (l_req_buffer, l_data.item.set.postfields, l_postsize.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if not l_return then
						l_result := Curl_add_buffer_send (l_req_buffer, (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), create {CE_INTEGER_32_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("info") + (create {PD_PUREINFO}.make).offset_of ("request_size")), (0).to_natural_32, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							l_data.item.Curl_failf ([ce_string ("Failed sending RTSP request")])
							update_class_fields -- Current might have been changed; synchronize
							Result := l_result
							l_return := True
						end
					end
					if not l_return then
						if l_putsize.to_boolean then
							l_tmp___24 := create {CE_INTEGER_64_POINTER}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("writebytecount"))
						else
							l_tmp___24 := create {CE_INTEGER_64_POINTER}.make_shared (default_pointer)
						end
						if l_putsize.to_boolean then
							l_tmp___25 := 0
						else
							l_tmp___25 := -1
						end
						((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (0, (-1).to_integer_64, (1).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (l_http.c_pointer + (create {PD_HTTP}.make).offset_of ("readbytecount")), l_tmp___25, l_tmp___24)
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.state.rtsp_next_client_CSeq := (l_data.item.state.rtsp_next_client_CSeq) + 1
						update_class_fields -- Current might have been changed; synchronize
						if (l_http.item.writebytecount).to_boolean then
							l_data.item.Curl_pgrsSetUploadCounter (l_http.item.writebytecount)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___26 := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_pgrsUpdate
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___26.to_boolean then
								l_result := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
							end
						end
						Result := l_result
					end
				when 49 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_rtsp_parseheader (a_header: CE_POINTER [INTEGER_8]): NATURAL_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_CSeq: CE_ARRAY [INTEGER_32]
			l_nc: INTEGER_32
			l_temp: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_start: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___1: NATURAL_32
			l_tmp___2: INTEGER_32
			l_end: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___5: NATURAL_32
			l_tmp___6: INTEGER_32
			l_tmp___7: NATURAL_32
			l_tmp___8: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_CSeq.make (<<1>>)

			l_data := data
			l_CSeq.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___7 := strlen (ce_string ("CSeq:"))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___8 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("CSeq:"), a_header, l_tmp___7)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___8.to_boolean then
				l_tmp := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([a_header]))
				update_class_fields -- Current might have been changed; synchronize
				l_temp := l_tmp
				if l_temp.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
				if not l_return then
					Curl_strntoupper (l_temp, l_temp, {PLATFORM}.Pointer_bytes.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_nc := sscanf ([l_temp, ce_string ("CSEQ: %%ld"), l_CSeq])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_temp)])
					update_class_fields -- Current might have been changed; synchronize
					if l_nc = 1 then
						(l_data.item.state.proto.rtsp).item.CSeq_recv := l_CSeq.item
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.state.rtsp_CSeq_recv := l_CSeq.item
						update_class_fields -- Current might have been changed; synchronize
					else
						l_data.item.Curl_failf ([ce_string ("Unable to read the CSeq header: [%%s]"), a_header])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_RTSP_CSEQ_ERROR)
						l_return := True
					end
				end
			else
				l_tmp___5 := strlen (ce_string ("Session:"))
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___6 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Session:"), a_header, l_tmp___5)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___6.to_boolean then
					l_start := a_header + 9
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_start[0]).to_boolean then
							l_tmp___0 := ctype_b_loc
							update_class_fields -- Current might have been changed; synchronize
							if not (((l_tmp___0.item[((l_start[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_start := l_start + 1
						end
					end
					l_break := False
					if not (l_start[0]).to_boolean then
						l_data.item.Curl_failf ([ce_string ("Got a blank Session ID")])
						update_class_fields -- Current might have been changed; synchronize
					elseif (not (l_data.item.set.str[33]).is_void) then
						l_tmp___1 := strlen (l_data.item.set.str[33])
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := strncmp (l_start, l_data.item.set.str[33], l_tmp___1)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2 /= 0 then
							l_data.item.Curl_failf ([ce_string ("Got RTSP Session ID Line [%%s], but wanted ID [%%s]"), l_start, l_data.item.set.str[33]])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_RTSP_SESSION_ERROR)
							l_return := True
						end
					else
						l_end := l_start
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_end[0]).to_boolean then
								l_tmp___3 := ctype_b_loc
								update_class_fields -- Current might have been changed; synchronize
								if not (((l_tmp___3.item[((l_end[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
									if (l_end[0]).to_integer_32 /= 45 then
										if (l_end[0]).to_integer_32 /= 95 then
											if (l_end[0]).to_integer_32 /= 46 then
												if (l_end[0]).to_integer_32 /= 43 then
													if (l_end[0]).to_integer_32 = 92 then
														if (l_end[1]).to_boolean then
															if (l_end[1]).to_integer_32 = 36 then
																l_end := l_end + 1
															else
																l_break := True
															end
														else
															l_break := True
														end
													else
														l_break := True
													end
												end
											end
										end
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_end := l_end + 1
							end
						end
						l_break := False
						l_tmp___4 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([((l_end.distance (l_start)) + 1).to_natural_32]))
						update_class_fields -- Current might have been changed; synchronize
						l_data.item.set.str[33] := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___4)
						update_class_fields -- Current might have been changed; synchronize
						if (l_data.item.set.str[33]).is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							memcpy (create {CE_VOID_POINTER}.make_cast (l_data.item.set.str[33]), create {CE_VOID_POINTER}.make_cast (l_start), (l_end.distance (l_start)).to_natural_32).do_nothing
							update_class_fields; -- Current might have been changed; synchronize
							(l_data.item.set.str[33])[(l_end.distance (l_start))] := (('%/0/').code).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				end
			end
			if not l_return then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	gopher_do (a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_sockfd: INTEGER_32
			l_bytecount: CE_POINTER [INTEGER_64]
			l_path: CE_POINTER [INTEGER_8]
			l_sel: CE_POINTER [INTEGER_8]
			l_sel_org: CE_POINTER [INTEGER_8]
			l_amount: CE_ARRAY [INTEGER_32]
			l_k: INTEGER_32
			l_newp: CE_POINTER [INTEGER_8]
			l_j: NATURAL_32
			l_i: NATURAL_32
			l_len: CE_ARRAY [INTEGER_32]
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_amount.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_len.make (<<1>>)

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data := data
			l_sockfd := sock[0]
			l_bytecount := create {CE_INTEGER_64_POINTER}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req") + (create {PD_SINGLEREQUEST}.make).offset_of ("bytecount"))
			l_path := l_data.item.state.path
			l_sel_org := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			a_done.item := (1).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := strlen (l_path)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp <= {NATURAL_32} 2 then
				l_sel := ce_string ("")
			else
				l_newp := l_path
				l_newp := l_newp + (2)
				l_j := strlen (l_newp)
				update_class_fields -- Current might have been changed; synchronize
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_j)
				loop
					if (l_newp[l_i.to_integer_32]).to_integer_32 = 63 then
						l_newp[l_i.to_integer_32] := (('%T').code).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
					end
					l_i := l_i + 1
				end
				l_sel := (create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_cast (l_data), l_newp, 0, l_len)
				update_class_fields -- Current might have been changed; synchronize
				if l_sel.is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
				if not l_return then
					l_sel_org := l_sel
				end
			end
			if not l_return then
				l_tmp___0 := strlen (l_sel)
				update_class_fields -- Current might have been changed; synchronize
				l_k := l_tmp___0.to_integer_32
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_write (l_sockfd, create {CE_VOID_POINTER}.make_cast (l_sel), l_k.to_natural_32, l_amount)
					update_class_fields -- Current might have been changed; synchronize
					if {NATURAL_32} 0 = l_result then
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write ((1).bit_shift_left (1), l_sel, (l_amount.item).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_sel_org))
							update_class_fields -- Current might have been changed; synchronize
							Result := l_result
							l_return := True
						end
						if not l_return then
							l_k := l_k - (l_amount.item)
							l_sel := l_sel + (l_amount.item)
							if l_k < 1 then
								l_break := True
							end
						end
					else
						l_data.item.Curl_failf ([ce_string ("Failed sending Gopher request")])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_sel_org))
						update_class_fields -- Current might have been changed; synchronize
						Result := l_result
						l_return := True
					end
					if not (l_return or l_break) then
						(create {P_SELECT_STATIC}).Curl_socket_ready (-1, l_sockfd, 100).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				l_break := False;
				(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_sel_org))
				update_class_fields -- Current might have been changed; synchronize
				l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_sendf ([l_sockfd, ce_string ("%R%N")])
				update_class_fields -- Current might have been changed; synchronize
				if l_result /= {NATURAL_32} 0 then
					l_data.item.Curl_failf ([ce_string ("Failed sending Gopher request")])
					update_class_fields -- Current might have been changed; synchronize
					Result := l_result
					l_return := True
				end
			end
			if not l_return then
				l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_client_write ((1).bit_shift_left (1), ce_string ("%R%N"), (2).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				if l_result.to_boolean then
					Result := l_result
					l_return := True
				end
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.Curl_setup_transfer (0, (-1).to_integer_64, (0).to_boolean, l_bytecount, -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	ftp_state_cwd: NATURAL_32
		local
			l_result: NATURAL_32
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
					if not (l_ftpc.item.cwddone) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_cwd
						update_class_fields -- Current might have been changed; synchronize
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						l_ftpc.item.count2 := 0
						update_class_fields -- Current might have been changed; synchronize
						if data.item.set.ftp_create_missing_dirs = 2 then
							l_ftpc.item.count3 := 1
							update_class_fields -- Current might have been changed; synchronize
						else
							l_ftpc.item.count3 := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						if not (bits.reuse) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (not (l_ftpc.item.entrypath).is_void) then
							l_ftpc.item.count1 := 0
							update_class_fields -- Current might have been changed; synchronize
							l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc") + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("CWD %%s"), l_ftpc.item.entrypath])
							update_class_fields -- Current might have been changed; synchronize
							if l_result /= {NATURAL_32} 0 then
								Result := l_result
								l_return := True
							end
							if not l_return then
								state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_CWD)
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if (l_ftpc.item.dirdepth).to_boolean then
							l_ftpc.item.count1 := 1
							update_class_fields -- Current might have been changed; synchronize
							l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc") + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("CWD %%s"), l_ftpc.item.dirs[(l_ftpc.item.count1 - 1)]])
							update_class_fields -- Current might have been changed; synchronize
							if l_result /= {NATURAL_32} 0 then
								Result := l_result
								l_return := True
							end
							if not l_return then
								state ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer)), {PC_FTPSTATE}.FTP_CWD)
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_post_cwd
							update_class_fields -- Current might have been changed; synchronize
						end
				when 7 then -- if done
					if not l_return then
						Result := l_result
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_state_post_retrtype: NATURAL_32
		local
			l_result: NATURAL_32
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_quote ((1).to_boolean, {PC_FTPSTATE}.FTP_RETR_PREQUOTE)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_result
		end

	ftp_state_post_stortype: NATURAL_32
		local
			l_result: NATURAL_32
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_result := ((create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (c_pointer))).item.ftp_state_quote ((1).to_boolean, {PC_FTPSTATE}.FTP_STOR_PREQUOTE)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_result
		end

feature {PD_CONNECTDATA_STATIC} -- private routines

	curl_strnequal (a_first, a_second: CE_POINTER [INTEGER_8]; a_max: NATURAL_32): INTEGER_32
		require
			not a_first.is_void
			not a_second.is_void
		local
			l_tmp___0: INTEGER_32
		do
			if (strncasecmp (a_first, a_second, a_max)).to_boolean then
				l_tmp___0 := 0
			else
				l_tmp___0 := 1
			end
			Result := l_tmp___0
		end

	Curl_gethostname (a_name: CE_POINTER [INTEGER_8]; a_namelen: NATURAL_32): INTEGER_32
		require
			not a_name.is_void
		do
			Result := (gethostname (a_name, a_namelen))
		end

	Curl_base64_encode (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_inputbuff: CE_POINTER [INTEGER_8]; a_insize: NATURAL_32; a_outptr: CE_POINTER [CE_POINTER [INTEGER_8]]): NATURAL_32
		require
			not a_outptr.is_void
		local
			l_insize: NATURAL_32
			l_ibuf: CE_ARRAY [NATURAL_8]
			l_obuf: CE_ARRAY [NATURAL_8]
			l_i: INTEGER_32
			l_inputparts: INTEGER_32
			l_output: CE_POINTER [INTEGER_8]
			l_base64data: CE_POINTER [INTEGER_8]
			l_indata: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_ibuf.make (<<3>>)
			create {CE_NATURAL_8_ARRAY} l_obuf.make (<<4>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_insize := a_insize
					l_indata := a_inputbuff
					a_outptr.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					if {NATURAL_32} 0 = l_insize then
						l_insize := strlen (l_indata)
					end
					l_output := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(l_insize * {NATURAL_32} 4) // {NATURAL_32} 3 + {NATURAL_32} 4]))))
					l_base64data := l_output
					if l_output.is_void then
						Result := (0).to_natural_32
						l_return := True
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not (l_return) and then (l_insize > {NATURAL_32} 0)) then
							l_pos := -1 + 7 -- skip loop
						end
				when 2 then -- loop body:
						l_inputparts := 0
						l_i := l_inputparts
						from
						until
							not (l_i < 3)
						loop
							if l_insize > {NATURAL_32} 0 then
								l_inputparts := l_inputparts + 1
								l_ibuf[l_i] := (l_indata[0]).to_natural_8
								l_indata := l_indata + 1
								l_insize := l_insize - 1
							else
								l_ibuf[l_i] := (0).to_natural_8
							end
							l_i := l_i + 1
						end
						l_obuf[0] := (((((l_ibuf[0]).to_integer_32).bit_and (252))).bit_shift_right (2)).to_natural_8
						l_obuf[1] := (((((((l_ibuf[0]).to_integer_32).bit_and (3))).bit_shift_left (4))).bit_or ((((((l_ibuf[1]).to_integer_32).bit_and (240))).bit_shift_right (4)))).to_natural_8
						l_obuf[2] := (((((((l_ibuf[1]).to_integer_32).bit_and (15))).bit_shift_left (2))).bit_or ((((((l_ibuf[2]).to_integer_32).bit_and (192))).bit_shift_right (6)))).to_natural_8
						l_obuf[3] := (((l_ibuf[2]).to_integer_32).bit_and (63)).to_natural_8
						inspect l_inputparts -- switch 1 head
						when 1 then l_pos := -1 + 3
						when 2 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 3 then -- switch 1, case 1;
						(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_output, (5).to_natural_32, ce_string ("%%c%%c=="), (table64.item[(l_obuf[0]).to_integer_32]).to_integer_32, (table64.item[(l_obuf[1]).to_integer_32]).to_integer_32]).do_nothing
						l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 2;
						(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_output, (5).to_natural_32, ce_string ("%%c%%c%%c="), (table64.item[(l_obuf[0]).to_integer_32]).to_integer_32, (table64.item[(l_obuf[1]).to_integer_32]).to_integer_32, (table64.item[(l_obuf[2]).to_integer_32]).to_integer_32]).do_nothing
						l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:;
						(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_output, (5).to_natural_32, ce_string ("%%c%%c%%c%%c"), (table64.item[(l_obuf[0]).to_integer_32]).to_integer_32, (table64.item[(l_obuf[1]).to_integer_32]).to_integer_32, (table64.item[(l_obuf[2]).to_integer_32]).to_integer_32, (table64.item[(l_obuf[3]).to_integer_32]).to_integer_32]).do_nothing
						l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
						l_output := l_output + (4)
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
						l_output[0] := (0).to_integer_8
						a_outptr.item := l_base64data
						Result := (strlen (l_base64data))
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_printable_address (a_ai: CE_POINTER [PD_CURL_ADDRINFO]; a_buf: CE_POINTER [INTEGER_8]; a_bufsize: NATURAL_32): CE_POINTER [INTEGER_8]
		require
			not a_ai.is_void
		local
			l_sa4: CE_POINTER [SD_SOCKADDR_IN]
			l_ipaddr4: CE_POINTER [SD_IN_ADDR]
			l_sa6: CE_POINTER [SD_SOCKADDR_IN6]
			l_ipaddr6: CE_POINTER [SD_IN6_ADDR]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_ai.item.ai_family -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					l_sa4 := create {CE_CLASS_POINTER [SD_SOCKADDR_IN]}.make_cast (a_ai.item.ai_addr)
					l_ipaddr4 := create {CE_CLASS_POINTER [SD_IN_ADDR]}.make_shared (l_sa4.c_pointer + (create {SD_SOCKADDR_IN}.make).offset_of ("sin_addr"))
					Result := (inet_ntop (a_ai.item.ai_family, create {CE_VOID_POINTER}.make_cast (l_ipaddr4), a_buf, a_bufsize))
					l_return := True
				when 2 then -- switch 1, case 10
					if not l_return then
						l_sa6 := create {CE_CLASS_POINTER [SD_SOCKADDR_IN6]}.make_cast (a_ai.item.ai_addr)
						l_ipaddr6 := create {CE_CLASS_POINTER [SD_IN6_ADDR]}.make_shared (l_sa6.c_pointer + (create {SD_SOCKADDR_IN6}.make).offset_of ("sin6_addr"))
						Result := (inet_ntop (a_ai.item.ai_family, create {CE_VOID_POINTER}.make_cast (l_ipaddr6), a_buf, a_bufsize))
						l_return := True
					end
				when 3 then -- switch 1, default:
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					if not l_return then
						Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	freedirs (a_ftpc: CE_POINTER [PD_FTP_CONN])
		require
			not a_ftpc.is_void
		local
			l_i: INTEGER_32
		do
			if (not (a_ftpc.item.dirs).is_void) then
				l_i := 0
				from
				until
					not (l_i < a_ftpc.item.dirdepth)
				loop
					if (not (a_ftpc.item.dirs[l_i]).is_void) then
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_ftpc.item.dirs[l_i])])
						a_ftpc.item.dirs[l_i] := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					end
					l_i := l_i + 1
				end
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_ftpc.item.dirs)])
				a_ftpc.item.dirs := create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer)
				a_ftpc.item.dirdepth := 0
			end
			if (not (a_ftpc.item.file).is_void) then
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_ftpc.item.file)])
				a_ftpc.item.file := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			end
		end

	ftp_easy_statemach (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_result: NATURAL_32
			l_break: BOOLEAN
		do
			l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
			l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))
			l_result := {PC_CURLCODE}.CURLE_OK
			from
			until
				not (not (l_break) and then (l_ftpc.item.state /= {NATURAL_32} 0))
			loop
				l_break := False
				l_result := l_pp.item.Curl_pp_easy_statemach
				if l_result.to_boolean then
					l_break := True
				end
			end
			l_break := False
			Result := l_result
		end

	tftp_state_machine (a_state___3: CE_POINTER [PD_TFTP_STATE_DATA]; a_event: INTEGER_32): NATURAL_32
		require
			not a_state___3.is_void
		local
			l_res: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_res := {PC_CURLCODE}.CURLE_OK
					l_data := (a_state___3.item.conn).item.data
					inspect (a_state___3.item.state).to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 0
					l_res := a_state___3.item.tftp_send_first (a_event)
					l_pos := -1 + 6 -- switch 1; break
				when 2 then -- switch 1, case 1
					l_res := a_state___3.item.tftp_rx (a_event)
					l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 2
					l_res := a_state___3.item.tftp_tx (a_event)
					l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 3;
					(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("%%s%N"), ce_string ("TFTP finished")])
					l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
					l_data.item.Curl_failf ([ce_string ("%%s"), ce_string ("Internal state machine error")])
					l_res := {PC_CURLCODE}.CURLE_TFTP_ILLEGAL
					l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
					Result := l_res
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	curlx_nonblock (a_sockfd, a_nonblock: INTEGER_32): INTEGER_32
		local
			l_flags: INTEGER_32
		do
			l_flags := fcntl ([a_sockfd, 3, 0])
			if 0 /= a_nonblock then
				Result := (fcntl ([a_sockfd, 4, (l_flags).bit_or (2_048)]))
			else
				Result := (fcntl ([a_sockfd, 4, (l_flags).bit_and (-2_049)]))
			end
		end

	Curl_pp_flushsend (a_pp: CE_POINTER [PD_PINGPONG]): NATURAL_32
		require
			not a_pp.is_void
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_written: CE_ARRAY [INTEGER_32]
			l_result: NATURAL_32
			l_sock: INTEGER_32
			l_tmp: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_written.make (<<1>>)

			l_conn := a_pp.item.conn
			l_result := {PC_CURLCODE}.CURLE_OK
			l_sock := l_conn.item.sock[0]
			l_result := l_conn.item.Curl_write (l_sock, create {CE_VOID_POINTER}.make_cast (((a_pp.item.sendthis + (a_pp.item.sendsize).to_integer_32) - (a_pp.item.sendleft).to_integer_32)), a_pp.item.sendleft, l_written)
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				if l_written.item /= (a_pp.item.sendleft).to_integer_32 then
					a_pp.item.sendleft := a_pp.item.sendleft - (l_written.item).to_natural_32
				else
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_pp.item.sendthis)])
					a_pp.item.sendthis := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_tmp := (0).to_natural_32
					a_pp.item.sendsize := l_tmp
					a_pp.item.sendleft := l_tmp
					a_pp.item.response := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
				end
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_add_buffer_init: CE_POINTER [PD_CURL_SEND_BUFFER]
		do
			Result := (create {CE_CLASS_POINTER [PD_CURL_SEND_BUFFER]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_CURL_SEND_BUFFER}.make).structure_size.to_natural_32])))))
		end

	Curl_add_buffer_send (a_in: CE_POINTER [PD_CURL_SEND_BUFFER]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_bytes_written: CE_POINTER [INTEGER_32]; a_included_body_bytes: NATURAL_32; a_socketindex: INTEGER_32): NATURAL_32
		require
			not a_in.is_void
			not a_conn.is_void
		local
			l_amount: CE_ARRAY [INTEGER_32]
			l_res: NATURAL_32
			l_ptr: CE_POINTER [INTEGER_8]
			l_size: NATURAL_32
			l_http: CE_POINTER [PD_HTTP]
			l_sendsize: NATURAL_32
			l_sockfd: INTEGER_32
			l_headersize: NATURAL_32
			l_headlen: NATURAL_32
			l_tmp: NATURAL_32
			l_bodylen: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_amount.make (<<1>>)

			l_http := (a_conn.item.data).item.state.proto.http
			l_sockfd := a_conn.item.sock[a_socketindex]
			l_ptr := a_in.item.buffer
			l_size := a_in.item.size_used
			l_headersize := l_size - a_included_body_bytes
			if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean then
				if l_size > {NATURAL_32} 16_384 then
					l_sendsize := (16_384).to_natural_32
				else
					l_sendsize := l_size
				end
				memcpy (create {CE_VOID_POINTER}.make_cast (((a_conn.item.data).item.state.uploadbuffer)), create {CE_VOID_POINTER}.make_cast (l_ptr), l_sendsize).do_nothing
				l_ptr := (a_conn.item.data).item.state.uploadbuffer
			else
				l_sendsize := l_size
			end
			l_res := a_conn.item.Curl_write (l_sockfd, create {CE_VOID_POINTER}.make_cast (l_ptr), l_sendsize, l_amount)
			if {NATURAL_32} 0 = l_res then
				if (l_amount.item).to_natural_32 > l_headersize then
					l_tmp := l_headersize
				else
					l_tmp := (l_amount.item).to_natural_32
				end
				l_headlen := l_tmp
				l_bodylen := (l_amount.item).to_natural_32 - l_headlen
				if (a_conn.item.data).item.set.verbose then
					(a_conn.item.data).item.Curl_debug ({PC_CURL_INFOTYPE}.CURLINFO_HEADER_OUT, l_ptr, l_headlen, a_conn).do_nothing
					if (l_amount.item).to_natural_32 > l_headlen then
						(a_conn.item.data).item.Curl_debug ({PC_CURL_INFOTYPE}.CURLINFO_DATA_OUT, l_ptr + l_headlen.to_integer_32, l_bodylen, a_conn).do_nothing
					end
				end
				if l_bodylen.to_boolean then
					l_http.item.writebytecount := l_http.item.writebytecount + l_bodylen.to_integer_64
				end
				a_bytes_written.item := a_bytes_written.item + (l_amount.item).to_integer_32
				if (not l_http.is_void) then
					if (l_amount.item).to_natural_32 /= l_size then
						l_size := l_size - (l_amount.item).to_natural_32
						l_ptr := a_in.item.buffer + l_amount.item
						l_http.item.backup.fread_func := a_conn.item.fread_func
						l_http.item.backup.fread_in := a_conn.item.fread_in
						l_http.item.backup.postdata := l_http.item.postdata
						l_http.item.backup.postsize := l_http.item.postsize
						a_conn.item.fread_func := (create {P_HTTP_STATIC}).readmoredata_address
						a_conn.item.fread_in := create {CE_VOID_POINTER}.make_cast (a_conn)
						l_http.item.postdata := l_ptr
						l_http.item.postsize := l_size.to_integer_64
						l_http.item.send_buffer := create {CE_VOID_POINTER}.make_cast (a_in)
						l_http.item.sending := {PC_SENDING}.HTTPSEND_REQUEST
						Result := ({PC_CURLCODE}.CURLE_OK)
						l_return := True
					end
					if not l_return then
						l_http.item.sending := {PC_SENDING}.HTTPSEND_BODY
					end
				elseif (l_amount.item).to_natural_32 /= l_size then
					Result := ({PC_CURLCODE}.CURLE_SEND_ERROR)
					l_return := True
				else
					a_conn.item.writechannel_inuse := (0).to_boolean
				end
			end
			if not l_return then
				if (not (a_in.item.buffer).is_void) then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_in.item.buffer)])
				end
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_in)])
				Result := l_res
			end
		end

	Curl_add_timecondition (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_req_buffer: CE_POINTER [PD_CURL_SEND_BUFFER]): NATURAL_32
		require
			not a_data.is_void
		local
			l_tm: CE_POINTER [SD_TM]
			l_buf: CE_POINTER [INTEGER_8]
			l_result: NATURAL_32
			l_keeptime: CE_ARRAY [SD_TM]
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_TM]} l_keeptime.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf := a_data.item.state.buffer
					l_result := {PC_CURLCODE}.CURLE_OK
					l_tm := (gmtime_r ((create {CE_INTEGER_32_POINTER}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("timevalue"))), l_keeptime))
					if (l_tm.item.tm_wday).to_boolean then
						l_tmp___0 := l_tm.item.tm_wday - 1
					else
						l_tmp___0 := 6
					end
					(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_buf, (16_383).to_natural_32, ce_string ("%%s, %%02d %%s %%4d %%02d:%%02d:%%02d GMT"), (create {P_PARSEDATE_STATIC}).Curl_wkday.item[l_tmp___0], l_tm.item.tm_mday, (create {P_PARSEDATE_STATIC}).Curl_month.item[l_tm.item.tm_mon], l_tm.item.tm_year + 1_900, l_tm.item.tm_hour, l_tm.item.tm_min, l_tm.item.tm_sec]).do_nothing
					inspect (a_data.item.set.timecondition).to_integer_32 -- switch 1 head
					when 2 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					else l_pos := -1 + 1
					end
				when 1 then -- switch 1, default:
					l_result := Curl_add_bufferf ([a_req_buffer, ce_string ("If-Modified-Since: %%s%R%N"), l_buf])
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_result := Curl_add_bufferf ([a_req_buffer, ce_string ("If-Unmodified-Since: %%s%R%N"), l_buf])
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 3
					l_result := Curl_add_bufferf ([a_req_buffer, ce_string ("Last-Modified: %%s%R%N"), l_buf])
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					Result := l_result
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	isBadFtpString (a_string: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_string.is_void
		local
			l_tmp___1: INTEGER_32
		do
			if not (strchr (a_string, ('%R').code)).is_void then
				l_tmp___1 := 1
			elseif not (strchr (a_string, ('%N').code)).is_void then
				l_tmp___1 := 1
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1.to_boolean
		end

	ftp_readresp (a_sockfd: INTEGER_32; a_pp: CE_POINTER [PD_PINGPONG]; a_ftpcode: CE_POINTER [INTEGER_32]; a_size: CE_POINTER [NATURAL_32]): NATURAL_32
		require
			not a_pp.is_void
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_result: NATURAL_32
			l_code: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_code.make (<<1>>)

			l_conn := a_pp.item.conn
			l_result := {PC_CURLCODE}.CURLE_OK
			l_result := Curl_pp_readresp (a_sockfd, a_pp, l_code, a_size);
			(l_conn.item.data).item.info.httpcode := l_code.item
			if (not a_ftpcode.is_void) then
				a_ftpcode.item := l_code.item
			end
			Result := l_result
		end

	Curl_pp_readresp (a_sockfd: INTEGER_32; a_pp: CE_POINTER [PD_PINGPONG]; a_code: CE_POINTER [INTEGER_32]; a_size: CE_POINTER [NATURAL_32]): NATURAL_32
		require
			not a_pp.is_void
			not a_code.is_void
			not a_size.is_void
		local
			l_perline: INTEGER_32
			l_keepon: BOOLEAN
			l_gotbytes: CE_ARRAY [INTEGER_32]
			l_ptr: CE_POINTER [INTEGER_8]
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_buf: CE_POINTER [INTEGER_8]
			l_result: NATURAL_32
			l_res: INTEGER_32
			l_i: INTEGER_32
			l_clipamount: INTEGER_32
			l_restart: BOOLEAN
			l_meow: CE_POINTER [INTEGER_8]
			l_n: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_gotbytes.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_keepon := (1).to_boolean
					l_conn := a_pp.item.conn
					l_data := l_conn.item.data
					l_buf := l_data.item.state.buffer
					l_result := {PC_CURLCODE}.CURLE_OK
					a_code.item := 0
					a_size.item := (0).to_natural_32
					l_ptr := l_buf + (a_pp.item.nread_resp).to_integer_32
					l_perline := l_ptr.distance ((a_pp.item.linestart_resp))
					l_keepon := (1).to_boolean
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 21 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if a_pp.item.nread_resp < {NATURAL_32} 16_384 then
							if l_keepon then
								if l_result.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 20 -- skip if block
						end
				when 3 then -- if:
						if (not (a_pp.item.cache).is_void) then
							memcpy (create {CE_VOID_POINTER}.make_cast (l_ptr), create {CE_VOID_POINTER}.make_cast (a_pp.item.cache), a_pp.item.cache_size).do_nothing
							l_gotbytes.item := (a_pp.item.cache_size).to_integer_32;
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_pp.item.cache)])
							a_pp.item.cache := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							a_pp.item.cache_size := (0).to_natural_32
						else
							l_res := (l_conn.item.Curl_read (a_sockfd, l_ptr, {NATURAL_32} 16_384 - a_pp.item.nread_resp, l_gotbytes)).to_integer_32
							if l_res = 81 then
								Result := ({PC_CURLCODE}.CURLE_OK)
								l_return := True
							end
							if not l_return and then (0 /= l_res) then
								l_result := l_res.to_natural_32
								l_keepon := (0).to_boolean
							end
						end
						if not (not l_return and then (l_keepon)) then
							l_pos := -1 + 20 -- skip if block
						end
				when 4 then -- if:
						if not (l_gotbytes.item <= 0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_keepon := (0).to_boolean
						l_result := {PC_CURLCODE}.CURLE_RECV_ERROR
						l_data.item.Curl_failf ([ce_string ("FTP response reading failed")])
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 7 then -- else:
						l_clipamount := 0
						l_restart := (0).to_boolean
						l_data.item.req.headerbytecount := l_data.item.req.headerbytecount + (l_gotbytes.item).to_integer_32
						a_pp.item.nread_resp := a_pp.item.nread_resp + (l_gotbytes.item).to_natural_32
						l_i := 0
						from
						until
							not (not (l_return or l_break) and then (l_i < l_gotbytes.item))
						loop
							l_break := False
							l_perline := l_perline + 1
							if (l_ptr[0]).to_integer_32 = 10 then
								if l_data.item.set.verbose then
									l_data.item.Curl_debug ({PC_CURL_INFOTYPE}.CURLINFO_HEADER_IN, a_pp.item.linestart_resp, l_perline.to_natural_32, l_conn).do_nothing
								end
								l_result := l_conn.item.Curl_client_write ((1).bit_shift_left (1), a_pp.item.linestart_resp, l_perline.to_natural_32)
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
								if not l_return then
									if ((a_pp.item.endofresp).integer_32_item ([a_pp, a_code])).to_boolean then
										l_meow := a_pp.item.linestart_resp
										l_n := 0
										from
										until
											not ((l_meow.c_pointer.to_integer_32).to_natural_32 < (l_ptr.c_pointer.to_integer_32).to_natural_32)
										loop
											l_buf[l_n] := l_meow[0]
											l_meow := l_meow + 1
											l_n := l_n + 1
										end
										l_meow[0] := (0).to_integer_8
										l_keepon := (0).to_boolean
										a_pp.item.linestart_resp := l_ptr + 1
										l_i := l_i + 1
										a_size.item := a_pp.item.nread_resp
										a_pp.item.nread_resp := (0).to_natural_32
										l_break := True
									end
									if not (l_return or l_break) then
										l_perline := 0
										a_pp.item.linestart_resp := l_ptr + 1
									end
								end
							end
							if not (l_return or l_break) then
								l_ptr := l_ptr + 1
								l_i := l_i + 1
							end
						end
						if l_return then
							l_pos := -1 + 19 -- skip if block
						end
				when 8 then -- if:
						l_break := False
						if l_keepon then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if l_i /= l_gotbytes.item then
							l_clipamount := l_gotbytes.item - l_i
							l_restart := (1).to_boolean
						else
							l_pos := -1 + 11 -- goto _L___0
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 11 then -- else: | _L___0:
						if not l_keepon then
							l_pos := -1 + 17 -- skip if block
						end
				when 12 then -- if:
						if l_perline /= l_gotbytes.item then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_gotbytes.item > 8_192 then
							(create {P_SENDF_STATIC}).Curl_infof ([l_data, ce_string ("Excessive server response line length received, %%zd bytes. Stripping%N"), l_gotbytes.item])
							l_restart := (1).to_boolean
							l_clipamount := 40
						else
							l_pos := -1 + 15 -- goto _L
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L:
						if a_pp.item.nread_resp > {NATURAL_32} 8_192 then
							l_clipamount := l_perline
							l_restart := (1).to_boolean
						end
				when 16 then -- if done | if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						if l_i = l_gotbytes.item then
							l_restart := (1).to_boolean
						end
				when 18 then -- if done
						if l_clipamount.to_boolean then
							a_pp.item.cache_size := l_clipamount.to_natural_32
							a_pp.item.cache := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([a_pp.item.cache_size]))))
							if (not (a_pp.item.cache).is_void) then
								memcpy (create {CE_VOID_POINTER}.make_cast (a_pp.item.cache), create {CE_VOID_POINTER}.make_cast (a_pp.item.linestart_resp), a_pp.item.cache_size).do_nothing
							else
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								l_return := True
							end
						end
				when 19 then -- if done
						if not l_return and then l_restart then
							a_pp.item.nread_resp := (0).to_natural_32
							l_tmp___2 := l_buf
							a_pp.item.linestart_resp := l_tmp___2
							l_ptr := l_tmp___2
							l_perline := 0
						end
				when 20 then -- if done | if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 21 then -- loop done
					if not l_return then
						l_break := False
						a_pp.item.pending_resp := (0).to_boolean
						Result := l_result
					end
				when 22 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_state_pwd (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_return: BOOLEAN
		do
			l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc") + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("PWD"), create {CE_VOID_POINTER}.make_shared (default_pointer)])
			if l_result /= {NATURAL_32} 0 then
				Result := l_result
				l_return := True
			end
			if not l_return then
				state (a_conn, {PC_FTPSTATE}.FTP_PWD)
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	ftp_nb_type (a_conn: CE_POINTER [PD_CONNECTDATA]; a_ascii: BOOLEAN; a_newstate: NATURAL_32): NATURAL_32
		local
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_result: NATURAL_32
			l_want: INTEGER_8
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
			if a_ascii then
				l_tmp := ('A').code
			else
				l_tmp := ('I').code
			end
			l_want := l_tmp.to_integer_8
			if (l_ftpc.item.transfertype).to_integer_32 = l_want.to_integer_32 then
				state (a_conn, a_newstate)
				Result := (a_conn.item.ftp_state_type_resp (200, a_newstate))
				l_return := True
			end
			if not l_return then
				l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("TYPE %%c"), l_want.to_integer_32])
				if l_result /= {NATURAL_32} 0 then
					Result := l_result
					l_return := True
				end
			end
			if not l_return then
				state (a_conn, a_newstate)
				l_ftpc.item.transfertype := l_want
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_if2ip (a_af: INTEGER_32; a_interface, a_buf: CE_POINTER [INTEGER_8]; a_buf_size: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_iface: CE_POINTER [SD_IFADDRS]
			l_head: CE_ARRAY [CE_POINTER [SD_IFADDRS]]
			l_ip: CE_POINTER [INTEGER_8]
			l_addr: CE_POINTER [ANY]
			l_scope: CE_ARRAY [INTEGER_8]
			l_scopeid: NATURAL_32
			l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [SD_IFADDRS]} l_head.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_scope.make (<<12>>)

			l_ip := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			if (getifaddrs (l_head)) >= 0 then
				l_iface := l_head.item
				from
				until
					not (not (l_break) and then (not l_iface.is_void))
				loop
					l_break := False
					if not (l_iface.item.ifa_addr).is_void then
						if ((l_iface.item.ifa_addr).item.sa_family).to_integer_32 = a_af then
							if ((create {P_STREQUAL_STATIC}).curl_strequal (l_iface.item.ifa_name, a_interface)).to_boolean then
								l_scope[0] := (('%/0/').code).to_integer_8
								l_scope[1] := (0).to_integer_8
								l_scope[2] := (0).to_integer_8
								l_scope[3] := (0).to_integer_8
								l_scope[4] := (0).to_integer_8
								l_scope[5] := (0).to_integer_8
								l_scope[6] := (0).to_integer_8
								l_scope[7] := (0).to_integer_8
								l_scope[8] := (0).to_integer_8
								l_scope[9] := (0).to_integer_8
								l_scope[10] := (0).to_integer_8
								l_scope[11] := (0).to_integer_8
								if a_af = 10 then
									l_scopeid := {NATURAL_32} 0
									l_addr := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN6_ADDR]}.make_shared ((create {CE_CLASS_POINTER [SD_SOCKADDR_IN6]}.make_cast (l_iface.item.ifa_addr)).c_pointer + (create {SD_SOCKADDR_IN6}.make).offset_of ("sin6_addr"))))
									l_scopeid := (create {CE_CLASS_POINTER [SD_SOCKADDR_IN6]}.make_cast (l_iface.item.ifa_addr)).item.sin6_scope_id
									if l_scopeid.to_boolean then
										(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_scope, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (12).to_natural_32), ce_string ("%%%%%%u"), l_scopeid]).do_nothing
									end
								else
									l_addr := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN_ADDR]}.make_shared ((create {CE_CLASS_POINTER [SD_SOCKADDR_IN]}.make_cast (l_iface.item.ifa_addr)).c_pointer + (create {SD_SOCKADDR_IN}.make).offset_of ("sin_addr"))))
								end
								l_ip := (inet_ntop (a_af, l_addr, a_buf, a_buf_size.to_natural_32))
								Curl_strlcat (a_buf, l_scope, a_buf_size.to_natural_32).do_nothing
								l_break := True
							end
						end
					end
					if not (l_break) then
						l_iface := l_iface.item.ifa_next
					end
				end
				l_break := False
				freeifaddrs (l_head.item)
			end
			Result := l_ip
		end

	Curl_strlcat (a_dst, a_src: CE_POINTER [INTEGER_8]; a_siz: NATURAL_32): NATURAL_32
		require
			not a_src.is_void
		local
			l_d: CE_POINTER [INTEGER_8]
			l_s: CE_POINTER [INTEGER_8]
			l_n: NATURAL_32
			l_dlen: PD_DLEN
			l_tmp: NATURAL_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			create l_dlen.make

			l_d := a_dst
			l_s := a_src
			l_n := a_siz
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp := l_n
				l_n := l_n - 1
				if l_tmp /= {NATURAL_32} 0 then
					if (l_d[0]).to_integer_32 = 0 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_d := l_d + 1
				end
			end
			l_break := False
			l_dlen.sig := l_d.distance (a_dst)
			l_dlen.update_class_fields -- synchronize union
			l_n := a_siz - l_dlen.uns
			if l_n = {NATURAL_32} 0 then
				Result := (l_dlen.uns + (strlen (l_s)))
				l_return := True
			end
			if not l_return then
				from
				until
					(l_s[0]).to_integer_32 = 0
				loop
					if l_n /= {NATURAL_32} 1 then
						l_tmp___1 := l_d
						l_d := l_d + 1
						l_tmp___1[0] := l_s[0]
						l_n := l_n - 1
					end
					l_s := l_s + 1
				end
				l_d[0] := (('%/0/').code).to_integer_8
				Result := (l_dlen.uns + (l_s.distance (a_src)).to_natural_32)
			end
		end

	verifyconnect (a_sockfd: INTEGER_32; a_error: CE_POINTER [INTEGER_32]): BOOLEAN
		local
			l_rc: BOOLEAN
			l_err: CE_ARRAY [INTEGER_32]
			l_errSize: CE_ARRAY [NATURAL_32]
		do
			create {CE_INTEGER_32_ARRAY} l_err.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_errSize.make (<<1>>)

			l_rc := (1).to_boolean
			l_err.item := 0
			l_errSize.item := {PLATFORM}.Integer_32_bytes.to_natural_32
			if 0 /= (getsockopt (a_sockfd, 1, 4, create {CE_VOID_POINTER}.make_cast (l_err), l_errSize)) then
				l_err.item := (errno_location).item
			end
			if 0 = l_err.item then
				l_rc := (1).to_boolean
			elseif 106 = l_err.item then
				l_rc := (1).to_boolean
			else
				l_rc := (0).to_boolean
			end
			if (not a_error.is_void) then
				a_error.item := l_err.item
			end
			Result := l_rc
		end

	tftp_translate_code (a_error: INTEGER_32): NATURAL_32
		local
			l_code: NATURAL_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_code := {PC_CURLCODE}.CURLE_OK
					if a_error = -100 then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						inspect a_error -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						when 0 then l_pos := -1 + 5
						when 4 then l_pos := -1 + 5
						when 5 then l_pos := -1 + 6
						when 6 then l_pos := -1 + 7
						when 7 then l_pos := -1 + 8
						when -99 then l_pos := -1 + 9 -- -99
						when -98 then l_pos := -1 + 10 -- -98
						else l_pos := -1 + 11
						end
				when 2 then -- switch 1, case 1
						l_code := {PC_CURLCODE}.CURLE_TFTP_NOTFOUND
						l_pos := -1 + 12 -- switch 1; break
				when 3 then -- switch 1, case 2
						l_code := {PC_CURLCODE}.CURLE_TFTP_PERM
						l_pos := -1 + 12 -- switch 1; break
				when 4 then -- switch 1, case 3
						l_code := {PC_CURLCODE}.CURLE_REMOTE_DISK_FULL
						l_pos := -1 + 12 -- switch 1; break
				when 5 then -- switch 1, case 0 | switch 1, case 4
						l_code := {PC_CURLCODE}.CURLE_TFTP_ILLEGAL
						l_pos := -1 + 12 -- switch 1; break
				when 6 then -- switch 1, case 5
						l_code := {PC_CURLCODE}.CURLE_TFTP_UNKNOWNID
						l_pos := -1 + 12 -- switch 1; break
				when 7 then -- switch 1, case 6
						l_code := {PC_CURLCODE}.CURLE_REMOTE_FILE_EXISTS
						l_pos := -1 + 12 -- switch 1; break
				when 8 then -- switch 1, case 7
						l_code := {PC_CURLCODE}.CURLE_TFTP_NOSUCHUSER
						l_pos := -1 + 12 -- switch 1; break
				when 9 then -- switch 1, case -99
						l_code := {PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT
						l_pos := -1 + 12 -- switch 1; break
				when 10 then -- switch 1, case -98
						l_code := {PC_CURLCODE}.CURLE_COULDNT_CONNECT
						l_pos := -1 + 12 -- switch 1; break
				when 11 then -- switch 1, default:
						l_code := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
						l_pos := -1 + 12 -- switch 1; break
				when 12 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						l_code := {PC_CURLCODE}.CURLE_OK
				when 14 then -- if done
					Result := l_code
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_strntoupper (a_dest, a_src: CE_POINTER [INTEGER_8]; a_n: NATURAL_32)
		local
			l_dest: CE_POINTER [INTEGER_8]
			l_src: CE_POINTER [INTEGER_8]
			l_n: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			l_dest := a_dest
			l_src := a_src
			l_n := a_n
			if l_n < {NATURAL_32} 1 then
				l_return := True
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp := l_dest
					l_dest := l_dest + 1
					l_tmp[0] := (create {P_RAWSTR_STATIC}).Curl_raw_toupper (l_src[0])
					l_tmp___0 := l_src
					l_src := l_src + 1
					if (l_tmp___0[0]).to_boolean then
						l_n := l_n - 1
						if not l_n.to_boolean then
							l_break := True
						end
					else
						l_break := True
					end
				end
				l_break := False
			end
		end

	smtp_state_ehlo (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_return: BOOLEAN
		do
			l_smtpc := create {CE_CLASS_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			l_smtpc.item.authmechs := {NATURAL_32} 0
			l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("EHLO %%s"), l_smtpc.item.domain])
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				(create {P_SMTP_STATIC}).state___2 (a_conn, {PC_SMTPSTATE}.SMTP_EHLO)
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	smtp_rcpt_to (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_smtpc := create {CE_CLASS_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			if (not (l_smtpc.item.rcpt).is_void) then
				if ((l_smtpc.item.rcpt).item.data[0]).to_integer_32 = 60 then
					l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("RCPT TO:%%s"), (l_smtpc.item.rcpt).item.data])
				else
					l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("RCPT TO:<%%s>"), (l_smtpc.item.rcpt).item.data])
				end
				if not l_result.to_boolean then
					(create {P_SMTP_STATIC}).state___2 (a_conn, {PC_SMTPSTATE}.SMTP_RCPT)
				end
			end
			Result := l_result
		end

	Curl_base64_decode (a_src: CE_POINTER [INTEGER_8]; a_outptr: CE_POINTER [CE_POINTER [NATURAL_8]]): NATURAL_32
		require
			not a_src.is_void
			not a_outptr.is_void
		local
			l_src: CE_POINTER [INTEGER_8]
			l_length: NATURAL_32
			l_equalsTerm: NATURAL_32
			l_i: NATURAL_32
			l_numQuantums: NATURAL_32
			l_lastQuantum: CE_ARRAY [NATURAL_8]
			l_rawlen: NATURAL_32
			l_newstr: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_lastQuantum.make (<<3>>)

			l_src := a_src
			l_length := (0).to_natural_32
			l_equalsTerm := (0).to_natural_32
			l_rawlen := (0).to_natural_32
			a_outptr.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_src[l_length.to_integer_32]).to_integer_32 /= 61 then
					if not (l_src[l_length.to_integer_32]).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_length := l_length + 1
				end
			end
			l_break := False
			if (l_src[l_length.to_integer_32]).to_integer_32 = 61 then
				l_equalsTerm := l_equalsTerm + 1
				if (l_src[(l_length + l_equalsTerm).to_integer_32]).to_integer_32 = 61 then
					l_equalsTerm := l_equalsTerm + 1
				end
			end
			l_numQuantums := (l_length + l_equalsTerm) // {NATURAL_32} 4
			if l_numQuantums = {NATURAL_32} 0 then
				Result := (0).to_natural_32
				l_return := True
			end
			if not l_return then
				l_rawlen := l_numQuantums * {NATURAL_32} 3 - l_equalsTerm
				l_newstr := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([l_rawlen + {NATURAL_32} 4]))))
				if l_newstr.is_void then
					Result := (0).to_natural_32
					l_return := True
				end
			end
			if not l_return then
				a_outptr.item := l_newstr
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_numQuantums - {NATURAL_32} 1)
				loop
					decodeQuantum (l_newstr, l_src)
					l_newstr := l_newstr + (3)
					l_src := l_src + (4)
					l_i := l_i + 1
				end
				decodeQuantum (l_lastQuantum, l_src)
				l_i := (0).to_natural_32
				from
				until
					not (l_i < {NATURAL_32} 3 - l_equalsTerm)
				loop
					l_newstr[l_i.to_integer_32] := l_lastQuantum[l_i.to_integer_32]
					l_i := l_i + 1
				end
				l_newstr[l_i.to_integer_32] := (('%/0/').code).to_natural_8
				Result := l_rawlen
			end
		end

	decodeQuantum (a_dest: CE_POINTER [NATURAL_8]; a_src: CE_POINTER [INTEGER_8])
		require
			not a_dest.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_p: CE_POINTER [INTEGER_8]
			l_i: NATURAL_32
			l_v: NATURAL_32
			l_x: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_x := {NATURAL_32} 0
			l_i := {NATURAL_32} 0
			l_s := a_src
			from
			until
				not (not (l_return) and then (l_i < {NATURAL_32} 4))
			loop
				l_v := {NATURAL_32} 0
				l_p := table64.item
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_p[0]).to_boolean then
						if (l_p[0]).to_integer_32 = (l_s[0]).to_integer_32 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_v := l_v + 1
						l_p := l_p + 1
					end
				end
				l_break := False
				if (l_p[0]).to_integer_32 = (l_s[0]).to_integer_32 then
					l_x := ((l_x).bit_shift_left (6)) + l_v
				elseif (l_s[0]).to_integer_32 = 61 then
					l_x := (l_x).bit_shift_left ((6))
				end
				l_i := l_i + 1
				l_s := l_s + 1
			end
			a_dest[2] := (create {P_WARNLESS_STATIC}).curlx_ultouc (l_x)
			l_x := (l_x).bit_shift_right ((8))
			a_dest[1] := (create {P_WARNLESS_STATIC}).curlx_ultouc (l_x)
			l_x := (l_x).bit_shift_right ((8))
			a_dest[0] := (create {P_WARNLESS_STATIC}).curlx_ultouc (l_x)
		end

	Curl_num_addresses (a_addr: CE_POINTER [PD_CURL_ADDRINFO]): INTEGER_32
		local
			l_addr: CE_POINTER [PD_CURL_ADDRINFO]
			l_i: INTEGER_32
		do
			l_addr := a_addr
			l_i := 0
			from
			until
				l_addr.is_void
			loop
				l_addr := l_addr.item.ai_next
				l_i := l_i + 1
			end
			Result := l_i
		end

	Curl_cache_addr (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_addr: CE_POINTER [PD_CURL_ADDRINFO]; a_hostname: CE_POINTER [INTEGER_8]; a_port: INTEGER_32): CE_POINTER [PD_CURL_DNS_ENTRY]
		local
			l_entry_id: CE_POINTER [INTEGER_8]
			l_entry_len: NATURAL_32
			l_dns: CE_POINTER [PD_CURL_DNS_ENTRY]
			l_dns2: CE_POINTER [PD_CURL_DNS_ENTRY]
			l_return: BOOLEAN
		do
			l_entry_id := create_hostcache_id (a_hostname, a_port)
			if l_entry_id.is_void then
				Result := (create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_entry_len := strlen (l_entry_id)
				l_dns := create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_CURL_DNS_ENTRY}.make).structure_size.to_natural_32]))))
				if l_dns.is_void then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_entry_id)])
					Result := (create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_dns.item.inuse := 0
				l_dns.item.addr := a_addr
				time (create {CE_INTEGER_32_POINTER}.make_shared (l_dns.c_pointer + (create {PD_CURL_DNS_ENTRY}.make).offset_of ("timestamp"))).do_nothing
				if l_dns.item.timestamp = 0 then
					l_dns.item.timestamp := (1).to_integer_32
				end
				l_dns2 := create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_cast (((a_data.item.dns.hostcache).item.Curl_hash_add (create {CE_VOID_POINTER}.make_cast (l_entry_id), l_entry_len + {NATURAL_32} 1, create {CE_VOID_POINTER}.make_cast (l_dns))))
				if l_dns2.is_void then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_dns)]);
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_entry_id)])
					Result := (create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_dns := l_dns2
				l_dns.item.inuse := (l_dns.item.inuse) + 1;
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_entry_id)])
				Result := l_dns
			end
		end

	create_hostcache_id (a_server: CE_POINTER [INTEGER_8]; a_port: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			Result := ((create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%s:%%d"), a_server, a_port]))
		end

	time2str (a_r: CE_POINTER [INTEGER_8]; a_seconds: INTEGER_64)
		local
			l_d: INTEGER_64
			l_h: INTEGER_64
			l_m: INTEGER_64
			l_s: INTEGER_64
			l_return: BOOLEAN
		do
			if a_seconds <= {INTEGER_64} 0 then
				strcpy (a_r, ce_string ("--:--:--")).do_nothing
				l_return := True
			end
			if not l_return then
				l_h := a_seconds // {INTEGER_64} 3_600
				if l_h <= {INTEGER_64} 99 then
					l_m := (a_seconds - l_h * {INTEGER_64} 3_600) // {INTEGER_64} 60
					l_s := (a_seconds - l_h * {INTEGER_64} 3_600) - l_m * {INTEGER_64} 60;
					(create {P_MPRINTF_STATIC}).curl_msnprintf ([a_r, (9).to_natural_32, ce_string ("%%2lld:%%02lld:%%02lld"), l_h, l_m, l_s]).do_nothing
				else
					l_d := a_seconds // {INTEGER_64} 86_400
					l_h := (a_seconds - l_d * {INTEGER_64} 86_400) // {INTEGER_64} 3_600
					if l_d <= {INTEGER_64} 999 then
						(create {P_MPRINTF_STATIC}).curl_msnprintf ([a_r, (9).to_natural_32, ce_string ("%%3lldd %%02lldh"), l_d, l_h]).do_nothing
					else
						(create {P_MPRINTF_STATIC}).curl_msnprintf ([a_r, (9).to_natural_32, ce_string ("%%7lldd"), l_d]).do_nothing
					end
				end
			end
		end

	max5data (a_bytes: INTEGER_64; a_max5: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			if a_bytes < {INTEGER_64} 100_000 then
				(create {P_MPRINTF_STATIC}).curl_msnprintf ([a_max5, (6).to_natural_32, ce_string ("%%5lld"), a_bytes]).do_nothing
			elseif a_bytes < {INTEGER_64} 10_240_000 then
				(create {P_MPRINTF_STATIC}).curl_msnprintf ([a_max5, (6).to_natural_32, ce_string ("%%4lldk"), a_bytes // {INTEGER_64} 1_024]).do_nothing
			elseif a_bytes < {INTEGER_64} 104_857_600 then
				(create {P_MPRINTF_STATIC}).curl_msnprintf ([a_max5, (6).to_natural_32, ce_string ("%%2lld.%%0lldM"), a_bytes // {INTEGER_64} 1_048_576, (a_bytes \\ {INTEGER_64} 1_048_576) // {INTEGER_64} 104_857]).do_nothing
			elseif a_bytes < {INTEGER_64} 10_485_760_000 then
				(create {P_MPRINTF_STATIC}).curl_msnprintf ([a_max5, (6).to_natural_32, ce_string ("%%4lldM"), a_bytes // {INTEGER_64} 1_048_576]).do_nothing
			elseif a_bytes < {INTEGER_64} 107_374_182_400 then
				(create {P_MPRINTF_STATIC}).curl_msnprintf ([a_max5, (6).to_natural_32, ce_string ("%%2lld.%%0lldG"), a_bytes // {INTEGER_64} 1_073_741_824, (a_bytes \\ {INTEGER_64} 1_073_741_824) // {INTEGER_64} 107_374_182]).do_nothing
			elseif a_bytes < {INTEGER_64} 10_737_418_240_000 then
				(create {P_MPRINTF_STATIC}).curl_msnprintf ([a_max5, (6).to_natural_32, ce_string ("%%4lldG"), a_bytes // {INTEGER_64} 1_073_741_824]).do_nothing
			elseif a_bytes < {INTEGER_64} 10_995_116_277_760_000 then
				(create {P_MPRINTF_STATIC}).curl_msnprintf ([a_max5, (6).to_natural_32, ce_string ("%%4lldT"), a_bytes // {INTEGER_64} 1_099_511_627_776]).do_nothing
			else
				(create {P_MPRINTF_STATIC}).curl_msnprintf ([a_max5, (6).to_natural_32, ce_string ("%%4lldP"), a_bytes // {INTEGER_64} 1_125_899_906_842_624]).do_nothing
			end
			Result := a_max5
		end

	Curl_formpostheader (a_formp: CE_POINTER [ANY]; a_len: CE_POINTER [NATURAL_32]): CE_POINTER [INTEGER_8]
		local
			l_header: CE_POINTER [INTEGER_8]
			l_form: CE_POINTER [PD_FORM]
			l_return: BOOLEAN
		do
			l_form := create {CE_CLASS_POINTER [PD_FORM]}.make_cast (a_formp)
			if (l_form.item.data).is_void then
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_header := (l_form.item.data).item.line
				a_len.item := (l_form.item.data).item.length
				l_form.item.data := (l_form.item.data).item.next
				Result := l_header
			end
		end

	Curl_cookie_getlist (a_c: CE_POINTER [PD_COOKIEINFO]; a_host, a_path: CE_POINTER [INTEGER_8]; a_secure: BOOLEAN): CE_POINTER [PD_COOKIE]
		local
			l_newco: CE_POINTER [PD_COOKIE]
			l_co: CE_POINTER [PD_COOKIE]
			l_now: INTEGER_32
			l_mainco: CE_POINTER [PD_COOKIE]
			l_matches: NATURAL_32
			l_tmp___5: INTEGER_32
			l_array: CE_POINTER [CE_POINTER [PD_COOKIE]]
			l_i: NATURAL_32
			l_tmp___7: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_now := (time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
					l_mainco := create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer)
					l_matches := (0).to_natural_32
					if a_c.is_void then
						Result := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer))
						l_return := True
					elseif (a_c.item.cookies).is_void then
						Result := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 25 -- skip if block
					end
				when 1 then -- if:
						l_co := a_c.item.cookies
				when 2 then -- loop condition:
						if not (not (l_return) and then (not l_co.is_void)) then
							l_pos := -1 + 25 -- skip loop
						end
				when 3 then -- loop body:
						if (l_co.item.expires).to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___2
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 6 then -- else:
						if not (l_co.item.expires > l_now.to_integer_64) then
							l_pos := -1 + 24 -- skip if block
						end
				when 7 then -- if: | _L___2:
						if l_co.item.secure then
							l_tmp___5 := a_secure.to_integer
						else
							l_tmp___5 := 1
						end
						if not (l_tmp___5.to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 8 then -- if:
						if (not (l_co.item.domain).is_void) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 11 then -- else:
						if not (l_co.item.tailmatch) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if ((create {P_COOKIE_STATIC}).tailmatch (l_co.item.domain, a_host)) then
							l_pos := -1 + 16 -- goto _L___0
						else
							l_pos := -1 + 14 -- goto _L___1
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 14 then -- else: | _L___1:
						if l_co.item.tailmatch then
							l_pos := -1 + 24 -- skip if block
						end
				when 15 then -- if:
						if not (((create {P_RAWSTR_STATIC}).Curl_raw_equal (a_host, l_co.item.domain)).to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 16 then -- if: | _L___0:
						if (not (l_co.item.path).is_void) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 19 then -- else:
						if (strncmp (l_co.item.path, a_path, (strlen (l_co.item.path)))).to_boolean then
							l_pos := -1 + 24 -- skip if block
						end
				when 20 then -- if: | _L:
						l_newco := create {CE_CLASS_POINTER [PD_COOKIE]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(create {PD_COOKIE}.make).structure_size.to_natural_32]))))
						if l_newco.is_void then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						memcpy (create {CE_VOID_POINTER}.make_cast (l_newco), create {CE_VOID_POINTER}.make_cast (l_co), (create {PD_COOKIE}.make).structure_size.to_natural_32).do_nothing
						l_newco.item.next := l_mainco
						l_mainco := l_newco
						l_matches := l_matches + 1
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else: | fail:
						from
						until
							l_mainco.is_void
						loop
							l_co := l_mainco.item.next;
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_mainco)])
							l_mainco := l_co
						end
						Result := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer))
						l_return := True
				when 24 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not l_return then
							l_co := l_co.item.next
						end
						l_pos := -1 + 2 -- back to loop condition
				when 25 then -- loop done | if done
					if l_return then
						l_pos := -1 + 30 -- skip if block
					end
				when 26 then -- if:
						if not (l_matches.to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						l_array := create {CE_POINTER_POINTER [PD_COOKIE]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([{PLATFORM}.Pointer_bytes.to_natural_32 * l_matches]))))
						if l_array.is_void then
							l_pos := -1 + 23 -- goto fail
						end
				when 28 then
						l_co := l_mainco
						l_i := (0).to_natural_32
						from
						until
							l_co.is_void
						loop
							l_tmp___7 := l_i
							l_i := l_i + 1
							l_array[l_tmp___7.to_integer_32] := l_co
							l_co := l_co.item.next
						end
						qsort (create {CE_VOID_POINTER}.make_cast (l_array), l_matches, {PLATFORM}.Pointer_bytes.to_natural_32, (create {P_COOKIE_STATIC}).cookie_sort_address)
						l_mainco := l_array[0]
						l_i := (0).to_natural_32
						from
						until
							not (l_i < l_matches - {NATURAL_32} 1)
						loop
							(l_array[l_i.to_integer_32]).item.next := l_array[(l_i + {NATURAL_32} 1).to_integer_32]
							l_i := l_i + 1
						end
						(l_array[(l_matches - {NATURAL_32} 1).to_integer_32]).item.next := create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (default_pointer);
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_array)])
				when 29 then -- if done
						Result := l_mainco
				when 30 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	pickoneauth (a_pick: CE_POINTER [PD_AUTH]): BOOLEAN
		require
			not a_pick.is_void
		local
			l_picked: BOOLEAN
			l_avail: INTEGER_32
		do
			l_avail := (a_pick.item.avail).bit_and (a_pick.item.want)
			l_picked := (1).to_boolean
			if ((l_avail).bit_and (((1).bit_shift_left (2)).to_integer_32)).to_boolean then
				a_pick.item.picked := ((1).bit_shift_left (2)).to_integer_32
			elseif ((l_avail).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean then
				a_pick.item.picked := ((1).bit_shift_left (1)).to_integer_32
			elseif ((l_avail).bit_and (((1).bit_shift_left (3)).to_integer_32)).to_boolean then
				a_pick.item.picked := ((1).bit_shift_left (3)).to_integer_32
			elseif ((l_avail).bit_and (1)).to_boolean then
				a_pick.item.picked := 1
			else
				a_pick.item.picked := ((1).bit_shift_left (30)).to_integer_32
				l_picked := (0).to_boolean
			end
			a_pick.item.avail := 0
			Result := l_picked
		end

	expect100 (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_req_buffer: CE_POINTER [PD_CURL_SEND_BUFFER]): NATURAL_32
		require
			not a_data.is_void
		local
			l_result: NATURAL_32
			l_ptr: CE_POINTER [INTEGER_8]
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			a_data.item.state.expect100header := (0).to_boolean
			if (use_http_1_1 (a_data, a_conn)) then
				l_ptr := (Curl_checkheaders (a_data, ce_string ("Expect:")))
				if (not l_ptr.is_void) then
					a_data.item.state.expect100header := (create {P_HTTP_STATIC}).Curl_compareheader (l_ptr, ce_string ("Expect:"), ce_string ("100-continue"))
				else
					l_result := Curl_add_bufferf ([a_req_buffer, ce_string ("Expect: 100-continue%R%N")])
					if l_result = {NATURAL_32} 0 then
						a_data.item.state.expect100header := (1).to_boolean
					end
				end
			end
			Result := l_result
		end

	Curl_add_bufferf (a_args: TUPLE [a_in: CE_POINTER [PD_CURL_SEND_BUFFER]; a_fmt: CE_POINTER [INTEGER_8]]): NATURAL_32
		local
			l_s: CE_POINTER [INTEGER_8]
			l_ap: CE_VA_LIST
			l_result: NATURAL_32
			l_return: BOOLEAN
		do
			create l_ap.make_shared (default_pointer)

			l_ap := create {CE_VA_LIST}.make (a_args, agent Curl_add_bufferf)
			l_s := curl_mvaprintf (a_args.a_fmt, l_ap.twin)
			if (not l_s.is_void) then
				l_result := (Curl_add_buffer (a_args.a_in, create {CE_VOID_POINTER}.make_cast (l_s), (strlen (l_s))));
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_s)])
				Result := l_result
				l_return := True
			end
			if not l_return then
				if (not (a_args.a_in.item.buffer).is_void) then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_args.a_in.item.buffer)])
				end
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_args.a_in)])
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
			end
		end

	Curl_checkheaders (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_thisheader: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_data.is_void
			not a_thisheader.is_void
		local
			l_head: CE_POINTER [PD_CURL_SLIST]
			l_thislen: NATURAL_32
			l_return: BOOLEAN
		do
			l_thislen := (strlen (a_thisheader))
			l_head := a_data.item.set.headers
			from
			until
				not (not (l_return) and then (not l_head.is_void))
			loop
				if ((create {P_RAWSTR_STATIC}).Curl_raw_nequal (l_head.item.data, a_thisheader, l_thislen)).to_boolean then
					Result := (l_head.item.data)
					l_return := True
				end
				if not l_return then
					l_head := l_head.item.next
				end
			end
			if not l_return then
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
			end
		end

	Curl_add_buffer (a_in: CE_POINTER [PD_CURL_SEND_BUFFER]; a_inptr: CE_POINTER [ANY]; a_size: NATURAL_32): NATURAL_32
		require
			not a_in.is_void
		local
			l_new_rb: CE_POINTER [INTEGER_8]
			l_new_size: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_size).bit_not < a_in.item.size_used then
						(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_in.item.buffer));
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_in)])
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if (not (a_in.item.buffer).is_void) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_in.item.size_used + a_size > a_in.item.size_max - {NATURAL_32} 1) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if a_size > {NATURAL_32} 2_147_483_647 then
							l_new_size := (-1).to_natural_32
						elseif a_in.item.size_used > {NATURAL_32} 2_147_483_647 then
							l_new_size := (-1).to_natural_32
						elseif ((a_size * {NATURAL_32} 2)).bit_not < a_in.item.size_used * {NATURAL_32} 2 then
							l_new_size := (-1).to_natural_32
						else
							l_new_size := (a_in.item.size_used + a_size) * {NATURAL_32} 2
						end
						if (not (a_in.item.buffer).is_void) then
							l_new_rb := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_crealloc.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (a_in.item.buffer), l_new_size]))))
						else
							l_new_rb := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([l_new_size]))))
						end
						if l_new_rb.is_void then
							(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_in.item.buffer));
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_in)])
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							a_in.item.buffer := l_new_rb
							a_in.item.size_max := l_new_size
						end
				when 6 then -- if done | if done
					if not l_return then
						memcpy (create {CE_VOID_POINTER}.make_cast ((a_in.item.buffer + (a_in.item.size_used).to_integer_32)), a_inptr, a_size).do_nothing
						a_in.item.size_used := a_in.item.size_used + a_size
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	use_http_1_1 (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]): BOOLEAN
		require
			not a_data.is_void
		local
			l_tmp: INTEGER_32
		do
			if a_data.item.set.httpversion = 2 then
				l_tmp := 1
			elseif a_data.item.set.httpversion /= 1 then
				if a_conn.item.httpversion = 11 then
					l_tmp := 1
				elseif a_conn.item.httpversion /= 10 then
					if a_data.item.state.httpversion /= 10 then
						l_tmp := 1
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp.to_boolean
		end

	curl_mvaprintf (a_format: CE_POINTER [INTEGER_8]; a_ap_save: CE_VA_LIST): CE_POINTER [INTEGER_8]
		local
			l_ap_save: CE_VA_LIST
			l_retcode: INTEGER_32
			l_info: CE_ARRAY [PD_ASPRINTF]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_ASPRINTF]} l_info.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ap_save := a_ap_save.twin
					l_info.item.buffer := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_info.item.len := (0).to_natural_32
					l_info.item.alloc := (0).to_natural_32
					l_info.item.fail := 0
					l_retcode := (create {P_MPRINTF_STATIC}).dprintf_formatf (create {CE_VOID_POINTER}.make_cast (l_info), (create {P_MPRINTF_STATIC}).alloc_addbyter_address, a_format, l_ap_save.twin)
					if -1 /= l_retcode then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((l_info.item.fail).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if (l_info.item.alloc).to_boolean then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_info.item.buffer)])
						end
						Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
						l_return := True
				when 5 then -- if done
					if not l_return then
						if (l_info.item.alloc).to_boolean then
							l_info.item.buffer[(l_info.item.len).to_integer_32] := (0).to_integer_8
							Result := (l_info.item.buffer)
						else
							Result := (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([ce_string ("")])))
						end
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	convert_lineends (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_startPtr: CE_POINTER [INTEGER_8]; a_size: NATURAL_32): NATURAL_32
		local
			l_size: NATURAL_32
			l_inPtr: CE_POINTER [INTEGER_8]
			l_outPtr: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_size := a_size
			if a_startPtr.is_void then
				Result := l_size
				l_return := True
			elseif l_size < {NATURAL_32} 1 then
				Result := l_size
				l_return := True
			end
			if not l_return then
				if (a_data.item.state.prev_block_had_trailing_cr).to_integer = 1 then
					if (a_startPtr[0]).to_integer_32 = 10 then
						memmove (create {CE_VOID_POINTER}.make_cast (a_startPtr), create {CE_VOID_POINTER}.make_cast ((a_startPtr + 1)), l_size - {NATURAL_32} 1).do_nothing
						l_size := l_size - 1
						a_data.item.state.crlf_conversions := (a_data.item.state.crlf_conversions) + 1
					end
					a_data.item.state.prev_block_had_trailing_cr := (0).to_boolean
				end
				l_outPtr := create {CE_INTEGER_8_POINTER}.make_cast ((memchr (create {CE_VOID_POINTER}.make_cast (a_startPtr), ('%R').code, l_size)))
				l_inPtr := l_outPtr
				if (not l_inPtr.is_void) then
					from
					until
						not ((l_inPtr.c_pointer.to_integer_32).to_natural_32 < (((a_startPtr + l_size.to_integer_32) - 1).c_pointer.to_integer_32).to_natural_32)
					loop
						if (memcmp (create {CE_VOID_POINTER}.make_cast (l_inPtr), create {CE_VOID_POINTER}.make_cast (ce_string ("%R%N")), (2).to_natural_32)) = 0 then
							l_inPtr := l_inPtr + 1
							l_outPtr[0] := l_inPtr[0]
							a_data.item.state.crlf_conversions := (a_data.item.state.crlf_conversions) + 1
						elseif (l_inPtr[0]).to_integer_32 = 13 then
							l_outPtr[0] := (('%N').code).to_integer_8
						else
							l_outPtr[0] := l_inPtr[0]
						end
						l_outPtr := l_outPtr + 1
						l_inPtr := l_inPtr + 1
					end
					if (l_inPtr.c_pointer.to_integer_32).to_natural_32 < ((a_startPtr + l_size.to_integer_32).c_pointer.to_integer_32).to_natural_32 then
						if (l_inPtr[0]).to_integer_32 = 13 then
							l_outPtr[0] := (('%N').code).to_integer_8
							a_data.item.state.prev_block_had_trailing_cr := (1).to_boolean
						else
							l_outPtr[0] := l_inPtr[0]
						end
						l_outPtr := l_outPtr + 1
					end
					if (l_outPtr.c_pointer.to_integer_32).to_natural_32 < ((a_startPtr + l_size.to_integer_32).c_pointer.to_integer_32).to_natural_32 then
						l_outPtr[0] := (('%/0/').code).to_integer_8
					end
					Result := (l_outPtr.distance (a_startPtr)).to_natural_32
					l_return := True
				end
			end
			if not l_return then
				Result := l_size
			end
		end

	pausewrite (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_type: INTEGER_32; a_ptr: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): NATURAL_32
		local
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_dupl: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_k := create {CE_CLASS_POINTER [PD_SINGLEREQUEST]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
			l_dupl := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([a_len]))))
			if l_dupl.is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				l_return := True
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_dupl), create {CE_VOID_POINTER}.make_cast (a_ptr), a_len).do_nothing
				a_data.item.state.tempwrite := l_dupl
				a_data.item.state.tempwritesize := a_len
				a_data.item.state.tempwritetype := a_type
				l_k.item.keepon := (l_k.item.keepon).bit_or (((1).bit_shift_left (4)))
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_read_plain (a_sockfd: INTEGER_32; a_buf: CE_POINTER [INTEGER_8]; a_bytesfromsocket: NATURAL_32; a_n: CE_POINTER [INTEGER_32]): NATURAL_32
		local
			l_nread: INTEGER_32
			l_err: INTEGER_32
			l_return: BOOLEAN
		do
			l_nread := (recv (a_sockfd, create {CE_VOID_POINTER}.make_cast (a_buf), a_bytesfromsocket, 0))
			if -1 = l_nread then
				l_err := (errno_location).item
				if 11 = l_err then
					Result := ({PC_CURLCODE}.CURLE_AGAIN)
					l_return := True
				elseif 11 = l_err then
					Result := ({PC_CURLCODE}.CURLE_AGAIN)
					l_return := True
				elseif 4 = l_err then
					Result := ({PC_CURLCODE}.CURLE_AGAIN)
					l_return := True
				else
					Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
					l_return := True
				end
			end
			if not l_return then
				a_n.item := l_nread
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	ftp_state_rest_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_ftpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_buffer: CE_ARRAY [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_buffer.make (<<24>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
					inspect a_instate.to_integer_32 -- switch 1 head
					when 27 then l_pos := -1 + 2
					else l_pos := -1 + 1
					end
				when 1 then -- switch 1, default:
					if a_ftpcode = 350 then
						l_buffer[0] := (('A').code).to_integer_8
						l_buffer[1] := (('c').code).to_integer_8
						l_buffer[2] := (('c').code).to_integer_8
						l_buffer[3] := (('e').code).to_integer_8
						l_buffer[4] := (('p').code).to_integer_8
						l_buffer[5] := (('t').code).to_integer_8
						l_buffer[6] := (('-').code).to_integer_8
						l_buffer[7] := (('r').code).to_integer_8
						l_buffer[8] := (('a').code).to_integer_8
						l_buffer[9] := (('n').code).to_integer_8
						l_buffer[10] := (('g').code).to_integer_8
						l_buffer[11] := (('e').code).to_integer_8
						l_buffer[12] := (('s').code).to_integer_8
						l_buffer[13] := ((':').code).to_integer_8
						l_buffer[14] := ((' ').code).to_integer_8
						l_buffer[15] := (('b').code).to_integer_8
						l_buffer[16] := (('y').code).to_integer_8
						l_buffer[17] := (('t').code).to_integer_8
						l_buffer[18] := (('e').code).to_integer_8
						l_buffer[19] := (('s').code).to_integer_8
						l_buffer[20] := (('%R').code).to_integer_8
						l_buffer[21] := (('%N').code).to_integer_8
						l_buffer[22] := (('%/0/').code).to_integer_8
						l_buffer[23] := (0).to_integer_8
						l_result := a_conn.item.Curl_client_write ((1).bit_or (((1).bit_shift_left (1))), l_buffer, (0).to_natural_32)
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if not l_return then
						l_result := a_conn.item.ftp_state_post_rest
					end
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 27
					if a_ftpcode /= 350 then
						(a_conn.item.data).item.Curl_failf ([ce_string ("Couldn%'t use REST")])
						l_result := {PC_CURLCODE}.CURLE_FTP_COULDNT_USE_REST
					else
						l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("RETR %%s"), l_ftpc.item.file])
						if l_result /= {NATURAL_32} 0 then
							Result := l_result
							l_return := True
						end
						if not l_return then
							state (a_conn, {PC_FTPSTATE}.FTP_RETR)
						end
					end
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
					if not l_return then
						Result := l_result
					end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	state (a_conn: CE_POINTER [PD_CONNECTDATA]; a_newstate: NATURAL_32)
		local
			l_ftpc: CE_POINTER [PD_FTP_CONN]
		do
			l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
			l_ftpc.item.state := a_newstate
		end

	ftp_sendquote (a_conn: CE_POINTER [PD_CONNECTDATA]; a_quote: CE_POINTER [PD_CURL_SLIST]): NATURAL_32
		local
			l_item: CE_POINTER [PD_CURL_SLIST]
			l_nread: CE_ARRAY [INTEGER_32]
			l_ftpcode: CE_ARRAY [INTEGER_32]
			l_result: NATURAL_32
			l_ftpc: CE_POINTER [PD_FTP_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_cmd: CE_POINTER [INTEGER_8]
			l_acceptfail: BOOLEAN
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_nread.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_ftpcode.make (<<1>>)

			l_ftpc := create {CE_CLASS_POINTER [PD_FTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("ftpc"))
			l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_ftpc.c_pointer + (create {PD_FTP_CONN}.make).offset_of ("pp"))
			l_item := a_quote
			from
			until
				not (not (l_return) and then (not l_item.is_void))
			loop
				if (not (l_item.item.data).is_void) then
					l_cmd := l_item.item.data
					l_acceptfail := (0).to_boolean
					if (l_cmd[0]).to_integer_32 = 42 then
						l_cmd := l_cmd + 1
						l_acceptfail := (1).to_boolean
					end
					l_result := a_conn.item.Curl_ftpsendf ([ce_string ("%%s"), l_cmd])
					if l_result /= {NATURAL_32} 0 then
						Result := l_result
						l_return := True
					end
					if not l_return then
						l_pp.item.response := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
						l_result := a_conn.item.Curl_GetFTPResponse (l_nread, l_ftpcode)
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if not l_return and then (not l_acceptfail) then
						if l_ftpcode.item >= 400 then
							(a_conn.item.data).item.Curl_failf ([ce_string ("QUOT string not accepted: %%s"), l_cmd])
							Result := ({PC_CURLCODE}.CURLE_QUOTE_ERROR)
							l_return := True
						end
					end
				end
				if not l_return then
					l_item := l_item.item.next
				end
			end
			if not l_return then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	ConnectPlease (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_connected: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_conn.is_void
		local
			l_result: NATURAL_32
			l_addr: CE_ARRAY [CE_POINTER [PD_CURL_ADDRINFO]]
			l_hostname: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			create {CE_POINTER_ARRAY [PD_CURL_ADDRINFO]} l_addr.make (<<1>>)

			if a_conn.item.bits.proxy then
				l_tmp := a_conn.item.proxy.name
			else
				l_tmp := a_conn.item.host.name
			end
			l_hostname := l_tmp
			if a_conn.item.bits.proxy then
				l_tmp___0 := ce_string ("proxy ")
			else
				l_tmp___0 := ce_string ("")
			end
			(create {P_SENDF_STATIC}).Curl_infof ([a_data, ce_string ("About to connect() to %%s%%s port %%ld (#%%ld)%N"), l_tmp___0, l_hostname, a_conn.item.port, a_conn.item.connectindex])
			l_result := a_conn.item.Curl_connecthost (a_conn.item.dns_entry, create {CE_INTEGER_32_POINTER}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("sock") + {PLATFORM}.Integer_32_bytes * (0)), l_addr, a_connected)
			if {NATURAL_32} 0 = l_result then
				a_conn.item.ip_addr := l_addr.item
				if a_connected.item then
					l_result := a_conn.item.Curl_connected_proxy
				end
			end
			if l_result.to_boolean then
				a_connected.item := (0).to_boolean
			end
			Result := l_result
		end

	unescape_word (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_inputbuff: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_newp: CE_POINTER [INTEGER_8]
			l_dictp: CE_POINTER [INTEGER_8]
			l_ptr: CE_POINTER [INTEGER_8]
			l_len: CE_ARRAY [INTEGER_32]
			l_byte: INTEGER_8
			l_olen: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_len.make (<<1>>)

			l_olen := 0
			l_newp := (create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_cast (a_data), a_inputbuff, 0, l_len)
			if l_newp.is_void then
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_dictp := create {CE_INTEGER_8_POINTER}.make_cast ((malloc ((l_len.item).to_natural_32 * {NATURAL_32} 2 + {NATURAL_32} 1)))
				if (not l_dictp.is_void) then
					l_ptr := l_newp
					from
					until
						(l_break)
					loop
						l_break := False
						l_byte := l_ptr[0]
						if l_byte.to_integer_32 = 0 then
							l_break := True
						end
						if not (l_break) then
							if l_byte.to_integer_32 <= 32 then
								l_tmp___0 := l_olen
								l_olen := l_olen + 1
								l_dictp[l_tmp___0] := (('\').code).to_integer_8
							elseif l_byte.to_integer_32 = 127 then
								l_tmp___0 := l_olen
								l_olen := l_olen + 1
								l_dictp[l_tmp___0] := (('\').code).to_integer_8
							elseif l_byte.to_integer_32 = 39 then
								l_tmp___0 := l_olen
								l_olen := l_olen + 1
								l_dictp[l_tmp___0] := (('\').code).to_integer_8
							elseif l_byte.to_integer_32 = 34 then
								l_tmp___0 := l_olen
								l_olen := l_olen + 1
								l_dictp[l_tmp___0] := (('\').code).to_integer_8
							elseif l_byte.to_integer_32 = 92 then
								l_tmp___0 := l_olen
								l_olen := l_olen + 1
								l_dictp[l_tmp___0] := (('\').code).to_integer_8
							end
							l_tmp___1 := l_olen
							l_olen := l_olen + 1
							l_dictp[l_tmp___1] := l_byte
							l_ptr := l_ptr + 1
						end
					end
					l_break := False
					l_dictp[l_olen] := (0).to_integer_8
					free (create {CE_VOID_POINTER}.make_cast (l_newp))
				end
				Result := l_dictp
			end
		end

	Curl_speedinit (a_data: CE_POINTER [PD_SESSIONHANDLE])
		do
			memset (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("keeps_speed")))), 0, (create {SD_TIMEVAL}.make).structure_size.to_natural_32).do_nothing
		end

	init_telnet (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_tn: CE_POINTER [PD_TELNET]
			l_return: BOOLEAN
		do
			l_tn := create {CE_CLASS_POINTER [PD_TELNET]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_TELNET}.make).structure_size.to_natural_32]))))
			if l_tn.is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				l_return := True
			end
			if not l_return then
				(a_conn.item.data).item.state.proto.telnet := create {CE_VOID_POINTER}.make_cast (l_tn)
				l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
				l_tn.item.subpointer := l_tn.item.subbuffer
				l_tn.item.us_preferred[0] := 1
				l_tn.item.us_preferred[3] := 1
				l_tn.item.him_preferred[0] := 1
				l_tn.item.him_preferred[3] := 1
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	send_telnet_data (a_conn: CE_POINTER [PD_CONNECTDATA]; a_buffer: CE_POINTER [INTEGER_8]; a_nread: INTEGER_32): NATURAL_32
		local
			l_buffer: CE_POINTER [INTEGER_8]
			l_nread: INTEGER_32
			l_outbuf: CE_ARRAY [NATURAL_8]
			l_bytes_written: CE_ARRAY [INTEGER_32]
			l_total_written: INTEGER_32
			l_out_count: INTEGER_32
			l_rc: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_pfd: CE_ARRAY [SD_POLLFD]
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_outbuf.make (<<2>>)
			create {CE_INTEGER_32_ARRAY} l_bytes_written.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_POLLFD]} l_pfd.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buffer := a_buffer
					l_nread := a_nread
					l_rc := {PC_CURLCODE}.CURLE_OK
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if l_rc = {NATURAL_32} 0 then
							l_tmp___2 := l_nread
							l_nread := l_nread - 1
							if not l_tmp___2.to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						l_tmp := l_buffer
						l_buffer := l_buffer + 1
						l_outbuf[0] := (l_tmp[0]).to_natural_8
						l_out_count := 1
						if (l_outbuf[0]).to_integer_32 = 255 then
							l_tmp___0 := l_out_count
							l_out_count := l_out_count + 1
							l_outbuf[l_tmp___0] := (255).to_natural_8
						end
						l_total_written := 0
				when 4 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 9 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						l_pfd[0].fd := a_conn.item.sock[0]
						l_pfd[0].events := (4).to_integer_16
						inspect (Curl_poll (l_pfd, {NATURAL_32} 1, -1)) -- switch 1 head
						when -1 then l_pos := -1 + 6 -- -1
						when 0 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 6 then -- switch 1, case -1 | switch 1, case 0
						l_rc := {PC_CURLCODE}.CURLE_SEND_ERROR
						l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, default:
						l_bytes_written.item := 0
						l_rc := a_conn.item.Curl_write (a_conn.item.sock[0], create {CE_VOID_POINTER}.make_cast ((l_outbuf + l_total_written)), (l_out_count - l_total_written).to_natural_32, l_bytes_written)
						l_total_written := l_total_written + (l_bytes_written.item)
						l_pos := -1 + 8 -- switch 1; break
				when 8 then -- switch 1, done:
						if l_rc = {NATURAL_32} 0 then
							if not (l_total_written < l_out_count) then
								l_break := True
							end
						else
							l_break := True
						end
						l_pos := -1 + 4 -- back to loop condition
				when 9 then -- loop done
						l_break := False
				when 10 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
					l_break := False
					Result := l_rc
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_poll (a_ufds: CE_POINTER [SD_POLLFD]; a_nfds: NATURAL_32; a_timeout_ms: INTEGER_32): INTEGER_32
		local
			l_initial_tv: SD_TIMEVAL
			l_fds_none: BOOLEAN
			l_i: NATURAL_32
			l_pending_ms: INTEGER_32
			l_error: INTEGER_32
			l_r: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			create l_initial_tv.make

			l_initial_tv.tv_sec := (0).to_integer_32
			l_initial_tv.tv_usec := (0).to_integer_32
			l_fds_none := (1).to_boolean
			l_pending_ms := 0
			if (not a_ufds.is_void) then
				l_i := {NATURAL_32} 0
				from
				until
					not (not (l_break) and then (l_i < a_nfds))
				loop
					l_break := False
					if (a_ufds + l_i.to_integer_32).item.fd /= -1 then
						l_fds_none := (0).to_boolean
						l_break := True
					end
					if not (l_break) then
						l_i := l_i + 1
					end
				end
				l_break := False
			end
			if l_fds_none then
				l_r := (create {P_SELECT_STATIC}).wait_ms (a_timeout_ms)
				Result := l_r
				l_return := True
			end
			if not l_return then
				if a_timeout_ms > 0 then
					l_pending_ms := a_timeout_ms
					l_initial_tv := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if a_timeout_ms < 0 then
						l_pending_ms := -1
					elseif not a_timeout_ms.to_boolean then
						l_pending_ms := 0
					end
					l_r := poll (a_ufds, a_nfds.to_natural_32, l_pending_ms)
					if l_r /= -1 then
						l_break := True
					end
					if not (l_break) then
						l_error := (errno_location).item
						if l_error.to_boolean then
							if l_error /= 4 then
								l_break := True
							end
						end
					end
					if not (l_break) and then (a_timeout_ms > 0) then
						l_pending_ms := a_timeout_ms - ((create {P_TIMEVAL_STATIC}).curlx_tvdiff ((((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin).twin, l_initial_tv.twin)).to_integer_32
						if l_pending_ms <= 0 then
							l_break := True
						end
					end
					if not (l_break) and then (l_r /= -1) then
						l_break := True
					end
				end
				l_break := False
				if l_r < 0 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return and then (l_r = 0) then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_i := {NATURAL_32} 0
				from
				until
					not (l_i < a_nfds)
				loop
					l_continue := False
					if (a_ufds + l_i.to_integer_32).item.fd = -1 then
						l_continue := True
					end
					if not (l_break or l_continue) then
						if ((((a_ufds + l_i.to_integer_32).item.revents).to_integer_32).bit_and (16)).to_boolean then
							(a_ufds + l_i.to_integer_32).item.revents := ((((a_ufds + l_i.to_integer_32).item.revents).to_integer_32).bit_or (1)).to_integer_16
						end
						if ((((a_ufds + l_i.to_integer_32).item.revents).to_integer_32).bit_and (8)).to_boolean then
							(a_ufds + l_i.to_integer_32).item.revents := ((((a_ufds + l_i.to_integer_32).item.revents).to_integer_32).bit_or (5)).to_integer_16
						end
					end
					l_i := l_i + 1
				end
				l_continue := False
				Result := l_r
			end
		end

	readwrite_upload (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_k: CE_POINTER [PD_SINGLEREQUEST]; a_didwhat: CE_POINTER [INTEGER_32]): NATURAL_32
		require
			not a_data.is_void
			not a_k.is_void
			not a_didwhat.is_void
		local
			l_i: INTEGER_32
			l_si: INTEGER_32
			l_bytes_written: CE_ARRAY [INTEGER_32]
			l_result: NATURAL_32
			l_nread: INTEGER_32
			l_sending_http_headers: BOOLEAN
			l_fillcount: CE_ARRAY [INTEGER_32]
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_bytes_written.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_fillcount.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sending_http_headers := (0).to_boolean
					if a_k.item.bytecount = {INTEGER_64} 0 then
						if a_k.item.writebytecount = {INTEGER_64} 0 then
							(create {P_PROGRESS_STATIC}).Curl_pgrsTime (a_data, {PC_TIMERID}.TIMER_STARTTRANSFER)
						end
					end
					a_didwhat.item := (a_didwhat.item).bit_or (((1).bit_shift_left (1)))
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 19 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if 0 /= a_data.item.req.upload_present then
							l_pos := -1 + 18 -- skip if block
						end
				when 3 then -- if:
						a_data.item.req.upload_fromhere := a_k.item.uploadbuf
						if not a_k.item.upload_done then
							if a_k.item.exp100 = {NATURAL_32} 2 then
								if (a_data.item.state.proto.http).item.sending = {NATURAL_32} 2 then
									a_k.item.exp100 := {PC_EXPECT100}.EXP100_AWAITING_CONTINUE
									a_k.item.keepon := (a_k.item.keepon).bit_and (((((1).bit_shift_left (1))).bit_not))
									a_k.item.start100 := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
									a_didwhat.item := (a_didwhat.item).bit_and (((((1).bit_shift_left (1))).bit_not))
									a_data.item.Curl_expire (1_000)
									l_break := True
								end
							end
							if not (l_return or l_break) then
								if ((a_conn.item.protocol).bit_and (((1).bit_or (((1).bit_shift_left (18)))).to_integer_32)).to_boolean then
									if (a_data.item.state.proto.http).item.sending = {NATURAL_32} 1 then
										l_sending_http_headers := (1).to_boolean
									else
										l_sending_http_headers := (0).to_boolean
									end
								end
								l_result := a_conn.item.Curl_fillreadbuffer (16_384, l_fillcount)
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
								if not l_return then
									l_nread := l_fillcount.item
								end
							end
						else
							l_nread := 0
						end
						if (l_return or l_break) then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if l_nread.to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if ((a_k.item.keepon).bit_and (((1).bit_shift_left (5)))).to_boolean then
							l_break := True
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if l_nread <= 0 then
							a_k.item.keepon := (a_k.item.keepon).bit_and (((((1).bit_shift_left (1))).bit_not))
							if a_conn.item.bits.rewindaftersend then
								l_result := a_conn.item.Curl_readrewind
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
							end
							if not l_return then
								l_break := True
							end
						end
				when 8 then -- if done
						if (l_return or l_break) then
							l_pos := -1 + 18 -- skip if block
						end
				when 9 then -- if:
						a_data.item.req.upload_present := l_nread
						if not (((a_conn.item.protocol).bit_and (((1).bit_shift_left (16)).to_integer_32)).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_result := a_conn.item.Curl_smtp_escape_eob (l_nread)
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 12 then -- else:
						if l_sending_http_headers then
							l_pos := -1 + 18 -- skip if block
						end
				when 13 then -- if:
						if not (a_data.item.set.crlf) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if not (a_data.item.set.prefer_ascii) then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L___0:
						if (a_data.item.state.scratch).is_void then
							a_data.item.state.scratch := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(32_768).to_natural_32]))))
						end
						if (a_data.item.state.scratch).is_void then
							a_data.item.Curl_failf ([ce_string ("Failed to alloc scratch buffer!")])
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							l_i := 0
							l_si := 0
							from
							until
								not (l_i < l_nread)
							loop
								if (a_data.item.req.upload_fromhere[l_i]).to_integer_32 = 10 then
									l_tmp___0 := l_si
									l_si := l_si + 1
									a_data.item.state.scratch[l_tmp___0] := (13).to_integer_8
									a_data.item.state.scratch[l_si] := (10).to_integer_8
									if not a_data.item.set.crlf then
										a_data.item.set.infilesize := (a_data.item.set.infilesize) + 1
									end
								else
									a_data.item.state.scratch[l_si] := a_data.item.req.upload_fromhere[l_i]
								end
								l_i := l_i + 1
								l_si := l_si + 1
							end
							if l_si /= l_nread then
								l_nread := l_si
								a_data.item.req.upload_fromhere := a_data.item.state.scratch
								a_data.item.req.upload_present := l_nread
							end
						end
				when 18 then -- if done | if done | if done | if done | if done
						if not (l_return or l_break) then
							l_result := a_conn.item.Curl_write (a_conn.item.writesockfd, create {CE_VOID_POINTER}.make_cast (a_data.item.req.upload_fromhere), (a_data.item.req.upload_present).to_natural_32, l_bytes_written)
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
							if not l_return then
								if a_data.item.set.verbose then
									a_data.item.Curl_debug ({PC_CURL_INFOTYPE}.CURLINFO_DATA_OUT, a_data.item.req.upload_fromhere, (l_bytes_written.item).to_natural_32, a_conn).do_nothing
								end
								if a_data.item.req.upload_present /= l_bytes_written.item then
									a_data.item.req.upload_present := a_data.item.req.upload_present - (l_bytes_written.item)
									a_data.item.req.upload_fromhere := a_data.item.req.upload_fromhere + (l_bytes_written.item)
								else
									a_data.item.req.upload_fromhere := a_k.item.uploadbuf
									a_data.item.req.upload_present := 0
									if a_k.item.upload_done then
										a_k.item.keepon := (a_k.item.keepon).bit_and (((((1).bit_shift_left (1))).bit_not))
									end
								end
								a_k.item.writebytecount := a_k.item.writebytecount + (l_bytes_written.item).to_integer_64
								a_data.item.Curl_pgrsSetUploadCounter (a_k.item.writebytecount)
								l_break := True
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 19 then -- loop done
					if not l_return then
						l_break := False
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_ftp_parselist_data_alloc: CE_POINTER [PD_FTP_PARSELIST_DATA]
		do
			Result := (create {CE_CLASS_POINTER [PD_FTP_PARSELIST_DATA]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_FTP_PARSELIST_DATA}.make).structure_size.to_natural_32])))))
		end

	Curl_ftp_parselist_geterror (a_pl_data: CE_POINTER [PD_FTP_PARSELIST_DATA]): NATURAL_32
		require
			not a_pl_data.is_void
		do
			Result := (a_pl_data.item.error)
		end

	Curl_isxdigit (a_digit: INTEGER_8): BOOLEAN
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_digit.to_integer_32 >= 48) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_digit.to_integer_32 <= 57 then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else: | _L___0:
						if not (a_digit.to_integer_32 >= 65) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_digit.to_integer_32 <= 70 then
							l_tmp := 1
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if a_digit.to_integer_32 >= 97 then
							if a_digit.to_integer_32 <= 102 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 7 then -- if done
					Result := l_tmp.to_boolean
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getaddressinfo (a_sa: CE_POINTER [SD_SOCKADDR]; a_addr: CE_POINTER [INTEGER_8]; a_port: CE_POINTER [INTEGER_32]): BOOLEAN
		require
			not a_sa.is_void
		local
			l_us_port: NATURAL_16
			l_si: CE_POINTER [SD_SOCKADDR_IN]
			l_si6: CE_POINTER [SD_SOCKADDR_IN6]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_si := create {CE_CLASS_POINTER [SD_SOCKADDR_IN]}.make_shared (default_pointer)
					l_si6 := create {CE_CLASS_POINTER [SD_SOCKADDR_IN6]}.make_shared (default_pointer)
					inspect (a_sa.item.sa_family).to_integer_32 -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					l_si := create {CE_CLASS_POINTER [SD_SOCKADDR_IN]}.make_cast (a_sa)
					if (inet_ntop ((a_sa.item.sa_family).to_integer_32, create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN_ADDR]}.make_shared (l_si.c_pointer + (create {SD_SOCKADDR_IN}.make).offset_of ("sin_addr")))), a_addr, (("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255").count + 1).to_natural_32)).is_void then
						Result := (0).to_boolean
						l_return := True
					end
					if not l_return then
						l_us_port := ntohs (l_si.item.sin_port)
						a_port.item := l_us_port.to_integer_32
					end
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 10
					l_si6 := create {CE_CLASS_POINTER [SD_SOCKADDR_IN6]}.make_cast (a_sa)
					if (inet_ntop ((a_sa.item.sa_family).to_integer_32, create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IN6_ADDR]}.make_shared (l_si6.c_pointer + (create {SD_SOCKADDR_IN6}.make).offset_of ("sin6_addr")))), a_addr, (("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255").count + 1).to_natural_32)).is_void then
						Result := (0).to_boolean
						l_return := True
					end
					if not l_return then
						l_us_port := ntohs (l_si6.item.sin6_port)
						a_port.item := l_us_port.to_integer_32
					end
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					a_addr[0] := (('%/0/').code).to_integer_8
					a_port.item := 0
				when 4 then -- switch 1, done:
					if not l_return then
						Result := (1).to_boolean
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_pair (a_str, a_value, a_content: CE_POINTER [INTEGER_8]; a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		require
			not a_str.is_void
			not a_value.is_void
		local
			l_str: CE_POINTER [INTEGER_8]
			l_value: CE_POINTER [INTEGER_8]
			l_content: CE_POINTER [INTEGER_8]
			l_c: INTEGER_32
			l_starts_with_quote: BOOLEAN
			l_escape: BOOLEAN
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str := a_str
					l_value := a_value
					l_content := a_content
					l_starts_with_quote := (0).to_boolean
					l_escape := (0).to_boolean
					l_c := 255
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_str[0]).to_boolean then
							if (l_str[0]).to_integer_32 /= 61 then
								l_tmp___1 := l_c
								l_c := l_c - 1
								if not l_tmp___1.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_tmp := l_value
							l_value := l_value + 1
							l_tmp___0 := l_str
							l_str := l_str + 1
							l_tmp[0] := l_tmp___0[0]
						end
					end
					l_break := False
					l_value[0] := (0).to_integer_8
					l_tmp___2 := l_str
					l_str := l_str + 1
					if 61 /= (l_tmp___2[0]).to_integer_32 then
						Result := 1
						l_return := True
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if 34 = (l_str[0]).to_integer_32 then
							l_str := l_str + 1
							l_starts_with_quote := (1).to_boolean
						end
						l_c := 1_023
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						if (l_str[0]).to_boolean then
							l_tmp___5 := l_c
							l_c := l_c - 1
							if not l_tmp___5.to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break or l_continue) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						inspect (l_str[0]).to_integer_32 -- switch 1 head
						when 92 then l_pos := -1 + 5
						when 44 then l_pos := -1 + 6
						when 13 then l_pos := -1 + 7
						when 10 then l_pos := -1 + 7
						when 34 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 5 then -- switch 1, case 92
						if not l_escape then
							l_escape := (1).to_boolean
							l_tmp___3 := l_content
							l_content := l_content + 1
							l_tmp___3[0] := (('\').code).to_integer_8
							l_continue := True
						end
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 44
						if not l_starts_with_quote then
							l_c := 0
							l_continue := True
						end
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 13 | switch 1, case 10
						l_c := 0
						l_continue := True
				when 8 then -- switch 1, case 34
						if not (l_break or l_continue) and then (not l_escape) then
							if l_starts_with_quote then
								l_c := 0
								l_continue := True
							end
						end
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done: | if done
						if not (l_break or l_continue) then
							l_escape := (0).to_boolean
							l_tmp___4 := l_content
							l_content := l_content + 1
							l_tmp___4[0] := l_str[0]
						end
						if (not l_break) then
							l_str := l_str + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						l_break := False
						l_continue := False
						l_content[0] := (0).to_integer_8
						a_endptr.item := l_str
						Result := 0
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	md5_to_ascii (a_source, a_dest: CE_POINTER [NATURAL_8])
		local
			l_i: INTEGER_32
		do
			l_i := 0
			from
			until
				not (l_i < 16)
			loop
				(create {P_MPRINTF_STATIC}).curl_msnprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((a_dest + l_i * 2)), (3).to_natural_32, ce_string ("%%02x"), (a_source[l_i]).to_integer_32]).do_nothing
				l_i := l_i + 1
			end
		end

	Curl_md5it (a_outbuffer, a_input: CE_POINTER [NATURAL_8])
		local
			l_ctx: CE_ARRAY [PD_MD5_CTX]
		do
			create {CE_CLASS_ARRAY [PD_MD5_CTX]} l_ctx.make (<<1>>)

			MD5_Init (l_ctx)
			l_ctx.item.MD5_Update (a_input, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_input))))
			l_ctx.item.MD5_Final (a_outbuffer)
		end

	MD5_Init (a_context: CE_POINTER [PD_MD5_CTX])
		require
			not a_context.is_void
		local
			l_tmp: NATURAL_32
		do
			l_tmp := (0).to_natural_32
			a_context.item.count[1] := l_tmp
			a_context.item.count[0] := l_tmp
			a_context.item.state[0] := (1_732_584_193).to_natural_32
			a_context.item.state[1] := {NATURAL_32} 4_023_233_417
			a_context.item.state[2] := {NATURAL_32} 2_562_383_102
			a_context.item.state[3] := (271_733_878).to_natural_32
		end

	Curl_ipvalid (a_data: CE_POINTER [PD_SESSIONHANDLE]): BOOLEAN
		require
			not a_data.is_void
		local
			l_s: INTEGER_32
			l_return: BOOLEAN
		do
			if a_data.item.set.ip_version = 2 then
				l_s := (socket (10, 2, 0))
				if l_s = -1 then
					Result := (0).to_boolean
					l_return := True
				end
				if not l_return then
					close (l_s).do_nothing
				end
			end
			if not l_return then
				Result := (1).to_boolean
			end
		end

	getrpacketevent (a_packet: CE_POINTER [PD_TFTP_PACKET]): NATURAL_16
		require
			not a_packet.is_void
		do
			Result := (((((a_packet.item.data[0]).to_integer_32).bit_shift_left (8))).bit_or ((a_packet.item.data[1]).to_integer_32)).to_natural_16
		end

	imap_select (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_str: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_imapc := create {CE_CLASS_POINTER [PD_IMAP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("imapc"))
			l_str := (create {P_IMAP_STATIC}).getcmdid (a_conn)
			if (not (l_imapc.item.mailbox).is_void) then
				l_tmp := l_imapc.item.mailbox
			else
				l_tmp := ce_string ("")
			end
			l_result := (create {P_IMAP_STATIC}).imapsendf ([a_conn, l_str, ce_string ("%%s SELECT %%s"), l_str, l_tmp])
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				(create {P_IMAP_STATIC}).state___0 (a_conn, {PC_IMAPSTATE}.IMAP_SELECT)
				Result := l_result
			end
		end

	imap_fetch (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_str: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_str := (create {P_IMAP_STATIC}).getcmdid (a_conn)
			l_result := (create {P_IMAP_STATIC}).imapsendf ([a_conn, l_str, ce_string ("%%s FETCH 1 BODY[TEXT]"), l_str])
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				(create {P_IMAP_STATIC}).state___0 (a_conn, {PC_IMAPSTATE}.IMAP_FETCH)
				Result := l_result
			end
		end

	pop3_retr (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_pop3c := create {CE_CLASS_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c") + (create {PD_POP3_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("RETR %%s"), l_pop3c.item.mailbox])
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				(create {P_POP3_STATIC}).state___1 (a_conn, {PC_POP3STATE}.POP3_RETR)
				Result := l_result
			end
		end

	pop3_list (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_pop3c := create {CE_CLASS_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c") + (create {PD_POP3_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("LIST %%s"), l_pop3c.item.mailbox])
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				(create {P_POP3_STATIC}).state___1 (a_conn, {PC_POP3STATE}.POP3_LIST)
				Result := l_result
			end
		end

	smtp_state_helo (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_return: BOOLEAN
		do
			l_smtpc := create {CE_CLASS_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("HELO %%s"), l_smtpc.item.domain])
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				(create {P_SMTP_STATIC}).state___2 (a_conn, {PC_SMTPSTATE}.SMTP_HELO)
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	smtp_state_postdata_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_smtpcode: INTEGER_32; a_instate: NATURAL_32): NATURAL_32
		local
			l_result: NATURAL_32
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			if a_smtpcode /= 250 then
				l_result := {PC_CURLCODE}.CURLE_RECV_ERROR
			end
			(create {P_SMTP_STATIC}).state___2 (a_conn, {PC_SMTPSTATE}.SMTP_STOP)
			Result := l_result
		end

	Curl_HMAC_update (a_ctxt: CE_POINTER [PD_HMAC_CONTEXT]; a_data: CE_POINTER [NATURAL_8]; a_len: NATURAL_32): INTEGER_32
		require
			not a_ctxt.is_void
		do
			((a_ctxt.item.hmac_hash).item.hmac_hupdate).call ([a_ctxt.item.hmac_hashctxt1, a_data, a_len])
			Result := 0
		end

	Curl_HMAC_final (a_ctxt: CE_POINTER [PD_HMAC_CONTEXT]; a_result: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_ctxt.is_void
		local
			l_result: CE_POINTER [NATURAL_8]
			l_hashparams: CE_POINTER [PD_HMAC_PARAMS]
		do
			l_result := a_result
			l_hashparams := a_ctxt.item.hmac_hash
			if l_result.is_void then
				l_result := create {CE_NATURAL_8_POINTER}.make_cast (a_ctxt.item.hmac_hashctxt2) + ((a_ctxt.item.hmac_hash).item.hmac_ctxtsize).to_integer_32
			end
			(l_hashparams.item.hmac_hfinal).call ([l_result, a_ctxt.item.hmac_hashctxt1]);
			(l_hashparams.item.hmac_hupdate).call ([a_ctxt.item.hmac_hashctxt2, l_result, l_hashparams.item.hmac_resultlen]);
			(l_hashparams.item.hmac_hfinal).call ([l_result, a_ctxt.item.hmac_hashctxt2]);
			(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_ctxt)])
			Result := 0
		end

feature {ANY}

	copy (a_other: like Current)
		do
			data := a_other.data
			chunk := a_other.chunk.twin
			inuse := a_other.inuse
			connectindex := a_other.connectindex
			protocol := a_other.protocol
			dns_entry := a_other.dns_entry
			ip_addr := a_other.ip_addr
			ip_addr_str := a_other.ip_addr_str.twin
			scope := a_other.scope
			socktype := a_other.socktype
			host := a_other.host.twin
			proxy := a_other.proxy.twin
			port := a_other.port
			remote_port := a_other.remote_port
			user := a_other.user
			passwd := a_other.passwd
			proxyuser := a_other.proxyuser
			proxypasswd := a_other.proxypasswd
			proxytype := a_other.proxytype
			httpversion := a_other.httpversion
			rtspversion := a_other.rtspversion
			now := a_other.now.twin
			created := a_other.created.twin
			sock := a_other.sock.twin
			recv2 := a_other.recv2.twin
			send2 := a_other.send2.twin
			ssl := a_other.ssl.twin
			ssl_config := a_other.ssl_config.twin
			bits := a_other.bits.twin
			handler := a_other.handler
			sockfd := a_other.sockfd
			writesockfd := a_other.writesockfd
			allocptr := a_other.allocptr.twin
			sec_complete := a_other.sec_complete
			readchannel_inuse := a_other.readchannel_inuse
			writechannel_inuse := a_other.writechannel_inuse
			server_supports_pipelining := a_other.server_supports_pipelining
			send_pipe := a_other.send_pipe
			recv_pipe := a_other.recv_pipe
			pend_pipe := a_other.pend_pipe
			done_pipe := a_other.done_pipe
			master_buffer := a_other.master_buffer
			read_pos := a_other.read_pos
			buf_len := a_other.buf_len
			seek_func := a_other.seek_func
			seek_client := a_other.seek_client
			fread_func := a_other.fread_func
			fread_in := a_other.fread_in
			ntlm := a_other.ntlm.twin
			proxyntlm := a_other.proxyntlm.twin
			syserr_buf := a_other.syserr_buf.twin
			trailer := a_other.trailer
			trlMax := a_other.trlMax
			trlPos := a_other.trlPos
			proto := a_other.proto.twin
			cselect_bits := a_other.cselect_bits
			waitfor := a_other.waitfor
			verifypeer := a_other.verifypeer
			verifyhost := a_other.verifyhost
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				data.is_equal (a_other.data) and
				chunk.is_equal (a_other.chunk) and
				inuse = a_other.inuse and
				connectindex = a_other.connectindex and
				protocol = a_other.protocol and
				dns_entry.is_equal (a_other.dns_entry) and
				ip_addr.is_equal (a_other.ip_addr) and
				ip_addr_str.is_equal (a_other.ip_addr_str) and
				scope = a_other.scope and
				socktype = a_other.socktype and
				host.is_equal (a_other.host) and
				proxy.is_equal (a_other.proxy) and
				port = a_other.port and
				remote_port = a_other.remote_port and
				user.is_equal (a_other.user) and
				passwd.is_equal (a_other.passwd) and
				proxyuser.is_equal (a_other.proxyuser) and
				proxypasswd.is_equal (a_other.proxypasswd) and
				proxytype = a_other.proxytype and
				httpversion = a_other.httpversion and
				rtspversion = a_other.rtspversion and
				now.is_equal (a_other.now) and
				created.is_equal (a_other.created) and
				sock.is_equal (a_other.sock) and
				recv2.is_equal (a_other.recv2) and
				send2.is_equal (a_other.send2) and
				ssl.is_equal (a_other.ssl) and
				ssl_config.is_equal (a_other.ssl_config) and
				bits.is_equal (a_other.bits) and
				handler.is_equal (a_other.handler) and
				sockfd = a_other.sockfd and
				writesockfd = a_other.writesockfd and
				allocptr.is_equal (a_other.allocptr) and
				sec_complete = a_other.sec_complete and
				readchannel_inuse = a_other.readchannel_inuse and
				writechannel_inuse = a_other.writechannel_inuse and
				server_supports_pipelining = a_other.server_supports_pipelining and
				send_pipe.is_equal (a_other.send_pipe) and
				recv_pipe.is_equal (a_other.recv_pipe) and
				pend_pipe.is_equal (a_other.pend_pipe) and
				done_pipe.is_equal (a_other.done_pipe) and
				master_buffer.is_equal (a_other.master_buffer) and
				read_pos = a_other.read_pos and
				buf_len = a_other.buf_len and
				seek_func.is_equal (a_other.seek_func) and
				seek_client.is_equal (a_other.seek_client) and
				fread_func.is_equal (a_other.fread_func) and
				fread_in.is_equal (a_other.fread_in) and
				ntlm.is_equal (a_other.ntlm) and
				proxyntlm.is_equal (a_other.proxyntlm) and
				syserr_buf.is_equal (a_other.syserr_buf) and
				trailer.is_equal (a_other.trailer) and
				trlMax = a_other.trlMax and
				trlPos = a_other.trlPos and
				proto.is_equal (a_other.proto) and
				cselect_bits = a_other.cselect_bits and
				waitfor = a_other.waitfor and
				verifypeer = a_other.verifypeer and
				verifyhost = a_other.verifyhost
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("chunk"),
					create {CE_STRUCTURE_FIELD}.make ("inuse"),
					create {CE_STRUCTURE_FIELD}.make ("connectindex"),
					create {CE_STRUCTURE_FIELD}.make ("protocol"),
					create {CE_STRUCTURE_FIELD}.make ("dns_entry"),
					create {CE_STRUCTURE_FIELD}.make ("ip_addr"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ip_addr_str", <<((("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255").count + 1).to_natural_32).to_integer_32>>),
					create {CE_STRUCTURE_FIELD}.make ("scope"),
					create {CE_STRUCTURE_FIELD}.make ("socktype"),
					create {CE_STRUCTURE_FIELD}.make ("host"),
					create {CE_STRUCTURE_FIELD}.make ("proxy"),
					create {CE_STRUCTURE_FIELD}.make ("port"),
					create {CE_STRUCTURE_FIELD}.make ("remote_port"),
					create {CE_STRUCTURE_FIELD}.make ("user"),
					create {CE_STRUCTURE_FIELD}.make ("passwd"),
					create {CE_STRUCTURE_FIELD}.make ("proxyuser"),
					create {CE_STRUCTURE_FIELD}.make ("proxypasswd"),
					create {CE_STRUCTURE_FIELD}.make ("proxytype"),
					create {CE_STRUCTURE_FIELD}.make ("httpversion"),
					create {CE_STRUCTURE_FIELD}.make ("rtspversion"),
					create {CE_STRUCTURE_FIELD}.make ("now"),
					create {CE_STRUCTURE_FIELD}.make ("created"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sock", <<2>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("recv2", <<2>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("send2", <<2>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ssl", <<2>>),
					create {CE_STRUCTURE_FIELD}.make ("ssl_config"),
					create {CE_STRUCTURE_FIELD}.make ("bits"),
					create {CE_STRUCTURE_FIELD}.make ("handler"),
					create {CE_STRUCTURE_FIELD}.make ("sockfd"),
					create {CE_STRUCTURE_FIELD}.make ("writesockfd"),
					create {CE_STRUCTURE_FIELD}.make ("allocptr"),
					create {CE_STRUCTURE_FIELD}.make ("sec_complete"),
					create {CE_STRUCTURE_FIELD}.make ("readchannel_inuse"),
					create {CE_STRUCTURE_FIELD}.make ("writechannel_inuse"),
					create {CE_STRUCTURE_FIELD}.make ("server_supports_pipelining"),
					create {CE_STRUCTURE_FIELD}.make ("send_pipe"),
					create {CE_STRUCTURE_FIELD}.make ("recv_pipe"),
					create {CE_STRUCTURE_FIELD}.make ("pend_pipe"),
					create {CE_STRUCTURE_FIELD}.make ("done_pipe"),
					create {CE_STRUCTURE_FIELD}.make ("master_buffer"),
					create {CE_STRUCTURE_FIELD}.make ("read_pos"),
					create {CE_STRUCTURE_FIELD}.make ("buf_len"),
					create {CE_STRUCTURE_FIELD}.make ("seek_func"),
					create {CE_STRUCTURE_FIELD}.make ("seek_client"),
					create {CE_STRUCTURE_FIELD}.make ("fread_func"),
					create {CE_STRUCTURE_FIELD}.make ("fread_in"),
					create {CE_STRUCTURE_FIELD}.make ("ntlm"),
					create {CE_STRUCTURE_FIELD}.make ("proxyntlm"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("syserr_buf", <<256>>),
					create {CE_STRUCTURE_FIELD}.make ("trailer"),
					create {CE_STRUCTURE_FIELD}.make ("trlMax"),
					create {CE_STRUCTURE_FIELD}.make ("trlPos"),
					create {CE_STRUCTURE_FIELD}.make ("proto"),
					create {CE_STRUCTURE_FIELD}.make ("cselect_bits"),
					create {CE_STRUCTURE_FIELD}.make ("waitfor"),
					create {CE_STRUCTURE_FIELD}.make ("verifypeer"),
					create {CE_STRUCTURE_FIELD}.make ("verifyhost")
				>>)
			init_structure_info
		end

end
