class
	PD_SESSIONHANDLE

inherit
	PD_SESSIONHANDLE_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_TIME_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_UNISTD_STATIC
		redefine
			copy,
			is_equal
		end
	S_SYS_SOCKET_STATIC
		redefine
			copy,
			is_equal
		end
	S_CTYPE_STATIC
		redefine
			copy,
			is_equal
		end
	S_SIGNAL_STATIC
		redefine
			copy,
			is_equal
		end
	S_PWD_STATIC
		redefine
			copy,
			is_equal
		end
	S_BITS_ERRNO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create dns.make
			create {CE_CLASS_POINTER [PD_CURL_MULTI]} multi.make
			create {CE_CLASS_POINTER [PD_CURL_ONE_EASY]} multi_pos.make
			create {CE_CLASS_POINTER [PD_CURL_SHARE]} share.make
			create req.make
			create set.make
			create change.make
			create {CE_CLASS_POINTER [PD_COOKIEINFO]} cookies.make
			create progress.make
			create state.make
			create wildcard.make
			create info.make
			Precursor
		end

feature {ANY} -- fields

	dns: PD_NAMES assign set_dns

	multi: CE_POINTER [PD_CURL_MULTI] assign set_multi

	multi_pos: CE_POINTER [PD_CURL_ONE_EASY] assign set_multi_pos

	share: CE_POINTER [PD_CURL_SHARE] assign set_share

	req: PD_SINGLEREQUEST assign set_req

	set: PD_USERDEFINED assign set_set

	change: PD_DYNAMICSTATIC assign set_change

	cookies: CE_POINTER [PD_COOKIEINFO] assign set_cookies

	progress: PD_PROGRESS assign set_progress

	state: PD_URLSTATE assign set_state

	wildcard: PD_WILDCARDDATA assign set_wildcard

	info: PD_PUREINFO assign set_info

	magic: NATURAL_32 assign set_magic

feature {ANY} -- field setters

	set_dns (a_dns: PD_NAMES)
		do
			dns := a_dns
			update_memory_field ("dns")
		end

	set_multi (a_multi: CE_POINTER [PD_CURL_MULTI])
		do
			multi := a_multi
			update_memory_field ("multi")
		end

	set_multi_pos (a_multi_pos: CE_POINTER [PD_CURL_ONE_EASY])
		do
			multi_pos := a_multi_pos
			update_memory_field ("multi_pos")
		end

	set_share (a_share: CE_POINTER [PD_CURL_SHARE])
		do
			share := a_share
			update_memory_field ("share")
		end

	set_req (a_req: PD_SINGLEREQUEST)
		do
			req := a_req
			update_memory_field ("req")
		end

	set_set (a_set: PD_USERDEFINED)
		do
			set := a_set
			update_memory_field ("set")
		end

	set_change (a_change: PD_DYNAMICSTATIC)
		do
			change := a_change
			update_memory_field ("change")
		end

	set_cookies (a_cookies: CE_POINTER [PD_COOKIEINFO])
		do
			cookies := a_cookies
			update_memory_field ("cookies")
		end

	set_progress (a_progress: PD_PROGRESS)
		do
			progress := a_progress
			update_memory_field ("progress")
		end

	set_state (a_state: PD_URLSTATE)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_wildcard (a_wildcard: PD_WILDCARDDATA)
		do
			wildcard := a_wildcard
			update_memory_field ("wildcard")
		end

	set_info (a_info: PD_PUREINFO)
		do
			info := a_info
			update_memory_field ("info")
		end

	set_magic (a_magic: NATURAL_32)
		do
			magic := a_magic
			update_memory_field ("magic")
		end

feature {PD_SESSIONHANDLE} -- private attributes

	telnetoptions: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("BINARY"),
					ce_string ("ECHO"),
					ce_string ("RCP"),
					ce_string ("SUPPRESS GO AHEAD"),
					ce_string ("NAME"),
					ce_string ("STATUS"),
					ce_string ("TIMING MARK"),
					ce_string ("RCTE"),
					ce_string ("NAOL"),
					ce_string ("NAOP"),
					ce_string ("NAOCRD"),
					ce_string ("NAOHTS"),
					ce_string ("NAOHTD"),
					ce_string ("NAOFFD"),
					ce_string ("NAOVTS"),
					ce_string ("NAOVTD"),
					ce_string ("NAOLFD"),
					ce_string ("EXTEND ASCII"),
					ce_string ("LOGOUT"),
					ce_string ("BYTE MACRO"),
					ce_string ("DE TERMINAL"),
					ce_string ("SUPDUP"),
					ce_string ("SUPDUP OUTPUT"),
					ce_string ("SEND LOCATION"),
					ce_string ("TERM TYPE"),
					ce_string ("END OF RECORD"),
					ce_string ("TACACS UID"),
					ce_string ("OUTPUT MARKING"),
					ce_string ("TTYLOC"),
					ce_string ("3270 REGIME"),
					ce_string ("X3 PAD"),
					ce_string ("NAWS"),
					ce_string ("TERM SPEED"),
					ce_string ("LFLOW"),
					ce_string ("LINEMODE"),
					ce_string ("XDISPLOC"),
					ce_string ("OLD-ENVIRON"),
					ce_string ("AUTHENTICATION"),
					ce_string ("ENCRYPT"),
					ce_string ("NEW-ENVIRON")
				>>)
		end

	telnetcmds: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("EOF"),
					ce_string ("SUSP"),
					ce_string ("ABORT"),
					ce_string ("EOR"),
					ce_string ("SE"),
					ce_string ("NOP"),
					ce_string ("DMARK"),
					ce_string ("BRK"),
					ce_string ("IP"),
					ce_string ("AO"),
					ce_string ("AYT"),
					ce_string ("EC"),
					ce_string ("EL"),
					ce_string ("GA"),
					ce_string ("SB"),
					ce_string ("WILL"),
					ce_string ("WONT"),
					ce_string ("DO"),
					ce_string ("DONT"),
					ce_string ("IAC")
				>>)
		end

	s_infotype: CE_STATIC [CE_ARRAY [CE_ARRAY [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_ARRAY_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("* %/0/"),
					ce_string ("< %/0/"),
					ce_string ("> %/0/"),
					ce_string ("{ %/0/"),
					ce_string ("} %/0/"),
					ce_string ("{ %/0/"),
					ce_string ("} %/0/")
				>>)
		end

	protocols: CE_STATIC [CE_ARRAY [CE_POINTER [PD_CURL_HANDLER]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					Curl_handler_http.item,
					((create {P_FTP_STATIC}).Curl_handler_ftp.item),
					Curl_handler_telnet.item,
					Curl_handler_dict.item,
					Curl_handler_file.item,
					Curl_handler_tftp.item,
					((create {P_IMAP_STATIC}).Curl_handler_imap.item),
					((create {P_POP3_STATIC}).Curl_handler_pop3.item),
					((create {P_SMTP_STATIC}).Curl_handler_smtp.item),
					Curl_handler_rtsp.item,
					Curl_handler_gopher.item,
					create {CE_CLASS_POINTER [PD_CURL_HANDLER]}.make_shared (default_pointer)
				>>)
		end

	Curl_handler_file: CE_STATIC [CE_ARRAY [PD_CURL_HANDLER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					create {PD_CURL_HANDLER}.make_initialized ([ce_string ("FILE"), create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).file_do_address, (create {PD_CONNECTDATA_STATIC}).file_done_address, create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).file_connect_address, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, ((1).bit_shift_left (10)).to_integer_32])
				>>)
		end

	Curl_handler_http: CE_STATIC [CE_ARRAY [PD_CURL_HANDLER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					create {PD_CURL_HANDLER}.make_initialized ([ce_string ("HTTP"), create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).Curl_http_address, (create {PD_CONNECTDATA_STATIC}).Curl_http_done_address, create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).Curl_http_connect_address, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).http_getsock_do_address, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 80, 1])
				>>)
		end

	Curl_handler_dummy: CE_STATIC [CE_ARRAY [PD_CURL_HANDLER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					create {PD_CURL_HANDLER}.make_initialized ([ce_string ("<no protocol>"), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0])
				>>)
		end

	Curl_handler_dict: CE_STATIC [CE_ARRAY [PD_CURL_HANDLER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					create {PD_CURL_HANDLER}.make_initialized ([ce_string ("DICT"), create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).dict_do_address, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 2_628, ((1).bit_shift_left (9)).to_integer_32])
				>>)
		end

	Curl_handler_telnet: CE_STATIC [CE_ARRAY [PD_CURL_HANDLER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					create {PD_CURL_HANDLER}.make_initialized ([ce_string ("TELNET"), create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).telnet_do_address, (create {PD_CONNECTDATA_STATIC}).telnet_done_address, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 23, ((1).bit_shift_left (6)).to_integer_32])
				>>)
		end

	Curl_handler_tftp: CE_STATIC [CE_ARRAY [PD_CURL_HANDLER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					create {PD_CURL_HANDLER}.make_initialized ([ce_string ("TFTP"), (create {PD_CONNECTDATA_STATIC}).tftp_setup_connection_address, (create {PD_CONNECTDATA_STATIC}).tftp_do_address, (create {PD_CONNECTDATA_STATIC}).tftp_done_address, create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).tftp_connect_address, (create {PD_CONNECTDATA_STATIC}).tftp_multi_statemach_address, (create {PD_CONNECTDATA_STATIC}).tftp_doing_address, (create {PD_CONNECTDATA_STATIC}).tftp_getsock_address, (create {PD_CONNECTDATA_STATIC}).tftp_getsock_address, create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).tftp_disconnect_address, 69, ((1).bit_shift_left (11)).to_integer_32])
				>>)
		end

	KEY_NOTUSED___0: CE_STATIC [SD_TIMEVAL]
		once ("PROCESS")
			Result.item := create {SD_TIMEVAL}.make_initialized ([(-1).to_integer_32, (-1).to_integer_32])
		end

	Curl_handler_rtsp: CE_STATIC [CE_ARRAY [PD_CURL_HANDLER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					create {PD_CURL_HANDLER}.make_initialized ([ce_string ("RTSP"), create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).Curl_rtsp_address, (create {PD_CONNECTDATA_STATIC}).Curl_rtsp_done_address, create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).Curl_rtsp_connect_address, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).rtsp_getsock_do_address, create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).Curl_rtsp_disconnect_address, 554, ((1).bit_shift_left (18)).to_integer_32])
				>>)
		end

	Curl_handler_gopher: CE_STATIC [CE_ARRAY [PD_CURL_HANDLER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					create {PD_CURL_HANDLER}.make_initialized ([ce_string ("GOPHER"), create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).gopher_do_address, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 70, ((1).bit_shift_left (25)).to_integer_32])
				>>)
		end

feature {ANY} -- public routines

	Curl_hostcache_prune
		local
			l_now: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_now.make (<<1>>)

			if set.dns_cache_timeout = -1 then
				l_return := True
			elseif (dns.hostcache).is_void then
				l_return := True
			end
			if not l_return then
				if (not share.is_void) then
					((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_share_lock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_DNS, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				time (l_now).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				hostcache_prune (dns.hostcache, set.dns_cache_timeout, l_now.item)
				update_class_fields -- Current might have been changed; synchronize
				if (not share.is_void) then
					((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_share_unlock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_DNS).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	remove_entry_if_stale (a_dns: CE_POINTER [PD_CURL_DNS_ENTRY]): INTEGER_32
		local
			l_user: CE_ARRAY [PD_HOSTCACHE_PRUNE_DATA]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_HOSTCACHE_PRUNE_DATA]} l_user.make (<<1>>)

			if a_dns.is_void then
				Result := 0
				l_return := True
			elseif set.dns_cache_timeout = -1 then
				Result := 0
				l_return := True
			elseif (dns.hostcache).is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				time (create {CE_INTEGER_32_POINTER}.make_shared (l_user.item.c_pointer + (create {PD_HOSTCACHE_PRUNE_DATA}.make).offset_of ("now"))).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_user.item.cache_timeout := set.dns_cache_timeout
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := hostcache_timestamp_remove (create {CE_VOID_POINTER}.make_cast (l_user), create {CE_VOID_POINTER}.make_cast (a_dns))
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp.to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Curl_hash_clean_with_criterium (dns.hostcache, create {CE_VOID_POINTER}.make_cast (l_user), hostcache_timestamp_remove_address)
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
			end
		end

	Curl_resolv_unlock (a_dns: CE_POINTER [PD_CURL_DNS_ENTRY])
		require
			not a_dns.is_void
		do
			if (not share.is_void) then
				((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_share_lock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_DNS, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			a_dns.item.inuse := (a_dns.item.inuse) - 1
			update_class_fields -- Current might have been changed; synchronize
			if a_dns.item.inuse = 0 then
				if a_dns.item.timestamp = 0 then
					(create {P_CURL_ADDRINFO_STATIC}).Curl_freeaddrinfo (a_dns.item.addr)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_dns)])
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if (not share.is_void) then
				((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_share_unlock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_DNS).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	Curl_pgrsResetTimes
		do
			progress.t_nslookup := 0.0
			update_class_fields -- Current might have been changed; synchronize
			progress.t_connect := 0.0
			update_class_fields -- Current might have been changed; synchronize
			progress.t_pretransfer := 0.0
			update_class_fields -- Current might have been changed; synchronize
			progress.t_starttransfer := 0.0
			update_class_fields -- Current might have been changed; synchronize
		end

	Curl_pgrsStartNow
		do
			progress.speeder_c := 0
			update_class_fields -- Current might have been changed; synchronize
			progress.start := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
			update_class_fields -- Current might have been changed; synchronize
		end

	Curl_pgrsSetDownloadCounter (a_size: INTEGER_64)
		do
			progress.downloaded := a_size
			update_class_fields -- Current might have been changed; synchronize
		end

	Curl_pgrsSetUploadCounter (a_size: INTEGER_64)
		do
			progress.uploaded := a_size
			update_class_fields -- Current might have been changed; synchronize
		end

	Curl_pgrsSetDownloadSize (a_size: INTEGER_64)
		do
			progress.size_dl := a_size
			update_class_fields -- Current might have been changed; synchronize
			if a_size >= {INTEGER_64} 0 then
				progress.flags := (progress.flags).bit_or (((1).bit_shift_left (6)))
				update_class_fields -- Current might have been changed; synchronize
			else
				progress.flags := (progress.flags).bit_and (((((1).bit_shift_left (6))).bit_not))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	Curl_pgrsSetUploadSize (a_size: INTEGER_64)
		do
			progress.size_ul := a_size
			update_class_fields -- Current might have been changed; synchronize
			if a_size >= {INTEGER_64} 0 then
				progress.flags := (progress.flags).bit_or (((1).bit_shift_left (5)))
				update_class_fields -- Current might have been changed; synchronize
			else
				progress.flags := (progress.flags).bit_and (((((1).bit_shift_left (5))).bit_not))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	Curl_cookie_loadfiles
		local
			l_list: CE_POINTER [PD_CURL_SLIST]
		do
			l_list := change.cookielist
			if (not l_list.is_void) then
				((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_share_lock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					l_list.is_void
				loop
					Current.cookies := (create {P_COOKIE_STATIC}).Curl_cookie_init ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), l_list.item.data, cookies, set.cookiesession)
					update_class_fields -- Current might have been changed; synchronize
					l_list := l_list.item.next
				end
				((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_share_unlock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SLIST_STATIC}).curl_slist_free_all (change.cookielist)
				update_class_fields -- Current might have been changed; synchronize
				change.cookielist := create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	Curl_cookie_list: CE_POINTER [PD_CURL_SLIST]
		local
			l_list: CE_POINTER [PD_CURL_SLIST]
			l_beg: CE_POINTER [PD_CURL_SLIST]
			l_c: CE_POINTER [PD_COOKIE]
			l_line: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_list := create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer)
			if cookies.is_void then
				Result := (create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer))
				l_return := True
			elseif cookies.item.numcookies = 0 then
				Result := (create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_c := cookies.item.cookies
				l_beg := l_list
				from
				until
					not (not (l_return) and then (not l_c.is_void))
				loop
					l_line := get_netscape_format (l_c)
					update_class_fields -- Current might have been changed; synchronize
					if l_line.is_void then
						(create {P_SLIST_STATIC}).curl_slist_free_all (l_beg)
						update_class_fields -- Current might have been changed; synchronize
						Result := (create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						l_list := (create {P_SLIST_STATIC}).curl_slist_append (l_list, l_line)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_line)])
						update_class_fields -- Current might have been changed; synchronize
						if l_list.is_void then
							(create {P_SLIST_STATIC}).curl_slist_free_all (l_beg)
							update_class_fields -- Current might have been changed; synchronize
							Result := (create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer))
							l_return := True
						elseif l_beg.is_void then
							l_beg := l_list
						end
					end
					if not l_return then
						l_c := l_c.item.next
					end
				end
			end
			if not l_return then
				Result := l_list
			end
		end

	checkhttpprefix (a_s: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_head: CE_POINTER [PD_CURL_SLIST]
			l_rc: BOOLEAN
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: INTEGER_32
			l_break: BOOLEAN
		do
			l_head := set.http200aliases
			l_rc := (0).to_boolean
			from
			until
				not (not (l_break) and then (not l_head.is_void))
			loop
				l_break := False
				l_tmp := strlen (l_head.item.data)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (l_head.item.data, a_s, l_tmp)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					l_rc := (1).to_boolean
					l_break := True
				end
				if not (l_break) then
					l_head := l_head.item.next
				end
			end
			l_break := False
			if l_rc.to_integer /= 1 then
				l_tmp___1 := strlen (ce_string ("HTTP/"))
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___2 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("HTTP/"), a_s, l_tmp___1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___2.to_boolean then
					l_rc := (1).to_boolean
				end
			end
			Result := l_rc
		end

	checkprotoprefix (a_conn: CE_POINTER [PD_CONNECTDATA]; a_s: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_conn.is_void
		local
			l_tmp: BOOLEAN
			l_tmp___0: BOOLEAN
			l_return: BOOLEAN
		do
			if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
				l_tmp := checkrtspprefix ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), a_s)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp
				l_return := True
			end
			if not l_return then
				l_tmp___0 := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.checkhttpprefix (a_s)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___0
			end
		end

	header_append (a_k: CE_POINTER [PD_SINGLEREQUEST]; a_length: NATURAL_32): NATURAL_32
		require
			not a_k.is_void
		local
			l_newbuff: CE_POINTER [INTEGER_8]
			l_hbufp_index: NATURAL_32
			l_newsize: NATURAL_32
			l_tmp: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			if a_k.item.hbuflen + a_length >= state.headersize then
				if a_k.item.hbuflen + a_length > {NATURAL_32} 102_400 then
					((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_failf ([ce_string ("Avoided giant realloc for header (max is %%d)!"), 102_400])
					update_class_fields -- Current might have been changed; synchronize
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
				if not l_return then
					if ((a_k.item.hbuflen + a_length) * {NATURAL_32} 3) // {NATURAL_32} 2 > state.headersize * {NATURAL_32} 2 then
						l_newsize := ((a_k.item.hbuflen + a_length) * {NATURAL_32} 3) // {NATURAL_32} 2
					else
						l_newsize := state.headersize * {NATURAL_32} 2
					end
					l_hbufp_index := ((a_k.item.hbufp).distance ((state.headerbuff))).to_natural_32
					l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_crealloc.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (state.headerbuff), l_newsize]))
					update_class_fields -- Current might have been changed; synchronize
					l_newbuff := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)
					if l_newbuff.is_void then
						((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_failf ([ce_string ("Failed to alloc memory for big header!")])
						update_class_fields -- Current might have been changed; synchronize
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						l_return := True
					end
				end
				if not l_return then
					state.headersize := l_newsize
					update_class_fields -- Current might have been changed; synchronize
					state.headerbuff := l_newbuff
					update_class_fields -- Current might have been changed; synchronize
					a_k.item.hbufp := state.headerbuff + l_hbufp_index.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (a_k.item.hbufp), create {CE_VOID_POINTER}.make_cast (a_k.item.str_start), a_length).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				a_k.item.hbufp := a_k.item.hbufp + a_length.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				a_k.item.hbuflen := a_k.item.hbuflen + a_length
				update_class_fields; -- Current might have been changed; synchronize
				(a_k.item.hbufp).item := (0).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_failf (a_args: TUPLE [a_fmt: CE_POINTER [INTEGER_8]])
		local
			l_ap: CE_VA_LIST
			l_len: NATURAL_32
		do
			create l_ap.make_shared (default_pointer)

			l_ap := create {CE_VA_LIST}.make (a_args, agent Curl_failf);
			(create {P_MPRINTF_STATIC}).curl_mvsnprintf (state.buffer, (16_384).to_natural_32, a_args.a_fmt, l_ap.twin).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			if (not (set.errorbuffer).is_void) then
				if not state.errorbuf then
					(create {P_MPRINTF_STATIC}).curl_msnprintf ([set.errorbuffer, (256).to_natural_32, ce_string ("%%s"), state.buffer]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					state.errorbuf := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if set.verbose then
				l_len := strlen ((state.buffer))
				update_class_fields -- Current might have been changed; synchronize
				if l_len < {NATURAL_32} 16_383 then
					state.buffer[l_len.to_integer_32] := (('%N').code).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_len := l_len + 1
					state.buffer[l_len.to_integer_32] := (('%/0/').code).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
				end
				((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_debug ({PC_CURL_INFOTYPE}.CURLINFO_TEXT, state.buffer, l_len, create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	showit (a_type: NATURAL_32; a_ptr: CE_POINTER [INTEGER_8]; a_size: NATURAL_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (not (set.fdebug).is_void) then
						l_tmp := (set.fdebug).integer_32_item ([create {CE_VOID_POINTER}.make_shared (c_pointer), a_type, a_ptr, a_size, set.debugdata])
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						inspect a_type.to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 2
						else l_pos := -1 + 3
						end
				when 2 then -- switch 1, case 0 | switch 1, case 2 | switch 1, case 1
						fwrite (create {CE_VOID_POINTER}.make_cast ((s_infotype.item[a_type.to_integer_32])), (2).to_natural_32, (1).to_natural_32, set.err).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						fwrite (create {CE_VOID_POINTER}.make_cast (a_ptr), a_size, (1).to_natural_32, set.err).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
						l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
						Result := 0
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_debug (a_type: NATURAL_32; a_ptr: CE_POINTER [INTEGER_8]; a_size: NATURAL_32; a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_rc: INTEGER_32
			l_buffer: CE_ARRAY [INTEGER_8]
			l_t: CE_POINTER [INTEGER_8]
			l_w: CE_POINTER [INTEGER_8]
			l_tmp: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_buffer.make (<<160>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (set.printhost) then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						if a_conn.is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						if (a_conn.item.host.dispname).is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						l_t := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						l_w := ce_string ("Data")
						inspect a_type.to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 4
						when 3 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 6
						when 4 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 4 then -- switch 1, case 1
						l_w := ce_string ("Header")
				when 5 then -- switch 1, case 3
						l_t := ce_string ("from")
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 2
						l_w := ce_string ("Header")
				when 7 then -- switch 1, case 4
						l_t := ce_string ("to")
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, default:
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done:
						if (not l_t.is_void) then
							(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_buffer, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (160).to_natural_32), ce_string ("[%%s %%s %%s]"), l_w, l_t, a_conn.item.host.dispname]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_tmp := strlen (l_buffer)
							update_class_fields -- Current might have been changed; synchronize
							l_rc := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.showit ({PC_CURL_INFOTYPE}.CURLINFO_TEXT, l_buffer, l_tmp)
							update_class_fields -- Current might have been changed; synchronize
							if l_rc.to_boolean then
								Result := l_rc
								l_return := True
							end
						end
				when 10 then -- if done | if done | if done
					if not l_return then
						l_rc := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.showit (a_type, a_ptr, a_size)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_rc
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_dupset (a_src: CE_POINTER [PD_SESSIONHANDLE]): NATURAL_32
		require
			not a_src.is_void
		local
			l_r: NATURAL_32
			l_i: NATURAL_32
			l_break: BOOLEAN
		do
			l_r := {PC_CURLCODE}.CURLE_OK
			Current.set := (a_src.item.set).twin
			update_class_fields -- Current might have been changed; synchronize
			memset (create {CE_VOID_POINTER}.make_cast ((set.str)), 0, {NATURAL_32} 37 * {PLATFORM}.Pointer_bytes.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_i := {PC_DUPSTRING}.STRING_CERT
			from
			until
				not (not (l_break) and then (l_i < {NATURAL_32} 37))
			loop
				l_break := False
				l_r := (create {P_URL_STATIC}).setstropt (create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("str") + {PLATFORM}.Pointer_bytes * (l_i.to_integer_32)), a_src.item.set.str[l_i.to_integer_32])
				update_class_fields -- Current might have been changed; synchronize
				if l_r /= {NATURAL_32} 0 then
					l_break := True
				end
				if not (l_break) then
					l_i := (l_i + {NATURAL_32} 1)
				end
			end
			l_break := False
			Result := l_r
		end

	flush_cookies (a_cleanup: INTEGER_32)
		local
			l_tmp: INTEGER_32
		do
			if (not (set.str[3]).is_void) then
				if (not (change.cookielist).is_void) then
					((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_cookie_loadfiles
					update_class_fields -- Current might have been changed; synchronize
				end
				((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_share_lock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := Curl_cookie_output (cookies, set.str[3])
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("WARNING: failed to save cookies in %%s%N"), set.str[3]])
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				if a_cleanup.to_boolean then
					if (not (change.cookielist).is_void) then
						(create {P_SLIST_STATIC}).curl_slist_free_all (change.cookielist)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_share_lock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			if a_cleanup.to_boolean then
				if share.is_void then
					(create {P_COOKIE_STATIC}).Curl_cookie_cleanup (cookies)
					update_class_fields -- Current might have been changed; synchronize
				elseif not cookies.is_equal (share.item.cookies) then
					(create {P_COOKIE_STATIC}).Curl_cookie_cleanup (cookies)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_share_unlock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE).do_nothing
			update_class_fields -- Current might have been changed; synchronize
		end

	Curl_close: NATURAL_32
		local
			l_m: CE_POINTER [PD_CURL_MULTI]
			l_return: BOOLEAN
		do
			l_m := multi;
			((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_expire (0)
			update_class_fields -- Current might have been changed; synchronize
			if (not l_m.is_void) then
				(create {P_MULTI_STATIC}).curl_multi_remove_handle (create {CE_VOID_POINTER}.make_cast (multi), create {CE_VOID_POINTER}.make_shared (c_pointer)).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not (state.timeoutlist).is_void) then
				(create {P_LLIST_STATIC}).Curl_llist_destroy (state.timeoutlist, create {CE_VOID_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				state.timeoutlist := create {CE_CLASS_POINTER [PD_CURL_LLIST]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.magic := {NATURAL_32} 0
			update_class_fields -- Current might have been changed; synchronize
			if (not (state.connc).is_void) then
				if (state.connc).item.type = {NATURAL_32} 0 then
					((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.close_connections
					update_class_fields; -- Current might have been changed; synchronize
					(state.connc).item.Curl_rm_connc
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if (not (state.shared_conn).is_void) then
				state.closed := (1).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
				l_return := True
			end
			if not l_return then
				if dns.hostcachetype = {NATURAL_32} 1 then
					(create {P_HASH_STATIC}).Curl_hash_destroy (dns.hostcache)
					update_class_fields -- Current might have been changed; synchronize
					dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_NONE
					update_class_fields -- Current might have been changed; synchronize
					dns.hostcache := create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
				end
				if state.rangestringalloc then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (state.range)])
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (state.pathbuffer))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_URL_STATIC}).Curl_safefree (state.proto.generic)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (state.first_host))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (state.scratch))
				update_class_fields -- Current might have been changed; synchronize
				if change.referer_alloc then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (change.referer)])
					update_class_fields -- Current might have been changed; synchronize
				end
				if change.url_alloc then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (change.url)])
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (state.headerbuff))
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.flush_cookies (1)
				update_class_fields -- Current might have been changed; synchronize
				Curl_digest_cleanup ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (info.contenttype))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (info.wouldredirect))
				update_class_fields -- Current might have been changed; synchronize
				if (not share.is_void) then
					((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_share_lock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_SHARE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					share.item.dirty := share.item.dirty - (1).to_natural_32
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_share_unlock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_SHARE).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_URL_STATIC}).Curl_freeset ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_shared (c_pointer)])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	IsPipeliningPossible: BOOLEAN
		local
			l_tmp: BOOLEAN
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if multi.is_void then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_tmp := multi.item.Curl_multi_canPipeline
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if set.httpreq /= {NATURAL_32} 1 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if set.httpreq /= {NATURAL_32} 5 then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						if set.httpversion /= 1 then
							Result := (1).to_boolean
							l_return := True
						end
				when 7 then -- if done | if done | if done
					if not l_return then
						Result := (0).to_boolean
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_isPipeliningEnabled: BOOLEAN
		local
			l_tmp: BOOLEAN
			l_return: BOOLEAN
		do
			if (not multi.is_void) then
				l_tmp := multi.item.Curl_multi_canPipeline
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp then
					Result := (1).to_boolean
					l_return := True
				end
			end
			if not l_return then
				Result := (0).to_boolean
			end
		end

	ConnectionExists (a_needle: CE_POINTER [PD_CONNECTDATA]; a_usethis: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]): BOOLEAN
		local
			l_i: INTEGER_32
			l_check: CE_POINTER [PD_CONNECTDATA]
			l_canPipeline: BOOLEAN
			l_tmp: BOOLEAN
			l_match: BOOLEAN
			l_pipeLen: NATURAL_32
			l_dead: BOOLEAN
			l_sh: CE_POINTER [PD_SESSIONHANDLE]
			l_tmp___0: CE_POINTER [PD_SESSIONHANDLE]
			l_rh: CE_POINTER [PD_SESSIONHANDLE]
			l_tmp___1: CE_POINTER [PD_SESSIONHANDLE]
			l_tmp___2: BOOLEAN
			l_tmp___3: BOOLEAN
			l_tmp___4: BOOLEAN
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.IsPipeliningPossible
					update_class_fields -- Current might have been changed; synchronize
					l_canPipeline := l_tmp
					l_i := 0
				when 1 then -- loop condition:
					if not (not (l_return) and then (l_i < (state.connc).item.num)) then
						l_pos := -1 + 39 -- skip loop
					end
				when 2 then -- loop body:
						l_continue := False
						l_match := (0).to_boolean
						l_pipeLen := (0).to_natural_32
						l_check := (state.connc).item.connects[l_i]
						if l_check.is_void then
							l_continue := True
						end
						if not (l_return or l_continue) then
							l_pipeLen := (l_check.item.send_pipe).item.size + (l_check.item.recv_pipe).item.size
							if l_check.item.connectindex = -1 then
								l_check.item.connectindex := l_i
								update_class_fields -- Current might have been changed; synchronize
							end
							if not l_pipeLen.to_boolean then
								if not l_check.item.inuse then
									if ((l_check.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
										l_dead := RTSPConnIsDead (l_check)
										update_class_fields -- Current might have been changed; synchronize
									else
										l_dead := SocketIsDead (l_check.item.sock[0])
										update_class_fields -- Current might have been changed; synchronize
									end
									if l_dead then
										l_check.item.data := (create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("Connection #%%ld seems to be dead!%N"), l_i])
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_URL_STATIC}).Curl_disconnect (l_check).do_nothing
										update_class_fields; -- Current might have been changed; synchronize
										(state.connc).item.connects[l_i] := create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
										update_class_fields -- Current might have been changed; synchronize
										l_continue := True
									end
								end
							end
						end
						if not (l_return or l_continue) then
							if l_canPipeline then
								l_tmp___0 := (l_check.item.send_pipe).item.gethandleathead
								update_class_fields -- Current might have been changed; synchronize
								l_sh := l_tmp___0
								l_tmp___1 := (l_check.item.recv_pipe).item.gethandleathead
								update_class_fields -- Current might have been changed; synchronize
								l_rh := l_tmp___1
								if (not l_sh.is_void) then
									l_tmp___2 := l_sh.item.IsPipeliningPossible
									update_class_fields -- Current might have been changed; synchronize
									if not l_tmp___2 then
										l_continue := True
									end
								elseif (not l_rh.is_void) then
									l_tmp___3 := l_rh.item.IsPipeliningPossible
									update_class_fields -- Current might have been changed; synchronize
									if not l_tmp___3 then
										l_continue := True
									end
								end
							else
								if l_pipeLen > {NATURAL_32} 0 then
									l_continue := True
								end
								if not (l_return or l_continue) then
									if l_check.item.sock[0] = -1 then
										(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("Connection #%%ld isn%'t open enough, can%'t reuse%N"), l_check.item.connectindex])
										update_class_fields -- Current might have been changed; synchronize
										l_continue := True
									elseif l_check.item.bits.close then
										(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("Connection #%%ld isn%'t open enough, can%'t reuse%N"), l_check.item.connectindex])
										update_class_fields -- Current might have been changed; synchronize
										l_continue := True
									end
								end
							end
						end
						if not (l_return or l_continue) and then (((a_needle.item.protocol).bit_and (((1).bit_shift_left (29)).to_integer_32)) /= ((l_check.item.protocol).bit_and (((1).bit_shift_left (29)).to_integer_32))) then
							l_continue := True
						end
						if not (l_return or l_continue) and then (((a_needle.item.protocol).bit_and (((1).bit_shift_left (29)).to_integer_32)).to_boolean) then
							if set.ssl.verifypeer /= l_check.item.verifypeer then
								l_continue := True
							elseif set.ssl.verifyhost /= l_check.item.verifyhost then
								l_continue := True
							end
						end
						if not (l_return or l_continue) and then ((a_needle.item.bits.proxy).to_integer /= (l_check.item.bits.proxy).to_integer) then
							l_continue := True
						end
						if not (l_return or l_continue) and then (not l_canPipeline) then
							if l_check.item.inuse then
								l_continue := True
							end
						end
						if (l_return or l_continue) then
							l_pos := -1 + 38 -- skip if block
						end
				when 3 then -- if:
						if a_needle.item.bits.httpproxy then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 15 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 6 then -- else:
						if not (((a_needle.item.protocol).bit_and (((1).bit_shift_left (29)).to_integer_32)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 15 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 9 then -- else:
						if not (a_needle.item.bits.httpproxy) then
							l_pos := -1 + 37 -- skip if block
						end
				when 10 then -- if:
						if not (l_check.item.bits.httpproxy) then
							l_pos := -1 + 35 -- skip if block
						end
				when 11 then -- if:
						if not (a_needle.item.bits.tunnel_proxy) then
							l_pos := -1 + 33 -- skip if block
						end
				when 12 then -- if:
						if not (l_check.item.bits.tunnel_proxy) then
							l_pos := -1 + 31 -- skip if block
						end
				when 13 then -- if:
						l_tmp___10 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (a_needle.item.proxy.name, l_check.item.proxy.name)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___10.to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 14 then -- if:
						if a_needle.item.port /= l_check.item.port then
							l_pos := -1 + 27 -- skip if block
						end
				when 15 then -- if: | _L___0:
						l_tmp___7 := (create {P_RAWSTR_STATIC}).Curl_raw_equal ((a_needle.item.handler).item.scheme, (l_check.item.handler).item.scheme)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___7.to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 16 then -- if:
						l_tmp___8 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (a_needle.item.host.name, l_check.item.host.name)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___8.to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 17 then -- if:
						if (a_needle.item.remote_port).to_integer_32 /= (l_check.item.remote_port).to_integer_32 then
							l_pos := -1 + 26 -- skip if block
						end
				when 18 then -- if:
						if ((a_needle.item.protocol).bit_and (((1).bit_shift_left (29)).to_integer_32)).to_boolean then
							l_tmp___4 := (create {CE_CLASS_POINTER [PD_SSL_CONFIG_DATA]}.make_shared (a_needle.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("ssl_config"))).item.Curl_ssl_config_matches (create {CE_CLASS_POINTER [PD_SSL_CONFIG_DATA]}.make_shared (l_check.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("ssl_config")))
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___4 then
								if l_check.item.ssl[0].state /= {NATURAL_32} 2 then
									l_continue := True
								end
							else
								l_continue := True
							end
						end
						if (l_return or l_continue) then
							l_pos := -1 + 25 -- skip if block
						end
				when 19 then -- if:
						if not (((a_needle.item.protocol).bit_and (((1).bit_shift_left (2)).to_integer_32)).to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 24 -- goto _L
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 22 then -- else:
						if not (((a_needle.item.protocol).bit_and (1)).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if state.authhost.want /= ((1).bit_shift_left (3)).to_integer_32 then
							l_pos := -1 + 25 -- skip if block
						end
				when 24 then -- if: | _L:
						l_tmp___5 := (create {P_STREQUAL_STATIC}).curl_strequal (a_needle.item.user, l_check.item.user)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___5.to_boolean then
							l_tmp___6 := (create {P_STREQUAL_STATIC}).curl_strequal (a_needle.item.passwd, l_check.item.passwd)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___6.to_boolean then
								l_continue := True
							end
						else
							l_continue := True
						end
				when 25 then -- if done | if done | if done
						if not (l_return or l_continue) then
							l_match := (1).to_boolean
						end
				when 26 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else:
						l_pos := -1 + 37 -- goto _L___5
				when 28 then -- if done | if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						l_pos := -1 + 37 -- goto _L___5
				when 30 then -- if done | if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else:
						l_pos := -1 + 37 -- goto _L___5
				when 32 then -- if done | if block done, skip else block:
						l_pos := -1 + 34
				when 33 then -- else:
						l_pos := -1 + 37 -- goto _L___5
				when 34 then -- if done | if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else:
						l_pos := -1 + 37 -- goto _L___5
				when 36 then -- if done | if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else: | _L___5:
						if l_check.item.bits.proxy then
							if a_needle.item.proxytype = l_check.item.proxytype then
								if (a_needle.item.bits.tunnel_proxy).to_integer = (l_check.item.bits.tunnel_proxy).to_integer then
									l_tmp___9 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (a_needle.item.proxy.name, l_check.item.proxy.name)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___9.to_boolean then
										if a_needle.item.port = l_check.item.port then
											l_match := (1).to_boolean
										end
									end
								end
							end
						end
				when 38 then -- if done | if done | if done
						if not (l_return or l_continue) and then l_match then
							l_check.item.inuse := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							a_usethis.item := l_check
							update_class_fields -- Current might have been changed; synchronize
							Result := (1).to_boolean
							l_return := True
						end
						if (not l_return) then
							l_i := l_i + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 39 then -- loop done
					if not l_return then
						l_continue := False
						Result := (0).to_boolean
					end
				when 40 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ConnectionKillOne: INTEGER_32
		local
			l_i: INTEGER_32
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_highscore: INTEGER_32
			l_connindex: INTEGER_32
			l_score: INTEGER_32
			l_now: SD_TIMEVAL
			l_break, l_continue: BOOLEAN
		do
			create {CE_CLASS_POINTER [PD_CONNECTDATA]} l_conn.make

			l_highscore := -1
			l_connindex := -1
			l_now := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
			update_class_fields -- Current might have been changed; synchronize
			l_i := 0
			from
			until
				(l_break)
			loop
				l_break := False
				l_continue := False
				if (not (state.connc).is_void) then
					if not (l_i < (state.connc).item.num) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break or l_continue) then
					l_conn := (state.connc).item.connects[l_i]
					if l_conn.is_void then
						l_continue := True
					elseif l_conn.item.inuse then
						l_continue := True
					end
				end
				if not (l_break or l_continue) then
					l_score := (create {P_TIMEVAL_STATIC}).curlx_tvdiff (l_now.twin, (l_conn.item.now).twin)
					update_class_fields -- Current might have been changed; synchronize
					if l_score > l_highscore then
						l_highscore := l_score
						l_connindex := l_i
					end
				end
				if (not l_break) then
					l_i := l_i + 1
				end
			end
			l_break := False
			l_continue := False
			if l_connindex >= 0 then
				l_conn := (state.connc).item.connects[l_connindex]
				l_conn.item.data := (create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_URL_STATIC}).Curl_disconnect (l_conn).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(state.connc).item.connects[l_connindex] := create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l_connindex
		end

	ConnectionStore (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		require
			not a_conn.is_void
		local
			l_i: INTEGER_32
			l_break: BOOLEAN
		do
			l_i := 0
			from
			until
				not (not (l_break) and then (l_i < (state.connc).item.num))
			loop
				l_break := False
				if ((state.connc).item.connects[l_i]).is_void then
					l_break := True
				end
				if not (l_break) then
					l_i := l_i + 1
				end
			end
			l_break := False
			if l_i = (state.connc).item.num then
				l_i := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.ConnectionKillOne
				update_class_fields -- Current might have been changed; synchronize
				if -1 /= l_i then
					(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("Connection (#%%ld) was killed to make room (holds %%ld)%N"), l_i, (state.connc).item.num])
					update_class_fields -- Current might have been changed; synchronize
				else
					(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("This connection did not fit in the connection cache%N")])
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			a_conn.item.connectindex := l_i
			update_class_fields -- Current might have been changed; synchronize
			a_conn.item.inuse := (1).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			if -1 /= l_i then
				(state.connc).item.connects[l_i] := a_conn
				update_class_fields -- Current might have been changed; synchronize
				a_conn.item.data := (create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l_i
		end

	findprotocol (a_conn: CE_POINTER [PD_CONNECTDATA]; a_protostr: CE_POINTER [INTEGER_8]): NATURAL_32
		local
			l_pp: CE_POINTER [CE_POINTER [PD_CURL_HANDLER]]
			l_p: CE_POINTER [PD_CURL_HANDLER]
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_pp := protocols.item
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_p := l_pp.item
				if l_p.is_void then
					l_break := True
				end
				if not (l_return or l_break) then
					l_tmp := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_p.item.scheme, a_protostr)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						if not ((set.allowed_protocols).bit_and (l_p.item.protocol)).to_boolean then
							l_break := True
						end
						if not (l_return or l_break) and then (state.this_is_a_follow) then
							if not ((set.redir_protocols).bit_and (l_p.item.protocol)).to_boolean then
								l_break := True
							end
						end
						if not (l_return or l_break) then
							a_conn.item.handler := l_p
							update_class_fields -- Current might have been changed; synchronize
							a_conn.item.protocol := (a_conn.item.protocol).bit_or ((l_p.item.protocol))
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						end
					end
				end
				if not (l_return or l_break) then
					l_pp := l_pp + 1
				end
			end
			if not l_return then
				l_break := False;
				((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_failf ([ce_string ("Protocol %%s not supported or disabled in libcurl"), a_protostr])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_UNSUPPORTED_PROTOCOL)
			end
		end

	parseurlandfillconn (a_conn: CE_POINTER [PD_CONNECTDATA]; a_prot_missing: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_conn.is_void
			not a_prot_missing.is_void
		local
			l_at: CE_POINTER [INTEGER_8]
			l_fragment: CE_POINTER [INTEGER_8]
			l_path: CE_POINTER [INTEGER_8]
			l_query: CE_POINTER [INTEGER_8]
			l_rc: INTEGER_32
			l_protobuf: CE_ARRAY [INTEGER_8]
			l_protop: CE_POINTER [INTEGER_8]
			l_tmp: NATURAL_32
			l_ptr: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___3: INTEGER_32
			l_tmp___4: NATURAL_32
			l_tmp___5: INTEGER_32
			l_tmp___6: NATURAL_32
			l_tmp___7: INTEGER_32
			l_tmp___8: NATURAL_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_hostlen: NATURAL_32
			l_tmp___13: NATURAL_32
			l_pathlen: NATURAL_32
			l_tmp___14: NATURAL_32
			l_tmp___15: NATURAL_32
			l_percent: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_endp: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_scope: NATURAL_32
			l_tmp___17: NATURAL_32
			l_tmp___18: NATURAL_32
			l_tmp___19: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_protobuf.make (<<16>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_endp.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_path := state.path
					a_prot_missing.item := (0).to_boolean
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___11 := sscanf ([change.url, ce_string ("%%15[^:]:%%[^%N]"), l_protobuf, l_path])
					update_class_fields -- Current might have been changed; synchronize
					if 2 /= l_tmp___11 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_tmp___12 := (create {P_RAWSTR_STATIC}).Curl_raw_equal (l_protobuf, ce_string ("file"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___12.to_boolean then
							if (l_path[0]).to_integer_32 = 47 then
								if (l_path[1]).to_integer_32 = 47 then
									l_tmp := strlen ((l_path + 2))
									update_class_fields -- Current might have been changed; synchronize
									memmove (create {CE_VOID_POINTER}.make_cast (l_path), create {CE_VOID_POINTER}.make_cast ((l_path + 2)), l_tmp + {NATURAL_32} 1).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							if (l_path[0]).to_integer_32 /= 47 then
								l_tmp___0 := strchr (l_path, ('/').code)
								update_class_fields -- Current might have been changed; synchronize
								l_ptr := l_tmp___0
								if (not l_ptr.is_void) then
									if (l_ptr[1]).to_boolean then
										if 47 = (l_ptr[1]).to_integer_32 then
											l_ptr := l_ptr + 1
										end
									end
									l_tmp___1 := strlen (l_ptr)
									update_class_fields -- Current might have been changed; synchronize
									memmove (create {CE_VOID_POINTER}.make_cast (l_path), create {CE_VOID_POINTER}.make_cast (l_ptr), l_tmp___1 + {NATURAL_32} 1).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_protop := ce_string ("file")
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_path[0] := (0).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___10 := sscanf ([change.url, ce_string ("%%15[^%N:]://%%[^%N/]%%[^%N]"), l_protobuf, a_conn.item.host.name, l_path])
						update_class_fields -- Current might have been changed; synchronize
						if 2 > l_tmp___10 then
							l_rc := sscanf ([change.url, ce_string ("%%[^%N/]%%[^%N]"), a_conn.item.host.name, l_path])
							update_class_fields -- Current might have been changed; synchronize
							if 1 > l_rc then
								((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_failf ([ce_string ("<url> malformed")])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_URL_MALFORMAT)
								l_return := True
							end
							if not l_return then
								l_tmp___8 := strlen (ce_string ("FTP."))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___9 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("FTP."), a_conn.item.host.name, l_tmp___8)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___9.to_boolean then
									l_protop := ce_string ("ftp")
								else
									l_tmp___6 := strlen (ce_string ("DICT."))
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___7 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("DICT."), a_conn.item.host.name, l_tmp___6)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___7.to_boolean then
										l_protop := ce_string ("DICT")
									else
										l_tmp___4 := strlen (ce_string ("LDAP."))
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___5 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("LDAP."), a_conn.item.host.name, l_tmp___4)
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___5.to_boolean then
											l_protop := ce_string ("LDAP")
										else
											l_tmp___2 := strlen (ce_string ("IMAP."))
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___3 := (create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("IMAP."), a_conn.item.host.name, l_tmp___2)
											update_class_fields -- Current might have been changed; synchronize
											if l_tmp___3.to_boolean then
												l_protop := ce_string ("IMAP")
											else
												l_protop := ce_string ("http")
											end
										end
									end
								end
								a_prot_missing.item := (1).to_boolean
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_protop := l_protobuf
						end
				when 4 then
					if not l_return then
						l_at := strchr (a_conn.item.host.name, ('@').code)
						update_class_fields -- Current might have been changed; synchronize
						if (not l_at.is_void) then
							l_query := strchr ((l_at + 1), ('?').code)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_query := strchr (a_conn.item.host.name, ('?').code)
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not l_query.is_void) then
							l_tmp___13 := strlen (l_query)
							update_class_fields -- Current might have been changed; synchronize
							l_hostlen := l_tmp___13
							l_tmp___14 := strlen (l_path)
							update_class_fields -- Current might have been changed; synchronize
							l_pathlen := l_tmp___14
							memmove (create {CE_VOID_POINTER}.make_cast (((l_path + l_hostlen.to_integer_32) + 1)), create {CE_VOID_POINTER}.make_cast (l_path), l_pathlen + {NATURAL_32} 1).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							memcpy (create {CE_VOID_POINTER}.make_cast ((l_path + 1)), create {CE_VOID_POINTER}.make_cast (l_query), l_hostlen).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_path[0] := (('/').code).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							l_query[0] := (0).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
						elseif not (l_path[0]).to_boolean then
							strcpy (l_path, ce_string ("/")).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						if (l_path[0]).to_integer_32 = 63 then
							l_tmp___15 := strlen (l_path)
							update_class_fields -- Current might have been changed; synchronize
							memmove (create {CE_VOID_POINTER}.make_cast ((l_path + 1)), create {CE_VOID_POINTER}.make_cast (l_path), l_tmp___15 + {NATURAL_32} 1).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_path[0] := (('/').code).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
						end
						if (a_conn.item.host.name[0]).to_integer_32 = 91 then
							l_tmp___16 := strstr (a_conn.item.host.name, ce_string ("%%25"))
							update_class_fields -- Current might have been changed; synchronize
							l_percent := l_tmp___16
							if (not l_percent.is_void) then
								l_tmp___17 := strtoul ((l_percent + 3), l_endp, 10)
								update_class_fields -- Current might have been changed; synchronize
								l_scope := l_tmp___17
								if (l_endp.item[0]).to_integer_32 = 93 then
									l_tmp___18 := strlen (l_endp.item)
									update_class_fields -- Current might have been changed; synchronize
									memmove (create {CE_VOID_POINTER}.make_cast (l_percent), create {CE_VOID_POINTER}.make_cast (l_endp.item), l_tmp___18 + {NATURAL_32} 1).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									if not state.this_is_a_follow then
										a_conn.item.scope := l_scope.to_natural_32
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("Invalid IPv6 address format%N")])
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if (set.scope).to_boolean then
							a_conn.item.scope := set.scope
							update_class_fields -- Current might have been changed; synchronize
						end
						l_fragment := strchr (l_path, ('#').code)
						update_class_fields -- Current might have been changed; synchronize
						if (not l_fragment.is_void) then
							l_fragment[0] := (0).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tmp___19 := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.findprotocol (a_conn, l_protop)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___19
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	setup_range: NATURAL_32
		local
			l_s: CE_POINTER [PD_URLSTATE]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := create {CE_CLASS_POINTER [PD_URLSTATE]}.make_shared (c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state"))
					l_s.item.resume_from := set.set_resume_from
					update_class_fields -- Current might have been changed; synchronize
					if not ((l_s.item.resume_from).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (set.str[17]).is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if l_s.item.rangestringalloc then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_s.item.range)])
							update_class_fields -- Current might have been changed; synchronize
						end
						if (l_s.item.resume_from).to_boolean then
							l_s.item.range := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%llu-"), l_s.item.resume_from])
							update_class_fields -- Current might have been changed; synchronize
						else
							l_s.item.range := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([set.str[17]]))
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not (l_s.item.range).is_void) then
							l_tmp := 1
						else
							l_tmp := 0
						end
						l_s.item.rangestringalloc := l_tmp.to_boolean
						update_class_fields -- Current might have been changed; synchronize
						if (l_s.item.range).is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							l_s.item.use_range := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_s.item.use_range := (0).to_boolean
						update_class_fields -- Current might have been changed; synchronize
				when 7 then -- if done
					if not l_return then
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	parse_proxy_auth (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		require
			not a_conn.is_void
		local
			l_proxyuser: CE_ARRAY [INTEGER_8]
			l_proxypasswd: CE_ARRAY [INTEGER_8]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_proxyuser.make (<<256>>)
			create {CE_INTEGER_8_ARRAY} l_proxypasswd.make (<<256>>)

			l_proxyuser[0] := (('%/0/').code).to_integer_8
			update_class_fields -- Current might have been changed; synchronize
			l_proxypasswd[0] := (('%/0/').code).to_integer_8
			update_class_fields -- Current might have been changed; synchronize
			if not (set.str[30]).is_void then
				strncpy (l_proxyuser, set.str[30], (256).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_proxyuser[255] := (('%/0/').code).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
			end
			if not (set.str[31]).is_void then
				strncpy (l_proxypasswd, set.str[31], (256).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_proxypasswd[255] := (('%/0/').code).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
			end
			a_conn.item.proxyuser := (create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_shared (c_pointer), l_proxyuser, 0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
			if (a_conn.item.proxyuser).is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				l_return := True
			end
			if not l_return then
				a_conn.item.proxypasswd := (create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_shared (c_pointer), l_proxypasswd, 0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				if (a_conn.item.proxypasswd).is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	parse_remote_port (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		require
			not a_conn.is_void
		local
			l_portptr: CE_POINTER [INTEGER_8]
			l_endbracket: CE_ARRAY [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_url: CE_POINTER [INTEGER_8]
			l_type: CE_ARRAY [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_rest: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_port: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_endbracket.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_type.make (<<12>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_rest.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp___0 := sscanf ([a_conn.item.host.name, ce_string ("[%%*45[0123456789abcdefABCDEF:.]%%c"), l_endbracket])
					update_class_fields -- Current might have been changed; synchronize
					if 1 = l_tmp___0 then
						if 93 = (l_endbracket.item).to_integer_32 then
							a_conn.item.bits.ipv6_ip := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							a_conn.item.host.name := (a_conn.item.host.name) + 1
							update_class_fields -- Current might have been changed; synchronize
							l_portptr := strchr (a_conn.item.host.name, (']').code)
							update_class_fields -- Current might have been changed; synchronize
							if (not l_portptr.is_void) then
								l_tmp := l_portptr
								l_portptr := l_portptr + 1
								l_tmp[0] := (('%/0/').code).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								if 58 /= (l_portptr[0]).to_integer_32 then
									l_portptr := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								end
							end
						else
							l_portptr := strrchr (a_conn.item.host.name, (':').code)
							update_class_fields -- Current might have been changed; synchronize
						end
					else
						l_portptr := strrchr (a_conn.item.host.name, (':').code)
						update_class_fields -- Current might have been changed; synchronize
					end
					if not ((set.use_port).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if state.allow_port then
							a_conn.item.remote_port := (set.use_port).to_natural_16
							update_class_fields -- Current might have been changed; synchronize
							if (not l_portptr.is_void) then
								l_portptr[0] := (('%/0/').code).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
							end
							if a_conn.item.bits.httpproxy then
								l_type[0] := (('%/0/').code).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_type[1] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_type[2] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_type[3] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_type[4] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_type[5] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_type[6] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_type[7] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_type[8] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_type[9] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_type[10] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_type[11] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								if a_conn.item.bits.type_set then
									if set.prefer_ascii then
										l_tmp___2 := ('A').code
									else
										if set.ftp_list_only then
											l_tmp___1 := ('D').code
										else
											l_tmp___1 := ('I').code
										end
										l_tmp___2 := l_tmp___1
									end
									(create {P_MPRINTF_STATIC}).curl_msnprintf ([l_type, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (12).to_natural_32), ce_string (";type=%%c"), l_tmp___2]).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
								if state.slash_removed then
									l_tmp___3 := ce_string ("/")
								else
									l_tmp___3 := ce_string ("")
								end
								if a_conn.item.bits.ipv6_ip then
									l_tmp___4 := ce_string ("]")
								else
									l_tmp___4 := ce_string ("")
								end
								if a_conn.item.bits.ipv6_ip then
									l_tmp___5 := ce_string ("[")
								else
									l_tmp___5 := ce_string ("")
								end
								l_url := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%s://%%s%%s%%s:%%hu%%s%%s%%s"), (a_conn.item.handler).item.scheme, l_tmp___5, a_conn.item.host.name, l_tmp___4, (a_conn.item.remote_port).to_integer_32, l_tmp___3, state.path, l_type])
								update_class_fields -- Current might have been changed; synchronize
								if l_url.is_void then
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									l_return := True
								end
								if not l_return then
									if change.url_alloc then
										(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (change.url)])
										update_class_fields -- Current might have been changed; synchronize
									end
									change.url := l_url
									update_class_fields -- Current might have been changed; synchronize
									change.url_alloc := (1).to_boolean
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else: | _L___0:
						if l_portptr.is_void then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						l_port := strtoul ((l_portptr + 1), l_rest, 10)
						update_class_fields -- Current might have been changed; synchronize
						if (l_rest.item).is_equal (l_portptr + 1) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (l_rest.item[0]).to_integer_32 = 0 then
							if l_port > {NATURAL_32} 65_535 then
								((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_failf ([ce_string ("Port number too large: %%lu"), l_port])
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_URL_MALFORMAT)
								l_return := True
							end
							if not l_return then
								l_portptr[0] := (('%/0/').code).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								a_conn.item.remote_port := (create {P_WARNLESS_STATIC}).curlx_ultous (l_port)
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if not l_port.to_boolean then
							l_portptr[0] := (('%/0/').code).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
						end
				when 8 then -- if done | if done
					if not l_return then
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	override_userpass (a_conn: CE_POINTER [PD_CONNECTDATA]; a_user, a_passwd: CE_POINTER [INTEGER_8])
		require
			not a_conn.is_void
		local
			l_tmp: INTEGER_32
		do
			if not (set.str[28]).is_void then
				strncpy (a_user, set.str[28], (256).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				a_user[255] := (('%/0/').code).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
			end
			if not (set.str[29]).is_void then
				strncpy (a_passwd, set.str[29], (256).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				a_passwd[255] := (('%/0/').code).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
			end
			a_conn.item.bits.netrc := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			if set.use_netrc /= {NATURAL_32} 0 then
				l_tmp := Curl_parsenetrc (a_conn.item.host.name, a_user, a_passwd, set.str[14])
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("Couldn%'t find host %%s in the .netrc file; using defaults%N"), a_conn.item.host.name])
					update_class_fields -- Current might have been changed; synchronize
				else
					a_conn.item.bits.netrc := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
					a_conn.item.bits.user_passwd := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	create_conn (a_in_connect: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]; a_async: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_async.is_void
		local
			l_result: NATURAL_32
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_conn_temp: CE_ARRAY [CE_POINTER [PD_CONNECTDATA]]
			l_urllen: NATURAL_32
			l_user: CE_ARRAY [INTEGER_8]
			l_passwd: CE_ARRAY [INTEGER_8]
			l_reuse: BOOLEAN
			l_proxy: CE_POINTER [INTEGER_8]
			l_prot_missing: CE_ARRAY [BOOLEAN]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: BOOLEAN
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: CE_POINTER [ANY]
			l_reurl: CE_POINTER [INTEGER_8]
			l_tmp___5: BOOLEAN
			l_bits: INTEGER_32
			l_done: CE_ARRAY [BOOLEAN]
			l_tmp___6: BOOLEAN
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_CONNECTDATA]} l_conn_temp.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_user.make (<<256>>)
			create {CE_INTEGER_8_ARRAY} l_passwd.make (<<256>>)
			create {CE_BOOLEAN_ARRAY} l_prot_missing.make (<<1>>)
			create {CE_BOOLEAN_ARRAY} l_done.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_conn_temp.item := create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					l_proxy := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_prot_missing.item := (0).to_boolean
					update_class_fields -- Current might have been changed; synchronize
					a_async.item := (0).to_boolean
					update_class_fields -- Current might have been changed; synchronize
					if (change.url).is_void then
						Result := ({PC_CURLCODE}.CURLE_URL_MALFORMAT)
						l_return := True
					end
					if not l_return then
						l_conn := allocate_conn
						update_class_fields -- Current might have been changed; synchronize
						a_in_connect.item := l_conn
						update_class_fields -- Current might have been changed; synchronize
						if l_conn.is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
					end
					if not l_return then
						l_conn.item.data := (create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.proxytype := set.proxytype
						update_class_fields -- Current might have been changed; synchronize
						if (not (set.str[16]).is_void) then
							if ((set.str[16]).item).to_boolean then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
						l_conn.item.bits.proxy := l_tmp.to_boolean
						update_class_fields -- Current might have been changed; synchronize
						if l_conn.item.bits.proxy then
							if l_conn.item.proxytype = {NATURAL_32} 0 then
								l_tmp___0 := 1
							elseif l_conn.item.proxytype = {NATURAL_32} 1 then
								l_tmp___0 := 1
							else
								l_tmp___0 := 0
							end
						else
							l_tmp___0 := 0
						end
						l_conn.item.bits.httpproxy := l_tmp___0.to_boolean
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.bits.proxy_user_passwd := (not (set.str[30]).is_void)
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.bits.tunnel_proxy := set.tunnel_thru_httpproxy
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.bits.user_passwd := (not (set.str[28]).is_void)
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.bits.ftp_use_epsv := set.ftp_use_epsv
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.bits.ftp_use_eprt := set.ftp_use_eprt
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.verifypeer := set.ssl.verifypeer
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.verifyhost := set.ssl.verifyhost
						update_class_fields -- Current might have been changed; synchronize
						if (not multi.is_void) then
							l_tmp___2 := multi.item.Curl_multi_canPipeline
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___2 then
								if (l_conn.item.master_buffer).is_void then
									l_tmp___1 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(16_384).to_natural_32, {PLATFORM}.Integer_8_bytes.to_natural_32]))
									update_class_fields -- Current might have been changed; synchronize
									l_conn.item.master_buffer := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___1)
									update_class_fields -- Current might have been changed; synchronize
									if (l_conn.item.master_buffer).is_void then
										Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
										l_return := True
									end
								end
							end
						end
					end
					if not l_return then
						l_conn.item.send_pipe := (create {P_LLIST_STATIC}).Curl_llist_alloc ((create {P_URL_STATIC}).llist_dtor_address)
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.recv_pipe := (create {P_LLIST_STATIC}).Curl_llist_alloc ((create {P_URL_STATIC}).llist_dtor_address)
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.pend_pipe := (create {P_LLIST_STATIC}).Curl_llist_alloc ((create {P_URL_STATIC}).llist_dtor_address)
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.done_pipe := (create {P_LLIST_STATIC}).Curl_llist_alloc ((create {P_URL_STATIC}).llist_dtor_address)
						update_class_fields -- Current might have been changed; synchronize
						if (l_conn.item.send_pipe).is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						elseif (l_conn.item.recv_pipe).is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						elseif (l_conn.item.pend_pipe).is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						elseif (l_conn.item.done_pipe).is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
					end
					if not l_return then
						l_urllen := strlen (change.url)
						update_class_fields -- Current might have been changed; synchronize
						if l_urllen < {NATURAL_32} 256 then
							l_urllen := (256).to_natural_32
						end
						(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (state.pathbuffer))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___3 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([l_urllen + {NATURAL_32} 2]))
						update_class_fields -- Current might have been changed; synchronize
						state.pathbuffer := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___3)
						update_class_fields -- Current might have been changed; synchronize
						if (state.pathbuffer).is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
					end
					if not l_return then
						state.path := state.pathbuffer
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___4 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([l_urllen + {NATURAL_32} 2]))
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.host.rawalloc := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___4)
						update_class_fields -- Current might have been changed; synchronize
						if (l_conn.item.host.rawalloc).is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
					end
					if not l_return then
						l_conn.item.host.name := l_conn.item.host.rawalloc
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.host.name[0] := (0).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_result := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.parseurlandfillconn (l_conn, l_prot_missing)
						update_class_fields -- Current might have been changed; synchronize
						if l_result /= {NATURAL_32} 0 then
							Result := l_result
							l_return := True
						end
					end
					if not l_return and then (l_prot_missing.item) then
						l_reurl := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%s://%%s"), (l_conn.item.handler).item.scheme, change.url])
						update_class_fields -- Current might have been changed; synchronize
						if l_reurl.is_void then
							(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_proxy))
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							change.url := l_reurl
							update_class_fields -- Current might have been changed; synchronize
							change.url_alloc := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if not l_return then
						l_result := parse_url_userpass ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), l_conn, l_user, l_passwd)
						update_class_fields -- Current might have been changed; synchronize
						if l_result /= {NATURAL_32} 0 then
							Result := l_result
							l_return := True
						end
					end
					if not l_return and then (l_conn.item.bits.proxy_user_passwd) then
						l_result := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.parse_proxy_auth (l_conn)
						update_class_fields -- Current might have been changed; synchronize
						if l_result /= {NATURAL_32} 0 then
							Result := l_result
							l_return := True
						end
					end
					if not l_return and then (not (set.str[16]).is_void) then
						l_proxy := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([set.str[16]]))
						update_class_fields -- Current might have been changed; synchronize
						if l_proxy.is_void then
							((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_failf ([ce_string ("memory shortage")])
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if (set.str[32]).is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_tmp___5 := (create {P_URL_STATIC}).check_noproxy (l_conn.item.host.name, set.str[32])
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___5 then
							if (not l_proxy.is_void) then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_proxy)])
								update_class_fields -- Current might have been changed; synchronize
								l_proxy := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_proxy.is_void then
							l_proxy := l_conn.item.detect_proxy
							update_class_fields -- Current might have been changed; synchronize
						end
				when 5 then
						if (not l_proxy.is_void) then
							if not (l_proxy[0]).to_boolean then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_proxy)])
								update_class_fields -- Current might have been changed; synchronize
								l_proxy := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							end
						end
						if (not l_proxy.is_void) then
							l_bits := (l_conn.item.protocol).bit_and (((((1).bit_shift_left (1))).bit_or (((1).bit_shift_left (29)))).to_integer_32)
							if l_conn.item.proxytype = {NATURAL_32} 0 then
								l_conn.item.protocol := (1).bit_or (l_bits)
								update_class_fields -- Current might have been changed; synchronize
								l_conn.item.bits.httpproxy := (1).to_boolean
								update_class_fields -- Current might have been changed; synchronize
							elseif l_conn.item.proxytype = {NATURAL_32} 1 then
								l_conn.item.protocol := (1).bit_or (l_bits)
								update_class_fields -- Current might have been changed; synchronize
								l_conn.item.bits.httpproxy := (1).to_boolean
								update_class_fields -- Current might have been changed; synchronize
							end
							l_conn.item.bits.proxy := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						else
							l_conn.item.bits.proxy := (0).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							l_conn.item.bits.httpproxy := (0).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							l_conn.item.bits.proxy_user_passwd := (0).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							l_conn.item.bits.tunnel_proxy := (0).to_boolean
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not l_proxy.is_void) then
							l_result := parse_proxy ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), l_conn, l_proxy)
							update_class_fields -- Current might have been changed; synchronize
							l_proxy := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							if l_result /= {NATURAL_32} 0 then
								Result := l_result
								l_return := True
							end
						end
				when 6 then -- if done
					if not l_return then
						l_result := setup_connection_internals (l_conn)
						update_class_fields -- Current might have been changed; synchronize
						if l_result /= {NATURAL_32} 0 then
							(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_proxy))
							update_class_fields -- Current might have been changed; synchronize
							Result := l_result
							l_return := True
						end
					end
					if not l_return then
						l_conn.item.recv2[0] := (create {PD_CONNECTDATA_STATIC}).Curl_recv_plain_address
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.send2[0] := (create {PD_CONNECTDATA_STATIC}).Curl_send_plain_address
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.recv2[1] := (create {PD_CONNECTDATA_STATIC}).Curl_recv_plain_address
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.send2[1] := (create {PD_CONNECTDATA_STATIC}).Curl_send_plain_address
						update_class_fields -- Current might have been changed; synchronize
						if ((l_conn.item.protocol).bit_and (((1).bit_shift_left (10)).to_integer_32)).to_boolean then
							l_result := ((l_conn.item.handler).item.connect_it).natural_32_item ([l_conn, l_done])
							update_class_fields -- Current might have been changed; synchronize
							if {NATURAL_32} 0 = l_result then
								l_conn.item.data := (create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))
								update_class_fields -- Current might have been changed; synchronize
								l_conn.item.bits.tcpconnect := (1).to_boolean
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.ConnectionStore (l_conn).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_result := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.setup_range
								update_class_fields -- Current might have been changed; synchronize
								if l_result.to_boolean then
									((l_conn.item.handler).item.done).call ([l_conn, l_result, (0).to_boolean])
									update_class_fields -- Current might have been changed; synchronize
									Result := l_result
									l_return := True
								end
								if not l_return then
									l_conn.item.Curl_setup_transfer (-1, (-1).to_integer_64, (0).to_boolean, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer), -1, create {CE_INTEGER_64_POINTER}.make_shared (default_pointer))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							if not l_return then
								Result := l_result
								l_return := True
							end
						end
					end
					if not l_return then
						if ((l_conn.item.protocol).bit_and (((1).bit_shift_left (29)).to_integer_32)).to_boolean then
							if l_conn.item.bits.httpproxy then
								l_conn.item.bits.tunnel_proxy := (1).to_boolean
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_result := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.parse_remote_port (l_conn)
						update_class_fields -- Current might have been changed; synchronize
						if l_result /= {NATURAL_32} 0 then
							Result := l_result
							l_return := True
						end
					end
					if not l_return then
						((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.override_userpass (l_conn, l_user, l_passwd)
						update_class_fields -- Current might have been changed; synchronize
						l_result := set_userpass (l_conn, l_user, l_passwd)
						update_class_fields -- Current might have been changed; synchronize
						if l_result /= {NATURAL_32} 0 then
							Result := l_result
							l_return := True
						end
					end
					if not l_return then
						set.ssl.CApath := set.str[20]
						update_class_fields -- Current might have been changed; synchronize
						set.ssl.CAfile := set.str[21]
						update_class_fields -- Current might have been changed; synchronize
						set.ssl.CRLfile := set.str[26]
						update_class_fields -- Current might have been changed; synchronize
						set.ssl.issuercert := set.str[27]
						update_class_fields -- Current might have been changed; synchronize
						set.ssl.random_file := set.str[24]
						update_class_fields -- Current might have been changed; synchronize
						set.ssl.egdsocket := set.str[23]
						update_class_fields -- Current might have been changed; synchronize
						set.ssl.cipher_list := set.str[22]
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___6 := Curl_clone_ssl_config (create {CE_CLASS_POINTER [PD_SSL_CONFIG_DATA]}.make_shared (c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("set") + (create {PD_USERDEFINED}.make).offset_of ("ssl")), create {CE_CLASS_POINTER [PD_SSL_CONFIG_DATA]}.make_shared (l_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("ssl_config")))
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___6 then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
					end
					if not l_return then
						if set.reuse_fresh then
							if not state.this_is_a_follow then
								l_reuse := (0).to_boolean
							else
								l_reuse := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.ConnectionExists (l_conn, l_conn_temp)
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_reuse := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.ConnectionExists (l_conn, l_conn_temp)
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_reuse then
							reuse_conn (l_conn, l_conn_temp.item)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_conn)])
							update_class_fields -- Current might have been changed; synchronize
							l_conn := l_conn_temp.item
							a_in_connect.item := l_conn
							update_class_fields -- Current might have been changed; synchronize
							if (not (l_conn.item.proxy.name).is_void) then
								l_tmp___7 := l_conn.item.proxy.dispname
							else
								l_tmp___7 := l_conn.item.host.dispname
							end
							(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("Re-using existing connection! (#%%ld) with host %%s%N"), l_conn.item.connectindex, l_tmp___7])
							update_class_fields -- Current might have been changed; synchronize
							strcpy ((info.ip), (l_conn.item.ip_addr_str)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						else
							((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.ConnectionStore (l_conn).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						l_result := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.setup_range
						update_class_fields -- Current might have been changed; synchronize
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
					end
					if not l_return then
						l_conn.item.fread_func := set.fread_func
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.fread_in := set.in
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.seek_func := set.seek_func
						update_class_fields -- Current might have been changed; synchronize
						l_conn.item.seek_client := set.seek_client
						update_class_fields -- Current might have been changed; synchronize
						l_result := resolve_server ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), l_conn, a_async)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_result
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_connect (a_in_connect: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]; a_asyncp, a_protocol_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_asyncp.is_void
		local
			l_code: NATURAL_32
		do
			a_asyncp.item := (0).to_boolean
			update_class_fields -- Current might have been changed; synchronize
			l_code := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.create_conn (a_in_connect, a_asyncp)
			update_class_fields -- Current might have been changed; synchronize
			if {NATURAL_32} 0 = l_code then
				if (((a_in_connect.item).item.send_pipe).item.size).to_boolean then
					a_protocol_done.item := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
				elseif (((a_in_connect.item).item.recv_pipe).item.size).to_boolean then
					a_protocol_done.item := (1).to_boolean
					update_class_fields -- Current might have been changed; synchronize
				elseif not a_asyncp.item then
					l_code := (a_in_connect.item).item.setup_conn (a_protocol_done)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if l_code.to_boolean then
				if (not (a_in_connect.item).is_void) then
					(create {P_URL_STATIC}).Curl_disconnect (a_in_connect.item).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					a_in_connect.item := create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			Result := l_code
		end

	Curl_speedcheck (a_now: SD_TIMEVAL): NATURAL_32
		local
			l_howlong: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (progress.current_speed >= {INTEGER_64} 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (set.low_speed_time).to_boolean then
							l_tmp___0 := Curl_tvlong ((state.keeps_speed).twin)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___0 /= 0 then
								if progress.current_speed < (set.low_speed_limit).to_integer_64 then
									l_tmp := (create {P_TIMEVAL_STATIC}).curlx_tvdiff (a_now.twin, (state.keeps_speed).twin)
									update_class_fields -- Current might have been changed; synchronize
									l_howlong := l_tmp
									if l_howlong // 1_000 > set.low_speed_time then
										((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_failf ([ce_string ("Operation too slow. Less than %%ld bytes/sec transfered the last %%ld seconds"), set.low_speed_limit, set.low_speed_time])
										update_class_fields -- Current might have been changed; synchronize
										Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
										l_return := True
									end
									if not l_return then
										((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_expire (l_howlong)
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									l_pos := -1 + 3 -- goto _L___1
								end
							else
								l_pos := -1 + 3 -- goto _L___1
							end
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___1:
						state.keeps_speed := a_now.twin
						update_class_fields -- Current might have been changed; synchronize
						if (set.low_speed_limit).to_boolean then
							((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_expire (set.low_speed_time * 1_000)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 4 then
					if not l_return then
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	printoption (a_direction: CE_POINTER [INTEGER_8]; a_cmd, a_option: INTEGER_32)
		local
			l_fmt: CE_POINTER [INTEGER_8]
			l_opt: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
		do
			if set.verbose then
				if a_cmd = 255 then
					if a_option.to_natural_32 >= {NATURAL_32} 236 then
						if a_option.to_natural_32 <= {NATURAL_32} 255 then
							(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%s IAC %%s%N"), a_direction, telnetcmds.item[a_option - 236]])
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%s IAC %%d%N"), a_direction, a_option])
							update_class_fields -- Current might have been changed; synchronize
						end
					else
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%s IAC %%d%N"), a_direction, a_option])
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					if a_cmd = 251 then
						l_fmt := ce_string ("WILL")
					else
						if a_cmd = 252 then
							l_tmp___1 := ce_string ("WONT")
						else
							if a_cmd = 253 then
								l_tmp___0 := ce_string ("DO")
							else
								if a_cmd = 254 then
									l_tmp := ce_string ("DONT")
								else
									l_tmp := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								end
								l_tmp___0 := l_tmp
							end
							l_tmp___1 := l_tmp___0
						end
						l_fmt := l_tmp___1
					end
					if (not l_fmt.is_void) then
						if a_option <= 39 then
							l_opt := telnetoptions.item[a_option]
						elseif a_option = 255 then
							l_opt := ce_string ("EXOPL")
						else
							l_opt := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						end
						if (not l_opt.is_void) then
							(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%s %%s %%s%N"), a_direction, l_fmt, l_opt])
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%s %%s %%d%N"), a_direction, l_fmt, a_option])
							update_class_fields -- Current might have been changed; synchronize
						end
					else
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%s %%d %%d%N"), a_direction, a_cmd, a_option])
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
		end

	printsub (a_direction: INTEGER_32; a_pointer: CE_POINTER [NATURAL_8]; a_length: NATURAL_32)
		local
			l_length: NATURAL_32
			l_i: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_j: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_length := a_length
					l_i := {NATURAL_32} 0
					if not (set.verbose) then
						l_pos := -1 + 34 -- skip if block
					end
				when 1 then -- if:
						if not (a_direction.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 2 then -- if:
						if a_direction = 60 then
							l_tmp := ce_string ("RCVD")
						else
							l_tmp := ce_string ("SENT")
						end
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%s IAC SB "), l_tmp])
						update_class_fields -- Current might have been changed; synchronize
						if not (l_length >= {NATURAL_32} 3) then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						l_i := (a_pointer[(l_length - {NATURAL_32} 2).to_integer_32]).to_natural_32
						l_j := (a_pointer[(l_length - {NATURAL_32} 1).to_integer_32]).to_integer_32
						if l_i = {NATURAL_32} 255 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if l_j = 240 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:;
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("(terminated by ")])
						update_class_fields -- Current might have been changed; synchronize
						if l_i <= {NATURAL_32} 39 then
							(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%s "), telnetoptions.item[l_i.to_integer_32]])
							update_class_fields -- Current might have been changed; synchronize
						elseif l_i >= {NATURAL_32} 236 then
							if l_i <= {NATURAL_32} 255 then
								(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%s "), telnetcmds.item[(l_i - {NATURAL_32} 236).to_integer_32]])
								update_class_fields -- Current might have been changed; synchronize
							else
								(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%u "), l_i])
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%u "), l_i])
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_j <= 39 then
							(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%s"), telnetoptions.item[l_j]])
							update_class_fields -- Current might have been changed; synchronize
						elseif l_j.to_natural_32 >= {NATURAL_32} 236 then
							if l_j.to_natural_32 <= {NATURAL_32} 255 then
								(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%s"), telnetcmds.item[l_j - 236]])
								update_class_fields -- Current might have been changed; synchronize
							else
								(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%d"), l_j])
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%d"), l_j])
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string (", not IAC SE!) ")])
						update_class_fields -- Current might have been changed; synchronize
				when 8 then -- if done | if done
						l_length := l_length - ({NATURAL_32} 2)
				when 9 then -- if done
						if l_length < {NATURAL_32} 1 then
							(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("(Empty suboption?)")])
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
						if l_return then
							l_pos := -1 + 34 -- skip if block
						end
				when 10 then -- if:
						if not ((a_pointer[0]).to_integer_32 <= 39) then
							l_pos := -1 + 15 -- skip if block
						end
				when 11 then -- if:
						inspect (a_pointer[0]).to_integer_32 -- switch 1 head
						when 24 then l_pos := -1 + 12
						when 35 then l_pos := -1 + 12
						when 39 then l_pos := -1 + 12
						else l_pos := -1 + 13
						end
				when 12 then -- switch 1, case 24 | switch 1, case 35 | switch 1, case 39;
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%s"), telnetoptions.item[(a_pointer[0]).to_integer_32]])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 14 -- switch 1; break
				when 13 then -- switch 1, default:;
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%s (unsupported)"), telnetoptions.item[(a_pointer[0]).to_integer_32]])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 14 -- switch 1; break
				when 14 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:;
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%d (unknown)"), (a_pointer[l_i.to_integer_32]).to_integer_32])
						update_class_fields -- Current might have been changed; synchronize
				when 16 then -- if done
						inspect (a_pointer[1]).to_integer_32 -- switch 2 head
						when 0 then l_pos := -1 + 17
						when 1 then l_pos := -1 + 18
						when 2 then l_pos := -1 + 19
						when 3 then l_pos := -1 + 20
						else l_pos := -1 + 21
						end
				when 17 then -- switch 2, case 0;
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string (" IS")])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 21 -- switch 2; break
				when 18 then -- switch 2, case 1;
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string (" SEND")])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 21 -- switch 2; break
				when 19 then -- switch 2, case 2;
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string (" INFO/REPLY")])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 21 -- switch 2; break
				when 20 then -- switch 2, case 3;
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string (" NAME")])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 21 -- switch 2; break
				when 21 then -- switch 2, done:
						inspect (a_pointer[0]).to_integer_32 -- switch 3 head
						when 24 then l_pos := -1 + 22
						when 35 then l_pos := -1 + 22
						when 39 then l_pos := -1 + 23
						else l_pos := -1 + 32
						end
				when 22 then -- switch 3, case 24 | switch 3, case 35
						a_pointer[l_length.to_integer_32] := (0).to_natural_8
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string (" %"%%s%""), a_pointer + 2])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 33 -- switch 3; break
				when 23 then -- switch 3, case 39
						if (a_pointer[1]).to_integer_32 /= 0 then
							l_pos := -1 + 31 -- skip if block
						end
				when 24 then -- if:;
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string (" ")])
						update_class_fields -- Current might have been changed; synchronize
						l_i := {NATURAL_32} 3
				when 25 then -- loop condition:
						if not (l_i < l_length) then
							l_pos := -1 + 31 -- skip loop
						end
				when 26 then -- loop body:
						inspect (a_pointer[l_i.to_integer_32]).to_integer_32 -- switch 4 head
						when 0 then l_pos := -1 + 27
						when 1 then l_pos := -1 + 28
						else l_pos := -1 + 29
						end
				when 27 then -- switch 4, case 0;
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string (", ")])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 30 -- switch 4; break
				when 28 then -- switch 4, case 1;
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string (" = ")])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 30 -- switch 4; break
				when 29 then -- switch 4, default:;
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%%c"), (a_pointer[l_i.to_integer_32]).to_integer_32])
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 30 -- switch 4; break
				when 30 then -- switch 4, done:
						l_i := l_i + 1
						l_pos := -1 + 25 -- back to loop condition
				when 31 then -- loop done | if done
						l_pos := -1 + 33 -- switch 3; break
				when 32 then -- switch 3, default:
						l_i := {NATURAL_32} 2
						from
						until
							not (l_i < l_length)
						loop
							(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string (" %%.2x"), (a_pointer[l_i.to_integer_32]).to_integer_32])
							update_class_fields -- Current might have been changed; synchronize
							l_i := l_i + 1
						end
						l_pos := -1 + 33 -- switch 3; break
				when 33 then -- switch 3, done:
						if a_direction.to_boolean then
							(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("%N")])
							update_class_fields -- Current might have been changed; synchronize
						end
				when 34 then -- if done | if done
					if not l_return then
					end
				when 35 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	readwrite_data (a_conn: CE_POINTER [PD_CONNECTDATA]; a_k: CE_POINTER [PD_SINGLEREQUEST]; a_didwhat: CE_POINTER [INTEGER_32]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_k.is_void
			not a_done.is_void
		local
			l_result: NATURAL_32
			l_nread: CE_ARRAY [INTEGER_32]
			l_excess: NATURAL_32
			l_is_empty_data: BOOLEAN
			l_readmore: CE_ARRAY [BOOLEAN]
			l_buffersize: NATURAL_32
			l_tmp: INTEGER_32
			l_bytestoread: NATURAL_32
			l_totalleft: INTEGER_64
			l_tmp___0: INTEGER_32
			l_stop_reading: CE_ARRAY [BOOLEAN]
			l_res: INTEGER_32
			l_tmp___1: INTEGER_32
			l_dataleft: NATURAL_32
			l_tmp___2: BOOLEAN
			l_tmp___3: BOOLEAN
			l_tmp___4: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_nread.make (<<1>>)
			create {CE_BOOLEAN_ARRAY} l_readmore.make (<<1>>)
			create {CE_BOOLEAN_ARRAY} l_stop_reading.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_excess := (0).to_natural_32
					l_is_empty_data := (0).to_boolean
					l_readmore.item := (0).to_boolean
					update_class_fields -- Current might have been changed; synchronize
					a_done.item := (0).to_boolean
					update_class_fields -- Current might have been changed; synchronize
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 31 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if (set.buffer_size).to_boolean then
							l_tmp := set.buffer_size
						else
							l_tmp := 16_384
						end
						l_buffersize := l_tmp.to_natural_32
						l_bytestoread := l_buffersize
						if a_k.item.size /= -{INTEGER_64} 1 then
							if not a_k.item.header then
								l_totalleft := a_k.item.size - a_k.item.bytecount
								if l_totalleft < l_bytestoread.to_integer_64 then
									l_bytestoread := l_totalleft.to_natural_32
								end
							end
						end
						if l_bytestoread.to_boolean then
							l_result := a_conn.item.Curl_read (a_conn.item.sockfd, a_k.item.buf, l_bytestoread, l_nread)
							update_class_fields -- Current might have been changed; synchronize
							if {NATURAL_32} 81 = l_result then
								l_break := True
							end
							if not (l_return or l_break) and then (l_result > {NATURAL_32} 0) then
								Result := l_result
								l_return := True
							end
						else
							l_nread.item := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						if not (l_return or l_break) then
							if a_k.item.bytecount = {INTEGER_64} 0 then
								if a_k.item.writebytecount = {INTEGER_64} 0 then
									(create {P_PROGRESS_STATIC}).Curl_pgrsTime ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), {PC_TIMERID}.TIMER_STARTTRANSFER)
									update_class_fields -- Current might have been changed; synchronize
									if a_k.item.exp100 > {NATURAL_32} 0 then
										a_k.item.start100 := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
							a_didwhat.item := (a_didwhat.item).bit_or ((1))
							update_class_fields -- Current might have been changed; synchronize
							if l_nread.item = 0 then
								if a_k.item.bodywrites = 0 then
									l_tmp___0 := 1
								else
									l_tmp___0 := 0
								end
							else
								l_tmp___0 := 0
							end
							l_is_empty_data := l_tmp___0.to_boolean
							if 0 < l_nread.item then
								a_k.item.buf[l_nread.item] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
							elseif l_is_empty_data then
								a_k.item.buf[l_nread.item] := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
							elseif 0 >= l_nread.item then
								a_k.item.keepon := (a_k.item.keepon).bit_and ((-2))
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
						end
						if not (l_return or l_break) then
							a_k.item.str := a_k.item.buf
							update_class_fields -- Current might have been changed; synchronize
							if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
								l_result := Curl_rtsp_rtp_readwrite ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), a_conn, l_nread, l_readmore)
								update_class_fields -- Current might have been changed; synchronize
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
								if not l_return and then (l_readmore.item) then
									l_break := True
								end
							end
						end
						if not (l_return or l_break) and then (a_k.item.header) then
							l_stop_reading.item := (0).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							l_result := Curl_http_readwrite_headers ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), a_conn, l_nread, l_stop_reading)
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
							if not l_return then
								if a_k.item.maxdownload <= {INTEGER_64} 0 then
									if l_nread.item > 0 then
										if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
											l_result := Curl_rtsp_rtp_readwrite ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), a_conn, l_nread, l_readmore)
											update_class_fields -- Current might have been changed; synchronize
											if l_result.to_boolean then
												Result := l_result
												l_return := True
											end
											if not l_return and then (l_readmore.item) then
												l_break := True
											end
										end
									end
								end
								if not (l_return or l_break) and then (l_stop_reading.item) then
									l_break := True
								end
							end
						end
						if (l_return or l_break) then
							l_pos := -1 + 30 -- skip if block
						end
				when 3 then -- if:
						if (a_k.item.str).is_void then
							l_pos := -1 + 29 -- skip if block
						end
				when 4 then -- if:
						if a_k.item.header then
							l_pos := -1 + 29 -- skip if block
						end
				when 5 then -- if:
						if not (l_nread.item > 0) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L___0
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 8 then -- else:
						if not l_is_empty_data then
							l_pos := -1 + 29 -- skip if block
						end
				when 9 then -- if: | _L___0:
						if 0 /= a_k.item.bodywrites then
							l_pos := -1 + 19 -- skip if block
						end
				when 10 then -- if:
						if l_is_empty_data then
							l_pos := -1 + 19 -- skip if block
						end
				when 11 then -- if:
						if not (((a_conn.item.protocol).bit_and (((1).bit_or (((1).bit_shift_left (18)))).to_integer_32)).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 12 then -- if:
						if (not (req.newurl).is_void) then
							if a_conn.item.bits.close then
								a_k.item.keepon := (a_k.item.keepon).bit_and ((-2))
								update_class_fields -- Current might have been changed; synchronize
								a_done.item := (1).to_boolean
								update_class_fields -- Current might have been changed; synchronize
								Result := ({PC_CURLCODE}.CURLE_OK)
								l_return := True
							end
							if not l_return then
								a_k.item.ignorebody := (1).to_boolean
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("Ignoring the response-body%N")])
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if not l_return and then ((state.resume_from).to_boolean) then
							if not a_k.item.content_range then
								if set.httpreq = {NATURAL_32} 1 then
									if not a_k.item.ignorebody then
										((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_failf ([ce_string ("HTTP server doesn%'t seem to support byte ranges. Cannot resume.")])
										update_class_fields -- Current might have been changed; synchronize
										Result := ({PC_CURLCODE}.CURLE_RANGE_ERROR)
										l_return := True
									end
								end
							end
						end
						if not (not l_return and then ((set.timecondition).to_boolean)) then
							l_pos := -1 + 19 -- skip if block
						end
				when 13 then -- if:
						if (not (state.range).is_void) then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if not (a_k.item.timeofdoc > 0) then
							l_pos := -1 + 19 -- skip if block
						end
				when 15 then -- if:
						if not (set.timevalue > 0) then
							l_pos := -1 + 19 -- skip if block
						end
				when 16 then -- if:
						inspect (set.timecondition).to_integer_32 -- switch 1 head
						when 2 then l_pos := -1 + 18
						else l_pos := -1 + 17
						end
				when 17 then -- switch 1, default:
						if a_k.item.timeofdoc < set.timevalue then
							(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("The requested document is not new enough%N")])
							update_class_fields -- Current might have been changed; synchronize
							a_done.item := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							info.timecond := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						end
						l_pos := -1 + 19 -- switch 1; break
				when 18 then -- switch 1, case 2
						if a_k.item.timeofdoc > set.timevalue then
							(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("The requested document is not old enough%N")])
							update_class_fields -- Current might have been changed; synchronize
							a_done.item := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							info.timecond := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						end
						l_pos := -1 + 19 -- switch 1; break
				when 19 then -- switch 1, done: | if done | if done | if done | if done | if done | if done | if done
						if not l_return then
							a_k.item.bodywrites := (a_k.item.bodywrites) + 1
							update_class_fields -- Current might have been changed; synchronize
							if set.verbose then
								if (a_k.item.badheader).to_boolean then
									((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_debug ({PC_CURL_INFOTYPE}.CURLINFO_DATA_IN, state.headerbuff, a_k.item.hbuflen, a_conn).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									if a_k.item.badheader = {NATURAL_32} 1 then
										((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_debug ({PC_CURL_INFOTYPE}.CURLINFO_DATA_IN, a_k.item.str, (l_nread.item).to_natural_32, a_conn).do_nothing
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_debug ({PC_CURL_INFOTYPE}.CURLINFO_DATA_IN, a_k.item.str, (l_nread.item).to_natural_32, a_conn).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							if a_k.item.chunk then
								l_tmp___1 := a_conn.item.Curl_httpchunk_read (a_k.item.str, l_nread.item, l_nread)
								update_class_fields -- Current might have been changed; synchronize
								l_res := l_tmp___1
								if 0 < l_res then
									if 4 = l_res then
										((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_failf ([ce_string ("Failed writing data")])
										update_class_fields -- Current might have been changed; synchronize
										Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
										l_return := True
									end
									if not l_return then
										((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_failf ([ce_string ("Received problem %%d in the chunky parser"), l_res])
										update_class_fields -- Current might have been changed; synchronize
										Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
										l_return := True
									end
								elseif -1 = l_res then
									a_k.item.keepon := (a_k.item.keepon).bit_and ((-2))
									update_class_fields -- Current might have been changed; synchronize
									l_dataleft := a_conn.item.chunk.dataleft
									if l_dataleft /= {NATURAL_32} 0 then
										(create {P_SENDF_STATIC}).Curl_infof ([a_conn.item.data, ce_string ("Leftovers after chunking: %%zu bytes"), l_dataleft])
										update_class_fields -- Current might have been changed; synchronize
										if (not ((a_conn.item.data).item.multi).is_void) then
											l_tmp___2 := ((a_conn.item.data).item.multi).item.Curl_multi_canPipeline
											update_class_fields -- Current might have been changed; synchronize
											if l_tmp___2 then
												(create {P_SENDF_STATIC}).Curl_infof ([a_conn.item.data, ce_string ("Rewinding %%zu bytes%N"), l_dataleft])
												update_class_fields -- Current might have been changed; synchronize
												read_rewind (a_conn, l_dataleft)
												update_class_fields -- Current might have been changed; synchronize
											end
										end
									end
								end
							end
						end
						if l_return then
							l_pos := -1 + 29 -- skip if block
						end
				when 20 then -- if:
						if (a_k.item.badheader).to_boolean then
							if not a_k.item.ignorebody then
								a_k.item.bytecount := a_k.item.bytecount + (a_k.item.hbuflen).to_integer_64
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if -{INTEGER_64} 1 /= a_k.item.maxdownload then
							if a_k.item.bytecount + (l_nread.item).to_integer_64 >= a_k.item.maxdownload then
								l_excess := ((a_k.item.bytecount + (l_nread.item).to_integer_64) - a_k.item.maxdownload).to_natural_32
								if l_excess > {NATURAL_32} 0 then
									if not a_k.item.ignorebody then
										if (not ((a_conn.item.data).item.multi).is_void) then
											l_tmp___3 := ((a_conn.item.data).item.multi).item.Curl_multi_canPipeline
											update_class_fields -- Current might have been changed; synchronize
											if l_tmp___3 then
												(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("Rewinding stream by : %%zu bytes on url %%s (size = %%lld, maxdownload = %%lld, bytecount = %%lld, nread = %%zd)%N"), l_excess, state.path, a_k.item.size, a_k.item.maxdownload, a_k.item.bytecount, l_nread.item])
												update_class_fields -- Current might have been changed; synchronize
												read_rewind (a_conn, l_excess)
												update_class_fields -- Current might have been changed; synchronize
											else
												(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("Excess found in a non pipelined read: excess = %%zu, size = %%lld, maxdownload = %%lld, bytecount = %%lld%N"), l_excess, a_k.item.size, a_k.item.maxdownload, a_k.item.bytecount])
												update_class_fields -- Current might have been changed; synchronize
											end
										else
											(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("Excess found in a non pipelined read: excess = %%zu, size = %%lld, maxdownload = %%lld, bytecount = %%lld%N"), l_excess, a_k.item.size, a_k.item.maxdownload, a_k.item.bytecount])
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								end
								l_nread.item := (a_k.item.maxdownload - a_k.item.bytecount).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								if l_nread.item < 0 then
									l_nread.item := 0
									update_class_fields -- Current might have been changed; synchronize
								end
								a_k.item.keepon := (a_k.item.keepon).bit_and ((-2))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						a_k.item.bytecount := a_k.item.bytecount + (l_nread.item).to_integer_64
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_pgrsSetDownloadCounter (a_k.item.bytecount)
						update_class_fields -- Current might have been changed; synchronize
						if a_k.item.chunk then
							l_pos := -1 + 29 -- skip if block
						end
				when 21 then -- if:
						if not ((l_nread.item).to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 28 -- goto _L
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 24 then -- else:
						if not ((a_k.item.badheader).to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 27 then -- else:
						if not l_is_empty_data then
							l_pos := -1 + 29 -- skip if block
						end
				when 28 then -- if: | _L:
						if (a_k.item.badheader).to_boolean then
							if not a_k.item.ignorebody then
								if a_k.item.maxdownload = -{INTEGER_64} 1 then
									l_result := a_conn.item.Curl_client_write (1, state.headerbuff, a_k.item.hbuflen)
									update_class_fields -- Current might have been changed; synchronize
								elseif (a_k.item.hbuflen).to_integer_64 <= a_k.item.maxdownload then
									l_result := a_conn.item.Curl_client_write (1, state.headerbuff, a_k.item.hbuflen)
									update_class_fields -- Current might have been changed; synchronize
								else
									l_result := a_conn.item.Curl_client_write (1, state.headerbuff, (a_k.item.maxdownload).to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
								end
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
							end
						end
						if not l_return then
							if a_k.item.badheader < {NATURAL_32} 2 then
								if not a_k.item.ignorebody then
									if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (14)).to_integer_32)).to_boolean then
										l_result := a_conn.item.Curl_pop3_write (a_k.item.str, (l_nread.item).to_natural_32)
										update_class_fields -- Current might have been changed; synchronize
									else
										l_result := a_conn.item.Curl_client_write (1, a_k.item.str, (l_nread.item).to_natural_32)
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
							a_k.item.badheader := {PC_BADHEADER}.HEADER_NORMAL
							update_class_fields -- Current might have been changed; synchronize
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
				when 29 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if not l_return then
							if l_excess > {NATURAL_32} 0 then
								if not a_conn.item.bits.stream_was_rewound then
									if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
										a_k.item.str := a_k.item.str + (l_nread.item)
										update_class_fields -- Current might have been changed; synchronize
										l_nread.item := l_excess.to_integer_32
										update_class_fields -- Current might have been changed; synchronize
										l_result := Curl_rtsp_rtp_readwrite ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), a_conn, l_nread, l_readmore)
										update_class_fields -- Current might have been changed; synchronize
										if l_result.to_boolean then
											Result := l_result
											l_return := True
										end
										if not l_return then
											if l_readmore.item then
												a_k.item.keepon := (a_k.item.keepon).bit_or ((1))
												update_class_fields -- Current might have been changed; synchronize
											end
											l_break := True
										end
									end
								end
							end
							if not (l_return or l_break) then
								if l_is_empty_data then
									a_k.item.keepon := (a_k.item.keepon).bit_and ((-2))
									update_class_fields -- Current might have been changed; synchronize
								end
								l_tmp___4 := data_pending (a_conn)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___4.to_boolean then
									l_break := True
								end
							end
						end
				when 30 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 31 then -- loop done
					if not l_return then
						l_break := False
						if ((a_k.item.keepon).bit_and (((1).bit_or (((1).bit_shift_left (1)))))) = (1).bit_shift_left (1) then
							if a_conn.item.bits.close then
								(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("we are done reading and this is set to close, stop send%N")])
								update_class_fields -- Current might have been changed; synchronize
								a_k.item.keepon := (a_k.item.keepon).bit_and (((((1).bit_shift_left (1))).bit_not))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 32 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_pretransfer: NATURAL_32
		local
			l_res: NATURAL_32
			l_return: BOOLEAN
		do
			if (change.url).is_void then
				((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_failf ([ce_string ("No URL set!")])
				update_class_fields -- Current might have been changed; synchronize
				Result := ({PC_CURLCODE}.CURLE_URL_MALFORMAT)
				l_return := True
			end
			if not l_return then
				l_res := {PC_CURLCODE}.CURLE_OK
				if l_res.to_boolean then
					Result := l_res
					l_return := True
				end
			end
			if not l_return then
				set.followlocation := 0
				update_class_fields -- Current might have been changed; synchronize
				state.this_is_a_follow := (0).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				state.errorbuf := (0).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				state.httpversion := 0
				update_class_fields -- Current might have been changed; synchronize
				state.ssl_connect_retry := (0).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				state.authproblem := (0).to_boolean
				update_class_fields -- Current might have been changed; synchronize
				state.authhost.want := set.httpauth
				update_class_fields -- Current might have been changed; synchronize
				state.authproxy.want := set.proxyauth
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (info.wouldredirect))
				update_class_fields -- Current might have been changed; synchronize
				info.wouldredirect := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				if (not (change.cookielist).is_void) then
					((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_cookie_loadfiles
					update_class_fields -- Current might have been changed; synchronize
				end
				state.allow_port := (1).to_boolean
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GETINFO_STATIC}).Curl_initinfo ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_pgrsStartNow
				update_class_fields -- Current might have been changed; synchronize
				if (set.timeout).to_boolean then
					((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_expire (set.timeout)
					update_class_fields -- Current might have been changed; synchronize
				end
				if (set.connecttimeout).to_boolean then
					((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_expire (set.connecttimeout)
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_posttransfer: NATURAL_32
		do
			if not ((progress.flags).bit_and (((1).bit_shift_left (4)))).to_boolean then
				if not progress.callback then
					(create {P_MPRINTF_STATIC}).curl_mfprintf ([set.err, ce_string ("%N")]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	connect_host (a_conn: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]): NATURAL_32
		local
			l_res: NATURAL_32
			l_async: CE_ARRAY [BOOLEAN]
			l_protocol_done: CE_ARRAY [BOOLEAN]
		do
			create {CE_BOOLEAN_ARRAY} l_async.make (<<1>>)
			create {CE_BOOLEAN_ARRAY} l_protocol_done.make (<<1>>)

			l_res := {PC_CURLCODE}.CURLE_OK
			l_protocol_done.item := (1).to_boolean
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_PROGRESS_STATIC}).Curl_pgrsTime ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), {PC_TIMERID}.TIMER_STARTSINGLE)
			update_class_fields -- Current might have been changed; synchronize
			l_res := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_connect (a_conn, l_async, l_protocol_done)
			update_class_fields -- Current might have been changed; synchronize
			if {NATURAL_32} 0 = l_res then
				if l_async.item then
					l_res := (create {P_HOSTSYN_STATIC}).Curl_wait_for_resolv (a_conn.item, create {CE_POINTER_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer))
					update_class_fields -- Current might have been changed; synchronize
					if {NATURAL_32} 0 = l_res then
						l_res := (create {P_URL_STATIC}).Curl_async_resolved (a_conn.item, l_protocol_done)
						update_class_fields -- Current might have been changed; synchronize
					else
						(create {P_URL_STATIC}).Curl_disconnect (a_conn.item).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			Result := l_res
		end

	Curl_do_perform: NATURAL_32
		local
			l_res: NATURAL_32
			l_res2: NATURAL_32
			l_conn: CE_ARRAY [CE_POINTER [PD_CONNECTDATA]]
			l_newurl: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_follow: NATURAL_32
			l_do_done: CE_ARRAY [BOOLEAN]
			l_retry: BOOLEAN
			l_rc: NATURAL_32
			l_tmp: NATURAL_32
			l_str: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_CONNECTDATA]} l_conn.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_newurl.make (<<1>>)
			create {CE_BOOLEAN_ARRAY} l_do_done.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_conn.item := create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					l_newurl.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					l_follow := {PC_FOLLOWTYPE}.FOLLOW_NONE
					state.used_interface := {PC_USED_INTERFACE}.Curl_if_easy
					update_class_fields -- Current might have been changed; synchronize
					l_res := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_pretransfer
					update_class_fields -- Current might have been changed; synchronize
					if l_res.to_boolean then
						Result := l_res
						l_return := True
					end
					if l_return then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 16 -- skip loop
						end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						l_res := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.connect_host (l_conn)
						update_class_fields -- Current might have been changed; synchronize
						if l_res /= {NATURAL_32} 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 3 then -- if:
						if set.connect_only then
							l_conn.item.item.bits.close := (0).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							l_res := (create {P_URL_STATIC}).Curl_done (l_conn, {PC_CURLCODE}.CURLE_OK, (0).to_boolean)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						if (l_break or l_continue) then
							l_pos := -1 + 14 -- skip if block
						end
				when 4 then -- if:
						l_res := (create {P_URL_STATIC}).Curl_do (l_conn, l_do_done)
						update_class_fields -- Current might have been changed; synchronize
						if l_res /= {NATURAL_32} 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if (l_conn.item.item.data).item.set.wildcardmatch then
							if (l_conn.item.item.data).item.wildcard.state = {NATURAL_32} 6 then
								l_conn.item.item.bits.close := (0).to_boolean
								update_class_fields -- Current might have been changed; synchronize
								l_res := (create {P_URL_STATIC}).Curl_done (l_conn, {PC_CURLCODE}.CURLE_OK, (0).to_boolean)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							elseif (l_conn.item.item.data).item.wildcard.state = {NATURAL_32} 4 then
								l_conn.item.item.bits.close := (0).to_boolean
								update_class_fields -- Current might have been changed; synchronize
								l_res := (create {P_URL_STATIC}).Curl_done (l_conn, {PC_CURLCODE}.CURLE_OK, (0).to_boolean)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
						end
						if (l_break or l_continue) then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
						l_res := Transfer (l_conn.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_res /= {NATURAL_32} 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if l_res /= {NATURAL_32} 56 then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						l_retry := (0).to_boolean
						l_tmp := (l_conn.item).item.Curl_retry_request (l_newurl)
						update_class_fields -- Current might have been changed; synchronize
						l_rc := l_tmp
						if l_rc.to_boolean then
							l_res := l_rc
						elseif (not (l_newurl.item).is_void) then
							l_retry := (1).to_boolean
						else
							l_retry := (0).to_boolean
						end
						if l_retry then
							l_res := {PC_CURLCODE}.CURLE_OK
							l_follow := {PC_FOLLOWTYPE}.FOLLOW_RETRY
						elseif l_res = {NATURAL_32} 0 then
							if (not (req.newurl).is_void) then
								l_follow := {PC_FOLLOWTYPE}.FOLLOW_REDIR
								l_newurl.item := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([req.newurl]))
								update_class_fields -- Current might have been changed; synchronize
								if (l_newurl.item).is_void then
									l_res := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
								end
							elseif (not (req.location).is_void) then
								l_follow := {PC_FOLLOWTYPE}.FOLLOW_FAKE
								l_newurl.item := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([req.location]))
								update_class_fields -- Current might have been changed; synchronize
								if (l_newurl.item).is_void then
									l_res := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
								end
							end
						end
				when 11 then -- if done
						if l_res /= {NATURAL_32} 0 then
							l_conn.item.item.bits.close := (1).to_boolean
							update_class_fields -- Current might have been changed; synchronize
							if -1 /= l_conn.item.item.sock[1] then
								close (l_conn.item.item.sock[1]).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_conn.item.item.sock[1] := -1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_res2 := (create {P_URL_STATIC}).Curl_done (l_conn, l_res, (0).to_boolean)
						update_class_fields -- Current might have been changed; synchronize
						if {NATURAL_32} 0 = l_res then
							l_res := l_res2
						end
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						if (not (l_conn.item).is_void) then
							(create {P_URL_STATIC}).Curl_done (l_conn, l_res, (0).to_boolean).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
				when 14 then -- if done | if done
						if not (l_break or l_continue) and then (l_res = {NATURAL_32} 0) then
							if l_follow.to_boolean then
								l_res := (create {P_TRANSFER_STATIC}).Curl_follow ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), l_newurl.item, l_follow)
								update_class_fields -- Current might have been changed; synchronize
								if {NATURAL_32} 0 = l_res then
									l_newurl.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									update_class_fields -- Current might have been changed; synchronize
									if l_follow >= {NATURAL_32} 2 then
										l_follow := {PC_FOLLOWTYPE}.FOLLOW_NONE
										l_continue := True
									end
								end
							end
						end
				when 15 then -- if done
						if not (l_break or l_continue) then
							l_break := True
						end
						if (not l_break) then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 16 then -- loop done
						l_break := False
						l_continue := False
						if (not (l_newurl.item).is_void) then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_newurl.item)])
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_res.to_boolean then
							if not state.errorbuf then
								l_tmp___0 := curl_easy_strerror (l_res)
								update_class_fields -- Current might have been changed; synchronize
								l_str := l_tmp___0
								if l_str.is_void then
									((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_failf ([ce_string ("unspecified error %%d"), l_res.to_integer_32])
									update_class_fields -- Current might have been changed; synchronize
								else
									((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_failf ([ce_string ("%%s"), l_str])
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						l_res2 := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_posttransfer
						update_class_fields -- Current might have been changed; synchronize
						if not l_res.to_boolean then
							if l_res2.to_boolean then
								l_res := l_res2
							end
						end
						Result := l_res
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_perform: NATURAL_32
		local
			l_res: NATURAL_32
			l_tmp: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if not set.wildcardmatch then
				l_tmp := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_do_perform
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp
				l_return := True
			end
			if not l_return then
				l_res := (create {CE_CLASS_POINTER [PD_WILDCARDDATA]}.make_shared (c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("wildcard"))).item.Curl_wildcard_init
				update_class_fields -- Current might have been changed; synchronize
				if l_res.to_boolean then
					Result := l_res
					l_return := True
				end
			end
			if not l_return then
				l_res := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_do_perform
				update_class_fields -- Current might have been changed; synchronize
				if l_res.to_boolean then
					(create {P_WILDCARD_STATIC}).Curl_wildcard_dtor (create {CE_CLASS_POINTER [PD_WILDCARDDATA]}.make_shared (c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("wildcard")))
					update_class_fields -- Current might have been changed; synchronize
					Result := l_res
					l_return := True
				end
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					if not l_res.to_boolean then
						if wildcard.state = {NATURAL_32} 6 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_res := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_do_perform
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_break := False;
				(create {P_WILDCARD_STATIC}).Curl_wildcard_dtor (create {CE_CLASS_POINTER [PD_WILDCARDDATA]}.make_shared (c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("wildcard")))
				update_class_fields -- Current might have been changed; synchronize
				wildcard.state := {PC_CURL_WILDCARD_STATES}.CURLWC_INIT
				update_class_fields -- Current might have been changed; synchronize
				Result := l_res
			end
		end

	Curl_easy_addmulti (a_multi: CE_POINTER [ANY])
		do
			Current.multi := create {CE_CLASS_POINTER [PD_CURL_MULTI]}.make_cast (a_multi)
			update_class_fields -- Current might have been changed; synchronize
			if a_multi.is_void then
				state.used_interface := {PC_USED_INTERFACE}.Curl_if_none
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	Curl_easy_initHandleData
		do
			memset (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_SINGLEREQUEST]}.make_shared (c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req")))), 0, (create {PD_SINGLEREQUEST}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			req.maxdownload := (-1).to_integer_64
			update_class_fields -- Current might have been changed; synchronize
		end

	Curl_getconnectinfo (a_connp: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]): INTEGER_32
		local
			l_sockfd: INTEGER_32
			l_c: CE_POINTER [PD_CONNECTDATA]
			l_buf: CE_ARRAY [INTEGER_8]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_buf.make (<<1>>)

			if state.lastconnect /= -1 then
				if not ((state.connc).item.connects[state.lastconnect]).is_void then
					l_c := (state.connc).item.connects[state.lastconnect]
					if (not a_connp.is_void) then
						a_connp.item := l_c
						update_class_fields -- Current might have been changed; synchronize
					end
					l_sockfd := l_c.item.sock[0]
					if l_c.item.ssl[0].use then
						Result := (-1)
						l_return := True
					else
						l_tmp := recv (l_c.item.sock[0], create {CE_VOID_POINTER}.make_cast (l_buf), (1).to_natural_32, 2)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp = 0 then
							Result := (-1)
							l_return := True
						end
					end
				else
					Result := (-1)
					l_return := True
				end
			else
				Result := (-1)
				l_return := True
			end
			if not l_return then
				Result := l_sockfd
			end
		end

	Curl_multi_handlePipeBreak
		local
			l_one_easy: CE_POINTER [PD_CURL_ONE_EASY]
		do
			l_one_easy := set.one_easy
			if (not l_one_easy.is_void) then
				l_one_easy.item.easy_conn := create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	addHandleToSendOrPendPipeline (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		require
			not a_conn.is_void
		local
			l_pipeLen: NATURAL_32
			l_sendhead: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_pipeline: CE_POINTER [PD_CURL_LLIST]
			l_rc: NATURAL_32
			l_tmp: BOOLEAN
		do
			l_pipeLen := (a_conn.item.send_pipe).item.size + (a_conn.item.recv_pipe).item.size
			l_sendhead := (a_conn.item.send_pipe).item.head
			l_tmp := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.Curl_isPipeliningEnabled
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp then
				if l_pipeLen = {NATURAL_32} 0 then
					l_pipeline := a_conn.item.send_pipe
				elseif a_conn.item.server_supports_pipelining then
					if l_pipeLen < {NATURAL_32} 5 then
						l_pipeline := a_conn.item.send_pipe
					else
						l_pipeline := a_conn.item.pend_pipe
					end
				else
					l_pipeline := a_conn.item.pend_pipe
				end
			else
				l_pipeline := a_conn.item.send_pipe
			end
			l_rc := Curl_addHandleToPipeline ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), l_pipeline)
			update_class_fields -- Current might have been changed; synchronize
			if l_pipeline.is_equal (a_conn.item.send_pipe) then
				if not l_sendhead.is_equal ((a_conn.item.send_pipe).item.head) then
					a_conn.item.writechannel_inuse := (0).to_boolean
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_SENDF_STATIC}).Curl_infof ([a_conn.item.data, ce_string ("%%p is at send pipe head!%N"), ((a_conn.item.send_pipe).item.head).item.ptr])
					update_class_fields; -- Current might have been changed; synchronize
					(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_cast (((a_conn.item.send_pipe).item.head).item.ptr)).item.Curl_expire (1)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			Result := l_rc
		end

	Curl_expire (a_milli: INTEGER_32)
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_nowp: CE_POINTER [SD_TIMEVAL]
			l_rc: INTEGER_32
			l_list: CE_POINTER [PD_CURL_LLIST]
			l_set: CE_ARRAY [SD_TIMEVAL]
			l_rest: INTEGER_32
			l_diff: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_set.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_multi := multi
					l_nowp := create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("expiretime"))
					if l_multi.is_void then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if a_milli.to_boolean then
							l_pos := -1 + 8 -- skip if block
						end
				when 2 then -- if:
						if not ((l_nowp.item.tv_sec).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if not ((l_nowp.item.tv_usec).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						l_list := state.timeoutlist
						l_rc := Curl_splayremovebyaddr (l_multi.item.timetree, create {CE_CLASS_POINTER [PD_CURL_TREE]}.make_shared (c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("timenode")), create {CE_POINTER_POINTER [PD_CURL_TREE]}.make_shared (l_multi.c_pointer + (create {PD_CURL_MULTI}.make).offset_of ("timetree")))
						update_class_fields -- Current might have been changed; synchronize
						if l_rc.to_boolean then
							(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("Internal error clearing splay node = %%d%N"), l_rc])
							update_class_fields -- Current might have been changed; synchronize
						end
						from
						until
							not (l_list.item.size > {NATURAL_32} 0)
						loop
							l_list.item.Curl_llist_remove (l_list.item.tail, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("Expire cleared%N")])
						update_class_fields -- Current might have been changed; synchronize
						l_nowp.item.tv_sec := (0).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_nowp.item.tv_usec := (0).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
				when 7 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 14
				when 8 then -- else:
						l_set.item := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
						update_class_fields -- Current might have been changed; synchronize
						l_set.item.tv_sec := l_set.item.tv_sec + (a_milli // 1_000)
						update_class_fields -- Current might have been changed; synchronize
						l_set.item.tv_usec := l_set.item.tv_usec + ((a_milli \\ 1_000) * 1_000)
						update_class_fields -- Current might have been changed; synchronize
						l_rest := (l_set.item.tv_usec - 1_000_000).to_integer_32
						if l_rest > 0 then
							l_set.item.tv_sec := (l_set.item.tv_sec) + 1
							update_class_fields -- Current might have been changed; synchronize
							l_set.item.tv_usec := l_set.item.tv_usec - (1_000_000)
							update_class_fields -- Current might have been changed; synchronize
						end
						if not ((l_nowp.item.tv_sec).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not ((l_nowp.item.tv_usec).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L___0:
						l_tmp := (create {P_TIMEVAL_STATIC}).curlx_tvdiff ((l_set.item).twin, (l_nowp.item).twin)
						update_class_fields -- Current might have been changed; synchronize
						l_diff := l_tmp
						if l_diff > 0 then
							multi_addtimeout (state.timeoutlist, l_set).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
						if not l_return then
							multi_addtimeout (state.timeoutlist, l_nowp).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_rc := Curl_splayremovebyaddr (l_multi.item.timetree, create {CE_CLASS_POINTER [PD_CURL_TREE]}.make_shared (c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("timenode")), create {CE_POINTER_POINTER [PD_CURL_TREE]}.make_shared (l_multi.c_pointer + (create {PD_CURL_MULTI}.make).offset_of ("timetree")))
							update_class_fields -- Current might have been changed; synchronize
							if l_rc.to_boolean then
								(create {P_SENDF_STATIC}).Curl_infof ([(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer)), ce_string ("Internal error removing splay node = %%d%N"), l_rc])
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 13 then -- if done
						if not l_return then
							l_nowp.item := (l_set.item).twin
							update_class_fields -- Current might have been changed; synchronize
							state.timenode.payload := create {CE_VOID_POINTER}.make_shared (c_pointer)
							update_class_fields -- Current might have been changed; synchronize
							l_multi.item.timetree := (create {P_SPLAY_STATIC}).Curl_splayinsert ((l_nowp.item).twin, l_multi.item.timetree, create {CE_CLASS_POINTER [PD_CURL_TREE]}.make_shared (c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("timenode")))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 14 then -- if done
					if not l_return then
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_share_lock (a_type, a_accesstype: NATURAL_32): NATURAL_32
		local
			l_share: CE_POINTER [PD_CURL_SHARE]
			l_return: BOOLEAN
		do
			l_share := share
			if l_share.is_void then
				Result := ({PC_CURLSHCODE}.CURLSHE_INVALID)
				l_return := True
			end
			if not l_return then
				if ((l_share.item.specifier).bit_and (((1).bit_shift_left (a_type.to_integer_32)).to_natural_32)).to_boolean then
					if (not (l_share.item.lockfunc).is_void) then
						(l_share.item.lockfunc).call ([create {CE_VOID_POINTER}.make_shared (c_pointer), a_type, a_accesstype, l_share.item.clientdata])
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				Result := ({PC_CURLSHCODE}.CURLSHE_OK)
			end
		end

	Curl_share_unlock (a_type: NATURAL_32): NATURAL_32
		local
			l_share: CE_POINTER [PD_CURL_SHARE]
			l_return: BOOLEAN
		do
			l_share := share
			if l_share.is_void then
				Result := ({PC_CURLSHCODE}.CURLSHE_INVALID)
				l_return := True
			end
			if not l_return then
				if ((l_share.item.specifier).bit_and (((1).bit_shift_left (a_type.to_integer_32)).to_natural_32)).to_boolean then
					if (not (l_share.item.unlockfunc).is_void) then
						(l_share.item.unlockfunc).call ([create {CE_VOID_POINTER}.make_shared (c_pointer), a_type, l_share.item.clientdata])
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				Result := ({PC_CURLSHCODE}.CURLSHE_OK)
			end
		end

	close_connections
		local
			l_i: INTEGER_32
			l_break: BOOLEAN
		do
			from
			until
				(l_break)
			loop
				l_break := False
				l_i := ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_shared (c_pointer))).item.ConnectionKillOne
				update_class_fields -- Current might have been changed; synchronize
				if l_i = -1 then
					l_break := True
				end
			end
			l_break := False
		end

feature {PD_SESSIONHANDLE_STATIC} -- private routines

	Curl_tvlong (a_t1: SD_TIMEVAL): INTEGER_32
		do
			Result := (a_t1.tv_sec)
		end

	hostcache_timestamp_remove (a_datap, a_hc: CE_POINTER [ANY]): INTEGER_32
		local
			l_data: CE_POINTER [PD_HOSTCACHE_PRUNE_DATA]
			l_c: CE_POINTER [PD_CURL_DNS_ENTRY]
		do
			l_data := create {CE_CLASS_POINTER [PD_HOSTCACHE_PRUNE_DATA]}.make_cast (a_datap)
			l_c := create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_cast (a_hc)
			Result := (l_data.item.now - l_c.item.timestamp >= l_data.item.cache_timeout).to_integer
		end

	hostcache_prune (a_hostcache: CE_POINTER [PD_CURL_HASH]; a_cache_timeout, a_now: INTEGER_32)
		local
			l_user: CE_ARRAY [PD_HOSTCACHE_PRUNE_DATA]
		do
			create {CE_CLASS_ARRAY [PD_HOSTCACHE_PRUNE_DATA]} l_user.make (<<1>>)

			l_user.item.cache_timeout := a_cache_timeout
			l_user.item.now := a_now
			Curl_hash_clean_with_criterium (a_hostcache, create {CE_VOID_POINTER}.make_cast (l_user), hostcache_timestamp_remove_address)
		end

	Curl_hash_clean_with_criterium (a_h: CE_POINTER [PD_CURL_HASH]; a_user: CE_POINTER [ANY]; a_comp: CE_ROUTINE)
		require
			not a_h.is_void
		local
			l_le: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_lnext: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_list: CE_POINTER [PD_CURL_LLIST]
			l_i: INTEGER_32
			l_he: CE_POINTER [PD_CURL_HASH_ELEMENT]
			l_return: BOOLEAN
		do
			l_i := 0
			from
			until
				not (not (l_return) and then (l_i < a_h.item.slots))
			loop
				l_list := a_h.item.table[l_i]
				l_le := l_list.item.head
				from
				until
					l_le.is_void
				loop
					l_he := create {CE_CLASS_POINTER [PD_CURL_HASH_ELEMENT]}.make_cast (l_le.item.ptr)
					l_lnext := l_le.item.next
					if (a_comp.integer_32_item ([a_user, l_he.item.ptr])).to_boolean then
						l_list.item.Curl_llist_remove (l_le, create {CE_VOID_POINTER}.make_cast (a_h)).do_nothing
						a_h.item.size := (a_h.item.size) - 1
					end
					l_le := l_lnext
				end
				l_i := l_i + 1
			end
		end

	Curl_cookie_output (a_c: CE_POINTER [PD_COOKIEINFO]; a_dumphere: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_co: CE_POINTER [PD_COOKIE]
			l_out: CE_POINTER [SD_IO_FILE]
			l_use_stdout: BOOLEAN
			l_format_ptr: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_use_stdout := (0).to_boolean
			if a_c.is_void then
				Result := 0
				l_return := True
			elseif 0 = a_c.item.numcookies then
				Result := 0
				l_return := True
			end
			if not l_return then
				if ((create {P_STREQUAL_STATIC}).curl_strequal (ce_string ("-"), a_dumphere)).to_boolean then
					l_out := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))
					l_use_stdout := (1).to_boolean
				else
					l_out := fopen (a_dumphere, ce_string ("w"))
					if l_out.is_void then
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return and then (not a_c.is_void) then
				fputs (ce_string ("# Netscape HTTP Cookie File%N# http://curl.haxx.se/rfc/cookie_spec.html%N# This file was generated by libcurl! Edit at your own risk.%N%N"), l_out).do_nothing
				l_co := a_c.item.cookies
				from
				until
					not (not (l_return) and then (not l_co.is_void))
				loop
					l_format_ptr := get_netscape_format (l_co)
					if l_format_ptr.is_void then
						(create {P_MPRINTF_STATIC}).curl_mfprintf ([l_out, ce_string ("#%N# Fatal libcurl error%N")]).do_nothing
						if not l_use_stdout then
							fclose (l_out).do_nothing
						end
						Result := 1
						l_return := True
					end
					if not l_return then
						(create {P_MPRINTF_STATIC}).curl_mfprintf ([l_out, ce_string ("%%s%N"), l_format_ptr]).do_nothing;
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_format_ptr)])
						l_co := l_co.item.next
					end
				end
			end
			if not l_return then
				if not l_use_stdout then
					fclose (l_out).do_nothing
				end
				Result := 0
			end
		end

	get_netscape_format (a_co: CE_POINTER [PD_COOKIE]): CE_POINTER [INTEGER_8]
		require
			not a_co.is_void
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
		do
			if (not (a_co.item.value).is_void) then
				l_tmp := a_co.item.value
			else
				l_tmp := ce_string ("")
			end
			if a_co.item.secure then
				l_tmp___0 := ce_string ("TRUE")
			else
				l_tmp___0 := ce_string ("FALSE")
			end
			if (not (a_co.item.path).is_void) then
				l_tmp___1 := a_co.item.path
			else
				l_tmp___1 := ce_string ("/")
			end
			if a_co.item.tailmatch then
				l_tmp___2 := ce_string ("TRUE")
			else
				l_tmp___2 := ce_string ("FALSE")
			end
			if (not (a_co.item.domain).is_void) then
				l_tmp___3 := a_co.item.domain
			else
				l_tmp___3 := ce_string ("unknown")
			end
			if a_co.item.tailmatch then
				if (not (a_co.item.domain).is_void) then
					if (a_co.item.domain[0]).to_integer_32 /= 46 then
						l_tmp___4 := ce_string (".")
					else
						l_tmp___4 := ce_string ("")
					end
				else
					l_tmp___4 := ce_string ("")
				end
			else
				l_tmp___4 := ce_string ("")
			end
			if a_co.item.httponly then
				l_tmp___5 := ce_string ("#HttpOnly_")
			else
				l_tmp___5 := ce_string ("")
			end
			Result := ((create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%s%%s%%s%T%%s%T%%s%T%%s%T%%lld%T%%s%T%%s"), l_tmp___5, l_tmp___4, l_tmp___3, l_tmp___2, l_tmp___1, l_tmp___0, a_co.item.expires, a_co.item.name, l_tmp]))
		end

	checkrtspprefix (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_s: CE_POINTER [INTEGER_8]): BOOLEAN
		do
			if ((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("RTSP/"), a_s, (strlen (ce_string ("RTSP/"))))).to_boolean then
				Result := (1).to_boolean
			else
				Result := (0).to_boolean
			end
		end

	Curl_http_readwrite_headers (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_nread: CE_POINTER [INTEGER_32]; a_stop_reading: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_nread.is_void
		local
			l_result: NATURAL_32
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_rest_length: NATURAL_32
			l_full_length: NATURAL_32
			l_writetype: INTEGER_32
			l_headerlen: NATURAL_32
			l_tmp___3: INTEGER_64
			l_httpversion_major: CE_ARRAY [INTEGER_32]
			l_rtspversion_major: CE_ARRAY [INTEGER_32]
			l_nc: INTEGER_32
			l_tmp___5: INTEGER_32
			l_contentlength: INTEGER_64
			l_contenttype: CE_POINTER [INTEGER_8]
			l_start: CE_POINTER [INTEGER_8]
			l_ptr: CE_POINTER [INTEGER_8]
			l_tmp___22: CE_POINTER [INTEGER_8]
			l_secs: CE_ARRAY [INTEGER_32]
			l_location: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_httpversion_major.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rtspversion_major.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_secs.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_k := create {CE_CLASS_POINTER [PD_SINGLEREQUEST]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 91 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						l_k.item.str_start := l_k.item.str
						l_k.item.end_ptr := create {CE_INTEGER_8_POINTER}.make_cast ((memchr (create {CE_VOID_POINTER}.make_cast (l_k.item.str_start), 10, (a_nread.item).to_natural_32)))
						if (l_k.item.end_ptr).is_void then
							l_result := a_data.item.header_append (l_k, (a_nread.item).to_natural_32)
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
							if not l_return then
								if not (l_k.item.headerline).to_boolean then
									if l_k.item.hbuflen > {NATURAL_32} 5 then
										if not (a_data.item.checkprotoprefix (a_conn, a_data.item.state.headerbuff)) then
											l_k.item.header := (0).to_boolean
											l_k.item.badheader := {PC_BADHEADER}.HEADER_ALLBAD
											l_break := True
										end
									end
								end
								if not (l_return or l_break or l_continue) then
									l_break := True
								end
							end
						end
						if l_return then
							l_pos := -1 + 90 -- skip if block
						end
				when 3 then -- if:
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 89 -- skip if block
						end
				when 4 then -- if:
						l_rest_length := (((l_k.item.end_ptr).distance ((l_k.item.str))) + 1).to_natural_32
						a_nread.item := a_nread.item - l_rest_length.to_integer_32
						l_k.item.str := l_k.item.end_ptr + 1
						l_full_length := ((l_k.item.str).distance ((l_k.item.str_start))).to_natural_32
						l_result := a_data.item.header_append (l_k, l_full_length)
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
						if l_return then
							l_pos := -1 + 89 -- skip if block
						end
				when 5 then -- if:
						l_k.item.end_ptr := l_k.item.hbufp
						l_k.item.p := a_data.item.state.headerbuff
						if not (l_k.item.headerline).to_boolean then
							if l_k.item.hbuflen > {NATURAL_32} 5 then
								if not (a_data.item.checkprotoprefix (a_conn, a_data.item.state.headerbuff)) then
									l_k.item.header := (0).to_boolean
									if (a_nread.item).to_boolean then
										l_k.item.badheader := {PC_BADHEADER}.HEADER_PARTHEADER
									else
										l_k.item.badheader := {PC_BADHEADER}.HEADER_ALLBAD
										a_nread.item := l_rest_length.to_integer_32
									end
									l_break := True
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 15 -- skip if block
						end
				when 6 then -- if:
						if 10 /= ((l_k.item.p).item).to_integer_32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 9 then -- else:
						if 13 /= ((l_k.item.p).item).to_integer_32 then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if: | _L___0:
						if 13 = ((l_k.item.p).item).to_integer_32 then
							l_k.item.p := (l_k.item.p) + 1
						end
						if 10 = ((l_k.item.p).item).to_integer_32 then
							l_k.item.p := (l_k.item.p) + 1
						end
						if not (100 <= l_k.item.httpcode) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if 199 >= l_k.item.httpcode then
							l_k.item.header := (1).to_boolean
							l_k.item.headerline := 0
							if (l_k.item.exp100).to_boolean then
								l_k.item.exp100 := {PC_EXPECT100}.EXP100_SEND_DATA
								l_k.item.keepon := (l_k.item.keepon).bit_or (((1).bit_shift_left (1)))
							end
						else
							l_pos := -1 + 13 -- goto _L
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						l_k.item.header := (0).to_boolean
						if l_k.item.size = -{INTEGER_64} 1 then
							if not l_k.item.chunk then
								if not a_conn.item.bits.close then
									if a_conn.item.httpversion >= 11 then
										if not ((a_conn.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
											(create {P_SENDF_STATIC}).Curl_infof ([a_data, ce_string ("no chunk, no close, no size. Assume close to signal end%N")])
											a_conn.item.bits.close := (1).to_boolean
										end
									end
								end
							end
						end
				when 14 then
						if 417 = l_k.item.httpcode then
							l_k.item.exp100 := {PC_EXPECT100}.EXP100_FAILED
							l_k.item.keepon := (l_k.item.keepon).bit_and (((((1).bit_shift_left (1))).bit_not))
						end
						if (a_conn.item.Curl_http_should_fail).to_boolean then
							a_data.item.Curl_failf ([ce_string ("The requested URL returned error: %%d"), l_k.item.httpcode])
							Result := ({PC_CURLCODE}.CURLE_HTTP_RETURNED_ERROR)
							l_return := True
						end
						if not l_return then
							l_writetype := (1).bit_shift_left (1)
							if a_data.item.set.include_header then
								l_writetype := (l_writetype).bit_or ((1))
							end
							l_headerlen := ((l_k.item.p).distance ((a_data.item.state.headerbuff))).to_natural_32
							l_result := a_conn.item.Curl_client_write (l_writetype, a_data.item.state.headerbuff, l_headerlen)
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
						if not l_return then
							a_data.item.info.header_size := a_data.item.info.header_size + l_headerlen.to_integer_32
							a_data.item.req.headerbytecount := a_data.item.req.headerbytecount + l_headerlen.to_integer_32
							if 100 <= l_k.item.httpcode then
								if 199 >= l_k.item.httpcode then
									a_data.item.req.deductheadercount := a_data.item.req.headerbytecount
								else
									a_data.item.req.deductheadercount := 0
								end
							else
								a_data.item.req.deductheadercount := 0
							end
							if not a_stop_reading.item then
								l_result := a_conn.item.Curl_http_auth_act
								if l_result.to_boolean then
									Result := l_result
									l_return := True
								end
								if not l_return and then (a_conn.item.bits.rewindaftersend) then
									(create {P_SENDF_STATIC}).Curl_infof ([a_data, ce_string ("Keep sending data to get tossed away!%N")])
									l_k.item.keepon := (l_k.item.keepon).bit_or (((1).bit_shift_left (1)))
								end
							end
						end
						if not l_return then
							if not l_k.item.header then
								if a_data.item.set.opt_no_body then
									a_stop_reading.item := (1).to_boolean
								elseif l_k.item.chunk then
									l_tmp___3 := (-1).to_integer_64
									l_k.item.size := l_tmp___3
									l_k.item.maxdownload := l_tmp___3
								end
								if -{INTEGER_64} 1 /= l_k.item.size then
									a_data.item.Curl_pgrsSetDownloadSize (l_k.item.size)
									l_k.item.maxdownload := l_k.item.size
								end
								if {INTEGER_64} 0 = l_k.item.maxdownload then
									a_stop_reading.item := (1).to_boolean
								end
								if a_stop_reading.item then
									l_k.item.keepon := (l_k.item.keepon).bit_and ((-2))
								end
								if a_data.item.set.verbose then
									a_data.item.Curl_debug ({PC_CURL_INFOTYPE}.CURLINFO_HEADER_IN, l_k.item.str_start, l_headerlen, a_conn).do_nothing
								end
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_k.item.hbufp := a_data.item.state.headerbuff
								l_k.item.hbuflen := (0).to_natural_32
								l_continue := True
							end
						end
				when 15 then -- if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 35 -- skip if block
						end
				when 16 then -- if:
						l_tmp___5 := l_k.item.headerline
						l_k.item.headerline := (l_k.item.headerline) + 1
						if l_tmp___5.to_boolean then
							l_pos := -1 + 35 -- skip if block
						end
				when 17 then -- if:
						l_nc := 0
						if ((a_conn.item.protocol).bit_and (1)).to_boolean then
							l_nc := sscanf ([l_k.item.p, ce_string (" HTTP/%%d.%%d %%3d"), l_httpversion_major, create {CE_INTEGER_32_POINTER}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("httpversion")), create {CE_INTEGER_32_POINTER}.make_shared (l_k.c_pointer + (create {PD_SINGLEREQUEST}.make).offset_of ("httpcode"))])
							if l_nc = 3 then
								a_conn.item.httpversion := a_conn.item.httpversion + (10 * l_httpversion_major.item)
							else
								l_nc := sscanf ([l_k.item.p, ce_string (" HTTP %%3d"), create {CE_INTEGER_32_POINTER}.make_shared (l_k.c_pointer + (create {PD_SINGLEREQUEST}.make).offset_of ("httpcode"))])
								a_conn.item.httpversion := 10
								if not l_nc.to_boolean then
									if (a_data.item.checkhttpprefix (l_k.item.p)) then
										l_nc := 1
										l_k.item.httpcode := 200
										a_conn.item.httpversion := 10
									end
								end
							end
						elseif ((a_conn.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
							l_nc := sscanf ([l_k.item.p, ce_string (" RTSP/%%d.%%d %%3d"), l_rtspversion_major, create {CE_INTEGER_32_POINTER}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("rtspversion")), create {CE_INTEGER_32_POINTER}.make_shared (l_k.c_pointer + (create {PD_SINGLEREQUEST}.make).offset_of ("httpcode"))])
							if l_nc = 3 then
								a_conn.item.rtspversion := a_conn.item.rtspversion + (10 * l_rtspversion_major.item)
								a_conn.item.httpversion := 11
							else
								l_nc := 0
							end
						end
						if not (l_nc.to_boolean) then
							l_pos := -1 + 34 -- skip if block
						end
				when 18 then -- if:
						a_data.item.info.httpcode := l_k.item.httpcode
						a_data.item.info.httpversion := a_conn.item.httpversion
						if not (a_data.item.state.httpversion).to_boolean then
							a_data.item.state.httpversion := a_conn.item.httpversion
						elseif a_data.item.state.httpversion > a_conn.item.httpversion then
							a_data.item.state.httpversion := a_conn.item.httpversion
						end
						if not (a_data.item.set.http_fail_on_error) then
							l_pos := -1 + 29 -- skip if block
						end
				when 19 then -- if:
						if not (l_k.item.httpcode >= 400) then
							l_pos := -1 + 29 -- skip if block
						end
				when 20 then -- if:
						if l_k.item.httpcode = 401 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 24 -- goto _L___2
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 23 then -- else:
						if a_conn.item.bits.user_passwd then
							l_pos := -1 + 29 -- skip if block
						end
				when 24 then -- if: | _L___2:
						if l_k.item.httpcode = 407 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L___1
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 27 then -- else:
						if a_conn.item.bits.proxy_user_passwd then
							l_pos := -1 + 29 -- skip if block
						end
				when 28 then -- if: | _L___1:
						if (a_data.item.state.resume_from).to_boolean then
							if a_data.item.set.httpreq = {NATURAL_32} 1 then
								if l_k.item.httpcode /= 416 then
									a_data.item.Curl_failf ([ce_string ("The requested URL returned error: %%d"), l_k.item.httpcode])
									Result := ({PC_CURLCODE}.CURLE_HTTP_RETURNED_ERROR)
									l_return := True
								end
							else
								a_data.item.Curl_failf ([ce_string ("The requested URL returned error: %%d"), l_k.item.httpcode])
								Result := ({PC_CURLCODE}.CURLE_HTTP_RETURNED_ERROR)
								l_return := True
							end
						else
							a_data.item.Curl_failf ([ce_string ("The requested URL returned error: %%d"), l_k.item.httpcode])
							Result := ({PC_CURLCODE}.CURLE_HTTP_RETURNED_ERROR)
							l_return := True
						end
				when 29 then -- if done | if done | if done | if done | if done
						if l_return then
							l_pos := -1 + 33 -- skip if block
						end
				when 30 then -- if:
						if a_conn.item.httpversion = 10 then
							(create {P_SENDF_STATIC}).Curl_infof ([a_data, ce_string ("HTTP 1.0, assume close after body%N")])
							a_conn.item.bits.close := (1).to_boolean
						elseif a_conn.item.httpversion >= 11 then
							if not a_conn.item.bits.close then
								a_conn.item.server_supports_pipelining := (1).to_boolean
							end
						end
						inspect l_k.item.httpcode -- switch 1 head
						when 204 then l_pos := -1 + 31
						when 304 then l_pos := -1 + 31
						else l_pos := -1 + 32
						end
				when 31 then -- switch 1, case 204 | switch 1, case 304
						if (a_data.item.set.timecondition).to_boolean then
							a_data.item.info.timecond := (1).to_boolean
						end
						l_k.item.size := (0).to_integer_64
						l_k.item.maxdownload := (0).to_integer_64
						l_k.item.ignorecl := (1).to_boolean
						l_pos := -1 + 33 -- switch 1; break
				when 32 then -- switch 1, default:
						l_pos := -1 + 33 -- switch 1; break
				when 33 then -- switch 1, done: | if done | if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else:
						l_k.item.header := (0).to_boolean
						l_break := True
				when 35 then -- if done | if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 89 -- skip if block
						end
				when 36 then -- if:
						if l_k.item.ignorecl then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if not a_data.item.set.ignorecl then
							if ((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Content-Length:"), l_k.item.p, (strlen (ce_string ("Content-Length:"))))).to_boolean then
								l_contentlength := (strtoll ((l_k.item.p + 15), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10))
								if (a_data.item.set.max_filesize).to_boolean then
									if l_contentlength > a_data.item.set.max_filesize then
										a_data.item.Curl_failf ([ce_string ("Maximum file size exceeded")])
										Result := ({PC_CURLCODE}.CURLE_FILESIZE_EXCEEDED)
										l_return := True
									end
								end
								if not l_return then
									if l_contentlength >= {INTEGER_64} 0 then
										l_k.item.size := l_contentlength
										l_k.item.maxdownload := l_k.item.size
										a_data.item.Curl_pgrsSetDownloadSize (l_k.item.size)
									else
										a_conn.item.bits.close := (1).to_boolean;
										(create {P_SENDF_STATIC}).Curl_infof ([a_data, ce_string ("Negative content-length: %%lld, closing after transfer%N"), l_contentlength])
									end
								end
							else
								l_pos := -1 + 39 -- goto _L___19
							end
						else
							l_pos := -1 + 39 -- goto _L___19
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 39 then -- else: | _L___19:
						if not (((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Content-Type:"), l_k.item.p, (strlen (ce_string ("Content-Type:"))))).to_boolean) then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						l_contenttype := ((create {P_HTTP_STATIC}).Curl_copy_header_value (l_k.item.p))
						if l_contenttype.is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							if not (l_contenttype[0]).to_boolean then
								(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_contenttype)])
							else
								(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_data.item.info.contenttype))
								a_data.item.info.contenttype := l_contenttype
							end
						end
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 42 then -- else:
						if a_conn.item.httpversion /= 10 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						if a_conn.item.bits.httpproxy then
							if ((create {P_HTTP_STATIC}).Curl_compareheader (l_k.item.p, ce_string ("Proxy-Connection:"), ce_string ("keep-alive"))) then
								a_conn.item.bits.close := (0).to_boolean;
								(create {P_SENDF_STATIC}).Curl_infof ([a_data, ce_string ("HTTP/1.0 proxy connection set to keep alive!%N")])
							else
								l_pos := -1 + 45 -- goto _L___17
							end
						else
							l_pos := -1 + 45 -- goto _L___17
						end
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 45 then -- else: | _L___17:
						if a_conn.item.httpversion /= 11 then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						if a_conn.item.bits.httpproxy then
							if ((create {P_HTTP_STATIC}).Curl_compareheader (l_k.item.p, ce_string ("Proxy-Connection:"), ce_string ("close"))) then
								a_conn.item.bits.close := (1).to_boolean;
								(create {P_SENDF_STATIC}).Curl_infof ([a_data, ce_string ("HTTP/1.1 proxy connection set close!%N")])
							else
								l_pos := -1 + 48 -- goto _L___15
							end
						else
							l_pos := -1 + 48 -- goto _L___15
						end
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 48 then -- else: | _L___15:
						if a_conn.item.httpversion /= 10 then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						if ((create {P_HTTP_STATIC}).Curl_compareheader (l_k.item.p, ce_string ("Connection:"), ce_string ("keep-alive"))) then
							a_conn.item.bits.close := (0).to_boolean;
							(create {P_SENDF_STATIC}).Curl_infof ([a_data, ce_string ("HTTP/1.0 connection set to keep alive!%N")])
						else
							l_pos := -1 + 51 -- goto _L___13
						end
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 51 then -- else: | _L___13:
						if not ((create {P_HTTP_STATIC}).Curl_compareheader (l_k.item.p, ce_string ("Connection:"), ce_string ("close"))) then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
						a_conn.item.bits.close := (1).to_boolean
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 54 then -- else:
						if not ((create {P_HTTP_STATIC}).Curl_compareheader (l_k.item.p, ce_string ("Transfer-Encoding:"), ce_string ("chunked"))) then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						if not ((a_conn.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
							l_k.item.chunk := (1).to_boolean;
							(create {P_HTTP_CHUNKS_STATIC}).Curl_httpchunk_init (a_conn)
						else
							l_pos := -1 + 57 -- goto _L___12
						end
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 57 then -- else: | _L___12:
						if not (((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Content-Encoding:"), l_k.item.p, (strlen (ce_string ("Content-Encoding:"))))).to_boolean) then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						if (not (a_data.item.set.str[6]).is_void) then
							l_start := l_k.item.p + 17
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_start[0]).to_boolean then
									if not ((((ctype_b_loc).item[((l_start[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_start := l_start + 1
								end
							end
							l_break := False
							if ((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("identity"), l_start, (strlen (ce_string ("identity"))))).to_boolean then
								l_k.item.content_encoding := 0
							elseif ((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("deflate"), l_start, (strlen (ce_string ("deflate"))))).to_boolean then
								l_k.item.content_encoding := 1
							elseif ((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("gzip"), l_start, (strlen (ce_string ("gzip"))))).to_boolean then
								l_k.item.content_encoding := 2
							elseif ((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("x-gzip"), l_start, (strlen (ce_string ("x-gzip"))))).to_boolean then
								l_k.item.content_encoding := 2
							elseif ((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("compress"), l_start, (strlen (ce_string ("compress"))))).to_boolean then
								l_k.item.content_encoding := 3
							elseif ((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("x-compress"), l_start, (strlen (ce_string ("x-compress"))))).to_boolean then
								l_k.item.content_encoding := 3
							end
						else
							l_pos := -1 + 60 -- goto _L___11
						end
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 60 then -- else: | _L___11:
						if not (((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Content-Range:"), l_k.item.p, (strlen (ce_string ("Content-Range:"))))).to_boolean) then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						l_ptr := l_k.item.p + 14
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_ptr[0]).to_boolean then
								if ((((ctype_b_loc).item[((l_ptr[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_ptr := l_ptr + 1
							end
						end
						l_break := False
						l_k.item.offset := strtoll (l_ptr, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10)
						if a_data.item.state.resume_from = l_k.item.offset then
							l_k.item.content_range := (1).to_boolean
						end
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 63 then -- else:
						if (a_data.item.cookies).is_void then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						if ((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Set-Cookie:"), l_k.item.p, (strlen (ce_string ("Set-Cookie:"))))).to_boolean then
							a_data.item.Curl_share_lock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
							if (not (a_conn.item.allocptr.cookiehost).is_void) then
								l_tmp___22 := a_conn.item.allocptr.cookiehost
							else
								l_tmp___22 := a_conn.item.host.name
							end
							(create {P_COOKIE_STATIC}).Curl_cookie_add (a_data, a_data.item.cookies, (1).to_boolean, l_k.item.p + 11, l_tmp___22, a_data.item.state.path).do_nothing
							a_data.item.Curl_share_unlock ({PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE).do_nothing
						else
							l_pos := -1 + 66 -- goto _L___10
						end
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 66 then -- else: | _L___10:
						if not (((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Last-Modified:"), l_k.item.p, (strlen (ce_string ("Last-Modified:"))))).to_boolean) then
							l_pos := -1 + 75 -- skip if block
						end
				when 67 then -- if:
						if not ((a_data.item.set.timecondition).to_boolean) then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						l_pos := -1 + 71 -- goto _L___9
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 74
				when 70 then -- else:
						if not (a_data.item.set.get_filetime) then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if: | _L___9:
						l_secs.item := (time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
						l_k.item.timeofdoc := (create {P_PARSEDATE_STATIC}).curl_getdate ((l_k.item.p + (strlen (ce_string ("Last-Modified:"))).to_integer_32), l_secs)
						if a_data.item.set.get_filetime then
							a_data.item.info.filetime := l_k.item.timeofdoc
						end
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 74
				when 73 then -- else:
						l_pos := -1 + 75 -- goto _L___8
				when 74 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 88
				when 75 then -- else: | _L___8:
						if not (((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("WWW-Authenticate:"), l_k.item.p, (strlen (ce_string ("WWW-Authenticate:"))))).to_boolean) then
							l_pos := -1 + 78 -- skip if block
						end
				when 76 then -- if:
						if 401 = l_k.item.httpcode then
							l_pos := -1 + 80 -- goto _L___5
						else
							l_pos := -1 + 78 -- goto _L___7
						end
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 78 then -- else: | _L___7:
						if not (((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Proxy-authenticate:"), l_k.item.p, (strlen (ce_string ("Proxy-authenticate:"))))).to_boolean) then
							l_pos := -1 + 84 -- skip if block
						end
				when 79 then -- if:
						if 407 /= l_k.item.httpcode then
							l_pos := -1 + 82 -- skip if block
						end
				when 80 then -- if: | _L___5:
						l_result := a_conn.item.Curl_http_input_auth (l_k.item.httpcode, l_k.item.p)
						if l_result.to_boolean then
							Result := l_result
							l_return := True
						end
				when 81 then -- if block done, skip else block:
						l_pos := -1 + 83
				when 82 then -- else:
						l_pos := -1 + 84 -- goto _L___6
				when 83 then -- if done | if block done, skip else block:
						l_pos := -1 + 88
				when 84 then -- else: | _L___6:
						if not (l_k.item.httpcode >= 300) then
							l_pos := -1 + 87 -- skip if block
						end
				when 85 then -- if:
						if l_k.item.httpcode < 400 then
							if ((create {P_RAWSTR_STATIC}).Curl_raw_nequal (ce_string ("Location:"), l_k.item.p, (strlen (ce_string ("Location:"))))).to_boolean then
								l_location := ((create {P_HTTP_STATIC}).Curl_copy_header_value (l_k.item.p))
								if l_location.is_void then
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									l_return := True
								end
								if not l_return then
									if not (l_location[0]).to_boolean then
										(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_location)])
									else
										a_data.item.req.location := l_location
										if a_data.item.set.http_follow_location then
											a_data.item.req.newurl := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([a_data.item.req.location]))
											if (a_data.item.req.newurl).is_void then
												Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
												l_return := True
											end
											if not l_return then
												l_result := a_conn.item.Curl_http_perhapsrewind
												if l_result.to_boolean then
													Result := l_result
													l_return := True
												end
											end
										end
									end
								end
							else
								l_pos := -1 + 87 -- goto _L___4
							end
						else
							l_pos := -1 + 87 -- goto _L___4
						end
				when 86 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 87 then -- else: | _L___4:
						if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
							l_result := a_conn.item.Curl_rtsp_parseheader (l_k.item.p)
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
				when 88 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not l_return then
							l_writetype := (1).bit_shift_left (1)
							if a_data.item.set.include_header then
								l_writetype := (l_writetype).bit_or ((1))
							end
							if a_data.item.set.verbose then
								a_data.item.Curl_debug ({PC_CURL_INFOTYPE}.CURLINFO_HEADER_IN, l_k.item.p, l_k.item.hbuflen, a_conn).do_nothing
							end
							l_result := a_conn.item.Curl_client_write (l_writetype, l_k.item.p, l_k.item.hbuflen)
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
						end
						if not l_return then
							a_data.item.info.header_size := a_data.item.info.header_size + (l_k.item.hbuflen).to_integer_32
							a_data.item.req.headerbytecount := a_data.item.req.headerbytecount + (l_k.item.hbuflen).to_integer_32
							l_k.item.hbufp := a_data.item.state.headerbuff
							l_k.item.hbuflen := (0).to_natural_32
						end
				when 89 then -- if done | if done | if done
						if (not l_return and not l_break) then
							if not a_stop_reading.item then
								if not ((l_k.item.str).item).to_boolean then
									l_pos := -1 + 91 -- break
								end
							else
								l_pos := -1 + 91 -- break
							end
						end
				when 90 then
						l_pos := -1 + 1 -- back to loop condition
				when 91 then -- loop done
					if not l_return then
						l_break := False
						l_continue := False
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 92 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	SocketIsDead (a_sock: INTEGER_32): BOOLEAN
		local
			l_sval: INTEGER_32
			l_ret_val: BOOLEAN
		do
			l_ret_val := (1).to_boolean
			l_sval := (create {P_SELECT_STATIC}).Curl_socket_ready (a_sock, -1, 0)
			if l_sval = 0 then
				l_ret_val := (0).to_boolean
			end
			Result := l_ret_val
		end

	RTSPConnIsDead (a_check: CE_POINTER [PD_CONNECTDATA]): BOOLEAN
		local
			l_check: CE_ARRAY [CE_POINTER [PD_CONNECTDATA]]
			l_sval: INTEGER_32
			l_ret_val: BOOLEAN
			l_connectinfo: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_CONNECTDATA]} l_check.make (<<1>>)

			l_check.item := a_check
			l_ret_val := (1).to_boolean
			l_sval := (create {P_SELECT_STATIC}).Curl_socket_ready (l_check.item.item.sock[0], -1, 0)
			if l_sval = 0 then
				l_ret_val := (0).to_boolean
			elseif ((l_sval).bit_and (4)).to_boolean then
				l_ret_val := (1).to_boolean
			elseif ((l_sval).bit_and (1)).to_boolean then
				l_connectinfo := ((l_check.item.item.data).item.Curl_getconnectinfo (l_check))
				if l_connectinfo /= -1 then
					l_ret_val := (0).to_boolean
				end
			end
			Result := l_ret_val
		end

	Curl_addHandleToPipeline (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_pipeline: CE_POINTER [PD_CURL_LLIST]): NATURAL_32
		require
			not a_pipeline.is_void
		local
			l_return: BOOLEAN
		do
			if not ((create {P_LLIST_STATIC}).Curl_llist_insert_next (a_pipeline, a_pipeline.item.tail, create {CE_VOID_POINTER}.make_cast (a_data))).to_boolean then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				l_return := True
			end
			if not l_return then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	allocate_conn: CE_POINTER [PD_CONNECTDATA]
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_return: BOOLEAN
		do
			l_conn := create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_CONNECTDATA}.make).structure_size.to_natural_32]))))
			if l_conn.is_void then
				Result := (create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_conn.item.handler := Curl_handler_dummy.item
				l_conn.item.sock[0] := -1
				l_conn.item.sock[1] := -1
				l_conn.item.connectindex := -1
				l_conn.item.port := -1
				l_conn.item.bits.close := (1).to_boolean
				l_conn.item.created := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
				Result := l_conn
			end
		end

	setup_connection_internals (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		require
			not a_conn.is_void
		local
			l_p: CE_POINTER [PD_CURL_HANDLER]
			l_result: NATURAL_32
			l_return: BOOLEAN
		do
			a_conn.item.socktype := 1
			l_p := a_conn.item.handler
			if (not (l_p.item.setup_connection).is_void) then
				l_result := (l_p.item.setup_connection).natural_32_item ([a_conn])
				if l_result /= {NATURAL_32} 0 then
					Result := l_result
					l_return := True
				end
				if not l_return then
					l_p := a_conn.item.handler
				end
			end
			if not l_return then
				if a_conn.item.port < 0 then
					a_conn.item.port := l_p.item.defport
				end
				a_conn.item.remote_port := (l_p.item.defport).to_natural_16
				a_conn.item.protocol := (a_conn.item.protocol).bit_or ((l_p.item.protocol))
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	parse_proxy (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_proxy: CE_POINTER [INTEGER_8]): NATURAL_32
		require
			not a_conn.is_void
			not a_proxy.is_void
		local
			l_proxy: CE_POINTER [INTEGER_8]
			l_prox_portno: CE_POINTER [INTEGER_8]
			l_endofprot: CE_POINTER [INTEGER_8]
			l_proxyptr: CE_POINTER [INTEGER_8]
			l_portptr: CE_POINTER [INTEGER_8]
			l_atsign: CE_POINTER [INTEGER_8]
			l_proxyuser: CE_ARRAY [INTEGER_8]
			l_proxypasswd: CE_ARRAY [INTEGER_8]
			l_res: NATURAL_32
			l_ptr: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_proxyuser.make (<<256>>)
			create {CE_INTEGER_8_ARRAY} l_proxypasswd.make (<<256>>)

			l_proxy := a_proxy
			l_endofprot := strstr (l_proxy, ce_string ("://"))
			if (not l_endofprot.is_void) then
				l_proxyptr := l_endofprot + 3
			else
				l_proxyptr := l_proxy
			end
			l_atsign := strchr (l_proxyptr, ('@').code)
			if (not l_atsign.is_void) then
				l_proxypasswd[0] := (0).to_integer_8
				if 1 <= (sscanf ([l_proxyptr, ce_string ("%%255[^:@]:%%255[^@]"), l_proxyuser, l_proxypasswd])) then
					l_res := {PC_CURLCODE}.CURLE_OK;
					(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.proxyuser))
					a_conn.item.proxyuser := (create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_cast (a_data), l_proxyuser, 0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
					if (a_conn.item.proxyuser).is_void then
						l_res := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
					else
						(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.proxypasswd))
						a_conn.item.proxypasswd := (create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_cast (a_data), l_proxypasswd, 0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						if (a_conn.item.proxypasswd).is_void then
							l_res := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
						end
					end
					if {NATURAL_32} 0 = l_res then
						a_conn.item.bits.proxy_user_passwd := (1).to_boolean
						l_atsign := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([(l_atsign + 1)]))
						if (not l_atsign.is_void) then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_proxy)])
							l_proxyptr := l_atsign
							l_proxy := l_proxyptr
						else
							l_res := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
						end
					end
					if l_res.to_boolean then
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_proxy)])
						Result := l_res
						l_return := True
					end
				end
			end
			if not l_return then
				l_portptr := l_proxyptr
				if (l_proxyptr[0]).to_integer_32 = 91 then
					l_proxyptr := l_proxyptr + 1
					l_ptr := l_proxyptr
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_ptr[0]).to_boolean then
							if not ((((ctype_b_loc).item[((l_ptr[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (4_096)).to_boolean then
								if (l_ptr[0]).to_integer_32 /= 58 then
									if (l_ptr[0]).to_integer_32 /= 37 then
										if (l_ptr[0]).to_integer_32 /= 46 then
											l_break := True
										end
									end
								end
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_ptr := l_ptr + 1
						end
					end
					l_break := False
					if (l_ptr[0]).to_integer_32 = 93 then
						l_tmp___1 := l_ptr
						l_ptr := l_ptr + 1
						l_tmp___1[0] := (0).to_integer_8
					else
						(create {P_SENDF_STATIC}).Curl_infof ([a_data, ce_string ("Invalid IPv6 address format%N")])
					end
					l_portptr := l_ptr
				end
				l_prox_portno := strchr (l_portptr, (':').code)
				if (not l_prox_portno.is_void) then
					l_prox_portno[0] := (0).to_integer_8
					l_prox_portno := l_prox_portno + 1
					a_conn.item.port := (atoi (l_prox_portno)).to_integer_32
				else
					l_atsign := strchr (l_proxyptr, ('/').code)
					if (not l_atsign.is_void) then
						l_atsign[0] := (0).to_integer_8
					end
					if (a_data.item.set.proxyport).to_boolean then
						a_conn.item.port := a_data.item.set.proxyport
					end
				end
				a_conn.item.proxy.rawalloc := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([l_proxyptr]))
				a_conn.item.proxy.name := a_conn.item.proxy.rawalloc;
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_proxy)])
				if (a_conn.item.proxy.rawalloc).is_void then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	parse_url_userpass (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_user, a_passwd: CE_POINTER [INTEGER_8]): NATURAL_32
		require
			not a_conn.is_void
			not a_user.is_void
			not a_passwd.is_void
		local
			l_ptr: CE_POINTER [INTEGER_8]
			l_userpass: CE_POINTER [INTEGER_8]
			l_newname: CE_POINTER [INTEGER_8]
			l_newpasswd: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_ptr := (strchr (a_conn.item.host.name, ('@').code))
			l_userpass := a_conn.item.host.name
			a_user[0] := (0).to_integer_8
			a_passwd[0] := (0).to_integer_8
			if not l_ptr.is_void then
				l_ptr := l_ptr + 1
				a_conn.item.host.name := l_ptr
				a_conn.item.bits.userpwd_in_url := (1).to_boolean
				if a_data.item.set.use_netrc /= {NATURAL_32} 2 then
					a_conn.item.bits.user_passwd := (1).to_boolean
					if (l_userpass[0]).to_integer_32 /= 58 then
						sscanf ([l_userpass, ce_string ("%%255[^:@]:%%255[^@]"), a_user, a_passwd]).do_nothing
					else
						sscanf ([l_userpass, ce_string (":%%255[^@]"), a_passwd]).do_nothing
					end
					if (a_user[0]).to_boolean then
						l_newname := ((create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_cast (a_data), a_user, 0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
						if l_newname.is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							if (strlen (l_newname)) < {NATURAL_32} 256 then
								strcpy (a_user, l_newname).do_nothing
							end
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_newname)])
						end
					end
					if not l_return and then ((a_passwd[0]).to_boolean) then
						l_newpasswd := ((create {P_ESCAPE_STATIC}).curl_easy_unescape (create {CE_VOID_POINTER}.make_cast (a_data), a_passwd, 0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
						if l_newpasswd.is_void then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							if (strlen (l_newpasswd)) < {NATURAL_32} 256 then
								strcpy (a_passwd, l_newpasswd).do_nothing
							end
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_newpasswd)])
						end
					end
				end
			end
			if not l_return then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	set_userpass (a_conn: CE_POINTER [PD_CONNECTDATA]; a_user, a_passwd: CE_POINTER [INTEGER_8]): NATURAL_32
		require
			not a_conn.is_void
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (((a_conn.item.protocol).bit_and (((((1).bit_shift_left (2))).bit_or (((1).bit_shift_left (12)))).to_integer_32)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not a_conn.item.bits.user_passwd then
							a_conn.item.user := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([ce_string ("anonymous")]))
							if (not (a_conn.item.user).is_void) then
								a_conn.item.passwd := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([ce_string ("ftp@example.com")]))
							else
								a_conn.item.passwd := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						a_conn.item.user := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([a_user]))
						if (not (a_conn.item.user).is_void) then
							a_conn.item.passwd := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([a_passwd]))
						else
							a_conn.item.passwd := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						end
				when 4 then
					if (a_conn.item.user).is_void then
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						l_return := True
					elseif (a_conn.item.passwd).is_void then
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						l_return := True
					end
					if not l_return then
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	resolve_server (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_async: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_conn.is_void
		local
			l_result: NATURAL_32
			l_timeout_ms: INTEGER_32
			l_rc: INTEGER_32
			l_hostaddr: CE_ARRAY [CE_POINTER [PD_CURL_DNS_ENTRY]]
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_CURL_DNS_ENTRY]} l_hostaddr.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_timeout_ms := (a_conn.item.Curl_timeleft (create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer), (1).to_boolean))
					if not (a_conn.item.bits.reuse) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_async.item := (0).to_boolean
						if a_conn.item.bits.proxy then
							fix_hostname (a_data, a_conn, create {CE_CLASS_POINTER [PD_HOSTNAME]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("host")))
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 3 then -- else:
						fix_hostname (a_data, a_conn, create {CE_CLASS_POINTER [PD_HOSTNAME]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("host")))
						if (not (a_conn.item.proxy.name).is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if ((a_conn.item.proxy.name).item).to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						a_conn.item.port := (a_conn.item.remote_port).to_integer_32
						l_rc := Curl_resolv_timeout (a_conn, a_conn.item.host.name, (a_conn.item.port).to_integer_32, l_hostaddr, l_timeout_ms)
						if l_rc = 1 then
							a_async.item := (1).to_boolean
						elseif l_rc = -2 then
							l_result := {PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT
						elseif (l_hostaddr.item).is_void then
							a_data.item.Curl_failf ([ce_string ("Couldn%'t resolve host %'%%s%'"), a_conn.item.host.dispname])
							l_result := {PC_CURLCODE}.CURLE_COULDNT_RESOLVE_HOST
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						fix_hostname (a_data, a_conn, create {CE_CLASS_POINTER [PD_HOSTNAME]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proxy")))
						l_rc := Curl_resolv_timeout (a_conn, a_conn.item.proxy.name, (a_conn.item.port).to_integer_32, l_hostaddr, l_timeout_ms)
						if l_rc = 1 then
							a_async.item := (1).to_boolean
						elseif l_rc = -2 then
							l_result := {PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT
						elseif (l_hostaddr.item).is_void then
							a_data.item.Curl_failf ([ce_string ("Couldn%'t resolve proxy %'%%s%'"), a_conn.item.proxy.dispname])
							l_result := {PC_CURLCODE}.CURLE_COULDNT_RESOLVE_PROXY
						end
				when 10 then -- if done
						a_conn.item.dns_entry := l_hostaddr.item
				when 11 then -- if done
					Result := l_result
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_resolv_timeout (a_conn: CE_POINTER [PD_CONNECTDATA]; a_hostname: CE_POINTER [INTEGER_8]; a_port: INTEGER_32; a_entry: CE_POINTER [CE_POINTER [PD_CURL_DNS_ENTRY]]; a_timeoutms: INTEGER_32): INTEGER_32
		require
			not a_conn.is_void
			not a_entry.is_void
		local
			l_keep_sigact: CE_ARRAY [SD_SIGACTION]
			l_keep_copysig: BOOLEAN
			l_sigact: CE_ARRAY [SD_SIGACTION]
			l_timeout: INTEGER_32
			l_prev_alarm: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_rc: INTEGER_32
			l_tmp___1: INTEGER_32
			l_elapsed_ms: NATURAL_32
			l_alarm_set: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_SIGACTION]} l_keep_sigact.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_SIGACTION]} l_sigact.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_keep_copysig := (0).to_boolean
					l_prev_alarm := (0).to_natural_32
					l_data := a_conn.item.data
					a_entry.item := create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer)
					if l_data.item.set.no_signal then
						l_timeout := (0).to_integer_32
					else
						l_timeout := a_timeoutms
					end
					if not l_timeout.to_boolean then
						Result := (a_conn.item.Curl_resolv (a_hostname, a_port, a_entry))
						l_return := True
					end
					if not l_return and then (l_timeout < (1_000).to_integer_32) then
						Result := (-2)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						sigaction (14, create {CE_CLASS_POINTER [SD_SIGACTION]}.make_shared (default_pointer), l_sigact).do_nothing
						l_keep_sigact.item := (l_sigact.item).twin
						l_keep_copysig := (1).to_boolean
						l_sigact.item.sigaction_handler.sa_handler := (create {P_HOSTIP_STATIC}).alarmfunc_address
						l_sigact.item.sa_flags := (l_sigact.item.sa_flags).bit_and ((-268_435_457))
						sigaction (14, l_sigact, create {CE_CLASS_POINTER [SD_SIGACTION]}.make_shared (default_pointer)).do_nothing
						l_prev_alarm := (alarm ((l_timeout // 1_000).to_natural_32));
						(create {P_HOSTIP_STATIC}).curl_jmpenv.item := create {CE_EXCEPTION}.make ($Curl_resolv_timeout, l_pos, $l_tmp___1)
				when 2 then -- continue here on raising curl_jmpenv:
						if l_tmp___1.to_boolean then
							l_data.item.Curl_failf ([ce_string ("name lookup timed out")])
							l_rc := -1
							l_pos := -1 + 4 -- goto clean_up
						end
				when 3 then
						l_rc := a_conn.item.Curl_resolv (a_hostname, a_port, a_entry)
				when 4 then -- clean_up:
						if not l_prev_alarm.to_boolean then
							alarm ({NATURAL_32} 0).do_nothing
						end
						if l_keep_copysig then
							sigaction (14, l_keep_sigact, create {CE_CLASS_POINTER [SD_SIGACTION]}.make_shared (default_pointer)).do_nothing
						end
						if l_prev_alarm.to_boolean then
							l_elapsed_ms := ((create {P_TIMEVAL_STATIC}).curlx_tvdiff ((((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin).twin, (a_conn.item.created).twin)).to_natural_32
							l_alarm_set := l_prev_alarm.to_natural_32 - l_elapsed_ms // {NATURAL_32} 1_000
							if not l_alarm_set.to_boolean then
								alarm ({NATURAL_32} 1).do_nothing
								l_rc := -2
								l_data.item.Curl_failf ([ce_string ("Previous alarm fired off!")])
							elseif l_alarm_set >= {NATURAL_32} 2_147_483_648 then
								if l_prev_alarm < {NATURAL_32} 2_147_483_648 then
									alarm ({NATURAL_32} 1).do_nothing
									l_rc := -2
									l_data.item.Curl_failf ([ce_string ("Previous alarm fired off!")])
								else
									alarm (l_alarm_set.to_natural_32).do_nothing
								end
							else
								alarm (l_alarm_set.to_natural_32).do_nothing
							end
						end
						Result := l_rc
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		rescue
			if attached {CE_EXCEPTION} (create {EXCEPTION_MANAGER}).last_exception as ex then
				if ex.routine = $Curl_resolv_timeout then
					l_pos := ex.position + 1
					retry
				end
				ex.re_raise
			end
		end

	fix_hostname (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_host: CE_POINTER [PD_HOSTNAME])
		require
			not a_host.is_void
		do
			a_host.item.dispname := a_host.item.name
		end

	reuse_conn (a_old_conn, a_conn: CE_POINTER [PD_CONNECTDATA])
		require
			not a_old_conn.is_void
			not a_conn.is_void
		do
			if (not (a_old_conn.item.proxy.rawalloc).is_void) then
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_old_conn.item.proxy.rawalloc)])
			end
			(create {CE_CLASS_POINTER [PD_SSL_CONFIG_DATA]}.make_shared (a_old_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("ssl_config"))).item.Curl_free_ssl_config
			a_conn.item.data := a_old_conn.item.data
			a_conn.item.bits.user_passwd := a_old_conn.item.bits.user_passwd
			if a_conn.item.bits.user_passwd then
				(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.user));
				(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.passwd))
				a_conn.item.user := a_old_conn.item.user
				a_conn.item.passwd := a_old_conn.item.passwd
				a_old_conn.item.user := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				a_old_conn.item.passwd := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			end
			a_conn.item.bits.proxy_user_passwd := a_old_conn.item.bits.proxy_user_passwd
			if a_conn.item.bits.proxy_user_passwd then
				(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.proxyuser));
				(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_conn.item.proxypasswd))
				a_conn.item.proxyuser := a_old_conn.item.proxyuser
				a_conn.item.proxypasswd := a_old_conn.item.proxypasswd
				a_old_conn.item.proxyuser := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				a_old_conn.item.proxypasswd := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			end
			if a_conn.item.bits.proxy then
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_conn.item.host.rawalloc)])
				a_conn.item.host := (a_old_conn.item.host).twin
			else
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (a_old_conn.item.host.rawalloc)])
			end
			a_conn.item.bits.reuse := (1).to_boolean;
			(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_old_conn.item.user));
			(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_old_conn.item.passwd));
			(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_old_conn.item.proxyuser));
			(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_old_conn.item.proxypasswd));
			(create {P_LLIST_STATIC}).Curl_llist_destroy (a_old_conn.item.send_pipe, create {CE_VOID_POINTER}.make_shared (default_pointer));
			(create {P_LLIST_STATIC}).Curl_llist_destroy (a_old_conn.item.recv_pipe, create {CE_VOID_POINTER}.make_shared (default_pointer));
			(create {P_LLIST_STATIC}).Curl_llist_destroy (a_old_conn.item.pend_pipe, create {CE_VOID_POINTER}.make_shared (default_pointer));
			(create {P_LLIST_STATIC}).Curl_llist_destroy (a_old_conn.item.done_pipe, create {CE_VOID_POINTER}.make_shared (default_pointer));
			(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (a_old_conn.item.master_buffer))
		end

	Curl_parsenetrc (a_host, a_login, a_password, a_netrcfile: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_login.is_void
		local
			l_netrcfile: CE_POINTER [INTEGER_8]
			l_file: CE_POINTER [SD_IO_FILE]
			l_retcode: INTEGER_32
			l_specific_login: INTEGER_32
			l_home: CE_POINTER [INTEGER_8]
			l_home_alloc: BOOLEAN
			l_netrc_alloc: BOOLEAN
			l_state___3: INTEGER_32
			l_state_login: INTEGER_8
			l_state_password: INTEGER_8
			l_state_our_login: INTEGER_32
			l_pw: CE_POINTER [SD_PASSWD]
			l_tok: CE_POINTER [INTEGER_8]
			l_tok_buf: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_done: BOOLEAN
			l_netrcbuffer: CE_ARRAY [INTEGER_8]
			l_netrcbuffsize: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_tok_buf.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_netrcbuffer.make (<<256>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_netrcfile := a_netrcfile
					l_retcode := 1
					l_specific_login := ((a_login[0]).to_integer_32 /= 0).to_integer
					l_home := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_home_alloc := (0).to_boolean
					l_netrc_alloc := (0).to_boolean
					l_state___3 := 0
					l_state_login := (0).to_integer_8
					l_state_password := (0).to_integer_8
					l_state_our_login := 0
					if l_netrcfile.is_void then
						l_home := (create {P_GETENV_STATIC}).curl_getenv (ce_string ("HOME"))
						if (not l_home.is_void) then
							l_home_alloc := (1).to_boolean
						else
							l_pw := getpwuid ((geteuid))
							if (not l_pw.is_void) then
								l_home := l_pw.item.pw_dir
							end
						end
						if l_home.is_void then
							Result := (-1)
							l_return := True
						end
						if not l_return then
							l_netrcfile := (create {P_MPRINTF_STATIC}).curl_maprintf ([ce_string ("%%s%%s%%s"), l_home, ce_string ("/"), ce_string (".netrc")])
							if l_netrcfile.is_void then
								if l_home_alloc then
									(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_home)])
								end
								Result := (-1)
								l_return := True
							end
						end
						if not l_return then
							l_netrc_alloc := (1).to_boolean
						end
					end
					if l_return then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						l_file := fopen (l_netrcfile, ce_string ("r"))
						if l_file.is_void then
							l_pos := -1 + 17 -- skip if block
						end
				when 2 then -- if:
						l_done := (0).to_boolean
						l_netrcbuffsize := ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32).to_integer_32
				when 3 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 16 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						if not l_done then
							if (fgets (l_netrcbuffer, l_netrcbuffsize, l_file)).is_void then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 15 -- skip if block
						end
				when 5 then -- if:
						l_tok := strtok_r (l_netrcbuffer, ce_string (" %T%N"), l_tok_buf)
				when 6 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 14 -- skip loop
						end
				when 7 then -- loop body:
						l_break := False
						if not l_done then
							if l_tok.is_void then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) and then ((a_login[0]).to_boolean) then
							if (a_password[0]).to_boolean then
								l_done := (1).to_boolean
								l_break := True
							end
						end
						if (l_break) then
							l_pos := -1 + 13 -- skip if block
						end
				when 8 then -- if:
						inspect l_state___3 -- switch 1 head
						when 0 then l_pos := -1 + 9
						when 1 then l_pos := -1 + 10
						when 3 then l_pos := -1 + 11
						else l_pos := -1 + 12
						end
				when 9 then -- switch 1, case 0
						if ((create {P_RAWSTR_STATIC}).Curl_raw_equal (ce_string ("machine"), l_tok)).to_boolean then
							l_state___3 := 1
						end
						l_pos := -1 + 12 -- switch 1; break
				when 10 then -- switch 1, case 1
						if ((create {P_RAWSTR_STATIC}).Curl_raw_equal (a_host, l_tok)).to_boolean then
							l_state___3 := 3
							l_retcode := 0
						else
							l_state___3 := 0
						end
						l_pos := -1 + 12 -- switch 1; break
				when 11 then -- switch 1, case 3
						if l_state_login.to_boolean then
							if l_specific_login.to_boolean then
								l_state_our_login := (create {P_RAWSTR_STATIC}).Curl_raw_equal (a_login, l_tok)
							else
								strncpy (a_login, l_tok, (63).to_natural_32).do_nothing
							end
							l_state_login := (0).to_integer_8
						elseif l_state_password.to_boolean then
							if l_state_our_login.to_boolean then
								strncpy (a_password, l_tok, (63).to_natural_32).do_nothing
							elseif not l_specific_login.to_boolean then
								strncpy (a_password, l_tok, (63).to_natural_32).do_nothing
							end
							l_state_password := (0).to_integer_8
						elseif ((create {P_RAWSTR_STATIC}).Curl_raw_equal (ce_string ("login"), l_tok)).to_boolean then
							l_state_login := (1).to_integer_8
						elseif ((create {P_RAWSTR_STATIC}).Curl_raw_equal (ce_string ("password"), l_tok)).to_boolean then
							l_state_password := (1).to_integer_8
						elseif ((create {P_RAWSTR_STATIC}).Curl_raw_equal (ce_string ("machine"), l_tok)).to_boolean then
							l_state___3 := 1
							l_state_our_login := 0
						end
						l_pos := -1 + 12 -- switch 1; break
				when 12 then -- switch 1, done:
						l_tok := strtok_r (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string (" %T%N"), l_tok_buf)
				when 13 then -- if done
						l_pos := -1 + 6 -- back to loop condition
				when 14 then -- loop done
						l_break := False
				when 15 then -- if done
						l_pos := -1 + 3 -- back to loop condition
				when 16 then -- loop done
						l_break := False
						fclose (l_file).do_nothing
				when 17 then -- if done
						if l_home_alloc then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_home)])
						end
						if l_netrc_alloc then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_netrcfile)])
						end
						Result := l_retcode
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	data_pending (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		require
			not a_conn.is_void
		local
			l_tmp: INTEGER_32
		do
			if ((a_conn.item.protocol).bit_and (((((1).bit_shift_left (4))).bit_or (((1).bit_shift_left (5)))).to_integer_32)).to_boolean then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	read_rewind (a_conn: CE_POINTER [PD_CONNECTDATA]; a_thismuch: NATURAL_32)
		require
			not a_conn.is_void
		do
			a_conn.item.read_pos := a_conn.item.read_pos - a_thismuch
			a_conn.item.bits.stream_was_rewound := (1).to_boolean
		end

	Transfer (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		require
			not a_conn.is_void
		local
			l_result: NATURAL_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_done: CE_ARRAY [BOOLEAN]
			l_first: BOOLEAN
			l_timeout_ms: INTEGER_32
			l_buffersize: INTEGER_32
			l_totmp: INTEGER_32
			l_fd_read: INTEGER_32
			l_fd_write: INTEGER_32
			l_keepon: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_BOOLEAN_ARRAY} l_done.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := a_conn.item.data
					l_k := create {CE_CLASS_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
					l_done.item := (0).to_boolean
					l_first := (1).to_boolean
					if a_conn.item.sockfd = -1 then
						if a_conn.item.writesockfd = -1 then
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						end
					end
					if not l_return and then (not l_k.item.getheader) then
						if l_data.item.set.opt_no_body then
							Result := ({PC_CURLCODE}.CURLE_OK)
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not (l_return) and then (not l_done.item)) then
							l_pos := -1 + 20 -- skip loop
						end
				when 2 then -- loop body:
						l_continue := False
						l_fd_read := a_conn.item.sockfd
						l_fd_write := a_conn.item.writesockfd
						l_keepon := l_k.item.keepon
						l_timeout_ms := 1_000
						if (a_conn.item.waitfor).to_boolean then
							l_keepon := (l_keepon).bit_and (((((1).bit_or (((1).bit_shift_left (1))))).bit_not))
							l_keepon := (l_keepon).bit_or (((a_conn.item.waitfor).bit_and (((1).bit_or (((1).bit_shift_left (1)))))))
						end
						if not (((l_keepon).bit_and (((1).bit_shift_left (1)))).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if not (l_data.item.set.max_send_speed).to_boolean then
							l_k.item.keepon := (l_k.item.keepon).bit_and (((((1).bit_shift_left (3))).bit_not))
						elseif l_data.item.progress.ulspeed < l_data.item.set.max_send_speed then
							l_k.item.keepon := (l_k.item.keepon).bit_and (((((1).bit_shift_left (3))).bit_not))
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if l_data.item.set.upload then
							if (l_data.item.set.max_send_speed).to_boolean then
								if l_data.item.progress.ulspeed > l_data.item.set.max_send_speed then
									if (l_data.item.set.buffer_size).to_boolean then
										l_tmp := l_data.item.set.buffer_size
									else
										l_tmp := 16_384
									end
									l_buffersize := l_tmp.to_integer_32
									l_totmp := ((create {P_TRANSFER_STATIC}).Curl_sleep_time (l_data.item.set.max_send_speed, l_data.item.progress.ulspeed, l_buffersize)).to_integer_32
									if l_totmp < l_timeout_ms then
										l_timeout_ms := l_totmp
									end
								end
							end
						end
						l_fd_write := -1
						if ((l_keepon).bit_and (((1).bit_shift_left (1)))).to_boolean then
							l_k.item.keepon := (l_k.item.keepon).bit_or (((1).bit_shift_left (3)))
						end
				when 6 then
						if not (((l_keepon).bit_and (1)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if not (l_data.item.set.max_recv_speed).to_boolean then
							l_k.item.keepon := (l_k.item.keepon).bit_and (((((1).bit_shift_left (2))).bit_not))
						elseif l_data.item.progress.dlspeed < l_data.item.set.max_recv_speed then
							l_k.item.keepon := (l_k.item.keepon).bit_and (((((1).bit_shift_left (2))).bit_not))
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___0:
						if not l_data.item.set.upload then
							if (l_data.item.set.max_recv_speed).to_boolean then
								if l_data.item.progress.dlspeed > l_data.item.set.max_recv_speed then
									if (l_data.item.set.buffer_size).to_boolean then
										l_tmp___1 := l_data.item.set.buffer_size
									else
										l_tmp___1 := 16_384
									end
									l_buffersize := l_tmp___1.to_integer_32
									l_totmp := ((create {P_TRANSFER_STATIC}).Curl_sleep_time (l_data.item.set.max_recv_speed, l_data.item.progress.dlspeed, l_buffersize)).to_integer_32
									if l_totmp < l_timeout_ms then
										l_timeout_ms := l_totmp
									end
								end
							end
						end
						l_fd_read := -1
						if ((l_keepon).bit_and (1)).to_boolean then
							l_k.item.keepon := (l_k.item.keepon).bit_or (((1).bit_shift_left (2)))
						end
				when 10 then
						if ((l_k.item.keepon).bit_and (((1).bit_shift_left (4)))).to_boolean then
							l_fd_read := -1
						end
						if ((l_k.item.keepon).bit_and (((1).bit_shift_left (5)))).to_boolean then
							l_fd_write := -1
						end
						if not l_first then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_fd_read /= -1 then
							l_timeout_ms := 0
						elseif l_fd_write /= -1 then
							l_timeout_ms := 0
						else
							l_pos := -1 + 13 -- goto _L___1
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___1:
						l_totmp := (a_conn.item.Curl_timeleft (create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (l_k.c_pointer + (create {PD_SINGLEREQUEST}.make).offset_of ("now")), (0).to_boolean)).to_integer_32
						if l_totmp < 0 then
							Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
							l_return := True
						elseif not l_totmp.to_boolean then
							l_totmp := 1_000
						end
						if not l_return and then (l_totmp < l_timeout_ms) then
							l_timeout_ms := l_totmp
						end
				when 14 then
						if l_return then
							l_pos := -1 + 19 -- skip if block
						end
				when 15 then -- if:
						inspect ((create {P_SELECT_STATIC}).Curl_socket_ready (l_fd_read, l_fd_write, l_timeout_ms)) -- switch 1 head
						when -1 then l_pos := -1 + 16 -- -1
						else l_pos := -1 + 17
						end
				when 16 then -- switch 1, case -1
						if (errno_location).item = 4 then
							l_continue := True
						end
						if not (l_return or l_continue) then
							Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
							l_return := True
						end
				when 17 then -- switch 1, default:
						if not (l_return or l_continue) then
							l_result := a_conn.item.Curl_readwrite (l_done)
						end
						l_pos := -1 + 18 -- switch 1; break
				when 18 then -- switch 1, done:
						if not (l_return or l_continue) then
							if l_result.to_boolean then
								Result := l_result
								l_return := True
							end
							if not l_return then
								l_first := (0).to_boolean
							end
						end
				when 19 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 20 then -- loop done | if done
					if not l_return then
						l_continue := False
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	multi_addtimeout (a_timeoutlist: CE_POINTER [PD_CURL_LLIST]; a_stamp: CE_POINTER [SD_TIMEVAL]): INTEGER_32
		local
			l_e: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_timedup: CE_POINTER [SD_TIMEVAL]
			l_prev: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_checktime: CE_POINTER [SD_TIMEVAL]
			l_diff: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_prev := create {CE_CLASS_POINTER [PD_CURL_LLIST_ELEMENT]}.make_shared (default_pointer)
			l_timedup := create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(create {SD_TIMEVAL}.make).structure_size.to_natural_32]))))
			if l_timedup.is_void then
				Result := ({PC_CURLMCODE}.CURLM_OUT_OF_MEMORY)
				l_return := True
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_timedup), create {CE_VOID_POINTER}.make_cast (a_stamp), (create {SD_TIMEVAL}.make).structure_size.to_natural_32).do_nothing
				if (a_timeoutlist.item.Curl_llist_count).to_boolean then
					l_e := a_timeoutlist.item.head
					from
					until
						not (not (l_break) and then (not l_e.is_void))
					loop
						l_break := False
						l_checktime := create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_cast (l_e.item.ptr)
						l_diff := ((create {P_TIMEVAL_STATIC}).curlx_tvdiff ((l_checktime.item).twin, (l_timedup.item).twin))
						if l_diff > 0 then
							l_break := True
						end
						if not (l_break) then
							l_prev := l_e
							l_e := l_e.item.next
						end
					end
					l_break := False
				end
				if not ((create {P_LLIST_STATIC}).Curl_llist_insert_next (a_timeoutlist, l_prev, create {CE_VOID_POINTER}.make_cast (l_timedup))).to_boolean then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_timedup)])
					Result := ({PC_CURLMCODE}.CURLM_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				Result := ({PC_CURLMCODE}.CURLM_OK)
			end
		end

	Curl_digest_cleanup (a_data: CE_POINTER [PD_SESSIONHANDLE])
		do
			(create {CE_CLASS_POINTER [PD_DIGESTDATA]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("digest"))).item.Curl_digest_cleanup_one;
			(create {CE_CLASS_POINTER [PD_DIGESTDATA]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("state") + (create {PD_URLSTATE}.make).offset_of ("proxydigest"))).item.Curl_digest_cleanup_one
		end

	curl_easy_strerror (a_error: NATURAL_32): CE_POINTER [INTEGER_8]
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_error.to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					when 5 then l_pos := -1 + 5
					when 6 then l_pos := -1 + 6
					when 7 then l_pos := -1 + 7
					when 8 then l_pos := -1 + 8
					when 9 then l_pos := -1 + 9
					when 84 then l_pos := -1 + 10
					when 11 then l_pos := -1 + 11
					when 13 then l_pos := -1 + 12
					when 14 then l_pos := -1 + 13
					when 15 then l_pos := -1 + 14
					when 17 then l_pos := -1 + 15
					when 18 then l_pos := -1 + 16
					when 19 then l_pos := -1 + 17
					when 21 then l_pos := -1 + 18
					when 22 then l_pos := -1 + 19
					when 23 then l_pos := -1 + 20
					when 25 then l_pos := -1 + 21
					when 26 then l_pos := -1 + 22
					when 27 then l_pos := -1 + 23
					when 28 then l_pos := -1 + 24
					when 30 then l_pos := -1 + 25
					when 31 then l_pos := -1 + 26
					when 33 then l_pos := -1 + 27
					when 34 then l_pos := -1 + 28
					when 35 then l_pos := -1 + 29
					when 36 then l_pos := -1 + 30
					when 37 then l_pos := -1 + 31
					when 38 then l_pos := -1 + 32
					when 39 then l_pos := -1 + 33
					when 41 then l_pos := -1 + 34
					when 42 then l_pos := -1 + 35
					when 43 then l_pos := -1 + 36
					when 45 then l_pos := -1 + 37
					when 47 then l_pos := -1 + 38
					when 48 then l_pos := -1 + 39
					when 49 then l_pos := -1 + 40
					when 51 then l_pos := -1 + 41
					when 52 then l_pos := -1 + 42
					when 53 then l_pos := -1 + 43
					when 54 then l_pos := -1 + 44
					when 66 then l_pos := -1 + 45
					when 55 then l_pos := -1 + 46
					when 56 then l_pos := -1 + 47
					when 58 then l_pos := -1 + 48
					when 59 then l_pos := -1 + 49
					when 60 then l_pos := -1 + 50
					when 77 then l_pos := -1 + 51
					when 61 then l_pos := -1 + 52
					when 62 then l_pos := -1 + 53
					when 63 then l_pos := -1 + 54
					when 64 then l_pos := -1 + 55
					when 80 then l_pos := -1 + 56
					when 82 then l_pos := -1 + 57
					when 83 then l_pos := -1 + 58
					when 65 then l_pos := -1 + 59
					when 67 then l_pos := -1 + 60
					when 68 then l_pos := -1 + 61
					when 69 then l_pos := -1 + 62
					when 70 then l_pos := -1 + 63
					when 71 then l_pos := -1 + 64
					when 72 then l_pos := -1 + 65
					when 73 then l_pos := -1 + 66
					when 74 then l_pos := -1 + 67
					when 75 then l_pos := -1 + 68
					when 76 then l_pos := -1 + 69
					when 78 then l_pos := -1 + 70
					when 79 then l_pos := -1 + 71
					when 81 then l_pos := -1 + 72
					when 85 then l_pos := -1 + 73
					when 86 then l_pos := -1 + 74
					when 87 then l_pos := -1 + 75
					when 88 then l_pos := -1 + 76
					when 4 then l_pos := -1 + 77
					when 10 then l_pos := -1 + 77
					when 12 then l_pos := -1 + 77
					when 16 then l_pos := -1 + 77
					when 20 then l_pos := -1 + 77
					when 24 then l_pos := -1 + 77
					when 29 then l_pos := -1 + 77
					when 32 then l_pos := -1 + 77
					when 40 then l_pos := -1 + 77
					when 44 then l_pos := -1 + 77
					when 46 then l_pos := -1 + 77
					when 50 then l_pos := -1 + 77
					when 57 then l_pos := -1 + 77
					when 89 then l_pos := -1 + 77
					else l_pos := -1 + 78
					end
				when 1 then -- switch 1, case 0
					Result := (ce_string ("No error"))
					l_return := True
				when 2 then -- switch 1, case 1
					if not l_return then
						Result := (ce_string ("Unsupported protocol"))
						l_return := True
					end
				when 3 then -- switch 1, case 2
					if not l_return then
						Result := (ce_string ("Failed initialization"))
						l_return := True
					end
				when 4 then -- switch 1, case 3
					if not l_return then
						Result := (ce_string ("URL using bad/illegal format or missing URL"))
						l_return := True
					end
				when 5 then -- switch 1, case 5
					if not l_return then
						Result := (ce_string ("Couldn%'t resolve proxy name"))
						l_return := True
					end
				when 6 then -- switch 1, case 6
					if not l_return then
						Result := (ce_string ("Couldn%'t resolve host name"))
						l_return := True
					end
				when 7 then -- switch 1, case 7
					if not l_return then
						Result := (ce_string ("Couldn%'t connect to server"))
						l_return := True
					end
				when 8 then -- switch 1, case 8
					if not l_return then
						Result := (ce_string ("FTP: weird server reply"))
						l_return := True
					end
				when 9 then -- switch 1, case 9
					if not l_return then
						Result := (ce_string ("Access denied to remote resource"))
						l_return := True
					end
				when 10 then -- switch 1, case 84
					if not l_return then
						Result := (ce_string ("FTP: The server did not accept the PRET command."))
						l_return := True
					end
				when 11 then -- switch 1, case 11
					if not l_return then
						Result := (ce_string ("FTP: unknown PASS reply"))
						l_return := True
					end
				when 12 then -- switch 1, case 13
					if not l_return then
						Result := (ce_string ("FTP: unknown PASV reply"))
						l_return := True
					end
				when 13 then -- switch 1, case 14
					if not l_return then
						Result := (ce_string ("FTP: unknown 227 response format"))
						l_return := True
					end
				when 14 then -- switch 1, case 15
					if not l_return then
						Result := (ce_string ("FTP: can%'t figure out the host in the PASV response"))
						l_return := True
					end
				when 15 then -- switch 1, case 17
					if not l_return then
						Result := (ce_string ("FTP: couldn%'t set file type"))
						l_return := True
					end
				when 16 then -- switch 1, case 18
					if not l_return then
						Result := (ce_string ("Transferred a partial file"))
						l_return := True
					end
				when 17 then -- switch 1, case 19
					if not l_return then
						Result := (ce_string ("FTP: couldn%'t retrieve (RETR failed) the specified file"))
						l_return := True
					end
				when 18 then -- switch 1, case 21
					if not l_return then
						Result := (ce_string ("Quote command returned error"))
						l_return := True
					end
				when 19 then -- switch 1, case 22
					if not l_return then
						Result := (ce_string ("HTTP response code said error"))
						l_return := True
					end
				when 20 then -- switch 1, case 23
					if not l_return then
						Result := (ce_string ("Failed writing received data to disk/application"))
						l_return := True
					end
				when 21 then -- switch 1, case 25
					if not l_return then
						Result := (ce_string ("Upload failed (at start/before it took off)"))
						l_return := True
					end
				when 22 then -- switch 1, case 26
					if not l_return then
						Result := (ce_string ("Failed to open/read local data from file/application"))
						l_return := True
					end
				when 23 then -- switch 1, case 27
					if not l_return then
						Result := (ce_string ("Out of memory"))
						l_return := True
					end
				when 24 then -- switch 1, case 28
					if not l_return then
						Result := (ce_string ("Timeout was reached"))
						l_return := True
					end
				when 25 then -- switch 1, case 30
					if not l_return then
						Result := (ce_string ("FTP: command PORT failed"))
						l_return := True
					end
				when 26 then -- switch 1, case 31
					if not l_return then
						Result := (ce_string ("FTP: command REST failed"))
						l_return := True
					end
				when 27 then -- switch 1, case 33
					if not l_return then
						Result := (ce_string ("Requested range was not delivered by the server"))
						l_return := True
					end
				when 28 then -- switch 1, case 34
					if not l_return then
						Result := (ce_string ("Internal problem setting up the POST"))
						l_return := True
					end
				when 29 then -- switch 1, case 35
					if not l_return then
						Result := (ce_string ("SSL connect error"))
						l_return := True
					end
				when 30 then -- switch 1, case 36
					if not l_return then
						Result := (ce_string ("Couldn%'t resume download"))
						l_return := True
					end
				when 31 then -- switch 1, case 37
					if not l_return then
						Result := (ce_string ("Couldn%'t read a file:// file"))
						l_return := True
					end
				when 32 then -- switch 1, case 38
					if not l_return then
						Result := (ce_string ("LDAP: cannot bind"))
						l_return := True
					end
				when 33 then -- switch 1, case 39
					if not l_return then
						Result := (ce_string ("LDAP: search failed"))
						l_return := True
					end
				when 34 then -- switch 1, case 41
					if not l_return then
						Result := (ce_string ("A required function in the library was not found"))
						l_return := True
					end
				when 35 then -- switch 1, case 42
					if not l_return then
						Result := (ce_string ("Operation was aborted by an application callback"))
						l_return := True
					end
				when 36 then -- switch 1, case 43
					if not l_return then
						Result := (ce_string ("A libcurl function was given a bad argument"))
						l_return := True
					end
				when 37 then -- switch 1, case 45
					if not l_return then
						Result := (ce_string ("Failed binding local connection end"))
						l_return := True
					end
				when 38 then -- switch 1, case 47
					if not l_return then
						Result := (ce_string ("Number of redirects hit maximum amount"))
						l_return := True
					end
				when 39 then -- switch 1, case 48
					if not l_return then
						Result := (ce_string ("User specified an unknown telnet option"))
						l_return := True
					end
				when 40 then -- switch 1, case 49
					if not l_return then
						Result := (ce_string ("Malformed telnet option"))
						l_return := True
					end
				when 41 then -- switch 1, case 51
					if not l_return then
						Result := (ce_string ("SSL peer certificate or SSH remote key was not OK"))
						l_return := True
					end
				when 42 then -- switch 1, case 52
					if not l_return then
						Result := (ce_string ("Server returned nothing (no headers, no data)"))
						l_return := True
					end
				when 43 then -- switch 1, case 53
					if not l_return then
						Result := (ce_string ("SSL crypto engine not found"))
						l_return := True
					end
				when 44 then -- switch 1, case 54
					if not l_return then
						Result := (ce_string ("Can not set SSL crypto engine as default"))
						l_return := True
					end
				when 45 then -- switch 1, case 66
					if not l_return then
						Result := (ce_string ("Failed to initialise SSL crypto engine"))
						l_return := True
					end
				when 46 then -- switch 1, case 55
					if not l_return then
						Result := (ce_string ("Failed sending data to the peer"))
						l_return := True
					end
				when 47 then -- switch 1, case 56
					if not l_return then
						Result := (ce_string ("Failure when receiving data from the peer"))
						l_return := True
					end
				when 48 then -- switch 1, case 58
					if not l_return then
						Result := (ce_string ("Problem with the local SSL certificate"))
						l_return := True
					end
				when 49 then -- switch 1, case 59
					if not l_return then
						Result := (ce_string ("Couldn%'t use specified SSL cipher"))
						l_return := True
					end
				when 50 then -- switch 1, case 60
					if not l_return then
						Result := (ce_string ("Peer certificate cannot be authenticated with known CA certificates"))
						l_return := True
					end
				when 51 then -- switch 1, case 77
					if not l_return then
						Result := (ce_string ("Problem with the SSL CA cert (path? access rights?)"))
						l_return := True
					end
				when 52 then -- switch 1, case 61
					if not l_return then
						Result := (ce_string ("Unrecognized HTTP Content-Encoding"))
						l_return := True
					end
				when 53 then -- switch 1, case 62
					if not l_return then
						Result := (ce_string ("Invalid LDAP URL"))
						l_return := True
					end
				when 54 then -- switch 1, case 63
					if not l_return then
						Result := (ce_string ("Maximum file size exceeded"))
						l_return := True
					end
				when 55 then -- switch 1, case 64
					if not l_return then
						Result := (ce_string ("Requested SSL level failed"))
						l_return := True
					end
				when 56 then -- switch 1, case 80
					if not l_return then
						Result := (ce_string ("Failed to shut down the SSL connection"))
						l_return := True
					end
				when 57 then -- switch 1, case 82
					if not l_return then
						Result := (ce_string ("Failed to load CRL file (path? access rights?, format?)"))
						l_return := True
					end
				when 58 then -- switch 1, case 83
					if not l_return then
						Result := (ce_string ("Issuer check against peer certificate failed"))
						l_return := True
					end
				when 59 then -- switch 1, case 65
					if not l_return then
						Result := (ce_string ("Send failed since rewinding of the data stream failed"))
						l_return := True
					end
				when 60 then -- switch 1, case 67
					if not l_return then
						Result := (ce_string ("Login denied"))
						l_return := True
					end
				when 61 then -- switch 1, case 68
					if not l_return then
						Result := (ce_string ("TFTP: File Not Found"))
						l_return := True
					end
				when 62 then -- switch 1, case 69
					if not l_return then
						Result := (ce_string ("TFTP: Access Violation"))
						l_return := True
					end
				when 63 then -- switch 1, case 70
					if not l_return then
						Result := (ce_string ("Disk full or allocation exceeded"))
						l_return := True
					end
				when 64 then -- switch 1, case 71
					if not l_return then
						Result := (ce_string ("TFTP: Illegal operation"))
						l_return := True
					end
				when 65 then -- switch 1, case 72
					if not l_return then
						Result := (ce_string ("TFTP: Unknown transfer ID"))
						l_return := True
					end
				when 66 then -- switch 1, case 73
					if not l_return then
						Result := (ce_string ("Remote file already exists"))
						l_return := True
					end
				when 67 then -- switch 1, case 74
					if not l_return then
						Result := (ce_string ("TFTP: No such user"))
						l_return := True
					end
				when 68 then -- switch 1, case 75
					if not l_return then
						Result := (ce_string ("Conversion failed"))
						l_return := True
					end
				when 69 then -- switch 1, case 76
					if not l_return then
						Result := (ce_string ("Caller must register CURLOPT_CONV_ callback options"))
						l_return := True
					end
				when 70 then -- switch 1, case 78
					if not l_return then
						Result := (ce_string ("Remote file not found"))
						l_return := True
					end
				when 71 then -- switch 1, case 79
					if not l_return then
						Result := (ce_string ("Error in the SSH layer"))
						l_return := True
					end
				when 72 then -- switch 1, case 81
					if not l_return then
						Result := (ce_string ("Socket not ready for send/recv"))
						l_return := True
					end
				when 73 then -- switch 1, case 85
					if not l_return then
						Result := (ce_string ("RTSP CSeq mismatch or invalid CSeq"))
						l_return := True
					end
				when 74 then -- switch 1, case 86
					if not l_return then
						Result := (ce_string ("RTSP session error"))
						l_return := True
					end
				when 75 then -- switch 1, case 87
					if not l_return then
						Result := (ce_string ("Unable to parse FTP file list"))
						l_return := True
					end
				when 76 then -- switch 1, case 88
					if not l_return then
						Result := (ce_string ("Chunk callback failed"))
						l_return := True
					end
				when 77 then -- switch 1, case 4 | switch 1, case 10 | switch 1, case 12 | switch 1, case 16 | switch 1, case 20 | switch 1, case 24 | switch 1, case 29 | switch 1, case 32 | switch 1, case 40 | switch 1, case 44 | switch 1, case 46 | switch 1, case 50 | switch 1, case 57 | switch 1, case 89
					l_pos := -1 + 78 -- switch 1; break
				when 78 then -- switch 1, done:
					if not l_return then
						Result := (ce_string ("Unknown error"))
					end
				when 79 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_clone_ssl_config (a_source, a_dest: CE_POINTER [PD_SSL_CONFIG_DATA]): BOOLEAN
		require
			not a_source.is_void
			not a_dest.is_void
		local
			l_return: BOOLEAN
		do
			a_dest.item.sessionid := a_source.item.sessionid
			a_dest.item.verifyhost := a_source.item.verifyhost
			a_dest.item.verifypeer := a_source.item.verifypeer
			a_dest.item.version := a_source.item.version
			if (not (a_source.item.CAfile).is_void) then
				a_dest.item.CAfile := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([a_source.item.CAfile]))
				if (a_dest.item.CAfile).is_void then
					Result := (0).to_boolean
					l_return := True
				end
			else
				a_dest.item.CAfile := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			end
			if not l_return then
				if (not (a_source.item.CApath).is_void) then
					a_dest.item.CApath := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([a_source.item.CApath]))
					if (a_dest.item.CApath).is_void then
						Result := (0).to_boolean
						l_return := True
					end
				else
					a_dest.item.CApath := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				end
			end
			if not l_return then
				if (not (a_source.item.cipher_list).is_void) then
					a_dest.item.cipher_list := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([a_source.item.cipher_list]))
					if (a_dest.item.cipher_list).is_void then
						Result := (0).to_boolean
						l_return := True
					end
				else
					a_dest.item.cipher_list := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				end
			end
			if not l_return then
				if (not (a_source.item.egdsocket).is_void) then
					a_dest.item.egdsocket := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([a_source.item.egdsocket]))
					if (a_dest.item.egdsocket).is_void then
						Result := (0).to_boolean
						l_return := True
					end
				else
					a_dest.item.egdsocket := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				end
			end
			if not l_return then
				if (not (a_source.item.random_file).is_void) then
					a_dest.item.random_file := create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([a_source.item.random_file]))
					if (a_dest.item.random_file).is_void then
						Result := (0).to_boolean
						l_return := True
					end
				else
					a_dest.item.random_file := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				end
			end
			if not l_return then
				Result := (1).to_boolean
			end
		end

	Curl_splayremovebyaddr (a_t, a_removenode: CE_POINTER [PD_CURL_TREE]; a_newroot: CE_POINTER [CE_POINTER [PD_CURL_TREE]]): INTEGER_32
		local
			l_t: CE_POINTER [PD_CURL_TREE]
			l_x: CE_POINTER [PD_CURL_TREE]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
		do
			l_t := a_t
			if l_t.is_void then
				Result := 1
				l_return := True
			elseif a_removenode.is_void then
				Result := 1
				l_return := True
			end
			if not l_return then
				if KEY_NOTUSED___0.item.tv_sec < a_removenode.item.key.tv_sec then
					l_tmp___2 := -1
				else
					if KEY_NOTUSED___0.item.tv_sec > a_removenode.item.key.tv_sec then
						l_tmp___1 := 1
					else
						if KEY_NOTUSED___0.item.tv_usec < a_removenode.item.key.tv_usec then
							l_tmp___0 := -1
						else
							if KEY_NOTUSED___0.item.tv_usec > a_removenode.item.key.tv_usec then
								l_tmp := 1
							else
								l_tmp := 0
							end
							l_tmp___0 := l_tmp
						end
						l_tmp___1 := l_tmp___0
					end
					l_tmp___2 := l_tmp___1
				end
				if l_tmp___2 = 0 then
					if (a_removenode.item.smaller).is_void then
						Result := 3
						l_return := True
					end
					if not l_return then
						(a_removenode.item.smaller).item.same := a_removenode.item.same
						if (not (a_removenode.item.same).is_void) then
							(a_removenode.item.same).item.smaller := a_removenode.item.smaller
						end
						a_removenode.item.smaller := create {CE_CLASS_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
						a_newroot.item := l_t
						Result := 0
						l_return := True
					end
				end
			end
			if not l_return then
				l_t := (create {P_SPLAY_STATIC}).Curl_splay ((a_removenode.item.key).twin, l_t)
				if not l_t.is_equal (a_removenode) then
					Result := 2
					l_return := True
				end
			end
			if not l_return then
				l_x := l_t.item.same
				if (not l_x.is_void) then
					l_x.item.key := (l_t.item.key).twin
					l_x.item.larger := l_t.item.larger
					l_x.item.smaller := l_t.item.smaller
				elseif (l_t.item.smaller).is_void then
					l_x := l_t.item.larger
				else
					l_x := (create {P_SPLAY_STATIC}).Curl_splay ((a_removenode.item.key).twin, l_t.item.smaller)
					l_x.item.larger := l_t.item.larger
				end
				a_newroot.item := l_x
				Result := 0
			end
		end

	Curl_rtsp_rtp_readwrite (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_nread: CE_POINTER [INTEGER_32]; a_readmore: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_nread.is_void
		local
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_rtspc: CE_POINTER [PD_RTSP_CONN]
			l_rtp: CE_POINTER [INTEGER_8]
			l_rtp_dataleft: INTEGER_32
			l_scratch: CE_POINTER [INTEGER_8]
			l_result: NATURAL_32
			l_newptr: CE_POINTER [INTEGER_8]
			l_rtp_length: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_k := create {CE_CLASS_POINTER [PD_SINGLEREQUEST]}.make_shared (a_data.c_pointer + (create {PD_SESSIONHANDLE}.make).offset_of ("req"))
					l_rtspc := create {CE_CLASS_POINTER [PD_RTSP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("rtspc"))
					if (not (l_rtspc.item.rtp_buf).is_void) then
						l_newptr := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_crealloc.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_rtspc.item.rtp_buf), (l_rtspc.item.rtp_bufsize + a_nread.item).to_natural_32]))))
						if l_newptr.is_void then
							(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_rtspc.item.rtp_buf))
							l_rtspc.item.rtp_buf := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_rtspc.item.rtp_bufsize := 0
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							l_return := True
						end
						if not l_return then
							l_rtspc.item.rtp_buf := l_newptr
							memcpy (create {CE_VOID_POINTER}.make_cast ((l_rtspc.item.rtp_buf + l_rtspc.item.rtp_bufsize)), create {CE_VOID_POINTER}.make_cast (l_k.item.str), (a_nread.item).to_natural_32).do_nothing
							l_rtspc.item.rtp_bufsize := l_rtspc.item.rtp_bufsize + (a_nread.item)
							l_rtp := l_rtspc.item.rtp_buf
							l_rtp_dataleft := l_rtspc.item.rtp_bufsize
						end
					else
						l_rtp := l_k.item.str
						l_rtp_dataleft := a_nread.item
					end
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_rtp_dataleft > 0 then
								if (l_rtp[0]).to_integer_32 /= 36 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								if l_rtp_dataleft > 4 then
									l_rtspc.item.rtp_channel := ((l_rtp[1]).to_natural_8).to_integer_32
									l_rtp_length := (((((l_rtp[2]).to_natural_8).to_integer_32).bit_shift_left (8))).bit_or (((l_rtp[3]).to_natural_8).to_integer_32)
									if l_rtp_dataleft < l_rtp_length + 4 then
										a_readmore.item := (1).to_boolean
										l_break := True
									else
										l_result := rtp_client_write (a_conn, l_rtp + 0, (l_rtp_length + 4).to_natural_32)
										if l_result.to_boolean then
											a_data.item.Curl_failf ([ce_string ("Got an error writing an RTP packet")])
											a_readmore.item := (0).to_boolean;
											(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_rtspc.item.rtp_buf))
											l_rtspc.item.rtp_buf := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
											l_rtspc.item.rtp_bufsize := 0
											Result := l_result
											l_return := True
										end
										if not l_return then
											l_rtp_dataleft := l_rtp_dataleft - (l_rtp_length + 4)
											l_rtp := l_rtp + (l_rtp_length + 4)
											if a_data.item.set.rtspreq = {NATURAL_32} 11 then
												l_k.item.keepon := (l_k.item.keepon).bit_and ((-2))
											end
										end
									end
								else
									a_readmore.item := (1).to_boolean
									l_break := True
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_break := False
						if l_rtp_dataleft = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (l_rtp[0]).to_integer_32 = 36 then
							l_scratch := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([l_rtp_dataleft.to_natural_32]))))
							if l_scratch.is_void then
								(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_rtspc.item.rtp_buf))
								l_rtspc.item.rtp_buf := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								l_rtspc.item.rtp_bufsize := 0
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								l_return := True
							end
							if not l_return then
								memcpy (create {CE_VOID_POINTER}.make_cast (l_scratch), create {CE_VOID_POINTER}.make_cast (l_rtp), l_rtp_dataleft.to_natural_32).do_nothing;
								(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_rtspc.item.rtp_buf))
								l_rtspc.item.rtp_buf := l_scratch
								l_rtspc.item.rtp_bufsize := l_rtp_dataleft
								a_nread.item := 0
								Result := ({PC_CURLCODE}.CURLE_OK)
								l_return := True
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_k.item.str := l_k.item.str + (a_nread.item - l_rtp_dataleft)
						if l_rtp_dataleft > 0 then
						end
						a_nread.item := l_rtp_dataleft
				when 5 then -- if done
					if not l_return then
						(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_rtspc.item.rtp_buf))
						l_rtspc.item.rtp_buf := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						l_rtspc.item.rtp_bufsize := 0
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	rtp_client_write (a_conn: CE_POINTER [PD_CONNECTDATA]; a_ptr: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): NATURAL_32
		require
			not a_conn.is_void
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_wrote: NATURAL_32
			l_writeit: CE_ROUTINE
			l_return: BOOLEAN
		do
			l_data := a_conn.item.data
			if a_len = {NATURAL_32} 0 then
				l_data.item.Curl_failf ([ce_string ("Cannot write a 0 size RTP packet.")])
				Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
				l_return := True
			end
			if not l_return then
				if (not (l_data.item.set.fwrite_rtp).is_void) then
					l_writeit := l_data.item.set.fwrite_rtp
				else
					l_writeit := l_data.item.set.fwrite_func
				end
				l_wrote := l_writeit.natural_32_item ([a_ptr, (1).to_natural_32, a_len, l_data.item.set.rtp_out])
				if {NATURAL_32} 268_435_457 = l_wrote then
					l_data.item.Curl_failf ([ce_string ("Cannot pause RTP")])
					Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
					l_return := True
				end
			end
			if not l_return and then (l_wrote /= a_len) then
				l_data.item.Curl_failf ([ce_string ("Failed writing RTP data")])
				Result := ({PC_CURLCODE}.CURLE_WRITE_ERROR)
				l_return := True
			end
			if not l_return then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			dns := a_other.dns.twin
			multi := a_other.multi
			multi_pos := a_other.multi_pos
			share := a_other.share
			req := a_other.req.twin
			set := a_other.set.twin
			change := a_other.change.twin
			cookies := a_other.cookies
			progress := a_other.progress.twin
			state := a_other.state.twin
			wildcard := a_other.wildcard.twin
			info := a_other.info.twin
			magic := a_other.magic
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				dns.is_equal (a_other.dns) and
				multi.is_equal (a_other.multi) and
				multi_pos.is_equal (a_other.multi_pos) and
				share.is_equal (a_other.share) and
				req.is_equal (a_other.req) and
				set.is_equal (a_other.set) and
				change.is_equal (a_other.change) and
				cookies.is_equal (a_other.cookies) and
				progress.is_equal (a_other.progress) and
				state.is_equal (a_other.state) and
				wildcard.is_equal (a_other.wildcard) and
				info.is_equal (a_other.info) and
				magic = a_other.magic
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("dns"),
					create {CE_STRUCTURE_FIELD}.make ("multi"),
					create {CE_STRUCTURE_FIELD}.make ("multi_pos"),
					create {CE_STRUCTURE_FIELD}.make ("share"),
					create {CE_STRUCTURE_FIELD}.make ("req"),
					create {CE_STRUCTURE_FIELD}.make ("set"),
					create {CE_STRUCTURE_FIELD}.make ("change"),
					create {CE_STRUCTURE_FIELD}.make ("cookies"),
					create {CE_STRUCTURE_FIELD}.make ("progress"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("wildcard"),
					create {CE_STRUCTURE_FIELD}.make ("info"),
					create {CE_STRUCTURE_FIELD}.make ("magic")
				>>)
			init_structure_info
		end

end
