class
	PD_MPZ_STRUCT

inherit
	PD_MPZ_STRUCT_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_GCC_BUILTIN_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	LIBGMP_ASSEMBLER
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_32_POINTER} mp_d.make
			Precursor
		end

feature {ANY} -- fields

	mp_alloc: INTEGER_32 assign set_mp_alloc

	mp_size: INTEGER_32 assign set_mp_size

	mp_d: CE_POINTER [NATURAL_32] assign set_mp_d

feature {ANY} -- field setters

	set_mp_alloc (a_mp_alloc: INTEGER_32)
		do
			mp_alloc := a_mp_alloc
			update_memory_field ("mp_alloc")
		end

	set_mp_size (a_mp_size: INTEGER_32)
		do
			mp_size := a_mp_size
			update_memory_field ("mp_size")
		end

	set_mp_d (a_mp_d: CE_POINTER [NATURAL_32])
		do
			mp_d := a_mp_d
			update_memory_field ("mp_d")
		end

feature {PD_MPZ_STRUCT} -- private attributes

	gmp_fib_table: CE_STATIC [CE_ARRAY [NATURAL_32]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_32_ARRAY}.make_initialized (<<
					1, 0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144, 233, 377, 610, 987, 1_597, 2_584, 4_181, 6_765,
					10_946, 17_711, 28_657, 46_368, 75_025, 121_393, 196_418, 317_811, 514_229, 832_040, 1_346_269, 2_178_309,
					3_524_578, 5_702_887, 9_227_465, 14_930_352, 24_157_817, 39_088_169, 63_245_986, 102_334_155, 165_580_141,
					267_914_296, 433_494_437, 701_408_733, 1_134_903_170, 1_836_311_903, {NATURAL_32} 2_971_215_073
				>>)
		end

	primegap: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					2, 2, 4, 2, 4, 2, 4, 6, 2, 6, 4, 2, 4, 6, 6, 2, 6, 4, 2, 6, 4, 6, 8, 4, 2, 4, 2, 4, 14, 4, 6, 2,
					10, 2, 6, 6, 4, 6, 6, 2, 10, 2, 4, 2, 12, 12, 4, 2, 4, 6, 2, 10, 6, 6, 6, 2, 6, 4, 2, 10, 14, 4,
					2, 4, 14, 6, 10, 2, 4, 6, 8, 6, 6, 4, 6, 8, 4, 8, 10, 2, 10, 2, 6, 4, 6, 8, 4, 2, 4, 12, 8, 4, 8,
					4, 6, 12, 2, 18, 6, 10, 6, 6, 2, 6, 10, 6, 6, 2, 6, 6, 4, 2, 12, 10, 2, 4, 6, 6, 2, 12, 4, 6, 8,
					10, 8, 10, 8, 6, 6, 4, 8, 6, 4, 8, 4, 14, 10, 12, 2, 10, 2, 4, 2, 10, 14, 4, 2, 4, 14, 4, 2, 4, 20,
					4, 8, 10, 8, 4, 6, 6, 14, 4, 6, 6, 8, 6, 12
				>>)
		end

	sq_res_0x100: CE_STATIC [CE_ARRAY [NATURAL_32]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_32_ARRAY}.make_initialized (<<
					33_751_571, 33_686_034, 33_686_035, 33_686_034, 33_751_570, 33_686_034, 33_686_034, 33_686_034
				>>)
		end

	nrtrial: CE_STATIC [CE_ARRAY [NATURAL_16]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_16_ARRAY}.make_initialized (<<
					100, 500, 1_000
				>>)
		end

	logs: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					0.1099457228193620, 0.0847016403115322, 0.0772048195144415
				>>)
		end

	x: CE_STATIC [CE_ARRAY [NATURAL_32]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_32_ARRAY}.make_initialized (<<
					0, 7, 25, 81, 241, 673, 1_793, 4_609, 11_521, 28_161, ((0).to_natural_32).bit_not
				>>)
		end

	x___0: CE_STATIC [CE_ARRAY [NATURAL_32]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_32_ARRAY}.make_initialized (<<
					1, 7, 25, 81, 241, 673, 1_793, 4_609, 11_521, 28_161, ((0).to_natural_32).bit_not
				>>)
		end

	x___1: CE_STATIC [CE_ARRAY [NATURAL_32]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_32_ARRAY}.make_initialized (<<
					0, 4, 27, 100, 325, 1_026, 2_905, 7_848, 20_457, 51_670, ((0).to_natural_32).bit_not
				>>)
		end

	gmp_primes_dtab: CE_STATIC [CE_ARRAY [PD_GMP_PRIMES_DTAB]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GMP_PRIMES_DTAB]}.make_initialized (<<
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_863_311_531, (1_431_655_765).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_435_973_837, (858_993_459).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_067_833_783, (613_566_756).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_123_612_579, (390_451_572).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_303_820_997, (330_382_099).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_042_322_161, (252_645_135).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(678_152_731).to_natural_32, (226_050_910).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_921_491_879, (186_737_708).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_332_920_885).to_natural_32, (148_102_320).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_186_588_639, (138_547_332).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_437_684_141, (116_080_197).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_247_414_297, (104_755_299).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(799_063_683).to_natural_32, (99_882_960).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_736_263_375).to_natural_32, (91_382_282).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_350_076_445, (81_037_118).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_693_454_067, (72_796_055).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_238_827_797, (70_409_299).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(128_207_979).to_natural_32, (64_103_989).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_811_027_319, (60_492_497).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_353_604_601, (58_835_168).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_631_000_239).to_natural_32, (54_366_674).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(724_452_315).to_natural_32, (51_746_593).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_198_451_177, (48_258_059).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_594_008_481).to_natural_32, (44_278_013).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_083_697_005).to_natural_32, (42_524_428).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_544_390_487, (41_698_711).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_368_252_995, (40_139_881).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_664_513_381, (39_403_369).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(266_059_921).to_natural_32, (38_008_560).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_024_418_175, (33_818_640).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_376_959_019, (32_786_009).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(125_400_505).to_natural_32, (31_350_126).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_884_841_763).to_natural_32, (30_899_045).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_363_673_277, (28_825_283).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_214_114_599, (28_443_492).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(738_624_949).to_natural_32, (27_356_479).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_159_377_675).to_natural_32, (26_349_492).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_677_726_487, (25_718_367).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(223_437_605).to_natural_32, (24_826_400).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_647_123_067, (23_994_230).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(284_749_213).to_natural_32, (23_729_101).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_002_639_679, (22_486_739).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_425_655_105, (22_253_716).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_024_687_629).to_natural_32, (21_801_864).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_014_391_543, (21_582_750).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_852_331_867).to_natural_32, (20_355_295).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_678_649_119, (19_259_943).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_611_037_387, (18_920_560).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_200_340_205).to_natural_32, (18_755_315).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(534_566_745).to_natural_32, (18_433_336).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_132_146_191).to_natural_32, (17_970_574).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(285_143_057).to_natural_32, (17_821_441).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_583_824_947, (17_111_423).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_278_255_361, (16_711_935).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_894_358_199).to_natural_32, (16_330_674).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_644_541_381).to_natural_32, (15_966_421).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_725_957_103, (15_848_587).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(635_717_181).to_natural_32, (15_505_297).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(122_276_649).to_natural_32, (15_284_581).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_384_373_523, (15_176_562).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_228_105_901, (14_658_591).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_343_639_035, (13_990_121).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_803_467_399, (13_810_184).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(960_535_817).to_natural_32, (13_721_940).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_869_733_397).to_natural_32, (13_548_792).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_217_981_539, (12_975_732).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_129_286_065, (12_744_710).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_893_746_387).to_natural_32, (12_377_427).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_048_837_365, (12_306_496).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_591_580_833, (12_167_046).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(705_858_135).to_natural_32, (11_963_697).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_077_864_847, (11_702_908).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_143_501_533, (11_514_657).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(317_306_291).to_natural_32, (11_332_367).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_969_760_895, (11_214_013).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_963_735_885, (11_041_047).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_931_829_061, (10_818_557).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_206_392_177, (10_710_641).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_226_242_217, (10_501_142).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_978_350_091).to_natural_32, (10_250_518).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_203_150_893, (10_201_822).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_066_267_983).to_natural_32, (9_965_121).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(158_705_489).to_natural_32, (9_919_093).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_287_264_263, (9_783_524).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_821_299_059, (9_695_185).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_611_416_641, (9_565_628).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(601_483_385).to_natural_32, (9_398_177).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_298_087_685, (9_316_631).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_875_680_047, (9_276_387).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_212_194_907, (9_196_932).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_210_017_311, (8_966_528).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_113_189_847, (8_819_234).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_910_082_243, (8_747_387).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_201_859_387, (8_607_148).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(384_241_607).to_natural_32, (8_538_702).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_649_547_605, (8_438_049).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_945_513_017).to_natural_32, (8_243_699).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_907_109_795, (8_212_174).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(619_237_429).to_natural_32, (7_938_941).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(588_889_483).to_natural_32, (7_851_859).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_354_238_373, (7_710_892).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_272_081_147, (7_628_716).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_457_109_001, (7_548_272).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_414_104_819).to_natural_32, (7_521_834).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_436_618_177).to_natural_32, (7_443_617).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_246_260_579, (7_316_809).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_628_631_729, (7_242_777).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(824_576_359).to_natural_32, (7_170_229).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_523_159_529, (7_146_368).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_535_433_119).to_natural_32, (7_075_728).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(322_297_709).to_natural_32, (7_006_471).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_976_937_945).to_natural_32, (6_961_049).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_013_029_443).to_natural_32, (6_938_557).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(74_872_647).to_natural_32, (6_806_604).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(6_700_417).to_natural_32, (6_700_416).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_730_010_155).to_natural_32, (6_679_575).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_252_757_303, (6_638_280).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_630_914_117, (6_577_285).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_437_507_995, (6_517_401).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_352_803_517, (6_497_681).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_667_602_273, (6_381_823).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_579_685_165).to_natural_32, (6_344_117).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(12_576_771).to_natural_32, (6_288_385).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_660_269_179, (6_215_582).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_985_120_405).to_natural_32, (6_126_914).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(30_288_909).to_natural_32, (6_057_781).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_201_811_503, (5_973_528).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_568_308_455, (5_907_795).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(515_630_453).to_natural_32, (5_859_436).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_027_981_003, (5_811_863).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_693_708_503).to_natural_32, (5_780_575).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(829_254_671).to_natural_32, (5_718_997).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_445_351_261, (5_673_668).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_725_977_929, (5_643_846).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_842_571_521, (5_585_133).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(322_261_453).to_natural_32, (5_556_231).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(764_034_843).to_natural_32, (5_457_391).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_276_461_877, (5_388_917).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(175_196_441).to_natural_32, (5_308_983).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(619_619_203).to_natural_32, (5_295_890).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_119_516_445).to_natural_32, (5_231_385).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(125_248_135).to_natural_32, (5_218_672).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_583_996_403).to_natural_32, (5_193_430).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(994_733_077).to_natural_32, (5_180_901).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_322_328_695, (5_119_150).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_188_291_069).to_natural_32, (5_035_131).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_212_814_569).to_natural_32, (5_011_630).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(484_996_307).to_natural_32, (4_999_961).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(74_651_807).to_natural_32, (4_976_787).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(925_597_285).to_natural_32, (4_897_340).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_335_778_705).to_natural_32, (4_875_104).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_147_918_779).to_natural_32, (4_864_062).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_883_386_439, (4_842_127).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_129_229_859, (4_735_355).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_781_592_431, (4_714_563).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_775_938_599).to_natural_32, (4_673_522).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_668_980_833).to_natural_32, (4_623_215).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(531_714_201).to_natural_32, (4_583_743).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_898_731_557).to_natural_32, (4_564_258).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_281_361_275, (4_535_340).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(18_027_145).to_natural_32, (4_506_786).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(257_609_207).to_natural_32, (4_441_538).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_296_009_699).to_natural_32, (4_423_241).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_525_653_809, (4_396_077).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_079_760_359).to_natural_32, (4_369_244).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_484_514_335, (4_333_973).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(831_422_957).to_natural_32, (4_307_890).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_668_924_177, (4_256_657).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(746_213_469).to_natural_32, (4_239_849).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(678_596_403).to_natural_32, (4_214_884).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_857_477_973, (4_206_628).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_682_792_375, (4_165_826).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_783_679_545).to_natural_32, (4_157_761).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_067_243_247, (4_133_751).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_821_003_305, (4_094_344).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(461_780_499).to_natural_32, (4_086_553).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(550_533_037).to_natural_32, (4_048_037).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(775_760_791).to_natural_32, (4_040_420).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_036_577_701).to_natural_32, (4_017_743).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(841_608_127).to_natural_32, (3_951_211).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_114_021_483).to_natural_32, (3_936_725).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(738_750_093).to_natural_32, (3_929_521).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_674_077_177, (3_915_193).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_757_609_647, (3_893_896).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_057_282_301).to_natural_32, (3_872_828).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_633_887_733, (3_845_091).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(198_876_491).to_natural_32, (3_824_547).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(620_088_281).to_natural_32, (3_804_222).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_496_379_775, (3_731_509).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_035_904_897, (3_725_036).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(55_395_107).to_natural_32, (3_693_007).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_962_260_891).to_natural_32, (3_667_777).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_331_236_277, (3_636_720).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_529_218_315, (3_618_338).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_812_548_505, (3_600_140).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_096_953_937, (3_576_159).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_411_271_829, (3_540_780).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_857_353_537, (3_529_143).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_482_863_351, (3_511_829).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(188_712_965).to_natural_32, (3_494_684).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_836_562_479, (3_489_006).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(329_847_933).to_natural_32, (3_472_083).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(206_323_489).to_natural_32, (3_438_724).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_053_669_827).to_natural_32, (3_411_411).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(716_388_437).to_natural_32, (3_363_325).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_196_175_615, (3_358_066).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(398_364_075).to_natural_32, (3_347_597).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_092_505_401).to_natural_32, (3_332_014).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_117_822_627).to_natural_32, (3_326_853).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_837_861_873).to_natural_32, (3_311_462).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_129_614_909, (3_301_281).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_620_490_407, (3_296_214).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_196_150_035).to_natural_32, (3_286_126).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_308_329_623, (3_256_229).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_222_038_297, (3_251_299).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_259_037_135).to_natural_32, (3_236_599).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_609_800_113, (3_155_743).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(69_121_639).to_natural_32, (3_141_892).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_305_455_861, (3_128_162).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_247_126_637).to_natural_32, (3_110_041).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_476_682_823).to_natural_32, (3_070_026).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_774_074_497).to_natural_32, (3_048_237).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_495_131_503, (3_018_248).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_314_526_875, (3_009_787).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_077_709_245, (3_005_575).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(905_150_121).to_natural_32, (2_997_185).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_074_100_319, (2_984_688).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(911_233_559).to_natural_32, (2_968_187).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_885_523_203).to_natural_32, (2_960_005).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_256_540_197, (2_955_930).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_122_461_563).to_natural_32, (2_943_774).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_623_386_687).to_natural_32, (2_919_760).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_031_063_161, (2_900_045).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_192_373_731, (2_896_134).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_943_855_407).to_natural_32, (2_888_343).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_244_113_201, (2_884_464).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_266_199_933, (2_876_736).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_593_025_619, (2_865_221).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_564_453_335, (2_842_466).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_299_482_427, (2_820_070).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_165_718_323, (2_805_334).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_497_532_343).to_natural_32, (2_783_517).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(329_955_525).to_natural_32, (2_772_735).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_378_410_737, (2_765_593).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_449_103_783).to_natural_32, (2_754_950).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_348_938_719, (2_740_885).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_351_159_691, (2_733_906).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(19_040_387).to_natural_32, (2_720_055).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_227_137_743, (2_713_182).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_367_125_269, (2_689_397).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_902_657_473, (2_682_677).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(614_712_183).to_natural_32, (2_672_661).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_333_002_745, (2_669_339).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_959_464_581, (2_662_719).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(233_450_971).to_natural_32, (2_652_851).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_596_587_261, (2_649_578).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_180_968_403, (2_639_807).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_392_420_717, (2_623_681).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_812_852_681, (2_592_014).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_711_285_631, (2_582_662).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_888_548_907).to_natural_32, (2_576_465).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_715_957_325, (2_573_377).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_953_410_997).to_natural_32, (2_536_897).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(913_661_281).to_natural_32, (2_530_917).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_375_198_475).to_natural_32, (2_527_938).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_465_628_965, (2_513_146).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_800_833_929, (2_495_623).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(852_512_371).to_natural_32, (2_492_726).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_302_380_045, (2_478_342).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_855_149_573).to_natural_32, (2_466_954).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(594_952_539).to_natural_32, (2_458_481).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_131_185_513, (2_450_066).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_120_744_735).to_natural_32, (2_441_709).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(77_343_249).to_natural_32, (2_416_976).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_040_620_231).to_natural_32, (2_408_843).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_756_594_227, (2_403_451).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(936_298_069).to_natural_32, (2_400_764).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_912_583_993).to_natural_32, (2_384_768).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_653_005_083).to_natural_32, (2_371_599).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_261_983_455, (2_355_988).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_000_877_719).to_natural_32, (2_345_694).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(744_119_943).to_natural_32, (2_325_374).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_646_452_621, (2_307_881).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(489_998_947).to_natural_32, (2_300_464).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_594_825_647, (2_295_546).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_474_039_217, (2_293_095).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(844_348_925).to_natural_32, (2_288_208).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_160_055_399, (2_285_772).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_028_947_617, (2_273_672).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_400_276_581, (2_259_319).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_925_622_715, (2_252_211).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_144_542_409, (2_245_147).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(949_741_603).to_natural_32, (2_224_219).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_279_824_709).to_natural_32, (2_221_917).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_048_950_453).to_natural_32, (2_203_677).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(358_831_199).to_natural_32, (2_201_418).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_861_769_885, (2_176_871).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_718_855_027).to_natural_32, (2_170_271).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_849_691_371, (2_161_533).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_764_830_841, (2_155_026).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_327_067_909, (2_150_709).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(382_443_311).to_natural_32, (2_148_557).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_921_864_795, (2_144_267).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(568_106_067).to_natural_32, (2_135_737).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_387_849_761, (2_129_383).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_277_683_907).to_natural_32, (2_118_878).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(433_941_989).to_natural_32, (2_116_790).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_727_799_239, (2_106_408).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_267_776_205, (2_092_044).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(949_348_079).to_natural_32, (2_081_903).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_559_543_101, (2_075_866).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_052_501_985, (2_063_895).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_245_481_355, (2_061_914).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(107_014_039).to_natural_32, (2_057_962).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(536_613_913).to_natural_32, (2_055_992).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_257_545_467, (2_046_196).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(221_767_615).to_natural_32, (2_034_565).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(264_243_137).to_natural_32, (2_032_639).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(201_736_369).to_natural_32, (2_017_363).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(822_311_899).to_natural_32, (2_015_470).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(267_304_937).to_natural_32, (2_009_811).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_414_269_941).to_natural_32, (2_006_056).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_497_125_791).to_natural_32, (2_004_184).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_195_223_513, (1_994_875).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_179_985_041, (1_987_490).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_083_423_787).to_natural_32, (1_971_072).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_499_241_875).to_natural_32, (1_949_599).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_560_744_799).to_natural_32, (1_946_065).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_847_631_661).to_natural_32, (1_940_789).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_198_955_301).to_natural_32, (1_933_798).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_864_591_509, (1_919_967).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_502_729_023, (1_918_252).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(649_127_915).to_natural_32, (1_914_831).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_455_824_099).to_natural_32, (1_908_026).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_703_536_979, (1_894_559).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_127_054_197, (1_892_889).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_176_348_449, (1_889_558).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_711_258_457, (1_882_931).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_947_477_519).to_natural_32, (1_877_991).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_393_793_373, (1_873_077).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_218_304_841, (1_869_815).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(351_558_605).to_natural_32, (1_860_098).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_729_986_743, (1_858_488).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_072_210_741, (1_840_963).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_751_440_011, (1_836_240).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_251_038_893, (1_834_672).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_184_998_275, (1_829_981).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(266_722_767).to_natural_32, (1_826_868).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_298_214_173, (1_822_217).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_169_976_683, (1_811_458).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_165_441_273).to_natural_32, (1_806_885).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_071_956_869, (1_803_850).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_366_467_503, (1_802_336).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_067_063_293, (1_797_809).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_857_034_985, (1_794_804).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(245_273_247).to_natural_32, (1_790_315).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_485_691_715).to_natural_32, (1_781_404).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_296_302_993, (1_776_982).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(994_418_759).to_natural_32, (1_772_582).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_150_846_797).to_natural_32, (1_762_399).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_845_129_913, (1_759_511).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_570_070_895, (1_755_197).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_241_855_123).to_natural_32, (1_746_631).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_791_455_755).to_natural_32, (1_740_967).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_339_758_233, (1_736_743).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_743_091_749, (1_733_939).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_022_134_775, (1_715_927).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_478_906_473, (1_703_676).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(834_896_843).to_natural_32, (1_696_944).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(495_638_211).to_natural_32, (1_691_597).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_056_827_151, (1_688_937).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(933_468_765).to_natural_32, (1_684_961).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_698_793_415).to_natural_32, (1_683_640).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_663_403_861, (1_679_689).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_061_717_531).to_natural_32, (1_665_361).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(462_483_935).to_natural_32, (1_657_648).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_222_848_481, (1_656_369).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_119_424_209).to_natural_32, (1_646_212).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_770_832_905).to_natural_32, (1_641_179).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_094_226_709).to_natural_32, (1_638_675).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_916_667_897).to_natural_32, (1_631_206).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_880_078_183, (1_622_579).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_588_992_417).to_natural_32, (1_616_472).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_274_281_291, (1_615_256).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(72_577_367).to_natural_32, (1_612_830).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_251_199_631, (1_607_999).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_447_846_365, (1_604_395).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_364_897_971, (1_600_807).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_777_448_319).to_natural_32, (1_598_424).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_328_769_921, (1_597_235).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_510_315_085, (1_594_863).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_760_936_739, (1_591_318).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_653_253_019).to_natural_32, (1_586_615).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_111_837_479).to_natural_32, (1_584_274).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_728_752_041).to_natural_32, (1_583_106).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(990_417_247).to_natural_32, (1_579_612).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_674_880_409, (1_573_824).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(201_302_019).to_natural_32, (1_572_672).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_912_635_293, (1_566_934).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_281_147_029).to_natural_32, (1_562_374).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(388_465_985).to_natural_32, (1_560_104).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_532_831_791, (1_552_210).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(595_449_193).to_natural_32, (1_546_621).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_455_268_589).to_natural_32, (1_539_966).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_893_323_991, (1_538_863).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_631_604_453, (1_535_562).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_364_698_641).to_natural_32, (1_533_369).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_921_092_155, (1_532_275).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_012_114_347, (1_523_578).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_304_394_737, (1_516_049).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(405_728_317).to_natural_32, (1_513_911).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(389_764_883).to_natural_32, (1_510_716).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(988_249_227).to_natural_32, (1_506_477).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_190_328_089, (1_503_313).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_257_629_861, (1_501_211).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(514_679_999).to_natural_32, (1_491_826).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_832_295_031, (1_487_692).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(128_982_449).to_natural_32, (1_482_556).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(355_078_247).to_natural_32, (1_479_492).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(160_932_085).to_natural_32, (1_476_441).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(281_226_861).to_natural_32, (1_472_391).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(104_182_671).to_natural_32, (1_467_361).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_544_245_683, (1_461_370).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_656_609_465).to_natural_32, (1_454_442).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(785_788_741).to_natural_32, (1_452_474).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(439_208_603).to_natural_32, (1_449_533).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_932_662_953).to_natural_32, (1_446_604).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_132_304_531).to_natural_32, (1_445_630).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_071_235_591).to_natural_32, (1_432_133).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(719_882_889).to_natural_32, (1_431_178).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_078_377_707).to_natural_32, (1_426_425).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(101_007_843).to_natural_32, (1_422_645).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_926_989_615, (1_420_763).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_824_184_949, (1_414_213).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_611_495_457).to_natural_32, (1_412_353).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_703_195_225, (1_408_647).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_148_613_725, (1_403_125).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_272_689_459, (1_400_380).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_486_987_703).to_natural_32, (1_394_922).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_932_757_923, (1_393_112).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_177_080_049, (1_390_407).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(733_556_653).to_natural_32, (1_381_462).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(665_107_151).to_natural_32, (1_377_033).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_030_737_105).to_natural_32, (1_376_151).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_397_883_841).to_natural_32, (1_369_132).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_216_210_387, (1_357_877).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_771_996_575, (1_356_162).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_082_890_145).to_natural_32, (1_355_306).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_752_189_285, (1_350_194).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(773_552_315).to_natural_32, (1_347_652).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(714_706_247).to_natural_32, (1_345_962).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_972_820_011, (1_340_920).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_272_419_769, (1_338_412).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(18_691_185).to_natural_32, (1_335_084).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_757_596_349, (1_333_426).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_229_538_741, (1_330_123).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_910_342_267).to_natural_32, (1_321_121).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(518_881_693).to_natural_32, (1_320_309).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_084_845_961).to_natural_32, (1_318_688).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_130_232_435, (1_317_878).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_960_141_047, (1_313_044).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_466_959_051, (1_301_899).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_643_303_149).to_natural_32, (1_301_110).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_354_672_067, (1_298_750).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_456_197_649, (1_296_398).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_595_569_351).to_natural_32, (1_294_054).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_253_214_771, (1_292_496).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_806_234_369).to_natural_32, (1_290_167).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(234_669_483).to_natural_32, (1_289_392).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_059_930_607).to_natural_32, (1_284_764).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_677_734_171, (1_283_228).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_715_941_087).to_natural_32, (1_278_644).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_418_339_041, (1_277_883).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(145_246_595).to_natural_32, (1_274_092).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_065_353_381).to_natural_32, (1_273_337).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_268_593_173).to_natural_32, (1_267_325).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_015_126_207).to_natural_32, (1_266_578).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(470_215_087).to_natural_32, (1_260_630).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_980_363_773, (1_258_414).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_950_438_105).to_natural_32, (1_251_082).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_123_118_793, (1_245_279).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_951_806_081).to_natural_32, (1_242_397).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_159_272_781, (1_240_961).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_334_140_471, (1_240_244).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(86_716_963).to_natural_32, (1_238_813).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_600_009_029, (1_238_099).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_053_134_347).to_natural_32, (1_230_297).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_756_529_923).to_natural_32, (1_227_484).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_227_686_407, (1_223_288).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_089_312_149).to_natural_32, (1_221_201).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(594_256_887).to_natural_32, (1_217_739).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_558_237_817, (1_217_049).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(737_912_581).to_natural_32, (1_215_671).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_118_963_803).to_natural_32, (1_213_610).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(665_895_805).to_natural_32, (1_212_924).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_178_360_915, (1_210_873).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_408_685_037, (1_207_469).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_424_012_759).to_natural_32, (1_206_790).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_305_643_323, (1_202_735).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_036_821_333, (1_199_376).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_195_110_911).to_natural_32, (1_198_707).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_739_789_881, (1_195_370).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_746_040_231, (1_190_731).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_124_044_853, (1_188_753).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_487_861_217).to_natural_32, (1_187_439).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_621_079_959, (1_185_472).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(578_418_895).to_natural_32, (1_182_860).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_554_076_701).to_natural_32, (1_180_909).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_626_970_867).to_natural_32, (1_178_964).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_926_220_643).to_natural_32, (1_173_809).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_403_122_535, (1_169_972).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_024_850_921, (1_169_334).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_806_855_157, (1_168_062).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_003_775_043).to_natural_32, (1_163_632).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_521_245_841, (1_161_743).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_402_551_773, (1_160_488).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(286_022_357).to_natural_32, (1_157_985).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_523_275_575).to_natural_32, (1_154_871).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(339_955_823).to_natural_32, (1_152_392).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_447_199_421, (1_150_540).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_786_731_923, (1_148_694).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_701_542_481).to_natural_32, (1_141_974).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_776_196_359, (1_140_155).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_695_651_721).to_natural_32, (1_139_550).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_018_335_723).to_natural_32, (1_136_535).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_246_276_657, (1_132_340).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(225_098_365).to_natural_32, (1_131_147).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_315_809_619, (1_129_362).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(767_721_189).to_natural_32, (1_124_042).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_079_514_639).to_natural_32, (1_123_454).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_332_302_665).to_natural_32, (1_120_523).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_861_786_295, (1_116_445).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_969_303_715, (1_115_286).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(410_212_293).to_natural_32, (1_114_707).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(760_486_055).to_natural_32, (1_111_821).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_850_387_117, (1_107_806).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_152_463_641, (1_106_665).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_424_709_073, (1_104_388).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(318_797_163).to_natural_32, (1_099_300).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_391_389_303).to_natural_32, (1_098_176).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_896_937_349, (1_096_494).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_486_675_375, (1_095_934).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(460_917_979).to_natural_32, (1_094_817).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_300_842_729).to_natural_32, (1_093_145).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(340_887_763).to_natural_32, (1_092_588).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_839_766_615).to_natural_32, (1_089_263).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(556_049_731).to_natural_32, (1_088_159).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_664_069_759).to_natural_32, (1_082_673).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_131_308_477, (1_076_702).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_847_328_865, (1_073_473).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_072_891_915, (1_072_937).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_074_060_823).to_natural_32, (1_071_866).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_885_430_309, (1_070_263).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_015_232_379).to_natural_32, (1_068_665).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_305_875_101, (1_068_134).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_705_401_715).to_natural_32, (1_066_542).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_808_574_769).to_natural_32, (1_060_747).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_241_522_267).to_natural_32, (1_060_223).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_029_013_609).to_natural_32, (1_058_655).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_964_909_657, (1_054_497).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_058_054_415, (1_052_946).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_752_212_275).to_natural_32, (1_049_857).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(158_451_029).to_natural_32, (1_049_344).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_227_641_003, (1_047_808).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_773_985_519).to_natural_32, (1_044_750).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_009_478_623).to_natural_32, (1_040_699).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_266_882_017, (1_040_195).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_803_731_373, (1_039_188).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_596_993_155).to_natural_32, (1_037_682).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_848_199_689, (1_034_184).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_515_942_677, (1_033_189).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_210_286_527, (1_032_692).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(678_639_793).to_natural_32, (1_028_242).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_067_352_025).to_natural_32, (1_022_367).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_659_442_363).to_natural_32, (1_019_939).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_203_853_769).to_natural_32, (1_018_488).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_193_103_027).to_natural_32, (1_018_005).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(29_452_365).to_natural_32, (1_015_598).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_985_356_087, (1_015_118).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_707_454_577).to_natural_32, (1_012_725).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_287_780_763, (1_012_247).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(535_229_877).to_natural_32, (1_009_867).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(838_017_803).to_natural_32, (1_008_445).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_824_244_525, (1_007_971).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_624_224_335, (1_005_611).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(915_683_409).to_natural_32, (1_005_140).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_157_584_499, (1_002_794).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(917_274_433).to_natural_32, (1_001_391).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(500_763_001).to_natural_32, (999_526).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_008_023_767).to_natural_32, (992_597).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_213_339_153, (990_308).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_138_329_659).to_natural_32, (989_851).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(678_464_597).to_natural_32, (987_575).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_012_053_453, (985_762).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_283_666_595).to_natural_32, (984_406).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_097_553_981, (982_155).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(753_159_831).to_natural_32, (978_129).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(498_165_413).to_natural_32, (976_794).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_516_632_329, (974_136).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_169_676_685).to_natural_32, (971_492).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_583_971_959, (971_052).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_738_876_649).to_natural_32, (967_117).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(409_504_415).to_natural_32, (965_812).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_148_295_755, (964_944).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_105_301_209).to_natural_32, (963_645).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_534_829_455, (962_349).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(567_422_593).to_natural_32, (958_484).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_964_437_803, (958_056).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_029_427_013).to_natural_32, (955_924).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(207_744_147).to_natural_32, (952_954).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_174_830_689, (951_687).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_514_696_237).to_natural_32, (950_845).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(827_819_543).to_natural_32, (950_424).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_045_403_395).to_natural_32, (949_583).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(435_447_531).to_natural_32, (944_571).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(179_389_709).to_natural_32, (944_156).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(714_729_265).to_natural_32, (941_672).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_866_128_871, (940_435).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_127_275_991, (937_151).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_570_875_663, (935_518).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(682_971_741).to_natural_32, (934_297).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_911_471_411, (933_080).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_231_681_733, (929_445).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_329_152_053).to_natural_32, (926_238).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_448_012_255).to_natural_32, (925_839).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(226_635_147).to_natural_32, (925_041).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_287_446_553, (923_847).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_324_227_715).to_natural_32, (923_450).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_999_191_249, (922_260).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_371_765_127, (921_073).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_749_955_521, (919_102).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_431_200_631, (917_924).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_236_561_371, (915_576).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_413_690_783, (913_239).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_528_393_361).to_natural_32, (909_757).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_114_890_939).to_natural_32, (909_372).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_976_233_417, (908_218).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(772_241_109).to_natural_32, (907_451).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(988_990_575).to_natural_32, (904_013).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(809_536_807).to_natural_32, (902_493).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_697_154_127).to_natural_32, (897_965).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(727_641_211).to_natural_32, (897_214).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_963_183_005).to_natural_32, (896_840).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_802_078_601, (896_091).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_305_763_135).to_natural_32, (894_971).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_996_010_305, (894_598).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_418_865_157).to_natural_32, (892_368).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_857_259_057).to_natural_32, (891_627).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_510_484_255).to_natural_32, (889_043).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_449_218_133, (883_556).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_401_088_695).to_natural_32, (881_742).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_729_585_093, (880_657).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(109_812_009).to_natural_32, (878_496).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_078_340_759).to_natural_32, (875_987).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_807_608_485, (874_916).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_011_094_151).to_natural_32, (873_138).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_963_982_187, (871_013).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_116_481_933, (870_660).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(749_031_161).to_natural_32, (869_954).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_127_269_807, (868_898).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_788_774_503).to_natural_32, (867_494).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_011_762_421, (866_444).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_307_020_887, (864_700).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_223_170_265, (864_352).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_062_413_413).to_natural_32, (863_657).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_825_704_371, (861_232).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(446_442_625).to_natural_32, (860_197).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_419_409_463, (859_165).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_622_651_427, (858_478).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(820_579_697).to_natural_32, (857_450).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_065_629_851).to_natural_32, (857_107).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(931_531_445).to_natural_32, (855_400).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_433_501_279, (855_060).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(612_836_175).to_natural_32, (852_345).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_632_614_771).to_natural_32, (850_320).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_231_956_715, (848_975).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(669_158_781).to_natural_32, (845_965).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(272_186_473).to_natural_32, (845_299).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_104_846_367).to_natural_32, (844_302).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_011_949_251, (842_315).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(142_295_525).to_natural_32, (841_985).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_533_080_379, (840_996).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_430_535_753).to_natural_32, (840_009).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_195_005_951, (839_024).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_861_882_387, (834_460).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_501_486_049, (833_488).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(935_965_391).to_natural_32, (831_230).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(666_961_659).to_natural_32, (830_587).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_698_697_459, (829_304).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_768_808_077).to_natural_32, (827_706).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_975_155_333, (826_432).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_642_460_137).to_natural_32, (824_528).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(962_197_571).to_natural_32, (821_688).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(167_496_335).to_natural_32, (821_060).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_744_907_409).to_natural_32, (820_746).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_126_022_621, (820_119).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_004_209_221).to_natural_32, (816_378).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_255_055_785, (814_520).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_677_540_703, (813_594).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_164_969_313, (813_286).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(125_678_673).to_natural_32, (810_830).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_742_932_231).to_natural_32, (809_912).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_180_168_853, (808_997).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_728_833_251, (806_869).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_623_046_781, (805_356).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(769_511_627).to_natural_32, (803_248).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_407_041_239).to_natural_32, (802_647).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_022_680_013, (798_172).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_675_890_339).to_natural_32, (797_283).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_841_817_585, (796_396).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(312_636_071).to_natural_32, (795_511).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_456_809_695).to_natural_32, (794_334).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_672_899_245, (793_454).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_144_322_329, (792_868).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_483_369_859, (792_575).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_568_597_639, (790_824).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_697_606_165).to_natural_32, (789_951).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_144_986_817, (789_370).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(80_486_251).to_natural_32, (789_080).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_857_509_625, (788_212).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(387_810_975).to_natural_32, (785_042).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(569_316_461).to_natural_32, (784_182).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(583_218_775).to_natural_32, (783_896).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_330_868_035).to_natural_32, (783_324).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_410_990_549, (780_761).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(466_725_503).to_natural_32, (780_477).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_319_608_619).to_natural_32, (779_910).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_715_197_295, (778_214).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_295_679_857, (777_932).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_377_890_343, (777_088).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_074_101_907).to_natural_32, (776_526).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_973_443_741, (772_893).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_519_230_323, (772_059).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(834_468_417).to_natural_32, (771_227).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_542_889_741).to_natural_32, (770_674).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_594_547_973).to_natural_32, (769_569).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_276_530_663, (768_193).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_750_678_471).to_natural_32, (763_821).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_623_188_407, (761_654).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(254_302_265).to_natural_32, (761_384).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_854_281_967).to_natural_32, (760_575).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_549_163_035, (760_036).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_741_242_173, (759_767).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_567_811_113).to_natural_32, (759_230).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_678_824_467).to_natural_32, (758_962).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_537_217_965).to_natural_32, (757_623).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_220_414_203, (755_757).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_117_662_729).to_natural_32, (754_959).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_210_471_189, (754_429).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_349_763_725, (753_370).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_704_149_167).to_natural_32, (752_051).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(979_646_205).to_natural_32, (751_262).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_478_758_361, (748_643).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_442_617_701, (748_121).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_495_613_071, (747_861).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_074_984_413, (747_080).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_302_441_371, (743_202).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_344_667_431, (742_688).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(862_553_439).to_natural_32, (741_662).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(104_394_137).to_natural_32, (740_383).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_258_725_967, (739_618).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(265_987_997).to_natural_32, (738_855).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_604_064_405).to_natural_32, (737_840).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_043_622_891, (737_080).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(641_413_167).to_natural_32, (735_565).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_433_790_299, (735_062).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(416_352_617).to_natural_32, (734_307).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_541_824_851, (734_056).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_013_427_489).to_natural_32, (733_304).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_926_543_085).to_natural_32, (732_804).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(618_586_563).to_natural_32, (732_055).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_664_857_829).to_natural_32, (731_805).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_419_479_751).to_natural_32, (730_560).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_723_334_985, (730_312).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_528_763_193, (728_330).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(598_079_471).to_natural_32, (727_590).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_949_159_563).to_natural_32, (725_133).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_873_930_391).to_natural_32, (724_644).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_106_782_203, (723_180).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_064_152_769).to_natural_32, (721_479).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_739_874_549, (718_101).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_433_360_459, (717_382).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_176_002_119, (714_993).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_356_869_555).to_natural_32, (714_517).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(71_238_469).to_natural_32, (712_384).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_477_947_837, (711_440).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_395_174_547, (710_734).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_897_167_455, (710_264).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_485_109_293).to_natural_32, (709_560).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_090_495_867).to_natural_32, (707_922).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_709_386_377, (707_223).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_750_063_167).to_natural_32, (706_525).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_408_821_369, (705_364).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(712_889_827).to_natural_32, (705_133).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(309_750_141).to_natural_32, (703_977).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_797_942_305).to_natural_32, (702_595).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_921_082_969, (701_677).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(578_640_187).to_natural_32, (700_532).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_146_502_749, (700_304).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_257_212_415, (699_164).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(776_459_703).to_natural_32, (698_255).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_554_819_099, (696_895).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_211_146_293, (695_766).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_179_917_341, (693_072).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_280_856_967, (692_848).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_928_686_835, (692_401).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_232_270_443).to_natural_32, (691_509).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(297_753_081).to_natural_32, (690_842).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_983_597_701, (690_398).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_136_379_645, (689_511).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_949_481_303, (687_524).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(577_284_241).to_natural_32, (686_425).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_356_836_167, (685_768).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_809_222_869, (685_112).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_072_487_807).to_natural_32, (684_893).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(298_328_141).to_natural_32, (684_238).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(125_699_695).to_natural_32, (683_150).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_245_056_403).to_natural_32, (681_849).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(597_110_197).to_natural_32, (681_632).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(311_693_079).to_natural_32, (680_552).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(121_703_205).to_natural_32, (679_906).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_840_797_307).to_natural_32, (679_260).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_389_129_097).to_natural_32, (678_617).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_665_327_937, (677_760).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_494_507_255, (677_119).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_400_665_649, (676_053).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(914_512_615).to_natural_32, (675_415).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_335_551_849).to_natural_32, (675_203).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_921_257_247, (674_566).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_086_607_597, (673_931).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_174_078_915, (673_297).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_266_433_885, (672_244).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_064_565_333).to_natural_32, (671_403).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_462_201_917).to_natural_32, (668_893).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(398_956_819).to_natural_32, (668_269).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_737_217_489, (665_989).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_058_614_267, (665_783).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_627_717_005, (663_930).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(810_821_881).to_natural_32, (663_520).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(915_853_233).to_natural_32, (662_701).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_280_812_243, (661_680).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_031_512_777, (658_636).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_294_608_001).to_natural_32, (657_829).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_817_177_243).to_natural_32, (656_020).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_315_173_927).to_natural_32, (655_620).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(119_286_441).to_natural_32, (655_420).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(553_640_459).to_natural_32, (654_421).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_461_295_769).to_natural_32, (653_823).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_182_406_915).to_natural_32, (653_624).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_036_581_713, (653_028).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_592_735_901, (652_631).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_612_516_855, (650_851).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_783_123_247).to_natural_32, (650_063).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_863_596_627).to_natural_32, (648_884).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_758_500_837, (647_124).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(917_998_421).to_natural_32, (645_568).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_080_352_939).to_natural_32, (644_986).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(669_295_309).to_natural_32, (644_793).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_762_268_913).to_natural_32, (643_633).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_614_069_159).to_natural_32, (643_055).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(235_006_433).to_natural_32, (642_094).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_224_107_403).to_natural_32, (641_902).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(235_226_533).to_natural_32, (640_944).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(340_880_591).to_natural_32, (640_752).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_531_911_709, (640_179).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_100_642_239, (639_227).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_948_588_677, (637_898).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_945_071_281).to_natural_32, (637_519).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_253_147_097, (635_256).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_833_039_939, (635_068).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_050_864_307).to_natural_32, (633_569).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_356_705_493).to_natural_32, (633_382).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_080_031_031, (632_449).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_518_697_401).to_natural_32, (632_263).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(428_675_995).to_natural_32, (631_334).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_309_825_303, (629_483).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_258_229_763).to_natural_32, (629_114).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_998_112_037, (628_930).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_700_261_457).to_natural_32, (628_562).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_890_517_385, (627_827).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_552_752_505).to_natural_32, (626_362).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_351_134_255).to_natural_32, (625_814).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_336_823_421).to_natural_32, (625_268).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_011_527_399).to_natural_32, (625_086).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(654_572_235).to_natural_32, (623_996).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_855_819_323).to_natural_32, (622_549).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_793_974_323).to_natural_32, (621_828).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(438_756_607).to_natural_32, (621_468).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(832_666_061).to_natural_32, (620_929).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_736_071_307, (618_247).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_155_172_525).to_natural_32, (618_069).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(829_492_175).to_natural_32, (617_181).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(576_282_065).to_natural_32, (617_004).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_159_343_239, (616_472).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_010_435_571).to_natural_32, (616_119).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_373_429_953, (615_589).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(464_985_719).to_natural_32, (615_060).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_060_379_567).to_natural_32, (614_356).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_496_517_117).to_natural_32, (613_829).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(988_314_857).to_natural_32, (613_479).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(807_181_933).to_natural_32, (612_429).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_541_711_171, (611_905).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_842_184_635).to_natural_32, (611_209).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_955_650_175, (610_167).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_366_210_347, (609_820).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_486_123_377, (608_610).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(94_782_133).to_natural_32, (607_577).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_040_271_383, (606_719).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_193_740_863, (604_669).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(885_697_293).to_natural_32, (604_159).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_754_537_265).to_natural_32, (603_141).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(897_320_935).to_natural_32, (602_633).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_935_717_481).to_natural_32, (602_464).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_041_475_855).to_natural_32, (600_610).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(832_116_167).to_natural_32, (599_939).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_330_290_233, (598_434).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(775_687_707).to_natural_32, (597_602).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_061_650_473).to_natural_32, (597_103).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_352_190_359, (595_943).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_266_377_859, (595_613).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_334_509_477, (595_448).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(313_540_347).to_natural_32, (594_953).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_909_376_789, (594_130).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(400_594_573).to_natural_32, (593_473).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_787_967_843, (592_981).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_682_354_351, (592_654).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_830_710_525, (592_164).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_549_554_875, (589_725).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_785_813_377, (588_593).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(938_109_731).to_natural_32, (587_788).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_646_672_965, (587_627).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_062_710_697).to_natural_32, (586_664).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_330_635_531, (585_863).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_126_487_853, (585_703).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_393_778_077, (584_428).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_712_764_679, (584_269).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_478_671_737).to_natural_32, (582_842).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_213_605_665).to_natural_32, (580_950).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(279_338_043).to_natural_32, (579_539).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(984_999_241).to_natural_32, (579_070).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(345_538_873).to_natural_32, (577_824).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_838_806_291).to_natural_32, (576_428).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_101_244_129).to_natural_32, (575_964).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_622_814_859, (575_810).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_637_682_461).to_natural_32, (574_423).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_890_566_409).to_natural_32, (574_116).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_396_620_991, (573_656).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(857_961_153).to_natural_32, (573_503).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_353_955_939, (572_738).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_224_434_907, (572_128).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(336_535_285).to_natural_32, (571_367).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_609_873_483, (570_911).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_709_668_569, (570_456).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_307_326_865, (569_851).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_807_747_805).to_natural_32, (569_548).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_644_588_979, (569_095).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_325_073_365).to_natural_32, (568_945).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_583_552_567).to_natural_32, (568_192).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_167_971_513, (568_042).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(32_327_101).to_natural_32, (567_142).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_273_516_713, (566_842).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_707_930_719, (566_394).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_014_230_573, (565_946).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_829_316_119, (565_797).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_718_764_923, (564_904).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_667_204_615, (564_607).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_596_704_013, (563_570).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_356_356_583, (562_242).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_699_597_395, (561_947).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_785_680_417, (561_507).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(385_869_405).to_natural_32, (560_042).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_533_706_313, (559_750).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_340_676_097, (559_167).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_834_572_727, (558_731).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_479_867_811).to_natural_32, (558_440).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_675_254_811).to_natural_32, (557_860).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_134_098_855).to_natural_32, (557_570).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_391_671_725, (556_559).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_796_845_699).to_natural_32, (556_126).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_516_838_607, (555_838).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_124_633_365, (554_833).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_930_048_505).to_natural_32, (553_974).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_068_545_669, (553_689).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_576_758_959, (553_546).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(245_930_853).to_natural_32, (551_414).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 4_219_462_289, (551_131).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_823_548_345, (549_439).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_782_661_231).to_natural_32, (549_017).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_326_052_029, (548_597).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(433_276_257).to_natural_32, (547_757).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_777_033_509, (546_920).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_436_738_163, (545_947).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(547_713_345).to_natural_32, (545_531).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_169_562_637, (545_254).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 3_782_558_455, (545_115).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_929_055_459, (544_839).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(196_782_453).to_natural_32, (543_597).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_371_543_243).to_natural_32, (543_185).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_189_400_591).to_natural_32, (542_362).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(287_703_751).to_natural_32, (541_814).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(1_992_912_469).to_natural_32, (541_405).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_764_103_937, (541_132).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(2_107_230_149).to_natural_32, (540_315).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([{NATURAL_32} 2_933_714_927, (540_179).to_natural_32]),
					create {PD_GMP_PRIMES_DTAB}.make_initialized ([(0).to_natural_32, (0).to_natural_32])
				>>)
		end

	gmp_primes_ptab: CE_STATIC [CE_ARRAY [PD_GMP_PRIMES_PTAB]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GMP_PRIMES_PTAB]}.make_initialized (<<
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(111_546_435).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							872_932_084, 5, 56_202_766, 41_996_971, 56_016_871, 2_552_806, 52_532_041
						>>), {NATURAL_32} 0, {NATURAL_32} 8]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(58_642_669).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							620_060_977, 6, 14_052_459, 39_636_151, 14_246_083, 30_401_305, 16_897_946
						>>), {NATURAL_32} 8, {NATURAL_32} 5]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(600_662_303).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_382_701_163, 2, 90_331_175, 95_285_005, 373_472_497, 424_277_521, 503_427_035
						>>), {NATURAL_32} 13, {NATURAL_32} 5]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(33_984_931).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_186_155_592, 6, 12_865_990, 32_705_024, 25_698_327, 20_284_587, 31_214_417
						>>), {NATURAL_32} 18, {NATURAL_32} 4]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(89_809_099).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							2_123_767_094, 5, 73_939_643, 11_829_502, 18_530_590, 82_061_065, 75_872_297
						>>), {NATURAL_32} 22, {NATURAL_32} 4]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(167_375_713).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_593_257_309, 4, 110_574_471, 151_130_637, 28_548_235, 35_928_685, 60_605_226
						>>), {NATURAL_32} 26, {NATURAL_32} 4]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(371_700_317).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_908_532_953, 3, 206_263_809, 91_419_201, 305_488_339, 181_213_774, 240_175_855
						>>), {NATURAL_32} 30, {NATURAL_32} 4]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(645_328_247).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_851_296_701, 2, 422_997_814, 640_673_839, 435_521_814, 489_906_921, 484_953_077
						>>), {NATURAL_32} 34, {NATURAL_32} 4]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_070_560_157).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							12_764_491, 2, 12_726_668, 891_109_380, 533_864_866, 164_444_418, 25_901_180
						>>), {NATURAL_32} 38, {NATURAL_32} 4]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_596_463_769).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_482_409_062, 1, 1_102_039_758, 1_264_741_243, 446_250_162, 880_971_961, 344_757_914
						>>), {NATURAL_32} 42, {NATURAL_32} 4]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(11_592_209).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_921_069_184, 8, 5_849_966, 110_880, 2_175_485, 6_632_860, 7_091_928
						>>), {NATURAL_32} 46, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(13_420_567).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_074_224_187, 8, 385_856, 10_503_005, 12_039_156, 12_357_290, 8_343_645
						>>), {NATURAL_32} 49, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(16_965_341).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_199_715_367, 7, 2_736_023, 863_007, 4_771_463, 2_612_149, 12_332_403
						>>), {NATURAL_32} 52, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(20_193_023).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_841_913_005, 7, 14_046_420, 6_460_092, 138_793, 9_365_525, 4_941_710
						>>), {NATURAL_32} 55, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(23_300_239).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_890_170_464, 7, 7_723_320, 11_471_645, 3_163_661, 7_545_497, 13_526_662
						>>), {NATURAL_32} 58, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(29_884_301).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							527_470_681, 7, 21_512_253, 10_231_486, 15_656_410, 3_927_343, 29_108_077
						>>), {NATURAL_32} 61, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(35_360_399).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_856_252_268, 6, 16_359_017, 1_302_170, 20_636_921, 9_495_653, 7_711_338
						>>), {NATURAL_32} 64, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(42_749_359).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_447_364_820, 6, 20_031_396, 13_554_681, 6_275_537, 27_668_868, 13_853_702
						>>), {NATURAL_32} 67, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(49_143_869).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_570_064_945, 6, 19_450_693, 2_207_435, 26_746_797, 7_236_268, 27_612_012
						>>), {NATURAL_32} 70, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(56_466_073).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							809_520_422, 6, 3_545_748, 44_793_908, 26_636_638, 14_699_307, 46_103_300
						>>), {NATURAL_32} 73, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(65_111_573).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							131_747_692, 6, 62_715_051, 21_176_873, 47_981_279, 19_214_676, 8_234_907
						>>), {NATURAL_32} 76, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(76_027_969).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_287_252_246, 5, 37_401_032, 37_565_435, 41_408_487, 7_640_984, 66_757_016
						>>), {NATURAL_32} 79, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(84_208_541).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_550_665_527, 5, 331_705, 51_852_479, 47_838_904, 61_976_739, 78_887_124
						>>), {NATURAL_32} 82, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(94_593_973).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_799_086_416, 5, 38_238_511, 34_480_865, 72_653_164, 66_531_042, 23_095_208
						>>), {NATURAL_32} 85, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(103_569_859).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_270_945_005, 5, 48_603_077, 50_367_253, 85_339_154, 59_437_222, 56_947_566
						>>), {NATURAL_32} 88, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(119_319_383).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							536_274_182, 5, 118_788_891, 66_656_950, 36_348_948, 21_406_065, 118_084_896
						>>), {NATURAL_32} 91, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(133_390_067).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							26_649_487, 5, 26_485_152, 129_087_792, 56_562_945, 97_698_571, 24_191_173
						>>), {NATURAL_32} 94, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(154_769_821).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_154_298_311, 4, 116_182_129, 15_700_601, 68_407_491, 13_212_556, 83_798_164
						>>), {NATURAL_32} 97, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(178_433_279).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_166_391_880, 4, 12_568_600, 47_562_115, 64_517_131, 154_704_379, 39_845_528
						>>), {NATURAL_32} 100, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(193_397_129).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_666_452_661, 4, 40_230_458, 41_733_691, 124_771_847, 71_809_927, 52_455_982
						>>), {NATURAL_32} 103, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(213_479_407).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_105_654_341, 4, 25_379_156, 31_648_216, 56_556_767, 62_879_032, 128_533_288
						>>), {NATURAL_32} 106, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(229_580_147).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							726_902_058, 4, 162_524_650, 4_649_979, 149_145_104, 216_875_834, 153_991_541
						>>), {NATURAL_32} 109, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(250_367_549).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							309_948_593, 4, 38_718_963, 25_234_248, 77_460_362, 224_094_883, 229_480_563
						>>), {NATURAL_32} 112, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(271_661_713).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_192_953_153, 3, 220_041_601, 215_028_242, 258_728_103, 200_865_798, 269_979_522
						>>), {NATURAL_32} 115, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(293_158_127).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_570_559_178, 3, 190_753_518, 56_569_270, 124_399_340, 148_236_743, 218_447_979
						>>), {NATURAL_32} 118, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(319_512_181).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_921_793_586, 3, 141_308_943, 83_610_299, 207_559_858, 5_407_866, 308_462_671
						>>), {NATURAL_32} 121, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(357_349_471).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_157_660_163, 3, 6_773_644, 10_360_220, 152_926_700, 313_989_369, 350_162_154
						>>), {NATURAL_32} 124, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(393_806_449).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_560_302_507, 3, 356_902_806, 77_255_893, 114_036_243, 351_731_452, 123_461_523
						>>), {NATURAL_32} 127, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(422_400_701).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_163_932_283, 3, 70_960_286, 309_508_378, 7_250_722, 107_360_123, 38_028_448
						>>), {NATURAL_32} 130, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(452_366_557).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							802_321_558, 3, 223_668_283, 100_073_407, 143_959_814, 75_002_468, 103_994_865
						>>), {NATURAL_32} 133, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(507_436_351).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							249_135_633, 3, 235_476_488, 290_993_229, 139_060_972, 507_341_565, 220_943_518
						>>), {NATURAL_32} 136, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(547_978_913).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_120_841_978, 2, 459_114_905, 138_258_229, 42_559_868, 411_312_456, 158_447_385
						>>), {NATURAL_32} 139, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(575_204_137).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_722_509_842, 2, 268_538_337, 237_063_718, 14_835_035, 356_811_893, 417_382_211
						>>), {NATURAL_32} 142, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(627_947_039).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_049_101_123, 2, 527_285_062, 127_865_135, 25_212_983, 531_354_884, 215_232_875
						>>), {NATURAL_32} 145, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(666_785_731).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_621_326_505, 2, 294_252_910, 66_980_299, 537_228_988, 15_598_592, 155_347_143
						>>), {NATURAL_32} 148, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(710_381_447).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_196_877_385, 2, 32_678_614, 247_036_541, 63_690_930, 343_597_554, 556_083_815
						>>), {NATURAL_32} 151, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(777_767_161).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_634_424_236, 2, 406_131_491, 505_229_008, 218_484_251, 191_206_288, 404_442_838
						>>), {NATURAL_32} 154, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(834_985_999).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_228_102_580, 2, 120_037_301, 204_915_122, 582_802_249, 453_787_400, 62_537_721
						>>), {NATURAL_32} 157, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(894_826_021).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							858_756_344, 2, 715_663_212, 355_379_835, 290_082_851, 612_184_771, 701_577_285
						>>), {NATURAL_32} 160, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(951_747_481).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							550_525_978, 2, 487_977_372, 878_285_478, 221_969_362, 695_682_139, 400_255_420
						>>), {NATURAL_32} 163, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_019_050_649).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							230_505_528, 2, 218_764_700, 393_300_512, 159_895_988, 536_113_121, 268_913_535
						>>), {NATURAL_32} 166, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_072_651_369).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							4_366_254, 2, 4_361_820, 929_031_816, 777_948_706, 760_101_453, 855_474_799
						>>), {NATURAL_32} 169, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_125_878_063).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_897_191_641, 1, 917_333_107, 1_028_275_491, 883_740_495, 608_408_592, 413_973_109
						>>), {NATURAL_32} 172, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_185_362_993).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_486_085_504, 1, 738_878_317, 1_126_127_823, 619_044_597, 515_719_670, 545_119_461
						>>), {NATURAL_32} 175, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_267_745_273).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_980_446_963, 1, 491_731_477, 513_710_929, 265_462_434, 439_487_952, 246_618_546
						>>), {NATURAL_32} 178, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_322_520_163).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_679_120_732, 1, 327_406_807, 1_253_214_325, 51_601_058, 1_170_317_980, 1_301_835_282
						>>), {NATURAL_32} 181, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_391_119_619).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_335_211_669, 1, 121_608_439, 933_203_327, 890_030_575, 212_379_206, 1_162_849_229
						>>), {NATURAL_32} 184, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_498_299_287).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_860_927_001, 1, 1_298_368_722, 126_319_851, 251_889_642, 142_625_215, 769_821_389
						>>), {NATURAL_32} 187, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_608_372_013).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_439_633_879, 1, 1_078_223_270, 927_349_053, 938_310_675, 152_540_479, 1_053_301_715
						>>), {NATURAL_32} 190, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_416_091).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							2_065_640_358, 11, 1_379_384, 701_308, 205_533, 433_017, 866_456
						>>), {NATURAL_32} 193, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_456_813).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_887_843_575, 11, 282_572, 471_467, 737_900, 604_549, 1_270_835
						>>), {NATURAL_32} 195, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_829_232_539).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							747_241_302, 1, 636_502_218, 105_978_433, 521_949_872, 836_349_276, 963_372_588
						>>), {NATURAL_32} 197, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_901_911_003).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							554_561_426, 1, 491_145_290, 334_984_281, 1_277_980_693, 12_540_249, 304_636_112
						>>), {NATURAL_32} 200, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_056_303_297).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							190_446_918, 1, 182_360_702, 391_824_500, 1_566_700_004, 1_060_286_734, 236_621_601
						>>), {NATURAL_32} 203, {NATURAL_32} 3]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_653_787).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_151_441_010, 11, 82_457, 438_492, 1_643_450, 996_083, 338_363
						>>), {NATURAL_32} 206, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_674_427).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_084_305_287, 11, 62_041, 1_252_435, 534_900, 262_187, 959_789
						>>), {NATURAL_32} 208, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_695_203).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_018_378_217, 11, 1_018_097, 1_493_480, 262_319, 515_917, 1_681_211
						>>), {NATURAL_32} 210, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_723_933).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							929_829_291, 11, 650_193, 1_191_257, 1_105_031, 1_588_506, 1_362_363
						>>), {NATURAL_32} 212, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_752_967).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							843_292_154, 11, 198_146, 635_417, 235_074, 886_647, 1_450_755
						>>), {NATURAL_32} 214, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_860_487).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							546_345_357, 11, 963_300, 1_091_445, 1_717_982, 966_795, 343_475
						>>), {NATURAL_32} 216, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_896_113).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							455_382_105, 11, 271_351, 1_505_185, 1_234_170, 1_785_610, 31_429
						>>), {NATURAL_32} 218, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(1_971_191).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							274_452_539, 11, 1_713_298, 815_109, 845_285, 928_185, 1_136_071
						>>), {NATURAL_32} 220, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_030_621).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							140_719_744, 11, 203_881, 650_291, 703_660, 1_561_431, 1_598_299
						>>), {NATURAL_32} 222, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_047_757).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							103_601_115, 11, 820_867, 2_047_568, 485_669, 35_721, 357_624
						>>), {NATURAL_32} 224, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_082_233).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							30_773_029, 11, 1_402_850, 1_000_511, 222_506, 1_239_769, 1_923_837
						>>), {NATURAL_32} 226, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_108_303).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_249_534_376, 10, 354_085, 1_732_724, 646_419, 1_464_723, 230_364
						>>), {NATURAL_32} 228, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_146_189).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_098_700_973, 10, 443_107, 1_858_973, 1_587_588, 2_110_252, 786_121
						>>), {NATURAL_32} 230, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_196_323).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_907_104_307, 10, 1_155_831, 1_087_289, 1_685_820, 158_895, 1_433_808
						>>), {NATURAL_32} 232, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_214_143).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_841_091_896, 10, 1_744_019, 821_116, 637_094, 586_383, 1_366_866
						>>), {NATURAL_32} 234, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_238_007).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_754_336_620, 10, 231_863, 1_284_622, 2_197_163, 1_033_252, 973_147
						>>), {NATURAL_32} 236, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_301_253).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_533_115_278, 10, 829_198, 951_864, 2_272_385, 345_842, 852_121
						>>), {NATURAL_32} 238, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_362_333).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_330_713_973, 10, 245_902, 1_518_136, 281_681, 2_317_702, 546_956
						>>), {NATURAL_32} 240, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_405_597).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_193_568_194, 10, 976_651, 1_503_734, 1_535_140, 469_099, 58_799
						>>), {NATURAL_32} 242, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_442_953).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_079_058_528, 10, 255_922, 500_154, 1_889_553, 522_422, 1_351_300
						>>), {NATURAL_32} 244, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_480_609).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_967_119_759, 10, 1_033_117, 1_581_868, 2_226_657, 1_963_110, 1_201_560
						>>), {NATURAL_32} 246, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_528_051).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_830_837_725, 10, 2_336_698, 2_207_976, 219_898, 1_266_901, 2_143_592
						>>), {NATURAL_32} 248, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_572_807).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_706_878_745, 10, 952_413, 1_104_193, 42_424, 1_807_984, 1_186_783
						>>), {NATURAL_32} 250, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_595_317).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_646_149_534, 10, 2_312_978, 149_266, 1_739_589, 2_137_628, 25_824
						>>), {NATURAL_32} 252, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_624_399).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_569_232_282, 10, 1_450_532, 2_043_547, 514_893, 1_559_262, 2_505_603
						>>), {NATURAL_32} 254, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_663_399).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_468_720_198, 10, 1_568_108, 880_106, 2_472_820, 893_662, 494_050
						>>), {NATURAL_32} 256, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_755_591).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_242_431_944, 10, 1_756_518, 153_763, 980_960, 89_389, 2_567_913
						>>), {NATURAL_32} 258, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_782_223).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_179_854_639, 10, 1_997_207, 1_636_871, 2_549_837, 1_930_512, 2_406_577
						>>), {NATURAL_32} 260, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_873_021).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_975_226_520, 10, 2_673_922, 1_341_064, 2_578_320, 1_839_537, 2_739_917
						>>), {NATURAL_32} 262, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_903_591).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_909_211_773, 10, 556_207, 220_163, 154_907, 2_102_006, 2_113_546
						>>), {NATURAL_32} 264, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(2_965_283).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_780_135_319, 10, 1_237_512, 718_379, 1_893_799, 2_395_453, 2_487_270
						>>), {NATURAL_32} 266, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_017_153).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_675_693_956, 10, 1_558_577, 1_093_028, 2_254_225, 2_101_068, 200_227
						>>), {NATURAL_32} 268, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_062_491).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_587_302_565, 10, 1_354_914, 92_392, 832_172, 1_119_247, 2_198_869
						>>), {NATURAL_32} 270, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_125_743).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_468_269_959, 10, 196_414, 539_290, 2_053_019, 2_072_408, 62_737
						>>), {NATURAL_32} 272, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_186_221).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_358_877_339, 10, 3_127_609, 620_306, 592_559, 1_927_013, 2_262_273
						>>), {NATURAL_32} 274, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_221_989).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_296_112_782, 10, 55_959, 2_858_362, 1_879_231, 610_547, 2_850_206
						>>), {NATURAL_32} 276, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_301_453).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_161_538_827, 10, 3_078_396, 1_528_539, 2_933_399, 3_090_780, 2_506_812
						>>), {NATURAL_32} 278, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_381_857).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_031_809_829, 10, 8_906, 1_534_125, 214_970, 391_758, 2_302_181
						>>), {NATURAL_32} 280, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_474_487).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							889_797_680, 10, 501_364, 623_994, 1_843_849, 126_381, 2_138_752
						>>), {NATURAL_32} 282, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_504_383).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							845_566_289, 10, 2_098_121, 424_382, 640_433, 2_830_788, 2_309_458
						>>), {NATURAL_32} 284, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_526_883).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							812_771_891, 10, 2_750_685, 19_846, 999_436, 2_379_703, 3_143_747
						>>), {NATURAL_32} 286, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_590_989).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							721_589_009, 10, 144_452, 2_734_214, 573_585, 611_223, 738_253
						>>), {NATURAL_32} 288, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_648_091).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							643_067_010, 10, 1_164_189, 907_492, 1_402_297, 3_427_269, 2_429_412
						>>), {NATURAL_32} 290, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_732_623).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							531_236_290, 10, 2_450_846, 938_049, 1_550_802, 3_647_758, 1_905_639
						>>), {NATURAL_32} 292, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_802_499).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							442_548_350, 10, 1_945_925, 538_950, 437_057, 1_808_888, 2_267_096
						>>), {NATURAL_32} 294, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_904_567).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							318_706_514, 10, 3_848_163, 3_093_678, 3_189_885, 173_820, 224_457
						>>), {NATURAL_32} 296, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_960_091).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							254_018_701, 10, 2_228_652, 1_041_628, 1_180_801, 3_158_204, 2_600_611
						>>), {NATURAL_32} 298, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(3_992_003).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							217_654_189, 10, 3_564_071, 643_005, 2_359_127, 3_679_315, 1_252_659
						>>), {NATURAL_32} 300, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(4_028_033).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							177_289_636, 10, 1_084_118, 285_085, 2_864_006, 3_863_417, 2_861_410
						>>), {NATURAL_32} 302, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(4_088_459).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							111_191_236, 10, 2_085_346, 3_055_120, 2_027_164, 2_563_432, 2_967_267
						>>), {NATURAL_32} 304, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(4_137_131).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							59_354_215, 10, 625_318, 1_664_659, 1_842_783, 2_008_302, 1_274_986
						>>), {NATURAL_32} 306, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(4_235_339).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_211_741_852, 9, 333_550, 1_717_648, 2_948_531, 2_916_538, 470_329
						>>), {NATURAL_32} 308, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(4_305_589).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_072_946_366, 9, 2_295_063, 2_981_395, 4_258_195, 4_184_674, 585_172
						>>), {NATURAL_32} 310, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(4_347_221).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_992_809_428, 9, 4_260_169, 844_501, 353_279, 2_945_067, 3_385_991
						>>), {NATURAL_32} 312, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(4_384_811).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_921_760_179, 9, 2_237_327, 2_024_305, 414_134, 3_152_219, 1_511_780
						>>), {NATURAL_32} 314, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(4_460_543).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_782_254_920, 9, 3_924_930, 1_462_724, 243_251, 4_063_167, 481_700
						>>), {NATURAL_32} 316, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(4_536_899).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_646_315_289, 9, 3_060_842, 2_871_176, 2_271_545, 1_791_299, 4_477_066
						>>), {NATURAL_32} 318, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(4_575_317).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_579_633_965, 9, 3_319_950, 1_240_624, 4_053_109, 2_119_942, 1_109_408
						>>), {NATURAL_32} 320, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(4_613_879).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_513_819_414, 9, 4_059_826, 4_129_181, 2_167_678, 2_660_282, 3_334_636
						>>), {NATURAL_32} 322, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(4_708_819).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_356_377_344, 9, 524_368, 4_440_376, 2_516_162, 2_587_092, 1_048_051
						>>), {NATURAL_32} 324, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(4_862_021).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_115_283_918, 9, 1_802_753, 2_544_000, 221_309, 2_606_480, 2_650_263
						>>), {NATURAL_32} 326, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(4_915_073).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_035_299_623, 9, 4_108_567, 997_362, 2_749_716, 3_740_085, 3_882_455
						>>), {NATURAL_32} 328, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(5_008_643).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_898_357_726, 9, 2_560_245, 3_296_781, 1_887_745, 4_643_318, 2_506_481
						>>), {NATURAL_32} 330, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(5_048_993).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_840_870_883, 9, 3_323_246, 3_697_029, 3_102_815, 505_394, 1_067_474
						>>), {NATURAL_32} 332, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(5_143_823).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_709_316_680, 9, 5_018_914, 1_043_122, 2_854_515, 4_908_579, 2_575_820
						>>), {NATURAL_32} 334, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(5_184_713).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_654_076_367, 9, 2_024_932, 3_774_435, 2_130_452, 2_206_919, 1_228_418
						>>), {NATURAL_32} 336, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(5_244_091).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_575_393_462, 9, 56_767, 2_620_415, 4_457_090, 3_969_553, 1_024_881
						>>), {NATURAL_32} 338, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(5_303_773).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_498_083_051, 9, 4_214_939, 1_797_093, 924_647, 1_618_127, 4_570_271
						>>), {NATURAL_32} 340, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(5_391_563).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_387_472_845, 9, 3_283_148, 28_406, 3_236_877, 3_557_949, 4_404_223
						>>), {NATURAL_32} 342, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(5_475_599).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_284_915_018, 9, 2_097_680, 4_318_812, 2_974_279, 1_901_754, 1_776_874
						>>), {NATURAL_32} 344, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(5_517_797).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_234_594_595, 9, 2_121_230, 2_239_919, 2_865_873, 3_634_807, 1_121_442
						>>), {NATURAL_32} 346, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(5_588_447).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_152_046_877, 9, 3_040_000, 1_961_441, 2_694_599, 1_816_718, 853_121
						>>), {NATURAL_32} 348, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(5_659_637).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							2_070_952_818, 9, 4_962_450, 3_108_498, 783_825, 4_969_534, 5_098_891
						>>), {NATURAL_32} 350, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(5_692_987).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							2_033_660_719, 9, 2_455_098, 4_966_471, 1_778_402, 208_551, 2_971_179
						>>), {NATURAL_32} 352, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(5_740_807).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_980_944_264, 9, 843_660, 5_462_126, 2_738_225, 1_462_665, 5_489_250
						>>), {NATURAL_32} 354, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(5_827_387).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_887_700_341, 9, 183_077, 3_885_292, 5_091_490, 3_372_371, 3_567_691
						>>), {NATURAL_32} 356, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(5_904_851).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_806_591_747, 9, 2_140_619, 2_659_247, 4_763_767, 4_097_919, 1_962_089
						>>), {NATURAL_32} 358, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(5_973_127).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_736_847_701, 9, 288_983, 885_702, 4_329_116, 5_317_640, 1_176_830
						>>), {NATURAL_32} 360, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(6_066_353).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_644_152_471, 9, 6_055_725, 3_760_030, 3_534_724, 1_877_457, 4_688_374
						>>), {NATURAL_32} 362, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(6_125_621).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_586_688_950, 9, 906_975, 132_156, 2_161_993, 1_062_865, 3_006_605
						>>), {NATURAL_32} 364, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(6_310_063).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_414_769_202, 9, 4_124_456, 2_515_874, 3_273_942, 4_098_639, 3_748_447
						>>), {NATURAL_32} 366, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(6_426_209).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_311_572_581, 9, 2_259_684, 2_501_591, 3_262_812, 5_961_528, 3_903_587
						>>), {NATURAL_32} 368, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(6_482_107).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_263_224_973, 9, 3_812_462, 5_564_809, 4_262_001, 6_275_348, 2_273_184
						>>), {NATURAL_32} 370, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(6_522_907).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_228_459_148, 9, 2_894_490, 4_948_951, 556_477, 2_640_406, 6_070_227
						>>), {NATURAL_32} 372, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(6_682_189).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_096_798_339, 9, 5_001_958, 4_818_373, 135_701, 626_127, 5_840_823
						>>), {NATURAL_32} 374, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(6_765_137).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_030_689_378, 9, 5_870_438, 1_465_076, 4_147_859, 5_018_416, 2_294_157
						>>), {NATURAL_32} 376, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(6_859_157).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							957_689_410, 9, 1_135_014, 4_208_241, 4_177_639, 5_250_259, 5_331_852
						>>), {NATURAL_32} 378, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(6_969_551).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							874_490_107, 9, 1_723_880, 1_464_408, 1_686_677, 1_765_070, 2_296_020
						>>), {NATURAL_32} 380, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(7_064_963).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							804_676_823, 9, 6_534_755, 5_645_494, 4_506_051, 119_176, 960_464
						>>), {NATURAL_32} 382, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(7_112_873).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							770_327_278, 9, 5_904_877, 5_762_828, 2_325_507, 4_698_759, 4_802_782
						>>), {NATURAL_32} 384, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(7_182_391).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							721_300_548, 9, 7_079_869, 2_922_451, 5_101_534, 2_243_872, 5_738_546
						>>), {NATURAL_32} 386, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(7_225_343).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							691_480_685, 9, 3_113_554, 4_709_188, 2_063_025, 2_588_507, 5_277_272
						>>), {NATURAL_32} 388, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(7_268_407).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							661_936_881, 9, 6_607_166, 1_368_589, 391_400, 3_709_056, 5_943_921
						>>), {NATURAL_32} 390, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(7_338_677).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							614_473_059, 9, 1_841_251, 663_373, 1_477_097, 7_309_501, 6_115_141
						>>), {NATURAL_32} 392, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(7_376_647).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							589_202_573, 9, 1_758_742, 5_179_171, 1_690_989, 111_436, 4_416_016
						>>), {NATURAL_32} 394, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(7_452_899).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							539_231_720, 9, 2_097_472, 2_134_276, 365_922, 4_157_265, 4_162_060
						>>), {NATURAL_32} 396, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(7_535_009).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							486_552_808, 9, 12_166, 4_846_385, 7_209_494, 3_199_244, 3_681_019
						>>), {NATURAL_32} 398, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(7_617_551).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							434_741_375, 9, 6_286_083, 4_860_998, 4_157_188, 1_143_799, 7_116_743
						>>), {NATURAL_32} 400, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(7_745_053).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							356_879_117, 9, 4_207_934, 7_105_021, 5_846_014, 5_107_854, 6_816_905
						>>), {NATURAL_32} 402, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(7_806_427).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							320_306_377, 9, 1_432_446, 5_625_247, 6_163_346, 5_127_947, 2_844_150
						>>), {NATURAL_32} 404, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(7_851_203).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							293_985_125, 9, 359_255, 6_080_111, 3_537_066, 7_142_686, 5_577_628
						>>), {NATURAL_32} 406, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(7_986_227).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							216_399_212, 9, 6_363_397, 7_048_472, 1_460_665, 5_012_601, 3_830_603
						>>), {NATURAL_32} 408, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(8_065_591).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							172_008_157, 9, 4_072_884, 4_051_621, 2_569_696, 1_529_844, 6_462_821
						>>), {NATURAL_32} 410, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(8_145_307).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							128_291_031, 9, 2_390_507, 4_394_445, 6_112_864, 517_908, 471_277
						>>), {NATURAL_32} 412, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(8_236_819).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							79_148_126, 9, 3_584_597, 5_091_056, 3_203_498, 3_426_922, 6_042_042
						>>), {NATURAL_32} 414, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(8_363_639).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							12_822_294, 9, 4_420_489, 475_911, 3_040_975, 3_935_801, 6_087_943
						>>), {NATURAL_32} 416, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(8_444_827).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_237_782_284, 8, 4_995_180, 2_678_251, 227_818, 810_028, 6_590_741
						>>), {NATURAL_32} 418, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(8_538_059).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_144_608_260, 8, 323_619, 1_425_467, 5_415_362, 582_797, 6_997_092
						>>), {NATURAL_32} 420, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(8_678_867).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_007_682_581, 8, 7_606_998, 3_418_568, 3_978_143, 701_971, 2_099_633
						>>), {NATURAL_32} 422, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(8_761_591).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_929_291_749, 8, 1_787_706, 6_047_685, 3_645_477, 3_249_733, 1_514_946
						>>), {NATURAL_32} 424, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(8_820_899).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_873_995_304, 8, 8_010_382, 1_354_264, 1_035_274, 7_303_414, 5_337_680
						>>), {NATURAL_32} 426, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(8_999_999).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_711_432_931, 8, 1_967_773, 7_009_765, 2_835_970, 5_814_870, 6_455_881
						>>), {NATURAL_32} 428, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(9_090_209).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_631_978_502, 8, 4_388_648, 5_521_212, 3_965_783, 2_412_878, 5_932_963
						>>), {NATURAL_32} 430, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(9_180_851).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_553_716_234, 8, 7_509_879, 2_752_707, 1_838_306, 7_997_552, 7_159_311
						>>), {NATURAL_32} 432, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(9_272_009).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_476_551_696, 8, 2_027_129, 8_857_949, 4_852_994, 6_237_190, 8_366_849
						>>), {NATURAL_32} 434, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(9_388_087).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_380_461_578, 8, 4_611_537, 3_306_489, 6_279_498, 955_532, 3_553_668
						>>), {NATURAL_32} 436, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(9_492_557).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_295_989_917, 8, 4_331_532, 7_153_283, 9_423_299, 35_615, 3_968_373
						>>), {NATURAL_32} 438, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(9_603_701).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_208_139_478, 8, 2_112_949, 4_163_123, 4_667_282, 5_199_851, 1_878_559
						>>), {NATURAL_32} 440, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(9_734_399).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_107_399_715, 8, 2_097_337, 3_333_853, 4_182_160, 4_532_192, 427_593
						>>), {NATURAL_32} 442, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(9_922_331).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_967_196_608, 8, 8_520_304, 6_403_643, 1_908_355, 1_240_896, 1_899_017
						>>), {NATURAL_32} 444, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(10_036_223).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_884_784_891, 8, 9_500_075, 7_214_961, 4_629_331, 1_572_027, 2_875_544
						>>), {NATURAL_32} 446, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(10_137_847).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_812_813_482, 8, 6_658_015, 8_434_145, 4_088_158, 3_116_693, 2_063_494
						>>), {NATURAL_32} 448, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(10_220_773).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_755_144_670, 8, 2_242_636, 8_912_975, 7_482_233, 1_675_757, 6_288_763
						>>), {NATURAL_32} 450, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(10_323_353).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_685_089_865, 8, 452_448, 7_426_067, 8_754_518, 7_170_847, 1_679_263
						>>), {NATURAL_32} 452, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(10_400_609).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_633_241_815, 8, 9_916_388, 9_048_154, 2_366_261, 223_413, 5_868_545
						>>), {NATURAL_32} 454, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(10_575_503).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_518_665_496, 8, 1_313_078, 7_277_982, 4_762_646, 7_740_368, 3_444_021
						>>), {NATURAL_32} 456, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(10_614_563).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_493_592_349, 8, 6_683_844, 4_568_724, 5_553_750, 8_671_003, 635_339
						>>), {NATURAL_32} 458, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(10_791_029).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_382_578_843, 8, 137_754, 5_535_534, 4_677_380, 6_253_959, 6_067_871
						>>), {NATURAL_32} 460, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(10_916_407).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_305_885_350, 8, 4_819_345, 287_208, 8_613_195, 4_063_972, 602_883
						>>), {NATURAL_32} 462, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(10_995_847).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_258_197_188, 8, 6_586_966, 4_258_348, 1_487_846, 1_505_229, 2_980_396
						>>), {NATURAL_32} 464, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(11_062_267).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_218_850_715, 8, 2_807_700, 8_704_994, 5_757_199, 4_410_691, 10_019_943
						>>), {NATURAL_32} 466, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(11_135_533).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_175_993_190, 8, 7_787_091, 7_444_588, 10_331_244, 8_682_754, 9_262_767
						>>), {NATURAL_32} 468, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(11_242_573).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							2_114_383_484, 8, 304_410, 4_161_434, 2_726_019, 1_888_087, 9_746_764
						>>), {NATURAL_32} 470, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(11_329_931).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							2_064_964_996, 8, 923_447, 7_105_094, 3_366_987, 6_399_583, 6_372_863
						>>), {NATURAL_32} 472, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(11_431_097).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							2_008_679_155, 8, 8_305_921, 7_185_273, 4_213_752, 10_003_521, 6_267_440
						>>), {NATURAL_32} 474, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(11_553_137).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_942_091_438, 8, 8_753_469, 7_537_670, 9_656_914, 1_317_957, 10_409_921
						>>), {NATURAL_32} 476, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(11_716_829).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_854_955_523, 8, 6_607_882, 5_538_918, 1_661_952, 9_786_886, 7_126_283
						>>), {NATURAL_32} 478, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(11_923_193).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_748_514_012, 8, 2_617_816, 10_047_562, 9_421_048, 5_860_739, 808_572
						>>), {NATURAL_32} 480, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(11_985_443).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_717_125_376, 8, 4_178_702, 6_439_876, 6_825_202, 8_983_105, 6_509_404
						>>), {NATURAL_32} 482, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(12_027_023).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_696_340_281, 8, 1_320_085, 4_990_709, 9_458_348, 5_473_199, 10_185_964
						>>), {NATURAL_32} 484, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(12_215_009).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_604_135_523, 8, 7_499_137, 9_359_399, 10_269_690, 548_871, 3_886_624
						>>), {NATURAL_32} 486, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(12_348_187).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_540_512_360, 8, 10_146_407, 11_041_322, 5_292_212, 6_036_068, 555_133
						>>), {NATURAL_32} 488, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(12_446_783).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_494_287_167, 8, 827_161, 8_105_194, 2_519_463, 11_763_287, 8_989_353
						>>), {NATURAL_32} 490, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(12_503_287).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_468_124_764, 8, 6_339_855, 7_350_040, 106_075, 10_827_830, 528_828
						>>), {NATURAL_32} 492, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(12_559_927).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_442_135_637, 8, 12_032_189, 3_575_346, 6_766_008, 7_236_780, 10_879_031
						>>), {NATURAL_32} 494, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(12_659_363).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_397_072_187, 8, 3_443_239, 8_921_368, 2_174_384, 11_939_857, 6_219_166
						>>), {NATURAL_32} 496, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(12_787_751).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_339_924_565, 8, 11_070_711, 10_368_550, 6_939_959, 1_841_484, 10_412_651
						>>), {NATURAL_32} 498, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(12_873_719).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_302_295_937, 8, 8_018_869, 3_313_168, 5_802_560, 9_595_337, 3_704_901
						>>), {NATURAL_32} 500, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(13_032_091).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_234_275_404, 8, 7_409_357, 1_633_761, 134_507, 7_286_956, 5_172_385
						>>), {NATURAL_32} 502, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(13_104_391).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_203_769_275, 8, 9_831_439, 4_162_572, 3_124_260, 12_952_036, 2_315_628
						>>), {NATURAL_32} 504, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(13_205_947).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_161_483_047, 8, 3_034_521, 8_945_546, 2_455_457, 10_385_022, 4_723_210
						>>), {NATURAL_32} 506, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(13_329_737).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_110_810_330, 8, 2_791_982, 13_269_146, 12_040_642, 5_591_606, 8_626_062
						>>), {NATURAL_32} 508, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(13_483_583).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_049_131_081, 8, 7_187_902, 264_026, 5_673_368, 13_088_149, 11_940_515
						>>), {NATURAL_32} 510, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(13_571_807).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_014_391_585, 8, 6_276_284, 5_328_980, 7_173_011, 12_434_811, 604_964
						>>), {NATURAL_32} 512, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(13_682_597).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							971_400_926, 8, 12_314_435, 5_893_062, 12_029_161, 10_860_025, 623_175
						>>), {NATURAL_32} 514, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(13_793_771).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							928_955_446, 8, 5_104_515, 12_398_042, 4_486_378, 6_544_424, 11_022_285
						>>), {NATURAL_32} 516, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(13_912_891).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							884_229_036, 8, 9_796_868, 1_443_175, 9_058_098, 8_210_816, 7_326_460
						>>), {NATURAL_32} 518, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(14_062_379).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							829_172_370, 8, 5_941_701, 11_420_595, 3_990_417, 4_628_746, 446_285
						>>), {NATURAL_32} 520, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(14_197_823).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							780_289_244, 8, 7_224_750, 8_304_893, 9_021_308, 12_533_147, 8_547_539
						>>), {NATURAL_32} 522, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(14_333_747).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							732_161_621, 8, 9_176_943, 707_654, 10_004_661, 10_398_524, 13_720_825
						>>), {NATURAL_32} 524, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(14_439_991).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							695_173_905, 8, 6_289_969, 11_879_791, 409_337, 8_885_289, 12_199_416
						>>), {NATURAL_32} 526, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(14_607_683).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							637_888_519, 8, 308_494, 14_100_974, 129_537, 9_374_273, 9_363_669
						>>), {NATURAL_32} 528, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(14_745_551).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							591_767_288, 8, 4_011_955, 11_308_057, 243_000, 2_960_635, 9_676_599
						>>), {NATURAL_32} 530, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(14_837_903).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							561_351_958, 8, 6_813_329, 4_197_725, 7_982_741, 9_926_848, 10_007_242
						>>), {NATURAL_32} 532, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(14_976_851).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							516_297_370, 8, 11_587_910, 12_773_237, 10_618_644, 214_968, 5_094_305
						>>), {NATURAL_32} 534, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(15_093_209).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							479_205_912, 8, 8_495_940, 3_515_659, 1_228_238, 14_260_972, 4_536_405
						>>), {NATURAL_32} 536, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(15_280_277).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							420_758_344, 8, 1_209_459, 10_155_471, 2_981_495, 3_391_975, 5_922_565
						>>), {NATURAL_32} 538, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(15_350_723).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							399_117_408, 8, 12_115_579, 3_057_890, 12_899_021, 13_246_772, 12_472_852
						>>), {NATURAL_32} 540, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(15_413_467).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							380_009_076, 8, 10_023_470, 9_798_526, 3_142_540, 9_290_996, 6_196_790
						>>), {NATURAL_32} 542, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(15_499_933).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							353_929_833, 8, 1_485_855, 1_124_304, 941_046, 8_948_400, 11_855_337
						>>), {NATURAL_32} 544, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(15_657_749).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							307_073_140, 8, 4_744_070, 2_276_284, 14_305_560, 6_549_576, 2_797_246
						>>), {NATURAL_32} 546, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(15_959_989).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							219_922_660, 8, 1_730_255, 7_628_405, 15_390_385, 1_071_708, 843_586
						>>), {NATURAL_32} 548, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(16_040_021).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							197_395_528, 8, 12_281_689, 8_409_351, 12_135_721, 3_816_485, 10_676_020
						>>), {NATURAL_32} 550, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(16_128_247).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							172_821_053, 8, 4_853_594, 5_557_720, 4_003_758, 13_560_892, 10_603_788
						>>), {NATURAL_32} 552, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(16_192_567).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							155_074_135, 8, 3_937_041, 5_652_632, 863_854, 6_613_602, 2_066_641
						>>), {NATURAL_32} 554, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(16_402_499).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							98_119_028, 8, 13_915_057, 628_085, 13_021_180, 10_666_275, 7_021_407
						>>), {NATURAL_32} 556, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(16_524_161).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							65_774_168, 8, 15_209_597, 14_801_038, 6_949_331, 9_003_844, 11_671_157
						>>), {NATURAL_32} 558, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(16_687_189).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							23_171_249, 8, 6_359_723, 1_682_309, 11_325_868, 16_317_081, 10_397_122
						>>), {NATURAL_32} 560, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(16_777_207).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							2_304, 8, 2_304, 5_308_416, 6_561, 15_116_544, 15_812_851
						>>), {NATURAL_32} 562, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(16_966_097).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_199_336_849, 7, 2_544_755, 5_412_192, 15_328_591, 8_469_237, 15_352_350
						>>), {NATURAL_32} 564, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(17_065_157).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_150_029_024, 7, 11_612_889, 12_957_493, 11_847_350, 2_595_658, 14_038_698
						>>), {NATURAL_32} 566, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(17_189_267).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_089_054_435, 7, 14_839_813, 13_543_474, 4_929_718, 16_809_162, 5_224_219
						>>), {NATURAL_32} 568, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(17_288_963).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_040_708_364, 7, 7_304_472, 15_374_114, 340_865, 3_419_761, 5_215_754
						>>), {NATURAL_32} 570, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(17_547_577).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_917_858_216, 7, 13_358_508, 2_636_104, 9_039_540, 10_783_469, 14_223_162
						>>), {NATURAL_32} 572, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(17_757_787).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_820_637_879, 7, 15_340_629, 3_476_011, 11_364_525, 5_588_303, 4_534_416
						>>), {NATURAL_32} 574, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(17_842_151).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_782_264_427, 7, 12_851_056, 14_336_486, 5_411_364, 13_483_425, 5_725_727
						>>), {NATURAL_32} 576, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(17_943_671).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_736_565_832, 7, 6_429_927, 2_705_242, 3_628_289, 8_061_214, 14_373_557
						>>), {NATURAL_32} 578, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(18_045_479).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_691_253_966, 7, 143_294, 15_460_813, 16_326_671, 7_869_319, 305_034
						>>), {NATURAL_32} 580, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(18_147_599).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_646_313_976, 7, 12_133_932, 304_070, 12_645_748, 14_695_594, 6_727_844
						>>), {NATURAL_32} 582, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(18_249_983).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_601_762_694, 7, 6_221_291, 7_260_179, 345_137, 14_211_985, 15_483_640
						>>), {NATURAL_32} 584, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(18_369_787).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_550_261_833, 7, 14_806_925, 3_569_369, 13_928_578, 10_914_524, 4_183_251
						>>), {NATURAL_32} 586, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(18_593_119).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_456_028_546, 7, 18_549_926, 6_323_349, 8_504_753, 17_048_873, 7_099_625
						>>), {NATURAL_32} 588, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(18_818_243).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_363_302_823, 7, 4_407_892, 14_714_538, 8_915_516, 5_521_054, 6_272_736
						>>), {NATURAL_32} 590, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(18_948_593).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_310_620_521, 7, 12_585_278, 17_795_514, 17_023_867, 6_306_617, 7_176_229
						>>), {NATURAL_32} 592, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(19_079_399).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_258_477_551, 7, 2_102_521, 12_283_535, 661_562, 2_572_505, 3_280_191
						>>), {NATURAL_32} 594, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(19_307_227).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_169_345_837, 7, 8_762_902, 18_538_382, 1_395_141, 12_572_193, 4_428_294
						>>), {NATURAL_32} 596, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(19_492_189).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_098_516_733, 7, 6_685_716, 12_336_660, 676_448, 509_366, 15_568_055
						>>), {NATURAL_32} 598, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(19_642_543).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_041_923_252, 7, 12_892_922, 1_527_795, 3_221_160, 14_534_792, 9_776_437
						>>), {NATURAL_32} 600, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(19_793_597).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_985_932_081, 7, 19_550_344, 8_960_576, 3_701_509, 7_558_753, 17_056_209
						>>), {NATURAL_32} 602, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(19_891_591).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_950_063_434, 7, 18_275_231, 18_304_478, 7_043_774, 15_723_257, 7_773_448
						>>), {NATURAL_32} 604, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(20_088_323).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_879_110_304, 7, 16_154_497, 7_640_195, 6_985_349, 11_017_917, 17_432_681
						>>), {NATURAL_32} 606, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(20_249_951).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_821_849_336, 7, 1_977_684, 16_718_059, 11_299_910, 7_784_350, 19_947_503
						>>), {NATURAL_32} 608, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(20_385_221).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_774_624_349, 7, 14_070_886, 4_680_176, 11_138_088, 5_115_150, 1_566_791
						>>), {NATURAL_32} 610, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(20_439_437).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_755_872_121, 7, 2_685_526, 14_990_663, 13_976_420, 17_843_659, 4_195_118
						>>), {NATURAL_32} 612, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(20_684_303).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_672_402_504, 7, 13_316_575, 6_827_753, 4_628_633, 11_664_821, 9_299_706
						>>), {NATURAL_32} 614, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(20_830_087).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_623_639_816, 7, 3_969_374, 10_484_902, 4_395_435, 11_177_186, 12_598_524
						>>), {NATURAL_32} 616, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(21_040_553).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_554_433_861, 7, 2_694_484, 11_848_629, 16_086_780, 12_248_432, 2_559_832
						>>), {NATURAL_32} 618, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(21_159_991).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_515_772_277, 7, 20_649_114, 7_980_135, 6_877_584, 17_024_382, 4_737_725
						>>), {NATURAL_32} 620, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(21_427_577).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_430_720_264, 7, 9_451_896, 19_795_061, 12_443_750, 10_745_727, 7_675_620
						>>), {NATURAL_32} 622, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(21_538_877).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_395_965_944, 7, 8_730_773, 9_930_251, 5_758_329, 16_691_922, 4_723_332
						>>), {NATURAL_32} 624, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(21_622_499).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_370_089_692, 7, 13_712_494, 18_643_685, 7_268_788, 21_441_970, 13_836_186
						>>), {NATURAL_32} 626, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(21_715_591).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_341_517_434, 7, 16_995_869, 9_371_848, 13_552_826, 4_108_774, 12_309_264
						>>), {NATURAL_32} 628, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(21_864_967).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_296_178_625, 7, 9_433_764, 21_275_946, 12_013_435, 14_307_052, 15_638_042
						>>), {NATURAL_32} 630, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(22_061_773).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_237_381_127, 7, 14_983_334, 4_572_378, 6_148_021, 22_009_164, 8_930_884
						>>), {NATURAL_32} 632, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(22_297_283).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_168_384_677, 7, 13_888_960, 5_195_174, 17_578_513, 19_791_077, 5_767_502
						>>), {NATURAL_32} 634, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(22_382_357).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							2_143_817_863, 7, 19_937_109, 14_932_524, 2_234_282, 3_075_265, 14_890_570
						>>), {NATURAL_32} 636, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(22_610_009).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							2_078_988_064, 7, 21_675_595, 21_415_852, 10_464_839, 20_283_028, 4_278_622
						>>), {NATURAL_32} 638, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(22_896_221).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_999_311_051, 7, 13_373_969, 12_190_619, 22_891_879, 17_939_279, 4_395_254
						>>), {NATURAL_32} 640, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(22_953_677).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_983_555_664, 7, 2_629_697, 6_134_665, 6_877_365, 370_689, 2_996_397
						>>), {NATURAL_32} 642, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(23_039_999).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_960_032_457, 7, 9_527_482, 17_360_120, 22_316_582, 4_134_859, 13_684_881
						>>), {NATURAL_32} 644, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(23_184_221).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_921_122_003, 7, 5_886_411, 19_254_918, 13_836_907, 6_011_964, 9_218_163
						>>), {NATURAL_32} 646, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(23_483_491).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_841_905_116, 7, 20_971_934, 18_046_739, 1_866_004, 1_407_151, 8_033_938
						>>), {NATURAL_32} 648, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(23_755_867).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_771_542_003, 7, 18_911_236, 9_268_166, 1_120_619, 14_006_522, 17_862_354
						>>), {NATURAL_32} 650, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(23_970_767).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_717_155_222, 7, 4_200_003, 9_677_010, 4_839_549, 12_557_929, 5_399_114
						>>), {NATURAL_32} 652, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(24_147_371).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_673_185_016, 7, 20_882_629, 11_504_019, 7_781_494, 9_439_196, 21_326_945
						>>), {NATURAL_32} 654, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(24_324_623).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_629_695_465, 7, 13_833_648, 5_045_937, 2_429_897, 21_627_441, 13_384_486
						>>), {NATURAL_32} 656, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(24_403_591).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_610_523_747, 7, 24_338_871, 15_664_339, 2_360_833, 22_175_082, 3_879_670
						>>), {NATURAL_32} 658, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(24_542_107).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_577_193_072, 7, 98_571, 22_109_776, 19_086_389, 15_611_713, 22_969_009
						>>), {NATURAL_32} 660, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(24_681_023).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_544_141_888, 7, 469_294, 8_090_207, 3_835_768, 17_176_310, 15_837_432
						>>), {NATURAL_32} 662, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(24_800_351).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_516_046_752, 7, 4_506_573, 19_167_972, 10_515_366, 1_813_428, 9_998_969
						>>), {NATURAL_32} 664, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(24_960_007).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_478_876_760, 7, 1_846_092, 16_316_684, 13_911_230, 9_290_846, 13_423_649
						>>), {NATURAL_32} 666, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(25_060_027).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_455_832_097, 7, 9_702_679, 3_807_248, 20_617_232, 16_756_272, 19_226_111
						>>), {NATURAL_32} 668, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(25_160_231).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_432_928_766, 7, 17_728_026, 19_416_540, 6_920_888, 17_217_436, 11_966_684
						>>), {NATURAL_32} 670, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(25_310_897).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_398_832_812, 7, 17_425_703, 15_315_342, 22_599_520, 23_930_590, 24_344_691
						>>), {NATURAL_32} 672, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(25_553_009).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_344_884_671, 7, 2_061_784, 5_791_434, 20_382_646, 7_034_019, 17_571_946
						>>), {NATURAL_32} 674, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(25_796_237).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_291_707_538, 7, 12_791_954, 17_292_669, 11_934_884, 24_372_785, 5_713_508
						>>), {NATURAL_32} 676, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(25_938_613).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_261_042_505, 7, 15_096_151, 382_844, 10_655_075, 16_364_886, 21_498_468
						>>), {NATURAL_32} 678, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(26_050_807).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_237_114_227, 7, 22_634_948, 14_405_002, 11_906_671, 523_677, 23_970_726
						>>), {NATURAL_32} 680, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(26_173_447).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_211_192_747, 7, 2_521_988, 14_116_674, 17_574_420, 20_942_349, 11_924_420
						>>), {NATURAL_32} 682, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(26_522_491).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_138_730_016, 7, 24_846_245, 7_955_976, 25_113_470, 11_469_125, 17_921_510
						>>), {NATURAL_32} 684, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(26_718_557).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_098_856_482, 7, 19_998_176, 21_708_667, 21_988_263, 12_863_212, 14_728_054
						>>), {NATURAL_32} 686, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(26_873_831).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_067_691_570, 7, 22_028_167, 14_115_097, 26_743_819, 18_121_666, 1_306_333
						>>), {NATURAL_32} 688, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(27_071_173).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_028_599_144, 7, 17_721_962, 18_086_045, 4_448_206, 6_778_248, 17_109_794
						>>), {NATURAL_32} 690, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(27_342_437).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							975_784_103, 7, 2_204_687, 7_084_916, 26_188_991, 23_294_220, 12_207_587
						>>), {NATURAL_32} 692, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(27_405_221).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							963_709_073, 7, 19_752_820, 11_478_990, 10_695_426, 3_898_674, 11_136_619
						>>), {NATURAL_32} 694, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(27_741_253).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							900_010_309, 7, 22_814_334, 18_996_212, 3_491_753, 15_142_678, 23_044_058
						>>), {NATURAL_32} 696, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(27_878_399).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							874_453_949, 7, 1_693_850, 22_389_415, 14_153_297, 6_836_183, 8_279_506
						>>), {NATURAL_32} 698, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(28_089_991).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							835_514_521, 7, 25_288_664, 16_445_232, 11_696_848, 25_574_285, 13_929_809
						>>), {NATURAL_32} 700, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(28_259_807).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							804_684_944, 7, 27_736_439, 20_013_980, 18_598_559, 2_075_789, 18_482_956
						>>), {NATURAL_32} 702, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(28_515_551).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							758_948_305, 7, 17_634_646, 6_719_962, 22_593_080, 6_860_171, 3_762_435
						>>), {NATURAL_32} 704, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(28_793_731).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							710_121_765, 7, 4_701_377, 13_968_599, 2_557_801, 3_326_985, 22_617_063
						>>), {NATURAL_32} 706, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(29_052_091).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							665_611_551, 7, 24_309_919, 17_509_760, 10_626_018, 11_027_039, 21_294_196
						>>), {NATURAL_32} 708, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(29_192_393).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							641_770_438, 7, 3_685_525, 20_024_690, 2_522_199, 10_536_057, 26_885_722
						>>), {NATURAL_32} 710, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(29_322_221).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							619_912_380, 7, 13_923_030, 7_272_187, 17_120_328, 25_633_999, 17_706_894
						>>), {NATURAL_32} 712, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(29_430_589).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							601_815_030, 7, 27_531_891, 12_956_827, 16_125_621, 16_896_446, 6_770_977
						>>), {NATURAL_32} 714, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(29_582_717).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							576_633_513, 7, 5_473_331, 29_290_190, 8_294_754, 18_828_165, 23_693_133
						>>), {NATURAL_32} 716, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(29_658_907).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							564_118_983, 7, 24_084_688, 812_667, 28_646_386, 12_770_720, 14_312_301
						>>), {NATURAL_32} 718, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(29_964_667).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							514_536_780, 7, 10_019_915, 12_261_702, 24_232_596, 1_172_286, 26_647_023
						>>), {NATURAL_32} 720, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(30_041_357).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							502_259_010, 7, 29_094_602, 1_061_216, 21_630_785, 19_048_797, 3_795_933
						>>), {NATURAL_32} 722, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(30_272_003).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							465_708_371, 7, 26_614_873, 5_103_458, 12_462_092, 8_976_639, 10_315_307
						>>), {NATURAL_32} 724, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(30_393_133).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							446_734_985, 7, 9_535_543, 21_778_276, 10_731_507, 15_776_202, 11_229_428
						>>), {NATURAL_32} 726, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(30_514_567).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							427_865_181, 7, 22_927_916, 25_799_927, 7_241_116, 12_746_089, 15_217_422
						>>), {NATURAL_32} 728, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(30_735_767).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							393_875_773, 7, 22_695_683, 8_080_695, 12_856_589, 17_199_564, 23_998_053
						>>), {NATURAL_32} 730, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(30_980_347).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							356_858_846, 7, 19_679_410, 25_190_153, 4_361_627, 3_660_829, 16_703_210
						>>), {NATURAL_32} 732, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(31_102_913).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							338_527_581, 7, 2_765_302, 26_269_763, 20_075_191, 24_863_371, 29_706_327
						>>), {NATURAL_32} 734, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(31_438_193).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							289_112_586, 7, 19_373_048, 24_710_599, 6_873_834, 23_465_298, 22_876_270
						>>), {NATURAL_32} 736, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(31_809_599).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							235_589_284, 7, 671_431, 13_950_733, 13_800_992, 23_194_060, 26_469_435
						>>), {NATURAL_32} 738, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(31_911_197).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							221_165_021, 7, 18_866_898, 10_966_504, 7_947_812, 3_180_161, 21_499_208
						>>), {NATURAL_32} 740, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(31_979_021).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							211_586_800, 7, 9_778_482, 30_357_400, 29_656_675, 19_770_811, 19_592_843
						>>), {NATURAL_32} 742, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(32_080_871).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							197_279_441, 7, 28_211_453, 28_596_927, 4_498_198, 4_090_544, 3_469_717
						>>), {NATURAL_32} 744, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(32_330_587).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							162_582_085, 7, 27_329_812, 9_225_538, 2_600_614, 22_467_248, 19_626_437
						>>), {NATURAL_32} 746, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(32_455_793).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							145_386_020, 7, 10_802_620, 10_064_285, 3_844_749, 8_698_210, 9_424_247
						>>), {NATURAL_32} 748, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(32_649_787).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							119_002_941, 7, 17_845_199, 25_904_260, 19_973_308, 20_053_475, 404_729
						>>), {NATURAL_32} 750, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(32_936_117).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							80_630_108, 7, 13_272_086, 17_510_453, 32_312_428, 15_559_771, 12_498_211
						>>), {NATURAL_32} 752, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(33_016_507).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							69_976_217, 7, 2_821_386, 5_156_310, 9_432_278, 59_140, 24_358_169
						>>), {NATURAL_32} 754, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(33_419_957).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							17_282_060, 7, 17_212_800, 32_551_125, 31_688_373, 12_475_465, 22_805_576
						>>), {NATURAL_32} 756, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(33_593_591).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_284_954_277, 6, 28_581_239, 77_143, 27_955_665, 4_976_842, 9_697_259
						>>), {NATURAL_32} 758, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(33_756_091).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_243_650_998, 6, 7_943_739, 27_906_541, 19_915_601, 2_243_349, 29_625_100
						>>), {NATURAL_32} 760, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(33_918_967).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_202_649_277, 6, 21_177_454, 5_290_871, 7_851_908, 26_392_508, 24_253_740
						>>), {NATURAL_32} 762, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(34_117_277).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_153_256_052, 6, 30_307_671, 17_646_760, 4_502_738, 31_532_494, 8_103_204
						>>), {NATURAL_32} 764, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(34_222_499).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_127_280_773, 6, 17_154_921, 33_518_092, 20_627_550, 31_431_147, 32_235_069
						>>), {NATURAL_32} 766, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(34_327_877).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_101_426_578, 6, 3_982_671, 26_463_990, 4_173_912, 9_513_825, 10_851_515
						>>), {NATURAL_32} 768, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(34_433_423).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_075_689_787, 6, 25_222_844, 4_967_182, 33_919_032, 6_538_127, 24_004_130
						>>), {NATURAL_32} 770, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(34_574_399).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 4_041_558_702, 6, 7_741_820, 19_013_930, 18_218_155, 14_416_667, 33_079_686
						>>), {NATURAL_32} 772, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(34_809_991).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_985_137_578, 6, 13_338_403, 839_184, 12_917_156, 23_667_926, 4_633_313
						>>), {NATURAL_32} 774, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(35_105_621).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_915_409_502, 6, 12_081_534, 13_891_379, 6_225_654, 7_516_549, 11_269_640
						>>), {NATURAL_32} 776, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(35_354_867).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_857_527_695, 6, 17_028_389, 14_361_392, 22_130_005, 33_979_232, 14_196_973
						>>), {NATURAL_32} 778, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(35_808_247).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_754_306_273, 6, 33_785_903, 514_984, 8_061_499, 12_642_974, 6_460_330
						>>), {NATURAL_32} 780, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(36_108_077).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_687_467_663, 6, 34_214_210, 8_601_048, 15_264_009, 15_189_166, 33_674_822
						>>), {NATURAL_32} 782, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(36_397_073).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_624_086_418, 6, 112_682, 31_051_720, 10_094_331, 4_477_419, 24_698_905
						>>), {NATURAL_32} 784, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(36_542_021).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_592_674_609, 6, 19_550_839, 28_846_624, 35_371_516, 12_763_513, 2_115_048
						>>), {NATURAL_32} 786, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(36_723_551).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_553_684_816, 6, 35_035_380, 26_873_437, 32_567_388, 22_364_466, 35_892_353
						>>), {NATURAL_32} 788, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(36_917_767).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_512_394_838, 6, 12_506_324, 2_501_455, 1_698_921, 10_952_661, 22_599_617
						>>), {NATURAL_32} 790, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(37_088_099).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_476_538_494, 6, 29_835_911, 5_564_533, 1_840_310, 26_679_266, 33_622_241
						>>), {NATURAL_32} 792, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(37_295_413).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_433_339_028, 6, 5_994_801, 2_835_279, 33_750_098, 4_508_169, 14_430_114
						>>), {NATURAL_32} 794, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(37_527_851).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_385_471_857, 6, 16_792_282, 27_499_369, 29_798_840, 13_663_636, 36_596_647
						>>), {NATURAL_32} 796, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(37_675_019).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_355_470_150, 6, 15_130, 2_866_786, 10_525_311, 33_325_136, 4_528_403
						>>), {NATURAL_32} 798, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(37_908_613).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_308_327_927, 6, 11_294_027, 31_128_490, 13_222_710, 36_706_227, 32_943_503
						>>), {NATURAL_32} 800, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(38_254_081).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_239_663_483, 6, 10_510_224, 28_989_716, 9_262_724, 34_304_304, 19_902_585
						>>), {NATURAL_32} 802, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(38_452_397).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_200_804_063, 6, 26_751_229, 36_375_912, 37_670_517, 7_322_424, 24_985_666
						>>), {NATURAL_32} 804, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(38_613_787).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_169_474_773, 6, 8_836_939, 10_633_170, 31_919_054, 8_196_153, 19_861_305
						>>), {NATURAL_32} 806, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(38_750_609).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_143_119_061, 6, 32_400_306, 23_178_042, 11_036_244, 5_542_070, 21_855_116
						>>), {NATURAL_32} 808, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(39_087_479).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_079_014_949, 6, 34_432_085, 15_164_022, 30_725_467, 28_444_779, 2_317_686
						>>), {NATURAL_32} 810, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(39_262_747).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_046_097_661, 6, 15_327_873, 6_397_528, 19_241_829, 13_257_550, 2_494_335
						>>), {NATURAL_32} 812, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(39_363_067).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 3_027_388_356, 6, 4_392_993, 14_092_227, 11_196_238, 16_319_427, 1_272_318
						>>), {NATURAL_32} 814, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(39_601_813).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_983_244_339, 6, 17_971_492, 37_897_540, 30_403_388, 30_687_670, 12_083_097
						>>), {NATURAL_32} 816, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(39_765_611).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_953_264_754, 6, 281_308, 624_974, 6_419_761, 14_669_434, 32_389_369
						>>), {NATURAL_32} 818, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(39_942_391).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_921_184_990, 6, 21_131_459, 3_028_766, 35_079_661, 14_311_350, 6_369_423
						>>), {NATURAL_32} 820, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(40_106_873).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_891_590_881, 6, 3_531_885, 11_585_273, 17_957_545, 17_638_823, 7_792_344
						>>), {NATURAL_32} 822, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(40_297_079).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_857_669_651, 6, 23_476_922, 29_855_607, 35_974_614, 26_133_178, 7_600_164
						>>), {NATURAL_32} 824, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(40_449_599).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_830_699_787, 6, 7_309_802, 13_092_986, 26_698_055, 32_392_617, 37_052_827
						>>), {NATURAL_32} 826, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(40_576_891).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_808_346_167, 6, 34_393_741, 106_755, 22_684_538, 35_100_545, 18_422_419
						>>), {NATURAL_32} 828, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(40_755_431).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_777_228_214, 6, 15_647_041, 35_941_967, 16_237_717, 13_911_227, 39_708_906
						>>), {NATURAL_32} 830, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(41_075_137).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_722_182_181, 6, 23_153_048, 28_355_019, 10_097_939, 29_569_552, 30_004_049
						>>), {NATURAL_32} 832, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(41_447_723).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_659_102_922, 6, 25_851_827, 30_046_447, 20_573_085, 40_944_285, 179_389
						>>), {NATURAL_32} 834, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(41_731_519).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_611_811_634, 6, 38_352_358, 25_640_584, 27_713_599, 29_052_524, 33_737_541
						>>), {NATURAL_32} 836, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(41_951_513).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_575_592_441, 6, 15_912_970, 9_534_886, 10_471_105, 4_277_410, 9_116_713
						>>), {NATURAL_32} 838, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(42_327_811).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_514_512_555, 6, 19_858_385, 22_720_147, 40_328_752, 27_826_288, 12_040_035
						>>), {NATURAL_32} 840, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(42_745_363).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_447_995_119, 6, 20_430_996, 29_711_816, 4_772_597, 26_191_621, 39_833_301
						>>), {NATURAL_32} 842, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(42_928_703).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_419_197_260, 6, 2_096_996, 33_460_914, 8_473_814, 33_101_251, 10_984_473
						>>), {NATURAL_32} 844, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(43_112_347).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_390_597_193, 6, 26_844_943, 18_430_352, 14_166_195, 4_065_604, 18_042_110
						>>), {NATURAL_32} 846, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(43_217_467).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_374_335_561, 6, 16_438_063, 6_526_392, 17_911_510, 40_021_408, 35_260_031
						>>), {NATURAL_32} 848, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(43_428_019).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_342_000_790, 6, 39_021_434, 21_226_755, 25_397_513, 6_824_902, 370_096
						>>), {NATURAL_32} 850, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(43_731_733).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_295_907_484, 6, 9_257_462, 6_570_407, 6_454_125, 30_597_369, 3_906_105
						>>), {NATURAL_32} 852, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(44_155_961).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_232_585_714, 6, 11_839_079, 10_281_512, 43_173_734, 30_060_222, 42_841_164
						>>), {NATURAL_32} 854, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(44_355_599).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_203_206_162, 6, 36_829_792, 17_926_951, 10_996_680, 7_071_435, 36_213_145
						>>), {NATURAL_32} 856, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(44_568_967).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							{NATURAL_32} 2_172_097_021, 6, 16_346_464, 17_017_077, 29_725_156, 18_783_007, 367_347
						>>), {NATURAL_32} 858, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(44_756_099).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							2_145_057_250, 6, 43_137_891, 7_290_972, 25_063_610, 21_727_316, 658_296
						>>), {NATURAL_32} 860, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(44_916_803).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							2_122_016_035, 6, 27_871_011, 41_823_986, 34_759_722, 34_628_609, 34_188_234
						>>), {NATURAL_32} 862, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(45_077_771).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							2_099_101_659, 6, 12_579_051, 36_440_920, 34_245_142, 3_889_920, 32_423_130
						>>), {NATURAL_32} 864, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(45_360_221).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							2_059_286_933, 6, 31_106_522, 4_286_032, 16_013_747, 42_644_223, 19_842_605
						>>), {NATURAL_32} 866, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(45_724_643).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							2_008_644_000, 6, 42_575_497, 39_882_975, 6_971_267, 6_632_393, 2_891_020
						>>), {NATURAL_32} 868, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(45_968_399).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_975_217_927, 6, 19_906_189, 27_127_911, 15_972_669, 10_250_857, 26_893_811
						>>), {NATURAL_32} 870, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(46_131_263).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_953_081_367, 6, 4_759_837, 16_250_746, 30_065_574, 26_885_676, 36_513_139
						>>), {NATURAL_32} 872, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(46_416_869).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_914_636_719, 6, 24_615_348, 39_447_498, 6_137_062, 35_074_233, 11_848_214
						>>), {NATURAL_32} 874, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(46_621_583).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_887_370_531, 6, 5_781_660, 10_587_766, 25_368_815, 31_735_750, 15_642_710
						>>), {NATURAL_32} 876, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(46_744_553).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_871_106_773, 6, 41_212_973, 581_789, 9_843_771, 1_132_248, 42_030_971
						>>), {NATURAL_32} 878, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(47_059_591).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_829_828_309, 6, 12_544_515, 31_379_957, 15_628_687, 42_330_570, 45_544_785
						>>), {NATURAL_32} 880, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(47_196_899).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_812_009_693, 6, 49_487, 41_921_320, 20_667_295, 5_626_335, 15_932_944
						>>), {NATURAL_32} 882, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(47_485_817).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_774_853_007, 6, 21_243_766, 34_311_293, 9_341_465, 13_704_124, 16_967_776
						>>), {NATURAL_32} 884, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(47_734_277).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_743_259_200, 6, 46_616_643, 42_931_697, 45_918_455, 1_618_493, 7_621_353
						>>), {NATURAL_32} 886, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(48_052_399).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_703_284_240, 6, 18_303_785, 11_638_375, 34_083_383, 36_557_859, 44_048_079
						>>), {NATURAL_32} 888, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(48_358_091).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_665_366_749, 6, 39_455_288, 22_945_989, 9_764_687, 13_682_584, 4_332_774
						>>), {NATURAL_32} 890, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(48_497_287).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_648_259_510, 6, 27_206_040, 11_455_806, 28_822_045, 38_088_017, 41_717_000
						>>), {NATURAL_32} 892, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(48_636_667).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_631_227_773, 6, 14_940_600, 43_323_476, 25_952_783, 12_522_339, 7_474_496
						>>), {NATURAL_32} 894, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(48_818_153).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_609_196_594, 6, 47_787_985, 37_098_310, 43_350_735, 13_482_002, 37_492_164
						>>), {NATURAL_32} 896, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(48_985_997).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_588_966_762, 6, 33_185_557, 3_558_902, 33_089_345, 13_047_281, 36_129_151
						>>), {NATURAL_32} 898, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(49_224_247).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_560_487_966, 6, 12_457_807, 41_974_064, 42_618_878, 7_665_352, 11_798_968
						>>), {NATURAL_32} 900, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(49_463_053).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_532_218_020, 6, 41_144_738, 4_966_995, 3_251_058, 6_143_844, 33_233_065
						>>), {NATURAL_32} 902, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(49_702_451).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_504_150_662, 6, 20_556_510, 14_085_453, 13_747_057, 28_626_155, 32_723_667
						>>), {NATURAL_32} 904, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(50_041_451).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_464_865_210, 6, 41_443_961, 6_530_588, 43_163_684, 2_389_229, 42_702_878
						>>), {NATURAL_32} 906, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(50_495_227).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_413_104_402, 6, 2_873_001, 33_454_900, 13_398_118, 42_393_883, 50_024_809
						>>), {NATURAL_32} 908, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(50_751_367).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_384_296_006, 6, 31_852_468, 4_747_964, 17_592_283, 13_940_300, 13_028_606
						>>), {NATURAL_32} 910, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(50_979_479).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_358_883_661, 6, 12_691_060, 18_334_849, 24_960_979, 50_528_077, 49_086_505
						>>), {NATURAL_32} 912, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(51_380_143).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_314_794_750, 6, 30_415_427, 9_380_904, 42_078_551, 19_933_966, 13_853_442
						>>), {NATURAL_32} 914, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(51_696_091).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_280_509_893, 6, 4_191_743, 35_184_605, 9_780_795, 11_782_406, 26_807_170
						>>), {NATURAL_32} 916, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(51_969_677).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_251_158_691, 6, 33_453_782, 21_207_141, 15_380_754, 50_998_439, 13_647_315
						>>), {NATURAL_32} 918, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(52_070_647).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_240_404_218, 6, 25_174_242, 40_424_671, 4_789_255, 30_327_794, 28_887_464
						>>), {NATURAL_32} 920, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(52_316_273).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_214_415_533, 6, 5_032_910, 3_904_598, 33_325_736, 34_212_763, 4_431_151
						>>), {NATURAL_32} 922, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(52_490_021).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_196_178_843, 6, 43_275_595, 45_610_779, 4_734_967, 17_361_384, 13_616_662
						>>), {NATURAL_32} 924, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(52_823_599).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_161_502_569, 6, 16_255_777, 20_581_833, 51_565_432, 22_998_056, 12_916_065
						>>), {NATURAL_32} 926, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(53_319_179).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_110_786_910, 6, 29_432_976, 21_203_174, 47_031_589, 13_630_057, 10_997_885
						>>), {NATURAL_32} 928, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(53_509_189).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_091_591_191, 6, 14_232_176, 25_961_407, 49_502_330, 25_497_786, 38_947_002
						>>), {NATURAL_32} 930, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(53_758_223).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_066_638_056, 6, 48_067_679, 3_985_649, 29_522_421, 4_329_370, 9_233_829
						>>), {NATURAL_32} 932, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(54_022_499).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							1_040_409_287, 6, 27_189_875, 47_300_465, 31_401_006, 26_393_580, 22_936_560
						>>), {NATURAL_32} 934, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(54_479_017).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							995_700_414, 6, 45_603_970, 42_725_405, 52_160_980, 48_528_114, 24_223_842
						>>), {NATURAL_32} 936, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(54_967_387).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							948_694_298, 6, 7_511_110, 6_371_684, 19_537_337, 49_598_913, 51_846_255
						>>), {NATURAL_32} 938, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(55_383_283).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							909_317_472, 6, 30_454_505, 6_052_846, 38_832_822, 16_862_688, 1_394_960
						>>), {NATURAL_32} 940, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(55_621_763).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							887_003_943, 6, 12_091_545, 41_026_930, 35_436_554, 46_713_089, 32_265_568
						>>), {NATURAL_32} 942, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(55_935_437).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							857_944_553, 6, 43_874_084, 22_866_253, 1_352_867, 23_297_152, 17_535_375
						>>), {NATURAL_32} 944, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(56_070_143).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							845_564_914, 6, 33_636_428, 38_739_118, 44_863_281, 35_708_205, 46_913_123
						>>), {NATURAL_32} 946, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(56_294_993).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							825_032_917, 6, 16_547_828, 56_207_040, 19_632_938, 23_316_168, 16_819_368
						>>), {NATURAL_32} 948, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(56_550_391).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							801_909_508, 6, 53_687_971, 31_755_583, 38_493_938, 17_535_554, 6_570_920
						>>), {NATURAL_32} 950, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(56_746_073).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							784_333_542, 6, 39_011_821, 47_103_750, 31_870_247, 37_943_085, 35_521_149
						>>), {NATURAL_32} 952, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(56_911_927).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							769_531_331, 6, 26_572_771, 18_400_960, 41_158_887, 38_800_253, 52_404_656
						>>), {NATURAL_32} 954, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(57_062_891).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							756_132_834, 6, 15_250_471, 48_709_823, 3_705_410, 37_979_483, 55_135_212
						>>), {NATURAL_32} 956, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(57_259_453).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							738_793_263, 6, 508_321, 35_587_105, 37_371_133, 21_051_507, 47_475_295
						>>), {NATURAL_32} 958, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(57_456_391).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							721_539_503, 6, 43_194_362, 22_013_980, 49_794_679, 17_571_201, 12_369_297
						>>), {NATURAL_32} 960, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(57_608_099).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							708_328_788, 6, 31_967_970, 20_793_412, 23_001_350, 32_393_242, 52_832_044
						>>), {NATURAL_32} 962, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(57_836_021).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							688_611_642, 6, 15_101_742, 27_594_062, 41_627_434, 46_719_221, 1_803_982
						>>), {NATURAL_32} 964, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(58_216_819).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							656_013_899, 6, 45_139_509, 55_846_270, 6_242_509, 7_673_788, 17_970_988
						>>), {NATURAL_32} 966, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(58_461_307).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							635_308_658, 6, 27_291_885, 9_717_047, 22_313_477, 28_541_895, 43_186_047
						>>), {NATURAL_32} 968, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(58_844_237).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							603_224_792, 6, 58_182_232, 37_587_086, 35_190_390, 42_763_639, 43_051_794
						>>), {NATURAL_32} 970, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(59_043_847).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							586_665_436, 6, 43_810_312, 25_337_502, 807_267, 4_266_621, 41_661_600
						>>), {NATURAL_32} 972, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(59_213_009).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							572_719_400, 6, 31_630_648, 16_373_603, 23_932_082, 42_410_903, 6_268_074
						>>), {NATURAL_32} 974, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(59_444_051).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							553_800_096, 6, 14_995_624, 38_051_363, 11_134_104, 12_799_207, 35_462_133
						>>), {NATURAL_32} 976, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(59_675_621).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							534_984_555, 6, 57_998_205, 18_906_906, 41_172_417, 41_256_280, 23_556_969
						>>), {NATURAL_32} 978, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(60_015_973).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							507_593_784, 6, 33_833_213, 28_443_098, 15_207_241, 29_267_120, 47_096_264
						>>), {NATURAL_32} 980, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(60_186_563).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							493_981_628, 6, 21_721_323, 44_096_343, 37_930_857, 30_695_128, 49_713_223
						>>), {NATURAL_32} 982, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(60_699_677).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							453_499_094, 6, 45_989_906, 10_277_001, 32_192_698, 39_970_125, 10_954_397
						>>), {NATURAL_32} 984, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(61_152_391).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							418_345_976, 6, 14_299_926, 36_426_230, 57_216_831, 22_906_785, 40_758_379
						>>), {NATURAL_32} 986, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(61_387_189).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							400_318_167, 6, 59_251_255, 40_940_254, 1_920_130, 7_145_670, 17_295_290
						>>), {NATURAL_32} 988, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(61_779_551).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							370_498_403, 6, 32_178_277, 49_686_367, 14_408_995, 51_894_248, 16_735_093
						>>), {NATURAL_32} 990, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(62_015_621).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							352_738_741, 6, 15_889_447, 2_625_385, 54_080_888, 44_233_422, 268_526
						>>), {NATURAL_32} 992, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(62_110_157).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							345_664_608, 6, 9_366_463, 32_367_869, 38_478_162, 32_843_072, 9_614_060
						>>), {NATURAL_32} 994, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(62_473_207).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							318_696_544, 6, 46_789_220, 7_805_360, 20_586_909, 23_156_028, 25_682_642
						>>), {NATURAL_32} 996, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(62_773_913).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							296_595_701, 6, 26_341_212, 54_874_740, 11_203_426, 41_205_407, 46_319_833
						>>), {NATURAL_32} 998, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(62_964_221).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							282_717_801, 6, 13_400_268, 24_315_692, 30_977_285, 15_946_785, 8_333_309
						>>), {NATURAL_32} 1_000, {NATURAL_32} 2]),
					create {PD_GMP_PRIMES_PTAB}.make_initialized ([(63_202_499).to_natural_32, create {CE_NATURAL_32_ARRAY}.make_initialized (<<
							265_459_597, 6, 60_399_863, 25_175_275, 52_176_233, 961_122, 15_389_788
						>>), {NATURAL_32} 1_002, {NATURAL_32} 2])
				>>)
		end

feature {ANY} -- public routines

	gmpz_fits_uint_p: INTEGER_32
		local
			l___gmp_n: INTEGER_32
			l___gmp_p: CE_POINTER [NATURAL_32]
			l_tmp: INTEGER_32
		do
			l___gmp_n := mp_size.to_integer_32
			l___gmp_p := mp_d
			if l___gmp_n = 0 then
				l_tmp := 1
			elseif l___gmp_n = 1 then
				if l___gmp_p[0] <= {NATURAL_32} 4_294_967_295 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	gmpz_fits_ushort_p: INTEGER_32
		local
			l___gmp_n: INTEGER_32
			l___gmp_p: CE_POINTER [NATURAL_32]
			l_tmp: INTEGER_32
		do
			l___gmp_n := mp_size.to_integer_32
			l___gmp_p := mp_d
			if l___gmp_n = 0 then
				l_tmp := 1
			elseif l___gmp_n = 1 then
				if l___gmp_p[0] <= {NATURAL_32} 65_535 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	gmpz_get_ui: NATURAL_32
		local
			l___gmp_p: CE_POINTER [NATURAL_32]
			l___gmp_n: INTEGER_32
			l___gmp_l: NATURAL_32
			l_tmp: NATURAL_32
		do
			l___gmp_p := mp_d
			l___gmp_n := mp_size.to_integer_32
			l___gmp_l := l___gmp_p[0]
			if l___gmp_n /= 0 then
				l_tmp := l___gmp_l
			else
				l_tmp := (0).to_natural_32
			end
			Result := l_tmp
		end

	gmpz_perfect_square_p: INTEGER_32
		local
			l___gmp_asize: INTEGER_32
			l___gmp_result: INTEGER_32
			l_tmp: INTEGER_32
		do
			l___gmp_asize := mp_size.to_integer_32
			l___gmp_result := (l___gmp_asize >= 0).to_integer
			l_tmp := builtin_expect ((l___gmp_asize > 0).to_integer, 1)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				l___gmp_result := gmpn_perfect_square_p (mp_d, l___gmp_asize)
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l___gmp_result
		end

	gmpz_popcount: NATURAL_32
		local
			l___gmp_usize: INTEGER_32
			l___gmp_result: NATURAL_32
			l_tmp: INTEGER_32
		do
			l___gmp_usize := mp_size.to_integer_32
			if l___gmp_usize < 0 then
				l___gmp_result := ({NATURAL_32} 0).bit_not
			else
				l___gmp_result := (0).to_natural_32
			end
			l_tmp := builtin_expect ((l___gmp_usize > 0).to_integer, 1)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				l___gmp_result := gmpn_popcount (mp_d, l___gmp_usize)
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l___gmp_result
		end

	gmpz_size: NATURAL_32
		local
			l_tmp: INTEGER_32
		do
			if mp_size >= 0 then
				l_tmp := mp_size
			else
				l_tmp := -mp_size
			end
			Result := l_tmp.to_natural_32
		end

	gmpz_abs (a_u: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_u.is_void
		local
			l_wp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if a_u.item.mp_size >= 0 then
				l_size := (a_u.item.mp_size).to_integer_32
			else
				l_size := (-a_u.item.mp_size).to_integer_32
			end
			if not (a_u.c_pointer = c_pointer) then
				if mp_alloc.to_integer_32 < l_size then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_size).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_wp := mp_d
				l_up := a_u.item.mp_d
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_wp, l_up, l_size)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
			end
			Current.mp_size := l_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_add (a_u, a_v: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_u.is_void
			not a_v.is_void
		local
			l_u: CE_POINTER [PD_MPZ_STRUCT]
			l_v: CE_POINTER [PD_MPZ_STRUCT]
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_wsize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_abs_vsize: INTEGER_32
			l___mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l___mp_size_t_swap__tmp: INTEGER_32
			l___mp_size_t_swap__tmp___0: INTEGER_32
			l_tmp: INTEGER_32
			l_cy_limb: NATURAL_32
			l_tmp___0: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_u := a_u
			l_v := a_v
			l_usize := (l_u.item.mp_size).to_integer_32
			l_vsize := (l_v.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_abs_usize := l_usize
			else
				l_abs_usize := -l_usize
			end
			if l_vsize >= 0 then
				l_abs_vsize := l_vsize
			else
				l_abs_vsize := -l_vsize
			end
			if l_abs_usize < l_abs_vsize then
				from
				until
					(l_break)
				loop
					l_break := False
					l___mpz_srcptr_swap__tmp := l_u
					l_u := l_v
					l_v := l___mpz_srcptr_swap__tmp
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l___mp_size_t_swap__tmp := l_usize
					l_usize := l_vsize
					l_vsize := l___mp_size_t_swap__tmp
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l___mp_size_t_swap__tmp___0 := l_abs_usize
					l_abs_usize := l_abs_vsize
					l_abs_vsize := l___mp_size_t_swap__tmp___0
					l_break := True
				end
				l_break := False
			end
			l_wsize := l_abs_usize + 1
			if mp_alloc.to_integer_32 < l_wsize then
				((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_wsize).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			l_up := l_u.item.mp_d
			l_vp := l_v.item.mp_d
			l_wp := mp_d
			if ((l_usize).bit_xor (l_vsize)) < 0 then
				if l_abs_usize /= l_abs_vsize then
					(create {P_GMP_STATIC}).gmpn_sub (l_wp, l_up, l_abs_usize, l_vp, l_abs_vsize).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_wsize := l_abs_usize
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_wsize > 0))
						loop
							l_break := False
							if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_break) then
								l_wsize := l_wsize - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if l_usize < 0 then
						l_wsize := -l_wsize
					end
				else
					l_tmp := (create {P_GMP_STATIC}).gmpn_cmp (l_up, l_vp, l_abs_usize)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp < 0 then
						(create {P_GMP_STATIC}).gmpn_sub_n (l_wp, l_vp, l_up, l_abs_usize).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_wsize := l_abs_usize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_wsize > 0))
							loop
								l_break := False
								if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_wsize := l_wsize - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if l_usize >= 0 then
							l_wsize := -l_wsize
						end
					else
						(create {P_GMP_STATIC}).gmpn_sub_n (l_wp, l_up, l_vp, l_abs_usize).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_wsize := l_abs_usize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_wsize > 0))
							loop
								l_break := False
								if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_wsize := l_wsize - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if l_usize < 0 then
							l_wsize := -l_wsize
						end
					end
				end
			else
				l_tmp___0 := (create {P_GMP_STATIC}).gmpn_add (l_wp, l_up, l_abs_usize, l_vp, l_abs_vsize)
				update_class_fields -- Current might have been changed; synchronize
				l_cy_limb := l_tmp___0
				l_wp[l_abs_usize] := l_cy_limb
				update_class_fields -- Current might have been changed; synchronize
				l_wsize := (l_abs_usize.to_natural_32 + l_cy_limb).to_integer_32
				if l_usize < 0 then
					l_wsize := -l_wsize
				end
			end
			Current.mp_size := l_wsize.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_add_ui (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_vval: NATURAL_32)
		require
			not a_u.is_void
		local
			l_up: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_wsize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_cy: NATURAL_32
			l_return: BOOLEAN
		do
			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_abs_usize := l_usize
			else
				l_abs_usize := -l_usize
			end
			l_wsize := l_abs_usize + 1
			if mp_alloc.to_integer_32 < l_wsize then
				((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_wsize).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			l_up := a_u.item.mp_d
			l_wp := mp_d
			if l_abs_usize = 0 then
				l_wp[0] := a_vval
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_size := (a_vval /= {NATURAL_32} 0).to_integer
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				if l_usize >= 0 then
					l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (l_wp, l_up, l_abs_usize, a_vval)
					update_class_fields -- Current might have been changed; synchronize
					l_wp[l_abs_usize] := l_cy
					update_class_fields -- Current might have been changed; synchronize
					l_wsize := (l_abs_usize.to_natural_32 + l_cy).to_integer_32
				elseif l_abs_usize = 1 then
					if l_up[0] < a_vval then
						l_wp[0] := a_vval - l_up[0]
						update_class_fields -- Current might have been changed; synchronize
						l_wsize := (1).to_integer_32
					else
						(create {P_GMP_STATIC}).gmpn_sub_1 (l_wp, l_up, l_abs_usize, a_vval).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_wsize := -(l_abs_usize - (l_wp[(l_abs_usize - 1)] = {NATURAL_32} 0).to_integer)
					end
				else
					(create {P_GMP_STATIC}).gmpn_sub_1 (l_wp, l_up, l_abs_usize, a_vval).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_wsize := -(l_abs_usize - (l_wp[(l_abs_usize - 1)] = {NATURAL_32} 0).to_integer)
				end
				Current.mp_size := l_wsize.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	gmpz_and (a_op1, a_op2: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_op1.is_void
			not a_op2.is_void
		local
			l_op1: CE_POINTER [PD_MPZ_STRUCT]
			l_op2: CE_POINTER [PD_MPZ_STRUCT]
			l_op1_ptr: CE_POINTER [NATURAL_32]
			l_op2_ptr: CE_POINTER [NATURAL_32]
			l_op1_size: INTEGER_32
			l_op2_size: INTEGER_32
			l_res_ptr: CE_POINTER [NATURAL_32]
			l_res_size: INTEGER_32
			l_i: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l___up: CE_POINTER [NATURAL_32]
			l___vp: CE_POINTER [NATURAL_32]
			l___rp: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l___a: NATURAL_32
			l___b: NATURAL_32
			l_tmp___0: INTEGER_32
			l_opx: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			l_res_alloc: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___6: INTEGER_32
			l_tmp___9: CE_POINTER [ANY]
			l_tmp___10: CE_POINTER [ANY]
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l___mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l___mp_srcptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp: INTEGER_32
			l_opx___0: CE_POINTER [NATURAL_32]
			l_tmp___15: CE_POINTER [ANY]
			l_tmp___16: CE_POINTER [ANY]
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_op1 := a_op1
			l_op2 := a_op2
			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_op1_size := (l_op1.item.mp_size).to_integer_32
			l_op2_size := (l_op2.item.mp_size).to_integer_32
			l_op1_ptr := l_op1.item.mp_d
			l_op2_ptr := l_op2.item.mp_d
			l_res_ptr := mp_d
			if l_op1_size >= 0 then
				if l_op2_size >= 0 then
					if l_op1_size < l_op2_size then
						l_res_size := l_op1_size
					else
						l_res_size := l_op2_size
					end
					l_i := l_res_size - 1
					from
					until
						not (not (l_break) and then (l_i >= 0))
					loop
						l_break := False
						if ((l_op1_ptr[l_i]).bit_and (l_op2_ptr[l_i])) /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_break) then
							l_i := l_i - 1
						end
					end
					l_break := False
					l_res_size := l_i + 1
					l_tmp := builtin_expect ((mp_alloc.to_integer_32 < l_res_size).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_res_size).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_res_ptr := mp_d
					end
					Current.mp_size := l_res_size.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := builtin_expect ((l_res_size /= 0).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___0.to_boolean then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___up := l_op1_ptr
							l___vp := l_op2_ptr
							l___rp := l_res_ptr
							l___n := l_res_size
							l___up := l___up + l___n
							l___vp := l___vp + l___n
							l___rp := l___rp + l___n
							l___n := -l___n
							from
							until
								(l_break)
							loop
								l_break := False
								l___a := l___up[l___n]
								l___b := l___vp[l___n]
								l___rp[l___n] := (l___a).bit_and (l___b)
								update_class_fields -- Current might have been changed; synchronize
								l___n := l___n + 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
					end
					l_return := True
				end
			elseif l_op2_size < 0 then
				l_op1_size := -l_op1_size
				l_op2_size := -l_op2_size
				if l_op1_size > l_op2_size then
					l_tmp___1 := l_op1_size
				else
					l_tmp___1 := l_op2_size
				end
				l_res_alloc := 1 + l_tmp___1
				l_tmp___6 := builtin_expect ((l_op1_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___6.to_boolean then
					l_tmp___5 := (l_aaf.new ((l_op1_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___4 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_op1_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___5 := l_tmp___4
				end
				l_opx := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___5);
				(create {P_GMP_STATIC}).gmpn_sub_1 (l_opx, l_op1_ptr, l_op1_size, (1).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_op1_ptr := l_opx
				l_tmp___11 := builtin_expect ((l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___11.to_boolean then
					l_tmp___10 := (l_aaf.new ((l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___9 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___10 := l_tmp___9
				end
				l_opx := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___10);
				(create {P_GMP_STATIC}).gmpn_sub_1 (l_opx, l_op2_ptr, l_op2_size, (1).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_op2_ptr := l_opx
				if mp_alloc.to_integer_32 < l_res_alloc then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_res_alloc).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_res_ptr := mp_d
				end
				if l_op1_size >= l_op2_size then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_res_ptr + l_op2_size, l_op1_ptr + l_op2_size, l_op1_size - l_op2_size)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_i := l_op2_size - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_or (l_op2_ptr[l_i]))
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i - 1
					end
					l_res_size := l_op1_size
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_res_ptr + l_op1_size, l_op2_ptr + l_op1_size, l_op2_size - l_op1_size)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_i := l_op1_size - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_or (l_op2_ptr[l_i]))
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i - 1
					end
					l_res_size := l_op2_size
				end
				l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (l_res_ptr, l_res_ptr, l_res_size, (1).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				if l_cy.to_boolean then
					l_res_ptr[l_res_size] := l_cy
					update_class_fields -- Current might have been changed; synchronize
					l_res_size := l_res_size + 1
				end
				Current.mp_size := (-l_res_size).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___12 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___12.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
				l_return := True
			else
				from
				until
					(l_break)
				loop
					l_break := False
					l___mpz_srcptr_swap__tmp := l_op1
					l_op1 := l_op2
					l_op2 := l___mpz_srcptr_swap__tmp
					l_break := True
				end
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						l___mp_srcptr_swap__tmp := l_op1_ptr
						l_op1_ptr := l_op2_ptr
						l_op2_ptr := l___mp_srcptr_swap__tmp
						l_break := True
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						l___mp_size_t_swap__tmp := l_op1_size
						l_op1_size := l_op2_size
						l_op2_size := l___mp_size_t_swap__tmp
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
			end
			if not l_return then
				l_op2_size := -l_op2_size
				l_tmp___17 := builtin_expect ((l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___17.to_boolean then
					l_tmp___16 := (l_aaf.new ((l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___15 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___16 := l_tmp___15
				end
				l_opx___0 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___16);
				(create {P_GMP_STATIC}).gmpn_sub_1 (l_opx___0, l_op2_ptr, l_op2_size, (1).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_op2_ptr := l_opx___0
				if l_op1_size > l_op2_size then
					l_res_size := l_op1_size
					if mp_alloc.to_integer_32 < l_res_size then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_res_size).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_res_ptr := mp_d
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_res_ptr + l_op2_size, l_op1_ptr + l_op2_size, l_res_size - l_op2_size)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_i := l_op2_size - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_and ((l_op2_ptr[l_i]).bit_not))
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i - 1
					end
					Current.mp_size := l_res_size.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					l_i := l_op1_size - 1
					from
					until
						not (not (l_break) and then (l_i >= 0))
					loop
						l_break := False
						if ((l_op1_ptr[l_i]).bit_and ((l_op2_ptr[l_i]).bit_not)) /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_i := l_i - 1
						end
					end
					l_break := False
					l_res_size := l_i + 1
					if mp_alloc.to_integer_32 < l_res_size then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_res_size).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_res_ptr := mp_d
					end
					l_i := l_res_size - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_and ((l_op2_ptr[l_i]).bit_not))
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i - 1
					end
					Current.mp_size := l_res_size.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___18 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___18.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpz_bin_uiui (a_n, a_k: NATURAL_32)
		local
			l_k: NATURAL_32
			l_i: NATURAL_32
			l_j: CE_ARRAY [NATURAL_32]
			l_nacc: CE_ARRAY [NATURAL_32]
			l_kacc: NATURAL_32
			l_cnt: NATURAL_32
			l_rsize: INTEGER_32
			l_ralloc: INTEGER_32
			l_rp: CE_POINTER [NATURAL_32]
			l_n1: CE_ARRAY [NATURAL_32]
			l_n0: CE_ARRAY [NATURAL_32]
			l_new_ralloc: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_new_ralloc___0: INTEGER_32
			l_tmp___0: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_j.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_nacc.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_n1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_n0.make (<<1>>)

			l_k := a_k
			if a_n < l_k then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_rp := mp_d
				if l_k < a_n - l_k then
					l_k := l_k
				else
					l_k := a_n - l_k
				end
				if l_k = {NATURAL_32} 0 then
					Current.mp_size := 1
					update_class_fields -- Current might have been changed; synchronize
					l_rp[0] := (1).to_natural_32
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
				l_j.item := (a_n - l_k) + {NATURAL_32} 1
				update_class_fields -- Current might have been changed; synchronize
				l_rp[0] := l_j.item
				update_class_fields -- Current might have been changed; synchronize
				l_rsize := (1).to_integer_32
				l_ralloc := mp_alloc.to_integer_32
				l_nacc.item := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_kacc := (1).to_natural_32
				l_i := {NATURAL_32} 2
				from
				until
					not (not (l_return) and then (l_i <= l_k))
				loop
					l_cnt := (((((l_nacc.item).bit_or (l_kacc))).bit_and ({NATURAL_32} 1))).bit_xor ({NATURAL_32} 1)
					l_nacc.item := (l_nacc.item).bit_shift_right (l_cnt.to_integer_32)
					update_class_fields -- Current might have been changed; synchronize
					l_kacc := (l_kacc).bit_shift_right (l_cnt.to_integer_32)
					l_j.item := l_j.item + 1
					update_class_fields -- Current might have been changed; synchronize
					asm6 (l_n0, l_n1, l_nacc, l_j)
					l_n0.item := l_n0.item
					update_class_fields -- Current might have been changed; synchronize
					if l_n1.item = {NATURAL_32} 0 then
						l_nacc.item := l_n0.item
						update_class_fields -- Current might have been changed; synchronize
						l_kacc := l_kacc * l_i
					else
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_rsize = l_ralloc then
								l_new_ralloc := l_ralloc + 32
								l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_rp), (l_ralloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32, (l_new_ralloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32]))
								update_class_fields -- Current might have been changed; synchronize
								l_rp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
								l_ralloc := l_new_ralloc
							end
							l_rp[l_rsize] := (create {P_GMP_STATIC}).gmpn_mul_1 (l_rp, l_rp, l_rsize, l_nacc.item)
							update_class_fields -- Current might have been changed; synchronize
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_IMPL_STATIC}).gmpn_divexact_1 (l_rp, l_rp, l_rsize + 1, l_kacc)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
							l_rsize := l_rsize + (l_rp[l_rsize] /= {NATURAL_32} 0).to_integer
							l_break := True
						end
						l_break := False
						l_nacc.item := l_j.item
						update_class_fields -- Current might have been changed; synchronize
						l_kacc := l_i
					end
					l_i := l_i + 1
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if l_rsize = l_ralloc then
						l_new_ralloc___0 := l_ralloc + 1
						l_tmp___0 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_rp), (l_ralloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32, (l_new_ralloc___0.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32]))
						update_class_fields -- Current might have been changed; synchronize
						l_rp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___0)
						l_ralloc := l_new_ralloc___0
					end
					l_rp[l_rsize] := (create {P_GMP_STATIC}).gmpn_mul_1 (l_rp, l_rp, l_rsize, l_nacc.item)
					update_class_fields -- Current might have been changed; synchronize
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_IMPL_STATIC}).gmpn_divexact_1 (l_rp, l_rp, l_rsize + 1, l_kacc)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_rsize := l_rsize + (l_rp[l_rsize] /= {NATURAL_32} 0).to_integer
					l_break := True
				end
				l_break := False
				Current.mp_alloc := l_ralloc.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_size := l_rsize.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_d := l_rp
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	gmpz_cdiv_q_ui (a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32): NATURAL_32
		require
			not a_dividend.is_void
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_qn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_qp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_rl: NATURAL_32
			l_tmp: INTEGER_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_qp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			if a_divisor = {NATURAL_32} 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_ns := (a_dividend.item.mp_size).to_integer_32
			if l_ns = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				l_tmp := builtin_expect ((l_nn > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_nn).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_qp.item := mp_d
				update_class_fields -- Current might have been changed; synchronize
				l_np := a_dividend.item.mp_d
				l_rl := (create {P_GMP_STATIC}).gmpn_divrem_1 (l_qp.item, (0).to_integer_32, l_np, l_nn, a_divisor)
				update_class_fields -- Current might have been changed; synchronize
				if l_rl /= {NATURAL_32} 0 then
					if l_ns >= 0 then
						from
						until
							(l_break)
						loop
							l_break := False
							asm7 (l___ptr_dummy, l_qp)
							l_break := True
						end
						l_break := False
						l_rl := a_divisor - l_rl
					end
				end
				l_qn := l_nn - (l_qp.item[(l_nn - 1)] = {NATURAL_32} 0).to_integer
				if l_ns >= 0 then
					Current.mp_size := l_qn.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_qn).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_rl
			end
		end

	gmpz_cdiv_qr_ui (a_rem, a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32): NATURAL_32
		require
			not a_rem.is_void
			not a_dividend.is_void
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_qn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_qp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_rl: NATURAL_32
			l_tmp: INTEGER_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_qp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			if a_divisor = {NATURAL_32} 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_ns := (a_dividend.item.mp_size).to_integer_32
			if l_ns = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				a_rem.item.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				l_tmp := builtin_expect ((l_nn > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_nn).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_qp.item := mp_d
				update_class_fields -- Current might have been changed; synchronize
				l_np := a_dividend.item.mp_d
				l_rl := (create {P_GMP_STATIC}).gmpn_divrem_1 (l_qp.item, (0).to_integer_32, l_np, l_nn, a_divisor)
				update_class_fields -- Current might have been changed; synchronize
				if l_rl = {NATURAL_32} 0 then
					a_rem.item.mp_size := 0
					update_class_fields -- Current might have been changed; synchronize
				else
					if l_ns >= 0 then
						from
						until
							(l_break)
						loop
							l_break := False
							asm8 (l___ptr_dummy, l_qp)
							l_break := True
						end
						l_break := False
						l_rl := a_divisor - l_rl
					end
					a_rem.item.mp_d[0] := l_rl
					update_class_fields -- Current might have been changed; synchronize
					a_rem.item.mp_size := (-(l_rl /= {NATURAL_32} 0).to_integer).to_integer
					update_class_fields -- Current might have been changed; synchronize
				end
				l_qn := l_nn - (l_qp.item[(l_nn - 1)] = {NATURAL_32} 0).to_integer
				if l_ns >= 0 then
					Current.mp_size := l_qn.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_qn).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_rl
			end
		end

	gmpz_cdiv_r_ui (a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32): NATURAL_32
		require
			not a_dividend.is_void
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_rl: NATURAL_32
			l_return: BOOLEAN
		do
			if a_divisor = {NATURAL_32} 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_ns := (a_dividend.item.mp_size).to_integer_32
			if l_ns = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				l_np := a_dividend.item.mp_d
				l_rl := (create {P_MOD_1_STATIC}).gmpn_mod_1 (l_np, l_nn, a_divisor)
				update_class_fields -- Current might have been changed; synchronize
				if l_rl = {NATURAL_32} 0 then
					Current.mp_size := 0
					update_class_fields -- Current might have been changed; synchronize
				else
					if l_ns >= 0 then
						l_rl := a_divisor - l_rl
					end
					mp_d[0] := l_rl
					update_class_fields -- Current might have been changed; synchronize
					Current.mp_size := -1
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_rl
			end
		end

	gmpz_cdiv_ui (a_divisor: NATURAL_32): NATURAL_32
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_rl: NATURAL_32
			l_return: BOOLEAN
		do
			if a_divisor = {NATURAL_32} 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_ns := mp_size.to_integer_32
			if l_ns = 0 then
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				l_np := mp_d
				l_rl := (create {P_MOD_1_STATIC}).gmpn_mod_1 (l_np, l_nn, a_divisor)
				update_class_fields -- Current might have been changed; synchronize
				if l_rl /= {NATURAL_32} 0 then
					if l_ns >= 0 then
						l_rl := a_divisor - l_rl
					end
				end
				Result := l_rl
			end
		end

	gmpz_cfdiv_q_2exp (a_dir: INTEGER_32; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		require
			not a_u.is_void
		local
			l_cnt: NATURAL_32
			l_wsize: INTEGER_32
			l_usize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_limb_cnt: INTEGER_32
			l_i: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_round: NATURAL_32
			l_rmask: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l_cy: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_cnt := a_cnt
			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_abs_usize := l_usize
			else
				l_abs_usize := -l_usize
			end
			l_limb_cnt := (l_cnt // {NATURAL_32} 32).to_integer_32
			l_wsize := l_abs_usize - l_limb_cnt
			if l_wsize <= 0 then
				mp_d[0] := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				if l_usize = 0 then
					Current.mp_size := 0
					update_class_fields -- Current might have been changed; synchronize
				elseif ((l_usize).bit_xor (a_dir.to_integer_32)) < 0 then
					Current.mp_size := 0
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := a_dir
					update_class_fields -- Current might have been changed; synchronize
				end
				l_return := True
			end
			if not l_return then
				l_tmp := builtin_expect ((l_wsize + 1 > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_wsize + 1).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_up := a_u.item.mp_d
				l_round := (0).to_natural_32
				if ((l_usize).bit_xor (a_dir.to_integer_32)) >= 0 then
					l_rmask := ((0).to_natural_32).bit_not
				else
					l_rmask := (0).to_natural_32
				end
				if l_rmask /= {NATURAL_32} 0 then
					l_i := (0).to_integer_32
					from
					until
						(l_break)
					loop
						l_break := False
						if l_i < l_limb_cnt then
							if l_round /= {NATURAL_32} 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_round := l_up[l_i]
							l_i := l_i + 1
						end
					end
					l_break := False
				end
				l_wp := mp_d
				l_cnt := l_cnt \\ ({NATURAL_32} 32)
				if l_cnt /= {NATURAL_32} 0 then
					l_tmp___0 := (create {P_GMP_STATIC}).gmpn_rshift (l_wp, l_up + l_limb_cnt, l_wsize, l_cnt.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_round := (l_round).bit_or (((l_rmask).bit_and (l_tmp___0)))
					l_wsize := l_wsize - (l_wp[(l_wsize - 1)] = {NATURAL_32} 0).to_integer
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_wp, l_up + l_limb_cnt, l_wsize)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
				end
				if l_round /= {NATURAL_32} 0 then
					if l_wsize /= 0 then
						l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (l_wp, l_wp, l_wsize, (1).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_wp[l_wsize] := l_cy
						update_class_fields -- Current might have been changed; synchronize
						l_wsize := (l_wsize.to_natural_32 + l_cy).to_integer_32
					else
						l_wp[0] := (1).to_natural_32
						update_class_fields -- Current might have been changed; synchronize
						l_wsize := (1).to_integer_32
					end
				end
				if l_usize >= 0 then
					Current.mp_size := l_wsize.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_wsize).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	gmpz_cdiv_q_2exp (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		require
			not a_u.is_void
		do
			((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_cfdiv_q_2exp (1, a_u, a_cnt)
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_fdiv_q_2exp (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		require
			not a_u.is_void
		do
			((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_cfdiv_q_2exp (-1, a_u, a_cnt)
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_clear
		do
			(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (mp_d), (mp_alloc * 4).to_natural_32])
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_cmp (a_v: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		require
			not a_v.is_void
		local
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_dsize: INTEGER_32
			l_asize: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_cmp: INTEGER_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_y: NATURAL_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_usize := mp_size.to_integer_32
			l_vsize := (a_v.item.mp_size).to_integer_32
			l_dsize := l_usize - l_vsize
			if l_dsize /= 0 then
				Result := l_dsize.to_integer_32
				l_return := True
			end
			if not l_return then
				if l_usize >= 0 then
					l_asize := l_usize
				else
					l_asize := -l_usize
				end
				l_up := mp_d
				l_vp := a_v.item.mp_d
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_cmp := 0
					l___gmp_i := l_asize
					from
					until
						(l_break)
					loop
						l_break := False
						l___gmp_i := l___gmp_i - 1
						if not (l___gmp_i >= 0) then
							l_break := True
						end
						if not (l_break) then
							l___gmp_x := l_up[l___gmp_i]
							l___gmp_y := l_vp[l___gmp_i]
							if l___gmp_x /= l___gmp_y then
								if l___gmp_x > l___gmp_y then
									l_cmp := 1
								else
									l_cmp := -1
								end
								l_break := True
							end
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				if l_usize >= 0 then
					l_tmp := l_cmp
				else
					l_tmp := -l_cmp
				end
				Result := l_tmp
			end
		end

	gmpz_cmp_si (a_v_digit: INTEGER_32): INTEGER_32
		local
			l_v_digit: INTEGER_32
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_u_digit: NATURAL_32
			l_return: BOOLEAN
		do
			l_v_digit := a_v_digit
			l_usize := mp_size.to_integer_32
			l_vsize := (0).to_integer_32
			if l_v_digit > 0 then
				l_vsize := (1).to_integer_32
			elseif l_v_digit < 0 then
				l_vsize := (-1).to_integer_32
				l_v_digit := -l_v_digit
			end
			if l_usize /= l_vsize then
				Result := (l_usize - l_vsize).to_integer_32
				l_return := True
			end
			if not l_return and then (l_usize = 0) then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_u_digit := mp_d[0]
				if l_u_digit = l_v_digit.to_natural_32 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if l_u_digit > l_v_digit.to_natural_32 then
					Result := l_usize.to_integer_32
				else
					Result := (-l_usize).to_integer_32
				end
			end
		end

	gmpz_cmp_ui (a_v_digit: NATURAL_32): INTEGER_32
		local
			l_up: CE_POINTER [NATURAL_32]
			l_un: INTEGER_32
			l_ul: NATURAL_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_up := mp_d
			l_un := mp_size.to_integer_32
			if l_un = 0 then
				Result := (-(a_v_digit /= {NATURAL_32} 0).to_integer).to_integer
				l_return := True
			end
			if not l_return and then (l_un = 1) then
				l_ul := l_up[0]
				if l_ul > a_v_digit then
					Result := 1
					l_return := True
				end
				if not l_return and then (l_ul < a_v_digit) then
					Result := (-1)
					l_return := True
				end
				if not l_return then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if l_un > 0 then
					l_tmp := 1
				else
					l_tmp := -1
				end
				Result := l_tmp
			end
		end

	gmpz_cmpabs (a_v: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		require
			not a_v.is_void
		local
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_dsize: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_cmp: INTEGER_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_y: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if mp_size >= 0 then
				l_usize := mp_size.to_integer_32
			else
				l_usize := (-mp_size).to_integer_32
			end
			if a_v.item.mp_size >= 0 then
				l_vsize := (a_v.item.mp_size).to_integer_32
			else
				l_vsize := (-a_v.item.mp_size).to_integer_32
			end
			l_dsize := l_usize - l_vsize
			if l_dsize /= 0 then
				Result := l_dsize.to_integer_32
				l_return := True
			end
			if not l_return then
				l_up := mp_d
				l_vp := a_v.item.mp_d
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_cmp := 0
					l___gmp_i := l_usize
					from
					until
						(l_break)
					loop
						l_break := False
						l___gmp_i := l___gmp_i - 1
						if not (l___gmp_i >= 0) then
							l_break := True
						end
						if not (l_break) then
							l___gmp_x := l_up[l___gmp_i]
							l___gmp_y := l_vp[l___gmp_i]
							if l___gmp_x /= l___gmp_y then
								if l___gmp_x > l___gmp_y then
									l_cmp := 1
								else
									l_cmp := -1
								end
								l_break := True
							end
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				Result := l_cmp
			end
		end

	gmpz_cmpabs_ui (a_v_digit: NATURAL_32): INTEGER_32
		local
			l_up: CE_POINTER [NATURAL_32]
			l_un: INTEGER_32
			l_ul: NATURAL_32
			l_return: BOOLEAN
		do
			l_up := mp_d
			l_un := mp_size.to_integer_32
			if l_un = 0 then
				Result := (-(a_v_digit /= {NATURAL_32} 0).to_integer).to_integer
				l_return := True
			end
			if not l_return then
				if l_un >= 0 then
					l_un := l_un
				else
					l_un := -l_un
				end
				if l_un = 1 then
					l_ul := l_up[0]
					if l_ul > a_v_digit then
						Result := 1
						l_return := True
					end
					if not l_return and then (l_ul < a_v_digit) then
						Result := (-1)
						l_return := True
					end
					if not l_return then
						Result := 0
						l_return := True
					end
				end
			end
			if not l_return then
				Result := 1
			end
		end

	gmpz_com (a_src: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_src.is_void
		local
			l_size: INTEGER_32
			l_src_ptr: CE_POINTER [NATURAL_32]
			l_dst_ptr: CE_POINTER [NATURAL_32]
			l_tmp: INTEGER_32
			l_cy: NATURAL_32
			l_return: BOOLEAN
		do
			l_size := (a_src.item.mp_size).to_integer_32
			if l_size >= 0 then
				if mp_alloc.to_integer_32 < l_size + 1 then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_size + 1).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_src_ptr := a_src.item.mp_d
				l_dst_ptr := mp_d
				l_tmp := builtin_expect ((l_size = 0).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					l_dst_ptr[0] := (1).to_natural_32
					update_class_fields -- Current might have been changed; synchronize
					Current.mp_size := -1
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
				if not l_return then
					l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (l_dst_ptr, l_src_ptr, l_size, (1).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_cy.to_boolean then
						l_dst_ptr[l_size] := l_cy
						update_class_fields -- Current might have been changed; synchronize
						l_size := l_size + 1
					end
					Current.mp_size := (-l_size).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				l_size := -l_size
				if mp_alloc.to_integer_32 < l_size then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_size).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_src_ptr := a_src.item.mp_d
				l_dst_ptr := mp_d;
				(create {P_GMP_STATIC}).gmpn_sub_1 (l_dst_ptr, l_src_ptr, l_size, (1).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_size := l_size - (l_dst_ptr[(l_size - 1)] = {NATURAL_32} 0).to_integer
				Current.mp_size := l_size.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
			if not l_return then
			end
		end

	gmpz_combit (a_bit_index: NATURAL_32)
		local
			l_dsize: INTEGER_32
			l_tmp: INTEGER_32
			l_dp: CE_POINTER [NATURAL_32]
			l_limb_index: INTEGER_32
			l_bit: NATURAL_32
			l_tmp___0: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_32]
			l_x___2: NATURAL_32
			l_i: INTEGER_32
			l_c: NATURAL_32
			l_tmp___2: INTEGER_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_r: NATURAL_32
			l___gmp_j: INTEGER_32
			l___gmp_j___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if mp_size >= 0 then
				l_tmp := mp_size
			else
				l_tmp := -mp_size
			end
			l_dsize := l_tmp.to_integer_32
			l_dp := mp_d
			l_limb_index := (a_bit_index // {NATURAL_32} 32).to_integer_32
			l_bit := ({NATURAL_32} 1).bit_shift_left ((a_bit_index \\ {NATURAL_32} 32).to_integer_32)
			if l_limb_index >= l_dsize then
				l_tmp___0 := builtin_expect ((l_limb_index + 1 > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_limb_index + 1).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_dp := mp_d
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if (l_limb_index + 1) - l_dsize /= 0 then
						l___dst := l_dp + l_dsize
						l___n := (l_limb_index + 1) - l_dsize
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___1 := l___dst
							l___dst := l___dst + 1
							l_tmp___1.item := (0).to_natural_32
							update_class_fields -- Current might have been changed; synchronize
							l___n := l___n - 1
							if not l___n.to_boolean then
								l_break := True
							end
						end
						l_break := False
					end
					l_break := True
				end
				l_break := False
				l_dsize := l_limb_index + 1
			end
			if mp_size >= 0 then
				l_dp[l_limb_index] := (l_dp[l_limb_index]).bit_xor (l_bit)
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						not (not (l_break) and then (l_dsize > 0))
					loop
						l_break := False
						if l_dp[(l_dsize - 1)] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_dsize := l_dsize - 1
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				Current.mp_size := l_dsize.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			else
				l_x___2 := (-(l_dp[l_limb_index]).to_integer_32).to_natural_32
				l_i := l_limb_index - 1
				from
				until
					not (not (l_break) and then (l_i >= 0))
				loop
					l_break := False
					if l_dp[l_i] /= {NATURAL_32} 0 then
						l_x___2 := l_x___2 - 1
						l_break := True
					end
					if not (l_return or l_break) then
						l_i := l_i - 1
					end
				end
				l_break := False
				if ((l_x___2).bit_and (l_bit)).to_boolean then
					l_tmp___2 := builtin_expect ((l_dsize + 1 > mp_alloc.to_integer_32).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___2.to_boolean then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_dsize + 1).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					l_dp := mp_d
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l___gmp_x := (l_dp + l_limb_index)[0]
						l___gmp_r := l___gmp_x + l_bit;
						(l_dp + l_limb_index)[0] := l___gmp_r
						update_class_fields -- Current might have been changed; synchronize
						if l___gmp_r < l_bit then
							l_c := (1).to_natural_32
							l___gmp_i := (1).to_integer_32
							from
							until
								not (not (l_return or l_break) and then (l___gmp_i < l_dsize - l_limb_index))
							loop
								l_break := False
								l___gmp_x := (l_dp + l_limb_index)[l___gmp_i]
								l___gmp_r := l___gmp_x + {NATURAL_32} 1;
								(l_dp + l_limb_index)[l___gmp_i] := l___gmp_r
								update_class_fields -- Current might have been changed; synchronize
								l___gmp_i := l___gmp_i + 1
								if not (l___gmp_r < {NATURAL_32} 1) then
									if not (l_dp + l_limb_index).is_equal (l_dp + l_limb_index) then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											l___gmp_j := l___gmp_i
											from
											until
												not (l___gmp_j < l_dsize - l_limb_index)
											loop
												(l_dp + l_limb_index)[l___gmp_j] := (l_dp + l_limb_index)[l___gmp_j]
												update_class_fields -- Current might have been changed; synchronize
												l___gmp_j := l___gmp_j + 1
											end
											l_break := True
										end
										l_break := False
									end
									l_c := (0).to_natural_32
									l_break := True
								end
							end
							l_break := False
						else
							if not (l_dp + l_limb_index).is_equal (l_dp + l_limb_index) then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l___gmp_j___0 := (1).to_integer_32
									from
									until
										not (l___gmp_j___0 < l_dsize - l_limb_index)
									loop
										(l_dp + l_limb_index)[l___gmp_j___0] := (l_dp + l_limb_index)[l___gmp_j___0]
										update_class_fields -- Current might have been changed; synchronize
										l___gmp_j___0 := l___gmp_j___0 + 1
									end
									l_break := True
								end
								l_break := False
							end
							l_c := (0).to_natural_32
						end
						l_break := True
					end
					l_break := False
					l_dp[l_dsize] := l_c
					update_class_fields -- Current might have been changed; synchronize
					l_dsize := (l_dsize.to_natural_32 + l_c).to_integer_32
				else
					(create {P_GMP_STATIC}).gmpn_sub_1 (l_dp + l_limb_index, (l_dp + l_limb_index), l_dsize + l_limb_index, l_bit).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						not (not (l_break) and then (l_dsize > 0))
					loop
						l_break := False
						if l_dp[(l_dsize - 1)] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_dsize := l_dsize - 1
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				Current.mp_size := (-l_dsize).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	gmpz_congruent_ui_p (a_cu, a_du: NATURAL_32): INTEGER_32
		local
			l_ap: CE_POINTER [NATURAL_32]
			l_asize: INTEGER_32
			l_c: NATURAL_32
			l_d: NATURAL_32
			l_r: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_climbs: CE_ARRAY [NATURAL_32]
			l_dlimbs: CE_ARRAY [NATURAL_32]
			l_cz: CE_ARRAY [PD_MPZ_STRUCT]
			l_dz: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp___2: INTEGER_32
			l___twos: NATURAL_32
			l___dnorm: NATURAL_32
			l_tmp___3: INTEGER_32
			l_tmp___4: NATURAL_32
			l_twos: NATURAL_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_climbs.make (<<2>>)
			create {CE_NATURAL_32_ARRAY} l_dlimbs.make (<<2>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_cz.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_dz.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp___1 := builtin_expect ((a_du = {NATURAL_32} 0).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___1.to_boolean then
						l_tmp___0 := ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_cmp_ui (a_cu)
						update_class_fields -- Current might have been changed; synchronize
						Result := (l_tmp___0 = 0).to_integer
						l_return := True
					end
					if not l_return then
						l_asize := mp_size.to_integer_32
						if l_asize = 0 then
							if a_cu < a_du then
								Result := (a_cu = {NATURAL_32} 0).to_integer
								l_return := True
							else
								Result := (a_cu \\ a_du = {NATURAL_32} 0).to_integer
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (a_du > {NATURAL_32} 4_294_967_295) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_cu > {NATURAL_32} 4_294_967_295) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_cz[0].mp_alloc := 2
						update_class_fields -- Current might have been changed; synchronize
						l_cz[0].mp_d := l_climbs
						update_class_fields -- Current might have been changed; synchronize
						l_dz[0].mp_alloc := 2
						update_class_fields -- Current might have been changed; synchronize
						l_dz[0].mp_d := l_dlimbs
						update_class_fields -- Current might have been changed; synchronize
						l_cz.item.gmpz_set_ui (a_cu)
						update_class_fields -- Current might have been changed; synchronize
						l_dz.item.gmpz_set_ui (a_du)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := gmpz_congruent_p ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_cz), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_dz))
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___2
						l_return := True
				when 6 then -- if done | if done
					if not l_return then
						l_c := a_cu
						l_d := a_du
						if l_asize < 0 then
							l_asize := -l_asize
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_c <= l_d then
									l_c := l_d - l_c
								else
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										l_tmp___3 := builtin_clzl (l_d)
										update_class_fields -- Current might have been changed; synchronize
										l___twos := l_tmp___3.to_natural_32
										l_break := True
									end
									l_break := False
									l___twos := l___twos
									l___dnorm := (l_d).bit_shift_left (l___twos.to_integer_32)
									if l_c <= l___dnorm then
										l_tmp___4 := l___dnorm
									else
										l_tmp___4 := {NATURAL_32} 2 * l___dnorm
									end
									l_c := l_tmp___4 - l_c
								end
								l_break := True
							end
							l_break := False
						end
						l_ap := mp_d
						if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_asize >= 22 then
								l_r := (create {P_MOD_1_STATIC}).gmpn_mod_1 (l_ap, l_asize, l_d)
								update_class_fields -- Current might have been changed; synchronize
								if l_c < l_d then
									Result := (l_r = l_c).to_integer
									l_return := True
								else
									Result := (l_r = l_c \\ l_d).to_integer
									l_return := True
								end
							end
						end
					end
					if not l_return and then (((l_d).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0) then
						if (((l_ap[0] - l_c)).bit_and ((((l_d).bit_and ((-l_d.to_integer_32).to_natural_32)) - {NATURAL_32} 1))).to_boolean then
							Result := 0
							l_return := True
						end
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_tmp___5 := builtin_ctzl (l_d)
								update_class_fields -- Current might have been changed; synchronize
								l_twos := l_tmp___5.to_natural_32
								l_break := True
							end
							l_break := False
							l_d := (l_d).bit_shift_right (l_twos.to_integer_32)
						end
					end
					if not l_return then
						l_r := gmpn_modexact_1c_odd (l_ap, l_asize, l_d, l_c)
						update_class_fields -- Current might have been changed; synchronize
						if l_r = {NATURAL_32} 0 then
							l_tmp___6 := 1
						elseif l_r = l_d then
							l_tmp___6 := 1
						else
							l_tmp___6 := 0
						end
						Result := l_tmp___6
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_divexact (a_num, a_den: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_num.is_void
			not a_den.is_void
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_qn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_nn: INTEGER_32
			l_dn: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_num.item.mp_size >= 0 then
						l_nn := (a_num.item.mp_size).to_integer_32
					else
						l_nn := (-a_num.item.mp_size).to_integer_32
					end
					if a_den.item.mp_size >= 0 then
						l_dn := (a_den.item.mp_size).to_integer_32
					else
						l_dn := (-a_den.item.mp_size).to_integer_32
					end
					l_qn := (l_nn - l_dn) + 1
					l_tmp := builtin_expect ((l_qn > mp_alloc.to_integer_32).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_qn).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_nn < l_dn then
						Current.mp_size := 0
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_qp := mp_d
						if not ((c_pointer = (a_num).c_pointer)) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not ((c_pointer = (a_den).c_pointer)) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_tmp___4 := builtin_expect ((l_qn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___4.to_boolean then
							l_tmp___3 := (l_aaf.new ((l_qn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___2 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_qn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___3 := l_tmp___2
						end
						l_qp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___3)
				when 6 then -- if done
						l_np := a_num.item.mp_d
						l_dp := a_den.item.mp_d
						gmpn_divexact (l_qp, l_np, l_nn, l_dp, l_dn)
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_qn > 0))
							loop
								l_break := False
								if l_qp[(l_qn - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_break) then
									l_qn := l_qn - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if ((a_num.item.mp_size).bit_xor (a_den.item.mp_size)) >= 0 then
							Current.mp_size := l_qn.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						else
							Current.mp_size := (-l_qn).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
						if not l_qp.is_equal (mp_d) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (mp_d, l_qp, l_qn)
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___5 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___5.to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mpz_divexact_by3 (a_a: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_a.is_void
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_tmp: INTEGER_32
			l_qp: CE_POINTER [NATURAL_32]
			l_tmp___0: INTEGER_32
			l_tmp___1: NATURAL_32
			l_return: BOOLEAN
		do
			l_size := (a_a.item.mp_size).to_integer_32
			if l_size = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			else
				if l_size >= 0 then
					l_tmp := l_size
				else
					l_tmp := -l_size
				end
				l_abs_size := l_tmp
				l_tmp___0 := builtin_expect ((l_abs_size > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_abs_size).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_qp := mp_d
				l_tmp___1 := (create {P_GMP_IMPL_STATIC}).gmpn_bdiv_dbm1c (l_qp, a_a.item.mp_d, l_abs_size, {NATURAL_32} 1_431_655_765, (0).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_abs_size := l_abs_size - (l_qp[(l_abs_size - 1)] = {NATURAL_32} 0).to_integer
				if l_size > 0 then
					Current.mp_size := l_abs_size.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_abs_size).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
			end
		end

	gmpz_divexact_ui (a_src: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32)
		require
			not a_src.is_void
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_dst_ptr: CE_POINTER [NATURAL_32]
			l_dlimbs: CE_ARRAY [NATURAL_32]
			l_dz: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_dlimbs.make (<<2>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_dz.make (<<1>>)

			if a_divisor = {NATURAL_32} 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			if a_divisor > {NATURAL_32} 4_294_967_295 then
				l_dz[0].mp_alloc := 2
				update_class_fields -- Current might have been changed; synchronize
				l_dz[0].mp_d := l_dlimbs
				update_class_fields -- Current might have been changed; synchronize
				l_dz.item.gmpz_set_ui (a_divisor)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_divexact (a_src, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_dz))
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_size := (a_src.item.mp_size).to_integer_32
				if l_size = 0 then
					Current.mp_size := 0
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
				if l_size >= 0 then
					l_abs_size := l_size
				else
					l_abs_size := -l_size
				end
				l_tmp := builtin_expect ((l_abs_size > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_abs_size).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_dst_ptr := mp_d
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_IMPL_STATIC}).gmpn_divexact_1 (l_dst_ptr, a_src.item.mp_d, l_abs_size, a_divisor)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_abs_size := l_abs_size - (l_dst_ptr[(l_abs_size - 1)] = {NATURAL_32} 0).to_integer
				if l_size >= 0 then
					Current.mp_size := l_abs_size.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_abs_size).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	gmpz_divisible_p (a_d: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		require
			not a_d.is_void
		local
			l_dsize: INTEGER_32
			l_asize: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
		do
			l_dsize := (a_d.item.mp_size).to_integer_32
			l_asize := mp_size.to_integer_32
			l_tmp := builtin_expect ((l_dsize = 0).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				Result := (l_asize = 0).to_integer
				l_return := True
			end
			if not l_return then
				if l_dsize >= 0 then
					l_tmp___0 := l_dsize
				else
					l_tmp___0 := -l_dsize
				end
				if l_asize >= 0 then
					l_tmp___1 := l_asize
				else
					l_tmp___1 := -l_asize
				end
				l_tmp___2 := gmpn_divisible_p (mp_d, l_tmp___1, a_d.item.mp_d, l_tmp___0)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___2
			end
		end

	gmpz_divisible_ui_p (a_d: NATURAL_32): INTEGER_32
		local
			l_d: NATURAL_32
			l_asize: INTEGER_32
			l_ap: CE_POINTER [NATURAL_32]
			l_twos: NATURAL_32
			l_tmp: INTEGER_32
			l_dlimbs: CE_ARRAY [NATURAL_32]
			l_dz: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp___0: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: INTEGER_32
			l_tmp___3: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_dlimbs.make (<<2>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_dz.make (<<1>>)

			l_d := a_d
			l_asize := mp_size.to_integer_32
			l_tmp := builtin_expect ((l_d = {NATURAL_32} 0).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				Result := (l_asize = 0).to_integer
				l_return := True
			end
			if not l_return and then (l_asize = 0) then
				Result := 1
				l_return := True
			end
			if not l_return and then (l_d > {NATURAL_32} 4_294_967_295) then
				l_dz[0].mp_alloc := 2
				update_class_fields -- Current might have been changed; synchronize
				l_dz[0].mp_d := l_dlimbs
				update_class_fields -- Current might have been changed; synchronize
				l_dz.item.gmpz_set_ui (l_d)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_divisible_p (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_dz))
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___0
				l_return := True
			end
			if not l_return then
				l_ap := mp_d
				if l_asize >= 0 then
					l_asize := l_asize
				else
					l_asize := -l_asize
				end
				if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_asize >= 22 then
						l_tmp___1 := (create {P_MOD_1_STATIC}).gmpn_mod_1 (l_ap, l_asize, l_d)
						update_class_fields -- Current might have been changed; synchronize
						Result := (l_tmp___1 = {NATURAL_32} 0).to_integer
						l_return := True
					end
				end
			end
			if not l_return and then (not ((l_d).bit_and ({NATURAL_32} 1)).to_boolean) then
				if ((l_ap[0]).bit_and ((((l_d).bit_and ((-l_d.to_integer_32).to_natural_32)) - {NATURAL_32} 1))) /= {NATURAL_32} 0 then
					Result := 0
					l_return := True
				end
				if not l_return then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_tmp___2 := builtin_ctzl (l_d)
						update_class_fields -- Current might have been changed; synchronize
						l_twos := l_tmp___2.to_natural_32
						l_break := True
					end
					l_break := False
					l_d := (l_d).bit_shift_right (l_twos.to_integer_32)
				end
			end
			if not l_return then
				l_tmp___3 := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l_ap, l_asize, l_d)
				update_class_fields -- Current might have been changed; synchronize
				Result := (l_tmp___3 = {NATURAL_32} 0).to_integer
			end
		end

	gmpz_divisible_2exp_p (a_d: NATURAL_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_dlimbs: INTEGER_32
			l_dbits: NATURAL_32
			l_ap: CE_POINTER [NATURAL_32]
			l_dmask: NATURAL_32
			l_asize: INTEGER_32
			l_return: BOOLEAN
		do
			if mp_size >= 0 then
				l_asize := mp_size.to_integer_32
			else
				l_asize := (-mp_size).to_integer_32
			end
			l_dlimbs := (a_d // {NATURAL_32} 32).to_integer_32
			if l_asize <= l_dlimbs then
				Result := (l_asize = 0).to_integer
				l_return := True
			end
			if not l_return then
				l_ap := mp_d
				l_i := (0).to_integer_32
				from
				until
					not (not (l_return) and then (l_i < l_dlimbs))
				loop
					if l_ap[l_i] /= {NATURAL_32} 0 then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				l_dbits := (a_d \\ {NATURAL_32} 32).to_natural_32
				l_dmask := (({NATURAL_32} 1).bit_shift_left (l_dbits.to_integer_32)) - {NATURAL_32} 1
				Result := (((l_ap[l_dlimbs]).bit_and (l_dmask)) = {NATURAL_32} 0).to_integer
			end
		end

	gmpz_fdiv_q_ui (a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32): NATURAL_32
		require
			not a_dividend.is_void
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_qn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_qp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_rl: NATURAL_32
			l_tmp: INTEGER_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_qp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			if a_divisor = {NATURAL_32} 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_ns := (a_dividend.item.mp_size).to_integer_32
			if l_ns = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				l_tmp := builtin_expect ((l_nn > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_nn).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_qp.item := mp_d
				update_class_fields -- Current might have been changed; synchronize
				l_np := a_dividend.item.mp_d
				l_rl := (create {P_GMP_STATIC}).gmpn_divrem_1 (l_qp.item, (0).to_integer_32, l_np, l_nn, a_divisor)
				update_class_fields -- Current might have been changed; synchronize
				if l_rl /= {NATURAL_32} 0 then
					if l_ns < 0 then
						from
						until
							(l_break)
						loop
							l_break := False
							asm15 (l___ptr_dummy, l_qp)
							l_break := True
						end
						l_break := False
						l_rl := a_divisor - l_rl
					end
				end
				l_qn := l_nn - (l_qp.item[(l_nn - 1)] = {NATURAL_32} 0).to_integer
				if l_ns >= 0 then
					Current.mp_size := l_qn.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_qn).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_rl
			end
		end

	gmpz_fdiv_qr_ui (a_rem, a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32): NATURAL_32
		require
			not a_rem.is_void
			not a_dividend.is_void
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_qn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_qp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_rl: NATURAL_32
			l_tmp: INTEGER_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_qp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			if a_divisor = {NATURAL_32} 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_ns := (a_dividend.item.mp_size).to_integer_32
			if l_ns = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				a_rem.item.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				l_tmp := builtin_expect ((l_nn > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_nn).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_qp.item := mp_d
				update_class_fields -- Current might have been changed; synchronize
				l_np := a_dividend.item.mp_d
				l_rl := (create {P_GMP_STATIC}).gmpn_divrem_1 (l_qp.item, (0).to_integer_32, l_np, l_nn, a_divisor)
				update_class_fields -- Current might have been changed; synchronize
				if l_rl = {NATURAL_32} 0 then
					a_rem.item.mp_size := 0
					update_class_fields -- Current might have been changed; synchronize
				else
					if l_ns < 0 then
						from
						until
							(l_break)
						loop
							l_break := False
							asm16 (l___ptr_dummy, l_qp)
							l_break := True
						end
						l_break := False
						l_rl := a_divisor - l_rl
					end
					a_rem.item.mp_d[0] := l_rl
					update_class_fields -- Current might have been changed; synchronize
					a_rem.item.mp_size := (l_rl /= {NATURAL_32} 0).to_integer
					update_class_fields -- Current might have been changed; synchronize
				end
				l_qn := l_nn - (l_qp.item[(l_nn - 1)] = {NATURAL_32} 0).to_integer
				if l_ns >= 0 then
					Current.mp_size := l_qn.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_qn).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_rl
			end
		end

	gmpz_fdiv_r_ui (a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32): NATURAL_32
		require
			not a_dividend.is_void
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_rl: NATURAL_32
			l_return: BOOLEAN
		do
			if a_divisor = {NATURAL_32} 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_ns := (a_dividend.item.mp_size).to_integer_32
			if l_ns = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				l_np := a_dividend.item.mp_d
				l_rl := (create {P_MOD_1_STATIC}).gmpn_mod_1 (l_np, l_nn, a_divisor)
				update_class_fields -- Current might have been changed; synchronize
				if l_rl = {NATURAL_32} 0 then
					Current.mp_size := 0
					update_class_fields -- Current might have been changed; synchronize
				else
					if l_ns < 0 then
						l_rl := a_divisor - l_rl
					end
					mp_d[0] := l_rl
					update_class_fields -- Current might have been changed; synchronize
					Current.mp_size := 1
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_rl
			end
		end

	gmpz_fdiv_ui (a_divisor: NATURAL_32): NATURAL_32
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_rl: NATURAL_32
			l_return: BOOLEAN
		do
			if a_divisor = {NATURAL_32} 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_ns := mp_size.to_integer_32
			if l_ns = 0 then
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				l_np := mp_d
				l_rl := (create {P_MOD_1_STATIC}).gmpn_mod_1 (l_np, l_nn, a_divisor)
				update_class_fields -- Current might have been changed; synchronize
				if l_rl /= {NATURAL_32} 0 then
					if l_ns < 0 then
						l_rl := a_divisor - l_rl
					end
				end
				Result := l_rl
			end
		end

	gmpz_fib_ui (a_n: NATURAL_32)
		local
			l_fp: CE_POINTER [NATURAL_32]
			l_xp: CE_POINTER [NATURAL_32]
			l_yp: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_xalloc: INTEGER_32
			l_n2: NATURAL_32
			l_c: NATURAL_32
			l_c2: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_tmp___12: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___14: INTEGER_32
			l_xsize: INTEGER_32
			l_ysize: INTEGER_32
			l_tmp___15: NATURAL_32
			l_tmp___16: NATURAL_32
			l_tmp___17: NATURAL_32
			l_xsize___0: INTEGER_32
			l_ysize___0: INTEGER_32
			l_tmp___18: NATURAL_32
			l_tmp___19: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			if a_n <= {NATURAL_32} 47 then
				mp_d[0] := gmp_fib_table.item[(a_n + {NATURAL_32} 1).to_integer_32]
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_size := (a_n /= {NATURAL_32} 0).to_integer
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_n2 := a_n // {NATURAL_32} 2
				l_xalloc := ((((l_n2 // {NATURAL_32} 32) * {NATURAL_32} 23) // {NATURAL_32} 32).to_integer_32 + 4) + 1
				l_tmp := builtin_expect ((2 * l_xalloc + 1 > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (2 * l_xalloc + 1).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_fp := mp_d
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___14 := builtin_expect (((l_xalloc + l_xalloc).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___14.to_boolean then
						l_tmp___13 := (l_aaf.new (((l_xalloc + l_xalloc).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___12 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_xalloc + l_xalloc).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___13 := l_tmp___12
					end
					l_xp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___13)
					l_yp := l_xp + l_xalloc
					l_break := True
				end
				l_break := False
				l_size := gmpn_fib2_ui (l_xp, l_yp, l_n2)
				update_class_fields -- Current might have been changed; synchronize
				if ((a_n).bit_and ({NATURAL_32} 1)).to_boolean then
					l_c2 := (create {P_GMP_STATIC}).gmpn_lshift (l_fp, l_xp, l_size, {NATURAL_32} 1)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___15 := (create {P_GMP_STATIC}).gmpn_add_n (l_xp, l_fp, l_yp, l_size)
					update_class_fields -- Current might have been changed; synchronize
					l_c := l_c2 + l_tmp___15
					l_xp[l_size] := l_c
					update_class_fields -- Current might have been changed; synchronize
					l_xsize := l_size + (l_c /= {NATURAL_32} 0).to_integer
					l_tmp___16 := (create {P_GMP_STATIC}).gmpn_sub_n (l_yp, l_fp, l_yp, l_size)
					update_class_fields -- Current might have been changed; synchronize
					l_c2 := l_c2 - l_tmp___16
					l_yp[l_size] := l_c2
					update_class_fields -- Current might have been changed; synchronize
					l_ysize := (l_size.to_natural_32 + l_c2).to_integer_32
					l_size := l_xsize + l_ysize
					l_c := (create {P_MUL_STATIC}).gmpn_mul (l_fp, l_xp, l_xsize, l_yp, l_ysize)
					update_class_fields -- Current might have been changed; synchronize
					if ((a_n).bit_and ({NATURAL_32} 2)).to_boolean then
						l_tmp___17 := (-((2).to_natural_32).to_integer_32).to_natural_32
					else
						l_tmp___17 := (2).to_natural_32
					end
					l_fp[0] := l_fp[0] + l_tmp___17
					update_class_fields -- Current might have been changed; synchronize
				else
					l_c := (create {P_GMP_STATIC}).gmpn_lshift (l_yp, l_yp, l_size, {NATURAL_32} 1)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___18 := (create {P_GMP_STATIC}).gmpn_add_n (l_yp, l_yp, l_xp, l_size)
					update_class_fields -- Current might have been changed; synchronize
					l_c := l_c + l_tmp___18
					l_yp[l_size] := l_c
					update_class_fields -- Current might have been changed; synchronize
					l_xsize___0 := l_size
					l_ysize___0 := l_size + (l_c /= {NATURAL_32} 0).to_integer
					l_size := l_size + l_ysize___0
					l_c := (create {P_MUL_STATIC}).gmpn_mul (l_fp, l_yp, l_ysize___0, l_xp, l_xsize___0)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_size := l_size - (l_c = {NATURAL_32} 0).to_integer
				l_size := l_size - (l_fp[(l_size - 1)] = {NATURAL_32} 0).to_integer
				Current.mp_size := l_size.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___19 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___19.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpz_fib2_ui (a_fnsub1: CE_POINTER [PD_MPZ_STRUCT]; a_n: NATURAL_32)
		require
			not a_fnsub1.is_void
		local
			l_fp: CE_POINTER [NATURAL_32]
			l_f1p: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_size := (((a_n // {NATURAL_32} 32) * {NATURAL_32} 23) // {NATURAL_32} 32).to_integer_32 + 4
			l_tmp := builtin_expect ((l_size > mp_alloc.to_integer_32).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_size).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			l_tmp___0 := builtin_expect ((l_size > (a_fnsub1.item.mp_alloc).to_integer_32).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___0.to_boolean then
				a_fnsub1.item.gmpz_realloc (l_size).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			l_fp := mp_d
			l_f1p := a_fnsub1.item.mp_d
			l_size := gmpn_fib2_ui (l_fp, l_f1p, a_n)
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_size := (l_size - (a_n = {NATURAL_32} 0).to_integer).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			a_fnsub1.item.mp_size := (l_size - (l_f1p[(l_size - 1)] = {NATURAL_32} 0).to_integer).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_fits_sint_p: INTEGER_32
		local
			l_n: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_limb: NATURAL_32
			l_return: BOOLEAN
		do
			l_n := mp_size.to_integer_32
			l_p := mp_d
			l_limb := l_p[0]
			if l_n = 0 then
				Result := 1
				l_return := True
			end
			if not l_return and then (l_n = 1) then
				Result := (l_limb <= (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)).to_natural_32).to_integer
				l_return := True
			end
			if not l_return and then (l_n = -1) then
				Result := (l_limb <= (-(((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32).to_natural_32).to_integer_32).to_natural_32).to_integer
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	gmpz_fits_slong_p: INTEGER_32
		local
			l_n: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_limb: NATURAL_32
			l_return: BOOLEAN
		do
			l_n := mp_size.to_integer_32
			l_p := mp_d
			l_limb := l_p[0]
			if l_n = 0 then
				Result := 1
				l_return := True
			end
			if not l_return and then (l_n = 1) then
				Result := (l_limb <= (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)).to_natural_32).to_integer
				l_return := True
			end
			if not l_return and then (l_n = -1) then
				Result := (l_limb <= (-(((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32).to_natural_32).to_integer_32).to_natural_32).to_integer
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	gmpz_fits_sshort_p: INTEGER_32
		local
			l_n: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_limb: NATURAL_32
			l_return: BOOLEAN
		do
			l_n := mp_size.to_integer_32
			l_p := mp_d
			l_limb := l_p[0]
			if l_n = 0 then
				Result := 1
				l_return := True
			end
			if not l_return and then (l_n = 1) then
				Result := (l_limb <= ((-(((((65_535).bit_xor (((65_535).bit_shift_right (1)))).to_natural_16).to_integer_16).to_integer_32 + 1)).to_integer_16).to_natural_32).to_integer
				l_return := True
			end
			if not l_return and then (l_n = -1) then
				Result := (l_limb <= (-(((((65_535).bit_xor (((65_535).bit_shift_right (1)))).to_natural_16).to_integer_16).to_natural_32).to_integer_32).to_natural_32).to_integer
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	gmpz_gcd (a_u, a_v: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_u.is_void
			not a_v.is_void
		local
			l_g_zero_bits: NATURAL_32
			l_u_zero_bits: NATURAL_32
			l_v_zero_bits: NATURAL_32
			l_g_zero_limbs: INTEGER_32
			l_u_zero_limbs: INTEGER_32
			l_v_zero_limbs: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_tmp: INTEGER_32
			l_vp: CE_POINTER [NATURAL_32]
			l_vsize: INTEGER_32
			l_tmp___0: INTEGER_32
			l_gsize: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___1: INTEGER_32
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___10: CE_POINTER [ANY]
			l_tmp___11: CE_POINTER [ANY]
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_cy_limb: NATURAL_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___15: CE_POINTER [NATURAL_32]
			l___dst___0: CE_POINTER [NATURAL_32]
			l___n___0: INTEGER_32
			l_tmp___16: CE_POINTER [NATURAL_32]
			l_tmp___17: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_up := a_u.item.mp_d
			if a_u.item.mp_size >= 0 then
				l_tmp := a_u.item.mp_size
			else
				l_tmp := -a_u.item.mp_size
			end
			l_usize := l_tmp.to_integer_32
			l_vp := a_v.item.mp_d
			if a_v.item.mp_size >= 0 then
				l_tmp___0 := a_v.item.mp_size
			else
				l_tmp___0 := -a_v.item.mp_size
			end
			l_vsize := l_tmp___0.to_integer_32
			if l_usize = 0 then
				Current.mp_size := l_vsize.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				if (c_pointer = (a_v).c_pointer) then
					l_return := True
				end
				if not l_return then
					if mp_alloc.to_integer_32 < l_vsize then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_vsize).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (mp_d, l_vp, l_vsize)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_return := True
				end
			end
			if not l_return and then (l_vsize = 0) then
				Current.mp_size := l_usize.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				if (c_pointer = (a_u).c_pointer) then
					l_return := True
				end
				if not l_return then
					if mp_alloc.to_integer_32 < l_usize then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_usize).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (mp_d, l_up, l_usize)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_return := True
				end
			end
			if not l_return and then (l_usize = 1) then
				Current.mp_size := 1
				update_class_fields -- Current might have been changed; synchronize
				mp_d[0] := (create {P_GCD_1_STATIC}).gmpn_gcd_1 (l_vp, l_vsize, l_up[0])
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return and then (l_vsize = 1) then
				Current.mp_size := 1
				update_class_fields -- Current might have been changed; synchronize
				mp_d[0] := (create {P_GCD_1_STATIC}).gmpn_gcd_1 (l_up, l_usize, l_vp[0])
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					l_up.item /= {NATURAL_32} 0
				loop
					l_up := l_up + 1
				end
				l_u_zero_limbs := (l_up.distance ((a_u.item.mp_d))).to_integer_32
				l_usize := l_usize - l_u_zero_limbs
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_tmp___1 := builtin_ctzl (l_up.item)
					update_class_fields -- Current might have been changed; synchronize
					l_u_zero_bits := l_tmp___1.to_natural_32
					l_break := True
				end
				l_break := False
				l_tp := l_up
				l_tmp___6 := builtin_expect ((l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___6.to_boolean then
					l_tmp___5 := (l_aaf.new ((l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___4 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___5 := l_tmp___4
				end
				l_up := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___5)
				if l_u_zero_bits /= {NATURAL_32} 0 then
					(create {P_GMP_STATIC}).gmpn_rshift (l_up, l_tp, l_usize, l_u_zero_bits.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_usize := l_usize - (l_up[(l_usize - 1)] = {NATURAL_32} 0).to_integer
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_up, l_tp, l_usize)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				end
				from
				until
					l_vp.item /= {NATURAL_32} 0
				loop
					l_vp := l_vp + 1
				end
				l_v_zero_limbs := (l_vp.distance ((a_v.item.mp_d))).to_integer_32
				l_vsize := l_vsize - l_v_zero_limbs
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_tmp___7 := builtin_ctzl (l_vp.item)
					update_class_fields -- Current might have been changed; synchronize
					l_v_zero_bits := l_tmp___7.to_natural_32
					l_break := True
				end
				l_break := False
				l_tp := l_vp
				l_tmp___12 := builtin_expect ((l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___12.to_boolean then
					l_tmp___11 := (l_aaf.new ((l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___10 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___11 := l_tmp___10
				end
				l_vp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___11)
				if l_v_zero_bits /= {NATURAL_32} 0 then
					(create {P_GMP_STATIC}).gmpn_rshift (l_vp, l_tp, l_vsize, l_v_zero_bits.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_vsize := l_vsize - (l_vp[(l_vsize - 1)] = {NATURAL_32} 0).to_integer
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_vp, l_tp, l_vsize)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				end
				if l_u_zero_limbs > l_v_zero_limbs then
					l_g_zero_limbs := l_v_zero_limbs
					l_g_zero_bits := l_v_zero_bits
				elseif l_u_zero_limbs < l_v_zero_limbs then
					l_g_zero_limbs := l_u_zero_limbs
					l_g_zero_bits := l_u_zero_bits
				else
					l_g_zero_limbs := l_u_zero_limbs
					if l_u_zero_bits < l_v_zero_bits then
						l_g_zero_bits := l_u_zero_bits
					else
						l_g_zero_bits := l_v_zero_bits
					end
				end
				if l_usize < l_vsize then
					l_tmp___13 := gmpn_gcd (l_vp, l_vp, l_vsize, l_up, l_usize)
					update_class_fields -- Current might have been changed; synchronize
					l_vsize := l_tmp___13
				elseif l_usize = l_vsize then
					if l_up[(l_usize - 1)] < l_vp[(l_vsize - 1)] then
						l_tmp___13 := gmpn_gcd (l_vp, l_vp, l_vsize, l_up, l_usize)
						update_class_fields -- Current might have been changed; synchronize
						l_vsize := l_tmp___13
					else
						l_tmp___14 := gmpn_gcd (l_vp, l_up, l_usize, l_vp, l_vsize)
						update_class_fields -- Current might have been changed; synchronize
						l_vsize := l_tmp___14
					end
				else
					l_tmp___14 := gmpn_gcd (l_vp, l_up, l_usize, l_vp, l_vsize)
					update_class_fields -- Current might have been changed; synchronize
					l_vsize := l_tmp___14
				end
				l_gsize := l_vsize + l_g_zero_limbs
				if l_g_zero_bits /= {NATURAL_32} 0 then
					l_gsize := l_gsize + ((l_vp[(l_vsize - 1)]).bit_shift_right (({NATURAL_32} 32 - l_g_zero_bits).to_integer_32) /= {NATURAL_32} 0).to_integer
					if mp_alloc.to_integer_32 < l_gsize then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_gsize).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_g_zero_limbs /= 0 then
							l___dst := mp_d
							l___n := l_g_zero_limbs
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___15 := l___dst
								l___dst := l___dst + 1
								l_tmp___15.item := (0).to_natural_32
								update_class_fields -- Current might have been changed; synchronize
								l___n := l___n - 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					l_tp := mp_d + l_g_zero_limbs
					l_cy_limb := (create {P_GMP_STATIC}).gmpn_lshift (l_tp, l_vp, l_vsize, l_g_zero_bits.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_cy_limb /= {NATURAL_32} 0 then
						l_tp[l_vsize] := l_cy_limb
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					if mp_alloc.to_integer_32 < l_gsize then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_gsize).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_g_zero_limbs /= 0 then
							l___dst___0 := mp_d
							l___n___0 := l_g_zero_limbs
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___16 := l___dst___0
								l___dst___0 := l___dst___0 + 1
								l_tmp___16.item := (0).to_natural_32
								update_class_fields -- Current might have been changed; synchronize
								l___n___0 := l___n___0 - 1
								if not l___n___0.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (mp_d + l_g_zero_limbs, l_vp, l_vsize)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				end
				Current.mp_size := l_gsize.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___17 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___17.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpz_gcdext (a_s, a_t, a_a, a_b: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_a.is_void
			not a_b.is_void
		local
			l_asize: INTEGER_32
			l_bsize: INTEGER_32
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_ap: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_gsize: INTEGER_32
			l_ssize: INTEGER_32
			l_tmp_ssize: CE_ARRAY [INTEGER_32]
			l_gp: CE_POINTER [NATURAL_32]
			l_sp: CE_POINTER [NATURAL_32]
			l_tmp_gp: CE_POINTER [NATURAL_32]
			l_tmp_sp: CE_POINTER [NATURAL_32]
			l_u: CE_POINTER [PD_MPZ_STRUCT]
			l_v: CE_POINTER [PD_MPZ_STRUCT]
			l_ss: CE_POINTER [PD_MPZ_STRUCT]
			l_tt: CE_POINTER [PD_MPZ_STRUCT]
			l_stmp: CE_ARRAY [PD_MPZ_STRUCT]
			l_gtmp: CE_ARRAY [PD_MPZ_STRUCT]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: INTEGER_32
			l_tmp___6: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___8: INTEGER_32
			l_tmp___11: CE_POINTER [ANY]
			l_tmp___12: CE_POINTER [ANY]
			l_tmp___13: INTEGER_32
			l_tmp___16: CE_POINTER [ANY]
			l_tmp___17: CE_POINTER [ANY]
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___22: CE_POINTER [ANY]
			l_tmp___23: CE_POINTER [ANY]
			l_tmp___24: INTEGER_32
			l_tmp___27: CE_POINTER [ANY]
			l_tmp___28: CE_POINTER [ANY]
			l_tmp___29: INTEGER_32
			l_x___2: CE_ARRAY [PD_MPZ_STRUCT]
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___32: CE_POINTER [ANY]
			l_tmp___33: CE_POINTER [ANY]
			l_tmp___34: INTEGER_32
			l_tmp___35: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_INTEGER_32_ARRAY} l_tmp_ssize.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_stmp.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_gtmp.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_x___2.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					if a_a.item.mp_size >= 0 then
						l_asize := (a_a.item.mp_size).to_integer_32
					else
						l_asize := (-a_a.item.mp_size).to_integer_32
					end
					if a_b.item.mp_size >= 0 then
						l_bsize := (a_b.item.mp_size).to_integer_32
					else
						l_bsize := (-a_b.item.mp_size).to_integer_32
					end
					l_ap := a_a.item.mp_d
					l_bp := a_b.item.mp_d
					if not (l_asize > l_bsize) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if l_asize /= l_bsize then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						l_tmp___19 := (create {P_GMP_STATIC}).gmpn_cmp (l_ap, l_bp, l_asize)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___19 > 0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						l_usize := l_asize
						l_vsize := l_bsize
						l_tmp___3 := builtin_expect (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___3.to_boolean then
							l_tmp___2 := (l_aaf.new (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___1 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___2 := l_tmp___1
						end
						l_up := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
						l_tmp___8 := builtin_expect (((l_vsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___8.to_boolean then
							l_tmp___7 := (l_aaf.new (((l_vsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___6 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_vsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___7 := l_tmp___6
						end
						l_vp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___7)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_up, l_ap, l_usize)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_vp, l_bp, l_vsize)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_u := a_a
						l_v := a_b
						l_ss := a_s
						l_tt := a_t
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 9 -- goto _L___0
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___0:
						l_usize := l_bsize
						l_vsize := l_asize
						l_tmp___13 := builtin_expect (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___13.to_boolean then
							l_tmp___12 := (l_aaf.new (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___11 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___12 := l_tmp___11
						end
						l_up := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___12)
						l_tmp___18 := builtin_expect (((l_vsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___18.to_boolean then
							l_tmp___17 := (l_aaf.new (((l_vsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___16 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_vsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___17 := l_tmp___16
						end
						l_vp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___17)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_up, l_bp, l_usize)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_vp, l_ap, l_vsize)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_u := a_b
						l_v := a_a
						l_ss := a_t
						l_tt := a_s
				when 10 then -- if done
					l_tmp___24 := builtin_expect (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___24.to_boolean then
						l_tmp___23 := (l_aaf.new (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___22 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___23 := l_tmp___22
					end
					l_tmp_gp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___23)
					l_tmp___29 := builtin_expect (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___29.to_boolean then
						l_tmp___28 := (l_aaf.new (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___27 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___28 := l_tmp___27
					end
					l_tmp_sp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___28)
					if l_vsize = 0 then
						l_tmp_sp[0] := (1).to_natural_32
						update_class_fields -- Current might have been changed; synchronize
						l_tmp_ssize.item := (1).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_tmp_gp, l_up, l_usize)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_gsize := l_usize
					else
						l_gsize := gmpn_gcdext (l_tmp_gp, l_tmp_sp, l_tmp_ssize, l_up, l_usize, l_vp, l_vsize)
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_tmp_ssize.item >= 0 then
						l_ssize := l_tmp_ssize.item
					else
						l_ssize := -l_tmp_ssize.item
					end
					l_gtmp.item.mp_d := l_tmp_gp
					update_class_fields -- Current might have been changed; synchronize
					l_gtmp.item.mp_size := l_gsize.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_stmp.item.mp_d := l_tmp_sp
					update_class_fields -- Current might have been changed; synchronize
					if ((l_tmp_ssize.item).bit_xor ((l_u.item.mp_size).to_integer_32)) >= 0 then
						l_stmp.item.mp_size := l_ssize.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					else
						l_stmp.item.mp_size := (-l_ssize).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					end
					if not l_tt.is_void then
						if l_v.item.mp_size = 0 then
							l_tt.item.mp_size := 0
							update_class_fields -- Current might have been changed; synchronize
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l___x := l_x___2
								l___x.item.mp_alloc := ((l_ssize + l_usize) + 1).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___34 := builtin_expect ((((l_ssize + l_usize) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___34.to_boolean then
									l_tmp___33 := (l_aaf.new ((((l_ssize + l_usize) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								else
									l_tmp___32 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (((l_ssize + l_usize) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___33 := l_tmp___32
								end
								l___x.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___33)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
							l_x___2.item.gmpz_mul (l_stmp, l_u)
							update_class_fields -- Current might have been changed; synchronize
							l_x___2.item.gmpz_sub (l_gtmp, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x___2))
							update_class_fields -- Current might have been changed; synchronize
							l_tt.item.gmpz_tdiv_q (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x___2), l_v)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if not l_ss.is_void then
						if (l_ss.item.mp_alloc).to_integer_32 < l_ssize then
							l_ss.item.gmpz_realloc (l_ssize).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						l_sp := l_ss.item.mp_d
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_sp, l_tmp_sp, l_ssize)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_ss.item.mp_size := l_stmp.item.mp_size
						update_class_fields -- Current might have been changed; synchronize
					end
					if mp_alloc.to_integer_32 < l_gsize then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_gsize).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					l_gp := mp_d
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_gp, l_tmp_gp, l_gsize)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					Current.mp_size := l_gsize.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___35 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___35.to_boolean then
							(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_break := True
					end
					l_break := False
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_get_d: REAL_64
		local
			l_size: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: REAL_64
			l_return: BOOLEAN
		do
			l_size := mp_size.to_integer_32
			l_tmp := builtin_expect ((l_size = 0).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				if l_size >= 0 then
					l_tmp___0 := l_size
				else
					l_tmp___0 := -l_size
				end
				l_tmp___1 := (create {P_GET_D_STATIC}).gmpn_get_d (mp_d, l_tmp___0, l_size, 0)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___1
			end
		end

	gmpz_get_d_2exp (a_exp2: CE_POINTER [INTEGER_32]): REAL_64
		require
			not a_exp2.is_void
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_32]
			l_cnt: INTEGER_32
			l_exp: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: REAL_64
			l_return, l_break: BOOLEAN
		do
			l_size := mp_size.to_integer_32
			l_tmp := builtin_expect ((l_size = 0).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				a_exp2.item := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				l_ptr := mp_d
				if l_size >= 0 then
					l_abs_size := l_size
				else
					l_abs_size := -l_size
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_cnt := builtin_clzl (l_ptr[(l_abs_size - 1)])
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_exp := l_abs_size * 32 - l_cnt.to_integer_32
				a_exp2.item := l_exp
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := (create {P_GET_D_STATIC}).gmpn_get_d (l_ptr, l_abs_size, l_size, -l_exp)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___0
			end
		end

	gmpz_get_si: INTEGER_32
		local
			l_zp: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_zl: NATURAL_32
		do
			l_zp := mp_d
			l_size := mp_size.to_integer_32
			l_zl := l_zp[0]
			if l_size > 0 then
				Result := ((l_zl.to_integer_32).bit_and (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)))
			elseif l_size < 0 then
				Result := (((((l_zl.to_integer_32 - 1)).bit_and (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)))).bit_not)
			else
				Result := 0
			end
		end

	gmpz_get_str (a_res_str: CE_POINTER [INTEGER_8]; a_base: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_res_str: CE_POINTER [INTEGER_8]
			l_base: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l_x_size: INTEGER_32
			l_str: CE_POINTER [INTEGER_8]
			l_return_str: CE_POINTER [INTEGER_8]
			l_str_size: NATURAL_32
			l_alloc_size: NATURAL_32
			l_num_to_text: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___lb_base: INTEGER_32
			l___cnt: INTEGER_32
			l___totbits: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_actual_size: NATURAL_32
			l_tmp___10: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_res_str := a_res_str
			l_base := a_base
			l_x_size := mp_size.to_integer_32
			l_alloc_size := (0).to_natural_32
			if l_base >= 0 then
				l_num_to_text := ce_string ("0123456789abcdefghijklmnopqrstuvwxyz")
				if l_base = 0 then
					l_base := 10
				elseif l_base > 36 then
					l_num_to_text := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz")
					if l_base > 62 then
						Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
				end
			else
				l_base := -l_base
				l_num_to_text := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ")
			end
			if not l_return then
				if l_res_str.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_x_size >= 0 then
							l_tmp___1 := l_x_size
						else
							l_tmp___1 := -l_x_size
						end
						if l_tmp___1 = 0 then
							l_alloc_size := (1).to_natural_32
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_x_size >= 0 then
									l_tmp := l_x_size
								else
									l_tmp := -l_x_size
								end
								l___cnt := builtin_clzl (mp_d[(l_tmp - 1)])
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
							if l_x_size >= 0 then
								l_tmp___0 := l_x_size
							else
								l_tmp___0 := -l_x_size
							end
							l___totbits := l_tmp___0.to_natural_32 * {NATURAL_32} 32 - l___cnt.to_natural_32
							if ((l_base).bit_and ((l_base - 1))) = 0 then
								l___lb_base := ((create {P_MP_BASES_STATIC}).gmpn_bases.item[l_base].big_base).to_integer_32
								l_alloc_size := ((l___totbits + l___lb_base.to_natural_32) - {NATURAL_32} 1) // l___lb_base.to_natural_32
							else
								l_alloc_size := (l___totbits.to_real_64 * (create {P_MP_BASES_STATIC}).gmpn_bases.item[l_base].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32 + {NATURAL_32} 1
							end
						end
						l_break := True
					end
					l_break := False
					l_alloc_size := l_alloc_size + (1 + (l_x_size < 0).to_integer).to_natural_32
					l_tmp___2 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([l_alloc_size]))
					update_class_fields -- Current might have been changed; synchronize
					l_res_str := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___2)
				end
				l_return_str := l_res_str
				if l_x_size < 0 then
					l_tmp___3 := l_res_str
					l_res_str := l_res_str + 1
					l_tmp___3[0] := (('-').code).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_x_size := -l_x_size
				end
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_xp := mp_d
				if ((l_base).bit_and ((l_base - 1))) /= 0 then
					l_tmp___8 := builtin_expect (((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___8.to_boolean then
						l_tmp___7 := (l_aaf.new (((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___6 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___7 := l_tmp___6
					end
					l_xp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___7)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_xp, mp_d, l_x_size)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				end
				l_str_size := (create {P_GET_STR_STATIC}).gmpn_get_str (create {CE_NATURAL_8_POINTER}.make_cast (l_res_str), l_base, l_xp, l_x_size)
				update_class_fields -- Current might have been changed; synchronize
				l_str := l_res_str
				if (l_res_str[0]).to_integer_32 = 0 then
					if l_str_size /= {NATURAL_32} 1 then
						l_str_size := l_str_size - 1
						l_str := l_str + 1
					end
				end
				l_i := 0
				from
				until
					not (l_i.to_natural_32 < l_str_size)
				loop
					l_res_str[l_i] := l_num_to_text[(l_str[l_i]).to_integer_32]
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_res_str[l_str_size.to_integer_32] := (0).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___9 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___9.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
				if l_alloc_size /= {NATURAL_32} 0 then
					l_actual_size := (l_str_size + {NATURAL_32} 1) + (l_res_str.distance (l_return_str)).to_natural_32
					from
					until
						(l_break)
					loop
						l_break := False
						if l_alloc_size /= l_actual_size then
							l_tmp___10 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_return_str), l_alloc_size * {PLATFORM}.Integer_8_bytes.to_natural_32, l_actual_size * {PLATFORM}.Integer_8_bytes.to_natural_32]))
							update_class_fields -- Current might have been changed; synchronize
							l_return_str := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___10)
						end
						l_break := True
					end
					l_break := False
				end
				Result := l_return_str
			end
		end

	gmpz_hamdist (a_v: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		require
			not a_v.is_void
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_count: NATURAL_32
			l___mp_srcptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp: INTEGER_32
			l_tmp: NATURAL_32
			l_ulimb: NATURAL_32
			l_vlimb: NATURAL_32
			l_old_vsize: INTEGER_32
			l_step___1: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_32]
			l_tmp___1: CE_POINTER [NATURAL_32]
			l___mp_srcptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp___0: INTEGER_32
			l___x: NATURAL_32
			l_twoscount: NATURAL_32
			l_tmp___2: CE_POINTER [NATURAL_32]
			l_tmp___3: NATURAL_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			l___x___0: NATURAL_32
			l_tmp___5: NATURAL_32
			l_tmp___6: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_usize := mp_size.to_integer_32
					l_vsize := (a_v.item.mp_size).to_integer_32
					l_up := mp_d
					l_vp := a_v.item.mp_d
					if not (l_usize >= 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_vsize < 0 then
							Result := (((0).to_natural_32).bit_not)
							l_return := True
						end
						if not l_return then
							if l_usize < l_vsize then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_break)
									loop
										l_break := False
										l___mp_srcptr_swap__tmp := l_up
										l_up := l_vp
										l_vp := l___mp_srcptr_swap__tmp
										l_break := True
									end
									l_break := False
									from
									until
										(l_break)
									loop
										l_break := False
										l___mp_size_t_swap__tmp := l_usize
										l_usize := l_vsize
										l_vsize := l___mp_size_t_swap__tmp
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
							end
							l_count := (0).to_natural_32
							if l_vsize /= 0 then
								l_count := gmpn_hamdist (l_up, l_vp, l_vsize)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_usize := l_usize - l_vsize
							if l_usize /= 0 then
								l_tmp := gmpn_popcount (l_up + l_vsize, l_usize)
								update_class_fields -- Current might have been changed; synchronize
								l_count := l_count + l_tmp
							end
							Result := l_count
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 3 then -- else:
						if l_vsize >= 0 then
							Result := (((0).to_natural_32).bit_not)
							l_return := True
						end
						if l_return then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						l_usize := -l_usize
						l_vsize := -l_vsize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_usize := l_usize - 1
							l_vsize := l_vsize - 1
							l_tmp___0 := l_up
							l_up := l_up + 1
							l_ulimb := l_tmp___0.item
							l_tmp___1 := l_vp
							l_vp := l_vp + 1
							l_vlimb := l_tmp___1.item
							if l_ulimb /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_return or l_break) and then (l_vlimb /= {NATURAL_32} 0) then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_break)
									loop
										l_break := False
										l___mp_srcptr_swap__tmp___0 := l_up
										l_up := l_vp
										l_vp := l___mp_srcptr_swap__tmp___0
										l_break := True
									end
									l_break := False
									from
									until
										(l_break)
									loop
										l_break := False
										l___mp_size_t_swap__tmp___0 := l_usize
										l_usize := l_vsize
										l_vsize := l___mp_size_t_swap__tmp___0
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								l_ulimb := l_vlimb
								l_vlimb := (0).to_natural_32
								l_break := True
							end
						end
						l_break := False
						l_ulimb := (-l_ulimb.to_integer_32).to_natural_32
						l_vlimb := (-l_vlimb.to_integer_32).to_natural_32
						from
						until
							(l_break)
						loop
							l_break := False
							l___x := (((l_ulimb).bit_xor (l_vlimb))).bit_and ({NATURAL_32} 4_294_967_295)
							l___x := l___x - ((((l___x).bit_shift_right (1))).bit_and ({NATURAL_32} 1_431_655_765))
							l___x := ((((l___x).bit_shift_right (2))).bit_and ({NATURAL_32} 858_993_459)) + ((l___x).bit_and ({NATURAL_32} 858_993_459))
							l___x := ((((l___x).bit_shift_right (4)) + l___x)).bit_and ({NATURAL_32} 252_645_135)
							l___x := ((l___x).bit_shift_right (8)) + l___x
							l___x := ((l___x).bit_shift_right (16)) + l___x
							l_count := (l___x).bit_and ({NATURAL_32} 255)
							l_break := True
						end
						l_break := False
						if l_vlimb = {NATURAL_32} 0 then
							l_old_vsize := l_vsize
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_vsize := l_vsize - 1
								l_tmp___2 := l_vp
								l_vp := l_vp + 1
								l_vlimb := l_tmp___2.item
								if l_vlimb /= {NATURAL_32} 0 then
									l_break := True
								end
							end
							l_break := False
							l_step___1 := (l_old_vsize - l_vsize) - 1
							l_count := l_count + (l_step___1 * 32).to_natural_32
							if l_step___1 < l_usize then
								l_step___1 := l_step___1
							else
								l_step___1 := l_usize
							end
							if l_step___1 /= 0 then
								l_tmp___3 := gmpn_popcount (l_up, l_step___1)
								update_class_fields -- Current might have been changed; synchronize
								l_count := l_count - l_tmp___3
								l_usize := l_usize - l_step___1
								l_up := l_up + l_step___1
							end
							l_vlimb := l_vlimb - 1
							if l_usize /= 0 then
								l_usize := l_usize - 1
								l_tmp___4 := l_up
								l_up := l_up + 1
								l_vlimb := (l_vlimb).bit_xor ((l_tmp___4.item))
							end
							from
							until
								(l_break)
							loop
								l_break := False
								l___x___0 := l_vlimb
								l___x___0 := l___x___0 - ((((l___x___0).bit_shift_right (1))).bit_and ({NATURAL_32} 1_431_655_765))
								l___x___0 := ((((l___x___0).bit_shift_right (2))).bit_and ({NATURAL_32} 858_993_459)) + ((l___x___0).bit_and ({NATURAL_32} 858_993_459))
								l___x___0 := ((((l___x___0).bit_shift_right (4)) + l___x___0)).bit_and ({NATURAL_32} 252_645_135)
								l___x___0 := ((l___x___0).bit_shift_right (8)) + l___x___0
								l___x___0 := ((l___x___0).bit_shift_right (16)) + l___x___0
								l_twoscount := (l___x___0).bit_and ({NATURAL_32} 255)
								l_break := True
							end
							l_break := False
							l_count := l_count + l_twoscount
						end
						if l_usize < l_vsize then
							l_step___1 := l_usize
						else
							l_step___1 := l_vsize
						end
						if l_step___1 /= 0 then
							l_tmp___5 := gmpn_hamdist (l_up, l_vp, l_step___1)
							update_class_fields -- Current might have been changed; synchronize
							l_count := l_count + l_tmp___5
							l_usize := l_usize - l_step___1
							l_vsize := l_vsize - l_step___1
							l_up := l_up + l_step___1
							l_vp := l_vp + l_step___1
						end
						if l_usize = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | remaining:
						l_tmp___6 := gmpn_popcount (l_up, l_usize)
						update_class_fields -- Current might have been changed; synchronize
						l_count := l_count + l_tmp___6
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						if l_vsize /= 0 then
							l_up := l_vp
							l_usize := l_vsize
							l_pos := -1 + 5 -- goto remaining
						end
				when 8 then
						Result := l_count
				when 9 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_import (a_count: NATURAL_32; a_order: INTEGER_32; a_size: NATURAL_32; a_endian: INTEGER_32; a_nail: NATURAL_32; a_data: CE_POINTER [ANY])
		local
			l_endian: INTEGER_32
			l_zsize: INTEGER_32
			l_zp: CE_POINTER [NATURAL_32]
			l_tmp: INTEGER_32
			l_align: NATURAL_32
			l___dst: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___src: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___size: INTEGER_32
			l___i: INTEGER_32
			l___dst___0: CE_POINTER [NATURAL_32]
			l___size___0: INTEGER_32
			l___src___0: CE_POINTER [NATURAL_32]
			l___i___0: INTEGER_32
			l_limb: NATURAL_32
			l_byte: NATURAL_32
			l_wbitsmask: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_numb: NATURAL_32
			l_wbytes: NATURAL_32
			l_woffset: INTEGER_32
			l_dp: CE_POINTER [NATURAL_8]
			l_lbits: INTEGER_32
			l_wbits: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___3: NATURAL_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			l_tmp___5: CE_POINTER [NATURAL_32]
			l_tmp___6: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l___dst.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___src.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_endian := a_endian
					l_zsize := (((a_count * ({NATURAL_32} 8 * a_size - a_nail) + {NATURAL_32} 32) - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
					l_tmp := builtin_expect ((l_zsize > mp_alloc.to_integer_32).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_zsize).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					l_zp := mp_d
					if l_endian = 0 then
						l_endian := -1
					end
					if a_nail /= {NATURAL_32} 0 then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						l_align := ((create {CE_INTEGER_8_POINTER}.make_cast (a_data)).distance ((create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)))).to_natural_32 \\ {PLATFORM}.Natural_32_bytes.to_natural_32
						if a_order = -1 then
							if a_size = {PLATFORM}.Natural_32_bytes.to_natural_32 then
								if l_endian = -1 then
									if l_align = {NATURAL_32} 0 then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											from
											until
												(l_return or l_break)
											loop
												l_break := False;
												(create {P_GMP_STATIC}).gmpn_copyi (l_zp, create {CE_NATURAL_32_POINTER}.make_cast (a_data), a_count.to_integer_32)
												update_class_fields -- Current might have been changed; synchronize
												l_break := True
											end
											l_break := False
											l_break := True
										end
										l_break := False
										l_pos := -1 + 5 -- goto done
									end
								end
							end
						end
				when 2 then
						if a_order = -1 then
							if a_size = {PLATFORM}.Natural_32_bytes.to_natural_32 then
								if l_endian = 1 then
									if l_align = {NATURAL_32} 0 then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											l___dst.item := l_zp
											update_class_fields -- Current might have been changed; synchronize
											l___src.item := create {CE_NATURAL_32_POINTER}.make_cast (a_data)
											update_class_fields -- Current might have been changed; synchronize
											l___size := a_count.to_integer_32
											l___i := (0).to_integer_32
											from
											until
												not (not (l_return) and then (l___i < l___size))
											loop
												from
												until
													(l_break)
												loop
													l_break := False
													asm17 (l___dst, l___src)
													l_break := True
												end
												l_break := False
												l___dst.item := l___dst.item + 1
												update_class_fields -- Current might have been changed; synchronize
												l___src.item := l___src.item + 1
												update_class_fields -- Current might have been changed; synchronize
												l___i := l___i + 1
											end
											l_break := True
										end
										l_break := False
										l_pos := -1 + 5 -- goto done
									end
								end
							end
						end
				when 3 then
						if a_order = 1 then
							if a_size = {PLATFORM}.Natural_32_bytes.to_natural_32 then
								if l_endian = -1 then
									if l_align = {NATURAL_32} 0 then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											l___dst___0 := l_zp
											l___size___0 := a_count.to_integer_32
											l___src___0 := (create {CE_NATURAL_32_POINTER}.make_cast (a_data) + l___size___0) - 1
											l___i___0 := (0).to_integer_32
											from
											until
												not (l___i___0 < l___size___0)
											loop
												l___dst___0.item := l___src___0.item
												update_class_fields -- Current might have been changed; synchronize
												l___dst___0 := l___dst___0 + 1
												l___src___0 := l___src___0 - 1
												l___i___0 := l___i___0 + 1
											end
											l_break := True
										end
										l_break := False
										l_pos := -1 + 5 -- goto done
									end
								end
							end
						end
				when 4 then
					l_numb := a_size * {NATURAL_32} 8 - a_nail
					l_wbytes := l_numb // {NATURAL_32} 8
					l_wbits := (l_numb \\ {NATURAL_32} 8).to_integer_32
					l_wbitsmask := (({NATURAL_32} 1).bit_shift_left (l_wbits)) - {NATURAL_32} 1
					l_woffset := ((l_numb + {NATURAL_32} 7) // {NATURAL_32} 8).to_integer_32
					if l_endian >= 0 then
						l_tmp___0 := l_woffset
					else
						l_tmp___0 := -l_woffset
					end
					if a_order < 0 then
						l_tmp___1 := a_size.to_natural_32
					else
						l_tmp___1 := (-a_size.to_integer_32).to_natural_32
					end
					l_woffset := (l_tmp___0.to_natural_32 + l_tmp___1).to_integer_32
					if a_order >= 0 then
						l_tmp___2 := (a_count - {NATURAL_32} 1) * a_size
					else
						l_tmp___2 := (0).to_natural_32
					end
					if l_endian >= 0 then
						l_tmp___3 := a_size - {NATURAL_32} 1
					else
						l_tmp___3 := (0).to_natural_32
					end
					l_dp := (create {CE_NATURAL_8_POINTER}.make_cast (a_data) + l_tmp___2.to_integer_32) + l_tmp___3.to_integer_32
					l_limb := (0).to_natural_32
					l_lbits := 0
					l_i := (0).to_natural_32
					from
					until
						not (not (l_return) and then (l_i < a_count))
					loop
						l_j := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_j < l_wbytes))
						loop
							l_byte := (l_dp.item).to_natural_32
							l_dp := l_dp - l_endian
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_limb := (l_limb).bit_or (((l_byte).bit_shift_left (l_lbits)))
								l_lbits := l_lbits + (8)
								if l_lbits >= 32 then
									l_tmp___4 := l_zp
									l_zp := l_zp + 1
									l_tmp___4.item := (l_limb).bit_and ({NATURAL_32} 4_294_967_295)
									update_class_fields -- Current might have been changed; synchronize
									l_lbits := l_lbits - (32)
									l_limb := (l_byte).bit_shift_right ((8 - l_lbits))
								end
								l_break := True
							end
							l_break := False
							l_j := l_j + 1
						end
						if l_wbits /= 0 then
							l_byte := ((l_dp.item).to_natural_32).bit_and (l_wbitsmask)
							l_dp := l_dp - l_endian
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_limb := (l_limb).bit_or (((l_byte).bit_shift_left (l_lbits)))
								l_lbits := l_lbits + l_wbits
								if l_lbits >= 32 then
									l_tmp___5 := l_zp
									l_zp := l_zp + 1
									l_tmp___5.item := (l_limb).bit_and ({NATURAL_32} 4_294_967_295)
									update_class_fields -- Current might have been changed; synchronize
									l_lbits := l_lbits - (32)
									l_limb := (l_byte).bit_shift_right ((l_wbits - l_lbits))
								end
								l_break := True
							end
							l_break := False
						end
						l_dp := l_dp + l_woffset
						l_i := l_i + 1
					end
					if l_lbits /= 0 then
						l_tmp___6 := l_zp
						l_zp := l_zp + 1
						l_tmp___6.item := l_limb
						update_class_fields -- Current might have been changed; synchronize
					end
				when 5 then -- done:
					l_zp := mp_d
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_zsize > 0))
						loop
							l_break := False
							if l_zp[(l_zsize - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_zsize := l_zsize - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					Current.mp_size := l_zsize.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_init
		local
			l_tmp: CE_POINTER [ANY]
		do
			Current.mp_alloc := 1
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([(4).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_size := 0
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_init2 (a_bits: NATURAL_32)
		local
			l_bits: NATURAL_32
			l_new_alloc: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [ANY]
		do
			l_bits := a_bits
			l_bits := l_bits - (l_bits /= {NATURAL_32} 0).to_integer.to_natural_32
			l_new_alloc := ({NATURAL_32} 1 + l_bits // {NATURAL_32} 32).to_integer_32
			if {PLATFORM}.Natural_32_bytes.to_natural_32 > {PLATFORM}.Integer_32_bytes.to_natural_32 then
				l_tmp := builtin_expect ((l_new_alloc > (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)).to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					Io.error.put_string ("gmp: overflow in mpz type%N")
					abort
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_tmp___0 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([(l_new_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___0)
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_alloc := l_new_alloc.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_size := 0
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_ior (a_op1, a_op2: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_op1.is_void
			not a_op2.is_void
		local
			l_op1: CE_POINTER [PD_MPZ_STRUCT]
			l_op2: CE_POINTER [PD_MPZ_STRUCT]
			l_op1_ptr: CE_POINTER [NATURAL_32]
			l_op2_ptr: CE_POINTER [NATURAL_32]
			l_op1_size: INTEGER_32
			l_op2_size: INTEGER_32
			l_res_ptr: CE_POINTER [NATURAL_32]
			l_res_size: INTEGER_32
			l_i: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_opx: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: INTEGER_32
			l_tmp___6: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l___mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l___mp_srcptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp: INTEGER_32
			l_opx___0: CE_POINTER [NATURAL_32]
			l_cy___0: NATURAL_32
			l_res_alloc: INTEGER_32
			l_count: INTEGER_32
			l_tmp___12: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_op1 := a_op1
			l_op2 := a_op2
			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_op1_size := (l_op1.item.mp_size).to_integer_32
			l_op2_size := (l_op2.item.mp_size).to_integer_32
			l_op1_ptr := l_op1.item.mp_d
			l_op2_ptr := l_op2.item.mp_d
			l_res_ptr := mp_d
			if l_op1_size >= 0 then
				if l_op2_size >= 0 then
					if l_op1_size >= l_op2_size then
						if mp_alloc.to_integer_32 < l_op1_size then
							((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_op1_size).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_op2_ptr := l_op2.item.mp_d
							l_res_ptr := mp_d
						end
						if not l_res_ptr.is_equal (l_op1_ptr) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_res_ptr + l_op2_size, l_op1_ptr + l_op2_size, l_op1_size - l_op2_size)
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
						l_i := l_op2_size - 1
						from
						until
							not (l_i >= 0)
						loop
							l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_or (l_op2_ptr[l_i]))
							update_class_fields -- Current might have been changed; synchronize
							l_i := l_i - 1
						end
						l_res_size := l_op1_size
					else
						if mp_alloc.to_integer_32 < l_op2_size then
							((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_op2_size).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_op1_ptr := l_op1.item.mp_d
							l_res_ptr := mp_d
						end
						if not l_res_ptr.is_equal (l_op2_ptr) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_res_ptr + l_op1_size, l_op2_ptr + l_op1_size, l_op2_size - l_op1_size)
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
						l_i := l_op1_size - 1
						from
						until
							not (l_i >= 0)
						loop
							l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_or (l_op2_ptr[l_i]))
							update_class_fields -- Current might have been changed; synchronize
							l_i := l_i - 1
						end
						l_res_size := l_op2_size
					end
					Current.mp_size := l_res_size.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			elseif l_op2_size < 0 then
				l_op1_size := -l_op1_size
				l_op2_size := -l_op2_size
				if l_op1_size < l_op2_size then
					l_res_size := l_op1_size
				else
					l_res_size := l_op2_size
				end
				l_tmp___3 := builtin_expect ((l_res_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___3.to_boolean then
					l_tmp___2 := (l_aaf.new ((l_res_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___1 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_res_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := l_tmp___1
				end
				l_opx := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2);
				(create {P_GMP_STATIC}).gmpn_sub_1 (l_opx, l_op1_ptr, l_res_size, (1).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_op1_ptr := l_opx
				l_tmp___8 := builtin_expect ((l_res_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___8.to_boolean then
					l_tmp___7 := (l_aaf.new ((l_res_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___6 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_res_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___7 := l_tmp___6
				end
				l_opx := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___7);
				(create {P_GMP_STATIC}).gmpn_sub_1 (l_opx, l_op2_ptr, l_res_size, (1).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_op2_ptr := l_opx
				if mp_alloc.to_integer_32 < l_res_size then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_res_size).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_res_ptr := mp_d
				end
				l_i := l_res_size - 1
				from
				until
					not (not (l_break) and then (l_i >= 0))
				loop
					l_break := False
					if ((l_op1_ptr[l_i]).bit_and (l_op2_ptr[l_i])) /= {NATURAL_32} 0 then
						l_break := True
					end
					if not (l_return or l_break) then
						l_i := l_i - 1
					end
				end
				l_break := False
				l_res_size := l_i + 1
				if l_res_size /= 0 then
					l_i := l_res_size - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_and (l_op2_ptr[l_i]))
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i - 1
					end
					l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (l_res_ptr, l_res_ptr, l_res_size, (1).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_cy.to_boolean then
						l_res_ptr[l_res_size] := l_cy
						update_class_fields -- Current might have been changed; synchronize
						l_res_size := l_res_size + 1
					end
				else
					l_res_ptr[0] := (1).to_natural_32
					update_class_fields -- Current might have been changed; synchronize
					l_res_size := (1).to_integer_32
				end
				Current.mp_size := (-l_res_size).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___9 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___9.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
				l_return := True
			else
				from
				until
					(l_break)
				loop
					l_break := False
					l___mpz_srcptr_swap__tmp := l_op1
					l_op1 := l_op2
					l_op2 := l___mpz_srcptr_swap__tmp
					l_break := True
				end
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						l___mp_srcptr_swap__tmp := l_op1_ptr
						l_op1_ptr := l_op2_ptr
						l_op2_ptr := l___mp_srcptr_swap__tmp
						l_break := True
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						l___mp_size_t_swap__tmp := l_op1_size
						l_op1_size := l_op2_size
						l_op2_size := l___mp_size_t_swap__tmp
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
			end
			if not l_return then
				l_op2_size := -l_op2_size
				l_res_alloc := l_op2_size
				l_tmp___14 := builtin_expect ((l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___14.to_boolean then
					l_tmp___13 := (l_aaf.new ((l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___12 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___13 := l_tmp___12
				end
				l_opx___0 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___13);
				(create {P_GMP_STATIC}).gmpn_sub_1 (l_opx___0, l_op2_ptr, l_op2_size, (1).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_op2_ptr := l_opx___0
				l_op2_size := l_op2_size - (l_op2_ptr[(l_op2_size - 1)] = {NATURAL_32} 0).to_integer
				if mp_alloc.to_integer_32 < l_res_alloc then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_res_alloc).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_op1_ptr := l_op1.item.mp_d
					l_res_ptr := mp_d
				end
				if l_op1_size >= l_op2_size then
					l_i := l_op2_size - 1
					from
					until
						not (not (l_break) and then (l_i >= 0))
					loop
						l_break := False
						if (((l_op1_ptr[l_i]).bit_not).bit_and (l_op2_ptr[l_i])) /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_i := l_i - 1
						end
					end
					l_break := False
					l_res_size := l_i + 1
					l_count := l_res_size
				else
					l_res_size := l_op2_size
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_res_ptr + l_op1_size, l_op2_ptr + l_op1_size, l_op2_size - l_op1_size)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_count := l_op1_size
				end
				if l_res_size /= 0 then
					l_i := l_count - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := (((l_op1_ptr[l_i]).bit_not).bit_and (l_op2_ptr[l_i]))
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i - 1
					end
					l_cy___0 := (create {P_GMP_STATIC}).gmpn_add_1 (l_res_ptr, l_res_ptr, l_res_size, (1).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_cy___0.to_boolean then
						l_res_ptr[l_res_size] := l_cy___0
						update_class_fields -- Current might have been changed; synchronize
						l_res_size := l_res_size + 1
					end
				else
					l_res_ptr[0] := (1).to_natural_32
					update_class_fields -- Current might have been changed; synchronize
					l_res_size := (1).to_integer_32
				end
				Current.mp_size := (-l_res_size).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___15 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___15.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpz_init_set_d (a_val: REAL_64)
		local
			l_tmp: CE_POINTER [ANY]
		do
			Current.mp_alloc := 1
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([(4).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_size := 0
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_set_d (a_val)
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_init_set_si (a_val: INTEGER_32)
		local
			l_size: INTEGER_32
			l_vl: NATURAL_32
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
		do
			Current.mp_alloc := 1
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([(4).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			if a_val >= 0 then
				l_tmp___0 := a_val
			else
				l_tmp___0 := -a_val
			end
			l_vl := l_tmp___0.to_natural_32
			mp_d[0] := (l_vl).bit_and ({NATURAL_32} 4_294_967_295)
			update_class_fields -- Current might have been changed; synchronize
			l_size := (l_vl /= {NATURAL_32} 0).to_integer
			if a_val >= 0 then
				Current.mp_size := l_size.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			else
				Current.mp_size := (-l_size).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	gmpz_init_set_str (a_str: CE_POINTER [INTEGER_8]; a_base: INTEGER_32): INTEGER_32
		local
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
		do
			Current.mp_alloc := 1
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([(4).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_size := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_SET_STR_STATIC}).gmpz_set_str ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer)), a_str, a_base)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp___0
		end

	gmpz_init_set_ui (a_val: NATURAL_32)
		local
			l_size: INTEGER_32
			l_tmp: CE_POINTER [ANY]
		do
			Current.mp_alloc := 1
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([(4).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			mp_d[0] := (a_val).bit_and ({NATURAL_32} 4_294_967_295)
			update_class_fields -- Current might have been changed; synchronize
			l_size := (a_val /= {NATURAL_32} 0).to_integer
			Current.mp_size := l_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_jacobi (a_b: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		require
			not a_b.is_void
		local
			l_asrcp: CE_POINTER [NATURAL_32]
			l_bsrcp: CE_POINTER [NATURAL_32]
			l_asize: INTEGER_32
			l_bsize: INTEGER_32
			l_ap: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_alow: NATURAL_32
			l_blow: NATURAL_32
			l_ahigh: NATURAL_32
			l_bhigh: NATURAL_32
			l_asecond: NATURAL_32
			l_bsecond: NATURAL_32
			l_atwos: NATURAL_32
			l_btwos: NATURAL_32
			l_result_bit1: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l___a_ptr: CE_POINTER [NATURAL_32]
			l___a_size: INTEGER_32
			l___b: NATURAL_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l___a_ptr___0: CE_POINTER [NATURAL_32]
			l___a_size___0: INTEGER_32
			l___b___0: NATURAL_32
			l_tmp___6: INTEGER_32
			l_tmp___19: CE_POINTER [ANY]
			l_tmp___20: CE_POINTER [ANY]
			l_tmp___21: INTEGER_32
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp: INTEGER_32
			l___mp_limb_t_swap__tmp: NATURAL_32
			l_rp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_tmp___34: CE_POINTER [ANY]
			l_tmp___35: CE_POINTER [ANY]
			l_tmp___36: INTEGER_32
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp___0: INTEGER_32
			l___mp_limb_t_swap__tmp___0: NATURAL_32
			l_tmp___37: INTEGER_32
			l_tmp___38: INTEGER_32
			l_twos: NATURAL_32
			l_tmp___39: INTEGER_32
			l_tmp___40: INTEGER_32
			l_tmp___41: INTEGER_32
			l_tmp___42: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_NATURAL_32_POINTER} l_bsrcp.make
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_asize := mp_size.to_integer_32
					l_asrcp := mp_d
					l_alow := l_asrcp[0]
					l_bsize := (a_b.item.mp_size).to_integer_32
					if l_bsize /= 0 then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if l_asize /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if l_asize /= -1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if l_alow = {NATURAL_32} 1 then
							l_tmp := 1
						else
							l_tmp := 0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_tmp := 0
				when 8 then -- if done
						Result := l_tmp
						l_return := True
				when 9 then -- if done
					if l_return then
						l_pos := -1 + 19 -- skip if block
					end
				when 10 then -- if:
						l_bsrcp := a_b.item.mp_d
						l_blow := l_bsrcp[0]
						if l_asize /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 11 then -- if:
						if l_bsize /= 1 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 14 then -- else:
						if l_bsize /= -1 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L___0:
						if l_blow = {NATURAL_32} 1 then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						l_tmp___0 := 0
				when 18 then -- if done
						Result := l_tmp___0
						l_return := True
				when 19 then -- if done | if done
					if not l_return and then (((((l_alow).bit_or (l_blow))).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0) then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 26 -- skip if block
					end
				when 20 then -- if:
						l_result_bit1 := ((((l_asize < 0).to_integer).bit_and ((l_bsize < 0).to_integer))).bit_shift_left (1)
						if l_bsize >= 0 then
							l_bsize := l_bsize
						else
							l_bsize := -l_bsize
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_tmp___1 := builtin_expect ((l_blow = {NATURAL_32} 0).to_integer, 0)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___1.to_boolean then
									l_break := True
								end
								if not (l_return or l_break) then
									l_bsize := l_bsize - 1
									l_bsrcp := l_bsrcp + 1
									l_blow := l_bsrcp.item
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_tmp___2 := builtin_ctzl (l_blow)
							update_class_fields -- Current might have been changed; synchronize
							l_btwos := l_tmp___2.to_natural_32
							l_break := True
						end
						l_break := False
						l_blow := (l_blow).bit_shift_right (l_btwos.to_integer_32)
						if l_bsize > 1 then
							l_bsecond := l_bsrcp[1]
							if l_btwos /= {NATURAL_32} 0 then
								l_blow := (l_blow).bit_or (((((l_bsecond).bit_shift_left (({NATURAL_32} 32 - l_btwos).to_integer_32))).bit_and ({NATURAL_32} 4_294_967_295)))
							end
						end
						l_result_bit1 := (l_result_bit1).bit_xor ((((((l_asize < 0).to_integer).bit_shift_left (1))).bit_and (l_blow.to_integer_32)))
						if l_asize >= 0 then
							l_asize := l_asize
						else
							l_asize := -l_asize
						end
						if l_bsize /= 1 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 25 -- goto _L___1
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 23 then -- else:
						if l_bsize /= 2 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						if (l_bsecond).bit_shift_right (l_btwos.to_integer_32) /= {NATURAL_32} 0 then
							l_pos := -1 + 26 -- skip if block
						end
				when 25 then -- if: | _L___1:
						l_result_bit1 := (l_result_bit1).bit_xor (((((l_btwos).bit_shift_left (1)).to_integer_32).bit_and (((((l_alow).bit_shift_right (1))).bit_xor (l_alow)).to_integer_32)))
						if l_blow = {NATURAL_32} 1 then
							Result := (1 - ((l_result_bit1).bit_and (2)))
							l_return := True
						end
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l___a_ptr := l_asrcp
								l___a_size := l_asize
								l___b := l_blow
								if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l___a_size >= 22 then
										l_alow := (create {P_MOD_1_STATIC}).gmpn_mod_1 (l___a_ptr, l___a_size, l___b)
										update_class_fields -- Current might have been changed; synchronize
									else
										l_result_bit1 := (l_result_bit1).bit_xor (l___b.to_integer_32)
										l_alow := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l___a_ptr, l___a_size, l___b)
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									l_result_bit1 := (l_result_bit1).bit_xor (l___b.to_integer_32)
									l_alow := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l___a_ptr, l___a_size, l___b)
									update_class_fields -- Current might have been changed; synchronize
								end
								l_break := True
							end
							l_break := False
							l_tmp___3 := gmpn_jacobi_base (l_alow, l_blow, l_result_bit1)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp___3
							l_return := True
						end
				when 26 then -- if done | if done | if done
					if l_return then
						l_pos := -1 + 33 -- skip if block
					end
				when 27 then -- if:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_tmp___4 := builtin_expect ((l_alow = {NATURAL_32} 0).to_integer, 0)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___4.to_boolean then
									l_break := True
								end
								if not (l_return or l_break) then
									l_asize := l_asize - 1
									l_asrcp := l_asrcp + 1
									l_alow := l_asrcp.item
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_tmp___5 := builtin_ctzl (l_alow)
							update_class_fields -- Current might have been changed; synchronize
							l_atwos := l_tmp___5.to_natural_32
							l_break := True
						end
						l_break := False
						l_result_bit1 := (l_result_bit1).bit_xor (((((l_atwos).bit_shift_left (1)).to_integer_32).bit_and (((((l_blow).bit_shift_right (1))).bit_xor (l_blow)).to_integer_32)))
						l_alow := (l_alow).bit_shift_right (l_atwos.to_integer_32)
						if l_asize > 1 then
							l_asecond := l_asrcp[1]
							if l_atwos /= {NATURAL_32} 0 then
								l_alow := (l_alow).bit_or (((((l_asecond).bit_shift_left (({NATURAL_32} 32 - l_atwos).to_integer_32))).bit_and ({NATURAL_32} 4_294_967_295)))
							end
						end
						l_result_bit1 := (l_result_bit1).bit_xor (((((l_btwos).bit_shift_left (1)).to_integer_32).bit_and (((((l_alow).bit_shift_right (1))).bit_xor (l_alow)).to_integer_32)))
						if l_asize /= 1 then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 32 -- goto _L___2
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 30 then -- else:
						if l_asize /= 2 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						if (l_asecond).bit_shift_right (l_atwos.to_integer_32) /= {NATURAL_32} 0 then
							l_pos := -1 + 33 -- skip if block
						end
				when 32 then -- if: | _L___2:
						if l_alow = {NATURAL_32} 1 then
							Result := (1 - ((l_result_bit1).bit_and (2)))
							l_return := True
						end
						if not l_return then
							l_result_bit1 := (l_result_bit1).bit_xor (((((l_btwos).bit_shift_left (1)).to_integer_32).bit_and (((((l_alow).bit_shift_right (1))).bit_xor (l_alow)).to_integer_32)))
							l_result_bit1 := (l_result_bit1).bit_xor (((l_alow).bit_and (l_blow)).to_integer_32)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l___a_ptr___0 := l_bsrcp
								l___a_size___0 := l_bsize
								l___b___0 := l_alow
								if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l___a_size___0 >= 22 then
										l_blow := (create {P_MOD_1_STATIC}).gmpn_mod_1 (l___a_ptr___0, l___a_size___0, l___b___0)
										update_class_fields -- Current might have been changed; synchronize
									else
										l_result_bit1 := (l_result_bit1).bit_xor (l___b___0.to_integer_32)
										l_blow := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l___a_ptr___0, l___a_size___0, l___b___0)
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									l_result_bit1 := (l_result_bit1).bit_xor (l___b___0.to_integer_32)
									l_blow := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l___a_ptr___0, l___a_size___0, l___b___0)
									update_class_fields -- Current might have been changed; synchronize
								end
								l_break := True
							end
							l_break := False
							l_tmp___6 := gmpn_jacobi_base (l_blow, l_alow, l_result_bit1)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp___6
							l_return := True
						end
				when 33 then -- if done | if done | if done
					if l_return then
						l_pos := -1 + 53 -- skip if block
					end
				when 34 then -- if:
						l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___21 := builtin_expect (((l_asize + l_bsize).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___21.to_boolean then
								l_tmp___20 := (l_aaf.new (((l_asize + l_bsize).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___19 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_asize + l_bsize).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___20 := l_tmp___19
							end
							l_ap := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___20)
							l_bp := l_ap + l_asize
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_atwos /= {NATURAL_32} 0 then
								(create {P_GMP_STATIC}).gmpn_rshift (l_ap, l_asrcp, l_asize, l_atwos).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_asize := l_asize - (l_ap[(l_asize - 1)] = {NATURAL_32} 0).to_integer
							else
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_ap, l_asrcp, l_asize)
										update_class_fields -- Current might have been changed; synchronize
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
							end
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_btwos /= {NATURAL_32} 0 then
								(create {P_GMP_STATIC}).gmpn_rshift (l_bp, l_bsrcp, l_bsize, l_btwos).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_bsize := l_bsize - (l_bp[(l_bsize - 1)] = {NATURAL_32} 0).to_integer
							else
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_bp, l_bsrcp, l_bsize)
										update_class_fields -- Current might have been changed; synchronize
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
							end
							l_break := True
						end
						l_break := False
						if l_asize < l_bsize then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_ptr_swap__tmp := l_ap
									l_ap := l_bp
									l_bp := l___mp_ptr_swap__tmp
									l_break := True
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_size_t_swap__tmp := l_asize
									l_asize := l_bsize
									l_bsize := l___mp_size_t_swap__tmp
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								l___mp_limb_t_swap__tmp := l_alow
								l_alow := l_blow
								l_blow := l___mp_limb_t_swap__tmp
								l_break := True
							end
							l_break := False
							l_result_bit1 := (l_result_bit1).bit_xor (((l_alow).bit_and (l_blow)).to_integer_32)
						end
						if not (l_asize > l_bsize) then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___36 := builtin_expect (((l_bsize + ((l_asize - l_bsize) + 1)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___36.to_boolean then
								l_tmp___35 := (l_aaf.new (((l_bsize + ((l_asize - l_bsize) + 1)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___34 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_bsize + ((l_asize - l_bsize) + 1)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___35 := l_tmp___34
							end
							l_rp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___35)
							l_qp := l_rp + l_bsize
							l_break := True
						end
						l_break := False;
						(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_qp, l_rp, (0).to_integer_32, l_ap, l_asize, l_bp, l_bsize)
						update_class_fields -- Current might have been changed; synchronize
						l_ap := l_rp
						l_asize := l_bsize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_asize > 0))
							loop
								l_break := False
								if l_ap[(l_asize - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_asize := l_asize - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if l_asize = 0 then
							l_pos := -1 + 54 -- goto zero
						end
				when 36 then
						l_alow := l_ap[0]
						l_pos := -1 + 50 -- goto strip_a
				when 37 then
						if (l_return or l_break) then
							l_pos := -1 + 52 -- skip loop
						end
				when 38 then -- loop body:
						l_break := False
						if not (l_asize < l_bsize) then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						l_pos := -1 + 47 -- goto _L___4
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 41 then -- else:
						if l_asize /= l_bsize then
							l_pos := -1 + 48 -- skip if block
						end
				when 42 then -- if:
						l_ahigh := l_ap[(l_asize - 1)]
						l_bhigh := l_bp[(l_asize - 1)]
						if not (l_ahigh < l_bhigh) then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						l_pos := -1 + 47 -- goto _L___4
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 45 then -- else:
						if l_ahigh /= l_bhigh then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						l_tmp___37 := (create {P_GMP_STATIC}).gmpn_cmp (l_ap, l_bp, l_asize - 1)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___37 < 0) then
							l_pos := -1 + 48 -- skip if block
						end
				when 47 then -- if: | _L___4:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								l___mp_ptr_swap__tmp___0 := l_ap
								l_ap := l_bp
								l_bp := l___mp_ptr_swap__tmp___0
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								l___mp_size_t_swap__tmp___0 := l_asize
								l_asize := l_bsize
								l_bsize := l___mp_size_t_swap__tmp___0
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							l___mp_limb_t_swap__tmp___0 := l_alow
							l_alow := l_blow
							l_blow := l___mp_limb_t_swap__tmp___0
							l_break := True
						end
						l_break := False
						l_result_bit1 := (l_result_bit1).bit_xor (((l_alow).bit_and (l_blow)).to_integer_32)
				when 48 then -- if done | if done | if done | if done
						if l_asize = 1 then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:;
						(create {P_GMP_STATIC}).gmpn_sub (l_ap, l_ap, l_asize, l_bp, l_bsize).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_asize > 0))
							loop
								l_break := False
								if l_ap[(l_asize - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_asize := l_asize - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_alow := l_ap[0]
						if l_asize = 0 then
							l_pos := -1 + 54 -- goto zero
						end
				when 50 then -- strip_a:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_tmp___38 := builtin_expect ((l_alow = {NATURAL_32} 0).to_integer, 0)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___38.to_boolean then
									l_break := True
								end
								if not (l_return or l_break) then
									l_asize := l_asize - 1
									l_ap := l_ap + 1
									l_alow := l_ap.item
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if ((l_alow).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_tmp___39 := builtin_ctzl (l_alow)
								update_class_fields -- Current might have been changed; synchronize
								l_twos := l_tmp___39.to_natural_32
								l_break := True
							end
							l_break := False
							l_result_bit1 := (l_result_bit1).bit_xor (((((l_twos).bit_shift_left (1)).to_integer_32).bit_and (((((l_blow).bit_shift_right (1))).bit_xor (l_blow)).to_integer_32)));
							(create {P_GMP_STATIC}).gmpn_rshift (l_ap, l_ap, l_asize, l_twos).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_asize := l_asize - (l_ap[(l_asize - 1)] = {NATURAL_32} 0).to_integer
							l_alow := l_ap[0]
						end
				when 51 then -- if done
						l_pos := -1 + 37 -- back to loop condition
				when 52 then -- loop done
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___40 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___40.to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
						if l_alow = {NATURAL_32} 1 then
							Result := (1 - ((l_result_bit1).bit_and (2)))
							l_return := True
						end
				when 53 then -- if done
					if not l_return then
						l_result_bit1 := (l_result_bit1).bit_xor (((l_alow).bit_and (l_blow)).to_integer_32)
						l_tmp___41 := gmpn_jacobi_base (l_blow, l_alow, l_result_bit1)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___41
						l_return := True
					end
					if l_return then
						l_pos := -1 + 55 -- skip if block
					end
				when 54 then -- if: | zero:
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___42 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___42.to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
						Result := 0
				when 55 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_si_kronecker (a_a: INTEGER_32): INTEGER_32
		local
			l_b_ptr: CE_POINTER [NATURAL_32]
			l_b_low: NATURAL_32
			l_b_size: INTEGER_32
			l_b_abs_size: INTEGER_32
			l_a_limb: NATURAL_32
			l_b_rem: NATURAL_32
			l_twos: NATURAL_32
			l_result_bit1: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l___a_ptr: CE_POINTER [NATURAL_32]
			l___a_size: INTEGER_32
			l___b: NATURAL_32
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_b_size := mp_size.to_integer_32
			if l_b_size = 0 then
				Result := (((a_a = 1).to_integer).bit_or ((a_a = -1).to_integer))
				l_return := True
			end
			if not l_return then
				l_result_bit1 := ((((a_a < 0).to_integer).bit_and ((l_b_size < 0).to_integer))).bit_shift_left (1)
				l_b_ptr := mp_d
				l_b_low := l_b_ptr[0]
				if l_b_size >= 0 then
					l_b_abs_size := l_b_size
				else
					l_b_abs_size := -l_b_size
				end
				if ((l_b_low).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
					l_result_bit1 := (l_result_bit1).bit_xor ((((((a_a < 0).to_integer).bit_shift_left (1))).bit_and (l_b_low.to_integer_32)))
					if a_a >= 0 then
						l_tmp := a_a
					else
						l_tmp := -a_a
					end
					l_a_limb := l_tmp.to_natural_32
					if ((l_a_limb).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
						if l_a_limb = {NATURAL_32} 0 then
							if l_b_abs_size = 1 then
								if l_b_low = {NATURAL_32} 1 then
									l_tmp___0 := 1
								else
									l_tmp___0 := 0
								end
							else
								l_tmp___0 := 0
							end
							Result := l_tmp___0
							l_return := True
						end
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_tmp___1 := builtin_ctzl (l_a_limb)
								update_class_fields -- Current might have been changed; synchronize
								l_twos := l_tmp___1.to_natural_32
								l_break := True
							end
							l_break := False
							l_a_limb := (l_a_limb).bit_shift_right (l_twos.to_integer_32)
							l_result_bit1 := (l_result_bit1).bit_xor (((((l_twos).bit_shift_left (1)).to_integer_32).bit_and (((((l_b_low).bit_shift_right (1))).bit_xor (l_b_low)).to_integer_32)))
						end
					end
				else
					if ((a_a).bit_and (1)) = 0 then
						Result := 0
						l_return := True
					end
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_tmp___2 := builtin_expect ((l_b_low = {NATURAL_32} 0).to_integer, 0)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___2.to_boolean then
									l_break := True
								end
								if not (l_return or l_break) then
									l_b_abs_size := l_b_abs_size - 1
									l_b_ptr := l_b_ptr + 1
									l_b_low := l_b_ptr.item
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if ((l_b_low).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
							l_tmp___4 := builtin_expect ((l_b_low = ({NATURAL_32} 1).bit_shift_left (31)).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___4.to_boolean then
								if l_b_abs_size = 1 then
									l_result_bit1 := (l_result_bit1).bit_xor (((((a_a).bit_shift_right (1))).bit_xor (a_a)).to_integer_32)
									Result := (1 - ((l_result_bit1).bit_and (2)))
									l_return := True
								end
								if not l_return then
									l_b_low := ((l_b_ptr[1]).bit_shift_left (1))
								end
							else
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_tmp___3 := builtin_ctzl (l_b_low)
									update_class_fields -- Current might have been changed; synchronize
									l_twos := l_tmp___3.to_natural_32
									l_break := True
								end
								l_break := False
								l_b_low := (l_b_low).bit_shift_right (l_twos.to_integer_32)
							end
						end
					end
					if not l_return then
						l_result_bit1 := (l_result_bit1).bit_xor ((((((a_a < 0).to_integer).bit_shift_left (1))).bit_and (l_b_low.to_integer_32)))
						if a_a >= 0 then
							l_tmp___5 := a_a
						else
							l_tmp___5 := -a_a
						end
						l_a_limb := l_tmp___5.to_natural_32
					end
				end
			end
			if not l_return and then (l_a_limb = {NATURAL_32} 1) then
				Result := (1 - ((l_result_bit1).bit_and (2)))
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___a_ptr := l_b_ptr
					l___a_size := l_b_abs_size
					l___b := l_a_limb
					if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l___a_size >= 22 then
							l_b_rem := (create {P_MOD_1_STATIC}).gmpn_mod_1 (l___a_ptr, l___a_size, l___b)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_result_bit1 := (l_result_bit1).bit_xor (l___b.to_integer_32)
							l_b_rem := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l___a_ptr, l___a_size, l___b)
							update_class_fields -- Current might have been changed; synchronize
						end
					else
						l_result_bit1 := (l_result_bit1).bit_xor (l___b.to_integer_32)
						l_b_rem := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l___a_ptr, l___a_size, l___b)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
				l_result_bit1 := (l_result_bit1).bit_xor (((l_a_limb).bit_and (l_b_low)).to_integer_32)
				l_tmp___6 := gmpn_jacobi_base (l_b_rem, l_a_limb, l_result_bit1)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___6
			end
		end

	gmpz_ui_kronecker (a_a: NATURAL_32): INTEGER_32
		local
			l_a: NATURAL_32
			l_b_ptr: CE_POINTER [NATURAL_32]
			l_b_low: NATURAL_32
			l_b_abs_size: INTEGER_32
			l_b_rem: NATURAL_32
			l_twos: INTEGER_32
			l_result_bit1: INTEGER_32
			l_alimbs: CE_ARRAY [NATURAL_32]
			l_az: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l___a_ptr: CE_POINTER [NATURAL_32]
			l___a_size: INTEGER_32
			l___b: NATURAL_32
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_alimbs.make (<<2>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_az.make (<<1>>)

			l_a := a_a
			if mp_size >= 0 then
				l_b_abs_size := mp_size
			else
				l_b_abs_size := (-mp_size)
			end
			if l_b_abs_size = 0 then
				Result := (l_a = {NATURAL_32} 1).to_integer
				l_return := True
			end
			if not l_return and then (l_a > {NATURAL_32} 4_294_967_295) then
				l_az[0].mp_alloc := (({PLATFORM}.Natural_32_bytes.to_natural_32 * (2).to_natural_32) // {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_az[0].mp_d := l_alimbs
				update_class_fields -- Current might have been changed; synchronize
				l_az.item.gmpz_set_ui (l_a)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_az)).item.gmpz_jacobi ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer)))
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp
				l_return := True
			end
			if not l_return then
				l_b_ptr := mp_d
				l_b_low := l_b_ptr[0]
				l_result_bit1 := 0
				if not ((l_b_low).bit_and ({NATURAL_32} 1)).to_boolean then
					if not ((l_a).bit_and ({NATURAL_32} 1)).to_boolean then
						Result := 0
						l_return := True
					end
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_tmp___0 := builtin_expect ((l_b_low = {NATURAL_32} 0).to_integer, 0)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___0.to_boolean then
									l_break := True
								end
								if not (l_return or l_break) then
									l_b_abs_size := l_b_abs_size - 1
									l_b_ptr := l_b_ptr + 1
									l_b_low := l_b_ptr.item
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if not ((l_b_low).bit_and ({NATURAL_32} 1)).to_boolean then
							l_tmp___1 := builtin_expect ((l_b_low = ({NATURAL_32} 1).bit_shift_left (31)).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___1.to_boolean then
								if l_b_abs_size = 1 then
									l_result_bit1 := ((((l_a).bit_shift_right (1))).bit_xor (l_a)).to_integer_32
									Result := (1 - ((l_result_bit1).bit_and (2)))
									l_return := True
								end
								if not l_return then
									l_b_low := ((l_b_ptr[1]).bit_shift_left (1))
								end
							else
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_twos := builtin_ctzl (l_b_low)
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
								l_break := False
								l_b_low := (l_b_low).bit_shift_right (l_twos)
							end
						end
					end
				else
					if l_a = {NATURAL_32} 0 then
						if l_b_abs_size = 1 then
							if l_b_low = {NATURAL_32} 1 then
								l_tmp___2 := 1
							else
								l_tmp___2 := 0
							end
						else
							l_tmp___2 := 0
						end
						Result := l_tmp___2
						l_return := True
					end
					if not l_return and then (not ((l_a).bit_and ({NATURAL_32} 1)).to_boolean) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_twos := builtin_ctzl (l_a)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_a := (l_a).bit_shift_right (l_twos)
						l_result_bit1 := (((l_twos).bit_shift_left (1))).bit_and (((((l_b_low).bit_shift_right (1))).bit_xor (l_b_low)).to_integer_32)
					end
				end
			end
			if not l_return and then (l_a = {NATURAL_32} 1) then
				Result := (1 - ((l_result_bit1).bit_and (2)))
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___a_ptr := l_b_ptr
					l___a_size := l_b_abs_size.to_integer_32
					l___b := l_a
					if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l___a_size >= 22 then
							l_b_rem := (create {P_MOD_1_STATIC}).gmpn_mod_1 (l___a_ptr, l___a_size, l___b)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_result_bit1 := (l_result_bit1).bit_xor (l___b.to_integer_32)
							l_b_rem := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l___a_ptr, l___a_size, l___b)
							update_class_fields -- Current might have been changed; synchronize
						end
					else
						l_result_bit1 := (l_result_bit1).bit_xor (l___b.to_integer_32)
						l_b_rem := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l___a_ptr, l___a_size, l___b)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
				l_result_bit1 := (l_result_bit1).bit_xor (((l_a).bit_and (l_b_low)).to_integer_32)
				l_tmp___3 := gmpn_jacobi_base (l_b_rem, l_a, l_result_bit1)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___3
			end
		end

	gmpz_kronecker_si (a_b: INTEGER_32): INTEGER_32
		local
			l_a_ptr: CE_POINTER [NATURAL_32]
			l_a_size: INTEGER_32
			l_a_rem: NATURAL_32
			l_b_limb: NATURAL_32
			l_result_bit1: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_a_low: NATURAL_32
			l_twos: INTEGER_32
			l_tmp___1: INTEGER_32
			l___a_ptr: CE_POINTER [NATURAL_32]
			l___a_size: INTEGER_32
			l___b: NATURAL_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_POINTER} l_a_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a_size := mp_size.to_integer_32
					if l_a_size = 0 then
						if a_b = 1 then
							l_tmp := 1
						elseif a_b = -1 then
							l_tmp := 1
						else
							l_tmp := 0
						end
						Result := l_tmp
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_result_bit1 := ((((l_a_size < 0).to_integer).bit_and ((a_b < 0).to_integer))).bit_shift_left (1)
						if a_b >= 0 then
							l_tmp___0 := a_b
						else
							l_tmp___0 := -a_b
						end
						l_b_limb := l_tmp___0.to_natural_32
						l_a_ptr := mp_d
						if ((l_b_limb).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 2 then -- if:
						l_a_low := l_a_ptr[0]
						if l_b_limb /= {NATURAL_32} 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if l_a_size /= 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if l_a_size /= -1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						if l_a_low = {NATURAL_32} 1 then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_tmp___1 := 0
				when 10 then -- if done
						Result := l_tmp___1
						l_return := True
				when 11 then -- if done
						if not l_return and then (not ((l_a_low).bit_and ({NATURAL_32} 1)).to_boolean) then
							Result := 0
							l_return := True
						end
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_twos := builtin_ctzl (l_b_limb)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
							l_b_limb := (l_b_limb).bit_shift_right (l_twos)
							l_result_bit1 := (l_result_bit1).bit_xor (((((l_twos).bit_shift_left (1))).bit_and (((((l_a_low).bit_shift_right (1))).bit_xor (l_a_low)).to_integer_32)))
						end
				when 12 then -- if done | if done
					if not l_return and then (l_b_limb = {NATURAL_32} 1) then
						Result := (1 - ((l_result_bit1).bit_and (2)))
						l_return := True
					end
					if not l_return then
						l_result_bit1 := (l_result_bit1).bit_xor ((((((l_a_size < 0).to_integer).bit_shift_left (1))).bit_and (l_b_limb.to_integer_32)))
						if l_a_size >= 0 then
							l_a_size := l_a_size
						else
							l_a_size := -l_a_size
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___a_ptr := l_a_ptr
							l___a_size := l_a_size
							l___b := l_b_limb
							if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l___a_size >= 22 then
									l_a_rem := (create {P_MOD_1_STATIC}).gmpn_mod_1 (l___a_ptr, l___a_size, l___b)
									update_class_fields -- Current might have been changed; synchronize
								else
									l_result_bit1 := (l_result_bit1).bit_xor (l___b.to_integer_32)
									l_a_rem := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l___a_ptr, l___a_size, l___b)
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_result_bit1 := (l_result_bit1).bit_xor (l___b.to_integer_32)
								l_a_rem := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l___a_ptr, l___a_size, l___b)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
						l_tmp___2 := gmpn_jacobi_base (l_a_rem, l_b_limb, l_result_bit1)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___2
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_kronecker_ui (a_b: NATURAL_32): INTEGER_32
		local
			l_b: NATURAL_32
			l_a_ptr: CE_POINTER [NATURAL_32]
			l_a_size: INTEGER_32
			l_a_rem: NATURAL_32
			l_result_bit1: INTEGER_32
			l_blimbs: CE_ARRAY [NATURAL_32]
			l_bz: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp: INTEGER_32
			l_a_low: NATURAL_32
			l_twos: INTEGER_32
			l_tmp___0: INTEGER_32
			l___a_ptr: CE_POINTER [NATURAL_32]
			l___a_size: INTEGER_32
			l___b: NATURAL_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_POINTER} l_a_ptr.make
			create {CE_NATURAL_32_ARRAY} l_blimbs.make (<<2>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_bz.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_b := a_b
					l_a_size := mp_size.to_integer_32
					if l_a_size = 0 then
						Result := (l_b = {NATURAL_32} 1).to_integer
						l_return := True
					end
					if not l_return and then (l_b > {NATURAL_32} 4_294_967_295) then
						l_bz[0].mp_alloc := (({PLATFORM}.Natural_32_bytes.to_natural_32 * (2).to_natural_32) // {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_bz[0].mp_d := l_blimbs
						update_class_fields -- Current might have been changed; synchronize
						l_bz.item.gmpz_set_ui (l_b)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp := ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_jacobi (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_bz))
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp
						l_return := True
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l_a_ptr := mp_d
						if ((l_b).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_result_bit1 := ((((l_a_size < 0).to_integer).bit_shift_left (1))).bit_and (l_b.to_integer_32)
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						l_a_low := l_a_ptr[0]
						if l_b /= {NATURAL_32} 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if l_a_size /= 1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if l_a_size /= -1 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | _L:
						if l_a_low = {NATURAL_32} 1 then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_tmp___0 := 0
				when 12 then -- if done
						Result := l_tmp___0
						l_return := True
				when 13 then -- if done
						if not l_return and then (not ((l_a_low).bit_and ({NATURAL_32} 1)).to_boolean) then
							Result := 0
							l_return := True
						end
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_twos := builtin_ctzl (l_b)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
							l_b := (l_b).bit_shift_right (l_twos)
							l_result_bit1 := (((((l_twos).bit_shift_left (1))).bit_and (((((l_a_low).bit_shift_right (1))).bit_xor (l_a_low)).to_integer_32))).bit_xor ((((((l_a_size < 0).to_integer).bit_shift_left (1))).bit_and (l_b.to_integer_32)))
						end
				when 14 then -- if done | if done
					if not l_return and then (l_b = {NATURAL_32} 1) then
						Result := (1 - ((l_result_bit1).bit_and (2)))
						l_return := True
					end
					if not l_return then
						if l_a_size >= 0 then
							l_a_size := l_a_size
						else
							l_a_size := -l_a_size
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___a_ptr := l_a_ptr
							l___a_size := l_a_size
							l___b := l_b
							if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l___a_size >= 22 then
									l_a_rem := (create {P_MOD_1_STATIC}).gmpn_mod_1 (l___a_ptr, l___a_size, l___b)
									update_class_fields -- Current might have been changed; synchronize
								else
									l_result_bit1 := (l_result_bit1).bit_xor (l___b.to_integer_32)
									l_a_rem := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l___a_ptr, l___a_size, l___b)
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_result_bit1 := (l_result_bit1).bit_xor (l___b.to_integer_32)
								l_a_rem := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l___a_ptr, l___a_size, l___b)
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
						l_tmp___1 := gmpn_jacobi_base (l_a_rem, l_b, l_result_bit1)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___1
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_lcm_ui (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v: NATURAL_32)
		require
			not a_u.is_void
		local
			l_v: NATURAL_32
			l_usize: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_g: NATURAL_32
			l_c: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l_return: BOOLEAN
		do
			l_v := a_v
			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			elseif l_v = {NATURAL_32} 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				if l_usize >= 0 then
					l_usize := l_usize
				else
					l_usize := -l_usize
				end
				l_tmp := builtin_expect ((l_usize + 1 > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_usize + 1).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_up := a_u.item.mp_d
				l_tmp___0 := (create {P_GCD_1_STATIC}).gmpn_gcd_1 (l_up, l_usize, l_v)
				update_class_fields -- Current might have been changed; synchronize
				l_g := l_tmp___0
				l_v := l_v // l_g
				l_rp := mp_d
				l_c := (create {P_GMP_STATIC}).gmpn_mul_1 (l_rp, l_up, l_usize, l_v)
				update_class_fields -- Current might have been changed; synchronize
				l_rp[l_usize] := l_c
				update_class_fields -- Current might have been changed; synchronize
				l_usize := l_usize + (l_c /= {NATURAL_32} 0).to_integer
				Current.mp_size := l_usize.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	gmpz_lucnum_ui (a_n: NATURAL_32)
		local
			l_n: NATURAL_32
			l_lalloc: INTEGER_32
			l_xalloc: INTEGER_32
			l_lsize: INTEGER_32
			l_xsize: INTEGER_32
			l_lp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_xp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_c: NATURAL_32
			l_zeros: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: INTEGER_32
			l_yalloc: INTEGER_32
			l_ysize: INTEGER_32
			l_yp: CE_POINTER [NATURAL_32]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___8: CE_POINTER [ANY]
			l_tmp___9: INTEGER_32
			l_tmp___10: NATURAL_32
			l_tmp___11: NATURAL_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l_tmp___12: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_lp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_xp.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)

			l_n := a_n
			if l_n <= {NATURAL_32} 46 then
				mp_d[0] := (gmp_fib_table.item[(l_n + {NATURAL_32} 1).to_integer_32] + {NATURAL_32} 2 * gmp_fib_table.item[(l_n.to_integer_32 - 1) + 1])
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_size := 1
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_lalloc := ((((l_n // {NATURAL_32} 32) * {NATURAL_32} 23) // {NATURAL_32} 32).to_integer_32 + 4) + 2
				l_tmp := builtin_expect ((l_lalloc > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_lalloc).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_lp.item := mp_d
				update_class_fields -- Current might have been changed; synchronize
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_xalloc := l_lalloc
				l_tmp___4 := builtin_expect ((l_xalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___4.to_boolean then
					l_tmp___3 := (l_aaf.new ((l_xalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___2 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_xalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___3 := l_tmp___2
				end
				l_xp.item := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___3)
				update_class_fields -- Current might have been changed; synchronize
				l_zeros := 0
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if ((l_n).bit_and ({NATURAL_32} 1)).to_boolean then
						l_yalloc := ((((l_n // {NATURAL_32} 2) // {NATURAL_32} 32) * {NATURAL_32} 23) // {NATURAL_32} 32).to_integer_32 + 4
						l_tmp___9 := builtin_expect ((l_yalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___9.to_boolean then
							l_tmp___8 := (l_aaf.new ((l_yalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___7 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_yalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___8 := l_tmp___7
						end
						l_yp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___8)
						l_xsize := gmpn_fib2_ui (l_xp.item, l_yp, l_n // {NATURAL_32} 2)
						update_class_fields -- Current might have been changed; synchronize
						l_ysize := l_xsize
						l_ysize := l_ysize - (l_yp[(l_ysize - 1)] = {NATURAL_32} 0).to_integer
						l_c := (create {P_GMP_STATIC}).gmpn_lshift (l_xp.item, l_xp.item, l_xsize, {NATURAL_32} 1)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___10 := (create {P_GMP_STATIC}).gmpn_add_n (l_xp.item, l_xp.item, l_yp, l_xsize)
						update_class_fields -- Current might have been changed; synchronize
						l_c := l_c + l_tmp___10
						l_xp.item[l_xsize] := l_c
						update_class_fields -- Current might have been changed; synchronize
						l_xsize := l_xsize + (l_c /= {NATURAL_32} 0).to_integer
						l_c := (create {P_MUL_STATIC}).gmpn_mul (l_lp.item, l_xp.item, l_xsize, l_yp, l_ysize)
						update_class_fields -- Current might have been changed; synchronize
						l_lsize := l_xsize + l_ysize
						l_lsize := l_lsize - (l_c = {NATURAL_32} 0).to_integer
						l_c := (create {P_GMP_STATIC}).gmpn_lshift (l_xp.item, l_lp.item, l_lsize, {NATURAL_32} 2)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___11 := (create {P_GMP_STATIC}).gmpn_add_n (l_lp.item, l_lp.item, l_xp.item, l_lsize)
						update_class_fields -- Current might have been changed; synchronize
						l_c := l_c + l_tmp___11
						l_lp.item[l_lsize] := l_c
						update_class_fields -- Current might have been changed; synchronize
						l_lsize := l_lsize + (l_c /= {NATURAL_32} 0).to_integer
						if ((l_n).bit_and ({NATURAL_32} 2)).to_boolean then
							l_lp.item[0] := l_lp.item[0] + ({NATURAL_32} 4)
							update_class_fields -- Current might have been changed; synchronize
						else
							from
							until
								(l_break)
							loop
								l_break := False
								asm20 (l___ptr_dummy, l_lp)
								l_break := True
							end
							l_break := False
						end
						l_break := True
					end
					if not (l_return or l_break) then
						from
						until
							(l_break)
						loop
							l_break := False
							l___mp_ptr_swap__tmp := l_xp.item
							l_xp.item := l_lp.item
							update_class_fields -- Current might have been changed; synchronize
							l_lp.item := l___mp_ptr_swap__tmp
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_zeros := l_zeros + 1
						l_n := l_n // ({NATURAL_32} 2)
						if l_n <= {NATURAL_32} 46 then
							l_lp.item[0] := (gmp_fib_table.item[(l_n + {NATURAL_32} 1).to_integer_32] + {NATURAL_32} 2 * gmp_fib_table.item[(l_n.to_integer_32 - 1) + 1])
							update_class_fields -- Current might have been changed; synchronize
							l_lsize := (1).to_integer_32
							l_break := True
						end
					end
				end
				l_break := False
				from
				until
					not (not (l_return) and then (l_zeros /= 0))
				loop
					(create {P_SQR_STATIC}).gmpn_sqr (l_xp.item, l_lp.item, l_lsize)
					update_class_fields -- Current might have been changed; synchronize
					l_lsize := l_lsize * (2)
					l_lsize := l_lsize - (l_xp.item[(l_lsize - 1)] = {NATURAL_32} 0).to_integer
					if ((l_n).bit_and ({NATURAL_32} 1)).to_boolean then
						l_xp.item[0] := l_xp.item[0] + ({NATURAL_32} 2)
						update_class_fields -- Current might have been changed; synchronize
						l_n := {NATURAL_32} 0
					else
						from
						until
							(l_break)
						loop
							l_break := False
							asm21 (l___ptr_dummy___0, l_xp)
							l_break := True
						end
						l_break := False
					end
					from
					until
						(l_break)
					loop
						l_break := False
						l___mp_ptr_swap__tmp___0 := l_xp.item
						l_xp.item := l_lp.item
						update_class_fields -- Current might have been changed; synchronize
						l_lp.item := l___mp_ptr_swap__tmp___0
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_zeros := l_zeros - 1
				end
				Current.mp_size := l_lsize.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___12 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___12.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpz_lucnum2_ui (a_lnsub1: CE_POINTER [PD_MPZ_STRUCT]; a_n: NATURAL_32)
		require
			not a_lnsub1.is_void
		local
			l_lp: CE_POINTER [NATURAL_32]
			l_l1p: CE_POINTER [NATURAL_32]
			l_f1p: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_c: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_f: NATURAL_32
			l_f1: NATURAL_32
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: NATURAL_32
			l_tmp___7: NATURAL_32
			l_tmp___8: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			if a_n <= {NATURAL_32} 46 then
				l_f := gmp_fib_table.item[(a_n + {NATURAL_32} 1).to_integer_32]
				l_f1 := gmp_fib_table.item[(a_n.to_integer_32 - 1) + 1]
				mp_d[0] := l_f + {NATURAL_32} 2 * l_f1
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_size := 1
				update_class_fields -- Current might have been changed; synchronize
				if a_n = {NATURAL_32} 0 then
					a_lnsub1.item.mp_d[0] := (1).to_natural_32
					update_class_fields -- Current might have been changed; synchronize
				else
					a_lnsub1.item.mp_d[0] := {NATURAL_32} 2 * l_f - l_f1
					update_class_fields -- Current might have been changed; synchronize
				end
				if a_n = {NATURAL_32} 0 then
					a_lnsub1.item.mp_size := -1
					update_class_fields -- Current might have been changed; synchronize
				else
					a_lnsub1.item.mp_size := 1
					update_class_fields -- Current might have been changed; synchronize
				end
				l_return := True
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_size := (((a_n // {NATURAL_32} 32) * {NATURAL_32} 23) // {NATURAL_32} 32).to_integer_32 + 4
				l_tmp___3 := builtin_expect ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___3.to_boolean then
					l_tmp___2 := (l_aaf.new ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___1 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := l_tmp___1
				end
				l_f1p := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
				l_tmp___4 := builtin_expect ((l_size + 1 > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___4.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_size + 1).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_tmp___5 := builtin_expect ((l_size + 1 > (a_lnsub1.item.mp_alloc).to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___5.to_boolean then
					a_lnsub1.item.gmpz_realloc (l_size + 1).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_lp := mp_d
				l_l1p := a_lnsub1.item.mp_d
				l_size := gmpn_fib2_ui (l_l1p, l_f1p, a_n)
				update_class_fields -- Current might have been changed; synchronize
				l_c := (create {P_GMP_STATIC}).gmpn_lshift (l_lp, l_f1p, l_size, {NATURAL_32} 1)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___6 := (create {P_GMP_STATIC}).gmpn_add_n (l_lp, l_lp, l_l1p, l_size)
				update_class_fields -- Current might have been changed; synchronize
				l_c := l_c + l_tmp___6
				l_lp[l_size] := l_c
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_size := (l_size + (l_c /= {NATURAL_32} 0).to_integer).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_c := (create {P_GMP_STATIC}).gmpn_lshift (l_l1p, l_l1p, l_size, {NATURAL_32} 1)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___7 := (create {P_GMP_STATIC}).gmpn_sub_n (l_l1p, l_l1p, l_f1p, l_size)
				update_class_fields -- Current might have been changed; synchronize
				l_c := l_c - l_tmp___7
				l_l1p[l_size] := l_c
				update_class_fields -- Current might have been changed; synchronize
				a_lnsub1.item.mp_size := (l_size + (l_c /= {NATURAL_32} 0).to_integer).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___8 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___8.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpz_millerrabin (a_reps: INTEGER_32): INTEGER_32
		local
			l_r: INTEGER_32
			l_nm1: CE_ARRAY [PD_MPZ_STRUCT]
			l_nm3: CE_ARRAY [PD_MPZ_STRUCT]
			l_x___2: CE_ARRAY [PD_MPZ_STRUCT]
			l_y: CE_ARRAY [PD_MPZ_STRUCT]
			l_q: CE_ARRAY [PD_MPZ_STRUCT]
			l_k: NATURAL_32
			l_rstate: CE_ARRAY [PD_GMP_RANDSTATE_STRUCT]
			l_is_prime: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: INTEGER_32
			l___x___0: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___6: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___8: INTEGER_32
			l___x___1: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___11: CE_POINTER [ANY]
			l_tmp___12: CE_POINTER [ANY]
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___16: INTEGER_32
			l___x___2: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___19: CE_POINTER [ANY]
			l_tmp___20: CE_POINTER [ANY]
			l_tmp___21: INTEGER_32
			l___x___3: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___24: CE_POINTER [ANY]
			l_tmp___25: CE_POINTER [ANY]
			l_tmp___26: INTEGER_32
			l_tmp___27: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_nm1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_nm3.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_x___2.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_y.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_q.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GMP_RANDSTATE_STRUCT]} l_rstate.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l___x := l_nm1
				l___x.item.mp_alloc := (mp_size + 1)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___3 := builtin_expect (((mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___3.to_boolean then
					l_tmp___2 := (l_aaf.new ((mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
				else
					l_tmp___1 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := l_tmp___1
				end
				l___x.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
				update_class_fields -- Current might have been changed; synchronize
				l_break := True
			end
			l_break := False
			l_nm1.item.gmpz_sub_ui ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer)), {NATURAL_32} 1)
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l___x___0 := l_x___2
				l___x___0.item.mp_alloc := (mp_size + 1)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___8 := builtin_expect (((mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___8.to_boolean then
					l_tmp___7 := (l_aaf.new ((mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
				else
					l_tmp___6 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___7 := l_tmp___6
				end
				l___x___0.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___7)
				update_class_fields -- Current might have been changed; synchronize
				l_break := True
			end
			l_break := False
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l___x___1 := l_y
				l___x___1.item.mp_alloc := 2 * mp_size
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___13 := builtin_expect (((2 * mp_size).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___13.to_boolean then
					l_tmp___12 := (l_aaf.new ((2 * mp_size).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
				else
					l_tmp___11 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (2 * mp_size).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___12 := l_tmp___11
				end
				l___x___1.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___12)
				update_class_fields -- Current might have been changed; synchronize
				l_break := True
			end
			l_break := False
			l_x___2.item.gmpz_set_ui ({NATURAL_32} 210)
			update_class_fields -- Current might have been changed; synchronize
			gmpz_powm (l_y, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x___2), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nm1), (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer)))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___16 := (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_y)).item.gmpz_cmp_ui ({NATURAL_32} 1)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___16 /= 0 then
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___14 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___14.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
				Result := 0
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___x___2 := l_q
					l___x___2.item.mp_alloc := mp_size
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___21 := builtin_expect ((mp_size.to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___21.to_boolean then
						l_tmp___20 := (l_aaf.new (mp_size.to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
					else
						l_tmp___19 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, mp_size.to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___20 := l_tmp___19
					end
					l___x___2.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___20)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_k := (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nm1)).item.gmpz_scan1 ((0).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_q.item.gmpz_tdiv_q_2exp (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nm1), l_k)
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___x___3 := l_nm3
					l___x___3.item.mp_alloc := (mp_size + 1)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___26 := builtin_expect (((mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___26.to_boolean then
						l_tmp___25 := (l_aaf.new ((mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
					else
						l_tmp___24 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___25 := l_tmp___24
					end
					l___x___3.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___25)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_nm3.item.gmpz_sub_ui ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer)), {NATURAL_32} 3)
				update_class_fields -- Current might have been changed; synchronize
				gmp_randinit_default (create {CE_CLASS_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (l_rstate))
				update_class_fields -- Current might have been changed; synchronize
				l_is_prime := 1
				l_r := 0
				from
				until
					(l_break)
				loop
					l_break := False
					if l_r < a_reps then
						if not l_is_prime.to_boolean then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_return or l_break) then
						l_x___2.item.gmpz_urandomm (create {CE_CLASS_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (l_rstate), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nm3))
						update_class_fields -- Current might have been changed; synchronize
						l_x___2.item.gmpz_add_ui (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x___2), {NATURAL_32} 2)
						update_class_fields -- Current might have been changed; synchronize
						l_is_prime := millerrabin ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nm1), l_x___2, l_y, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_q), l_k)
						update_class_fields -- Current might have been changed; synchronize
						l_r := l_r + 1
					end
				end
				l_break := False
				gmp_randclear (create {CE_CLASS_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (l_rstate))
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___27 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___27.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
				Result := l_is_prime
			end
		end

	gmpz_mul (a_u, a_v: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_u.is_void
			not a_v.is_void
		local
			l_u: CE_POINTER [PD_MPZ_STRUCT]
			l_v: CE_POINTER [PD_MPZ_STRUCT]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_wsize: INTEGER_32
			l_sign_product: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_free_me: CE_POINTER [NATURAL_32]
			l_free_me_size: NATURAL_32
			l_cy_limb: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l___mp_size_t_swap__tmp: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___5: INTEGER_32
			l_tmp___8: CE_POINTER [ANY]
			l_tmp___9: CE_POINTER [ANY]
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_u := a_u
			l_v := a_v
			l_usize := (l_u.item.mp_size).to_integer_32
			l_vsize := (l_v.item.mp_size).to_integer_32
			l_sign_product := (l_usize).bit_xor (l_vsize)
			if l_usize >= 0 then
				l_usize := l_usize
			else
				l_usize := -l_usize
			end
			if l_vsize >= 0 then
				l_vsize := l_vsize
			else
				l_vsize := -l_vsize
			end
			if l_usize < l_vsize then
				from
				until
					(l_break)
				loop
					l_break := False
					l___mpz_srcptr_swap__tmp := l_u
					l_u := l_v
					l_v := l___mpz_srcptr_swap__tmp
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l___mp_size_t_swap__tmp := l_usize
					l_usize := l_vsize
					l_vsize := l___mp_size_t_swap__tmp
					l_break := True
				end
				l_break := False
			end
			if l_vsize = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return and then (l_vsize = 1) then
				l_tmp := builtin_expect ((l_usize + 1 > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_usize + 1).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_wp := mp_d
				l_cy_limb := (create {P_GMP_STATIC}).gmpn_mul_1 (l_wp, l_u.item.mp_d, l_usize, l_v.item.mp_d[0])
				update_class_fields -- Current might have been changed; synchronize
				l_wp[l_usize] := l_cy_limb
				update_class_fields -- Current might have been changed; synchronize
				l_usize := l_usize + (l_cy_limb /= {NATURAL_32} 0).to_integer
				if l_sign_product >= 0 then
					Current.mp_size := l_usize.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_usize).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				l_return := True
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_free_me := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_up := l_u.item.mp_d
				l_vp := l_v.item.mp_d
				l_wp := mp_d
				l_wsize := l_usize + l_vsize
				if mp_alloc.to_integer_32 < l_wsize then
					if l_wp.is_equal (l_up) then
						l_free_me := l_wp
						l_free_me_size := mp_alloc.to_natural_32
					elseif l_wp.is_equal (l_vp) then
						l_free_me := l_wp
						l_free_me_size := mp_alloc.to_natural_32
					else
						(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (l_wp), (mp_alloc * 4).to_natural_32])
						update_class_fields -- Current might have been changed; synchronize
					end
					Current.mp_alloc := l_wsize.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([(l_wsize * 4).to_natural_32]))
					update_class_fields -- Current might have been changed; synchronize
					l_wp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___0)
					Current.mp_d := l_wp
					update_class_fields -- Current might have been changed; synchronize
				elseif l_wp.is_equal (l_up) then
					l_tmp___5 := builtin_expect ((l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___5.to_boolean then
						l_tmp___4 := (l_aaf.new ((l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___3 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___4 := l_tmp___3
					end
					l_up := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___4)
					if l_wp.is_equal (l_vp) then
						l_vp := l_up
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_up, l_wp, l_usize)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				elseif l_wp.is_equal (l_vp) then
					l_tmp___10 := builtin_expect ((l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___10.to_boolean then
						l_tmp___9 := (l_aaf.new ((l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___8 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___9 := l_tmp___8
					end
					l_vp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___9)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_vp, l_wp, l_vsize)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				end
				if l_up.is_equal (l_vp) then
					(create {P_SQR_STATIC}).gmpn_sqr (l_wp, l_up, l_usize)
					update_class_fields -- Current might have been changed; synchronize
					l_wsize := l_usize + l_vsize
					l_cy_limb := l_wp[(l_wsize - 1)]
				else
					l_cy_limb := (create {P_MUL_STATIC}).gmpn_mul (l_wp, l_up, l_usize, l_vp, l_vsize)
					update_class_fields -- Current might have been changed; synchronize
					l_wsize := l_usize + l_vsize
				end
				l_wsize := l_wsize - (l_cy_limb = {NATURAL_32} 0).to_integer
				if l_sign_product < 0 then
					Current.mp_size := (-l_wsize).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := l_wsize.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				if not l_free_me.is_void then
					(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (l_free_me), l_free_me_size * {NATURAL_32} 4])
					update_class_fields -- Current might have been changed; synchronize
				end
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___11 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___11.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpz_mul_2exp (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		require
			not a_u.is_void
		local
			l_cnt: NATURAL_32
			l_usize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_tmp: INTEGER_32
			l_wsize: INTEGER_32
			l_limb_cnt: INTEGER_32
			l_wp: CE_POINTER [NATURAL_32]
			l_wlimb: NATURAL_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			l_cnt := a_cnt
			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_tmp := l_usize
			else
				l_tmp := -l_usize
			end
			l_abs_usize := l_tmp
			if l_usize = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_limb_cnt := (l_cnt // {NATURAL_32} 32).to_integer_32
				l_wsize := (l_abs_usize + l_limb_cnt) + 1
				if mp_alloc.to_integer_32 < l_wsize then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_wsize).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_wp := mp_d
				l_wsize := l_abs_usize + l_limb_cnt
				l_cnt := l_cnt \\ ({NATURAL_32} 32)
				if l_cnt /= {NATURAL_32} 0 then
					l_wlimb := (create {P_GMP_STATIC}).gmpn_lshift (l_wp + l_limb_cnt, a_u.item.mp_d, l_abs_usize, l_cnt.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_wlimb /= {NATURAL_32} 0 then
						l_wp[l_wsize] := l_wlimb
						update_class_fields -- Current might have been changed; synchronize
						l_wsize := l_wsize + 1
					end
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyd (l_wp + l_limb_cnt, a_u.item.mp_d, l_abs_usize)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if l_limb_cnt /= 0 then
						l___dst := l_wp
						l___n := l_limb_cnt
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___0 := l___dst
							l___dst := l___dst + 1
							l_tmp___0.item := (0).to_natural_32
							update_class_fields -- Current might have been changed; synchronize
							l___n := l___n - 1
							if not l___n.to_boolean then
								l_break := True
							end
						end
						l_break := False
					end
					l_break := True
				end
				l_break := False
				if l_usize >= 0 then
					Current.mp_size := l_wsize.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_wsize).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	gmpz_mul_si (a_mult: CE_POINTER [PD_MPZ_STRUCT]; a_small_mult: INTEGER_32)
		require
			not a_mult.is_void
		local
			l_size: INTEGER_32
			l_sign_product: INTEGER_32
			l_sml: NATURAL_32
			l_cy: NATURAL_32
			l_pp: CE_POINTER [NATURAL_32]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_size := (a_mult.item.mp_size).to_integer_32
			l_sign_product := l_size
			if l_size = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			elseif a_small_mult = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				if l_size >= 0 then
					l_size := l_size
				else
					l_size := -l_size
				end
				if a_small_mult >= 0 then
					l_tmp := a_small_mult
				else
					l_tmp := -a_small_mult
				end
				l_sml := l_tmp.to_natural_32
				if l_sml <= {NATURAL_32} 4_294_967_295 then
					l_tmp___0 := builtin_expect ((l_size + 1 > mp_alloc.to_integer_32).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___0.to_boolean then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_size + 1).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pp := mp_d
					l_cy := (create {P_GMP_STATIC}).gmpn_mul_1 (l_pp, a_mult.item.mp_d, l_size, (l_sml).bit_and ({NATURAL_32} 4_294_967_295))
					update_class_fields -- Current might have been changed; synchronize
					l_pp[l_size] := l_cy
					update_class_fields -- Current might have been changed; synchronize
					l_size := l_size + (l_cy /= {NATURAL_32} 0).to_integer
				end
				if (((l_sign_product < 0).to_integer).bit_xor ((a_small_mult < 0).to_integer)).to_boolean then
					Current.mp_size := (-l_size).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := l_size.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	gmpz_mul_ui (a_mult: CE_POINTER [PD_MPZ_STRUCT]; a_small_mult: NATURAL_32)
		require
			not a_mult.is_void
		local
			l_size: INTEGER_32
			l_sign_product: INTEGER_32
			l_sml: NATURAL_32
			l_cy: NATURAL_32
			l_pp: CE_POINTER [NATURAL_32]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_size := (a_mult.item.mp_size).to_integer_32
			l_sign_product := l_size
			if l_size = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			elseif a_small_mult = {NATURAL_32} 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				if l_size >= 0 then
					l_size := l_size
				else
					l_size := -l_size
				end
				l_sml := a_small_mult
				if l_sml <= {NATURAL_32} 4_294_967_295 then
					l_tmp := builtin_expect ((l_size + 1 > mp_alloc.to_integer_32).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_size + 1).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pp := mp_d
					l_cy := (create {P_GMP_STATIC}).gmpn_mul_1 (l_pp, a_mult.item.mp_d, l_size, (l_sml).bit_and ({NATURAL_32} 4_294_967_295))
					update_class_fields -- Current might have been changed; synchronize
					l_pp[l_size] := l_cy
					update_class_fields -- Current might have been changed; synchronize
					l_size := l_size + (l_cy /= {NATURAL_32} 0).to_integer
				end
				if (((l_sign_product < 0).to_integer).bit_xor ((a_small_mult < {NATURAL_32} 0).to_integer)).to_boolean then
					Current.mp_size := (-l_size).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := l_size.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	gmpz_neg (a_u: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_u.is_void
		local
			l_wp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_size: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_usize := (a_u.item.mp_size).to_integer_32
			if not (a_u.c_pointer = c_pointer) then
				if l_usize >= 0 then
					l_size := l_usize
				else
					l_size := -l_usize
				end
				if mp_alloc.to_integer_32 < l_size then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_size).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_wp := mp_d
				l_up := a_u.item.mp_d
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_wp, l_up, l_size)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
			end
			Current.mp_size := (-l_usize).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_out_raw (a_fp: CE_POINTER [SD_IO_FILE]): NATURAL_32
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_xsize: INTEGER_32
			l_abs_xsize: INTEGER_32
			l_bytes: INTEGER_32
			l_i: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [INTEGER_8]
			l_bp: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_xlimb: CE_ARRAY [NATURAL_32]
			l_zeros: INTEGER_32
			l_tsize: NATURAL_32
			l_ssize: NATURAL_32
			l_tmp: CE_POINTER [ANY]
			l_tmp___1: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_bp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_xlimb.make (<<1>>)

			l_fp := a_fp
			l_xsize := mp_size.to_integer_32
			if l_xsize >= 0 then
				l_abs_xsize := l_xsize
			else
				l_abs_xsize := -l_xsize
			end
			l_bytes := (l_abs_xsize * 32 + 7) // 8
			l_tsize := ({NATURAL_32} 4 + l_bytes.to_natural_32).to_natural_32
			l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([l_tsize * {PLATFORM}.Integer_8_bytes.to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			l_tp := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)
			l_bp.item := l_tp + ({NATURAL_32} 4).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			if l_bytes /= 0 then
				l_bp.item := l_bp.item + l_bytes
				update_class_fields -- Current might have been changed; synchronize
				l_xp := mp_d
				l_i := l_abs_xsize
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_bp.item := l_bp.item - (4)
					update_class_fields -- Current might have been changed; synchronize
					l_xlimb.item := l_xp.item
					update_class_fields -- Current might have been changed; synchronize
					from
					until
						(l_break)
					loop
						l_break := False
						asm23 (l_bp, l_xlimb)
						l_break := True
					end
					l_break := False
					l_xp := l_xp + 1
					l_i := l_i - 1
					if not (l_i > 0) then
						l_break := True
					end
				end
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_zeros := builtin_clzl (l_xlimb.item)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_zeros := l_zeros // (8)
				l_bp.item := l_bp.item + l_zeros
				update_class_fields -- Current might have been changed; synchronize
				l_bytes := l_bytes - l_zeros.to_integer_32
			end
			l_ssize := (4 + l_bytes).to_natural_32
			if l_xsize >= 0 then
				l_bytes := l_bytes
			else
				l_bytes := -l_bytes
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if not ({PLATFORM}.Integer_32_bytes.to_natural_32 >= {NATURAL_32} 4) then
					(create {P_ASSERT_STATIC}).gmp_assert_fail (ce_string ("out_raw.c"), 147, ce_string ("sizeof (bytes) >= 4"))
					update_class_fields -- Current might have been changed; synchronize
				end
				l_break := True
			end
			l_break := False
			l_bp.item[-4] := ((l_bytes).bit_shift_right (24)).to_integer_8
			update_class_fields -- Current might have been changed; synchronize
			l_bp.item[-3] := ((l_bytes).bit_shift_right (16)).to_integer_8
			update_class_fields -- Current might have been changed; synchronize
			l_bp.item[-2] := ((l_bytes).bit_shift_right (8)).to_integer_8
			update_class_fields -- Current might have been changed; synchronize
			l_bp.item[-1] := l_bytes.to_integer_8
			update_class_fields -- Current might have been changed; synchronize
			l_bp.item := l_bp.item - (4)
			update_class_fields -- Current might have been changed; synchronize
			if l_fp.is_void then
				l_fp := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))
			end
			l_tmp___1 := fwrite (create {CE_VOID_POINTER}.make_cast (l_bp.item), l_ssize, (1).to_natural_32, l_fp)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___1 /= {NATURAL_32} 1 then
				l_ssize := (0).to_natural_32
			end
			(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (l_tp), l_tsize])
			update_class_fields -- Current might have been changed; synchronize
			Result := l_ssize
		end

	gmpz_out_str (a_stream: CE_POINTER [SD_IO_FILE]; a_base: INTEGER_32): NATURAL_32
		local
			l_stream: CE_POINTER [SD_IO_FILE]
			l_base: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l_x_size: INTEGER_32
			l_str: CE_POINTER [NATURAL_8]
			l_str_size: NATURAL_32
			l_i: NATURAL_32
			l_written: NATURAL_32
			l_num_to_text: CE_POINTER [INTEGER_8]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___6: INTEGER_32
			l_tmp___9: CE_POINTER [ANY]
			l_tmp___10: CE_POINTER [ANY]
			l_tmp___11: INTEGER_32
			l_fwret: NATURAL_32
			l_tmp___12: INTEGER_32
			l_tmp___14: NATURAL_32
			l_tmp___15: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_stream := a_stream
			l_base := a_base
			l_x_size := mp_size.to_integer_32
			if l_stream.is_void then
				l_stream := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))
			end
			if l_base >= 0 then
				l_num_to_text := ce_string ("0123456789abcdefghijklmnopqrstuvwxyz")
				if l_base = 0 then
					l_base := 10
				elseif l_base > 36 then
					l_num_to_text := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz")
					if l_base > 62 then
						Result := (0).to_natural_32
						l_return := True
					end
				end
			else
				l_base := -l_base
				l_num_to_text := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ")
			end
			if not l_return and then (l_x_size = 0) then
				fputc (('0').code, l_stream).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___1 := ferror (l_stream)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___1.to_boolean then
					l_tmp___0 := 0
				else
					l_tmp___0 := 1
				end
				Result := l_tmp___0.to_natural_32
				l_return := True
			end
			if not l_return then
				l_written := (0).to_natural_32
				if l_x_size < 0 then
					fputc (('-').code, l_stream).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_x_size := -l_x_size
					l_written := (1).to_natural_32
				end
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_str_size := ((l_x_size * 32).to_double * (create {P_MP_BASES_STATIC}).gmpn_bases.item[l_base].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32 + {NATURAL_32} 3
				l_tmp___6 := builtin_expect ((l_str_size < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___6.to_boolean then
					l_tmp___5 := (l_aaf.new (l_str_size))
				else
					l_tmp___4 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, l_str_size)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___5 := l_tmp___4
				end
				l_str := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___5)
				l_tmp___11 := builtin_expect (((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___11.to_boolean then
					l_tmp___10 := (l_aaf.new (((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___9 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___10 := l_tmp___9
				end
				l_xp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___10)
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_xp, mp_d, l_x_size)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				l_str_size := (create {P_GET_STR_STATIC}).gmpn_get_str (l_str, l_base, l_xp, l_x_size)
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_str.item).to_integer_32 /= 0
				loop
					l_str_size := l_str_size - 1
					l_str := l_str + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_str_size)
				loop
					l_str[l_i.to_integer_32] := (l_num_to_text[(l_str[l_i.to_integer_32]).to_integer_32]).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_str[l_str_size.to_integer_32] := (0).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				l_fwret := fwrite (create {CE_VOID_POINTER}.make_cast (l_str), (1).to_natural_32, l_str_size, l_stream)
				update_class_fields -- Current might have been changed; synchronize
				l_written := l_written + l_fwret
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___12 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___12.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
				l_tmp___15 := ferror (l_stream)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___15.to_boolean then
					l_tmp___14 := (0).to_natural_32
				else
					l_tmp___14 := l_written
				end
				Result := l_tmp___14
			end
		end

	gmpz_perfect_power_p: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			l_tmp := gmpn_perfect_power_p (mp_d, mp_size.to_integer_32)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	gmpz_powm_sec (a_b, a_e, a_m: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_e.is_void
			not a_m.is_void
		local
			l_n: INTEGER_32
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_ep: CE_POINTER [NATURAL_32]
			l_mp: CE_POINTER [NATURAL_32]
			l_rn: INTEGER_32
			l_bn: INTEGER_32
			l_es: INTEGER_32
			l_en: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			if a_m.item.mp_size >= 0 then
				l_n := (a_m.item.mp_size).to_integer_32
			else
				l_n := (-a_m.item.mp_size).to_integer_32
			end
			if l_n = 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_mp := a_m.item.mp_d
			if l_mp[0] \\ {NATURAL_32} 2 = {NATURAL_32} 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_es := (a_e.item.mp_size).to_integer_32
			l_tmp___0 := builtin_expect ((l_es <= 0).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___0.to_boolean then
				if l_es = 0 then
					if l_n /= 1 then
						l_tmp := 1
					elseif l_mp[0] /= {NATURAL_32} 1 then
						l_tmp := 1
					else
						l_tmp := 0
					end
					Current.mp_size := l_tmp
					update_class_fields -- Current might have been changed; synchronize
					mp_d[0] := (1).to_natural_32
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
				if not l_return then
					(create {P_ERRNO_STATIC}).gmp_divide_by_zero
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				l_en := l_es
				if a_b.item.mp_size >= 0 then
					l_bn := (a_b.item.mp_size).to_integer_32
				else
					l_bn := (-a_b.item.mp_size).to_integer_32
				end
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___8 := gmpn_powm_sec_itch (l_bn, l_en, l_n)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___9 := builtin_expect (((l_n + l_tmp___8).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___9.to_boolean then
					l_tmp___3 := gmpn_powm_sec_itch (l_bn, l_en, l_n)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___7 := (l_aaf.new (((l_n + l_tmp___3).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___5 := gmpn_powm_sec_itch (l_bn, l_en, l_n)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___6 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_n + l_tmp___5).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___7 := l_tmp___6
				end
				l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___7)
				l_rp := l_tp
				l_tp := l_tp + l_n
				l_bp := a_b.item.mp_d
				l_ep := a_e.item.mp_d
				gmpn_powm_sec (l_rp, l_bp, l_bn, l_ep, l_en, l_mp, l_n, l_tp)
				update_class_fields -- Current might have been changed; synchronize
				l_rn := l_n
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						not (not (l_break) and then (l_rn > 0))
					loop
						l_break := False
						if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_break) then
							l_rn := l_rn - 1
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				if ((l_ep[0]).bit_and ({NATURAL_32} 1)).to_boolean then
					if a_b.item.mp_size < 0 then
						if l_rn /= 0 then
							(create {P_GMP_STATIC}).gmpn_sub (l_rp, a_m.item.mp_d, l_n, l_rp, l_rn).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_rn := l_n
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									not (not (l_break) and then (l_rn > 0))
								loop
									l_break := False
									if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
										l_break := True
									end
									if not (l_return or l_break) then
										l_rn := l_rn - 1
									end
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
					end
				end
				l_tmp___10 := builtin_expect ((l_rn > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___10.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_rn).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.mp_size := l_rn.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (mp_d, l_rp, l_rn)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___11 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___11.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpz_random2 (a_size: INTEGER_32)
		local
			l_abs_size: INTEGER_32
		do
			if a_size >= 0 then
				l_abs_size := a_size
			else
				l_abs_size := -a_size
			end
			if l_abs_size /= 0 then
				if mp_alloc.to_integer_32 < l_abs_size then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_abs_size).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_RANDOM2_STATIC}).gmpn_random2 (mp_d, l_abs_size)
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.mp_size := a_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_realloc (a_new_alloc: INTEGER_32): CE_POINTER [ANY]
		local
			l_new_alloc: INTEGER_32
			l_mp: CE_POINTER [NATURAL_32]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: INTEGER_32
		do
			l_new_alloc := a_new_alloc
			if l_new_alloc > 1 then
				l_new_alloc := l_new_alloc
			else
				l_new_alloc := (1).to_integer_32
			end
			if {PLATFORM}.Integer_32_bytes.to_natural_32 = {PLATFORM}.Integer_32_bytes.to_natural_32 then
				l_tmp := builtin_expect ((l_new_alloc.to_natural_32 > {NATURAL_32} 134_217_727).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					Io.error.put_string ("gmp: overflow in mpz type%N")
					abort
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				l_tmp___0 := builtin_expect ((l_new_alloc > (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)).to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					Io.error.put_string ("gmp: overflow in mpz type%N")
					abort
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_tmp___1 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (mp_d), mp_alloc.to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32, (l_new_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			l_mp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___1)
			Current.mp_d := l_mp
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_alloc := l_new_alloc.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			if mp_size >= 0 then
				l_tmp___2 := mp_size
			else
				l_tmp___2 := -mp_size
			end
			if l_tmp___2.to_integer_32 > l_new_alloc then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := (create {CE_VOID_POINTER}.make_cast (l_mp))
		end

	gmpz_realloc2 (a_bits: NATURAL_32)
		local
			l_bits: NATURAL_32
			l_new_alloc: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: INTEGER_32
		do
			l_bits := a_bits
			l_bits := l_bits - (l_bits /= {NATURAL_32} 0).to_integer.to_natural_32
			l_new_alloc := ({NATURAL_32} 1 + l_bits // {NATURAL_32} 32).to_integer_32
			if {PLATFORM}.Natural_32_bytes.to_natural_32 > {PLATFORM}.Integer_32_bytes.to_natural_32 then
				l_tmp := builtin_expect ((l_new_alloc > (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)).to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					Io.error.put_string ("gmp: overflow in mpz type%N")
					abort
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_tmp___0 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (mp_d), mp_alloc.to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32, (l_new_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___0)
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_alloc := l_new_alloc.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			if mp_size >= 0 then
				l_tmp___1 := mp_size
			else
				l_tmp___1 := -mp_size
			end
			if l_tmp___1.to_integer_32 > l_new_alloc then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	gmpz_rrandomb (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_nbits: NATURAL_32)
		local
			l_nl: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_nl := (((a_nbits + {NATURAL_32} 32) - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
			if a_nbits /= {NATURAL_32} 0 then
				l_tmp := builtin_expect ((l_nl > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_nl).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				gmp_rrandomb (mp_d, a_rstate, a_nbits)
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.mp_size := l_nl.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_scan0 (a_starting_bit: NATURAL_32): NATURAL_32
		local
			l_u_ptr: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_tmp: INTEGER_32
			l_u_end: CE_POINTER [NATURAL_32]
			l_starting_limb: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_limb: NATURAL_32
			l_cnt: INTEGER_32
			l_tmp___0: NATURAL_32
			l_q: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_u_ptr := mp_d
					l_size := mp_size.to_integer_32
					if l_size >= 0 then
						l_tmp := l_size
					else
						l_tmp := -l_size
					end
					l_abs_size := l_tmp
					l_u_end := l_u_ptr + l_abs_size
					l_starting_limb := (a_starting_bit // {NATURAL_32} 32).to_integer_32
					l_p := l_u_ptr + l_starting_limb
					if l_starting_limb >= l_abs_size then
						if l_size >= 0 then
							l_tmp___0 := a_starting_bit
						else
							l_tmp___0 := ({NATURAL_32} 0).bit_not
						end
						Result := l_tmp___0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_limb := l_p.item
						if not (l_size >= 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_limb := (l_limb).bit_or (((({NATURAL_32} 1).bit_shift_left ((a_starting_bit \\ {NATURAL_32} 32).to_integer_32)) - {NATURAL_32} 1))
						from
						until
							not (not (l_return) and then (l_limb = {NATURAL_32} 4_294_967_295))
						loop
							l_p := l_p + 1
							if l_p.is_equal (l_u_end) then
								Result := (l_abs_size.to_natural_32 * {NATURAL_32} 32)
								l_return := True
							end
							if not l_return then
								l_limb := l_p.item
							end
						end
						if not l_return then
							l_limb := (l_limb).bit_not
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 4 then -- else:
						l_q := l_p
				when 5 then -- loop condition:
						if l_q.is_equal (l_u_ptr) then
							l_pos := -1 + 8 -- skip loop
						end
				when 6 then -- loop body:
						l_q := l_q - 1
						if l_q.item /= {NATURAL_32} 0 then
							l_pos := -1 + 9 -- goto inverted
						end
				when 7 then
						l_pos := -1 + 5 -- back to loop condition
				when 8 then -- loop done
						l_limb := l_limb - 1
				when 9 then -- inverted:
						l_limb := (l_limb).bit_and ((({NATURAL_32} 4_294_967_295).bit_shift_left ((a_starting_bit \\ {NATURAL_32} 32).to_integer_32)))
						if l_limb = {NATURAL_32} 0 then
							l_p := l_p + 1
							if l_p.is_equal (l_u_end) then
								Result := (({NATURAL_32} 0).bit_not)
								l_return := True
							end
							if not l_return then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_limb := l_p.item
									if l_limb /= {NATURAL_32} 0 then
										l_break := True
									end
									if not (l_return or l_break) then
										l_p := l_p + 1
									end
								end
								l_break := False
							end
						end
				when 10 then -- if done | if done
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_cnt := builtin_ctzl (l_limb)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						Result := ((l_p.distance (l_u_ptr)).to_natural_32 * {NATURAL_32} 32 + l_cnt.to_natural_32)
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_scan1 (a_starting_bit: NATURAL_32): NATURAL_32
		local
			l_u_ptr: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_tmp: INTEGER_32
			l_u_end: CE_POINTER [NATURAL_32]
			l_starting_limb: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_limb: NATURAL_32
			l_cnt: INTEGER_32
			l_tmp___0: NATURAL_32
			l_q: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_u_ptr := mp_d
					l_size := mp_size.to_integer_32
					if l_size >= 0 then
						l_tmp := l_size
					else
						l_tmp := -l_size
					end
					l_abs_size := l_tmp
					l_u_end := l_u_ptr + l_abs_size
					l_starting_limb := (a_starting_bit // {NATURAL_32} 32).to_integer_32
					l_p := l_u_ptr + l_starting_limb
					if l_starting_limb >= l_abs_size then
						if l_size >= 0 then
							l_tmp___0 := ({NATURAL_32} 0).bit_not
						else
							l_tmp___0 := a_starting_bit
						end
						Result := l_tmp___0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_limb := l_p.item
						if not (l_size >= 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_limb := (l_limb).bit_and ((({NATURAL_32} 4_294_967_295).bit_shift_left ((a_starting_bit \\ {NATURAL_32} 32).to_integer_32)))
						if l_limb = {NATURAL_32} 0 then
							l_p := l_p + 1
							if l_p.is_equal (l_u_end) then
								Result := (({NATURAL_32} 0).bit_not)
								l_return := True
							end
							if not l_return then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_limb := l_p.item
									if l_limb /= {NATURAL_32} 0 then
										l_break := True
									end
									if not (l_return or l_break) then
										l_p := l_p + 1
									end
								end
								l_break := False
							end
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						l_q := l_p
				when 5 then -- loop condition:
						if l_q.is_equal (l_u_ptr) then
							l_pos := -1 + 8 -- skip loop
						end
				when 6 then -- loop body:
						l_q := l_q - 1
						if l_q.item /= {NATURAL_32} 0 then
							l_pos := -1 + 10 -- goto inverted
						end
				when 7 then
						l_pos := -1 + 5 -- back to loop condition
				when 8 then -- loop done
						if l_limb = {NATURAL_32} 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_p := l_p + 1
								l_limb := l_p.item
								if l_limb /= {NATURAL_32} 0 then
									l_break := True
								end
							end
							l_break := False
							l_limb := (-l_limb.to_integer_32).to_natural_32
							l_pos := -1 + 12 -- goto got_limb
						end
				when 9 then
						l_limb := l_limb - 1
				when 10 then -- inverted:
						l_limb := (l_limb).bit_or (((({NATURAL_32} 1).bit_shift_left ((a_starting_bit \\ {NATURAL_32} 32).to_integer_32)) - {NATURAL_32} 1))
						from
						until
							not (not (l_return) and then (l_limb = {NATURAL_32} 4_294_967_295))
						loop
							l_p := l_p + 1
							if l_p.is_equal (l_u_end) then
								Result := (l_abs_size.to_natural_32 * {NATURAL_32} 32)
								l_return := True
							end
							if not l_return then
								l_limb := l_p.item
							end
						end
						if not l_return then
							l_limb := (l_limb).bit_not
						end
				when 11 then -- if done | if done
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 12 then -- if: | got_limb:
						
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_cnt := builtin_ctzl (l_limb)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						Result := ((l_p.distance (l_u_ptr)).to_natural_32 * {NATURAL_32} 32 + l_cnt.to_natural_32)
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_set (a_u: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_u.is_void
		local
			l_wp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_size: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_size := l_usize
			else
				l_size := -l_usize
			end
			if mp_alloc.to_integer_32 < l_size then
				((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_size).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			l_wp := mp_d
			l_up := a_u.item.mp_d
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (l_wp, l_up, l_size)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			Current.mp_size := l_usize.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_set_d (a_d: REAL_64)
		local
			l_d: REAL_64
			l_negative: INTEGER_32
			l_tp: CE_ARRAY [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_rn: INTEGER_32
			l_u: PD_IEEE_DOUBLE_EXTRACT
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_tp.make (<<3>>)
			create l_u.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := a_d
					from
					until
						(l_break)
					loop
						l_break := False
						l_u.d := l_d
						update_class_fields -- Current might have been changed; synchronize
						l_u.update_class_fields -- synchronize union
						l_tmp := builtin_expect ((l_u.s.exp = {NATURAL_32} 2_047).to_integer, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp.to_boolean then
							if l_u.s.manl = {NATURAL_32} 0 then
								if l_u.s.manh = {NATURAL_32} 0 then
									(create {P_INVALID_STATIC}).gmp_invalid_operation
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_INVALID_STATIC}).gmp_invalid_operation
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								(create {P_INVALID_STATIC}).gmp_invalid_operation
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := True
					end
					l_break := False
					l_negative := (l_d < (0).to_double).to_integer
					if l_d >= (0).to_double then
						l_d := l_d
					else
						l_d := -l_d
					end
					l_tmp___0 := (create {P_EXTRACT_DBL_STATIC}).gmp_extract_double (l_tp, l_d)
					update_class_fields -- Current might have been changed; synchronize
					l_rn := l_tmp___0.to_integer_32
					if mp_alloc.to_integer_32 < l_rn then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_rn).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_rn <= 0 then
						l_rn := (0).to_integer_32
					end
					l_rp := mp_d
					inspect l_rn.to_integer_32 -- switch 1 head
					when 3 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 1 then l_pos := -1 + 4
					when 0 then l_pos := -1 + 5
					else l_pos := -1 + 1
					end
				when 1 then -- switch 1, default:
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_rn - 3 /= 0 then
							l___dst := l_rp
							l___n := l_rn - 3
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___1 := l___dst
								l___dst := l___dst + 1
								l_tmp___1.item := (0).to_natural_32
								update_class_fields -- Current might have been changed; synchronize
								l___n := l___n - 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					l_rp := l_rp + (l_rn - 3)
				when 2 then -- switch 1, case 3
					l_rp[2] := l_tp[2]
					update_class_fields -- Current might have been changed; synchronize
					l_rp[1] := l_tp[1]
					update_class_fields -- Current might have been changed; synchronize
					l_rp[0] := l_tp[0]
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 2
					l_rp[1] := l_tp[2]
					update_class_fields -- Current might have been changed; synchronize
					l_rp[0] := l_tp[1]
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 1
					l_rp[0] := l_tp[2]
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, case 0
					l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
					if l_negative.to_boolean then
						Current.mp_size := (-l_rn).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					else
						Current.mp_size := l_rn.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_set_f (a_u: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_u.is_void
		local
			l_wp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_exp: INTEGER_32
			l_tmp: INTEGER_32
			l_zeros: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			l_exp := a_u.item.mp_exp
			if l_exp <= 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_tmp := builtin_expect ((l_exp > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_exp).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_wp := mp_d
				l_up := a_u.item.mp_d
				l_size := (a_u.item.mp_size).to_integer_32
				if l_size >= 0 then
					Current.mp_size := l_exp.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_exp).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				if l_size >= 0 then
					l_size := l_size
				else
					l_size := -l_size
				end
				if l_exp > l_size then
					l_zeros := l_exp - l_size
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_zeros /= 0 then
							l___dst := l_wp
							l___n := l_zeros
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___0 := l___dst
								l___dst := l___dst + 1
								l_tmp___0.item := (0).to_natural_32
								update_class_fields -- Current might have been changed; synchronize
								l___n := l___n - 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					l_wp := l_wp + l_zeros
				else
					l_up := l_up + (l_size - l_exp)
					l_size := l_exp
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_wp, l_up, l_size)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
			end
		end

	gmpz_set_si (a_val: INTEGER_32)
		local
			l_size: INTEGER_32
			l_vl: NATURAL_32
			l_tmp: INTEGER_32
		do
			if a_val >= 0 then
				l_tmp := a_val
			else
				l_tmp := -a_val
			end
			l_vl := l_tmp.to_natural_32
			mp_d[0] := (l_vl).bit_and ({NATURAL_32} 4_294_967_295)
			update_class_fields -- Current might have been changed; synchronize
			l_size := (l_vl /= {NATURAL_32} 0).to_integer
			if a_val >= 0 then
				Current.mp_size := l_size.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			else
				Current.mp_size := (-l_size).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	gmpz_set_ui (a_val: NATURAL_32)
		local
			l_size: INTEGER_32
		do
			mp_d[0] := (a_val).bit_and ({NATURAL_32} 4_294_967_295)
			update_class_fields -- Current might have been changed; synchronize
			l_size := (a_val /= {NATURAL_32} 0).to_integer
			Current.mp_size := l_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_setbit (a_bit_index: NATURAL_32)
		local
			l_bit_index: CE_ARRAY [NATURAL_32]
			l_dsize: INTEGER_32
			l_dp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_limb_index: CE_ARRAY [INTEGER_32]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_32]
			l_zero_bound: INTEGER_32
			l_dlimb: NATURAL_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_i: INTEGER_32
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___5: INTEGER_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_bit_index.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_dp.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_limb_index.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bit_index.item := a_bit_index
					update_class_fields -- Current might have been changed; synchronize
					l_dsize := mp_size.to_integer_32
					l_dp.item := mp_d
					update_class_fields -- Current might have been changed; synchronize
					l_limb_index.item := (l_bit_index.item // {NATURAL_32} 32).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					if not (l_dsize >= 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_limb_index.item < l_dsize then
							l_dp.item[l_limb_index.item] := (l_dp.item[l_limb_index.item]).bit_or ((({NATURAL_32} 1).bit_shift_left ((l_bit_index.item \\ {NATURAL_32} 32).to_integer_32)))
							update_class_fields -- Current might have been changed; synchronize
							Current.mp_size := l_dsize.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___0 := builtin_expect ((mp_alloc.to_integer_32 < l_limb_index.item + 1).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___0.to_boolean then
								l_tmp := ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_limb_index.item + 1)
								update_class_fields -- Current might have been changed; synchronize
								l_dp.item := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
								update_class_fields -- Current might have been changed; synchronize
							end
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_limb_index.item - l_dsize /= 0 then
									l___dst := l_dp.item + l_dsize
									l___n := l_limb_index.item - l_dsize
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp___1 := l___dst
										l___dst := l___dst + 1
										l_tmp___1.item := (0).to_natural_32
										update_class_fields -- Current might have been changed; synchronize
										l___n := l___n - 1
										if not l___n.to_boolean then
											l_break := True
										end
									end
									l_break := False
								end
								l_break := True
							end
							l_break := False
							l_dp.item[l_limb_index.item] := ({NATURAL_32} 1).bit_shift_left ((l_bit_index.item \\ {NATURAL_32} 32).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							Current.mp_size := (l_limb_index.item + 1).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else:
						l_dsize := -l_dsize
						l_zero_bound := (0).to_integer_32
						from
						until
							(l_dp.item[l_zero_bound] /= {NATURAL_32} 0)
						loop
							l_zero_bound := l_zero_bound + 1
						end
						if not (l_limb_index.item > l_zero_bound) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_limb_index.item < l_dsize then
							l_dlimb := l_dp.item[l_limb_index.item]
							l_dlimb := (l_dlimb).bit_and ((((({NATURAL_32} 1).bit_shift_left ((l_bit_index.item \\ {NATURAL_32} 32).to_integer_32))).bit_not))
							l_dp.item[l_limb_index.item] := l_dlimb
							update_class_fields -- Current might have been changed; synchronize
							if l_dlimb = {NATURAL_32} 0 then
								if l_limb_index.item = l_dsize - 1 then
									l_tmp___2 := 1
								else
									l_tmp___2 := 0
								end
							else
								l_tmp___2 := 0
							end
							l_tmp___3 := builtin_expect ((l_tmp___2 /= 0).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___3.to_boolean then
								from
								until
									(l_break)
								loop
									l_break := False
									l_dsize := l_dsize - 1
									if l_dsize > 0 then
										if l_dp.item[(l_dsize - 1)] /= {NATURAL_32} 0 then
											l_break := True
										end
									else
										l_break := True
									end
								end
								l_break := False
								Current.mp_size := (-l_dsize).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 6 then -- else:
						if l_limb_index.item /= l_zero_bound then
							l_pos := -1 + 15 -- skip if block
						end
				when 7 then -- if:
						l_dp.item[l_limb_index.item] := (((l_dp.item[l_limb_index.item] - {NATURAL_32} 1)).bit_and (((({NATURAL_32} 1).bit_shift_left ((l_bit_index.item \\ {NATURAL_32} 32).to_integer_32))).bit_not)) + {NATURAL_32} 1
						update_class_fields -- Current might have been changed; synchronize
						if l_dp.item[l_limb_index.item] /= {NATURAL_32} 0 then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
						l_i := l_limb_index.item + 1
				when 9 then -- loop condition:
						if not (l_i < l_dsize) then
							l_pos := -1 + 12 -- skip loop
						end
				when 10 then -- loop body:
						l_dp.item[l_i] := (l_dp.item[l_i]) + 1
						update_class_fields -- Current might have been changed; synchronize
						if l_dp.item[l_i] /= {NATURAL_32} 0 then
							l_pos := -1 + 13 -- goto fin
						end
				when 11 then
						l_i := l_i + 1
						l_pos := -1 + 9 -- back to loop condition
				when 12 then -- loop done
						l_dsize := l_dsize + 1
						l_tmp___5 := builtin_expect ((mp_alloc.to_integer_32 < l_dsize).to_integer, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___5.to_boolean then
							l_tmp___4 := ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_dsize)
							update_class_fields -- Current might have been changed; synchronize
							l_dp.item := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___4)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_dp.item[l_i] := (1).to_natural_32
						update_class_fields -- Current might have been changed; synchronize
						Current.mp_size := (-l_dsize).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
				when 13 then -- fin:
						
				when 14 then -- if done | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						from
						until
							(l_break)
						loop
							l_break := False
							asm26 (l___ptr_dummy, l_dp, l_limb_index, l_bit_index)
							l_break := True
						end
						l_break := False
						l_dsize := l_dsize - (l_dp.item[(l_dsize - 1)] = {NATURAL_32} 0).to_integer
						Current.mp_size := (-l_dsize).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
				when 16 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_sizeinbase (a_base: INTEGER_32): NATURAL_32
		local
			l_result: NATURAL_32
			l___lb_base: INTEGER_32
			l___cnt: INTEGER_32
			l___totbits: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if mp_size >= 0 then
					l_tmp___1 := mp_size
				else
					l_tmp___1 := -mp_size
				end
				if l_tmp___1 = 0 then
					l_result := (1).to_natural_32
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if mp_size >= 0 then
							l_tmp := mp_size
						else
							l_tmp := -mp_size
						end
						l___cnt := builtin_clzl (mp_d[(l_tmp - 1)])
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					if mp_size >= 0 then
						l_tmp___0 := mp_size
					else
						l_tmp___0 := -mp_size
					end
					l___totbits := l_tmp___0.to_natural_32 * {NATURAL_32} 32 - l___cnt.to_natural_32
					if ((a_base).bit_and ((a_base - 1))) = 0 then
						l___lb_base := ((create {P_MP_BASES_STATIC}).gmpn_bases.item[a_base].big_base).to_integer_32
						l_result := ((l___totbits + l___lb_base.to_natural_32) - {NATURAL_32} 1) // l___lb_base.to_natural_32
					else
						l_result := (l___totbits.to_real_64 * (create {P_MP_BASES_STATIC}).gmpn_bases.item[a_base].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32 + {NATURAL_32} 1
					end
				end
				l_break := True
			end
			l_break := False
			Result := l_result
		end

	gmpz_sqrt (a_op: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_op.is_void
		local
			l_op_size: INTEGER_32
			l_root_size: INTEGER_32
			l_root_ptr: CE_POINTER [NATURAL_32]
			l_op_ptr: CE_POINTER [NATURAL_32]
			l_free_me: CE_POINTER [NATURAL_32]
			l_free_me_size: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_free_me := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_op_size := (a_op.item.mp_size).to_integer_32
			if l_op_size <= 0 then
				if l_op_size < 0 then
					(create {P_ERRNO_STATIC}).gmp_sqrt_of_negative
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_root_size := (l_op_size + 1) // 2
				l_root_ptr := mp_d
				l_op_ptr := a_op.item.mp_d
				if mp_alloc.to_integer_32 < l_root_size then
					if l_root_ptr.is_equal (l_op_ptr) then
						l_free_me := l_root_ptr
						l_free_me_size := mp_alloc.to_integer_32
					else
						(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (l_root_ptr), (mp_alloc * 4).to_natural_32])
						update_class_fields -- Current might have been changed; synchronize
					end
					Current.mp_alloc := l_root_size.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([(l_root_size * 4).to_natural_32]))
					update_class_fields -- Current might have been changed; synchronize
					l_root_ptr := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
					Current.mp_d := l_root_ptr
					update_class_fields -- Current might have been changed; synchronize
				elseif l_root_ptr.is_equal (l_op_ptr) then
					l_tmp___4 := builtin_expect ((l_op_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___4.to_boolean then
						l_tmp___3 := (l_aaf.new ((l_op_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___2 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_op_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___3 := l_tmp___2
					end
					l_op_ptr := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___3)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_op_ptr, l_root_ptr, l_op_size)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				end
				(create {P_SQRTREM_STATIC}).gmpn_sqrtrem (l_root_ptr, create {CE_NATURAL_32_POINTER}.make_shared (default_pointer), l_op_ptr, l_op_size).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_size := l_root_size.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				if not l_free_me.is_void then
					(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (l_free_me), (l_free_me_size * 4).to_natural_32])
					update_class_fields -- Current might have been changed; synchronize
				end
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___5 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___5.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpz_sqrtrem (a_rem, a_op: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_rem.is_void
			not a_op.is_void
		local
			l_op_size: INTEGER_32
			l_root_size: INTEGER_32
			l_rem_size: INTEGER_32
			l_root_ptr: CE_POINTER [NATURAL_32]
			l_op_ptr: CE_POINTER [NATURAL_32]
			l_free_me: CE_POINTER [NATURAL_32]
			l_free_me_size: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_free_me := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_op_size := (a_op.item.mp_size).to_integer_32
			if l_op_size <= 0 then
				if l_op_size < 0 then
					(create {P_ERRNO_STATIC}).gmp_sqrt_of_negative
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				a_rem.item.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				if (a_rem.item.mp_alloc).to_integer_32 < l_op_size then
					a_rem.item.gmpz_realloc (l_op_size).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_root_size := (l_op_size + 1) // 2
				l_root_ptr := mp_d
				l_op_ptr := a_op.item.mp_d
				if mp_alloc.to_integer_32 < l_root_size then
					if l_root_ptr.is_equal (l_op_ptr) then
						l_free_me := l_root_ptr
						l_free_me_size := mp_alloc.to_integer_32
					else
						(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (l_root_ptr), (mp_alloc * 4).to_natural_32])
						update_class_fields -- Current might have been changed; synchronize
					end
					Current.mp_alloc := l_root_size.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([(l_root_size * 4).to_natural_32]))
					update_class_fields -- Current might have been changed; synchronize
					l_root_ptr := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
					Current.mp_d := l_root_ptr
					update_class_fields -- Current might have been changed; synchronize
				elseif l_root_ptr.is_equal (l_op_ptr) then
					l_tmp___4 := builtin_expect ((l_op_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___4.to_boolean then
						l_tmp___3 := (l_aaf.new ((l_op_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___2 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_op_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___3 := l_tmp___2
					end
					l_op_ptr := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___3)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_op_ptr, l_root_ptr, l_op_size)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				end
				l_rem_size := (create {P_SQRTREM_STATIC}).gmpn_sqrtrem (l_root_ptr, a_rem.item.mp_d, l_op_ptr, l_op_size)
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_size := l_root_size.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				a_rem.item.mp_size := l_rem_size.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				if not l_free_me.is_void then
					(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (l_free_me), (l_free_me_size * 4).to_natural_32])
					update_class_fields -- Current might have been changed; synchronize
				end
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___5 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___5.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpz_sub (a_u, a_v: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_u.is_void
			not a_v.is_void
		local
			l_u: CE_POINTER [PD_MPZ_STRUCT]
			l_v: CE_POINTER [PD_MPZ_STRUCT]
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_wsize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_abs_vsize: INTEGER_32
			l___mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l___mp_size_t_swap__tmp: INTEGER_32
			l___mp_size_t_swap__tmp___0: INTEGER_32
			l_tmp: INTEGER_32
			l_cy_limb: NATURAL_32
			l_tmp___0: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_u := a_u
			l_v := a_v
			l_usize := (l_u.item.mp_size).to_integer_32
			l_vsize := (-l_v.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_abs_usize := l_usize
			else
				l_abs_usize := -l_usize
			end
			if l_vsize >= 0 then
				l_abs_vsize := l_vsize
			else
				l_abs_vsize := -l_vsize
			end
			if l_abs_usize < l_abs_vsize then
				from
				until
					(l_break)
				loop
					l_break := False
					l___mpz_srcptr_swap__tmp := l_u
					l_u := l_v
					l_v := l___mpz_srcptr_swap__tmp
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l___mp_size_t_swap__tmp := l_usize
					l_usize := l_vsize
					l_vsize := l___mp_size_t_swap__tmp
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l___mp_size_t_swap__tmp___0 := l_abs_usize
					l_abs_usize := l_abs_vsize
					l_abs_vsize := l___mp_size_t_swap__tmp___0
					l_break := True
				end
				l_break := False
			end
			l_wsize := l_abs_usize + 1
			if mp_alloc.to_integer_32 < l_wsize then
				((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_wsize).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			l_up := l_u.item.mp_d
			l_vp := l_v.item.mp_d
			l_wp := mp_d
			if ((l_usize).bit_xor (l_vsize)) < 0 then
				if l_abs_usize /= l_abs_vsize then
					(create {P_GMP_STATIC}).gmpn_sub (l_wp, l_up, l_abs_usize, l_vp, l_abs_vsize).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_wsize := l_abs_usize
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_wsize > 0))
						loop
							l_break := False
							if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_break) then
								l_wsize := l_wsize - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if l_usize < 0 then
						l_wsize := -l_wsize
					end
				else
					l_tmp := (create {P_GMP_STATIC}).gmpn_cmp (l_up, l_vp, l_abs_usize)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp < 0 then
						(create {P_GMP_STATIC}).gmpn_sub_n (l_wp, l_vp, l_up, l_abs_usize).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_wsize := l_abs_usize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_wsize > 0))
							loop
								l_break := False
								if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_wsize := l_wsize - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if l_usize >= 0 then
							l_wsize := -l_wsize
						end
					else
						(create {P_GMP_STATIC}).gmpn_sub_n (l_wp, l_up, l_vp, l_abs_usize).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_wsize := l_abs_usize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_wsize > 0))
							loop
								l_break := False
								if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_wsize := l_wsize - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if l_usize < 0 then
							l_wsize := -l_wsize
						end
					end
				end
			else
				l_tmp___0 := (create {P_GMP_STATIC}).gmpn_add (l_wp, l_up, l_abs_usize, l_vp, l_abs_vsize)
				update_class_fields -- Current might have been changed; synchronize
				l_cy_limb := l_tmp___0
				l_wp[l_abs_usize] := l_cy_limb
				update_class_fields -- Current might have been changed; synchronize
				l_wsize := (l_abs_usize.to_natural_32 + l_cy_limb).to_integer_32
				if l_usize < 0 then
					l_wsize := -l_wsize
				end
			end
			Current.mp_size := l_wsize.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_sub_ui (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_vval: NATURAL_32)
		require
			not a_u.is_void
		local
			l_up: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_wsize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_cy: NATURAL_32
			l_return: BOOLEAN
		do
			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_abs_usize := l_usize
			else
				l_abs_usize := -l_usize
			end
			l_wsize := l_abs_usize + 1
			if mp_alloc.to_integer_32 < l_wsize then
				((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_wsize).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			l_up := a_u.item.mp_d
			l_wp := mp_d
			if l_abs_usize = 0 then
				l_wp[0] := a_vval
				update_class_fields -- Current might have been changed; synchronize
				Current.mp_size := (-(a_vval /= {NATURAL_32} 0).to_integer).to_integer
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				if l_usize < 0 then
					l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (l_wp, l_up, l_abs_usize, a_vval)
					update_class_fields -- Current might have been changed; synchronize
					l_wp[l_abs_usize] := l_cy
					update_class_fields -- Current might have been changed; synchronize
					l_wsize := ((-(l_abs_usize.to_natural_32 + l_cy).to_integer_32).to_natural_32).to_integer_32
				elseif l_abs_usize = 1 then
					if l_up[0] < a_vval then
						l_wp[0] := a_vval - l_up[0]
						update_class_fields -- Current might have been changed; synchronize
						l_wsize := (-1).to_integer_32
					else
						(create {P_GMP_STATIC}).gmpn_sub_1 (l_wp, l_up, l_abs_usize, a_vval).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_wsize := l_abs_usize - (l_wp[(l_abs_usize - 1)] = {NATURAL_32} 0).to_integer
					end
				else
					(create {P_GMP_STATIC}).gmpn_sub_1 (l_wp, l_up, l_abs_usize, a_vval).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_wsize := l_abs_usize - (l_wp[(l_abs_usize - 1)] = {NATURAL_32} 0).to_integer
				end
				Current.mp_size := l_wsize.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	gmpz_swap (a_v: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_v.is_void
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_ualloc: INTEGER_32
			l_valloc: INTEGER_32
		do
			l_ualloc := mp_alloc.to_integer_32
			l_valloc := (a_v.item.mp_alloc).to_integer_32
			a_v.item.mp_alloc := l_ualloc.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_alloc := l_valloc.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_usize := mp_size.to_integer_32
			l_vsize := (a_v.item.mp_size).to_integer_32
			a_v.item.mp_size := l_usize.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_size := l_vsize.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_up := mp_d
			l_vp := a_v.item.mp_d
			a_v.item.mp_d := l_up
			update_class_fields -- Current might have been changed; synchronize
			Current.mp_d := l_vp
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_tdiv_ui (a_divisor: NATURAL_32): NATURAL_32
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_rl: NATURAL_32
			l_return: BOOLEAN
		do
			if a_divisor = {NATURAL_32} 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_ns := mp_size.to_integer_32
			if l_ns = 0 then
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				l_np := mp_d
				l_rl := (create {P_MOD_1_STATIC}).gmpn_mod_1 (l_np, l_nn, a_divisor)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_rl
			end
		end

	gmpz_tdiv_q (a_num, a_den: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_num.is_void
			not a_den.is_void
		local
			l_ql: INTEGER_32
			l_ns: INTEGER_32
			l_ds: INTEGER_32
			l_nl: INTEGER_32
			l_dl: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: INTEGER_32
			l_tp___0: CE_POINTER [NATURAL_32]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___8: CE_POINTER [ANY]
			l_tmp___9: INTEGER_32
			l_tp___1: CE_POINTER [NATURAL_32]
			l_tmp___12: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_ns := (a_num.item.mp_size).to_integer_32
			l_ds := (a_den.item.mp_size).to_integer_32
			if l_ns >= 0 then
				l_nl := l_ns
			else
				l_nl := -l_ns
			end
			if l_ds >= 0 then
				l_dl := l_ds
			else
				l_dl := -l_ds
			end
			l_ql := (l_nl - l_dl) + 1
			if l_dl = 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_ql <= 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_tmp := builtin_expect ((l_ql > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_ql).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_qp := mp_d
				l_np := a_num.item.mp_d
				l_dp := a_den.item.mp_d
				if l_dp.is_equal (l_qp) then
					l_tmp___4 := builtin_expect ((l_dl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___4.to_boolean then
						l_tmp___3 := (l_aaf.new ((l_dl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___2 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_dl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___3 := l_tmp___2
					end
					l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___3)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_dp, l_dl)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_dp := l_tp
				end
				if l_np.is_equal (l_qp) then
					l_tmp___9 := builtin_expect (((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___9.to_boolean then
						l_tmp___8 := (l_aaf.new (((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___7 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___8 := l_tmp___7
					end
					l_tp___0 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___8)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_tp___0, l_np, l_nl)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False;
					(create {P_DIV_Q_STATIC}).gmpn_div_q (l_qp, l_tp___0, l_nl, l_dp, l_dl, l_tp___0)
					update_class_fields -- Current might have been changed; synchronize
				else
					l_tmp___14 := builtin_expect (((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___14.to_boolean then
						l_tmp___13 := (l_aaf.new (((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___12 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_nl + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___13 := l_tmp___12
					end
					l_tp___1 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___13);
					(create {P_DIV_Q_STATIC}).gmpn_div_q (l_qp, l_np, l_nl, l_dp, l_dl, l_tp___1)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_ql := l_ql - (l_qp[(l_ql - 1)] = {NATURAL_32} 0).to_integer
				if ((l_ns).bit_xor (l_ds)) >= 0 then
					Current.mp_size := l_ql.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_ql).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___15 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___15.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpz_tdiv_q_2exp (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		require
			not a_u.is_void
		local
			l_cnt: NATURAL_32
			l_usize: INTEGER_32
			l_wsize: INTEGER_32
			l_limb_cnt: INTEGER_32
			l_tmp: INTEGER_32
			l_wp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			l_cnt := a_cnt
			l_usize := (a_u.item.mp_size).to_integer_32
			l_limb_cnt := (l_cnt // {NATURAL_32} 32).to_integer_32
			if l_usize >= 0 then
				l_tmp := l_usize
			else
				l_tmp := -l_usize
			end
			l_wsize := l_tmp - l_limb_cnt
			if l_wsize <= 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
			else
				if mp_alloc.to_integer_32 < l_wsize then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_wsize).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_wp := mp_d
				l_up := a_u.item.mp_d
				l_cnt := l_cnt \\ ({NATURAL_32} 32)
				if l_cnt /= {NATURAL_32} 0 then
					(create {P_GMP_STATIC}).gmpn_rshift (l_wp, l_up + l_limb_cnt, l_wsize, l_cnt.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_wsize := l_wsize - (l_wp[(l_wsize - 1)] = {NATURAL_32} 0).to_integer
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_wp, l_up + l_limb_cnt, l_wsize)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
				end
				if l_usize >= 0 then
					Current.mp_size := l_wsize.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_wsize).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	gmpz_tdiv_q_ui (a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32): NATURAL_32
		require
			not a_dividend.is_void
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_qn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_rl: NATURAL_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			if a_divisor = {NATURAL_32} 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_ns := (a_dividend.item.mp_size).to_integer_32
			if l_ns = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				l_tmp := builtin_expect ((l_nn > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_nn).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_qp := mp_d
				l_np := a_dividend.item.mp_d
				l_rl := (create {P_GMP_STATIC}).gmpn_divrem_1 (l_qp, (0).to_integer_32, l_np, l_nn, a_divisor)
				update_class_fields -- Current might have been changed; synchronize
				l_qn := l_nn - (l_qp[(l_nn - 1)] = {NATURAL_32} 0).to_integer
				if l_ns >= 0 then
					Current.mp_size := l_qn.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_qn).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_rl
			end
		end

	gmpz_tdiv_qr_ui (a_rem, a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32): NATURAL_32
		require
			not a_rem.is_void
			not a_dividend.is_void
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_qn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_rl: NATURAL_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			if a_divisor = {NATURAL_32} 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_ns := (a_dividend.item.mp_size).to_integer_32
			if l_ns = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				a_rem.item.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				l_tmp := builtin_expect ((l_nn > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_nn).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_qp := mp_d
				l_np := a_dividend.item.mp_d
				l_rl := (create {P_GMP_STATIC}).gmpn_divrem_1 (l_qp, (0).to_integer_32, l_np, l_nn, a_divisor)
				update_class_fields -- Current might have been changed; synchronize
				if l_rl = {NATURAL_32} 0 then
					a_rem.item.mp_size := 0
					update_class_fields -- Current might have been changed; synchronize
				else
					if l_ns >= 0 then
						a_rem.item.mp_size := 1
						update_class_fields -- Current might have been changed; synchronize
					else
						a_rem.item.mp_size := -1
						update_class_fields -- Current might have been changed; synchronize
					end
					a_rem.item.mp_d[0] := l_rl
					update_class_fields -- Current might have been changed; synchronize
				end
				l_qn := l_nn - (l_qp[(l_nn - 1)] = {NATURAL_32} 0).to_integer
				if l_ns >= 0 then
					Current.mp_size := l_qn.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_qn).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_rl
			end
		end

	gmpz_tdiv_r (a_num, a_den: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_num.is_void
			not a_den.is_void
		local
			l_ql: INTEGER_32
			l_ns: INTEGER_32
			l_ds: INTEGER_32
			l_nl: INTEGER_32
			l_dl: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_np___0: CE_POINTER [NATURAL_32]
			l_rp___0: CE_POINTER [NATURAL_32]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___8: CE_POINTER [ANY]
			l_tmp___9: INTEGER_32
			l_tp___0: CE_POINTER [NATURAL_32]
			l_tmp___12: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_ns := (a_num.item.mp_size).to_integer_32
			l_ds := (a_den.item.mp_size).to_integer_32
			if l_ns >= 0 then
				l_nl := l_ns
			else
				l_nl := -l_ns
			end
			if l_ds >= 0 then
				l_dl := l_ds
			else
				l_dl := -l_ds
			end
			l_ql := (l_nl - l_dl) + 1
			if l_dl = 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_tmp := builtin_expect ((l_dl > mp_alloc.to_integer_32).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_dl).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_ql <= 0 then
				if not (a_num.c_pointer = c_pointer) then
					l_np___0 := a_num.item.mp_d
					l_rp___0 := mp_d
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_rp___0, l_np___0, l_nl)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					Current.mp_size := a_num.item.mp_size
					update_class_fields -- Current might have been changed; synchronize
				end
				l_return := True
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___4 := builtin_expect ((l_ql.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___4.to_boolean then
					l_tmp___3 := (l_aaf.new ((l_ql.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___2 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_ql.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___3 := l_tmp___2
				end
				l_qp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___3)
				l_rp := mp_d
				l_np := a_num.item.mp_d
				l_dp := a_den.item.mp_d
				if l_dp.is_equal (l_rp) then
					l_tmp___9 := builtin_expect ((l_dl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___9.to_boolean then
						l_tmp___8 := (l_aaf.new ((l_dl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___7 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_dl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___8 := l_tmp___7
					end
					l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___8)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_dp, l_dl)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_dp := l_tp
				end
				if l_np.is_equal (l_rp) then
					l_tmp___14 := builtin_expect ((l_nl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___14.to_boolean then
						l_tmp___13 := (l_aaf.new ((l_nl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___12 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_nl.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___13 := l_tmp___12
					end
					l_tp___0 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___13)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_tp___0, l_np, l_nl)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_np := l_tp___0
				end
				(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_qp, l_rp, 0, l_np, l_nl, l_dp, l_dl)
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						not (not (l_break) and then (l_dl > 0))
					loop
						l_break := False
						if l_rp[(l_dl - 1)] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_dl := l_dl - 1
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				if l_ns >= 0 then
					Current.mp_size := l_dl.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.mp_size := (-l_dl).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___15 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___15.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpz_tdiv_r_ui (a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32): NATURAL_32
		require
			not a_dividend.is_void
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_rl: NATURAL_32
			l_return: BOOLEAN
		do
			if a_divisor = {NATURAL_32} 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_ns := (a_dividend.item.mp_size).to_integer_32
			if l_ns = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				l_np := a_dividend.item.mp_d
				l_rl := (create {P_MOD_1_STATIC}).gmpn_mod_1 (l_np, l_nn, a_divisor)
				update_class_fields -- Current might have been changed; synchronize
				if l_rl = {NATURAL_32} 0 then
					Current.mp_size := 0
					update_class_fields -- Current might have been changed; synchronize
				else
					if l_ns >= 0 then
						Current.mp_size := 1
						update_class_fields -- Current might have been changed; synchronize
					else
						Current.mp_size := -1
						update_class_fields -- Current might have been changed; synchronize
					end
					mp_d[0] := l_rl
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_rl
			end
		end

	gmpz_ui_sub (a_uval: NATURAL_32; a_v: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_v.is_void
		local
			l_vp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_vn: INTEGER_32
			l_wn: INTEGER_32
			l_cy: NATURAL_32
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: INTEGER_32
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: INTEGER_32
		do
			l_vp := a_v.item.mp_d
			l_vn := (a_v.item.mp_size).to_integer_32
			l_wp := mp_d
			if l_vn > 1 then
				l_tmp___1 := builtin_expect ((l_vn > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___1.to_boolean then
					l_tmp___0 := ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_vn)
					update_class_fields -- Current might have been changed; synchronize
					l_wp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___0)
				else
					l_wp := mp_d
				end
				l_vp := a_v.item.mp_d;
				(create {P_GMP_STATIC}).gmpn_sub_1 (l_wp, l_vp, l_vn, a_uval).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_wn := -(l_vn - (l_wp[(l_vn - 1)] = {NATURAL_32} 0).to_integer)
			elseif l_vn = 1 then
				if a_uval >= l_vp[0] then
					l_wp[0] := a_uval - l_vp[0]
					update_class_fields -- Current might have been changed; synchronize
					l_wn := (l_wp[0] /= {NATURAL_32} 0).to_integer
				else
					l_wp[0] := l_vp[0] - a_uval
					update_class_fields -- Current might have been changed; synchronize
					l_wn := (-1).to_integer_32
				end
			elseif l_vn = 0 then
				l_wp[0] := a_uval
				update_class_fields -- Current might have been changed; synchronize
				l_wn := (a_uval /= {NATURAL_32} 0).to_integer
			else
				l_vn := -l_vn
				l_tmp___4 := builtin_expect ((l_vn + 1 > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___4.to_boolean then
					l_tmp___3 := ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_vn + 1)
					update_class_fields -- Current might have been changed; synchronize
					l_wp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___3)
				else
					l_wp := mp_d
				end
				l_vp := a_v.item.mp_d
				l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (l_wp, l_vp, l_vn, a_uval)
				update_class_fields -- Current might have been changed; synchronize
				l_wp[l_vn] := l_cy
				update_class_fields -- Current might have been changed; synchronize
				l_wn := l_vn + (l_cy /= {NATURAL_32} 0).to_integer
			end
			Current.mp_size := l_wn.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_urandomb (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_nbits: NATURAL_32)
		require
			not a_rstate.is_void
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: INTEGER_32
			l___rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_return, l_break: BOOLEAN
		do
			l_size := ((a_nbits + {NATURAL_32} 31) // {NATURAL_32} 32).to_integer_32
			l_tmp___1 := builtin_expect ((l_size > mp_alloc.to_integer_32).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___1.to_boolean then
				l_tmp___0 := ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_size)
				update_class_fields -- Current might have been changed; synchronize
				l_rp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___0)
			else
				l_rp := mp_d
			end
			from
			until
				(l_break)
			loop
				l_break := False
				l___rstate := a_rstate;
				((create {CE_CLASS_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate, l_rp, a_nbits])
				update_class_fields -- Current might have been changed; synchronize
				l_break := True
			end
			l_break := False
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					not (not (l_break) and then (l_size > 0))
				loop
					l_break := False
					if l_rp[(l_size - 1)] /= {NATURAL_32} 0 then
						l_break := True
					end
					if not (l_break) then
						l_size := l_size - 1
					end
				end
				l_break := False
				l_break := True
			end
			l_break := False
			Current.mp_size := l_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_urandomm (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_n: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_n.is_void
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_nlast: CE_POINTER [NATURAL_32]
			l_nbits: INTEGER_32
			l_size: INTEGER_32
			l_count: INTEGER_32
			l_pow2: INTEGER_32
			l_cmp: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: INTEGER_32
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___6: INTEGER_32
			l___rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_y: NATURAL_32
			l_tmp___7: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			if a_n.item.mp_size >= 0 then
				l_size := (a_n.item.mp_size).to_integer_32
			else
				l_size := (-a_n.item.mp_size).to_integer_32
			end
			if l_size = 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l_nlast := a_n.item.mp_d + (l_size - 1)
			l_pow2 := (((l_nlast.item).bit_and ((l_nlast.item - {NATURAL_32} 1))) = {NATURAL_32} 0).to_integer
			if l_pow2 /= 0 then
				l_np := a_n.item.mp_d
				from
				until
					not (not (l_break) and then ((l_np.c_pointer.to_integer_32).to_natural_32 < (l_nlast.c_pointer.to_integer_32).to_natural_32))
				loop
					l_break := False
					if l_np.item /= {NATURAL_32} 0 then
						l_pow2 := 0
						l_break := True
					end
					if not (l_break) then
						l_np := l_np + 1
					end
				end
				l_break := False
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_count := builtin_clzl (l_nlast.item)
				update_class_fields -- Current might have been changed; synchronize
				l_break := True
			end
			l_break := False
			l_nbits := (l_size * 32 - l_count.to_integer_32) - l_pow2.to_integer_32
			if l_nbits = 0 then
				Current.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_np := a_n.item.mp_d
				if (c_pointer = (a_n).c_pointer) then
					l_tmp___3 := builtin_expect ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___3.to_boolean then
						l_tmp___2 := (l_aaf.new ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___1 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := l_tmp___1
					end
					l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_np, l_size)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_np := l_tp
				end
				l_tmp___6 := builtin_expect ((l_size > mp_alloc.to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___6.to_boolean then
					l_tmp___5 := ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_size)
					update_class_fields -- Current might have been changed; synchronize
					l_rp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___5)
				else
					l_rp := mp_d
				end
				l_rp[(l_size - 1)] := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_count := 80
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						l___rstate := a_rstate;
						((create {CE_CLASS_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate, l_rp, l_nbits.to_natural_32])
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_cmp := 0
						l___gmp_i := l_size
						from
						until
							(l_break)
						loop
							l_break := False
							l___gmp_i := l___gmp_i - 1
							if not (l___gmp_i >= 0) then
								l_break := True
							end
							if not (l_return or l_break) then
								l___gmp_x := l_rp[l___gmp_i]
								l___gmp_y := l_np[l___gmp_i]
								if l___gmp_x /= l___gmp_y then
									if l___gmp_x > l___gmp_y then
										l_cmp := 1
									else
										l_cmp := -1
									end
									l_break := True
								end
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if l_cmp >= 0 then
						l_count := l_count - 1
						if l_count = 0 then
							l_break := True
						end
					else
						l_break := True
					end
				end
				l_break := False
				if l_count = 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n (l_rp, l_rp, l_np, l_size).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						not (not (l_break) and then (l_size > 0))
					loop
						l_break := False
						if l_rp[(l_size - 1)] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_size := l_size - 1
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				Current.mp_size := l_size.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___7 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___7.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpz_xor (a_op1, a_op2: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_op1.is_void
			not a_op2.is_void
		local
			l_op1: CE_POINTER [PD_MPZ_STRUCT]
			l_op2: CE_POINTER [PD_MPZ_STRUCT]
			l_op1_ptr: CE_POINTER [NATURAL_32]
			l_op2_ptr: CE_POINTER [NATURAL_32]
			l_op1_size: INTEGER_32
			l_op2_size: INTEGER_32
			l_res_ptr: CE_POINTER [NATURAL_32]
			l_res_size: INTEGER_32
			l_res_alloc: INTEGER_32
			l_i: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_opx: CE_POINTER [NATURAL_32]
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: INTEGER_32
			l_tmp___6: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l___mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l___mp_srcptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp: INTEGER_32
			l_opx___0: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			l_tmp___12: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_op1 := a_op1
			l_op2 := a_op2
			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_op1_size := (l_op1.item.mp_size).to_integer_32
			l_op2_size := (l_op2.item.mp_size).to_integer_32
			l_op1_ptr := l_op1.item.mp_d
			l_op2_ptr := l_op2.item.mp_d
			l_res_ptr := mp_d
			if l_op1_size >= 0 then
				if l_op2_size >= 0 then
					if l_op1_size >= l_op2_size then
						if mp_alloc.to_integer_32 < l_op1_size then
							((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_op1_size).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_op2_ptr := l_op2.item.mp_d
							l_res_ptr := mp_d
						end
						if not l_res_ptr.is_equal (l_op1_ptr) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_res_ptr + l_op2_size, l_op1_ptr + l_op2_size, l_op1_size - l_op2_size)
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
						l_i := l_op2_size - 1
						from
						until
							not (l_i >= 0)
						loop
							l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_xor (l_op2_ptr[l_i]))
							update_class_fields -- Current might have been changed; synchronize
							l_i := l_i - 1
						end
						l_res_size := l_op1_size
					else
						if mp_alloc.to_integer_32 < l_op2_size then
							((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_op2_size).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_op1_ptr := l_op1.item.mp_d
							l_res_ptr := mp_d
						end
						if not l_res_ptr.is_equal (l_op2_ptr) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_res_ptr + l_op1_size, l_op2_ptr + l_op1_size, l_op2_size - l_op1_size)
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
						l_i := l_op1_size - 1
						from
						until
							not (l_i >= 0)
						loop
							l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_xor (l_op2_ptr[l_i]))
							update_class_fields -- Current might have been changed; synchronize
							l_i := l_i - 1
						end
						l_res_size := l_op2_size
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_res_size > 0))
						loop
							l_break := False
							if l_res_ptr[(l_res_size - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_res_size := l_res_size - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					Current.mp_size := l_res_size.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			elseif l_op2_size < 0 then
				l_op1_size := -l_op1_size
				l_op2_size := -l_op2_size
				l_tmp___3 := builtin_expect ((l_op1_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___3.to_boolean then
					l_tmp___2 := (l_aaf.new ((l_op1_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___1 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_op1_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := l_tmp___1
				end
				l_opx := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2);
				(create {P_GMP_STATIC}).gmpn_sub_1 (l_opx, l_op1_ptr, l_op1_size, (1).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_op1_ptr := l_opx
				l_tmp___8 := builtin_expect ((l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___8.to_boolean then
					l_tmp___7 := (l_aaf.new ((l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___6 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___7 := l_tmp___6
				end
				l_opx := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___7);
				(create {P_GMP_STATIC}).gmpn_sub_1 (l_opx, l_op2_ptr, l_op2_size, (1).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_op2_ptr := l_opx
				if l_op1_size > l_op2_size then
					l_res_alloc := l_op1_size
				else
					l_res_alloc := l_op2_size
				end
				if mp_alloc.to_integer_32 < l_res_alloc then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_res_alloc).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_res_ptr := mp_d
				end
				if l_op1_size > l_op2_size then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_res_ptr + l_op2_size, l_op1_ptr + l_op2_size, l_op1_size - l_op2_size)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_i := l_op2_size - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_xor (l_op2_ptr[l_i]))
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i - 1
					end
					l_res_size := l_op1_size
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_res_ptr + l_op1_size, l_op2_ptr + l_op1_size, l_op2_size - l_op1_size)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_i := l_op1_size - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_xor (l_op2_ptr[l_i]))
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i - 1
					end
					l_res_size := l_op2_size
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						not (not (l_break) and then (l_res_size > 0))
					loop
						l_break := False
						if l_res_ptr[(l_res_size - 1)] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_res_size := l_res_size - 1
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				Current.mp_size := l_res_size.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___9 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___9.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
				l_return := True
			else
				from
				until
					(l_break)
				loop
					l_break := False
					l___mpz_srcptr_swap__tmp := l_op1
					l_op1 := l_op2
					l_op2 := l___mpz_srcptr_swap__tmp
					l_break := True
				end
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						l___mp_srcptr_swap__tmp := l_op1_ptr
						l_op1_ptr := l_op2_ptr
						l_op2_ptr := l___mp_srcptr_swap__tmp
						l_break := True
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						l___mp_size_t_swap__tmp := l_op1_size
						l_op1_size := l_op2_size
						l_op2_size := l___mp_size_t_swap__tmp
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
			end
			if not l_return then
				l_op2_size := -l_op2_size
				l_tmp___14 := builtin_expect ((l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___14.to_boolean then
					l_tmp___13 := (l_aaf.new ((l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___12 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___13 := l_tmp___12
				end
				l_opx___0 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___13);
				(create {P_GMP_STATIC}).gmpn_sub_1 (l_opx___0, l_op2_ptr, l_op2_size, (1).to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_op2_ptr := l_opx___0
				if l_op1_size > l_op2_size then
					l_tmp___15 := l_op1_size
				else
					l_tmp___15 := l_op2_size
				end
				l_res_alloc := l_tmp___15 + 1
				if mp_alloc.to_integer_32 < l_res_alloc then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_res_alloc).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_op1_ptr := l_op1.item.mp_d
					l_res_ptr := mp_d
				end
				if l_op1_size > l_op2_size then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_res_ptr + l_op2_size, l_op1_ptr + l_op2_size, l_op1_size - l_op2_size)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_i := l_op2_size - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_xor (l_op2_ptr[l_i]))
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i - 1
					end
					l_res_size := l_op1_size
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_res_ptr + l_op1_size, l_op2_ptr + l_op1_size, l_op2_size - l_op1_size)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_i := l_op1_size - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_xor (l_op2_ptr[l_i]))
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i - 1
					end
					l_res_size := l_op2_size
				end
				l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (l_res_ptr, l_res_ptr, l_res_size, (1).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				if l_cy.to_boolean then
					l_res_ptr[l_res_size] := l_cy
					update_class_fields -- Current might have been changed; synchronize
					l_res_size := l_res_size + 1
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						not (not (l_break) and then (l_res_size > 0))
					loop
						l_break := False
						if l_res_ptr[(l_res_size - 1)] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_res_size := l_res_size - 1
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				Current.mp_size := (-l_res_size).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___16 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___16.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpq_get_den (a_src: CE_POINTER [PD_MPQ_STRUCT])
		require
			not a_src.is_void
		local
			l_size: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_size := (a_src.item.mp_den.mp_size).to_integer_32
			if mp_alloc.to_integer_32 < l_size then
				((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_size).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (mp_d, a_src.item.mp_den.mp_d, l_size)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			Current.mp_size := l_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpq_get_num (a_src: CE_POINTER [PD_MPQ_STRUCT])
		require
			not a_src.is_void
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_size := (a_src.item.mp_num.mp_size).to_integer_32
			if l_size >= 0 then
				l_tmp := l_size
			else
				l_tmp := -l_size
			end
			l_abs_size := l_tmp
			if mp_alloc.to_integer_32 < l_abs_size then
				((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_realloc (l_abs_size).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (mp_d, a_src.item.mp_num.mp_d, l_abs_size)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			Current.mp_size := l_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_set_q (a___gmp_u: CE_POINTER [PD_MPQ_STRUCT])
		do
			((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_tdiv_q (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a___gmp_u.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a___gmp_u.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_legendre (a_b: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_jacobi (a_b)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	gmpz_bin_ui (a_n: CE_POINTER [PD_MPZ_STRUCT]; a_k: NATURAL_32)
		require
			not a_n.is_void
		local
			l_k: NATURAL_32
			l_ni: CE_ARRAY [PD_MPZ_STRUCT]
			l_i: CE_ARRAY [NATURAL_32]
			l_nacc: CE_ARRAY [PD_MPZ_STRUCT]
			l_kacc: CE_ARRAY [NATURAL_32]
			l_negate: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: NATURAL_32
			l_tmp___4: INTEGER_32
			l_k1: CE_ARRAY [NATURAL_32]
			l_k0: CE_ARRAY [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_ni.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_i.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_nacc.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_kacc.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_k1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_k0.make (<<1>>)

			l_k := a_k
			if a_n.item.mp_size < 0 then
				l_tmp___1 := -1
			else
				l_tmp___1 := (a_n.item.mp_size > 0).to_integer
			end
			if l_tmp___1 < 0 then
				l_ni.item.gmpz_init
				update_class_fields -- Current might have been changed; synchronize
				l_ni.item.gmpz_neg (a_n)
				update_class_fields -- Current might have been changed; synchronize
				l_ni.item.gmpz_sub_ui (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ni), {NATURAL_32} 1)
				update_class_fields -- Current might have been changed; synchronize
				l_negate := ((l_k).bit_and ({NATURAL_32} 1)).to_integer_32
			else
				l_tmp___0 := a_n.item.gmpz_cmp_ui (l_k)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0 < 0 then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_set_ui ({NATURAL_32} 0)
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
				if not l_return then
					l_ni.item.gmpz_init
					update_class_fields -- Current might have been changed; synchronize
					l_ni.item.gmpz_sub_ui (a_n, l_k)
					update_class_fields -- Current might have been changed; synchronize
					l_negate := (0).to_integer_32
				end
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_set_ui ({NATURAL_32} 1)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___4 := (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ni)).item.gmpz_cmp_ui (l_k)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___4 < 0 then
					l_tmp___2 := l_k
					l_k := (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ni)).item.gmpz_get_ui
					update_class_fields -- Current might have been changed; synchronize
					l_ni.item.gmpz_set_ui (l_tmp___2)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_kacc.item := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_nacc.item.gmpz_init_set_ui ({NATURAL_32} 1)
				update_class_fields -- Current might have been changed; synchronize
				l_i.item := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					not (not (l_return) and then (l_i.item <= l_k))
				loop
					l_ni.item.gmpz_add_ui (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ni), {NATURAL_32} 1)
					update_class_fields -- Current might have been changed; synchronize
					l_nacc.item.gmpz_mul (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nacc), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ni))
					update_class_fields -- Current might have been changed; synchronize
					asm5 (l_k0, l_k1, l_kacc, l_i)
					l_k0.item := l_k0.item
					update_class_fields -- Current might have been changed; synchronize
					if l_k1.item /= {NATURAL_32} 0 then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_mul ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nacc))
						update_class_fields -- Current might have been changed; synchronize
						l_nacc.item.gmpz_set_ui ({NATURAL_32} 1)
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_IMPL_STATIC}).gmpn_divexact_1 (mp_d, mp_d, mp_size.to_integer_32, l_kacc.item)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
							Current.mp_size := mp_size - (mp_d[(mp_size - 1)] = {NATURAL_32} 0).to_integer
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_kacc.item := l_i.item
						update_class_fields -- Current might have been changed; synchronize
					else
						l_kacc.item := l_k0.item
						update_class_fields -- Current might have been changed; synchronize
					end
					l_i.item := l_i.item + 1
					update_class_fields -- Current might have been changed; synchronize
				end
				((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_mul ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nacc))
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_IMPL_STATIC}).gmpn_divexact_1 (mp_d, mp_d, mp_size.to_integer_32, l_kacc.item)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					Current.mp_size := mp_size - (mp_d[(mp_size - 1)] = {NATURAL_32} 0).to_integer
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				Current.mp_size := (((mp_size.to_integer_32).bit_xor (-l_negate)) + l_negate).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_nacc.item.gmpz_clear
				update_class_fields -- Current might have been changed; synchronize
				l_ni.item.gmpz_clear
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	gmpz_cdiv_r (a_dividend, a_divisor: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_dividend.is_void
			not a_divisor.is_void
		local
			l_divisor: CE_POINTER [PD_MPZ_STRUCT]
			l_divisor_size: INTEGER_32
			l_temp_divisor: CE_ARRAY [PD_MPZ_STRUCT]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_temp_divisor.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_divisor := a_divisor
			l_divisor_size := (l_divisor.item.mp_size).to_integer_32
			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			if (c_pointer = (l_divisor).c_pointer) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___x := l_temp_divisor
					if l_divisor_size >= 0 then
						l___x.item.mp_alloc := l_divisor_size.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					else
						l___x.item.mp_alloc := (-l_divisor_size).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_divisor_size >= 0 then
						l_tmp___6 := l_divisor_size
					else
						l_tmp___6 := -l_divisor_size
					end
					l_tmp___7 := builtin_expect ((l_tmp___6.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___7.to_boolean then
						if l_divisor_size >= 0 then
							l_tmp___1 := l_divisor_size
						else
							l_tmp___1 := -l_divisor_size
						end
						l_tmp___5 := (l_aaf.new ((l_tmp___1.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						if l_divisor_size >= 0 then
							l_tmp___3 := l_divisor_size
						else
							l_tmp___3 := -l_divisor_size
						end
						l_tmp___4 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_tmp___3.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___5 := l_tmp___4
					end
					l___x.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___5)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_temp_divisor.item.gmpz_set (l_divisor)
				update_class_fields -- Current might have been changed; synchronize
				l_divisor := create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_temp_divisor)
			end
			((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_tdiv_r (a_dividend, l_divisor)
			update_class_fields -- Current might have been changed; synchronize
			if ((l_divisor_size).bit_xor ((a_dividend.item.mp_size).to_integer_32)) >= 0 then
				if mp_size /= 0 then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_sub ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer)), l_divisor)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp___8 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___8.to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_break := True
			end
			l_break := False
		end

	gmpz_dump
		local
			l_str: CE_POINTER [INTEGER_8]
			l_tmp: NATURAL_32
		do
			l_str := ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_get_str (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), 10)
			update_class_fields -- Current might have been changed; synchronize
			Io.put_string (eif_string (l_str) + "%N")
			l_tmp := strlen (l_str)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (l_str), l_tmp + {NATURAL_32} 1])
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpz_fdiv_r (a_dividend, a_divisor: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_dividend.is_void
			not a_divisor.is_void
		local
			l_divisor: CE_POINTER [PD_MPZ_STRUCT]
			l_divisor_size: INTEGER_32
			l_temp_divisor: CE_ARRAY [PD_MPZ_STRUCT]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_temp_divisor.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_divisor := a_divisor
			l_divisor_size := (l_divisor.item.mp_size).to_integer_32
			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			if (c_pointer = (l_divisor).c_pointer) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___x := l_temp_divisor
					if l_divisor_size >= 0 then
						l___x.item.mp_alloc := l_divisor_size.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					else
						l___x.item.mp_alloc := (-l_divisor_size).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_divisor_size >= 0 then
						l_tmp___6 := l_divisor_size
					else
						l_tmp___6 := -l_divisor_size
					end
					l_tmp___7 := builtin_expect ((l_tmp___6.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___7.to_boolean then
						if l_divisor_size >= 0 then
							l_tmp___1 := l_divisor_size
						else
							l_tmp___1 := -l_divisor_size
						end
						l_tmp___5 := (l_aaf.new ((l_tmp___1.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						if l_divisor_size >= 0 then
							l_tmp___3 := l_divisor_size
						else
							l_tmp___3 := -l_divisor_size
						end
						l_tmp___4 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_tmp___3.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___5 := l_tmp___4
					end
					l___x.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___5)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_temp_divisor.item.gmpz_set (l_divisor)
				update_class_fields -- Current might have been changed; synchronize
				l_divisor := create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_temp_divisor)
			end
			((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_tdiv_r (a_dividend, l_divisor)
			update_class_fields -- Current might have been changed; synchronize
			if ((l_divisor_size).bit_xor ((a_dividend.item.mp_size).to_integer_32)) < 0 then
				if mp_size /= 0 then
					((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_add ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer)), l_divisor)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp___8 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___8.to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_break := True
			end
			l_break := False
		end

	gmpz_nextprime (a_n: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_n.is_void
		local
			l_moduli: CE_POINTER [NATURAL_16]
			l_difference: NATURAL_32
			l_i: INTEGER_32
			l_prime_limit: NATURAL_32
			l_prime: NATURAL_32
			l_cnt: INTEGER_32
			l_pn: INTEGER_32
			l_nbits: NATURAL_32
			l_incr: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: NATURAL_32
			l_r: NATURAL_32
			l_tmp___5: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp___0 := a_n.item.gmpz_cmp_ui ({NATURAL_32} 2)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___0 < 0 then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_set_ui ({NATURAL_32} 2)
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return then
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_add_ui (a_n, {NATURAL_32} 1)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_setbit ((0).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_cmp_ui ({NATURAL_32} 7)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2 <= 0 then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_pn := mp_size.to_integer_32
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_cnt := builtin_clzl (mp_d[(l_pn - 1)])
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_nbits := (l_pn * 32 - l_cnt.to_integer_32).to_natural_32
						if l_nbits // {NATURAL_32} 2 >= {NATURAL_32} 167 then
							l_prime_limit := {NATURAL_32} 166
						else
							l_prime_limit := (l_nbits // {NATURAL_32} 2).to_natural_32
						end
						l_moduli := create {CE_NATURAL_16_POINTER}.make_cast ((l_aaf.new ((l_prime_limit * {PLATFORM}.Natural_16_bytes.to_natural_32) * {PLATFORM}.Natural_16_bytes.to_natural_32)))
				when 2 then -- loop condition:
						if (l_return) then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						l_prime := {NATURAL_32} 3
						l_i := 0
						from
						until
							not (l_i.to_natural_32 < l_prime_limit)
						loop
							l_tmp___4 := ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_fdiv_ui (l_prime)
							update_class_fields -- Current might have been changed; synchronize
							l_moduli[l_i] := l_tmp___4.to_natural_16
							update_class_fields -- Current might have been changed; synchronize
							l_prime := l_prime + (primegap.item[l_i]).to_natural_32
							l_i := l_i + 1
						end
						l_incr := {NATURAL_32} 0
						l_difference := l_incr.to_natural_32
				when 4 then -- loop condition:
						if not (not (l_return) and then (l_incr < {NATURAL_32} 65_536)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 5 then -- loop body:
						l_prime := {NATURAL_32} 3
						l_i := 0
				when 6 then -- loop condition:
						if not (l_i.to_natural_32 < l_prime_limit) then
							l_pos := -1 + 9 -- skip loop
						end
				when 7 then -- loop body:
						l_r := (((l_moduli[l_i]).to_natural_32 + l_incr).to_natural_32 \\ l_prime).to_natural_32
						l_prime := l_prime + (primegap.item[l_i]).to_natural_32
						if l_r = {NATURAL_32} 0 then
							l_pos := -1 + 10 -- goto next
						end
				when 8 then
						l_i := l_i + 1
						l_pos := -1 + 6 -- back to loop condition
				when 9 then -- loop done;
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_add_ui ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer)), l_difference)
						update_class_fields -- Current might have been changed; synchronize
						l_difference := {NATURAL_32} 0
						l_tmp___5 := ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_millerrabin (10)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___5.to_boolean then
							l_pos := -1 + 12 -- goto done
						end
				when 10 then -- next:
						l_incr := l_incr + ({NATURAL_32} 2)
						l_difference := l_difference + ({NATURAL_32} 2)
						l_pos := -1 + 4 -- back to loop condition
				when 11 then -- loop done;
						((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_add_ui ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer)), l_difference)
						update_class_fields -- Current might have been changed; synchronize
						l_difference := {NATURAL_32} 0
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- done:
						
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_random (a_size: INTEGER_32)
		local
			l_tmp: INTEGER_32
		do
			if a_size >= 0 then
				l_tmp := a_size
			else
				l_tmp := -a_size
			end
			if not ((create {P_RANDS_STATIC}).gmp_rands_initialized.item).to_boolean then
				(create {P_RANDS_STATIC}).gmp_rands_initialized.item := (1).to_integer_8
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (((create {P_GMP_IMPL_STATIC}).gmp_rands.item))).item.gmp_randinit_mt_noseed
				update_class_fields -- Current might have been changed; synchronize
			end
			((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer))).item.gmpz_urandomb (create {CE_CLASS_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (((create {P_GMP_IMPL_STATIC}).gmp_rands.item)), (l_tmp * 32).to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			if a_size < 0 then
				Current.mp_size := -mp_size
				update_class_fields -- Current might have been changed; synchronize
			end
		end

feature {PD_MPZ_STRUCT} -- private routines

	gmpn_jacobi_base (a_a, a_b: NATURAL_32; a_result_bit1: INTEGER_32): INTEGER_32
		local
			l_a: NATURAL_32
			l_b: NATURAL_32
			l_result_bit1: INTEGER_32
			l_twos: NATURAL_32
			l___mp_limb_t_swap__tmp: NATURAL_32
			l_twos___0: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a := a_a
					l_b := a_b
					l_result_bit1 := a_result_bit1
					if l_a = {NATURAL_32} 0 then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_twos := (builtin_ctzl (l_a)).to_natural_32
							l_break := True
						end
						l_break := False
						l_result_bit1 := (l_result_bit1).bit_xor (((((l_twos).bit_shift_left (1)).to_integer_32).bit_and (((((l_b).bit_shift_right (1))).bit_xor (l_b)).to_integer_32)))
						l_a := (l_a).bit_shift_right (l_twos.to_integer_32)
						if l_a = {NATURAL_32} 1 then
							l_pos := -1 + 11 -- goto done
						end
				when 2 then
						if (l_return) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_result_bit1 := (l_result_bit1).bit_xor (((l_a).bit_and (l_b)).to_integer_32)
						from
						until
							(l_break)
						loop
							l_break := False
							l___mp_limb_t_swap__tmp := l_a
							l_a := l_b
							l_b := l___mp_limb_t_swap__tmp
							l_break := True
						end
						l_break := False
				when 4 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 9 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						l_a := l_a - l_b
						if l_a = {NATURAL_32} 0 then
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_twos___0 := (builtin_ctzl (l_a)).to_natural_32
							l_break := True
						end
						l_break := False
						l_result_bit1 := (l_result_bit1).bit_xor (((((l_twos___0).bit_shift_left (1)).to_integer_32).bit_and (((((l_b).bit_shift_right (1))).bit_xor (l_b)).to_integer_32)))
						l_a := (l_a).bit_shift_right (l_twos___0.to_integer_32)
						if l_a = {NATURAL_32} 1 then
							l_pos := -1 + 11 -- goto done
						end
				when 7 then
						if not (l_a >= l_b) then
							l_break := True
						end
				when 8 then -- if done
						l_pos := -1 + 4 -- back to loop condition
				when 9 then -- loop done
						if not l_return then
							l_break := False
						end
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done | if done
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 11 then -- if: | done:
						Result := (1 - ((l_result_bit1).bit_and (2)))
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_fib2_ui (a_fp, a_f1p: CE_POINTER [NATURAL_32]; a_n: NATURAL_32): INTEGER_32
		require
			not a_fp.is_void
			not a_f1p.is_void
		local
			l_size: INTEGER_32
			l_nfirst: NATURAL_32
			l_mask: NATURAL_32
			l_alloc: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			l_c: NATURAL_32
			l_tmp___4: INTEGER_32
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_mask := {NATURAL_32} 1
			l_nfirst := a_n
			from
			until
				not (l_nfirst > {NATURAL_32} 47)
			loop
				l_mask := (l_mask).bit_shift_left ((1))
				l_nfirst := l_nfirst // ({NATURAL_32} 2)
			end
			a_f1p[0] := gmp_fib_table.item[(l_nfirst.to_integer_32 - 1) + 1]
			a_fp[0] := gmp_fib_table.item[(l_nfirst + {NATURAL_32} 1).to_integer_32]
			l_size := (1).to_integer_32
			if l_mask /= {NATURAL_32} 1 then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_alloc := (((a_n // {NATURAL_32} 32) * {NATURAL_32} 23) // {NATURAL_32} 32).to_integer_32 + 4
				if (builtin_expect ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___2 := (l_aaf.new ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___2 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_xp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_SQR_STATIC}).gmpn_sqr (l_xp, a_fp, l_size);
					(create {P_SQR_STATIC}).gmpn_sqr (a_fp, a_f1p, l_size)
					l_size := l_size * (2)
					l_size := l_size - (l_xp[(l_size - 1)] = {NATURAL_32} 0).to_integer
					a_f1p[l_size] := (create {P_GMP_STATIC}).gmpn_add_n (a_f1p, l_xp, a_fp, l_size)
					l_c := (create {P_GMP_STATIC}).gmpn_lshift (l_xp, l_xp, l_size, {NATURAL_32} 2)
					if ((a_n).bit_and (l_mask)).to_boolean then
						l_tmp___4 := 0
					else
						l_tmp___4 := 2
					end
					l_xp[0] := (l_xp[0]).bit_or (l_tmp___4.to_natural_32)
					l_c := l_c - ((create {P_GMP_STATIC}).gmpn_sub_n (a_fp, l_xp, a_fp, l_size))
					if ((a_n).bit_and (l_mask)).to_boolean then
						l_tmp___6 := 2
					else
						l_tmp___6 := 0
					end
					a_fp[0] := a_fp[0] - l_tmp___6.to_natural_32
					a_fp[l_size] := l_c
					l_size := l_size + (a_fp[l_size] /= {NATURAL_32} 0).to_integer
					l_mask := (l_mask).bit_shift_right ((1))
					if ((a_n).bit_and (l_mask)).to_boolean then
						(create {P_GMP_STATIC}).gmpn_sub_n (a_f1p, a_fp, a_f1p, l_size).do_nothing
					else
						(create {P_GMP_STATIC}).gmpn_sub_n (a_fp, a_fp, a_f1p, l_size).do_nothing
						l_size := l_size - (a_fp[(l_size - 1)] = {NATURAL_32} 0).to_integer
					end
					if l_mask = {NATURAL_32} 1 then
						l_break := True
					end
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
			end
			Result := l_size
		end

	gmpn_popcount (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_popcount (a_arg1.c_pointer, a_arg2)
		end

	c_gmpn_popcount (a_arg1: POINTER; a_arg2: INTEGER_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_popcount($a_arg1, $a_arg2);"
		end

	gmp_randclear (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT])
		require
			not a_rstate.is_void
		do
			((create {CE_CLASS_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (a_rstate.item.mp_algdata.mp_lc)).item.randclear_fn).call ([a_rstate])
		end

	gmp_randinit_default (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT])
		require
			not a_rstate.is_void
		do
			a_rstate.item.gmp_randinit_mt
		end

	gmpz_congruent_p (a_a, a_c, a_d: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		require
			not a_a.is_void
			not a_c.is_void
			not a_d.is_void
		local
			l_a: CE_POINTER [PD_MPZ_STRUCT]
			l_c: CE_POINTER [PD_MPZ_STRUCT]
			l_asize: INTEGER_32
			l_csize: INTEGER_32
			l_dsize: INTEGER_32
			l_sign: INTEGER_32
			l_ap: CE_POINTER [NATURAL_32]
			l_cp: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_xp: CE_POINTER [NATURAL_32]
			l_alow: NATURAL_32
			l_clow: NATURAL_32
			l_dlow: NATURAL_32
			l_dmask: NATURAL_32
			l_r: NATURAL_32
			l_result: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l___twos: NATURAL_32
			l___dnorm: NATURAL_32
			l_tmp___5: NATURAL_32
			l_twos: NATURAL_32
			l_tmp___7: INTEGER_32
			l_dsecond: NATURAL_32
			l_twos___0: NATURAL_32
			l_tmp___12: CE_POINTER [ANY]
			l_carry: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a := a_a
					l_c := a_c
					l_dsize := (a_d.item.mp_size).to_integer_32
					if (builtin_expect ((l_dsize = 0).to_integer, 0)).to_boolean then
						Result := ((l_a.item.gmpz_cmp (l_c)) = 0).to_integer
						l_return := True
					end
					if not l_return then
						if l_dsize >= 0 then
							l_dsize := l_dsize
						else
							l_dsize := -l_dsize
						end
						l_dp := a_d.item.mp_d
						if l_a.item.mp_size >= 0 then
							l_tmp___1 := l_a.item.mp_size
						else
							l_tmp___1 := -l_a.item.mp_size
						end
						if l_c.item.mp_size >= 0 then
							l_tmp___2 := l_c.item.mp_size
						else
							l_tmp___2 := -l_c.item.mp_size
						end
						if l_tmp___1 < l_tmp___2 then
							from
							until
								(l_break)
							loop
								l_break := False
								l___mpz_srcptr_swap__tmp := l_a
								l_a := l_c
								l_c := l___mpz_srcptr_swap__tmp
								l_break := True
							end
							l_break := False
						end
						l_asize := (l_a.item.mp_size).to_integer_32
						l_csize := (l_c.item.mp_size).to_integer_32
						l_sign := (l_asize).bit_xor (l_csize)
						if l_asize >= 0 then
							l_asize := l_asize
						else
							l_asize := -l_asize
						end
						l_ap := l_a.item.mp_d
						if l_csize = 0 then
							Result := (gmpn_divisible_p (l_ap, l_asize, l_dp, l_dsize))
							l_return := True
						end
					end
					if not l_return then
						if l_csize >= 0 then
							l_csize := l_csize
						else
							l_csize := -l_csize
						end
						l_cp := l_c.item.mp_d
						l_alow := l_ap[0]
						l_clow := l_cp[0]
						l_dlow := l_dp[0]
						l_dmask := ((((l_dlow).bit_and ((-l_dlow.to_integer_32).to_natural_32)) - {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
						if l_sign >= 0 then
							l_alow := l_alow
						else
							l_alow := (-l_alow.to_integer_32).to_natural_32
						end
						if (((l_alow - l_clow)).bit_and (l_dmask)) /= {NATURAL_32} 0 then
							Result := 0
							l_return := True
						end
					end
					if not (not l_return and then (l_csize = 1)) then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if l_dsize /= 1 then
							l_pos := -1 + 3 -- skip if block
						end
				when 2 then -- if: | cong_1:
						if l_sign < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_clow <= l_dlow then
									l_clow := l_dlow - l_clow
								else
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										l___twos := (builtin_clzl (l_dlow)).to_natural_32
										l_break := True
									end
									l_break := False
									l___twos := l___twos
									l___dnorm := (l_dlow).bit_shift_left (l___twos.to_integer_32)
									if l_clow <= l___dnorm then
										l_tmp___5 := l___dnorm
									else
										l_tmp___5 := {NATURAL_32} 2 * l___dnorm
									end
									l_clow := l_tmp___5 - l_clow
								end
								l_break := True
							end
							l_break := False
						end
						if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_asize >= 22 then
								l_r := (create {P_MOD_1_STATIC}).gmpn_mod_1 (l_ap, l_asize, l_dlow)
								if l_clow < l_dlow then
									Result := (l_r = l_clow).to_integer
									l_return := True
								else
									Result := (l_r = l_clow \\ l_dlow).to_integer
									l_return := True
								end
							end
						end
						if not l_return then
							if ((l_dlow).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_twos := (builtin_ctzl (l_dlow)).to_natural_32
									l_break := True
								end
								l_break := False
								l_dlow := (l_dlow).bit_shift_right (l_twos.to_integer_32)
							end
							l_r := gmpn_modexact_1c_odd (l_ap, l_asize, l_dlow, l_clow)
							if l_r = {NATURAL_32} 0 then
								l_tmp___7 := 1
							elseif l_r = l_dlow then
								l_tmp___7 := 1
							else
								l_tmp___7 := 0
							end
							Result := l_tmp___7
							l_return := True
						end
				when 3 then -- if done
						if not l_return and then (l_dsize = 2) then
							if l_dlow /= {NATURAL_32} 0 then
								l_dsecond := l_dp[1]
								if l_dsecond <= l_dmask then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										l_twos___0 := (builtin_ctzl (l_dlow)).to_natural_32
										l_break := True
									end
									l_break := False
									l_dlow := (((l_dlow).bit_shift_right (l_twos___0.to_integer_32))).bit_or (((l_dsecond).bit_shift_left (({NATURAL_32} 32 - l_twos___0).to_integer_32)))
									l_pos := -1 + 2 -- goto cong_1
								end
							end
						end
				when 4 then
					if not l_return then
						l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						if (builtin_expect (((l_asize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___12 := (l_aaf.new (((l_asize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___12 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_asize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_xp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___12)
						if l_sign >= 0 then
							if l_asize > l_csize then
								(create {P_GMP_STATIC}).gmpn_sub (l_xp, l_ap, l_asize, l_cp, l_csize).do_nothing
							elseif ((create {P_GMP_STATIC}).gmpn_cmp (l_ap, l_cp, l_asize)) >= 0 then
								(create {P_GMP_STATIC}).gmpn_sub (l_xp, l_ap, l_asize, l_cp, l_csize).do_nothing
							else
								(create {P_GMP_STATIC}).gmpn_sub_n (l_xp, l_cp, l_ap, l_asize).do_nothing
							end
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									not (not (l_break) and then (l_asize > 0))
								loop
									l_break := False
									if l_xp[(l_asize - 1)] /= {NATURAL_32} 0 then
										l_break := True
									end
									if not (l_return or l_break) then
										l_asize := l_asize - 1
									end
								end
								l_break := False
								l_break := True
							end
							l_break := False
						else
							l_carry := (create {P_GMP_STATIC}).gmpn_add (l_xp, l_ap, l_asize, l_cp, l_csize)
							l_xp[l_asize] := l_carry
							l_asize := l_asize + (l_carry /= {NATURAL_32} 0).to_integer
						end
						l_result := gmpn_divisible_p (l_xp, l_asize, l_dp, l_dsize)
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
						Result := l_result
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_modexact_1c_odd (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3, a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_modexact_1c_odd (a_arg1.c_pointer, a_arg2, a_arg3, a_arg4)
		end

	c_gmpn_modexact_1c_odd (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: NATURAL_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_modexact_1c_odd($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_hamdist (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_hamdist (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_gmpn_hamdist (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_hamdist($a_arg1, $a_arg2, $a_arg3);"
		end

	millerrabin (a_n, a_nm1, a_x___2, a_y, a_q: CE_POINTER [PD_MPZ_STRUCT]; a_k: NATURAL_32): INTEGER_32
		require
			not a_y.is_void
		local
			l_i: NATURAL_32
			l_return: BOOLEAN
		do
			gmpz_powm (a_y, a_x___2, a_q, a_n)
			if (a_y.item.gmpz_cmp_ui ({NATURAL_32} 1)) = 0 then
				Result := 1
				l_return := True
			elseif (a_y.item.gmpz_cmp (a_nm1)) = 0 then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_i := {NATURAL_32} 1
				from
				until
					not (not (l_return) and then (l_i < a_k))
				loop
					gmpz_powm_ui (a_y, a_y, {NATURAL_32} 2, a_n)
					if (a_y.item.gmpz_cmp (a_nm1)) = 0 then
						Result := 1
						l_return := True
					end
					if not l_return then
						if (a_y.item.gmpz_cmp_ui ({NATURAL_32} 1)) = 0 then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gmpz_powm (a_r, a_b, a_e, a_m: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_e.is_void
			not a_m.is_void
		local
			l_b: CE_POINTER [PD_MPZ_STRUCT]
			l_n: INTEGER_32
			l_nodd: INTEGER_32
			l_ncnt: INTEGER_32
			l_cnt: INTEGER_32
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_ep: CE_POINTER [NATURAL_32]
			l_mp: CE_POINTER [NATURAL_32]
			l_rn: INTEGER_32
			l_bn: INTEGER_32
			l_es: INTEGER_32
			l_en: INTEGER_32
			l_itch: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_new_b: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp: INTEGER_32
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			l_qp: CE_POINTER [NATURAL_32]
			l_tmp___18: CE_POINTER [ANY]
			l_tmp___20: INTEGER_32
			l_new: CE_POINTER [NATURAL_32]
			l_tmp___26: CE_POINTER [ANY]
			l_n_largest_binvert: INTEGER_32
			l_tmp___28: INTEGER_32
			l_itch_binvert: INTEGER_32
			l_tmp___30: INTEGER_32
			l_itch_binvert___0: INTEGER_32
			l_tmp___32: INTEGER_32
			l_tmp___36: CE_POINTER [ANY]
			l_r2: CE_POINTER [NATURAL_32]
			l_xp: CE_POINTER [NATURAL_32]
			l_yp: CE_POINTER [NATURAL_32]
			l_odd_inv_2exp: CE_POINTER [NATURAL_32]
			l_t: NATURAL_32
			l_bcnt: INTEGER_32
			l_new___0: CE_POINTER [NATURAL_32]
			l_tmp___41: CE_POINTER [ANY]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___43: CE_POINTER [NATURAL_32]
			l___dst___0: CE_POINTER [NATURAL_32]
			l___n___0: INTEGER_32
			l_tmp___44: CE_POINTER [NATURAL_32]
			l___dst___1: CE_POINTER [NATURAL_32]
			l___n___1: INTEGER_32
			l_tmp___45: CE_POINTER [NATURAL_32]
			l_new___1: CE_POINTER [NATURAL_32]
			l_tmp___49: CE_POINTER [ANY]
			l___dst___2: CE_POINTER [NATURAL_32]
			l___n___2: INTEGER_32
			l_tmp___51: CE_POINTER [NATURAL_32]
			l_tmp___52: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_new_b.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_b := a_b
					if a_m.item.mp_size >= 0 then
						l_n := (a_m.item.mp_size).to_integer_32
					else
						l_n := (-a_m.item.mp_size).to_integer_32
					end
					if l_n = 0 then
						(create {P_ERRNO_STATIC}).gmp_divide_by_zero
					end
					l_mp := a_m.item.mp_d
					l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
					l_es := (a_e.item.mp_size).to_integer_32
					if (builtin_expect ((l_es <= 0).to_integer, 0)).to_boolean then
						if l_es = 0 then
							if l_n /= 1 then
								l_tmp := 1
							elseif l_mp[0] /= {NATURAL_32} 1 then
								l_tmp := 1
							else
								l_tmp := 0
							end
							a_r.item.mp_size := l_tmp
							a_r.item.mp_d[0] := (1).to_natural_32
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
									(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
								end
								l_break := True
							end
							l_break := False
							l_return := True
						end
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l___x := l_new_b
								l___x.item.mp_alloc := (l_n + 1).to_integer_32
								if (builtin_expect (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
									l_tmp___4 := (l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								else
									l_tmp___4 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								end
								l___x.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___4)
								l_break := True
							end
							l_break := False
							if not (gmpz_invert (l_new_b, l_b, a_m)).to_boolean then
								(create {P_ERRNO_STATIC}).gmp_divide_by_zero
							end
							l_b := create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_new_b)
							l_es := -l_es
						end
					end
					if not l_return then
						l_en := l_es
						if l_b.item.mp_size >= 0 then
							l_bn := (l_b.item.mp_size).to_integer_32
						else
							l_bn := (-l_b.item.mp_size).to_integer_32
						end
						if (builtin_expect ((l_bn = 0).to_integer, 0)).to_boolean then
							a_r.item.mp_size := 0
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
									(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
								end
								l_break := True
							end
							l_break := False
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_ep := a_e.item.mp_d
						if l_en = 1 then
							if l_ep[0] = {NATURAL_32} 1 then
								l_tmp___20 := 1
							else
								l_tmp___20 := 0
							end
						else
							l_tmp___20 := 0
						end
						if (builtin_expect ((l_tmp___20 /= 0).to_integer, 0)).to_boolean then
							if (builtin_expect ((l_n.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___13 := (l_aaf.new ((l_n.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___13 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_n.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_rp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___13)
							l_bp := l_b.item.mp_d
							if l_bn >= l_n then
								if (builtin_expect ((((l_bn - l_n) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
									l_tmp___18 := (l_aaf.new ((((l_bn - l_n) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								else
									l_tmp___18 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (((l_bn - l_n) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								end
								l_qp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___18);
								(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_qp, l_rp, 0, l_bp, l_bn, l_mp, l_n)
								l_rn := l_n
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										not (not (l_break) and then (l_rn > 0))
									loop
										l_break := False
										if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
											l_break := True
										end
										if not (l_return or l_break) then
											l_rn := l_rn - 1
										end
									end
									l_break := False
									l_break := True
								end
								l_break := False
								if l_b.item.mp_size < 0 then
									if l_rn /= 0 then
										(create {P_GMP_STATIC}).gmpn_sub (l_rp, l_mp, l_n, l_rp, l_rn).do_nothing
										l_rn := l_n
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											from
											until
												not (not (l_break) and then (l_rn > 0))
											loop
												l_break := False
												if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
													l_break := True
												end
												if not (l_return or l_break) then
													l_rn := l_rn - 1
												end
											end
											l_break := False
											l_break := True
										end
										l_break := False
									end
								end
							elseif l_b.item.mp_size < 0 then
								(create {P_GMP_STATIC}).gmpn_sub (l_rp, l_mp, l_n, l_bp, l_bn).do_nothing
								l_rn := l_n
								l_rn := l_rn - (l_rp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
							else
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_bp, l_bn)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								l_rn := l_bn
							end
							l_pos := -1 + 9 -- goto ret
						end
				when 2 then
						l_ncnt := (0).to_integer_32
						from
						until
							(l_break)
						loop
							l_break := False
							if not (builtin_expect ((l_mp[0] = {NATURAL_32} 0).to_integer, 0)).to_boolean then
								l_break := True
							end
							if not (l_return or l_break) then
								l_mp := l_mp + 1
								l_ncnt := l_ncnt + 1
							end
						end
						l_break := False
						l_nodd := l_n - l_ncnt
						l_cnt := 0
						if l_mp[0] \\ {NATURAL_32} 2 = {NATURAL_32} 0 then
							if (builtin_expect ((l_nodd.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___26 := (l_aaf.new ((l_nodd.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___26 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_nodd.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_new := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___26)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_cnt := builtin_ctzl (l_mp[0])
								l_break := True
							end
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_rshift (l_new, l_mp, l_nodd, l_cnt.to_natural_32).do_nothing
							l_nodd := l_nodd - (l_new[(l_nodd - 1)] = {NATURAL_32} 0).to_integer
							l_mp := l_new
							l_ncnt := l_ncnt + 1
						end
						if l_ncnt /= 0 then
							if l_ncnt > l_nodd then
								l_tmp___28 := l_ncnt
							else
								l_tmp___28 := l_nodd
							end
							l_n_largest_binvert := l_tmp___28
							l_itch_binvert := ((create {P_BINVERT_STATIC}).gmpn_binvert_itch (l_n_largest_binvert))
							if l_itch_binvert > 2 * l_n then
								l_tmp___30 := l_itch_binvert
							else
								l_tmp___30 := 2 * l_n
							end
							l_itch := 3 * l_n + l_tmp___30
						else
							l_itch_binvert___0 := ((create {P_BINVERT_STATIC}).gmpn_binvert_itch (l_nodd))
							if l_itch_binvert___0 > 2 * l_n then
								l_tmp___32 := l_itch_binvert___0
							else
								l_tmp___32 := 2 * l_n
							end
							l_itch := l_n + l_tmp___32
						end
						if (builtin_expect ((l_itch.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___36 := (l_aaf.new ((l_itch.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___36 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_itch.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___36)
						l_rp := l_tp
						l_tp := l_tp + l_n
						l_bp := l_b.item.mp_d
						gmpn_powm (l_rp, l_bp, l_bn, l_ep, l_en, l_mp, l_nodd, l_tp)
						l_rn := l_n
						if l_ncnt = 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if l_bn < l_ncnt then
							if (builtin_expect ((l_ncnt.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___41 := (l_aaf.new ((l_ncnt.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___41 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_ncnt.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_new___0 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___41)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_new___0, l_bp, l_bn)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_ncnt - l_bn /= 0 then
									l___dst := l_new___0 + l_bn
									l___n := l_ncnt - l_bn
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp___43 := l___dst
										l___dst := l___dst + 1
										l_tmp___43.item := (0).to_natural_32
										l___n := l___n - 1
										if not l___n.to_boolean then
											l_break := True
										end
									end
									l_break := False
								end
								l_break := True
							end
							l_break := False
							l_bp := l_new___0
						end
						l_r2 := l_tp
						if l_bp[0] \\ {NATURAL_32} 2 /= {NATURAL_32} 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_en > 1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_ncnt /= 0 then
									l___dst___0 := l_r2
									l___n___0 := l_ncnt
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp___44 := l___dst___0
										l___dst___0 := l___dst___0 + 1
										l_tmp___44.item := (0).to_natural_32
										l___n___0 := l___n___0 - 1
										if not l___n___0.to_boolean then
											l_break := True
										end
									end
									l_break := False
								end
								l_break := True
							end
							l_break := False
							l_pos := -1 + 7 -- goto zero
						end
				when 5 then
						l_t := ((l_ncnt - (l_cnt /= 0).to_integer) * 32 + l_cnt.to_integer_32).to_natural_32
						l_bcnt := (((4_627).bit_shift_right (((((l_bp[0]).bit_and ({NATURAL_32} 7))).bit_shift_left (1)).to_integer_32))).bit_and (3)
						if l_ep[0] * l_bcnt.to_natural_32 >= l_t then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_ncnt /= 0 then
									l___dst___1 := l_r2
									l___n___1 := l_ncnt
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp___45 := l___dst___1
										l___dst___1 := l___dst___1 + 1
										l_tmp___45.item := (0).to_natural_32
										l___n___1 := l___n___1 - 1
										if not l___n___1.to_boolean then
											l_break := True
										end
									end
									l_break := False
								end
								l_break := True
							end
							l_break := False
							l_pos := -1 + 7 -- goto zero
						end
				when 6 then
						gmpn_powlo (l_r2, l_bp, l_ep, l_en, l_ncnt, l_tp + l_ncnt)
				when 7 then -- zero:
						if l_nodd < l_ncnt then
							if (builtin_expect ((l_ncnt.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___49 := (l_aaf.new ((l_ncnt.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___49 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_ncnt.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_new___1 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___49)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_new___1, l_mp, l_nodd)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_ncnt - l_nodd /= 0 then
									l___dst___2 := l_new___1 + l_nodd
									l___n___2 := l_ncnt - l_nodd
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp___51 := l___dst___2
										l___dst___2 := l___dst___2 + 1
										l_tmp___51.item := (0).to_natural_32
										l___n___2 := l___n___2 - 1
										if not l___n___2.to_boolean then
											l_break := True
										end
									end
									l_break := False
								end
								l_break := True
							end
							l_break := False
							l_mp := l_new___1
						end
						l_odd_inv_2exp := l_tp + l_n;
						(create {P_BINVERT_STATIC}).gmpn_binvert (l_odd_inv_2exp, l_mp, l_ncnt, l_tp + 2 * l_n)
						if l_nodd > l_ncnt then
							l_tmp___52 := l_ncnt
						else
							l_tmp___52 := l_nodd
						end
						(create {P_GMP_STATIC}).gmpn_sub (l_r2, l_r2, l_ncnt, l_rp, l_tmp___52).do_nothing
						l_xp := l_tp + 2 * l_n;
						(create {P_MULLO_N_STATIC}).gmpn_mullo_n (l_xp, l_odd_inv_2exp, l_r2, l_ncnt)
						if l_cnt /= 0 then
							l_xp[(l_ncnt - 1)] := (l_xp[(l_ncnt - 1)]).bit_and (((({NATURAL_32} 1).bit_shift_left (l_cnt)) - {NATURAL_32} 1))
						end
						l_yp := l_tp
						if l_ncnt > l_nodd then
							(create {P_MUL_STATIC}).gmpn_mul (l_yp, l_xp, l_ncnt, l_mp, l_nodd).do_nothing
						else
							(create {P_MUL_STATIC}).gmpn_mul (l_yp, l_mp, l_nodd, l_xp, l_ncnt).do_nothing
						end
						(create {P_GMP_STATIC}).gmpn_add (l_rp, l_yp, l_n, l_rp, l_nodd).do_nothing
				when 8 then -- if done
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_rn > 0))
							loop
								l_break := False
								if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_rn := l_rn - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if ((l_ep[0]).bit_and ({NATURAL_32} 1)).to_boolean then
							if l_b.item.mp_size < 0 then
								if l_rn /= 0 then
									(create {P_GMP_STATIC}).gmpn_sub (l_rp, a_m.item.mp_d, l_n, l_rp, l_rn).do_nothing
									l_rn := l_n
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											not (not (l_break) and then (l_rn > 0))
										loop
											l_break := False
											if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
												l_break := True
											end
											if not (l_return or l_break) then
												l_rn := l_rn - 1
											end
										end
										l_break := False
										l_break := True
									end
									l_break := False
								end
							end
						end
				when 9 then -- ret:
						if (builtin_expect ((l_rn > (a_r.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							a_r.item.gmpz_realloc (l_rn).do_nothing
						end
						a_r.item.mp_size := l_rn.to_integer_32
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_r.item.mp_d, l_rp, l_rn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_invert (a_inverse, a_x___2, a_n: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		require
			not a_x___2.is_void
			not a_n.is_void
		local
			l_gcd: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp: CE_ARRAY [PD_MPZ_STRUCT]
			l_xsize: INTEGER_32
			l_nsize: INTEGER_32
			l_size: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___0: INTEGER_32
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___4: CE_POINTER [ANY]
			l___x___0: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___9: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_gcd.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_tmp.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_xsize := (a_x___2.item.mp_size).to_integer_32
					l_nsize := (a_n.item.mp_size).to_integer_32
					if l_xsize >= 0 then
						l_xsize := l_xsize
					else
						l_xsize := -l_xsize
					end
					if l_nsize >= 0 then
						l_nsize := l_nsize
					else
						l_nsize := -l_nsize
					end
					if l_xsize > l_nsize then
						l_tmp___0 := l_xsize
					else
						l_tmp___0 := l_nsize
					end
					l_size := l_tmp___0 + 1
					if l_xsize = 0 then
						Result := 0
						l_return := True
					elseif l_nsize = 1 then
						if a_n.item.mp_d[0] = {NATURAL_32} 1 then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___x := l_gcd
							l___x.item.mp_alloc := l_size.to_integer_32
							if (builtin_expect ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___4 := (l_aaf.new ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___4 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l___x.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___4)
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___x___0 := l_tmp
							l___x___0.item.mp_alloc := l_size.to_integer_32
							if (builtin_expect ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___9 := (l_aaf.new ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___9 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l___x___0.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___9)
							l_break := True
						end
						l_break := False
						l_gcd.item.gmpz_gcdext (l_tmp, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (default_pointer), a_x___2, a_n)
						if l_gcd[0].mp_size = 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if l_gcd[0].mp_d[0] = {NATURAL_32} 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
						Result := 0
						l_return := True
				when 6 then -- if done | if done
					if not l_return then
						if l_tmp[0].mp_size < 0 then
							if a_n.item.mp_size < 0 then
								a_inverse.item.gmpz_sub (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp), a_n)
							else
								a_inverse.item.gmpz_add (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp), a_n)
							end
						else
							a_inverse.item.gmpz_set (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp))
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
						Result := 1
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_powm_ui (a_r, a_b: CE_POINTER [PD_MPZ_STRUCT]; a_el: NATURAL_32; a_m: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_m.is_void
		local
			l_xp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_mp: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_xn: INTEGER_32
			l_tn: INTEGER_32
			l_mn: INTEGER_32
			l_bn: INTEGER_32
			l_m_zero_cnt: INTEGER_32
			l_c: INTEGER_32
			l_e: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_new_mp: CE_POINTER [NATURAL_32]
			l_tmp___2: CE_POINTER [ANY]
			l_new_bp: CE_POINTER [NATURAL_32]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___18: CE_POINTER [ANY]
			l_tmp___23: CE_POINTER [ANY]
			l_cy: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_mp := a_m.item.mp_d
					if a_m.item.mp_size >= 0 then
						l_mn := (a_m.item.mp_size).to_integer_32
					else
						l_mn := (-a_m.item.mp_size).to_integer_32
					end
					if l_mn = 0 then
						(create {P_ERRNO_STATIC}).gmp_divide_by_zero
					end
					if a_el = {NATURAL_32} 0 then
						if l_mn = 1 then
							if l_mp[0] = {NATURAL_32} 1 then
								a_r.item.mp_size := 0
							else
								a_r.item.mp_size := 1
							end
						else
							a_r.item.mp_size := 1
						end
						a_r.item.mp_d[0] := (1).to_natural_32
						l_return := True
					end
					if not l_return then
						l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_m_zero_cnt := builtin_clzl (l_mp[(l_mn - 1)])
							l_break := True
						end
						l_break := False
						l_m_zero_cnt := l_m_zero_cnt
						if l_m_zero_cnt /= 0 then
							if (builtin_expect ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___2 := (l_aaf.new ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___2 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_new_mp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2);
							(create {P_GMP_STATIC}).gmpn_lshift (l_new_mp, l_mp, l_mn, l_m_zero_cnt.to_natural_32).do_nothing
							l_mp := l_new_mp
						end
						if a_b.item.mp_size >= 0 then
							l_bn := (a_b.item.mp_size).to_integer_32
						else
							l_bn := (-a_b.item.mp_size).to_integer_32
						end
						l_bp := a_b.item.mp_d
						if l_bn > l_mn then
							if (builtin_expect ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___7 := (l_aaf.new ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___7 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_new_bp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___7)
							reduce (l_new_bp, l_bp, l_bn, l_mp, l_mn)
							l_bp := l_new_bp
							l_bn := l_mn
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									not (not (l_break) and then (l_bn > 0))
								loop
									l_break := False
									if l_bp[(l_bn - 1)] /= {NATURAL_32} 0 then
										l_break := True
									end
									if not (l_return or l_break) then
										l_bn := l_bn - 1
									end
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
						if l_bn = 0 then
							a_r.item.mp_size := 0
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
									(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
								end
								l_break := True
							end
							l_break := False
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if (builtin_expect (((2 * l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___13 := (l_aaf.new (((2 * l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___13 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((2 * l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___13)
						if (builtin_expect ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___18 := (l_aaf.new ((l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___18 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_mn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_xp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___18)
						if (builtin_expect (((l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___23 := (l_aaf.new (((l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___23 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_mn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_qp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___23)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_xp, l_bp, l_bn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_xn := l_bn
						l_e := a_el
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_c := builtin_clzl (l_e)
							l_break := True
						end
						l_break := False
						l_e := (((l_e).bit_shift_left (l_c))).bit_shift_left (1)
						l_c := 31 - l_c
						if l_c = 0 then
							if l_xn = l_mn then
								if ((create {P_GMP_STATIC}).gmpn_cmp (l_xp, l_mp, l_mn)) >= 0 then
									(create {P_GMP_STATIC}).gmpn_sub_n (l_xp, l_xp, l_mp, l_mn).do_nothing
								end
							end
							l_pos := -1 + 3 -- goto finishup
						end
				when 2 then
						from
						until
							not (not (l_return) and then (l_c /= 0))
						loop
							(create {P_SQR_STATIC}).gmpn_sqr (l_tp, l_xp, l_xn)
							l_tn := 2 * l_xn
							l_tn := l_tn - (l_tp[(l_tn - 1)] = {NATURAL_32} 0).to_integer
							if l_tn < l_mn then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_xp, l_tp, l_tn)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								l_xn := l_tn
							else
								(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_qp, l_xp, 0, l_tp, l_tn, l_mp, l_mn)
								l_xn := l_mn
							end
							if l_e.to_integer_32 < 0 then
								(create {P_MUL_STATIC}).gmpn_mul (l_tp, l_xp, l_xn, l_bp, l_bn).do_nothing
								l_tn := l_xn + l_bn
								l_tn := l_tn - (l_tp[(l_tn - 1)] = {NATURAL_32} 0).to_integer
								if l_tn < l_mn then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											(l_return or l_break)
										loop
											l_break := False;
											(create {P_GMP_STATIC}).gmpn_copyi (l_xp, l_tp, l_tn)
											l_break := True
										end
										l_break := False
										l_break := True
									end
									l_break := False
									l_xn := l_tn
								else
									(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_qp, l_xp, 0, l_tp, l_tn, l_mp, l_mn)
									l_xn := l_mn
								end
							end
							l_e := (l_e).bit_shift_left ((1))
							l_c := l_c - 1
						end
				when 3 then -- finishup:
						if l_m_zero_cnt /= 0 then
							l_cy := (create {P_GMP_STATIC}).gmpn_lshift (l_tp, l_xp, l_xn, l_m_zero_cnt.to_natural_32)
							l_tp[l_xn] := l_cy
							l_xn := l_xn + (l_cy /= {NATURAL_32} 0).to_integer
							if l_xn < l_mn then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_xp, l_tp, l_xn)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
							else
								(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_qp, l_xp, 0, l_tp, l_xn, l_mp, l_mn)
								l_xn := l_mn
							end
							(create {P_GMP_STATIC}).gmpn_rshift (l_xp, l_xp, l_xn, l_m_zero_cnt.to_natural_32).do_nothing
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_xn > 0))
							loop
								l_break := False
								if l_xp[(l_xn - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_xn := l_xn - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if ((a_el).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							if a_b.item.mp_size < 0 then
								if l_xn /= 0 then
									l_mp := a_m.item.mp_d;
									(create {P_GMP_STATIC}).gmpn_sub (l_xp, l_mp, l_mn, l_xp, l_xn).do_nothing
									l_xn := l_mn
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											not (not (l_break) and then (l_xn > 0))
										loop
											l_break := False
											if l_xp[(l_xn - 1)] /= {NATURAL_32} 0 then
												l_break := True
											end
											if not (l_return or l_break) then
												l_xn := l_xn - 1
											end
										end
										l_break := False
										l_break := True
									end
									l_break := False
								end
							end
						end
						if (builtin_expect ((l_xn > (a_r.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							a_r.item.gmpz_realloc (l_xn).do_nothing
						end
						a_r.item.mp_size := l_xn.to_integer_32
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_r.item.mp_d, l_xp, l_xn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	reduce (a_tp, a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_mp: CE_POINTER [NATURAL_32]; a_mn: INTEGER_32)
		local
			l_qp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			if (builtin_expect ((((a_an - a_mn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___2 := (l_aaf.new ((((a_an - a_mn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___2 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (((a_an - a_mn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_qp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2);
			(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_qp, a_tp, 0, a_ap, a_an, a_mp, a_mn)
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
				end
				l_break := True
			end
			l_break := False
		end

	gmp_rrandomb (a_rp: CE_POINTER [NATURAL_32]; a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_nbits: NATURAL_32)
		require
			not a_rstate.is_void
		local
			l_rp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_bi: CE_ARRAY [NATURAL_32]
			l_ranm: CE_ARRAY [NATURAL_32]
			l_cap_chunksize: NATURAL_32
			l_chunksize: NATURAL_32
			l_i: INTEGER_32
			l___rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l___rstate___0: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l___rstate___1: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_rp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_bi.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_ranm.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			l_rp.item := a_rp
			l_i := (((a_nbits + {NATURAL_32} 32) - {NATURAL_32} 1) // {NATURAL_32} 32 - {NATURAL_32} 1).to_integer_32
			l_rp.item[l_i] := ({NATURAL_32} 4_294_967_295).bit_shift_right ((({NATURAL_32} 32 - a_nbits \\ {NATURAL_32} 32) \\ {NATURAL_32} 32).to_integer_32)
			l_i := l_i - 1
			from
			until
				not (l_i >= 0)
			loop
				l_rp.item[l_i] := {NATURAL_32} 4_294_967_295
				l_i := l_i - 1
			end
			from
			until
				(l_break)
			loop
				l_break := False
				l___rstate := a_rstate;
				((create {CE_CLASS_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate, l_ranm, {NATURAL_32} 32])
				l_break := True
			end
			l_break := False
			l_cap_chunksize := (a_nbits // (l_ranm.item \\ {NATURAL_32} 4 + {NATURAL_32} 1)).to_natural_32
			l_cap_chunksize := l_cap_chunksize + (l_cap_chunksize = {NATURAL_32} 0).to_integer.to_natural_32
			l_bi.item := a_nbits
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l___rstate___0 := a_rstate;
					((create {CE_CLASS_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate___0.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate___0, l_ranm, {NATURAL_32} 32])
					l_break := True
				end
				l_break := False
				l_chunksize := ({NATURAL_32} 1 + l_ranm.item \\ l_cap_chunksize.to_natural_32).to_natural_32
				if l_bi.item < l_chunksize.to_natural_32 then
					l_bi.item := (0).to_natural_32
				else
					l_bi.item := l_bi.item - l_chunksize.to_natural_32
				end
				if l_bi.item = {NATURAL_32} 0 then
					l_break := True
				end
				if not (l_return or l_break) then
					l_rp.item[(l_bi.item // {NATURAL_32} 32).to_integer_32] := (l_rp.item[(l_bi.item // {NATURAL_32} 32).to_integer_32]).bit_xor ((({NATURAL_32} 1).bit_shift_left ((l_bi.item \\ {NATURAL_32} 32).to_integer_32)))
					from
					until
						(l_break)
					loop
						l_break := False
						l___rstate___1 := a_rstate;
						((create {CE_CLASS_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate___1.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate___1, l_ranm, {NATURAL_32} 32])
						l_break := True
					end
					l_break := False
					l_chunksize := ({NATURAL_32} 1 + l_ranm.item \\ l_cap_chunksize.to_natural_32).to_natural_32
					if l_bi.item < l_chunksize.to_natural_32 then
						l_bi.item := (0).to_natural_32
					else
						l_bi.item := l_bi.item - l_chunksize.to_natural_32
					end
					from
					until
						(l_break)
					loop
						l_break := False
						asm25 (l___ptr_dummy, l_rp, l_bi)
						l_break := True
					end
					l_break := False
					if l_bi.item = {NATURAL_32} 0 then
						l_break := True
					end
				end
			end
			l_break := False
		end

	gmpn_perfect_square_p (a_up: CE_POINTER [NATURAL_32]; a_usize: INTEGER_32): INTEGER_32
		require
			not a_up.is_void
		local
			l_idx: NATURAL_32
			l_r: NATURAL_32
			l_m: NATURAL_32
			l_idx___0: NATURAL_32
			l_q: NATURAL_32
			l_idx___1: NATURAL_32
			l_q___0: NATURAL_32
			l_idx___2: NATURAL_32
			l_q___1: NATURAL_32
			l_idx___3: NATURAL_32
			l_q___2: NATURAL_32
			l_root_ptr: CE_POINTER [NATURAL_32]
			l_res: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___5: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_idx := (a_up[0] \\ {NATURAL_32} 256).to_natural_32
			if ((((sq_res_0x100.item[(l_idx // {NATURAL_32} 32).to_integer_32]).bit_shift_right ((l_idx \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						l_r := gmpn_mod_34lsub1 (a_up, a_usize)
						l_r := ((l_r).bit_and (((({NATURAL_32} 1).bit_shift_left (24)) - {NATURAL_32} 1))) + ((l_r).bit_shift_right (24))
						l_break := True
					end
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_q := (l_r * {NATURAL_32} 16_404_389).bit_and (((({NATURAL_32} 1).bit_shift_left (25)) - {NATURAL_32} 1))
							l_idx___0 := ((l_q * {NATURAL_32} 45).bit_shift_right (25)).to_natural_32
							l_break := True
						end
						l_break := False
						if l_idx___0.to_integer_32 - 32 < 0 then
							l_m := (440_673_409).to_natural_32
						else
							l_m := (2_336).to_natural_32
						end
						l_idx___0 := l_idx___0 \\ ({NATURAL_32} 32)
						if ((((l_m).bit_shift_right (l_idx___0.to_integer_32))).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_q___0 := (l_r * {NATURAL_32} 15_790_321).bit_and (((({NATURAL_32} 1).bit_shift_left (25)) - {NATURAL_32} 1))
								l_idx___1 := ((l_q___0 * {NATURAL_32} 17).bit_shift_right (25)).to_natural_32
								l_break := True
							end
							l_break := False
							if (((({NATURAL_32} 107_287).bit_shift_right (l_idx___1.to_integer_32))).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
								Result := 0
								l_return := True
							end
							if not l_return then
								l_break := True
							end
						end
					end
					if not l_return then
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_q___1 := (l_r * {NATURAL_32} 15_486_661).bit_and (((({NATURAL_32} 1).bit_shift_left (25)) - {NATURAL_32} 1))
								l_idx___2 := ((l_q___1 * {NATURAL_32} 13).bit_shift_right (25)).to_natural_32
								l_break := True
							end
							l_break := False
							if (((({NATURAL_32} 2_533).bit_shift_right (l_idx___2.to_integer_32))).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
								Result := 0
								l_return := True
							end
							if not l_return then
								l_break := True
							end
						end
					end
					if not l_return then
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_q___2 := (l_r * {NATURAL_32} 14_380_471).bit_and (((({NATURAL_32} 1).bit_shift_left (25)) - {NATURAL_32} 1))
								l_idx___3 := ((l_q___2 * {NATURAL_32} 7).bit_shift_right (25)).to_natural_32
								l_break := True
							end
							l_break := False
							if (((({NATURAL_32} 105).bit_shift_right (l_idx___3.to_integer_32))).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
								Result := 0
								l_return := True
							end
							if not l_return then
								l_break := True
							end
						end
					end
					if not l_return then
						l_break := False
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				if (builtin_expect ((((a_usize + 1) // 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___2 := (l_aaf.new ((((a_usize + 1) // 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___2 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (((a_usize + 1) // 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_root_ptr := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
				if ((create {P_SQRTREM_STATIC}).gmpn_sqrtrem (l_root_ptr, create {CE_NATURAL_32_POINTER}.make_shared (default_pointer), a_up, a_usize)).to_boolean then
					l_tmp___5 := 0
				else
					l_tmp___5 := 1
				end
				l_res := l_tmp___5
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
				Result := l_res
			end
		end

	gmpn_mod_34lsub1 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_mod_34lsub1 (a_arg1.c_pointer, a_arg2)
		end

	c_gmpn_mod_34lsub1 (a_arg1: POINTER; a_arg2: INTEGER_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_mod_34lsub1($a_arg1, $a_arg2);"
		end

	gmpn_perfect_power_p (a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32): INTEGER_32
		local
			l_nn: INTEGER_32
			l_ncn: INTEGER_32
			l_s: INTEGER_32
			l_pn: INTEGER_32
			l_xn: INTEGER_32
			l_nc: CE_POINTER [NATURAL_32]
			l_factor: NATURAL_32
			l_g: CE_ARRAY [NATURAL_32]
			l_exp: NATURAL_32
			l_prev: CE_POINTER [NATURAL_32]
			l_next: CE_POINTER [NATURAL_32]
			l_d: CE_ARRAY [NATURAL_32]
			l_l: NATURAL_32
			l_r: NATURAL_32
			l_c: NATURAL_32
			l_tp: CE_POINTER [NATURAL_32]
			l_cry: NATURAL_32
			l_twos: NATURAL_32
			l_count: NATURAL_32
			l_ans: INTEGER_32
			l_where: CE_ARRAY [INTEGER_32]
			l_neg: INTEGER_32
			l_trial: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___8: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___18: CE_POINTER [ANY]
			l_tmp___23: CE_POINTER [ANY]
			l___n: NATURAL_32
			l___inv: NATURAL_32
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l_tmp___27: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_NATURAL_32_ARRAY} l_g.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_d.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_where.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nn := a_nn
					l_g.item := (0).to_natural_32
					l_twos := (0).to_natural_32
					l_where.item := 0
					l_neg := 0
					l_nc := a_np
					if l_nn < 0 then
						l_neg := 1
						l_nn := -l_nn
					end
					if l_nn = 0 then
						Result := 1
						l_return := True
					elseif l_nn = 1 then
						if a_np[0] = {NATURAL_32} 1 then
							Result := 1
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						l_ncn := l_nn
						l_twos := gmpn_scan1 (a_np, (0).to_natural_32)
						if not (l_twos > {NATURAL_32} 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						if l_twos = {NATURAL_32} 1 then
							l_ans := 0
							l_pos := -1 + 13 -- goto ret
						end
				when 3 then
						l_s := (l_twos // {NATURAL_32} 32).to_integer_32
						if l_s + 1 = l_nn then
							if ((a_np[l_s]).bit_and ((a_np[l_s] - {NATURAL_32} 1))) = {NATURAL_32} 0 then
								if l_neg.to_boolean then
									if ((l_twos).bit_and ((l_twos - {NATURAL_32} 1))) = {NATURAL_32} 0 then
										l_tmp := 0
									else
										l_tmp := 1
									end
								else
									l_tmp := 1
								end
								l_ans := l_tmp
								l_pos := -1 + 13 -- goto ret
							end
						end
				when 4 then
						l_count := l_twos \\ {NATURAL_32} 32
						l_ncn := l_nn - l_s
						if (builtin_expect ((l_ncn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___3 := (l_aaf.new ((l_ncn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___3 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_ncn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_nc := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___3)
						if l_count > {NATURAL_32} 0 then
							(create {P_GMP_STATIC}).gmpn_rshift (l_nc, a_np + l_s, l_ncn, l_count.to_natural_32).do_nothing
							l_ncn := l_ncn - (l_nc[(l_ncn - 1)] = {NATURAL_32} 0).to_integer
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_nc, a_np + l_s, l_ncn)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
						l_g.item := l_twos
				when 5 then -- if done
						if l_ncn <= 20 then
							l_trial := 0
						elseif l_ncn <= 100 then
							l_trial := 1
						else
							l_trial := 2
						end
						l_factor := gmpn_trialdiv (l_nc, l_ncn, (nrtrial.item[l_trial]).to_integer_32, l_where)
						if l_factor = {NATURAL_32} 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
						if l_twos = {NATURAL_32} 0 then
							if (builtin_expect ((l_ncn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___8 := (l_aaf.new ((l_ncn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___8 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_ncn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_nc := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___8)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_nc, a_np, l_ncn)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
						if (builtin_expect (((l_ncn + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___13 := (l_aaf.new (((l_ncn + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___13 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_ncn + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_prev := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___13)
						if (builtin_expect (((l_ncn + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___18 := (l_aaf.new (((l_ncn + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___18 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_ncn + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_next := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___18)
						if (builtin_expect (((4 * l_ncn).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___23 := (l_aaf.new (((4 * l_ncn).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___23 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((4 * l_ncn).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___23)
				when 7 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 11 -- skip loop
						end
				when 8 then -- loop body:
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___n := l_factor
							l___inv := ((create {P_GMP_IMPL_STATIC}).gmp_binvert_limb_table[((l___n // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
							l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
							l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
							l_d.item := (l___inv).bit_and ({NATURAL_32} 4_294_967_295)
							l_break := True
						end
						l_break := False
						l_prev[0] := l_d.item
						l_pn := (1).to_integer_32
						l_exp := (1).to_natural_32
						from
						until
							not (not (l_return or l_break) and then (2 * l_pn - 1 <= l_ncn))
						loop
							l_break := False;
							(create {P_SQR_STATIC}).gmpn_sqr (l_next, l_prev, l_pn)
							l_xn := 2 * l_pn
							l_xn := l_xn - (l_next[(l_xn - 1)] = {NATURAL_32} 0).to_integer
							if (gmpn_divisible_p (l_nc, l_ncn, l_next, l_xn)) = 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_exp := (l_exp).bit_shift_left ((1))
								l_pn := l_xn
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_ptr_swap__tmp := l_next
									l_next := l_prev
									l_prev := l___mp_ptr_swap__tmp
									l_break := True
								end
								l_break := False
							end
						end
						l_break := False
						l_l := l_exp + {NATURAL_32} 1
						l_r := {NATURAL_32} 2 * l_exp - {NATURAL_32} 1
						from
						until
							not (not (l_return) and then (l_l <= l_r))
						loop
							l_continue := False
							l_c := ((l_l + l_r)).bit_shift_right (1)
							if l_c - l_exp > {NATURAL_32} 1 then
								l_xn := (create {P_POW_1_STATIC}).gmpn_pow_1 (l_tp, l_d, (1).to_integer_32, l_c - l_exp, l_next)
								if (l_pn + l_xn) - 1 > l_ncn then
									l_r := l_c - {NATURAL_32} 1
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									(create {P_MUL_STATIC}).gmpn_mul (l_next, l_prev, l_pn, l_tp, l_xn).do_nothing
									l_xn := l_xn + l_pn
									l_xn := l_xn - (l_next[(l_xn - 1)] = {NATURAL_32} 0).to_integer
								end
							else
								l_cry := (create {P_GMP_STATIC}).gmpn_mul_1 (l_next, l_prev, l_pn, l_d.item)
								l_next[l_pn] := l_cry
								l_xn := l_pn + (l_cry /= {NATURAL_32} 0).to_integer
							end
							if not (l_return or l_break or l_continue) then
								if (gmpn_divisible_p (l_nc, l_ncn, l_next, l_xn)) = 0 then
									l_r := l_c - {NATURAL_32} 1
								else
									l_exp := l_c
									l_l := l_c + {NATURAL_32} 1
									from
									until
										(l_break)
									loop
										l_break := False
										l___mp_ptr_swap__tmp___0 := l_next
										l_next := l_prev
										l_prev := l___mp_ptr_swap__tmp___0
										l_break := True
									end
									l_break := False
									l_pn := l_xn
								end
							end
						end
						l_continue := False
						if l_g.item = {NATURAL_32} 0 then
							l_g.item := l_exp
						else
							l_g.item := (create {P_GCD_1_STATIC}).gmpn_gcd_1 (l_g, (1).to_integer_32, l_exp)
						end
						if l_g.item = {NATURAL_32} 1 then
							l_ans := 0
							l_pos := -1 + 13 -- goto ret
						end
				when 9 then
						gmpn_divexact (l_next, l_nc, l_ncn, l_prev, l_pn)
						l_ncn := l_ncn - l_pn
						l_ncn := l_ncn + (l_next[l_ncn] /= {NATURAL_32} 0).to_integer
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_nc, l_next, l_ncn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if l_ncn = 1 then
							if l_nc[0] = {NATURAL_32} 1 then
								if l_neg.to_boolean then
									if ((l_g.item).bit_and ((l_g.item - {NATURAL_32} 1))) = {NATURAL_32} 0 then
										l_tmp___27 := 0
									else
										l_tmp___27 := 1
									end
								else
									l_tmp___27 := 1
								end
								l_ans := l_tmp___27
								l_pos := -1 + 13 -- goto ret
							end
						end
				when 10 then
						l_factor := gmpn_trialdiv (l_nc, l_ncn, (nrtrial.item[l_trial]).to_integer_32, l_where)
						if l_factor = {NATURAL_32} 0 then
							l_break := True
						end
						l_pos := -1 + 7 -- back to loop condition
				when 11 then -- loop done
						l_break := False
				when 12 then -- if done
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_count := (builtin_clzl (l_nc[(l_ncn - 1)])).to_natural_32
							l_break := True
						end
						l_break := False
						l_count := (32 * l_ncn).to_natural_32 - l_count
						l_d.item := (l_count.to_real_64 * logs.item[l_trial] + 1.e-9).truncated_to_integer_64.to_natural_32 + {NATURAL_32} 1
						l_ans := perfpow (l_nc, l_ncn, l_d.item, l_g.item, l_count, l_neg)
				when 13 then -- ret:
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
						Result := l_ans
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_divisible_p (a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32): INTEGER_32
		local
			l_ap: CE_POINTER [NATURAL_32]
			l_an: INTEGER_32
			l_dp: CE_POINTER [NATURAL_32]
			l_dn: INTEGER_32
			l_alow: NATURAL_32
			l_dlow: NATURAL_32
			l_dmask: NATURAL_32
			l_qp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_di: NATURAL_32
			l_twos: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_dsecond: NATURAL_32
			l_tmp___3: NATURAL_32
			l_tmp___5: NATURAL_32
			l_tmp___9: CE_POINTER [ANY]
			l_tmp___14: CE_POINTER [ANY]
			l_tmp___20: CE_POINTER [ANY]
			l___n: NATURAL_32
			l___inv: NATURAL_32
			l___n___0: NATURAL_32
			l___inv___0: NATURAL_32
			l_tmp___29: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ap := a_ap
					l_an := a_an
					l_dp := a_dp
					l_dn := a_dn
					if l_an < l_dn then
						Result := (l_an = 0).to_integer
						l_return := True
					end
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_alow := l_ap.item
							l_dlow := l_dp.item
							if l_dlow /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								if l_alow /= {NATURAL_32} 0 then
									Result := 0
									l_return := True
								end
								if not l_return then
									l_an := l_an - 1
									l_dn := l_dn - 1
									l_ap := l_ap + 1
									l_dp := l_dp + 1
								end
							end
						end
					end
					if not l_return then
						l_break := False
						l_dmask := ((l_dlow).bit_and ((-l_dlow.to_integer_32).to_natural_32)) - {NATURAL_32} 1
						if ((l_alow).bit_and (l_dmask)) /= {NATURAL_32} 0 then
							Result := 0
							l_return := True
						end
					end
					if not l_return and then (l_dn = 1) then
						if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_an >= 22 then
								Result := (((create {P_MOD_1_STATIC}).gmpn_mod_1 (l_ap, l_an, l_dlow)) = {NATURAL_32} 0).to_integer
								l_return := True
							end
						end
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_twos := (builtin_ctzl (l_dlow)).to_natural_32
								l_break := True
							end
							l_break := False
							l_dlow := (l_dlow).bit_shift_right (l_twos.to_integer_32)
							Result := (((create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l_ap, l_an, l_dlow)) = {NATURAL_32} 0).to_integer
							l_return := True
						end
					end
					if not l_return and then (l_dn = 2) then
						l_dsecond := l_dp[1]
						if l_dsecond <= l_dmask then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_twos := (builtin_ctzl (l_dlow)).to_natural_32
								l_break := True
							end
							l_break := False
							l_dlow := (((l_dlow).bit_shift_right (l_twos.to_integer_32))).bit_or (((l_dsecond).bit_shift_left (({NATURAL_32} 32 - l_twos).to_integer_32)))
							if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_an >= 22 then
									l_tmp___5 := ((create {P_MOD_1_STATIC}).gmpn_mod_1 (l_ap, l_an, l_dlow))
								else
									l_tmp___3 := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l_ap, l_an, l_dlow)
									l_tmp___5 := l_tmp___3
								end
							else
								l_tmp___3 := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l_ap, l_an, l_dlow)
								l_tmp___5 := l_tmp___3
							end
							Result := (l_tmp___5 = {NATURAL_32} 0).to_integer
							l_return := True
						end
					end
					if not l_return then
						l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						if (builtin_expect (((l_an + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___9 := (l_aaf.new (((l_an + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___9 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_an + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_rp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___9)
						if (builtin_expect ((((l_an - l_dn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___14 := (l_aaf.new ((((l_an - l_dn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___14 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (((l_an - l_dn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_qp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___14)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_twos := (builtin_ctzl (l_dp[0])).to_natural_32
							l_break := True
						end
						l_break := False
						if l_twos /= {NATURAL_32} 0 then
							if (builtin_expect ((l_dn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___20 := (l_aaf.new ((l_dn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___20 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_dn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___20);
							(create {P_GMP_STATIC}).gmpn_rshift (l_tp, l_dp, l_dn, l_twos).do_nothing
							l_dp := l_tp;
							(create {P_GMP_STATIC}).gmpn_rshift (l_rp, l_ap, l_an, l_twos).do_nothing
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_ap, l_an)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						end
						if l_rp[(l_an - 1)] >= l_dp[(l_dn - 1)] then
							l_rp[l_an] := (0).to_natural_32
							l_an := l_an + 1
						elseif l_an = l_dn then
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
									(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
								end
								l_break := True
							end
							l_break := False
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						if 60 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 16 -- skip if block
						end
				when 2 then -- if:
						if not (l_dn >= 60) then
							l_pos := -1 + 14 -- skip if block
						end
				when 3 then -- if:
						if 60 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if not (l_an - l_dn >= 60) then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if 1_442 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_dn >= 1_442 then
							if (builtin_expect ((((create {P_MU_BDIV_QR_STATIC}).gmpn_mu_bdiv_qr_itch (l_an, l_dn)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___29 := (l_aaf.new ((((create {P_MU_BDIV_QR_STATIC}).gmpn_mu_bdiv_qr_itch (l_an, l_dn)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___29 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (((create {P_MU_BDIV_QR_STATIC}).gmpn_mu_bdiv_qr_itch (l_an, l_dn)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___29);
							(create {P_MU_BDIV_QR_STATIC}).gmpn_mu_bdiv_qr (l_qp, l_rp, l_rp, l_an, l_dp, l_dn, l_tp).do_nothing
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___n___0 := l_dp[0]
							l___inv___0 := ((create {P_GMP_IMPL_STATIC}).gmp_binvert_limb_table[((l___n___0 // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
							l___inv___0 := {NATURAL_32} 2 * l___inv___0 - (l___inv___0 * l___inv___0) * l___n___0
							l___inv___0 := {NATURAL_32} 2 * l___inv___0 - (l___inv___0 * l___inv___0) * l___n___0
							l_di := (l___inv___0).bit_and ({NATURAL_32} 4_294_967_295)
							l_break := True
						end
						l_break := False;
						(create {P_DCPI1_BDIV_QR_STATIC}).gmpn_dcpi1_bdiv_qr (l_qp, l_rp, l_an, l_dp, l_dn, (-l_di.to_integer_32).to_natural_32).do_nothing
						l_rp := l_rp + (l_an - l_dn)
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___1
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___1:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___n := l_dp[0]
							l___inv := ((create {P_GMP_IMPL_STATIC}).gmp_binvert_limb_table[((l___n // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
							l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
							l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
							l_di := (l___inv).bit_and ({NATURAL_32} 4_294_967_295)
							l_break := True
						end
						l_break := False;
						(create {P_SBPI1_BDIV_QR_STATIC}).gmpn_sbpi1_bdiv_qr (l_qp, l_rp, l_an, l_dp, l_dn, (-l_di.to_integer_32).to_natural_32).do_nothing
						l_rp := l_rp + (l_an - l_dn)
				when 13 then -- if done | if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_pos := -1 + 12 -- goto _L___1
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 12 -- goto _L___1
				when 17 then
						l_i := (0).to_integer_32
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_rp[l_i] /= {NATURAL_32} 0 then
								from
								until
									(l_break)
								loop
									l_break := False
									if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
										(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
									end
									l_break := True
								end
								l_break := False
								Result := 0
								l_return := True
							end
							if not l_return then
								l_i := l_i + 1
								if not (l_i < l_dn) then
									l_break := True
								end
							end
						end
				when 18 then -- if done
					if not l_return then
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
						Result := 1
					end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_scan1 (a_up: CE_POINTER [NATURAL_32]; a_starting_bit: NATURAL_32): NATURAL_32
		local
			l_starting_word: INTEGER_32
			l_alimb: NATURAL_32
			l_cnt: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_tmp: CE_POINTER [NATURAL_32]
			l_tmp___0: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			l_starting_word := (a_starting_bit // {NATURAL_32} 32).to_integer_32
			l_p := a_up + l_starting_word
			l_tmp := l_p
			l_p := l_p + 1
			l_alimb := l_tmp.item
			l_alimb := (l_alimb).bit_and ((({NATURAL_32} 4_294_967_295).bit_shift_left ((a_starting_bit \\ {NATURAL_32} 32).to_integer_32)))
			from
			until
				l_alimb /= {NATURAL_32} 0
			loop
				l_tmp___0 := l_p
				l_p := l_p + 1
				l_alimb := l_tmp___0.item
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_cnt := builtin_ctzl (l_alimb)
				l_break := True
			end
			l_break := False
			Result := (((l_p.distance (a_up)) - 1) * 32 + l_cnt).to_natural_32
		end

	perfpow (a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_ub, a_g, a_f: NATURAL_32; a_neg: INTEGER_32): INTEGER_32
		local
			l_ub: NATURAL_32
			l_yp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_k: NATURAL_32
			l_rp1: CE_POINTER [NATURAL_32]
			l_ans: INTEGER_32
			l_b: NATURAL_32
			l_ps: CE_ARRAY [PD_GMP_PRIMESIEVE_T]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___12: CE_POINTER [ANY]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___14: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [PD_GMP_PRIMESIEVE_T]} l_ps.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ub := a_ub
					l_k := (0).to_natural_32
					l_ans := 0
					l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
					gmp_init_primesieve (l_ps)
					l_b := ((a_f + {NATURAL_32} 3)).bit_shift_right (1)
					if (builtin_expect ((a_nn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___2 := (l_aaf.new ((a_nn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___2 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (a_nn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_yp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
					if (builtin_expect ((a_nn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___7 := (l_aaf.new ((a_nn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___7 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (a_nn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_rp1 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___7)
					if (builtin_expect (((5 * a_nn).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___12 := (l_aaf.new (((5 * a_nn).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___12 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((5 * a_nn).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___12)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if a_nn /= 0 then
							l___dst := l_rp1
							l___n := a_nn
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___14 := l___dst
								l___dst := l___dst + 1
								l_tmp___14.item := (0).to_natural_32
								l___n := l___n - 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False;
					(create {P_BINVERT_STATIC}).gmpn_binvert (l_yp, a_np, ({NATURAL_32} 1 + (l_b - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32, l_tp)
					if (l_b \\ {NATURAL_32} 32).to_boolean then
						l_yp[((l_b - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32] := (l_yp[((l_b - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_and (((({NATURAL_32} 1).bit_shift_left ((l_b \\ {NATURAL_32} 32).to_integer_32)) - {NATURAL_32} 1))
					end
					if a_neg.to_boolean then
						l_ps.item.gmp_nextprime.do_nothing
					end
					if not (a_g > {NATURAL_32} 0) then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if l_ub < a_g + {NATURAL_32} 1 then
							l_ub := l_ub
						else
							l_ub := a_g + {NATURAL_32} 1
						end
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_k := l_ps.item.gmp_nextprime
						if not (l_k < l_ub) then
							l_break := True
						end
						if not (l_return or l_break) and then (a_g \\ l_k = {NATURAL_32} 0) then
							if (is_kth_power (l_rp1, a_np, l_k, l_yp, a_nn, a_f, l_tp)) /= 0 then
								l_ans := 1
								l_pos := -1 + 11 -- goto ret
							end
						end
				when 4 then
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						l_break := False
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else: | loop condition:
						if (l_break) then
							l_pos := -1 + 10 -- skip loop
						end
				when 8 then -- loop body:
						l_break := False
						l_k := l_ps.item.gmp_nextprime
						if not (l_k < l_ub) then
							l_break := True
						end
						if not (l_return or l_break) then
							if (is_kth_power (l_rp1, a_np, l_k, l_yp, a_nn, a_f, l_tp)) /= 0 then
								l_ans := 1
								l_pos := -1 + 11 -- goto ret
							end
						end
				when 9 then
						l_pos := -1 + 7 -- back to loop condition
				when 10 then -- loop done
						l_break := False
				when 11 then -- ret:
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
							(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						end
						l_break := True
					end
					l_break := False
					Result := l_ans
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmp_init_primesieve (a_ps: CE_POINTER [PD_GMP_PRIMESIEVE_T])
		require
			not a_ps.is_void
		do
			a_ps.item.s0 := {NATURAL_32} 0
			a_ps.item.sqrt_s0 := {NATURAL_32} 0
			a_ps.item.d := {NATURAL_32} 512
			a_ps.item.s[512] := (0).to_natural_8
		end

	is_kth_power (a_rp, a_np: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_yp: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_f: NATURAL_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		require
			not a_rp.is_void
		local
			l_x___2: NATURAL_32
			l_c: NATURAL_32
			l_b: NATURAL_32
			l_i: INTEGER_32
			l_rn: INTEGER_32
			l_xn: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			if a_k = {NATURAL_32} 2 then
				l_b := ((a_f + {NATURAL_32} 1)).bit_shift_right (1)
				l_rn := ({NATURAL_32} 1 + l_b // {NATURAL_32} 32).to_integer_32
				if (binv_sqroot (a_rp, a_yp, l_rn, l_b, a_tp)) /= 0 then
					l_xn := l_rn
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_xn > 0))
						loop
							l_break := False
							if a_rp[(l_xn - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_break) then
								l_xn := l_xn - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if (pow_equals (a_np, a_nn, a_rp, l_xn, a_k, a_f, a_tp)) /= 0 then
						Result := 1
						l_return := True
					end
					if not l_return then
						l_c := (0).to_natural_32
						l_i := (0).to_integer_32
						from
						until
							not (l_i < l_rn)
						loop
							l_x___2 := a_rp[l_i]
							a_rp[l_i] := (-l_x___2.to_integer_32).to_natural_32 - l_c
							l_c := (l_c).bit_or ((l_x___2 /= {NATURAL_32} 0).to_integer.to_natural_32)
							l_i := l_i + 1
						end
						a_rp[(l_rn - 1)] := (a_rp[(l_rn - 1)]).bit_and (((({NATURAL_32} 1).bit_shift_left ((l_b \\ {NATURAL_32} 32).to_integer_32)) - {NATURAL_32} 1))
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_rn > 0))
							loop
								l_break := False
								if a_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_rn := l_rn - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if (pow_equals (a_np, a_nn, a_rp, l_rn, a_k, a_f, a_tp)) /= 0 then
							Result := 1
							l_return := True
						end
					end
				end
			else
				l_b := {NATURAL_32} 1 + (a_f - {NATURAL_32} 1) // a_k
				l_rn := ({NATURAL_32} 1 + (l_b - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
				binv_root (a_rp, a_yp, a_k, l_rn, l_b, a_tp)
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						not (not (l_break) and then (l_rn > 0))
					loop
						l_break := False
						if a_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_rn := l_rn - 1
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				if (pow_equals (a_np, a_nn, a_rp, l_rn, a_k, a_f, a_tp)) /= 0 then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if l_rn /= 0 then
						l___dst := a_rp
						l___n := l_rn
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___3 := l___dst
							l___dst := l___dst + 1
							l_tmp___3.item := (0).to_natural_32
							l___n := l___n - 1
							if not l___n.to_boolean then
								l_break := True
							end
						end
						l_break := False
					end
					l_break := True
				end
				l_break := False
				Result := 0
			end
		end

	pow_equals (a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_xp: CE_POINTER [NATURAL_32]; a_xn: INTEGER_32; a_k, a_f: NATURAL_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_k: CE_ARRAY [NATURAL_32]
			l_tp2: CE_POINTER [NATURAL_32]
			l_y: CE_ARRAY [NATURAL_32]
			l_z: NATURAL_32
			l_count: NATURAL_32
			l_i: INTEGER_32
			l_bn: INTEGER_32
			l_ans: INTEGER_32
			l_h: CE_ARRAY [NATURAL_32]
			l_l: CE_ARRAY [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_size: NATURAL_32
			l_tmp___4: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_NATURAL_32_ARRAY} l_k.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_y.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_h.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_l.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_k.item := a_k
			if a_xn = 1 then
				if a_xp[0] = {NATURAL_32} 1 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_z := (1 + ((a_nn).bit_shift_right (1))).to_natural_32
				l_bn := (1).to_integer_32
				from
				until
					not (not (l_return) and then (l_bn.to_natural_32 < l_z))
				loop
					gmpn_powlo (a_tp, a_xp, l_k, (1).to_integer_32, l_bn, a_tp + l_bn)
					if ((create {P_GMP_STATIC}).gmpn_cmp (a_tp, a_np, l_bn)) /= 0 then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_bn := (l_bn).bit_shift_left ((1))
					end
				end
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_count := (builtin_clzl (a_xp[(a_xn - 1)])).to_natural_32
					l_break := True
				end
				l_break := False
				l_y.item := ((a_xn * 32).to_natural_32 - l_count) - {NATURAL_32} 1
				asm106 (l_l, l_h, l_k, l_y)
				l_h.item := l_h.item - (l_l.item = {NATURAL_32} 0).to_integer.to_natural_32
				l_l.item := l_l.item - 1
				l_z := a_f - {NATURAL_32} 1
				if l_h.item = {NATURAL_32} 0 then
					if l_l.item <= l_z then
						l_size := l_l.item + l_k.item
						from
						until
							(l_break)
						loop
							l_break := False
							if not (l_size >= l_k.item) then
								(create {P_ASSERT_STATIC}).gmp_assert_fail (ce_string ("perfpow.c"), 83, ce_string ("size >= k"))
							end
							l_break := True
						end
						l_break := False
						l_y.item := {NATURAL_32} 2 + l_size // {NATURAL_32} 32
						if (builtin_expect ((l_y.item * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___4 := (l_aaf.new ((l_y.item * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___4 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_y.item * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp2 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___4)
						l_i := (create {P_POW_1_STATIC}).gmpn_pow_1 (a_tp, a_xp, a_xn, l_k.item, l_tp2)
						if l_i = a_nn then
							if ((create {P_GMP_STATIC}).gmpn_cmp (a_tp, a_np, a_nn)) = 0 then
								l_ans := 1
							else
								l_ans := 0
							end
						else
							l_ans := 0
						end
					else
						l_ans := 0
					end
				else
					l_ans := 0
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
				Result := l_ans
			end
		end

	binv_root (a_rp, a_yp: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_bn: INTEGER_32; a_b: NATURAL_32; a_tp: CE_POINTER [NATURAL_32])
		require
			not a_rp.is_void
		local
			l_bn: INTEGER_32
			l_b: NATURAL_32
			l_tp2: CE_POINTER [NATURAL_32]
			l_tp3: CE_POINTER [NATURAL_32]
			l_di: NATURAL_32
			l_k2: CE_ARRAY [NATURAL_32]
			l_order: CE_ARRAY [NATURAL_32]
			l_i: INTEGER_32
			l_d: INTEGER_32
			l___n: NATURAL_32
			l___inv: NATURAL_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_k2.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_order.make (<<64>>)

			l_bn := a_bn
			l_b := a_b
			l_tp2 := a_tp + l_bn
			l_tp3 := a_tp + 2 * l_bn
			l_k2.item := a_k + {NATURAL_32} 1
			l_d := 0
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l___n := a_k
				l___inv := ((create {P_GMP_IMPL_STATIC}).gmp_binvert_limb_table[((l___n // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
				l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
				l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
				l_di := (l___inv).bit_and ({NATURAL_32} 4_294_967_295)
				l_break := True
			end
			l_break := False
			a_rp[0] := (1).to_natural_32
			from
			until
				l_b = {NATURAL_32} 1
			loop
				l_tmp := l_d
				l_d := l_d + 1
				l_order[l_tmp] := l_b
				l_b := ((l_b + {NATURAL_32} 1)).bit_shift_right (1)
			end
			l_i := l_d - 1
			from
			until
				not (l_i >= 0)
			loop
				l_b := l_order[l_i]
				l_bn := ({NATURAL_32} 1 + (l_b - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32;
				(create {P_GMP_STATIC}).gmpn_mul_1 (a_tp, a_rp, l_bn, l_k2.item).do_nothing
				gmpn_powlo (l_tp2, a_rp, l_k2, (1).to_integer_32, l_bn, l_tp3);
				(create {P_MULLO_N_STATIC}).gmpn_mullo_n (a_rp, a_yp, l_tp2, l_bn);
				(create {P_GMP_STATIC}).gmpn_sub_n (l_tp2, a_tp, a_rp, l_bn).do_nothing;
				(create {P_BDIV_Q_1_STATIC}).gmpn_pi1_bdiv_q_1 (a_rp, l_tp2, l_bn, a_k, l_di, 0).do_nothing
				if l_b \\ {NATURAL_32} 32 /= {NATURAL_32} 0 then
					a_rp[((l_b - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32] := (a_rp[((l_b - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_and (((({NATURAL_32} 1).bit_shift_left ((l_b \\ {NATURAL_32} 32).to_integer_32)) - {NATURAL_32} 1))
				end
				l_i := l_i - 1
			end
		end

	binv_sqroot (a_rp, a_yp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_b: NATURAL_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		require
			not a_rp.is_void
			not a_yp.is_void
		local
			l_bn: INTEGER_32
			l_b: NATURAL_32
			l_k: CE_ARRAY [NATURAL_32]
			l_tp2: CE_POINTER [NATURAL_32]
			l_tp3: CE_POINTER [NATURAL_32]
			l_order: CE_ARRAY [NATURAL_32]
			l_i: INTEGER_32
			l_d: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_k.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_order.make (<<64>>)

			l_bn := a_bn
			l_b := a_b
			l_k.item := (3).to_natural_32
			l_tp2 := a_tp + l_bn
			l_tp3 := a_tp + ((l_bn).bit_shift_left (1))
			l_d := 0
			a_rp[0] := (1).to_natural_32
			if l_b = {NATURAL_32} 1 then
				if ((a_yp[0]).bit_and ({NATURAL_32} 3)) /= {NATURAL_32} 1 then
					Result := 0
					l_return := True
				end
			else
				if ((a_yp[0]).bit_and ({NATURAL_32} 7)) /= {NATURAL_32} 1 then
					Result := 0
					l_return := True
				end
				if not l_return then
					from
					until
						l_b = {NATURAL_32} 2
					loop
						l_tmp := l_d
						l_d := l_d + 1
						l_order[l_tmp] := l_b
						l_b := ((l_b + {NATURAL_32} 2)).bit_shift_right (1)
					end
					l_i := l_d - 1
					from
					until
						not (l_i >= 0)
					loop
						l_b := l_order[l_i]
						l_bn := ({NATURAL_32} 1 + l_b // {NATURAL_32} 32).to_integer_32;
						(create {P_GMP_STATIC}).gmpn_mul_1 (a_tp, a_rp, l_bn, l_k.item).do_nothing
						gmpn_powlo (l_tp2, a_rp, l_k, (1).to_integer_32, l_bn, l_tp3);
						(create {P_MULLO_N_STATIC}).gmpn_mullo_n (a_rp, a_yp, l_tp2, l_bn);
						(create {P_GMP_STATIC}).gmpn_sub_n (l_tp2, a_tp, a_rp, l_bn).do_nothing;
						(create {P_GMP_STATIC}).gmpn_rshift (a_rp, l_tp2, l_bn, {NATURAL_32} 1).do_nothing
						a_rp[(l_b // {NATURAL_32} 32).to_integer_32] := (a_rp[(l_b // {NATURAL_32} 32).to_integer_32]).bit_and (((({NATURAL_32} 1).bit_shift_left ((l_b \\ {NATURAL_32} 32).to_integer_32)) - {NATURAL_32} 1))
						l_i := l_i - 1
					end
				end
			end
			if not l_return then
				Result := 1
			end
		end

	gmpn_powlo (a_rp, a_bp, a_ep: CE_POINTER [NATURAL_32]; a_en, a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		require
			not a_ep.is_void
		local
			l_cnt: INTEGER_32
			l_ebi: NATURAL_32
			l_windowsize: INTEGER_32
			l_this_windowsize: INTEGER_32
			l_expbits: NATURAL_32
			l_pp: CE_POINTER [NATURAL_32]
			l_this_pp: CE_POINTER [NATURAL_32]
			l_last_pp: CE_POINTER [NATURAL_32]
			l_b2p: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_cnt := builtin_clzl (a_ep[(a_en - 1)])
						l_break := True
					end
					l_break := False
					l_ebi := a_en.to_natural_32 * {NATURAL_32} 32 - l_cnt.to_natural_32
					l_windowsize := win_size___0 (l_ebi)
					if (builtin_expect (((((a_n).bit_shift_left ((l_windowsize - 1))) + a_n).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___2 := (l_aaf.new (((((a_n).bit_shift_left ((l_windowsize - 1))) + a_n).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___2 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((((a_n).bit_shift_left ((l_windowsize - 1))) + a_n).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_pp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
					l_this_pp := l_pp
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_this_pp, a_bp, a_n)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_b2p := a_tp + 2 * a_n;
					(create {P_SQR_STATIC}).gmpn_sqr (a_tp, a_bp, a_n)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_b2p, a_tp, a_n)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_i := (((1).bit_shift_left ((l_windowsize - 1))) - 1).to_integer_32
					from
					until
						not (l_i > 0)
					loop
						l_last_pp := l_this_pp
						l_this_pp := l_this_pp + a_n;
						(create {P_MULLO_N_STATIC}).gmpn_mullo_n (l_this_pp, l_last_pp, l_b2p, a_n)
						l_i := l_i - 1
					end
					l_expbits := getbits (a_ep, l_ebi, l_windowsize)
					if l_ebi < l_windowsize.to_natural_32 then
						l_ebi := (0).to_natural_32
					else
						l_ebi := l_ebi - l_windowsize.to_natural_32
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_cnt := builtin_ctzl (l_expbits)
						l_break := True
					end
					l_break := False
					l_ebi := l_ebi + l_cnt.to_natural_32
					l_expbits := (l_expbits).bit_shift_right (l_cnt)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (a_rp, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				when 1 then -- loop condition:
					if not (not (l_return) and then (l_ebi /= {NATURAL_32} 0)) then
						l_pos := -1 + 6 -- skip loop
					end
				when 2 then -- loop body: | loop condition:
						if not (not (l_return) and then (((((a_ep[((l_ebi - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_shift_right (((l_ebi - {NATURAL_32} 1) \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0)) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:;
						(create {P_SQR_STATIC}).gmpn_sqr (a_tp, a_rp, a_n)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_rp, a_tp, a_n)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_ebi := l_ebi - 1
						if l_ebi = {NATURAL_32} 0 then
							l_pos := -1 + 6 -- goto done
						end
				when 4 then
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						l_expbits := getbits (a_ep, l_ebi, l_windowsize)
						l_this_windowsize := l_windowsize
						if l_ebi < l_windowsize.to_natural_32 then
							l_this_windowsize := (l_this_windowsize.to_natural_32 - (l_windowsize.to_natural_32 - l_ebi)).to_integer_32
							l_ebi := (0).to_natural_32
						else
							l_ebi := l_ebi - l_windowsize.to_natural_32
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_cnt := builtin_ctzl (l_expbits)
							l_break := True
						end
						l_break := False
						l_this_windowsize := l_this_windowsize - l_cnt
						l_ebi := l_ebi + l_cnt.to_natural_32
						l_expbits := (l_expbits).bit_shift_right (l_cnt)
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_SQR_STATIC}).gmpn_sqr (a_tp, a_rp, a_n)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (a_rp, a_tp, a_n)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							l_this_windowsize := l_this_windowsize - 1
							if l_this_windowsize = 0 then
								l_break := True
							end
						end
						l_break := False;
						(create {P_MULLO_N_STATIC}).gmpn_mullo_n (a_tp, a_rp, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_rp, a_tp, a_n)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_pos := -1 + 1 -- back to loop condition
				when 6 then -- done:
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
							(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						end
						l_break := True
					end
					l_break := False
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_gcd (a_gp, a_up: CE_POINTER [NATURAL_32]; a_usize: INTEGER_32; a_vp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_talloc: INTEGER_32
			l_scratch: INTEGER_32
			l_matrix_scratch: INTEGER_32
			l_gn: CE_ARRAY [INTEGER_32]
			l_tp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_hgcd_scratch: INTEGER_32
			l_update_scratch: INTEGER_32
			l_p: INTEGER_32
			l_scratch___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___3: CE_POINTER [ANY]
			l_M: CE_ARRAY [PD_HGCD_MATRIX]
			l_p___0: INTEGER_32
			l_matrix_scratch___0: INTEGER_32
			l_nn: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_INTEGER_32_ARRAY} l_gn.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_HGCD_MATRIX]} l_M.make (<<1>>)

			l_n := a_n
			l_talloc := l_n
			l_scratch := (a_usize - l_n) + 1
			if l_scratch > l_talloc then
				l_talloc := l_scratch
			end
			if 393 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_n >= 393 then
					l_p := (2 * l_n) // 3
					l_matrix_scratch := 4 * (((l_n - l_p) + 1) // 2 + 1)
					l_hgcd_scratch := gmpn_hgcd_itch (l_n - l_p)
					l_update_scratch := (l_p + l_n) - 1
					if l_hgcd_scratch > l_update_scratch then
						l_tmp := l_hgcd_scratch
					else
						l_tmp := l_update_scratch
					end
					l_scratch___0 := l_matrix_scratch + l_tmp
					if l_scratch___0 > l_talloc then
						l_talloc := l_scratch___0
					end
				end
			end
			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			if (builtin_expect ((l_talloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___3 := (l_aaf.new ((l_talloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___3 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_talloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___3)
			if a_usize > l_n then
				(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_tp, a_up, (0).to_integer_32, a_up, a_usize, a_vp, l_n)
				if ((create {P_GMP_IMPL_STATIC}).mpn_zero_p (a_up, l_n)).to_boolean then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (a_gp, a_vp, l_n)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
							(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						end
						l_break := True
					end
					l_break := False
					Result := l_n
					l_return := True
				end
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if 393 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if not (l_n >= 393) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_return or l_break) then
						l_p___0 := (2 * l_n) // 3
						l_matrix_scratch___0 := 4 * (((l_n - l_p___0) + 1) // 2 + 1)
						gmpn_hgcd_matrix_init (l_M, l_n - l_p___0, l_tp)
						l_nn := gmpn_hgcd (a_up + l_p___0, a_vp + l_p___0, l_n - l_p___0, l_M, l_tp + l_matrix_scratch___0)
						if l_nn > 0 then
							l_n := gmpn_hgcd_matrix_adjust (l_M, l_p___0 + l_nn, a_up, a_vp, l_p___0, l_tp + l_matrix_scratch___0)
						else
							l_n := gmpn_gcd_subdiv_step (a_gp, l_gn, a_up, a_vp, l_n, l_tp)
							if l_n = 0 then
								from
								until
									(l_break)
								loop
									l_break := False
									if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
										(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
									end
									l_break := True
								end
								l_break := False
								Result := (l_gn.item)
								l_return := True
							end
						end
					end
				end
			end
			if not l_return then
				l_break := False
				l_gn.item := gmpn_gcd_lehmer_n (a_gp, a_up, a_vp, l_n, l_tp)
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
				Result := (l_gn.item)
			end
		end

	gmpn_gcdext (a_gp, a_up: CE_POINTER [NATURAL_32]; a_usizep: CE_POINTER [INTEGER_32]; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_talloc: INTEGER_32
			l_scratch: INTEGER_32
			l_matrix_scratch: INTEGER_32
			l_ualloc: INTEGER_32
			l_un: INTEGER_32
			l_u0: CE_POINTER [NATURAL_32]
			l_u1: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_hgcd_scratch: INTEGER_32
			l_update_scratch: INTEGER_32
			l_p1: INTEGER_32
			l_p2: INTEGER_32
			l_min_p: INTEGER_32
			l_tmp: INTEGER_32
			l_max_p: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___5: CE_POINTER [ANY]
			l_gn: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___11: CE_POINTER [NATURAL_32]
			l_M: CE_ARRAY [PD_HGCD_MATRIX]
			l_p: INTEGER_32
			l_nn: INTEGER_32
			l_gn___0: CE_ARRAY [INTEGER_32]
			l_updated_un: CE_ARRAY [INTEGER_32]
			l_M___0: CE_ARRAY [PD_HGCD_MATRIX]
			l_p___0: INTEGER_32
			l_nn___0: INTEGER_32
			l_t0: CE_POINTER [NATURAL_32]
			l_gn___1: CE_ARRAY [INTEGER_32]
			l_updated_un___0: CE_ARRAY [INTEGER_32]
			l_c: INTEGER_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_y: NATURAL_32
			l_gn___2: INTEGER_32
			l_u0n: INTEGER_32
			l_u1n: INTEGER_32
			l_lehmer_un: CE_ARRAY [INTEGER_32]
			l_lehmer_vn: INTEGER_32
			l_gn___3: INTEGER_32
			l_lehmer_up: CE_POINTER [NATURAL_32]
			l_lehmer_vp: CE_POINTER [NATURAL_32]
			l_negate: INTEGER_32
			l_cy: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_HGCD_MATRIX]} l_M.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_gn___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_updated_un.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_HGCD_MATRIX]} l_M___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_gn___1.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_updated_un___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_lehmer_un.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := a_n
					l_ualloc := l_n + 1
					l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
					l_talloc := 4 * l_n + 3
					l_scratch := (a_an - l_n) + 1
					if l_scratch > l_talloc then
						l_talloc := l_scratch
					end
					if 303 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l_n >= 303 then
							l_p1 := l_n // 2
							l_p2 := l_n // 3
							if l_p1 < l_p2 then
								l_tmp := l_p1
							else
								l_tmp := l_p2
							end
							l_min_p := l_tmp
							if l_p1 > l_p2 then
								l_tmp___0 := l_p1
							else
								l_tmp___0 := l_p2
							end
							l_max_p := l_tmp___0
							l_matrix_scratch := 4 * (((l_n - l_min_p) + 1) // 2 + 1)
							l_hgcd_scratch := gmpn_hgcd_itch (l_n - l_min_p)
							l_update_scratch := (l_max_p + l_n) - 1
							if l_hgcd_scratch > l_update_scratch then
								l_tmp___1 := l_hgcd_scratch
							else
								l_tmp___1 := l_update_scratch
							end
							l_scratch := l_matrix_scratch + l_tmp___1
							if l_scratch > l_talloc then
								l_talloc := l_scratch
							end
							l_scratch := (2_124).to_integer_32
							if l_scratch > l_talloc then
								l_talloc := l_scratch
							end
							l_talloc := l_talloc + (2 * (l_n + 1))
						end
					end
					if (builtin_expect ((l_talloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___5 := (l_aaf.new ((l_talloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___5 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_talloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___5)
					if a_an > l_n then
						(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_tp, a_ap, (0).to_integer_32, a_ap, a_an, a_bp, l_n)
						if ((create {P_GMP_IMPL_STATIC}).mpn_zero_p (a_ap, l_n)).to_boolean then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (a_gp, a_bp, l_n)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							a_usizep.item := (0).to_integer_32
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
									(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
								end
								l_break := True
							end
							l_break := False
							Result := l_n
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if 303 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not (l_n >= 303) then
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_gn := (gmpn_gcdext_lehmer_n (a_gp, a_up, a_usizep, a_ap, a_bp, l_n, l_tp))
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
						Result := l_gn
						l_return := True
				when 5 then -- if done
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if 2 * l_ualloc /= 0 then
								l___dst := l_tp
								l___n := 2 * l_ualloc
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___11 := l___dst
									l___dst := l___dst + 1
									l_tmp___11.item := (0).to_natural_32
									l___n := l___n - 1
									if not l___n.to_boolean then
										l_break := True
									end
								end
								l_break := False
							end
							l_break := True
						end
						l_break := False
						l_u0 := l_tp
						l_tp := l_tp + l_ualloc
						l_u1 := l_tp
						l_tp := l_tp + l_ualloc
						l_p := l_n // 2
						gmpn_hgcd_matrix_init (l_M, l_n - l_p, l_tp)
						l_nn := gmpn_hgcd (a_ap + l_p, a_bp + l_p, l_n - l_p, l_M, l_tp + l_matrix_scratch)
						if l_nn > 0 then
							l_n := gmpn_hgcd_matrix_adjust (l_M, l_p + l_nn, a_ap, a_bp, l_p, l_tp + l_matrix_scratch)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_u0, (l_M.item.p[1])[0], l_M.item.n)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_u1, (l_M.item.p[1])[1], l_M.item.n)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							l_un := l_M.item.n
							from
							until
								((l_u0[(l_un - 1)]).bit_or (l_u1[(l_un - 1)])) /= {NATURAL_32} 0
							loop
								l_un := l_un - 1
							end
						else
							l_updated_un.item := (1).to_integer_32
							l_u1[0] := (1).to_natural_32
							l_n := gmpn_gcdext_subdiv_step (a_gp, l_gn___0, a_up, a_usizep, a_ap, a_bp, l_n, l_u0, l_u1, l_updated_un, l_tp, l_tp + l_n)
							if l_n = 0 then
								from
								until
									(l_break)
								loop
									l_break := False
									if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
										(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
									end
									l_break := True
								end
								l_break := False
								Result := (l_gn___0.item)
								l_return := True
							end
							if not l_return then
								l_un := l_updated_un.item
							end
						end
					end
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if 303 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if not (l_n >= 303) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_p___0 := l_n // 3
								gmpn_hgcd_matrix_init (l_M___0, l_n - l_p___0, l_tp)
								l_nn___0 := gmpn_hgcd (a_ap + l_p___0, a_bp + l_p___0, l_n - l_p___0, l_M___0, l_tp + l_matrix_scratch)
								if l_nn___0 > 0 then
									l_t0 := l_tp + l_matrix_scratch
									l_n := gmpn_hgcd_matrix_adjust (l_M___0, l_p___0 + l_nn___0, a_ap, a_bp, l_p___0, l_t0)
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											(l_return or l_break)
										loop
											l_break := False;
											(create {P_GMP_STATIC}).gmpn_copyi (l_t0, l_u0, l_un)
											l_break := True
										end
										l_break := False
										l_break := True
									end
									l_break := False
									l_un := (hgcd_mul_matrix_vector (l_M___0, l_u0, l_t0, l_u1, l_un, l_t0 + l_un)).to_integer_32
								else
									l_updated_un___0.item := l_un
									l_n := gmpn_gcdext_subdiv_step (a_gp, l_gn___1, a_up, a_usizep, a_ap, a_bp, l_n, l_u0, l_u1, l_updated_un___0, l_tp, l_tp + l_n)
									if l_n = 0 then
										from
										until
											(l_break)
										loop
											l_break := False
											if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
												(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
											end
											l_break := True
										end
										l_break := False
										Result := (l_gn___1.item)
										l_return := True
									end
									if not l_return then
										l_un := l_updated_un___0.item
									end
								end
							end
						end
					end
					if not l_return then
						l_break := False
						if (builtin_expect ((((create {P_GMP_STATIC}).gmpn_cmp (a_ap, a_bp, l_n)) = 0).to_integer, 0)).to_boolean then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (a_gp, a_ap, l_n)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_c := 0
								l___gmp_i := l_un
								from
								until
									(l_break)
								loop
									l_break := False
									l___gmp_i := l___gmp_i - 1
									if not (l___gmp_i >= 0) then
										l_break := True
									end
									if not (l_return or l_break) then
										l___gmp_x := l_u0[l___gmp_i]
										l___gmp_y := l_u1[l___gmp_i]
										if l___gmp_x /= l___gmp_y then
											if l___gmp_x > l___gmp_y then
												l_c := 1
											else
												l_c := -1
											end
											l_break := True
										end
									end
								end
								l_break := False
								l_break := True
							end
							l_break := False
							if l_c < 0 then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										not (not (l_break) and then (l_un > 0))
									loop
										l_break := False
										if l_u0[(l_un - 1)] /= {NATURAL_32} 0 then
											l_break := True
										end
										if not (l_return or l_break) then
											l_un := l_un - 1
										end
									end
									l_break := False
									l_break := True
								end
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (a_up, l_u0, l_un)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								a_usizep.item := -l_un
							else
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_u1[(l_un - 1)] /= {NATURAL_32} 0)
									loop
										l_un := l_un - 1
									end
									l_break := True
								end
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (a_up, l_u1, l_un)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								a_usizep.item := l_un
							end
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
									(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
								end
								l_break := True
							end
							l_break := False
							Result := l_n
						elseif ((create {P_GMP_IMPL_STATIC}).mpn_zero_p (l_u0, l_un)).to_boolean then
							l_gn___2 := gmpn_gcdext_lehmer_n (a_gp, a_up, a_usizep, a_ap, a_bp, l_n, l_tp)
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
									(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
								end
								l_break := True
							end
							l_break := False
							Result := l_gn___2
						else
							l_lehmer_up := l_tp
							l_tp := l_tp + l_n
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_tp, a_ap, l_n)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_tp + l_n, a_bp, l_n)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							l_gn___3 := gmpn_gcdext_lehmer_n (a_gp, l_lehmer_up, l_lehmer_un, l_tp, l_tp + l_n, l_n, l_tp + 2 * l_n)
							l_u0n := l_un
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									not (not (l_break) and then (l_u0n > 0))
								loop
									l_break := False
									if l_u0[(l_u0n - 1)] /= {NATURAL_32} 0 then
										l_break := True
									end
									if not (l_return or l_break) then
										l_u0n := l_u0n - 1
									end
								end
								l_break := False
								l_break := True
							end
							l_break := False
							if l_lehmer_un.item = 0 then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (a_up, l_u0, l_u0n)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								a_usizep.item := -l_u0n
								from
								until
									(l_break)
								loop
									l_break := False
									if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
										(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
									end
									l_break := True
								end
								l_break := False
								Result := l_gn___3
								l_return := True
							end
							if not l_return then
								l_lehmer_vp := l_tp
								l_lehmer_vn := compute_v (l_lehmer_vp, a_ap, a_bp, l_n, a_gp, l_gn___3, l_lehmer_up, l_lehmer_un.item, (l_tp + l_n) + 1)
								if l_lehmer_un.item > 0 then
									l_negate := 0
								else
									l_lehmer_un.item := -l_lehmer_un.item
									l_negate := 1
								end
								l_u1n := l_un
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										not (not (l_break) and then (l_u1n > 0))
									loop
										l_break := False
										if l_u1[(l_u1n - 1)] /= {NATURAL_32} 0 then
											l_break := True
										end
										if not (l_return or l_break) then
											l_u1n := l_u1n - 1
										end
									end
									l_break := False
									l_break := True
								end
								l_break := False
								if l_u1n = 0 then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											(l_return or l_break)
										loop
											l_break := False;
											(create {P_GMP_STATIC}).gmpn_copyi (a_up, l_lehmer_vp, l_lehmer_vn)
											l_break := True
										end
										l_break := False
										l_break := True
									end
									l_break := False
									if l_negate.to_boolean then
										a_usizep.item := l_lehmer_vn
									else
										a_usizep.item := -l_lehmer_vn
									end
									from
									until
										(l_break)
									loop
										l_break := False
										if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
											(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
										end
										l_break := True
									end
									l_break := False
									Result := l_gn___3
									l_return := True
								end
							end
							if not l_return then
								if l_lehmer_un.item <= l_u1n then
									(create {P_MUL_STATIC}).gmpn_mul (a_up, l_u1, l_u1n, l_lehmer_up, l_lehmer_un.item).do_nothing
								else
									(create {P_MUL_STATIC}).gmpn_mul (a_up, l_lehmer_up, l_lehmer_un.item, l_u1, l_u1n).do_nothing
								end
								l_un := l_u1n + l_lehmer_un.item
								l_un := l_un - (a_up[(l_un - 1)] = {NATURAL_32} 0).to_integer
								if l_lehmer_vn > 0 then
									if l_lehmer_vn <= l_u0n then
										(create {P_MUL_STATIC}).gmpn_mul (l_u1, l_u0, l_u0n, l_lehmer_vp, l_lehmer_vn).do_nothing
									else
										(create {P_MUL_STATIC}).gmpn_mul (l_u1, l_lehmer_vp, l_lehmer_vn, l_u0, l_u0n).do_nothing
									end
									l_u1n := l_u0n + l_lehmer_vn
									l_u1n := l_u1n - (l_u1[(l_u1n - 1)] = {NATURAL_32} 0).to_integer
									if l_u1n <= l_un then
										l_cy := (create {P_GMP_STATIC}).gmpn_add (a_up, a_up, l_un, l_u1, l_u1n)
									else
										l_cy := (create {P_GMP_STATIC}).gmpn_add (a_up, l_u1, l_u1n, a_up, l_un)
										l_un := l_u1n
									end
									a_up[l_un] := l_cy
									l_un := l_un + (l_cy /= {NATURAL_32} 0).to_integer
								end
								if l_negate.to_boolean then
									a_usizep.item := -l_un
								else
									a_usizep.item := l_un
								end
								from
								until
									(l_break)
								loop
									l_break := False
									if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
										(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
									end
									l_break := True
								end
								l_break := False
								Result := l_gn___3
							end
						end
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_hgcd_itch (a_n: INTEGER_32): INTEGER_32
		local
			l_k: NATURAL_32
			l_count: INTEGER_32
			l_nscaled: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if 60 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if not (a_n >= 60) then
					Result := a_n
					l_return := True
				end
			else
				Result := a_n
				l_return := True
			end
			if not l_return then
				l_nscaled := (a_n - 1) // 59
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_count := builtin_clzl (l_nscaled.to_natural_32)
					l_break := True
				end
				l_break := False
				l_k := (32 - l_count).to_natural_32
				Result := (((20 * ((a_n + 3) // 4)).to_natural_32 + ({NATURAL_32} 22 * l_k).to_natural_32) + {NATURAL_32} 60).to_integer_32
			end
		end

	gmpn_hgcd (a_ap, a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_M: CE_POINTER [PD_HGCD_MATRIX]; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_n2: INTEGER_32
			l_p: INTEGER_32
			l_nn: INTEGER_32
			l_success: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_M1: CE_ARRAY [PD_HGCD_MATRIX]
			l_scratch: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_HGCD_MATRIX]} l_M1.make (<<1>>)

			l_n := a_n
			l_s := l_n // 2 + 1
			l_n2 := (3 * l_n) // 4 + 1
			l_success := 0
			if l_n <= l_s then
				Result := (0).to_integer_32
				l_return := True
			end
			if not l_return then
				if 60 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (l_n >= 60) then
						l_tmp := gmpn_hgcd_lehmer (a_ap, a_bp, l_n, a_M, a_tp)
						Result := l_tmp
						l_return := True
					end
				else
					l_tmp := gmpn_hgcd_lehmer (a_ap, a_bp, l_n, a_M, a_tp)
					Result := l_tmp
					l_return := True
				end
			end
			if not l_return then
				l_p := l_n // 2
				l_nn := gmpn_hgcd (a_ap + l_p, a_bp + l_p, l_n - l_p, a_M, a_tp)
				if l_nn > 0 then
					l_n := gmpn_hgcd_matrix_adjust (a_M, l_p + l_nn, a_ap, a_bp, l_p, a_tp)
					l_success := 1
				end
				from
				until
					not (not (l_return) and then (l_n > l_n2))
				loop
					l_nn := hgcd_step (l_n, a_ap, a_bp, l_s, a_M, a_tp)
					if not l_nn.to_boolean then
						if l_success.to_boolean then
							l_tmp___0 := l_n
						else
							l_tmp___0 := (0).to_integer_32
						end
						Result := l_tmp___0
						l_return := True
					end
					if not l_return then
						l_n := l_nn
						l_success := 1
					end
				end
			end
			if not l_return then
				if l_n > l_s + 2 then
					l_p := (2 * l_s - l_n) + 1
					l_scratch := 4 * (((l_n - l_p) + 1) // 2 + 1)
					gmpn_hgcd_matrix_init (l_M1, l_n - l_p, a_tp)
					l_nn := gmpn_hgcd (a_ap + l_p, a_bp + l_p, l_n - l_p, l_M1, a_tp + l_scratch)
					if l_nn > 0 then
						l_n := gmpn_hgcd_matrix_adjust (l_M1, l_p + l_nn, a_ap, a_bp, l_p, a_tp + l_scratch)
						a_M.item.gmpn_hgcd_matrix_mul (l_M1, a_tp + l_scratch)
						l_success := 1
					end
				end
				from
				until
					(l_return)
				loop
					l_nn := hgcd_step (l_n, a_ap, a_bp, l_s, a_M, a_tp)
					if not l_nn.to_boolean then
						if l_success.to_boolean then
							l_tmp___1 := l_n
						else
							l_tmp___1 := (0).to_integer_32
						end
						Result := l_tmp___1
						l_return := True
					end
					if not l_return then
						l_n := l_nn
						l_success := 1
					end
				end
			end
		end

	gmpn_hgcd_matrix_init (a_M: CE_POINTER [PD_HGCD_MATRIX]; a_n: INTEGER_32; a_p: CE_POINTER [NATURAL_32])
		require
			not a_M.is_void
		local
			l_s: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_tmp___0: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_s := (a_n + 1) // 2 + 1
			a_M.item.alloc := l_s
			a_M.item.n := (1).to_integer_32
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if 4 * l_s /= 0 then
					l___dst := a_p
					l___n := 4 * l_s
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp := l___dst
						l___dst := l___dst + 1
						l_tmp.item := (0).to_natural_32
						l___n := l___n - 1
						if not l___n.to_boolean then
							l_break := True
						end
					end
					l_break := False
				end
				l_break := True
			end
			l_break := False;
			(a_M.item.p[0])[0] := a_p;
			(a_M.item.p[0])[1] := a_p + l_s;
			(a_M.item.p[1])[0] := a_p + 2 * l_s;
			(a_M.item.p[1])[1] := a_p + 3 * l_s
			l_tmp___0 := (1).to_natural_32;
			((a_M.item.p[1])[1])[0] := l_tmp___0;
			((a_M.item.p[0])[0])[0] := l_tmp___0
		end

	gmpn_hgcd_matrix_adjust (a_M: CE_POINTER [PD_HGCD_MATRIX]; a_n: INTEGER_32; a_ap, a_bp: CE_POINTER [NATURAL_32]; a_p: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		require
			not a_M.is_void
			not a_ap.is_void
		local
			l_n: INTEGER_32
			l_t0: CE_POINTER [NATURAL_32]
			l_t1: CE_POINTER [NATURAL_32]
			l_ah: NATURAL_32
			l_bh: NATURAL_32
			l_cy: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_n := a_n
			l_t0 := a_tp
			l_t1 := (a_tp + a_p) + a_M.item.n
			if a_M.item.n >= a_p then
				(create {P_MUL_STATIC}).gmpn_mul (l_t0, (a_M.item.p[1])[1], a_M.item.n, a_ap, a_p).do_nothing;
				(create {P_MUL_STATIC}).gmpn_mul (l_t1, (a_M.item.p[1])[0], a_M.item.n, a_ap, a_p).do_nothing
			else
				(create {P_MUL_STATIC}).gmpn_mul (l_t0, a_ap, a_p, (a_M.item.p[1])[1], a_M.item.n).do_nothing;
				(create {P_MUL_STATIC}).gmpn_mul (l_t1, a_ap, a_p, (a_M.item.p[1])[0], a_M.item.n).do_nothing
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (a_ap, l_t0, a_p)
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			l_ah := (create {P_GMP_STATIC}).gmpn_add (a_ap + a_p, (a_ap + a_p), l_n - a_p, (l_t0 + a_p), a_M.item.n)
			if a_M.item.n >= a_p then
				(create {P_MUL_STATIC}).gmpn_mul (l_t0, (a_M.item.p[0])[1], a_M.item.n, a_bp, a_p).do_nothing
			else
				(create {P_MUL_STATIC}).gmpn_mul (l_t0, a_bp, a_p, (a_M.item.p[0])[1], a_M.item.n).do_nothing
			end
			l_cy := (create {P_GMP_STATIC}).gmpn_sub (a_ap, a_ap, l_n, l_t0, a_p + a_M.item.n)
			l_ah := l_ah - l_cy
			if a_M.item.n >= a_p then
				(create {P_MUL_STATIC}).gmpn_mul (l_t0, (a_M.item.p[0])[0], a_M.item.n, a_bp, a_p).do_nothing
			else
				(create {P_MUL_STATIC}).gmpn_mul (l_t0, a_bp, a_p, (a_M.item.p[0])[0], a_M.item.n).do_nothing
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (a_bp, l_t0, a_p)
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			l_bh := (create {P_GMP_STATIC}).gmpn_add (a_bp + a_p, (a_bp + a_p), l_n - a_p, (l_t0 + a_p), a_M.item.n)
			l_cy := (create {P_GMP_STATIC}).gmpn_sub (a_bp, a_bp, l_n, l_t1, a_p + a_M.item.n)
			l_bh := l_bh - l_cy
			if l_ah > {NATURAL_32} 0 then
				a_ap[l_n] := l_ah
				a_bp[l_n] := l_bh
				l_n := l_n + 1
			elseif l_bh > {NATURAL_32} 0 then
				a_ap[l_n] := l_ah
				a_bp[l_n] := l_bh
				l_n := l_n + 1
			elseif a_ap[(l_n - 1)] = {NATURAL_32} 0 then
				if a_bp[(l_n - 1)] = {NATURAL_32} 0 then
					l_n := l_n - 1
				end
			end
			Result := l_n
		end

	hgcd_mul_matrix_vector (a_M: CE_POINTER [PD_HGCD_MATRIX]; a_rp, a_ap, a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): NATURAL_32
		require
			not a_M.is_void
			not a_rp.is_void
			not a_bp.is_void
		local
			l_n: INTEGER_32
			l_ah: NATURAL_32
			l_bh: NATURAL_32
		do
			l_n := a_n
			if a_M.item.n >= l_n then
				(create {P_MUL_STATIC}).gmpn_mul (a_tp, (a_M.item.p[0])[0], a_M.item.n, a_ap, l_n).do_nothing;
				(create {P_MUL_STATIC}).gmpn_mul (a_rp, (a_M.item.p[1])[0], a_M.item.n, a_bp, l_n).do_nothing
			else
				(create {P_MUL_STATIC}).gmpn_mul (a_tp, a_ap, l_n, (a_M.item.p[0])[0], a_M.item.n).do_nothing;
				(create {P_MUL_STATIC}).gmpn_mul (a_rp, a_bp, l_n, (a_M.item.p[1])[0], a_M.item.n).do_nothing
			end
			l_ah := (create {P_GMP_STATIC}).gmpn_add_n (a_rp, a_rp, a_tp, l_n + a_M.item.n)
			if a_M.item.n >= l_n then
				(create {P_MUL_STATIC}).gmpn_mul (a_tp, (a_M.item.p[1])[1], a_M.item.n, a_bp, l_n).do_nothing;
				(create {P_MUL_STATIC}).gmpn_mul (a_bp, (a_M.item.p[0])[1], a_M.item.n, a_ap, l_n).do_nothing
			else
				(create {P_MUL_STATIC}).gmpn_mul (a_tp, a_bp, l_n, (a_M.item.p[1])[1], a_M.item.n).do_nothing;
				(create {P_MUL_STATIC}).gmpn_mul (a_bp, a_ap, l_n, (a_M.item.p[0])[1], a_M.item.n).do_nothing
			end
			l_bh := (create {P_GMP_STATIC}).gmpn_add_n (a_bp, a_bp, a_tp, l_n + a_M.item.n)
			l_n := l_n + (a_M.item.n)
			if ((l_ah).bit_or (l_bh)) > {NATURAL_32} 0 then
				a_rp[l_n] := l_ah
				a_bp[l_n] := l_bh
				l_n := l_n + 1
			else
				from
				until
					((a_rp[(l_n - 1)]).bit_or (a_bp[(l_n - 1)])) /= {NATURAL_32} 0
				loop
					l_n := l_n - 1
				end
			end
			Result := l_n.to_natural_32
		end

	compute_v (a_vp, a_ap, a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_gp: CE_POINTER [NATURAL_32]; a_gn: INTEGER_32; a_up: CE_POINTER [NATURAL_32]; a_usize: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		require
			not a_tp.is_void
		local
			l_size: INTEGER_32
			l_an: INTEGER_32
			l_bn: INTEGER_32
			l_vn: INTEGER_32
			l_cy: NATURAL_32
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if a_usize >= 0 then
				l_size := a_usize
			else
				l_size := -a_usize
			end
			l_an := a_n
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					not (not (l_break) and then (l_an > 0))
				loop
					l_break := False
					if a_ap[(l_an - 1)] /= {NATURAL_32} 0 then
						l_break := True
					end
					if not (l_break) then
						l_an := l_an - 1
					end
				end
				l_break := False
				l_break := True
			end
			l_break := False
			if l_an >= l_size then
				(create {P_MUL_STATIC}).gmpn_mul (a_tp, a_ap, l_an, a_up, l_size).do_nothing
			else
				(create {P_MUL_STATIC}).gmpn_mul (a_tp, a_up, l_size, a_ap, l_an).do_nothing
			end
			l_size := l_size + l_an
			l_size := l_size - (a_tp[(l_size - 1)] = {NATURAL_32} 0).to_integer
			if a_usize > 0 then
				(create {P_GMP_STATIC}).gmpn_sub (a_tp, a_tp, l_size, a_gp, a_gn).do_nothing
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						not (not (l_break) and then (l_size > 0))
					loop
						l_break := False
						if a_tp[(l_size - 1)] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_size := l_size - 1
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				if l_size = 0 then
					Result := (0).to_integer_32
					l_return := True
				end
			else
				l_cy := ((create {P_GMP_STATIC}).gmpn_add (a_tp, a_tp, l_size, a_gp, a_gn))
				if l_cy.to_boolean then
					l_tmp___0 := l_size
					l_size := l_size + 1
					a_tp[l_tmp___0] := l_cy
				end
			end
			if not l_return then
				l_bn := a_n
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						not (not (l_break) and then (l_bn > 0))
					loop
						l_break := False
						if a_bp[(l_bn - 1)] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_bn := l_bn - 1
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				l_vn := (l_size + 1) - l_bn
				gmpn_divexact (a_vp, a_tp, l_size, a_bp, l_bn)
				l_vn := l_vn - (a_vp[(l_vn - 1)] = {NATURAL_32} 0).to_integer
				Result := l_vn
			end
		end

	gmpn_divexact (a_qp, a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32)
		require
			not a_dp.is_void
		local
			l_np: CE_POINTER [NATURAL_32]
			l_nn: INTEGER_32
			l_dp: CE_POINTER [NATURAL_32]
			l_dn: INTEGER_32
			l_shift: NATURAL_32
			l_qn: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_ss: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___9: CE_POINTER [ANY]
			l_tmp___14: CE_POINTER [ANY]
			l_tmp___22: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_np := a_np
			l_nn := a_nn
			l_dp := a_dp
			l_dn := a_dn
			from
			until
				not (not (l_return) and then (l_dp[0] = {NATURAL_32} 0))
			loop
				l_dp := l_dp + 1
				l_np := l_np + 1
				l_dn := l_dn - 1
				l_nn := l_nn - 1
			end
			if l_dn = 1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_IMPL_STATIC}).gmpn_divexact_1 (a_qp, l_np, l_nn, l_dp[0])
					l_break := True
				end
				l_break := False
				l_return := True
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_qn := (l_nn + 1) - l_dn
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_shift := (builtin_ctzl (l_dp[0])).to_natural_32
					l_break := True
				end
				l_break := False
				if l_shift > {NATURAL_32} 0 then
					if l_dn > l_qn then
						l_tmp___0 := l_qn + 1
					else
						l_tmp___0 := l_dn
					end
					l_ss := l_tmp___0
					if (builtin_expect ((l_ss.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___4 := (l_aaf.new ((l_ss.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___4 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_ss.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___4);
					(create {P_GMP_STATIC}).gmpn_rshift (l_tp, l_dp, l_ss, l_shift).do_nothing
					l_dp := l_tp
					if (builtin_expect (((l_qn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___9 := (l_aaf.new (((l_qn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___9 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_qn + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_wp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___9);
					(create {P_GMP_STATIC}).gmpn_rshift (l_wp, l_np, l_qn + 1, l_shift).do_nothing
				else
					if (builtin_expect ((l_qn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___14 := (l_aaf.new ((l_qn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___14 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_qn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_wp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___14)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_wp, l_np, l_qn)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				end
				if l_dn > l_qn then
					l_dn := l_qn
				end
				if (builtin_expect (((gmpn_bdiv_q_itch (l_qn, l_dn)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___22 := (l_aaf.new (((gmpn_bdiv_q_itch (l_qn, l_dn)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___22 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((gmpn_bdiv_q_itch (l_qn, l_dn)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___22)
				gmpn_bdiv_q (a_qp, l_wp, l_qn, l_dp, l_dn, l_tp)
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpn_gcd_lehmer_n (a_gp, a_ap, a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		require
			not a_ap.is_void
			not a_bp.is_void
		local
			l_ap: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_M: CE_ARRAY [PD_HGCD_MATRIX1]
			l_ah: NATURAL_32
			l_al: NATURAL_32
			l_bh: NATURAL_32
			l_bl: NATURAL_32
			l_mask: NATURAL_32
			l_shift: INTEGER_32
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l_gn: CE_ARRAY [INTEGER_32]
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l_r: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_HGCD_MATRIX1]} l_M.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_gn.make (<<1>>)

			l_ap := a_ap
			l_bp := a_bp
			l_n := a_n
			l_tp := a_tp
			from
			until
				not (not (l_return) and then (l_n > 2))
			loop
				l_mask := (l_ap[(l_n - 1)]).bit_or (l_bp[(l_n - 1)])
				if ((l_mask).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))).to_boolean then
					l_ah := l_ap[(l_n - 1)]
					l_al := l_ap[(l_n - 2)]
					l_bh := l_bp[(l_n - 1)]
					l_bl := l_bp[(l_n - 2)]
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_shift := builtin_clzl (l_mask)
						l_break := True
					end
					l_break := False
					l_ah := (((((l_ap[(l_n - 1)]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_ap[(l_n - 2)]).bit_shift_right ((32 - l_shift))))
					l_al := (((((l_ap[(l_n - 2)]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_ap[(l_n - 3)]).bit_shift_right ((32 - l_shift))))
					l_bh := (((((l_bp[(l_n - 1)]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_bp[(l_n - 2)]).bit_shift_right ((32 - l_shift))))
					l_bl := (((((l_bp[(l_n - 2)]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_bp[(l_n - 3)]).bit_shift_right ((32 - l_shift))))
				end
				if (gmpn_hgcd2 (l_ah, l_al, l_bh, l_bl, l_M)).to_boolean then
					l_n := gmpn_hgcd_mul_matrix1_inverse_vector (l_M, l_tp, l_ap, l_bp, l_n)
					from
					until
						(l_break)
					loop
						l_break := False
						l___mp_ptr_swap__tmp := l_ap
						l_ap := l_tp
						l_tp := l___mp_ptr_swap__tmp
						l_break := True
					end
					l_break := False
				else
					l_n := gmpn_gcd_subdiv_step (a_gp, l_gn, l_ap, l_bp, l_n, l_tp)
					if l_n = 0 then
						Result := (l_gn.item)
						l_return := True
					end
				end
			end
			if not l_return and then (l_n = 1) then
				a_gp.item := (create {P_GCD_1_STATIC}).gmpn_gcd_1 (l_ap, (1).to_integer_32, l_bp[0])
				Result := (1).to_integer_32
				l_return := True
			end
			if not l_return then
				if not ((l_ap[0]).bit_and ({NATURAL_32} 1)).to_boolean then
					from
					until
						(l_break)
					loop
						l_break := False
						l___mp_ptr_swap__tmp___0 := l_ap
						l_ap := l_bp
						l_bp := l___mp_ptr_swap__tmp___0
						l_break := True
					end
					l_break := False
				end
				if l_bp[0] = {NATURAL_32} 0 then
					a_gp.item := (create {P_GCD_1_STATIC}).gmpn_gcd_1 (l_ap, (2).to_integer_32, l_bp[1])
					Result := (1).to_integer_32
					l_return := True
				elseif not ((l_bp[0]).bit_and ({NATURAL_32} 1)).to_boolean then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_r := builtin_ctzl (l_bp[0])
						l_break := True
					end
					l_break := False
					l_bp[0] := (((((l_bp[1]).bit_shift_left ((32 - l_r)))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_bp[0]).bit_shift_right (l_r)))
					l_bp[1] := (l_bp[1]).bit_shift_right (l_r)
				end
			end
			if not l_return then
				Result := (gcd_2 (a_gp, l_ap, l_bp))
			end
		end

	gmpn_gcd_subdiv_step (a_gp: CE_POINTER [NATURAL_32]; a_gn: CE_POINTER [INTEGER_32]; a_ap, a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_ap: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_an: INTEGER_32
			l_bn: INTEGER_32
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp: INTEGER_32
			l_c: INTEGER_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_y: NATURAL_32
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___1: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp___0: INTEGER_32
			l_c___0: INTEGER_32
			l___gmp_i___0: INTEGER_32
			l___gmp_x___0: NATURAL_32
			l___gmp_y___0: NATURAL_32
			l___mp_ptr_swap__tmp___2: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ap := a_ap
					l_bp := a_bp
					l_bn := a_n
					l_an := l_bn
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_an > 0))
						loop
							l_break := False
							if l_ap[(l_an - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_break) then
								l_an := l_an - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_bn > 0))
						loop
							l_break := False
							if l_bp[(l_bn - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_bn := l_bn - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if not ((builtin_expect ((l_an = 0).to_integer, 0)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if: | return_b:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_gp, l_bp, l_bn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						a_gn.item := l_bn
						Result := (0).to_integer_32
						l_return := True
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((builtin_expect ((l_bn = 0).to_integer, 0)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | return_a:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_gp, l_ap, l_an)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						a_gn.item := l_an
						Result := (0).to_integer_32
						l_return := True
				when 5 then -- if done | if done
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 6 then -- if:
						if l_an < l_bn then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_ptr_swap__tmp := l_ap
									l_ap := l_bp
									l_bp := l___mp_ptr_swap__tmp
									l_break := True
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_size_t_swap__tmp := l_an
									l_an := l_bn
									l_bn := l___mp_size_t_swap__tmp
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						elseif l_an = l_bn then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_c := 0
								l___gmp_i := l_an
								from
								until
									(l_break)
								loop
									l_break := False
									l___gmp_i := l___gmp_i - 1
									if not (l___gmp_i >= 0) then
										l_break := True
									end
									if not (l_return or l_break) then
										l___gmp_x := l_ap[l___gmp_i]
										l___gmp_y := l_bp[l___gmp_i]
										if l___gmp_x /= l___gmp_y then
											if l___gmp_x > l___gmp_y then
												l_c := 1
											else
												l_c := -1
											end
											l_break := True
										end
									end
								end
								l_break := False
								l_break := True
							end
							l_break := False
							if (builtin_expect ((l_c = 0).to_integer, 0)).to_boolean then
								l_pos := -1 + 4 -- goto return_a
							elseif l_c < 0 then
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_ptr_swap__tmp___0 := l_ap
									l_ap := l_bp
									l_bp := l___mp_ptr_swap__tmp___0
									l_break := True
								end
								l_break := False
							end
						end
				when 7 then;
						(create {P_GMP_STATIC}).gmpn_sub (l_ap, l_ap, l_an, l_bp, l_bn).do_nothing
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_an > 0))
							loop
								l_break := False
								if l_ap[(l_an - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_an := l_an - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if l_an < l_bn then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_ptr_swap__tmp___1 := l_ap
									l_ap := l_bp
									l_bp := l___mp_ptr_swap__tmp___1
									l_break := True
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_size_t_swap__tmp___0 := l_an
									l_an := l_bn
									l_bn := l___mp_size_t_swap__tmp___0
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
						elseif l_an = l_bn then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_c___0 := 0
								l___gmp_i___0 := l_an
								from
								until
									(l_break)
								loop
									l_break := False
									l___gmp_i___0 := l___gmp_i___0 - 1
									if not (l___gmp_i___0 >= 0) then
										l_break := True
									end
									if not (l_return or l_break) then
										l___gmp_x___0 := l_ap[l___gmp_i___0]
										l___gmp_y___0 := l_bp[l___gmp_i___0]
										if l___gmp_x___0 /= l___gmp_y___0 then
											if l___gmp_x___0 > l___gmp_y___0 then
												l_c___0 := 1
											else
												l_c___0 := -1
											end
											l_break := True
										end
									end
								end
								l_break := False
								l_break := True
							end
							l_break := False
							if (builtin_expect ((l_c___0 = 0).to_integer, 0)).to_boolean then
								l_pos := -1 + 4 -- goto return_a
							elseif l_c___0 < 0 then
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_ptr_swap__tmp___2 := l_ap
									l_ap := l_bp
									l_bp := l___mp_ptr_swap__tmp___2
									l_break := True
								end
								l_break := False
							end
						end
				when 8 then;
						(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (a_tp, l_ap, (0).to_integer_32, l_ap, l_an, l_bp, l_bn)
						if ((create {P_GMP_IMPL_STATIC}).mpn_zero_p (l_ap, l_bn)).to_boolean then
							l_pos := -1 + 1 -- goto return_b
						end
				when 9 then
						Result := l_bn
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gcd_2 (a_gp, a_up, a_vp: CE_POINTER [NATURAL_32]): INTEGER_32
		require
			not a_gp.is_void
			not a_up.is_void
			not a_vp.is_void
		local
			l_u0: NATURAL_32
			l_u1: NATURAL_32
			l_v0: NATURAL_32
			l_v1: NATURAL_32
			l_gn: INTEGER_32
			l_r: NATURAL_32
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_u0 := a_up[0]
			l_u1 := a_up[1]
			l_v0 := a_vp[0]
			l_v1 := a_vp[1]
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if l_u1 /= l_v1 then
					if l_u0 = l_v0 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_return or l_break) then
					if l_u1 > l_v1 then
						l_u1 := l_u1 - (l_v1 + (l_u0 < l_v0).to_integer.to_natural_32)
						l_u0 := ((l_u0 - l_v0)).bit_and ({NATURAL_32} 4_294_967_295)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_r := (builtin_ctzl (l_u0)).to_natural_32
							l_break := True
						end
						l_break := False
						l_u0 := (((((l_u1).bit_shift_left (({NATURAL_32} 32 - l_r).to_integer_32))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_u0).bit_shift_right (l_r.to_integer_32)))
						l_u1 := (l_u1).bit_shift_right (l_r.to_integer_32)
					else
						l_v1 := l_v1 - (l_u1 + (l_v0 < l_u0).to_integer.to_natural_32)
						l_v0 := ((l_v0 - l_u0)).bit_and ({NATURAL_32} 4_294_967_295)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_r := (builtin_ctzl (l_v0)).to_natural_32
							l_break := True
						end
						l_break := False
						l_v0 := (((((l_v1).bit_shift_left (({NATURAL_32} 32 - l_r).to_integer_32))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_v0).bit_shift_right (l_r.to_integer_32)))
						l_v1 := (l_v1).bit_shift_right (l_r.to_integer_32)
					end
				end
			end
			l_break := False
			a_gp[0] := l_u0
			a_gp[1] := l_u1
			l_gn := (1 + (l_u1 /= {NATURAL_32} 0).to_integer).to_integer_32
			if l_u1 = l_v1 then
				if l_u0 = l_v0 then
					Result := l_gn
					l_return := True
				end
			end
			if not l_return then
				if l_u0 = l_v0 then
					if l_u1 > l_v1 then
						l_tmp___1 := l_u1 - l_v1
					else
						l_tmp___1 := l_v1 - l_u1
					end
					l_v0 := l_tmp___1
				else
					if l_u0 > l_v0 then
						l_tmp___2 := l_u0 - l_v0
					else
						l_tmp___2 := l_v0 - l_u0
					end
					l_v0 := l_tmp___2
				end
				a_gp[0] := (create {P_GCD_1_STATIC}).gmpn_gcd_1 (a_gp, l_gn, l_v0)
				Result := (1).to_integer_32
			end
		end

	gmpn_gcdext_lehmer_n (a_gp, a_up: CE_POINTER [NATURAL_32]; a_usize: CE_POINTER [INTEGER_32]; a_ap, a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		require
			not a_ap.is_void
			not a_bp.is_void
			not a_tp.is_void
		local
			l_ap: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_ualloc: INTEGER_32
			l_un: INTEGER_32
			l_u0: CE_POINTER [NATURAL_32]
			l_u1: CE_POINTER [NATURAL_32]
			l_u2: CE_POINTER [NATURAL_32]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_M: CE_ARRAY [PD_HGCD_MATRIX1]
			l_ah: NATURAL_32
			l_al: NATURAL_32
			l_bh: NATURAL_32
			l_bl: NATURAL_32
			l_mask: NATURAL_32
			l_shift: INTEGER_32
			l_shift___0: INTEGER_32
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l_gn: CE_ARRAY [INTEGER_32]
			l_updated_un: CE_ARRAY [INTEGER_32]
			l_c: INTEGER_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_y: NATURAL_32
			l_uh: NATURAL_32
			l_vh: NATURAL_32
			l_u: CE_ARRAY [INTEGER_32]
			l_v: CE_ARRAY [INTEGER_32]
			l_negate: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_HGCD_MATRIX1]} l_M.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_gn.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_updated_un.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_u.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_v.make (<<1>>)

			l_ap := a_ap
			l_n := a_n
			l_tp := a_tp
			l_ualloc := l_n + 1
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if 3 * l_ualloc /= 0 then
					l___dst := l_tp
					l___n := 3 * l_ualloc
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp := l___dst
						l___dst := l___dst + 1
						l_tmp.item := (0).to_natural_32
						l___n := l___n - 1
						if not l___n.to_boolean then
							l_break := True
						end
					end
					l_break := False
				end
				l_break := True
			end
			l_break := False
			l_u0 := l_tp
			l_tp := l_tp + l_ualloc
			l_u1 := l_tp
			l_tp := l_tp + l_ualloc
			l_u2 := l_tp
			l_tp := l_tp + l_ualloc
			l_u1[0] := (1).to_natural_32
			l_un := (1).to_integer_32
			from
			until
				not (not (l_return) and then (l_n >= 2))
			loop
				l_mask := (l_ap[(l_n - 1)]).bit_or (a_bp[(l_n - 1)])
				if ((l_mask).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))).to_boolean then
					l_ah := l_ap[(l_n - 1)]
					l_al := l_ap[(l_n - 2)]
					l_bh := a_bp[(l_n - 1)]
					l_bl := a_bp[(l_n - 2)]
				elseif l_n = 2 then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_shift := builtin_clzl (l_mask)
						l_break := True
					end
					l_break := False
					l_ah := (((((l_ap[1]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_ap[0]).bit_shift_right ((32 - l_shift))))
					l_al := (l_ap[0]).bit_shift_left (l_shift)
					l_bh := (((((a_bp[1]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((a_bp[0]).bit_shift_right ((32 - l_shift))))
					l_bl := (a_bp[0]).bit_shift_left (l_shift)
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_shift___0 := builtin_clzl (l_mask)
						l_break := True
					end
					l_break := False
					l_ah := (((((l_ap[(l_n - 1)]).bit_shift_left (l_shift___0))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_ap[(l_n - 2)]).bit_shift_right ((32 - l_shift___0))))
					l_al := (((((l_ap[(l_n - 2)]).bit_shift_left (l_shift___0))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_ap[(l_n - 3)]).bit_shift_right ((32 - l_shift___0))))
					l_bh := (((((a_bp[(l_n - 1)]).bit_shift_left (l_shift___0))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((a_bp[(l_n - 2)]).bit_shift_right ((32 - l_shift___0))))
					l_bl := (((((a_bp[(l_n - 2)]).bit_shift_left (l_shift___0))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((a_bp[(l_n - 3)]).bit_shift_right ((32 - l_shift___0))))
				end
				if (gmpn_hgcd2 (l_ah, l_al, l_bh, l_bl, l_M)).to_boolean then
					l_n := gmpn_hgcd_mul_matrix1_inverse_vector (l_M, l_tp, l_ap, a_bp, l_n)
					from
					until
						(l_break)
					loop
						l_break := False
						l___mp_ptr_swap__tmp := l_ap
						l_ap := l_tp
						l_tp := l___mp_ptr_swap__tmp
						l_break := True
					end
					l_break := False
					l_un := gmpn_hgcd_mul_matrix1_vector (l_M, l_u2, l_u0, l_u1, l_un)
					from
					until
						(l_break)
					loop
						l_break := False
						l___mp_ptr_swap__tmp___0 := l_u0
						l_u0 := l_u2
						l_u2 := l___mp_ptr_swap__tmp___0
						l_break := True
					end
					l_break := False
				else
					l_updated_un.item := l_un
					l_n := gmpn_gcdext_subdiv_step (a_gp, l_gn, a_up, a_usize, l_ap, a_bp, l_n, l_u0, l_u1, l_updated_un, l_tp, l_u2)
					if l_n = 0 then
						Result := (l_gn.item)
						l_return := True
					end
					if not l_return then
						l_un := l_updated_un.item
					end
				end
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					if not (l_ap[0] > {NATURAL_32} 0) then
						(create {P_ASSERT_STATIC}).gmp_assert_fail (ce_string ("gcdext_lehmer.c"), 122, ce_string ("ap[0] > 0"))
					end
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					if not (a_bp[0] > {NATURAL_32} 0) then
						(create {P_ASSERT_STATIC}).gmp_assert_fail (ce_string ("gcdext_lehmer.c"), 123, ce_string ("bp[0] > 0"))
					end
					l_break := True
				end
				l_break := False
				if l_ap[0] = a_bp[0] then
					a_gp[0] := l_ap[0]
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_c := 0
						l___gmp_i := l_un
						from
						until
							(l_break)
						loop
							l_break := False
							l___gmp_i := l___gmp_i - 1
							if not (l___gmp_i >= 0) then
								l_break := True
							end
							if not (l_return or l_break) then
								l___gmp_x := l_u0[l___gmp_i]
								l___gmp_y := l_u1[l___gmp_i]
								if l___gmp_x /= l___gmp_y then
									if l___gmp_x > l___gmp_y then
										l_c := 1
									else
										l_c := -1
									end
									l_break := True
								end
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if l_c < 0 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_un > 0))
							loop
								l_break := False
								if l_u0[(l_un - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_un := l_un - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_up, l_u0, l_un)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						a_usize.item := -l_un
					else
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_u1[(l_un - 1)] /= {NATURAL_32} 0)
							loop
								l_un := l_un - 1
							end
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_up, l_u1, l_un)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						a_usize.item := l_un
					end
					Result := (1).to_integer_32
				else
					a_gp[0] := gmpn_gcdext_1 (l_u, l_v, l_ap[0], a_bp[0])
					if l_u.item = 0 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_un > 0))
							loop
								l_break := False
								if l_u0[(l_un - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_un := l_un - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_up, l_u0, l_un)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						a_usize.item := -l_un
						Result := (1).to_integer_32
						l_return := True
					elseif l_v.item = 0 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_un > 0))
							loop
								l_break := False
								if l_u1[(l_un - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_un := l_un - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_up, l_u1, l_un)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						a_usize.item := l_un
						Result := (1).to_integer_32
						l_return := True
					elseif l_u.item > 0 then
						l_negate := 0
						l_v.item := -l_v.item
					else
						l_negate := 1
						l_u.item := -l_u.item
					end
					if not l_return then
						l_uh := (create {P_GMP_STATIC}).gmpn_mul_1 (a_up, l_u1, l_un, (l_u.item).to_natural_32)
						l_vh := (create {P_GMP_STATIC}).gmpn_addmul_1 (a_up, l_u0, l_un, (l_v.item).to_natural_32)
						if ((l_uh).bit_or (l_vh)) > {NATURAL_32} 0 then
							l_uh := l_uh + l_vh
							l_tmp___1 := l_un
							l_un := l_un + 1
							a_up[l_tmp___1] := l_uh
							if l_uh < l_vh then
								l_tmp___2 := l_un
								l_un := l_un + 1
								a_up[l_tmp___2] := (1).to_natural_32
							end
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(a_up[(l_un - 1)] /= {NATURAL_32} 0)
							loop
								l_un := l_un - 1
							end
							l_break := True
						end
						l_break := False
						if l_negate.to_boolean then
							a_usize.item := -l_un
						else
							a_usize.item := l_un
						end
						Result := (1).to_integer_32
					end
				end
			end
		end

	gmpn_gcdext_subdiv_step (a_gp: CE_POINTER [NATURAL_32]; a_gn: CE_POINTER [INTEGER_32]; a_up: CE_POINTER [NATURAL_32]; a_usizep: CE_POINTER [INTEGER_32]; a_ap, a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_u0, a_u1: CE_POINTER [NATURAL_32]; a_unp: CE_POINTER [INTEGER_32]; a_qp, a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		require
			not a_unp.is_void
		local
			l_ap: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_u0: CE_POINTER [NATURAL_32]
			l_u1: CE_POINTER [NATURAL_32]
			l_an: INTEGER_32
			l_bn: INTEGER_32
			l_un: INTEGER_32
			l_qn: INTEGER_32
			l_u0n: INTEGER_32
			l_swapped: INTEGER_32
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp: INTEGER_32
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l_c: INTEGER_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_y: NATURAL_32
			l___gmp_i___0: INTEGER_32
			l___gmp_x___0: NATURAL_32
			l___gmp_y___0: NATURAL_32
			l___mp_ptr_swap__tmp___1: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___2: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___3: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp___0: INTEGER_32
			l___mp_ptr_swap__tmp___4: CE_POINTER [NATURAL_32]
			l_c___0: INTEGER_32
			l___gmp_i___1: INTEGER_32
			l___gmp_x___1: NATURAL_32
			l___gmp_y___1: NATURAL_32
			l___mp_ptr_swap__tmp___5: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___6: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ap := a_ap
					l_bp := a_bp
					l_n := a_n
					l_u0 := a_u0
					l_u1 := a_u1
					l_bn := l_n
					l_an := l_bn
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_an > 0))
						loop
							l_break := False
							if l_ap[(l_an - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_break) then
								l_an := l_an - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_bn > 0))
						loop
							l_break := False
							if l_bp[(l_bn - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_bn := l_bn - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_un := a_unp.item
					l_swapped := 0
					if not ((builtin_expect ((l_an = 0).to_integer, 0)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if: | return_b:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_gp, l_bp, l_bn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						a_gn.item := l_bn
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_un > 0))
							loop
								l_break := False
								if l_u0[(l_un - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_un := l_un - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_up, l_u0, l_un)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if l_swapped.to_boolean then
							a_usizep.item := l_un
						else
							a_usizep.item := -l_un
						end
						Result := (0).to_integer_32
						l_return := True
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else:
						if (builtin_expect ((l_bn = 0).to_integer, 0)).to_boolean then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (a_gp, l_ap, l_an)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							a_gn.item := l_an
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									not (not (l_break) and then (l_un > 0))
								loop
									l_break := False
									if l_u1[(l_un - 1)] /= {NATURAL_32} 0 then
										l_break := True
									end
									if not (l_return or l_break) then
										l_un := l_un - 1
									end
								end
								l_break := False
								l_break := True
							end
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (a_up, l_u1, l_un)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							if l_swapped.to_boolean then
								a_usizep.item := -l_un
							else
								a_usizep.item := l_un
							end
							Result := (0).to_integer_32
							l_return := True
						end
				when 4 then -- if done
					if not l_return then
						if l_an < l_bn then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_ptr_swap__tmp := l_ap
									l_ap := l_bp
									l_bp := l___mp_ptr_swap__tmp
									l_break := True
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_size_t_swap__tmp := l_an
									l_an := l_bn
									l_bn := l___mp_size_t_swap__tmp
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								l___mp_ptr_swap__tmp___0 := l_u0
								l_u0 := l_u1
								l_u1 := l___mp_ptr_swap__tmp___0
								l_break := True
							end
							l_break := False
							l_swapped := (l_swapped).bit_xor ((1))
						elseif l_an = l_bn then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_c := 0
								l___gmp_i := l_an
								from
								until
									(l_break)
								loop
									l_break := False
									l___gmp_i := l___gmp_i - 1
									if not (l___gmp_i >= 0) then
										l_break := True
									end
									if not (l_return or l_break) then
										l___gmp_x := l_ap[l___gmp_i]
										l___gmp_y := l_bp[l___gmp_i]
										if l___gmp_x /= l___gmp_y then
											if l___gmp_x > l___gmp_y then
												l_c := 1
											else
												l_c := -1
											end
											l_break := True
										end
									end
								end
								l_break := False
								l_break := True
							end
							l_break := False
							if (builtin_expect ((l_c = 0).to_integer, 0)).to_boolean then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (a_gp, l_ap, l_an)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								a_gn.item := l_an
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_c := 0
									l___gmp_i___0 := l_un
									from
									until
										(l_break)
									loop
										l_break := False
										l___gmp_i___0 := l___gmp_i___0 - 1
										if not (l___gmp_i___0 >= 0) then
											l_break := True
										end
										if not (l_return or l_break) then
											l___gmp_x___0 := l_u0[l___gmp_i___0]
											l___gmp_y___0 := l_u1[l___gmp_i___0]
											if l___gmp_x___0 /= l___gmp_y___0 then
												if l___gmp_x___0 > l___gmp_y___0 then
													l_c := 1
												else
													l_c := -1
												end
												l_break := True
											end
										end
									end
									l_break := False
									l_break := True
								end
								l_break := False
								if l_c < 0 then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											not (not (l_break) and then (l_un > 0))
										loop
											l_break := False
											if l_u0[(l_un - 1)] /= {NATURAL_32} 0 then
												l_break := True
											end
											if not (l_return or l_break) then
												l_un := l_un - 1
											end
										end
										l_break := False
										l_break := True
									end
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											(l_return or l_break)
										loop
											l_break := False;
											(create {P_GMP_STATIC}).gmpn_copyi (a_up, l_u0, l_un)
											l_break := True
										end
										l_break := False
										l_break := True
									end
									l_break := False
									l_swapped := (l_swapped).bit_xor ((1))
								else
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											(l_u1[(l_un - 1)] /= {NATURAL_32} 0)
										loop
											l_un := l_un - 1
										end
										l_break := True
									end
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											(l_return or l_break)
										loop
											l_break := False;
											(create {P_GMP_STATIC}).gmpn_copyi (a_up, l_u1, l_un)
											l_break := True
										end
										l_break := False
										l_break := True
									end
									l_break := False
								end
								if l_swapped.to_boolean then
									a_usizep.item := -l_un
								else
									a_usizep.item := l_un
								end
								Result := (0).to_integer_32
								l_return := True
							elseif l_c < 0 then
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_ptr_swap__tmp___1 := l_ap
									l_ap := l_bp
									l_bp := l___mp_ptr_swap__tmp___1
									l_break := True
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_ptr_swap__tmp___2 := l_u0
									l_u0 := l_u1
									l_u1 := l___mp_ptr_swap__tmp___2
									l_break := True
								end
								l_break := False
								l_swapped := (l_swapped).bit_xor ((1))
							end
						end
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 5 then -- if:;
						(create {P_GMP_STATIC}).gmpn_sub (l_ap, l_ap, l_an, l_bp, l_bn).do_nothing
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_an > 0))
							loop
								l_break := False
								if l_ap[(l_an - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_an := l_an - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_u1[l_un] := (create {P_GMP_STATIC}).gmpn_add_n (l_u1, l_u1, l_u0, l_un)
						l_un := l_un + (l_u1[l_un] > {NATURAL_32} 0).to_integer
						if l_an < l_bn then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_ptr_swap__tmp___3 := l_ap
									l_ap := l_bp
									l_bp := l___mp_ptr_swap__tmp___3
									l_break := True
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_size_t_swap__tmp___0 := l_an
									l_an := l_bn
									l_bn := l___mp_size_t_swap__tmp___0
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								l___mp_ptr_swap__tmp___4 := l_u0
								l_u0 := l_u1
								l_u1 := l___mp_ptr_swap__tmp___4
								l_break := True
							end
							l_break := False
							l_swapped := (l_swapped).bit_xor ((1))
						elseif l_an = l_bn then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_c___0 := 0
								l___gmp_i___1 := l_an
								from
								until
									(l_break)
								loop
									l_break := False
									l___gmp_i___1 := l___gmp_i___1 - 1
									if not (l___gmp_i___1 >= 0) then
										l_break := True
									end
									if not (l_return or l_break) then
										l___gmp_x___1 := l_ap[l___gmp_i___1]
										l___gmp_y___1 := l_bp[l___gmp_i___1]
										if l___gmp_x___1 /= l___gmp_y___1 then
											if l___gmp_x___1 > l___gmp_y___1 then
												l_c___0 := 1
											else
												l_c___0 := -1
											end
											l_break := True
										end
									end
								end
								l_break := False
								l_break := True
							end
							l_break := False
							if (builtin_expect ((l_c___0 = 0).to_integer, 0)).to_boolean then
								l_pos := -1 + 1 -- goto return_b
							elseif l_c___0 < 0 then
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_ptr_swap__tmp___5 := l_ap
									l_ap := l_bp
									l_bp := l___mp_ptr_swap__tmp___5
									l_break := True
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_ptr_swap__tmp___6 := l_u0
									l_u0 := l_u1
									l_u1 := l___mp_ptr_swap__tmp___6
									l_break := True
								end
								l_break := False
								l_swapped := (l_swapped).bit_xor ((1))
							end
						end
				when 6 then
						l_qn := (l_an - l_bn) + 1;
						(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (a_qp, l_ap, (0).to_integer_32, l_ap, l_an, l_bp, l_bn)
						if ((create {P_GMP_IMPL_STATIC}).mpn_zero_p (l_ap, l_bn)).to_boolean then
							l_pos := -1 + 1 -- goto return_b
						end
				when 7 then
						l_n := l_bn
						l_u0n := l_un
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_u0n > 0))
							loop
								l_break := False
								if l_u0[(l_u0n - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_u0n := l_u0n - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if l_u0n > 0 then
							l_qn := l_qn - (a_qp[(l_qn - 1)] = {NATURAL_32} 0).to_integer
							if l_qn > l_u0n then
								(create {P_MUL_STATIC}).gmpn_mul (a_tp, a_qp, l_qn, l_u0, l_u0n).do_nothing
							else
								(create {P_MUL_STATIC}).gmpn_mul (a_tp, l_u0, l_u0n, a_qp, l_qn).do_nothing
							end
							if l_qn + l_u0n > l_un then
								(create {P_GMP_STATIC}).gmpn_add (l_u1, a_tp, l_qn + l_u0n, l_u1, l_un).do_nothing
								l_un := l_qn + l_u0n
								l_un := l_un - (l_u1[(l_un - 1)] = {NATURAL_32} 0).to_integer
							else
								l_u1[l_un] := (create {P_GMP_STATIC}).gmpn_add (l_u1, l_u1, l_un, a_tp, l_qn + l_u0n)
								l_un := l_un + (l_u1[l_un] > {NATURAL_32} 0).to_integer
							end
						end
						a_unp.item := l_un
						Result := l_n
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_gcdext_1 (a_up, a_vp: CE_POINTER [INTEGER_32]; a_a, a_b: NATURAL_32): NATURAL_32
		require
			not a_up.is_void
			not a_vp.is_void
		local
			l_a: NATURAL_32
			l_b: NATURAL_32
			l_u0: INTEGER_32
			l_v0: INTEGER_32
			l_u1: INTEGER_32
			l_v1: INTEGER_32
			l_q: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a := a_a
					l_b := a_b
					l_u0 := (1).to_integer_32
					l_v0 := (0).to_integer_32
					l_u1 := (0).to_integer_32
					l_v1 := (1).to_integer_32
					if l_a < l_b then
						l_pos := -1 + 4 -- goto divide_by_b
					end
				when 1 then
					if (l_return) then
						l_pos := -1 + 6 -- skip loop
					end
				when 2 then -- loop body:
						l_q := l_a // l_b
						l_a := l_a - (l_q * l_b)
						if l_a = {NATURAL_32} 0 then
							a_up.item := l_u1
							a_vp.item := l_v1
							Result := l_b
							l_return := True
						end
						if l_return then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_u0 := (l_u0.to_natural_32 - l_q * l_u1.to_natural_32).to_integer_32
						l_v0 := (l_v0.to_natural_32 - l_q * l_v1.to_natural_32).to_integer_32
				when 4 then -- divide_by_b:
						l_q := l_b // l_a
						l_b := l_b - (l_q * l_a)
						if l_b = {NATURAL_32} 0 then
							a_up.item := l_u0
							a_vp.item := l_v0
							Result := l_a
							l_return := True
						end
				when 5 then -- if done
						if not l_return then
							l_u1 := (l_u1.to_natural_32 - l_q * l_u0.to_natural_32).to_integer_32
							l_v1 := (l_v1.to_natural_32 - l_q * l_v0.to_natural_32).to_integer_32
						end
						l_pos := -1 + 1 -- back to loop condition
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_hgcd_lehmer (a_ap, a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_M: CE_POINTER [PD_HGCD_MATRIX]; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		require
			not a_ap.is_void
			not a_bp.is_void
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_nn: INTEGER_32
			l_return: BOOLEAN
		do
			l_n := a_n
			l_s := l_n // 2 + 1
			l_nn := hgcd_step (l_n, a_ap, a_bp, l_s, a_M, a_tp)
			if not l_nn.to_boolean then
				Result := (0).to_integer_32
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return)
				loop
					l_n := l_nn
					l_nn := hgcd_step (l_n, a_ap, a_bp, l_s, a_M, a_tp)
					if not l_nn.to_boolean then
						Result := l_n
						l_return := True
					end
				end
			end
		end

	hgcd_step (a_n: INTEGER_32; a_ap, a_bp: CE_POINTER [NATURAL_32]; a_s: INTEGER_32; a_M: CE_POINTER [PD_HGCD_MATRIX]; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		require
			not a_ap.is_void
			not a_bp.is_void
		local
			l_tp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_ap: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_M1: CE_ARRAY [PD_HGCD_MATRIX1]
			l_mask: NATURAL_32
			l_ah: NATURAL_32
			l_al: NATURAL_32
			l_bh: NATURAL_32
			l_bl: NATURAL_32
			l_an: INTEGER_32
			l_bn: INTEGER_32
			l_qn: INTEGER_32
			l_col: INTEGER_32
			l_shift: INTEGER_32
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l_k: INTEGER_32
			l_c: INTEGER_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_y: NATURAL_32
			l_cy: NATURAL_32
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp: INTEGER_32
			l_c___0: INTEGER_32
			l___gmp_i___0: INTEGER_32
			l___gmp_x___0: NATURAL_32
			l___gmp_y___0: NATURAL_32
			l___mp_ptr_swap__tmp___1: CE_POINTER [NATURAL_32]
			l_cy___0: NATURAL_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_tp.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_HGCD_MATRIX1]} l_M1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tp.item := a_tp
					l_ap := a_ap
					l_bp := a_bp
					l_mask := (l_ap[(a_n - 1)]).bit_or (l_bp[(a_n - 1)])
					if a_n /= a_s + 1 then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if l_mask < {NATURAL_32} 4 then
							l_pos := -1 + 6 -- goto subtract
						end
				when 2 then
						l_ah := l_ap[(a_n - 1)]
						l_al := l_ap[(a_n - 2)]
						l_bh := l_bp[(a_n - 1)]
						l_bl := l_bp[(a_n - 2)]
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else:
						if ((l_mask).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))).to_boolean then
							l_ah := l_ap[(a_n - 1)]
							l_al := l_ap[(a_n - 2)]
							l_bh := l_bp[(a_n - 1)]
							l_bl := l_bp[(a_n - 2)]
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_shift := builtin_clzl (l_mask)
								l_break := True
							end
							l_break := False
							l_ah := (((((l_ap[(a_n - 1)]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_ap[(a_n - 2)]).bit_shift_right ((32 - l_shift))))
							l_al := (((((l_ap[(a_n - 2)]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_ap[(a_n - 3)]).bit_shift_right ((32 - l_shift))))
							l_bh := (((((l_bp[(a_n - 1)]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_bp[(a_n - 2)]).bit_shift_right ((32 - l_shift))))
							l_bl := (((((l_bp[(a_n - 2)]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4_294_967_295))).bit_or (((l_bp[(a_n - 3)]).bit_shift_right ((32 - l_shift))))
						end
				when 5 then -- if done
					if (gmpn_hgcd2 (l_ah, l_al, l_bh, l_bl, l_M1)).to_boolean then
						hgcd_matrix_mul_1 (a_M, l_M1, l_tp.item)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_tp.item, l_ap, a_n)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						Result := (gmpn_hgcd_mul_matrix1_inverse_vector (l_M1, l_ap, l_tp.item, l_bp, a_n))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 6 then -- if: | subtract:
						l_an := a_n
						from
						until
							not (not (l_break) and then (l_an > a_s))
						loop
							l_break := False
							if l_ap[(l_an - 1)] /= l_bp[(l_an - 1)] then
								l_break := True
							end
							if not (l_return or l_break) then
								l_an := l_an - 1
							end
						end
						l_break := False
						if l_an = a_s then
							Result := (0).to_integer_32
							l_return := True
						end
				when 7 then -- if done
					if not l_return then
						if l_ap[(l_an - 1)] > l_bp[(l_an - 1)] then
							l_col := 1
						else
							from
							until
								(l_break)
							loop
								l_break := False
								l___mp_ptr_swap__tmp := l_ap
								l_ap := l_bp
								l_bp := l___mp_ptr_swap__tmp
								l_break := True
							end
							l_break := False
							l_col := 0
						end
						l_bn := a_n
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_bn > 0))
							loop
								l_break := False
								if l_bp[(l_bn - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_bn := l_bn - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if l_bn <= a_s then
							Result := (0).to_integer_32
							l_return := True
						end
					end
					if not l_return then
						if l_ap[(l_an - 1)] = l_bp[(l_an - 1)] + {NATURAL_32} 1 then
							l_k := l_an - 1
							from
							until
								not (not (l_break) and then (l_k > a_s))
							loop
								l_break := False
								if l_ap[(l_k - 1)] /= {NATURAL_32} 0 then
									l_break := True
								elseif l_bp[(l_k - 1)] /= {NATURAL_32} 4_294_967_295 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_k := l_k - 1
								end
							end
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_c := 0
								l___gmp_i := l_k
								from
								until
									(l_break)
								loop
									l_break := False
									l___gmp_i := l___gmp_i - 1
									if not (l___gmp_i >= 0) then
										l_break := True
									end
									if not (l_return or l_break) then
										l___gmp_x := l_ap[l___gmp_i]
										l___gmp_y := l_bp[l___gmp_i]
										if l___gmp_x /= l___gmp_y then
											if l___gmp_x > l___gmp_y then
												l_c := 1
											else
												l_c := -1
											end
											l_break := True
										end
									end
								end
								l_break := False
								l_break := True
							end
							l_break := False
							if l_c < 0 then
								if l_k = a_s then
									Result := (0).to_integer_32
									l_return := True
								end
								if not l_return then
									l_cy := (create {P_GMP_STATIC}).gmpn_sub_n (l_ap, l_ap, l_bp, l_k)
									l_an := l_k
								end
							else
								(create {P_GMP_STATIC}).gmpn_sub_n (l_ap, l_ap, l_bp, l_k).do_nothing
								l_ap[l_k] := (1).to_natural_32
								l_an := l_k + 1
							end
						else
							(create {P_GMP_STATIC}).gmpn_sub_n (l_ap, l_ap, l_bp, l_an).do_nothing
						end
					end
					if not l_return then
						hgcd_matrix_update_1 (a_M, l_col.to_natural_32)
						if l_an < l_bn then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_ptr_swap__tmp___0 := l_ap
									l_ap := l_bp
									l_bp := l___mp_ptr_swap__tmp___0
									l_break := True
								end
								l_break := False
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_size_t_swap__tmp := l_an
									l_an := l_bn
									l_bn := l___mp_size_t_swap__tmp
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							l_col := (l_col).bit_xor ((1))
						elseif l_an = l_bn then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_c___0 := 0
								l___gmp_i___0 := l_an
								from
								until
									(l_break)
								loop
									l_break := False
									l___gmp_i___0 := l___gmp_i___0 - 1
									if not (l___gmp_i___0 >= 0) then
										l_break := True
									end
									if not (l_return or l_break) then
										l___gmp_x___0 := l_ap[l___gmp_i___0]
										l___gmp_y___0 := l_bp[l___gmp_i___0]
										if l___gmp_x___0 /= l___gmp_y___0 then
											if l___gmp_x___0 > l___gmp_y___0 then
												l_c___0 := 1
											else
												l_c___0 := -1
											end
											l_break := True
										end
									end
								end
								l_break := False
								l_break := True
							end
							l_break := False
							if l_c___0 < 0 then
								from
								until
									(l_break)
								loop
									l_break := False
									l___mp_ptr_swap__tmp___1 := l_ap
									l_ap := l_bp
									l_bp := l___mp_ptr_swap__tmp___1
									l_break := True
								end
								l_break := False
								l_col := (l_col).bit_xor ((1))
							end
						end
						l_qn := (l_an + 1) - l_bn;
						(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_tp.item, l_ap, (0).to_integer_32, l_ap, l_an, l_bp, l_bn)
						l_qn := l_qn - (l_tp.item[(l_qn - 1)] = {NATURAL_32} 0).to_integer
						l_an := l_bn
						from
						until
							not (not (l_break) and then (l_an > a_s))
						loop
							l_break := False
							if l_ap[(l_an - 1)] > {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_an := l_an - 1
							end
						end
						l_break := False
						if l_an <= a_s then
							l_cy___0 := (create {P_GMP_STATIC}).gmpn_add (l_ap, l_bp, l_bn, l_ap, l_an)
							if l_cy___0 > {NATURAL_32} 0 then
								l_ap[l_bn] := l_cy___0
								l_bp[l_bn] := (0).to_natural_32
								l_bn := l_bn + 1
							end
							from
							until
								(l_break)
							loop
								l_break := False
								asm130 (l___ptr_dummy, l_tp)
								l_break := True
							end
							l_break := False
							l_qn := l_qn - (l_tp.item[(l_qn - 1)] = {NATURAL_32} 0).to_integer
						end
						if l_qn > 0 then
							hgcd_matrix_update_q (a_M, l_tp.item, l_qn, l_col.to_natural_32, l_tp.item + l_qn)
						end
						Result := l_bn
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_hgcd2 (a_ah, a_al, a_bh, a_bl: NATURAL_32; a_M: CE_POINTER [PD_HGCD_MATRIX1]): INTEGER_32
		local
			l_ah: CE_ARRAY [NATURAL_32]
			l_al: CE_ARRAY [NATURAL_32]
			l_bh: CE_ARRAY [NATURAL_32]
			l_bl: CE_ARRAY [NATURAL_32]
			l_u00: NATURAL_32
			l_u01: NATURAL_32
			l_u10: NATURAL_32
			l_u11: NATURAL_32
			l_r: CE_ARRAY [NATURAL_32]
			l_q: NATURAL_32
			l_r___0: CE_ARRAY [NATURAL_32]
			l_q___0: NATURAL_32
			l_r___1: CE_ARRAY [NATURAL_32]
			l_q___1: NATURAL_32
			l_r___2: CE_ARRAY [NATURAL_32]
			l_q___2: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_ah.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_al.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_bh.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_bl.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_r.make (<<2>>)
			create {CE_NATURAL_32_ARRAY} l_r___0.make (<<2>>)
			create {CE_NATURAL_32_ARRAY} l_r___1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_r___2.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ah.item := a_ah
					l_al.item := a_al
					l_bh.item := a_bh
					l_bl.item := a_bl
					if l_ah.item < {NATURAL_32} 2 then
						Result := 0
						l_return := True
					elseif l_bh.item < {NATURAL_32} 2 then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if not (l_ah.item > l_bh.item) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						if l_ah.item /= l_bh.item then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if not (l_al.item > l_bl.item) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L:
						asm126 (l_ah, l_al, l_bh, l_bl)
						if l_ah.item < {NATURAL_32} 2 then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_u11 := (1).to_natural_32
							l_u01 := l_u11
							l_u00 := l_u01
							l_u10 := (0).to_natural_32
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 10 -- goto _L___0
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___0:
						asm127 (l_bh, l_bl, l_ah, l_al)
						if l_bh.item < {NATURAL_32} 2 then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_u11 := (1).to_natural_32
							l_u10 := l_u11
							l_u00 := l_u10
							l_u01 := (0).to_natural_32
						end
				when 11 then -- if done | if done
					if l_return then
						l_pos := -1 + 38 -- skip if block
					end
				when 12 then -- if:
						if l_ah.item < l_bh.item then
							l_pos := -1 + 22 -- goto subtract_a
						end
				when 13 then
						if (l_return or l_break) then
							l_pos := -1 + 31 -- skip loop
						end
				when 14 then -- loop body:
						l_break := False
						if l_ah.item = l_bh.item then
							l_pos := -1 + 37 -- goto done
						end
				when 15 then
						if l_ah.item < ({NATURAL_32} 1).bit_shift_left (16) then
							l_ah.item := ((l_ah.item).bit_shift_left (16)) + ((l_al.item).bit_shift_right (16))
							l_bh.item := ((l_bh.item).bit_shift_left (16)) + ((l_bl.item).bit_shift_right (16))
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 30 -- skip if block
						end
				when 16 then -- if:
						asm128 (l_ah, l_al, l_bh, l_bl)
						if l_ah.item < {NATURAL_32} 2 then
							l_pos := -1 + 37 -- goto done
						end
				when 17 then
						if not (l_ah.item <= l_bh.item) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_u01 := l_u01 + l_u00
						l_u11 := l_u11 + l_u10
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 20 then -- else:
						l_q := (div2 (l_r, l_ah.item, l_al.item, l_bh.item, l_bl.item))
						l_al.item := l_r[0]
						l_ah.item := l_r[1]
						if l_ah.item < {NATURAL_32} 2 then
							l_u01 := l_u01 + (l_q * l_u00)
							l_u11 := l_u11 + (l_q * l_u10)
							l_pos := -1 + 37 -- goto done
						end
				when 21 then
						l_q := l_q + 1
						l_u01 := l_u01 + (l_q * l_u00)
						l_u11 := l_u11 + (l_q * l_u10)
				when 22 then -- subtract_a:
						
						if l_ah.item = l_bh.item then
							l_pos := -1 + 37 -- goto done
						end
				when 23 then
						if l_bh.item < ({NATURAL_32} 1).bit_shift_left (16) then
							l_ah.item := ((l_ah.item).bit_shift_left (16)) + ((l_al.item).bit_shift_right (16))
							l_bh.item := ((l_bh.item).bit_shift_left (16)) + ((l_bl.item).bit_shift_right (16))
							l_pos := -1 + 34 -- goto subtract_a1
						end
				when 24 then
						asm129 (l_bh, l_bl, l_ah, l_al)
						if l_bh.item < {NATURAL_32} 2 then
							l_pos := -1 + 37 -- goto done
						end
				when 25 then
						if not (l_bh.item <= l_ah.item) then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_u00 := l_u00 + l_u01
						l_u10 := l_u10 + l_u11
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 28 then -- else:
						l_q___0 := (div2 (l_r___0, l_bh.item, l_bl.item, l_ah.item, l_al.item))
						l_bl.item := l_r___0[0]
						l_bh.item := l_r___0[1]
						if l_bh.item < {NATURAL_32} 2 then
							l_u00 := l_u00 + (l_q___0 * l_u01)
							l_u10 := l_u10 + (l_q___0 * l_u11)
							l_pos := -1 + 37 -- goto done
						end
				when 29 then
						l_q___0 := l_q___0 + 1
						l_u00 := l_u00 + (l_q___0 * l_u01)
						l_u10 := l_u10 + (l_q___0 * l_u11)
				when 30 then -- if done | if done
						l_pos := -1 + 13 -- back to loop condition
				when 31 then -- loop done
						l_break := False
				when 32 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 36 -- skip loop
						end
				when 33 then -- loop body:
						l_break := False
						if l_ah.item = l_bh.item then
							l_break := True
						end
						if not (l_return or l_break) then
							l_ah.item := l_ah.item - (l_bh.item)
							if l_ah.item < ({NATURAL_32} 1).bit_shift_left (17) then
								l_break := True
							end
						end
						if not (l_return or l_break) then
							if l_ah.item <= l_bh.item then
								l_u01 := l_u01 + l_u00
								l_u11 := l_u11 + l_u10
							else
								l_q___1 := (div1 (l_r___1, l_ah.item, l_bh.item))
								l_ah.item := l_r___1.item
								if l_ah.item < ({NATURAL_32} 1).bit_shift_left (17) then
									l_u01 := l_u01 + (l_q___1 * l_u00)
									l_u11 := l_u11 + (l_q___1 * l_u10)
									l_break := True
								end
								if not (l_return or l_break) then
									l_q___1 := l_q___1 + 1
									l_u01 := l_u01 + (l_q___1 * l_u00)
									l_u11 := l_u11 + (l_q___1 * l_u10)
								end
							end
						end
						if (l_return or l_break) then
							l_pos := -1 + 35 -- skip if block
						end
				when 34 then -- if: | subtract_a1:
						
						if l_ah.item = l_bh.item then
							l_break := True
						end
				when 35 then -- if done
						if not (l_return or l_break) then
							l_bh.item := l_bh.item - (l_ah.item)
							if l_bh.item < ({NATURAL_32} 1).bit_shift_left (17) then
								l_break := True
							end
						end
						if not (l_return or l_break) then
							if l_bh.item <= l_ah.item then
								l_u00 := l_u00 + l_u01
								l_u10 := l_u10 + l_u11
							else
								l_q___2 := (div1 (l_r___2, l_bh.item, l_ah.item))
								l_bh.item := l_r___2.item
								if l_bh.item < ({NATURAL_32} 1).bit_shift_left (17) then
									l_u00 := l_u00 + (l_q___2 * l_u01)
									l_u10 := l_u10 + (l_q___2 * l_u11)
									l_break := True
								end
								if not (l_return or l_break) then
									l_q___2 := l_q___2 + 1
									l_u00 := l_u00 + (l_q___2 * l_u01)
									l_u10 := l_u10 + (l_q___2 * l_u11)
								end
							end
						end
						l_pos := -1 + 32 -- back to loop condition
				when 36 then -- loop done
						l_break := False
				when 37 then -- done:;
						(a_M.item.u[0])[0] := l_u00;
						(a_M.item.u[0])[1] := l_u01;
						(a_M.item.u[1])[0] := l_u10;
						(a_M.item.u[1])[1] := l_u11
						Result := 1
				when 38 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_hgcd_mul_matrix1_inverse_vector (a_M: CE_POINTER [PD_HGCD_MATRIX1]; a_rp, a_ap, a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32): INTEGER_32
		require
			not a_M.is_void
			not a_rp.is_void
			not a_bp.is_void
		local
			l_n: INTEGER_32
			l_h0: NATURAL_32
			l_h1: NATURAL_32
		do
			l_n := a_n
			l_h0 := (create {P_GMP_STATIC}).gmpn_mul_1 (a_rp, a_ap, l_n, (a_M.item.u[1])[1])
			l_h1 := (create {P_GMP_STATIC}).gmpn_submul_1 (a_rp, a_bp, l_n, (a_M.item.u[0])[1])
			l_h0 := (create {P_GMP_STATIC}).gmpn_mul_1 (a_bp, a_bp, l_n, (a_M.item.u[0])[0])
			l_h1 := (create {P_GMP_STATIC}).gmpn_submul_1 (a_bp, a_ap, l_n, (a_M.item.u[1])[0])
			l_n := l_n - (((a_rp[(l_n - 1)]).bit_or (a_bp[(l_n - 1)])) = {NATURAL_32} 0).to_integer
			Result := l_n
		end

	div1 (a_rp: CE_POINTER [NATURAL_32]; a_n0, a_d0: NATURAL_32): NATURAL_32
		require
			not a_rp.is_void
		local
			l_n0: NATURAL_32
			l_d0: NATURAL_32
			l_q: NATURAL_32
			l_cnt: INTEGER_32
			l_cnt___0: INTEGER_32
		do
			l_n0 := a_n0
			l_d0 := a_d0
			l_q := (0).to_natural_32
			if l_n0.to_integer_32 < 0 then
				l_cnt := 1
				from
				until
					not (l_d0.to_integer_32 >= 0)
				loop
					l_d0 := (l_d0).bit_shift_left ((1))
					l_cnt := l_cnt + 1
				end
				l_q := (0).to_natural_32
				from
				until
					not (l_cnt.to_boolean)
				loop
					l_q := (l_q).bit_shift_left ((1))
					if l_n0 >= l_d0 then
						l_n0 := l_n0 - l_d0
						l_q := (l_q).bit_or (({NATURAL_32} 1))
					end
					l_d0 := (l_d0).bit_shift_right ((1))
					l_cnt := l_cnt - 1
				end
			else
				l_cnt___0 := 0
				from
				until
					not (l_n0 >= l_d0)
				loop
					l_d0 := (l_d0).bit_shift_left ((1))
					l_cnt___0 := l_cnt___0 + 1
				end
				l_q := (0).to_natural_32
				from
				until
					not (l_cnt___0.to_boolean)
				loop
					l_d0 := (l_d0).bit_shift_right ((1))
					l_q := (l_q).bit_shift_left ((1))
					if l_n0 >= l_d0 then
						l_n0 := l_n0 - l_d0
						l_q := (l_q).bit_or (({NATURAL_32} 1))
					end
					l_cnt___0 := l_cnt___0 - 1
				end
			end
			a_rp.item := l_n0
			Result := l_q
		end

	div2 (a_rp: CE_POINTER [NATURAL_32]; a_nh, a_nl, a_dh, a_dl: NATURAL_32): NATURAL_32
		require
			not a_rp.is_void
		local
			l_nl: CE_ARRAY [NATURAL_32]
			l_nh: CE_ARRAY [NATURAL_32]
			l_dh: CE_ARRAY [NATURAL_32]
			l_dl: CE_ARRAY [NATURAL_32]
			l_q: NATURAL_32
			l_cnt: INTEGER_32
			l_cnt___0: INTEGER_32
			l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_nl.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_nh.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_dh.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_dl.make (<<1>>)

			l_nl.item := a_nl
			l_nh.item := a_nh
			l_dh.item := a_dh
			l_dl.item := a_dl
			l_q := (0).to_natural_32
			if (l_nh.item).to_integer_32 < 0 then
				l_cnt := 1
				from
				until
					not ((l_dh.item).to_integer_32 >= 0)
				loop
					l_dh.item := (((l_dh.item).bit_shift_left (1))).bit_or (((l_dl.item).bit_shift_right (31)))
					l_dl.item := (l_dl.item).bit_shift_left ((1))
					l_cnt := l_cnt + 1
				end
				from
				until
					not (l_cnt.to_boolean)
				loop
					l_q := (l_q).bit_shift_left ((1))
					if l_nh.item > l_dh.item then
						asm122 (l_nh, l_nl, l_dh, l_dl)
						l_q := (l_q).bit_or (({NATURAL_32} 1))
					elseif l_nh.item = l_dh.item then
						if l_nl.item >= l_dl.item then
							asm123 (l_nh, l_nl, l_dh, l_dl)
							l_q := (l_q).bit_or (({NATURAL_32} 1))
						end
					end
					l_dl.item := (((l_dh.item).bit_shift_left (31))).bit_or (((l_dl.item).bit_shift_right (1)))
					l_dh.item := (l_dh.item).bit_shift_right ((1))
					l_cnt := l_cnt - 1
				end
			else
				l_cnt___0 := 0
				from
				until
					(l_break)
				loop
					l_break := False
					if not (l_nh.item > l_dh.item) then
						if l_nh.item = l_dh.item then
							if not (l_nl.item >= l_dl.item) then
								l_break := True
							end
						else
							l_break := True
						end
					end
					if not (l_break) then
						l_dh.item := (((l_dh.item).bit_shift_left (1))).bit_or (((l_dl.item).bit_shift_right (31)))
						l_dl.item := (l_dl.item).bit_shift_left ((1))
						l_cnt___0 := l_cnt___0 + 1
					end
				end
				l_break := False
				from
				until
					not (l_cnt___0.to_boolean)
				loop
					l_dl.item := (((l_dh.item).bit_shift_left (31))).bit_or (((l_dl.item).bit_shift_right (1)))
					l_dh.item := (l_dh.item).bit_shift_right ((1))
					l_q := (l_q).bit_shift_left ((1))
					if l_nh.item > l_dh.item then
						asm124 (l_nh, l_nl, l_dh, l_dl)
						l_q := (l_q).bit_or (({NATURAL_32} 1))
					elseif l_nh.item = l_dh.item then
						if l_nl.item >= l_dl.item then
							asm125 (l_nh, l_nl, l_dh, l_dl)
							l_q := (l_q).bit_or (({NATURAL_32} 1))
						end
					end
					l_cnt___0 := l_cnt___0 - 1
				end
			end
			a_rp[0] := l_nl.item
			a_rp[1] := l_nh.item
			Result := l_q
		end

	hgcd_matrix_update_1 (a_M: CE_POINTER [PD_HGCD_MATRIX]; a_col: NATURAL_32)
		require
			not a_M.is_void
		local
			l_c0: NATURAL_32
			l_c1: NATURAL_32
		do
			l_c0 := (create {P_GMP_STATIC}).gmpn_add_n ((a_M.item.p[0])[a_col.to_integer_32], (a_M.item.p[0])[0], (a_M.item.p[0])[1], a_M.item.n)
			l_c1 := (create {P_GMP_STATIC}).gmpn_add_n ((a_M.item.p[1])[a_col.to_integer_32], (a_M.item.p[1])[0], (a_M.item.p[1])[1], a_M.item.n);
			((a_M.item.p[0])[a_col.to_integer_32])[a_M.item.n] := l_c0;
			((a_M.item.p[1])[a_col.to_integer_32])[a_M.item.n] := l_c1
			a_M.item.n := a_M.item.n + (((l_c0).bit_or (l_c1)) /= {NATURAL_32} 0).to_integer
		end

	hgcd_matrix_update_q (a_M: CE_POINTER [PD_HGCD_MATRIX]; a_qp: CE_POINTER [NATURAL_32]; a_qn: INTEGER_32; a_col: NATURAL_32; a_tp: CE_POINTER [NATURAL_32])
		require
			not a_M.is_void
		local
			l_q: NATURAL_32
			l_c0: NATURAL_32
			l_c1: NATURAL_32
			l_row: NATURAL_32
			l_c: CE_ARRAY [NATURAL_32]
			l_n: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_c.make (<<2>>)

			if a_qn = 1 then
				l_q := a_qp[0]
				l_c0 := (create {P_GMP_STATIC}).gmpn_addmul_1 ((a_M.item.p[0])[a_col.to_integer_32], (a_M.item.p[0])[({NATURAL_32} 1 - a_col).to_integer_32], a_M.item.n, l_q)
				l_c1 := (create {P_GMP_STATIC}).gmpn_addmul_1 ((a_M.item.p[1])[a_col.to_integer_32], (a_M.item.p[1])[({NATURAL_32} 1 - a_col).to_integer_32], a_M.item.n, l_q);
				((a_M.item.p[0])[a_col.to_integer_32])[a_M.item.n] := l_c0;
				((a_M.item.p[1])[a_col.to_integer_32])[a_M.item.n] := l_c1
				a_M.item.n := a_M.item.n + (((l_c0).bit_or (l_c1)) /= {NATURAL_32} 0).to_integer
			else
				l_n := a_M.item.n
				from
				until
					not (not (l_return or l_break) and then (l_n + a_qn > a_M.item.n))
				loop
					l_break := False
					if ((a_M.item.p[0])[({NATURAL_32} 1 - a_col).to_integer_32])[(l_n - 1)] > {NATURAL_32} 0 then
						l_break := True
					elseif ((a_M.item.p[1])[({NATURAL_32} 1 - a_col).to_integer_32])[(l_n - 1)] > {NATURAL_32} 0 then
						l_break := True
					end
					if not (l_return or l_break) then
						l_n := l_n - 1
					end
				end
				l_break := False
				l_row := {NATURAL_32} 0
				from
				until
					not (not (l_return) and then (l_row < {NATURAL_32} 2))
				loop
					if a_qn <= l_n then
						(create {P_MUL_STATIC}).gmpn_mul (a_tp, (a_M.item.p[l_row.to_integer_32])[({NATURAL_32} 1 - a_col).to_integer_32], l_n, a_qp, a_qn).do_nothing
					else
						(create {P_MUL_STATIC}).gmpn_mul (a_tp, a_qp, a_qn, (a_M.item.p[l_row.to_integer_32])[({NATURAL_32} 1 - a_col).to_integer_32], l_n).do_nothing
					end
					l_c[l_row.to_integer_32] := (create {P_GMP_STATIC}).gmpn_add ((a_M.item.p[l_row.to_integer_32])[a_col.to_integer_32], a_tp, l_n + a_qn, (a_M.item.p[l_row.to_integer_32])[a_col.to_integer_32], a_M.item.n)
					l_row := l_row + 1
				end
				if ((l_c[0]).bit_or (l_c[1])).to_boolean then
					a_M.item.n := (l_n + a_qn) + 1;
					((a_M.item.p[0])[a_col.to_integer_32])[(l_n - 1)] := l_c[0];
					((a_M.item.p[1])[a_col.to_integer_32])[(l_n - 1)] := l_c[1]
				else
					l_n := l_n + a_qn
					l_n := l_n - (((((a_M.item.p[0])[a_col.to_integer_32])[(l_n - 1)]).bit_or (((a_M.item.p[1])[a_col.to_integer_32])[(l_n - 1)])) = {NATURAL_32} 0).to_integer
					if l_n > a_M.item.n then
						a_M.item.n := l_n
					end
				end
			end
		end

	hgcd_matrix_mul_1 (a_M: CE_POINTER [PD_HGCD_MATRIX]; a_M1: CE_POINTER [PD_HGCD_MATRIX1]; a_tp: CE_POINTER [NATURAL_32])
		require
			not a_M.is_void
			not a_M1.is_void
		local
			l_n0: INTEGER_32
			l_n1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (a_tp, (a_M.item.p[0])[0], a_M.item.n)
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			l_n0 := gmpn_hgcd_mul_matrix1_vector (a_M1, (a_M.item.p[0])[0], a_tp, (a_M.item.p[0])[1], a_M.item.n)
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (a_tp, (a_M.item.p[1])[0], a_M.item.n)
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			l_n1 := gmpn_hgcd_mul_matrix1_vector (a_M1, (a_M.item.p[1])[0], a_tp, (a_M.item.p[1])[1], a_M.item.n)
			if l_n0 > l_n1 then
				a_M.item.n := l_n0
			else
				a_M.item.n := l_n1
			end
		end

	gmpn_hgcd_mul_matrix1_vector (a_M: CE_POINTER [PD_HGCD_MATRIX1]; a_rp, a_ap, a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32): INTEGER_32
		require
			not a_M.is_void
			not a_rp.is_void
			not a_bp.is_void
		local
			l_n: INTEGER_32
			l_ah: NATURAL_32
			l_bh: NATURAL_32
		do
			l_n := a_n
			l_ah := (create {P_GMP_STATIC}).gmpn_mul_1 (a_rp, a_ap, l_n, (a_M.item.u[0])[0])
			l_ah := l_ah + ((create {P_GMP_STATIC}).gmpn_addmul_1 (a_rp, a_bp, l_n, (a_M.item.u[1])[0]))
			l_bh := (create {P_GMP_STATIC}).gmpn_mul_1 (a_bp, a_bp, l_n, (a_M.item.u[1])[1])
			l_bh := l_bh + ((create {P_GMP_STATIC}).gmpn_addmul_1 (a_bp, a_ap, l_n, (a_M.item.u[0])[1]))
			a_rp[l_n] := l_ah
			a_bp[l_n] := l_bh
			l_n := l_n + (((l_ah).bit_or (l_bh)) > {NATURAL_32} 0).to_integer
			Result := l_n
		end

	gmpn_bdiv_q (a_qp, a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		require
			not a_dp.is_void
		local
			l_di: NATURAL_32
			l___n: NATURAL_32
			l___inv: NATURAL_32
			l___n___0: NATURAL_32
			l___inv___0: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if 132 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (a_dn >= 132) then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if 1_470 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if a_dn >= 1_470 then
							gmpn_mu_bdiv_q (a_qp, a_np, a_nn, a_dp, a_dn, a_tp)
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_tp, a_np, a_nn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___n___0 := a_dp[0]
							l___inv___0 := ((create {P_GMP_IMPL_STATIC}).gmp_binvert_limb_table[((l___n___0 // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
							l___inv___0 := {NATURAL_32} 2 * l___inv___0 - (l___inv___0 * l___inv___0) * l___n___0
							l___inv___0 := {NATURAL_32} 2 * l___inv___0 - (l___inv___0 * l___inv___0) * l___n___0
							l_di := (l___inv___0).bit_and ({NATURAL_32} 4_294_967_295)
							l_break := True
						end
						l_break := False
						l_di := (-l_di.to_integer_32).to_natural_32;
						(create {P_DCPI1_BDIV_Q_STATIC}).gmpn_dcpi1_bdiv_q (a_qp, a_tp, a_nn, a_dp, a_dn, l_di)
				when 6 then -- if done | if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 9 -- goto _L___0
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___0:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_tp, a_np, a_nn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___n := a_dp[0]
							l___inv := ((create {P_GMP_IMPL_STATIC}).gmp_binvert_limb_table[((l___n // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
							l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
							l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
							l_di := (l___inv).bit_and ({NATURAL_32} 4_294_967_295)
							l_break := True
						end
						l_break := False
						l_di := (-l_di.to_integer_32).to_natural_32;
						(create {P_SBPI1_BDIV_Q_STATIC}).gmpn_sbpi1_bdiv_q (a_qp, a_tp, a_nn, a_dp, a_dn, l_di)
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_mu_bdiv_q (a_qp, a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		require
			not a_dp.is_void
		local
			l_scratch: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_dn: CE_ARRAY [INTEGER_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_qn: INTEGER_32
			l_in: CE_ARRAY [INTEGER_32]
			l_cy: INTEGER_32
			l_c0: CE_ARRAY [INTEGER_32]
			l_tn: INTEGER_32
			l_wn: CE_ARRAY [INTEGER_32]
			l_b: INTEGER_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_scratch.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_dn.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_in.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_c0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_wn.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___2.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___3.make (<<1>>)

			l_scratch.item := a_scratch
			l_dn.item := a_dn
			l_qp := a_qp
			l_np := a_np
			l_qn := a_nn
			if l_qn > l_dn.item then
				l_b := (l_qn - 1) // l_dn.item + 1
				l_in.item := (l_qn - 1) // l_b + 1;
				(create {P_BINVERT_STATIC}).gmpn_binvert (l_scratch.item, a_dp, l_in.item, l_scratch.item + l_in.item)
				l_cy := 0
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_scratch.item + l_in.item, l_np, l_dn.item)
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				l_np := l_np + (l_dn.item);
				(create {P_MULLO_N_STATIC}).gmpn_mullo_n (l_qp, (l_scratch.item + l_in.item), l_scratch.item, l_in.item)
				l_qn := l_qn - (l_in.item)
				from
				until
					not (not (l_return) and then (l_qn > l_in.item))
				loop
					if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l_in.item >= 58 then
							l_tn := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (l_dn.item);
							(create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1 ((l_scratch.item + l_in.item) + l_dn.item, l_tn, a_dp, l_dn.item, l_qp, l_in.item, ((l_scratch.item + l_in.item) + l_dn.item) + l_tn)
							l_wn.item := (l_dn.item + l_in.item) - l_tn
							if l_wn.item > 0 then
								l_c0.item := ((create {P_GMP_STATIC}).gmpn_sub_n (((l_scratch.item + l_in.item) + l_dn.item) + l_tn, ((l_scratch.item + l_in.item) + l_dn.item), (l_scratch.item + l_in.item), l_wn.item)).to_integer_32
								from
								until
									(l_break)
								loop
									l_break := False
									asm327 (l___ptr_dummy, l_scratch, l_in, l_dn, l_wn, l_c0)
									l_break := True
								end
								l_break := False
							end
						else
							(create {P_MUL_STATIC}).gmpn_mul ((l_scratch.item + l_in.item) + l_dn.item, a_dp, l_dn.item, l_qp, l_in.item).do_nothing
						end
					else
						(create {P_MUL_STATIC}).gmpn_mul ((l_scratch.item + l_in.item) + l_dn.item, a_dp, l_dn.item, l_qp, l_in.item).do_nothing
					end
					l_qp := l_qp + (l_in.item)
					if l_dn.item /= l_in.item then
						l_cy := (l_cy.to_natural_32 + ((create {P_GMP_STATIC}).gmpn_sub_n (l_scratch.item + l_in.item, ((l_scratch.item + l_in.item) + l_in.item), (((l_scratch.item + l_in.item) + l_dn.item) + l_in.item), l_dn.item - l_in.item))).to_integer_32
						if l_cy = 2 then
							from
							until
								(l_break)
							loop
								l_break := False
								asm328 (l___ptr_dummy___0, l_scratch, l_in, l_dn)
								l_break := True
							end
							l_break := False
							l_cy := 1
						end
					end
					l_cy := ((create {P_GMP_IMPL_STATIC}).gmpn_sub_nc (((l_scratch.item + l_in.item) + l_dn.item) - l_in.item, l_np, (((l_scratch.item + l_in.item) + l_dn.item) + l_dn.item), l_in.item, l_cy.to_natural_32)).to_integer_32
					l_np := l_np + (l_in.item);
					(create {P_MULLO_N_STATIC}).gmpn_mullo_n (l_qp, (l_scratch.item + l_in.item), l_scratch.item, l_in.item)
					l_qn := l_qn - (l_in.item)
				end
				if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_in.item >= 58 then
						l_tn := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (l_dn.item);
						(create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1 ((l_scratch.item + l_in.item) + l_dn.item, l_tn, a_dp, l_dn.item, l_qp, l_in.item, ((l_scratch.item + l_in.item) + l_dn.item) + l_tn)
						l_wn.item := (l_dn.item + l_in.item) - l_tn
						if l_wn.item > 0 then
							l_c0.item := ((create {P_GMP_STATIC}).gmpn_sub_n (((l_scratch.item + l_in.item) + l_dn.item) + l_tn, ((l_scratch.item + l_in.item) + l_dn.item), (l_scratch.item + l_in.item), l_wn.item)).to_integer_32
							from
							until
								(l_break)
							loop
								l_break := False
								asm329 (l___ptr_dummy___1, l_scratch, l_in, l_dn, l_wn, l_c0)
								l_break := True
							end
							l_break := False
						end
					else
						(create {P_MUL_STATIC}).gmpn_mul ((l_scratch.item + l_in.item) + l_dn.item, a_dp, l_dn.item, l_qp, l_in.item).do_nothing
					end
				else
					(create {P_MUL_STATIC}).gmpn_mul ((l_scratch.item + l_in.item) + l_dn.item, a_dp, l_dn.item, l_qp, l_in.item).do_nothing
				end
				l_qp := l_qp + (l_in.item)
				if l_dn.item /= l_in.item then
					l_cy := (l_cy.to_natural_32 + ((create {P_GMP_STATIC}).gmpn_sub_n (l_scratch.item + l_in.item, ((l_scratch.item + l_in.item) + l_in.item), (((l_scratch.item + l_in.item) + l_dn.item) + l_in.item), l_dn.item - l_in.item))).to_integer_32
					if l_cy = 2 then
						from
						until
							(l_break)
						loop
							l_break := False
							asm330 (l___ptr_dummy___2, l_scratch, l_in, l_dn)
							l_break := True
						end
						l_break := False
						l_cy := 1
					end
				end
				(create {P_GMP_IMPL_STATIC}).gmpn_sub_nc (((l_scratch.item + l_in.item) + l_dn.item) - l_in.item, l_np, (((l_scratch.item + l_in.item) + l_dn.item) + l_dn.item), l_qn - (l_dn.item - l_in.item), l_cy.to_natural_32).do_nothing;
				(create {P_MULLO_N_STATIC}).gmpn_mullo_n (l_qp, (l_scratch.item + l_in.item), l_scratch.item, l_qn)
			else
				l_in.item := l_qn - ((l_qn).bit_shift_right (1));
				(create {P_BINVERT_STATIC}).gmpn_binvert (l_scratch.item, a_dp, l_in.item, l_scratch.item + l_in.item);
				(create {P_MULLO_N_STATIC}).gmpn_mullo_n (l_qp, l_np, l_scratch.item, l_in.item)
				if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_in.item >= 58 then
						l_tn := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (l_qn);
						(create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1 (l_scratch.item + l_in.item, l_tn, a_dp, l_qn, l_qp, l_in.item, (l_scratch.item + l_in.item) + l_tn)
						l_wn.item := (l_qn + l_in.item) - l_tn
						if l_wn.item > 0 then
							l_c0.item := (((create {P_GMP_STATIC}).gmpn_cmp ((l_scratch.item + l_in.item), l_np, l_wn.item)) < 0).to_integer
							from
							until
								(l_break)
							loop
								l_break := False
								asm331 (l___ptr_dummy___3, l_scratch, l_in, l_wn, l_c0)
								l_break := True
							end
							l_break := False
						end
					else
						(create {P_MUL_STATIC}).gmpn_mul (l_scratch.item + l_in.item, a_dp, l_qn, l_qp, l_in.item).do_nothing
					end
				else
					(create {P_MUL_STATIC}).gmpn_mul (l_scratch.item + l_in.item, a_dp, l_qn, l_qp, l_in.item).do_nothing
				end
				(create {P_GMP_STATIC}).gmpn_sub_n (l_scratch.item + l_in.item, l_np + l_in.item, ((l_scratch.item + l_in.item) + l_in.item), l_qn - l_in.item).do_nothing;
				(create {P_MULLO_N_STATIC}).gmpn_mullo_n (l_qp + l_in.item, (l_scratch.item + l_in.item), l_scratch.item, l_qn - l_in.item)
			end
		end

	gmpn_bdiv_q_itch (a_nn, a_dn: INTEGER_32): INTEGER_32
		do
			if 1_470 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if a_dn >= 1_470 then
					Result := (gmpn_mu_bdiv_q_itch (a_nn, a_dn))
				else
					Result := a_nn
				end
			else
				Result := a_nn
			end
		end

	gmpn_mu_bdiv_q_itch (a_nn, a_dn: INTEGER_32): INTEGER_32
		local
			l_qn: INTEGER_32
			l_in: INTEGER_32
			l_tn: INTEGER_32
			l_itch_binvert: INTEGER_32
			l_itch_out: INTEGER_32
			l_itches: INTEGER_32
			l_b: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_qn := a_nn
			if l_qn > a_dn then
				l_b := (l_qn - 1) // a_dn + 1
				l_in := (l_qn - 1) // l_b + 1
				if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_in >= 58 then
						l_tn := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (a_dn)
						l_itch_out := (create {P_GMP_IMPL_STATIC}).mpn_mulmod_bnm1_itch (l_tn, a_dn, l_in)
					else
						l_tn := a_dn + l_in
						l_itch_out := (0).to_integer_32
					end
				else
					l_tn := a_dn + l_in
					l_itch_out := (0).to_integer_32
				end
				l_itch_binvert := (create {P_BINVERT_STATIC}).gmpn_binvert_itch (l_in)
				l_itches := (a_dn + l_tn) + l_itch_out
				if l_itches > l_itch_binvert then
					l_tmp := l_itches
				else
					l_tmp := l_itch_binvert
				end
				Result := (l_in + l_tmp)
			else
				l_in := l_qn - ((l_qn).bit_shift_right (1))
				if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_in >= 58 then
						l_tn := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (l_qn)
						l_itch_out := (create {P_GMP_IMPL_STATIC}).mpn_mulmod_bnm1_itch (l_tn, l_qn, l_in)
					else
						l_tn := l_qn + l_in
						l_itch_out := (0).to_integer_32
					end
				else
					l_tn := l_qn + l_in
					l_itch_out := (0).to_integer_32
				end
				l_itch_binvert := (create {P_BINVERT_STATIC}).gmpn_binvert_itch (l_in)
				l_itches := l_tn + l_itch_out
				if l_itches > l_itch_binvert then
					l_tmp___0 := l_itches
				else
					l_tmp___0 := l_itch_binvert
				end
				Result := (l_in + l_tmp___0)
			end
		end

	gmpn_powm (a_rp, a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_ep: CE_POINTER [NATURAL_32]; a_en: INTEGER_32; a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		require
			not a_ep.is_void
			not a_mp.is_void
		local
			l_ip: CE_ARRAY [NATURAL_32]
			l_mip: CE_POINTER [NATURAL_32]
			l_cnt: INTEGER_32
			l_ebi: NATURAL_32
			l_windowsize: INTEGER_32
			l_this_windowsize: INTEGER_32
			l_expbits: NATURAL_32
			l_pp: CE_POINTER [NATURAL_32]
			l_this_pp: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___n: NATURAL_32
			l___inv: NATURAL_32
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l___dst: CE_POINTER [NATURAL_32]
			l___n___0: INTEGER_32
			l_tmp___9: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_NATURAL_32_ARRAY} l_ip.make (<<2>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_cnt := builtin_clzl (a_ep[(a_en - 1)])
						l_break := True
					end
					l_break := False
					l_ebi := a_en.to_natural_32 * {NATURAL_32} 32 - l_cnt.to_natural_32
					l_windowsize := win_size (l_ebi)
					if 63 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_n >= 63 then
							if (builtin_expect ((a_n.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___2 := (l_aaf.new ((a_n.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___2 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (a_n.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_mip := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2);
							(create {P_BINVERT_STATIC}).gmpn_binvert (l_mip, a_mp, a_n, a_tp)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_mip := l_ip
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___n := a_mp[0]
							l___inv := ((create {P_GMP_IMPL_STATIC}).gmp_binvert_limb_table[((l___n // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
							l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
							l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
							l_mip[0] := (l___inv).bit_and ({NATURAL_32} 4_294_967_295)
							l_break := True
						end
						l_break := False
						l_mip[0] := (-(l_mip[0]).to_integer_32).to_natural_32
				when 4 then
					if (builtin_expect ((((a_n).bit_shift_left ((l_windowsize - 1))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___7 := (l_aaf.new ((((a_n).bit_shift_left ((l_windowsize - 1))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___7 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (((a_n).bit_shift_left ((l_windowsize - 1))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_pp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___7)
					l_this_pp := l_pp
					redcify (l_this_pp, a_bp, a_bn, a_mp, a_n);
					(create {P_SQR_STATIC}).gmpn_sqr (a_tp, l_this_pp, a_n)
					if 63 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if a_n >= 63 then
							gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
						else
							gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
						end
					else
						gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
					end
					l_i := (((1).bit_shift_left ((l_windowsize - 1))) - 1).to_integer_32
					from
					until
						not (l_i > 0)
					loop
						(create {P_MUL_N_STATIC}).gmpn_mul_n (a_tp, l_this_pp, a_rp, a_n)
						l_this_pp := l_this_pp + a_n
						if 63 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if a_n >= 63 then
								gmpn_redc_n (l_this_pp, a_tp, a_mp, a_n, l_mip)
							else
								gmpn_redc_1 (l_this_pp, a_tp, a_mp, a_n, l_mip[0])
							end
						else
							gmpn_redc_1 (l_this_pp, a_tp, a_mp, a_n, l_mip[0])
						end
						l_i := l_i - 1
					end
					l_expbits := getbits (a_ep, l_ebi, l_windowsize)
					if l_ebi < l_windowsize.to_natural_32 then
						l_ebi := (0).to_natural_32
					else
						l_ebi := l_ebi - l_windowsize.to_natural_32
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_cnt := builtin_ctzl (l_expbits)
						l_break := True
					end
					l_break := False
					l_ebi := l_ebi + l_cnt.to_natural_32
					l_expbits := (l_expbits).bit_shift_right (l_cnt)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (a_rp, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if True then
						l_pos := -1 + 31 -- skip if block
					end
				when 5 then -- if:
						if 63 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 25 -- skip if block
						end
				when 6 then -- if:
						if not (a_n >= 63) then
							l_pos := -1 + 23 -- skip if block
						end
				when 7 then -- if:
						if 20 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 17 -- skip if block
						end
				when 8 then -- if:
						if not (a_n >= 20) then
							l_pos := -1 + 15 -- skip if block
						end
				when 9 then -- if: | loop condition:
						if not (not (l_return) and then (l_ebi /= {NATURAL_32} 0)) then
							l_pos := -1 + 14 -- skip loop
						end
				when 10 then -- loop body: | loop condition:
						if ((((a_ep[((l_ebi - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_shift_right (((l_ebi - {NATURAL_32} 1) \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_pos := -1 + 13 -- skip loop
						end
				when 11 then -- loop body:;
						(create {P_SQR_STATIC}).gmpn_sqr (a_tp, a_rp, a_n)
						gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
						l_ebi := l_ebi - 1
						if l_ebi = {NATURAL_32} 0 then
							l_pos := -1 + 56 -- goto done
						end
				when 12 then
						l_pos := -1 + 10 -- back to loop condition
				when 13 then -- loop done
						l_expbits := getbits (a_ep, l_ebi, l_windowsize)
						l_this_windowsize := l_windowsize
						if l_ebi < l_windowsize.to_natural_32 then
							l_this_windowsize := (l_this_windowsize.to_natural_32 - (l_windowsize.to_natural_32 - l_ebi)).to_integer_32
							l_ebi := (0).to_natural_32
						else
							l_ebi := l_ebi - l_windowsize.to_natural_32
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_cnt := builtin_ctzl (l_expbits)
							l_break := True
						end
						l_break := False
						l_this_windowsize := l_this_windowsize - l_cnt
						l_ebi := l_ebi + l_cnt.to_natural_32
						l_expbits := (l_expbits).bit_shift_right (l_cnt)
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_SQR_STATIC}).gmpn_sqr (a_tp, a_rp, a_n)
							gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
							l_this_windowsize := l_this_windowsize - 1
							if l_this_windowsize = 0 then
								l_break := True
							end
						end
						l_break := False;
						(create {P_MUL_N_STATIC}).gmpn_mul_n (a_tp, a_rp, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
						gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
						l_pos := -1 + 9 -- back to loop condition
				when 14 then -- loop done | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_pos := -1 + 17 -- goto _L___0
				when 16 then -- if done | if block done, skip else block:
						l_pos := -1 + 22
				when 17 then -- else: | _L___0:
						if not (not (l_return) and then (l_ebi /= {NATURAL_32} 0)) then
							l_pos := -1 + 22 -- skip loop
						end
				when 18 then -- loop body: | loop condition:
						if ((((a_ep[((l_ebi - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_shift_right (((l_ebi - {NATURAL_32} 1) \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_pos := -1 + 21 -- skip loop
						end
				when 19 then -- loop body:;
						(create {P_GMP_IMPL_STATIC}).gmpn_sqr_basecase (a_tp, a_rp, a_n)
						gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
						l_ebi := l_ebi - 1
						if l_ebi = {NATURAL_32} 0 then
							l_pos := -1 + 56 -- goto done
						end
				when 20 then
						l_pos := -1 + 18 -- back to loop condition
				when 21 then -- loop done
						l_expbits := getbits (a_ep, l_ebi, l_windowsize)
						l_this_windowsize := l_windowsize
						if l_ebi < l_windowsize.to_natural_32 then
							l_this_windowsize := (l_this_windowsize.to_natural_32 - (l_windowsize.to_natural_32 - l_ebi)).to_integer_32
							l_ebi := (0).to_natural_32
						else
							l_ebi := l_ebi - l_windowsize.to_natural_32
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_cnt := builtin_ctzl (l_expbits)
							l_break := True
						end
						l_break := False
						l_this_windowsize := l_this_windowsize - l_cnt
						l_ebi := l_ebi + l_cnt.to_natural_32
						l_expbits := (l_expbits).bit_shift_right (l_cnt)
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_GMP_IMPL_STATIC}).gmpn_sqr_basecase (a_tp, a_rp, a_n)
							gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
							l_this_windowsize := l_this_windowsize - 1
							if l_this_windowsize = 0 then
								l_break := True
							end
						end
						l_break := False;
						(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (a_tp, a_rp, a_n, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
						gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
						l_pos := -1 + 17 -- back to loop condition
				when 22 then -- loop done | if done | if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 25 -- goto _L___1
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 30
				when 25 then -- else: | _L___1:
						if not (not (l_return) and then (l_ebi /= {NATURAL_32} 0)) then
							l_pos := -1 + 30 -- skip loop
						end
				when 26 then -- loop body: | loop condition:
						if ((((a_ep[((l_ebi - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_shift_right (((l_ebi - {NATURAL_32} 1) \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_pos := -1 + 29 -- skip loop
						end
				when 27 then -- loop body:;
						(create {P_GMP_IMPL_STATIC}).gmpn_sqr_basecase (a_tp, a_rp, a_n)
						gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
						l_ebi := l_ebi - 1
						if l_ebi = {NATURAL_32} 0 then
							l_pos := -1 + 56 -- goto done
						end
				when 28 then
						l_pos := -1 + 26 -- back to loop condition
				when 29 then -- loop done
						l_expbits := getbits (a_ep, l_ebi, l_windowsize)
						l_this_windowsize := l_windowsize
						if l_ebi < l_windowsize.to_natural_32 then
							l_this_windowsize := (l_this_windowsize.to_natural_32 - (l_windowsize.to_natural_32 - l_ebi)).to_integer_32
							l_ebi := (0).to_natural_32
						else
							l_ebi := l_ebi - l_windowsize.to_natural_32
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_cnt := builtin_ctzl (l_expbits)
							l_break := True
						end
						l_break := False
						l_this_windowsize := l_this_windowsize - l_cnt
						l_ebi := l_ebi + l_cnt.to_natural_32
						l_expbits := (l_expbits).bit_shift_right (l_cnt)
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_GMP_IMPL_STATIC}).gmpn_sqr_basecase (a_tp, a_rp, a_n)
							gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
							l_this_windowsize := l_this_windowsize - 1
							if l_this_windowsize = 0 then
								l_break := True
							end
						end
						l_break := False;
						(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (a_tp, a_rp, a_n, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
						gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
						l_pos := -1 + 25 -- back to loop condition
				when 30 then -- loop done | if done | if block done, skip else block:
						l_pos := -1 + 56
				when 31 then -- else:
						if 20 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 51 -- skip if block
						end
				when 32 then -- if:
						if not (a_n >= 20) then
							l_pos := -1 + 49 -- skip if block
						end
				when 33 then -- if:
						if 63 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 43 -- skip if block
						end
				when 34 then -- if:
						if not (a_n >= 63) then
							l_pos := -1 + 41 -- skip if block
						end
				when 35 then -- if: | loop condition:
						if not (not (l_return) and then (l_ebi /= {NATURAL_32} 0)) then
							l_pos := -1 + 40 -- skip loop
						end
				when 36 then -- loop body: | loop condition:
						if ((((a_ep[((l_ebi - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_shift_right (((l_ebi - {NATURAL_32} 1) \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_pos := -1 + 39 -- skip loop
						end
				when 37 then -- loop body:;
						(create {P_SQR_STATIC}).gmpn_sqr (a_tp, a_rp, a_n)
						gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
						l_ebi := l_ebi - 1
						if l_ebi = {NATURAL_32} 0 then
							l_pos := -1 + 56 -- goto done
						end
				when 38 then
						l_pos := -1 + 36 -- back to loop condition
				when 39 then -- loop done
						l_expbits := getbits (a_ep, l_ebi, l_windowsize)
						l_this_windowsize := l_windowsize
						if l_ebi < l_windowsize.to_natural_32 then
							l_this_windowsize := (l_this_windowsize.to_natural_32 - (l_windowsize.to_natural_32 - l_ebi)).to_integer_32
							l_ebi := (0).to_natural_32
						else
							l_ebi := l_ebi - l_windowsize.to_natural_32
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_cnt := builtin_ctzl (l_expbits)
							l_break := True
						end
						l_break := False
						l_this_windowsize := l_this_windowsize - l_cnt
						l_ebi := l_ebi + l_cnt.to_natural_32
						l_expbits := (l_expbits).bit_shift_right (l_cnt)
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_SQR_STATIC}).gmpn_sqr (a_tp, a_rp, a_n)
							gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
							l_this_windowsize := l_this_windowsize - 1
							if l_this_windowsize = 0 then
								l_break := True
							end
						end
						l_break := False;
						(create {P_MUL_N_STATIC}).gmpn_mul_n (a_tp, a_rp, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
						gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
						l_pos := -1 + 35 -- back to loop condition
				when 40 then -- loop done | if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else:
						l_pos := -1 + 43 -- goto _L___2
				when 42 then -- if done | if block done, skip else block:
						l_pos := -1 + 48
				when 43 then -- else: | _L___2:
						if not (not (l_return) and then (l_ebi /= {NATURAL_32} 0)) then
							l_pos := -1 + 48 -- skip loop
						end
				when 44 then -- loop body: | loop condition:
						if ((((a_ep[((l_ebi - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_shift_right (((l_ebi - {NATURAL_32} 1) \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_pos := -1 + 47 -- skip loop
						end
				when 45 then -- loop body:;
						(create {P_SQR_STATIC}).gmpn_sqr (a_tp, a_rp, a_n)
						gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
						l_ebi := l_ebi - 1
						if l_ebi = {NATURAL_32} 0 then
							l_pos := -1 + 56 -- goto done
						end
				when 46 then
						l_pos := -1 + 44 -- back to loop condition
				when 47 then -- loop done
						l_expbits := getbits (a_ep, l_ebi, l_windowsize)
						l_this_windowsize := l_windowsize
						if l_ebi < l_windowsize.to_natural_32 then
							l_this_windowsize := (l_this_windowsize.to_natural_32 - (l_windowsize.to_natural_32 - l_ebi)).to_integer_32
							l_ebi := (0).to_natural_32
						else
							l_ebi := l_ebi - l_windowsize.to_natural_32
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_cnt := builtin_ctzl (l_expbits)
							l_break := True
						end
						l_break := False
						l_this_windowsize := l_this_windowsize - l_cnt
						l_ebi := l_ebi + l_cnt.to_natural_32
						l_expbits := (l_expbits).bit_shift_right (l_cnt)
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_SQR_STATIC}).gmpn_sqr (a_tp, a_rp, a_n)
							gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
							l_this_windowsize := l_this_windowsize - 1
							if l_this_windowsize = 0 then
								l_break := True
							end
						end
						l_break := False;
						(create {P_MUL_N_STATIC}).gmpn_mul_n (a_tp, a_rp, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
						gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
						l_pos := -1 + 43 -- back to loop condition
				when 48 then -- loop done | if done | if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else:
						l_pos := -1 + 51 -- goto _L___3
				when 50 then -- if done | if block done, skip else block:
						l_pos := -1 + 56
				when 51 then -- else: | _L___3:
						if not (not (l_return) and then (l_ebi /= {NATURAL_32} 0)) then
							l_pos := -1 + 56 -- skip loop
						end
				when 52 then -- loop body: | loop condition:
						if ((((a_ep[((l_ebi - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_shift_right (((l_ebi - {NATURAL_32} 1) \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_pos := -1 + 55 -- skip loop
						end
				when 53 then -- loop body:;
						(create {P_GMP_IMPL_STATIC}).gmpn_sqr_basecase (a_tp, a_rp, a_n)
						gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
						l_ebi := l_ebi - 1
						if l_ebi = {NATURAL_32} 0 then
							l_pos := -1 + 56 -- goto done
						end
				when 54 then
						l_pos := -1 + 52 -- back to loop condition
				when 55 then -- loop done
						l_expbits := getbits (a_ep, l_ebi, l_windowsize)
						l_this_windowsize := l_windowsize
						if l_ebi < l_windowsize.to_natural_32 then
							l_this_windowsize := (l_this_windowsize.to_natural_32 - (l_windowsize.to_natural_32 - l_ebi)).to_integer_32
							l_ebi := (0).to_natural_32
						else
							l_ebi := l_ebi - l_windowsize.to_natural_32
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_cnt := builtin_ctzl (l_expbits)
							l_break := True
						end
						l_break := False
						l_this_windowsize := l_this_windowsize - l_cnt
						l_ebi := l_ebi + l_cnt.to_natural_32
						l_expbits := (l_expbits).bit_shift_right (l_cnt)
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_GMP_IMPL_STATIC}).gmpn_sqr_basecase (a_tp, a_rp, a_n)
							gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
							l_this_windowsize := l_this_windowsize - 1
							if l_this_windowsize = 0 then
								l_break := True
							end
						end
						l_break := False;
						(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (a_tp, a_rp, a_n, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
						gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
						l_pos := -1 + 51 -- back to loop condition
				when 56 then -- loop done | if done | done:
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (a_tp, a_rp, a_n)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if a_n /= 0 then
							l___dst := a_tp + a_n
							l___n___0 := a_n
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___9 := l___dst
								l___dst := l___dst + 1
								l_tmp___9.item := (0).to_natural_32
								l___n___0 := l___n___0 - 1
								if not l___n___0.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					if 63 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if a_n >= 63 then
							gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
						else
							gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
						end
					else
						gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
					end
					if ((create {P_GMP_STATIC}).gmpn_cmp (a_rp, a_mp, a_n)) >= 0 then
						(create {P_GMP_STATIC}).gmpn_sub_n (a_rp, a_rp, a_mp, a_n).do_nothing
					end
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
							(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						end
						l_break := True
					end
					l_break := False
				when 57 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_redc_1 (a_rp, a_up, a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_invm: NATURAL_32)
		local
			l_up: CE_POINTER [NATURAL_32]
			l_j: INTEGER_32
			l_cy: NATURAL_32
			l_return: BOOLEAN
		do
			l_up := a_up
			l_j := a_n - 1
			from
			until
				not (not (l_return) and then (l_j >= 0))
			loop
				l_cy := (create {P_GMP_STATIC}).gmpn_addmul_1 (l_up, a_mp, a_n, (l_up[0] * a_invm).bit_and ({NATURAL_32} 4_294_967_295))
				l_up[0] := l_cy
				l_up := l_up + 1
				l_j := l_j - 1
			end
			l_cy := (create {P_GMP_STATIC}).gmpn_add_n (a_rp, l_up, (l_up - a_n), a_n)
			if l_cy /= {NATURAL_32} 0 then
				(create {P_GMP_STATIC}).gmpn_sub_n (a_rp, a_rp, a_mp, a_n).do_nothing
			end
		end

	gmpn_redc_n (a_rp, a_up, a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_ip: CE_POINTER [NATURAL_32])
		local
			l_n: CE_ARRAY [INTEGER_32]
			l_xp: CE_POINTER [NATURAL_32]
			l_yp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_scratch: CE_POINTER [NATURAL_32]
			l_cy: CE_ARRAY [NATURAL_32]
			l_rn: CE_ARRAY [INTEGER_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___5: CE_POINTER [ANY]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_INTEGER_32_ARRAY} l_n.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_yp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rn.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			l_n.item := a_n
			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			l_rn.item := (create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1_next_size (l_n.item)
			if (builtin_expect ((((l_n.item + l_rn.item) + ((create {P_GMP_IMPL_STATIC}).mpn_mulmod_bnm1_itch (l_rn.item, l_n.item, l_n.item))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___5 := (l_aaf.new ((((l_n.item + l_rn.item) + ((create {P_GMP_IMPL_STATIC}).mpn_mulmod_bnm1_itch (l_rn.item, l_n.item, l_n.item))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___5 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (((l_n.item + l_rn.item) + ((create {P_GMP_IMPL_STATIC}).mpn_mulmod_bnm1_itch (l_rn.item, l_n.item, l_n.item))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_scratch := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___5)
			l_xp := l_scratch;
			(create {P_MULLO_N_STATIC}).gmpn_mullo_n (l_xp, a_up, a_ip, l_n.item)
			l_yp.item := l_scratch + l_n.item;
			(create {P_MULMOD_BNM1_STATIC}).gmpn_mulmod_bnm1 (l_yp.item, l_rn.item, l_xp, l_n.item, a_mp, l_n.item, (l_scratch + l_n.item) + l_rn.item)
			from
			until
				(l_break)
			loop
				l_break := False
				if not (2 * l_n.item > l_rn.item) then
					(create {P_ASSERT_STATIC}).gmp_assert_fail (ce_string ("redc_n.c"), 56, ce_string ("2 * n > rn"))
				end
				l_break := True
			end
			l_break := False
			l_cy.item := (create {P_GMP_STATIC}).gmpn_sub_n (l_yp.item + l_rn.item, l_yp.item, a_up, 2 * l_n.item - l_rn.item)
			from
			until
				(l_break)
			loop
				l_break := False
				asm340 (l___ptr_dummy, l_yp, l_n, l_rn, l_cy)
				l_break := True
			end
			l_break := False
			l_cy.item := (create {P_GMP_STATIC}).gmpn_sub_n (a_rp, (a_up + l_n.item), (l_yp.item + l_n.item), l_n.item)
			if l_cy.item /= {NATURAL_32} 0 then
				(create {P_GMP_STATIC}).gmpn_add_n (a_rp, a_rp, a_mp, l_n.item).do_nothing
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
				end
				l_break := True
			end
			l_break := False
		end

	win_size (a_eb: NATURAL_32): INTEGER_32
		local
			l_k: INTEGER_32
		do
			l_k := 1
			from
			until
				not (a_eb > x.item[l_k])
			loop
				l_k := l_k + 1
			end
			Result := l_k
		end

	redcify (a_rp, a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32)
		require
			not a_mp.is_void
		local
			l_tp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___9: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			if (builtin_expect (((a_un + a_n).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___2 := (l_aaf.new (((a_un + a_n).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___2 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((a_un + a_n).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
			if (builtin_expect (((a_un + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___7 := (l_aaf.new (((a_un + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___7 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((a_un + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_qp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___7)
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if a_n /= 0 then
					l___dst := l_tp
					l___n := a_n
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___9 := l___dst
						l___dst := l___dst + 1
						l_tmp___9.item := (0).to_natural_32
						l___n := l___n - 1
						if not l___n.to_boolean then
							l_break := True
						end
					end
					l_break := False
				end
				l_break := True
			end
			l_break := False
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (l_tp + a_n, a_up, a_un)
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False;
			(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_qp, a_rp, 0, l_tp, a_un + a_n, a_mp, a_n)
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
				end
				l_break := True
			end
			l_break := False
		end

	win_size___0 (a_eb: NATURAL_32): INTEGER_32
		local
			l_k: INTEGER_32
		do
			l_k := 0
			from
			until
				not (a_eb > x___0.item[l_k])
			loop
				l_k := l_k + 1
			end
			Result := l_k
		end

	gmpn_powm_sec (a_rp, a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_ep: CE_POINTER [NATURAL_32]; a_en: INTEGER_32; a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		require
			not a_ep.is_void
			not a_mp.is_void
		local
			l_minv: NATURAL_32
			l_cnt: INTEGER_32
			l_ebi: NATURAL_32
			l_windowsize: INTEGER_32
			l_this_windowsize: INTEGER_32
			l_expbits: NATURAL_32
			l_pp: CE_POINTER [NATURAL_32]
			l_this_pp: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_cnd: INTEGER_32
			l___tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l___n: NATURAL_32
			l___inv: NATURAL_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n___0: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			l___tmp_marker := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_cnt := builtin_clzl (a_ep[(a_en - 1)])
				l_break := True
			end
			l_break := False
			l_ebi := a_en.to_natural_32 * {NATURAL_32} 32 - l_cnt.to_natural_32
			l_windowsize := win_size___1 (l_ebi)
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l___n := a_mp[0]
				l___inv := ((create {P_GMP_IMPL_STATIC}).gmp_binvert_limb_table[((l___n // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
				l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
				l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
				l_minv := (l___inv).bit_and ({NATURAL_32} 4_294_967_295)
				l_break := True
			end
			l_break := False
			l_minv := (-l_minv.to_integer_32).to_natural_32
			l_pp := a_tp + 4 * a_n
			l_this_pp := l_pp
			l_this_pp[a_n] := (1).to_natural_32
			redcify___0 (l_this_pp, (l_this_pp + a_n), (1).to_integer_32, a_mp, a_n, a_tp + 6 * a_n)
			l_this_pp := l_this_pp + a_n
			redcify___0 (l_this_pp, a_bp, a_bn, a_mp, a_n, a_tp + 6 * a_n)
			l_i := (((1).bit_shift_left (l_windowsize)) - 2).to_integer_32
			from
			until
				not (l_i > 0)
			loop
				(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (a_tp, l_this_pp, a_n, (l_pp + a_n), a_n)
				l_this_pp := l_this_pp + a_n
				gmpn_redc_1_sec (l_this_pp, a_tp, a_mp, a_n, l_minv)
				l_i := l_i - 1
			end
			l_expbits := getbits (a_ep, l_ebi, l_windowsize)
			if l_ebi < l_windowsize.to_natural_32 then
				l_ebi := (0).to_natural_32
			else
				l_ebi := l_ebi - l_windowsize.to_natural_32
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (a_rp, (l_pp + (a_n.to_natural_32 * l_expbits).to_integer_32), a_n)
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			from
			until
				not (not (l_return) and then (l_ebi /= {NATURAL_32} 0))
			loop
				l_expbits := getbits (a_ep, l_ebi, l_windowsize)
				l_this_windowsize := l_windowsize
				if l_ebi < l_windowsize.to_natural_32 then
					l_this_windowsize := (l_this_windowsize.to_natural_32 - (l_windowsize.to_natural_32 - l_ebi)).to_integer_32
					l_ebi := (0).to_natural_32
				else
					l_ebi := l_ebi - l_windowsize.to_natural_32
				end
				from
				until
					(l_break)
				loop
					l_break := False;
					(create {P_GMP_IMPL_STATIC}).gmpn_sqr_basecase (a_tp, a_rp, a_n)
					gmpn_redc_1_sec (a_rp, a_tp, a_mp, a_n, l_minv)
					l_this_windowsize := l_this_windowsize - 1
					if l_this_windowsize = 0 then
						l_break := True
					end
				end
				l_break := False
				gmpn_tabselect ((a_tp + 2 * a_n), l_pp, a_n, ((1).bit_shift_left (l_windowsize)).to_integer_32, l_expbits.to_integer_32);
				(create {P_GMP_IMPL_STATIC}).gmpn_mul_basecase (a_tp, a_rp, a_n, (a_tp + 2 * a_n), a_n)
				gmpn_redc_1_sec (a_rp, a_tp, a_mp, a_n, l_minv)
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (a_tp, a_rp, a_n)
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if a_n /= 0 then
					l___dst := a_tp + a_n
					l___n___0 := a_n
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp := l___dst
						l___dst := l___dst + 1
						l_tmp.item := (0).to_natural_32
						l___n___0 := l___n___0 - 1
						if not l___n___0.to_boolean then
							l_break := True
						end
					end
					l_break := False
				end
				l_break := True
			end
			l_break := False
			gmpn_redc_1_sec (a_rp, a_tp, a_mp, a_n, l_minv)
			l_cnd := ((create {P_GMP_STATIC}).gmpn_sub_n (a_tp, a_rp, a_mp, a_n)).to_integer_32
			gmpn_subcnd_n (a_rp, a_rp, a_mp, a_n, (not l_cnd.to_boolean).to_integer.to_natural_32).do_nothing
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect ((not l___tmp_marker.is_void).to_integer, 0)).to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker)
				end
				l_break := True
			end
			l_break := False
		end

	getbits (a_p: CE_POINTER [NATURAL_32]; a_bi: NATURAL_32; a_nbits: INTEGER_32): NATURAL_32
		require
			not a_p.is_void
		local
			l_bi: NATURAL_32
			l_nbits_in_r: INTEGER_32
			l_r: NATURAL_32
			l_i: INTEGER_32
		do
			l_bi := a_bi
			if l_bi < a_nbits.to_natural_32 then
				Result := ((a_p[0]).bit_and (((({NATURAL_32} 1).bit_shift_left (l_bi.to_integer_32)) - {NATURAL_32} 1)))
			else
				l_bi := l_bi - a_nbits.to_natural_32
				l_i := (l_bi // {NATURAL_32} 32).to_integer_32
				l_bi := l_bi \\ ({NATURAL_32} 32)
				l_r := ((a_p[l_i]).bit_shift_right (l_bi.to_integer_32))
				l_nbits_in_r := ({NATURAL_32} 32 - l_bi).to_integer_32
				if l_nbits_in_r < a_nbits then
					l_r := l_r + ((a_p[(l_i + 1)]).bit_shift_left (l_nbits_in_r))
				end
				Result := ((l_r).bit_and (((({NATURAL_32} 1).bit_shift_left (a_nbits)) - {NATURAL_32} 1)))
			end
		end

	redcify___0 (a_rp, a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		require
			not a_mp.is_void
		local
			l_qp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			l___tmp_marker := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			l_qp := (a_tp + a_un) + a_n
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if a_n /= 0 then
					l___dst := a_tp
					l___n := a_n
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp := l___dst
						l___dst := l___dst + 1
						l_tmp.item := (0).to_natural_32
						l___n := l___n - 1
						if not l___n.to_boolean then
							l_break := True
						end
					end
					l_break := False
				end
				l_break := True
			end
			l_break := False
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (a_tp + a_n, a_up, a_un)
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False;
			(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_qp, a_rp, 0, a_tp, a_un + a_n, a_mp, a_n)
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect ((not l___tmp_marker.is_void).to_integer, 0)).to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker)
				end
				l_break := True
			end
			l_break := False
		end

	gmpn_tabselect (a_rp, a_tab___0: CE_POINTER [NATURAL_32]; a_n, a_nents, a_which: INTEGER_32)
		local
			l_k: INTEGER_32
			l_i: INTEGER_32
			l_mask: NATURAL_32
			l_tp: CE_POINTER [NATURAL_32]
			l_return: BOOLEAN
		do
			l_k := (0).to_integer_32
			from
			until
				not (not (l_return) and then (l_k < a_nents))
			loop
				l_mask := (-((a_which = l_k).to_integer.to_natural_32).to_integer_32).to_natural_32
				l_tp := a_tab___0 + a_n * l_k
				l_i := (0).to_integer_32
				from
				until
					not (l_i < a_n)
				loop
					a_rp[l_i] := (((a_rp[l_i]).bit_and (((l_mask).bit_not)))).bit_or (((l_tp[l_i]).bit_and (l_mask)))
					l_i := l_i + 1
				end
				l_k := l_k + 1
			end
		end

	gmpn_powm_sec_itch (a_bn, a_en, a_n: INTEGER_32): INTEGER_32
		local
			l_windowsize: INTEGER_32
			l_redcify_itch: INTEGER_32
			l_itch: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_windowsize := win_size___1 ((a_en * 32).to_natural_32)
			l_itch := 4 * a_n + ((a_n).bit_shift_left (l_windowsize))
			l_redcify_itch := (2 * a_bn + a_n) + 1
			if l_itch > l_redcify_itch + 6 * a_n then
				l_tmp := l_itch
			else
				l_tmp := l_redcify_itch + 6 * a_n
			end
			Result := l_tmp
		end

	win_size___1 (a_eb: NATURAL_32): INTEGER_32
		local
			l_k: INTEGER_32
		do
			l_k := 1
			from
			until
				not (a_eb > x___1.item[l_k])
			loop
				l_k := l_k + 1
			end
			Result := l_k
		end

	gmpn_redc_1_sec (a_rp, a_up, a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_invm: NATURAL_32)
		require
			not a_rp.is_void
			not a_mp.is_void
		local
			l_up: CE_POINTER [NATURAL_32]
			l_j: INTEGER_32
			l_cy: NATURAL_32
			l_return: BOOLEAN
		do
			l_up := a_up
			l_j := a_n - 1
			from
			until
				not (not (l_return) and then (l_j >= 0))
			loop
				l_cy := (create {P_GMP_STATIC}).gmpn_addmul_1 (l_up, a_mp, a_n, (l_up[0] * a_invm).bit_and ({NATURAL_32} 4_294_967_295))
				l_up[0] := l_cy
				l_up := l_up + 1
				l_j := l_j - 1
			end
			l_cy := (create {P_GMP_STATIC}).gmpn_add_n (a_rp, l_up, (l_up - a_n), a_n)
			gmpn_subcnd_n (a_rp, a_rp, a_mp, a_n, l_cy).do_nothing
		end

	gmpn_subcnd_n (a_rp, a_up, a_vp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_cnd: NATURAL_32): NATURAL_32
		require
			not a_rp.is_void
			not a_up.is_void
			not a_vp.is_void
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_ul: NATURAL_32
			l_vl: NATURAL_32
			l_sl: NATURAL_32
			l_rl: NATURAL_32
			l_cy: NATURAL_32
			l_cy1: NATURAL_32
			l_cy2: NATURAL_32
			l_mask: NATURAL_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_tmp___0: CE_POINTER [NATURAL_32]
			l_tmp___1: CE_POINTER [NATURAL_32]
			l_break: BOOLEAN
		do
			l_rp := a_rp
			l_up := a_up
			l_vp := a_vp
			l_n := a_n
			l_mask := (-((a_cnd /= {NATURAL_32} 0).to_integer.to_natural_32).to_integer_32).to_natural_32
			l_cy := (0).to_natural_32
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp := l_up
				l_up := l_up + 1
				l_ul := l_tmp.item
				l_tmp___0 := l_vp
				l_vp := l_vp + 1
				l_vl := ((l_tmp___0.item).bit_and (l_mask))
				l_sl := l_ul - l_vl
				l_cy1 := (l_sl > l_ul).to_integer.to_natural_32
				l_rl := l_sl - l_cy
				l_cy2 := (l_rl > l_sl).to_integer.to_natural_32
				l_cy := (l_cy1).bit_or (l_cy2)
				l_tmp___1 := l_rp
				l_rp := l_rp + 1
				l_tmp___1.item := l_rl
				l_n := l_n - 1
				if l_n = 0 then
					l_break := True
				end
			end
			l_break := False
			Result := l_cy
		end

	gmpn_trialdiv (a_tp: CE_POINTER [NATURAL_32]; a_tn, a_nprimes: INTEGER_32; a_where: CE_POINTER [INTEGER_32]): NATURAL_32
		require
			not a_where.is_void
		local
			l_nprimes: INTEGER_32
			l_ppp: NATURAL_32
			l_cps: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [PD_GMP_PRIMES_DTAB]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_idx: INTEGER_32
			l_np: INTEGER_32
			l_r: NATURAL_32
			l_q: NATURAL_32
			l_return: BOOLEAN
		do
			l_nprimes := a_nprimes
			l_i := (a_where.item).to_integer_32
			from
			until
				not (not (l_return) and then (l_i.to_natural_32 < (((create {PD_GMP_PRIMES_PTAB}.make).structure_size.to_natural_32 * (463).to_natural_32) // (create {PD_GMP_PRIMES_PTAB}.make).structure_size.to_natural_32).to_natural_32))
			loop
				l_ppp := gmp_primes_ptab.item[l_i].ppp
				l_cps := gmp_primes_ptab.item[l_i].cps
				l_r := (create {P_GMP_IMPL_STATIC}).gmpn_mod_1s_4p (a_tp, a_tn, (l_ppp).bit_shift_left ((l_cps[1]).to_integer_32), l_cps)
				l_idx := (gmp_primes_ptab.item[l_i].idx).to_integer_32
				l_np := (gmp_primes_ptab.item[l_i].np).to_integer_32
				l_dp := gmp_primes_dtab.item + l_idx + l_np
				l_j := -l_np
				from
				until
					not (not (l_return) and then (l_j < 0))
				loop
					l_q := l_r * (l_dp + l_j).item.binv
					if l_q <= (l_dp + l_j).item.lim then
						a_where.item := l_i.to_integer_32
						Result := ((l_dp + l_j).item.binv)
						l_return := True
					end
					if not l_return then
						l_j := l_j + 1
					end
				end
				if not l_return then
					l_nprimes := l_nprimes - l_np
					if l_nprimes <= 0 then
						Result := (0).to_natural_32
						l_return := True
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := (0).to_natural_32
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mp_alloc := a_other.mp_alloc
			mp_size := a_other.mp_size
			mp_d := a_other.mp_d
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mp_alloc = a_other.mp_alloc and
				mp_size = a_other.mp_size and
				mp_d.is_equal (a_other.mp_d)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("mp_alloc"),
					create {CE_STRUCTURE_FIELD}.make ("mp_size"),
					create {CE_STRUCTURE_FIELD}.make ("mp_d")
				>>)
			init_structure_info
		end

end
